# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class NGAP_CommonDataTypes:

    _name_  = 'NGAP-CommonDataTypes'
    _oid_   = [0, 4, 0, 0, 22, 3, 1, 1, 3]
    
    _obj_ = [
        'Criticality',
        'Presence',
        'PrivateIE-ID',
        'ProcedureCode',
        'ProtocolExtensionID',
        'ProtocolIE-ID',
        'TriggeringMessage',
        ]
    _type_ = [
        'Criticality',
        'Presence',
        'PrivateIE-ID',
        'ProcedureCode',
        'ProtocolExtensionID',
        'ProtocolIE-ID',
        'TriggeringMessage',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< Criticality >-----#
    Criticality = ENUM(name='Criticality', mode=MODE_TYPE)
    Criticality._cont = ASN1Dict([('reject', 0), ('ignore', 1), ('notify', 2)])
    Criticality._ext = None
    
    #-----< Presence >-----#
    Presence = ENUM(name='Presence', mode=MODE_TYPE)
    Presence._cont = ASN1Dict([('optional', 0), ('conditional', 1), ('mandatory', 2)])
    Presence._ext = None
    
    #-----< PrivateIE-ID >-----#
    PrivateIE_ID = CHOICE(name='PrivateIE-ID', mode=MODE_TYPE)
    _PrivateIE_ID_local = INT(name='local', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrivateIE_ID_local._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PrivateIE_ID_global_ = OID(name='global', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    PrivateIE_ID._cont = ASN1Dict([
        ('local', _PrivateIE_ID_local),
        ('global', _PrivateIE_ID_global_),
        ])
    PrivateIE_ID._ext = None
    
    #-----< ProcedureCode >-----#
    ProcedureCode = INT(name='ProcedureCode', mode=MODE_TYPE)
    ProcedureCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ProtocolExtensionID >-----#
    ProtocolExtensionID = INT(name='ProtocolExtensionID', mode=MODE_TYPE)
    ProtocolExtensionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< ProtocolIE-ID >-----#
    ProtocolIE_ID = INT(name='ProtocolIE-ID', mode=MODE_TYPE)
    ProtocolIE_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TriggeringMessage >-----#
    TriggeringMessage = ENUM(name='TriggeringMessage', mode=MODE_TYPE)
    TriggeringMessage._cont = ASN1Dict([('initiating-message', 0), ('successful-outcome', 1), ('unsuccessful-outcome', 2)])
    TriggeringMessage._ext = None
    
    _all_ = [
        Criticality,
        Presence,
        _PrivateIE_ID_local,
        _PrivateIE_ID_global_,
        PrivateIE_ID,
        ProcedureCode,
        ProtocolExtensionID,
        ProtocolIE_ID,
        TriggeringMessage,
    ]

class NGAP_Constants:

    _name_  = 'NGAP-Constants'
    _oid_   = [0, 4, 0, 0, 22, 3, 1, 1, 4]
    
    _obj_ = [
        'id-AMFConfigurationUpdate',
        'id-AMFStatusIndication',
        'id-CellTrafficTrace',
        'id-DeactivateTrace',
        'id-DownlinkNASTransport',
        'id-DownlinkNonUEAssociatedNRPPaTransport',
        'id-DownlinkRANConfigurationTransfer',
        'id-DownlinkRANStatusTransfer',
        'id-DownlinkUEAssociatedNRPPaTransport',
        'id-ErrorIndication',
        'id-HandoverCancel',
        'id-HandoverNotification',
        'id-HandoverPreparation',
        'id-HandoverResourceAllocation',
        'id-InitialContextSetup',
        'id-InitialUEMessage',
        'id-LocationReportingControl',
        'id-LocationReportingFailureIndication',
        'id-LocationReport',
        'id-NASNonDeliveryIndication',
        'id-NGReset',
        'id-NGSetup',
        'id-OverloadStart',
        'id-OverloadStop',
        'id-Paging',
        'id-PathSwitchRequest',
        'id-PDUSessionResourceModify',
        'id-PDUSessionResourceModifyIndication',
        'id-PDUSessionResourceRelease',
        'id-PDUSessionResourceSetup',
        'id-PDUSessionResourceNotify',
        'id-PrivateMessage',
        'id-PWSCancel',
        'id-PWSFailureIndication',
        'id-PWSRestartIndication',
        'id-RANConfigurationUpdate',
        'id-RerouteNASRequest',
        'id-RRCInactiveTransitionReport',
        'id-TraceFailureIndication',
        'id-TraceStart',
        'id-UEContextModification',
        'id-UEContextRelease',
        'id-UEContextReleaseRequest',
        'id-UERadioCapabilityCheck',
        'id-UERadioCapabilityInfoIndication',
        'id-UETNLABindingRelease',
        'id-UplinkNASTransport',
        'id-UplinkNonUEAssociatedNRPPaTransport',
        'id-UplinkRANConfigurationTransfer',
        'id-UplinkRANStatusTransfer',
        'id-UplinkUEAssociatedNRPPaTransport',
        'id-WriteReplaceWarning',
        'id-SecondaryRATDataUsageReport',
        'id-UplinkRIMInformationTransfer',
        'id-DownlinkRIMInformationTransfer',
        'id-RetrieveUEInformation',
        'id-UEInformationTransfer',
        'id-RANCPRelocationIndication',
        'id-UEContextResume',
        'id-UEContextSuspend',
        'id-UERadioCapabilityIDMapping',
        'id-HandoverSuccess',
        'id-UplinkRANEarlyStatusTransfer',
        'id-DownlinkRANEarlyStatusTransfer',
        'id-AMFCPRelocationIndication',
        'id-ConnectionEstablishmentIndication',
        'id-BroadcastSessionModification',
        'id-BroadcastSessionRelease',
        'id-BroadcastSessionSetup',
        'id-DistributionSetup',
        'id-DistributionRelease',
        'id-MulticastSessionActivation',
        'id-MulticastSessionDeactivation',
        'id-MulticastSessionUpdate',
        'id-MulticastGroupPaging',
        'id-BroadcastSessionReleaseRequired',
        'maxPrivateIEs',
        'maxProtocolExtensions',
        'maxProtocolIEs',
        'maxnoofAllowedAreas',
        'maxnoofAllowedCAGsperPLMN',
        'maxnoofAllowedS-NSSAIs',
        'maxnoofBluetoothName',
        'maxnoofBPLMNs',
        'maxnoofCAGSperCell',
        'maxnoofCellIDforMDT',
        'maxnoofCellIDforWarning',
        'maxnoofCellinAoI',
        'maxnoofCellinEAI',
        'maxnoofCellinTAI',
        'maxnoofCellsforMBS',
        'maxnoofCellsingNB',
        'maxnoofCellsinngeNB',
        'maxnoofCellsinNGRANNode',
        'maxnoofCellsinUEHistoryInfo',
        'maxnoofCellsUEMovingTrajectory',
        'maxnoofDRBs',
        'maxnoofEmergencyAreaID',
        'maxnoofEAIforRestart',
        'maxnoofEPLMNs',
        'maxnoofEPLMNsPlusOne',
        'maxnoofE-RABs',
        'maxnoofErrors',
        'maxnoofExtSliceItems',
        'maxnoofForbTACs',
        'maxnoofFreqforMDT',
        'maxnoofMBSAreaSessionIDs',
        'maxnoofMBSFSAs',
        'maxnoofMBSQoSFlows',
        'maxnoofMBSSessions',
        'maxnoofMBSSessionsofUE',
        'maxnoofMBSServiceAreaInformation',
        'maxnoofMDTPLMNs',
        'maxnoofMRBs',
        'maxnoofMultiConnectivity',
        'maxnoofMultiConnectivityMinusOne',
        'maxnoofNeighPCIforMDT',
        'maxnoofNGAPIESupportInfo',
        'maxnoofNGConnectionsToReset',
        'maxnoofNRCellBands',
        'maxnoofNSAGs',
        'maxnoofPagingAreas',
        'maxnoofPC5QoSFlows',
        'maxnoofPDUSessions',
        'maxnoofPLMNs',
        'maxnoofPSCellsPerPrimaryCellinUEHistoryInfo',
        'maxnoofQosFlows',
        'maxnoofQosParaSets',
        'maxnoofRANNodeinAoI',
        'maxnoofRecommendedCells',
        'maxnoofRecommendedRANNodes',
        'maxnoofAoI',
        'maxnoofReportedCells',
        'maxnoofSensorName',
        'maxnoofServedGUAMIs',
        'maxnoofSliceItems',
        'maxnoofSuccessfulHOReports',
        'maxnoofTACs',
        'maxnoofTACsinNTN',
        'maxnoofTAforMDT',
        'maxnoofTAIforInactive',
        'maxnoofTAIforMBS',
        'maxnoofTAIforPaging',
        'maxnoofTAIforRestart',
        'maxnoofTAIforWarning',
        'maxnoofTAIinAoI',
        'maxnoofTimePeriods',
        'maxnoofTNLAssociations',
        'maxnoofUEsforPaging',
        'maxnoofWLANName',
        'maxnoofXnExtTLAs',
        'maxnoofXnGTP-TLAs',
        'maxnoofXnTLAs',
        'maxnoofCandidateCells',
        'maxnoofTargetS-NSSAIs',
        'maxNRARFCN',
        'maxnoofCellIDforQMC',
        'maxnoofPLMNforQMC',
        'maxnoofUEAppLayerMeas',
        'maxnoofSNSSAIforQMC',
        'maxnoofTAforQMC',
        'maxnoofThresholdsForExcessPacketDelay',
        'id-AllowedNSSAI',
        'id-AMFName',
        'id-AMFOverloadResponse',
        'id-AMFSetID',
        'id-AMF-TNLAssociationFailedToSetupList',
        'id-AMF-TNLAssociationSetupList',
        'id-AMF-TNLAssociationToAddList',
        'id-AMF-TNLAssociationToRemoveList',
        'id-AMF-TNLAssociationToUpdateList',
        'id-AMFTrafficLoadReductionIndication',
        'id-AMF-UE-NGAP-ID',
        'id-AssistanceDataForPaging',
        'id-BroadcastCancelledAreaList',
        'id-BroadcastCompletedAreaList',
        'id-CancelAllWarningMessages',
        'id-Cause',
        'id-CellIDListForRestart',
        'id-ConcurrentWarningMessageInd',
        'id-CoreNetworkAssistanceInformationForInactive',
        'id-CriticalityDiagnostics',
        'id-DataCodingScheme',
        'id-DefaultPagingDRX',
        'id-DirectForwardingPathAvailability',
        'id-EmergencyAreaIDListForRestart',
        'id-EmergencyFallbackIndicator',
        'id-EUTRA-CGI',
        'id-FiveG-S-TMSI',
        'id-GlobalRANNodeID',
        'id-GUAMI',
        'id-HandoverType',
        'id-IMSVoiceSupportIndicator',
        'id-IndexToRFSP',
        'id-InfoOnRecommendedCellsAndRANNodesForPaging',
        'id-LocationReportingRequestType',
        'id-MaskedIMEISV',
        'id-MessageIdentifier',
        'id-MobilityRestrictionList',
        'id-NASC',
        'id-NAS-PDU',
        'id-NASSecurityParametersFromNGRAN',
        'id-NewAMF-UE-NGAP-ID',
        'id-NewSecurityContextInd',
        'id-NGAP-Message',
        'id-NGRAN-CGI',
        'id-NGRANTraceID',
        'id-NR-CGI',
        'id-NRPPa-PDU',
        'id-NumberOfBroadcastsRequested',
        'id-OldAMF',
        'id-OverloadStartNSSAIList',
        'id-PagingDRX',
        'id-PagingOrigin',
        'id-PagingPriority',
        'id-PDUSessionResourceAdmittedList',
        'id-PDUSessionResourceFailedToModifyListModRes',
        'id-PDUSessionResourceFailedToSetupListCxtRes',
        'id-PDUSessionResourceFailedToSetupListHOAck',
        'id-PDUSessionResourceFailedToSetupListPSReq',
        'id-PDUSessionResourceFailedToSetupListSURes',
        'id-PDUSessionResourceHandoverList',
        'id-PDUSessionResourceListCxtRelCpl',
        'id-PDUSessionResourceListHORqd',
        'id-PDUSessionResourceModifyListModCfm',
        'id-PDUSessionResourceModifyListModInd',
        'id-PDUSessionResourceModifyListModReq',
        'id-PDUSessionResourceModifyListModRes',
        'id-PDUSessionResourceNotifyList',
        'id-PDUSessionResourceReleasedListNot',
        'id-PDUSessionResourceReleasedListPSAck',
        'id-PDUSessionResourceReleasedListPSFail',
        'id-PDUSessionResourceReleasedListRelRes',
        'id-PDUSessionResourceSetupListCxtReq',
        'id-PDUSessionResourceSetupListCxtRes',
        'id-PDUSessionResourceSetupListHOReq',
        'id-PDUSessionResourceSetupListSUReq',
        'id-PDUSessionResourceSetupListSURes',
        'id-PDUSessionResourceToBeSwitchedDLList',
        'id-PDUSessionResourceSwitchedList',
        'id-PDUSessionResourceToReleaseListHOCmd',
        'id-PDUSessionResourceToReleaseListRelCmd',
        'id-PLMNSupportList',
        'id-PWSFailedCellIDList',
        'id-RANNodeName',
        'id-RANPagingPriority',
        'id-RANStatusTransfer-TransparentContainer',
        'id-RAN-UE-NGAP-ID',
        'id-RelativeAMFCapacity',
        'id-RepetitionPeriod',
        'id-ResetType',
        'id-RoutingID',
        'id-RRCEstablishmentCause',
        'id-RRCInactiveTransitionReportRequest',
        'id-RRCState',
        'id-SecurityContext',
        'id-SecurityKey',
        'id-SerialNumber',
        'id-ServedGUAMIList',
        'id-SliceSupportList',
        'id-SONConfigurationTransferDL',
        'id-SONConfigurationTransferUL',
        'id-SourceAMF-UE-NGAP-ID',
        'id-SourceToTarget-TransparentContainer',
        'id-SupportedTAList',
        'id-TAIListForPaging',
        'id-TAIListForRestart',
        'id-TargetID',
        'id-TargetToSource-TransparentContainer',
        'id-TimeToWait',
        'id-TraceActivation',
        'id-TraceCollectionEntityIPAddress',
        'id-UEAggregateMaximumBitRate',
        'id-UE-associatedLogicalNG-connectionList',
        'id-UEContextRequest',
        'id-UE-NGAP-IDs',
        'id-UEPagingIdentity',
        'id-UEPresenceInAreaOfInterestList',
        'id-UERadioCapability',
        'id-UERadioCapabilityForPaging',
        'id-UESecurityCapabilities',
        'id-UnavailableGUAMIList',
        'id-UserLocationInformation',
        'id-WarningAreaList',
        'id-WarningMessageContents',
        'id-WarningSecurityInfo',
        'id-WarningType',
        'id-AdditionalUL-NGU-UP-TNLInformation',
        'id-DataForwardingNotPossible',
        'id-DL-NGU-UP-TNLInformation',
        'id-NetworkInstance',
        'id-PDUSessionAggregateMaximumBitRate',
        'id-PDUSessionResourceFailedToModifyListModCfm',
        'id-PDUSessionResourceFailedToSetupListCxtFail',
        'id-PDUSessionResourceListCxtRelReq',
        'id-PDUSessionType',
        'id-QosFlowAddOrModifyRequestList',
        'id-QosFlowSetupRequestList',
        'id-QosFlowToReleaseList',
        'id-SecurityIndication',
        'id-UL-NGU-UP-TNLInformation',
        'id-UL-NGU-UP-TNLModifyList',
        'id-WarningAreaCoordinates',
        'id-PDUSessionResourceSecondaryRATUsageList',
        'id-HandoverFlag',
        'id-SecondaryRATUsageInformation',
        'id-PDUSessionResourceReleaseResponseTransfer',
        'id-RedirectionVoiceFallback',
        'id-UERetentionInformation',
        'id-S-NSSAI',
        'id-PSCellInformation',
        'id-LastEUTRAN-PLMNIdentity',
        'id-MaximumIntegrityProtectedDataRate-DL',
        'id-AdditionalDLForwardingUPTNLInformation',
        'id-AdditionalDLUPTNLInformationForHOList',
        'id-AdditionalNGU-UP-TNLInformation',
        'id-AdditionalDLQosFlowPerTNLInformation',
        'id-SecurityResult',
        'id-ENDC-SONConfigurationTransferDL',
        'id-ENDC-SONConfigurationTransferUL',
        'id-OldAssociatedQosFlowList-ULendmarkerexpected',
        'id-CNTypeRestrictionsForEquivalent',
        'id-CNTypeRestrictionsForServing',
        'id-NewGUAMI',
        'id-ULForwarding',
        'id-ULForwardingUP-TNLInformation',
        'id-CNAssistedRANTuning',
        'id-CommonNetworkInstance',
        'id-NGRAN-TNLAssociationToRemoveList',
        'id-TNLAssociationTransportLayerAddressNGRAN',
        'id-EndpointIPAddressAndPort',
        'id-LocationReportingAdditionalInfo',
        'id-SourceToTarget-AMFInformationReroute',
        'id-AdditionalULForwardingUPTNLInformation',
        'id-SCTP-TLAs',
        'id-SelectedPLMNIdentity',
        'id-RIMInformationTransfer',
        'id-GUAMIType',
        'id-SRVCCOperationPossible',
        'id-TargetRNC-ID',
        'id-RAT-Information',
        'id-ExtendedRATRestrictionInformation',
        'id-QosMonitoringRequest',
        'id-SgNB-UE-X2AP-ID',
        'id-AdditionalRedundantDL-NGU-UP-TNLInformation',
        'id-AdditionalRedundantDLQosFlowPerTNLInformation',
        'id-AdditionalRedundantNGU-UP-TNLInformation',
        'id-AdditionalRedundantUL-NGU-UP-TNLInformation',
        'id-CNPacketDelayBudgetDL',
        'id-CNPacketDelayBudgetUL',
        'id-ExtendedPacketDelayBudget',
        'id-RedundantCommonNetworkInstance',
        'id-RedundantDL-NGU-TNLInformationReused',
        'id-RedundantDL-NGU-UP-TNLInformation',
        'id-RedundantDLQosFlowPerTNLInformation',
        'id-RedundantQosFlowIndicator',
        'id-RedundantUL-NGU-UP-TNLInformation',
        'id-TSCTrafficCharacteristics',
        'id-RedundantPDUSessionInformation',
        'id-UsedRSNInformation',
        'id-IAB-Authorized',
        'id-IAB-Supported',
        'id-IABNodeIndication',
        'id-NB-IoT-PagingDRX',
        'id-NB-IoT-Paging-eDRXInfo',
        'id-NB-IoT-DefaultPagingDRX',
        'id-Enhanced-CoverageRestriction',
        'id-Extended-ConnectedTime',
        'id-PagingAssisDataforCEcapabUE',
        'id-WUS-Assistance-Information',
        'id-UE-DifferentiationInfo',
        'id-NB-IoT-UEPriority',
        'id-UL-CP-SecurityInformation',
        'id-DL-CP-SecurityInformation',
        'id-TAI',
        'id-UERadioCapabilityForPagingOfNB-IoT',
        'id-LTEV2XServicesAuthorized',
        'id-NRV2XServicesAuthorized',
        'id-LTEUESidelinkAggregateMaximumBitrate',
        'id-NRUESidelinkAggregateMaximumBitrate',
        'id-PC5QoSParameters',
        'id-AlternativeQoSParaSetList',
        'id-CurrentQoSParaSetIndex',
        'id-CEmodeBrestricted',
        'id-EUTRA-PagingeDRXInformation',
        'id-CEmodeBSupport-Indicator',
        'id-LTEM-Indication',
        'id-EndIndication',
        'id-EDT-Session',
        'id-UECapabilityInfoRequest',
        'id-PDUSessionResourceFailedToResumeListRESReq',
        'id-PDUSessionResourceFailedToResumeListRESRes',
        'id-PDUSessionResourceSuspendListSUSReq',
        'id-PDUSessionResourceResumeListRESReq',
        'id-PDUSessionResourceResumeListRESRes',
        'id-UE-UP-CIoT-Support',
        'id-Suspend-Request-Indication',
        'id-Suspend-Response-Indication',
        'id-RRC-Resume-Cause',
        'id-RGLevelWirelineAccessCharacteristics',
        'id-W-AGFIdentityInformation',
        'id-GlobalTNGF-ID',
        'id-GlobalTWIF-ID',
        'id-GlobalW-AGF-ID',
        'id-UserLocationInformationW-AGF',
        'id-UserLocationInformationTNGF',
        'id-AuthenticatedIndication',
        'id-TNGFIdentityInformation',
        'id-TWIFIdentityInformation',
        'id-UserLocationInformationTWIF',
        'id-DataForwardingResponseERABList',
        'id-IntersystemSONConfigurationTransferDL',
        'id-IntersystemSONConfigurationTransferUL',
        'id-SONInformationReport',
        'id-UEHistoryInformationFromTheUE',
        'id-ManagementBasedMDTPLMNList',
        'id-MDTConfiguration',
        'id-PrivacyIndicator',
        'id-TraceCollectionEntityURI',
        'id-NPN-Support',
        'id-NPN-AccessInformation',
        'id-NPN-PagingAssistanceInformation',
        'id-NPN-MobilityInformation',
        'id-TargettoSource-Failure-TransparentContainer',
        'id-NID',
        'id-UERadioCapabilityID',
        'id-UERadioCapability-EUTRA-Format',
        'id-DAPSRequestInfo',
        'id-DAPSResponseInfoList',
        'id-EarlyStatusTransfer-TransparentContainer',
        'id-NotifySourceNGRANNode',
        'id-ExtendedSliceSupportList',
        'id-ExtendedTAISliceSupportList',
        'id-ConfiguredTACIndication',
        'id-Extended-RANNodeName',
        'id-Extended-AMFName',
        'id-GlobalCable-ID',
        'id-QosMonitoringReportingFrequency',
        'id-QosFlowParametersList',
        'id-QosFlowFeedbackList',
        'id-BurstArrivalTimeDownlink',
        'id-ExtendedUEIdentityIndexValue',
        'id-PduSessionExpectedUEActivityBehaviour',
        'id-MicoAllPLMN',
        'id-QosFlowFailedToSetupList',
        'id-SourceTNLAddrInfo',
        'id-ExtendedReportIntervalMDT',
        'id-SourceNodeID',
        'id-NRNTNTAIInformation',
        'id-UEContextReferenceAtSource',
        'id-LastVisitedPSCellList',
        'id-IntersystemSONInformationRequest',
        'id-IntersystemSONInformationReply',
        'id-EnergySavingIndication',
        'id-IntersystemResourceStatusUpdate',
        'id-SuccessfulHandoverReportList',
        'id-MBS-AreaSessionID',
        'id-MBS-QoSFlowsToBeSetupList',
        'id-MBS-QoSFlowsToBeSetupModList',
        'id-MBS-ServiceArea',
        'id-MBS-SessionID',
        'id-MBS-DistributionReleaseRequestTransfer',
        'id-MBS-DistributionSetupRequestTransfer',
        'id-MBS-DistributionSetupResponseTransfer',
        'id-MBS-DistributionSetupUnsuccessfulTransfer',
        'id-MulticastSessionActivationRequestTransfer',
        'id-MulticastSessionDeactivationRequestTransfer',
        'id-MulticastSessionUpdateRequestTransfer',
        'id-MulticastGroupPagingAreaList',
        'id-MBS-SupportIndicator',
        'id-MBSSessionFailedtoSetupList',
        'id-MBSSessionFailedtoSetuporModifyList',
        'id-MBSSessionSetupResponseList',
        'id-MBSSessionSetuporModifyResponseList',
        'id-MBSSessionSetupFailureTransfer',
        'id-MBSSessionSetupRequestTransfer',
        'id-MBSSessionSetupResponseTransfer',
        'id-MBSSessionToReleaseList',
        'id-MBSSessionSetupRequestList',
        'id-MBSSessionSetuporModifyRequestList',
        'id-MBS-ActiveSessionInformation-SourcetoTargetList',
        'id-MBS-ActiveSessionInformation-TargettoSourceList',
        'id-OnboardingSupport',
        'id-TimeSyncAssistanceInfo',
        'id-SurvivalTime',
        'id-QMCConfigInfo',
        'id-QMCDeactivation',
        'id-PDUSessionPairID',
        'id-NR-PagingeDRXInformation',
        'id-RedCapIndication',
        'id-TargetNSSAIInformation',
        'id-UESliceMaximumBitRateList',
        'id-M4ReportAmount',
        'id-M5ReportAmount',
        'id-M6ReportAmount',
        'id-M7ReportAmount',
        'id-IncludeBeamMeasurementsIndication',
        'id-ExcessPacketDelayThresholdConfiguration',
        'id-PagingCause',
        'id-PagingCauseIndicationForVoiceService',
        'id-PEIPSassistanceInformation',
        'id-FiveG-ProSeAuthorized',
        'id-FiveG-ProSeUEPC5AggregateMaximumBitRate',
        'id-FiveG-ProSePC5QoSParameters',
        'id-MBSSessionModificationFailureTransfer',
        'id-MBSSessionModificationRequestTransfer',
        'id-MBSSessionModificationResponseTransfer',
        'id-MBS-QoSFlowToReleaseList',
        'id-MBS-SessionTNLInfo5GC',
        'id-TAINSAGSupportList',
        'id-SourceNodeTNLAddrInfo',
        'id-NGAPIESupportInformationRequestList',
        'id-NGAPIESupportInformationResponseList',
        'id-MBS-SessionFSAIDList',
        'id-MBSSessionReleaseResponseTransfer',
        'id-ManagementBasedMDTPLMNModificationList',
        'id-EarlyMeasurement',
        'id-BeamMeasurementsReportConfiguration',
        'id-HFCNode-ID-new',
        'id-GlobalCable-ID-new',
        'id-TargetHomeENB-ID',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        'id-AMFConfigurationUpdate',
        'id-AMFStatusIndication',
        'id-CellTrafficTrace',
        'id-DeactivateTrace',
        'id-DownlinkNASTransport',
        'id-DownlinkNonUEAssociatedNRPPaTransport',
        'id-DownlinkRANConfigurationTransfer',
        'id-DownlinkRANStatusTransfer',
        'id-DownlinkUEAssociatedNRPPaTransport',
        'id-ErrorIndication',
        'id-HandoverCancel',
        'id-HandoverNotification',
        'id-HandoverPreparation',
        'id-HandoverResourceAllocation',
        'id-InitialContextSetup',
        'id-InitialUEMessage',
        'id-LocationReportingControl',
        'id-LocationReportingFailureIndication',
        'id-LocationReport',
        'id-NASNonDeliveryIndication',
        'id-NGReset',
        'id-NGSetup',
        'id-OverloadStart',
        'id-OverloadStop',
        'id-Paging',
        'id-PathSwitchRequest',
        'id-PDUSessionResourceModify',
        'id-PDUSessionResourceModifyIndication',
        'id-PDUSessionResourceRelease',
        'id-PDUSessionResourceSetup',
        'id-PDUSessionResourceNotify',
        'id-PrivateMessage',
        'id-PWSCancel',
        'id-PWSFailureIndication',
        'id-PWSRestartIndication',
        'id-RANConfigurationUpdate',
        'id-RerouteNASRequest',
        'id-RRCInactiveTransitionReport',
        'id-TraceFailureIndication',
        'id-TraceStart',
        'id-UEContextModification',
        'id-UEContextRelease',
        'id-UEContextReleaseRequest',
        'id-UERadioCapabilityCheck',
        'id-UERadioCapabilityInfoIndication',
        'id-UETNLABindingRelease',
        'id-UplinkNASTransport',
        'id-UplinkNonUEAssociatedNRPPaTransport',
        'id-UplinkRANConfigurationTransfer',
        'id-UplinkRANStatusTransfer',
        'id-UplinkUEAssociatedNRPPaTransport',
        'id-WriteReplaceWarning',
        'id-SecondaryRATDataUsageReport',
        'id-UplinkRIMInformationTransfer',
        'id-DownlinkRIMInformationTransfer',
        'id-RetrieveUEInformation',
        'id-UEInformationTransfer',
        'id-RANCPRelocationIndication',
        'id-UEContextResume',
        'id-UEContextSuspend',
        'id-UERadioCapabilityIDMapping',
        'id-HandoverSuccess',
        'id-UplinkRANEarlyStatusTransfer',
        'id-DownlinkRANEarlyStatusTransfer',
        'id-AMFCPRelocationIndication',
        'id-ConnectionEstablishmentIndication',
        'id-BroadcastSessionModification',
        'id-BroadcastSessionRelease',
        'id-BroadcastSessionSetup',
        'id-DistributionSetup',
        'id-DistributionRelease',
        'id-MulticastSessionActivation',
        'id-MulticastSessionDeactivation',
        'id-MulticastSessionUpdate',
        'id-MulticastGroupPaging',
        'id-BroadcastSessionReleaseRequired',
        'maxPrivateIEs',
        'maxProtocolExtensions',
        'maxProtocolIEs',
        'maxnoofAllowedAreas',
        'maxnoofAllowedCAGsperPLMN',
        'maxnoofAllowedS-NSSAIs',
        'maxnoofBluetoothName',
        'maxnoofBPLMNs',
        'maxnoofCAGSperCell',
        'maxnoofCellIDforMDT',
        'maxnoofCellIDforWarning',
        'maxnoofCellinAoI',
        'maxnoofCellinEAI',
        'maxnoofCellinTAI',
        'maxnoofCellsforMBS',
        'maxnoofCellsingNB',
        'maxnoofCellsinngeNB',
        'maxnoofCellsinNGRANNode',
        'maxnoofCellsinUEHistoryInfo',
        'maxnoofCellsUEMovingTrajectory',
        'maxnoofDRBs',
        'maxnoofEmergencyAreaID',
        'maxnoofEAIforRestart',
        'maxnoofEPLMNs',
        'maxnoofEPLMNsPlusOne',
        'maxnoofE-RABs',
        'maxnoofErrors',
        'maxnoofExtSliceItems',
        'maxnoofForbTACs',
        'maxnoofFreqforMDT',
        'maxnoofMBSAreaSessionIDs',
        'maxnoofMBSFSAs',
        'maxnoofMBSQoSFlows',
        'maxnoofMBSSessions',
        'maxnoofMBSSessionsofUE',
        'maxnoofMBSServiceAreaInformation',
        'maxnoofMDTPLMNs',
        'maxnoofMRBs',
        'maxnoofMultiConnectivity',
        'maxnoofMultiConnectivityMinusOne',
        'maxnoofNeighPCIforMDT',
        'maxnoofNGAPIESupportInfo',
        'maxnoofNGConnectionsToReset',
        'maxnoofNRCellBands',
        'maxnoofNSAGs',
        'maxnoofPagingAreas',
        'maxnoofPC5QoSFlows',
        'maxnoofPDUSessions',
        'maxnoofPLMNs',
        'maxnoofPSCellsPerPrimaryCellinUEHistoryInfo',
        'maxnoofQosFlows',
        'maxnoofQosParaSets',
        'maxnoofRANNodeinAoI',
        'maxnoofRecommendedCells',
        'maxnoofRecommendedRANNodes',
        'maxnoofAoI',
        'maxnoofReportedCells',
        'maxnoofSensorName',
        'maxnoofServedGUAMIs',
        'maxnoofSliceItems',
        'maxnoofSuccessfulHOReports',
        'maxnoofTACs',
        'maxnoofTACsinNTN',
        'maxnoofTAforMDT',
        'maxnoofTAIforInactive',
        'maxnoofTAIforMBS',
        'maxnoofTAIforPaging',
        'maxnoofTAIforRestart',
        'maxnoofTAIforWarning',
        'maxnoofTAIinAoI',
        'maxnoofTimePeriods',
        'maxnoofTNLAssociations',
        'maxnoofUEsforPaging',
        'maxnoofWLANName',
        'maxnoofXnExtTLAs',
        'maxnoofXnGTP-TLAs',
        'maxnoofXnTLAs',
        'maxnoofCandidateCells',
        'maxnoofTargetS-NSSAIs',
        'maxNRARFCN',
        'maxnoofCellIDforQMC',
        'maxnoofPLMNforQMC',
        'maxnoofUEAppLayerMeas',
        'maxnoofSNSSAIforQMC',
        'maxnoofTAforQMC',
        'maxnoofThresholdsForExcessPacketDelay',
        'id-AllowedNSSAI',
        'id-AMFName',
        'id-AMFOverloadResponse',
        'id-AMFSetID',
        'id-AMF-TNLAssociationFailedToSetupList',
        'id-AMF-TNLAssociationSetupList',
        'id-AMF-TNLAssociationToAddList',
        'id-AMF-TNLAssociationToRemoveList',
        'id-AMF-TNLAssociationToUpdateList',
        'id-AMFTrafficLoadReductionIndication',
        'id-AMF-UE-NGAP-ID',
        'id-AssistanceDataForPaging',
        'id-BroadcastCancelledAreaList',
        'id-BroadcastCompletedAreaList',
        'id-CancelAllWarningMessages',
        'id-Cause',
        'id-CellIDListForRestart',
        'id-ConcurrentWarningMessageInd',
        'id-CoreNetworkAssistanceInformationForInactive',
        'id-CriticalityDiagnostics',
        'id-DataCodingScheme',
        'id-DefaultPagingDRX',
        'id-DirectForwardingPathAvailability',
        'id-EmergencyAreaIDListForRestart',
        'id-EmergencyFallbackIndicator',
        'id-EUTRA-CGI',
        'id-FiveG-S-TMSI',
        'id-GlobalRANNodeID',
        'id-GUAMI',
        'id-HandoverType',
        'id-IMSVoiceSupportIndicator',
        'id-IndexToRFSP',
        'id-InfoOnRecommendedCellsAndRANNodesForPaging',
        'id-LocationReportingRequestType',
        'id-MaskedIMEISV',
        'id-MessageIdentifier',
        'id-MobilityRestrictionList',
        'id-NASC',
        'id-NAS-PDU',
        'id-NASSecurityParametersFromNGRAN',
        'id-NewAMF-UE-NGAP-ID',
        'id-NewSecurityContextInd',
        'id-NGAP-Message',
        'id-NGRAN-CGI',
        'id-NGRANTraceID',
        'id-NR-CGI',
        'id-NRPPa-PDU',
        'id-NumberOfBroadcastsRequested',
        'id-OldAMF',
        'id-OverloadStartNSSAIList',
        'id-PagingDRX',
        'id-PagingOrigin',
        'id-PagingPriority',
        'id-PDUSessionResourceAdmittedList',
        'id-PDUSessionResourceFailedToModifyListModRes',
        'id-PDUSessionResourceFailedToSetupListCxtRes',
        'id-PDUSessionResourceFailedToSetupListHOAck',
        'id-PDUSessionResourceFailedToSetupListPSReq',
        'id-PDUSessionResourceFailedToSetupListSURes',
        'id-PDUSessionResourceHandoverList',
        'id-PDUSessionResourceListCxtRelCpl',
        'id-PDUSessionResourceListHORqd',
        'id-PDUSessionResourceModifyListModCfm',
        'id-PDUSessionResourceModifyListModInd',
        'id-PDUSessionResourceModifyListModReq',
        'id-PDUSessionResourceModifyListModRes',
        'id-PDUSessionResourceNotifyList',
        'id-PDUSessionResourceReleasedListNot',
        'id-PDUSessionResourceReleasedListPSAck',
        'id-PDUSessionResourceReleasedListPSFail',
        'id-PDUSessionResourceReleasedListRelRes',
        'id-PDUSessionResourceSetupListCxtReq',
        'id-PDUSessionResourceSetupListCxtRes',
        'id-PDUSessionResourceSetupListHOReq',
        'id-PDUSessionResourceSetupListSUReq',
        'id-PDUSessionResourceSetupListSURes',
        'id-PDUSessionResourceToBeSwitchedDLList',
        'id-PDUSessionResourceSwitchedList',
        'id-PDUSessionResourceToReleaseListHOCmd',
        'id-PDUSessionResourceToReleaseListRelCmd',
        'id-PLMNSupportList',
        'id-PWSFailedCellIDList',
        'id-RANNodeName',
        'id-RANPagingPriority',
        'id-RANStatusTransfer-TransparentContainer',
        'id-RAN-UE-NGAP-ID',
        'id-RelativeAMFCapacity',
        'id-RepetitionPeriod',
        'id-ResetType',
        'id-RoutingID',
        'id-RRCEstablishmentCause',
        'id-RRCInactiveTransitionReportRequest',
        'id-RRCState',
        'id-SecurityContext',
        'id-SecurityKey',
        'id-SerialNumber',
        'id-ServedGUAMIList',
        'id-SliceSupportList',
        'id-SONConfigurationTransferDL',
        'id-SONConfigurationTransferUL',
        'id-SourceAMF-UE-NGAP-ID',
        'id-SourceToTarget-TransparentContainer',
        'id-SupportedTAList',
        'id-TAIListForPaging',
        'id-TAIListForRestart',
        'id-TargetID',
        'id-TargetToSource-TransparentContainer',
        'id-TimeToWait',
        'id-TraceActivation',
        'id-TraceCollectionEntityIPAddress',
        'id-UEAggregateMaximumBitRate',
        'id-UE-associatedLogicalNG-connectionList',
        'id-UEContextRequest',
        'id-UE-NGAP-IDs',
        'id-UEPagingIdentity',
        'id-UEPresenceInAreaOfInterestList',
        'id-UERadioCapability',
        'id-UERadioCapabilityForPaging',
        'id-UESecurityCapabilities',
        'id-UnavailableGUAMIList',
        'id-UserLocationInformation',
        'id-WarningAreaList',
        'id-WarningMessageContents',
        'id-WarningSecurityInfo',
        'id-WarningType',
        'id-AdditionalUL-NGU-UP-TNLInformation',
        'id-DataForwardingNotPossible',
        'id-DL-NGU-UP-TNLInformation',
        'id-NetworkInstance',
        'id-PDUSessionAggregateMaximumBitRate',
        'id-PDUSessionResourceFailedToModifyListModCfm',
        'id-PDUSessionResourceFailedToSetupListCxtFail',
        'id-PDUSessionResourceListCxtRelReq',
        'id-PDUSessionType',
        'id-QosFlowAddOrModifyRequestList',
        'id-QosFlowSetupRequestList',
        'id-QosFlowToReleaseList',
        'id-SecurityIndication',
        'id-UL-NGU-UP-TNLInformation',
        'id-UL-NGU-UP-TNLModifyList',
        'id-WarningAreaCoordinates',
        'id-PDUSessionResourceSecondaryRATUsageList',
        'id-HandoverFlag',
        'id-SecondaryRATUsageInformation',
        'id-PDUSessionResourceReleaseResponseTransfer',
        'id-RedirectionVoiceFallback',
        'id-UERetentionInformation',
        'id-S-NSSAI',
        'id-PSCellInformation',
        'id-LastEUTRAN-PLMNIdentity',
        'id-MaximumIntegrityProtectedDataRate-DL',
        'id-AdditionalDLForwardingUPTNLInformation',
        'id-AdditionalDLUPTNLInformationForHOList',
        'id-AdditionalNGU-UP-TNLInformation',
        'id-AdditionalDLQosFlowPerTNLInformation',
        'id-SecurityResult',
        'id-ENDC-SONConfigurationTransferDL',
        'id-ENDC-SONConfigurationTransferUL',
        'id-OldAssociatedQosFlowList-ULendmarkerexpected',
        'id-CNTypeRestrictionsForEquivalent',
        'id-CNTypeRestrictionsForServing',
        'id-NewGUAMI',
        'id-ULForwarding',
        'id-ULForwardingUP-TNLInformation',
        'id-CNAssistedRANTuning',
        'id-CommonNetworkInstance',
        'id-NGRAN-TNLAssociationToRemoveList',
        'id-TNLAssociationTransportLayerAddressNGRAN',
        'id-EndpointIPAddressAndPort',
        'id-LocationReportingAdditionalInfo',
        'id-SourceToTarget-AMFInformationReroute',
        'id-AdditionalULForwardingUPTNLInformation',
        'id-SCTP-TLAs',
        'id-SelectedPLMNIdentity',
        'id-RIMInformationTransfer',
        'id-GUAMIType',
        'id-SRVCCOperationPossible',
        'id-TargetRNC-ID',
        'id-RAT-Information',
        'id-ExtendedRATRestrictionInformation',
        'id-QosMonitoringRequest',
        'id-SgNB-UE-X2AP-ID',
        'id-AdditionalRedundantDL-NGU-UP-TNLInformation',
        'id-AdditionalRedundantDLQosFlowPerTNLInformation',
        'id-AdditionalRedundantNGU-UP-TNLInformation',
        'id-AdditionalRedundantUL-NGU-UP-TNLInformation',
        'id-CNPacketDelayBudgetDL',
        'id-CNPacketDelayBudgetUL',
        'id-ExtendedPacketDelayBudget',
        'id-RedundantCommonNetworkInstance',
        'id-RedundantDL-NGU-TNLInformationReused',
        'id-RedundantDL-NGU-UP-TNLInformation',
        'id-RedundantDLQosFlowPerTNLInformation',
        'id-RedundantQosFlowIndicator',
        'id-RedundantUL-NGU-UP-TNLInformation',
        'id-TSCTrafficCharacteristics',
        'id-RedundantPDUSessionInformation',
        'id-UsedRSNInformation',
        'id-IAB-Authorized',
        'id-IAB-Supported',
        'id-IABNodeIndication',
        'id-NB-IoT-PagingDRX',
        'id-NB-IoT-Paging-eDRXInfo',
        'id-NB-IoT-DefaultPagingDRX',
        'id-Enhanced-CoverageRestriction',
        'id-Extended-ConnectedTime',
        'id-PagingAssisDataforCEcapabUE',
        'id-WUS-Assistance-Information',
        'id-UE-DifferentiationInfo',
        'id-NB-IoT-UEPriority',
        'id-UL-CP-SecurityInformation',
        'id-DL-CP-SecurityInformation',
        'id-TAI',
        'id-UERadioCapabilityForPagingOfNB-IoT',
        'id-LTEV2XServicesAuthorized',
        'id-NRV2XServicesAuthorized',
        'id-LTEUESidelinkAggregateMaximumBitrate',
        'id-NRUESidelinkAggregateMaximumBitrate',
        'id-PC5QoSParameters',
        'id-AlternativeQoSParaSetList',
        'id-CurrentQoSParaSetIndex',
        'id-CEmodeBrestricted',
        'id-EUTRA-PagingeDRXInformation',
        'id-CEmodeBSupport-Indicator',
        'id-LTEM-Indication',
        'id-EndIndication',
        'id-EDT-Session',
        'id-UECapabilityInfoRequest',
        'id-PDUSessionResourceFailedToResumeListRESReq',
        'id-PDUSessionResourceFailedToResumeListRESRes',
        'id-PDUSessionResourceSuspendListSUSReq',
        'id-PDUSessionResourceResumeListRESReq',
        'id-PDUSessionResourceResumeListRESRes',
        'id-UE-UP-CIoT-Support',
        'id-Suspend-Request-Indication',
        'id-Suspend-Response-Indication',
        'id-RRC-Resume-Cause',
        'id-RGLevelWirelineAccessCharacteristics',
        'id-W-AGFIdentityInformation',
        'id-GlobalTNGF-ID',
        'id-GlobalTWIF-ID',
        'id-GlobalW-AGF-ID',
        'id-UserLocationInformationW-AGF',
        'id-UserLocationInformationTNGF',
        'id-AuthenticatedIndication',
        'id-TNGFIdentityInformation',
        'id-TWIFIdentityInformation',
        'id-UserLocationInformationTWIF',
        'id-DataForwardingResponseERABList',
        'id-IntersystemSONConfigurationTransferDL',
        'id-IntersystemSONConfigurationTransferUL',
        'id-SONInformationReport',
        'id-UEHistoryInformationFromTheUE',
        'id-ManagementBasedMDTPLMNList',
        'id-MDTConfiguration',
        'id-PrivacyIndicator',
        'id-TraceCollectionEntityURI',
        'id-NPN-Support',
        'id-NPN-AccessInformation',
        'id-NPN-PagingAssistanceInformation',
        'id-NPN-MobilityInformation',
        'id-TargettoSource-Failure-TransparentContainer',
        'id-NID',
        'id-UERadioCapabilityID',
        'id-UERadioCapability-EUTRA-Format',
        'id-DAPSRequestInfo',
        'id-DAPSResponseInfoList',
        'id-EarlyStatusTransfer-TransparentContainer',
        'id-NotifySourceNGRANNode',
        'id-ExtendedSliceSupportList',
        'id-ExtendedTAISliceSupportList',
        'id-ConfiguredTACIndication',
        'id-Extended-RANNodeName',
        'id-Extended-AMFName',
        'id-GlobalCable-ID',
        'id-QosMonitoringReportingFrequency',
        'id-QosFlowParametersList',
        'id-QosFlowFeedbackList',
        'id-BurstArrivalTimeDownlink',
        'id-ExtendedUEIdentityIndexValue',
        'id-PduSessionExpectedUEActivityBehaviour',
        'id-MicoAllPLMN',
        'id-QosFlowFailedToSetupList',
        'id-SourceTNLAddrInfo',
        'id-ExtendedReportIntervalMDT',
        'id-SourceNodeID',
        'id-NRNTNTAIInformation',
        'id-UEContextReferenceAtSource',
        'id-LastVisitedPSCellList',
        'id-IntersystemSONInformationRequest',
        'id-IntersystemSONInformationReply',
        'id-EnergySavingIndication',
        'id-IntersystemResourceStatusUpdate',
        'id-SuccessfulHandoverReportList',
        'id-MBS-AreaSessionID',
        'id-MBS-QoSFlowsToBeSetupList',
        'id-MBS-QoSFlowsToBeSetupModList',
        'id-MBS-ServiceArea',
        'id-MBS-SessionID',
        'id-MBS-DistributionReleaseRequestTransfer',
        'id-MBS-DistributionSetupRequestTransfer',
        'id-MBS-DistributionSetupResponseTransfer',
        'id-MBS-DistributionSetupUnsuccessfulTransfer',
        'id-MulticastSessionActivationRequestTransfer',
        'id-MulticastSessionDeactivationRequestTransfer',
        'id-MulticastSessionUpdateRequestTransfer',
        'id-MulticastGroupPagingAreaList',
        'id-MBS-SupportIndicator',
        'id-MBSSessionFailedtoSetupList',
        'id-MBSSessionFailedtoSetuporModifyList',
        'id-MBSSessionSetupResponseList',
        'id-MBSSessionSetuporModifyResponseList',
        'id-MBSSessionSetupFailureTransfer',
        'id-MBSSessionSetupRequestTransfer',
        'id-MBSSessionSetupResponseTransfer',
        'id-MBSSessionToReleaseList',
        'id-MBSSessionSetupRequestList',
        'id-MBSSessionSetuporModifyRequestList',
        'id-MBS-ActiveSessionInformation-SourcetoTargetList',
        'id-MBS-ActiveSessionInformation-TargettoSourceList',
        'id-OnboardingSupport',
        'id-TimeSyncAssistanceInfo',
        'id-SurvivalTime',
        'id-QMCConfigInfo',
        'id-QMCDeactivation',
        'id-PDUSessionPairID',
        'id-NR-PagingeDRXInformation',
        'id-RedCapIndication',
        'id-TargetNSSAIInformation',
        'id-UESliceMaximumBitRateList',
        'id-M4ReportAmount',
        'id-M5ReportAmount',
        'id-M6ReportAmount',
        'id-M7ReportAmount',
        'id-IncludeBeamMeasurementsIndication',
        'id-ExcessPacketDelayThresholdConfiguration',
        'id-PagingCause',
        'id-PagingCauseIndicationForVoiceService',
        'id-PEIPSassistanceInformation',
        'id-FiveG-ProSeAuthorized',
        'id-FiveG-ProSeUEPC5AggregateMaximumBitRate',
        'id-FiveG-ProSePC5QoSParameters',
        'id-MBSSessionModificationFailureTransfer',
        'id-MBSSessionModificationRequestTransfer',
        'id-MBSSessionModificationResponseTransfer',
        'id-MBS-QoSFlowToReleaseList',
        'id-MBS-SessionTNLInfo5GC',
        'id-TAINSAGSupportList',
        'id-SourceNodeTNLAddrInfo',
        'id-NGAPIESupportInformationRequestList',
        'id-NGAPIESupportInformationResponseList',
        'id-MBS-SessionFSAIDList',
        'id-MBSSessionReleaseResponseTransfer',
        'id-ManagementBasedMDTPLMNModificationList',
        'id-EarlyMeasurement',
        'id-BeamMeasurementsReportConfiguration',
        'id-HFCNode-ID-new',
        'id-GlobalCable-ID-new',
        'id-TargetHomeENB-ID',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< id-AMFConfigurationUpdate >-----#
    id_AMFConfigurationUpdate = INT(name='id-AMFConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_AMFConfigurationUpdate._val = 0
    
    #-----< id-AMFStatusIndication >-----#
    id_AMFStatusIndication = INT(name='id-AMFStatusIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_AMFStatusIndication._val = 1
    
    #-----< id-CellTrafficTrace >-----#
    id_CellTrafficTrace = INT(name='id-CellTrafficTrace', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_CellTrafficTrace._val = 2
    
    #-----< id-DeactivateTrace >-----#
    id_DeactivateTrace = INT(name='id-DeactivateTrace', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_DeactivateTrace._val = 3
    
    #-----< id-DownlinkNASTransport >-----#
    id_DownlinkNASTransport = INT(name='id-DownlinkNASTransport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_DownlinkNASTransport._val = 4
    
    #-----< id-DownlinkNonUEAssociatedNRPPaTransport >-----#
    id_DownlinkNonUEAssociatedNRPPaTransport = INT(name='id-DownlinkNonUEAssociatedNRPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_DownlinkNonUEAssociatedNRPPaTransport._val = 5
    
    #-----< id-DownlinkRANConfigurationTransfer >-----#
    id_DownlinkRANConfigurationTransfer = INT(name='id-DownlinkRANConfigurationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_DownlinkRANConfigurationTransfer._val = 6
    
    #-----< id-DownlinkRANStatusTransfer >-----#
    id_DownlinkRANStatusTransfer = INT(name='id-DownlinkRANStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_DownlinkRANStatusTransfer._val = 7
    
    #-----< id-DownlinkUEAssociatedNRPPaTransport >-----#
    id_DownlinkUEAssociatedNRPPaTransport = INT(name='id-DownlinkUEAssociatedNRPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_DownlinkUEAssociatedNRPPaTransport._val = 8
    
    #-----< id-ErrorIndication >-----#
    id_ErrorIndication = INT(name='id-ErrorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_ErrorIndication._val = 9
    
    #-----< id-HandoverCancel >-----#
    id_HandoverCancel = INT(name='id-HandoverCancel', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_HandoverCancel._val = 10
    
    #-----< id-HandoverNotification >-----#
    id_HandoverNotification = INT(name='id-HandoverNotification', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_HandoverNotification._val = 11
    
    #-----< id-HandoverPreparation >-----#
    id_HandoverPreparation = INT(name='id-HandoverPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_HandoverPreparation._val = 12
    
    #-----< id-HandoverResourceAllocation >-----#
    id_HandoverResourceAllocation = INT(name='id-HandoverResourceAllocation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_HandoverResourceAllocation._val = 13
    
    #-----< id-InitialContextSetup >-----#
    id_InitialContextSetup = INT(name='id-InitialContextSetup', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_InitialContextSetup._val = 14
    
    #-----< id-InitialUEMessage >-----#
    id_InitialUEMessage = INT(name='id-InitialUEMessage', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_InitialUEMessage._val = 15
    
    #-----< id-LocationReportingControl >-----#
    id_LocationReportingControl = INT(name='id-LocationReportingControl', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_LocationReportingControl._val = 16
    
    #-----< id-LocationReportingFailureIndication >-----#
    id_LocationReportingFailureIndication = INT(name='id-LocationReportingFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_LocationReportingFailureIndication._val = 17
    
    #-----< id-LocationReport >-----#
    id_LocationReport = INT(name='id-LocationReport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_LocationReport._val = 18
    
    #-----< id-NASNonDeliveryIndication >-----#
    id_NASNonDeliveryIndication = INT(name='id-NASNonDeliveryIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_NASNonDeliveryIndication._val = 19
    
    #-----< id-NGReset >-----#
    id_NGReset = INT(name='id-NGReset', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_NGReset._val = 20
    
    #-----< id-NGSetup >-----#
    id_NGSetup = INT(name='id-NGSetup', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_NGSetup._val = 21
    
    #-----< id-OverloadStart >-----#
    id_OverloadStart = INT(name='id-OverloadStart', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_OverloadStart._val = 22
    
    #-----< id-OverloadStop >-----#
    id_OverloadStop = INT(name='id-OverloadStop', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_OverloadStop._val = 23
    
    #-----< id-Paging >-----#
    id_Paging = INT(name='id-Paging', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_Paging._val = 24
    
    #-----< id-PathSwitchRequest >-----#
    id_PathSwitchRequest = INT(name='id-PathSwitchRequest', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_PathSwitchRequest._val = 25
    
    #-----< id-PDUSessionResourceModify >-----#
    id_PDUSessionResourceModify = INT(name='id-PDUSessionResourceModify', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_PDUSessionResourceModify._val = 26
    
    #-----< id-PDUSessionResourceModifyIndication >-----#
    id_PDUSessionResourceModifyIndication = INT(name='id-PDUSessionResourceModifyIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_PDUSessionResourceModifyIndication._val = 27
    
    #-----< id-PDUSessionResourceRelease >-----#
    id_PDUSessionResourceRelease = INT(name='id-PDUSessionResourceRelease', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_PDUSessionResourceRelease._val = 28
    
    #-----< id-PDUSessionResourceSetup >-----#
    id_PDUSessionResourceSetup = INT(name='id-PDUSessionResourceSetup', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_PDUSessionResourceSetup._val = 29
    
    #-----< id-PDUSessionResourceNotify >-----#
    id_PDUSessionResourceNotify = INT(name='id-PDUSessionResourceNotify', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_PDUSessionResourceNotify._val = 30
    
    #-----< id-PrivateMessage >-----#
    id_PrivateMessage = INT(name='id-PrivateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_PrivateMessage._val = 31
    
    #-----< id-PWSCancel >-----#
    id_PWSCancel = INT(name='id-PWSCancel', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_PWSCancel._val = 32
    
    #-----< id-PWSFailureIndication >-----#
    id_PWSFailureIndication = INT(name='id-PWSFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_PWSFailureIndication._val = 33
    
    #-----< id-PWSRestartIndication >-----#
    id_PWSRestartIndication = INT(name='id-PWSRestartIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_PWSRestartIndication._val = 34
    
    #-----< id-RANConfigurationUpdate >-----#
    id_RANConfigurationUpdate = INT(name='id-RANConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_RANConfigurationUpdate._val = 35
    
    #-----< id-RerouteNASRequest >-----#
    id_RerouteNASRequest = INT(name='id-RerouteNASRequest', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_RerouteNASRequest._val = 36
    
    #-----< id-RRCInactiveTransitionReport >-----#
    id_RRCInactiveTransitionReport = INT(name='id-RRCInactiveTransitionReport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_RRCInactiveTransitionReport._val = 37
    
    #-----< id-TraceFailureIndication >-----#
    id_TraceFailureIndication = INT(name='id-TraceFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_TraceFailureIndication._val = 38
    
    #-----< id-TraceStart >-----#
    id_TraceStart = INT(name='id-TraceStart', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_TraceStart._val = 39
    
    #-----< id-UEContextModification >-----#
    id_UEContextModification = INT(name='id-UEContextModification', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextModification._val = 40
    
    #-----< id-UEContextRelease >-----#
    id_UEContextRelease = INT(name='id-UEContextRelease', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextRelease._val = 41
    
    #-----< id-UEContextReleaseRequest >-----#
    id_UEContextReleaseRequest = INT(name='id-UEContextReleaseRequest', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextReleaseRequest._val = 42
    
    #-----< id-UERadioCapabilityCheck >-----#
    id_UERadioCapabilityCheck = INT(name='id-UERadioCapabilityCheck', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UERadioCapabilityCheck._val = 43
    
    #-----< id-UERadioCapabilityInfoIndication >-----#
    id_UERadioCapabilityInfoIndication = INT(name='id-UERadioCapabilityInfoIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UERadioCapabilityInfoIndication._val = 44
    
    #-----< id-UETNLABindingRelease >-----#
    id_UETNLABindingRelease = INT(name='id-UETNLABindingRelease', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UETNLABindingRelease._val = 45
    
    #-----< id-UplinkNASTransport >-----#
    id_UplinkNASTransport = INT(name='id-UplinkNASTransport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UplinkNASTransport._val = 46
    
    #-----< id-UplinkNonUEAssociatedNRPPaTransport >-----#
    id_UplinkNonUEAssociatedNRPPaTransport = INT(name='id-UplinkNonUEAssociatedNRPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UplinkNonUEAssociatedNRPPaTransport._val = 47
    
    #-----< id-UplinkRANConfigurationTransfer >-----#
    id_UplinkRANConfigurationTransfer = INT(name='id-UplinkRANConfigurationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UplinkRANConfigurationTransfer._val = 48
    
    #-----< id-UplinkRANStatusTransfer >-----#
    id_UplinkRANStatusTransfer = INT(name='id-UplinkRANStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UplinkRANStatusTransfer._val = 49
    
    #-----< id-UplinkUEAssociatedNRPPaTransport >-----#
    id_UplinkUEAssociatedNRPPaTransport = INT(name='id-UplinkUEAssociatedNRPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UplinkUEAssociatedNRPPaTransport._val = 50
    
    #-----< id-WriteReplaceWarning >-----#
    id_WriteReplaceWarning = INT(name='id-WriteReplaceWarning', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_WriteReplaceWarning._val = 51
    
    #-----< id-SecondaryRATDataUsageReport >-----#
    id_SecondaryRATDataUsageReport = INT(name='id-SecondaryRATDataUsageReport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_SecondaryRATDataUsageReport._val = 52
    
    #-----< id-UplinkRIMInformationTransfer >-----#
    id_UplinkRIMInformationTransfer = INT(name='id-UplinkRIMInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UplinkRIMInformationTransfer._val = 53
    
    #-----< id-DownlinkRIMInformationTransfer >-----#
    id_DownlinkRIMInformationTransfer = INT(name='id-DownlinkRIMInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_DownlinkRIMInformationTransfer._val = 54
    
    #-----< id-RetrieveUEInformation >-----#
    id_RetrieveUEInformation = INT(name='id-RetrieveUEInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_RetrieveUEInformation._val = 55
    
    #-----< id-UEInformationTransfer >-----#
    id_UEInformationTransfer = INT(name='id-UEInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UEInformationTransfer._val = 56
    
    #-----< id-RANCPRelocationIndication >-----#
    id_RANCPRelocationIndication = INT(name='id-RANCPRelocationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_RANCPRelocationIndication._val = 57
    
    #-----< id-UEContextResume >-----#
    id_UEContextResume = INT(name='id-UEContextResume', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextResume._val = 58
    
    #-----< id-UEContextSuspend >-----#
    id_UEContextSuspend = INT(name='id-UEContextSuspend', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextSuspend._val = 59
    
    #-----< id-UERadioCapabilityIDMapping >-----#
    id_UERadioCapabilityIDMapping = INT(name='id-UERadioCapabilityIDMapping', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UERadioCapabilityIDMapping._val = 60
    
    #-----< id-HandoverSuccess >-----#
    id_HandoverSuccess = INT(name='id-HandoverSuccess', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_HandoverSuccess._val = 61
    
    #-----< id-UplinkRANEarlyStatusTransfer >-----#
    id_UplinkRANEarlyStatusTransfer = INT(name='id-UplinkRANEarlyStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_UplinkRANEarlyStatusTransfer._val = 62
    
    #-----< id-DownlinkRANEarlyStatusTransfer >-----#
    id_DownlinkRANEarlyStatusTransfer = INT(name='id-DownlinkRANEarlyStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_DownlinkRANEarlyStatusTransfer._val = 63
    
    #-----< id-AMFCPRelocationIndication >-----#
    id_AMFCPRelocationIndication = INT(name='id-AMFCPRelocationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_AMFCPRelocationIndication._val = 64
    
    #-----< id-ConnectionEstablishmentIndication >-----#
    id_ConnectionEstablishmentIndication = INT(name='id-ConnectionEstablishmentIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_ConnectionEstablishmentIndication._val = 65
    
    #-----< id-BroadcastSessionModification >-----#
    id_BroadcastSessionModification = INT(name='id-BroadcastSessionModification', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_BroadcastSessionModification._val = 66
    
    #-----< id-BroadcastSessionRelease >-----#
    id_BroadcastSessionRelease = INT(name='id-BroadcastSessionRelease', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_BroadcastSessionRelease._val = 67
    
    #-----< id-BroadcastSessionSetup >-----#
    id_BroadcastSessionSetup = INT(name='id-BroadcastSessionSetup', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_BroadcastSessionSetup._val = 68
    
    #-----< id-DistributionSetup >-----#
    id_DistributionSetup = INT(name='id-DistributionSetup', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_DistributionSetup._val = 69
    
    #-----< id-DistributionRelease >-----#
    id_DistributionRelease = INT(name='id-DistributionRelease', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_DistributionRelease._val = 70
    
    #-----< id-MulticastSessionActivation >-----#
    id_MulticastSessionActivation = INT(name='id-MulticastSessionActivation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_MulticastSessionActivation._val = 71
    
    #-----< id-MulticastSessionDeactivation >-----#
    id_MulticastSessionDeactivation = INT(name='id-MulticastSessionDeactivation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_MulticastSessionDeactivation._val = 72
    
    #-----< id-MulticastSessionUpdate >-----#
    id_MulticastSessionUpdate = INT(name='id-MulticastSessionUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_MulticastSessionUpdate._val = 73
    
    #-----< id-MulticastGroupPaging >-----#
    id_MulticastGroupPaging = INT(name='id-MulticastGroupPaging', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_MulticastGroupPaging._val = 74
    
    #-----< id-BroadcastSessionReleaseRequired >-----#
    id_BroadcastSessionReleaseRequired = INT(name='id-BroadcastSessionReleaseRequired', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')))
    id_BroadcastSessionReleaseRequired._val = 75
    
    #-----< maxPrivateIEs >-----#
    maxPrivateIEs = INT(name='maxPrivateIEs', mode=MODE_VALUE)
    maxPrivateIEs._val = 65535
    
    #-----< maxProtocolExtensions >-----#
    maxProtocolExtensions = INT(name='maxProtocolExtensions', mode=MODE_VALUE)
    maxProtocolExtensions._val = 65535
    
    #-----< maxProtocolIEs >-----#
    maxProtocolIEs = INT(name='maxProtocolIEs', mode=MODE_VALUE)
    maxProtocolIEs._val = 65535
    
    #-----< maxnoofAllowedAreas >-----#
    maxnoofAllowedAreas = INT(name='maxnoofAllowedAreas', mode=MODE_VALUE)
    maxnoofAllowedAreas._val = 16
    
    #-----< maxnoofAllowedCAGsperPLMN >-----#
    maxnoofAllowedCAGsperPLMN = INT(name='maxnoofAllowedCAGsperPLMN', mode=MODE_VALUE)
    maxnoofAllowedCAGsperPLMN._val = 256
    
    #-----< maxnoofAllowedS-NSSAIs >-----#
    maxnoofAllowedS_NSSAIs = INT(name='maxnoofAllowedS-NSSAIs', mode=MODE_VALUE)
    maxnoofAllowedS_NSSAIs._val = 8
    
    #-----< maxnoofBluetoothName >-----#
    maxnoofBluetoothName = INT(name='maxnoofBluetoothName', mode=MODE_VALUE)
    maxnoofBluetoothName._val = 4
    
    #-----< maxnoofBPLMNs >-----#
    maxnoofBPLMNs = INT(name='maxnoofBPLMNs', mode=MODE_VALUE)
    maxnoofBPLMNs._val = 12
    
    #-----< maxnoofCAGSperCell >-----#
    maxnoofCAGSperCell = INT(name='maxnoofCAGSperCell', mode=MODE_VALUE)
    maxnoofCAGSperCell._val = 64
    
    #-----< maxnoofCellIDforMDT >-----#
    maxnoofCellIDforMDT = INT(name='maxnoofCellIDforMDT', mode=MODE_VALUE)
    maxnoofCellIDforMDT._val = 32
    
    #-----< maxnoofCellIDforWarning >-----#
    maxnoofCellIDforWarning = INT(name='maxnoofCellIDforWarning', mode=MODE_VALUE)
    maxnoofCellIDforWarning._val = 65535
    
    #-----< maxnoofCellinAoI >-----#
    maxnoofCellinAoI = INT(name='maxnoofCellinAoI', mode=MODE_VALUE)
    maxnoofCellinAoI._val = 256
    
    #-----< maxnoofCellinEAI >-----#
    maxnoofCellinEAI = INT(name='maxnoofCellinEAI', mode=MODE_VALUE)
    maxnoofCellinEAI._val = 65535
    
    #-----< maxnoofCellinTAI >-----#
    maxnoofCellinTAI = INT(name='maxnoofCellinTAI', mode=MODE_VALUE)
    maxnoofCellinTAI._val = 65535
    
    #-----< maxnoofCellsforMBS >-----#
    maxnoofCellsforMBS = INT(name='maxnoofCellsforMBS', mode=MODE_VALUE)
    maxnoofCellsforMBS._val = 8192
    
    #-----< maxnoofCellsingNB >-----#
    maxnoofCellsingNB = INT(name='maxnoofCellsingNB', mode=MODE_VALUE)
    maxnoofCellsingNB._val = 16384
    
    #-----< maxnoofCellsinngeNB >-----#
    maxnoofCellsinngeNB = INT(name='maxnoofCellsinngeNB', mode=MODE_VALUE)
    maxnoofCellsinngeNB._val = 256
    
    #-----< maxnoofCellsinNGRANNode >-----#
    maxnoofCellsinNGRANNode = INT(name='maxnoofCellsinNGRANNode', mode=MODE_VALUE)
    maxnoofCellsinNGRANNode._val = 16384
    
    #-----< maxnoofCellsinUEHistoryInfo >-----#
    maxnoofCellsinUEHistoryInfo = INT(name='maxnoofCellsinUEHistoryInfo', mode=MODE_VALUE)
    maxnoofCellsinUEHistoryInfo._val = 16
    
    #-----< maxnoofCellsUEMovingTrajectory >-----#
    maxnoofCellsUEMovingTrajectory = INT(name='maxnoofCellsUEMovingTrajectory', mode=MODE_VALUE)
    maxnoofCellsUEMovingTrajectory._val = 16
    
    #-----< maxnoofDRBs >-----#
    maxnoofDRBs = INT(name='maxnoofDRBs', mode=MODE_VALUE)
    maxnoofDRBs._val = 32
    
    #-----< maxnoofEmergencyAreaID >-----#
    maxnoofEmergencyAreaID = INT(name='maxnoofEmergencyAreaID', mode=MODE_VALUE)
    maxnoofEmergencyAreaID._val = 65535
    
    #-----< maxnoofEAIforRestart >-----#
    maxnoofEAIforRestart = INT(name='maxnoofEAIforRestart', mode=MODE_VALUE)
    maxnoofEAIforRestart._val = 256
    
    #-----< maxnoofEPLMNs >-----#
    maxnoofEPLMNs = INT(name='maxnoofEPLMNs', mode=MODE_VALUE)
    maxnoofEPLMNs._val = 15
    
    #-----< maxnoofEPLMNsPlusOne >-----#
    maxnoofEPLMNsPlusOne = INT(name='maxnoofEPLMNsPlusOne', mode=MODE_VALUE)
    maxnoofEPLMNsPlusOne._val = 16
    
    #-----< maxnoofE-RABs >-----#
    maxnoofE_RABs = INT(name='maxnoofE-RABs', mode=MODE_VALUE)
    maxnoofE_RABs._val = 256
    
    #-----< maxnoofErrors >-----#
    maxnoofErrors = INT(name='maxnoofErrors', mode=MODE_VALUE)
    maxnoofErrors._val = 256
    
    #-----< maxnoofExtSliceItems >-----#
    maxnoofExtSliceItems = INT(name='maxnoofExtSliceItems', mode=MODE_VALUE)
    maxnoofExtSliceItems._val = 65535
    
    #-----< maxnoofForbTACs >-----#
    maxnoofForbTACs = INT(name='maxnoofForbTACs', mode=MODE_VALUE)
    maxnoofForbTACs._val = 4096
    
    #-----< maxnoofFreqforMDT >-----#
    maxnoofFreqforMDT = INT(name='maxnoofFreqforMDT', mode=MODE_VALUE)
    maxnoofFreqforMDT._val = 8
    
    #-----< maxnoofMBSAreaSessionIDs >-----#
    maxnoofMBSAreaSessionIDs = INT(name='maxnoofMBSAreaSessionIDs', mode=MODE_VALUE)
    maxnoofMBSAreaSessionIDs._val = 256
    
    #-----< maxnoofMBSFSAs >-----#
    maxnoofMBSFSAs = INT(name='maxnoofMBSFSAs', mode=MODE_VALUE)
    maxnoofMBSFSAs._val = 64
    
    #-----< maxnoofMBSQoSFlows >-----#
    maxnoofMBSQoSFlows = INT(name='maxnoofMBSQoSFlows', mode=MODE_VALUE)
    maxnoofMBSQoSFlows._val = 64
    
    #-----< maxnoofMBSSessions >-----#
    maxnoofMBSSessions = INT(name='maxnoofMBSSessions', mode=MODE_VALUE)
    maxnoofMBSSessions._val = 32
    
    #-----< maxnoofMBSSessionsofUE >-----#
    maxnoofMBSSessionsofUE = INT(name='maxnoofMBSSessionsofUE', mode=MODE_VALUE)
    maxnoofMBSSessionsofUE._val = 256
    
    #-----< maxnoofMBSServiceAreaInformation >-----#
    maxnoofMBSServiceAreaInformation = INT(name='maxnoofMBSServiceAreaInformation', mode=MODE_VALUE)
    maxnoofMBSServiceAreaInformation._val = 256
    
    #-----< maxnoofMDTPLMNs >-----#
    maxnoofMDTPLMNs = INT(name='maxnoofMDTPLMNs', mode=MODE_VALUE)
    maxnoofMDTPLMNs._val = 16
    
    #-----< maxnoofMRBs >-----#
    maxnoofMRBs = INT(name='maxnoofMRBs', mode=MODE_VALUE)
    maxnoofMRBs._val = 32
    
    #-----< maxnoofMultiConnectivity >-----#
    maxnoofMultiConnectivity = INT(name='maxnoofMultiConnectivity', mode=MODE_VALUE)
    maxnoofMultiConnectivity._val = 4
    
    #-----< maxnoofMultiConnectivityMinusOne >-----#
    maxnoofMultiConnectivityMinusOne = INT(name='maxnoofMultiConnectivityMinusOne', mode=MODE_VALUE)
    maxnoofMultiConnectivityMinusOne._val = 3
    
    #-----< maxnoofNeighPCIforMDT >-----#
    maxnoofNeighPCIforMDT = INT(name='maxnoofNeighPCIforMDT', mode=MODE_VALUE)
    maxnoofNeighPCIforMDT._val = 32
    
    #-----< maxnoofNGAPIESupportInfo >-----#
    maxnoofNGAPIESupportInfo = INT(name='maxnoofNGAPIESupportInfo', mode=MODE_VALUE)
    maxnoofNGAPIESupportInfo._val = 32
    
    #-----< maxnoofNGConnectionsToReset >-----#
    maxnoofNGConnectionsToReset = INT(name='maxnoofNGConnectionsToReset', mode=MODE_VALUE)
    maxnoofNGConnectionsToReset._val = 65536
    
    #-----< maxnoofNRCellBands >-----#
    maxnoofNRCellBands = INT(name='maxnoofNRCellBands', mode=MODE_VALUE)
    maxnoofNRCellBands._val = 32
    
    #-----< maxnoofNSAGs >-----#
    maxnoofNSAGs = INT(name='maxnoofNSAGs', mode=MODE_VALUE)
    maxnoofNSAGs._val = 256
    
    #-----< maxnoofPagingAreas >-----#
    maxnoofPagingAreas = INT(name='maxnoofPagingAreas', mode=MODE_VALUE)
    maxnoofPagingAreas._val = 64
    
    #-----< maxnoofPC5QoSFlows >-----#
    maxnoofPC5QoSFlows = INT(name='maxnoofPC5QoSFlows', mode=MODE_VALUE)
    maxnoofPC5QoSFlows._val = 2048
    
    #-----< maxnoofPDUSessions >-----#
    maxnoofPDUSessions = INT(name='maxnoofPDUSessions', mode=MODE_VALUE)
    maxnoofPDUSessions._val = 256
    
    #-----< maxnoofPLMNs >-----#
    maxnoofPLMNs = INT(name='maxnoofPLMNs', mode=MODE_VALUE)
    maxnoofPLMNs._val = 12
    
    #-----< maxnoofPSCellsPerPrimaryCellinUEHistoryInfo >-----#
    maxnoofPSCellsPerPrimaryCellinUEHistoryInfo = INT(name='maxnoofPSCellsPerPrimaryCellinUEHistoryInfo', mode=MODE_VALUE)
    maxnoofPSCellsPerPrimaryCellinUEHistoryInfo._val = 8
    
    #-----< maxnoofQosFlows >-----#
    maxnoofQosFlows = INT(name='maxnoofQosFlows', mode=MODE_VALUE)
    maxnoofQosFlows._val = 64
    
    #-----< maxnoofQosParaSets >-----#
    maxnoofQosParaSets = INT(name='maxnoofQosParaSets', mode=MODE_VALUE)
    maxnoofQosParaSets._val = 8
    
    #-----< maxnoofRANNodeinAoI >-----#
    maxnoofRANNodeinAoI = INT(name='maxnoofRANNodeinAoI', mode=MODE_VALUE)
    maxnoofRANNodeinAoI._val = 64
    
    #-----< maxnoofRecommendedCells >-----#
    maxnoofRecommendedCells = INT(name='maxnoofRecommendedCells', mode=MODE_VALUE)
    maxnoofRecommendedCells._val = 16
    
    #-----< maxnoofRecommendedRANNodes >-----#
    maxnoofRecommendedRANNodes = INT(name='maxnoofRecommendedRANNodes', mode=MODE_VALUE)
    maxnoofRecommendedRANNodes._val = 16
    
    #-----< maxnoofAoI >-----#
    maxnoofAoI = INT(name='maxnoofAoI', mode=MODE_VALUE)
    maxnoofAoI._val = 64
    
    #-----< maxnoofReportedCells >-----#
    maxnoofReportedCells = INT(name='maxnoofReportedCells', mode=MODE_VALUE)
    maxnoofReportedCells._val = 256
    
    #-----< maxnoofSensorName >-----#
    maxnoofSensorName = INT(name='maxnoofSensorName', mode=MODE_VALUE)
    maxnoofSensorName._val = 3
    
    #-----< maxnoofServedGUAMIs >-----#
    maxnoofServedGUAMIs = INT(name='maxnoofServedGUAMIs', mode=MODE_VALUE)
    maxnoofServedGUAMIs._val = 256
    
    #-----< maxnoofSliceItems >-----#
    maxnoofSliceItems = INT(name='maxnoofSliceItems', mode=MODE_VALUE)
    maxnoofSliceItems._val = 1024
    
    #-----< maxnoofSuccessfulHOReports >-----#
    maxnoofSuccessfulHOReports = INT(name='maxnoofSuccessfulHOReports', mode=MODE_VALUE)
    maxnoofSuccessfulHOReports._val = 64
    
    #-----< maxnoofTACs >-----#
    maxnoofTACs = INT(name='maxnoofTACs', mode=MODE_VALUE)
    maxnoofTACs._val = 256
    
    #-----< maxnoofTACsinNTN >-----#
    maxnoofTACsinNTN = INT(name='maxnoofTACsinNTN', mode=MODE_VALUE)
    maxnoofTACsinNTN._val = 12
    
    #-----< maxnoofTAforMDT >-----#
    maxnoofTAforMDT = INT(name='maxnoofTAforMDT', mode=MODE_VALUE)
    maxnoofTAforMDT._val = 8
    
    #-----< maxnoofTAIforInactive >-----#
    maxnoofTAIforInactive = INT(name='maxnoofTAIforInactive', mode=MODE_VALUE)
    maxnoofTAIforInactive._val = 16
    
    #-----< maxnoofTAIforMBS >-----#
    maxnoofTAIforMBS = INT(name='maxnoofTAIforMBS', mode=MODE_VALUE)
    maxnoofTAIforMBS._val = 1024
    
    #-----< maxnoofTAIforPaging >-----#
    maxnoofTAIforPaging = INT(name='maxnoofTAIforPaging', mode=MODE_VALUE)
    maxnoofTAIforPaging._val = 16
    
    #-----< maxnoofTAIforRestart >-----#
    maxnoofTAIforRestart = INT(name='maxnoofTAIforRestart', mode=MODE_VALUE)
    maxnoofTAIforRestart._val = 2048
    
    #-----< maxnoofTAIforWarning >-----#
    maxnoofTAIforWarning = INT(name='maxnoofTAIforWarning', mode=MODE_VALUE)
    maxnoofTAIforWarning._val = 65535
    
    #-----< maxnoofTAIinAoI >-----#
    maxnoofTAIinAoI = INT(name='maxnoofTAIinAoI', mode=MODE_VALUE)
    maxnoofTAIinAoI._val = 16
    
    #-----< maxnoofTimePeriods >-----#
    maxnoofTimePeriods = INT(name='maxnoofTimePeriods', mode=MODE_VALUE)
    maxnoofTimePeriods._val = 2
    
    #-----< maxnoofTNLAssociations >-----#
    maxnoofTNLAssociations = INT(name='maxnoofTNLAssociations', mode=MODE_VALUE)
    maxnoofTNLAssociations._val = 32
    
    #-----< maxnoofUEsforPaging >-----#
    maxnoofUEsforPaging = INT(name='maxnoofUEsforPaging', mode=MODE_VALUE)
    maxnoofUEsforPaging._val = 4096
    
    #-----< maxnoofWLANName >-----#
    maxnoofWLANName = INT(name='maxnoofWLANName', mode=MODE_VALUE)
    maxnoofWLANName._val = 4
    
    #-----< maxnoofXnExtTLAs >-----#
    maxnoofXnExtTLAs = INT(name='maxnoofXnExtTLAs', mode=MODE_VALUE)
    maxnoofXnExtTLAs._val = 16
    
    #-----< maxnoofXnGTP-TLAs >-----#
    maxnoofXnGTP_TLAs = INT(name='maxnoofXnGTP-TLAs', mode=MODE_VALUE)
    maxnoofXnGTP_TLAs._val = 16
    
    #-----< maxnoofXnTLAs >-----#
    maxnoofXnTLAs = INT(name='maxnoofXnTLAs', mode=MODE_VALUE)
    maxnoofXnTLAs._val = 2
    
    #-----< maxnoofCandidateCells >-----#
    maxnoofCandidateCells = INT(name='maxnoofCandidateCells', mode=MODE_VALUE)
    maxnoofCandidateCells._val = 32
    
    #-----< maxnoofTargetS-NSSAIs >-----#
    maxnoofTargetS_NSSAIs = INT(name='maxnoofTargetS-NSSAIs', mode=MODE_VALUE)
    maxnoofTargetS_NSSAIs._val = 8
    
    #-----< maxNRARFCN >-----#
    maxNRARFCN = INT(name='maxNRARFCN', mode=MODE_VALUE)
    maxNRARFCN._val = 3279165
    
    #-----< maxnoofCellIDforQMC >-----#
    maxnoofCellIDforQMC = INT(name='maxnoofCellIDforQMC', mode=MODE_VALUE)
    maxnoofCellIDforQMC._val = 32
    
    #-----< maxnoofPLMNforQMC >-----#
    maxnoofPLMNforQMC = INT(name='maxnoofPLMNforQMC', mode=MODE_VALUE)
    maxnoofPLMNforQMC._val = 16
    
    #-----< maxnoofUEAppLayerMeas >-----#
    maxnoofUEAppLayerMeas = INT(name='maxnoofUEAppLayerMeas', mode=MODE_VALUE)
    maxnoofUEAppLayerMeas._val = 16
    
    #-----< maxnoofSNSSAIforQMC >-----#
    maxnoofSNSSAIforQMC = INT(name='maxnoofSNSSAIforQMC', mode=MODE_VALUE)
    maxnoofSNSSAIforQMC._val = 16
    
    #-----< maxnoofTAforQMC >-----#
    maxnoofTAforQMC = INT(name='maxnoofTAforQMC', mode=MODE_VALUE)
    maxnoofTAforQMC._val = 8
    
    #-----< maxnoofThresholdsForExcessPacketDelay >-----#
    maxnoofThresholdsForExcessPacketDelay = INT(name='maxnoofThresholdsForExcessPacketDelay', mode=MODE_VALUE)
    maxnoofThresholdsForExcessPacketDelay._val = 255
    
    #-----< id-AllowedNSSAI >-----#
    id_AllowedNSSAI = INT(name='id-AllowedNSSAI', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AllowedNSSAI._val = 0
    
    #-----< id-AMFName >-----#
    id_AMFName = INT(name='id-AMFName', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AMFName._val = 1
    
    #-----< id-AMFOverloadResponse >-----#
    id_AMFOverloadResponse = INT(name='id-AMFOverloadResponse', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AMFOverloadResponse._val = 2
    
    #-----< id-AMFSetID >-----#
    id_AMFSetID = INT(name='id-AMFSetID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AMFSetID._val = 3
    
    #-----< id-AMF-TNLAssociationFailedToSetupList >-----#
    id_AMF_TNLAssociationFailedToSetupList = INT(name='id-AMF-TNLAssociationFailedToSetupList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AMF_TNLAssociationFailedToSetupList._val = 4
    
    #-----< id-AMF-TNLAssociationSetupList >-----#
    id_AMF_TNLAssociationSetupList = INT(name='id-AMF-TNLAssociationSetupList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AMF_TNLAssociationSetupList._val = 5
    
    #-----< id-AMF-TNLAssociationToAddList >-----#
    id_AMF_TNLAssociationToAddList = INT(name='id-AMF-TNLAssociationToAddList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AMF_TNLAssociationToAddList._val = 6
    
    #-----< id-AMF-TNLAssociationToRemoveList >-----#
    id_AMF_TNLAssociationToRemoveList = INT(name='id-AMF-TNLAssociationToRemoveList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AMF_TNLAssociationToRemoveList._val = 7
    
    #-----< id-AMF-TNLAssociationToUpdateList >-----#
    id_AMF_TNLAssociationToUpdateList = INT(name='id-AMF-TNLAssociationToUpdateList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AMF_TNLAssociationToUpdateList._val = 8
    
    #-----< id-AMFTrafficLoadReductionIndication >-----#
    id_AMFTrafficLoadReductionIndication = INT(name='id-AMFTrafficLoadReductionIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AMFTrafficLoadReductionIndication._val = 9
    
    #-----< id-AMF-UE-NGAP-ID >-----#
    id_AMF_UE_NGAP_ID = INT(name='id-AMF-UE-NGAP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AMF_UE_NGAP_ID._val = 10
    
    #-----< id-AssistanceDataForPaging >-----#
    id_AssistanceDataForPaging = INT(name='id-AssistanceDataForPaging', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AssistanceDataForPaging._val = 11
    
    #-----< id-BroadcastCancelledAreaList >-----#
    id_BroadcastCancelledAreaList = INT(name='id-BroadcastCancelledAreaList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastCancelledAreaList._val = 12
    
    #-----< id-BroadcastCompletedAreaList >-----#
    id_BroadcastCompletedAreaList = INT(name='id-BroadcastCompletedAreaList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastCompletedAreaList._val = 13
    
    #-----< id-CancelAllWarningMessages >-----#
    id_CancelAllWarningMessages = INT(name='id-CancelAllWarningMessages', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CancelAllWarningMessages._val = 14
    
    #-----< id-Cause >-----#
    id_Cause = INT(name='id-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cause._val = 15
    
    #-----< id-CellIDListForRestart >-----#
    id_CellIDListForRestart = INT(name='id-CellIDListForRestart', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellIDListForRestart._val = 16
    
    #-----< id-ConcurrentWarningMessageInd >-----#
    id_ConcurrentWarningMessageInd = INT(name='id-ConcurrentWarningMessageInd', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ConcurrentWarningMessageInd._val = 17
    
    #-----< id-CoreNetworkAssistanceInformationForInactive >-----#
    id_CoreNetworkAssistanceInformationForInactive = INT(name='id-CoreNetworkAssistanceInformationForInactive', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CoreNetworkAssistanceInformationForInactive._val = 18
    
    #-----< id-CriticalityDiagnostics >-----#
    id_CriticalityDiagnostics = INT(name='id-CriticalityDiagnostics', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CriticalityDiagnostics._val = 19
    
    #-----< id-DataCodingScheme >-----#
    id_DataCodingScheme = INT(name='id-DataCodingScheme', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DataCodingScheme._val = 20
    
    #-----< id-DefaultPagingDRX >-----#
    id_DefaultPagingDRX = INT(name='id-DefaultPagingDRX', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DefaultPagingDRX._val = 21
    
    #-----< id-DirectForwardingPathAvailability >-----#
    id_DirectForwardingPathAvailability = INT(name='id-DirectForwardingPathAvailability', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DirectForwardingPathAvailability._val = 22
    
    #-----< id-EmergencyAreaIDListForRestart >-----#
    id_EmergencyAreaIDListForRestart = INT(name='id-EmergencyAreaIDListForRestart', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EmergencyAreaIDListForRestart._val = 23
    
    #-----< id-EmergencyFallbackIndicator >-----#
    id_EmergencyFallbackIndicator = INT(name='id-EmergencyFallbackIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EmergencyFallbackIndicator._val = 24
    
    #-----< id-EUTRA-CGI >-----#
    id_EUTRA_CGI = INT(name='id-EUTRA-CGI', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EUTRA_CGI._val = 25
    
    #-----< id-FiveG-S-TMSI >-----#
    id_FiveG_S_TMSI = INT(name='id-FiveG-S-TMSI', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FiveG_S_TMSI._val = 26
    
    #-----< id-GlobalRANNodeID >-----#
    id_GlobalRANNodeID = INT(name='id-GlobalRANNodeID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GlobalRANNodeID._val = 27
    
    #-----< id-GUAMI >-----#
    id_GUAMI = INT(name='id-GUAMI', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GUAMI._val = 28
    
    #-----< id-HandoverType >-----#
    id_HandoverType = INT(name='id-HandoverType', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HandoverType._val = 29
    
    #-----< id-IMSVoiceSupportIndicator >-----#
    id_IMSVoiceSupportIndicator = INT(name='id-IMSVoiceSupportIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IMSVoiceSupportIndicator._val = 30
    
    #-----< id-IndexToRFSP >-----#
    id_IndexToRFSP = INT(name='id-IndexToRFSP', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IndexToRFSP._val = 31
    
    #-----< id-InfoOnRecommendedCellsAndRANNodesForPaging >-----#
    id_InfoOnRecommendedCellsAndRANNodesForPaging = INT(name='id-InfoOnRecommendedCellsAndRANNodesForPaging', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InfoOnRecommendedCellsAndRANNodesForPaging._val = 32
    
    #-----< id-LocationReportingRequestType >-----#
    id_LocationReportingRequestType = INT(name='id-LocationReportingRequestType', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LocationReportingRequestType._val = 33
    
    #-----< id-MaskedIMEISV >-----#
    id_MaskedIMEISV = INT(name='id-MaskedIMEISV', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MaskedIMEISV._val = 34
    
    #-----< id-MessageIdentifier >-----#
    id_MessageIdentifier = INT(name='id-MessageIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MessageIdentifier._val = 35
    
    #-----< id-MobilityRestrictionList >-----#
    id_MobilityRestrictionList = INT(name='id-MobilityRestrictionList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MobilityRestrictionList._val = 36
    
    #-----< id-NASC >-----#
    id_NASC = INT(name='id-NASC', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NASC._val = 37
    
    #-----< id-NAS-PDU >-----#
    id_NAS_PDU = INT(name='id-NAS-PDU', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NAS_PDU._val = 38
    
    #-----< id-NASSecurityParametersFromNGRAN >-----#
    id_NASSecurityParametersFromNGRAN = INT(name='id-NASSecurityParametersFromNGRAN', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NASSecurityParametersFromNGRAN._val = 39
    
    #-----< id-NewAMF-UE-NGAP-ID >-----#
    id_NewAMF_UE_NGAP_ID = INT(name='id-NewAMF-UE-NGAP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NewAMF_UE_NGAP_ID._val = 40
    
    #-----< id-NewSecurityContextInd >-----#
    id_NewSecurityContextInd = INT(name='id-NewSecurityContextInd', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NewSecurityContextInd._val = 41
    
    #-----< id-NGAP-Message >-----#
    id_NGAP_Message = INT(name='id-NGAP-Message', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NGAP_Message._val = 42
    
    #-----< id-NGRAN-CGI >-----#
    id_NGRAN_CGI = INT(name='id-NGRAN-CGI', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NGRAN_CGI._val = 43
    
    #-----< id-NGRANTraceID >-----#
    id_NGRANTraceID = INT(name='id-NGRANTraceID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NGRANTraceID._val = 44
    
    #-----< id-NR-CGI >-----#
    id_NR_CGI = INT(name='id-NR-CGI', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NR_CGI._val = 45
    
    #-----< id-NRPPa-PDU >-----#
    id_NRPPa_PDU = INT(name='id-NRPPa-PDU', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRPPa_PDU._val = 46
    
    #-----< id-NumberOfBroadcastsRequested >-----#
    id_NumberOfBroadcastsRequested = INT(name='id-NumberOfBroadcastsRequested', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NumberOfBroadcastsRequested._val = 47
    
    #-----< id-OldAMF >-----#
    id_OldAMF = INT(name='id-OldAMF', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_OldAMF._val = 48
    
    #-----< id-OverloadStartNSSAIList >-----#
    id_OverloadStartNSSAIList = INT(name='id-OverloadStartNSSAIList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_OverloadStartNSSAIList._val = 49
    
    #-----< id-PagingDRX >-----#
    id_PagingDRX = INT(name='id-PagingDRX', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingDRX._val = 50
    
    #-----< id-PagingOrigin >-----#
    id_PagingOrigin = INT(name='id-PagingOrigin', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingOrigin._val = 51
    
    #-----< id-PagingPriority >-----#
    id_PagingPriority = INT(name='id-PagingPriority', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingPriority._val = 52
    
    #-----< id-PDUSessionResourceAdmittedList >-----#
    id_PDUSessionResourceAdmittedList = INT(name='id-PDUSessionResourceAdmittedList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceAdmittedList._val = 53
    
    #-----< id-PDUSessionResourceFailedToModifyListModRes >-----#
    id_PDUSessionResourceFailedToModifyListModRes = INT(name='id-PDUSessionResourceFailedToModifyListModRes', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceFailedToModifyListModRes._val = 54
    
    #-----< id-PDUSessionResourceFailedToSetupListCxtRes >-----#
    id_PDUSessionResourceFailedToSetupListCxtRes = INT(name='id-PDUSessionResourceFailedToSetupListCxtRes', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceFailedToSetupListCxtRes._val = 55
    
    #-----< id-PDUSessionResourceFailedToSetupListHOAck >-----#
    id_PDUSessionResourceFailedToSetupListHOAck = INT(name='id-PDUSessionResourceFailedToSetupListHOAck', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceFailedToSetupListHOAck._val = 56
    
    #-----< id-PDUSessionResourceFailedToSetupListPSReq >-----#
    id_PDUSessionResourceFailedToSetupListPSReq = INT(name='id-PDUSessionResourceFailedToSetupListPSReq', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceFailedToSetupListPSReq._val = 57
    
    #-----< id-PDUSessionResourceFailedToSetupListSURes >-----#
    id_PDUSessionResourceFailedToSetupListSURes = INT(name='id-PDUSessionResourceFailedToSetupListSURes', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceFailedToSetupListSURes._val = 58
    
    #-----< id-PDUSessionResourceHandoverList >-----#
    id_PDUSessionResourceHandoverList = INT(name='id-PDUSessionResourceHandoverList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceHandoverList._val = 59
    
    #-----< id-PDUSessionResourceListCxtRelCpl >-----#
    id_PDUSessionResourceListCxtRelCpl = INT(name='id-PDUSessionResourceListCxtRelCpl', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceListCxtRelCpl._val = 60
    
    #-----< id-PDUSessionResourceListHORqd >-----#
    id_PDUSessionResourceListHORqd = INT(name='id-PDUSessionResourceListHORqd', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceListHORqd._val = 61
    
    #-----< id-PDUSessionResourceModifyListModCfm >-----#
    id_PDUSessionResourceModifyListModCfm = INT(name='id-PDUSessionResourceModifyListModCfm', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceModifyListModCfm._val = 62
    
    #-----< id-PDUSessionResourceModifyListModInd >-----#
    id_PDUSessionResourceModifyListModInd = INT(name='id-PDUSessionResourceModifyListModInd', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceModifyListModInd._val = 63
    
    #-----< id-PDUSessionResourceModifyListModReq >-----#
    id_PDUSessionResourceModifyListModReq = INT(name='id-PDUSessionResourceModifyListModReq', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceModifyListModReq._val = 64
    
    #-----< id-PDUSessionResourceModifyListModRes >-----#
    id_PDUSessionResourceModifyListModRes = INT(name='id-PDUSessionResourceModifyListModRes', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceModifyListModRes._val = 65
    
    #-----< id-PDUSessionResourceNotifyList >-----#
    id_PDUSessionResourceNotifyList = INT(name='id-PDUSessionResourceNotifyList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceNotifyList._val = 66
    
    #-----< id-PDUSessionResourceReleasedListNot >-----#
    id_PDUSessionResourceReleasedListNot = INT(name='id-PDUSessionResourceReleasedListNot', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceReleasedListNot._val = 67
    
    #-----< id-PDUSessionResourceReleasedListPSAck >-----#
    id_PDUSessionResourceReleasedListPSAck = INT(name='id-PDUSessionResourceReleasedListPSAck', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceReleasedListPSAck._val = 68
    
    #-----< id-PDUSessionResourceReleasedListPSFail >-----#
    id_PDUSessionResourceReleasedListPSFail = INT(name='id-PDUSessionResourceReleasedListPSFail', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceReleasedListPSFail._val = 69
    
    #-----< id-PDUSessionResourceReleasedListRelRes >-----#
    id_PDUSessionResourceReleasedListRelRes = INT(name='id-PDUSessionResourceReleasedListRelRes', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceReleasedListRelRes._val = 70
    
    #-----< id-PDUSessionResourceSetupListCxtReq >-----#
    id_PDUSessionResourceSetupListCxtReq = INT(name='id-PDUSessionResourceSetupListCxtReq', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceSetupListCxtReq._val = 71
    
    #-----< id-PDUSessionResourceSetupListCxtRes >-----#
    id_PDUSessionResourceSetupListCxtRes = INT(name='id-PDUSessionResourceSetupListCxtRes', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceSetupListCxtRes._val = 72
    
    #-----< id-PDUSessionResourceSetupListHOReq >-----#
    id_PDUSessionResourceSetupListHOReq = INT(name='id-PDUSessionResourceSetupListHOReq', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceSetupListHOReq._val = 73
    
    #-----< id-PDUSessionResourceSetupListSUReq >-----#
    id_PDUSessionResourceSetupListSUReq = INT(name='id-PDUSessionResourceSetupListSUReq', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceSetupListSUReq._val = 74
    
    #-----< id-PDUSessionResourceSetupListSURes >-----#
    id_PDUSessionResourceSetupListSURes = INT(name='id-PDUSessionResourceSetupListSURes', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceSetupListSURes._val = 75
    
    #-----< id-PDUSessionResourceToBeSwitchedDLList >-----#
    id_PDUSessionResourceToBeSwitchedDLList = INT(name='id-PDUSessionResourceToBeSwitchedDLList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceToBeSwitchedDLList._val = 76
    
    #-----< id-PDUSessionResourceSwitchedList >-----#
    id_PDUSessionResourceSwitchedList = INT(name='id-PDUSessionResourceSwitchedList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceSwitchedList._val = 77
    
    #-----< id-PDUSessionResourceToReleaseListHOCmd >-----#
    id_PDUSessionResourceToReleaseListHOCmd = INT(name='id-PDUSessionResourceToReleaseListHOCmd', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceToReleaseListHOCmd._val = 78
    
    #-----< id-PDUSessionResourceToReleaseListRelCmd >-----#
    id_PDUSessionResourceToReleaseListRelCmd = INT(name='id-PDUSessionResourceToReleaseListRelCmd', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceToReleaseListRelCmd._val = 79
    
    #-----< id-PLMNSupportList >-----#
    id_PLMNSupportList = INT(name='id-PLMNSupportList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PLMNSupportList._val = 80
    
    #-----< id-PWSFailedCellIDList >-----#
    id_PWSFailedCellIDList = INT(name='id-PWSFailedCellIDList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PWSFailedCellIDList._val = 81
    
    #-----< id-RANNodeName >-----#
    id_RANNodeName = INT(name='id-RANNodeName', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RANNodeName._val = 82
    
    #-----< id-RANPagingPriority >-----#
    id_RANPagingPriority = INT(name='id-RANPagingPriority', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RANPagingPriority._val = 83
    
    #-----< id-RANStatusTransfer-TransparentContainer >-----#
    id_RANStatusTransfer_TransparentContainer = INT(name='id-RANStatusTransfer-TransparentContainer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RANStatusTransfer_TransparentContainer._val = 84
    
    #-----< id-RAN-UE-NGAP-ID >-----#
    id_RAN_UE_NGAP_ID = INT(name='id-RAN-UE-NGAP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RAN_UE_NGAP_ID._val = 85
    
    #-----< id-RelativeAMFCapacity >-----#
    id_RelativeAMFCapacity = INT(name='id-RelativeAMFCapacity', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RelativeAMFCapacity._val = 86
    
    #-----< id-RepetitionPeriod >-----#
    id_RepetitionPeriod = INT(name='id-RepetitionPeriod', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RepetitionPeriod._val = 87
    
    #-----< id-ResetType >-----#
    id_ResetType = INT(name='id-ResetType', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResetType._val = 88
    
    #-----< id-RoutingID >-----#
    id_RoutingID = INT(name='id-RoutingID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RoutingID._val = 89
    
    #-----< id-RRCEstablishmentCause >-----#
    id_RRCEstablishmentCause = INT(name='id-RRCEstablishmentCause', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRCEstablishmentCause._val = 90
    
    #-----< id-RRCInactiveTransitionReportRequest >-----#
    id_RRCInactiveTransitionReportRequest = INT(name='id-RRCInactiveTransitionReportRequest', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRCInactiveTransitionReportRequest._val = 91
    
    #-----< id-RRCState >-----#
    id_RRCState = INT(name='id-RRCState', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRCState._val = 92
    
    #-----< id-SecurityContext >-----#
    id_SecurityContext = INT(name='id-SecurityContext', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecurityContext._val = 93
    
    #-----< id-SecurityKey >-----#
    id_SecurityKey = INT(name='id-SecurityKey', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecurityKey._val = 94
    
    #-----< id-SerialNumber >-----#
    id_SerialNumber = INT(name='id-SerialNumber', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SerialNumber._val = 95
    
    #-----< id-ServedGUAMIList >-----#
    id_ServedGUAMIList = INT(name='id-ServedGUAMIList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServedGUAMIList._val = 96
    
    #-----< id-SliceSupportList >-----#
    id_SliceSupportList = INT(name='id-SliceSupportList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SliceSupportList._val = 97
    
    #-----< id-SONConfigurationTransferDL >-----#
    id_SONConfigurationTransferDL = INT(name='id-SONConfigurationTransferDL', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SONConfigurationTransferDL._val = 98
    
    #-----< id-SONConfigurationTransferUL >-----#
    id_SONConfigurationTransferUL = INT(name='id-SONConfigurationTransferUL', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SONConfigurationTransferUL._val = 99
    
    #-----< id-SourceAMF-UE-NGAP-ID >-----#
    id_SourceAMF_UE_NGAP_ID = INT(name='id-SourceAMF-UE-NGAP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceAMF_UE_NGAP_ID._val = 100
    
    #-----< id-SourceToTarget-TransparentContainer >-----#
    id_SourceToTarget_TransparentContainer = INT(name='id-SourceToTarget-TransparentContainer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceToTarget_TransparentContainer._val = 101
    
    #-----< id-SupportedTAList >-----#
    id_SupportedTAList = INT(name='id-SupportedTAList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SupportedTAList._val = 102
    
    #-----< id-TAIListForPaging >-----#
    id_TAIListForPaging = INT(name='id-TAIListForPaging', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TAIListForPaging._val = 103
    
    #-----< id-TAIListForRestart >-----#
    id_TAIListForRestart = INT(name='id-TAIListForRestart', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TAIListForRestart._val = 104
    
    #-----< id-TargetID >-----#
    id_TargetID = INT(name='id-TargetID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TargetID._val = 105
    
    #-----< id-TargetToSource-TransparentContainer >-----#
    id_TargetToSource_TransparentContainer = INT(name='id-TargetToSource-TransparentContainer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TargetToSource_TransparentContainer._val = 106
    
    #-----< id-TimeToWait >-----#
    id_TimeToWait = INT(name='id-TimeToWait', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeToWait._val = 107
    
    #-----< id-TraceActivation >-----#
    id_TraceActivation = INT(name='id-TraceActivation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceActivation._val = 108
    
    #-----< id-TraceCollectionEntityIPAddress >-----#
    id_TraceCollectionEntityIPAddress = INT(name='id-TraceCollectionEntityIPAddress', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceCollectionEntityIPAddress._val = 109
    
    #-----< id-UEAggregateMaximumBitRate >-----#
    id_UEAggregateMaximumBitRate = INT(name='id-UEAggregateMaximumBitRate', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEAggregateMaximumBitRate._val = 110
    
    #-----< id-UE-associatedLogicalNG-connectionList >-----#
    id_UE_associatedLogicalNG_connectionList = INT(name='id-UE-associatedLogicalNG-connectionList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_associatedLogicalNG_connectionList._val = 111
    
    #-----< id-UEContextRequest >-----#
    id_UEContextRequest = INT(name='id-UEContextRequest', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEContextRequest._val = 112
    
    #-----< id-UE-NGAP-IDs >-----#
    id_UE_NGAP_IDs = INT(name='id-UE-NGAP-IDs', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_NGAP_IDs._val = 114
    
    #-----< id-UEPagingIdentity >-----#
    id_UEPagingIdentity = INT(name='id-UEPagingIdentity', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEPagingIdentity._val = 115
    
    #-----< id-UEPresenceInAreaOfInterestList >-----#
    id_UEPresenceInAreaOfInterestList = INT(name='id-UEPresenceInAreaOfInterestList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEPresenceInAreaOfInterestList._val = 116
    
    #-----< id-UERadioCapability >-----#
    id_UERadioCapability = INT(name='id-UERadioCapability', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UERadioCapability._val = 117
    
    #-----< id-UERadioCapabilityForPaging >-----#
    id_UERadioCapabilityForPaging = INT(name='id-UERadioCapabilityForPaging', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UERadioCapabilityForPaging._val = 118
    
    #-----< id-UESecurityCapabilities >-----#
    id_UESecurityCapabilities = INT(name='id-UESecurityCapabilities', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UESecurityCapabilities._val = 119
    
    #-----< id-UnavailableGUAMIList >-----#
    id_UnavailableGUAMIList = INT(name='id-UnavailableGUAMIList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UnavailableGUAMIList._val = 120
    
    #-----< id-UserLocationInformation >-----#
    id_UserLocationInformation = INT(name='id-UserLocationInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UserLocationInformation._val = 121
    
    #-----< id-WarningAreaList >-----#
    id_WarningAreaList = INT(name='id-WarningAreaList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WarningAreaList._val = 122
    
    #-----< id-WarningMessageContents >-----#
    id_WarningMessageContents = INT(name='id-WarningMessageContents', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WarningMessageContents._val = 123
    
    #-----< id-WarningSecurityInfo >-----#
    id_WarningSecurityInfo = INT(name='id-WarningSecurityInfo', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WarningSecurityInfo._val = 124
    
    #-----< id-WarningType >-----#
    id_WarningType = INT(name='id-WarningType', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WarningType._val = 125
    
    #-----< id-AdditionalUL-NGU-UP-TNLInformation >-----#
    id_AdditionalUL_NGU_UP_TNLInformation = INT(name='id-AdditionalUL-NGU-UP-TNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalUL_NGU_UP_TNLInformation._val = 126
    
    #-----< id-DataForwardingNotPossible >-----#
    id_DataForwardingNotPossible = INT(name='id-DataForwardingNotPossible', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DataForwardingNotPossible._val = 127
    
    #-----< id-DL-NGU-UP-TNLInformation >-----#
    id_DL_NGU_UP_TNLInformation = INT(name='id-DL-NGU-UP-TNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_NGU_UP_TNLInformation._val = 128
    
    #-----< id-NetworkInstance >-----#
    id_NetworkInstance = INT(name='id-NetworkInstance', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NetworkInstance._val = 129
    
    #-----< id-PDUSessionAggregateMaximumBitRate >-----#
    id_PDUSessionAggregateMaximumBitRate = INT(name='id-PDUSessionAggregateMaximumBitRate', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionAggregateMaximumBitRate._val = 130
    
    #-----< id-PDUSessionResourceFailedToModifyListModCfm >-----#
    id_PDUSessionResourceFailedToModifyListModCfm = INT(name='id-PDUSessionResourceFailedToModifyListModCfm', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceFailedToModifyListModCfm._val = 131
    
    #-----< id-PDUSessionResourceFailedToSetupListCxtFail >-----#
    id_PDUSessionResourceFailedToSetupListCxtFail = INT(name='id-PDUSessionResourceFailedToSetupListCxtFail', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceFailedToSetupListCxtFail._val = 132
    
    #-----< id-PDUSessionResourceListCxtRelReq >-----#
    id_PDUSessionResourceListCxtRelReq = INT(name='id-PDUSessionResourceListCxtRelReq', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceListCxtRelReq._val = 133
    
    #-----< id-PDUSessionType >-----#
    id_PDUSessionType = INT(name='id-PDUSessionType', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionType._val = 134
    
    #-----< id-QosFlowAddOrModifyRequestList >-----#
    id_QosFlowAddOrModifyRequestList = INT(name='id-QosFlowAddOrModifyRequestList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QosFlowAddOrModifyRequestList._val = 135
    
    #-----< id-QosFlowSetupRequestList >-----#
    id_QosFlowSetupRequestList = INT(name='id-QosFlowSetupRequestList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QosFlowSetupRequestList._val = 136
    
    #-----< id-QosFlowToReleaseList >-----#
    id_QosFlowToReleaseList = INT(name='id-QosFlowToReleaseList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QosFlowToReleaseList._val = 137
    
    #-----< id-SecurityIndication >-----#
    id_SecurityIndication = INT(name='id-SecurityIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecurityIndication._val = 138
    
    #-----< id-UL-NGU-UP-TNLInformation >-----#
    id_UL_NGU_UP_TNLInformation = INT(name='id-UL-NGU-UP-TNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_NGU_UP_TNLInformation._val = 139
    
    #-----< id-UL-NGU-UP-TNLModifyList >-----#
    id_UL_NGU_UP_TNLModifyList = INT(name='id-UL-NGU-UP-TNLModifyList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_NGU_UP_TNLModifyList._val = 140
    
    #-----< id-WarningAreaCoordinates >-----#
    id_WarningAreaCoordinates = INT(name='id-WarningAreaCoordinates', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WarningAreaCoordinates._val = 141
    
    #-----< id-PDUSessionResourceSecondaryRATUsageList >-----#
    id_PDUSessionResourceSecondaryRATUsageList = INT(name='id-PDUSessionResourceSecondaryRATUsageList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceSecondaryRATUsageList._val = 142
    
    #-----< id-HandoverFlag >-----#
    id_HandoverFlag = INT(name='id-HandoverFlag', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HandoverFlag._val = 143
    
    #-----< id-SecondaryRATUsageInformation >-----#
    id_SecondaryRATUsageInformation = INT(name='id-SecondaryRATUsageInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecondaryRATUsageInformation._val = 144
    
    #-----< id-PDUSessionResourceReleaseResponseTransfer >-----#
    id_PDUSessionResourceReleaseResponseTransfer = INT(name='id-PDUSessionResourceReleaseResponseTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceReleaseResponseTransfer._val = 145
    
    #-----< id-RedirectionVoiceFallback >-----#
    id_RedirectionVoiceFallback = INT(name='id-RedirectionVoiceFallback', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RedirectionVoiceFallback._val = 146
    
    #-----< id-UERetentionInformation >-----#
    id_UERetentionInformation = INT(name='id-UERetentionInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UERetentionInformation._val = 147
    
    #-----< id-S-NSSAI >-----#
    id_S_NSSAI = INT(name='id-S-NSSAI', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_S_NSSAI._val = 148
    
    #-----< id-PSCellInformation >-----#
    id_PSCellInformation = INT(name='id-PSCellInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PSCellInformation._val = 149
    
    #-----< id-LastEUTRAN-PLMNIdentity >-----#
    id_LastEUTRAN_PLMNIdentity = INT(name='id-LastEUTRAN-PLMNIdentity', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LastEUTRAN_PLMNIdentity._val = 150
    
    #-----< id-MaximumIntegrityProtectedDataRate-DL >-----#
    id_MaximumIntegrityProtectedDataRate_DL = INT(name='id-MaximumIntegrityProtectedDataRate-DL', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MaximumIntegrityProtectedDataRate_DL._val = 151
    
    #-----< id-AdditionalDLForwardingUPTNLInformation >-----#
    id_AdditionalDLForwardingUPTNLInformation = INT(name='id-AdditionalDLForwardingUPTNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalDLForwardingUPTNLInformation._val = 152
    
    #-----< id-AdditionalDLUPTNLInformationForHOList >-----#
    id_AdditionalDLUPTNLInformationForHOList = INT(name='id-AdditionalDLUPTNLInformationForHOList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalDLUPTNLInformationForHOList._val = 153
    
    #-----< id-AdditionalNGU-UP-TNLInformation >-----#
    id_AdditionalNGU_UP_TNLInformation = INT(name='id-AdditionalNGU-UP-TNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalNGU_UP_TNLInformation._val = 154
    
    #-----< id-AdditionalDLQosFlowPerTNLInformation >-----#
    id_AdditionalDLQosFlowPerTNLInformation = INT(name='id-AdditionalDLQosFlowPerTNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalDLQosFlowPerTNLInformation._val = 155
    
    #-----< id-SecurityResult >-----#
    id_SecurityResult = INT(name='id-SecurityResult', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecurityResult._val = 156
    
    #-----< id-ENDC-SONConfigurationTransferDL >-----#
    id_ENDC_SONConfigurationTransferDL = INT(name='id-ENDC-SONConfigurationTransferDL', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ENDC_SONConfigurationTransferDL._val = 157
    
    #-----< id-ENDC-SONConfigurationTransferUL >-----#
    id_ENDC_SONConfigurationTransferUL = INT(name='id-ENDC-SONConfigurationTransferUL', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ENDC_SONConfigurationTransferUL._val = 158
    
    #-----< id-OldAssociatedQosFlowList-ULendmarkerexpected >-----#
    id_OldAssociatedQosFlowList_ULendmarkerexpected = INT(name='id-OldAssociatedQosFlowList-ULendmarkerexpected', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_OldAssociatedQosFlowList_ULendmarkerexpected._val = 159
    
    #-----< id-CNTypeRestrictionsForEquivalent >-----#
    id_CNTypeRestrictionsForEquivalent = INT(name='id-CNTypeRestrictionsForEquivalent', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CNTypeRestrictionsForEquivalent._val = 160
    
    #-----< id-CNTypeRestrictionsForServing >-----#
    id_CNTypeRestrictionsForServing = INT(name='id-CNTypeRestrictionsForServing', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CNTypeRestrictionsForServing._val = 161
    
    #-----< id-NewGUAMI >-----#
    id_NewGUAMI = INT(name='id-NewGUAMI', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NewGUAMI._val = 162
    
    #-----< id-ULForwarding >-----#
    id_ULForwarding = INT(name='id-ULForwarding', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ULForwarding._val = 163
    
    #-----< id-ULForwardingUP-TNLInformation >-----#
    id_ULForwardingUP_TNLInformation = INT(name='id-ULForwardingUP-TNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ULForwardingUP_TNLInformation._val = 164
    
    #-----< id-CNAssistedRANTuning >-----#
    id_CNAssistedRANTuning = INT(name='id-CNAssistedRANTuning', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CNAssistedRANTuning._val = 165
    
    #-----< id-CommonNetworkInstance >-----#
    id_CommonNetworkInstance = INT(name='id-CommonNetworkInstance', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CommonNetworkInstance._val = 166
    
    #-----< id-NGRAN-TNLAssociationToRemoveList >-----#
    id_NGRAN_TNLAssociationToRemoveList = INT(name='id-NGRAN-TNLAssociationToRemoveList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NGRAN_TNLAssociationToRemoveList._val = 167
    
    #-----< id-TNLAssociationTransportLayerAddressNGRAN >-----#
    id_TNLAssociationTransportLayerAddressNGRAN = INT(name='id-TNLAssociationTransportLayerAddressNGRAN', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TNLAssociationTransportLayerAddressNGRAN._val = 168
    
    #-----< id-EndpointIPAddressAndPort >-----#
    id_EndpointIPAddressAndPort = INT(name='id-EndpointIPAddressAndPort', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EndpointIPAddressAndPort._val = 169
    
    #-----< id-LocationReportingAdditionalInfo >-----#
    id_LocationReportingAdditionalInfo = INT(name='id-LocationReportingAdditionalInfo', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LocationReportingAdditionalInfo._val = 170
    
    #-----< id-SourceToTarget-AMFInformationReroute >-----#
    id_SourceToTarget_AMFInformationReroute = INT(name='id-SourceToTarget-AMFInformationReroute', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceToTarget_AMFInformationReroute._val = 171
    
    #-----< id-AdditionalULForwardingUPTNLInformation >-----#
    id_AdditionalULForwardingUPTNLInformation = INT(name='id-AdditionalULForwardingUPTNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalULForwardingUPTNLInformation._val = 172
    
    #-----< id-SCTP-TLAs >-----#
    id_SCTP_TLAs = INT(name='id-SCTP-TLAs', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SCTP_TLAs._val = 173
    
    #-----< id-SelectedPLMNIdentity >-----#
    id_SelectedPLMNIdentity = INT(name='id-SelectedPLMNIdentity', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SelectedPLMNIdentity._val = 174
    
    #-----< id-RIMInformationTransfer >-----#
    id_RIMInformationTransfer = INT(name='id-RIMInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RIMInformationTransfer._val = 175
    
    #-----< id-GUAMIType >-----#
    id_GUAMIType = INT(name='id-GUAMIType', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GUAMIType._val = 176
    
    #-----< id-SRVCCOperationPossible >-----#
    id_SRVCCOperationPossible = INT(name='id-SRVCCOperationPossible', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRVCCOperationPossible._val = 177
    
    #-----< id-TargetRNC-ID >-----#
    id_TargetRNC_ID = INT(name='id-TargetRNC-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TargetRNC_ID._val = 178
    
    #-----< id-RAT-Information >-----#
    id_RAT_Information = INT(name='id-RAT-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RAT_Information._val = 179
    
    #-----< id-ExtendedRATRestrictionInformation >-----#
    id_ExtendedRATRestrictionInformation = INT(name='id-ExtendedRATRestrictionInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedRATRestrictionInformation._val = 180
    
    #-----< id-QosMonitoringRequest >-----#
    id_QosMonitoringRequest = INT(name='id-QosMonitoringRequest', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QosMonitoringRequest._val = 181
    
    #-----< id-SgNB-UE-X2AP-ID >-----#
    id_SgNB_UE_X2AP_ID = INT(name='id-SgNB-UE-X2AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SgNB_UE_X2AP_ID._val = 182
    
    #-----< id-AdditionalRedundantDL-NGU-UP-TNLInformation >-----#
    id_AdditionalRedundantDL_NGU_UP_TNLInformation = INT(name='id-AdditionalRedundantDL-NGU-UP-TNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalRedundantDL_NGU_UP_TNLInformation._val = 183
    
    #-----< id-AdditionalRedundantDLQosFlowPerTNLInformation >-----#
    id_AdditionalRedundantDLQosFlowPerTNLInformation = INT(name='id-AdditionalRedundantDLQosFlowPerTNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalRedundantDLQosFlowPerTNLInformation._val = 184
    
    #-----< id-AdditionalRedundantNGU-UP-TNLInformation >-----#
    id_AdditionalRedundantNGU_UP_TNLInformation = INT(name='id-AdditionalRedundantNGU-UP-TNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalRedundantNGU_UP_TNLInformation._val = 185
    
    #-----< id-AdditionalRedundantUL-NGU-UP-TNLInformation >-----#
    id_AdditionalRedundantUL_NGU_UP_TNLInformation = INT(name='id-AdditionalRedundantUL-NGU-UP-TNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalRedundantUL_NGU_UP_TNLInformation._val = 186
    
    #-----< id-CNPacketDelayBudgetDL >-----#
    id_CNPacketDelayBudgetDL = INT(name='id-CNPacketDelayBudgetDL', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CNPacketDelayBudgetDL._val = 187
    
    #-----< id-CNPacketDelayBudgetUL >-----#
    id_CNPacketDelayBudgetUL = INT(name='id-CNPacketDelayBudgetUL', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CNPacketDelayBudgetUL._val = 188
    
    #-----< id-ExtendedPacketDelayBudget >-----#
    id_ExtendedPacketDelayBudget = INT(name='id-ExtendedPacketDelayBudget', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedPacketDelayBudget._val = 189
    
    #-----< id-RedundantCommonNetworkInstance >-----#
    id_RedundantCommonNetworkInstance = INT(name='id-RedundantCommonNetworkInstance', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RedundantCommonNetworkInstance._val = 190
    
    #-----< id-RedundantDL-NGU-TNLInformationReused >-----#
    id_RedundantDL_NGU_TNLInformationReused = INT(name='id-RedundantDL-NGU-TNLInformationReused', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RedundantDL_NGU_TNLInformationReused._val = 191
    
    #-----< id-RedundantDL-NGU-UP-TNLInformation >-----#
    id_RedundantDL_NGU_UP_TNLInformation = INT(name='id-RedundantDL-NGU-UP-TNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RedundantDL_NGU_UP_TNLInformation._val = 192
    
    #-----< id-RedundantDLQosFlowPerTNLInformation >-----#
    id_RedundantDLQosFlowPerTNLInformation = INT(name='id-RedundantDLQosFlowPerTNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RedundantDLQosFlowPerTNLInformation._val = 193
    
    #-----< id-RedundantQosFlowIndicator >-----#
    id_RedundantQosFlowIndicator = INT(name='id-RedundantQosFlowIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RedundantQosFlowIndicator._val = 194
    
    #-----< id-RedundantUL-NGU-UP-TNLInformation >-----#
    id_RedundantUL_NGU_UP_TNLInformation = INT(name='id-RedundantUL-NGU-UP-TNLInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RedundantUL_NGU_UP_TNLInformation._val = 195
    
    #-----< id-TSCTrafficCharacteristics >-----#
    id_TSCTrafficCharacteristics = INT(name='id-TSCTrafficCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TSCTrafficCharacteristics._val = 196
    
    #-----< id-RedundantPDUSessionInformation >-----#
    id_RedundantPDUSessionInformation = INT(name='id-RedundantPDUSessionInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RedundantPDUSessionInformation._val = 197
    
    #-----< id-UsedRSNInformation >-----#
    id_UsedRSNInformation = INT(name='id-UsedRSNInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UsedRSNInformation._val = 198
    
    #-----< id-IAB-Authorized >-----#
    id_IAB_Authorized = INT(name='id-IAB-Authorized', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IAB_Authorized._val = 199
    
    #-----< id-IAB-Supported >-----#
    id_IAB_Supported = INT(name='id-IAB-Supported', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IAB_Supported._val = 200
    
    #-----< id-IABNodeIndication >-----#
    id_IABNodeIndication = INT(name='id-IABNodeIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IABNodeIndication._val = 201
    
    #-----< id-NB-IoT-PagingDRX >-----#
    id_NB_IoT_PagingDRX = INT(name='id-NB-IoT-PagingDRX', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NB_IoT_PagingDRX._val = 202
    
    #-----< id-NB-IoT-Paging-eDRXInfo >-----#
    id_NB_IoT_Paging_eDRXInfo = INT(name='id-NB-IoT-Paging-eDRXInfo', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NB_IoT_Paging_eDRXInfo._val = 203
    
    #-----< id-NB-IoT-DefaultPagingDRX >-----#
    id_NB_IoT_DefaultPagingDRX = INT(name='id-NB-IoT-DefaultPagingDRX', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NB_IoT_DefaultPagingDRX._val = 204
    
    #-----< id-Enhanced-CoverageRestriction >-----#
    id_Enhanced_CoverageRestriction = INT(name='id-Enhanced-CoverageRestriction', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Enhanced_CoverageRestriction._val = 205
    
    #-----< id-Extended-ConnectedTime >-----#
    id_Extended_ConnectedTime = INT(name='id-Extended-ConnectedTime', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extended_ConnectedTime._val = 206
    
    #-----< id-PagingAssisDataforCEcapabUE >-----#
    id_PagingAssisDataforCEcapabUE = INT(name='id-PagingAssisDataforCEcapabUE', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingAssisDataforCEcapabUE._val = 207
    
    #-----< id-WUS-Assistance-Information >-----#
    id_WUS_Assistance_Information = INT(name='id-WUS-Assistance-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WUS_Assistance_Information._val = 208
    
    #-----< id-UE-DifferentiationInfo >-----#
    id_UE_DifferentiationInfo = INT(name='id-UE-DifferentiationInfo', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_DifferentiationInfo._val = 209
    
    #-----< id-NB-IoT-UEPriority >-----#
    id_NB_IoT_UEPriority = INT(name='id-NB-IoT-UEPriority', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NB_IoT_UEPriority._val = 210
    
    #-----< id-UL-CP-SecurityInformation >-----#
    id_UL_CP_SecurityInformation = INT(name='id-UL-CP-SecurityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CP_SecurityInformation._val = 211
    
    #-----< id-DL-CP-SecurityInformation >-----#
    id_DL_CP_SecurityInformation = INT(name='id-DL-CP-SecurityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CP_SecurityInformation._val = 212
    
    #-----< id-TAI >-----#
    id_TAI = INT(name='id-TAI', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TAI._val = 213
    
    #-----< id-UERadioCapabilityForPagingOfNB-IoT >-----#
    id_UERadioCapabilityForPagingOfNB_IoT = INT(name='id-UERadioCapabilityForPagingOfNB-IoT', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UERadioCapabilityForPagingOfNB_IoT._val = 214
    
    #-----< id-LTEV2XServicesAuthorized >-----#
    id_LTEV2XServicesAuthorized = INT(name='id-LTEV2XServicesAuthorized', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LTEV2XServicesAuthorized._val = 215
    
    #-----< id-NRV2XServicesAuthorized >-----#
    id_NRV2XServicesAuthorized = INT(name='id-NRV2XServicesAuthorized', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRV2XServicesAuthorized._val = 216
    
    #-----< id-LTEUESidelinkAggregateMaximumBitrate >-----#
    id_LTEUESidelinkAggregateMaximumBitrate = INT(name='id-LTEUESidelinkAggregateMaximumBitrate', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LTEUESidelinkAggregateMaximumBitrate._val = 217
    
    #-----< id-NRUESidelinkAggregateMaximumBitrate >-----#
    id_NRUESidelinkAggregateMaximumBitrate = INT(name='id-NRUESidelinkAggregateMaximumBitrate', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRUESidelinkAggregateMaximumBitrate._val = 218
    
    #-----< id-PC5QoSParameters >-----#
    id_PC5QoSParameters = INT(name='id-PC5QoSParameters', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PC5QoSParameters._val = 219
    
    #-----< id-AlternativeQoSParaSetList >-----#
    id_AlternativeQoSParaSetList = INT(name='id-AlternativeQoSParaSetList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AlternativeQoSParaSetList._val = 220
    
    #-----< id-CurrentQoSParaSetIndex >-----#
    id_CurrentQoSParaSetIndex = INT(name='id-CurrentQoSParaSetIndex', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CurrentQoSParaSetIndex._val = 221
    
    #-----< id-CEmodeBrestricted >-----#
    id_CEmodeBrestricted = INT(name='id-CEmodeBrestricted', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CEmodeBrestricted._val = 222
    
    #-----< id-EUTRA-PagingeDRXInformation >-----#
    id_EUTRA_PagingeDRXInformation = INT(name='id-EUTRA-PagingeDRXInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EUTRA_PagingeDRXInformation._val = 223
    
    #-----< id-CEmodeBSupport-Indicator >-----#
    id_CEmodeBSupport_Indicator = INT(name='id-CEmodeBSupport-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CEmodeBSupport_Indicator._val = 224
    
    #-----< id-LTEM-Indication >-----#
    id_LTEM_Indication = INT(name='id-LTEM-Indication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LTEM_Indication._val = 225
    
    #-----< id-EndIndication >-----#
    id_EndIndication = INT(name='id-EndIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EndIndication._val = 226
    
    #-----< id-EDT-Session >-----#
    id_EDT_Session = INT(name='id-EDT-Session', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EDT_Session._val = 227
    
    #-----< id-UECapabilityInfoRequest >-----#
    id_UECapabilityInfoRequest = INT(name='id-UECapabilityInfoRequest', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UECapabilityInfoRequest._val = 228
    
    #-----< id-PDUSessionResourceFailedToResumeListRESReq >-----#
    id_PDUSessionResourceFailedToResumeListRESReq = INT(name='id-PDUSessionResourceFailedToResumeListRESReq', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceFailedToResumeListRESReq._val = 229
    
    #-----< id-PDUSessionResourceFailedToResumeListRESRes >-----#
    id_PDUSessionResourceFailedToResumeListRESRes = INT(name='id-PDUSessionResourceFailedToResumeListRESRes', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceFailedToResumeListRESRes._val = 230
    
    #-----< id-PDUSessionResourceSuspendListSUSReq >-----#
    id_PDUSessionResourceSuspendListSUSReq = INT(name='id-PDUSessionResourceSuspendListSUSReq', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceSuspendListSUSReq._val = 231
    
    #-----< id-PDUSessionResourceResumeListRESReq >-----#
    id_PDUSessionResourceResumeListRESReq = INT(name='id-PDUSessionResourceResumeListRESReq', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceResumeListRESReq._val = 232
    
    #-----< id-PDUSessionResourceResumeListRESRes >-----#
    id_PDUSessionResourceResumeListRESRes = INT(name='id-PDUSessionResourceResumeListRESRes', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionResourceResumeListRESRes._val = 233
    
    #-----< id-UE-UP-CIoT-Support >-----#
    id_UE_UP_CIoT_Support = INT(name='id-UE-UP-CIoT-Support', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_UP_CIoT_Support._val = 234
    
    #-----< id-Suspend-Request-Indication >-----#
    id_Suspend_Request_Indication = INT(name='id-Suspend-Request-Indication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Suspend_Request_Indication._val = 235
    
    #-----< id-Suspend-Response-Indication >-----#
    id_Suspend_Response_Indication = INT(name='id-Suspend-Response-Indication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Suspend_Response_Indication._val = 236
    
    #-----< id-RRC-Resume-Cause >-----#
    id_RRC_Resume_Cause = INT(name='id-RRC-Resume-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRC_Resume_Cause._val = 237
    
    #-----< id-RGLevelWirelineAccessCharacteristics >-----#
    id_RGLevelWirelineAccessCharacteristics = INT(name='id-RGLevelWirelineAccessCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RGLevelWirelineAccessCharacteristics._val = 238
    
    #-----< id-W-AGFIdentityInformation >-----#
    id_W_AGFIdentityInformation = INT(name='id-W-AGFIdentityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_W_AGFIdentityInformation._val = 239
    
    #-----< id-GlobalTNGF-ID >-----#
    id_GlobalTNGF_ID = INT(name='id-GlobalTNGF-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GlobalTNGF_ID._val = 240
    
    #-----< id-GlobalTWIF-ID >-----#
    id_GlobalTWIF_ID = INT(name='id-GlobalTWIF-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GlobalTWIF_ID._val = 241
    
    #-----< id-GlobalW-AGF-ID >-----#
    id_GlobalW_AGF_ID = INT(name='id-GlobalW-AGF-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GlobalW_AGF_ID._val = 242
    
    #-----< id-UserLocationInformationW-AGF >-----#
    id_UserLocationInformationW_AGF = INT(name='id-UserLocationInformationW-AGF', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UserLocationInformationW_AGF._val = 243
    
    #-----< id-UserLocationInformationTNGF >-----#
    id_UserLocationInformationTNGF = INT(name='id-UserLocationInformationTNGF', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UserLocationInformationTNGF._val = 244
    
    #-----< id-AuthenticatedIndication >-----#
    id_AuthenticatedIndication = INT(name='id-AuthenticatedIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AuthenticatedIndication._val = 245
    
    #-----< id-TNGFIdentityInformation >-----#
    id_TNGFIdentityInformation = INT(name='id-TNGFIdentityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TNGFIdentityInformation._val = 246
    
    #-----< id-TWIFIdentityInformation >-----#
    id_TWIFIdentityInformation = INT(name='id-TWIFIdentityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TWIFIdentityInformation._val = 247
    
    #-----< id-UserLocationInformationTWIF >-----#
    id_UserLocationInformationTWIF = INT(name='id-UserLocationInformationTWIF', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UserLocationInformationTWIF._val = 248
    
    #-----< id-DataForwardingResponseERABList >-----#
    id_DataForwardingResponseERABList = INT(name='id-DataForwardingResponseERABList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DataForwardingResponseERABList._val = 249
    
    #-----< id-IntersystemSONConfigurationTransferDL >-----#
    id_IntersystemSONConfigurationTransferDL = INT(name='id-IntersystemSONConfigurationTransferDL', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IntersystemSONConfigurationTransferDL._val = 250
    
    #-----< id-IntersystemSONConfigurationTransferUL >-----#
    id_IntersystemSONConfigurationTransferUL = INT(name='id-IntersystemSONConfigurationTransferUL', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IntersystemSONConfigurationTransferUL._val = 251
    
    #-----< id-SONInformationReport >-----#
    id_SONInformationReport = INT(name='id-SONInformationReport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SONInformationReport._val = 252
    
    #-----< id-UEHistoryInformationFromTheUE >-----#
    id_UEHistoryInformationFromTheUE = INT(name='id-UEHistoryInformationFromTheUE', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEHistoryInformationFromTheUE._val = 253
    
    #-----< id-ManagementBasedMDTPLMNList >-----#
    id_ManagementBasedMDTPLMNList = INT(name='id-ManagementBasedMDTPLMNList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ManagementBasedMDTPLMNList._val = 254
    
    #-----< id-MDTConfiguration >-----#
    id_MDTConfiguration = INT(name='id-MDTConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MDTConfiguration._val = 255
    
    #-----< id-PrivacyIndicator >-----#
    id_PrivacyIndicator = INT(name='id-PrivacyIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PrivacyIndicator._val = 256
    
    #-----< id-TraceCollectionEntityURI >-----#
    id_TraceCollectionEntityURI = INT(name='id-TraceCollectionEntityURI', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceCollectionEntityURI._val = 257
    
    #-----< id-NPN-Support >-----#
    id_NPN_Support = INT(name='id-NPN-Support', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NPN_Support._val = 258
    
    #-----< id-NPN-AccessInformation >-----#
    id_NPN_AccessInformation = INT(name='id-NPN-AccessInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NPN_AccessInformation._val = 259
    
    #-----< id-NPN-PagingAssistanceInformation >-----#
    id_NPN_PagingAssistanceInformation = INT(name='id-NPN-PagingAssistanceInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NPN_PagingAssistanceInformation._val = 260
    
    #-----< id-NPN-MobilityInformation >-----#
    id_NPN_MobilityInformation = INT(name='id-NPN-MobilityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NPN_MobilityInformation._val = 261
    
    #-----< id-TargettoSource-Failure-TransparentContainer >-----#
    id_TargettoSource_Failure_TransparentContainer = INT(name='id-TargettoSource-Failure-TransparentContainer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TargettoSource_Failure_TransparentContainer._val = 262
    
    #-----< id-NID >-----#
    id_NID = INT(name='id-NID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NID._val = 263
    
    #-----< id-UERadioCapabilityID >-----#
    id_UERadioCapabilityID = INT(name='id-UERadioCapabilityID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UERadioCapabilityID._val = 264
    
    #-----< id-UERadioCapability-EUTRA-Format >-----#
    id_UERadioCapability_EUTRA_Format = INT(name='id-UERadioCapability-EUTRA-Format', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UERadioCapability_EUTRA_Format._val = 265
    
    #-----< id-DAPSRequestInfo >-----#
    id_DAPSRequestInfo = INT(name='id-DAPSRequestInfo', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DAPSRequestInfo._val = 266
    
    #-----< id-DAPSResponseInfoList >-----#
    id_DAPSResponseInfoList = INT(name='id-DAPSResponseInfoList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DAPSResponseInfoList._val = 267
    
    #-----< id-EarlyStatusTransfer-TransparentContainer >-----#
    id_EarlyStatusTransfer_TransparentContainer = INT(name='id-EarlyStatusTransfer-TransparentContainer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EarlyStatusTransfer_TransparentContainer._val = 268
    
    #-----< id-NotifySourceNGRANNode >-----#
    id_NotifySourceNGRANNode = INT(name='id-NotifySourceNGRANNode', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NotifySourceNGRANNode._val = 269
    
    #-----< id-ExtendedSliceSupportList >-----#
    id_ExtendedSliceSupportList = INT(name='id-ExtendedSliceSupportList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedSliceSupportList._val = 270
    
    #-----< id-ExtendedTAISliceSupportList >-----#
    id_ExtendedTAISliceSupportList = INT(name='id-ExtendedTAISliceSupportList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedTAISliceSupportList._val = 271
    
    #-----< id-ConfiguredTACIndication >-----#
    id_ConfiguredTACIndication = INT(name='id-ConfiguredTACIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ConfiguredTACIndication._val = 272
    
    #-----< id-Extended-RANNodeName >-----#
    id_Extended_RANNodeName = INT(name='id-Extended-RANNodeName', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extended_RANNodeName._val = 273
    
    #-----< id-Extended-AMFName >-----#
    id_Extended_AMFName = INT(name='id-Extended-AMFName', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extended_AMFName._val = 274
    
    #-----< id-GlobalCable-ID >-----#
    id_GlobalCable_ID = INT(name='id-GlobalCable-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GlobalCable_ID._val = 275
    
    #-----< id-QosMonitoringReportingFrequency >-----#
    id_QosMonitoringReportingFrequency = INT(name='id-QosMonitoringReportingFrequency', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QosMonitoringReportingFrequency._val = 276
    
    #-----< id-QosFlowParametersList >-----#
    id_QosFlowParametersList = INT(name='id-QosFlowParametersList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QosFlowParametersList._val = 277
    
    #-----< id-QosFlowFeedbackList >-----#
    id_QosFlowFeedbackList = INT(name='id-QosFlowFeedbackList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QosFlowFeedbackList._val = 278
    
    #-----< id-BurstArrivalTimeDownlink >-----#
    id_BurstArrivalTimeDownlink = INT(name='id-BurstArrivalTimeDownlink', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BurstArrivalTimeDownlink._val = 279
    
    #-----< id-ExtendedUEIdentityIndexValue >-----#
    id_ExtendedUEIdentityIndexValue = INT(name='id-ExtendedUEIdentityIndexValue', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedUEIdentityIndexValue._val = 280
    
    #-----< id-PduSessionExpectedUEActivityBehaviour >-----#
    id_PduSessionExpectedUEActivityBehaviour = INT(name='id-PduSessionExpectedUEActivityBehaviour', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PduSessionExpectedUEActivityBehaviour._val = 281
    
    #-----< id-MicoAllPLMN >-----#
    id_MicoAllPLMN = INT(name='id-MicoAllPLMN', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MicoAllPLMN._val = 282
    
    #-----< id-QosFlowFailedToSetupList >-----#
    id_QosFlowFailedToSetupList = INT(name='id-QosFlowFailedToSetupList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QosFlowFailedToSetupList._val = 283
    
    #-----< id-SourceTNLAddrInfo >-----#
    id_SourceTNLAddrInfo = INT(name='id-SourceTNLAddrInfo', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceTNLAddrInfo._val = 284
    
    #-----< id-ExtendedReportIntervalMDT >-----#
    id_ExtendedReportIntervalMDT = INT(name='id-ExtendedReportIntervalMDT', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedReportIntervalMDT._val = 285
    
    #-----< id-SourceNodeID >-----#
    id_SourceNodeID = INT(name='id-SourceNodeID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceNodeID._val = 286
    
    #-----< id-NRNTNTAIInformation >-----#
    id_NRNTNTAIInformation = INT(name='id-NRNTNTAIInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRNTNTAIInformation._val = 287
    
    #-----< id-UEContextReferenceAtSource >-----#
    id_UEContextReferenceAtSource = INT(name='id-UEContextReferenceAtSource', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEContextReferenceAtSource._val = 288
    
    #-----< id-LastVisitedPSCellList >-----#
    id_LastVisitedPSCellList = INT(name='id-LastVisitedPSCellList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LastVisitedPSCellList._val = 289
    
    #-----< id-IntersystemSONInformationRequest >-----#
    id_IntersystemSONInformationRequest = INT(name='id-IntersystemSONInformationRequest', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IntersystemSONInformationRequest._val = 290
    
    #-----< id-IntersystemSONInformationReply >-----#
    id_IntersystemSONInformationReply = INT(name='id-IntersystemSONInformationReply', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IntersystemSONInformationReply._val = 291
    
    #-----< id-EnergySavingIndication >-----#
    id_EnergySavingIndication = INT(name='id-EnergySavingIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EnergySavingIndication._val = 292
    
    #-----< id-IntersystemResourceStatusUpdate >-----#
    id_IntersystemResourceStatusUpdate = INT(name='id-IntersystemResourceStatusUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IntersystemResourceStatusUpdate._val = 293
    
    #-----< id-SuccessfulHandoverReportList >-----#
    id_SuccessfulHandoverReportList = INT(name='id-SuccessfulHandoverReportList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SuccessfulHandoverReportList._val = 294
    
    #-----< id-MBS-AreaSessionID >-----#
    id_MBS_AreaSessionID = INT(name='id-MBS-AreaSessionID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBS_AreaSessionID._val = 295
    
    #-----< id-MBS-QoSFlowsToBeSetupList >-----#
    id_MBS_QoSFlowsToBeSetupList = INT(name='id-MBS-QoSFlowsToBeSetupList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBS_QoSFlowsToBeSetupList._val = 296
    
    #-----< id-MBS-QoSFlowsToBeSetupModList >-----#
    id_MBS_QoSFlowsToBeSetupModList = INT(name='id-MBS-QoSFlowsToBeSetupModList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBS_QoSFlowsToBeSetupModList._val = 297
    
    #-----< id-MBS-ServiceArea >-----#
    id_MBS_ServiceArea = INT(name='id-MBS-ServiceArea', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBS_ServiceArea._val = 298
    
    #-----< id-MBS-SessionID >-----#
    id_MBS_SessionID = INT(name='id-MBS-SessionID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBS_SessionID._val = 299
    
    #-----< id-MBS-DistributionReleaseRequestTransfer >-----#
    id_MBS_DistributionReleaseRequestTransfer = INT(name='id-MBS-DistributionReleaseRequestTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBS_DistributionReleaseRequestTransfer._val = 300
    
    #-----< id-MBS-DistributionSetupRequestTransfer >-----#
    id_MBS_DistributionSetupRequestTransfer = INT(name='id-MBS-DistributionSetupRequestTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBS_DistributionSetupRequestTransfer._val = 301
    
    #-----< id-MBS-DistributionSetupResponseTransfer >-----#
    id_MBS_DistributionSetupResponseTransfer = INT(name='id-MBS-DistributionSetupResponseTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBS_DistributionSetupResponseTransfer._val = 302
    
    #-----< id-MBS-DistributionSetupUnsuccessfulTransfer >-----#
    id_MBS_DistributionSetupUnsuccessfulTransfer = INT(name='id-MBS-DistributionSetupUnsuccessfulTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBS_DistributionSetupUnsuccessfulTransfer._val = 303
    
    #-----< id-MulticastSessionActivationRequestTransfer >-----#
    id_MulticastSessionActivationRequestTransfer = INT(name='id-MulticastSessionActivationRequestTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastSessionActivationRequestTransfer._val = 304
    
    #-----< id-MulticastSessionDeactivationRequestTransfer >-----#
    id_MulticastSessionDeactivationRequestTransfer = INT(name='id-MulticastSessionDeactivationRequestTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastSessionDeactivationRequestTransfer._val = 305
    
    #-----< id-MulticastSessionUpdateRequestTransfer >-----#
    id_MulticastSessionUpdateRequestTransfer = INT(name='id-MulticastSessionUpdateRequestTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastSessionUpdateRequestTransfer._val = 306
    
    #-----< id-MulticastGroupPagingAreaList >-----#
    id_MulticastGroupPagingAreaList = INT(name='id-MulticastGroupPagingAreaList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticastGroupPagingAreaList._val = 307
    
    #-----< id-MBS-SupportIndicator >-----#
    id_MBS_SupportIndicator = INT(name='id-MBS-SupportIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBS_SupportIndicator._val = 309
    
    #-----< id-MBSSessionFailedtoSetupList >-----#
    id_MBSSessionFailedtoSetupList = INT(name='id-MBSSessionFailedtoSetupList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSSessionFailedtoSetupList._val = 310
    
    #-----< id-MBSSessionFailedtoSetuporModifyList >-----#
    id_MBSSessionFailedtoSetuporModifyList = INT(name='id-MBSSessionFailedtoSetuporModifyList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSSessionFailedtoSetuporModifyList._val = 311
    
    #-----< id-MBSSessionSetupResponseList >-----#
    id_MBSSessionSetupResponseList = INT(name='id-MBSSessionSetupResponseList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSSessionSetupResponseList._val = 312
    
    #-----< id-MBSSessionSetuporModifyResponseList >-----#
    id_MBSSessionSetuporModifyResponseList = INT(name='id-MBSSessionSetuporModifyResponseList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSSessionSetuporModifyResponseList._val = 313
    
    #-----< id-MBSSessionSetupFailureTransfer >-----#
    id_MBSSessionSetupFailureTransfer = INT(name='id-MBSSessionSetupFailureTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSSessionSetupFailureTransfer._val = 314
    
    #-----< id-MBSSessionSetupRequestTransfer >-----#
    id_MBSSessionSetupRequestTransfer = INT(name='id-MBSSessionSetupRequestTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSSessionSetupRequestTransfer._val = 315
    
    #-----< id-MBSSessionSetupResponseTransfer >-----#
    id_MBSSessionSetupResponseTransfer = INT(name='id-MBSSessionSetupResponseTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSSessionSetupResponseTransfer._val = 316
    
    #-----< id-MBSSessionToReleaseList >-----#
    id_MBSSessionToReleaseList = INT(name='id-MBSSessionToReleaseList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSSessionToReleaseList._val = 317
    
    #-----< id-MBSSessionSetupRequestList >-----#
    id_MBSSessionSetupRequestList = INT(name='id-MBSSessionSetupRequestList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSSessionSetupRequestList._val = 318
    
    #-----< id-MBSSessionSetuporModifyRequestList >-----#
    id_MBSSessionSetuporModifyRequestList = INT(name='id-MBSSessionSetuporModifyRequestList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSSessionSetuporModifyRequestList._val = 319
    
    #-----< id-MBS-ActiveSessionInformation-SourcetoTargetList >-----#
    id_MBS_ActiveSessionInformation_SourcetoTargetList = INT(name='id-MBS-ActiveSessionInformation-SourcetoTargetList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBS_ActiveSessionInformation_SourcetoTargetList._val = 323
    
    #-----< id-MBS-ActiveSessionInformation-TargettoSourceList >-----#
    id_MBS_ActiveSessionInformation_TargettoSourceList = INT(name='id-MBS-ActiveSessionInformation-TargettoSourceList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBS_ActiveSessionInformation_TargettoSourceList._val = 324
    
    #-----< id-OnboardingSupport >-----#
    id_OnboardingSupport = INT(name='id-OnboardingSupport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_OnboardingSupport._val = 325
    
    #-----< id-TimeSyncAssistanceInfo >-----#
    id_TimeSyncAssistanceInfo = INT(name='id-TimeSyncAssistanceInfo', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeSyncAssistanceInfo._val = 326
    
    #-----< id-SurvivalTime >-----#
    id_SurvivalTime = INT(name='id-SurvivalTime', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SurvivalTime._val = 327
    
    #-----< id-QMCConfigInfo >-----#
    id_QMCConfigInfo = INT(name='id-QMCConfigInfo', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QMCConfigInfo._val = 328
    
    #-----< id-QMCDeactivation >-----#
    id_QMCDeactivation = INT(name='id-QMCDeactivation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_QMCDeactivation._val = 329
    
    #-----< id-PDUSessionPairID >-----#
    id_PDUSessionPairID = INT(name='id-PDUSessionPairID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDUSessionPairID._val = 331
    
    #-----< id-NR-PagingeDRXInformation >-----#
    id_NR_PagingeDRXInformation = INT(name='id-NR-PagingeDRXInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NR_PagingeDRXInformation._val = 332
    
    #-----< id-RedCapIndication >-----#
    id_RedCapIndication = INT(name='id-RedCapIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RedCapIndication._val = 333
    
    #-----< id-TargetNSSAIInformation >-----#
    id_TargetNSSAIInformation = INT(name='id-TargetNSSAIInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TargetNSSAIInformation._val = 334
    
    #-----< id-UESliceMaximumBitRateList >-----#
    id_UESliceMaximumBitRateList = INT(name='id-UESliceMaximumBitRateList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UESliceMaximumBitRateList._val = 335
    
    #-----< id-M4ReportAmount >-----#
    id_M4ReportAmount = INT(name='id-M4ReportAmount', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M4ReportAmount._val = 336
    
    #-----< id-M5ReportAmount >-----#
    id_M5ReportAmount = INT(name='id-M5ReportAmount', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M5ReportAmount._val = 337
    
    #-----< id-M6ReportAmount >-----#
    id_M6ReportAmount = INT(name='id-M6ReportAmount', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M6ReportAmount._val = 338
    
    #-----< id-M7ReportAmount >-----#
    id_M7ReportAmount = INT(name='id-M7ReportAmount', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M7ReportAmount._val = 339
    
    #-----< id-IncludeBeamMeasurementsIndication >-----#
    id_IncludeBeamMeasurementsIndication = INT(name='id-IncludeBeamMeasurementsIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IncludeBeamMeasurementsIndication._val = 340
    
    #-----< id-ExcessPacketDelayThresholdConfiguration >-----#
    id_ExcessPacketDelayThresholdConfiguration = INT(name='id-ExcessPacketDelayThresholdConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExcessPacketDelayThresholdConfiguration._val = 341
    
    #-----< id-PagingCause >-----#
    id_PagingCause = INT(name='id-PagingCause', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingCause._val = 342
    
    #-----< id-PagingCauseIndicationForVoiceService >-----#
    id_PagingCauseIndicationForVoiceService = INT(name='id-PagingCauseIndicationForVoiceService', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingCauseIndicationForVoiceService._val = 343
    
    #-----< id-PEIPSassistanceInformation >-----#
    id_PEIPSassistanceInformation = INT(name='id-PEIPSassistanceInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PEIPSassistanceInformation._val = 344
    
    #-----< id-FiveG-ProSeAuthorized >-----#
    id_FiveG_ProSeAuthorized = INT(name='id-FiveG-ProSeAuthorized', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FiveG_ProSeAuthorized._val = 345
    
    #-----< id-FiveG-ProSeUEPC5AggregateMaximumBitRate >-----#
    id_FiveG_ProSeUEPC5AggregateMaximumBitRate = INT(name='id-FiveG-ProSeUEPC5AggregateMaximumBitRate', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FiveG_ProSeUEPC5AggregateMaximumBitRate._val = 346
    
    #-----< id-FiveG-ProSePC5QoSParameters >-----#
    id_FiveG_ProSePC5QoSParameters = INT(name='id-FiveG-ProSePC5QoSParameters', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FiveG_ProSePC5QoSParameters._val = 347
    
    #-----< id-MBSSessionModificationFailureTransfer >-----#
    id_MBSSessionModificationFailureTransfer = INT(name='id-MBSSessionModificationFailureTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSSessionModificationFailureTransfer._val = 348
    
    #-----< id-MBSSessionModificationRequestTransfer >-----#
    id_MBSSessionModificationRequestTransfer = INT(name='id-MBSSessionModificationRequestTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSSessionModificationRequestTransfer._val = 349
    
    #-----< id-MBSSessionModificationResponseTransfer >-----#
    id_MBSSessionModificationResponseTransfer = INT(name='id-MBSSessionModificationResponseTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSSessionModificationResponseTransfer._val = 350
    
    #-----< id-MBS-QoSFlowToReleaseList >-----#
    id_MBS_QoSFlowToReleaseList = INT(name='id-MBS-QoSFlowToReleaseList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBS_QoSFlowToReleaseList._val = 351
    
    #-----< id-MBS-SessionTNLInfo5GC >-----#
    id_MBS_SessionTNLInfo5GC = INT(name='id-MBS-SessionTNLInfo5GC', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBS_SessionTNLInfo5GC._val = 352
    
    #-----< id-TAINSAGSupportList >-----#
    id_TAINSAGSupportList = INT(name='id-TAINSAGSupportList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TAINSAGSupportList._val = 353
    
    #-----< id-SourceNodeTNLAddrInfo >-----#
    id_SourceNodeTNLAddrInfo = INT(name='id-SourceNodeTNLAddrInfo', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceNodeTNLAddrInfo._val = 354
    
    #-----< id-NGAPIESupportInformationRequestList >-----#
    id_NGAPIESupportInformationRequestList = INT(name='id-NGAPIESupportInformationRequestList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NGAPIESupportInformationRequestList._val = 355
    
    #-----< id-NGAPIESupportInformationResponseList >-----#
    id_NGAPIESupportInformationResponseList = INT(name='id-NGAPIESupportInformationResponseList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NGAPIESupportInformationResponseList._val = 356
    
    #-----< id-MBS-SessionFSAIDList >-----#
    id_MBS_SessionFSAIDList = INT(name='id-MBS-SessionFSAIDList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBS_SessionFSAIDList._val = 357
    
    #-----< id-MBSSessionReleaseResponseTransfer >-----#
    id_MBSSessionReleaseResponseTransfer = INT(name='id-MBSSessionReleaseResponseTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSSessionReleaseResponseTransfer._val = 358
    
    #-----< id-ManagementBasedMDTPLMNModificationList >-----#
    id_ManagementBasedMDTPLMNModificationList = INT(name='id-ManagementBasedMDTPLMNModificationList', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ManagementBasedMDTPLMNModificationList._val = 359
    
    #-----< id-EarlyMeasurement >-----#
    id_EarlyMeasurement = INT(name='id-EarlyMeasurement', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EarlyMeasurement._val = 360
    
    #-----< id-BeamMeasurementsReportConfiguration >-----#
    id_BeamMeasurementsReportConfiguration = INT(name='id-BeamMeasurementsReportConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BeamMeasurementsReportConfiguration._val = 361
    
    #-----< id-HFCNode-ID-new >-----#
    id_HFCNode_ID_new = INT(name='id-HFCNode-ID-new', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HFCNode_ID_new._val = 362
    
    #-----< id-GlobalCable-ID-new >-----#
    id_GlobalCable_ID_new = INT(name='id-GlobalCable-ID-new', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GlobalCable_ID_new._val = 363
    
    #-----< id-TargetHomeENB-ID >-----#
    id_TargetHomeENB_ID = INT(name='id-TargetHomeENB-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TargetHomeENB_ID._val = 364
    
    _all_ = [
        id_AMFConfigurationUpdate,
        id_AMFStatusIndication,
        id_CellTrafficTrace,
        id_DeactivateTrace,
        id_DownlinkNASTransport,
        id_DownlinkNonUEAssociatedNRPPaTransport,
        id_DownlinkRANConfigurationTransfer,
        id_DownlinkRANStatusTransfer,
        id_DownlinkUEAssociatedNRPPaTransport,
        id_ErrorIndication,
        id_HandoverCancel,
        id_HandoverNotification,
        id_HandoverPreparation,
        id_HandoverResourceAllocation,
        id_InitialContextSetup,
        id_InitialUEMessage,
        id_LocationReportingControl,
        id_LocationReportingFailureIndication,
        id_LocationReport,
        id_NASNonDeliveryIndication,
        id_NGReset,
        id_NGSetup,
        id_OverloadStart,
        id_OverloadStop,
        id_Paging,
        id_PathSwitchRequest,
        id_PDUSessionResourceModify,
        id_PDUSessionResourceModifyIndication,
        id_PDUSessionResourceRelease,
        id_PDUSessionResourceSetup,
        id_PDUSessionResourceNotify,
        id_PrivateMessage,
        id_PWSCancel,
        id_PWSFailureIndication,
        id_PWSRestartIndication,
        id_RANConfigurationUpdate,
        id_RerouteNASRequest,
        id_RRCInactiveTransitionReport,
        id_TraceFailureIndication,
        id_TraceStart,
        id_UEContextModification,
        id_UEContextRelease,
        id_UEContextReleaseRequest,
        id_UERadioCapabilityCheck,
        id_UERadioCapabilityInfoIndication,
        id_UETNLABindingRelease,
        id_UplinkNASTransport,
        id_UplinkNonUEAssociatedNRPPaTransport,
        id_UplinkRANConfigurationTransfer,
        id_UplinkRANStatusTransfer,
        id_UplinkUEAssociatedNRPPaTransport,
        id_WriteReplaceWarning,
        id_SecondaryRATDataUsageReport,
        id_UplinkRIMInformationTransfer,
        id_DownlinkRIMInformationTransfer,
        id_RetrieveUEInformation,
        id_UEInformationTransfer,
        id_RANCPRelocationIndication,
        id_UEContextResume,
        id_UEContextSuspend,
        id_UERadioCapabilityIDMapping,
        id_HandoverSuccess,
        id_UplinkRANEarlyStatusTransfer,
        id_DownlinkRANEarlyStatusTransfer,
        id_AMFCPRelocationIndication,
        id_ConnectionEstablishmentIndication,
        id_BroadcastSessionModification,
        id_BroadcastSessionRelease,
        id_BroadcastSessionSetup,
        id_DistributionSetup,
        id_DistributionRelease,
        id_MulticastSessionActivation,
        id_MulticastSessionDeactivation,
        id_MulticastSessionUpdate,
        id_MulticastGroupPaging,
        id_BroadcastSessionReleaseRequired,
        maxPrivateIEs,
        maxProtocolExtensions,
        maxProtocolIEs,
        maxnoofAllowedAreas,
        maxnoofAllowedCAGsperPLMN,
        maxnoofAllowedS_NSSAIs,
        maxnoofBluetoothName,
        maxnoofBPLMNs,
        maxnoofCAGSperCell,
        maxnoofCellIDforMDT,
        maxnoofCellIDforWarning,
        maxnoofCellinAoI,
        maxnoofCellinEAI,
        maxnoofCellinTAI,
        maxnoofCellsforMBS,
        maxnoofCellsingNB,
        maxnoofCellsinngeNB,
        maxnoofCellsinNGRANNode,
        maxnoofCellsinUEHistoryInfo,
        maxnoofCellsUEMovingTrajectory,
        maxnoofDRBs,
        maxnoofEmergencyAreaID,
        maxnoofEAIforRestart,
        maxnoofEPLMNs,
        maxnoofEPLMNsPlusOne,
        maxnoofE_RABs,
        maxnoofErrors,
        maxnoofExtSliceItems,
        maxnoofForbTACs,
        maxnoofFreqforMDT,
        maxnoofMBSAreaSessionIDs,
        maxnoofMBSFSAs,
        maxnoofMBSQoSFlows,
        maxnoofMBSSessions,
        maxnoofMBSSessionsofUE,
        maxnoofMBSServiceAreaInformation,
        maxnoofMDTPLMNs,
        maxnoofMRBs,
        maxnoofMultiConnectivity,
        maxnoofMultiConnectivityMinusOne,
        maxnoofNeighPCIforMDT,
        maxnoofNGAPIESupportInfo,
        maxnoofNGConnectionsToReset,
        maxnoofNRCellBands,
        maxnoofNSAGs,
        maxnoofPagingAreas,
        maxnoofPC5QoSFlows,
        maxnoofPDUSessions,
        maxnoofPLMNs,
        maxnoofPSCellsPerPrimaryCellinUEHistoryInfo,
        maxnoofQosFlows,
        maxnoofQosParaSets,
        maxnoofRANNodeinAoI,
        maxnoofRecommendedCells,
        maxnoofRecommendedRANNodes,
        maxnoofAoI,
        maxnoofReportedCells,
        maxnoofSensorName,
        maxnoofServedGUAMIs,
        maxnoofSliceItems,
        maxnoofSuccessfulHOReports,
        maxnoofTACs,
        maxnoofTACsinNTN,
        maxnoofTAforMDT,
        maxnoofTAIforInactive,
        maxnoofTAIforMBS,
        maxnoofTAIforPaging,
        maxnoofTAIforRestart,
        maxnoofTAIforWarning,
        maxnoofTAIinAoI,
        maxnoofTimePeriods,
        maxnoofTNLAssociations,
        maxnoofUEsforPaging,
        maxnoofWLANName,
        maxnoofXnExtTLAs,
        maxnoofXnGTP_TLAs,
        maxnoofXnTLAs,
        maxnoofCandidateCells,
        maxnoofTargetS_NSSAIs,
        maxNRARFCN,
        maxnoofCellIDforQMC,
        maxnoofPLMNforQMC,
        maxnoofUEAppLayerMeas,
        maxnoofSNSSAIforQMC,
        maxnoofTAforQMC,
        maxnoofThresholdsForExcessPacketDelay,
        id_AllowedNSSAI,
        id_AMFName,
        id_AMFOverloadResponse,
        id_AMFSetID,
        id_AMF_TNLAssociationFailedToSetupList,
        id_AMF_TNLAssociationSetupList,
        id_AMF_TNLAssociationToAddList,
        id_AMF_TNLAssociationToRemoveList,
        id_AMF_TNLAssociationToUpdateList,
        id_AMFTrafficLoadReductionIndication,
        id_AMF_UE_NGAP_ID,
        id_AssistanceDataForPaging,
        id_BroadcastCancelledAreaList,
        id_BroadcastCompletedAreaList,
        id_CancelAllWarningMessages,
        id_Cause,
        id_CellIDListForRestart,
        id_ConcurrentWarningMessageInd,
        id_CoreNetworkAssistanceInformationForInactive,
        id_CriticalityDiagnostics,
        id_DataCodingScheme,
        id_DefaultPagingDRX,
        id_DirectForwardingPathAvailability,
        id_EmergencyAreaIDListForRestart,
        id_EmergencyFallbackIndicator,
        id_EUTRA_CGI,
        id_FiveG_S_TMSI,
        id_GlobalRANNodeID,
        id_GUAMI,
        id_HandoverType,
        id_IMSVoiceSupportIndicator,
        id_IndexToRFSP,
        id_InfoOnRecommendedCellsAndRANNodesForPaging,
        id_LocationReportingRequestType,
        id_MaskedIMEISV,
        id_MessageIdentifier,
        id_MobilityRestrictionList,
        id_NASC,
        id_NAS_PDU,
        id_NASSecurityParametersFromNGRAN,
        id_NewAMF_UE_NGAP_ID,
        id_NewSecurityContextInd,
        id_NGAP_Message,
        id_NGRAN_CGI,
        id_NGRANTraceID,
        id_NR_CGI,
        id_NRPPa_PDU,
        id_NumberOfBroadcastsRequested,
        id_OldAMF,
        id_OverloadStartNSSAIList,
        id_PagingDRX,
        id_PagingOrigin,
        id_PagingPriority,
        id_PDUSessionResourceAdmittedList,
        id_PDUSessionResourceFailedToModifyListModRes,
        id_PDUSessionResourceFailedToSetupListCxtRes,
        id_PDUSessionResourceFailedToSetupListHOAck,
        id_PDUSessionResourceFailedToSetupListPSReq,
        id_PDUSessionResourceFailedToSetupListSURes,
        id_PDUSessionResourceHandoverList,
        id_PDUSessionResourceListCxtRelCpl,
        id_PDUSessionResourceListHORqd,
        id_PDUSessionResourceModifyListModCfm,
        id_PDUSessionResourceModifyListModInd,
        id_PDUSessionResourceModifyListModReq,
        id_PDUSessionResourceModifyListModRes,
        id_PDUSessionResourceNotifyList,
        id_PDUSessionResourceReleasedListNot,
        id_PDUSessionResourceReleasedListPSAck,
        id_PDUSessionResourceReleasedListPSFail,
        id_PDUSessionResourceReleasedListRelRes,
        id_PDUSessionResourceSetupListCxtReq,
        id_PDUSessionResourceSetupListCxtRes,
        id_PDUSessionResourceSetupListHOReq,
        id_PDUSessionResourceSetupListSUReq,
        id_PDUSessionResourceSetupListSURes,
        id_PDUSessionResourceToBeSwitchedDLList,
        id_PDUSessionResourceSwitchedList,
        id_PDUSessionResourceToReleaseListHOCmd,
        id_PDUSessionResourceToReleaseListRelCmd,
        id_PLMNSupportList,
        id_PWSFailedCellIDList,
        id_RANNodeName,
        id_RANPagingPriority,
        id_RANStatusTransfer_TransparentContainer,
        id_RAN_UE_NGAP_ID,
        id_RelativeAMFCapacity,
        id_RepetitionPeriod,
        id_ResetType,
        id_RoutingID,
        id_RRCEstablishmentCause,
        id_RRCInactiveTransitionReportRequest,
        id_RRCState,
        id_SecurityContext,
        id_SecurityKey,
        id_SerialNumber,
        id_ServedGUAMIList,
        id_SliceSupportList,
        id_SONConfigurationTransferDL,
        id_SONConfigurationTransferUL,
        id_SourceAMF_UE_NGAP_ID,
        id_SourceToTarget_TransparentContainer,
        id_SupportedTAList,
        id_TAIListForPaging,
        id_TAIListForRestart,
        id_TargetID,
        id_TargetToSource_TransparentContainer,
        id_TimeToWait,
        id_TraceActivation,
        id_TraceCollectionEntityIPAddress,
        id_UEAggregateMaximumBitRate,
        id_UE_associatedLogicalNG_connectionList,
        id_UEContextRequest,
        id_UE_NGAP_IDs,
        id_UEPagingIdentity,
        id_UEPresenceInAreaOfInterestList,
        id_UERadioCapability,
        id_UERadioCapabilityForPaging,
        id_UESecurityCapabilities,
        id_UnavailableGUAMIList,
        id_UserLocationInformation,
        id_WarningAreaList,
        id_WarningMessageContents,
        id_WarningSecurityInfo,
        id_WarningType,
        id_AdditionalUL_NGU_UP_TNLInformation,
        id_DataForwardingNotPossible,
        id_DL_NGU_UP_TNLInformation,
        id_NetworkInstance,
        id_PDUSessionAggregateMaximumBitRate,
        id_PDUSessionResourceFailedToModifyListModCfm,
        id_PDUSessionResourceFailedToSetupListCxtFail,
        id_PDUSessionResourceListCxtRelReq,
        id_PDUSessionType,
        id_QosFlowAddOrModifyRequestList,
        id_QosFlowSetupRequestList,
        id_QosFlowToReleaseList,
        id_SecurityIndication,
        id_UL_NGU_UP_TNLInformation,
        id_UL_NGU_UP_TNLModifyList,
        id_WarningAreaCoordinates,
        id_PDUSessionResourceSecondaryRATUsageList,
        id_HandoverFlag,
        id_SecondaryRATUsageInformation,
        id_PDUSessionResourceReleaseResponseTransfer,
        id_RedirectionVoiceFallback,
        id_UERetentionInformation,
        id_S_NSSAI,
        id_PSCellInformation,
        id_LastEUTRAN_PLMNIdentity,
        id_MaximumIntegrityProtectedDataRate_DL,
        id_AdditionalDLForwardingUPTNLInformation,
        id_AdditionalDLUPTNLInformationForHOList,
        id_AdditionalNGU_UP_TNLInformation,
        id_AdditionalDLQosFlowPerTNLInformation,
        id_SecurityResult,
        id_ENDC_SONConfigurationTransferDL,
        id_ENDC_SONConfigurationTransferUL,
        id_OldAssociatedQosFlowList_ULendmarkerexpected,
        id_CNTypeRestrictionsForEquivalent,
        id_CNTypeRestrictionsForServing,
        id_NewGUAMI,
        id_ULForwarding,
        id_ULForwardingUP_TNLInformation,
        id_CNAssistedRANTuning,
        id_CommonNetworkInstance,
        id_NGRAN_TNLAssociationToRemoveList,
        id_TNLAssociationTransportLayerAddressNGRAN,
        id_EndpointIPAddressAndPort,
        id_LocationReportingAdditionalInfo,
        id_SourceToTarget_AMFInformationReroute,
        id_AdditionalULForwardingUPTNLInformation,
        id_SCTP_TLAs,
        id_SelectedPLMNIdentity,
        id_RIMInformationTransfer,
        id_GUAMIType,
        id_SRVCCOperationPossible,
        id_TargetRNC_ID,
        id_RAT_Information,
        id_ExtendedRATRestrictionInformation,
        id_QosMonitoringRequest,
        id_SgNB_UE_X2AP_ID,
        id_AdditionalRedundantDL_NGU_UP_TNLInformation,
        id_AdditionalRedundantDLQosFlowPerTNLInformation,
        id_AdditionalRedundantNGU_UP_TNLInformation,
        id_AdditionalRedundantUL_NGU_UP_TNLInformation,
        id_CNPacketDelayBudgetDL,
        id_CNPacketDelayBudgetUL,
        id_ExtendedPacketDelayBudget,
        id_RedundantCommonNetworkInstance,
        id_RedundantDL_NGU_TNLInformationReused,
        id_RedundantDL_NGU_UP_TNLInformation,
        id_RedundantDLQosFlowPerTNLInformation,
        id_RedundantQosFlowIndicator,
        id_RedundantUL_NGU_UP_TNLInformation,
        id_TSCTrafficCharacteristics,
        id_RedundantPDUSessionInformation,
        id_UsedRSNInformation,
        id_IAB_Authorized,
        id_IAB_Supported,
        id_IABNodeIndication,
        id_NB_IoT_PagingDRX,
        id_NB_IoT_Paging_eDRXInfo,
        id_NB_IoT_DefaultPagingDRX,
        id_Enhanced_CoverageRestriction,
        id_Extended_ConnectedTime,
        id_PagingAssisDataforCEcapabUE,
        id_WUS_Assistance_Information,
        id_UE_DifferentiationInfo,
        id_NB_IoT_UEPriority,
        id_UL_CP_SecurityInformation,
        id_DL_CP_SecurityInformation,
        id_TAI,
        id_UERadioCapabilityForPagingOfNB_IoT,
        id_LTEV2XServicesAuthorized,
        id_NRV2XServicesAuthorized,
        id_LTEUESidelinkAggregateMaximumBitrate,
        id_NRUESidelinkAggregateMaximumBitrate,
        id_PC5QoSParameters,
        id_AlternativeQoSParaSetList,
        id_CurrentQoSParaSetIndex,
        id_CEmodeBrestricted,
        id_EUTRA_PagingeDRXInformation,
        id_CEmodeBSupport_Indicator,
        id_LTEM_Indication,
        id_EndIndication,
        id_EDT_Session,
        id_UECapabilityInfoRequest,
        id_PDUSessionResourceFailedToResumeListRESReq,
        id_PDUSessionResourceFailedToResumeListRESRes,
        id_PDUSessionResourceSuspendListSUSReq,
        id_PDUSessionResourceResumeListRESReq,
        id_PDUSessionResourceResumeListRESRes,
        id_UE_UP_CIoT_Support,
        id_Suspend_Request_Indication,
        id_Suspend_Response_Indication,
        id_RRC_Resume_Cause,
        id_RGLevelWirelineAccessCharacteristics,
        id_W_AGFIdentityInformation,
        id_GlobalTNGF_ID,
        id_GlobalTWIF_ID,
        id_GlobalW_AGF_ID,
        id_UserLocationInformationW_AGF,
        id_UserLocationInformationTNGF,
        id_AuthenticatedIndication,
        id_TNGFIdentityInformation,
        id_TWIFIdentityInformation,
        id_UserLocationInformationTWIF,
        id_DataForwardingResponseERABList,
        id_IntersystemSONConfigurationTransferDL,
        id_IntersystemSONConfigurationTransferUL,
        id_SONInformationReport,
        id_UEHistoryInformationFromTheUE,
        id_ManagementBasedMDTPLMNList,
        id_MDTConfiguration,
        id_PrivacyIndicator,
        id_TraceCollectionEntityURI,
        id_NPN_Support,
        id_NPN_AccessInformation,
        id_NPN_PagingAssistanceInformation,
        id_NPN_MobilityInformation,
        id_TargettoSource_Failure_TransparentContainer,
        id_NID,
        id_UERadioCapabilityID,
        id_UERadioCapability_EUTRA_Format,
        id_DAPSRequestInfo,
        id_DAPSResponseInfoList,
        id_EarlyStatusTransfer_TransparentContainer,
        id_NotifySourceNGRANNode,
        id_ExtendedSliceSupportList,
        id_ExtendedTAISliceSupportList,
        id_ConfiguredTACIndication,
        id_Extended_RANNodeName,
        id_Extended_AMFName,
        id_GlobalCable_ID,
        id_QosMonitoringReportingFrequency,
        id_QosFlowParametersList,
        id_QosFlowFeedbackList,
        id_BurstArrivalTimeDownlink,
        id_ExtendedUEIdentityIndexValue,
        id_PduSessionExpectedUEActivityBehaviour,
        id_MicoAllPLMN,
        id_QosFlowFailedToSetupList,
        id_SourceTNLAddrInfo,
        id_ExtendedReportIntervalMDT,
        id_SourceNodeID,
        id_NRNTNTAIInformation,
        id_UEContextReferenceAtSource,
        id_LastVisitedPSCellList,
        id_IntersystemSONInformationRequest,
        id_IntersystemSONInformationReply,
        id_EnergySavingIndication,
        id_IntersystemResourceStatusUpdate,
        id_SuccessfulHandoverReportList,
        id_MBS_AreaSessionID,
        id_MBS_QoSFlowsToBeSetupList,
        id_MBS_QoSFlowsToBeSetupModList,
        id_MBS_ServiceArea,
        id_MBS_SessionID,
        id_MBS_DistributionReleaseRequestTransfer,
        id_MBS_DistributionSetupRequestTransfer,
        id_MBS_DistributionSetupResponseTransfer,
        id_MBS_DistributionSetupUnsuccessfulTransfer,
        id_MulticastSessionActivationRequestTransfer,
        id_MulticastSessionDeactivationRequestTransfer,
        id_MulticastSessionUpdateRequestTransfer,
        id_MulticastGroupPagingAreaList,
        id_MBS_SupportIndicator,
        id_MBSSessionFailedtoSetupList,
        id_MBSSessionFailedtoSetuporModifyList,
        id_MBSSessionSetupResponseList,
        id_MBSSessionSetuporModifyResponseList,
        id_MBSSessionSetupFailureTransfer,
        id_MBSSessionSetupRequestTransfer,
        id_MBSSessionSetupResponseTransfer,
        id_MBSSessionToReleaseList,
        id_MBSSessionSetupRequestList,
        id_MBSSessionSetuporModifyRequestList,
        id_MBS_ActiveSessionInformation_SourcetoTargetList,
        id_MBS_ActiveSessionInformation_TargettoSourceList,
        id_OnboardingSupport,
        id_TimeSyncAssistanceInfo,
        id_SurvivalTime,
        id_QMCConfigInfo,
        id_QMCDeactivation,
        id_PDUSessionPairID,
        id_NR_PagingeDRXInformation,
        id_RedCapIndication,
        id_TargetNSSAIInformation,
        id_UESliceMaximumBitRateList,
        id_M4ReportAmount,
        id_M5ReportAmount,
        id_M6ReportAmount,
        id_M7ReportAmount,
        id_IncludeBeamMeasurementsIndication,
        id_ExcessPacketDelayThresholdConfiguration,
        id_PagingCause,
        id_PagingCauseIndicationForVoiceService,
        id_PEIPSassistanceInformation,
        id_FiveG_ProSeAuthorized,
        id_FiveG_ProSeUEPC5AggregateMaximumBitRate,
        id_FiveG_ProSePC5QoSParameters,
        id_MBSSessionModificationFailureTransfer,
        id_MBSSessionModificationRequestTransfer,
        id_MBSSessionModificationResponseTransfer,
        id_MBS_QoSFlowToReleaseList,
        id_MBS_SessionTNLInfo5GC,
        id_TAINSAGSupportList,
        id_SourceNodeTNLAddrInfo,
        id_NGAPIESupportInformationRequestList,
        id_NGAPIESupportInformationResponseList,
        id_MBS_SessionFSAIDList,
        id_MBSSessionReleaseResponseTransfer,
        id_ManagementBasedMDTPLMNModificationList,
        id_EarlyMeasurement,
        id_BeamMeasurementsReportConfiguration,
        id_HFCNode_ID_new,
        id_GlobalCable_ID_new,
        id_TargetHomeENB_ID,
    ]

class NGAP_Containers:

    _name_  = 'NGAP-Containers'
    _oid_   = [0, 4, 0, 0, 22, 3, 1, 1, 5]
    
    _obj_ = [
        'NGAP-PROTOCOL-IES',
        'NGAP-PROTOCOL-IES-PAIR',
        'NGAP-PROTOCOL-EXTENSION',
        'NGAP-PRIVATE-IES',
        'ProtocolIE-Container',
        'ProtocolIE-SingleContainer',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerPair',
        'ProtocolIE-FieldPair',
        'ProtocolIE-ContainerList',
        'ProtocolIE-ContainerPairList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    _type_ = [
        'NGAP-PROTOCOL-IES',
        'NGAP-PROTOCOL-IES-PAIR',
        'NGAP-PROTOCOL-EXTENSION',
        'NGAP-PRIVATE-IES',
        'ProtocolIE-Container',
        'ProtocolIE-SingleContainer',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerPair',
        'ProtocolIE-FieldPair',
        'ProtocolIE-ContainerList',
        'ProtocolIE-ContainerPairList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        'NGAP-PROTOCOL-IES',
        'NGAP-PROTOCOL-IES-PAIR',
        'NGAP-PROTOCOL-EXTENSION',
        'NGAP-PRIVATE-IES',
        ]
    _param_ = [
        'ProtocolIE-Container',
        'ProtocolIE-SingleContainer',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerPair',
        'ProtocolIE-FieldPair',
        'ProtocolIE-ContainerList',
        'ProtocolIE-ContainerPairList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    
    #-----< NGAP-PROTOCOL-IES >-----#
    NGAP_PROTOCOL_IES = CLASS(name='NGAP-PROTOCOL-IES', mode=MODE_TYPE)
    _NGAP_PROTOCOL_IES_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _NGAP_PROTOCOL_IES_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'Criticality')))
    _NGAP_PROTOCOL_IES_Value = OPEN(name='Value', mode=MODE_TYPE)
    _NGAP_PROTOCOL_IES_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'Presence')))
    NGAP_PROTOCOL_IES._cont = ASN1Dict([
        ('id', _NGAP_PROTOCOL_IES_id),
        ('criticality', _NGAP_PROTOCOL_IES_criticality),
        ('Value', _NGAP_PROTOCOL_IES_Value),
        ('presence', _NGAP_PROTOCOL_IES_presence),
        ])
    
    #-----< NGAP-PROTOCOL-IES-PAIR >-----#
    NGAP_PROTOCOL_IES_PAIR = CLASS(name='NGAP-PROTOCOL-IES-PAIR', mode=MODE_TYPE)
    _NGAP_PROTOCOL_IES_PAIR_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _NGAP_PROTOCOL_IES_PAIR_firstCriticality = ENUM(name='firstCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'Criticality')))
    _NGAP_PROTOCOL_IES_PAIR_FirstValue = OPEN(name='FirstValue', mode=MODE_TYPE)
    _NGAP_PROTOCOL_IES_PAIR_secondCriticality = ENUM(name='secondCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'Criticality')))
    _NGAP_PROTOCOL_IES_PAIR_SecondValue = OPEN(name='SecondValue', mode=MODE_TYPE)
    _NGAP_PROTOCOL_IES_PAIR_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'Presence')))
    NGAP_PROTOCOL_IES_PAIR._cont = ASN1Dict([
        ('id', _NGAP_PROTOCOL_IES_PAIR_id),
        ('firstCriticality', _NGAP_PROTOCOL_IES_PAIR_firstCriticality),
        ('FirstValue', _NGAP_PROTOCOL_IES_PAIR_FirstValue),
        ('secondCriticality', _NGAP_PROTOCOL_IES_PAIR_secondCriticality),
        ('SecondValue', _NGAP_PROTOCOL_IES_PAIR_SecondValue),
        ('presence', _NGAP_PROTOCOL_IES_PAIR_presence),
        ])
    
    #-----< NGAP-PROTOCOL-EXTENSION >-----#
    NGAP_PROTOCOL_EXTENSION = CLASS(name='NGAP-PROTOCOL-EXTENSION', mode=MODE_TYPE)
    _NGAP_PROTOCOL_EXTENSION_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolExtensionID')), uniq=True)
    _NGAP_PROTOCOL_EXTENSION_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'Criticality')))
    _NGAP_PROTOCOL_EXTENSION_Extension = OPEN(name='Extension', mode=MODE_TYPE)
    _NGAP_PROTOCOL_EXTENSION_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'Presence')))
    NGAP_PROTOCOL_EXTENSION._cont = ASN1Dict([
        ('id', _NGAP_PROTOCOL_EXTENSION_id),
        ('criticality', _NGAP_PROTOCOL_EXTENSION_criticality),
        ('Extension', _NGAP_PROTOCOL_EXTENSION_Extension),
        ('presence', _NGAP_PROTOCOL_EXTENSION_presence),
        ])
    
    #-----< NGAP-PRIVATE-IES >-----#
    NGAP_PRIVATE_IES = CLASS(name='NGAP-PRIVATE-IES', mode=MODE_TYPE)
    _NGAP_PRIVATE_IES_id = CHOICE(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'PrivateIE-ID')))
    _NGAP_PRIVATE_IES_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'Criticality')))
    _NGAP_PRIVATE_IES_Value = OPEN(name='Value', mode=MODE_TYPE)
    _NGAP_PRIVATE_IES_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'Presence')))
    NGAP_PRIVATE_IES._cont = ASN1Dict([
        ('id', _NGAP_PRIVATE_IES_id),
        ('criticality', _NGAP_PRIVATE_IES_criticality),
        ('Value', _NGAP_PRIVATE_IES_Value),
        ('presence', _NGAP_PRIVATE_IES_presence),
        ])
    
    #-----< ProtocolIE-Container >-----#
    ProtocolIE_Container = SEQ_OF(name='ProtocolIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-SingleContainer >-----#
    ProtocolIE_SingleContainer = SEQ(name='ProtocolIE-SingleContainer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')), param=True)
    
    #-----< ProtocolIE-Field >-----#
    ProtocolIE_Field = SEQ(name='ProtocolIE-Field', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerPair >-----#
    ProtocolIE_ContainerPair = SEQ_OF(name='ProtocolIE-ContainerPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-FieldPair >-----#
    ProtocolIE_FieldPair = SEQ(name='ProtocolIE-FieldPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerList >-----#
    ProtocolIE_ContainerList = SEQ_OF(name='ProtocolIE-ContainerList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerPairList >-----#
    ProtocolIE_ContainerPairList = SEQ_OF(name='ProtocolIE-ContainerPairList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionContainer >-----#
    ProtocolExtensionContainer = SEQ_OF(name='ProtocolExtensionContainer', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionField >-----#
    ProtocolExtensionField = SEQ(name='ProtocolExtensionField', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Container >-----#
    PrivateIE_Container = SEQ_OF(name='PrivateIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Field >-----#
    PrivateIE_Field = SEQ(name='PrivateIE-Field', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _NGAP_PROTOCOL_IES_id,
        _NGAP_PROTOCOL_IES_criticality,
        _NGAP_PROTOCOL_IES_Value,
        _NGAP_PROTOCOL_IES_presence,
        NGAP_PROTOCOL_IES,
        _NGAP_PROTOCOL_IES_PAIR_id,
        _NGAP_PROTOCOL_IES_PAIR_firstCriticality,
        _NGAP_PROTOCOL_IES_PAIR_FirstValue,
        _NGAP_PROTOCOL_IES_PAIR_secondCriticality,
        _NGAP_PROTOCOL_IES_PAIR_SecondValue,
        _NGAP_PROTOCOL_IES_PAIR_presence,
        NGAP_PROTOCOL_IES_PAIR,
        _NGAP_PROTOCOL_EXTENSION_id,
        _NGAP_PROTOCOL_EXTENSION_criticality,
        _NGAP_PROTOCOL_EXTENSION_Extension,
        _NGAP_PROTOCOL_EXTENSION_presence,
        NGAP_PROTOCOL_EXTENSION,
        _NGAP_PRIVATE_IES_id,
        _NGAP_PRIVATE_IES_criticality,
        _NGAP_PRIVATE_IES_Value,
        _NGAP_PRIVATE_IES_presence,
        NGAP_PRIVATE_IES,
    ]

class NGAP_IEs:

    _name_  = 'NGAP-IEs'
    _oid_   = [0, 4, 0, 0, 22, 3, 1, 1, 2]
    
    _obj_ = [
        'AdditionalDLUPTNLInformationForHOList',
        'AdditionalDLUPTNLInformationForHOItem',
        'AdditionalDLUPTNLInformationForHOItem-ExtIEs',
        'AdditionalQosFlowInformation',
        'AllocationAndRetentionPriority',
        'AllocationAndRetentionPriority-ExtIEs',
        'Allowed-CAG-List-per-PLMN',
        'AllowedNSSAI',
        'AllowedNSSAI-Item',
        'AllowedNSSAI-Item-ExtIEs',
        'Allowed-PNI-NPN-List',
        'Allowed-PNI-NPN-Item',
        'Allowed-PNI-NPN-Item-ExtIEs',
        'AllowedTACs',
        'AlternativeQoSParaSetIndex',
        'AlternativeQoSParaSetNotifyIndex',
        'AlternativeQoSParaSetList',
        'AlternativeQoSParaSetItem',
        'AlternativeQoSParaSetItem-ExtIEs',
        'AMFName',
        'AMFNameVisibleString',
        'AMFNameUTF8String',
        'AMFPagingTarget',
        'AMFPagingTarget-ExtIEs',
        'AMFPointer',
        'AMFRegionID',
        'AMFSetID',
        'AMF-TNLAssociationSetupList',
        'AMF-TNLAssociationSetupItem',
        'AMF-TNLAssociationSetupItem-ExtIEs',
        'AMF-TNLAssociationToAddList',
        'AMF-TNLAssociationToAddItem',
        'AMF-TNLAssociationToAddItem-ExtIEs',
        'AMF-TNLAssociationToRemoveList',
        'AMF-TNLAssociationToRemoveItem',
        'AMF-TNLAssociationToRemoveItem-ExtIEs',
        'AMF-TNLAssociationToUpdateList',
        'AMF-TNLAssociationToUpdateItem',
        'AMF-TNLAssociationToUpdateItem-ExtIEs',
        'AMF-UE-NGAP-ID',
        'AreaOfInterest',
        'AreaOfInterest-ExtIEs',
        'AreaOfInterestCellList',
        'AreaOfInterestCellItem',
        'AreaOfInterestCellItem-ExtIEs',
        'AreaOfInterestList',
        'AreaOfInterestItem',
        'AreaOfInterestItem-ExtIEs',
        'AreaOfInterestRANNodeList',
        'AreaOfInterestRANNodeItem',
        'AreaOfInterestRANNodeItem-ExtIEs',
        'AreaOfInterestTAIList',
        'AreaOfInterestTAIItem',
        'AreaOfInterestTAIItem-ExtIEs',
        'AssistanceDataForPaging',
        'AssistanceDataForPaging-ExtIEs',
        'AssistanceDataForRecommendedCells',
        'AssistanceDataForRecommendedCells-ExtIEs',
        'AssociatedMBSQosFlowSetupRequestList',
        'AssociatedMBSQosFlowSetupRequestItem',
        'AssociatedMBSQosFlowSetupRequestItem-ExtIEs',
        'AssociatedMBSQosFlowSetuporModifyRequestList',
        'AssociatedMBSQosFlowSetuporModifyRequestItem',
        'AssociatedMBSQosFlowSetuporModifyRequestItem-ExtIEs',
        'AssociatedQosFlowList',
        'AssociatedQosFlowItem',
        'AssociatedQosFlowItem-ExtIEs',
        'AuthenticatedIndication',
        'AveragingWindow',
        'AreaScopeOfMDT-NR',
        'AreaScopeOfMDT-NR-ExtIEs',
        'AreaScopeOfMDT-EUTRA',
        'AreaScopeOfMDT-EUTRA-ExtIEs',
        'AreaScopeOfNeighCellsList',
        'AreaScopeOfNeighCellsItem',
        'AreaScopeOfNeighCellsItem-ExtIEs',
        'AreaScopeOfQMC',
        'AreaScopeOfQMC-ExtIEs',
        'AvailableRANVisibleQoEMetrics',
        'AvailableRANVisibleQoEMetrics-ExtIEs',
        'BeamMeasurementsReportConfiguration',
        'BeamMeasurementsReportConfiguration-ExtIEs',
        'BeamMeasurementsReportQuantity',
        'BeamMeasurementsReportQuantity-ExtIEs',
        'BitRate',
        'BroadcastCancelledAreaList',
        'BroadcastCancelledAreaList-ExtIEs',
        'BroadcastCompletedAreaList',
        'BroadcastCompletedAreaList-ExtIEs',
        'BroadcastPLMNList',
        'BroadcastPLMNItem',
        'BroadcastPLMNItem-ExtIEs',
        'BluetoothMeasurementConfiguration',
        'BluetoothMeasurementConfiguration-ExtIEs',
        'BluetoothMeasConfigNameList',
        'BluetoothMeasConfigNameItem',
        'BluetoothMeasConfigNameItem-ExtIEs',
        'BluetoothMeasConfig',
        'BluetoothName',
        'BurstArrivalTime',
        'CAG-ID',
        'CancelAllWarningMessages',
        'CancelledCellsInEAI-EUTRA',
        'CancelledCellsInEAI-EUTRA-Item',
        'CancelledCellsInEAI-EUTRA-Item-ExtIEs',
        'CancelledCellsInEAI-NR',
        'CancelledCellsInEAI-NR-Item',
        'CancelledCellsInEAI-NR-Item-ExtIEs',
        'CancelledCellsInTAI-EUTRA',
        'CancelledCellsInTAI-EUTRA-Item',
        'CancelledCellsInTAI-EUTRA-Item-ExtIEs',
        'CancelledCellsInTAI-NR',
        'CancelledCellsInTAI-NR-Item',
        'CancelledCellsInTAI-NR-Item-ExtIEs',
        'CandidateCellList',
        'CandidateCellItem',
        'CandidateCellItem-ExtIEs',
        'CandidateCell',
        'CandidateCell-ExtIEs',
        'CandidateCellID',
        'CandidateCellID-ExtIEs',
        'CandidatePCI',
        'CandidatePCI-ExtIEs',
        'Cause',
        'Cause-ExtIEs',
        'CauseMisc',
        'CauseNas',
        'CauseProtocol',
        'CauseRadioNetwork',
        'CauseTransport',
        'Cell-CAGInformation',
        'Cell-CAGInformation-ExtIEs',
        'CellCAGList',
        'CellIDBroadcastEUTRA',
        'CellIDBroadcastEUTRA-Item',
        'CellIDBroadcastEUTRA-Item-ExtIEs',
        'CellIDBroadcastNR',
        'CellIDBroadcastNR-Item',
        'CellIDBroadcastNR-Item-ExtIEs',
        'CellIDCancelledEUTRA',
        'CellIDCancelledEUTRA-Item',
        'CellIDCancelledEUTRA-Item-ExtIEs',
        'CellIDCancelledNR',
        'CellIDCancelledNR-Item',
        'CellIDCancelledNR-Item-ExtIEs',
        'CellIDListForRestart',
        'CellIDListForRestart-ExtIEs',
        'CellSize',
        'CellType',
        'CellType-ExtIEs',
        'CEmodeBSupport-Indicator',
        'CEmodeBrestricted',
        'CNAssistedRANTuning',
        'CNAssistedRANTuning-ExtIEs',
        'CNsubgroupID',
        'CNTypeRestrictionsForEquivalent',
        'CNTypeRestrictionsForEquivalentItem',
        'CNTypeRestrictionsForEquivalentItem-ExtIEs',
        'CNTypeRestrictionsForServing',
        'CommonNetworkInstance',
        'CompletedCellsInEAI-EUTRA',
        'CompletedCellsInEAI-EUTRA-Item',
        'CompletedCellsInEAI-EUTRA-Item-ExtIEs',
        'CompletedCellsInEAI-NR',
        'CompletedCellsInEAI-NR-Item',
        'CompletedCellsInEAI-NR-Item-ExtIEs',
        'CompletedCellsInTAI-EUTRA',
        'CompletedCellsInTAI-EUTRA-Item',
        'CompletedCellsInTAI-EUTRA-Item-ExtIEs',
        'CompletedCellsInTAI-NR',
        'CompletedCellsInTAI-NR-Item',
        'CompletedCellsInTAI-NR-Item-ExtIEs',
        'ConcurrentWarningMessageInd',
        'ConfidentialityProtectionIndication',
        'ConfidentialityProtectionResult',
        'ConfiguredTACIndication',
        'CoreNetworkAssistanceInformationForInactive',
        'CoreNetworkAssistanceInformationForInactive-ExtIEs',
        'COUNTValueForPDCP-SN12',
        'COUNTValueForPDCP-SN12-ExtIEs',
        'COUNTValueForPDCP-SN18',
        'COUNTValueForPDCP-SN18-ExtIEs',
        'CoverageEnhancementLevel',
        'CPTransportLayerInformation',
        'CPTransportLayerInformation-ExtIEs',
        'CriticalityDiagnostics',
        'CriticalityDiagnostics-ExtIEs',
        'CriticalityDiagnostics-IE-List',
        'CriticalityDiagnostics-IE-Item',
        'CriticalityDiagnostics-IE-Item-ExtIEs',
        'CellBasedMDT-NR',
        'CellBasedMDT-NR-ExtIEs',
        'CellIdListforMDT-NR',
        'CellBasedMDT-EUTRA',
        'CellBasedMDT-EUTRA-ExtIEs',
        'CellBasedQMC',
        'CellBasedQMC-ExtIEs',
        'CellIdListforQMC',
        'CellIdListforMDT-EUTRA',
        'DataCodingScheme',
        'DataForwardingAccepted',
        'DataForwardingNotPossible',
        'DataForwardingResponseDRBList',
        'DataForwardingResponseDRBItem',
        'DataForwardingResponseDRBItem-ExtIEs',
        'DAPSRequestInfo',
        'DAPSRequestInfo-ExtIEs',
        'DAPSResponseInfoList',
        'DAPSResponseInfoItem',
        'DAPSResponseInfoItem-ExtIEs',
        'DAPSResponseInfo',
        'DAPSResponseInfo-ExtIEs',
        'DataForwardingResponseERABList',
        'DataForwardingResponseERABListItem',
        'DataForwardingResponseERABListItem-ExtIEs',
        'DelayCritical',
        'DL-CP-SecurityInformation',
        'DL-CP-SecurityInformation-ExtIEs',
        'DL-NAS-MAC',
        'DLForwarding',
        'DL-NGU-TNLInformationReused',
        'DirectForwardingPathAvailability',
        'DRB-ID',
        'DRBsSubjectToStatusTransferList',
        'DRBsSubjectToStatusTransferItem',
        'DRBsSubjectToStatusTransferItem-ExtIEs',
        'DRBStatusDL',
        'DRBStatusDL-ExtIEs',
        'DRBStatusDL12',
        'DRBStatusDL12-ExtIEs',
        'DRBStatusDL18',
        'DRBStatusDL18-ExtIEs',
        'DRBStatusUL',
        'DRBStatusUL-ExtIEs',
        'DRBStatusUL12',
        'DRBStatusUL12-ExtIEs',
        'DRBStatusUL18',
        'DRBStatusUL18-ExtIEs',
        'DRBsToQosFlowsMappingList',
        'DRBsToQosFlowsMappingItem',
        'DRBsToQosFlowsMappingItem-ExtIEs',
        'Dynamic5QIDescriptor',
        'Dynamic5QIDescriptor-ExtIEs',
        'EarlyMeasurement',
        'EarlyStatusTransfer-TransparentContainer',
        'EarlyStatusTransfer-TransparentContainer-ExtIEs',
        'ProcedureStageChoice',
        'ProcedureStageChoice-ExtIEs',
        'FirstDLCount',
        'FirstDLCount-ExtIEs',
        'DRBsSubjectToEarlyStatusTransfer-List',
        'DRBsSubjectToEarlyStatusTransfer-Item',
        'DRBsSubjectToEarlyStatusTransfer-Item-ExtIEs',
        'EDT-Session',
        'EmergencyAreaID',
        'EmergencyAreaIDBroadcastEUTRA',
        'EmergencyAreaIDBroadcastEUTRA-Item',
        'EmergencyAreaIDBroadcastEUTRA-Item-ExtIEs',
        'EmergencyAreaIDBroadcastNR',
        'EmergencyAreaIDBroadcastNR-Item',
        'EmergencyAreaIDBroadcastNR-Item-ExtIEs',
        'EmergencyAreaIDCancelledEUTRA',
        'EmergencyAreaIDCancelledEUTRA-Item',
        'EmergencyAreaIDCancelledEUTRA-Item-ExtIEs',
        'EmergencyAreaIDCancelledNR',
        'EmergencyAreaIDCancelledNR-Item',
        'EmergencyAreaIDCancelledNR-Item-ExtIEs',
        'EmergencyAreaIDList',
        'EmergencyAreaIDListForRestart',
        'EmergencyFallbackIndicator',
        'EmergencyFallbackIndicator-ExtIEs',
        'EmergencyFallbackRequestIndicator',
        'EmergencyServiceTargetCN',
        'ENB-ID',
        'ENB-ID-ExtIEs',
        'Enhanced-CoverageRestriction',
        'Extended-ConnectedTime',
        'EN-DCSONConfigurationTransfer',
        'EndpointIPAddressAndPort',
        'EndIndication',
        'EndpointIPAddressAndPort-ExtIEs',
        'EquivalentPLMNs',
        'EPS-TAC',
        'EPS-TAI',
        'EPS-TAI-ExtIEs',
        'E-RAB-ID',
        'E-RABInformationList',
        'E-RABInformationItem',
        'E-RABInformationItem-ExtIEs',
        'EUTRACellIdentity',
        'EUTRA-CGI',
        'EUTRA-CGI-ExtIEs',
        'EUTRA-CGIList',
        'EUTRA-CGIListForWarning',
        'EUTRA-PagingeDRXInformation',
        'EUTRA-PagingeDRXInformation-ExtIEs',
        'EUTRA-Paging-eDRX-Cycle',
        'EUTRA-Paging-Time-Window',
        'EUTRAencryptionAlgorithms',
        'EUTRAintegrityProtectionAlgorithms',
        'EventType',
        'ExcessPacketDelayThresholdConfiguration',
        'ExcessPacketDelayThresholdItem',
        'ExcessPacketDelayThresholdItem-ExtIEs',
        'ExcessPacketDelayThresholdValue',
        'ExpectedActivityPeriod',
        'ExpectedHOInterval',
        'ExpectedIdlePeriod',
        'ExpectedUEActivityBehaviour',
        'ExpectedUEActivityBehaviour-ExtIEs',
        'ExpectedUEBehaviour',
        'ExpectedUEBehaviour-ExtIEs',
        'ExpectedUEMobility',
        'ExpectedUEMovingTrajectory',
        'ExpectedUEMovingTrajectoryItem',
        'ExpectedUEMovingTrajectoryItem-ExtIEs',
        'Extended-AMFName',
        'Extended-AMFName-ExtIEs',
        'ExtendedPacketDelayBudget',
        'Extended-RANNodeName',
        'Extended-RANNodeName-ExtIEs',
        'ExtendedRATRestrictionInformation',
        'ExtendedRATRestrictionInformation-ExtIEs',
        'ExtendedRNC-ID',
        'ExtendedSliceSupportList',
        'ExtendedUEIdentityIndexValue',
        'EventTrigger',
        'EventTrigger-ExtIEs',
        'EventL1LoggedMDTConfig',
        'EventL1LoggedMDTConfig-ExtIEs',
        'MeasurementThresholdL1LoggedMDT',
        'MeasurementThresholdL1LoggedMDT-ExtIEs',
        'FailureIndication',
        'FailureIndication-ExtIEs',
        'FiveG-ProSeAuthorized',
        'FiveG-ProSeAuthorized-ExtIEs',
        'FiveGProSeDirectDiscovery',
        'FiveGProSeDirectCommunication',
        'FiveGProSeLayer2UEtoNetworkRelay',
        'FiveGProSeLayer3UEtoNetworkRelay',
        'FiveGProSeLayer2RemoteUE',
        'FiveG-ProSePC5QoSParameters',
        'FiveG-ProSePC5QoSParameters-ExtIEs',
        'FiveGProSePC5QoSFlowList',
        'FiveGProSePC5QoSFlowItem',
        'FiveGProSePC5QoSFlowItem-ExtIEs',
        'FiveGProSePC5FlowBitRates',
        'FiveGProSePC5FlowBitRates-ExtIEs',
        'FiveG-S-TMSI',
        'FiveG-S-TMSI-ExtIEs',
        'FiveG-TMSI',
        'FiveQI',
        'ForbiddenAreaInformation',
        'ForbiddenAreaInformation-Item',
        'ForbiddenAreaInformation-Item-ExtIEs',
        'ForbiddenTACs',
        'FromEUTRANtoNGRAN',
        'FromEUTRANtoNGRAN-ExtIEs',
        'FromNGRANtoEUTRAN',
        'FromNGRANtoEUTRAN-ExtIEs',
        'GBR-QosInformation',
        'GBR-QosInformation-ExtIEs',
        'GlobalCable-ID',
        'GlobalCable-ID-new',
        'GlobalCable-ID-new-ExtIEs',
        'GlobalENB-ID',
        'GlobalENB-ID-ExtIEs',
        'GlobalGNB-ID',
        'GlobalGNB-ID-ExtIEs',
        'GlobalN3IWF-ID',
        'GlobalN3IWF-ID-ExtIEs',
        'GlobalLine-ID',
        'GlobalLine-ID-ExtIEs',
        'GlobalLineIdentity',
        'GlobalNgENB-ID',
        'GlobalNgENB-ID-ExtIEs',
        'GlobalRANNodeID',
        'GlobalRANNodeID-ExtIEs',
        'GlobalTNGF-ID',
        'GlobalTNGF-ID-ExtIEs',
        'GlobalTWIF-ID',
        'GlobalTWIF-ID-ExtIEs',
        'GlobalW-AGF-ID',
        'GlobalW-AGF-ID-ExtIEs',
        'GNB-ID',
        'GNB-ID-ExtIEs',
        'GTP-TEID',
        'GTPTunnel',
        'GTPTunnel-ExtIEs',
        'GUAMI',
        'GUAMI-ExtIEs',
        'GUAMIType',
        'HandoverCommandTransfer',
        'HandoverCommandTransfer-ExtIEs',
        'HandoverFlag',
        'HandoverPreparationUnsuccessfulTransfer',
        'HandoverPreparationUnsuccessfulTransfer-ExtIEs',
        'HandoverRequestAcknowledgeTransfer',
        'HandoverRequestAcknowledgeTransfer-ExtIEs',
        'HandoverRequiredTransfer',
        'HandoverRequiredTransfer-ExtIEs',
        'HandoverResourceAllocationUnsuccessfulTransfer',
        'HandoverResourceAllocationUnsuccessfulTransfer-ExtIEs',
        'HandoverType',
        'HFCNode-ID',
        'HFCNode-ID-new',
        'HFCNode-ID-new-ExtIEs',
        'HOReport',
        'HOReport-ExtIEs',
        'Hysteresis',
        'IAB-Authorized',
        'IAB-Supported',
        'IABNodeIndication',
        'IMSVoiceSupportIndicator',
        'IndexToRFSP',
        'InfoOnRecommendedCellsAndRANNodesForPaging',
        'InfoOnRecommendedCellsAndRANNodesForPaging-ExtIEs',
        'IntegrityProtectionIndication',
        'IntegrityProtectionResult',
        'IntendedNumberOfPagingAttempts',
        'InterfacesToTrace',
        'ImmediateMDTNr',
        'ImmediateMDTNr-ExtIEs',
        'InterSystemFailureIndication',
        'InterSystemFailureIndication-ExtIEs',
        'IntersystemSONConfigurationTransfer',
        'IntersystemSONConfigurationTransfer-ExtIEs',
        'IntersystemSONTransferType',
        'IntersystemSONTransferType-ExtIEs',
        'IntersystemSONeNBID',
        'IntersystemSONeNBID-ExtIEs',
        'IntersystemSONNGRANnodeID',
        'IntersystemSONNGRANnodeID-ExtIEs',
        'IntersystemSONInformation',
        'IntersystemSONInformation-ExtIEs',
        'IntersystemSONInformationRequest',
        'IntersystemSONInformationRequest-ExtIEs',
        'IntersystemCellActivationRequest',
        'IntersystemCellActivationRequest-ExtIEs',
        'CellsToActivateList',
        'IntersystemResourceStatusRequest',
        'IntersystemResourceStatusRequest-ExtIEs',
        'ReportingSystem',
        'ReportingSystem-ExtIEs',
        'EUTRAN-ReportingSystemIEs',
        'EUTRAN-ReportingSystemIEs-ExtIEs',
        'NGRAN-ReportingSystemIEs',
        'NGRAN-ReportingSystemIEs-ExtIEs',
        'EUTRAN-CellToReportList',
        'EUTRAN-CellToReportItem',
        'EUTRAN-CellToReportItem-ExtIEs',
        'NGRAN-CellToReportList',
        'NGRAN-CellToReportItem',
        'NGRAN-CellToReportItem-ExtIEs',
        'ReportCharacteristics',
        'ReportType',
        'ReportType-ExtIEs',
        'EventBasedReportingIEs',
        'EventBasedReportingIEs-ExtIEs',
        'IntersystemResourceThreshold',
        'NumberOfMeasurementReportingLevels',
        'PeriodicReportingIEs',
        'PeriodicReportingIEs-ExtIEs',
        'ReportingPeriodicity',
        'IntersystemSONInformationReply',
        'IntersystemSONInformationReply-ExtIEs',
        'IntersystemCellActivationReply',
        'IntersystemCellActivationReply-ExtIEs',
        'ActivatedCellList',
        'IntersystemResourceStatusReply',
        'IntersystemResourceStatusReply-ExtIEs',
        'IntersystemSONInformationReport',
        'IntersystemSONInformationReport-ExtIEs',
        'IntersystemCellStateIndication',
        'IntersystemCellStateIndication-ExtIEs',
        'NotificationCellList',
        'NotificationCell-Item',
        'NotificationCell-Item-ExtIEs',
        'IntersystemResourceStatusReport',
        'IntersystemResourceStatusReport-ExtIEs',
        'ResourceStatusReportingSystem',
        'ResourceStatusReportingSystem-ExtIEs',
        'EUTRAN-ReportingStatusIEs',
        'EUTRAN-ReportingStatusIEs-ExtIEs',
        'EUTRAN-CellReportList',
        'EUTRAN-CellReportItem',
        'EUTRAN-CellReportItem-ExtIEs',
        'EUTRAN-CompositeAvailableCapacityGroup',
        'EUTRAN-CompositeAvailableCapacityGroup-ExtIEs',
        'CompositeAvailableCapacity',
        'CompositeAvailableCapacity-ExtIEs',
        'EUTRAN-NumberOfActiveUEs',
        'EUTRAN-RadioResourceStatus',
        'EUTRAN-RadioResourceStatus-ExtIEs',
        'NGRAN-ReportingStatusIEs',
        'NGRAN-ReportingStatusIEs-ExtIEs',
        'NGRAN-CellReportList',
        'NGRAN-CellReportItem',
        'NGRAN-CellReportItem-ExtIEs',
        'NGRAN-NumberOfActiveUEs',
        'NGRAN-NoofRRCConnections',
        'NGRAN-RadioResourceStatus',
        'NGRAN-RadioResourceStatus-ExtIEs',
        'InterSystemHOReport',
        'InterSystemHOReport-ExtIEs',
        'InterSystemHandoverReportType',
        'InterSystemHandoverReportType-ExtIEs',
        'IntersystemUnnecessaryHO',
        'IntersystemUnnecessaryHO-ExtIEs',
        'LAC',
        'LAI',
        'LAI-ExtIEs',
        'LastVisitedCellInformation',
        'LastVisitedCellInformation-ExtIEs',
        'LastVisitedCellItem',
        'LastVisitedCellItem-ExtIEs',
        'LastVisitedEUTRANCellInformation',
        'LastVisitedGERANCellInformation',
        'LastVisitedNGRANCellInformation',
        'LastVisitedNGRANCellInformation-ExtIEs',
        'LastVisitedPSCellList',
        'LastVisitedPSCellInformation',
        'LastVisitedPSCellInformation-ExtIEs',
        'LastVisitedUTRANCellInformation',
        'LineType',
        'LocationReportingAdditionalInfo',
        'LocationReportingReferenceID',
        'LocationReportingRequestType',
        'LocationReportingRequestType-ExtIEs',
        'LoggedMDTNr',
        'LoggedMDTNr-ExtIEs',
        'LoggingInterval',
        'LoggingDuration',
        'Links-to-log',
        'LoggedMDTTrigger',
        'LoggedMDTTrigger-ExtIEs',
        'LTEM-Indication',
        'LTEUERLFReportContainer',
        'LTEV2XServicesAuthorized',
        'LTEV2XServicesAuthorized-ExtIEs',
        'LTEUESidelinkAggregateMaximumBitrate',
        'LTEUE-Sidelink-Aggregate-MaximumBitrates-ExtIEs',
        'MaskedIMEISV',
        'MaximumDataBurstVolume',
        'MessageIdentifier',
        'MaximumIntegrityProtectedDataRate',
        'MBS-AreaSessionID',
        'MBS-DataForwardingResponseMRBList',
        'MBS-DataForwardingResponseMRBItem',
        'MBS-DataForwardingResponseMRBItem-ExtIEs',
        'MBS-MappingandDataForwardingRequestList',
        'MBS-MappingandDataForwardingRequestItem',
        'MBS-MappingandDataForwardingRequestItem-ExtIEs',
        'MBS-QoSFlowList',
        'MRB-ProgressInformation',
        'MRB-ProgressInformation-ExtIEs',
        'MBS-QoSFlowsToBeSetupList',
        'MBS-QoSFlowsToBeSetupItem',
        'MBS-QoSFlowsToBeSetupItem-ExtIEs',
        'MBS-ServiceArea',
        'MBS-ServiceArea-ExtIEs',
        'MBS-ServiceAreaInformationList',
        'MBS-ServiceAreaInformationItem',
        'MBS-ServiceAreaInformationItem-ExtIEs',
        'MBS-ServiceAreaInformation',
        'MBS-ServiceAreaInformation-ExtIEs',
        'MBS-ServiceAreaCellList',
        'MBS-ServiceAreaTAIList',
        'MBS-SessionID',
        'MBS-SessionID-ExtIEs',
        'MBSSessionFailedtoSetupList',
        'MBSSessionFailedtoSetupItem',
        'MBSSessionFailedtoSetupItem-ExtIEs',
        'MBS-ActiveSessionInformation-SourcetoTargetList',
        'MBS-ActiveSessionInformation-SourcetoTargetItem',
        'MBS-ActiveSessionInformation-SourcetoTargetItem-ExtIEs',
        'MBS-ActiveSessionInformation-TargettoSourceList',
        'MBS-ActiveSessionInformation-TargettoSourceItem',
        'MBS-ActiveSessionInformation-TargettoSourceItem-ExtIEs',
        'MBSSessionSetupOrModFailureTransfer',
        'MBSSessionSetupOrModFailureTransfer-ExtIEs',
        'MBSSessionSetupResponseList',
        'MBSSessionSetupResponseItem',
        'MBSSessionSetupResponseItem-ExtIEs',
        'MBSSessionSetupOrModRequestTransfer',
        'MBSSessionSetupOrModRequestTransferIEs',
        'MBS-SessionFSAIDList',
        'MBS-SessionFSAID',
        'MBSSessionReleaseResponseTransfer',
        'MBSSessionReleaseResponseTransfer-ExtIEs',
        'MBSSessionSetupOrModResponseTransfer',
        'MBSSessionSetupOrModResponseTransfer-ExtIEs',
        'MBS-SupportIndicator',
        'MBS-SessionTNLInfo5GC',
        'MBS-SessionTNLInfo5GC-ExtIEs',
        'MBS-SessionTNLInfo5GCList',
        'MBS-SessionTNLInfo5GCItem',
        'MBS-SessionTNLInfo5GCItem-ExtIEs',
        'MBS-SessionTNLInfoNGRAN',
        'MBS-SessionTNLInfoNGRAN-ExtIEs',
        'MBS-SessionTNLInfoNGRANList',
        'MBS-SessionTNLInfoNGRANItem',
        'MBS-SessionTNLInfoNGRANItem-ExtIEs',
        'MBS-DistributionReleaseRequestTransfer',
        'MBS-DistributionReleaseRequesTransfer-ExtIEs',
        'MBS-DistributionSetupRequestTransfer',
        'MBS-DistributionSetupRequestTransfer-ExtIEs',
        'MBS-DistributionSetupResponseTransfer',
        'MBS-DistributionSetupResponseTransfer-ExtIEs',
        'MBS-DistributionSetupUnsuccessfulTransfer',
        'MBS-DistributionSetupUnsuccessfulTransfer-ExtIEs',
        'MBSSessionSetupRequestList',
        'MBSSessionSetupRequestItem',
        'MBSSessionSetupRequestItem-ExtIEs',
        'MBSSessionSetuporModifyRequestList',
        'MBSSessionSetuporModifyRequestItem',
        'MBSSessionSetuporModifyRequestItem-ExtIEs',
        'MBSSessionToReleaseList',
        'MBSSessionToReleaseItem',
        'MBSSessionToReleaseItem-ExtIEs',
        'MBSSessionStatus',
        'MicoAllPLMN',
        'MICOModeIndication',
        'MobilityInformation',
        'MobilityRestrictionList',
        'MobilityRestrictionList-ExtIEs',
        'MDT-AlignmentInfo',
        'MDT-AlignmentInfo-ExtIEs',
        'MDTPLMNList',
        'MDTPLMNModificationList',
        'MDT-Configuration',
        'MDT-Configuration-ExtIEs',
        'MDT-Configuration-NR',
        'MDT-Configuration-NR-ExtIEs',
        'MDT-Configuration-EUTRA',
        'MDT-Configuration-EUTRA-ExtIEs',
        'MDT-Activation',
        'MDTModeNr',
        'MDTModeNr-ExtIEs',
        'MDTModeEutra',
        'MeasurementsToActivate',
        'MRB-ID',
        'MulticastSessionActivationRequestTransfer',
        'MulticastSessionActivationRequestTransfer-ExtIEs',
        'MulticastSessionDeactivationRequestTransfer',
        'MulticastSessionDeactivationRequestTransfer-ExtIEs',
        'MulticastSessionUpdateRequestTransfer',
        'MulticastSessionUpdateRequestTransferIEs',
        'MulticastGroupPagingAreaList',
        'MulticastGroupPagingAreaItem',
        'MulticastGroupPagingAreaItem-ExtIEs',
        'MBS-AreaTAIList',
        'MulticastGroupPagingArea',
        'MulticastGroupPagingArea-ExtIEs',
        'UE-PagingList',
        'UE-PagingItem',
        'UE-PagingItem-ExtIEs',
        'M1Configuration',
        'M1Configuration-ExtIEs',
        'IncludeBeamMeasurementsIndication',
        'MaxNrofRS-IndexesToReport',
        'M1ReportingTrigger',
        'M1ThresholdEventA2',
        'M1ThresholdEventA2-ExtIEs',
        'M1ThresholdType',
        'M1ThresholdType-ExtIEs',
        'M1PeriodicReporting',
        'M1PeriodicReporting-ExtIEs',
        'M4Configuration',
        'M4Configuration-ExtIEs',
        'M4ReportAmountMDT',
        'M4period',
        'M5Configuration',
        'M5Configuration-ExtIEs',
        'M5ReportAmountMDT',
        'M5period',
        'M6Configuration',
        'M6Configuration-ExtIEs',
        'M6ReportAmountMDT',
        'M6report-Interval',
        'M7Configuration',
        'M7Configuration-ExtIEs',
        'M7ReportAmountMDT',
        'M7period',
        'MDT-Location-Info',
        'MDT-Location-Info-ExtIEs',
        'MDT-Location-Information',
        'N3IWF-ID',
        'N3IWF-ID-ExtIEs',
        'NAS-PDU',
        'NASSecurityParametersFromNGRAN',
        'NB-IoT-DefaultPagingDRX',
        'NB-IoT-PagingDRX',
        'NB-IoT-Paging-eDRXCycle',
        'NB-IoT-Paging-TimeWindow',
        'NB-IoT-Paging-eDRXInfo',
        'NB-IoT-Paging-eDRXInfo-ExtIEs',
        'NB-IoT-UEPriority',
        'NetworkInstance',
        'NewSecurityContextInd',
        'NextHopChainingCount',
        'NextPagingAreaScope',
        'NGAPIESupportInformationRequestList',
        'NGAPIESupportInformationRequestItem',
        'NGAPIESupportInformationRequestItem-ExtIEs',
        'NGAPIESupportInformationResponseList',
        'NGAPIESupportInformationResponseItem',
        'NGAPIESupportInformationResponseItem-ExtIEs',
        'NgENB-ID',
        'NgENB-ID-ExtIEs',
        'NotifySourceNGRANNode',
        'NGRAN-CGI',
        'NGRAN-CGI-ExtIEs',
        'NGRAN-TNLAssociationToRemoveList',
        'NGRAN-TNLAssociationToRemoveItem',
        'NGRAN-TNLAssociationToRemoveItem-ExtIEs',
        'NGRANTraceID',
        'NID',
        'NonDynamic5QIDescriptor',
        'NonDynamic5QIDescriptor-ExtIEs',
        'NotAllowedTACs',
        'NotificationCause',
        'NotificationControl',
        'NPN-AccessInformation',
        'NPN-AccessInformation-ExtIEs',
        'NPN-MobilityInformation',
        'NPN-MobilityInformation-ExtIEs',
        'NPN-PagingAssistanceInformation',
        'NPN-PagingAssistanceInformation-ExtIEs',
        'NPN-Support',
        'NPN-Support-ExtIEs',
        'NRCellIdentity',
        'NR-CGI',
        'NR-CGI-ExtIEs',
        'NR-CGIList',
        'NR-CGIListForWarning',
        'NR-PagingeDRXInformation',
        'NR-PagingeDRXInformation-ExtIEs',
        'NR-Paging-eDRX-Cycle',
        'NR-Paging-Time-Window',
        'NRencryptionAlgorithms',
        'NRintegrityProtectionAlgorithms',
        'NRMobilityHistoryReport',
        'NRPPa-PDU',
        'NRUERLFReportContainer',
        'NRNTNTAIInformation',
        'NRNTNTAIInformation-ExtIEs',
        'NumberOfBroadcasts',
        'NumberOfBroadcastsRequested',
        'NRARFCN',
        'NRFrequencyBand',
        'NRFrequencyBand-List',
        'NRFrequencyBandItem',
        'NRFrequencyBandItem-ExtIEs',
        'NRFrequencyInfo',
        'NRFrequencyInfo-ExtIEs',
        'NR-PCI',
        'NRV2XServicesAuthorized',
        'NRV2XServicesAuthorized-ExtIEs',
        'VehicleUE',
        'PedestrianUE',
        'NRUESidelinkAggregateMaximumBitrate',
        'NRUESidelinkAggregateMaximumBitrate-ExtIEs',
        'NSAG-ID',
        'OnboardingSupport',
        'OverloadAction',
        'OverloadResponse',
        'OverloadResponse-ExtIEs',
        'OverloadStartNSSAIList',
        'OverloadStartNSSAIItem',
        'OverloadStartNSSAIItem-ExtIEs',
        'PacketDelayBudget',
        'PacketErrorRate',
        'PacketErrorRate-ExtIEs',
        'PacketLossRate',
        'PagingAssisDataforCEcapabUE',
        'PagingAssisDataforCEcapabUE-ExtIEs',
        'PagingAttemptInformation',
        'PagingAttemptInformation-ExtIEs',
        'PagingAttemptCount',
        'PagingCause',
        'PagingCauseIndicationForVoiceService',
        'PagingDRX',
        'PagingOrigin',
        'PagingPriority',
        'PagingProbabilityInformation',
        'PathSwitchRequestAcknowledgeTransfer',
        'PathSwitchRequestAcknowledgeTransfer-ExtIEs',
        'PathSwitchRequestSetupFailedTransfer',
        'PathSwitchRequestSetupFailedTransfer-ExtIEs',
        'PathSwitchRequestTransfer',
        'PathSwitchRequestTransfer-ExtIEs',
        'PathSwitchRequestUnsuccessfulTransfer',
        'PathSwitchRequestUnsuccessfulTransfer-ExtIEs',
        'PC5QoSParameters',
        'PC5QoSParameters-ExtIEs',
        'PC5QoSFlowList',
        'PC5QoSFlowItem',
        'PC5QoSFlowItem-ExtIEs',
        'PC5FlowBitRates',
        'PC5FlowBitRates-ExtIEs',
        'PCIListForMDT',
        'PrivacyIndicator',
        'PDUSessionAggregateMaximumBitRate',
        'PDUSessionAggregateMaximumBitRate-ExtIEs',
        'PDUSessionID',
        'PDUSessionPairID',
        'PDUSessionResourceAdmittedList',
        'PDUSessionResourceAdmittedItem',
        'PDUSessionResourceAdmittedItem-ExtIEs',
        'PDUSessionResourceFailedToModifyListModCfm',
        'PDUSessionResourceFailedToModifyItemModCfm',
        'PDUSessionResourceFailedToModifyItemModCfm-ExtIEs',
        'PDUSessionResourceFailedToModifyListModRes',
        'PDUSessionResourceFailedToModifyItemModRes',
        'PDUSessionResourceFailedToModifyItemModRes-ExtIEs',
        'PDUSessionResourceFailedToResumeListRESReq',
        'PDUSessionResourceFailedToResumeItemRESReq',
        'PDUSessionResourceFailedToResumeItemRESReq-ExtIEs',
        'PDUSessionResourceFailedToResumeListRESRes',
        'PDUSessionResourceFailedToResumeItemRESRes',
        'PDUSessionResourceFailedToResumeItemRESRes-ExtIEs',
        'PDUSessionResourceFailedToSetupListCxtFail',
        'PDUSessionResourceFailedToSetupItemCxtFail',
        'PDUSessionResourceFailedToSetupItemCxtFail-ExtIEs',
        'PDUSessionResourceFailedToSetupListCxtRes',
        'PDUSessionResourceFailedToSetupItemCxtRes',
        'PDUSessionResourceFailedToSetupItemCxtRes-ExtIEs',
        'PDUSessionResourceFailedToSetupListHOAck',
        'PDUSessionResourceFailedToSetupItemHOAck',
        'PDUSessionResourceFailedToSetupItemHOAck-ExtIEs',
        'PDUSessionResourceFailedToSetupListPSReq',
        'PDUSessionResourceFailedToSetupItemPSReq',
        'PDUSessionResourceFailedToSetupItemPSReq-ExtIEs',
        'PDUSessionResourceFailedToSetupListSURes',
        'PDUSessionResourceFailedToSetupItemSURes',
        'PDUSessionResourceFailedToSetupItemSURes-ExtIEs',
        'PDUSessionResourceHandoverList',
        'PDUSessionResourceHandoverItem',
        'PDUSessionResourceHandoverItem-ExtIEs',
        'PDUSessionResourceInformationList',
        'PDUSessionResourceInformationItem',
        'PDUSessionResourceInformationItem-ExtIEs',
        'PDUSessionResourceListCxtRelCpl',
        'PDUSessionResourceItemCxtRelCpl',
        'PDUSessionResourceItemCxtRelCpl-ExtIEs',
        'PDUSessionResourceListCxtRelReq',
        'PDUSessionResourceItemCxtRelReq',
        'PDUSessionResourceItemCxtRelReq-ExtIEs',
        'PDUSessionResourceListHORqd',
        'PDUSessionResourceItemHORqd',
        'PDUSessionResourceItemHORqd-ExtIEs',
        'PDUSessionResourceModifyConfirmTransfer',
        'PDUSessionResourceModifyConfirmTransfer-ExtIEs',
        'PDUSessionResourceModifyIndicationUnsuccessfulTransfer',
        'PDUSessionResourceModifyIndicationUnsuccessfulTransfer-ExtIEs',
        'PDUSessionResourceModifyRequestTransfer',
        'PDUSessionResourceModifyRequestTransferIEs',
        'PDUSessionResourceModifyResponseTransfer',
        'PDUSessionResourceModifyResponseTransfer-ExtIEs',
        'PDUSessionResourceModifyIndicationTransfer',
        'PDUSessionResourceModifyIndicationTransfer-ExtIEs',
        'PDUSessionResourceModifyListModCfm',
        'PDUSessionResourceModifyItemModCfm',
        'PDUSessionResourceModifyItemModCfm-ExtIEs',
        'PDUSessionResourceModifyListModInd',
        'PDUSessionResourceModifyItemModInd',
        'PDUSessionResourceModifyItemModInd-ExtIEs',
        'PDUSessionResourceModifyListModReq',
        'PDUSessionResourceModifyItemModReq',
        'PDUSessionResourceModifyItemModReq-ExtIEs',
        'PDUSessionResourceModifyListModRes',
        'PDUSessionResourceModifyItemModRes',
        'PDUSessionResourceModifyItemModRes-ExtIEs',
        'PDUSessionResourceModifyUnsuccessfulTransfer',
        'PDUSessionResourceModifyUnsuccessfulTransfer-ExtIEs',
        'PDUSessionResourceNotifyList',
        'PDUSessionResourceNotifyItem',
        'PDUSessionResourceNotifyItem-ExtIEs',
        'PDUSessionResourceNotifyReleasedTransfer',
        'PDUSessionResourceNotifyReleasedTransfer-ExtIEs',
        'PDUSessionResourceNotifyTransfer',
        'PDUSessionResourceNotifyTransfer-ExtIEs',
        'PDUSessionResourceReleaseCommandTransfer',
        'PDUSessionResourceReleaseCommandTransfer-ExtIEs',
        'PDUSessionResourceReleasedListNot',
        'PDUSessionResourceReleasedItemNot',
        'PDUSessionResourceReleasedItemNot-ExtIEs',
        'PDUSessionResourceReleasedListPSAck',
        'PDUSessionResourceReleasedItemPSAck',
        'PDUSessionResourceReleasedItemPSAck-ExtIEs',
        'PDUSessionResourceReleasedListPSFail',
        'PDUSessionResourceReleasedItemPSFail',
        'PDUSessionResourceReleasedItemPSFail-ExtIEs',
        'PDUSessionResourceReleasedListRelRes',
        'PDUSessionResourceReleasedItemRelRes',
        'PDUSessionResourceReleasedItemRelRes-ExtIEs',
        'PDUSessionResourceReleaseResponseTransfer',
        'PDUSessionResourceReleaseResponseTransfer-ExtIEs',
        'PDUSessionResourceResumeListRESReq',
        'PDUSessionResourceResumeItemRESReq',
        'PDUSessionResourceResumeItemRESReq-ExtIEs',
        'PDUSessionResourceResumeListRESRes',
        'PDUSessionResourceResumeItemRESRes',
        'PDUSessionResourceResumeItemRESRes-ExtIEs',
        'PDUSessionResourceSecondaryRATUsageList',
        'PDUSessionResourceSecondaryRATUsageItem',
        'PDUSessionResourceSecondaryRATUsageItem-ExtIEs',
        'PDUSessionResourceSetupListCxtReq',
        'PDUSessionResourceSetupItemCxtReq',
        'PDUSessionResourceSetupItemCxtReq-ExtIEs',
        'PDUSessionResourceSetupListCxtRes',
        'PDUSessionResourceSetupItemCxtRes',
        'PDUSessionResourceSetupItemCxtRes-ExtIEs',
        'PDUSessionResourceSetupListHOReq',
        'PDUSessionResourceSetupItemHOReq',
        'PDUSessionResourceSetupItemHOReq-ExtIEs',
        'PDUSessionResourceSetupListSUReq',
        'PDUSessionResourceSetupItemSUReq',
        'PDUSessionResourceSetupItemSUReq-ExtIEs',
        'PDUSessionResourceSetupListSURes',
        'PDUSessionResourceSetupItemSURes',
        'PDUSessionResourceSetupItemSURes-ExtIEs',
        'PDUSessionResourceSetupRequestTransfer',
        'PDUSessionResourceSetupRequestTransferIEs',
        'PDUSessionResourceSetupResponseTransfer',
        'PDUSessionResourceSetupResponseTransfer-ExtIEs',
        'PDUSessionResourceSetupUnsuccessfulTransfer',
        'PDUSessionResourceSetupUnsuccessfulTransfer-ExtIEs',
        'PDUSessionResourceSuspendListSUSReq',
        'PDUSessionResourceSuspendItemSUSReq',
        'PDUSessionResourceSuspendItemSUSReq-ExtIEs',
        'PDUSessionResourceSwitchedList',
        'PDUSessionResourceSwitchedItem',
        'PDUSessionResourceSwitchedItem-ExtIEs',
        'PDUSessionResourceToBeSwitchedDLList',
        'PDUSessionResourceToBeSwitchedDLItem',
        'PDUSessionResourceToBeSwitchedDLItem-ExtIEs',
        'PDUSessionResourceToReleaseListHOCmd',
        'PDUSessionResourceToReleaseItemHOCmd',
        'PDUSessionResourceToReleaseItemHOCmd-ExtIEs',
        'PDUSessionResourceToReleaseListRelCmd',
        'PDUSessionResourceToReleaseItemRelCmd',
        'PDUSessionResourceToReleaseItemRelCmd-ExtIEs',
        'PDUSessionType',
        'PDUSessionUsageReport',
        'PDUSessionUsageReport-ExtIEs',
        'PEIPSassistanceInformation',
        'PEIPSassistanceInformation-ExtIEs',
        'Periodicity',
        'PeriodicRegistrationUpdateTimer',
        'PLMNIdentity',
        'PLMNAreaBasedQMC',
        'PLMNAreaBasedQMC-ExtIEs',
        'PLMNListforQMC',
        'PLMNSupportList',
        'PLMNSupportItem',
        'PLMNSupportItem-ExtIEs',
        'PNI-NPN-MobilityInformation',
        'PNI-NPN-MobilityInformation-ExtIEs',
        'PortNumber',
        'Pre-emptionCapability',
        'Pre-emptionVulnerability',
        'PriorityLevelARP',
        'PriorityLevelQos',
        'PWSFailedCellIDList',
        'PWSFailedCellIDList-ExtIEs',
        'QMCConfigInfo',
        'QMCConfigInfo-ExtIEs',
        'QMCDeactivation',
        'QMCDeactivation-ExtIEs',
        'QoEReferenceList',
        'QoEReference',
        'QosCharacteristics',
        'QosCharacteristics-ExtIEs',
        'QosFlowAcceptedList',
        'QosFlowAcceptedItem',
        'QosFlowAcceptedItem-ExtIEs',
        'QosFlowAddOrModifyRequestList',
        'QosFlowAddOrModifyRequestItem',
        'QosFlowAddOrModifyRequestItem-ExtIEs',
        'QosFlowAddOrModifyResponseList',
        'QosFlowAddOrModifyResponseItem',
        'QosFlowAddOrModifyResponseItem-ExtIEs',
        'QosFlowFeedbackList',
        'QosFlowFeedbackItem',
        'QosFlowFeedbackItem-ExtIEs',
        'QosFlowIdentifier',
        'QosFlowInformationList',
        'QosFlowInformationItem',
        'QosFlowInformationItem-ExtIEs',
        'QosFlowLevelQosParameters',
        'QosFlowLevelQosParameters-ExtIEs',
        'QosMonitoringRequest',
        'QosMonitoringReportingFrequency',
        'QoSFlowList',
        'QosFlowListWithCause',
        'QosFlowWithCauseItem',
        'QosFlowWithCauseItem-ExtIEs',
        'QosFlowModifyConfirmList',
        'QosFlowModifyConfirmItem',
        'QosFlowModifyConfirmItem-ExtIEs',
        'QosFlowNotifyList',
        'QosFlowNotifyItem',
        'QosFlowNotifyItem-ExtIEs',
        'QosFlowParametersList',
        'QosFlowParametersItem',
        'QosFlowParametersItem-ExtIEs',
        'QosFlowPerTNLInformation',
        'QosFlowPerTNLInformation-ExtIEs',
        'QosFlowPerTNLInformationList',
        'QosFlowPerTNLInformationItem',
        'QosFlowPerTNLInformationItem-ExtIEs',
        'QosFlowSetupRequestList',
        'QosFlowSetupRequestItem',
        'QosFlowSetupRequestItem-ExtIEs',
        'QosFlowListWithDataForwarding',
        'QosFlowItemWithDataForwarding',
        'QosFlowItemWithDataForwarding-ExtIEs',
        'QosFlowToBeForwardedList',
        'QosFlowToBeForwardedItem',
        'QosFlowToBeForwardedItem-ExtIEs',
        'QoSFlowsUsageReportList',
        'QoSFlowsUsageReport-Item',
        'QoSFlowsUsageReport-Item-ExtIEs',
        'Range',
        'RANNodeName',
        'RANNodeNameVisibleString',
        'RANNodeNameUTF8String',
        'RANPagingPriority',
        'RANStatusTransfer-TransparentContainer',
        'RANStatusTransfer-TransparentContainer-ExtIEs',
        'RAN-UE-NGAP-ID',
        'RAT-Information',
        'RATRestrictions',
        'RATRestrictions-Item',
        'RATRestrictions-Item-ExtIEs',
        'RATRestrictionInformation',
        'RecommendedCellsForPaging',
        'RecommendedCellsForPaging-ExtIEs',
        'RecommendedCellList',
        'RecommendedCellItem',
        'RecommendedCellItem-ExtIEs',
        'RecommendedRANNodesForPaging',
        'RecommendedRANNodesForPaging-ExtIEs',
        'RecommendedRANNodeList',
        'RecommendedRANNodeItem',
        'RecommendedRANNodeItem-ExtIEs',
        'RedCapIndication',
        'RedirectionVoiceFallback',
        'RedundantPDUSessionInformation',
        'RedundantPDUSessionInformation-ExtIEs',
        'RedundantQosFlowIndicator',
        'ReflectiveQosAttribute',
        'RelativeAMFCapacity',
        'ReportArea',
        'RepetitionPeriod',
        'ResetAll',
        'ReportAmountMDT',
        'ReportIntervalMDT',
        'ExtendedReportIntervalMDT',
        'ResetType',
        'ResetType-ExtIEs',
        'RGLevelWirelineAccessCharacteristics',
        'RNC-ID',
        'RoutingID',
        'RRCContainer',
        'RRCEstablishmentCause',
        'RRCInactiveTransitionReportRequest',
        'RRCState',
        'RSN',
        'RIMInformationTransfer',
        'RIMInformationTransfer-ExtIEs',
        'RIMInformation',
        'RIMInformation-ExtIEs',
        'GNBSetID',
        'ScheduledCommunicationTime',
        'ScheduledCommunicationTime-ExtIEs',
        'SCTP-TLAs',
        'SD',
        'SecondaryRATUsageInformation',
        'SecondaryRATUsageInformation-ExtIEs',
        'SecondaryRATDataUsageReportTransfer',
        'SecondaryRATDataUsageReportTransfer-ExtIEs',
        'SecurityContext',
        'SecurityContext-ExtIEs',
        'SecurityIndication',
        'SecurityIndication-ExtIEs',
        'SecurityKey',
        'SecurityResult',
        'SecurityResult-ExtIEs',
        'SensorMeasurementConfiguration',
        'SensorMeasurementConfiguration-ExtIEs',
        'SensorMeasConfigNameList',
        'SensorMeasConfigNameItem',
        'SensorMeasConfigNameItem-ExtIEs',
        'SensorMeasConfig',
        'SensorNameConfig',
        'SensorNameConfig-ExtIEs',
        'SerialNumber',
        'ServedGUAMIList',
        'ServedGUAMIItem',
        'ServedGUAMIItem-ExtIEs',
        'ServiceAreaInformation',
        'ServiceAreaInformation-Item',
        'ServiceAreaInformation-Item-ExtIEs',
        'ServiceType',
        'SgNB-UE-X2AP-ID',
        'SharedNGU-MulticastTNLInformation',
        'SharedNGU-MulticastTNLInformation-ExtIEs',
        'SliceOverloadList',
        'SliceOverloadItem',
        'SliceOverloadItem-ExtIEs',
        'SliceSupportList',
        'SliceSupportItem',
        'SliceSupportItem-ExtIEs',
        'SliceSupportListQMC',
        'SliceSupportQMC-Item',
        'SliceSupportQMC-Item-ExtIEs',
        'SNPN-MobilityInformation',
        'SNPN-MobilityInformation-ExtIEs',
        'S-NSSAI',
        'S-NSSAI-ExtIEs',
        'SONConfigurationTransfer',
        'SONConfigurationTransfer-ExtIEs',
        'SONInformation',
        'SONInformation-ExtIEs',
        'SONInformationReply',
        'SONInformationReply-ExtIEs',
        'SONInformationReport',
        'SONInformationReport-ExtIEs',
        'SuccessfulHandoverReportList',
        'SuccessfulHandoverReport-Item',
        'SuccessfulHandoverReport-Item-ExtIEs',
        'SONInformationRequest',
        'SourceNGRANNode-ToTargetNGRANNode-TransparentContainer',
        'SourceNGRANNode-ToTargetNGRANNode-TransparentContainer-ExtIEs',
        'SourceNodeID',
        'SourceNodeID-ExtIEs',
        'SourceOfUEActivityBehaviourInformation',
        'SourceRANNodeID',
        'SourceRANNodeID-ExtIEs',
        'SourceToTarget-TransparentContainer',
        'SourceToTarget-AMFInformationReroute',
        'SourceToTarget-AMFInformationReroute-ExtIEs',
        'SRVCCOperationPossible',
        'ConfiguredNSSAI',
        'RejectedNSSAIinPLMN',
        'RejectedNSSAIinTA',
        'SST',
        'SupportedTAList',
        'SupportedTAItem',
        'SupportedTAItem-ExtIEs',
        'SuspendIndicator',
        'Suspend-Request-Indication',
        'Suspend-Response-Indication',
        'SurvivalTime',
        'TAC',
        'TACListInNRNTN',
        'TAI',
        'TAI-ExtIEs',
        'TAIBroadcastEUTRA',
        'TAIBroadcastEUTRA-Item',
        'TAIBroadcastEUTRA-Item-ExtIEs',
        'TAIBroadcastNR',
        'TAIBroadcastNR-Item',
        'TAIBroadcastNR-Item-ExtIEs',
        'TAICancelledEUTRA',
        'TAICancelledEUTRA-Item',
        'TAICancelledEUTRA-Item-ExtIEs',
        'TAICancelledNR',
        'TAICancelledNR-Item',
        'TAICancelledNR-Item-ExtIEs',
        'TAIListForInactive',
        'TAIListForInactiveItem',
        'TAIListForInactiveItem-ExtIEs',
        'TAIListForPaging',
        'TAIListForPagingItem',
        'TAIListForPagingItem-ExtIEs',
        'TAIListForRestart',
        'TAIListForWarning',
        'TAINSAGSupportList',
        'TAINSAGSupportItem',
        'TAINSAGSupportItem-ExtIEs',
        'TargeteNB-ID',
        'TargeteNB-ID-ExtIEs',
        'TargetHomeENB-ID',
        'TargetHomeENB-ID-ExtIEs',
        'TargetID',
        'TargetID-ExtIEs',
        'TargetNGRANNode-ToSourceNGRANNode-TransparentContainer',
        'TargetNGRANNode-ToSourceNGRANNode-TransparentContainer-ExtIEs',
        'TargetNGRANNode-ToSourceNGRANNode-FailureTransparentContainer',
        'TargetNGRANNode-ToSourceNGRANNode-FailureTransparentContainer-ExtIEs',
        'TargetNSSAI',
        'TargetNSSAI-Item',
        'TargetNSSAI-Item-ExtIEs',
        'TargetNSSAIInformation',
        'TargetNSSAIInformation-Item-ExtIEs',
        'TargetRANNodeID',
        'TargetRANNodeID-ExtIEs',
        'TargetRANNodeID-RIM',
        'TargetRANNodeID-RIM-ExtIEs',
        'TargetRANNodeID-SON',
        'TargetRANNodeID-SON-ExtIEs',
        'TargetRNC-ID',
        'TargetRNC-ID-ExtIEs',
        'TargetToSource-TransparentContainer',
        'TargettoSource-Failure-TransparentContainer',
        'TimerApproachForGUAMIRemoval',
        'TimeStamp',
        'TimeSyncAssistanceInfo',
        'TimeSyncAssistanceInfo-ExtIEs',
        'TimeToWait',
        'TimeUEStayedInCell',
        'TimeUEStayedInCellEnhancedGranularity',
        'TMGI',
        'TNAP-ID',
        'TNGF-ID',
        'TNGF-ID-ExtIEs',
        'TNLAddressWeightFactor',
        'TNLAssociationList',
        'TNLAssociationItem',
        'TNLAssociationItem-ExtIEs',
        'TNLAssociationUsage',
        'TooearlyIntersystemHO',
        'TooearlyIntersystemHO-ExtIEs',
        'TraceActivation',
        'TraceActivation-ExtIEs',
        'TraceDepth',
        'TrafficLoadReductionIndication',
        'TransportLayerAddress',
        'TypeOfError',
        'TAIBasedMDT',
        'TAIBasedMDT-ExtIEs',
        'TAIListforMDT',
        'TAIBasedQMC',
        'TAIBasedQMC-ExtIEs',
        'TAIListforQMC',
        'TABasedQMC',
        'TABasedQMC-ExtIEs',
        'TAListforQMC',
        'TABasedMDT',
        'TABasedMDT-ExtIEs',
        'TAListforMDT',
        'Threshold-RSRP',
        'Threshold-RSRQ',
        'Threshold-SINR',
        'TimeToTrigger',
        'TWAP-ID',
        'TWIF-ID',
        'TWIF-ID-ExtIEs',
        'TSCAssistanceInformation',
        'TSCAssistanceInformation-ExtIEs',
        'TSCTrafficCharacteristics',
        'TSCTrafficCharacteristics-ExtIEs',
        'UEAggregateMaximumBitRate',
        'UEAggregateMaximumBitRate-ExtIEs',
        'UEAppLayerMeasInfoList',
        'UEAppLayerMeasInfoItem',
        'UEAppLayerMeasInfoItem-ExtIEs',
        'UEAppLayerMeasConfigInfo',
        'UEAppLayerMeasConfigInfo-ExtIEs',
        'UE-associatedLogicalNG-connectionList',
        'UE-associatedLogicalNG-connectionItem',
        'UE-associatedLogicalNG-connectionItem-ExtIEs',
        'UECapabilityInfoRequest',
        'UEContextRequest',
        'UEContextResumeRequestTransfer',
        'UEContextResumeRequestTransfer-ExtIEs',
        'UEContextResumeResponseTransfer',
        'UEContextResumeResponseTransfer-ExtIEs',
        'UEContextSuspendRequestTransfer',
        'UEContextSuspendRequestTransfer-ExtIEs',
        'UE-DifferentiationInfo',
        'UE-DifferentiationInfo-ExtIEs',
        'UEHistoryInformation',
        'UEHistoryInformationFromTheUE',
        'UEHistoryInformationFromTheUE-ExtIEs',
        'UEIdentityIndexValue',
        'UEIdentityIndexValue-ExtIEs',
        'UE-NGAP-IDs',
        'UE-NGAP-IDs-ExtIEs',
        'UE-NGAP-ID-pair',
        'UE-NGAP-ID-pair-ExtIEs',
        'UEPagingIdentity',
        'UEPagingIdentity-ExtIEs',
        'UEPresence',
        'UEPresenceInAreaOfInterestList',
        'UEPresenceInAreaOfInterestItem',
        'UEPresenceInAreaOfInterestItem-ExtIEs',
        'UERadioCapability',
        'UERadioCapabilityForPaging',
        'UERadioCapabilityForPaging-ExtIEs',
        'UERadioCapabilityForPagingOfNB-IoT',
        'UERadioCapabilityForPagingOfNR',
        'UERadioCapabilityForPagingOfEUTRA',
        'UERadioCapabilityID',
        'UERetentionInformation',
        'UERLFReportContainer',
        'UERLFReportContainer-ExtIEs',
        'UESecurityCapabilities',
        'UESecurityCapabilities-ExtIEs',
        'UESliceMaximumBitRateList',
        'UESliceMaximumBitRateItem',
        'UESliceMaximumBitRateItem-ExtIEs',
        'UE-UP-CIoT-Support',
        'UL-CP-SecurityInformation',
        'UL-CP-SecurityInformation-ExtIEs',
        'UL-NAS-MAC',
        'UL-NAS-Count',
        'UL-NGU-UP-TNLModifyList',
        'UL-NGU-UP-TNLModifyItem',
        'UL-NGU-UP-TNLModifyItem-ExtIEs',
        'UnavailableGUAMIList',
        'UnavailableGUAMIItem',
        'UnavailableGUAMIItem-ExtIEs',
        'ULForwarding',
        'UpdateFeedback',
        'UPTransportLayerInformation',
        'UPTransportLayerInformation-ExtIEs',
        'UPTransportLayerInformationList',
        'UPTransportLayerInformationItem',
        'UPTransportLayerInformationItem-ExtIEs',
        'UPTransportLayerInformationPairList',
        'UPTransportLayerInformationPairItem',
        'UPTransportLayerInformationPairItem-ExtIEs',
        'URI-address',
        'UserLocationInformation',
        'UserLocationInformation-ExtIEs',
        'UserLocationInformationEUTRA',
        'UserLocationInformationEUTRA-ExtIEs',
        'UserLocationInformationN3IWF',
        'UserLocationInformationN3IWF-ExtIEs',
        'UserLocationInformationTNGF',
        'UserLocationInformationTNGF-ExtIEs',
        'UserLocationInformationTWIF',
        'UserLocationInformationTWIF-ExtIEs',
        'UserLocationInformationW-AGF',
        'UserLocationInformationW-AGF-ExtIEs',
        'UserLocationInformationNR',
        'UserLocationInformationNR-ExtIEs',
        'UserPlaneSecurityInformation',
        'UserPlaneSecurityInformation-ExtIEs',
        'VolumeTimedReportList',
        'VolumeTimedReport-Item',
        'VolumeTimedReport-Item-ExtIEs',
        'W-AGF-ID',
        'W-AGF-ID-ExtIEs',
        'WarningAreaCoordinates',
        'WarningAreaList',
        'WarningAreaList-ExtIEs',
        'WarningMessageContents',
        'WarningSecurityInfo',
        'WarningType',
        'WLANMeasurementConfiguration',
        'WLANMeasurementConfiguration-ExtIEs',
        'WLANMeasConfigNameList',
        'WLANMeasConfigNameItem',
        'WLANMeasConfigNameItem-ExtIEs',
        'WLANMeasConfig',
        'WLANName',
        'WUS-Assistance-Information',
        'WUS-Assistance-Information-ExtIEs',
        'XnExtTLAs',
        'XnExtTLA-Item',
        'XnExtTLA-Item-ExtIEs',
        'XnGTP-TLAs',
        'XnTLAs',
        'XnTNLConfigurationInfo',
        'XnTNLConfigurationInfo-ExtIEs',
        ]
    _type_ = [
        'AdditionalDLUPTNLInformationForHOList',
        'AdditionalDLUPTNLInformationForHOItem',
        'AdditionalQosFlowInformation',
        'AllocationAndRetentionPriority',
        'Allowed-CAG-List-per-PLMN',
        'AllowedNSSAI',
        'AllowedNSSAI-Item',
        'Allowed-PNI-NPN-List',
        'Allowed-PNI-NPN-Item',
        'AllowedTACs',
        'AlternativeQoSParaSetIndex',
        'AlternativeQoSParaSetNotifyIndex',
        'AlternativeQoSParaSetList',
        'AlternativeQoSParaSetItem',
        'AMFName',
        'AMFNameVisibleString',
        'AMFNameUTF8String',
        'AMFPagingTarget',
        'AMFPointer',
        'AMFRegionID',
        'AMFSetID',
        'AMF-TNLAssociationSetupList',
        'AMF-TNLAssociationSetupItem',
        'AMF-TNLAssociationToAddList',
        'AMF-TNLAssociationToAddItem',
        'AMF-TNLAssociationToRemoveList',
        'AMF-TNLAssociationToRemoveItem',
        'AMF-TNLAssociationToUpdateList',
        'AMF-TNLAssociationToUpdateItem',
        'AMF-UE-NGAP-ID',
        'AreaOfInterest',
        'AreaOfInterestCellList',
        'AreaOfInterestCellItem',
        'AreaOfInterestList',
        'AreaOfInterestItem',
        'AreaOfInterestRANNodeList',
        'AreaOfInterestRANNodeItem',
        'AreaOfInterestTAIList',
        'AreaOfInterestTAIItem',
        'AssistanceDataForPaging',
        'AssistanceDataForRecommendedCells',
        'AssociatedMBSQosFlowSetupRequestList',
        'AssociatedMBSQosFlowSetupRequestItem',
        'AssociatedMBSQosFlowSetuporModifyRequestList',
        'AssociatedMBSQosFlowSetuporModifyRequestItem',
        'AssociatedQosFlowList',
        'AssociatedQosFlowItem',
        'AuthenticatedIndication',
        'AveragingWindow',
        'AreaScopeOfMDT-NR',
        'AreaScopeOfMDT-EUTRA',
        'AreaScopeOfNeighCellsList',
        'AreaScopeOfNeighCellsItem',
        'AreaScopeOfQMC',
        'AvailableRANVisibleQoEMetrics',
        'BeamMeasurementsReportConfiguration',
        'BeamMeasurementsReportQuantity',
        'BitRate',
        'BroadcastCancelledAreaList',
        'BroadcastCompletedAreaList',
        'BroadcastPLMNList',
        'BroadcastPLMNItem',
        'BluetoothMeasurementConfiguration',
        'BluetoothMeasConfigNameList',
        'BluetoothMeasConfigNameItem',
        'BluetoothMeasConfig',
        'BluetoothName',
        'BurstArrivalTime',
        'CAG-ID',
        'CancelAllWarningMessages',
        'CancelledCellsInEAI-EUTRA',
        'CancelledCellsInEAI-EUTRA-Item',
        'CancelledCellsInEAI-NR',
        'CancelledCellsInEAI-NR-Item',
        'CancelledCellsInTAI-EUTRA',
        'CancelledCellsInTAI-EUTRA-Item',
        'CancelledCellsInTAI-NR',
        'CancelledCellsInTAI-NR-Item',
        'CandidateCellList',
        'CandidateCellItem',
        'CandidateCell',
        'CandidateCellID',
        'CandidatePCI',
        'Cause',
        'CauseMisc',
        'CauseNas',
        'CauseProtocol',
        'CauseRadioNetwork',
        'CauseTransport',
        'Cell-CAGInformation',
        'CellCAGList',
        'CellIDBroadcastEUTRA',
        'CellIDBroadcastEUTRA-Item',
        'CellIDBroadcastNR',
        'CellIDBroadcastNR-Item',
        'CellIDCancelledEUTRA',
        'CellIDCancelledEUTRA-Item',
        'CellIDCancelledNR',
        'CellIDCancelledNR-Item',
        'CellIDListForRestart',
        'CellSize',
        'CellType',
        'CEmodeBSupport-Indicator',
        'CEmodeBrestricted',
        'CNAssistedRANTuning',
        'CNsubgroupID',
        'CNTypeRestrictionsForEquivalent',
        'CNTypeRestrictionsForEquivalentItem',
        'CNTypeRestrictionsForServing',
        'CommonNetworkInstance',
        'CompletedCellsInEAI-EUTRA',
        'CompletedCellsInEAI-EUTRA-Item',
        'CompletedCellsInEAI-NR',
        'CompletedCellsInEAI-NR-Item',
        'CompletedCellsInTAI-EUTRA',
        'CompletedCellsInTAI-EUTRA-Item',
        'CompletedCellsInTAI-NR',
        'CompletedCellsInTAI-NR-Item',
        'ConcurrentWarningMessageInd',
        'ConfidentialityProtectionIndication',
        'ConfidentialityProtectionResult',
        'ConfiguredTACIndication',
        'CoreNetworkAssistanceInformationForInactive',
        'COUNTValueForPDCP-SN12',
        'COUNTValueForPDCP-SN18',
        'CoverageEnhancementLevel',
        'CPTransportLayerInformation',
        'CriticalityDiagnostics',
        'CriticalityDiagnostics-IE-List',
        'CriticalityDiagnostics-IE-Item',
        'CellBasedMDT-NR',
        'CellIdListforMDT-NR',
        'CellBasedMDT-EUTRA',
        'CellBasedQMC',
        'CellIdListforQMC',
        'CellIdListforMDT-EUTRA',
        'DataCodingScheme',
        'DataForwardingAccepted',
        'DataForwardingNotPossible',
        'DataForwardingResponseDRBList',
        'DataForwardingResponseDRBItem',
        'DAPSRequestInfo',
        'DAPSResponseInfoList',
        'DAPSResponseInfoItem',
        'DAPSResponseInfo',
        'DataForwardingResponseERABList',
        'DataForwardingResponseERABListItem',
        'DelayCritical',
        'DL-CP-SecurityInformation',
        'DL-NAS-MAC',
        'DLForwarding',
        'DL-NGU-TNLInformationReused',
        'DirectForwardingPathAvailability',
        'DRB-ID',
        'DRBsSubjectToStatusTransferList',
        'DRBsSubjectToStatusTransferItem',
        'DRBStatusDL',
        'DRBStatusDL12',
        'DRBStatusDL18',
        'DRBStatusUL',
        'DRBStatusUL12',
        'DRBStatusUL18',
        'DRBsToQosFlowsMappingList',
        'DRBsToQosFlowsMappingItem',
        'Dynamic5QIDescriptor',
        'EarlyMeasurement',
        'EarlyStatusTransfer-TransparentContainer',
        'ProcedureStageChoice',
        'FirstDLCount',
        'DRBsSubjectToEarlyStatusTransfer-List',
        'DRBsSubjectToEarlyStatusTransfer-Item',
        'EDT-Session',
        'EmergencyAreaID',
        'EmergencyAreaIDBroadcastEUTRA',
        'EmergencyAreaIDBroadcastEUTRA-Item',
        'EmergencyAreaIDBroadcastNR',
        'EmergencyAreaIDBroadcastNR-Item',
        'EmergencyAreaIDCancelledEUTRA',
        'EmergencyAreaIDCancelledEUTRA-Item',
        'EmergencyAreaIDCancelledNR',
        'EmergencyAreaIDCancelledNR-Item',
        'EmergencyAreaIDList',
        'EmergencyAreaIDListForRestart',
        'EmergencyFallbackIndicator',
        'EmergencyFallbackRequestIndicator',
        'EmergencyServiceTargetCN',
        'ENB-ID',
        'Enhanced-CoverageRestriction',
        'Extended-ConnectedTime',
        'EN-DCSONConfigurationTransfer',
        'EndpointIPAddressAndPort',
        'EndIndication',
        'EquivalentPLMNs',
        'EPS-TAC',
        'EPS-TAI',
        'E-RAB-ID',
        'E-RABInformationList',
        'E-RABInformationItem',
        'EUTRACellIdentity',
        'EUTRA-CGI',
        'EUTRA-CGIList',
        'EUTRA-CGIListForWarning',
        'EUTRA-PagingeDRXInformation',
        'EUTRA-Paging-eDRX-Cycle',
        'EUTRA-Paging-Time-Window',
        'EUTRAencryptionAlgorithms',
        'EUTRAintegrityProtectionAlgorithms',
        'EventType',
        'ExcessPacketDelayThresholdConfiguration',
        'ExcessPacketDelayThresholdItem',
        'ExcessPacketDelayThresholdValue',
        'ExpectedActivityPeriod',
        'ExpectedHOInterval',
        'ExpectedIdlePeriod',
        'ExpectedUEActivityBehaviour',
        'ExpectedUEBehaviour',
        'ExpectedUEMobility',
        'ExpectedUEMovingTrajectory',
        'ExpectedUEMovingTrajectoryItem',
        'Extended-AMFName',
        'ExtendedPacketDelayBudget',
        'Extended-RANNodeName',
        'ExtendedRATRestrictionInformation',
        'ExtendedRNC-ID',
        'ExtendedSliceSupportList',
        'ExtendedUEIdentityIndexValue',
        'EventTrigger',
        'EventL1LoggedMDTConfig',
        'MeasurementThresholdL1LoggedMDT',
        'FailureIndication',
        'FiveG-ProSeAuthorized',
        'FiveGProSeDirectDiscovery',
        'FiveGProSeDirectCommunication',
        'FiveGProSeLayer2UEtoNetworkRelay',
        'FiveGProSeLayer3UEtoNetworkRelay',
        'FiveGProSeLayer2RemoteUE',
        'FiveG-ProSePC5QoSParameters',
        'FiveGProSePC5QoSFlowList',
        'FiveGProSePC5QoSFlowItem',
        'FiveGProSePC5FlowBitRates',
        'FiveG-S-TMSI',
        'FiveG-TMSI',
        'FiveQI',
        'ForbiddenAreaInformation',
        'ForbiddenAreaInformation-Item',
        'ForbiddenTACs',
        'FromEUTRANtoNGRAN',
        'FromNGRANtoEUTRAN',
        'GBR-QosInformation',
        'GlobalCable-ID',
        'GlobalCable-ID-new',
        'GlobalENB-ID',
        'GlobalGNB-ID',
        'GlobalN3IWF-ID',
        'GlobalLine-ID',
        'GlobalLineIdentity',
        'GlobalNgENB-ID',
        'GlobalRANNodeID',
        'GlobalTNGF-ID',
        'GlobalTWIF-ID',
        'GlobalW-AGF-ID',
        'GNB-ID',
        'GTP-TEID',
        'GTPTunnel',
        'GUAMI',
        'GUAMIType',
        'HandoverCommandTransfer',
        'HandoverFlag',
        'HandoverPreparationUnsuccessfulTransfer',
        'HandoverRequestAcknowledgeTransfer',
        'HandoverRequiredTransfer',
        'HandoverResourceAllocationUnsuccessfulTransfer',
        'HandoverType',
        'HFCNode-ID',
        'HFCNode-ID-new',
        'HOReport',
        'Hysteresis',
        'IAB-Authorized',
        'IAB-Supported',
        'IABNodeIndication',
        'IMSVoiceSupportIndicator',
        'IndexToRFSP',
        'InfoOnRecommendedCellsAndRANNodesForPaging',
        'IntegrityProtectionIndication',
        'IntegrityProtectionResult',
        'IntendedNumberOfPagingAttempts',
        'InterfacesToTrace',
        'ImmediateMDTNr',
        'InterSystemFailureIndication',
        'IntersystemSONConfigurationTransfer',
        'IntersystemSONTransferType',
        'IntersystemSONeNBID',
        'IntersystemSONNGRANnodeID',
        'IntersystemSONInformation',
        'IntersystemSONInformationRequest',
        'IntersystemCellActivationRequest',
        'CellsToActivateList',
        'IntersystemResourceStatusRequest',
        'ReportingSystem',
        'EUTRAN-ReportingSystemIEs',
        'NGRAN-ReportingSystemIEs',
        'EUTRAN-CellToReportList',
        'EUTRAN-CellToReportItem',
        'NGRAN-CellToReportList',
        'NGRAN-CellToReportItem',
        'ReportCharacteristics',
        'ReportType',
        'EventBasedReportingIEs',
        'IntersystemResourceThreshold',
        'NumberOfMeasurementReportingLevels',
        'PeriodicReportingIEs',
        'ReportingPeriodicity',
        'IntersystemSONInformationReply',
        'IntersystemCellActivationReply',
        'ActivatedCellList',
        'IntersystemResourceStatusReply',
        'IntersystemSONInformationReport',
        'IntersystemCellStateIndication',
        'NotificationCellList',
        'NotificationCell-Item',
        'IntersystemResourceStatusReport',
        'ResourceStatusReportingSystem',
        'EUTRAN-ReportingStatusIEs',
        'EUTRAN-CellReportList',
        'EUTRAN-CellReportItem',
        'EUTRAN-CompositeAvailableCapacityGroup',
        'CompositeAvailableCapacity',
        'EUTRAN-NumberOfActiveUEs',
        'EUTRAN-RadioResourceStatus',
        'NGRAN-ReportingStatusIEs',
        'NGRAN-CellReportList',
        'NGRAN-CellReportItem',
        'NGRAN-NumberOfActiveUEs',
        'NGRAN-NoofRRCConnections',
        'NGRAN-RadioResourceStatus',
        'InterSystemHOReport',
        'InterSystemHandoverReportType',
        'IntersystemUnnecessaryHO',
        'LAC',
        'LAI',
        'LastVisitedCellInformation',
        'LastVisitedCellItem',
        'LastVisitedEUTRANCellInformation',
        'LastVisitedGERANCellInformation',
        'LastVisitedNGRANCellInformation',
        'LastVisitedPSCellList',
        'LastVisitedPSCellInformation',
        'LastVisitedUTRANCellInformation',
        'LineType',
        'LocationReportingAdditionalInfo',
        'LocationReportingReferenceID',
        'LocationReportingRequestType',
        'LoggedMDTNr',
        'LoggingInterval',
        'LoggingDuration',
        'Links-to-log',
        'LoggedMDTTrigger',
        'LTEM-Indication',
        'LTEUERLFReportContainer',
        'LTEV2XServicesAuthorized',
        'LTEUESidelinkAggregateMaximumBitrate',
        'MaskedIMEISV',
        'MaximumDataBurstVolume',
        'MessageIdentifier',
        'MaximumIntegrityProtectedDataRate',
        'MBS-AreaSessionID',
        'MBS-DataForwardingResponseMRBList',
        'MBS-DataForwardingResponseMRBItem',
        'MBS-MappingandDataForwardingRequestList',
        'MBS-MappingandDataForwardingRequestItem',
        'MBS-QoSFlowList',
        'MRB-ProgressInformation',
        'MBS-QoSFlowsToBeSetupList',
        'MBS-QoSFlowsToBeSetupItem',
        'MBS-ServiceArea',
        'MBS-ServiceAreaInformationList',
        'MBS-ServiceAreaInformationItem',
        'MBS-ServiceAreaInformation',
        'MBS-ServiceAreaCellList',
        'MBS-ServiceAreaTAIList',
        'MBS-SessionID',
        'MBSSessionFailedtoSetupList',
        'MBSSessionFailedtoSetupItem',
        'MBS-ActiveSessionInformation-SourcetoTargetList',
        'MBS-ActiveSessionInformation-SourcetoTargetItem',
        'MBS-ActiveSessionInformation-TargettoSourceList',
        'MBS-ActiveSessionInformation-TargettoSourceItem',
        'MBSSessionSetupOrModFailureTransfer',
        'MBSSessionSetupResponseList',
        'MBSSessionSetupResponseItem',
        'MBSSessionSetupOrModRequestTransfer',
        'MBS-SessionFSAIDList',
        'MBS-SessionFSAID',
        'MBSSessionReleaseResponseTransfer',
        'MBSSessionSetupOrModResponseTransfer',
        'MBS-SupportIndicator',
        'MBS-SessionTNLInfo5GC',
        'MBS-SessionTNLInfo5GCList',
        'MBS-SessionTNLInfo5GCItem',
        'MBS-SessionTNLInfoNGRAN',
        'MBS-SessionTNLInfoNGRANList',
        'MBS-SessionTNLInfoNGRANItem',
        'MBS-DistributionReleaseRequestTransfer',
        'MBS-DistributionSetupRequestTransfer',
        'MBS-DistributionSetupResponseTransfer',
        'MBS-DistributionSetupUnsuccessfulTransfer',
        'MBSSessionSetupRequestList',
        'MBSSessionSetupRequestItem',
        'MBSSessionSetuporModifyRequestList',
        'MBSSessionSetuporModifyRequestItem',
        'MBSSessionToReleaseList',
        'MBSSessionToReleaseItem',
        'MBSSessionStatus',
        'MicoAllPLMN',
        'MICOModeIndication',
        'MobilityInformation',
        'MobilityRestrictionList',
        'MDT-AlignmentInfo',
        'MDTPLMNList',
        'MDTPLMNModificationList',
        'MDT-Configuration',
        'MDT-Configuration-NR',
        'MDT-Configuration-EUTRA',
        'MDT-Activation',
        'MDTModeNr',
        'MDTModeEutra',
        'MeasurementsToActivate',
        'MRB-ID',
        'MulticastSessionActivationRequestTransfer',
        'MulticastSessionDeactivationRequestTransfer',
        'MulticastSessionUpdateRequestTransfer',
        'MulticastGroupPagingAreaList',
        'MulticastGroupPagingAreaItem',
        'MBS-AreaTAIList',
        'MulticastGroupPagingArea',
        'UE-PagingList',
        'UE-PagingItem',
        'M1Configuration',
        'IncludeBeamMeasurementsIndication',
        'MaxNrofRS-IndexesToReport',
        'M1ReportingTrigger',
        'M1ThresholdEventA2',
        'M1ThresholdType',
        'M1PeriodicReporting',
        'M4Configuration',
        'M4ReportAmountMDT',
        'M4period',
        'M5Configuration',
        'M5ReportAmountMDT',
        'M5period',
        'M6Configuration',
        'M6ReportAmountMDT',
        'M6report-Interval',
        'M7Configuration',
        'M7ReportAmountMDT',
        'M7period',
        'MDT-Location-Info',
        'MDT-Location-Information',
        'N3IWF-ID',
        'NAS-PDU',
        'NASSecurityParametersFromNGRAN',
        'NB-IoT-DefaultPagingDRX',
        'NB-IoT-PagingDRX',
        'NB-IoT-Paging-eDRXCycle',
        'NB-IoT-Paging-TimeWindow',
        'NB-IoT-Paging-eDRXInfo',
        'NB-IoT-UEPriority',
        'NetworkInstance',
        'NewSecurityContextInd',
        'NextHopChainingCount',
        'NextPagingAreaScope',
        'NGAPIESupportInformationRequestList',
        'NGAPIESupportInformationRequestItem',
        'NGAPIESupportInformationResponseList',
        'NGAPIESupportInformationResponseItem',
        'NgENB-ID',
        'NotifySourceNGRANNode',
        'NGRAN-CGI',
        'NGRAN-TNLAssociationToRemoveList',
        'NGRAN-TNLAssociationToRemoveItem',
        'NGRANTraceID',
        'NID',
        'NonDynamic5QIDescriptor',
        'NotAllowedTACs',
        'NotificationCause',
        'NotificationControl',
        'NPN-AccessInformation',
        'NPN-MobilityInformation',
        'NPN-PagingAssistanceInformation',
        'NPN-Support',
        'NRCellIdentity',
        'NR-CGI',
        'NR-CGIList',
        'NR-CGIListForWarning',
        'NR-PagingeDRXInformation',
        'NR-Paging-eDRX-Cycle',
        'NR-Paging-Time-Window',
        'NRencryptionAlgorithms',
        'NRintegrityProtectionAlgorithms',
        'NRMobilityHistoryReport',
        'NRPPa-PDU',
        'NRUERLFReportContainer',
        'NRNTNTAIInformation',
        'NumberOfBroadcasts',
        'NumberOfBroadcastsRequested',
        'NRARFCN',
        'NRFrequencyBand',
        'NRFrequencyBand-List',
        'NRFrequencyBandItem',
        'NRFrequencyInfo',
        'NR-PCI',
        'NRV2XServicesAuthorized',
        'VehicleUE',
        'PedestrianUE',
        'NRUESidelinkAggregateMaximumBitrate',
        'NSAG-ID',
        'OnboardingSupport',
        'OverloadAction',
        'OverloadResponse',
        'OverloadStartNSSAIList',
        'OverloadStartNSSAIItem',
        'PacketDelayBudget',
        'PacketErrorRate',
        'PacketLossRate',
        'PagingAssisDataforCEcapabUE',
        'PagingAttemptInformation',
        'PagingAttemptCount',
        'PagingCause',
        'PagingCauseIndicationForVoiceService',
        'PagingDRX',
        'PagingOrigin',
        'PagingPriority',
        'PagingProbabilityInformation',
        'PathSwitchRequestAcknowledgeTransfer',
        'PathSwitchRequestSetupFailedTransfer',
        'PathSwitchRequestTransfer',
        'PathSwitchRequestUnsuccessfulTransfer',
        'PC5QoSParameters',
        'PC5QoSFlowList',
        'PC5QoSFlowItem',
        'PC5FlowBitRates',
        'PCIListForMDT',
        'PrivacyIndicator',
        'PDUSessionAggregateMaximumBitRate',
        'PDUSessionID',
        'PDUSessionPairID',
        'PDUSessionResourceAdmittedList',
        'PDUSessionResourceAdmittedItem',
        'PDUSessionResourceFailedToModifyListModCfm',
        'PDUSessionResourceFailedToModifyItemModCfm',
        'PDUSessionResourceFailedToModifyListModRes',
        'PDUSessionResourceFailedToModifyItemModRes',
        'PDUSessionResourceFailedToResumeListRESReq',
        'PDUSessionResourceFailedToResumeItemRESReq',
        'PDUSessionResourceFailedToResumeListRESRes',
        'PDUSessionResourceFailedToResumeItemRESRes',
        'PDUSessionResourceFailedToSetupListCxtFail',
        'PDUSessionResourceFailedToSetupItemCxtFail',
        'PDUSessionResourceFailedToSetupListCxtRes',
        'PDUSessionResourceFailedToSetupItemCxtRes',
        'PDUSessionResourceFailedToSetupListHOAck',
        'PDUSessionResourceFailedToSetupItemHOAck',
        'PDUSessionResourceFailedToSetupListPSReq',
        'PDUSessionResourceFailedToSetupItemPSReq',
        'PDUSessionResourceFailedToSetupListSURes',
        'PDUSessionResourceFailedToSetupItemSURes',
        'PDUSessionResourceHandoverList',
        'PDUSessionResourceHandoverItem',
        'PDUSessionResourceInformationList',
        'PDUSessionResourceInformationItem',
        'PDUSessionResourceListCxtRelCpl',
        'PDUSessionResourceItemCxtRelCpl',
        'PDUSessionResourceListCxtRelReq',
        'PDUSessionResourceItemCxtRelReq',
        'PDUSessionResourceListHORqd',
        'PDUSessionResourceItemHORqd',
        'PDUSessionResourceModifyConfirmTransfer',
        'PDUSessionResourceModifyIndicationUnsuccessfulTransfer',
        'PDUSessionResourceModifyRequestTransfer',
        'PDUSessionResourceModifyResponseTransfer',
        'PDUSessionResourceModifyIndicationTransfer',
        'PDUSessionResourceModifyListModCfm',
        'PDUSessionResourceModifyItemModCfm',
        'PDUSessionResourceModifyListModInd',
        'PDUSessionResourceModifyItemModInd',
        'PDUSessionResourceModifyListModReq',
        'PDUSessionResourceModifyItemModReq',
        'PDUSessionResourceModifyListModRes',
        'PDUSessionResourceModifyItemModRes',
        'PDUSessionResourceModifyUnsuccessfulTransfer',
        'PDUSessionResourceNotifyList',
        'PDUSessionResourceNotifyItem',
        'PDUSessionResourceNotifyReleasedTransfer',
        'PDUSessionResourceNotifyTransfer',
        'PDUSessionResourceReleaseCommandTransfer',
        'PDUSessionResourceReleasedListNot',
        'PDUSessionResourceReleasedItemNot',
        'PDUSessionResourceReleasedListPSAck',
        'PDUSessionResourceReleasedItemPSAck',
        'PDUSessionResourceReleasedListPSFail',
        'PDUSessionResourceReleasedItemPSFail',
        'PDUSessionResourceReleasedListRelRes',
        'PDUSessionResourceReleasedItemRelRes',
        'PDUSessionResourceReleaseResponseTransfer',
        'PDUSessionResourceResumeListRESReq',
        'PDUSessionResourceResumeItemRESReq',
        'PDUSessionResourceResumeListRESRes',
        'PDUSessionResourceResumeItemRESRes',
        'PDUSessionResourceSecondaryRATUsageList',
        'PDUSessionResourceSecondaryRATUsageItem',
        'PDUSessionResourceSetupListCxtReq',
        'PDUSessionResourceSetupItemCxtReq',
        'PDUSessionResourceSetupListCxtRes',
        'PDUSessionResourceSetupItemCxtRes',
        'PDUSessionResourceSetupListHOReq',
        'PDUSessionResourceSetupItemHOReq',
        'PDUSessionResourceSetupListSUReq',
        'PDUSessionResourceSetupItemSUReq',
        'PDUSessionResourceSetupListSURes',
        'PDUSessionResourceSetupItemSURes',
        'PDUSessionResourceSetupRequestTransfer',
        'PDUSessionResourceSetupResponseTransfer',
        'PDUSessionResourceSetupUnsuccessfulTransfer',
        'PDUSessionResourceSuspendListSUSReq',
        'PDUSessionResourceSuspendItemSUSReq',
        'PDUSessionResourceSwitchedList',
        'PDUSessionResourceSwitchedItem',
        'PDUSessionResourceToBeSwitchedDLList',
        'PDUSessionResourceToBeSwitchedDLItem',
        'PDUSessionResourceToReleaseListHOCmd',
        'PDUSessionResourceToReleaseItemHOCmd',
        'PDUSessionResourceToReleaseListRelCmd',
        'PDUSessionResourceToReleaseItemRelCmd',
        'PDUSessionType',
        'PDUSessionUsageReport',
        'PEIPSassistanceInformation',
        'Periodicity',
        'PeriodicRegistrationUpdateTimer',
        'PLMNIdentity',
        'PLMNAreaBasedQMC',
        'PLMNListforQMC',
        'PLMNSupportList',
        'PLMNSupportItem',
        'PNI-NPN-MobilityInformation',
        'PortNumber',
        'Pre-emptionCapability',
        'Pre-emptionVulnerability',
        'PriorityLevelARP',
        'PriorityLevelQos',
        'PWSFailedCellIDList',
        'QMCConfigInfo',
        'QMCDeactivation',
        'QoEReferenceList',
        'QoEReference',
        'QosCharacteristics',
        'QosFlowAcceptedList',
        'QosFlowAcceptedItem',
        'QosFlowAddOrModifyRequestList',
        'QosFlowAddOrModifyRequestItem',
        'QosFlowAddOrModifyResponseList',
        'QosFlowAddOrModifyResponseItem',
        'QosFlowFeedbackList',
        'QosFlowFeedbackItem',
        'QosFlowIdentifier',
        'QosFlowInformationList',
        'QosFlowInformationItem',
        'QosFlowLevelQosParameters',
        'QosMonitoringRequest',
        'QosMonitoringReportingFrequency',
        'QoSFlowList',
        'QosFlowListWithCause',
        'QosFlowWithCauseItem',
        'QosFlowModifyConfirmList',
        'QosFlowModifyConfirmItem',
        'QosFlowNotifyList',
        'QosFlowNotifyItem',
        'QosFlowParametersList',
        'QosFlowParametersItem',
        'QosFlowPerTNLInformation',
        'QosFlowPerTNLInformationList',
        'QosFlowPerTNLInformationItem',
        'QosFlowSetupRequestList',
        'QosFlowSetupRequestItem',
        'QosFlowListWithDataForwarding',
        'QosFlowItemWithDataForwarding',
        'QosFlowToBeForwardedList',
        'QosFlowToBeForwardedItem',
        'QoSFlowsUsageReportList',
        'QoSFlowsUsageReport-Item',
        'Range',
        'RANNodeName',
        'RANNodeNameVisibleString',
        'RANNodeNameUTF8String',
        'RANPagingPriority',
        'RANStatusTransfer-TransparentContainer',
        'RAN-UE-NGAP-ID',
        'RAT-Information',
        'RATRestrictions',
        'RATRestrictions-Item',
        'RATRestrictionInformation',
        'RecommendedCellsForPaging',
        'RecommendedCellList',
        'RecommendedCellItem',
        'RecommendedRANNodesForPaging',
        'RecommendedRANNodeList',
        'RecommendedRANNodeItem',
        'RedCapIndication',
        'RedirectionVoiceFallback',
        'RedundantPDUSessionInformation',
        'RedundantQosFlowIndicator',
        'ReflectiveQosAttribute',
        'RelativeAMFCapacity',
        'ReportArea',
        'RepetitionPeriod',
        'ResetAll',
        'ReportAmountMDT',
        'ReportIntervalMDT',
        'ExtendedReportIntervalMDT',
        'ResetType',
        'RGLevelWirelineAccessCharacteristics',
        'RNC-ID',
        'RoutingID',
        'RRCContainer',
        'RRCEstablishmentCause',
        'RRCInactiveTransitionReportRequest',
        'RRCState',
        'RSN',
        'RIMInformationTransfer',
        'RIMInformation',
        'GNBSetID',
        'ScheduledCommunicationTime',
        'SCTP-TLAs',
        'SD',
        'SecondaryRATUsageInformation',
        'SecondaryRATDataUsageReportTransfer',
        'SecurityContext',
        'SecurityIndication',
        'SecurityKey',
        'SecurityResult',
        'SensorMeasurementConfiguration',
        'SensorMeasConfigNameList',
        'SensorMeasConfigNameItem',
        'SensorMeasConfig',
        'SensorNameConfig',
        'SerialNumber',
        'ServedGUAMIList',
        'ServedGUAMIItem',
        'ServiceAreaInformation',
        'ServiceAreaInformation-Item',
        'ServiceType',
        'SgNB-UE-X2AP-ID',
        'SharedNGU-MulticastTNLInformation',
        'SliceOverloadList',
        'SliceOverloadItem',
        'SliceSupportList',
        'SliceSupportItem',
        'SliceSupportListQMC',
        'SliceSupportQMC-Item',
        'SNPN-MobilityInformation',
        'S-NSSAI',
        'SONConfigurationTransfer',
        'SONInformation',
        'SONInformationReply',
        'SONInformationReport',
        'SuccessfulHandoverReportList',
        'SuccessfulHandoverReport-Item',
        'SONInformationRequest',
        'SourceNGRANNode-ToTargetNGRANNode-TransparentContainer',
        'SourceNodeID',
        'SourceOfUEActivityBehaviourInformation',
        'SourceRANNodeID',
        'SourceToTarget-TransparentContainer',
        'SourceToTarget-AMFInformationReroute',
        'SRVCCOperationPossible',
        'ConfiguredNSSAI',
        'RejectedNSSAIinPLMN',
        'RejectedNSSAIinTA',
        'SST',
        'SupportedTAList',
        'SupportedTAItem',
        'SuspendIndicator',
        'Suspend-Request-Indication',
        'Suspend-Response-Indication',
        'SurvivalTime',
        'TAC',
        'TACListInNRNTN',
        'TAI',
        'TAIBroadcastEUTRA',
        'TAIBroadcastEUTRA-Item',
        'TAIBroadcastNR',
        'TAIBroadcastNR-Item',
        'TAICancelledEUTRA',
        'TAICancelledEUTRA-Item',
        'TAICancelledNR',
        'TAICancelledNR-Item',
        'TAIListForInactive',
        'TAIListForInactiveItem',
        'TAIListForPaging',
        'TAIListForPagingItem',
        'TAIListForRestart',
        'TAIListForWarning',
        'TAINSAGSupportList',
        'TAINSAGSupportItem',
        'TargeteNB-ID',
        'TargetHomeENB-ID',
        'TargetID',
        'TargetNGRANNode-ToSourceNGRANNode-TransparentContainer',
        'TargetNGRANNode-ToSourceNGRANNode-FailureTransparentContainer',
        'TargetNSSAI',
        'TargetNSSAI-Item',
        'TargetNSSAIInformation',
        'TargetRANNodeID',
        'TargetRANNodeID-RIM',
        'TargetRANNodeID-SON',
        'TargetRNC-ID',
        'TargetToSource-TransparentContainer',
        'TargettoSource-Failure-TransparentContainer',
        'TimerApproachForGUAMIRemoval',
        'TimeStamp',
        'TimeSyncAssistanceInfo',
        'TimeToWait',
        'TimeUEStayedInCell',
        'TimeUEStayedInCellEnhancedGranularity',
        'TMGI',
        'TNAP-ID',
        'TNGF-ID',
        'TNLAddressWeightFactor',
        'TNLAssociationList',
        'TNLAssociationItem',
        'TNLAssociationUsage',
        'TooearlyIntersystemHO',
        'TraceActivation',
        'TraceDepth',
        'TrafficLoadReductionIndication',
        'TransportLayerAddress',
        'TypeOfError',
        'TAIBasedMDT',
        'TAIListforMDT',
        'TAIBasedQMC',
        'TAIListforQMC',
        'TABasedQMC',
        'TAListforQMC',
        'TABasedMDT',
        'TAListforMDT',
        'Threshold-RSRP',
        'Threshold-RSRQ',
        'Threshold-SINR',
        'TimeToTrigger',
        'TWAP-ID',
        'TWIF-ID',
        'TSCAssistanceInformation',
        'TSCTrafficCharacteristics',
        'UEAggregateMaximumBitRate',
        'UEAppLayerMeasInfoList',
        'UEAppLayerMeasInfoItem',
        'UEAppLayerMeasConfigInfo',
        'UE-associatedLogicalNG-connectionList',
        'UE-associatedLogicalNG-connectionItem',
        'UECapabilityInfoRequest',
        'UEContextRequest',
        'UEContextResumeRequestTransfer',
        'UEContextResumeResponseTransfer',
        'UEContextSuspendRequestTransfer',
        'UE-DifferentiationInfo',
        'UEHistoryInformation',
        'UEHistoryInformationFromTheUE',
        'UEIdentityIndexValue',
        'UE-NGAP-IDs',
        'UE-NGAP-ID-pair',
        'UEPagingIdentity',
        'UEPresence',
        'UEPresenceInAreaOfInterestList',
        'UEPresenceInAreaOfInterestItem',
        'UERadioCapability',
        'UERadioCapabilityForPaging',
        'UERadioCapabilityForPagingOfNB-IoT',
        'UERadioCapabilityForPagingOfNR',
        'UERadioCapabilityForPagingOfEUTRA',
        'UERadioCapabilityID',
        'UERetentionInformation',
        'UERLFReportContainer',
        'UESecurityCapabilities',
        'UESliceMaximumBitRateList',
        'UESliceMaximumBitRateItem',
        'UE-UP-CIoT-Support',
        'UL-CP-SecurityInformation',
        'UL-NAS-MAC',
        'UL-NAS-Count',
        'UL-NGU-UP-TNLModifyList',
        'UL-NGU-UP-TNLModifyItem',
        'UnavailableGUAMIList',
        'UnavailableGUAMIItem',
        'ULForwarding',
        'UpdateFeedback',
        'UPTransportLayerInformation',
        'UPTransportLayerInformationList',
        'UPTransportLayerInformationItem',
        'UPTransportLayerInformationPairList',
        'UPTransportLayerInformationPairItem',
        'URI-address',
        'UserLocationInformation',
        'UserLocationInformationEUTRA',
        'UserLocationInformationN3IWF',
        'UserLocationInformationTNGF',
        'UserLocationInformationTWIF',
        'UserLocationInformationW-AGF',
        'UserLocationInformationNR',
        'UserPlaneSecurityInformation',
        'VolumeTimedReportList',
        'VolumeTimedReport-Item',
        'W-AGF-ID',
        'WarningAreaCoordinates',
        'WarningAreaList',
        'WarningMessageContents',
        'WarningSecurityInfo',
        'WarningType',
        'WLANMeasurementConfiguration',
        'WLANMeasConfigNameList',
        'WLANMeasConfigNameItem',
        'WLANMeasConfig',
        'WLANName',
        'WUS-Assistance-Information',
        'XnExtTLAs',
        'XnExtTLA-Item',
        'XnGTP-TLAs',
        'XnTLAs',
        'XnTNLConfigurationInfo',
        ]
    _set_ = [
        'AdditionalDLUPTNLInformationForHOItem-ExtIEs',
        'AllocationAndRetentionPriority-ExtIEs',
        'AllowedNSSAI-Item-ExtIEs',
        'Allowed-PNI-NPN-Item-ExtIEs',
        'AlternativeQoSParaSetItem-ExtIEs',
        'AMFPagingTarget-ExtIEs',
        'AMF-TNLAssociationSetupItem-ExtIEs',
        'AMF-TNLAssociationToAddItem-ExtIEs',
        'AMF-TNLAssociationToRemoveItem-ExtIEs',
        'AMF-TNLAssociationToUpdateItem-ExtIEs',
        'AreaOfInterest-ExtIEs',
        'AreaOfInterestCellItem-ExtIEs',
        'AreaOfInterestItem-ExtIEs',
        'AreaOfInterestRANNodeItem-ExtIEs',
        'AreaOfInterestTAIItem-ExtIEs',
        'AssistanceDataForPaging-ExtIEs',
        'AssistanceDataForRecommendedCells-ExtIEs',
        'AssociatedMBSQosFlowSetupRequestItem-ExtIEs',
        'AssociatedMBSQosFlowSetuporModifyRequestItem-ExtIEs',
        'AssociatedQosFlowItem-ExtIEs',
        'AreaScopeOfMDT-NR-ExtIEs',
        'AreaScopeOfMDT-EUTRA-ExtIEs',
        'AreaScopeOfNeighCellsItem-ExtIEs',
        'AreaScopeOfQMC-ExtIEs',
        'AvailableRANVisibleQoEMetrics-ExtIEs',
        'BeamMeasurementsReportConfiguration-ExtIEs',
        'BeamMeasurementsReportQuantity-ExtIEs',
        'BroadcastCancelledAreaList-ExtIEs',
        'BroadcastCompletedAreaList-ExtIEs',
        'BroadcastPLMNItem-ExtIEs',
        'BluetoothMeasurementConfiguration-ExtIEs',
        'BluetoothMeasConfigNameItem-ExtIEs',
        'CancelledCellsInEAI-EUTRA-Item-ExtIEs',
        'CancelledCellsInEAI-NR-Item-ExtIEs',
        'CancelledCellsInTAI-EUTRA-Item-ExtIEs',
        'CancelledCellsInTAI-NR-Item-ExtIEs',
        'CandidateCellItem-ExtIEs',
        'CandidateCell-ExtIEs',
        'CandidateCellID-ExtIEs',
        'CandidatePCI-ExtIEs',
        'Cause-ExtIEs',
        'Cell-CAGInformation-ExtIEs',
        'CellIDBroadcastEUTRA-Item-ExtIEs',
        'CellIDBroadcastNR-Item-ExtIEs',
        'CellIDCancelledEUTRA-Item-ExtIEs',
        'CellIDCancelledNR-Item-ExtIEs',
        'CellIDListForRestart-ExtIEs',
        'CellType-ExtIEs',
        'CNAssistedRANTuning-ExtIEs',
        'CNTypeRestrictionsForEquivalentItem-ExtIEs',
        'CompletedCellsInEAI-EUTRA-Item-ExtIEs',
        'CompletedCellsInEAI-NR-Item-ExtIEs',
        'CompletedCellsInTAI-EUTRA-Item-ExtIEs',
        'CompletedCellsInTAI-NR-Item-ExtIEs',
        'CoreNetworkAssistanceInformationForInactive-ExtIEs',
        'COUNTValueForPDCP-SN12-ExtIEs',
        'COUNTValueForPDCP-SN18-ExtIEs',
        'CPTransportLayerInformation-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        'CriticalityDiagnostics-IE-Item-ExtIEs',
        'CellBasedMDT-NR-ExtIEs',
        'CellBasedMDT-EUTRA-ExtIEs',
        'CellBasedQMC-ExtIEs',
        'DataForwardingResponseDRBItem-ExtIEs',
        'DAPSRequestInfo-ExtIEs',
        'DAPSResponseInfoItem-ExtIEs',
        'DAPSResponseInfo-ExtIEs',
        'DataForwardingResponseERABListItem-ExtIEs',
        'DL-CP-SecurityInformation-ExtIEs',
        'DRBsSubjectToStatusTransferItem-ExtIEs',
        'DRBStatusDL-ExtIEs',
        'DRBStatusDL12-ExtIEs',
        'DRBStatusDL18-ExtIEs',
        'DRBStatusUL-ExtIEs',
        'DRBStatusUL12-ExtIEs',
        'DRBStatusUL18-ExtIEs',
        'DRBsToQosFlowsMappingItem-ExtIEs',
        'Dynamic5QIDescriptor-ExtIEs',
        'EarlyStatusTransfer-TransparentContainer-ExtIEs',
        'ProcedureStageChoice-ExtIEs',
        'FirstDLCount-ExtIEs',
        'DRBsSubjectToEarlyStatusTransfer-Item-ExtIEs',
        'EmergencyAreaIDBroadcastEUTRA-Item-ExtIEs',
        'EmergencyAreaIDBroadcastNR-Item-ExtIEs',
        'EmergencyAreaIDCancelledEUTRA-Item-ExtIEs',
        'EmergencyAreaIDCancelledNR-Item-ExtIEs',
        'EmergencyFallbackIndicator-ExtIEs',
        'ENB-ID-ExtIEs',
        'EndpointIPAddressAndPort-ExtIEs',
        'EPS-TAI-ExtIEs',
        'E-RABInformationItem-ExtIEs',
        'EUTRA-CGI-ExtIEs',
        'EUTRA-PagingeDRXInformation-ExtIEs',
        'ExcessPacketDelayThresholdItem-ExtIEs',
        'ExpectedUEActivityBehaviour-ExtIEs',
        'ExpectedUEBehaviour-ExtIEs',
        'ExpectedUEMovingTrajectoryItem-ExtIEs',
        'Extended-AMFName-ExtIEs',
        'Extended-RANNodeName-ExtIEs',
        'ExtendedRATRestrictionInformation-ExtIEs',
        'EventTrigger-ExtIEs',
        'EventL1LoggedMDTConfig-ExtIEs',
        'MeasurementThresholdL1LoggedMDT-ExtIEs',
        'FailureIndication-ExtIEs',
        'FiveG-ProSeAuthorized-ExtIEs',
        'FiveG-ProSePC5QoSParameters-ExtIEs',
        'FiveGProSePC5QoSFlowItem-ExtIEs',
        'FiveGProSePC5FlowBitRates-ExtIEs',
        'FiveG-S-TMSI-ExtIEs',
        'ForbiddenAreaInformation-Item-ExtIEs',
        'FromEUTRANtoNGRAN-ExtIEs',
        'FromNGRANtoEUTRAN-ExtIEs',
        'GBR-QosInformation-ExtIEs',
        'GlobalCable-ID-new-ExtIEs',
        'GlobalENB-ID-ExtIEs',
        'GlobalGNB-ID-ExtIEs',
        'GlobalN3IWF-ID-ExtIEs',
        'GlobalLine-ID-ExtIEs',
        'GlobalNgENB-ID-ExtIEs',
        'GlobalRANNodeID-ExtIEs',
        'GlobalTNGF-ID-ExtIEs',
        'GlobalTWIF-ID-ExtIEs',
        'GlobalW-AGF-ID-ExtIEs',
        'GNB-ID-ExtIEs',
        'GTPTunnel-ExtIEs',
        'GUAMI-ExtIEs',
        'HandoverCommandTransfer-ExtIEs',
        'HandoverPreparationUnsuccessfulTransfer-ExtIEs',
        'HandoverRequestAcknowledgeTransfer-ExtIEs',
        'HandoverRequiredTransfer-ExtIEs',
        'HandoverResourceAllocationUnsuccessfulTransfer-ExtIEs',
        'HFCNode-ID-new-ExtIEs',
        'HOReport-ExtIEs',
        'InfoOnRecommendedCellsAndRANNodesForPaging-ExtIEs',
        'ImmediateMDTNr-ExtIEs',
        'InterSystemFailureIndication-ExtIEs',
        'IntersystemSONConfigurationTransfer-ExtIEs',
        'IntersystemSONTransferType-ExtIEs',
        'IntersystemSONeNBID-ExtIEs',
        'IntersystemSONNGRANnodeID-ExtIEs',
        'IntersystemSONInformation-ExtIEs',
        'IntersystemSONInformationRequest-ExtIEs',
        'IntersystemCellActivationRequest-ExtIEs',
        'IntersystemResourceStatusRequest-ExtIEs',
        'ReportingSystem-ExtIEs',
        'EUTRAN-ReportingSystemIEs-ExtIEs',
        'NGRAN-ReportingSystemIEs-ExtIEs',
        'EUTRAN-CellToReportItem-ExtIEs',
        'NGRAN-CellToReportItem-ExtIEs',
        'ReportType-ExtIEs',
        'EventBasedReportingIEs-ExtIEs',
        'PeriodicReportingIEs-ExtIEs',
        'IntersystemSONInformationReply-ExtIEs',
        'IntersystemCellActivationReply-ExtIEs',
        'IntersystemResourceStatusReply-ExtIEs',
        'IntersystemSONInformationReport-ExtIEs',
        'IntersystemCellStateIndication-ExtIEs',
        'NotificationCell-Item-ExtIEs',
        'IntersystemResourceStatusReport-ExtIEs',
        'ResourceStatusReportingSystem-ExtIEs',
        'EUTRAN-ReportingStatusIEs-ExtIEs',
        'EUTRAN-CellReportItem-ExtIEs',
        'EUTRAN-CompositeAvailableCapacityGroup-ExtIEs',
        'CompositeAvailableCapacity-ExtIEs',
        'EUTRAN-RadioResourceStatus-ExtIEs',
        'NGRAN-ReportingStatusIEs-ExtIEs',
        'NGRAN-CellReportItem-ExtIEs',
        'NGRAN-RadioResourceStatus-ExtIEs',
        'InterSystemHOReport-ExtIEs',
        'InterSystemHandoverReportType-ExtIEs',
        'IntersystemUnnecessaryHO-ExtIEs',
        'LAI-ExtIEs',
        'LastVisitedCellInformation-ExtIEs',
        'LastVisitedCellItem-ExtIEs',
        'LastVisitedNGRANCellInformation-ExtIEs',
        'LastVisitedPSCellInformation-ExtIEs',
        'LocationReportingRequestType-ExtIEs',
        'LoggedMDTNr-ExtIEs',
        'LoggedMDTTrigger-ExtIEs',
        'LTEV2XServicesAuthorized-ExtIEs',
        'LTEUE-Sidelink-Aggregate-MaximumBitrates-ExtIEs',
        'MBS-DataForwardingResponseMRBItem-ExtIEs',
        'MBS-MappingandDataForwardingRequestItem-ExtIEs',
        'MRB-ProgressInformation-ExtIEs',
        'MBS-QoSFlowsToBeSetupItem-ExtIEs',
        'MBS-ServiceArea-ExtIEs',
        'MBS-ServiceAreaInformationItem-ExtIEs',
        'MBS-ServiceAreaInformation-ExtIEs',
        'MBS-SessionID-ExtIEs',
        'MBSSessionFailedtoSetupItem-ExtIEs',
        'MBS-ActiveSessionInformation-SourcetoTargetItem-ExtIEs',
        'MBS-ActiveSessionInformation-TargettoSourceItem-ExtIEs',
        'MBSSessionSetupOrModFailureTransfer-ExtIEs',
        'MBSSessionSetupResponseItem-ExtIEs',
        'MBSSessionSetupOrModRequestTransferIEs',
        'MBSSessionReleaseResponseTransfer-ExtIEs',
        'MBSSessionSetupOrModResponseTransfer-ExtIEs',
        'MBS-SessionTNLInfo5GC-ExtIEs',
        'MBS-SessionTNLInfo5GCItem-ExtIEs',
        'MBS-SessionTNLInfoNGRAN-ExtIEs',
        'MBS-SessionTNLInfoNGRANItem-ExtIEs',
        'MBS-DistributionReleaseRequesTransfer-ExtIEs',
        'MBS-DistributionSetupRequestTransfer-ExtIEs',
        'MBS-DistributionSetupResponseTransfer-ExtIEs',
        'MBS-DistributionSetupUnsuccessfulTransfer-ExtIEs',
        'MBSSessionSetupRequestItem-ExtIEs',
        'MBSSessionSetuporModifyRequestItem-ExtIEs',
        'MBSSessionToReleaseItem-ExtIEs',
        'MobilityRestrictionList-ExtIEs',
        'MDT-AlignmentInfo-ExtIEs',
        'MDT-Configuration-ExtIEs',
        'MDT-Configuration-NR-ExtIEs',
        'MDT-Configuration-EUTRA-ExtIEs',
        'MDTModeNr-ExtIEs',
        'MulticastSessionActivationRequestTransfer-ExtIEs',
        'MulticastSessionDeactivationRequestTransfer-ExtIEs',
        'MulticastSessionUpdateRequestTransferIEs',
        'MulticastGroupPagingAreaItem-ExtIEs',
        'MulticastGroupPagingArea-ExtIEs',
        'UE-PagingItem-ExtIEs',
        'M1Configuration-ExtIEs',
        'M1ThresholdEventA2-ExtIEs',
        'M1ThresholdType-ExtIEs',
        'M1PeriodicReporting-ExtIEs',
        'M4Configuration-ExtIEs',
        'M5Configuration-ExtIEs',
        'M6Configuration-ExtIEs',
        'M7Configuration-ExtIEs',
        'MDT-Location-Info-ExtIEs',
        'N3IWF-ID-ExtIEs',
        'NB-IoT-Paging-eDRXInfo-ExtIEs',
        'NGAPIESupportInformationRequestItem-ExtIEs',
        'NGAPIESupportInformationResponseItem-ExtIEs',
        'NgENB-ID-ExtIEs',
        'NGRAN-CGI-ExtIEs',
        'NGRAN-TNLAssociationToRemoveItem-ExtIEs',
        'NonDynamic5QIDescriptor-ExtIEs',
        'NPN-AccessInformation-ExtIEs',
        'NPN-MobilityInformation-ExtIEs',
        'NPN-PagingAssistanceInformation-ExtIEs',
        'NPN-Support-ExtIEs',
        'NR-CGI-ExtIEs',
        'NR-PagingeDRXInformation-ExtIEs',
        'NRNTNTAIInformation-ExtIEs',
        'NRFrequencyBandItem-ExtIEs',
        'NRFrequencyInfo-ExtIEs',
        'NRV2XServicesAuthorized-ExtIEs',
        'NRUESidelinkAggregateMaximumBitrate-ExtIEs',
        'OverloadResponse-ExtIEs',
        'OverloadStartNSSAIItem-ExtIEs',
        'PacketErrorRate-ExtIEs',
        'PagingAssisDataforCEcapabUE-ExtIEs',
        'PagingAttemptInformation-ExtIEs',
        'PathSwitchRequestAcknowledgeTransfer-ExtIEs',
        'PathSwitchRequestSetupFailedTransfer-ExtIEs',
        'PathSwitchRequestTransfer-ExtIEs',
        'PathSwitchRequestUnsuccessfulTransfer-ExtIEs',
        'PC5QoSParameters-ExtIEs',
        'PC5QoSFlowItem-ExtIEs',
        'PC5FlowBitRates-ExtIEs',
        'PDUSessionAggregateMaximumBitRate-ExtIEs',
        'PDUSessionResourceAdmittedItem-ExtIEs',
        'PDUSessionResourceFailedToModifyItemModCfm-ExtIEs',
        'PDUSessionResourceFailedToModifyItemModRes-ExtIEs',
        'PDUSessionResourceFailedToResumeItemRESReq-ExtIEs',
        'PDUSessionResourceFailedToResumeItemRESRes-ExtIEs',
        'PDUSessionResourceFailedToSetupItemCxtFail-ExtIEs',
        'PDUSessionResourceFailedToSetupItemCxtRes-ExtIEs',
        'PDUSessionResourceFailedToSetupItemHOAck-ExtIEs',
        'PDUSessionResourceFailedToSetupItemPSReq-ExtIEs',
        'PDUSessionResourceFailedToSetupItemSURes-ExtIEs',
        'PDUSessionResourceHandoverItem-ExtIEs',
        'PDUSessionResourceInformationItem-ExtIEs',
        'PDUSessionResourceItemCxtRelCpl-ExtIEs',
        'PDUSessionResourceItemCxtRelReq-ExtIEs',
        'PDUSessionResourceItemHORqd-ExtIEs',
        'PDUSessionResourceModifyConfirmTransfer-ExtIEs',
        'PDUSessionResourceModifyIndicationUnsuccessfulTransfer-ExtIEs',
        'PDUSessionResourceModifyRequestTransferIEs',
        'PDUSessionResourceModifyResponseTransfer-ExtIEs',
        'PDUSessionResourceModifyIndicationTransfer-ExtIEs',
        'PDUSessionResourceModifyItemModCfm-ExtIEs',
        'PDUSessionResourceModifyItemModInd-ExtIEs',
        'PDUSessionResourceModifyItemModReq-ExtIEs',
        'PDUSessionResourceModifyItemModRes-ExtIEs',
        'PDUSessionResourceModifyUnsuccessfulTransfer-ExtIEs',
        'PDUSessionResourceNotifyItem-ExtIEs',
        'PDUSessionResourceNotifyReleasedTransfer-ExtIEs',
        'PDUSessionResourceNotifyTransfer-ExtIEs',
        'PDUSessionResourceReleaseCommandTransfer-ExtIEs',
        'PDUSessionResourceReleasedItemNot-ExtIEs',
        'PDUSessionResourceReleasedItemPSAck-ExtIEs',
        'PDUSessionResourceReleasedItemPSFail-ExtIEs',
        'PDUSessionResourceReleasedItemRelRes-ExtIEs',
        'PDUSessionResourceReleaseResponseTransfer-ExtIEs',
        'PDUSessionResourceResumeItemRESReq-ExtIEs',
        'PDUSessionResourceResumeItemRESRes-ExtIEs',
        'PDUSessionResourceSecondaryRATUsageItem-ExtIEs',
        'PDUSessionResourceSetupItemCxtReq-ExtIEs',
        'PDUSessionResourceSetupItemCxtRes-ExtIEs',
        'PDUSessionResourceSetupItemHOReq-ExtIEs',
        'PDUSessionResourceSetupItemSUReq-ExtIEs',
        'PDUSessionResourceSetupItemSURes-ExtIEs',
        'PDUSessionResourceSetupRequestTransferIEs',
        'PDUSessionResourceSetupResponseTransfer-ExtIEs',
        'PDUSessionResourceSetupUnsuccessfulTransfer-ExtIEs',
        'PDUSessionResourceSuspendItemSUSReq-ExtIEs',
        'PDUSessionResourceSwitchedItem-ExtIEs',
        'PDUSessionResourceToBeSwitchedDLItem-ExtIEs',
        'PDUSessionResourceToReleaseItemHOCmd-ExtIEs',
        'PDUSessionResourceToReleaseItemRelCmd-ExtIEs',
        'PDUSessionUsageReport-ExtIEs',
        'PEIPSassistanceInformation-ExtIEs',
        'PLMNAreaBasedQMC-ExtIEs',
        'PLMNSupportItem-ExtIEs',
        'PNI-NPN-MobilityInformation-ExtIEs',
        'PWSFailedCellIDList-ExtIEs',
        'QMCConfigInfo-ExtIEs',
        'QMCDeactivation-ExtIEs',
        'QosCharacteristics-ExtIEs',
        'QosFlowAcceptedItem-ExtIEs',
        'QosFlowAddOrModifyRequestItem-ExtIEs',
        'QosFlowAddOrModifyResponseItem-ExtIEs',
        'QosFlowFeedbackItem-ExtIEs',
        'QosFlowInformationItem-ExtIEs',
        'QosFlowLevelQosParameters-ExtIEs',
        'QosFlowWithCauseItem-ExtIEs',
        'QosFlowModifyConfirmItem-ExtIEs',
        'QosFlowNotifyItem-ExtIEs',
        'QosFlowParametersItem-ExtIEs',
        'QosFlowPerTNLInformation-ExtIEs',
        'QosFlowPerTNLInformationItem-ExtIEs',
        'QosFlowSetupRequestItem-ExtIEs',
        'QosFlowItemWithDataForwarding-ExtIEs',
        'QosFlowToBeForwardedItem-ExtIEs',
        'QoSFlowsUsageReport-Item-ExtIEs',
        'RANStatusTransfer-TransparentContainer-ExtIEs',
        'RATRestrictions-Item-ExtIEs',
        'RecommendedCellsForPaging-ExtIEs',
        'RecommendedCellItem-ExtIEs',
        'RecommendedRANNodesForPaging-ExtIEs',
        'RecommendedRANNodeItem-ExtIEs',
        'RedundantPDUSessionInformation-ExtIEs',
        'ResetType-ExtIEs',
        'RIMInformationTransfer-ExtIEs',
        'RIMInformation-ExtIEs',
        'ScheduledCommunicationTime-ExtIEs',
        'SecondaryRATUsageInformation-ExtIEs',
        'SecondaryRATDataUsageReportTransfer-ExtIEs',
        'SecurityContext-ExtIEs',
        'SecurityIndication-ExtIEs',
        'SecurityResult-ExtIEs',
        'SensorMeasurementConfiguration-ExtIEs',
        'SensorMeasConfigNameItem-ExtIEs',
        'SensorNameConfig-ExtIEs',
        'ServedGUAMIItem-ExtIEs',
        'ServiceAreaInformation-Item-ExtIEs',
        'SharedNGU-MulticastTNLInformation-ExtIEs',
        'SliceOverloadItem-ExtIEs',
        'SliceSupportItem-ExtIEs',
        'SliceSupportQMC-Item-ExtIEs',
        'SNPN-MobilityInformation-ExtIEs',
        'S-NSSAI-ExtIEs',
        'SONConfigurationTransfer-ExtIEs',
        'SONInformation-ExtIEs',
        'SONInformationReply-ExtIEs',
        'SONInformationReport-ExtIEs',
        'SuccessfulHandoverReport-Item-ExtIEs',
        'SourceNGRANNode-ToTargetNGRANNode-TransparentContainer-ExtIEs',
        'SourceNodeID-ExtIEs',
        'SourceRANNodeID-ExtIEs',
        'SourceToTarget-AMFInformationReroute-ExtIEs',
        'SupportedTAItem-ExtIEs',
        'TAI-ExtIEs',
        'TAIBroadcastEUTRA-Item-ExtIEs',
        'TAIBroadcastNR-Item-ExtIEs',
        'TAICancelledEUTRA-Item-ExtIEs',
        'TAICancelledNR-Item-ExtIEs',
        'TAIListForInactiveItem-ExtIEs',
        'TAIListForPagingItem-ExtIEs',
        'TAINSAGSupportItem-ExtIEs',
        'TargeteNB-ID-ExtIEs',
        'TargetHomeENB-ID-ExtIEs',
        'TargetID-ExtIEs',
        'TargetNGRANNode-ToSourceNGRANNode-TransparentContainer-ExtIEs',
        'TargetNGRANNode-ToSourceNGRANNode-FailureTransparentContainer-ExtIEs',
        'TargetNSSAI-Item-ExtIEs',
        'TargetNSSAIInformation-Item-ExtIEs',
        'TargetRANNodeID-ExtIEs',
        'TargetRANNodeID-RIM-ExtIEs',
        'TargetRANNodeID-SON-ExtIEs',
        'TargetRNC-ID-ExtIEs',
        'TimeSyncAssistanceInfo-ExtIEs',
        'TNGF-ID-ExtIEs',
        'TNLAssociationItem-ExtIEs',
        'TooearlyIntersystemHO-ExtIEs',
        'TraceActivation-ExtIEs',
        'TAIBasedMDT-ExtIEs',
        'TAIBasedQMC-ExtIEs',
        'TABasedQMC-ExtIEs',
        'TABasedMDT-ExtIEs',
        'TWIF-ID-ExtIEs',
        'TSCAssistanceInformation-ExtIEs',
        'TSCTrafficCharacteristics-ExtIEs',
        'UEAggregateMaximumBitRate-ExtIEs',
        'UEAppLayerMeasInfoItem-ExtIEs',
        'UEAppLayerMeasConfigInfo-ExtIEs',
        'UE-associatedLogicalNG-connectionItem-ExtIEs',
        'UEContextResumeRequestTransfer-ExtIEs',
        'UEContextResumeResponseTransfer-ExtIEs',
        'UEContextSuspendRequestTransfer-ExtIEs',
        'UE-DifferentiationInfo-ExtIEs',
        'UEHistoryInformationFromTheUE-ExtIEs',
        'UEIdentityIndexValue-ExtIEs',
        'UE-NGAP-IDs-ExtIEs',
        'UE-NGAP-ID-pair-ExtIEs',
        'UEPagingIdentity-ExtIEs',
        'UEPresenceInAreaOfInterestItem-ExtIEs',
        'UERadioCapabilityForPaging-ExtIEs',
        'UERLFReportContainer-ExtIEs',
        'UESecurityCapabilities-ExtIEs',
        'UESliceMaximumBitRateItem-ExtIEs',
        'UL-CP-SecurityInformation-ExtIEs',
        'UL-NGU-UP-TNLModifyItem-ExtIEs',
        'UnavailableGUAMIItem-ExtIEs',
        'UPTransportLayerInformation-ExtIEs',
        'UPTransportLayerInformationItem-ExtIEs',
        'UPTransportLayerInformationPairItem-ExtIEs',
        'UserLocationInformation-ExtIEs',
        'UserLocationInformationEUTRA-ExtIEs',
        'UserLocationInformationN3IWF-ExtIEs',
        'UserLocationInformationTNGF-ExtIEs',
        'UserLocationInformationTWIF-ExtIEs',
        'UserLocationInformationW-AGF-ExtIEs',
        'UserLocationInformationNR-ExtIEs',
        'UserPlaneSecurityInformation-ExtIEs',
        'VolumeTimedReport-Item-ExtIEs',
        'W-AGF-ID-ExtIEs',
        'WarningAreaList-ExtIEs',
        'WLANMeasurementConfiguration-ExtIEs',
        'WLANMeasConfigNameItem-ExtIEs',
        'WUS-Assistance-Information-ExtIEs',
        'XnExtTLA-Item-ExtIEs',
        'XnTNLConfigurationInfo-ExtIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        'AdditionalDLUPTNLInformationForHOItem-ExtIEs',
        'AllocationAndRetentionPriority-ExtIEs',
        'AllowedNSSAI-Item-ExtIEs',
        'Allowed-PNI-NPN-Item-ExtIEs',
        'AlternativeQoSParaSetItem-ExtIEs',
        'AMFPagingTarget-ExtIEs',
        'AMF-TNLAssociationSetupItem-ExtIEs',
        'AMF-TNLAssociationToAddItem-ExtIEs',
        'AMF-TNLAssociationToRemoveItem-ExtIEs',
        'AMF-TNLAssociationToUpdateItem-ExtIEs',
        'AreaOfInterest-ExtIEs',
        'AreaOfInterestCellItem-ExtIEs',
        'AreaOfInterestItem-ExtIEs',
        'AreaOfInterestRANNodeItem-ExtIEs',
        'AreaOfInterestTAIItem-ExtIEs',
        'AssistanceDataForPaging-ExtIEs',
        'AssistanceDataForRecommendedCells-ExtIEs',
        'AssociatedMBSQosFlowSetupRequestItem-ExtIEs',
        'AssociatedMBSQosFlowSetuporModifyRequestItem-ExtIEs',
        'AssociatedQosFlowItem-ExtIEs',
        'AreaScopeOfMDT-NR-ExtIEs',
        'AreaScopeOfMDT-EUTRA-ExtIEs',
        'AreaScopeOfNeighCellsItem-ExtIEs',
        'AreaScopeOfQMC-ExtIEs',
        'AvailableRANVisibleQoEMetrics-ExtIEs',
        'BeamMeasurementsReportConfiguration-ExtIEs',
        'BeamMeasurementsReportQuantity-ExtIEs',
        'BroadcastCancelledAreaList-ExtIEs',
        'BroadcastCompletedAreaList-ExtIEs',
        'BroadcastPLMNItem-ExtIEs',
        'BluetoothMeasurementConfiguration-ExtIEs',
        'BluetoothMeasConfigNameItem-ExtIEs',
        'CancelledCellsInEAI-EUTRA-Item-ExtIEs',
        'CancelledCellsInEAI-NR-Item-ExtIEs',
        'CancelledCellsInTAI-EUTRA-Item-ExtIEs',
        'CancelledCellsInTAI-NR-Item-ExtIEs',
        'CandidateCellItem-ExtIEs',
        'CandidateCell-ExtIEs',
        'CandidateCellID-ExtIEs',
        'CandidatePCI-ExtIEs',
        'Cause-ExtIEs',
        'Cell-CAGInformation-ExtIEs',
        'CellIDBroadcastEUTRA-Item-ExtIEs',
        'CellIDBroadcastNR-Item-ExtIEs',
        'CellIDCancelledEUTRA-Item-ExtIEs',
        'CellIDCancelledNR-Item-ExtIEs',
        'CellIDListForRestart-ExtIEs',
        'CellType-ExtIEs',
        'CNAssistedRANTuning-ExtIEs',
        'CNTypeRestrictionsForEquivalentItem-ExtIEs',
        'CompletedCellsInEAI-EUTRA-Item-ExtIEs',
        'CompletedCellsInEAI-NR-Item-ExtIEs',
        'CompletedCellsInTAI-EUTRA-Item-ExtIEs',
        'CompletedCellsInTAI-NR-Item-ExtIEs',
        'CoreNetworkAssistanceInformationForInactive-ExtIEs',
        'COUNTValueForPDCP-SN12-ExtIEs',
        'COUNTValueForPDCP-SN18-ExtIEs',
        'CPTransportLayerInformation-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        'CriticalityDiagnostics-IE-Item-ExtIEs',
        'CellBasedMDT-NR-ExtIEs',
        'CellBasedMDT-EUTRA-ExtIEs',
        'CellBasedQMC-ExtIEs',
        'DataForwardingResponseDRBItem-ExtIEs',
        'DAPSRequestInfo-ExtIEs',
        'DAPSResponseInfoItem-ExtIEs',
        'DAPSResponseInfo-ExtIEs',
        'DataForwardingResponseERABListItem-ExtIEs',
        'DL-CP-SecurityInformation-ExtIEs',
        'DRBsSubjectToStatusTransferItem-ExtIEs',
        'DRBStatusDL-ExtIEs',
        'DRBStatusDL12-ExtIEs',
        'DRBStatusDL18-ExtIEs',
        'DRBStatusUL-ExtIEs',
        'DRBStatusUL12-ExtIEs',
        'DRBStatusUL18-ExtIEs',
        'DRBsToQosFlowsMappingItem-ExtIEs',
        'Dynamic5QIDescriptor-ExtIEs',
        'EarlyStatusTransfer-TransparentContainer-ExtIEs',
        'ProcedureStageChoice-ExtIEs',
        'FirstDLCount-ExtIEs',
        'DRBsSubjectToEarlyStatusTransfer-Item-ExtIEs',
        'EmergencyAreaIDBroadcastEUTRA-Item-ExtIEs',
        'EmergencyAreaIDBroadcastNR-Item-ExtIEs',
        'EmergencyAreaIDCancelledEUTRA-Item-ExtIEs',
        'EmergencyAreaIDCancelledNR-Item-ExtIEs',
        'EmergencyFallbackIndicator-ExtIEs',
        'ENB-ID-ExtIEs',
        'EndpointIPAddressAndPort-ExtIEs',
        'EPS-TAI-ExtIEs',
        'E-RABInformationItem-ExtIEs',
        'EUTRA-CGI-ExtIEs',
        'EUTRA-PagingeDRXInformation-ExtIEs',
        'ExcessPacketDelayThresholdItem-ExtIEs',
        'ExpectedUEActivityBehaviour-ExtIEs',
        'ExpectedUEBehaviour-ExtIEs',
        'ExpectedUEMovingTrajectoryItem-ExtIEs',
        'Extended-AMFName-ExtIEs',
        'Extended-RANNodeName-ExtIEs',
        'ExtendedRATRestrictionInformation-ExtIEs',
        'EventTrigger-ExtIEs',
        'EventL1LoggedMDTConfig-ExtIEs',
        'MeasurementThresholdL1LoggedMDT-ExtIEs',
        'FailureIndication-ExtIEs',
        'FiveG-ProSeAuthorized-ExtIEs',
        'FiveG-ProSePC5QoSParameters-ExtIEs',
        'FiveGProSePC5QoSFlowItem-ExtIEs',
        'FiveGProSePC5FlowBitRates-ExtIEs',
        'FiveG-S-TMSI-ExtIEs',
        'ForbiddenAreaInformation-Item-ExtIEs',
        'FromEUTRANtoNGRAN-ExtIEs',
        'FromNGRANtoEUTRAN-ExtIEs',
        'GBR-QosInformation-ExtIEs',
        'GlobalCable-ID-new-ExtIEs',
        'GlobalENB-ID-ExtIEs',
        'GlobalGNB-ID-ExtIEs',
        'GlobalN3IWF-ID-ExtIEs',
        'GlobalLine-ID-ExtIEs',
        'GlobalNgENB-ID-ExtIEs',
        'GlobalRANNodeID-ExtIEs',
        'GlobalTNGF-ID-ExtIEs',
        'GlobalTWIF-ID-ExtIEs',
        'GlobalW-AGF-ID-ExtIEs',
        'GNB-ID-ExtIEs',
        'GTPTunnel-ExtIEs',
        'GUAMI-ExtIEs',
        'HandoverCommandTransfer-ExtIEs',
        'HandoverPreparationUnsuccessfulTransfer-ExtIEs',
        'HandoverRequestAcknowledgeTransfer-ExtIEs',
        'HandoverRequiredTransfer-ExtIEs',
        'HandoverResourceAllocationUnsuccessfulTransfer-ExtIEs',
        'HFCNode-ID-new-ExtIEs',
        'HOReport-ExtIEs',
        'InfoOnRecommendedCellsAndRANNodesForPaging-ExtIEs',
        'ImmediateMDTNr-ExtIEs',
        'InterSystemFailureIndication-ExtIEs',
        'IntersystemSONConfigurationTransfer-ExtIEs',
        'IntersystemSONTransferType-ExtIEs',
        'IntersystemSONeNBID-ExtIEs',
        'IntersystemSONNGRANnodeID-ExtIEs',
        'IntersystemSONInformation-ExtIEs',
        'IntersystemSONInformationRequest-ExtIEs',
        'IntersystemCellActivationRequest-ExtIEs',
        'IntersystemResourceStatusRequest-ExtIEs',
        'ReportingSystem-ExtIEs',
        'EUTRAN-ReportingSystemIEs-ExtIEs',
        'NGRAN-ReportingSystemIEs-ExtIEs',
        'EUTRAN-CellToReportItem-ExtIEs',
        'NGRAN-CellToReportItem-ExtIEs',
        'ReportType-ExtIEs',
        'EventBasedReportingIEs-ExtIEs',
        'PeriodicReportingIEs-ExtIEs',
        'IntersystemSONInformationReply-ExtIEs',
        'IntersystemCellActivationReply-ExtIEs',
        'IntersystemResourceStatusReply-ExtIEs',
        'IntersystemSONInformationReport-ExtIEs',
        'IntersystemCellStateIndication-ExtIEs',
        'NotificationCell-Item-ExtIEs',
        'IntersystemResourceStatusReport-ExtIEs',
        'ResourceStatusReportingSystem-ExtIEs',
        'EUTRAN-ReportingStatusIEs-ExtIEs',
        'EUTRAN-CellReportItem-ExtIEs',
        'EUTRAN-CompositeAvailableCapacityGroup-ExtIEs',
        'CompositeAvailableCapacity-ExtIEs',
        'EUTRAN-RadioResourceStatus-ExtIEs',
        'NGRAN-ReportingStatusIEs-ExtIEs',
        'NGRAN-CellReportItem-ExtIEs',
        'NGRAN-RadioResourceStatus-ExtIEs',
        'InterSystemHOReport-ExtIEs',
        'InterSystemHandoverReportType-ExtIEs',
        'IntersystemUnnecessaryHO-ExtIEs',
        'LAI-ExtIEs',
        'LastVisitedCellInformation-ExtIEs',
        'LastVisitedCellItem-ExtIEs',
        'LastVisitedNGRANCellInformation-ExtIEs',
        'LastVisitedPSCellInformation-ExtIEs',
        'LocationReportingRequestType-ExtIEs',
        'LoggedMDTNr-ExtIEs',
        'LoggedMDTTrigger-ExtIEs',
        'LTEV2XServicesAuthorized-ExtIEs',
        'LTEUE-Sidelink-Aggregate-MaximumBitrates-ExtIEs',
        'MBS-DataForwardingResponseMRBItem-ExtIEs',
        'MBS-MappingandDataForwardingRequestItem-ExtIEs',
        'MRB-ProgressInformation-ExtIEs',
        'MBS-QoSFlowsToBeSetupItem-ExtIEs',
        'MBS-ServiceArea-ExtIEs',
        'MBS-ServiceAreaInformationItem-ExtIEs',
        'MBS-ServiceAreaInformation-ExtIEs',
        'MBS-SessionID-ExtIEs',
        'MBSSessionFailedtoSetupItem-ExtIEs',
        'MBS-ActiveSessionInformation-SourcetoTargetItem-ExtIEs',
        'MBS-ActiveSessionInformation-TargettoSourceItem-ExtIEs',
        'MBSSessionSetupOrModFailureTransfer-ExtIEs',
        'MBSSessionSetupResponseItem-ExtIEs',
        'MBSSessionSetupOrModRequestTransferIEs',
        'MBSSessionReleaseResponseTransfer-ExtIEs',
        'MBSSessionSetupOrModResponseTransfer-ExtIEs',
        'MBS-SessionTNLInfo5GC-ExtIEs',
        'MBS-SessionTNLInfo5GCItem-ExtIEs',
        'MBS-SessionTNLInfoNGRAN-ExtIEs',
        'MBS-SessionTNLInfoNGRANItem-ExtIEs',
        'MBS-DistributionReleaseRequesTransfer-ExtIEs',
        'MBS-DistributionSetupRequestTransfer-ExtIEs',
        'MBS-DistributionSetupResponseTransfer-ExtIEs',
        'MBS-DistributionSetupUnsuccessfulTransfer-ExtIEs',
        'MBSSessionSetupRequestItem-ExtIEs',
        'MBSSessionSetuporModifyRequestItem-ExtIEs',
        'MBSSessionToReleaseItem-ExtIEs',
        'MobilityRestrictionList-ExtIEs',
        'MDT-AlignmentInfo-ExtIEs',
        'MDT-Configuration-ExtIEs',
        'MDT-Configuration-NR-ExtIEs',
        'MDT-Configuration-EUTRA-ExtIEs',
        'MDTModeNr-ExtIEs',
        'MulticastSessionActivationRequestTransfer-ExtIEs',
        'MulticastSessionDeactivationRequestTransfer-ExtIEs',
        'MulticastSessionUpdateRequestTransferIEs',
        'MulticastGroupPagingAreaItem-ExtIEs',
        'MulticastGroupPagingArea-ExtIEs',
        'UE-PagingItem-ExtIEs',
        'M1Configuration-ExtIEs',
        'M1ThresholdEventA2-ExtIEs',
        'M1ThresholdType-ExtIEs',
        'M1PeriodicReporting-ExtIEs',
        'M4Configuration-ExtIEs',
        'M5Configuration-ExtIEs',
        'M6Configuration-ExtIEs',
        'M7Configuration-ExtIEs',
        'MDT-Location-Info-ExtIEs',
        'N3IWF-ID-ExtIEs',
        'NB-IoT-Paging-eDRXInfo-ExtIEs',
        'NGAPIESupportInformationRequestItem-ExtIEs',
        'NGAPIESupportInformationResponseItem-ExtIEs',
        'NgENB-ID-ExtIEs',
        'NGRAN-CGI-ExtIEs',
        'NGRAN-TNLAssociationToRemoveItem-ExtIEs',
        'NonDynamic5QIDescriptor-ExtIEs',
        'NPN-AccessInformation-ExtIEs',
        'NPN-MobilityInformation-ExtIEs',
        'NPN-PagingAssistanceInformation-ExtIEs',
        'NPN-Support-ExtIEs',
        'NR-CGI-ExtIEs',
        'NR-PagingeDRXInformation-ExtIEs',
        'NRNTNTAIInformation-ExtIEs',
        'NRFrequencyBandItem-ExtIEs',
        'NRFrequencyInfo-ExtIEs',
        'NRV2XServicesAuthorized-ExtIEs',
        'NRUESidelinkAggregateMaximumBitrate-ExtIEs',
        'OverloadResponse-ExtIEs',
        'OverloadStartNSSAIItem-ExtIEs',
        'PacketErrorRate-ExtIEs',
        'PagingAssisDataforCEcapabUE-ExtIEs',
        'PagingAttemptInformation-ExtIEs',
        'PathSwitchRequestAcknowledgeTransfer-ExtIEs',
        'PathSwitchRequestSetupFailedTransfer-ExtIEs',
        'PathSwitchRequestTransfer-ExtIEs',
        'PathSwitchRequestUnsuccessfulTransfer-ExtIEs',
        'PC5QoSParameters-ExtIEs',
        'PC5QoSFlowItem-ExtIEs',
        'PC5FlowBitRates-ExtIEs',
        'PDUSessionAggregateMaximumBitRate-ExtIEs',
        'PDUSessionResourceAdmittedItem-ExtIEs',
        'PDUSessionResourceFailedToModifyItemModCfm-ExtIEs',
        'PDUSessionResourceFailedToModifyItemModRes-ExtIEs',
        'PDUSessionResourceFailedToResumeItemRESReq-ExtIEs',
        'PDUSessionResourceFailedToResumeItemRESRes-ExtIEs',
        'PDUSessionResourceFailedToSetupItemCxtFail-ExtIEs',
        'PDUSessionResourceFailedToSetupItemCxtRes-ExtIEs',
        'PDUSessionResourceFailedToSetupItemHOAck-ExtIEs',
        'PDUSessionResourceFailedToSetupItemPSReq-ExtIEs',
        'PDUSessionResourceFailedToSetupItemSURes-ExtIEs',
        'PDUSessionResourceHandoverItem-ExtIEs',
        'PDUSessionResourceInformationItem-ExtIEs',
        'PDUSessionResourceItemCxtRelCpl-ExtIEs',
        'PDUSessionResourceItemCxtRelReq-ExtIEs',
        'PDUSessionResourceItemHORqd-ExtIEs',
        'PDUSessionResourceModifyConfirmTransfer-ExtIEs',
        'PDUSessionResourceModifyIndicationUnsuccessfulTransfer-ExtIEs',
        'PDUSessionResourceModifyRequestTransferIEs',
        'PDUSessionResourceModifyResponseTransfer-ExtIEs',
        'PDUSessionResourceModifyIndicationTransfer-ExtIEs',
        'PDUSessionResourceModifyItemModCfm-ExtIEs',
        'PDUSessionResourceModifyItemModInd-ExtIEs',
        'PDUSessionResourceModifyItemModReq-ExtIEs',
        'PDUSessionResourceModifyItemModRes-ExtIEs',
        'PDUSessionResourceModifyUnsuccessfulTransfer-ExtIEs',
        'PDUSessionResourceNotifyItem-ExtIEs',
        'PDUSessionResourceNotifyReleasedTransfer-ExtIEs',
        'PDUSessionResourceNotifyTransfer-ExtIEs',
        'PDUSessionResourceReleaseCommandTransfer-ExtIEs',
        'PDUSessionResourceReleasedItemNot-ExtIEs',
        'PDUSessionResourceReleasedItemPSAck-ExtIEs',
        'PDUSessionResourceReleasedItemPSFail-ExtIEs',
        'PDUSessionResourceReleasedItemRelRes-ExtIEs',
        'PDUSessionResourceReleaseResponseTransfer-ExtIEs',
        'PDUSessionResourceResumeItemRESReq-ExtIEs',
        'PDUSessionResourceResumeItemRESRes-ExtIEs',
        'PDUSessionResourceSecondaryRATUsageItem-ExtIEs',
        'PDUSessionResourceSetupItemCxtReq-ExtIEs',
        'PDUSessionResourceSetupItemCxtRes-ExtIEs',
        'PDUSessionResourceSetupItemHOReq-ExtIEs',
        'PDUSessionResourceSetupItemSUReq-ExtIEs',
        'PDUSessionResourceSetupItemSURes-ExtIEs',
        'PDUSessionResourceSetupRequestTransferIEs',
        'PDUSessionResourceSetupResponseTransfer-ExtIEs',
        'PDUSessionResourceSetupUnsuccessfulTransfer-ExtIEs',
        'PDUSessionResourceSuspendItemSUSReq-ExtIEs',
        'PDUSessionResourceSwitchedItem-ExtIEs',
        'PDUSessionResourceToBeSwitchedDLItem-ExtIEs',
        'PDUSessionResourceToReleaseItemHOCmd-ExtIEs',
        'PDUSessionResourceToReleaseItemRelCmd-ExtIEs',
        'PDUSessionUsageReport-ExtIEs',
        'PEIPSassistanceInformation-ExtIEs',
        'PLMNAreaBasedQMC-ExtIEs',
        'PLMNSupportItem-ExtIEs',
        'PNI-NPN-MobilityInformation-ExtIEs',
        'PWSFailedCellIDList-ExtIEs',
        'QMCConfigInfo-ExtIEs',
        'QMCDeactivation-ExtIEs',
        'QosCharacteristics-ExtIEs',
        'QosFlowAcceptedItem-ExtIEs',
        'QosFlowAddOrModifyRequestItem-ExtIEs',
        'QosFlowAddOrModifyResponseItem-ExtIEs',
        'QosFlowFeedbackItem-ExtIEs',
        'QosFlowInformationItem-ExtIEs',
        'QosFlowLevelQosParameters-ExtIEs',
        'QosFlowWithCauseItem-ExtIEs',
        'QosFlowModifyConfirmItem-ExtIEs',
        'QosFlowNotifyItem-ExtIEs',
        'QosFlowParametersItem-ExtIEs',
        'QosFlowPerTNLInformation-ExtIEs',
        'QosFlowPerTNLInformationItem-ExtIEs',
        'QosFlowSetupRequestItem-ExtIEs',
        'QosFlowItemWithDataForwarding-ExtIEs',
        'QosFlowToBeForwardedItem-ExtIEs',
        'QoSFlowsUsageReport-Item-ExtIEs',
        'RANStatusTransfer-TransparentContainer-ExtIEs',
        'RATRestrictions-Item-ExtIEs',
        'RecommendedCellsForPaging-ExtIEs',
        'RecommendedCellItem-ExtIEs',
        'RecommendedRANNodesForPaging-ExtIEs',
        'RecommendedRANNodeItem-ExtIEs',
        'RedundantPDUSessionInformation-ExtIEs',
        'ResetType-ExtIEs',
        'RIMInformationTransfer-ExtIEs',
        'RIMInformation-ExtIEs',
        'ScheduledCommunicationTime-ExtIEs',
        'SecondaryRATUsageInformation-ExtIEs',
        'SecondaryRATDataUsageReportTransfer-ExtIEs',
        'SecurityContext-ExtIEs',
        'SecurityIndication-ExtIEs',
        'SecurityResult-ExtIEs',
        'SensorMeasurementConfiguration-ExtIEs',
        'SensorMeasConfigNameItem-ExtIEs',
        'SensorNameConfig-ExtIEs',
        'ServedGUAMIItem-ExtIEs',
        'ServiceAreaInformation-Item-ExtIEs',
        'SharedNGU-MulticastTNLInformation-ExtIEs',
        'SliceOverloadItem-ExtIEs',
        'SliceSupportItem-ExtIEs',
        'SliceSupportQMC-Item-ExtIEs',
        'SNPN-MobilityInformation-ExtIEs',
        'S-NSSAI-ExtIEs',
        'SONConfigurationTransfer-ExtIEs',
        'SONInformation-ExtIEs',
        'SONInformationReply-ExtIEs',
        'SONInformationReport-ExtIEs',
        'SuccessfulHandoverReport-Item-ExtIEs',
        'SourceNGRANNode-ToTargetNGRANNode-TransparentContainer-ExtIEs',
        'SourceNodeID-ExtIEs',
        'SourceRANNodeID-ExtIEs',
        'SourceToTarget-AMFInformationReroute-ExtIEs',
        'SupportedTAItem-ExtIEs',
        'TAI-ExtIEs',
        'TAIBroadcastEUTRA-Item-ExtIEs',
        'TAIBroadcastNR-Item-ExtIEs',
        'TAICancelledEUTRA-Item-ExtIEs',
        'TAICancelledNR-Item-ExtIEs',
        'TAIListForInactiveItem-ExtIEs',
        'TAIListForPagingItem-ExtIEs',
        'TAINSAGSupportItem-ExtIEs',
        'TargeteNB-ID-ExtIEs',
        'TargetHomeENB-ID-ExtIEs',
        'TargetID-ExtIEs',
        'TargetNGRANNode-ToSourceNGRANNode-TransparentContainer-ExtIEs',
        'TargetNGRANNode-ToSourceNGRANNode-FailureTransparentContainer-ExtIEs',
        'TargetNSSAI-Item-ExtIEs',
        'TargetNSSAIInformation-Item-ExtIEs',
        'TargetRANNodeID-ExtIEs',
        'TargetRANNodeID-RIM-ExtIEs',
        'TargetRANNodeID-SON-ExtIEs',
        'TargetRNC-ID-ExtIEs',
        'TimeSyncAssistanceInfo-ExtIEs',
        'TNGF-ID-ExtIEs',
        'TNLAssociationItem-ExtIEs',
        'TooearlyIntersystemHO-ExtIEs',
        'TraceActivation-ExtIEs',
        'TAIBasedMDT-ExtIEs',
        'TAIBasedQMC-ExtIEs',
        'TABasedQMC-ExtIEs',
        'TABasedMDT-ExtIEs',
        'TWIF-ID-ExtIEs',
        'TSCAssistanceInformation-ExtIEs',
        'TSCTrafficCharacteristics-ExtIEs',
        'UEAggregateMaximumBitRate-ExtIEs',
        'UEAppLayerMeasInfoItem-ExtIEs',
        'UEAppLayerMeasConfigInfo-ExtIEs',
        'UE-associatedLogicalNG-connectionItem-ExtIEs',
        'UEContextResumeRequestTransfer-ExtIEs',
        'UEContextResumeResponseTransfer-ExtIEs',
        'UEContextSuspendRequestTransfer-ExtIEs',
        'UE-DifferentiationInfo-ExtIEs',
        'UEHistoryInformationFromTheUE-ExtIEs',
        'UEIdentityIndexValue-ExtIEs',
        'UE-NGAP-IDs-ExtIEs',
        'UE-NGAP-ID-pair-ExtIEs',
        'UEPagingIdentity-ExtIEs',
        'UEPresenceInAreaOfInterestItem-ExtIEs',
        'UERadioCapabilityForPaging-ExtIEs',
        'UERLFReportContainer-ExtIEs',
        'UESecurityCapabilities-ExtIEs',
        'UESliceMaximumBitRateItem-ExtIEs',
        'UL-CP-SecurityInformation-ExtIEs',
        'UL-NGU-UP-TNLModifyItem-ExtIEs',
        'UnavailableGUAMIItem-ExtIEs',
        'UPTransportLayerInformation-ExtIEs',
        'UPTransportLayerInformationItem-ExtIEs',
        'UPTransportLayerInformationPairItem-ExtIEs',
        'UserLocationInformation-ExtIEs',
        'UserLocationInformationEUTRA-ExtIEs',
        'UserLocationInformationN3IWF-ExtIEs',
        'UserLocationInformationTNGF-ExtIEs',
        'UserLocationInformationTWIF-ExtIEs',
        'UserLocationInformationW-AGF-ExtIEs',
        'UserLocationInformationNR-ExtIEs',
        'UserPlaneSecurityInformation-ExtIEs',
        'VolumeTimedReport-Item-ExtIEs',
        'W-AGF-ID-ExtIEs',
        'WarningAreaList-ExtIEs',
        'WLANMeasurementConfiguration-ExtIEs',
        'WLANMeasConfigNameItem-ExtIEs',
        'WUS-Assistance-Information-ExtIEs',
        'XnExtTLA-Item-ExtIEs',
        'XnTNLConfigurationInfo-ExtIEs',
        ]
    _param_ = [
        ]
    
    #-----< AdditionalDLUPTNLInformationForHOList >-----#
    AdditionalDLUPTNLInformationForHOList = SEQ_OF(name='AdditionalDLUPTNLInformationForHOList', mode=MODE_TYPE)
    _AdditionalDLUPTNLInformationForHOList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AdditionalDLUPTNLInformationForHOItem')))
    AdditionalDLUPTNLInformationForHOList._cont = _AdditionalDLUPTNLInformationForHOList__item_
    AdditionalDLUPTNLInformationForHOList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< AdditionalDLUPTNLInformationForHOItem >-----#
    AdditionalDLUPTNLInformationForHOItem = SEQ(name='AdditionalDLUPTNLInformationForHOItem', mode=MODE_TYPE)
    _AdditionalDLUPTNLInformationForHOItem_additionalDL_NGU_UP_TNLInformation = CHOICE(name='additionalDL-NGU-UP-TNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _AdditionalDLUPTNLInformationForHOItem_additionalQosFlowSetupResponseList = SEQ_OF(name='additionalQosFlowSetupResponseList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithDataForwarding')))
    _AdditionalDLUPTNLInformationForHOItem_additionalDLForwardingUPTNLInformation = CHOICE(name='additionalDLForwardingUPTNLInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')), opt=True)
    _AdditionalDLUPTNLInformationForHOItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    ____AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 183), ('criticality', 'ignore'), ('Extension', _____AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id._const_tab = ____AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id_tab
    ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id._const_tab_at = None
    ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__criticality._const_tab = ____AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id_tab
    ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__extensionValue._const_tab = ____AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id_tab
    ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id),
        ('criticality', ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__criticality),
        ('extensionValue', ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__extensionValue),
        ])
    __AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item_._ext = None
    _AdditionalDLUPTNLInformationForHOItem_iE_Extensions._cont = __AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item_
    _AdditionalDLUPTNLInformationForHOItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AdditionalDLUPTNLInformationForHOItem._cont = ASN1Dict([
        ('additionalDL-NGU-UP-TNLInformation', _AdditionalDLUPTNLInformationForHOItem_additionalDL_NGU_UP_TNLInformation),
        ('additionalQosFlowSetupResponseList', _AdditionalDLUPTNLInformationForHOItem_additionalQosFlowSetupResponseList),
        ('additionalDLForwardingUPTNLInformation', _AdditionalDLUPTNLInformationForHOItem_additionalDLForwardingUPTNLInformation),
        ('iE-Extensions', _AdditionalDLUPTNLInformationForHOItem_iE_Extensions),
        ])
    AdditionalDLUPTNLInformationForHOItem._ext = []
    
    #-----< AdditionalDLUPTNLInformationForHOItem-ExtIEs >-----#
    AdditionalDLUPTNLInformationForHOItem_ExtIEs = CLASS(name='AdditionalDLUPTNLInformationForHOItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _AdditionalDLUPTNLInformationForHOItem_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    AdditionalDLUPTNLInformationForHOItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 183), ('criticality', 'ignore'), ('Extension', _AdditionalDLUPTNLInformationForHOItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< AdditionalQosFlowInformation >-----#
    AdditionalQosFlowInformation = ENUM(name='AdditionalQosFlowInformation', mode=MODE_TYPE)
    AdditionalQosFlowInformation._cont = ASN1Dict([('more-likely', 0)])
    AdditionalQosFlowInformation._ext = []
    
    #-----< AllocationAndRetentionPriority >-----#
    AllocationAndRetentionPriority = SEQ(name='AllocationAndRetentionPriority', mode=MODE_TYPE)
    _AllocationAndRetentionPriority_priorityLevelARP = INT(name='priorityLevelARP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PriorityLevelARP')))
    _AllocationAndRetentionPriority_pre_emptionCapability = ENUM(name='pre-emptionCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Pre-emptionCapability')))
    _AllocationAndRetentionPriority_pre_emptionVulnerability = ENUM(name='pre-emptionVulnerability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Pre-emptionVulnerability')))
    _AllocationAndRetentionPriority_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AllocationAndRetentionPriority_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AllocationAndRetentionPriority_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab_at = None
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab_id = 'id'
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AllocationAndRetentionPriority_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AllocationAndRetentionPriority_iE_Extensions__item__id),
        ('criticality', ___AllocationAndRetentionPriority_iE_Extensions__item__criticality),
        ('extensionValue', ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue),
        ])
    __AllocationAndRetentionPriority_iE_Extensions__item_._ext = None
    _AllocationAndRetentionPriority_iE_Extensions._cont = __AllocationAndRetentionPriority_iE_Extensions__item_
    _AllocationAndRetentionPriority_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AllocationAndRetentionPriority._cont = ASN1Dict([
        ('priorityLevelARP', _AllocationAndRetentionPriority_priorityLevelARP),
        ('pre-emptionCapability', _AllocationAndRetentionPriority_pre_emptionCapability),
        ('pre-emptionVulnerability', _AllocationAndRetentionPriority_pre_emptionVulnerability),
        ('iE-Extensions', _AllocationAndRetentionPriority_iE_Extensions),
        ])
    AllocationAndRetentionPriority._ext = []
    
    #-----< AllocationAndRetentionPriority-ExtIEs >-----#
    AllocationAndRetentionPriority_ExtIEs = CLASS(name='AllocationAndRetentionPriority-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AllocationAndRetentionPriority_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Allowed-CAG-List-per-PLMN >-----#
    Allowed_CAG_List_per_PLMN = SEQ_OF(name='Allowed-CAG-List-per-PLMN', mode=MODE_TYPE)
    _Allowed_CAG_List_per_PLMN__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CAG-ID')))
    Allowed_CAG_List_per_PLMN._cont = _Allowed_CAG_List_per_PLMN__item_
    Allowed_CAG_List_per_PLMN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< AllowedNSSAI >-----#
    AllowedNSSAI = SEQ_OF(name='AllowedNSSAI', mode=MODE_TYPE)
    _AllowedNSSAI__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI-Item')))
    AllowedNSSAI._cont = _AllowedNSSAI__item_
    AllowedNSSAI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< AllowedNSSAI-Item >-----#
    AllowedNSSAI_Item = SEQ(name='AllowedNSSAI-Item', mode=MODE_TYPE)
    _AllowedNSSAI_Item_s_NSSAI = SEQ(name='s-NSSAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _AllowedNSSAI_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AllowedNSSAI_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AllowedNSSAI_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____AllowedNSSAI_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AllowedNSSAI_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllowedNSSAI_Item_iE_Extensions__item__id._const_tab = ____AllowedNSSAI_Item_iE_Extensions__item__id_tab
    ___AllowedNSSAI_Item_iE_Extensions__item__id._const_tab_at = None
    ___AllowedNSSAI_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___AllowedNSSAI_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AllowedNSSAI_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AllowedNSSAI_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllowedNSSAI_Item_iE_Extensions__item__criticality._const_tab = ____AllowedNSSAI_Item_iE_Extensions__item__criticality_tab
    ___AllowedNSSAI_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AllowedNSSAI_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AllowedNSSAI_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AllowedNSSAI_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AllowedNSSAI_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllowedNSSAI_Item_iE_Extensions__item__extensionValue._const_tab = ____AllowedNSSAI_Item_iE_Extensions__item__extensionValue_tab
    ___AllowedNSSAI_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AllowedNSSAI_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AllowedNSSAI_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AllowedNSSAI_Item_iE_Extensions__item__id),
        ('criticality', ___AllowedNSSAI_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___AllowedNSSAI_Item_iE_Extensions__item__extensionValue),
        ])
    __AllowedNSSAI_Item_iE_Extensions__item_._ext = None
    _AllowedNSSAI_Item_iE_Extensions._cont = __AllowedNSSAI_Item_iE_Extensions__item_
    _AllowedNSSAI_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AllowedNSSAI_Item._cont = ASN1Dict([
        ('s-NSSAI', _AllowedNSSAI_Item_s_NSSAI),
        ('iE-Extensions', _AllowedNSSAI_Item_iE_Extensions),
        ])
    AllowedNSSAI_Item._ext = []
    
    #-----< AllowedNSSAI-Item-ExtIEs >-----#
    AllowedNSSAI_Item_ExtIEs = CLASS(name='AllowedNSSAI-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AllowedNSSAI_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Allowed-PNI-NPN-List >-----#
    Allowed_PNI_NPN_List = SEQ_OF(name='Allowed-PNI-NPN-List', mode=MODE_TYPE)
    _Allowed_PNI_NPN_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Allowed-PNI-NPN-Item')))
    Allowed_PNI_NPN_List._cont = _Allowed_PNI_NPN_List__item_
    Allowed_PNI_NPN_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Allowed-PNI-NPN-Item >-----#
    Allowed_PNI_NPN_Item = SEQ(name='Allowed-PNI-NPN-Item', mode=MODE_TYPE)
    _Allowed_PNI_NPN_Item_pLMNIdentity = OCT_STR(name='pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _Allowed_PNI_NPN_Item_pNI_NPN_restricted = ENUM(name='pNI-NPN-restricted', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Allowed_PNI_NPN_Item_pNI_NPN_restricted._cont = ASN1Dict([('restricted', 0), ('not-restricted', 1)])
    _Allowed_PNI_NPN_Item_pNI_NPN_restricted._ext = []
    _Allowed_PNI_NPN_Item_allowed_CAG_List_per_PLMN = SEQ_OF(name='allowed-CAG-List-per-PLMN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Allowed-CAG-List-per-PLMN')))
    _Allowed_PNI_NPN_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Allowed_PNI_NPN_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___Allowed_PNI_NPN_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____Allowed_PNI_NPN_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____Allowed_PNI_NPN_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Allowed_PNI_NPN_Item_iE_Extensions__item__id._const_tab = ____Allowed_PNI_NPN_Item_iE_Extensions__item__id_tab
    ___Allowed_PNI_NPN_Item_iE_Extensions__item__id._const_tab_at = None
    ___Allowed_PNI_NPN_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Allowed_PNI_NPN_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Allowed_PNI_NPN_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____Allowed_PNI_NPN_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Allowed_PNI_NPN_Item_iE_Extensions__item__criticality._const_tab = ____Allowed_PNI_NPN_Item_iE_Extensions__item__criticality_tab
    ___Allowed_PNI_NPN_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Allowed_PNI_NPN_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Allowed_PNI_NPN_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Allowed_PNI_NPN_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____Allowed_PNI_NPN_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Allowed_PNI_NPN_Item_iE_Extensions__item__extensionValue._const_tab = ____Allowed_PNI_NPN_Item_iE_Extensions__item__extensionValue_tab
    ___Allowed_PNI_NPN_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Allowed_PNI_NPN_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Allowed_PNI_NPN_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Allowed_PNI_NPN_Item_iE_Extensions__item__id),
        ('criticality', ___Allowed_PNI_NPN_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Allowed_PNI_NPN_Item_iE_Extensions__item__extensionValue),
        ])
    __Allowed_PNI_NPN_Item_iE_Extensions__item_._ext = None
    _Allowed_PNI_NPN_Item_iE_Extensions._cont = __Allowed_PNI_NPN_Item_iE_Extensions__item_
    _Allowed_PNI_NPN_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Allowed_PNI_NPN_Item._cont = ASN1Dict([
        ('pLMNIdentity', _Allowed_PNI_NPN_Item_pLMNIdentity),
        ('pNI-NPN-restricted', _Allowed_PNI_NPN_Item_pNI_NPN_restricted),
        ('allowed-CAG-List-per-PLMN', _Allowed_PNI_NPN_Item_allowed_CAG_List_per_PLMN),
        ('iE-Extensions', _Allowed_PNI_NPN_Item_iE_Extensions),
        ])
    Allowed_PNI_NPN_Item._ext = []
    
    #-----< Allowed-PNI-NPN-Item-ExtIEs >-----#
    Allowed_PNI_NPN_Item_ExtIEs = CLASS(name='Allowed-PNI-NPN-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    Allowed_PNI_NPN_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AllowedTACs >-----#
    AllowedTACs = SEQ_OF(name='AllowedTACs', mode=MODE_TYPE)
    _AllowedTACs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAC')))
    AllowedTACs._cont = _AllowedTACs__item_
    AllowedTACs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< AlternativeQoSParaSetIndex >-----#
    AlternativeQoSParaSetIndex = INT(name='AlternativeQoSParaSetIndex', mode=MODE_TYPE)
    AlternativeQoSParaSetIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=[], er=[])
    
    #-----< AlternativeQoSParaSetNotifyIndex >-----#
    AlternativeQoSParaSetNotifyIndex = INT(name='AlternativeQoSParaSetNotifyIndex', mode=MODE_TYPE)
    AlternativeQoSParaSetNotifyIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=[], er=[])
    
    #-----< AlternativeQoSParaSetList >-----#
    AlternativeQoSParaSetList = SEQ_OF(name='AlternativeQoSParaSetList', mode=MODE_TYPE)
    _AlternativeQoSParaSetList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetItem')))
    AlternativeQoSParaSetList._cont = _AlternativeQoSParaSetList__item_
    AlternativeQoSParaSetList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< AlternativeQoSParaSetItem >-----#
    AlternativeQoSParaSetItem = SEQ(name='AlternativeQoSParaSetItem', mode=MODE_TYPE)
    _AlternativeQoSParaSetItem_alternativeQoSParaSetIndex = INT(name='alternativeQoSParaSetIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetIndex')))
    _AlternativeQoSParaSetItem_guaranteedFlowBitRateDL = INT(name='guaranteedFlowBitRateDL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')), opt=True)
    _AlternativeQoSParaSetItem_guaranteedFlowBitRateUL = INT(name='guaranteedFlowBitRateUL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')), opt=True)
    _AlternativeQoSParaSetItem_packetDelayBudget = INT(name='packetDelayBudget', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PacketDelayBudget')), opt=True)
    _AlternativeQoSParaSetItem_packetErrorRate = SEQ(name='packetErrorRate', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PacketErrorRate')), opt=True)
    _AlternativeQoSParaSetItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AlternativeQoSParaSetItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AlternativeQoSParaSetItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AlternativeQoSParaSetItem_iE_Extensions__item__id._const_tab = ____AlternativeQoSParaSetItem_iE_Extensions__item__id_tab
    ___AlternativeQoSParaSetItem_iE_Extensions__item__id._const_tab_at = None
    ___AlternativeQoSParaSetItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality._const_tab = ____AlternativeQoSParaSetItem_iE_Extensions__item__criticality_tab
    ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue._const_tab = ____AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue_tab
    ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AlternativeQoSParaSetItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AlternativeQoSParaSetItem_iE_Extensions__item__id),
        ('criticality', ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality),
        ('extensionValue', ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue),
        ])
    __AlternativeQoSParaSetItem_iE_Extensions__item_._ext = None
    _AlternativeQoSParaSetItem_iE_Extensions._cont = __AlternativeQoSParaSetItem_iE_Extensions__item_
    _AlternativeQoSParaSetItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AlternativeQoSParaSetItem._cont = ASN1Dict([
        ('alternativeQoSParaSetIndex', _AlternativeQoSParaSetItem_alternativeQoSParaSetIndex),
        ('guaranteedFlowBitRateDL', _AlternativeQoSParaSetItem_guaranteedFlowBitRateDL),
        ('guaranteedFlowBitRateUL', _AlternativeQoSParaSetItem_guaranteedFlowBitRateUL),
        ('packetDelayBudget', _AlternativeQoSParaSetItem_packetDelayBudget),
        ('packetErrorRate', _AlternativeQoSParaSetItem_packetErrorRate),
        ('iE-Extensions', _AlternativeQoSParaSetItem_iE_Extensions),
        ])
    AlternativeQoSParaSetItem._ext = []
    
    #-----< AlternativeQoSParaSetItem-ExtIEs >-----#
    AlternativeQoSParaSetItem_ExtIEs = CLASS(name='AlternativeQoSParaSetItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AlternativeQoSParaSetItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AMFName >-----#
    AMFName = STR_PRINT(name='AMFName', mode=MODE_TYPE)
    AMFName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< AMFNameVisibleString >-----#
    AMFNameVisibleString = STR_VIS(name='AMFNameVisibleString', mode=MODE_TYPE)
    AMFNameVisibleString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< AMFNameUTF8String >-----#
    AMFNameUTF8String = STR_UTF8(name='AMFNameUTF8String', mode=MODE_TYPE)
    AMFNameUTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< AMFPagingTarget >-----#
    AMFPagingTarget = CHOICE(name='AMFPagingTarget', mode=MODE_TYPE)
    _AMFPagingTarget_globalRANNodeID = CHOICE(name='globalRANNodeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _AMFPagingTarget_tAI = SEQ(name='tAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _AMFPagingTarget_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __AMFPagingTarget_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___AMFPagingTarget_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___AMFPagingTarget_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AMFPagingTarget_choice_Extensions_id._const_tab = ___AMFPagingTarget_choice_Extensions_id_tab
    __AMFPagingTarget_choice_Extensions_id._const_tab_at = None
    __AMFPagingTarget_choice_Extensions_id._const_tab_id = 'id'
    __AMFPagingTarget_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___AMFPagingTarget_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___AMFPagingTarget_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AMFPagingTarget_choice_Extensions_criticality._const_tab = ___AMFPagingTarget_choice_Extensions_criticality_tab
    __AMFPagingTarget_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __AMFPagingTarget_choice_Extensions_criticality._const_tab_id = 'criticality'
    __AMFPagingTarget_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___AMFPagingTarget_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___AMFPagingTarget_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AMFPagingTarget_choice_Extensions_value._const_tab = ___AMFPagingTarget_choice_Extensions_value_tab
    __AMFPagingTarget_choice_Extensions_value._const_tab_at = ('..', 'id')
    __AMFPagingTarget_choice_Extensions_value._const_tab_id = 'Value'
    _AMFPagingTarget_choice_Extensions._cont = ASN1Dict([
        ('id', __AMFPagingTarget_choice_Extensions_id),
        ('criticality', __AMFPagingTarget_choice_Extensions_criticality),
        ('value', __AMFPagingTarget_choice_Extensions_value),
        ])
    _AMFPagingTarget_choice_Extensions._ext = None
    AMFPagingTarget._cont = ASN1Dict([
        ('globalRANNodeID', _AMFPagingTarget_globalRANNodeID),
        ('tAI', _AMFPagingTarget_tAI),
        ('choice-Extensions', _AMFPagingTarget_choice_Extensions),
        ])
    AMFPagingTarget._ext = None
    
    #-----< AMFPagingTarget-ExtIEs >-----#
    AMFPagingTarget_ExtIEs = CLASS(name='AMFPagingTarget-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    AMFPagingTarget_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AMFPointer >-----#
    AMFPointer = BIT_STR(name='AMFPointer', mode=MODE_TYPE)
    AMFPointer._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< AMFRegionID >-----#
    AMFRegionID = BIT_STR(name='AMFRegionID', mode=MODE_TYPE)
    AMFRegionID._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< AMFSetID >-----#
    AMFSetID = BIT_STR(name='AMFSetID', mode=MODE_TYPE)
    AMFSetID._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    
    #-----< AMF-TNLAssociationSetupList >-----#
    AMF_TNLAssociationSetupList = SEQ_OF(name='AMF-TNLAssociationSetupList', mode=MODE_TYPE)
    _AMF_TNLAssociationSetupList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-TNLAssociationSetupItem')))
    AMF_TNLAssociationSetupList._cont = _AMF_TNLAssociationSetupList__item_
    AMF_TNLAssociationSetupList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< AMF-TNLAssociationSetupItem >-----#
    AMF_TNLAssociationSetupItem = SEQ(name='AMF-TNLAssociationSetupItem', mode=MODE_TYPE)
    _AMF_TNLAssociationSetupItem_aMF_TNLAssociationAddress = CHOICE(name='aMF-TNLAssociationAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CPTransportLayerInformation')))
    _AMF_TNLAssociationSetupItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AMF_TNLAssociationSetupItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AMF_TNLAssociationSetupItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____AMF_TNLAssociationSetupItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AMF_TNLAssociationSetupItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AMF_TNLAssociationSetupItem_iE_Extensions__item__id._const_tab = ____AMF_TNLAssociationSetupItem_iE_Extensions__item__id_tab
    ___AMF_TNLAssociationSetupItem_iE_Extensions__item__id._const_tab_at = None
    ___AMF_TNLAssociationSetupItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___AMF_TNLAssociationSetupItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AMF_TNLAssociationSetupItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AMF_TNLAssociationSetupItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AMF_TNLAssociationSetupItem_iE_Extensions__item__criticality._const_tab = ____AMF_TNLAssociationSetupItem_iE_Extensions__item__criticality_tab
    ___AMF_TNLAssociationSetupItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AMF_TNLAssociationSetupItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AMF_TNLAssociationSetupItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AMF_TNLAssociationSetupItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AMF_TNLAssociationSetupItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AMF_TNLAssociationSetupItem_iE_Extensions__item__extensionValue._const_tab = ____AMF_TNLAssociationSetupItem_iE_Extensions__item__extensionValue_tab
    ___AMF_TNLAssociationSetupItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AMF_TNLAssociationSetupItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AMF_TNLAssociationSetupItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AMF_TNLAssociationSetupItem_iE_Extensions__item__id),
        ('criticality', ___AMF_TNLAssociationSetupItem_iE_Extensions__item__criticality),
        ('extensionValue', ___AMF_TNLAssociationSetupItem_iE_Extensions__item__extensionValue),
        ])
    __AMF_TNLAssociationSetupItem_iE_Extensions__item_._ext = None
    _AMF_TNLAssociationSetupItem_iE_Extensions._cont = __AMF_TNLAssociationSetupItem_iE_Extensions__item_
    _AMF_TNLAssociationSetupItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AMF_TNLAssociationSetupItem._cont = ASN1Dict([
        ('aMF-TNLAssociationAddress', _AMF_TNLAssociationSetupItem_aMF_TNLAssociationAddress),
        ('iE-Extensions', _AMF_TNLAssociationSetupItem_iE_Extensions),
        ])
    AMF_TNLAssociationSetupItem._ext = []
    
    #-----< AMF-TNLAssociationSetupItem-ExtIEs >-----#
    AMF_TNLAssociationSetupItem_ExtIEs = CLASS(name='AMF-TNLAssociationSetupItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AMF_TNLAssociationSetupItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AMF-TNLAssociationToAddList >-----#
    AMF_TNLAssociationToAddList = SEQ_OF(name='AMF-TNLAssociationToAddList', mode=MODE_TYPE)
    _AMF_TNLAssociationToAddList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-TNLAssociationToAddItem')))
    AMF_TNLAssociationToAddList._cont = _AMF_TNLAssociationToAddList__item_
    AMF_TNLAssociationToAddList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< AMF-TNLAssociationToAddItem >-----#
    AMF_TNLAssociationToAddItem = SEQ(name='AMF-TNLAssociationToAddItem', mode=MODE_TYPE)
    _AMF_TNLAssociationToAddItem_aMF_TNLAssociationAddress = CHOICE(name='aMF-TNLAssociationAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CPTransportLayerInformation')))
    _AMF_TNLAssociationToAddItem_tNLAssociationUsage = ENUM(name='tNLAssociationUsage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TNLAssociationUsage')), opt=True)
    _AMF_TNLAssociationToAddItem_tNLAddressWeightFactor = INT(name='tNLAddressWeightFactor', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TNLAddressWeightFactor')))
    _AMF_TNLAssociationToAddItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AMF_TNLAssociationToAddItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AMF_TNLAssociationToAddItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____AMF_TNLAssociationToAddItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AMF_TNLAssociationToAddItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AMF_TNLAssociationToAddItem_iE_Extensions__item__id._const_tab = ____AMF_TNLAssociationToAddItem_iE_Extensions__item__id_tab
    ___AMF_TNLAssociationToAddItem_iE_Extensions__item__id._const_tab_at = None
    ___AMF_TNLAssociationToAddItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___AMF_TNLAssociationToAddItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AMF_TNLAssociationToAddItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AMF_TNLAssociationToAddItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AMF_TNLAssociationToAddItem_iE_Extensions__item__criticality._const_tab = ____AMF_TNLAssociationToAddItem_iE_Extensions__item__criticality_tab
    ___AMF_TNLAssociationToAddItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AMF_TNLAssociationToAddItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AMF_TNLAssociationToAddItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AMF_TNLAssociationToAddItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AMF_TNLAssociationToAddItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AMF_TNLAssociationToAddItem_iE_Extensions__item__extensionValue._const_tab = ____AMF_TNLAssociationToAddItem_iE_Extensions__item__extensionValue_tab
    ___AMF_TNLAssociationToAddItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AMF_TNLAssociationToAddItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AMF_TNLAssociationToAddItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AMF_TNLAssociationToAddItem_iE_Extensions__item__id),
        ('criticality', ___AMF_TNLAssociationToAddItem_iE_Extensions__item__criticality),
        ('extensionValue', ___AMF_TNLAssociationToAddItem_iE_Extensions__item__extensionValue),
        ])
    __AMF_TNLAssociationToAddItem_iE_Extensions__item_._ext = None
    _AMF_TNLAssociationToAddItem_iE_Extensions._cont = __AMF_TNLAssociationToAddItem_iE_Extensions__item_
    _AMF_TNLAssociationToAddItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AMF_TNLAssociationToAddItem._cont = ASN1Dict([
        ('aMF-TNLAssociationAddress', _AMF_TNLAssociationToAddItem_aMF_TNLAssociationAddress),
        ('tNLAssociationUsage', _AMF_TNLAssociationToAddItem_tNLAssociationUsage),
        ('tNLAddressWeightFactor', _AMF_TNLAssociationToAddItem_tNLAddressWeightFactor),
        ('iE-Extensions', _AMF_TNLAssociationToAddItem_iE_Extensions),
        ])
    AMF_TNLAssociationToAddItem._ext = []
    
    #-----< AMF-TNLAssociationToAddItem-ExtIEs >-----#
    AMF_TNLAssociationToAddItem_ExtIEs = CLASS(name='AMF-TNLAssociationToAddItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AMF_TNLAssociationToAddItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AMF-TNLAssociationToRemoveList >-----#
    AMF_TNLAssociationToRemoveList = SEQ_OF(name='AMF-TNLAssociationToRemoveList', mode=MODE_TYPE)
    _AMF_TNLAssociationToRemoveList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-TNLAssociationToRemoveItem')))
    AMF_TNLAssociationToRemoveList._cont = _AMF_TNLAssociationToRemoveList__item_
    AMF_TNLAssociationToRemoveList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< AMF-TNLAssociationToRemoveItem >-----#
    AMF_TNLAssociationToRemoveItem = SEQ(name='AMF-TNLAssociationToRemoveItem', mode=MODE_TYPE)
    _AMF_TNLAssociationToRemoveItem_aMF_TNLAssociationAddress = CHOICE(name='aMF-TNLAssociationAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CPTransportLayerInformation')))
    _AMF_TNLAssociationToRemoveItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AMF_TNLAssociationToRemoveItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CPTransportLayerInformation')))
    ____AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 168), ('criticality', 'reject'), ('Extension', _____AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id._const_tab = ____AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id_tab
    ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id._const_tab_at = None
    ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__criticality._const_tab = ____AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id_tab
    ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue._const_tab = ____AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id_tab
    ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AMF_TNLAssociationToRemoveItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id),
        ('criticality', ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__criticality),
        ('extensionValue', ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue),
        ])
    __AMF_TNLAssociationToRemoveItem_iE_Extensions__item_._ext = None
    _AMF_TNLAssociationToRemoveItem_iE_Extensions._cont = __AMF_TNLAssociationToRemoveItem_iE_Extensions__item_
    _AMF_TNLAssociationToRemoveItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AMF_TNLAssociationToRemoveItem._cont = ASN1Dict([
        ('aMF-TNLAssociationAddress', _AMF_TNLAssociationToRemoveItem_aMF_TNLAssociationAddress),
        ('iE-Extensions', _AMF_TNLAssociationToRemoveItem_iE_Extensions),
        ])
    AMF_TNLAssociationToRemoveItem._ext = []
    
    #-----< AMF-TNLAssociationToRemoveItem-ExtIEs >-----#
    AMF_TNLAssociationToRemoveItem_ExtIEs = CLASS(name='AMF-TNLAssociationToRemoveItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _AMF_TNLAssociationToRemoveItem_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CPTransportLayerInformation')))
    AMF_TNLAssociationToRemoveItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 168), ('criticality', 'reject'), ('Extension', _AMF_TNLAssociationToRemoveItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< AMF-TNLAssociationToUpdateList >-----#
    AMF_TNLAssociationToUpdateList = SEQ_OF(name='AMF-TNLAssociationToUpdateList', mode=MODE_TYPE)
    _AMF_TNLAssociationToUpdateList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-TNLAssociationToUpdateItem')))
    AMF_TNLAssociationToUpdateList._cont = _AMF_TNLAssociationToUpdateList__item_
    AMF_TNLAssociationToUpdateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< AMF-TNLAssociationToUpdateItem >-----#
    AMF_TNLAssociationToUpdateItem = SEQ(name='AMF-TNLAssociationToUpdateItem', mode=MODE_TYPE)
    _AMF_TNLAssociationToUpdateItem_aMF_TNLAssociationAddress = CHOICE(name='aMF-TNLAssociationAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CPTransportLayerInformation')))
    _AMF_TNLAssociationToUpdateItem_tNLAssociationUsage = ENUM(name='tNLAssociationUsage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TNLAssociationUsage')), opt=True)
    _AMF_TNLAssociationToUpdateItem_tNLAddressWeightFactor = INT(name='tNLAddressWeightFactor', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TNLAddressWeightFactor')), opt=True)
    _AMF_TNLAssociationToUpdateItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AMF_TNLAssociationToUpdateItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____AMF_TNLAssociationToUpdateItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AMF_TNLAssociationToUpdateItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__id._const_tab = ____AMF_TNLAssociationToUpdateItem_iE_Extensions__item__id_tab
    ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__id._const_tab_at = None
    ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AMF_TNLAssociationToUpdateItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AMF_TNLAssociationToUpdateItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__criticality._const_tab = ____AMF_TNLAssociationToUpdateItem_iE_Extensions__item__criticality_tab
    ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AMF_TNLAssociationToUpdateItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AMF_TNLAssociationToUpdateItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__extensionValue._const_tab = ____AMF_TNLAssociationToUpdateItem_iE_Extensions__item__extensionValue_tab
    ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AMF_TNLAssociationToUpdateItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__id),
        ('criticality', ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__criticality),
        ('extensionValue', ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__extensionValue),
        ])
    __AMF_TNLAssociationToUpdateItem_iE_Extensions__item_._ext = None
    _AMF_TNLAssociationToUpdateItem_iE_Extensions._cont = __AMF_TNLAssociationToUpdateItem_iE_Extensions__item_
    _AMF_TNLAssociationToUpdateItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AMF_TNLAssociationToUpdateItem._cont = ASN1Dict([
        ('aMF-TNLAssociationAddress', _AMF_TNLAssociationToUpdateItem_aMF_TNLAssociationAddress),
        ('tNLAssociationUsage', _AMF_TNLAssociationToUpdateItem_tNLAssociationUsage),
        ('tNLAddressWeightFactor', _AMF_TNLAssociationToUpdateItem_tNLAddressWeightFactor),
        ('iE-Extensions', _AMF_TNLAssociationToUpdateItem_iE_Extensions),
        ])
    AMF_TNLAssociationToUpdateItem._ext = []
    
    #-----< AMF-TNLAssociationToUpdateItem-ExtIEs >-----#
    AMF_TNLAssociationToUpdateItem_ExtIEs = CLASS(name='AMF-TNLAssociationToUpdateItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AMF_TNLAssociationToUpdateItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AMF-UE-NGAP-ID >-----#
    AMF_UE_NGAP_ID = INT(name='AMF-UE-NGAP-ID', mode=MODE_TYPE)
    AMF_UE_NGAP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1099511627775)], ev=None, er=[])
    
    #-----< AreaOfInterest >-----#
    AreaOfInterest = SEQ(name='AreaOfInterest', mode=MODE_TYPE)
    _AreaOfInterest_areaOfInterestTAIList = SEQ_OF(name='areaOfInterestTAIList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AreaOfInterestTAIList')), opt=True)
    _AreaOfInterest_areaOfInterestCellList = SEQ_OF(name='areaOfInterestCellList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AreaOfInterestCellList')), opt=True)
    _AreaOfInterest_areaOfInterestRANNodeList = SEQ_OF(name='areaOfInterestRANNodeList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AreaOfInterestRANNodeList')), opt=True)
    _AreaOfInterest_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AreaOfInterest_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AreaOfInterest_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____AreaOfInterest_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterest_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterest_iE_Extensions__item__id._const_tab = ____AreaOfInterest_iE_Extensions__item__id_tab
    ___AreaOfInterest_iE_Extensions__item__id._const_tab_at = None
    ___AreaOfInterest_iE_Extensions__item__id._const_tab_id = 'id'
    ___AreaOfInterest_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AreaOfInterest_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterest_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterest_iE_Extensions__item__criticality._const_tab = ____AreaOfInterest_iE_Extensions__item__criticality_tab
    ___AreaOfInterest_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AreaOfInterest_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AreaOfInterest_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AreaOfInterest_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterest_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterest_iE_Extensions__item__extensionValue._const_tab = ____AreaOfInterest_iE_Extensions__item__extensionValue_tab
    ___AreaOfInterest_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AreaOfInterest_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AreaOfInterest_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AreaOfInterest_iE_Extensions__item__id),
        ('criticality', ___AreaOfInterest_iE_Extensions__item__criticality),
        ('extensionValue', ___AreaOfInterest_iE_Extensions__item__extensionValue),
        ])
    __AreaOfInterest_iE_Extensions__item_._ext = None
    _AreaOfInterest_iE_Extensions._cont = __AreaOfInterest_iE_Extensions__item_
    _AreaOfInterest_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AreaOfInterest._cont = ASN1Dict([
        ('areaOfInterestTAIList', _AreaOfInterest_areaOfInterestTAIList),
        ('areaOfInterestCellList', _AreaOfInterest_areaOfInterestCellList),
        ('areaOfInterestRANNodeList', _AreaOfInterest_areaOfInterestRANNodeList),
        ('iE-Extensions', _AreaOfInterest_iE_Extensions),
        ])
    AreaOfInterest._ext = []
    
    #-----< AreaOfInterest-ExtIEs >-----#
    AreaOfInterest_ExtIEs = CLASS(name='AreaOfInterest-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AreaOfInterest_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AreaOfInterestCellList >-----#
    AreaOfInterestCellList = SEQ_OF(name='AreaOfInterestCellList', mode=MODE_TYPE)
    _AreaOfInterestCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AreaOfInterestCellItem')))
    AreaOfInterestCellList._cont = _AreaOfInterestCellList__item_
    AreaOfInterestCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< AreaOfInterestCellItem >-----#
    AreaOfInterestCellItem = SEQ(name='AreaOfInterestCellItem', mode=MODE_TYPE)
    _AreaOfInterestCellItem_nGRAN_CGI = CHOICE(name='nGRAN-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _AreaOfInterestCellItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AreaOfInterestCellItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AreaOfInterestCellItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____AreaOfInterestCellItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterestCellItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterestCellItem_iE_Extensions__item__id._const_tab = ____AreaOfInterestCellItem_iE_Extensions__item__id_tab
    ___AreaOfInterestCellItem_iE_Extensions__item__id._const_tab_at = None
    ___AreaOfInterestCellItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___AreaOfInterestCellItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AreaOfInterestCellItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterestCellItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterestCellItem_iE_Extensions__item__criticality._const_tab = ____AreaOfInterestCellItem_iE_Extensions__item__criticality_tab
    ___AreaOfInterestCellItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AreaOfInterestCellItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AreaOfInterestCellItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AreaOfInterestCellItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterestCellItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterestCellItem_iE_Extensions__item__extensionValue._const_tab = ____AreaOfInterestCellItem_iE_Extensions__item__extensionValue_tab
    ___AreaOfInterestCellItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AreaOfInterestCellItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AreaOfInterestCellItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AreaOfInterestCellItem_iE_Extensions__item__id),
        ('criticality', ___AreaOfInterestCellItem_iE_Extensions__item__criticality),
        ('extensionValue', ___AreaOfInterestCellItem_iE_Extensions__item__extensionValue),
        ])
    __AreaOfInterestCellItem_iE_Extensions__item_._ext = None
    _AreaOfInterestCellItem_iE_Extensions._cont = __AreaOfInterestCellItem_iE_Extensions__item_
    _AreaOfInterestCellItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AreaOfInterestCellItem._cont = ASN1Dict([
        ('nGRAN-CGI', _AreaOfInterestCellItem_nGRAN_CGI),
        ('iE-Extensions', _AreaOfInterestCellItem_iE_Extensions),
        ])
    AreaOfInterestCellItem._ext = []
    
    #-----< AreaOfInterestCellItem-ExtIEs >-----#
    AreaOfInterestCellItem_ExtIEs = CLASS(name='AreaOfInterestCellItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AreaOfInterestCellItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AreaOfInterestList >-----#
    AreaOfInterestList = SEQ_OF(name='AreaOfInterestList', mode=MODE_TYPE)
    _AreaOfInterestList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AreaOfInterestItem')))
    AreaOfInterestList._cont = _AreaOfInterestList__item_
    AreaOfInterestList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< AreaOfInterestItem >-----#
    AreaOfInterestItem = SEQ(name='AreaOfInterestItem', mode=MODE_TYPE)
    _AreaOfInterestItem_areaOfInterest = SEQ(name='areaOfInterest', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AreaOfInterest')))
    _AreaOfInterestItem_locationReportingReferenceID = INT(name='locationReportingReferenceID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LocationReportingReferenceID')))
    _AreaOfInterestItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AreaOfInterestItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AreaOfInterestItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____AreaOfInterestItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterestItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterestItem_iE_Extensions__item__id._const_tab = ____AreaOfInterestItem_iE_Extensions__item__id_tab
    ___AreaOfInterestItem_iE_Extensions__item__id._const_tab_at = None
    ___AreaOfInterestItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___AreaOfInterestItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AreaOfInterestItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterestItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterestItem_iE_Extensions__item__criticality._const_tab = ____AreaOfInterestItem_iE_Extensions__item__criticality_tab
    ___AreaOfInterestItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AreaOfInterestItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AreaOfInterestItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AreaOfInterestItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterestItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterestItem_iE_Extensions__item__extensionValue._const_tab = ____AreaOfInterestItem_iE_Extensions__item__extensionValue_tab
    ___AreaOfInterestItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AreaOfInterestItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AreaOfInterestItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AreaOfInterestItem_iE_Extensions__item__id),
        ('criticality', ___AreaOfInterestItem_iE_Extensions__item__criticality),
        ('extensionValue', ___AreaOfInterestItem_iE_Extensions__item__extensionValue),
        ])
    __AreaOfInterestItem_iE_Extensions__item_._ext = None
    _AreaOfInterestItem_iE_Extensions._cont = __AreaOfInterestItem_iE_Extensions__item_
    _AreaOfInterestItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AreaOfInterestItem._cont = ASN1Dict([
        ('areaOfInterest', _AreaOfInterestItem_areaOfInterest),
        ('locationReportingReferenceID', _AreaOfInterestItem_locationReportingReferenceID),
        ('iE-Extensions', _AreaOfInterestItem_iE_Extensions),
        ])
    AreaOfInterestItem._ext = []
    
    #-----< AreaOfInterestItem-ExtIEs >-----#
    AreaOfInterestItem_ExtIEs = CLASS(name='AreaOfInterestItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AreaOfInterestItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AreaOfInterestRANNodeList >-----#
    AreaOfInterestRANNodeList = SEQ_OF(name='AreaOfInterestRANNodeList', mode=MODE_TYPE)
    _AreaOfInterestRANNodeList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AreaOfInterestRANNodeItem')))
    AreaOfInterestRANNodeList._cont = _AreaOfInterestRANNodeList__item_
    AreaOfInterestRANNodeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< AreaOfInterestRANNodeItem >-----#
    AreaOfInterestRANNodeItem = SEQ(name='AreaOfInterestRANNodeItem', mode=MODE_TYPE)
    _AreaOfInterestRANNodeItem_globalRANNodeID = CHOICE(name='globalRANNodeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _AreaOfInterestRANNodeItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AreaOfInterestRANNodeItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AreaOfInterestRANNodeItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____AreaOfInterestRANNodeItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterestRANNodeItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterestRANNodeItem_iE_Extensions__item__id._const_tab = ____AreaOfInterestRANNodeItem_iE_Extensions__item__id_tab
    ___AreaOfInterestRANNodeItem_iE_Extensions__item__id._const_tab_at = None
    ___AreaOfInterestRANNodeItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___AreaOfInterestRANNodeItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AreaOfInterestRANNodeItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterestRANNodeItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterestRANNodeItem_iE_Extensions__item__criticality._const_tab = ____AreaOfInterestRANNodeItem_iE_Extensions__item__criticality_tab
    ___AreaOfInterestRANNodeItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AreaOfInterestRANNodeItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AreaOfInterestRANNodeItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AreaOfInterestRANNodeItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterestRANNodeItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterestRANNodeItem_iE_Extensions__item__extensionValue._const_tab = ____AreaOfInterestRANNodeItem_iE_Extensions__item__extensionValue_tab
    ___AreaOfInterestRANNodeItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AreaOfInterestRANNodeItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AreaOfInterestRANNodeItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AreaOfInterestRANNodeItem_iE_Extensions__item__id),
        ('criticality', ___AreaOfInterestRANNodeItem_iE_Extensions__item__criticality),
        ('extensionValue', ___AreaOfInterestRANNodeItem_iE_Extensions__item__extensionValue),
        ])
    __AreaOfInterestRANNodeItem_iE_Extensions__item_._ext = None
    _AreaOfInterestRANNodeItem_iE_Extensions._cont = __AreaOfInterestRANNodeItem_iE_Extensions__item_
    _AreaOfInterestRANNodeItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AreaOfInterestRANNodeItem._cont = ASN1Dict([
        ('globalRANNodeID', _AreaOfInterestRANNodeItem_globalRANNodeID),
        ('iE-Extensions', _AreaOfInterestRANNodeItem_iE_Extensions),
        ])
    AreaOfInterestRANNodeItem._ext = []
    
    #-----< AreaOfInterestRANNodeItem-ExtIEs >-----#
    AreaOfInterestRANNodeItem_ExtIEs = CLASS(name='AreaOfInterestRANNodeItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AreaOfInterestRANNodeItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AreaOfInterestTAIList >-----#
    AreaOfInterestTAIList = SEQ_OF(name='AreaOfInterestTAIList', mode=MODE_TYPE)
    _AreaOfInterestTAIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AreaOfInterestTAIItem')))
    AreaOfInterestTAIList._cont = _AreaOfInterestTAIList__item_
    AreaOfInterestTAIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< AreaOfInterestTAIItem >-----#
    AreaOfInterestTAIItem = SEQ(name='AreaOfInterestTAIItem', mode=MODE_TYPE)
    _AreaOfInterestTAIItem_tAI = SEQ(name='tAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _AreaOfInterestTAIItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AreaOfInterestTAIItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AreaOfInterestTAIItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____AreaOfInterestTAIItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterestTAIItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterestTAIItem_iE_Extensions__item__id._const_tab = ____AreaOfInterestTAIItem_iE_Extensions__item__id_tab
    ___AreaOfInterestTAIItem_iE_Extensions__item__id._const_tab_at = None
    ___AreaOfInterestTAIItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___AreaOfInterestTAIItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AreaOfInterestTAIItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterestTAIItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterestTAIItem_iE_Extensions__item__criticality._const_tab = ____AreaOfInterestTAIItem_iE_Extensions__item__criticality_tab
    ___AreaOfInterestTAIItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AreaOfInterestTAIItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AreaOfInterestTAIItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AreaOfInterestTAIItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaOfInterestTAIItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaOfInterestTAIItem_iE_Extensions__item__extensionValue._const_tab = ____AreaOfInterestTAIItem_iE_Extensions__item__extensionValue_tab
    ___AreaOfInterestTAIItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AreaOfInterestTAIItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AreaOfInterestTAIItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AreaOfInterestTAIItem_iE_Extensions__item__id),
        ('criticality', ___AreaOfInterestTAIItem_iE_Extensions__item__criticality),
        ('extensionValue', ___AreaOfInterestTAIItem_iE_Extensions__item__extensionValue),
        ])
    __AreaOfInterestTAIItem_iE_Extensions__item_._ext = None
    _AreaOfInterestTAIItem_iE_Extensions._cont = __AreaOfInterestTAIItem_iE_Extensions__item_
    _AreaOfInterestTAIItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AreaOfInterestTAIItem._cont = ASN1Dict([
        ('tAI', _AreaOfInterestTAIItem_tAI),
        ('iE-Extensions', _AreaOfInterestTAIItem_iE_Extensions),
        ])
    AreaOfInterestTAIItem._ext = []
    
    #-----< AreaOfInterestTAIItem-ExtIEs >-----#
    AreaOfInterestTAIItem_ExtIEs = CLASS(name='AreaOfInterestTAIItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AreaOfInterestTAIItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AssistanceDataForPaging >-----#
    AssistanceDataForPaging = SEQ(name='AssistanceDataForPaging', mode=MODE_TYPE)
    _AssistanceDataForPaging_assistanceDataForRecommendedCells = SEQ(name='assistanceDataForRecommendedCells', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AssistanceDataForRecommendedCells')), opt=True)
    _AssistanceDataForPaging_pagingAttemptInformation = SEQ(name='pagingAttemptInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PagingAttemptInformation')), opt=True)
    _AssistanceDataForPaging_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AssistanceDataForPaging_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AssistanceDataForPaging_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____AssistanceDataForPaging_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____AssistanceDataForPaging_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NPN-PagingAssistanceInformation')))
    _____AssistanceDataForPaging_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingAssisDataforCEcapabUE')))
    ____AssistanceDataForPaging_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 260), ('criticality', 'ignore'), ('Extension', _____AssistanceDataForPaging_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 207), ('criticality', 'ignore'), ('Extension', _____AssistanceDataForPaging_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___AssistanceDataForPaging_iE_Extensions__item__id._const_tab = ____AssistanceDataForPaging_iE_Extensions__item__id_tab
    ___AssistanceDataForPaging_iE_Extensions__item__id._const_tab_at = None
    ___AssistanceDataForPaging_iE_Extensions__item__id._const_tab_id = 'id'
    ___AssistanceDataForPaging_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___AssistanceDataForPaging_iE_Extensions__item__criticality._const_tab = ____AssistanceDataForPaging_iE_Extensions__item__id_tab
    ___AssistanceDataForPaging_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AssistanceDataForPaging_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AssistanceDataForPaging_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___AssistanceDataForPaging_iE_Extensions__item__extensionValue._const_tab = ____AssistanceDataForPaging_iE_Extensions__item__id_tab
    ___AssistanceDataForPaging_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AssistanceDataForPaging_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AssistanceDataForPaging_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AssistanceDataForPaging_iE_Extensions__item__id),
        ('criticality', ___AssistanceDataForPaging_iE_Extensions__item__criticality),
        ('extensionValue', ___AssistanceDataForPaging_iE_Extensions__item__extensionValue),
        ])
    __AssistanceDataForPaging_iE_Extensions__item_._ext = None
    _AssistanceDataForPaging_iE_Extensions._cont = __AssistanceDataForPaging_iE_Extensions__item_
    _AssistanceDataForPaging_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AssistanceDataForPaging._cont = ASN1Dict([
        ('assistanceDataForRecommendedCells', _AssistanceDataForPaging_assistanceDataForRecommendedCells),
        ('pagingAttemptInformation', _AssistanceDataForPaging_pagingAttemptInformation),
        ('iE-Extensions', _AssistanceDataForPaging_iE_Extensions),
        ])
    AssistanceDataForPaging._ext = []
    
    #-----< AssistanceDataForPaging-ExtIEs >-----#
    AssistanceDataForPaging_ExtIEs = CLASS(name='AssistanceDataForPaging-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _AssistanceDataForPaging_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NPN-PagingAssistanceInformation')))
    _AssistanceDataForPaging_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingAssisDataforCEcapabUE')))
    AssistanceDataForPaging_ExtIEs._val = ASN1Set(rv=[dict([('id', 260), ('criticality', 'ignore'), ('Extension', _AssistanceDataForPaging_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 207), ('criticality', 'ignore'), ('Extension', _AssistanceDataForPaging_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< AssistanceDataForRecommendedCells >-----#
    AssistanceDataForRecommendedCells = SEQ(name='AssistanceDataForRecommendedCells', mode=MODE_TYPE)
    _AssistanceDataForRecommendedCells_recommendedCellsForPaging = SEQ(name='recommendedCellsForPaging', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RecommendedCellsForPaging')))
    _AssistanceDataForRecommendedCells_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AssistanceDataForRecommendedCells_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____AssistanceDataForRecommendedCells_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AssistanceDataForRecommendedCells_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__id._const_tab = ____AssistanceDataForRecommendedCells_iE_Extensions__item__id_tab
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__id._const_tab_at = None
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__id._const_tab_id = 'id'
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AssistanceDataForRecommendedCells_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AssistanceDataForRecommendedCells_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__criticality._const_tab = ____AssistanceDataForRecommendedCells_iE_Extensions__item__criticality_tab
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue._const_tab = ____AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue_tab
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AssistanceDataForRecommendedCells_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AssistanceDataForRecommendedCells_iE_Extensions__item__id),
        ('criticality', ___AssistanceDataForRecommendedCells_iE_Extensions__item__criticality),
        ('extensionValue', ___AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue),
        ])
    __AssistanceDataForRecommendedCells_iE_Extensions__item_._ext = None
    _AssistanceDataForRecommendedCells_iE_Extensions._cont = __AssistanceDataForRecommendedCells_iE_Extensions__item_
    _AssistanceDataForRecommendedCells_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AssistanceDataForRecommendedCells._cont = ASN1Dict([
        ('recommendedCellsForPaging', _AssistanceDataForRecommendedCells_recommendedCellsForPaging),
        ('iE-Extensions', _AssistanceDataForRecommendedCells_iE_Extensions),
        ])
    AssistanceDataForRecommendedCells._ext = []
    
    #-----< AssistanceDataForRecommendedCells-ExtIEs >-----#
    AssistanceDataForRecommendedCells_ExtIEs = CLASS(name='AssistanceDataForRecommendedCells-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AssistanceDataForRecommendedCells_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AssociatedMBSQosFlowSetupRequestList >-----#
    AssociatedMBSQosFlowSetupRequestList = SEQ_OF(name='AssociatedMBSQosFlowSetupRequestList', mode=MODE_TYPE)
    _AssociatedMBSQosFlowSetupRequestList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AssociatedMBSQosFlowSetupRequestItem')))
    AssociatedMBSQosFlowSetupRequestList._cont = _AssociatedMBSQosFlowSetupRequestList__item_
    AssociatedMBSQosFlowSetupRequestList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< AssociatedMBSQosFlowSetupRequestItem >-----#
    AssociatedMBSQosFlowSetupRequestItem = SEQ(name='AssociatedMBSQosFlowSetupRequestItem', mode=MODE_TYPE)
    _AssociatedMBSQosFlowSetupRequestItem_mBS_QosFlowIdentifier = INT(name='mBS-QosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _AssociatedMBSQosFlowSetupRequestItem_associatedUnicastQosFlowIdentifier = INT(name='associatedUnicastQosFlowIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _AssociatedMBSQosFlowSetupRequestItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__id._const_tab = ____AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__id_tab
    ___AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__id._const_tab_at = None
    ___AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__criticality._const_tab = ____AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__criticality_tab
    ___AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__extensionValue._const_tab = ____AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__extensionValue_tab
    ___AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__id),
        ('criticality', ___AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__criticality),
        ('extensionValue', ___AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__extensionValue),
        ])
    __AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item_._ext = None
    _AssociatedMBSQosFlowSetupRequestItem_iE_Extensions._cont = __AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item_
    _AssociatedMBSQosFlowSetupRequestItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AssociatedMBSQosFlowSetupRequestItem._cont = ASN1Dict([
        ('mBS-QosFlowIdentifier', _AssociatedMBSQosFlowSetupRequestItem_mBS_QosFlowIdentifier),
        ('associatedUnicastQosFlowIdentifier', _AssociatedMBSQosFlowSetupRequestItem_associatedUnicastQosFlowIdentifier),
        ('iE-Extensions', _AssociatedMBSQosFlowSetupRequestItem_iE_Extensions),
        ])
    AssociatedMBSQosFlowSetupRequestItem._ext = []
    
    #-----< AssociatedMBSQosFlowSetupRequestItem-ExtIEs >-----#
    AssociatedMBSQosFlowSetupRequestItem_ExtIEs = CLASS(name='AssociatedMBSQosFlowSetupRequestItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AssociatedMBSQosFlowSetupRequestItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AssociatedMBSQosFlowSetuporModifyRequestList >-----#
    AssociatedMBSQosFlowSetuporModifyRequestList = SEQ_OF(name='AssociatedMBSQosFlowSetuporModifyRequestList', mode=MODE_TYPE)
    _AssociatedMBSQosFlowSetuporModifyRequestList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AssociatedMBSQosFlowSetuporModifyRequestItem')))
    AssociatedMBSQosFlowSetuporModifyRequestList._cont = _AssociatedMBSQosFlowSetuporModifyRequestList__item_
    AssociatedMBSQosFlowSetuporModifyRequestList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< AssociatedMBSQosFlowSetuporModifyRequestItem >-----#
    AssociatedMBSQosFlowSetuporModifyRequestItem = SEQ(name='AssociatedMBSQosFlowSetuporModifyRequestItem', mode=MODE_TYPE)
    _AssociatedMBSQosFlowSetuporModifyRequestItem_mBS_QosFlowIdentifier = INT(name='mBS-QosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _AssociatedMBSQosFlowSetuporModifyRequestItem_associatedUnicastQosFlowIdentifier = INT(name='associatedUnicastQosFlowIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__id._const_tab = ____AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__id_tab
    ___AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__id._const_tab_at = None
    ___AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__criticality._const_tab = ____AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__criticality_tab
    ___AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__extensionValue._const_tab = ____AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__extensionValue_tab
    ___AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__id),
        ('criticality', ___AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__criticality),
        ('extensionValue', ___AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__extensionValue),
        ])
    __AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item_._ext = None
    _AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions._cont = __AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item_
    _AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AssociatedMBSQosFlowSetuporModifyRequestItem._cont = ASN1Dict([
        ('mBS-QosFlowIdentifier', _AssociatedMBSQosFlowSetuporModifyRequestItem_mBS_QosFlowIdentifier),
        ('associatedUnicastQosFlowIdentifier', _AssociatedMBSQosFlowSetuporModifyRequestItem_associatedUnicastQosFlowIdentifier),
        ('iE-Extensions', _AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions),
        ])
    AssociatedMBSQosFlowSetuporModifyRequestItem._ext = []
    
    #-----< AssociatedMBSQosFlowSetuporModifyRequestItem-ExtIEs >-----#
    AssociatedMBSQosFlowSetuporModifyRequestItem_ExtIEs = CLASS(name='AssociatedMBSQosFlowSetuporModifyRequestItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AssociatedMBSQosFlowSetuporModifyRequestItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AssociatedQosFlowList >-----#
    AssociatedQosFlowList = SEQ_OF(name='AssociatedQosFlowList', mode=MODE_TYPE)
    _AssociatedQosFlowList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AssociatedQosFlowItem')))
    AssociatedQosFlowList._cont = _AssociatedQosFlowList__item_
    AssociatedQosFlowList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< AssociatedQosFlowItem >-----#
    AssociatedQosFlowItem = SEQ(name='AssociatedQosFlowItem', mode=MODE_TYPE)
    _AssociatedQosFlowItem_qosFlowIdentifier = INT(name='qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _AssociatedQosFlowItem_qosFlowMappingIndication = ENUM(name='qosFlowMappingIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AssociatedQosFlowItem_qosFlowMappingIndication._cont = ASN1Dict([('ul', 0), ('dl', 1)])
    _AssociatedQosFlowItem_qosFlowMappingIndication._ext = []
    _AssociatedQosFlowItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AssociatedQosFlowItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AssociatedQosFlowItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____AssociatedQosFlowItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____AssociatedQosFlowItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetIndex')))
    ____AssociatedQosFlowItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 221), ('criticality', 'ignore'), ('Extension', _____AssociatedQosFlowItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___AssociatedQosFlowItem_iE_Extensions__item__id._const_tab = ____AssociatedQosFlowItem_iE_Extensions__item__id_tab
    ___AssociatedQosFlowItem_iE_Extensions__item__id._const_tab_at = None
    ___AssociatedQosFlowItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___AssociatedQosFlowItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___AssociatedQosFlowItem_iE_Extensions__item__criticality._const_tab = ____AssociatedQosFlowItem_iE_Extensions__item__id_tab
    ___AssociatedQosFlowItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AssociatedQosFlowItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AssociatedQosFlowItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___AssociatedQosFlowItem_iE_Extensions__item__extensionValue._const_tab = ____AssociatedQosFlowItem_iE_Extensions__item__id_tab
    ___AssociatedQosFlowItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AssociatedQosFlowItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AssociatedQosFlowItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AssociatedQosFlowItem_iE_Extensions__item__id),
        ('criticality', ___AssociatedQosFlowItem_iE_Extensions__item__criticality),
        ('extensionValue', ___AssociatedQosFlowItem_iE_Extensions__item__extensionValue),
        ])
    __AssociatedQosFlowItem_iE_Extensions__item_._ext = None
    _AssociatedQosFlowItem_iE_Extensions._cont = __AssociatedQosFlowItem_iE_Extensions__item_
    _AssociatedQosFlowItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AssociatedQosFlowItem._cont = ASN1Dict([
        ('qosFlowIdentifier', _AssociatedQosFlowItem_qosFlowIdentifier),
        ('qosFlowMappingIndication', _AssociatedQosFlowItem_qosFlowMappingIndication),
        ('iE-Extensions', _AssociatedQosFlowItem_iE_Extensions),
        ])
    AssociatedQosFlowItem._ext = []
    
    #-----< AssociatedQosFlowItem-ExtIEs >-----#
    AssociatedQosFlowItem_ExtIEs = CLASS(name='AssociatedQosFlowItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _AssociatedQosFlowItem_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetIndex')))
    AssociatedQosFlowItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 221), ('criticality', 'ignore'), ('Extension', _AssociatedQosFlowItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< AuthenticatedIndication >-----#
    AuthenticatedIndication = ENUM(name='AuthenticatedIndication', mode=MODE_TYPE)
    AuthenticatedIndication._cont = ASN1Dict([('true', 0)])
    AuthenticatedIndication._ext = []
    
    #-----< AveragingWindow >-----#
    AveragingWindow = INT(name='AveragingWindow', mode=MODE_TYPE)
    AveragingWindow._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=[], er=[])
    
    #-----< AreaScopeOfMDT-NR >-----#
    AreaScopeOfMDT_NR = CHOICE(name='AreaScopeOfMDT-NR', mode=MODE_TYPE)
    _AreaScopeOfMDT_NR_cellBased = SEQ(name='cellBased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellBasedMDT-NR')))
    _AreaScopeOfMDT_NR_tABased = SEQ(name='tABased', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TABasedMDT')))
    _AreaScopeOfMDT_NR_pLMNWide = NULL(name='pLMNWide', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AreaScopeOfMDT_NR_tAIBased = SEQ(name='tAIBased', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAIBasedMDT')))
    _AreaScopeOfMDT_NR_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __AreaScopeOfMDT_NR_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___AreaScopeOfMDT_NR_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___AreaScopeOfMDT_NR_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AreaScopeOfMDT_NR_choice_Extensions_id._const_tab = ___AreaScopeOfMDT_NR_choice_Extensions_id_tab
    __AreaScopeOfMDT_NR_choice_Extensions_id._const_tab_at = None
    __AreaScopeOfMDT_NR_choice_Extensions_id._const_tab_id = 'id'
    __AreaScopeOfMDT_NR_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___AreaScopeOfMDT_NR_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___AreaScopeOfMDT_NR_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AreaScopeOfMDT_NR_choice_Extensions_criticality._const_tab = ___AreaScopeOfMDT_NR_choice_Extensions_criticality_tab
    __AreaScopeOfMDT_NR_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __AreaScopeOfMDT_NR_choice_Extensions_criticality._const_tab_id = 'criticality'
    __AreaScopeOfMDT_NR_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___AreaScopeOfMDT_NR_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___AreaScopeOfMDT_NR_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AreaScopeOfMDT_NR_choice_Extensions_value._const_tab = ___AreaScopeOfMDT_NR_choice_Extensions_value_tab
    __AreaScopeOfMDT_NR_choice_Extensions_value._const_tab_at = ('..', 'id')
    __AreaScopeOfMDT_NR_choice_Extensions_value._const_tab_id = 'Value'
    _AreaScopeOfMDT_NR_choice_Extensions._cont = ASN1Dict([
        ('id', __AreaScopeOfMDT_NR_choice_Extensions_id),
        ('criticality', __AreaScopeOfMDT_NR_choice_Extensions_criticality),
        ('value', __AreaScopeOfMDT_NR_choice_Extensions_value),
        ])
    _AreaScopeOfMDT_NR_choice_Extensions._ext = None
    AreaScopeOfMDT_NR._cont = ASN1Dict([
        ('cellBased', _AreaScopeOfMDT_NR_cellBased),
        ('tABased', _AreaScopeOfMDT_NR_tABased),
        ('pLMNWide', _AreaScopeOfMDT_NR_pLMNWide),
        ('tAIBased', _AreaScopeOfMDT_NR_tAIBased),
        ('choice-Extensions', _AreaScopeOfMDT_NR_choice_Extensions),
        ])
    AreaScopeOfMDT_NR._ext = None
    
    #-----< AreaScopeOfMDT-NR-ExtIEs >-----#
    AreaScopeOfMDT_NR_ExtIEs = CLASS(name='AreaScopeOfMDT-NR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    AreaScopeOfMDT_NR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AreaScopeOfMDT-EUTRA >-----#
    AreaScopeOfMDT_EUTRA = CHOICE(name='AreaScopeOfMDT-EUTRA', mode=MODE_TYPE)
    _AreaScopeOfMDT_EUTRA_cellBased = SEQ(name='cellBased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellBasedMDT-EUTRA')))
    _AreaScopeOfMDT_EUTRA_tABased = SEQ(name='tABased', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TABasedMDT')))
    _AreaScopeOfMDT_EUTRA_pLMNWide = NULL(name='pLMNWide', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AreaScopeOfMDT_EUTRA_tAIBased = SEQ(name='tAIBased', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAIBasedMDT')))
    _AreaScopeOfMDT_EUTRA_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __AreaScopeOfMDT_EUTRA_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___AreaScopeOfMDT_EUTRA_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___AreaScopeOfMDT_EUTRA_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AreaScopeOfMDT_EUTRA_choice_Extensions_id._const_tab = ___AreaScopeOfMDT_EUTRA_choice_Extensions_id_tab
    __AreaScopeOfMDT_EUTRA_choice_Extensions_id._const_tab_at = None
    __AreaScopeOfMDT_EUTRA_choice_Extensions_id._const_tab_id = 'id'
    __AreaScopeOfMDT_EUTRA_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___AreaScopeOfMDT_EUTRA_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___AreaScopeOfMDT_EUTRA_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AreaScopeOfMDT_EUTRA_choice_Extensions_criticality._const_tab = ___AreaScopeOfMDT_EUTRA_choice_Extensions_criticality_tab
    __AreaScopeOfMDT_EUTRA_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __AreaScopeOfMDT_EUTRA_choice_Extensions_criticality._const_tab_id = 'criticality'
    __AreaScopeOfMDT_EUTRA_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___AreaScopeOfMDT_EUTRA_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___AreaScopeOfMDT_EUTRA_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AreaScopeOfMDT_EUTRA_choice_Extensions_value._const_tab = ___AreaScopeOfMDT_EUTRA_choice_Extensions_value_tab
    __AreaScopeOfMDT_EUTRA_choice_Extensions_value._const_tab_at = ('..', 'id')
    __AreaScopeOfMDT_EUTRA_choice_Extensions_value._const_tab_id = 'Value'
    _AreaScopeOfMDT_EUTRA_choice_Extensions._cont = ASN1Dict([
        ('id', __AreaScopeOfMDT_EUTRA_choice_Extensions_id),
        ('criticality', __AreaScopeOfMDT_EUTRA_choice_Extensions_criticality),
        ('value', __AreaScopeOfMDT_EUTRA_choice_Extensions_value),
        ])
    _AreaScopeOfMDT_EUTRA_choice_Extensions._ext = None
    AreaScopeOfMDT_EUTRA._cont = ASN1Dict([
        ('cellBased', _AreaScopeOfMDT_EUTRA_cellBased),
        ('tABased', _AreaScopeOfMDT_EUTRA_tABased),
        ('pLMNWide', _AreaScopeOfMDT_EUTRA_pLMNWide),
        ('tAIBased', _AreaScopeOfMDT_EUTRA_tAIBased),
        ('choice-Extensions', _AreaScopeOfMDT_EUTRA_choice_Extensions),
        ])
    AreaScopeOfMDT_EUTRA._ext = None
    
    #-----< AreaScopeOfMDT-EUTRA-ExtIEs >-----#
    AreaScopeOfMDT_EUTRA_ExtIEs = CLASS(name='AreaScopeOfMDT-EUTRA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    AreaScopeOfMDT_EUTRA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AreaScopeOfNeighCellsList >-----#
    AreaScopeOfNeighCellsList = SEQ_OF(name='AreaScopeOfNeighCellsList', mode=MODE_TYPE)
    _AreaScopeOfNeighCellsList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AreaScopeOfNeighCellsItem')))
    AreaScopeOfNeighCellsList._cont = _AreaScopeOfNeighCellsList__item_
    AreaScopeOfNeighCellsList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< AreaScopeOfNeighCellsItem >-----#
    AreaScopeOfNeighCellsItem = SEQ(name='AreaScopeOfNeighCellsItem', mode=MODE_TYPE)
    _AreaScopeOfNeighCellsItem_nrFrequencyInfo = SEQ(name='nrFrequencyInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NRFrequencyInfo')))
    _AreaScopeOfNeighCellsItem_pciListForMDT = SEQ_OF(name='pciListForMDT', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PCIListForMDT')), opt=True)
    _AreaScopeOfNeighCellsItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AreaScopeOfNeighCellsItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AreaScopeOfNeighCellsItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____AreaScopeOfNeighCellsItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaScopeOfNeighCellsItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaScopeOfNeighCellsItem_iE_Extensions__item__id._const_tab = ____AreaScopeOfNeighCellsItem_iE_Extensions__item__id_tab
    ___AreaScopeOfNeighCellsItem_iE_Extensions__item__id._const_tab_at = None
    ___AreaScopeOfNeighCellsItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___AreaScopeOfNeighCellsItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AreaScopeOfNeighCellsItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaScopeOfNeighCellsItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaScopeOfNeighCellsItem_iE_Extensions__item__criticality._const_tab = ____AreaScopeOfNeighCellsItem_iE_Extensions__item__criticality_tab
    ___AreaScopeOfNeighCellsItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AreaScopeOfNeighCellsItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AreaScopeOfNeighCellsItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AreaScopeOfNeighCellsItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AreaScopeOfNeighCellsItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AreaScopeOfNeighCellsItem_iE_Extensions__item__extensionValue._const_tab = ____AreaScopeOfNeighCellsItem_iE_Extensions__item__extensionValue_tab
    ___AreaScopeOfNeighCellsItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AreaScopeOfNeighCellsItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AreaScopeOfNeighCellsItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AreaScopeOfNeighCellsItem_iE_Extensions__item__id),
        ('criticality', ___AreaScopeOfNeighCellsItem_iE_Extensions__item__criticality),
        ('extensionValue', ___AreaScopeOfNeighCellsItem_iE_Extensions__item__extensionValue),
        ])
    __AreaScopeOfNeighCellsItem_iE_Extensions__item_._ext = None
    _AreaScopeOfNeighCellsItem_iE_Extensions._cont = __AreaScopeOfNeighCellsItem_iE_Extensions__item_
    _AreaScopeOfNeighCellsItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AreaScopeOfNeighCellsItem._cont = ASN1Dict([
        ('nrFrequencyInfo', _AreaScopeOfNeighCellsItem_nrFrequencyInfo),
        ('pciListForMDT', _AreaScopeOfNeighCellsItem_pciListForMDT),
        ('iE-Extensions', _AreaScopeOfNeighCellsItem_iE_Extensions),
        ])
    AreaScopeOfNeighCellsItem._ext = []
    
    #-----< AreaScopeOfNeighCellsItem-ExtIEs >-----#
    AreaScopeOfNeighCellsItem_ExtIEs = CLASS(name='AreaScopeOfNeighCellsItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AreaScopeOfNeighCellsItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AreaScopeOfQMC >-----#
    AreaScopeOfQMC = CHOICE(name='AreaScopeOfQMC', mode=MODE_TYPE)
    _AreaScopeOfQMC_cellBased = SEQ(name='cellBased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellBasedQMC')))
    _AreaScopeOfQMC_tABased = SEQ(name='tABased', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TABasedQMC')))
    _AreaScopeOfQMC_tAIBased = SEQ(name='tAIBased', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAIBasedQMC')))
    _AreaScopeOfQMC_pLMNAreaBased = SEQ(name='pLMNAreaBased', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNAreaBasedQMC')))
    _AreaScopeOfQMC_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __AreaScopeOfQMC_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___AreaScopeOfQMC_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___AreaScopeOfQMC_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AreaScopeOfQMC_choice_Extensions_id._const_tab = ___AreaScopeOfQMC_choice_Extensions_id_tab
    __AreaScopeOfQMC_choice_Extensions_id._const_tab_at = None
    __AreaScopeOfQMC_choice_Extensions_id._const_tab_id = 'id'
    __AreaScopeOfQMC_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___AreaScopeOfQMC_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___AreaScopeOfQMC_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AreaScopeOfQMC_choice_Extensions_criticality._const_tab = ___AreaScopeOfQMC_choice_Extensions_criticality_tab
    __AreaScopeOfQMC_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __AreaScopeOfQMC_choice_Extensions_criticality._const_tab_id = 'criticality'
    __AreaScopeOfQMC_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___AreaScopeOfQMC_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___AreaScopeOfQMC_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AreaScopeOfQMC_choice_Extensions_value._const_tab = ___AreaScopeOfQMC_choice_Extensions_value_tab
    __AreaScopeOfQMC_choice_Extensions_value._const_tab_at = ('..', 'id')
    __AreaScopeOfQMC_choice_Extensions_value._const_tab_id = 'Value'
    _AreaScopeOfQMC_choice_Extensions._cont = ASN1Dict([
        ('id', __AreaScopeOfQMC_choice_Extensions_id),
        ('criticality', __AreaScopeOfQMC_choice_Extensions_criticality),
        ('value', __AreaScopeOfQMC_choice_Extensions_value),
        ])
    _AreaScopeOfQMC_choice_Extensions._ext = None
    AreaScopeOfQMC._cont = ASN1Dict([
        ('cellBased', _AreaScopeOfQMC_cellBased),
        ('tABased', _AreaScopeOfQMC_tABased),
        ('tAIBased', _AreaScopeOfQMC_tAIBased),
        ('pLMNAreaBased', _AreaScopeOfQMC_pLMNAreaBased),
        ('choice-Extensions', _AreaScopeOfQMC_choice_Extensions),
        ])
    AreaScopeOfQMC._ext = None
    
    #-----< AreaScopeOfQMC-ExtIEs >-----#
    AreaScopeOfQMC_ExtIEs = CLASS(name='AreaScopeOfQMC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    AreaScopeOfQMC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AvailableRANVisibleQoEMetrics >-----#
    AvailableRANVisibleQoEMetrics = SEQ(name='AvailableRANVisibleQoEMetrics', mode=MODE_TYPE)
    _AvailableRANVisibleQoEMetrics_applicationLayerBufferLevelList = ENUM(name='applicationLayerBufferLevelList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AvailableRANVisibleQoEMetrics_applicationLayerBufferLevelList._cont = ASN1Dict([('true', 0)])
    _AvailableRANVisibleQoEMetrics_applicationLayerBufferLevelList._ext = []
    _AvailableRANVisibleQoEMetrics_playoutDelayForMediaStartup = ENUM(name='playoutDelayForMediaStartup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AvailableRANVisibleQoEMetrics_playoutDelayForMediaStartup._cont = ASN1Dict([('true', 0)])
    _AvailableRANVisibleQoEMetrics_playoutDelayForMediaStartup._ext = []
    _AvailableRANVisibleQoEMetrics_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AvailableRANVisibleQoEMetrics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___AvailableRANVisibleQoEMetrics_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____AvailableRANVisibleQoEMetrics_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AvailableRANVisibleQoEMetrics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AvailableRANVisibleQoEMetrics_iE_Extensions__item__id._const_tab = ____AvailableRANVisibleQoEMetrics_iE_Extensions__item__id_tab
    ___AvailableRANVisibleQoEMetrics_iE_Extensions__item__id._const_tab_at = None
    ___AvailableRANVisibleQoEMetrics_iE_Extensions__item__id._const_tab_id = 'id'
    ___AvailableRANVisibleQoEMetrics_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AvailableRANVisibleQoEMetrics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AvailableRANVisibleQoEMetrics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AvailableRANVisibleQoEMetrics_iE_Extensions__item__criticality._const_tab = ____AvailableRANVisibleQoEMetrics_iE_Extensions__item__criticality_tab
    ___AvailableRANVisibleQoEMetrics_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AvailableRANVisibleQoEMetrics_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AvailableRANVisibleQoEMetrics_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AvailableRANVisibleQoEMetrics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____AvailableRANVisibleQoEMetrics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AvailableRANVisibleQoEMetrics_iE_Extensions__item__extensionValue._const_tab = ____AvailableRANVisibleQoEMetrics_iE_Extensions__item__extensionValue_tab
    ___AvailableRANVisibleQoEMetrics_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AvailableRANVisibleQoEMetrics_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AvailableRANVisibleQoEMetrics_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AvailableRANVisibleQoEMetrics_iE_Extensions__item__id),
        ('criticality', ___AvailableRANVisibleQoEMetrics_iE_Extensions__item__criticality),
        ('extensionValue', ___AvailableRANVisibleQoEMetrics_iE_Extensions__item__extensionValue),
        ])
    __AvailableRANVisibleQoEMetrics_iE_Extensions__item_._ext = None
    _AvailableRANVisibleQoEMetrics_iE_Extensions._cont = __AvailableRANVisibleQoEMetrics_iE_Extensions__item_
    _AvailableRANVisibleQoEMetrics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AvailableRANVisibleQoEMetrics._cont = ASN1Dict([
        ('applicationLayerBufferLevelList', _AvailableRANVisibleQoEMetrics_applicationLayerBufferLevelList),
        ('playoutDelayForMediaStartup', _AvailableRANVisibleQoEMetrics_playoutDelayForMediaStartup),
        ('iE-Extensions', _AvailableRANVisibleQoEMetrics_iE_Extensions),
        ])
    AvailableRANVisibleQoEMetrics._ext = []
    
    #-----< AvailableRANVisibleQoEMetrics-ExtIEs >-----#
    AvailableRANVisibleQoEMetrics_ExtIEs = CLASS(name='AvailableRANVisibleQoEMetrics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    AvailableRANVisibleQoEMetrics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BeamMeasurementsReportConfiguration >-----#
    BeamMeasurementsReportConfiguration = SEQ(name='BeamMeasurementsReportConfiguration', mode=MODE_TYPE)
    _BeamMeasurementsReportConfiguration_beamMeasurementsReportQuantity = SEQ(name='beamMeasurementsReportQuantity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BeamMeasurementsReportQuantity')), opt=True)
    _BeamMeasurementsReportConfiguration_maxNrofRS_IndexesToReport = INT(name='maxNrofRS-IndexesToReport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MaxNrofRS-IndexesToReport')), opt=True)
    _BeamMeasurementsReportConfiguration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BeamMeasurementsReportConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___BeamMeasurementsReportConfiguration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____BeamMeasurementsReportConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____BeamMeasurementsReportConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BeamMeasurementsReportConfiguration_iE_Extensions__item__id._const_tab = ____BeamMeasurementsReportConfiguration_iE_Extensions__item__id_tab
    ___BeamMeasurementsReportConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___BeamMeasurementsReportConfiguration_iE_Extensions__item__id._const_tab_id = 'id'
    ___BeamMeasurementsReportConfiguration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BeamMeasurementsReportConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____BeamMeasurementsReportConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BeamMeasurementsReportConfiguration_iE_Extensions__item__criticality._const_tab = ____BeamMeasurementsReportConfiguration_iE_Extensions__item__criticality_tab
    ___BeamMeasurementsReportConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BeamMeasurementsReportConfiguration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BeamMeasurementsReportConfiguration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BeamMeasurementsReportConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____BeamMeasurementsReportConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BeamMeasurementsReportConfiguration_iE_Extensions__item__extensionValue._const_tab = ____BeamMeasurementsReportConfiguration_iE_Extensions__item__extensionValue_tab
    ___BeamMeasurementsReportConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BeamMeasurementsReportConfiguration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BeamMeasurementsReportConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BeamMeasurementsReportConfiguration_iE_Extensions__item__id),
        ('criticality', ___BeamMeasurementsReportConfiguration_iE_Extensions__item__criticality),
        ('extensionValue', ___BeamMeasurementsReportConfiguration_iE_Extensions__item__extensionValue),
        ])
    __BeamMeasurementsReportConfiguration_iE_Extensions__item_._ext = None
    _BeamMeasurementsReportConfiguration_iE_Extensions._cont = __BeamMeasurementsReportConfiguration_iE_Extensions__item_
    _BeamMeasurementsReportConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BeamMeasurementsReportConfiguration._cont = ASN1Dict([
        ('beamMeasurementsReportQuantity', _BeamMeasurementsReportConfiguration_beamMeasurementsReportQuantity),
        ('maxNrofRS-IndexesToReport', _BeamMeasurementsReportConfiguration_maxNrofRS_IndexesToReport),
        ('iE-Extensions', _BeamMeasurementsReportConfiguration_iE_Extensions),
        ])
    BeamMeasurementsReportConfiguration._ext = []
    
    #-----< BeamMeasurementsReportConfiguration-ExtIEs >-----#
    BeamMeasurementsReportConfiguration_ExtIEs = CLASS(name='BeamMeasurementsReportConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    BeamMeasurementsReportConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BeamMeasurementsReportQuantity >-----#
    BeamMeasurementsReportQuantity = SEQ(name='BeamMeasurementsReportQuantity', mode=MODE_TYPE)
    _BeamMeasurementsReportQuantity_rSRP = ENUM(name='rSRP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BeamMeasurementsReportQuantity_rSRP._cont = ASN1Dict([('true', 0)])
    _BeamMeasurementsReportQuantity_rSRP._ext = []
    _BeamMeasurementsReportQuantity_rSRQ = ENUM(name='rSRQ', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BeamMeasurementsReportQuantity_rSRQ._cont = ASN1Dict([('true', 0)])
    _BeamMeasurementsReportQuantity_rSRQ._ext = []
    _BeamMeasurementsReportQuantity_sINR = ENUM(name='sINR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BeamMeasurementsReportQuantity_sINR._cont = ASN1Dict([('true', 0)])
    _BeamMeasurementsReportQuantity_sINR._ext = []
    _BeamMeasurementsReportQuantity_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BeamMeasurementsReportQuantity_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___BeamMeasurementsReportQuantity_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____BeamMeasurementsReportQuantity_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____BeamMeasurementsReportQuantity_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BeamMeasurementsReportQuantity_iE_Extensions__item__id._const_tab = ____BeamMeasurementsReportQuantity_iE_Extensions__item__id_tab
    ___BeamMeasurementsReportQuantity_iE_Extensions__item__id._const_tab_at = None
    ___BeamMeasurementsReportQuantity_iE_Extensions__item__id._const_tab_id = 'id'
    ___BeamMeasurementsReportQuantity_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BeamMeasurementsReportQuantity_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____BeamMeasurementsReportQuantity_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BeamMeasurementsReportQuantity_iE_Extensions__item__criticality._const_tab = ____BeamMeasurementsReportQuantity_iE_Extensions__item__criticality_tab
    ___BeamMeasurementsReportQuantity_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BeamMeasurementsReportQuantity_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BeamMeasurementsReportQuantity_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BeamMeasurementsReportQuantity_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____BeamMeasurementsReportQuantity_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BeamMeasurementsReportQuantity_iE_Extensions__item__extensionValue._const_tab = ____BeamMeasurementsReportQuantity_iE_Extensions__item__extensionValue_tab
    ___BeamMeasurementsReportQuantity_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BeamMeasurementsReportQuantity_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BeamMeasurementsReportQuantity_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BeamMeasurementsReportQuantity_iE_Extensions__item__id),
        ('criticality', ___BeamMeasurementsReportQuantity_iE_Extensions__item__criticality),
        ('extensionValue', ___BeamMeasurementsReportQuantity_iE_Extensions__item__extensionValue),
        ])
    __BeamMeasurementsReportQuantity_iE_Extensions__item_._ext = None
    _BeamMeasurementsReportQuantity_iE_Extensions._cont = __BeamMeasurementsReportQuantity_iE_Extensions__item_
    _BeamMeasurementsReportQuantity_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BeamMeasurementsReportQuantity._cont = ASN1Dict([
        ('rSRP', _BeamMeasurementsReportQuantity_rSRP),
        ('rSRQ', _BeamMeasurementsReportQuantity_rSRQ),
        ('sINR', _BeamMeasurementsReportQuantity_sINR),
        ('iE-Extensions', _BeamMeasurementsReportQuantity_iE_Extensions),
        ])
    BeamMeasurementsReportQuantity._ext = []
    
    #-----< BeamMeasurementsReportQuantity-ExtIEs >-----#
    BeamMeasurementsReportQuantity_ExtIEs = CLASS(name='BeamMeasurementsReportQuantity-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    BeamMeasurementsReportQuantity_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BitRate >-----#
    BitRate = INT(name='BitRate', mode=MODE_TYPE)
    BitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4000000000000)], ev=[], er=[])
    
    #-----< BroadcastCancelledAreaList >-----#
    BroadcastCancelledAreaList = CHOICE(name='BroadcastCancelledAreaList', mode=MODE_TYPE)
    _BroadcastCancelledAreaList_cellIDCancelledEUTRA = SEQ_OF(name='cellIDCancelledEUTRA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellIDCancelledEUTRA')))
    _BroadcastCancelledAreaList_tAICancelledEUTRA = SEQ_OF(name='tAICancelledEUTRA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAICancelledEUTRA')))
    _BroadcastCancelledAreaList_emergencyAreaIDCancelledEUTRA = SEQ_OF(name='emergencyAreaIDCancelledEUTRA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaIDCancelledEUTRA')))
    _BroadcastCancelledAreaList_cellIDCancelledNR = SEQ_OF(name='cellIDCancelledNR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellIDCancelledNR')))
    _BroadcastCancelledAreaList_tAICancelledNR = SEQ_OF(name='tAICancelledNR', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAICancelledNR')))
    _BroadcastCancelledAreaList_emergencyAreaIDCancelledNR = SEQ_OF(name='emergencyAreaIDCancelledNR', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaIDCancelledNR')))
    _BroadcastCancelledAreaList_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __BroadcastCancelledAreaList_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___BroadcastCancelledAreaList_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___BroadcastCancelledAreaList_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BroadcastCancelledAreaList_choice_Extensions_id._const_tab = ___BroadcastCancelledAreaList_choice_Extensions_id_tab
    __BroadcastCancelledAreaList_choice_Extensions_id._const_tab_at = None
    __BroadcastCancelledAreaList_choice_Extensions_id._const_tab_id = 'id'
    __BroadcastCancelledAreaList_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___BroadcastCancelledAreaList_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___BroadcastCancelledAreaList_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BroadcastCancelledAreaList_choice_Extensions_criticality._const_tab = ___BroadcastCancelledAreaList_choice_Extensions_criticality_tab
    __BroadcastCancelledAreaList_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __BroadcastCancelledAreaList_choice_Extensions_criticality._const_tab_id = 'criticality'
    __BroadcastCancelledAreaList_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___BroadcastCancelledAreaList_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___BroadcastCancelledAreaList_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BroadcastCancelledAreaList_choice_Extensions_value._const_tab = ___BroadcastCancelledAreaList_choice_Extensions_value_tab
    __BroadcastCancelledAreaList_choice_Extensions_value._const_tab_at = ('..', 'id')
    __BroadcastCancelledAreaList_choice_Extensions_value._const_tab_id = 'Value'
    _BroadcastCancelledAreaList_choice_Extensions._cont = ASN1Dict([
        ('id', __BroadcastCancelledAreaList_choice_Extensions_id),
        ('criticality', __BroadcastCancelledAreaList_choice_Extensions_criticality),
        ('value', __BroadcastCancelledAreaList_choice_Extensions_value),
        ])
    _BroadcastCancelledAreaList_choice_Extensions._ext = None
    BroadcastCancelledAreaList._cont = ASN1Dict([
        ('cellIDCancelledEUTRA', _BroadcastCancelledAreaList_cellIDCancelledEUTRA),
        ('tAICancelledEUTRA', _BroadcastCancelledAreaList_tAICancelledEUTRA),
        ('emergencyAreaIDCancelledEUTRA', _BroadcastCancelledAreaList_emergencyAreaIDCancelledEUTRA),
        ('cellIDCancelledNR', _BroadcastCancelledAreaList_cellIDCancelledNR),
        ('tAICancelledNR', _BroadcastCancelledAreaList_tAICancelledNR),
        ('emergencyAreaIDCancelledNR', _BroadcastCancelledAreaList_emergencyAreaIDCancelledNR),
        ('choice-Extensions', _BroadcastCancelledAreaList_choice_Extensions),
        ])
    BroadcastCancelledAreaList._ext = None
    
    #-----< BroadcastCancelledAreaList-ExtIEs >-----#
    BroadcastCancelledAreaList_ExtIEs = CLASS(name='BroadcastCancelledAreaList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    BroadcastCancelledAreaList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BroadcastCompletedAreaList >-----#
    BroadcastCompletedAreaList = CHOICE(name='BroadcastCompletedAreaList', mode=MODE_TYPE)
    _BroadcastCompletedAreaList_cellIDBroadcastEUTRA = SEQ_OF(name='cellIDBroadcastEUTRA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellIDBroadcastEUTRA')))
    _BroadcastCompletedAreaList_tAIBroadcastEUTRA = SEQ_OF(name='tAIBroadcastEUTRA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAIBroadcastEUTRA')))
    _BroadcastCompletedAreaList_emergencyAreaIDBroadcastEUTRA = SEQ_OF(name='emergencyAreaIDBroadcastEUTRA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaIDBroadcastEUTRA')))
    _BroadcastCompletedAreaList_cellIDBroadcastNR = SEQ_OF(name='cellIDBroadcastNR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellIDBroadcastNR')))
    _BroadcastCompletedAreaList_tAIBroadcastNR = SEQ_OF(name='tAIBroadcastNR', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAIBroadcastNR')))
    _BroadcastCompletedAreaList_emergencyAreaIDBroadcastNR = SEQ_OF(name='emergencyAreaIDBroadcastNR', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaIDBroadcastNR')))
    _BroadcastCompletedAreaList_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __BroadcastCompletedAreaList_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___BroadcastCompletedAreaList_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___BroadcastCompletedAreaList_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BroadcastCompletedAreaList_choice_Extensions_id._const_tab = ___BroadcastCompletedAreaList_choice_Extensions_id_tab
    __BroadcastCompletedAreaList_choice_Extensions_id._const_tab_at = None
    __BroadcastCompletedAreaList_choice_Extensions_id._const_tab_id = 'id'
    __BroadcastCompletedAreaList_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___BroadcastCompletedAreaList_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___BroadcastCompletedAreaList_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BroadcastCompletedAreaList_choice_Extensions_criticality._const_tab = ___BroadcastCompletedAreaList_choice_Extensions_criticality_tab
    __BroadcastCompletedAreaList_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __BroadcastCompletedAreaList_choice_Extensions_criticality._const_tab_id = 'criticality'
    __BroadcastCompletedAreaList_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___BroadcastCompletedAreaList_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___BroadcastCompletedAreaList_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BroadcastCompletedAreaList_choice_Extensions_value._const_tab = ___BroadcastCompletedAreaList_choice_Extensions_value_tab
    __BroadcastCompletedAreaList_choice_Extensions_value._const_tab_at = ('..', 'id')
    __BroadcastCompletedAreaList_choice_Extensions_value._const_tab_id = 'Value'
    _BroadcastCompletedAreaList_choice_Extensions._cont = ASN1Dict([
        ('id', __BroadcastCompletedAreaList_choice_Extensions_id),
        ('criticality', __BroadcastCompletedAreaList_choice_Extensions_criticality),
        ('value', __BroadcastCompletedAreaList_choice_Extensions_value),
        ])
    _BroadcastCompletedAreaList_choice_Extensions._ext = None
    BroadcastCompletedAreaList._cont = ASN1Dict([
        ('cellIDBroadcastEUTRA', _BroadcastCompletedAreaList_cellIDBroadcastEUTRA),
        ('tAIBroadcastEUTRA', _BroadcastCompletedAreaList_tAIBroadcastEUTRA),
        ('emergencyAreaIDBroadcastEUTRA', _BroadcastCompletedAreaList_emergencyAreaIDBroadcastEUTRA),
        ('cellIDBroadcastNR', _BroadcastCompletedAreaList_cellIDBroadcastNR),
        ('tAIBroadcastNR', _BroadcastCompletedAreaList_tAIBroadcastNR),
        ('emergencyAreaIDBroadcastNR', _BroadcastCompletedAreaList_emergencyAreaIDBroadcastNR),
        ('choice-Extensions', _BroadcastCompletedAreaList_choice_Extensions),
        ])
    BroadcastCompletedAreaList._ext = None
    
    #-----< BroadcastCompletedAreaList-ExtIEs >-----#
    BroadcastCompletedAreaList_ExtIEs = CLASS(name='BroadcastCompletedAreaList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    BroadcastCompletedAreaList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BroadcastPLMNList >-----#
    BroadcastPLMNList = SEQ_OF(name='BroadcastPLMNList', mode=MODE_TYPE)
    _BroadcastPLMNList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'BroadcastPLMNItem')))
    BroadcastPLMNList._cont = _BroadcastPLMNList__item_
    BroadcastPLMNList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< BroadcastPLMNItem >-----#
    BroadcastPLMNItem = SEQ(name='BroadcastPLMNItem', mode=MODE_TYPE)
    _BroadcastPLMNItem_pLMNIdentity = OCT_STR(name='pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _BroadcastPLMNItem_tAISliceSupportList = SEQ_OF(name='tAISliceSupportList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SliceSupportList')))
    _BroadcastPLMNItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BroadcastPLMNItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___BroadcastPLMNItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____BroadcastPLMNItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____BroadcastPLMNItem_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NPN-Support')))
    _____BroadcastPLMNItem_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedSliceSupportList')))
    _____BroadcastPLMNItem_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAINSAGSupportList')))
    ____BroadcastPLMNItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 258), ('criticality', 'reject'), ('Extension', _____BroadcastPLMNItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 271), ('criticality', 'reject'), ('Extension', _____BroadcastPLMNItem_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 353), ('criticality', 'ignore'), ('Extension', _____BroadcastPLMNItem_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BroadcastPLMNItem_iE_Extensions__item__id._const_tab = ____BroadcastPLMNItem_iE_Extensions__item__id_tab
    ___BroadcastPLMNItem_iE_Extensions__item__id._const_tab_at = None
    ___BroadcastPLMNItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___BroadcastPLMNItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___BroadcastPLMNItem_iE_Extensions__item__criticality._const_tab = ____BroadcastPLMNItem_iE_Extensions__item__id_tab
    ___BroadcastPLMNItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastPLMNItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BroadcastPLMNItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___BroadcastPLMNItem_iE_Extensions__item__extensionValue._const_tab = ____BroadcastPLMNItem_iE_Extensions__item__id_tab
    ___BroadcastPLMNItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BroadcastPLMNItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BroadcastPLMNItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BroadcastPLMNItem_iE_Extensions__item__id),
        ('criticality', ___BroadcastPLMNItem_iE_Extensions__item__criticality),
        ('extensionValue', ___BroadcastPLMNItem_iE_Extensions__item__extensionValue),
        ])
    __BroadcastPLMNItem_iE_Extensions__item_._ext = None
    _BroadcastPLMNItem_iE_Extensions._cont = __BroadcastPLMNItem_iE_Extensions__item_
    _BroadcastPLMNItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BroadcastPLMNItem._cont = ASN1Dict([
        ('pLMNIdentity', _BroadcastPLMNItem_pLMNIdentity),
        ('tAISliceSupportList', _BroadcastPLMNItem_tAISliceSupportList),
        ('iE-Extensions', _BroadcastPLMNItem_iE_Extensions),
        ])
    BroadcastPLMNItem._ext = []
    
    #-----< BroadcastPLMNItem-ExtIEs >-----#
    BroadcastPLMNItem_ExtIEs = CLASS(name='BroadcastPLMNItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _BroadcastPLMNItem_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NPN-Support')))
    _BroadcastPLMNItem_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedSliceSupportList')))
    _BroadcastPLMNItem_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAINSAGSupportList')))
    BroadcastPLMNItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 258), ('criticality', 'reject'), ('Extension', _BroadcastPLMNItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 271), ('criticality', 'reject'), ('Extension', _BroadcastPLMNItem_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 353), ('criticality', 'ignore'), ('Extension', _BroadcastPLMNItem_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BluetoothMeasurementConfiguration >-----#
    BluetoothMeasurementConfiguration = SEQ(name='BluetoothMeasurementConfiguration', mode=MODE_TYPE)
    _BluetoothMeasurementConfiguration_bluetoothMeasConfig = ENUM(name='bluetoothMeasConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BluetoothMeasConfig')))
    _BluetoothMeasurementConfiguration_bluetoothMeasConfigNameList = SEQ_OF(name='bluetoothMeasConfigNameList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BluetoothMeasConfigNameList')), opt=True)
    _BluetoothMeasurementConfiguration_bt_rssi = ENUM(name='bt-rssi', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BluetoothMeasurementConfiguration_bt_rssi._cont = ASN1Dict([('true', 0)])
    _BluetoothMeasurementConfiguration_bt_rssi._ext = []
    _BluetoothMeasurementConfiguration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BluetoothMeasurementConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__id._const_tab = ____BluetoothMeasurementConfiguration_iE_Extensions__item__id_tab
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__id._const_tab_id = 'id'
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality._const_tab = ____BluetoothMeasurementConfiguration_iE_Extensions__item__criticality_tab
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab = ____BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue_tab
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BluetoothMeasurementConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BluetoothMeasurementConfiguration_iE_Extensions__item__id),
        ('criticality', ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality),
        ('extensionValue', ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue),
        ])
    __BluetoothMeasurementConfiguration_iE_Extensions__item_._ext = None
    _BluetoothMeasurementConfiguration_iE_Extensions._cont = __BluetoothMeasurementConfiguration_iE_Extensions__item_
    _BluetoothMeasurementConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BluetoothMeasurementConfiguration._cont = ASN1Dict([
        ('bluetoothMeasConfig', _BluetoothMeasurementConfiguration_bluetoothMeasConfig),
        ('bluetoothMeasConfigNameList', _BluetoothMeasurementConfiguration_bluetoothMeasConfigNameList),
        ('bt-rssi', _BluetoothMeasurementConfiguration_bt_rssi),
        ('iE-Extensions', _BluetoothMeasurementConfiguration_iE_Extensions),
        ])
    BluetoothMeasurementConfiguration._ext = []
    
    #-----< BluetoothMeasurementConfiguration-ExtIEs >-----#
    BluetoothMeasurementConfiguration_ExtIEs = CLASS(name='BluetoothMeasurementConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    BluetoothMeasurementConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BluetoothMeasConfigNameList >-----#
    BluetoothMeasConfigNameList = SEQ_OF(name='BluetoothMeasConfigNameList', mode=MODE_TYPE)
    _BluetoothMeasConfigNameList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'BluetoothMeasConfigNameItem')))
    BluetoothMeasConfigNameList._cont = _BluetoothMeasConfigNameList__item_
    BluetoothMeasConfigNameList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< BluetoothMeasConfigNameItem >-----#
    BluetoothMeasConfigNameItem = SEQ(name='BluetoothMeasConfigNameItem', mode=MODE_TYPE)
    _BluetoothMeasConfigNameItem_bluetoothName = OCT_STR(name='bluetoothName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BluetoothName')))
    _BluetoothMeasConfigNameItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BluetoothMeasConfigNameItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___BluetoothMeasConfigNameItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____BluetoothMeasConfigNameItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____BluetoothMeasConfigNameItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BluetoothMeasConfigNameItem_iE_Extensions__item__id._const_tab = ____BluetoothMeasConfigNameItem_iE_Extensions__item__id_tab
    ___BluetoothMeasConfigNameItem_iE_Extensions__item__id._const_tab_at = None
    ___BluetoothMeasConfigNameItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___BluetoothMeasConfigNameItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BluetoothMeasConfigNameItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____BluetoothMeasConfigNameItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BluetoothMeasConfigNameItem_iE_Extensions__item__criticality._const_tab = ____BluetoothMeasConfigNameItem_iE_Extensions__item__criticality_tab
    ___BluetoothMeasConfigNameItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BluetoothMeasConfigNameItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BluetoothMeasConfigNameItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BluetoothMeasConfigNameItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____BluetoothMeasConfigNameItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BluetoothMeasConfigNameItem_iE_Extensions__item__extensionValue._const_tab = ____BluetoothMeasConfigNameItem_iE_Extensions__item__extensionValue_tab
    ___BluetoothMeasConfigNameItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BluetoothMeasConfigNameItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BluetoothMeasConfigNameItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BluetoothMeasConfigNameItem_iE_Extensions__item__id),
        ('criticality', ___BluetoothMeasConfigNameItem_iE_Extensions__item__criticality),
        ('extensionValue', ___BluetoothMeasConfigNameItem_iE_Extensions__item__extensionValue),
        ])
    __BluetoothMeasConfigNameItem_iE_Extensions__item_._ext = None
    _BluetoothMeasConfigNameItem_iE_Extensions._cont = __BluetoothMeasConfigNameItem_iE_Extensions__item_
    _BluetoothMeasConfigNameItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BluetoothMeasConfigNameItem._cont = ASN1Dict([
        ('bluetoothName', _BluetoothMeasConfigNameItem_bluetoothName),
        ('iE-Extensions', _BluetoothMeasConfigNameItem_iE_Extensions),
        ])
    BluetoothMeasConfigNameItem._ext = []
    
    #-----< BluetoothMeasConfigNameItem-ExtIEs >-----#
    BluetoothMeasConfigNameItem_ExtIEs = CLASS(name='BluetoothMeasConfigNameItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    BluetoothMeasConfigNameItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BluetoothMeasConfig >-----#
    BluetoothMeasConfig = ENUM(name='BluetoothMeasConfig', mode=MODE_TYPE)
    BluetoothMeasConfig._cont = ASN1Dict([('setup', 0)])
    BluetoothMeasConfig._ext = []
    
    #-----< BluetoothName >-----#
    BluetoothName = OCT_STR(name='BluetoothName', mode=MODE_TYPE)
    BluetoothName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=248)], ev=None, er=[])
    
    #-----< BurstArrivalTime >-----#
    BurstArrivalTime = OCT_STR(name='BurstArrivalTime', mode=MODE_TYPE)
    
    #-----< CAG-ID >-----#
    CAG_ID = BIT_STR(name='CAG-ID', mode=MODE_TYPE)
    CAG_ID._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< CancelAllWarningMessages >-----#
    CancelAllWarningMessages = ENUM(name='CancelAllWarningMessages', mode=MODE_TYPE)
    CancelAllWarningMessages._cont = ASN1Dict([('true', 0)])
    CancelAllWarningMessages._ext = []
    
    #-----< CancelledCellsInEAI-EUTRA >-----#
    CancelledCellsInEAI_EUTRA = SEQ_OF(name='CancelledCellsInEAI-EUTRA', mode=MODE_TYPE)
    _CancelledCellsInEAI_EUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CancelledCellsInEAI-EUTRA-Item')))
    CancelledCellsInEAI_EUTRA._cont = _CancelledCellsInEAI_EUTRA__item_
    CancelledCellsInEAI_EUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CancelledCellsInEAI-EUTRA-Item >-----#
    CancelledCellsInEAI_EUTRA_Item = SEQ(name='CancelledCellsInEAI-EUTRA-Item', mode=MODE_TYPE)
    _CancelledCellsInEAI_EUTRA_Item_eUTRA_CGI = SEQ(name='eUTRA-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _CancelledCellsInEAI_EUTRA_Item_numberOfBroadcasts = INT(name='numberOfBroadcasts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NumberOfBroadcasts')))
    _CancelledCellsInEAI_EUTRA_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__id._const_tab = ____CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__id_tab
    ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality._const_tab = ____CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality_tab
    ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__id),
        ('criticality', ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item_._ext = None
    _CancelledCellsInEAI_EUTRA_Item_iE_Extensions._cont = __CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item_
    _CancelledCellsInEAI_EUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CancelledCellsInEAI_EUTRA_Item._cont = ASN1Dict([
        ('eUTRA-CGI', _CancelledCellsInEAI_EUTRA_Item_eUTRA_CGI),
        ('numberOfBroadcasts', _CancelledCellsInEAI_EUTRA_Item_numberOfBroadcasts),
        ('iE-Extensions', _CancelledCellsInEAI_EUTRA_Item_iE_Extensions),
        ])
    CancelledCellsInEAI_EUTRA_Item._ext = []
    
    #-----< CancelledCellsInEAI-EUTRA-Item-ExtIEs >-----#
    CancelledCellsInEAI_EUTRA_Item_ExtIEs = CLASS(name='CancelledCellsInEAI-EUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CancelledCellsInEAI_EUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CancelledCellsInEAI-NR >-----#
    CancelledCellsInEAI_NR = SEQ_OF(name='CancelledCellsInEAI-NR', mode=MODE_TYPE)
    _CancelledCellsInEAI_NR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CancelledCellsInEAI-NR-Item')))
    CancelledCellsInEAI_NR._cont = _CancelledCellsInEAI_NR__item_
    CancelledCellsInEAI_NR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CancelledCellsInEAI-NR-Item >-----#
    CancelledCellsInEAI_NR_Item = SEQ(name='CancelledCellsInEAI-NR-Item', mode=MODE_TYPE)
    _CancelledCellsInEAI_NR_Item_nR_CGI = SEQ(name='nR-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    _CancelledCellsInEAI_NR_Item_numberOfBroadcasts = INT(name='numberOfBroadcasts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NumberOfBroadcasts')))
    _CancelledCellsInEAI_NR_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CancelledCellsInEAI_NR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____CancelledCellsInEAI_NR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CancelledCellsInEAI_NR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__id._const_tab = ____CancelledCellsInEAI_NR_Item_iE_Extensions__item__id_tab
    ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__id._const_tab_at = None
    ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CancelledCellsInEAI_NR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CancelledCellsInEAI_NR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__criticality._const_tab = ____CancelledCellsInEAI_NR_Item_iE_Extensions__item__criticality_tab
    ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CancelledCellsInEAI_NR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CancelledCellsInEAI_NR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__extensionValue._const_tab = ____CancelledCellsInEAI_NR_Item_iE_Extensions__item__extensionValue_tab
    ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CancelledCellsInEAI_NR_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__id),
        ('criticality', ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__extensionValue),
        ])
    __CancelledCellsInEAI_NR_Item_iE_Extensions__item_._ext = None
    _CancelledCellsInEAI_NR_Item_iE_Extensions._cont = __CancelledCellsInEAI_NR_Item_iE_Extensions__item_
    _CancelledCellsInEAI_NR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CancelledCellsInEAI_NR_Item._cont = ASN1Dict([
        ('nR-CGI', _CancelledCellsInEAI_NR_Item_nR_CGI),
        ('numberOfBroadcasts', _CancelledCellsInEAI_NR_Item_numberOfBroadcasts),
        ('iE-Extensions', _CancelledCellsInEAI_NR_Item_iE_Extensions),
        ])
    CancelledCellsInEAI_NR_Item._ext = []
    
    #-----< CancelledCellsInEAI-NR-Item-ExtIEs >-----#
    CancelledCellsInEAI_NR_Item_ExtIEs = CLASS(name='CancelledCellsInEAI-NR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CancelledCellsInEAI_NR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CancelledCellsInTAI-EUTRA >-----#
    CancelledCellsInTAI_EUTRA = SEQ_OF(name='CancelledCellsInTAI-EUTRA', mode=MODE_TYPE)
    _CancelledCellsInTAI_EUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CancelledCellsInTAI-EUTRA-Item')))
    CancelledCellsInTAI_EUTRA._cont = _CancelledCellsInTAI_EUTRA__item_
    CancelledCellsInTAI_EUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CancelledCellsInTAI-EUTRA-Item >-----#
    CancelledCellsInTAI_EUTRA_Item = SEQ(name='CancelledCellsInTAI-EUTRA-Item', mode=MODE_TYPE)
    _CancelledCellsInTAI_EUTRA_Item_eUTRA_CGI = SEQ(name='eUTRA-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _CancelledCellsInTAI_EUTRA_Item_numberOfBroadcasts = INT(name='numberOfBroadcasts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NumberOfBroadcasts')))
    _CancelledCellsInTAI_EUTRA_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__id._const_tab = ____CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__id_tab
    ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality._const_tab = ____CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality_tab
    ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__id),
        ('criticality', ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item_._ext = None
    _CancelledCellsInTAI_EUTRA_Item_iE_Extensions._cont = __CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item_
    _CancelledCellsInTAI_EUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CancelledCellsInTAI_EUTRA_Item._cont = ASN1Dict([
        ('eUTRA-CGI', _CancelledCellsInTAI_EUTRA_Item_eUTRA_CGI),
        ('numberOfBroadcasts', _CancelledCellsInTAI_EUTRA_Item_numberOfBroadcasts),
        ('iE-Extensions', _CancelledCellsInTAI_EUTRA_Item_iE_Extensions),
        ])
    CancelledCellsInTAI_EUTRA_Item._ext = []
    
    #-----< CancelledCellsInTAI-EUTRA-Item-ExtIEs >-----#
    CancelledCellsInTAI_EUTRA_Item_ExtIEs = CLASS(name='CancelledCellsInTAI-EUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CancelledCellsInTAI_EUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CancelledCellsInTAI-NR >-----#
    CancelledCellsInTAI_NR = SEQ_OF(name='CancelledCellsInTAI-NR', mode=MODE_TYPE)
    _CancelledCellsInTAI_NR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CancelledCellsInTAI-NR-Item')))
    CancelledCellsInTAI_NR._cont = _CancelledCellsInTAI_NR__item_
    CancelledCellsInTAI_NR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CancelledCellsInTAI-NR-Item >-----#
    CancelledCellsInTAI_NR_Item = SEQ(name='CancelledCellsInTAI-NR-Item', mode=MODE_TYPE)
    _CancelledCellsInTAI_NR_Item_nR_CGI = SEQ(name='nR-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    _CancelledCellsInTAI_NR_Item_numberOfBroadcasts = INT(name='numberOfBroadcasts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NumberOfBroadcasts')))
    _CancelledCellsInTAI_NR_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CancelledCellsInTAI_NR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____CancelledCellsInTAI_NR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CancelledCellsInTAI_NR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__id._const_tab = ____CancelledCellsInTAI_NR_Item_iE_Extensions__item__id_tab
    ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__id._const_tab_at = None
    ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CancelledCellsInTAI_NR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CancelledCellsInTAI_NR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__criticality._const_tab = ____CancelledCellsInTAI_NR_Item_iE_Extensions__item__criticality_tab
    ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CancelledCellsInTAI_NR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CancelledCellsInTAI_NR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__extensionValue._const_tab = ____CancelledCellsInTAI_NR_Item_iE_Extensions__item__extensionValue_tab
    ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CancelledCellsInTAI_NR_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__id),
        ('criticality', ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__extensionValue),
        ])
    __CancelledCellsInTAI_NR_Item_iE_Extensions__item_._ext = None
    _CancelledCellsInTAI_NR_Item_iE_Extensions._cont = __CancelledCellsInTAI_NR_Item_iE_Extensions__item_
    _CancelledCellsInTAI_NR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CancelledCellsInTAI_NR_Item._cont = ASN1Dict([
        ('nR-CGI', _CancelledCellsInTAI_NR_Item_nR_CGI),
        ('numberOfBroadcasts', _CancelledCellsInTAI_NR_Item_numberOfBroadcasts),
        ('iE-Extensions', _CancelledCellsInTAI_NR_Item_iE_Extensions),
        ])
    CancelledCellsInTAI_NR_Item._ext = []
    
    #-----< CancelledCellsInTAI-NR-Item-ExtIEs >-----#
    CancelledCellsInTAI_NR_Item_ExtIEs = CLASS(name='CancelledCellsInTAI-NR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CancelledCellsInTAI_NR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CandidateCellList >-----#
    CandidateCellList = SEQ_OF(name='CandidateCellList', mode=MODE_TYPE)
    _CandidateCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CandidateCellItem')))
    CandidateCellList._cont = _CandidateCellList__item_
    CandidateCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< CandidateCellItem >-----#
    CandidateCellItem = SEQ(name='CandidateCellItem', mode=MODE_TYPE)
    _CandidateCellItem_candidateCell = CHOICE(name='candidateCell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CandidateCell')))
    _CandidateCellItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CandidateCellItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CandidateCellItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____CandidateCellItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CandidateCellItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CandidateCellItem_iE_Extensions__item__id._const_tab = ____CandidateCellItem_iE_Extensions__item__id_tab
    ___CandidateCellItem_iE_Extensions__item__id._const_tab_at = None
    ___CandidateCellItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___CandidateCellItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CandidateCellItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CandidateCellItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CandidateCellItem_iE_Extensions__item__criticality._const_tab = ____CandidateCellItem_iE_Extensions__item__criticality_tab
    ___CandidateCellItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CandidateCellItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CandidateCellItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CandidateCellItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CandidateCellItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CandidateCellItem_iE_Extensions__item__extensionValue._const_tab = ____CandidateCellItem_iE_Extensions__item__extensionValue_tab
    ___CandidateCellItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CandidateCellItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CandidateCellItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CandidateCellItem_iE_Extensions__item__id),
        ('criticality', ___CandidateCellItem_iE_Extensions__item__criticality),
        ('extensionValue', ___CandidateCellItem_iE_Extensions__item__extensionValue),
        ])
    __CandidateCellItem_iE_Extensions__item_._ext = None
    _CandidateCellItem_iE_Extensions._cont = __CandidateCellItem_iE_Extensions__item_
    _CandidateCellItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CandidateCellItem._cont = ASN1Dict([
        ('candidateCell', _CandidateCellItem_candidateCell),
        ('iE-Extensions', _CandidateCellItem_iE_Extensions),
        ])
    CandidateCellItem._ext = []
    
    #-----< CandidateCellItem-ExtIEs >-----#
    CandidateCellItem_ExtIEs = CLASS(name='CandidateCellItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CandidateCellItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CandidateCell >-----#
    CandidateCell = CHOICE(name='CandidateCell', mode=MODE_TYPE)
    _CandidateCell_candidateCGI = SEQ(name='candidateCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CandidateCellID')))
    _CandidateCell_candidatePCI = SEQ(name='candidatePCI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CandidatePCI')))
    _CandidateCell_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __CandidateCell_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___CandidateCell_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___CandidateCell_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CandidateCell_choice_Extensions_id._const_tab = ___CandidateCell_choice_Extensions_id_tab
    __CandidateCell_choice_Extensions_id._const_tab_at = None
    __CandidateCell_choice_Extensions_id._const_tab_id = 'id'
    __CandidateCell_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___CandidateCell_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___CandidateCell_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CandidateCell_choice_Extensions_criticality._const_tab = ___CandidateCell_choice_Extensions_criticality_tab
    __CandidateCell_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __CandidateCell_choice_Extensions_criticality._const_tab_id = 'criticality'
    __CandidateCell_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___CandidateCell_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___CandidateCell_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CandidateCell_choice_Extensions_value._const_tab = ___CandidateCell_choice_Extensions_value_tab
    __CandidateCell_choice_Extensions_value._const_tab_at = ('..', 'id')
    __CandidateCell_choice_Extensions_value._const_tab_id = 'Value'
    _CandidateCell_choice_Extensions._cont = ASN1Dict([
        ('id', __CandidateCell_choice_Extensions_id),
        ('criticality', __CandidateCell_choice_Extensions_criticality),
        ('value', __CandidateCell_choice_Extensions_value),
        ])
    _CandidateCell_choice_Extensions._ext = None
    CandidateCell._cont = ASN1Dict([
        ('candidateCGI', _CandidateCell_candidateCGI),
        ('candidatePCI', _CandidateCell_candidatePCI),
        ('choice-Extensions', _CandidateCell_choice_Extensions),
        ])
    CandidateCell._ext = None
    
    #-----< CandidateCell-ExtIEs >-----#
    CandidateCell_ExtIEs = CLASS(name='CandidateCell-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    CandidateCell_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CandidateCellID >-----#
    CandidateCellID = SEQ(name='CandidateCellID', mode=MODE_TYPE)
    _CandidateCellID_candidateCellID = SEQ(name='candidateCellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    _CandidateCellID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CandidateCellID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CandidateCellID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____CandidateCellID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CandidateCellID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CandidateCellID_iE_Extensions__item__id._const_tab = ____CandidateCellID_iE_Extensions__item__id_tab
    ___CandidateCellID_iE_Extensions__item__id._const_tab_at = None
    ___CandidateCellID_iE_Extensions__item__id._const_tab_id = 'id'
    ___CandidateCellID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CandidateCellID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CandidateCellID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CandidateCellID_iE_Extensions__item__criticality._const_tab = ____CandidateCellID_iE_Extensions__item__criticality_tab
    ___CandidateCellID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CandidateCellID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CandidateCellID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CandidateCellID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CandidateCellID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CandidateCellID_iE_Extensions__item__extensionValue._const_tab = ____CandidateCellID_iE_Extensions__item__extensionValue_tab
    ___CandidateCellID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CandidateCellID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CandidateCellID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CandidateCellID_iE_Extensions__item__id),
        ('criticality', ___CandidateCellID_iE_Extensions__item__criticality),
        ('extensionValue', ___CandidateCellID_iE_Extensions__item__extensionValue),
        ])
    __CandidateCellID_iE_Extensions__item_._ext = None
    _CandidateCellID_iE_Extensions._cont = __CandidateCellID_iE_Extensions__item_
    _CandidateCellID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CandidateCellID._cont = ASN1Dict([
        ('candidateCellID', _CandidateCellID_candidateCellID),
        ('iE-Extensions', _CandidateCellID_iE_Extensions),
        ])
    CandidateCellID._ext = []
    
    #-----< CandidateCellID-ExtIEs >-----#
    CandidateCellID_ExtIEs = CLASS(name='CandidateCellID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CandidateCellID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CandidatePCI >-----#
    CandidatePCI = SEQ(name='CandidatePCI', mode=MODE_TYPE)
    _CandidatePCI_candidatePCI = INT(name='candidatePCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CandidatePCI_candidatePCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1007)], ev=[], er=[])
    _CandidatePCI_candidateNRARFCN = INT(name='candidateNRARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CandidatePCI_candidateNRARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _CandidatePCI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CandidatePCI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CandidatePCI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____CandidatePCI_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CandidatePCI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CandidatePCI_iE_Extensions__item__id._const_tab = ____CandidatePCI_iE_Extensions__item__id_tab
    ___CandidatePCI_iE_Extensions__item__id._const_tab_at = None
    ___CandidatePCI_iE_Extensions__item__id._const_tab_id = 'id'
    ___CandidatePCI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CandidatePCI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CandidatePCI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CandidatePCI_iE_Extensions__item__criticality._const_tab = ____CandidatePCI_iE_Extensions__item__criticality_tab
    ___CandidatePCI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CandidatePCI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CandidatePCI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CandidatePCI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CandidatePCI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CandidatePCI_iE_Extensions__item__extensionValue._const_tab = ____CandidatePCI_iE_Extensions__item__extensionValue_tab
    ___CandidatePCI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CandidatePCI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CandidatePCI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CandidatePCI_iE_Extensions__item__id),
        ('criticality', ___CandidatePCI_iE_Extensions__item__criticality),
        ('extensionValue', ___CandidatePCI_iE_Extensions__item__extensionValue),
        ])
    __CandidatePCI_iE_Extensions__item_._ext = None
    _CandidatePCI_iE_Extensions._cont = __CandidatePCI_iE_Extensions__item_
    _CandidatePCI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CandidatePCI._cont = ASN1Dict([
        ('candidatePCI', _CandidatePCI_candidatePCI),
        ('candidateNRARFCN', _CandidatePCI_candidateNRARFCN),
        ('iE-Extensions', _CandidatePCI_iE_Extensions),
        ])
    CandidatePCI._ext = []
    
    #-----< CandidatePCI-ExtIEs >-----#
    CandidatePCI_ExtIEs = CLASS(name='CandidatePCI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CandidatePCI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cause >-----#
    Cause = CHOICE(name='Cause', mode=MODE_TYPE)
    _Cause_radioNetwork = ENUM(name='radioNetwork', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CauseRadioNetwork')))
    _Cause_transport = ENUM(name='transport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CauseTransport')))
    _Cause_nas = ENUM(name='nas', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CauseNas')))
    _Cause_protocol = ENUM(name='protocol', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CauseProtocol')))
    _Cause_misc = ENUM(name='misc', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CauseMisc')))
    _Cause_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __Cause_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___Cause_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___Cause_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Cause_choice_Extensions_id._const_tab = ___Cause_choice_Extensions_id_tab
    __Cause_choice_Extensions_id._const_tab_at = None
    __Cause_choice_Extensions_id._const_tab_id = 'id'
    __Cause_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___Cause_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___Cause_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Cause_choice_Extensions_criticality._const_tab = ___Cause_choice_Extensions_criticality_tab
    __Cause_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __Cause_choice_Extensions_criticality._const_tab_id = 'criticality'
    __Cause_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___Cause_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___Cause_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Cause_choice_Extensions_value._const_tab = ___Cause_choice_Extensions_value_tab
    __Cause_choice_Extensions_value._const_tab_at = ('..', 'id')
    __Cause_choice_Extensions_value._const_tab_id = 'Value'
    _Cause_choice_Extensions._cont = ASN1Dict([
        ('id', __Cause_choice_Extensions_id),
        ('criticality', __Cause_choice_Extensions_criticality),
        ('value', __Cause_choice_Extensions_value),
        ])
    _Cause_choice_Extensions._ext = None
    Cause._cont = ASN1Dict([
        ('radioNetwork', _Cause_radioNetwork),
        ('transport', _Cause_transport),
        ('nas', _Cause_nas),
        ('protocol', _Cause_protocol),
        ('misc', _Cause_misc),
        ('choice-Extensions', _Cause_choice_Extensions),
        ])
    Cause._ext = None
    
    #-----< Cause-ExtIEs >-----#
    Cause_ExtIEs = CLASS(name='Cause-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    Cause_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CauseMisc >-----#
    CauseMisc = ENUM(name='CauseMisc', mode=MODE_TYPE)
    CauseMisc._cont = ASN1Dict([('control-processing-overload', 0), ('not-enough-user-plane-processing-resources', 1), ('hardware-failure', 2), ('om-intervention', 3), ('unknown-PLMN-or-SNPN', 4), ('unspecified', 5)])
    CauseMisc._ext = []
    
    #-----< CauseNas >-----#
    CauseNas = ENUM(name='CauseNas', mode=MODE_TYPE)
    CauseNas._cont = ASN1Dict([('normal-release', 0), ('authentication-failure', 1), ('deregister', 2), ('unspecified', 3), ('uE-not-in-PLMN-serving-area', 4)])
    CauseNas._ext = ['uE-not-in-PLMN-serving-area']
    
    #-----< CauseProtocol >-----#
    CauseProtocol = ENUM(name='CauseProtocol', mode=MODE_TYPE)
    CauseProtocol._cont = ASN1Dict([('transfer-syntax-error', 0), ('abstract-syntax-error-reject', 1), ('abstract-syntax-error-ignore-and-notify', 2), ('message-not-compatible-with-receiver-state', 3), ('semantic-error', 4), ('abstract-syntax-error-falsely-constructed-message', 5), ('unspecified', 6)])
    CauseProtocol._ext = []
    
    #-----< CauseRadioNetwork >-----#
    CauseRadioNetwork = ENUM(name='CauseRadioNetwork', mode=MODE_TYPE)
    CauseRadioNetwork._cont = ASN1Dict([('unspecified', 0), ('txnrelocoverall-expiry', 1), ('successful-handover', 2), ('release-due-to-ngran-generated-reason', 3), ('release-due-to-5gc-generated-reason', 4), ('handover-cancelled', 5), ('partial-handover', 6), ('ho-failure-in-target-5GC-ngran-node-or-target-system', 7), ('ho-target-not-allowed', 8), ('tngrelocoverall-expiry', 9), ('tngrelocprep-expiry', 10), ('cell-not-available', 11), ('unknown-targetID', 12), ('no-radio-resources-available-in-target-cell', 13), ('unknown-local-UE-NGAP-ID', 14), ('inconsistent-remote-UE-NGAP-ID', 15), ('handover-desirable-for-radio-reason', 16), ('time-critical-handover', 17), ('resource-optimisation-handover', 18), ('reduce-load-in-serving-cell', 19), ('user-inactivity', 20), ('radio-connection-with-ue-lost', 21), ('radio-resources-not-available', 22), ('invalid-qos-combination', 23), ('failure-in-radio-interface-procedure', 24), ('interaction-with-other-procedure', 25), ('unknown-PDU-session-ID', 26), ('unkown-qos-flow-ID', 27), ('multiple-PDU-session-ID-instances', 28), ('multiple-qos-flow-ID-instances', 29), ('encryption-and-or-integrity-protection-algorithms-not-supported', 30), ('ng-intra-system-handover-triggered', 31), ('ng-inter-system-handover-triggered', 32), ('xn-handover-triggered', 33), ('not-supported-5QI-value', 34), ('ue-context-transfer', 35), ('ims-voice-eps-fallback-or-rat-fallback-triggered', 36), ('up-integrity-protection-not-possible', 37), ('up-confidentiality-protection-not-possible', 38), ('slice-not-supported', 39), ('ue-in-rrc-inactive-state-not-reachable', 40), ('redirection', 41), ('resources-not-available-for-the-slice', 42), ('ue-max-integrity-protected-data-rate-reason', 43), ('release-due-to-cn-detected-mobility', 44), ('n26-interface-not-available', 45), ('release-due-to-pre-emption', 46), ('multiple-location-reporting-reference-ID-instances', 47), ('rsn-not-available-for-the-up', 48), ('npn-access-denied', 49), ('cag-only-access-denied', 50), ('insufficient-ue-capabilities', 51), ('redcap-ue-not-supported', 52), ('unknown-MBS-Session-ID', 53), ('indicated-MBS-session-area-information-not-served-by-the-gNB', 54), ('inconsistent-slice-info-for-the-session', 55), ('misaligned-association-for-multicast-unicast', 56)])
    CauseRadioNetwork._ext = ['n26-interface-not-available', 'release-due-to-pre-emption', 'multiple-location-reporting-reference-ID-instances', 'rsn-not-available-for-the-up', 'npn-access-denied', 'cag-only-access-denied', 'insufficient-ue-capabilities', 'redcap-ue-not-supported', 'unknown-MBS-Session-ID', 'indicated-MBS-session-area-information-not-served-by-the-gNB', 'inconsistent-slice-info-for-the-session', 'misaligned-association-for-multicast-unicast']
    
    #-----< CauseTransport >-----#
    CauseTransport = ENUM(name='CauseTransport', mode=MODE_TYPE)
    CauseTransport._cont = ASN1Dict([('transport-resource-unavailable', 0), ('unspecified', 1)])
    CauseTransport._ext = []
    
    #-----< Cell-CAGInformation >-----#
    Cell_CAGInformation = SEQ(name='Cell-CAGInformation', mode=MODE_TYPE)
    _Cell_CAGInformation_nGRAN_CGI = CHOICE(name='nGRAN-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _Cell_CAGInformation_cellCAGList = SEQ_OF(name='cellCAGList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellCAGList')))
    _Cell_CAGInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cell_CAGInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___Cell_CAGInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____Cell_CAGInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____Cell_CAGInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_CAGInformation_iE_Extensions__item__id._const_tab = ____Cell_CAGInformation_iE_Extensions__item__id_tab
    ___Cell_CAGInformation_iE_Extensions__item__id._const_tab_at = None
    ___Cell_CAGInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___Cell_CAGInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Cell_CAGInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____Cell_CAGInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_CAGInformation_iE_Extensions__item__criticality._const_tab = ____Cell_CAGInformation_iE_Extensions__item__criticality_tab
    ___Cell_CAGInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Cell_CAGInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Cell_CAGInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Cell_CAGInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____Cell_CAGInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_CAGInformation_iE_Extensions__item__extensionValue._const_tab = ____Cell_CAGInformation_iE_Extensions__item__extensionValue_tab
    ___Cell_CAGInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Cell_CAGInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Cell_CAGInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Cell_CAGInformation_iE_Extensions__item__id),
        ('criticality', ___Cell_CAGInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___Cell_CAGInformation_iE_Extensions__item__extensionValue),
        ])
    __Cell_CAGInformation_iE_Extensions__item_._ext = None
    _Cell_CAGInformation_iE_Extensions._cont = __Cell_CAGInformation_iE_Extensions__item_
    _Cell_CAGInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cell_CAGInformation._cont = ASN1Dict([
        ('nGRAN-CGI', _Cell_CAGInformation_nGRAN_CGI),
        ('cellCAGList', _Cell_CAGInformation_cellCAGList),
        ('iE-Extensions', _Cell_CAGInformation_iE_Extensions),
        ])
    Cell_CAGInformation._ext = []
    
    #-----< Cell-CAGInformation-ExtIEs >-----#
    Cell_CAGInformation_ExtIEs = CLASS(name='Cell-CAGInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    Cell_CAGInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellCAGList >-----#
    CellCAGList = SEQ_OF(name='CellCAGList', mode=MODE_TYPE)
    _CellCAGList__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CAG-ID')))
    CellCAGList._cont = _CellCAGList__item_
    CellCAGList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< CellIDBroadcastEUTRA >-----#
    CellIDBroadcastEUTRA = SEQ_OF(name='CellIDBroadcastEUTRA', mode=MODE_TYPE)
    _CellIDBroadcastEUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CellIDBroadcastEUTRA-Item')))
    CellIDBroadcastEUTRA._cont = _CellIDBroadcastEUTRA__item_
    CellIDBroadcastEUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CellIDBroadcastEUTRA-Item >-----#
    CellIDBroadcastEUTRA_Item = SEQ(name='CellIDBroadcastEUTRA-Item', mode=MODE_TYPE)
    _CellIDBroadcastEUTRA_Item_eUTRA_CGI = SEQ(name='eUTRA-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _CellIDBroadcastEUTRA_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellIDBroadcastEUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellIDBroadcastEUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellIDBroadcastEUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__id._const_tab = ____CellIDBroadcastEUTRA_Item_iE_Extensions__item__id_tab
    ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellIDBroadcastEUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellIDBroadcastEUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__criticality._const_tab = ____CellIDBroadcastEUTRA_Item_iE_Extensions__item__criticality_tab
    ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____CellIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellIDBroadcastEUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__id),
        ('criticality', ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __CellIDBroadcastEUTRA_Item_iE_Extensions__item_._ext = None
    _CellIDBroadcastEUTRA_Item_iE_Extensions._cont = __CellIDBroadcastEUTRA_Item_iE_Extensions__item_
    _CellIDBroadcastEUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellIDBroadcastEUTRA_Item._cont = ASN1Dict([
        ('eUTRA-CGI', _CellIDBroadcastEUTRA_Item_eUTRA_CGI),
        ('iE-Extensions', _CellIDBroadcastEUTRA_Item_iE_Extensions),
        ])
    CellIDBroadcastEUTRA_Item._ext = []
    
    #-----< CellIDBroadcastEUTRA-Item-ExtIEs >-----#
    CellIDBroadcastEUTRA_Item_ExtIEs = CLASS(name='CellIDBroadcastEUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CellIDBroadcastEUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellIDBroadcastNR >-----#
    CellIDBroadcastNR = SEQ_OF(name='CellIDBroadcastNR', mode=MODE_TYPE)
    _CellIDBroadcastNR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CellIDBroadcastNR-Item')))
    CellIDBroadcastNR._cont = _CellIDBroadcastNR__item_
    CellIDBroadcastNR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CellIDBroadcastNR-Item >-----#
    CellIDBroadcastNR_Item = SEQ(name='CellIDBroadcastNR-Item', mode=MODE_TYPE)
    _CellIDBroadcastNR_Item_nR_CGI = SEQ(name='nR-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    _CellIDBroadcastNR_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellIDBroadcastNR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CellIDBroadcastNR_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellIDBroadcastNR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellIDBroadcastNR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIDBroadcastNR_Item_iE_Extensions__item__id._const_tab = ____CellIDBroadcastNR_Item_iE_Extensions__item__id_tab
    ___CellIDBroadcastNR_Item_iE_Extensions__item__id._const_tab_at = None
    ___CellIDBroadcastNR_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellIDBroadcastNR_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellIDBroadcastNR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellIDBroadcastNR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIDBroadcastNR_Item_iE_Extensions__item__criticality._const_tab = ____CellIDBroadcastNR_Item_iE_Extensions__item__criticality_tab
    ___CellIDBroadcastNR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellIDBroadcastNR_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellIDBroadcastNR_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellIDBroadcastNR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellIDBroadcastNR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIDBroadcastNR_Item_iE_Extensions__item__extensionValue._const_tab = ____CellIDBroadcastNR_Item_iE_Extensions__item__extensionValue_tab
    ___CellIDBroadcastNR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellIDBroadcastNR_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellIDBroadcastNR_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellIDBroadcastNR_Item_iE_Extensions__item__id),
        ('criticality', ___CellIDBroadcastNR_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CellIDBroadcastNR_Item_iE_Extensions__item__extensionValue),
        ])
    __CellIDBroadcastNR_Item_iE_Extensions__item_._ext = None
    _CellIDBroadcastNR_Item_iE_Extensions._cont = __CellIDBroadcastNR_Item_iE_Extensions__item_
    _CellIDBroadcastNR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellIDBroadcastNR_Item._cont = ASN1Dict([
        ('nR-CGI', _CellIDBroadcastNR_Item_nR_CGI),
        ('iE-Extensions', _CellIDBroadcastNR_Item_iE_Extensions),
        ])
    CellIDBroadcastNR_Item._ext = []
    
    #-----< CellIDBroadcastNR-Item-ExtIEs >-----#
    CellIDBroadcastNR_Item_ExtIEs = CLASS(name='CellIDBroadcastNR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CellIDBroadcastNR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellIDCancelledEUTRA >-----#
    CellIDCancelledEUTRA = SEQ_OF(name='CellIDCancelledEUTRA', mode=MODE_TYPE)
    _CellIDCancelledEUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CellIDCancelledEUTRA-Item')))
    CellIDCancelledEUTRA._cont = _CellIDCancelledEUTRA__item_
    CellIDCancelledEUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CellIDCancelledEUTRA-Item >-----#
    CellIDCancelledEUTRA_Item = SEQ(name='CellIDCancelledEUTRA-Item', mode=MODE_TYPE)
    _CellIDCancelledEUTRA_Item_eUTRA_CGI = SEQ(name='eUTRA-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _CellIDCancelledEUTRA_Item_numberOfBroadcasts = INT(name='numberOfBroadcasts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NumberOfBroadcasts')))
    _CellIDCancelledEUTRA_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellIDCancelledEUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CellIDCancelledEUTRA_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellIDCancelledEUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellIDCancelledEUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIDCancelledEUTRA_Item_iE_Extensions__item__id._const_tab = ____CellIDCancelledEUTRA_Item_iE_Extensions__item__id_tab
    ___CellIDCancelledEUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___CellIDCancelledEUTRA_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellIDCancelledEUTRA_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellIDCancelledEUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellIDCancelledEUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIDCancelledEUTRA_Item_iE_Extensions__item__criticality._const_tab = ____CellIDCancelledEUTRA_Item_iE_Extensions__item__criticality_tab
    ___CellIDCancelledEUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellIDCancelledEUTRA_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____CellIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___CellIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellIDCancelledEUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellIDCancelledEUTRA_Item_iE_Extensions__item__id),
        ('criticality', ___CellIDCancelledEUTRA_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CellIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __CellIDCancelledEUTRA_Item_iE_Extensions__item_._ext = None
    _CellIDCancelledEUTRA_Item_iE_Extensions._cont = __CellIDCancelledEUTRA_Item_iE_Extensions__item_
    _CellIDCancelledEUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellIDCancelledEUTRA_Item._cont = ASN1Dict([
        ('eUTRA-CGI', _CellIDCancelledEUTRA_Item_eUTRA_CGI),
        ('numberOfBroadcasts', _CellIDCancelledEUTRA_Item_numberOfBroadcasts),
        ('iE-Extensions', _CellIDCancelledEUTRA_Item_iE_Extensions),
        ])
    CellIDCancelledEUTRA_Item._ext = []
    
    #-----< CellIDCancelledEUTRA-Item-ExtIEs >-----#
    CellIDCancelledEUTRA_Item_ExtIEs = CLASS(name='CellIDCancelledEUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CellIDCancelledEUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellIDCancelledNR >-----#
    CellIDCancelledNR = SEQ_OF(name='CellIDCancelledNR', mode=MODE_TYPE)
    _CellIDCancelledNR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CellIDCancelledNR-Item')))
    CellIDCancelledNR._cont = _CellIDCancelledNR__item_
    CellIDCancelledNR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CellIDCancelledNR-Item >-----#
    CellIDCancelledNR_Item = SEQ(name='CellIDCancelledNR-Item', mode=MODE_TYPE)
    _CellIDCancelledNR_Item_nR_CGI = SEQ(name='nR-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    _CellIDCancelledNR_Item_numberOfBroadcasts = INT(name='numberOfBroadcasts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NumberOfBroadcasts')))
    _CellIDCancelledNR_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellIDCancelledNR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CellIDCancelledNR_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellIDCancelledNR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellIDCancelledNR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIDCancelledNR_Item_iE_Extensions__item__id._const_tab = ____CellIDCancelledNR_Item_iE_Extensions__item__id_tab
    ___CellIDCancelledNR_Item_iE_Extensions__item__id._const_tab_at = None
    ___CellIDCancelledNR_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellIDCancelledNR_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellIDCancelledNR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellIDCancelledNR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIDCancelledNR_Item_iE_Extensions__item__criticality._const_tab = ____CellIDCancelledNR_Item_iE_Extensions__item__criticality_tab
    ___CellIDCancelledNR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellIDCancelledNR_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellIDCancelledNR_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellIDCancelledNR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellIDCancelledNR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIDCancelledNR_Item_iE_Extensions__item__extensionValue._const_tab = ____CellIDCancelledNR_Item_iE_Extensions__item__extensionValue_tab
    ___CellIDCancelledNR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellIDCancelledNR_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellIDCancelledNR_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellIDCancelledNR_Item_iE_Extensions__item__id),
        ('criticality', ___CellIDCancelledNR_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CellIDCancelledNR_Item_iE_Extensions__item__extensionValue),
        ])
    __CellIDCancelledNR_Item_iE_Extensions__item_._ext = None
    _CellIDCancelledNR_Item_iE_Extensions._cont = __CellIDCancelledNR_Item_iE_Extensions__item_
    _CellIDCancelledNR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellIDCancelledNR_Item._cont = ASN1Dict([
        ('nR-CGI', _CellIDCancelledNR_Item_nR_CGI),
        ('numberOfBroadcasts', _CellIDCancelledNR_Item_numberOfBroadcasts),
        ('iE-Extensions', _CellIDCancelledNR_Item_iE_Extensions),
        ])
    CellIDCancelledNR_Item._ext = []
    
    #-----< CellIDCancelledNR-Item-ExtIEs >-----#
    CellIDCancelledNR_Item_ExtIEs = CLASS(name='CellIDCancelledNR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CellIDCancelledNR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellIDListForRestart >-----#
    CellIDListForRestart = CHOICE(name='CellIDListForRestart', mode=MODE_TYPE)
    _CellIDListForRestart_eUTRA_CGIListforRestart = SEQ_OF(name='eUTRA-CGIListforRestart', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGIList')))
    _CellIDListForRestart_nR_CGIListforRestart = SEQ_OF(name='nR-CGIListforRestart', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NR-CGIList')))
    _CellIDListForRestart_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __CellIDListForRestart_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___CellIDListForRestart_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___CellIDListForRestart_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CellIDListForRestart_choice_Extensions_id._const_tab = ___CellIDListForRestart_choice_Extensions_id_tab
    __CellIDListForRestart_choice_Extensions_id._const_tab_at = None
    __CellIDListForRestart_choice_Extensions_id._const_tab_id = 'id'
    __CellIDListForRestart_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___CellIDListForRestart_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___CellIDListForRestart_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CellIDListForRestart_choice_Extensions_criticality._const_tab = ___CellIDListForRestart_choice_Extensions_criticality_tab
    __CellIDListForRestart_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __CellIDListForRestart_choice_Extensions_criticality._const_tab_id = 'criticality'
    __CellIDListForRestart_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___CellIDListForRestart_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___CellIDListForRestart_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CellIDListForRestart_choice_Extensions_value._const_tab = ___CellIDListForRestart_choice_Extensions_value_tab
    __CellIDListForRestart_choice_Extensions_value._const_tab_at = ('..', 'id')
    __CellIDListForRestart_choice_Extensions_value._const_tab_id = 'Value'
    _CellIDListForRestart_choice_Extensions._cont = ASN1Dict([
        ('id', __CellIDListForRestart_choice_Extensions_id),
        ('criticality', __CellIDListForRestart_choice_Extensions_criticality),
        ('value', __CellIDListForRestart_choice_Extensions_value),
        ])
    _CellIDListForRestart_choice_Extensions._ext = None
    CellIDListForRestart._cont = ASN1Dict([
        ('eUTRA-CGIListforRestart', _CellIDListForRestart_eUTRA_CGIListforRestart),
        ('nR-CGIListforRestart', _CellIDListForRestart_nR_CGIListforRestart),
        ('choice-Extensions', _CellIDListForRestart_choice_Extensions),
        ])
    CellIDListForRestart._ext = None
    
    #-----< CellIDListForRestart-ExtIEs >-----#
    CellIDListForRestart_ExtIEs = CLASS(name='CellIDListForRestart-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    CellIDListForRestart_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellSize >-----#
    CellSize = ENUM(name='CellSize', mode=MODE_TYPE)
    CellSize._cont = ASN1Dict([('verysmall', 0), ('small', 1), ('medium', 2), ('large', 3)])
    CellSize._ext = []
    
    #-----< CellType >-----#
    CellType = SEQ(name='CellType', mode=MODE_TYPE)
    _CellType_cellSize = ENUM(name='cellSize', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellSize')))
    _CellType_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellType_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CellType_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellType_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellType_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellType_iE_Extensions__item__id._const_tab = ____CellType_iE_Extensions__item__id_tab
    ___CellType_iE_Extensions__item__id._const_tab_at = None
    ___CellType_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellType_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellType_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellType_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellType_iE_Extensions__item__criticality._const_tab = ____CellType_iE_Extensions__item__criticality_tab
    ___CellType_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellType_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellType_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellType_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellType_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellType_iE_Extensions__item__extensionValue._const_tab = ____CellType_iE_Extensions__item__extensionValue_tab
    ___CellType_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellType_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellType_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellType_iE_Extensions__item__id),
        ('criticality', ___CellType_iE_Extensions__item__criticality),
        ('extensionValue', ___CellType_iE_Extensions__item__extensionValue),
        ])
    __CellType_iE_Extensions__item_._ext = None
    _CellType_iE_Extensions._cont = __CellType_iE_Extensions__item_
    _CellType_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellType._cont = ASN1Dict([
        ('cellSize', _CellType_cellSize),
        ('iE-Extensions', _CellType_iE_Extensions),
        ])
    CellType._ext = []
    
    #-----< CellType-ExtIEs >-----#
    CellType_ExtIEs = CLASS(name='CellType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CellType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CEmodeBSupport-Indicator >-----#
    CEmodeBSupport_Indicator = ENUM(name='CEmodeBSupport-Indicator', mode=MODE_TYPE)
    CEmodeBSupport_Indicator._cont = ASN1Dict([('supported', 0)])
    CEmodeBSupport_Indicator._ext = []
    
    #-----< CEmodeBrestricted >-----#
    CEmodeBrestricted = ENUM(name='CEmodeBrestricted', mode=MODE_TYPE)
    CEmodeBrestricted._cont = ASN1Dict([('restricted', 0), ('not-restricted', 1)])
    CEmodeBrestricted._ext = []
    
    #-----< CNAssistedRANTuning >-----#
    CNAssistedRANTuning = SEQ(name='CNAssistedRANTuning', mode=MODE_TYPE)
    _CNAssistedRANTuning_expectedUEBehaviour = SEQ(name='expectedUEBehaviour', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEBehaviour')), opt=True)
    _CNAssistedRANTuning_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CNAssistedRANTuning_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CNAssistedRANTuning_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____CNAssistedRANTuning_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CNAssistedRANTuning_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNAssistedRANTuning_iE_Extensions__item__id._const_tab = ____CNAssistedRANTuning_iE_Extensions__item__id_tab
    ___CNAssistedRANTuning_iE_Extensions__item__id._const_tab_at = None
    ___CNAssistedRANTuning_iE_Extensions__item__id._const_tab_id = 'id'
    ___CNAssistedRANTuning_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CNAssistedRANTuning_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CNAssistedRANTuning_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNAssistedRANTuning_iE_Extensions__item__criticality._const_tab = ____CNAssistedRANTuning_iE_Extensions__item__criticality_tab
    ___CNAssistedRANTuning_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CNAssistedRANTuning_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CNAssistedRANTuning_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CNAssistedRANTuning_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CNAssistedRANTuning_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNAssistedRANTuning_iE_Extensions__item__extensionValue._const_tab = ____CNAssistedRANTuning_iE_Extensions__item__extensionValue_tab
    ___CNAssistedRANTuning_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CNAssistedRANTuning_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CNAssistedRANTuning_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CNAssistedRANTuning_iE_Extensions__item__id),
        ('criticality', ___CNAssistedRANTuning_iE_Extensions__item__criticality),
        ('extensionValue', ___CNAssistedRANTuning_iE_Extensions__item__extensionValue),
        ])
    __CNAssistedRANTuning_iE_Extensions__item_._ext = None
    _CNAssistedRANTuning_iE_Extensions._cont = __CNAssistedRANTuning_iE_Extensions__item_
    _CNAssistedRANTuning_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CNAssistedRANTuning._cont = ASN1Dict([
        ('expectedUEBehaviour', _CNAssistedRANTuning_expectedUEBehaviour),
        ('iE-Extensions', _CNAssistedRANTuning_iE_Extensions),
        ])
    CNAssistedRANTuning._ext = []
    
    #-----< CNAssistedRANTuning-ExtIEs >-----#
    CNAssistedRANTuning_ExtIEs = CLASS(name='CNAssistedRANTuning-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CNAssistedRANTuning_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CNsubgroupID >-----#
    CNsubgroupID = INT(name='CNsubgroupID', mode=MODE_TYPE)
    CNsubgroupID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=[], er=[])
    
    #-----< CNTypeRestrictionsForEquivalent >-----#
    CNTypeRestrictionsForEquivalent = SEQ_OF(name='CNTypeRestrictionsForEquivalent', mode=MODE_TYPE)
    _CNTypeRestrictionsForEquivalent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CNTypeRestrictionsForEquivalentItem')))
    CNTypeRestrictionsForEquivalent._cont = _CNTypeRestrictionsForEquivalent__item_
    CNTypeRestrictionsForEquivalent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< CNTypeRestrictionsForEquivalentItem >-----#
    CNTypeRestrictionsForEquivalentItem = SEQ(name='CNTypeRestrictionsForEquivalentItem', mode=MODE_TYPE)
    _CNTypeRestrictionsForEquivalentItem_plmnIdentity = OCT_STR(name='plmnIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _CNTypeRestrictionsForEquivalentItem_cn_Type = ENUM(name='cn-Type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CNTypeRestrictionsForEquivalentItem_cn_Type._cont = ASN1Dict([('epc-forbidden', 0), ('fiveGC-forbidden', 1)])
    _CNTypeRestrictionsForEquivalentItem_cn_Type._ext = []
    _CNTypeRestrictionsForEquivalentItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CNTypeRestrictionsForEquivalentItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__id._const_tab = ____CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__id_tab
    ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__id._const_tab_at = None
    ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__criticality._const_tab = ____CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__criticality_tab
    ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__extensionValue._const_tab = ____CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__extensionValue_tab
    ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CNTypeRestrictionsForEquivalentItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__id),
        ('criticality', ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__criticality),
        ('extensionValue', ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__extensionValue),
        ])
    __CNTypeRestrictionsForEquivalentItem_iE_Extensions__item_._ext = None
    _CNTypeRestrictionsForEquivalentItem_iE_Extensions._cont = __CNTypeRestrictionsForEquivalentItem_iE_Extensions__item_
    _CNTypeRestrictionsForEquivalentItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CNTypeRestrictionsForEquivalentItem._cont = ASN1Dict([
        ('plmnIdentity', _CNTypeRestrictionsForEquivalentItem_plmnIdentity),
        ('cn-Type', _CNTypeRestrictionsForEquivalentItem_cn_Type),
        ('iE-Extensions', _CNTypeRestrictionsForEquivalentItem_iE_Extensions),
        ])
    CNTypeRestrictionsForEquivalentItem._ext = []
    
    #-----< CNTypeRestrictionsForEquivalentItem-ExtIEs >-----#
    CNTypeRestrictionsForEquivalentItem_ExtIEs = CLASS(name='CNTypeRestrictionsForEquivalentItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CNTypeRestrictionsForEquivalentItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CNTypeRestrictionsForServing >-----#
    CNTypeRestrictionsForServing = ENUM(name='CNTypeRestrictionsForServing', mode=MODE_TYPE)
    CNTypeRestrictionsForServing._cont = ASN1Dict([('epc-forbidden', 0)])
    CNTypeRestrictionsForServing._ext = []
    
    #-----< CommonNetworkInstance >-----#
    CommonNetworkInstance = OCT_STR(name='CommonNetworkInstance', mode=MODE_TYPE)
    
    #-----< CompletedCellsInEAI-EUTRA >-----#
    CompletedCellsInEAI_EUTRA = SEQ_OF(name='CompletedCellsInEAI-EUTRA', mode=MODE_TYPE)
    _CompletedCellsInEAI_EUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CompletedCellsInEAI-EUTRA-Item')))
    CompletedCellsInEAI_EUTRA._cont = _CompletedCellsInEAI_EUTRA__item_
    CompletedCellsInEAI_EUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CompletedCellsInEAI-EUTRA-Item >-----#
    CompletedCellsInEAI_EUTRA_Item = SEQ(name='CompletedCellsInEAI-EUTRA-Item', mode=MODE_TYPE)
    _CompletedCellsInEAI_EUTRA_Item_eUTRA_CGI = SEQ(name='eUTRA-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _CompletedCellsInEAI_EUTRA_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__id._const_tab = ____CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__id_tab
    ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality._const_tab = ____CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality_tab
    ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__id),
        ('criticality', ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item_._ext = None
    _CompletedCellsInEAI_EUTRA_Item_iE_Extensions._cont = __CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item_
    _CompletedCellsInEAI_EUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CompletedCellsInEAI_EUTRA_Item._cont = ASN1Dict([
        ('eUTRA-CGI', _CompletedCellsInEAI_EUTRA_Item_eUTRA_CGI),
        ('iE-Extensions', _CompletedCellsInEAI_EUTRA_Item_iE_Extensions),
        ])
    CompletedCellsInEAI_EUTRA_Item._ext = []
    
    #-----< CompletedCellsInEAI-EUTRA-Item-ExtIEs >-----#
    CompletedCellsInEAI_EUTRA_Item_ExtIEs = CLASS(name='CompletedCellsInEAI-EUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CompletedCellsInEAI_EUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CompletedCellsInEAI-NR >-----#
    CompletedCellsInEAI_NR = SEQ_OF(name='CompletedCellsInEAI-NR', mode=MODE_TYPE)
    _CompletedCellsInEAI_NR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CompletedCellsInEAI-NR-Item')))
    CompletedCellsInEAI_NR._cont = _CompletedCellsInEAI_NR__item_
    CompletedCellsInEAI_NR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CompletedCellsInEAI-NR-Item >-----#
    CompletedCellsInEAI_NR_Item = SEQ(name='CompletedCellsInEAI-NR-Item', mode=MODE_TYPE)
    _CompletedCellsInEAI_NR_Item_nR_CGI = SEQ(name='nR-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    _CompletedCellsInEAI_NR_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CompletedCellsInEAI_NR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____CompletedCellsInEAI_NR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompletedCellsInEAI_NR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__id._const_tab = ____CompletedCellsInEAI_NR_Item_iE_Extensions__item__id_tab
    ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__id._const_tab_at = None
    ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CompletedCellsInEAI_NR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompletedCellsInEAI_NR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__criticality._const_tab = ____CompletedCellsInEAI_NR_Item_iE_Extensions__item__criticality_tab
    ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CompletedCellsInEAI_NR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompletedCellsInEAI_NR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__extensionValue._const_tab = ____CompletedCellsInEAI_NR_Item_iE_Extensions__item__extensionValue_tab
    ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CompletedCellsInEAI_NR_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__id),
        ('criticality', ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__extensionValue),
        ])
    __CompletedCellsInEAI_NR_Item_iE_Extensions__item_._ext = None
    _CompletedCellsInEAI_NR_Item_iE_Extensions._cont = __CompletedCellsInEAI_NR_Item_iE_Extensions__item_
    _CompletedCellsInEAI_NR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CompletedCellsInEAI_NR_Item._cont = ASN1Dict([
        ('nR-CGI', _CompletedCellsInEAI_NR_Item_nR_CGI),
        ('iE-Extensions', _CompletedCellsInEAI_NR_Item_iE_Extensions),
        ])
    CompletedCellsInEAI_NR_Item._ext = []
    
    #-----< CompletedCellsInEAI-NR-Item-ExtIEs >-----#
    CompletedCellsInEAI_NR_Item_ExtIEs = CLASS(name='CompletedCellsInEAI-NR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CompletedCellsInEAI_NR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CompletedCellsInTAI-EUTRA >-----#
    CompletedCellsInTAI_EUTRA = SEQ_OF(name='CompletedCellsInTAI-EUTRA', mode=MODE_TYPE)
    _CompletedCellsInTAI_EUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CompletedCellsInTAI-EUTRA-Item')))
    CompletedCellsInTAI_EUTRA._cont = _CompletedCellsInTAI_EUTRA__item_
    CompletedCellsInTAI_EUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CompletedCellsInTAI-EUTRA-Item >-----#
    CompletedCellsInTAI_EUTRA_Item = SEQ(name='CompletedCellsInTAI-EUTRA-Item', mode=MODE_TYPE)
    _CompletedCellsInTAI_EUTRA_Item_eUTRA_CGI = SEQ(name='eUTRA-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _CompletedCellsInTAI_EUTRA_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__id._const_tab = ____CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__id_tab
    ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality._const_tab = ____CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality_tab
    ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__id),
        ('criticality', ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item_._ext = None
    _CompletedCellsInTAI_EUTRA_Item_iE_Extensions._cont = __CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item_
    _CompletedCellsInTAI_EUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CompletedCellsInTAI_EUTRA_Item._cont = ASN1Dict([
        ('eUTRA-CGI', _CompletedCellsInTAI_EUTRA_Item_eUTRA_CGI),
        ('iE-Extensions', _CompletedCellsInTAI_EUTRA_Item_iE_Extensions),
        ])
    CompletedCellsInTAI_EUTRA_Item._ext = []
    
    #-----< CompletedCellsInTAI-EUTRA-Item-ExtIEs >-----#
    CompletedCellsInTAI_EUTRA_Item_ExtIEs = CLASS(name='CompletedCellsInTAI-EUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CompletedCellsInTAI_EUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CompletedCellsInTAI-NR >-----#
    CompletedCellsInTAI_NR = SEQ_OF(name='CompletedCellsInTAI-NR', mode=MODE_TYPE)
    _CompletedCellsInTAI_NR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CompletedCellsInTAI-NR-Item')))
    CompletedCellsInTAI_NR._cont = _CompletedCellsInTAI_NR__item_
    CompletedCellsInTAI_NR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CompletedCellsInTAI-NR-Item >-----#
    CompletedCellsInTAI_NR_Item = SEQ(name='CompletedCellsInTAI-NR-Item', mode=MODE_TYPE)
    _CompletedCellsInTAI_NR_Item_nR_CGI = SEQ(name='nR-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    _CompletedCellsInTAI_NR_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CompletedCellsInTAI_NR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____CompletedCellsInTAI_NR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompletedCellsInTAI_NR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__id._const_tab = ____CompletedCellsInTAI_NR_Item_iE_Extensions__item__id_tab
    ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__id._const_tab_at = None
    ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CompletedCellsInTAI_NR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompletedCellsInTAI_NR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__criticality._const_tab = ____CompletedCellsInTAI_NR_Item_iE_Extensions__item__criticality_tab
    ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CompletedCellsInTAI_NR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompletedCellsInTAI_NR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__extensionValue._const_tab = ____CompletedCellsInTAI_NR_Item_iE_Extensions__item__extensionValue_tab
    ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CompletedCellsInTAI_NR_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__id),
        ('criticality', ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__extensionValue),
        ])
    __CompletedCellsInTAI_NR_Item_iE_Extensions__item_._ext = None
    _CompletedCellsInTAI_NR_Item_iE_Extensions._cont = __CompletedCellsInTAI_NR_Item_iE_Extensions__item_
    _CompletedCellsInTAI_NR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CompletedCellsInTAI_NR_Item._cont = ASN1Dict([
        ('nR-CGI', _CompletedCellsInTAI_NR_Item_nR_CGI),
        ('iE-Extensions', _CompletedCellsInTAI_NR_Item_iE_Extensions),
        ])
    CompletedCellsInTAI_NR_Item._ext = []
    
    #-----< CompletedCellsInTAI-NR-Item-ExtIEs >-----#
    CompletedCellsInTAI_NR_Item_ExtIEs = CLASS(name='CompletedCellsInTAI-NR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CompletedCellsInTAI_NR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ConcurrentWarningMessageInd >-----#
    ConcurrentWarningMessageInd = ENUM(name='ConcurrentWarningMessageInd', mode=MODE_TYPE)
    ConcurrentWarningMessageInd._cont = ASN1Dict([('true', 0)])
    ConcurrentWarningMessageInd._ext = []
    
    #-----< ConfidentialityProtectionIndication >-----#
    ConfidentialityProtectionIndication = ENUM(name='ConfidentialityProtectionIndication', mode=MODE_TYPE)
    ConfidentialityProtectionIndication._cont = ASN1Dict([('required', 0), ('preferred', 1), ('not-needed', 2)])
    ConfidentialityProtectionIndication._ext = []
    
    #-----< ConfidentialityProtectionResult >-----#
    ConfidentialityProtectionResult = ENUM(name='ConfidentialityProtectionResult', mode=MODE_TYPE)
    ConfidentialityProtectionResult._cont = ASN1Dict([('performed', 0), ('not-performed', 1)])
    ConfidentialityProtectionResult._ext = []
    
    #-----< ConfiguredTACIndication >-----#
    ConfiguredTACIndication = ENUM(name='ConfiguredTACIndication', mode=MODE_TYPE)
    ConfiguredTACIndication._cont = ASN1Dict([('true', 0)])
    ConfiguredTACIndication._ext = []
    
    #-----< CoreNetworkAssistanceInformationForInactive >-----#
    CoreNetworkAssistanceInformationForInactive = SEQ(name='CoreNetworkAssistanceInformationForInactive', mode=MODE_TYPE)
    _CoreNetworkAssistanceInformationForInactive_uEIdentityIndexValue = CHOICE(name='uEIdentityIndexValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UEIdentityIndexValue')))
    _CoreNetworkAssistanceInformationForInactive_uESpecificDRX = ENUM(name='uESpecificDRX', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PagingDRX')), opt=True)
    _CoreNetworkAssistanceInformationForInactive_periodicRegistrationUpdateTimer = BIT_STR(name='periodicRegistrationUpdateTimer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PeriodicRegistrationUpdateTimer')))
    _CoreNetworkAssistanceInformationForInactive_mICOModeIndication = ENUM(name='mICOModeIndication', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MICOModeIndication')), opt=True)
    _CoreNetworkAssistanceInformationForInactive_tAIListForInactive = SEQ_OF(name='tAIListForInactive', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAIListForInactive')))
    _CoreNetworkAssistanceInformationForInactive_expectedUEBehaviour = SEQ(name='expectedUEBehaviour', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEBehaviour')), opt=True)
    _CoreNetworkAssistanceInformationForInactive_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CoreNetworkAssistanceInformationForInactive_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-PagingeDRXInformation')))
    _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedUEIdentityIndexValue')))
    _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityForPaging')))
    _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MicoAllPLMN')))
    _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NR-PagingeDRXInformation')))
    _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingCauseIndicationForVoiceService')))
    _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PEIPSassistanceInformation')))
    ____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 223), ('criticality', 'ignore'), ('Extension', _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'ignore'), ('Extension', _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 118), ('criticality', 'ignore'), ('Extension', _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 282), ('criticality', 'ignore'), ('Extension', _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 332), ('criticality', 'ignore'), ('Extension', _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 343), ('criticality', 'ignore'), ('Extension', _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 344), ('criticality', 'ignore'), ('Extension', _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id._const_tab = ____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab
    ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id._const_tab_at = None
    ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id._const_tab_id = 'id'
    ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__criticality._const_tab = ____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab
    ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__extensionValue._const_tab = ____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab
    ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CoreNetworkAssistanceInformationForInactive_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id),
        ('criticality', ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__criticality),
        ('extensionValue', ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__extensionValue),
        ])
    __CoreNetworkAssistanceInformationForInactive_iE_Extensions__item_._ext = None
    _CoreNetworkAssistanceInformationForInactive_iE_Extensions._cont = __CoreNetworkAssistanceInformationForInactive_iE_Extensions__item_
    _CoreNetworkAssistanceInformationForInactive_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CoreNetworkAssistanceInformationForInactive._cont = ASN1Dict([
        ('uEIdentityIndexValue', _CoreNetworkAssistanceInformationForInactive_uEIdentityIndexValue),
        ('uESpecificDRX', _CoreNetworkAssistanceInformationForInactive_uESpecificDRX),
        ('periodicRegistrationUpdateTimer', _CoreNetworkAssistanceInformationForInactive_periodicRegistrationUpdateTimer),
        ('mICOModeIndication', _CoreNetworkAssistanceInformationForInactive_mICOModeIndication),
        ('tAIListForInactive', _CoreNetworkAssistanceInformationForInactive_tAIListForInactive),
        ('expectedUEBehaviour', _CoreNetworkAssistanceInformationForInactive_expectedUEBehaviour),
        ('iE-Extensions', _CoreNetworkAssistanceInformationForInactive_iE_Extensions),
        ])
    CoreNetworkAssistanceInformationForInactive._ext = []
    
    #-----< CoreNetworkAssistanceInformationForInactive-ExtIEs >-----#
    CoreNetworkAssistanceInformationForInactive_ExtIEs = CLASS(name='CoreNetworkAssistanceInformationForInactive-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-PagingeDRXInformation')))
    _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedUEIdentityIndexValue')))
    _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityForPaging')))
    _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MicoAllPLMN')))
    _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NR-PagingeDRXInformation')))
    _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingCauseIndicationForVoiceService')))
    _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PEIPSassistanceInformation')))
    CoreNetworkAssistanceInformationForInactive_ExtIEs._val = ASN1Set(rv=[dict([('id', 223), ('criticality', 'ignore'), ('Extension', _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'ignore'), ('Extension', _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 118), ('criticality', 'ignore'), ('Extension', _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 282), ('criticality', 'ignore'), ('Extension', _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 332), ('criticality', 'ignore'), ('Extension', _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 343), ('criticality', 'ignore'), ('Extension', _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 344), ('criticality', 'ignore'), ('Extension', _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< COUNTValueForPDCP-SN12 >-----#
    COUNTValueForPDCP_SN12 = SEQ(name='COUNTValueForPDCP-SN12', mode=MODE_TYPE)
    _COUNTValueForPDCP_SN12_pDCP_SN12 = INT(name='pDCP-SN12', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _COUNTValueForPDCP_SN12_pDCP_SN12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _COUNTValueForPDCP_SN12_hFN_PDCP_SN12 = INT(name='hFN-PDCP-SN12', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _COUNTValueForPDCP_SN12_hFN_PDCP_SN12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=None, er=[])
    _COUNTValueForPDCP_SN12_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __COUNTValueForPDCP_SN12_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___COUNTValueForPDCP_SN12_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____COUNTValueForPDCP_SN12_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____COUNTValueForPDCP_SN12_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTValueForPDCP_SN12_iE_Extensions__item__id._const_tab = ____COUNTValueForPDCP_SN12_iE_Extensions__item__id_tab
    ___COUNTValueForPDCP_SN12_iE_Extensions__item__id._const_tab_at = None
    ___COUNTValueForPDCP_SN12_iE_Extensions__item__id._const_tab_id = 'id'
    ___COUNTValueForPDCP_SN12_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____COUNTValueForPDCP_SN12_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____COUNTValueForPDCP_SN12_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTValueForPDCP_SN12_iE_Extensions__item__criticality._const_tab = ____COUNTValueForPDCP_SN12_iE_Extensions__item__criticality_tab
    ___COUNTValueForPDCP_SN12_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___COUNTValueForPDCP_SN12_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___COUNTValueForPDCP_SN12_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____COUNTValueForPDCP_SN12_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____COUNTValueForPDCP_SN12_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTValueForPDCP_SN12_iE_Extensions__item__extensionValue._const_tab = ____COUNTValueForPDCP_SN12_iE_Extensions__item__extensionValue_tab
    ___COUNTValueForPDCP_SN12_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___COUNTValueForPDCP_SN12_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __COUNTValueForPDCP_SN12_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___COUNTValueForPDCP_SN12_iE_Extensions__item__id),
        ('criticality', ___COUNTValueForPDCP_SN12_iE_Extensions__item__criticality),
        ('extensionValue', ___COUNTValueForPDCP_SN12_iE_Extensions__item__extensionValue),
        ])
    __COUNTValueForPDCP_SN12_iE_Extensions__item_._ext = None
    _COUNTValueForPDCP_SN12_iE_Extensions._cont = __COUNTValueForPDCP_SN12_iE_Extensions__item_
    _COUNTValueForPDCP_SN12_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    COUNTValueForPDCP_SN12._cont = ASN1Dict([
        ('pDCP-SN12', _COUNTValueForPDCP_SN12_pDCP_SN12),
        ('hFN-PDCP-SN12', _COUNTValueForPDCP_SN12_hFN_PDCP_SN12),
        ('iE-Extensions', _COUNTValueForPDCP_SN12_iE_Extensions),
        ])
    COUNTValueForPDCP_SN12._ext = []
    
    #-----< COUNTValueForPDCP-SN12-ExtIEs >-----#
    COUNTValueForPDCP_SN12_ExtIEs = CLASS(name='COUNTValueForPDCP-SN12-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    COUNTValueForPDCP_SN12_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< COUNTValueForPDCP-SN18 >-----#
    COUNTValueForPDCP_SN18 = SEQ(name='COUNTValueForPDCP-SN18', mode=MODE_TYPE)
    _COUNTValueForPDCP_SN18_pDCP_SN18 = INT(name='pDCP-SN18', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _COUNTValueForPDCP_SN18_pDCP_SN18._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=262143)], ev=None, er=[])
    _COUNTValueForPDCP_SN18_hFN_PDCP_SN18 = INT(name='hFN-PDCP-SN18', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _COUNTValueForPDCP_SN18_hFN_PDCP_SN18._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    _COUNTValueForPDCP_SN18_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __COUNTValueForPDCP_SN18_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___COUNTValueForPDCP_SN18_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____COUNTValueForPDCP_SN18_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____COUNTValueForPDCP_SN18_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTValueForPDCP_SN18_iE_Extensions__item__id._const_tab = ____COUNTValueForPDCP_SN18_iE_Extensions__item__id_tab
    ___COUNTValueForPDCP_SN18_iE_Extensions__item__id._const_tab_at = None
    ___COUNTValueForPDCP_SN18_iE_Extensions__item__id._const_tab_id = 'id'
    ___COUNTValueForPDCP_SN18_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____COUNTValueForPDCP_SN18_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____COUNTValueForPDCP_SN18_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTValueForPDCP_SN18_iE_Extensions__item__criticality._const_tab = ____COUNTValueForPDCP_SN18_iE_Extensions__item__criticality_tab
    ___COUNTValueForPDCP_SN18_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___COUNTValueForPDCP_SN18_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___COUNTValueForPDCP_SN18_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____COUNTValueForPDCP_SN18_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____COUNTValueForPDCP_SN18_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTValueForPDCP_SN18_iE_Extensions__item__extensionValue._const_tab = ____COUNTValueForPDCP_SN18_iE_Extensions__item__extensionValue_tab
    ___COUNTValueForPDCP_SN18_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___COUNTValueForPDCP_SN18_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __COUNTValueForPDCP_SN18_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___COUNTValueForPDCP_SN18_iE_Extensions__item__id),
        ('criticality', ___COUNTValueForPDCP_SN18_iE_Extensions__item__criticality),
        ('extensionValue', ___COUNTValueForPDCP_SN18_iE_Extensions__item__extensionValue),
        ])
    __COUNTValueForPDCP_SN18_iE_Extensions__item_._ext = None
    _COUNTValueForPDCP_SN18_iE_Extensions._cont = __COUNTValueForPDCP_SN18_iE_Extensions__item_
    _COUNTValueForPDCP_SN18_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    COUNTValueForPDCP_SN18._cont = ASN1Dict([
        ('pDCP-SN18', _COUNTValueForPDCP_SN18_pDCP_SN18),
        ('hFN-PDCP-SN18', _COUNTValueForPDCP_SN18_hFN_PDCP_SN18),
        ('iE-Extensions', _COUNTValueForPDCP_SN18_iE_Extensions),
        ])
    COUNTValueForPDCP_SN18._ext = []
    
    #-----< COUNTValueForPDCP-SN18-ExtIEs >-----#
    COUNTValueForPDCP_SN18_ExtIEs = CLASS(name='COUNTValueForPDCP-SN18-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    COUNTValueForPDCP_SN18_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CoverageEnhancementLevel >-----#
    CoverageEnhancementLevel = OCT_STR(name='CoverageEnhancementLevel', mode=MODE_TYPE)
    
    #-----< CPTransportLayerInformation >-----#
    CPTransportLayerInformation = CHOICE(name='CPTransportLayerInformation', mode=MODE_TYPE)
    _CPTransportLayerInformation_endpointIPAddress = BIT_STR(name='endpointIPAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _CPTransportLayerInformation_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __CPTransportLayerInformation_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___CPTransportLayerInformation_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ____CPTransportLayerInformation_choice_Extensions_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EndpointIPAddressAndPort')))
    ___CPTransportLayerInformation_choice_Extensions_id_tab._val = ASN1Set(rv=[dict([('id', 169), ('criticality', 'reject'), ('Value', ____CPTransportLayerInformation_choice_Extensions_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __CPTransportLayerInformation_choice_Extensions_id._const_tab = ___CPTransportLayerInformation_choice_Extensions_id_tab
    __CPTransportLayerInformation_choice_Extensions_id._const_tab_at = None
    __CPTransportLayerInformation_choice_Extensions_id._const_tab_id = 'id'
    __CPTransportLayerInformation_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    __CPTransportLayerInformation_choice_Extensions_criticality._const_tab = ___CPTransportLayerInformation_choice_Extensions_id_tab
    __CPTransportLayerInformation_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __CPTransportLayerInformation_choice_Extensions_criticality._const_tab_id = 'criticality'
    __CPTransportLayerInformation_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    __CPTransportLayerInformation_choice_Extensions_value._const_tab = ___CPTransportLayerInformation_choice_Extensions_id_tab
    __CPTransportLayerInformation_choice_Extensions_value._const_tab_at = ('..', 'id')
    __CPTransportLayerInformation_choice_Extensions_value._const_tab_id = 'Value'
    _CPTransportLayerInformation_choice_Extensions._cont = ASN1Dict([
        ('id', __CPTransportLayerInformation_choice_Extensions_id),
        ('criticality', __CPTransportLayerInformation_choice_Extensions_criticality),
        ('value', __CPTransportLayerInformation_choice_Extensions_value),
        ])
    _CPTransportLayerInformation_choice_Extensions._ext = None
    CPTransportLayerInformation._cont = ASN1Dict([
        ('endpointIPAddress', _CPTransportLayerInformation_endpointIPAddress),
        ('choice-Extensions', _CPTransportLayerInformation_choice_Extensions),
        ])
    CPTransportLayerInformation._ext = None
    
    #-----< CPTransportLayerInformation-ExtIEs >-----#
    CPTransportLayerInformation_ExtIEs = CLASS(name='CPTransportLayerInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _CPTransportLayerInformation_ExtIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EndpointIPAddressAndPort')))
    CPTransportLayerInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 169), ('criticality', 'reject'), ('Value', _CPTransportLayerInformation_ExtIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CriticalityDiagnostics >-----#
    CriticalityDiagnostics = SEQ(name='CriticalityDiagnostics', mode=MODE_TYPE)
    _CriticalityDiagnostics_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')), opt=True)
    _CriticalityDiagnostics_triggeringMessage = ENUM(name='triggeringMessage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-CommonDataTypes', 'TriggeringMessage')), opt=True)
    _CriticalityDiagnostics_procedureCriticality = ENUM(name='procedureCriticality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-CommonDataTypes', 'Criticality')), opt=True)
    _CriticalityDiagnostics_iEsCriticalityDiagnostics = SEQ_OF(name='iEsCriticalityDiagnostics', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics-IE-List')), opt=True)
    _CriticalityDiagnostics_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_id = 'id'
    ___CriticalityDiagnostics_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CriticalityDiagnostics_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CriticalityDiagnostics_iE_Extensions__item__id),
        ('criticality', ___CriticalityDiagnostics_iE_Extensions__item__criticality),
        ('extensionValue', ___CriticalityDiagnostics_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_iE_Extensions._cont = __CriticalityDiagnostics_iE_Extensions__item_
    _CriticalityDiagnostics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics._cont = ASN1Dict([
        ('procedureCode', _CriticalityDiagnostics_procedureCode),
        ('triggeringMessage', _CriticalityDiagnostics_triggeringMessage),
        ('procedureCriticality', _CriticalityDiagnostics_procedureCriticality),
        ('iEsCriticalityDiagnostics', _CriticalityDiagnostics_iEsCriticalityDiagnostics),
        ('iE-Extensions', _CriticalityDiagnostics_iE_Extensions),
        ])
    CriticalityDiagnostics._ext = []
    
    #-----< CriticalityDiagnostics-ExtIEs >-----#
    CriticalityDiagnostics_ExtIEs = CLASS(name='CriticalityDiagnostics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CriticalityDiagnostics-IE-List >-----#
    CriticalityDiagnostics_IE_List = SEQ_OF(name='CriticalityDiagnostics-IE-List', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics-IE-Item')))
    CriticalityDiagnostics_IE_List._cont = _CriticalityDiagnostics_IE_List__item_
    CriticalityDiagnostics_IE_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CriticalityDiagnostics-IE-Item >-----#
    CriticalityDiagnostics_IE_Item = SEQ(name='CriticalityDiagnostics-IE-Item', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_Item_iECriticality = ENUM(name='iECriticality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-CommonDataTypes', 'Criticality')))
    _CriticalityDiagnostics_IE_Item_iE_ID = INT(name='iE-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    _CriticalityDiagnostics_IE_Item_typeOfError = ENUM(name='typeOfError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TypeOfError')))
    _CriticalityDiagnostics_IE_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_IE_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CriticalityDiagnostics_IE_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id),
        ('criticality', ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_IE_Item_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_IE_Item_iE_Extensions._cont = __CriticalityDiagnostics_IE_Item_iE_Extensions__item_
    _CriticalityDiagnostics_IE_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics_IE_Item._cont = ASN1Dict([
        ('iECriticality', _CriticalityDiagnostics_IE_Item_iECriticality),
        ('iE-ID', _CriticalityDiagnostics_IE_Item_iE_ID),
        ('typeOfError', _CriticalityDiagnostics_IE_Item_typeOfError),
        ('iE-Extensions', _CriticalityDiagnostics_IE_Item_iE_Extensions),
        ])
    CriticalityDiagnostics_IE_Item._ext = []
    
    #-----< CriticalityDiagnostics-IE-Item-ExtIEs >-----#
    CriticalityDiagnostics_IE_Item_ExtIEs = CLASS(name='CriticalityDiagnostics-IE-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_IE_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellBasedMDT-NR >-----#
    CellBasedMDT_NR = SEQ(name='CellBasedMDT-NR', mode=MODE_TYPE)
    _CellBasedMDT_NR_cellIdListforMDT = SEQ_OF(name='cellIdListforMDT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellIdListforMDT-NR')))
    _CellBasedMDT_NR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellBasedMDT_NR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CellBasedMDT_NR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellBasedMDT_NR_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellBasedMDT_NR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedMDT_NR_iE_Extensions__item__id._const_tab = ____CellBasedMDT_NR_iE_Extensions__item__id_tab
    ___CellBasedMDT_NR_iE_Extensions__item__id._const_tab_at = None
    ___CellBasedMDT_NR_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellBasedMDT_NR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellBasedMDT_NR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellBasedMDT_NR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedMDT_NR_iE_Extensions__item__criticality._const_tab = ____CellBasedMDT_NR_iE_Extensions__item__criticality_tab
    ___CellBasedMDT_NR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellBasedMDT_NR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellBasedMDT_NR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellBasedMDT_NR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellBasedMDT_NR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedMDT_NR_iE_Extensions__item__extensionValue._const_tab = ____CellBasedMDT_NR_iE_Extensions__item__extensionValue_tab
    ___CellBasedMDT_NR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellBasedMDT_NR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellBasedMDT_NR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellBasedMDT_NR_iE_Extensions__item__id),
        ('criticality', ___CellBasedMDT_NR_iE_Extensions__item__criticality),
        ('extensionValue', ___CellBasedMDT_NR_iE_Extensions__item__extensionValue),
        ])
    __CellBasedMDT_NR_iE_Extensions__item_._ext = None
    _CellBasedMDT_NR_iE_Extensions._cont = __CellBasedMDT_NR_iE_Extensions__item_
    _CellBasedMDT_NR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellBasedMDT_NR._cont = ASN1Dict([
        ('cellIdListforMDT', _CellBasedMDT_NR_cellIdListforMDT),
        ('iE-Extensions', _CellBasedMDT_NR_iE_Extensions),
        ])
    CellBasedMDT_NR._ext = []
    
    #-----< CellBasedMDT-NR-ExtIEs >-----#
    CellBasedMDT_NR_ExtIEs = CLASS(name='CellBasedMDT-NR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CellBasedMDT_NR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellIdListforMDT-NR >-----#
    CellIdListforMDT_NR = SEQ_OF(name='CellIdListforMDT-NR', mode=MODE_TYPE)
    _CellIdListforMDT_NR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    CellIdListforMDT_NR._cont = _CellIdListforMDT_NR__item_
    CellIdListforMDT_NR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< CellBasedMDT-EUTRA >-----#
    CellBasedMDT_EUTRA = SEQ(name='CellBasedMDT-EUTRA', mode=MODE_TYPE)
    _CellBasedMDT_EUTRA_cellIdListforMDT = SEQ_OF(name='cellIdListforMDT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellIdListforMDT-EUTRA')))
    _CellBasedMDT_EUTRA_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellBasedMDT_EUTRA_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CellBasedMDT_EUTRA_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellBasedMDT_EUTRA_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellBasedMDT_EUTRA_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedMDT_EUTRA_iE_Extensions__item__id._const_tab = ____CellBasedMDT_EUTRA_iE_Extensions__item__id_tab
    ___CellBasedMDT_EUTRA_iE_Extensions__item__id._const_tab_at = None
    ___CellBasedMDT_EUTRA_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellBasedMDT_EUTRA_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellBasedMDT_EUTRA_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellBasedMDT_EUTRA_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedMDT_EUTRA_iE_Extensions__item__criticality._const_tab = ____CellBasedMDT_EUTRA_iE_Extensions__item__criticality_tab
    ___CellBasedMDT_EUTRA_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellBasedMDT_EUTRA_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellBasedMDT_EUTRA_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellBasedMDT_EUTRA_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellBasedMDT_EUTRA_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedMDT_EUTRA_iE_Extensions__item__extensionValue._const_tab = ____CellBasedMDT_EUTRA_iE_Extensions__item__extensionValue_tab
    ___CellBasedMDT_EUTRA_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellBasedMDT_EUTRA_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellBasedMDT_EUTRA_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellBasedMDT_EUTRA_iE_Extensions__item__id),
        ('criticality', ___CellBasedMDT_EUTRA_iE_Extensions__item__criticality),
        ('extensionValue', ___CellBasedMDT_EUTRA_iE_Extensions__item__extensionValue),
        ])
    __CellBasedMDT_EUTRA_iE_Extensions__item_._ext = None
    _CellBasedMDT_EUTRA_iE_Extensions._cont = __CellBasedMDT_EUTRA_iE_Extensions__item_
    _CellBasedMDT_EUTRA_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellBasedMDT_EUTRA._cont = ASN1Dict([
        ('cellIdListforMDT', _CellBasedMDT_EUTRA_cellIdListforMDT),
        ('iE-Extensions', _CellBasedMDT_EUTRA_iE_Extensions),
        ])
    CellBasedMDT_EUTRA._ext = []
    
    #-----< CellBasedMDT-EUTRA-ExtIEs >-----#
    CellBasedMDT_EUTRA_ExtIEs = CLASS(name='CellBasedMDT-EUTRA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CellBasedMDT_EUTRA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellBasedQMC >-----#
    CellBasedQMC = SEQ(name='CellBasedQMC', mode=MODE_TYPE)
    _CellBasedQMC_cellIdListforQMC = SEQ_OF(name='cellIdListforQMC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellIdListforQMC')))
    _CellBasedQMC_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellBasedQMC_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CellBasedQMC_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellBasedQMC_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellBasedQMC_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedQMC_iE_Extensions__item__id._const_tab = ____CellBasedQMC_iE_Extensions__item__id_tab
    ___CellBasedQMC_iE_Extensions__item__id._const_tab_at = None
    ___CellBasedQMC_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellBasedQMC_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellBasedQMC_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellBasedQMC_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedQMC_iE_Extensions__item__criticality._const_tab = ____CellBasedQMC_iE_Extensions__item__criticality_tab
    ___CellBasedQMC_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellBasedQMC_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellBasedQMC_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellBasedQMC_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CellBasedQMC_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedQMC_iE_Extensions__item__extensionValue._const_tab = ____CellBasedQMC_iE_Extensions__item__extensionValue_tab
    ___CellBasedQMC_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellBasedQMC_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellBasedQMC_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellBasedQMC_iE_Extensions__item__id),
        ('criticality', ___CellBasedQMC_iE_Extensions__item__criticality),
        ('extensionValue', ___CellBasedQMC_iE_Extensions__item__extensionValue),
        ])
    __CellBasedQMC_iE_Extensions__item_._ext = None
    _CellBasedQMC_iE_Extensions._cont = __CellBasedQMC_iE_Extensions__item_
    _CellBasedQMC_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellBasedQMC._cont = ASN1Dict([
        ('cellIdListforQMC', _CellBasedQMC_cellIdListforQMC),
        ('iE-Extensions', _CellBasedQMC_iE_Extensions),
        ])
    CellBasedQMC._ext = []
    
    #-----< CellBasedQMC-ExtIEs >-----#
    CellBasedQMC_ExtIEs = CLASS(name='CellBasedQMC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CellBasedQMC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellIdListforQMC >-----#
    CellIdListforQMC = SEQ_OF(name='CellIdListforQMC', mode=MODE_TYPE)
    _CellIdListforQMC__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    CellIdListforQMC._cont = _CellIdListforQMC__item_
    CellIdListforQMC._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< CellIdListforMDT-EUTRA >-----#
    CellIdListforMDT_EUTRA = SEQ_OF(name='CellIdListforMDT-EUTRA', mode=MODE_TYPE)
    _CellIdListforMDT_EUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    CellIdListforMDT_EUTRA._cont = _CellIdListforMDT_EUTRA__item_
    CellIdListforMDT_EUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DataCodingScheme >-----#
    DataCodingScheme = BIT_STR(name='DataCodingScheme', mode=MODE_TYPE)
    DataCodingScheme._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< DataForwardingAccepted >-----#
    DataForwardingAccepted = ENUM(name='DataForwardingAccepted', mode=MODE_TYPE)
    DataForwardingAccepted._cont = ASN1Dict([('data-forwarding-accepted', 0)])
    DataForwardingAccepted._ext = []
    
    #-----< DataForwardingNotPossible >-----#
    DataForwardingNotPossible = ENUM(name='DataForwardingNotPossible', mode=MODE_TYPE)
    DataForwardingNotPossible._cont = ASN1Dict([('data-forwarding-not-possible', 0)])
    DataForwardingNotPossible._ext = []
    
    #-----< DataForwardingResponseDRBList >-----#
    DataForwardingResponseDRBList = SEQ_OF(name='DataForwardingResponseDRBList', mode=MODE_TYPE)
    _DataForwardingResponseDRBList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DataForwardingResponseDRBItem')))
    DataForwardingResponseDRBList._cont = _DataForwardingResponseDRBList__item_
    DataForwardingResponseDRBList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DataForwardingResponseDRBItem >-----#
    DataForwardingResponseDRBItem = SEQ(name='DataForwardingResponseDRBItem', mode=MODE_TYPE)
    _DataForwardingResponseDRBItem_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRB-ID')))
    _DataForwardingResponseDRBItem_dLForwardingUP_TNLInformation = CHOICE(name='dLForwardingUP-TNLInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')), opt=True)
    _DataForwardingResponseDRBItem_uLForwardingUP_TNLInformation = CHOICE(name='uLForwardingUP-TNLInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')), opt=True)
    _DataForwardingResponseDRBItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DataForwardingResponseDRBItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___DataForwardingResponseDRBItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____DataForwardingResponseDRBItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DataForwardingResponseDRBItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataForwardingResponseDRBItem_iE_Extensions__item__id._const_tab = ____DataForwardingResponseDRBItem_iE_Extensions__item__id_tab
    ___DataForwardingResponseDRBItem_iE_Extensions__item__id._const_tab_at = None
    ___DataForwardingResponseDRBItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___DataForwardingResponseDRBItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DataForwardingResponseDRBItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DataForwardingResponseDRBItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataForwardingResponseDRBItem_iE_Extensions__item__criticality._const_tab = ____DataForwardingResponseDRBItem_iE_Extensions__item__criticality_tab
    ___DataForwardingResponseDRBItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DataForwardingResponseDRBItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DataForwardingResponseDRBItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DataForwardingResponseDRBItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DataForwardingResponseDRBItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataForwardingResponseDRBItem_iE_Extensions__item__extensionValue._const_tab = ____DataForwardingResponseDRBItem_iE_Extensions__item__extensionValue_tab
    ___DataForwardingResponseDRBItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DataForwardingResponseDRBItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DataForwardingResponseDRBItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DataForwardingResponseDRBItem_iE_Extensions__item__id),
        ('criticality', ___DataForwardingResponseDRBItem_iE_Extensions__item__criticality),
        ('extensionValue', ___DataForwardingResponseDRBItem_iE_Extensions__item__extensionValue),
        ])
    __DataForwardingResponseDRBItem_iE_Extensions__item_._ext = None
    _DataForwardingResponseDRBItem_iE_Extensions._cont = __DataForwardingResponseDRBItem_iE_Extensions__item_
    _DataForwardingResponseDRBItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DataForwardingResponseDRBItem._cont = ASN1Dict([
        ('dRB-ID', _DataForwardingResponseDRBItem_dRB_ID),
        ('dLForwardingUP-TNLInformation', _DataForwardingResponseDRBItem_dLForwardingUP_TNLInformation),
        ('uLForwardingUP-TNLInformation', _DataForwardingResponseDRBItem_uLForwardingUP_TNLInformation),
        ('iE-Extensions', _DataForwardingResponseDRBItem_iE_Extensions),
        ])
    DataForwardingResponseDRBItem._ext = []
    
    #-----< DataForwardingResponseDRBItem-ExtIEs >-----#
    DataForwardingResponseDRBItem_ExtIEs = CLASS(name='DataForwardingResponseDRBItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    DataForwardingResponseDRBItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DAPSRequestInfo >-----#
    DAPSRequestInfo = SEQ(name='DAPSRequestInfo', mode=MODE_TYPE)
    _DAPSRequestInfo_dAPSIndicator = ENUM(name='dAPSIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DAPSRequestInfo_dAPSIndicator._cont = ASN1Dict([('daps-ho-required', 0)])
    _DAPSRequestInfo_dAPSIndicator._ext = []
    _DAPSRequestInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DAPSRequestInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___DAPSRequestInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____DAPSRequestInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DAPSRequestInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSRequestInfo_iE_Extensions__item__id._const_tab = ____DAPSRequestInfo_iE_Extensions__item__id_tab
    ___DAPSRequestInfo_iE_Extensions__item__id._const_tab_at = None
    ___DAPSRequestInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___DAPSRequestInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DAPSRequestInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DAPSRequestInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSRequestInfo_iE_Extensions__item__criticality._const_tab = ____DAPSRequestInfo_iE_Extensions__item__criticality_tab
    ___DAPSRequestInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DAPSRequestInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DAPSRequestInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DAPSRequestInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DAPSRequestInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSRequestInfo_iE_Extensions__item__extensionValue._const_tab = ____DAPSRequestInfo_iE_Extensions__item__extensionValue_tab
    ___DAPSRequestInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DAPSRequestInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DAPSRequestInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DAPSRequestInfo_iE_Extensions__item__id),
        ('criticality', ___DAPSRequestInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___DAPSRequestInfo_iE_Extensions__item__extensionValue),
        ])
    __DAPSRequestInfo_iE_Extensions__item_._ext = None
    _DAPSRequestInfo_iE_Extensions._cont = __DAPSRequestInfo_iE_Extensions__item_
    _DAPSRequestInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DAPSRequestInfo._cont = ASN1Dict([
        ('dAPSIndicator', _DAPSRequestInfo_dAPSIndicator),
        ('iE-Extensions', _DAPSRequestInfo_iE_Extensions),
        ])
    DAPSRequestInfo._ext = []
    
    #-----< DAPSRequestInfo-ExtIEs >-----#
    DAPSRequestInfo_ExtIEs = CLASS(name='DAPSRequestInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    DAPSRequestInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DAPSResponseInfoList >-----#
    DAPSResponseInfoList = SEQ_OF(name='DAPSResponseInfoList', mode=MODE_TYPE)
    _DAPSResponseInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DAPSResponseInfoItem')))
    DAPSResponseInfoList._cont = _DAPSResponseInfoList__item_
    DAPSResponseInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DAPSResponseInfoItem >-----#
    DAPSResponseInfoItem = SEQ(name='DAPSResponseInfoItem', mode=MODE_TYPE)
    _DAPSResponseInfoItem_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRB-ID')))
    _DAPSResponseInfoItem_dAPSResponseInfo = SEQ(name='dAPSResponseInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DAPSResponseInfo')))
    _DAPSResponseInfoItem_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DAPSResponseInfoItem_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___DAPSResponseInfoItem_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____DAPSResponseInfoItem_iE_Extension__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfoItem_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfoItem_iE_Extension__item__id._const_tab = ____DAPSResponseInfoItem_iE_Extension__item__id_tab
    ___DAPSResponseInfoItem_iE_Extension__item__id._const_tab_at = None
    ___DAPSResponseInfoItem_iE_Extension__item__id._const_tab_id = 'id'
    ___DAPSResponseInfoItem_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DAPSResponseInfoItem_iE_Extension__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfoItem_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfoItem_iE_Extension__item__criticality._const_tab = ____DAPSResponseInfoItem_iE_Extension__item__criticality_tab
    ___DAPSResponseInfoItem_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___DAPSResponseInfoItem_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___DAPSResponseInfoItem_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DAPSResponseInfoItem_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfoItem_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfoItem_iE_Extension__item__extensionValue._const_tab = ____DAPSResponseInfoItem_iE_Extension__item__extensionValue_tab
    ___DAPSResponseInfoItem_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___DAPSResponseInfoItem_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __DAPSResponseInfoItem_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___DAPSResponseInfoItem_iE_Extension__item__id),
        ('criticality', ___DAPSResponseInfoItem_iE_Extension__item__criticality),
        ('extensionValue', ___DAPSResponseInfoItem_iE_Extension__item__extensionValue),
        ])
    __DAPSResponseInfoItem_iE_Extension__item_._ext = None
    _DAPSResponseInfoItem_iE_Extension._cont = __DAPSResponseInfoItem_iE_Extension__item_
    _DAPSResponseInfoItem_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DAPSResponseInfoItem._cont = ASN1Dict([
        ('dRB-ID', _DAPSResponseInfoItem_dRB_ID),
        ('dAPSResponseInfo', _DAPSResponseInfoItem_dAPSResponseInfo),
        ('iE-Extension', _DAPSResponseInfoItem_iE_Extension),
        ])
    DAPSResponseInfoItem._ext = []
    
    #-----< DAPSResponseInfoItem-ExtIEs >-----#
    DAPSResponseInfoItem_ExtIEs = CLASS(name='DAPSResponseInfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    DAPSResponseInfoItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DAPSResponseInfo >-----#
    DAPSResponseInfo = SEQ(name='DAPSResponseInfo', mode=MODE_TYPE)
    _DAPSResponseInfo_dapsresponseindicator = ENUM(name='dapsresponseindicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DAPSResponseInfo_dapsresponseindicator._cont = ASN1Dict([('daps-ho-accepted', 0), ('daps-ho-not-accepted', 1)])
    _DAPSResponseInfo_dapsresponseindicator._ext = []
    _DAPSResponseInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DAPSResponseInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___DAPSResponseInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____DAPSResponseInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfo_iE_Extensions__item__id._const_tab = ____DAPSResponseInfo_iE_Extensions__item__id_tab
    ___DAPSResponseInfo_iE_Extensions__item__id._const_tab_at = None
    ___DAPSResponseInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___DAPSResponseInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DAPSResponseInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfo_iE_Extensions__item__criticality._const_tab = ____DAPSResponseInfo_iE_Extensions__item__criticality_tab
    ___DAPSResponseInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DAPSResponseInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DAPSResponseInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DAPSResponseInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfo_iE_Extensions__item__extensionValue._const_tab = ____DAPSResponseInfo_iE_Extensions__item__extensionValue_tab
    ___DAPSResponseInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DAPSResponseInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DAPSResponseInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DAPSResponseInfo_iE_Extensions__item__id),
        ('criticality', ___DAPSResponseInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___DAPSResponseInfo_iE_Extensions__item__extensionValue),
        ])
    __DAPSResponseInfo_iE_Extensions__item_._ext = None
    _DAPSResponseInfo_iE_Extensions._cont = __DAPSResponseInfo_iE_Extensions__item_
    _DAPSResponseInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DAPSResponseInfo._cont = ASN1Dict([
        ('dapsresponseindicator', _DAPSResponseInfo_dapsresponseindicator),
        ('iE-Extensions', _DAPSResponseInfo_iE_Extensions),
        ])
    DAPSResponseInfo._ext = []
    
    #-----< DAPSResponseInfo-ExtIEs >-----#
    DAPSResponseInfo_ExtIEs = CLASS(name='DAPSResponseInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    DAPSResponseInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DataForwardingResponseERABList >-----#
    DataForwardingResponseERABList = SEQ_OF(name='DataForwardingResponseERABList', mode=MODE_TYPE)
    _DataForwardingResponseERABList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DataForwardingResponseERABListItem')))
    DataForwardingResponseERABList._cont = _DataForwardingResponseERABList__item_
    DataForwardingResponseERABList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< DataForwardingResponseERABListItem >-----#
    DataForwardingResponseERABListItem = SEQ(name='DataForwardingResponseERABListItem', mode=MODE_TYPE)
    _DataForwardingResponseERABListItem_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'E-RAB-ID')))
    _DataForwardingResponseERABListItem_dLForwardingUP_TNLInformation = CHOICE(name='dLForwardingUP-TNLInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _DataForwardingResponseERABListItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DataForwardingResponseERABListItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___DataForwardingResponseERABListItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____DataForwardingResponseERABListItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DataForwardingResponseERABListItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataForwardingResponseERABListItem_iE_Extensions__item__id._const_tab = ____DataForwardingResponseERABListItem_iE_Extensions__item__id_tab
    ___DataForwardingResponseERABListItem_iE_Extensions__item__id._const_tab_at = None
    ___DataForwardingResponseERABListItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___DataForwardingResponseERABListItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DataForwardingResponseERABListItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DataForwardingResponseERABListItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataForwardingResponseERABListItem_iE_Extensions__item__criticality._const_tab = ____DataForwardingResponseERABListItem_iE_Extensions__item__criticality_tab
    ___DataForwardingResponseERABListItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DataForwardingResponseERABListItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DataForwardingResponseERABListItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DataForwardingResponseERABListItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DataForwardingResponseERABListItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataForwardingResponseERABListItem_iE_Extensions__item__extensionValue._const_tab = ____DataForwardingResponseERABListItem_iE_Extensions__item__extensionValue_tab
    ___DataForwardingResponseERABListItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DataForwardingResponseERABListItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DataForwardingResponseERABListItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DataForwardingResponseERABListItem_iE_Extensions__item__id),
        ('criticality', ___DataForwardingResponseERABListItem_iE_Extensions__item__criticality),
        ('extensionValue', ___DataForwardingResponseERABListItem_iE_Extensions__item__extensionValue),
        ])
    __DataForwardingResponseERABListItem_iE_Extensions__item_._ext = None
    _DataForwardingResponseERABListItem_iE_Extensions._cont = __DataForwardingResponseERABListItem_iE_Extensions__item_
    _DataForwardingResponseERABListItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DataForwardingResponseERABListItem._cont = ASN1Dict([
        ('e-RAB-ID', _DataForwardingResponseERABListItem_e_RAB_ID),
        ('dLForwardingUP-TNLInformation', _DataForwardingResponseERABListItem_dLForwardingUP_TNLInformation),
        ('iE-Extensions', _DataForwardingResponseERABListItem_iE_Extensions),
        ])
    DataForwardingResponseERABListItem._ext = []
    
    #-----< DataForwardingResponseERABListItem-ExtIEs >-----#
    DataForwardingResponseERABListItem_ExtIEs = CLASS(name='DataForwardingResponseERABListItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    DataForwardingResponseERABListItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DelayCritical >-----#
    DelayCritical = ENUM(name='DelayCritical', mode=MODE_TYPE)
    DelayCritical._cont = ASN1Dict([('delay-critical', 0), ('non-delay-critical', 1)])
    DelayCritical._ext = []
    
    #-----< DL-CP-SecurityInformation >-----#
    DL_CP_SecurityInformation = SEQ(name='DL-CP-SecurityInformation', mode=MODE_TYPE)
    _DL_CP_SecurityInformation_dl_NAS_MAC = BIT_STR(name='dl-NAS-MAC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DL-NAS-MAC')))
    _DL_CP_SecurityInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CP_SecurityInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___DL_CP_SecurityInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_CP_SecurityInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DL_CP_SecurityInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CP_SecurityInformation_iE_Extensions__item__id._const_tab = ____DL_CP_SecurityInformation_iE_Extensions__item__id_tab
    ___DL_CP_SecurityInformation_iE_Extensions__item__id._const_tab_at = None
    ___DL_CP_SecurityInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_CP_SecurityInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_CP_SecurityInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DL_CP_SecurityInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CP_SecurityInformation_iE_Extensions__item__criticality._const_tab = ____DL_CP_SecurityInformation_iE_Extensions__item__criticality_tab
    ___DL_CP_SecurityInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_CP_SecurityInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_CP_SecurityInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CP_SecurityInformation_iE_Extensions__item__extensionValue._const_tab = ____DL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab
    ___DL_CP_SecurityInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_CP_SecurityInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_CP_SecurityInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_CP_SecurityInformation_iE_Extensions__item__id),
        ('criticality', ___DL_CP_SecurityInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_CP_SecurityInformation_iE_Extensions__item__extensionValue),
        ])
    __DL_CP_SecurityInformation_iE_Extensions__item_._ext = None
    _DL_CP_SecurityInformation_iE_Extensions._cont = __DL_CP_SecurityInformation_iE_Extensions__item_
    _DL_CP_SecurityInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CP_SecurityInformation._cont = ASN1Dict([
        ('dl-NAS-MAC', _DL_CP_SecurityInformation_dl_NAS_MAC),
        ('iE-Extensions', _DL_CP_SecurityInformation_iE_Extensions),
        ])
    DL_CP_SecurityInformation._ext = []
    
    #-----< DL-CP-SecurityInformation-ExtIEs >-----#
    DL_CP_SecurityInformation_ExtIEs = CLASS(name='DL-CP-SecurityInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    DL_CP_SecurityInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-NAS-MAC >-----#
    DL_NAS_MAC = BIT_STR(name='DL-NAS-MAC', mode=MODE_TYPE)
    DL_NAS_MAC._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< DLForwarding >-----#
    DLForwarding = ENUM(name='DLForwarding', mode=MODE_TYPE)
    DLForwarding._cont = ASN1Dict([('dl-forwarding-proposed', 0)])
    DLForwarding._ext = []
    
    #-----< DL-NGU-TNLInformationReused >-----#
    DL_NGU_TNLInformationReused = ENUM(name='DL-NGU-TNLInformationReused', mode=MODE_TYPE)
    DL_NGU_TNLInformationReused._cont = ASN1Dict([('true', 0)])
    DL_NGU_TNLInformationReused._ext = []
    
    #-----< DirectForwardingPathAvailability >-----#
    DirectForwardingPathAvailability = ENUM(name='DirectForwardingPathAvailability', mode=MODE_TYPE)
    DirectForwardingPathAvailability._cont = ASN1Dict([('direct-path-available', 0)])
    DirectForwardingPathAvailability._ext = []
    
    #-----< DRB-ID >-----#
    DRB_ID = INT(name='DRB-ID', mode=MODE_TYPE)
    DRB_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=[], er=[])
    
    #-----< DRBsSubjectToStatusTransferList >-----#
    DRBsSubjectToStatusTransferList = SEQ_OF(name='DRBsSubjectToStatusTransferList', mode=MODE_TYPE)
    _DRBsSubjectToStatusTransferList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DRBsSubjectToStatusTransferItem')))
    DRBsSubjectToStatusTransferList._cont = _DRBsSubjectToStatusTransferList__item_
    DRBsSubjectToStatusTransferList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRBsSubjectToStatusTransferItem >-----#
    DRBsSubjectToStatusTransferItem = SEQ(name='DRBsSubjectToStatusTransferItem', mode=MODE_TYPE)
    _DRBsSubjectToStatusTransferItem_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRB-ID')))
    _DRBsSubjectToStatusTransferItem_dRBStatusUL = CHOICE(name='dRBStatusUL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRBStatusUL')))
    _DRBsSubjectToStatusTransferItem_dRBStatusDL = CHOICE(name='dRBStatusDL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRBStatusDL')))
    _DRBsSubjectToStatusTransferItem_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBsSubjectToStatusTransferItem_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___DRBsSubjectToStatusTransferItem_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____DRBsSubjectToStatusTransferItem_iE_Extension__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____DRBsSubjectToStatusTransferItem_iE_Extension__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AssociatedQosFlowList')))
    ____DRBsSubjectToStatusTransferItem_iE_Extension__item__id_tab._val = ASN1Set(rv=[dict([('id', 159), ('criticality', 'ignore'), ('Extension', _____DRBsSubjectToStatusTransferItem_iE_Extension__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DRBsSubjectToStatusTransferItem_iE_Extension__item__id._const_tab = ____DRBsSubjectToStatusTransferItem_iE_Extension__item__id_tab
    ___DRBsSubjectToStatusTransferItem_iE_Extension__item__id._const_tab_at = None
    ___DRBsSubjectToStatusTransferItem_iE_Extension__item__id._const_tab_id = 'id'
    ___DRBsSubjectToStatusTransferItem_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DRBsSubjectToStatusTransferItem_iE_Extension__item__criticality._const_tab = ____DRBsSubjectToStatusTransferItem_iE_Extension__item__id_tab
    ___DRBsSubjectToStatusTransferItem_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___DRBsSubjectToStatusTransferItem_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___DRBsSubjectToStatusTransferItem_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DRBsSubjectToStatusTransferItem_iE_Extension__item__extensionValue._const_tab = ____DRBsSubjectToStatusTransferItem_iE_Extension__item__id_tab
    ___DRBsSubjectToStatusTransferItem_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRBsSubjectToStatusTransferItem_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __DRBsSubjectToStatusTransferItem_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___DRBsSubjectToStatusTransferItem_iE_Extension__item__id),
        ('criticality', ___DRBsSubjectToStatusTransferItem_iE_Extension__item__criticality),
        ('extensionValue', ___DRBsSubjectToStatusTransferItem_iE_Extension__item__extensionValue),
        ])
    __DRBsSubjectToStatusTransferItem_iE_Extension__item_._ext = None
    _DRBsSubjectToStatusTransferItem_iE_Extension._cont = __DRBsSubjectToStatusTransferItem_iE_Extension__item_
    _DRBsSubjectToStatusTransferItem_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBsSubjectToStatusTransferItem._cont = ASN1Dict([
        ('dRB-ID', _DRBsSubjectToStatusTransferItem_dRB_ID),
        ('dRBStatusUL', _DRBsSubjectToStatusTransferItem_dRBStatusUL),
        ('dRBStatusDL', _DRBsSubjectToStatusTransferItem_dRBStatusDL),
        ('iE-Extension', _DRBsSubjectToStatusTransferItem_iE_Extension),
        ])
    DRBsSubjectToStatusTransferItem._ext = []
    
    #-----< DRBsSubjectToStatusTransferItem-ExtIEs >-----#
    DRBsSubjectToStatusTransferItem_ExtIEs = CLASS(name='DRBsSubjectToStatusTransferItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _DRBsSubjectToStatusTransferItem_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AssociatedQosFlowList')))
    DRBsSubjectToStatusTransferItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 159), ('criticality', 'ignore'), ('Extension', _DRBsSubjectToStatusTransferItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRBStatusDL >-----#
    DRBStatusDL = CHOICE(name='DRBStatusDL', mode=MODE_TYPE)
    _DRBStatusDL_dRBStatusDL12 = SEQ(name='dRBStatusDL12', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRBStatusDL12')))
    _DRBStatusDL_dRBStatusDL18 = SEQ(name='dRBStatusDL18', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRBStatusDL18')))
    _DRBStatusDL_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBStatusDL_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___DRBStatusDL_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___DRBStatusDL_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DRBStatusDL_choice_Extensions_id._const_tab = ___DRBStatusDL_choice_Extensions_id_tab
    __DRBStatusDL_choice_Extensions_id._const_tab_at = None
    __DRBStatusDL_choice_Extensions_id._const_tab_id = 'id'
    __DRBStatusDL_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___DRBStatusDL_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___DRBStatusDL_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DRBStatusDL_choice_Extensions_criticality._const_tab = ___DRBStatusDL_choice_Extensions_criticality_tab
    __DRBStatusDL_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __DRBStatusDL_choice_Extensions_criticality._const_tab_id = 'criticality'
    __DRBStatusDL_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___DRBStatusDL_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___DRBStatusDL_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DRBStatusDL_choice_Extensions_value._const_tab = ___DRBStatusDL_choice_Extensions_value_tab
    __DRBStatusDL_choice_Extensions_value._const_tab_at = ('..', 'id')
    __DRBStatusDL_choice_Extensions_value._const_tab_id = 'Value'
    _DRBStatusDL_choice_Extensions._cont = ASN1Dict([
        ('id', __DRBStatusDL_choice_Extensions_id),
        ('criticality', __DRBStatusDL_choice_Extensions_criticality),
        ('value', __DRBStatusDL_choice_Extensions_value),
        ])
    _DRBStatusDL_choice_Extensions._ext = None
    DRBStatusDL._cont = ASN1Dict([
        ('dRBStatusDL12', _DRBStatusDL_dRBStatusDL12),
        ('dRBStatusDL18', _DRBStatusDL_dRBStatusDL18),
        ('choice-Extensions', _DRBStatusDL_choice_Extensions),
        ])
    DRBStatusDL._ext = None
    
    #-----< DRBStatusDL-ExtIEs >-----#
    DRBStatusDL_ExtIEs = CLASS(name='DRBStatusDL-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    DRBStatusDL_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBStatusDL12 >-----#
    DRBStatusDL12 = SEQ(name='DRBStatusDL12', mode=MODE_TYPE)
    _DRBStatusDL12_dL_COUNTValue = SEQ(name='dL-COUNTValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'COUNTValueForPDCP-SN12')))
    _DRBStatusDL12_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBStatusDL12_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___DRBStatusDL12_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____DRBStatusDL12_iE_Extension__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBStatusDL12_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBStatusDL12_iE_Extension__item__id._const_tab = ____DRBStatusDL12_iE_Extension__item__id_tab
    ___DRBStatusDL12_iE_Extension__item__id._const_tab_at = None
    ___DRBStatusDL12_iE_Extension__item__id._const_tab_id = 'id'
    ___DRBStatusDL12_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRBStatusDL12_iE_Extension__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBStatusDL12_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBStatusDL12_iE_Extension__item__criticality._const_tab = ____DRBStatusDL12_iE_Extension__item__criticality_tab
    ___DRBStatusDL12_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___DRBStatusDL12_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___DRBStatusDL12_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRBStatusDL12_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBStatusDL12_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBStatusDL12_iE_Extension__item__extensionValue._const_tab = ____DRBStatusDL12_iE_Extension__item__extensionValue_tab
    ___DRBStatusDL12_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRBStatusDL12_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __DRBStatusDL12_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___DRBStatusDL12_iE_Extension__item__id),
        ('criticality', ___DRBStatusDL12_iE_Extension__item__criticality),
        ('extensionValue', ___DRBStatusDL12_iE_Extension__item__extensionValue),
        ])
    __DRBStatusDL12_iE_Extension__item_._ext = None
    _DRBStatusDL12_iE_Extension._cont = __DRBStatusDL12_iE_Extension__item_
    _DRBStatusDL12_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBStatusDL12._cont = ASN1Dict([
        ('dL-COUNTValue', _DRBStatusDL12_dL_COUNTValue),
        ('iE-Extension', _DRBStatusDL12_iE_Extension),
        ])
    DRBStatusDL12._ext = []
    
    #-----< DRBStatusDL12-ExtIEs >-----#
    DRBStatusDL12_ExtIEs = CLASS(name='DRBStatusDL12-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    DRBStatusDL12_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBStatusDL18 >-----#
    DRBStatusDL18 = SEQ(name='DRBStatusDL18', mode=MODE_TYPE)
    _DRBStatusDL18_dL_COUNTValue = SEQ(name='dL-COUNTValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'COUNTValueForPDCP-SN18')))
    _DRBStatusDL18_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBStatusDL18_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___DRBStatusDL18_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____DRBStatusDL18_iE_Extension__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBStatusDL18_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBStatusDL18_iE_Extension__item__id._const_tab = ____DRBStatusDL18_iE_Extension__item__id_tab
    ___DRBStatusDL18_iE_Extension__item__id._const_tab_at = None
    ___DRBStatusDL18_iE_Extension__item__id._const_tab_id = 'id'
    ___DRBStatusDL18_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRBStatusDL18_iE_Extension__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBStatusDL18_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBStatusDL18_iE_Extension__item__criticality._const_tab = ____DRBStatusDL18_iE_Extension__item__criticality_tab
    ___DRBStatusDL18_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___DRBStatusDL18_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___DRBStatusDL18_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRBStatusDL18_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBStatusDL18_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBStatusDL18_iE_Extension__item__extensionValue._const_tab = ____DRBStatusDL18_iE_Extension__item__extensionValue_tab
    ___DRBStatusDL18_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRBStatusDL18_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __DRBStatusDL18_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___DRBStatusDL18_iE_Extension__item__id),
        ('criticality', ___DRBStatusDL18_iE_Extension__item__criticality),
        ('extensionValue', ___DRBStatusDL18_iE_Extension__item__extensionValue),
        ])
    __DRBStatusDL18_iE_Extension__item_._ext = None
    _DRBStatusDL18_iE_Extension._cont = __DRBStatusDL18_iE_Extension__item_
    _DRBStatusDL18_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBStatusDL18._cont = ASN1Dict([
        ('dL-COUNTValue', _DRBStatusDL18_dL_COUNTValue),
        ('iE-Extension', _DRBStatusDL18_iE_Extension),
        ])
    DRBStatusDL18._ext = []
    
    #-----< DRBStatusDL18-ExtIEs >-----#
    DRBStatusDL18_ExtIEs = CLASS(name='DRBStatusDL18-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    DRBStatusDL18_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBStatusUL >-----#
    DRBStatusUL = CHOICE(name='DRBStatusUL', mode=MODE_TYPE)
    _DRBStatusUL_dRBStatusUL12 = SEQ(name='dRBStatusUL12', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRBStatusUL12')))
    _DRBStatusUL_dRBStatusUL18 = SEQ(name='dRBStatusUL18', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRBStatusUL18')))
    _DRBStatusUL_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __DRBStatusUL_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___DRBStatusUL_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___DRBStatusUL_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DRBStatusUL_choice_Extensions_id._const_tab = ___DRBStatusUL_choice_Extensions_id_tab
    __DRBStatusUL_choice_Extensions_id._const_tab_at = None
    __DRBStatusUL_choice_Extensions_id._const_tab_id = 'id'
    __DRBStatusUL_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___DRBStatusUL_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___DRBStatusUL_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DRBStatusUL_choice_Extensions_criticality._const_tab = ___DRBStatusUL_choice_Extensions_criticality_tab
    __DRBStatusUL_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __DRBStatusUL_choice_Extensions_criticality._const_tab_id = 'criticality'
    __DRBStatusUL_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___DRBStatusUL_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___DRBStatusUL_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DRBStatusUL_choice_Extensions_value._const_tab = ___DRBStatusUL_choice_Extensions_value_tab
    __DRBStatusUL_choice_Extensions_value._const_tab_at = ('..', 'id')
    __DRBStatusUL_choice_Extensions_value._const_tab_id = 'Value'
    _DRBStatusUL_choice_Extensions._cont = ASN1Dict([
        ('id', __DRBStatusUL_choice_Extensions_id),
        ('criticality', __DRBStatusUL_choice_Extensions_criticality),
        ('value', __DRBStatusUL_choice_Extensions_value),
        ])
    _DRBStatusUL_choice_Extensions._ext = None
    DRBStatusUL._cont = ASN1Dict([
        ('dRBStatusUL12', _DRBStatusUL_dRBStatusUL12),
        ('dRBStatusUL18', _DRBStatusUL_dRBStatusUL18),
        ('choice-Extensions', _DRBStatusUL_choice_Extensions),
        ])
    DRBStatusUL._ext = None
    
    #-----< DRBStatusUL-ExtIEs >-----#
    DRBStatusUL_ExtIEs = CLASS(name='DRBStatusUL-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    DRBStatusUL_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBStatusUL12 >-----#
    DRBStatusUL12 = SEQ(name='DRBStatusUL12', mode=MODE_TYPE)
    _DRBStatusUL12_uL_COUNTValue = SEQ(name='uL-COUNTValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'COUNTValueForPDCP-SN12')))
    _DRBStatusUL12_receiveStatusOfUL_PDCP_SDUs = BIT_STR(name='receiveStatusOfUL-PDCP-SDUs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DRBStatusUL12_receiveStatusOfUL_PDCP_SDUs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    _DRBStatusUL12_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBStatusUL12_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___DRBStatusUL12_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____DRBStatusUL12_iE_Extension__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBStatusUL12_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBStatusUL12_iE_Extension__item__id._const_tab = ____DRBStatusUL12_iE_Extension__item__id_tab
    ___DRBStatusUL12_iE_Extension__item__id._const_tab_at = None
    ___DRBStatusUL12_iE_Extension__item__id._const_tab_id = 'id'
    ___DRBStatusUL12_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRBStatusUL12_iE_Extension__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBStatusUL12_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBStatusUL12_iE_Extension__item__criticality._const_tab = ____DRBStatusUL12_iE_Extension__item__criticality_tab
    ___DRBStatusUL12_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___DRBStatusUL12_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___DRBStatusUL12_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRBStatusUL12_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBStatusUL12_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBStatusUL12_iE_Extension__item__extensionValue._const_tab = ____DRBStatusUL12_iE_Extension__item__extensionValue_tab
    ___DRBStatusUL12_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRBStatusUL12_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __DRBStatusUL12_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___DRBStatusUL12_iE_Extension__item__id),
        ('criticality', ___DRBStatusUL12_iE_Extension__item__criticality),
        ('extensionValue', ___DRBStatusUL12_iE_Extension__item__extensionValue),
        ])
    __DRBStatusUL12_iE_Extension__item_._ext = None
    _DRBStatusUL12_iE_Extension._cont = __DRBStatusUL12_iE_Extension__item_
    _DRBStatusUL12_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBStatusUL12._cont = ASN1Dict([
        ('uL-COUNTValue', _DRBStatusUL12_uL_COUNTValue),
        ('receiveStatusOfUL-PDCP-SDUs', _DRBStatusUL12_receiveStatusOfUL_PDCP_SDUs),
        ('iE-Extension', _DRBStatusUL12_iE_Extension),
        ])
    DRBStatusUL12._ext = []
    
    #-----< DRBStatusUL12-ExtIEs >-----#
    DRBStatusUL12_ExtIEs = CLASS(name='DRBStatusUL12-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    DRBStatusUL12_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBStatusUL18 >-----#
    DRBStatusUL18 = SEQ(name='DRBStatusUL18', mode=MODE_TYPE)
    _DRBStatusUL18_uL_COUNTValue = SEQ(name='uL-COUNTValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'COUNTValueForPDCP-SN18')))
    _DRBStatusUL18_receiveStatusOfUL_PDCP_SDUs = BIT_STR(name='receiveStatusOfUL-PDCP-SDUs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DRBStatusUL18_receiveStatusOfUL_PDCP_SDUs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=131072)], ev=None, er=[])
    _DRBStatusUL18_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBStatusUL18_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___DRBStatusUL18_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____DRBStatusUL18_iE_Extension__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBStatusUL18_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBStatusUL18_iE_Extension__item__id._const_tab = ____DRBStatusUL18_iE_Extension__item__id_tab
    ___DRBStatusUL18_iE_Extension__item__id._const_tab_at = None
    ___DRBStatusUL18_iE_Extension__item__id._const_tab_id = 'id'
    ___DRBStatusUL18_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRBStatusUL18_iE_Extension__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBStatusUL18_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBStatusUL18_iE_Extension__item__criticality._const_tab = ____DRBStatusUL18_iE_Extension__item__criticality_tab
    ___DRBStatusUL18_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___DRBStatusUL18_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___DRBStatusUL18_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRBStatusUL18_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBStatusUL18_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBStatusUL18_iE_Extension__item__extensionValue._const_tab = ____DRBStatusUL18_iE_Extension__item__extensionValue_tab
    ___DRBStatusUL18_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRBStatusUL18_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __DRBStatusUL18_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___DRBStatusUL18_iE_Extension__item__id),
        ('criticality', ___DRBStatusUL18_iE_Extension__item__criticality),
        ('extensionValue', ___DRBStatusUL18_iE_Extension__item__extensionValue),
        ])
    __DRBStatusUL18_iE_Extension__item_._ext = None
    _DRBStatusUL18_iE_Extension._cont = __DRBStatusUL18_iE_Extension__item_
    _DRBStatusUL18_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBStatusUL18._cont = ASN1Dict([
        ('uL-COUNTValue', _DRBStatusUL18_uL_COUNTValue),
        ('receiveStatusOfUL-PDCP-SDUs', _DRBStatusUL18_receiveStatusOfUL_PDCP_SDUs),
        ('iE-Extension', _DRBStatusUL18_iE_Extension),
        ])
    DRBStatusUL18._ext = []
    
    #-----< DRBStatusUL18-ExtIEs >-----#
    DRBStatusUL18_ExtIEs = CLASS(name='DRBStatusUL18-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    DRBStatusUL18_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBsToQosFlowsMappingList >-----#
    DRBsToQosFlowsMappingList = SEQ_OF(name='DRBsToQosFlowsMappingList', mode=MODE_TYPE)
    _DRBsToQosFlowsMappingList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DRBsToQosFlowsMappingItem')))
    DRBsToQosFlowsMappingList._cont = _DRBsToQosFlowsMappingList__item_
    DRBsToQosFlowsMappingList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRBsToQosFlowsMappingItem >-----#
    DRBsToQosFlowsMappingItem = SEQ(name='DRBsToQosFlowsMappingItem', mode=MODE_TYPE)
    _DRBsToQosFlowsMappingItem_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRB-ID')))
    _DRBsToQosFlowsMappingItem_associatedQosFlowList = SEQ_OF(name='associatedQosFlowList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AssociatedQosFlowList')))
    _DRBsToQosFlowsMappingItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBsToQosFlowsMappingItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___DRBsToQosFlowsMappingItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____DRBsToQosFlowsMappingItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____DRBsToQosFlowsMappingItem_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DAPSRequestInfo')))
    ____DRBsToQosFlowsMappingItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 266), ('criticality', 'ignore'), ('Extension', _____DRBsToQosFlowsMappingItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DRBsToQosFlowsMappingItem_iE_Extensions__item__id._const_tab = ____DRBsToQosFlowsMappingItem_iE_Extensions__item__id_tab
    ___DRBsToQosFlowsMappingItem_iE_Extensions__item__id._const_tab_at = None
    ___DRBsToQosFlowsMappingItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___DRBsToQosFlowsMappingItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DRBsToQosFlowsMappingItem_iE_Extensions__item__criticality._const_tab = ____DRBsToQosFlowsMappingItem_iE_Extensions__item__id_tab
    ___DRBsToQosFlowsMappingItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DRBsToQosFlowsMappingItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DRBsToQosFlowsMappingItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DRBsToQosFlowsMappingItem_iE_Extensions__item__extensionValue._const_tab = ____DRBsToQosFlowsMappingItem_iE_Extensions__item__id_tab
    ___DRBsToQosFlowsMappingItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRBsToQosFlowsMappingItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DRBsToQosFlowsMappingItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DRBsToQosFlowsMappingItem_iE_Extensions__item__id),
        ('criticality', ___DRBsToQosFlowsMappingItem_iE_Extensions__item__criticality),
        ('extensionValue', ___DRBsToQosFlowsMappingItem_iE_Extensions__item__extensionValue),
        ])
    __DRBsToQosFlowsMappingItem_iE_Extensions__item_._ext = None
    _DRBsToQosFlowsMappingItem_iE_Extensions._cont = __DRBsToQosFlowsMappingItem_iE_Extensions__item_
    _DRBsToQosFlowsMappingItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBsToQosFlowsMappingItem._cont = ASN1Dict([
        ('dRB-ID', _DRBsToQosFlowsMappingItem_dRB_ID),
        ('associatedQosFlowList', _DRBsToQosFlowsMappingItem_associatedQosFlowList),
        ('iE-Extensions', _DRBsToQosFlowsMappingItem_iE_Extensions),
        ])
    DRBsToQosFlowsMappingItem._ext = []
    
    #-----< DRBsToQosFlowsMappingItem-ExtIEs >-----#
    DRBsToQosFlowsMappingItem_ExtIEs = CLASS(name='DRBsToQosFlowsMappingItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _DRBsToQosFlowsMappingItem_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DAPSRequestInfo')))
    DRBsToQosFlowsMappingItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 266), ('criticality', 'ignore'), ('Extension', _DRBsToQosFlowsMappingItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Dynamic5QIDescriptor >-----#
    Dynamic5QIDescriptor = SEQ(name='Dynamic5QIDescriptor', mode=MODE_TYPE)
    _Dynamic5QIDescriptor_priorityLevelQos = INT(name='priorityLevelQos', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PriorityLevelQos')))
    _Dynamic5QIDescriptor_packetDelayBudget = INT(name='packetDelayBudget', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PacketDelayBudget')))
    _Dynamic5QIDescriptor_packetErrorRate = SEQ(name='packetErrorRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PacketErrorRate')))
    _Dynamic5QIDescriptor_fiveQI = INT(name='fiveQI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FiveQI')), opt=True)
    _Dynamic5QIDescriptor_delayCritical = ENUM(name='delayCritical', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DelayCritical')), opt=True)
    _Dynamic5QIDescriptor_averagingWindow = INT(name='averagingWindow', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AveragingWindow')), opt=True)
    _Dynamic5QIDescriptor_maximumDataBurstVolume = INT(name='maximumDataBurstVolume', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MaximumDataBurstVolume')), opt=True)
    _Dynamic5QIDescriptor_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Dynamic5QIDescriptor_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___Dynamic5QIDescriptor_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 189), ('criticality', 'ignore'), ('Extension', _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 187), ('criticality', 'ignore'), ('Extension', _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 188), ('criticality', 'ignore'), ('Extension', _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Dynamic5QIDescriptor_iE_Extensions__item__id._const_tab = ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___Dynamic5QIDescriptor_iE_Extensions__item__id._const_tab_at = None
    ___Dynamic5QIDescriptor_iE_Extensions__item__id._const_tab_id = 'id'
    ___Dynamic5QIDescriptor_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Dynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab = ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___Dynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Dynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab = ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Dynamic5QIDescriptor_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Dynamic5QIDescriptor_iE_Extensions__item__id),
        ('criticality', ___Dynamic5QIDescriptor_iE_Extensions__item__criticality),
        ('extensionValue', ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue),
        ])
    __Dynamic5QIDescriptor_iE_Extensions__item_._ext = None
    _Dynamic5QIDescriptor_iE_Extensions._cont = __Dynamic5QIDescriptor_iE_Extensions__item_
    _Dynamic5QIDescriptor_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Dynamic5QIDescriptor._cont = ASN1Dict([
        ('priorityLevelQos', _Dynamic5QIDescriptor_priorityLevelQos),
        ('packetDelayBudget', _Dynamic5QIDescriptor_packetDelayBudget),
        ('packetErrorRate', _Dynamic5QIDescriptor_packetErrorRate),
        ('fiveQI', _Dynamic5QIDescriptor_fiveQI),
        ('delayCritical', _Dynamic5QIDescriptor_delayCritical),
        ('averagingWindow', _Dynamic5QIDescriptor_averagingWindow),
        ('maximumDataBurstVolume', _Dynamic5QIDescriptor_maximumDataBurstVolume),
        ('iE-Extensions', _Dynamic5QIDescriptor_iE_Extensions),
        ])
    Dynamic5QIDescriptor._ext = []
    
    #-----< Dynamic5QIDescriptor-ExtIEs >-----#
    Dynamic5QIDescriptor_ExtIEs = CLASS(name='Dynamic5QIDescriptor-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _Dynamic5QIDescriptor_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    _Dynamic5QIDescriptor_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    _Dynamic5QIDescriptor_ExtIEs_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    Dynamic5QIDescriptor_ExtIEs._val = ASN1Set(rv=[dict([('id', 189), ('criticality', 'ignore'), ('Extension', _Dynamic5QIDescriptor_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 187), ('criticality', 'ignore'), ('Extension', _Dynamic5QIDescriptor_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 188), ('criticality', 'ignore'), ('Extension', _Dynamic5QIDescriptor_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< EarlyMeasurement >-----#
    EarlyMeasurement = ENUM(name='EarlyMeasurement', mode=MODE_TYPE)
    EarlyMeasurement._cont = ASN1Dict([('true', 0)])
    EarlyMeasurement._ext = []
    
    #-----< EarlyStatusTransfer-TransparentContainer >-----#
    EarlyStatusTransfer_TransparentContainer = SEQ(name='EarlyStatusTransfer-TransparentContainer', mode=MODE_TYPE)
    _EarlyStatusTransfer_TransparentContainer_procedureStage = CHOICE(name='procedureStage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ProcedureStageChoice')))
    _EarlyStatusTransfer_TransparentContainer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EarlyStatusTransfer_TransparentContainer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id._const_tab = ____EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id_tab
    ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id._const_tab_at = None
    ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id._const_tab_id = 'id'
    ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality._const_tab = ____EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab
    ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue._const_tab = ____EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab
    ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EarlyStatusTransfer_TransparentContainer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id),
        ('criticality', ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality),
        ('extensionValue', ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue),
        ])
    __EarlyStatusTransfer_TransparentContainer_iE_Extensions__item_._ext = None
    _EarlyStatusTransfer_TransparentContainer_iE_Extensions._cont = __EarlyStatusTransfer_TransparentContainer_iE_Extensions__item_
    _EarlyStatusTransfer_TransparentContainer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EarlyStatusTransfer_TransparentContainer._cont = ASN1Dict([
        ('procedureStage', _EarlyStatusTransfer_TransparentContainer_procedureStage),
        ('iE-Extensions', _EarlyStatusTransfer_TransparentContainer_iE_Extensions),
        ])
    EarlyStatusTransfer_TransparentContainer._ext = []
    
    #-----< EarlyStatusTransfer-TransparentContainer-ExtIEs >-----#
    EarlyStatusTransfer_TransparentContainer_ExtIEs = CLASS(name='EarlyStatusTransfer-TransparentContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EarlyStatusTransfer_TransparentContainer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ProcedureStageChoice >-----#
    ProcedureStageChoice = CHOICE(name='ProcedureStageChoice', mode=MODE_TYPE)
    _ProcedureStageChoice_first_dl_count = SEQ(name='first-dl-count', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FirstDLCount')))
    _ProcedureStageChoice_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __ProcedureStageChoice_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___ProcedureStageChoice_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ProcedureStageChoice_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ProcedureStageChoice_choice_Extensions_id._const_tab = ___ProcedureStageChoice_choice_Extensions_id_tab
    __ProcedureStageChoice_choice_Extensions_id._const_tab_at = None
    __ProcedureStageChoice_choice_Extensions_id._const_tab_id = 'id'
    __ProcedureStageChoice_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___ProcedureStageChoice_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ProcedureStageChoice_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ProcedureStageChoice_choice_Extensions_criticality._const_tab = ___ProcedureStageChoice_choice_Extensions_criticality_tab
    __ProcedureStageChoice_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __ProcedureStageChoice_choice_Extensions_criticality._const_tab_id = 'criticality'
    __ProcedureStageChoice_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___ProcedureStageChoice_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ProcedureStageChoice_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ProcedureStageChoice_choice_Extensions_value._const_tab = ___ProcedureStageChoice_choice_Extensions_value_tab
    __ProcedureStageChoice_choice_Extensions_value._const_tab_at = ('..', 'id')
    __ProcedureStageChoice_choice_Extensions_value._const_tab_id = 'Value'
    _ProcedureStageChoice_choice_Extensions._cont = ASN1Dict([
        ('id', __ProcedureStageChoice_choice_Extensions_id),
        ('criticality', __ProcedureStageChoice_choice_Extensions_criticality),
        ('value', __ProcedureStageChoice_choice_Extensions_value),
        ])
    _ProcedureStageChoice_choice_Extensions._ext = None
    ProcedureStageChoice._cont = ASN1Dict([
        ('first-dl-count', _ProcedureStageChoice_first_dl_count),
        ('choice-Extensions', _ProcedureStageChoice_choice_Extensions),
        ])
    ProcedureStageChoice._ext = None
    
    #-----< ProcedureStageChoice-ExtIEs >-----#
    ProcedureStageChoice_ExtIEs = CLASS(name='ProcedureStageChoice-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ProcedureStageChoice_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FirstDLCount >-----#
    FirstDLCount = SEQ(name='FirstDLCount', mode=MODE_TYPE)
    _FirstDLCount_dRBsSubjectToEarlyStatusTransfer = SEQ_OF(name='dRBsSubjectToEarlyStatusTransfer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRBsSubjectToEarlyStatusTransfer-List')))
    _FirstDLCount_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FirstDLCount_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___FirstDLCount_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____FirstDLCount_iE_Extension__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FirstDLCount_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FirstDLCount_iE_Extension__item__id._const_tab = ____FirstDLCount_iE_Extension__item__id_tab
    ___FirstDLCount_iE_Extension__item__id._const_tab_at = None
    ___FirstDLCount_iE_Extension__item__id._const_tab_id = 'id'
    ___FirstDLCount_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FirstDLCount_iE_Extension__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FirstDLCount_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FirstDLCount_iE_Extension__item__criticality._const_tab = ____FirstDLCount_iE_Extension__item__criticality_tab
    ___FirstDLCount_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___FirstDLCount_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___FirstDLCount_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FirstDLCount_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FirstDLCount_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FirstDLCount_iE_Extension__item__extensionValue._const_tab = ____FirstDLCount_iE_Extension__item__extensionValue_tab
    ___FirstDLCount_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___FirstDLCount_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __FirstDLCount_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___FirstDLCount_iE_Extension__item__id),
        ('criticality', ___FirstDLCount_iE_Extension__item__criticality),
        ('extensionValue', ___FirstDLCount_iE_Extension__item__extensionValue),
        ])
    __FirstDLCount_iE_Extension__item_._ext = None
    _FirstDLCount_iE_Extension._cont = __FirstDLCount_iE_Extension__item_
    _FirstDLCount_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FirstDLCount._cont = ASN1Dict([
        ('dRBsSubjectToEarlyStatusTransfer', _FirstDLCount_dRBsSubjectToEarlyStatusTransfer),
        ('iE-Extension', _FirstDLCount_iE_Extension),
        ])
    FirstDLCount._ext = []
    
    #-----< FirstDLCount-ExtIEs >-----#
    FirstDLCount_ExtIEs = CLASS(name='FirstDLCount-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    FirstDLCount_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRBsSubjectToEarlyStatusTransfer-List >-----#
    DRBsSubjectToEarlyStatusTransfer_List = SEQ_OF(name='DRBsSubjectToEarlyStatusTransfer-List', mode=MODE_TYPE)
    _DRBsSubjectToEarlyStatusTransfer_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DRBsSubjectToEarlyStatusTransfer-Item')))
    DRBsSubjectToEarlyStatusTransfer_List._cont = _DRBsSubjectToEarlyStatusTransfer_List__item_
    DRBsSubjectToEarlyStatusTransfer_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< DRBsSubjectToEarlyStatusTransfer-Item >-----#
    DRBsSubjectToEarlyStatusTransfer_Item = SEQ(name='DRBsSubjectToEarlyStatusTransfer-Item', mode=MODE_TYPE)
    _DRBsSubjectToEarlyStatusTransfer_Item_dRB_ID = INT(name='dRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRB-ID')))
    _DRBsSubjectToEarlyStatusTransfer_Item_firstDLCOUNT = CHOICE(name='firstDLCOUNT', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRBStatusDL')))
    _DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id._const_tab = ____DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id_tab
    ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id._const_tab_at = None
    ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id._const_tab_id = 'id'
    ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality._const_tab = ____DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality_tab
    ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue._const_tab = ____DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue_tab
    ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id),
        ('criticality', ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality),
        ('extensionValue', ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue),
        ])
    __DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item_._ext = None
    _DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension._cont = __DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item_
    _DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRBsSubjectToEarlyStatusTransfer_Item._cont = ASN1Dict([
        ('dRB-ID', _DRBsSubjectToEarlyStatusTransfer_Item_dRB_ID),
        ('firstDLCOUNT', _DRBsSubjectToEarlyStatusTransfer_Item_firstDLCOUNT),
        ('iE-Extension', _DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension),
        ])
    DRBsSubjectToEarlyStatusTransfer_Item._ext = []
    
    #-----< DRBsSubjectToEarlyStatusTransfer-Item-ExtIEs >-----#
    DRBsSubjectToEarlyStatusTransfer_Item_ExtIEs = CLASS(name='DRBsSubjectToEarlyStatusTransfer-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    DRBsSubjectToEarlyStatusTransfer_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EDT-Session >-----#
    EDT_Session = ENUM(name='EDT-Session', mode=MODE_TYPE)
    EDT_Session._cont = ASN1Dict([('true', 0)])
    EDT_Session._ext = []
    
    #-----< EmergencyAreaID >-----#
    EmergencyAreaID = OCT_STR(name='EmergencyAreaID', mode=MODE_TYPE)
    EmergencyAreaID._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< EmergencyAreaIDBroadcastEUTRA >-----#
    EmergencyAreaIDBroadcastEUTRA = SEQ_OF(name='EmergencyAreaIDBroadcastEUTRA', mode=MODE_TYPE)
    _EmergencyAreaIDBroadcastEUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaIDBroadcastEUTRA-Item')))
    EmergencyAreaIDBroadcastEUTRA._cont = _EmergencyAreaIDBroadcastEUTRA__item_
    EmergencyAreaIDBroadcastEUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< EmergencyAreaIDBroadcastEUTRA-Item >-----#
    EmergencyAreaIDBroadcastEUTRA_Item = SEQ(name='EmergencyAreaIDBroadcastEUTRA-Item', mode=MODE_TYPE)
    _EmergencyAreaIDBroadcastEUTRA_Item_emergencyAreaID = OCT_STR(name='emergencyAreaID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaID')))
    _EmergencyAreaIDBroadcastEUTRA_Item_completedCellsInEAI_EUTRA = SEQ_OF(name='completedCellsInEAI-EUTRA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CompletedCellsInEAI-EUTRA')))
    _EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__id._const_tab = ____EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__id_tab
    ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__criticality._const_tab = ____EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__criticality_tab
    ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__id),
        ('criticality', ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item_._ext = None
    _EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions._cont = __EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item_
    _EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EmergencyAreaIDBroadcastEUTRA_Item._cont = ASN1Dict([
        ('emergencyAreaID', _EmergencyAreaIDBroadcastEUTRA_Item_emergencyAreaID),
        ('completedCellsInEAI-EUTRA', _EmergencyAreaIDBroadcastEUTRA_Item_completedCellsInEAI_EUTRA),
        ('iE-Extensions', _EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions),
        ])
    EmergencyAreaIDBroadcastEUTRA_Item._ext = []
    
    #-----< EmergencyAreaIDBroadcastEUTRA-Item-ExtIEs >-----#
    EmergencyAreaIDBroadcastEUTRA_Item_ExtIEs = CLASS(name='EmergencyAreaIDBroadcastEUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EmergencyAreaIDBroadcastEUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EmergencyAreaIDBroadcastNR >-----#
    EmergencyAreaIDBroadcastNR = SEQ_OF(name='EmergencyAreaIDBroadcastNR', mode=MODE_TYPE)
    _EmergencyAreaIDBroadcastNR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaIDBroadcastNR-Item')))
    EmergencyAreaIDBroadcastNR._cont = _EmergencyAreaIDBroadcastNR__item_
    EmergencyAreaIDBroadcastNR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< EmergencyAreaIDBroadcastNR-Item >-----#
    EmergencyAreaIDBroadcastNR_Item = SEQ(name='EmergencyAreaIDBroadcastNR-Item', mode=MODE_TYPE)
    _EmergencyAreaIDBroadcastNR_Item_emergencyAreaID = OCT_STR(name='emergencyAreaID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaID')))
    _EmergencyAreaIDBroadcastNR_Item_completedCellsInEAI_NR = SEQ_OF(name='completedCellsInEAI-NR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CompletedCellsInEAI-NR')))
    _EmergencyAreaIDBroadcastNR_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__id._const_tab = ____EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__id_tab
    ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__id._const_tab_at = None
    ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__criticality._const_tab = ____EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__criticality_tab
    ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__extensionValue._const_tab = ____EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__extensionValue_tab
    ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__id),
        ('criticality', ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__extensionValue),
        ])
    __EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item_._ext = None
    _EmergencyAreaIDBroadcastNR_Item_iE_Extensions._cont = __EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item_
    _EmergencyAreaIDBroadcastNR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EmergencyAreaIDBroadcastNR_Item._cont = ASN1Dict([
        ('emergencyAreaID', _EmergencyAreaIDBroadcastNR_Item_emergencyAreaID),
        ('completedCellsInEAI-NR', _EmergencyAreaIDBroadcastNR_Item_completedCellsInEAI_NR),
        ('iE-Extensions', _EmergencyAreaIDBroadcastNR_Item_iE_Extensions),
        ])
    EmergencyAreaIDBroadcastNR_Item._ext = []
    
    #-----< EmergencyAreaIDBroadcastNR-Item-ExtIEs >-----#
    EmergencyAreaIDBroadcastNR_Item_ExtIEs = CLASS(name='EmergencyAreaIDBroadcastNR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EmergencyAreaIDBroadcastNR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EmergencyAreaIDCancelledEUTRA >-----#
    EmergencyAreaIDCancelledEUTRA = SEQ_OF(name='EmergencyAreaIDCancelledEUTRA', mode=MODE_TYPE)
    _EmergencyAreaIDCancelledEUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaIDCancelledEUTRA-Item')))
    EmergencyAreaIDCancelledEUTRA._cont = _EmergencyAreaIDCancelledEUTRA__item_
    EmergencyAreaIDCancelledEUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< EmergencyAreaIDCancelledEUTRA-Item >-----#
    EmergencyAreaIDCancelledEUTRA_Item = SEQ(name='EmergencyAreaIDCancelledEUTRA-Item', mode=MODE_TYPE)
    _EmergencyAreaIDCancelledEUTRA_Item_emergencyAreaID = OCT_STR(name='emergencyAreaID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaID')))
    _EmergencyAreaIDCancelledEUTRA_Item_cancelledCellsInEAI_EUTRA = SEQ_OF(name='cancelledCellsInEAI-EUTRA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CancelledCellsInEAI-EUTRA')))
    _EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__id._const_tab = ____EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__id_tab
    ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__criticality._const_tab = ____EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__criticality_tab
    ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__id),
        ('criticality', ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item_._ext = None
    _EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions._cont = __EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item_
    _EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EmergencyAreaIDCancelledEUTRA_Item._cont = ASN1Dict([
        ('emergencyAreaID', _EmergencyAreaIDCancelledEUTRA_Item_emergencyAreaID),
        ('cancelledCellsInEAI-EUTRA', _EmergencyAreaIDCancelledEUTRA_Item_cancelledCellsInEAI_EUTRA),
        ('iE-Extensions', _EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions),
        ])
    EmergencyAreaIDCancelledEUTRA_Item._ext = []
    
    #-----< EmergencyAreaIDCancelledEUTRA-Item-ExtIEs >-----#
    EmergencyAreaIDCancelledEUTRA_Item_ExtIEs = CLASS(name='EmergencyAreaIDCancelledEUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EmergencyAreaIDCancelledEUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EmergencyAreaIDCancelledNR >-----#
    EmergencyAreaIDCancelledNR = SEQ_OF(name='EmergencyAreaIDCancelledNR', mode=MODE_TYPE)
    _EmergencyAreaIDCancelledNR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaIDCancelledNR-Item')))
    EmergencyAreaIDCancelledNR._cont = _EmergencyAreaIDCancelledNR__item_
    EmergencyAreaIDCancelledNR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< EmergencyAreaIDCancelledNR-Item >-----#
    EmergencyAreaIDCancelledNR_Item = SEQ(name='EmergencyAreaIDCancelledNR-Item', mode=MODE_TYPE)
    _EmergencyAreaIDCancelledNR_Item_emergencyAreaID = OCT_STR(name='emergencyAreaID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaID')))
    _EmergencyAreaIDCancelledNR_Item_cancelledCellsInEAI_NR = SEQ_OF(name='cancelledCellsInEAI-NR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CancelledCellsInEAI-NR')))
    _EmergencyAreaIDCancelledNR_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EmergencyAreaIDCancelledNR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__id._const_tab = ____EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__id_tab
    ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__id._const_tab_at = None
    ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__criticality._const_tab = ____EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__criticality_tab
    ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__extensionValue._const_tab = ____EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__extensionValue_tab
    ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EmergencyAreaIDCancelledNR_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__id),
        ('criticality', ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__extensionValue),
        ])
    __EmergencyAreaIDCancelledNR_Item_iE_Extensions__item_._ext = None
    _EmergencyAreaIDCancelledNR_Item_iE_Extensions._cont = __EmergencyAreaIDCancelledNR_Item_iE_Extensions__item_
    _EmergencyAreaIDCancelledNR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EmergencyAreaIDCancelledNR_Item._cont = ASN1Dict([
        ('emergencyAreaID', _EmergencyAreaIDCancelledNR_Item_emergencyAreaID),
        ('cancelledCellsInEAI-NR', _EmergencyAreaIDCancelledNR_Item_cancelledCellsInEAI_NR),
        ('iE-Extensions', _EmergencyAreaIDCancelledNR_Item_iE_Extensions),
        ])
    EmergencyAreaIDCancelledNR_Item._ext = []
    
    #-----< EmergencyAreaIDCancelledNR-Item-ExtIEs >-----#
    EmergencyAreaIDCancelledNR_Item_ExtIEs = CLASS(name='EmergencyAreaIDCancelledNR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EmergencyAreaIDCancelledNR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EmergencyAreaIDList >-----#
    EmergencyAreaIDList = SEQ_OF(name='EmergencyAreaIDList', mode=MODE_TYPE)
    _EmergencyAreaIDList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaID')))
    EmergencyAreaIDList._cont = _EmergencyAreaIDList__item_
    EmergencyAreaIDList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< EmergencyAreaIDListForRestart >-----#
    EmergencyAreaIDListForRestart = SEQ_OF(name='EmergencyAreaIDListForRestart', mode=MODE_TYPE)
    _EmergencyAreaIDListForRestart__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaID')))
    EmergencyAreaIDListForRestart._cont = _EmergencyAreaIDListForRestart__item_
    EmergencyAreaIDListForRestart._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< EmergencyFallbackIndicator >-----#
    EmergencyFallbackIndicator = SEQ(name='EmergencyFallbackIndicator', mode=MODE_TYPE)
    _EmergencyFallbackIndicator_emergencyFallbackRequestIndicator = ENUM(name='emergencyFallbackRequestIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EmergencyFallbackRequestIndicator')))
    _EmergencyFallbackIndicator_emergencyServiceTargetCN = ENUM(name='emergencyServiceTargetCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EmergencyServiceTargetCN')), opt=True)
    _EmergencyFallbackIndicator_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EmergencyFallbackIndicator_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EmergencyFallbackIndicator_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____EmergencyFallbackIndicator_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyFallbackIndicator_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyFallbackIndicator_iE_Extensions__item__id._const_tab = ____EmergencyFallbackIndicator_iE_Extensions__item__id_tab
    ___EmergencyFallbackIndicator_iE_Extensions__item__id._const_tab_at = None
    ___EmergencyFallbackIndicator_iE_Extensions__item__id._const_tab_id = 'id'
    ___EmergencyFallbackIndicator_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EmergencyFallbackIndicator_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyFallbackIndicator_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyFallbackIndicator_iE_Extensions__item__criticality._const_tab = ____EmergencyFallbackIndicator_iE_Extensions__item__criticality_tab
    ___EmergencyFallbackIndicator_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EmergencyFallbackIndicator_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EmergencyFallbackIndicator_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EmergencyFallbackIndicator_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EmergencyFallbackIndicator_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyFallbackIndicator_iE_Extensions__item__extensionValue._const_tab = ____EmergencyFallbackIndicator_iE_Extensions__item__extensionValue_tab
    ___EmergencyFallbackIndicator_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EmergencyFallbackIndicator_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EmergencyFallbackIndicator_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EmergencyFallbackIndicator_iE_Extensions__item__id),
        ('criticality', ___EmergencyFallbackIndicator_iE_Extensions__item__criticality),
        ('extensionValue', ___EmergencyFallbackIndicator_iE_Extensions__item__extensionValue),
        ])
    __EmergencyFallbackIndicator_iE_Extensions__item_._ext = None
    _EmergencyFallbackIndicator_iE_Extensions._cont = __EmergencyFallbackIndicator_iE_Extensions__item_
    _EmergencyFallbackIndicator_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EmergencyFallbackIndicator._cont = ASN1Dict([
        ('emergencyFallbackRequestIndicator', _EmergencyFallbackIndicator_emergencyFallbackRequestIndicator),
        ('emergencyServiceTargetCN', _EmergencyFallbackIndicator_emergencyServiceTargetCN),
        ('iE-Extensions', _EmergencyFallbackIndicator_iE_Extensions),
        ])
    EmergencyFallbackIndicator._ext = []
    
    #-----< EmergencyFallbackIndicator-ExtIEs >-----#
    EmergencyFallbackIndicator_ExtIEs = CLASS(name='EmergencyFallbackIndicator-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EmergencyFallbackIndicator_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EmergencyFallbackRequestIndicator >-----#
    EmergencyFallbackRequestIndicator = ENUM(name='EmergencyFallbackRequestIndicator', mode=MODE_TYPE)
    EmergencyFallbackRequestIndicator._cont = ASN1Dict([('emergency-fallback-requested', 0)])
    EmergencyFallbackRequestIndicator._ext = []
    
    #-----< EmergencyServiceTargetCN >-----#
    EmergencyServiceTargetCN = ENUM(name='EmergencyServiceTargetCN', mode=MODE_TYPE)
    EmergencyServiceTargetCN._cont = ASN1Dict([('fiveGC', 0), ('epc', 1)])
    EmergencyServiceTargetCN._ext = []
    
    #-----< ENB-ID >-----#
    ENB_ID = CHOICE(name='ENB-ID', mode=MODE_TYPE)
    _ENB_ID_macroENB_ID = BIT_STR(name='macroENB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_macroENB_ID._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    _ENB_ID_homeENB_ID = BIT_STR(name='homeENB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_homeENB_ID._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    _ENB_ID_short_macroENB_ID = BIT_STR(name='short-macroENB-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_short_macroENB_ID._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _ENB_ID_long_macroENB_ID = BIT_STR(name='long-macroENB-ID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_long_macroENB_ID._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    _ENB_ID_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __ENB_ID_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___ENB_ID_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ENB_ID_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ENB_ID_choice_Extensions_id._const_tab = ___ENB_ID_choice_Extensions_id_tab
    __ENB_ID_choice_Extensions_id._const_tab_at = None
    __ENB_ID_choice_Extensions_id._const_tab_id = 'id'
    __ENB_ID_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___ENB_ID_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ENB_ID_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ENB_ID_choice_Extensions_criticality._const_tab = ___ENB_ID_choice_Extensions_criticality_tab
    __ENB_ID_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __ENB_ID_choice_Extensions_criticality._const_tab_id = 'criticality'
    __ENB_ID_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___ENB_ID_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ENB_ID_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ENB_ID_choice_Extensions_value._const_tab = ___ENB_ID_choice_Extensions_value_tab
    __ENB_ID_choice_Extensions_value._const_tab_at = ('..', 'id')
    __ENB_ID_choice_Extensions_value._const_tab_id = 'Value'
    _ENB_ID_choice_Extensions._cont = ASN1Dict([
        ('id', __ENB_ID_choice_Extensions_id),
        ('criticality', __ENB_ID_choice_Extensions_criticality),
        ('value', __ENB_ID_choice_Extensions_value),
        ])
    _ENB_ID_choice_Extensions._ext = None
    ENB_ID._cont = ASN1Dict([
        ('macroENB-ID', _ENB_ID_macroENB_ID),
        ('homeENB-ID', _ENB_ID_homeENB_ID),
        ('short-macroENB-ID', _ENB_ID_short_macroENB_ID),
        ('long-macroENB-ID', _ENB_ID_long_macroENB_ID),
        ('choice-Extensions', _ENB_ID_choice_Extensions),
        ])
    ENB_ID._ext = None
    
    #-----< ENB-ID-ExtIEs >-----#
    ENB_ID_ExtIEs = CLASS(name='ENB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ENB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Enhanced-CoverageRestriction >-----#
    Enhanced_CoverageRestriction = ENUM(name='Enhanced-CoverageRestriction', mode=MODE_TYPE)
    Enhanced_CoverageRestriction._cont = ASN1Dict([('restricted', 0)])
    Enhanced_CoverageRestriction._ext = []
    
    #-----< Extended-ConnectedTime >-----#
    Extended_ConnectedTime = INT(name='Extended-ConnectedTime', mode=MODE_TYPE)
    Extended_ConnectedTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< EN-DCSONConfigurationTransfer >-----#
    EN_DCSONConfigurationTransfer = OCT_STR(name='EN-DCSONConfigurationTransfer', mode=MODE_TYPE)
    
    #-----< EndpointIPAddressAndPort >-----#
    EndpointIPAddressAndPort = SEQ(name='EndpointIPAddressAndPort', mode=MODE_TYPE)
    _EndpointIPAddressAndPort_endpointIPAddress = BIT_STR(name='endpointIPAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _EndpointIPAddressAndPort_portNumber = OCT_STR(name='portNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PortNumber')))
    _EndpointIPAddressAndPort_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EndpointIPAddressAndPort_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EndpointIPAddressAndPort_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____EndpointIPAddressAndPort_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EndpointIPAddressAndPort_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EndpointIPAddressAndPort_iE_Extensions__item__id._const_tab = ____EndpointIPAddressAndPort_iE_Extensions__item__id_tab
    ___EndpointIPAddressAndPort_iE_Extensions__item__id._const_tab_at = None
    ___EndpointIPAddressAndPort_iE_Extensions__item__id._const_tab_id = 'id'
    ___EndpointIPAddressAndPort_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EndpointIPAddressAndPort_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EndpointIPAddressAndPort_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EndpointIPAddressAndPort_iE_Extensions__item__criticality._const_tab = ____EndpointIPAddressAndPort_iE_Extensions__item__criticality_tab
    ___EndpointIPAddressAndPort_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EndpointIPAddressAndPort_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EndpointIPAddressAndPort_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EndpointIPAddressAndPort_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EndpointIPAddressAndPort_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EndpointIPAddressAndPort_iE_Extensions__item__extensionValue._const_tab = ____EndpointIPAddressAndPort_iE_Extensions__item__extensionValue_tab
    ___EndpointIPAddressAndPort_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EndpointIPAddressAndPort_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EndpointIPAddressAndPort_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EndpointIPAddressAndPort_iE_Extensions__item__id),
        ('criticality', ___EndpointIPAddressAndPort_iE_Extensions__item__criticality),
        ('extensionValue', ___EndpointIPAddressAndPort_iE_Extensions__item__extensionValue),
        ])
    __EndpointIPAddressAndPort_iE_Extensions__item_._ext = None
    _EndpointIPAddressAndPort_iE_Extensions._cont = __EndpointIPAddressAndPort_iE_Extensions__item_
    _EndpointIPAddressAndPort_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EndpointIPAddressAndPort._cont = ASN1Dict([
        ('endpointIPAddress', _EndpointIPAddressAndPort_endpointIPAddress),
        ('portNumber', _EndpointIPAddressAndPort_portNumber),
        ('iE-Extensions', _EndpointIPAddressAndPort_iE_Extensions),
        ])
    EndpointIPAddressAndPort._ext = None
    
    #-----< EndIndication >-----#
    EndIndication = ENUM(name='EndIndication', mode=MODE_TYPE)
    EndIndication._cont = ASN1Dict([('no-further-data', 0), ('further-data-exists', 1)])
    EndIndication._ext = []
    
    #-----< EndpointIPAddressAndPort-ExtIEs >-----#
    EndpointIPAddressAndPort_ExtIEs = CLASS(name='EndpointIPAddressAndPort-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EndpointIPAddressAndPort_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EquivalentPLMNs >-----#
    EquivalentPLMNs = SEQ_OF(name='EquivalentPLMNs', mode=MODE_TYPE)
    _EquivalentPLMNs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    EquivalentPLMNs._cont = _EquivalentPLMNs__item_
    EquivalentPLMNs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< EPS-TAC >-----#
    EPS_TAC = OCT_STR(name='EPS-TAC', mode=MODE_TYPE)
    EPS_TAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< EPS-TAI >-----#
    EPS_TAI = SEQ(name='EPS-TAI', mode=MODE_TYPE)
    _EPS_TAI_pLMNIdentity = OCT_STR(name='pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _EPS_TAI_ePS_TAC = OCT_STR(name='ePS-TAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EPS-TAC')))
    _EPS_TAI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EPS_TAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EPS_TAI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____EPS_TAI_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EPS_TAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EPS_TAI_iE_Extensions__item__id._const_tab = ____EPS_TAI_iE_Extensions__item__id_tab
    ___EPS_TAI_iE_Extensions__item__id._const_tab_at = None
    ___EPS_TAI_iE_Extensions__item__id._const_tab_id = 'id'
    ___EPS_TAI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EPS_TAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EPS_TAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EPS_TAI_iE_Extensions__item__criticality._const_tab = ____EPS_TAI_iE_Extensions__item__criticality_tab
    ___EPS_TAI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EPS_TAI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EPS_TAI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EPS_TAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EPS_TAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EPS_TAI_iE_Extensions__item__extensionValue._const_tab = ____EPS_TAI_iE_Extensions__item__extensionValue_tab
    ___EPS_TAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EPS_TAI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EPS_TAI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EPS_TAI_iE_Extensions__item__id),
        ('criticality', ___EPS_TAI_iE_Extensions__item__criticality),
        ('extensionValue', ___EPS_TAI_iE_Extensions__item__extensionValue),
        ])
    __EPS_TAI_iE_Extensions__item_._ext = None
    _EPS_TAI_iE_Extensions._cont = __EPS_TAI_iE_Extensions__item_
    _EPS_TAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EPS_TAI._cont = ASN1Dict([
        ('pLMNIdentity', _EPS_TAI_pLMNIdentity),
        ('ePS-TAC', _EPS_TAI_ePS_TAC),
        ('iE-Extensions', _EPS_TAI_iE_Extensions),
        ])
    EPS_TAI._ext = []
    
    #-----< EPS-TAI-ExtIEs >-----#
    EPS_TAI_ExtIEs = CLASS(name='EPS-TAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EPS_TAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RAB-ID >-----#
    E_RAB_ID = INT(name='E-RAB-ID', mode=MODE_TYPE)
    E_RAB_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    
    #-----< E-RABInformationList >-----#
    E_RABInformationList = SEQ_OF(name='E-RABInformationList', mode=MODE_TYPE)
    _E_RABInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'E-RABInformationItem')))
    E_RABInformationList._cont = _E_RABInformationList__item_
    E_RABInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABInformationItem >-----#
    E_RABInformationItem = SEQ(name='E-RABInformationItem', mode=MODE_TYPE)
    _E_RABInformationItem_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'E-RAB-ID')))
    _E_RABInformationItem_dLForwarding = ENUM(name='dLForwarding', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DLForwarding')), opt=True)
    _E_RABInformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___E_RABInformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_RABInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____E_RABInformationItem_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _____E_RABInformationItem_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    ____E_RABInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 284), ('criticality', 'ignore'), ('Extension', _____E_RABInformationItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 354), ('criticality', 'ignore'), ('Extension', _____E_RABInformationItem_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_RABInformationItem_iE_Extensions__item__id._const_tab = ____E_RABInformationItem_iE_Extensions__item__id_tab
    ___E_RABInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABInformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_RABInformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_RABInformationItem_iE_Extensions__item__criticality._const_tab = ____E_RABInformationItem_iE_Extensions__item__id_tab
    ___E_RABInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_RABInformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_RABInformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_RABInformationItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABInformationItem_iE_Extensions__item__id_tab
    ___E_RABInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_RABInformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_RABInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_RABInformationItem_iE_Extensions__item__id),
        ('criticality', ___E_RABInformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___E_RABInformationItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABInformationItem_iE_Extensions__item_._ext = None
    _E_RABInformationItem_iE_Extensions._cont = __E_RABInformationItem_iE_Extensions__item_
    _E_RABInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABInformationItem._cont = ASN1Dict([
        ('e-RAB-ID', _E_RABInformationItem_e_RAB_ID),
        ('dLForwarding', _E_RABInformationItem_dLForwarding),
        ('iE-Extensions', _E_RABInformationItem_iE_Extensions),
        ])
    E_RABInformationItem._ext = []
    
    #-----< E-RABInformationItem-ExtIEs >-----#
    E_RABInformationItem_ExtIEs = CLASS(name='E-RABInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _E_RABInformationItem_ExtIEs_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _E_RABInformationItem_ExtIEs_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    E_RABInformationItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 284), ('criticality', 'ignore'), ('Extension', _E_RABInformationItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 354), ('criticality', 'ignore'), ('Extension', _E_RABInformationItem_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< EUTRACellIdentity >-----#
    EUTRACellIdentity = BIT_STR(name='EUTRACellIdentity', mode=MODE_TYPE)
    EUTRACellIdentity._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    
    #-----< EUTRA-CGI >-----#
    EUTRA_CGI = SEQ(name='EUTRA-CGI', mode=MODE_TYPE)
    _EUTRA_CGI_pLMNIdentity = OCT_STR(name='pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _EUTRA_CGI_eUTRACellIdentity = BIT_STR(name='eUTRACellIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRACellIdentity')))
    _EUTRA_CGI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRA_CGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EUTRA_CGI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____EUTRA_CGI_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRA_CGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_CGI_iE_Extensions__item__id._const_tab = ____EUTRA_CGI_iE_Extensions__item__id_tab
    ___EUTRA_CGI_iE_Extensions__item__id._const_tab_at = None
    ___EUTRA_CGI_iE_Extensions__item__id._const_tab_id = 'id'
    ___EUTRA_CGI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EUTRA_CGI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRA_CGI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_CGI_iE_Extensions__item__criticality._const_tab = ____EUTRA_CGI_iE_Extensions__item__criticality_tab
    ___EUTRA_CGI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EUTRA_CGI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EUTRA_CGI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EUTRA_CGI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRA_CGI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_CGI_iE_Extensions__item__extensionValue._const_tab = ____EUTRA_CGI_iE_Extensions__item__extensionValue_tab
    ___EUTRA_CGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EUTRA_CGI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EUTRA_CGI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EUTRA_CGI_iE_Extensions__item__id),
        ('criticality', ___EUTRA_CGI_iE_Extensions__item__criticality),
        ('extensionValue', ___EUTRA_CGI_iE_Extensions__item__extensionValue),
        ])
    __EUTRA_CGI_iE_Extensions__item_._ext = None
    _EUTRA_CGI_iE_Extensions._cont = __EUTRA_CGI_iE_Extensions__item_
    _EUTRA_CGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRA_CGI._cont = ASN1Dict([
        ('pLMNIdentity', _EUTRA_CGI_pLMNIdentity),
        ('eUTRACellIdentity', _EUTRA_CGI_eUTRACellIdentity),
        ('iE-Extensions', _EUTRA_CGI_iE_Extensions),
        ])
    EUTRA_CGI._ext = []
    
    #-----< EUTRA-CGI-ExtIEs >-----#
    EUTRA_CGI_ExtIEs = CLASS(name='EUTRA-CGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EUTRA_CGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRA-CGIList >-----#
    EUTRA_CGIList = SEQ_OF(name='EUTRA-CGIList', mode=MODE_TYPE)
    _EUTRA_CGIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    EUTRA_CGIList._cont = _EUTRA_CGIList__item_
    EUTRA_CGIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< EUTRA-CGIListForWarning >-----#
    EUTRA_CGIListForWarning = SEQ_OF(name='EUTRA-CGIListForWarning', mode=MODE_TYPE)
    _EUTRA_CGIListForWarning__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    EUTRA_CGIListForWarning._cont = _EUTRA_CGIListForWarning__item_
    EUTRA_CGIListForWarning._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< EUTRA-PagingeDRXInformation >-----#
    EUTRA_PagingeDRXInformation = SEQ(name='EUTRA-PagingeDRXInformation', mode=MODE_TYPE)
    _EUTRA_PagingeDRXInformation_eUTRA_paging_eDRX_Cycle = ENUM(name='eUTRA-paging-eDRX-Cycle', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-Paging-eDRX-Cycle')))
    _EUTRA_PagingeDRXInformation_eUTRA_paging_Time_Window = ENUM(name='eUTRA-paging-Time-Window', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-Paging-Time-Window')), opt=True)
    _EUTRA_PagingeDRXInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRA_PagingeDRXInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EUTRA_PagingeDRXInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____EUTRA_PagingeDRXInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRA_PagingeDRXInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_PagingeDRXInformation_iE_Extensions__item__id._const_tab = ____EUTRA_PagingeDRXInformation_iE_Extensions__item__id_tab
    ___EUTRA_PagingeDRXInformation_iE_Extensions__item__id._const_tab_at = None
    ___EUTRA_PagingeDRXInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___EUTRA_PagingeDRXInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EUTRA_PagingeDRXInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRA_PagingeDRXInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_PagingeDRXInformation_iE_Extensions__item__criticality._const_tab = ____EUTRA_PagingeDRXInformation_iE_Extensions__item__criticality_tab
    ___EUTRA_PagingeDRXInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EUTRA_PagingeDRXInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EUTRA_PagingeDRXInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EUTRA_PagingeDRXInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRA_PagingeDRXInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRA_PagingeDRXInformation_iE_Extensions__item__extensionValue._const_tab = ____EUTRA_PagingeDRXInformation_iE_Extensions__item__extensionValue_tab
    ___EUTRA_PagingeDRXInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EUTRA_PagingeDRXInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EUTRA_PagingeDRXInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EUTRA_PagingeDRXInformation_iE_Extensions__item__id),
        ('criticality', ___EUTRA_PagingeDRXInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___EUTRA_PagingeDRXInformation_iE_Extensions__item__extensionValue),
        ])
    __EUTRA_PagingeDRXInformation_iE_Extensions__item_._ext = None
    _EUTRA_PagingeDRXInformation_iE_Extensions._cont = __EUTRA_PagingeDRXInformation_iE_Extensions__item_
    _EUTRA_PagingeDRXInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRA_PagingeDRXInformation._cont = ASN1Dict([
        ('eUTRA-paging-eDRX-Cycle', _EUTRA_PagingeDRXInformation_eUTRA_paging_eDRX_Cycle),
        ('eUTRA-paging-Time-Window', _EUTRA_PagingeDRXInformation_eUTRA_paging_Time_Window),
        ('iE-Extensions', _EUTRA_PagingeDRXInformation_iE_Extensions),
        ])
    EUTRA_PagingeDRXInformation._ext = []
    
    #-----< EUTRA-PagingeDRXInformation-ExtIEs >-----#
    EUTRA_PagingeDRXInformation_ExtIEs = CLASS(name='EUTRA-PagingeDRXInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EUTRA_PagingeDRXInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRA-Paging-eDRX-Cycle >-----#
    EUTRA_Paging_eDRX_Cycle = ENUM(name='EUTRA-Paging-eDRX-Cycle', mode=MODE_TYPE)
    EUTRA_Paging_eDRX_Cycle._cont = ASN1Dict([('hfhalf', 0), ('hf1', 1), ('hf2', 2), ('hf4', 3), ('hf6', 4), ('hf8', 5), ('hf10', 6), ('hf12', 7), ('hf14', 8), ('hf16', 9), ('hf32', 10), ('hf64', 11), ('hf128', 12), ('hf256', 13)])
    EUTRA_Paging_eDRX_Cycle._ext = []
    
    #-----< EUTRA-Paging-Time-Window >-----#
    EUTRA_Paging_Time_Window = ENUM(name='EUTRA-Paging-Time-Window', mode=MODE_TYPE)
    EUTRA_Paging_Time_Window._cont = ASN1Dict([('s1', 0), ('s2', 1), ('s3', 2), ('s4', 3), ('s5', 4), ('s6', 5), ('s7', 6), ('s8', 7), ('s9', 8), ('s10', 9), ('s11', 10), ('s12', 11), ('s13', 12), ('s14', 13), ('s15', 14), ('s16', 15)])
    EUTRA_Paging_Time_Window._ext = []
    
    #-----< EUTRAencryptionAlgorithms >-----#
    EUTRAencryptionAlgorithms = BIT_STR(name='EUTRAencryptionAlgorithms', mode=MODE_TYPE)
    EUTRAencryptionAlgorithms._const_sz = ASN1Set(rv=[16], rr=[], ev=[], er=[])
    
    #-----< EUTRAintegrityProtectionAlgorithms >-----#
    EUTRAintegrityProtectionAlgorithms = BIT_STR(name='EUTRAintegrityProtectionAlgorithms', mode=MODE_TYPE)
    EUTRAintegrityProtectionAlgorithms._const_sz = ASN1Set(rv=[16], rr=[], ev=[], er=[])
    
    #-----< EventType >-----#
    EventType = ENUM(name='EventType', mode=MODE_TYPE)
    EventType._cont = ASN1Dict([('direct', 0), ('change-of-serve-cell', 1), ('ue-presence-in-area-of-interest', 2), ('stop-change-of-serve-cell', 3), ('stop-ue-presence-in-area-of-interest', 4), ('cancel-location-reporting-for-the-ue', 5)])
    EventType._ext = []
    
    #-----< ExcessPacketDelayThresholdConfiguration >-----#
    ExcessPacketDelayThresholdConfiguration = SEQ_OF(name='ExcessPacketDelayThresholdConfiguration', mode=MODE_TYPE)
    _ExcessPacketDelayThresholdConfiguration__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExcessPacketDelayThresholdItem')))
    ExcessPacketDelayThresholdConfiguration._cont = _ExcessPacketDelayThresholdConfiguration__item_
    ExcessPacketDelayThresholdConfiguration._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    
    #-----< ExcessPacketDelayThresholdItem >-----#
    ExcessPacketDelayThresholdItem = SEQ(name='ExcessPacketDelayThresholdItem', mode=MODE_TYPE)
    _ExcessPacketDelayThresholdItem_fiveQi = INT(name='fiveQi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FiveQI')))
    _ExcessPacketDelayThresholdItem_excessPacketDelayThresholdValue = ENUM(name='excessPacketDelayThresholdValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ExcessPacketDelayThresholdValue')))
    _ExcessPacketDelayThresholdItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExcessPacketDelayThresholdItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___ExcessPacketDelayThresholdItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____ExcessPacketDelayThresholdItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExcessPacketDelayThresholdItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExcessPacketDelayThresholdItem_iE_Extensions__item__id._const_tab = ____ExcessPacketDelayThresholdItem_iE_Extensions__item__id_tab
    ___ExcessPacketDelayThresholdItem_iE_Extensions__item__id._const_tab_at = None
    ___ExcessPacketDelayThresholdItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___ExcessPacketDelayThresholdItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ExcessPacketDelayThresholdItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExcessPacketDelayThresholdItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExcessPacketDelayThresholdItem_iE_Extensions__item__criticality._const_tab = ____ExcessPacketDelayThresholdItem_iE_Extensions__item__criticality_tab
    ___ExcessPacketDelayThresholdItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ExcessPacketDelayThresholdItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ExcessPacketDelayThresholdItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ExcessPacketDelayThresholdItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExcessPacketDelayThresholdItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExcessPacketDelayThresholdItem_iE_Extensions__item__extensionValue._const_tab = ____ExcessPacketDelayThresholdItem_iE_Extensions__item__extensionValue_tab
    ___ExcessPacketDelayThresholdItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ExcessPacketDelayThresholdItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ExcessPacketDelayThresholdItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ExcessPacketDelayThresholdItem_iE_Extensions__item__id),
        ('criticality', ___ExcessPacketDelayThresholdItem_iE_Extensions__item__criticality),
        ('extensionValue', ___ExcessPacketDelayThresholdItem_iE_Extensions__item__extensionValue),
        ])
    __ExcessPacketDelayThresholdItem_iE_Extensions__item_._ext = None
    _ExcessPacketDelayThresholdItem_iE_Extensions._cont = __ExcessPacketDelayThresholdItem_iE_Extensions__item_
    _ExcessPacketDelayThresholdItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExcessPacketDelayThresholdItem._cont = ASN1Dict([
        ('fiveQi', _ExcessPacketDelayThresholdItem_fiveQi),
        ('excessPacketDelayThresholdValue', _ExcessPacketDelayThresholdItem_excessPacketDelayThresholdValue),
        ('iE-Extensions', _ExcessPacketDelayThresholdItem_iE_Extensions),
        ])
    ExcessPacketDelayThresholdItem._ext = []
    
    #-----< ExcessPacketDelayThresholdItem-ExtIEs >-----#
    ExcessPacketDelayThresholdItem_ExtIEs = CLASS(name='ExcessPacketDelayThresholdItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ExcessPacketDelayThresholdItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExcessPacketDelayThresholdValue >-----#
    ExcessPacketDelayThresholdValue = ENUM(name='ExcessPacketDelayThresholdValue', mode=MODE_TYPE)
    ExcessPacketDelayThresholdValue._cont = ASN1Dict([('ms0dot25', 0), ('ms0dot5', 1), ('ms1', 2), ('ms2', 3), ('ms4', 4), ('ms5', 5), ('ms10', 6), ('ms20', 7), ('ms30', 8), ('ms40', 9), ('ms50', 10), ('ms60', 11), ('ms70', 12), ('ms80', 13), ('ms90', 14), ('ms100', 15), ('ms150', 16), ('ms300', 17), ('ms500', 18)])
    ExcessPacketDelayThresholdValue._ext = []
    
    #-----< ExpectedActivityPeriod >-----#
    ExpectedActivityPeriod = INT(name='ExpectedActivityPeriod', mode=MODE_TYPE)
    ExpectedActivityPeriod._const_val = ASN1Set(rv=[40, 50, 60, 80, 100, 120, 150, 180, 181], rr=[ASN1RangeInt(lb=1, ub=30)], ev=[], er=[])
    
    #-----< ExpectedHOInterval >-----#
    ExpectedHOInterval = ENUM(name='ExpectedHOInterval', mode=MODE_TYPE)
    ExpectedHOInterval._cont = ASN1Dict([('sec15', 0), ('sec30', 1), ('sec60', 2), ('sec90', 3), ('sec120', 4), ('sec180', 5), ('long-time', 6)])
    ExpectedHOInterval._ext = []
    
    #-----< ExpectedIdlePeriod >-----#
    ExpectedIdlePeriod = INT(name='ExpectedIdlePeriod', mode=MODE_TYPE)
    ExpectedIdlePeriod._const_val = ASN1Set(rv=[40, 50, 60, 80, 100, 120, 150, 180, 181], rr=[ASN1RangeInt(lb=1, ub=30)], ev=[], er=[])
    
    #-----< ExpectedUEActivityBehaviour >-----#
    ExpectedUEActivityBehaviour = SEQ(name='ExpectedUEActivityBehaviour', mode=MODE_TYPE)
    _ExpectedUEActivityBehaviour_expectedActivityPeriod = INT(name='expectedActivityPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ExpectedActivityPeriod')), opt=True)
    _ExpectedUEActivityBehaviour_expectedIdlePeriod = INT(name='expectedIdlePeriod', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ExpectedIdlePeriod')), opt=True)
    _ExpectedUEActivityBehaviour_sourceOfUEActivityBehaviourInformation = ENUM(name='sourceOfUEActivityBehaviourInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SourceOfUEActivityBehaviourInformation')), opt=True)
    _ExpectedUEActivityBehaviour_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExpectedUEActivityBehaviour_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__id._const_tab = ____ExpectedUEActivityBehaviour_iE_Extensions__item__id_tab
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__id._const_tab_at = None
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__id._const_tab_id = 'id'
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality._const_tab = ____ExpectedUEActivityBehaviour_iE_Extensions__item__criticality_tab
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue._const_tab = ____ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue_tab
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ExpectedUEActivityBehaviour_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ExpectedUEActivityBehaviour_iE_Extensions__item__id),
        ('criticality', ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality),
        ('extensionValue', ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue),
        ])
    __ExpectedUEActivityBehaviour_iE_Extensions__item_._ext = None
    _ExpectedUEActivityBehaviour_iE_Extensions._cont = __ExpectedUEActivityBehaviour_iE_Extensions__item_
    _ExpectedUEActivityBehaviour_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExpectedUEActivityBehaviour._cont = ASN1Dict([
        ('expectedActivityPeriod', _ExpectedUEActivityBehaviour_expectedActivityPeriod),
        ('expectedIdlePeriod', _ExpectedUEActivityBehaviour_expectedIdlePeriod),
        ('sourceOfUEActivityBehaviourInformation', _ExpectedUEActivityBehaviour_sourceOfUEActivityBehaviourInformation),
        ('iE-Extensions', _ExpectedUEActivityBehaviour_iE_Extensions),
        ])
    ExpectedUEActivityBehaviour._ext = []
    
    #-----< ExpectedUEActivityBehaviour-ExtIEs >-----#
    ExpectedUEActivityBehaviour_ExtIEs = CLASS(name='ExpectedUEActivityBehaviour-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ExpectedUEActivityBehaviour_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExpectedUEBehaviour >-----#
    ExpectedUEBehaviour = SEQ(name='ExpectedUEBehaviour', mode=MODE_TYPE)
    _ExpectedUEBehaviour_expectedUEActivityBehaviour = SEQ(name='expectedUEActivityBehaviour', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEActivityBehaviour')), opt=True)
    _ExpectedUEBehaviour_expectedHOInterval = ENUM(name='expectedHOInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ExpectedHOInterval')), opt=True)
    _ExpectedUEBehaviour_expectedUEMobility = ENUM(name='expectedUEMobility', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEMobility')), opt=True)
    _ExpectedUEBehaviour_expectedUEMovingTrajectory = SEQ_OF(name='expectedUEMovingTrajectory', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEMovingTrajectory')), opt=True)
    _ExpectedUEBehaviour_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExpectedUEBehaviour_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___ExpectedUEBehaviour_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____ExpectedUEBehaviour_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExpectedUEBehaviour_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEBehaviour_iE_Extensions__item__id._const_tab = ____ExpectedUEBehaviour_iE_Extensions__item__id_tab
    ___ExpectedUEBehaviour_iE_Extensions__item__id._const_tab_at = None
    ___ExpectedUEBehaviour_iE_Extensions__item__id._const_tab_id = 'id'
    ___ExpectedUEBehaviour_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ExpectedUEBehaviour_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExpectedUEBehaviour_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEBehaviour_iE_Extensions__item__criticality._const_tab = ____ExpectedUEBehaviour_iE_Extensions__item__criticality_tab
    ___ExpectedUEBehaviour_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ExpectedUEBehaviour_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ExpectedUEBehaviour_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExpectedUEBehaviour_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue._const_tab = ____ExpectedUEBehaviour_iE_Extensions__item__extensionValue_tab
    ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ExpectedUEBehaviour_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ExpectedUEBehaviour_iE_Extensions__item__id),
        ('criticality', ___ExpectedUEBehaviour_iE_Extensions__item__criticality),
        ('extensionValue', ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue),
        ])
    __ExpectedUEBehaviour_iE_Extensions__item_._ext = None
    _ExpectedUEBehaviour_iE_Extensions._cont = __ExpectedUEBehaviour_iE_Extensions__item_
    _ExpectedUEBehaviour_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExpectedUEBehaviour._cont = ASN1Dict([
        ('expectedUEActivityBehaviour', _ExpectedUEBehaviour_expectedUEActivityBehaviour),
        ('expectedHOInterval', _ExpectedUEBehaviour_expectedHOInterval),
        ('expectedUEMobility', _ExpectedUEBehaviour_expectedUEMobility),
        ('expectedUEMovingTrajectory', _ExpectedUEBehaviour_expectedUEMovingTrajectory),
        ('iE-Extensions', _ExpectedUEBehaviour_iE_Extensions),
        ])
    ExpectedUEBehaviour._ext = []
    
    #-----< ExpectedUEBehaviour-ExtIEs >-----#
    ExpectedUEBehaviour_ExtIEs = CLASS(name='ExpectedUEBehaviour-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ExpectedUEBehaviour_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExpectedUEMobility >-----#
    ExpectedUEMobility = ENUM(name='ExpectedUEMobility', mode=MODE_TYPE)
    ExpectedUEMobility._cont = ASN1Dict([('stationary', 0), ('mobile', 1)])
    ExpectedUEMobility._ext = []
    
    #-----< ExpectedUEMovingTrajectory >-----#
    ExpectedUEMovingTrajectory = SEQ_OF(name='ExpectedUEMovingTrajectory', mode=MODE_TYPE)
    _ExpectedUEMovingTrajectory__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEMovingTrajectoryItem')))
    ExpectedUEMovingTrajectory._cont = _ExpectedUEMovingTrajectory__item_
    ExpectedUEMovingTrajectory._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< ExpectedUEMovingTrajectoryItem >-----#
    ExpectedUEMovingTrajectoryItem = SEQ(name='ExpectedUEMovingTrajectoryItem', mode=MODE_TYPE)
    _ExpectedUEMovingTrajectoryItem_nGRAN_CGI = CHOICE(name='nGRAN-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _ExpectedUEMovingTrajectoryItem_timeStayedInCell = INT(name='timeStayedInCell', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ExpectedUEMovingTrajectoryItem_timeStayedInCell._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _ExpectedUEMovingTrajectoryItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExpectedUEMovingTrajectoryItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____ExpectedUEMovingTrajectoryItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExpectedUEMovingTrajectoryItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__id._const_tab = ____ExpectedUEMovingTrajectoryItem_iE_Extensions__item__id_tab
    ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__id._const_tab_at = None
    ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ExpectedUEMovingTrajectoryItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExpectedUEMovingTrajectoryItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__criticality._const_tab = ____ExpectedUEMovingTrajectoryItem_iE_Extensions__item__criticality_tab
    ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ExpectedUEMovingTrajectoryItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExpectedUEMovingTrajectoryItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__extensionValue._const_tab = ____ExpectedUEMovingTrajectoryItem_iE_Extensions__item__extensionValue_tab
    ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ExpectedUEMovingTrajectoryItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__id),
        ('criticality', ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__criticality),
        ('extensionValue', ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__extensionValue),
        ])
    __ExpectedUEMovingTrajectoryItem_iE_Extensions__item_._ext = None
    _ExpectedUEMovingTrajectoryItem_iE_Extensions._cont = __ExpectedUEMovingTrajectoryItem_iE_Extensions__item_
    _ExpectedUEMovingTrajectoryItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExpectedUEMovingTrajectoryItem._cont = ASN1Dict([
        ('nGRAN-CGI', _ExpectedUEMovingTrajectoryItem_nGRAN_CGI),
        ('timeStayedInCell', _ExpectedUEMovingTrajectoryItem_timeStayedInCell),
        ('iE-Extensions', _ExpectedUEMovingTrajectoryItem_iE_Extensions),
        ])
    ExpectedUEMovingTrajectoryItem._ext = []
    
    #-----< ExpectedUEMovingTrajectoryItem-ExtIEs >-----#
    ExpectedUEMovingTrajectoryItem_ExtIEs = CLASS(name='ExpectedUEMovingTrajectoryItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ExpectedUEMovingTrajectoryItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Extended-AMFName >-----#
    Extended_AMFName = SEQ(name='Extended-AMFName', mode=MODE_TYPE)
    _Extended_AMFName_aMFNameVisibleString = STR_VIS(name='aMFNameVisibleString', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AMFNameVisibleString')), opt=True)
    _Extended_AMFName_aMFNameUTF8String = STR_UTF8(name='aMFNameUTF8String', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AMFNameUTF8String')), opt=True)
    _Extended_AMFName_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Extended_AMFName_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___Extended_AMFName_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____Extended_AMFName_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____Extended_AMFName_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_AMFName_iE_Extensions__item__id._const_tab = ____Extended_AMFName_iE_Extensions__item__id_tab
    ___Extended_AMFName_iE_Extensions__item__id._const_tab_at = None
    ___Extended_AMFName_iE_Extensions__item__id._const_tab_id = 'id'
    ___Extended_AMFName_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Extended_AMFName_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____Extended_AMFName_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_AMFName_iE_Extensions__item__criticality._const_tab = ____Extended_AMFName_iE_Extensions__item__criticality_tab
    ___Extended_AMFName_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Extended_AMFName_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Extended_AMFName_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Extended_AMFName_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____Extended_AMFName_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_AMFName_iE_Extensions__item__extensionValue._const_tab = ____Extended_AMFName_iE_Extensions__item__extensionValue_tab
    ___Extended_AMFName_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Extended_AMFName_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Extended_AMFName_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Extended_AMFName_iE_Extensions__item__id),
        ('criticality', ___Extended_AMFName_iE_Extensions__item__criticality),
        ('extensionValue', ___Extended_AMFName_iE_Extensions__item__extensionValue),
        ])
    __Extended_AMFName_iE_Extensions__item_._ext = None
    _Extended_AMFName_iE_Extensions._cont = __Extended_AMFName_iE_Extensions__item_
    _Extended_AMFName_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Extended_AMFName._cont = ASN1Dict([
        ('aMFNameVisibleString', _Extended_AMFName_aMFNameVisibleString),
        ('aMFNameUTF8String', _Extended_AMFName_aMFNameUTF8String),
        ('iE-Extensions', _Extended_AMFName_iE_Extensions),
        ])
    Extended_AMFName._ext = []
    
    #-----< Extended-AMFName-ExtIEs >-----#
    Extended_AMFName_ExtIEs = CLASS(name='Extended-AMFName-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    Extended_AMFName_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExtendedPacketDelayBudget >-----#
    ExtendedPacketDelayBudget = INT(name='ExtendedPacketDelayBudget', mode=MODE_TYPE)
    ExtendedPacketDelayBudget._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=[], er=[])
    
    #-----< Extended-RANNodeName >-----#
    Extended_RANNodeName = SEQ(name='Extended-RANNodeName', mode=MODE_TYPE)
    _Extended_RANNodeName_rANNodeNameVisibleString = STR_VIS(name='rANNodeNameVisibleString', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RANNodeNameVisibleString')), opt=True)
    _Extended_RANNodeName_rANNodeNameUTF8String = STR_UTF8(name='rANNodeNameUTF8String', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RANNodeNameUTF8String')), opt=True)
    _Extended_RANNodeName_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Extended_RANNodeName_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___Extended_RANNodeName_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____Extended_RANNodeName_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____Extended_RANNodeName_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_RANNodeName_iE_Extensions__item__id._const_tab = ____Extended_RANNodeName_iE_Extensions__item__id_tab
    ___Extended_RANNodeName_iE_Extensions__item__id._const_tab_at = None
    ___Extended_RANNodeName_iE_Extensions__item__id._const_tab_id = 'id'
    ___Extended_RANNodeName_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Extended_RANNodeName_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____Extended_RANNodeName_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_RANNodeName_iE_Extensions__item__criticality._const_tab = ____Extended_RANNodeName_iE_Extensions__item__criticality_tab
    ___Extended_RANNodeName_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Extended_RANNodeName_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Extended_RANNodeName_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Extended_RANNodeName_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____Extended_RANNodeName_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extended_RANNodeName_iE_Extensions__item__extensionValue._const_tab = ____Extended_RANNodeName_iE_Extensions__item__extensionValue_tab
    ___Extended_RANNodeName_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Extended_RANNodeName_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Extended_RANNodeName_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Extended_RANNodeName_iE_Extensions__item__id),
        ('criticality', ___Extended_RANNodeName_iE_Extensions__item__criticality),
        ('extensionValue', ___Extended_RANNodeName_iE_Extensions__item__extensionValue),
        ])
    __Extended_RANNodeName_iE_Extensions__item_._ext = None
    _Extended_RANNodeName_iE_Extensions._cont = __Extended_RANNodeName_iE_Extensions__item_
    _Extended_RANNodeName_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Extended_RANNodeName._cont = ASN1Dict([
        ('rANNodeNameVisibleString', _Extended_RANNodeName_rANNodeNameVisibleString),
        ('rANNodeNameUTF8String', _Extended_RANNodeName_rANNodeNameUTF8String),
        ('iE-Extensions', _Extended_RANNodeName_iE_Extensions),
        ])
    Extended_RANNodeName._ext = []
    
    #-----< Extended-RANNodeName-ExtIEs >-----#
    Extended_RANNodeName_ExtIEs = CLASS(name='Extended-RANNodeName-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    Extended_RANNodeName_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExtendedRATRestrictionInformation >-----#
    ExtendedRATRestrictionInformation = SEQ(name='ExtendedRATRestrictionInformation', mode=MODE_TYPE)
    _ExtendedRATRestrictionInformation_primaryRATRestriction = BIT_STR(name='primaryRATRestriction', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ExtendedRATRestrictionInformation_primaryRATRestriction._const_sz = ASN1Set(rv=[8], rr=[], ev=[], er=[])
    _ExtendedRATRestrictionInformation_secondaryRATRestriction = BIT_STR(name='secondaryRATRestriction', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ExtendedRATRestrictionInformation_secondaryRATRestriction._const_sz = ASN1Set(rv=[8], rr=[], ev=[], er=[])
    _ExtendedRATRestrictionInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExtendedRATRestrictionInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___ExtendedRATRestrictionInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____ExtendedRATRestrictionInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExtendedRATRestrictionInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtendedRATRestrictionInformation_iE_Extensions__item__id._const_tab = ____ExtendedRATRestrictionInformation_iE_Extensions__item__id_tab
    ___ExtendedRATRestrictionInformation_iE_Extensions__item__id._const_tab_at = None
    ___ExtendedRATRestrictionInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___ExtendedRATRestrictionInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ExtendedRATRestrictionInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExtendedRATRestrictionInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtendedRATRestrictionInformation_iE_Extensions__item__criticality._const_tab = ____ExtendedRATRestrictionInformation_iE_Extensions__item__criticality_tab
    ___ExtendedRATRestrictionInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ExtendedRATRestrictionInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ExtendedRATRestrictionInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ExtendedRATRestrictionInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ExtendedRATRestrictionInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtendedRATRestrictionInformation_iE_Extensions__item__extensionValue._const_tab = ____ExtendedRATRestrictionInformation_iE_Extensions__item__extensionValue_tab
    ___ExtendedRATRestrictionInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ExtendedRATRestrictionInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ExtendedRATRestrictionInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ExtendedRATRestrictionInformation_iE_Extensions__item__id),
        ('criticality', ___ExtendedRATRestrictionInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___ExtendedRATRestrictionInformation_iE_Extensions__item__extensionValue),
        ])
    __ExtendedRATRestrictionInformation_iE_Extensions__item_._ext = None
    _ExtendedRATRestrictionInformation_iE_Extensions._cont = __ExtendedRATRestrictionInformation_iE_Extensions__item_
    _ExtendedRATRestrictionInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExtendedRATRestrictionInformation._cont = ASN1Dict([
        ('primaryRATRestriction', _ExtendedRATRestrictionInformation_primaryRATRestriction),
        ('secondaryRATRestriction', _ExtendedRATRestrictionInformation_secondaryRATRestriction),
        ('iE-Extensions', _ExtendedRATRestrictionInformation_iE_Extensions),
        ])
    ExtendedRATRestrictionInformation._ext = []
    
    #-----< ExtendedRATRestrictionInformation-ExtIEs >-----#
    ExtendedRATRestrictionInformation_ExtIEs = CLASS(name='ExtendedRATRestrictionInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ExtendedRATRestrictionInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExtendedRNC-ID >-----#
    ExtendedRNC_ID = INT(name='ExtendedRNC-ID', mode=MODE_TYPE)
    ExtendedRNC_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4096, ub=65535)], ev=None, er=[])
    
    #-----< ExtendedSliceSupportList >-----#
    ExtendedSliceSupportList = SEQ_OF(name='ExtendedSliceSupportList', mode=MODE_TYPE)
    _ExtendedSliceSupportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SliceSupportItem')))
    ExtendedSliceSupportList._cont = _ExtendedSliceSupportList__item_
    ExtendedSliceSupportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< ExtendedUEIdentityIndexValue >-----#
    ExtendedUEIdentityIndexValue = BIT_STR(name='ExtendedUEIdentityIndexValue', mode=MODE_TYPE)
    ExtendedUEIdentityIndexValue._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< EventTrigger >-----#
    EventTrigger = CHOICE(name='EventTrigger', mode=MODE_TYPE)
    _EventTrigger_outOfCoverage = ENUM(name='outOfCoverage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EventTrigger_outOfCoverage._cont = ASN1Dict([('true', 0)])
    _EventTrigger_outOfCoverage._ext = []
    _EventTrigger_eventL1LoggedMDTConfig = SEQ(name='eventL1LoggedMDTConfig', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EventL1LoggedMDTConfig')))
    _EventTrigger_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __EventTrigger_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___EventTrigger_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___EventTrigger_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __EventTrigger_choice_Extensions_id._const_tab = ___EventTrigger_choice_Extensions_id_tab
    __EventTrigger_choice_Extensions_id._const_tab_at = None
    __EventTrigger_choice_Extensions_id._const_tab_id = 'id'
    __EventTrigger_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___EventTrigger_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___EventTrigger_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __EventTrigger_choice_Extensions_criticality._const_tab = ___EventTrigger_choice_Extensions_criticality_tab
    __EventTrigger_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __EventTrigger_choice_Extensions_criticality._const_tab_id = 'criticality'
    __EventTrigger_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___EventTrigger_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___EventTrigger_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __EventTrigger_choice_Extensions_value._const_tab = ___EventTrigger_choice_Extensions_value_tab
    __EventTrigger_choice_Extensions_value._const_tab_at = ('..', 'id')
    __EventTrigger_choice_Extensions_value._const_tab_id = 'Value'
    _EventTrigger_choice_Extensions._cont = ASN1Dict([
        ('id', __EventTrigger_choice_Extensions_id),
        ('criticality', __EventTrigger_choice_Extensions_criticality),
        ('value', __EventTrigger_choice_Extensions_value),
        ])
    _EventTrigger_choice_Extensions._ext = None
    EventTrigger._cont = ASN1Dict([
        ('outOfCoverage', _EventTrigger_outOfCoverage),
        ('eventL1LoggedMDTConfig', _EventTrigger_eventL1LoggedMDTConfig),
        ('choice-Extensions', _EventTrigger_choice_Extensions),
        ])
    EventTrigger._ext = None
    
    #-----< EventTrigger-ExtIEs >-----#
    EventTrigger_ExtIEs = CLASS(name='EventTrigger-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    EventTrigger_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EventL1LoggedMDTConfig >-----#
    EventL1LoggedMDTConfig = SEQ(name='EventL1LoggedMDTConfig', mode=MODE_TYPE)
    _EventL1LoggedMDTConfig_l1Threshold = CHOICE(name='l1Threshold', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MeasurementThresholdL1LoggedMDT')))
    _EventL1LoggedMDTConfig_hysteresis = INT(name='hysteresis', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Hysteresis')))
    _EventL1LoggedMDTConfig_timeToTrigger = ENUM(name='timeToTrigger', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TimeToTrigger')))
    _EventL1LoggedMDTConfig_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EventL1LoggedMDTConfig_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EventL1LoggedMDTConfig_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____EventL1LoggedMDTConfig_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EventL1LoggedMDTConfig_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventL1LoggedMDTConfig_iE_Extensions__item__id._const_tab = ____EventL1LoggedMDTConfig_iE_Extensions__item__id_tab
    ___EventL1LoggedMDTConfig_iE_Extensions__item__id._const_tab_at = None
    ___EventL1LoggedMDTConfig_iE_Extensions__item__id._const_tab_id = 'id'
    ___EventL1LoggedMDTConfig_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EventL1LoggedMDTConfig_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EventL1LoggedMDTConfig_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventL1LoggedMDTConfig_iE_Extensions__item__criticality._const_tab = ____EventL1LoggedMDTConfig_iE_Extensions__item__criticality_tab
    ___EventL1LoggedMDTConfig_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EventL1LoggedMDTConfig_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue._const_tab = ____EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue_tab
    ___EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EventL1LoggedMDTConfig_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EventL1LoggedMDTConfig_iE_Extensions__item__id),
        ('criticality', ___EventL1LoggedMDTConfig_iE_Extensions__item__criticality),
        ('extensionValue', ___EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue),
        ])
    __EventL1LoggedMDTConfig_iE_Extensions__item_._ext = None
    _EventL1LoggedMDTConfig_iE_Extensions._cont = __EventL1LoggedMDTConfig_iE_Extensions__item_
    _EventL1LoggedMDTConfig_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EventL1LoggedMDTConfig._cont = ASN1Dict([
        ('l1Threshold', _EventL1LoggedMDTConfig_l1Threshold),
        ('hysteresis', _EventL1LoggedMDTConfig_hysteresis),
        ('timeToTrigger', _EventL1LoggedMDTConfig_timeToTrigger),
        ('iE-Extensions', _EventL1LoggedMDTConfig_iE_Extensions),
        ])
    EventL1LoggedMDTConfig._ext = []
    
    #-----< EventL1LoggedMDTConfig-ExtIEs >-----#
    EventL1LoggedMDTConfig_ExtIEs = CLASS(name='EventL1LoggedMDTConfig-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EventL1LoggedMDTConfig_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MeasurementThresholdL1LoggedMDT >-----#
    MeasurementThresholdL1LoggedMDT = CHOICE(name='MeasurementThresholdL1LoggedMDT', mode=MODE_TYPE)
    _MeasurementThresholdL1LoggedMDT_threshold_RSRP = INT(name='threshold-RSRP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Threshold-RSRP')))
    _MeasurementThresholdL1LoggedMDT_threshold_RSRQ = INT(name='threshold-RSRQ', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Threshold-RSRQ')))
    _MeasurementThresholdL1LoggedMDT_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___MeasurementThresholdL1LoggedMDT_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MeasurementThresholdL1LoggedMDT_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_id._const_tab = ___MeasurementThresholdL1LoggedMDT_choice_Extensions_id_tab
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_id._const_tab_at = None
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_id._const_tab_id = 'id'
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality._const_tab = ___MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality_tab
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality._const_tab_id = 'criticality'
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___MeasurementThresholdL1LoggedMDT_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MeasurementThresholdL1LoggedMDT_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_value._const_tab = ___MeasurementThresholdL1LoggedMDT_choice_Extensions_value_tab
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_value._const_tab_at = ('..', 'id')
    __MeasurementThresholdL1LoggedMDT_choice_Extensions_value._const_tab_id = 'Value'
    _MeasurementThresholdL1LoggedMDT_choice_Extensions._cont = ASN1Dict([
        ('id', __MeasurementThresholdL1LoggedMDT_choice_Extensions_id),
        ('criticality', __MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality),
        ('value', __MeasurementThresholdL1LoggedMDT_choice_Extensions_value),
        ])
    _MeasurementThresholdL1LoggedMDT_choice_Extensions._ext = None
    MeasurementThresholdL1LoggedMDT._cont = ASN1Dict([
        ('threshold-RSRP', _MeasurementThresholdL1LoggedMDT_threshold_RSRP),
        ('threshold-RSRQ', _MeasurementThresholdL1LoggedMDT_threshold_RSRQ),
        ('choice-Extensions', _MeasurementThresholdL1LoggedMDT_choice_Extensions),
        ])
    MeasurementThresholdL1LoggedMDT._ext = None
    
    #-----< MeasurementThresholdL1LoggedMDT-ExtIEs >-----#
    MeasurementThresholdL1LoggedMDT_ExtIEs = CLASS(name='MeasurementThresholdL1LoggedMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    MeasurementThresholdL1LoggedMDT_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FailureIndication >-----#
    FailureIndication = SEQ(name='FailureIndication', mode=MODE_TYPE)
    _FailureIndication_uERLFReportContainer = CHOICE(name='uERLFReportContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UERLFReportContainer')))
    _FailureIndication_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FailureIndication_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___FailureIndication_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____FailureIndication_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FailureIndication_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FailureIndication_iE_Extensions__item__id._const_tab = ____FailureIndication_iE_Extensions__item__id_tab
    ___FailureIndication_iE_Extensions__item__id._const_tab_at = None
    ___FailureIndication_iE_Extensions__item__id._const_tab_id = 'id'
    ___FailureIndication_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FailureIndication_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FailureIndication_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FailureIndication_iE_Extensions__item__criticality._const_tab = ____FailureIndication_iE_Extensions__item__criticality_tab
    ___FailureIndication_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FailureIndication_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FailureIndication_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FailureIndication_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FailureIndication_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FailureIndication_iE_Extensions__item__extensionValue._const_tab = ____FailureIndication_iE_Extensions__item__extensionValue_tab
    ___FailureIndication_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FailureIndication_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FailureIndication_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FailureIndication_iE_Extensions__item__id),
        ('criticality', ___FailureIndication_iE_Extensions__item__criticality),
        ('extensionValue', ___FailureIndication_iE_Extensions__item__extensionValue),
        ])
    __FailureIndication_iE_Extensions__item_._ext = None
    _FailureIndication_iE_Extensions._cont = __FailureIndication_iE_Extensions__item_
    _FailureIndication_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FailureIndication._cont = ASN1Dict([
        ('uERLFReportContainer', _FailureIndication_uERLFReportContainer),
        ('iE-Extensions', _FailureIndication_iE_Extensions),
        ])
    FailureIndication._ext = []
    
    #-----< FailureIndication-ExtIEs >-----#
    FailureIndication_ExtIEs = CLASS(name='FailureIndication-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    FailureIndication_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FiveG-ProSeAuthorized >-----#
    FiveG_ProSeAuthorized = SEQ(name='FiveG-ProSeAuthorized', mode=MODE_TYPE)
    _FiveG_ProSeAuthorized_fiveGProSeDirectDiscovery = ENUM(name='fiveGProSeDirectDiscovery', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FiveGProSeDirectDiscovery')), opt=True)
    _FiveG_ProSeAuthorized_fiveGProSeDirectCommunication = ENUM(name='fiveGProSeDirectCommunication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FiveGProSeDirectCommunication')), opt=True)
    _FiveG_ProSeAuthorized_fiveGProSeLayer2UEtoNetworkRelay = ENUM(name='fiveGProSeLayer2UEtoNetworkRelay', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FiveGProSeLayer2UEtoNetworkRelay')), opt=True)
    _FiveG_ProSeAuthorized_fiveGProSeLayer3UEtoNetworkRelay = ENUM(name='fiveGProSeLayer3UEtoNetworkRelay', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FiveGProSeLayer3UEtoNetworkRelay')), opt=True)
    _FiveG_ProSeAuthorized_fiveGProSeLayer2RemoteUE = ENUM(name='fiveGProSeLayer2RemoteUE', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FiveGProSeLayer2RemoteUE')), opt=True)
    _FiveG_ProSeAuthorized_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FiveG_ProSeAuthorized_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___FiveG_ProSeAuthorized_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____FiveG_ProSeAuthorized_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FiveG_ProSeAuthorized_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveG_ProSeAuthorized_iE_Extensions__item__id._const_tab = ____FiveG_ProSeAuthorized_iE_Extensions__item__id_tab
    ___FiveG_ProSeAuthorized_iE_Extensions__item__id._const_tab_at = None
    ___FiveG_ProSeAuthorized_iE_Extensions__item__id._const_tab_id = 'id'
    ___FiveG_ProSeAuthorized_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FiveG_ProSeAuthorized_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FiveG_ProSeAuthorized_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveG_ProSeAuthorized_iE_Extensions__item__criticality._const_tab = ____FiveG_ProSeAuthorized_iE_Extensions__item__criticality_tab
    ___FiveG_ProSeAuthorized_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FiveG_ProSeAuthorized_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FiveG_ProSeAuthorized_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FiveG_ProSeAuthorized_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FiveG_ProSeAuthorized_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveG_ProSeAuthorized_iE_Extensions__item__extensionValue._const_tab = ____FiveG_ProSeAuthorized_iE_Extensions__item__extensionValue_tab
    ___FiveG_ProSeAuthorized_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FiveG_ProSeAuthorized_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FiveG_ProSeAuthorized_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FiveG_ProSeAuthorized_iE_Extensions__item__id),
        ('criticality', ___FiveG_ProSeAuthorized_iE_Extensions__item__criticality),
        ('extensionValue', ___FiveG_ProSeAuthorized_iE_Extensions__item__extensionValue),
        ])
    __FiveG_ProSeAuthorized_iE_Extensions__item_._ext = None
    _FiveG_ProSeAuthorized_iE_Extensions._cont = __FiveG_ProSeAuthorized_iE_Extensions__item_
    _FiveG_ProSeAuthorized_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FiveG_ProSeAuthorized._cont = ASN1Dict([
        ('fiveGProSeDirectDiscovery', _FiveG_ProSeAuthorized_fiveGProSeDirectDiscovery),
        ('fiveGProSeDirectCommunication', _FiveG_ProSeAuthorized_fiveGProSeDirectCommunication),
        ('fiveGProSeLayer2UEtoNetworkRelay', _FiveG_ProSeAuthorized_fiveGProSeLayer2UEtoNetworkRelay),
        ('fiveGProSeLayer3UEtoNetworkRelay', _FiveG_ProSeAuthorized_fiveGProSeLayer3UEtoNetworkRelay),
        ('fiveGProSeLayer2RemoteUE', _FiveG_ProSeAuthorized_fiveGProSeLayer2RemoteUE),
        ('iE-Extensions', _FiveG_ProSeAuthorized_iE_Extensions),
        ])
    FiveG_ProSeAuthorized._ext = []
    
    #-----< FiveG-ProSeAuthorized-ExtIEs >-----#
    FiveG_ProSeAuthorized_ExtIEs = CLASS(name='FiveG-ProSeAuthorized-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    FiveG_ProSeAuthorized_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FiveGProSeDirectDiscovery >-----#
    FiveGProSeDirectDiscovery = ENUM(name='FiveGProSeDirectDiscovery', mode=MODE_TYPE)
    FiveGProSeDirectDiscovery._cont = ASN1Dict([('authorized', 0), ('not-authorized', 1)])
    FiveGProSeDirectDiscovery._ext = []
    
    #-----< FiveGProSeDirectCommunication >-----#
    FiveGProSeDirectCommunication = ENUM(name='FiveGProSeDirectCommunication', mode=MODE_TYPE)
    FiveGProSeDirectCommunication._cont = ASN1Dict([('authorized', 0), ('not-authorized', 1)])
    FiveGProSeDirectCommunication._ext = []
    
    #-----< FiveGProSeLayer2UEtoNetworkRelay >-----#
    FiveGProSeLayer2UEtoNetworkRelay = ENUM(name='FiveGProSeLayer2UEtoNetworkRelay', mode=MODE_TYPE)
    FiveGProSeLayer2UEtoNetworkRelay._cont = ASN1Dict([('authorized', 0), ('not-authorized', 1)])
    FiveGProSeLayer2UEtoNetworkRelay._ext = []
    
    #-----< FiveGProSeLayer3UEtoNetworkRelay >-----#
    FiveGProSeLayer3UEtoNetworkRelay = ENUM(name='FiveGProSeLayer3UEtoNetworkRelay', mode=MODE_TYPE)
    FiveGProSeLayer3UEtoNetworkRelay._cont = ASN1Dict([('authorized', 0), ('not-authorized', 1)])
    FiveGProSeLayer3UEtoNetworkRelay._ext = []
    
    #-----< FiveGProSeLayer2RemoteUE >-----#
    FiveGProSeLayer2RemoteUE = ENUM(name='FiveGProSeLayer2RemoteUE', mode=MODE_TYPE)
    FiveGProSeLayer2RemoteUE._cont = ASN1Dict([('authorized', 0), ('not-authorized', 1)])
    FiveGProSeLayer2RemoteUE._ext = []
    
    #-----< FiveG-ProSePC5QoSParameters >-----#
    FiveG_ProSePC5QoSParameters = SEQ(name='FiveG-ProSePC5QoSParameters', mode=MODE_TYPE)
    _FiveG_ProSePC5QoSParameters_fiveGProSepc5QoSFlowList = SEQ_OF(name='fiveGProSepc5QoSFlowList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FiveGProSePC5QoSFlowList')))
    _FiveG_ProSePC5QoSParameters_fiveGProSepc5LinkAggregateBitRates = INT(name='fiveGProSepc5LinkAggregateBitRates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')), opt=True)
    _FiveG_ProSePC5QoSParameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FiveG_ProSePC5QoSParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___FiveG_ProSePC5QoSParameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____FiveG_ProSePC5QoSParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FiveG_ProSePC5QoSParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveG_ProSePC5QoSParameters_iE_Extensions__item__id._const_tab = ____FiveG_ProSePC5QoSParameters_iE_Extensions__item__id_tab
    ___FiveG_ProSePC5QoSParameters_iE_Extensions__item__id._const_tab_at = None
    ___FiveG_ProSePC5QoSParameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___FiveG_ProSePC5QoSParameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FiveG_ProSePC5QoSParameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FiveG_ProSePC5QoSParameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveG_ProSePC5QoSParameters_iE_Extensions__item__criticality._const_tab = ____FiveG_ProSePC5QoSParameters_iE_Extensions__item__criticality_tab
    ___FiveG_ProSePC5QoSParameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FiveG_ProSePC5QoSParameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FiveG_ProSePC5QoSParameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FiveG_ProSePC5QoSParameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FiveG_ProSePC5QoSParameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveG_ProSePC5QoSParameters_iE_Extensions__item__extensionValue._const_tab = ____FiveG_ProSePC5QoSParameters_iE_Extensions__item__extensionValue_tab
    ___FiveG_ProSePC5QoSParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FiveG_ProSePC5QoSParameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FiveG_ProSePC5QoSParameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FiveG_ProSePC5QoSParameters_iE_Extensions__item__id),
        ('criticality', ___FiveG_ProSePC5QoSParameters_iE_Extensions__item__criticality),
        ('extensionValue', ___FiveG_ProSePC5QoSParameters_iE_Extensions__item__extensionValue),
        ])
    __FiveG_ProSePC5QoSParameters_iE_Extensions__item_._ext = None
    _FiveG_ProSePC5QoSParameters_iE_Extensions._cont = __FiveG_ProSePC5QoSParameters_iE_Extensions__item_
    _FiveG_ProSePC5QoSParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FiveG_ProSePC5QoSParameters._cont = ASN1Dict([
        ('fiveGProSepc5QoSFlowList', _FiveG_ProSePC5QoSParameters_fiveGProSepc5QoSFlowList),
        ('fiveGProSepc5LinkAggregateBitRates', _FiveG_ProSePC5QoSParameters_fiveGProSepc5LinkAggregateBitRates),
        ('iE-Extensions', _FiveG_ProSePC5QoSParameters_iE_Extensions),
        ])
    FiveG_ProSePC5QoSParameters._ext = []
    
    #-----< FiveG-ProSePC5QoSParameters-ExtIEs >-----#
    FiveG_ProSePC5QoSParameters_ExtIEs = CLASS(name='FiveG-ProSePC5QoSParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    FiveG_ProSePC5QoSParameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FiveGProSePC5QoSFlowList >-----#
    FiveGProSePC5QoSFlowList = SEQ_OF(name='FiveGProSePC5QoSFlowList', mode=MODE_TYPE)
    _FiveGProSePC5QoSFlowList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveGProSePC5QoSFlowItem')))
    FiveGProSePC5QoSFlowList._cont = _FiveGProSePC5QoSFlowList__item_
    FiveGProSePC5QoSFlowList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    
    #-----< FiveGProSePC5QoSFlowItem >-----#
    FiveGProSePC5QoSFlowItem = SEQ(name='FiveGProSePC5QoSFlowItem', mode=MODE_TYPE)
    _FiveGProSePC5QoSFlowItem_fiveGproSepQI = INT(name='fiveGproSepQI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FiveQI')))
    _FiveGProSePC5QoSFlowItem_fiveGproSepc5FlowBitRates = SEQ(name='fiveGproSepc5FlowBitRates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FiveGProSePC5FlowBitRates')), opt=True)
    _FiveGProSePC5QoSFlowItem_fiveGproSerange = ENUM(name='fiveGproSerange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Range')), opt=True)
    _FiveGProSePC5QoSFlowItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FiveGProSePC5QoSFlowItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___FiveGProSePC5QoSFlowItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____FiveGProSePC5QoSFlowItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FiveGProSePC5QoSFlowItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveGProSePC5QoSFlowItem_iE_Extensions__item__id._const_tab = ____FiveGProSePC5QoSFlowItem_iE_Extensions__item__id_tab
    ___FiveGProSePC5QoSFlowItem_iE_Extensions__item__id._const_tab_at = None
    ___FiveGProSePC5QoSFlowItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___FiveGProSePC5QoSFlowItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FiveGProSePC5QoSFlowItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FiveGProSePC5QoSFlowItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveGProSePC5QoSFlowItem_iE_Extensions__item__criticality._const_tab = ____FiveGProSePC5QoSFlowItem_iE_Extensions__item__criticality_tab
    ___FiveGProSePC5QoSFlowItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FiveGProSePC5QoSFlowItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FiveGProSePC5QoSFlowItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FiveGProSePC5QoSFlowItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FiveGProSePC5QoSFlowItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveGProSePC5QoSFlowItem_iE_Extensions__item__extensionValue._const_tab = ____FiveGProSePC5QoSFlowItem_iE_Extensions__item__extensionValue_tab
    ___FiveGProSePC5QoSFlowItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FiveGProSePC5QoSFlowItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FiveGProSePC5QoSFlowItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FiveGProSePC5QoSFlowItem_iE_Extensions__item__id),
        ('criticality', ___FiveGProSePC5QoSFlowItem_iE_Extensions__item__criticality),
        ('extensionValue', ___FiveGProSePC5QoSFlowItem_iE_Extensions__item__extensionValue),
        ])
    __FiveGProSePC5QoSFlowItem_iE_Extensions__item_._ext = None
    _FiveGProSePC5QoSFlowItem_iE_Extensions._cont = __FiveGProSePC5QoSFlowItem_iE_Extensions__item_
    _FiveGProSePC5QoSFlowItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FiveGProSePC5QoSFlowItem._cont = ASN1Dict([
        ('fiveGproSepQI', _FiveGProSePC5QoSFlowItem_fiveGproSepQI),
        ('fiveGproSepc5FlowBitRates', _FiveGProSePC5QoSFlowItem_fiveGproSepc5FlowBitRates),
        ('fiveGproSerange', _FiveGProSePC5QoSFlowItem_fiveGproSerange),
        ('iE-Extensions', _FiveGProSePC5QoSFlowItem_iE_Extensions),
        ])
    FiveGProSePC5QoSFlowItem._ext = []
    
    #-----< FiveGProSePC5QoSFlowItem-ExtIEs >-----#
    FiveGProSePC5QoSFlowItem_ExtIEs = CLASS(name='FiveGProSePC5QoSFlowItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    FiveGProSePC5QoSFlowItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FiveGProSePC5FlowBitRates >-----#
    FiveGProSePC5FlowBitRates = SEQ(name='FiveGProSePC5FlowBitRates', mode=MODE_TYPE)
    _FiveGProSePC5FlowBitRates_fiveGproSeguaranteedFlowBitRate = INT(name='fiveGproSeguaranteedFlowBitRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _FiveGProSePC5FlowBitRates_fiveGproSemaximumFlowBitRate = INT(name='fiveGproSemaximumFlowBitRate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _FiveGProSePC5FlowBitRates_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FiveGProSePC5FlowBitRates_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___FiveGProSePC5FlowBitRates_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____FiveGProSePC5FlowBitRates_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FiveGProSePC5FlowBitRates_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveGProSePC5FlowBitRates_iE_Extensions__item__id._const_tab = ____FiveGProSePC5FlowBitRates_iE_Extensions__item__id_tab
    ___FiveGProSePC5FlowBitRates_iE_Extensions__item__id._const_tab_at = None
    ___FiveGProSePC5FlowBitRates_iE_Extensions__item__id._const_tab_id = 'id'
    ___FiveGProSePC5FlowBitRates_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FiveGProSePC5FlowBitRates_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FiveGProSePC5FlowBitRates_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveGProSePC5FlowBitRates_iE_Extensions__item__criticality._const_tab = ____FiveGProSePC5FlowBitRates_iE_Extensions__item__criticality_tab
    ___FiveGProSePC5FlowBitRates_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FiveGProSePC5FlowBitRates_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FiveGProSePC5FlowBitRates_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FiveGProSePC5FlowBitRates_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FiveGProSePC5FlowBitRates_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveGProSePC5FlowBitRates_iE_Extensions__item__extensionValue._const_tab = ____FiveGProSePC5FlowBitRates_iE_Extensions__item__extensionValue_tab
    ___FiveGProSePC5FlowBitRates_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FiveGProSePC5FlowBitRates_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FiveGProSePC5FlowBitRates_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FiveGProSePC5FlowBitRates_iE_Extensions__item__id),
        ('criticality', ___FiveGProSePC5FlowBitRates_iE_Extensions__item__criticality),
        ('extensionValue', ___FiveGProSePC5FlowBitRates_iE_Extensions__item__extensionValue),
        ])
    __FiveGProSePC5FlowBitRates_iE_Extensions__item_._ext = None
    _FiveGProSePC5FlowBitRates_iE_Extensions._cont = __FiveGProSePC5FlowBitRates_iE_Extensions__item_
    _FiveGProSePC5FlowBitRates_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FiveGProSePC5FlowBitRates._cont = ASN1Dict([
        ('fiveGproSeguaranteedFlowBitRate', _FiveGProSePC5FlowBitRates_fiveGproSeguaranteedFlowBitRate),
        ('fiveGproSemaximumFlowBitRate', _FiveGProSePC5FlowBitRates_fiveGproSemaximumFlowBitRate),
        ('iE-Extensions', _FiveGProSePC5FlowBitRates_iE_Extensions),
        ])
    FiveGProSePC5FlowBitRates._ext = []
    
    #-----< FiveGProSePC5FlowBitRates-ExtIEs >-----#
    FiveGProSePC5FlowBitRates_ExtIEs = CLASS(name='FiveGProSePC5FlowBitRates-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    FiveGProSePC5FlowBitRates_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FiveG-S-TMSI >-----#
    FiveG_S_TMSI = SEQ(name='FiveG-S-TMSI', mode=MODE_TYPE)
    _FiveG_S_TMSI_aMFSetID = BIT_STR(name='aMFSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AMFSetID')))
    _FiveG_S_TMSI_aMFPointer = BIT_STR(name='aMFPointer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AMFPointer')))
    _FiveG_S_TMSI_fiveG_TMSI = OCT_STR(name='fiveG-TMSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FiveG-TMSI')))
    _FiveG_S_TMSI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FiveG_S_TMSI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___FiveG_S_TMSI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____FiveG_S_TMSI_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FiveG_S_TMSI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveG_S_TMSI_iE_Extensions__item__id._const_tab = ____FiveG_S_TMSI_iE_Extensions__item__id_tab
    ___FiveG_S_TMSI_iE_Extensions__item__id._const_tab_at = None
    ___FiveG_S_TMSI_iE_Extensions__item__id._const_tab_id = 'id'
    ___FiveG_S_TMSI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FiveG_S_TMSI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FiveG_S_TMSI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveG_S_TMSI_iE_Extensions__item__criticality._const_tab = ____FiveG_S_TMSI_iE_Extensions__item__criticality_tab
    ___FiveG_S_TMSI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FiveG_S_TMSI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FiveG_S_TMSI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FiveG_S_TMSI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FiveG_S_TMSI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveG_S_TMSI_iE_Extensions__item__extensionValue._const_tab = ____FiveG_S_TMSI_iE_Extensions__item__extensionValue_tab
    ___FiveG_S_TMSI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FiveG_S_TMSI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FiveG_S_TMSI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FiveG_S_TMSI_iE_Extensions__item__id),
        ('criticality', ___FiveG_S_TMSI_iE_Extensions__item__criticality),
        ('extensionValue', ___FiveG_S_TMSI_iE_Extensions__item__extensionValue),
        ])
    __FiveG_S_TMSI_iE_Extensions__item_._ext = None
    _FiveG_S_TMSI_iE_Extensions._cont = __FiveG_S_TMSI_iE_Extensions__item_
    _FiveG_S_TMSI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FiveG_S_TMSI._cont = ASN1Dict([
        ('aMFSetID', _FiveG_S_TMSI_aMFSetID),
        ('aMFPointer', _FiveG_S_TMSI_aMFPointer),
        ('fiveG-TMSI', _FiveG_S_TMSI_fiveG_TMSI),
        ('iE-Extensions', _FiveG_S_TMSI_iE_Extensions),
        ])
    FiveG_S_TMSI._ext = []
    
    #-----< FiveG-S-TMSI-ExtIEs >-----#
    FiveG_S_TMSI_ExtIEs = CLASS(name='FiveG-S-TMSI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    FiveG_S_TMSI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FiveG-TMSI >-----#
    FiveG_TMSI = OCT_STR(name='FiveG-TMSI', mode=MODE_TYPE)
    FiveG_TMSI._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< FiveQI >-----#
    FiveQI = INT(name='FiveQI', mode=MODE_TYPE)
    FiveQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< ForbiddenAreaInformation >-----#
    ForbiddenAreaInformation = SEQ_OF(name='ForbiddenAreaInformation', mode=MODE_TYPE)
    _ForbiddenAreaInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ForbiddenAreaInformation-Item')))
    ForbiddenAreaInformation._cont = _ForbiddenAreaInformation__item_
    ForbiddenAreaInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< ForbiddenAreaInformation-Item >-----#
    ForbiddenAreaInformation_Item = SEQ(name='ForbiddenAreaInformation-Item', mode=MODE_TYPE)
    _ForbiddenAreaInformation_Item_pLMNIdentity = OCT_STR(name='pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _ForbiddenAreaInformation_Item_forbiddenTACs = SEQ_OF(name='forbiddenTACs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ForbiddenTACs')))
    _ForbiddenAreaInformation_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ForbiddenAreaInformation_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___ForbiddenAreaInformation_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____ForbiddenAreaInformation_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ForbiddenAreaInformation_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ForbiddenAreaInformation_Item_iE_Extensions__item__id._const_tab = ____ForbiddenAreaInformation_Item_iE_Extensions__item__id_tab
    ___ForbiddenAreaInformation_Item_iE_Extensions__item__id._const_tab_at = None
    ___ForbiddenAreaInformation_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ForbiddenAreaInformation_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ForbiddenAreaInformation_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ForbiddenAreaInformation_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ForbiddenAreaInformation_Item_iE_Extensions__item__criticality._const_tab = ____ForbiddenAreaInformation_Item_iE_Extensions__item__criticality_tab
    ___ForbiddenAreaInformation_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ForbiddenAreaInformation_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ForbiddenAreaInformation_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ForbiddenAreaInformation_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ForbiddenAreaInformation_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ForbiddenAreaInformation_Item_iE_Extensions__item__extensionValue._const_tab = ____ForbiddenAreaInformation_Item_iE_Extensions__item__extensionValue_tab
    ___ForbiddenAreaInformation_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ForbiddenAreaInformation_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ForbiddenAreaInformation_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ForbiddenAreaInformation_Item_iE_Extensions__item__id),
        ('criticality', ___ForbiddenAreaInformation_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ForbiddenAreaInformation_Item_iE_Extensions__item__extensionValue),
        ])
    __ForbiddenAreaInformation_Item_iE_Extensions__item_._ext = None
    _ForbiddenAreaInformation_Item_iE_Extensions._cont = __ForbiddenAreaInformation_Item_iE_Extensions__item_
    _ForbiddenAreaInformation_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ForbiddenAreaInformation_Item._cont = ASN1Dict([
        ('pLMNIdentity', _ForbiddenAreaInformation_Item_pLMNIdentity),
        ('forbiddenTACs', _ForbiddenAreaInformation_Item_forbiddenTACs),
        ('iE-Extensions', _ForbiddenAreaInformation_Item_iE_Extensions),
        ])
    ForbiddenAreaInformation_Item._ext = []
    
    #-----< ForbiddenAreaInformation-Item-ExtIEs >-----#
    ForbiddenAreaInformation_Item_ExtIEs = CLASS(name='ForbiddenAreaInformation-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ForbiddenAreaInformation_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ForbiddenTACs >-----#
    ForbiddenTACs = SEQ_OF(name='ForbiddenTACs', mode=MODE_TYPE)
    _ForbiddenTACs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAC')))
    ForbiddenTACs._cont = _ForbiddenTACs__item_
    ForbiddenTACs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4096)], ev=None, er=[])
    
    #-----< FromEUTRANtoNGRAN >-----#
    FromEUTRANtoNGRAN = SEQ(name='FromEUTRANtoNGRAN', mode=MODE_TYPE)
    _FromEUTRANtoNGRAN_sourceeNBID = SEQ(name='sourceeNBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntersystemSONeNBID')))
    _FromEUTRANtoNGRAN_targetNGRANnodeID = SEQ(name='targetNGRANnodeID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntersystemSONNGRANnodeID')))
    _FromEUTRANtoNGRAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FromEUTRANtoNGRAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___FromEUTRANtoNGRAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____FromEUTRANtoNGRAN_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FromEUTRANtoNGRAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FromEUTRANtoNGRAN_iE_Extensions__item__id._const_tab = ____FromEUTRANtoNGRAN_iE_Extensions__item__id_tab
    ___FromEUTRANtoNGRAN_iE_Extensions__item__id._const_tab_at = None
    ___FromEUTRANtoNGRAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___FromEUTRANtoNGRAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FromEUTRANtoNGRAN_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FromEUTRANtoNGRAN_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FromEUTRANtoNGRAN_iE_Extensions__item__criticality._const_tab = ____FromEUTRANtoNGRAN_iE_Extensions__item__criticality_tab
    ___FromEUTRANtoNGRAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FromEUTRANtoNGRAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FromEUTRANtoNGRAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FromEUTRANtoNGRAN_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FromEUTRANtoNGRAN_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FromEUTRANtoNGRAN_iE_Extensions__item__extensionValue._const_tab = ____FromEUTRANtoNGRAN_iE_Extensions__item__extensionValue_tab
    ___FromEUTRANtoNGRAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FromEUTRANtoNGRAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FromEUTRANtoNGRAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FromEUTRANtoNGRAN_iE_Extensions__item__id),
        ('criticality', ___FromEUTRANtoNGRAN_iE_Extensions__item__criticality),
        ('extensionValue', ___FromEUTRANtoNGRAN_iE_Extensions__item__extensionValue),
        ])
    __FromEUTRANtoNGRAN_iE_Extensions__item_._ext = None
    _FromEUTRANtoNGRAN_iE_Extensions._cont = __FromEUTRANtoNGRAN_iE_Extensions__item_
    _FromEUTRANtoNGRAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FromEUTRANtoNGRAN._cont = ASN1Dict([
        ('sourceeNBID', _FromEUTRANtoNGRAN_sourceeNBID),
        ('targetNGRANnodeID', _FromEUTRANtoNGRAN_targetNGRANnodeID),
        ('iE-Extensions', _FromEUTRANtoNGRAN_iE_Extensions),
        ])
    FromEUTRANtoNGRAN._ext = None
    
    #-----< FromEUTRANtoNGRAN-ExtIEs >-----#
    FromEUTRANtoNGRAN_ExtIEs = CLASS(name='FromEUTRANtoNGRAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    FromEUTRANtoNGRAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FromNGRANtoEUTRAN >-----#
    FromNGRANtoEUTRAN = SEQ(name='FromNGRANtoEUTRAN', mode=MODE_TYPE)
    _FromNGRANtoEUTRAN_sourceNGRANnodeID = SEQ(name='sourceNGRANnodeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntersystemSONNGRANnodeID')))
    _FromNGRANtoEUTRAN_targeteNBID = SEQ(name='targeteNBID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntersystemSONeNBID')))
    _FromNGRANtoEUTRAN_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FromNGRANtoEUTRAN_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___FromNGRANtoEUTRAN_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____FromNGRANtoEUTRAN_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FromNGRANtoEUTRAN_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FromNGRANtoEUTRAN_iE_Extensions__item__id._const_tab = ____FromNGRANtoEUTRAN_iE_Extensions__item__id_tab
    ___FromNGRANtoEUTRAN_iE_Extensions__item__id._const_tab_at = None
    ___FromNGRANtoEUTRAN_iE_Extensions__item__id._const_tab_id = 'id'
    ___FromNGRANtoEUTRAN_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FromNGRANtoEUTRAN_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FromNGRANtoEUTRAN_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FromNGRANtoEUTRAN_iE_Extensions__item__criticality._const_tab = ____FromNGRANtoEUTRAN_iE_Extensions__item__criticality_tab
    ___FromNGRANtoEUTRAN_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FromNGRANtoEUTRAN_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FromNGRANtoEUTRAN_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FromNGRANtoEUTRAN_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____FromNGRANtoEUTRAN_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FromNGRANtoEUTRAN_iE_Extensions__item__extensionValue._const_tab = ____FromNGRANtoEUTRAN_iE_Extensions__item__extensionValue_tab
    ___FromNGRANtoEUTRAN_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FromNGRANtoEUTRAN_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FromNGRANtoEUTRAN_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FromNGRANtoEUTRAN_iE_Extensions__item__id),
        ('criticality', ___FromNGRANtoEUTRAN_iE_Extensions__item__criticality),
        ('extensionValue', ___FromNGRANtoEUTRAN_iE_Extensions__item__extensionValue),
        ])
    __FromNGRANtoEUTRAN_iE_Extensions__item_._ext = None
    _FromNGRANtoEUTRAN_iE_Extensions._cont = __FromNGRANtoEUTRAN_iE_Extensions__item_
    _FromNGRANtoEUTRAN_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FromNGRANtoEUTRAN._cont = ASN1Dict([
        ('sourceNGRANnodeID', _FromNGRANtoEUTRAN_sourceNGRANnodeID),
        ('targeteNBID', _FromNGRANtoEUTRAN_targeteNBID),
        ('iE-Extensions', _FromNGRANtoEUTRAN_iE_Extensions),
        ])
    FromNGRANtoEUTRAN._ext = None
    
    #-----< FromNGRANtoEUTRAN-ExtIEs >-----#
    FromNGRANtoEUTRAN_ExtIEs = CLASS(name='FromNGRANtoEUTRAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    FromNGRANtoEUTRAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GBR-QosInformation >-----#
    GBR_QosInformation = SEQ(name='GBR-QosInformation', mode=MODE_TYPE)
    _GBR_QosInformation_maximumFlowBitRateDL = INT(name='maximumFlowBitRateDL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _GBR_QosInformation_maximumFlowBitRateUL = INT(name='maximumFlowBitRateUL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _GBR_QosInformation_guaranteedFlowBitRateDL = INT(name='guaranteedFlowBitRateDL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _GBR_QosInformation_guaranteedFlowBitRateUL = INT(name='guaranteedFlowBitRateUL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _GBR_QosInformation_notificationControl = ENUM(name='notificationControl', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NotificationControl')), opt=True)
    _GBR_QosInformation_maximumPacketLossRateDL = INT(name='maximumPacketLossRateDL', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PacketLossRate')), opt=True)
    _GBR_QosInformation_maximumPacketLossRateUL = INT(name='maximumPacketLossRateUL', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PacketLossRate')), opt=True)
    _GBR_QosInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GBR_QosInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___GBR_QosInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____GBR_QosInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetList')))
    ____GBR_QosInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 220), ('criticality', 'ignore'), ('Extension', _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab = ____GBR_QosInformation_iE_Extensions__item__id_tab
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab_at = None
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___GBR_QosInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab = ____GBR_QosInformation_iE_Extensions__item__id_tab
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GBR_QosInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab = ____GBR_QosInformation_iE_Extensions__item__id_tab
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GBR_QosInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GBR_QosInformation_iE_Extensions__item__id),
        ('criticality', ___GBR_QosInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___GBR_QosInformation_iE_Extensions__item__extensionValue),
        ])
    __GBR_QosInformation_iE_Extensions__item_._ext = None
    _GBR_QosInformation_iE_Extensions._cont = __GBR_QosInformation_iE_Extensions__item_
    _GBR_QosInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GBR_QosInformation._cont = ASN1Dict([
        ('maximumFlowBitRateDL', _GBR_QosInformation_maximumFlowBitRateDL),
        ('maximumFlowBitRateUL', _GBR_QosInformation_maximumFlowBitRateUL),
        ('guaranteedFlowBitRateDL', _GBR_QosInformation_guaranteedFlowBitRateDL),
        ('guaranteedFlowBitRateUL', _GBR_QosInformation_guaranteedFlowBitRateUL),
        ('notificationControl', _GBR_QosInformation_notificationControl),
        ('maximumPacketLossRateDL', _GBR_QosInformation_maximumPacketLossRateDL),
        ('maximumPacketLossRateUL', _GBR_QosInformation_maximumPacketLossRateUL),
        ('iE-Extensions', _GBR_QosInformation_iE_Extensions),
        ])
    GBR_QosInformation._ext = []
    
    #-----< GBR-QosInformation-ExtIEs >-----#
    GBR_QosInformation_ExtIEs = CLASS(name='GBR-QosInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _GBR_QosInformation_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetList')))
    GBR_QosInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 220), ('criticality', 'ignore'), ('Extension', _GBR_QosInformation_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GlobalCable-ID >-----#
    GlobalCable_ID = OCT_STR(name='GlobalCable-ID', mode=MODE_TYPE)
    
    #-----< GlobalCable-ID-new >-----#
    GlobalCable_ID_new = SEQ(name='GlobalCable-ID-new', mode=MODE_TYPE)
    _GlobalCable_ID_new_globalCable_ID = OCT_STR(name='globalCable-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalCable-ID')))
    _GlobalCable_ID_new_tAI = SEQ(name='tAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _GlobalCable_ID_new_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GlobalCable_ID_new_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___GlobalCable_ID_new_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____GlobalCable_ID_new_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalCable_ID_new_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalCable_ID_new_iE_Extensions__item__id._const_tab = ____GlobalCable_ID_new_iE_Extensions__item__id_tab
    ___GlobalCable_ID_new_iE_Extensions__item__id._const_tab_at = None
    ___GlobalCable_ID_new_iE_Extensions__item__id._const_tab_id = 'id'
    ___GlobalCable_ID_new_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GlobalCable_ID_new_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalCable_ID_new_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalCable_ID_new_iE_Extensions__item__criticality._const_tab = ____GlobalCable_ID_new_iE_Extensions__item__criticality_tab
    ___GlobalCable_ID_new_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GlobalCable_ID_new_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GlobalCable_ID_new_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GlobalCable_ID_new_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalCable_ID_new_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalCable_ID_new_iE_Extensions__item__extensionValue._const_tab = ____GlobalCable_ID_new_iE_Extensions__item__extensionValue_tab
    ___GlobalCable_ID_new_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GlobalCable_ID_new_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GlobalCable_ID_new_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GlobalCable_ID_new_iE_Extensions__item__id),
        ('criticality', ___GlobalCable_ID_new_iE_Extensions__item__criticality),
        ('extensionValue', ___GlobalCable_ID_new_iE_Extensions__item__extensionValue),
        ])
    __GlobalCable_ID_new_iE_Extensions__item_._ext = None
    _GlobalCable_ID_new_iE_Extensions._cont = __GlobalCable_ID_new_iE_Extensions__item_
    _GlobalCable_ID_new_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GlobalCable_ID_new._cont = ASN1Dict([
        ('globalCable-ID', _GlobalCable_ID_new_globalCable_ID),
        ('tAI', _GlobalCable_ID_new_tAI),
        ('iE-Extensions', _GlobalCable_ID_new_iE_Extensions),
        ])
    GlobalCable_ID_new._ext = []
    
    #-----< GlobalCable-ID-new-ExtIEs >-----#
    GlobalCable_ID_new_ExtIEs = CLASS(name='GlobalCable-ID-new-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    GlobalCable_ID_new_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GlobalENB-ID >-----#
    GlobalENB_ID = SEQ(name='GlobalENB-ID', mode=MODE_TYPE)
    _GlobalENB_ID_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _GlobalENB_ID_eNB_ID = CHOICE(name='eNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ENB-ID')))
    _GlobalENB_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GlobalENB_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___GlobalENB_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____GlobalENB_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalENB_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalENB_ID_iE_Extensions__item__id._const_tab = ____GlobalENB_ID_iE_Extensions__item__id_tab
    ___GlobalENB_ID_iE_Extensions__item__id._const_tab_at = None
    ___GlobalENB_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___GlobalENB_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GlobalENB_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalENB_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalENB_ID_iE_Extensions__item__criticality._const_tab = ____GlobalENB_ID_iE_Extensions__item__criticality_tab
    ___GlobalENB_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GlobalENB_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GlobalENB_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GlobalENB_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalENB_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalENB_ID_iE_Extensions__item__extensionValue._const_tab = ____GlobalENB_ID_iE_Extensions__item__extensionValue_tab
    ___GlobalENB_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GlobalENB_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GlobalENB_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GlobalENB_ID_iE_Extensions__item__id),
        ('criticality', ___GlobalENB_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___GlobalENB_ID_iE_Extensions__item__extensionValue),
        ])
    __GlobalENB_ID_iE_Extensions__item_._ext = None
    _GlobalENB_ID_iE_Extensions._cont = __GlobalENB_ID_iE_Extensions__item_
    _GlobalENB_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GlobalENB_ID._cont = ASN1Dict([
        ('pLMNidentity', _GlobalENB_ID_pLMNidentity),
        ('eNB-ID', _GlobalENB_ID_eNB_ID),
        ('iE-Extensions', _GlobalENB_ID_iE_Extensions),
        ])
    GlobalENB_ID._ext = []
    
    #-----< GlobalENB-ID-ExtIEs >-----#
    GlobalENB_ID_ExtIEs = CLASS(name='GlobalENB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    GlobalENB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GlobalGNB-ID >-----#
    GlobalGNB_ID = SEQ(name='GlobalGNB-ID', mode=MODE_TYPE)
    _GlobalGNB_ID_pLMNIdentity = OCT_STR(name='pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _GlobalGNB_ID_gNB_ID = CHOICE(name='gNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GNB-ID')))
    _GlobalGNB_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GlobalGNB_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___GlobalGNB_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____GlobalGNB_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalGNB_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalGNB_ID_iE_Extensions__item__id._const_tab = ____GlobalGNB_ID_iE_Extensions__item__id_tab
    ___GlobalGNB_ID_iE_Extensions__item__id._const_tab_at = None
    ___GlobalGNB_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___GlobalGNB_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GlobalGNB_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalGNB_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalGNB_ID_iE_Extensions__item__criticality._const_tab = ____GlobalGNB_ID_iE_Extensions__item__criticality_tab
    ___GlobalGNB_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GlobalGNB_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GlobalGNB_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GlobalGNB_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalGNB_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalGNB_ID_iE_Extensions__item__extensionValue._const_tab = ____GlobalGNB_ID_iE_Extensions__item__extensionValue_tab
    ___GlobalGNB_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GlobalGNB_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GlobalGNB_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GlobalGNB_ID_iE_Extensions__item__id),
        ('criticality', ___GlobalGNB_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___GlobalGNB_ID_iE_Extensions__item__extensionValue),
        ])
    __GlobalGNB_ID_iE_Extensions__item_._ext = None
    _GlobalGNB_ID_iE_Extensions._cont = __GlobalGNB_ID_iE_Extensions__item_
    _GlobalGNB_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GlobalGNB_ID._cont = ASN1Dict([
        ('pLMNIdentity', _GlobalGNB_ID_pLMNIdentity),
        ('gNB-ID', _GlobalGNB_ID_gNB_ID),
        ('iE-Extensions', _GlobalGNB_ID_iE_Extensions),
        ])
    GlobalGNB_ID._ext = []
    
    #-----< GlobalGNB-ID-ExtIEs >-----#
    GlobalGNB_ID_ExtIEs = CLASS(name='GlobalGNB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    GlobalGNB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GlobalN3IWF-ID >-----#
    GlobalN3IWF_ID = SEQ(name='GlobalN3IWF-ID', mode=MODE_TYPE)
    _GlobalN3IWF_ID_pLMNIdentity = OCT_STR(name='pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _GlobalN3IWF_ID_n3IWF_ID = CHOICE(name='n3IWF-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'N3IWF-ID')))
    _GlobalN3IWF_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GlobalN3IWF_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___GlobalN3IWF_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____GlobalN3IWF_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalN3IWF_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalN3IWF_ID_iE_Extensions__item__id._const_tab = ____GlobalN3IWF_ID_iE_Extensions__item__id_tab
    ___GlobalN3IWF_ID_iE_Extensions__item__id._const_tab_at = None
    ___GlobalN3IWF_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___GlobalN3IWF_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GlobalN3IWF_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalN3IWF_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalN3IWF_ID_iE_Extensions__item__criticality._const_tab = ____GlobalN3IWF_ID_iE_Extensions__item__criticality_tab
    ___GlobalN3IWF_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GlobalN3IWF_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GlobalN3IWF_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GlobalN3IWF_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalN3IWF_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalN3IWF_ID_iE_Extensions__item__extensionValue._const_tab = ____GlobalN3IWF_ID_iE_Extensions__item__extensionValue_tab
    ___GlobalN3IWF_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GlobalN3IWF_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GlobalN3IWF_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GlobalN3IWF_ID_iE_Extensions__item__id),
        ('criticality', ___GlobalN3IWF_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___GlobalN3IWF_ID_iE_Extensions__item__extensionValue),
        ])
    __GlobalN3IWF_ID_iE_Extensions__item_._ext = None
    _GlobalN3IWF_ID_iE_Extensions._cont = __GlobalN3IWF_ID_iE_Extensions__item_
    _GlobalN3IWF_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GlobalN3IWF_ID._cont = ASN1Dict([
        ('pLMNIdentity', _GlobalN3IWF_ID_pLMNIdentity),
        ('n3IWF-ID', _GlobalN3IWF_ID_n3IWF_ID),
        ('iE-Extensions', _GlobalN3IWF_ID_iE_Extensions),
        ])
    GlobalN3IWF_ID._ext = []
    
    #-----< GlobalN3IWF-ID-ExtIEs >-----#
    GlobalN3IWF_ID_ExtIEs = CLASS(name='GlobalN3IWF-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    GlobalN3IWF_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GlobalLine-ID >-----#
    GlobalLine_ID = SEQ(name='GlobalLine-ID', mode=MODE_TYPE)
    _GlobalLine_ID_globalLineIdentity = OCT_STR(name='globalLineIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalLineIdentity')))
    _GlobalLine_ID_lineType = ENUM(name='lineType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LineType')), opt=True)
    _GlobalLine_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GlobalLine_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___GlobalLine_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____GlobalLine_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____GlobalLine_ID_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    ____GlobalLine_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 213), ('criticality', 'ignore'), ('Extension', _____GlobalLine_ID_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GlobalLine_ID_iE_Extensions__item__id._const_tab = ____GlobalLine_ID_iE_Extensions__item__id_tab
    ___GlobalLine_ID_iE_Extensions__item__id._const_tab_at = None
    ___GlobalLine_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___GlobalLine_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GlobalLine_ID_iE_Extensions__item__criticality._const_tab = ____GlobalLine_ID_iE_Extensions__item__id_tab
    ___GlobalLine_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GlobalLine_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GlobalLine_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GlobalLine_ID_iE_Extensions__item__extensionValue._const_tab = ____GlobalLine_ID_iE_Extensions__item__id_tab
    ___GlobalLine_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GlobalLine_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GlobalLine_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GlobalLine_ID_iE_Extensions__item__id),
        ('criticality', ___GlobalLine_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___GlobalLine_ID_iE_Extensions__item__extensionValue),
        ])
    __GlobalLine_ID_iE_Extensions__item_._ext = None
    _GlobalLine_ID_iE_Extensions._cont = __GlobalLine_ID_iE_Extensions__item_
    _GlobalLine_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GlobalLine_ID._cont = ASN1Dict([
        ('globalLineIdentity', _GlobalLine_ID_globalLineIdentity),
        ('lineType', _GlobalLine_ID_lineType),
        ('iE-Extensions', _GlobalLine_ID_iE_Extensions),
        ])
    GlobalLine_ID._ext = []
    
    #-----< GlobalLine-ID-ExtIEs >-----#
    GlobalLine_ID_ExtIEs = CLASS(name='GlobalLine-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _GlobalLine_ID_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    GlobalLine_ID_ExtIEs._val = ASN1Set(rv=[dict([('id', 213), ('criticality', 'ignore'), ('Extension', _GlobalLine_ID_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GlobalLineIdentity >-----#
    GlobalLineIdentity = OCT_STR(name='GlobalLineIdentity', mode=MODE_TYPE)
    
    #-----< GlobalNgENB-ID >-----#
    GlobalNgENB_ID = SEQ(name='GlobalNgENB-ID', mode=MODE_TYPE)
    _GlobalNgENB_ID_pLMNIdentity = OCT_STR(name='pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _GlobalNgENB_ID_ngENB_ID = CHOICE(name='ngENB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NgENB-ID')))
    _GlobalNgENB_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GlobalNgENB_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___GlobalNgENB_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____GlobalNgENB_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalNgENB_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalNgENB_ID_iE_Extensions__item__id._const_tab = ____GlobalNgENB_ID_iE_Extensions__item__id_tab
    ___GlobalNgENB_ID_iE_Extensions__item__id._const_tab_at = None
    ___GlobalNgENB_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___GlobalNgENB_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GlobalNgENB_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalNgENB_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalNgENB_ID_iE_Extensions__item__criticality._const_tab = ____GlobalNgENB_ID_iE_Extensions__item__criticality_tab
    ___GlobalNgENB_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GlobalNgENB_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GlobalNgENB_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GlobalNgENB_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalNgENB_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalNgENB_ID_iE_Extensions__item__extensionValue._const_tab = ____GlobalNgENB_ID_iE_Extensions__item__extensionValue_tab
    ___GlobalNgENB_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GlobalNgENB_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GlobalNgENB_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GlobalNgENB_ID_iE_Extensions__item__id),
        ('criticality', ___GlobalNgENB_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___GlobalNgENB_ID_iE_Extensions__item__extensionValue),
        ])
    __GlobalNgENB_ID_iE_Extensions__item_._ext = None
    _GlobalNgENB_ID_iE_Extensions._cont = __GlobalNgENB_ID_iE_Extensions__item_
    _GlobalNgENB_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GlobalNgENB_ID._cont = ASN1Dict([
        ('pLMNIdentity', _GlobalNgENB_ID_pLMNIdentity),
        ('ngENB-ID', _GlobalNgENB_ID_ngENB_ID),
        ('iE-Extensions', _GlobalNgENB_ID_iE_Extensions),
        ])
    GlobalNgENB_ID._ext = []
    
    #-----< GlobalNgENB-ID-ExtIEs >-----#
    GlobalNgENB_ID_ExtIEs = CLASS(name='GlobalNgENB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    GlobalNgENB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GlobalRANNodeID >-----#
    GlobalRANNodeID = CHOICE(name='GlobalRANNodeID', mode=MODE_TYPE)
    _GlobalRANNodeID_globalGNB_ID = SEQ(name='globalGNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalGNB-ID')))
    _GlobalRANNodeID_globalNgENB_ID = SEQ(name='globalNgENB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalNgENB-ID')))
    _GlobalRANNodeID_globalN3IWF_ID = SEQ(name='globalN3IWF-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalN3IWF-ID')))
    _GlobalRANNodeID_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __GlobalRANNodeID_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___GlobalRANNodeID_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ____GlobalRANNodeID_choice_Extensions_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalTNGF-ID')))
    ____GlobalRANNodeID_choice_Extensions_id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalTWIF-ID')))
    ____GlobalRANNodeID_choice_Extensions_id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalW-AGF-ID')))
    ___GlobalRANNodeID_choice_Extensions_id_tab._val = ASN1Set(rv=[dict([('id', 240), ('criticality', 'reject'), ('Value', ____GlobalRANNodeID_choice_Extensions_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 241), ('criticality', 'reject'), ('Value', ____GlobalRANNodeID_choice_Extensions_id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 242), ('criticality', 'reject'), ('Value', ____GlobalRANNodeID_choice_Extensions_id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __GlobalRANNodeID_choice_Extensions_id._const_tab = ___GlobalRANNodeID_choice_Extensions_id_tab
    __GlobalRANNodeID_choice_Extensions_id._const_tab_at = None
    __GlobalRANNodeID_choice_Extensions_id._const_tab_id = 'id'
    __GlobalRANNodeID_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    __GlobalRANNodeID_choice_Extensions_criticality._const_tab = ___GlobalRANNodeID_choice_Extensions_id_tab
    __GlobalRANNodeID_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __GlobalRANNodeID_choice_Extensions_criticality._const_tab_id = 'criticality'
    __GlobalRANNodeID_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    __GlobalRANNodeID_choice_Extensions_value._const_tab = ___GlobalRANNodeID_choice_Extensions_id_tab
    __GlobalRANNodeID_choice_Extensions_value._const_tab_at = ('..', 'id')
    __GlobalRANNodeID_choice_Extensions_value._const_tab_id = 'Value'
    _GlobalRANNodeID_choice_Extensions._cont = ASN1Dict([
        ('id', __GlobalRANNodeID_choice_Extensions_id),
        ('criticality', __GlobalRANNodeID_choice_Extensions_criticality),
        ('value', __GlobalRANNodeID_choice_Extensions_value),
        ])
    _GlobalRANNodeID_choice_Extensions._ext = None
    GlobalRANNodeID._cont = ASN1Dict([
        ('globalGNB-ID', _GlobalRANNodeID_globalGNB_ID),
        ('globalNgENB-ID', _GlobalRANNodeID_globalNgENB_ID),
        ('globalN3IWF-ID', _GlobalRANNodeID_globalN3IWF_ID),
        ('choice-Extensions', _GlobalRANNodeID_choice_Extensions),
        ])
    GlobalRANNodeID._ext = None
    
    #-----< GlobalRANNodeID-ExtIEs >-----#
    GlobalRANNodeID_ExtIEs = CLASS(name='GlobalRANNodeID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _GlobalRANNodeID_ExtIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalTNGF-ID')))
    _GlobalRANNodeID_ExtIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalTWIF-ID')))
    _GlobalRANNodeID_ExtIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalW-AGF-ID')))
    GlobalRANNodeID_ExtIEs._val = ASN1Set(rv=[dict([('id', 240), ('criticality', 'reject'), ('Value', _GlobalRANNodeID_ExtIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 241), ('criticality', 'reject'), ('Value', _GlobalRANNodeID_ExtIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 242), ('criticality', 'reject'), ('Value', _GlobalRANNodeID_ExtIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GlobalTNGF-ID >-----#
    GlobalTNGF_ID = SEQ(name='GlobalTNGF-ID', mode=MODE_TYPE)
    _GlobalTNGF_ID_pLMNIdentity = OCT_STR(name='pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _GlobalTNGF_ID_tNGF_ID = CHOICE(name='tNGF-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TNGF-ID')))
    _GlobalTNGF_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GlobalTNGF_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___GlobalTNGF_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____GlobalTNGF_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalTNGF_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalTNGF_ID_iE_Extensions__item__id._const_tab = ____GlobalTNGF_ID_iE_Extensions__item__id_tab
    ___GlobalTNGF_ID_iE_Extensions__item__id._const_tab_at = None
    ___GlobalTNGF_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___GlobalTNGF_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GlobalTNGF_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalTNGF_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalTNGF_ID_iE_Extensions__item__criticality._const_tab = ____GlobalTNGF_ID_iE_Extensions__item__criticality_tab
    ___GlobalTNGF_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GlobalTNGF_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GlobalTNGF_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GlobalTNGF_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalTNGF_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalTNGF_ID_iE_Extensions__item__extensionValue._const_tab = ____GlobalTNGF_ID_iE_Extensions__item__extensionValue_tab
    ___GlobalTNGF_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GlobalTNGF_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GlobalTNGF_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GlobalTNGF_ID_iE_Extensions__item__id),
        ('criticality', ___GlobalTNGF_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___GlobalTNGF_ID_iE_Extensions__item__extensionValue),
        ])
    __GlobalTNGF_ID_iE_Extensions__item_._ext = None
    _GlobalTNGF_ID_iE_Extensions._cont = __GlobalTNGF_ID_iE_Extensions__item_
    _GlobalTNGF_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GlobalTNGF_ID._cont = ASN1Dict([
        ('pLMNIdentity', _GlobalTNGF_ID_pLMNIdentity),
        ('tNGF-ID', _GlobalTNGF_ID_tNGF_ID),
        ('iE-Extensions', _GlobalTNGF_ID_iE_Extensions),
        ])
    GlobalTNGF_ID._ext = []
    
    #-----< GlobalTNGF-ID-ExtIEs >-----#
    GlobalTNGF_ID_ExtIEs = CLASS(name='GlobalTNGF-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    GlobalTNGF_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GlobalTWIF-ID >-----#
    GlobalTWIF_ID = SEQ(name='GlobalTWIF-ID', mode=MODE_TYPE)
    _GlobalTWIF_ID_pLMNIdentity = OCT_STR(name='pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _GlobalTWIF_ID_tWIF_ID = CHOICE(name='tWIF-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TWIF-ID')))
    _GlobalTWIF_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GlobalTWIF_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___GlobalTWIF_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____GlobalTWIF_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalTWIF_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalTWIF_ID_iE_Extensions__item__id._const_tab = ____GlobalTWIF_ID_iE_Extensions__item__id_tab
    ___GlobalTWIF_ID_iE_Extensions__item__id._const_tab_at = None
    ___GlobalTWIF_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___GlobalTWIF_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GlobalTWIF_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalTWIF_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalTWIF_ID_iE_Extensions__item__criticality._const_tab = ____GlobalTWIF_ID_iE_Extensions__item__criticality_tab
    ___GlobalTWIF_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GlobalTWIF_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GlobalTWIF_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GlobalTWIF_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalTWIF_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalTWIF_ID_iE_Extensions__item__extensionValue._const_tab = ____GlobalTWIF_ID_iE_Extensions__item__extensionValue_tab
    ___GlobalTWIF_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GlobalTWIF_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GlobalTWIF_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GlobalTWIF_ID_iE_Extensions__item__id),
        ('criticality', ___GlobalTWIF_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___GlobalTWIF_ID_iE_Extensions__item__extensionValue),
        ])
    __GlobalTWIF_ID_iE_Extensions__item_._ext = None
    _GlobalTWIF_ID_iE_Extensions._cont = __GlobalTWIF_ID_iE_Extensions__item_
    _GlobalTWIF_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GlobalTWIF_ID._cont = ASN1Dict([
        ('pLMNIdentity', _GlobalTWIF_ID_pLMNIdentity),
        ('tWIF-ID', _GlobalTWIF_ID_tWIF_ID),
        ('iE-Extensions', _GlobalTWIF_ID_iE_Extensions),
        ])
    GlobalTWIF_ID._ext = []
    
    #-----< GlobalTWIF-ID-ExtIEs >-----#
    GlobalTWIF_ID_ExtIEs = CLASS(name='GlobalTWIF-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    GlobalTWIF_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GlobalW-AGF-ID >-----#
    GlobalW_AGF_ID = SEQ(name='GlobalW-AGF-ID', mode=MODE_TYPE)
    _GlobalW_AGF_ID_pLMNIdentity = OCT_STR(name='pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _GlobalW_AGF_ID_w_AGF_ID = CHOICE(name='w-AGF-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'W-AGF-ID')))
    _GlobalW_AGF_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GlobalW_AGF_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___GlobalW_AGF_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____GlobalW_AGF_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalW_AGF_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalW_AGF_ID_iE_Extensions__item__id._const_tab = ____GlobalW_AGF_ID_iE_Extensions__item__id_tab
    ___GlobalW_AGF_ID_iE_Extensions__item__id._const_tab_at = None
    ___GlobalW_AGF_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___GlobalW_AGF_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GlobalW_AGF_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalW_AGF_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalW_AGF_ID_iE_Extensions__item__criticality._const_tab = ____GlobalW_AGF_ID_iE_Extensions__item__criticality_tab
    ___GlobalW_AGF_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GlobalW_AGF_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GlobalW_AGF_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GlobalW_AGF_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GlobalW_AGF_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GlobalW_AGF_ID_iE_Extensions__item__extensionValue._const_tab = ____GlobalW_AGF_ID_iE_Extensions__item__extensionValue_tab
    ___GlobalW_AGF_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GlobalW_AGF_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GlobalW_AGF_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GlobalW_AGF_ID_iE_Extensions__item__id),
        ('criticality', ___GlobalW_AGF_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___GlobalW_AGF_ID_iE_Extensions__item__extensionValue),
        ])
    __GlobalW_AGF_ID_iE_Extensions__item_._ext = None
    _GlobalW_AGF_ID_iE_Extensions._cont = __GlobalW_AGF_ID_iE_Extensions__item_
    _GlobalW_AGF_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GlobalW_AGF_ID._cont = ASN1Dict([
        ('pLMNIdentity', _GlobalW_AGF_ID_pLMNIdentity),
        ('w-AGF-ID', _GlobalW_AGF_ID_w_AGF_ID),
        ('iE-Extensions', _GlobalW_AGF_ID_iE_Extensions),
        ])
    GlobalW_AGF_ID._ext = []
    
    #-----< GlobalW-AGF-ID-ExtIEs >-----#
    GlobalW_AGF_ID_ExtIEs = CLASS(name='GlobalW-AGF-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    GlobalW_AGF_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-ID >-----#
    GNB_ID = CHOICE(name='GNB-ID', mode=MODE_TYPE)
    _GNB_ID_gNB_ID = BIT_STR(name='gNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNB_ID_gNB_ID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=22, ub=32)], ev=None, er=[])
    _GNB_ID_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __GNB_ID_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___GNB_ID_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___GNB_ID_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __GNB_ID_choice_Extensions_id._const_tab = ___GNB_ID_choice_Extensions_id_tab
    __GNB_ID_choice_Extensions_id._const_tab_at = None
    __GNB_ID_choice_Extensions_id._const_tab_id = 'id'
    __GNB_ID_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___GNB_ID_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___GNB_ID_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __GNB_ID_choice_Extensions_criticality._const_tab = ___GNB_ID_choice_Extensions_criticality_tab
    __GNB_ID_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __GNB_ID_choice_Extensions_criticality._const_tab_id = 'criticality'
    __GNB_ID_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___GNB_ID_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___GNB_ID_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __GNB_ID_choice_Extensions_value._const_tab = ___GNB_ID_choice_Extensions_value_tab
    __GNB_ID_choice_Extensions_value._const_tab_at = ('..', 'id')
    __GNB_ID_choice_Extensions_value._const_tab_id = 'Value'
    _GNB_ID_choice_Extensions._cont = ASN1Dict([
        ('id', __GNB_ID_choice_Extensions_id),
        ('criticality', __GNB_ID_choice_Extensions_criticality),
        ('value', __GNB_ID_choice_Extensions_value),
        ])
    _GNB_ID_choice_Extensions._ext = None
    GNB_ID._cont = ASN1Dict([
        ('gNB-ID', _GNB_ID_gNB_ID),
        ('choice-Extensions', _GNB_ID_choice_Extensions),
        ])
    GNB_ID._ext = None
    
    #-----< GNB-ID-ExtIEs >-----#
    GNB_ID_ExtIEs = CLASS(name='GNB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    GNB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GTP-TEID >-----#
    GTP_TEID = OCT_STR(name='GTP-TEID', mode=MODE_TYPE)
    GTP_TEID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< GTPTunnel >-----#
    GTPTunnel = SEQ(name='GTPTunnel', mode=MODE_TYPE)
    _GTPTunnel_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _GTPTunnel_gTP_TEID = OCT_STR(name='gTP-TEID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GTP-TEID')))
    _GTPTunnel_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GTPTunnel_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___GTPTunnel_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____GTPTunnel_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GTPTunnel_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTunnel_iE_Extensions__item__id._const_tab = ____GTPTunnel_iE_Extensions__item__id_tab
    ___GTPTunnel_iE_Extensions__item__id._const_tab_at = None
    ___GTPTunnel_iE_Extensions__item__id._const_tab_id = 'id'
    ___GTPTunnel_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GTPTunnel_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GTPTunnel_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTunnel_iE_Extensions__item__criticality._const_tab = ____GTPTunnel_iE_Extensions__item__criticality_tab
    ___GTPTunnel_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GTPTunnel_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GTPTunnel_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GTPTunnel_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GTPTunnel_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPTunnel_iE_Extensions__item__extensionValue._const_tab = ____GTPTunnel_iE_Extensions__item__extensionValue_tab
    ___GTPTunnel_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GTPTunnel_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GTPTunnel_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GTPTunnel_iE_Extensions__item__id),
        ('criticality', ___GTPTunnel_iE_Extensions__item__criticality),
        ('extensionValue', ___GTPTunnel_iE_Extensions__item__extensionValue),
        ])
    __GTPTunnel_iE_Extensions__item_._ext = None
    _GTPTunnel_iE_Extensions._cont = __GTPTunnel_iE_Extensions__item_
    _GTPTunnel_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GTPTunnel._cont = ASN1Dict([
        ('transportLayerAddress', _GTPTunnel_transportLayerAddress),
        ('gTP-TEID', _GTPTunnel_gTP_TEID),
        ('iE-Extensions', _GTPTunnel_iE_Extensions),
        ])
    GTPTunnel._ext = []
    
    #-----< GTPTunnel-ExtIEs >-----#
    GTPTunnel_ExtIEs = CLASS(name='GTPTunnel-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    GTPTunnel_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GUAMI >-----#
    GUAMI = SEQ(name='GUAMI', mode=MODE_TYPE)
    _GUAMI_pLMNIdentity = OCT_STR(name='pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _GUAMI_aMFRegionID = BIT_STR(name='aMFRegionID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AMFRegionID')))
    _GUAMI_aMFSetID = BIT_STR(name='aMFSetID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AMFSetID')))
    _GUAMI_aMFPointer = BIT_STR(name='aMFPointer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AMFPointer')))
    _GUAMI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GUAMI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___GUAMI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____GUAMI_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GUAMI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GUAMI_iE_Extensions__item__id._const_tab = ____GUAMI_iE_Extensions__item__id_tab
    ___GUAMI_iE_Extensions__item__id._const_tab_at = None
    ___GUAMI_iE_Extensions__item__id._const_tab_id = 'id'
    ___GUAMI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GUAMI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GUAMI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GUAMI_iE_Extensions__item__criticality._const_tab = ____GUAMI_iE_Extensions__item__criticality_tab
    ___GUAMI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GUAMI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GUAMI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GUAMI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____GUAMI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GUAMI_iE_Extensions__item__extensionValue._const_tab = ____GUAMI_iE_Extensions__item__extensionValue_tab
    ___GUAMI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GUAMI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GUAMI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GUAMI_iE_Extensions__item__id),
        ('criticality', ___GUAMI_iE_Extensions__item__criticality),
        ('extensionValue', ___GUAMI_iE_Extensions__item__extensionValue),
        ])
    __GUAMI_iE_Extensions__item_._ext = None
    _GUAMI_iE_Extensions._cont = __GUAMI_iE_Extensions__item_
    _GUAMI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GUAMI._cont = ASN1Dict([
        ('pLMNIdentity', _GUAMI_pLMNIdentity),
        ('aMFRegionID', _GUAMI_aMFRegionID),
        ('aMFSetID', _GUAMI_aMFSetID),
        ('aMFPointer', _GUAMI_aMFPointer),
        ('iE-Extensions', _GUAMI_iE_Extensions),
        ])
    GUAMI._ext = []
    
    #-----< GUAMI-ExtIEs >-----#
    GUAMI_ExtIEs = CLASS(name='GUAMI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    GUAMI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GUAMIType >-----#
    GUAMIType = ENUM(name='GUAMIType', mode=MODE_TYPE)
    GUAMIType._cont = ASN1Dict([('native', 0), ('mapped', 1)])
    GUAMIType._ext = []
    
    #-----< HandoverCommandTransfer >-----#
    HandoverCommandTransfer = SEQ(name='HandoverCommandTransfer', mode=MODE_TYPE)
    _HandoverCommandTransfer_dLForwardingUP_TNLInformation = CHOICE(name='dLForwardingUP-TNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')), opt=True)
    _HandoverCommandTransfer_qosFlowToBeForwardedList = SEQ_OF(name='qosFlowToBeForwardedList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowToBeForwardedList')), opt=True)
    _HandoverCommandTransfer_dataForwardingResponseDRBList = SEQ_OF(name='dataForwardingResponseDRBList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DataForwardingResponseDRBList')), opt=True)
    _HandoverCommandTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HandoverCommandTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___HandoverCommandTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____HandoverCommandTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')))
    _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationList')))
    _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DataForwardingResponseERABList')))
    _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithCause')))
    ____HandoverCommandTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 152), ('criticality', 'ignore'), ('Extension', _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 164), ('criticality', 'reject'), ('Extension', _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 172), ('criticality', 'reject'), ('Extension', _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 249), ('criticality', 'ignore'), ('Extension', _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 283), ('criticality', 'ignore'), ('Extension', _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HandoverCommandTransfer_iE_Extensions__item__id._const_tab = ____HandoverCommandTransfer_iE_Extensions__item__id_tab
    ___HandoverCommandTransfer_iE_Extensions__item__id._const_tab_at = None
    ___HandoverCommandTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___HandoverCommandTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HandoverCommandTransfer_iE_Extensions__item__criticality._const_tab = ____HandoverCommandTransfer_iE_Extensions__item__id_tab
    ___HandoverCommandTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverCommandTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HandoverCommandTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HandoverCommandTransfer_iE_Extensions__item__extensionValue._const_tab = ____HandoverCommandTransfer_iE_Extensions__item__id_tab
    ___HandoverCommandTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HandoverCommandTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HandoverCommandTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HandoverCommandTransfer_iE_Extensions__item__id),
        ('criticality', ___HandoverCommandTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___HandoverCommandTransfer_iE_Extensions__item__extensionValue),
        ])
    __HandoverCommandTransfer_iE_Extensions__item_._ext = None
    _HandoverCommandTransfer_iE_Extensions._cont = __HandoverCommandTransfer_iE_Extensions__item_
    _HandoverCommandTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HandoverCommandTransfer._cont = ASN1Dict([
        ('dLForwardingUP-TNLInformation', _HandoverCommandTransfer_dLForwardingUP_TNLInformation),
        ('qosFlowToBeForwardedList', _HandoverCommandTransfer_qosFlowToBeForwardedList),
        ('dataForwardingResponseDRBList', _HandoverCommandTransfer_dataForwardingResponseDRBList),
        ('iE-Extensions', _HandoverCommandTransfer_iE_Extensions),
        ])
    HandoverCommandTransfer._ext = []
    
    #-----< HandoverCommandTransfer-ExtIEs >-----#
    HandoverCommandTransfer_ExtIEs = CLASS(name='HandoverCommandTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _HandoverCommandTransfer_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')))
    _HandoverCommandTransfer_ExtIEs_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _HandoverCommandTransfer_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationList')))
    _HandoverCommandTransfer_ExtIEs_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DataForwardingResponseERABList')))
    _HandoverCommandTransfer_ExtIEs_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithCause')))
    HandoverCommandTransfer_ExtIEs._val = ASN1Set(rv=[dict([('id', 152), ('criticality', 'ignore'), ('Extension', _HandoverCommandTransfer_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 164), ('criticality', 'reject'), ('Extension', _HandoverCommandTransfer_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 172), ('criticality', 'reject'), ('Extension', _HandoverCommandTransfer_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 249), ('criticality', 'ignore'), ('Extension', _HandoverCommandTransfer_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 283), ('criticality', 'ignore'), ('Extension', _HandoverCommandTransfer_ExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverFlag >-----#
    HandoverFlag = ENUM(name='HandoverFlag', mode=MODE_TYPE)
    HandoverFlag._cont = ASN1Dict([('handover-preparation', 0)])
    HandoverFlag._ext = []
    
    #-----< HandoverPreparationUnsuccessfulTransfer >-----#
    HandoverPreparationUnsuccessfulTransfer = SEQ(name='HandoverPreparationUnsuccessfulTransfer', mode=MODE_TYPE)
    _HandoverPreparationUnsuccessfulTransfer_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _HandoverPreparationUnsuccessfulTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__id._const_tab = ____HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__id_tab
    ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__id._const_tab_at = None
    ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab = ____HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__criticality_tab
    ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab = ____HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab
    ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__id),
        ('criticality', ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__extensionValue),
        ])
    __HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item_._ext = None
    _HandoverPreparationUnsuccessfulTransfer_iE_Extensions._cont = __HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item_
    _HandoverPreparationUnsuccessfulTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HandoverPreparationUnsuccessfulTransfer._cont = ASN1Dict([
        ('cause', _HandoverPreparationUnsuccessfulTransfer_cause),
        ('iE-Extensions', _HandoverPreparationUnsuccessfulTransfer_iE_Extensions),
        ])
    HandoverPreparationUnsuccessfulTransfer._ext = []
    
    #-----< HandoverPreparationUnsuccessfulTransfer-ExtIEs >-----#
    HandoverPreparationUnsuccessfulTransfer_ExtIEs = CLASS(name='HandoverPreparationUnsuccessfulTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    HandoverPreparationUnsuccessfulTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HandoverRequestAcknowledgeTransfer >-----#
    HandoverRequestAcknowledgeTransfer = SEQ(name='HandoverRequestAcknowledgeTransfer', mode=MODE_TYPE)
    _HandoverRequestAcknowledgeTransfer_dL_NGU_UP_TNLInformation = CHOICE(name='dL-NGU-UP-TNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _HandoverRequestAcknowledgeTransfer_dLForwardingUP_TNLInformation = CHOICE(name='dLForwardingUP-TNLInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')), opt=True)
    _HandoverRequestAcknowledgeTransfer_securityResult = SEQ(name='securityResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SecurityResult')), opt=True)
    _HandoverRequestAcknowledgeTransfer_qosFlowSetupResponseList = SEQ_OF(name='qosFlowSetupResponseList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithDataForwarding')))
    _HandoverRequestAcknowledgeTransfer_qosFlowFailedToSetupList = SEQ_OF(name='qosFlowFailedToSetupList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithCause')), opt=True)
    _HandoverRequestAcknowledgeTransfer_dataForwardingResponseDRBList = SEQ_OF(name='dataForwardingResponseDRBList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DataForwardingResponseDRBList')), opt=True)
    _HandoverRequestAcknowledgeTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HandoverRequestAcknowledgeTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AdditionalDLUPTNLInformationForHOList')))
    _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationList')))
    _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DataForwardingResponseERABList')))
    _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_4 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedundantPDUSessionInformation')))
    _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_6 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_7 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SupportIndicator')))
    ____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 153), ('criticality', 'ignore'), ('Extension', _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 164), ('criticality', 'reject'), ('Extension', _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 172), ('criticality', 'reject'), ('Extension', _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 249), ('criticality', 'ignore'), ('Extension', _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 192), ('criticality', 'ignore'), ('Extension', _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 198), ('criticality', 'ignore'), ('Extension', _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 27), ('criticality', 'ignore'), ('Extension', _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 309), ('criticality', 'ignore'), ('Extension', _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id._const_tab = ____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab
    ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id._const_tab_at = None
    ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__criticality._const_tab = ____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab
    ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__extensionValue._const_tab = ____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab
    ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HandoverRequestAcknowledgeTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id),
        ('criticality', ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__extensionValue),
        ])
    __HandoverRequestAcknowledgeTransfer_iE_Extensions__item_._ext = None
    _HandoverRequestAcknowledgeTransfer_iE_Extensions._cont = __HandoverRequestAcknowledgeTransfer_iE_Extensions__item_
    _HandoverRequestAcknowledgeTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HandoverRequestAcknowledgeTransfer._cont = ASN1Dict([
        ('dL-NGU-UP-TNLInformation', _HandoverRequestAcknowledgeTransfer_dL_NGU_UP_TNLInformation),
        ('dLForwardingUP-TNLInformation', _HandoverRequestAcknowledgeTransfer_dLForwardingUP_TNLInformation),
        ('securityResult', _HandoverRequestAcknowledgeTransfer_securityResult),
        ('qosFlowSetupResponseList', _HandoverRequestAcknowledgeTransfer_qosFlowSetupResponseList),
        ('qosFlowFailedToSetupList', _HandoverRequestAcknowledgeTransfer_qosFlowFailedToSetupList),
        ('dataForwardingResponseDRBList', _HandoverRequestAcknowledgeTransfer_dataForwardingResponseDRBList),
        ('iE-Extensions', _HandoverRequestAcknowledgeTransfer_iE_Extensions),
        ])
    HandoverRequestAcknowledgeTransfer._ext = []
    
    #-----< HandoverRequestAcknowledgeTransfer-ExtIEs >-----#
    HandoverRequestAcknowledgeTransfer_ExtIEs = CLASS(name='HandoverRequestAcknowledgeTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AdditionalDLUPTNLInformationForHOList')))
    _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationList')))
    _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DataForwardingResponseERABList')))
    _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_4 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedundantPDUSessionInformation')))
    _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_6 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_7 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SupportIndicator')))
    HandoverRequestAcknowledgeTransfer_ExtIEs._val = ASN1Set(rv=[dict([('id', 153), ('criticality', 'ignore'), ('Extension', _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 164), ('criticality', 'reject'), ('Extension', _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 172), ('criticality', 'reject'), ('Extension', _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 249), ('criticality', 'ignore'), ('Extension', _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 192), ('criticality', 'ignore'), ('Extension', _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 198), ('criticality', 'ignore'), ('Extension', _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 27), ('criticality', 'ignore'), ('Extension', _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 309), ('criticality', 'ignore'), ('Extension', _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverRequiredTransfer >-----#
    HandoverRequiredTransfer = SEQ(name='HandoverRequiredTransfer', mode=MODE_TYPE)
    _HandoverRequiredTransfer_directForwardingPathAvailability = ENUM(name='directForwardingPathAvailability', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DirectForwardingPathAvailability')), opt=True)
    _HandoverRequiredTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HandoverRequiredTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___HandoverRequiredTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____HandoverRequiredTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HandoverRequiredTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HandoverRequiredTransfer_iE_Extensions__item__id._const_tab = ____HandoverRequiredTransfer_iE_Extensions__item__id_tab
    ___HandoverRequiredTransfer_iE_Extensions__item__id._const_tab_at = None
    ___HandoverRequiredTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___HandoverRequiredTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HandoverRequiredTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HandoverRequiredTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HandoverRequiredTransfer_iE_Extensions__item__criticality._const_tab = ____HandoverRequiredTransfer_iE_Extensions__item__criticality_tab
    ___HandoverRequiredTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverRequiredTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HandoverRequiredTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HandoverRequiredTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HandoverRequiredTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HandoverRequiredTransfer_iE_Extensions__item__extensionValue._const_tab = ____HandoverRequiredTransfer_iE_Extensions__item__extensionValue_tab
    ___HandoverRequiredTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HandoverRequiredTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HandoverRequiredTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HandoverRequiredTransfer_iE_Extensions__item__id),
        ('criticality', ___HandoverRequiredTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___HandoverRequiredTransfer_iE_Extensions__item__extensionValue),
        ])
    __HandoverRequiredTransfer_iE_Extensions__item_._ext = None
    _HandoverRequiredTransfer_iE_Extensions._cont = __HandoverRequiredTransfer_iE_Extensions__item_
    _HandoverRequiredTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HandoverRequiredTransfer._cont = ASN1Dict([
        ('directForwardingPathAvailability', _HandoverRequiredTransfer_directForwardingPathAvailability),
        ('iE-Extensions', _HandoverRequiredTransfer_iE_Extensions),
        ])
    HandoverRequiredTransfer._ext = []
    
    #-----< HandoverRequiredTransfer-ExtIEs >-----#
    HandoverRequiredTransfer_ExtIEs = CLASS(name='HandoverRequiredTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    HandoverRequiredTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HandoverResourceAllocationUnsuccessfulTransfer >-----#
    HandoverResourceAllocationUnsuccessfulTransfer = SEQ(name='HandoverResourceAllocationUnsuccessfulTransfer', mode=MODE_TYPE)
    _HandoverResourceAllocationUnsuccessfulTransfer_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _HandoverResourceAllocationUnsuccessfulTransfer_criticalityDiagnostics = SEQ(name='criticalityDiagnostics', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')), opt=True)
    _HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__id._const_tab = ____HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__id_tab
    ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__id._const_tab_at = None
    ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab = ____HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__criticality_tab
    ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab = ____HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab
    ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__id),
        ('criticality', ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__extensionValue),
        ])
    __HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item_._ext = None
    _HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions._cont = __HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item_
    _HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HandoverResourceAllocationUnsuccessfulTransfer._cont = ASN1Dict([
        ('cause', _HandoverResourceAllocationUnsuccessfulTransfer_cause),
        ('criticalityDiagnostics', _HandoverResourceAllocationUnsuccessfulTransfer_criticalityDiagnostics),
        ('iE-Extensions', _HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions),
        ])
    HandoverResourceAllocationUnsuccessfulTransfer._ext = []
    
    #-----< HandoverResourceAllocationUnsuccessfulTransfer-ExtIEs >-----#
    HandoverResourceAllocationUnsuccessfulTransfer_ExtIEs = CLASS(name='HandoverResourceAllocationUnsuccessfulTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    HandoverResourceAllocationUnsuccessfulTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HandoverType >-----#
    HandoverType = ENUM(name='HandoverType', mode=MODE_TYPE)
    HandoverType._cont = ASN1Dict([('intra5gs', 0), ('fivegs-to-eps', 1), ('eps-to-5gs', 2), ('fivegs-to-utran', 3)])
    HandoverType._ext = ['fivegs-to-utran']
    
    #-----< HFCNode-ID >-----#
    HFCNode_ID = OCT_STR(name='HFCNode-ID', mode=MODE_TYPE)
    
    #-----< HFCNode-ID-new >-----#
    HFCNode_ID_new = SEQ(name='HFCNode-ID-new', mode=MODE_TYPE)
    _HFCNode_ID_new_hFCNode_ID = OCT_STR(name='hFCNode-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'HFCNode-ID')))
    _HFCNode_ID_new_tAI = SEQ(name='tAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _HFCNode_ID_new_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HFCNode_ID_new_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___HFCNode_ID_new_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____HFCNode_ID_new_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HFCNode_ID_new_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HFCNode_ID_new_iE_Extensions__item__id._const_tab = ____HFCNode_ID_new_iE_Extensions__item__id_tab
    ___HFCNode_ID_new_iE_Extensions__item__id._const_tab_at = None
    ___HFCNode_ID_new_iE_Extensions__item__id._const_tab_id = 'id'
    ___HFCNode_ID_new_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HFCNode_ID_new_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HFCNode_ID_new_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HFCNode_ID_new_iE_Extensions__item__criticality._const_tab = ____HFCNode_ID_new_iE_Extensions__item__criticality_tab
    ___HFCNode_ID_new_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HFCNode_ID_new_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HFCNode_ID_new_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HFCNode_ID_new_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HFCNode_ID_new_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HFCNode_ID_new_iE_Extensions__item__extensionValue._const_tab = ____HFCNode_ID_new_iE_Extensions__item__extensionValue_tab
    ___HFCNode_ID_new_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HFCNode_ID_new_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HFCNode_ID_new_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HFCNode_ID_new_iE_Extensions__item__id),
        ('criticality', ___HFCNode_ID_new_iE_Extensions__item__criticality),
        ('extensionValue', ___HFCNode_ID_new_iE_Extensions__item__extensionValue),
        ])
    __HFCNode_ID_new_iE_Extensions__item_._ext = None
    _HFCNode_ID_new_iE_Extensions._cont = __HFCNode_ID_new_iE_Extensions__item_
    _HFCNode_ID_new_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HFCNode_ID_new._cont = ASN1Dict([
        ('hFCNode-ID', _HFCNode_ID_new_hFCNode_ID),
        ('tAI', _HFCNode_ID_new_tAI),
        ('iE-Extensions', _HFCNode_ID_new_iE_Extensions),
        ])
    HFCNode_ID_new._ext = []
    
    #-----< HFCNode-ID-new-ExtIEs >-----#
    HFCNode_ID_new_ExtIEs = CLASS(name='HFCNode-ID-new-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    HFCNode_ID_new_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HOReport >-----#
    HOReport = SEQ(name='HOReport', mode=MODE_TYPE)
    _HOReport_handoverReportType = ENUM(name='handoverReportType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HOReport_handoverReportType._cont = ASN1Dict([('ho-too-early', 0), ('ho-to-wrong-cell', 1), ('intersystem-ping-pong', 2)])
    _HOReport_handoverReportType._ext = []
    _HOReport_handoverCause = CHOICE(name='handoverCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _HOReport_sourcecellCGI = CHOICE(name='sourcecellCGI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _HOReport_targetcellCGI = CHOICE(name='targetcellCGI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _HOReport_reestablishmentcellCGI = CHOICE(name='reestablishmentcellCGI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')), opt=True)
    _HOReport_sourcecellC_RNTI = BIT_STR(name='sourcecellC-RNTI', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _HOReport_sourcecellC_RNTI._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _HOReport_targetcellinE_UTRAN = SEQ(name='targetcellinE-UTRAN', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')), opt=True)
    _HOReport_mobilityInformation = BIT_STR(name='mobilityInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MobilityInformation')), opt=True)
    _HOReport_uERLFReportContainer = CHOICE(name='uERLFReportContainer', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UERLFReportContainer')), opt=True)
    _HOReport_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HOReport_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___HOReport_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____HOReport_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HOReport_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HOReport_iE_Extensions__item__id._const_tab = ____HOReport_iE_Extensions__item__id_tab
    ___HOReport_iE_Extensions__item__id._const_tab_at = None
    ___HOReport_iE_Extensions__item__id._const_tab_id = 'id'
    ___HOReport_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HOReport_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HOReport_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HOReport_iE_Extensions__item__criticality._const_tab = ____HOReport_iE_Extensions__item__criticality_tab
    ___HOReport_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HOReport_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HOReport_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HOReport_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____HOReport_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HOReport_iE_Extensions__item__extensionValue._const_tab = ____HOReport_iE_Extensions__item__extensionValue_tab
    ___HOReport_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HOReport_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HOReport_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HOReport_iE_Extensions__item__id),
        ('criticality', ___HOReport_iE_Extensions__item__criticality),
        ('extensionValue', ___HOReport_iE_Extensions__item__extensionValue),
        ])
    __HOReport_iE_Extensions__item_._ext = None
    _HOReport_iE_Extensions._cont = __HOReport_iE_Extensions__item_
    _HOReport_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HOReport._cont = ASN1Dict([
        ('handoverReportType', _HOReport_handoverReportType),
        ('handoverCause', _HOReport_handoverCause),
        ('sourcecellCGI', _HOReport_sourcecellCGI),
        ('targetcellCGI', _HOReport_targetcellCGI),
        ('reestablishmentcellCGI', _HOReport_reestablishmentcellCGI),
        ('sourcecellC-RNTI', _HOReport_sourcecellC_RNTI),
        ('targetcellinE-UTRAN', _HOReport_targetcellinE_UTRAN),
        ('mobilityInformation', _HOReport_mobilityInformation),
        ('uERLFReportContainer', _HOReport_uERLFReportContainer),
        ('iE-Extensions', _HOReport_iE_Extensions),
        ])
    HOReport._ext = []
    
    #-----< HOReport-ExtIEs >-----#
    HOReport_ExtIEs = CLASS(name='HOReport-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    HOReport_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Hysteresis >-----#
    Hysteresis = INT(name='Hysteresis', mode=MODE_TYPE)
    Hysteresis._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=30)], ev=None, er=[])
    
    #-----< IAB-Authorized >-----#
    IAB_Authorized = ENUM(name='IAB-Authorized', mode=MODE_TYPE)
    IAB_Authorized._cont = ASN1Dict([('authorized', 0), ('not-authorized', 1)])
    IAB_Authorized._ext = []
    
    #-----< IAB-Supported >-----#
    IAB_Supported = ENUM(name='IAB-Supported', mode=MODE_TYPE)
    IAB_Supported._cont = ASN1Dict([('true', 0)])
    IAB_Supported._ext = []
    
    #-----< IABNodeIndication >-----#
    IABNodeIndication = ENUM(name='IABNodeIndication', mode=MODE_TYPE)
    IABNodeIndication._cont = ASN1Dict([('true', 0)])
    IABNodeIndication._ext = []
    
    #-----< IMSVoiceSupportIndicator >-----#
    IMSVoiceSupportIndicator = ENUM(name='IMSVoiceSupportIndicator', mode=MODE_TYPE)
    IMSVoiceSupportIndicator._cont = ASN1Dict([('supported', 0), ('not-supported', 1)])
    IMSVoiceSupportIndicator._ext = []
    
    #-----< IndexToRFSP >-----#
    IndexToRFSP = INT(name='IndexToRFSP', mode=MODE_TYPE)
    IndexToRFSP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=[], er=[])
    
    #-----< InfoOnRecommendedCellsAndRANNodesForPaging >-----#
    InfoOnRecommendedCellsAndRANNodesForPaging = SEQ(name='InfoOnRecommendedCellsAndRANNodesForPaging', mode=MODE_TYPE)
    _InfoOnRecommendedCellsAndRANNodesForPaging_recommendedCellsForPaging = SEQ(name='recommendedCellsForPaging', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RecommendedCellsForPaging')))
    _InfoOnRecommendedCellsAndRANNodesForPaging_recommendRANNodesForPaging = SEQ(name='recommendRANNodesForPaging', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RecommendedRANNodesForPaging')))
    _InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__id._const_tab = ____InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__id_tab
    ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__id._const_tab_at = None
    ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__id._const_tab_id = 'id'
    ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__criticality._const_tab = ____InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__criticality_tab
    ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__extensionValue._const_tab = ____InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__extensionValue_tab
    ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__id),
        ('criticality', ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__criticality),
        ('extensionValue', ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__extensionValue),
        ])
    __InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item_._ext = None
    _InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions._cont = __InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item_
    _InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InfoOnRecommendedCellsAndRANNodesForPaging._cont = ASN1Dict([
        ('recommendedCellsForPaging', _InfoOnRecommendedCellsAndRANNodesForPaging_recommendedCellsForPaging),
        ('recommendRANNodesForPaging', _InfoOnRecommendedCellsAndRANNodesForPaging_recommendRANNodesForPaging),
        ('iE-Extensions', _InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions),
        ])
    InfoOnRecommendedCellsAndRANNodesForPaging._ext = []
    
    #-----< InfoOnRecommendedCellsAndRANNodesForPaging-ExtIEs >-----#
    InfoOnRecommendedCellsAndRANNodesForPaging_ExtIEs = CLASS(name='InfoOnRecommendedCellsAndRANNodesForPaging-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    InfoOnRecommendedCellsAndRANNodesForPaging_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntegrityProtectionIndication >-----#
    IntegrityProtectionIndication = ENUM(name='IntegrityProtectionIndication', mode=MODE_TYPE)
    IntegrityProtectionIndication._cont = ASN1Dict([('required', 0), ('preferred', 1), ('not-needed', 2)])
    IntegrityProtectionIndication._ext = []
    
    #-----< IntegrityProtectionResult >-----#
    IntegrityProtectionResult = ENUM(name='IntegrityProtectionResult', mode=MODE_TYPE)
    IntegrityProtectionResult._cont = ASN1Dict([('performed', 0), ('not-performed', 1)])
    IntegrityProtectionResult._ext = []
    
    #-----< IntendedNumberOfPagingAttempts >-----#
    IntendedNumberOfPagingAttempts = INT(name='IntendedNumberOfPagingAttempts', mode=MODE_TYPE)
    IntendedNumberOfPagingAttempts._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=[], er=[])
    
    #-----< InterfacesToTrace >-----#
    InterfacesToTrace = BIT_STR(name='InterfacesToTrace', mode=MODE_TYPE)
    InterfacesToTrace._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< ImmediateMDTNr >-----#
    ImmediateMDTNr = SEQ(name='ImmediateMDTNr', mode=MODE_TYPE)
    _ImmediateMDTNr_measurementsToActivate = BIT_STR(name='measurementsToActivate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MeasurementsToActivate')))
    _ImmediateMDTNr_m1Configuration = SEQ(name='m1Configuration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'M1Configuration')), opt=True)
    _ImmediateMDTNr_m4Configuration = SEQ(name='m4Configuration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'M4Configuration')), opt=True)
    _ImmediateMDTNr_m5Configuration = SEQ(name='m5Configuration', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'M5Configuration')), opt=True)
    _ImmediateMDTNr_m6Configuration = SEQ(name='m6Configuration', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'M6Configuration')), opt=True)
    _ImmediateMDTNr_m7Configuration = SEQ(name='m7Configuration', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'M7Configuration')), opt=True)
    _ImmediateMDTNr_bluetoothMeasurementConfiguration = SEQ(name='bluetoothMeasurementConfiguration', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BluetoothMeasurementConfiguration')), opt=True)
    _ImmediateMDTNr_wLANMeasurementConfiguration = SEQ(name='wLANMeasurementConfiguration', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'WLANMeasurementConfiguration')), opt=True)
    _ImmediateMDTNr_mDT_Location_Info = SEQ(name='mDT-Location-Info', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MDT-Location-Info')), opt=True)
    _ImmediateMDTNr_sensorMeasurementConfiguration = SEQ(name='sensorMeasurementConfiguration', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SensorMeasurementConfiguration')), opt=True)
    _ImmediateMDTNr_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ImmediateMDTNr_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___ImmediateMDTNr_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____ImmediateMDTNr_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ImmediateMDTNr_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ImmediateMDTNr_iE_Extensions__item__id._const_tab = ____ImmediateMDTNr_iE_Extensions__item__id_tab
    ___ImmediateMDTNr_iE_Extensions__item__id._const_tab_at = None
    ___ImmediateMDTNr_iE_Extensions__item__id._const_tab_id = 'id'
    ___ImmediateMDTNr_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ImmediateMDTNr_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ImmediateMDTNr_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ImmediateMDTNr_iE_Extensions__item__criticality._const_tab = ____ImmediateMDTNr_iE_Extensions__item__criticality_tab
    ___ImmediateMDTNr_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ImmediateMDTNr_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ImmediateMDTNr_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ImmediateMDTNr_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ImmediateMDTNr_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ImmediateMDTNr_iE_Extensions__item__extensionValue._const_tab = ____ImmediateMDTNr_iE_Extensions__item__extensionValue_tab
    ___ImmediateMDTNr_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ImmediateMDTNr_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ImmediateMDTNr_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ImmediateMDTNr_iE_Extensions__item__id),
        ('criticality', ___ImmediateMDTNr_iE_Extensions__item__criticality),
        ('extensionValue', ___ImmediateMDTNr_iE_Extensions__item__extensionValue),
        ])
    __ImmediateMDTNr_iE_Extensions__item_._ext = None
    _ImmediateMDTNr_iE_Extensions._cont = __ImmediateMDTNr_iE_Extensions__item_
    _ImmediateMDTNr_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ImmediateMDTNr._cont = ASN1Dict([
        ('measurementsToActivate', _ImmediateMDTNr_measurementsToActivate),
        ('m1Configuration', _ImmediateMDTNr_m1Configuration),
        ('m4Configuration', _ImmediateMDTNr_m4Configuration),
        ('m5Configuration', _ImmediateMDTNr_m5Configuration),
        ('m6Configuration', _ImmediateMDTNr_m6Configuration),
        ('m7Configuration', _ImmediateMDTNr_m7Configuration),
        ('bluetoothMeasurementConfiguration', _ImmediateMDTNr_bluetoothMeasurementConfiguration),
        ('wLANMeasurementConfiguration', _ImmediateMDTNr_wLANMeasurementConfiguration),
        ('mDT-Location-Info', _ImmediateMDTNr_mDT_Location_Info),
        ('sensorMeasurementConfiguration', _ImmediateMDTNr_sensorMeasurementConfiguration),
        ('iE-Extensions', _ImmediateMDTNr_iE_Extensions),
        ])
    ImmediateMDTNr._ext = []
    
    #-----< ImmediateMDTNr-ExtIEs >-----#
    ImmediateMDTNr_ExtIEs = CLASS(name='ImmediateMDTNr-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ImmediateMDTNr_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InterSystemFailureIndication >-----#
    InterSystemFailureIndication = SEQ(name='InterSystemFailureIndication', mode=MODE_TYPE)
    _InterSystemFailureIndication_uERLFReportContainer = CHOICE(name='uERLFReportContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UERLFReportContainer')), opt=True)
    _InterSystemFailureIndication_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InterSystemFailureIndication_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___InterSystemFailureIndication_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____InterSystemFailureIndication_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____InterSystemFailureIndication_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemFailureIndication_iE_Extensions__item__id._const_tab = ____InterSystemFailureIndication_iE_Extensions__item__id_tab
    ___InterSystemFailureIndication_iE_Extensions__item__id._const_tab_at = None
    ___InterSystemFailureIndication_iE_Extensions__item__id._const_tab_id = 'id'
    ___InterSystemFailureIndication_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____InterSystemFailureIndication_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____InterSystemFailureIndication_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemFailureIndication_iE_Extensions__item__criticality._const_tab = ____InterSystemFailureIndication_iE_Extensions__item__criticality_tab
    ___InterSystemFailureIndication_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___InterSystemFailureIndication_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___InterSystemFailureIndication_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____InterSystemFailureIndication_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____InterSystemFailureIndication_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemFailureIndication_iE_Extensions__item__extensionValue._const_tab = ____InterSystemFailureIndication_iE_Extensions__item__extensionValue_tab
    ___InterSystemFailureIndication_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InterSystemFailureIndication_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __InterSystemFailureIndication_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___InterSystemFailureIndication_iE_Extensions__item__id),
        ('criticality', ___InterSystemFailureIndication_iE_Extensions__item__criticality),
        ('extensionValue', ___InterSystemFailureIndication_iE_Extensions__item__extensionValue),
        ])
    __InterSystemFailureIndication_iE_Extensions__item_._ext = None
    _InterSystemFailureIndication_iE_Extensions._cont = __InterSystemFailureIndication_iE_Extensions__item_
    _InterSystemFailureIndication_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InterSystemFailureIndication._cont = ASN1Dict([
        ('uERLFReportContainer', _InterSystemFailureIndication_uERLFReportContainer),
        ('iE-Extensions', _InterSystemFailureIndication_iE_Extensions),
        ])
    InterSystemFailureIndication._ext = []
    
    #-----< InterSystemFailureIndication-ExtIEs >-----#
    InterSystemFailureIndication_ExtIEs = CLASS(name='InterSystemFailureIndication-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    InterSystemFailureIndication_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntersystemSONConfigurationTransfer >-----#
    IntersystemSONConfigurationTransfer = SEQ(name='IntersystemSONConfigurationTransfer', mode=MODE_TYPE)
    _IntersystemSONConfigurationTransfer_transferType = CHOICE(name='transferType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntersystemSONTransferType')))
    _IntersystemSONConfigurationTransfer_intersystemSONInformation = CHOICE(name='intersystemSONInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntersystemSONInformation')))
    _IntersystemSONConfigurationTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IntersystemSONConfigurationTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___IntersystemSONConfigurationTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____IntersystemSONConfigurationTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemSONConfigurationTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemSONConfigurationTransfer_iE_Extensions__item__id._const_tab = ____IntersystemSONConfigurationTransfer_iE_Extensions__item__id_tab
    ___IntersystemSONConfigurationTransfer_iE_Extensions__item__id._const_tab_at = None
    ___IntersystemSONConfigurationTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___IntersystemSONConfigurationTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IntersystemSONConfigurationTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemSONConfigurationTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemSONConfigurationTransfer_iE_Extensions__item__criticality._const_tab = ____IntersystemSONConfigurationTransfer_iE_Extensions__item__criticality_tab
    ___IntersystemSONConfigurationTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IntersystemSONConfigurationTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IntersystemSONConfigurationTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IntersystemSONConfigurationTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemSONConfigurationTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemSONConfigurationTransfer_iE_Extensions__item__extensionValue._const_tab = ____IntersystemSONConfigurationTransfer_iE_Extensions__item__extensionValue_tab
    ___IntersystemSONConfigurationTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IntersystemSONConfigurationTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IntersystemSONConfigurationTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IntersystemSONConfigurationTransfer_iE_Extensions__item__id),
        ('criticality', ___IntersystemSONConfigurationTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___IntersystemSONConfigurationTransfer_iE_Extensions__item__extensionValue),
        ])
    __IntersystemSONConfigurationTransfer_iE_Extensions__item_._ext = None
    _IntersystemSONConfigurationTransfer_iE_Extensions._cont = __IntersystemSONConfigurationTransfer_iE_Extensions__item_
    _IntersystemSONConfigurationTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IntersystemSONConfigurationTransfer._cont = ASN1Dict([
        ('transferType', _IntersystemSONConfigurationTransfer_transferType),
        ('intersystemSONInformation', _IntersystemSONConfigurationTransfer_intersystemSONInformation),
        ('iE-Extensions', _IntersystemSONConfigurationTransfer_iE_Extensions),
        ])
    IntersystemSONConfigurationTransfer._ext = []
    
    #-----< IntersystemSONConfigurationTransfer-ExtIEs >-----#
    IntersystemSONConfigurationTransfer_ExtIEs = CLASS(name='IntersystemSONConfigurationTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    IntersystemSONConfigurationTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntersystemSONTransferType >-----#
    IntersystemSONTransferType = CHOICE(name='IntersystemSONTransferType', mode=MODE_TYPE)
    _IntersystemSONTransferType_fromEUTRANtoNGRAN = SEQ(name='fromEUTRANtoNGRAN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FromEUTRANtoNGRAN')))
    _IntersystemSONTransferType_fromNGRANtoEUTRAN = SEQ(name='fromNGRANtoEUTRAN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FromNGRANtoEUTRAN')))
    _IntersystemSONTransferType_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __IntersystemSONTransferType_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___IntersystemSONTransferType_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___IntersystemSONTransferType_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IntersystemSONTransferType_choice_Extensions_id._const_tab = ___IntersystemSONTransferType_choice_Extensions_id_tab
    __IntersystemSONTransferType_choice_Extensions_id._const_tab_at = None
    __IntersystemSONTransferType_choice_Extensions_id._const_tab_id = 'id'
    __IntersystemSONTransferType_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___IntersystemSONTransferType_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___IntersystemSONTransferType_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IntersystemSONTransferType_choice_Extensions_criticality._const_tab = ___IntersystemSONTransferType_choice_Extensions_criticality_tab
    __IntersystemSONTransferType_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __IntersystemSONTransferType_choice_Extensions_criticality._const_tab_id = 'criticality'
    __IntersystemSONTransferType_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___IntersystemSONTransferType_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___IntersystemSONTransferType_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IntersystemSONTransferType_choice_Extensions_value._const_tab = ___IntersystemSONTransferType_choice_Extensions_value_tab
    __IntersystemSONTransferType_choice_Extensions_value._const_tab_at = ('..', 'id')
    __IntersystemSONTransferType_choice_Extensions_value._const_tab_id = 'Value'
    _IntersystemSONTransferType_choice_Extensions._cont = ASN1Dict([
        ('id', __IntersystemSONTransferType_choice_Extensions_id),
        ('criticality', __IntersystemSONTransferType_choice_Extensions_criticality),
        ('value', __IntersystemSONTransferType_choice_Extensions_value),
        ])
    _IntersystemSONTransferType_choice_Extensions._ext = None
    IntersystemSONTransferType._cont = ASN1Dict([
        ('fromEUTRANtoNGRAN', _IntersystemSONTransferType_fromEUTRANtoNGRAN),
        ('fromNGRANtoEUTRAN', _IntersystemSONTransferType_fromNGRANtoEUTRAN),
        ('choice-Extensions', _IntersystemSONTransferType_choice_Extensions),
        ])
    IntersystemSONTransferType._ext = None
    
    #-----< IntersystemSONTransferType-ExtIEs >-----#
    IntersystemSONTransferType_ExtIEs = CLASS(name='IntersystemSONTransferType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    IntersystemSONTransferType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntersystemSONeNBID >-----#
    IntersystemSONeNBID = SEQ(name='IntersystemSONeNBID', mode=MODE_TYPE)
    _IntersystemSONeNBID_globaleNBID = SEQ(name='globaleNBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalENB-ID')))
    _IntersystemSONeNBID_selectedEPSTAI = SEQ(name='selectedEPSTAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EPS-TAI')))
    _IntersystemSONeNBID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IntersystemSONeNBID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___IntersystemSONeNBID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____IntersystemSONeNBID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemSONeNBID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemSONeNBID_iE_Extensions__item__id._const_tab = ____IntersystemSONeNBID_iE_Extensions__item__id_tab
    ___IntersystemSONeNBID_iE_Extensions__item__id._const_tab_at = None
    ___IntersystemSONeNBID_iE_Extensions__item__id._const_tab_id = 'id'
    ___IntersystemSONeNBID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IntersystemSONeNBID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemSONeNBID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemSONeNBID_iE_Extensions__item__criticality._const_tab = ____IntersystemSONeNBID_iE_Extensions__item__criticality_tab
    ___IntersystemSONeNBID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IntersystemSONeNBID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IntersystemSONeNBID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IntersystemSONeNBID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemSONeNBID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemSONeNBID_iE_Extensions__item__extensionValue._const_tab = ____IntersystemSONeNBID_iE_Extensions__item__extensionValue_tab
    ___IntersystemSONeNBID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IntersystemSONeNBID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IntersystemSONeNBID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IntersystemSONeNBID_iE_Extensions__item__id),
        ('criticality', ___IntersystemSONeNBID_iE_Extensions__item__criticality),
        ('extensionValue', ___IntersystemSONeNBID_iE_Extensions__item__extensionValue),
        ])
    __IntersystemSONeNBID_iE_Extensions__item_._ext = None
    _IntersystemSONeNBID_iE_Extensions._cont = __IntersystemSONeNBID_iE_Extensions__item_
    _IntersystemSONeNBID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IntersystemSONeNBID._cont = ASN1Dict([
        ('globaleNBID', _IntersystemSONeNBID_globaleNBID),
        ('selectedEPSTAI', _IntersystemSONeNBID_selectedEPSTAI),
        ('iE-Extensions', _IntersystemSONeNBID_iE_Extensions),
        ])
    IntersystemSONeNBID._ext = []
    
    #-----< IntersystemSONeNBID-ExtIEs >-----#
    IntersystemSONeNBID_ExtIEs = CLASS(name='IntersystemSONeNBID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    IntersystemSONeNBID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntersystemSONNGRANnodeID >-----#
    IntersystemSONNGRANnodeID = SEQ(name='IntersystemSONNGRANnodeID', mode=MODE_TYPE)
    _IntersystemSONNGRANnodeID_globalRANNodeID = CHOICE(name='globalRANNodeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _IntersystemSONNGRANnodeID_selectedTAI = SEQ(name='selectedTAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _IntersystemSONNGRANnodeID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IntersystemSONNGRANnodeID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___IntersystemSONNGRANnodeID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____IntersystemSONNGRANnodeID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemSONNGRANnodeID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemSONNGRANnodeID_iE_Extensions__item__id._const_tab = ____IntersystemSONNGRANnodeID_iE_Extensions__item__id_tab
    ___IntersystemSONNGRANnodeID_iE_Extensions__item__id._const_tab_at = None
    ___IntersystemSONNGRANnodeID_iE_Extensions__item__id._const_tab_id = 'id'
    ___IntersystemSONNGRANnodeID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IntersystemSONNGRANnodeID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemSONNGRANnodeID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemSONNGRANnodeID_iE_Extensions__item__criticality._const_tab = ____IntersystemSONNGRANnodeID_iE_Extensions__item__criticality_tab
    ___IntersystemSONNGRANnodeID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IntersystemSONNGRANnodeID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IntersystemSONNGRANnodeID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IntersystemSONNGRANnodeID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemSONNGRANnodeID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemSONNGRANnodeID_iE_Extensions__item__extensionValue._const_tab = ____IntersystemSONNGRANnodeID_iE_Extensions__item__extensionValue_tab
    ___IntersystemSONNGRANnodeID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IntersystemSONNGRANnodeID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IntersystemSONNGRANnodeID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IntersystemSONNGRANnodeID_iE_Extensions__item__id),
        ('criticality', ___IntersystemSONNGRANnodeID_iE_Extensions__item__criticality),
        ('extensionValue', ___IntersystemSONNGRANnodeID_iE_Extensions__item__extensionValue),
        ])
    __IntersystemSONNGRANnodeID_iE_Extensions__item_._ext = None
    _IntersystemSONNGRANnodeID_iE_Extensions._cont = __IntersystemSONNGRANnodeID_iE_Extensions__item_
    _IntersystemSONNGRANnodeID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IntersystemSONNGRANnodeID._cont = ASN1Dict([
        ('globalRANNodeID', _IntersystemSONNGRANnodeID_globalRANNodeID),
        ('selectedTAI', _IntersystemSONNGRANnodeID_selectedTAI),
        ('iE-Extensions', _IntersystemSONNGRANnodeID_iE_Extensions),
        ])
    IntersystemSONNGRANnodeID._ext = []
    
    #-----< IntersystemSONNGRANnodeID-ExtIEs >-----#
    IntersystemSONNGRANnodeID_ExtIEs = CLASS(name='IntersystemSONNGRANnodeID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    IntersystemSONNGRANnodeID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntersystemSONInformation >-----#
    IntersystemSONInformation = CHOICE(name='IntersystemSONInformation', mode=MODE_TYPE)
    _IntersystemSONInformation_intersystemSONInformationReport = CHOICE(name='intersystemSONInformationReport', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntersystemSONInformationReport')))
    _IntersystemSONInformation_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __IntersystemSONInformation_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___IntersystemSONInformation_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ____IntersystemSONInformation_choice_Extensions_id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IntersystemSONInformationRequest')))
    ____IntersystemSONInformation_choice_Extensions_id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IntersystemSONInformationReply')))
    ___IntersystemSONInformation_choice_Extensions_id_tab._val = ASN1Set(rv=[dict([('id', 290), ('criticality', 'ignore'), ('Value', ____IntersystemSONInformation_choice_Extensions_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 291), ('criticality', 'ignore'), ('Value', ____IntersystemSONInformation_choice_Extensions_id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __IntersystemSONInformation_choice_Extensions_id._const_tab = ___IntersystemSONInformation_choice_Extensions_id_tab
    __IntersystemSONInformation_choice_Extensions_id._const_tab_at = None
    __IntersystemSONInformation_choice_Extensions_id._const_tab_id = 'id'
    __IntersystemSONInformation_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    __IntersystemSONInformation_choice_Extensions_criticality._const_tab = ___IntersystemSONInformation_choice_Extensions_id_tab
    __IntersystemSONInformation_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __IntersystemSONInformation_choice_Extensions_criticality._const_tab_id = 'criticality'
    __IntersystemSONInformation_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    __IntersystemSONInformation_choice_Extensions_value._const_tab = ___IntersystemSONInformation_choice_Extensions_id_tab
    __IntersystemSONInformation_choice_Extensions_value._const_tab_at = ('..', 'id')
    __IntersystemSONInformation_choice_Extensions_value._const_tab_id = 'Value'
    _IntersystemSONInformation_choice_Extensions._cont = ASN1Dict([
        ('id', __IntersystemSONInformation_choice_Extensions_id),
        ('criticality', __IntersystemSONInformation_choice_Extensions_criticality),
        ('value', __IntersystemSONInformation_choice_Extensions_value),
        ])
    _IntersystemSONInformation_choice_Extensions._ext = None
    IntersystemSONInformation._cont = ASN1Dict([
        ('intersystemSONInformationReport', _IntersystemSONInformation_intersystemSONInformationReport),
        ('choice-Extensions', _IntersystemSONInformation_choice_Extensions),
        ])
    IntersystemSONInformation._ext = None
    
    #-----< IntersystemSONInformation-ExtIEs >-----#
    IntersystemSONInformation_ExtIEs = CLASS(name='IntersystemSONInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _IntersystemSONInformation_ExtIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IntersystemSONInformationRequest')))
    _IntersystemSONInformation_ExtIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IntersystemSONInformationReply')))
    IntersystemSONInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 290), ('criticality', 'ignore'), ('Value', _IntersystemSONInformation_ExtIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 291), ('criticality', 'ignore'), ('Value', _IntersystemSONInformation_ExtIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< IntersystemSONInformationRequest >-----#
    IntersystemSONInformationRequest = CHOICE(name='IntersystemSONInformationRequest', mode=MODE_TYPE)
    _IntersystemSONInformationRequest_nGRAN_CellActivation = SEQ(name='nGRAN-CellActivation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntersystemCellActivationRequest')))
    _IntersystemSONInformationRequest_resourceStatus = SEQ(name='resourceStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntersystemResourceStatusRequest')))
    _IntersystemSONInformationRequest_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __IntersystemSONInformationRequest_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___IntersystemSONInformationRequest_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___IntersystemSONInformationRequest_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IntersystemSONInformationRequest_choice_Extensions_id._const_tab = ___IntersystemSONInformationRequest_choice_Extensions_id_tab
    __IntersystemSONInformationRequest_choice_Extensions_id._const_tab_at = None
    __IntersystemSONInformationRequest_choice_Extensions_id._const_tab_id = 'id'
    __IntersystemSONInformationRequest_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___IntersystemSONInformationRequest_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___IntersystemSONInformationRequest_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IntersystemSONInformationRequest_choice_Extensions_criticality._const_tab = ___IntersystemSONInformationRequest_choice_Extensions_criticality_tab
    __IntersystemSONInformationRequest_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __IntersystemSONInformationRequest_choice_Extensions_criticality._const_tab_id = 'criticality'
    __IntersystemSONInformationRequest_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___IntersystemSONInformationRequest_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___IntersystemSONInformationRequest_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IntersystemSONInformationRequest_choice_Extensions_value._const_tab = ___IntersystemSONInformationRequest_choice_Extensions_value_tab
    __IntersystemSONInformationRequest_choice_Extensions_value._const_tab_at = ('..', 'id')
    __IntersystemSONInformationRequest_choice_Extensions_value._const_tab_id = 'Value'
    _IntersystemSONInformationRequest_choice_Extensions._cont = ASN1Dict([
        ('id', __IntersystemSONInformationRequest_choice_Extensions_id),
        ('criticality', __IntersystemSONInformationRequest_choice_Extensions_criticality),
        ('value', __IntersystemSONInformationRequest_choice_Extensions_value),
        ])
    _IntersystemSONInformationRequest_choice_Extensions._ext = None
    IntersystemSONInformationRequest._cont = ASN1Dict([
        ('nGRAN-CellActivation', _IntersystemSONInformationRequest_nGRAN_CellActivation),
        ('resourceStatus', _IntersystemSONInformationRequest_resourceStatus),
        ('choice-Extensions', _IntersystemSONInformationRequest_choice_Extensions),
        ])
    IntersystemSONInformationRequest._ext = None
    
    #-----< IntersystemSONInformationRequest-ExtIEs >-----#
    IntersystemSONInformationRequest_ExtIEs = CLASS(name='IntersystemSONInformationRequest-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    IntersystemSONInformationRequest_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntersystemCellActivationRequest >-----#
    IntersystemCellActivationRequest = SEQ(name='IntersystemCellActivationRequest', mode=MODE_TYPE)
    _IntersystemCellActivationRequest_activationID = INT(name='activationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IntersystemCellActivationRequest_activationID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16384)], ev=[], er=[])
    _IntersystemCellActivationRequest_cellsToActivateList = SEQ_OF(name='cellsToActivateList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellsToActivateList')))
    _IntersystemCellActivationRequest_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IntersystemCellActivationRequest_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___IntersystemCellActivationRequest_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____IntersystemCellActivationRequest_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemCellActivationRequest_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemCellActivationRequest_iE_Extensions__item__id._const_tab = ____IntersystemCellActivationRequest_iE_Extensions__item__id_tab
    ___IntersystemCellActivationRequest_iE_Extensions__item__id._const_tab_at = None
    ___IntersystemCellActivationRequest_iE_Extensions__item__id._const_tab_id = 'id'
    ___IntersystemCellActivationRequest_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IntersystemCellActivationRequest_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemCellActivationRequest_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemCellActivationRequest_iE_Extensions__item__criticality._const_tab = ____IntersystemCellActivationRequest_iE_Extensions__item__criticality_tab
    ___IntersystemCellActivationRequest_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IntersystemCellActivationRequest_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IntersystemCellActivationRequest_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IntersystemCellActivationRequest_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemCellActivationRequest_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemCellActivationRequest_iE_Extensions__item__extensionValue._const_tab = ____IntersystemCellActivationRequest_iE_Extensions__item__extensionValue_tab
    ___IntersystemCellActivationRequest_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IntersystemCellActivationRequest_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IntersystemCellActivationRequest_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IntersystemCellActivationRequest_iE_Extensions__item__id),
        ('criticality', ___IntersystemCellActivationRequest_iE_Extensions__item__criticality),
        ('extensionValue', ___IntersystemCellActivationRequest_iE_Extensions__item__extensionValue),
        ])
    __IntersystemCellActivationRequest_iE_Extensions__item_._ext = None
    _IntersystemCellActivationRequest_iE_Extensions._cont = __IntersystemCellActivationRequest_iE_Extensions__item_
    _IntersystemCellActivationRequest_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IntersystemCellActivationRequest._cont = ASN1Dict([
        ('activationID', _IntersystemCellActivationRequest_activationID),
        ('cellsToActivateList', _IntersystemCellActivationRequest_cellsToActivateList),
        ('iE-Extensions', _IntersystemCellActivationRequest_iE_Extensions),
        ])
    IntersystemCellActivationRequest._ext = []
    
    #-----< IntersystemCellActivationRequest-ExtIEs >-----#
    IntersystemCellActivationRequest_ExtIEs = CLASS(name='IntersystemCellActivationRequest-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    IntersystemCellActivationRequest_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellsToActivateList >-----#
    CellsToActivateList = SEQ_OF(name='CellsToActivateList', mode=MODE_TYPE)
    _CellsToActivateList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    CellsToActivateList._cont = _CellsToActivateList__item_
    CellsToActivateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< IntersystemResourceStatusRequest >-----#
    IntersystemResourceStatusRequest = SEQ(name='IntersystemResourceStatusRequest', mode=MODE_TYPE)
    _IntersystemResourceStatusRequest_reportingSystem = CHOICE(name='reportingSystem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ReportingSystem')))
    _IntersystemResourceStatusRequest_reportCharacteristics = BIT_STR(name='reportCharacteristics', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ReportCharacteristics')))
    _IntersystemResourceStatusRequest_reportType = CHOICE(name='reportType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ReportType')))
    _IntersystemResourceStatusRequest_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IntersystemResourceStatusRequest_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___IntersystemResourceStatusRequest_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____IntersystemResourceStatusRequest_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemResourceStatusRequest_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemResourceStatusRequest_iE_Extensions__item__id._const_tab = ____IntersystemResourceStatusRequest_iE_Extensions__item__id_tab
    ___IntersystemResourceStatusRequest_iE_Extensions__item__id._const_tab_at = None
    ___IntersystemResourceStatusRequest_iE_Extensions__item__id._const_tab_id = 'id'
    ___IntersystemResourceStatusRequest_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IntersystemResourceStatusRequest_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemResourceStatusRequest_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemResourceStatusRequest_iE_Extensions__item__criticality._const_tab = ____IntersystemResourceStatusRequest_iE_Extensions__item__criticality_tab
    ___IntersystemResourceStatusRequest_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IntersystemResourceStatusRequest_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IntersystemResourceStatusRequest_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IntersystemResourceStatusRequest_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemResourceStatusRequest_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemResourceStatusRequest_iE_Extensions__item__extensionValue._const_tab = ____IntersystemResourceStatusRequest_iE_Extensions__item__extensionValue_tab
    ___IntersystemResourceStatusRequest_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IntersystemResourceStatusRequest_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IntersystemResourceStatusRequest_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IntersystemResourceStatusRequest_iE_Extensions__item__id),
        ('criticality', ___IntersystemResourceStatusRequest_iE_Extensions__item__criticality),
        ('extensionValue', ___IntersystemResourceStatusRequest_iE_Extensions__item__extensionValue),
        ])
    __IntersystemResourceStatusRequest_iE_Extensions__item_._ext = None
    _IntersystemResourceStatusRequest_iE_Extensions._cont = __IntersystemResourceStatusRequest_iE_Extensions__item_
    _IntersystemResourceStatusRequest_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IntersystemResourceStatusRequest._cont = ASN1Dict([
        ('reportingSystem', _IntersystemResourceStatusRequest_reportingSystem),
        ('reportCharacteristics', _IntersystemResourceStatusRequest_reportCharacteristics),
        ('reportType', _IntersystemResourceStatusRequest_reportType),
        ('iE-Extensions', _IntersystemResourceStatusRequest_iE_Extensions),
        ])
    IntersystemResourceStatusRequest._ext = []
    
    #-----< IntersystemResourceStatusRequest-ExtIEs >-----#
    IntersystemResourceStatusRequest_ExtIEs = CLASS(name='IntersystemResourceStatusRequest-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    IntersystemResourceStatusRequest_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ReportingSystem >-----#
    ReportingSystem = CHOICE(name='ReportingSystem', mode=MODE_TYPE)
    _ReportingSystem_eUTRAN = SEQ(name='eUTRAN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRAN-ReportingSystemIEs')))
    _ReportingSystem_nGRAN = SEQ(name='nGRAN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-ReportingSystemIEs')))
    _ReportingSystem_noReporting = NULL(name='noReporting', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ReportingSystem_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __ReportingSystem_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___ReportingSystem_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ReportingSystem_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReportingSystem_choice_Extensions_id._const_tab = ___ReportingSystem_choice_Extensions_id_tab
    __ReportingSystem_choice_Extensions_id._const_tab_at = None
    __ReportingSystem_choice_Extensions_id._const_tab_id = 'id'
    __ReportingSystem_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___ReportingSystem_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ReportingSystem_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReportingSystem_choice_Extensions_criticality._const_tab = ___ReportingSystem_choice_Extensions_criticality_tab
    __ReportingSystem_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __ReportingSystem_choice_Extensions_criticality._const_tab_id = 'criticality'
    __ReportingSystem_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___ReportingSystem_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ReportingSystem_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReportingSystem_choice_Extensions_value._const_tab = ___ReportingSystem_choice_Extensions_value_tab
    __ReportingSystem_choice_Extensions_value._const_tab_at = ('..', 'id')
    __ReportingSystem_choice_Extensions_value._const_tab_id = 'Value'
    _ReportingSystem_choice_Extensions._cont = ASN1Dict([
        ('id', __ReportingSystem_choice_Extensions_id),
        ('criticality', __ReportingSystem_choice_Extensions_criticality),
        ('value', __ReportingSystem_choice_Extensions_value),
        ])
    _ReportingSystem_choice_Extensions._ext = None
    ReportingSystem._cont = ASN1Dict([
        ('eUTRAN', _ReportingSystem_eUTRAN),
        ('nGRAN', _ReportingSystem_nGRAN),
        ('noReporting', _ReportingSystem_noReporting),
        ('choice-Extensions', _ReportingSystem_choice_Extensions),
        ])
    ReportingSystem._ext = None
    
    #-----< ReportingSystem-ExtIEs >-----#
    ReportingSystem_ExtIEs = CLASS(name='ReportingSystem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ReportingSystem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRAN-ReportingSystemIEs >-----#
    EUTRAN_ReportingSystemIEs = SEQ(name='EUTRAN-ReportingSystemIEs', mode=MODE_TYPE)
    _EUTRAN_ReportingSystemIEs_eUTRAN_CellToReportList = SEQ_OF(name='eUTRAN-CellToReportList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRAN-CellToReportList')))
    _EUTRAN_ReportingSystemIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRAN_ReportingSystemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EUTRAN_ReportingSystemIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____EUTRAN_ReportingSystemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRAN_ReportingSystemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_ReportingSystemIEs_iE_Extensions__item__id._const_tab = ____EUTRAN_ReportingSystemIEs_iE_Extensions__item__id_tab
    ___EUTRAN_ReportingSystemIEs_iE_Extensions__item__id._const_tab_at = None
    ___EUTRAN_ReportingSystemIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___EUTRAN_ReportingSystemIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EUTRAN_ReportingSystemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRAN_ReportingSystemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_ReportingSystemIEs_iE_Extensions__item__criticality._const_tab = ____EUTRAN_ReportingSystemIEs_iE_Extensions__item__criticality_tab
    ___EUTRAN_ReportingSystemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EUTRAN_ReportingSystemIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EUTRAN_ReportingSystemIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EUTRAN_ReportingSystemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRAN_ReportingSystemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_ReportingSystemIEs_iE_Extensions__item__extensionValue._const_tab = ____EUTRAN_ReportingSystemIEs_iE_Extensions__item__extensionValue_tab
    ___EUTRAN_ReportingSystemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EUTRAN_ReportingSystemIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EUTRAN_ReportingSystemIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EUTRAN_ReportingSystemIEs_iE_Extensions__item__id),
        ('criticality', ___EUTRAN_ReportingSystemIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___EUTRAN_ReportingSystemIEs_iE_Extensions__item__extensionValue),
        ])
    __EUTRAN_ReportingSystemIEs_iE_Extensions__item_._ext = None
    _EUTRAN_ReportingSystemIEs_iE_Extensions._cont = __EUTRAN_ReportingSystemIEs_iE_Extensions__item_
    _EUTRAN_ReportingSystemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRAN_ReportingSystemIEs._cont = ASN1Dict([
        ('eUTRAN-CellToReportList', _EUTRAN_ReportingSystemIEs_eUTRAN_CellToReportList),
        ('iE-Extensions', _EUTRAN_ReportingSystemIEs_iE_Extensions),
        ])
    EUTRAN_ReportingSystemIEs._ext = []
    
    #-----< EUTRAN-ReportingSystemIEs-ExtIEs >-----#
    EUTRAN_ReportingSystemIEs_ExtIEs = CLASS(name='EUTRAN-ReportingSystemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EUTRAN_ReportingSystemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NGRAN-ReportingSystemIEs >-----#
    NGRAN_ReportingSystemIEs = SEQ(name='NGRAN-ReportingSystemIEs', mode=MODE_TYPE)
    _NGRAN_ReportingSystemIEs_nGRAN_CellToReportList = SEQ_OF(name='nGRAN-CellToReportList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CellToReportList')))
    _NGRAN_ReportingSystemIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NGRAN_ReportingSystemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___NGRAN_ReportingSystemIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____NGRAN_ReportingSystemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGRAN_ReportingSystemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRAN_ReportingSystemIEs_iE_Extensions__item__id._const_tab = ____NGRAN_ReportingSystemIEs_iE_Extensions__item__id_tab
    ___NGRAN_ReportingSystemIEs_iE_Extensions__item__id._const_tab_at = None
    ___NGRAN_ReportingSystemIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___NGRAN_ReportingSystemIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NGRAN_ReportingSystemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGRAN_ReportingSystemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRAN_ReportingSystemIEs_iE_Extensions__item__criticality._const_tab = ____NGRAN_ReportingSystemIEs_iE_Extensions__item__criticality_tab
    ___NGRAN_ReportingSystemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NGRAN_ReportingSystemIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NGRAN_ReportingSystemIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NGRAN_ReportingSystemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGRAN_ReportingSystemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRAN_ReportingSystemIEs_iE_Extensions__item__extensionValue._const_tab = ____NGRAN_ReportingSystemIEs_iE_Extensions__item__extensionValue_tab
    ___NGRAN_ReportingSystemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NGRAN_ReportingSystemIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NGRAN_ReportingSystemIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NGRAN_ReportingSystemIEs_iE_Extensions__item__id),
        ('criticality', ___NGRAN_ReportingSystemIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___NGRAN_ReportingSystemIEs_iE_Extensions__item__extensionValue),
        ])
    __NGRAN_ReportingSystemIEs_iE_Extensions__item_._ext = None
    _NGRAN_ReportingSystemIEs_iE_Extensions._cont = __NGRAN_ReportingSystemIEs_iE_Extensions__item_
    _NGRAN_ReportingSystemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NGRAN_ReportingSystemIEs._cont = ASN1Dict([
        ('nGRAN-CellToReportList', _NGRAN_ReportingSystemIEs_nGRAN_CellToReportList),
        ('iE-Extensions', _NGRAN_ReportingSystemIEs_iE_Extensions),
        ])
    NGRAN_ReportingSystemIEs._ext = []
    
    #-----< NGRAN-ReportingSystemIEs-ExtIEs >-----#
    NGRAN_ReportingSystemIEs_ExtIEs = CLASS(name='NGRAN-ReportingSystemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    NGRAN_ReportingSystemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRAN-CellToReportList >-----#
    EUTRAN_CellToReportList = SEQ_OF(name='EUTRAN-CellToReportList', mode=MODE_TYPE)
    _EUTRAN_CellToReportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EUTRAN-CellToReportItem')))
    EUTRAN_CellToReportList._cont = _EUTRAN_CellToReportList__item_
    EUTRAN_CellToReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< EUTRAN-CellToReportItem >-----#
    EUTRAN_CellToReportItem = SEQ(name='EUTRAN-CellToReportItem', mode=MODE_TYPE)
    _EUTRAN_CellToReportItem_eCGI = SEQ(name='eCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _EUTRAN_CellToReportItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRAN_CellToReportItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EUTRAN_CellToReportItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____EUTRAN_CellToReportItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRAN_CellToReportItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_CellToReportItem_iE_Extensions__item__id._const_tab = ____EUTRAN_CellToReportItem_iE_Extensions__item__id_tab
    ___EUTRAN_CellToReportItem_iE_Extensions__item__id._const_tab_at = None
    ___EUTRAN_CellToReportItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___EUTRAN_CellToReportItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EUTRAN_CellToReportItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRAN_CellToReportItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_CellToReportItem_iE_Extensions__item__criticality._const_tab = ____EUTRAN_CellToReportItem_iE_Extensions__item__criticality_tab
    ___EUTRAN_CellToReportItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EUTRAN_CellToReportItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EUTRAN_CellToReportItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EUTRAN_CellToReportItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRAN_CellToReportItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_CellToReportItem_iE_Extensions__item__extensionValue._const_tab = ____EUTRAN_CellToReportItem_iE_Extensions__item__extensionValue_tab
    ___EUTRAN_CellToReportItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EUTRAN_CellToReportItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EUTRAN_CellToReportItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EUTRAN_CellToReportItem_iE_Extensions__item__id),
        ('criticality', ___EUTRAN_CellToReportItem_iE_Extensions__item__criticality),
        ('extensionValue', ___EUTRAN_CellToReportItem_iE_Extensions__item__extensionValue),
        ])
    __EUTRAN_CellToReportItem_iE_Extensions__item_._ext = None
    _EUTRAN_CellToReportItem_iE_Extensions._cont = __EUTRAN_CellToReportItem_iE_Extensions__item_
    _EUTRAN_CellToReportItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRAN_CellToReportItem._cont = ASN1Dict([
        ('eCGI', _EUTRAN_CellToReportItem_eCGI),
        ('iE-Extensions', _EUTRAN_CellToReportItem_iE_Extensions),
        ])
    EUTRAN_CellToReportItem._ext = []
    
    #-----< EUTRAN-CellToReportItem-ExtIEs >-----#
    EUTRAN_CellToReportItem_ExtIEs = CLASS(name='EUTRAN-CellToReportItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EUTRAN_CellToReportItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NGRAN-CellToReportList >-----#
    NGRAN_CellToReportList = SEQ_OF(name='NGRAN-CellToReportList', mode=MODE_TYPE)
    _NGRAN_CellToReportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CellToReportItem')))
    NGRAN_CellToReportList._cont = _NGRAN_CellToReportList__item_
    NGRAN_CellToReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< NGRAN-CellToReportItem >-----#
    NGRAN_CellToReportItem = SEQ(name='NGRAN-CellToReportItem', mode=MODE_TYPE)
    _NGRAN_CellToReportItem_nGRAN_CGI = CHOICE(name='nGRAN-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _NGRAN_CellToReportItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NGRAN_CellToReportItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___NGRAN_CellToReportItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____NGRAN_CellToReportItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGRAN_CellToReportItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRAN_CellToReportItem_iE_Extensions__item__id._const_tab = ____NGRAN_CellToReportItem_iE_Extensions__item__id_tab
    ___NGRAN_CellToReportItem_iE_Extensions__item__id._const_tab_at = None
    ___NGRAN_CellToReportItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___NGRAN_CellToReportItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NGRAN_CellToReportItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGRAN_CellToReportItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRAN_CellToReportItem_iE_Extensions__item__criticality._const_tab = ____NGRAN_CellToReportItem_iE_Extensions__item__criticality_tab
    ___NGRAN_CellToReportItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NGRAN_CellToReportItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NGRAN_CellToReportItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NGRAN_CellToReportItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGRAN_CellToReportItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRAN_CellToReportItem_iE_Extensions__item__extensionValue._const_tab = ____NGRAN_CellToReportItem_iE_Extensions__item__extensionValue_tab
    ___NGRAN_CellToReportItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NGRAN_CellToReportItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NGRAN_CellToReportItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NGRAN_CellToReportItem_iE_Extensions__item__id),
        ('criticality', ___NGRAN_CellToReportItem_iE_Extensions__item__criticality),
        ('extensionValue', ___NGRAN_CellToReportItem_iE_Extensions__item__extensionValue),
        ])
    __NGRAN_CellToReportItem_iE_Extensions__item_._ext = None
    _NGRAN_CellToReportItem_iE_Extensions._cont = __NGRAN_CellToReportItem_iE_Extensions__item_
    _NGRAN_CellToReportItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NGRAN_CellToReportItem._cont = ASN1Dict([
        ('nGRAN-CGI', _NGRAN_CellToReportItem_nGRAN_CGI),
        ('iE-Extensions', _NGRAN_CellToReportItem_iE_Extensions),
        ])
    NGRAN_CellToReportItem._ext = []
    
    #-----< NGRAN-CellToReportItem-ExtIEs >-----#
    NGRAN_CellToReportItem_ExtIEs = CLASS(name='NGRAN-CellToReportItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    NGRAN_CellToReportItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ReportCharacteristics >-----#
    ReportCharacteristics = BIT_STR(name='ReportCharacteristics', mode=MODE_TYPE)
    ReportCharacteristics._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< ReportType >-----#
    ReportType = CHOICE(name='ReportType', mode=MODE_TYPE)
    _ReportType_eventBasedReporting = SEQ(name='eventBasedReporting', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EventBasedReportingIEs')))
    _ReportType_periodicReporting = SEQ(name='periodicReporting', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PeriodicReportingIEs')))
    _ReportType_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __ReportType_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___ReportType_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ReportType_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReportType_choice_Extensions_id._const_tab = ___ReportType_choice_Extensions_id_tab
    __ReportType_choice_Extensions_id._const_tab_at = None
    __ReportType_choice_Extensions_id._const_tab_id = 'id'
    __ReportType_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___ReportType_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ReportType_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReportType_choice_Extensions_criticality._const_tab = ___ReportType_choice_Extensions_criticality_tab
    __ReportType_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __ReportType_choice_Extensions_criticality._const_tab_id = 'criticality'
    __ReportType_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___ReportType_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ReportType_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReportType_choice_Extensions_value._const_tab = ___ReportType_choice_Extensions_value_tab
    __ReportType_choice_Extensions_value._const_tab_at = ('..', 'id')
    __ReportType_choice_Extensions_value._const_tab_id = 'Value'
    _ReportType_choice_Extensions._cont = ASN1Dict([
        ('id', __ReportType_choice_Extensions_id),
        ('criticality', __ReportType_choice_Extensions_criticality),
        ('value', __ReportType_choice_Extensions_value),
        ])
    _ReportType_choice_Extensions._ext = None
    ReportType._cont = ASN1Dict([
        ('eventBasedReporting', _ReportType_eventBasedReporting),
        ('periodicReporting', _ReportType_periodicReporting),
        ('choice-Extensions', _ReportType_choice_Extensions),
        ])
    ReportType._ext = None
    
    #-----< ReportType-ExtIEs >-----#
    ReportType_ExtIEs = CLASS(name='ReportType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ReportType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EventBasedReportingIEs >-----#
    EventBasedReportingIEs = SEQ(name='EventBasedReportingIEs', mode=MODE_TYPE)
    _EventBasedReportingIEs_intersystemResourceThresholdLow = INT(name='intersystemResourceThresholdLow', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntersystemResourceThreshold')))
    _EventBasedReportingIEs_intersystemResourceThresholdHigh = INT(name='intersystemResourceThresholdHigh', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntersystemResourceThreshold')))
    _EventBasedReportingIEs_numberOfMeasurementReportingLevels = ENUM(name='numberOfMeasurementReportingLevels', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NumberOfMeasurementReportingLevels')))
    _EventBasedReportingIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EventBasedReportingIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EventBasedReportingIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____EventBasedReportingIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EventBasedReportingIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventBasedReportingIEs_iE_Extensions__item__id._const_tab = ____EventBasedReportingIEs_iE_Extensions__item__id_tab
    ___EventBasedReportingIEs_iE_Extensions__item__id._const_tab_at = None
    ___EventBasedReportingIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___EventBasedReportingIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EventBasedReportingIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EventBasedReportingIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventBasedReportingIEs_iE_Extensions__item__criticality._const_tab = ____EventBasedReportingIEs_iE_Extensions__item__criticality_tab
    ___EventBasedReportingIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EventBasedReportingIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EventBasedReportingIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EventBasedReportingIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EventBasedReportingIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventBasedReportingIEs_iE_Extensions__item__extensionValue._const_tab = ____EventBasedReportingIEs_iE_Extensions__item__extensionValue_tab
    ___EventBasedReportingIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EventBasedReportingIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EventBasedReportingIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EventBasedReportingIEs_iE_Extensions__item__id),
        ('criticality', ___EventBasedReportingIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___EventBasedReportingIEs_iE_Extensions__item__extensionValue),
        ])
    __EventBasedReportingIEs_iE_Extensions__item_._ext = None
    _EventBasedReportingIEs_iE_Extensions._cont = __EventBasedReportingIEs_iE_Extensions__item_
    _EventBasedReportingIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EventBasedReportingIEs._cont = ASN1Dict([
        ('intersystemResourceThresholdLow', _EventBasedReportingIEs_intersystemResourceThresholdLow),
        ('intersystemResourceThresholdHigh', _EventBasedReportingIEs_intersystemResourceThresholdHigh),
        ('numberOfMeasurementReportingLevels', _EventBasedReportingIEs_numberOfMeasurementReportingLevels),
        ('iE-Extensions', _EventBasedReportingIEs_iE_Extensions),
        ])
    EventBasedReportingIEs._ext = []
    
    #-----< EventBasedReportingIEs-ExtIEs >-----#
    EventBasedReportingIEs_ExtIEs = CLASS(name='EventBasedReportingIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EventBasedReportingIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntersystemResourceThreshold >-----#
    IntersystemResourceThreshold = INT(name='IntersystemResourceThreshold', mode=MODE_TYPE)
    IntersystemResourceThreshold._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< NumberOfMeasurementReportingLevels >-----#
    NumberOfMeasurementReportingLevels = ENUM(name='NumberOfMeasurementReportingLevels', mode=MODE_TYPE)
    NumberOfMeasurementReportingLevels._cont = ASN1Dict([('n2', 0), ('n3', 1), ('n4', 2), ('n5', 3), ('n10', 4)])
    NumberOfMeasurementReportingLevels._ext = []
    
    #-----< PeriodicReportingIEs >-----#
    PeriodicReportingIEs = SEQ(name='PeriodicReportingIEs', mode=MODE_TYPE)
    _PeriodicReportingIEs_reportingPeriodicity = ENUM(name='reportingPeriodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ReportingPeriodicity')))
    _PeriodicReportingIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PeriodicReportingIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PeriodicReportingIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PeriodicReportingIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PeriodicReportingIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PeriodicReportingIEs_iE_Extensions__item__id._const_tab = ____PeriodicReportingIEs_iE_Extensions__item__id_tab
    ___PeriodicReportingIEs_iE_Extensions__item__id._const_tab_at = None
    ___PeriodicReportingIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___PeriodicReportingIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PeriodicReportingIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PeriodicReportingIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PeriodicReportingIEs_iE_Extensions__item__criticality._const_tab = ____PeriodicReportingIEs_iE_Extensions__item__criticality_tab
    ___PeriodicReportingIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PeriodicReportingIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PeriodicReportingIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PeriodicReportingIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PeriodicReportingIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PeriodicReportingIEs_iE_Extensions__item__extensionValue._const_tab = ____PeriodicReportingIEs_iE_Extensions__item__extensionValue_tab
    ___PeriodicReportingIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PeriodicReportingIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PeriodicReportingIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PeriodicReportingIEs_iE_Extensions__item__id),
        ('criticality', ___PeriodicReportingIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___PeriodicReportingIEs_iE_Extensions__item__extensionValue),
        ])
    __PeriodicReportingIEs_iE_Extensions__item_._ext = None
    _PeriodicReportingIEs_iE_Extensions._cont = __PeriodicReportingIEs_iE_Extensions__item_
    _PeriodicReportingIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PeriodicReportingIEs._cont = ASN1Dict([
        ('reportingPeriodicity', _PeriodicReportingIEs_reportingPeriodicity),
        ('iE-Extensions', _PeriodicReportingIEs_iE_Extensions),
        ])
    PeriodicReportingIEs._ext = []
    
    #-----< PeriodicReportingIEs-ExtIEs >-----#
    PeriodicReportingIEs_ExtIEs = CLASS(name='PeriodicReportingIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PeriodicReportingIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ReportingPeriodicity >-----#
    ReportingPeriodicity = ENUM(name='ReportingPeriodicity', mode=MODE_TYPE)
    ReportingPeriodicity._cont = ASN1Dict([('stop', 0), ('single', 1), ('ms1000', 2), ('ms2000', 3), ('ms5000', 4), ('ms10000', 5)])
    ReportingPeriodicity._ext = []
    
    #-----< IntersystemSONInformationReply >-----#
    IntersystemSONInformationReply = CHOICE(name='IntersystemSONInformationReply', mode=MODE_TYPE)
    _IntersystemSONInformationReply_nGRAN_CellActivation = SEQ(name='nGRAN-CellActivation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntersystemCellActivationReply')))
    _IntersystemSONInformationReply_resourceStatus = SEQ(name='resourceStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntersystemResourceStatusReply')))
    _IntersystemSONInformationReply_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __IntersystemSONInformationReply_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___IntersystemSONInformationReply_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___IntersystemSONInformationReply_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IntersystemSONInformationReply_choice_Extensions_id._const_tab = ___IntersystemSONInformationReply_choice_Extensions_id_tab
    __IntersystemSONInformationReply_choice_Extensions_id._const_tab_at = None
    __IntersystemSONInformationReply_choice_Extensions_id._const_tab_id = 'id'
    __IntersystemSONInformationReply_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___IntersystemSONInformationReply_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___IntersystemSONInformationReply_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IntersystemSONInformationReply_choice_Extensions_criticality._const_tab = ___IntersystemSONInformationReply_choice_Extensions_criticality_tab
    __IntersystemSONInformationReply_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __IntersystemSONInformationReply_choice_Extensions_criticality._const_tab_id = 'criticality'
    __IntersystemSONInformationReply_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___IntersystemSONInformationReply_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___IntersystemSONInformationReply_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __IntersystemSONInformationReply_choice_Extensions_value._const_tab = ___IntersystemSONInformationReply_choice_Extensions_value_tab
    __IntersystemSONInformationReply_choice_Extensions_value._const_tab_at = ('..', 'id')
    __IntersystemSONInformationReply_choice_Extensions_value._const_tab_id = 'Value'
    _IntersystemSONInformationReply_choice_Extensions._cont = ASN1Dict([
        ('id', __IntersystemSONInformationReply_choice_Extensions_id),
        ('criticality', __IntersystemSONInformationReply_choice_Extensions_criticality),
        ('value', __IntersystemSONInformationReply_choice_Extensions_value),
        ])
    _IntersystemSONInformationReply_choice_Extensions._ext = None
    IntersystemSONInformationReply._cont = ASN1Dict([
        ('nGRAN-CellActivation', _IntersystemSONInformationReply_nGRAN_CellActivation),
        ('resourceStatus', _IntersystemSONInformationReply_resourceStatus),
        ('choice-Extensions', _IntersystemSONInformationReply_choice_Extensions),
        ])
    IntersystemSONInformationReply._ext = None
    
    #-----< IntersystemSONInformationReply-ExtIEs >-----#
    IntersystemSONInformationReply_ExtIEs = CLASS(name='IntersystemSONInformationReply-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    IntersystemSONInformationReply_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntersystemCellActivationReply >-----#
    IntersystemCellActivationReply = SEQ(name='IntersystemCellActivationReply', mode=MODE_TYPE)
    _IntersystemCellActivationReply_activatedCellList = SEQ_OF(name='activatedCellList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ActivatedCellList')))
    _IntersystemCellActivationReply_activation_ID = INT(name='activation-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IntersystemCellActivationReply_activation_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16384)], ev=[], er=[])
    _IntersystemCellActivationReply_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IntersystemCellActivationReply_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___IntersystemCellActivationReply_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____IntersystemCellActivationReply_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemCellActivationReply_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemCellActivationReply_iE_Extensions__item__id._const_tab = ____IntersystemCellActivationReply_iE_Extensions__item__id_tab
    ___IntersystemCellActivationReply_iE_Extensions__item__id._const_tab_at = None
    ___IntersystemCellActivationReply_iE_Extensions__item__id._const_tab_id = 'id'
    ___IntersystemCellActivationReply_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IntersystemCellActivationReply_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemCellActivationReply_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemCellActivationReply_iE_Extensions__item__criticality._const_tab = ____IntersystemCellActivationReply_iE_Extensions__item__criticality_tab
    ___IntersystemCellActivationReply_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IntersystemCellActivationReply_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IntersystemCellActivationReply_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IntersystemCellActivationReply_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemCellActivationReply_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemCellActivationReply_iE_Extensions__item__extensionValue._const_tab = ____IntersystemCellActivationReply_iE_Extensions__item__extensionValue_tab
    ___IntersystemCellActivationReply_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IntersystemCellActivationReply_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IntersystemCellActivationReply_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IntersystemCellActivationReply_iE_Extensions__item__id),
        ('criticality', ___IntersystemCellActivationReply_iE_Extensions__item__criticality),
        ('extensionValue', ___IntersystemCellActivationReply_iE_Extensions__item__extensionValue),
        ])
    __IntersystemCellActivationReply_iE_Extensions__item_._ext = None
    _IntersystemCellActivationReply_iE_Extensions._cont = __IntersystemCellActivationReply_iE_Extensions__item_
    _IntersystemCellActivationReply_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IntersystemCellActivationReply._cont = ASN1Dict([
        ('activatedCellList', _IntersystemCellActivationReply_activatedCellList),
        ('activation-ID', _IntersystemCellActivationReply_activation_ID),
        ('iE-Extensions', _IntersystemCellActivationReply_iE_Extensions),
        ])
    IntersystemCellActivationReply._ext = []
    
    #-----< IntersystemCellActivationReply-ExtIEs >-----#
    IntersystemCellActivationReply_ExtIEs = CLASS(name='IntersystemCellActivationReply-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    IntersystemCellActivationReply_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ActivatedCellList >-----#
    ActivatedCellList = SEQ_OF(name='ActivatedCellList', mode=MODE_TYPE)
    _ActivatedCellList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    ActivatedCellList._cont = _ActivatedCellList__item_
    ActivatedCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< IntersystemResourceStatusReply >-----#
    IntersystemResourceStatusReply = SEQ(name='IntersystemResourceStatusReply', mode=MODE_TYPE)
    _IntersystemResourceStatusReply_reportingsystem = CHOICE(name='reportingsystem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ReportingSystem')))
    _IntersystemResourceStatusReply_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IntersystemResourceStatusReply_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___IntersystemResourceStatusReply_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____IntersystemResourceStatusReply_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemResourceStatusReply_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemResourceStatusReply_iE_Extensions__item__id._const_tab = ____IntersystemResourceStatusReply_iE_Extensions__item__id_tab
    ___IntersystemResourceStatusReply_iE_Extensions__item__id._const_tab_at = None
    ___IntersystemResourceStatusReply_iE_Extensions__item__id._const_tab_id = 'id'
    ___IntersystemResourceStatusReply_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IntersystemResourceStatusReply_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemResourceStatusReply_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemResourceStatusReply_iE_Extensions__item__criticality._const_tab = ____IntersystemResourceStatusReply_iE_Extensions__item__criticality_tab
    ___IntersystemResourceStatusReply_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IntersystemResourceStatusReply_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IntersystemResourceStatusReply_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IntersystemResourceStatusReply_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemResourceStatusReply_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemResourceStatusReply_iE_Extensions__item__extensionValue._const_tab = ____IntersystemResourceStatusReply_iE_Extensions__item__extensionValue_tab
    ___IntersystemResourceStatusReply_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IntersystemResourceStatusReply_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IntersystemResourceStatusReply_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IntersystemResourceStatusReply_iE_Extensions__item__id),
        ('criticality', ___IntersystemResourceStatusReply_iE_Extensions__item__criticality),
        ('extensionValue', ___IntersystemResourceStatusReply_iE_Extensions__item__extensionValue),
        ])
    __IntersystemResourceStatusReply_iE_Extensions__item_._ext = None
    _IntersystemResourceStatusReply_iE_Extensions._cont = __IntersystemResourceStatusReply_iE_Extensions__item_
    _IntersystemResourceStatusReply_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IntersystemResourceStatusReply._cont = ASN1Dict([
        ('reportingsystem', _IntersystemResourceStatusReply_reportingsystem),
        ('iE-Extensions', _IntersystemResourceStatusReply_iE_Extensions),
        ])
    IntersystemResourceStatusReply._ext = []
    
    #-----< IntersystemResourceStatusReply-ExtIEs >-----#
    IntersystemResourceStatusReply_ExtIEs = CLASS(name='IntersystemResourceStatusReply-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    IntersystemResourceStatusReply_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntersystemSONInformationReport >-----#
    IntersystemSONInformationReport = CHOICE(name='IntersystemSONInformationReport', mode=MODE_TYPE)
    _IntersystemSONInformationReport_hOReportInformation = SEQ(name='hOReportInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'InterSystemHOReport')))
    _IntersystemSONInformationReport_failureIndicationInformation = SEQ(name='failureIndicationInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'InterSystemFailureIndication')))
    _IntersystemSONInformationReport_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __IntersystemSONInformationReport_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___IntersystemSONInformationReport_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ____IntersystemSONInformationReport_choice_Extensions_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IntersystemCellStateIndication')))
    ____IntersystemSONInformationReport_choice_Extensions_id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IntersystemResourceStatusReport')))
    ___IntersystemSONInformationReport_choice_Extensions_id_tab._val = ASN1Set(rv=[dict([('id', 292), ('criticality', 'ignore'), ('Value', ____IntersystemSONInformationReport_choice_Extensions_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 293), ('criticality', 'ignore'), ('Value', ____IntersystemSONInformationReport_choice_Extensions_id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __IntersystemSONInformationReport_choice_Extensions_id._const_tab = ___IntersystemSONInformationReport_choice_Extensions_id_tab
    __IntersystemSONInformationReport_choice_Extensions_id._const_tab_at = None
    __IntersystemSONInformationReport_choice_Extensions_id._const_tab_id = 'id'
    __IntersystemSONInformationReport_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    __IntersystemSONInformationReport_choice_Extensions_criticality._const_tab = ___IntersystemSONInformationReport_choice_Extensions_id_tab
    __IntersystemSONInformationReport_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __IntersystemSONInformationReport_choice_Extensions_criticality._const_tab_id = 'criticality'
    __IntersystemSONInformationReport_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    __IntersystemSONInformationReport_choice_Extensions_value._const_tab = ___IntersystemSONInformationReport_choice_Extensions_id_tab
    __IntersystemSONInformationReport_choice_Extensions_value._const_tab_at = ('..', 'id')
    __IntersystemSONInformationReport_choice_Extensions_value._const_tab_id = 'Value'
    _IntersystemSONInformationReport_choice_Extensions._cont = ASN1Dict([
        ('id', __IntersystemSONInformationReport_choice_Extensions_id),
        ('criticality', __IntersystemSONInformationReport_choice_Extensions_criticality),
        ('value', __IntersystemSONInformationReport_choice_Extensions_value),
        ])
    _IntersystemSONInformationReport_choice_Extensions._ext = None
    IntersystemSONInformationReport._cont = ASN1Dict([
        ('hOReportInformation', _IntersystemSONInformationReport_hOReportInformation),
        ('failureIndicationInformation', _IntersystemSONInformationReport_failureIndicationInformation),
        ('choice-Extensions', _IntersystemSONInformationReport_choice_Extensions),
        ])
    IntersystemSONInformationReport._ext = None
    
    #-----< IntersystemSONInformationReport-ExtIEs >-----#
    IntersystemSONInformationReport_ExtIEs = CLASS(name='IntersystemSONInformationReport-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _IntersystemSONInformationReport_ExtIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IntersystemCellStateIndication')))
    _IntersystemSONInformationReport_ExtIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IntersystemResourceStatusReport')))
    IntersystemSONInformationReport_ExtIEs._val = ASN1Set(rv=[dict([('id', 292), ('criticality', 'ignore'), ('Value', _IntersystemSONInformationReport_ExtIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 293), ('criticality', 'ignore'), ('Value', _IntersystemSONInformationReport_ExtIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< IntersystemCellStateIndication >-----#
    IntersystemCellStateIndication = SEQ(name='IntersystemCellStateIndication', mode=MODE_TYPE)
    _IntersystemCellStateIndication_notificationCellList = SEQ_OF(name='notificationCellList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NotificationCellList')))
    _IntersystemCellStateIndication_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IntersystemCellStateIndication_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___IntersystemCellStateIndication_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____IntersystemCellStateIndication_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemCellStateIndication_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemCellStateIndication_iE_Extensions__item__id._const_tab = ____IntersystemCellStateIndication_iE_Extensions__item__id_tab
    ___IntersystemCellStateIndication_iE_Extensions__item__id._const_tab_at = None
    ___IntersystemCellStateIndication_iE_Extensions__item__id._const_tab_id = 'id'
    ___IntersystemCellStateIndication_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IntersystemCellStateIndication_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemCellStateIndication_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemCellStateIndication_iE_Extensions__item__criticality._const_tab = ____IntersystemCellStateIndication_iE_Extensions__item__criticality_tab
    ___IntersystemCellStateIndication_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IntersystemCellStateIndication_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IntersystemCellStateIndication_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IntersystemCellStateIndication_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemCellStateIndication_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemCellStateIndication_iE_Extensions__item__extensionValue._const_tab = ____IntersystemCellStateIndication_iE_Extensions__item__extensionValue_tab
    ___IntersystemCellStateIndication_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IntersystemCellStateIndication_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IntersystemCellStateIndication_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IntersystemCellStateIndication_iE_Extensions__item__id),
        ('criticality', ___IntersystemCellStateIndication_iE_Extensions__item__criticality),
        ('extensionValue', ___IntersystemCellStateIndication_iE_Extensions__item__extensionValue),
        ])
    __IntersystemCellStateIndication_iE_Extensions__item_._ext = None
    _IntersystemCellStateIndication_iE_Extensions._cont = __IntersystemCellStateIndication_iE_Extensions__item_
    _IntersystemCellStateIndication_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IntersystemCellStateIndication._cont = ASN1Dict([
        ('notificationCellList', _IntersystemCellStateIndication_notificationCellList),
        ('iE-Extensions', _IntersystemCellStateIndication_iE_Extensions),
        ])
    IntersystemCellStateIndication._ext = []
    
    #-----< IntersystemCellStateIndication-ExtIEs >-----#
    IntersystemCellStateIndication_ExtIEs = CLASS(name='IntersystemCellStateIndication-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    IntersystemCellStateIndication_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NotificationCellList >-----#
    NotificationCellList = SEQ_OF(name='NotificationCellList', mode=MODE_TYPE)
    _NotificationCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NotificationCell-Item')))
    NotificationCellList._cont = _NotificationCellList__item_
    NotificationCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< NotificationCell-Item >-----#
    NotificationCell_Item = SEQ(name='NotificationCell-Item', mode=MODE_TYPE)
    _NotificationCell_Item_nGRAN_CGI = CHOICE(name='nGRAN-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _NotificationCell_Item_notifyFlag = ENUM(name='notifyFlag', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NotificationCell_Item_notifyFlag._cont = ASN1Dict([('activated', 0), ('deactivated', 1)])
    _NotificationCell_Item_notifyFlag._ext = []
    _NotificationCell_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NotificationCell_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___NotificationCell_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____NotificationCell_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NotificationCell_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NotificationCell_Item_iE_Extensions__item__id._const_tab = ____NotificationCell_Item_iE_Extensions__item__id_tab
    ___NotificationCell_Item_iE_Extensions__item__id._const_tab_at = None
    ___NotificationCell_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___NotificationCell_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NotificationCell_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NotificationCell_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NotificationCell_Item_iE_Extensions__item__criticality._const_tab = ____NotificationCell_Item_iE_Extensions__item__criticality_tab
    ___NotificationCell_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NotificationCell_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NotificationCell_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NotificationCell_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NotificationCell_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NotificationCell_Item_iE_Extensions__item__extensionValue._const_tab = ____NotificationCell_Item_iE_Extensions__item__extensionValue_tab
    ___NotificationCell_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NotificationCell_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NotificationCell_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NotificationCell_Item_iE_Extensions__item__id),
        ('criticality', ___NotificationCell_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___NotificationCell_Item_iE_Extensions__item__extensionValue),
        ])
    __NotificationCell_Item_iE_Extensions__item_._ext = None
    _NotificationCell_Item_iE_Extensions._cont = __NotificationCell_Item_iE_Extensions__item_
    _NotificationCell_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NotificationCell_Item._cont = ASN1Dict([
        ('nGRAN-CGI', _NotificationCell_Item_nGRAN_CGI),
        ('notifyFlag', _NotificationCell_Item_notifyFlag),
        ('iE-Extensions', _NotificationCell_Item_iE_Extensions),
        ])
    NotificationCell_Item._ext = []
    
    #-----< NotificationCell-Item-ExtIEs >-----#
    NotificationCell_Item_ExtIEs = CLASS(name='NotificationCell-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    NotificationCell_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntersystemResourceStatusReport >-----#
    IntersystemResourceStatusReport = SEQ(name='IntersystemResourceStatusReport', mode=MODE_TYPE)
    _IntersystemResourceStatusReport_reportingSystem = CHOICE(name='reportingSystem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ResourceStatusReportingSystem')))
    _IntersystemResourceStatusReport_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IntersystemResourceStatusReport_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___IntersystemResourceStatusReport_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____IntersystemResourceStatusReport_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemResourceStatusReport_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemResourceStatusReport_iE_Extensions__item__id._const_tab = ____IntersystemResourceStatusReport_iE_Extensions__item__id_tab
    ___IntersystemResourceStatusReport_iE_Extensions__item__id._const_tab_at = None
    ___IntersystemResourceStatusReport_iE_Extensions__item__id._const_tab_id = 'id'
    ___IntersystemResourceStatusReport_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IntersystemResourceStatusReport_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemResourceStatusReport_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemResourceStatusReport_iE_Extensions__item__criticality._const_tab = ____IntersystemResourceStatusReport_iE_Extensions__item__criticality_tab
    ___IntersystemResourceStatusReport_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IntersystemResourceStatusReport_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IntersystemResourceStatusReport_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IntersystemResourceStatusReport_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemResourceStatusReport_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemResourceStatusReport_iE_Extensions__item__extensionValue._const_tab = ____IntersystemResourceStatusReport_iE_Extensions__item__extensionValue_tab
    ___IntersystemResourceStatusReport_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IntersystemResourceStatusReport_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IntersystemResourceStatusReport_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IntersystemResourceStatusReport_iE_Extensions__item__id),
        ('criticality', ___IntersystemResourceStatusReport_iE_Extensions__item__criticality),
        ('extensionValue', ___IntersystemResourceStatusReport_iE_Extensions__item__extensionValue),
        ])
    __IntersystemResourceStatusReport_iE_Extensions__item_._ext = None
    _IntersystemResourceStatusReport_iE_Extensions._cont = __IntersystemResourceStatusReport_iE_Extensions__item_
    _IntersystemResourceStatusReport_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IntersystemResourceStatusReport._cont = ASN1Dict([
        ('reportingSystem', _IntersystemResourceStatusReport_reportingSystem),
        ('iE-Extensions', _IntersystemResourceStatusReport_iE_Extensions),
        ])
    IntersystemResourceStatusReport._ext = []
    
    #-----< IntersystemResourceStatusReport-ExtIEs >-----#
    IntersystemResourceStatusReport_ExtIEs = CLASS(name='IntersystemResourceStatusReport-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    IntersystemResourceStatusReport_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceStatusReportingSystem >-----#
    ResourceStatusReportingSystem = CHOICE(name='ResourceStatusReportingSystem', mode=MODE_TYPE)
    _ResourceStatusReportingSystem_eUTRAN_ReportingStatus = SEQ(name='eUTRAN-ReportingStatus', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRAN-ReportingStatusIEs')))
    _ResourceStatusReportingSystem_nGRAN_ReportingStatus = SEQ(name='nGRAN-ReportingStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-ReportingStatusIEs')))
    _ResourceStatusReportingSystem_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __ResourceStatusReportingSystem_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___ResourceStatusReportingSystem_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ResourceStatusReportingSystem_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceStatusReportingSystem_choice_Extensions_id._const_tab = ___ResourceStatusReportingSystem_choice_Extensions_id_tab
    __ResourceStatusReportingSystem_choice_Extensions_id._const_tab_at = None
    __ResourceStatusReportingSystem_choice_Extensions_id._const_tab_id = 'id'
    __ResourceStatusReportingSystem_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___ResourceStatusReportingSystem_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ResourceStatusReportingSystem_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceStatusReportingSystem_choice_Extensions_criticality._const_tab = ___ResourceStatusReportingSystem_choice_Extensions_criticality_tab
    __ResourceStatusReportingSystem_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __ResourceStatusReportingSystem_choice_Extensions_criticality._const_tab_id = 'criticality'
    __ResourceStatusReportingSystem_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___ResourceStatusReportingSystem_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ResourceStatusReportingSystem_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceStatusReportingSystem_choice_Extensions_value._const_tab = ___ResourceStatusReportingSystem_choice_Extensions_value_tab
    __ResourceStatusReportingSystem_choice_Extensions_value._const_tab_at = ('..', 'id')
    __ResourceStatusReportingSystem_choice_Extensions_value._const_tab_id = 'Value'
    _ResourceStatusReportingSystem_choice_Extensions._cont = ASN1Dict([
        ('id', __ResourceStatusReportingSystem_choice_Extensions_id),
        ('criticality', __ResourceStatusReportingSystem_choice_Extensions_criticality),
        ('value', __ResourceStatusReportingSystem_choice_Extensions_value),
        ])
    _ResourceStatusReportingSystem_choice_Extensions._ext = None
    ResourceStatusReportingSystem._cont = ASN1Dict([
        ('eUTRAN-ReportingStatus', _ResourceStatusReportingSystem_eUTRAN_ReportingStatus),
        ('nGRAN-ReportingStatus', _ResourceStatusReportingSystem_nGRAN_ReportingStatus),
        ('choice-Extensions', _ResourceStatusReportingSystem_choice_Extensions),
        ])
    ResourceStatusReportingSystem._ext = None
    
    #-----< ResourceStatusReportingSystem-ExtIEs >-----#
    ResourceStatusReportingSystem_ExtIEs = CLASS(name='ResourceStatusReportingSystem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ResourceStatusReportingSystem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRAN-ReportingStatusIEs >-----#
    EUTRAN_ReportingStatusIEs = SEQ(name='EUTRAN-ReportingStatusIEs', mode=MODE_TYPE)
    _EUTRAN_ReportingStatusIEs_eUTRAN_CellReportList = SEQ_OF(name='eUTRAN-CellReportList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRAN-CellReportList')))
    _EUTRAN_ReportingStatusIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRAN_ReportingStatusIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EUTRAN_ReportingStatusIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____EUTRAN_ReportingStatusIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRAN_ReportingStatusIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_ReportingStatusIEs_iE_Extensions__item__id._const_tab = ____EUTRAN_ReportingStatusIEs_iE_Extensions__item__id_tab
    ___EUTRAN_ReportingStatusIEs_iE_Extensions__item__id._const_tab_at = None
    ___EUTRAN_ReportingStatusIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___EUTRAN_ReportingStatusIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EUTRAN_ReportingStatusIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRAN_ReportingStatusIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_ReportingStatusIEs_iE_Extensions__item__criticality._const_tab = ____EUTRAN_ReportingStatusIEs_iE_Extensions__item__criticality_tab
    ___EUTRAN_ReportingStatusIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EUTRAN_ReportingStatusIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EUTRAN_ReportingStatusIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EUTRAN_ReportingStatusIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRAN_ReportingStatusIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_ReportingStatusIEs_iE_Extensions__item__extensionValue._const_tab = ____EUTRAN_ReportingStatusIEs_iE_Extensions__item__extensionValue_tab
    ___EUTRAN_ReportingStatusIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EUTRAN_ReportingStatusIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EUTRAN_ReportingStatusIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EUTRAN_ReportingStatusIEs_iE_Extensions__item__id),
        ('criticality', ___EUTRAN_ReportingStatusIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___EUTRAN_ReportingStatusIEs_iE_Extensions__item__extensionValue),
        ])
    __EUTRAN_ReportingStatusIEs_iE_Extensions__item_._ext = None
    _EUTRAN_ReportingStatusIEs_iE_Extensions._cont = __EUTRAN_ReportingStatusIEs_iE_Extensions__item_
    _EUTRAN_ReportingStatusIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRAN_ReportingStatusIEs._cont = ASN1Dict([
        ('eUTRAN-CellReportList', _EUTRAN_ReportingStatusIEs_eUTRAN_CellReportList),
        ('iE-Extensions', _EUTRAN_ReportingStatusIEs_iE_Extensions),
        ])
    EUTRAN_ReportingStatusIEs._ext = []
    
    #-----< EUTRAN-ReportingStatusIEs-ExtIEs >-----#
    EUTRAN_ReportingStatusIEs_ExtIEs = CLASS(name='EUTRAN-ReportingStatusIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EUTRAN_ReportingStatusIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRAN-CellReportList >-----#
    EUTRAN_CellReportList = SEQ_OF(name='EUTRAN-CellReportList', mode=MODE_TYPE)
    _EUTRAN_CellReportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EUTRAN-CellReportItem')))
    EUTRAN_CellReportList._cont = _EUTRAN_CellReportList__item_
    EUTRAN_CellReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< EUTRAN-CellReportItem >-----#
    EUTRAN_CellReportItem = SEQ(name='EUTRAN-CellReportItem', mode=MODE_TYPE)
    _EUTRAN_CellReportItem_eCGI = SEQ(name='eCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _EUTRAN_CellReportItem_eUTRAN_CompositeAvailableCapacityGroup = SEQ(name='eUTRAN-CompositeAvailableCapacityGroup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRAN-CompositeAvailableCapacityGroup')))
    _EUTRAN_CellReportItem_eUTRAN_NumberOfActiveUEs = INT(name='eUTRAN-NumberOfActiveUEs', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRAN-NumberOfActiveUEs')), opt=True)
    _EUTRAN_CellReportItem_eUTRAN_NoofRRCConnections = INT(name='eUTRAN-NoofRRCConnections', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-NoofRRCConnections')), opt=True)
    _EUTRAN_CellReportItem_eUTRAN_RadioResourceStatus = SEQ(name='eUTRAN-RadioResourceStatus', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRAN-RadioResourceStatus')), opt=True)
    _EUTRAN_CellReportItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRAN_CellReportItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EUTRAN_CellReportItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____EUTRAN_CellReportItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRAN_CellReportItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_CellReportItem_iE_Extensions__item__id._const_tab = ____EUTRAN_CellReportItem_iE_Extensions__item__id_tab
    ___EUTRAN_CellReportItem_iE_Extensions__item__id._const_tab_at = None
    ___EUTRAN_CellReportItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___EUTRAN_CellReportItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EUTRAN_CellReportItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRAN_CellReportItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_CellReportItem_iE_Extensions__item__criticality._const_tab = ____EUTRAN_CellReportItem_iE_Extensions__item__criticality_tab
    ___EUTRAN_CellReportItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EUTRAN_CellReportItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EUTRAN_CellReportItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EUTRAN_CellReportItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRAN_CellReportItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_CellReportItem_iE_Extensions__item__extensionValue._const_tab = ____EUTRAN_CellReportItem_iE_Extensions__item__extensionValue_tab
    ___EUTRAN_CellReportItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EUTRAN_CellReportItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EUTRAN_CellReportItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EUTRAN_CellReportItem_iE_Extensions__item__id),
        ('criticality', ___EUTRAN_CellReportItem_iE_Extensions__item__criticality),
        ('extensionValue', ___EUTRAN_CellReportItem_iE_Extensions__item__extensionValue),
        ])
    __EUTRAN_CellReportItem_iE_Extensions__item_._ext = None
    _EUTRAN_CellReportItem_iE_Extensions._cont = __EUTRAN_CellReportItem_iE_Extensions__item_
    _EUTRAN_CellReportItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRAN_CellReportItem._cont = ASN1Dict([
        ('eCGI', _EUTRAN_CellReportItem_eCGI),
        ('eUTRAN-CompositeAvailableCapacityGroup', _EUTRAN_CellReportItem_eUTRAN_CompositeAvailableCapacityGroup),
        ('eUTRAN-NumberOfActiveUEs', _EUTRAN_CellReportItem_eUTRAN_NumberOfActiveUEs),
        ('eUTRAN-NoofRRCConnections', _EUTRAN_CellReportItem_eUTRAN_NoofRRCConnections),
        ('eUTRAN-RadioResourceStatus', _EUTRAN_CellReportItem_eUTRAN_RadioResourceStatus),
        ('iE-Extensions', _EUTRAN_CellReportItem_iE_Extensions),
        ])
    EUTRAN_CellReportItem._ext = []
    
    #-----< EUTRAN-CellReportItem-ExtIEs >-----#
    EUTRAN_CellReportItem_ExtIEs = CLASS(name='EUTRAN-CellReportItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EUTRAN_CellReportItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRAN-CompositeAvailableCapacityGroup >-----#
    EUTRAN_CompositeAvailableCapacityGroup = SEQ(name='EUTRAN-CompositeAvailableCapacityGroup', mode=MODE_TYPE)
    _EUTRAN_CompositeAvailableCapacityGroup_dL_CompositeAvailableCapacity = SEQ(name='dL-CompositeAvailableCapacity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CompositeAvailableCapacity')))
    _EUTRAN_CompositeAvailableCapacityGroup_uL_CompositeAvailableCapacity = SEQ(name='uL-CompositeAvailableCapacity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CompositeAvailableCapacity')))
    _EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__id._const_tab = ____EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab
    ___EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__id._const_tab_at = None
    ___EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__id._const_tab_id = 'id'
    ___EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__criticality._const_tab = ____EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__criticality_tab
    ___EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue._const_tab = ____EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue_tab
    ___EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__id),
        ('criticality', ___EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__criticality),
        ('extensionValue', ___EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue),
        ])
    __EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item_._ext = None
    _EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions._cont = __EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item_
    _EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRAN_CompositeAvailableCapacityGroup._cont = ASN1Dict([
        ('dL-CompositeAvailableCapacity', _EUTRAN_CompositeAvailableCapacityGroup_dL_CompositeAvailableCapacity),
        ('uL-CompositeAvailableCapacity', _EUTRAN_CompositeAvailableCapacityGroup_uL_CompositeAvailableCapacity),
        ('iE-Extensions', _EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions),
        ])
    EUTRAN_CompositeAvailableCapacityGroup._ext = []
    
    #-----< EUTRAN-CompositeAvailableCapacityGroup-ExtIEs >-----#
    EUTRAN_CompositeAvailableCapacityGroup_ExtIEs = CLASS(name='EUTRAN-CompositeAvailableCapacityGroup-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EUTRAN_CompositeAvailableCapacityGroup_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CompositeAvailableCapacity >-----#
    CompositeAvailableCapacity = SEQ(name='CompositeAvailableCapacity', mode=MODE_TYPE)
    _CompositeAvailableCapacity_cellCapacityClassValue = INT(name='cellCapacityClassValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CompositeAvailableCapacity_cellCapacityClassValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=[], er=[])
    _CompositeAvailableCapacity_capacityValue = INT(name='capacityValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CompositeAvailableCapacity_capacityValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _CompositeAvailableCapacity_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CompositeAvailableCapacity_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___CompositeAvailableCapacity_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____CompositeAvailableCapacity_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompositeAvailableCapacity_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompositeAvailableCapacity_iE_Extensions__item__id._const_tab = ____CompositeAvailableCapacity_iE_Extensions__item__id_tab
    ___CompositeAvailableCapacity_iE_Extensions__item__id._const_tab_at = None
    ___CompositeAvailableCapacity_iE_Extensions__item__id._const_tab_id = 'id'
    ___CompositeAvailableCapacity_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CompositeAvailableCapacity_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompositeAvailableCapacity_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompositeAvailableCapacity_iE_Extensions__item__criticality._const_tab = ____CompositeAvailableCapacity_iE_Extensions__item__criticality_tab
    ___CompositeAvailableCapacity_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CompositeAvailableCapacity_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CompositeAvailableCapacity_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____CompositeAvailableCapacity_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue._const_tab = ____CompositeAvailableCapacity_iE_Extensions__item__extensionValue_tab
    ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CompositeAvailableCapacity_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CompositeAvailableCapacity_iE_Extensions__item__id),
        ('criticality', ___CompositeAvailableCapacity_iE_Extensions__item__criticality),
        ('extensionValue', ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue),
        ])
    __CompositeAvailableCapacity_iE_Extensions__item_._ext = None
    _CompositeAvailableCapacity_iE_Extensions._cont = __CompositeAvailableCapacity_iE_Extensions__item_
    _CompositeAvailableCapacity_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CompositeAvailableCapacity._cont = ASN1Dict([
        ('cellCapacityClassValue', _CompositeAvailableCapacity_cellCapacityClassValue),
        ('capacityValue', _CompositeAvailableCapacity_capacityValue),
        ('iE-Extensions', _CompositeAvailableCapacity_iE_Extensions),
        ])
    CompositeAvailableCapacity._ext = []
    
    #-----< CompositeAvailableCapacity-ExtIEs >-----#
    CompositeAvailableCapacity_ExtIEs = CLASS(name='CompositeAvailableCapacity-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    CompositeAvailableCapacity_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRAN-NumberOfActiveUEs >-----#
    EUTRAN_NumberOfActiveUEs = INT(name='EUTRAN-NumberOfActiveUEs', mode=MODE_TYPE)
    EUTRAN_NumberOfActiveUEs._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=[], er=[])
    
    #-----< EUTRAN-RadioResourceStatus >-----#
    EUTRAN_RadioResourceStatus = SEQ(name='EUTRAN-RadioResourceStatus', mode=MODE_TYPE)
    _EUTRAN_RadioResourceStatus_dL_GBR_PRB_usage = INT(name='dL-GBR-PRB-usage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EUTRAN_RadioResourceStatus_dL_GBR_PRB_usage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _EUTRAN_RadioResourceStatus_uL_GBR_PRB_usage = INT(name='uL-GBR-PRB-usage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EUTRAN_RadioResourceStatus_uL_GBR_PRB_usage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _EUTRAN_RadioResourceStatus_dL_non_GBR_PRB_usage = INT(name='dL-non-GBR-PRB-usage', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EUTRAN_RadioResourceStatus_dL_non_GBR_PRB_usage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _EUTRAN_RadioResourceStatus_uL_non_GBR_PRB_usage = INT(name='uL-non-GBR-PRB-usage', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EUTRAN_RadioResourceStatus_uL_non_GBR_PRB_usage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _EUTRAN_RadioResourceStatus_dL_Total_PRB_usage = INT(name='dL-Total-PRB-usage', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EUTRAN_RadioResourceStatus_dL_Total_PRB_usage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _EUTRAN_RadioResourceStatus_uL_Total_PRB_usage = INT(name='uL-Total-PRB-usage', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EUTRAN_RadioResourceStatus_uL_Total_PRB_usage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _EUTRAN_RadioResourceStatus_dL_scheduling_PDCCH_CCE_usage = INT(name='dL-scheduling-PDCCH-CCE-usage', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EUTRAN_RadioResourceStatus_dL_scheduling_PDCCH_CCE_usage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _EUTRAN_RadioResourceStatus_uL_scheduling_PDCCH_CCE_usage = INT(name='uL-scheduling-PDCCH-CCE-usage', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EUTRAN_RadioResourceStatus_uL_scheduling_PDCCH_CCE_usage._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _EUTRAN_RadioResourceStatus_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRAN_RadioResourceStatus_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___EUTRAN_RadioResourceStatus_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____EUTRAN_RadioResourceStatus_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRAN_RadioResourceStatus_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_RadioResourceStatus_iE_Extensions__item__id._const_tab = ____EUTRAN_RadioResourceStatus_iE_Extensions__item__id_tab
    ___EUTRAN_RadioResourceStatus_iE_Extensions__item__id._const_tab_at = None
    ___EUTRAN_RadioResourceStatus_iE_Extensions__item__id._const_tab_id = 'id'
    ___EUTRAN_RadioResourceStatus_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EUTRAN_RadioResourceStatus_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRAN_RadioResourceStatus_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_RadioResourceStatus_iE_Extensions__item__criticality._const_tab = ____EUTRAN_RadioResourceStatus_iE_Extensions__item__criticality_tab
    ___EUTRAN_RadioResourceStatus_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EUTRAN_RadioResourceStatus_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EUTRAN_RadioResourceStatus_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EUTRAN_RadioResourceStatus_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____EUTRAN_RadioResourceStatus_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_RadioResourceStatus_iE_Extensions__item__extensionValue._const_tab = ____EUTRAN_RadioResourceStatus_iE_Extensions__item__extensionValue_tab
    ___EUTRAN_RadioResourceStatus_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EUTRAN_RadioResourceStatus_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EUTRAN_RadioResourceStatus_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EUTRAN_RadioResourceStatus_iE_Extensions__item__id),
        ('criticality', ___EUTRAN_RadioResourceStatus_iE_Extensions__item__criticality),
        ('extensionValue', ___EUTRAN_RadioResourceStatus_iE_Extensions__item__extensionValue),
        ])
    __EUTRAN_RadioResourceStatus_iE_Extensions__item_._ext = None
    _EUTRAN_RadioResourceStatus_iE_Extensions._cont = __EUTRAN_RadioResourceStatus_iE_Extensions__item_
    _EUTRAN_RadioResourceStatus_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRAN_RadioResourceStatus._cont = ASN1Dict([
        ('dL-GBR-PRB-usage', _EUTRAN_RadioResourceStatus_dL_GBR_PRB_usage),
        ('uL-GBR-PRB-usage', _EUTRAN_RadioResourceStatus_uL_GBR_PRB_usage),
        ('dL-non-GBR-PRB-usage', _EUTRAN_RadioResourceStatus_dL_non_GBR_PRB_usage),
        ('uL-non-GBR-PRB-usage', _EUTRAN_RadioResourceStatus_uL_non_GBR_PRB_usage),
        ('dL-Total-PRB-usage', _EUTRAN_RadioResourceStatus_dL_Total_PRB_usage),
        ('uL-Total-PRB-usage', _EUTRAN_RadioResourceStatus_uL_Total_PRB_usage),
        ('dL-scheduling-PDCCH-CCE-usage', _EUTRAN_RadioResourceStatus_dL_scheduling_PDCCH_CCE_usage),
        ('uL-scheduling-PDCCH-CCE-usage', _EUTRAN_RadioResourceStatus_uL_scheduling_PDCCH_CCE_usage),
        ('iE-Extensions', _EUTRAN_RadioResourceStatus_iE_Extensions),
        ])
    EUTRAN_RadioResourceStatus._ext = []
    
    #-----< EUTRAN-RadioResourceStatus-ExtIEs >-----#
    EUTRAN_RadioResourceStatus_ExtIEs = CLASS(name='EUTRAN-RadioResourceStatus-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    EUTRAN_RadioResourceStatus_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NGRAN-ReportingStatusIEs >-----#
    NGRAN_ReportingStatusIEs = SEQ(name='NGRAN-ReportingStatusIEs', mode=MODE_TYPE)
    _NGRAN_ReportingStatusIEs_nGRAN_CellReportList = SEQ_OF(name='nGRAN-CellReportList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CellReportList')))
    _NGRAN_ReportingStatusIEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NGRAN_ReportingStatusIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___NGRAN_ReportingStatusIEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____NGRAN_ReportingStatusIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGRAN_ReportingStatusIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRAN_ReportingStatusIEs_iE_Extensions__item__id._const_tab = ____NGRAN_ReportingStatusIEs_iE_Extensions__item__id_tab
    ___NGRAN_ReportingStatusIEs_iE_Extensions__item__id._const_tab_at = None
    ___NGRAN_ReportingStatusIEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___NGRAN_ReportingStatusIEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NGRAN_ReportingStatusIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGRAN_ReportingStatusIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRAN_ReportingStatusIEs_iE_Extensions__item__criticality._const_tab = ____NGRAN_ReportingStatusIEs_iE_Extensions__item__criticality_tab
    ___NGRAN_ReportingStatusIEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NGRAN_ReportingStatusIEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NGRAN_ReportingStatusIEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NGRAN_ReportingStatusIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGRAN_ReportingStatusIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRAN_ReportingStatusIEs_iE_Extensions__item__extensionValue._const_tab = ____NGRAN_ReportingStatusIEs_iE_Extensions__item__extensionValue_tab
    ___NGRAN_ReportingStatusIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NGRAN_ReportingStatusIEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NGRAN_ReportingStatusIEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NGRAN_ReportingStatusIEs_iE_Extensions__item__id),
        ('criticality', ___NGRAN_ReportingStatusIEs_iE_Extensions__item__criticality),
        ('extensionValue', ___NGRAN_ReportingStatusIEs_iE_Extensions__item__extensionValue),
        ])
    __NGRAN_ReportingStatusIEs_iE_Extensions__item_._ext = None
    _NGRAN_ReportingStatusIEs_iE_Extensions._cont = __NGRAN_ReportingStatusIEs_iE_Extensions__item_
    _NGRAN_ReportingStatusIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NGRAN_ReportingStatusIEs._cont = ASN1Dict([
        ('nGRAN-CellReportList', _NGRAN_ReportingStatusIEs_nGRAN_CellReportList),
        ('iE-Extensions', _NGRAN_ReportingStatusIEs_iE_Extensions),
        ])
    NGRAN_ReportingStatusIEs._ext = []
    
    #-----< NGRAN-ReportingStatusIEs-ExtIEs >-----#
    NGRAN_ReportingStatusIEs_ExtIEs = CLASS(name='NGRAN-ReportingStatusIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    NGRAN_ReportingStatusIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NGRAN-CellReportList >-----#
    NGRAN_CellReportList = SEQ_OF(name='NGRAN-CellReportList', mode=MODE_TYPE)
    _NGRAN_CellReportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CellReportItem')))
    NGRAN_CellReportList._cont = _NGRAN_CellReportList__item_
    NGRAN_CellReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< NGRAN-CellReportItem >-----#
    NGRAN_CellReportItem = SEQ(name='NGRAN-CellReportItem', mode=MODE_TYPE)
    _NGRAN_CellReportItem_nGRAN_CGI = CHOICE(name='nGRAN-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _NGRAN_CellReportItem_nGRAN_CompositeAvailableCapacityGroup = SEQ(name='nGRAN-CompositeAvailableCapacityGroup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRAN-CompositeAvailableCapacityGroup')))
    _NGRAN_CellReportItem_nGRAN_NumberOfActiveUEs = INT(name='nGRAN-NumberOfActiveUEs', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-NumberOfActiveUEs')), opt=True)
    _NGRAN_CellReportItem_nGRAN_NoofRRCConnections = INT(name='nGRAN-NoofRRCConnections', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-NoofRRCConnections')), opt=True)
    _NGRAN_CellReportItem_nGRAN_RadioResourceStatus = SEQ(name='nGRAN-RadioResourceStatus', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-RadioResourceStatus')), opt=True)
    _NGRAN_CellReportItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NGRAN_CellReportItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___NGRAN_CellReportItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____NGRAN_CellReportItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGRAN_CellReportItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRAN_CellReportItem_iE_Extensions__item__id._const_tab = ____NGRAN_CellReportItem_iE_Extensions__item__id_tab
    ___NGRAN_CellReportItem_iE_Extensions__item__id._const_tab_at = None
    ___NGRAN_CellReportItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___NGRAN_CellReportItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NGRAN_CellReportItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGRAN_CellReportItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRAN_CellReportItem_iE_Extensions__item__criticality._const_tab = ____NGRAN_CellReportItem_iE_Extensions__item__criticality_tab
    ___NGRAN_CellReportItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NGRAN_CellReportItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NGRAN_CellReportItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NGRAN_CellReportItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGRAN_CellReportItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRAN_CellReportItem_iE_Extensions__item__extensionValue._const_tab = ____NGRAN_CellReportItem_iE_Extensions__item__extensionValue_tab
    ___NGRAN_CellReportItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NGRAN_CellReportItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NGRAN_CellReportItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NGRAN_CellReportItem_iE_Extensions__item__id),
        ('criticality', ___NGRAN_CellReportItem_iE_Extensions__item__criticality),
        ('extensionValue', ___NGRAN_CellReportItem_iE_Extensions__item__extensionValue),
        ])
    __NGRAN_CellReportItem_iE_Extensions__item_._ext = None
    _NGRAN_CellReportItem_iE_Extensions._cont = __NGRAN_CellReportItem_iE_Extensions__item_
    _NGRAN_CellReportItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NGRAN_CellReportItem._cont = ASN1Dict([
        ('nGRAN-CGI', _NGRAN_CellReportItem_nGRAN_CGI),
        ('nGRAN-CompositeAvailableCapacityGroup', _NGRAN_CellReportItem_nGRAN_CompositeAvailableCapacityGroup),
        ('nGRAN-NumberOfActiveUEs', _NGRAN_CellReportItem_nGRAN_NumberOfActiveUEs),
        ('nGRAN-NoofRRCConnections', _NGRAN_CellReportItem_nGRAN_NoofRRCConnections),
        ('nGRAN-RadioResourceStatus', _NGRAN_CellReportItem_nGRAN_RadioResourceStatus),
        ('iE-Extensions', _NGRAN_CellReportItem_iE_Extensions),
        ])
    NGRAN_CellReportItem._ext = []
    
    #-----< NGRAN-CellReportItem-ExtIEs >-----#
    NGRAN_CellReportItem_ExtIEs = CLASS(name='NGRAN-CellReportItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    NGRAN_CellReportItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NGRAN-NumberOfActiveUEs >-----#
    NGRAN_NumberOfActiveUEs = INT(name='NGRAN-NumberOfActiveUEs', mode=MODE_TYPE)
    NGRAN_NumberOfActiveUEs._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=[], er=[])
    
    #-----< NGRAN-NoofRRCConnections >-----#
    NGRAN_NoofRRCConnections = INT(name='NGRAN-NoofRRCConnections', mode=MODE_TYPE)
    NGRAN_NoofRRCConnections._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=[], er=[])
    
    #-----< NGRAN-RadioResourceStatus >-----#
    NGRAN_RadioResourceStatus = SEQ(name='NGRAN-RadioResourceStatus', mode=MODE_TYPE)
    _NGRAN_RadioResourceStatus_dL_GBR_PRB_usage_for_MIMO = INT(name='dL-GBR-PRB-usage-for-MIMO', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRAN_RadioResourceStatus_dL_GBR_PRB_usage_for_MIMO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _NGRAN_RadioResourceStatus_uL_GBR_PRB_usage_for_MIMO = INT(name='uL-GBR-PRB-usage-for-MIMO', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRAN_RadioResourceStatus_uL_GBR_PRB_usage_for_MIMO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _NGRAN_RadioResourceStatus_dL_non_GBR_PRB_usage_for_MIMO = INT(name='dL-non-GBR-PRB-usage-for-MIMO', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRAN_RadioResourceStatus_dL_non_GBR_PRB_usage_for_MIMO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _NGRAN_RadioResourceStatus_uL_non_GBR_PRB_usage_for_MIMO = INT(name='uL-non-GBR-PRB-usage-for-MIMO', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRAN_RadioResourceStatus_uL_non_GBR_PRB_usage_for_MIMO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _NGRAN_RadioResourceStatus_dL_Total_PRB_usage_for_MIMO = INT(name='dL-Total-PRB-usage-for-MIMO', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRAN_RadioResourceStatus_dL_Total_PRB_usage_for_MIMO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _NGRAN_RadioResourceStatus_uL_Total_PRB_usage_for_MIMO = INT(name='uL-Total-PRB-usage-for-MIMO', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRAN_RadioResourceStatus_uL_Total_PRB_usage_for_MIMO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _NGRAN_RadioResourceStatus_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NGRAN_RadioResourceStatus_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___NGRAN_RadioResourceStatus_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____NGRAN_RadioResourceStatus_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGRAN_RadioResourceStatus_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRAN_RadioResourceStatus_iE_Extensions__item__id._const_tab = ____NGRAN_RadioResourceStatus_iE_Extensions__item__id_tab
    ___NGRAN_RadioResourceStatus_iE_Extensions__item__id._const_tab_at = None
    ___NGRAN_RadioResourceStatus_iE_Extensions__item__id._const_tab_id = 'id'
    ___NGRAN_RadioResourceStatus_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NGRAN_RadioResourceStatus_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGRAN_RadioResourceStatus_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRAN_RadioResourceStatus_iE_Extensions__item__criticality._const_tab = ____NGRAN_RadioResourceStatus_iE_Extensions__item__criticality_tab
    ___NGRAN_RadioResourceStatus_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NGRAN_RadioResourceStatus_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NGRAN_RadioResourceStatus_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NGRAN_RadioResourceStatus_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGRAN_RadioResourceStatus_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRAN_RadioResourceStatus_iE_Extensions__item__extensionValue._const_tab = ____NGRAN_RadioResourceStatus_iE_Extensions__item__extensionValue_tab
    ___NGRAN_RadioResourceStatus_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NGRAN_RadioResourceStatus_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NGRAN_RadioResourceStatus_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NGRAN_RadioResourceStatus_iE_Extensions__item__id),
        ('criticality', ___NGRAN_RadioResourceStatus_iE_Extensions__item__criticality),
        ('extensionValue', ___NGRAN_RadioResourceStatus_iE_Extensions__item__extensionValue),
        ])
    __NGRAN_RadioResourceStatus_iE_Extensions__item_._ext = None
    _NGRAN_RadioResourceStatus_iE_Extensions._cont = __NGRAN_RadioResourceStatus_iE_Extensions__item_
    _NGRAN_RadioResourceStatus_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NGRAN_RadioResourceStatus._cont = ASN1Dict([
        ('dL-GBR-PRB-usage-for-MIMO', _NGRAN_RadioResourceStatus_dL_GBR_PRB_usage_for_MIMO),
        ('uL-GBR-PRB-usage-for-MIMO', _NGRAN_RadioResourceStatus_uL_GBR_PRB_usage_for_MIMO),
        ('dL-non-GBR-PRB-usage-for-MIMO', _NGRAN_RadioResourceStatus_dL_non_GBR_PRB_usage_for_MIMO),
        ('uL-non-GBR-PRB-usage-for-MIMO', _NGRAN_RadioResourceStatus_uL_non_GBR_PRB_usage_for_MIMO),
        ('dL-Total-PRB-usage-for-MIMO', _NGRAN_RadioResourceStatus_dL_Total_PRB_usage_for_MIMO),
        ('uL-Total-PRB-usage-for-MIMO', _NGRAN_RadioResourceStatus_uL_Total_PRB_usage_for_MIMO),
        ('iE-Extensions', _NGRAN_RadioResourceStatus_iE_Extensions),
        ])
    NGRAN_RadioResourceStatus._ext = []
    
    #-----< NGRAN-RadioResourceStatus-ExtIEs >-----#
    NGRAN_RadioResourceStatus_ExtIEs = CLASS(name='NGRAN-RadioResourceStatus-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    NGRAN_RadioResourceStatus_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InterSystemHOReport >-----#
    InterSystemHOReport = SEQ(name='InterSystemHOReport', mode=MODE_TYPE)
    _InterSystemHOReport_handoverReportType = CHOICE(name='handoverReportType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'InterSystemHandoverReportType')))
    _InterSystemHOReport_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InterSystemHOReport_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___InterSystemHOReport_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____InterSystemHOReport_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____InterSystemHOReport_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemHOReport_iE_Extensions__item__id._const_tab = ____InterSystemHOReport_iE_Extensions__item__id_tab
    ___InterSystemHOReport_iE_Extensions__item__id._const_tab_at = None
    ___InterSystemHOReport_iE_Extensions__item__id._const_tab_id = 'id'
    ___InterSystemHOReport_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____InterSystemHOReport_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____InterSystemHOReport_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemHOReport_iE_Extensions__item__criticality._const_tab = ____InterSystemHOReport_iE_Extensions__item__criticality_tab
    ___InterSystemHOReport_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___InterSystemHOReport_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___InterSystemHOReport_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____InterSystemHOReport_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____InterSystemHOReport_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemHOReport_iE_Extensions__item__extensionValue._const_tab = ____InterSystemHOReport_iE_Extensions__item__extensionValue_tab
    ___InterSystemHOReport_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InterSystemHOReport_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __InterSystemHOReport_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___InterSystemHOReport_iE_Extensions__item__id),
        ('criticality', ___InterSystemHOReport_iE_Extensions__item__criticality),
        ('extensionValue', ___InterSystemHOReport_iE_Extensions__item__extensionValue),
        ])
    __InterSystemHOReport_iE_Extensions__item_._ext = None
    _InterSystemHOReport_iE_Extensions._cont = __InterSystemHOReport_iE_Extensions__item_
    _InterSystemHOReport_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InterSystemHOReport._cont = ASN1Dict([
        ('handoverReportType', _InterSystemHOReport_handoverReportType),
        ('iE-Extensions', _InterSystemHOReport_iE_Extensions),
        ])
    InterSystemHOReport._ext = []
    
    #-----< InterSystemHOReport-ExtIEs >-----#
    InterSystemHOReport_ExtIEs = CLASS(name='InterSystemHOReport-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    InterSystemHOReport_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InterSystemHandoverReportType >-----#
    InterSystemHandoverReportType = CHOICE(name='InterSystemHandoverReportType', mode=MODE_TYPE)
    _InterSystemHandoverReportType_tooearlyIntersystemHO = SEQ(name='tooearlyIntersystemHO', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TooearlyIntersystemHO')))
    _InterSystemHandoverReportType_intersystemUnnecessaryHO = SEQ(name='intersystemUnnecessaryHO', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntersystemUnnecessaryHO')))
    _InterSystemHandoverReportType_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __InterSystemHandoverReportType_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___InterSystemHandoverReportType_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___InterSystemHandoverReportType_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __InterSystemHandoverReportType_choice_Extensions_id._const_tab = ___InterSystemHandoverReportType_choice_Extensions_id_tab
    __InterSystemHandoverReportType_choice_Extensions_id._const_tab_at = None
    __InterSystemHandoverReportType_choice_Extensions_id._const_tab_id = 'id'
    __InterSystemHandoverReportType_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___InterSystemHandoverReportType_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___InterSystemHandoverReportType_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __InterSystemHandoverReportType_choice_Extensions_criticality._const_tab = ___InterSystemHandoverReportType_choice_Extensions_criticality_tab
    __InterSystemHandoverReportType_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __InterSystemHandoverReportType_choice_Extensions_criticality._const_tab_id = 'criticality'
    __InterSystemHandoverReportType_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___InterSystemHandoverReportType_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___InterSystemHandoverReportType_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __InterSystemHandoverReportType_choice_Extensions_value._const_tab = ___InterSystemHandoverReportType_choice_Extensions_value_tab
    __InterSystemHandoverReportType_choice_Extensions_value._const_tab_at = ('..', 'id')
    __InterSystemHandoverReportType_choice_Extensions_value._const_tab_id = 'Value'
    _InterSystemHandoverReportType_choice_Extensions._cont = ASN1Dict([
        ('id', __InterSystemHandoverReportType_choice_Extensions_id),
        ('criticality', __InterSystemHandoverReportType_choice_Extensions_criticality),
        ('value', __InterSystemHandoverReportType_choice_Extensions_value),
        ])
    _InterSystemHandoverReportType_choice_Extensions._ext = None
    InterSystemHandoverReportType._cont = ASN1Dict([
        ('tooearlyIntersystemHO', _InterSystemHandoverReportType_tooearlyIntersystemHO),
        ('intersystemUnnecessaryHO', _InterSystemHandoverReportType_intersystemUnnecessaryHO),
        ('choice-Extensions', _InterSystemHandoverReportType_choice_Extensions),
        ])
    InterSystemHandoverReportType._ext = None
    
    #-----< InterSystemHandoverReportType-ExtIEs >-----#
    InterSystemHandoverReportType_ExtIEs = CLASS(name='InterSystemHandoverReportType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    InterSystemHandoverReportType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntersystemUnnecessaryHO >-----#
    IntersystemUnnecessaryHO = SEQ(name='IntersystemUnnecessaryHO', mode=MODE_TYPE)
    _IntersystemUnnecessaryHO_sourcecellID = CHOICE(name='sourcecellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _IntersystemUnnecessaryHO_targetcellID = SEQ(name='targetcellID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _IntersystemUnnecessaryHO_earlyIRATHO = ENUM(name='earlyIRATHO', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IntersystemUnnecessaryHO_earlyIRATHO._cont = ASN1Dict([('true', 0), ('false', 1)])
    _IntersystemUnnecessaryHO_earlyIRATHO._ext = []
    _IntersystemUnnecessaryHO_candidateCellList = SEQ_OF(name='candidateCellList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CandidateCellList')))
    _IntersystemUnnecessaryHO_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IntersystemUnnecessaryHO_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___IntersystemUnnecessaryHO_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____IntersystemUnnecessaryHO_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemUnnecessaryHO_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemUnnecessaryHO_iE_Extensions__item__id._const_tab = ____IntersystemUnnecessaryHO_iE_Extensions__item__id_tab
    ___IntersystemUnnecessaryHO_iE_Extensions__item__id._const_tab_at = None
    ___IntersystemUnnecessaryHO_iE_Extensions__item__id._const_tab_id = 'id'
    ___IntersystemUnnecessaryHO_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IntersystemUnnecessaryHO_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemUnnecessaryHO_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemUnnecessaryHO_iE_Extensions__item__criticality._const_tab = ____IntersystemUnnecessaryHO_iE_Extensions__item__criticality_tab
    ___IntersystemUnnecessaryHO_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IntersystemUnnecessaryHO_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IntersystemUnnecessaryHO_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IntersystemUnnecessaryHO_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____IntersystemUnnecessaryHO_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemUnnecessaryHO_iE_Extensions__item__extensionValue._const_tab = ____IntersystemUnnecessaryHO_iE_Extensions__item__extensionValue_tab
    ___IntersystemUnnecessaryHO_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IntersystemUnnecessaryHO_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IntersystemUnnecessaryHO_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IntersystemUnnecessaryHO_iE_Extensions__item__id),
        ('criticality', ___IntersystemUnnecessaryHO_iE_Extensions__item__criticality),
        ('extensionValue', ___IntersystemUnnecessaryHO_iE_Extensions__item__extensionValue),
        ])
    __IntersystemUnnecessaryHO_iE_Extensions__item_._ext = None
    _IntersystemUnnecessaryHO_iE_Extensions._cont = __IntersystemUnnecessaryHO_iE_Extensions__item_
    _IntersystemUnnecessaryHO_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IntersystemUnnecessaryHO._cont = ASN1Dict([
        ('sourcecellID', _IntersystemUnnecessaryHO_sourcecellID),
        ('targetcellID', _IntersystemUnnecessaryHO_targetcellID),
        ('earlyIRATHO', _IntersystemUnnecessaryHO_earlyIRATHO),
        ('candidateCellList', _IntersystemUnnecessaryHO_candidateCellList),
        ('iE-Extensions', _IntersystemUnnecessaryHO_iE_Extensions),
        ])
    IntersystemUnnecessaryHO._ext = []
    
    #-----< IntersystemUnnecessaryHO-ExtIEs >-----#
    IntersystemUnnecessaryHO_ExtIEs = CLASS(name='IntersystemUnnecessaryHO-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    IntersystemUnnecessaryHO_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LAC >-----#
    LAC = OCT_STR(name='LAC', mode=MODE_TYPE)
    LAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< LAI >-----#
    LAI = SEQ(name='LAI', mode=MODE_TYPE)
    _LAI_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _LAI_lAC = OCT_STR(name='lAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LAC')))
    _LAI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___LAI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____LAI_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LAI_iE_Extensions__item__id._const_tab = ____LAI_iE_Extensions__item__id_tab
    ___LAI_iE_Extensions__item__id._const_tab_at = None
    ___LAI_iE_Extensions__item__id._const_tab_id = 'id'
    ___LAI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____LAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LAI_iE_Extensions__item__criticality._const_tab = ____LAI_iE_Extensions__item__criticality_tab
    ___LAI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LAI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LAI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____LAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LAI_iE_Extensions__item__extensionValue._const_tab = ____LAI_iE_Extensions__item__extensionValue_tab
    ___LAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LAI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LAI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LAI_iE_Extensions__item__id),
        ('criticality', ___LAI_iE_Extensions__item__criticality),
        ('extensionValue', ___LAI_iE_Extensions__item__extensionValue),
        ])
    __LAI_iE_Extensions__item_._ext = None
    _LAI_iE_Extensions._cont = __LAI_iE_Extensions__item_
    _LAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LAI._cont = ASN1Dict([
        ('pLMNidentity', _LAI_pLMNidentity),
        ('lAC', _LAI_lAC),
        ('iE-Extensions', _LAI_iE_Extensions),
        ])
    LAI._ext = []
    
    #-----< LAI-ExtIEs >-----#
    LAI_ExtIEs = CLASS(name='LAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    LAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LastVisitedCellInformation >-----#
    LastVisitedCellInformation = CHOICE(name='LastVisitedCellInformation', mode=MODE_TYPE)
    _LastVisitedCellInformation_nGRANCell = SEQ(name='nGRANCell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LastVisitedNGRANCellInformation')))
    _LastVisitedCellInformation_eUTRANCell = OCT_STR(name='eUTRANCell', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LastVisitedEUTRANCellInformation')))
    _LastVisitedCellInformation_uTRANCell = OCT_STR(name='uTRANCell', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LastVisitedUTRANCellInformation')))
    _LastVisitedCellInformation_gERANCell = OCT_STR(name='gERANCell', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LastVisitedGERANCellInformation')))
    _LastVisitedCellInformation_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __LastVisitedCellInformation_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___LastVisitedCellInformation_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___LastVisitedCellInformation_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __LastVisitedCellInformation_choice_Extensions_id._const_tab = ___LastVisitedCellInformation_choice_Extensions_id_tab
    __LastVisitedCellInformation_choice_Extensions_id._const_tab_at = None
    __LastVisitedCellInformation_choice_Extensions_id._const_tab_id = 'id'
    __LastVisitedCellInformation_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___LastVisitedCellInformation_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___LastVisitedCellInformation_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __LastVisitedCellInformation_choice_Extensions_criticality._const_tab = ___LastVisitedCellInformation_choice_Extensions_criticality_tab
    __LastVisitedCellInformation_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __LastVisitedCellInformation_choice_Extensions_criticality._const_tab_id = 'criticality'
    __LastVisitedCellInformation_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___LastVisitedCellInformation_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___LastVisitedCellInformation_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __LastVisitedCellInformation_choice_Extensions_value._const_tab = ___LastVisitedCellInformation_choice_Extensions_value_tab
    __LastVisitedCellInformation_choice_Extensions_value._const_tab_at = ('..', 'id')
    __LastVisitedCellInformation_choice_Extensions_value._const_tab_id = 'Value'
    _LastVisitedCellInformation_choice_Extensions._cont = ASN1Dict([
        ('id', __LastVisitedCellInformation_choice_Extensions_id),
        ('criticality', __LastVisitedCellInformation_choice_Extensions_criticality),
        ('value', __LastVisitedCellInformation_choice_Extensions_value),
        ])
    _LastVisitedCellInformation_choice_Extensions._ext = None
    LastVisitedCellInformation._cont = ASN1Dict([
        ('nGRANCell', _LastVisitedCellInformation_nGRANCell),
        ('eUTRANCell', _LastVisitedCellInformation_eUTRANCell),
        ('uTRANCell', _LastVisitedCellInformation_uTRANCell),
        ('gERANCell', _LastVisitedCellInformation_gERANCell),
        ('choice-Extensions', _LastVisitedCellInformation_choice_Extensions),
        ])
    LastVisitedCellInformation._ext = None
    
    #-----< LastVisitedCellInformation-ExtIEs >-----#
    LastVisitedCellInformation_ExtIEs = CLASS(name='LastVisitedCellInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    LastVisitedCellInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LastVisitedCellItem >-----#
    LastVisitedCellItem = SEQ(name='LastVisitedCellItem', mode=MODE_TYPE)
    _LastVisitedCellItem_lastVisitedCellInformation = CHOICE(name='lastVisitedCellInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LastVisitedCellInformation')))
    _LastVisitedCellItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LastVisitedCellItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___LastVisitedCellItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____LastVisitedCellItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LastVisitedCellItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LastVisitedCellItem_iE_Extensions__item__id._const_tab = ____LastVisitedCellItem_iE_Extensions__item__id_tab
    ___LastVisitedCellItem_iE_Extensions__item__id._const_tab_at = None
    ___LastVisitedCellItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___LastVisitedCellItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____LastVisitedCellItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LastVisitedCellItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LastVisitedCellItem_iE_Extensions__item__criticality._const_tab = ____LastVisitedCellItem_iE_Extensions__item__criticality_tab
    ___LastVisitedCellItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LastVisitedCellItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LastVisitedCellItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____LastVisitedCellItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LastVisitedCellItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LastVisitedCellItem_iE_Extensions__item__extensionValue._const_tab = ____LastVisitedCellItem_iE_Extensions__item__extensionValue_tab
    ___LastVisitedCellItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LastVisitedCellItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LastVisitedCellItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LastVisitedCellItem_iE_Extensions__item__id),
        ('criticality', ___LastVisitedCellItem_iE_Extensions__item__criticality),
        ('extensionValue', ___LastVisitedCellItem_iE_Extensions__item__extensionValue),
        ])
    __LastVisitedCellItem_iE_Extensions__item_._ext = None
    _LastVisitedCellItem_iE_Extensions._cont = __LastVisitedCellItem_iE_Extensions__item_
    _LastVisitedCellItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LastVisitedCellItem._cont = ASN1Dict([
        ('lastVisitedCellInformation', _LastVisitedCellItem_lastVisitedCellInformation),
        ('iE-Extensions', _LastVisitedCellItem_iE_Extensions),
        ])
    LastVisitedCellItem._ext = []
    
    #-----< LastVisitedCellItem-ExtIEs >-----#
    LastVisitedCellItem_ExtIEs = CLASS(name='LastVisitedCellItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    LastVisitedCellItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LastVisitedEUTRANCellInformation >-----#
    LastVisitedEUTRANCellInformation = OCT_STR(name='LastVisitedEUTRANCellInformation', mode=MODE_TYPE)
    
    #-----< LastVisitedGERANCellInformation >-----#
    LastVisitedGERANCellInformation = OCT_STR(name='LastVisitedGERANCellInformation', mode=MODE_TYPE)
    
    #-----< LastVisitedNGRANCellInformation >-----#
    LastVisitedNGRANCellInformation = SEQ(name='LastVisitedNGRANCellInformation', mode=MODE_TYPE)
    _LastVisitedNGRANCellInformation_globalCellID = CHOICE(name='globalCellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _LastVisitedNGRANCellInformation_cellType = SEQ(name='cellType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellType')))
    _LastVisitedNGRANCellInformation_timeUEStayedInCell = INT(name='timeUEStayedInCell', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TimeUEStayedInCell')))
    _LastVisitedNGRANCellInformation_timeUEStayedInCellEnhancedGranularity = INT(name='timeUEStayedInCellEnhancedGranularity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TimeUEStayedInCellEnhancedGranularity')), opt=True)
    _LastVisitedNGRANCellInformation_hOCauseValue = CHOICE(name='hOCauseValue', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')), opt=True)
    _LastVisitedNGRANCellInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LastVisitedNGRANCellInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___LastVisitedNGRANCellInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____LastVisitedNGRANCellInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____LastVisitedNGRANCellInformation_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LastVisitedPSCellList')))
    ____LastVisitedNGRANCellInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 289), ('criticality', 'ignore'), ('Extension', _____LastVisitedNGRANCellInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___LastVisitedNGRANCellInformation_iE_Extensions__item__id._const_tab = ____LastVisitedNGRANCellInformation_iE_Extensions__item__id_tab
    ___LastVisitedNGRANCellInformation_iE_Extensions__item__id._const_tab_at = None
    ___LastVisitedNGRANCellInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___LastVisitedNGRANCellInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___LastVisitedNGRANCellInformation_iE_Extensions__item__criticality._const_tab = ____LastVisitedNGRANCellInformation_iE_Extensions__item__id_tab
    ___LastVisitedNGRANCellInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LastVisitedNGRANCellInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LastVisitedNGRANCellInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___LastVisitedNGRANCellInformation_iE_Extensions__item__extensionValue._const_tab = ____LastVisitedNGRANCellInformation_iE_Extensions__item__id_tab
    ___LastVisitedNGRANCellInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LastVisitedNGRANCellInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LastVisitedNGRANCellInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LastVisitedNGRANCellInformation_iE_Extensions__item__id),
        ('criticality', ___LastVisitedNGRANCellInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___LastVisitedNGRANCellInformation_iE_Extensions__item__extensionValue),
        ])
    __LastVisitedNGRANCellInformation_iE_Extensions__item_._ext = None
    _LastVisitedNGRANCellInformation_iE_Extensions._cont = __LastVisitedNGRANCellInformation_iE_Extensions__item_
    _LastVisitedNGRANCellInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LastVisitedNGRANCellInformation._cont = ASN1Dict([
        ('globalCellID', _LastVisitedNGRANCellInformation_globalCellID),
        ('cellType', _LastVisitedNGRANCellInformation_cellType),
        ('timeUEStayedInCell', _LastVisitedNGRANCellInformation_timeUEStayedInCell),
        ('timeUEStayedInCellEnhancedGranularity', _LastVisitedNGRANCellInformation_timeUEStayedInCellEnhancedGranularity),
        ('hOCauseValue', _LastVisitedNGRANCellInformation_hOCauseValue),
        ('iE-Extensions', _LastVisitedNGRANCellInformation_iE_Extensions),
        ])
    LastVisitedNGRANCellInformation._ext = []
    
    #-----< LastVisitedNGRANCellInformation-ExtIEs >-----#
    LastVisitedNGRANCellInformation_ExtIEs = CLASS(name='LastVisitedNGRANCellInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _LastVisitedNGRANCellInformation_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LastVisitedPSCellList')))
    LastVisitedNGRANCellInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 289), ('criticality', 'ignore'), ('Extension', _LastVisitedNGRANCellInformation_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< LastVisitedPSCellList >-----#
    LastVisitedPSCellList = SEQ_OF(name='LastVisitedPSCellList', mode=MODE_TYPE)
    _LastVisitedPSCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LastVisitedPSCellInformation')))
    LastVisitedPSCellList._cont = _LastVisitedPSCellList__item_
    LastVisitedPSCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< LastVisitedPSCellInformation >-----#
    LastVisitedPSCellInformation = SEQ(name='LastVisitedPSCellInformation', mode=MODE_TYPE)
    _LastVisitedPSCellInformation_pSCellID = CHOICE(name='pSCellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')), opt=True)
    _LastVisitedPSCellInformation_timeStay = INT(name='timeStay', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LastVisitedPSCellInformation_timeStay._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=40950)], ev=None, er=[])
    _LastVisitedPSCellInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LastVisitedPSCellInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___LastVisitedPSCellInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____LastVisitedPSCellInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LastVisitedPSCellInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LastVisitedPSCellInformation_iE_Extensions__item__id._const_tab = ____LastVisitedPSCellInformation_iE_Extensions__item__id_tab
    ___LastVisitedPSCellInformation_iE_Extensions__item__id._const_tab_at = None
    ___LastVisitedPSCellInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___LastVisitedPSCellInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____LastVisitedPSCellInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LastVisitedPSCellInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LastVisitedPSCellInformation_iE_Extensions__item__criticality._const_tab = ____LastVisitedPSCellInformation_iE_Extensions__item__criticality_tab
    ___LastVisitedPSCellInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LastVisitedPSCellInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LastVisitedPSCellInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____LastVisitedPSCellInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LastVisitedPSCellInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LastVisitedPSCellInformation_iE_Extensions__item__extensionValue._const_tab = ____LastVisitedPSCellInformation_iE_Extensions__item__extensionValue_tab
    ___LastVisitedPSCellInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LastVisitedPSCellInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LastVisitedPSCellInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LastVisitedPSCellInformation_iE_Extensions__item__id),
        ('criticality', ___LastVisitedPSCellInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___LastVisitedPSCellInformation_iE_Extensions__item__extensionValue),
        ])
    __LastVisitedPSCellInformation_iE_Extensions__item_._ext = None
    _LastVisitedPSCellInformation_iE_Extensions._cont = __LastVisitedPSCellInformation_iE_Extensions__item_
    _LastVisitedPSCellInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LastVisitedPSCellInformation._cont = ASN1Dict([
        ('pSCellID', _LastVisitedPSCellInformation_pSCellID),
        ('timeStay', _LastVisitedPSCellInformation_timeStay),
        ('iE-Extensions', _LastVisitedPSCellInformation_iE_Extensions),
        ])
    LastVisitedPSCellInformation._ext = []
    
    #-----< LastVisitedPSCellInformation-ExtIEs >-----#
    LastVisitedPSCellInformation_ExtIEs = CLASS(name='LastVisitedPSCellInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    LastVisitedPSCellInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LastVisitedUTRANCellInformation >-----#
    LastVisitedUTRANCellInformation = OCT_STR(name='LastVisitedUTRANCellInformation', mode=MODE_TYPE)
    
    #-----< LineType >-----#
    LineType = ENUM(name='LineType', mode=MODE_TYPE)
    LineType._cont = ASN1Dict([('dsl', 0), ('pon', 1)])
    LineType._ext = []
    
    #-----< LocationReportingAdditionalInfo >-----#
    LocationReportingAdditionalInfo = ENUM(name='LocationReportingAdditionalInfo', mode=MODE_TYPE)
    LocationReportingAdditionalInfo._cont = ASN1Dict([('includePSCell', 0)])
    LocationReportingAdditionalInfo._ext = []
    
    #-----< LocationReportingReferenceID >-----#
    LocationReportingReferenceID = INT(name='LocationReportingReferenceID', mode=MODE_TYPE)
    LocationReportingReferenceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=[], er=[])
    
    #-----< LocationReportingRequestType >-----#
    LocationReportingRequestType = SEQ(name='LocationReportingRequestType', mode=MODE_TYPE)
    _LocationReportingRequestType_eventType = ENUM(name='eventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EventType')))
    _LocationReportingRequestType_reportArea = ENUM(name='reportArea', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ReportArea')))
    _LocationReportingRequestType_areaOfInterestList = SEQ_OF(name='areaOfInterestList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AreaOfInterestList')), opt=True)
    _LocationReportingRequestType_locationReportingReferenceIDToBeCancelled = INT(name='locationReportingReferenceIDToBeCancelled', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LocationReportingReferenceID')), opt=True)
    _LocationReportingRequestType_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LocationReportingRequestType_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___LocationReportingRequestType_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____LocationReportingRequestType_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____LocationReportingRequestType_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LocationReportingAdditionalInfo')))
    ____LocationReportingRequestType_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 170), ('criticality', 'ignore'), ('Extension', _____LocationReportingRequestType_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___LocationReportingRequestType_iE_Extensions__item__id._const_tab = ____LocationReportingRequestType_iE_Extensions__item__id_tab
    ___LocationReportingRequestType_iE_Extensions__item__id._const_tab_at = None
    ___LocationReportingRequestType_iE_Extensions__item__id._const_tab_id = 'id'
    ___LocationReportingRequestType_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___LocationReportingRequestType_iE_Extensions__item__criticality._const_tab = ____LocationReportingRequestType_iE_Extensions__item__id_tab
    ___LocationReportingRequestType_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LocationReportingRequestType_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LocationReportingRequestType_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___LocationReportingRequestType_iE_Extensions__item__extensionValue._const_tab = ____LocationReportingRequestType_iE_Extensions__item__id_tab
    ___LocationReportingRequestType_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LocationReportingRequestType_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LocationReportingRequestType_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LocationReportingRequestType_iE_Extensions__item__id),
        ('criticality', ___LocationReportingRequestType_iE_Extensions__item__criticality),
        ('extensionValue', ___LocationReportingRequestType_iE_Extensions__item__extensionValue),
        ])
    __LocationReportingRequestType_iE_Extensions__item_._ext = None
    _LocationReportingRequestType_iE_Extensions._cont = __LocationReportingRequestType_iE_Extensions__item_
    _LocationReportingRequestType_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LocationReportingRequestType._cont = ASN1Dict([
        ('eventType', _LocationReportingRequestType_eventType),
        ('reportArea', _LocationReportingRequestType_reportArea),
        ('areaOfInterestList', _LocationReportingRequestType_areaOfInterestList),
        ('locationReportingReferenceIDToBeCancelled', _LocationReportingRequestType_locationReportingReferenceIDToBeCancelled),
        ('iE-Extensions', _LocationReportingRequestType_iE_Extensions),
        ])
    LocationReportingRequestType._ext = []
    
    #-----< LocationReportingRequestType-ExtIEs >-----#
    LocationReportingRequestType_ExtIEs = CLASS(name='LocationReportingRequestType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _LocationReportingRequestType_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LocationReportingAdditionalInfo')))
    LocationReportingRequestType_ExtIEs._val = ASN1Set(rv=[dict([('id', 170), ('criticality', 'ignore'), ('Extension', _LocationReportingRequestType_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< LoggedMDTNr >-----#
    LoggedMDTNr = SEQ(name='LoggedMDTNr', mode=MODE_TYPE)
    _LoggedMDTNr_loggingInterval = ENUM(name='loggingInterval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LoggingInterval')))
    _LoggedMDTNr_loggingDuration = ENUM(name='loggingDuration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LoggingDuration')))
    _LoggedMDTNr_loggedMDTTrigger = CHOICE(name='loggedMDTTrigger', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LoggedMDTTrigger')))
    _LoggedMDTNr_bluetoothMeasurementConfiguration = SEQ(name='bluetoothMeasurementConfiguration', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BluetoothMeasurementConfiguration')), opt=True)
    _LoggedMDTNr_wLANMeasurementConfiguration = SEQ(name='wLANMeasurementConfiguration', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'WLANMeasurementConfiguration')), opt=True)
    _LoggedMDTNr_sensorMeasurementConfiguration = SEQ(name='sensorMeasurementConfiguration', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SensorMeasurementConfiguration')), opt=True)
    _LoggedMDTNr_areaScopeOfNeighCellsList = SEQ_OF(name='areaScopeOfNeighCellsList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AreaScopeOfNeighCellsList')), opt=True)
    _LoggedMDTNr_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LoggedMDTNr_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___LoggedMDTNr_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____LoggedMDTNr_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____LoggedMDTNr_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EarlyMeasurement')))
    ____LoggedMDTNr_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 360), ('criticality', 'ignore'), ('Extension', _____LoggedMDTNr_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___LoggedMDTNr_iE_Extensions__item__id._const_tab = ____LoggedMDTNr_iE_Extensions__item__id_tab
    ___LoggedMDTNr_iE_Extensions__item__id._const_tab_at = None
    ___LoggedMDTNr_iE_Extensions__item__id._const_tab_id = 'id'
    ___LoggedMDTNr_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___LoggedMDTNr_iE_Extensions__item__criticality._const_tab = ____LoggedMDTNr_iE_Extensions__item__id_tab
    ___LoggedMDTNr_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LoggedMDTNr_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LoggedMDTNr_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___LoggedMDTNr_iE_Extensions__item__extensionValue._const_tab = ____LoggedMDTNr_iE_Extensions__item__id_tab
    ___LoggedMDTNr_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LoggedMDTNr_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LoggedMDTNr_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LoggedMDTNr_iE_Extensions__item__id),
        ('criticality', ___LoggedMDTNr_iE_Extensions__item__criticality),
        ('extensionValue', ___LoggedMDTNr_iE_Extensions__item__extensionValue),
        ])
    __LoggedMDTNr_iE_Extensions__item_._ext = None
    _LoggedMDTNr_iE_Extensions._cont = __LoggedMDTNr_iE_Extensions__item_
    _LoggedMDTNr_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LoggedMDTNr._cont = ASN1Dict([
        ('loggingInterval', _LoggedMDTNr_loggingInterval),
        ('loggingDuration', _LoggedMDTNr_loggingDuration),
        ('loggedMDTTrigger', _LoggedMDTNr_loggedMDTTrigger),
        ('bluetoothMeasurementConfiguration', _LoggedMDTNr_bluetoothMeasurementConfiguration),
        ('wLANMeasurementConfiguration', _LoggedMDTNr_wLANMeasurementConfiguration),
        ('sensorMeasurementConfiguration', _LoggedMDTNr_sensorMeasurementConfiguration),
        ('areaScopeOfNeighCellsList', _LoggedMDTNr_areaScopeOfNeighCellsList),
        ('iE-Extensions', _LoggedMDTNr_iE_Extensions),
        ])
    LoggedMDTNr._ext = []
    
    #-----< LoggedMDTNr-ExtIEs >-----#
    LoggedMDTNr_ExtIEs = CLASS(name='LoggedMDTNr-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _LoggedMDTNr_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EarlyMeasurement')))
    LoggedMDTNr_ExtIEs._val = ASN1Set(rv=[dict([('id', 360), ('criticality', 'ignore'), ('Extension', _LoggedMDTNr_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< LoggingInterval >-----#
    LoggingInterval = ENUM(name='LoggingInterval', mode=MODE_TYPE)
    LoggingInterval._cont = ASN1Dict([('ms320', 0), ('ms640', 1), ('ms1280', 2), ('ms2560', 3), ('ms5120', 4), ('ms10240', 5), ('ms20480', 6), ('ms30720', 7), ('ms40960', 8), ('ms61440', 9), ('infinity', 10)])
    LoggingInterval._ext = []
    
    #-----< LoggingDuration >-----#
    LoggingDuration = ENUM(name='LoggingDuration', mode=MODE_TYPE)
    LoggingDuration._cont = ASN1Dict([('m10', 0), ('m20', 1), ('m40', 2), ('m60', 3), ('m90', 4), ('m120', 5)])
    LoggingDuration._ext = []
    
    #-----< Links-to-log >-----#
    Links_to_log = ENUM(name='Links-to-log', mode=MODE_TYPE)
    Links_to_log._cont = ASN1Dict([('uplink', 0), ('downlink', 1), ('both-uplink-and-downlink', 2)])
    Links_to_log._ext = []
    
    #-----< LoggedMDTTrigger >-----#
    LoggedMDTTrigger = CHOICE(name='LoggedMDTTrigger', mode=MODE_TYPE)
    _LoggedMDTTrigger_periodical = NULL(name='periodical', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LoggedMDTTrigger_eventTrigger = CHOICE(name='eventTrigger', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EventTrigger')))
    _LoggedMDTTrigger_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __LoggedMDTTrigger_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___LoggedMDTTrigger_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___LoggedMDTTrigger_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __LoggedMDTTrigger_choice_Extensions_id._const_tab = ___LoggedMDTTrigger_choice_Extensions_id_tab
    __LoggedMDTTrigger_choice_Extensions_id._const_tab_at = None
    __LoggedMDTTrigger_choice_Extensions_id._const_tab_id = 'id'
    __LoggedMDTTrigger_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___LoggedMDTTrigger_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___LoggedMDTTrigger_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __LoggedMDTTrigger_choice_Extensions_criticality._const_tab = ___LoggedMDTTrigger_choice_Extensions_criticality_tab
    __LoggedMDTTrigger_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __LoggedMDTTrigger_choice_Extensions_criticality._const_tab_id = 'criticality'
    __LoggedMDTTrigger_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___LoggedMDTTrigger_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___LoggedMDTTrigger_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __LoggedMDTTrigger_choice_Extensions_value._const_tab = ___LoggedMDTTrigger_choice_Extensions_value_tab
    __LoggedMDTTrigger_choice_Extensions_value._const_tab_at = ('..', 'id')
    __LoggedMDTTrigger_choice_Extensions_value._const_tab_id = 'Value'
    _LoggedMDTTrigger_choice_Extensions._cont = ASN1Dict([
        ('id', __LoggedMDTTrigger_choice_Extensions_id),
        ('criticality', __LoggedMDTTrigger_choice_Extensions_criticality),
        ('value', __LoggedMDTTrigger_choice_Extensions_value),
        ])
    _LoggedMDTTrigger_choice_Extensions._ext = None
    LoggedMDTTrigger._cont = ASN1Dict([
        ('periodical', _LoggedMDTTrigger_periodical),
        ('eventTrigger', _LoggedMDTTrigger_eventTrigger),
        ('choice-Extensions', _LoggedMDTTrigger_choice_Extensions),
        ])
    LoggedMDTTrigger._ext = None
    
    #-----< LoggedMDTTrigger-ExtIEs >-----#
    LoggedMDTTrigger_ExtIEs = CLASS(name='LoggedMDTTrigger-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    LoggedMDTTrigger_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LTEM-Indication >-----#
    LTEM_Indication = ENUM(name='LTEM-Indication', mode=MODE_TYPE)
    LTEM_Indication._cont = ASN1Dict([('lte-m', 0)])
    LTEM_Indication._ext = []
    
    #-----< LTEUERLFReportContainer >-----#
    LTEUERLFReportContainer = OCT_STR(name='LTEUERLFReportContainer', mode=MODE_TYPE)
    
    #-----< LTEV2XServicesAuthorized >-----#
    LTEV2XServicesAuthorized = SEQ(name='LTEV2XServicesAuthorized', mode=MODE_TYPE)
    _LTEV2XServicesAuthorized_vehicleUE = ENUM(name='vehicleUE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'VehicleUE')), opt=True)
    _LTEV2XServicesAuthorized_pedestrianUE = ENUM(name='pedestrianUE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PedestrianUE')), opt=True)
    _LTEV2XServicesAuthorized_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LTEV2XServicesAuthorized_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___LTEV2XServicesAuthorized_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____LTEV2XServicesAuthorized_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LTEV2XServicesAuthorized_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTEV2XServicesAuthorized_iE_Extensions__item__id._const_tab = ____LTEV2XServicesAuthorized_iE_Extensions__item__id_tab
    ___LTEV2XServicesAuthorized_iE_Extensions__item__id._const_tab_at = None
    ___LTEV2XServicesAuthorized_iE_Extensions__item__id._const_tab_id = 'id'
    ___LTEV2XServicesAuthorized_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____LTEV2XServicesAuthorized_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LTEV2XServicesAuthorized_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTEV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab = ____LTEV2XServicesAuthorized_iE_Extensions__item__criticality_tab
    ___LTEV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LTEV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab = ____LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab
    ___LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LTEV2XServicesAuthorized_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LTEV2XServicesAuthorized_iE_Extensions__item__id),
        ('criticality', ___LTEV2XServicesAuthorized_iE_Extensions__item__criticality),
        ('extensionValue', ___LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue),
        ])
    __LTEV2XServicesAuthorized_iE_Extensions__item_._ext = None
    _LTEV2XServicesAuthorized_iE_Extensions._cont = __LTEV2XServicesAuthorized_iE_Extensions__item_
    _LTEV2XServicesAuthorized_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LTEV2XServicesAuthorized._cont = ASN1Dict([
        ('vehicleUE', _LTEV2XServicesAuthorized_vehicleUE),
        ('pedestrianUE', _LTEV2XServicesAuthorized_pedestrianUE),
        ('iE-Extensions', _LTEV2XServicesAuthorized_iE_Extensions),
        ])
    LTEV2XServicesAuthorized._ext = []
    
    #-----< LTEV2XServicesAuthorized-ExtIEs >-----#
    LTEV2XServicesAuthorized_ExtIEs = CLASS(name='LTEV2XServicesAuthorized-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    LTEV2XServicesAuthorized_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LTEUESidelinkAggregateMaximumBitrate >-----#
    LTEUESidelinkAggregateMaximumBitrate = SEQ(name='LTEUESidelinkAggregateMaximumBitrate', mode=MODE_TYPE)
    _LTEUESidelinkAggregateMaximumBitrate_uESidelinkAggregateMaximumBitRate = INT(name='uESidelinkAggregateMaximumBitRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _LTEUESidelinkAggregateMaximumBitrate_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab = ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_at = None
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_id = 'id'
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab = ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab = ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id),
        ('criticality', ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality),
        ('extensionValue', ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue),
        ])
    __LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item_._ext = None
    _LTEUESidelinkAggregateMaximumBitrate_iE_Extensions._cont = __LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item_
    _LTEUESidelinkAggregateMaximumBitrate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LTEUESidelinkAggregateMaximumBitrate._cont = ASN1Dict([
        ('uESidelinkAggregateMaximumBitRate', _LTEUESidelinkAggregateMaximumBitrate_uESidelinkAggregateMaximumBitRate),
        ('iE-Extensions', _LTEUESidelinkAggregateMaximumBitrate_iE_Extensions),
        ])
    LTEUESidelinkAggregateMaximumBitrate._ext = []
    
    #-----< LTEUE-Sidelink-Aggregate-MaximumBitrates-ExtIEs >-----#
    LTEUE_Sidelink_Aggregate_MaximumBitrates_ExtIEs = CLASS(name='LTEUE-Sidelink-Aggregate-MaximumBitrates-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    LTEUE_Sidelink_Aggregate_MaximumBitrates_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MaskedIMEISV >-----#
    MaskedIMEISV = BIT_STR(name='MaskedIMEISV', mode=MODE_TYPE)
    MaskedIMEISV._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    
    #-----< MaximumDataBurstVolume >-----#
    MaximumDataBurstVolume = INT(name='MaximumDataBurstVolume', mode=MODE_TYPE)
    MaximumDataBurstVolume._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=[], er=[ASN1RangeInt(lb=4096, ub=2000000)])
    
    #-----< MessageIdentifier >-----#
    MessageIdentifier = BIT_STR(name='MessageIdentifier', mode=MODE_TYPE)
    MessageIdentifier._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< MaximumIntegrityProtectedDataRate >-----#
    MaximumIntegrityProtectedDataRate = ENUM(name='MaximumIntegrityProtectedDataRate', mode=MODE_TYPE)
    MaximumIntegrityProtectedDataRate._cont = ASN1Dict([('bitrate64kbs', 0), ('maximum-UE-rate', 1)])
    MaximumIntegrityProtectedDataRate._ext = []
    
    #-----< MBS-AreaSessionID >-----#
    MBS_AreaSessionID = INT(name='MBS-AreaSessionID', mode=MODE_TYPE)
    MBS_AreaSessionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=[], er=[])
    
    #-----< MBS-DataForwardingResponseMRBList >-----#
    MBS_DataForwardingResponseMRBList = SEQ_OF(name='MBS-DataForwardingResponseMRBList', mode=MODE_TYPE)
    _MBS_DataForwardingResponseMRBList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-DataForwardingResponseMRBItem')))
    MBS_DataForwardingResponseMRBList._cont = _MBS_DataForwardingResponseMRBList__item_
    MBS_DataForwardingResponseMRBList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MBS-DataForwardingResponseMRBItem >-----#
    MBS_DataForwardingResponseMRBItem = SEQ(name='MBS-DataForwardingResponseMRBItem', mode=MODE_TYPE)
    _MBS_DataForwardingResponseMRBItem_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MRB-ID')))
    _MBS_DataForwardingResponseMRBItem_dL_Forwarding_UPTNLInformation = CHOICE(name='dL-Forwarding-UPTNLInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _MBS_DataForwardingResponseMRBItem_mRB_ProgressInformation = CHOICE(name='mRB-ProgressInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MRB-ProgressInformation')), opt=True)
    _MBS_DataForwardingResponseMRBItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBS_DataForwardingResponseMRBItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MBS_DataForwardingResponseMRBItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBS_DataForwardingResponseMRBItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_DataForwardingResponseMRBItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_DataForwardingResponseMRBItem_iE_Extensions__item__id._const_tab = ____MBS_DataForwardingResponseMRBItem_iE_Extensions__item__id_tab
    ___MBS_DataForwardingResponseMRBItem_iE_Extensions__item__id._const_tab_at = None
    ___MBS_DataForwardingResponseMRBItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBS_DataForwardingResponseMRBItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBS_DataForwardingResponseMRBItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_DataForwardingResponseMRBItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_DataForwardingResponseMRBItem_iE_Extensions__item__criticality._const_tab = ____MBS_DataForwardingResponseMRBItem_iE_Extensions__item__criticality_tab
    ___MBS_DataForwardingResponseMRBItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBS_DataForwardingResponseMRBItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBS_DataForwardingResponseMRBItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBS_DataForwardingResponseMRBItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_DataForwardingResponseMRBItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_DataForwardingResponseMRBItem_iE_Extensions__item__extensionValue._const_tab = ____MBS_DataForwardingResponseMRBItem_iE_Extensions__item__extensionValue_tab
    ___MBS_DataForwardingResponseMRBItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBS_DataForwardingResponseMRBItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBS_DataForwardingResponseMRBItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBS_DataForwardingResponseMRBItem_iE_Extensions__item__id),
        ('criticality', ___MBS_DataForwardingResponseMRBItem_iE_Extensions__item__criticality),
        ('extensionValue', ___MBS_DataForwardingResponseMRBItem_iE_Extensions__item__extensionValue),
        ])
    __MBS_DataForwardingResponseMRBItem_iE_Extensions__item_._ext = None
    _MBS_DataForwardingResponseMRBItem_iE_Extensions._cont = __MBS_DataForwardingResponseMRBItem_iE_Extensions__item_
    _MBS_DataForwardingResponseMRBItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBS_DataForwardingResponseMRBItem._cont = ASN1Dict([
        ('mRB-ID', _MBS_DataForwardingResponseMRBItem_mRB_ID),
        ('dL-Forwarding-UPTNLInformation', _MBS_DataForwardingResponseMRBItem_dL_Forwarding_UPTNLInformation),
        ('mRB-ProgressInformation', _MBS_DataForwardingResponseMRBItem_mRB_ProgressInformation),
        ('iE-Extensions', _MBS_DataForwardingResponseMRBItem_iE_Extensions),
        ])
    MBS_DataForwardingResponseMRBItem._ext = []
    
    #-----< MBS-DataForwardingResponseMRBItem-ExtIEs >-----#
    MBS_DataForwardingResponseMRBItem_ExtIEs = CLASS(name='MBS-DataForwardingResponseMRBItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MBS_DataForwardingResponseMRBItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-MappingandDataForwardingRequestList >-----#
    MBS_MappingandDataForwardingRequestList = SEQ_OF(name='MBS-MappingandDataForwardingRequestList', mode=MODE_TYPE)
    _MBS_MappingandDataForwardingRequestList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-MappingandDataForwardingRequestItem')))
    MBS_MappingandDataForwardingRequestList._cont = _MBS_MappingandDataForwardingRequestList__item_
    MBS_MappingandDataForwardingRequestList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MBS-MappingandDataForwardingRequestItem >-----#
    MBS_MappingandDataForwardingRequestItem = SEQ(name='MBS-MappingandDataForwardingRequestItem', mode=MODE_TYPE)
    _MBS_MappingandDataForwardingRequestItem_mRB_ID = INT(name='mRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MRB-ID')))
    _MBS_MappingandDataForwardingRequestItem_mBS_QoSFlowList = SEQ_OF(name='mBS-QoSFlowList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-QoSFlowList')))
    _MBS_MappingandDataForwardingRequestItem_mRB_ProgressInformation = CHOICE(name='mRB-ProgressInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MRB-ProgressInformation')), opt=True)
    _MBS_MappingandDataForwardingRequestItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBS_MappingandDataForwardingRequestItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__id._const_tab = ____MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__id_tab
    ___MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__id._const_tab_at = None
    ___MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__criticality._const_tab = ____MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__criticality_tab
    ___MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__extensionValue._const_tab = ____MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__extensionValue_tab
    ___MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBS_MappingandDataForwardingRequestItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__id),
        ('criticality', ___MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__criticality),
        ('extensionValue', ___MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__extensionValue),
        ])
    __MBS_MappingandDataForwardingRequestItem_iE_Extensions__item_._ext = None
    _MBS_MappingandDataForwardingRequestItem_iE_Extensions._cont = __MBS_MappingandDataForwardingRequestItem_iE_Extensions__item_
    _MBS_MappingandDataForwardingRequestItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBS_MappingandDataForwardingRequestItem._cont = ASN1Dict([
        ('mRB-ID', _MBS_MappingandDataForwardingRequestItem_mRB_ID),
        ('mBS-QoSFlowList', _MBS_MappingandDataForwardingRequestItem_mBS_QoSFlowList),
        ('mRB-ProgressInformation', _MBS_MappingandDataForwardingRequestItem_mRB_ProgressInformation),
        ('iE-Extensions', _MBS_MappingandDataForwardingRequestItem_iE_Extensions),
        ])
    MBS_MappingandDataForwardingRequestItem._ext = []
    
    #-----< MBS-MappingandDataForwardingRequestItem-ExtIEs >-----#
    MBS_MappingandDataForwardingRequestItem_ExtIEs = CLASS(name='MBS-MappingandDataForwardingRequestItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MBS_MappingandDataForwardingRequestItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-QoSFlowList >-----#
    MBS_QoSFlowList = SEQ_OF(name='MBS-QoSFlowList', mode=MODE_TYPE)
    _MBS_QoSFlowList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    MBS_QoSFlowList._cont = _MBS_QoSFlowList__item_
    MBS_QoSFlowList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< MRB-ProgressInformation >-----#
    MRB_ProgressInformation = CHOICE(name='MRB-ProgressInformation', mode=MODE_TYPE)
    _MRB_ProgressInformation_pDCP_SN_Length12 = INT(name='pDCP-SN-Length12', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MRB_ProgressInformation_pDCP_SN_Length12._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _MRB_ProgressInformation_pDCP_SN_Length18 = INT(name='pDCP-SN-Length18', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MRB_ProgressInformation_pDCP_SN_Length18._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=262143)], ev=None, er=[])
    _MRB_ProgressInformation_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __MRB_ProgressInformation_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___MRB_ProgressInformation_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MRB_ProgressInformation_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MRB_ProgressInformation_choice_Extensions_id._const_tab = ___MRB_ProgressInformation_choice_Extensions_id_tab
    __MRB_ProgressInformation_choice_Extensions_id._const_tab_at = None
    __MRB_ProgressInformation_choice_Extensions_id._const_tab_id = 'id'
    __MRB_ProgressInformation_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___MRB_ProgressInformation_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MRB_ProgressInformation_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MRB_ProgressInformation_choice_Extensions_criticality._const_tab = ___MRB_ProgressInformation_choice_Extensions_criticality_tab
    __MRB_ProgressInformation_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __MRB_ProgressInformation_choice_Extensions_criticality._const_tab_id = 'criticality'
    __MRB_ProgressInformation_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___MRB_ProgressInformation_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MRB_ProgressInformation_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MRB_ProgressInformation_choice_Extensions_value._const_tab = ___MRB_ProgressInformation_choice_Extensions_value_tab
    __MRB_ProgressInformation_choice_Extensions_value._const_tab_at = ('..', 'id')
    __MRB_ProgressInformation_choice_Extensions_value._const_tab_id = 'Value'
    _MRB_ProgressInformation_choice_Extensions._cont = ASN1Dict([
        ('id', __MRB_ProgressInformation_choice_Extensions_id),
        ('criticality', __MRB_ProgressInformation_choice_Extensions_criticality),
        ('value', __MRB_ProgressInformation_choice_Extensions_value),
        ])
    _MRB_ProgressInformation_choice_Extensions._ext = None
    MRB_ProgressInformation._cont = ASN1Dict([
        ('pDCP-SN-Length12', _MRB_ProgressInformation_pDCP_SN_Length12),
        ('pDCP-SN-Length18', _MRB_ProgressInformation_pDCP_SN_Length18),
        ('choice-Extensions', _MRB_ProgressInformation_choice_Extensions),
        ])
    MRB_ProgressInformation._ext = None
    
    #-----< MRB-ProgressInformation-ExtIEs >-----#
    MRB_ProgressInformation_ExtIEs = CLASS(name='MRB-ProgressInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    MRB_ProgressInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-QoSFlowsToBeSetupList >-----#
    MBS_QoSFlowsToBeSetupList = SEQ_OF(name='MBS-QoSFlowsToBeSetupList', mode=MODE_TYPE)
    _MBS_QoSFlowsToBeSetupList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-QoSFlowsToBeSetupItem')))
    MBS_QoSFlowsToBeSetupList._cont = _MBS_QoSFlowsToBeSetupList__item_
    MBS_QoSFlowsToBeSetupList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< MBS-QoSFlowsToBeSetupItem >-----#
    MBS_QoSFlowsToBeSetupItem = SEQ(name='MBS-QoSFlowsToBeSetupItem', mode=MODE_TYPE)
    _MBS_QoSFlowsToBeSetupItem_mBSqosFlowIdentifier = INT(name='mBSqosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _MBS_QoSFlowsToBeSetupItem_mBSqosFlowLevelQosParameters = SEQ(name='mBSqosFlowLevelQosParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowLevelQosParameters')))
    _MBS_QoSFlowsToBeSetupItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBS_QoSFlowsToBeSetupItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__id._const_tab = ____MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__id_tab
    ___MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__id._const_tab_at = None
    ___MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__criticality._const_tab = ____MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__criticality_tab
    ___MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__extensionValue._const_tab = ____MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__extensionValue_tab
    ___MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBS_QoSFlowsToBeSetupItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__id),
        ('criticality', ___MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__criticality),
        ('extensionValue', ___MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__extensionValue),
        ])
    __MBS_QoSFlowsToBeSetupItem_iE_Extensions__item_._ext = None
    _MBS_QoSFlowsToBeSetupItem_iE_Extensions._cont = __MBS_QoSFlowsToBeSetupItem_iE_Extensions__item_
    _MBS_QoSFlowsToBeSetupItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBS_QoSFlowsToBeSetupItem._cont = ASN1Dict([
        ('mBSqosFlowIdentifier', _MBS_QoSFlowsToBeSetupItem_mBSqosFlowIdentifier),
        ('mBSqosFlowLevelQosParameters', _MBS_QoSFlowsToBeSetupItem_mBSqosFlowLevelQosParameters),
        ('iE-Extensions', _MBS_QoSFlowsToBeSetupItem_iE_Extensions),
        ])
    MBS_QoSFlowsToBeSetupItem._ext = []
    
    #-----< MBS-QoSFlowsToBeSetupItem-ExtIEs >-----#
    MBS_QoSFlowsToBeSetupItem_ExtIEs = CLASS(name='MBS-QoSFlowsToBeSetupItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MBS_QoSFlowsToBeSetupItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-ServiceArea >-----#
    MBS_ServiceArea = CHOICE(name='MBS-ServiceArea', mode=MODE_TYPE)
    _MBS_ServiceArea_locationindependent = SEQ(name='locationindependent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-ServiceAreaInformation')))
    _MBS_ServiceArea_locationdependent = SEQ_OF(name='locationdependent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-ServiceAreaInformationList')))
    _MBS_ServiceArea_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __MBS_ServiceArea_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___MBS_ServiceArea_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MBS_ServiceArea_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MBS_ServiceArea_choice_Extensions_id._const_tab = ___MBS_ServiceArea_choice_Extensions_id_tab
    __MBS_ServiceArea_choice_Extensions_id._const_tab_at = None
    __MBS_ServiceArea_choice_Extensions_id._const_tab_id = 'id'
    __MBS_ServiceArea_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___MBS_ServiceArea_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MBS_ServiceArea_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MBS_ServiceArea_choice_Extensions_criticality._const_tab = ___MBS_ServiceArea_choice_Extensions_criticality_tab
    __MBS_ServiceArea_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __MBS_ServiceArea_choice_Extensions_criticality._const_tab_id = 'criticality'
    __MBS_ServiceArea_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___MBS_ServiceArea_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MBS_ServiceArea_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MBS_ServiceArea_choice_Extensions_value._const_tab = ___MBS_ServiceArea_choice_Extensions_value_tab
    __MBS_ServiceArea_choice_Extensions_value._const_tab_at = ('..', 'id')
    __MBS_ServiceArea_choice_Extensions_value._const_tab_id = 'Value'
    _MBS_ServiceArea_choice_Extensions._cont = ASN1Dict([
        ('id', __MBS_ServiceArea_choice_Extensions_id),
        ('criticality', __MBS_ServiceArea_choice_Extensions_criticality),
        ('value', __MBS_ServiceArea_choice_Extensions_value),
        ])
    _MBS_ServiceArea_choice_Extensions._ext = None
    MBS_ServiceArea._cont = ASN1Dict([
        ('locationindependent', _MBS_ServiceArea_locationindependent),
        ('locationdependent', _MBS_ServiceArea_locationdependent),
        ('choice-Extensions', _MBS_ServiceArea_choice_Extensions),
        ])
    MBS_ServiceArea._ext = None
    
    #-----< MBS-ServiceArea-ExtIEs >-----#
    MBS_ServiceArea_ExtIEs = CLASS(name='MBS-ServiceArea-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    MBS_ServiceArea_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-ServiceAreaInformationList >-----#
    MBS_ServiceAreaInformationList = SEQ_OF(name='MBS-ServiceAreaInformationList', mode=MODE_TYPE)
    _MBS_ServiceAreaInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-ServiceAreaInformationItem')))
    MBS_ServiceAreaInformationList._cont = _MBS_ServiceAreaInformationList__item_
    MBS_ServiceAreaInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< MBS-ServiceAreaInformationItem >-----#
    MBS_ServiceAreaInformationItem = SEQ(name='MBS-ServiceAreaInformationItem', mode=MODE_TYPE)
    _MBS_ServiceAreaInformationItem_mBS_AreaSessionID = INT(name='mBS-AreaSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')))
    _MBS_ServiceAreaInformationItem_mBS_ServiceAreaInformation = SEQ(name='mBS-ServiceAreaInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-ServiceAreaInformation')))
    _MBS_ServiceAreaInformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBS_ServiceAreaInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MBS_ServiceAreaInformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBS_ServiceAreaInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_ServiceAreaInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_ServiceAreaInformationItem_iE_Extensions__item__id._const_tab = ____MBS_ServiceAreaInformationItem_iE_Extensions__item__id_tab
    ___MBS_ServiceAreaInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___MBS_ServiceAreaInformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBS_ServiceAreaInformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBS_ServiceAreaInformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_ServiceAreaInformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_ServiceAreaInformationItem_iE_Extensions__item__criticality._const_tab = ____MBS_ServiceAreaInformationItem_iE_Extensions__item__criticality_tab
    ___MBS_ServiceAreaInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBS_ServiceAreaInformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBS_ServiceAreaInformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBS_ServiceAreaInformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_ServiceAreaInformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_ServiceAreaInformationItem_iE_Extensions__item__extensionValue._const_tab = ____MBS_ServiceAreaInformationItem_iE_Extensions__item__extensionValue_tab
    ___MBS_ServiceAreaInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBS_ServiceAreaInformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBS_ServiceAreaInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBS_ServiceAreaInformationItem_iE_Extensions__item__id),
        ('criticality', ___MBS_ServiceAreaInformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___MBS_ServiceAreaInformationItem_iE_Extensions__item__extensionValue),
        ])
    __MBS_ServiceAreaInformationItem_iE_Extensions__item_._ext = None
    _MBS_ServiceAreaInformationItem_iE_Extensions._cont = __MBS_ServiceAreaInformationItem_iE_Extensions__item_
    _MBS_ServiceAreaInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBS_ServiceAreaInformationItem._cont = ASN1Dict([
        ('mBS-AreaSessionID', _MBS_ServiceAreaInformationItem_mBS_AreaSessionID),
        ('mBS-ServiceAreaInformation', _MBS_ServiceAreaInformationItem_mBS_ServiceAreaInformation),
        ('iE-Extensions', _MBS_ServiceAreaInformationItem_iE_Extensions),
        ])
    MBS_ServiceAreaInformationItem._ext = []
    
    #-----< MBS-ServiceAreaInformationItem-ExtIEs >-----#
    MBS_ServiceAreaInformationItem_ExtIEs = CLASS(name='MBS-ServiceAreaInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MBS_ServiceAreaInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-ServiceAreaInformation >-----#
    MBS_ServiceAreaInformation = SEQ(name='MBS-ServiceAreaInformation', mode=MODE_TYPE)
    _MBS_ServiceAreaInformation_mBS_ServiceAreaCellList = SEQ_OF(name='mBS-ServiceAreaCellList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-ServiceAreaCellList')), opt=True)
    _MBS_ServiceAreaInformation_mBS_ServiceAreaTAIList = SEQ_OF(name='mBS-ServiceAreaTAIList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-ServiceAreaTAIList')), opt=True)
    _MBS_ServiceAreaInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBS_ServiceAreaInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MBS_ServiceAreaInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBS_ServiceAreaInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_ServiceAreaInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_ServiceAreaInformation_iE_Extensions__item__id._const_tab = ____MBS_ServiceAreaInformation_iE_Extensions__item__id_tab
    ___MBS_ServiceAreaInformation_iE_Extensions__item__id._const_tab_at = None
    ___MBS_ServiceAreaInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBS_ServiceAreaInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBS_ServiceAreaInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_ServiceAreaInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_ServiceAreaInformation_iE_Extensions__item__criticality._const_tab = ____MBS_ServiceAreaInformation_iE_Extensions__item__criticality_tab
    ___MBS_ServiceAreaInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBS_ServiceAreaInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBS_ServiceAreaInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBS_ServiceAreaInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_ServiceAreaInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_ServiceAreaInformation_iE_Extensions__item__extensionValue._const_tab = ____MBS_ServiceAreaInformation_iE_Extensions__item__extensionValue_tab
    ___MBS_ServiceAreaInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBS_ServiceAreaInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBS_ServiceAreaInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBS_ServiceAreaInformation_iE_Extensions__item__id),
        ('criticality', ___MBS_ServiceAreaInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___MBS_ServiceAreaInformation_iE_Extensions__item__extensionValue),
        ])
    __MBS_ServiceAreaInformation_iE_Extensions__item_._ext = None
    _MBS_ServiceAreaInformation_iE_Extensions._cont = __MBS_ServiceAreaInformation_iE_Extensions__item_
    _MBS_ServiceAreaInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBS_ServiceAreaInformation._cont = ASN1Dict([
        ('mBS-ServiceAreaCellList', _MBS_ServiceAreaInformation_mBS_ServiceAreaCellList),
        ('mBS-ServiceAreaTAIList', _MBS_ServiceAreaInformation_mBS_ServiceAreaTAIList),
        ('iE-Extensions', _MBS_ServiceAreaInformation_iE_Extensions),
        ])
    MBS_ServiceAreaInformation._ext = []
    
    #-----< MBS-ServiceAreaInformation-ExtIEs >-----#
    MBS_ServiceAreaInformation_ExtIEs = CLASS(name='MBS-ServiceAreaInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MBS_ServiceAreaInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-ServiceAreaCellList >-----#
    MBS_ServiceAreaCellList = SEQ_OF(name='MBS-ServiceAreaCellList', mode=MODE_TYPE)
    _MBS_ServiceAreaCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    MBS_ServiceAreaCellList._cont = _MBS_ServiceAreaCellList__item_
    MBS_ServiceAreaCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8192)], ev=None, er=[])
    
    #-----< MBS-ServiceAreaTAIList >-----#
    MBS_ServiceAreaTAIList = SEQ_OF(name='MBS-ServiceAreaTAIList', mode=MODE_TYPE)
    _MBS_ServiceAreaTAIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    MBS_ServiceAreaTAIList._cont = _MBS_ServiceAreaTAIList__item_
    MBS_ServiceAreaTAIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< MBS-SessionID >-----#
    MBS_SessionID = SEQ(name='MBS-SessionID', mode=MODE_TYPE)
    _MBS_SessionID_tMGI = OCT_STR(name='tMGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TMGI')))
    _MBS_SessionID_nID = BIT_STR(name='nID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NID')), opt=True)
    _MBS_SessionID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBS_SessionID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MBS_SessionID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBS_SessionID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_SessionID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_SessionID_iE_Extensions__item__id._const_tab = ____MBS_SessionID_iE_Extensions__item__id_tab
    ___MBS_SessionID_iE_Extensions__item__id._const_tab_at = None
    ___MBS_SessionID_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBS_SessionID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBS_SessionID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_SessionID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_SessionID_iE_Extensions__item__criticality._const_tab = ____MBS_SessionID_iE_Extensions__item__criticality_tab
    ___MBS_SessionID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBS_SessionID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBS_SessionID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBS_SessionID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_SessionID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_SessionID_iE_Extensions__item__extensionValue._const_tab = ____MBS_SessionID_iE_Extensions__item__extensionValue_tab
    ___MBS_SessionID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBS_SessionID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBS_SessionID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBS_SessionID_iE_Extensions__item__id),
        ('criticality', ___MBS_SessionID_iE_Extensions__item__criticality),
        ('extensionValue', ___MBS_SessionID_iE_Extensions__item__extensionValue),
        ])
    __MBS_SessionID_iE_Extensions__item_._ext = None
    _MBS_SessionID_iE_Extensions._cont = __MBS_SessionID_iE_Extensions__item_
    _MBS_SessionID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBS_SessionID._cont = ASN1Dict([
        ('tMGI', _MBS_SessionID_tMGI),
        ('nID', _MBS_SessionID_nID),
        ('iE-Extensions', _MBS_SessionID_iE_Extensions),
        ])
    MBS_SessionID._ext = []
    
    #-----< MBS-SessionID-ExtIEs >-----#
    MBS_SessionID_ExtIEs = CLASS(name='MBS-SessionID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MBS_SessionID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBSSessionFailedtoSetupList >-----#
    MBSSessionFailedtoSetupList = SEQ_OF(name='MBSSessionFailedtoSetupList', mode=MODE_TYPE)
    _MBSSessionFailedtoSetupList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionFailedtoSetupItem')))
    MBSSessionFailedtoSetupList._cont = _MBSSessionFailedtoSetupList__item_
    MBSSessionFailedtoSetupList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MBSSessionFailedtoSetupItem >-----#
    MBSSessionFailedtoSetupItem = SEQ(name='MBSSessionFailedtoSetupItem', mode=MODE_TYPE)
    _MBSSessionFailedtoSetupItem_mBS_SessionID = SEQ(name='mBS-SessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _MBSSessionFailedtoSetupItem_mBS_AreaSessionID = INT(name='mBS-AreaSessionID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')), opt=True)
    _MBSSessionFailedtoSetupItem_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _MBSSessionFailedtoSetupItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBSSessionFailedtoSetupItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MBSSessionFailedtoSetupItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBSSessionFailedtoSetupItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBSSessionFailedtoSetupItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionFailedtoSetupItem_iE_Extensions__item__id._const_tab = ____MBSSessionFailedtoSetupItem_iE_Extensions__item__id_tab
    ___MBSSessionFailedtoSetupItem_iE_Extensions__item__id._const_tab_at = None
    ___MBSSessionFailedtoSetupItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBSSessionFailedtoSetupItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBSSessionFailedtoSetupItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBSSessionFailedtoSetupItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionFailedtoSetupItem_iE_Extensions__item__criticality._const_tab = ____MBSSessionFailedtoSetupItem_iE_Extensions__item__criticality_tab
    ___MBSSessionFailedtoSetupItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBSSessionFailedtoSetupItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBSSessionFailedtoSetupItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBSSessionFailedtoSetupItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBSSessionFailedtoSetupItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionFailedtoSetupItem_iE_Extensions__item__extensionValue._const_tab = ____MBSSessionFailedtoSetupItem_iE_Extensions__item__extensionValue_tab
    ___MBSSessionFailedtoSetupItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBSSessionFailedtoSetupItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBSSessionFailedtoSetupItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBSSessionFailedtoSetupItem_iE_Extensions__item__id),
        ('criticality', ___MBSSessionFailedtoSetupItem_iE_Extensions__item__criticality),
        ('extensionValue', ___MBSSessionFailedtoSetupItem_iE_Extensions__item__extensionValue),
        ])
    __MBSSessionFailedtoSetupItem_iE_Extensions__item_._ext = None
    _MBSSessionFailedtoSetupItem_iE_Extensions._cont = __MBSSessionFailedtoSetupItem_iE_Extensions__item_
    _MBSSessionFailedtoSetupItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBSSessionFailedtoSetupItem._cont = ASN1Dict([
        ('mBS-SessionID', _MBSSessionFailedtoSetupItem_mBS_SessionID),
        ('mBS-AreaSessionID', _MBSSessionFailedtoSetupItem_mBS_AreaSessionID),
        ('cause', _MBSSessionFailedtoSetupItem_cause),
        ('iE-Extensions', _MBSSessionFailedtoSetupItem_iE_Extensions),
        ])
    MBSSessionFailedtoSetupItem._ext = []
    
    #-----< MBSSessionFailedtoSetupItem-ExtIEs >-----#
    MBSSessionFailedtoSetupItem_ExtIEs = CLASS(name='MBSSessionFailedtoSetupItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MBSSessionFailedtoSetupItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-ActiveSessionInformation-SourcetoTargetList >-----#
    MBS_ActiveSessionInformation_SourcetoTargetList = SEQ_OF(name='MBS-ActiveSessionInformation-SourcetoTargetList', mode=MODE_TYPE)
    _MBS_ActiveSessionInformation_SourcetoTargetList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-ActiveSessionInformation-SourcetoTargetItem')))
    MBS_ActiveSessionInformation_SourcetoTargetList._cont = _MBS_ActiveSessionInformation_SourcetoTargetList__item_
    MBS_ActiveSessionInformation_SourcetoTargetList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< MBS-ActiveSessionInformation-SourcetoTargetItem >-----#
    MBS_ActiveSessionInformation_SourcetoTargetItem = SEQ(name='MBS-ActiveSessionInformation-SourcetoTargetItem', mode=MODE_TYPE)
    _MBS_ActiveSessionInformation_SourcetoTargetItem_mBS_SessionID = SEQ(name='mBS-SessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _MBS_ActiveSessionInformation_SourcetoTargetItem_mBS_AreaSessionID = INT(name='mBS-AreaSessionID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')), opt=True)
    _MBS_ActiveSessionInformation_SourcetoTargetItem_mBS_ServiceArea = CHOICE(name='mBS-ServiceArea', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-ServiceArea')), opt=True)
    _MBS_ActiveSessionInformation_SourcetoTargetItem_mBS_QoSFlowsToBeSetupList = SEQ_OF(name='mBS-QoSFlowsToBeSetupList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-QoSFlowsToBeSetupList')))
    _MBS_ActiveSessionInformation_SourcetoTargetItem_mBS_MappingandDataForwardingRequestList = SEQ_OF(name='mBS-MappingandDataForwardingRequestList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-MappingandDataForwardingRequestList')), opt=True)
    _MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__id._const_tab = ____MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__id_tab
    ___MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__id._const_tab_at = None
    ___MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__criticality._const_tab = ____MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__criticality_tab
    ___MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__extensionValue._const_tab = ____MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__extensionValue_tab
    ___MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__id),
        ('criticality', ___MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__criticality),
        ('extensionValue', ___MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__extensionValue),
        ])
    __MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item_._ext = None
    _MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions._cont = __MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item_
    _MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBS_ActiveSessionInformation_SourcetoTargetItem._cont = ASN1Dict([
        ('mBS-SessionID', _MBS_ActiveSessionInformation_SourcetoTargetItem_mBS_SessionID),
        ('mBS-AreaSessionID', _MBS_ActiveSessionInformation_SourcetoTargetItem_mBS_AreaSessionID),
        ('mBS-ServiceArea', _MBS_ActiveSessionInformation_SourcetoTargetItem_mBS_ServiceArea),
        ('mBS-QoSFlowsToBeSetupList', _MBS_ActiveSessionInformation_SourcetoTargetItem_mBS_QoSFlowsToBeSetupList),
        ('mBS-MappingandDataForwardingRequestList', _MBS_ActiveSessionInformation_SourcetoTargetItem_mBS_MappingandDataForwardingRequestList),
        ('iE-Extensions', _MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions),
        ])
    MBS_ActiveSessionInformation_SourcetoTargetItem._ext = []
    
    #-----< MBS-ActiveSessionInformation-SourcetoTargetItem-ExtIEs >-----#
    MBS_ActiveSessionInformation_SourcetoTargetItem_ExtIEs = CLASS(name='MBS-ActiveSessionInformation-SourcetoTargetItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MBS_ActiveSessionInformation_SourcetoTargetItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-ActiveSessionInformation-TargettoSourceList >-----#
    MBS_ActiveSessionInformation_TargettoSourceList = SEQ_OF(name='MBS-ActiveSessionInformation-TargettoSourceList', mode=MODE_TYPE)
    _MBS_ActiveSessionInformation_TargettoSourceList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-ActiveSessionInformation-TargettoSourceItem')))
    MBS_ActiveSessionInformation_TargettoSourceList._cont = _MBS_ActiveSessionInformation_TargettoSourceList__item_
    MBS_ActiveSessionInformation_TargettoSourceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< MBS-ActiveSessionInformation-TargettoSourceItem >-----#
    MBS_ActiveSessionInformation_TargettoSourceItem = SEQ(name='MBS-ActiveSessionInformation-TargettoSourceItem', mode=MODE_TYPE)
    _MBS_ActiveSessionInformation_TargettoSourceItem_mBS_SessionID = SEQ(name='mBS-SessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _MBS_ActiveSessionInformation_TargettoSourceItem_mBS_DataForwardingResponseMRBList = SEQ_OF(name='mBS-DataForwardingResponseMRBList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-DataForwardingResponseMRBList')), opt=True)
    _MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__id._const_tab = ____MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__id_tab
    ___MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__id._const_tab_at = None
    ___MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__criticality._const_tab = ____MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__criticality_tab
    ___MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__extensionValue._const_tab = ____MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__extensionValue_tab
    ___MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__id),
        ('criticality', ___MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__criticality),
        ('extensionValue', ___MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__extensionValue),
        ])
    __MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item_._ext = None
    _MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions._cont = __MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item_
    _MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBS_ActiveSessionInformation_TargettoSourceItem._cont = ASN1Dict([
        ('mBS-SessionID', _MBS_ActiveSessionInformation_TargettoSourceItem_mBS_SessionID),
        ('mBS-DataForwardingResponseMRBList', _MBS_ActiveSessionInformation_TargettoSourceItem_mBS_DataForwardingResponseMRBList),
        ('iE-Extensions', _MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions),
        ])
    MBS_ActiveSessionInformation_TargettoSourceItem._ext = []
    
    #-----< MBS-ActiveSessionInformation-TargettoSourceItem-ExtIEs >-----#
    MBS_ActiveSessionInformation_TargettoSourceItem_ExtIEs = CLASS(name='MBS-ActiveSessionInformation-TargettoSourceItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MBS_ActiveSessionInformation_TargettoSourceItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBSSessionSetupOrModFailureTransfer >-----#
    MBSSessionSetupOrModFailureTransfer = SEQ(name='MBSSessionSetupOrModFailureTransfer', mode=MODE_TYPE)
    _MBSSessionSetupOrModFailureTransfer_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _MBSSessionSetupOrModFailureTransfer_criticalityDiagnostics = SEQ(name='criticalityDiagnostics', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')), opt=True)
    _MBSSessionSetupOrModFailureTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBSSessionSetupOrModFailureTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__id._const_tab = ____MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__id_tab
    ___MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__id._const_tab_at = None
    ___MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__criticality._const_tab = ____MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__criticality_tab
    ___MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__extensionValue._const_tab = ____MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__extensionValue_tab
    ___MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBSSessionSetupOrModFailureTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__id),
        ('criticality', ___MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__extensionValue),
        ])
    __MBSSessionSetupOrModFailureTransfer_iE_Extensions__item_._ext = None
    _MBSSessionSetupOrModFailureTransfer_iE_Extensions._cont = __MBSSessionSetupOrModFailureTransfer_iE_Extensions__item_
    _MBSSessionSetupOrModFailureTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBSSessionSetupOrModFailureTransfer._cont = ASN1Dict([
        ('cause', _MBSSessionSetupOrModFailureTransfer_cause),
        ('criticalityDiagnostics', _MBSSessionSetupOrModFailureTransfer_criticalityDiagnostics),
        ('iE-Extensions', _MBSSessionSetupOrModFailureTransfer_iE_Extensions),
        ])
    MBSSessionSetupOrModFailureTransfer._ext = []
    
    #-----< MBSSessionSetupOrModFailureTransfer-ExtIEs >-----#
    MBSSessionSetupOrModFailureTransfer_ExtIEs = CLASS(name='MBSSessionSetupOrModFailureTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MBSSessionSetupOrModFailureTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBSSessionSetupResponseList >-----#
    MBSSessionSetupResponseList = SEQ_OF(name='MBSSessionSetupResponseList', mode=MODE_TYPE)
    _MBSSessionSetupResponseList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionSetupResponseItem')))
    MBSSessionSetupResponseList._cont = _MBSSessionSetupResponseList__item_
    MBSSessionSetupResponseList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MBSSessionSetupResponseItem >-----#
    MBSSessionSetupResponseItem = SEQ(name='MBSSessionSetupResponseItem', mode=MODE_TYPE)
    _MBSSessionSetupResponseItem_mBS_SessionID = SEQ(name='mBS-SessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _MBSSessionSetupResponseItem_mBS_AreaSessionID = INT(name='mBS-AreaSessionID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')), opt=True)
    _MBSSessionSetupResponseItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBSSessionSetupResponseItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MBSSessionSetupResponseItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBSSessionSetupResponseItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBSSessionSetupResponseItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionSetupResponseItem_iE_Extensions__item__id._const_tab = ____MBSSessionSetupResponseItem_iE_Extensions__item__id_tab
    ___MBSSessionSetupResponseItem_iE_Extensions__item__id._const_tab_at = None
    ___MBSSessionSetupResponseItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBSSessionSetupResponseItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBSSessionSetupResponseItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBSSessionSetupResponseItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionSetupResponseItem_iE_Extensions__item__criticality._const_tab = ____MBSSessionSetupResponseItem_iE_Extensions__item__criticality_tab
    ___MBSSessionSetupResponseItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBSSessionSetupResponseItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBSSessionSetupResponseItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBSSessionSetupResponseItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBSSessionSetupResponseItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionSetupResponseItem_iE_Extensions__item__extensionValue._const_tab = ____MBSSessionSetupResponseItem_iE_Extensions__item__extensionValue_tab
    ___MBSSessionSetupResponseItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBSSessionSetupResponseItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBSSessionSetupResponseItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBSSessionSetupResponseItem_iE_Extensions__item__id),
        ('criticality', ___MBSSessionSetupResponseItem_iE_Extensions__item__criticality),
        ('extensionValue', ___MBSSessionSetupResponseItem_iE_Extensions__item__extensionValue),
        ])
    __MBSSessionSetupResponseItem_iE_Extensions__item_._ext = None
    _MBSSessionSetupResponseItem_iE_Extensions._cont = __MBSSessionSetupResponseItem_iE_Extensions__item_
    _MBSSessionSetupResponseItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBSSessionSetupResponseItem._cont = ASN1Dict([
        ('mBS-SessionID', _MBSSessionSetupResponseItem_mBS_SessionID),
        ('mBS-AreaSessionID', _MBSSessionSetupResponseItem_mBS_AreaSessionID),
        ('iE-Extensions', _MBSSessionSetupResponseItem_iE_Extensions),
        ])
    MBSSessionSetupResponseItem._ext = []
    
    #-----< MBSSessionSetupResponseItem-ExtIEs >-----#
    MBSSessionSetupResponseItem_ExtIEs = CLASS(name='MBSSessionSetupResponseItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MBSSessionSetupResponseItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBSSessionSetupOrModRequestTransfer >-----#
    MBSSessionSetupOrModRequestTransfer = SEQ(name='MBSSessionSetupOrModRequestTransfer', mode=MODE_TYPE)
    _MBSSessionSetupOrModRequestTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __MBSSessionSetupOrModRequestTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___MBSSessionSetupOrModRequestTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____MBSSessionSetupOrModRequestTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____MBSSessionSetupOrModRequestTransfer_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionTNLInfo5GC')))
    _____MBSSessionSetupOrModRequestTransfer_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-QoSFlowsToBeSetupList')))
    _____MBSSessionSetupOrModRequestTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionFSAIDList')))
    ____MBSSessionSetupOrModRequestTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 352), ('criticality', 'reject'), ('Value', _____MBSSessionSetupOrModRequestTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 297), ('criticality', 'reject'), ('Value', _____MBSSessionSetupOrModRequestTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 357), ('criticality', 'ignore'), ('Value', _____MBSSessionSetupOrModRequestTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MBSSessionSetupOrModRequestTransfer_protocolIEs__item__id._const_tab = ____MBSSessionSetupOrModRequestTransfer_protocolIEs__item__id_tab
    ___MBSSessionSetupOrModRequestTransfer_protocolIEs__item__id._const_tab_at = None
    ___MBSSessionSetupOrModRequestTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___MBSSessionSetupOrModRequestTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___MBSSessionSetupOrModRequestTransfer_protocolIEs__item__criticality._const_tab = ____MBSSessionSetupOrModRequestTransfer_protocolIEs__item__id_tab
    ___MBSSessionSetupOrModRequestTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MBSSessionSetupOrModRequestTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MBSSessionSetupOrModRequestTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___MBSSessionSetupOrModRequestTransfer_protocolIEs__item__value._const_tab = ____MBSSessionSetupOrModRequestTransfer_protocolIEs__item__id_tab
    ___MBSSessionSetupOrModRequestTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MBSSessionSetupOrModRequestTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __MBSSessionSetupOrModRequestTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MBSSessionSetupOrModRequestTransfer_protocolIEs__item__id),
        ('criticality', ___MBSSessionSetupOrModRequestTransfer_protocolIEs__item__criticality),
        ('value', ___MBSSessionSetupOrModRequestTransfer_protocolIEs__item__value),
        ])
    __MBSSessionSetupOrModRequestTransfer_protocolIEs__item_._ext = None
    _MBSSessionSetupOrModRequestTransfer_protocolIEs._cont = __MBSSessionSetupOrModRequestTransfer_protocolIEs__item_
    _MBSSessionSetupOrModRequestTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MBSSessionSetupOrModRequestTransfer._cont = ASN1Dict([
        ('protocolIEs', _MBSSessionSetupOrModRequestTransfer_protocolIEs),
        ])
    MBSSessionSetupOrModRequestTransfer._ext = []
    
    #-----< MBSSessionSetupOrModRequestTransferIEs >-----#
    MBSSessionSetupOrModRequestTransferIEs = CLASS(name='MBSSessionSetupOrModRequestTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _MBSSessionSetupOrModRequestTransferIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionTNLInfo5GC')))
    _MBSSessionSetupOrModRequestTransferIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-QoSFlowsToBeSetupList')))
    _MBSSessionSetupOrModRequestTransferIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionFSAIDList')))
    MBSSessionSetupOrModRequestTransferIEs._val = ASN1Set(rv=[dict([('id', 352), ('criticality', 'reject'), ('Value', _MBSSessionSetupOrModRequestTransferIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 297), ('criticality', 'reject'), ('Value', _MBSSessionSetupOrModRequestTransferIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 357), ('criticality', 'ignore'), ('Value', _MBSSessionSetupOrModRequestTransferIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBS-SessionFSAIDList >-----#
    MBS_SessionFSAIDList = SEQ_OF(name='MBS-SessionFSAIDList', mode=MODE_TYPE)
    _MBS_SessionFSAIDList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionFSAID')))
    MBS_SessionFSAIDList._cont = _MBS_SessionFSAIDList__item_
    MBS_SessionFSAIDList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< MBS-SessionFSAID >-----#
    MBS_SessionFSAID = OCT_STR(name='MBS-SessionFSAID', mode=MODE_TYPE)
    MBS_SessionFSAID._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< MBSSessionReleaseResponseTransfer >-----#
    MBSSessionReleaseResponseTransfer = SEQ(name='MBSSessionReleaseResponseTransfer', mode=MODE_TYPE)
    _MBSSessionReleaseResponseTransfer_mBS_SessionTNLInfoNGRAN = CHOICE(name='mBS-SessionTNLInfoNGRAN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionTNLInfoNGRAN')), opt=True)
    _MBSSessionReleaseResponseTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBSSessionReleaseResponseTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MBSSessionReleaseResponseTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBSSessionReleaseResponseTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBSSessionReleaseResponseTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionReleaseResponseTransfer_iE_Extensions__item__id._const_tab = ____MBSSessionReleaseResponseTransfer_iE_Extensions__item__id_tab
    ___MBSSessionReleaseResponseTransfer_iE_Extensions__item__id._const_tab_at = None
    ___MBSSessionReleaseResponseTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBSSessionReleaseResponseTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBSSessionReleaseResponseTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBSSessionReleaseResponseTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionReleaseResponseTransfer_iE_Extensions__item__criticality._const_tab = ____MBSSessionReleaseResponseTransfer_iE_Extensions__item__criticality_tab
    ___MBSSessionReleaseResponseTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBSSessionReleaseResponseTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBSSessionReleaseResponseTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBSSessionReleaseResponseTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBSSessionReleaseResponseTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionReleaseResponseTransfer_iE_Extensions__item__extensionValue._const_tab = ____MBSSessionReleaseResponseTransfer_iE_Extensions__item__extensionValue_tab
    ___MBSSessionReleaseResponseTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBSSessionReleaseResponseTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBSSessionReleaseResponseTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBSSessionReleaseResponseTransfer_iE_Extensions__item__id),
        ('criticality', ___MBSSessionReleaseResponseTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___MBSSessionReleaseResponseTransfer_iE_Extensions__item__extensionValue),
        ])
    __MBSSessionReleaseResponseTransfer_iE_Extensions__item_._ext = None
    _MBSSessionReleaseResponseTransfer_iE_Extensions._cont = __MBSSessionReleaseResponseTransfer_iE_Extensions__item_
    _MBSSessionReleaseResponseTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBSSessionReleaseResponseTransfer._cont = ASN1Dict([
        ('mBS-SessionTNLInfoNGRAN', _MBSSessionReleaseResponseTransfer_mBS_SessionTNLInfoNGRAN),
        ('iE-Extensions', _MBSSessionReleaseResponseTransfer_iE_Extensions),
        ])
    MBSSessionReleaseResponseTransfer._ext = []
    
    #-----< MBSSessionReleaseResponseTransfer-ExtIEs >-----#
    MBSSessionReleaseResponseTransfer_ExtIEs = CLASS(name='MBSSessionReleaseResponseTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MBSSessionReleaseResponseTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBSSessionSetupOrModResponseTransfer >-----#
    MBSSessionSetupOrModResponseTransfer = SEQ(name='MBSSessionSetupOrModResponseTransfer', mode=MODE_TYPE)
    _MBSSessionSetupOrModResponseTransfer_mBS_SessionTNLInfoNGRAN = CHOICE(name='mBS-SessionTNLInfoNGRAN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionTNLInfoNGRAN')), opt=True)
    _MBSSessionSetupOrModResponseTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBSSessionSetupOrModResponseTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__id._const_tab = ____MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__id_tab
    ___MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__id._const_tab_at = None
    ___MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__criticality._const_tab = ____MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__criticality_tab
    ___MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__extensionValue._const_tab = ____MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__extensionValue_tab
    ___MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBSSessionSetupOrModResponseTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__id),
        ('criticality', ___MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__extensionValue),
        ])
    __MBSSessionSetupOrModResponseTransfer_iE_Extensions__item_._ext = None
    _MBSSessionSetupOrModResponseTransfer_iE_Extensions._cont = __MBSSessionSetupOrModResponseTransfer_iE_Extensions__item_
    _MBSSessionSetupOrModResponseTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBSSessionSetupOrModResponseTransfer._cont = ASN1Dict([
        ('mBS-SessionTNLInfoNGRAN', _MBSSessionSetupOrModResponseTransfer_mBS_SessionTNLInfoNGRAN),
        ('iE-Extensions', _MBSSessionSetupOrModResponseTransfer_iE_Extensions),
        ])
    MBSSessionSetupOrModResponseTransfer._ext = []
    
    #-----< MBSSessionSetupOrModResponseTransfer-ExtIEs >-----#
    MBSSessionSetupOrModResponseTransfer_ExtIEs = CLASS(name='MBSSessionSetupOrModResponseTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MBSSessionSetupOrModResponseTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-SupportIndicator >-----#
    MBS_SupportIndicator = ENUM(name='MBS-SupportIndicator', mode=MODE_TYPE)
    MBS_SupportIndicator._cont = ASN1Dict([('true', 0)])
    MBS_SupportIndicator._ext = []
    
    #-----< MBS-SessionTNLInfo5GC >-----#
    MBS_SessionTNLInfo5GC = CHOICE(name='MBS-SessionTNLInfo5GC', mode=MODE_TYPE)
    _MBS_SessionTNLInfo5GC_locationindependent = SEQ(name='locationindependent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SharedNGU-MulticastTNLInformation')))
    _MBS_SessionTNLInfo5GC_locationdependent = SEQ_OF(name='locationdependent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionTNLInfo5GCList')))
    _MBS_SessionTNLInfo5GC_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __MBS_SessionTNLInfo5GC_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___MBS_SessionTNLInfo5GC_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MBS_SessionTNLInfo5GC_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MBS_SessionTNLInfo5GC_choice_Extensions_id._const_tab = ___MBS_SessionTNLInfo5GC_choice_Extensions_id_tab
    __MBS_SessionTNLInfo5GC_choice_Extensions_id._const_tab_at = None
    __MBS_SessionTNLInfo5GC_choice_Extensions_id._const_tab_id = 'id'
    __MBS_SessionTNLInfo5GC_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___MBS_SessionTNLInfo5GC_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MBS_SessionTNLInfo5GC_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MBS_SessionTNLInfo5GC_choice_Extensions_criticality._const_tab = ___MBS_SessionTNLInfo5GC_choice_Extensions_criticality_tab
    __MBS_SessionTNLInfo5GC_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __MBS_SessionTNLInfo5GC_choice_Extensions_criticality._const_tab_id = 'criticality'
    __MBS_SessionTNLInfo5GC_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___MBS_SessionTNLInfo5GC_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MBS_SessionTNLInfo5GC_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MBS_SessionTNLInfo5GC_choice_Extensions_value._const_tab = ___MBS_SessionTNLInfo5GC_choice_Extensions_value_tab
    __MBS_SessionTNLInfo5GC_choice_Extensions_value._const_tab_at = ('..', 'id')
    __MBS_SessionTNLInfo5GC_choice_Extensions_value._const_tab_id = 'Value'
    _MBS_SessionTNLInfo5GC_choice_Extensions._cont = ASN1Dict([
        ('id', __MBS_SessionTNLInfo5GC_choice_Extensions_id),
        ('criticality', __MBS_SessionTNLInfo5GC_choice_Extensions_criticality),
        ('value', __MBS_SessionTNLInfo5GC_choice_Extensions_value),
        ])
    _MBS_SessionTNLInfo5GC_choice_Extensions._ext = None
    MBS_SessionTNLInfo5GC._cont = ASN1Dict([
        ('locationindependent', _MBS_SessionTNLInfo5GC_locationindependent),
        ('locationdependent', _MBS_SessionTNLInfo5GC_locationdependent),
        ('choice-Extensions', _MBS_SessionTNLInfo5GC_choice_Extensions),
        ])
    MBS_SessionTNLInfo5GC._ext = None
    
    #-----< MBS-SessionTNLInfo5GC-ExtIEs >-----#
    MBS_SessionTNLInfo5GC_ExtIEs = CLASS(name='MBS-SessionTNLInfo5GC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    MBS_SessionTNLInfo5GC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-SessionTNLInfo5GCList >-----#
    MBS_SessionTNLInfo5GCList = SEQ_OF(name='MBS-SessionTNLInfo5GCList', mode=MODE_TYPE)
    _MBS_SessionTNLInfo5GCList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionTNLInfo5GCItem')))
    MBS_SessionTNLInfo5GCList._cont = _MBS_SessionTNLInfo5GCList__item_
    MBS_SessionTNLInfo5GCList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< MBS-SessionTNLInfo5GCItem >-----#
    MBS_SessionTNLInfo5GCItem = SEQ(name='MBS-SessionTNLInfo5GCItem', mode=MODE_TYPE)
    _MBS_SessionTNLInfo5GCItem_mBS_AreaSessionID = INT(name='mBS-AreaSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')))
    _MBS_SessionTNLInfo5GCItem_sharedNGU_MulticastTNLInformation = SEQ(name='sharedNGU-MulticastTNLInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SharedNGU-MulticastTNLInformation')))
    _MBS_SessionTNLInfo5GCItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBS_SessionTNLInfo5GCItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MBS_SessionTNLInfo5GCItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBS_SessionTNLInfo5GCItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_SessionTNLInfo5GCItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_SessionTNLInfo5GCItem_iE_Extensions__item__id._const_tab = ____MBS_SessionTNLInfo5GCItem_iE_Extensions__item__id_tab
    ___MBS_SessionTNLInfo5GCItem_iE_Extensions__item__id._const_tab_at = None
    ___MBS_SessionTNLInfo5GCItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBS_SessionTNLInfo5GCItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBS_SessionTNLInfo5GCItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_SessionTNLInfo5GCItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_SessionTNLInfo5GCItem_iE_Extensions__item__criticality._const_tab = ____MBS_SessionTNLInfo5GCItem_iE_Extensions__item__criticality_tab
    ___MBS_SessionTNLInfo5GCItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBS_SessionTNLInfo5GCItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBS_SessionTNLInfo5GCItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBS_SessionTNLInfo5GCItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_SessionTNLInfo5GCItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_SessionTNLInfo5GCItem_iE_Extensions__item__extensionValue._const_tab = ____MBS_SessionTNLInfo5GCItem_iE_Extensions__item__extensionValue_tab
    ___MBS_SessionTNLInfo5GCItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBS_SessionTNLInfo5GCItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBS_SessionTNLInfo5GCItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBS_SessionTNLInfo5GCItem_iE_Extensions__item__id),
        ('criticality', ___MBS_SessionTNLInfo5GCItem_iE_Extensions__item__criticality),
        ('extensionValue', ___MBS_SessionTNLInfo5GCItem_iE_Extensions__item__extensionValue),
        ])
    __MBS_SessionTNLInfo5GCItem_iE_Extensions__item_._ext = None
    _MBS_SessionTNLInfo5GCItem_iE_Extensions._cont = __MBS_SessionTNLInfo5GCItem_iE_Extensions__item_
    _MBS_SessionTNLInfo5GCItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBS_SessionTNLInfo5GCItem._cont = ASN1Dict([
        ('mBS-AreaSessionID', _MBS_SessionTNLInfo5GCItem_mBS_AreaSessionID),
        ('sharedNGU-MulticastTNLInformation', _MBS_SessionTNLInfo5GCItem_sharedNGU_MulticastTNLInformation),
        ('iE-Extensions', _MBS_SessionTNLInfo5GCItem_iE_Extensions),
        ])
    MBS_SessionTNLInfo5GCItem._ext = []
    
    #-----< MBS-SessionTNLInfo5GCItem-ExtIEs >-----#
    MBS_SessionTNLInfo5GCItem_ExtIEs = CLASS(name='MBS-SessionTNLInfo5GCItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MBS_SessionTNLInfo5GCItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-SessionTNLInfoNGRAN >-----#
    MBS_SessionTNLInfoNGRAN = CHOICE(name='MBS-SessionTNLInfoNGRAN', mode=MODE_TYPE)
    _MBS_SessionTNLInfoNGRAN_locationindependent = CHOICE(name='locationindependent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _MBS_SessionTNLInfoNGRAN_locationdependent = SEQ_OF(name='locationdependent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionTNLInfoNGRANList')))
    _MBS_SessionTNLInfoNGRAN_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __MBS_SessionTNLInfoNGRAN_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___MBS_SessionTNLInfoNGRAN_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MBS_SessionTNLInfoNGRAN_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MBS_SessionTNLInfoNGRAN_choice_Extensions_id._const_tab = ___MBS_SessionTNLInfoNGRAN_choice_Extensions_id_tab
    __MBS_SessionTNLInfoNGRAN_choice_Extensions_id._const_tab_at = None
    __MBS_SessionTNLInfoNGRAN_choice_Extensions_id._const_tab_id = 'id'
    __MBS_SessionTNLInfoNGRAN_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___MBS_SessionTNLInfoNGRAN_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MBS_SessionTNLInfoNGRAN_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MBS_SessionTNLInfoNGRAN_choice_Extensions_criticality._const_tab = ___MBS_SessionTNLInfoNGRAN_choice_Extensions_criticality_tab
    __MBS_SessionTNLInfoNGRAN_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __MBS_SessionTNLInfoNGRAN_choice_Extensions_criticality._const_tab_id = 'criticality'
    __MBS_SessionTNLInfoNGRAN_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___MBS_SessionTNLInfoNGRAN_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MBS_SessionTNLInfoNGRAN_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MBS_SessionTNLInfoNGRAN_choice_Extensions_value._const_tab = ___MBS_SessionTNLInfoNGRAN_choice_Extensions_value_tab
    __MBS_SessionTNLInfoNGRAN_choice_Extensions_value._const_tab_at = ('..', 'id')
    __MBS_SessionTNLInfoNGRAN_choice_Extensions_value._const_tab_id = 'Value'
    _MBS_SessionTNLInfoNGRAN_choice_Extensions._cont = ASN1Dict([
        ('id', __MBS_SessionTNLInfoNGRAN_choice_Extensions_id),
        ('criticality', __MBS_SessionTNLInfoNGRAN_choice_Extensions_criticality),
        ('value', __MBS_SessionTNLInfoNGRAN_choice_Extensions_value),
        ])
    _MBS_SessionTNLInfoNGRAN_choice_Extensions._ext = None
    MBS_SessionTNLInfoNGRAN._cont = ASN1Dict([
        ('locationindependent', _MBS_SessionTNLInfoNGRAN_locationindependent),
        ('locationdependent', _MBS_SessionTNLInfoNGRAN_locationdependent),
        ('choice-Extensions', _MBS_SessionTNLInfoNGRAN_choice_Extensions),
        ])
    MBS_SessionTNLInfoNGRAN._ext = None
    
    #-----< MBS-SessionTNLInfoNGRAN-ExtIEs >-----#
    MBS_SessionTNLInfoNGRAN_ExtIEs = CLASS(name='MBS-SessionTNLInfoNGRAN-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    MBS_SessionTNLInfoNGRAN_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-SessionTNLInfoNGRANList >-----#
    MBS_SessionTNLInfoNGRANList = SEQ_OF(name='MBS-SessionTNLInfoNGRANList', mode=MODE_TYPE)
    _MBS_SessionTNLInfoNGRANList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionTNLInfoNGRANItem')))
    MBS_SessionTNLInfoNGRANList._cont = _MBS_SessionTNLInfoNGRANList__item_
    MBS_SessionTNLInfoNGRANList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< MBS-SessionTNLInfoNGRANItem >-----#
    MBS_SessionTNLInfoNGRANItem = SEQ(name='MBS-SessionTNLInfoNGRANItem', mode=MODE_TYPE)
    _MBS_SessionTNLInfoNGRANItem_mBS_AreaSessionID = INT(name='mBS-AreaSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')))
    _MBS_SessionTNLInfoNGRANItem_sharedNGU_UnicastTNLInformation = CHOICE(name='sharedNGU-UnicastTNLInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')), opt=True)
    _MBS_SessionTNLInfoNGRANItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBS_SessionTNLInfoNGRANItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__id._const_tab = ____MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__id_tab
    ___MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__id._const_tab_at = None
    ___MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__criticality._const_tab = ____MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__criticality_tab
    ___MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__extensionValue._const_tab = ____MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__extensionValue_tab
    ___MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBS_SessionTNLInfoNGRANItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__id),
        ('criticality', ___MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__criticality),
        ('extensionValue', ___MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__extensionValue),
        ])
    __MBS_SessionTNLInfoNGRANItem_iE_Extensions__item_._ext = None
    _MBS_SessionTNLInfoNGRANItem_iE_Extensions._cont = __MBS_SessionTNLInfoNGRANItem_iE_Extensions__item_
    _MBS_SessionTNLInfoNGRANItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBS_SessionTNLInfoNGRANItem._cont = ASN1Dict([
        ('mBS-AreaSessionID', _MBS_SessionTNLInfoNGRANItem_mBS_AreaSessionID),
        ('sharedNGU-UnicastTNLInformation', _MBS_SessionTNLInfoNGRANItem_sharedNGU_UnicastTNLInformation),
        ('iE-Extensions', _MBS_SessionTNLInfoNGRANItem_iE_Extensions),
        ])
    MBS_SessionTNLInfoNGRANItem._ext = []
    
    #-----< MBS-SessionTNLInfoNGRANItem-ExtIEs >-----#
    MBS_SessionTNLInfoNGRANItem_ExtIEs = CLASS(name='MBS-SessionTNLInfoNGRANItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MBS_SessionTNLInfoNGRANItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-DistributionReleaseRequestTransfer >-----#
    MBS_DistributionReleaseRequestTransfer = SEQ(name='MBS-DistributionReleaseRequestTransfer', mode=MODE_TYPE)
    _MBS_DistributionReleaseRequestTransfer_mBS_SessionID = SEQ(name='mBS-SessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _MBS_DistributionReleaseRequestTransfer_mBS_AreaSessionID = INT(name='mBS-AreaSessionID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')), opt=True)
    _MBS_DistributionReleaseRequestTransfer_sharedNGU_UnicastTNLInformation = CHOICE(name='sharedNGU-UnicastTNLInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')), opt=True)
    _MBS_DistributionReleaseRequestTransfer_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _MBS_DistributionReleaseRequestTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBS_DistributionReleaseRequestTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__id._const_tab = ____MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__id_tab
    ___MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__id._const_tab_at = None
    ___MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__criticality._const_tab = ____MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__criticality_tab
    ___MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__extensionValue._const_tab = ____MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__extensionValue_tab
    ___MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBS_DistributionReleaseRequestTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__id),
        ('criticality', ___MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__extensionValue),
        ])
    __MBS_DistributionReleaseRequestTransfer_iE_Extensions__item_._ext = None
    _MBS_DistributionReleaseRequestTransfer_iE_Extensions._cont = __MBS_DistributionReleaseRequestTransfer_iE_Extensions__item_
    _MBS_DistributionReleaseRequestTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBS_DistributionReleaseRequestTransfer._cont = ASN1Dict([
        ('mBS-SessionID', _MBS_DistributionReleaseRequestTransfer_mBS_SessionID),
        ('mBS-AreaSessionID', _MBS_DistributionReleaseRequestTransfer_mBS_AreaSessionID),
        ('sharedNGU-UnicastTNLInformation', _MBS_DistributionReleaseRequestTransfer_sharedNGU_UnicastTNLInformation),
        ('cause', _MBS_DistributionReleaseRequestTransfer_cause),
        ('iE-Extensions', _MBS_DistributionReleaseRequestTransfer_iE_Extensions),
        ])
    MBS_DistributionReleaseRequestTransfer._ext = []
    
    #-----< MBS-DistributionReleaseRequesTransfer-ExtIEs >-----#
    MBS_DistributionReleaseRequesTransfer_ExtIEs = CLASS(name='MBS-DistributionReleaseRequesTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MBS_DistributionReleaseRequesTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-DistributionSetupRequestTransfer >-----#
    MBS_DistributionSetupRequestTransfer = SEQ(name='MBS-DistributionSetupRequestTransfer', mode=MODE_TYPE)
    _MBS_DistributionSetupRequestTransfer_mBS_SessionID = SEQ(name='mBS-SessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _MBS_DistributionSetupRequestTransfer_mBS_AreaSessionID = INT(name='mBS-AreaSessionID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')), opt=True)
    _MBS_DistributionSetupRequestTransfer_sharedNGU_UnicastTNLInformation = CHOICE(name='sharedNGU-UnicastTNLInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')), opt=True)
    _MBS_DistributionSetupRequestTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBS_DistributionSetupRequestTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MBS_DistributionSetupRequestTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBS_DistributionSetupRequestTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_DistributionSetupRequestTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_DistributionSetupRequestTransfer_iE_Extensions__item__id._const_tab = ____MBS_DistributionSetupRequestTransfer_iE_Extensions__item__id_tab
    ___MBS_DistributionSetupRequestTransfer_iE_Extensions__item__id._const_tab_at = None
    ___MBS_DistributionSetupRequestTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBS_DistributionSetupRequestTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBS_DistributionSetupRequestTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_DistributionSetupRequestTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_DistributionSetupRequestTransfer_iE_Extensions__item__criticality._const_tab = ____MBS_DistributionSetupRequestTransfer_iE_Extensions__item__criticality_tab
    ___MBS_DistributionSetupRequestTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBS_DistributionSetupRequestTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBS_DistributionSetupRequestTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBS_DistributionSetupRequestTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_DistributionSetupRequestTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_DistributionSetupRequestTransfer_iE_Extensions__item__extensionValue._const_tab = ____MBS_DistributionSetupRequestTransfer_iE_Extensions__item__extensionValue_tab
    ___MBS_DistributionSetupRequestTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBS_DistributionSetupRequestTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBS_DistributionSetupRequestTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBS_DistributionSetupRequestTransfer_iE_Extensions__item__id),
        ('criticality', ___MBS_DistributionSetupRequestTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___MBS_DistributionSetupRequestTransfer_iE_Extensions__item__extensionValue),
        ])
    __MBS_DistributionSetupRequestTransfer_iE_Extensions__item_._ext = None
    _MBS_DistributionSetupRequestTransfer_iE_Extensions._cont = __MBS_DistributionSetupRequestTransfer_iE_Extensions__item_
    _MBS_DistributionSetupRequestTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBS_DistributionSetupRequestTransfer._cont = ASN1Dict([
        ('mBS-SessionID', _MBS_DistributionSetupRequestTransfer_mBS_SessionID),
        ('mBS-AreaSessionID', _MBS_DistributionSetupRequestTransfer_mBS_AreaSessionID),
        ('sharedNGU-UnicastTNLInformation', _MBS_DistributionSetupRequestTransfer_sharedNGU_UnicastTNLInformation),
        ('iE-Extensions', _MBS_DistributionSetupRequestTransfer_iE_Extensions),
        ])
    MBS_DistributionSetupRequestTransfer._ext = []
    
    #-----< MBS-DistributionSetupRequestTransfer-ExtIEs >-----#
    MBS_DistributionSetupRequestTransfer_ExtIEs = CLASS(name='MBS-DistributionSetupRequestTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MBS_DistributionSetupRequestTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-DistributionSetupResponseTransfer >-----#
    MBS_DistributionSetupResponseTransfer = SEQ(name='MBS-DistributionSetupResponseTransfer', mode=MODE_TYPE)
    _MBS_DistributionSetupResponseTransfer_mBS_SessionID = SEQ(name='mBS-SessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _MBS_DistributionSetupResponseTransfer_mBS_AreaSessionID = INT(name='mBS-AreaSessionID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')), opt=True)
    _MBS_DistributionSetupResponseTransfer_sharedNGU_MulticastTNLInformation = SEQ(name='sharedNGU-MulticastTNLInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionTNLInfo5GCItem')), opt=True)
    _MBS_DistributionSetupResponseTransfer_mBS_QoSFlowsToBeSetupList = SEQ_OF(name='mBS-QoSFlowsToBeSetupList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-QoSFlowsToBeSetupList')))
    _MBS_DistributionSetupResponseTransfer_mBSSessionStatus = ENUM(name='mBSSessionStatus', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionStatus')))
    _MBS_DistributionSetupResponseTransfer_mBS_ServiceArea = CHOICE(name='mBS-ServiceArea', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-ServiceArea')), opt=True)
    _MBS_DistributionSetupResponseTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBS_DistributionSetupResponseTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MBS_DistributionSetupResponseTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBS_DistributionSetupResponseTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_DistributionSetupResponseTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_DistributionSetupResponseTransfer_iE_Extensions__item__id._const_tab = ____MBS_DistributionSetupResponseTransfer_iE_Extensions__item__id_tab
    ___MBS_DistributionSetupResponseTransfer_iE_Extensions__item__id._const_tab_at = None
    ___MBS_DistributionSetupResponseTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBS_DistributionSetupResponseTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBS_DistributionSetupResponseTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_DistributionSetupResponseTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_DistributionSetupResponseTransfer_iE_Extensions__item__criticality._const_tab = ____MBS_DistributionSetupResponseTransfer_iE_Extensions__item__criticality_tab
    ___MBS_DistributionSetupResponseTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBS_DistributionSetupResponseTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBS_DistributionSetupResponseTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBS_DistributionSetupResponseTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_DistributionSetupResponseTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_DistributionSetupResponseTransfer_iE_Extensions__item__extensionValue._const_tab = ____MBS_DistributionSetupResponseTransfer_iE_Extensions__item__extensionValue_tab
    ___MBS_DistributionSetupResponseTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBS_DistributionSetupResponseTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBS_DistributionSetupResponseTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBS_DistributionSetupResponseTransfer_iE_Extensions__item__id),
        ('criticality', ___MBS_DistributionSetupResponseTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___MBS_DistributionSetupResponseTransfer_iE_Extensions__item__extensionValue),
        ])
    __MBS_DistributionSetupResponseTransfer_iE_Extensions__item_._ext = None
    _MBS_DistributionSetupResponseTransfer_iE_Extensions._cont = __MBS_DistributionSetupResponseTransfer_iE_Extensions__item_
    _MBS_DistributionSetupResponseTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBS_DistributionSetupResponseTransfer._cont = ASN1Dict([
        ('mBS-SessionID', _MBS_DistributionSetupResponseTransfer_mBS_SessionID),
        ('mBS-AreaSessionID', _MBS_DistributionSetupResponseTransfer_mBS_AreaSessionID),
        ('sharedNGU-MulticastTNLInformation', _MBS_DistributionSetupResponseTransfer_sharedNGU_MulticastTNLInformation),
        ('mBS-QoSFlowsToBeSetupList', _MBS_DistributionSetupResponseTransfer_mBS_QoSFlowsToBeSetupList),
        ('mBSSessionStatus', _MBS_DistributionSetupResponseTransfer_mBSSessionStatus),
        ('mBS-ServiceArea', _MBS_DistributionSetupResponseTransfer_mBS_ServiceArea),
        ('iE-Extensions', _MBS_DistributionSetupResponseTransfer_iE_Extensions),
        ])
    MBS_DistributionSetupResponseTransfer._ext = []
    
    #-----< MBS-DistributionSetupResponseTransfer-ExtIEs >-----#
    MBS_DistributionSetupResponseTransfer_ExtIEs = CLASS(name='MBS-DistributionSetupResponseTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MBS_DistributionSetupResponseTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-DistributionSetupUnsuccessfulTransfer >-----#
    MBS_DistributionSetupUnsuccessfulTransfer = SEQ(name='MBS-DistributionSetupUnsuccessfulTransfer', mode=MODE_TYPE)
    _MBS_DistributionSetupUnsuccessfulTransfer_mBS_SessionID = SEQ(name='mBS-SessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _MBS_DistributionSetupUnsuccessfulTransfer_mBS_AreaSessionID = INT(name='mBS-AreaSessionID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')), opt=True)
    _MBS_DistributionSetupUnsuccessfulTransfer_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _MBS_DistributionSetupUnsuccessfulTransfer_criticalityDiagnostics = SEQ(name='criticalityDiagnostics', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')), opt=True)
    _MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__id._const_tab = ____MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__id_tab
    ___MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__id._const_tab_at = None
    ___MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab = ____MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__criticality_tab
    ___MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab = ____MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab
    ___MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__id),
        ('criticality', ___MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue),
        ])
    __MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item_._ext = None
    _MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions._cont = __MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item_
    _MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBS_DistributionSetupUnsuccessfulTransfer._cont = ASN1Dict([
        ('mBS-SessionID', _MBS_DistributionSetupUnsuccessfulTransfer_mBS_SessionID),
        ('mBS-AreaSessionID', _MBS_DistributionSetupUnsuccessfulTransfer_mBS_AreaSessionID),
        ('cause', _MBS_DistributionSetupUnsuccessfulTransfer_cause),
        ('criticalityDiagnostics', _MBS_DistributionSetupUnsuccessfulTransfer_criticalityDiagnostics),
        ('iE-Extensions', _MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions),
        ])
    MBS_DistributionSetupUnsuccessfulTransfer._ext = []
    
    #-----< MBS-DistributionSetupUnsuccessfulTransfer-ExtIEs >-----#
    MBS_DistributionSetupUnsuccessfulTransfer_ExtIEs = CLASS(name='MBS-DistributionSetupUnsuccessfulTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MBS_DistributionSetupUnsuccessfulTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBSSessionSetupRequestList >-----#
    MBSSessionSetupRequestList = SEQ_OF(name='MBSSessionSetupRequestList', mode=MODE_TYPE)
    _MBSSessionSetupRequestList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionSetupRequestItem')))
    MBSSessionSetupRequestList._cont = _MBSSessionSetupRequestList__item_
    MBSSessionSetupRequestList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MBSSessionSetupRequestItem >-----#
    MBSSessionSetupRequestItem = SEQ(name='MBSSessionSetupRequestItem', mode=MODE_TYPE)
    _MBSSessionSetupRequestItem_mBS_SessionID = SEQ(name='mBS-SessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _MBSSessionSetupRequestItem_mBS_AreaSessionID = INT(name='mBS-AreaSessionID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')), opt=True)
    _MBSSessionSetupRequestItem_associatedMBSQosFlowSetupRequestList = SEQ_OF(name='associatedMBSQosFlowSetupRequestList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AssociatedMBSQosFlowSetupRequestList')), opt=True)
    _MBSSessionSetupRequestItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBSSessionSetupRequestItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MBSSessionSetupRequestItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBSSessionSetupRequestItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBSSessionSetupRequestItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionSetupRequestItem_iE_Extensions__item__id._const_tab = ____MBSSessionSetupRequestItem_iE_Extensions__item__id_tab
    ___MBSSessionSetupRequestItem_iE_Extensions__item__id._const_tab_at = None
    ___MBSSessionSetupRequestItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBSSessionSetupRequestItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBSSessionSetupRequestItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBSSessionSetupRequestItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionSetupRequestItem_iE_Extensions__item__criticality._const_tab = ____MBSSessionSetupRequestItem_iE_Extensions__item__criticality_tab
    ___MBSSessionSetupRequestItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBSSessionSetupRequestItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBSSessionSetupRequestItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBSSessionSetupRequestItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBSSessionSetupRequestItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionSetupRequestItem_iE_Extensions__item__extensionValue._const_tab = ____MBSSessionSetupRequestItem_iE_Extensions__item__extensionValue_tab
    ___MBSSessionSetupRequestItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBSSessionSetupRequestItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBSSessionSetupRequestItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBSSessionSetupRequestItem_iE_Extensions__item__id),
        ('criticality', ___MBSSessionSetupRequestItem_iE_Extensions__item__criticality),
        ('extensionValue', ___MBSSessionSetupRequestItem_iE_Extensions__item__extensionValue),
        ])
    __MBSSessionSetupRequestItem_iE_Extensions__item_._ext = None
    _MBSSessionSetupRequestItem_iE_Extensions._cont = __MBSSessionSetupRequestItem_iE_Extensions__item_
    _MBSSessionSetupRequestItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBSSessionSetupRequestItem._cont = ASN1Dict([
        ('mBS-SessionID', _MBSSessionSetupRequestItem_mBS_SessionID),
        ('mBS-AreaSessionID', _MBSSessionSetupRequestItem_mBS_AreaSessionID),
        ('associatedMBSQosFlowSetupRequestList', _MBSSessionSetupRequestItem_associatedMBSQosFlowSetupRequestList),
        ('iE-Extensions', _MBSSessionSetupRequestItem_iE_Extensions),
        ])
    MBSSessionSetupRequestItem._ext = []
    
    #-----< MBSSessionSetupRequestItem-ExtIEs >-----#
    MBSSessionSetupRequestItem_ExtIEs = CLASS(name='MBSSessionSetupRequestItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MBSSessionSetupRequestItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBSSessionSetuporModifyRequestList >-----#
    MBSSessionSetuporModifyRequestList = SEQ_OF(name='MBSSessionSetuporModifyRequestList', mode=MODE_TYPE)
    _MBSSessionSetuporModifyRequestList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionSetuporModifyRequestItem')))
    MBSSessionSetuporModifyRequestList._cont = _MBSSessionSetuporModifyRequestList__item_
    MBSSessionSetuporModifyRequestList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MBSSessionSetuporModifyRequestItem >-----#
    MBSSessionSetuporModifyRequestItem = SEQ(name='MBSSessionSetuporModifyRequestItem', mode=MODE_TYPE)
    _MBSSessionSetuporModifyRequestItem_mBS_SessionID = SEQ(name='mBS-SessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _MBSSessionSetuporModifyRequestItem_mBS_AreaSessionID = INT(name='mBS-AreaSessionID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')), opt=True)
    _MBSSessionSetuporModifyRequestItem_associatedMBSQosFlowSetuporModifyRequestList = SEQ_OF(name='associatedMBSQosFlowSetuporModifyRequestList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AssociatedMBSQosFlowSetuporModifyRequestList')), opt=True)
    _MBSSessionSetuporModifyRequestItem_mBS_QosFlowToReleaseList = SEQ_OF(name='mBS-QosFlowToReleaseList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithCause')), opt=True)
    _MBSSessionSetuporModifyRequestItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBSSessionSetuporModifyRequestItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MBSSessionSetuporModifyRequestItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBSSessionSetuporModifyRequestItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBSSessionSetuporModifyRequestItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionSetuporModifyRequestItem_iE_Extensions__item__id._const_tab = ____MBSSessionSetuporModifyRequestItem_iE_Extensions__item__id_tab
    ___MBSSessionSetuporModifyRequestItem_iE_Extensions__item__id._const_tab_at = None
    ___MBSSessionSetuporModifyRequestItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBSSessionSetuporModifyRequestItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBSSessionSetuporModifyRequestItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBSSessionSetuporModifyRequestItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionSetuporModifyRequestItem_iE_Extensions__item__criticality._const_tab = ____MBSSessionSetuporModifyRequestItem_iE_Extensions__item__criticality_tab
    ___MBSSessionSetuporModifyRequestItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBSSessionSetuporModifyRequestItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBSSessionSetuporModifyRequestItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBSSessionSetuporModifyRequestItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBSSessionSetuporModifyRequestItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionSetuporModifyRequestItem_iE_Extensions__item__extensionValue._const_tab = ____MBSSessionSetuporModifyRequestItem_iE_Extensions__item__extensionValue_tab
    ___MBSSessionSetuporModifyRequestItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBSSessionSetuporModifyRequestItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBSSessionSetuporModifyRequestItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBSSessionSetuporModifyRequestItem_iE_Extensions__item__id),
        ('criticality', ___MBSSessionSetuporModifyRequestItem_iE_Extensions__item__criticality),
        ('extensionValue', ___MBSSessionSetuporModifyRequestItem_iE_Extensions__item__extensionValue),
        ])
    __MBSSessionSetuporModifyRequestItem_iE_Extensions__item_._ext = None
    _MBSSessionSetuporModifyRequestItem_iE_Extensions._cont = __MBSSessionSetuporModifyRequestItem_iE_Extensions__item_
    _MBSSessionSetuporModifyRequestItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBSSessionSetuporModifyRequestItem._cont = ASN1Dict([
        ('mBS-SessionID', _MBSSessionSetuporModifyRequestItem_mBS_SessionID),
        ('mBS-AreaSessionID', _MBSSessionSetuporModifyRequestItem_mBS_AreaSessionID),
        ('associatedMBSQosFlowSetuporModifyRequestList', _MBSSessionSetuporModifyRequestItem_associatedMBSQosFlowSetuporModifyRequestList),
        ('mBS-QosFlowToReleaseList', _MBSSessionSetuporModifyRequestItem_mBS_QosFlowToReleaseList),
        ('iE-Extensions', _MBSSessionSetuporModifyRequestItem_iE_Extensions),
        ])
    MBSSessionSetuporModifyRequestItem._ext = []
    
    #-----< MBSSessionSetuporModifyRequestItem-ExtIEs >-----#
    MBSSessionSetuporModifyRequestItem_ExtIEs = CLASS(name='MBSSessionSetuporModifyRequestItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MBSSessionSetuporModifyRequestItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBSSessionToReleaseList >-----#
    MBSSessionToReleaseList = SEQ_OF(name='MBSSessionToReleaseList', mode=MODE_TYPE)
    _MBSSessionToReleaseList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionToReleaseItem')))
    MBSSessionToReleaseList._cont = _MBSSessionToReleaseList__item_
    MBSSessionToReleaseList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MBSSessionToReleaseItem >-----#
    MBSSessionToReleaseItem = SEQ(name='MBSSessionToReleaseItem', mode=MODE_TYPE)
    _MBSSessionToReleaseItem_mBS_SessionID = SEQ(name='mBS-SessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _MBSSessionToReleaseItem_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _MBSSessionToReleaseItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBSSessionToReleaseItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MBSSessionToReleaseItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBSSessionToReleaseItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBSSessionToReleaseItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionToReleaseItem_iE_Extensions__item__id._const_tab = ____MBSSessionToReleaseItem_iE_Extensions__item__id_tab
    ___MBSSessionToReleaseItem_iE_Extensions__item__id._const_tab_at = None
    ___MBSSessionToReleaseItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBSSessionToReleaseItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBSSessionToReleaseItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBSSessionToReleaseItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionToReleaseItem_iE_Extensions__item__criticality._const_tab = ____MBSSessionToReleaseItem_iE_Extensions__item__criticality_tab
    ___MBSSessionToReleaseItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBSSessionToReleaseItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBSSessionToReleaseItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBSSessionToReleaseItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MBSSessionToReleaseItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSSessionToReleaseItem_iE_Extensions__item__extensionValue._const_tab = ____MBSSessionToReleaseItem_iE_Extensions__item__extensionValue_tab
    ___MBSSessionToReleaseItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBSSessionToReleaseItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBSSessionToReleaseItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBSSessionToReleaseItem_iE_Extensions__item__id),
        ('criticality', ___MBSSessionToReleaseItem_iE_Extensions__item__criticality),
        ('extensionValue', ___MBSSessionToReleaseItem_iE_Extensions__item__extensionValue),
        ])
    __MBSSessionToReleaseItem_iE_Extensions__item_._ext = None
    _MBSSessionToReleaseItem_iE_Extensions._cont = __MBSSessionToReleaseItem_iE_Extensions__item_
    _MBSSessionToReleaseItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBSSessionToReleaseItem._cont = ASN1Dict([
        ('mBS-SessionID', _MBSSessionToReleaseItem_mBS_SessionID),
        ('cause', _MBSSessionToReleaseItem_cause),
        ('iE-Extensions', _MBSSessionToReleaseItem_iE_Extensions),
        ])
    MBSSessionToReleaseItem._ext = []
    
    #-----< MBSSessionToReleaseItem-ExtIEs >-----#
    MBSSessionToReleaseItem_ExtIEs = CLASS(name='MBSSessionToReleaseItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MBSSessionToReleaseItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBSSessionStatus >-----#
    MBSSessionStatus = ENUM(name='MBSSessionStatus', mode=MODE_TYPE)
    MBSSessionStatus._cont = ASN1Dict([('activated', 0), ('deactivated', 1)])
    MBSSessionStatus._ext = []
    
    #-----< MicoAllPLMN >-----#
    MicoAllPLMN = ENUM(name='MicoAllPLMN', mode=MODE_TYPE)
    MicoAllPLMN._cont = ASN1Dict([('true', 0)])
    MicoAllPLMN._ext = []
    
    #-----< MICOModeIndication >-----#
    MICOModeIndication = ENUM(name='MICOModeIndication', mode=MODE_TYPE)
    MICOModeIndication._cont = ASN1Dict([('true', 0)])
    MICOModeIndication._ext = []
    
    #-----< MobilityInformation >-----#
    MobilityInformation = BIT_STR(name='MobilityInformation', mode=MODE_TYPE)
    MobilityInformation._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< MobilityRestrictionList >-----#
    MobilityRestrictionList = SEQ(name='MobilityRestrictionList', mode=MODE_TYPE)
    _MobilityRestrictionList_servingPLMN = OCT_STR(name='servingPLMN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _MobilityRestrictionList_equivalentPLMNs = SEQ_OF(name='equivalentPLMNs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EquivalentPLMNs')), opt=True)
    _MobilityRestrictionList_rATRestrictions = SEQ_OF(name='rATRestrictions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RATRestrictions')), opt=True)
    _MobilityRestrictionList_forbiddenAreaInformation = SEQ_OF(name='forbiddenAreaInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ForbiddenAreaInformation')), opt=True)
    _MobilityRestrictionList_serviceAreaInformation = SEQ_OF(name='serviceAreaInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ServiceAreaInformation')), opt=True)
    _MobilityRestrictionList_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MobilityRestrictionList_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MobilityRestrictionList_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MobilityRestrictionList_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____MobilityRestrictionList_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _____MobilityRestrictionList_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CNTypeRestrictionsForServing')))
    _____MobilityRestrictionList_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CNTypeRestrictionsForEquivalent')))
    _____MobilityRestrictionList_iE_Extensions__item__id_tab_val_Extension_3 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NPN-MobilityInformation')))
    ____MobilityRestrictionList_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 150), ('criticality', 'ignore'), ('Extension', _____MobilityRestrictionList_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 161), ('criticality', 'ignore'), ('Extension', _____MobilityRestrictionList_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 160), ('criticality', 'ignore'), ('Extension', _____MobilityRestrictionList_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 261), ('criticality', 'reject'), ('Extension', _____MobilityRestrictionList_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MobilityRestrictionList_iE_Extensions__item__id._const_tab = ____MobilityRestrictionList_iE_Extensions__item__id_tab
    ___MobilityRestrictionList_iE_Extensions__item__id._const_tab_at = None
    ___MobilityRestrictionList_iE_Extensions__item__id._const_tab_id = 'id'
    ___MobilityRestrictionList_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___MobilityRestrictionList_iE_Extensions__item__criticality._const_tab = ____MobilityRestrictionList_iE_Extensions__item__id_tab
    ___MobilityRestrictionList_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MobilityRestrictionList_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MobilityRestrictionList_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___MobilityRestrictionList_iE_Extensions__item__extensionValue._const_tab = ____MobilityRestrictionList_iE_Extensions__item__id_tab
    ___MobilityRestrictionList_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MobilityRestrictionList_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MobilityRestrictionList_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MobilityRestrictionList_iE_Extensions__item__id),
        ('criticality', ___MobilityRestrictionList_iE_Extensions__item__criticality),
        ('extensionValue', ___MobilityRestrictionList_iE_Extensions__item__extensionValue),
        ])
    __MobilityRestrictionList_iE_Extensions__item_._ext = None
    _MobilityRestrictionList_iE_Extensions._cont = __MobilityRestrictionList_iE_Extensions__item_
    _MobilityRestrictionList_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MobilityRestrictionList._cont = ASN1Dict([
        ('servingPLMN', _MobilityRestrictionList_servingPLMN),
        ('equivalentPLMNs', _MobilityRestrictionList_equivalentPLMNs),
        ('rATRestrictions', _MobilityRestrictionList_rATRestrictions),
        ('forbiddenAreaInformation', _MobilityRestrictionList_forbiddenAreaInformation),
        ('serviceAreaInformation', _MobilityRestrictionList_serviceAreaInformation),
        ('iE-Extensions', _MobilityRestrictionList_iE_Extensions),
        ])
    MobilityRestrictionList._ext = []
    
    #-----< MobilityRestrictionList-ExtIEs >-----#
    MobilityRestrictionList_ExtIEs = CLASS(name='MobilityRestrictionList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _MobilityRestrictionList_ExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _MobilityRestrictionList_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CNTypeRestrictionsForServing')))
    _MobilityRestrictionList_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CNTypeRestrictionsForEquivalent')))
    _MobilityRestrictionList_ExtIEs_val_Extension_3 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NPN-MobilityInformation')))
    MobilityRestrictionList_ExtIEs._val = ASN1Set(rv=[dict([('id', 150), ('criticality', 'ignore'), ('Extension', _MobilityRestrictionList_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 161), ('criticality', 'ignore'), ('Extension', _MobilityRestrictionList_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 160), ('criticality', 'ignore'), ('Extension', _MobilityRestrictionList_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 261), ('criticality', 'reject'), ('Extension', _MobilityRestrictionList_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MDT-AlignmentInfo >-----#
    MDT_AlignmentInfo = CHOICE(name='MDT-AlignmentInfo', mode=MODE_TYPE)
    _MDT_AlignmentInfo_s_basedMDT = OCT_STR(name='s-basedMDT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRANTraceID')))
    _MDT_AlignmentInfo_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __MDT_AlignmentInfo_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___MDT_AlignmentInfo_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MDT_AlignmentInfo_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MDT_AlignmentInfo_choice_Extensions_id._const_tab = ___MDT_AlignmentInfo_choice_Extensions_id_tab
    __MDT_AlignmentInfo_choice_Extensions_id._const_tab_at = None
    __MDT_AlignmentInfo_choice_Extensions_id._const_tab_id = 'id'
    __MDT_AlignmentInfo_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___MDT_AlignmentInfo_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MDT_AlignmentInfo_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MDT_AlignmentInfo_choice_Extensions_criticality._const_tab = ___MDT_AlignmentInfo_choice_Extensions_criticality_tab
    __MDT_AlignmentInfo_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __MDT_AlignmentInfo_choice_Extensions_criticality._const_tab_id = 'criticality'
    __MDT_AlignmentInfo_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___MDT_AlignmentInfo_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MDT_AlignmentInfo_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MDT_AlignmentInfo_choice_Extensions_value._const_tab = ___MDT_AlignmentInfo_choice_Extensions_value_tab
    __MDT_AlignmentInfo_choice_Extensions_value._const_tab_at = ('..', 'id')
    __MDT_AlignmentInfo_choice_Extensions_value._const_tab_id = 'Value'
    _MDT_AlignmentInfo_choice_Extensions._cont = ASN1Dict([
        ('id', __MDT_AlignmentInfo_choice_Extensions_id),
        ('criticality', __MDT_AlignmentInfo_choice_Extensions_criticality),
        ('value', __MDT_AlignmentInfo_choice_Extensions_value),
        ])
    _MDT_AlignmentInfo_choice_Extensions._ext = None
    MDT_AlignmentInfo._cont = ASN1Dict([
        ('s-basedMDT', _MDT_AlignmentInfo_s_basedMDT),
        ('choice-Extensions', _MDT_AlignmentInfo_choice_Extensions),
        ])
    MDT_AlignmentInfo._ext = None
    
    #-----< MDT-AlignmentInfo-ExtIEs >-----#
    MDT_AlignmentInfo_ExtIEs = CLASS(name='MDT-AlignmentInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    MDT_AlignmentInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MDTPLMNList >-----#
    MDTPLMNList = SEQ_OF(name='MDTPLMNList', mode=MODE_TYPE)
    _MDTPLMNList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    MDTPLMNList._cont = _MDTPLMNList__item_
    MDTPLMNList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< MDTPLMNModificationList >-----#
    MDTPLMNModificationList = SEQ_OF(name='MDTPLMNModificationList', mode=MODE_TYPE)
    _MDTPLMNModificationList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    MDTPLMNModificationList._cont = _MDTPLMNModificationList__item_
    MDTPLMNModificationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< MDT-Configuration >-----#
    MDT_Configuration = SEQ(name='MDT-Configuration', mode=MODE_TYPE)
    _MDT_Configuration_mdt_Config_NR = SEQ(name='mdt-Config-NR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MDT-Configuration-NR')), opt=True)
    _MDT_Configuration_mdt_Config_EUTRA = SEQ(name='mdt-Config-EUTRA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MDT-Configuration-EUTRA')), opt=True)
    _MDT_Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MDT_Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MDT_Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MDT_Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MDT_Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Configuration_iE_Extensions__item__id._const_tab = ____MDT_Configuration_iE_Extensions__item__id_tab
    ___MDT_Configuration_iE_Extensions__item__id._const_tab_at = None
    ___MDT_Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___MDT_Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MDT_Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MDT_Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab = ____MDT_Configuration_iE_Extensions__item__criticality_tab
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MDT_Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MDT_Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MDT_Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab = ____MDT_Configuration_iE_Extensions__item__extensionValue_tab
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MDT_Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MDT_Configuration_iE_Extensions__item__id),
        ('criticality', ___MDT_Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___MDT_Configuration_iE_Extensions__item__extensionValue),
        ])
    __MDT_Configuration_iE_Extensions__item_._ext = None
    _MDT_Configuration_iE_Extensions._cont = __MDT_Configuration_iE_Extensions__item_
    _MDT_Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MDT_Configuration._cont = ASN1Dict([
        ('mdt-Config-NR', _MDT_Configuration_mdt_Config_NR),
        ('mdt-Config-EUTRA', _MDT_Configuration_mdt_Config_EUTRA),
        ('iE-Extensions', _MDT_Configuration_iE_Extensions),
        ])
    MDT_Configuration._ext = []
    
    #-----< MDT-Configuration-ExtIEs >-----#
    MDT_Configuration_ExtIEs = CLASS(name='MDT-Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MDT_Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MDT-Configuration-NR >-----#
    MDT_Configuration_NR = SEQ(name='MDT-Configuration-NR', mode=MODE_TYPE)
    _MDT_Configuration_NR_mdt_Activation = ENUM(name='mdt-Activation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MDT-Activation')))
    _MDT_Configuration_NR_areaScopeOfMDT = CHOICE(name='areaScopeOfMDT', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AreaScopeOfMDT-NR')))
    _MDT_Configuration_NR_mDTModeNr = CHOICE(name='mDTModeNr', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MDTModeNr')))
    _MDT_Configuration_NR_signallingBasedMDTPLMNList = SEQ_OF(name='signallingBasedMDTPLMNList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MDTPLMNList')), opt=True)
    _MDT_Configuration_NR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MDT_Configuration_NR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MDT_Configuration_NR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MDT_Configuration_NR_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MDT_Configuration_NR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Configuration_NR_iE_Extensions__item__id._const_tab = ____MDT_Configuration_NR_iE_Extensions__item__id_tab
    ___MDT_Configuration_NR_iE_Extensions__item__id._const_tab_at = None
    ___MDT_Configuration_NR_iE_Extensions__item__id._const_tab_id = 'id'
    ___MDT_Configuration_NR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MDT_Configuration_NR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MDT_Configuration_NR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Configuration_NR_iE_Extensions__item__criticality._const_tab = ____MDT_Configuration_NR_iE_Extensions__item__criticality_tab
    ___MDT_Configuration_NR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MDT_Configuration_NR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MDT_Configuration_NR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MDT_Configuration_NR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MDT_Configuration_NR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Configuration_NR_iE_Extensions__item__extensionValue._const_tab = ____MDT_Configuration_NR_iE_Extensions__item__extensionValue_tab
    ___MDT_Configuration_NR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MDT_Configuration_NR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MDT_Configuration_NR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MDT_Configuration_NR_iE_Extensions__item__id),
        ('criticality', ___MDT_Configuration_NR_iE_Extensions__item__criticality),
        ('extensionValue', ___MDT_Configuration_NR_iE_Extensions__item__extensionValue),
        ])
    __MDT_Configuration_NR_iE_Extensions__item_._ext = None
    _MDT_Configuration_NR_iE_Extensions._cont = __MDT_Configuration_NR_iE_Extensions__item_
    _MDT_Configuration_NR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MDT_Configuration_NR._cont = ASN1Dict([
        ('mdt-Activation', _MDT_Configuration_NR_mdt_Activation),
        ('areaScopeOfMDT', _MDT_Configuration_NR_areaScopeOfMDT),
        ('mDTModeNr', _MDT_Configuration_NR_mDTModeNr),
        ('signallingBasedMDTPLMNList', _MDT_Configuration_NR_signallingBasedMDTPLMNList),
        ('iE-Extensions', _MDT_Configuration_NR_iE_Extensions),
        ])
    MDT_Configuration_NR._ext = []
    
    #-----< MDT-Configuration-NR-ExtIEs >-----#
    MDT_Configuration_NR_ExtIEs = CLASS(name='MDT-Configuration-NR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MDT_Configuration_NR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MDT-Configuration-EUTRA >-----#
    MDT_Configuration_EUTRA = SEQ(name='MDT-Configuration-EUTRA', mode=MODE_TYPE)
    _MDT_Configuration_EUTRA_mdt_Activation = ENUM(name='mdt-Activation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MDT-Activation')))
    _MDT_Configuration_EUTRA_areaScopeOfMDT = CHOICE(name='areaScopeOfMDT', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AreaScopeOfMDT-EUTRA')))
    _MDT_Configuration_EUTRA_mDTMode = OCT_STR(name='mDTMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MDTModeEutra')))
    _MDT_Configuration_EUTRA_signallingBasedMDTPLMNList = SEQ_OF(name='signallingBasedMDTPLMNList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MDTPLMNList')), opt=True)
    _MDT_Configuration_EUTRA_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MDT_Configuration_EUTRA_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MDT_Configuration_EUTRA_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MDT_Configuration_EUTRA_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MDT_Configuration_EUTRA_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Configuration_EUTRA_iE_Extensions__item__id._const_tab = ____MDT_Configuration_EUTRA_iE_Extensions__item__id_tab
    ___MDT_Configuration_EUTRA_iE_Extensions__item__id._const_tab_at = None
    ___MDT_Configuration_EUTRA_iE_Extensions__item__id._const_tab_id = 'id'
    ___MDT_Configuration_EUTRA_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MDT_Configuration_EUTRA_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MDT_Configuration_EUTRA_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Configuration_EUTRA_iE_Extensions__item__criticality._const_tab = ____MDT_Configuration_EUTRA_iE_Extensions__item__criticality_tab
    ___MDT_Configuration_EUTRA_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MDT_Configuration_EUTRA_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MDT_Configuration_EUTRA_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MDT_Configuration_EUTRA_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MDT_Configuration_EUTRA_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Configuration_EUTRA_iE_Extensions__item__extensionValue._const_tab = ____MDT_Configuration_EUTRA_iE_Extensions__item__extensionValue_tab
    ___MDT_Configuration_EUTRA_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MDT_Configuration_EUTRA_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MDT_Configuration_EUTRA_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MDT_Configuration_EUTRA_iE_Extensions__item__id),
        ('criticality', ___MDT_Configuration_EUTRA_iE_Extensions__item__criticality),
        ('extensionValue', ___MDT_Configuration_EUTRA_iE_Extensions__item__extensionValue),
        ])
    __MDT_Configuration_EUTRA_iE_Extensions__item_._ext = None
    _MDT_Configuration_EUTRA_iE_Extensions._cont = __MDT_Configuration_EUTRA_iE_Extensions__item_
    _MDT_Configuration_EUTRA_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MDT_Configuration_EUTRA._cont = ASN1Dict([
        ('mdt-Activation', _MDT_Configuration_EUTRA_mdt_Activation),
        ('areaScopeOfMDT', _MDT_Configuration_EUTRA_areaScopeOfMDT),
        ('mDTMode', _MDT_Configuration_EUTRA_mDTMode),
        ('signallingBasedMDTPLMNList', _MDT_Configuration_EUTRA_signallingBasedMDTPLMNList),
        ('iE-Extensions', _MDT_Configuration_EUTRA_iE_Extensions),
        ])
    MDT_Configuration_EUTRA._ext = []
    
    #-----< MDT-Configuration-EUTRA-ExtIEs >-----#
    MDT_Configuration_EUTRA_ExtIEs = CLASS(name='MDT-Configuration-EUTRA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MDT_Configuration_EUTRA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MDT-Activation >-----#
    MDT_Activation = ENUM(name='MDT-Activation', mode=MODE_TYPE)
    MDT_Activation._cont = ASN1Dict([('immediate-MDT-only', 0), ('logged-MDT-only', 1), ('immediate-MDT-and-Trace', 2)])
    MDT_Activation._ext = []
    
    #-----< MDTModeNr >-----#
    MDTModeNr = CHOICE(name='MDTModeNr', mode=MODE_TYPE)
    _MDTModeNr_immediateMDTNr = SEQ(name='immediateMDTNr', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ImmediateMDTNr')))
    _MDTModeNr_loggedMDTNr = SEQ(name='loggedMDTNr', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LoggedMDTNr')))
    _MDTModeNr_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __MDTModeNr_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___MDTModeNr_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MDTModeNr_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MDTModeNr_choice_Extensions_id._const_tab = ___MDTModeNr_choice_Extensions_id_tab
    __MDTModeNr_choice_Extensions_id._const_tab_at = None
    __MDTModeNr_choice_Extensions_id._const_tab_id = 'id'
    __MDTModeNr_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___MDTModeNr_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MDTModeNr_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MDTModeNr_choice_Extensions_criticality._const_tab = ___MDTModeNr_choice_Extensions_criticality_tab
    __MDTModeNr_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __MDTModeNr_choice_Extensions_criticality._const_tab_id = 'criticality'
    __MDTModeNr_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___MDTModeNr_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___MDTModeNr_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MDTModeNr_choice_Extensions_value._const_tab = ___MDTModeNr_choice_Extensions_value_tab
    __MDTModeNr_choice_Extensions_value._const_tab_at = ('..', 'id')
    __MDTModeNr_choice_Extensions_value._const_tab_id = 'Value'
    _MDTModeNr_choice_Extensions._cont = ASN1Dict([
        ('id', __MDTModeNr_choice_Extensions_id),
        ('criticality', __MDTModeNr_choice_Extensions_criticality),
        ('value', __MDTModeNr_choice_Extensions_value),
        ])
    _MDTModeNr_choice_Extensions._ext = None
    MDTModeNr._cont = ASN1Dict([
        ('immediateMDTNr', _MDTModeNr_immediateMDTNr),
        ('loggedMDTNr', _MDTModeNr_loggedMDTNr),
        ('choice-Extensions', _MDTModeNr_choice_Extensions),
        ])
    MDTModeNr._ext = None
    
    #-----< MDTModeNr-ExtIEs >-----#
    MDTModeNr_ExtIEs = CLASS(name='MDTModeNr-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    MDTModeNr_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MDTModeEutra >-----#
    MDTModeEutra = OCT_STR(name='MDTModeEutra', mode=MODE_TYPE)
    
    #-----< MeasurementsToActivate >-----#
    MeasurementsToActivate = BIT_STR(name='MeasurementsToActivate', mode=MODE_TYPE)
    MeasurementsToActivate._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< MRB-ID >-----#
    MRB_ID = INT(name='MRB-ID', mode=MODE_TYPE)
    MRB_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=[], er=[])
    
    #-----< MulticastSessionActivationRequestTransfer >-----#
    MulticastSessionActivationRequestTransfer = SEQ(name='MulticastSessionActivationRequestTransfer', mode=MODE_TYPE)
    _MulticastSessionActivationRequestTransfer_mBS_SessionID = SEQ(name='mBS-SessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _MulticastSessionActivationRequestTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MulticastSessionActivationRequestTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MulticastSessionActivationRequestTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MulticastSessionActivationRequestTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MulticastSessionActivationRequestTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastSessionActivationRequestTransfer_iE_Extensions__item__id._const_tab = ____MulticastSessionActivationRequestTransfer_iE_Extensions__item__id_tab
    ___MulticastSessionActivationRequestTransfer_iE_Extensions__item__id._const_tab_at = None
    ___MulticastSessionActivationRequestTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___MulticastSessionActivationRequestTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MulticastSessionActivationRequestTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MulticastSessionActivationRequestTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastSessionActivationRequestTransfer_iE_Extensions__item__criticality._const_tab = ____MulticastSessionActivationRequestTransfer_iE_Extensions__item__criticality_tab
    ___MulticastSessionActivationRequestTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastSessionActivationRequestTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MulticastSessionActivationRequestTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MulticastSessionActivationRequestTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MulticastSessionActivationRequestTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastSessionActivationRequestTransfer_iE_Extensions__item__extensionValue._const_tab = ____MulticastSessionActivationRequestTransfer_iE_Extensions__item__extensionValue_tab
    ___MulticastSessionActivationRequestTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MulticastSessionActivationRequestTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MulticastSessionActivationRequestTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MulticastSessionActivationRequestTransfer_iE_Extensions__item__id),
        ('criticality', ___MulticastSessionActivationRequestTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___MulticastSessionActivationRequestTransfer_iE_Extensions__item__extensionValue),
        ])
    __MulticastSessionActivationRequestTransfer_iE_Extensions__item_._ext = None
    _MulticastSessionActivationRequestTransfer_iE_Extensions._cont = __MulticastSessionActivationRequestTransfer_iE_Extensions__item_
    _MulticastSessionActivationRequestTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MulticastSessionActivationRequestTransfer._cont = ASN1Dict([
        ('mBS-SessionID', _MulticastSessionActivationRequestTransfer_mBS_SessionID),
        ('iE-Extensions', _MulticastSessionActivationRequestTransfer_iE_Extensions),
        ])
    MulticastSessionActivationRequestTransfer._ext = []
    
    #-----< MulticastSessionActivationRequestTransfer-ExtIEs >-----#
    MulticastSessionActivationRequestTransfer_ExtIEs = CLASS(name='MulticastSessionActivationRequestTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MulticastSessionActivationRequestTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MulticastSessionDeactivationRequestTransfer >-----#
    MulticastSessionDeactivationRequestTransfer = SEQ(name='MulticastSessionDeactivationRequestTransfer', mode=MODE_TYPE)
    _MulticastSessionDeactivationRequestTransfer_mBS_SessionID = SEQ(name='mBS-SessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _MulticastSessionDeactivationRequestTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MulticastSessionDeactivationRequestTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__id._const_tab = ____MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__id_tab
    ___MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__id._const_tab_at = None
    ___MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__criticality._const_tab = ____MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__criticality_tab
    ___MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__extensionValue._const_tab = ____MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__extensionValue_tab
    ___MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MulticastSessionDeactivationRequestTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__id),
        ('criticality', ___MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__extensionValue),
        ])
    __MulticastSessionDeactivationRequestTransfer_iE_Extensions__item_._ext = None
    _MulticastSessionDeactivationRequestTransfer_iE_Extensions._cont = __MulticastSessionDeactivationRequestTransfer_iE_Extensions__item_
    _MulticastSessionDeactivationRequestTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MulticastSessionDeactivationRequestTransfer._cont = ASN1Dict([
        ('mBS-SessionID', _MulticastSessionDeactivationRequestTransfer_mBS_SessionID),
        ('iE-Extensions', _MulticastSessionDeactivationRequestTransfer_iE_Extensions),
        ])
    MulticastSessionDeactivationRequestTransfer._ext = []
    
    #-----< MulticastSessionDeactivationRequestTransfer-ExtIEs >-----#
    MulticastSessionDeactivationRequestTransfer_ExtIEs = CLASS(name='MulticastSessionDeactivationRequestTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MulticastSessionDeactivationRequestTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MulticastSessionUpdateRequestTransfer >-----#
    MulticastSessionUpdateRequestTransfer = SEQ(name='MulticastSessionUpdateRequestTransfer', mode=MODE_TYPE)
    _MulticastSessionUpdateRequestTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __MulticastSessionUpdateRequestTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___MulticastSessionUpdateRequestTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____MulticastSessionUpdateRequestTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____MulticastSessionUpdateRequestTransfer_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _____MulticastSessionUpdateRequestTransfer_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-ServiceArea')))
    _____MulticastSessionUpdateRequestTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-QoSFlowsToBeSetupList')))
    _____MulticastSessionUpdateRequestTransfer_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithCause')))
    _____MulticastSessionUpdateRequestTransfer_protocolIEs__item__id_tab_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionTNLInfo5GC')))
    ____MulticastSessionUpdateRequestTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _____MulticastSessionUpdateRequestTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 298), ('criticality', 'reject'), ('Value', _____MulticastSessionUpdateRequestTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 297), ('criticality', 'reject'), ('Value', _____MulticastSessionUpdateRequestTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 351), ('criticality', 'reject'), ('Value', _____MulticastSessionUpdateRequestTransfer_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 352), ('criticality', 'reject'), ('Value', _____MulticastSessionUpdateRequestTransfer_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MulticastSessionUpdateRequestTransfer_protocolIEs__item__id._const_tab = ____MulticastSessionUpdateRequestTransfer_protocolIEs__item__id_tab
    ___MulticastSessionUpdateRequestTransfer_protocolIEs__item__id._const_tab_at = None
    ___MulticastSessionUpdateRequestTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___MulticastSessionUpdateRequestTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___MulticastSessionUpdateRequestTransfer_protocolIEs__item__criticality._const_tab = ____MulticastSessionUpdateRequestTransfer_protocolIEs__item__id_tab
    ___MulticastSessionUpdateRequestTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastSessionUpdateRequestTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MulticastSessionUpdateRequestTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___MulticastSessionUpdateRequestTransfer_protocolIEs__item__value._const_tab = ____MulticastSessionUpdateRequestTransfer_protocolIEs__item__id_tab
    ___MulticastSessionUpdateRequestTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MulticastSessionUpdateRequestTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __MulticastSessionUpdateRequestTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MulticastSessionUpdateRequestTransfer_protocolIEs__item__id),
        ('criticality', ___MulticastSessionUpdateRequestTransfer_protocolIEs__item__criticality),
        ('value', ___MulticastSessionUpdateRequestTransfer_protocolIEs__item__value),
        ])
    __MulticastSessionUpdateRequestTransfer_protocolIEs__item_._ext = None
    _MulticastSessionUpdateRequestTransfer_protocolIEs._cont = __MulticastSessionUpdateRequestTransfer_protocolIEs__item_
    _MulticastSessionUpdateRequestTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MulticastSessionUpdateRequestTransfer._cont = ASN1Dict([
        ('protocolIEs', _MulticastSessionUpdateRequestTransfer_protocolIEs),
        ])
    MulticastSessionUpdateRequestTransfer._ext = []
    
    #-----< MulticastSessionUpdateRequestTransferIEs >-----#
    MulticastSessionUpdateRequestTransferIEs = CLASS(name='MulticastSessionUpdateRequestTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _MulticastSessionUpdateRequestTransferIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _MulticastSessionUpdateRequestTransferIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-ServiceArea')))
    _MulticastSessionUpdateRequestTransferIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-QoSFlowsToBeSetupList')))
    _MulticastSessionUpdateRequestTransferIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithCause')))
    _MulticastSessionUpdateRequestTransferIEs_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionTNLInfo5GC')))
    MulticastSessionUpdateRequestTransferIEs._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _MulticastSessionUpdateRequestTransferIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 298), ('criticality', 'reject'), ('Value', _MulticastSessionUpdateRequestTransferIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 297), ('criticality', 'reject'), ('Value', _MulticastSessionUpdateRequestTransferIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 351), ('criticality', 'reject'), ('Value', _MulticastSessionUpdateRequestTransferIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 352), ('criticality', 'reject'), ('Value', _MulticastSessionUpdateRequestTransferIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MulticastGroupPagingAreaList >-----#
    MulticastGroupPagingAreaList = SEQ_OF(name='MulticastGroupPagingAreaList', mode=MODE_TYPE)
    _MulticastGroupPagingAreaList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MulticastGroupPagingAreaItem')))
    MulticastGroupPagingAreaList._cont = _MulticastGroupPagingAreaList__item_
    MulticastGroupPagingAreaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< MulticastGroupPagingAreaItem >-----#
    MulticastGroupPagingAreaItem = SEQ(name='MulticastGroupPagingAreaItem', mode=MODE_TYPE)
    _MulticastGroupPagingAreaItem_multicastGroupPagingArea = SEQ(name='multicastGroupPagingArea', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MulticastGroupPagingArea')))
    _MulticastGroupPagingAreaItem_uE_PagingList = SEQ_OF(name='uE-PagingList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UE-PagingList')), opt=True)
    _MulticastGroupPagingAreaItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MulticastGroupPagingAreaItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MulticastGroupPagingAreaItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MulticastGroupPagingAreaItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MulticastGroupPagingAreaItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastGroupPagingAreaItem_iE_Extensions__item__id._const_tab = ____MulticastGroupPagingAreaItem_iE_Extensions__item__id_tab
    ___MulticastGroupPagingAreaItem_iE_Extensions__item__id._const_tab_at = None
    ___MulticastGroupPagingAreaItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___MulticastGroupPagingAreaItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MulticastGroupPagingAreaItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MulticastGroupPagingAreaItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastGroupPagingAreaItem_iE_Extensions__item__criticality._const_tab = ____MulticastGroupPagingAreaItem_iE_Extensions__item__criticality_tab
    ___MulticastGroupPagingAreaItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastGroupPagingAreaItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MulticastGroupPagingAreaItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MulticastGroupPagingAreaItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MulticastGroupPagingAreaItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastGroupPagingAreaItem_iE_Extensions__item__extensionValue._const_tab = ____MulticastGroupPagingAreaItem_iE_Extensions__item__extensionValue_tab
    ___MulticastGroupPagingAreaItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MulticastGroupPagingAreaItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MulticastGroupPagingAreaItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MulticastGroupPagingAreaItem_iE_Extensions__item__id),
        ('criticality', ___MulticastGroupPagingAreaItem_iE_Extensions__item__criticality),
        ('extensionValue', ___MulticastGroupPagingAreaItem_iE_Extensions__item__extensionValue),
        ])
    __MulticastGroupPagingAreaItem_iE_Extensions__item_._ext = None
    _MulticastGroupPagingAreaItem_iE_Extensions._cont = __MulticastGroupPagingAreaItem_iE_Extensions__item_
    _MulticastGroupPagingAreaItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MulticastGroupPagingAreaItem._cont = ASN1Dict([
        ('multicastGroupPagingArea', _MulticastGroupPagingAreaItem_multicastGroupPagingArea),
        ('uE-PagingList', _MulticastGroupPagingAreaItem_uE_PagingList),
        ('iE-Extensions', _MulticastGroupPagingAreaItem_iE_Extensions),
        ])
    MulticastGroupPagingAreaItem._ext = []
    
    #-----< MulticastGroupPagingAreaItem-ExtIEs >-----#
    MulticastGroupPagingAreaItem_ExtIEs = CLASS(name='MulticastGroupPagingAreaItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MulticastGroupPagingAreaItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBS-AreaTAIList >-----#
    MBS_AreaTAIList = SEQ_OF(name='MBS-AreaTAIList', mode=MODE_TYPE)
    _MBS_AreaTAIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    MBS_AreaTAIList._cont = _MBS_AreaTAIList__item_
    MBS_AreaTAIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< MulticastGroupPagingArea >-----#
    MulticastGroupPagingArea = SEQ(name='MulticastGroupPagingArea', mode=MODE_TYPE)
    _MulticastGroupPagingArea_mBS_AreaTAIList = SEQ_OF(name='mBS-AreaTAIList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaTAIList')))
    _MulticastGroupPagingArea_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MulticastGroupPagingArea_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MulticastGroupPagingArea_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MulticastGroupPagingArea_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MulticastGroupPagingArea_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastGroupPagingArea_iE_Extensions__item__id._const_tab = ____MulticastGroupPagingArea_iE_Extensions__item__id_tab
    ___MulticastGroupPagingArea_iE_Extensions__item__id._const_tab_at = None
    ___MulticastGroupPagingArea_iE_Extensions__item__id._const_tab_id = 'id'
    ___MulticastGroupPagingArea_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MulticastGroupPagingArea_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MulticastGroupPagingArea_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastGroupPagingArea_iE_Extensions__item__criticality._const_tab = ____MulticastGroupPagingArea_iE_Extensions__item__criticality_tab
    ___MulticastGroupPagingArea_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastGroupPagingArea_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MulticastGroupPagingArea_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MulticastGroupPagingArea_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MulticastGroupPagingArea_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticastGroupPagingArea_iE_Extensions__item__extensionValue._const_tab = ____MulticastGroupPagingArea_iE_Extensions__item__extensionValue_tab
    ___MulticastGroupPagingArea_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MulticastGroupPagingArea_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MulticastGroupPagingArea_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MulticastGroupPagingArea_iE_Extensions__item__id),
        ('criticality', ___MulticastGroupPagingArea_iE_Extensions__item__criticality),
        ('extensionValue', ___MulticastGroupPagingArea_iE_Extensions__item__extensionValue),
        ])
    __MulticastGroupPagingArea_iE_Extensions__item_._ext = None
    _MulticastGroupPagingArea_iE_Extensions._cont = __MulticastGroupPagingArea_iE_Extensions__item_
    _MulticastGroupPagingArea_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MulticastGroupPagingArea._cont = ASN1Dict([
        ('mBS-AreaTAIList', _MulticastGroupPagingArea_mBS_AreaTAIList),
        ('iE-Extensions', _MulticastGroupPagingArea_iE_Extensions),
        ])
    MulticastGroupPagingArea._ext = []
    
    #-----< MulticastGroupPagingArea-ExtIEs >-----#
    MulticastGroupPagingArea_ExtIEs = CLASS(name='MulticastGroupPagingArea-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MulticastGroupPagingArea_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-PagingList >-----#
    UE_PagingList = SEQ_OF(name='UE-PagingList', mode=MODE_TYPE)
    _UE_PagingList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-PagingItem')))
    UE_PagingList._cont = _UE_PagingList__item_
    UE_PagingList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4096)], ev=None, er=[])
    
    #-----< UE-PagingItem >-----#
    UE_PagingItem = SEQ(name='UE-PagingItem', mode=MODE_TYPE)
    _UE_PagingItem_uEIdentityIndexValue = CHOICE(name='uEIdentityIndexValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UEIdentityIndexValue')))
    _UE_PagingItem_pagingDRX = ENUM(name='pagingDRX', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PagingDRX')), opt=True)
    _UE_PagingItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_PagingItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UE_PagingItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_PagingItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UE_PagingItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_PagingItem_iE_Extensions__item__id._const_tab = ____UE_PagingItem_iE_Extensions__item__id_tab
    ___UE_PagingItem_iE_Extensions__item__id._const_tab_at = None
    ___UE_PagingItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_PagingItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UE_PagingItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UE_PagingItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_PagingItem_iE_Extensions__item__criticality._const_tab = ____UE_PagingItem_iE_Extensions__item__criticality_tab
    ___UE_PagingItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_PagingItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_PagingItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UE_PagingItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UE_PagingItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_PagingItem_iE_Extensions__item__extensionValue._const_tab = ____UE_PagingItem_iE_Extensions__item__extensionValue_tab
    ___UE_PagingItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_PagingItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_PagingItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_PagingItem_iE_Extensions__item__id),
        ('criticality', ___UE_PagingItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_PagingItem_iE_Extensions__item__extensionValue),
        ])
    __UE_PagingItem_iE_Extensions__item_._ext = None
    _UE_PagingItem_iE_Extensions._cont = __UE_PagingItem_iE_Extensions__item_
    _UE_PagingItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_PagingItem._cont = ASN1Dict([
        ('uEIdentityIndexValue', _UE_PagingItem_uEIdentityIndexValue),
        ('pagingDRX', _UE_PagingItem_pagingDRX),
        ('iE-Extensions', _UE_PagingItem_iE_Extensions),
        ])
    UE_PagingItem._ext = []
    
    #-----< UE-PagingItem-ExtIEs >-----#
    UE_PagingItem_ExtIEs = CLASS(name='UE-PagingItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UE_PagingItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M1Configuration >-----#
    M1Configuration = SEQ(name='M1Configuration', mode=MODE_TYPE)
    _M1Configuration_m1reportingTrigger = ENUM(name='m1reportingTrigger', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'M1ReportingTrigger')))
    _M1Configuration_m1thresholdEventA2 = SEQ(name='m1thresholdEventA2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'M1ThresholdEventA2')), opt=True)
    _M1Configuration_m1periodicReporting = SEQ(name='m1periodicReporting', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'M1PeriodicReporting')), opt=True)
    _M1Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M1Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___M1Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____M1Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____M1Configuration_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IncludeBeamMeasurementsIndication')))
    _____M1Configuration_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'BeamMeasurementsReportConfiguration')))
    ____M1Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 340), ('criticality', 'ignore'), ('Extension', _____M1Configuration_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 361), ('criticality', 'ignore'), ('Extension', _____M1Configuration_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'conditional')])], rr=[], ev=None, er=[])
    ___M1Configuration_iE_Extensions__item__id._const_tab = ____M1Configuration_iE_Extensions__item__id_tab
    ___M1Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M1Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___M1Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___M1Configuration_iE_Extensions__item__criticality._const_tab = ____M1Configuration_iE_Extensions__item__id_tab
    ___M1Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M1Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M1Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___M1Configuration_iE_Extensions__item__extensionValue._const_tab = ____M1Configuration_iE_Extensions__item__id_tab
    ___M1Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M1Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M1Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M1Configuration_iE_Extensions__item__id),
        ('criticality', ___M1Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___M1Configuration_iE_Extensions__item__extensionValue),
        ])
    __M1Configuration_iE_Extensions__item_._ext = None
    _M1Configuration_iE_Extensions._cont = __M1Configuration_iE_Extensions__item_
    _M1Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M1Configuration._cont = ASN1Dict([
        ('m1reportingTrigger', _M1Configuration_m1reportingTrigger),
        ('m1thresholdEventA2', _M1Configuration_m1thresholdEventA2),
        ('m1periodicReporting', _M1Configuration_m1periodicReporting),
        ('iE-Extensions', _M1Configuration_iE_Extensions),
        ])
    M1Configuration._ext = []
    
    #-----< M1Configuration-ExtIEs >-----#
    M1Configuration_ExtIEs = CLASS(name='M1Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _M1Configuration_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IncludeBeamMeasurementsIndication')))
    _M1Configuration_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'BeamMeasurementsReportConfiguration')))
    M1Configuration_ExtIEs._val = ASN1Set(rv=[dict([('id', 340), ('criticality', 'ignore'), ('Extension', _M1Configuration_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 361), ('criticality', 'ignore'), ('Extension', _M1Configuration_ExtIEs_val_Extension_1), ('presence', 'conditional')])], rr=[], ev=[], er=[])
    
    #-----< IncludeBeamMeasurementsIndication >-----#
    IncludeBeamMeasurementsIndication = ENUM(name='IncludeBeamMeasurementsIndication', mode=MODE_TYPE)
    IncludeBeamMeasurementsIndication._cont = ASN1Dict([('true', 0)])
    IncludeBeamMeasurementsIndication._ext = []
    
    #-----< MaxNrofRS-IndexesToReport >-----#
    MaxNrofRS_IndexesToReport = INT(name='MaxNrofRS-IndexesToReport', mode=MODE_TYPE)
    MaxNrofRS_IndexesToReport._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=[], er=[])
    
    #-----< M1ReportingTrigger >-----#
    M1ReportingTrigger = ENUM(name='M1ReportingTrigger', mode=MODE_TYPE)
    M1ReportingTrigger._cont = ASN1Dict([('periodic', 0), ('a2eventtriggered', 1), ('a2eventtriggered-periodic', 2)])
    M1ReportingTrigger._ext = []
    
    #-----< M1ThresholdEventA2 >-----#
    M1ThresholdEventA2 = SEQ(name='M1ThresholdEventA2', mode=MODE_TYPE)
    _M1ThresholdEventA2_m1ThresholdType = CHOICE(name='m1ThresholdType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'M1ThresholdType')))
    _M1ThresholdEventA2_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M1ThresholdEventA2_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___M1ThresholdEventA2_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____M1ThresholdEventA2_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____M1ThresholdEventA2_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1ThresholdEventA2_iE_Extensions__item__id._const_tab = ____M1ThresholdEventA2_iE_Extensions__item__id_tab
    ___M1ThresholdEventA2_iE_Extensions__item__id._const_tab_at = None
    ___M1ThresholdEventA2_iE_Extensions__item__id._const_tab_id = 'id'
    ___M1ThresholdEventA2_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____M1ThresholdEventA2_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____M1ThresholdEventA2_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1ThresholdEventA2_iE_Extensions__item__criticality._const_tab = ____M1ThresholdEventA2_iE_Extensions__item__criticality_tab
    ___M1ThresholdEventA2_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M1ThresholdEventA2_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M1ThresholdEventA2_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____M1ThresholdEventA2_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____M1ThresholdEventA2_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1ThresholdEventA2_iE_Extensions__item__extensionValue._const_tab = ____M1ThresholdEventA2_iE_Extensions__item__extensionValue_tab
    ___M1ThresholdEventA2_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M1ThresholdEventA2_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M1ThresholdEventA2_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M1ThresholdEventA2_iE_Extensions__item__id),
        ('criticality', ___M1ThresholdEventA2_iE_Extensions__item__criticality),
        ('extensionValue', ___M1ThresholdEventA2_iE_Extensions__item__extensionValue),
        ])
    __M1ThresholdEventA2_iE_Extensions__item_._ext = None
    _M1ThresholdEventA2_iE_Extensions._cont = __M1ThresholdEventA2_iE_Extensions__item_
    _M1ThresholdEventA2_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M1ThresholdEventA2._cont = ASN1Dict([
        ('m1ThresholdType', _M1ThresholdEventA2_m1ThresholdType),
        ('iE-Extensions', _M1ThresholdEventA2_iE_Extensions),
        ])
    M1ThresholdEventA2._ext = []
    
    #-----< M1ThresholdEventA2-ExtIEs >-----#
    M1ThresholdEventA2_ExtIEs = CLASS(name='M1ThresholdEventA2-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    M1ThresholdEventA2_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M1ThresholdType >-----#
    M1ThresholdType = CHOICE(name='M1ThresholdType', mode=MODE_TYPE)
    _M1ThresholdType_threshold_RSRP = INT(name='threshold-RSRP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Threshold-RSRP')))
    _M1ThresholdType_threshold_RSRQ = INT(name='threshold-RSRQ', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Threshold-RSRQ')))
    _M1ThresholdType_threshold_SINR = INT(name='threshold-SINR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Threshold-SINR')))
    _M1ThresholdType_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __M1ThresholdType_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___M1ThresholdType_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___M1ThresholdType_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __M1ThresholdType_choice_Extensions_id._const_tab = ___M1ThresholdType_choice_Extensions_id_tab
    __M1ThresholdType_choice_Extensions_id._const_tab_at = None
    __M1ThresholdType_choice_Extensions_id._const_tab_id = 'id'
    __M1ThresholdType_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___M1ThresholdType_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___M1ThresholdType_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __M1ThresholdType_choice_Extensions_criticality._const_tab = ___M1ThresholdType_choice_Extensions_criticality_tab
    __M1ThresholdType_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __M1ThresholdType_choice_Extensions_criticality._const_tab_id = 'criticality'
    __M1ThresholdType_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___M1ThresholdType_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___M1ThresholdType_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __M1ThresholdType_choice_Extensions_value._const_tab = ___M1ThresholdType_choice_Extensions_value_tab
    __M1ThresholdType_choice_Extensions_value._const_tab_at = ('..', 'id')
    __M1ThresholdType_choice_Extensions_value._const_tab_id = 'Value'
    _M1ThresholdType_choice_Extensions._cont = ASN1Dict([
        ('id', __M1ThresholdType_choice_Extensions_id),
        ('criticality', __M1ThresholdType_choice_Extensions_criticality),
        ('value', __M1ThresholdType_choice_Extensions_value),
        ])
    _M1ThresholdType_choice_Extensions._ext = None
    M1ThresholdType._cont = ASN1Dict([
        ('threshold-RSRP', _M1ThresholdType_threshold_RSRP),
        ('threshold-RSRQ', _M1ThresholdType_threshold_RSRQ),
        ('threshold-SINR', _M1ThresholdType_threshold_SINR),
        ('choice-Extensions', _M1ThresholdType_choice_Extensions),
        ])
    M1ThresholdType._ext = None
    
    #-----< M1ThresholdType-ExtIEs >-----#
    M1ThresholdType_ExtIEs = CLASS(name='M1ThresholdType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    M1ThresholdType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M1PeriodicReporting >-----#
    M1PeriodicReporting = SEQ(name='M1PeriodicReporting', mode=MODE_TYPE)
    _M1PeriodicReporting_reportInterval = ENUM(name='reportInterval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ReportIntervalMDT')))
    _M1PeriodicReporting_reportAmount = ENUM(name='reportAmount', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ReportAmountMDT')))
    _M1PeriodicReporting_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M1PeriodicReporting_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___M1PeriodicReporting_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____M1PeriodicReporting_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____M1PeriodicReporting_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedReportIntervalMDT')))
    ____M1PeriodicReporting_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 285), ('criticality', 'ignore'), ('Extension', _____M1PeriodicReporting_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___M1PeriodicReporting_iE_Extensions__item__id._const_tab = ____M1PeriodicReporting_iE_Extensions__item__id_tab
    ___M1PeriodicReporting_iE_Extensions__item__id._const_tab_at = None
    ___M1PeriodicReporting_iE_Extensions__item__id._const_tab_id = 'id'
    ___M1PeriodicReporting_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___M1PeriodicReporting_iE_Extensions__item__criticality._const_tab = ____M1PeriodicReporting_iE_Extensions__item__id_tab
    ___M1PeriodicReporting_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M1PeriodicReporting_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M1PeriodicReporting_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___M1PeriodicReporting_iE_Extensions__item__extensionValue._const_tab = ____M1PeriodicReporting_iE_Extensions__item__id_tab
    ___M1PeriodicReporting_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M1PeriodicReporting_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M1PeriodicReporting_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M1PeriodicReporting_iE_Extensions__item__id),
        ('criticality', ___M1PeriodicReporting_iE_Extensions__item__criticality),
        ('extensionValue', ___M1PeriodicReporting_iE_Extensions__item__extensionValue),
        ])
    __M1PeriodicReporting_iE_Extensions__item_._ext = None
    _M1PeriodicReporting_iE_Extensions._cont = __M1PeriodicReporting_iE_Extensions__item_
    _M1PeriodicReporting_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M1PeriodicReporting._cont = ASN1Dict([
        ('reportInterval', _M1PeriodicReporting_reportInterval),
        ('reportAmount', _M1PeriodicReporting_reportAmount),
        ('iE-Extensions', _M1PeriodicReporting_iE_Extensions),
        ])
    M1PeriodicReporting._ext = []
    
    #-----< M1PeriodicReporting-ExtIEs >-----#
    M1PeriodicReporting_ExtIEs = CLASS(name='M1PeriodicReporting-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _M1PeriodicReporting_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedReportIntervalMDT')))
    M1PeriodicReporting_ExtIEs._val = ASN1Set(rv=[dict([('id', 285), ('criticality', 'ignore'), ('Extension', _M1PeriodicReporting_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< M4Configuration >-----#
    M4Configuration = SEQ(name='M4Configuration', mode=MODE_TYPE)
    _M4Configuration_m4period = ENUM(name='m4period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'M4period')))
    _M4Configuration_m4_links_to_log = ENUM(name='m4-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Links-to-log')))
    _M4Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M4Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___M4Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____M4Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____M4Configuration_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'M4ReportAmountMDT')))
    ____M4Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 336), ('criticality', 'ignore'), ('Extension', _____M4Configuration_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___M4Configuration_iE_Extensions__item__id._const_tab = ____M4Configuration_iE_Extensions__item__id_tab
    ___M4Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M4Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___M4Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___M4Configuration_iE_Extensions__item__criticality._const_tab = ____M4Configuration_iE_Extensions__item__id_tab
    ___M4Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M4Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M4Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___M4Configuration_iE_Extensions__item__extensionValue._const_tab = ____M4Configuration_iE_Extensions__item__id_tab
    ___M4Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M4Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M4Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M4Configuration_iE_Extensions__item__id),
        ('criticality', ___M4Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___M4Configuration_iE_Extensions__item__extensionValue),
        ])
    __M4Configuration_iE_Extensions__item_._ext = None
    _M4Configuration_iE_Extensions._cont = __M4Configuration_iE_Extensions__item_
    _M4Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M4Configuration._cont = ASN1Dict([
        ('m4period', _M4Configuration_m4period),
        ('m4-links-to-log', _M4Configuration_m4_links_to_log),
        ('iE-Extensions', _M4Configuration_iE_Extensions),
        ])
    M4Configuration._ext = []
    
    #-----< M4Configuration-ExtIEs >-----#
    M4Configuration_ExtIEs = CLASS(name='M4Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _M4Configuration_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'M4ReportAmountMDT')))
    M4Configuration_ExtIEs._val = ASN1Set(rv=[dict([('id', 336), ('criticality', 'ignore'), ('Extension', _M4Configuration_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< M4ReportAmountMDT >-----#
    M4ReportAmountMDT = ENUM(name='M4ReportAmountMDT', mode=MODE_TYPE)
    M4ReportAmountMDT._cont = ASN1Dict([('r1', 0), ('r2', 1), ('r4', 2), ('r8', 3), ('r16', 4), ('r32', 5), ('r64', 6), ('infinity', 7)])
    M4ReportAmountMDT._ext = []
    
    #-----< M4period >-----#
    M4period = ENUM(name='M4period', mode=MODE_TYPE)
    M4period._cont = ASN1Dict([('ms1024', 0), ('ms2048', 1), ('ms5120', 2), ('ms10240', 3), ('min1', 4)])
    M4period._ext = []
    
    #-----< M5Configuration >-----#
    M5Configuration = SEQ(name='M5Configuration', mode=MODE_TYPE)
    _M5Configuration_m5period = ENUM(name='m5period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'M5period')))
    _M5Configuration_m5_links_to_log = ENUM(name='m5-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Links-to-log')))
    _M5Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M5Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___M5Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____M5Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____M5Configuration_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'M5ReportAmountMDT')))
    ____M5Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 337), ('criticality', 'ignore'), ('Extension', _____M5Configuration_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___M5Configuration_iE_Extensions__item__id._const_tab = ____M5Configuration_iE_Extensions__item__id_tab
    ___M5Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M5Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___M5Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___M5Configuration_iE_Extensions__item__criticality._const_tab = ____M5Configuration_iE_Extensions__item__id_tab
    ___M5Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M5Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M5Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___M5Configuration_iE_Extensions__item__extensionValue._const_tab = ____M5Configuration_iE_Extensions__item__id_tab
    ___M5Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M5Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M5Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M5Configuration_iE_Extensions__item__id),
        ('criticality', ___M5Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___M5Configuration_iE_Extensions__item__extensionValue),
        ])
    __M5Configuration_iE_Extensions__item_._ext = None
    _M5Configuration_iE_Extensions._cont = __M5Configuration_iE_Extensions__item_
    _M5Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M5Configuration._cont = ASN1Dict([
        ('m5period', _M5Configuration_m5period),
        ('m5-links-to-log', _M5Configuration_m5_links_to_log),
        ('iE-Extensions', _M5Configuration_iE_Extensions),
        ])
    M5Configuration._ext = []
    
    #-----< M5Configuration-ExtIEs >-----#
    M5Configuration_ExtIEs = CLASS(name='M5Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _M5Configuration_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'M5ReportAmountMDT')))
    M5Configuration_ExtIEs._val = ASN1Set(rv=[dict([('id', 337), ('criticality', 'ignore'), ('Extension', _M5Configuration_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< M5ReportAmountMDT >-----#
    M5ReportAmountMDT = ENUM(name='M5ReportAmountMDT', mode=MODE_TYPE)
    M5ReportAmountMDT._cont = ASN1Dict([('r1', 0), ('r2', 1), ('r4', 2), ('r8', 3), ('r16', 4), ('r32', 5), ('r64', 6), ('infinity', 7)])
    M5ReportAmountMDT._ext = []
    
    #-----< M5period >-----#
    M5period = ENUM(name='M5period', mode=MODE_TYPE)
    M5period._cont = ASN1Dict([('ms1024', 0), ('ms2048', 1), ('ms5120', 2), ('ms10240', 3), ('min1', 4)])
    M5period._ext = []
    
    #-----< M6Configuration >-----#
    M6Configuration = SEQ(name='M6Configuration', mode=MODE_TYPE)
    _M6Configuration_m6report_Interval = ENUM(name='m6report-Interval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'M6report-Interval')))
    _M6Configuration_m6_links_to_log = ENUM(name='m6-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Links-to-log')))
    _M6Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M6Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___M6Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____M6Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____M6Configuration_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'M6ReportAmountMDT')))
    _____M6Configuration_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExcessPacketDelayThresholdConfiguration')))
    ____M6Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 338), ('criticality', 'ignore'), ('Extension', _____M6Configuration_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 341), ('criticality', 'ignore'), ('Extension', _____M6Configuration_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___M6Configuration_iE_Extensions__item__id._const_tab = ____M6Configuration_iE_Extensions__item__id_tab
    ___M6Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M6Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___M6Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___M6Configuration_iE_Extensions__item__criticality._const_tab = ____M6Configuration_iE_Extensions__item__id_tab
    ___M6Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M6Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M6Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab = ____M6Configuration_iE_Extensions__item__id_tab
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M6Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M6Configuration_iE_Extensions__item__id),
        ('criticality', ___M6Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___M6Configuration_iE_Extensions__item__extensionValue),
        ])
    __M6Configuration_iE_Extensions__item_._ext = None
    _M6Configuration_iE_Extensions._cont = __M6Configuration_iE_Extensions__item_
    _M6Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M6Configuration._cont = ASN1Dict([
        ('m6report-Interval', _M6Configuration_m6report_Interval),
        ('m6-links-to-log', _M6Configuration_m6_links_to_log),
        ('iE-Extensions', _M6Configuration_iE_Extensions),
        ])
    M6Configuration._ext = []
    
    #-----< M6Configuration-ExtIEs >-----#
    M6Configuration_ExtIEs = CLASS(name='M6Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _M6Configuration_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'M6ReportAmountMDT')))
    _M6Configuration_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExcessPacketDelayThresholdConfiguration')))
    M6Configuration_ExtIEs._val = ASN1Set(rv=[dict([('id', 338), ('criticality', 'ignore'), ('Extension', _M6Configuration_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 341), ('criticality', 'ignore'), ('Extension', _M6Configuration_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< M6ReportAmountMDT >-----#
    M6ReportAmountMDT = ENUM(name='M6ReportAmountMDT', mode=MODE_TYPE)
    M6ReportAmountMDT._cont = ASN1Dict([('r1', 0), ('r2', 1), ('r4', 2), ('r8', 3), ('r16', 4), ('r32', 5), ('r64', 6), ('infinity', 7)])
    M6ReportAmountMDT._ext = []
    
    #-----< M6report-Interval >-----#
    M6report_Interval = ENUM(name='M6report-Interval', mode=MODE_TYPE)
    M6report_Interval._cont = ASN1Dict([('ms120', 0), ('ms240', 1), ('ms480', 2), ('ms640', 3), ('ms1024', 4), ('ms2048', 5), ('ms5120', 6), ('ms10240', 7), ('ms20480', 8), ('ms40960', 9), ('min1', 10), ('min6', 11), ('min12', 12), ('min30', 13)])
    M6report_Interval._ext = []
    
    #-----< M7Configuration >-----#
    M7Configuration = SEQ(name='M7Configuration', mode=MODE_TYPE)
    _M7Configuration_m7period = INT(name='m7period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'M7period')))
    _M7Configuration_m7_links_to_log = ENUM(name='m7-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Links-to-log')))
    _M7Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M7Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___M7Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____M7Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____M7Configuration_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'M7ReportAmountMDT')))
    ____M7Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 339), ('criticality', 'ignore'), ('Extension', _____M7Configuration_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___M7Configuration_iE_Extensions__item__id._const_tab = ____M7Configuration_iE_Extensions__item__id_tab
    ___M7Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M7Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___M7Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___M7Configuration_iE_Extensions__item__criticality._const_tab = ____M7Configuration_iE_Extensions__item__id_tab
    ___M7Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M7Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M7Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab = ____M7Configuration_iE_Extensions__item__id_tab
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M7Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M7Configuration_iE_Extensions__item__id),
        ('criticality', ___M7Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___M7Configuration_iE_Extensions__item__extensionValue),
        ])
    __M7Configuration_iE_Extensions__item_._ext = None
    _M7Configuration_iE_Extensions._cont = __M7Configuration_iE_Extensions__item_
    _M7Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M7Configuration._cont = ASN1Dict([
        ('m7period', _M7Configuration_m7period),
        ('m7-links-to-log', _M7Configuration_m7_links_to_log),
        ('iE-Extensions', _M7Configuration_iE_Extensions),
        ])
    M7Configuration._ext = []
    
    #-----< M7Configuration-ExtIEs >-----#
    M7Configuration_ExtIEs = CLASS(name='M7Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _M7Configuration_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'M7ReportAmountMDT')))
    M7Configuration_ExtIEs._val = ASN1Set(rv=[dict([('id', 339), ('criticality', 'ignore'), ('Extension', _M7Configuration_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< M7ReportAmountMDT >-----#
    M7ReportAmountMDT = ENUM(name='M7ReportAmountMDT', mode=MODE_TYPE)
    M7ReportAmountMDT._cont = ASN1Dict([('r1', 0), ('r2', 1), ('r4', 2), ('r8', 3), ('r16', 4), ('r32', 5), ('r64', 6), ('infinity', 7)])
    M7ReportAmountMDT._ext = []
    
    #-----< M7period >-----#
    M7period = INT(name='M7period', mode=MODE_TYPE)
    M7period._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=60)], ev=[], er=[])
    
    #-----< MDT-Location-Info >-----#
    MDT_Location_Info = SEQ(name='MDT-Location-Info', mode=MODE_TYPE)
    _MDT_Location_Info_mDT_Location_Information = BIT_STR(name='mDT-Location-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MDT-Location-Information')))
    _MDT_Location_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MDT_Location_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___MDT_Location_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____MDT_Location_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MDT_Location_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Location_Info_iE_Extensions__item__id._const_tab = ____MDT_Location_Info_iE_Extensions__item__id_tab
    ___MDT_Location_Info_iE_Extensions__item__id._const_tab_at = None
    ___MDT_Location_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___MDT_Location_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MDT_Location_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MDT_Location_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Location_Info_iE_Extensions__item__criticality._const_tab = ____MDT_Location_Info_iE_Extensions__item__criticality_tab
    ___MDT_Location_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MDT_Location_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MDT_Location_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MDT_Location_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____MDT_Location_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Location_Info_iE_Extensions__item__extensionValue._const_tab = ____MDT_Location_Info_iE_Extensions__item__extensionValue_tab
    ___MDT_Location_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MDT_Location_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MDT_Location_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MDT_Location_Info_iE_Extensions__item__id),
        ('criticality', ___MDT_Location_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___MDT_Location_Info_iE_Extensions__item__extensionValue),
        ])
    __MDT_Location_Info_iE_Extensions__item_._ext = None
    _MDT_Location_Info_iE_Extensions._cont = __MDT_Location_Info_iE_Extensions__item_
    _MDT_Location_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MDT_Location_Info._cont = ASN1Dict([
        ('mDT-Location-Information', _MDT_Location_Info_mDT_Location_Information),
        ('iE-Extensions', _MDT_Location_Info_iE_Extensions),
        ])
    MDT_Location_Info._ext = []
    
    #-----< MDT-Location-Info-ExtIEs >-----#
    MDT_Location_Info_ExtIEs = CLASS(name='MDT-Location-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    MDT_Location_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MDT-Location-Information >-----#
    MDT_Location_Information = BIT_STR(name='MDT-Location-Information', mode=MODE_TYPE)
    MDT_Location_Information._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< N3IWF-ID >-----#
    N3IWF_ID = CHOICE(name='N3IWF-ID', mode=MODE_TYPE)
    _N3IWF_ID_n3IWF_ID = BIT_STR(name='n3IWF-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _N3IWF_ID_n3IWF_ID._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _N3IWF_ID_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __N3IWF_ID_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___N3IWF_ID_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___N3IWF_ID_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __N3IWF_ID_choice_Extensions_id._const_tab = ___N3IWF_ID_choice_Extensions_id_tab
    __N3IWF_ID_choice_Extensions_id._const_tab_at = None
    __N3IWF_ID_choice_Extensions_id._const_tab_id = 'id'
    __N3IWF_ID_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___N3IWF_ID_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___N3IWF_ID_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __N3IWF_ID_choice_Extensions_criticality._const_tab = ___N3IWF_ID_choice_Extensions_criticality_tab
    __N3IWF_ID_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __N3IWF_ID_choice_Extensions_criticality._const_tab_id = 'criticality'
    __N3IWF_ID_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___N3IWF_ID_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___N3IWF_ID_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __N3IWF_ID_choice_Extensions_value._const_tab = ___N3IWF_ID_choice_Extensions_value_tab
    __N3IWF_ID_choice_Extensions_value._const_tab_at = ('..', 'id')
    __N3IWF_ID_choice_Extensions_value._const_tab_id = 'Value'
    _N3IWF_ID_choice_Extensions._cont = ASN1Dict([
        ('id', __N3IWF_ID_choice_Extensions_id),
        ('criticality', __N3IWF_ID_choice_Extensions_criticality),
        ('value', __N3IWF_ID_choice_Extensions_value),
        ])
    _N3IWF_ID_choice_Extensions._ext = None
    N3IWF_ID._cont = ASN1Dict([
        ('n3IWF-ID', _N3IWF_ID_n3IWF_ID),
        ('choice-Extensions', _N3IWF_ID_choice_Extensions),
        ])
    N3IWF_ID._ext = None
    
    #-----< N3IWF-ID-ExtIEs >-----#
    N3IWF_ID_ExtIEs = CLASS(name='N3IWF-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    N3IWF_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NAS-PDU >-----#
    NAS_PDU = OCT_STR(name='NAS-PDU', mode=MODE_TYPE)
    
    #-----< NASSecurityParametersFromNGRAN >-----#
    NASSecurityParametersFromNGRAN = OCT_STR(name='NASSecurityParametersFromNGRAN', mode=MODE_TYPE)
    
    #-----< NB-IoT-DefaultPagingDRX >-----#
    NB_IoT_DefaultPagingDRX = ENUM(name='NB-IoT-DefaultPagingDRX', mode=MODE_TYPE)
    NB_IoT_DefaultPagingDRX._cont = ASN1Dict([('rf128', 0), ('rf256', 1), ('rf512', 2), ('rf1024', 3)])
    NB_IoT_DefaultPagingDRX._ext = []
    
    #-----< NB-IoT-PagingDRX >-----#
    NB_IoT_PagingDRX = ENUM(name='NB-IoT-PagingDRX', mode=MODE_TYPE)
    NB_IoT_PagingDRX._cont = ASN1Dict([('rf32', 0), ('rf64', 1), ('rf128', 2), ('rf256', 3), ('rf512', 4), ('rf1024', 5)])
    NB_IoT_PagingDRX._ext = []
    
    #-----< NB-IoT-Paging-eDRXCycle >-----#
    NB_IoT_Paging_eDRXCycle = ENUM(name='NB-IoT-Paging-eDRXCycle', mode=MODE_TYPE)
    NB_IoT_Paging_eDRXCycle._cont = ASN1Dict([('hf2', 0), ('hf4', 1), ('hf6', 2), ('hf8', 3), ('hf10', 4), ('hf12', 5), ('hf14', 6), ('hf16', 7), ('hf32', 8), ('hf64', 9), ('hf128', 10), ('hf256', 11), ('hf512', 12), ('hf1024', 13)])
    NB_IoT_Paging_eDRXCycle._ext = []
    
    #-----< NB-IoT-Paging-TimeWindow >-----#
    NB_IoT_Paging_TimeWindow = ENUM(name='NB-IoT-Paging-TimeWindow', mode=MODE_TYPE)
    NB_IoT_Paging_TimeWindow._cont = ASN1Dict([('s1', 0), ('s2', 1), ('s3', 2), ('s4', 3), ('s5', 4), ('s6', 5), ('s7', 6), ('s8', 7), ('s9', 8), ('s10', 9), ('s11', 10), ('s12', 11), ('s13', 12), ('s14', 13), ('s15', 14), ('s16', 15)])
    NB_IoT_Paging_TimeWindow._ext = []
    
    #-----< NB-IoT-Paging-eDRXInfo >-----#
    NB_IoT_Paging_eDRXInfo = SEQ(name='NB-IoT-Paging-eDRXInfo', mode=MODE_TYPE)
    _NB_IoT_Paging_eDRXInfo_nB_IoT_Paging_eDRXCycle = ENUM(name='nB-IoT-Paging-eDRXCycle', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-Paging-eDRXCycle')))
    _NB_IoT_Paging_eDRXInfo_nB_IoT_Paging_TimeWindow = ENUM(name='nB-IoT-Paging-TimeWindow', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-Paging-TimeWindow')), opt=True)
    _NB_IoT_Paging_eDRXInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NB_IoT_Paging_eDRXInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____NB_IoT_Paging_eDRXInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NB_IoT_Paging_eDRXInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__id._const_tab = ____NB_IoT_Paging_eDRXInfo_iE_Extensions__item__id_tab
    ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__id._const_tab_at = None
    ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NB_IoT_Paging_eDRXInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NB_IoT_Paging_eDRXInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__criticality._const_tab = ____NB_IoT_Paging_eDRXInfo_iE_Extensions__item__criticality_tab
    ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NB_IoT_Paging_eDRXInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NB_IoT_Paging_eDRXInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__extensionValue._const_tab = ____NB_IoT_Paging_eDRXInfo_iE_Extensions__item__extensionValue_tab
    ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NB_IoT_Paging_eDRXInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__id),
        ('criticality', ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__extensionValue),
        ])
    __NB_IoT_Paging_eDRXInfo_iE_Extensions__item_._ext = None
    _NB_IoT_Paging_eDRXInfo_iE_Extensions._cont = __NB_IoT_Paging_eDRXInfo_iE_Extensions__item_
    _NB_IoT_Paging_eDRXInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NB_IoT_Paging_eDRXInfo._cont = ASN1Dict([
        ('nB-IoT-Paging-eDRXCycle', _NB_IoT_Paging_eDRXInfo_nB_IoT_Paging_eDRXCycle),
        ('nB-IoT-Paging-TimeWindow', _NB_IoT_Paging_eDRXInfo_nB_IoT_Paging_TimeWindow),
        ('iE-Extensions', _NB_IoT_Paging_eDRXInfo_iE_Extensions),
        ])
    NB_IoT_Paging_eDRXInfo._ext = []
    
    #-----< NB-IoT-Paging-eDRXInfo-ExtIEs >-----#
    NB_IoT_Paging_eDRXInfo_ExtIEs = CLASS(name='NB-IoT-Paging-eDRXInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    NB_IoT_Paging_eDRXInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NB-IoT-UEPriority >-----#
    NB_IoT_UEPriority = INT(name='NB-IoT-UEPriority', mode=MODE_TYPE)
    NB_IoT_UEPriority._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< NetworkInstance >-----#
    NetworkInstance = INT(name='NetworkInstance', mode=MODE_TYPE)
    NetworkInstance._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=[], er=[])
    
    #-----< NewSecurityContextInd >-----#
    NewSecurityContextInd = ENUM(name='NewSecurityContextInd', mode=MODE_TYPE)
    NewSecurityContextInd._cont = ASN1Dict([('true', 0)])
    NewSecurityContextInd._ext = []
    
    #-----< NextHopChainingCount >-----#
    NextHopChainingCount = INT(name='NextHopChainingCount', mode=MODE_TYPE)
    NextHopChainingCount._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< NextPagingAreaScope >-----#
    NextPagingAreaScope = ENUM(name='NextPagingAreaScope', mode=MODE_TYPE)
    NextPagingAreaScope._cont = ASN1Dict([('same', 0), ('changed', 1)])
    NextPagingAreaScope._ext = []
    
    #-----< NGAPIESupportInformationRequestList >-----#
    NGAPIESupportInformationRequestList = SEQ_OF(name='NGAPIESupportInformationRequestList', mode=MODE_TYPE)
    _NGAPIESupportInformationRequestList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGAPIESupportInformationRequestItem')))
    NGAPIESupportInformationRequestList._cont = _NGAPIESupportInformationRequestList__item_
    NGAPIESupportInformationRequestList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< NGAPIESupportInformationRequestItem >-----#
    NGAPIESupportInformationRequestItem = SEQ(name='NGAPIESupportInformationRequestItem', mode=MODE_TYPE)
    _NGAPIESupportInformationRequestItem_ngap_ProtocolIE_Id = INT(name='ngap-ProtocolIE-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    _NGAPIESupportInformationRequestItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NGAPIESupportInformationRequestItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___NGAPIESupportInformationRequestItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____NGAPIESupportInformationRequestItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGAPIESupportInformationRequestItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGAPIESupportInformationRequestItem_iE_Extensions__item__id._const_tab = ____NGAPIESupportInformationRequestItem_iE_Extensions__item__id_tab
    ___NGAPIESupportInformationRequestItem_iE_Extensions__item__id._const_tab_at = None
    ___NGAPIESupportInformationRequestItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___NGAPIESupportInformationRequestItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NGAPIESupportInformationRequestItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGAPIESupportInformationRequestItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGAPIESupportInformationRequestItem_iE_Extensions__item__criticality._const_tab = ____NGAPIESupportInformationRequestItem_iE_Extensions__item__criticality_tab
    ___NGAPIESupportInformationRequestItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NGAPIESupportInformationRequestItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NGAPIESupportInformationRequestItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NGAPIESupportInformationRequestItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGAPIESupportInformationRequestItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGAPIESupportInformationRequestItem_iE_Extensions__item__extensionValue._const_tab = ____NGAPIESupportInformationRequestItem_iE_Extensions__item__extensionValue_tab
    ___NGAPIESupportInformationRequestItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NGAPIESupportInformationRequestItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NGAPIESupportInformationRequestItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NGAPIESupportInformationRequestItem_iE_Extensions__item__id),
        ('criticality', ___NGAPIESupportInformationRequestItem_iE_Extensions__item__criticality),
        ('extensionValue', ___NGAPIESupportInformationRequestItem_iE_Extensions__item__extensionValue),
        ])
    __NGAPIESupportInformationRequestItem_iE_Extensions__item_._ext = None
    _NGAPIESupportInformationRequestItem_iE_Extensions._cont = __NGAPIESupportInformationRequestItem_iE_Extensions__item_
    _NGAPIESupportInformationRequestItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NGAPIESupportInformationRequestItem._cont = ASN1Dict([
        ('ngap-ProtocolIE-Id', _NGAPIESupportInformationRequestItem_ngap_ProtocolIE_Id),
        ('iE-Extensions', _NGAPIESupportInformationRequestItem_iE_Extensions),
        ])
    NGAPIESupportInformationRequestItem._ext = []
    
    #-----< NGAPIESupportInformationRequestItem-ExtIEs >-----#
    NGAPIESupportInformationRequestItem_ExtIEs = CLASS(name='NGAPIESupportInformationRequestItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    NGAPIESupportInformationRequestItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NGAPIESupportInformationResponseList >-----#
    NGAPIESupportInformationResponseList = SEQ_OF(name='NGAPIESupportInformationResponseList', mode=MODE_TYPE)
    _NGAPIESupportInformationResponseList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGAPIESupportInformationResponseItem')))
    NGAPIESupportInformationResponseList._cont = _NGAPIESupportInformationResponseList__item_
    NGAPIESupportInformationResponseList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< NGAPIESupportInformationResponseItem >-----#
    NGAPIESupportInformationResponseItem = SEQ(name='NGAPIESupportInformationResponseItem', mode=MODE_TYPE)
    _NGAPIESupportInformationResponseItem_ngap_ProtocolIE_Id = INT(name='ngap-ProtocolIE-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProtocolIE-ID')))
    _NGAPIESupportInformationResponseItem_ngap_ProtocolIESupportInfo = ENUM(name='ngap-ProtocolIESupportInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGAPIESupportInformationResponseItem_ngap_ProtocolIESupportInfo._cont = ASN1Dict([('supported', 0), ('not-supported', 1)])
    _NGAPIESupportInformationResponseItem_ngap_ProtocolIESupportInfo._ext = []
    _NGAPIESupportInformationResponseItem_ngap_ProtocolIEPresenceInfo = ENUM(name='ngap-ProtocolIEPresenceInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGAPIESupportInformationResponseItem_ngap_ProtocolIEPresenceInfo._cont = ASN1Dict([('present', 0), ('not-present', 1)])
    _NGAPIESupportInformationResponseItem_ngap_ProtocolIEPresenceInfo._ext = []
    _NGAPIESupportInformationResponseItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NGAPIESupportInformationResponseItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___NGAPIESupportInformationResponseItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____NGAPIESupportInformationResponseItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGAPIESupportInformationResponseItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGAPIESupportInformationResponseItem_iE_Extensions__item__id._const_tab = ____NGAPIESupportInformationResponseItem_iE_Extensions__item__id_tab
    ___NGAPIESupportInformationResponseItem_iE_Extensions__item__id._const_tab_at = None
    ___NGAPIESupportInformationResponseItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___NGAPIESupportInformationResponseItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NGAPIESupportInformationResponseItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGAPIESupportInformationResponseItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGAPIESupportInformationResponseItem_iE_Extensions__item__criticality._const_tab = ____NGAPIESupportInformationResponseItem_iE_Extensions__item__criticality_tab
    ___NGAPIESupportInformationResponseItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NGAPIESupportInformationResponseItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NGAPIESupportInformationResponseItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NGAPIESupportInformationResponseItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGAPIESupportInformationResponseItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGAPIESupportInformationResponseItem_iE_Extensions__item__extensionValue._const_tab = ____NGAPIESupportInformationResponseItem_iE_Extensions__item__extensionValue_tab
    ___NGAPIESupportInformationResponseItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NGAPIESupportInformationResponseItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NGAPIESupportInformationResponseItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NGAPIESupportInformationResponseItem_iE_Extensions__item__id),
        ('criticality', ___NGAPIESupportInformationResponseItem_iE_Extensions__item__criticality),
        ('extensionValue', ___NGAPIESupportInformationResponseItem_iE_Extensions__item__extensionValue),
        ])
    __NGAPIESupportInformationResponseItem_iE_Extensions__item_._ext = None
    _NGAPIESupportInformationResponseItem_iE_Extensions._cont = __NGAPIESupportInformationResponseItem_iE_Extensions__item_
    _NGAPIESupportInformationResponseItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NGAPIESupportInformationResponseItem._cont = ASN1Dict([
        ('ngap-ProtocolIE-Id', _NGAPIESupportInformationResponseItem_ngap_ProtocolIE_Id),
        ('ngap-ProtocolIESupportInfo', _NGAPIESupportInformationResponseItem_ngap_ProtocolIESupportInfo),
        ('ngap-ProtocolIEPresenceInfo', _NGAPIESupportInformationResponseItem_ngap_ProtocolIEPresenceInfo),
        ('iE-Extensions', _NGAPIESupportInformationResponseItem_iE_Extensions),
        ])
    NGAPIESupportInformationResponseItem._ext = []
    
    #-----< NGAPIESupportInformationResponseItem-ExtIEs >-----#
    NGAPIESupportInformationResponseItem_ExtIEs = CLASS(name='NGAPIESupportInformationResponseItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    NGAPIESupportInformationResponseItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NgENB-ID >-----#
    NgENB_ID = CHOICE(name='NgENB-ID', mode=MODE_TYPE)
    _NgENB_ID_macroNgENB_ID = BIT_STR(name='macroNgENB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NgENB_ID_macroNgENB_ID._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    _NgENB_ID_shortMacroNgENB_ID = BIT_STR(name='shortMacroNgENB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NgENB_ID_shortMacroNgENB_ID._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _NgENB_ID_longMacroNgENB_ID = BIT_STR(name='longMacroNgENB-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NgENB_ID_longMacroNgENB_ID._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    _NgENB_ID_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __NgENB_ID_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___NgENB_ID_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NgENB_ID_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NgENB_ID_choice_Extensions_id._const_tab = ___NgENB_ID_choice_Extensions_id_tab
    __NgENB_ID_choice_Extensions_id._const_tab_at = None
    __NgENB_ID_choice_Extensions_id._const_tab_id = 'id'
    __NgENB_ID_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___NgENB_ID_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NgENB_ID_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NgENB_ID_choice_Extensions_criticality._const_tab = ___NgENB_ID_choice_Extensions_criticality_tab
    __NgENB_ID_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __NgENB_ID_choice_Extensions_criticality._const_tab_id = 'criticality'
    __NgENB_ID_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___NgENB_ID_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NgENB_ID_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NgENB_ID_choice_Extensions_value._const_tab = ___NgENB_ID_choice_Extensions_value_tab
    __NgENB_ID_choice_Extensions_value._const_tab_at = ('..', 'id')
    __NgENB_ID_choice_Extensions_value._const_tab_id = 'Value'
    _NgENB_ID_choice_Extensions._cont = ASN1Dict([
        ('id', __NgENB_ID_choice_Extensions_id),
        ('criticality', __NgENB_ID_choice_Extensions_criticality),
        ('value', __NgENB_ID_choice_Extensions_value),
        ])
    _NgENB_ID_choice_Extensions._ext = None
    NgENB_ID._cont = ASN1Dict([
        ('macroNgENB-ID', _NgENB_ID_macroNgENB_ID),
        ('shortMacroNgENB-ID', _NgENB_ID_shortMacroNgENB_ID),
        ('longMacroNgENB-ID', _NgENB_ID_longMacroNgENB_ID),
        ('choice-Extensions', _NgENB_ID_choice_Extensions),
        ])
    NgENB_ID._ext = None
    
    #-----< NgENB-ID-ExtIEs >-----#
    NgENB_ID_ExtIEs = CLASS(name='NgENB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    NgENB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NotifySourceNGRANNode >-----#
    NotifySourceNGRANNode = ENUM(name='NotifySourceNGRANNode', mode=MODE_TYPE)
    NotifySourceNGRANNode._cont = ASN1Dict([('notifySource', 0)])
    NotifySourceNGRANNode._ext = []
    
    #-----< NGRAN-CGI >-----#
    NGRAN_CGI = CHOICE(name='NGRAN-CGI', mode=MODE_TYPE)
    _NGRAN_CGI_nR_CGI = SEQ(name='nR-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    _NGRAN_CGI_eUTRA_CGI = SEQ(name='eUTRA-CGI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _NGRAN_CGI_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __NGRAN_CGI_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___NGRAN_CGI_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NGRAN_CGI_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NGRAN_CGI_choice_Extensions_id._const_tab = ___NGRAN_CGI_choice_Extensions_id_tab
    __NGRAN_CGI_choice_Extensions_id._const_tab_at = None
    __NGRAN_CGI_choice_Extensions_id._const_tab_id = 'id'
    __NGRAN_CGI_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___NGRAN_CGI_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NGRAN_CGI_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NGRAN_CGI_choice_Extensions_criticality._const_tab = ___NGRAN_CGI_choice_Extensions_criticality_tab
    __NGRAN_CGI_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __NGRAN_CGI_choice_Extensions_criticality._const_tab_id = 'criticality'
    __NGRAN_CGI_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___NGRAN_CGI_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NGRAN_CGI_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NGRAN_CGI_choice_Extensions_value._const_tab = ___NGRAN_CGI_choice_Extensions_value_tab
    __NGRAN_CGI_choice_Extensions_value._const_tab_at = ('..', 'id')
    __NGRAN_CGI_choice_Extensions_value._const_tab_id = 'Value'
    _NGRAN_CGI_choice_Extensions._cont = ASN1Dict([
        ('id', __NGRAN_CGI_choice_Extensions_id),
        ('criticality', __NGRAN_CGI_choice_Extensions_criticality),
        ('value', __NGRAN_CGI_choice_Extensions_value),
        ])
    _NGRAN_CGI_choice_Extensions._ext = None
    NGRAN_CGI._cont = ASN1Dict([
        ('nR-CGI', _NGRAN_CGI_nR_CGI),
        ('eUTRA-CGI', _NGRAN_CGI_eUTRA_CGI),
        ('choice-Extensions', _NGRAN_CGI_choice_Extensions),
        ])
    NGRAN_CGI._ext = None
    
    #-----< NGRAN-CGI-ExtIEs >-----#
    NGRAN_CGI_ExtIEs = CLASS(name='NGRAN-CGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    NGRAN_CGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NGRAN-TNLAssociationToRemoveList >-----#
    NGRAN_TNLAssociationToRemoveList = SEQ_OF(name='NGRAN-TNLAssociationToRemoveList', mode=MODE_TYPE)
    _NGRAN_TNLAssociationToRemoveList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-TNLAssociationToRemoveItem')))
    NGRAN_TNLAssociationToRemoveList._cont = _NGRAN_TNLAssociationToRemoveList__item_
    NGRAN_TNLAssociationToRemoveList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< NGRAN-TNLAssociationToRemoveItem >-----#
    NGRAN_TNLAssociationToRemoveItem = SEQ(name='NGRAN-TNLAssociationToRemoveItem', mode=MODE_TYPE)
    _NGRAN_TNLAssociationToRemoveItem_tNLAssociationTransportLayerAddress = CHOICE(name='tNLAssociationTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CPTransportLayerInformation')))
    _NGRAN_TNLAssociationToRemoveItem_tNLAssociationTransportLayerAddressAMF = CHOICE(name='tNLAssociationTransportLayerAddressAMF', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CPTransportLayerInformation')), opt=True)
    _NGRAN_TNLAssociationToRemoveItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__id._const_tab = ____NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__id_tab
    ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__id._const_tab_at = None
    ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__criticality._const_tab = ____NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__criticality_tab
    ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue._const_tab = ____NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue_tab
    ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__id),
        ('criticality', ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__criticality),
        ('extensionValue', ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue),
        ])
    __NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item_._ext = None
    _NGRAN_TNLAssociationToRemoveItem_iE_Extensions._cont = __NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item_
    _NGRAN_TNLAssociationToRemoveItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NGRAN_TNLAssociationToRemoveItem._cont = ASN1Dict([
        ('tNLAssociationTransportLayerAddress', _NGRAN_TNLAssociationToRemoveItem_tNLAssociationTransportLayerAddress),
        ('tNLAssociationTransportLayerAddressAMF', _NGRAN_TNLAssociationToRemoveItem_tNLAssociationTransportLayerAddressAMF),
        ('iE-Extensions', _NGRAN_TNLAssociationToRemoveItem_iE_Extensions),
        ])
    NGRAN_TNLAssociationToRemoveItem._ext = None
    
    #-----< NGRAN-TNLAssociationToRemoveItem-ExtIEs >-----#
    NGRAN_TNLAssociationToRemoveItem_ExtIEs = CLASS(name='NGRAN-TNLAssociationToRemoveItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    NGRAN_TNLAssociationToRemoveItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NGRANTraceID >-----#
    NGRANTraceID = OCT_STR(name='NGRANTraceID', mode=MODE_TYPE)
    NGRANTraceID._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< NID >-----#
    NID = BIT_STR(name='NID', mode=MODE_TYPE)
    NID._const_sz = ASN1Set(rv=[44], rr=[], ev=None, er=[])
    
    #-----< NonDynamic5QIDescriptor >-----#
    NonDynamic5QIDescriptor = SEQ(name='NonDynamic5QIDescriptor', mode=MODE_TYPE)
    _NonDynamic5QIDescriptor_fiveQI = INT(name='fiveQI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FiveQI')))
    _NonDynamic5QIDescriptor_priorityLevelQos = INT(name='priorityLevelQos', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PriorityLevelQos')), opt=True)
    _NonDynamic5QIDescriptor_averagingWindow = INT(name='averagingWindow', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AveragingWindow')), opt=True)
    _NonDynamic5QIDescriptor_maximumDataBurstVolume = INT(name='maximumDataBurstVolume', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MaximumDataBurstVolume')), opt=True)
    _NonDynamic5QIDescriptor_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NonDynamic5QIDescriptor_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___NonDynamic5QIDescriptor_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    _____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    ____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 187), ('criticality', 'ignore'), ('Extension', _____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 188), ('criticality', 'ignore'), ('Extension', _____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___NonDynamic5QIDescriptor_iE_Extensions__item__id._const_tab = ____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___NonDynamic5QIDescriptor_iE_Extensions__item__id._const_tab_at = None
    ___NonDynamic5QIDescriptor_iE_Extensions__item__id._const_tab_id = 'id'
    ___NonDynamic5QIDescriptor_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___NonDynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab = ____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___NonDynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NonDynamic5QIDescriptor_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NonDynamic5QIDescriptor_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___NonDynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab = ____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab
    ___NonDynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NonDynamic5QIDescriptor_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NonDynamic5QIDescriptor_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NonDynamic5QIDescriptor_iE_Extensions__item__id),
        ('criticality', ___NonDynamic5QIDescriptor_iE_Extensions__item__criticality),
        ('extensionValue', ___NonDynamic5QIDescriptor_iE_Extensions__item__extensionValue),
        ])
    __NonDynamic5QIDescriptor_iE_Extensions__item_._ext = None
    _NonDynamic5QIDescriptor_iE_Extensions._cont = __NonDynamic5QIDescriptor_iE_Extensions__item_
    _NonDynamic5QIDescriptor_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NonDynamic5QIDescriptor._cont = ASN1Dict([
        ('fiveQI', _NonDynamic5QIDescriptor_fiveQI),
        ('priorityLevelQos', _NonDynamic5QIDescriptor_priorityLevelQos),
        ('averagingWindow', _NonDynamic5QIDescriptor_averagingWindow),
        ('maximumDataBurstVolume', _NonDynamic5QIDescriptor_maximumDataBurstVolume),
        ('iE-Extensions', _NonDynamic5QIDescriptor_iE_Extensions),
        ])
    NonDynamic5QIDescriptor._ext = []
    
    #-----< NonDynamic5QIDescriptor-ExtIEs >-----#
    NonDynamic5QIDescriptor_ExtIEs = CLASS(name='NonDynamic5QIDescriptor-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _NonDynamic5QIDescriptor_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    _NonDynamic5QIDescriptor_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    NonDynamic5QIDescriptor_ExtIEs._val = ASN1Set(rv=[dict([('id', 187), ('criticality', 'ignore'), ('Extension', _NonDynamic5QIDescriptor_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 188), ('criticality', 'ignore'), ('Extension', _NonDynamic5QIDescriptor_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< NotAllowedTACs >-----#
    NotAllowedTACs = SEQ_OF(name='NotAllowedTACs', mode=MODE_TYPE)
    _NotAllowedTACs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAC')))
    NotAllowedTACs._cont = _NotAllowedTACs__item_
    NotAllowedTACs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< NotificationCause >-----#
    NotificationCause = ENUM(name='NotificationCause', mode=MODE_TYPE)
    NotificationCause._cont = ASN1Dict([('fulfilled', 0), ('not-fulfilled', 1)])
    NotificationCause._ext = []
    
    #-----< NotificationControl >-----#
    NotificationControl = ENUM(name='NotificationControl', mode=MODE_TYPE)
    NotificationControl._cont = ASN1Dict([('notification-requested', 0)])
    NotificationControl._ext = []
    
    #-----< NPN-AccessInformation >-----#
    NPN_AccessInformation = CHOICE(name='NPN-AccessInformation', mode=MODE_TYPE)
    _NPN_AccessInformation_pNI_NPN_Access_Information = SEQ_OF(name='pNI-NPN-Access-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CellCAGList')))
    _NPN_AccessInformation_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __NPN_AccessInformation_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___NPN_AccessInformation_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NPN_AccessInformation_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPN_AccessInformation_choice_Extensions_id._const_tab = ___NPN_AccessInformation_choice_Extensions_id_tab
    __NPN_AccessInformation_choice_Extensions_id._const_tab_at = None
    __NPN_AccessInformation_choice_Extensions_id._const_tab_id = 'id'
    __NPN_AccessInformation_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___NPN_AccessInformation_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NPN_AccessInformation_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPN_AccessInformation_choice_Extensions_criticality._const_tab = ___NPN_AccessInformation_choice_Extensions_criticality_tab
    __NPN_AccessInformation_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __NPN_AccessInformation_choice_Extensions_criticality._const_tab_id = 'criticality'
    __NPN_AccessInformation_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___NPN_AccessInformation_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NPN_AccessInformation_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPN_AccessInformation_choice_Extensions_value._const_tab = ___NPN_AccessInformation_choice_Extensions_value_tab
    __NPN_AccessInformation_choice_Extensions_value._const_tab_at = ('..', 'id')
    __NPN_AccessInformation_choice_Extensions_value._const_tab_id = 'Value'
    _NPN_AccessInformation_choice_Extensions._cont = ASN1Dict([
        ('id', __NPN_AccessInformation_choice_Extensions_id),
        ('criticality', __NPN_AccessInformation_choice_Extensions_criticality),
        ('value', __NPN_AccessInformation_choice_Extensions_value),
        ])
    _NPN_AccessInformation_choice_Extensions._ext = None
    NPN_AccessInformation._cont = ASN1Dict([
        ('pNI-NPN-Access-Information', _NPN_AccessInformation_pNI_NPN_Access_Information),
        ('choice-Extensions', _NPN_AccessInformation_choice_Extensions),
        ])
    NPN_AccessInformation._ext = None
    
    #-----< NPN-AccessInformation-ExtIEs >-----#
    NPN_AccessInformation_ExtIEs = CLASS(name='NPN-AccessInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    NPN_AccessInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NPN-MobilityInformation >-----#
    NPN_MobilityInformation = CHOICE(name='NPN-MobilityInformation', mode=MODE_TYPE)
    _NPN_MobilityInformation_sNPN_MobilityInformation = SEQ(name='sNPN-MobilityInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SNPN-MobilityInformation')))
    _NPN_MobilityInformation_pNI_NPN_MobilityInformation = SEQ(name='pNI-NPN-MobilityInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PNI-NPN-MobilityInformation')))
    _NPN_MobilityInformation_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __NPN_MobilityInformation_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___NPN_MobilityInformation_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NPN_MobilityInformation_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPN_MobilityInformation_choice_Extensions_id._const_tab = ___NPN_MobilityInformation_choice_Extensions_id_tab
    __NPN_MobilityInformation_choice_Extensions_id._const_tab_at = None
    __NPN_MobilityInformation_choice_Extensions_id._const_tab_id = 'id'
    __NPN_MobilityInformation_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___NPN_MobilityInformation_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NPN_MobilityInformation_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPN_MobilityInformation_choice_Extensions_criticality._const_tab = ___NPN_MobilityInformation_choice_Extensions_criticality_tab
    __NPN_MobilityInformation_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __NPN_MobilityInformation_choice_Extensions_criticality._const_tab_id = 'criticality'
    __NPN_MobilityInformation_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___NPN_MobilityInformation_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NPN_MobilityInformation_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPN_MobilityInformation_choice_Extensions_value._const_tab = ___NPN_MobilityInformation_choice_Extensions_value_tab
    __NPN_MobilityInformation_choice_Extensions_value._const_tab_at = ('..', 'id')
    __NPN_MobilityInformation_choice_Extensions_value._const_tab_id = 'Value'
    _NPN_MobilityInformation_choice_Extensions._cont = ASN1Dict([
        ('id', __NPN_MobilityInformation_choice_Extensions_id),
        ('criticality', __NPN_MobilityInformation_choice_Extensions_criticality),
        ('value', __NPN_MobilityInformation_choice_Extensions_value),
        ])
    _NPN_MobilityInformation_choice_Extensions._ext = None
    NPN_MobilityInformation._cont = ASN1Dict([
        ('sNPN-MobilityInformation', _NPN_MobilityInformation_sNPN_MobilityInformation),
        ('pNI-NPN-MobilityInformation', _NPN_MobilityInformation_pNI_NPN_MobilityInformation),
        ('choice-Extensions', _NPN_MobilityInformation_choice_Extensions),
        ])
    NPN_MobilityInformation._ext = None
    
    #-----< NPN-MobilityInformation-ExtIEs >-----#
    NPN_MobilityInformation_ExtIEs = CLASS(name='NPN-MobilityInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    NPN_MobilityInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NPN-PagingAssistanceInformation >-----#
    NPN_PagingAssistanceInformation = CHOICE(name='NPN-PagingAssistanceInformation', mode=MODE_TYPE)
    _NPN_PagingAssistanceInformation_pNI_NPN_PagingAssistance = SEQ_OF(name='pNI-NPN-PagingAssistance', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Allowed-PNI-NPN-List')))
    _NPN_PagingAssistanceInformation_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __NPN_PagingAssistanceInformation_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___NPN_PagingAssistanceInformation_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NPN_PagingAssistanceInformation_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPN_PagingAssistanceInformation_choice_Extensions_id._const_tab = ___NPN_PagingAssistanceInformation_choice_Extensions_id_tab
    __NPN_PagingAssistanceInformation_choice_Extensions_id._const_tab_at = None
    __NPN_PagingAssistanceInformation_choice_Extensions_id._const_tab_id = 'id'
    __NPN_PagingAssistanceInformation_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___NPN_PagingAssistanceInformation_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NPN_PagingAssistanceInformation_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPN_PagingAssistanceInformation_choice_Extensions_criticality._const_tab = ___NPN_PagingAssistanceInformation_choice_Extensions_criticality_tab
    __NPN_PagingAssistanceInformation_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __NPN_PagingAssistanceInformation_choice_Extensions_criticality._const_tab_id = 'criticality'
    __NPN_PagingAssistanceInformation_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___NPN_PagingAssistanceInformation_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NPN_PagingAssistanceInformation_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPN_PagingAssistanceInformation_choice_Extensions_value._const_tab = ___NPN_PagingAssistanceInformation_choice_Extensions_value_tab
    __NPN_PagingAssistanceInformation_choice_Extensions_value._const_tab_at = ('..', 'id')
    __NPN_PagingAssistanceInformation_choice_Extensions_value._const_tab_id = 'Value'
    _NPN_PagingAssistanceInformation_choice_Extensions._cont = ASN1Dict([
        ('id', __NPN_PagingAssistanceInformation_choice_Extensions_id),
        ('criticality', __NPN_PagingAssistanceInformation_choice_Extensions_criticality),
        ('value', __NPN_PagingAssistanceInformation_choice_Extensions_value),
        ])
    _NPN_PagingAssistanceInformation_choice_Extensions._ext = None
    NPN_PagingAssistanceInformation._cont = ASN1Dict([
        ('pNI-NPN-PagingAssistance', _NPN_PagingAssistanceInformation_pNI_NPN_PagingAssistance),
        ('choice-Extensions', _NPN_PagingAssistanceInformation_choice_Extensions),
        ])
    NPN_PagingAssistanceInformation._ext = None
    
    #-----< NPN-PagingAssistanceInformation-ExtIEs >-----#
    NPN_PagingAssistanceInformation_ExtIEs = CLASS(name='NPN-PagingAssistanceInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    NPN_PagingAssistanceInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NPN-Support >-----#
    NPN_Support = CHOICE(name='NPN-Support', mode=MODE_TYPE)
    _NPN_Support_sNPN = BIT_STR(name='sNPN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NID')))
    _NPN_Support_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __NPN_Support_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___NPN_Support_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NPN_Support_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPN_Support_choice_Extensions_id._const_tab = ___NPN_Support_choice_Extensions_id_tab
    __NPN_Support_choice_Extensions_id._const_tab_at = None
    __NPN_Support_choice_Extensions_id._const_tab_id = 'id'
    __NPN_Support_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___NPN_Support_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NPN_Support_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPN_Support_choice_Extensions_criticality._const_tab = ___NPN_Support_choice_Extensions_criticality_tab
    __NPN_Support_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __NPN_Support_choice_Extensions_criticality._const_tab_id = 'criticality'
    __NPN_Support_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___NPN_Support_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___NPN_Support_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NPN_Support_choice_Extensions_value._const_tab = ___NPN_Support_choice_Extensions_value_tab
    __NPN_Support_choice_Extensions_value._const_tab_at = ('..', 'id')
    __NPN_Support_choice_Extensions_value._const_tab_id = 'Value'
    _NPN_Support_choice_Extensions._cont = ASN1Dict([
        ('id', __NPN_Support_choice_Extensions_id),
        ('criticality', __NPN_Support_choice_Extensions_criticality),
        ('value', __NPN_Support_choice_Extensions_value),
        ])
    _NPN_Support_choice_Extensions._ext = None
    NPN_Support._cont = ASN1Dict([
        ('sNPN', _NPN_Support_sNPN),
        ('choice-Extensions', _NPN_Support_choice_Extensions),
        ])
    NPN_Support._ext = None
    
    #-----< NPN-Support-ExtIEs >-----#
    NPN_Support_ExtIEs = CLASS(name='NPN-Support-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    NPN_Support_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRCellIdentity >-----#
    NRCellIdentity = BIT_STR(name='NRCellIdentity', mode=MODE_TYPE)
    NRCellIdentity._const_sz = ASN1Set(rv=[36], rr=[], ev=None, er=[])
    
    #-----< NR-CGI >-----#
    NR_CGI = SEQ(name='NR-CGI', mode=MODE_TYPE)
    _NR_CGI_pLMNIdentity = OCT_STR(name='pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _NR_CGI_nRCellIdentity = BIT_STR(name='nRCellIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NRCellIdentity')))
    _NR_CGI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NR_CGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___NR_CGI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____NR_CGI_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NR_CGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_CGI_iE_Extensions__item__id._const_tab = ____NR_CGI_iE_Extensions__item__id_tab
    ___NR_CGI_iE_Extensions__item__id._const_tab_at = None
    ___NR_CGI_iE_Extensions__item__id._const_tab_id = 'id'
    ___NR_CGI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NR_CGI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NR_CGI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_CGI_iE_Extensions__item__criticality._const_tab = ____NR_CGI_iE_Extensions__item__criticality_tab
    ___NR_CGI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NR_CGI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NR_CGI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NR_CGI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NR_CGI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_CGI_iE_Extensions__item__extensionValue._const_tab = ____NR_CGI_iE_Extensions__item__extensionValue_tab
    ___NR_CGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NR_CGI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NR_CGI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NR_CGI_iE_Extensions__item__id),
        ('criticality', ___NR_CGI_iE_Extensions__item__criticality),
        ('extensionValue', ___NR_CGI_iE_Extensions__item__extensionValue),
        ])
    __NR_CGI_iE_Extensions__item_._ext = None
    _NR_CGI_iE_Extensions._cont = __NR_CGI_iE_Extensions__item_
    _NR_CGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NR_CGI._cont = ASN1Dict([
        ('pLMNIdentity', _NR_CGI_pLMNIdentity),
        ('nRCellIdentity', _NR_CGI_nRCellIdentity),
        ('iE-Extensions', _NR_CGI_iE_Extensions),
        ])
    NR_CGI._ext = []
    
    #-----< NR-CGI-ExtIEs >-----#
    NR_CGI_ExtIEs = CLASS(name='NR-CGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    NR_CGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NR-CGIList >-----#
    NR_CGIList = SEQ_OF(name='NR-CGIList', mode=MODE_TYPE)
    _NR_CGIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    NR_CGIList._cont = _NR_CGIList__item_
    NR_CGIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< NR-CGIListForWarning >-----#
    NR_CGIListForWarning = SEQ_OF(name='NR-CGIListForWarning', mode=MODE_TYPE)
    _NR_CGIListForWarning__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    NR_CGIListForWarning._cont = _NR_CGIListForWarning__item_
    NR_CGIListForWarning._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< NR-PagingeDRXInformation >-----#
    NR_PagingeDRXInformation = SEQ(name='NR-PagingeDRXInformation', mode=MODE_TYPE)
    _NR_PagingeDRXInformation_nR_paging_eDRX_Cycle = ENUM(name='nR-paging-eDRX-Cycle', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NR-Paging-eDRX-Cycle')))
    _NR_PagingeDRXInformation_nR_paging_Time_Window = ENUM(name='nR-paging-Time-Window', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NR-Paging-Time-Window')), opt=True)
    _NR_PagingeDRXInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NR_PagingeDRXInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___NR_PagingeDRXInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____NR_PagingeDRXInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NR_PagingeDRXInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PagingeDRXInformation_iE_Extensions__item__id._const_tab = ____NR_PagingeDRXInformation_iE_Extensions__item__id_tab
    ___NR_PagingeDRXInformation_iE_Extensions__item__id._const_tab_at = None
    ___NR_PagingeDRXInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___NR_PagingeDRXInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NR_PagingeDRXInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NR_PagingeDRXInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PagingeDRXInformation_iE_Extensions__item__criticality._const_tab = ____NR_PagingeDRXInformation_iE_Extensions__item__criticality_tab
    ___NR_PagingeDRXInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NR_PagingeDRXInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NR_PagingeDRXInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NR_PagingeDRXInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NR_PagingeDRXInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PagingeDRXInformation_iE_Extensions__item__extensionValue._const_tab = ____NR_PagingeDRXInformation_iE_Extensions__item__extensionValue_tab
    ___NR_PagingeDRXInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NR_PagingeDRXInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NR_PagingeDRXInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NR_PagingeDRXInformation_iE_Extensions__item__id),
        ('criticality', ___NR_PagingeDRXInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___NR_PagingeDRXInformation_iE_Extensions__item__extensionValue),
        ])
    __NR_PagingeDRXInformation_iE_Extensions__item_._ext = None
    _NR_PagingeDRXInformation_iE_Extensions._cont = __NR_PagingeDRXInformation_iE_Extensions__item_
    _NR_PagingeDRXInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NR_PagingeDRXInformation._cont = ASN1Dict([
        ('nR-paging-eDRX-Cycle', _NR_PagingeDRXInformation_nR_paging_eDRX_Cycle),
        ('nR-paging-Time-Window', _NR_PagingeDRXInformation_nR_paging_Time_Window),
        ('iE-Extensions', _NR_PagingeDRXInformation_iE_Extensions),
        ])
    NR_PagingeDRXInformation._ext = []
    
    #-----< NR-PagingeDRXInformation-ExtIEs >-----#
    NR_PagingeDRXInformation_ExtIEs = CLASS(name='NR-PagingeDRXInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    NR_PagingeDRXInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NR-Paging-eDRX-Cycle >-----#
    NR_Paging_eDRX_Cycle = ENUM(name='NR-Paging-eDRX-Cycle', mode=MODE_TYPE)
    NR_Paging_eDRX_Cycle._cont = ASN1Dict([('hfquarter', 0), ('hfhalf', 1), ('hf1', 2), ('hf2', 3), ('hf4', 4), ('hf8', 5), ('hf16', 6), ('hf32', 7), ('hf64', 8), ('hf128', 9), ('hf256', 10), ('hf512', 11), ('hf1024', 12)])
    NR_Paging_eDRX_Cycle._ext = []
    
    #-----< NR-Paging-Time-Window >-----#
    NR_Paging_Time_Window = ENUM(name='NR-Paging-Time-Window', mode=MODE_TYPE)
    NR_Paging_Time_Window._cont = ASN1Dict([('s1', 0), ('s2', 1), ('s3', 2), ('s4', 3), ('s5', 4), ('s6', 5), ('s7', 6), ('s8', 7), ('s9', 8), ('s10', 9), ('s11', 10), ('s12', 11), ('s13', 12), ('s14', 13), ('s15', 14), ('s16', 15), ('s17', 16), ('s18', 17), ('s19', 18), ('s20', 19), ('s21', 20), ('s22', 21), ('s23', 22), ('s24', 23), ('s25', 24), ('s26', 25), ('s27', 26), ('s28', 27), ('s29', 28), ('s30', 29), ('s31', 30), ('s32', 31)])
    NR_Paging_Time_Window._ext = ['s17', 's18', 's19', 's20', 's21', 's22', 's23', 's24', 's25', 's26', 's27', 's28', 's29', 's30', 's31', 's32']
    
    #-----< NRencryptionAlgorithms >-----#
    NRencryptionAlgorithms = BIT_STR(name='NRencryptionAlgorithms', mode=MODE_TYPE)
    NRencryptionAlgorithms._const_sz = ASN1Set(rv=[16], rr=[], ev=[], er=[])
    
    #-----< NRintegrityProtectionAlgorithms >-----#
    NRintegrityProtectionAlgorithms = BIT_STR(name='NRintegrityProtectionAlgorithms', mode=MODE_TYPE)
    NRintegrityProtectionAlgorithms._const_sz = ASN1Set(rv=[16], rr=[], ev=[], er=[])
    
    #-----< NRMobilityHistoryReport >-----#
    NRMobilityHistoryReport = OCT_STR(name='NRMobilityHistoryReport', mode=MODE_TYPE)
    
    #-----< NRPPa-PDU >-----#
    NRPPa_PDU = OCT_STR(name='NRPPa-PDU', mode=MODE_TYPE)
    
    #-----< NRUERLFReportContainer >-----#
    NRUERLFReportContainer = OCT_STR(name='NRUERLFReportContainer', mode=MODE_TYPE)
    
    #-----< NRNTNTAIInformation >-----#
    NRNTNTAIInformation = SEQ(name='NRNTNTAIInformation', mode=MODE_TYPE)
    _NRNTNTAIInformation_servingPLMN = OCT_STR(name='servingPLMN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _NRNTNTAIInformation_tACListInNRNTN = SEQ_OF(name='tACListInNRNTN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TACListInNRNTN')))
    _NRNTNTAIInformation_uELocationDerivedTACInNRNTN = OCT_STR(name='uELocationDerivedTACInNRNTN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAC')), opt=True)
    _NRNTNTAIInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRNTNTAIInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___NRNTNTAIInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____NRNTNTAIInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRNTNTAIInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRNTNTAIInformation_iE_Extensions__item__id._const_tab = ____NRNTNTAIInformation_iE_Extensions__item__id_tab
    ___NRNTNTAIInformation_iE_Extensions__item__id._const_tab_at = None
    ___NRNTNTAIInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___NRNTNTAIInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRNTNTAIInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRNTNTAIInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRNTNTAIInformation_iE_Extensions__item__criticality._const_tab = ____NRNTNTAIInformation_iE_Extensions__item__criticality_tab
    ___NRNTNTAIInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NRNTNTAIInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NRNTNTAIInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRNTNTAIInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRNTNTAIInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRNTNTAIInformation_iE_Extensions__item__extensionValue._const_tab = ____NRNTNTAIInformation_iE_Extensions__item__extensionValue_tab
    ___NRNTNTAIInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRNTNTAIInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NRNTNTAIInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NRNTNTAIInformation_iE_Extensions__item__id),
        ('criticality', ___NRNTNTAIInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___NRNTNTAIInformation_iE_Extensions__item__extensionValue),
        ])
    __NRNTNTAIInformation_iE_Extensions__item_._ext = None
    _NRNTNTAIInformation_iE_Extensions._cont = __NRNTNTAIInformation_iE_Extensions__item_
    _NRNTNTAIInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRNTNTAIInformation._cont = ASN1Dict([
        ('servingPLMN', _NRNTNTAIInformation_servingPLMN),
        ('tACListInNRNTN', _NRNTNTAIInformation_tACListInNRNTN),
        ('uELocationDerivedTACInNRNTN', _NRNTNTAIInformation_uELocationDerivedTACInNRNTN),
        ('iE-Extensions', _NRNTNTAIInformation_iE_Extensions),
        ])
    NRNTNTAIInformation._ext = []
    
    #-----< NRNTNTAIInformation-ExtIEs >-----#
    NRNTNTAIInformation_ExtIEs = CLASS(name='NRNTNTAIInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    NRNTNTAIInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NumberOfBroadcasts >-----#
    NumberOfBroadcasts = INT(name='NumberOfBroadcasts', mode=MODE_TYPE)
    NumberOfBroadcasts._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< NumberOfBroadcastsRequested >-----#
    NumberOfBroadcastsRequested = INT(name='NumberOfBroadcastsRequested', mode=MODE_TYPE)
    NumberOfBroadcastsRequested._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< NRARFCN >-----#
    NRARFCN = INT(name='NRARFCN', mode=MODE_TYPE)
    NRARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    
    #-----< NRFrequencyBand >-----#
    NRFrequencyBand = INT(name='NRFrequencyBand', mode=MODE_TYPE)
    NRFrequencyBand._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=[], er=[])
    
    #-----< NRFrequencyBand-List >-----#
    NRFrequencyBand_List = SEQ_OF(name='NRFrequencyBand-List', mode=MODE_TYPE)
    _NRFrequencyBand_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRFrequencyBandItem')))
    NRFrequencyBand_List._cont = _NRFrequencyBand_List__item_
    NRFrequencyBand_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< NRFrequencyBandItem >-----#
    NRFrequencyBandItem = SEQ(name='NRFrequencyBandItem', mode=MODE_TYPE)
    _NRFrequencyBandItem_nr_frequency_band = INT(name='nr-frequency-band', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NRFrequencyBand')))
    _NRFrequencyBandItem_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRFrequencyBandItem_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___NRFrequencyBandItem_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____NRFrequencyBandItem_iE_Extension__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRFrequencyBandItem_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRFrequencyBandItem_iE_Extension__item__id._const_tab = ____NRFrequencyBandItem_iE_Extension__item__id_tab
    ___NRFrequencyBandItem_iE_Extension__item__id._const_tab_at = None
    ___NRFrequencyBandItem_iE_Extension__item__id._const_tab_id = 'id'
    ___NRFrequencyBandItem_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRFrequencyBandItem_iE_Extension__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRFrequencyBandItem_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRFrequencyBandItem_iE_Extension__item__criticality._const_tab = ____NRFrequencyBandItem_iE_Extension__item__criticality_tab
    ___NRFrequencyBandItem_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___NRFrequencyBandItem_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___NRFrequencyBandItem_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRFrequencyBandItem_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRFrequencyBandItem_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRFrequencyBandItem_iE_Extension__item__extensionValue._const_tab = ____NRFrequencyBandItem_iE_Extension__item__extensionValue_tab
    ___NRFrequencyBandItem_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRFrequencyBandItem_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __NRFrequencyBandItem_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___NRFrequencyBandItem_iE_Extension__item__id),
        ('criticality', ___NRFrequencyBandItem_iE_Extension__item__criticality),
        ('extensionValue', ___NRFrequencyBandItem_iE_Extension__item__extensionValue),
        ])
    __NRFrequencyBandItem_iE_Extension__item_._ext = None
    _NRFrequencyBandItem_iE_Extension._cont = __NRFrequencyBandItem_iE_Extension__item_
    _NRFrequencyBandItem_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRFrequencyBandItem._cont = ASN1Dict([
        ('nr-frequency-band', _NRFrequencyBandItem_nr_frequency_band),
        ('iE-Extension', _NRFrequencyBandItem_iE_Extension),
        ])
    NRFrequencyBandItem._ext = []
    
    #-----< NRFrequencyBandItem-ExtIEs >-----#
    NRFrequencyBandItem_ExtIEs = CLASS(name='NRFrequencyBandItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    NRFrequencyBandItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRFrequencyInfo >-----#
    NRFrequencyInfo = SEQ(name='NRFrequencyInfo', mode=MODE_TYPE)
    _NRFrequencyInfo_nrARFCN = INT(name='nrARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NRARFCN')))
    _NRFrequencyInfo_frequencyBand_List = SEQ_OF(name='frequencyBand-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NRFrequencyBand-List')))
    _NRFrequencyInfo_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRFrequencyInfo_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___NRFrequencyInfo_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____NRFrequencyInfo_iE_Extension__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRFrequencyInfo_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRFrequencyInfo_iE_Extension__item__id._const_tab = ____NRFrequencyInfo_iE_Extension__item__id_tab
    ___NRFrequencyInfo_iE_Extension__item__id._const_tab_at = None
    ___NRFrequencyInfo_iE_Extension__item__id._const_tab_id = 'id'
    ___NRFrequencyInfo_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRFrequencyInfo_iE_Extension__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRFrequencyInfo_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRFrequencyInfo_iE_Extension__item__criticality._const_tab = ____NRFrequencyInfo_iE_Extension__item__criticality_tab
    ___NRFrequencyInfo_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___NRFrequencyInfo_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___NRFrequencyInfo_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRFrequencyInfo_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRFrequencyInfo_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRFrequencyInfo_iE_Extension__item__extensionValue._const_tab = ____NRFrequencyInfo_iE_Extension__item__extensionValue_tab
    ___NRFrequencyInfo_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRFrequencyInfo_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __NRFrequencyInfo_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___NRFrequencyInfo_iE_Extension__item__id),
        ('criticality', ___NRFrequencyInfo_iE_Extension__item__criticality),
        ('extensionValue', ___NRFrequencyInfo_iE_Extension__item__extensionValue),
        ])
    __NRFrequencyInfo_iE_Extension__item_._ext = None
    _NRFrequencyInfo_iE_Extension._cont = __NRFrequencyInfo_iE_Extension__item_
    _NRFrequencyInfo_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRFrequencyInfo._cont = ASN1Dict([
        ('nrARFCN', _NRFrequencyInfo_nrARFCN),
        ('frequencyBand-List', _NRFrequencyInfo_frequencyBand_List),
        ('iE-Extension', _NRFrequencyInfo_iE_Extension),
        ])
    NRFrequencyInfo._ext = []
    
    #-----< NRFrequencyInfo-ExtIEs >-----#
    NRFrequencyInfo_ExtIEs = CLASS(name='NRFrequencyInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    NRFrequencyInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NR-PCI >-----#
    NR_PCI = INT(name='NR-PCI', mode=MODE_TYPE)
    NR_PCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1007)], ev=[], er=[])
    
    #-----< NRV2XServicesAuthorized >-----#
    NRV2XServicesAuthorized = SEQ(name='NRV2XServicesAuthorized', mode=MODE_TYPE)
    _NRV2XServicesAuthorized_vehicleUE = ENUM(name='vehicleUE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'VehicleUE')), opt=True)
    _NRV2XServicesAuthorized_pedestrianUE = ENUM(name='pedestrianUE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PedestrianUE')), opt=True)
    _NRV2XServicesAuthorized_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRV2XServicesAuthorized_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___NRV2XServicesAuthorized_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRV2XServicesAuthorized_iE_Extensions__item__id._const_tab = ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab
    ___NRV2XServicesAuthorized_iE_Extensions__item__id._const_tab_at = None
    ___NRV2XServicesAuthorized_iE_Extensions__item__id._const_tab_id = 'id'
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab = ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab = ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NRV2XServicesAuthorized_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NRV2XServicesAuthorized_iE_Extensions__item__id),
        ('criticality', ___NRV2XServicesAuthorized_iE_Extensions__item__criticality),
        ('extensionValue', ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue),
        ])
    __NRV2XServicesAuthorized_iE_Extensions__item_._ext = None
    _NRV2XServicesAuthorized_iE_Extensions._cont = __NRV2XServicesAuthorized_iE_Extensions__item_
    _NRV2XServicesAuthorized_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRV2XServicesAuthorized._cont = ASN1Dict([
        ('vehicleUE', _NRV2XServicesAuthorized_vehicleUE),
        ('pedestrianUE', _NRV2XServicesAuthorized_pedestrianUE),
        ('iE-Extensions', _NRV2XServicesAuthorized_iE_Extensions),
        ])
    NRV2XServicesAuthorized._ext = []
    
    #-----< NRV2XServicesAuthorized-ExtIEs >-----#
    NRV2XServicesAuthorized_ExtIEs = CLASS(name='NRV2XServicesAuthorized-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    NRV2XServicesAuthorized_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< VehicleUE >-----#
    VehicleUE = ENUM(name='VehicleUE', mode=MODE_TYPE)
    VehicleUE._cont = ASN1Dict([('authorized', 0), ('not-authorized', 1)])
    VehicleUE._ext = []
    
    #-----< PedestrianUE >-----#
    PedestrianUE = ENUM(name='PedestrianUE', mode=MODE_TYPE)
    PedestrianUE._cont = ASN1Dict([('authorized', 0), ('not-authorized', 1)])
    PedestrianUE._ext = []
    
    #-----< NRUESidelinkAggregateMaximumBitrate >-----#
    NRUESidelinkAggregateMaximumBitrate = SEQ(name='NRUESidelinkAggregateMaximumBitrate', mode=MODE_TYPE)
    _NRUESidelinkAggregateMaximumBitrate_uESidelinkAggregateMaximumBitRate = INT(name='uESidelinkAggregateMaximumBitRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _NRUESidelinkAggregateMaximumBitrate_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab = ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_at = None
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_id = 'id'
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab = ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab = ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id),
        ('criticality', ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality),
        ('extensionValue', ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue),
        ])
    __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_._ext = None
    _NRUESidelinkAggregateMaximumBitrate_iE_Extensions._cont = __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_
    _NRUESidelinkAggregateMaximumBitrate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRUESidelinkAggregateMaximumBitrate._cont = ASN1Dict([
        ('uESidelinkAggregateMaximumBitRate', _NRUESidelinkAggregateMaximumBitrate_uESidelinkAggregateMaximumBitRate),
        ('iE-Extensions', _NRUESidelinkAggregateMaximumBitrate_iE_Extensions),
        ])
    NRUESidelinkAggregateMaximumBitrate._ext = []
    
    #-----< NRUESidelinkAggregateMaximumBitrate-ExtIEs >-----#
    NRUESidelinkAggregateMaximumBitrate_ExtIEs = CLASS(name='NRUESidelinkAggregateMaximumBitrate-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    NRUESidelinkAggregateMaximumBitrate_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NSAG-ID >-----#
    NSAG_ID = INT(name='NSAG-ID', mode=MODE_TYPE)
    NSAG_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< OnboardingSupport >-----#
    OnboardingSupport = ENUM(name='OnboardingSupport', mode=MODE_TYPE)
    OnboardingSupport._cont = ASN1Dict([('true', 0)])
    OnboardingSupport._ext = []
    
    #-----< OverloadAction >-----#
    OverloadAction = ENUM(name='OverloadAction', mode=MODE_TYPE)
    OverloadAction._cont = ASN1Dict([('reject-non-emergency-mo-dt', 0), ('reject-rrc-cr-signalling', 1), ('permit-emergency-sessions-and-mobile-terminated-services-only', 2), ('permit-high-priority-sessions-and-mobile-terminated-services-only', 3)])
    OverloadAction._ext = []
    
    #-----< OverloadResponse >-----#
    OverloadResponse = CHOICE(name='OverloadResponse', mode=MODE_TYPE)
    _OverloadResponse_overloadAction = ENUM(name='overloadAction', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'OverloadAction')))
    _OverloadResponse_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __OverloadResponse_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___OverloadResponse_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___OverloadResponse_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __OverloadResponse_choice_Extensions_id._const_tab = ___OverloadResponse_choice_Extensions_id_tab
    __OverloadResponse_choice_Extensions_id._const_tab_at = None
    __OverloadResponse_choice_Extensions_id._const_tab_id = 'id'
    __OverloadResponse_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___OverloadResponse_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___OverloadResponse_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __OverloadResponse_choice_Extensions_criticality._const_tab = ___OverloadResponse_choice_Extensions_criticality_tab
    __OverloadResponse_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __OverloadResponse_choice_Extensions_criticality._const_tab_id = 'criticality'
    __OverloadResponse_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___OverloadResponse_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___OverloadResponse_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __OverloadResponse_choice_Extensions_value._const_tab = ___OverloadResponse_choice_Extensions_value_tab
    __OverloadResponse_choice_Extensions_value._const_tab_at = ('..', 'id')
    __OverloadResponse_choice_Extensions_value._const_tab_id = 'Value'
    _OverloadResponse_choice_Extensions._cont = ASN1Dict([
        ('id', __OverloadResponse_choice_Extensions_id),
        ('criticality', __OverloadResponse_choice_Extensions_criticality),
        ('value', __OverloadResponse_choice_Extensions_value),
        ])
    _OverloadResponse_choice_Extensions._ext = None
    OverloadResponse._cont = ASN1Dict([
        ('overloadAction', _OverloadResponse_overloadAction),
        ('choice-Extensions', _OverloadResponse_choice_Extensions),
        ])
    OverloadResponse._ext = None
    
    #-----< OverloadResponse-ExtIEs >-----#
    OverloadResponse_ExtIEs = CLASS(name='OverloadResponse-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    OverloadResponse_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< OverloadStartNSSAIList >-----#
    OverloadStartNSSAIList = SEQ_OF(name='OverloadStartNSSAIList', mode=MODE_TYPE)
    _OverloadStartNSSAIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'OverloadStartNSSAIItem')))
    OverloadStartNSSAIList._cont = _OverloadStartNSSAIList__item_
    OverloadStartNSSAIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< OverloadStartNSSAIItem >-----#
    OverloadStartNSSAIItem = SEQ(name='OverloadStartNSSAIItem', mode=MODE_TYPE)
    _OverloadStartNSSAIItem_sliceOverloadList = SEQ_OF(name='sliceOverloadList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SliceOverloadList')))
    _OverloadStartNSSAIItem_sliceOverloadResponse = CHOICE(name='sliceOverloadResponse', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'OverloadResponse')), opt=True)
    _OverloadStartNSSAIItem_sliceTrafficLoadReductionIndication = INT(name='sliceTrafficLoadReductionIndication', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TrafficLoadReductionIndication')), opt=True)
    _OverloadStartNSSAIItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __OverloadStartNSSAIItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___OverloadStartNSSAIItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____OverloadStartNSSAIItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____OverloadStartNSSAIItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OverloadStartNSSAIItem_iE_Extensions__item__id._const_tab = ____OverloadStartNSSAIItem_iE_Extensions__item__id_tab
    ___OverloadStartNSSAIItem_iE_Extensions__item__id._const_tab_at = None
    ___OverloadStartNSSAIItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___OverloadStartNSSAIItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____OverloadStartNSSAIItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____OverloadStartNSSAIItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OverloadStartNSSAIItem_iE_Extensions__item__criticality._const_tab = ____OverloadStartNSSAIItem_iE_Extensions__item__criticality_tab
    ___OverloadStartNSSAIItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___OverloadStartNSSAIItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___OverloadStartNSSAIItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____OverloadStartNSSAIItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____OverloadStartNSSAIItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OverloadStartNSSAIItem_iE_Extensions__item__extensionValue._const_tab = ____OverloadStartNSSAIItem_iE_Extensions__item__extensionValue_tab
    ___OverloadStartNSSAIItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___OverloadStartNSSAIItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __OverloadStartNSSAIItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___OverloadStartNSSAIItem_iE_Extensions__item__id),
        ('criticality', ___OverloadStartNSSAIItem_iE_Extensions__item__criticality),
        ('extensionValue', ___OverloadStartNSSAIItem_iE_Extensions__item__extensionValue),
        ])
    __OverloadStartNSSAIItem_iE_Extensions__item_._ext = None
    _OverloadStartNSSAIItem_iE_Extensions._cont = __OverloadStartNSSAIItem_iE_Extensions__item_
    _OverloadStartNSSAIItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    OverloadStartNSSAIItem._cont = ASN1Dict([
        ('sliceOverloadList', _OverloadStartNSSAIItem_sliceOverloadList),
        ('sliceOverloadResponse', _OverloadStartNSSAIItem_sliceOverloadResponse),
        ('sliceTrafficLoadReductionIndication', _OverloadStartNSSAIItem_sliceTrafficLoadReductionIndication),
        ('iE-Extensions', _OverloadStartNSSAIItem_iE_Extensions),
        ])
    OverloadStartNSSAIItem._ext = []
    
    #-----< OverloadStartNSSAIItem-ExtIEs >-----#
    OverloadStartNSSAIItem_ExtIEs = CLASS(name='OverloadStartNSSAIItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    OverloadStartNSSAIItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PacketDelayBudget >-----#
    PacketDelayBudget = INT(name='PacketDelayBudget', mode=MODE_TYPE)
    PacketDelayBudget._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=[], er=[])
    
    #-----< PacketErrorRate >-----#
    PacketErrorRate = SEQ(name='PacketErrorRate', mode=MODE_TYPE)
    _PacketErrorRate_pERScalar = INT(name='pERScalar', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PacketErrorRate_pERScalar._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=[], er=[])
    _PacketErrorRate_pERExponent = INT(name='pERExponent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PacketErrorRate_pERExponent._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=[], er=[])
    _PacketErrorRate_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PacketErrorRate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PacketErrorRate_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PacketErrorRate_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PacketErrorRate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PacketErrorRate_iE_Extensions__item__id._const_tab = ____PacketErrorRate_iE_Extensions__item__id_tab
    ___PacketErrorRate_iE_Extensions__item__id._const_tab_at = None
    ___PacketErrorRate_iE_Extensions__item__id._const_tab_id = 'id'
    ___PacketErrorRate_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PacketErrorRate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PacketErrorRate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PacketErrorRate_iE_Extensions__item__criticality._const_tab = ____PacketErrorRate_iE_Extensions__item__criticality_tab
    ___PacketErrorRate_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PacketErrorRate_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PacketErrorRate_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PacketErrorRate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PacketErrorRate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PacketErrorRate_iE_Extensions__item__extensionValue._const_tab = ____PacketErrorRate_iE_Extensions__item__extensionValue_tab
    ___PacketErrorRate_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PacketErrorRate_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PacketErrorRate_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PacketErrorRate_iE_Extensions__item__id),
        ('criticality', ___PacketErrorRate_iE_Extensions__item__criticality),
        ('extensionValue', ___PacketErrorRate_iE_Extensions__item__extensionValue),
        ])
    __PacketErrorRate_iE_Extensions__item_._ext = None
    _PacketErrorRate_iE_Extensions._cont = __PacketErrorRate_iE_Extensions__item_
    _PacketErrorRate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PacketErrorRate._cont = ASN1Dict([
        ('pERScalar', _PacketErrorRate_pERScalar),
        ('pERExponent', _PacketErrorRate_pERExponent),
        ('iE-Extensions', _PacketErrorRate_iE_Extensions),
        ])
    PacketErrorRate._ext = []
    
    #-----< PacketErrorRate-ExtIEs >-----#
    PacketErrorRate_ExtIEs = CLASS(name='PacketErrorRate-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PacketErrorRate_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PacketLossRate >-----#
    PacketLossRate = INT(name='PacketLossRate', mode=MODE_TYPE)
    PacketLossRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1000)], ev=[], er=[])
    
    #-----< PagingAssisDataforCEcapabUE >-----#
    PagingAssisDataforCEcapabUE = SEQ(name='PagingAssisDataforCEcapabUE', mode=MODE_TYPE)
    _PagingAssisDataforCEcapabUE_eUTRA_CGI = SEQ(name='eUTRA-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _PagingAssisDataforCEcapabUE_coverageEnhancementLevel = OCT_STR(name='coverageEnhancementLevel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CoverageEnhancementLevel')))
    _PagingAssisDataforCEcapabUE_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PagingAssisDataforCEcapabUE_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PagingAssisDataforCEcapabUE_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PagingAssisDataforCEcapabUE_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PagingAssisDataforCEcapabUE_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PagingAssisDataforCEcapabUE_iE_Extensions__item__id._const_tab = ____PagingAssisDataforCEcapabUE_iE_Extensions__item__id_tab
    ___PagingAssisDataforCEcapabUE_iE_Extensions__item__id._const_tab_at = None
    ___PagingAssisDataforCEcapabUE_iE_Extensions__item__id._const_tab_id = 'id'
    ___PagingAssisDataforCEcapabUE_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PagingAssisDataforCEcapabUE_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PagingAssisDataforCEcapabUE_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PagingAssisDataforCEcapabUE_iE_Extensions__item__criticality._const_tab = ____PagingAssisDataforCEcapabUE_iE_Extensions__item__criticality_tab
    ___PagingAssisDataforCEcapabUE_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PagingAssisDataforCEcapabUE_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PagingAssisDataforCEcapabUE_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PagingAssisDataforCEcapabUE_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PagingAssisDataforCEcapabUE_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PagingAssisDataforCEcapabUE_iE_Extensions__item__extensionValue._const_tab = ____PagingAssisDataforCEcapabUE_iE_Extensions__item__extensionValue_tab
    ___PagingAssisDataforCEcapabUE_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PagingAssisDataforCEcapabUE_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PagingAssisDataforCEcapabUE_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PagingAssisDataforCEcapabUE_iE_Extensions__item__id),
        ('criticality', ___PagingAssisDataforCEcapabUE_iE_Extensions__item__criticality),
        ('extensionValue', ___PagingAssisDataforCEcapabUE_iE_Extensions__item__extensionValue),
        ])
    __PagingAssisDataforCEcapabUE_iE_Extensions__item_._ext = None
    _PagingAssisDataforCEcapabUE_iE_Extensions._cont = __PagingAssisDataforCEcapabUE_iE_Extensions__item_
    _PagingAssisDataforCEcapabUE_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PagingAssisDataforCEcapabUE._cont = ASN1Dict([
        ('eUTRA-CGI', _PagingAssisDataforCEcapabUE_eUTRA_CGI),
        ('coverageEnhancementLevel', _PagingAssisDataforCEcapabUE_coverageEnhancementLevel),
        ('iE-Extensions', _PagingAssisDataforCEcapabUE_iE_Extensions),
        ])
    PagingAssisDataforCEcapabUE._ext = []
    
    #-----< PagingAssisDataforCEcapabUE-ExtIEs >-----#
    PagingAssisDataforCEcapabUE_ExtIEs = CLASS(name='PagingAssisDataforCEcapabUE-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PagingAssisDataforCEcapabUE_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PagingAttemptInformation >-----#
    PagingAttemptInformation = SEQ(name='PagingAttemptInformation', mode=MODE_TYPE)
    _PagingAttemptInformation_pagingAttemptCount = INT(name='pagingAttemptCount', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PagingAttemptCount')))
    _PagingAttemptInformation_intendedNumberOfPagingAttempts = INT(name='intendedNumberOfPagingAttempts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntendedNumberOfPagingAttempts')))
    _PagingAttemptInformation_nextPagingAreaScope = ENUM(name='nextPagingAreaScope', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NextPagingAreaScope')), opt=True)
    _PagingAttemptInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PagingAttemptInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PagingAttemptInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PagingAttemptInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PagingAttemptInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PagingAttemptInformation_iE_Extensions__item__id._const_tab = ____PagingAttemptInformation_iE_Extensions__item__id_tab
    ___PagingAttemptInformation_iE_Extensions__item__id._const_tab_at = None
    ___PagingAttemptInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___PagingAttemptInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PagingAttemptInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PagingAttemptInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PagingAttemptInformation_iE_Extensions__item__criticality._const_tab = ____PagingAttemptInformation_iE_Extensions__item__criticality_tab
    ___PagingAttemptInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PagingAttemptInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PagingAttemptInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PagingAttemptInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PagingAttemptInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PagingAttemptInformation_iE_Extensions__item__extensionValue._const_tab = ____PagingAttemptInformation_iE_Extensions__item__extensionValue_tab
    ___PagingAttemptInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PagingAttemptInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PagingAttemptInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PagingAttemptInformation_iE_Extensions__item__id),
        ('criticality', ___PagingAttemptInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___PagingAttemptInformation_iE_Extensions__item__extensionValue),
        ])
    __PagingAttemptInformation_iE_Extensions__item_._ext = None
    _PagingAttemptInformation_iE_Extensions._cont = __PagingAttemptInformation_iE_Extensions__item_
    _PagingAttemptInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PagingAttemptInformation._cont = ASN1Dict([
        ('pagingAttemptCount', _PagingAttemptInformation_pagingAttemptCount),
        ('intendedNumberOfPagingAttempts', _PagingAttemptInformation_intendedNumberOfPagingAttempts),
        ('nextPagingAreaScope', _PagingAttemptInformation_nextPagingAreaScope),
        ('iE-Extensions', _PagingAttemptInformation_iE_Extensions),
        ])
    PagingAttemptInformation._ext = []
    
    #-----< PagingAttemptInformation-ExtIEs >-----#
    PagingAttemptInformation_ExtIEs = CLASS(name='PagingAttemptInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PagingAttemptInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PagingAttemptCount >-----#
    PagingAttemptCount = INT(name='PagingAttemptCount', mode=MODE_TYPE)
    PagingAttemptCount._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=[], er=[])
    
    #-----< PagingCause >-----#
    PagingCause = ENUM(name='PagingCause', mode=MODE_TYPE)
    PagingCause._cont = ASN1Dict([('voice', 0)])
    PagingCause._ext = []
    
    #-----< PagingCauseIndicationForVoiceService >-----#
    PagingCauseIndicationForVoiceService = ENUM(name='PagingCauseIndicationForVoiceService', mode=MODE_TYPE)
    PagingCauseIndicationForVoiceService._cont = ASN1Dict([('supported', 0)])
    PagingCauseIndicationForVoiceService._ext = []
    
    #-----< PagingDRX >-----#
    PagingDRX = ENUM(name='PagingDRX', mode=MODE_TYPE)
    PagingDRX._cont = ASN1Dict([('v32', 0), ('v64', 1), ('v128', 2), ('v256', 3)])
    PagingDRX._ext = []
    
    #-----< PagingOrigin >-----#
    PagingOrigin = ENUM(name='PagingOrigin', mode=MODE_TYPE)
    PagingOrigin._cont = ASN1Dict([('non-3gpp', 0)])
    PagingOrigin._ext = []
    
    #-----< PagingPriority >-----#
    PagingPriority = ENUM(name='PagingPriority', mode=MODE_TYPE)
    PagingPriority._cont = ASN1Dict([('priolevel1', 0), ('priolevel2', 1), ('priolevel3', 2), ('priolevel4', 3), ('priolevel5', 4), ('priolevel6', 5), ('priolevel7', 6), ('priolevel8', 7)])
    PagingPriority._ext = []
    
    #-----< PagingProbabilityInformation >-----#
    PagingProbabilityInformation = ENUM(name='PagingProbabilityInformation', mode=MODE_TYPE)
    PagingProbabilityInformation._cont = ASN1Dict([('p00', 0), ('p05', 1), ('p10', 2), ('p15', 3), ('p20', 4), ('p25', 5), ('p30', 6), ('p35', 7), ('p40', 8), ('p45', 9), ('p50', 10), ('p55', 11), ('p60', 12), ('p65', 13), ('p70', 14), ('p75', 15), ('p80', 16), ('p85', 17), ('p90', 18), ('p95', 19), ('p100', 20)])
    PagingProbabilityInformation._ext = []
    
    #-----< PathSwitchRequestAcknowledgeTransfer >-----#
    PathSwitchRequestAcknowledgeTransfer = SEQ(name='PathSwitchRequestAcknowledgeTransfer', mode=MODE_TYPE)
    _PathSwitchRequestAcknowledgeTransfer_uL_NGU_UP_TNLInformation = CHOICE(name='uL-NGU-UP-TNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')), opt=True)
    _PathSwitchRequestAcknowledgeTransfer_securityIndication = SEQ(name='securityIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SecurityIndication')), opt=True)
    _PathSwitchRequestAcknowledgeTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationPairList')))
    _____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationPairList')))
    _____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowParametersList')))
    ____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 154), ('criticality', 'ignore'), ('Extension', _____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 195), ('criticality', 'ignore'), ('Extension', _____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 185), ('criticality', 'ignore'), ('Extension', _____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 277), ('criticality', 'ignore'), ('Extension', _____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id._const_tab = ____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab
    ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__criticality._const_tab = ____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab
    ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__extensionValue._const_tab = ____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab
    ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id),
        ('criticality', ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__extensionValue),
        ])
    __PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item_._ext = None
    _PathSwitchRequestAcknowledgeTransfer_iE_Extensions._cont = __PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item_
    _PathSwitchRequestAcknowledgeTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PathSwitchRequestAcknowledgeTransfer._cont = ASN1Dict([
        ('uL-NGU-UP-TNLInformation', _PathSwitchRequestAcknowledgeTransfer_uL_NGU_UP_TNLInformation),
        ('securityIndication', _PathSwitchRequestAcknowledgeTransfer_securityIndication),
        ('iE-Extensions', _PathSwitchRequestAcknowledgeTransfer_iE_Extensions),
        ])
    PathSwitchRequestAcknowledgeTransfer._ext = []
    
    #-----< PathSwitchRequestAcknowledgeTransfer-ExtIEs >-----#
    PathSwitchRequestAcknowledgeTransfer_ExtIEs = CLASS(name='PathSwitchRequestAcknowledgeTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PathSwitchRequestAcknowledgeTransfer_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationPairList')))
    _PathSwitchRequestAcknowledgeTransfer_ExtIEs_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _PathSwitchRequestAcknowledgeTransfer_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationPairList')))
    _PathSwitchRequestAcknowledgeTransfer_ExtIEs_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowParametersList')))
    PathSwitchRequestAcknowledgeTransfer_ExtIEs._val = ASN1Set(rv=[dict([('id', 154), ('criticality', 'ignore'), ('Extension', _PathSwitchRequestAcknowledgeTransfer_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 195), ('criticality', 'ignore'), ('Extension', _PathSwitchRequestAcknowledgeTransfer_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 185), ('criticality', 'ignore'), ('Extension', _PathSwitchRequestAcknowledgeTransfer_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 277), ('criticality', 'ignore'), ('Extension', _PathSwitchRequestAcknowledgeTransfer_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PathSwitchRequestSetupFailedTransfer >-----#
    PathSwitchRequestSetupFailedTransfer = SEQ(name='PathSwitchRequestSetupFailedTransfer', mode=MODE_TYPE)
    _PathSwitchRequestSetupFailedTransfer_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _PathSwitchRequestSetupFailedTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PathSwitchRequestSetupFailedTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__id._const_tab = ____PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__id_tab
    ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__criticality._const_tab = ____PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__criticality_tab
    ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__extensionValue._const_tab = ____PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__extensionValue_tab
    ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PathSwitchRequestSetupFailedTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__id),
        ('criticality', ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__extensionValue),
        ])
    __PathSwitchRequestSetupFailedTransfer_iE_Extensions__item_._ext = None
    _PathSwitchRequestSetupFailedTransfer_iE_Extensions._cont = __PathSwitchRequestSetupFailedTransfer_iE_Extensions__item_
    _PathSwitchRequestSetupFailedTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PathSwitchRequestSetupFailedTransfer._cont = ASN1Dict([
        ('cause', _PathSwitchRequestSetupFailedTransfer_cause),
        ('iE-Extensions', _PathSwitchRequestSetupFailedTransfer_iE_Extensions),
        ])
    PathSwitchRequestSetupFailedTransfer._ext = []
    
    #-----< PathSwitchRequestSetupFailedTransfer-ExtIEs >-----#
    PathSwitchRequestSetupFailedTransfer_ExtIEs = CLASS(name='PathSwitchRequestSetupFailedTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PathSwitchRequestSetupFailedTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PathSwitchRequestTransfer >-----#
    PathSwitchRequestTransfer = SEQ(name='PathSwitchRequestTransfer', mode=MODE_TYPE)
    _PathSwitchRequestTransfer_dL_NGU_UP_TNLInformation = CHOICE(name='dL-NGU-UP-TNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _PathSwitchRequestTransfer_dL_NGU_TNLInformationReused = ENUM(name='dL-NGU-TNLInformationReused', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DL-NGU-TNLInformationReused')), opt=True)
    _PathSwitchRequestTransfer_userPlaneSecurityInformation = SEQ(name='userPlaneSecurityInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UserPlaneSecurityInformation')), opt=True)
    _PathSwitchRequestTransfer_qosFlowAcceptedList = SEQ_OF(name='qosFlowAcceptedList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowAcceptedList')))
    _PathSwitchRequestTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PathSwitchRequestTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PathSwitchRequestTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PathSwitchRequestTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')))
    _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DL-NGU-TNLInformationReused')))
    _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')))
    _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedundantPDUSessionInformation')))
    _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_5 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SupportIndicator')))
    ____PathSwitchRequestTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'ignore'), ('Extension', _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 192), ('criticality', 'ignore'), ('Extension', _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 191), ('criticality', 'ignore'), ('Extension', _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 184), ('criticality', 'ignore'), ('Extension', _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 198), ('criticality', 'ignore'), ('Extension', _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 27), ('criticality', 'ignore'), ('Extension', _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 309), ('criticality', 'ignore'), ('Extension', _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PathSwitchRequestTransfer_iE_Extensions__item__id._const_tab = ____PathSwitchRequestTransfer_iE_Extensions__item__id_tab
    ___PathSwitchRequestTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PathSwitchRequestTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___PathSwitchRequestTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PathSwitchRequestTransfer_iE_Extensions__item__criticality._const_tab = ____PathSwitchRequestTransfer_iE_Extensions__item__id_tab
    ___PathSwitchRequestTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PathSwitchRequestTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PathSwitchRequestTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PathSwitchRequestTransfer_iE_Extensions__item__extensionValue._const_tab = ____PathSwitchRequestTransfer_iE_Extensions__item__id_tab
    ___PathSwitchRequestTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PathSwitchRequestTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PathSwitchRequestTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PathSwitchRequestTransfer_iE_Extensions__item__id),
        ('criticality', ___PathSwitchRequestTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___PathSwitchRequestTransfer_iE_Extensions__item__extensionValue),
        ])
    __PathSwitchRequestTransfer_iE_Extensions__item_._ext = None
    _PathSwitchRequestTransfer_iE_Extensions._cont = __PathSwitchRequestTransfer_iE_Extensions__item_
    _PathSwitchRequestTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PathSwitchRequestTransfer._cont = ASN1Dict([
        ('dL-NGU-UP-TNLInformation', _PathSwitchRequestTransfer_dL_NGU_UP_TNLInformation),
        ('dL-NGU-TNLInformationReused', _PathSwitchRequestTransfer_dL_NGU_TNLInformationReused),
        ('userPlaneSecurityInformation', _PathSwitchRequestTransfer_userPlaneSecurityInformation),
        ('qosFlowAcceptedList', _PathSwitchRequestTransfer_qosFlowAcceptedList),
        ('iE-Extensions', _PathSwitchRequestTransfer_iE_Extensions),
        ])
    PathSwitchRequestTransfer._ext = []
    
    #-----< PathSwitchRequestTransfer-ExtIEs >-----#
    PathSwitchRequestTransfer_ExtIEs = CLASS(name='PathSwitchRequestTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PathSwitchRequestTransfer_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')))
    _PathSwitchRequestTransfer_ExtIEs_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _PathSwitchRequestTransfer_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DL-NGU-TNLInformationReused')))
    _PathSwitchRequestTransfer_ExtIEs_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')))
    _PathSwitchRequestTransfer_ExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedundantPDUSessionInformation')))
    _PathSwitchRequestTransfer_ExtIEs_val_Extension_5 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _PathSwitchRequestTransfer_ExtIEs_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SupportIndicator')))
    PathSwitchRequestTransfer_ExtIEs._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'ignore'), ('Extension', _PathSwitchRequestTransfer_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 192), ('criticality', 'ignore'), ('Extension', _PathSwitchRequestTransfer_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 191), ('criticality', 'ignore'), ('Extension', _PathSwitchRequestTransfer_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 184), ('criticality', 'ignore'), ('Extension', _PathSwitchRequestTransfer_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 198), ('criticality', 'ignore'), ('Extension', _PathSwitchRequestTransfer_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 27), ('criticality', 'ignore'), ('Extension', _PathSwitchRequestTransfer_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 309), ('criticality', 'ignore'), ('Extension', _PathSwitchRequestTransfer_ExtIEs_val_Extension_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PathSwitchRequestUnsuccessfulTransfer >-----#
    PathSwitchRequestUnsuccessfulTransfer = SEQ(name='PathSwitchRequestUnsuccessfulTransfer', mode=MODE_TYPE)
    _PathSwitchRequestUnsuccessfulTransfer_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _PathSwitchRequestUnsuccessfulTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__id._const_tab = ____PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__id_tab
    ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab = ____PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__criticality_tab
    ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab = ____PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab
    ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__id),
        ('criticality', ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__extensionValue),
        ])
    __PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item_._ext = None
    _PathSwitchRequestUnsuccessfulTransfer_iE_Extensions._cont = __PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item_
    _PathSwitchRequestUnsuccessfulTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PathSwitchRequestUnsuccessfulTransfer._cont = ASN1Dict([
        ('cause', _PathSwitchRequestUnsuccessfulTransfer_cause),
        ('iE-Extensions', _PathSwitchRequestUnsuccessfulTransfer_iE_Extensions),
        ])
    PathSwitchRequestUnsuccessfulTransfer._ext = []
    
    #-----< PathSwitchRequestUnsuccessfulTransfer-ExtIEs >-----#
    PathSwitchRequestUnsuccessfulTransfer_ExtIEs = CLASS(name='PathSwitchRequestUnsuccessfulTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PathSwitchRequestUnsuccessfulTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5QoSParameters >-----#
    PC5QoSParameters = SEQ(name='PC5QoSParameters', mode=MODE_TYPE)
    _PC5QoSParameters_pc5QoSFlowList = SEQ_OF(name='pc5QoSFlowList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PC5QoSFlowList')))
    _PC5QoSParameters_pc5LinkAggregateBitRates = INT(name='pc5LinkAggregateBitRates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')), opt=True)
    _PC5QoSParameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5QoSParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PC5QoSParameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PC5QoSParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PC5QoSParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSParameters_iE_Extensions__item__id._const_tab = ____PC5QoSParameters_iE_Extensions__item__id_tab
    ___PC5QoSParameters_iE_Extensions__item__id._const_tab_at = None
    ___PC5QoSParameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___PC5QoSParameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PC5QoSParameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PC5QoSParameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSParameters_iE_Extensions__item__criticality._const_tab = ____PC5QoSParameters_iE_Extensions__item__criticality_tab
    ___PC5QoSParameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PC5QoSParameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PC5QoSParameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSParameters_iE_Extensions__item__extensionValue._const_tab = ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab
    ___PC5QoSParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PC5QoSParameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PC5QoSParameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PC5QoSParameters_iE_Extensions__item__id),
        ('criticality', ___PC5QoSParameters_iE_Extensions__item__criticality),
        ('extensionValue', ___PC5QoSParameters_iE_Extensions__item__extensionValue),
        ])
    __PC5QoSParameters_iE_Extensions__item_._ext = None
    _PC5QoSParameters_iE_Extensions._cont = __PC5QoSParameters_iE_Extensions__item_
    _PC5QoSParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5QoSParameters._cont = ASN1Dict([
        ('pc5QoSFlowList', _PC5QoSParameters_pc5QoSFlowList),
        ('pc5LinkAggregateBitRates', _PC5QoSParameters_pc5LinkAggregateBitRates),
        ('iE-Extensions', _PC5QoSParameters_iE_Extensions),
        ])
    PC5QoSParameters._ext = []
    
    #-----< PC5QoSParameters-ExtIEs >-----#
    PC5QoSParameters_ExtIEs = CLASS(name='PC5QoSParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PC5QoSParameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5QoSFlowList >-----#
    PC5QoSFlowList = SEQ_OF(name='PC5QoSFlowList', mode=MODE_TYPE)
    _PC5QoSFlowList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PC5QoSFlowItem')))
    PC5QoSFlowList._cont = _PC5QoSFlowList__item_
    PC5QoSFlowList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    
    #-----< PC5QoSFlowItem >-----#
    PC5QoSFlowItem = SEQ(name='PC5QoSFlowItem', mode=MODE_TYPE)
    _PC5QoSFlowItem_pQI = INT(name='pQI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FiveQI')))
    _PC5QoSFlowItem_pc5FlowBitRates = SEQ(name='pc5FlowBitRates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PC5FlowBitRates')), opt=True)
    _PC5QoSFlowItem_range = ENUM(name='range', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Range')), opt=True)
    _PC5QoSFlowItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5QoSFlowItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PC5QoSFlowItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PC5QoSFlowItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PC5QoSFlowItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSFlowItem_iE_Extensions__item__id._const_tab = ____PC5QoSFlowItem_iE_Extensions__item__id_tab
    ___PC5QoSFlowItem_iE_Extensions__item__id._const_tab_at = None
    ___PC5QoSFlowItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PC5QoSFlowItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PC5QoSFlowItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PC5QoSFlowItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSFlowItem_iE_Extensions__item__criticality._const_tab = ____PC5QoSFlowItem_iE_Extensions__item__criticality_tab
    ___PC5QoSFlowItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PC5QoSFlowItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PC5QoSFlowItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PC5QoSFlowItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PC5QoSFlowItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSFlowItem_iE_Extensions__item__extensionValue._const_tab = ____PC5QoSFlowItem_iE_Extensions__item__extensionValue_tab
    ___PC5QoSFlowItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PC5QoSFlowItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PC5QoSFlowItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PC5QoSFlowItem_iE_Extensions__item__id),
        ('criticality', ___PC5QoSFlowItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PC5QoSFlowItem_iE_Extensions__item__extensionValue),
        ])
    __PC5QoSFlowItem_iE_Extensions__item_._ext = None
    _PC5QoSFlowItem_iE_Extensions._cont = __PC5QoSFlowItem_iE_Extensions__item_
    _PC5QoSFlowItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5QoSFlowItem._cont = ASN1Dict([
        ('pQI', _PC5QoSFlowItem_pQI),
        ('pc5FlowBitRates', _PC5QoSFlowItem_pc5FlowBitRates),
        ('range', _PC5QoSFlowItem_range),
        ('iE-Extensions', _PC5QoSFlowItem_iE_Extensions),
        ])
    PC5QoSFlowItem._ext = []
    
    #-----< PC5QoSFlowItem-ExtIEs >-----#
    PC5QoSFlowItem_ExtIEs = CLASS(name='PC5QoSFlowItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PC5QoSFlowItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5FlowBitRates >-----#
    PC5FlowBitRates = SEQ(name='PC5FlowBitRates', mode=MODE_TYPE)
    _PC5FlowBitRates_guaranteedFlowBitRate = INT(name='guaranteedFlowBitRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _PC5FlowBitRates_maximumFlowBitRate = INT(name='maximumFlowBitRate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _PC5FlowBitRates_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5FlowBitRates_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PC5FlowBitRates_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PC5FlowBitRates_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PC5FlowBitRates_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5FlowBitRates_iE_Extensions__item__id._const_tab = ____PC5FlowBitRates_iE_Extensions__item__id_tab
    ___PC5FlowBitRates_iE_Extensions__item__id._const_tab_at = None
    ___PC5FlowBitRates_iE_Extensions__item__id._const_tab_id = 'id'
    ___PC5FlowBitRates_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PC5FlowBitRates_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PC5FlowBitRates_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5FlowBitRates_iE_Extensions__item__criticality._const_tab = ____PC5FlowBitRates_iE_Extensions__item__criticality_tab
    ___PC5FlowBitRates_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PC5FlowBitRates_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue._const_tab = ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PC5FlowBitRates_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PC5FlowBitRates_iE_Extensions__item__id),
        ('criticality', ___PC5FlowBitRates_iE_Extensions__item__criticality),
        ('extensionValue', ___PC5FlowBitRates_iE_Extensions__item__extensionValue),
        ])
    __PC5FlowBitRates_iE_Extensions__item_._ext = None
    _PC5FlowBitRates_iE_Extensions._cont = __PC5FlowBitRates_iE_Extensions__item_
    _PC5FlowBitRates_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5FlowBitRates._cont = ASN1Dict([
        ('guaranteedFlowBitRate', _PC5FlowBitRates_guaranteedFlowBitRate),
        ('maximumFlowBitRate', _PC5FlowBitRates_maximumFlowBitRate),
        ('iE-Extensions', _PC5FlowBitRates_iE_Extensions),
        ])
    PC5FlowBitRates._ext = []
    
    #-----< PC5FlowBitRates-ExtIEs >-----#
    PC5FlowBitRates_ExtIEs = CLASS(name='PC5FlowBitRates-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PC5FlowBitRates_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PCIListForMDT >-----#
    PCIListForMDT = SEQ_OF(name='PCIListForMDT', mode=MODE_TYPE)
    _PCIListForMDT__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NR-PCI')))
    PCIListForMDT._cont = _PCIListForMDT__item_
    PCIListForMDT._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< PrivacyIndicator >-----#
    PrivacyIndicator = ENUM(name='PrivacyIndicator', mode=MODE_TYPE)
    PrivacyIndicator._cont = ASN1Dict([('immediate-MDT', 0), ('logged-MDT', 1)])
    PrivacyIndicator._ext = []
    
    #-----< PDUSessionAggregateMaximumBitRate >-----#
    PDUSessionAggregateMaximumBitRate = SEQ(name='PDUSessionAggregateMaximumBitRate', mode=MODE_TYPE)
    _PDUSessionAggregateMaximumBitRate_pDUSessionAggregateMaximumBitRateDL = INT(name='pDUSessionAggregateMaximumBitRateDL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _PDUSessionAggregateMaximumBitRate_pDUSessionAggregateMaximumBitRateUL = INT(name='pDUSessionAggregateMaximumBitRateUL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _PDUSessionAggregateMaximumBitRate_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionAggregateMaximumBitRate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionAggregateMaximumBitRate_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionAggregateMaximumBitRate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__id._const_tab = ____PDUSessionAggregateMaximumBitRate_iE_Extensions__item__id_tab
    ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionAggregateMaximumBitRate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionAggregateMaximumBitRate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__criticality._const_tab = ____PDUSessionAggregateMaximumBitRate_iE_Extensions__item__criticality_tab
    ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionAggregateMaximumBitRate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionAggregateMaximumBitRate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionAggregateMaximumBitRate_iE_Extensions__item__extensionValue_tab
    ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionAggregateMaximumBitRate_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__id),
        ('criticality', ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionAggregateMaximumBitRate_iE_Extensions__item_._ext = None
    _PDUSessionAggregateMaximumBitRate_iE_Extensions._cont = __PDUSessionAggregateMaximumBitRate_iE_Extensions__item_
    _PDUSessionAggregateMaximumBitRate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionAggregateMaximumBitRate._cont = ASN1Dict([
        ('pDUSessionAggregateMaximumBitRateDL', _PDUSessionAggregateMaximumBitRate_pDUSessionAggregateMaximumBitRateDL),
        ('pDUSessionAggregateMaximumBitRateUL', _PDUSessionAggregateMaximumBitRate_pDUSessionAggregateMaximumBitRateUL),
        ('iE-Extensions', _PDUSessionAggregateMaximumBitRate_iE_Extensions),
        ])
    PDUSessionAggregateMaximumBitRate._ext = []
    
    #-----< PDUSessionAggregateMaximumBitRate-ExtIEs >-----#
    PDUSessionAggregateMaximumBitRate_ExtIEs = CLASS(name='PDUSessionAggregateMaximumBitRate-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionAggregateMaximumBitRate_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionID >-----#
    PDUSessionID = INT(name='PDUSessionID', mode=MODE_TYPE)
    PDUSessionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< PDUSessionPairID >-----#
    PDUSessionPairID = INT(name='PDUSessionPairID', mode=MODE_TYPE)
    PDUSessionPairID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< PDUSessionResourceAdmittedList >-----#
    PDUSessionResourceAdmittedList = SEQ_OF(name='PDUSessionResourceAdmittedList', mode=MODE_TYPE)
    _PDUSessionResourceAdmittedList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceAdmittedItem')))
    PDUSessionResourceAdmittedList._cont = _PDUSessionResourceAdmittedList__item_
    PDUSessionResourceAdmittedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceAdmittedItem >-----#
    PDUSessionResourceAdmittedItem = SEQ(name='PDUSessionResourceAdmittedItem', mode=MODE_TYPE)
    _PDUSessionResourceAdmittedItem_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceAdmittedItem_handoverRequestAcknowledgeTransfer = OCT_STR(name='handoverRequestAcknowledgeTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceAdmittedItem_handoverRequestAcknowledgeTransfer_contain = SEQ(name='_cont_handoverRequestAcknowledgeTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HandoverRequestAcknowledgeTransfer')))
    _PDUSessionResourceAdmittedItem_handoverRequestAcknowledgeTransfer._const_cont = __PDUSessionResourceAdmittedItem_handoverRequestAcknowledgeTransfer_contain
    _PDUSessionResourceAdmittedItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceAdmittedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceAdmittedItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceAdmittedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceAdmittedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceAdmittedItem_iE_Extensions__item__id._const_tab = ____PDUSessionResourceAdmittedItem_iE_Extensions__item__id_tab
    ___PDUSessionResourceAdmittedItem_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceAdmittedItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceAdmittedItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceAdmittedItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceAdmittedItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceAdmittedItem_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceAdmittedItem_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceAdmittedItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceAdmittedItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceAdmittedItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceAdmittedItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceAdmittedItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceAdmittedItem_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceAdmittedItem_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceAdmittedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceAdmittedItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceAdmittedItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceAdmittedItem_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceAdmittedItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceAdmittedItem_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceAdmittedItem_iE_Extensions__item_._ext = None
    _PDUSessionResourceAdmittedItem_iE_Extensions._cont = __PDUSessionResourceAdmittedItem_iE_Extensions__item_
    _PDUSessionResourceAdmittedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceAdmittedItem._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceAdmittedItem_pDUSessionID),
        ('handoverRequestAcknowledgeTransfer', _PDUSessionResourceAdmittedItem_handoverRequestAcknowledgeTransfer),
        ('iE-Extensions', _PDUSessionResourceAdmittedItem_iE_Extensions),
        ])
    PDUSessionResourceAdmittedItem._ext = []
    
    #-----< PDUSessionResourceAdmittedItem-ExtIEs >-----#
    PDUSessionResourceAdmittedItem_ExtIEs = CLASS(name='PDUSessionResourceAdmittedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceAdmittedItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceFailedToModifyListModCfm >-----#
    PDUSessionResourceFailedToModifyListModCfm = SEQ_OF(name='PDUSessionResourceFailedToModifyListModCfm', mode=MODE_TYPE)
    _PDUSessionResourceFailedToModifyListModCfm__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToModifyItemModCfm')))
    PDUSessionResourceFailedToModifyListModCfm._cont = _PDUSessionResourceFailedToModifyListModCfm__item_
    PDUSessionResourceFailedToModifyListModCfm._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceFailedToModifyItemModCfm >-----#
    PDUSessionResourceFailedToModifyItemModCfm = SEQ(name='PDUSessionResourceFailedToModifyItemModCfm', mode=MODE_TYPE)
    _PDUSessionResourceFailedToModifyItemModCfm_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceFailedToModifyItemModCfm_pDUSessionResourceModifyIndicationUnsuccessfulTransfer = OCT_STR(name='pDUSessionResourceModifyIndicationUnsuccessfulTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceFailedToModifyItemModCfm_pDUSessionResourceModifyIndicationUnsuccessfulTransfer_contain = SEQ(name='_cont_pDUSessionResourceModifyIndicationUnsuccessfulTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyIndicationUnsuccessfulTransfer')))
    _PDUSessionResourceFailedToModifyItemModCfm_pDUSessionResourceModifyIndicationUnsuccessfulTransfer._const_cont = __PDUSessionResourceFailedToModifyItemModCfm_pDUSessionResourceModifyIndicationUnsuccessfulTransfer_contain
    _PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__id._const_tab = ____PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__id_tab
    ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item_._ext = None
    _PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions._cont = __PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item_
    _PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceFailedToModifyItemModCfm._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceFailedToModifyItemModCfm_pDUSessionID),
        ('pDUSessionResourceModifyIndicationUnsuccessfulTransfer', _PDUSessionResourceFailedToModifyItemModCfm_pDUSessionResourceModifyIndicationUnsuccessfulTransfer),
        ('iE-Extensions', _PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions),
        ])
    PDUSessionResourceFailedToModifyItemModCfm._ext = []
    
    #-----< PDUSessionResourceFailedToModifyItemModCfm-ExtIEs >-----#
    PDUSessionResourceFailedToModifyItemModCfm_ExtIEs = CLASS(name='PDUSessionResourceFailedToModifyItemModCfm-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceFailedToModifyItemModCfm_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceFailedToModifyListModRes >-----#
    PDUSessionResourceFailedToModifyListModRes = SEQ_OF(name='PDUSessionResourceFailedToModifyListModRes', mode=MODE_TYPE)
    _PDUSessionResourceFailedToModifyListModRes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToModifyItemModRes')))
    PDUSessionResourceFailedToModifyListModRes._cont = _PDUSessionResourceFailedToModifyListModRes__item_
    PDUSessionResourceFailedToModifyListModRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceFailedToModifyItemModRes >-----#
    PDUSessionResourceFailedToModifyItemModRes = SEQ(name='PDUSessionResourceFailedToModifyItemModRes', mode=MODE_TYPE)
    _PDUSessionResourceFailedToModifyItemModRes_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceFailedToModifyItemModRes_pDUSessionResourceModifyUnsuccessfulTransfer = OCT_STR(name='pDUSessionResourceModifyUnsuccessfulTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceFailedToModifyItemModRes_pDUSessionResourceModifyUnsuccessfulTransfer_contain = SEQ(name='_cont_pDUSessionResourceModifyUnsuccessfulTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyUnsuccessfulTransfer')))
    _PDUSessionResourceFailedToModifyItemModRes_pDUSessionResourceModifyUnsuccessfulTransfer._const_cont = __PDUSessionResourceFailedToModifyItemModRes_pDUSessionResourceModifyUnsuccessfulTransfer_contain
    _PDUSessionResourceFailedToModifyItemModRes_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__id._const_tab = ____PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__id_tab
    ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item_._ext = None
    _PDUSessionResourceFailedToModifyItemModRes_iE_Extensions._cont = __PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item_
    _PDUSessionResourceFailedToModifyItemModRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceFailedToModifyItemModRes._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceFailedToModifyItemModRes_pDUSessionID),
        ('pDUSessionResourceModifyUnsuccessfulTransfer', _PDUSessionResourceFailedToModifyItemModRes_pDUSessionResourceModifyUnsuccessfulTransfer),
        ('iE-Extensions', _PDUSessionResourceFailedToModifyItemModRes_iE_Extensions),
        ])
    PDUSessionResourceFailedToModifyItemModRes._ext = []
    
    #-----< PDUSessionResourceFailedToModifyItemModRes-ExtIEs >-----#
    PDUSessionResourceFailedToModifyItemModRes_ExtIEs = CLASS(name='PDUSessionResourceFailedToModifyItemModRes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceFailedToModifyItemModRes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceFailedToResumeListRESReq >-----#
    PDUSessionResourceFailedToResumeListRESReq = SEQ_OF(name='PDUSessionResourceFailedToResumeListRESReq', mode=MODE_TYPE)
    _PDUSessionResourceFailedToResumeListRESReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToResumeItemRESReq')))
    PDUSessionResourceFailedToResumeListRESReq._cont = _PDUSessionResourceFailedToResumeListRESReq__item_
    PDUSessionResourceFailedToResumeListRESReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceFailedToResumeItemRESReq >-----#
    PDUSessionResourceFailedToResumeItemRESReq = SEQ(name='PDUSessionResourceFailedToResumeItemRESReq', mode=MODE_TYPE)
    _PDUSessionResourceFailedToResumeItemRESReq_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceFailedToResumeItemRESReq_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__id._const_tab = ____PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item_._ext = None
    _PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions._cont = __PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item_
    _PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceFailedToResumeItemRESReq._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceFailedToResumeItemRESReq_pDUSessionID),
        ('cause', _PDUSessionResourceFailedToResumeItemRESReq_cause),
        ('iE-Extensions', _PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions),
        ])
    PDUSessionResourceFailedToResumeItemRESReq._ext = []
    
    #-----< PDUSessionResourceFailedToResumeItemRESReq-ExtIEs >-----#
    PDUSessionResourceFailedToResumeItemRESReq_ExtIEs = CLASS(name='PDUSessionResourceFailedToResumeItemRESReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceFailedToResumeItemRESReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceFailedToResumeListRESRes >-----#
    PDUSessionResourceFailedToResumeListRESRes = SEQ_OF(name='PDUSessionResourceFailedToResumeListRESRes', mode=MODE_TYPE)
    _PDUSessionResourceFailedToResumeListRESRes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToResumeItemRESRes')))
    PDUSessionResourceFailedToResumeListRESRes._cont = _PDUSessionResourceFailedToResumeListRESRes__item_
    PDUSessionResourceFailedToResumeListRESRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceFailedToResumeItemRESRes >-----#
    PDUSessionResourceFailedToResumeItemRESRes = SEQ(name='PDUSessionResourceFailedToResumeItemRESRes', mode=MODE_TYPE)
    _PDUSessionResourceFailedToResumeItemRESRes_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceFailedToResumeItemRESRes_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__id._const_tab = ____PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__id_tab
    ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item_._ext = None
    _PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions._cont = __PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item_
    _PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceFailedToResumeItemRESRes._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceFailedToResumeItemRESRes_pDUSessionID),
        ('cause', _PDUSessionResourceFailedToResumeItemRESRes_cause),
        ('iE-Extensions', _PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions),
        ])
    PDUSessionResourceFailedToResumeItemRESRes._ext = []
    
    #-----< PDUSessionResourceFailedToResumeItemRESRes-ExtIEs >-----#
    PDUSessionResourceFailedToResumeItemRESRes_ExtIEs = CLASS(name='PDUSessionResourceFailedToResumeItemRESRes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceFailedToResumeItemRESRes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceFailedToSetupListCxtFail >-----#
    PDUSessionResourceFailedToSetupListCxtFail = SEQ_OF(name='PDUSessionResourceFailedToSetupListCxtFail', mode=MODE_TYPE)
    _PDUSessionResourceFailedToSetupListCxtFail__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupItemCxtFail')))
    PDUSessionResourceFailedToSetupListCxtFail._cont = _PDUSessionResourceFailedToSetupListCxtFail__item_
    PDUSessionResourceFailedToSetupListCxtFail._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceFailedToSetupItemCxtFail >-----#
    PDUSessionResourceFailedToSetupItemCxtFail = SEQ(name='PDUSessionResourceFailedToSetupItemCxtFail', mode=MODE_TYPE)
    _PDUSessionResourceFailedToSetupItemCxtFail_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceFailedToSetupItemCxtFail_pDUSessionResourceSetupUnsuccessfulTransfer = OCT_STR(name='pDUSessionResourceSetupUnsuccessfulTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceFailedToSetupItemCxtFail_pDUSessionResourceSetupUnsuccessfulTransfer_contain = SEQ(name='_cont_pDUSessionResourceSetupUnsuccessfulTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupUnsuccessfulTransfer')))
    _PDUSessionResourceFailedToSetupItemCxtFail_pDUSessionResourceSetupUnsuccessfulTransfer._const_cont = __PDUSessionResourceFailedToSetupItemCxtFail_pDUSessionResourceSetupUnsuccessfulTransfer_contain
    _PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__id._const_tab = ____PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__id_tab
    ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item_._ext = None
    _PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions._cont = __PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item_
    _PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceFailedToSetupItemCxtFail._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceFailedToSetupItemCxtFail_pDUSessionID),
        ('pDUSessionResourceSetupUnsuccessfulTransfer', _PDUSessionResourceFailedToSetupItemCxtFail_pDUSessionResourceSetupUnsuccessfulTransfer),
        ('iE-Extensions', _PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions),
        ])
    PDUSessionResourceFailedToSetupItemCxtFail._ext = []
    
    #-----< PDUSessionResourceFailedToSetupItemCxtFail-ExtIEs >-----#
    PDUSessionResourceFailedToSetupItemCxtFail_ExtIEs = CLASS(name='PDUSessionResourceFailedToSetupItemCxtFail-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceFailedToSetupItemCxtFail_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceFailedToSetupListCxtRes >-----#
    PDUSessionResourceFailedToSetupListCxtRes = SEQ_OF(name='PDUSessionResourceFailedToSetupListCxtRes', mode=MODE_TYPE)
    _PDUSessionResourceFailedToSetupListCxtRes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupItemCxtRes')))
    PDUSessionResourceFailedToSetupListCxtRes._cont = _PDUSessionResourceFailedToSetupListCxtRes__item_
    PDUSessionResourceFailedToSetupListCxtRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceFailedToSetupItemCxtRes >-----#
    PDUSessionResourceFailedToSetupItemCxtRes = SEQ(name='PDUSessionResourceFailedToSetupItemCxtRes', mode=MODE_TYPE)
    _PDUSessionResourceFailedToSetupItemCxtRes_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceFailedToSetupItemCxtRes_pDUSessionResourceSetupUnsuccessfulTransfer = OCT_STR(name='pDUSessionResourceSetupUnsuccessfulTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceFailedToSetupItemCxtRes_pDUSessionResourceSetupUnsuccessfulTransfer_contain = SEQ(name='_cont_pDUSessionResourceSetupUnsuccessfulTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupUnsuccessfulTransfer')))
    _PDUSessionResourceFailedToSetupItemCxtRes_pDUSessionResourceSetupUnsuccessfulTransfer._const_cont = __PDUSessionResourceFailedToSetupItemCxtRes_pDUSessionResourceSetupUnsuccessfulTransfer_contain
    _PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__id._const_tab = ____PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__id_tab
    ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item_._ext = None
    _PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions._cont = __PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item_
    _PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceFailedToSetupItemCxtRes._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceFailedToSetupItemCxtRes_pDUSessionID),
        ('pDUSessionResourceSetupUnsuccessfulTransfer', _PDUSessionResourceFailedToSetupItemCxtRes_pDUSessionResourceSetupUnsuccessfulTransfer),
        ('iE-Extensions', _PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions),
        ])
    PDUSessionResourceFailedToSetupItemCxtRes._ext = []
    
    #-----< PDUSessionResourceFailedToSetupItemCxtRes-ExtIEs >-----#
    PDUSessionResourceFailedToSetupItemCxtRes_ExtIEs = CLASS(name='PDUSessionResourceFailedToSetupItemCxtRes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceFailedToSetupItemCxtRes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceFailedToSetupListHOAck >-----#
    PDUSessionResourceFailedToSetupListHOAck = SEQ_OF(name='PDUSessionResourceFailedToSetupListHOAck', mode=MODE_TYPE)
    _PDUSessionResourceFailedToSetupListHOAck__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupItemHOAck')))
    PDUSessionResourceFailedToSetupListHOAck._cont = _PDUSessionResourceFailedToSetupListHOAck__item_
    PDUSessionResourceFailedToSetupListHOAck._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceFailedToSetupItemHOAck >-----#
    PDUSessionResourceFailedToSetupItemHOAck = SEQ(name='PDUSessionResourceFailedToSetupItemHOAck', mode=MODE_TYPE)
    _PDUSessionResourceFailedToSetupItemHOAck_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceFailedToSetupItemHOAck_handoverResourceAllocationUnsuccessfulTransfer = OCT_STR(name='handoverResourceAllocationUnsuccessfulTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceFailedToSetupItemHOAck_handoverResourceAllocationUnsuccessfulTransfer_contain = SEQ(name='_cont_handoverResourceAllocationUnsuccessfulTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HandoverResourceAllocationUnsuccessfulTransfer')))
    _PDUSessionResourceFailedToSetupItemHOAck_handoverResourceAllocationUnsuccessfulTransfer._const_cont = __PDUSessionResourceFailedToSetupItemHOAck_handoverResourceAllocationUnsuccessfulTransfer_contain
    _PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__id._const_tab = ____PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__id_tab
    ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item_._ext = None
    _PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions._cont = __PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item_
    _PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceFailedToSetupItemHOAck._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceFailedToSetupItemHOAck_pDUSessionID),
        ('handoverResourceAllocationUnsuccessfulTransfer', _PDUSessionResourceFailedToSetupItemHOAck_handoverResourceAllocationUnsuccessfulTransfer),
        ('iE-Extensions', _PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions),
        ])
    PDUSessionResourceFailedToSetupItemHOAck._ext = []
    
    #-----< PDUSessionResourceFailedToSetupItemHOAck-ExtIEs >-----#
    PDUSessionResourceFailedToSetupItemHOAck_ExtIEs = CLASS(name='PDUSessionResourceFailedToSetupItemHOAck-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceFailedToSetupItemHOAck_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceFailedToSetupListPSReq >-----#
    PDUSessionResourceFailedToSetupListPSReq = SEQ_OF(name='PDUSessionResourceFailedToSetupListPSReq', mode=MODE_TYPE)
    _PDUSessionResourceFailedToSetupListPSReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupItemPSReq')))
    PDUSessionResourceFailedToSetupListPSReq._cont = _PDUSessionResourceFailedToSetupListPSReq__item_
    PDUSessionResourceFailedToSetupListPSReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceFailedToSetupItemPSReq >-----#
    PDUSessionResourceFailedToSetupItemPSReq = SEQ(name='PDUSessionResourceFailedToSetupItemPSReq', mode=MODE_TYPE)
    _PDUSessionResourceFailedToSetupItemPSReq_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceFailedToSetupItemPSReq_pathSwitchRequestSetupFailedTransfer = OCT_STR(name='pathSwitchRequestSetupFailedTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceFailedToSetupItemPSReq_pathSwitchRequestSetupFailedTransfer_contain = SEQ(name='_cont_pathSwitchRequestSetupFailedTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PathSwitchRequestSetupFailedTransfer')))
    _PDUSessionResourceFailedToSetupItemPSReq_pathSwitchRequestSetupFailedTransfer._const_cont = __PDUSessionResourceFailedToSetupItemPSReq_pathSwitchRequestSetupFailedTransfer_contain
    _PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__id._const_tab = ____PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item_._ext = None
    _PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions._cont = __PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item_
    _PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceFailedToSetupItemPSReq._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceFailedToSetupItemPSReq_pDUSessionID),
        ('pathSwitchRequestSetupFailedTransfer', _PDUSessionResourceFailedToSetupItemPSReq_pathSwitchRequestSetupFailedTransfer),
        ('iE-Extensions', _PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions),
        ])
    PDUSessionResourceFailedToSetupItemPSReq._ext = []
    
    #-----< PDUSessionResourceFailedToSetupItemPSReq-ExtIEs >-----#
    PDUSessionResourceFailedToSetupItemPSReq_ExtIEs = CLASS(name='PDUSessionResourceFailedToSetupItemPSReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceFailedToSetupItemPSReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceFailedToSetupListSURes >-----#
    PDUSessionResourceFailedToSetupListSURes = SEQ_OF(name='PDUSessionResourceFailedToSetupListSURes', mode=MODE_TYPE)
    _PDUSessionResourceFailedToSetupListSURes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupItemSURes')))
    PDUSessionResourceFailedToSetupListSURes._cont = _PDUSessionResourceFailedToSetupListSURes__item_
    PDUSessionResourceFailedToSetupListSURes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceFailedToSetupItemSURes >-----#
    PDUSessionResourceFailedToSetupItemSURes = SEQ(name='PDUSessionResourceFailedToSetupItemSURes', mode=MODE_TYPE)
    _PDUSessionResourceFailedToSetupItemSURes_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceFailedToSetupItemSURes_pDUSessionResourceSetupUnsuccessfulTransfer = OCT_STR(name='pDUSessionResourceSetupUnsuccessfulTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceFailedToSetupItemSURes_pDUSessionResourceSetupUnsuccessfulTransfer_contain = SEQ(name='_cont_pDUSessionResourceSetupUnsuccessfulTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupUnsuccessfulTransfer')))
    _PDUSessionResourceFailedToSetupItemSURes_pDUSessionResourceSetupUnsuccessfulTransfer._const_cont = __PDUSessionResourceFailedToSetupItemSURes_pDUSessionResourceSetupUnsuccessfulTransfer_contain
    _PDUSessionResourceFailedToSetupItemSURes_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__id._const_tab = ____PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__id_tab
    ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item_._ext = None
    _PDUSessionResourceFailedToSetupItemSURes_iE_Extensions._cont = __PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item_
    _PDUSessionResourceFailedToSetupItemSURes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceFailedToSetupItemSURes._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceFailedToSetupItemSURes_pDUSessionID),
        ('pDUSessionResourceSetupUnsuccessfulTransfer', _PDUSessionResourceFailedToSetupItemSURes_pDUSessionResourceSetupUnsuccessfulTransfer),
        ('iE-Extensions', _PDUSessionResourceFailedToSetupItemSURes_iE_Extensions),
        ])
    PDUSessionResourceFailedToSetupItemSURes._ext = []
    
    #-----< PDUSessionResourceFailedToSetupItemSURes-ExtIEs >-----#
    PDUSessionResourceFailedToSetupItemSURes_ExtIEs = CLASS(name='PDUSessionResourceFailedToSetupItemSURes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceFailedToSetupItemSURes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceHandoverList >-----#
    PDUSessionResourceHandoverList = SEQ_OF(name='PDUSessionResourceHandoverList', mode=MODE_TYPE)
    _PDUSessionResourceHandoverList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceHandoverItem')))
    PDUSessionResourceHandoverList._cont = _PDUSessionResourceHandoverList__item_
    PDUSessionResourceHandoverList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceHandoverItem >-----#
    PDUSessionResourceHandoverItem = SEQ(name='PDUSessionResourceHandoverItem', mode=MODE_TYPE)
    _PDUSessionResourceHandoverItem_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceHandoverItem_handoverCommandTransfer = OCT_STR(name='handoverCommandTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceHandoverItem_handoverCommandTransfer_contain = SEQ(name='_cont_handoverCommandTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HandoverCommandTransfer')))
    _PDUSessionResourceHandoverItem_handoverCommandTransfer._const_cont = __PDUSessionResourceHandoverItem_handoverCommandTransfer_contain
    _PDUSessionResourceHandoverItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceHandoverItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceHandoverItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceHandoverItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceHandoverItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceHandoverItem_iE_Extensions__item__id._const_tab = ____PDUSessionResourceHandoverItem_iE_Extensions__item__id_tab
    ___PDUSessionResourceHandoverItem_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceHandoverItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceHandoverItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceHandoverItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceHandoverItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceHandoverItem_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceHandoverItem_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceHandoverItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceHandoverItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceHandoverItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceHandoverItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceHandoverItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceHandoverItem_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceHandoverItem_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceHandoverItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceHandoverItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceHandoverItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceHandoverItem_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceHandoverItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceHandoverItem_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceHandoverItem_iE_Extensions__item_._ext = None
    _PDUSessionResourceHandoverItem_iE_Extensions._cont = __PDUSessionResourceHandoverItem_iE_Extensions__item_
    _PDUSessionResourceHandoverItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceHandoverItem._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceHandoverItem_pDUSessionID),
        ('handoverCommandTransfer', _PDUSessionResourceHandoverItem_handoverCommandTransfer),
        ('iE-Extensions', _PDUSessionResourceHandoverItem_iE_Extensions),
        ])
    PDUSessionResourceHandoverItem._ext = []
    
    #-----< PDUSessionResourceHandoverItem-ExtIEs >-----#
    PDUSessionResourceHandoverItem_ExtIEs = CLASS(name='PDUSessionResourceHandoverItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceHandoverItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceInformationList >-----#
    PDUSessionResourceInformationList = SEQ_OF(name='PDUSessionResourceInformationList', mode=MODE_TYPE)
    _PDUSessionResourceInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceInformationItem')))
    PDUSessionResourceInformationList._cont = _PDUSessionResourceInformationList__item_
    PDUSessionResourceInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceInformationItem >-----#
    PDUSessionResourceInformationItem = SEQ(name='PDUSessionResourceInformationItem', mode=MODE_TYPE)
    _PDUSessionResourceInformationItem_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceInformationItem_qosFlowInformationList = SEQ_OF(name='qosFlowInformationList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowInformationList')))
    _PDUSessionResourceInformationItem_dRBsToQosFlowsMappingList = SEQ_OF(name='dRBsToQosFlowsMappingList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRBsToQosFlowsMappingList')), opt=True)
    _PDUSessionResourceInformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceInformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceInformationItem_iE_Extensions__item__id._const_tab = ____PDUSessionResourceInformationItem_iE_Extensions__item__id_tab
    ___PDUSessionResourceInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceInformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceInformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceInformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceInformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceInformationItem_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceInformationItem_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceInformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceInformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceInformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceInformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceInformationItem_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceInformationItem_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceInformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceInformationItem_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceInformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceInformationItem_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceInformationItem_iE_Extensions__item_._ext = None
    _PDUSessionResourceInformationItem_iE_Extensions._cont = __PDUSessionResourceInformationItem_iE_Extensions__item_
    _PDUSessionResourceInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceInformationItem._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceInformationItem_pDUSessionID),
        ('qosFlowInformationList', _PDUSessionResourceInformationItem_qosFlowInformationList),
        ('dRBsToQosFlowsMappingList', _PDUSessionResourceInformationItem_dRBsToQosFlowsMappingList),
        ('iE-Extensions', _PDUSessionResourceInformationItem_iE_Extensions),
        ])
    PDUSessionResourceInformationItem._ext = []
    
    #-----< PDUSessionResourceInformationItem-ExtIEs >-----#
    PDUSessionResourceInformationItem_ExtIEs = CLASS(name='PDUSessionResourceInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceListCxtRelCpl >-----#
    PDUSessionResourceListCxtRelCpl = SEQ_OF(name='PDUSessionResourceListCxtRelCpl', mode=MODE_TYPE)
    _PDUSessionResourceListCxtRelCpl__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceItemCxtRelCpl')))
    PDUSessionResourceListCxtRelCpl._cont = _PDUSessionResourceListCxtRelCpl__item_
    PDUSessionResourceListCxtRelCpl._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceItemCxtRelCpl >-----#
    PDUSessionResourceItemCxtRelCpl = SEQ(name='PDUSessionResourceItemCxtRelCpl', mode=MODE_TYPE)
    _PDUSessionResourceItemCxtRelCpl_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceItemCxtRelCpl_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceItemCxtRelCpl_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE)
    ______PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id_tab_val_Extension_0_contain = SEQ(name='_cont_Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleaseResponseTransfer')))
    _____PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id_tab_val_Extension_0._const_cont = ______PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id_tab_val_Extension_0_contain
    ____PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 145), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id._const_tab = ____PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id_tab
    ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id_tab
    ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id_tab
    ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceItemCxtRelCpl_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceItemCxtRelCpl_iE_Extensions__item_._ext = None
    _PDUSessionResourceItemCxtRelCpl_iE_Extensions._cont = __PDUSessionResourceItemCxtRelCpl_iE_Extensions__item_
    _PDUSessionResourceItemCxtRelCpl_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceItemCxtRelCpl._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceItemCxtRelCpl_pDUSessionID),
        ('iE-Extensions', _PDUSessionResourceItemCxtRelCpl_iE_Extensions),
        ])
    PDUSessionResourceItemCxtRelCpl._ext = []
    
    #-----< PDUSessionResourceItemCxtRelCpl-ExtIEs >-----#
    PDUSessionResourceItemCxtRelCpl_ExtIEs = CLASS(name='PDUSessionResourceItemCxtRelCpl-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PDUSessionResourceItemCxtRelCpl_ExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE)
    __PDUSessionResourceItemCxtRelCpl_ExtIEs_val_Extension_0_contain = SEQ(name='_cont_Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleaseResponseTransfer')))
    _PDUSessionResourceItemCxtRelCpl_ExtIEs_val_Extension_0._const_cont = __PDUSessionResourceItemCxtRelCpl_ExtIEs_val_Extension_0_contain
    PDUSessionResourceItemCxtRelCpl_ExtIEs._val = ASN1Set(rv=[dict([('id', 145), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceItemCxtRelCpl_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceListCxtRelReq >-----#
    PDUSessionResourceListCxtRelReq = SEQ_OF(name='PDUSessionResourceListCxtRelReq', mode=MODE_TYPE)
    _PDUSessionResourceListCxtRelReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceItemCxtRelReq')))
    PDUSessionResourceListCxtRelReq._cont = _PDUSessionResourceListCxtRelReq__item_
    PDUSessionResourceListCxtRelReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceItemCxtRelReq >-----#
    PDUSessionResourceItemCxtRelReq = SEQ(name='PDUSessionResourceItemCxtRelReq', mode=MODE_TYPE)
    _PDUSessionResourceItemCxtRelReq_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceItemCxtRelReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceItemCxtRelReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceItemCxtRelReq_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceItemCxtRelReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__id._const_tab = ____PDUSessionResourceItemCxtRelReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceItemCxtRelReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceItemCxtRelReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceItemCxtRelReq_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceItemCxtRelReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceItemCxtRelReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceItemCxtRelReq_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceItemCxtRelReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceItemCxtRelReq_iE_Extensions__item_._ext = None
    _PDUSessionResourceItemCxtRelReq_iE_Extensions._cont = __PDUSessionResourceItemCxtRelReq_iE_Extensions__item_
    _PDUSessionResourceItemCxtRelReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceItemCxtRelReq._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceItemCxtRelReq_pDUSessionID),
        ('iE-Extensions', _PDUSessionResourceItemCxtRelReq_iE_Extensions),
        ])
    PDUSessionResourceItemCxtRelReq._ext = []
    
    #-----< PDUSessionResourceItemCxtRelReq-ExtIEs >-----#
    PDUSessionResourceItemCxtRelReq_ExtIEs = CLASS(name='PDUSessionResourceItemCxtRelReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceItemCxtRelReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceListHORqd >-----#
    PDUSessionResourceListHORqd = SEQ_OF(name='PDUSessionResourceListHORqd', mode=MODE_TYPE)
    _PDUSessionResourceListHORqd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceItemHORqd')))
    PDUSessionResourceListHORqd._cont = _PDUSessionResourceListHORqd__item_
    PDUSessionResourceListHORqd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceItemHORqd >-----#
    PDUSessionResourceItemHORqd = SEQ(name='PDUSessionResourceItemHORqd', mode=MODE_TYPE)
    _PDUSessionResourceItemHORqd_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceItemHORqd_handoverRequiredTransfer = OCT_STR(name='handoverRequiredTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceItemHORqd_handoverRequiredTransfer_contain = SEQ(name='_cont_handoverRequiredTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HandoverRequiredTransfer')))
    _PDUSessionResourceItemHORqd_handoverRequiredTransfer._const_cont = __PDUSessionResourceItemHORqd_handoverRequiredTransfer_contain
    _PDUSessionResourceItemHORqd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceItemHORqd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceItemHORqd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceItemHORqd_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceItemHORqd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceItemHORqd_iE_Extensions__item__id._const_tab = ____PDUSessionResourceItemHORqd_iE_Extensions__item__id_tab
    ___PDUSessionResourceItemHORqd_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceItemHORqd_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceItemHORqd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceItemHORqd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceItemHORqd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceItemHORqd_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceItemHORqd_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceItemHORqd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceItemHORqd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceItemHORqd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceItemHORqd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceItemHORqd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceItemHORqd_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceItemHORqd_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceItemHORqd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceItemHORqd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceItemHORqd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceItemHORqd_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceItemHORqd_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceItemHORqd_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceItemHORqd_iE_Extensions__item_._ext = None
    _PDUSessionResourceItemHORqd_iE_Extensions._cont = __PDUSessionResourceItemHORqd_iE_Extensions__item_
    _PDUSessionResourceItemHORqd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceItemHORqd._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceItemHORqd_pDUSessionID),
        ('handoverRequiredTransfer', _PDUSessionResourceItemHORqd_handoverRequiredTransfer),
        ('iE-Extensions', _PDUSessionResourceItemHORqd_iE_Extensions),
        ])
    PDUSessionResourceItemHORqd._ext = []
    
    #-----< PDUSessionResourceItemHORqd-ExtIEs >-----#
    PDUSessionResourceItemHORqd_ExtIEs = CLASS(name='PDUSessionResourceItemHORqd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceItemHORqd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyConfirmTransfer >-----#
    PDUSessionResourceModifyConfirmTransfer = SEQ(name='PDUSessionResourceModifyConfirmTransfer', mode=MODE_TYPE)
    _PDUSessionResourceModifyConfirmTransfer_qosFlowModifyConfirmList = SEQ_OF(name='qosFlowModifyConfirmList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowModifyConfirmList')))
    _PDUSessionResourceModifyConfirmTransfer_uLNGU_UP_TNLInformation = CHOICE(name='uLNGU-UP-TNLInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _PDUSessionResourceModifyConfirmTransfer_additionalNG_UUPTNLInformation = SEQ_OF(name='additionalNG-UUPTNLInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationPairList')), opt=True)
    _PDUSessionResourceModifyConfirmTransfer_qosFlowFailedToModifyList = SEQ_OF(name='qosFlowFailedToModifyList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithCause')), opt=True)
    _PDUSessionResourceModifyConfirmTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _____PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationPairList')))
    ____PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 195), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 185), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id._const_tab = ____PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item_._ext = None
    _PDUSessionResourceModifyConfirmTransfer_iE_Extensions._cont = __PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item_
    _PDUSessionResourceModifyConfirmTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyConfirmTransfer._cont = ASN1Dict([
        ('qosFlowModifyConfirmList', _PDUSessionResourceModifyConfirmTransfer_qosFlowModifyConfirmList),
        ('uLNGU-UP-TNLInformation', _PDUSessionResourceModifyConfirmTransfer_uLNGU_UP_TNLInformation),
        ('additionalNG-UUPTNLInformation', _PDUSessionResourceModifyConfirmTransfer_additionalNG_UUPTNLInformation),
        ('qosFlowFailedToModifyList', _PDUSessionResourceModifyConfirmTransfer_qosFlowFailedToModifyList),
        ('iE-Extensions', _PDUSessionResourceModifyConfirmTransfer_iE_Extensions),
        ])
    PDUSessionResourceModifyConfirmTransfer._ext = []
    
    #-----< PDUSessionResourceModifyConfirmTransfer-ExtIEs >-----#
    PDUSessionResourceModifyConfirmTransfer_ExtIEs = CLASS(name='PDUSessionResourceModifyConfirmTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PDUSessionResourceModifyConfirmTransfer_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _PDUSessionResourceModifyConfirmTransfer_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationPairList')))
    PDUSessionResourceModifyConfirmTransfer_ExtIEs._val = ASN1Set(rv=[dict([('id', 195), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceModifyConfirmTransfer_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 185), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceModifyConfirmTransfer_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyIndicationUnsuccessfulTransfer >-----#
    PDUSessionResourceModifyIndicationUnsuccessfulTransfer = SEQ(name='PDUSessionResourceModifyIndicationUnsuccessfulTransfer', mode=MODE_TYPE)
    _PDUSessionResourceModifyIndicationUnsuccessfulTransfer_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__id._const_tab = ____PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item_._ext = None
    _PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions._cont = __PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item_
    _PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyIndicationUnsuccessfulTransfer._cont = ASN1Dict([
        ('cause', _PDUSessionResourceModifyIndicationUnsuccessfulTransfer_cause),
        ('iE-Extensions', _PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions),
        ])
    PDUSessionResourceModifyIndicationUnsuccessfulTransfer._ext = []
    
    #-----< PDUSessionResourceModifyIndicationUnsuccessfulTransfer-ExtIEs >-----#
    PDUSessionResourceModifyIndicationUnsuccessfulTransfer_ExtIEs = CLASS(name='PDUSessionResourceModifyIndicationUnsuccessfulTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceModifyIndicationUnsuccessfulTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyRequestTransfer >-----#
    PDUSessionResourceModifyRequestTransfer = SEQ(name='PDUSessionResourceModifyRequestTransfer', mode=MODE_TYPE)
    _PDUSessionResourceModifyRequestTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PDUSessionResourceModifyRequestTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionAggregateMaximumBitRate')))
    _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UL-NGU-UP-TNLModifyList')))
    _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NetworkInstance')))
    _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowAddOrModifyRequestList')))
    _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithCause')))
    _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationList')))
    _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CommonNetworkInstance')))
    _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationList')))
    _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_8 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CommonNetworkInstance')))
    _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_9 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityIndication')))
    _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_11 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionSetuporModifyRequestList')))
    _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_12 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionToReleaseList')))
    ____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 130), ('criticality', 'reject'), ('Value', _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 140), ('criticality', 'reject'), ('Value', _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 129), ('criticality', 'reject'), ('Value', _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 135), ('criticality', 'reject'), ('Value', _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 137), ('criticality', 'reject'), ('Value', _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 126), ('criticality', 'reject'), ('Value', _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 166), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 186), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 190), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 195), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 138), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 319), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 317), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id._const_tab = ____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id._const_tab_at = None
    ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__criticality._const_tab = ____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__value._const_tab = ____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __PDUSessionResourceModifyRequestTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id),
        ('criticality', ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__criticality),
        ('value', ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__value),
        ])
    __PDUSessionResourceModifyRequestTransfer_protocolIEs__item_._ext = None
    _PDUSessionResourceModifyRequestTransfer_protocolIEs._cont = __PDUSessionResourceModifyRequestTransfer_protocolIEs__item_
    _PDUSessionResourceModifyRequestTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyRequestTransfer._cont = ASN1Dict([
        ('protocolIEs', _PDUSessionResourceModifyRequestTransfer_protocolIEs),
        ])
    PDUSessionResourceModifyRequestTransfer._ext = []
    
    #-----< PDUSessionResourceModifyRequestTransferIEs >-----#
    PDUSessionResourceModifyRequestTransferIEs = CLASS(name='PDUSessionResourceModifyRequestTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PDUSessionResourceModifyRequestTransferIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionAggregateMaximumBitRate')))
    _PDUSessionResourceModifyRequestTransferIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UL-NGU-UP-TNLModifyList')))
    _PDUSessionResourceModifyRequestTransferIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NetworkInstance')))
    _PDUSessionResourceModifyRequestTransferIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowAddOrModifyRequestList')))
    _PDUSessionResourceModifyRequestTransferIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithCause')))
    _PDUSessionResourceModifyRequestTransferIEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationList')))
    _PDUSessionResourceModifyRequestTransferIEs_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CommonNetworkInstance')))
    _PDUSessionResourceModifyRequestTransferIEs_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationList')))
    _PDUSessionResourceModifyRequestTransferIEs_val_Value_8 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CommonNetworkInstance')))
    _PDUSessionResourceModifyRequestTransferIEs_val_Value_9 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _PDUSessionResourceModifyRequestTransferIEs_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityIndication')))
    _PDUSessionResourceModifyRequestTransferIEs_val_Value_11 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionSetuporModifyRequestList')))
    _PDUSessionResourceModifyRequestTransferIEs_val_Value_12 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionToReleaseList')))
    PDUSessionResourceModifyRequestTransferIEs._val = ASN1Set(rv=[dict([('id', 130), ('criticality', 'reject'), ('Value', _PDUSessionResourceModifyRequestTransferIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 140), ('criticality', 'reject'), ('Value', _PDUSessionResourceModifyRequestTransferIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 129), ('criticality', 'reject'), ('Value', _PDUSessionResourceModifyRequestTransferIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 135), ('criticality', 'reject'), ('Value', _PDUSessionResourceModifyRequestTransferIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 137), ('criticality', 'reject'), ('Value', _PDUSessionResourceModifyRequestTransferIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 126), ('criticality', 'reject'), ('Value', _PDUSessionResourceModifyRequestTransferIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 166), ('criticality', 'ignore'), ('Value', _PDUSessionResourceModifyRequestTransferIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 186), ('criticality', 'ignore'), ('Value', _PDUSessionResourceModifyRequestTransferIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 190), ('criticality', 'ignore'), ('Value', _PDUSessionResourceModifyRequestTransferIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 195), ('criticality', 'ignore'), ('Value', _PDUSessionResourceModifyRequestTransferIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 138), ('criticality', 'ignore'), ('Value', _PDUSessionResourceModifyRequestTransferIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 319), ('criticality', 'ignore'), ('Value', _PDUSessionResourceModifyRequestTransferIEs_val_Value_11), ('presence', 'optional')]), dict([('id', 317), ('criticality', 'ignore'), ('Value', _PDUSessionResourceModifyRequestTransferIEs_val_Value_12), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyResponseTransfer >-----#
    PDUSessionResourceModifyResponseTransfer = SEQ(name='PDUSessionResourceModifyResponseTransfer', mode=MODE_TYPE)
    _PDUSessionResourceModifyResponseTransfer_dL_NGU_UP_TNLInformation = CHOICE(name='dL-NGU-UP-TNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')), opt=True)
    _PDUSessionResourceModifyResponseTransfer_uL_NGU_UP_TNLInformation = CHOICE(name='uL-NGU-UP-TNLInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')), opt=True)
    _PDUSessionResourceModifyResponseTransfer_qosFlowAddOrModifyResponseList = SEQ_OF(name='qosFlowAddOrModifyResponseList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowAddOrModifyResponseList')), opt=True)
    _PDUSessionResourceModifyResponseTransfer_additionalDLQosFlowPerTNLInformation = SEQ_OF(name='additionalDLQosFlowPerTNLInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')), opt=True)
    _PDUSessionResourceModifyResponseTransfer_qosFlowFailedToAddOrModifyList = SEQ_OF(name='qosFlowFailedToAddOrModifyList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithCause')), opt=True)
    _PDUSessionResourceModifyResponseTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceModifyResponseTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationPairList')))
    _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')))
    _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationPairList')))
    _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecondaryRATUsageInformation')))
    _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SupportIndicator')))
    _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_7 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionSetupResponseList')))
    _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_8 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionFailedtoSetupList')))
    ____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 154), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 192), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 195), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 184), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 185), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 144), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 309), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 313), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 311), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id._const_tab = ____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceModifyResponseTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceModifyResponseTransfer_iE_Extensions__item_._ext = None
    _PDUSessionResourceModifyResponseTransfer_iE_Extensions._cont = __PDUSessionResourceModifyResponseTransfer_iE_Extensions__item_
    _PDUSessionResourceModifyResponseTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyResponseTransfer._cont = ASN1Dict([
        ('dL-NGU-UP-TNLInformation', _PDUSessionResourceModifyResponseTransfer_dL_NGU_UP_TNLInformation),
        ('uL-NGU-UP-TNLInformation', _PDUSessionResourceModifyResponseTransfer_uL_NGU_UP_TNLInformation),
        ('qosFlowAddOrModifyResponseList', _PDUSessionResourceModifyResponseTransfer_qosFlowAddOrModifyResponseList),
        ('additionalDLQosFlowPerTNLInformation', _PDUSessionResourceModifyResponseTransfer_additionalDLQosFlowPerTNLInformation),
        ('qosFlowFailedToAddOrModifyList', _PDUSessionResourceModifyResponseTransfer_qosFlowFailedToAddOrModifyList),
        ('iE-Extensions', _PDUSessionResourceModifyResponseTransfer_iE_Extensions),
        ])
    PDUSessionResourceModifyResponseTransfer._ext = []
    
    #-----< PDUSessionResourceModifyResponseTransfer-ExtIEs >-----#
    PDUSessionResourceModifyResponseTransfer_ExtIEs = CLASS(name='PDUSessionResourceModifyResponseTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationPairList')))
    _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')))
    _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationPairList')))
    _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecondaryRATUsageInformation')))
    _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SupportIndicator')))
    _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_7 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionSetupResponseList')))
    _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_8 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionFailedtoSetupList')))
    PDUSessionResourceModifyResponseTransfer_ExtIEs._val = ASN1Set(rv=[dict([('id', 154), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 192), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 195), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 184), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 185), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 144), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 309), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 313), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 311), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_8), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyIndicationTransfer >-----#
    PDUSessionResourceModifyIndicationTransfer = SEQ(name='PDUSessionResourceModifyIndicationTransfer', mode=MODE_TYPE)
    _PDUSessionResourceModifyIndicationTransfer_dLQosFlowPerTNLInformation = SEQ(name='dLQosFlowPerTNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformation')))
    _PDUSessionResourceModifyIndicationTransfer_additionalDLQosFlowPerTNLInformation = SEQ_OF(name='additionalDLQosFlowPerTNLInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')), opt=True)
    _PDUSessionResourceModifyIndicationTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecondaryRATUsageInformation')))
    _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityResult')))
    _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformation')))
    _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')))
    _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_4 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    ____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 144), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 156), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 193), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 184), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 27), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id._const_tab = ____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item_._ext = None
    _PDUSessionResourceModifyIndicationTransfer_iE_Extensions._cont = __PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item_
    _PDUSessionResourceModifyIndicationTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyIndicationTransfer._cont = ASN1Dict([
        ('dLQosFlowPerTNLInformation', _PDUSessionResourceModifyIndicationTransfer_dLQosFlowPerTNLInformation),
        ('additionalDLQosFlowPerTNLInformation', _PDUSessionResourceModifyIndicationTransfer_additionalDLQosFlowPerTNLInformation),
        ('iE-Extensions', _PDUSessionResourceModifyIndicationTransfer_iE_Extensions),
        ])
    PDUSessionResourceModifyIndicationTransfer._ext = []
    
    #-----< PDUSessionResourceModifyIndicationTransfer-ExtIEs >-----#
    PDUSessionResourceModifyIndicationTransfer_ExtIEs = CLASS(name='PDUSessionResourceModifyIndicationTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecondaryRATUsageInformation')))
    _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityResult')))
    _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformation')))
    _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')))
    _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_4 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    PDUSessionResourceModifyIndicationTransfer_ExtIEs._val = ASN1Set(rv=[dict([('id', 144), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 156), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 193), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 184), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 27), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyListModCfm >-----#
    PDUSessionResourceModifyListModCfm = SEQ_OF(name='PDUSessionResourceModifyListModCfm', mode=MODE_TYPE)
    _PDUSessionResourceModifyListModCfm__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyItemModCfm')))
    PDUSessionResourceModifyListModCfm._cont = _PDUSessionResourceModifyListModCfm__item_
    PDUSessionResourceModifyListModCfm._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceModifyItemModCfm >-----#
    PDUSessionResourceModifyItemModCfm = SEQ(name='PDUSessionResourceModifyItemModCfm', mode=MODE_TYPE)
    _PDUSessionResourceModifyItemModCfm_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceModifyItemModCfm_pDUSessionResourceModifyConfirmTransfer = OCT_STR(name='pDUSessionResourceModifyConfirmTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceModifyItemModCfm_pDUSessionResourceModifyConfirmTransfer_contain = SEQ(name='_cont_pDUSessionResourceModifyConfirmTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyConfirmTransfer')))
    _PDUSessionResourceModifyItemModCfm_pDUSessionResourceModifyConfirmTransfer._const_cont = __PDUSessionResourceModifyItemModCfm_pDUSessionResourceModifyConfirmTransfer_contain
    _PDUSessionResourceModifyItemModCfm_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceModifyItemModCfm_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceModifyItemModCfm_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyItemModCfm_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__id._const_tab = ____PDUSessionResourceModifyItemModCfm_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceModifyItemModCfm_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyItemModCfm_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceModifyItemModCfm_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceModifyItemModCfm_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyItemModCfm_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceModifyItemModCfm_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceModifyItemModCfm_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceModifyItemModCfm_iE_Extensions__item_._ext = None
    _PDUSessionResourceModifyItemModCfm_iE_Extensions._cont = __PDUSessionResourceModifyItemModCfm_iE_Extensions__item_
    _PDUSessionResourceModifyItemModCfm_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyItemModCfm._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceModifyItemModCfm_pDUSessionID),
        ('pDUSessionResourceModifyConfirmTransfer', _PDUSessionResourceModifyItemModCfm_pDUSessionResourceModifyConfirmTransfer),
        ('iE-Extensions', _PDUSessionResourceModifyItemModCfm_iE_Extensions),
        ])
    PDUSessionResourceModifyItemModCfm._ext = []
    
    #-----< PDUSessionResourceModifyItemModCfm-ExtIEs >-----#
    PDUSessionResourceModifyItemModCfm_ExtIEs = CLASS(name='PDUSessionResourceModifyItemModCfm-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceModifyItemModCfm_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyListModInd >-----#
    PDUSessionResourceModifyListModInd = SEQ_OF(name='PDUSessionResourceModifyListModInd', mode=MODE_TYPE)
    _PDUSessionResourceModifyListModInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyItemModInd')))
    PDUSessionResourceModifyListModInd._cont = _PDUSessionResourceModifyListModInd__item_
    PDUSessionResourceModifyListModInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceModifyItemModInd >-----#
    PDUSessionResourceModifyItemModInd = SEQ(name='PDUSessionResourceModifyItemModInd', mode=MODE_TYPE)
    _PDUSessionResourceModifyItemModInd_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceModifyItemModInd_pDUSessionResourceModifyIndicationTransfer = OCT_STR(name='pDUSessionResourceModifyIndicationTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceModifyItemModInd_pDUSessionResourceModifyIndicationTransfer_contain = SEQ(name='_cont_pDUSessionResourceModifyIndicationTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyIndicationTransfer')))
    _PDUSessionResourceModifyItemModInd_pDUSessionResourceModifyIndicationTransfer._const_cont = __PDUSessionResourceModifyItemModInd_pDUSessionResourceModifyIndicationTransfer_contain
    _PDUSessionResourceModifyItemModInd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceModifyItemModInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceModifyItemModInd_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyItemModInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__id._const_tab = ____PDUSessionResourceModifyItemModInd_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceModifyItemModInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyItemModInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceModifyItemModInd_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceModifyItemModInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyItemModInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceModifyItemModInd_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceModifyItemModInd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceModifyItemModInd_iE_Extensions__item_._ext = None
    _PDUSessionResourceModifyItemModInd_iE_Extensions._cont = __PDUSessionResourceModifyItemModInd_iE_Extensions__item_
    _PDUSessionResourceModifyItemModInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyItemModInd._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceModifyItemModInd_pDUSessionID),
        ('pDUSessionResourceModifyIndicationTransfer', _PDUSessionResourceModifyItemModInd_pDUSessionResourceModifyIndicationTransfer),
        ('iE-Extensions', _PDUSessionResourceModifyItemModInd_iE_Extensions),
        ])
    PDUSessionResourceModifyItemModInd._ext = []
    
    #-----< PDUSessionResourceModifyItemModInd-ExtIEs >-----#
    PDUSessionResourceModifyItemModInd_ExtIEs = CLASS(name='PDUSessionResourceModifyItemModInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceModifyItemModInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyListModReq >-----#
    PDUSessionResourceModifyListModReq = SEQ_OF(name='PDUSessionResourceModifyListModReq', mode=MODE_TYPE)
    _PDUSessionResourceModifyListModReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyItemModReq')))
    PDUSessionResourceModifyListModReq._cont = _PDUSessionResourceModifyListModReq__item_
    PDUSessionResourceModifyListModReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceModifyItemModReq >-----#
    PDUSessionResourceModifyItemModReq = SEQ(name='PDUSessionResourceModifyItemModReq', mode=MODE_TYPE)
    _PDUSessionResourceModifyItemModReq_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceModifyItemModReq_nAS_PDU = OCT_STR(name='nAS-PDU', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')), opt=True)
    _PDUSessionResourceModifyItemModReq_pDUSessionResourceModifyRequestTransfer = OCT_STR(name='pDUSessionResourceModifyRequestTransfer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceModifyItemModReq_pDUSessionResourceModifyRequestTransfer_contain = SEQ(name='_cont_pDUSessionResourceModifyRequestTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyRequestTransfer')))
    _PDUSessionResourceModifyItemModReq_pDUSessionResourceModifyRequestTransfer._const_cont = __PDUSessionResourceModifyItemModReq_pDUSessionResourceModifyRequestTransfer_contain
    _PDUSessionResourceModifyItemModReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceModifyItemModReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceModifyItemModReq_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PDUSessionResourceModifyItemModReq_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _____PDUSessionResourceModifyItemModReq_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEActivityBehaviour')))
    ____PDUSessionResourceModifyItemModReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 148), ('criticality', 'reject'), ('Extension', _____PDUSessionResourceModifyItemModReq_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 281), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceModifyItemModReq_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__id._const_tab = ____PDUSessionResourceModifyItemModReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceModifyItemModReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceModifyItemModReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceModifyItemModReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceModifyItemModReq_iE_Extensions__item_._ext = None
    _PDUSessionResourceModifyItemModReq_iE_Extensions._cont = __PDUSessionResourceModifyItemModReq_iE_Extensions__item_
    _PDUSessionResourceModifyItemModReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyItemModReq._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceModifyItemModReq_pDUSessionID),
        ('nAS-PDU', _PDUSessionResourceModifyItemModReq_nAS_PDU),
        ('pDUSessionResourceModifyRequestTransfer', _PDUSessionResourceModifyItemModReq_pDUSessionResourceModifyRequestTransfer),
        ('iE-Extensions', _PDUSessionResourceModifyItemModReq_iE_Extensions),
        ])
    PDUSessionResourceModifyItemModReq._ext = []
    
    #-----< PDUSessionResourceModifyItemModReq-ExtIEs >-----#
    PDUSessionResourceModifyItemModReq_ExtIEs = CLASS(name='PDUSessionResourceModifyItemModReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PDUSessionResourceModifyItemModReq_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _PDUSessionResourceModifyItemModReq_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEActivityBehaviour')))
    PDUSessionResourceModifyItemModReq_ExtIEs._val = ASN1Set(rv=[dict([('id', 148), ('criticality', 'reject'), ('Extension', _PDUSessionResourceModifyItemModReq_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 281), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceModifyItemModReq_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyListModRes >-----#
    PDUSessionResourceModifyListModRes = SEQ_OF(name='PDUSessionResourceModifyListModRes', mode=MODE_TYPE)
    _PDUSessionResourceModifyListModRes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyItemModRes')))
    PDUSessionResourceModifyListModRes._cont = _PDUSessionResourceModifyListModRes__item_
    PDUSessionResourceModifyListModRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceModifyItemModRes >-----#
    PDUSessionResourceModifyItemModRes = SEQ(name='PDUSessionResourceModifyItemModRes', mode=MODE_TYPE)
    _PDUSessionResourceModifyItemModRes_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceModifyItemModRes_pDUSessionResourceModifyResponseTransfer = OCT_STR(name='pDUSessionResourceModifyResponseTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceModifyItemModRes_pDUSessionResourceModifyResponseTransfer_contain = SEQ(name='_cont_pDUSessionResourceModifyResponseTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyResponseTransfer')))
    _PDUSessionResourceModifyItemModRes_pDUSessionResourceModifyResponseTransfer._const_cont = __PDUSessionResourceModifyItemModRes_pDUSessionResourceModifyResponseTransfer_contain
    _PDUSessionResourceModifyItemModRes_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceModifyItemModRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceModifyItemModRes_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyItemModRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__id._const_tab = ____PDUSessionResourceModifyItemModRes_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceModifyItemModRes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyItemModRes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceModifyItemModRes_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceModifyItemModRes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyItemModRes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceModifyItemModRes_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceModifyItemModRes_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceModifyItemModRes_iE_Extensions__item_._ext = None
    _PDUSessionResourceModifyItemModRes_iE_Extensions._cont = __PDUSessionResourceModifyItemModRes_iE_Extensions__item_
    _PDUSessionResourceModifyItemModRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyItemModRes._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceModifyItemModRes_pDUSessionID),
        ('pDUSessionResourceModifyResponseTransfer', _PDUSessionResourceModifyItemModRes_pDUSessionResourceModifyResponseTransfer),
        ('iE-Extensions', _PDUSessionResourceModifyItemModRes_iE_Extensions),
        ])
    PDUSessionResourceModifyItemModRes._ext = []
    
    #-----< PDUSessionResourceModifyItemModRes-ExtIEs >-----#
    PDUSessionResourceModifyItemModRes_ExtIEs = CLASS(name='PDUSessionResourceModifyItemModRes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceModifyItemModRes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyUnsuccessfulTransfer >-----#
    PDUSessionResourceModifyUnsuccessfulTransfer = SEQ(name='PDUSessionResourceModifyUnsuccessfulTransfer', mode=MODE_TYPE)
    _PDUSessionResourceModifyUnsuccessfulTransfer_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _PDUSessionResourceModifyUnsuccessfulTransfer_criticalityDiagnostics = SEQ(name='criticalityDiagnostics', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')), opt=True)
    _PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__id._const_tab = ____PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item_._ext = None
    _PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions._cont = __PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item_
    _PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyUnsuccessfulTransfer._cont = ASN1Dict([
        ('cause', _PDUSessionResourceModifyUnsuccessfulTransfer_cause),
        ('criticalityDiagnostics', _PDUSessionResourceModifyUnsuccessfulTransfer_criticalityDiagnostics),
        ('iE-Extensions', _PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions),
        ])
    PDUSessionResourceModifyUnsuccessfulTransfer._ext = []
    
    #-----< PDUSessionResourceModifyUnsuccessfulTransfer-ExtIEs >-----#
    PDUSessionResourceModifyUnsuccessfulTransfer_ExtIEs = CLASS(name='PDUSessionResourceModifyUnsuccessfulTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceModifyUnsuccessfulTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceNotifyList >-----#
    PDUSessionResourceNotifyList = SEQ_OF(name='PDUSessionResourceNotifyList', mode=MODE_TYPE)
    _PDUSessionResourceNotifyList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceNotifyItem')))
    PDUSessionResourceNotifyList._cont = _PDUSessionResourceNotifyList__item_
    PDUSessionResourceNotifyList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceNotifyItem >-----#
    PDUSessionResourceNotifyItem = SEQ(name='PDUSessionResourceNotifyItem', mode=MODE_TYPE)
    _PDUSessionResourceNotifyItem_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceNotifyItem_pDUSessionResourceNotifyTransfer = OCT_STR(name='pDUSessionResourceNotifyTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceNotifyItem_pDUSessionResourceNotifyTransfer_contain = SEQ(name='_cont_pDUSessionResourceNotifyTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceNotifyTransfer')))
    _PDUSessionResourceNotifyItem_pDUSessionResourceNotifyTransfer._const_cont = __PDUSessionResourceNotifyItem_pDUSessionResourceNotifyTransfer_contain
    _PDUSessionResourceNotifyItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceNotifyItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceNotifyItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceNotifyItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceNotifyItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceNotifyItem_iE_Extensions__item__id._const_tab = ____PDUSessionResourceNotifyItem_iE_Extensions__item__id_tab
    ___PDUSessionResourceNotifyItem_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceNotifyItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceNotifyItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceNotifyItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceNotifyItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceNotifyItem_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceNotifyItem_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceNotifyItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceNotifyItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceNotifyItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceNotifyItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceNotifyItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceNotifyItem_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceNotifyItem_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceNotifyItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceNotifyItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceNotifyItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceNotifyItem_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceNotifyItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceNotifyItem_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceNotifyItem_iE_Extensions__item_._ext = None
    _PDUSessionResourceNotifyItem_iE_Extensions._cont = __PDUSessionResourceNotifyItem_iE_Extensions__item_
    _PDUSessionResourceNotifyItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceNotifyItem._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceNotifyItem_pDUSessionID),
        ('pDUSessionResourceNotifyTransfer', _PDUSessionResourceNotifyItem_pDUSessionResourceNotifyTransfer),
        ('iE-Extensions', _PDUSessionResourceNotifyItem_iE_Extensions),
        ])
    PDUSessionResourceNotifyItem._ext = []
    
    #-----< PDUSessionResourceNotifyItem-ExtIEs >-----#
    PDUSessionResourceNotifyItem_ExtIEs = CLASS(name='PDUSessionResourceNotifyItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceNotifyItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceNotifyReleasedTransfer >-----#
    PDUSessionResourceNotifyReleasedTransfer = SEQ(name='PDUSessionResourceNotifyReleasedTransfer', mode=MODE_TYPE)
    _PDUSessionResourceNotifyReleasedTransfer_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _PDUSessionResourceNotifyReleasedTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecondaryRATUsageInformation')))
    ____PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 144), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id._const_tab = ____PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item_._ext = None
    _PDUSessionResourceNotifyReleasedTransfer_iE_Extensions._cont = __PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item_
    _PDUSessionResourceNotifyReleasedTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceNotifyReleasedTransfer._cont = ASN1Dict([
        ('cause', _PDUSessionResourceNotifyReleasedTransfer_cause),
        ('iE-Extensions', _PDUSessionResourceNotifyReleasedTransfer_iE_Extensions),
        ])
    PDUSessionResourceNotifyReleasedTransfer._ext = []
    
    #-----< PDUSessionResourceNotifyReleasedTransfer-ExtIEs >-----#
    PDUSessionResourceNotifyReleasedTransfer_ExtIEs = CLASS(name='PDUSessionResourceNotifyReleasedTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PDUSessionResourceNotifyReleasedTransfer_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecondaryRATUsageInformation')))
    PDUSessionResourceNotifyReleasedTransfer_ExtIEs._val = ASN1Set(rv=[dict([('id', 144), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceNotifyReleasedTransfer_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceNotifyTransfer >-----#
    PDUSessionResourceNotifyTransfer = SEQ(name='PDUSessionResourceNotifyTransfer', mode=MODE_TYPE)
    _PDUSessionResourceNotifyTransfer_qosFlowNotifyList = SEQ_OF(name='qosFlowNotifyList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowNotifyList')), opt=True)
    _PDUSessionResourceNotifyTransfer_qosFlowReleasedList = SEQ_OF(name='qosFlowReleasedList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithCause')), opt=True)
    _PDUSessionResourceNotifyTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceNotifyTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceNotifyTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PDUSessionResourceNotifyTransfer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecondaryRATUsageInformation')))
    _____PDUSessionResourceNotifyTransfer_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowFeedbackList')))
    ____PDUSessionResourceNotifyTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 144), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceNotifyTransfer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 278), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceNotifyTransfer_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__id._const_tab = ____PDUSessionResourceNotifyTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceNotifyTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceNotifyTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceNotifyTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceNotifyTransfer_iE_Extensions__item_._ext = None
    _PDUSessionResourceNotifyTransfer_iE_Extensions._cont = __PDUSessionResourceNotifyTransfer_iE_Extensions__item_
    _PDUSessionResourceNotifyTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceNotifyTransfer._cont = ASN1Dict([
        ('qosFlowNotifyList', _PDUSessionResourceNotifyTransfer_qosFlowNotifyList),
        ('qosFlowReleasedList', _PDUSessionResourceNotifyTransfer_qosFlowReleasedList),
        ('iE-Extensions', _PDUSessionResourceNotifyTransfer_iE_Extensions),
        ])
    PDUSessionResourceNotifyTransfer._ext = []
    
    #-----< PDUSessionResourceNotifyTransfer-ExtIEs >-----#
    PDUSessionResourceNotifyTransfer_ExtIEs = CLASS(name='PDUSessionResourceNotifyTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PDUSessionResourceNotifyTransfer_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecondaryRATUsageInformation')))
    _PDUSessionResourceNotifyTransfer_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowFeedbackList')))
    PDUSessionResourceNotifyTransfer_ExtIEs._val = ASN1Set(rv=[dict([('id', 144), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceNotifyTransfer_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 278), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceNotifyTransfer_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceReleaseCommandTransfer >-----#
    PDUSessionResourceReleaseCommandTransfer = SEQ(name='PDUSessionResourceReleaseCommandTransfer', mode=MODE_TYPE)
    _PDUSessionResourceReleaseCommandTransfer_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _PDUSessionResourceReleaseCommandTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__id._const_tab = ____PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item_._ext = None
    _PDUSessionResourceReleaseCommandTransfer_iE_Extensions._cont = __PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item_
    _PDUSessionResourceReleaseCommandTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceReleaseCommandTransfer._cont = ASN1Dict([
        ('cause', _PDUSessionResourceReleaseCommandTransfer_cause),
        ('iE-Extensions', _PDUSessionResourceReleaseCommandTransfer_iE_Extensions),
        ])
    PDUSessionResourceReleaseCommandTransfer._ext = []
    
    #-----< PDUSessionResourceReleaseCommandTransfer-ExtIEs >-----#
    PDUSessionResourceReleaseCommandTransfer_ExtIEs = CLASS(name='PDUSessionResourceReleaseCommandTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceReleaseCommandTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceReleasedListNot >-----#
    PDUSessionResourceReleasedListNot = SEQ_OF(name='PDUSessionResourceReleasedListNot', mode=MODE_TYPE)
    _PDUSessionResourceReleasedListNot__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleasedItemNot')))
    PDUSessionResourceReleasedListNot._cont = _PDUSessionResourceReleasedListNot__item_
    PDUSessionResourceReleasedListNot._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceReleasedItemNot >-----#
    PDUSessionResourceReleasedItemNot = SEQ(name='PDUSessionResourceReleasedItemNot', mode=MODE_TYPE)
    _PDUSessionResourceReleasedItemNot_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceReleasedItemNot_pDUSessionResourceNotifyReleasedTransfer = OCT_STR(name='pDUSessionResourceNotifyReleasedTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceReleasedItemNot_pDUSessionResourceNotifyReleasedTransfer_contain = SEQ(name='_cont_pDUSessionResourceNotifyReleasedTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceNotifyReleasedTransfer')))
    _PDUSessionResourceReleasedItemNot_pDUSessionResourceNotifyReleasedTransfer._const_cont = __PDUSessionResourceReleasedItemNot_pDUSessionResourceNotifyReleasedTransfer_contain
    _PDUSessionResourceReleasedItemNot_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceReleasedItemNot_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceReleasedItemNot_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleasedItemNot_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__id._const_tab = ____PDUSessionResourceReleasedItemNot_iE_Extensions__item__id_tab
    ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceReleasedItemNot_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleasedItemNot_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceReleasedItemNot_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceReleasedItemNot_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleasedItemNot_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceReleasedItemNot_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceReleasedItemNot_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceReleasedItemNot_iE_Extensions__item_._ext = None
    _PDUSessionResourceReleasedItemNot_iE_Extensions._cont = __PDUSessionResourceReleasedItemNot_iE_Extensions__item_
    _PDUSessionResourceReleasedItemNot_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceReleasedItemNot._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceReleasedItemNot_pDUSessionID),
        ('pDUSessionResourceNotifyReleasedTransfer', _PDUSessionResourceReleasedItemNot_pDUSessionResourceNotifyReleasedTransfer),
        ('iE-Extensions', _PDUSessionResourceReleasedItemNot_iE_Extensions),
        ])
    PDUSessionResourceReleasedItemNot._ext = []
    
    #-----< PDUSessionResourceReleasedItemNot-ExtIEs >-----#
    PDUSessionResourceReleasedItemNot_ExtIEs = CLASS(name='PDUSessionResourceReleasedItemNot-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceReleasedItemNot_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceReleasedListPSAck >-----#
    PDUSessionResourceReleasedListPSAck = SEQ_OF(name='PDUSessionResourceReleasedListPSAck', mode=MODE_TYPE)
    _PDUSessionResourceReleasedListPSAck__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleasedItemPSAck')))
    PDUSessionResourceReleasedListPSAck._cont = _PDUSessionResourceReleasedListPSAck__item_
    PDUSessionResourceReleasedListPSAck._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceReleasedItemPSAck >-----#
    PDUSessionResourceReleasedItemPSAck = SEQ(name='PDUSessionResourceReleasedItemPSAck', mode=MODE_TYPE)
    _PDUSessionResourceReleasedItemPSAck_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceReleasedItemPSAck_pathSwitchRequestUnsuccessfulTransfer = OCT_STR(name='pathSwitchRequestUnsuccessfulTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceReleasedItemPSAck_pathSwitchRequestUnsuccessfulTransfer_contain = SEQ(name='_cont_pathSwitchRequestUnsuccessfulTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PathSwitchRequestUnsuccessfulTransfer')))
    _PDUSessionResourceReleasedItemPSAck_pathSwitchRequestUnsuccessfulTransfer._const_cont = __PDUSessionResourceReleasedItemPSAck_pathSwitchRequestUnsuccessfulTransfer_contain
    _PDUSessionResourceReleasedItemPSAck_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceReleasedItemPSAck_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__id._const_tab = ____PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__id_tab
    ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceReleasedItemPSAck_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceReleasedItemPSAck_iE_Extensions__item_._ext = None
    _PDUSessionResourceReleasedItemPSAck_iE_Extensions._cont = __PDUSessionResourceReleasedItemPSAck_iE_Extensions__item_
    _PDUSessionResourceReleasedItemPSAck_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceReleasedItemPSAck._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceReleasedItemPSAck_pDUSessionID),
        ('pathSwitchRequestUnsuccessfulTransfer', _PDUSessionResourceReleasedItemPSAck_pathSwitchRequestUnsuccessfulTransfer),
        ('iE-Extensions', _PDUSessionResourceReleasedItemPSAck_iE_Extensions),
        ])
    PDUSessionResourceReleasedItemPSAck._ext = []
    
    #-----< PDUSessionResourceReleasedItemPSAck-ExtIEs >-----#
    PDUSessionResourceReleasedItemPSAck_ExtIEs = CLASS(name='PDUSessionResourceReleasedItemPSAck-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceReleasedItemPSAck_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceReleasedListPSFail >-----#
    PDUSessionResourceReleasedListPSFail = SEQ_OF(name='PDUSessionResourceReleasedListPSFail', mode=MODE_TYPE)
    _PDUSessionResourceReleasedListPSFail__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleasedItemPSFail')))
    PDUSessionResourceReleasedListPSFail._cont = _PDUSessionResourceReleasedListPSFail__item_
    PDUSessionResourceReleasedListPSFail._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceReleasedItemPSFail >-----#
    PDUSessionResourceReleasedItemPSFail = SEQ(name='PDUSessionResourceReleasedItemPSFail', mode=MODE_TYPE)
    _PDUSessionResourceReleasedItemPSFail_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceReleasedItemPSFail_pathSwitchRequestUnsuccessfulTransfer = OCT_STR(name='pathSwitchRequestUnsuccessfulTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceReleasedItemPSFail_pathSwitchRequestUnsuccessfulTransfer_contain = SEQ(name='_cont_pathSwitchRequestUnsuccessfulTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PathSwitchRequestUnsuccessfulTransfer')))
    _PDUSessionResourceReleasedItemPSFail_pathSwitchRequestUnsuccessfulTransfer._const_cont = __PDUSessionResourceReleasedItemPSFail_pathSwitchRequestUnsuccessfulTransfer_contain
    _PDUSessionResourceReleasedItemPSFail_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceReleasedItemPSFail_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__id._const_tab = ____PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__id_tab
    ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceReleasedItemPSFail_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceReleasedItemPSFail_iE_Extensions__item_._ext = None
    _PDUSessionResourceReleasedItemPSFail_iE_Extensions._cont = __PDUSessionResourceReleasedItemPSFail_iE_Extensions__item_
    _PDUSessionResourceReleasedItemPSFail_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceReleasedItemPSFail._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceReleasedItemPSFail_pDUSessionID),
        ('pathSwitchRequestUnsuccessfulTransfer', _PDUSessionResourceReleasedItemPSFail_pathSwitchRequestUnsuccessfulTransfer),
        ('iE-Extensions', _PDUSessionResourceReleasedItemPSFail_iE_Extensions),
        ])
    PDUSessionResourceReleasedItemPSFail._ext = []
    
    #-----< PDUSessionResourceReleasedItemPSFail-ExtIEs >-----#
    PDUSessionResourceReleasedItemPSFail_ExtIEs = CLASS(name='PDUSessionResourceReleasedItemPSFail-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceReleasedItemPSFail_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceReleasedListRelRes >-----#
    PDUSessionResourceReleasedListRelRes = SEQ_OF(name='PDUSessionResourceReleasedListRelRes', mode=MODE_TYPE)
    _PDUSessionResourceReleasedListRelRes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleasedItemRelRes')))
    PDUSessionResourceReleasedListRelRes._cont = _PDUSessionResourceReleasedListRelRes__item_
    PDUSessionResourceReleasedListRelRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceReleasedItemRelRes >-----#
    PDUSessionResourceReleasedItemRelRes = SEQ(name='PDUSessionResourceReleasedItemRelRes', mode=MODE_TYPE)
    _PDUSessionResourceReleasedItemRelRes_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceReleasedItemRelRes_pDUSessionResourceReleaseResponseTransfer = OCT_STR(name='pDUSessionResourceReleaseResponseTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceReleasedItemRelRes_pDUSessionResourceReleaseResponseTransfer_contain = SEQ(name='_cont_pDUSessionResourceReleaseResponseTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleaseResponseTransfer')))
    _PDUSessionResourceReleasedItemRelRes_pDUSessionResourceReleaseResponseTransfer._const_cont = __PDUSessionResourceReleasedItemRelRes_pDUSessionResourceReleaseResponseTransfer_contain
    _PDUSessionResourceReleasedItemRelRes_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceReleasedItemRelRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__id._const_tab = ____PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__id_tab
    ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceReleasedItemRelRes_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceReleasedItemRelRes_iE_Extensions__item_._ext = None
    _PDUSessionResourceReleasedItemRelRes_iE_Extensions._cont = __PDUSessionResourceReleasedItemRelRes_iE_Extensions__item_
    _PDUSessionResourceReleasedItemRelRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceReleasedItemRelRes._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceReleasedItemRelRes_pDUSessionID),
        ('pDUSessionResourceReleaseResponseTransfer', _PDUSessionResourceReleasedItemRelRes_pDUSessionResourceReleaseResponseTransfer),
        ('iE-Extensions', _PDUSessionResourceReleasedItemRelRes_iE_Extensions),
        ])
    PDUSessionResourceReleasedItemRelRes._ext = []
    
    #-----< PDUSessionResourceReleasedItemRelRes-ExtIEs >-----#
    PDUSessionResourceReleasedItemRelRes_ExtIEs = CLASS(name='PDUSessionResourceReleasedItemRelRes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceReleasedItemRelRes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceReleaseResponseTransfer >-----#
    PDUSessionResourceReleaseResponseTransfer = SEQ(name='PDUSessionResourceReleaseResponseTransfer', mode=MODE_TYPE)
    _PDUSessionResourceReleaseResponseTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecondaryRATUsageInformation')))
    ____PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 144), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id._const_tab = ____PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item_._ext = None
    _PDUSessionResourceReleaseResponseTransfer_iE_Extensions._cont = __PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item_
    _PDUSessionResourceReleaseResponseTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceReleaseResponseTransfer._cont = ASN1Dict([
        ('iE-Extensions', _PDUSessionResourceReleaseResponseTransfer_iE_Extensions),
        ])
    PDUSessionResourceReleaseResponseTransfer._ext = []
    
    #-----< PDUSessionResourceReleaseResponseTransfer-ExtIEs >-----#
    PDUSessionResourceReleaseResponseTransfer_ExtIEs = CLASS(name='PDUSessionResourceReleaseResponseTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PDUSessionResourceReleaseResponseTransfer_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecondaryRATUsageInformation')))
    PDUSessionResourceReleaseResponseTransfer_ExtIEs._val = ASN1Set(rv=[dict([('id', 144), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceReleaseResponseTransfer_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceResumeListRESReq >-----#
    PDUSessionResourceResumeListRESReq = SEQ_OF(name='PDUSessionResourceResumeListRESReq', mode=MODE_TYPE)
    _PDUSessionResourceResumeListRESReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceResumeItemRESReq')))
    PDUSessionResourceResumeListRESReq._cont = _PDUSessionResourceResumeListRESReq__item_
    PDUSessionResourceResumeListRESReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceResumeItemRESReq >-----#
    PDUSessionResourceResumeItemRESReq = SEQ(name='PDUSessionResourceResumeItemRESReq', mode=MODE_TYPE)
    _PDUSessionResourceResumeItemRESReq_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceResumeItemRESReq_uEContextResumeRequestTransfer = OCT_STR(name='uEContextResumeRequestTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceResumeItemRESReq_uEContextResumeRequestTransfer_contain = SEQ(name='_cont_uEContextResumeRequestTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEContextResumeRequestTransfer')))
    _PDUSessionResourceResumeItemRESReq_uEContextResumeRequestTransfer._const_cont = __PDUSessionResourceResumeItemRESReq_uEContextResumeRequestTransfer_contain
    _PDUSessionResourceResumeItemRESReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceResumeItemRESReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceResumeItemRESReq_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceResumeItemRESReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__id._const_tab = ____PDUSessionResourceResumeItemRESReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceResumeItemRESReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceResumeItemRESReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceResumeItemRESReq_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceResumeItemRESReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceResumeItemRESReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceResumeItemRESReq_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceResumeItemRESReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceResumeItemRESReq_iE_Extensions__item_._ext = None
    _PDUSessionResourceResumeItemRESReq_iE_Extensions._cont = __PDUSessionResourceResumeItemRESReq_iE_Extensions__item_
    _PDUSessionResourceResumeItemRESReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceResumeItemRESReq._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceResumeItemRESReq_pDUSessionID),
        ('uEContextResumeRequestTransfer', _PDUSessionResourceResumeItemRESReq_uEContextResumeRequestTransfer),
        ('iE-Extensions', _PDUSessionResourceResumeItemRESReq_iE_Extensions),
        ])
    PDUSessionResourceResumeItemRESReq._ext = []
    
    #-----< PDUSessionResourceResumeItemRESReq-ExtIEs >-----#
    PDUSessionResourceResumeItemRESReq_ExtIEs = CLASS(name='PDUSessionResourceResumeItemRESReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceResumeItemRESReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceResumeListRESRes >-----#
    PDUSessionResourceResumeListRESRes = SEQ_OF(name='PDUSessionResourceResumeListRESRes', mode=MODE_TYPE)
    _PDUSessionResourceResumeListRESRes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceResumeItemRESRes')))
    PDUSessionResourceResumeListRESRes._cont = _PDUSessionResourceResumeListRESRes__item_
    PDUSessionResourceResumeListRESRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceResumeItemRESRes >-----#
    PDUSessionResourceResumeItemRESRes = SEQ(name='PDUSessionResourceResumeItemRESRes', mode=MODE_TYPE)
    _PDUSessionResourceResumeItemRESRes_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceResumeItemRESRes_uEContextResumeResponseTransfer = OCT_STR(name='uEContextResumeResponseTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceResumeItemRESRes_uEContextResumeResponseTransfer_contain = SEQ(name='_cont_uEContextResumeResponseTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEContextResumeResponseTransfer')))
    _PDUSessionResourceResumeItemRESRes_uEContextResumeResponseTransfer._const_cont = __PDUSessionResourceResumeItemRESRes_uEContextResumeResponseTransfer_contain
    _PDUSessionResourceResumeItemRESRes_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceResumeItemRESRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceResumeItemRESRes_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceResumeItemRESRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__id._const_tab = ____PDUSessionResourceResumeItemRESRes_iE_Extensions__item__id_tab
    ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceResumeItemRESRes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceResumeItemRESRes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceResumeItemRESRes_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceResumeItemRESRes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceResumeItemRESRes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceResumeItemRESRes_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceResumeItemRESRes_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceResumeItemRESRes_iE_Extensions__item_._ext = None
    _PDUSessionResourceResumeItemRESRes_iE_Extensions._cont = __PDUSessionResourceResumeItemRESRes_iE_Extensions__item_
    _PDUSessionResourceResumeItemRESRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceResumeItemRESRes._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceResumeItemRESRes_pDUSessionID),
        ('uEContextResumeResponseTransfer', _PDUSessionResourceResumeItemRESRes_uEContextResumeResponseTransfer),
        ('iE-Extensions', _PDUSessionResourceResumeItemRESRes_iE_Extensions),
        ])
    PDUSessionResourceResumeItemRESRes._ext = []
    
    #-----< PDUSessionResourceResumeItemRESRes-ExtIEs >-----#
    PDUSessionResourceResumeItemRESRes_ExtIEs = CLASS(name='PDUSessionResourceResumeItemRESRes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceResumeItemRESRes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceSecondaryRATUsageList >-----#
    PDUSessionResourceSecondaryRATUsageList = SEQ_OF(name='PDUSessionResourceSecondaryRATUsageList', mode=MODE_TYPE)
    _PDUSessionResourceSecondaryRATUsageList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSecondaryRATUsageItem')))
    PDUSessionResourceSecondaryRATUsageList._cont = _PDUSessionResourceSecondaryRATUsageList__item_
    PDUSessionResourceSecondaryRATUsageList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceSecondaryRATUsageItem >-----#
    PDUSessionResourceSecondaryRATUsageItem = SEQ(name='PDUSessionResourceSecondaryRATUsageItem', mode=MODE_TYPE)
    _PDUSessionResourceSecondaryRATUsageItem_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceSecondaryRATUsageItem_secondaryRATDataUsageReportTransfer = OCT_STR(name='secondaryRATDataUsageReportTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceSecondaryRATUsageItem_secondaryRATDataUsageReportTransfer_contain = SEQ(name='_cont_secondaryRATDataUsageReportTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecondaryRATDataUsageReportTransfer')))
    _PDUSessionResourceSecondaryRATUsageItem_secondaryRATDataUsageReportTransfer._const_cont = __PDUSessionResourceSecondaryRATUsageItem_secondaryRATDataUsageReportTransfer_contain
    _PDUSessionResourceSecondaryRATUsageItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__id._const_tab = ____PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__id_tab
    ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item_._ext = None
    _PDUSessionResourceSecondaryRATUsageItem_iE_Extensions._cont = __PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item_
    _PDUSessionResourceSecondaryRATUsageItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceSecondaryRATUsageItem._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceSecondaryRATUsageItem_pDUSessionID),
        ('secondaryRATDataUsageReportTransfer', _PDUSessionResourceSecondaryRATUsageItem_secondaryRATDataUsageReportTransfer),
        ('iE-Extensions', _PDUSessionResourceSecondaryRATUsageItem_iE_Extensions),
        ])
    PDUSessionResourceSecondaryRATUsageItem._ext = []
    
    #-----< PDUSessionResourceSecondaryRATUsageItem-ExtIEs >-----#
    PDUSessionResourceSecondaryRATUsageItem_ExtIEs = CLASS(name='PDUSessionResourceSecondaryRATUsageItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceSecondaryRATUsageItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceSetupListCxtReq >-----#
    PDUSessionResourceSetupListCxtReq = SEQ_OF(name='PDUSessionResourceSetupListCxtReq', mode=MODE_TYPE)
    _PDUSessionResourceSetupListCxtReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupItemCxtReq')))
    PDUSessionResourceSetupListCxtReq._cont = _PDUSessionResourceSetupListCxtReq__item_
    PDUSessionResourceSetupListCxtReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceSetupItemCxtReq >-----#
    PDUSessionResourceSetupItemCxtReq = SEQ(name='PDUSessionResourceSetupItemCxtReq', mode=MODE_TYPE)
    _PDUSessionResourceSetupItemCxtReq_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceSetupItemCxtReq_nAS_PDU = OCT_STR(name='nAS-PDU', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')), opt=True)
    _PDUSessionResourceSetupItemCxtReq_s_NSSAI = SEQ(name='s-NSSAI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _PDUSessionResourceSetupItemCxtReq_pDUSessionResourceSetupRequestTransfer = OCT_STR(name='pDUSessionResourceSetupRequestTransfer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceSetupItemCxtReq_pDUSessionResourceSetupRequestTransfer_contain = SEQ(name='_cont_pDUSessionResourceSetupRequestTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupRequestTransfer')))
    _PDUSessionResourceSetupItemCxtReq_pDUSessionResourceSetupRequestTransfer._const_cont = __PDUSessionResourceSetupItemCxtReq_pDUSessionResourceSetupRequestTransfer_contain
    _PDUSessionResourceSetupItemCxtReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceSetupItemCxtReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEActivityBehaviour')))
    ____PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 281), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id._const_tab = ____PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceSetupItemCxtReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceSetupItemCxtReq_iE_Extensions__item_._ext = None
    _PDUSessionResourceSetupItemCxtReq_iE_Extensions._cont = __PDUSessionResourceSetupItemCxtReq_iE_Extensions__item_
    _PDUSessionResourceSetupItemCxtReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceSetupItemCxtReq._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceSetupItemCxtReq_pDUSessionID),
        ('nAS-PDU', _PDUSessionResourceSetupItemCxtReq_nAS_PDU),
        ('s-NSSAI', _PDUSessionResourceSetupItemCxtReq_s_NSSAI),
        ('pDUSessionResourceSetupRequestTransfer', _PDUSessionResourceSetupItemCxtReq_pDUSessionResourceSetupRequestTransfer),
        ('iE-Extensions', _PDUSessionResourceSetupItemCxtReq_iE_Extensions),
        ])
    PDUSessionResourceSetupItemCxtReq._ext = []
    
    #-----< PDUSessionResourceSetupItemCxtReq-ExtIEs >-----#
    PDUSessionResourceSetupItemCxtReq_ExtIEs = CLASS(name='PDUSessionResourceSetupItemCxtReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PDUSessionResourceSetupItemCxtReq_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEActivityBehaviour')))
    PDUSessionResourceSetupItemCxtReq_ExtIEs._val = ASN1Set(rv=[dict([('id', 281), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceSetupItemCxtReq_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceSetupListCxtRes >-----#
    PDUSessionResourceSetupListCxtRes = SEQ_OF(name='PDUSessionResourceSetupListCxtRes', mode=MODE_TYPE)
    _PDUSessionResourceSetupListCxtRes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupItemCxtRes')))
    PDUSessionResourceSetupListCxtRes._cont = _PDUSessionResourceSetupListCxtRes__item_
    PDUSessionResourceSetupListCxtRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceSetupItemCxtRes >-----#
    PDUSessionResourceSetupItemCxtRes = SEQ(name='PDUSessionResourceSetupItemCxtRes', mode=MODE_TYPE)
    _PDUSessionResourceSetupItemCxtRes_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceSetupItemCxtRes_pDUSessionResourceSetupResponseTransfer = OCT_STR(name='pDUSessionResourceSetupResponseTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceSetupItemCxtRes_pDUSessionResourceSetupResponseTransfer_contain = SEQ(name='_cont_pDUSessionResourceSetupResponseTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupResponseTransfer')))
    _PDUSessionResourceSetupItemCxtRes_pDUSessionResourceSetupResponseTransfer._const_cont = __PDUSessionResourceSetupItemCxtRes_pDUSessionResourceSetupResponseTransfer_contain
    _PDUSessionResourceSetupItemCxtRes_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceSetupItemCxtRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__id._const_tab = ____PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceSetupItemCxtRes_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceSetupItemCxtRes_iE_Extensions__item_._ext = None
    _PDUSessionResourceSetupItemCxtRes_iE_Extensions._cont = __PDUSessionResourceSetupItemCxtRes_iE_Extensions__item_
    _PDUSessionResourceSetupItemCxtRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceSetupItemCxtRes._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceSetupItemCxtRes_pDUSessionID),
        ('pDUSessionResourceSetupResponseTransfer', _PDUSessionResourceSetupItemCxtRes_pDUSessionResourceSetupResponseTransfer),
        ('iE-Extensions', _PDUSessionResourceSetupItemCxtRes_iE_Extensions),
        ])
    PDUSessionResourceSetupItemCxtRes._ext = []
    
    #-----< PDUSessionResourceSetupItemCxtRes-ExtIEs >-----#
    PDUSessionResourceSetupItemCxtRes_ExtIEs = CLASS(name='PDUSessionResourceSetupItemCxtRes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceSetupItemCxtRes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceSetupListHOReq >-----#
    PDUSessionResourceSetupListHOReq = SEQ_OF(name='PDUSessionResourceSetupListHOReq', mode=MODE_TYPE)
    _PDUSessionResourceSetupListHOReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupItemHOReq')))
    PDUSessionResourceSetupListHOReq._cont = _PDUSessionResourceSetupListHOReq__item_
    PDUSessionResourceSetupListHOReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceSetupItemHOReq >-----#
    PDUSessionResourceSetupItemHOReq = SEQ(name='PDUSessionResourceSetupItemHOReq', mode=MODE_TYPE)
    _PDUSessionResourceSetupItemHOReq_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceSetupItemHOReq_s_NSSAI = SEQ(name='s-NSSAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _PDUSessionResourceSetupItemHOReq_handoverRequestTransfer = OCT_STR(name='handoverRequestTransfer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceSetupItemHOReq_handoverRequestTransfer_contain = SEQ(name='_cont_handoverRequestTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupRequestTransfer')))
    _PDUSessionResourceSetupItemHOReq_handoverRequestTransfer._const_cont = __PDUSessionResourceSetupItemHOReq_handoverRequestTransfer_contain
    _PDUSessionResourceSetupItemHOReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceSetupItemHOReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEActivityBehaviour')))
    ____PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 281), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id._const_tab = ____PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceSetupItemHOReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceSetupItemHOReq_iE_Extensions__item_._ext = None
    _PDUSessionResourceSetupItemHOReq_iE_Extensions._cont = __PDUSessionResourceSetupItemHOReq_iE_Extensions__item_
    _PDUSessionResourceSetupItemHOReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceSetupItemHOReq._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceSetupItemHOReq_pDUSessionID),
        ('s-NSSAI', _PDUSessionResourceSetupItemHOReq_s_NSSAI),
        ('handoverRequestTransfer', _PDUSessionResourceSetupItemHOReq_handoverRequestTransfer),
        ('iE-Extensions', _PDUSessionResourceSetupItemHOReq_iE_Extensions),
        ])
    PDUSessionResourceSetupItemHOReq._ext = []
    
    #-----< PDUSessionResourceSetupItemHOReq-ExtIEs >-----#
    PDUSessionResourceSetupItemHOReq_ExtIEs = CLASS(name='PDUSessionResourceSetupItemHOReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PDUSessionResourceSetupItemHOReq_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEActivityBehaviour')))
    PDUSessionResourceSetupItemHOReq_ExtIEs._val = ASN1Set(rv=[dict([('id', 281), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceSetupItemHOReq_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceSetupListSUReq >-----#
    PDUSessionResourceSetupListSUReq = SEQ_OF(name='PDUSessionResourceSetupListSUReq', mode=MODE_TYPE)
    _PDUSessionResourceSetupListSUReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupItemSUReq')))
    PDUSessionResourceSetupListSUReq._cont = _PDUSessionResourceSetupListSUReq__item_
    PDUSessionResourceSetupListSUReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceSetupItemSUReq >-----#
    PDUSessionResourceSetupItemSUReq = SEQ(name='PDUSessionResourceSetupItemSUReq', mode=MODE_TYPE)
    _PDUSessionResourceSetupItemSUReq_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceSetupItemSUReq_pDUSessionNAS_PDU = OCT_STR(name='pDUSessionNAS-PDU', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')), opt=True)
    _PDUSessionResourceSetupItemSUReq_s_NSSAI = SEQ(name='s-NSSAI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _PDUSessionResourceSetupItemSUReq_pDUSessionResourceSetupRequestTransfer = OCT_STR(name='pDUSessionResourceSetupRequestTransfer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceSetupItemSUReq_pDUSessionResourceSetupRequestTransfer_contain = SEQ(name='_cont_pDUSessionResourceSetupRequestTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupRequestTransfer')))
    _PDUSessionResourceSetupItemSUReq_pDUSessionResourceSetupRequestTransfer._const_cont = __PDUSessionResourceSetupItemSUReq_pDUSessionResourceSetupRequestTransfer_contain
    _PDUSessionResourceSetupItemSUReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceSetupItemSUReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEActivityBehaviour')))
    ____PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 281), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id._const_tab = ____PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceSetupItemSUReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceSetupItemSUReq_iE_Extensions__item_._ext = None
    _PDUSessionResourceSetupItemSUReq_iE_Extensions._cont = __PDUSessionResourceSetupItemSUReq_iE_Extensions__item_
    _PDUSessionResourceSetupItemSUReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceSetupItemSUReq._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceSetupItemSUReq_pDUSessionID),
        ('pDUSessionNAS-PDU', _PDUSessionResourceSetupItemSUReq_pDUSessionNAS_PDU),
        ('s-NSSAI', _PDUSessionResourceSetupItemSUReq_s_NSSAI),
        ('pDUSessionResourceSetupRequestTransfer', _PDUSessionResourceSetupItemSUReq_pDUSessionResourceSetupRequestTransfer),
        ('iE-Extensions', _PDUSessionResourceSetupItemSUReq_iE_Extensions),
        ])
    PDUSessionResourceSetupItemSUReq._ext = []
    
    #-----< PDUSessionResourceSetupItemSUReq-ExtIEs >-----#
    PDUSessionResourceSetupItemSUReq_ExtIEs = CLASS(name='PDUSessionResourceSetupItemSUReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PDUSessionResourceSetupItemSUReq_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEActivityBehaviour')))
    PDUSessionResourceSetupItemSUReq_ExtIEs._val = ASN1Set(rv=[dict([('id', 281), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceSetupItemSUReq_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceSetupListSURes >-----#
    PDUSessionResourceSetupListSURes = SEQ_OF(name='PDUSessionResourceSetupListSURes', mode=MODE_TYPE)
    _PDUSessionResourceSetupListSURes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupItemSURes')))
    PDUSessionResourceSetupListSURes._cont = _PDUSessionResourceSetupListSURes__item_
    PDUSessionResourceSetupListSURes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceSetupItemSURes >-----#
    PDUSessionResourceSetupItemSURes = SEQ(name='PDUSessionResourceSetupItemSURes', mode=MODE_TYPE)
    _PDUSessionResourceSetupItemSURes_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceSetupItemSURes_pDUSessionResourceSetupResponseTransfer = OCT_STR(name='pDUSessionResourceSetupResponseTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceSetupItemSURes_pDUSessionResourceSetupResponseTransfer_contain = SEQ(name='_cont_pDUSessionResourceSetupResponseTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupResponseTransfer')))
    _PDUSessionResourceSetupItemSURes_pDUSessionResourceSetupResponseTransfer._const_cont = __PDUSessionResourceSetupItemSURes_pDUSessionResourceSetupResponseTransfer_contain
    _PDUSessionResourceSetupItemSURes_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceSetupItemSURes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceSetupItemSURes_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSetupItemSURes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__id._const_tab = ____PDUSessionResourceSetupItemSURes_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceSetupItemSURes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSetupItemSURes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceSetupItemSURes_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceSetupItemSURes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSetupItemSURes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceSetupItemSURes_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceSetupItemSURes_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceSetupItemSURes_iE_Extensions__item_._ext = None
    _PDUSessionResourceSetupItemSURes_iE_Extensions._cont = __PDUSessionResourceSetupItemSURes_iE_Extensions__item_
    _PDUSessionResourceSetupItemSURes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceSetupItemSURes._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceSetupItemSURes_pDUSessionID),
        ('pDUSessionResourceSetupResponseTransfer', _PDUSessionResourceSetupItemSURes_pDUSessionResourceSetupResponseTransfer),
        ('iE-Extensions', _PDUSessionResourceSetupItemSURes_iE_Extensions),
        ])
    PDUSessionResourceSetupItemSURes._ext = []
    
    #-----< PDUSessionResourceSetupItemSURes-ExtIEs >-----#
    PDUSessionResourceSetupItemSURes_ExtIEs = CLASS(name='PDUSessionResourceSetupItemSURes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceSetupItemSURes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceSetupRequestTransfer >-----#
    PDUSessionResourceSetupRequestTransfer = SEQ(name='PDUSessionResourceSetupRequestTransfer', mode=MODE_TYPE)
    _PDUSessionResourceSetupRequestTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PDUSessionResourceSetupRequestTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionAggregateMaximumBitRate')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationList')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DataForwardingNotPossible')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionType')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityIndication')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NetworkInstance')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowSetupRequestList')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_8 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CommonNetworkInstance')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DirectForwardingPathAvailability')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_10 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_11 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationList')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_12 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CommonNetworkInstance')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_13 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedundantPDUSessionInformation')))
    _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_14 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionSetupRequestList')))
    ____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 130), ('criticality', 'reject'), ('Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 139), ('criticality', 'reject'), ('Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 126), ('criticality', 'reject'), ('Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 127), ('criticality', 'reject'), ('Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 134), ('criticality', 'reject'), ('Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 138), ('criticality', 'reject'), ('Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 129), ('criticality', 'reject'), ('Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 136), ('criticality', 'reject'), ('Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_7), ('presence', 'mandatory')]), dict([('id', 166), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 22), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 195), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 186), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 190), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 197), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 318), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id._const_tab = ____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab
    ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id._const_tab_at = None
    ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__criticality._const_tab = ____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab
    ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__value._const_tab = ____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab
    ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __PDUSessionResourceSetupRequestTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id),
        ('criticality', ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__criticality),
        ('value', ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__value),
        ])
    __PDUSessionResourceSetupRequestTransfer_protocolIEs__item_._ext = None
    _PDUSessionResourceSetupRequestTransfer_protocolIEs._cont = __PDUSessionResourceSetupRequestTransfer_protocolIEs__item_
    _PDUSessionResourceSetupRequestTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDUSessionResourceSetupRequestTransfer._cont = ASN1Dict([
        ('protocolIEs', _PDUSessionResourceSetupRequestTransfer_protocolIEs),
        ])
    PDUSessionResourceSetupRequestTransfer._ext = []
    
    #-----< PDUSessionResourceSetupRequestTransferIEs >-----#
    PDUSessionResourceSetupRequestTransferIEs = CLASS(name='PDUSessionResourceSetupRequestTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionAggregateMaximumBitRate')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationList')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DataForwardingNotPossible')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionType')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityIndication')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NetworkInstance')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowSetupRequestList')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_8 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CommonNetworkInstance')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DirectForwardingPathAvailability')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_10 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_11 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationList')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_12 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CommonNetworkInstance')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_13 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedundantPDUSessionInformation')))
    _PDUSessionResourceSetupRequestTransferIEs_val_Value_14 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionSetupRequestList')))
    PDUSessionResourceSetupRequestTransferIEs._val = ASN1Set(rv=[dict([('id', 130), ('criticality', 'reject'), ('Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 139), ('criticality', 'reject'), ('Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 126), ('criticality', 'reject'), ('Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 127), ('criticality', 'reject'), ('Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 134), ('criticality', 'reject'), ('Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 138), ('criticality', 'reject'), ('Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 129), ('criticality', 'reject'), ('Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 136), ('criticality', 'reject'), ('Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_7), ('presence', 'mandatory')]), dict([('id', 166), ('criticality', 'ignore'), ('Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 22), ('criticality', 'ignore'), ('Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 195), ('criticality', 'ignore'), ('Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 186), ('criticality', 'ignore'), ('Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_11), ('presence', 'optional')]), dict([('id', 190), ('criticality', 'ignore'), ('Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_12), ('presence', 'optional')]), dict([('id', 197), ('criticality', 'ignore'), ('Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_13), ('presence', 'optional')]), dict([('id', 318), ('criticality', 'ignore'), ('Value', _PDUSessionResourceSetupRequestTransferIEs_val_Value_14), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceSetupResponseTransfer >-----#
    PDUSessionResourceSetupResponseTransfer = SEQ(name='PDUSessionResourceSetupResponseTransfer', mode=MODE_TYPE)
    _PDUSessionResourceSetupResponseTransfer_dLQosFlowPerTNLInformation = SEQ(name='dLQosFlowPerTNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformation')))
    _PDUSessionResourceSetupResponseTransfer_additionalDLQosFlowPerTNLInformation = SEQ_OF(name='additionalDLQosFlowPerTNLInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')), opt=True)
    _PDUSessionResourceSetupResponseTransfer_securityResult = SEQ(name='securityResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SecurityResult')), opt=True)
    _PDUSessionResourceSetupResponseTransfer_qosFlowFailedToSetupList = SEQ_OF(name='qosFlowFailedToSetupList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithCause')), opt=True)
    _PDUSessionResourceSetupResponseTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceSetupResponseTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformation')))
    _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')))
    _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedundantPDUSessionInformation')))
    _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_3 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SupportIndicator')))
    _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionSetupResponseList')))
    _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_6 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionFailedtoSetupList')))
    ____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 193), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 184), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 198), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 27), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 309), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 312), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 310), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id._const_tab = ____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceSetupResponseTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceSetupResponseTransfer_iE_Extensions__item_._ext = None
    _PDUSessionResourceSetupResponseTransfer_iE_Extensions._cont = __PDUSessionResourceSetupResponseTransfer_iE_Extensions__item_
    _PDUSessionResourceSetupResponseTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceSetupResponseTransfer._cont = ASN1Dict([
        ('dLQosFlowPerTNLInformation', _PDUSessionResourceSetupResponseTransfer_dLQosFlowPerTNLInformation),
        ('additionalDLQosFlowPerTNLInformation', _PDUSessionResourceSetupResponseTransfer_additionalDLQosFlowPerTNLInformation),
        ('securityResult', _PDUSessionResourceSetupResponseTransfer_securityResult),
        ('qosFlowFailedToSetupList', _PDUSessionResourceSetupResponseTransfer_qosFlowFailedToSetupList),
        ('iE-Extensions', _PDUSessionResourceSetupResponseTransfer_iE_Extensions),
        ])
    PDUSessionResourceSetupResponseTransfer._ext = []
    
    #-----< PDUSessionResourceSetupResponseTransfer-ExtIEs >-----#
    PDUSessionResourceSetupResponseTransfer_ExtIEs = CLASS(name='PDUSessionResourceSetupResponseTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformation')))
    _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationList')))
    _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedundantPDUSessionInformation')))
    _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_3 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SupportIndicator')))
    _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionSetupResponseList')))
    _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_6 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionFailedtoSetupList')))
    PDUSessionResourceSetupResponseTransfer_ExtIEs._val = ASN1Set(rv=[dict([('id', 193), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 184), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 198), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 27), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 309), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 312), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 310), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceSetupUnsuccessfulTransfer >-----#
    PDUSessionResourceSetupUnsuccessfulTransfer = SEQ(name='PDUSessionResourceSetupUnsuccessfulTransfer', mode=MODE_TYPE)
    _PDUSessionResourceSetupUnsuccessfulTransfer_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _PDUSessionResourceSetupUnsuccessfulTransfer_criticalityDiagnostics = SEQ(name='criticalityDiagnostics', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')), opt=True)
    _PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__id._const_tab = ____PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__id_tab
    ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item_._ext = None
    _PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions._cont = __PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item_
    _PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceSetupUnsuccessfulTransfer._cont = ASN1Dict([
        ('cause', _PDUSessionResourceSetupUnsuccessfulTransfer_cause),
        ('criticalityDiagnostics', _PDUSessionResourceSetupUnsuccessfulTransfer_criticalityDiagnostics),
        ('iE-Extensions', _PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions),
        ])
    PDUSessionResourceSetupUnsuccessfulTransfer._ext = []
    
    #-----< PDUSessionResourceSetupUnsuccessfulTransfer-ExtIEs >-----#
    PDUSessionResourceSetupUnsuccessfulTransfer_ExtIEs = CLASS(name='PDUSessionResourceSetupUnsuccessfulTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceSetupUnsuccessfulTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceSuspendListSUSReq >-----#
    PDUSessionResourceSuspendListSUSReq = SEQ_OF(name='PDUSessionResourceSuspendListSUSReq', mode=MODE_TYPE)
    _PDUSessionResourceSuspendListSUSReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSuspendItemSUSReq')))
    PDUSessionResourceSuspendListSUSReq._cont = _PDUSessionResourceSuspendListSUSReq__item_
    PDUSessionResourceSuspendListSUSReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceSuspendItemSUSReq >-----#
    PDUSessionResourceSuspendItemSUSReq = SEQ(name='PDUSessionResourceSuspendItemSUSReq', mode=MODE_TYPE)
    _PDUSessionResourceSuspendItemSUSReq_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceSuspendItemSUSReq_uEContextSuspendRequestTransfer = OCT_STR(name='uEContextSuspendRequestTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceSuspendItemSUSReq_uEContextSuspendRequestTransfer_contain = SEQ(name='_cont_uEContextSuspendRequestTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEContextSuspendRequestTransfer')))
    _PDUSessionResourceSuspendItemSUSReq_uEContextSuspendRequestTransfer._const_cont = __PDUSessionResourceSuspendItemSUSReq_uEContextSuspendRequestTransfer_contain
    _PDUSessionResourceSuspendItemSUSReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__id._const_tab = ____PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__id_tab
    ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item_._ext = None
    _PDUSessionResourceSuspendItemSUSReq_iE_Extensions._cont = __PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item_
    _PDUSessionResourceSuspendItemSUSReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceSuspendItemSUSReq._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceSuspendItemSUSReq_pDUSessionID),
        ('uEContextSuspendRequestTransfer', _PDUSessionResourceSuspendItemSUSReq_uEContextSuspendRequestTransfer),
        ('iE-Extensions', _PDUSessionResourceSuspendItemSUSReq_iE_Extensions),
        ])
    PDUSessionResourceSuspendItemSUSReq._ext = []
    
    #-----< PDUSessionResourceSuspendItemSUSReq-ExtIEs >-----#
    PDUSessionResourceSuspendItemSUSReq_ExtIEs = CLASS(name='PDUSessionResourceSuspendItemSUSReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceSuspendItemSUSReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceSwitchedList >-----#
    PDUSessionResourceSwitchedList = SEQ_OF(name='PDUSessionResourceSwitchedList', mode=MODE_TYPE)
    _PDUSessionResourceSwitchedList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSwitchedItem')))
    PDUSessionResourceSwitchedList._cont = _PDUSessionResourceSwitchedList__item_
    PDUSessionResourceSwitchedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceSwitchedItem >-----#
    PDUSessionResourceSwitchedItem = SEQ(name='PDUSessionResourceSwitchedItem', mode=MODE_TYPE)
    _PDUSessionResourceSwitchedItem_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceSwitchedItem_pathSwitchRequestAcknowledgeTransfer = OCT_STR(name='pathSwitchRequestAcknowledgeTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceSwitchedItem_pathSwitchRequestAcknowledgeTransfer_contain = SEQ(name='_cont_pathSwitchRequestAcknowledgeTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PathSwitchRequestAcknowledgeTransfer')))
    _PDUSessionResourceSwitchedItem_pathSwitchRequestAcknowledgeTransfer._const_cont = __PDUSessionResourceSwitchedItem_pathSwitchRequestAcknowledgeTransfer_contain
    _PDUSessionResourceSwitchedItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceSwitchedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceSwitchedItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceSwitchedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PDUSessionResourceSwitchedItem_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEActivityBehaviour')))
    ____PDUSessionResourceSwitchedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 281), ('criticality', 'ignore'), ('Extension', _____PDUSessionResourceSwitchedItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceSwitchedItem_iE_Extensions__item__id._const_tab = ____PDUSessionResourceSwitchedItem_iE_Extensions__item__id_tab
    ___PDUSessionResourceSwitchedItem_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceSwitchedItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceSwitchedItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PDUSessionResourceSwitchedItem_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceSwitchedItem_iE_Extensions__item__id_tab
    ___PDUSessionResourceSwitchedItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceSwitchedItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceSwitchedItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PDUSessionResourceSwitchedItem_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceSwitchedItem_iE_Extensions__item__id_tab
    ___PDUSessionResourceSwitchedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceSwitchedItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceSwitchedItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceSwitchedItem_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceSwitchedItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceSwitchedItem_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceSwitchedItem_iE_Extensions__item_._ext = None
    _PDUSessionResourceSwitchedItem_iE_Extensions._cont = __PDUSessionResourceSwitchedItem_iE_Extensions__item_
    _PDUSessionResourceSwitchedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceSwitchedItem._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceSwitchedItem_pDUSessionID),
        ('pathSwitchRequestAcknowledgeTransfer', _PDUSessionResourceSwitchedItem_pathSwitchRequestAcknowledgeTransfer),
        ('iE-Extensions', _PDUSessionResourceSwitchedItem_iE_Extensions),
        ])
    PDUSessionResourceSwitchedItem._ext = []
    
    #-----< PDUSessionResourceSwitchedItem-ExtIEs >-----#
    PDUSessionResourceSwitchedItem_ExtIEs = CLASS(name='PDUSessionResourceSwitchedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PDUSessionResourceSwitchedItem_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExpectedUEActivityBehaviour')))
    PDUSessionResourceSwitchedItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 281), ('criticality', 'ignore'), ('Extension', _PDUSessionResourceSwitchedItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceToBeSwitchedDLList >-----#
    PDUSessionResourceToBeSwitchedDLList = SEQ_OF(name='PDUSessionResourceToBeSwitchedDLList', mode=MODE_TYPE)
    _PDUSessionResourceToBeSwitchedDLList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceToBeSwitchedDLItem')))
    PDUSessionResourceToBeSwitchedDLList._cont = _PDUSessionResourceToBeSwitchedDLList__item_
    PDUSessionResourceToBeSwitchedDLList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceToBeSwitchedDLItem >-----#
    PDUSessionResourceToBeSwitchedDLItem = SEQ(name='PDUSessionResourceToBeSwitchedDLItem', mode=MODE_TYPE)
    _PDUSessionResourceToBeSwitchedDLItem_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceToBeSwitchedDLItem_pathSwitchRequestTransfer = OCT_STR(name='pathSwitchRequestTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceToBeSwitchedDLItem_pathSwitchRequestTransfer_contain = SEQ(name='_cont_pathSwitchRequestTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PathSwitchRequestTransfer')))
    _PDUSessionResourceToBeSwitchedDLItem_pathSwitchRequestTransfer._const_cont = __PDUSessionResourceToBeSwitchedDLItem_pathSwitchRequestTransfer_contain
    _PDUSessionResourceToBeSwitchedDLItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__id._const_tab = ____PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__id_tab
    ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item_._ext = None
    _PDUSessionResourceToBeSwitchedDLItem_iE_Extensions._cont = __PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item_
    _PDUSessionResourceToBeSwitchedDLItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceToBeSwitchedDLItem._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceToBeSwitchedDLItem_pDUSessionID),
        ('pathSwitchRequestTransfer', _PDUSessionResourceToBeSwitchedDLItem_pathSwitchRequestTransfer),
        ('iE-Extensions', _PDUSessionResourceToBeSwitchedDLItem_iE_Extensions),
        ])
    PDUSessionResourceToBeSwitchedDLItem._ext = []
    
    #-----< PDUSessionResourceToBeSwitchedDLItem-ExtIEs >-----#
    PDUSessionResourceToBeSwitchedDLItem_ExtIEs = CLASS(name='PDUSessionResourceToBeSwitchedDLItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceToBeSwitchedDLItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceToReleaseListHOCmd >-----#
    PDUSessionResourceToReleaseListHOCmd = SEQ_OF(name='PDUSessionResourceToReleaseListHOCmd', mode=MODE_TYPE)
    _PDUSessionResourceToReleaseListHOCmd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceToReleaseItemHOCmd')))
    PDUSessionResourceToReleaseListHOCmd._cont = _PDUSessionResourceToReleaseListHOCmd__item_
    PDUSessionResourceToReleaseListHOCmd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceToReleaseItemHOCmd >-----#
    PDUSessionResourceToReleaseItemHOCmd = SEQ(name='PDUSessionResourceToReleaseItemHOCmd', mode=MODE_TYPE)
    _PDUSessionResourceToReleaseItemHOCmd_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceToReleaseItemHOCmd_handoverPreparationUnsuccessfulTransfer = OCT_STR(name='handoverPreparationUnsuccessfulTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceToReleaseItemHOCmd_handoverPreparationUnsuccessfulTransfer_contain = SEQ(name='_cont_handoverPreparationUnsuccessfulTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HandoverPreparationUnsuccessfulTransfer')))
    _PDUSessionResourceToReleaseItemHOCmd_handoverPreparationUnsuccessfulTransfer._const_cont = __PDUSessionResourceToReleaseItemHOCmd_handoverPreparationUnsuccessfulTransfer_contain
    _PDUSessionResourceToReleaseItemHOCmd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__id._const_tab = ____PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__id_tab
    ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item_._ext = None
    _PDUSessionResourceToReleaseItemHOCmd_iE_Extensions._cont = __PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item_
    _PDUSessionResourceToReleaseItemHOCmd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceToReleaseItemHOCmd._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceToReleaseItemHOCmd_pDUSessionID),
        ('handoverPreparationUnsuccessfulTransfer', _PDUSessionResourceToReleaseItemHOCmd_handoverPreparationUnsuccessfulTransfer),
        ('iE-Extensions', _PDUSessionResourceToReleaseItemHOCmd_iE_Extensions),
        ])
    PDUSessionResourceToReleaseItemHOCmd._ext = []
    
    #-----< PDUSessionResourceToReleaseItemHOCmd-ExtIEs >-----#
    PDUSessionResourceToReleaseItemHOCmd_ExtIEs = CLASS(name='PDUSessionResourceToReleaseItemHOCmd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceToReleaseItemHOCmd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceToReleaseListRelCmd >-----#
    PDUSessionResourceToReleaseListRelCmd = SEQ_OF(name='PDUSessionResourceToReleaseListRelCmd', mode=MODE_TYPE)
    _PDUSessionResourceToReleaseListRelCmd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceToReleaseItemRelCmd')))
    PDUSessionResourceToReleaseListRelCmd._cont = _PDUSessionResourceToReleaseListRelCmd__item_
    PDUSessionResourceToReleaseListRelCmd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PDUSessionResourceToReleaseItemRelCmd >-----#
    PDUSessionResourceToReleaseItemRelCmd = SEQ(name='PDUSessionResourceToReleaseItemRelCmd', mode=MODE_TYPE)
    _PDUSessionResourceToReleaseItemRelCmd_pDUSessionID = INT(name='pDUSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionID')))
    _PDUSessionResourceToReleaseItemRelCmd_pDUSessionResourceReleaseCommandTransfer = OCT_STR(name='pDUSessionResourceReleaseCommandTransfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PDUSessionResourceToReleaseItemRelCmd_pDUSessionResourceReleaseCommandTransfer_contain = SEQ(name='_cont_pDUSessionResourceReleaseCommandTransfer', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleaseCommandTransfer')))
    _PDUSessionResourceToReleaseItemRelCmd_pDUSessionResourceReleaseCommandTransfer._const_cont = __PDUSessionResourceToReleaseItemRelCmd_pDUSessionResourceReleaseCommandTransfer_contain
    _PDUSessionResourceToReleaseItemRelCmd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__id._const_tab = ____PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__id_tab
    ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__criticality._const_tab = ____PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__criticality_tab
    ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__extensionValue_tab
    ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__id),
        ('criticality', ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item_._ext = None
    _PDUSessionResourceToReleaseItemRelCmd_iE_Extensions._cont = __PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item_
    _PDUSessionResourceToReleaseItemRelCmd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionResourceToReleaseItemRelCmd._cont = ASN1Dict([
        ('pDUSessionID', _PDUSessionResourceToReleaseItemRelCmd_pDUSessionID),
        ('pDUSessionResourceReleaseCommandTransfer', _PDUSessionResourceToReleaseItemRelCmd_pDUSessionResourceReleaseCommandTransfer),
        ('iE-Extensions', _PDUSessionResourceToReleaseItemRelCmd_iE_Extensions),
        ])
    PDUSessionResourceToReleaseItemRelCmd._ext = []
    
    #-----< PDUSessionResourceToReleaseItemRelCmd-ExtIEs >-----#
    PDUSessionResourceToReleaseItemRelCmd_ExtIEs = CLASS(name='PDUSessionResourceToReleaseItemRelCmd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionResourceToReleaseItemRelCmd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDUSessionType >-----#
    PDUSessionType = ENUM(name='PDUSessionType', mode=MODE_TYPE)
    PDUSessionType._cont = ASN1Dict([('ipv4', 0), ('ipv6', 1), ('ipv4v6', 2), ('ethernet', 3), ('unstructured', 4)])
    PDUSessionType._ext = []
    
    #-----< PDUSessionUsageReport >-----#
    PDUSessionUsageReport = SEQ(name='PDUSessionUsageReport', mode=MODE_TYPE)
    _PDUSessionUsageReport_rATType = ENUM(name='rATType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PDUSessionUsageReport_rATType._cont = ASN1Dict([('nr', 0), ('eutra', 1), ('nr-unlicensed', 2), ('e-utra-unlicensed', 3)])
    _PDUSessionUsageReport_rATType._ext = ['nr-unlicensed', 'e-utra-unlicensed']
    _PDUSessionUsageReport_pDUSessionTimedReportList = SEQ_OF(name='pDUSessionTimedReportList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'VolumeTimedReportList')))
    _PDUSessionUsageReport_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PDUSessionUsageReport_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PDUSessionUsageReport_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PDUSessionUsageReport_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionUsageReport_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionUsageReport_iE_Extensions__item__id._const_tab = ____PDUSessionUsageReport_iE_Extensions__item__id_tab
    ___PDUSessionUsageReport_iE_Extensions__item__id._const_tab_at = None
    ___PDUSessionUsageReport_iE_Extensions__item__id._const_tab_id = 'id'
    ___PDUSessionUsageReport_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PDUSessionUsageReport_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionUsageReport_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionUsageReport_iE_Extensions__item__criticality._const_tab = ____PDUSessionUsageReport_iE_Extensions__item__criticality_tab
    ___PDUSessionUsageReport_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionUsageReport_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionUsageReport_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PDUSessionUsageReport_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PDUSessionUsageReport_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PDUSessionUsageReport_iE_Extensions__item__extensionValue._const_tab = ____PDUSessionUsageReport_iE_Extensions__item__extensionValue_tab
    ___PDUSessionUsageReport_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PDUSessionUsageReport_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PDUSessionUsageReport_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PDUSessionUsageReport_iE_Extensions__item__id),
        ('criticality', ___PDUSessionUsageReport_iE_Extensions__item__criticality),
        ('extensionValue', ___PDUSessionUsageReport_iE_Extensions__item__extensionValue),
        ])
    __PDUSessionUsageReport_iE_Extensions__item_._ext = None
    _PDUSessionUsageReport_iE_Extensions._cont = __PDUSessionUsageReport_iE_Extensions__item_
    _PDUSessionUsageReport_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PDUSessionUsageReport._cont = ASN1Dict([
        ('rATType', _PDUSessionUsageReport_rATType),
        ('pDUSessionTimedReportList', _PDUSessionUsageReport_pDUSessionTimedReportList),
        ('iE-Extensions', _PDUSessionUsageReport_iE_Extensions),
        ])
    PDUSessionUsageReport._ext = []
    
    #-----< PDUSessionUsageReport-ExtIEs >-----#
    PDUSessionUsageReport_ExtIEs = CLASS(name='PDUSessionUsageReport-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PDUSessionUsageReport_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PEIPSassistanceInformation >-----#
    PEIPSassistanceInformation = SEQ(name='PEIPSassistanceInformation', mode=MODE_TYPE)
    _PEIPSassistanceInformation_cNsubgroupID = INT(name='cNsubgroupID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CNsubgroupID')))
    _PEIPSassistanceInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PEIPSassistanceInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PEIPSassistanceInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PEIPSassistanceInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PEIPSassistanceInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PEIPSassistanceInformation_iE_Extensions__item__id._const_tab = ____PEIPSassistanceInformation_iE_Extensions__item__id_tab
    ___PEIPSassistanceInformation_iE_Extensions__item__id._const_tab_at = None
    ___PEIPSassistanceInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___PEIPSassistanceInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PEIPSassistanceInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PEIPSassistanceInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PEIPSassistanceInformation_iE_Extensions__item__criticality._const_tab = ____PEIPSassistanceInformation_iE_Extensions__item__criticality_tab
    ___PEIPSassistanceInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PEIPSassistanceInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PEIPSassistanceInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PEIPSassistanceInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PEIPSassistanceInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PEIPSassistanceInformation_iE_Extensions__item__extensionValue._const_tab = ____PEIPSassistanceInformation_iE_Extensions__item__extensionValue_tab
    ___PEIPSassistanceInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PEIPSassistanceInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PEIPSassistanceInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PEIPSassistanceInformation_iE_Extensions__item__id),
        ('criticality', ___PEIPSassistanceInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___PEIPSassistanceInformation_iE_Extensions__item__extensionValue),
        ])
    __PEIPSassistanceInformation_iE_Extensions__item_._ext = None
    _PEIPSassistanceInformation_iE_Extensions._cont = __PEIPSassistanceInformation_iE_Extensions__item_
    _PEIPSassistanceInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PEIPSassistanceInformation._cont = ASN1Dict([
        ('cNsubgroupID', _PEIPSassistanceInformation_cNsubgroupID),
        ('iE-Extensions', _PEIPSassistanceInformation_iE_Extensions),
        ])
    PEIPSassistanceInformation._ext = []
    
    #-----< PEIPSassistanceInformation-ExtIEs >-----#
    PEIPSassistanceInformation_ExtIEs = CLASS(name='PEIPSassistanceInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PEIPSassistanceInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Periodicity >-----#
    Periodicity = INT(name='Periodicity', mode=MODE_TYPE)
    Periodicity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=640000)], ev=[], er=[])
    
    #-----< PeriodicRegistrationUpdateTimer >-----#
    PeriodicRegistrationUpdateTimer = BIT_STR(name='PeriodicRegistrationUpdateTimer', mode=MODE_TYPE)
    PeriodicRegistrationUpdateTimer._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< PLMNIdentity >-----#
    PLMNIdentity = OCT_STR(name='PLMNIdentity', mode=MODE_TYPE)
    PLMNIdentity._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< PLMNAreaBasedQMC >-----#
    PLMNAreaBasedQMC = SEQ(name='PLMNAreaBasedQMC', mode=MODE_TYPE)
    _PLMNAreaBasedQMC_plmnListforQMC = SEQ_OF(name='plmnListforQMC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNListforQMC')))
    _PLMNAreaBasedQMC_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PLMNAreaBasedQMC_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PLMNAreaBasedQMC_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PLMNAreaBasedQMC_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PLMNAreaBasedQMC_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLMNAreaBasedQMC_iE_Extensions__item__id._const_tab = ____PLMNAreaBasedQMC_iE_Extensions__item__id_tab
    ___PLMNAreaBasedQMC_iE_Extensions__item__id._const_tab_at = None
    ___PLMNAreaBasedQMC_iE_Extensions__item__id._const_tab_id = 'id'
    ___PLMNAreaBasedQMC_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PLMNAreaBasedQMC_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PLMNAreaBasedQMC_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLMNAreaBasedQMC_iE_Extensions__item__criticality._const_tab = ____PLMNAreaBasedQMC_iE_Extensions__item__criticality_tab
    ___PLMNAreaBasedQMC_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PLMNAreaBasedQMC_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PLMNAreaBasedQMC_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PLMNAreaBasedQMC_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PLMNAreaBasedQMC_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLMNAreaBasedQMC_iE_Extensions__item__extensionValue._const_tab = ____PLMNAreaBasedQMC_iE_Extensions__item__extensionValue_tab
    ___PLMNAreaBasedQMC_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PLMNAreaBasedQMC_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PLMNAreaBasedQMC_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PLMNAreaBasedQMC_iE_Extensions__item__id),
        ('criticality', ___PLMNAreaBasedQMC_iE_Extensions__item__criticality),
        ('extensionValue', ___PLMNAreaBasedQMC_iE_Extensions__item__extensionValue),
        ])
    __PLMNAreaBasedQMC_iE_Extensions__item_._ext = None
    _PLMNAreaBasedQMC_iE_Extensions._cont = __PLMNAreaBasedQMC_iE_Extensions__item_
    _PLMNAreaBasedQMC_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PLMNAreaBasedQMC._cont = ASN1Dict([
        ('plmnListforQMC', _PLMNAreaBasedQMC_plmnListforQMC),
        ('iE-Extensions', _PLMNAreaBasedQMC_iE_Extensions),
        ])
    PLMNAreaBasedQMC._ext = []
    
    #-----< PLMNAreaBasedQMC-ExtIEs >-----#
    PLMNAreaBasedQMC_ExtIEs = CLASS(name='PLMNAreaBasedQMC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PLMNAreaBasedQMC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PLMNListforQMC >-----#
    PLMNListforQMC = SEQ_OF(name='PLMNListforQMC', mode=MODE_TYPE)
    _PLMNListforQMC__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    PLMNListforQMC._cont = _PLMNListforQMC__item_
    PLMNListforQMC._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PLMNSupportList >-----#
    PLMNSupportList = SEQ_OF(name='PLMNSupportList', mode=MODE_TYPE)
    _PLMNSupportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PLMNSupportItem')))
    PLMNSupportList._cont = _PLMNSupportList__item_
    PLMNSupportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< PLMNSupportItem >-----#
    PLMNSupportItem = SEQ(name='PLMNSupportItem', mode=MODE_TYPE)
    _PLMNSupportItem_pLMNIdentity = OCT_STR(name='pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _PLMNSupportItem_sliceSupportList = SEQ_OF(name='sliceSupportList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SliceSupportList')))
    _PLMNSupportItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PLMNSupportItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PLMNSupportItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PLMNSupportItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____PLMNSupportItem_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NPN-Support')))
    _____PLMNSupportItem_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedSliceSupportList')))
    _____PLMNSupportItem_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'OnboardingSupport')))
    ____PLMNSupportItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 258), ('criticality', 'reject'), ('Extension', _____PLMNSupportItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 270), ('criticality', 'reject'), ('Extension', _____PLMNSupportItem_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 325), ('criticality', 'ignore'), ('Extension', _____PLMNSupportItem_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PLMNSupportItem_iE_Extensions__item__id._const_tab = ____PLMNSupportItem_iE_Extensions__item__id_tab
    ___PLMNSupportItem_iE_Extensions__item__id._const_tab_at = None
    ___PLMNSupportItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PLMNSupportItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PLMNSupportItem_iE_Extensions__item__criticality._const_tab = ____PLMNSupportItem_iE_Extensions__item__id_tab
    ___PLMNSupportItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PLMNSupportItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PLMNSupportItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PLMNSupportItem_iE_Extensions__item__extensionValue._const_tab = ____PLMNSupportItem_iE_Extensions__item__id_tab
    ___PLMNSupportItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PLMNSupportItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PLMNSupportItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PLMNSupportItem_iE_Extensions__item__id),
        ('criticality', ___PLMNSupportItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PLMNSupportItem_iE_Extensions__item__extensionValue),
        ])
    __PLMNSupportItem_iE_Extensions__item_._ext = None
    _PLMNSupportItem_iE_Extensions._cont = __PLMNSupportItem_iE_Extensions__item_
    _PLMNSupportItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PLMNSupportItem._cont = ASN1Dict([
        ('pLMNIdentity', _PLMNSupportItem_pLMNIdentity),
        ('sliceSupportList', _PLMNSupportItem_sliceSupportList),
        ('iE-Extensions', _PLMNSupportItem_iE_Extensions),
        ])
    PLMNSupportItem._ext = []
    
    #-----< PLMNSupportItem-ExtIEs >-----#
    PLMNSupportItem_ExtIEs = CLASS(name='PLMNSupportItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _PLMNSupportItem_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NPN-Support')))
    _PLMNSupportItem_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedSliceSupportList')))
    _PLMNSupportItem_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'OnboardingSupport')))
    PLMNSupportItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 258), ('criticality', 'reject'), ('Extension', _PLMNSupportItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 270), ('criticality', 'reject'), ('Extension', _PLMNSupportItem_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 325), ('criticality', 'ignore'), ('Extension', _PLMNSupportItem_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PNI-NPN-MobilityInformation >-----#
    PNI_NPN_MobilityInformation = SEQ(name='PNI-NPN-MobilityInformation', mode=MODE_TYPE)
    _PNI_NPN_MobilityInformation_allowed_PNI_NPI_List = SEQ_OF(name='allowed-PNI-NPI-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Allowed-PNI-NPN-List')))
    _PNI_NPN_MobilityInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PNI_NPN_MobilityInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___PNI_NPN_MobilityInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____PNI_NPN_MobilityInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PNI_NPN_MobilityInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PNI_NPN_MobilityInformation_iE_Extensions__item__id._const_tab = ____PNI_NPN_MobilityInformation_iE_Extensions__item__id_tab
    ___PNI_NPN_MobilityInformation_iE_Extensions__item__id._const_tab_at = None
    ___PNI_NPN_MobilityInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___PNI_NPN_MobilityInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PNI_NPN_MobilityInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PNI_NPN_MobilityInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PNI_NPN_MobilityInformation_iE_Extensions__item__criticality._const_tab = ____PNI_NPN_MobilityInformation_iE_Extensions__item__criticality_tab
    ___PNI_NPN_MobilityInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PNI_NPN_MobilityInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PNI_NPN_MobilityInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PNI_NPN_MobilityInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____PNI_NPN_MobilityInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PNI_NPN_MobilityInformation_iE_Extensions__item__extensionValue._const_tab = ____PNI_NPN_MobilityInformation_iE_Extensions__item__extensionValue_tab
    ___PNI_NPN_MobilityInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PNI_NPN_MobilityInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PNI_NPN_MobilityInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PNI_NPN_MobilityInformation_iE_Extensions__item__id),
        ('criticality', ___PNI_NPN_MobilityInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___PNI_NPN_MobilityInformation_iE_Extensions__item__extensionValue),
        ])
    __PNI_NPN_MobilityInformation_iE_Extensions__item_._ext = None
    _PNI_NPN_MobilityInformation_iE_Extensions._cont = __PNI_NPN_MobilityInformation_iE_Extensions__item_
    _PNI_NPN_MobilityInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PNI_NPN_MobilityInformation._cont = ASN1Dict([
        ('allowed-PNI-NPI-List', _PNI_NPN_MobilityInformation_allowed_PNI_NPI_List),
        ('iE-Extensions', _PNI_NPN_MobilityInformation_iE_Extensions),
        ])
    PNI_NPN_MobilityInformation._ext = []
    
    #-----< PNI-NPN-MobilityInformation-ExtIEs >-----#
    PNI_NPN_MobilityInformation_ExtIEs = CLASS(name='PNI-NPN-MobilityInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    PNI_NPN_MobilityInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PortNumber >-----#
    PortNumber = OCT_STR(name='PortNumber', mode=MODE_TYPE)
    PortNumber._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< Pre-emptionCapability >-----#
    Pre_emptionCapability = ENUM(name='Pre-emptionCapability', mode=MODE_TYPE)
    Pre_emptionCapability._cont = ASN1Dict([('shall-not-trigger-pre-emption', 0), ('may-trigger-pre-emption', 1)])
    Pre_emptionCapability._ext = []
    
    #-----< Pre-emptionVulnerability >-----#
    Pre_emptionVulnerability = ENUM(name='Pre-emptionVulnerability', mode=MODE_TYPE)
    Pre_emptionVulnerability._cont = ASN1Dict([('not-pre-emptable', 0), ('pre-emptable', 1)])
    Pre_emptionVulnerability._ext = []
    
    #-----< PriorityLevelARP >-----#
    PriorityLevelARP = INT(name='PriorityLevelARP', mode=MODE_TYPE)
    PriorityLevelARP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< PriorityLevelQos >-----#
    PriorityLevelQos = INT(name='PriorityLevelQos', mode=MODE_TYPE)
    PriorityLevelQos._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=[], er=[])
    
    #-----< PWSFailedCellIDList >-----#
    PWSFailedCellIDList = CHOICE(name='PWSFailedCellIDList', mode=MODE_TYPE)
    _PWSFailedCellIDList_eUTRA_CGI_PWSFailedList = SEQ_OF(name='eUTRA-CGI-PWSFailedList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGIList')))
    _PWSFailedCellIDList_nR_CGI_PWSFailedList = SEQ_OF(name='nR-CGI-PWSFailedList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NR-CGIList')))
    _PWSFailedCellIDList_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __PWSFailedCellIDList_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___PWSFailedCellIDList_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___PWSFailedCellIDList_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PWSFailedCellIDList_choice_Extensions_id._const_tab = ___PWSFailedCellIDList_choice_Extensions_id_tab
    __PWSFailedCellIDList_choice_Extensions_id._const_tab_at = None
    __PWSFailedCellIDList_choice_Extensions_id._const_tab_id = 'id'
    __PWSFailedCellIDList_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___PWSFailedCellIDList_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___PWSFailedCellIDList_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PWSFailedCellIDList_choice_Extensions_criticality._const_tab = ___PWSFailedCellIDList_choice_Extensions_criticality_tab
    __PWSFailedCellIDList_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __PWSFailedCellIDList_choice_Extensions_criticality._const_tab_id = 'criticality'
    __PWSFailedCellIDList_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___PWSFailedCellIDList_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___PWSFailedCellIDList_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PWSFailedCellIDList_choice_Extensions_value._const_tab = ___PWSFailedCellIDList_choice_Extensions_value_tab
    __PWSFailedCellIDList_choice_Extensions_value._const_tab_at = ('..', 'id')
    __PWSFailedCellIDList_choice_Extensions_value._const_tab_id = 'Value'
    _PWSFailedCellIDList_choice_Extensions._cont = ASN1Dict([
        ('id', __PWSFailedCellIDList_choice_Extensions_id),
        ('criticality', __PWSFailedCellIDList_choice_Extensions_criticality),
        ('value', __PWSFailedCellIDList_choice_Extensions_value),
        ])
    _PWSFailedCellIDList_choice_Extensions._ext = None
    PWSFailedCellIDList._cont = ASN1Dict([
        ('eUTRA-CGI-PWSFailedList', _PWSFailedCellIDList_eUTRA_CGI_PWSFailedList),
        ('nR-CGI-PWSFailedList', _PWSFailedCellIDList_nR_CGI_PWSFailedList),
        ('choice-Extensions', _PWSFailedCellIDList_choice_Extensions),
        ])
    PWSFailedCellIDList._ext = None
    
    #-----< PWSFailedCellIDList-ExtIEs >-----#
    PWSFailedCellIDList_ExtIEs = CLASS(name='PWSFailedCellIDList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    PWSFailedCellIDList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QMCConfigInfo >-----#
    QMCConfigInfo = SEQ(name='QMCConfigInfo', mode=MODE_TYPE)
    _QMCConfigInfo_uEAppLayerMeasInfoList = SEQ_OF(name='uEAppLayerMeasInfoList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UEAppLayerMeasInfoList')))
    _QMCConfigInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QMCConfigInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QMCConfigInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____QMCConfigInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QMCConfigInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QMCConfigInfo_iE_Extensions__item__id._const_tab = ____QMCConfigInfo_iE_Extensions__item__id_tab
    ___QMCConfigInfo_iE_Extensions__item__id._const_tab_at = None
    ___QMCConfigInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___QMCConfigInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____QMCConfigInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QMCConfigInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QMCConfigInfo_iE_Extensions__item__criticality._const_tab = ____QMCConfigInfo_iE_Extensions__item__criticality_tab
    ___QMCConfigInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QMCConfigInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QMCConfigInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____QMCConfigInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QMCConfigInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QMCConfigInfo_iE_Extensions__item__extensionValue._const_tab = ____QMCConfigInfo_iE_Extensions__item__extensionValue_tab
    ___QMCConfigInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QMCConfigInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QMCConfigInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QMCConfigInfo_iE_Extensions__item__id),
        ('criticality', ___QMCConfigInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___QMCConfigInfo_iE_Extensions__item__extensionValue),
        ])
    __QMCConfigInfo_iE_Extensions__item_._ext = None
    _QMCConfigInfo_iE_Extensions._cont = __QMCConfigInfo_iE_Extensions__item_
    _QMCConfigInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QMCConfigInfo._cont = ASN1Dict([
        ('uEAppLayerMeasInfoList', _QMCConfigInfo_uEAppLayerMeasInfoList),
        ('iE-Extensions', _QMCConfigInfo_iE_Extensions),
        ])
    QMCConfigInfo._ext = []
    
    #-----< QMCConfigInfo-ExtIEs >-----#
    QMCConfigInfo_ExtIEs = CLASS(name='QMCConfigInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    QMCConfigInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QMCDeactivation >-----#
    QMCDeactivation = SEQ(name='QMCDeactivation', mode=MODE_TYPE)
    _QMCDeactivation_qoEReferenceList = SEQ_OF(name='qoEReferenceList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QoEReferenceList')))
    _QMCDeactivation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QMCDeactivation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QMCDeactivation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____QMCDeactivation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QMCDeactivation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QMCDeactivation_iE_Extensions__item__id._const_tab = ____QMCDeactivation_iE_Extensions__item__id_tab
    ___QMCDeactivation_iE_Extensions__item__id._const_tab_at = None
    ___QMCDeactivation_iE_Extensions__item__id._const_tab_id = 'id'
    ___QMCDeactivation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____QMCDeactivation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QMCDeactivation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QMCDeactivation_iE_Extensions__item__criticality._const_tab = ____QMCDeactivation_iE_Extensions__item__criticality_tab
    ___QMCDeactivation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QMCDeactivation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QMCDeactivation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____QMCDeactivation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QMCDeactivation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QMCDeactivation_iE_Extensions__item__extensionValue._const_tab = ____QMCDeactivation_iE_Extensions__item__extensionValue_tab
    ___QMCDeactivation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QMCDeactivation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QMCDeactivation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QMCDeactivation_iE_Extensions__item__id),
        ('criticality', ___QMCDeactivation_iE_Extensions__item__criticality),
        ('extensionValue', ___QMCDeactivation_iE_Extensions__item__extensionValue),
        ])
    __QMCDeactivation_iE_Extensions__item_._ext = None
    _QMCDeactivation_iE_Extensions._cont = __QMCDeactivation_iE_Extensions__item_
    _QMCDeactivation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QMCDeactivation._cont = ASN1Dict([
        ('qoEReferenceList', _QMCDeactivation_qoEReferenceList),
        ('iE-Extensions', _QMCDeactivation_iE_Extensions),
        ])
    QMCDeactivation._ext = []
    
    #-----< QMCDeactivation-ExtIEs >-----#
    QMCDeactivation_ExtIEs = CLASS(name='QMCDeactivation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    QMCDeactivation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QoEReferenceList >-----#
    QoEReferenceList = SEQ_OF(name='QoEReferenceList', mode=MODE_TYPE)
    _QoEReferenceList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QoEReference')))
    QoEReferenceList._cont = _QoEReferenceList__item_
    QoEReferenceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< QoEReference >-----#
    QoEReference = OCT_STR(name='QoEReference', mode=MODE_TYPE)
    QoEReference._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< QosCharacteristics >-----#
    QosCharacteristics = CHOICE(name='QosCharacteristics', mode=MODE_TYPE)
    _QosCharacteristics_nonDynamic5QI = SEQ(name='nonDynamic5QI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NonDynamic5QIDescriptor')))
    _QosCharacteristics_dynamic5QI = SEQ(name='dynamic5QI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Dynamic5QIDescriptor')))
    _QosCharacteristics_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __QosCharacteristics_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___QosCharacteristics_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___QosCharacteristics_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __QosCharacteristics_choice_Extensions_id._const_tab = ___QosCharacteristics_choice_Extensions_id_tab
    __QosCharacteristics_choice_Extensions_id._const_tab_at = None
    __QosCharacteristics_choice_Extensions_id._const_tab_id = 'id'
    __QosCharacteristics_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___QosCharacteristics_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___QosCharacteristics_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __QosCharacteristics_choice_Extensions_criticality._const_tab = ___QosCharacteristics_choice_Extensions_criticality_tab
    __QosCharacteristics_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __QosCharacteristics_choice_Extensions_criticality._const_tab_id = 'criticality'
    __QosCharacteristics_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___QosCharacteristics_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___QosCharacteristics_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __QosCharacteristics_choice_Extensions_value._const_tab = ___QosCharacteristics_choice_Extensions_value_tab
    __QosCharacteristics_choice_Extensions_value._const_tab_at = ('..', 'id')
    __QosCharacteristics_choice_Extensions_value._const_tab_id = 'Value'
    _QosCharacteristics_choice_Extensions._cont = ASN1Dict([
        ('id', __QosCharacteristics_choice_Extensions_id),
        ('criticality', __QosCharacteristics_choice_Extensions_criticality),
        ('value', __QosCharacteristics_choice_Extensions_value),
        ])
    _QosCharacteristics_choice_Extensions._ext = None
    QosCharacteristics._cont = ASN1Dict([
        ('nonDynamic5QI', _QosCharacteristics_nonDynamic5QI),
        ('dynamic5QI', _QosCharacteristics_dynamic5QI),
        ('choice-Extensions', _QosCharacteristics_choice_Extensions),
        ])
    QosCharacteristics._ext = None
    
    #-----< QosCharacteristics-ExtIEs >-----#
    QosCharacteristics_ExtIEs = CLASS(name='QosCharacteristics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    QosCharacteristics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QosFlowAcceptedList >-----#
    QosFlowAcceptedList = SEQ_OF(name='QosFlowAcceptedList', mode=MODE_TYPE)
    _QosFlowAcceptedList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowAcceptedItem')))
    QosFlowAcceptedList._cont = _QosFlowAcceptedList__item_
    QosFlowAcceptedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QosFlowAcceptedItem >-----#
    QosFlowAcceptedItem = SEQ(name='QosFlowAcceptedItem', mode=MODE_TYPE)
    _QosFlowAcceptedItem_qosFlowIdentifier = INT(name='qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _QosFlowAcceptedItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowAcceptedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowAcceptedItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____QosFlowAcceptedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____QosFlowAcceptedItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetIndex')))
    ____QosFlowAcceptedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 221), ('criticality', 'ignore'), ('Extension', _____QosFlowAcceptedItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___QosFlowAcceptedItem_iE_Extensions__item__id._const_tab = ____QosFlowAcceptedItem_iE_Extensions__item__id_tab
    ___QosFlowAcceptedItem_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowAcceptedItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___QosFlowAcceptedItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___QosFlowAcceptedItem_iE_Extensions__item__criticality._const_tab = ____QosFlowAcceptedItem_iE_Extensions__item__id_tab
    ___QosFlowAcceptedItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QosFlowAcceptedItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QosFlowAcceptedItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___QosFlowAcceptedItem_iE_Extensions__item__extensionValue._const_tab = ____QosFlowAcceptedItem_iE_Extensions__item__id_tab
    ___QosFlowAcceptedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QosFlowAcceptedItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QosFlowAcceptedItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QosFlowAcceptedItem_iE_Extensions__item__id),
        ('criticality', ___QosFlowAcceptedItem_iE_Extensions__item__criticality),
        ('extensionValue', ___QosFlowAcceptedItem_iE_Extensions__item__extensionValue),
        ])
    __QosFlowAcceptedItem_iE_Extensions__item_._ext = None
    _QosFlowAcceptedItem_iE_Extensions._cont = __QosFlowAcceptedItem_iE_Extensions__item_
    _QosFlowAcceptedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowAcceptedItem._cont = ASN1Dict([
        ('qosFlowIdentifier', _QosFlowAcceptedItem_qosFlowIdentifier),
        ('iE-Extensions', _QosFlowAcceptedItem_iE_Extensions),
        ])
    QosFlowAcceptedItem._ext = []
    
    #-----< QosFlowAcceptedItem-ExtIEs >-----#
    QosFlowAcceptedItem_ExtIEs = CLASS(name='QosFlowAcceptedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _QosFlowAcceptedItem_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetIndex')))
    QosFlowAcceptedItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 221), ('criticality', 'ignore'), ('Extension', _QosFlowAcceptedItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< QosFlowAddOrModifyRequestList >-----#
    QosFlowAddOrModifyRequestList = SEQ_OF(name='QosFlowAddOrModifyRequestList', mode=MODE_TYPE)
    _QosFlowAddOrModifyRequestList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowAddOrModifyRequestItem')))
    QosFlowAddOrModifyRequestList._cont = _QosFlowAddOrModifyRequestList__item_
    QosFlowAddOrModifyRequestList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QosFlowAddOrModifyRequestItem >-----#
    QosFlowAddOrModifyRequestItem = SEQ(name='QosFlowAddOrModifyRequestItem', mode=MODE_TYPE)
    _QosFlowAddOrModifyRequestItem_qosFlowIdentifier = INT(name='qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _QosFlowAddOrModifyRequestItem_qosFlowLevelQosParameters = SEQ(name='qosFlowLevelQosParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowLevelQosParameters')), opt=True)
    _QosFlowAddOrModifyRequestItem_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'E-RAB-ID')), opt=True)
    _QosFlowAddOrModifyRequestItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowAddOrModifyRequestItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____QosFlowAddOrModifyRequestItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____QosFlowAddOrModifyRequestItem_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TSCTrafficCharacteristics')))
    _____QosFlowAddOrModifyRequestItem_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedundantQosFlowIndicator')))
    ____QosFlowAddOrModifyRequestItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 196), ('criticality', 'ignore'), ('Extension', _____QosFlowAddOrModifyRequestItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 194), ('criticality', 'ignore'), ('Extension', _____QosFlowAddOrModifyRequestItem_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__id._const_tab = ____QosFlowAddOrModifyRequestItem_iE_Extensions__item__id_tab
    ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__criticality._const_tab = ____QosFlowAddOrModifyRequestItem_iE_Extensions__item__id_tab
    ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__extensionValue._const_tab = ____QosFlowAddOrModifyRequestItem_iE_Extensions__item__id_tab
    ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QosFlowAddOrModifyRequestItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__id),
        ('criticality', ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__criticality),
        ('extensionValue', ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__extensionValue),
        ])
    __QosFlowAddOrModifyRequestItem_iE_Extensions__item_._ext = None
    _QosFlowAddOrModifyRequestItem_iE_Extensions._cont = __QosFlowAddOrModifyRequestItem_iE_Extensions__item_
    _QosFlowAddOrModifyRequestItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowAddOrModifyRequestItem._cont = ASN1Dict([
        ('qosFlowIdentifier', _QosFlowAddOrModifyRequestItem_qosFlowIdentifier),
        ('qosFlowLevelQosParameters', _QosFlowAddOrModifyRequestItem_qosFlowLevelQosParameters),
        ('e-RAB-ID', _QosFlowAddOrModifyRequestItem_e_RAB_ID),
        ('iE-Extensions', _QosFlowAddOrModifyRequestItem_iE_Extensions),
        ])
    QosFlowAddOrModifyRequestItem._ext = []
    
    #-----< QosFlowAddOrModifyRequestItem-ExtIEs >-----#
    QosFlowAddOrModifyRequestItem_ExtIEs = CLASS(name='QosFlowAddOrModifyRequestItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _QosFlowAddOrModifyRequestItem_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TSCTrafficCharacteristics')))
    _QosFlowAddOrModifyRequestItem_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedundantQosFlowIndicator')))
    QosFlowAddOrModifyRequestItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 196), ('criticality', 'ignore'), ('Extension', _QosFlowAddOrModifyRequestItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 194), ('criticality', 'ignore'), ('Extension', _QosFlowAddOrModifyRequestItem_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< QosFlowAddOrModifyResponseList >-----#
    QosFlowAddOrModifyResponseList = SEQ_OF(name='QosFlowAddOrModifyResponseList', mode=MODE_TYPE)
    _QosFlowAddOrModifyResponseList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowAddOrModifyResponseItem')))
    QosFlowAddOrModifyResponseList._cont = _QosFlowAddOrModifyResponseList__item_
    QosFlowAddOrModifyResponseList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QosFlowAddOrModifyResponseItem >-----#
    QosFlowAddOrModifyResponseItem = SEQ(name='QosFlowAddOrModifyResponseItem', mode=MODE_TYPE)
    _QosFlowAddOrModifyResponseItem_qosFlowIdentifier = INT(name='qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _QosFlowAddOrModifyResponseItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowAddOrModifyResponseItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____QosFlowAddOrModifyResponseItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____QosFlowAddOrModifyResponseItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetIndex')))
    ____QosFlowAddOrModifyResponseItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 221), ('criticality', 'ignore'), ('Extension', _____QosFlowAddOrModifyResponseItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__id._const_tab = ____QosFlowAddOrModifyResponseItem_iE_Extensions__item__id_tab
    ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__criticality._const_tab = ____QosFlowAddOrModifyResponseItem_iE_Extensions__item__id_tab
    ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__extensionValue._const_tab = ____QosFlowAddOrModifyResponseItem_iE_Extensions__item__id_tab
    ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QosFlowAddOrModifyResponseItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__id),
        ('criticality', ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__criticality),
        ('extensionValue', ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__extensionValue),
        ])
    __QosFlowAddOrModifyResponseItem_iE_Extensions__item_._ext = None
    _QosFlowAddOrModifyResponseItem_iE_Extensions._cont = __QosFlowAddOrModifyResponseItem_iE_Extensions__item_
    _QosFlowAddOrModifyResponseItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowAddOrModifyResponseItem._cont = ASN1Dict([
        ('qosFlowIdentifier', _QosFlowAddOrModifyResponseItem_qosFlowIdentifier),
        ('iE-Extensions', _QosFlowAddOrModifyResponseItem_iE_Extensions),
        ])
    QosFlowAddOrModifyResponseItem._ext = []
    
    #-----< QosFlowAddOrModifyResponseItem-ExtIEs >-----#
    QosFlowAddOrModifyResponseItem_ExtIEs = CLASS(name='QosFlowAddOrModifyResponseItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _QosFlowAddOrModifyResponseItem_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetIndex')))
    QosFlowAddOrModifyResponseItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 221), ('criticality', 'ignore'), ('Extension', _QosFlowAddOrModifyResponseItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< QosFlowFeedbackList >-----#
    QosFlowFeedbackList = SEQ_OF(name='QosFlowFeedbackList', mode=MODE_TYPE)
    _QosFlowFeedbackList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowFeedbackItem')))
    QosFlowFeedbackList._cont = _QosFlowFeedbackList__item_
    QosFlowFeedbackList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QosFlowFeedbackItem >-----#
    QosFlowFeedbackItem = SEQ(name='QosFlowFeedbackItem', mode=MODE_TYPE)
    _QosFlowFeedbackItem_qosFlowIdentifier = INT(name='qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _QosFlowFeedbackItem_updateFeedback = BIT_STR(name='updateFeedback', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UpdateFeedback')), opt=True)
    _QosFlowFeedbackItem_cNpacketDelayBudgetDL = INT(name='cNpacketDelayBudgetDL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')), opt=True)
    _QosFlowFeedbackItem_cNpacketDelayBudgetUL = INT(name='cNpacketDelayBudgetUL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')), opt=True)
    _QosFlowFeedbackItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowFeedbackItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowFeedbackItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____QosFlowFeedbackItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowFeedbackItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowFeedbackItem_iE_Extensions__item__id._const_tab = ____QosFlowFeedbackItem_iE_Extensions__item__id_tab
    ___QosFlowFeedbackItem_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowFeedbackItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___QosFlowFeedbackItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____QosFlowFeedbackItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowFeedbackItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowFeedbackItem_iE_Extensions__item__criticality._const_tab = ____QosFlowFeedbackItem_iE_Extensions__item__criticality_tab
    ___QosFlowFeedbackItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QosFlowFeedbackItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QosFlowFeedbackItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____QosFlowFeedbackItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowFeedbackItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowFeedbackItem_iE_Extensions__item__extensionValue._const_tab = ____QosFlowFeedbackItem_iE_Extensions__item__extensionValue_tab
    ___QosFlowFeedbackItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QosFlowFeedbackItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QosFlowFeedbackItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QosFlowFeedbackItem_iE_Extensions__item__id),
        ('criticality', ___QosFlowFeedbackItem_iE_Extensions__item__criticality),
        ('extensionValue', ___QosFlowFeedbackItem_iE_Extensions__item__extensionValue),
        ])
    __QosFlowFeedbackItem_iE_Extensions__item_._ext = None
    _QosFlowFeedbackItem_iE_Extensions._cont = __QosFlowFeedbackItem_iE_Extensions__item_
    _QosFlowFeedbackItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowFeedbackItem._cont = ASN1Dict([
        ('qosFlowIdentifier', _QosFlowFeedbackItem_qosFlowIdentifier),
        ('updateFeedback', _QosFlowFeedbackItem_updateFeedback),
        ('cNpacketDelayBudgetDL', _QosFlowFeedbackItem_cNpacketDelayBudgetDL),
        ('cNpacketDelayBudgetUL', _QosFlowFeedbackItem_cNpacketDelayBudgetUL),
        ('iE-Extensions', _QosFlowFeedbackItem_iE_Extensions),
        ])
    QosFlowFeedbackItem._ext = []
    
    #-----< QosFlowFeedbackItem-ExtIEs >-----#
    QosFlowFeedbackItem_ExtIEs = CLASS(name='QosFlowFeedbackItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    QosFlowFeedbackItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QosFlowIdentifier >-----#
    QosFlowIdentifier = INT(name='QosFlowIdentifier', mode=MODE_TYPE)
    QosFlowIdentifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=[], er=[])
    
    #-----< QosFlowInformationList >-----#
    QosFlowInformationList = SEQ_OF(name='QosFlowInformationList', mode=MODE_TYPE)
    _QosFlowInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowInformationItem')))
    QosFlowInformationList._cont = _QosFlowInformationList__item_
    QosFlowInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QosFlowInformationItem >-----#
    QosFlowInformationItem = SEQ(name='QosFlowInformationItem', mode=MODE_TYPE)
    _QosFlowInformationItem_qosFlowIdentifier = INT(name='qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _QosFlowInformationItem_dLForwarding = ENUM(name='dLForwarding', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DLForwarding')), opt=True)
    _QosFlowInformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowInformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____QosFlowInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____QosFlowInformationItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ULForwarding')))
    _____QosFlowInformationItem_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _____QosFlowInformationItem_iE_Extensions__item__id_tab_val_Extension_2 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    ____QosFlowInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 163), ('criticality', 'ignore'), ('Extension', _____QosFlowInformationItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 284), ('criticality', 'ignore'), ('Extension', _____QosFlowInformationItem_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 354), ('criticality', 'ignore'), ('Extension', _____QosFlowInformationItem_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___QosFlowInformationItem_iE_Extensions__item__id._const_tab = ____QosFlowInformationItem_iE_Extensions__item__id_tab
    ___QosFlowInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowInformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___QosFlowInformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___QosFlowInformationItem_iE_Extensions__item__criticality._const_tab = ____QosFlowInformationItem_iE_Extensions__item__id_tab
    ___QosFlowInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QosFlowInformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QosFlowInformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___QosFlowInformationItem_iE_Extensions__item__extensionValue._const_tab = ____QosFlowInformationItem_iE_Extensions__item__id_tab
    ___QosFlowInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QosFlowInformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QosFlowInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QosFlowInformationItem_iE_Extensions__item__id),
        ('criticality', ___QosFlowInformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___QosFlowInformationItem_iE_Extensions__item__extensionValue),
        ])
    __QosFlowInformationItem_iE_Extensions__item_._ext = None
    _QosFlowInformationItem_iE_Extensions._cont = __QosFlowInformationItem_iE_Extensions__item_
    _QosFlowInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowInformationItem._cont = ASN1Dict([
        ('qosFlowIdentifier', _QosFlowInformationItem_qosFlowIdentifier),
        ('dLForwarding', _QosFlowInformationItem_dLForwarding),
        ('iE-Extensions', _QosFlowInformationItem_iE_Extensions),
        ])
    QosFlowInformationItem._ext = []
    
    #-----< QosFlowInformationItem-ExtIEs >-----#
    QosFlowInformationItem_ExtIEs = CLASS(name='QosFlowInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _QosFlowInformationItem_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ULForwarding')))
    _QosFlowInformationItem_ExtIEs_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _QosFlowInformationItem_ExtIEs_val_Extension_2 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    QosFlowInformationItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 163), ('criticality', 'ignore'), ('Extension', _QosFlowInformationItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 284), ('criticality', 'ignore'), ('Extension', _QosFlowInformationItem_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 354), ('criticality', 'ignore'), ('Extension', _QosFlowInformationItem_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< QosFlowLevelQosParameters >-----#
    QosFlowLevelQosParameters = SEQ(name='QosFlowLevelQosParameters', mode=MODE_TYPE)
    _QosFlowLevelQosParameters_qosCharacteristics = CHOICE(name='qosCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosCharacteristics')))
    _QosFlowLevelQosParameters_allocationAndRetentionPriority = SEQ(name='allocationAndRetentionPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AllocationAndRetentionPriority')))
    _QosFlowLevelQosParameters_gBR_QosInformation = SEQ(name='gBR-QosInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GBR-QosInformation')), opt=True)
    _QosFlowLevelQosParameters_reflectiveQosAttribute = ENUM(name='reflectiveQosAttribute', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ReflectiveQosAttribute')), opt=True)
    _QosFlowLevelQosParameters_additionalQosFlowInformation = ENUM(name='additionalQosFlowInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AdditionalQosFlowInformation')), opt=True)
    _QosFlowLevelQosParameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowLevelQosParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowLevelQosParameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____QosFlowLevelQosParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____QosFlowLevelQosParameters_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosMonitoringRequest')))
    _____QosFlowLevelQosParameters_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosMonitoringReportingFrequency')))
    ____QosFlowLevelQosParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 181), ('criticality', 'ignore'), ('Extension', _____QosFlowLevelQosParameters_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 276), ('criticality', 'ignore'), ('Extension', _____QosFlowLevelQosParameters_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___QosFlowLevelQosParameters_iE_Extensions__item__id._const_tab = ____QosFlowLevelQosParameters_iE_Extensions__item__id_tab
    ___QosFlowLevelQosParameters_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowLevelQosParameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___QosFlowLevelQosParameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___QosFlowLevelQosParameters_iE_Extensions__item__criticality._const_tab = ____QosFlowLevelQosParameters_iE_Extensions__item__id_tab
    ___QosFlowLevelQosParameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QosFlowLevelQosParameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QosFlowLevelQosParameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___QosFlowLevelQosParameters_iE_Extensions__item__extensionValue._const_tab = ____QosFlowLevelQosParameters_iE_Extensions__item__id_tab
    ___QosFlowLevelQosParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QosFlowLevelQosParameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QosFlowLevelQosParameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QosFlowLevelQosParameters_iE_Extensions__item__id),
        ('criticality', ___QosFlowLevelQosParameters_iE_Extensions__item__criticality),
        ('extensionValue', ___QosFlowLevelQosParameters_iE_Extensions__item__extensionValue),
        ])
    __QosFlowLevelQosParameters_iE_Extensions__item_._ext = None
    _QosFlowLevelQosParameters_iE_Extensions._cont = __QosFlowLevelQosParameters_iE_Extensions__item_
    _QosFlowLevelQosParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowLevelQosParameters._cont = ASN1Dict([
        ('qosCharacteristics', _QosFlowLevelQosParameters_qosCharacteristics),
        ('allocationAndRetentionPriority', _QosFlowLevelQosParameters_allocationAndRetentionPriority),
        ('gBR-QosInformation', _QosFlowLevelQosParameters_gBR_QosInformation),
        ('reflectiveQosAttribute', _QosFlowLevelQosParameters_reflectiveQosAttribute),
        ('additionalQosFlowInformation', _QosFlowLevelQosParameters_additionalQosFlowInformation),
        ('iE-Extensions', _QosFlowLevelQosParameters_iE_Extensions),
        ])
    QosFlowLevelQosParameters._ext = []
    
    #-----< QosFlowLevelQosParameters-ExtIEs >-----#
    QosFlowLevelQosParameters_ExtIEs = CLASS(name='QosFlowLevelQosParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _QosFlowLevelQosParameters_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosMonitoringRequest')))
    _QosFlowLevelQosParameters_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosMonitoringReportingFrequency')))
    QosFlowLevelQosParameters_ExtIEs._val = ASN1Set(rv=[dict([('id', 181), ('criticality', 'ignore'), ('Extension', _QosFlowLevelQosParameters_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 276), ('criticality', 'ignore'), ('Extension', _QosFlowLevelQosParameters_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< QosMonitoringRequest >-----#
    QosMonitoringRequest = ENUM(name='QosMonitoringRequest', mode=MODE_TYPE)
    QosMonitoringRequest._cont = ASN1Dict([('ul', 0), ('dl', 1), ('both', 2), ('stop', 3)])
    QosMonitoringRequest._ext = ['stop']
    
    #-----< QosMonitoringReportingFrequency >-----#
    QosMonitoringReportingFrequency = INT(name='QosMonitoringReportingFrequency', mode=MODE_TYPE)
    QosMonitoringReportingFrequency._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1800)], ev=[], er=[])
    
    #-----< QoSFlowList >-----#
    QoSFlowList = SEQ_OF(name='QoSFlowList', mode=MODE_TYPE)
    _QoSFlowList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    QoSFlowList._cont = _QoSFlowList__item_
    QoSFlowList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QosFlowListWithCause >-----#
    QosFlowListWithCause = SEQ_OF(name='QosFlowListWithCause', mode=MODE_TYPE)
    _QosFlowListWithCause__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowWithCauseItem')))
    QosFlowListWithCause._cont = _QosFlowListWithCause__item_
    QosFlowListWithCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QosFlowWithCauseItem >-----#
    QosFlowWithCauseItem = SEQ(name='QosFlowWithCauseItem', mode=MODE_TYPE)
    _QosFlowWithCauseItem_qosFlowIdentifier = INT(name='qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _QosFlowWithCauseItem_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _QosFlowWithCauseItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowWithCauseItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowWithCauseItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____QosFlowWithCauseItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowWithCauseItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowWithCauseItem_iE_Extensions__item__id._const_tab = ____QosFlowWithCauseItem_iE_Extensions__item__id_tab
    ___QosFlowWithCauseItem_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowWithCauseItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___QosFlowWithCauseItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____QosFlowWithCauseItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowWithCauseItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowWithCauseItem_iE_Extensions__item__criticality._const_tab = ____QosFlowWithCauseItem_iE_Extensions__item__criticality_tab
    ___QosFlowWithCauseItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QosFlowWithCauseItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QosFlowWithCauseItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____QosFlowWithCauseItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowWithCauseItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowWithCauseItem_iE_Extensions__item__extensionValue._const_tab = ____QosFlowWithCauseItem_iE_Extensions__item__extensionValue_tab
    ___QosFlowWithCauseItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QosFlowWithCauseItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QosFlowWithCauseItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QosFlowWithCauseItem_iE_Extensions__item__id),
        ('criticality', ___QosFlowWithCauseItem_iE_Extensions__item__criticality),
        ('extensionValue', ___QosFlowWithCauseItem_iE_Extensions__item__extensionValue),
        ])
    __QosFlowWithCauseItem_iE_Extensions__item_._ext = None
    _QosFlowWithCauseItem_iE_Extensions._cont = __QosFlowWithCauseItem_iE_Extensions__item_
    _QosFlowWithCauseItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowWithCauseItem._cont = ASN1Dict([
        ('qosFlowIdentifier', _QosFlowWithCauseItem_qosFlowIdentifier),
        ('cause', _QosFlowWithCauseItem_cause),
        ('iE-Extensions', _QosFlowWithCauseItem_iE_Extensions),
        ])
    QosFlowWithCauseItem._ext = []
    
    #-----< QosFlowWithCauseItem-ExtIEs >-----#
    QosFlowWithCauseItem_ExtIEs = CLASS(name='QosFlowWithCauseItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    QosFlowWithCauseItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QosFlowModifyConfirmList >-----#
    QosFlowModifyConfirmList = SEQ_OF(name='QosFlowModifyConfirmList', mode=MODE_TYPE)
    _QosFlowModifyConfirmList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowModifyConfirmItem')))
    QosFlowModifyConfirmList._cont = _QosFlowModifyConfirmList__item_
    QosFlowModifyConfirmList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QosFlowModifyConfirmItem >-----#
    QosFlowModifyConfirmItem = SEQ(name='QosFlowModifyConfirmItem', mode=MODE_TYPE)
    _QosFlowModifyConfirmItem_qosFlowIdentifier = INT(name='qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _QosFlowModifyConfirmItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowModifyConfirmItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowModifyConfirmItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____QosFlowModifyConfirmItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowModifyConfirmItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowModifyConfirmItem_iE_Extensions__item__id._const_tab = ____QosFlowModifyConfirmItem_iE_Extensions__item__id_tab
    ___QosFlowModifyConfirmItem_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowModifyConfirmItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___QosFlowModifyConfirmItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____QosFlowModifyConfirmItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowModifyConfirmItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowModifyConfirmItem_iE_Extensions__item__criticality._const_tab = ____QosFlowModifyConfirmItem_iE_Extensions__item__criticality_tab
    ___QosFlowModifyConfirmItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QosFlowModifyConfirmItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QosFlowModifyConfirmItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____QosFlowModifyConfirmItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowModifyConfirmItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowModifyConfirmItem_iE_Extensions__item__extensionValue._const_tab = ____QosFlowModifyConfirmItem_iE_Extensions__item__extensionValue_tab
    ___QosFlowModifyConfirmItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QosFlowModifyConfirmItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QosFlowModifyConfirmItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QosFlowModifyConfirmItem_iE_Extensions__item__id),
        ('criticality', ___QosFlowModifyConfirmItem_iE_Extensions__item__criticality),
        ('extensionValue', ___QosFlowModifyConfirmItem_iE_Extensions__item__extensionValue),
        ])
    __QosFlowModifyConfirmItem_iE_Extensions__item_._ext = None
    _QosFlowModifyConfirmItem_iE_Extensions._cont = __QosFlowModifyConfirmItem_iE_Extensions__item_
    _QosFlowModifyConfirmItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowModifyConfirmItem._cont = ASN1Dict([
        ('qosFlowIdentifier', _QosFlowModifyConfirmItem_qosFlowIdentifier),
        ('iE-Extensions', _QosFlowModifyConfirmItem_iE_Extensions),
        ])
    QosFlowModifyConfirmItem._ext = []
    
    #-----< QosFlowModifyConfirmItem-ExtIEs >-----#
    QosFlowModifyConfirmItem_ExtIEs = CLASS(name='QosFlowModifyConfirmItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    QosFlowModifyConfirmItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QosFlowNotifyList >-----#
    QosFlowNotifyList = SEQ_OF(name='QosFlowNotifyList', mode=MODE_TYPE)
    _QosFlowNotifyList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowNotifyItem')))
    QosFlowNotifyList._cont = _QosFlowNotifyList__item_
    QosFlowNotifyList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QosFlowNotifyItem >-----#
    QosFlowNotifyItem = SEQ(name='QosFlowNotifyItem', mode=MODE_TYPE)
    _QosFlowNotifyItem_qosFlowIdentifier = INT(name='qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _QosFlowNotifyItem_notificationCause = ENUM(name='notificationCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NotificationCause')))
    _QosFlowNotifyItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowNotifyItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowNotifyItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____QosFlowNotifyItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____QosFlowNotifyItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetNotifyIndex')))
    ____QosFlowNotifyItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 221), ('criticality', 'ignore'), ('Extension', _____QosFlowNotifyItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___QosFlowNotifyItem_iE_Extensions__item__id._const_tab = ____QosFlowNotifyItem_iE_Extensions__item__id_tab
    ___QosFlowNotifyItem_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowNotifyItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___QosFlowNotifyItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___QosFlowNotifyItem_iE_Extensions__item__criticality._const_tab = ____QosFlowNotifyItem_iE_Extensions__item__id_tab
    ___QosFlowNotifyItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QosFlowNotifyItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QosFlowNotifyItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___QosFlowNotifyItem_iE_Extensions__item__extensionValue._const_tab = ____QosFlowNotifyItem_iE_Extensions__item__id_tab
    ___QosFlowNotifyItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QosFlowNotifyItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QosFlowNotifyItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QosFlowNotifyItem_iE_Extensions__item__id),
        ('criticality', ___QosFlowNotifyItem_iE_Extensions__item__criticality),
        ('extensionValue', ___QosFlowNotifyItem_iE_Extensions__item__extensionValue),
        ])
    __QosFlowNotifyItem_iE_Extensions__item_._ext = None
    _QosFlowNotifyItem_iE_Extensions._cont = __QosFlowNotifyItem_iE_Extensions__item_
    _QosFlowNotifyItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowNotifyItem._cont = ASN1Dict([
        ('qosFlowIdentifier', _QosFlowNotifyItem_qosFlowIdentifier),
        ('notificationCause', _QosFlowNotifyItem_notificationCause),
        ('iE-Extensions', _QosFlowNotifyItem_iE_Extensions),
        ])
    QosFlowNotifyItem._ext = []
    
    #-----< QosFlowNotifyItem-ExtIEs >-----#
    QosFlowNotifyItem_ExtIEs = CLASS(name='QosFlowNotifyItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _QosFlowNotifyItem_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetNotifyIndex')))
    QosFlowNotifyItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 221), ('criticality', 'ignore'), ('Extension', _QosFlowNotifyItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< QosFlowParametersList >-----#
    QosFlowParametersList = SEQ_OF(name='QosFlowParametersList', mode=MODE_TYPE)
    _QosFlowParametersList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowParametersItem')))
    QosFlowParametersList._cont = _QosFlowParametersList__item_
    QosFlowParametersList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QosFlowParametersItem >-----#
    QosFlowParametersItem = SEQ(name='QosFlowParametersItem', mode=MODE_TYPE)
    _QosFlowParametersItem_qosFlowIdentifier = INT(name='qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _QosFlowParametersItem_alternativeQoSParaSetList = SEQ_OF(name='alternativeQoSParaSetList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetList')), opt=True)
    _QosFlowParametersItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowParametersItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowParametersItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____QosFlowParametersItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____QosFlowParametersItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    _____QosFlowParametersItem_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    _____QosFlowParametersItem_iE_Extensions__item__id_tab_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'BurstArrivalTime')))
    ____QosFlowParametersItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 187), ('criticality', 'ignore'), ('Extension', _____QosFlowParametersItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 188), ('criticality', 'ignore'), ('Extension', _____QosFlowParametersItem_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 279), ('criticality', 'ignore'), ('Extension', _____QosFlowParametersItem_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___QosFlowParametersItem_iE_Extensions__item__id._const_tab = ____QosFlowParametersItem_iE_Extensions__item__id_tab
    ___QosFlowParametersItem_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowParametersItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___QosFlowParametersItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___QosFlowParametersItem_iE_Extensions__item__criticality._const_tab = ____QosFlowParametersItem_iE_Extensions__item__id_tab
    ___QosFlowParametersItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QosFlowParametersItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QosFlowParametersItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___QosFlowParametersItem_iE_Extensions__item__extensionValue._const_tab = ____QosFlowParametersItem_iE_Extensions__item__id_tab
    ___QosFlowParametersItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QosFlowParametersItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QosFlowParametersItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QosFlowParametersItem_iE_Extensions__item__id),
        ('criticality', ___QosFlowParametersItem_iE_Extensions__item__criticality),
        ('extensionValue', ___QosFlowParametersItem_iE_Extensions__item__extensionValue),
        ])
    __QosFlowParametersItem_iE_Extensions__item_._ext = None
    _QosFlowParametersItem_iE_Extensions._cont = __QosFlowParametersItem_iE_Extensions__item_
    _QosFlowParametersItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowParametersItem._cont = ASN1Dict([
        ('qosFlowIdentifier', _QosFlowParametersItem_qosFlowIdentifier),
        ('alternativeQoSParaSetList', _QosFlowParametersItem_alternativeQoSParaSetList),
        ('iE-Extensions', _QosFlowParametersItem_iE_Extensions),
        ])
    QosFlowParametersItem._ext = []
    
    #-----< QosFlowParametersItem-ExtIEs >-----#
    QosFlowParametersItem_ExtIEs = CLASS(name='QosFlowParametersItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _QosFlowParametersItem_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    _QosFlowParametersItem_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedPacketDelayBudget')))
    _QosFlowParametersItem_ExtIEs_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'BurstArrivalTime')))
    QosFlowParametersItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 187), ('criticality', 'ignore'), ('Extension', _QosFlowParametersItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 188), ('criticality', 'ignore'), ('Extension', _QosFlowParametersItem_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 279), ('criticality', 'ignore'), ('Extension', _QosFlowParametersItem_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< QosFlowPerTNLInformation >-----#
    QosFlowPerTNLInformation = SEQ(name='QosFlowPerTNLInformation', mode=MODE_TYPE)
    _QosFlowPerTNLInformation_uPTransportLayerInformation = CHOICE(name='uPTransportLayerInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _QosFlowPerTNLInformation_associatedQosFlowList = SEQ_OF(name='associatedQosFlowList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AssociatedQosFlowList')))
    _QosFlowPerTNLInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowPerTNLInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowPerTNLInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____QosFlowPerTNLInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowPerTNLInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowPerTNLInformation_iE_Extensions__item__id._const_tab = ____QosFlowPerTNLInformation_iE_Extensions__item__id_tab
    ___QosFlowPerTNLInformation_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowPerTNLInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___QosFlowPerTNLInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____QosFlowPerTNLInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowPerTNLInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowPerTNLInformation_iE_Extensions__item__criticality._const_tab = ____QosFlowPerTNLInformation_iE_Extensions__item__criticality_tab
    ___QosFlowPerTNLInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QosFlowPerTNLInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QosFlowPerTNLInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____QosFlowPerTNLInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowPerTNLInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowPerTNLInformation_iE_Extensions__item__extensionValue._const_tab = ____QosFlowPerTNLInformation_iE_Extensions__item__extensionValue_tab
    ___QosFlowPerTNLInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QosFlowPerTNLInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QosFlowPerTNLInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QosFlowPerTNLInformation_iE_Extensions__item__id),
        ('criticality', ___QosFlowPerTNLInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___QosFlowPerTNLInformation_iE_Extensions__item__extensionValue),
        ])
    __QosFlowPerTNLInformation_iE_Extensions__item_._ext = None
    _QosFlowPerTNLInformation_iE_Extensions._cont = __QosFlowPerTNLInformation_iE_Extensions__item_
    _QosFlowPerTNLInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowPerTNLInformation._cont = ASN1Dict([
        ('uPTransportLayerInformation', _QosFlowPerTNLInformation_uPTransportLayerInformation),
        ('associatedQosFlowList', _QosFlowPerTNLInformation_associatedQosFlowList),
        ('iE-Extensions', _QosFlowPerTNLInformation_iE_Extensions),
        ])
    QosFlowPerTNLInformation._ext = []
    
    #-----< QosFlowPerTNLInformation-ExtIEs >-----#
    QosFlowPerTNLInformation_ExtIEs = CLASS(name='QosFlowPerTNLInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    QosFlowPerTNLInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QosFlowPerTNLInformationList >-----#
    QosFlowPerTNLInformationList = SEQ_OF(name='QosFlowPerTNLInformationList', mode=MODE_TYPE)
    _QosFlowPerTNLInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformationItem')))
    QosFlowPerTNLInformationList._cont = _QosFlowPerTNLInformationList__item_
    QosFlowPerTNLInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< QosFlowPerTNLInformationItem >-----#
    QosFlowPerTNLInformationItem = SEQ(name='QosFlowPerTNLInformationItem', mode=MODE_TYPE)
    _QosFlowPerTNLInformationItem_qosFlowPerTNLInformation = SEQ(name='qosFlowPerTNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowPerTNLInformation')))
    _QosFlowPerTNLInformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowPerTNLInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowPerTNLInformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____QosFlowPerTNLInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowPerTNLInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowPerTNLInformationItem_iE_Extensions__item__id._const_tab = ____QosFlowPerTNLInformationItem_iE_Extensions__item__id_tab
    ___QosFlowPerTNLInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowPerTNLInformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___QosFlowPerTNLInformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____QosFlowPerTNLInformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowPerTNLInformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowPerTNLInformationItem_iE_Extensions__item__criticality._const_tab = ____QosFlowPerTNLInformationItem_iE_Extensions__item__criticality_tab
    ___QosFlowPerTNLInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QosFlowPerTNLInformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QosFlowPerTNLInformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____QosFlowPerTNLInformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowPerTNLInformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowPerTNLInformationItem_iE_Extensions__item__extensionValue._const_tab = ____QosFlowPerTNLInformationItem_iE_Extensions__item__extensionValue_tab
    ___QosFlowPerTNLInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QosFlowPerTNLInformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QosFlowPerTNLInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QosFlowPerTNLInformationItem_iE_Extensions__item__id),
        ('criticality', ___QosFlowPerTNLInformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___QosFlowPerTNLInformationItem_iE_Extensions__item__extensionValue),
        ])
    __QosFlowPerTNLInformationItem_iE_Extensions__item_._ext = None
    _QosFlowPerTNLInformationItem_iE_Extensions._cont = __QosFlowPerTNLInformationItem_iE_Extensions__item_
    _QosFlowPerTNLInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowPerTNLInformationItem._cont = ASN1Dict([
        ('qosFlowPerTNLInformation', _QosFlowPerTNLInformationItem_qosFlowPerTNLInformation),
        ('iE-Extensions', _QosFlowPerTNLInformationItem_iE_Extensions),
        ])
    QosFlowPerTNLInformationItem._ext = []
    
    #-----< QosFlowPerTNLInformationItem-ExtIEs >-----#
    QosFlowPerTNLInformationItem_ExtIEs = CLASS(name='QosFlowPerTNLInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    QosFlowPerTNLInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QosFlowSetupRequestList >-----#
    QosFlowSetupRequestList = SEQ_OF(name='QosFlowSetupRequestList', mode=MODE_TYPE)
    _QosFlowSetupRequestList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowSetupRequestItem')))
    QosFlowSetupRequestList._cont = _QosFlowSetupRequestList__item_
    QosFlowSetupRequestList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QosFlowSetupRequestItem >-----#
    QosFlowSetupRequestItem = SEQ(name='QosFlowSetupRequestItem', mode=MODE_TYPE)
    _QosFlowSetupRequestItem_qosFlowIdentifier = INT(name='qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _QosFlowSetupRequestItem_qosFlowLevelQosParameters = SEQ(name='qosFlowLevelQosParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowLevelQosParameters')))
    _QosFlowSetupRequestItem_e_RAB_ID = INT(name='e-RAB-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'E-RAB-ID')), opt=True)
    _QosFlowSetupRequestItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowSetupRequestItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowSetupRequestItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____QosFlowSetupRequestItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____QosFlowSetupRequestItem_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TSCTrafficCharacteristics')))
    _____QosFlowSetupRequestItem_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedundantQosFlowIndicator')))
    ____QosFlowSetupRequestItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 196), ('criticality', 'ignore'), ('Extension', _____QosFlowSetupRequestItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 194), ('criticality', 'ignore'), ('Extension', _____QosFlowSetupRequestItem_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___QosFlowSetupRequestItem_iE_Extensions__item__id._const_tab = ____QosFlowSetupRequestItem_iE_Extensions__item__id_tab
    ___QosFlowSetupRequestItem_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowSetupRequestItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___QosFlowSetupRequestItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___QosFlowSetupRequestItem_iE_Extensions__item__criticality._const_tab = ____QosFlowSetupRequestItem_iE_Extensions__item__id_tab
    ___QosFlowSetupRequestItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QosFlowSetupRequestItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QosFlowSetupRequestItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___QosFlowSetupRequestItem_iE_Extensions__item__extensionValue._const_tab = ____QosFlowSetupRequestItem_iE_Extensions__item__id_tab
    ___QosFlowSetupRequestItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QosFlowSetupRequestItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QosFlowSetupRequestItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QosFlowSetupRequestItem_iE_Extensions__item__id),
        ('criticality', ___QosFlowSetupRequestItem_iE_Extensions__item__criticality),
        ('extensionValue', ___QosFlowSetupRequestItem_iE_Extensions__item__extensionValue),
        ])
    __QosFlowSetupRequestItem_iE_Extensions__item_._ext = None
    _QosFlowSetupRequestItem_iE_Extensions._cont = __QosFlowSetupRequestItem_iE_Extensions__item_
    _QosFlowSetupRequestItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowSetupRequestItem._cont = ASN1Dict([
        ('qosFlowIdentifier', _QosFlowSetupRequestItem_qosFlowIdentifier),
        ('qosFlowLevelQosParameters', _QosFlowSetupRequestItem_qosFlowLevelQosParameters),
        ('e-RAB-ID', _QosFlowSetupRequestItem_e_RAB_ID),
        ('iE-Extensions', _QosFlowSetupRequestItem_iE_Extensions),
        ])
    QosFlowSetupRequestItem._ext = []
    
    #-----< QosFlowSetupRequestItem-ExtIEs >-----#
    QosFlowSetupRequestItem_ExtIEs = CLASS(name='QosFlowSetupRequestItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _QosFlowSetupRequestItem_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TSCTrafficCharacteristics')))
    _QosFlowSetupRequestItem_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedundantQosFlowIndicator')))
    QosFlowSetupRequestItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 196), ('criticality', 'ignore'), ('Extension', _QosFlowSetupRequestItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 194), ('criticality', 'ignore'), ('Extension', _QosFlowSetupRequestItem_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< QosFlowListWithDataForwarding >-----#
    QosFlowListWithDataForwarding = SEQ_OF(name='QosFlowListWithDataForwarding', mode=MODE_TYPE)
    _QosFlowListWithDataForwarding__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowItemWithDataForwarding')))
    QosFlowListWithDataForwarding._cont = _QosFlowListWithDataForwarding__item_
    QosFlowListWithDataForwarding._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QosFlowItemWithDataForwarding >-----#
    QosFlowItemWithDataForwarding = SEQ(name='QosFlowItemWithDataForwarding', mode=MODE_TYPE)
    _QosFlowItemWithDataForwarding_qosFlowIdentifier = INT(name='qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _QosFlowItemWithDataForwarding_dataForwardingAccepted = ENUM(name='dataForwardingAccepted', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DataForwardingAccepted')), opt=True)
    _QosFlowItemWithDataForwarding_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowItemWithDataForwarding_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowItemWithDataForwarding_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____QosFlowItemWithDataForwarding_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____QosFlowItemWithDataForwarding_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetIndex')))
    ____QosFlowItemWithDataForwarding_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 221), ('criticality', 'ignore'), ('Extension', _____QosFlowItemWithDataForwarding_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___QosFlowItemWithDataForwarding_iE_Extensions__item__id._const_tab = ____QosFlowItemWithDataForwarding_iE_Extensions__item__id_tab
    ___QosFlowItemWithDataForwarding_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowItemWithDataForwarding_iE_Extensions__item__id._const_tab_id = 'id'
    ___QosFlowItemWithDataForwarding_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___QosFlowItemWithDataForwarding_iE_Extensions__item__criticality._const_tab = ____QosFlowItemWithDataForwarding_iE_Extensions__item__id_tab
    ___QosFlowItemWithDataForwarding_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QosFlowItemWithDataForwarding_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QosFlowItemWithDataForwarding_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___QosFlowItemWithDataForwarding_iE_Extensions__item__extensionValue._const_tab = ____QosFlowItemWithDataForwarding_iE_Extensions__item__id_tab
    ___QosFlowItemWithDataForwarding_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QosFlowItemWithDataForwarding_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QosFlowItemWithDataForwarding_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QosFlowItemWithDataForwarding_iE_Extensions__item__id),
        ('criticality', ___QosFlowItemWithDataForwarding_iE_Extensions__item__criticality),
        ('extensionValue', ___QosFlowItemWithDataForwarding_iE_Extensions__item__extensionValue),
        ])
    __QosFlowItemWithDataForwarding_iE_Extensions__item_._ext = None
    _QosFlowItemWithDataForwarding_iE_Extensions._cont = __QosFlowItemWithDataForwarding_iE_Extensions__item_
    _QosFlowItemWithDataForwarding_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowItemWithDataForwarding._cont = ASN1Dict([
        ('qosFlowIdentifier', _QosFlowItemWithDataForwarding_qosFlowIdentifier),
        ('dataForwardingAccepted', _QosFlowItemWithDataForwarding_dataForwardingAccepted),
        ('iE-Extensions', _QosFlowItemWithDataForwarding_iE_Extensions),
        ])
    QosFlowItemWithDataForwarding._ext = []
    
    #-----< QosFlowItemWithDataForwarding-ExtIEs >-----#
    QosFlowItemWithDataForwarding_ExtIEs = CLASS(name='QosFlowItemWithDataForwarding-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _QosFlowItemWithDataForwarding_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AlternativeQoSParaSetIndex')))
    QosFlowItemWithDataForwarding_ExtIEs._val = ASN1Set(rv=[dict([('id', 221), ('criticality', 'ignore'), ('Extension', _QosFlowItemWithDataForwarding_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< QosFlowToBeForwardedList >-----#
    QosFlowToBeForwardedList = SEQ_OF(name='QosFlowToBeForwardedList', mode=MODE_TYPE)
    _QosFlowToBeForwardedList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QosFlowToBeForwardedItem')))
    QosFlowToBeForwardedList._cont = _QosFlowToBeForwardedList__item_
    QosFlowToBeForwardedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QosFlowToBeForwardedItem >-----#
    QosFlowToBeForwardedItem = SEQ(name='QosFlowToBeForwardedItem', mode=MODE_TYPE)
    _QosFlowToBeForwardedItem_qosFlowIdentifier = INT(name='qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _QosFlowToBeForwardedItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QosFlowToBeForwardedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QosFlowToBeForwardedItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____QosFlowToBeForwardedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowToBeForwardedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowToBeForwardedItem_iE_Extensions__item__id._const_tab = ____QosFlowToBeForwardedItem_iE_Extensions__item__id_tab
    ___QosFlowToBeForwardedItem_iE_Extensions__item__id._const_tab_at = None
    ___QosFlowToBeForwardedItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___QosFlowToBeForwardedItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____QosFlowToBeForwardedItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowToBeForwardedItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowToBeForwardedItem_iE_Extensions__item__criticality._const_tab = ____QosFlowToBeForwardedItem_iE_Extensions__item__criticality_tab
    ___QosFlowToBeForwardedItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QosFlowToBeForwardedItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QosFlowToBeForwardedItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____QosFlowToBeForwardedItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QosFlowToBeForwardedItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QosFlowToBeForwardedItem_iE_Extensions__item__extensionValue._const_tab = ____QosFlowToBeForwardedItem_iE_Extensions__item__extensionValue_tab
    ___QosFlowToBeForwardedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QosFlowToBeForwardedItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QosFlowToBeForwardedItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QosFlowToBeForwardedItem_iE_Extensions__item__id),
        ('criticality', ___QosFlowToBeForwardedItem_iE_Extensions__item__criticality),
        ('extensionValue', ___QosFlowToBeForwardedItem_iE_Extensions__item__extensionValue),
        ])
    __QosFlowToBeForwardedItem_iE_Extensions__item_._ext = None
    _QosFlowToBeForwardedItem_iE_Extensions._cont = __QosFlowToBeForwardedItem_iE_Extensions__item_
    _QosFlowToBeForwardedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QosFlowToBeForwardedItem._cont = ASN1Dict([
        ('qosFlowIdentifier', _QosFlowToBeForwardedItem_qosFlowIdentifier),
        ('iE-Extensions', _QosFlowToBeForwardedItem_iE_Extensions),
        ])
    QosFlowToBeForwardedItem._ext = []
    
    #-----< QosFlowToBeForwardedItem-ExtIEs >-----#
    QosFlowToBeForwardedItem_ExtIEs = CLASS(name='QosFlowToBeForwardedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    QosFlowToBeForwardedItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QoSFlowsUsageReportList >-----#
    QoSFlowsUsageReportList = SEQ_OF(name='QoSFlowsUsageReportList', mode=MODE_TYPE)
    _QoSFlowsUsageReportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QoSFlowsUsageReport-Item')))
    QoSFlowsUsageReportList._cont = _QoSFlowsUsageReportList__item_
    QoSFlowsUsageReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< QoSFlowsUsageReport-Item >-----#
    QoSFlowsUsageReport_Item = SEQ(name='QoSFlowsUsageReport-Item', mode=MODE_TYPE)
    _QoSFlowsUsageReport_Item_qosFlowIdentifier = INT(name='qosFlowIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowIdentifier')))
    _QoSFlowsUsageReport_Item_rATType = ENUM(name='rATType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _QoSFlowsUsageReport_Item_rATType._cont = ASN1Dict([('nr', 0), ('eutra', 1), ('nr-unlicensed', 2), ('e-utra-unlicensed', 3)])
    _QoSFlowsUsageReport_Item_rATType._ext = ['nr-unlicensed', 'e-utra-unlicensed']
    _QoSFlowsUsageReport_Item_qoSFlowsTimedReportList = SEQ_OF(name='qoSFlowsTimedReportList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'VolumeTimedReportList')))
    _QoSFlowsUsageReport_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __QoSFlowsUsageReport_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___QoSFlowsUsageReport_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____QoSFlowsUsageReport_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QoSFlowsUsageReport_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoSFlowsUsageReport_Item_iE_Extensions__item__id._const_tab = ____QoSFlowsUsageReport_Item_iE_Extensions__item__id_tab
    ___QoSFlowsUsageReport_Item_iE_Extensions__item__id._const_tab_at = None
    ___QoSFlowsUsageReport_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___QoSFlowsUsageReport_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____QoSFlowsUsageReport_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QoSFlowsUsageReport_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoSFlowsUsageReport_Item_iE_Extensions__item__criticality._const_tab = ____QoSFlowsUsageReport_Item_iE_Extensions__item__criticality_tab
    ___QoSFlowsUsageReport_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___QoSFlowsUsageReport_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___QoSFlowsUsageReport_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____QoSFlowsUsageReport_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____QoSFlowsUsageReport_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___QoSFlowsUsageReport_Item_iE_Extensions__item__extensionValue._const_tab = ____QoSFlowsUsageReport_Item_iE_Extensions__item__extensionValue_tab
    ___QoSFlowsUsageReport_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___QoSFlowsUsageReport_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __QoSFlowsUsageReport_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___QoSFlowsUsageReport_Item_iE_Extensions__item__id),
        ('criticality', ___QoSFlowsUsageReport_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___QoSFlowsUsageReport_Item_iE_Extensions__item__extensionValue),
        ])
    __QoSFlowsUsageReport_Item_iE_Extensions__item_._ext = None
    _QoSFlowsUsageReport_Item_iE_Extensions._cont = __QoSFlowsUsageReport_Item_iE_Extensions__item_
    _QoSFlowsUsageReport_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    QoSFlowsUsageReport_Item._cont = ASN1Dict([
        ('qosFlowIdentifier', _QoSFlowsUsageReport_Item_qosFlowIdentifier),
        ('rATType', _QoSFlowsUsageReport_Item_rATType),
        ('qoSFlowsTimedReportList', _QoSFlowsUsageReport_Item_qoSFlowsTimedReportList),
        ('iE-Extensions', _QoSFlowsUsageReport_Item_iE_Extensions),
        ])
    QoSFlowsUsageReport_Item._ext = []
    
    #-----< QoSFlowsUsageReport-Item-ExtIEs >-----#
    QoSFlowsUsageReport_Item_ExtIEs = CLASS(name='QoSFlowsUsageReport-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    QoSFlowsUsageReport_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Range >-----#
    Range = ENUM(name='Range', mode=MODE_TYPE)
    Range._cont = ASN1Dict([('m50', 0), ('m80', 1), ('m180', 2), ('m200', 3), ('m350', 4), ('m400', 5), ('m500', 6), ('m700', 7), ('m1000', 8)])
    Range._ext = []
    
    #-----< RANNodeName >-----#
    RANNodeName = STR_PRINT(name='RANNodeName', mode=MODE_TYPE)
    RANNodeName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< RANNodeNameVisibleString >-----#
    RANNodeNameVisibleString = STR_VIS(name='RANNodeNameVisibleString', mode=MODE_TYPE)
    RANNodeNameVisibleString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< RANNodeNameUTF8String >-----#
    RANNodeNameUTF8String = STR_UTF8(name='RANNodeNameUTF8String', mode=MODE_TYPE)
    RANNodeNameUTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< RANPagingPriority >-----#
    RANPagingPriority = INT(name='RANPagingPriority', mode=MODE_TYPE)
    RANPagingPriority._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RANStatusTransfer-TransparentContainer >-----#
    RANStatusTransfer_TransparentContainer = SEQ(name='RANStatusTransfer-TransparentContainer', mode=MODE_TYPE)
    _RANStatusTransfer_TransparentContainer_dRBsSubjectToStatusTransferList = SEQ_OF(name='dRBsSubjectToStatusTransferList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'DRBsSubjectToStatusTransferList')))
    _RANStatusTransfer_TransparentContainer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RANStatusTransfer_TransparentContainer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____RANStatusTransfer_TransparentContainer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RANStatusTransfer_TransparentContainer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__id._const_tab = ____RANStatusTransfer_TransparentContainer_iE_Extensions__item__id_tab
    ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__id._const_tab_at = None
    ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__id._const_tab_id = 'id'
    ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RANStatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RANStatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__criticality._const_tab = ____RANStatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab
    ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RANStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RANStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue._const_tab = ____RANStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab
    ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RANStatusTransfer_TransparentContainer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__id),
        ('criticality', ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__criticality),
        ('extensionValue', ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue),
        ])
    __RANStatusTransfer_TransparentContainer_iE_Extensions__item_._ext = None
    _RANStatusTransfer_TransparentContainer_iE_Extensions._cont = __RANStatusTransfer_TransparentContainer_iE_Extensions__item_
    _RANStatusTransfer_TransparentContainer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RANStatusTransfer_TransparentContainer._cont = ASN1Dict([
        ('dRBsSubjectToStatusTransferList', _RANStatusTransfer_TransparentContainer_dRBsSubjectToStatusTransferList),
        ('iE-Extensions', _RANStatusTransfer_TransparentContainer_iE_Extensions),
        ])
    RANStatusTransfer_TransparentContainer._ext = []
    
    #-----< RANStatusTransfer-TransparentContainer-ExtIEs >-----#
    RANStatusTransfer_TransparentContainer_ExtIEs = CLASS(name='RANStatusTransfer-TransparentContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    RANStatusTransfer_TransparentContainer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAN-UE-NGAP-ID >-----#
    RAN_UE_NGAP_ID = INT(name='RAN-UE-NGAP-ID', mode=MODE_TYPE)
    RAN_UE_NGAP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< RAT-Information >-----#
    RAT_Information = ENUM(name='RAT-Information', mode=MODE_TYPE)
    RAT_Information._cont = ASN1Dict([('unlicensed', 0), ('nb-IoT', 1), ('nR-LEO', 2), ('nR-MEO', 3), ('nR-GEO', 4), ('nR-OTHERSAT', 5)])
    RAT_Information._ext = ['nR-LEO', 'nR-MEO', 'nR-GEO', 'nR-OTHERSAT']
    
    #-----< RATRestrictions >-----#
    RATRestrictions = SEQ_OF(name='RATRestrictions', mode=MODE_TYPE)
    _RATRestrictions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RATRestrictions-Item')))
    RATRestrictions._cont = _RATRestrictions__item_
    RATRestrictions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RATRestrictions-Item >-----#
    RATRestrictions_Item = SEQ(name='RATRestrictions-Item', mode=MODE_TYPE)
    _RATRestrictions_Item_pLMNIdentity = OCT_STR(name='pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _RATRestrictions_Item_rATRestrictionInformation = BIT_STR(name='rATRestrictionInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RATRestrictionInformation')))
    _RATRestrictions_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RATRestrictions_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___RATRestrictions_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____RATRestrictions_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____RATRestrictions_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedRATRestrictionInformation')))
    ____RATRestrictions_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 180), ('criticality', 'ignore'), ('Extension', _____RATRestrictions_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RATRestrictions_Item_iE_Extensions__item__id._const_tab = ____RATRestrictions_Item_iE_Extensions__item__id_tab
    ___RATRestrictions_Item_iE_Extensions__item__id._const_tab_at = None
    ___RATRestrictions_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___RATRestrictions_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RATRestrictions_Item_iE_Extensions__item__criticality._const_tab = ____RATRestrictions_Item_iE_Extensions__item__id_tab
    ___RATRestrictions_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RATRestrictions_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RATRestrictions_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RATRestrictions_Item_iE_Extensions__item__extensionValue._const_tab = ____RATRestrictions_Item_iE_Extensions__item__id_tab
    ___RATRestrictions_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RATRestrictions_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RATRestrictions_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RATRestrictions_Item_iE_Extensions__item__id),
        ('criticality', ___RATRestrictions_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___RATRestrictions_Item_iE_Extensions__item__extensionValue),
        ])
    __RATRestrictions_Item_iE_Extensions__item_._ext = None
    _RATRestrictions_Item_iE_Extensions._cont = __RATRestrictions_Item_iE_Extensions__item_
    _RATRestrictions_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RATRestrictions_Item._cont = ASN1Dict([
        ('pLMNIdentity', _RATRestrictions_Item_pLMNIdentity),
        ('rATRestrictionInformation', _RATRestrictions_Item_rATRestrictionInformation),
        ('iE-Extensions', _RATRestrictions_Item_iE_Extensions),
        ])
    RATRestrictions_Item._ext = []
    
    #-----< RATRestrictions-Item-ExtIEs >-----#
    RATRestrictions_Item_ExtIEs = CLASS(name='RATRestrictions-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _RATRestrictions_Item_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ExtendedRATRestrictionInformation')))
    RATRestrictions_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 180), ('criticality', 'ignore'), ('Extension', _RATRestrictions_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RATRestrictionInformation >-----#
    RATRestrictionInformation = BIT_STR(name='RATRestrictionInformation', mode=MODE_TYPE)
    RATRestrictionInformation._const_sz = ASN1Set(rv=[8], rr=[], ev=[], er=[])
    
    #-----< RecommendedCellsForPaging >-----#
    RecommendedCellsForPaging = SEQ(name='RecommendedCellsForPaging', mode=MODE_TYPE)
    _RecommendedCellsForPaging_recommendedCellList = SEQ_OF(name='recommendedCellList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RecommendedCellList')))
    _RecommendedCellsForPaging_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RecommendedCellsForPaging_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___RecommendedCellsForPaging_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____RecommendedCellsForPaging_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RecommendedCellsForPaging_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedCellsForPaging_iE_Extensions__item__id._const_tab = ____RecommendedCellsForPaging_iE_Extensions__item__id_tab
    ___RecommendedCellsForPaging_iE_Extensions__item__id._const_tab_at = None
    ___RecommendedCellsForPaging_iE_Extensions__item__id._const_tab_id = 'id'
    ___RecommendedCellsForPaging_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RecommendedCellsForPaging_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RecommendedCellsForPaging_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedCellsForPaging_iE_Extensions__item__criticality._const_tab = ____RecommendedCellsForPaging_iE_Extensions__item__criticality_tab
    ___RecommendedCellsForPaging_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RecommendedCellsForPaging_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RecommendedCellsForPaging_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RecommendedCellsForPaging_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RecommendedCellsForPaging_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedCellsForPaging_iE_Extensions__item__extensionValue._const_tab = ____RecommendedCellsForPaging_iE_Extensions__item__extensionValue_tab
    ___RecommendedCellsForPaging_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RecommendedCellsForPaging_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RecommendedCellsForPaging_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RecommendedCellsForPaging_iE_Extensions__item__id),
        ('criticality', ___RecommendedCellsForPaging_iE_Extensions__item__criticality),
        ('extensionValue', ___RecommendedCellsForPaging_iE_Extensions__item__extensionValue),
        ])
    __RecommendedCellsForPaging_iE_Extensions__item_._ext = None
    _RecommendedCellsForPaging_iE_Extensions._cont = __RecommendedCellsForPaging_iE_Extensions__item_
    _RecommendedCellsForPaging_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RecommendedCellsForPaging._cont = ASN1Dict([
        ('recommendedCellList', _RecommendedCellsForPaging_recommendedCellList),
        ('iE-Extensions', _RecommendedCellsForPaging_iE_Extensions),
        ])
    RecommendedCellsForPaging._ext = []
    
    #-----< RecommendedCellsForPaging-ExtIEs >-----#
    RecommendedCellsForPaging_ExtIEs = CLASS(name='RecommendedCellsForPaging-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    RecommendedCellsForPaging_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RecommendedCellList >-----#
    RecommendedCellList = SEQ_OF(name='RecommendedCellList', mode=MODE_TYPE)
    _RecommendedCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RecommendedCellItem')))
    RecommendedCellList._cont = _RecommendedCellList__item_
    RecommendedCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RecommendedCellItem >-----#
    RecommendedCellItem = SEQ(name='RecommendedCellItem', mode=MODE_TYPE)
    _RecommendedCellItem_nGRAN_CGI = CHOICE(name='nGRAN-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _RecommendedCellItem_timeStayedInCell = INT(name='timeStayedInCell', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RecommendedCellItem_timeStayedInCell._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _RecommendedCellItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RecommendedCellItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___RecommendedCellItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____RecommendedCellItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RecommendedCellItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedCellItem_iE_Extensions__item__id._const_tab = ____RecommendedCellItem_iE_Extensions__item__id_tab
    ___RecommendedCellItem_iE_Extensions__item__id._const_tab_at = None
    ___RecommendedCellItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___RecommendedCellItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RecommendedCellItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RecommendedCellItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedCellItem_iE_Extensions__item__criticality._const_tab = ____RecommendedCellItem_iE_Extensions__item__criticality_tab
    ___RecommendedCellItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RecommendedCellItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RecommendedCellItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RecommendedCellItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RecommendedCellItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedCellItem_iE_Extensions__item__extensionValue._const_tab = ____RecommendedCellItem_iE_Extensions__item__extensionValue_tab
    ___RecommendedCellItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RecommendedCellItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RecommendedCellItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RecommendedCellItem_iE_Extensions__item__id),
        ('criticality', ___RecommendedCellItem_iE_Extensions__item__criticality),
        ('extensionValue', ___RecommendedCellItem_iE_Extensions__item__extensionValue),
        ])
    __RecommendedCellItem_iE_Extensions__item_._ext = None
    _RecommendedCellItem_iE_Extensions._cont = __RecommendedCellItem_iE_Extensions__item_
    _RecommendedCellItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RecommendedCellItem._cont = ASN1Dict([
        ('nGRAN-CGI', _RecommendedCellItem_nGRAN_CGI),
        ('timeStayedInCell', _RecommendedCellItem_timeStayedInCell),
        ('iE-Extensions', _RecommendedCellItem_iE_Extensions),
        ])
    RecommendedCellItem._ext = []
    
    #-----< RecommendedCellItem-ExtIEs >-----#
    RecommendedCellItem_ExtIEs = CLASS(name='RecommendedCellItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    RecommendedCellItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RecommendedRANNodesForPaging >-----#
    RecommendedRANNodesForPaging = SEQ(name='RecommendedRANNodesForPaging', mode=MODE_TYPE)
    _RecommendedRANNodesForPaging_recommendedRANNodeList = SEQ_OF(name='recommendedRANNodeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RecommendedRANNodeList')))
    _RecommendedRANNodesForPaging_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RecommendedRANNodesForPaging_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___RecommendedRANNodesForPaging_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____RecommendedRANNodesForPaging_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RecommendedRANNodesForPaging_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedRANNodesForPaging_iE_Extensions__item__id._const_tab = ____RecommendedRANNodesForPaging_iE_Extensions__item__id_tab
    ___RecommendedRANNodesForPaging_iE_Extensions__item__id._const_tab_at = None
    ___RecommendedRANNodesForPaging_iE_Extensions__item__id._const_tab_id = 'id'
    ___RecommendedRANNodesForPaging_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RecommendedRANNodesForPaging_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RecommendedRANNodesForPaging_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedRANNodesForPaging_iE_Extensions__item__criticality._const_tab = ____RecommendedRANNodesForPaging_iE_Extensions__item__criticality_tab
    ___RecommendedRANNodesForPaging_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RecommendedRANNodesForPaging_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RecommendedRANNodesForPaging_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RecommendedRANNodesForPaging_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RecommendedRANNodesForPaging_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedRANNodesForPaging_iE_Extensions__item__extensionValue._const_tab = ____RecommendedRANNodesForPaging_iE_Extensions__item__extensionValue_tab
    ___RecommendedRANNodesForPaging_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RecommendedRANNodesForPaging_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RecommendedRANNodesForPaging_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RecommendedRANNodesForPaging_iE_Extensions__item__id),
        ('criticality', ___RecommendedRANNodesForPaging_iE_Extensions__item__criticality),
        ('extensionValue', ___RecommendedRANNodesForPaging_iE_Extensions__item__extensionValue),
        ])
    __RecommendedRANNodesForPaging_iE_Extensions__item_._ext = None
    _RecommendedRANNodesForPaging_iE_Extensions._cont = __RecommendedRANNodesForPaging_iE_Extensions__item_
    _RecommendedRANNodesForPaging_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RecommendedRANNodesForPaging._cont = ASN1Dict([
        ('recommendedRANNodeList', _RecommendedRANNodesForPaging_recommendedRANNodeList),
        ('iE-Extensions', _RecommendedRANNodesForPaging_iE_Extensions),
        ])
    RecommendedRANNodesForPaging._ext = []
    
    #-----< RecommendedRANNodesForPaging-ExtIEs >-----#
    RecommendedRANNodesForPaging_ExtIEs = CLASS(name='RecommendedRANNodesForPaging-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    RecommendedRANNodesForPaging_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RecommendedRANNodeList >-----#
    RecommendedRANNodeList = SEQ_OF(name='RecommendedRANNodeList', mode=MODE_TYPE)
    _RecommendedRANNodeList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RecommendedRANNodeItem')))
    RecommendedRANNodeList._cont = _RecommendedRANNodeList__item_
    RecommendedRANNodeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RecommendedRANNodeItem >-----#
    RecommendedRANNodeItem = SEQ(name='RecommendedRANNodeItem', mode=MODE_TYPE)
    _RecommendedRANNodeItem_aMFPagingTarget = CHOICE(name='aMFPagingTarget', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AMFPagingTarget')))
    _RecommendedRANNodeItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RecommendedRANNodeItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___RecommendedRANNodeItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____RecommendedRANNodeItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RecommendedRANNodeItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedRANNodeItem_iE_Extensions__item__id._const_tab = ____RecommendedRANNodeItem_iE_Extensions__item__id_tab
    ___RecommendedRANNodeItem_iE_Extensions__item__id._const_tab_at = None
    ___RecommendedRANNodeItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___RecommendedRANNodeItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RecommendedRANNodeItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RecommendedRANNodeItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedRANNodeItem_iE_Extensions__item__criticality._const_tab = ____RecommendedRANNodeItem_iE_Extensions__item__criticality_tab
    ___RecommendedRANNodeItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RecommendedRANNodeItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RecommendedRANNodeItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RecommendedRANNodeItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RecommendedRANNodeItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedRANNodeItem_iE_Extensions__item__extensionValue._const_tab = ____RecommendedRANNodeItem_iE_Extensions__item__extensionValue_tab
    ___RecommendedRANNodeItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RecommendedRANNodeItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RecommendedRANNodeItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RecommendedRANNodeItem_iE_Extensions__item__id),
        ('criticality', ___RecommendedRANNodeItem_iE_Extensions__item__criticality),
        ('extensionValue', ___RecommendedRANNodeItem_iE_Extensions__item__extensionValue),
        ])
    __RecommendedRANNodeItem_iE_Extensions__item_._ext = None
    _RecommendedRANNodeItem_iE_Extensions._cont = __RecommendedRANNodeItem_iE_Extensions__item_
    _RecommendedRANNodeItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RecommendedRANNodeItem._cont = ASN1Dict([
        ('aMFPagingTarget', _RecommendedRANNodeItem_aMFPagingTarget),
        ('iE-Extensions', _RecommendedRANNodeItem_iE_Extensions),
        ])
    RecommendedRANNodeItem._ext = []
    
    #-----< RecommendedRANNodeItem-ExtIEs >-----#
    RecommendedRANNodeItem_ExtIEs = CLASS(name='RecommendedRANNodeItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    RecommendedRANNodeItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RedCapIndication >-----#
    RedCapIndication = ENUM(name='RedCapIndication', mode=MODE_TYPE)
    RedCapIndication._cont = ASN1Dict([('redcap', 0)])
    RedCapIndication._ext = []
    
    #-----< RedirectionVoiceFallback >-----#
    RedirectionVoiceFallback = ENUM(name='RedirectionVoiceFallback', mode=MODE_TYPE)
    RedirectionVoiceFallback._cont = ASN1Dict([('possible', 0), ('not-possible', 1)])
    RedirectionVoiceFallback._ext = []
    
    #-----< RedundantPDUSessionInformation >-----#
    RedundantPDUSessionInformation = SEQ(name='RedundantPDUSessionInformation', mode=MODE_TYPE)
    _RedundantPDUSessionInformation_rSN = ENUM(name='rSN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RSN')))
    _RedundantPDUSessionInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RedundantPDUSessionInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___RedundantPDUSessionInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____RedundantPDUSessionInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____RedundantPDUSessionInformation_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionPairID')))
    ____RedundantPDUSessionInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 331), ('criticality', 'ignore'), ('Extension', _____RedundantPDUSessionInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RedundantPDUSessionInformation_iE_Extensions__item__id._const_tab = ____RedundantPDUSessionInformation_iE_Extensions__item__id_tab
    ___RedundantPDUSessionInformation_iE_Extensions__item__id._const_tab_at = None
    ___RedundantPDUSessionInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___RedundantPDUSessionInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RedundantPDUSessionInformation_iE_Extensions__item__criticality._const_tab = ____RedundantPDUSessionInformation_iE_Extensions__item__id_tab
    ___RedundantPDUSessionInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RedundantPDUSessionInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RedundantPDUSessionInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RedundantPDUSessionInformation_iE_Extensions__item__extensionValue._const_tab = ____RedundantPDUSessionInformation_iE_Extensions__item__id_tab
    ___RedundantPDUSessionInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RedundantPDUSessionInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RedundantPDUSessionInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RedundantPDUSessionInformation_iE_Extensions__item__id),
        ('criticality', ___RedundantPDUSessionInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___RedundantPDUSessionInformation_iE_Extensions__item__extensionValue),
        ])
    __RedundantPDUSessionInformation_iE_Extensions__item_._ext = None
    _RedundantPDUSessionInformation_iE_Extensions._cont = __RedundantPDUSessionInformation_iE_Extensions__item_
    _RedundantPDUSessionInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RedundantPDUSessionInformation._cont = ASN1Dict([
        ('rSN', _RedundantPDUSessionInformation_rSN),
        ('iE-Extensions', _RedundantPDUSessionInformation_iE_Extensions),
        ])
    RedundantPDUSessionInformation._ext = []
    
    #-----< RedundantPDUSessionInformation-ExtIEs >-----#
    RedundantPDUSessionInformation_ExtIEs = CLASS(name='RedundantPDUSessionInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _RedundantPDUSessionInformation_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionPairID')))
    RedundantPDUSessionInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 331), ('criticality', 'ignore'), ('Extension', _RedundantPDUSessionInformation_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RedundantQosFlowIndicator >-----#
    RedundantQosFlowIndicator = ENUM(name='RedundantQosFlowIndicator', mode=MODE_TYPE)
    RedundantQosFlowIndicator._cont = ASN1Dict([('true', 0), ('false', 1)])
    RedundantQosFlowIndicator._ext = None
    
    #-----< ReflectiveQosAttribute >-----#
    ReflectiveQosAttribute = ENUM(name='ReflectiveQosAttribute', mode=MODE_TYPE)
    ReflectiveQosAttribute._cont = ASN1Dict([('subject-to', 0)])
    ReflectiveQosAttribute._ext = []
    
    #-----< RelativeAMFCapacity >-----#
    RelativeAMFCapacity = INT(name='RelativeAMFCapacity', mode=MODE_TYPE)
    RelativeAMFCapacity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ReportArea >-----#
    ReportArea = ENUM(name='ReportArea', mode=MODE_TYPE)
    ReportArea._cont = ASN1Dict([('cell', 0)])
    ReportArea._ext = []
    
    #-----< RepetitionPeriod >-----#
    RepetitionPeriod = INT(name='RepetitionPeriod', mode=MODE_TYPE)
    RepetitionPeriod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=131071)], ev=None, er=[])
    
    #-----< ResetAll >-----#
    ResetAll = ENUM(name='ResetAll', mode=MODE_TYPE)
    ResetAll._cont = ASN1Dict([('reset-all', 0)])
    ResetAll._ext = []
    
    #-----< ReportAmountMDT >-----#
    ReportAmountMDT = ENUM(name='ReportAmountMDT', mode=MODE_TYPE)
    ReportAmountMDT._cont = ASN1Dict([('r1', 0), ('r2', 1), ('r4', 2), ('r8', 3), ('r16', 4), ('r32', 5), ('r64', 6), ('rinfinity', 7)])
    ReportAmountMDT._ext = None
    
    #-----< ReportIntervalMDT >-----#
    ReportIntervalMDT = ENUM(name='ReportIntervalMDT', mode=MODE_TYPE)
    ReportIntervalMDT._cont = ASN1Dict([('ms120', 0), ('ms240', 1), ('ms480', 2), ('ms640', 3), ('ms1024', 4), ('ms2048', 5), ('ms5120', 6), ('ms10240', 7), ('min1', 8), ('min6', 9), ('min12', 10), ('min30', 11), ('min60', 12)])
    ReportIntervalMDT._ext = None
    
    #-----< ExtendedReportIntervalMDT >-----#
    ExtendedReportIntervalMDT = ENUM(name='ExtendedReportIntervalMDT', mode=MODE_TYPE)
    ExtendedReportIntervalMDT._cont = ASN1Dict([('ms20480', 0), ('ms40960', 1)])
    ExtendedReportIntervalMDT._ext = []
    
    #-----< ResetType >-----#
    ResetType = CHOICE(name='ResetType', mode=MODE_TYPE)
    _ResetType_nG_Interface = ENUM(name='nG-Interface', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ResetAll')))
    _ResetType_partOfNG_Interface = SEQ_OF(name='partOfNG-Interface', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UE-associatedLogicalNG-connectionList')))
    _ResetType_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __ResetType_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___ResetType_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ResetType_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResetType_choice_Extensions_id._const_tab = ___ResetType_choice_Extensions_id_tab
    __ResetType_choice_Extensions_id._const_tab_at = None
    __ResetType_choice_Extensions_id._const_tab_id = 'id'
    __ResetType_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___ResetType_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ResetType_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResetType_choice_Extensions_criticality._const_tab = ___ResetType_choice_Extensions_criticality_tab
    __ResetType_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __ResetType_choice_Extensions_criticality._const_tab_id = 'criticality'
    __ResetType_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___ResetType_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___ResetType_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResetType_choice_Extensions_value._const_tab = ___ResetType_choice_Extensions_value_tab
    __ResetType_choice_Extensions_value._const_tab_at = ('..', 'id')
    __ResetType_choice_Extensions_value._const_tab_id = 'Value'
    _ResetType_choice_Extensions._cont = ASN1Dict([
        ('id', __ResetType_choice_Extensions_id),
        ('criticality', __ResetType_choice_Extensions_criticality),
        ('value', __ResetType_choice_Extensions_value),
        ])
    _ResetType_choice_Extensions._ext = None
    ResetType._cont = ASN1Dict([
        ('nG-Interface', _ResetType_nG_Interface),
        ('partOfNG-Interface', _ResetType_partOfNG_Interface),
        ('choice-Extensions', _ResetType_choice_Extensions),
        ])
    ResetType._ext = None
    
    #-----< ResetType-ExtIEs >-----#
    ResetType_ExtIEs = CLASS(name='ResetType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ResetType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RGLevelWirelineAccessCharacteristics >-----#
    RGLevelWirelineAccessCharacteristics = OCT_STR(name='RGLevelWirelineAccessCharacteristics', mode=MODE_TYPE)
    
    #-----< RNC-ID >-----#
    RNC_ID = INT(name='RNC-ID', mode=MODE_TYPE)
    RNC_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< RoutingID >-----#
    RoutingID = OCT_STR(name='RoutingID', mode=MODE_TYPE)
    
    #-----< RRCContainer >-----#
    RRCContainer = OCT_STR(name='RRCContainer', mode=MODE_TYPE)
    
    #-----< RRCEstablishmentCause >-----#
    RRCEstablishmentCause = ENUM(name='RRCEstablishmentCause', mode=MODE_TYPE)
    RRCEstablishmentCause._cont = ASN1Dict([('emergency', 0), ('highPriorityAccess', 1), ('mt-Access', 2), ('mo-Signalling', 3), ('mo-Data', 4), ('mo-VoiceCall', 5), ('mo-VideoCall', 6), ('mo-SMS', 7), ('mps-PriorityAccess', 8), ('mcs-PriorityAccess', 9), ('notAvailable', 10), ('mo-ExceptionData', 11)])
    RRCEstablishmentCause._ext = ['notAvailable', 'mo-ExceptionData']
    
    #-----< RRCInactiveTransitionReportRequest >-----#
    RRCInactiveTransitionReportRequest = ENUM(name='RRCInactiveTransitionReportRequest', mode=MODE_TYPE)
    RRCInactiveTransitionReportRequest._cont = ASN1Dict([('subsequent-state-transition-report', 0), ('single-rrc-connected-state-report', 1), ('cancel-report', 2)])
    RRCInactiveTransitionReportRequest._ext = []
    
    #-----< RRCState >-----#
    RRCState = ENUM(name='RRCState', mode=MODE_TYPE)
    RRCState._cont = ASN1Dict([('inactive', 0), ('connected', 1)])
    RRCState._ext = []
    
    #-----< RSN >-----#
    RSN = ENUM(name='RSN', mode=MODE_TYPE)
    RSN._cont = ASN1Dict([('v1', 0), ('v2', 1)])
    RSN._ext = []
    
    #-----< RIMInformationTransfer >-----#
    RIMInformationTransfer = SEQ(name='RIMInformationTransfer', mode=MODE_TYPE)
    _RIMInformationTransfer_targetRANNodeID_RIM = SEQ(name='targetRANNodeID-RIM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TargetRANNodeID-RIM')))
    _RIMInformationTransfer_sourceRANNodeID = SEQ(name='sourceRANNodeID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SourceRANNodeID')))
    _RIMInformationTransfer_rIMInformation = SEQ(name='rIMInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RIMInformation')))
    _RIMInformationTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RIMInformationTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___RIMInformationTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____RIMInformationTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RIMInformationTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RIMInformationTransfer_iE_Extensions__item__id._const_tab = ____RIMInformationTransfer_iE_Extensions__item__id_tab
    ___RIMInformationTransfer_iE_Extensions__item__id._const_tab_at = None
    ___RIMInformationTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___RIMInformationTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RIMInformationTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RIMInformationTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RIMInformationTransfer_iE_Extensions__item__criticality._const_tab = ____RIMInformationTransfer_iE_Extensions__item__criticality_tab
    ___RIMInformationTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RIMInformationTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RIMInformationTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RIMInformationTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RIMInformationTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RIMInformationTransfer_iE_Extensions__item__extensionValue._const_tab = ____RIMInformationTransfer_iE_Extensions__item__extensionValue_tab
    ___RIMInformationTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RIMInformationTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RIMInformationTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RIMInformationTransfer_iE_Extensions__item__id),
        ('criticality', ___RIMInformationTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___RIMInformationTransfer_iE_Extensions__item__extensionValue),
        ])
    __RIMInformationTransfer_iE_Extensions__item_._ext = None
    _RIMInformationTransfer_iE_Extensions._cont = __RIMInformationTransfer_iE_Extensions__item_
    _RIMInformationTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RIMInformationTransfer._cont = ASN1Dict([
        ('targetRANNodeID-RIM', _RIMInformationTransfer_targetRANNodeID_RIM),
        ('sourceRANNodeID', _RIMInformationTransfer_sourceRANNodeID),
        ('rIMInformation', _RIMInformationTransfer_rIMInformation),
        ('iE-Extensions', _RIMInformationTransfer_iE_Extensions),
        ])
    RIMInformationTransfer._ext = []
    
    #-----< RIMInformationTransfer-ExtIEs >-----#
    RIMInformationTransfer_ExtIEs = CLASS(name='RIMInformationTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    RIMInformationTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RIMInformation >-----#
    RIMInformation = SEQ(name='RIMInformation', mode=MODE_TYPE)
    _RIMInformation_targetgNBSetID = BIT_STR(name='targetgNBSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GNBSetID')))
    _RIMInformation_rIM_RSDetection = ENUM(name='rIM-RSDetection', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RIMInformation_rIM_RSDetection._cont = ASN1Dict([('rs-detected', 0), ('rs-disappeared', 1)])
    _RIMInformation_rIM_RSDetection._ext = []
    _RIMInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RIMInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___RIMInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____RIMInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RIMInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RIMInformation_iE_Extensions__item__id._const_tab = ____RIMInformation_iE_Extensions__item__id_tab
    ___RIMInformation_iE_Extensions__item__id._const_tab_at = None
    ___RIMInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___RIMInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RIMInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RIMInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RIMInformation_iE_Extensions__item__criticality._const_tab = ____RIMInformation_iE_Extensions__item__criticality_tab
    ___RIMInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RIMInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RIMInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RIMInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____RIMInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RIMInformation_iE_Extensions__item__extensionValue._const_tab = ____RIMInformation_iE_Extensions__item__extensionValue_tab
    ___RIMInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RIMInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RIMInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RIMInformation_iE_Extensions__item__id),
        ('criticality', ___RIMInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___RIMInformation_iE_Extensions__item__extensionValue),
        ])
    __RIMInformation_iE_Extensions__item_._ext = None
    _RIMInformation_iE_Extensions._cont = __RIMInformation_iE_Extensions__item_
    _RIMInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RIMInformation._cont = ASN1Dict([
        ('targetgNBSetID', _RIMInformation_targetgNBSetID),
        ('rIM-RSDetection', _RIMInformation_rIM_RSDetection),
        ('iE-Extensions', _RIMInformation_iE_Extensions),
        ])
    RIMInformation._ext = []
    
    #-----< RIMInformation-ExtIEs >-----#
    RIMInformation_ExtIEs = CLASS(name='RIMInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    RIMInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNBSetID >-----#
    GNBSetID = BIT_STR(name='GNBSetID', mode=MODE_TYPE)
    GNBSetID._const_sz = ASN1Set(rv=[22], rr=[], ev=None, er=[])
    
    #-----< ScheduledCommunicationTime >-----#
    ScheduledCommunicationTime = SEQ(name='ScheduledCommunicationTime', mode=MODE_TYPE)
    _ScheduledCommunicationTime_dayofWeek = BIT_STR(name='dayofWeek', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScheduledCommunicationTime_dayofWeek._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    _ScheduledCommunicationTime_timeofDayStart = INT(name='timeofDayStart', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScheduledCommunicationTime_timeofDayStart._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86399)], ev=[], er=[])
    _ScheduledCommunicationTime_timeofDayEnd = INT(name='timeofDayEnd', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScheduledCommunicationTime_timeofDayEnd._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86399)], ev=[], er=[])
    _ScheduledCommunicationTime_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ScheduledCommunicationTime_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___ScheduledCommunicationTime_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____ScheduledCommunicationTime_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ScheduledCommunicationTime_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ScheduledCommunicationTime_iE_Extensions__item__id._const_tab = ____ScheduledCommunicationTime_iE_Extensions__item__id_tab
    ___ScheduledCommunicationTime_iE_Extensions__item__id._const_tab_at = None
    ___ScheduledCommunicationTime_iE_Extensions__item__id._const_tab_id = 'id'
    ___ScheduledCommunicationTime_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ScheduledCommunicationTime_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ScheduledCommunicationTime_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ScheduledCommunicationTime_iE_Extensions__item__criticality._const_tab = ____ScheduledCommunicationTime_iE_Extensions__item__criticality_tab
    ___ScheduledCommunicationTime_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ScheduledCommunicationTime_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ScheduledCommunicationTime_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ScheduledCommunicationTime_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue._const_tab = ____ScheduledCommunicationTime_iE_Extensions__item__extensionValue_tab
    ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ScheduledCommunicationTime_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ScheduledCommunicationTime_iE_Extensions__item__id),
        ('criticality', ___ScheduledCommunicationTime_iE_Extensions__item__criticality),
        ('extensionValue', ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue),
        ])
    __ScheduledCommunicationTime_iE_Extensions__item_._ext = None
    _ScheduledCommunicationTime_iE_Extensions._cont = __ScheduledCommunicationTime_iE_Extensions__item_
    _ScheduledCommunicationTime_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ScheduledCommunicationTime._cont = ASN1Dict([
        ('dayofWeek', _ScheduledCommunicationTime_dayofWeek),
        ('timeofDayStart', _ScheduledCommunicationTime_timeofDayStart),
        ('timeofDayEnd', _ScheduledCommunicationTime_timeofDayEnd),
        ('iE-Extensions', _ScheduledCommunicationTime_iE_Extensions),
        ])
    ScheduledCommunicationTime._ext = []
    
    #-----< ScheduledCommunicationTime-ExtIEs >-----#
    ScheduledCommunicationTime_ExtIEs = CLASS(name='ScheduledCommunicationTime-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ScheduledCommunicationTime_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SCTP-TLAs >-----#
    SCTP_TLAs = SEQ_OF(name='SCTP-TLAs', mode=MODE_TYPE)
    _SCTP_TLAs__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    SCTP_TLAs._cont = _SCTP_TLAs__item_
    SCTP_TLAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< SD >-----#
    SD = OCT_STR(name='SD', mode=MODE_TYPE)
    SD._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< SecondaryRATUsageInformation >-----#
    SecondaryRATUsageInformation = SEQ(name='SecondaryRATUsageInformation', mode=MODE_TYPE)
    _SecondaryRATUsageInformation_pDUSessionUsageReport = SEQ(name='pDUSessionUsageReport', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionUsageReport')), opt=True)
    _SecondaryRATUsageInformation_qosFlowsUsageReportList = SEQ_OF(name='qosFlowsUsageReportList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QoSFlowsUsageReportList')), opt=True)
    _SecondaryRATUsageInformation_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecondaryRATUsageInformation_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SecondaryRATUsageInformation_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____SecondaryRATUsageInformation_iE_Extension__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SecondaryRATUsageInformation_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryRATUsageInformation_iE_Extension__item__id._const_tab = ____SecondaryRATUsageInformation_iE_Extension__item__id_tab
    ___SecondaryRATUsageInformation_iE_Extension__item__id._const_tab_at = None
    ___SecondaryRATUsageInformation_iE_Extension__item__id._const_tab_id = 'id'
    ___SecondaryRATUsageInformation_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SecondaryRATUsageInformation_iE_Extension__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SecondaryRATUsageInformation_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryRATUsageInformation_iE_Extension__item__criticality._const_tab = ____SecondaryRATUsageInformation_iE_Extension__item__criticality_tab
    ___SecondaryRATUsageInformation_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___SecondaryRATUsageInformation_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___SecondaryRATUsageInformation_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SecondaryRATUsageInformation_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SecondaryRATUsageInformation_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryRATUsageInformation_iE_Extension__item__extensionValue._const_tab = ____SecondaryRATUsageInformation_iE_Extension__item__extensionValue_tab
    ___SecondaryRATUsageInformation_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___SecondaryRATUsageInformation_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __SecondaryRATUsageInformation_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___SecondaryRATUsageInformation_iE_Extension__item__id),
        ('criticality', ___SecondaryRATUsageInformation_iE_Extension__item__criticality),
        ('extensionValue', ___SecondaryRATUsageInformation_iE_Extension__item__extensionValue),
        ])
    __SecondaryRATUsageInformation_iE_Extension__item_._ext = None
    _SecondaryRATUsageInformation_iE_Extension._cont = __SecondaryRATUsageInformation_iE_Extension__item_
    _SecondaryRATUsageInformation_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecondaryRATUsageInformation._cont = ASN1Dict([
        ('pDUSessionUsageReport', _SecondaryRATUsageInformation_pDUSessionUsageReport),
        ('qosFlowsUsageReportList', _SecondaryRATUsageInformation_qosFlowsUsageReportList),
        ('iE-Extension', _SecondaryRATUsageInformation_iE_Extension),
        ])
    SecondaryRATUsageInformation._ext = []
    
    #-----< SecondaryRATUsageInformation-ExtIEs >-----#
    SecondaryRATUsageInformation_ExtIEs = CLASS(name='SecondaryRATUsageInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SecondaryRATUsageInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecondaryRATDataUsageReportTransfer >-----#
    SecondaryRATDataUsageReportTransfer = SEQ(name='SecondaryRATDataUsageReportTransfer', mode=MODE_TYPE)
    _SecondaryRATDataUsageReportTransfer_secondaryRATUsageInformation = SEQ(name='secondaryRATUsageInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SecondaryRATUsageInformation')), opt=True)
    _SecondaryRATDataUsageReportTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecondaryRATDataUsageReportTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____SecondaryRATDataUsageReportTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SecondaryRATDataUsageReportTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__id._const_tab = ____SecondaryRATDataUsageReportTransfer_iE_Extensions__item__id_tab
    ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__id._const_tab_at = None
    ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SecondaryRATDataUsageReportTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SecondaryRATDataUsageReportTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__criticality._const_tab = ____SecondaryRATDataUsageReportTransfer_iE_Extensions__item__criticality_tab
    ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SecondaryRATDataUsageReportTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SecondaryRATDataUsageReportTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__extensionValue._const_tab = ____SecondaryRATDataUsageReportTransfer_iE_Extensions__item__extensionValue_tab
    ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SecondaryRATDataUsageReportTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__id),
        ('criticality', ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__extensionValue),
        ])
    __SecondaryRATDataUsageReportTransfer_iE_Extensions__item_._ext = None
    _SecondaryRATDataUsageReportTransfer_iE_Extensions._cont = __SecondaryRATDataUsageReportTransfer_iE_Extensions__item_
    _SecondaryRATDataUsageReportTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecondaryRATDataUsageReportTransfer._cont = ASN1Dict([
        ('secondaryRATUsageInformation', _SecondaryRATDataUsageReportTransfer_secondaryRATUsageInformation),
        ('iE-Extensions', _SecondaryRATDataUsageReportTransfer_iE_Extensions),
        ])
    SecondaryRATDataUsageReportTransfer._ext = []
    
    #-----< SecondaryRATDataUsageReportTransfer-ExtIEs >-----#
    SecondaryRATDataUsageReportTransfer_ExtIEs = CLASS(name='SecondaryRATDataUsageReportTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SecondaryRATDataUsageReportTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecurityContext >-----#
    SecurityContext = SEQ(name='SecurityContext', mode=MODE_TYPE)
    _SecurityContext_nextHopChainingCount = INT(name='nextHopChainingCount', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NextHopChainingCount')))
    _SecurityContext_nextHopNH = BIT_STR(name='nextHopNH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SecurityKey')))
    _SecurityContext_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecurityContext_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SecurityContext_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____SecurityContext_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SecurityContext_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityContext_iE_Extensions__item__id._const_tab = ____SecurityContext_iE_Extensions__item__id_tab
    ___SecurityContext_iE_Extensions__item__id._const_tab_at = None
    ___SecurityContext_iE_Extensions__item__id._const_tab_id = 'id'
    ___SecurityContext_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SecurityContext_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SecurityContext_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityContext_iE_Extensions__item__criticality._const_tab = ____SecurityContext_iE_Extensions__item__criticality_tab
    ___SecurityContext_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SecurityContext_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SecurityContext_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SecurityContext_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SecurityContext_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityContext_iE_Extensions__item__extensionValue._const_tab = ____SecurityContext_iE_Extensions__item__extensionValue_tab
    ___SecurityContext_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SecurityContext_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SecurityContext_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SecurityContext_iE_Extensions__item__id),
        ('criticality', ___SecurityContext_iE_Extensions__item__criticality),
        ('extensionValue', ___SecurityContext_iE_Extensions__item__extensionValue),
        ])
    __SecurityContext_iE_Extensions__item_._ext = None
    _SecurityContext_iE_Extensions._cont = __SecurityContext_iE_Extensions__item_
    _SecurityContext_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecurityContext._cont = ASN1Dict([
        ('nextHopChainingCount', _SecurityContext_nextHopChainingCount),
        ('nextHopNH', _SecurityContext_nextHopNH),
        ('iE-Extensions', _SecurityContext_iE_Extensions),
        ])
    SecurityContext._ext = []
    
    #-----< SecurityContext-ExtIEs >-----#
    SecurityContext_ExtIEs = CLASS(name='SecurityContext-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SecurityContext_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecurityIndication >-----#
    SecurityIndication = SEQ(name='SecurityIndication', mode=MODE_TYPE)
    _SecurityIndication_integrityProtectionIndication = ENUM(name='integrityProtectionIndication', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntegrityProtectionIndication')))
    _SecurityIndication_confidentialityProtectionIndication = ENUM(name='confidentialityProtectionIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ConfidentialityProtectionIndication')))
    _SecurityIndication_maximumIntegrityProtectedDataRate_UL = ENUM(name='maximumIntegrityProtectedDataRate-UL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MaximumIntegrityProtectedDataRate')), opt=True)
    _SecurityIndication_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecurityIndication_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SecurityIndication_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____SecurityIndication_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____SecurityIndication_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MaximumIntegrityProtectedDataRate')))
    ____SecurityIndication_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 151), ('criticality', 'ignore'), ('Extension', _____SecurityIndication_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SecurityIndication_iE_Extensions__item__id._const_tab = ____SecurityIndication_iE_Extensions__item__id_tab
    ___SecurityIndication_iE_Extensions__item__id._const_tab_at = None
    ___SecurityIndication_iE_Extensions__item__id._const_tab_id = 'id'
    ___SecurityIndication_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SecurityIndication_iE_Extensions__item__criticality._const_tab = ____SecurityIndication_iE_Extensions__item__id_tab
    ___SecurityIndication_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SecurityIndication_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SecurityIndication_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SecurityIndication_iE_Extensions__item__extensionValue._const_tab = ____SecurityIndication_iE_Extensions__item__id_tab
    ___SecurityIndication_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SecurityIndication_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SecurityIndication_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SecurityIndication_iE_Extensions__item__id),
        ('criticality', ___SecurityIndication_iE_Extensions__item__criticality),
        ('extensionValue', ___SecurityIndication_iE_Extensions__item__extensionValue),
        ])
    __SecurityIndication_iE_Extensions__item_._ext = None
    _SecurityIndication_iE_Extensions._cont = __SecurityIndication_iE_Extensions__item_
    _SecurityIndication_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecurityIndication._cont = ASN1Dict([
        ('integrityProtectionIndication', _SecurityIndication_integrityProtectionIndication),
        ('confidentialityProtectionIndication', _SecurityIndication_confidentialityProtectionIndication),
        ('maximumIntegrityProtectedDataRate-UL', _SecurityIndication_maximumIntegrityProtectedDataRate_UL),
        ('iE-Extensions', _SecurityIndication_iE_Extensions),
        ])
    SecurityIndication._ext = []
    
    #-----< SecurityIndication-ExtIEs >-----#
    SecurityIndication_ExtIEs = CLASS(name='SecurityIndication-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _SecurityIndication_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MaximumIntegrityProtectedDataRate')))
    SecurityIndication_ExtIEs._val = ASN1Set(rv=[dict([('id', 151), ('criticality', 'ignore'), ('Extension', _SecurityIndication_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SecurityKey >-----#
    SecurityKey = BIT_STR(name='SecurityKey', mode=MODE_TYPE)
    SecurityKey._const_sz = ASN1Set(rv=[256], rr=[], ev=None, er=[])
    
    #-----< SecurityResult >-----#
    SecurityResult = SEQ(name='SecurityResult', mode=MODE_TYPE)
    _SecurityResult_integrityProtectionResult = ENUM(name='integrityProtectionResult', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IntegrityProtectionResult')))
    _SecurityResult_confidentialityProtectionResult = ENUM(name='confidentialityProtectionResult', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ConfidentialityProtectionResult')))
    _SecurityResult_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecurityResult_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SecurityResult_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____SecurityResult_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SecurityResult_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityResult_iE_Extensions__item__id._const_tab = ____SecurityResult_iE_Extensions__item__id_tab
    ___SecurityResult_iE_Extensions__item__id._const_tab_at = None
    ___SecurityResult_iE_Extensions__item__id._const_tab_id = 'id'
    ___SecurityResult_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SecurityResult_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SecurityResult_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityResult_iE_Extensions__item__criticality._const_tab = ____SecurityResult_iE_Extensions__item__criticality_tab
    ___SecurityResult_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SecurityResult_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SecurityResult_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SecurityResult_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SecurityResult_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityResult_iE_Extensions__item__extensionValue._const_tab = ____SecurityResult_iE_Extensions__item__extensionValue_tab
    ___SecurityResult_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SecurityResult_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SecurityResult_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SecurityResult_iE_Extensions__item__id),
        ('criticality', ___SecurityResult_iE_Extensions__item__criticality),
        ('extensionValue', ___SecurityResult_iE_Extensions__item__extensionValue),
        ])
    __SecurityResult_iE_Extensions__item_._ext = None
    _SecurityResult_iE_Extensions._cont = __SecurityResult_iE_Extensions__item_
    _SecurityResult_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecurityResult._cont = ASN1Dict([
        ('integrityProtectionResult', _SecurityResult_integrityProtectionResult),
        ('confidentialityProtectionResult', _SecurityResult_confidentialityProtectionResult),
        ('iE-Extensions', _SecurityResult_iE_Extensions),
        ])
    SecurityResult._ext = []
    
    #-----< SecurityResult-ExtIEs >-----#
    SecurityResult_ExtIEs = CLASS(name='SecurityResult-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SecurityResult_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SensorMeasurementConfiguration >-----#
    SensorMeasurementConfiguration = SEQ(name='SensorMeasurementConfiguration', mode=MODE_TYPE)
    _SensorMeasurementConfiguration_sensorMeasConfig = ENUM(name='sensorMeasConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SensorMeasConfig')))
    _SensorMeasurementConfiguration_sensorMeasConfigNameList = SEQ_OF(name='sensorMeasConfigNameList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SensorMeasConfigNameList')), opt=True)
    _SensorMeasurementConfiguration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SensorMeasurementConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SensorMeasurementConfiguration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____SensorMeasurementConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SensorMeasurementConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SensorMeasurementConfiguration_iE_Extensions__item__id._const_tab = ____SensorMeasurementConfiguration_iE_Extensions__item__id_tab
    ___SensorMeasurementConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___SensorMeasurementConfiguration_iE_Extensions__item__id._const_tab_id = 'id'
    ___SensorMeasurementConfiguration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SensorMeasurementConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SensorMeasurementConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SensorMeasurementConfiguration_iE_Extensions__item__criticality._const_tab = ____SensorMeasurementConfiguration_iE_Extensions__item__criticality_tab
    ___SensorMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SensorMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SensorMeasurementConfiguration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SensorMeasurementConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SensorMeasurementConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SensorMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab = ____SensorMeasurementConfiguration_iE_Extensions__item__extensionValue_tab
    ___SensorMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SensorMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SensorMeasurementConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SensorMeasurementConfiguration_iE_Extensions__item__id),
        ('criticality', ___SensorMeasurementConfiguration_iE_Extensions__item__criticality),
        ('extensionValue', ___SensorMeasurementConfiguration_iE_Extensions__item__extensionValue),
        ])
    __SensorMeasurementConfiguration_iE_Extensions__item_._ext = None
    _SensorMeasurementConfiguration_iE_Extensions._cont = __SensorMeasurementConfiguration_iE_Extensions__item_
    _SensorMeasurementConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SensorMeasurementConfiguration._cont = ASN1Dict([
        ('sensorMeasConfig', _SensorMeasurementConfiguration_sensorMeasConfig),
        ('sensorMeasConfigNameList', _SensorMeasurementConfiguration_sensorMeasConfigNameList),
        ('iE-Extensions', _SensorMeasurementConfiguration_iE_Extensions),
        ])
    SensorMeasurementConfiguration._ext = []
    
    #-----< SensorMeasurementConfiguration-ExtIEs >-----#
    SensorMeasurementConfiguration_ExtIEs = CLASS(name='SensorMeasurementConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SensorMeasurementConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SensorMeasConfigNameList >-----#
    SensorMeasConfigNameList = SEQ_OF(name='SensorMeasConfigNameList', mode=MODE_TYPE)
    _SensorMeasConfigNameList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SensorMeasConfigNameItem')))
    SensorMeasConfigNameList._cont = _SensorMeasConfigNameList__item_
    SensorMeasConfigNameList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< SensorMeasConfigNameItem >-----#
    SensorMeasConfigNameItem = SEQ(name='SensorMeasConfigNameItem', mode=MODE_TYPE)
    _SensorMeasConfigNameItem_sensorNameConfig = CHOICE(name='sensorNameConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SensorNameConfig')))
    _SensorMeasConfigNameItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SensorMeasConfigNameItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SensorMeasConfigNameItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____SensorMeasConfigNameItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SensorMeasConfigNameItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SensorMeasConfigNameItem_iE_Extensions__item__id._const_tab = ____SensorMeasConfigNameItem_iE_Extensions__item__id_tab
    ___SensorMeasConfigNameItem_iE_Extensions__item__id._const_tab_at = None
    ___SensorMeasConfigNameItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SensorMeasConfigNameItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SensorMeasConfigNameItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SensorMeasConfigNameItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SensorMeasConfigNameItem_iE_Extensions__item__criticality._const_tab = ____SensorMeasConfigNameItem_iE_Extensions__item__criticality_tab
    ___SensorMeasConfigNameItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SensorMeasConfigNameItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SensorMeasConfigNameItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SensorMeasConfigNameItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SensorMeasConfigNameItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SensorMeasConfigNameItem_iE_Extensions__item__extensionValue._const_tab = ____SensorMeasConfigNameItem_iE_Extensions__item__extensionValue_tab
    ___SensorMeasConfigNameItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SensorMeasConfigNameItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SensorMeasConfigNameItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SensorMeasConfigNameItem_iE_Extensions__item__id),
        ('criticality', ___SensorMeasConfigNameItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SensorMeasConfigNameItem_iE_Extensions__item__extensionValue),
        ])
    __SensorMeasConfigNameItem_iE_Extensions__item_._ext = None
    _SensorMeasConfigNameItem_iE_Extensions._cont = __SensorMeasConfigNameItem_iE_Extensions__item_
    _SensorMeasConfigNameItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SensorMeasConfigNameItem._cont = ASN1Dict([
        ('sensorNameConfig', _SensorMeasConfigNameItem_sensorNameConfig),
        ('iE-Extensions', _SensorMeasConfigNameItem_iE_Extensions),
        ])
    SensorMeasConfigNameItem._ext = []
    
    #-----< SensorMeasConfigNameItem-ExtIEs >-----#
    SensorMeasConfigNameItem_ExtIEs = CLASS(name='SensorMeasConfigNameItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SensorMeasConfigNameItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SensorMeasConfig >-----#
    SensorMeasConfig = ENUM(name='SensorMeasConfig', mode=MODE_TYPE)
    SensorMeasConfig._cont = ASN1Dict([('setup', 0)])
    SensorMeasConfig._ext = []
    
    #-----< SensorNameConfig >-----#
    SensorNameConfig = CHOICE(name='SensorNameConfig', mode=MODE_TYPE)
    _SensorNameConfig_uncompensatedBarometricConfig = ENUM(name='uncompensatedBarometricConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SensorNameConfig_uncompensatedBarometricConfig._cont = ASN1Dict([('true', 0)])
    _SensorNameConfig_uncompensatedBarometricConfig._ext = []
    _SensorNameConfig_ueSpeedConfig = ENUM(name='ueSpeedConfig', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SensorNameConfig_ueSpeedConfig._cont = ASN1Dict([('true', 0)])
    _SensorNameConfig_ueSpeedConfig._ext = []
    _SensorNameConfig_ueOrientationConfig = ENUM(name='ueOrientationConfig', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SensorNameConfig_ueOrientationConfig._cont = ASN1Dict([('true', 0)])
    _SensorNameConfig_ueOrientationConfig._ext = []
    _SensorNameConfig_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __SensorNameConfig_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___SensorNameConfig_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___SensorNameConfig_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SensorNameConfig_choice_Extensions_id._const_tab = ___SensorNameConfig_choice_Extensions_id_tab
    __SensorNameConfig_choice_Extensions_id._const_tab_at = None
    __SensorNameConfig_choice_Extensions_id._const_tab_id = 'id'
    __SensorNameConfig_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___SensorNameConfig_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___SensorNameConfig_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SensorNameConfig_choice_Extensions_criticality._const_tab = ___SensorNameConfig_choice_Extensions_criticality_tab
    __SensorNameConfig_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __SensorNameConfig_choice_Extensions_criticality._const_tab_id = 'criticality'
    __SensorNameConfig_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___SensorNameConfig_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___SensorNameConfig_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SensorNameConfig_choice_Extensions_value._const_tab = ___SensorNameConfig_choice_Extensions_value_tab
    __SensorNameConfig_choice_Extensions_value._const_tab_at = ('..', 'id')
    __SensorNameConfig_choice_Extensions_value._const_tab_id = 'Value'
    _SensorNameConfig_choice_Extensions._cont = ASN1Dict([
        ('id', __SensorNameConfig_choice_Extensions_id),
        ('criticality', __SensorNameConfig_choice_Extensions_criticality),
        ('value', __SensorNameConfig_choice_Extensions_value),
        ])
    _SensorNameConfig_choice_Extensions._ext = None
    SensorNameConfig._cont = ASN1Dict([
        ('uncompensatedBarometricConfig', _SensorNameConfig_uncompensatedBarometricConfig),
        ('ueSpeedConfig', _SensorNameConfig_ueSpeedConfig),
        ('ueOrientationConfig', _SensorNameConfig_ueOrientationConfig),
        ('choice-Extensions', _SensorNameConfig_choice_Extensions),
        ])
    SensorNameConfig._ext = None
    
    #-----< SensorNameConfig-ExtIEs >-----#
    SensorNameConfig_ExtIEs = CLASS(name='SensorNameConfig-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    SensorNameConfig_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SerialNumber >-----#
    SerialNumber = BIT_STR(name='SerialNumber', mode=MODE_TYPE)
    SerialNumber._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< ServedGUAMIList >-----#
    ServedGUAMIList = SEQ_OF(name='ServedGUAMIList', mode=MODE_TYPE)
    _ServedGUAMIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ServedGUAMIItem')))
    ServedGUAMIList._cont = _ServedGUAMIList__item_
    ServedGUAMIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ServedGUAMIItem >-----#
    ServedGUAMIItem = SEQ(name='ServedGUAMIItem', mode=MODE_TYPE)
    _ServedGUAMIItem_gUAMI = SEQ(name='gUAMI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GUAMI')))
    _ServedGUAMIItem_backupAMFName = STR_PRINT(name='backupAMFName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AMFName')), opt=True)
    _ServedGUAMIItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ServedGUAMIItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___ServedGUAMIItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____ServedGUAMIItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____ServedGUAMIItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GUAMIType')))
    ____ServedGUAMIItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 176), ('criticality', 'ignore'), ('Extension', _____ServedGUAMIItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ServedGUAMIItem_iE_Extensions__item__id._const_tab = ____ServedGUAMIItem_iE_Extensions__item__id_tab
    ___ServedGUAMIItem_iE_Extensions__item__id._const_tab_at = None
    ___ServedGUAMIItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___ServedGUAMIItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___ServedGUAMIItem_iE_Extensions__item__criticality._const_tab = ____ServedGUAMIItem_iE_Extensions__item__id_tab
    ___ServedGUAMIItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ServedGUAMIItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ServedGUAMIItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___ServedGUAMIItem_iE_Extensions__item__extensionValue._const_tab = ____ServedGUAMIItem_iE_Extensions__item__id_tab
    ___ServedGUAMIItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ServedGUAMIItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ServedGUAMIItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ServedGUAMIItem_iE_Extensions__item__id),
        ('criticality', ___ServedGUAMIItem_iE_Extensions__item__criticality),
        ('extensionValue', ___ServedGUAMIItem_iE_Extensions__item__extensionValue),
        ])
    __ServedGUAMIItem_iE_Extensions__item_._ext = None
    _ServedGUAMIItem_iE_Extensions._cont = __ServedGUAMIItem_iE_Extensions__item_
    _ServedGUAMIItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ServedGUAMIItem._cont = ASN1Dict([
        ('gUAMI', _ServedGUAMIItem_gUAMI),
        ('backupAMFName', _ServedGUAMIItem_backupAMFName),
        ('iE-Extensions', _ServedGUAMIItem_iE_Extensions),
        ])
    ServedGUAMIItem._ext = []
    
    #-----< ServedGUAMIItem-ExtIEs >-----#
    ServedGUAMIItem_ExtIEs = CLASS(name='ServedGUAMIItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _ServedGUAMIItem_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GUAMIType')))
    ServedGUAMIItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 176), ('criticality', 'ignore'), ('Extension', _ServedGUAMIItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ServiceAreaInformation >-----#
    ServiceAreaInformation = SEQ_OF(name='ServiceAreaInformation', mode=MODE_TYPE)
    _ServiceAreaInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ServiceAreaInformation-Item')))
    ServiceAreaInformation._cont = _ServiceAreaInformation__item_
    ServiceAreaInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< ServiceAreaInformation-Item >-----#
    ServiceAreaInformation_Item = SEQ(name='ServiceAreaInformation-Item', mode=MODE_TYPE)
    _ServiceAreaInformation_Item_pLMNIdentity = OCT_STR(name='pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _ServiceAreaInformation_Item_allowedTACs = SEQ_OF(name='allowedTACs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AllowedTACs')), opt=True)
    _ServiceAreaInformation_Item_notAllowedTACs = SEQ_OF(name='notAllowedTACs', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NotAllowedTACs')), opt=True)
    _ServiceAreaInformation_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ServiceAreaInformation_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___ServiceAreaInformation_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____ServiceAreaInformation_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ServiceAreaInformation_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServiceAreaInformation_Item_iE_Extensions__item__id._const_tab = ____ServiceAreaInformation_Item_iE_Extensions__item__id_tab
    ___ServiceAreaInformation_Item_iE_Extensions__item__id._const_tab_at = None
    ___ServiceAreaInformation_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ServiceAreaInformation_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ServiceAreaInformation_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ServiceAreaInformation_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServiceAreaInformation_Item_iE_Extensions__item__criticality._const_tab = ____ServiceAreaInformation_Item_iE_Extensions__item__criticality_tab
    ___ServiceAreaInformation_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ServiceAreaInformation_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ServiceAreaInformation_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ServiceAreaInformation_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____ServiceAreaInformation_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServiceAreaInformation_Item_iE_Extensions__item__extensionValue._const_tab = ____ServiceAreaInformation_Item_iE_Extensions__item__extensionValue_tab
    ___ServiceAreaInformation_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ServiceAreaInformation_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ServiceAreaInformation_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ServiceAreaInformation_Item_iE_Extensions__item__id),
        ('criticality', ___ServiceAreaInformation_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ServiceAreaInformation_Item_iE_Extensions__item__extensionValue),
        ])
    __ServiceAreaInformation_Item_iE_Extensions__item_._ext = None
    _ServiceAreaInformation_Item_iE_Extensions._cont = __ServiceAreaInformation_Item_iE_Extensions__item_
    _ServiceAreaInformation_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ServiceAreaInformation_Item._cont = ASN1Dict([
        ('pLMNIdentity', _ServiceAreaInformation_Item_pLMNIdentity),
        ('allowedTACs', _ServiceAreaInformation_Item_allowedTACs),
        ('notAllowedTACs', _ServiceAreaInformation_Item_notAllowedTACs),
        ('iE-Extensions', _ServiceAreaInformation_Item_iE_Extensions),
        ])
    ServiceAreaInformation_Item._ext = []
    
    #-----< ServiceAreaInformation-Item-ExtIEs >-----#
    ServiceAreaInformation_Item_ExtIEs = CLASS(name='ServiceAreaInformation-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ServiceAreaInformation_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ServiceType >-----#
    ServiceType = ENUM(name='ServiceType', mode=MODE_TYPE)
    ServiceType._cont = ASN1Dict([('streaming', 0), ('mTSI', 1), ('vR', 2)])
    ServiceType._ext = []
    
    #-----< SgNB-UE-X2AP-ID >-----#
    SgNB_UE_X2AP_ID = INT(name='SgNB-UE-X2AP-ID', mode=MODE_TYPE)
    SgNB_UE_X2AP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< SharedNGU-MulticastTNLInformation >-----#
    SharedNGU_MulticastTNLInformation = SEQ(name='SharedNGU-MulticastTNLInformation', mode=MODE_TYPE)
    _SharedNGU_MulticastTNLInformation_iP_MulticastAddress = BIT_STR(name='iP-MulticastAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _SharedNGU_MulticastTNLInformation_iP_SourceAddress = BIT_STR(name='iP-SourceAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _SharedNGU_MulticastTNLInformation_gTP_TEID = OCT_STR(name='gTP-TEID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GTP-TEID')))
    _SharedNGU_MulticastTNLInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SharedNGU_MulticastTNLInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SharedNGU_MulticastTNLInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____SharedNGU_MulticastTNLInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SharedNGU_MulticastTNLInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SharedNGU_MulticastTNLInformation_iE_Extensions__item__id._const_tab = ____SharedNGU_MulticastTNLInformation_iE_Extensions__item__id_tab
    ___SharedNGU_MulticastTNLInformation_iE_Extensions__item__id._const_tab_at = None
    ___SharedNGU_MulticastTNLInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___SharedNGU_MulticastTNLInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SharedNGU_MulticastTNLInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SharedNGU_MulticastTNLInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SharedNGU_MulticastTNLInformation_iE_Extensions__item__criticality._const_tab = ____SharedNGU_MulticastTNLInformation_iE_Extensions__item__criticality_tab
    ___SharedNGU_MulticastTNLInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SharedNGU_MulticastTNLInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SharedNGU_MulticastTNLInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SharedNGU_MulticastTNLInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SharedNGU_MulticastTNLInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SharedNGU_MulticastTNLInformation_iE_Extensions__item__extensionValue._const_tab = ____SharedNGU_MulticastTNLInformation_iE_Extensions__item__extensionValue_tab
    ___SharedNGU_MulticastTNLInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SharedNGU_MulticastTNLInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SharedNGU_MulticastTNLInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SharedNGU_MulticastTNLInformation_iE_Extensions__item__id),
        ('criticality', ___SharedNGU_MulticastTNLInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___SharedNGU_MulticastTNLInformation_iE_Extensions__item__extensionValue),
        ])
    __SharedNGU_MulticastTNLInformation_iE_Extensions__item_._ext = None
    _SharedNGU_MulticastTNLInformation_iE_Extensions._cont = __SharedNGU_MulticastTNLInformation_iE_Extensions__item_
    _SharedNGU_MulticastTNLInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SharedNGU_MulticastTNLInformation._cont = ASN1Dict([
        ('iP-MulticastAddress', _SharedNGU_MulticastTNLInformation_iP_MulticastAddress),
        ('iP-SourceAddress', _SharedNGU_MulticastTNLInformation_iP_SourceAddress),
        ('gTP-TEID', _SharedNGU_MulticastTNLInformation_gTP_TEID),
        ('iE-Extensions', _SharedNGU_MulticastTNLInformation_iE_Extensions),
        ])
    SharedNGU_MulticastTNLInformation._ext = []
    
    #-----< SharedNGU-MulticastTNLInformation-ExtIEs >-----#
    SharedNGU_MulticastTNLInformation_ExtIEs = CLASS(name='SharedNGU-MulticastTNLInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SharedNGU_MulticastTNLInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SliceOverloadList >-----#
    SliceOverloadList = SEQ_OF(name='SliceOverloadList', mode=MODE_TYPE)
    _SliceOverloadList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SliceOverloadItem')))
    SliceOverloadList._cont = _SliceOverloadList__item_
    SliceOverloadList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< SliceOverloadItem >-----#
    SliceOverloadItem = SEQ(name='SliceOverloadItem', mode=MODE_TYPE)
    _SliceOverloadItem_s_NSSAI = SEQ(name='s-NSSAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _SliceOverloadItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SliceOverloadItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SliceOverloadItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____SliceOverloadItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SliceOverloadItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceOverloadItem_iE_Extensions__item__id._const_tab = ____SliceOverloadItem_iE_Extensions__item__id_tab
    ___SliceOverloadItem_iE_Extensions__item__id._const_tab_at = None
    ___SliceOverloadItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SliceOverloadItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SliceOverloadItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SliceOverloadItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceOverloadItem_iE_Extensions__item__criticality._const_tab = ____SliceOverloadItem_iE_Extensions__item__criticality_tab
    ___SliceOverloadItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SliceOverloadItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SliceOverloadItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SliceOverloadItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SliceOverloadItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceOverloadItem_iE_Extensions__item__extensionValue._const_tab = ____SliceOverloadItem_iE_Extensions__item__extensionValue_tab
    ___SliceOverloadItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SliceOverloadItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SliceOverloadItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SliceOverloadItem_iE_Extensions__item__id),
        ('criticality', ___SliceOverloadItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SliceOverloadItem_iE_Extensions__item__extensionValue),
        ])
    __SliceOverloadItem_iE_Extensions__item_._ext = None
    _SliceOverloadItem_iE_Extensions._cont = __SliceOverloadItem_iE_Extensions__item_
    _SliceOverloadItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SliceOverloadItem._cont = ASN1Dict([
        ('s-NSSAI', _SliceOverloadItem_s_NSSAI),
        ('iE-Extensions', _SliceOverloadItem_iE_Extensions),
        ])
    SliceOverloadItem._ext = []
    
    #-----< SliceOverloadItem-ExtIEs >-----#
    SliceOverloadItem_ExtIEs = CLASS(name='SliceOverloadItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SliceOverloadItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SliceSupportList >-----#
    SliceSupportList = SEQ_OF(name='SliceSupportList', mode=MODE_TYPE)
    _SliceSupportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SliceSupportItem')))
    SliceSupportList._cont = _SliceSupportList__item_
    SliceSupportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< SliceSupportItem >-----#
    SliceSupportItem = SEQ(name='SliceSupportItem', mode=MODE_TYPE)
    _SliceSupportItem_s_NSSAI = SEQ(name='s-NSSAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _SliceSupportItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SliceSupportItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SliceSupportItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____SliceSupportItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SliceSupportItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceSupportItem_iE_Extensions__item__id._const_tab = ____SliceSupportItem_iE_Extensions__item__id_tab
    ___SliceSupportItem_iE_Extensions__item__id._const_tab_at = None
    ___SliceSupportItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SliceSupportItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SliceSupportItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SliceSupportItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceSupportItem_iE_Extensions__item__criticality._const_tab = ____SliceSupportItem_iE_Extensions__item__criticality_tab
    ___SliceSupportItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SliceSupportItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SliceSupportItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SliceSupportItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SliceSupportItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceSupportItem_iE_Extensions__item__extensionValue._const_tab = ____SliceSupportItem_iE_Extensions__item__extensionValue_tab
    ___SliceSupportItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SliceSupportItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SliceSupportItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SliceSupportItem_iE_Extensions__item__id),
        ('criticality', ___SliceSupportItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SliceSupportItem_iE_Extensions__item__extensionValue),
        ])
    __SliceSupportItem_iE_Extensions__item_._ext = None
    _SliceSupportItem_iE_Extensions._cont = __SliceSupportItem_iE_Extensions__item_
    _SliceSupportItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SliceSupportItem._cont = ASN1Dict([
        ('s-NSSAI', _SliceSupportItem_s_NSSAI),
        ('iE-Extensions', _SliceSupportItem_iE_Extensions),
        ])
    SliceSupportItem._ext = []
    
    #-----< SliceSupportItem-ExtIEs >-----#
    SliceSupportItem_ExtIEs = CLASS(name='SliceSupportItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SliceSupportItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SliceSupportListQMC >-----#
    SliceSupportListQMC = SEQ_OF(name='SliceSupportListQMC', mode=MODE_TYPE)
    _SliceSupportListQMC__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SliceSupportQMC-Item')))
    SliceSupportListQMC._cont = _SliceSupportListQMC__item_
    SliceSupportListQMC._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< SliceSupportQMC-Item >-----#
    SliceSupportQMC_Item = SEQ(name='SliceSupportQMC-Item', mode=MODE_TYPE)
    _SliceSupportQMC_Item_s_NSSAI = SEQ(name='s-NSSAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _SliceSupportQMC_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SliceSupportQMC_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SliceSupportQMC_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____SliceSupportQMC_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SliceSupportQMC_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceSupportQMC_Item_iE_Extensions__item__id._const_tab = ____SliceSupportQMC_Item_iE_Extensions__item__id_tab
    ___SliceSupportQMC_Item_iE_Extensions__item__id._const_tab_at = None
    ___SliceSupportQMC_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SliceSupportQMC_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SliceSupportQMC_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SliceSupportQMC_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceSupportQMC_Item_iE_Extensions__item__criticality._const_tab = ____SliceSupportQMC_Item_iE_Extensions__item__criticality_tab
    ___SliceSupportQMC_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SliceSupportQMC_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SliceSupportQMC_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SliceSupportQMC_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SliceSupportQMC_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SliceSupportQMC_Item_iE_Extensions__item__extensionValue._const_tab = ____SliceSupportQMC_Item_iE_Extensions__item__extensionValue_tab
    ___SliceSupportQMC_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SliceSupportQMC_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SliceSupportQMC_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SliceSupportQMC_Item_iE_Extensions__item__id),
        ('criticality', ___SliceSupportQMC_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SliceSupportQMC_Item_iE_Extensions__item__extensionValue),
        ])
    __SliceSupportQMC_Item_iE_Extensions__item_._ext = None
    _SliceSupportQMC_Item_iE_Extensions._cont = __SliceSupportQMC_Item_iE_Extensions__item_
    _SliceSupportQMC_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SliceSupportQMC_Item._cont = ASN1Dict([
        ('s-NSSAI', _SliceSupportQMC_Item_s_NSSAI),
        ('iE-Extensions', _SliceSupportQMC_Item_iE_Extensions),
        ])
    SliceSupportQMC_Item._ext = []
    
    #-----< SliceSupportQMC-Item-ExtIEs >-----#
    SliceSupportQMC_Item_ExtIEs = CLASS(name='SliceSupportQMC-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SliceSupportQMC_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SNPN-MobilityInformation >-----#
    SNPN_MobilityInformation = SEQ(name='SNPN-MobilityInformation', mode=MODE_TYPE)
    _SNPN_MobilityInformation_serving_NID = BIT_STR(name='serving-NID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NID')))
    _SNPN_MobilityInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SNPN_MobilityInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SNPN_MobilityInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____SNPN_MobilityInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SNPN_MobilityInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNPN_MobilityInformation_iE_Extensions__item__id._const_tab = ____SNPN_MobilityInformation_iE_Extensions__item__id_tab
    ___SNPN_MobilityInformation_iE_Extensions__item__id._const_tab_at = None
    ___SNPN_MobilityInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___SNPN_MobilityInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SNPN_MobilityInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SNPN_MobilityInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNPN_MobilityInformation_iE_Extensions__item__criticality._const_tab = ____SNPN_MobilityInformation_iE_Extensions__item__criticality_tab
    ___SNPN_MobilityInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SNPN_MobilityInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SNPN_MobilityInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SNPN_MobilityInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SNPN_MobilityInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNPN_MobilityInformation_iE_Extensions__item__extensionValue._const_tab = ____SNPN_MobilityInformation_iE_Extensions__item__extensionValue_tab
    ___SNPN_MobilityInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SNPN_MobilityInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SNPN_MobilityInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SNPN_MobilityInformation_iE_Extensions__item__id),
        ('criticality', ___SNPN_MobilityInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___SNPN_MobilityInformation_iE_Extensions__item__extensionValue),
        ])
    __SNPN_MobilityInformation_iE_Extensions__item_._ext = None
    _SNPN_MobilityInformation_iE_Extensions._cont = __SNPN_MobilityInformation_iE_Extensions__item_
    _SNPN_MobilityInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SNPN_MobilityInformation._cont = ASN1Dict([
        ('serving-NID', _SNPN_MobilityInformation_serving_NID),
        ('iE-Extensions', _SNPN_MobilityInformation_iE_Extensions),
        ])
    SNPN_MobilityInformation._ext = []
    
    #-----< SNPN-MobilityInformation-ExtIEs >-----#
    SNPN_MobilityInformation_ExtIEs = CLASS(name='SNPN-MobilityInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SNPN_MobilityInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< S-NSSAI >-----#
    S_NSSAI = SEQ(name='S-NSSAI', mode=MODE_TYPE)
    _S_NSSAI_sST = OCT_STR(name='sST', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SST')))
    _S_NSSAI_sD = OCT_STR(name='sD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SD')), opt=True)
    _S_NSSAI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __S_NSSAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___S_NSSAI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____S_NSSAI_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____S_NSSAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___S_NSSAI_iE_Extensions__item__id._const_tab = ____S_NSSAI_iE_Extensions__item__id_tab
    ___S_NSSAI_iE_Extensions__item__id._const_tab_at = None
    ___S_NSSAI_iE_Extensions__item__id._const_tab_id = 'id'
    ___S_NSSAI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____S_NSSAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____S_NSSAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___S_NSSAI_iE_Extensions__item__criticality._const_tab = ____S_NSSAI_iE_Extensions__item__criticality_tab
    ___S_NSSAI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___S_NSSAI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___S_NSSAI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____S_NSSAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____S_NSSAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___S_NSSAI_iE_Extensions__item__extensionValue._const_tab = ____S_NSSAI_iE_Extensions__item__extensionValue_tab
    ___S_NSSAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___S_NSSAI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __S_NSSAI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___S_NSSAI_iE_Extensions__item__id),
        ('criticality', ___S_NSSAI_iE_Extensions__item__criticality),
        ('extensionValue', ___S_NSSAI_iE_Extensions__item__extensionValue),
        ])
    __S_NSSAI_iE_Extensions__item_._ext = None
    _S_NSSAI_iE_Extensions._cont = __S_NSSAI_iE_Extensions__item_
    _S_NSSAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    S_NSSAI._cont = ASN1Dict([
        ('sST', _S_NSSAI_sST),
        ('sD', _S_NSSAI_sD),
        ('iE-Extensions', _S_NSSAI_iE_Extensions),
        ])
    S_NSSAI._ext = []
    
    #-----< S-NSSAI-ExtIEs >-----#
    S_NSSAI_ExtIEs = CLASS(name='S-NSSAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    S_NSSAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SONConfigurationTransfer >-----#
    SONConfigurationTransfer = SEQ(name='SONConfigurationTransfer', mode=MODE_TYPE)
    _SONConfigurationTransfer_targetRANNodeID_SON = SEQ(name='targetRANNodeID-SON', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TargetRANNodeID-SON')))
    _SONConfigurationTransfer_sourceRANNodeID = SEQ(name='sourceRANNodeID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SourceRANNodeID')))
    _SONConfigurationTransfer_sONInformation = CHOICE(name='sONInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SONInformation')))
    _SONConfigurationTransfer_xnTNLConfigurationInfo = SEQ(name='xnTNLConfigurationInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'XnTNLConfigurationInfo')), opt=True)
    _SONConfigurationTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SONConfigurationTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SONConfigurationTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____SONConfigurationTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SONConfigurationTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SONConfigurationTransfer_iE_Extensions__item__id._const_tab = ____SONConfigurationTransfer_iE_Extensions__item__id_tab
    ___SONConfigurationTransfer_iE_Extensions__item__id._const_tab_at = None
    ___SONConfigurationTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___SONConfigurationTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SONConfigurationTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SONConfigurationTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SONConfigurationTransfer_iE_Extensions__item__criticality._const_tab = ____SONConfigurationTransfer_iE_Extensions__item__criticality_tab
    ___SONConfigurationTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SONConfigurationTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SONConfigurationTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SONConfigurationTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SONConfigurationTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SONConfigurationTransfer_iE_Extensions__item__extensionValue._const_tab = ____SONConfigurationTransfer_iE_Extensions__item__extensionValue_tab
    ___SONConfigurationTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SONConfigurationTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SONConfigurationTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SONConfigurationTransfer_iE_Extensions__item__id),
        ('criticality', ___SONConfigurationTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___SONConfigurationTransfer_iE_Extensions__item__extensionValue),
        ])
    __SONConfigurationTransfer_iE_Extensions__item_._ext = None
    _SONConfigurationTransfer_iE_Extensions._cont = __SONConfigurationTransfer_iE_Extensions__item_
    _SONConfigurationTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SONConfigurationTransfer._cont = ASN1Dict([
        ('targetRANNodeID-SON', _SONConfigurationTransfer_targetRANNodeID_SON),
        ('sourceRANNodeID', _SONConfigurationTransfer_sourceRANNodeID),
        ('sONInformation', _SONConfigurationTransfer_sONInformation),
        ('xnTNLConfigurationInfo', _SONConfigurationTransfer_xnTNLConfigurationInfo),
        ('iE-Extensions', _SONConfigurationTransfer_iE_Extensions),
        ])
    SONConfigurationTransfer._ext = []
    
    #-----< SONConfigurationTransfer-ExtIEs >-----#
    SONConfigurationTransfer_ExtIEs = CLASS(name='SONConfigurationTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SONConfigurationTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SONInformation >-----#
    SONInformation = CHOICE(name='SONInformation', mode=MODE_TYPE)
    _SONInformation_sONInformationRequest = ENUM(name='sONInformationRequest', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SONInformationRequest')))
    _SONInformation_sONInformationReply = SEQ(name='sONInformationReply', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SONInformationReply')))
    _SONInformation_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __SONInformation_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___SONInformation_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ____SONInformation_choice_Extensions_id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SONInformationReport')))
    ___SONInformation_choice_Extensions_id_tab._val = ASN1Set(rv=[dict([('id', 252), ('criticality', 'ignore'), ('Value', ____SONInformation_choice_Extensions_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SONInformation_choice_Extensions_id._const_tab = ___SONInformation_choice_Extensions_id_tab
    __SONInformation_choice_Extensions_id._const_tab_at = None
    __SONInformation_choice_Extensions_id._const_tab_id = 'id'
    __SONInformation_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    __SONInformation_choice_Extensions_criticality._const_tab = ___SONInformation_choice_Extensions_id_tab
    __SONInformation_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __SONInformation_choice_Extensions_criticality._const_tab_id = 'criticality'
    __SONInformation_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    __SONInformation_choice_Extensions_value._const_tab = ___SONInformation_choice_Extensions_id_tab
    __SONInformation_choice_Extensions_value._const_tab_at = ('..', 'id')
    __SONInformation_choice_Extensions_value._const_tab_id = 'Value'
    _SONInformation_choice_Extensions._cont = ASN1Dict([
        ('id', __SONInformation_choice_Extensions_id),
        ('criticality', __SONInformation_choice_Extensions_criticality),
        ('value', __SONInformation_choice_Extensions_value),
        ])
    _SONInformation_choice_Extensions._ext = None
    SONInformation._cont = ASN1Dict([
        ('sONInformationRequest', _SONInformation_sONInformationRequest),
        ('sONInformationReply', _SONInformation_sONInformationReply),
        ('choice-Extensions', _SONInformation_choice_Extensions),
        ])
    SONInformation._ext = None
    
    #-----< SONInformation-ExtIEs >-----#
    SONInformation_ExtIEs = CLASS(name='SONInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _SONInformation_ExtIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SONInformationReport')))
    SONInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 252), ('criticality', 'ignore'), ('Value', _SONInformation_ExtIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SONInformationReply >-----#
    SONInformationReply = SEQ(name='SONInformationReply', mode=MODE_TYPE)
    _SONInformationReply_xnTNLConfigurationInfo = SEQ(name='xnTNLConfigurationInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'XnTNLConfigurationInfo')), opt=True)
    _SONInformationReply_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SONInformationReply_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SONInformationReply_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____SONInformationReply_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SONInformationReply_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SONInformationReply_iE_Extensions__item__id._const_tab = ____SONInformationReply_iE_Extensions__item__id_tab
    ___SONInformationReply_iE_Extensions__item__id._const_tab_at = None
    ___SONInformationReply_iE_Extensions__item__id._const_tab_id = 'id'
    ___SONInformationReply_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SONInformationReply_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SONInformationReply_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SONInformationReply_iE_Extensions__item__criticality._const_tab = ____SONInformationReply_iE_Extensions__item__criticality_tab
    ___SONInformationReply_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SONInformationReply_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SONInformationReply_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SONInformationReply_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SONInformationReply_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SONInformationReply_iE_Extensions__item__extensionValue._const_tab = ____SONInformationReply_iE_Extensions__item__extensionValue_tab
    ___SONInformationReply_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SONInformationReply_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SONInformationReply_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SONInformationReply_iE_Extensions__item__id),
        ('criticality', ___SONInformationReply_iE_Extensions__item__criticality),
        ('extensionValue', ___SONInformationReply_iE_Extensions__item__extensionValue),
        ])
    __SONInformationReply_iE_Extensions__item_._ext = None
    _SONInformationReply_iE_Extensions._cont = __SONInformationReply_iE_Extensions__item_
    _SONInformationReply_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SONInformationReply._cont = ASN1Dict([
        ('xnTNLConfigurationInfo', _SONInformationReply_xnTNLConfigurationInfo),
        ('iE-Extensions', _SONInformationReply_iE_Extensions),
        ])
    SONInformationReply._ext = []
    
    #-----< SONInformationReply-ExtIEs >-----#
    SONInformationReply_ExtIEs = CLASS(name='SONInformationReply-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SONInformationReply_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SONInformationReport >-----#
    SONInformationReport = CHOICE(name='SONInformationReport', mode=MODE_TYPE)
    _SONInformationReport_failureIndicationInformation = SEQ(name='failureIndicationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FailureIndication')))
    _SONInformationReport_hOReportInformation = SEQ(name='hOReportInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'HOReport')))
    _SONInformationReport_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __SONInformationReport_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___SONInformationReport_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ____SONInformationReport_choice_Extensions_id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SuccessfulHandoverReportList')))
    ___SONInformationReport_choice_Extensions_id_tab._val = ASN1Set(rv=[dict([('id', 294), ('criticality', 'ignore'), ('Value', ____SONInformationReport_choice_Extensions_id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __SONInformationReport_choice_Extensions_id._const_tab = ___SONInformationReport_choice_Extensions_id_tab
    __SONInformationReport_choice_Extensions_id._const_tab_at = None
    __SONInformationReport_choice_Extensions_id._const_tab_id = 'id'
    __SONInformationReport_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    __SONInformationReport_choice_Extensions_criticality._const_tab = ___SONInformationReport_choice_Extensions_id_tab
    __SONInformationReport_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __SONInformationReport_choice_Extensions_criticality._const_tab_id = 'criticality'
    __SONInformationReport_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    __SONInformationReport_choice_Extensions_value._const_tab = ___SONInformationReport_choice_Extensions_id_tab
    __SONInformationReport_choice_Extensions_value._const_tab_at = ('..', 'id')
    __SONInformationReport_choice_Extensions_value._const_tab_id = 'Value'
    _SONInformationReport_choice_Extensions._cont = ASN1Dict([
        ('id', __SONInformationReport_choice_Extensions_id),
        ('criticality', __SONInformationReport_choice_Extensions_criticality),
        ('value', __SONInformationReport_choice_Extensions_value),
        ])
    _SONInformationReport_choice_Extensions._ext = None
    SONInformationReport._cont = ASN1Dict([
        ('failureIndicationInformation', _SONInformationReport_failureIndicationInformation),
        ('hOReportInformation', _SONInformationReport_hOReportInformation),
        ('choice-Extensions', _SONInformationReport_choice_Extensions),
        ])
    SONInformationReport._ext = None
    
    #-----< SONInformationReport-ExtIEs >-----#
    SONInformationReport_ExtIEs = CLASS(name='SONInformationReport-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _SONInformationReport_ExtIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SuccessfulHandoverReportList')))
    SONInformationReport_ExtIEs._val = ASN1Set(rv=[dict([('id', 294), ('criticality', 'ignore'), ('Value', _SONInformationReport_ExtIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SuccessfulHandoverReportList >-----#
    SuccessfulHandoverReportList = SEQ_OF(name='SuccessfulHandoverReportList', mode=MODE_TYPE)
    _SuccessfulHandoverReportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SuccessfulHandoverReport-Item')))
    SuccessfulHandoverReportList._cont = _SuccessfulHandoverReportList__item_
    SuccessfulHandoverReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SuccessfulHandoverReport-Item >-----#
    SuccessfulHandoverReport_Item = SEQ(name='SuccessfulHandoverReport-Item', mode=MODE_TYPE)
    _SuccessfulHandoverReport_Item_successfulHOReportContainer = OCT_STR(name='successfulHOReportContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SuccessfulHandoverReport_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SuccessfulHandoverReport_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SuccessfulHandoverReport_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____SuccessfulHandoverReport_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SuccessfulHandoverReport_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SuccessfulHandoverReport_Item_iE_Extensions__item__id._const_tab = ____SuccessfulHandoverReport_Item_iE_Extensions__item__id_tab
    ___SuccessfulHandoverReport_Item_iE_Extensions__item__id._const_tab_at = None
    ___SuccessfulHandoverReport_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SuccessfulHandoverReport_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SuccessfulHandoverReport_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SuccessfulHandoverReport_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SuccessfulHandoverReport_Item_iE_Extensions__item__criticality._const_tab = ____SuccessfulHandoverReport_Item_iE_Extensions__item__criticality_tab
    ___SuccessfulHandoverReport_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SuccessfulHandoverReport_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SuccessfulHandoverReport_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SuccessfulHandoverReport_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SuccessfulHandoverReport_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SuccessfulHandoverReport_Item_iE_Extensions__item__extensionValue._const_tab = ____SuccessfulHandoverReport_Item_iE_Extensions__item__extensionValue_tab
    ___SuccessfulHandoverReport_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SuccessfulHandoverReport_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SuccessfulHandoverReport_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SuccessfulHandoverReport_Item_iE_Extensions__item__id),
        ('criticality', ___SuccessfulHandoverReport_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SuccessfulHandoverReport_Item_iE_Extensions__item__extensionValue),
        ])
    __SuccessfulHandoverReport_Item_iE_Extensions__item_._ext = None
    _SuccessfulHandoverReport_Item_iE_Extensions._cont = __SuccessfulHandoverReport_Item_iE_Extensions__item_
    _SuccessfulHandoverReport_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SuccessfulHandoverReport_Item._cont = ASN1Dict([
        ('successfulHOReportContainer', _SuccessfulHandoverReport_Item_successfulHOReportContainer),
        ('iE-Extensions', _SuccessfulHandoverReport_Item_iE_Extensions),
        ])
    SuccessfulHandoverReport_Item._ext = []
    
    #-----< SuccessfulHandoverReport-Item-ExtIEs >-----#
    SuccessfulHandoverReport_Item_ExtIEs = CLASS(name='SuccessfulHandoverReport-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SuccessfulHandoverReport_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SONInformationRequest >-----#
    SONInformationRequest = ENUM(name='SONInformationRequest', mode=MODE_TYPE)
    SONInformationRequest._cont = ASN1Dict([('xn-TNL-configuration-info', 0)])
    SONInformationRequest._ext = []
    
    #-----< SourceNGRANNode-ToTargetNGRANNode-TransparentContainer >-----#
    SourceNGRANNode_ToTargetNGRANNode_TransparentContainer = SEQ(name='SourceNGRANNode-ToTargetNGRANNode-TransparentContainer', mode=MODE_TYPE)
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_rRCContainer = OCT_STR(name='rRCContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RRCContainer')))
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_pDUSessionResourceInformationList = SEQ_OF(name='pDUSessionResourceInformationList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceInformationList')), opt=True)
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_e_RABInformationList = SEQ_OF(name='e-RABInformationList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'E-RABInformationList')), opt=True)
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_targetCell_ID = CHOICE(name='targetCell-ID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_indexToRFSP = INT(name='indexToRFSP', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IndexToRFSP')), opt=True)
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_uEHistoryInformation = SEQ_OF(name='uEHistoryInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UEHistoryInformation')))
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SgNB-UE-X2AP-ID')))
    _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEHistoryInformationFromTheUE')))
    _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SourceNodeID')))
    _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-ActiveSessionInformation-SourcetoTargetList')))
    _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QMCConfigInfo')))
    _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_6 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGAPIESupportInformationRequestList')))
    ____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 182), ('criticality', 'ignore'), ('Extension', _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 253), ('criticality', 'ignore'), ('Extension', _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 286), ('criticality', 'ignore'), ('Extension', _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 288), ('criticality', 'ignore'), ('Extension', _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 323), ('criticality', 'ignore'), ('Extension', _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 328), ('criticality', 'ignore'), ('Extension', _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 355), ('criticality', 'ignore'), ('Extension', _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id._const_tab = ____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab
    ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id._const_tab_at = None
    ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id._const_tab_id = 'id'
    ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__criticality._const_tab = ____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab
    ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__extensionValue._const_tab = ____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab
    ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id),
        ('criticality', ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__criticality),
        ('extensionValue', ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__extensionValue),
        ])
    __SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item_._ext = None
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions._cont = __SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item_
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SourceNGRANNode_ToTargetNGRANNode_TransparentContainer._cont = ASN1Dict([
        ('rRCContainer', _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_rRCContainer),
        ('pDUSessionResourceInformationList', _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_pDUSessionResourceInformationList),
        ('e-RABInformationList', _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_e_RABInformationList),
        ('targetCell-ID', _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_targetCell_ID),
        ('indexToRFSP', _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_indexToRFSP),
        ('uEHistoryInformation', _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_uEHistoryInformation),
        ('iE-Extensions', _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions),
        ])
    SourceNGRANNode_ToTargetNGRANNode_TransparentContainer._ext = []
    
    #-----< SourceNGRANNode-ToTargetNGRANNode-TransparentContainer-ExtIEs >-----#
    SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs = CLASS(name='SourceNGRANNode-ToTargetNGRANNode-TransparentContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SgNB-UE-X2AP-ID')))
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEHistoryInformationFromTheUE')))
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SourceNodeID')))
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-ActiveSessionInformation-SourcetoTargetList')))
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QMCConfigInfo')))
    _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_6 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGAPIESupportInformationRequestList')))
    SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs._val = ASN1Set(rv=[dict([('id', 182), ('criticality', 'ignore'), ('Extension', _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 253), ('criticality', 'ignore'), ('Extension', _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 286), ('criticality', 'ignore'), ('Extension', _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 288), ('criticality', 'ignore'), ('Extension', _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 323), ('criticality', 'ignore'), ('Extension', _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 328), ('criticality', 'ignore'), ('Extension', _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 355), ('criticality', 'ignore'), ('Extension', _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SourceNodeID >-----#
    SourceNodeID = CHOICE(name='SourceNodeID', mode=MODE_TYPE)
    _SourceNodeID_sourceengNB_ID = SEQ(name='sourceengNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalGNB-ID')))
    _SourceNodeID_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __SourceNodeID_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___SourceNodeID_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___SourceNodeID_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SourceNodeID_choice_Extensions_id._const_tab = ___SourceNodeID_choice_Extensions_id_tab
    __SourceNodeID_choice_Extensions_id._const_tab_at = None
    __SourceNodeID_choice_Extensions_id._const_tab_id = 'id'
    __SourceNodeID_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___SourceNodeID_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___SourceNodeID_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SourceNodeID_choice_Extensions_criticality._const_tab = ___SourceNodeID_choice_Extensions_criticality_tab
    __SourceNodeID_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __SourceNodeID_choice_Extensions_criticality._const_tab_id = 'criticality'
    __SourceNodeID_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___SourceNodeID_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___SourceNodeID_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SourceNodeID_choice_Extensions_value._const_tab = ___SourceNodeID_choice_Extensions_value_tab
    __SourceNodeID_choice_Extensions_value._const_tab_at = ('..', 'id')
    __SourceNodeID_choice_Extensions_value._const_tab_id = 'Value'
    _SourceNodeID_choice_Extensions._cont = ASN1Dict([
        ('id', __SourceNodeID_choice_Extensions_id),
        ('criticality', __SourceNodeID_choice_Extensions_criticality),
        ('value', __SourceNodeID_choice_Extensions_value),
        ])
    _SourceNodeID_choice_Extensions._ext = None
    SourceNodeID._cont = ASN1Dict([
        ('sourceengNB-ID', _SourceNodeID_sourceengNB_ID),
        ('choice-Extensions', _SourceNodeID_choice_Extensions),
        ])
    SourceNodeID._ext = None
    
    #-----< SourceNodeID-ExtIEs >-----#
    SourceNodeID_ExtIEs = CLASS(name='SourceNodeID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    SourceNodeID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SourceOfUEActivityBehaviourInformation >-----#
    SourceOfUEActivityBehaviourInformation = ENUM(name='SourceOfUEActivityBehaviourInformation', mode=MODE_TYPE)
    SourceOfUEActivityBehaviourInformation._cont = ASN1Dict([('subscription-information', 0), ('statistics', 1)])
    SourceOfUEActivityBehaviourInformation._ext = []
    
    #-----< SourceRANNodeID >-----#
    SourceRANNodeID = SEQ(name='SourceRANNodeID', mode=MODE_TYPE)
    _SourceRANNodeID_globalRANNodeID = CHOICE(name='globalRANNodeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _SourceRANNodeID_selectedTAI = SEQ(name='selectedTAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _SourceRANNodeID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SourceRANNodeID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SourceRANNodeID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____SourceRANNodeID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SourceRANNodeID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceRANNodeID_iE_Extensions__item__id._const_tab = ____SourceRANNodeID_iE_Extensions__item__id_tab
    ___SourceRANNodeID_iE_Extensions__item__id._const_tab_at = None
    ___SourceRANNodeID_iE_Extensions__item__id._const_tab_id = 'id'
    ___SourceRANNodeID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SourceRANNodeID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SourceRANNodeID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceRANNodeID_iE_Extensions__item__criticality._const_tab = ____SourceRANNodeID_iE_Extensions__item__criticality_tab
    ___SourceRANNodeID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SourceRANNodeID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SourceRANNodeID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SourceRANNodeID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SourceRANNodeID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceRANNodeID_iE_Extensions__item__extensionValue._const_tab = ____SourceRANNodeID_iE_Extensions__item__extensionValue_tab
    ___SourceRANNodeID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SourceRANNodeID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SourceRANNodeID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SourceRANNodeID_iE_Extensions__item__id),
        ('criticality', ___SourceRANNodeID_iE_Extensions__item__criticality),
        ('extensionValue', ___SourceRANNodeID_iE_Extensions__item__extensionValue),
        ])
    __SourceRANNodeID_iE_Extensions__item_._ext = None
    _SourceRANNodeID_iE_Extensions._cont = __SourceRANNodeID_iE_Extensions__item_
    _SourceRANNodeID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SourceRANNodeID._cont = ASN1Dict([
        ('globalRANNodeID', _SourceRANNodeID_globalRANNodeID),
        ('selectedTAI', _SourceRANNodeID_selectedTAI),
        ('iE-Extensions', _SourceRANNodeID_iE_Extensions),
        ])
    SourceRANNodeID._ext = []
    
    #-----< SourceRANNodeID-ExtIEs >-----#
    SourceRANNodeID_ExtIEs = CLASS(name='SourceRANNodeID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SourceRANNodeID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SourceToTarget-TransparentContainer >-----#
    SourceToTarget_TransparentContainer = OCT_STR(name='SourceToTarget-TransparentContainer', mode=MODE_TYPE)
    
    #-----< SourceToTarget-AMFInformationReroute >-----#
    SourceToTarget_AMFInformationReroute = SEQ(name='SourceToTarget-AMFInformationReroute', mode=MODE_TYPE)
    _SourceToTarget_AMFInformationReroute_configuredNSSAI = OCT_STR(name='configuredNSSAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ConfiguredNSSAI')), opt=True)
    _SourceToTarget_AMFInformationReroute_rejectedNSSAIinPLMN = OCT_STR(name='rejectedNSSAIinPLMN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RejectedNSSAIinPLMN')), opt=True)
    _SourceToTarget_AMFInformationReroute_rejectedNSSAIinTA = OCT_STR(name='rejectedNSSAIinTA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RejectedNSSAIinTA')), opt=True)
    _SourceToTarget_AMFInformationReroute_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SourceToTarget_AMFInformationReroute_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____SourceToTarget_AMFInformationReroute_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SourceToTarget_AMFInformationReroute_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__id._const_tab = ____SourceToTarget_AMFInformationReroute_iE_Extensions__item__id_tab
    ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__id._const_tab_at = None
    ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__id._const_tab_id = 'id'
    ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SourceToTarget_AMFInformationReroute_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SourceToTarget_AMFInformationReroute_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__criticality._const_tab = ____SourceToTarget_AMFInformationReroute_iE_Extensions__item__criticality_tab
    ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SourceToTarget_AMFInformationReroute_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____SourceToTarget_AMFInformationReroute_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__extensionValue._const_tab = ____SourceToTarget_AMFInformationReroute_iE_Extensions__item__extensionValue_tab
    ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SourceToTarget_AMFInformationReroute_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__id),
        ('criticality', ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__criticality),
        ('extensionValue', ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__extensionValue),
        ])
    __SourceToTarget_AMFInformationReroute_iE_Extensions__item_._ext = None
    _SourceToTarget_AMFInformationReroute_iE_Extensions._cont = __SourceToTarget_AMFInformationReroute_iE_Extensions__item_
    _SourceToTarget_AMFInformationReroute_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SourceToTarget_AMFInformationReroute._cont = ASN1Dict([
        ('configuredNSSAI', _SourceToTarget_AMFInformationReroute_configuredNSSAI),
        ('rejectedNSSAIinPLMN', _SourceToTarget_AMFInformationReroute_rejectedNSSAIinPLMN),
        ('rejectedNSSAIinTA', _SourceToTarget_AMFInformationReroute_rejectedNSSAIinTA),
        ('iE-Extensions', _SourceToTarget_AMFInformationReroute_iE_Extensions),
        ])
    SourceToTarget_AMFInformationReroute._ext = []
    
    #-----< SourceToTarget-AMFInformationReroute-ExtIEs >-----#
    SourceToTarget_AMFInformationReroute_ExtIEs = CLASS(name='SourceToTarget-AMFInformationReroute-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    SourceToTarget_AMFInformationReroute_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRVCCOperationPossible >-----#
    SRVCCOperationPossible = ENUM(name='SRVCCOperationPossible', mode=MODE_TYPE)
    SRVCCOperationPossible._cont = ASN1Dict([('possible', 0), ('notPossible', 1)])
    SRVCCOperationPossible._ext = []
    
    #-----< ConfiguredNSSAI >-----#
    ConfiguredNSSAI = OCT_STR(name='ConfiguredNSSAI', mode=MODE_TYPE)
    ConfiguredNSSAI._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    
    #-----< RejectedNSSAIinPLMN >-----#
    RejectedNSSAIinPLMN = OCT_STR(name='RejectedNSSAIinPLMN', mode=MODE_TYPE)
    RejectedNSSAIinPLMN._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< RejectedNSSAIinTA >-----#
    RejectedNSSAIinTA = OCT_STR(name='RejectedNSSAIinTA', mode=MODE_TYPE)
    RejectedNSSAIinTA._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< SST >-----#
    SST = OCT_STR(name='SST', mode=MODE_TYPE)
    SST._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SupportedTAList >-----#
    SupportedTAList = SEQ_OF(name='SupportedTAList', mode=MODE_TYPE)
    _SupportedTAList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SupportedTAItem')))
    SupportedTAList._cont = _SupportedTAList__item_
    SupportedTAList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< SupportedTAItem >-----#
    SupportedTAItem = SEQ(name='SupportedTAItem', mode=MODE_TYPE)
    _SupportedTAItem_tAC = OCT_STR(name='tAC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAC')))
    _SupportedTAItem_broadcastPLMNList = SEQ_OF(name='broadcastPLMNList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BroadcastPLMNList')))
    _SupportedTAItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SupportedTAItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___SupportedTAItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____SupportedTAItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____SupportedTAItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ConfiguredTACIndication')))
    _____SupportedTAItem_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAT-Information')))
    ____SupportedTAItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 272), ('criticality', 'ignore'), ('Extension', _____SupportedTAItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 179), ('criticality', 'reject'), ('Extension', _____SupportedTAItem_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SupportedTAItem_iE_Extensions__item__id._const_tab = ____SupportedTAItem_iE_Extensions__item__id_tab
    ___SupportedTAItem_iE_Extensions__item__id._const_tab_at = None
    ___SupportedTAItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SupportedTAItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SupportedTAItem_iE_Extensions__item__criticality._const_tab = ____SupportedTAItem_iE_Extensions__item__id_tab
    ___SupportedTAItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SupportedTAItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SupportedTAItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SupportedTAItem_iE_Extensions__item__extensionValue._const_tab = ____SupportedTAItem_iE_Extensions__item__id_tab
    ___SupportedTAItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SupportedTAItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SupportedTAItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SupportedTAItem_iE_Extensions__item__id),
        ('criticality', ___SupportedTAItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SupportedTAItem_iE_Extensions__item__extensionValue),
        ])
    __SupportedTAItem_iE_Extensions__item_._ext = None
    _SupportedTAItem_iE_Extensions._cont = __SupportedTAItem_iE_Extensions__item_
    _SupportedTAItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SupportedTAItem._cont = ASN1Dict([
        ('tAC', _SupportedTAItem_tAC),
        ('broadcastPLMNList', _SupportedTAItem_broadcastPLMNList),
        ('iE-Extensions', _SupportedTAItem_iE_Extensions),
        ])
    SupportedTAItem._ext = []
    
    #-----< SupportedTAItem-ExtIEs >-----#
    SupportedTAItem_ExtIEs = CLASS(name='SupportedTAItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _SupportedTAItem_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ConfiguredTACIndication')))
    _SupportedTAItem_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAT-Information')))
    SupportedTAItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 272), ('criticality', 'ignore'), ('Extension', _SupportedTAItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 179), ('criticality', 'reject'), ('Extension', _SupportedTAItem_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SuspendIndicator >-----#
    SuspendIndicator = ENUM(name='SuspendIndicator', mode=MODE_TYPE)
    SuspendIndicator._cont = ASN1Dict([('true', 0)])
    SuspendIndicator._ext = []
    
    #-----< Suspend-Request-Indication >-----#
    Suspend_Request_Indication = ENUM(name='Suspend-Request-Indication', mode=MODE_TYPE)
    Suspend_Request_Indication._cont = ASN1Dict([('suspend-requested', 0)])
    Suspend_Request_Indication._ext = []
    
    #-----< Suspend-Response-Indication >-----#
    Suspend_Response_Indication = ENUM(name='Suspend-Response-Indication', mode=MODE_TYPE)
    Suspend_Response_Indication._cont = ASN1Dict([('suspend-indicated', 0)])
    Suspend_Response_Indication._ext = []
    
    #-----< SurvivalTime >-----#
    SurvivalTime = INT(name='SurvivalTime', mode=MODE_TYPE)
    SurvivalTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1920000)], ev=[], er=[])
    
    #-----< TAC >-----#
    TAC = OCT_STR(name='TAC', mode=MODE_TYPE)
    TAC._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< TACListInNRNTN >-----#
    TACListInNRNTN = SEQ_OF(name='TACListInNRNTN', mode=MODE_TYPE)
    _TACListInNRNTN__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAC')))
    TACListInNRNTN._cont = _TACListInNRNTN__item_
    TACListInNRNTN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< TAI >-----#
    TAI = SEQ(name='TAI', mode=MODE_TYPE)
    _TAI_pLMNIdentity = OCT_STR(name='pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _TAI_tAC = OCT_STR(name='tAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAC')))
    _TAI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TAI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TAI_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_iE_Extensions__item__id._const_tab = ____TAI_iE_Extensions__item__id_tab
    ___TAI_iE_Extensions__item__id._const_tab_at = None
    ___TAI_iE_Extensions__item__id._const_tab_id = 'id'
    ___TAI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_iE_Extensions__item__criticality._const_tab = ____TAI_iE_Extensions__item__criticality_tab
    ___TAI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TAI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TAI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_iE_Extensions__item__extensionValue._const_tab = ____TAI_iE_Extensions__item__extensionValue_tab
    ___TAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TAI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TAI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TAI_iE_Extensions__item__id),
        ('criticality', ___TAI_iE_Extensions__item__criticality),
        ('extensionValue', ___TAI_iE_Extensions__item__extensionValue),
        ])
    __TAI_iE_Extensions__item_._ext = None
    _TAI_iE_Extensions._cont = __TAI_iE_Extensions__item_
    _TAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAI._cont = ASN1Dict([
        ('pLMNIdentity', _TAI_pLMNIdentity),
        ('tAC', _TAI_tAC),
        ('iE-Extensions', _TAI_iE_Extensions),
        ])
    TAI._ext = []
    
    #-----< TAI-ExtIEs >-----#
    TAI_ExtIEs = CLASS(name='TAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAIBroadcastEUTRA >-----#
    TAIBroadcastEUTRA = SEQ_OF(name='TAIBroadcastEUTRA', mode=MODE_TYPE)
    _TAIBroadcastEUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAIBroadcastEUTRA-Item')))
    TAIBroadcastEUTRA._cont = _TAIBroadcastEUTRA__item_
    TAIBroadcastEUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< TAIBroadcastEUTRA-Item >-----#
    TAIBroadcastEUTRA_Item = SEQ(name='TAIBroadcastEUTRA-Item', mode=MODE_TYPE)
    _TAIBroadcastEUTRA_Item_tAI = SEQ(name='tAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _TAIBroadcastEUTRA_Item_completedCellsInTAI_EUTRA = SEQ_OF(name='completedCellsInTAI-EUTRA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CompletedCellsInTAI-EUTRA')))
    _TAIBroadcastEUTRA_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAIBroadcastEUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TAIBroadcastEUTRA_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TAIBroadcastEUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIBroadcastEUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBroadcastEUTRA_Item_iE_Extensions__item__id._const_tab = ____TAIBroadcastEUTRA_Item_iE_Extensions__item__id_tab
    ___TAIBroadcastEUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___TAIBroadcastEUTRA_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TAIBroadcastEUTRA_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TAIBroadcastEUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIBroadcastEUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBroadcastEUTRA_Item_iE_Extensions__item__criticality._const_tab = ____TAIBroadcastEUTRA_Item_iE_Extensions__item__criticality_tab
    ___TAIBroadcastEUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TAIBroadcastEUTRA_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TAIBroadcastEUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TAIBroadcastEUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIBroadcastEUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBroadcastEUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____TAIBroadcastEUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___TAIBroadcastEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TAIBroadcastEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TAIBroadcastEUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TAIBroadcastEUTRA_Item_iE_Extensions__item__id),
        ('criticality', ___TAIBroadcastEUTRA_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TAIBroadcastEUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __TAIBroadcastEUTRA_Item_iE_Extensions__item_._ext = None
    _TAIBroadcastEUTRA_Item_iE_Extensions._cont = __TAIBroadcastEUTRA_Item_iE_Extensions__item_
    _TAIBroadcastEUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAIBroadcastEUTRA_Item._cont = ASN1Dict([
        ('tAI', _TAIBroadcastEUTRA_Item_tAI),
        ('completedCellsInTAI-EUTRA', _TAIBroadcastEUTRA_Item_completedCellsInTAI_EUTRA),
        ('iE-Extensions', _TAIBroadcastEUTRA_Item_iE_Extensions),
        ])
    TAIBroadcastEUTRA_Item._ext = []
    
    #-----< TAIBroadcastEUTRA-Item-ExtIEs >-----#
    TAIBroadcastEUTRA_Item_ExtIEs = CLASS(name='TAIBroadcastEUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TAIBroadcastEUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAIBroadcastNR >-----#
    TAIBroadcastNR = SEQ_OF(name='TAIBroadcastNR', mode=MODE_TYPE)
    _TAIBroadcastNR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAIBroadcastNR-Item')))
    TAIBroadcastNR._cont = _TAIBroadcastNR__item_
    TAIBroadcastNR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< TAIBroadcastNR-Item >-----#
    TAIBroadcastNR_Item = SEQ(name='TAIBroadcastNR-Item', mode=MODE_TYPE)
    _TAIBroadcastNR_Item_tAI = SEQ(name='tAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _TAIBroadcastNR_Item_completedCellsInTAI_NR = SEQ_OF(name='completedCellsInTAI-NR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CompletedCellsInTAI-NR')))
    _TAIBroadcastNR_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAIBroadcastNR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TAIBroadcastNR_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TAIBroadcastNR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIBroadcastNR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBroadcastNR_Item_iE_Extensions__item__id._const_tab = ____TAIBroadcastNR_Item_iE_Extensions__item__id_tab
    ___TAIBroadcastNR_Item_iE_Extensions__item__id._const_tab_at = None
    ___TAIBroadcastNR_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TAIBroadcastNR_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TAIBroadcastNR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIBroadcastNR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBroadcastNR_Item_iE_Extensions__item__criticality._const_tab = ____TAIBroadcastNR_Item_iE_Extensions__item__criticality_tab
    ___TAIBroadcastNR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TAIBroadcastNR_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TAIBroadcastNR_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TAIBroadcastNR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIBroadcastNR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBroadcastNR_Item_iE_Extensions__item__extensionValue._const_tab = ____TAIBroadcastNR_Item_iE_Extensions__item__extensionValue_tab
    ___TAIBroadcastNR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TAIBroadcastNR_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TAIBroadcastNR_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TAIBroadcastNR_Item_iE_Extensions__item__id),
        ('criticality', ___TAIBroadcastNR_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TAIBroadcastNR_Item_iE_Extensions__item__extensionValue),
        ])
    __TAIBroadcastNR_Item_iE_Extensions__item_._ext = None
    _TAIBroadcastNR_Item_iE_Extensions._cont = __TAIBroadcastNR_Item_iE_Extensions__item_
    _TAIBroadcastNR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAIBroadcastNR_Item._cont = ASN1Dict([
        ('tAI', _TAIBroadcastNR_Item_tAI),
        ('completedCellsInTAI-NR', _TAIBroadcastNR_Item_completedCellsInTAI_NR),
        ('iE-Extensions', _TAIBroadcastNR_Item_iE_Extensions),
        ])
    TAIBroadcastNR_Item._ext = []
    
    #-----< TAIBroadcastNR-Item-ExtIEs >-----#
    TAIBroadcastNR_Item_ExtIEs = CLASS(name='TAIBroadcastNR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TAIBroadcastNR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAICancelledEUTRA >-----#
    TAICancelledEUTRA = SEQ_OF(name='TAICancelledEUTRA', mode=MODE_TYPE)
    _TAICancelledEUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAICancelledEUTRA-Item')))
    TAICancelledEUTRA._cont = _TAICancelledEUTRA__item_
    TAICancelledEUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< TAICancelledEUTRA-Item >-----#
    TAICancelledEUTRA_Item = SEQ(name='TAICancelledEUTRA-Item', mode=MODE_TYPE)
    _TAICancelledEUTRA_Item_tAI = SEQ(name='tAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _TAICancelledEUTRA_Item_cancelledCellsInTAI_EUTRA = SEQ_OF(name='cancelledCellsInTAI-EUTRA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CancelledCellsInTAI-EUTRA')))
    _TAICancelledEUTRA_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAICancelledEUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TAICancelledEUTRA_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TAICancelledEUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAICancelledEUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAICancelledEUTRA_Item_iE_Extensions__item__id._const_tab = ____TAICancelledEUTRA_Item_iE_Extensions__item__id_tab
    ___TAICancelledEUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___TAICancelledEUTRA_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TAICancelledEUTRA_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TAICancelledEUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAICancelledEUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAICancelledEUTRA_Item_iE_Extensions__item__criticality._const_tab = ____TAICancelledEUTRA_Item_iE_Extensions__item__criticality_tab
    ___TAICancelledEUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TAICancelledEUTRA_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TAICancelledEUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TAICancelledEUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAICancelledEUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAICancelledEUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____TAICancelledEUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___TAICancelledEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TAICancelledEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TAICancelledEUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TAICancelledEUTRA_Item_iE_Extensions__item__id),
        ('criticality', ___TAICancelledEUTRA_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TAICancelledEUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __TAICancelledEUTRA_Item_iE_Extensions__item_._ext = None
    _TAICancelledEUTRA_Item_iE_Extensions._cont = __TAICancelledEUTRA_Item_iE_Extensions__item_
    _TAICancelledEUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAICancelledEUTRA_Item._cont = ASN1Dict([
        ('tAI', _TAICancelledEUTRA_Item_tAI),
        ('cancelledCellsInTAI-EUTRA', _TAICancelledEUTRA_Item_cancelledCellsInTAI_EUTRA),
        ('iE-Extensions', _TAICancelledEUTRA_Item_iE_Extensions),
        ])
    TAICancelledEUTRA_Item._ext = []
    
    #-----< TAICancelledEUTRA-Item-ExtIEs >-----#
    TAICancelledEUTRA_Item_ExtIEs = CLASS(name='TAICancelledEUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TAICancelledEUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAICancelledNR >-----#
    TAICancelledNR = SEQ_OF(name='TAICancelledNR', mode=MODE_TYPE)
    _TAICancelledNR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAICancelledNR-Item')))
    TAICancelledNR._cont = _TAICancelledNR__item_
    TAICancelledNR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< TAICancelledNR-Item >-----#
    TAICancelledNR_Item = SEQ(name='TAICancelledNR-Item', mode=MODE_TYPE)
    _TAICancelledNR_Item_tAI = SEQ(name='tAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _TAICancelledNR_Item_cancelledCellsInTAI_NR = SEQ_OF(name='cancelledCellsInTAI-NR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CancelledCellsInTAI-NR')))
    _TAICancelledNR_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAICancelledNR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TAICancelledNR_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TAICancelledNR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAICancelledNR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAICancelledNR_Item_iE_Extensions__item__id._const_tab = ____TAICancelledNR_Item_iE_Extensions__item__id_tab
    ___TAICancelledNR_Item_iE_Extensions__item__id._const_tab_at = None
    ___TAICancelledNR_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TAICancelledNR_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TAICancelledNR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAICancelledNR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAICancelledNR_Item_iE_Extensions__item__criticality._const_tab = ____TAICancelledNR_Item_iE_Extensions__item__criticality_tab
    ___TAICancelledNR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TAICancelledNR_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TAICancelledNR_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TAICancelledNR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAICancelledNR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAICancelledNR_Item_iE_Extensions__item__extensionValue._const_tab = ____TAICancelledNR_Item_iE_Extensions__item__extensionValue_tab
    ___TAICancelledNR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TAICancelledNR_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TAICancelledNR_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TAICancelledNR_Item_iE_Extensions__item__id),
        ('criticality', ___TAICancelledNR_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TAICancelledNR_Item_iE_Extensions__item__extensionValue),
        ])
    __TAICancelledNR_Item_iE_Extensions__item_._ext = None
    _TAICancelledNR_Item_iE_Extensions._cont = __TAICancelledNR_Item_iE_Extensions__item_
    _TAICancelledNR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAICancelledNR_Item._cont = ASN1Dict([
        ('tAI', _TAICancelledNR_Item_tAI),
        ('cancelledCellsInTAI-NR', _TAICancelledNR_Item_cancelledCellsInTAI_NR),
        ('iE-Extensions', _TAICancelledNR_Item_iE_Extensions),
        ])
    TAICancelledNR_Item._ext = []
    
    #-----< TAICancelledNR-Item-ExtIEs >-----#
    TAICancelledNR_Item_ExtIEs = CLASS(name='TAICancelledNR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TAICancelledNR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAIListForInactive >-----#
    TAIListForInactive = SEQ_OF(name='TAIListForInactive', mode=MODE_TYPE)
    _TAIListForInactive__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAIListForInactiveItem')))
    TAIListForInactive._cont = _TAIListForInactive__item_
    TAIListForInactive._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< TAIListForInactiveItem >-----#
    TAIListForInactiveItem = SEQ(name='TAIListForInactiveItem', mode=MODE_TYPE)
    _TAIListForInactiveItem_tAI = SEQ(name='tAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _TAIListForInactiveItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAIListForInactiveItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TAIListForInactiveItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TAIListForInactiveItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIListForInactiveItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIListForInactiveItem_iE_Extensions__item__id._const_tab = ____TAIListForInactiveItem_iE_Extensions__item__id_tab
    ___TAIListForInactiveItem_iE_Extensions__item__id._const_tab_at = None
    ___TAIListForInactiveItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___TAIListForInactiveItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TAIListForInactiveItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIListForInactiveItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIListForInactiveItem_iE_Extensions__item__criticality._const_tab = ____TAIListForInactiveItem_iE_Extensions__item__criticality_tab
    ___TAIListForInactiveItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TAIListForInactiveItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TAIListForInactiveItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TAIListForInactiveItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIListForInactiveItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIListForInactiveItem_iE_Extensions__item__extensionValue._const_tab = ____TAIListForInactiveItem_iE_Extensions__item__extensionValue_tab
    ___TAIListForInactiveItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TAIListForInactiveItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TAIListForInactiveItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TAIListForInactiveItem_iE_Extensions__item__id),
        ('criticality', ___TAIListForInactiveItem_iE_Extensions__item__criticality),
        ('extensionValue', ___TAIListForInactiveItem_iE_Extensions__item__extensionValue),
        ])
    __TAIListForInactiveItem_iE_Extensions__item_._ext = None
    _TAIListForInactiveItem_iE_Extensions._cont = __TAIListForInactiveItem_iE_Extensions__item_
    _TAIListForInactiveItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAIListForInactiveItem._cont = ASN1Dict([
        ('tAI', _TAIListForInactiveItem_tAI),
        ('iE-Extensions', _TAIListForInactiveItem_iE_Extensions),
        ])
    TAIListForInactiveItem._ext = []
    
    #-----< TAIListForInactiveItem-ExtIEs >-----#
    TAIListForInactiveItem_ExtIEs = CLASS(name='TAIListForInactiveItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TAIListForInactiveItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAIListForPaging >-----#
    TAIListForPaging = SEQ_OF(name='TAIListForPaging', mode=MODE_TYPE)
    _TAIListForPaging__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAIListForPagingItem')))
    TAIListForPaging._cont = _TAIListForPaging__item_
    TAIListForPaging._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< TAIListForPagingItem >-----#
    TAIListForPagingItem = SEQ(name='TAIListForPagingItem', mode=MODE_TYPE)
    _TAIListForPagingItem_tAI = SEQ(name='tAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _TAIListForPagingItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAIListForPagingItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TAIListForPagingItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TAIListForPagingItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIListForPagingItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIListForPagingItem_iE_Extensions__item__id._const_tab = ____TAIListForPagingItem_iE_Extensions__item__id_tab
    ___TAIListForPagingItem_iE_Extensions__item__id._const_tab_at = None
    ___TAIListForPagingItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___TAIListForPagingItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TAIListForPagingItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIListForPagingItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIListForPagingItem_iE_Extensions__item__criticality._const_tab = ____TAIListForPagingItem_iE_Extensions__item__criticality_tab
    ___TAIListForPagingItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TAIListForPagingItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TAIListForPagingItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TAIListForPagingItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIListForPagingItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIListForPagingItem_iE_Extensions__item__extensionValue._const_tab = ____TAIListForPagingItem_iE_Extensions__item__extensionValue_tab
    ___TAIListForPagingItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TAIListForPagingItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TAIListForPagingItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TAIListForPagingItem_iE_Extensions__item__id),
        ('criticality', ___TAIListForPagingItem_iE_Extensions__item__criticality),
        ('extensionValue', ___TAIListForPagingItem_iE_Extensions__item__extensionValue),
        ])
    __TAIListForPagingItem_iE_Extensions__item_._ext = None
    _TAIListForPagingItem_iE_Extensions._cont = __TAIListForPagingItem_iE_Extensions__item_
    _TAIListForPagingItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAIListForPagingItem._cont = ASN1Dict([
        ('tAI', _TAIListForPagingItem_tAI),
        ('iE-Extensions', _TAIListForPagingItem_iE_Extensions),
        ])
    TAIListForPagingItem._ext = []
    
    #-----< TAIListForPagingItem-ExtIEs >-----#
    TAIListForPagingItem_ExtIEs = CLASS(name='TAIListForPagingItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TAIListForPagingItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAIListForRestart >-----#
    TAIListForRestart = SEQ_OF(name='TAIListForRestart', mode=MODE_TYPE)
    _TAIListForRestart__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    TAIListForRestart._cont = _TAIListForRestart__item_
    TAIListForRestart._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    
    #-----< TAIListForWarning >-----#
    TAIListForWarning = SEQ_OF(name='TAIListForWarning', mode=MODE_TYPE)
    _TAIListForWarning__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    TAIListForWarning._cont = _TAIListForWarning__item_
    TAIListForWarning._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< TAINSAGSupportList >-----#
    TAINSAGSupportList = SEQ_OF(name='TAINSAGSupportList', mode=MODE_TYPE)
    _TAINSAGSupportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAINSAGSupportItem')))
    TAINSAGSupportList._cont = _TAINSAGSupportList__item_
    TAINSAGSupportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< TAINSAGSupportItem >-----#
    TAINSAGSupportItem = SEQ(name='TAINSAGSupportItem', mode=MODE_TYPE)
    _TAINSAGSupportItem_nSAG_ID = INT(name='nSAG-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NSAG-ID')))
    _TAINSAGSupportItem_nSAGSliceSupportList = SEQ_OF(name='nSAGSliceSupportList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ExtendedSliceSupportList')))
    _TAINSAGSupportItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAINSAGSupportItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TAINSAGSupportItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TAINSAGSupportItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAINSAGSupportItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAINSAGSupportItem_iE_Extensions__item__id._const_tab = ____TAINSAGSupportItem_iE_Extensions__item__id_tab
    ___TAINSAGSupportItem_iE_Extensions__item__id._const_tab_at = None
    ___TAINSAGSupportItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___TAINSAGSupportItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TAINSAGSupportItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAINSAGSupportItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAINSAGSupportItem_iE_Extensions__item__criticality._const_tab = ____TAINSAGSupportItem_iE_Extensions__item__criticality_tab
    ___TAINSAGSupportItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TAINSAGSupportItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TAINSAGSupportItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TAINSAGSupportItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAINSAGSupportItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAINSAGSupportItem_iE_Extensions__item__extensionValue._const_tab = ____TAINSAGSupportItem_iE_Extensions__item__extensionValue_tab
    ___TAINSAGSupportItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TAINSAGSupportItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TAINSAGSupportItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TAINSAGSupportItem_iE_Extensions__item__id),
        ('criticality', ___TAINSAGSupportItem_iE_Extensions__item__criticality),
        ('extensionValue', ___TAINSAGSupportItem_iE_Extensions__item__extensionValue),
        ])
    __TAINSAGSupportItem_iE_Extensions__item_._ext = None
    _TAINSAGSupportItem_iE_Extensions._cont = __TAINSAGSupportItem_iE_Extensions__item_
    _TAINSAGSupportItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAINSAGSupportItem._cont = ASN1Dict([
        ('nSAG-ID', _TAINSAGSupportItem_nSAG_ID),
        ('nSAGSliceSupportList', _TAINSAGSupportItem_nSAGSliceSupportList),
        ('iE-Extensions', _TAINSAGSupportItem_iE_Extensions),
        ])
    TAINSAGSupportItem._ext = []
    
    #-----< TAINSAGSupportItem-ExtIEs >-----#
    TAINSAGSupportItem_ExtIEs = CLASS(name='TAINSAGSupportItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TAINSAGSupportItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TargeteNB-ID >-----#
    TargeteNB_ID = SEQ(name='TargeteNB-ID', mode=MODE_TYPE)
    _TargeteNB_ID_globalENB_ID = SEQ(name='globalENB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalNgENB-ID')))
    _TargeteNB_ID_selected_EPS_TAI = SEQ(name='selected-EPS-TAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EPS-TAI')))
    _TargeteNB_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargeteNB_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TargeteNB_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TargeteNB_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargeteNB_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargeteNB_ID_iE_Extensions__item__id._const_tab = ____TargeteNB_ID_iE_Extensions__item__id_tab
    ___TargeteNB_ID_iE_Extensions__item__id._const_tab_at = None
    ___TargeteNB_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___TargeteNB_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TargeteNB_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargeteNB_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargeteNB_ID_iE_Extensions__item__criticality._const_tab = ____TargeteNB_ID_iE_Extensions__item__criticality_tab
    ___TargeteNB_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TargeteNB_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TargeteNB_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TargeteNB_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargeteNB_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargeteNB_ID_iE_Extensions__item__extensionValue._const_tab = ____TargeteNB_ID_iE_Extensions__item__extensionValue_tab
    ___TargeteNB_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TargeteNB_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TargeteNB_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TargeteNB_ID_iE_Extensions__item__id),
        ('criticality', ___TargeteNB_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___TargeteNB_ID_iE_Extensions__item__extensionValue),
        ])
    __TargeteNB_ID_iE_Extensions__item_._ext = None
    _TargeteNB_ID_iE_Extensions._cont = __TargeteNB_ID_iE_Extensions__item_
    _TargeteNB_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargeteNB_ID._cont = ASN1Dict([
        ('globalENB-ID', _TargeteNB_ID_globalENB_ID),
        ('selected-EPS-TAI', _TargeteNB_ID_selected_EPS_TAI),
        ('iE-Extensions', _TargeteNB_ID_iE_Extensions),
        ])
    TargeteNB_ID._ext = []
    
    #-----< TargeteNB-ID-ExtIEs >-----#
    TargeteNB_ID_ExtIEs = CLASS(name='TargeteNB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TargeteNB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TargetHomeENB-ID >-----#
    TargetHomeENB_ID = SEQ(name='TargetHomeENB-ID', mode=MODE_TYPE)
    _TargetHomeENB_ID_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _TargetHomeENB_ID_homeENB_ID = BIT_STR(name='homeENB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TargetHomeENB_ID_homeENB_ID._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    _TargetHomeENB_ID_selected_EPS_TAI = SEQ(name='selected-EPS-TAI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EPS-TAI')))
    _TargetHomeENB_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargetHomeENB_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TargetHomeENB_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TargetHomeENB_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetHomeENB_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetHomeENB_ID_iE_Extensions__item__id._const_tab = ____TargetHomeENB_ID_iE_Extensions__item__id_tab
    ___TargetHomeENB_ID_iE_Extensions__item__id._const_tab_at = None
    ___TargetHomeENB_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___TargetHomeENB_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TargetHomeENB_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetHomeENB_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetHomeENB_ID_iE_Extensions__item__criticality._const_tab = ____TargetHomeENB_ID_iE_Extensions__item__criticality_tab
    ___TargetHomeENB_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TargetHomeENB_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TargetHomeENB_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TargetHomeENB_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetHomeENB_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetHomeENB_ID_iE_Extensions__item__extensionValue._const_tab = ____TargetHomeENB_ID_iE_Extensions__item__extensionValue_tab
    ___TargetHomeENB_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TargetHomeENB_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TargetHomeENB_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TargetHomeENB_ID_iE_Extensions__item__id),
        ('criticality', ___TargetHomeENB_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___TargetHomeENB_ID_iE_Extensions__item__extensionValue),
        ])
    __TargetHomeENB_ID_iE_Extensions__item_._ext = None
    _TargetHomeENB_ID_iE_Extensions._cont = __TargetHomeENB_ID_iE_Extensions__item_
    _TargetHomeENB_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargetHomeENB_ID._cont = ASN1Dict([
        ('pLMNidentity', _TargetHomeENB_ID_pLMNidentity),
        ('homeENB-ID', _TargetHomeENB_ID_homeENB_ID),
        ('selected-EPS-TAI', _TargetHomeENB_ID_selected_EPS_TAI),
        ('iE-Extensions', _TargetHomeENB_ID_iE_Extensions),
        ])
    TargetHomeENB_ID._ext = []
    
    #-----< TargetHomeENB-ID-ExtIEs >-----#
    TargetHomeENB_ID_ExtIEs = CLASS(name='TargetHomeENB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TargetHomeENB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TargetID >-----#
    TargetID = CHOICE(name='TargetID', mode=MODE_TYPE)
    _TargetID_targetRANNodeID = SEQ(name='targetRANNodeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TargetRANNodeID')))
    _TargetID_targeteNB_ID = SEQ(name='targeteNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TargeteNB-ID')))
    _TargetID_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __TargetID_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___TargetID_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ____TargetID_choice_Extensions_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargetRNC-ID')))
    ____TargetID_choice_Extensions_id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargetHomeENB-ID')))
    ___TargetID_choice_Extensions_id_tab._val = ASN1Set(rv=[dict([('id', 178), ('criticality', 'reject'), ('Value', ____TargetID_choice_Extensions_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 364), ('criticality', 'reject'), ('Value', ____TargetID_choice_Extensions_id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __TargetID_choice_Extensions_id._const_tab = ___TargetID_choice_Extensions_id_tab
    __TargetID_choice_Extensions_id._const_tab_at = None
    __TargetID_choice_Extensions_id._const_tab_id = 'id'
    __TargetID_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    __TargetID_choice_Extensions_criticality._const_tab = ___TargetID_choice_Extensions_id_tab
    __TargetID_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __TargetID_choice_Extensions_criticality._const_tab_id = 'criticality'
    __TargetID_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    __TargetID_choice_Extensions_value._const_tab = ___TargetID_choice_Extensions_id_tab
    __TargetID_choice_Extensions_value._const_tab_at = ('..', 'id')
    __TargetID_choice_Extensions_value._const_tab_id = 'Value'
    _TargetID_choice_Extensions._cont = ASN1Dict([
        ('id', __TargetID_choice_Extensions_id),
        ('criticality', __TargetID_choice_Extensions_criticality),
        ('value', __TargetID_choice_Extensions_value),
        ])
    _TargetID_choice_Extensions._ext = None
    TargetID._cont = ASN1Dict([
        ('targetRANNodeID', _TargetID_targetRANNodeID),
        ('targeteNB-ID', _TargetID_targeteNB_ID),
        ('choice-Extensions', _TargetID_choice_Extensions),
        ])
    TargetID._ext = None
    
    #-----< TargetID-ExtIEs >-----#
    TargetID_ExtIEs = CLASS(name='TargetID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _TargetID_ExtIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargetRNC-ID')))
    _TargetID_ExtIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargetHomeENB-ID')))
    TargetID_ExtIEs._val = ASN1Set(rv=[dict([('id', 178), ('criticality', 'reject'), ('Value', _TargetID_ExtIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 364), ('criticality', 'reject'), ('Value', _TargetID_ExtIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TargetNGRANNode-ToSourceNGRANNode-TransparentContainer >-----#
    TargetNGRANNode_ToSourceNGRANNode_TransparentContainer = SEQ(name='TargetNGRANNode-ToSourceNGRANNode-TransparentContainer', mode=MODE_TYPE)
    _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_rRCContainer = OCT_STR(name='rRCContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RRCContainer')))
    _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DAPSResponseInfoList')))
    _____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DirectForwardingPathAvailability')))
    _____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-ActiveSessionInformation-TargettoSourceList')))
    _____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGAPIESupportInformationResponseList')))
    ____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 267), ('criticality', 'ignore'), ('Extension', _____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 22), ('criticality', 'ignore'), ('Extension', _____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 324), ('criticality', 'ignore'), ('Extension', _____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 356), ('criticality', 'ignore'), ('Extension', _____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id._const_tab = ____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab
    ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id._const_tab_at = None
    ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id._const_tab_id = 'id'
    ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__criticality._const_tab = ____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab
    ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__extensionValue._const_tab = ____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab
    ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id),
        ('criticality', ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__criticality),
        ('extensionValue', ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__extensionValue),
        ])
    __TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item_._ext = None
    _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions._cont = __TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item_
    _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargetNGRANNode_ToSourceNGRANNode_TransparentContainer._cont = ASN1Dict([
        ('rRCContainer', _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_rRCContainer),
        ('iE-Extensions', _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions),
        ])
    TargetNGRANNode_ToSourceNGRANNode_TransparentContainer._ext = []
    
    #-----< TargetNGRANNode-ToSourceNGRANNode-TransparentContainer-ExtIEs >-----#
    TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_ExtIEs = CLASS(name='TargetNGRANNode-ToSourceNGRANNode-TransparentContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DAPSResponseInfoList')))
    _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DirectForwardingPathAvailability')))
    _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-ActiveSessionInformation-TargettoSourceList')))
    _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_ExtIEs_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGAPIESupportInformationResponseList')))
    TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_ExtIEs._val = ASN1Set(rv=[dict([('id', 267), ('criticality', 'ignore'), ('Extension', _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 22), ('criticality', 'ignore'), ('Extension', _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 324), ('criticality', 'ignore'), ('Extension', _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 356), ('criticality', 'ignore'), ('Extension', _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TargetNGRANNode-ToSourceNGRANNode-FailureTransparentContainer >-----#
    TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer = SEQ(name='TargetNGRANNode-ToSourceNGRANNode-FailureTransparentContainer', mode=MODE_TYPE)
    _TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_cell_CAGInformation = SEQ(name='cell-CAGInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cell-CAGInformation')), opt=True)
    _TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGAPIESupportInformationResponseList')))
    ____TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 356), ('criticality', 'ignore'), ('Extension', _____TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__id._const_tab = ____TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__id_tab
    ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__id._const_tab_at = None
    ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__id._const_tab_id = 'id'
    ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__criticality._const_tab = ____TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__id_tab
    ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__extensionValue._const_tab = ____TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__id_tab
    ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__id),
        ('criticality', ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__criticality),
        ('extensionValue', ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__extensionValue),
        ])
    __TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item_._ext = None
    _TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions._cont = __TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item_
    _TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer._cont = ASN1Dict([
        ('cell-CAGInformation', _TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_cell_CAGInformation),
        ('iE-Extensions', _TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions),
        ])
    TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer._ext = []
    
    #-----< TargetNGRANNode-ToSourceNGRANNode-FailureTransparentContainer-ExtIEs >-----#
    TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_ExtIEs = CLASS(name='TargetNGRANNode-ToSourceNGRANNode-FailureTransparentContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGAPIESupportInformationResponseList')))
    TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_ExtIEs._val = ASN1Set(rv=[dict([('id', 356), ('criticality', 'ignore'), ('Extension', _TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TargetNSSAI >-----#
    TargetNSSAI = SEQ_OF(name='TargetNSSAI', mode=MODE_TYPE)
    _TargetNSSAI__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargetNSSAI-Item')))
    TargetNSSAI._cont = _TargetNSSAI__item_
    TargetNSSAI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TargetNSSAI-Item >-----#
    TargetNSSAI_Item = SEQ(name='TargetNSSAI-Item', mode=MODE_TYPE)
    _TargetNSSAI_Item_s_NSSAI = SEQ(name='s-NSSAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _TargetNSSAI_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargetNSSAI_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TargetNSSAI_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TargetNSSAI_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetNSSAI_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetNSSAI_Item_iE_Extensions__item__id._const_tab = ____TargetNSSAI_Item_iE_Extensions__item__id_tab
    ___TargetNSSAI_Item_iE_Extensions__item__id._const_tab_at = None
    ___TargetNSSAI_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TargetNSSAI_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TargetNSSAI_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetNSSAI_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetNSSAI_Item_iE_Extensions__item__criticality._const_tab = ____TargetNSSAI_Item_iE_Extensions__item__criticality_tab
    ___TargetNSSAI_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TargetNSSAI_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TargetNSSAI_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TargetNSSAI_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetNSSAI_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetNSSAI_Item_iE_Extensions__item__extensionValue._const_tab = ____TargetNSSAI_Item_iE_Extensions__item__extensionValue_tab
    ___TargetNSSAI_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TargetNSSAI_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TargetNSSAI_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TargetNSSAI_Item_iE_Extensions__item__id),
        ('criticality', ___TargetNSSAI_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TargetNSSAI_Item_iE_Extensions__item__extensionValue),
        ])
    __TargetNSSAI_Item_iE_Extensions__item_._ext = None
    _TargetNSSAI_Item_iE_Extensions._cont = __TargetNSSAI_Item_iE_Extensions__item_
    _TargetNSSAI_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargetNSSAI_Item._cont = ASN1Dict([
        ('s-NSSAI', _TargetNSSAI_Item_s_NSSAI),
        ('iE-Extensions', _TargetNSSAI_Item_iE_Extensions),
        ])
    TargetNSSAI_Item._ext = []
    
    #-----< TargetNSSAI-Item-ExtIEs >-----#
    TargetNSSAI_Item_ExtIEs = CLASS(name='TargetNSSAI-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TargetNSSAI_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TargetNSSAIInformation >-----#
    TargetNSSAIInformation = SEQ(name='TargetNSSAIInformation', mode=MODE_TYPE)
    _TargetNSSAIInformation_targetNSSAI = SEQ_OF(name='targetNSSAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TargetNSSAI')))
    _TargetNSSAIInformation_indexToRFSP = INT(name='indexToRFSP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'IndexToRFSP')))
    _TargetNSSAIInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargetNSSAIInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TargetNSSAIInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TargetNSSAIInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetNSSAIInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetNSSAIInformation_iE_Extensions__item__id._const_tab = ____TargetNSSAIInformation_iE_Extensions__item__id_tab
    ___TargetNSSAIInformation_iE_Extensions__item__id._const_tab_at = None
    ___TargetNSSAIInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TargetNSSAIInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TargetNSSAIInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetNSSAIInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetNSSAIInformation_iE_Extensions__item__criticality._const_tab = ____TargetNSSAIInformation_iE_Extensions__item__criticality_tab
    ___TargetNSSAIInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TargetNSSAIInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TargetNSSAIInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TargetNSSAIInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetNSSAIInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetNSSAIInformation_iE_Extensions__item__extensionValue._const_tab = ____TargetNSSAIInformation_iE_Extensions__item__extensionValue_tab
    ___TargetNSSAIInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TargetNSSAIInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TargetNSSAIInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TargetNSSAIInformation_iE_Extensions__item__id),
        ('criticality', ___TargetNSSAIInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___TargetNSSAIInformation_iE_Extensions__item__extensionValue),
        ])
    __TargetNSSAIInformation_iE_Extensions__item_._ext = None
    _TargetNSSAIInformation_iE_Extensions._cont = __TargetNSSAIInformation_iE_Extensions__item_
    _TargetNSSAIInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargetNSSAIInformation._cont = ASN1Dict([
        ('targetNSSAI', _TargetNSSAIInformation_targetNSSAI),
        ('indexToRFSP', _TargetNSSAIInformation_indexToRFSP),
        ('iE-Extensions', _TargetNSSAIInformation_iE_Extensions),
        ])
    TargetNSSAIInformation._ext = []
    
    #-----< TargetNSSAIInformation-Item-ExtIEs >-----#
    TargetNSSAIInformation_Item_ExtIEs = CLASS(name='TargetNSSAIInformation-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TargetNSSAIInformation_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TargetRANNodeID >-----#
    TargetRANNodeID = SEQ(name='TargetRANNodeID', mode=MODE_TYPE)
    _TargetRANNodeID_globalRANNodeID = CHOICE(name='globalRANNodeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _TargetRANNodeID_selectedTAI = SEQ(name='selectedTAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _TargetRANNodeID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargetRANNodeID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TargetRANNodeID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TargetRANNodeID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetRANNodeID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetRANNodeID_iE_Extensions__item__id._const_tab = ____TargetRANNodeID_iE_Extensions__item__id_tab
    ___TargetRANNodeID_iE_Extensions__item__id._const_tab_at = None
    ___TargetRANNodeID_iE_Extensions__item__id._const_tab_id = 'id'
    ___TargetRANNodeID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TargetRANNodeID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetRANNodeID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetRANNodeID_iE_Extensions__item__criticality._const_tab = ____TargetRANNodeID_iE_Extensions__item__criticality_tab
    ___TargetRANNodeID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TargetRANNodeID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TargetRANNodeID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TargetRANNodeID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetRANNodeID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetRANNodeID_iE_Extensions__item__extensionValue._const_tab = ____TargetRANNodeID_iE_Extensions__item__extensionValue_tab
    ___TargetRANNodeID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TargetRANNodeID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TargetRANNodeID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TargetRANNodeID_iE_Extensions__item__id),
        ('criticality', ___TargetRANNodeID_iE_Extensions__item__criticality),
        ('extensionValue', ___TargetRANNodeID_iE_Extensions__item__extensionValue),
        ])
    __TargetRANNodeID_iE_Extensions__item_._ext = None
    _TargetRANNodeID_iE_Extensions._cont = __TargetRANNodeID_iE_Extensions__item_
    _TargetRANNodeID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargetRANNodeID._cont = ASN1Dict([
        ('globalRANNodeID', _TargetRANNodeID_globalRANNodeID),
        ('selectedTAI', _TargetRANNodeID_selectedTAI),
        ('iE-Extensions', _TargetRANNodeID_iE_Extensions),
        ])
    TargetRANNodeID._ext = []
    
    #-----< TargetRANNodeID-ExtIEs >-----#
    TargetRANNodeID_ExtIEs = CLASS(name='TargetRANNodeID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TargetRANNodeID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TargetRANNodeID-RIM >-----#
    TargetRANNodeID_RIM = SEQ(name='TargetRANNodeID-RIM', mode=MODE_TYPE)
    _TargetRANNodeID_RIM_globalRANNodeID = CHOICE(name='globalRANNodeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _TargetRANNodeID_RIM_selectedTAI = SEQ(name='selectedTAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _TargetRANNodeID_RIM_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargetRANNodeID_RIM_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TargetRANNodeID_RIM_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TargetRANNodeID_RIM_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetRANNodeID_RIM_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetRANNodeID_RIM_iE_Extensions__item__id._const_tab = ____TargetRANNodeID_RIM_iE_Extensions__item__id_tab
    ___TargetRANNodeID_RIM_iE_Extensions__item__id._const_tab_at = None
    ___TargetRANNodeID_RIM_iE_Extensions__item__id._const_tab_id = 'id'
    ___TargetRANNodeID_RIM_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TargetRANNodeID_RIM_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetRANNodeID_RIM_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetRANNodeID_RIM_iE_Extensions__item__criticality._const_tab = ____TargetRANNodeID_RIM_iE_Extensions__item__criticality_tab
    ___TargetRANNodeID_RIM_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TargetRANNodeID_RIM_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TargetRANNodeID_RIM_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TargetRANNodeID_RIM_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetRANNodeID_RIM_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetRANNodeID_RIM_iE_Extensions__item__extensionValue._const_tab = ____TargetRANNodeID_RIM_iE_Extensions__item__extensionValue_tab
    ___TargetRANNodeID_RIM_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TargetRANNodeID_RIM_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TargetRANNodeID_RIM_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TargetRANNodeID_RIM_iE_Extensions__item__id),
        ('criticality', ___TargetRANNodeID_RIM_iE_Extensions__item__criticality),
        ('extensionValue', ___TargetRANNodeID_RIM_iE_Extensions__item__extensionValue),
        ])
    __TargetRANNodeID_RIM_iE_Extensions__item_._ext = None
    _TargetRANNodeID_RIM_iE_Extensions._cont = __TargetRANNodeID_RIM_iE_Extensions__item_
    _TargetRANNodeID_RIM_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargetRANNodeID_RIM._cont = ASN1Dict([
        ('globalRANNodeID', _TargetRANNodeID_RIM_globalRANNodeID),
        ('selectedTAI', _TargetRANNodeID_RIM_selectedTAI),
        ('iE-Extensions', _TargetRANNodeID_RIM_iE_Extensions),
        ])
    TargetRANNodeID_RIM._ext = []
    
    #-----< TargetRANNodeID-RIM-ExtIEs >-----#
    TargetRANNodeID_RIM_ExtIEs = CLASS(name='TargetRANNodeID-RIM-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TargetRANNodeID_RIM_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TargetRANNodeID-SON >-----#
    TargetRANNodeID_SON = SEQ(name='TargetRANNodeID-SON', mode=MODE_TYPE)
    _TargetRANNodeID_SON_globalRANNodeID = CHOICE(name='globalRANNodeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _TargetRANNodeID_SON_selectedTAI = SEQ(name='selectedTAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _TargetRANNodeID_SON_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargetRANNodeID_SON_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TargetRANNodeID_SON_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TargetRANNodeID_SON_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____TargetRANNodeID_SON_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    ____TargetRANNodeID_SON_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Extension', _____TargetRANNodeID_SON_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TargetRANNodeID_SON_iE_Extensions__item__id._const_tab = ____TargetRANNodeID_SON_iE_Extensions__item__id_tab
    ___TargetRANNodeID_SON_iE_Extensions__item__id._const_tab_at = None
    ___TargetRANNodeID_SON_iE_Extensions__item__id._const_tab_id = 'id'
    ___TargetRANNodeID_SON_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___TargetRANNodeID_SON_iE_Extensions__item__criticality._const_tab = ____TargetRANNodeID_SON_iE_Extensions__item__id_tab
    ___TargetRANNodeID_SON_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TargetRANNodeID_SON_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TargetRANNodeID_SON_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___TargetRANNodeID_SON_iE_Extensions__item__extensionValue._const_tab = ____TargetRANNodeID_SON_iE_Extensions__item__id_tab
    ___TargetRANNodeID_SON_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TargetRANNodeID_SON_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TargetRANNodeID_SON_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TargetRANNodeID_SON_iE_Extensions__item__id),
        ('criticality', ___TargetRANNodeID_SON_iE_Extensions__item__criticality),
        ('extensionValue', ___TargetRANNodeID_SON_iE_Extensions__item__extensionValue),
        ])
    __TargetRANNodeID_SON_iE_Extensions__item_._ext = None
    _TargetRANNodeID_SON_iE_Extensions._cont = __TargetRANNodeID_SON_iE_Extensions__item_
    _TargetRANNodeID_SON_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargetRANNodeID_SON._cont = ASN1Dict([
        ('globalRANNodeID', _TargetRANNodeID_SON_globalRANNodeID),
        ('selectedTAI', _TargetRANNodeID_SON_selectedTAI),
        ('iE-Extensions', _TargetRANNodeID_SON_iE_Extensions),
        ])
    TargetRANNodeID_SON._ext = []
    
    #-----< TargetRANNodeID-SON-ExtIEs >-----#
    TargetRANNodeID_SON_ExtIEs = CLASS(name='TargetRANNodeID-SON-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _TargetRANNodeID_SON_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    TargetRANNodeID_SON_ExtIEs._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Extension', _TargetRANNodeID_SON_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TargetRNC-ID >-----#
    TargetRNC_ID = SEQ(name='TargetRNC-ID', mode=MODE_TYPE)
    _TargetRNC_ID_lAI = SEQ(name='lAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LAI')))
    _TargetRNC_ID_rNC_ID = INT(name='rNC-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RNC-ID')))
    _TargetRNC_ID_extendedRNC_ID = INT(name='extendedRNC-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ExtendedRNC-ID')), opt=True)
    _TargetRNC_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargetRNC_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TargetRNC_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TargetRNC_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetRNC_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetRNC_ID_iE_Extensions__item__id._const_tab = ____TargetRNC_ID_iE_Extensions__item__id_tab
    ___TargetRNC_ID_iE_Extensions__item__id._const_tab_at = None
    ___TargetRNC_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___TargetRNC_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TargetRNC_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetRNC_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetRNC_ID_iE_Extensions__item__criticality._const_tab = ____TargetRNC_ID_iE_Extensions__item__criticality_tab
    ___TargetRNC_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TargetRNC_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TargetRNC_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TargetRNC_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TargetRNC_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetRNC_ID_iE_Extensions__item__extensionValue._const_tab = ____TargetRNC_ID_iE_Extensions__item__extensionValue_tab
    ___TargetRNC_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TargetRNC_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TargetRNC_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TargetRNC_ID_iE_Extensions__item__id),
        ('criticality', ___TargetRNC_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___TargetRNC_ID_iE_Extensions__item__extensionValue),
        ])
    __TargetRNC_ID_iE_Extensions__item_._ext = None
    _TargetRNC_ID_iE_Extensions._cont = __TargetRNC_ID_iE_Extensions__item_
    _TargetRNC_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargetRNC_ID._cont = ASN1Dict([
        ('lAI', _TargetRNC_ID_lAI),
        ('rNC-ID', _TargetRNC_ID_rNC_ID),
        ('extendedRNC-ID', _TargetRNC_ID_extendedRNC_ID),
        ('iE-Extensions', _TargetRNC_ID_iE_Extensions),
        ])
    TargetRNC_ID._ext = []
    
    #-----< TargetRNC-ID-ExtIEs >-----#
    TargetRNC_ID_ExtIEs = CLASS(name='TargetRNC-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TargetRNC_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TargetToSource-TransparentContainer >-----#
    TargetToSource_TransparentContainer = OCT_STR(name='TargetToSource-TransparentContainer', mode=MODE_TYPE)
    
    #-----< TargettoSource-Failure-TransparentContainer >-----#
    TargettoSource_Failure_TransparentContainer = OCT_STR(name='TargettoSource-Failure-TransparentContainer', mode=MODE_TYPE)
    
    #-----< TimerApproachForGUAMIRemoval >-----#
    TimerApproachForGUAMIRemoval = ENUM(name='TimerApproachForGUAMIRemoval', mode=MODE_TYPE)
    TimerApproachForGUAMIRemoval._cont = ASN1Dict([('apply-timer', 0)])
    TimerApproachForGUAMIRemoval._ext = []
    
    #-----< TimeStamp >-----#
    TimeStamp = OCT_STR(name='TimeStamp', mode=MODE_TYPE)
    TimeStamp._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< TimeSyncAssistanceInfo >-----#
    TimeSyncAssistanceInfo = SEQ(name='TimeSyncAssistanceInfo', mode=MODE_TYPE)
    _TimeSyncAssistanceInfo_timeDistributionIndication = ENUM(name='timeDistributionIndication', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimeSyncAssistanceInfo_timeDistributionIndication._cont = ASN1Dict([('enabled', 0), ('disabled', 1)])
    _TimeSyncAssistanceInfo_timeDistributionIndication._ext = []
    _TimeSyncAssistanceInfo_uUTimeSyncErrorBudget = INT(name='uUTimeSyncErrorBudget', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TimeSyncAssistanceInfo_uUTimeSyncErrorBudget._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1000000)], ev=[], er=[])
    _TimeSyncAssistanceInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TimeSyncAssistanceInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TimeSyncAssistanceInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TimeSyncAssistanceInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TimeSyncAssistanceInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeSyncAssistanceInfo_iE_Extensions__item__id._const_tab = ____TimeSyncAssistanceInfo_iE_Extensions__item__id_tab
    ___TimeSyncAssistanceInfo_iE_Extensions__item__id._const_tab_at = None
    ___TimeSyncAssistanceInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___TimeSyncAssistanceInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TimeSyncAssistanceInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TimeSyncAssistanceInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeSyncAssistanceInfo_iE_Extensions__item__criticality._const_tab = ____TimeSyncAssistanceInfo_iE_Extensions__item__criticality_tab
    ___TimeSyncAssistanceInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TimeSyncAssistanceInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TimeSyncAssistanceInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TimeSyncAssistanceInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TimeSyncAssistanceInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeSyncAssistanceInfo_iE_Extensions__item__extensionValue._const_tab = ____TimeSyncAssistanceInfo_iE_Extensions__item__extensionValue_tab
    ___TimeSyncAssistanceInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TimeSyncAssistanceInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TimeSyncAssistanceInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TimeSyncAssistanceInfo_iE_Extensions__item__id),
        ('criticality', ___TimeSyncAssistanceInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___TimeSyncAssistanceInfo_iE_Extensions__item__extensionValue),
        ])
    __TimeSyncAssistanceInfo_iE_Extensions__item_._ext = None
    _TimeSyncAssistanceInfo_iE_Extensions._cont = __TimeSyncAssistanceInfo_iE_Extensions__item_
    _TimeSyncAssistanceInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TimeSyncAssistanceInfo._cont = ASN1Dict([
        ('timeDistributionIndication', _TimeSyncAssistanceInfo_timeDistributionIndication),
        ('uUTimeSyncErrorBudget', _TimeSyncAssistanceInfo_uUTimeSyncErrorBudget),
        ('iE-Extensions', _TimeSyncAssistanceInfo_iE_Extensions),
        ])
    TimeSyncAssistanceInfo._ext = []
    
    #-----< TimeSyncAssistanceInfo-ExtIEs >-----#
    TimeSyncAssistanceInfo_ExtIEs = CLASS(name='TimeSyncAssistanceInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TimeSyncAssistanceInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TimeToWait >-----#
    TimeToWait = ENUM(name='TimeToWait', mode=MODE_TYPE)
    TimeToWait._cont = ASN1Dict([('v1s', 0), ('v2s', 1), ('v5s', 2), ('v10s', 3), ('v20s', 4), ('v60s', 5)])
    TimeToWait._ext = []
    
    #-----< TimeUEStayedInCell >-----#
    TimeUEStayedInCell = INT(name='TimeUEStayedInCell', mode=MODE_TYPE)
    TimeUEStayedInCell._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< TimeUEStayedInCellEnhancedGranularity >-----#
    TimeUEStayedInCellEnhancedGranularity = INT(name='TimeUEStayedInCellEnhancedGranularity', mode=MODE_TYPE)
    TimeUEStayedInCellEnhancedGranularity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=40950)], ev=None, er=[])
    
    #-----< TMGI >-----#
    TMGI = OCT_STR(name='TMGI', mode=MODE_TYPE)
    TMGI._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< TNAP-ID >-----#
    TNAP_ID = OCT_STR(name='TNAP-ID', mode=MODE_TYPE)
    
    #-----< TNGF-ID >-----#
    TNGF_ID = CHOICE(name='TNGF-ID', mode=MODE_TYPE)
    _TNGF_ID_tNGF_ID = BIT_STR(name='tNGF-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TNGF_ID_tNGF_ID._const_sz = ASN1Set(rv=[32], rr=[], ev=[], er=[])
    _TNGF_ID_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __TNGF_ID_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___TNGF_ID_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___TNGF_ID_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TNGF_ID_choice_Extensions_id._const_tab = ___TNGF_ID_choice_Extensions_id_tab
    __TNGF_ID_choice_Extensions_id._const_tab_at = None
    __TNGF_ID_choice_Extensions_id._const_tab_id = 'id'
    __TNGF_ID_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___TNGF_ID_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___TNGF_ID_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TNGF_ID_choice_Extensions_criticality._const_tab = ___TNGF_ID_choice_Extensions_criticality_tab
    __TNGF_ID_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __TNGF_ID_choice_Extensions_criticality._const_tab_id = 'criticality'
    __TNGF_ID_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___TNGF_ID_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___TNGF_ID_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TNGF_ID_choice_Extensions_value._const_tab = ___TNGF_ID_choice_Extensions_value_tab
    __TNGF_ID_choice_Extensions_value._const_tab_at = ('..', 'id')
    __TNGF_ID_choice_Extensions_value._const_tab_id = 'Value'
    _TNGF_ID_choice_Extensions._cont = ASN1Dict([
        ('id', __TNGF_ID_choice_Extensions_id),
        ('criticality', __TNGF_ID_choice_Extensions_criticality),
        ('value', __TNGF_ID_choice_Extensions_value),
        ])
    _TNGF_ID_choice_Extensions._ext = None
    TNGF_ID._cont = ASN1Dict([
        ('tNGF-ID', _TNGF_ID_tNGF_ID),
        ('choice-Extensions', _TNGF_ID_choice_Extensions),
        ])
    TNGF_ID._ext = None
    
    #-----< TNGF-ID-ExtIEs >-----#
    TNGF_ID_ExtIEs = CLASS(name='TNGF-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    TNGF_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TNLAddressWeightFactor >-----#
    TNLAddressWeightFactor = INT(name='TNLAddressWeightFactor', mode=MODE_TYPE)
    TNLAddressWeightFactor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< TNLAssociationList >-----#
    TNLAssociationList = SEQ_OF(name='TNLAssociationList', mode=MODE_TYPE)
    _TNLAssociationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TNLAssociationItem')))
    TNLAssociationList._cont = _TNLAssociationList__item_
    TNLAssociationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< TNLAssociationItem >-----#
    TNLAssociationItem = SEQ(name='TNLAssociationItem', mode=MODE_TYPE)
    _TNLAssociationItem_tNLAssociationAddress = CHOICE(name='tNLAssociationAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'CPTransportLayerInformation')))
    _TNLAssociationItem_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _TNLAssociationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TNLAssociationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TNLAssociationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TNLAssociationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TNLAssociationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLAssociationItem_iE_Extensions__item__id._const_tab = ____TNLAssociationItem_iE_Extensions__item__id_tab
    ___TNLAssociationItem_iE_Extensions__item__id._const_tab_at = None
    ___TNLAssociationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___TNLAssociationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TNLAssociationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TNLAssociationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLAssociationItem_iE_Extensions__item__criticality._const_tab = ____TNLAssociationItem_iE_Extensions__item__criticality_tab
    ___TNLAssociationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TNLAssociationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TNLAssociationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TNLAssociationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TNLAssociationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLAssociationItem_iE_Extensions__item__extensionValue._const_tab = ____TNLAssociationItem_iE_Extensions__item__extensionValue_tab
    ___TNLAssociationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TNLAssociationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TNLAssociationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TNLAssociationItem_iE_Extensions__item__id),
        ('criticality', ___TNLAssociationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___TNLAssociationItem_iE_Extensions__item__extensionValue),
        ])
    __TNLAssociationItem_iE_Extensions__item_._ext = None
    _TNLAssociationItem_iE_Extensions._cont = __TNLAssociationItem_iE_Extensions__item_
    _TNLAssociationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TNLAssociationItem._cont = ASN1Dict([
        ('tNLAssociationAddress', _TNLAssociationItem_tNLAssociationAddress),
        ('cause', _TNLAssociationItem_cause),
        ('iE-Extensions', _TNLAssociationItem_iE_Extensions),
        ])
    TNLAssociationItem._ext = []
    
    #-----< TNLAssociationItem-ExtIEs >-----#
    TNLAssociationItem_ExtIEs = CLASS(name='TNLAssociationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TNLAssociationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TNLAssociationUsage >-----#
    TNLAssociationUsage = ENUM(name='TNLAssociationUsage', mode=MODE_TYPE)
    TNLAssociationUsage._cont = ASN1Dict([('ue', 0), ('non-ue', 1), ('both', 2)])
    TNLAssociationUsage._ext = []
    
    #-----< TooearlyIntersystemHO >-----#
    TooearlyIntersystemHO = SEQ(name='TooearlyIntersystemHO', mode=MODE_TYPE)
    _TooearlyIntersystemHO_sourcecellID = SEQ(name='sourcecellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _TooearlyIntersystemHO_failurecellID = CHOICE(name='failurecellID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _TooearlyIntersystemHO_uERLFReportContainer = CHOICE(name='uERLFReportContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UERLFReportContainer')), opt=True)
    _TooearlyIntersystemHO_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TooearlyIntersystemHO_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TooearlyIntersystemHO_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TooearlyIntersystemHO_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TooearlyIntersystemHO_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TooearlyIntersystemHO_iE_Extensions__item__id._const_tab = ____TooearlyIntersystemHO_iE_Extensions__item__id_tab
    ___TooearlyIntersystemHO_iE_Extensions__item__id._const_tab_at = None
    ___TooearlyIntersystemHO_iE_Extensions__item__id._const_tab_id = 'id'
    ___TooearlyIntersystemHO_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TooearlyIntersystemHO_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TooearlyIntersystemHO_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TooearlyIntersystemHO_iE_Extensions__item__criticality._const_tab = ____TooearlyIntersystemHO_iE_Extensions__item__criticality_tab
    ___TooearlyIntersystemHO_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TooearlyIntersystemHO_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TooearlyIntersystemHO_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TooearlyIntersystemHO_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TooearlyIntersystemHO_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TooearlyIntersystemHO_iE_Extensions__item__extensionValue._const_tab = ____TooearlyIntersystemHO_iE_Extensions__item__extensionValue_tab
    ___TooearlyIntersystemHO_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TooearlyIntersystemHO_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TooearlyIntersystemHO_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TooearlyIntersystemHO_iE_Extensions__item__id),
        ('criticality', ___TooearlyIntersystemHO_iE_Extensions__item__criticality),
        ('extensionValue', ___TooearlyIntersystemHO_iE_Extensions__item__extensionValue),
        ])
    __TooearlyIntersystemHO_iE_Extensions__item_._ext = None
    _TooearlyIntersystemHO_iE_Extensions._cont = __TooearlyIntersystemHO_iE_Extensions__item_
    _TooearlyIntersystemHO_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TooearlyIntersystemHO._cont = ASN1Dict([
        ('sourcecellID', _TooearlyIntersystemHO_sourcecellID),
        ('failurecellID', _TooearlyIntersystemHO_failurecellID),
        ('uERLFReportContainer', _TooearlyIntersystemHO_uERLFReportContainer),
        ('iE-Extensions', _TooearlyIntersystemHO_iE_Extensions),
        ])
    TooearlyIntersystemHO._ext = []
    
    #-----< TooearlyIntersystemHO-ExtIEs >-----#
    TooearlyIntersystemHO_ExtIEs = CLASS(name='TooearlyIntersystemHO-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TooearlyIntersystemHO_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TraceActivation >-----#
    TraceActivation = SEQ(name='TraceActivation', mode=MODE_TYPE)
    _TraceActivation_nGRANTraceID = OCT_STR(name='nGRANTraceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NGRANTraceID')))
    _TraceActivation_interfacesToTrace = BIT_STR(name='interfacesToTrace', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'InterfacesToTrace')))
    _TraceActivation_traceDepth = ENUM(name='traceDepth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TraceDepth')))
    _TraceActivation_traceCollectionEntityIPAddress = BIT_STR(name='traceCollectionEntityIPAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _TraceActivation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TraceActivation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TraceActivation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TraceActivation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MDT-Configuration')))
    _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_1 = STR_VIS(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'URI-address')))
    ____TraceActivation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 255), ('criticality', 'ignore'), ('Extension', _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 257), ('criticality', 'ignore'), ('Extension', _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TraceActivation_iE_Extensions__item__id._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__id._const_tab_at = None
    ___TraceActivation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TraceActivation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___TraceActivation_iE_Extensions__item__criticality._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TraceActivation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TraceActivation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TraceActivation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TraceActivation_iE_Extensions__item__id),
        ('criticality', ___TraceActivation_iE_Extensions__item__criticality),
        ('extensionValue', ___TraceActivation_iE_Extensions__item__extensionValue),
        ])
    __TraceActivation_iE_Extensions__item_._ext = None
    _TraceActivation_iE_Extensions._cont = __TraceActivation_iE_Extensions__item_
    _TraceActivation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TraceActivation._cont = ASN1Dict([
        ('nGRANTraceID', _TraceActivation_nGRANTraceID),
        ('interfacesToTrace', _TraceActivation_interfacesToTrace),
        ('traceDepth', _TraceActivation_traceDepth),
        ('traceCollectionEntityIPAddress', _TraceActivation_traceCollectionEntityIPAddress),
        ('iE-Extensions', _TraceActivation_iE_Extensions),
        ])
    TraceActivation._ext = []
    
    #-----< TraceActivation-ExtIEs >-----#
    TraceActivation_ExtIEs = CLASS(name='TraceActivation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _TraceActivation_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MDT-Configuration')))
    _TraceActivation_ExtIEs_val_Extension_1 = STR_VIS(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'URI-address')))
    TraceActivation_ExtIEs._val = ASN1Set(rv=[dict([('id', 255), ('criticality', 'ignore'), ('Extension', _TraceActivation_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 257), ('criticality', 'ignore'), ('Extension', _TraceActivation_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TraceDepth >-----#
    TraceDepth = ENUM(name='TraceDepth', mode=MODE_TYPE)
    TraceDepth._cont = ASN1Dict([('minimum', 0), ('medium', 1), ('maximum', 2), ('minimumWithoutVendorSpecificExtension', 3), ('mediumWithoutVendorSpecificExtension', 4), ('maximumWithoutVendorSpecificExtension', 5)])
    TraceDepth._ext = []
    
    #-----< TrafficLoadReductionIndication >-----#
    TrafficLoadReductionIndication = INT(name='TrafficLoadReductionIndication', mode=MODE_TYPE)
    TrafficLoadReductionIndication._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=99)], ev=None, er=[])
    
    #-----< TransportLayerAddress >-----#
    TransportLayerAddress = BIT_STR(name='TransportLayerAddress', mode=MODE_TYPE)
    TransportLayerAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=[], er=[])
    
    #-----< TypeOfError >-----#
    TypeOfError = ENUM(name='TypeOfError', mode=MODE_TYPE)
    TypeOfError._cont = ASN1Dict([('not-understood', 0), ('missing', 1)])
    TypeOfError._ext = []
    
    #-----< TAIBasedMDT >-----#
    TAIBasedMDT = SEQ(name='TAIBasedMDT', mode=MODE_TYPE)
    _TAIBasedMDT_tAIListforMDT = SEQ_OF(name='tAIListforMDT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAIListforMDT')))
    _TAIBasedMDT_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAIBasedMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TAIBasedMDT_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TAIBasedMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIBasedMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedMDT_iE_Extensions__item__id._const_tab = ____TAIBasedMDT_iE_Extensions__item__id_tab
    ___TAIBasedMDT_iE_Extensions__item__id._const_tab_at = None
    ___TAIBasedMDT_iE_Extensions__item__id._const_tab_id = 'id'
    ___TAIBasedMDT_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TAIBasedMDT_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIBasedMDT_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedMDT_iE_Extensions__item__criticality._const_tab = ____TAIBasedMDT_iE_Extensions__item__criticality_tab
    ___TAIBasedMDT_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TAIBasedMDT_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TAIBasedMDT_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TAIBasedMDT_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIBasedMDT_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedMDT_iE_Extensions__item__extensionValue._const_tab = ____TAIBasedMDT_iE_Extensions__item__extensionValue_tab
    ___TAIBasedMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TAIBasedMDT_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TAIBasedMDT_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TAIBasedMDT_iE_Extensions__item__id),
        ('criticality', ___TAIBasedMDT_iE_Extensions__item__criticality),
        ('extensionValue', ___TAIBasedMDT_iE_Extensions__item__extensionValue),
        ])
    __TAIBasedMDT_iE_Extensions__item_._ext = None
    _TAIBasedMDT_iE_Extensions._cont = __TAIBasedMDT_iE_Extensions__item_
    _TAIBasedMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAIBasedMDT._cont = ASN1Dict([
        ('tAIListforMDT', _TAIBasedMDT_tAIListforMDT),
        ('iE-Extensions', _TAIBasedMDT_iE_Extensions),
        ])
    TAIBasedMDT._ext = []
    
    #-----< TAIBasedMDT-ExtIEs >-----#
    TAIBasedMDT_ExtIEs = CLASS(name='TAIBasedMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TAIBasedMDT_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAIListforMDT >-----#
    TAIListforMDT = SEQ_OF(name='TAIListforMDT', mode=MODE_TYPE)
    _TAIListforMDT__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    TAIListforMDT._cont = _TAIListforMDT__item_
    TAIListforMDT._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TAIBasedQMC >-----#
    TAIBasedQMC = SEQ(name='TAIBasedQMC', mode=MODE_TYPE)
    _TAIBasedQMC_tAIListforQMC = SEQ_OF(name='tAIListforQMC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAIListforQMC')))
    _TAIBasedQMC_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAIBasedQMC_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TAIBasedQMC_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TAIBasedQMC_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIBasedQMC_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedQMC_iE_Extensions__item__id._const_tab = ____TAIBasedQMC_iE_Extensions__item__id_tab
    ___TAIBasedQMC_iE_Extensions__item__id._const_tab_at = None
    ___TAIBasedQMC_iE_Extensions__item__id._const_tab_id = 'id'
    ___TAIBasedQMC_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TAIBasedQMC_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIBasedQMC_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedQMC_iE_Extensions__item__criticality._const_tab = ____TAIBasedQMC_iE_Extensions__item__criticality_tab
    ___TAIBasedQMC_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TAIBasedQMC_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TAIBasedQMC_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TAIBasedQMC_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TAIBasedQMC_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedQMC_iE_Extensions__item__extensionValue._const_tab = ____TAIBasedQMC_iE_Extensions__item__extensionValue_tab
    ___TAIBasedQMC_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TAIBasedQMC_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TAIBasedQMC_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TAIBasedQMC_iE_Extensions__item__id),
        ('criticality', ___TAIBasedQMC_iE_Extensions__item__criticality),
        ('extensionValue', ___TAIBasedQMC_iE_Extensions__item__extensionValue),
        ])
    __TAIBasedQMC_iE_Extensions__item_._ext = None
    _TAIBasedQMC_iE_Extensions._cont = __TAIBasedQMC_iE_Extensions__item_
    _TAIBasedQMC_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAIBasedQMC._cont = ASN1Dict([
        ('tAIListforQMC', _TAIBasedQMC_tAIListforQMC),
        ('iE-Extensions', _TAIBasedQMC_iE_Extensions),
        ])
    TAIBasedQMC._ext = []
    
    #-----< TAIBasedQMC-ExtIEs >-----#
    TAIBasedQMC_ExtIEs = CLASS(name='TAIBasedQMC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TAIBasedQMC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAIListforQMC >-----#
    TAIListforQMC = SEQ_OF(name='TAIListforQMC', mode=MODE_TYPE)
    _TAIListforQMC__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    TAIListforQMC._cont = _TAIListforQMC__item_
    TAIListforQMC._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TABasedQMC >-----#
    TABasedQMC = SEQ(name='TABasedQMC', mode=MODE_TYPE)
    _TABasedQMC_tAListforQMC = SEQ_OF(name='tAListforQMC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAListforQMC')))
    _TABasedQMC_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TABasedQMC_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TABasedQMC_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TABasedQMC_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TABasedQMC_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedQMC_iE_Extensions__item__id._const_tab = ____TABasedQMC_iE_Extensions__item__id_tab
    ___TABasedQMC_iE_Extensions__item__id._const_tab_at = None
    ___TABasedQMC_iE_Extensions__item__id._const_tab_id = 'id'
    ___TABasedQMC_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TABasedQMC_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TABasedQMC_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedQMC_iE_Extensions__item__criticality._const_tab = ____TABasedQMC_iE_Extensions__item__criticality_tab
    ___TABasedQMC_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TABasedQMC_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TABasedQMC_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TABasedQMC_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TABasedQMC_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedQMC_iE_Extensions__item__extensionValue._const_tab = ____TABasedQMC_iE_Extensions__item__extensionValue_tab
    ___TABasedQMC_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TABasedQMC_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TABasedQMC_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TABasedQMC_iE_Extensions__item__id),
        ('criticality', ___TABasedQMC_iE_Extensions__item__criticality),
        ('extensionValue', ___TABasedQMC_iE_Extensions__item__extensionValue),
        ])
    __TABasedQMC_iE_Extensions__item_._ext = None
    _TABasedQMC_iE_Extensions._cont = __TABasedQMC_iE_Extensions__item_
    _TABasedQMC_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TABasedQMC._cont = ASN1Dict([
        ('tAListforQMC', _TABasedQMC_tAListforQMC),
        ('iE-Extensions', _TABasedQMC_iE_Extensions),
        ])
    TABasedQMC._ext = []
    
    #-----< TABasedQMC-ExtIEs >-----#
    TABasedQMC_ExtIEs = CLASS(name='TABasedQMC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TABasedQMC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAListforQMC >-----#
    TAListforQMC = SEQ_OF(name='TAListforQMC', mode=MODE_TYPE)
    _TAListforQMC__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAC')))
    TAListforQMC._cont = _TAListforQMC__item_
    TAListforQMC._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TABasedMDT >-----#
    TABasedMDT = SEQ(name='TABasedMDT', mode=MODE_TYPE)
    _TABasedMDT_tAListforMDT = SEQ_OF(name='tAListforMDT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAListforMDT')))
    _TABasedMDT_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TABasedMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TABasedMDT_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TABasedMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TABasedMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedMDT_iE_Extensions__item__id._const_tab = ____TABasedMDT_iE_Extensions__item__id_tab
    ___TABasedMDT_iE_Extensions__item__id._const_tab_at = None
    ___TABasedMDT_iE_Extensions__item__id._const_tab_id = 'id'
    ___TABasedMDT_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TABasedMDT_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TABasedMDT_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedMDT_iE_Extensions__item__criticality._const_tab = ____TABasedMDT_iE_Extensions__item__criticality_tab
    ___TABasedMDT_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TABasedMDT_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TABasedMDT_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TABasedMDT_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TABasedMDT_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedMDT_iE_Extensions__item__extensionValue._const_tab = ____TABasedMDT_iE_Extensions__item__extensionValue_tab
    ___TABasedMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TABasedMDT_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TABasedMDT_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TABasedMDT_iE_Extensions__item__id),
        ('criticality', ___TABasedMDT_iE_Extensions__item__criticality),
        ('extensionValue', ___TABasedMDT_iE_Extensions__item__extensionValue),
        ])
    __TABasedMDT_iE_Extensions__item_._ext = None
    _TABasedMDT_iE_Extensions._cont = __TABasedMDT_iE_Extensions__item_
    _TABasedMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TABasedMDT._cont = ASN1Dict([
        ('tAListforMDT', _TABasedMDT_tAListforMDT),
        ('iE-Extensions', _TABasedMDT_iE_Extensions),
        ])
    TABasedMDT._ext = []
    
    #-----< TABasedMDT-ExtIEs >-----#
    TABasedMDT_ExtIEs = CLASS(name='TABasedMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TABasedMDT_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAListforMDT >-----#
    TAListforMDT = SEQ_OF(name='TAListforMDT', mode=MODE_TYPE)
    _TAListforMDT__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAC')))
    TAListforMDT._cont = _TAListforMDT__item_
    TAListforMDT._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Threshold-RSRP >-----#
    Threshold_RSRP = INT(name='Threshold-RSRP', mode=MODE_TYPE)
    Threshold_RSRP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< Threshold-RSRQ >-----#
    Threshold_RSRQ = INT(name='Threshold-RSRQ', mode=MODE_TYPE)
    Threshold_RSRQ._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< Threshold-SINR >-----#
    Threshold_SINR = INT(name='Threshold-SINR', mode=MODE_TYPE)
    Threshold_SINR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< TimeToTrigger >-----#
    TimeToTrigger = ENUM(name='TimeToTrigger', mode=MODE_TYPE)
    TimeToTrigger._cont = ASN1Dict([('ms0', 0), ('ms40', 1), ('ms64', 2), ('ms80', 3), ('ms100', 4), ('ms128', 5), ('ms160', 6), ('ms256', 7), ('ms320', 8), ('ms480', 9), ('ms512', 10), ('ms640', 11), ('ms1024', 12), ('ms1280', 13), ('ms2560', 14), ('ms5120', 15)])
    TimeToTrigger._ext = None
    
    #-----< TWAP-ID >-----#
    TWAP_ID = OCT_STR(name='TWAP-ID', mode=MODE_TYPE)
    
    #-----< TWIF-ID >-----#
    TWIF_ID = CHOICE(name='TWIF-ID', mode=MODE_TYPE)
    _TWIF_ID_tWIF_ID = BIT_STR(name='tWIF-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TWIF_ID_tWIF_ID._const_sz = ASN1Set(rv=[32], rr=[], ev=[], er=[])
    _TWIF_ID_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __TWIF_ID_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___TWIF_ID_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___TWIF_ID_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TWIF_ID_choice_Extensions_id._const_tab = ___TWIF_ID_choice_Extensions_id_tab
    __TWIF_ID_choice_Extensions_id._const_tab_at = None
    __TWIF_ID_choice_Extensions_id._const_tab_id = 'id'
    __TWIF_ID_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___TWIF_ID_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___TWIF_ID_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TWIF_ID_choice_Extensions_criticality._const_tab = ___TWIF_ID_choice_Extensions_criticality_tab
    __TWIF_ID_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __TWIF_ID_choice_Extensions_criticality._const_tab_id = 'criticality'
    __TWIF_ID_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___TWIF_ID_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___TWIF_ID_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TWIF_ID_choice_Extensions_value._const_tab = ___TWIF_ID_choice_Extensions_value_tab
    __TWIF_ID_choice_Extensions_value._const_tab_at = ('..', 'id')
    __TWIF_ID_choice_Extensions_value._const_tab_id = 'Value'
    _TWIF_ID_choice_Extensions._cont = ASN1Dict([
        ('id', __TWIF_ID_choice_Extensions_id),
        ('criticality', __TWIF_ID_choice_Extensions_criticality),
        ('value', __TWIF_ID_choice_Extensions_value),
        ])
    _TWIF_ID_choice_Extensions._ext = None
    TWIF_ID._cont = ASN1Dict([
        ('tWIF-ID', _TWIF_ID_tWIF_ID),
        ('choice-Extensions', _TWIF_ID_choice_Extensions),
        ])
    TWIF_ID._ext = None
    
    #-----< TWIF-ID-ExtIEs >-----#
    TWIF_ID_ExtIEs = CLASS(name='TWIF-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    TWIF_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TSCAssistanceInformation >-----#
    TSCAssistanceInformation = SEQ(name='TSCAssistanceInformation', mode=MODE_TYPE)
    _TSCAssistanceInformation_periodicity = INT(name='periodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'Periodicity')))
    _TSCAssistanceInformation_burstArrivalTime = OCT_STR(name='burstArrivalTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BurstArrivalTime')), opt=True)
    _TSCAssistanceInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TSCAssistanceInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TSCAssistanceInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TSCAssistanceInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____TSCAssistanceInformation_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SurvivalTime')))
    ____TSCAssistanceInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 327), ('criticality', 'ignore'), ('Extension', _____TSCAssistanceInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TSCAssistanceInformation_iE_Extensions__item__id._const_tab = ____TSCAssistanceInformation_iE_Extensions__item__id_tab
    ___TSCAssistanceInformation_iE_Extensions__item__id._const_tab_at = None
    ___TSCAssistanceInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TSCAssistanceInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___TSCAssistanceInformation_iE_Extensions__item__criticality._const_tab = ____TSCAssistanceInformation_iE_Extensions__item__id_tab
    ___TSCAssistanceInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TSCAssistanceInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TSCAssistanceInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___TSCAssistanceInformation_iE_Extensions__item__extensionValue._const_tab = ____TSCAssistanceInformation_iE_Extensions__item__id_tab
    ___TSCAssistanceInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TSCAssistanceInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TSCAssistanceInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TSCAssistanceInformation_iE_Extensions__item__id),
        ('criticality', ___TSCAssistanceInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___TSCAssistanceInformation_iE_Extensions__item__extensionValue),
        ])
    __TSCAssistanceInformation_iE_Extensions__item_._ext = None
    _TSCAssistanceInformation_iE_Extensions._cont = __TSCAssistanceInformation_iE_Extensions__item_
    _TSCAssistanceInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TSCAssistanceInformation._cont = ASN1Dict([
        ('periodicity', _TSCAssistanceInformation_periodicity),
        ('burstArrivalTime', _TSCAssistanceInformation_burstArrivalTime),
        ('iE-Extensions', _TSCAssistanceInformation_iE_Extensions),
        ])
    TSCAssistanceInformation._ext = []
    
    #-----< TSCAssistanceInformation-ExtIEs >-----#
    TSCAssistanceInformation_ExtIEs = CLASS(name='TSCAssistanceInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _TSCAssistanceInformation_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SurvivalTime')))
    TSCAssistanceInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 327), ('criticality', 'ignore'), ('Extension', _TSCAssistanceInformation_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TSCTrafficCharacteristics >-----#
    TSCTrafficCharacteristics = SEQ(name='TSCTrafficCharacteristics', mode=MODE_TYPE)
    _TSCTrafficCharacteristics_tSCAssistanceInformationDL = SEQ(name='tSCAssistanceInformationDL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TSCAssistanceInformation')), opt=True)
    _TSCTrafficCharacteristics_tSCAssistanceInformationUL = SEQ(name='tSCAssistanceInformationUL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TSCAssistanceInformation')), opt=True)
    _TSCTrafficCharacteristics_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TSCTrafficCharacteristics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___TSCTrafficCharacteristics_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____TSCTrafficCharacteristics_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TSCTrafficCharacteristics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TSCTrafficCharacteristics_iE_Extensions__item__id._const_tab = ____TSCTrafficCharacteristics_iE_Extensions__item__id_tab
    ___TSCTrafficCharacteristics_iE_Extensions__item__id._const_tab_at = None
    ___TSCTrafficCharacteristics_iE_Extensions__item__id._const_tab_id = 'id'
    ___TSCTrafficCharacteristics_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TSCTrafficCharacteristics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TSCTrafficCharacteristics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TSCTrafficCharacteristics_iE_Extensions__item__criticality._const_tab = ____TSCTrafficCharacteristics_iE_Extensions__item__criticality_tab
    ___TSCTrafficCharacteristics_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TSCTrafficCharacteristics_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TSCTrafficCharacteristics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____TSCTrafficCharacteristics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue._const_tab = ____TSCTrafficCharacteristics_iE_Extensions__item__extensionValue_tab
    ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TSCTrafficCharacteristics_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TSCTrafficCharacteristics_iE_Extensions__item__id),
        ('criticality', ___TSCTrafficCharacteristics_iE_Extensions__item__criticality),
        ('extensionValue', ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue),
        ])
    __TSCTrafficCharacteristics_iE_Extensions__item_._ext = None
    _TSCTrafficCharacteristics_iE_Extensions._cont = __TSCTrafficCharacteristics_iE_Extensions__item_
    _TSCTrafficCharacteristics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TSCTrafficCharacteristics._cont = ASN1Dict([
        ('tSCAssistanceInformationDL', _TSCTrafficCharacteristics_tSCAssistanceInformationDL),
        ('tSCAssistanceInformationUL', _TSCTrafficCharacteristics_tSCAssistanceInformationUL),
        ('iE-Extensions', _TSCTrafficCharacteristics_iE_Extensions),
        ])
    TSCTrafficCharacteristics._ext = []
    
    #-----< TSCTrafficCharacteristics-ExtIEs >-----#
    TSCTrafficCharacteristics_ExtIEs = CLASS(name='TSCTrafficCharacteristics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    TSCTrafficCharacteristics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEAggregateMaximumBitRate >-----#
    UEAggregateMaximumBitRate = SEQ(name='UEAggregateMaximumBitRate', mode=MODE_TYPE)
    _UEAggregateMaximumBitRate_uEAggregateMaximumBitRateDL = INT(name='uEAggregateMaximumBitRateDL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _UEAggregateMaximumBitRate_uEAggregateMaximumBitRateUL = INT(name='uEAggregateMaximumBitRateUL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _UEAggregateMaximumBitRate_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEAggregateMaximumBitRate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UEAggregateMaximumBitRate_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____UEAggregateMaximumBitRate_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEAggregateMaximumBitRate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEAggregateMaximumBitRate_iE_Extensions__item__id._const_tab = ____UEAggregateMaximumBitRate_iE_Extensions__item__id_tab
    ___UEAggregateMaximumBitRate_iE_Extensions__item__id._const_tab_at = None
    ___UEAggregateMaximumBitRate_iE_Extensions__item__id._const_tab_id = 'id'
    ___UEAggregateMaximumBitRate_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UEAggregateMaximumBitRate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEAggregateMaximumBitRate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEAggregateMaximumBitRate_iE_Extensions__item__criticality._const_tab = ____UEAggregateMaximumBitRate_iE_Extensions__item__criticality_tab
    ___UEAggregateMaximumBitRate_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UEAggregateMaximumBitRate_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue._const_tab = ____UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue_tab
    ___UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UEAggregateMaximumBitRate_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UEAggregateMaximumBitRate_iE_Extensions__item__id),
        ('criticality', ___UEAggregateMaximumBitRate_iE_Extensions__item__criticality),
        ('extensionValue', ___UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue),
        ])
    __UEAggregateMaximumBitRate_iE_Extensions__item_._ext = None
    _UEAggregateMaximumBitRate_iE_Extensions._cont = __UEAggregateMaximumBitRate_iE_Extensions__item_
    _UEAggregateMaximumBitRate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEAggregateMaximumBitRate._cont = ASN1Dict([
        ('uEAggregateMaximumBitRateDL', _UEAggregateMaximumBitRate_uEAggregateMaximumBitRateDL),
        ('uEAggregateMaximumBitRateUL', _UEAggregateMaximumBitRate_uEAggregateMaximumBitRateUL),
        ('iE-Extensions', _UEAggregateMaximumBitRate_iE_Extensions),
        ])
    UEAggregateMaximumBitRate._ext = []
    
    #-----< UEAggregateMaximumBitRate-ExtIEs >-----#
    UEAggregateMaximumBitRate_ExtIEs = CLASS(name='UEAggregateMaximumBitRate-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UEAggregateMaximumBitRate_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEAppLayerMeasInfoList >-----#
    UEAppLayerMeasInfoList = SEQ_OF(name='UEAppLayerMeasInfoList', mode=MODE_TYPE)
    _UEAppLayerMeasInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEAppLayerMeasInfoItem')))
    UEAppLayerMeasInfoList._cont = _UEAppLayerMeasInfoList__item_
    UEAppLayerMeasInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< UEAppLayerMeasInfoItem >-----#
    UEAppLayerMeasInfoItem = SEQ(name='UEAppLayerMeasInfoItem', mode=MODE_TYPE)
    _UEAppLayerMeasInfoItem_uEAppLayerMeasConfigInfo = SEQ(name='uEAppLayerMeasConfigInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UEAppLayerMeasConfigInfo')))
    _UEAppLayerMeasInfoItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEAppLayerMeasInfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UEAppLayerMeasInfoItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____UEAppLayerMeasInfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEAppLayerMeasInfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEAppLayerMeasInfoItem_iE_Extensions__item__id._const_tab = ____UEAppLayerMeasInfoItem_iE_Extensions__item__id_tab
    ___UEAppLayerMeasInfoItem_iE_Extensions__item__id._const_tab_at = None
    ___UEAppLayerMeasInfoItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UEAppLayerMeasInfoItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UEAppLayerMeasInfoItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEAppLayerMeasInfoItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEAppLayerMeasInfoItem_iE_Extensions__item__criticality._const_tab = ____UEAppLayerMeasInfoItem_iE_Extensions__item__criticality_tab
    ___UEAppLayerMeasInfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UEAppLayerMeasInfoItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UEAppLayerMeasInfoItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UEAppLayerMeasInfoItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEAppLayerMeasInfoItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEAppLayerMeasInfoItem_iE_Extensions__item__extensionValue._const_tab = ____UEAppLayerMeasInfoItem_iE_Extensions__item__extensionValue_tab
    ___UEAppLayerMeasInfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UEAppLayerMeasInfoItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UEAppLayerMeasInfoItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UEAppLayerMeasInfoItem_iE_Extensions__item__id),
        ('criticality', ___UEAppLayerMeasInfoItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UEAppLayerMeasInfoItem_iE_Extensions__item__extensionValue),
        ])
    __UEAppLayerMeasInfoItem_iE_Extensions__item_._ext = None
    _UEAppLayerMeasInfoItem_iE_Extensions._cont = __UEAppLayerMeasInfoItem_iE_Extensions__item_
    _UEAppLayerMeasInfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEAppLayerMeasInfoItem._cont = ASN1Dict([
        ('uEAppLayerMeasConfigInfo', _UEAppLayerMeasInfoItem_uEAppLayerMeasConfigInfo),
        ('iE-Extensions', _UEAppLayerMeasInfoItem_iE_Extensions),
        ])
    UEAppLayerMeasInfoItem._ext = []
    
    #-----< UEAppLayerMeasInfoItem-ExtIEs >-----#
    UEAppLayerMeasInfoItem_ExtIEs = CLASS(name='UEAppLayerMeasInfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UEAppLayerMeasInfoItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEAppLayerMeasConfigInfo >-----#
    UEAppLayerMeasConfigInfo = SEQ(name='UEAppLayerMeasConfigInfo', mode=MODE_TYPE)
    _UEAppLayerMeasConfigInfo_qoEReference = OCT_STR(name='qoEReference', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QoEReference')))
    _UEAppLayerMeasConfigInfo_serviceType = ENUM(name='serviceType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ServiceType')))
    _UEAppLayerMeasConfigInfo_areaScopeOfQMC = CHOICE(name='areaScopeOfQMC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AreaScopeOfQMC')))
    _UEAppLayerMeasConfigInfo_measCollEntityIPAddress = BIT_STR(name='measCollEntityIPAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _UEAppLayerMeasConfigInfo_qoEMeasurementStatus = ENUM(name='qoEMeasurementStatus', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UEAppLayerMeasConfigInfo_qoEMeasurementStatus._cont = ASN1Dict([('ongoing', 0)])
    _UEAppLayerMeasConfigInfo_qoEMeasurementStatus._ext = []
    _UEAppLayerMeasConfigInfo_containerForAppLayerMeasConfig = OCT_STR(name='containerForAppLayerMeasConfig', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UEAppLayerMeasConfigInfo_containerForAppLayerMeasConfig._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8000)], ev=None, er=[])
    _UEAppLayerMeasConfigInfo_measConfigAppLayerID = INT(name='measConfigAppLayerID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UEAppLayerMeasConfigInfo_measConfigAppLayerID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    _UEAppLayerMeasConfigInfo_sliceSupportListQMC = SEQ_OF(name='sliceSupportListQMC', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SliceSupportListQMC')), opt=True)
    _UEAppLayerMeasConfigInfo_mDT_AlignmentInfo = CHOICE(name='mDT-AlignmentInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'MDT-AlignmentInfo')), opt=True)
    _UEAppLayerMeasConfigInfo_availableRANVisibleQoEMetrics = SEQ(name='availableRANVisibleQoEMetrics', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AvailableRANVisibleQoEMetrics')), opt=True)
    _UEAppLayerMeasConfigInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEAppLayerMeasConfigInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UEAppLayerMeasConfigInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____UEAppLayerMeasConfigInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEAppLayerMeasConfigInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEAppLayerMeasConfigInfo_iE_Extensions__item__id._const_tab = ____UEAppLayerMeasConfigInfo_iE_Extensions__item__id_tab
    ___UEAppLayerMeasConfigInfo_iE_Extensions__item__id._const_tab_at = None
    ___UEAppLayerMeasConfigInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___UEAppLayerMeasConfigInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UEAppLayerMeasConfigInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEAppLayerMeasConfigInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEAppLayerMeasConfigInfo_iE_Extensions__item__criticality._const_tab = ____UEAppLayerMeasConfigInfo_iE_Extensions__item__criticality_tab
    ___UEAppLayerMeasConfigInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UEAppLayerMeasConfigInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UEAppLayerMeasConfigInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UEAppLayerMeasConfigInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEAppLayerMeasConfigInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEAppLayerMeasConfigInfo_iE_Extensions__item__extensionValue._const_tab = ____UEAppLayerMeasConfigInfo_iE_Extensions__item__extensionValue_tab
    ___UEAppLayerMeasConfigInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UEAppLayerMeasConfigInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UEAppLayerMeasConfigInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UEAppLayerMeasConfigInfo_iE_Extensions__item__id),
        ('criticality', ___UEAppLayerMeasConfigInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___UEAppLayerMeasConfigInfo_iE_Extensions__item__extensionValue),
        ])
    __UEAppLayerMeasConfigInfo_iE_Extensions__item_._ext = None
    _UEAppLayerMeasConfigInfo_iE_Extensions._cont = __UEAppLayerMeasConfigInfo_iE_Extensions__item_
    _UEAppLayerMeasConfigInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEAppLayerMeasConfigInfo._cont = ASN1Dict([
        ('qoEReference', _UEAppLayerMeasConfigInfo_qoEReference),
        ('serviceType', _UEAppLayerMeasConfigInfo_serviceType),
        ('areaScopeOfQMC', _UEAppLayerMeasConfigInfo_areaScopeOfQMC),
        ('measCollEntityIPAddress', _UEAppLayerMeasConfigInfo_measCollEntityIPAddress),
        ('qoEMeasurementStatus', _UEAppLayerMeasConfigInfo_qoEMeasurementStatus),
        ('containerForAppLayerMeasConfig', _UEAppLayerMeasConfigInfo_containerForAppLayerMeasConfig),
        ('measConfigAppLayerID', _UEAppLayerMeasConfigInfo_measConfigAppLayerID),
        ('sliceSupportListQMC', _UEAppLayerMeasConfigInfo_sliceSupportListQMC),
        ('mDT-AlignmentInfo', _UEAppLayerMeasConfigInfo_mDT_AlignmentInfo),
        ('availableRANVisibleQoEMetrics', _UEAppLayerMeasConfigInfo_availableRANVisibleQoEMetrics),
        ('iE-Extensions', _UEAppLayerMeasConfigInfo_iE_Extensions),
        ])
    UEAppLayerMeasConfigInfo._ext = []
    
    #-----< UEAppLayerMeasConfigInfo-ExtIEs >-----#
    UEAppLayerMeasConfigInfo_ExtIEs = CLASS(name='UEAppLayerMeasConfigInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UEAppLayerMeasConfigInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-associatedLogicalNG-connectionList >-----#
    UE_associatedLogicalNG_connectionList = SEQ_OF(name='UE-associatedLogicalNG-connectionList', mode=MODE_TYPE)
    _UE_associatedLogicalNG_connectionList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-associatedLogicalNG-connectionItem')))
    UE_associatedLogicalNG_connectionList._cont = _UE_associatedLogicalNG_connectionList__item_
    UE_associatedLogicalNG_connectionList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< UE-associatedLogicalNG-connectionItem >-----#
    UE_associatedLogicalNG_connectionItem = SEQ(name='UE-associatedLogicalNG-connectionItem', mode=MODE_TYPE)
    _UE_associatedLogicalNG_connectionItem_aMF_UE_NGAP_ID = INT(name='aMF-UE-NGAP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')), opt=True)
    _UE_associatedLogicalNG_connectionItem_rAN_UE_NGAP_ID = INT(name='rAN-UE-NGAP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')), opt=True)
    _UE_associatedLogicalNG_connectionItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_associatedLogicalNG_connectionItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_associatedLogicalNG_connectionItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UE_associatedLogicalNG_connectionItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__id._const_tab = ____UE_associatedLogicalNG_connectionItem_iE_Extensions__item__id_tab
    ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__id._const_tab_at = None
    ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UE_associatedLogicalNG_connectionItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UE_associatedLogicalNG_connectionItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__criticality._const_tab = ____UE_associatedLogicalNG_connectionItem_iE_Extensions__item__criticality_tab
    ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UE_associatedLogicalNG_connectionItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UE_associatedLogicalNG_connectionItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__extensionValue._const_tab = ____UE_associatedLogicalNG_connectionItem_iE_Extensions__item__extensionValue_tab
    ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_associatedLogicalNG_connectionItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__id),
        ('criticality', ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__extensionValue),
        ])
    __UE_associatedLogicalNG_connectionItem_iE_Extensions__item_._ext = None
    _UE_associatedLogicalNG_connectionItem_iE_Extensions._cont = __UE_associatedLogicalNG_connectionItem_iE_Extensions__item_
    _UE_associatedLogicalNG_connectionItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_associatedLogicalNG_connectionItem._cont = ASN1Dict([
        ('aMF-UE-NGAP-ID', _UE_associatedLogicalNG_connectionItem_aMF_UE_NGAP_ID),
        ('rAN-UE-NGAP-ID', _UE_associatedLogicalNG_connectionItem_rAN_UE_NGAP_ID),
        ('iE-Extensions', _UE_associatedLogicalNG_connectionItem_iE_Extensions),
        ])
    UE_associatedLogicalNG_connectionItem._ext = []
    
    #-----< UE-associatedLogicalNG-connectionItem-ExtIEs >-----#
    UE_associatedLogicalNG_connectionItem_ExtIEs = CLASS(name='UE-associatedLogicalNG-connectionItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UE_associatedLogicalNG_connectionItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UECapabilityInfoRequest >-----#
    UECapabilityInfoRequest = ENUM(name='UECapabilityInfoRequest', mode=MODE_TYPE)
    UECapabilityInfoRequest._cont = ASN1Dict([('requested', 0)])
    UECapabilityInfoRequest._ext = []
    
    #-----< UEContextRequest >-----#
    UEContextRequest = ENUM(name='UEContextRequest', mode=MODE_TYPE)
    UEContextRequest._cont = ASN1Dict([('requested', 0)])
    UEContextRequest._ext = []
    
    #-----< UEContextResumeRequestTransfer >-----#
    UEContextResumeRequestTransfer = SEQ(name='UEContextResumeRequestTransfer', mode=MODE_TYPE)
    _UEContextResumeRequestTransfer_qosFlowFailedToResumeList = SEQ_OF(name='qosFlowFailedToResumeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithCause')), opt=True)
    _UEContextResumeRequestTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEContextResumeRequestTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UEContextResumeRequestTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____UEContextResumeRequestTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEContextResumeRequestTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEContextResumeRequestTransfer_iE_Extensions__item__id._const_tab = ____UEContextResumeRequestTransfer_iE_Extensions__item__id_tab
    ___UEContextResumeRequestTransfer_iE_Extensions__item__id._const_tab_at = None
    ___UEContextResumeRequestTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___UEContextResumeRequestTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UEContextResumeRequestTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEContextResumeRequestTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEContextResumeRequestTransfer_iE_Extensions__item__criticality._const_tab = ____UEContextResumeRequestTransfer_iE_Extensions__item__criticality_tab
    ___UEContextResumeRequestTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextResumeRequestTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UEContextResumeRequestTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UEContextResumeRequestTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEContextResumeRequestTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEContextResumeRequestTransfer_iE_Extensions__item__extensionValue._const_tab = ____UEContextResumeRequestTransfer_iE_Extensions__item__extensionValue_tab
    ___UEContextResumeRequestTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UEContextResumeRequestTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UEContextResumeRequestTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UEContextResumeRequestTransfer_iE_Extensions__item__id),
        ('criticality', ___UEContextResumeRequestTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___UEContextResumeRequestTransfer_iE_Extensions__item__extensionValue),
        ])
    __UEContextResumeRequestTransfer_iE_Extensions__item_._ext = None
    _UEContextResumeRequestTransfer_iE_Extensions._cont = __UEContextResumeRequestTransfer_iE_Extensions__item_
    _UEContextResumeRequestTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEContextResumeRequestTransfer._cont = ASN1Dict([
        ('qosFlowFailedToResumeList', _UEContextResumeRequestTransfer_qosFlowFailedToResumeList),
        ('iE-Extensions', _UEContextResumeRequestTransfer_iE_Extensions),
        ])
    UEContextResumeRequestTransfer._ext = []
    
    #-----< UEContextResumeRequestTransfer-ExtIEs >-----#
    UEContextResumeRequestTransfer_ExtIEs = CLASS(name='UEContextResumeRequestTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UEContextResumeRequestTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEContextResumeResponseTransfer >-----#
    UEContextResumeResponseTransfer = SEQ(name='UEContextResumeResponseTransfer', mode=MODE_TYPE)
    _UEContextResumeResponseTransfer_qosFlowFailedToResumeList = SEQ_OF(name='qosFlowFailedToResumeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'QosFlowListWithCause')), opt=True)
    _UEContextResumeResponseTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEContextResumeResponseTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UEContextResumeResponseTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____UEContextResumeResponseTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEContextResumeResponseTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEContextResumeResponseTransfer_iE_Extensions__item__id._const_tab = ____UEContextResumeResponseTransfer_iE_Extensions__item__id_tab
    ___UEContextResumeResponseTransfer_iE_Extensions__item__id._const_tab_at = None
    ___UEContextResumeResponseTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___UEContextResumeResponseTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UEContextResumeResponseTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEContextResumeResponseTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEContextResumeResponseTransfer_iE_Extensions__item__criticality._const_tab = ____UEContextResumeResponseTransfer_iE_Extensions__item__criticality_tab
    ___UEContextResumeResponseTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextResumeResponseTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UEContextResumeResponseTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UEContextResumeResponseTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEContextResumeResponseTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEContextResumeResponseTransfer_iE_Extensions__item__extensionValue._const_tab = ____UEContextResumeResponseTransfer_iE_Extensions__item__extensionValue_tab
    ___UEContextResumeResponseTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UEContextResumeResponseTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UEContextResumeResponseTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UEContextResumeResponseTransfer_iE_Extensions__item__id),
        ('criticality', ___UEContextResumeResponseTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___UEContextResumeResponseTransfer_iE_Extensions__item__extensionValue),
        ])
    __UEContextResumeResponseTransfer_iE_Extensions__item_._ext = None
    _UEContextResumeResponseTransfer_iE_Extensions._cont = __UEContextResumeResponseTransfer_iE_Extensions__item_
    _UEContextResumeResponseTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEContextResumeResponseTransfer._cont = ASN1Dict([
        ('qosFlowFailedToResumeList', _UEContextResumeResponseTransfer_qosFlowFailedToResumeList),
        ('iE-Extensions', _UEContextResumeResponseTransfer_iE_Extensions),
        ])
    UEContextResumeResponseTransfer._ext = []
    
    #-----< UEContextResumeResponseTransfer-ExtIEs >-----#
    UEContextResumeResponseTransfer_ExtIEs = CLASS(name='UEContextResumeResponseTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UEContextResumeResponseTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEContextSuspendRequestTransfer >-----#
    UEContextSuspendRequestTransfer = SEQ(name='UEContextSuspendRequestTransfer', mode=MODE_TYPE)
    _UEContextSuspendRequestTransfer_suspendIndicator = ENUM(name='suspendIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SuspendIndicator')), opt=True)
    _UEContextSuspendRequestTransfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEContextSuspendRequestTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UEContextSuspendRequestTransfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____UEContextSuspendRequestTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEContextSuspendRequestTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEContextSuspendRequestTransfer_iE_Extensions__item__id._const_tab = ____UEContextSuspendRequestTransfer_iE_Extensions__item__id_tab
    ___UEContextSuspendRequestTransfer_iE_Extensions__item__id._const_tab_at = None
    ___UEContextSuspendRequestTransfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___UEContextSuspendRequestTransfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UEContextSuspendRequestTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEContextSuspendRequestTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEContextSuspendRequestTransfer_iE_Extensions__item__criticality._const_tab = ____UEContextSuspendRequestTransfer_iE_Extensions__item__criticality_tab
    ___UEContextSuspendRequestTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextSuspendRequestTransfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UEContextSuspendRequestTransfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UEContextSuspendRequestTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEContextSuspendRequestTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEContextSuspendRequestTransfer_iE_Extensions__item__extensionValue._const_tab = ____UEContextSuspendRequestTransfer_iE_Extensions__item__extensionValue_tab
    ___UEContextSuspendRequestTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UEContextSuspendRequestTransfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UEContextSuspendRequestTransfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UEContextSuspendRequestTransfer_iE_Extensions__item__id),
        ('criticality', ___UEContextSuspendRequestTransfer_iE_Extensions__item__criticality),
        ('extensionValue', ___UEContextSuspendRequestTransfer_iE_Extensions__item__extensionValue),
        ])
    __UEContextSuspendRequestTransfer_iE_Extensions__item_._ext = None
    _UEContextSuspendRequestTransfer_iE_Extensions._cont = __UEContextSuspendRequestTransfer_iE_Extensions__item_
    _UEContextSuspendRequestTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEContextSuspendRequestTransfer._cont = ASN1Dict([
        ('suspendIndicator', _UEContextSuspendRequestTransfer_suspendIndicator),
        ('iE-Extensions', _UEContextSuspendRequestTransfer_iE_Extensions),
        ])
    UEContextSuspendRequestTransfer._ext = []
    
    #-----< UEContextSuspendRequestTransfer-ExtIEs >-----#
    UEContextSuspendRequestTransfer_ExtIEs = CLASS(name='UEContextSuspendRequestTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UEContextSuspendRequestTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-DifferentiationInfo >-----#
    UE_DifferentiationInfo = SEQ(name='UE-DifferentiationInfo', mode=MODE_TYPE)
    _UE_DifferentiationInfo_periodicCommunicationIndicator = ENUM(name='periodicCommunicationIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UE_DifferentiationInfo_periodicCommunicationIndicator._cont = ASN1Dict([('periodically', 0), ('ondemand', 1)])
    _UE_DifferentiationInfo_periodicCommunicationIndicator._ext = []
    _UE_DifferentiationInfo_periodicTime = INT(name='periodicTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UE_DifferentiationInfo_periodicTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3600)], ev=[], er=[])
    _UE_DifferentiationInfo_scheduledCommunicationTime = SEQ(name='scheduledCommunicationTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'ScheduledCommunicationTime')), opt=True)
    _UE_DifferentiationInfo_stationaryIndication = ENUM(name='stationaryIndication', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UE_DifferentiationInfo_stationaryIndication._cont = ASN1Dict([('stationary', 0), ('mobile', 1)])
    _UE_DifferentiationInfo_stationaryIndication._ext = []
    _UE_DifferentiationInfo_trafficProfile = ENUM(name='trafficProfile', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UE_DifferentiationInfo_trafficProfile._cont = ASN1Dict([('single-packet', 0), ('dual-packets', 1), ('multiple-packets', 2)])
    _UE_DifferentiationInfo_trafficProfile._ext = []
    _UE_DifferentiationInfo_batteryIndication = ENUM(name='batteryIndication', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UE_DifferentiationInfo_batteryIndication._cont = ASN1Dict([('battery-powered', 0), ('battery-powered-not-rechargeable-or-replaceable', 1), ('not-battery-powered', 2)])
    _UE_DifferentiationInfo_batteryIndication._ext = []
    _UE_DifferentiationInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_DifferentiationInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UE_DifferentiationInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_DifferentiationInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UE_DifferentiationInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_DifferentiationInfo_iE_Extensions__item__id._const_tab = ____UE_DifferentiationInfo_iE_Extensions__item__id_tab
    ___UE_DifferentiationInfo_iE_Extensions__item__id._const_tab_at = None
    ___UE_DifferentiationInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_DifferentiationInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UE_DifferentiationInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UE_DifferentiationInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_DifferentiationInfo_iE_Extensions__item__criticality._const_tab = ____UE_DifferentiationInfo_iE_Extensions__item__criticality_tab
    ___UE_DifferentiationInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_DifferentiationInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_DifferentiationInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UE_DifferentiationInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UE_DifferentiationInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_DifferentiationInfo_iE_Extensions__item__extensionValue._const_tab = ____UE_DifferentiationInfo_iE_Extensions__item__extensionValue_tab
    ___UE_DifferentiationInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_DifferentiationInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_DifferentiationInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_DifferentiationInfo_iE_Extensions__item__id),
        ('criticality', ___UE_DifferentiationInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_DifferentiationInfo_iE_Extensions__item__extensionValue),
        ])
    __UE_DifferentiationInfo_iE_Extensions__item_._ext = None
    _UE_DifferentiationInfo_iE_Extensions._cont = __UE_DifferentiationInfo_iE_Extensions__item_
    _UE_DifferentiationInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_DifferentiationInfo._cont = ASN1Dict([
        ('periodicCommunicationIndicator', _UE_DifferentiationInfo_periodicCommunicationIndicator),
        ('periodicTime', _UE_DifferentiationInfo_periodicTime),
        ('scheduledCommunicationTime', _UE_DifferentiationInfo_scheduledCommunicationTime),
        ('stationaryIndication', _UE_DifferentiationInfo_stationaryIndication),
        ('trafficProfile', _UE_DifferentiationInfo_trafficProfile),
        ('batteryIndication', _UE_DifferentiationInfo_batteryIndication),
        ('iE-Extensions', _UE_DifferentiationInfo_iE_Extensions),
        ])
    UE_DifferentiationInfo._ext = []
    
    #-----< UE-DifferentiationInfo-ExtIEs >-----#
    UE_DifferentiationInfo_ExtIEs = CLASS(name='UE-DifferentiationInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UE_DifferentiationInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEHistoryInformation >-----#
    UEHistoryInformation = SEQ_OF(name='UEHistoryInformation', mode=MODE_TYPE)
    _UEHistoryInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LastVisitedCellItem')))
    UEHistoryInformation._cont = _UEHistoryInformation__item_
    UEHistoryInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< UEHistoryInformationFromTheUE >-----#
    UEHistoryInformationFromTheUE = CHOICE(name='UEHistoryInformationFromTheUE', mode=MODE_TYPE)
    _UEHistoryInformationFromTheUE_nR = OCT_STR(name='nR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NRMobilityHistoryReport')))
    _UEHistoryInformationFromTheUE_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __UEHistoryInformationFromTheUE_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___UEHistoryInformationFromTheUE_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UEHistoryInformationFromTheUE_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UEHistoryInformationFromTheUE_choice_Extensions_id._const_tab = ___UEHistoryInformationFromTheUE_choice_Extensions_id_tab
    __UEHistoryInformationFromTheUE_choice_Extensions_id._const_tab_at = None
    __UEHistoryInformationFromTheUE_choice_Extensions_id._const_tab_id = 'id'
    __UEHistoryInformationFromTheUE_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UEHistoryInformationFromTheUE_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UEHistoryInformationFromTheUE_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UEHistoryInformationFromTheUE_choice_Extensions_criticality._const_tab = ___UEHistoryInformationFromTheUE_choice_Extensions_criticality_tab
    __UEHistoryInformationFromTheUE_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __UEHistoryInformationFromTheUE_choice_Extensions_criticality._const_tab_id = 'criticality'
    __UEHistoryInformationFromTheUE_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UEHistoryInformationFromTheUE_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UEHistoryInformationFromTheUE_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UEHistoryInformationFromTheUE_choice_Extensions_value._const_tab = ___UEHistoryInformationFromTheUE_choice_Extensions_value_tab
    __UEHistoryInformationFromTheUE_choice_Extensions_value._const_tab_at = ('..', 'id')
    __UEHistoryInformationFromTheUE_choice_Extensions_value._const_tab_id = 'Value'
    _UEHistoryInformationFromTheUE_choice_Extensions._cont = ASN1Dict([
        ('id', __UEHistoryInformationFromTheUE_choice_Extensions_id),
        ('criticality', __UEHistoryInformationFromTheUE_choice_Extensions_criticality),
        ('value', __UEHistoryInformationFromTheUE_choice_Extensions_value),
        ])
    _UEHistoryInformationFromTheUE_choice_Extensions._ext = None
    UEHistoryInformationFromTheUE._cont = ASN1Dict([
        ('nR', _UEHistoryInformationFromTheUE_nR),
        ('choice-Extensions', _UEHistoryInformationFromTheUE_choice_Extensions),
        ])
    UEHistoryInformationFromTheUE._ext = None
    
    #-----< UEHistoryInformationFromTheUE-ExtIEs >-----#
    UEHistoryInformationFromTheUE_ExtIEs = CLASS(name='UEHistoryInformationFromTheUE-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    UEHistoryInformationFromTheUE_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEIdentityIndexValue >-----#
    UEIdentityIndexValue = CHOICE(name='UEIdentityIndexValue', mode=MODE_TYPE)
    _UEIdentityIndexValue_indexLength10 = BIT_STR(name='indexLength10', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UEIdentityIndexValue_indexLength10._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _UEIdentityIndexValue_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __UEIdentityIndexValue_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___UEIdentityIndexValue_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UEIdentityIndexValue_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UEIdentityIndexValue_choice_Extensions_id._const_tab = ___UEIdentityIndexValue_choice_Extensions_id_tab
    __UEIdentityIndexValue_choice_Extensions_id._const_tab_at = None
    __UEIdentityIndexValue_choice_Extensions_id._const_tab_id = 'id'
    __UEIdentityIndexValue_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UEIdentityIndexValue_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UEIdentityIndexValue_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UEIdentityIndexValue_choice_Extensions_criticality._const_tab = ___UEIdentityIndexValue_choice_Extensions_criticality_tab
    __UEIdentityIndexValue_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __UEIdentityIndexValue_choice_Extensions_criticality._const_tab_id = 'criticality'
    __UEIdentityIndexValue_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UEIdentityIndexValue_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UEIdentityIndexValue_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UEIdentityIndexValue_choice_Extensions_value._const_tab = ___UEIdentityIndexValue_choice_Extensions_value_tab
    __UEIdentityIndexValue_choice_Extensions_value._const_tab_at = ('..', 'id')
    __UEIdentityIndexValue_choice_Extensions_value._const_tab_id = 'Value'
    _UEIdentityIndexValue_choice_Extensions._cont = ASN1Dict([
        ('id', __UEIdentityIndexValue_choice_Extensions_id),
        ('criticality', __UEIdentityIndexValue_choice_Extensions_criticality),
        ('value', __UEIdentityIndexValue_choice_Extensions_value),
        ])
    _UEIdentityIndexValue_choice_Extensions._ext = None
    UEIdentityIndexValue._cont = ASN1Dict([
        ('indexLength10', _UEIdentityIndexValue_indexLength10),
        ('choice-Extensions', _UEIdentityIndexValue_choice_Extensions),
        ])
    UEIdentityIndexValue._ext = None
    
    #-----< UEIdentityIndexValue-ExtIEs >-----#
    UEIdentityIndexValue_ExtIEs = CLASS(name='UEIdentityIndexValue-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    UEIdentityIndexValue_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-NGAP-IDs >-----#
    UE_NGAP_IDs = CHOICE(name='UE-NGAP-IDs', mode=MODE_TYPE)
    _UE_NGAP_IDs_uE_NGAP_ID_pair = SEQ(name='uE-NGAP-ID-pair', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UE-NGAP-ID-pair')))
    _UE_NGAP_IDs_aMF_UE_NGAP_ID = INT(name='aMF-UE-NGAP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UE_NGAP_IDs_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __UE_NGAP_IDs_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___UE_NGAP_IDs_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UE_NGAP_IDs_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UE_NGAP_IDs_choice_Extensions_id._const_tab = ___UE_NGAP_IDs_choice_Extensions_id_tab
    __UE_NGAP_IDs_choice_Extensions_id._const_tab_at = None
    __UE_NGAP_IDs_choice_Extensions_id._const_tab_id = 'id'
    __UE_NGAP_IDs_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UE_NGAP_IDs_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UE_NGAP_IDs_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UE_NGAP_IDs_choice_Extensions_criticality._const_tab = ___UE_NGAP_IDs_choice_Extensions_criticality_tab
    __UE_NGAP_IDs_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __UE_NGAP_IDs_choice_Extensions_criticality._const_tab_id = 'criticality'
    __UE_NGAP_IDs_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UE_NGAP_IDs_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UE_NGAP_IDs_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UE_NGAP_IDs_choice_Extensions_value._const_tab = ___UE_NGAP_IDs_choice_Extensions_value_tab
    __UE_NGAP_IDs_choice_Extensions_value._const_tab_at = ('..', 'id')
    __UE_NGAP_IDs_choice_Extensions_value._const_tab_id = 'Value'
    _UE_NGAP_IDs_choice_Extensions._cont = ASN1Dict([
        ('id', __UE_NGAP_IDs_choice_Extensions_id),
        ('criticality', __UE_NGAP_IDs_choice_Extensions_criticality),
        ('value', __UE_NGAP_IDs_choice_Extensions_value),
        ])
    _UE_NGAP_IDs_choice_Extensions._ext = None
    UE_NGAP_IDs._cont = ASN1Dict([
        ('uE-NGAP-ID-pair', _UE_NGAP_IDs_uE_NGAP_ID_pair),
        ('aMF-UE-NGAP-ID', _UE_NGAP_IDs_aMF_UE_NGAP_ID),
        ('choice-Extensions', _UE_NGAP_IDs_choice_Extensions),
        ])
    UE_NGAP_IDs._ext = None
    
    #-----< UE-NGAP-IDs-ExtIEs >-----#
    UE_NGAP_IDs_ExtIEs = CLASS(name='UE-NGAP-IDs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    UE_NGAP_IDs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-NGAP-ID-pair >-----#
    UE_NGAP_ID_pair = SEQ(name='UE-NGAP-ID-pair', mode=MODE_TYPE)
    _UE_NGAP_ID_pair_aMF_UE_NGAP_ID = INT(name='aMF-UE-NGAP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UE_NGAP_ID_pair_rAN_UE_NGAP_ID = INT(name='rAN-UE-NGAP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UE_NGAP_ID_pair_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_NGAP_ID_pair_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UE_NGAP_ID_pair_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_NGAP_ID_pair_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UE_NGAP_ID_pair_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_NGAP_ID_pair_iE_Extensions__item__id._const_tab = ____UE_NGAP_ID_pair_iE_Extensions__item__id_tab
    ___UE_NGAP_ID_pair_iE_Extensions__item__id._const_tab_at = None
    ___UE_NGAP_ID_pair_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_NGAP_ID_pair_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UE_NGAP_ID_pair_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UE_NGAP_ID_pair_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_NGAP_ID_pair_iE_Extensions__item__criticality._const_tab = ____UE_NGAP_ID_pair_iE_Extensions__item__criticality_tab
    ___UE_NGAP_ID_pair_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_NGAP_ID_pair_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_NGAP_ID_pair_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UE_NGAP_ID_pair_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UE_NGAP_ID_pair_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_NGAP_ID_pair_iE_Extensions__item__extensionValue._const_tab = ____UE_NGAP_ID_pair_iE_Extensions__item__extensionValue_tab
    ___UE_NGAP_ID_pair_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_NGAP_ID_pair_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_NGAP_ID_pair_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_NGAP_ID_pair_iE_Extensions__item__id),
        ('criticality', ___UE_NGAP_ID_pair_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_NGAP_ID_pair_iE_Extensions__item__extensionValue),
        ])
    __UE_NGAP_ID_pair_iE_Extensions__item_._ext = None
    _UE_NGAP_ID_pair_iE_Extensions._cont = __UE_NGAP_ID_pair_iE_Extensions__item_
    _UE_NGAP_ID_pair_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_NGAP_ID_pair._cont = ASN1Dict([
        ('aMF-UE-NGAP-ID', _UE_NGAP_ID_pair_aMF_UE_NGAP_ID),
        ('rAN-UE-NGAP-ID', _UE_NGAP_ID_pair_rAN_UE_NGAP_ID),
        ('iE-Extensions', _UE_NGAP_ID_pair_iE_Extensions),
        ])
    UE_NGAP_ID_pair._ext = []
    
    #-----< UE-NGAP-ID-pair-ExtIEs >-----#
    UE_NGAP_ID_pair_ExtIEs = CLASS(name='UE-NGAP-ID-pair-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UE_NGAP_ID_pair_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEPagingIdentity >-----#
    UEPagingIdentity = CHOICE(name='UEPagingIdentity', mode=MODE_TYPE)
    _UEPagingIdentity_fiveG_S_TMSI = SEQ(name='fiveG-S-TMSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'FiveG-S-TMSI')))
    _UEPagingIdentity_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __UEPagingIdentity_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___UEPagingIdentity_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UEPagingIdentity_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UEPagingIdentity_choice_Extensions_id._const_tab = ___UEPagingIdentity_choice_Extensions_id_tab
    __UEPagingIdentity_choice_Extensions_id._const_tab_at = None
    __UEPagingIdentity_choice_Extensions_id._const_tab_id = 'id'
    __UEPagingIdentity_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UEPagingIdentity_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UEPagingIdentity_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UEPagingIdentity_choice_Extensions_criticality._const_tab = ___UEPagingIdentity_choice_Extensions_criticality_tab
    __UEPagingIdentity_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __UEPagingIdentity_choice_Extensions_criticality._const_tab_id = 'criticality'
    __UEPagingIdentity_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UEPagingIdentity_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UEPagingIdentity_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UEPagingIdentity_choice_Extensions_value._const_tab = ___UEPagingIdentity_choice_Extensions_value_tab
    __UEPagingIdentity_choice_Extensions_value._const_tab_at = ('..', 'id')
    __UEPagingIdentity_choice_Extensions_value._const_tab_id = 'Value'
    _UEPagingIdentity_choice_Extensions._cont = ASN1Dict([
        ('id', __UEPagingIdentity_choice_Extensions_id),
        ('criticality', __UEPagingIdentity_choice_Extensions_criticality),
        ('value', __UEPagingIdentity_choice_Extensions_value),
        ])
    _UEPagingIdentity_choice_Extensions._ext = None
    UEPagingIdentity._cont = ASN1Dict([
        ('fiveG-S-TMSI', _UEPagingIdentity_fiveG_S_TMSI),
        ('choice-Extensions', _UEPagingIdentity_choice_Extensions),
        ])
    UEPagingIdentity._ext = None
    
    #-----< UEPagingIdentity-ExtIEs >-----#
    UEPagingIdentity_ExtIEs = CLASS(name='UEPagingIdentity-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    UEPagingIdentity_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEPresence >-----#
    UEPresence = ENUM(name='UEPresence', mode=MODE_TYPE)
    UEPresence._cont = ASN1Dict([('in', 0), ('out', 1), ('unknown', 2)])
    UEPresence._ext = []
    
    #-----< UEPresenceInAreaOfInterestList >-----#
    UEPresenceInAreaOfInterestList = SEQ_OF(name='UEPresenceInAreaOfInterestList', mode=MODE_TYPE)
    _UEPresenceInAreaOfInterestList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEPresenceInAreaOfInterestItem')))
    UEPresenceInAreaOfInterestList._cont = _UEPresenceInAreaOfInterestList__item_
    UEPresenceInAreaOfInterestList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< UEPresenceInAreaOfInterestItem >-----#
    UEPresenceInAreaOfInterestItem = SEQ(name='UEPresenceInAreaOfInterestItem', mode=MODE_TYPE)
    _UEPresenceInAreaOfInterestItem_locationReportingReferenceID = INT(name='locationReportingReferenceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LocationReportingReferenceID')))
    _UEPresenceInAreaOfInterestItem_uEPresence = ENUM(name='uEPresence', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UEPresence')))
    _UEPresenceInAreaOfInterestItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEPresenceInAreaOfInterestItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____UEPresenceInAreaOfInterestItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEPresenceInAreaOfInterestItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__id._const_tab = ____UEPresenceInAreaOfInterestItem_iE_Extensions__item__id_tab
    ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__id._const_tab_at = None
    ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UEPresenceInAreaOfInterestItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEPresenceInAreaOfInterestItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__criticality._const_tab = ____UEPresenceInAreaOfInterestItem_iE_Extensions__item__criticality_tab
    ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UEPresenceInAreaOfInterestItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UEPresenceInAreaOfInterestItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__extensionValue._const_tab = ____UEPresenceInAreaOfInterestItem_iE_Extensions__item__extensionValue_tab
    ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UEPresenceInAreaOfInterestItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__id),
        ('criticality', ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__extensionValue),
        ])
    __UEPresenceInAreaOfInterestItem_iE_Extensions__item_._ext = None
    _UEPresenceInAreaOfInterestItem_iE_Extensions._cont = __UEPresenceInAreaOfInterestItem_iE_Extensions__item_
    _UEPresenceInAreaOfInterestItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEPresenceInAreaOfInterestItem._cont = ASN1Dict([
        ('locationReportingReferenceID', _UEPresenceInAreaOfInterestItem_locationReportingReferenceID),
        ('uEPresence', _UEPresenceInAreaOfInterestItem_uEPresence),
        ('iE-Extensions', _UEPresenceInAreaOfInterestItem_iE_Extensions),
        ])
    UEPresenceInAreaOfInterestItem._ext = []
    
    #-----< UEPresenceInAreaOfInterestItem-ExtIEs >-----#
    UEPresenceInAreaOfInterestItem_ExtIEs = CLASS(name='UEPresenceInAreaOfInterestItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UEPresenceInAreaOfInterestItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UERadioCapability >-----#
    UERadioCapability = OCT_STR(name='UERadioCapability', mode=MODE_TYPE)
    
    #-----< UERadioCapabilityForPaging >-----#
    UERadioCapabilityForPaging = SEQ(name='UERadioCapabilityForPaging', mode=MODE_TYPE)
    _UERadioCapabilityForPaging_uERadioCapabilityForPagingOfNR = OCT_STR(name='uERadioCapabilityForPagingOfNR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityForPagingOfNR')), opt=True)
    _UERadioCapabilityForPaging_uERadioCapabilityForPagingOfEUTRA = OCT_STR(name='uERadioCapabilityForPagingOfEUTRA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityForPagingOfEUTRA')), opt=True)
    _UERadioCapabilityForPaging_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UERadioCapabilityForPaging_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UERadioCapabilityForPaging_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____UERadioCapabilityForPaging_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____UERadioCapabilityForPaging_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityForPagingOfNB-IoT')))
    ____UERadioCapabilityForPaging_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 214), ('criticality', 'ignore'), ('Extension', _____UERadioCapabilityForPaging_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UERadioCapabilityForPaging_iE_Extensions__item__id._const_tab = ____UERadioCapabilityForPaging_iE_Extensions__item__id_tab
    ___UERadioCapabilityForPaging_iE_Extensions__item__id._const_tab_at = None
    ___UERadioCapabilityForPaging_iE_Extensions__item__id._const_tab_id = 'id'
    ___UERadioCapabilityForPaging_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UERadioCapabilityForPaging_iE_Extensions__item__criticality._const_tab = ____UERadioCapabilityForPaging_iE_Extensions__item__id_tab
    ___UERadioCapabilityForPaging_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UERadioCapabilityForPaging_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UERadioCapabilityForPaging_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UERadioCapabilityForPaging_iE_Extensions__item__extensionValue._const_tab = ____UERadioCapabilityForPaging_iE_Extensions__item__id_tab
    ___UERadioCapabilityForPaging_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UERadioCapabilityForPaging_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UERadioCapabilityForPaging_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UERadioCapabilityForPaging_iE_Extensions__item__id),
        ('criticality', ___UERadioCapabilityForPaging_iE_Extensions__item__criticality),
        ('extensionValue', ___UERadioCapabilityForPaging_iE_Extensions__item__extensionValue),
        ])
    __UERadioCapabilityForPaging_iE_Extensions__item_._ext = None
    _UERadioCapabilityForPaging_iE_Extensions._cont = __UERadioCapabilityForPaging_iE_Extensions__item_
    _UERadioCapabilityForPaging_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UERadioCapabilityForPaging._cont = ASN1Dict([
        ('uERadioCapabilityForPagingOfNR', _UERadioCapabilityForPaging_uERadioCapabilityForPagingOfNR),
        ('uERadioCapabilityForPagingOfEUTRA', _UERadioCapabilityForPaging_uERadioCapabilityForPagingOfEUTRA),
        ('iE-Extensions', _UERadioCapabilityForPaging_iE_Extensions),
        ])
    UERadioCapabilityForPaging._ext = []
    
    #-----< UERadioCapabilityForPaging-ExtIEs >-----#
    UERadioCapabilityForPaging_ExtIEs = CLASS(name='UERadioCapabilityForPaging-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _UERadioCapabilityForPaging_ExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityForPagingOfNB-IoT')))
    UERadioCapabilityForPaging_ExtIEs._val = ASN1Set(rv=[dict([('id', 214), ('criticality', 'ignore'), ('Extension', _UERadioCapabilityForPaging_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UERadioCapabilityForPagingOfNB-IoT >-----#
    UERadioCapabilityForPagingOfNB_IoT = OCT_STR(name='UERadioCapabilityForPagingOfNB-IoT', mode=MODE_TYPE)
    
    #-----< UERadioCapabilityForPagingOfNR >-----#
    UERadioCapabilityForPagingOfNR = OCT_STR(name='UERadioCapabilityForPagingOfNR', mode=MODE_TYPE)
    
    #-----< UERadioCapabilityForPagingOfEUTRA >-----#
    UERadioCapabilityForPagingOfEUTRA = OCT_STR(name='UERadioCapabilityForPagingOfEUTRA', mode=MODE_TYPE)
    
    #-----< UERadioCapabilityID >-----#
    UERadioCapabilityID = OCT_STR(name='UERadioCapabilityID', mode=MODE_TYPE)
    
    #-----< UERetentionInformation >-----#
    UERetentionInformation = ENUM(name='UERetentionInformation', mode=MODE_TYPE)
    UERetentionInformation._cont = ASN1Dict([('ues-retained', 0)])
    UERetentionInformation._ext = []
    
    #-----< UERLFReportContainer >-----#
    UERLFReportContainer = CHOICE(name='UERLFReportContainer', mode=MODE_TYPE)
    _UERLFReportContainer_nR = OCT_STR(name='nR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NRUERLFReportContainer')))
    _UERLFReportContainer_lTE = OCT_STR(name='lTE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'LTEUERLFReportContainer')))
    _UERLFReportContainer_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __UERLFReportContainer_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___UERLFReportContainer_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UERLFReportContainer_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UERLFReportContainer_choice_Extensions_id._const_tab = ___UERLFReportContainer_choice_Extensions_id_tab
    __UERLFReportContainer_choice_Extensions_id._const_tab_at = None
    __UERLFReportContainer_choice_Extensions_id._const_tab_id = 'id'
    __UERLFReportContainer_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UERLFReportContainer_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UERLFReportContainer_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UERLFReportContainer_choice_Extensions_criticality._const_tab = ___UERLFReportContainer_choice_Extensions_criticality_tab
    __UERLFReportContainer_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __UERLFReportContainer_choice_Extensions_criticality._const_tab_id = 'criticality'
    __UERLFReportContainer_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UERLFReportContainer_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UERLFReportContainer_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UERLFReportContainer_choice_Extensions_value._const_tab = ___UERLFReportContainer_choice_Extensions_value_tab
    __UERLFReportContainer_choice_Extensions_value._const_tab_at = ('..', 'id')
    __UERLFReportContainer_choice_Extensions_value._const_tab_id = 'Value'
    _UERLFReportContainer_choice_Extensions._cont = ASN1Dict([
        ('id', __UERLFReportContainer_choice_Extensions_id),
        ('criticality', __UERLFReportContainer_choice_Extensions_criticality),
        ('value', __UERLFReportContainer_choice_Extensions_value),
        ])
    _UERLFReportContainer_choice_Extensions._ext = None
    UERLFReportContainer._cont = ASN1Dict([
        ('nR', _UERLFReportContainer_nR),
        ('lTE', _UERLFReportContainer_lTE),
        ('choice-Extensions', _UERLFReportContainer_choice_Extensions),
        ])
    UERLFReportContainer._ext = None
    
    #-----< UERLFReportContainer-ExtIEs >-----#
    UERLFReportContainer_ExtIEs = CLASS(name='UERLFReportContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    UERLFReportContainer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UESecurityCapabilities >-----#
    UESecurityCapabilities = SEQ(name='UESecurityCapabilities', mode=MODE_TYPE)
    _UESecurityCapabilities_nRencryptionAlgorithms = BIT_STR(name='nRencryptionAlgorithms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NRencryptionAlgorithms')))
    _UESecurityCapabilities_nRintegrityProtectionAlgorithms = BIT_STR(name='nRintegrityProtectionAlgorithms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NRintegrityProtectionAlgorithms')))
    _UESecurityCapabilities_eUTRAencryptionAlgorithms = BIT_STR(name='eUTRAencryptionAlgorithms', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRAencryptionAlgorithms')))
    _UESecurityCapabilities_eUTRAintegrityProtectionAlgorithms = BIT_STR(name='eUTRAintegrityProtectionAlgorithms', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRAintegrityProtectionAlgorithms')))
    _UESecurityCapabilities_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UESecurityCapabilities_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UESecurityCapabilities_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____UESecurityCapabilities_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UESecurityCapabilities_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESecurityCapabilities_iE_Extensions__item__id._const_tab = ____UESecurityCapabilities_iE_Extensions__item__id_tab
    ___UESecurityCapabilities_iE_Extensions__item__id._const_tab_at = None
    ___UESecurityCapabilities_iE_Extensions__item__id._const_tab_id = 'id'
    ___UESecurityCapabilities_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UESecurityCapabilities_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UESecurityCapabilities_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESecurityCapabilities_iE_Extensions__item__criticality._const_tab = ____UESecurityCapabilities_iE_Extensions__item__criticality_tab
    ___UESecurityCapabilities_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UESecurityCapabilities_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UESecurityCapabilities_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UESecurityCapabilities_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UESecurityCapabilities_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab = ____UESecurityCapabilities_iE_Extensions__item__extensionValue_tab
    ___UESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UESecurityCapabilities_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UESecurityCapabilities_iE_Extensions__item__id),
        ('criticality', ___UESecurityCapabilities_iE_Extensions__item__criticality),
        ('extensionValue', ___UESecurityCapabilities_iE_Extensions__item__extensionValue),
        ])
    __UESecurityCapabilities_iE_Extensions__item_._ext = None
    _UESecurityCapabilities_iE_Extensions._cont = __UESecurityCapabilities_iE_Extensions__item_
    _UESecurityCapabilities_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UESecurityCapabilities._cont = ASN1Dict([
        ('nRencryptionAlgorithms', _UESecurityCapabilities_nRencryptionAlgorithms),
        ('nRintegrityProtectionAlgorithms', _UESecurityCapabilities_nRintegrityProtectionAlgorithms),
        ('eUTRAencryptionAlgorithms', _UESecurityCapabilities_eUTRAencryptionAlgorithms),
        ('eUTRAintegrityProtectionAlgorithms', _UESecurityCapabilities_eUTRAintegrityProtectionAlgorithms),
        ('iE-Extensions', _UESecurityCapabilities_iE_Extensions),
        ])
    UESecurityCapabilities._ext = []
    
    #-----< UESecurityCapabilities-ExtIEs >-----#
    UESecurityCapabilities_ExtIEs = CLASS(name='UESecurityCapabilities-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UESecurityCapabilities_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UESliceMaximumBitRateList >-----#
    UESliceMaximumBitRateList = SEQ_OF(name='UESliceMaximumBitRateList', mode=MODE_TYPE)
    _UESliceMaximumBitRateList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESliceMaximumBitRateItem')))
    UESliceMaximumBitRateList._cont = _UESliceMaximumBitRateList__item_
    UESliceMaximumBitRateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< UESliceMaximumBitRateItem >-----#
    UESliceMaximumBitRateItem = SEQ(name='UESliceMaximumBitRateItem', mode=MODE_TYPE)
    _UESliceMaximumBitRateItem_s_NSSAI = SEQ(name='s-NSSAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _UESliceMaximumBitRateItem_uESliceMaximumBitRateDL = INT(name='uESliceMaximumBitRateDL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _UESliceMaximumBitRateItem_uESliceMaximumBitRateUL = INT(name='uESliceMaximumBitRateUL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'BitRate')))
    _UESliceMaximumBitRateItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UESliceMaximumBitRateItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UESliceMaximumBitRateItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____UESliceMaximumBitRateItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UESliceMaximumBitRateItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESliceMaximumBitRateItem_iE_Extensions__item__id._const_tab = ____UESliceMaximumBitRateItem_iE_Extensions__item__id_tab
    ___UESliceMaximumBitRateItem_iE_Extensions__item__id._const_tab_at = None
    ___UESliceMaximumBitRateItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UESliceMaximumBitRateItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UESliceMaximumBitRateItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UESliceMaximumBitRateItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESliceMaximumBitRateItem_iE_Extensions__item__criticality._const_tab = ____UESliceMaximumBitRateItem_iE_Extensions__item__criticality_tab
    ___UESliceMaximumBitRateItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UESliceMaximumBitRateItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UESliceMaximumBitRateItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UESliceMaximumBitRateItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UESliceMaximumBitRateItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESliceMaximumBitRateItem_iE_Extensions__item__extensionValue._const_tab = ____UESliceMaximumBitRateItem_iE_Extensions__item__extensionValue_tab
    ___UESliceMaximumBitRateItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UESliceMaximumBitRateItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UESliceMaximumBitRateItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UESliceMaximumBitRateItem_iE_Extensions__item__id),
        ('criticality', ___UESliceMaximumBitRateItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UESliceMaximumBitRateItem_iE_Extensions__item__extensionValue),
        ])
    __UESliceMaximumBitRateItem_iE_Extensions__item_._ext = None
    _UESliceMaximumBitRateItem_iE_Extensions._cont = __UESliceMaximumBitRateItem_iE_Extensions__item_
    _UESliceMaximumBitRateItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UESliceMaximumBitRateItem._cont = ASN1Dict([
        ('s-NSSAI', _UESliceMaximumBitRateItem_s_NSSAI),
        ('uESliceMaximumBitRateDL', _UESliceMaximumBitRateItem_uESliceMaximumBitRateDL),
        ('uESliceMaximumBitRateUL', _UESliceMaximumBitRateItem_uESliceMaximumBitRateUL),
        ('iE-Extensions', _UESliceMaximumBitRateItem_iE_Extensions),
        ])
    UESliceMaximumBitRateItem._ext = []
    
    #-----< UESliceMaximumBitRateItem-ExtIEs >-----#
    UESliceMaximumBitRateItem_ExtIEs = CLASS(name='UESliceMaximumBitRateItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UESliceMaximumBitRateItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-UP-CIoT-Support >-----#
    UE_UP_CIoT_Support = ENUM(name='UE-UP-CIoT-Support', mode=MODE_TYPE)
    UE_UP_CIoT_Support._cont = ASN1Dict([('supported', 0)])
    UE_UP_CIoT_Support._ext = []
    
    #-----< UL-CP-SecurityInformation >-----#
    UL_CP_SecurityInformation = SEQ(name='UL-CP-SecurityInformation', mode=MODE_TYPE)
    _UL_CP_SecurityInformation_ul_NAS_MAC = BIT_STR(name='ul-NAS-MAC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UL-NAS-MAC')))
    _UL_CP_SecurityInformation_ul_NAS_Count = BIT_STR(name='ul-NAS-Count', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UL-NAS-Count')))
    _UL_CP_SecurityInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CP_SecurityInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UL_CP_SecurityInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_CP_SecurityInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UL_CP_SecurityInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CP_SecurityInformation_iE_Extensions__item__id._const_tab = ____UL_CP_SecurityInformation_iE_Extensions__item__id_tab
    ___UL_CP_SecurityInformation_iE_Extensions__item__id._const_tab_at = None
    ___UL_CP_SecurityInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_CP_SecurityInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_CP_SecurityInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UL_CP_SecurityInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CP_SecurityInformation_iE_Extensions__item__criticality._const_tab = ____UL_CP_SecurityInformation_iE_Extensions__item__criticality_tab
    ___UL_CP_SecurityInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_CP_SecurityInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_CP_SecurityInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CP_SecurityInformation_iE_Extensions__item__extensionValue._const_tab = ____UL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab
    ___UL_CP_SecurityInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_CP_SecurityInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_CP_SecurityInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_CP_SecurityInformation_iE_Extensions__item__id),
        ('criticality', ___UL_CP_SecurityInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_CP_SecurityInformation_iE_Extensions__item__extensionValue),
        ])
    __UL_CP_SecurityInformation_iE_Extensions__item_._ext = None
    _UL_CP_SecurityInformation_iE_Extensions._cont = __UL_CP_SecurityInformation_iE_Extensions__item_
    _UL_CP_SecurityInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CP_SecurityInformation._cont = ASN1Dict([
        ('ul-NAS-MAC', _UL_CP_SecurityInformation_ul_NAS_MAC),
        ('ul-NAS-Count', _UL_CP_SecurityInformation_ul_NAS_Count),
        ('iE-Extensions', _UL_CP_SecurityInformation_iE_Extensions),
        ])
    UL_CP_SecurityInformation._ext = []
    
    #-----< UL-CP-SecurityInformation-ExtIEs >-----#
    UL_CP_SecurityInformation_ExtIEs = CLASS(name='UL-CP-SecurityInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UL_CP_SecurityInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-NAS-MAC >-----#
    UL_NAS_MAC = BIT_STR(name='UL-NAS-MAC', mode=MODE_TYPE)
    UL_NAS_MAC._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< UL-NAS-Count >-----#
    UL_NAS_Count = BIT_STR(name='UL-NAS-Count', mode=MODE_TYPE)
    UL_NAS_Count._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    
    #-----< UL-NGU-UP-TNLModifyList >-----#
    UL_NGU_UP_TNLModifyList = SEQ_OF(name='UL-NGU-UP-TNLModifyList', mode=MODE_TYPE)
    _UL_NGU_UP_TNLModifyList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UL-NGU-UP-TNLModifyItem')))
    UL_NGU_UP_TNLModifyList._cont = _UL_NGU_UP_TNLModifyList__item_
    UL_NGU_UP_TNLModifyList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< UL-NGU-UP-TNLModifyItem >-----#
    UL_NGU_UP_TNLModifyItem = SEQ(name='UL-NGU-UP-TNLModifyItem', mode=MODE_TYPE)
    _UL_NGU_UP_TNLModifyItem_uL_NGU_UP_TNLInformation = CHOICE(name='uL-NGU-UP-TNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _UL_NGU_UP_TNLModifyItem_dL_NGU_UP_TNLInformation = CHOICE(name='dL-NGU-UP-TNLInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _UL_NGU_UP_TNLModifyItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_NGU_UP_TNLModifyItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _____UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    ____UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 195), ('criticality', 'ignore'), ('Extension', _____UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 192), ('criticality', 'ignore'), ('Extension', _____UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id._const_tab = ____UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id_tab
    ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id._const_tab_at = None
    ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__criticality._const_tab = ____UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id_tab
    ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__extensionValue._const_tab = ____UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id_tab
    ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_NGU_UP_TNLModifyItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id),
        ('criticality', ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__extensionValue),
        ])
    __UL_NGU_UP_TNLModifyItem_iE_Extensions__item_._ext = None
    _UL_NGU_UP_TNLModifyItem_iE_Extensions._cont = __UL_NGU_UP_TNLModifyItem_iE_Extensions__item_
    _UL_NGU_UP_TNLModifyItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_NGU_UP_TNLModifyItem._cont = ASN1Dict([
        ('uL-NGU-UP-TNLInformation', _UL_NGU_UP_TNLModifyItem_uL_NGU_UP_TNLInformation),
        ('dL-NGU-UP-TNLInformation', _UL_NGU_UP_TNLModifyItem_dL_NGU_UP_TNLInformation),
        ('iE-Extensions', _UL_NGU_UP_TNLModifyItem_iE_Extensions),
        ])
    UL_NGU_UP_TNLModifyItem._ext = []
    
    #-----< UL-NGU-UP-TNLModifyItem-ExtIEs >-----#
    UL_NGU_UP_TNLModifyItem_ExtIEs = CLASS(name='UL-NGU-UP-TNLModifyItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _UL_NGU_UP_TNLModifyItem_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _UL_NGU_UP_TNLModifyItem_ExtIEs_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    UL_NGU_UP_TNLModifyItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 195), ('criticality', 'ignore'), ('Extension', _UL_NGU_UP_TNLModifyItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 192), ('criticality', 'ignore'), ('Extension', _UL_NGU_UP_TNLModifyItem_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UnavailableGUAMIList >-----#
    UnavailableGUAMIList = SEQ_OF(name='UnavailableGUAMIList', mode=MODE_TYPE)
    _UnavailableGUAMIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UnavailableGUAMIItem')))
    UnavailableGUAMIList._cont = _UnavailableGUAMIList__item_
    UnavailableGUAMIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< UnavailableGUAMIItem >-----#
    UnavailableGUAMIItem = SEQ(name='UnavailableGUAMIItem', mode=MODE_TYPE)
    _UnavailableGUAMIItem_gUAMI = SEQ(name='gUAMI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GUAMI')))
    _UnavailableGUAMIItem_timerApproachForGUAMIRemoval = ENUM(name='timerApproachForGUAMIRemoval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TimerApproachForGUAMIRemoval')), opt=True)
    _UnavailableGUAMIItem_backupAMFName = STR_PRINT(name='backupAMFName', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'AMFName')), opt=True)
    _UnavailableGUAMIItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UnavailableGUAMIItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UnavailableGUAMIItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____UnavailableGUAMIItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UnavailableGUAMIItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UnavailableGUAMIItem_iE_Extensions__item__id._const_tab = ____UnavailableGUAMIItem_iE_Extensions__item__id_tab
    ___UnavailableGUAMIItem_iE_Extensions__item__id._const_tab_at = None
    ___UnavailableGUAMIItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UnavailableGUAMIItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UnavailableGUAMIItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UnavailableGUAMIItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UnavailableGUAMIItem_iE_Extensions__item__criticality._const_tab = ____UnavailableGUAMIItem_iE_Extensions__item__criticality_tab
    ___UnavailableGUAMIItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UnavailableGUAMIItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UnavailableGUAMIItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UnavailableGUAMIItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UnavailableGUAMIItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UnavailableGUAMIItem_iE_Extensions__item__extensionValue._const_tab = ____UnavailableGUAMIItem_iE_Extensions__item__extensionValue_tab
    ___UnavailableGUAMIItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UnavailableGUAMIItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UnavailableGUAMIItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UnavailableGUAMIItem_iE_Extensions__item__id),
        ('criticality', ___UnavailableGUAMIItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UnavailableGUAMIItem_iE_Extensions__item__extensionValue),
        ])
    __UnavailableGUAMIItem_iE_Extensions__item_._ext = None
    _UnavailableGUAMIItem_iE_Extensions._cont = __UnavailableGUAMIItem_iE_Extensions__item_
    _UnavailableGUAMIItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UnavailableGUAMIItem._cont = ASN1Dict([
        ('gUAMI', _UnavailableGUAMIItem_gUAMI),
        ('timerApproachForGUAMIRemoval', _UnavailableGUAMIItem_timerApproachForGUAMIRemoval),
        ('backupAMFName', _UnavailableGUAMIItem_backupAMFName),
        ('iE-Extensions', _UnavailableGUAMIItem_iE_Extensions),
        ])
    UnavailableGUAMIItem._ext = []
    
    #-----< UnavailableGUAMIItem-ExtIEs >-----#
    UnavailableGUAMIItem_ExtIEs = CLASS(name='UnavailableGUAMIItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UnavailableGUAMIItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ULForwarding >-----#
    ULForwarding = ENUM(name='ULForwarding', mode=MODE_TYPE)
    ULForwarding._cont = ASN1Dict([('ul-forwarding-proposed', 0)])
    ULForwarding._ext = []
    
    #-----< UpdateFeedback >-----#
    UpdateFeedback = BIT_STR(name='UpdateFeedback', mode=MODE_TYPE)
    UpdateFeedback._const_sz = ASN1Set(rv=[8], rr=[], ev=[], er=[])
    
    #-----< UPTransportLayerInformation >-----#
    UPTransportLayerInformation = CHOICE(name='UPTransportLayerInformation', mode=MODE_TYPE)
    _UPTransportLayerInformation_gTPTunnel = SEQ(name='gTPTunnel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GTPTunnel')))
    _UPTransportLayerInformation_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __UPTransportLayerInformation_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___UPTransportLayerInformation_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UPTransportLayerInformation_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UPTransportLayerInformation_choice_Extensions_id._const_tab = ___UPTransportLayerInformation_choice_Extensions_id_tab
    __UPTransportLayerInformation_choice_Extensions_id._const_tab_at = None
    __UPTransportLayerInformation_choice_Extensions_id._const_tab_id = 'id'
    __UPTransportLayerInformation_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UPTransportLayerInformation_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UPTransportLayerInformation_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UPTransportLayerInformation_choice_Extensions_criticality._const_tab = ___UPTransportLayerInformation_choice_Extensions_criticality_tab
    __UPTransportLayerInformation_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __UPTransportLayerInformation_choice_Extensions_criticality._const_tab_id = 'criticality'
    __UPTransportLayerInformation_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UPTransportLayerInformation_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___UPTransportLayerInformation_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UPTransportLayerInformation_choice_Extensions_value._const_tab = ___UPTransportLayerInformation_choice_Extensions_value_tab
    __UPTransportLayerInformation_choice_Extensions_value._const_tab_at = ('..', 'id')
    __UPTransportLayerInformation_choice_Extensions_value._const_tab_id = 'Value'
    _UPTransportLayerInformation_choice_Extensions._cont = ASN1Dict([
        ('id', __UPTransportLayerInformation_choice_Extensions_id),
        ('criticality', __UPTransportLayerInformation_choice_Extensions_criticality),
        ('value', __UPTransportLayerInformation_choice_Extensions_value),
        ])
    _UPTransportLayerInformation_choice_Extensions._ext = None
    UPTransportLayerInformation._cont = ASN1Dict([
        ('gTPTunnel', _UPTransportLayerInformation_gTPTunnel),
        ('choice-Extensions', _UPTransportLayerInformation_choice_Extensions),
        ])
    UPTransportLayerInformation._ext = None
    
    #-----< UPTransportLayerInformation-ExtIEs >-----#
    UPTransportLayerInformation_ExtIEs = CLASS(name='UPTransportLayerInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    UPTransportLayerInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UPTransportLayerInformationList >-----#
    UPTransportLayerInformationList = SEQ_OF(name='UPTransportLayerInformationList', mode=MODE_TYPE)
    _UPTransportLayerInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationItem')))
    UPTransportLayerInformationList._cont = _UPTransportLayerInformationList__item_
    UPTransportLayerInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< UPTransportLayerInformationItem >-----#
    UPTransportLayerInformationItem = SEQ(name='UPTransportLayerInformationItem', mode=MODE_TYPE)
    _UPTransportLayerInformationItem_nGU_UP_TNLInformation = CHOICE(name='nGU-UP-TNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _UPTransportLayerInformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UPTransportLayerInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UPTransportLayerInformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____UPTransportLayerInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____UPTransportLayerInformationItem_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CommonNetworkInstance')))
    ____UPTransportLayerInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 166), ('criticality', 'ignore'), ('Extension', _____UPTransportLayerInformationItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UPTransportLayerInformationItem_iE_Extensions__item__id._const_tab = ____UPTransportLayerInformationItem_iE_Extensions__item__id_tab
    ___UPTransportLayerInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___UPTransportLayerInformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UPTransportLayerInformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UPTransportLayerInformationItem_iE_Extensions__item__criticality._const_tab = ____UPTransportLayerInformationItem_iE_Extensions__item__id_tab
    ___UPTransportLayerInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UPTransportLayerInformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UPTransportLayerInformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UPTransportLayerInformationItem_iE_Extensions__item__extensionValue._const_tab = ____UPTransportLayerInformationItem_iE_Extensions__item__id_tab
    ___UPTransportLayerInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UPTransportLayerInformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UPTransportLayerInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UPTransportLayerInformationItem_iE_Extensions__item__id),
        ('criticality', ___UPTransportLayerInformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UPTransportLayerInformationItem_iE_Extensions__item__extensionValue),
        ])
    __UPTransportLayerInformationItem_iE_Extensions__item_._ext = None
    _UPTransportLayerInformationItem_iE_Extensions._cont = __UPTransportLayerInformationItem_iE_Extensions__item_
    _UPTransportLayerInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UPTransportLayerInformationItem._cont = ASN1Dict([
        ('nGU-UP-TNLInformation', _UPTransportLayerInformationItem_nGU_UP_TNLInformation),
        ('iE-Extensions', _UPTransportLayerInformationItem_iE_Extensions),
        ])
    UPTransportLayerInformationItem._ext = []
    
    #-----< UPTransportLayerInformationItem-ExtIEs >-----#
    UPTransportLayerInformationItem_ExtIEs = CLASS(name='UPTransportLayerInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _UPTransportLayerInformationItem_ExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CommonNetworkInstance')))
    UPTransportLayerInformationItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 166), ('criticality', 'ignore'), ('Extension', _UPTransportLayerInformationItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UPTransportLayerInformationPairList >-----#
    UPTransportLayerInformationPairList = SEQ_OF(name='UPTransportLayerInformationPairList', mode=MODE_TYPE)
    _UPTransportLayerInformationPairList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformationPairItem')))
    UPTransportLayerInformationPairList._cont = _UPTransportLayerInformationPairList__item_
    UPTransportLayerInformationPairList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< UPTransportLayerInformationPairItem >-----#
    UPTransportLayerInformationPairItem = SEQ(name='UPTransportLayerInformationPairItem', mode=MODE_TYPE)
    _UPTransportLayerInformationPairItem_uL_NGU_UP_TNLInformation = CHOICE(name='uL-NGU-UP-TNLInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _UPTransportLayerInformationPairItem_dL_NGU_UP_TNLInformation = CHOICE(name='dL-NGU-UP-TNLInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UPTransportLayerInformation')))
    _UPTransportLayerInformationPairItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UPTransportLayerInformationPairItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UPTransportLayerInformationPairItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____UPTransportLayerInformationPairItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UPTransportLayerInformationPairItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UPTransportLayerInformationPairItem_iE_Extensions__item__id._const_tab = ____UPTransportLayerInformationPairItem_iE_Extensions__item__id_tab
    ___UPTransportLayerInformationPairItem_iE_Extensions__item__id._const_tab_at = None
    ___UPTransportLayerInformationPairItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UPTransportLayerInformationPairItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UPTransportLayerInformationPairItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UPTransportLayerInformationPairItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UPTransportLayerInformationPairItem_iE_Extensions__item__criticality._const_tab = ____UPTransportLayerInformationPairItem_iE_Extensions__item__criticality_tab
    ___UPTransportLayerInformationPairItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UPTransportLayerInformationPairItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UPTransportLayerInformationPairItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UPTransportLayerInformationPairItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UPTransportLayerInformationPairItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UPTransportLayerInformationPairItem_iE_Extensions__item__extensionValue._const_tab = ____UPTransportLayerInformationPairItem_iE_Extensions__item__extensionValue_tab
    ___UPTransportLayerInformationPairItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UPTransportLayerInformationPairItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UPTransportLayerInformationPairItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UPTransportLayerInformationPairItem_iE_Extensions__item__id),
        ('criticality', ___UPTransportLayerInformationPairItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UPTransportLayerInformationPairItem_iE_Extensions__item__extensionValue),
        ])
    __UPTransportLayerInformationPairItem_iE_Extensions__item_._ext = None
    _UPTransportLayerInformationPairItem_iE_Extensions._cont = __UPTransportLayerInformationPairItem_iE_Extensions__item_
    _UPTransportLayerInformationPairItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UPTransportLayerInformationPairItem._cont = ASN1Dict([
        ('uL-NGU-UP-TNLInformation', _UPTransportLayerInformationPairItem_uL_NGU_UP_TNLInformation),
        ('dL-NGU-UP-TNLInformation', _UPTransportLayerInformationPairItem_dL_NGU_UP_TNLInformation),
        ('iE-Extensions', _UPTransportLayerInformationPairItem_iE_Extensions),
        ])
    UPTransportLayerInformationPairItem._ext = []
    
    #-----< UPTransportLayerInformationPairItem-ExtIEs >-----#
    UPTransportLayerInformationPairItem_ExtIEs = CLASS(name='UPTransportLayerInformationPairItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UPTransportLayerInformationPairItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< URI-address >-----#
    URI_address = STR_VIS(name='URI-address', mode=MODE_TYPE)
    
    #-----< UserLocationInformation >-----#
    UserLocationInformation = CHOICE(name='UserLocationInformation', mode=MODE_TYPE)
    _UserLocationInformation_userLocationInformationEUTRA = SEQ(name='userLocationInformationEUTRA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformationEUTRA')))
    _UserLocationInformation_userLocationInformationNR = SEQ(name='userLocationInformationNR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformationNR')))
    _UserLocationInformation_userLocationInformationN3IWF = SEQ(name='userLocationInformationN3IWF', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformationN3IWF')))
    _UserLocationInformation_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __UserLocationInformation_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___UserLocationInformation_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ____UserLocationInformation_choice_Extensions_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformationTNGF')))
    ____UserLocationInformation_choice_Extensions_id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformationTWIF')))
    ____UserLocationInformation_choice_Extensions_id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformationW-AGF')))
    ___UserLocationInformation_choice_Extensions_id_tab._val = ASN1Set(rv=[dict([('id', 244), ('criticality', 'ignore'), ('Value', ____UserLocationInformation_choice_Extensions_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 248), ('criticality', 'ignore'), ('Value', ____UserLocationInformation_choice_Extensions_id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 243), ('criticality', 'ignore'), ('Value', ____UserLocationInformation_choice_Extensions_id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __UserLocationInformation_choice_Extensions_id._const_tab = ___UserLocationInformation_choice_Extensions_id_tab
    __UserLocationInformation_choice_Extensions_id._const_tab_at = None
    __UserLocationInformation_choice_Extensions_id._const_tab_id = 'id'
    __UserLocationInformation_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    __UserLocationInformation_choice_Extensions_criticality._const_tab = ___UserLocationInformation_choice_Extensions_id_tab
    __UserLocationInformation_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __UserLocationInformation_choice_Extensions_criticality._const_tab_id = 'criticality'
    __UserLocationInformation_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    __UserLocationInformation_choice_Extensions_value._const_tab = ___UserLocationInformation_choice_Extensions_id_tab
    __UserLocationInformation_choice_Extensions_value._const_tab_at = ('..', 'id')
    __UserLocationInformation_choice_Extensions_value._const_tab_id = 'Value'
    _UserLocationInformation_choice_Extensions._cont = ASN1Dict([
        ('id', __UserLocationInformation_choice_Extensions_id),
        ('criticality', __UserLocationInformation_choice_Extensions_criticality),
        ('value', __UserLocationInformation_choice_Extensions_value),
        ])
    _UserLocationInformation_choice_Extensions._ext = None
    UserLocationInformation._cont = ASN1Dict([
        ('userLocationInformationEUTRA', _UserLocationInformation_userLocationInformationEUTRA),
        ('userLocationInformationNR', _UserLocationInformation_userLocationInformationNR),
        ('userLocationInformationN3IWF', _UserLocationInformation_userLocationInformationN3IWF),
        ('choice-Extensions', _UserLocationInformation_choice_Extensions),
        ])
    UserLocationInformation._ext = None
    
    #-----< UserLocationInformation-ExtIEs >-----#
    UserLocationInformation_ExtIEs = CLASS(name='UserLocationInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UserLocationInformation_ExtIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformationTNGF')))
    _UserLocationInformation_ExtIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformationTWIF')))
    _UserLocationInformation_ExtIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformationW-AGF')))
    UserLocationInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 244), ('criticality', 'ignore'), ('Value', _UserLocationInformation_ExtIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 248), ('criticality', 'ignore'), ('Value', _UserLocationInformation_ExtIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 243), ('criticality', 'ignore'), ('Value', _UserLocationInformation_ExtIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UserLocationInformationEUTRA >-----#
    UserLocationInformationEUTRA = SEQ(name='UserLocationInformationEUTRA', mode=MODE_TYPE)
    _UserLocationInformationEUTRA_eUTRA_CGI = SEQ(name='eUTRA-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _UserLocationInformationEUTRA_tAI = SEQ(name='tAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _UserLocationInformationEUTRA_timeStamp = OCT_STR(name='timeStamp', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TimeStamp')), opt=True)
    _UserLocationInformationEUTRA_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UserLocationInformationEUTRA_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UserLocationInformationEUTRA_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____UserLocationInformationEUTRA_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____UserLocationInformationEUTRA_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    ____UserLocationInformationEUTRA_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 149), ('criticality', 'ignore'), ('Extension', _____UserLocationInformationEUTRA_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UserLocationInformationEUTRA_iE_Extensions__item__id._const_tab = ____UserLocationInformationEUTRA_iE_Extensions__item__id_tab
    ___UserLocationInformationEUTRA_iE_Extensions__item__id._const_tab_at = None
    ___UserLocationInformationEUTRA_iE_Extensions__item__id._const_tab_id = 'id'
    ___UserLocationInformationEUTRA_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UserLocationInformationEUTRA_iE_Extensions__item__criticality._const_tab = ____UserLocationInformationEUTRA_iE_Extensions__item__id_tab
    ___UserLocationInformationEUTRA_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UserLocationInformationEUTRA_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UserLocationInformationEUTRA_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UserLocationInformationEUTRA_iE_Extensions__item__extensionValue._const_tab = ____UserLocationInformationEUTRA_iE_Extensions__item__id_tab
    ___UserLocationInformationEUTRA_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UserLocationInformationEUTRA_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UserLocationInformationEUTRA_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UserLocationInformationEUTRA_iE_Extensions__item__id),
        ('criticality', ___UserLocationInformationEUTRA_iE_Extensions__item__criticality),
        ('extensionValue', ___UserLocationInformationEUTRA_iE_Extensions__item__extensionValue),
        ])
    __UserLocationInformationEUTRA_iE_Extensions__item_._ext = None
    _UserLocationInformationEUTRA_iE_Extensions._cont = __UserLocationInformationEUTRA_iE_Extensions__item_
    _UserLocationInformationEUTRA_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UserLocationInformationEUTRA._cont = ASN1Dict([
        ('eUTRA-CGI', _UserLocationInformationEUTRA_eUTRA_CGI),
        ('tAI', _UserLocationInformationEUTRA_tAI),
        ('timeStamp', _UserLocationInformationEUTRA_timeStamp),
        ('iE-Extensions', _UserLocationInformationEUTRA_iE_Extensions),
        ])
    UserLocationInformationEUTRA._ext = []
    
    #-----< UserLocationInformationEUTRA-ExtIEs >-----#
    UserLocationInformationEUTRA_ExtIEs = CLASS(name='UserLocationInformationEUTRA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _UserLocationInformationEUTRA_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    UserLocationInformationEUTRA_ExtIEs._val = ASN1Set(rv=[dict([('id', 149), ('criticality', 'ignore'), ('Extension', _UserLocationInformationEUTRA_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UserLocationInformationN3IWF >-----#
    UserLocationInformationN3IWF = SEQ(name='UserLocationInformationN3IWF', mode=MODE_TYPE)
    _UserLocationInformationN3IWF_iPAddress = BIT_STR(name='iPAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _UserLocationInformationN3IWF_portNumber = OCT_STR(name='portNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PortNumber')))
    _UserLocationInformationN3IWF_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UserLocationInformationN3IWF_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UserLocationInformationN3IWF_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____UserLocationInformationN3IWF_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____UserLocationInformationN3IWF_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    ____UserLocationInformationN3IWF_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 213), ('criticality', 'ignore'), ('Extension', _____UserLocationInformationN3IWF_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UserLocationInformationN3IWF_iE_Extensions__item__id._const_tab = ____UserLocationInformationN3IWF_iE_Extensions__item__id_tab
    ___UserLocationInformationN3IWF_iE_Extensions__item__id._const_tab_at = None
    ___UserLocationInformationN3IWF_iE_Extensions__item__id._const_tab_id = 'id'
    ___UserLocationInformationN3IWF_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UserLocationInformationN3IWF_iE_Extensions__item__criticality._const_tab = ____UserLocationInformationN3IWF_iE_Extensions__item__id_tab
    ___UserLocationInformationN3IWF_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UserLocationInformationN3IWF_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UserLocationInformationN3IWF_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UserLocationInformationN3IWF_iE_Extensions__item__extensionValue._const_tab = ____UserLocationInformationN3IWF_iE_Extensions__item__id_tab
    ___UserLocationInformationN3IWF_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UserLocationInformationN3IWF_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UserLocationInformationN3IWF_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UserLocationInformationN3IWF_iE_Extensions__item__id),
        ('criticality', ___UserLocationInformationN3IWF_iE_Extensions__item__criticality),
        ('extensionValue', ___UserLocationInformationN3IWF_iE_Extensions__item__extensionValue),
        ])
    __UserLocationInformationN3IWF_iE_Extensions__item_._ext = None
    _UserLocationInformationN3IWF_iE_Extensions._cont = __UserLocationInformationN3IWF_iE_Extensions__item_
    _UserLocationInformationN3IWF_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UserLocationInformationN3IWF._cont = ASN1Dict([
        ('iPAddress', _UserLocationInformationN3IWF_iPAddress),
        ('portNumber', _UserLocationInformationN3IWF_portNumber),
        ('iE-Extensions', _UserLocationInformationN3IWF_iE_Extensions),
        ])
    UserLocationInformationN3IWF._ext = []
    
    #-----< UserLocationInformationN3IWF-ExtIEs >-----#
    UserLocationInformationN3IWF_ExtIEs = CLASS(name='UserLocationInformationN3IWF-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _UserLocationInformationN3IWF_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    UserLocationInformationN3IWF_ExtIEs._val = ASN1Set(rv=[dict([('id', 213), ('criticality', 'ignore'), ('Extension', _UserLocationInformationN3IWF_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UserLocationInformationTNGF >-----#
    UserLocationInformationTNGF = SEQ(name='UserLocationInformationTNGF', mode=MODE_TYPE)
    _UserLocationInformationTNGF_tNAP_ID = OCT_STR(name='tNAP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TNAP-ID')))
    _UserLocationInformationTNGF_iPAddress = BIT_STR(name='iPAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _UserLocationInformationTNGF_portNumber = OCT_STR(name='portNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PortNumber')), opt=True)
    _UserLocationInformationTNGF_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UserLocationInformationTNGF_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UserLocationInformationTNGF_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____UserLocationInformationTNGF_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____UserLocationInformationTNGF_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    ____UserLocationInformationTNGF_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 213), ('criticality', 'ignore'), ('Extension', _____UserLocationInformationTNGF_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UserLocationInformationTNGF_iE_Extensions__item__id._const_tab = ____UserLocationInformationTNGF_iE_Extensions__item__id_tab
    ___UserLocationInformationTNGF_iE_Extensions__item__id._const_tab_at = None
    ___UserLocationInformationTNGF_iE_Extensions__item__id._const_tab_id = 'id'
    ___UserLocationInformationTNGF_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UserLocationInformationTNGF_iE_Extensions__item__criticality._const_tab = ____UserLocationInformationTNGF_iE_Extensions__item__id_tab
    ___UserLocationInformationTNGF_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UserLocationInformationTNGF_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UserLocationInformationTNGF_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UserLocationInformationTNGF_iE_Extensions__item__extensionValue._const_tab = ____UserLocationInformationTNGF_iE_Extensions__item__id_tab
    ___UserLocationInformationTNGF_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UserLocationInformationTNGF_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UserLocationInformationTNGF_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UserLocationInformationTNGF_iE_Extensions__item__id),
        ('criticality', ___UserLocationInformationTNGF_iE_Extensions__item__criticality),
        ('extensionValue', ___UserLocationInformationTNGF_iE_Extensions__item__extensionValue),
        ])
    __UserLocationInformationTNGF_iE_Extensions__item_._ext = None
    _UserLocationInformationTNGF_iE_Extensions._cont = __UserLocationInformationTNGF_iE_Extensions__item_
    _UserLocationInformationTNGF_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UserLocationInformationTNGF._cont = ASN1Dict([
        ('tNAP-ID', _UserLocationInformationTNGF_tNAP_ID),
        ('iPAddress', _UserLocationInformationTNGF_iPAddress),
        ('portNumber', _UserLocationInformationTNGF_portNumber),
        ('iE-Extensions', _UserLocationInformationTNGF_iE_Extensions),
        ])
    UserLocationInformationTNGF._ext = []
    
    #-----< UserLocationInformationTNGF-ExtIEs >-----#
    UserLocationInformationTNGF_ExtIEs = CLASS(name='UserLocationInformationTNGF-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _UserLocationInformationTNGF_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    UserLocationInformationTNGF_ExtIEs._val = ASN1Set(rv=[dict([('id', 213), ('criticality', 'ignore'), ('Extension', _UserLocationInformationTNGF_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UserLocationInformationTWIF >-----#
    UserLocationInformationTWIF = SEQ(name='UserLocationInformationTWIF', mode=MODE_TYPE)
    _UserLocationInformationTWIF_tWAP_ID = OCT_STR(name='tWAP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TWAP-ID')))
    _UserLocationInformationTWIF_iPAddress = BIT_STR(name='iPAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _UserLocationInformationTWIF_portNumber = OCT_STR(name='portNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PortNumber')), opt=True)
    _UserLocationInformationTWIF_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UserLocationInformationTWIF_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UserLocationInformationTWIF_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____UserLocationInformationTWIF_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____UserLocationInformationTWIF_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    ____UserLocationInformationTWIF_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 213), ('criticality', 'ignore'), ('Extension', _____UserLocationInformationTWIF_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UserLocationInformationTWIF_iE_Extensions__item__id._const_tab = ____UserLocationInformationTWIF_iE_Extensions__item__id_tab
    ___UserLocationInformationTWIF_iE_Extensions__item__id._const_tab_at = None
    ___UserLocationInformationTWIF_iE_Extensions__item__id._const_tab_id = 'id'
    ___UserLocationInformationTWIF_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UserLocationInformationTWIF_iE_Extensions__item__criticality._const_tab = ____UserLocationInformationTWIF_iE_Extensions__item__id_tab
    ___UserLocationInformationTWIF_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UserLocationInformationTWIF_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UserLocationInformationTWIF_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UserLocationInformationTWIF_iE_Extensions__item__extensionValue._const_tab = ____UserLocationInformationTWIF_iE_Extensions__item__id_tab
    ___UserLocationInformationTWIF_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UserLocationInformationTWIF_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UserLocationInformationTWIF_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UserLocationInformationTWIF_iE_Extensions__item__id),
        ('criticality', ___UserLocationInformationTWIF_iE_Extensions__item__criticality),
        ('extensionValue', ___UserLocationInformationTWIF_iE_Extensions__item__extensionValue),
        ])
    __UserLocationInformationTWIF_iE_Extensions__item_._ext = None
    _UserLocationInformationTWIF_iE_Extensions._cont = __UserLocationInformationTWIF_iE_Extensions__item_
    _UserLocationInformationTWIF_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UserLocationInformationTWIF._cont = ASN1Dict([
        ('tWAP-ID', _UserLocationInformationTWIF_tWAP_ID),
        ('iPAddress', _UserLocationInformationTWIF_iPAddress),
        ('portNumber', _UserLocationInformationTWIF_portNumber),
        ('iE-Extensions', _UserLocationInformationTWIF_iE_Extensions),
        ])
    UserLocationInformationTWIF._ext = []
    
    #-----< UserLocationInformationTWIF-ExtIEs >-----#
    UserLocationInformationTWIF_ExtIEs = CLASS(name='UserLocationInformationTWIF-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _UserLocationInformationTWIF_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    UserLocationInformationTWIF_ExtIEs._val = ASN1Set(rv=[dict([('id', 213), ('criticality', 'ignore'), ('Extension', _UserLocationInformationTWIF_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UserLocationInformationW-AGF >-----#
    UserLocationInformationW_AGF = CHOICE(name='UserLocationInformationW-AGF', mode=MODE_TYPE)
    _UserLocationInformationW_AGF_globalLine_ID = SEQ(name='globalLine-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'GlobalLine-ID')))
    _UserLocationInformationW_AGF_hFCNode_ID = OCT_STR(name='hFCNode-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'HFCNode-ID')))
    _UserLocationInformationW_AGF_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __UserLocationInformationW_AGF_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___UserLocationInformationW_AGF_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ____UserLocationInformationW_AGF_choice_Extensions_id_tab_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalCable-ID')))
    ____UserLocationInformationW_AGF_choice_Extensions_id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HFCNode-ID-new')))
    ____UserLocationInformationW_AGF_choice_Extensions_id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalCable-ID-new')))
    ___UserLocationInformationW_AGF_choice_Extensions_id_tab._val = ASN1Set(rv=[dict([('id', 275), ('criticality', 'ignore'), ('Value', ____UserLocationInformationW_AGF_choice_Extensions_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 362), ('criticality', 'ignore'), ('Value', ____UserLocationInformationW_AGF_choice_Extensions_id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 363), ('criticality', 'ignore'), ('Value', ____UserLocationInformationW_AGF_choice_Extensions_id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __UserLocationInformationW_AGF_choice_Extensions_id._const_tab = ___UserLocationInformationW_AGF_choice_Extensions_id_tab
    __UserLocationInformationW_AGF_choice_Extensions_id._const_tab_at = None
    __UserLocationInformationW_AGF_choice_Extensions_id._const_tab_id = 'id'
    __UserLocationInformationW_AGF_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    __UserLocationInformationW_AGF_choice_Extensions_criticality._const_tab = ___UserLocationInformationW_AGF_choice_Extensions_id_tab
    __UserLocationInformationW_AGF_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __UserLocationInformationW_AGF_choice_Extensions_criticality._const_tab_id = 'criticality'
    __UserLocationInformationW_AGF_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    __UserLocationInformationW_AGF_choice_Extensions_value._const_tab = ___UserLocationInformationW_AGF_choice_Extensions_id_tab
    __UserLocationInformationW_AGF_choice_Extensions_value._const_tab_at = ('..', 'id')
    __UserLocationInformationW_AGF_choice_Extensions_value._const_tab_id = 'Value'
    _UserLocationInformationW_AGF_choice_Extensions._cont = ASN1Dict([
        ('id', __UserLocationInformationW_AGF_choice_Extensions_id),
        ('criticality', __UserLocationInformationW_AGF_choice_Extensions_criticality),
        ('value', __UserLocationInformationW_AGF_choice_Extensions_value),
        ])
    _UserLocationInformationW_AGF_choice_Extensions._ext = None
    UserLocationInformationW_AGF._cont = ASN1Dict([
        ('globalLine-ID', _UserLocationInformationW_AGF_globalLine_ID),
        ('hFCNode-ID', _UserLocationInformationW_AGF_hFCNode_ID),
        ('choice-Extensions', _UserLocationInformationW_AGF_choice_Extensions),
        ])
    UserLocationInformationW_AGF._ext = None
    
    #-----< UserLocationInformationW-AGF-ExtIEs >-----#
    UserLocationInformationW_AGF_ExtIEs = CLASS(name='UserLocationInformationW-AGF-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UserLocationInformationW_AGF_ExtIEs_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalCable-ID')))
    _UserLocationInformationW_AGF_ExtIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HFCNode-ID-new')))
    _UserLocationInformationW_AGF_ExtIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalCable-ID-new')))
    UserLocationInformationW_AGF_ExtIEs._val = ASN1Set(rv=[dict([('id', 275), ('criticality', 'ignore'), ('Value', _UserLocationInformationW_AGF_ExtIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 362), ('criticality', 'ignore'), ('Value', _UserLocationInformationW_AGF_ExtIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 363), ('criticality', 'ignore'), ('Value', _UserLocationInformationW_AGF_ExtIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UserLocationInformationNR >-----#
    UserLocationInformationNR = SEQ(name='UserLocationInformationNR', mode=MODE_TYPE)
    _UserLocationInformationNR_nR_CGI = SEQ(name='nR-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NR-CGI')))
    _UserLocationInformationNR_tAI = SEQ(name='tAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _UserLocationInformationNR_timeStamp = OCT_STR(name='timeStamp', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TimeStamp')), opt=True)
    _UserLocationInformationNR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UserLocationInformationNR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UserLocationInformationNR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____UserLocationInformationNR_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____UserLocationInformationNR_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _____UserLocationInformationNR_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NID')))
    _____UserLocationInformationNR_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRNTNTAIInformation')))
    ____UserLocationInformationNR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 149), ('criticality', 'ignore'), ('Extension', _____UserLocationInformationNR_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 263), ('criticality', 'reject'), ('Extension', _____UserLocationInformationNR_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 287), ('criticality', 'ignore'), ('Extension', _____UserLocationInformationNR_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UserLocationInformationNR_iE_Extensions__item__id._const_tab = ____UserLocationInformationNR_iE_Extensions__item__id_tab
    ___UserLocationInformationNR_iE_Extensions__item__id._const_tab_at = None
    ___UserLocationInformationNR_iE_Extensions__item__id._const_tab_id = 'id'
    ___UserLocationInformationNR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UserLocationInformationNR_iE_Extensions__item__criticality._const_tab = ____UserLocationInformationNR_iE_Extensions__item__id_tab
    ___UserLocationInformationNR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UserLocationInformationNR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UserLocationInformationNR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UserLocationInformationNR_iE_Extensions__item__extensionValue._const_tab = ____UserLocationInformationNR_iE_Extensions__item__id_tab
    ___UserLocationInformationNR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UserLocationInformationNR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UserLocationInformationNR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UserLocationInformationNR_iE_Extensions__item__id),
        ('criticality', ___UserLocationInformationNR_iE_Extensions__item__criticality),
        ('extensionValue', ___UserLocationInformationNR_iE_Extensions__item__extensionValue),
        ])
    __UserLocationInformationNR_iE_Extensions__item_._ext = None
    _UserLocationInformationNR_iE_Extensions._cont = __UserLocationInformationNR_iE_Extensions__item_
    _UserLocationInformationNR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UserLocationInformationNR._cont = ASN1Dict([
        ('nR-CGI', _UserLocationInformationNR_nR_CGI),
        ('tAI', _UserLocationInformationNR_tAI),
        ('timeStamp', _UserLocationInformationNR_timeStamp),
        ('iE-Extensions', _UserLocationInformationNR_iE_Extensions),
        ])
    UserLocationInformationNR._ext = []
    
    #-----< UserLocationInformationNR-ExtIEs >-----#
    UserLocationInformationNR_ExtIEs = CLASS(name='UserLocationInformationNR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _UserLocationInformationNR_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _UserLocationInformationNR_ExtIEs_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NID')))
    _UserLocationInformationNR_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRNTNTAIInformation')))
    UserLocationInformationNR_ExtIEs._val = ASN1Set(rv=[dict([('id', 149), ('criticality', 'ignore'), ('Extension', _UserLocationInformationNR_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 263), ('criticality', 'reject'), ('Extension', _UserLocationInformationNR_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 287), ('criticality', 'ignore'), ('Extension', _UserLocationInformationNR_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UserPlaneSecurityInformation >-----#
    UserPlaneSecurityInformation = SEQ(name='UserPlaneSecurityInformation', mode=MODE_TYPE)
    _UserPlaneSecurityInformation_securityResult = SEQ(name='securityResult', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SecurityResult')))
    _UserPlaneSecurityInformation_securityIndication = SEQ(name='securityIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'SecurityIndication')))
    _UserPlaneSecurityInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UserPlaneSecurityInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___UserPlaneSecurityInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____UserPlaneSecurityInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UserPlaneSecurityInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserPlaneSecurityInformation_iE_Extensions__item__id._const_tab = ____UserPlaneSecurityInformation_iE_Extensions__item__id_tab
    ___UserPlaneSecurityInformation_iE_Extensions__item__id._const_tab_at = None
    ___UserPlaneSecurityInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___UserPlaneSecurityInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UserPlaneSecurityInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UserPlaneSecurityInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserPlaneSecurityInformation_iE_Extensions__item__criticality._const_tab = ____UserPlaneSecurityInformation_iE_Extensions__item__criticality_tab
    ___UserPlaneSecurityInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UserPlaneSecurityInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UserPlaneSecurityInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UserPlaneSecurityInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____UserPlaneSecurityInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserPlaneSecurityInformation_iE_Extensions__item__extensionValue._const_tab = ____UserPlaneSecurityInformation_iE_Extensions__item__extensionValue_tab
    ___UserPlaneSecurityInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UserPlaneSecurityInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UserPlaneSecurityInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UserPlaneSecurityInformation_iE_Extensions__item__id),
        ('criticality', ___UserPlaneSecurityInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___UserPlaneSecurityInformation_iE_Extensions__item__extensionValue),
        ])
    __UserPlaneSecurityInformation_iE_Extensions__item_._ext = None
    _UserPlaneSecurityInformation_iE_Extensions._cont = __UserPlaneSecurityInformation_iE_Extensions__item_
    _UserPlaneSecurityInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UserPlaneSecurityInformation._cont = ASN1Dict([
        ('securityResult', _UserPlaneSecurityInformation_securityResult),
        ('securityIndication', _UserPlaneSecurityInformation_securityIndication),
        ('iE-Extensions', _UserPlaneSecurityInformation_iE_Extensions),
        ])
    UserPlaneSecurityInformation._ext = []
    
    #-----< UserPlaneSecurityInformation-ExtIEs >-----#
    UserPlaneSecurityInformation_ExtIEs = CLASS(name='UserPlaneSecurityInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    UserPlaneSecurityInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< VolumeTimedReportList >-----#
    VolumeTimedReportList = SEQ_OF(name='VolumeTimedReportList', mode=MODE_TYPE)
    _VolumeTimedReportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'VolumeTimedReport-Item')))
    VolumeTimedReportList._cont = _VolumeTimedReportList__item_
    VolumeTimedReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< VolumeTimedReport-Item >-----#
    VolumeTimedReport_Item = SEQ(name='VolumeTimedReport-Item', mode=MODE_TYPE)
    _VolumeTimedReport_Item_startTimeStamp = OCT_STR(name='startTimeStamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _VolumeTimedReport_Item_startTimeStamp._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _VolumeTimedReport_Item_endTimeStamp = OCT_STR(name='endTimeStamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _VolumeTimedReport_Item_endTimeStamp._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _VolumeTimedReport_Item_usageCountUL = INT(name='usageCountUL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _VolumeTimedReport_Item_usageCountUL._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=18446744073709551615)], ev=None, er=[])
    _VolumeTimedReport_Item_usageCountDL = INT(name='usageCountDL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _VolumeTimedReport_Item_usageCountDL._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=18446744073709551615)], ev=None, er=[])
    _VolumeTimedReport_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __VolumeTimedReport_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___VolumeTimedReport_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____VolumeTimedReport_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____VolumeTimedReport_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___VolumeTimedReport_Item_iE_Extensions__item__id._const_tab = ____VolumeTimedReport_Item_iE_Extensions__item__id_tab
    ___VolumeTimedReport_Item_iE_Extensions__item__id._const_tab_at = None
    ___VolumeTimedReport_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___VolumeTimedReport_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____VolumeTimedReport_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____VolumeTimedReport_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___VolumeTimedReport_Item_iE_Extensions__item__criticality._const_tab = ____VolumeTimedReport_Item_iE_Extensions__item__criticality_tab
    ___VolumeTimedReport_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___VolumeTimedReport_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___VolumeTimedReport_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____VolumeTimedReport_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____VolumeTimedReport_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___VolumeTimedReport_Item_iE_Extensions__item__extensionValue._const_tab = ____VolumeTimedReport_Item_iE_Extensions__item__extensionValue_tab
    ___VolumeTimedReport_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___VolumeTimedReport_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __VolumeTimedReport_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___VolumeTimedReport_Item_iE_Extensions__item__id),
        ('criticality', ___VolumeTimedReport_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___VolumeTimedReport_Item_iE_Extensions__item__extensionValue),
        ])
    __VolumeTimedReport_Item_iE_Extensions__item_._ext = None
    _VolumeTimedReport_Item_iE_Extensions._cont = __VolumeTimedReport_Item_iE_Extensions__item_
    _VolumeTimedReport_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    VolumeTimedReport_Item._cont = ASN1Dict([
        ('startTimeStamp', _VolumeTimedReport_Item_startTimeStamp),
        ('endTimeStamp', _VolumeTimedReport_Item_endTimeStamp),
        ('usageCountUL', _VolumeTimedReport_Item_usageCountUL),
        ('usageCountDL', _VolumeTimedReport_Item_usageCountDL),
        ('iE-Extensions', _VolumeTimedReport_Item_iE_Extensions),
        ])
    VolumeTimedReport_Item._ext = []
    
    #-----< VolumeTimedReport-Item-ExtIEs >-----#
    VolumeTimedReport_Item_ExtIEs = CLASS(name='VolumeTimedReport-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    VolumeTimedReport_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< W-AGF-ID >-----#
    W_AGF_ID = CHOICE(name='W-AGF-ID', mode=MODE_TYPE)
    _W_AGF_ID_w_AGF_ID = BIT_STR(name='w-AGF-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _W_AGF_ID_w_AGF_ID._const_sz = ASN1Set(rv=[16], rr=[], ev=[], er=[])
    _W_AGF_ID_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __W_AGF_ID_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___W_AGF_ID_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___W_AGF_ID_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __W_AGF_ID_choice_Extensions_id._const_tab = ___W_AGF_ID_choice_Extensions_id_tab
    __W_AGF_ID_choice_Extensions_id._const_tab_at = None
    __W_AGF_ID_choice_Extensions_id._const_tab_id = 'id'
    __W_AGF_ID_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___W_AGF_ID_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___W_AGF_ID_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __W_AGF_ID_choice_Extensions_criticality._const_tab = ___W_AGF_ID_choice_Extensions_criticality_tab
    __W_AGF_ID_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __W_AGF_ID_choice_Extensions_criticality._const_tab_id = 'criticality'
    __W_AGF_ID_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___W_AGF_ID_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___W_AGF_ID_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __W_AGF_ID_choice_Extensions_value._const_tab = ___W_AGF_ID_choice_Extensions_value_tab
    __W_AGF_ID_choice_Extensions_value._const_tab_at = ('..', 'id')
    __W_AGF_ID_choice_Extensions_value._const_tab_id = 'Value'
    _W_AGF_ID_choice_Extensions._cont = ASN1Dict([
        ('id', __W_AGF_ID_choice_Extensions_id),
        ('criticality', __W_AGF_ID_choice_Extensions_criticality),
        ('value', __W_AGF_ID_choice_Extensions_value),
        ])
    _W_AGF_ID_choice_Extensions._ext = None
    W_AGF_ID._cont = ASN1Dict([
        ('w-AGF-ID', _W_AGF_ID_w_AGF_ID),
        ('choice-Extensions', _W_AGF_ID_choice_Extensions),
        ])
    W_AGF_ID._ext = None
    
    #-----< W-AGF-ID-ExtIEs >-----#
    W_AGF_ID_ExtIEs = CLASS(name='W-AGF-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    W_AGF_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WarningAreaCoordinates >-----#
    WarningAreaCoordinates = OCT_STR(name='WarningAreaCoordinates', mode=MODE_TYPE)
    WarningAreaCoordinates._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< WarningAreaList >-----#
    WarningAreaList = CHOICE(name='WarningAreaList', mode=MODE_TYPE)
    _WarningAreaList_eUTRA_CGIListForWarning = SEQ_OF(name='eUTRA-CGIListForWarning', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGIListForWarning')))
    _WarningAreaList_nR_CGIListForWarning = SEQ_OF(name='nR-CGIListForWarning', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'NR-CGIListForWarning')))
    _WarningAreaList_tAIListForWarning = SEQ_OF(name='tAIListForWarning', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TAIListForWarning')))
    _WarningAreaList_emergencyAreaIDList = SEQ_OF(name='emergencyAreaIDList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaIDList')))
    _WarningAreaList_choice_Extensions = SEQ(name='choice-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-SingleContainer')))
    __WarningAreaList_choice_Extensions_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ___WarningAreaList_choice_Extensions_id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___WarningAreaList_choice_Extensions_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __WarningAreaList_choice_Extensions_id._const_tab = ___WarningAreaList_choice_Extensions_id_tab
    __WarningAreaList_choice_Extensions_id._const_tab_at = None
    __WarningAreaList_choice_Extensions_id._const_tab_id = 'id'
    __WarningAreaList_choice_Extensions_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___WarningAreaList_choice_Extensions_criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___WarningAreaList_choice_Extensions_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __WarningAreaList_choice_Extensions_criticality._const_tab = ___WarningAreaList_choice_Extensions_criticality_tab
    __WarningAreaList_choice_Extensions_criticality._const_tab_at = ('..', 'id')
    __WarningAreaList_choice_Extensions_criticality._const_tab_id = 'criticality'
    __WarningAreaList_choice_Extensions_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___WarningAreaList_choice_Extensions_value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ___WarningAreaList_choice_Extensions_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __WarningAreaList_choice_Extensions_value._const_tab = ___WarningAreaList_choice_Extensions_value_tab
    __WarningAreaList_choice_Extensions_value._const_tab_at = ('..', 'id')
    __WarningAreaList_choice_Extensions_value._const_tab_id = 'Value'
    _WarningAreaList_choice_Extensions._cont = ASN1Dict([
        ('id', __WarningAreaList_choice_Extensions_id),
        ('criticality', __WarningAreaList_choice_Extensions_criticality),
        ('value', __WarningAreaList_choice_Extensions_value),
        ])
    _WarningAreaList_choice_Extensions._ext = None
    WarningAreaList._cont = ASN1Dict([
        ('eUTRA-CGIListForWarning', _WarningAreaList_eUTRA_CGIListForWarning),
        ('nR-CGIListForWarning', _WarningAreaList_nR_CGIListForWarning),
        ('tAIListForWarning', _WarningAreaList_tAIListForWarning),
        ('emergencyAreaIDList', _WarningAreaList_emergencyAreaIDList),
        ('choice-Extensions', _WarningAreaList_choice_Extensions),
        ])
    WarningAreaList._ext = None
    
    #-----< WarningAreaList-ExtIEs >-----#
    WarningAreaList_ExtIEs = CLASS(name='WarningAreaList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    WarningAreaList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WarningMessageContents >-----#
    WarningMessageContents = OCT_STR(name='WarningMessageContents', mode=MODE_TYPE)
    WarningMessageContents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9600)], ev=None, er=[])
    
    #-----< WarningSecurityInfo >-----#
    WarningSecurityInfo = OCT_STR(name='WarningSecurityInfo', mode=MODE_TYPE)
    WarningSecurityInfo._const_sz = ASN1Set(rv=[50], rr=[], ev=None, er=[])
    
    #-----< WarningType >-----#
    WarningType = OCT_STR(name='WarningType', mode=MODE_TYPE)
    WarningType._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< WLANMeasurementConfiguration >-----#
    WLANMeasurementConfiguration = SEQ(name='WLANMeasurementConfiguration', mode=MODE_TYPE)
    _WLANMeasurementConfiguration_wlanMeasConfig = ENUM(name='wlanMeasConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'WLANMeasConfig')))
    _WLANMeasurementConfiguration_wlanMeasConfigNameList = SEQ_OF(name='wlanMeasConfigNameList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'WLANMeasConfigNameList')), opt=True)
    _WLANMeasurementConfiguration_wlan_rssi = ENUM(name='wlan-rssi', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WLANMeasurementConfiguration_wlan_rssi._cont = ASN1Dict([('true', 0)])
    _WLANMeasurementConfiguration_wlan_rssi._ext = []
    _WLANMeasurementConfiguration_wlan_rtt = ENUM(name='wlan-rtt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WLANMeasurementConfiguration_wlan_rtt._cont = ASN1Dict([('true', 0)])
    _WLANMeasurementConfiguration_wlan_rtt._ext = []
    _WLANMeasurementConfiguration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __WLANMeasurementConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___WLANMeasurementConfiguration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____WLANMeasurementConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____WLANMeasurementConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementConfiguration_iE_Extensions__item__id._const_tab = ____WLANMeasurementConfiguration_iE_Extensions__item__id_tab
    ___WLANMeasurementConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___WLANMeasurementConfiguration_iE_Extensions__item__id._const_tab_id = 'id'
    ___WLANMeasurementConfiguration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____WLANMeasurementConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____WLANMeasurementConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementConfiguration_iE_Extensions__item__criticality._const_tab = ____WLANMeasurementConfiguration_iE_Extensions__item__criticality_tab
    ___WLANMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___WLANMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____WLANMeasurementConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____WLANMeasurementConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab = ____WLANMeasurementConfiguration_iE_Extensions__item__extensionValue_tab
    ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __WLANMeasurementConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___WLANMeasurementConfiguration_iE_Extensions__item__id),
        ('criticality', ___WLANMeasurementConfiguration_iE_Extensions__item__criticality),
        ('extensionValue', ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue),
        ])
    __WLANMeasurementConfiguration_iE_Extensions__item_._ext = None
    _WLANMeasurementConfiguration_iE_Extensions._cont = __WLANMeasurementConfiguration_iE_Extensions__item_
    _WLANMeasurementConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    WLANMeasurementConfiguration._cont = ASN1Dict([
        ('wlanMeasConfig', _WLANMeasurementConfiguration_wlanMeasConfig),
        ('wlanMeasConfigNameList', _WLANMeasurementConfiguration_wlanMeasConfigNameList),
        ('wlan-rssi', _WLANMeasurementConfiguration_wlan_rssi),
        ('wlan-rtt', _WLANMeasurementConfiguration_wlan_rtt),
        ('iE-Extensions', _WLANMeasurementConfiguration_iE_Extensions),
        ])
    WLANMeasurementConfiguration._ext = []
    
    #-----< WLANMeasurementConfiguration-ExtIEs >-----#
    WLANMeasurementConfiguration_ExtIEs = CLASS(name='WLANMeasurementConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    WLANMeasurementConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WLANMeasConfigNameList >-----#
    WLANMeasConfigNameList = SEQ_OF(name='WLANMeasConfigNameList', mode=MODE_TYPE)
    _WLANMeasConfigNameList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WLANMeasConfigNameItem')))
    WLANMeasConfigNameList._cont = _WLANMeasConfigNameList__item_
    WLANMeasConfigNameList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< WLANMeasConfigNameItem >-----#
    WLANMeasConfigNameItem = SEQ(name='WLANMeasConfigNameItem', mode=MODE_TYPE)
    _WLANMeasConfigNameItem_wLANName = OCT_STR(name='wLANName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'WLANName')))
    _WLANMeasConfigNameItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __WLANMeasConfigNameItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___WLANMeasConfigNameItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____WLANMeasConfigNameItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____WLANMeasConfigNameItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasConfigNameItem_iE_Extensions__item__id._const_tab = ____WLANMeasConfigNameItem_iE_Extensions__item__id_tab
    ___WLANMeasConfigNameItem_iE_Extensions__item__id._const_tab_at = None
    ___WLANMeasConfigNameItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___WLANMeasConfigNameItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____WLANMeasConfigNameItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____WLANMeasConfigNameItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasConfigNameItem_iE_Extensions__item__criticality._const_tab = ____WLANMeasConfigNameItem_iE_Extensions__item__criticality_tab
    ___WLANMeasConfigNameItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___WLANMeasConfigNameItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___WLANMeasConfigNameItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____WLANMeasConfigNameItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____WLANMeasConfigNameItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasConfigNameItem_iE_Extensions__item__extensionValue._const_tab = ____WLANMeasConfigNameItem_iE_Extensions__item__extensionValue_tab
    ___WLANMeasConfigNameItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___WLANMeasConfigNameItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __WLANMeasConfigNameItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___WLANMeasConfigNameItem_iE_Extensions__item__id),
        ('criticality', ___WLANMeasConfigNameItem_iE_Extensions__item__criticality),
        ('extensionValue', ___WLANMeasConfigNameItem_iE_Extensions__item__extensionValue),
        ])
    __WLANMeasConfigNameItem_iE_Extensions__item_._ext = None
    _WLANMeasConfigNameItem_iE_Extensions._cont = __WLANMeasConfigNameItem_iE_Extensions__item_
    _WLANMeasConfigNameItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    WLANMeasConfigNameItem._cont = ASN1Dict([
        ('wLANName', _WLANMeasConfigNameItem_wLANName),
        ('iE-Extensions', _WLANMeasConfigNameItem_iE_Extensions),
        ])
    WLANMeasConfigNameItem._ext = []
    
    #-----< WLANMeasConfigNameItem-ExtIEs >-----#
    WLANMeasConfigNameItem_ExtIEs = CLASS(name='WLANMeasConfigNameItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    WLANMeasConfigNameItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WLANMeasConfig >-----#
    WLANMeasConfig = ENUM(name='WLANMeasConfig', mode=MODE_TYPE)
    WLANMeasConfig._cont = ASN1Dict([('setup', 0)])
    WLANMeasConfig._ext = []
    
    #-----< WLANName >-----#
    WLANName = OCT_STR(name='WLANName', mode=MODE_TYPE)
    WLANName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< WUS-Assistance-Information >-----#
    WUS_Assistance_Information = SEQ(name='WUS-Assistance-Information', mode=MODE_TYPE)
    _WUS_Assistance_Information_pagingProbabilityInformation = ENUM(name='pagingProbabilityInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'PagingProbabilityInformation')))
    _WUS_Assistance_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __WUS_Assistance_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___WUS_Assistance_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____WUS_Assistance_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____WUS_Assistance_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WUS_Assistance_Information_iE_Extensions__item__id._const_tab = ____WUS_Assistance_Information_iE_Extensions__item__id_tab
    ___WUS_Assistance_Information_iE_Extensions__item__id._const_tab_at = None
    ___WUS_Assistance_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___WUS_Assistance_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____WUS_Assistance_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____WUS_Assistance_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WUS_Assistance_Information_iE_Extensions__item__criticality._const_tab = ____WUS_Assistance_Information_iE_Extensions__item__criticality_tab
    ___WUS_Assistance_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___WUS_Assistance_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___WUS_Assistance_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____WUS_Assistance_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____WUS_Assistance_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WUS_Assistance_Information_iE_Extensions__item__extensionValue._const_tab = ____WUS_Assistance_Information_iE_Extensions__item__extensionValue_tab
    ___WUS_Assistance_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___WUS_Assistance_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __WUS_Assistance_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___WUS_Assistance_Information_iE_Extensions__item__id),
        ('criticality', ___WUS_Assistance_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___WUS_Assistance_Information_iE_Extensions__item__extensionValue),
        ])
    __WUS_Assistance_Information_iE_Extensions__item_._ext = None
    _WUS_Assistance_Information_iE_Extensions._cont = __WUS_Assistance_Information_iE_Extensions__item_
    _WUS_Assistance_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    WUS_Assistance_Information._cont = ASN1Dict([
        ('pagingProbabilityInformation', _WUS_Assistance_Information_pagingProbabilityInformation),
        ('iE-Extensions', _WUS_Assistance_Information_iE_Extensions),
        ])
    WUS_Assistance_Information._ext = []
    
    #-----< WUS-Assistance-Information-ExtIEs >-----#
    WUS_Assistance_Information_ExtIEs = CLASS(name='WUS-Assistance-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    WUS_Assistance_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< XnExtTLAs >-----#
    XnExtTLAs = SEQ_OF(name='XnExtTLAs', mode=MODE_TYPE)
    _XnExtTLAs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'XnExtTLA-Item')))
    XnExtTLAs._cont = _XnExtTLAs__item_
    XnExtTLAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< XnExtTLA-Item >-----#
    XnExtTLA_Item = SEQ(name='XnExtTLA-Item', mode=MODE_TYPE)
    _XnExtTLA_Item_iPsecTLA = BIT_STR(name='iPsecTLA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')), opt=True)
    _XnExtTLA_Item_gTP_TLAs = SEQ_OF(name='gTP-TLAs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'XnGTP-TLAs')), opt=True)
    _XnExtTLA_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __XnExtTLA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___XnExtTLA_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____XnExtTLA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _____XnExtTLA_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SCTP-TLAs')))
    ____XnExtTLA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 173), ('criticality', 'ignore'), ('Extension', _____XnExtTLA_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___XnExtTLA_Item_iE_Extensions__item__id._const_tab = ____XnExtTLA_Item_iE_Extensions__item__id_tab
    ___XnExtTLA_Item_iE_Extensions__item__id._const_tab_at = None
    ___XnExtTLA_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___XnExtTLA_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___XnExtTLA_Item_iE_Extensions__item__criticality._const_tab = ____XnExtTLA_Item_iE_Extensions__item__id_tab
    ___XnExtTLA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___XnExtTLA_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___XnExtTLA_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___XnExtTLA_Item_iE_Extensions__item__extensionValue._const_tab = ____XnExtTLA_Item_iE_Extensions__item__id_tab
    ___XnExtTLA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___XnExtTLA_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __XnExtTLA_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___XnExtTLA_Item_iE_Extensions__item__id),
        ('criticality', ___XnExtTLA_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___XnExtTLA_Item_iE_Extensions__item__extensionValue),
        ])
    __XnExtTLA_Item_iE_Extensions__item_._ext = None
    _XnExtTLA_Item_iE_Extensions._cont = __XnExtTLA_Item_iE_Extensions__item_
    _XnExtTLA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    XnExtTLA_Item._cont = ASN1Dict([
        ('iPsecTLA', _XnExtTLA_Item_iPsecTLA),
        ('gTP-TLAs', _XnExtTLA_Item_gTP_TLAs),
        ('iE-Extensions', _XnExtTLA_Item_iE_Extensions),
        ])
    XnExtTLA_Item._ext = []
    
    #-----< XnExtTLA-Item-ExtIEs >-----#
    XnExtTLA_Item_ExtIEs = CLASS(name='XnExtTLA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    _XnExtTLA_Item_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SCTP-TLAs')))
    XnExtTLA_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 173), ('criticality', 'ignore'), ('Extension', _XnExtTLA_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< XnGTP-TLAs >-----#
    XnGTP_TLAs = SEQ_OF(name='XnGTP-TLAs', mode=MODE_TYPE)
    _XnGTP_TLAs__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    XnGTP_TLAs._cont = _XnGTP_TLAs__item_
    XnGTP_TLAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< XnTLAs >-----#
    XnTLAs = SEQ_OF(name='XnTLAs', mode=MODE_TYPE)
    _XnTLAs__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    XnTLAs._cont = _XnTLAs__item_
    XnTLAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< XnTNLConfigurationInfo >-----#
    XnTNLConfigurationInfo = SEQ(name='XnTNLConfigurationInfo', mode=MODE_TYPE)
    _XnTNLConfigurationInfo_xnTransportLayerAddresses = SEQ_OF(name='xnTransportLayerAddresses', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'XnTLAs')))
    _XnTNLConfigurationInfo_xnExtendedTransportLayerAddresses = SEQ_OF(name='xnExtendedTransportLayerAddresses', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-IEs', 'XnExtTLAs')), opt=True)
    _XnTNLConfigurationInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __XnTNLConfigurationInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolExtensionField')))
    ___XnTNLConfigurationInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['id']))
    ____XnTNLConfigurationInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____XnTNLConfigurationInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___XnTNLConfigurationInfo_iE_Extensions__item__id._const_tab = ____XnTNLConfigurationInfo_iE_Extensions__item__id_tab
    ___XnTNLConfigurationInfo_iE_Extensions__item__id._const_tab_at = None
    ___XnTNLConfigurationInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___XnTNLConfigurationInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____XnTNLConfigurationInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____XnTNLConfigurationInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___XnTNLConfigurationInfo_iE_Extensions__item__criticality._const_tab = ____XnTNLConfigurationInfo_iE_Extensions__item__criticality_tab
    ___XnTNLConfigurationInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___XnTNLConfigurationInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___XnTNLConfigurationInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____XnTNLConfigurationInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NGAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    ____XnTNLConfigurationInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___XnTNLConfigurationInfo_iE_Extensions__item__extensionValue._const_tab = ____XnTNLConfigurationInfo_iE_Extensions__item__extensionValue_tab
    ___XnTNLConfigurationInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___XnTNLConfigurationInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __XnTNLConfigurationInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___XnTNLConfigurationInfo_iE_Extensions__item__id),
        ('criticality', ___XnTNLConfigurationInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___XnTNLConfigurationInfo_iE_Extensions__item__extensionValue),
        ])
    __XnTNLConfigurationInfo_iE_Extensions__item_._ext = None
    _XnTNLConfigurationInfo_iE_Extensions._cont = __XnTNLConfigurationInfo_iE_Extensions__item_
    _XnTNLConfigurationInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    XnTNLConfigurationInfo._cont = ASN1Dict([
        ('xnTransportLayerAddresses', _XnTNLConfigurationInfo_xnTransportLayerAddresses),
        ('xnExtendedTransportLayerAddresses', _XnTNLConfigurationInfo_xnExtendedTransportLayerAddresses),
        ('iE-Extensions', _XnTNLConfigurationInfo_iE_Extensions),
        ])
    XnTNLConfigurationInfo._ext = []
    
    #-----< XnTNLConfigurationInfo-ExtIEs >-----#
    XnTNLConfigurationInfo_ExtIEs = CLASS(name='XnTNLConfigurationInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-EXTENSION')))
    XnTNLConfigurationInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    _all_ = [
        _AdditionalDLUPTNLInformationForHOList__item_,
        AdditionalDLUPTNLInformationForHOList,
        _AdditionalDLUPTNLInformationForHOItem_additionalDL_NGU_UP_TNLInformation,
        _AdditionalDLUPTNLInformationForHOItem_additionalQosFlowSetupResponseList,
        _AdditionalDLUPTNLInformationForHOItem_additionalDLForwardingUPTNLInformation,
        ____AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id_tab,
        _____AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__id,
        ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__criticality,
        ___AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item__extensionValue,
        __AdditionalDLUPTNLInformationForHOItem_iE_Extensions__item_,
        _AdditionalDLUPTNLInformationForHOItem_iE_Extensions,
        AdditionalDLUPTNLInformationForHOItem,
        AdditionalDLUPTNLInformationForHOItem_ExtIEs,
        _AdditionalDLUPTNLInformationForHOItem_ExtIEs_val_Extension_0,
        AdditionalQosFlowInformation,
        _AllocationAndRetentionPriority_priorityLevelARP,
        _AllocationAndRetentionPriority_pre_emptionCapability,
        _AllocationAndRetentionPriority_pre_emptionVulnerability,
        ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab,
        ___AllocationAndRetentionPriority_iE_Extensions__item__id,
        ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab,
        ___AllocationAndRetentionPriority_iE_Extensions__item__criticality,
        ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab,
        ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue,
        __AllocationAndRetentionPriority_iE_Extensions__item_,
        _AllocationAndRetentionPriority_iE_Extensions,
        AllocationAndRetentionPriority,
        AllocationAndRetentionPriority_ExtIEs,
        _Allowed_CAG_List_per_PLMN__item_,
        Allowed_CAG_List_per_PLMN,
        _AllowedNSSAI__item_,
        AllowedNSSAI,
        _AllowedNSSAI_Item_s_NSSAI,
        ____AllowedNSSAI_Item_iE_Extensions__item__id_tab,
        ___AllowedNSSAI_Item_iE_Extensions__item__id,
        ____AllowedNSSAI_Item_iE_Extensions__item__criticality_tab,
        ___AllowedNSSAI_Item_iE_Extensions__item__criticality,
        ____AllowedNSSAI_Item_iE_Extensions__item__extensionValue_tab,
        ___AllowedNSSAI_Item_iE_Extensions__item__extensionValue,
        __AllowedNSSAI_Item_iE_Extensions__item_,
        _AllowedNSSAI_Item_iE_Extensions,
        AllowedNSSAI_Item,
        AllowedNSSAI_Item_ExtIEs,
        _Allowed_PNI_NPN_List__item_,
        Allowed_PNI_NPN_List,
        _Allowed_PNI_NPN_Item_pLMNIdentity,
        _Allowed_PNI_NPN_Item_pNI_NPN_restricted,
        _Allowed_PNI_NPN_Item_allowed_CAG_List_per_PLMN,
        ____Allowed_PNI_NPN_Item_iE_Extensions__item__id_tab,
        ___Allowed_PNI_NPN_Item_iE_Extensions__item__id,
        ____Allowed_PNI_NPN_Item_iE_Extensions__item__criticality_tab,
        ___Allowed_PNI_NPN_Item_iE_Extensions__item__criticality,
        ____Allowed_PNI_NPN_Item_iE_Extensions__item__extensionValue_tab,
        ___Allowed_PNI_NPN_Item_iE_Extensions__item__extensionValue,
        __Allowed_PNI_NPN_Item_iE_Extensions__item_,
        _Allowed_PNI_NPN_Item_iE_Extensions,
        Allowed_PNI_NPN_Item,
        Allowed_PNI_NPN_Item_ExtIEs,
        _AllowedTACs__item_,
        AllowedTACs,
        AlternativeQoSParaSetIndex,
        AlternativeQoSParaSetNotifyIndex,
        _AlternativeQoSParaSetList__item_,
        AlternativeQoSParaSetList,
        _AlternativeQoSParaSetItem_alternativeQoSParaSetIndex,
        _AlternativeQoSParaSetItem_guaranteedFlowBitRateDL,
        _AlternativeQoSParaSetItem_guaranteedFlowBitRateUL,
        _AlternativeQoSParaSetItem_packetDelayBudget,
        _AlternativeQoSParaSetItem_packetErrorRate,
        ____AlternativeQoSParaSetItem_iE_Extensions__item__id_tab,
        ___AlternativeQoSParaSetItem_iE_Extensions__item__id,
        ____AlternativeQoSParaSetItem_iE_Extensions__item__criticality_tab,
        ___AlternativeQoSParaSetItem_iE_Extensions__item__criticality,
        ____AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue_tab,
        ___AlternativeQoSParaSetItem_iE_Extensions__item__extensionValue,
        __AlternativeQoSParaSetItem_iE_Extensions__item_,
        _AlternativeQoSParaSetItem_iE_Extensions,
        AlternativeQoSParaSetItem,
        AlternativeQoSParaSetItem_ExtIEs,
        AMFName,
        AMFNameVisibleString,
        AMFNameUTF8String,
        _AMFPagingTarget_globalRANNodeID,
        _AMFPagingTarget_tAI,
        ___AMFPagingTarget_choice_Extensions_id_tab,
        __AMFPagingTarget_choice_Extensions_id,
        ___AMFPagingTarget_choice_Extensions_criticality_tab,
        __AMFPagingTarget_choice_Extensions_criticality,
        ___AMFPagingTarget_choice_Extensions_value_tab,
        __AMFPagingTarget_choice_Extensions_value,
        _AMFPagingTarget_choice_Extensions,
        AMFPagingTarget,
        AMFPagingTarget_ExtIEs,
        AMFPointer,
        AMFRegionID,
        AMFSetID,
        _AMF_TNLAssociationSetupList__item_,
        AMF_TNLAssociationSetupList,
        _AMF_TNLAssociationSetupItem_aMF_TNLAssociationAddress,
        ____AMF_TNLAssociationSetupItem_iE_Extensions__item__id_tab,
        ___AMF_TNLAssociationSetupItem_iE_Extensions__item__id,
        ____AMF_TNLAssociationSetupItem_iE_Extensions__item__criticality_tab,
        ___AMF_TNLAssociationSetupItem_iE_Extensions__item__criticality,
        ____AMF_TNLAssociationSetupItem_iE_Extensions__item__extensionValue_tab,
        ___AMF_TNLAssociationSetupItem_iE_Extensions__item__extensionValue,
        __AMF_TNLAssociationSetupItem_iE_Extensions__item_,
        _AMF_TNLAssociationSetupItem_iE_Extensions,
        AMF_TNLAssociationSetupItem,
        AMF_TNLAssociationSetupItem_ExtIEs,
        _AMF_TNLAssociationToAddList__item_,
        AMF_TNLAssociationToAddList,
        _AMF_TNLAssociationToAddItem_aMF_TNLAssociationAddress,
        _AMF_TNLAssociationToAddItem_tNLAssociationUsage,
        _AMF_TNLAssociationToAddItem_tNLAddressWeightFactor,
        ____AMF_TNLAssociationToAddItem_iE_Extensions__item__id_tab,
        ___AMF_TNLAssociationToAddItem_iE_Extensions__item__id,
        ____AMF_TNLAssociationToAddItem_iE_Extensions__item__criticality_tab,
        ___AMF_TNLAssociationToAddItem_iE_Extensions__item__criticality,
        ____AMF_TNLAssociationToAddItem_iE_Extensions__item__extensionValue_tab,
        ___AMF_TNLAssociationToAddItem_iE_Extensions__item__extensionValue,
        __AMF_TNLAssociationToAddItem_iE_Extensions__item_,
        _AMF_TNLAssociationToAddItem_iE_Extensions,
        AMF_TNLAssociationToAddItem,
        AMF_TNLAssociationToAddItem_ExtIEs,
        _AMF_TNLAssociationToRemoveList__item_,
        AMF_TNLAssociationToRemoveList,
        _AMF_TNLAssociationToRemoveItem_aMF_TNLAssociationAddress,
        ____AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id_tab,
        _____AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__id,
        ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__criticality,
        ___AMF_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue,
        __AMF_TNLAssociationToRemoveItem_iE_Extensions__item_,
        _AMF_TNLAssociationToRemoveItem_iE_Extensions,
        AMF_TNLAssociationToRemoveItem,
        AMF_TNLAssociationToRemoveItem_ExtIEs,
        _AMF_TNLAssociationToRemoveItem_ExtIEs_val_Extension_0,
        _AMF_TNLAssociationToUpdateList__item_,
        AMF_TNLAssociationToUpdateList,
        _AMF_TNLAssociationToUpdateItem_aMF_TNLAssociationAddress,
        _AMF_TNLAssociationToUpdateItem_tNLAssociationUsage,
        _AMF_TNLAssociationToUpdateItem_tNLAddressWeightFactor,
        ____AMF_TNLAssociationToUpdateItem_iE_Extensions__item__id_tab,
        ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__id,
        ____AMF_TNLAssociationToUpdateItem_iE_Extensions__item__criticality_tab,
        ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__criticality,
        ____AMF_TNLAssociationToUpdateItem_iE_Extensions__item__extensionValue_tab,
        ___AMF_TNLAssociationToUpdateItem_iE_Extensions__item__extensionValue,
        __AMF_TNLAssociationToUpdateItem_iE_Extensions__item_,
        _AMF_TNLAssociationToUpdateItem_iE_Extensions,
        AMF_TNLAssociationToUpdateItem,
        AMF_TNLAssociationToUpdateItem_ExtIEs,
        AMF_UE_NGAP_ID,
        _AreaOfInterest_areaOfInterestTAIList,
        _AreaOfInterest_areaOfInterestCellList,
        _AreaOfInterest_areaOfInterestRANNodeList,
        ____AreaOfInterest_iE_Extensions__item__id_tab,
        ___AreaOfInterest_iE_Extensions__item__id,
        ____AreaOfInterest_iE_Extensions__item__criticality_tab,
        ___AreaOfInterest_iE_Extensions__item__criticality,
        ____AreaOfInterest_iE_Extensions__item__extensionValue_tab,
        ___AreaOfInterest_iE_Extensions__item__extensionValue,
        __AreaOfInterest_iE_Extensions__item_,
        _AreaOfInterest_iE_Extensions,
        AreaOfInterest,
        AreaOfInterest_ExtIEs,
        _AreaOfInterestCellList__item_,
        AreaOfInterestCellList,
        _AreaOfInterestCellItem_nGRAN_CGI,
        ____AreaOfInterestCellItem_iE_Extensions__item__id_tab,
        ___AreaOfInterestCellItem_iE_Extensions__item__id,
        ____AreaOfInterestCellItem_iE_Extensions__item__criticality_tab,
        ___AreaOfInterestCellItem_iE_Extensions__item__criticality,
        ____AreaOfInterestCellItem_iE_Extensions__item__extensionValue_tab,
        ___AreaOfInterestCellItem_iE_Extensions__item__extensionValue,
        __AreaOfInterestCellItem_iE_Extensions__item_,
        _AreaOfInterestCellItem_iE_Extensions,
        AreaOfInterestCellItem,
        AreaOfInterestCellItem_ExtIEs,
        _AreaOfInterestList__item_,
        AreaOfInterestList,
        _AreaOfInterestItem_areaOfInterest,
        _AreaOfInterestItem_locationReportingReferenceID,
        ____AreaOfInterestItem_iE_Extensions__item__id_tab,
        ___AreaOfInterestItem_iE_Extensions__item__id,
        ____AreaOfInterestItem_iE_Extensions__item__criticality_tab,
        ___AreaOfInterestItem_iE_Extensions__item__criticality,
        ____AreaOfInterestItem_iE_Extensions__item__extensionValue_tab,
        ___AreaOfInterestItem_iE_Extensions__item__extensionValue,
        __AreaOfInterestItem_iE_Extensions__item_,
        _AreaOfInterestItem_iE_Extensions,
        AreaOfInterestItem,
        AreaOfInterestItem_ExtIEs,
        _AreaOfInterestRANNodeList__item_,
        AreaOfInterestRANNodeList,
        _AreaOfInterestRANNodeItem_globalRANNodeID,
        ____AreaOfInterestRANNodeItem_iE_Extensions__item__id_tab,
        ___AreaOfInterestRANNodeItem_iE_Extensions__item__id,
        ____AreaOfInterestRANNodeItem_iE_Extensions__item__criticality_tab,
        ___AreaOfInterestRANNodeItem_iE_Extensions__item__criticality,
        ____AreaOfInterestRANNodeItem_iE_Extensions__item__extensionValue_tab,
        ___AreaOfInterestRANNodeItem_iE_Extensions__item__extensionValue,
        __AreaOfInterestRANNodeItem_iE_Extensions__item_,
        _AreaOfInterestRANNodeItem_iE_Extensions,
        AreaOfInterestRANNodeItem,
        AreaOfInterestRANNodeItem_ExtIEs,
        _AreaOfInterestTAIList__item_,
        AreaOfInterestTAIList,
        _AreaOfInterestTAIItem_tAI,
        ____AreaOfInterestTAIItem_iE_Extensions__item__id_tab,
        ___AreaOfInterestTAIItem_iE_Extensions__item__id,
        ____AreaOfInterestTAIItem_iE_Extensions__item__criticality_tab,
        ___AreaOfInterestTAIItem_iE_Extensions__item__criticality,
        ____AreaOfInterestTAIItem_iE_Extensions__item__extensionValue_tab,
        ___AreaOfInterestTAIItem_iE_Extensions__item__extensionValue,
        __AreaOfInterestTAIItem_iE_Extensions__item_,
        _AreaOfInterestTAIItem_iE_Extensions,
        AreaOfInterestTAIItem,
        AreaOfInterestTAIItem_ExtIEs,
        _AssistanceDataForPaging_assistanceDataForRecommendedCells,
        _AssistanceDataForPaging_pagingAttemptInformation,
        ____AssistanceDataForPaging_iE_Extensions__item__id_tab,
        _____AssistanceDataForPaging_iE_Extensions__item__id_tab_val_Extension_0,
        _____AssistanceDataForPaging_iE_Extensions__item__id_tab_val_Extension_1,
        ___AssistanceDataForPaging_iE_Extensions__item__id,
        ___AssistanceDataForPaging_iE_Extensions__item__criticality,
        ___AssistanceDataForPaging_iE_Extensions__item__extensionValue,
        __AssistanceDataForPaging_iE_Extensions__item_,
        _AssistanceDataForPaging_iE_Extensions,
        AssistanceDataForPaging,
        AssistanceDataForPaging_ExtIEs,
        _AssistanceDataForPaging_ExtIEs_val_Extension_0,
        _AssistanceDataForPaging_ExtIEs_val_Extension_1,
        _AssistanceDataForRecommendedCells_recommendedCellsForPaging,
        ____AssistanceDataForRecommendedCells_iE_Extensions__item__id_tab,
        ___AssistanceDataForRecommendedCells_iE_Extensions__item__id,
        ____AssistanceDataForRecommendedCells_iE_Extensions__item__criticality_tab,
        ___AssistanceDataForRecommendedCells_iE_Extensions__item__criticality,
        ____AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue_tab,
        ___AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue,
        __AssistanceDataForRecommendedCells_iE_Extensions__item_,
        _AssistanceDataForRecommendedCells_iE_Extensions,
        AssistanceDataForRecommendedCells,
        AssistanceDataForRecommendedCells_ExtIEs,
        _AssociatedMBSQosFlowSetupRequestList__item_,
        AssociatedMBSQosFlowSetupRequestList,
        _AssociatedMBSQosFlowSetupRequestItem_mBS_QosFlowIdentifier,
        _AssociatedMBSQosFlowSetupRequestItem_associatedUnicastQosFlowIdentifier,
        ____AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__id_tab,
        ___AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__id,
        ____AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__criticality_tab,
        ___AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__criticality,
        ____AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__extensionValue_tab,
        ___AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item__extensionValue,
        __AssociatedMBSQosFlowSetupRequestItem_iE_Extensions__item_,
        _AssociatedMBSQosFlowSetupRequestItem_iE_Extensions,
        AssociatedMBSQosFlowSetupRequestItem,
        AssociatedMBSQosFlowSetupRequestItem_ExtIEs,
        _AssociatedMBSQosFlowSetuporModifyRequestList__item_,
        AssociatedMBSQosFlowSetuporModifyRequestList,
        _AssociatedMBSQosFlowSetuporModifyRequestItem_mBS_QosFlowIdentifier,
        _AssociatedMBSQosFlowSetuporModifyRequestItem_associatedUnicastQosFlowIdentifier,
        ____AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__id_tab,
        ___AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__id,
        ____AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__criticality_tab,
        ___AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__criticality,
        ____AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__extensionValue_tab,
        ___AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item__extensionValue,
        __AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions__item_,
        _AssociatedMBSQosFlowSetuporModifyRequestItem_iE_Extensions,
        AssociatedMBSQosFlowSetuporModifyRequestItem,
        AssociatedMBSQosFlowSetuporModifyRequestItem_ExtIEs,
        _AssociatedQosFlowList__item_,
        AssociatedQosFlowList,
        _AssociatedQosFlowItem_qosFlowIdentifier,
        _AssociatedQosFlowItem_qosFlowMappingIndication,
        ____AssociatedQosFlowItem_iE_Extensions__item__id_tab,
        _____AssociatedQosFlowItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___AssociatedQosFlowItem_iE_Extensions__item__id,
        ___AssociatedQosFlowItem_iE_Extensions__item__criticality,
        ___AssociatedQosFlowItem_iE_Extensions__item__extensionValue,
        __AssociatedQosFlowItem_iE_Extensions__item_,
        _AssociatedQosFlowItem_iE_Extensions,
        AssociatedQosFlowItem,
        AssociatedQosFlowItem_ExtIEs,
        _AssociatedQosFlowItem_ExtIEs_val_Extension_0,
        AuthenticatedIndication,
        AveragingWindow,
        _AreaScopeOfMDT_NR_cellBased,
        _AreaScopeOfMDT_NR_tABased,
        _AreaScopeOfMDT_NR_pLMNWide,
        _AreaScopeOfMDT_NR_tAIBased,
        ___AreaScopeOfMDT_NR_choice_Extensions_id_tab,
        __AreaScopeOfMDT_NR_choice_Extensions_id,
        ___AreaScopeOfMDT_NR_choice_Extensions_criticality_tab,
        __AreaScopeOfMDT_NR_choice_Extensions_criticality,
        ___AreaScopeOfMDT_NR_choice_Extensions_value_tab,
        __AreaScopeOfMDT_NR_choice_Extensions_value,
        _AreaScopeOfMDT_NR_choice_Extensions,
        AreaScopeOfMDT_NR,
        AreaScopeOfMDT_NR_ExtIEs,
        _AreaScopeOfMDT_EUTRA_cellBased,
        _AreaScopeOfMDT_EUTRA_tABased,
        _AreaScopeOfMDT_EUTRA_pLMNWide,
        _AreaScopeOfMDT_EUTRA_tAIBased,
        ___AreaScopeOfMDT_EUTRA_choice_Extensions_id_tab,
        __AreaScopeOfMDT_EUTRA_choice_Extensions_id,
        ___AreaScopeOfMDT_EUTRA_choice_Extensions_criticality_tab,
        __AreaScopeOfMDT_EUTRA_choice_Extensions_criticality,
        ___AreaScopeOfMDT_EUTRA_choice_Extensions_value_tab,
        __AreaScopeOfMDT_EUTRA_choice_Extensions_value,
        _AreaScopeOfMDT_EUTRA_choice_Extensions,
        AreaScopeOfMDT_EUTRA,
        AreaScopeOfMDT_EUTRA_ExtIEs,
        _AreaScopeOfNeighCellsList__item_,
        AreaScopeOfNeighCellsList,
        _AreaScopeOfNeighCellsItem_nrFrequencyInfo,
        _AreaScopeOfNeighCellsItem_pciListForMDT,
        ____AreaScopeOfNeighCellsItem_iE_Extensions__item__id_tab,
        ___AreaScopeOfNeighCellsItem_iE_Extensions__item__id,
        ____AreaScopeOfNeighCellsItem_iE_Extensions__item__criticality_tab,
        ___AreaScopeOfNeighCellsItem_iE_Extensions__item__criticality,
        ____AreaScopeOfNeighCellsItem_iE_Extensions__item__extensionValue_tab,
        ___AreaScopeOfNeighCellsItem_iE_Extensions__item__extensionValue,
        __AreaScopeOfNeighCellsItem_iE_Extensions__item_,
        _AreaScopeOfNeighCellsItem_iE_Extensions,
        AreaScopeOfNeighCellsItem,
        AreaScopeOfNeighCellsItem_ExtIEs,
        _AreaScopeOfQMC_cellBased,
        _AreaScopeOfQMC_tABased,
        _AreaScopeOfQMC_tAIBased,
        _AreaScopeOfQMC_pLMNAreaBased,
        ___AreaScopeOfQMC_choice_Extensions_id_tab,
        __AreaScopeOfQMC_choice_Extensions_id,
        ___AreaScopeOfQMC_choice_Extensions_criticality_tab,
        __AreaScopeOfQMC_choice_Extensions_criticality,
        ___AreaScopeOfQMC_choice_Extensions_value_tab,
        __AreaScopeOfQMC_choice_Extensions_value,
        _AreaScopeOfQMC_choice_Extensions,
        AreaScopeOfQMC,
        AreaScopeOfQMC_ExtIEs,
        _AvailableRANVisibleQoEMetrics_applicationLayerBufferLevelList,
        _AvailableRANVisibleQoEMetrics_playoutDelayForMediaStartup,
        ____AvailableRANVisibleQoEMetrics_iE_Extensions__item__id_tab,
        ___AvailableRANVisibleQoEMetrics_iE_Extensions__item__id,
        ____AvailableRANVisibleQoEMetrics_iE_Extensions__item__criticality_tab,
        ___AvailableRANVisibleQoEMetrics_iE_Extensions__item__criticality,
        ____AvailableRANVisibleQoEMetrics_iE_Extensions__item__extensionValue_tab,
        ___AvailableRANVisibleQoEMetrics_iE_Extensions__item__extensionValue,
        __AvailableRANVisibleQoEMetrics_iE_Extensions__item_,
        _AvailableRANVisibleQoEMetrics_iE_Extensions,
        AvailableRANVisibleQoEMetrics,
        AvailableRANVisibleQoEMetrics_ExtIEs,
        _BeamMeasurementsReportConfiguration_beamMeasurementsReportQuantity,
        _BeamMeasurementsReportConfiguration_maxNrofRS_IndexesToReport,
        ____BeamMeasurementsReportConfiguration_iE_Extensions__item__id_tab,
        ___BeamMeasurementsReportConfiguration_iE_Extensions__item__id,
        ____BeamMeasurementsReportConfiguration_iE_Extensions__item__criticality_tab,
        ___BeamMeasurementsReportConfiguration_iE_Extensions__item__criticality,
        ____BeamMeasurementsReportConfiguration_iE_Extensions__item__extensionValue_tab,
        ___BeamMeasurementsReportConfiguration_iE_Extensions__item__extensionValue,
        __BeamMeasurementsReportConfiguration_iE_Extensions__item_,
        _BeamMeasurementsReportConfiguration_iE_Extensions,
        BeamMeasurementsReportConfiguration,
        BeamMeasurementsReportConfiguration_ExtIEs,
        _BeamMeasurementsReportQuantity_rSRP,
        _BeamMeasurementsReportQuantity_rSRQ,
        _BeamMeasurementsReportQuantity_sINR,
        ____BeamMeasurementsReportQuantity_iE_Extensions__item__id_tab,
        ___BeamMeasurementsReportQuantity_iE_Extensions__item__id,
        ____BeamMeasurementsReportQuantity_iE_Extensions__item__criticality_tab,
        ___BeamMeasurementsReportQuantity_iE_Extensions__item__criticality,
        ____BeamMeasurementsReportQuantity_iE_Extensions__item__extensionValue_tab,
        ___BeamMeasurementsReportQuantity_iE_Extensions__item__extensionValue,
        __BeamMeasurementsReportQuantity_iE_Extensions__item_,
        _BeamMeasurementsReportQuantity_iE_Extensions,
        BeamMeasurementsReportQuantity,
        BeamMeasurementsReportQuantity_ExtIEs,
        BitRate,
        _BroadcastCancelledAreaList_cellIDCancelledEUTRA,
        _BroadcastCancelledAreaList_tAICancelledEUTRA,
        _BroadcastCancelledAreaList_emergencyAreaIDCancelledEUTRA,
        _BroadcastCancelledAreaList_cellIDCancelledNR,
        _BroadcastCancelledAreaList_tAICancelledNR,
        _BroadcastCancelledAreaList_emergencyAreaIDCancelledNR,
        ___BroadcastCancelledAreaList_choice_Extensions_id_tab,
        __BroadcastCancelledAreaList_choice_Extensions_id,
        ___BroadcastCancelledAreaList_choice_Extensions_criticality_tab,
        __BroadcastCancelledAreaList_choice_Extensions_criticality,
        ___BroadcastCancelledAreaList_choice_Extensions_value_tab,
        __BroadcastCancelledAreaList_choice_Extensions_value,
        _BroadcastCancelledAreaList_choice_Extensions,
        BroadcastCancelledAreaList,
        BroadcastCancelledAreaList_ExtIEs,
        _BroadcastCompletedAreaList_cellIDBroadcastEUTRA,
        _BroadcastCompletedAreaList_tAIBroadcastEUTRA,
        _BroadcastCompletedAreaList_emergencyAreaIDBroadcastEUTRA,
        _BroadcastCompletedAreaList_cellIDBroadcastNR,
        _BroadcastCompletedAreaList_tAIBroadcastNR,
        _BroadcastCompletedAreaList_emergencyAreaIDBroadcastNR,
        ___BroadcastCompletedAreaList_choice_Extensions_id_tab,
        __BroadcastCompletedAreaList_choice_Extensions_id,
        ___BroadcastCompletedAreaList_choice_Extensions_criticality_tab,
        __BroadcastCompletedAreaList_choice_Extensions_criticality,
        ___BroadcastCompletedAreaList_choice_Extensions_value_tab,
        __BroadcastCompletedAreaList_choice_Extensions_value,
        _BroadcastCompletedAreaList_choice_Extensions,
        BroadcastCompletedAreaList,
        BroadcastCompletedAreaList_ExtIEs,
        _BroadcastPLMNList__item_,
        BroadcastPLMNList,
        _BroadcastPLMNItem_pLMNIdentity,
        _BroadcastPLMNItem_tAISliceSupportList,
        ____BroadcastPLMNItem_iE_Extensions__item__id_tab,
        _____BroadcastPLMNItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____BroadcastPLMNItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____BroadcastPLMNItem_iE_Extensions__item__id_tab_val_Extension_2,
        ___BroadcastPLMNItem_iE_Extensions__item__id,
        ___BroadcastPLMNItem_iE_Extensions__item__criticality,
        ___BroadcastPLMNItem_iE_Extensions__item__extensionValue,
        __BroadcastPLMNItem_iE_Extensions__item_,
        _BroadcastPLMNItem_iE_Extensions,
        BroadcastPLMNItem,
        BroadcastPLMNItem_ExtIEs,
        _BroadcastPLMNItem_ExtIEs_val_Extension_0,
        _BroadcastPLMNItem_ExtIEs_val_Extension_1,
        _BroadcastPLMNItem_ExtIEs_val_Extension_2,
        _BluetoothMeasurementConfiguration_bluetoothMeasConfig,
        _BluetoothMeasurementConfiguration_bluetoothMeasConfigNameList,
        _BluetoothMeasurementConfiguration_bt_rssi,
        ____BluetoothMeasurementConfiguration_iE_Extensions__item__id_tab,
        ___BluetoothMeasurementConfiguration_iE_Extensions__item__id,
        ____BluetoothMeasurementConfiguration_iE_Extensions__item__criticality_tab,
        ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality,
        ____BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue_tab,
        ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue,
        __BluetoothMeasurementConfiguration_iE_Extensions__item_,
        _BluetoothMeasurementConfiguration_iE_Extensions,
        BluetoothMeasurementConfiguration,
        BluetoothMeasurementConfiguration_ExtIEs,
        _BluetoothMeasConfigNameList__item_,
        BluetoothMeasConfigNameList,
        _BluetoothMeasConfigNameItem_bluetoothName,
        ____BluetoothMeasConfigNameItem_iE_Extensions__item__id_tab,
        ___BluetoothMeasConfigNameItem_iE_Extensions__item__id,
        ____BluetoothMeasConfigNameItem_iE_Extensions__item__criticality_tab,
        ___BluetoothMeasConfigNameItem_iE_Extensions__item__criticality,
        ____BluetoothMeasConfigNameItem_iE_Extensions__item__extensionValue_tab,
        ___BluetoothMeasConfigNameItem_iE_Extensions__item__extensionValue,
        __BluetoothMeasConfigNameItem_iE_Extensions__item_,
        _BluetoothMeasConfigNameItem_iE_Extensions,
        BluetoothMeasConfigNameItem,
        BluetoothMeasConfigNameItem_ExtIEs,
        BluetoothMeasConfig,
        BluetoothName,
        BurstArrivalTime,
        CAG_ID,
        CancelAllWarningMessages,
        _CancelledCellsInEAI_EUTRA__item_,
        CancelledCellsInEAI_EUTRA,
        _CancelledCellsInEAI_EUTRA_Item_eUTRA_CGI,
        _CancelledCellsInEAI_EUTRA_Item_numberOfBroadcasts,
        ____CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__id_tab,
        ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__id,
        ____CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality_tab,
        ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality,
        ____CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue,
        __CancelledCellsInEAI_EUTRA_Item_iE_Extensions__item_,
        _CancelledCellsInEAI_EUTRA_Item_iE_Extensions,
        CancelledCellsInEAI_EUTRA_Item,
        CancelledCellsInEAI_EUTRA_Item_ExtIEs,
        _CancelledCellsInEAI_NR__item_,
        CancelledCellsInEAI_NR,
        _CancelledCellsInEAI_NR_Item_nR_CGI,
        _CancelledCellsInEAI_NR_Item_numberOfBroadcasts,
        ____CancelledCellsInEAI_NR_Item_iE_Extensions__item__id_tab,
        ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__id,
        ____CancelledCellsInEAI_NR_Item_iE_Extensions__item__criticality_tab,
        ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__criticality,
        ____CancelledCellsInEAI_NR_Item_iE_Extensions__item__extensionValue_tab,
        ___CancelledCellsInEAI_NR_Item_iE_Extensions__item__extensionValue,
        __CancelledCellsInEAI_NR_Item_iE_Extensions__item_,
        _CancelledCellsInEAI_NR_Item_iE_Extensions,
        CancelledCellsInEAI_NR_Item,
        CancelledCellsInEAI_NR_Item_ExtIEs,
        _CancelledCellsInTAI_EUTRA__item_,
        CancelledCellsInTAI_EUTRA,
        _CancelledCellsInTAI_EUTRA_Item_eUTRA_CGI,
        _CancelledCellsInTAI_EUTRA_Item_numberOfBroadcasts,
        ____CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__id_tab,
        ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__id,
        ____CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality_tab,
        ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality,
        ____CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue,
        __CancelledCellsInTAI_EUTRA_Item_iE_Extensions__item_,
        _CancelledCellsInTAI_EUTRA_Item_iE_Extensions,
        CancelledCellsInTAI_EUTRA_Item,
        CancelledCellsInTAI_EUTRA_Item_ExtIEs,
        _CancelledCellsInTAI_NR__item_,
        CancelledCellsInTAI_NR,
        _CancelledCellsInTAI_NR_Item_nR_CGI,
        _CancelledCellsInTAI_NR_Item_numberOfBroadcasts,
        ____CancelledCellsInTAI_NR_Item_iE_Extensions__item__id_tab,
        ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__id,
        ____CancelledCellsInTAI_NR_Item_iE_Extensions__item__criticality_tab,
        ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__criticality,
        ____CancelledCellsInTAI_NR_Item_iE_Extensions__item__extensionValue_tab,
        ___CancelledCellsInTAI_NR_Item_iE_Extensions__item__extensionValue,
        __CancelledCellsInTAI_NR_Item_iE_Extensions__item_,
        _CancelledCellsInTAI_NR_Item_iE_Extensions,
        CancelledCellsInTAI_NR_Item,
        CancelledCellsInTAI_NR_Item_ExtIEs,
        _CandidateCellList__item_,
        CandidateCellList,
        _CandidateCellItem_candidateCell,
        ____CandidateCellItem_iE_Extensions__item__id_tab,
        ___CandidateCellItem_iE_Extensions__item__id,
        ____CandidateCellItem_iE_Extensions__item__criticality_tab,
        ___CandidateCellItem_iE_Extensions__item__criticality,
        ____CandidateCellItem_iE_Extensions__item__extensionValue_tab,
        ___CandidateCellItem_iE_Extensions__item__extensionValue,
        __CandidateCellItem_iE_Extensions__item_,
        _CandidateCellItem_iE_Extensions,
        CandidateCellItem,
        CandidateCellItem_ExtIEs,
        _CandidateCell_candidateCGI,
        _CandidateCell_candidatePCI,
        ___CandidateCell_choice_Extensions_id_tab,
        __CandidateCell_choice_Extensions_id,
        ___CandidateCell_choice_Extensions_criticality_tab,
        __CandidateCell_choice_Extensions_criticality,
        ___CandidateCell_choice_Extensions_value_tab,
        __CandidateCell_choice_Extensions_value,
        _CandidateCell_choice_Extensions,
        CandidateCell,
        CandidateCell_ExtIEs,
        _CandidateCellID_candidateCellID,
        ____CandidateCellID_iE_Extensions__item__id_tab,
        ___CandidateCellID_iE_Extensions__item__id,
        ____CandidateCellID_iE_Extensions__item__criticality_tab,
        ___CandidateCellID_iE_Extensions__item__criticality,
        ____CandidateCellID_iE_Extensions__item__extensionValue_tab,
        ___CandidateCellID_iE_Extensions__item__extensionValue,
        __CandidateCellID_iE_Extensions__item_,
        _CandidateCellID_iE_Extensions,
        CandidateCellID,
        CandidateCellID_ExtIEs,
        _CandidatePCI_candidatePCI,
        _CandidatePCI_candidateNRARFCN,
        ____CandidatePCI_iE_Extensions__item__id_tab,
        ___CandidatePCI_iE_Extensions__item__id,
        ____CandidatePCI_iE_Extensions__item__criticality_tab,
        ___CandidatePCI_iE_Extensions__item__criticality,
        ____CandidatePCI_iE_Extensions__item__extensionValue_tab,
        ___CandidatePCI_iE_Extensions__item__extensionValue,
        __CandidatePCI_iE_Extensions__item_,
        _CandidatePCI_iE_Extensions,
        CandidatePCI,
        CandidatePCI_ExtIEs,
        _Cause_radioNetwork,
        _Cause_transport,
        _Cause_nas,
        _Cause_protocol,
        _Cause_misc,
        ___Cause_choice_Extensions_id_tab,
        __Cause_choice_Extensions_id,
        ___Cause_choice_Extensions_criticality_tab,
        __Cause_choice_Extensions_criticality,
        ___Cause_choice_Extensions_value_tab,
        __Cause_choice_Extensions_value,
        _Cause_choice_Extensions,
        Cause,
        Cause_ExtIEs,
        CauseMisc,
        CauseNas,
        CauseProtocol,
        CauseRadioNetwork,
        CauseTransport,
        _Cell_CAGInformation_nGRAN_CGI,
        _Cell_CAGInformation_cellCAGList,
        ____Cell_CAGInformation_iE_Extensions__item__id_tab,
        ___Cell_CAGInformation_iE_Extensions__item__id,
        ____Cell_CAGInformation_iE_Extensions__item__criticality_tab,
        ___Cell_CAGInformation_iE_Extensions__item__criticality,
        ____Cell_CAGInformation_iE_Extensions__item__extensionValue_tab,
        ___Cell_CAGInformation_iE_Extensions__item__extensionValue,
        __Cell_CAGInformation_iE_Extensions__item_,
        _Cell_CAGInformation_iE_Extensions,
        Cell_CAGInformation,
        Cell_CAGInformation_ExtIEs,
        _CellCAGList__item_,
        CellCAGList,
        _CellIDBroadcastEUTRA__item_,
        CellIDBroadcastEUTRA,
        _CellIDBroadcastEUTRA_Item_eUTRA_CGI,
        ____CellIDBroadcastEUTRA_Item_iE_Extensions__item__id_tab,
        ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__id,
        ____CellIDBroadcastEUTRA_Item_iE_Extensions__item__criticality_tab,
        ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__criticality,
        ____CellIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___CellIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue,
        __CellIDBroadcastEUTRA_Item_iE_Extensions__item_,
        _CellIDBroadcastEUTRA_Item_iE_Extensions,
        CellIDBroadcastEUTRA_Item,
        CellIDBroadcastEUTRA_Item_ExtIEs,
        _CellIDBroadcastNR__item_,
        CellIDBroadcastNR,
        _CellIDBroadcastNR_Item_nR_CGI,
        ____CellIDBroadcastNR_Item_iE_Extensions__item__id_tab,
        ___CellIDBroadcastNR_Item_iE_Extensions__item__id,
        ____CellIDBroadcastNR_Item_iE_Extensions__item__criticality_tab,
        ___CellIDBroadcastNR_Item_iE_Extensions__item__criticality,
        ____CellIDBroadcastNR_Item_iE_Extensions__item__extensionValue_tab,
        ___CellIDBroadcastNR_Item_iE_Extensions__item__extensionValue,
        __CellIDBroadcastNR_Item_iE_Extensions__item_,
        _CellIDBroadcastNR_Item_iE_Extensions,
        CellIDBroadcastNR_Item,
        CellIDBroadcastNR_Item_ExtIEs,
        _CellIDCancelledEUTRA__item_,
        CellIDCancelledEUTRA,
        _CellIDCancelledEUTRA_Item_eUTRA_CGI,
        _CellIDCancelledEUTRA_Item_numberOfBroadcasts,
        ____CellIDCancelledEUTRA_Item_iE_Extensions__item__id_tab,
        ___CellIDCancelledEUTRA_Item_iE_Extensions__item__id,
        ____CellIDCancelledEUTRA_Item_iE_Extensions__item__criticality_tab,
        ___CellIDCancelledEUTRA_Item_iE_Extensions__item__criticality,
        ____CellIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___CellIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue,
        __CellIDCancelledEUTRA_Item_iE_Extensions__item_,
        _CellIDCancelledEUTRA_Item_iE_Extensions,
        CellIDCancelledEUTRA_Item,
        CellIDCancelledEUTRA_Item_ExtIEs,
        _CellIDCancelledNR__item_,
        CellIDCancelledNR,
        _CellIDCancelledNR_Item_nR_CGI,
        _CellIDCancelledNR_Item_numberOfBroadcasts,
        ____CellIDCancelledNR_Item_iE_Extensions__item__id_tab,
        ___CellIDCancelledNR_Item_iE_Extensions__item__id,
        ____CellIDCancelledNR_Item_iE_Extensions__item__criticality_tab,
        ___CellIDCancelledNR_Item_iE_Extensions__item__criticality,
        ____CellIDCancelledNR_Item_iE_Extensions__item__extensionValue_tab,
        ___CellIDCancelledNR_Item_iE_Extensions__item__extensionValue,
        __CellIDCancelledNR_Item_iE_Extensions__item_,
        _CellIDCancelledNR_Item_iE_Extensions,
        CellIDCancelledNR_Item,
        CellIDCancelledNR_Item_ExtIEs,
        _CellIDListForRestart_eUTRA_CGIListforRestart,
        _CellIDListForRestart_nR_CGIListforRestart,
        ___CellIDListForRestart_choice_Extensions_id_tab,
        __CellIDListForRestart_choice_Extensions_id,
        ___CellIDListForRestart_choice_Extensions_criticality_tab,
        __CellIDListForRestart_choice_Extensions_criticality,
        ___CellIDListForRestart_choice_Extensions_value_tab,
        __CellIDListForRestart_choice_Extensions_value,
        _CellIDListForRestart_choice_Extensions,
        CellIDListForRestart,
        CellIDListForRestart_ExtIEs,
        CellSize,
        _CellType_cellSize,
        ____CellType_iE_Extensions__item__id_tab,
        ___CellType_iE_Extensions__item__id,
        ____CellType_iE_Extensions__item__criticality_tab,
        ___CellType_iE_Extensions__item__criticality,
        ____CellType_iE_Extensions__item__extensionValue_tab,
        ___CellType_iE_Extensions__item__extensionValue,
        __CellType_iE_Extensions__item_,
        _CellType_iE_Extensions,
        CellType,
        CellType_ExtIEs,
        CEmodeBSupport_Indicator,
        CEmodeBrestricted,
        _CNAssistedRANTuning_expectedUEBehaviour,
        ____CNAssistedRANTuning_iE_Extensions__item__id_tab,
        ___CNAssistedRANTuning_iE_Extensions__item__id,
        ____CNAssistedRANTuning_iE_Extensions__item__criticality_tab,
        ___CNAssistedRANTuning_iE_Extensions__item__criticality,
        ____CNAssistedRANTuning_iE_Extensions__item__extensionValue_tab,
        ___CNAssistedRANTuning_iE_Extensions__item__extensionValue,
        __CNAssistedRANTuning_iE_Extensions__item_,
        _CNAssistedRANTuning_iE_Extensions,
        CNAssistedRANTuning,
        CNAssistedRANTuning_ExtIEs,
        CNsubgroupID,
        _CNTypeRestrictionsForEquivalent__item_,
        CNTypeRestrictionsForEquivalent,
        _CNTypeRestrictionsForEquivalentItem_plmnIdentity,
        _CNTypeRestrictionsForEquivalentItem_cn_Type,
        ____CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__id_tab,
        ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__id,
        ____CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__criticality_tab,
        ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__criticality,
        ____CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__extensionValue_tab,
        ___CNTypeRestrictionsForEquivalentItem_iE_Extensions__item__extensionValue,
        __CNTypeRestrictionsForEquivalentItem_iE_Extensions__item_,
        _CNTypeRestrictionsForEquivalentItem_iE_Extensions,
        CNTypeRestrictionsForEquivalentItem,
        CNTypeRestrictionsForEquivalentItem_ExtIEs,
        CNTypeRestrictionsForServing,
        CommonNetworkInstance,
        _CompletedCellsInEAI_EUTRA__item_,
        CompletedCellsInEAI_EUTRA,
        _CompletedCellsInEAI_EUTRA_Item_eUTRA_CGI,
        ____CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__id_tab,
        ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__id,
        ____CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality_tab,
        ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__criticality,
        ____CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item__extensionValue,
        __CompletedCellsInEAI_EUTRA_Item_iE_Extensions__item_,
        _CompletedCellsInEAI_EUTRA_Item_iE_Extensions,
        CompletedCellsInEAI_EUTRA_Item,
        CompletedCellsInEAI_EUTRA_Item_ExtIEs,
        _CompletedCellsInEAI_NR__item_,
        CompletedCellsInEAI_NR,
        _CompletedCellsInEAI_NR_Item_nR_CGI,
        ____CompletedCellsInEAI_NR_Item_iE_Extensions__item__id_tab,
        ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__id,
        ____CompletedCellsInEAI_NR_Item_iE_Extensions__item__criticality_tab,
        ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__criticality,
        ____CompletedCellsInEAI_NR_Item_iE_Extensions__item__extensionValue_tab,
        ___CompletedCellsInEAI_NR_Item_iE_Extensions__item__extensionValue,
        __CompletedCellsInEAI_NR_Item_iE_Extensions__item_,
        _CompletedCellsInEAI_NR_Item_iE_Extensions,
        CompletedCellsInEAI_NR_Item,
        CompletedCellsInEAI_NR_Item_ExtIEs,
        _CompletedCellsInTAI_EUTRA__item_,
        CompletedCellsInTAI_EUTRA,
        _CompletedCellsInTAI_EUTRA_Item_eUTRA_CGI,
        ____CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__id_tab,
        ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__id,
        ____CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality_tab,
        ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__criticality,
        ____CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item__extensionValue,
        __CompletedCellsInTAI_EUTRA_Item_iE_Extensions__item_,
        _CompletedCellsInTAI_EUTRA_Item_iE_Extensions,
        CompletedCellsInTAI_EUTRA_Item,
        CompletedCellsInTAI_EUTRA_Item_ExtIEs,
        _CompletedCellsInTAI_NR__item_,
        CompletedCellsInTAI_NR,
        _CompletedCellsInTAI_NR_Item_nR_CGI,
        ____CompletedCellsInTAI_NR_Item_iE_Extensions__item__id_tab,
        ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__id,
        ____CompletedCellsInTAI_NR_Item_iE_Extensions__item__criticality_tab,
        ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__criticality,
        ____CompletedCellsInTAI_NR_Item_iE_Extensions__item__extensionValue_tab,
        ___CompletedCellsInTAI_NR_Item_iE_Extensions__item__extensionValue,
        __CompletedCellsInTAI_NR_Item_iE_Extensions__item_,
        _CompletedCellsInTAI_NR_Item_iE_Extensions,
        CompletedCellsInTAI_NR_Item,
        CompletedCellsInTAI_NR_Item_ExtIEs,
        ConcurrentWarningMessageInd,
        ConfidentialityProtectionIndication,
        ConfidentialityProtectionResult,
        ConfiguredTACIndication,
        _CoreNetworkAssistanceInformationForInactive_uEIdentityIndexValue,
        _CoreNetworkAssistanceInformationForInactive_uESpecificDRX,
        _CoreNetworkAssistanceInformationForInactive_periodicRegistrationUpdateTimer,
        _CoreNetworkAssistanceInformationForInactive_mICOModeIndication,
        _CoreNetworkAssistanceInformationForInactive_tAIListForInactive,
        _CoreNetworkAssistanceInformationForInactive_expectedUEBehaviour,
        ____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab,
        _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_0,
        _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_1,
        _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_2,
        _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_3,
        _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_4,
        _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_5,
        _____CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id_tab_val_Extension_6,
        ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__id,
        ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__criticality,
        ___CoreNetworkAssistanceInformationForInactive_iE_Extensions__item__extensionValue,
        __CoreNetworkAssistanceInformationForInactive_iE_Extensions__item_,
        _CoreNetworkAssistanceInformationForInactive_iE_Extensions,
        CoreNetworkAssistanceInformationForInactive,
        CoreNetworkAssistanceInformationForInactive_ExtIEs,
        _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_0,
        _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_1,
        _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_2,
        _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_3,
        _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_4,
        _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_5,
        _CoreNetworkAssistanceInformationForInactive_ExtIEs_val_Extension_6,
        _COUNTValueForPDCP_SN12_pDCP_SN12,
        _COUNTValueForPDCP_SN12_hFN_PDCP_SN12,
        ____COUNTValueForPDCP_SN12_iE_Extensions__item__id_tab,
        ___COUNTValueForPDCP_SN12_iE_Extensions__item__id,
        ____COUNTValueForPDCP_SN12_iE_Extensions__item__criticality_tab,
        ___COUNTValueForPDCP_SN12_iE_Extensions__item__criticality,
        ____COUNTValueForPDCP_SN12_iE_Extensions__item__extensionValue_tab,
        ___COUNTValueForPDCP_SN12_iE_Extensions__item__extensionValue,
        __COUNTValueForPDCP_SN12_iE_Extensions__item_,
        _COUNTValueForPDCP_SN12_iE_Extensions,
        COUNTValueForPDCP_SN12,
        COUNTValueForPDCP_SN12_ExtIEs,
        _COUNTValueForPDCP_SN18_pDCP_SN18,
        _COUNTValueForPDCP_SN18_hFN_PDCP_SN18,
        ____COUNTValueForPDCP_SN18_iE_Extensions__item__id_tab,
        ___COUNTValueForPDCP_SN18_iE_Extensions__item__id,
        ____COUNTValueForPDCP_SN18_iE_Extensions__item__criticality_tab,
        ___COUNTValueForPDCP_SN18_iE_Extensions__item__criticality,
        ____COUNTValueForPDCP_SN18_iE_Extensions__item__extensionValue_tab,
        ___COUNTValueForPDCP_SN18_iE_Extensions__item__extensionValue,
        __COUNTValueForPDCP_SN18_iE_Extensions__item_,
        _COUNTValueForPDCP_SN18_iE_Extensions,
        COUNTValueForPDCP_SN18,
        COUNTValueForPDCP_SN18_ExtIEs,
        CoverageEnhancementLevel,
        _CPTransportLayerInformation_endpointIPAddress,
        ___CPTransportLayerInformation_choice_Extensions_id_tab,
        ____CPTransportLayerInformation_choice_Extensions_id_tab_val_Value_0,
        __CPTransportLayerInformation_choice_Extensions_id,
        __CPTransportLayerInformation_choice_Extensions_criticality,
        __CPTransportLayerInformation_choice_Extensions_value,
        _CPTransportLayerInformation_choice_Extensions,
        CPTransportLayerInformation,
        CPTransportLayerInformation_ExtIEs,
        _CPTransportLayerInformation_ExtIEs_val_Value_0,
        _CriticalityDiagnostics_procedureCode,
        _CriticalityDiagnostics_triggeringMessage,
        _CriticalityDiagnostics_procedureCriticality,
        _CriticalityDiagnostics_iEsCriticalityDiagnostics,
        ____CriticalityDiagnostics_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__id,
        ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_iE_Extensions__item_,
        _CriticalityDiagnostics_iE_Extensions,
        CriticalityDiagnostics,
        CriticalityDiagnostics_ExtIEs,
        _CriticalityDiagnostics_IE_List__item_,
        CriticalityDiagnostics_IE_List,
        _CriticalityDiagnostics_IE_Item_iECriticality,
        _CriticalityDiagnostics_IE_Item_iE_ID,
        _CriticalityDiagnostics_IE_Item_typeOfError,
        ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id,
        ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab,
        ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab,
        ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_IE_Item_iE_Extensions__item_,
        _CriticalityDiagnostics_IE_Item_iE_Extensions,
        CriticalityDiagnostics_IE_Item,
        CriticalityDiagnostics_IE_Item_ExtIEs,
        _CellBasedMDT_NR_cellIdListforMDT,
        ____CellBasedMDT_NR_iE_Extensions__item__id_tab,
        ___CellBasedMDT_NR_iE_Extensions__item__id,
        ____CellBasedMDT_NR_iE_Extensions__item__criticality_tab,
        ___CellBasedMDT_NR_iE_Extensions__item__criticality,
        ____CellBasedMDT_NR_iE_Extensions__item__extensionValue_tab,
        ___CellBasedMDT_NR_iE_Extensions__item__extensionValue,
        __CellBasedMDT_NR_iE_Extensions__item_,
        _CellBasedMDT_NR_iE_Extensions,
        CellBasedMDT_NR,
        CellBasedMDT_NR_ExtIEs,
        _CellIdListforMDT_NR__item_,
        CellIdListforMDT_NR,
        _CellBasedMDT_EUTRA_cellIdListforMDT,
        ____CellBasedMDT_EUTRA_iE_Extensions__item__id_tab,
        ___CellBasedMDT_EUTRA_iE_Extensions__item__id,
        ____CellBasedMDT_EUTRA_iE_Extensions__item__criticality_tab,
        ___CellBasedMDT_EUTRA_iE_Extensions__item__criticality,
        ____CellBasedMDT_EUTRA_iE_Extensions__item__extensionValue_tab,
        ___CellBasedMDT_EUTRA_iE_Extensions__item__extensionValue,
        __CellBasedMDT_EUTRA_iE_Extensions__item_,
        _CellBasedMDT_EUTRA_iE_Extensions,
        CellBasedMDT_EUTRA,
        CellBasedMDT_EUTRA_ExtIEs,
        _CellBasedQMC_cellIdListforQMC,
        ____CellBasedQMC_iE_Extensions__item__id_tab,
        ___CellBasedQMC_iE_Extensions__item__id,
        ____CellBasedQMC_iE_Extensions__item__criticality_tab,
        ___CellBasedQMC_iE_Extensions__item__criticality,
        ____CellBasedQMC_iE_Extensions__item__extensionValue_tab,
        ___CellBasedQMC_iE_Extensions__item__extensionValue,
        __CellBasedQMC_iE_Extensions__item_,
        _CellBasedQMC_iE_Extensions,
        CellBasedQMC,
        CellBasedQMC_ExtIEs,
        _CellIdListforQMC__item_,
        CellIdListforQMC,
        _CellIdListforMDT_EUTRA__item_,
        CellIdListforMDT_EUTRA,
        DataCodingScheme,
        DataForwardingAccepted,
        DataForwardingNotPossible,
        _DataForwardingResponseDRBList__item_,
        DataForwardingResponseDRBList,
        _DataForwardingResponseDRBItem_dRB_ID,
        _DataForwardingResponseDRBItem_dLForwardingUP_TNLInformation,
        _DataForwardingResponseDRBItem_uLForwardingUP_TNLInformation,
        ____DataForwardingResponseDRBItem_iE_Extensions__item__id_tab,
        ___DataForwardingResponseDRBItem_iE_Extensions__item__id,
        ____DataForwardingResponseDRBItem_iE_Extensions__item__criticality_tab,
        ___DataForwardingResponseDRBItem_iE_Extensions__item__criticality,
        ____DataForwardingResponseDRBItem_iE_Extensions__item__extensionValue_tab,
        ___DataForwardingResponseDRBItem_iE_Extensions__item__extensionValue,
        __DataForwardingResponseDRBItem_iE_Extensions__item_,
        _DataForwardingResponseDRBItem_iE_Extensions,
        DataForwardingResponseDRBItem,
        DataForwardingResponseDRBItem_ExtIEs,
        _DAPSRequestInfo_dAPSIndicator,
        ____DAPSRequestInfo_iE_Extensions__item__id_tab,
        ___DAPSRequestInfo_iE_Extensions__item__id,
        ____DAPSRequestInfo_iE_Extensions__item__criticality_tab,
        ___DAPSRequestInfo_iE_Extensions__item__criticality,
        ____DAPSRequestInfo_iE_Extensions__item__extensionValue_tab,
        ___DAPSRequestInfo_iE_Extensions__item__extensionValue,
        __DAPSRequestInfo_iE_Extensions__item_,
        _DAPSRequestInfo_iE_Extensions,
        DAPSRequestInfo,
        DAPSRequestInfo_ExtIEs,
        _DAPSResponseInfoList__item_,
        DAPSResponseInfoList,
        _DAPSResponseInfoItem_dRB_ID,
        _DAPSResponseInfoItem_dAPSResponseInfo,
        ____DAPSResponseInfoItem_iE_Extension__item__id_tab,
        ___DAPSResponseInfoItem_iE_Extension__item__id,
        ____DAPSResponseInfoItem_iE_Extension__item__criticality_tab,
        ___DAPSResponseInfoItem_iE_Extension__item__criticality,
        ____DAPSResponseInfoItem_iE_Extension__item__extensionValue_tab,
        ___DAPSResponseInfoItem_iE_Extension__item__extensionValue,
        __DAPSResponseInfoItem_iE_Extension__item_,
        _DAPSResponseInfoItem_iE_Extension,
        DAPSResponseInfoItem,
        DAPSResponseInfoItem_ExtIEs,
        _DAPSResponseInfo_dapsresponseindicator,
        ____DAPSResponseInfo_iE_Extensions__item__id_tab,
        ___DAPSResponseInfo_iE_Extensions__item__id,
        ____DAPSResponseInfo_iE_Extensions__item__criticality_tab,
        ___DAPSResponseInfo_iE_Extensions__item__criticality,
        ____DAPSResponseInfo_iE_Extensions__item__extensionValue_tab,
        ___DAPSResponseInfo_iE_Extensions__item__extensionValue,
        __DAPSResponseInfo_iE_Extensions__item_,
        _DAPSResponseInfo_iE_Extensions,
        DAPSResponseInfo,
        DAPSResponseInfo_ExtIEs,
        _DataForwardingResponseERABList__item_,
        DataForwardingResponseERABList,
        _DataForwardingResponseERABListItem_e_RAB_ID,
        _DataForwardingResponseERABListItem_dLForwardingUP_TNLInformation,
        ____DataForwardingResponseERABListItem_iE_Extensions__item__id_tab,
        ___DataForwardingResponseERABListItem_iE_Extensions__item__id,
        ____DataForwardingResponseERABListItem_iE_Extensions__item__criticality_tab,
        ___DataForwardingResponseERABListItem_iE_Extensions__item__criticality,
        ____DataForwardingResponseERABListItem_iE_Extensions__item__extensionValue_tab,
        ___DataForwardingResponseERABListItem_iE_Extensions__item__extensionValue,
        __DataForwardingResponseERABListItem_iE_Extensions__item_,
        _DataForwardingResponseERABListItem_iE_Extensions,
        DataForwardingResponseERABListItem,
        DataForwardingResponseERABListItem_ExtIEs,
        DelayCritical,
        _DL_CP_SecurityInformation_dl_NAS_MAC,
        ____DL_CP_SecurityInformation_iE_Extensions__item__id_tab,
        ___DL_CP_SecurityInformation_iE_Extensions__item__id,
        ____DL_CP_SecurityInformation_iE_Extensions__item__criticality_tab,
        ___DL_CP_SecurityInformation_iE_Extensions__item__criticality,
        ____DL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab,
        ___DL_CP_SecurityInformation_iE_Extensions__item__extensionValue,
        __DL_CP_SecurityInformation_iE_Extensions__item_,
        _DL_CP_SecurityInformation_iE_Extensions,
        DL_CP_SecurityInformation,
        DL_CP_SecurityInformation_ExtIEs,
        DL_NAS_MAC,
        DLForwarding,
        DL_NGU_TNLInformationReused,
        DirectForwardingPathAvailability,
        DRB_ID,
        _DRBsSubjectToStatusTransferList__item_,
        DRBsSubjectToStatusTransferList,
        _DRBsSubjectToStatusTransferItem_dRB_ID,
        _DRBsSubjectToStatusTransferItem_dRBStatusUL,
        _DRBsSubjectToStatusTransferItem_dRBStatusDL,
        ____DRBsSubjectToStatusTransferItem_iE_Extension__item__id_tab,
        _____DRBsSubjectToStatusTransferItem_iE_Extension__item__id_tab_val_Extension_0,
        ___DRBsSubjectToStatusTransferItem_iE_Extension__item__id,
        ___DRBsSubjectToStatusTransferItem_iE_Extension__item__criticality,
        ___DRBsSubjectToStatusTransferItem_iE_Extension__item__extensionValue,
        __DRBsSubjectToStatusTransferItem_iE_Extension__item_,
        _DRBsSubjectToStatusTransferItem_iE_Extension,
        DRBsSubjectToStatusTransferItem,
        DRBsSubjectToStatusTransferItem_ExtIEs,
        _DRBsSubjectToStatusTransferItem_ExtIEs_val_Extension_0,
        _DRBStatusDL_dRBStatusDL12,
        _DRBStatusDL_dRBStatusDL18,
        ___DRBStatusDL_choice_Extensions_id_tab,
        __DRBStatusDL_choice_Extensions_id,
        ___DRBStatusDL_choice_Extensions_criticality_tab,
        __DRBStatusDL_choice_Extensions_criticality,
        ___DRBStatusDL_choice_Extensions_value_tab,
        __DRBStatusDL_choice_Extensions_value,
        _DRBStatusDL_choice_Extensions,
        DRBStatusDL,
        DRBStatusDL_ExtIEs,
        _DRBStatusDL12_dL_COUNTValue,
        ____DRBStatusDL12_iE_Extension__item__id_tab,
        ___DRBStatusDL12_iE_Extension__item__id,
        ____DRBStatusDL12_iE_Extension__item__criticality_tab,
        ___DRBStatusDL12_iE_Extension__item__criticality,
        ____DRBStatusDL12_iE_Extension__item__extensionValue_tab,
        ___DRBStatusDL12_iE_Extension__item__extensionValue,
        __DRBStatusDL12_iE_Extension__item_,
        _DRBStatusDL12_iE_Extension,
        DRBStatusDL12,
        DRBStatusDL12_ExtIEs,
        _DRBStatusDL18_dL_COUNTValue,
        ____DRBStatusDL18_iE_Extension__item__id_tab,
        ___DRBStatusDL18_iE_Extension__item__id,
        ____DRBStatusDL18_iE_Extension__item__criticality_tab,
        ___DRBStatusDL18_iE_Extension__item__criticality,
        ____DRBStatusDL18_iE_Extension__item__extensionValue_tab,
        ___DRBStatusDL18_iE_Extension__item__extensionValue,
        __DRBStatusDL18_iE_Extension__item_,
        _DRBStatusDL18_iE_Extension,
        DRBStatusDL18,
        DRBStatusDL18_ExtIEs,
        _DRBStatusUL_dRBStatusUL12,
        _DRBStatusUL_dRBStatusUL18,
        ___DRBStatusUL_choice_Extensions_id_tab,
        __DRBStatusUL_choice_Extensions_id,
        ___DRBStatusUL_choice_Extensions_criticality_tab,
        __DRBStatusUL_choice_Extensions_criticality,
        ___DRBStatusUL_choice_Extensions_value_tab,
        __DRBStatusUL_choice_Extensions_value,
        _DRBStatusUL_choice_Extensions,
        DRBStatusUL,
        DRBStatusUL_ExtIEs,
        _DRBStatusUL12_uL_COUNTValue,
        _DRBStatusUL12_receiveStatusOfUL_PDCP_SDUs,
        ____DRBStatusUL12_iE_Extension__item__id_tab,
        ___DRBStatusUL12_iE_Extension__item__id,
        ____DRBStatusUL12_iE_Extension__item__criticality_tab,
        ___DRBStatusUL12_iE_Extension__item__criticality,
        ____DRBStatusUL12_iE_Extension__item__extensionValue_tab,
        ___DRBStatusUL12_iE_Extension__item__extensionValue,
        __DRBStatusUL12_iE_Extension__item_,
        _DRBStatusUL12_iE_Extension,
        DRBStatusUL12,
        DRBStatusUL12_ExtIEs,
        _DRBStatusUL18_uL_COUNTValue,
        _DRBStatusUL18_receiveStatusOfUL_PDCP_SDUs,
        ____DRBStatusUL18_iE_Extension__item__id_tab,
        ___DRBStatusUL18_iE_Extension__item__id,
        ____DRBStatusUL18_iE_Extension__item__criticality_tab,
        ___DRBStatusUL18_iE_Extension__item__criticality,
        ____DRBStatusUL18_iE_Extension__item__extensionValue_tab,
        ___DRBStatusUL18_iE_Extension__item__extensionValue,
        __DRBStatusUL18_iE_Extension__item_,
        _DRBStatusUL18_iE_Extension,
        DRBStatusUL18,
        DRBStatusUL18_ExtIEs,
        _DRBsToQosFlowsMappingList__item_,
        DRBsToQosFlowsMappingList,
        _DRBsToQosFlowsMappingItem_dRB_ID,
        _DRBsToQosFlowsMappingItem_associatedQosFlowList,
        ____DRBsToQosFlowsMappingItem_iE_Extensions__item__id_tab,
        _____DRBsToQosFlowsMappingItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___DRBsToQosFlowsMappingItem_iE_Extensions__item__id,
        ___DRBsToQosFlowsMappingItem_iE_Extensions__item__criticality,
        ___DRBsToQosFlowsMappingItem_iE_Extensions__item__extensionValue,
        __DRBsToQosFlowsMappingItem_iE_Extensions__item_,
        _DRBsToQosFlowsMappingItem_iE_Extensions,
        DRBsToQosFlowsMappingItem,
        DRBsToQosFlowsMappingItem_ExtIEs,
        _DRBsToQosFlowsMappingItem_ExtIEs_val_Extension_0,
        _Dynamic5QIDescriptor_priorityLevelQos,
        _Dynamic5QIDescriptor_packetDelayBudget,
        _Dynamic5QIDescriptor_packetErrorRate,
        _Dynamic5QIDescriptor_fiveQI,
        _Dynamic5QIDescriptor_delayCritical,
        _Dynamic5QIDescriptor_averagingWindow,
        _Dynamic5QIDescriptor_maximumDataBurstVolume,
        ____Dynamic5QIDescriptor_iE_Extensions__item__id_tab,
        _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0,
        _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1,
        _____Dynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_2,
        ___Dynamic5QIDescriptor_iE_Extensions__item__id,
        ___Dynamic5QIDescriptor_iE_Extensions__item__criticality,
        ___Dynamic5QIDescriptor_iE_Extensions__item__extensionValue,
        __Dynamic5QIDescriptor_iE_Extensions__item_,
        _Dynamic5QIDescriptor_iE_Extensions,
        Dynamic5QIDescriptor,
        Dynamic5QIDescriptor_ExtIEs,
        _Dynamic5QIDescriptor_ExtIEs_val_Extension_0,
        _Dynamic5QIDescriptor_ExtIEs_val_Extension_1,
        _Dynamic5QIDescriptor_ExtIEs_val_Extension_2,
        EarlyMeasurement,
        _EarlyStatusTransfer_TransparentContainer_procedureStage,
        ____EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id_tab,
        ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id,
        ____EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab,
        ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality,
        ____EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab,
        ___EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue,
        __EarlyStatusTransfer_TransparentContainer_iE_Extensions__item_,
        _EarlyStatusTransfer_TransparentContainer_iE_Extensions,
        EarlyStatusTransfer_TransparentContainer,
        EarlyStatusTransfer_TransparentContainer_ExtIEs,
        _ProcedureStageChoice_first_dl_count,
        ___ProcedureStageChoice_choice_Extensions_id_tab,
        __ProcedureStageChoice_choice_Extensions_id,
        ___ProcedureStageChoice_choice_Extensions_criticality_tab,
        __ProcedureStageChoice_choice_Extensions_criticality,
        ___ProcedureStageChoice_choice_Extensions_value_tab,
        __ProcedureStageChoice_choice_Extensions_value,
        _ProcedureStageChoice_choice_Extensions,
        ProcedureStageChoice,
        ProcedureStageChoice_ExtIEs,
        _FirstDLCount_dRBsSubjectToEarlyStatusTransfer,
        ____FirstDLCount_iE_Extension__item__id_tab,
        ___FirstDLCount_iE_Extension__item__id,
        ____FirstDLCount_iE_Extension__item__criticality_tab,
        ___FirstDLCount_iE_Extension__item__criticality,
        ____FirstDLCount_iE_Extension__item__extensionValue_tab,
        ___FirstDLCount_iE_Extension__item__extensionValue,
        __FirstDLCount_iE_Extension__item_,
        _FirstDLCount_iE_Extension,
        FirstDLCount,
        FirstDLCount_ExtIEs,
        _DRBsSubjectToEarlyStatusTransfer_List__item_,
        DRBsSubjectToEarlyStatusTransfer_List,
        _DRBsSubjectToEarlyStatusTransfer_Item_dRB_ID,
        _DRBsSubjectToEarlyStatusTransfer_Item_firstDLCOUNT,
        ____DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id_tab,
        ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__id,
        ____DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality_tab,
        ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__criticality,
        ____DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue_tab,
        ___DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item__extensionValue,
        __DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension__item_,
        _DRBsSubjectToEarlyStatusTransfer_Item_iE_Extension,
        DRBsSubjectToEarlyStatusTransfer_Item,
        DRBsSubjectToEarlyStatusTransfer_Item_ExtIEs,
        EDT_Session,
        EmergencyAreaID,
        _EmergencyAreaIDBroadcastEUTRA__item_,
        EmergencyAreaIDBroadcastEUTRA,
        _EmergencyAreaIDBroadcastEUTRA_Item_emergencyAreaID,
        _EmergencyAreaIDBroadcastEUTRA_Item_completedCellsInEAI_EUTRA,
        ____EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__id_tab,
        ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__id,
        ____EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__criticality_tab,
        ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__criticality,
        ____EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item__extensionValue,
        __EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions__item_,
        _EmergencyAreaIDBroadcastEUTRA_Item_iE_Extensions,
        EmergencyAreaIDBroadcastEUTRA_Item,
        EmergencyAreaIDBroadcastEUTRA_Item_ExtIEs,
        _EmergencyAreaIDBroadcastNR__item_,
        EmergencyAreaIDBroadcastNR,
        _EmergencyAreaIDBroadcastNR_Item_emergencyAreaID,
        _EmergencyAreaIDBroadcastNR_Item_completedCellsInEAI_NR,
        ____EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__id_tab,
        ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__id,
        ____EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__criticality_tab,
        ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__criticality,
        ____EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__extensionValue_tab,
        ___EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item__extensionValue,
        __EmergencyAreaIDBroadcastNR_Item_iE_Extensions__item_,
        _EmergencyAreaIDBroadcastNR_Item_iE_Extensions,
        EmergencyAreaIDBroadcastNR_Item,
        EmergencyAreaIDBroadcastNR_Item_ExtIEs,
        _EmergencyAreaIDCancelledEUTRA__item_,
        EmergencyAreaIDCancelledEUTRA,
        _EmergencyAreaIDCancelledEUTRA_Item_emergencyAreaID,
        _EmergencyAreaIDCancelledEUTRA_Item_cancelledCellsInEAI_EUTRA,
        ____EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__id_tab,
        ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__id,
        ____EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__criticality_tab,
        ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__criticality,
        ____EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item__extensionValue,
        __EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions__item_,
        _EmergencyAreaIDCancelledEUTRA_Item_iE_Extensions,
        EmergencyAreaIDCancelledEUTRA_Item,
        EmergencyAreaIDCancelledEUTRA_Item_ExtIEs,
        _EmergencyAreaIDCancelledNR__item_,
        EmergencyAreaIDCancelledNR,
        _EmergencyAreaIDCancelledNR_Item_emergencyAreaID,
        _EmergencyAreaIDCancelledNR_Item_cancelledCellsInEAI_NR,
        ____EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__id_tab,
        ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__id,
        ____EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__criticality_tab,
        ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__criticality,
        ____EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__extensionValue_tab,
        ___EmergencyAreaIDCancelledNR_Item_iE_Extensions__item__extensionValue,
        __EmergencyAreaIDCancelledNR_Item_iE_Extensions__item_,
        _EmergencyAreaIDCancelledNR_Item_iE_Extensions,
        EmergencyAreaIDCancelledNR_Item,
        EmergencyAreaIDCancelledNR_Item_ExtIEs,
        _EmergencyAreaIDList__item_,
        EmergencyAreaIDList,
        _EmergencyAreaIDListForRestart__item_,
        EmergencyAreaIDListForRestart,
        _EmergencyFallbackIndicator_emergencyFallbackRequestIndicator,
        _EmergencyFallbackIndicator_emergencyServiceTargetCN,
        ____EmergencyFallbackIndicator_iE_Extensions__item__id_tab,
        ___EmergencyFallbackIndicator_iE_Extensions__item__id,
        ____EmergencyFallbackIndicator_iE_Extensions__item__criticality_tab,
        ___EmergencyFallbackIndicator_iE_Extensions__item__criticality,
        ____EmergencyFallbackIndicator_iE_Extensions__item__extensionValue_tab,
        ___EmergencyFallbackIndicator_iE_Extensions__item__extensionValue,
        __EmergencyFallbackIndicator_iE_Extensions__item_,
        _EmergencyFallbackIndicator_iE_Extensions,
        EmergencyFallbackIndicator,
        EmergencyFallbackIndicator_ExtIEs,
        EmergencyFallbackRequestIndicator,
        EmergencyServiceTargetCN,
        _ENB_ID_macroENB_ID,
        _ENB_ID_homeENB_ID,
        _ENB_ID_short_macroENB_ID,
        _ENB_ID_long_macroENB_ID,
        ___ENB_ID_choice_Extensions_id_tab,
        __ENB_ID_choice_Extensions_id,
        ___ENB_ID_choice_Extensions_criticality_tab,
        __ENB_ID_choice_Extensions_criticality,
        ___ENB_ID_choice_Extensions_value_tab,
        __ENB_ID_choice_Extensions_value,
        _ENB_ID_choice_Extensions,
        ENB_ID,
        ENB_ID_ExtIEs,
        Enhanced_CoverageRestriction,
        Extended_ConnectedTime,
        EN_DCSONConfigurationTransfer,
        _EndpointIPAddressAndPort_endpointIPAddress,
        _EndpointIPAddressAndPort_portNumber,
        ____EndpointIPAddressAndPort_iE_Extensions__item__id_tab,
        ___EndpointIPAddressAndPort_iE_Extensions__item__id,
        ____EndpointIPAddressAndPort_iE_Extensions__item__criticality_tab,
        ___EndpointIPAddressAndPort_iE_Extensions__item__criticality,
        ____EndpointIPAddressAndPort_iE_Extensions__item__extensionValue_tab,
        ___EndpointIPAddressAndPort_iE_Extensions__item__extensionValue,
        __EndpointIPAddressAndPort_iE_Extensions__item_,
        _EndpointIPAddressAndPort_iE_Extensions,
        EndpointIPAddressAndPort,
        EndIndication,
        EndpointIPAddressAndPort_ExtIEs,
        _EquivalentPLMNs__item_,
        EquivalentPLMNs,
        EPS_TAC,
        _EPS_TAI_pLMNIdentity,
        _EPS_TAI_ePS_TAC,
        ____EPS_TAI_iE_Extensions__item__id_tab,
        ___EPS_TAI_iE_Extensions__item__id,
        ____EPS_TAI_iE_Extensions__item__criticality_tab,
        ___EPS_TAI_iE_Extensions__item__criticality,
        ____EPS_TAI_iE_Extensions__item__extensionValue_tab,
        ___EPS_TAI_iE_Extensions__item__extensionValue,
        __EPS_TAI_iE_Extensions__item_,
        _EPS_TAI_iE_Extensions,
        EPS_TAI,
        EPS_TAI_ExtIEs,
        E_RAB_ID,
        _E_RABInformationList__item_,
        E_RABInformationList,
        _E_RABInformationItem_e_RAB_ID,
        _E_RABInformationItem_dLForwarding,
        ____E_RABInformationItem_iE_Extensions__item__id_tab,
        _____E_RABInformationItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABInformationItem_iE_Extensions__item__id_tab_val_Extension_1,
        ___E_RABInformationItem_iE_Extensions__item__id,
        ___E_RABInformationItem_iE_Extensions__item__criticality,
        ___E_RABInformationItem_iE_Extensions__item__extensionValue,
        __E_RABInformationItem_iE_Extensions__item_,
        _E_RABInformationItem_iE_Extensions,
        E_RABInformationItem,
        E_RABInformationItem_ExtIEs,
        _E_RABInformationItem_ExtIEs_val_Extension_0,
        _E_RABInformationItem_ExtIEs_val_Extension_1,
        EUTRACellIdentity,
        _EUTRA_CGI_pLMNIdentity,
        _EUTRA_CGI_eUTRACellIdentity,
        ____EUTRA_CGI_iE_Extensions__item__id_tab,
        ___EUTRA_CGI_iE_Extensions__item__id,
        ____EUTRA_CGI_iE_Extensions__item__criticality_tab,
        ___EUTRA_CGI_iE_Extensions__item__criticality,
        ____EUTRA_CGI_iE_Extensions__item__extensionValue_tab,
        ___EUTRA_CGI_iE_Extensions__item__extensionValue,
        __EUTRA_CGI_iE_Extensions__item_,
        _EUTRA_CGI_iE_Extensions,
        EUTRA_CGI,
        EUTRA_CGI_ExtIEs,
        _EUTRA_CGIList__item_,
        EUTRA_CGIList,
        _EUTRA_CGIListForWarning__item_,
        EUTRA_CGIListForWarning,
        _EUTRA_PagingeDRXInformation_eUTRA_paging_eDRX_Cycle,
        _EUTRA_PagingeDRXInformation_eUTRA_paging_Time_Window,
        ____EUTRA_PagingeDRXInformation_iE_Extensions__item__id_tab,
        ___EUTRA_PagingeDRXInformation_iE_Extensions__item__id,
        ____EUTRA_PagingeDRXInformation_iE_Extensions__item__criticality_tab,
        ___EUTRA_PagingeDRXInformation_iE_Extensions__item__criticality,
        ____EUTRA_PagingeDRXInformation_iE_Extensions__item__extensionValue_tab,
        ___EUTRA_PagingeDRXInformation_iE_Extensions__item__extensionValue,
        __EUTRA_PagingeDRXInformation_iE_Extensions__item_,
        _EUTRA_PagingeDRXInformation_iE_Extensions,
        EUTRA_PagingeDRXInformation,
        EUTRA_PagingeDRXInformation_ExtIEs,
        EUTRA_Paging_eDRX_Cycle,
        EUTRA_Paging_Time_Window,
        EUTRAencryptionAlgorithms,
        EUTRAintegrityProtectionAlgorithms,
        EventType,
        _ExcessPacketDelayThresholdConfiguration__item_,
        ExcessPacketDelayThresholdConfiguration,
        _ExcessPacketDelayThresholdItem_fiveQi,
        _ExcessPacketDelayThresholdItem_excessPacketDelayThresholdValue,
        ____ExcessPacketDelayThresholdItem_iE_Extensions__item__id_tab,
        ___ExcessPacketDelayThresholdItem_iE_Extensions__item__id,
        ____ExcessPacketDelayThresholdItem_iE_Extensions__item__criticality_tab,
        ___ExcessPacketDelayThresholdItem_iE_Extensions__item__criticality,
        ____ExcessPacketDelayThresholdItem_iE_Extensions__item__extensionValue_tab,
        ___ExcessPacketDelayThresholdItem_iE_Extensions__item__extensionValue,
        __ExcessPacketDelayThresholdItem_iE_Extensions__item_,
        _ExcessPacketDelayThresholdItem_iE_Extensions,
        ExcessPacketDelayThresholdItem,
        ExcessPacketDelayThresholdItem_ExtIEs,
        ExcessPacketDelayThresholdValue,
        ExpectedActivityPeriod,
        ExpectedHOInterval,
        ExpectedIdlePeriod,
        _ExpectedUEActivityBehaviour_expectedActivityPeriod,
        _ExpectedUEActivityBehaviour_expectedIdlePeriod,
        _ExpectedUEActivityBehaviour_sourceOfUEActivityBehaviourInformation,
        ____ExpectedUEActivityBehaviour_iE_Extensions__item__id_tab,
        ___ExpectedUEActivityBehaviour_iE_Extensions__item__id,
        ____ExpectedUEActivityBehaviour_iE_Extensions__item__criticality_tab,
        ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality,
        ____ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue_tab,
        ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue,
        __ExpectedUEActivityBehaviour_iE_Extensions__item_,
        _ExpectedUEActivityBehaviour_iE_Extensions,
        ExpectedUEActivityBehaviour,
        ExpectedUEActivityBehaviour_ExtIEs,
        _ExpectedUEBehaviour_expectedUEActivityBehaviour,
        _ExpectedUEBehaviour_expectedHOInterval,
        _ExpectedUEBehaviour_expectedUEMobility,
        _ExpectedUEBehaviour_expectedUEMovingTrajectory,
        ____ExpectedUEBehaviour_iE_Extensions__item__id_tab,
        ___ExpectedUEBehaviour_iE_Extensions__item__id,
        ____ExpectedUEBehaviour_iE_Extensions__item__criticality_tab,
        ___ExpectedUEBehaviour_iE_Extensions__item__criticality,
        ____ExpectedUEBehaviour_iE_Extensions__item__extensionValue_tab,
        ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue,
        __ExpectedUEBehaviour_iE_Extensions__item_,
        _ExpectedUEBehaviour_iE_Extensions,
        ExpectedUEBehaviour,
        ExpectedUEBehaviour_ExtIEs,
        ExpectedUEMobility,
        _ExpectedUEMovingTrajectory__item_,
        ExpectedUEMovingTrajectory,
        _ExpectedUEMovingTrajectoryItem_nGRAN_CGI,
        _ExpectedUEMovingTrajectoryItem_timeStayedInCell,
        ____ExpectedUEMovingTrajectoryItem_iE_Extensions__item__id_tab,
        ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__id,
        ____ExpectedUEMovingTrajectoryItem_iE_Extensions__item__criticality_tab,
        ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__criticality,
        ____ExpectedUEMovingTrajectoryItem_iE_Extensions__item__extensionValue_tab,
        ___ExpectedUEMovingTrajectoryItem_iE_Extensions__item__extensionValue,
        __ExpectedUEMovingTrajectoryItem_iE_Extensions__item_,
        _ExpectedUEMovingTrajectoryItem_iE_Extensions,
        ExpectedUEMovingTrajectoryItem,
        ExpectedUEMovingTrajectoryItem_ExtIEs,
        _Extended_AMFName_aMFNameVisibleString,
        _Extended_AMFName_aMFNameUTF8String,
        ____Extended_AMFName_iE_Extensions__item__id_tab,
        ___Extended_AMFName_iE_Extensions__item__id,
        ____Extended_AMFName_iE_Extensions__item__criticality_tab,
        ___Extended_AMFName_iE_Extensions__item__criticality,
        ____Extended_AMFName_iE_Extensions__item__extensionValue_tab,
        ___Extended_AMFName_iE_Extensions__item__extensionValue,
        __Extended_AMFName_iE_Extensions__item_,
        _Extended_AMFName_iE_Extensions,
        Extended_AMFName,
        Extended_AMFName_ExtIEs,
        ExtendedPacketDelayBudget,
        _Extended_RANNodeName_rANNodeNameVisibleString,
        _Extended_RANNodeName_rANNodeNameUTF8String,
        ____Extended_RANNodeName_iE_Extensions__item__id_tab,
        ___Extended_RANNodeName_iE_Extensions__item__id,
        ____Extended_RANNodeName_iE_Extensions__item__criticality_tab,
        ___Extended_RANNodeName_iE_Extensions__item__criticality,
        ____Extended_RANNodeName_iE_Extensions__item__extensionValue_tab,
        ___Extended_RANNodeName_iE_Extensions__item__extensionValue,
        __Extended_RANNodeName_iE_Extensions__item_,
        _Extended_RANNodeName_iE_Extensions,
        Extended_RANNodeName,
        Extended_RANNodeName_ExtIEs,
        _ExtendedRATRestrictionInformation_primaryRATRestriction,
        _ExtendedRATRestrictionInformation_secondaryRATRestriction,
        ____ExtendedRATRestrictionInformation_iE_Extensions__item__id_tab,
        ___ExtendedRATRestrictionInformation_iE_Extensions__item__id,
        ____ExtendedRATRestrictionInformation_iE_Extensions__item__criticality_tab,
        ___ExtendedRATRestrictionInformation_iE_Extensions__item__criticality,
        ____ExtendedRATRestrictionInformation_iE_Extensions__item__extensionValue_tab,
        ___ExtendedRATRestrictionInformation_iE_Extensions__item__extensionValue,
        __ExtendedRATRestrictionInformation_iE_Extensions__item_,
        _ExtendedRATRestrictionInformation_iE_Extensions,
        ExtendedRATRestrictionInformation,
        ExtendedRATRestrictionInformation_ExtIEs,
        ExtendedRNC_ID,
        _ExtendedSliceSupportList__item_,
        ExtendedSliceSupportList,
        ExtendedUEIdentityIndexValue,
        _EventTrigger_outOfCoverage,
        _EventTrigger_eventL1LoggedMDTConfig,
        ___EventTrigger_choice_Extensions_id_tab,
        __EventTrigger_choice_Extensions_id,
        ___EventTrigger_choice_Extensions_criticality_tab,
        __EventTrigger_choice_Extensions_criticality,
        ___EventTrigger_choice_Extensions_value_tab,
        __EventTrigger_choice_Extensions_value,
        _EventTrigger_choice_Extensions,
        EventTrigger,
        EventTrigger_ExtIEs,
        _EventL1LoggedMDTConfig_l1Threshold,
        _EventL1LoggedMDTConfig_hysteresis,
        _EventL1LoggedMDTConfig_timeToTrigger,
        ____EventL1LoggedMDTConfig_iE_Extensions__item__id_tab,
        ___EventL1LoggedMDTConfig_iE_Extensions__item__id,
        ____EventL1LoggedMDTConfig_iE_Extensions__item__criticality_tab,
        ___EventL1LoggedMDTConfig_iE_Extensions__item__criticality,
        ____EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue_tab,
        ___EventL1LoggedMDTConfig_iE_Extensions__item__extensionValue,
        __EventL1LoggedMDTConfig_iE_Extensions__item_,
        _EventL1LoggedMDTConfig_iE_Extensions,
        EventL1LoggedMDTConfig,
        EventL1LoggedMDTConfig_ExtIEs,
        _MeasurementThresholdL1LoggedMDT_threshold_RSRP,
        _MeasurementThresholdL1LoggedMDT_threshold_RSRQ,
        ___MeasurementThresholdL1LoggedMDT_choice_Extensions_id_tab,
        __MeasurementThresholdL1LoggedMDT_choice_Extensions_id,
        ___MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality_tab,
        __MeasurementThresholdL1LoggedMDT_choice_Extensions_criticality,
        ___MeasurementThresholdL1LoggedMDT_choice_Extensions_value_tab,
        __MeasurementThresholdL1LoggedMDT_choice_Extensions_value,
        _MeasurementThresholdL1LoggedMDT_choice_Extensions,
        MeasurementThresholdL1LoggedMDT,
        MeasurementThresholdL1LoggedMDT_ExtIEs,
        _FailureIndication_uERLFReportContainer,
        ____FailureIndication_iE_Extensions__item__id_tab,
        ___FailureIndication_iE_Extensions__item__id,
        ____FailureIndication_iE_Extensions__item__criticality_tab,
        ___FailureIndication_iE_Extensions__item__criticality,
        ____FailureIndication_iE_Extensions__item__extensionValue_tab,
        ___FailureIndication_iE_Extensions__item__extensionValue,
        __FailureIndication_iE_Extensions__item_,
        _FailureIndication_iE_Extensions,
        FailureIndication,
        FailureIndication_ExtIEs,
        _FiveG_ProSeAuthorized_fiveGProSeDirectDiscovery,
        _FiveG_ProSeAuthorized_fiveGProSeDirectCommunication,
        _FiveG_ProSeAuthorized_fiveGProSeLayer2UEtoNetworkRelay,
        _FiveG_ProSeAuthorized_fiveGProSeLayer3UEtoNetworkRelay,
        _FiveG_ProSeAuthorized_fiveGProSeLayer2RemoteUE,
        ____FiveG_ProSeAuthorized_iE_Extensions__item__id_tab,
        ___FiveG_ProSeAuthorized_iE_Extensions__item__id,
        ____FiveG_ProSeAuthorized_iE_Extensions__item__criticality_tab,
        ___FiveG_ProSeAuthorized_iE_Extensions__item__criticality,
        ____FiveG_ProSeAuthorized_iE_Extensions__item__extensionValue_tab,
        ___FiveG_ProSeAuthorized_iE_Extensions__item__extensionValue,
        __FiveG_ProSeAuthorized_iE_Extensions__item_,
        _FiveG_ProSeAuthorized_iE_Extensions,
        FiveG_ProSeAuthorized,
        FiveG_ProSeAuthorized_ExtIEs,
        FiveGProSeDirectDiscovery,
        FiveGProSeDirectCommunication,
        FiveGProSeLayer2UEtoNetworkRelay,
        FiveGProSeLayer3UEtoNetworkRelay,
        FiveGProSeLayer2RemoteUE,
        _FiveG_ProSePC5QoSParameters_fiveGProSepc5QoSFlowList,
        _FiveG_ProSePC5QoSParameters_fiveGProSepc5LinkAggregateBitRates,
        ____FiveG_ProSePC5QoSParameters_iE_Extensions__item__id_tab,
        ___FiveG_ProSePC5QoSParameters_iE_Extensions__item__id,
        ____FiveG_ProSePC5QoSParameters_iE_Extensions__item__criticality_tab,
        ___FiveG_ProSePC5QoSParameters_iE_Extensions__item__criticality,
        ____FiveG_ProSePC5QoSParameters_iE_Extensions__item__extensionValue_tab,
        ___FiveG_ProSePC5QoSParameters_iE_Extensions__item__extensionValue,
        __FiveG_ProSePC5QoSParameters_iE_Extensions__item_,
        _FiveG_ProSePC5QoSParameters_iE_Extensions,
        FiveG_ProSePC5QoSParameters,
        FiveG_ProSePC5QoSParameters_ExtIEs,
        _FiveGProSePC5QoSFlowList__item_,
        FiveGProSePC5QoSFlowList,
        _FiveGProSePC5QoSFlowItem_fiveGproSepQI,
        _FiveGProSePC5QoSFlowItem_fiveGproSepc5FlowBitRates,
        _FiveGProSePC5QoSFlowItem_fiveGproSerange,
        ____FiveGProSePC5QoSFlowItem_iE_Extensions__item__id_tab,
        ___FiveGProSePC5QoSFlowItem_iE_Extensions__item__id,
        ____FiveGProSePC5QoSFlowItem_iE_Extensions__item__criticality_tab,
        ___FiveGProSePC5QoSFlowItem_iE_Extensions__item__criticality,
        ____FiveGProSePC5QoSFlowItem_iE_Extensions__item__extensionValue_tab,
        ___FiveGProSePC5QoSFlowItem_iE_Extensions__item__extensionValue,
        __FiveGProSePC5QoSFlowItem_iE_Extensions__item_,
        _FiveGProSePC5QoSFlowItem_iE_Extensions,
        FiveGProSePC5QoSFlowItem,
        FiveGProSePC5QoSFlowItem_ExtIEs,
        _FiveGProSePC5FlowBitRates_fiveGproSeguaranteedFlowBitRate,
        _FiveGProSePC5FlowBitRates_fiveGproSemaximumFlowBitRate,
        ____FiveGProSePC5FlowBitRates_iE_Extensions__item__id_tab,
        ___FiveGProSePC5FlowBitRates_iE_Extensions__item__id,
        ____FiveGProSePC5FlowBitRates_iE_Extensions__item__criticality_tab,
        ___FiveGProSePC5FlowBitRates_iE_Extensions__item__criticality,
        ____FiveGProSePC5FlowBitRates_iE_Extensions__item__extensionValue_tab,
        ___FiveGProSePC5FlowBitRates_iE_Extensions__item__extensionValue,
        __FiveGProSePC5FlowBitRates_iE_Extensions__item_,
        _FiveGProSePC5FlowBitRates_iE_Extensions,
        FiveGProSePC5FlowBitRates,
        FiveGProSePC5FlowBitRates_ExtIEs,
        _FiveG_S_TMSI_aMFSetID,
        _FiveG_S_TMSI_aMFPointer,
        _FiveG_S_TMSI_fiveG_TMSI,
        ____FiveG_S_TMSI_iE_Extensions__item__id_tab,
        ___FiveG_S_TMSI_iE_Extensions__item__id,
        ____FiveG_S_TMSI_iE_Extensions__item__criticality_tab,
        ___FiveG_S_TMSI_iE_Extensions__item__criticality,
        ____FiveG_S_TMSI_iE_Extensions__item__extensionValue_tab,
        ___FiveG_S_TMSI_iE_Extensions__item__extensionValue,
        __FiveG_S_TMSI_iE_Extensions__item_,
        _FiveG_S_TMSI_iE_Extensions,
        FiveG_S_TMSI,
        FiveG_S_TMSI_ExtIEs,
        FiveG_TMSI,
        FiveQI,
        _ForbiddenAreaInformation__item_,
        ForbiddenAreaInformation,
        _ForbiddenAreaInformation_Item_pLMNIdentity,
        _ForbiddenAreaInformation_Item_forbiddenTACs,
        ____ForbiddenAreaInformation_Item_iE_Extensions__item__id_tab,
        ___ForbiddenAreaInformation_Item_iE_Extensions__item__id,
        ____ForbiddenAreaInformation_Item_iE_Extensions__item__criticality_tab,
        ___ForbiddenAreaInformation_Item_iE_Extensions__item__criticality,
        ____ForbiddenAreaInformation_Item_iE_Extensions__item__extensionValue_tab,
        ___ForbiddenAreaInformation_Item_iE_Extensions__item__extensionValue,
        __ForbiddenAreaInformation_Item_iE_Extensions__item_,
        _ForbiddenAreaInformation_Item_iE_Extensions,
        ForbiddenAreaInformation_Item,
        ForbiddenAreaInformation_Item_ExtIEs,
        _ForbiddenTACs__item_,
        ForbiddenTACs,
        _FromEUTRANtoNGRAN_sourceeNBID,
        _FromEUTRANtoNGRAN_targetNGRANnodeID,
        ____FromEUTRANtoNGRAN_iE_Extensions__item__id_tab,
        ___FromEUTRANtoNGRAN_iE_Extensions__item__id,
        ____FromEUTRANtoNGRAN_iE_Extensions__item__criticality_tab,
        ___FromEUTRANtoNGRAN_iE_Extensions__item__criticality,
        ____FromEUTRANtoNGRAN_iE_Extensions__item__extensionValue_tab,
        ___FromEUTRANtoNGRAN_iE_Extensions__item__extensionValue,
        __FromEUTRANtoNGRAN_iE_Extensions__item_,
        _FromEUTRANtoNGRAN_iE_Extensions,
        FromEUTRANtoNGRAN,
        FromEUTRANtoNGRAN_ExtIEs,
        _FromNGRANtoEUTRAN_sourceNGRANnodeID,
        _FromNGRANtoEUTRAN_targeteNBID,
        ____FromNGRANtoEUTRAN_iE_Extensions__item__id_tab,
        ___FromNGRANtoEUTRAN_iE_Extensions__item__id,
        ____FromNGRANtoEUTRAN_iE_Extensions__item__criticality_tab,
        ___FromNGRANtoEUTRAN_iE_Extensions__item__criticality,
        ____FromNGRANtoEUTRAN_iE_Extensions__item__extensionValue_tab,
        ___FromNGRANtoEUTRAN_iE_Extensions__item__extensionValue,
        __FromNGRANtoEUTRAN_iE_Extensions__item_,
        _FromNGRANtoEUTRAN_iE_Extensions,
        FromNGRANtoEUTRAN,
        FromNGRANtoEUTRAN_ExtIEs,
        _GBR_QosInformation_maximumFlowBitRateDL,
        _GBR_QosInformation_maximumFlowBitRateUL,
        _GBR_QosInformation_guaranteedFlowBitRateDL,
        _GBR_QosInformation_guaranteedFlowBitRateUL,
        _GBR_QosInformation_notificationControl,
        _GBR_QosInformation_maximumPacketLossRateDL,
        _GBR_QosInformation_maximumPacketLossRateUL,
        ____GBR_QosInformation_iE_Extensions__item__id_tab,
        _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_0,
        ___GBR_QosInformation_iE_Extensions__item__id,
        ___GBR_QosInformation_iE_Extensions__item__criticality,
        ___GBR_QosInformation_iE_Extensions__item__extensionValue,
        __GBR_QosInformation_iE_Extensions__item_,
        _GBR_QosInformation_iE_Extensions,
        GBR_QosInformation,
        GBR_QosInformation_ExtIEs,
        _GBR_QosInformation_ExtIEs_val_Extension_0,
        GlobalCable_ID,
        _GlobalCable_ID_new_globalCable_ID,
        _GlobalCable_ID_new_tAI,
        ____GlobalCable_ID_new_iE_Extensions__item__id_tab,
        ___GlobalCable_ID_new_iE_Extensions__item__id,
        ____GlobalCable_ID_new_iE_Extensions__item__criticality_tab,
        ___GlobalCable_ID_new_iE_Extensions__item__criticality,
        ____GlobalCable_ID_new_iE_Extensions__item__extensionValue_tab,
        ___GlobalCable_ID_new_iE_Extensions__item__extensionValue,
        __GlobalCable_ID_new_iE_Extensions__item_,
        _GlobalCable_ID_new_iE_Extensions,
        GlobalCable_ID_new,
        GlobalCable_ID_new_ExtIEs,
        _GlobalENB_ID_pLMNidentity,
        _GlobalENB_ID_eNB_ID,
        ____GlobalENB_ID_iE_Extensions__item__id_tab,
        ___GlobalENB_ID_iE_Extensions__item__id,
        ____GlobalENB_ID_iE_Extensions__item__criticality_tab,
        ___GlobalENB_ID_iE_Extensions__item__criticality,
        ____GlobalENB_ID_iE_Extensions__item__extensionValue_tab,
        ___GlobalENB_ID_iE_Extensions__item__extensionValue,
        __GlobalENB_ID_iE_Extensions__item_,
        _GlobalENB_ID_iE_Extensions,
        GlobalENB_ID,
        GlobalENB_ID_ExtIEs,
        _GlobalGNB_ID_pLMNIdentity,
        _GlobalGNB_ID_gNB_ID,
        ____GlobalGNB_ID_iE_Extensions__item__id_tab,
        ___GlobalGNB_ID_iE_Extensions__item__id,
        ____GlobalGNB_ID_iE_Extensions__item__criticality_tab,
        ___GlobalGNB_ID_iE_Extensions__item__criticality,
        ____GlobalGNB_ID_iE_Extensions__item__extensionValue_tab,
        ___GlobalGNB_ID_iE_Extensions__item__extensionValue,
        __GlobalGNB_ID_iE_Extensions__item_,
        _GlobalGNB_ID_iE_Extensions,
        GlobalGNB_ID,
        GlobalGNB_ID_ExtIEs,
        _GlobalN3IWF_ID_pLMNIdentity,
        _GlobalN3IWF_ID_n3IWF_ID,
        ____GlobalN3IWF_ID_iE_Extensions__item__id_tab,
        ___GlobalN3IWF_ID_iE_Extensions__item__id,
        ____GlobalN3IWF_ID_iE_Extensions__item__criticality_tab,
        ___GlobalN3IWF_ID_iE_Extensions__item__criticality,
        ____GlobalN3IWF_ID_iE_Extensions__item__extensionValue_tab,
        ___GlobalN3IWF_ID_iE_Extensions__item__extensionValue,
        __GlobalN3IWF_ID_iE_Extensions__item_,
        _GlobalN3IWF_ID_iE_Extensions,
        GlobalN3IWF_ID,
        GlobalN3IWF_ID_ExtIEs,
        _GlobalLine_ID_globalLineIdentity,
        _GlobalLine_ID_lineType,
        ____GlobalLine_ID_iE_Extensions__item__id_tab,
        _____GlobalLine_ID_iE_Extensions__item__id_tab_val_Extension_0,
        ___GlobalLine_ID_iE_Extensions__item__id,
        ___GlobalLine_ID_iE_Extensions__item__criticality,
        ___GlobalLine_ID_iE_Extensions__item__extensionValue,
        __GlobalLine_ID_iE_Extensions__item_,
        _GlobalLine_ID_iE_Extensions,
        GlobalLine_ID,
        GlobalLine_ID_ExtIEs,
        _GlobalLine_ID_ExtIEs_val_Extension_0,
        GlobalLineIdentity,
        _GlobalNgENB_ID_pLMNIdentity,
        _GlobalNgENB_ID_ngENB_ID,
        ____GlobalNgENB_ID_iE_Extensions__item__id_tab,
        ___GlobalNgENB_ID_iE_Extensions__item__id,
        ____GlobalNgENB_ID_iE_Extensions__item__criticality_tab,
        ___GlobalNgENB_ID_iE_Extensions__item__criticality,
        ____GlobalNgENB_ID_iE_Extensions__item__extensionValue_tab,
        ___GlobalNgENB_ID_iE_Extensions__item__extensionValue,
        __GlobalNgENB_ID_iE_Extensions__item_,
        _GlobalNgENB_ID_iE_Extensions,
        GlobalNgENB_ID,
        GlobalNgENB_ID_ExtIEs,
        _GlobalRANNodeID_globalGNB_ID,
        _GlobalRANNodeID_globalNgENB_ID,
        _GlobalRANNodeID_globalN3IWF_ID,
        ___GlobalRANNodeID_choice_Extensions_id_tab,
        ____GlobalRANNodeID_choice_Extensions_id_tab_val_Value_0,
        ____GlobalRANNodeID_choice_Extensions_id_tab_val_Value_1,
        ____GlobalRANNodeID_choice_Extensions_id_tab_val_Value_2,
        __GlobalRANNodeID_choice_Extensions_id,
        __GlobalRANNodeID_choice_Extensions_criticality,
        __GlobalRANNodeID_choice_Extensions_value,
        _GlobalRANNodeID_choice_Extensions,
        GlobalRANNodeID,
        GlobalRANNodeID_ExtIEs,
        _GlobalRANNodeID_ExtIEs_val_Value_0,
        _GlobalRANNodeID_ExtIEs_val_Value_1,
        _GlobalRANNodeID_ExtIEs_val_Value_2,
        _GlobalTNGF_ID_pLMNIdentity,
        _GlobalTNGF_ID_tNGF_ID,
        ____GlobalTNGF_ID_iE_Extensions__item__id_tab,
        ___GlobalTNGF_ID_iE_Extensions__item__id,
        ____GlobalTNGF_ID_iE_Extensions__item__criticality_tab,
        ___GlobalTNGF_ID_iE_Extensions__item__criticality,
        ____GlobalTNGF_ID_iE_Extensions__item__extensionValue_tab,
        ___GlobalTNGF_ID_iE_Extensions__item__extensionValue,
        __GlobalTNGF_ID_iE_Extensions__item_,
        _GlobalTNGF_ID_iE_Extensions,
        GlobalTNGF_ID,
        GlobalTNGF_ID_ExtIEs,
        _GlobalTWIF_ID_pLMNIdentity,
        _GlobalTWIF_ID_tWIF_ID,
        ____GlobalTWIF_ID_iE_Extensions__item__id_tab,
        ___GlobalTWIF_ID_iE_Extensions__item__id,
        ____GlobalTWIF_ID_iE_Extensions__item__criticality_tab,
        ___GlobalTWIF_ID_iE_Extensions__item__criticality,
        ____GlobalTWIF_ID_iE_Extensions__item__extensionValue_tab,
        ___GlobalTWIF_ID_iE_Extensions__item__extensionValue,
        __GlobalTWIF_ID_iE_Extensions__item_,
        _GlobalTWIF_ID_iE_Extensions,
        GlobalTWIF_ID,
        GlobalTWIF_ID_ExtIEs,
        _GlobalW_AGF_ID_pLMNIdentity,
        _GlobalW_AGF_ID_w_AGF_ID,
        ____GlobalW_AGF_ID_iE_Extensions__item__id_tab,
        ___GlobalW_AGF_ID_iE_Extensions__item__id,
        ____GlobalW_AGF_ID_iE_Extensions__item__criticality_tab,
        ___GlobalW_AGF_ID_iE_Extensions__item__criticality,
        ____GlobalW_AGF_ID_iE_Extensions__item__extensionValue_tab,
        ___GlobalW_AGF_ID_iE_Extensions__item__extensionValue,
        __GlobalW_AGF_ID_iE_Extensions__item_,
        _GlobalW_AGF_ID_iE_Extensions,
        GlobalW_AGF_ID,
        GlobalW_AGF_ID_ExtIEs,
        _GNB_ID_gNB_ID,
        ___GNB_ID_choice_Extensions_id_tab,
        __GNB_ID_choice_Extensions_id,
        ___GNB_ID_choice_Extensions_criticality_tab,
        __GNB_ID_choice_Extensions_criticality,
        ___GNB_ID_choice_Extensions_value_tab,
        __GNB_ID_choice_Extensions_value,
        _GNB_ID_choice_Extensions,
        GNB_ID,
        GNB_ID_ExtIEs,
        GTP_TEID,
        _GTPTunnel_transportLayerAddress,
        _GTPTunnel_gTP_TEID,
        ____GTPTunnel_iE_Extensions__item__id_tab,
        ___GTPTunnel_iE_Extensions__item__id,
        ____GTPTunnel_iE_Extensions__item__criticality_tab,
        ___GTPTunnel_iE_Extensions__item__criticality,
        ____GTPTunnel_iE_Extensions__item__extensionValue_tab,
        ___GTPTunnel_iE_Extensions__item__extensionValue,
        __GTPTunnel_iE_Extensions__item_,
        _GTPTunnel_iE_Extensions,
        GTPTunnel,
        GTPTunnel_ExtIEs,
        _GUAMI_pLMNIdentity,
        _GUAMI_aMFRegionID,
        _GUAMI_aMFSetID,
        _GUAMI_aMFPointer,
        ____GUAMI_iE_Extensions__item__id_tab,
        ___GUAMI_iE_Extensions__item__id,
        ____GUAMI_iE_Extensions__item__criticality_tab,
        ___GUAMI_iE_Extensions__item__criticality,
        ____GUAMI_iE_Extensions__item__extensionValue_tab,
        ___GUAMI_iE_Extensions__item__extensionValue,
        __GUAMI_iE_Extensions__item_,
        _GUAMI_iE_Extensions,
        GUAMI,
        GUAMI_ExtIEs,
        GUAMIType,
        _HandoverCommandTransfer_dLForwardingUP_TNLInformation,
        _HandoverCommandTransfer_qosFlowToBeForwardedList,
        _HandoverCommandTransfer_dataForwardingResponseDRBList,
        ____HandoverCommandTransfer_iE_Extensions__item__id_tab,
        _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_0,
        _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_1,
        _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_2,
        _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_3,
        _____HandoverCommandTransfer_iE_Extensions__item__id_tab_val_Extension_4,
        ___HandoverCommandTransfer_iE_Extensions__item__id,
        ___HandoverCommandTransfer_iE_Extensions__item__criticality,
        ___HandoverCommandTransfer_iE_Extensions__item__extensionValue,
        __HandoverCommandTransfer_iE_Extensions__item_,
        _HandoverCommandTransfer_iE_Extensions,
        HandoverCommandTransfer,
        HandoverCommandTransfer_ExtIEs,
        _HandoverCommandTransfer_ExtIEs_val_Extension_0,
        _HandoverCommandTransfer_ExtIEs_val_Extension_1,
        _HandoverCommandTransfer_ExtIEs_val_Extension_2,
        _HandoverCommandTransfer_ExtIEs_val_Extension_3,
        _HandoverCommandTransfer_ExtIEs_val_Extension_4,
        HandoverFlag,
        _HandoverPreparationUnsuccessfulTransfer_cause,
        ____HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__id_tab,
        ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__id,
        ____HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__criticality_tab,
        ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__criticality,
        ____HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab,
        ___HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item__extensionValue,
        __HandoverPreparationUnsuccessfulTransfer_iE_Extensions__item_,
        _HandoverPreparationUnsuccessfulTransfer_iE_Extensions,
        HandoverPreparationUnsuccessfulTransfer,
        HandoverPreparationUnsuccessfulTransfer_ExtIEs,
        _HandoverRequestAcknowledgeTransfer_dL_NGU_UP_TNLInformation,
        _HandoverRequestAcknowledgeTransfer_dLForwardingUP_TNLInformation,
        _HandoverRequestAcknowledgeTransfer_securityResult,
        _HandoverRequestAcknowledgeTransfer_qosFlowSetupResponseList,
        _HandoverRequestAcknowledgeTransfer_qosFlowFailedToSetupList,
        _HandoverRequestAcknowledgeTransfer_dataForwardingResponseDRBList,
        ____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab,
        _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_0,
        _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_1,
        _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_2,
        _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_3,
        _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_4,
        _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_5,
        _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_6,
        _____HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_7,
        ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__id,
        ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__criticality,
        ___HandoverRequestAcknowledgeTransfer_iE_Extensions__item__extensionValue,
        __HandoverRequestAcknowledgeTransfer_iE_Extensions__item_,
        _HandoverRequestAcknowledgeTransfer_iE_Extensions,
        HandoverRequestAcknowledgeTransfer,
        HandoverRequestAcknowledgeTransfer_ExtIEs,
        _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_0,
        _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_1,
        _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_2,
        _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_3,
        _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_4,
        _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_5,
        _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_6,
        _HandoverRequestAcknowledgeTransfer_ExtIEs_val_Extension_7,
        _HandoverRequiredTransfer_directForwardingPathAvailability,
        ____HandoverRequiredTransfer_iE_Extensions__item__id_tab,
        ___HandoverRequiredTransfer_iE_Extensions__item__id,
        ____HandoverRequiredTransfer_iE_Extensions__item__criticality_tab,
        ___HandoverRequiredTransfer_iE_Extensions__item__criticality,
        ____HandoverRequiredTransfer_iE_Extensions__item__extensionValue_tab,
        ___HandoverRequiredTransfer_iE_Extensions__item__extensionValue,
        __HandoverRequiredTransfer_iE_Extensions__item_,
        _HandoverRequiredTransfer_iE_Extensions,
        HandoverRequiredTransfer,
        HandoverRequiredTransfer_ExtIEs,
        _HandoverResourceAllocationUnsuccessfulTransfer_cause,
        _HandoverResourceAllocationUnsuccessfulTransfer_criticalityDiagnostics,
        ____HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__id_tab,
        ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__id,
        ____HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__criticality_tab,
        ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__criticality,
        ____HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab,
        ___HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item__extensionValue,
        __HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions__item_,
        _HandoverResourceAllocationUnsuccessfulTransfer_iE_Extensions,
        HandoverResourceAllocationUnsuccessfulTransfer,
        HandoverResourceAllocationUnsuccessfulTransfer_ExtIEs,
        HandoverType,
        HFCNode_ID,
        _HFCNode_ID_new_hFCNode_ID,
        _HFCNode_ID_new_tAI,
        ____HFCNode_ID_new_iE_Extensions__item__id_tab,
        ___HFCNode_ID_new_iE_Extensions__item__id,
        ____HFCNode_ID_new_iE_Extensions__item__criticality_tab,
        ___HFCNode_ID_new_iE_Extensions__item__criticality,
        ____HFCNode_ID_new_iE_Extensions__item__extensionValue_tab,
        ___HFCNode_ID_new_iE_Extensions__item__extensionValue,
        __HFCNode_ID_new_iE_Extensions__item_,
        _HFCNode_ID_new_iE_Extensions,
        HFCNode_ID_new,
        HFCNode_ID_new_ExtIEs,
        _HOReport_handoverReportType,
        _HOReport_handoverCause,
        _HOReport_sourcecellCGI,
        _HOReport_targetcellCGI,
        _HOReport_reestablishmentcellCGI,
        _HOReport_sourcecellC_RNTI,
        _HOReport_targetcellinE_UTRAN,
        _HOReport_mobilityInformation,
        _HOReport_uERLFReportContainer,
        ____HOReport_iE_Extensions__item__id_tab,
        ___HOReport_iE_Extensions__item__id,
        ____HOReport_iE_Extensions__item__criticality_tab,
        ___HOReport_iE_Extensions__item__criticality,
        ____HOReport_iE_Extensions__item__extensionValue_tab,
        ___HOReport_iE_Extensions__item__extensionValue,
        __HOReport_iE_Extensions__item_,
        _HOReport_iE_Extensions,
        HOReport,
        HOReport_ExtIEs,
        Hysteresis,
        IAB_Authorized,
        IAB_Supported,
        IABNodeIndication,
        IMSVoiceSupportIndicator,
        IndexToRFSP,
        _InfoOnRecommendedCellsAndRANNodesForPaging_recommendedCellsForPaging,
        _InfoOnRecommendedCellsAndRANNodesForPaging_recommendRANNodesForPaging,
        ____InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__id_tab,
        ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__id,
        ____InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__criticality_tab,
        ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__criticality,
        ____InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__extensionValue_tab,
        ___InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item__extensionValue,
        __InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions__item_,
        _InfoOnRecommendedCellsAndRANNodesForPaging_iE_Extensions,
        InfoOnRecommendedCellsAndRANNodesForPaging,
        InfoOnRecommendedCellsAndRANNodesForPaging_ExtIEs,
        IntegrityProtectionIndication,
        IntegrityProtectionResult,
        IntendedNumberOfPagingAttempts,
        InterfacesToTrace,
        _ImmediateMDTNr_measurementsToActivate,
        _ImmediateMDTNr_m1Configuration,
        _ImmediateMDTNr_m4Configuration,
        _ImmediateMDTNr_m5Configuration,
        _ImmediateMDTNr_m6Configuration,
        _ImmediateMDTNr_m7Configuration,
        _ImmediateMDTNr_bluetoothMeasurementConfiguration,
        _ImmediateMDTNr_wLANMeasurementConfiguration,
        _ImmediateMDTNr_mDT_Location_Info,
        _ImmediateMDTNr_sensorMeasurementConfiguration,
        ____ImmediateMDTNr_iE_Extensions__item__id_tab,
        ___ImmediateMDTNr_iE_Extensions__item__id,
        ____ImmediateMDTNr_iE_Extensions__item__criticality_tab,
        ___ImmediateMDTNr_iE_Extensions__item__criticality,
        ____ImmediateMDTNr_iE_Extensions__item__extensionValue_tab,
        ___ImmediateMDTNr_iE_Extensions__item__extensionValue,
        __ImmediateMDTNr_iE_Extensions__item_,
        _ImmediateMDTNr_iE_Extensions,
        ImmediateMDTNr,
        ImmediateMDTNr_ExtIEs,
        _InterSystemFailureIndication_uERLFReportContainer,
        ____InterSystemFailureIndication_iE_Extensions__item__id_tab,
        ___InterSystemFailureIndication_iE_Extensions__item__id,
        ____InterSystemFailureIndication_iE_Extensions__item__criticality_tab,
        ___InterSystemFailureIndication_iE_Extensions__item__criticality,
        ____InterSystemFailureIndication_iE_Extensions__item__extensionValue_tab,
        ___InterSystemFailureIndication_iE_Extensions__item__extensionValue,
        __InterSystemFailureIndication_iE_Extensions__item_,
        _InterSystemFailureIndication_iE_Extensions,
        InterSystemFailureIndication,
        InterSystemFailureIndication_ExtIEs,
        _IntersystemSONConfigurationTransfer_transferType,
        _IntersystemSONConfigurationTransfer_intersystemSONInformation,
        ____IntersystemSONConfigurationTransfer_iE_Extensions__item__id_tab,
        ___IntersystemSONConfigurationTransfer_iE_Extensions__item__id,
        ____IntersystemSONConfigurationTransfer_iE_Extensions__item__criticality_tab,
        ___IntersystemSONConfigurationTransfer_iE_Extensions__item__criticality,
        ____IntersystemSONConfigurationTransfer_iE_Extensions__item__extensionValue_tab,
        ___IntersystemSONConfigurationTransfer_iE_Extensions__item__extensionValue,
        __IntersystemSONConfigurationTransfer_iE_Extensions__item_,
        _IntersystemSONConfigurationTransfer_iE_Extensions,
        IntersystemSONConfigurationTransfer,
        IntersystemSONConfigurationTransfer_ExtIEs,
        _IntersystemSONTransferType_fromEUTRANtoNGRAN,
        _IntersystemSONTransferType_fromNGRANtoEUTRAN,
        ___IntersystemSONTransferType_choice_Extensions_id_tab,
        __IntersystemSONTransferType_choice_Extensions_id,
        ___IntersystemSONTransferType_choice_Extensions_criticality_tab,
        __IntersystemSONTransferType_choice_Extensions_criticality,
        ___IntersystemSONTransferType_choice_Extensions_value_tab,
        __IntersystemSONTransferType_choice_Extensions_value,
        _IntersystemSONTransferType_choice_Extensions,
        IntersystemSONTransferType,
        IntersystemSONTransferType_ExtIEs,
        _IntersystemSONeNBID_globaleNBID,
        _IntersystemSONeNBID_selectedEPSTAI,
        ____IntersystemSONeNBID_iE_Extensions__item__id_tab,
        ___IntersystemSONeNBID_iE_Extensions__item__id,
        ____IntersystemSONeNBID_iE_Extensions__item__criticality_tab,
        ___IntersystemSONeNBID_iE_Extensions__item__criticality,
        ____IntersystemSONeNBID_iE_Extensions__item__extensionValue_tab,
        ___IntersystemSONeNBID_iE_Extensions__item__extensionValue,
        __IntersystemSONeNBID_iE_Extensions__item_,
        _IntersystemSONeNBID_iE_Extensions,
        IntersystemSONeNBID,
        IntersystemSONeNBID_ExtIEs,
        _IntersystemSONNGRANnodeID_globalRANNodeID,
        _IntersystemSONNGRANnodeID_selectedTAI,
        ____IntersystemSONNGRANnodeID_iE_Extensions__item__id_tab,
        ___IntersystemSONNGRANnodeID_iE_Extensions__item__id,
        ____IntersystemSONNGRANnodeID_iE_Extensions__item__criticality_tab,
        ___IntersystemSONNGRANnodeID_iE_Extensions__item__criticality,
        ____IntersystemSONNGRANnodeID_iE_Extensions__item__extensionValue_tab,
        ___IntersystemSONNGRANnodeID_iE_Extensions__item__extensionValue,
        __IntersystemSONNGRANnodeID_iE_Extensions__item_,
        _IntersystemSONNGRANnodeID_iE_Extensions,
        IntersystemSONNGRANnodeID,
        IntersystemSONNGRANnodeID_ExtIEs,
        _IntersystemSONInformation_intersystemSONInformationReport,
        ___IntersystemSONInformation_choice_Extensions_id_tab,
        ____IntersystemSONInformation_choice_Extensions_id_tab_val_Value_0,
        ____IntersystemSONInformation_choice_Extensions_id_tab_val_Value_1,
        __IntersystemSONInformation_choice_Extensions_id,
        __IntersystemSONInformation_choice_Extensions_criticality,
        __IntersystemSONInformation_choice_Extensions_value,
        _IntersystemSONInformation_choice_Extensions,
        IntersystemSONInformation,
        IntersystemSONInformation_ExtIEs,
        _IntersystemSONInformation_ExtIEs_val_Value_0,
        _IntersystemSONInformation_ExtIEs_val_Value_1,
        _IntersystemSONInformationRequest_nGRAN_CellActivation,
        _IntersystemSONInformationRequest_resourceStatus,
        ___IntersystemSONInformationRequest_choice_Extensions_id_tab,
        __IntersystemSONInformationRequest_choice_Extensions_id,
        ___IntersystemSONInformationRequest_choice_Extensions_criticality_tab,
        __IntersystemSONInformationRequest_choice_Extensions_criticality,
        ___IntersystemSONInformationRequest_choice_Extensions_value_tab,
        __IntersystemSONInformationRequest_choice_Extensions_value,
        _IntersystemSONInformationRequest_choice_Extensions,
        IntersystemSONInformationRequest,
        IntersystemSONInformationRequest_ExtIEs,
        _IntersystemCellActivationRequest_activationID,
        _IntersystemCellActivationRequest_cellsToActivateList,
        ____IntersystemCellActivationRequest_iE_Extensions__item__id_tab,
        ___IntersystemCellActivationRequest_iE_Extensions__item__id,
        ____IntersystemCellActivationRequest_iE_Extensions__item__criticality_tab,
        ___IntersystemCellActivationRequest_iE_Extensions__item__criticality,
        ____IntersystemCellActivationRequest_iE_Extensions__item__extensionValue_tab,
        ___IntersystemCellActivationRequest_iE_Extensions__item__extensionValue,
        __IntersystemCellActivationRequest_iE_Extensions__item_,
        _IntersystemCellActivationRequest_iE_Extensions,
        IntersystemCellActivationRequest,
        IntersystemCellActivationRequest_ExtIEs,
        _CellsToActivateList__item_,
        CellsToActivateList,
        _IntersystemResourceStatusRequest_reportingSystem,
        _IntersystemResourceStatusRequest_reportCharacteristics,
        _IntersystemResourceStatusRequest_reportType,
        ____IntersystemResourceStatusRequest_iE_Extensions__item__id_tab,
        ___IntersystemResourceStatusRequest_iE_Extensions__item__id,
        ____IntersystemResourceStatusRequest_iE_Extensions__item__criticality_tab,
        ___IntersystemResourceStatusRequest_iE_Extensions__item__criticality,
        ____IntersystemResourceStatusRequest_iE_Extensions__item__extensionValue_tab,
        ___IntersystemResourceStatusRequest_iE_Extensions__item__extensionValue,
        __IntersystemResourceStatusRequest_iE_Extensions__item_,
        _IntersystemResourceStatusRequest_iE_Extensions,
        IntersystemResourceStatusRequest,
        IntersystemResourceStatusRequest_ExtIEs,
        _ReportingSystem_eUTRAN,
        _ReportingSystem_nGRAN,
        _ReportingSystem_noReporting,
        ___ReportingSystem_choice_Extensions_id_tab,
        __ReportingSystem_choice_Extensions_id,
        ___ReportingSystem_choice_Extensions_criticality_tab,
        __ReportingSystem_choice_Extensions_criticality,
        ___ReportingSystem_choice_Extensions_value_tab,
        __ReportingSystem_choice_Extensions_value,
        _ReportingSystem_choice_Extensions,
        ReportingSystem,
        ReportingSystem_ExtIEs,
        _EUTRAN_ReportingSystemIEs_eUTRAN_CellToReportList,
        ____EUTRAN_ReportingSystemIEs_iE_Extensions__item__id_tab,
        ___EUTRAN_ReportingSystemIEs_iE_Extensions__item__id,
        ____EUTRAN_ReportingSystemIEs_iE_Extensions__item__criticality_tab,
        ___EUTRAN_ReportingSystemIEs_iE_Extensions__item__criticality,
        ____EUTRAN_ReportingSystemIEs_iE_Extensions__item__extensionValue_tab,
        ___EUTRAN_ReportingSystemIEs_iE_Extensions__item__extensionValue,
        __EUTRAN_ReportingSystemIEs_iE_Extensions__item_,
        _EUTRAN_ReportingSystemIEs_iE_Extensions,
        EUTRAN_ReportingSystemIEs,
        EUTRAN_ReportingSystemIEs_ExtIEs,
        _NGRAN_ReportingSystemIEs_nGRAN_CellToReportList,
        ____NGRAN_ReportingSystemIEs_iE_Extensions__item__id_tab,
        ___NGRAN_ReportingSystemIEs_iE_Extensions__item__id,
        ____NGRAN_ReportingSystemIEs_iE_Extensions__item__criticality_tab,
        ___NGRAN_ReportingSystemIEs_iE_Extensions__item__criticality,
        ____NGRAN_ReportingSystemIEs_iE_Extensions__item__extensionValue_tab,
        ___NGRAN_ReportingSystemIEs_iE_Extensions__item__extensionValue,
        __NGRAN_ReportingSystemIEs_iE_Extensions__item_,
        _NGRAN_ReportingSystemIEs_iE_Extensions,
        NGRAN_ReportingSystemIEs,
        NGRAN_ReportingSystemIEs_ExtIEs,
        _EUTRAN_CellToReportList__item_,
        EUTRAN_CellToReportList,
        _EUTRAN_CellToReportItem_eCGI,
        ____EUTRAN_CellToReportItem_iE_Extensions__item__id_tab,
        ___EUTRAN_CellToReportItem_iE_Extensions__item__id,
        ____EUTRAN_CellToReportItem_iE_Extensions__item__criticality_tab,
        ___EUTRAN_CellToReportItem_iE_Extensions__item__criticality,
        ____EUTRAN_CellToReportItem_iE_Extensions__item__extensionValue_tab,
        ___EUTRAN_CellToReportItem_iE_Extensions__item__extensionValue,
        __EUTRAN_CellToReportItem_iE_Extensions__item_,
        _EUTRAN_CellToReportItem_iE_Extensions,
        EUTRAN_CellToReportItem,
        EUTRAN_CellToReportItem_ExtIEs,
        _NGRAN_CellToReportList__item_,
        NGRAN_CellToReportList,
        _NGRAN_CellToReportItem_nGRAN_CGI,
        ____NGRAN_CellToReportItem_iE_Extensions__item__id_tab,
        ___NGRAN_CellToReportItem_iE_Extensions__item__id,
        ____NGRAN_CellToReportItem_iE_Extensions__item__criticality_tab,
        ___NGRAN_CellToReportItem_iE_Extensions__item__criticality,
        ____NGRAN_CellToReportItem_iE_Extensions__item__extensionValue_tab,
        ___NGRAN_CellToReportItem_iE_Extensions__item__extensionValue,
        __NGRAN_CellToReportItem_iE_Extensions__item_,
        _NGRAN_CellToReportItem_iE_Extensions,
        NGRAN_CellToReportItem,
        NGRAN_CellToReportItem_ExtIEs,
        ReportCharacteristics,
        _ReportType_eventBasedReporting,
        _ReportType_periodicReporting,
        ___ReportType_choice_Extensions_id_tab,
        __ReportType_choice_Extensions_id,
        ___ReportType_choice_Extensions_criticality_tab,
        __ReportType_choice_Extensions_criticality,
        ___ReportType_choice_Extensions_value_tab,
        __ReportType_choice_Extensions_value,
        _ReportType_choice_Extensions,
        ReportType,
        ReportType_ExtIEs,
        _EventBasedReportingIEs_intersystemResourceThresholdLow,
        _EventBasedReportingIEs_intersystemResourceThresholdHigh,
        _EventBasedReportingIEs_numberOfMeasurementReportingLevels,
        ____EventBasedReportingIEs_iE_Extensions__item__id_tab,
        ___EventBasedReportingIEs_iE_Extensions__item__id,
        ____EventBasedReportingIEs_iE_Extensions__item__criticality_tab,
        ___EventBasedReportingIEs_iE_Extensions__item__criticality,
        ____EventBasedReportingIEs_iE_Extensions__item__extensionValue_tab,
        ___EventBasedReportingIEs_iE_Extensions__item__extensionValue,
        __EventBasedReportingIEs_iE_Extensions__item_,
        _EventBasedReportingIEs_iE_Extensions,
        EventBasedReportingIEs,
        EventBasedReportingIEs_ExtIEs,
        IntersystemResourceThreshold,
        NumberOfMeasurementReportingLevels,
        _PeriodicReportingIEs_reportingPeriodicity,
        ____PeriodicReportingIEs_iE_Extensions__item__id_tab,
        ___PeriodicReportingIEs_iE_Extensions__item__id,
        ____PeriodicReportingIEs_iE_Extensions__item__criticality_tab,
        ___PeriodicReportingIEs_iE_Extensions__item__criticality,
        ____PeriodicReportingIEs_iE_Extensions__item__extensionValue_tab,
        ___PeriodicReportingIEs_iE_Extensions__item__extensionValue,
        __PeriodicReportingIEs_iE_Extensions__item_,
        _PeriodicReportingIEs_iE_Extensions,
        PeriodicReportingIEs,
        PeriodicReportingIEs_ExtIEs,
        ReportingPeriodicity,
        _IntersystemSONInformationReply_nGRAN_CellActivation,
        _IntersystemSONInformationReply_resourceStatus,
        ___IntersystemSONInformationReply_choice_Extensions_id_tab,
        __IntersystemSONInformationReply_choice_Extensions_id,
        ___IntersystemSONInformationReply_choice_Extensions_criticality_tab,
        __IntersystemSONInformationReply_choice_Extensions_criticality,
        ___IntersystemSONInformationReply_choice_Extensions_value_tab,
        __IntersystemSONInformationReply_choice_Extensions_value,
        _IntersystemSONInformationReply_choice_Extensions,
        IntersystemSONInformationReply,
        IntersystemSONInformationReply_ExtIEs,
        _IntersystemCellActivationReply_activatedCellList,
        _IntersystemCellActivationReply_activation_ID,
        ____IntersystemCellActivationReply_iE_Extensions__item__id_tab,
        ___IntersystemCellActivationReply_iE_Extensions__item__id,
        ____IntersystemCellActivationReply_iE_Extensions__item__criticality_tab,
        ___IntersystemCellActivationReply_iE_Extensions__item__criticality,
        ____IntersystemCellActivationReply_iE_Extensions__item__extensionValue_tab,
        ___IntersystemCellActivationReply_iE_Extensions__item__extensionValue,
        __IntersystemCellActivationReply_iE_Extensions__item_,
        _IntersystemCellActivationReply_iE_Extensions,
        IntersystemCellActivationReply,
        IntersystemCellActivationReply_ExtIEs,
        _ActivatedCellList__item_,
        ActivatedCellList,
        _IntersystemResourceStatusReply_reportingsystem,
        ____IntersystemResourceStatusReply_iE_Extensions__item__id_tab,
        ___IntersystemResourceStatusReply_iE_Extensions__item__id,
        ____IntersystemResourceStatusReply_iE_Extensions__item__criticality_tab,
        ___IntersystemResourceStatusReply_iE_Extensions__item__criticality,
        ____IntersystemResourceStatusReply_iE_Extensions__item__extensionValue_tab,
        ___IntersystemResourceStatusReply_iE_Extensions__item__extensionValue,
        __IntersystemResourceStatusReply_iE_Extensions__item_,
        _IntersystemResourceStatusReply_iE_Extensions,
        IntersystemResourceStatusReply,
        IntersystemResourceStatusReply_ExtIEs,
        _IntersystemSONInformationReport_hOReportInformation,
        _IntersystemSONInformationReport_failureIndicationInformation,
        ___IntersystemSONInformationReport_choice_Extensions_id_tab,
        ____IntersystemSONInformationReport_choice_Extensions_id_tab_val_Value_0,
        ____IntersystemSONInformationReport_choice_Extensions_id_tab_val_Value_1,
        __IntersystemSONInformationReport_choice_Extensions_id,
        __IntersystemSONInformationReport_choice_Extensions_criticality,
        __IntersystemSONInformationReport_choice_Extensions_value,
        _IntersystemSONInformationReport_choice_Extensions,
        IntersystemSONInformationReport,
        IntersystemSONInformationReport_ExtIEs,
        _IntersystemSONInformationReport_ExtIEs_val_Value_0,
        _IntersystemSONInformationReport_ExtIEs_val_Value_1,
        _IntersystemCellStateIndication_notificationCellList,
        ____IntersystemCellStateIndication_iE_Extensions__item__id_tab,
        ___IntersystemCellStateIndication_iE_Extensions__item__id,
        ____IntersystemCellStateIndication_iE_Extensions__item__criticality_tab,
        ___IntersystemCellStateIndication_iE_Extensions__item__criticality,
        ____IntersystemCellStateIndication_iE_Extensions__item__extensionValue_tab,
        ___IntersystemCellStateIndication_iE_Extensions__item__extensionValue,
        __IntersystemCellStateIndication_iE_Extensions__item_,
        _IntersystemCellStateIndication_iE_Extensions,
        IntersystemCellStateIndication,
        IntersystemCellStateIndication_ExtIEs,
        _NotificationCellList__item_,
        NotificationCellList,
        _NotificationCell_Item_nGRAN_CGI,
        _NotificationCell_Item_notifyFlag,
        ____NotificationCell_Item_iE_Extensions__item__id_tab,
        ___NotificationCell_Item_iE_Extensions__item__id,
        ____NotificationCell_Item_iE_Extensions__item__criticality_tab,
        ___NotificationCell_Item_iE_Extensions__item__criticality,
        ____NotificationCell_Item_iE_Extensions__item__extensionValue_tab,
        ___NotificationCell_Item_iE_Extensions__item__extensionValue,
        __NotificationCell_Item_iE_Extensions__item_,
        _NotificationCell_Item_iE_Extensions,
        NotificationCell_Item,
        NotificationCell_Item_ExtIEs,
        _IntersystemResourceStatusReport_reportingSystem,
        ____IntersystemResourceStatusReport_iE_Extensions__item__id_tab,
        ___IntersystemResourceStatusReport_iE_Extensions__item__id,
        ____IntersystemResourceStatusReport_iE_Extensions__item__criticality_tab,
        ___IntersystemResourceStatusReport_iE_Extensions__item__criticality,
        ____IntersystemResourceStatusReport_iE_Extensions__item__extensionValue_tab,
        ___IntersystemResourceStatusReport_iE_Extensions__item__extensionValue,
        __IntersystemResourceStatusReport_iE_Extensions__item_,
        _IntersystemResourceStatusReport_iE_Extensions,
        IntersystemResourceStatusReport,
        IntersystemResourceStatusReport_ExtIEs,
        _ResourceStatusReportingSystem_eUTRAN_ReportingStatus,
        _ResourceStatusReportingSystem_nGRAN_ReportingStatus,
        ___ResourceStatusReportingSystem_choice_Extensions_id_tab,
        __ResourceStatusReportingSystem_choice_Extensions_id,
        ___ResourceStatusReportingSystem_choice_Extensions_criticality_tab,
        __ResourceStatusReportingSystem_choice_Extensions_criticality,
        ___ResourceStatusReportingSystem_choice_Extensions_value_tab,
        __ResourceStatusReportingSystem_choice_Extensions_value,
        _ResourceStatusReportingSystem_choice_Extensions,
        ResourceStatusReportingSystem,
        ResourceStatusReportingSystem_ExtIEs,
        _EUTRAN_ReportingStatusIEs_eUTRAN_CellReportList,
        ____EUTRAN_ReportingStatusIEs_iE_Extensions__item__id_tab,
        ___EUTRAN_ReportingStatusIEs_iE_Extensions__item__id,
        ____EUTRAN_ReportingStatusIEs_iE_Extensions__item__criticality_tab,
        ___EUTRAN_ReportingStatusIEs_iE_Extensions__item__criticality,
        ____EUTRAN_ReportingStatusIEs_iE_Extensions__item__extensionValue_tab,
        ___EUTRAN_ReportingStatusIEs_iE_Extensions__item__extensionValue,
        __EUTRAN_ReportingStatusIEs_iE_Extensions__item_,
        _EUTRAN_ReportingStatusIEs_iE_Extensions,
        EUTRAN_ReportingStatusIEs,
        EUTRAN_ReportingStatusIEs_ExtIEs,
        _EUTRAN_CellReportList__item_,
        EUTRAN_CellReportList,
        _EUTRAN_CellReportItem_eCGI,
        _EUTRAN_CellReportItem_eUTRAN_CompositeAvailableCapacityGroup,
        _EUTRAN_CellReportItem_eUTRAN_NumberOfActiveUEs,
        _EUTRAN_CellReportItem_eUTRAN_NoofRRCConnections,
        _EUTRAN_CellReportItem_eUTRAN_RadioResourceStatus,
        ____EUTRAN_CellReportItem_iE_Extensions__item__id_tab,
        ___EUTRAN_CellReportItem_iE_Extensions__item__id,
        ____EUTRAN_CellReportItem_iE_Extensions__item__criticality_tab,
        ___EUTRAN_CellReportItem_iE_Extensions__item__criticality,
        ____EUTRAN_CellReportItem_iE_Extensions__item__extensionValue_tab,
        ___EUTRAN_CellReportItem_iE_Extensions__item__extensionValue,
        __EUTRAN_CellReportItem_iE_Extensions__item_,
        _EUTRAN_CellReportItem_iE_Extensions,
        EUTRAN_CellReportItem,
        EUTRAN_CellReportItem_ExtIEs,
        _EUTRAN_CompositeAvailableCapacityGroup_dL_CompositeAvailableCapacity,
        _EUTRAN_CompositeAvailableCapacityGroup_uL_CompositeAvailableCapacity,
        ____EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__id_tab,
        ___EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__id,
        ____EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__criticality_tab,
        ___EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__criticality,
        ____EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue_tab,
        ___EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item__extensionValue,
        __EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions__item_,
        _EUTRAN_CompositeAvailableCapacityGroup_iE_Extensions,
        EUTRAN_CompositeAvailableCapacityGroup,
        EUTRAN_CompositeAvailableCapacityGroup_ExtIEs,
        _CompositeAvailableCapacity_cellCapacityClassValue,
        _CompositeAvailableCapacity_capacityValue,
        ____CompositeAvailableCapacity_iE_Extensions__item__id_tab,
        ___CompositeAvailableCapacity_iE_Extensions__item__id,
        ____CompositeAvailableCapacity_iE_Extensions__item__criticality_tab,
        ___CompositeAvailableCapacity_iE_Extensions__item__criticality,
        ____CompositeAvailableCapacity_iE_Extensions__item__extensionValue_tab,
        ___CompositeAvailableCapacity_iE_Extensions__item__extensionValue,
        __CompositeAvailableCapacity_iE_Extensions__item_,
        _CompositeAvailableCapacity_iE_Extensions,
        CompositeAvailableCapacity,
        CompositeAvailableCapacity_ExtIEs,
        EUTRAN_NumberOfActiveUEs,
        _EUTRAN_RadioResourceStatus_dL_GBR_PRB_usage,
        _EUTRAN_RadioResourceStatus_uL_GBR_PRB_usage,
        _EUTRAN_RadioResourceStatus_dL_non_GBR_PRB_usage,
        _EUTRAN_RadioResourceStatus_uL_non_GBR_PRB_usage,
        _EUTRAN_RadioResourceStatus_dL_Total_PRB_usage,
        _EUTRAN_RadioResourceStatus_uL_Total_PRB_usage,
        _EUTRAN_RadioResourceStatus_dL_scheduling_PDCCH_CCE_usage,
        _EUTRAN_RadioResourceStatus_uL_scheduling_PDCCH_CCE_usage,
        ____EUTRAN_RadioResourceStatus_iE_Extensions__item__id_tab,
        ___EUTRAN_RadioResourceStatus_iE_Extensions__item__id,
        ____EUTRAN_RadioResourceStatus_iE_Extensions__item__criticality_tab,
        ___EUTRAN_RadioResourceStatus_iE_Extensions__item__criticality,
        ____EUTRAN_RadioResourceStatus_iE_Extensions__item__extensionValue_tab,
        ___EUTRAN_RadioResourceStatus_iE_Extensions__item__extensionValue,
        __EUTRAN_RadioResourceStatus_iE_Extensions__item_,
        _EUTRAN_RadioResourceStatus_iE_Extensions,
        EUTRAN_RadioResourceStatus,
        EUTRAN_RadioResourceStatus_ExtIEs,
        _NGRAN_ReportingStatusIEs_nGRAN_CellReportList,
        ____NGRAN_ReportingStatusIEs_iE_Extensions__item__id_tab,
        ___NGRAN_ReportingStatusIEs_iE_Extensions__item__id,
        ____NGRAN_ReportingStatusIEs_iE_Extensions__item__criticality_tab,
        ___NGRAN_ReportingStatusIEs_iE_Extensions__item__criticality,
        ____NGRAN_ReportingStatusIEs_iE_Extensions__item__extensionValue_tab,
        ___NGRAN_ReportingStatusIEs_iE_Extensions__item__extensionValue,
        __NGRAN_ReportingStatusIEs_iE_Extensions__item_,
        _NGRAN_ReportingStatusIEs_iE_Extensions,
        NGRAN_ReportingStatusIEs,
        NGRAN_ReportingStatusIEs_ExtIEs,
        _NGRAN_CellReportList__item_,
        NGRAN_CellReportList,
        _NGRAN_CellReportItem_nGRAN_CGI,
        _NGRAN_CellReportItem_nGRAN_CompositeAvailableCapacityGroup,
        _NGRAN_CellReportItem_nGRAN_NumberOfActiveUEs,
        _NGRAN_CellReportItem_nGRAN_NoofRRCConnections,
        _NGRAN_CellReportItem_nGRAN_RadioResourceStatus,
        ____NGRAN_CellReportItem_iE_Extensions__item__id_tab,
        ___NGRAN_CellReportItem_iE_Extensions__item__id,
        ____NGRAN_CellReportItem_iE_Extensions__item__criticality_tab,
        ___NGRAN_CellReportItem_iE_Extensions__item__criticality,
        ____NGRAN_CellReportItem_iE_Extensions__item__extensionValue_tab,
        ___NGRAN_CellReportItem_iE_Extensions__item__extensionValue,
        __NGRAN_CellReportItem_iE_Extensions__item_,
        _NGRAN_CellReportItem_iE_Extensions,
        NGRAN_CellReportItem,
        NGRAN_CellReportItem_ExtIEs,
        NGRAN_NumberOfActiveUEs,
        NGRAN_NoofRRCConnections,
        _NGRAN_RadioResourceStatus_dL_GBR_PRB_usage_for_MIMO,
        _NGRAN_RadioResourceStatus_uL_GBR_PRB_usage_for_MIMO,
        _NGRAN_RadioResourceStatus_dL_non_GBR_PRB_usage_for_MIMO,
        _NGRAN_RadioResourceStatus_uL_non_GBR_PRB_usage_for_MIMO,
        _NGRAN_RadioResourceStatus_dL_Total_PRB_usage_for_MIMO,
        _NGRAN_RadioResourceStatus_uL_Total_PRB_usage_for_MIMO,
        ____NGRAN_RadioResourceStatus_iE_Extensions__item__id_tab,
        ___NGRAN_RadioResourceStatus_iE_Extensions__item__id,
        ____NGRAN_RadioResourceStatus_iE_Extensions__item__criticality_tab,
        ___NGRAN_RadioResourceStatus_iE_Extensions__item__criticality,
        ____NGRAN_RadioResourceStatus_iE_Extensions__item__extensionValue_tab,
        ___NGRAN_RadioResourceStatus_iE_Extensions__item__extensionValue,
        __NGRAN_RadioResourceStatus_iE_Extensions__item_,
        _NGRAN_RadioResourceStatus_iE_Extensions,
        NGRAN_RadioResourceStatus,
        NGRAN_RadioResourceStatus_ExtIEs,
        _InterSystemHOReport_handoverReportType,
        ____InterSystemHOReport_iE_Extensions__item__id_tab,
        ___InterSystemHOReport_iE_Extensions__item__id,
        ____InterSystemHOReport_iE_Extensions__item__criticality_tab,
        ___InterSystemHOReport_iE_Extensions__item__criticality,
        ____InterSystemHOReport_iE_Extensions__item__extensionValue_tab,
        ___InterSystemHOReport_iE_Extensions__item__extensionValue,
        __InterSystemHOReport_iE_Extensions__item_,
        _InterSystemHOReport_iE_Extensions,
        InterSystemHOReport,
        InterSystemHOReport_ExtIEs,
        _InterSystemHandoverReportType_tooearlyIntersystemHO,
        _InterSystemHandoverReportType_intersystemUnnecessaryHO,
        ___InterSystemHandoverReportType_choice_Extensions_id_tab,
        __InterSystemHandoverReportType_choice_Extensions_id,
        ___InterSystemHandoverReportType_choice_Extensions_criticality_tab,
        __InterSystemHandoverReportType_choice_Extensions_criticality,
        ___InterSystemHandoverReportType_choice_Extensions_value_tab,
        __InterSystemHandoverReportType_choice_Extensions_value,
        _InterSystemHandoverReportType_choice_Extensions,
        InterSystemHandoverReportType,
        InterSystemHandoverReportType_ExtIEs,
        _IntersystemUnnecessaryHO_sourcecellID,
        _IntersystemUnnecessaryHO_targetcellID,
        _IntersystemUnnecessaryHO_earlyIRATHO,
        _IntersystemUnnecessaryHO_candidateCellList,
        ____IntersystemUnnecessaryHO_iE_Extensions__item__id_tab,
        ___IntersystemUnnecessaryHO_iE_Extensions__item__id,
        ____IntersystemUnnecessaryHO_iE_Extensions__item__criticality_tab,
        ___IntersystemUnnecessaryHO_iE_Extensions__item__criticality,
        ____IntersystemUnnecessaryHO_iE_Extensions__item__extensionValue_tab,
        ___IntersystemUnnecessaryHO_iE_Extensions__item__extensionValue,
        __IntersystemUnnecessaryHO_iE_Extensions__item_,
        _IntersystemUnnecessaryHO_iE_Extensions,
        IntersystemUnnecessaryHO,
        IntersystemUnnecessaryHO_ExtIEs,
        LAC,
        _LAI_pLMNidentity,
        _LAI_lAC,
        ____LAI_iE_Extensions__item__id_tab,
        ___LAI_iE_Extensions__item__id,
        ____LAI_iE_Extensions__item__criticality_tab,
        ___LAI_iE_Extensions__item__criticality,
        ____LAI_iE_Extensions__item__extensionValue_tab,
        ___LAI_iE_Extensions__item__extensionValue,
        __LAI_iE_Extensions__item_,
        _LAI_iE_Extensions,
        LAI,
        LAI_ExtIEs,
        _LastVisitedCellInformation_nGRANCell,
        _LastVisitedCellInformation_eUTRANCell,
        _LastVisitedCellInformation_uTRANCell,
        _LastVisitedCellInformation_gERANCell,
        ___LastVisitedCellInformation_choice_Extensions_id_tab,
        __LastVisitedCellInformation_choice_Extensions_id,
        ___LastVisitedCellInformation_choice_Extensions_criticality_tab,
        __LastVisitedCellInformation_choice_Extensions_criticality,
        ___LastVisitedCellInformation_choice_Extensions_value_tab,
        __LastVisitedCellInformation_choice_Extensions_value,
        _LastVisitedCellInformation_choice_Extensions,
        LastVisitedCellInformation,
        LastVisitedCellInformation_ExtIEs,
        _LastVisitedCellItem_lastVisitedCellInformation,
        ____LastVisitedCellItem_iE_Extensions__item__id_tab,
        ___LastVisitedCellItem_iE_Extensions__item__id,
        ____LastVisitedCellItem_iE_Extensions__item__criticality_tab,
        ___LastVisitedCellItem_iE_Extensions__item__criticality,
        ____LastVisitedCellItem_iE_Extensions__item__extensionValue_tab,
        ___LastVisitedCellItem_iE_Extensions__item__extensionValue,
        __LastVisitedCellItem_iE_Extensions__item_,
        _LastVisitedCellItem_iE_Extensions,
        LastVisitedCellItem,
        LastVisitedCellItem_ExtIEs,
        LastVisitedEUTRANCellInformation,
        LastVisitedGERANCellInformation,
        _LastVisitedNGRANCellInformation_globalCellID,
        _LastVisitedNGRANCellInformation_cellType,
        _LastVisitedNGRANCellInformation_timeUEStayedInCell,
        _LastVisitedNGRANCellInformation_timeUEStayedInCellEnhancedGranularity,
        _LastVisitedNGRANCellInformation_hOCauseValue,
        ____LastVisitedNGRANCellInformation_iE_Extensions__item__id_tab,
        _____LastVisitedNGRANCellInformation_iE_Extensions__item__id_tab_val_Extension_0,
        ___LastVisitedNGRANCellInformation_iE_Extensions__item__id,
        ___LastVisitedNGRANCellInformation_iE_Extensions__item__criticality,
        ___LastVisitedNGRANCellInformation_iE_Extensions__item__extensionValue,
        __LastVisitedNGRANCellInformation_iE_Extensions__item_,
        _LastVisitedNGRANCellInformation_iE_Extensions,
        LastVisitedNGRANCellInformation,
        LastVisitedNGRANCellInformation_ExtIEs,
        _LastVisitedNGRANCellInformation_ExtIEs_val_Extension_0,
        _LastVisitedPSCellList__item_,
        LastVisitedPSCellList,
        _LastVisitedPSCellInformation_pSCellID,
        _LastVisitedPSCellInformation_timeStay,
        ____LastVisitedPSCellInformation_iE_Extensions__item__id_tab,
        ___LastVisitedPSCellInformation_iE_Extensions__item__id,
        ____LastVisitedPSCellInformation_iE_Extensions__item__criticality_tab,
        ___LastVisitedPSCellInformation_iE_Extensions__item__criticality,
        ____LastVisitedPSCellInformation_iE_Extensions__item__extensionValue_tab,
        ___LastVisitedPSCellInformation_iE_Extensions__item__extensionValue,
        __LastVisitedPSCellInformation_iE_Extensions__item_,
        _LastVisitedPSCellInformation_iE_Extensions,
        LastVisitedPSCellInformation,
        LastVisitedPSCellInformation_ExtIEs,
        LastVisitedUTRANCellInformation,
        LineType,
        LocationReportingAdditionalInfo,
        LocationReportingReferenceID,
        _LocationReportingRequestType_eventType,
        _LocationReportingRequestType_reportArea,
        _LocationReportingRequestType_areaOfInterestList,
        _LocationReportingRequestType_locationReportingReferenceIDToBeCancelled,
        ____LocationReportingRequestType_iE_Extensions__item__id_tab,
        _____LocationReportingRequestType_iE_Extensions__item__id_tab_val_Extension_0,
        ___LocationReportingRequestType_iE_Extensions__item__id,
        ___LocationReportingRequestType_iE_Extensions__item__criticality,
        ___LocationReportingRequestType_iE_Extensions__item__extensionValue,
        __LocationReportingRequestType_iE_Extensions__item_,
        _LocationReportingRequestType_iE_Extensions,
        LocationReportingRequestType,
        LocationReportingRequestType_ExtIEs,
        _LocationReportingRequestType_ExtIEs_val_Extension_0,
        _LoggedMDTNr_loggingInterval,
        _LoggedMDTNr_loggingDuration,
        _LoggedMDTNr_loggedMDTTrigger,
        _LoggedMDTNr_bluetoothMeasurementConfiguration,
        _LoggedMDTNr_wLANMeasurementConfiguration,
        _LoggedMDTNr_sensorMeasurementConfiguration,
        _LoggedMDTNr_areaScopeOfNeighCellsList,
        ____LoggedMDTNr_iE_Extensions__item__id_tab,
        _____LoggedMDTNr_iE_Extensions__item__id_tab_val_Extension_0,
        ___LoggedMDTNr_iE_Extensions__item__id,
        ___LoggedMDTNr_iE_Extensions__item__criticality,
        ___LoggedMDTNr_iE_Extensions__item__extensionValue,
        __LoggedMDTNr_iE_Extensions__item_,
        _LoggedMDTNr_iE_Extensions,
        LoggedMDTNr,
        LoggedMDTNr_ExtIEs,
        _LoggedMDTNr_ExtIEs_val_Extension_0,
        LoggingInterval,
        LoggingDuration,
        Links_to_log,
        _LoggedMDTTrigger_periodical,
        _LoggedMDTTrigger_eventTrigger,
        ___LoggedMDTTrigger_choice_Extensions_id_tab,
        __LoggedMDTTrigger_choice_Extensions_id,
        ___LoggedMDTTrigger_choice_Extensions_criticality_tab,
        __LoggedMDTTrigger_choice_Extensions_criticality,
        ___LoggedMDTTrigger_choice_Extensions_value_tab,
        __LoggedMDTTrigger_choice_Extensions_value,
        _LoggedMDTTrigger_choice_Extensions,
        LoggedMDTTrigger,
        LoggedMDTTrigger_ExtIEs,
        LTEM_Indication,
        LTEUERLFReportContainer,
        _LTEV2XServicesAuthorized_vehicleUE,
        _LTEV2XServicesAuthorized_pedestrianUE,
        ____LTEV2XServicesAuthorized_iE_Extensions__item__id_tab,
        ___LTEV2XServicesAuthorized_iE_Extensions__item__id,
        ____LTEV2XServicesAuthorized_iE_Extensions__item__criticality_tab,
        ___LTEV2XServicesAuthorized_iE_Extensions__item__criticality,
        ____LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab,
        ___LTEV2XServicesAuthorized_iE_Extensions__item__extensionValue,
        __LTEV2XServicesAuthorized_iE_Extensions__item_,
        _LTEV2XServicesAuthorized_iE_Extensions,
        LTEV2XServicesAuthorized,
        LTEV2XServicesAuthorized_ExtIEs,
        _LTEUESidelinkAggregateMaximumBitrate_uESidelinkAggregateMaximumBitRate,
        ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab,
        ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id,
        ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab,
        ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality,
        ____LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab,
        ___LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue,
        __LTEUESidelinkAggregateMaximumBitrate_iE_Extensions__item_,
        _LTEUESidelinkAggregateMaximumBitrate_iE_Extensions,
        LTEUESidelinkAggregateMaximumBitrate,
        LTEUE_Sidelink_Aggregate_MaximumBitrates_ExtIEs,
        MaskedIMEISV,
        MaximumDataBurstVolume,
        MessageIdentifier,
        MaximumIntegrityProtectedDataRate,
        MBS_AreaSessionID,
        _MBS_DataForwardingResponseMRBList__item_,
        MBS_DataForwardingResponseMRBList,
        _MBS_DataForwardingResponseMRBItem_mRB_ID,
        _MBS_DataForwardingResponseMRBItem_dL_Forwarding_UPTNLInformation,
        _MBS_DataForwardingResponseMRBItem_mRB_ProgressInformation,
        ____MBS_DataForwardingResponseMRBItem_iE_Extensions__item__id_tab,
        ___MBS_DataForwardingResponseMRBItem_iE_Extensions__item__id,
        ____MBS_DataForwardingResponseMRBItem_iE_Extensions__item__criticality_tab,
        ___MBS_DataForwardingResponseMRBItem_iE_Extensions__item__criticality,
        ____MBS_DataForwardingResponseMRBItem_iE_Extensions__item__extensionValue_tab,
        ___MBS_DataForwardingResponseMRBItem_iE_Extensions__item__extensionValue,
        __MBS_DataForwardingResponseMRBItem_iE_Extensions__item_,
        _MBS_DataForwardingResponseMRBItem_iE_Extensions,
        MBS_DataForwardingResponseMRBItem,
        MBS_DataForwardingResponseMRBItem_ExtIEs,
        _MBS_MappingandDataForwardingRequestList__item_,
        MBS_MappingandDataForwardingRequestList,
        _MBS_MappingandDataForwardingRequestItem_mRB_ID,
        _MBS_MappingandDataForwardingRequestItem_mBS_QoSFlowList,
        _MBS_MappingandDataForwardingRequestItem_mRB_ProgressInformation,
        ____MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__id_tab,
        ___MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__id,
        ____MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__criticality_tab,
        ___MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__criticality,
        ____MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__extensionValue_tab,
        ___MBS_MappingandDataForwardingRequestItem_iE_Extensions__item__extensionValue,
        __MBS_MappingandDataForwardingRequestItem_iE_Extensions__item_,
        _MBS_MappingandDataForwardingRequestItem_iE_Extensions,
        MBS_MappingandDataForwardingRequestItem,
        MBS_MappingandDataForwardingRequestItem_ExtIEs,
        _MBS_QoSFlowList__item_,
        MBS_QoSFlowList,
        _MRB_ProgressInformation_pDCP_SN_Length12,
        _MRB_ProgressInformation_pDCP_SN_Length18,
        ___MRB_ProgressInformation_choice_Extensions_id_tab,
        __MRB_ProgressInformation_choice_Extensions_id,
        ___MRB_ProgressInformation_choice_Extensions_criticality_tab,
        __MRB_ProgressInformation_choice_Extensions_criticality,
        ___MRB_ProgressInformation_choice_Extensions_value_tab,
        __MRB_ProgressInformation_choice_Extensions_value,
        _MRB_ProgressInformation_choice_Extensions,
        MRB_ProgressInformation,
        MRB_ProgressInformation_ExtIEs,
        _MBS_QoSFlowsToBeSetupList__item_,
        MBS_QoSFlowsToBeSetupList,
        _MBS_QoSFlowsToBeSetupItem_mBSqosFlowIdentifier,
        _MBS_QoSFlowsToBeSetupItem_mBSqosFlowLevelQosParameters,
        ____MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__id_tab,
        ___MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__id,
        ____MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__criticality_tab,
        ___MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__criticality,
        ____MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__extensionValue_tab,
        ___MBS_QoSFlowsToBeSetupItem_iE_Extensions__item__extensionValue,
        __MBS_QoSFlowsToBeSetupItem_iE_Extensions__item_,
        _MBS_QoSFlowsToBeSetupItem_iE_Extensions,
        MBS_QoSFlowsToBeSetupItem,
        MBS_QoSFlowsToBeSetupItem_ExtIEs,
        _MBS_ServiceArea_locationindependent,
        _MBS_ServiceArea_locationdependent,
        ___MBS_ServiceArea_choice_Extensions_id_tab,
        __MBS_ServiceArea_choice_Extensions_id,
        ___MBS_ServiceArea_choice_Extensions_criticality_tab,
        __MBS_ServiceArea_choice_Extensions_criticality,
        ___MBS_ServiceArea_choice_Extensions_value_tab,
        __MBS_ServiceArea_choice_Extensions_value,
        _MBS_ServiceArea_choice_Extensions,
        MBS_ServiceArea,
        MBS_ServiceArea_ExtIEs,
        _MBS_ServiceAreaInformationList__item_,
        MBS_ServiceAreaInformationList,
        _MBS_ServiceAreaInformationItem_mBS_AreaSessionID,
        _MBS_ServiceAreaInformationItem_mBS_ServiceAreaInformation,
        ____MBS_ServiceAreaInformationItem_iE_Extensions__item__id_tab,
        ___MBS_ServiceAreaInformationItem_iE_Extensions__item__id,
        ____MBS_ServiceAreaInformationItem_iE_Extensions__item__criticality_tab,
        ___MBS_ServiceAreaInformationItem_iE_Extensions__item__criticality,
        ____MBS_ServiceAreaInformationItem_iE_Extensions__item__extensionValue_tab,
        ___MBS_ServiceAreaInformationItem_iE_Extensions__item__extensionValue,
        __MBS_ServiceAreaInformationItem_iE_Extensions__item_,
        _MBS_ServiceAreaInformationItem_iE_Extensions,
        MBS_ServiceAreaInformationItem,
        MBS_ServiceAreaInformationItem_ExtIEs,
        _MBS_ServiceAreaInformation_mBS_ServiceAreaCellList,
        _MBS_ServiceAreaInformation_mBS_ServiceAreaTAIList,
        ____MBS_ServiceAreaInformation_iE_Extensions__item__id_tab,
        ___MBS_ServiceAreaInformation_iE_Extensions__item__id,
        ____MBS_ServiceAreaInformation_iE_Extensions__item__criticality_tab,
        ___MBS_ServiceAreaInformation_iE_Extensions__item__criticality,
        ____MBS_ServiceAreaInformation_iE_Extensions__item__extensionValue_tab,
        ___MBS_ServiceAreaInformation_iE_Extensions__item__extensionValue,
        __MBS_ServiceAreaInformation_iE_Extensions__item_,
        _MBS_ServiceAreaInformation_iE_Extensions,
        MBS_ServiceAreaInformation,
        MBS_ServiceAreaInformation_ExtIEs,
        _MBS_ServiceAreaCellList__item_,
        MBS_ServiceAreaCellList,
        _MBS_ServiceAreaTAIList__item_,
        MBS_ServiceAreaTAIList,
        _MBS_SessionID_tMGI,
        _MBS_SessionID_nID,
        ____MBS_SessionID_iE_Extensions__item__id_tab,
        ___MBS_SessionID_iE_Extensions__item__id,
        ____MBS_SessionID_iE_Extensions__item__criticality_tab,
        ___MBS_SessionID_iE_Extensions__item__criticality,
        ____MBS_SessionID_iE_Extensions__item__extensionValue_tab,
        ___MBS_SessionID_iE_Extensions__item__extensionValue,
        __MBS_SessionID_iE_Extensions__item_,
        _MBS_SessionID_iE_Extensions,
        MBS_SessionID,
        MBS_SessionID_ExtIEs,
        _MBSSessionFailedtoSetupList__item_,
        MBSSessionFailedtoSetupList,
        _MBSSessionFailedtoSetupItem_mBS_SessionID,
        _MBSSessionFailedtoSetupItem_mBS_AreaSessionID,
        _MBSSessionFailedtoSetupItem_cause,
        ____MBSSessionFailedtoSetupItem_iE_Extensions__item__id_tab,
        ___MBSSessionFailedtoSetupItem_iE_Extensions__item__id,
        ____MBSSessionFailedtoSetupItem_iE_Extensions__item__criticality_tab,
        ___MBSSessionFailedtoSetupItem_iE_Extensions__item__criticality,
        ____MBSSessionFailedtoSetupItem_iE_Extensions__item__extensionValue_tab,
        ___MBSSessionFailedtoSetupItem_iE_Extensions__item__extensionValue,
        __MBSSessionFailedtoSetupItem_iE_Extensions__item_,
        _MBSSessionFailedtoSetupItem_iE_Extensions,
        MBSSessionFailedtoSetupItem,
        MBSSessionFailedtoSetupItem_ExtIEs,
        _MBS_ActiveSessionInformation_SourcetoTargetList__item_,
        MBS_ActiveSessionInformation_SourcetoTargetList,
        _MBS_ActiveSessionInformation_SourcetoTargetItem_mBS_SessionID,
        _MBS_ActiveSessionInformation_SourcetoTargetItem_mBS_AreaSessionID,
        _MBS_ActiveSessionInformation_SourcetoTargetItem_mBS_ServiceArea,
        _MBS_ActiveSessionInformation_SourcetoTargetItem_mBS_QoSFlowsToBeSetupList,
        _MBS_ActiveSessionInformation_SourcetoTargetItem_mBS_MappingandDataForwardingRequestList,
        ____MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__id_tab,
        ___MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__id,
        ____MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__criticality_tab,
        ___MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__criticality,
        ____MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__extensionValue_tab,
        ___MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item__extensionValue,
        __MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions__item_,
        _MBS_ActiveSessionInformation_SourcetoTargetItem_iE_Extensions,
        MBS_ActiveSessionInformation_SourcetoTargetItem,
        MBS_ActiveSessionInformation_SourcetoTargetItem_ExtIEs,
        _MBS_ActiveSessionInformation_TargettoSourceList__item_,
        MBS_ActiveSessionInformation_TargettoSourceList,
        _MBS_ActiveSessionInformation_TargettoSourceItem_mBS_SessionID,
        _MBS_ActiveSessionInformation_TargettoSourceItem_mBS_DataForwardingResponseMRBList,
        ____MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__id_tab,
        ___MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__id,
        ____MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__criticality_tab,
        ___MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__criticality,
        ____MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__extensionValue_tab,
        ___MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item__extensionValue,
        __MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions__item_,
        _MBS_ActiveSessionInformation_TargettoSourceItem_iE_Extensions,
        MBS_ActiveSessionInformation_TargettoSourceItem,
        MBS_ActiveSessionInformation_TargettoSourceItem_ExtIEs,
        _MBSSessionSetupOrModFailureTransfer_cause,
        _MBSSessionSetupOrModFailureTransfer_criticalityDiagnostics,
        ____MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__id_tab,
        ___MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__id,
        ____MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__criticality_tab,
        ___MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__criticality,
        ____MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__extensionValue_tab,
        ___MBSSessionSetupOrModFailureTransfer_iE_Extensions__item__extensionValue,
        __MBSSessionSetupOrModFailureTransfer_iE_Extensions__item_,
        _MBSSessionSetupOrModFailureTransfer_iE_Extensions,
        MBSSessionSetupOrModFailureTransfer,
        MBSSessionSetupOrModFailureTransfer_ExtIEs,
        _MBSSessionSetupResponseList__item_,
        MBSSessionSetupResponseList,
        _MBSSessionSetupResponseItem_mBS_SessionID,
        _MBSSessionSetupResponseItem_mBS_AreaSessionID,
        ____MBSSessionSetupResponseItem_iE_Extensions__item__id_tab,
        ___MBSSessionSetupResponseItem_iE_Extensions__item__id,
        ____MBSSessionSetupResponseItem_iE_Extensions__item__criticality_tab,
        ___MBSSessionSetupResponseItem_iE_Extensions__item__criticality,
        ____MBSSessionSetupResponseItem_iE_Extensions__item__extensionValue_tab,
        ___MBSSessionSetupResponseItem_iE_Extensions__item__extensionValue,
        __MBSSessionSetupResponseItem_iE_Extensions__item_,
        _MBSSessionSetupResponseItem_iE_Extensions,
        MBSSessionSetupResponseItem,
        MBSSessionSetupResponseItem_ExtIEs,
        ____MBSSessionSetupOrModRequestTransfer_protocolIEs__item__id_tab,
        _____MBSSessionSetupOrModRequestTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____MBSSessionSetupOrModRequestTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____MBSSessionSetupOrModRequestTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___MBSSessionSetupOrModRequestTransfer_protocolIEs__item__id,
        ___MBSSessionSetupOrModRequestTransfer_protocolIEs__item__criticality,
        ___MBSSessionSetupOrModRequestTransfer_protocolIEs__item__value,
        __MBSSessionSetupOrModRequestTransfer_protocolIEs__item_,
        _MBSSessionSetupOrModRequestTransfer_protocolIEs,
        MBSSessionSetupOrModRequestTransfer,
        MBSSessionSetupOrModRequestTransferIEs,
        _MBSSessionSetupOrModRequestTransferIEs_val_Value_0,
        _MBSSessionSetupOrModRequestTransferIEs_val_Value_1,
        _MBSSessionSetupOrModRequestTransferIEs_val_Value_2,
        _MBS_SessionFSAIDList__item_,
        MBS_SessionFSAIDList,
        MBS_SessionFSAID,
        _MBSSessionReleaseResponseTransfer_mBS_SessionTNLInfoNGRAN,
        ____MBSSessionReleaseResponseTransfer_iE_Extensions__item__id_tab,
        ___MBSSessionReleaseResponseTransfer_iE_Extensions__item__id,
        ____MBSSessionReleaseResponseTransfer_iE_Extensions__item__criticality_tab,
        ___MBSSessionReleaseResponseTransfer_iE_Extensions__item__criticality,
        ____MBSSessionReleaseResponseTransfer_iE_Extensions__item__extensionValue_tab,
        ___MBSSessionReleaseResponseTransfer_iE_Extensions__item__extensionValue,
        __MBSSessionReleaseResponseTransfer_iE_Extensions__item_,
        _MBSSessionReleaseResponseTransfer_iE_Extensions,
        MBSSessionReleaseResponseTransfer,
        MBSSessionReleaseResponseTransfer_ExtIEs,
        _MBSSessionSetupOrModResponseTransfer_mBS_SessionTNLInfoNGRAN,
        ____MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__id_tab,
        ___MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__id,
        ____MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__criticality_tab,
        ___MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__criticality,
        ____MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__extensionValue_tab,
        ___MBSSessionSetupOrModResponseTransfer_iE_Extensions__item__extensionValue,
        __MBSSessionSetupOrModResponseTransfer_iE_Extensions__item_,
        _MBSSessionSetupOrModResponseTransfer_iE_Extensions,
        MBSSessionSetupOrModResponseTransfer,
        MBSSessionSetupOrModResponseTransfer_ExtIEs,
        MBS_SupportIndicator,
        _MBS_SessionTNLInfo5GC_locationindependent,
        _MBS_SessionTNLInfo5GC_locationdependent,
        ___MBS_SessionTNLInfo5GC_choice_Extensions_id_tab,
        __MBS_SessionTNLInfo5GC_choice_Extensions_id,
        ___MBS_SessionTNLInfo5GC_choice_Extensions_criticality_tab,
        __MBS_SessionTNLInfo5GC_choice_Extensions_criticality,
        ___MBS_SessionTNLInfo5GC_choice_Extensions_value_tab,
        __MBS_SessionTNLInfo5GC_choice_Extensions_value,
        _MBS_SessionTNLInfo5GC_choice_Extensions,
        MBS_SessionTNLInfo5GC,
        MBS_SessionTNLInfo5GC_ExtIEs,
        _MBS_SessionTNLInfo5GCList__item_,
        MBS_SessionTNLInfo5GCList,
        _MBS_SessionTNLInfo5GCItem_mBS_AreaSessionID,
        _MBS_SessionTNLInfo5GCItem_sharedNGU_MulticastTNLInformation,
        ____MBS_SessionTNLInfo5GCItem_iE_Extensions__item__id_tab,
        ___MBS_SessionTNLInfo5GCItem_iE_Extensions__item__id,
        ____MBS_SessionTNLInfo5GCItem_iE_Extensions__item__criticality_tab,
        ___MBS_SessionTNLInfo5GCItem_iE_Extensions__item__criticality,
        ____MBS_SessionTNLInfo5GCItem_iE_Extensions__item__extensionValue_tab,
        ___MBS_SessionTNLInfo5GCItem_iE_Extensions__item__extensionValue,
        __MBS_SessionTNLInfo5GCItem_iE_Extensions__item_,
        _MBS_SessionTNLInfo5GCItem_iE_Extensions,
        MBS_SessionTNLInfo5GCItem,
        MBS_SessionTNLInfo5GCItem_ExtIEs,
        _MBS_SessionTNLInfoNGRAN_locationindependent,
        _MBS_SessionTNLInfoNGRAN_locationdependent,
        ___MBS_SessionTNLInfoNGRAN_choice_Extensions_id_tab,
        __MBS_SessionTNLInfoNGRAN_choice_Extensions_id,
        ___MBS_SessionTNLInfoNGRAN_choice_Extensions_criticality_tab,
        __MBS_SessionTNLInfoNGRAN_choice_Extensions_criticality,
        ___MBS_SessionTNLInfoNGRAN_choice_Extensions_value_tab,
        __MBS_SessionTNLInfoNGRAN_choice_Extensions_value,
        _MBS_SessionTNLInfoNGRAN_choice_Extensions,
        MBS_SessionTNLInfoNGRAN,
        MBS_SessionTNLInfoNGRAN_ExtIEs,
        _MBS_SessionTNLInfoNGRANList__item_,
        MBS_SessionTNLInfoNGRANList,
        _MBS_SessionTNLInfoNGRANItem_mBS_AreaSessionID,
        _MBS_SessionTNLInfoNGRANItem_sharedNGU_UnicastTNLInformation,
        ____MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__id_tab,
        ___MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__id,
        ____MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__criticality_tab,
        ___MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__criticality,
        ____MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__extensionValue_tab,
        ___MBS_SessionTNLInfoNGRANItem_iE_Extensions__item__extensionValue,
        __MBS_SessionTNLInfoNGRANItem_iE_Extensions__item_,
        _MBS_SessionTNLInfoNGRANItem_iE_Extensions,
        MBS_SessionTNLInfoNGRANItem,
        MBS_SessionTNLInfoNGRANItem_ExtIEs,
        _MBS_DistributionReleaseRequestTransfer_mBS_SessionID,
        _MBS_DistributionReleaseRequestTransfer_mBS_AreaSessionID,
        _MBS_DistributionReleaseRequestTransfer_sharedNGU_UnicastTNLInformation,
        _MBS_DistributionReleaseRequestTransfer_cause,
        ____MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__id_tab,
        ___MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__id,
        ____MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__criticality_tab,
        ___MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__criticality,
        ____MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__extensionValue_tab,
        ___MBS_DistributionReleaseRequestTransfer_iE_Extensions__item__extensionValue,
        __MBS_DistributionReleaseRequestTransfer_iE_Extensions__item_,
        _MBS_DistributionReleaseRequestTransfer_iE_Extensions,
        MBS_DistributionReleaseRequestTransfer,
        MBS_DistributionReleaseRequesTransfer_ExtIEs,
        _MBS_DistributionSetupRequestTransfer_mBS_SessionID,
        _MBS_DistributionSetupRequestTransfer_mBS_AreaSessionID,
        _MBS_DistributionSetupRequestTransfer_sharedNGU_UnicastTNLInformation,
        ____MBS_DistributionSetupRequestTransfer_iE_Extensions__item__id_tab,
        ___MBS_DistributionSetupRequestTransfer_iE_Extensions__item__id,
        ____MBS_DistributionSetupRequestTransfer_iE_Extensions__item__criticality_tab,
        ___MBS_DistributionSetupRequestTransfer_iE_Extensions__item__criticality,
        ____MBS_DistributionSetupRequestTransfer_iE_Extensions__item__extensionValue_tab,
        ___MBS_DistributionSetupRequestTransfer_iE_Extensions__item__extensionValue,
        __MBS_DistributionSetupRequestTransfer_iE_Extensions__item_,
        _MBS_DistributionSetupRequestTransfer_iE_Extensions,
        MBS_DistributionSetupRequestTransfer,
        MBS_DistributionSetupRequestTransfer_ExtIEs,
        _MBS_DistributionSetupResponseTransfer_mBS_SessionID,
        _MBS_DistributionSetupResponseTransfer_mBS_AreaSessionID,
        _MBS_DistributionSetupResponseTransfer_sharedNGU_MulticastTNLInformation,
        _MBS_DistributionSetupResponseTransfer_mBS_QoSFlowsToBeSetupList,
        _MBS_DistributionSetupResponseTransfer_mBSSessionStatus,
        _MBS_DistributionSetupResponseTransfer_mBS_ServiceArea,
        ____MBS_DistributionSetupResponseTransfer_iE_Extensions__item__id_tab,
        ___MBS_DistributionSetupResponseTransfer_iE_Extensions__item__id,
        ____MBS_DistributionSetupResponseTransfer_iE_Extensions__item__criticality_tab,
        ___MBS_DistributionSetupResponseTransfer_iE_Extensions__item__criticality,
        ____MBS_DistributionSetupResponseTransfer_iE_Extensions__item__extensionValue_tab,
        ___MBS_DistributionSetupResponseTransfer_iE_Extensions__item__extensionValue,
        __MBS_DistributionSetupResponseTransfer_iE_Extensions__item_,
        _MBS_DistributionSetupResponseTransfer_iE_Extensions,
        MBS_DistributionSetupResponseTransfer,
        MBS_DistributionSetupResponseTransfer_ExtIEs,
        _MBS_DistributionSetupUnsuccessfulTransfer_mBS_SessionID,
        _MBS_DistributionSetupUnsuccessfulTransfer_mBS_AreaSessionID,
        _MBS_DistributionSetupUnsuccessfulTransfer_cause,
        _MBS_DistributionSetupUnsuccessfulTransfer_criticalityDiagnostics,
        ____MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__id_tab,
        ___MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__id,
        ____MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__criticality_tab,
        ___MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__criticality,
        ____MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab,
        ___MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue,
        __MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions__item_,
        _MBS_DistributionSetupUnsuccessfulTransfer_iE_Extensions,
        MBS_DistributionSetupUnsuccessfulTransfer,
        MBS_DistributionSetupUnsuccessfulTransfer_ExtIEs,
        _MBSSessionSetupRequestList__item_,
        MBSSessionSetupRequestList,
        _MBSSessionSetupRequestItem_mBS_SessionID,
        _MBSSessionSetupRequestItem_mBS_AreaSessionID,
        _MBSSessionSetupRequestItem_associatedMBSQosFlowSetupRequestList,
        ____MBSSessionSetupRequestItem_iE_Extensions__item__id_tab,
        ___MBSSessionSetupRequestItem_iE_Extensions__item__id,
        ____MBSSessionSetupRequestItem_iE_Extensions__item__criticality_tab,
        ___MBSSessionSetupRequestItem_iE_Extensions__item__criticality,
        ____MBSSessionSetupRequestItem_iE_Extensions__item__extensionValue_tab,
        ___MBSSessionSetupRequestItem_iE_Extensions__item__extensionValue,
        __MBSSessionSetupRequestItem_iE_Extensions__item_,
        _MBSSessionSetupRequestItem_iE_Extensions,
        MBSSessionSetupRequestItem,
        MBSSessionSetupRequestItem_ExtIEs,
        _MBSSessionSetuporModifyRequestList__item_,
        MBSSessionSetuporModifyRequestList,
        _MBSSessionSetuporModifyRequestItem_mBS_SessionID,
        _MBSSessionSetuporModifyRequestItem_mBS_AreaSessionID,
        _MBSSessionSetuporModifyRequestItem_associatedMBSQosFlowSetuporModifyRequestList,
        _MBSSessionSetuporModifyRequestItem_mBS_QosFlowToReleaseList,
        ____MBSSessionSetuporModifyRequestItem_iE_Extensions__item__id_tab,
        ___MBSSessionSetuporModifyRequestItem_iE_Extensions__item__id,
        ____MBSSessionSetuporModifyRequestItem_iE_Extensions__item__criticality_tab,
        ___MBSSessionSetuporModifyRequestItem_iE_Extensions__item__criticality,
        ____MBSSessionSetuporModifyRequestItem_iE_Extensions__item__extensionValue_tab,
        ___MBSSessionSetuporModifyRequestItem_iE_Extensions__item__extensionValue,
        __MBSSessionSetuporModifyRequestItem_iE_Extensions__item_,
        _MBSSessionSetuporModifyRequestItem_iE_Extensions,
        MBSSessionSetuporModifyRequestItem,
        MBSSessionSetuporModifyRequestItem_ExtIEs,
        _MBSSessionToReleaseList__item_,
        MBSSessionToReleaseList,
        _MBSSessionToReleaseItem_mBS_SessionID,
        _MBSSessionToReleaseItem_cause,
        ____MBSSessionToReleaseItem_iE_Extensions__item__id_tab,
        ___MBSSessionToReleaseItem_iE_Extensions__item__id,
        ____MBSSessionToReleaseItem_iE_Extensions__item__criticality_tab,
        ___MBSSessionToReleaseItem_iE_Extensions__item__criticality,
        ____MBSSessionToReleaseItem_iE_Extensions__item__extensionValue_tab,
        ___MBSSessionToReleaseItem_iE_Extensions__item__extensionValue,
        __MBSSessionToReleaseItem_iE_Extensions__item_,
        _MBSSessionToReleaseItem_iE_Extensions,
        MBSSessionToReleaseItem,
        MBSSessionToReleaseItem_ExtIEs,
        MBSSessionStatus,
        MicoAllPLMN,
        MICOModeIndication,
        MobilityInformation,
        _MobilityRestrictionList_servingPLMN,
        _MobilityRestrictionList_equivalentPLMNs,
        _MobilityRestrictionList_rATRestrictions,
        _MobilityRestrictionList_forbiddenAreaInformation,
        _MobilityRestrictionList_serviceAreaInformation,
        ____MobilityRestrictionList_iE_Extensions__item__id_tab,
        _____MobilityRestrictionList_iE_Extensions__item__id_tab_val_Extension_0,
        _____MobilityRestrictionList_iE_Extensions__item__id_tab_val_Extension_1,
        _____MobilityRestrictionList_iE_Extensions__item__id_tab_val_Extension_2,
        _____MobilityRestrictionList_iE_Extensions__item__id_tab_val_Extension_3,
        ___MobilityRestrictionList_iE_Extensions__item__id,
        ___MobilityRestrictionList_iE_Extensions__item__criticality,
        ___MobilityRestrictionList_iE_Extensions__item__extensionValue,
        __MobilityRestrictionList_iE_Extensions__item_,
        _MobilityRestrictionList_iE_Extensions,
        MobilityRestrictionList,
        MobilityRestrictionList_ExtIEs,
        _MobilityRestrictionList_ExtIEs_val_Extension_0,
        _MobilityRestrictionList_ExtIEs_val_Extension_1,
        _MobilityRestrictionList_ExtIEs_val_Extension_2,
        _MobilityRestrictionList_ExtIEs_val_Extension_3,
        _MDT_AlignmentInfo_s_basedMDT,
        ___MDT_AlignmentInfo_choice_Extensions_id_tab,
        __MDT_AlignmentInfo_choice_Extensions_id,
        ___MDT_AlignmentInfo_choice_Extensions_criticality_tab,
        __MDT_AlignmentInfo_choice_Extensions_criticality,
        ___MDT_AlignmentInfo_choice_Extensions_value_tab,
        __MDT_AlignmentInfo_choice_Extensions_value,
        _MDT_AlignmentInfo_choice_Extensions,
        MDT_AlignmentInfo,
        MDT_AlignmentInfo_ExtIEs,
        _MDTPLMNList__item_,
        MDTPLMNList,
        _MDTPLMNModificationList__item_,
        MDTPLMNModificationList,
        _MDT_Configuration_mdt_Config_NR,
        _MDT_Configuration_mdt_Config_EUTRA,
        ____MDT_Configuration_iE_Extensions__item__id_tab,
        ___MDT_Configuration_iE_Extensions__item__id,
        ____MDT_Configuration_iE_Extensions__item__criticality_tab,
        ___MDT_Configuration_iE_Extensions__item__criticality,
        ____MDT_Configuration_iE_Extensions__item__extensionValue_tab,
        ___MDT_Configuration_iE_Extensions__item__extensionValue,
        __MDT_Configuration_iE_Extensions__item_,
        _MDT_Configuration_iE_Extensions,
        MDT_Configuration,
        MDT_Configuration_ExtIEs,
        _MDT_Configuration_NR_mdt_Activation,
        _MDT_Configuration_NR_areaScopeOfMDT,
        _MDT_Configuration_NR_mDTModeNr,
        _MDT_Configuration_NR_signallingBasedMDTPLMNList,
        ____MDT_Configuration_NR_iE_Extensions__item__id_tab,
        ___MDT_Configuration_NR_iE_Extensions__item__id,
        ____MDT_Configuration_NR_iE_Extensions__item__criticality_tab,
        ___MDT_Configuration_NR_iE_Extensions__item__criticality,
        ____MDT_Configuration_NR_iE_Extensions__item__extensionValue_tab,
        ___MDT_Configuration_NR_iE_Extensions__item__extensionValue,
        __MDT_Configuration_NR_iE_Extensions__item_,
        _MDT_Configuration_NR_iE_Extensions,
        MDT_Configuration_NR,
        MDT_Configuration_NR_ExtIEs,
        _MDT_Configuration_EUTRA_mdt_Activation,
        _MDT_Configuration_EUTRA_areaScopeOfMDT,
        _MDT_Configuration_EUTRA_mDTMode,
        _MDT_Configuration_EUTRA_signallingBasedMDTPLMNList,
        ____MDT_Configuration_EUTRA_iE_Extensions__item__id_tab,
        ___MDT_Configuration_EUTRA_iE_Extensions__item__id,
        ____MDT_Configuration_EUTRA_iE_Extensions__item__criticality_tab,
        ___MDT_Configuration_EUTRA_iE_Extensions__item__criticality,
        ____MDT_Configuration_EUTRA_iE_Extensions__item__extensionValue_tab,
        ___MDT_Configuration_EUTRA_iE_Extensions__item__extensionValue,
        __MDT_Configuration_EUTRA_iE_Extensions__item_,
        _MDT_Configuration_EUTRA_iE_Extensions,
        MDT_Configuration_EUTRA,
        MDT_Configuration_EUTRA_ExtIEs,
        MDT_Activation,
        _MDTModeNr_immediateMDTNr,
        _MDTModeNr_loggedMDTNr,
        ___MDTModeNr_choice_Extensions_id_tab,
        __MDTModeNr_choice_Extensions_id,
        ___MDTModeNr_choice_Extensions_criticality_tab,
        __MDTModeNr_choice_Extensions_criticality,
        ___MDTModeNr_choice_Extensions_value_tab,
        __MDTModeNr_choice_Extensions_value,
        _MDTModeNr_choice_Extensions,
        MDTModeNr,
        MDTModeNr_ExtIEs,
        MDTModeEutra,
        MeasurementsToActivate,
        MRB_ID,
        _MulticastSessionActivationRequestTransfer_mBS_SessionID,
        ____MulticastSessionActivationRequestTransfer_iE_Extensions__item__id_tab,
        ___MulticastSessionActivationRequestTransfer_iE_Extensions__item__id,
        ____MulticastSessionActivationRequestTransfer_iE_Extensions__item__criticality_tab,
        ___MulticastSessionActivationRequestTransfer_iE_Extensions__item__criticality,
        ____MulticastSessionActivationRequestTransfer_iE_Extensions__item__extensionValue_tab,
        ___MulticastSessionActivationRequestTransfer_iE_Extensions__item__extensionValue,
        __MulticastSessionActivationRequestTransfer_iE_Extensions__item_,
        _MulticastSessionActivationRequestTransfer_iE_Extensions,
        MulticastSessionActivationRequestTransfer,
        MulticastSessionActivationRequestTransfer_ExtIEs,
        _MulticastSessionDeactivationRequestTransfer_mBS_SessionID,
        ____MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__id_tab,
        ___MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__id,
        ____MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__criticality_tab,
        ___MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__criticality,
        ____MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__extensionValue_tab,
        ___MulticastSessionDeactivationRequestTransfer_iE_Extensions__item__extensionValue,
        __MulticastSessionDeactivationRequestTransfer_iE_Extensions__item_,
        _MulticastSessionDeactivationRequestTransfer_iE_Extensions,
        MulticastSessionDeactivationRequestTransfer,
        MulticastSessionDeactivationRequestTransfer_ExtIEs,
        ____MulticastSessionUpdateRequestTransfer_protocolIEs__item__id_tab,
        _____MulticastSessionUpdateRequestTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____MulticastSessionUpdateRequestTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____MulticastSessionUpdateRequestTransfer_protocolIEs__item__id_tab_val_Value_2,
        _____MulticastSessionUpdateRequestTransfer_protocolIEs__item__id_tab_val_Value_3,
        _____MulticastSessionUpdateRequestTransfer_protocolIEs__item__id_tab_val_Value_4,
        ___MulticastSessionUpdateRequestTransfer_protocolIEs__item__id,
        ___MulticastSessionUpdateRequestTransfer_protocolIEs__item__criticality,
        ___MulticastSessionUpdateRequestTransfer_protocolIEs__item__value,
        __MulticastSessionUpdateRequestTransfer_protocolIEs__item_,
        _MulticastSessionUpdateRequestTransfer_protocolIEs,
        MulticastSessionUpdateRequestTransfer,
        MulticastSessionUpdateRequestTransferIEs,
        _MulticastSessionUpdateRequestTransferIEs_val_Value_0,
        _MulticastSessionUpdateRequestTransferIEs_val_Value_1,
        _MulticastSessionUpdateRequestTransferIEs_val_Value_2,
        _MulticastSessionUpdateRequestTransferIEs_val_Value_3,
        _MulticastSessionUpdateRequestTransferIEs_val_Value_4,
        _MulticastGroupPagingAreaList__item_,
        MulticastGroupPagingAreaList,
        _MulticastGroupPagingAreaItem_multicastGroupPagingArea,
        _MulticastGroupPagingAreaItem_uE_PagingList,
        ____MulticastGroupPagingAreaItem_iE_Extensions__item__id_tab,
        ___MulticastGroupPagingAreaItem_iE_Extensions__item__id,
        ____MulticastGroupPagingAreaItem_iE_Extensions__item__criticality_tab,
        ___MulticastGroupPagingAreaItem_iE_Extensions__item__criticality,
        ____MulticastGroupPagingAreaItem_iE_Extensions__item__extensionValue_tab,
        ___MulticastGroupPagingAreaItem_iE_Extensions__item__extensionValue,
        __MulticastGroupPagingAreaItem_iE_Extensions__item_,
        _MulticastGroupPagingAreaItem_iE_Extensions,
        MulticastGroupPagingAreaItem,
        MulticastGroupPagingAreaItem_ExtIEs,
        _MBS_AreaTAIList__item_,
        MBS_AreaTAIList,
        _MulticastGroupPagingArea_mBS_AreaTAIList,
        ____MulticastGroupPagingArea_iE_Extensions__item__id_tab,
        ___MulticastGroupPagingArea_iE_Extensions__item__id,
        ____MulticastGroupPagingArea_iE_Extensions__item__criticality_tab,
        ___MulticastGroupPagingArea_iE_Extensions__item__criticality,
        ____MulticastGroupPagingArea_iE_Extensions__item__extensionValue_tab,
        ___MulticastGroupPagingArea_iE_Extensions__item__extensionValue,
        __MulticastGroupPagingArea_iE_Extensions__item_,
        _MulticastGroupPagingArea_iE_Extensions,
        MulticastGroupPagingArea,
        MulticastGroupPagingArea_ExtIEs,
        _UE_PagingList__item_,
        UE_PagingList,
        _UE_PagingItem_uEIdentityIndexValue,
        _UE_PagingItem_pagingDRX,
        ____UE_PagingItem_iE_Extensions__item__id_tab,
        ___UE_PagingItem_iE_Extensions__item__id,
        ____UE_PagingItem_iE_Extensions__item__criticality_tab,
        ___UE_PagingItem_iE_Extensions__item__criticality,
        ____UE_PagingItem_iE_Extensions__item__extensionValue_tab,
        ___UE_PagingItem_iE_Extensions__item__extensionValue,
        __UE_PagingItem_iE_Extensions__item_,
        _UE_PagingItem_iE_Extensions,
        UE_PagingItem,
        UE_PagingItem_ExtIEs,
        _M1Configuration_m1reportingTrigger,
        _M1Configuration_m1thresholdEventA2,
        _M1Configuration_m1periodicReporting,
        ____M1Configuration_iE_Extensions__item__id_tab,
        _____M1Configuration_iE_Extensions__item__id_tab_val_Extension_0,
        _____M1Configuration_iE_Extensions__item__id_tab_val_Extension_1,
        ___M1Configuration_iE_Extensions__item__id,
        ___M1Configuration_iE_Extensions__item__criticality,
        ___M1Configuration_iE_Extensions__item__extensionValue,
        __M1Configuration_iE_Extensions__item_,
        _M1Configuration_iE_Extensions,
        M1Configuration,
        M1Configuration_ExtIEs,
        _M1Configuration_ExtIEs_val_Extension_0,
        _M1Configuration_ExtIEs_val_Extension_1,
        IncludeBeamMeasurementsIndication,
        MaxNrofRS_IndexesToReport,
        M1ReportingTrigger,
        _M1ThresholdEventA2_m1ThresholdType,
        ____M1ThresholdEventA2_iE_Extensions__item__id_tab,
        ___M1ThresholdEventA2_iE_Extensions__item__id,
        ____M1ThresholdEventA2_iE_Extensions__item__criticality_tab,
        ___M1ThresholdEventA2_iE_Extensions__item__criticality,
        ____M1ThresholdEventA2_iE_Extensions__item__extensionValue_tab,
        ___M1ThresholdEventA2_iE_Extensions__item__extensionValue,
        __M1ThresholdEventA2_iE_Extensions__item_,
        _M1ThresholdEventA2_iE_Extensions,
        M1ThresholdEventA2,
        M1ThresholdEventA2_ExtIEs,
        _M1ThresholdType_threshold_RSRP,
        _M1ThresholdType_threshold_RSRQ,
        _M1ThresholdType_threshold_SINR,
        ___M1ThresholdType_choice_Extensions_id_tab,
        __M1ThresholdType_choice_Extensions_id,
        ___M1ThresholdType_choice_Extensions_criticality_tab,
        __M1ThresholdType_choice_Extensions_criticality,
        ___M1ThresholdType_choice_Extensions_value_tab,
        __M1ThresholdType_choice_Extensions_value,
        _M1ThresholdType_choice_Extensions,
        M1ThresholdType,
        M1ThresholdType_ExtIEs,
        _M1PeriodicReporting_reportInterval,
        _M1PeriodicReporting_reportAmount,
        ____M1PeriodicReporting_iE_Extensions__item__id_tab,
        _____M1PeriodicReporting_iE_Extensions__item__id_tab_val_Extension_0,
        ___M1PeriodicReporting_iE_Extensions__item__id,
        ___M1PeriodicReporting_iE_Extensions__item__criticality,
        ___M1PeriodicReporting_iE_Extensions__item__extensionValue,
        __M1PeriodicReporting_iE_Extensions__item_,
        _M1PeriodicReporting_iE_Extensions,
        M1PeriodicReporting,
        M1PeriodicReporting_ExtIEs,
        _M1PeriodicReporting_ExtIEs_val_Extension_0,
        _M4Configuration_m4period,
        _M4Configuration_m4_links_to_log,
        ____M4Configuration_iE_Extensions__item__id_tab,
        _____M4Configuration_iE_Extensions__item__id_tab_val_Extension_0,
        ___M4Configuration_iE_Extensions__item__id,
        ___M4Configuration_iE_Extensions__item__criticality,
        ___M4Configuration_iE_Extensions__item__extensionValue,
        __M4Configuration_iE_Extensions__item_,
        _M4Configuration_iE_Extensions,
        M4Configuration,
        M4Configuration_ExtIEs,
        _M4Configuration_ExtIEs_val_Extension_0,
        M4ReportAmountMDT,
        M4period,
        _M5Configuration_m5period,
        _M5Configuration_m5_links_to_log,
        ____M5Configuration_iE_Extensions__item__id_tab,
        _____M5Configuration_iE_Extensions__item__id_tab_val_Extension_0,
        ___M5Configuration_iE_Extensions__item__id,
        ___M5Configuration_iE_Extensions__item__criticality,
        ___M5Configuration_iE_Extensions__item__extensionValue,
        __M5Configuration_iE_Extensions__item_,
        _M5Configuration_iE_Extensions,
        M5Configuration,
        M5Configuration_ExtIEs,
        _M5Configuration_ExtIEs_val_Extension_0,
        M5ReportAmountMDT,
        M5period,
        _M6Configuration_m6report_Interval,
        _M6Configuration_m6_links_to_log,
        ____M6Configuration_iE_Extensions__item__id_tab,
        _____M6Configuration_iE_Extensions__item__id_tab_val_Extension_0,
        _____M6Configuration_iE_Extensions__item__id_tab_val_Extension_1,
        ___M6Configuration_iE_Extensions__item__id,
        ___M6Configuration_iE_Extensions__item__criticality,
        ___M6Configuration_iE_Extensions__item__extensionValue,
        __M6Configuration_iE_Extensions__item_,
        _M6Configuration_iE_Extensions,
        M6Configuration,
        M6Configuration_ExtIEs,
        _M6Configuration_ExtIEs_val_Extension_0,
        _M6Configuration_ExtIEs_val_Extension_1,
        M6ReportAmountMDT,
        M6report_Interval,
        _M7Configuration_m7period,
        _M7Configuration_m7_links_to_log,
        ____M7Configuration_iE_Extensions__item__id_tab,
        _____M7Configuration_iE_Extensions__item__id_tab_val_Extension_0,
        ___M7Configuration_iE_Extensions__item__id,
        ___M7Configuration_iE_Extensions__item__criticality,
        ___M7Configuration_iE_Extensions__item__extensionValue,
        __M7Configuration_iE_Extensions__item_,
        _M7Configuration_iE_Extensions,
        M7Configuration,
        M7Configuration_ExtIEs,
        _M7Configuration_ExtIEs_val_Extension_0,
        M7ReportAmountMDT,
        M7period,
        _MDT_Location_Info_mDT_Location_Information,
        ____MDT_Location_Info_iE_Extensions__item__id_tab,
        ___MDT_Location_Info_iE_Extensions__item__id,
        ____MDT_Location_Info_iE_Extensions__item__criticality_tab,
        ___MDT_Location_Info_iE_Extensions__item__criticality,
        ____MDT_Location_Info_iE_Extensions__item__extensionValue_tab,
        ___MDT_Location_Info_iE_Extensions__item__extensionValue,
        __MDT_Location_Info_iE_Extensions__item_,
        _MDT_Location_Info_iE_Extensions,
        MDT_Location_Info,
        MDT_Location_Info_ExtIEs,
        MDT_Location_Information,
        _N3IWF_ID_n3IWF_ID,
        ___N3IWF_ID_choice_Extensions_id_tab,
        __N3IWF_ID_choice_Extensions_id,
        ___N3IWF_ID_choice_Extensions_criticality_tab,
        __N3IWF_ID_choice_Extensions_criticality,
        ___N3IWF_ID_choice_Extensions_value_tab,
        __N3IWF_ID_choice_Extensions_value,
        _N3IWF_ID_choice_Extensions,
        N3IWF_ID,
        N3IWF_ID_ExtIEs,
        NAS_PDU,
        NASSecurityParametersFromNGRAN,
        NB_IoT_DefaultPagingDRX,
        NB_IoT_PagingDRX,
        NB_IoT_Paging_eDRXCycle,
        NB_IoT_Paging_TimeWindow,
        _NB_IoT_Paging_eDRXInfo_nB_IoT_Paging_eDRXCycle,
        _NB_IoT_Paging_eDRXInfo_nB_IoT_Paging_TimeWindow,
        ____NB_IoT_Paging_eDRXInfo_iE_Extensions__item__id_tab,
        ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__id,
        ____NB_IoT_Paging_eDRXInfo_iE_Extensions__item__criticality_tab,
        ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__criticality,
        ____NB_IoT_Paging_eDRXInfo_iE_Extensions__item__extensionValue_tab,
        ___NB_IoT_Paging_eDRXInfo_iE_Extensions__item__extensionValue,
        __NB_IoT_Paging_eDRXInfo_iE_Extensions__item_,
        _NB_IoT_Paging_eDRXInfo_iE_Extensions,
        NB_IoT_Paging_eDRXInfo,
        NB_IoT_Paging_eDRXInfo_ExtIEs,
        NB_IoT_UEPriority,
        NetworkInstance,
        NewSecurityContextInd,
        NextHopChainingCount,
        NextPagingAreaScope,
        _NGAPIESupportInformationRequestList__item_,
        NGAPIESupportInformationRequestList,
        _NGAPIESupportInformationRequestItem_ngap_ProtocolIE_Id,
        ____NGAPIESupportInformationRequestItem_iE_Extensions__item__id_tab,
        ___NGAPIESupportInformationRequestItem_iE_Extensions__item__id,
        ____NGAPIESupportInformationRequestItem_iE_Extensions__item__criticality_tab,
        ___NGAPIESupportInformationRequestItem_iE_Extensions__item__criticality,
        ____NGAPIESupportInformationRequestItem_iE_Extensions__item__extensionValue_tab,
        ___NGAPIESupportInformationRequestItem_iE_Extensions__item__extensionValue,
        __NGAPIESupportInformationRequestItem_iE_Extensions__item_,
        _NGAPIESupportInformationRequestItem_iE_Extensions,
        NGAPIESupportInformationRequestItem,
        NGAPIESupportInformationRequestItem_ExtIEs,
        _NGAPIESupportInformationResponseList__item_,
        NGAPIESupportInformationResponseList,
        _NGAPIESupportInformationResponseItem_ngap_ProtocolIE_Id,
        _NGAPIESupportInformationResponseItem_ngap_ProtocolIESupportInfo,
        _NGAPIESupportInformationResponseItem_ngap_ProtocolIEPresenceInfo,
        ____NGAPIESupportInformationResponseItem_iE_Extensions__item__id_tab,
        ___NGAPIESupportInformationResponseItem_iE_Extensions__item__id,
        ____NGAPIESupportInformationResponseItem_iE_Extensions__item__criticality_tab,
        ___NGAPIESupportInformationResponseItem_iE_Extensions__item__criticality,
        ____NGAPIESupportInformationResponseItem_iE_Extensions__item__extensionValue_tab,
        ___NGAPIESupportInformationResponseItem_iE_Extensions__item__extensionValue,
        __NGAPIESupportInformationResponseItem_iE_Extensions__item_,
        _NGAPIESupportInformationResponseItem_iE_Extensions,
        NGAPIESupportInformationResponseItem,
        NGAPIESupportInformationResponseItem_ExtIEs,
        _NgENB_ID_macroNgENB_ID,
        _NgENB_ID_shortMacroNgENB_ID,
        _NgENB_ID_longMacroNgENB_ID,
        ___NgENB_ID_choice_Extensions_id_tab,
        __NgENB_ID_choice_Extensions_id,
        ___NgENB_ID_choice_Extensions_criticality_tab,
        __NgENB_ID_choice_Extensions_criticality,
        ___NgENB_ID_choice_Extensions_value_tab,
        __NgENB_ID_choice_Extensions_value,
        _NgENB_ID_choice_Extensions,
        NgENB_ID,
        NgENB_ID_ExtIEs,
        NotifySourceNGRANNode,
        _NGRAN_CGI_nR_CGI,
        _NGRAN_CGI_eUTRA_CGI,
        ___NGRAN_CGI_choice_Extensions_id_tab,
        __NGRAN_CGI_choice_Extensions_id,
        ___NGRAN_CGI_choice_Extensions_criticality_tab,
        __NGRAN_CGI_choice_Extensions_criticality,
        ___NGRAN_CGI_choice_Extensions_value_tab,
        __NGRAN_CGI_choice_Extensions_value,
        _NGRAN_CGI_choice_Extensions,
        NGRAN_CGI,
        NGRAN_CGI_ExtIEs,
        _NGRAN_TNLAssociationToRemoveList__item_,
        NGRAN_TNLAssociationToRemoveList,
        _NGRAN_TNLAssociationToRemoveItem_tNLAssociationTransportLayerAddress,
        _NGRAN_TNLAssociationToRemoveItem_tNLAssociationTransportLayerAddressAMF,
        ____NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__id_tab,
        ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__id,
        ____NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__criticality_tab,
        ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__criticality,
        ____NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue_tab,
        ___NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item__extensionValue,
        __NGRAN_TNLAssociationToRemoveItem_iE_Extensions__item_,
        _NGRAN_TNLAssociationToRemoveItem_iE_Extensions,
        NGRAN_TNLAssociationToRemoveItem,
        NGRAN_TNLAssociationToRemoveItem_ExtIEs,
        NGRANTraceID,
        NID,
        _NonDynamic5QIDescriptor_fiveQI,
        _NonDynamic5QIDescriptor_priorityLevelQos,
        _NonDynamic5QIDescriptor_averagingWindow,
        _NonDynamic5QIDescriptor_maximumDataBurstVolume,
        ____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab,
        _____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_0,
        _____NonDynamic5QIDescriptor_iE_Extensions__item__id_tab_val_Extension_1,
        ___NonDynamic5QIDescriptor_iE_Extensions__item__id,
        ___NonDynamic5QIDescriptor_iE_Extensions__item__criticality,
        ___NonDynamic5QIDescriptor_iE_Extensions__item__extensionValue,
        __NonDynamic5QIDescriptor_iE_Extensions__item_,
        _NonDynamic5QIDescriptor_iE_Extensions,
        NonDynamic5QIDescriptor,
        NonDynamic5QIDescriptor_ExtIEs,
        _NonDynamic5QIDescriptor_ExtIEs_val_Extension_0,
        _NonDynamic5QIDescriptor_ExtIEs_val_Extension_1,
        _NotAllowedTACs__item_,
        NotAllowedTACs,
        NotificationCause,
        NotificationControl,
        _NPN_AccessInformation_pNI_NPN_Access_Information,
        ___NPN_AccessInformation_choice_Extensions_id_tab,
        __NPN_AccessInformation_choice_Extensions_id,
        ___NPN_AccessInformation_choice_Extensions_criticality_tab,
        __NPN_AccessInformation_choice_Extensions_criticality,
        ___NPN_AccessInformation_choice_Extensions_value_tab,
        __NPN_AccessInformation_choice_Extensions_value,
        _NPN_AccessInformation_choice_Extensions,
        NPN_AccessInformation,
        NPN_AccessInformation_ExtIEs,
        _NPN_MobilityInformation_sNPN_MobilityInformation,
        _NPN_MobilityInformation_pNI_NPN_MobilityInformation,
        ___NPN_MobilityInformation_choice_Extensions_id_tab,
        __NPN_MobilityInformation_choice_Extensions_id,
        ___NPN_MobilityInformation_choice_Extensions_criticality_tab,
        __NPN_MobilityInformation_choice_Extensions_criticality,
        ___NPN_MobilityInformation_choice_Extensions_value_tab,
        __NPN_MobilityInformation_choice_Extensions_value,
        _NPN_MobilityInformation_choice_Extensions,
        NPN_MobilityInformation,
        NPN_MobilityInformation_ExtIEs,
        _NPN_PagingAssistanceInformation_pNI_NPN_PagingAssistance,
        ___NPN_PagingAssistanceInformation_choice_Extensions_id_tab,
        __NPN_PagingAssistanceInformation_choice_Extensions_id,
        ___NPN_PagingAssistanceInformation_choice_Extensions_criticality_tab,
        __NPN_PagingAssistanceInformation_choice_Extensions_criticality,
        ___NPN_PagingAssistanceInformation_choice_Extensions_value_tab,
        __NPN_PagingAssistanceInformation_choice_Extensions_value,
        _NPN_PagingAssistanceInformation_choice_Extensions,
        NPN_PagingAssistanceInformation,
        NPN_PagingAssistanceInformation_ExtIEs,
        _NPN_Support_sNPN,
        ___NPN_Support_choice_Extensions_id_tab,
        __NPN_Support_choice_Extensions_id,
        ___NPN_Support_choice_Extensions_criticality_tab,
        __NPN_Support_choice_Extensions_criticality,
        ___NPN_Support_choice_Extensions_value_tab,
        __NPN_Support_choice_Extensions_value,
        _NPN_Support_choice_Extensions,
        NPN_Support,
        NPN_Support_ExtIEs,
        NRCellIdentity,
        _NR_CGI_pLMNIdentity,
        _NR_CGI_nRCellIdentity,
        ____NR_CGI_iE_Extensions__item__id_tab,
        ___NR_CGI_iE_Extensions__item__id,
        ____NR_CGI_iE_Extensions__item__criticality_tab,
        ___NR_CGI_iE_Extensions__item__criticality,
        ____NR_CGI_iE_Extensions__item__extensionValue_tab,
        ___NR_CGI_iE_Extensions__item__extensionValue,
        __NR_CGI_iE_Extensions__item_,
        _NR_CGI_iE_Extensions,
        NR_CGI,
        NR_CGI_ExtIEs,
        _NR_CGIList__item_,
        NR_CGIList,
        _NR_CGIListForWarning__item_,
        NR_CGIListForWarning,
        _NR_PagingeDRXInformation_nR_paging_eDRX_Cycle,
        _NR_PagingeDRXInformation_nR_paging_Time_Window,
        ____NR_PagingeDRXInformation_iE_Extensions__item__id_tab,
        ___NR_PagingeDRXInformation_iE_Extensions__item__id,
        ____NR_PagingeDRXInformation_iE_Extensions__item__criticality_tab,
        ___NR_PagingeDRXInformation_iE_Extensions__item__criticality,
        ____NR_PagingeDRXInformation_iE_Extensions__item__extensionValue_tab,
        ___NR_PagingeDRXInformation_iE_Extensions__item__extensionValue,
        __NR_PagingeDRXInformation_iE_Extensions__item_,
        _NR_PagingeDRXInformation_iE_Extensions,
        NR_PagingeDRXInformation,
        NR_PagingeDRXInformation_ExtIEs,
        NR_Paging_eDRX_Cycle,
        NR_Paging_Time_Window,
        NRencryptionAlgorithms,
        NRintegrityProtectionAlgorithms,
        NRMobilityHistoryReport,
        NRPPa_PDU,
        NRUERLFReportContainer,
        _NRNTNTAIInformation_servingPLMN,
        _NRNTNTAIInformation_tACListInNRNTN,
        _NRNTNTAIInformation_uELocationDerivedTACInNRNTN,
        ____NRNTNTAIInformation_iE_Extensions__item__id_tab,
        ___NRNTNTAIInformation_iE_Extensions__item__id,
        ____NRNTNTAIInformation_iE_Extensions__item__criticality_tab,
        ___NRNTNTAIInformation_iE_Extensions__item__criticality,
        ____NRNTNTAIInformation_iE_Extensions__item__extensionValue_tab,
        ___NRNTNTAIInformation_iE_Extensions__item__extensionValue,
        __NRNTNTAIInformation_iE_Extensions__item_,
        _NRNTNTAIInformation_iE_Extensions,
        NRNTNTAIInformation,
        NRNTNTAIInformation_ExtIEs,
        NumberOfBroadcasts,
        NumberOfBroadcastsRequested,
        NRARFCN,
        NRFrequencyBand,
        _NRFrequencyBand_List__item_,
        NRFrequencyBand_List,
        _NRFrequencyBandItem_nr_frequency_band,
        ____NRFrequencyBandItem_iE_Extension__item__id_tab,
        ___NRFrequencyBandItem_iE_Extension__item__id,
        ____NRFrequencyBandItem_iE_Extension__item__criticality_tab,
        ___NRFrequencyBandItem_iE_Extension__item__criticality,
        ____NRFrequencyBandItem_iE_Extension__item__extensionValue_tab,
        ___NRFrequencyBandItem_iE_Extension__item__extensionValue,
        __NRFrequencyBandItem_iE_Extension__item_,
        _NRFrequencyBandItem_iE_Extension,
        NRFrequencyBandItem,
        NRFrequencyBandItem_ExtIEs,
        _NRFrequencyInfo_nrARFCN,
        _NRFrequencyInfo_frequencyBand_List,
        ____NRFrequencyInfo_iE_Extension__item__id_tab,
        ___NRFrequencyInfo_iE_Extension__item__id,
        ____NRFrequencyInfo_iE_Extension__item__criticality_tab,
        ___NRFrequencyInfo_iE_Extension__item__criticality,
        ____NRFrequencyInfo_iE_Extension__item__extensionValue_tab,
        ___NRFrequencyInfo_iE_Extension__item__extensionValue,
        __NRFrequencyInfo_iE_Extension__item_,
        _NRFrequencyInfo_iE_Extension,
        NRFrequencyInfo,
        NRFrequencyInfo_ExtIEs,
        NR_PCI,
        _NRV2XServicesAuthorized_vehicleUE,
        _NRV2XServicesAuthorized_pedestrianUE,
        ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab,
        ___NRV2XServicesAuthorized_iE_Extensions__item__id,
        ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab,
        ___NRV2XServicesAuthorized_iE_Extensions__item__criticality,
        ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab,
        ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue,
        __NRV2XServicesAuthorized_iE_Extensions__item_,
        _NRV2XServicesAuthorized_iE_Extensions,
        NRV2XServicesAuthorized,
        NRV2XServicesAuthorized_ExtIEs,
        VehicleUE,
        PedestrianUE,
        _NRUESidelinkAggregateMaximumBitrate_uESidelinkAggregateMaximumBitRate,
        ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab,
        ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id,
        ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab,
        ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality,
        ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab,
        ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue,
        __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_,
        _NRUESidelinkAggregateMaximumBitrate_iE_Extensions,
        NRUESidelinkAggregateMaximumBitrate,
        NRUESidelinkAggregateMaximumBitrate_ExtIEs,
        NSAG_ID,
        OnboardingSupport,
        OverloadAction,
        _OverloadResponse_overloadAction,
        ___OverloadResponse_choice_Extensions_id_tab,
        __OverloadResponse_choice_Extensions_id,
        ___OverloadResponse_choice_Extensions_criticality_tab,
        __OverloadResponse_choice_Extensions_criticality,
        ___OverloadResponse_choice_Extensions_value_tab,
        __OverloadResponse_choice_Extensions_value,
        _OverloadResponse_choice_Extensions,
        OverloadResponse,
        OverloadResponse_ExtIEs,
        _OverloadStartNSSAIList__item_,
        OverloadStartNSSAIList,
        _OverloadStartNSSAIItem_sliceOverloadList,
        _OverloadStartNSSAIItem_sliceOverloadResponse,
        _OverloadStartNSSAIItem_sliceTrafficLoadReductionIndication,
        ____OverloadStartNSSAIItem_iE_Extensions__item__id_tab,
        ___OverloadStartNSSAIItem_iE_Extensions__item__id,
        ____OverloadStartNSSAIItem_iE_Extensions__item__criticality_tab,
        ___OverloadStartNSSAIItem_iE_Extensions__item__criticality,
        ____OverloadStartNSSAIItem_iE_Extensions__item__extensionValue_tab,
        ___OverloadStartNSSAIItem_iE_Extensions__item__extensionValue,
        __OverloadStartNSSAIItem_iE_Extensions__item_,
        _OverloadStartNSSAIItem_iE_Extensions,
        OverloadStartNSSAIItem,
        OverloadStartNSSAIItem_ExtIEs,
        PacketDelayBudget,
        _PacketErrorRate_pERScalar,
        _PacketErrorRate_pERExponent,
        ____PacketErrorRate_iE_Extensions__item__id_tab,
        ___PacketErrorRate_iE_Extensions__item__id,
        ____PacketErrorRate_iE_Extensions__item__criticality_tab,
        ___PacketErrorRate_iE_Extensions__item__criticality,
        ____PacketErrorRate_iE_Extensions__item__extensionValue_tab,
        ___PacketErrorRate_iE_Extensions__item__extensionValue,
        __PacketErrorRate_iE_Extensions__item_,
        _PacketErrorRate_iE_Extensions,
        PacketErrorRate,
        PacketErrorRate_ExtIEs,
        PacketLossRate,
        _PagingAssisDataforCEcapabUE_eUTRA_CGI,
        _PagingAssisDataforCEcapabUE_coverageEnhancementLevel,
        ____PagingAssisDataforCEcapabUE_iE_Extensions__item__id_tab,
        ___PagingAssisDataforCEcapabUE_iE_Extensions__item__id,
        ____PagingAssisDataforCEcapabUE_iE_Extensions__item__criticality_tab,
        ___PagingAssisDataforCEcapabUE_iE_Extensions__item__criticality,
        ____PagingAssisDataforCEcapabUE_iE_Extensions__item__extensionValue_tab,
        ___PagingAssisDataforCEcapabUE_iE_Extensions__item__extensionValue,
        __PagingAssisDataforCEcapabUE_iE_Extensions__item_,
        _PagingAssisDataforCEcapabUE_iE_Extensions,
        PagingAssisDataforCEcapabUE,
        PagingAssisDataforCEcapabUE_ExtIEs,
        _PagingAttemptInformation_pagingAttemptCount,
        _PagingAttemptInformation_intendedNumberOfPagingAttempts,
        _PagingAttemptInformation_nextPagingAreaScope,
        ____PagingAttemptInformation_iE_Extensions__item__id_tab,
        ___PagingAttemptInformation_iE_Extensions__item__id,
        ____PagingAttemptInformation_iE_Extensions__item__criticality_tab,
        ___PagingAttemptInformation_iE_Extensions__item__criticality,
        ____PagingAttemptInformation_iE_Extensions__item__extensionValue_tab,
        ___PagingAttemptInformation_iE_Extensions__item__extensionValue,
        __PagingAttemptInformation_iE_Extensions__item_,
        _PagingAttemptInformation_iE_Extensions,
        PagingAttemptInformation,
        PagingAttemptInformation_ExtIEs,
        PagingAttemptCount,
        PagingCause,
        PagingCauseIndicationForVoiceService,
        PagingDRX,
        PagingOrigin,
        PagingPriority,
        PagingProbabilityInformation,
        _PathSwitchRequestAcknowledgeTransfer_uL_NGU_UP_TNLInformation,
        _PathSwitchRequestAcknowledgeTransfer_securityIndication,
        ____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab,
        _____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_0,
        _____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_1,
        _____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_2,
        _____PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id_tab_val_Extension_3,
        ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__id,
        ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__criticality,
        ___PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item__extensionValue,
        __PathSwitchRequestAcknowledgeTransfer_iE_Extensions__item_,
        _PathSwitchRequestAcknowledgeTransfer_iE_Extensions,
        PathSwitchRequestAcknowledgeTransfer,
        PathSwitchRequestAcknowledgeTransfer_ExtIEs,
        _PathSwitchRequestAcknowledgeTransfer_ExtIEs_val_Extension_0,
        _PathSwitchRequestAcknowledgeTransfer_ExtIEs_val_Extension_1,
        _PathSwitchRequestAcknowledgeTransfer_ExtIEs_val_Extension_2,
        _PathSwitchRequestAcknowledgeTransfer_ExtIEs_val_Extension_3,
        _PathSwitchRequestSetupFailedTransfer_cause,
        ____PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__id_tab,
        ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__id,
        ____PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__criticality_tab,
        ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__criticality,
        ____PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__extensionValue_tab,
        ___PathSwitchRequestSetupFailedTransfer_iE_Extensions__item__extensionValue,
        __PathSwitchRequestSetupFailedTransfer_iE_Extensions__item_,
        _PathSwitchRequestSetupFailedTransfer_iE_Extensions,
        PathSwitchRequestSetupFailedTransfer,
        PathSwitchRequestSetupFailedTransfer_ExtIEs,
        _PathSwitchRequestTransfer_dL_NGU_UP_TNLInformation,
        _PathSwitchRequestTransfer_dL_NGU_TNLInformationReused,
        _PathSwitchRequestTransfer_userPlaneSecurityInformation,
        _PathSwitchRequestTransfer_qosFlowAcceptedList,
        ____PathSwitchRequestTransfer_iE_Extensions__item__id_tab,
        _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_0,
        _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_1,
        _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_2,
        _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_3,
        _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_4,
        _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_5,
        _____PathSwitchRequestTransfer_iE_Extensions__item__id_tab_val_Extension_6,
        ___PathSwitchRequestTransfer_iE_Extensions__item__id,
        ___PathSwitchRequestTransfer_iE_Extensions__item__criticality,
        ___PathSwitchRequestTransfer_iE_Extensions__item__extensionValue,
        __PathSwitchRequestTransfer_iE_Extensions__item_,
        _PathSwitchRequestTransfer_iE_Extensions,
        PathSwitchRequestTransfer,
        PathSwitchRequestTransfer_ExtIEs,
        _PathSwitchRequestTransfer_ExtIEs_val_Extension_0,
        _PathSwitchRequestTransfer_ExtIEs_val_Extension_1,
        _PathSwitchRequestTransfer_ExtIEs_val_Extension_2,
        _PathSwitchRequestTransfer_ExtIEs_val_Extension_3,
        _PathSwitchRequestTransfer_ExtIEs_val_Extension_4,
        _PathSwitchRequestTransfer_ExtIEs_val_Extension_5,
        _PathSwitchRequestTransfer_ExtIEs_val_Extension_6,
        _PathSwitchRequestUnsuccessfulTransfer_cause,
        ____PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__id_tab,
        ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__id,
        ____PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__criticality_tab,
        ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__criticality,
        ____PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab,
        ___PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item__extensionValue,
        __PathSwitchRequestUnsuccessfulTransfer_iE_Extensions__item_,
        _PathSwitchRequestUnsuccessfulTransfer_iE_Extensions,
        PathSwitchRequestUnsuccessfulTransfer,
        PathSwitchRequestUnsuccessfulTransfer_ExtIEs,
        _PC5QoSParameters_pc5QoSFlowList,
        _PC5QoSParameters_pc5LinkAggregateBitRates,
        ____PC5QoSParameters_iE_Extensions__item__id_tab,
        ___PC5QoSParameters_iE_Extensions__item__id,
        ____PC5QoSParameters_iE_Extensions__item__criticality_tab,
        ___PC5QoSParameters_iE_Extensions__item__criticality,
        ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab,
        ___PC5QoSParameters_iE_Extensions__item__extensionValue,
        __PC5QoSParameters_iE_Extensions__item_,
        _PC5QoSParameters_iE_Extensions,
        PC5QoSParameters,
        PC5QoSParameters_ExtIEs,
        _PC5QoSFlowList__item_,
        PC5QoSFlowList,
        _PC5QoSFlowItem_pQI,
        _PC5QoSFlowItem_pc5FlowBitRates,
        _PC5QoSFlowItem_range,
        ____PC5QoSFlowItem_iE_Extensions__item__id_tab,
        ___PC5QoSFlowItem_iE_Extensions__item__id,
        ____PC5QoSFlowItem_iE_Extensions__item__criticality_tab,
        ___PC5QoSFlowItem_iE_Extensions__item__criticality,
        ____PC5QoSFlowItem_iE_Extensions__item__extensionValue_tab,
        ___PC5QoSFlowItem_iE_Extensions__item__extensionValue,
        __PC5QoSFlowItem_iE_Extensions__item_,
        _PC5QoSFlowItem_iE_Extensions,
        PC5QoSFlowItem,
        PC5QoSFlowItem_ExtIEs,
        _PC5FlowBitRates_guaranteedFlowBitRate,
        _PC5FlowBitRates_maximumFlowBitRate,
        ____PC5FlowBitRates_iE_Extensions__item__id_tab,
        ___PC5FlowBitRates_iE_Extensions__item__id,
        ____PC5FlowBitRates_iE_Extensions__item__criticality_tab,
        ___PC5FlowBitRates_iE_Extensions__item__criticality,
        ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab,
        ___PC5FlowBitRates_iE_Extensions__item__extensionValue,
        __PC5FlowBitRates_iE_Extensions__item_,
        _PC5FlowBitRates_iE_Extensions,
        PC5FlowBitRates,
        PC5FlowBitRates_ExtIEs,
        _PCIListForMDT__item_,
        PCIListForMDT,
        PrivacyIndicator,
        _PDUSessionAggregateMaximumBitRate_pDUSessionAggregateMaximumBitRateDL,
        _PDUSessionAggregateMaximumBitRate_pDUSessionAggregateMaximumBitRateUL,
        ____PDUSessionAggregateMaximumBitRate_iE_Extensions__item__id_tab,
        ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__id,
        ____PDUSessionAggregateMaximumBitRate_iE_Extensions__item__criticality_tab,
        ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__criticality,
        ____PDUSessionAggregateMaximumBitRate_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionAggregateMaximumBitRate_iE_Extensions__item__extensionValue,
        __PDUSessionAggregateMaximumBitRate_iE_Extensions__item_,
        _PDUSessionAggregateMaximumBitRate_iE_Extensions,
        PDUSessionAggregateMaximumBitRate,
        PDUSessionAggregateMaximumBitRate_ExtIEs,
        PDUSessionID,
        PDUSessionPairID,
        _PDUSessionResourceAdmittedList__item_,
        PDUSessionResourceAdmittedList,
        _PDUSessionResourceAdmittedItem_pDUSessionID,
        __PDUSessionResourceAdmittedItem_handoverRequestAcknowledgeTransfer_contain,
        _PDUSessionResourceAdmittedItem_handoverRequestAcknowledgeTransfer,
        ____PDUSessionResourceAdmittedItem_iE_Extensions__item__id_tab,
        ___PDUSessionResourceAdmittedItem_iE_Extensions__item__id,
        ____PDUSessionResourceAdmittedItem_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceAdmittedItem_iE_Extensions__item__criticality,
        ____PDUSessionResourceAdmittedItem_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceAdmittedItem_iE_Extensions__item__extensionValue,
        __PDUSessionResourceAdmittedItem_iE_Extensions__item_,
        _PDUSessionResourceAdmittedItem_iE_Extensions,
        PDUSessionResourceAdmittedItem,
        PDUSessionResourceAdmittedItem_ExtIEs,
        _PDUSessionResourceFailedToModifyListModCfm__item_,
        PDUSessionResourceFailedToModifyListModCfm,
        _PDUSessionResourceFailedToModifyItemModCfm_pDUSessionID,
        __PDUSessionResourceFailedToModifyItemModCfm_pDUSessionResourceModifyIndicationUnsuccessfulTransfer_contain,
        _PDUSessionResourceFailedToModifyItemModCfm_pDUSessionResourceModifyIndicationUnsuccessfulTransfer,
        ____PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__id_tab,
        ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__id,
        ____PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__criticality,
        ____PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item__extensionValue,
        __PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions__item_,
        _PDUSessionResourceFailedToModifyItemModCfm_iE_Extensions,
        PDUSessionResourceFailedToModifyItemModCfm,
        PDUSessionResourceFailedToModifyItemModCfm_ExtIEs,
        _PDUSessionResourceFailedToModifyListModRes__item_,
        PDUSessionResourceFailedToModifyListModRes,
        _PDUSessionResourceFailedToModifyItemModRes_pDUSessionID,
        __PDUSessionResourceFailedToModifyItemModRes_pDUSessionResourceModifyUnsuccessfulTransfer_contain,
        _PDUSessionResourceFailedToModifyItemModRes_pDUSessionResourceModifyUnsuccessfulTransfer,
        ____PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__id_tab,
        ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__id,
        ____PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__criticality,
        ____PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item__extensionValue,
        __PDUSessionResourceFailedToModifyItemModRes_iE_Extensions__item_,
        _PDUSessionResourceFailedToModifyItemModRes_iE_Extensions,
        PDUSessionResourceFailedToModifyItemModRes,
        PDUSessionResourceFailedToModifyItemModRes_ExtIEs,
        _PDUSessionResourceFailedToResumeListRESReq__item_,
        PDUSessionResourceFailedToResumeListRESReq,
        _PDUSessionResourceFailedToResumeItemRESReq_pDUSessionID,
        _PDUSessionResourceFailedToResumeItemRESReq_cause,
        ____PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__id_tab,
        ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__id,
        ____PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__criticality,
        ____PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item__extensionValue,
        __PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions__item_,
        _PDUSessionResourceFailedToResumeItemRESReq_iE_Extensions,
        PDUSessionResourceFailedToResumeItemRESReq,
        PDUSessionResourceFailedToResumeItemRESReq_ExtIEs,
        _PDUSessionResourceFailedToResumeListRESRes__item_,
        PDUSessionResourceFailedToResumeListRESRes,
        _PDUSessionResourceFailedToResumeItemRESRes_pDUSessionID,
        _PDUSessionResourceFailedToResumeItemRESRes_cause,
        ____PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__id_tab,
        ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__id,
        ____PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__criticality,
        ____PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item__extensionValue,
        __PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions__item_,
        _PDUSessionResourceFailedToResumeItemRESRes_iE_Extensions,
        PDUSessionResourceFailedToResumeItemRESRes,
        PDUSessionResourceFailedToResumeItemRESRes_ExtIEs,
        _PDUSessionResourceFailedToSetupListCxtFail__item_,
        PDUSessionResourceFailedToSetupListCxtFail,
        _PDUSessionResourceFailedToSetupItemCxtFail_pDUSessionID,
        __PDUSessionResourceFailedToSetupItemCxtFail_pDUSessionResourceSetupUnsuccessfulTransfer_contain,
        _PDUSessionResourceFailedToSetupItemCxtFail_pDUSessionResourceSetupUnsuccessfulTransfer,
        ____PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__id_tab,
        ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__id,
        ____PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__criticality,
        ____PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item__extensionValue,
        __PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions__item_,
        _PDUSessionResourceFailedToSetupItemCxtFail_iE_Extensions,
        PDUSessionResourceFailedToSetupItemCxtFail,
        PDUSessionResourceFailedToSetupItemCxtFail_ExtIEs,
        _PDUSessionResourceFailedToSetupListCxtRes__item_,
        PDUSessionResourceFailedToSetupListCxtRes,
        _PDUSessionResourceFailedToSetupItemCxtRes_pDUSessionID,
        __PDUSessionResourceFailedToSetupItemCxtRes_pDUSessionResourceSetupUnsuccessfulTransfer_contain,
        _PDUSessionResourceFailedToSetupItemCxtRes_pDUSessionResourceSetupUnsuccessfulTransfer,
        ____PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__id_tab,
        ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__id,
        ____PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__criticality,
        ____PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item__extensionValue,
        __PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions__item_,
        _PDUSessionResourceFailedToSetupItemCxtRes_iE_Extensions,
        PDUSessionResourceFailedToSetupItemCxtRes,
        PDUSessionResourceFailedToSetupItemCxtRes_ExtIEs,
        _PDUSessionResourceFailedToSetupListHOAck__item_,
        PDUSessionResourceFailedToSetupListHOAck,
        _PDUSessionResourceFailedToSetupItemHOAck_pDUSessionID,
        __PDUSessionResourceFailedToSetupItemHOAck_handoverResourceAllocationUnsuccessfulTransfer_contain,
        _PDUSessionResourceFailedToSetupItemHOAck_handoverResourceAllocationUnsuccessfulTransfer,
        ____PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__id_tab,
        ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__id,
        ____PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__criticality,
        ____PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item__extensionValue,
        __PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions__item_,
        _PDUSessionResourceFailedToSetupItemHOAck_iE_Extensions,
        PDUSessionResourceFailedToSetupItemHOAck,
        PDUSessionResourceFailedToSetupItemHOAck_ExtIEs,
        _PDUSessionResourceFailedToSetupListPSReq__item_,
        PDUSessionResourceFailedToSetupListPSReq,
        _PDUSessionResourceFailedToSetupItemPSReq_pDUSessionID,
        __PDUSessionResourceFailedToSetupItemPSReq_pathSwitchRequestSetupFailedTransfer_contain,
        _PDUSessionResourceFailedToSetupItemPSReq_pathSwitchRequestSetupFailedTransfer,
        ____PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__id_tab,
        ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__id,
        ____PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__criticality,
        ____PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item__extensionValue,
        __PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions__item_,
        _PDUSessionResourceFailedToSetupItemPSReq_iE_Extensions,
        PDUSessionResourceFailedToSetupItemPSReq,
        PDUSessionResourceFailedToSetupItemPSReq_ExtIEs,
        _PDUSessionResourceFailedToSetupListSURes__item_,
        PDUSessionResourceFailedToSetupListSURes,
        _PDUSessionResourceFailedToSetupItemSURes_pDUSessionID,
        __PDUSessionResourceFailedToSetupItemSURes_pDUSessionResourceSetupUnsuccessfulTransfer_contain,
        _PDUSessionResourceFailedToSetupItemSURes_pDUSessionResourceSetupUnsuccessfulTransfer,
        ____PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__id_tab,
        ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__id,
        ____PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__criticality,
        ____PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item__extensionValue,
        __PDUSessionResourceFailedToSetupItemSURes_iE_Extensions__item_,
        _PDUSessionResourceFailedToSetupItemSURes_iE_Extensions,
        PDUSessionResourceFailedToSetupItemSURes,
        PDUSessionResourceFailedToSetupItemSURes_ExtIEs,
        _PDUSessionResourceHandoverList__item_,
        PDUSessionResourceHandoverList,
        _PDUSessionResourceHandoverItem_pDUSessionID,
        __PDUSessionResourceHandoverItem_handoverCommandTransfer_contain,
        _PDUSessionResourceHandoverItem_handoverCommandTransfer,
        ____PDUSessionResourceHandoverItem_iE_Extensions__item__id_tab,
        ___PDUSessionResourceHandoverItem_iE_Extensions__item__id,
        ____PDUSessionResourceHandoverItem_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceHandoverItem_iE_Extensions__item__criticality,
        ____PDUSessionResourceHandoverItem_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceHandoverItem_iE_Extensions__item__extensionValue,
        __PDUSessionResourceHandoverItem_iE_Extensions__item_,
        _PDUSessionResourceHandoverItem_iE_Extensions,
        PDUSessionResourceHandoverItem,
        PDUSessionResourceHandoverItem_ExtIEs,
        _PDUSessionResourceInformationList__item_,
        PDUSessionResourceInformationList,
        _PDUSessionResourceInformationItem_pDUSessionID,
        _PDUSessionResourceInformationItem_qosFlowInformationList,
        _PDUSessionResourceInformationItem_dRBsToQosFlowsMappingList,
        ____PDUSessionResourceInformationItem_iE_Extensions__item__id_tab,
        ___PDUSessionResourceInformationItem_iE_Extensions__item__id,
        ____PDUSessionResourceInformationItem_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceInformationItem_iE_Extensions__item__criticality,
        ____PDUSessionResourceInformationItem_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceInformationItem_iE_Extensions__item__extensionValue,
        __PDUSessionResourceInformationItem_iE_Extensions__item_,
        _PDUSessionResourceInformationItem_iE_Extensions,
        PDUSessionResourceInformationItem,
        PDUSessionResourceInformationItem_ExtIEs,
        _PDUSessionResourceListCxtRelCpl__item_,
        PDUSessionResourceListCxtRelCpl,
        _PDUSessionResourceItemCxtRelCpl_pDUSessionID,
        ____PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id_tab,
        ______PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id_tab_val_Extension_0_contain,
        _____PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id_tab_val_Extension_0,
        ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__id,
        ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__criticality,
        ___PDUSessionResourceItemCxtRelCpl_iE_Extensions__item__extensionValue,
        __PDUSessionResourceItemCxtRelCpl_iE_Extensions__item_,
        _PDUSessionResourceItemCxtRelCpl_iE_Extensions,
        PDUSessionResourceItemCxtRelCpl,
        PDUSessionResourceItemCxtRelCpl_ExtIEs,
        __PDUSessionResourceItemCxtRelCpl_ExtIEs_val_Extension_0_contain,
        _PDUSessionResourceItemCxtRelCpl_ExtIEs_val_Extension_0,
        _PDUSessionResourceListCxtRelReq__item_,
        PDUSessionResourceListCxtRelReq,
        _PDUSessionResourceItemCxtRelReq_pDUSessionID,
        ____PDUSessionResourceItemCxtRelReq_iE_Extensions__item__id_tab,
        ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__id,
        ____PDUSessionResourceItemCxtRelReq_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__criticality,
        ____PDUSessionResourceItemCxtRelReq_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceItemCxtRelReq_iE_Extensions__item__extensionValue,
        __PDUSessionResourceItemCxtRelReq_iE_Extensions__item_,
        _PDUSessionResourceItemCxtRelReq_iE_Extensions,
        PDUSessionResourceItemCxtRelReq,
        PDUSessionResourceItemCxtRelReq_ExtIEs,
        _PDUSessionResourceListHORqd__item_,
        PDUSessionResourceListHORqd,
        _PDUSessionResourceItemHORqd_pDUSessionID,
        __PDUSessionResourceItemHORqd_handoverRequiredTransfer_contain,
        _PDUSessionResourceItemHORqd_handoverRequiredTransfer,
        ____PDUSessionResourceItemHORqd_iE_Extensions__item__id_tab,
        ___PDUSessionResourceItemHORqd_iE_Extensions__item__id,
        ____PDUSessionResourceItemHORqd_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceItemHORqd_iE_Extensions__item__criticality,
        ____PDUSessionResourceItemHORqd_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceItemHORqd_iE_Extensions__item__extensionValue,
        __PDUSessionResourceItemHORqd_iE_Extensions__item_,
        _PDUSessionResourceItemHORqd_iE_Extensions,
        PDUSessionResourceItemHORqd,
        PDUSessionResourceItemHORqd_ExtIEs,
        _PDUSessionResourceModifyConfirmTransfer_qosFlowModifyConfirmList,
        _PDUSessionResourceModifyConfirmTransfer_uLNGU_UP_TNLInformation,
        _PDUSessionResourceModifyConfirmTransfer_additionalNG_UUPTNLInformation,
        _PDUSessionResourceModifyConfirmTransfer_qosFlowFailedToModifyList,
        ____PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id_tab,
        _____PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id_tab_val_Extension_0,
        _____PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id_tab_val_Extension_1,
        ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__id,
        ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__criticality,
        ___PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item__extensionValue,
        __PDUSessionResourceModifyConfirmTransfer_iE_Extensions__item_,
        _PDUSessionResourceModifyConfirmTransfer_iE_Extensions,
        PDUSessionResourceModifyConfirmTransfer,
        PDUSessionResourceModifyConfirmTransfer_ExtIEs,
        _PDUSessionResourceModifyConfirmTransfer_ExtIEs_val_Extension_0,
        _PDUSessionResourceModifyConfirmTransfer_ExtIEs_val_Extension_1,
        _PDUSessionResourceModifyIndicationUnsuccessfulTransfer_cause,
        ____PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__id_tab,
        ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__id,
        ____PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__criticality,
        ____PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item__extensionValue,
        __PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions__item_,
        _PDUSessionResourceModifyIndicationUnsuccessfulTransfer_iE_Extensions,
        PDUSessionResourceModifyIndicationUnsuccessfulTransfer,
        PDUSessionResourceModifyIndicationUnsuccessfulTransfer_ExtIEs,
        ____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab,
        _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_2,
        _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_3,
        _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_4,
        _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_5,
        _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_6,
        _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_7,
        _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_8,
        _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_9,
        _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_10,
        _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_11,
        _____PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id_tab_val_Value_12,
        ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__id,
        ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__criticality,
        ___PDUSessionResourceModifyRequestTransfer_protocolIEs__item__value,
        __PDUSessionResourceModifyRequestTransfer_protocolIEs__item_,
        _PDUSessionResourceModifyRequestTransfer_protocolIEs,
        PDUSessionResourceModifyRequestTransfer,
        PDUSessionResourceModifyRequestTransferIEs,
        _PDUSessionResourceModifyRequestTransferIEs_val_Value_0,
        _PDUSessionResourceModifyRequestTransferIEs_val_Value_1,
        _PDUSessionResourceModifyRequestTransferIEs_val_Value_2,
        _PDUSessionResourceModifyRequestTransferIEs_val_Value_3,
        _PDUSessionResourceModifyRequestTransferIEs_val_Value_4,
        _PDUSessionResourceModifyRequestTransferIEs_val_Value_5,
        _PDUSessionResourceModifyRequestTransferIEs_val_Value_6,
        _PDUSessionResourceModifyRequestTransferIEs_val_Value_7,
        _PDUSessionResourceModifyRequestTransferIEs_val_Value_8,
        _PDUSessionResourceModifyRequestTransferIEs_val_Value_9,
        _PDUSessionResourceModifyRequestTransferIEs_val_Value_10,
        _PDUSessionResourceModifyRequestTransferIEs_val_Value_11,
        _PDUSessionResourceModifyRequestTransferIEs_val_Value_12,
        _PDUSessionResourceModifyResponseTransfer_dL_NGU_UP_TNLInformation,
        _PDUSessionResourceModifyResponseTransfer_uL_NGU_UP_TNLInformation,
        _PDUSessionResourceModifyResponseTransfer_qosFlowAddOrModifyResponseList,
        _PDUSessionResourceModifyResponseTransfer_additionalDLQosFlowPerTNLInformation,
        _PDUSessionResourceModifyResponseTransfer_qosFlowFailedToAddOrModifyList,
        ____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab,
        _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_0,
        _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_1,
        _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_2,
        _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_3,
        _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_4,
        _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_5,
        _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_6,
        _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_7,
        _____PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id_tab_val_Extension_8,
        ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__id,
        ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__criticality,
        ___PDUSessionResourceModifyResponseTransfer_iE_Extensions__item__extensionValue,
        __PDUSessionResourceModifyResponseTransfer_iE_Extensions__item_,
        _PDUSessionResourceModifyResponseTransfer_iE_Extensions,
        PDUSessionResourceModifyResponseTransfer,
        PDUSessionResourceModifyResponseTransfer_ExtIEs,
        _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_0,
        _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_1,
        _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_2,
        _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_3,
        _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_4,
        _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_5,
        _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_6,
        _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_7,
        _PDUSessionResourceModifyResponseTransfer_ExtIEs_val_Extension_8,
        _PDUSessionResourceModifyIndicationTransfer_dLQosFlowPerTNLInformation,
        _PDUSessionResourceModifyIndicationTransfer_additionalDLQosFlowPerTNLInformation,
        ____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab,
        _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_0,
        _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_1,
        _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_2,
        _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_3,
        _____PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id_tab_val_Extension_4,
        ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__id,
        ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__criticality,
        ___PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item__extensionValue,
        __PDUSessionResourceModifyIndicationTransfer_iE_Extensions__item_,
        _PDUSessionResourceModifyIndicationTransfer_iE_Extensions,
        PDUSessionResourceModifyIndicationTransfer,
        PDUSessionResourceModifyIndicationTransfer_ExtIEs,
        _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_0,
        _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_1,
        _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_2,
        _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_3,
        _PDUSessionResourceModifyIndicationTransfer_ExtIEs_val_Extension_4,
        _PDUSessionResourceModifyListModCfm__item_,
        PDUSessionResourceModifyListModCfm,
        _PDUSessionResourceModifyItemModCfm_pDUSessionID,
        __PDUSessionResourceModifyItemModCfm_pDUSessionResourceModifyConfirmTransfer_contain,
        _PDUSessionResourceModifyItemModCfm_pDUSessionResourceModifyConfirmTransfer,
        ____PDUSessionResourceModifyItemModCfm_iE_Extensions__item__id_tab,
        ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__id,
        ____PDUSessionResourceModifyItemModCfm_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__criticality,
        ____PDUSessionResourceModifyItemModCfm_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceModifyItemModCfm_iE_Extensions__item__extensionValue,
        __PDUSessionResourceModifyItemModCfm_iE_Extensions__item_,
        _PDUSessionResourceModifyItemModCfm_iE_Extensions,
        PDUSessionResourceModifyItemModCfm,
        PDUSessionResourceModifyItemModCfm_ExtIEs,
        _PDUSessionResourceModifyListModInd__item_,
        PDUSessionResourceModifyListModInd,
        _PDUSessionResourceModifyItemModInd_pDUSessionID,
        __PDUSessionResourceModifyItemModInd_pDUSessionResourceModifyIndicationTransfer_contain,
        _PDUSessionResourceModifyItemModInd_pDUSessionResourceModifyIndicationTransfer,
        ____PDUSessionResourceModifyItemModInd_iE_Extensions__item__id_tab,
        ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__id,
        ____PDUSessionResourceModifyItemModInd_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__criticality,
        ____PDUSessionResourceModifyItemModInd_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceModifyItemModInd_iE_Extensions__item__extensionValue,
        __PDUSessionResourceModifyItemModInd_iE_Extensions__item_,
        _PDUSessionResourceModifyItemModInd_iE_Extensions,
        PDUSessionResourceModifyItemModInd,
        PDUSessionResourceModifyItemModInd_ExtIEs,
        _PDUSessionResourceModifyListModReq__item_,
        PDUSessionResourceModifyListModReq,
        _PDUSessionResourceModifyItemModReq_pDUSessionID,
        _PDUSessionResourceModifyItemModReq_nAS_PDU,
        __PDUSessionResourceModifyItemModReq_pDUSessionResourceModifyRequestTransfer_contain,
        _PDUSessionResourceModifyItemModReq_pDUSessionResourceModifyRequestTransfer,
        ____PDUSessionResourceModifyItemModReq_iE_Extensions__item__id_tab,
        _____PDUSessionResourceModifyItemModReq_iE_Extensions__item__id_tab_val_Extension_0,
        _____PDUSessionResourceModifyItemModReq_iE_Extensions__item__id_tab_val_Extension_1,
        ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__id,
        ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__criticality,
        ___PDUSessionResourceModifyItemModReq_iE_Extensions__item__extensionValue,
        __PDUSessionResourceModifyItemModReq_iE_Extensions__item_,
        _PDUSessionResourceModifyItemModReq_iE_Extensions,
        PDUSessionResourceModifyItemModReq,
        PDUSessionResourceModifyItemModReq_ExtIEs,
        _PDUSessionResourceModifyItemModReq_ExtIEs_val_Extension_0,
        _PDUSessionResourceModifyItemModReq_ExtIEs_val_Extension_1,
        _PDUSessionResourceModifyListModRes__item_,
        PDUSessionResourceModifyListModRes,
        _PDUSessionResourceModifyItemModRes_pDUSessionID,
        __PDUSessionResourceModifyItemModRes_pDUSessionResourceModifyResponseTransfer_contain,
        _PDUSessionResourceModifyItemModRes_pDUSessionResourceModifyResponseTransfer,
        ____PDUSessionResourceModifyItemModRes_iE_Extensions__item__id_tab,
        ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__id,
        ____PDUSessionResourceModifyItemModRes_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__criticality,
        ____PDUSessionResourceModifyItemModRes_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceModifyItemModRes_iE_Extensions__item__extensionValue,
        __PDUSessionResourceModifyItemModRes_iE_Extensions__item_,
        _PDUSessionResourceModifyItemModRes_iE_Extensions,
        PDUSessionResourceModifyItemModRes,
        PDUSessionResourceModifyItemModRes_ExtIEs,
        _PDUSessionResourceModifyUnsuccessfulTransfer_cause,
        _PDUSessionResourceModifyUnsuccessfulTransfer_criticalityDiagnostics,
        ____PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__id_tab,
        ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__id,
        ____PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__criticality,
        ____PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item__extensionValue,
        __PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions__item_,
        _PDUSessionResourceModifyUnsuccessfulTransfer_iE_Extensions,
        PDUSessionResourceModifyUnsuccessfulTransfer,
        PDUSessionResourceModifyUnsuccessfulTransfer_ExtIEs,
        _PDUSessionResourceNotifyList__item_,
        PDUSessionResourceNotifyList,
        _PDUSessionResourceNotifyItem_pDUSessionID,
        __PDUSessionResourceNotifyItem_pDUSessionResourceNotifyTransfer_contain,
        _PDUSessionResourceNotifyItem_pDUSessionResourceNotifyTransfer,
        ____PDUSessionResourceNotifyItem_iE_Extensions__item__id_tab,
        ___PDUSessionResourceNotifyItem_iE_Extensions__item__id,
        ____PDUSessionResourceNotifyItem_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceNotifyItem_iE_Extensions__item__criticality,
        ____PDUSessionResourceNotifyItem_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceNotifyItem_iE_Extensions__item__extensionValue,
        __PDUSessionResourceNotifyItem_iE_Extensions__item_,
        _PDUSessionResourceNotifyItem_iE_Extensions,
        PDUSessionResourceNotifyItem,
        PDUSessionResourceNotifyItem_ExtIEs,
        _PDUSessionResourceNotifyReleasedTransfer_cause,
        ____PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id_tab,
        _____PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id_tab_val_Extension_0,
        ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__id,
        ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__criticality,
        ___PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item__extensionValue,
        __PDUSessionResourceNotifyReleasedTransfer_iE_Extensions__item_,
        _PDUSessionResourceNotifyReleasedTransfer_iE_Extensions,
        PDUSessionResourceNotifyReleasedTransfer,
        PDUSessionResourceNotifyReleasedTransfer_ExtIEs,
        _PDUSessionResourceNotifyReleasedTransfer_ExtIEs_val_Extension_0,
        _PDUSessionResourceNotifyTransfer_qosFlowNotifyList,
        _PDUSessionResourceNotifyTransfer_qosFlowReleasedList,
        ____PDUSessionResourceNotifyTransfer_iE_Extensions__item__id_tab,
        _____PDUSessionResourceNotifyTransfer_iE_Extensions__item__id_tab_val_Extension_0,
        _____PDUSessionResourceNotifyTransfer_iE_Extensions__item__id_tab_val_Extension_1,
        ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__id,
        ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__criticality,
        ___PDUSessionResourceNotifyTransfer_iE_Extensions__item__extensionValue,
        __PDUSessionResourceNotifyTransfer_iE_Extensions__item_,
        _PDUSessionResourceNotifyTransfer_iE_Extensions,
        PDUSessionResourceNotifyTransfer,
        PDUSessionResourceNotifyTransfer_ExtIEs,
        _PDUSessionResourceNotifyTransfer_ExtIEs_val_Extension_0,
        _PDUSessionResourceNotifyTransfer_ExtIEs_val_Extension_1,
        _PDUSessionResourceReleaseCommandTransfer_cause,
        ____PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__id_tab,
        ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__id,
        ____PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__criticality,
        ____PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item__extensionValue,
        __PDUSessionResourceReleaseCommandTransfer_iE_Extensions__item_,
        _PDUSessionResourceReleaseCommandTransfer_iE_Extensions,
        PDUSessionResourceReleaseCommandTransfer,
        PDUSessionResourceReleaseCommandTransfer_ExtIEs,
        _PDUSessionResourceReleasedListNot__item_,
        PDUSessionResourceReleasedListNot,
        _PDUSessionResourceReleasedItemNot_pDUSessionID,
        __PDUSessionResourceReleasedItemNot_pDUSessionResourceNotifyReleasedTransfer_contain,
        _PDUSessionResourceReleasedItemNot_pDUSessionResourceNotifyReleasedTransfer,
        ____PDUSessionResourceReleasedItemNot_iE_Extensions__item__id_tab,
        ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__id,
        ____PDUSessionResourceReleasedItemNot_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__criticality,
        ____PDUSessionResourceReleasedItemNot_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceReleasedItemNot_iE_Extensions__item__extensionValue,
        __PDUSessionResourceReleasedItemNot_iE_Extensions__item_,
        _PDUSessionResourceReleasedItemNot_iE_Extensions,
        PDUSessionResourceReleasedItemNot,
        PDUSessionResourceReleasedItemNot_ExtIEs,
        _PDUSessionResourceReleasedListPSAck__item_,
        PDUSessionResourceReleasedListPSAck,
        _PDUSessionResourceReleasedItemPSAck_pDUSessionID,
        __PDUSessionResourceReleasedItemPSAck_pathSwitchRequestUnsuccessfulTransfer_contain,
        _PDUSessionResourceReleasedItemPSAck_pathSwitchRequestUnsuccessfulTransfer,
        ____PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__id_tab,
        ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__id,
        ____PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__criticality,
        ____PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceReleasedItemPSAck_iE_Extensions__item__extensionValue,
        __PDUSessionResourceReleasedItemPSAck_iE_Extensions__item_,
        _PDUSessionResourceReleasedItemPSAck_iE_Extensions,
        PDUSessionResourceReleasedItemPSAck,
        PDUSessionResourceReleasedItemPSAck_ExtIEs,
        _PDUSessionResourceReleasedListPSFail__item_,
        PDUSessionResourceReleasedListPSFail,
        _PDUSessionResourceReleasedItemPSFail_pDUSessionID,
        __PDUSessionResourceReleasedItemPSFail_pathSwitchRequestUnsuccessfulTransfer_contain,
        _PDUSessionResourceReleasedItemPSFail_pathSwitchRequestUnsuccessfulTransfer,
        ____PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__id_tab,
        ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__id,
        ____PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__criticality,
        ____PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceReleasedItemPSFail_iE_Extensions__item__extensionValue,
        __PDUSessionResourceReleasedItemPSFail_iE_Extensions__item_,
        _PDUSessionResourceReleasedItemPSFail_iE_Extensions,
        PDUSessionResourceReleasedItemPSFail,
        PDUSessionResourceReleasedItemPSFail_ExtIEs,
        _PDUSessionResourceReleasedListRelRes__item_,
        PDUSessionResourceReleasedListRelRes,
        _PDUSessionResourceReleasedItemRelRes_pDUSessionID,
        __PDUSessionResourceReleasedItemRelRes_pDUSessionResourceReleaseResponseTransfer_contain,
        _PDUSessionResourceReleasedItemRelRes_pDUSessionResourceReleaseResponseTransfer,
        ____PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__id_tab,
        ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__id,
        ____PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__criticality,
        ____PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceReleasedItemRelRes_iE_Extensions__item__extensionValue,
        __PDUSessionResourceReleasedItemRelRes_iE_Extensions__item_,
        _PDUSessionResourceReleasedItemRelRes_iE_Extensions,
        PDUSessionResourceReleasedItemRelRes,
        PDUSessionResourceReleasedItemRelRes_ExtIEs,
        ____PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id_tab,
        _____PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id_tab_val_Extension_0,
        ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__id,
        ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__criticality,
        ___PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item__extensionValue,
        __PDUSessionResourceReleaseResponseTransfer_iE_Extensions__item_,
        _PDUSessionResourceReleaseResponseTransfer_iE_Extensions,
        PDUSessionResourceReleaseResponseTransfer,
        PDUSessionResourceReleaseResponseTransfer_ExtIEs,
        _PDUSessionResourceReleaseResponseTransfer_ExtIEs_val_Extension_0,
        _PDUSessionResourceResumeListRESReq__item_,
        PDUSessionResourceResumeListRESReq,
        _PDUSessionResourceResumeItemRESReq_pDUSessionID,
        __PDUSessionResourceResumeItemRESReq_uEContextResumeRequestTransfer_contain,
        _PDUSessionResourceResumeItemRESReq_uEContextResumeRequestTransfer,
        ____PDUSessionResourceResumeItemRESReq_iE_Extensions__item__id_tab,
        ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__id,
        ____PDUSessionResourceResumeItemRESReq_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__criticality,
        ____PDUSessionResourceResumeItemRESReq_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceResumeItemRESReq_iE_Extensions__item__extensionValue,
        __PDUSessionResourceResumeItemRESReq_iE_Extensions__item_,
        _PDUSessionResourceResumeItemRESReq_iE_Extensions,
        PDUSessionResourceResumeItemRESReq,
        PDUSessionResourceResumeItemRESReq_ExtIEs,
        _PDUSessionResourceResumeListRESRes__item_,
        PDUSessionResourceResumeListRESRes,
        _PDUSessionResourceResumeItemRESRes_pDUSessionID,
        __PDUSessionResourceResumeItemRESRes_uEContextResumeResponseTransfer_contain,
        _PDUSessionResourceResumeItemRESRes_uEContextResumeResponseTransfer,
        ____PDUSessionResourceResumeItemRESRes_iE_Extensions__item__id_tab,
        ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__id,
        ____PDUSessionResourceResumeItemRESRes_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__criticality,
        ____PDUSessionResourceResumeItemRESRes_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceResumeItemRESRes_iE_Extensions__item__extensionValue,
        __PDUSessionResourceResumeItemRESRes_iE_Extensions__item_,
        _PDUSessionResourceResumeItemRESRes_iE_Extensions,
        PDUSessionResourceResumeItemRESRes,
        PDUSessionResourceResumeItemRESRes_ExtIEs,
        _PDUSessionResourceSecondaryRATUsageList__item_,
        PDUSessionResourceSecondaryRATUsageList,
        _PDUSessionResourceSecondaryRATUsageItem_pDUSessionID,
        __PDUSessionResourceSecondaryRATUsageItem_secondaryRATDataUsageReportTransfer_contain,
        _PDUSessionResourceSecondaryRATUsageItem_secondaryRATDataUsageReportTransfer,
        ____PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__id_tab,
        ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__id,
        ____PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__criticality,
        ____PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item__extensionValue,
        __PDUSessionResourceSecondaryRATUsageItem_iE_Extensions__item_,
        _PDUSessionResourceSecondaryRATUsageItem_iE_Extensions,
        PDUSessionResourceSecondaryRATUsageItem,
        PDUSessionResourceSecondaryRATUsageItem_ExtIEs,
        _PDUSessionResourceSetupListCxtReq__item_,
        PDUSessionResourceSetupListCxtReq,
        _PDUSessionResourceSetupItemCxtReq_pDUSessionID,
        _PDUSessionResourceSetupItemCxtReq_nAS_PDU,
        _PDUSessionResourceSetupItemCxtReq_s_NSSAI,
        __PDUSessionResourceSetupItemCxtReq_pDUSessionResourceSetupRequestTransfer_contain,
        _PDUSessionResourceSetupItemCxtReq_pDUSessionResourceSetupRequestTransfer,
        ____PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id_tab,
        _____PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id_tab_val_Extension_0,
        ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__id,
        ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__criticality,
        ___PDUSessionResourceSetupItemCxtReq_iE_Extensions__item__extensionValue,
        __PDUSessionResourceSetupItemCxtReq_iE_Extensions__item_,
        _PDUSessionResourceSetupItemCxtReq_iE_Extensions,
        PDUSessionResourceSetupItemCxtReq,
        PDUSessionResourceSetupItemCxtReq_ExtIEs,
        _PDUSessionResourceSetupItemCxtReq_ExtIEs_val_Extension_0,
        _PDUSessionResourceSetupListCxtRes__item_,
        PDUSessionResourceSetupListCxtRes,
        _PDUSessionResourceSetupItemCxtRes_pDUSessionID,
        __PDUSessionResourceSetupItemCxtRes_pDUSessionResourceSetupResponseTransfer_contain,
        _PDUSessionResourceSetupItemCxtRes_pDUSessionResourceSetupResponseTransfer,
        ____PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__id_tab,
        ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__id,
        ____PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__criticality,
        ____PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceSetupItemCxtRes_iE_Extensions__item__extensionValue,
        __PDUSessionResourceSetupItemCxtRes_iE_Extensions__item_,
        _PDUSessionResourceSetupItemCxtRes_iE_Extensions,
        PDUSessionResourceSetupItemCxtRes,
        PDUSessionResourceSetupItemCxtRes_ExtIEs,
        _PDUSessionResourceSetupListHOReq__item_,
        PDUSessionResourceSetupListHOReq,
        _PDUSessionResourceSetupItemHOReq_pDUSessionID,
        _PDUSessionResourceSetupItemHOReq_s_NSSAI,
        __PDUSessionResourceSetupItemHOReq_handoverRequestTransfer_contain,
        _PDUSessionResourceSetupItemHOReq_handoverRequestTransfer,
        ____PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id_tab,
        _____PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_0,
        ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__id,
        ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__criticality,
        ___PDUSessionResourceSetupItemHOReq_iE_Extensions__item__extensionValue,
        __PDUSessionResourceSetupItemHOReq_iE_Extensions__item_,
        _PDUSessionResourceSetupItemHOReq_iE_Extensions,
        PDUSessionResourceSetupItemHOReq,
        PDUSessionResourceSetupItemHOReq_ExtIEs,
        _PDUSessionResourceSetupItemHOReq_ExtIEs_val_Extension_0,
        _PDUSessionResourceSetupListSUReq__item_,
        PDUSessionResourceSetupListSUReq,
        _PDUSessionResourceSetupItemSUReq_pDUSessionID,
        _PDUSessionResourceSetupItemSUReq_pDUSessionNAS_PDU,
        _PDUSessionResourceSetupItemSUReq_s_NSSAI,
        __PDUSessionResourceSetupItemSUReq_pDUSessionResourceSetupRequestTransfer_contain,
        _PDUSessionResourceSetupItemSUReq_pDUSessionResourceSetupRequestTransfer,
        ____PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id_tab,
        _____PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id_tab_val_Extension_0,
        ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__id,
        ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__criticality,
        ___PDUSessionResourceSetupItemSUReq_iE_Extensions__item__extensionValue,
        __PDUSessionResourceSetupItemSUReq_iE_Extensions__item_,
        _PDUSessionResourceSetupItemSUReq_iE_Extensions,
        PDUSessionResourceSetupItemSUReq,
        PDUSessionResourceSetupItemSUReq_ExtIEs,
        _PDUSessionResourceSetupItemSUReq_ExtIEs_val_Extension_0,
        _PDUSessionResourceSetupListSURes__item_,
        PDUSessionResourceSetupListSURes,
        _PDUSessionResourceSetupItemSURes_pDUSessionID,
        __PDUSessionResourceSetupItemSURes_pDUSessionResourceSetupResponseTransfer_contain,
        _PDUSessionResourceSetupItemSURes_pDUSessionResourceSetupResponseTransfer,
        ____PDUSessionResourceSetupItemSURes_iE_Extensions__item__id_tab,
        ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__id,
        ____PDUSessionResourceSetupItemSURes_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__criticality,
        ____PDUSessionResourceSetupItemSURes_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceSetupItemSURes_iE_Extensions__item__extensionValue,
        __PDUSessionResourceSetupItemSURes_iE_Extensions__item_,
        _PDUSessionResourceSetupItemSURes_iE_Extensions,
        PDUSessionResourceSetupItemSURes,
        PDUSessionResourceSetupItemSURes_ExtIEs,
        ____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_2,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_3,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_4,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_5,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_6,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_7,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_8,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_9,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_10,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_11,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_12,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_13,
        _____PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id_tab_val_Value_14,
        ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__id,
        ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__criticality,
        ___PDUSessionResourceSetupRequestTransfer_protocolIEs__item__value,
        __PDUSessionResourceSetupRequestTransfer_protocolIEs__item_,
        _PDUSessionResourceSetupRequestTransfer_protocolIEs,
        PDUSessionResourceSetupRequestTransfer,
        PDUSessionResourceSetupRequestTransferIEs,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_0,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_1,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_2,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_3,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_4,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_5,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_6,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_7,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_8,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_9,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_10,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_11,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_12,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_13,
        _PDUSessionResourceSetupRequestTransferIEs_val_Value_14,
        _PDUSessionResourceSetupResponseTransfer_dLQosFlowPerTNLInformation,
        _PDUSessionResourceSetupResponseTransfer_additionalDLQosFlowPerTNLInformation,
        _PDUSessionResourceSetupResponseTransfer_securityResult,
        _PDUSessionResourceSetupResponseTransfer_qosFlowFailedToSetupList,
        ____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab,
        _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_0,
        _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_1,
        _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_2,
        _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_3,
        _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_4,
        _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_5,
        _____PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id_tab_val_Extension_6,
        ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__id,
        ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__criticality,
        ___PDUSessionResourceSetupResponseTransfer_iE_Extensions__item__extensionValue,
        __PDUSessionResourceSetupResponseTransfer_iE_Extensions__item_,
        _PDUSessionResourceSetupResponseTransfer_iE_Extensions,
        PDUSessionResourceSetupResponseTransfer,
        PDUSessionResourceSetupResponseTransfer_ExtIEs,
        _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_0,
        _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_1,
        _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_2,
        _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_3,
        _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_4,
        _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_5,
        _PDUSessionResourceSetupResponseTransfer_ExtIEs_val_Extension_6,
        _PDUSessionResourceSetupUnsuccessfulTransfer_cause,
        _PDUSessionResourceSetupUnsuccessfulTransfer_criticalityDiagnostics,
        ____PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__id_tab,
        ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__id,
        ____PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__criticality,
        ____PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item__extensionValue,
        __PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions__item_,
        _PDUSessionResourceSetupUnsuccessfulTransfer_iE_Extensions,
        PDUSessionResourceSetupUnsuccessfulTransfer,
        PDUSessionResourceSetupUnsuccessfulTransfer_ExtIEs,
        _PDUSessionResourceSuspendListSUSReq__item_,
        PDUSessionResourceSuspendListSUSReq,
        _PDUSessionResourceSuspendItemSUSReq_pDUSessionID,
        __PDUSessionResourceSuspendItemSUSReq_uEContextSuspendRequestTransfer_contain,
        _PDUSessionResourceSuspendItemSUSReq_uEContextSuspendRequestTransfer,
        ____PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__id_tab,
        ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__id,
        ____PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__criticality,
        ____PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item__extensionValue,
        __PDUSessionResourceSuspendItemSUSReq_iE_Extensions__item_,
        _PDUSessionResourceSuspendItemSUSReq_iE_Extensions,
        PDUSessionResourceSuspendItemSUSReq,
        PDUSessionResourceSuspendItemSUSReq_ExtIEs,
        _PDUSessionResourceSwitchedList__item_,
        PDUSessionResourceSwitchedList,
        _PDUSessionResourceSwitchedItem_pDUSessionID,
        __PDUSessionResourceSwitchedItem_pathSwitchRequestAcknowledgeTransfer_contain,
        _PDUSessionResourceSwitchedItem_pathSwitchRequestAcknowledgeTransfer,
        ____PDUSessionResourceSwitchedItem_iE_Extensions__item__id_tab,
        _____PDUSessionResourceSwitchedItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___PDUSessionResourceSwitchedItem_iE_Extensions__item__id,
        ___PDUSessionResourceSwitchedItem_iE_Extensions__item__criticality,
        ___PDUSessionResourceSwitchedItem_iE_Extensions__item__extensionValue,
        __PDUSessionResourceSwitchedItem_iE_Extensions__item_,
        _PDUSessionResourceSwitchedItem_iE_Extensions,
        PDUSessionResourceSwitchedItem,
        PDUSessionResourceSwitchedItem_ExtIEs,
        _PDUSessionResourceSwitchedItem_ExtIEs_val_Extension_0,
        _PDUSessionResourceToBeSwitchedDLList__item_,
        PDUSessionResourceToBeSwitchedDLList,
        _PDUSessionResourceToBeSwitchedDLItem_pDUSessionID,
        __PDUSessionResourceToBeSwitchedDLItem_pathSwitchRequestTransfer_contain,
        _PDUSessionResourceToBeSwitchedDLItem_pathSwitchRequestTransfer,
        ____PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__id_tab,
        ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__id,
        ____PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__criticality,
        ____PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item__extensionValue,
        __PDUSessionResourceToBeSwitchedDLItem_iE_Extensions__item_,
        _PDUSessionResourceToBeSwitchedDLItem_iE_Extensions,
        PDUSessionResourceToBeSwitchedDLItem,
        PDUSessionResourceToBeSwitchedDLItem_ExtIEs,
        _PDUSessionResourceToReleaseListHOCmd__item_,
        PDUSessionResourceToReleaseListHOCmd,
        _PDUSessionResourceToReleaseItemHOCmd_pDUSessionID,
        __PDUSessionResourceToReleaseItemHOCmd_handoverPreparationUnsuccessfulTransfer_contain,
        _PDUSessionResourceToReleaseItemHOCmd_handoverPreparationUnsuccessfulTransfer,
        ____PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__id_tab,
        ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__id,
        ____PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__criticality,
        ____PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item__extensionValue,
        __PDUSessionResourceToReleaseItemHOCmd_iE_Extensions__item_,
        _PDUSessionResourceToReleaseItemHOCmd_iE_Extensions,
        PDUSessionResourceToReleaseItemHOCmd,
        PDUSessionResourceToReleaseItemHOCmd_ExtIEs,
        _PDUSessionResourceToReleaseListRelCmd__item_,
        PDUSessionResourceToReleaseListRelCmd,
        _PDUSessionResourceToReleaseItemRelCmd_pDUSessionID,
        __PDUSessionResourceToReleaseItemRelCmd_pDUSessionResourceReleaseCommandTransfer_contain,
        _PDUSessionResourceToReleaseItemRelCmd_pDUSessionResourceReleaseCommandTransfer,
        ____PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__id_tab,
        ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__id,
        ____PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__criticality_tab,
        ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__criticality,
        ____PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item__extensionValue,
        __PDUSessionResourceToReleaseItemRelCmd_iE_Extensions__item_,
        _PDUSessionResourceToReleaseItemRelCmd_iE_Extensions,
        PDUSessionResourceToReleaseItemRelCmd,
        PDUSessionResourceToReleaseItemRelCmd_ExtIEs,
        PDUSessionType,
        _PDUSessionUsageReport_rATType,
        _PDUSessionUsageReport_pDUSessionTimedReportList,
        ____PDUSessionUsageReport_iE_Extensions__item__id_tab,
        ___PDUSessionUsageReport_iE_Extensions__item__id,
        ____PDUSessionUsageReport_iE_Extensions__item__criticality_tab,
        ___PDUSessionUsageReport_iE_Extensions__item__criticality,
        ____PDUSessionUsageReport_iE_Extensions__item__extensionValue_tab,
        ___PDUSessionUsageReport_iE_Extensions__item__extensionValue,
        __PDUSessionUsageReport_iE_Extensions__item_,
        _PDUSessionUsageReport_iE_Extensions,
        PDUSessionUsageReport,
        PDUSessionUsageReport_ExtIEs,
        _PEIPSassistanceInformation_cNsubgroupID,
        ____PEIPSassistanceInformation_iE_Extensions__item__id_tab,
        ___PEIPSassistanceInformation_iE_Extensions__item__id,
        ____PEIPSassistanceInformation_iE_Extensions__item__criticality_tab,
        ___PEIPSassistanceInformation_iE_Extensions__item__criticality,
        ____PEIPSassistanceInformation_iE_Extensions__item__extensionValue_tab,
        ___PEIPSassistanceInformation_iE_Extensions__item__extensionValue,
        __PEIPSassistanceInformation_iE_Extensions__item_,
        _PEIPSassistanceInformation_iE_Extensions,
        PEIPSassistanceInformation,
        PEIPSassistanceInformation_ExtIEs,
        Periodicity,
        PeriodicRegistrationUpdateTimer,
        PLMNIdentity,
        _PLMNAreaBasedQMC_plmnListforQMC,
        ____PLMNAreaBasedQMC_iE_Extensions__item__id_tab,
        ___PLMNAreaBasedQMC_iE_Extensions__item__id,
        ____PLMNAreaBasedQMC_iE_Extensions__item__criticality_tab,
        ___PLMNAreaBasedQMC_iE_Extensions__item__criticality,
        ____PLMNAreaBasedQMC_iE_Extensions__item__extensionValue_tab,
        ___PLMNAreaBasedQMC_iE_Extensions__item__extensionValue,
        __PLMNAreaBasedQMC_iE_Extensions__item_,
        _PLMNAreaBasedQMC_iE_Extensions,
        PLMNAreaBasedQMC,
        PLMNAreaBasedQMC_ExtIEs,
        _PLMNListforQMC__item_,
        PLMNListforQMC,
        _PLMNSupportList__item_,
        PLMNSupportList,
        _PLMNSupportItem_pLMNIdentity,
        _PLMNSupportItem_sliceSupportList,
        ____PLMNSupportItem_iE_Extensions__item__id_tab,
        _____PLMNSupportItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____PLMNSupportItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____PLMNSupportItem_iE_Extensions__item__id_tab_val_Extension_2,
        ___PLMNSupportItem_iE_Extensions__item__id,
        ___PLMNSupportItem_iE_Extensions__item__criticality,
        ___PLMNSupportItem_iE_Extensions__item__extensionValue,
        __PLMNSupportItem_iE_Extensions__item_,
        _PLMNSupportItem_iE_Extensions,
        PLMNSupportItem,
        PLMNSupportItem_ExtIEs,
        _PLMNSupportItem_ExtIEs_val_Extension_0,
        _PLMNSupportItem_ExtIEs_val_Extension_1,
        _PLMNSupportItem_ExtIEs_val_Extension_2,
        _PNI_NPN_MobilityInformation_allowed_PNI_NPI_List,
        ____PNI_NPN_MobilityInformation_iE_Extensions__item__id_tab,
        ___PNI_NPN_MobilityInformation_iE_Extensions__item__id,
        ____PNI_NPN_MobilityInformation_iE_Extensions__item__criticality_tab,
        ___PNI_NPN_MobilityInformation_iE_Extensions__item__criticality,
        ____PNI_NPN_MobilityInformation_iE_Extensions__item__extensionValue_tab,
        ___PNI_NPN_MobilityInformation_iE_Extensions__item__extensionValue,
        __PNI_NPN_MobilityInformation_iE_Extensions__item_,
        _PNI_NPN_MobilityInformation_iE_Extensions,
        PNI_NPN_MobilityInformation,
        PNI_NPN_MobilityInformation_ExtIEs,
        PortNumber,
        Pre_emptionCapability,
        Pre_emptionVulnerability,
        PriorityLevelARP,
        PriorityLevelQos,
        _PWSFailedCellIDList_eUTRA_CGI_PWSFailedList,
        _PWSFailedCellIDList_nR_CGI_PWSFailedList,
        ___PWSFailedCellIDList_choice_Extensions_id_tab,
        __PWSFailedCellIDList_choice_Extensions_id,
        ___PWSFailedCellIDList_choice_Extensions_criticality_tab,
        __PWSFailedCellIDList_choice_Extensions_criticality,
        ___PWSFailedCellIDList_choice_Extensions_value_tab,
        __PWSFailedCellIDList_choice_Extensions_value,
        _PWSFailedCellIDList_choice_Extensions,
        PWSFailedCellIDList,
        PWSFailedCellIDList_ExtIEs,
        _QMCConfigInfo_uEAppLayerMeasInfoList,
        ____QMCConfigInfo_iE_Extensions__item__id_tab,
        ___QMCConfigInfo_iE_Extensions__item__id,
        ____QMCConfigInfo_iE_Extensions__item__criticality_tab,
        ___QMCConfigInfo_iE_Extensions__item__criticality,
        ____QMCConfigInfo_iE_Extensions__item__extensionValue_tab,
        ___QMCConfigInfo_iE_Extensions__item__extensionValue,
        __QMCConfigInfo_iE_Extensions__item_,
        _QMCConfigInfo_iE_Extensions,
        QMCConfigInfo,
        QMCConfigInfo_ExtIEs,
        _QMCDeactivation_qoEReferenceList,
        ____QMCDeactivation_iE_Extensions__item__id_tab,
        ___QMCDeactivation_iE_Extensions__item__id,
        ____QMCDeactivation_iE_Extensions__item__criticality_tab,
        ___QMCDeactivation_iE_Extensions__item__criticality,
        ____QMCDeactivation_iE_Extensions__item__extensionValue_tab,
        ___QMCDeactivation_iE_Extensions__item__extensionValue,
        __QMCDeactivation_iE_Extensions__item_,
        _QMCDeactivation_iE_Extensions,
        QMCDeactivation,
        QMCDeactivation_ExtIEs,
        _QoEReferenceList__item_,
        QoEReferenceList,
        QoEReference,
        _QosCharacteristics_nonDynamic5QI,
        _QosCharacteristics_dynamic5QI,
        ___QosCharacteristics_choice_Extensions_id_tab,
        __QosCharacteristics_choice_Extensions_id,
        ___QosCharacteristics_choice_Extensions_criticality_tab,
        __QosCharacteristics_choice_Extensions_criticality,
        ___QosCharacteristics_choice_Extensions_value_tab,
        __QosCharacteristics_choice_Extensions_value,
        _QosCharacteristics_choice_Extensions,
        QosCharacteristics,
        QosCharacteristics_ExtIEs,
        _QosFlowAcceptedList__item_,
        QosFlowAcceptedList,
        _QosFlowAcceptedItem_qosFlowIdentifier,
        ____QosFlowAcceptedItem_iE_Extensions__item__id_tab,
        _____QosFlowAcceptedItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___QosFlowAcceptedItem_iE_Extensions__item__id,
        ___QosFlowAcceptedItem_iE_Extensions__item__criticality,
        ___QosFlowAcceptedItem_iE_Extensions__item__extensionValue,
        __QosFlowAcceptedItem_iE_Extensions__item_,
        _QosFlowAcceptedItem_iE_Extensions,
        QosFlowAcceptedItem,
        QosFlowAcceptedItem_ExtIEs,
        _QosFlowAcceptedItem_ExtIEs_val_Extension_0,
        _QosFlowAddOrModifyRequestList__item_,
        QosFlowAddOrModifyRequestList,
        _QosFlowAddOrModifyRequestItem_qosFlowIdentifier,
        _QosFlowAddOrModifyRequestItem_qosFlowLevelQosParameters,
        _QosFlowAddOrModifyRequestItem_e_RAB_ID,
        ____QosFlowAddOrModifyRequestItem_iE_Extensions__item__id_tab,
        _____QosFlowAddOrModifyRequestItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____QosFlowAddOrModifyRequestItem_iE_Extensions__item__id_tab_val_Extension_1,
        ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__id,
        ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__criticality,
        ___QosFlowAddOrModifyRequestItem_iE_Extensions__item__extensionValue,
        __QosFlowAddOrModifyRequestItem_iE_Extensions__item_,
        _QosFlowAddOrModifyRequestItem_iE_Extensions,
        QosFlowAddOrModifyRequestItem,
        QosFlowAddOrModifyRequestItem_ExtIEs,
        _QosFlowAddOrModifyRequestItem_ExtIEs_val_Extension_0,
        _QosFlowAddOrModifyRequestItem_ExtIEs_val_Extension_1,
        _QosFlowAddOrModifyResponseList__item_,
        QosFlowAddOrModifyResponseList,
        _QosFlowAddOrModifyResponseItem_qosFlowIdentifier,
        ____QosFlowAddOrModifyResponseItem_iE_Extensions__item__id_tab,
        _____QosFlowAddOrModifyResponseItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__id,
        ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__criticality,
        ___QosFlowAddOrModifyResponseItem_iE_Extensions__item__extensionValue,
        __QosFlowAddOrModifyResponseItem_iE_Extensions__item_,
        _QosFlowAddOrModifyResponseItem_iE_Extensions,
        QosFlowAddOrModifyResponseItem,
        QosFlowAddOrModifyResponseItem_ExtIEs,
        _QosFlowAddOrModifyResponseItem_ExtIEs_val_Extension_0,
        _QosFlowFeedbackList__item_,
        QosFlowFeedbackList,
        _QosFlowFeedbackItem_qosFlowIdentifier,
        _QosFlowFeedbackItem_updateFeedback,
        _QosFlowFeedbackItem_cNpacketDelayBudgetDL,
        _QosFlowFeedbackItem_cNpacketDelayBudgetUL,
        ____QosFlowFeedbackItem_iE_Extensions__item__id_tab,
        ___QosFlowFeedbackItem_iE_Extensions__item__id,
        ____QosFlowFeedbackItem_iE_Extensions__item__criticality_tab,
        ___QosFlowFeedbackItem_iE_Extensions__item__criticality,
        ____QosFlowFeedbackItem_iE_Extensions__item__extensionValue_tab,
        ___QosFlowFeedbackItem_iE_Extensions__item__extensionValue,
        __QosFlowFeedbackItem_iE_Extensions__item_,
        _QosFlowFeedbackItem_iE_Extensions,
        QosFlowFeedbackItem,
        QosFlowFeedbackItem_ExtIEs,
        QosFlowIdentifier,
        _QosFlowInformationList__item_,
        QosFlowInformationList,
        _QosFlowInformationItem_qosFlowIdentifier,
        _QosFlowInformationItem_dLForwarding,
        ____QosFlowInformationItem_iE_Extensions__item__id_tab,
        _____QosFlowInformationItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____QosFlowInformationItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____QosFlowInformationItem_iE_Extensions__item__id_tab_val_Extension_2,
        ___QosFlowInformationItem_iE_Extensions__item__id,
        ___QosFlowInformationItem_iE_Extensions__item__criticality,
        ___QosFlowInformationItem_iE_Extensions__item__extensionValue,
        __QosFlowInformationItem_iE_Extensions__item_,
        _QosFlowInformationItem_iE_Extensions,
        QosFlowInformationItem,
        QosFlowInformationItem_ExtIEs,
        _QosFlowInformationItem_ExtIEs_val_Extension_0,
        _QosFlowInformationItem_ExtIEs_val_Extension_1,
        _QosFlowInformationItem_ExtIEs_val_Extension_2,
        _QosFlowLevelQosParameters_qosCharacteristics,
        _QosFlowLevelQosParameters_allocationAndRetentionPriority,
        _QosFlowLevelQosParameters_gBR_QosInformation,
        _QosFlowLevelQosParameters_reflectiveQosAttribute,
        _QosFlowLevelQosParameters_additionalQosFlowInformation,
        ____QosFlowLevelQosParameters_iE_Extensions__item__id_tab,
        _____QosFlowLevelQosParameters_iE_Extensions__item__id_tab_val_Extension_0,
        _____QosFlowLevelQosParameters_iE_Extensions__item__id_tab_val_Extension_1,
        ___QosFlowLevelQosParameters_iE_Extensions__item__id,
        ___QosFlowLevelQosParameters_iE_Extensions__item__criticality,
        ___QosFlowLevelQosParameters_iE_Extensions__item__extensionValue,
        __QosFlowLevelQosParameters_iE_Extensions__item_,
        _QosFlowLevelQosParameters_iE_Extensions,
        QosFlowLevelQosParameters,
        QosFlowLevelQosParameters_ExtIEs,
        _QosFlowLevelQosParameters_ExtIEs_val_Extension_0,
        _QosFlowLevelQosParameters_ExtIEs_val_Extension_1,
        QosMonitoringRequest,
        QosMonitoringReportingFrequency,
        _QoSFlowList__item_,
        QoSFlowList,
        _QosFlowListWithCause__item_,
        QosFlowListWithCause,
        _QosFlowWithCauseItem_qosFlowIdentifier,
        _QosFlowWithCauseItem_cause,
        ____QosFlowWithCauseItem_iE_Extensions__item__id_tab,
        ___QosFlowWithCauseItem_iE_Extensions__item__id,
        ____QosFlowWithCauseItem_iE_Extensions__item__criticality_tab,
        ___QosFlowWithCauseItem_iE_Extensions__item__criticality,
        ____QosFlowWithCauseItem_iE_Extensions__item__extensionValue_tab,
        ___QosFlowWithCauseItem_iE_Extensions__item__extensionValue,
        __QosFlowWithCauseItem_iE_Extensions__item_,
        _QosFlowWithCauseItem_iE_Extensions,
        QosFlowWithCauseItem,
        QosFlowWithCauseItem_ExtIEs,
        _QosFlowModifyConfirmList__item_,
        QosFlowModifyConfirmList,
        _QosFlowModifyConfirmItem_qosFlowIdentifier,
        ____QosFlowModifyConfirmItem_iE_Extensions__item__id_tab,
        ___QosFlowModifyConfirmItem_iE_Extensions__item__id,
        ____QosFlowModifyConfirmItem_iE_Extensions__item__criticality_tab,
        ___QosFlowModifyConfirmItem_iE_Extensions__item__criticality,
        ____QosFlowModifyConfirmItem_iE_Extensions__item__extensionValue_tab,
        ___QosFlowModifyConfirmItem_iE_Extensions__item__extensionValue,
        __QosFlowModifyConfirmItem_iE_Extensions__item_,
        _QosFlowModifyConfirmItem_iE_Extensions,
        QosFlowModifyConfirmItem,
        QosFlowModifyConfirmItem_ExtIEs,
        _QosFlowNotifyList__item_,
        QosFlowNotifyList,
        _QosFlowNotifyItem_qosFlowIdentifier,
        _QosFlowNotifyItem_notificationCause,
        ____QosFlowNotifyItem_iE_Extensions__item__id_tab,
        _____QosFlowNotifyItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___QosFlowNotifyItem_iE_Extensions__item__id,
        ___QosFlowNotifyItem_iE_Extensions__item__criticality,
        ___QosFlowNotifyItem_iE_Extensions__item__extensionValue,
        __QosFlowNotifyItem_iE_Extensions__item_,
        _QosFlowNotifyItem_iE_Extensions,
        QosFlowNotifyItem,
        QosFlowNotifyItem_ExtIEs,
        _QosFlowNotifyItem_ExtIEs_val_Extension_0,
        _QosFlowParametersList__item_,
        QosFlowParametersList,
        _QosFlowParametersItem_qosFlowIdentifier,
        _QosFlowParametersItem_alternativeQoSParaSetList,
        ____QosFlowParametersItem_iE_Extensions__item__id_tab,
        _____QosFlowParametersItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____QosFlowParametersItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____QosFlowParametersItem_iE_Extensions__item__id_tab_val_Extension_2,
        ___QosFlowParametersItem_iE_Extensions__item__id,
        ___QosFlowParametersItem_iE_Extensions__item__criticality,
        ___QosFlowParametersItem_iE_Extensions__item__extensionValue,
        __QosFlowParametersItem_iE_Extensions__item_,
        _QosFlowParametersItem_iE_Extensions,
        QosFlowParametersItem,
        QosFlowParametersItem_ExtIEs,
        _QosFlowParametersItem_ExtIEs_val_Extension_0,
        _QosFlowParametersItem_ExtIEs_val_Extension_1,
        _QosFlowParametersItem_ExtIEs_val_Extension_2,
        _QosFlowPerTNLInformation_uPTransportLayerInformation,
        _QosFlowPerTNLInformation_associatedQosFlowList,
        ____QosFlowPerTNLInformation_iE_Extensions__item__id_tab,
        ___QosFlowPerTNLInformation_iE_Extensions__item__id,
        ____QosFlowPerTNLInformation_iE_Extensions__item__criticality_tab,
        ___QosFlowPerTNLInformation_iE_Extensions__item__criticality,
        ____QosFlowPerTNLInformation_iE_Extensions__item__extensionValue_tab,
        ___QosFlowPerTNLInformation_iE_Extensions__item__extensionValue,
        __QosFlowPerTNLInformation_iE_Extensions__item_,
        _QosFlowPerTNLInformation_iE_Extensions,
        QosFlowPerTNLInformation,
        QosFlowPerTNLInformation_ExtIEs,
        _QosFlowPerTNLInformationList__item_,
        QosFlowPerTNLInformationList,
        _QosFlowPerTNLInformationItem_qosFlowPerTNLInformation,
        ____QosFlowPerTNLInformationItem_iE_Extensions__item__id_tab,
        ___QosFlowPerTNLInformationItem_iE_Extensions__item__id,
        ____QosFlowPerTNLInformationItem_iE_Extensions__item__criticality_tab,
        ___QosFlowPerTNLInformationItem_iE_Extensions__item__criticality,
        ____QosFlowPerTNLInformationItem_iE_Extensions__item__extensionValue_tab,
        ___QosFlowPerTNLInformationItem_iE_Extensions__item__extensionValue,
        __QosFlowPerTNLInformationItem_iE_Extensions__item_,
        _QosFlowPerTNLInformationItem_iE_Extensions,
        QosFlowPerTNLInformationItem,
        QosFlowPerTNLInformationItem_ExtIEs,
        _QosFlowSetupRequestList__item_,
        QosFlowSetupRequestList,
        _QosFlowSetupRequestItem_qosFlowIdentifier,
        _QosFlowSetupRequestItem_qosFlowLevelQosParameters,
        _QosFlowSetupRequestItem_e_RAB_ID,
        ____QosFlowSetupRequestItem_iE_Extensions__item__id_tab,
        _____QosFlowSetupRequestItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____QosFlowSetupRequestItem_iE_Extensions__item__id_tab_val_Extension_1,
        ___QosFlowSetupRequestItem_iE_Extensions__item__id,
        ___QosFlowSetupRequestItem_iE_Extensions__item__criticality,
        ___QosFlowSetupRequestItem_iE_Extensions__item__extensionValue,
        __QosFlowSetupRequestItem_iE_Extensions__item_,
        _QosFlowSetupRequestItem_iE_Extensions,
        QosFlowSetupRequestItem,
        QosFlowSetupRequestItem_ExtIEs,
        _QosFlowSetupRequestItem_ExtIEs_val_Extension_0,
        _QosFlowSetupRequestItem_ExtIEs_val_Extension_1,
        _QosFlowListWithDataForwarding__item_,
        QosFlowListWithDataForwarding,
        _QosFlowItemWithDataForwarding_qosFlowIdentifier,
        _QosFlowItemWithDataForwarding_dataForwardingAccepted,
        ____QosFlowItemWithDataForwarding_iE_Extensions__item__id_tab,
        _____QosFlowItemWithDataForwarding_iE_Extensions__item__id_tab_val_Extension_0,
        ___QosFlowItemWithDataForwarding_iE_Extensions__item__id,
        ___QosFlowItemWithDataForwarding_iE_Extensions__item__criticality,
        ___QosFlowItemWithDataForwarding_iE_Extensions__item__extensionValue,
        __QosFlowItemWithDataForwarding_iE_Extensions__item_,
        _QosFlowItemWithDataForwarding_iE_Extensions,
        QosFlowItemWithDataForwarding,
        QosFlowItemWithDataForwarding_ExtIEs,
        _QosFlowItemWithDataForwarding_ExtIEs_val_Extension_0,
        _QosFlowToBeForwardedList__item_,
        QosFlowToBeForwardedList,
        _QosFlowToBeForwardedItem_qosFlowIdentifier,
        ____QosFlowToBeForwardedItem_iE_Extensions__item__id_tab,
        ___QosFlowToBeForwardedItem_iE_Extensions__item__id,
        ____QosFlowToBeForwardedItem_iE_Extensions__item__criticality_tab,
        ___QosFlowToBeForwardedItem_iE_Extensions__item__criticality,
        ____QosFlowToBeForwardedItem_iE_Extensions__item__extensionValue_tab,
        ___QosFlowToBeForwardedItem_iE_Extensions__item__extensionValue,
        __QosFlowToBeForwardedItem_iE_Extensions__item_,
        _QosFlowToBeForwardedItem_iE_Extensions,
        QosFlowToBeForwardedItem,
        QosFlowToBeForwardedItem_ExtIEs,
        _QoSFlowsUsageReportList__item_,
        QoSFlowsUsageReportList,
        _QoSFlowsUsageReport_Item_qosFlowIdentifier,
        _QoSFlowsUsageReport_Item_rATType,
        _QoSFlowsUsageReport_Item_qoSFlowsTimedReportList,
        ____QoSFlowsUsageReport_Item_iE_Extensions__item__id_tab,
        ___QoSFlowsUsageReport_Item_iE_Extensions__item__id,
        ____QoSFlowsUsageReport_Item_iE_Extensions__item__criticality_tab,
        ___QoSFlowsUsageReport_Item_iE_Extensions__item__criticality,
        ____QoSFlowsUsageReport_Item_iE_Extensions__item__extensionValue_tab,
        ___QoSFlowsUsageReport_Item_iE_Extensions__item__extensionValue,
        __QoSFlowsUsageReport_Item_iE_Extensions__item_,
        _QoSFlowsUsageReport_Item_iE_Extensions,
        QoSFlowsUsageReport_Item,
        QoSFlowsUsageReport_Item_ExtIEs,
        Range,
        RANNodeName,
        RANNodeNameVisibleString,
        RANNodeNameUTF8String,
        RANPagingPriority,
        _RANStatusTransfer_TransparentContainer_dRBsSubjectToStatusTransferList,
        ____RANStatusTransfer_TransparentContainer_iE_Extensions__item__id_tab,
        ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__id,
        ____RANStatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab,
        ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__criticality,
        ____RANStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab,
        ___RANStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue,
        __RANStatusTransfer_TransparentContainer_iE_Extensions__item_,
        _RANStatusTransfer_TransparentContainer_iE_Extensions,
        RANStatusTransfer_TransparentContainer,
        RANStatusTransfer_TransparentContainer_ExtIEs,
        RAN_UE_NGAP_ID,
        RAT_Information,
        _RATRestrictions__item_,
        RATRestrictions,
        _RATRestrictions_Item_pLMNIdentity,
        _RATRestrictions_Item_rATRestrictionInformation,
        ____RATRestrictions_Item_iE_Extensions__item__id_tab,
        _____RATRestrictions_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___RATRestrictions_Item_iE_Extensions__item__id,
        ___RATRestrictions_Item_iE_Extensions__item__criticality,
        ___RATRestrictions_Item_iE_Extensions__item__extensionValue,
        __RATRestrictions_Item_iE_Extensions__item_,
        _RATRestrictions_Item_iE_Extensions,
        RATRestrictions_Item,
        RATRestrictions_Item_ExtIEs,
        _RATRestrictions_Item_ExtIEs_val_Extension_0,
        RATRestrictionInformation,
        _RecommendedCellsForPaging_recommendedCellList,
        ____RecommendedCellsForPaging_iE_Extensions__item__id_tab,
        ___RecommendedCellsForPaging_iE_Extensions__item__id,
        ____RecommendedCellsForPaging_iE_Extensions__item__criticality_tab,
        ___RecommendedCellsForPaging_iE_Extensions__item__criticality,
        ____RecommendedCellsForPaging_iE_Extensions__item__extensionValue_tab,
        ___RecommendedCellsForPaging_iE_Extensions__item__extensionValue,
        __RecommendedCellsForPaging_iE_Extensions__item_,
        _RecommendedCellsForPaging_iE_Extensions,
        RecommendedCellsForPaging,
        RecommendedCellsForPaging_ExtIEs,
        _RecommendedCellList__item_,
        RecommendedCellList,
        _RecommendedCellItem_nGRAN_CGI,
        _RecommendedCellItem_timeStayedInCell,
        ____RecommendedCellItem_iE_Extensions__item__id_tab,
        ___RecommendedCellItem_iE_Extensions__item__id,
        ____RecommendedCellItem_iE_Extensions__item__criticality_tab,
        ___RecommendedCellItem_iE_Extensions__item__criticality,
        ____RecommendedCellItem_iE_Extensions__item__extensionValue_tab,
        ___RecommendedCellItem_iE_Extensions__item__extensionValue,
        __RecommendedCellItem_iE_Extensions__item_,
        _RecommendedCellItem_iE_Extensions,
        RecommendedCellItem,
        RecommendedCellItem_ExtIEs,
        _RecommendedRANNodesForPaging_recommendedRANNodeList,
        ____RecommendedRANNodesForPaging_iE_Extensions__item__id_tab,
        ___RecommendedRANNodesForPaging_iE_Extensions__item__id,
        ____RecommendedRANNodesForPaging_iE_Extensions__item__criticality_tab,
        ___RecommendedRANNodesForPaging_iE_Extensions__item__criticality,
        ____RecommendedRANNodesForPaging_iE_Extensions__item__extensionValue_tab,
        ___RecommendedRANNodesForPaging_iE_Extensions__item__extensionValue,
        __RecommendedRANNodesForPaging_iE_Extensions__item_,
        _RecommendedRANNodesForPaging_iE_Extensions,
        RecommendedRANNodesForPaging,
        RecommendedRANNodesForPaging_ExtIEs,
        _RecommendedRANNodeList__item_,
        RecommendedRANNodeList,
        _RecommendedRANNodeItem_aMFPagingTarget,
        ____RecommendedRANNodeItem_iE_Extensions__item__id_tab,
        ___RecommendedRANNodeItem_iE_Extensions__item__id,
        ____RecommendedRANNodeItem_iE_Extensions__item__criticality_tab,
        ___RecommendedRANNodeItem_iE_Extensions__item__criticality,
        ____RecommendedRANNodeItem_iE_Extensions__item__extensionValue_tab,
        ___RecommendedRANNodeItem_iE_Extensions__item__extensionValue,
        __RecommendedRANNodeItem_iE_Extensions__item_,
        _RecommendedRANNodeItem_iE_Extensions,
        RecommendedRANNodeItem,
        RecommendedRANNodeItem_ExtIEs,
        RedCapIndication,
        RedirectionVoiceFallback,
        _RedundantPDUSessionInformation_rSN,
        ____RedundantPDUSessionInformation_iE_Extensions__item__id_tab,
        _____RedundantPDUSessionInformation_iE_Extensions__item__id_tab_val_Extension_0,
        ___RedundantPDUSessionInformation_iE_Extensions__item__id,
        ___RedundantPDUSessionInformation_iE_Extensions__item__criticality,
        ___RedundantPDUSessionInformation_iE_Extensions__item__extensionValue,
        __RedundantPDUSessionInformation_iE_Extensions__item_,
        _RedundantPDUSessionInformation_iE_Extensions,
        RedundantPDUSessionInformation,
        RedundantPDUSessionInformation_ExtIEs,
        _RedundantPDUSessionInformation_ExtIEs_val_Extension_0,
        RedundantQosFlowIndicator,
        ReflectiveQosAttribute,
        RelativeAMFCapacity,
        ReportArea,
        RepetitionPeriod,
        ResetAll,
        ReportAmountMDT,
        ReportIntervalMDT,
        ExtendedReportIntervalMDT,
        _ResetType_nG_Interface,
        _ResetType_partOfNG_Interface,
        ___ResetType_choice_Extensions_id_tab,
        __ResetType_choice_Extensions_id,
        ___ResetType_choice_Extensions_criticality_tab,
        __ResetType_choice_Extensions_criticality,
        ___ResetType_choice_Extensions_value_tab,
        __ResetType_choice_Extensions_value,
        _ResetType_choice_Extensions,
        ResetType,
        ResetType_ExtIEs,
        RGLevelWirelineAccessCharacteristics,
        RNC_ID,
        RoutingID,
        RRCContainer,
        RRCEstablishmentCause,
        RRCInactiveTransitionReportRequest,
        RRCState,
        RSN,
        _RIMInformationTransfer_targetRANNodeID_RIM,
        _RIMInformationTransfer_sourceRANNodeID,
        _RIMInformationTransfer_rIMInformation,
        ____RIMInformationTransfer_iE_Extensions__item__id_tab,
        ___RIMInformationTransfer_iE_Extensions__item__id,
        ____RIMInformationTransfer_iE_Extensions__item__criticality_tab,
        ___RIMInformationTransfer_iE_Extensions__item__criticality,
        ____RIMInformationTransfer_iE_Extensions__item__extensionValue_tab,
        ___RIMInformationTransfer_iE_Extensions__item__extensionValue,
        __RIMInformationTransfer_iE_Extensions__item_,
        _RIMInformationTransfer_iE_Extensions,
        RIMInformationTransfer,
        RIMInformationTransfer_ExtIEs,
        _RIMInformation_targetgNBSetID,
        _RIMInformation_rIM_RSDetection,
        ____RIMInformation_iE_Extensions__item__id_tab,
        ___RIMInformation_iE_Extensions__item__id,
        ____RIMInformation_iE_Extensions__item__criticality_tab,
        ___RIMInformation_iE_Extensions__item__criticality,
        ____RIMInformation_iE_Extensions__item__extensionValue_tab,
        ___RIMInformation_iE_Extensions__item__extensionValue,
        __RIMInformation_iE_Extensions__item_,
        _RIMInformation_iE_Extensions,
        RIMInformation,
        RIMInformation_ExtIEs,
        GNBSetID,
        _ScheduledCommunicationTime_dayofWeek,
        _ScheduledCommunicationTime_timeofDayStart,
        _ScheduledCommunicationTime_timeofDayEnd,
        ____ScheduledCommunicationTime_iE_Extensions__item__id_tab,
        ___ScheduledCommunicationTime_iE_Extensions__item__id,
        ____ScheduledCommunicationTime_iE_Extensions__item__criticality_tab,
        ___ScheduledCommunicationTime_iE_Extensions__item__criticality,
        ____ScheduledCommunicationTime_iE_Extensions__item__extensionValue_tab,
        ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue,
        __ScheduledCommunicationTime_iE_Extensions__item_,
        _ScheduledCommunicationTime_iE_Extensions,
        ScheduledCommunicationTime,
        ScheduledCommunicationTime_ExtIEs,
        _SCTP_TLAs__item_,
        SCTP_TLAs,
        SD,
        _SecondaryRATUsageInformation_pDUSessionUsageReport,
        _SecondaryRATUsageInformation_qosFlowsUsageReportList,
        ____SecondaryRATUsageInformation_iE_Extension__item__id_tab,
        ___SecondaryRATUsageInformation_iE_Extension__item__id,
        ____SecondaryRATUsageInformation_iE_Extension__item__criticality_tab,
        ___SecondaryRATUsageInformation_iE_Extension__item__criticality,
        ____SecondaryRATUsageInformation_iE_Extension__item__extensionValue_tab,
        ___SecondaryRATUsageInformation_iE_Extension__item__extensionValue,
        __SecondaryRATUsageInformation_iE_Extension__item_,
        _SecondaryRATUsageInformation_iE_Extension,
        SecondaryRATUsageInformation,
        SecondaryRATUsageInformation_ExtIEs,
        _SecondaryRATDataUsageReportTransfer_secondaryRATUsageInformation,
        ____SecondaryRATDataUsageReportTransfer_iE_Extensions__item__id_tab,
        ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__id,
        ____SecondaryRATDataUsageReportTransfer_iE_Extensions__item__criticality_tab,
        ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__criticality,
        ____SecondaryRATDataUsageReportTransfer_iE_Extensions__item__extensionValue_tab,
        ___SecondaryRATDataUsageReportTransfer_iE_Extensions__item__extensionValue,
        __SecondaryRATDataUsageReportTransfer_iE_Extensions__item_,
        _SecondaryRATDataUsageReportTransfer_iE_Extensions,
        SecondaryRATDataUsageReportTransfer,
        SecondaryRATDataUsageReportTransfer_ExtIEs,
        _SecurityContext_nextHopChainingCount,
        _SecurityContext_nextHopNH,
        ____SecurityContext_iE_Extensions__item__id_tab,
        ___SecurityContext_iE_Extensions__item__id,
        ____SecurityContext_iE_Extensions__item__criticality_tab,
        ___SecurityContext_iE_Extensions__item__criticality,
        ____SecurityContext_iE_Extensions__item__extensionValue_tab,
        ___SecurityContext_iE_Extensions__item__extensionValue,
        __SecurityContext_iE_Extensions__item_,
        _SecurityContext_iE_Extensions,
        SecurityContext,
        SecurityContext_ExtIEs,
        _SecurityIndication_integrityProtectionIndication,
        _SecurityIndication_confidentialityProtectionIndication,
        _SecurityIndication_maximumIntegrityProtectedDataRate_UL,
        ____SecurityIndication_iE_Extensions__item__id_tab,
        _____SecurityIndication_iE_Extensions__item__id_tab_val_Extension_0,
        ___SecurityIndication_iE_Extensions__item__id,
        ___SecurityIndication_iE_Extensions__item__criticality,
        ___SecurityIndication_iE_Extensions__item__extensionValue,
        __SecurityIndication_iE_Extensions__item_,
        _SecurityIndication_iE_Extensions,
        SecurityIndication,
        SecurityIndication_ExtIEs,
        _SecurityIndication_ExtIEs_val_Extension_0,
        SecurityKey,
        _SecurityResult_integrityProtectionResult,
        _SecurityResult_confidentialityProtectionResult,
        ____SecurityResult_iE_Extensions__item__id_tab,
        ___SecurityResult_iE_Extensions__item__id,
        ____SecurityResult_iE_Extensions__item__criticality_tab,
        ___SecurityResult_iE_Extensions__item__criticality,
        ____SecurityResult_iE_Extensions__item__extensionValue_tab,
        ___SecurityResult_iE_Extensions__item__extensionValue,
        __SecurityResult_iE_Extensions__item_,
        _SecurityResult_iE_Extensions,
        SecurityResult,
        SecurityResult_ExtIEs,
        _SensorMeasurementConfiguration_sensorMeasConfig,
        _SensorMeasurementConfiguration_sensorMeasConfigNameList,
        ____SensorMeasurementConfiguration_iE_Extensions__item__id_tab,
        ___SensorMeasurementConfiguration_iE_Extensions__item__id,
        ____SensorMeasurementConfiguration_iE_Extensions__item__criticality_tab,
        ___SensorMeasurementConfiguration_iE_Extensions__item__criticality,
        ____SensorMeasurementConfiguration_iE_Extensions__item__extensionValue_tab,
        ___SensorMeasurementConfiguration_iE_Extensions__item__extensionValue,
        __SensorMeasurementConfiguration_iE_Extensions__item_,
        _SensorMeasurementConfiguration_iE_Extensions,
        SensorMeasurementConfiguration,
        SensorMeasurementConfiguration_ExtIEs,
        _SensorMeasConfigNameList__item_,
        SensorMeasConfigNameList,
        _SensorMeasConfigNameItem_sensorNameConfig,
        ____SensorMeasConfigNameItem_iE_Extensions__item__id_tab,
        ___SensorMeasConfigNameItem_iE_Extensions__item__id,
        ____SensorMeasConfigNameItem_iE_Extensions__item__criticality_tab,
        ___SensorMeasConfigNameItem_iE_Extensions__item__criticality,
        ____SensorMeasConfigNameItem_iE_Extensions__item__extensionValue_tab,
        ___SensorMeasConfigNameItem_iE_Extensions__item__extensionValue,
        __SensorMeasConfigNameItem_iE_Extensions__item_,
        _SensorMeasConfigNameItem_iE_Extensions,
        SensorMeasConfigNameItem,
        SensorMeasConfigNameItem_ExtIEs,
        SensorMeasConfig,
        _SensorNameConfig_uncompensatedBarometricConfig,
        _SensorNameConfig_ueSpeedConfig,
        _SensorNameConfig_ueOrientationConfig,
        ___SensorNameConfig_choice_Extensions_id_tab,
        __SensorNameConfig_choice_Extensions_id,
        ___SensorNameConfig_choice_Extensions_criticality_tab,
        __SensorNameConfig_choice_Extensions_criticality,
        ___SensorNameConfig_choice_Extensions_value_tab,
        __SensorNameConfig_choice_Extensions_value,
        _SensorNameConfig_choice_Extensions,
        SensorNameConfig,
        SensorNameConfig_ExtIEs,
        SerialNumber,
        _ServedGUAMIList__item_,
        ServedGUAMIList,
        _ServedGUAMIItem_gUAMI,
        _ServedGUAMIItem_backupAMFName,
        ____ServedGUAMIItem_iE_Extensions__item__id_tab,
        _____ServedGUAMIItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___ServedGUAMIItem_iE_Extensions__item__id,
        ___ServedGUAMIItem_iE_Extensions__item__criticality,
        ___ServedGUAMIItem_iE_Extensions__item__extensionValue,
        __ServedGUAMIItem_iE_Extensions__item_,
        _ServedGUAMIItem_iE_Extensions,
        ServedGUAMIItem,
        ServedGUAMIItem_ExtIEs,
        _ServedGUAMIItem_ExtIEs_val_Extension_0,
        _ServiceAreaInformation__item_,
        ServiceAreaInformation,
        _ServiceAreaInformation_Item_pLMNIdentity,
        _ServiceAreaInformation_Item_allowedTACs,
        _ServiceAreaInformation_Item_notAllowedTACs,
        ____ServiceAreaInformation_Item_iE_Extensions__item__id_tab,
        ___ServiceAreaInformation_Item_iE_Extensions__item__id,
        ____ServiceAreaInformation_Item_iE_Extensions__item__criticality_tab,
        ___ServiceAreaInformation_Item_iE_Extensions__item__criticality,
        ____ServiceAreaInformation_Item_iE_Extensions__item__extensionValue_tab,
        ___ServiceAreaInformation_Item_iE_Extensions__item__extensionValue,
        __ServiceAreaInformation_Item_iE_Extensions__item_,
        _ServiceAreaInformation_Item_iE_Extensions,
        ServiceAreaInformation_Item,
        ServiceAreaInformation_Item_ExtIEs,
        ServiceType,
        SgNB_UE_X2AP_ID,
        _SharedNGU_MulticastTNLInformation_iP_MulticastAddress,
        _SharedNGU_MulticastTNLInformation_iP_SourceAddress,
        _SharedNGU_MulticastTNLInformation_gTP_TEID,
        ____SharedNGU_MulticastTNLInformation_iE_Extensions__item__id_tab,
        ___SharedNGU_MulticastTNLInformation_iE_Extensions__item__id,
        ____SharedNGU_MulticastTNLInformation_iE_Extensions__item__criticality_tab,
        ___SharedNGU_MulticastTNLInformation_iE_Extensions__item__criticality,
        ____SharedNGU_MulticastTNLInformation_iE_Extensions__item__extensionValue_tab,
        ___SharedNGU_MulticastTNLInformation_iE_Extensions__item__extensionValue,
        __SharedNGU_MulticastTNLInformation_iE_Extensions__item_,
        _SharedNGU_MulticastTNLInformation_iE_Extensions,
        SharedNGU_MulticastTNLInformation,
        SharedNGU_MulticastTNLInformation_ExtIEs,
        _SliceOverloadList__item_,
        SliceOverloadList,
        _SliceOverloadItem_s_NSSAI,
        ____SliceOverloadItem_iE_Extensions__item__id_tab,
        ___SliceOverloadItem_iE_Extensions__item__id,
        ____SliceOverloadItem_iE_Extensions__item__criticality_tab,
        ___SliceOverloadItem_iE_Extensions__item__criticality,
        ____SliceOverloadItem_iE_Extensions__item__extensionValue_tab,
        ___SliceOverloadItem_iE_Extensions__item__extensionValue,
        __SliceOverloadItem_iE_Extensions__item_,
        _SliceOverloadItem_iE_Extensions,
        SliceOverloadItem,
        SliceOverloadItem_ExtIEs,
        _SliceSupportList__item_,
        SliceSupportList,
        _SliceSupportItem_s_NSSAI,
        ____SliceSupportItem_iE_Extensions__item__id_tab,
        ___SliceSupportItem_iE_Extensions__item__id,
        ____SliceSupportItem_iE_Extensions__item__criticality_tab,
        ___SliceSupportItem_iE_Extensions__item__criticality,
        ____SliceSupportItem_iE_Extensions__item__extensionValue_tab,
        ___SliceSupportItem_iE_Extensions__item__extensionValue,
        __SliceSupportItem_iE_Extensions__item_,
        _SliceSupportItem_iE_Extensions,
        SliceSupportItem,
        SliceSupportItem_ExtIEs,
        _SliceSupportListQMC__item_,
        SliceSupportListQMC,
        _SliceSupportQMC_Item_s_NSSAI,
        ____SliceSupportQMC_Item_iE_Extensions__item__id_tab,
        ___SliceSupportQMC_Item_iE_Extensions__item__id,
        ____SliceSupportQMC_Item_iE_Extensions__item__criticality_tab,
        ___SliceSupportQMC_Item_iE_Extensions__item__criticality,
        ____SliceSupportQMC_Item_iE_Extensions__item__extensionValue_tab,
        ___SliceSupportQMC_Item_iE_Extensions__item__extensionValue,
        __SliceSupportQMC_Item_iE_Extensions__item_,
        _SliceSupportQMC_Item_iE_Extensions,
        SliceSupportQMC_Item,
        SliceSupportQMC_Item_ExtIEs,
        _SNPN_MobilityInformation_serving_NID,
        ____SNPN_MobilityInformation_iE_Extensions__item__id_tab,
        ___SNPN_MobilityInformation_iE_Extensions__item__id,
        ____SNPN_MobilityInformation_iE_Extensions__item__criticality_tab,
        ___SNPN_MobilityInformation_iE_Extensions__item__criticality,
        ____SNPN_MobilityInformation_iE_Extensions__item__extensionValue_tab,
        ___SNPN_MobilityInformation_iE_Extensions__item__extensionValue,
        __SNPN_MobilityInformation_iE_Extensions__item_,
        _SNPN_MobilityInformation_iE_Extensions,
        SNPN_MobilityInformation,
        SNPN_MobilityInformation_ExtIEs,
        _S_NSSAI_sST,
        _S_NSSAI_sD,
        ____S_NSSAI_iE_Extensions__item__id_tab,
        ___S_NSSAI_iE_Extensions__item__id,
        ____S_NSSAI_iE_Extensions__item__criticality_tab,
        ___S_NSSAI_iE_Extensions__item__criticality,
        ____S_NSSAI_iE_Extensions__item__extensionValue_tab,
        ___S_NSSAI_iE_Extensions__item__extensionValue,
        __S_NSSAI_iE_Extensions__item_,
        _S_NSSAI_iE_Extensions,
        S_NSSAI,
        S_NSSAI_ExtIEs,
        _SONConfigurationTransfer_targetRANNodeID_SON,
        _SONConfigurationTransfer_sourceRANNodeID,
        _SONConfigurationTransfer_sONInformation,
        _SONConfigurationTransfer_xnTNLConfigurationInfo,
        ____SONConfigurationTransfer_iE_Extensions__item__id_tab,
        ___SONConfigurationTransfer_iE_Extensions__item__id,
        ____SONConfigurationTransfer_iE_Extensions__item__criticality_tab,
        ___SONConfigurationTransfer_iE_Extensions__item__criticality,
        ____SONConfigurationTransfer_iE_Extensions__item__extensionValue_tab,
        ___SONConfigurationTransfer_iE_Extensions__item__extensionValue,
        __SONConfigurationTransfer_iE_Extensions__item_,
        _SONConfigurationTransfer_iE_Extensions,
        SONConfigurationTransfer,
        SONConfigurationTransfer_ExtIEs,
        _SONInformation_sONInformationRequest,
        _SONInformation_sONInformationReply,
        ___SONInformation_choice_Extensions_id_tab,
        ____SONInformation_choice_Extensions_id_tab_val_Value_0,
        __SONInformation_choice_Extensions_id,
        __SONInformation_choice_Extensions_criticality,
        __SONInformation_choice_Extensions_value,
        _SONInformation_choice_Extensions,
        SONInformation,
        SONInformation_ExtIEs,
        _SONInformation_ExtIEs_val_Value_0,
        _SONInformationReply_xnTNLConfigurationInfo,
        ____SONInformationReply_iE_Extensions__item__id_tab,
        ___SONInformationReply_iE_Extensions__item__id,
        ____SONInformationReply_iE_Extensions__item__criticality_tab,
        ___SONInformationReply_iE_Extensions__item__criticality,
        ____SONInformationReply_iE_Extensions__item__extensionValue_tab,
        ___SONInformationReply_iE_Extensions__item__extensionValue,
        __SONInformationReply_iE_Extensions__item_,
        _SONInformationReply_iE_Extensions,
        SONInformationReply,
        SONInformationReply_ExtIEs,
        _SONInformationReport_failureIndicationInformation,
        _SONInformationReport_hOReportInformation,
        ___SONInformationReport_choice_Extensions_id_tab,
        ____SONInformationReport_choice_Extensions_id_tab_val_Value_0,
        __SONInformationReport_choice_Extensions_id,
        __SONInformationReport_choice_Extensions_criticality,
        __SONInformationReport_choice_Extensions_value,
        _SONInformationReport_choice_Extensions,
        SONInformationReport,
        SONInformationReport_ExtIEs,
        _SONInformationReport_ExtIEs_val_Value_0,
        _SuccessfulHandoverReportList__item_,
        SuccessfulHandoverReportList,
        _SuccessfulHandoverReport_Item_successfulHOReportContainer,
        ____SuccessfulHandoverReport_Item_iE_Extensions__item__id_tab,
        ___SuccessfulHandoverReport_Item_iE_Extensions__item__id,
        ____SuccessfulHandoverReport_Item_iE_Extensions__item__criticality_tab,
        ___SuccessfulHandoverReport_Item_iE_Extensions__item__criticality,
        ____SuccessfulHandoverReport_Item_iE_Extensions__item__extensionValue_tab,
        ___SuccessfulHandoverReport_Item_iE_Extensions__item__extensionValue,
        __SuccessfulHandoverReport_Item_iE_Extensions__item_,
        _SuccessfulHandoverReport_Item_iE_Extensions,
        SuccessfulHandoverReport_Item,
        SuccessfulHandoverReport_Item_ExtIEs,
        SONInformationRequest,
        _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_rRCContainer,
        _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_pDUSessionResourceInformationList,
        _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_e_RABInformationList,
        _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_targetCell_ID,
        _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_indexToRFSP,
        _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_uEHistoryInformation,
        ____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab,
        _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0,
        _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1,
        _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_2,
        _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_3,
        _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_4,
        _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_5,
        _____SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_6,
        ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__id,
        ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__criticality,
        ___SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item__extensionValue,
        __SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions__item_,
        _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_iE_Extensions,
        SourceNGRANNode_ToTargetNGRANNode_TransparentContainer,
        SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs,
        _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_0,
        _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_1,
        _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_2,
        _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_3,
        _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_4,
        _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_5,
        _SourceNGRANNode_ToTargetNGRANNode_TransparentContainer_ExtIEs_val_Extension_6,
        _SourceNodeID_sourceengNB_ID,
        ___SourceNodeID_choice_Extensions_id_tab,
        __SourceNodeID_choice_Extensions_id,
        ___SourceNodeID_choice_Extensions_criticality_tab,
        __SourceNodeID_choice_Extensions_criticality,
        ___SourceNodeID_choice_Extensions_value_tab,
        __SourceNodeID_choice_Extensions_value,
        _SourceNodeID_choice_Extensions,
        SourceNodeID,
        SourceNodeID_ExtIEs,
        SourceOfUEActivityBehaviourInformation,
        _SourceRANNodeID_globalRANNodeID,
        _SourceRANNodeID_selectedTAI,
        ____SourceRANNodeID_iE_Extensions__item__id_tab,
        ___SourceRANNodeID_iE_Extensions__item__id,
        ____SourceRANNodeID_iE_Extensions__item__criticality_tab,
        ___SourceRANNodeID_iE_Extensions__item__criticality,
        ____SourceRANNodeID_iE_Extensions__item__extensionValue_tab,
        ___SourceRANNodeID_iE_Extensions__item__extensionValue,
        __SourceRANNodeID_iE_Extensions__item_,
        _SourceRANNodeID_iE_Extensions,
        SourceRANNodeID,
        SourceRANNodeID_ExtIEs,
        SourceToTarget_TransparentContainer,
        _SourceToTarget_AMFInformationReroute_configuredNSSAI,
        _SourceToTarget_AMFInformationReroute_rejectedNSSAIinPLMN,
        _SourceToTarget_AMFInformationReroute_rejectedNSSAIinTA,
        ____SourceToTarget_AMFInformationReroute_iE_Extensions__item__id_tab,
        ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__id,
        ____SourceToTarget_AMFInformationReroute_iE_Extensions__item__criticality_tab,
        ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__criticality,
        ____SourceToTarget_AMFInformationReroute_iE_Extensions__item__extensionValue_tab,
        ___SourceToTarget_AMFInformationReroute_iE_Extensions__item__extensionValue,
        __SourceToTarget_AMFInformationReroute_iE_Extensions__item_,
        _SourceToTarget_AMFInformationReroute_iE_Extensions,
        SourceToTarget_AMFInformationReroute,
        SourceToTarget_AMFInformationReroute_ExtIEs,
        SRVCCOperationPossible,
        ConfiguredNSSAI,
        RejectedNSSAIinPLMN,
        RejectedNSSAIinTA,
        SST,
        _SupportedTAList__item_,
        SupportedTAList,
        _SupportedTAItem_tAC,
        _SupportedTAItem_broadcastPLMNList,
        ____SupportedTAItem_iE_Extensions__item__id_tab,
        _____SupportedTAItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____SupportedTAItem_iE_Extensions__item__id_tab_val_Extension_1,
        ___SupportedTAItem_iE_Extensions__item__id,
        ___SupportedTAItem_iE_Extensions__item__criticality,
        ___SupportedTAItem_iE_Extensions__item__extensionValue,
        __SupportedTAItem_iE_Extensions__item_,
        _SupportedTAItem_iE_Extensions,
        SupportedTAItem,
        SupportedTAItem_ExtIEs,
        _SupportedTAItem_ExtIEs_val_Extension_0,
        _SupportedTAItem_ExtIEs_val_Extension_1,
        SuspendIndicator,
        Suspend_Request_Indication,
        Suspend_Response_Indication,
        SurvivalTime,
        TAC,
        _TACListInNRNTN__item_,
        TACListInNRNTN,
        _TAI_pLMNIdentity,
        _TAI_tAC,
        ____TAI_iE_Extensions__item__id_tab,
        ___TAI_iE_Extensions__item__id,
        ____TAI_iE_Extensions__item__criticality_tab,
        ___TAI_iE_Extensions__item__criticality,
        ____TAI_iE_Extensions__item__extensionValue_tab,
        ___TAI_iE_Extensions__item__extensionValue,
        __TAI_iE_Extensions__item_,
        _TAI_iE_Extensions,
        TAI,
        TAI_ExtIEs,
        _TAIBroadcastEUTRA__item_,
        TAIBroadcastEUTRA,
        _TAIBroadcastEUTRA_Item_tAI,
        _TAIBroadcastEUTRA_Item_completedCellsInTAI_EUTRA,
        ____TAIBroadcastEUTRA_Item_iE_Extensions__item__id_tab,
        ___TAIBroadcastEUTRA_Item_iE_Extensions__item__id,
        ____TAIBroadcastEUTRA_Item_iE_Extensions__item__criticality_tab,
        ___TAIBroadcastEUTRA_Item_iE_Extensions__item__criticality,
        ____TAIBroadcastEUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___TAIBroadcastEUTRA_Item_iE_Extensions__item__extensionValue,
        __TAIBroadcastEUTRA_Item_iE_Extensions__item_,
        _TAIBroadcastEUTRA_Item_iE_Extensions,
        TAIBroadcastEUTRA_Item,
        TAIBroadcastEUTRA_Item_ExtIEs,
        _TAIBroadcastNR__item_,
        TAIBroadcastNR,
        _TAIBroadcastNR_Item_tAI,
        _TAIBroadcastNR_Item_completedCellsInTAI_NR,
        ____TAIBroadcastNR_Item_iE_Extensions__item__id_tab,
        ___TAIBroadcastNR_Item_iE_Extensions__item__id,
        ____TAIBroadcastNR_Item_iE_Extensions__item__criticality_tab,
        ___TAIBroadcastNR_Item_iE_Extensions__item__criticality,
        ____TAIBroadcastNR_Item_iE_Extensions__item__extensionValue_tab,
        ___TAIBroadcastNR_Item_iE_Extensions__item__extensionValue,
        __TAIBroadcastNR_Item_iE_Extensions__item_,
        _TAIBroadcastNR_Item_iE_Extensions,
        TAIBroadcastNR_Item,
        TAIBroadcastNR_Item_ExtIEs,
        _TAICancelledEUTRA__item_,
        TAICancelledEUTRA,
        _TAICancelledEUTRA_Item_tAI,
        _TAICancelledEUTRA_Item_cancelledCellsInTAI_EUTRA,
        ____TAICancelledEUTRA_Item_iE_Extensions__item__id_tab,
        ___TAICancelledEUTRA_Item_iE_Extensions__item__id,
        ____TAICancelledEUTRA_Item_iE_Extensions__item__criticality_tab,
        ___TAICancelledEUTRA_Item_iE_Extensions__item__criticality,
        ____TAICancelledEUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___TAICancelledEUTRA_Item_iE_Extensions__item__extensionValue,
        __TAICancelledEUTRA_Item_iE_Extensions__item_,
        _TAICancelledEUTRA_Item_iE_Extensions,
        TAICancelledEUTRA_Item,
        TAICancelledEUTRA_Item_ExtIEs,
        _TAICancelledNR__item_,
        TAICancelledNR,
        _TAICancelledNR_Item_tAI,
        _TAICancelledNR_Item_cancelledCellsInTAI_NR,
        ____TAICancelledNR_Item_iE_Extensions__item__id_tab,
        ___TAICancelledNR_Item_iE_Extensions__item__id,
        ____TAICancelledNR_Item_iE_Extensions__item__criticality_tab,
        ___TAICancelledNR_Item_iE_Extensions__item__criticality,
        ____TAICancelledNR_Item_iE_Extensions__item__extensionValue_tab,
        ___TAICancelledNR_Item_iE_Extensions__item__extensionValue,
        __TAICancelledNR_Item_iE_Extensions__item_,
        _TAICancelledNR_Item_iE_Extensions,
        TAICancelledNR_Item,
        TAICancelledNR_Item_ExtIEs,
        _TAIListForInactive__item_,
        TAIListForInactive,
        _TAIListForInactiveItem_tAI,
        ____TAIListForInactiveItem_iE_Extensions__item__id_tab,
        ___TAIListForInactiveItem_iE_Extensions__item__id,
        ____TAIListForInactiveItem_iE_Extensions__item__criticality_tab,
        ___TAIListForInactiveItem_iE_Extensions__item__criticality,
        ____TAIListForInactiveItem_iE_Extensions__item__extensionValue_tab,
        ___TAIListForInactiveItem_iE_Extensions__item__extensionValue,
        __TAIListForInactiveItem_iE_Extensions__item_,
        _TAIListForInactiveItem_iE_Extensions,
        TAIListForInactiveItem,
        TAIListForInactiveItem_ExtIEs,
        _TAIListForPaging__item_,
        TAIListForPaging,
        _TAIListForPagingItem_tAI,
        ____TAIListForPagingItem_iE_Extensions__item__id_tab,
        ___TAIListForPagingItem_iE_Extensions__item__id,
        ____TAIListForPagingItem_iE_Extensions__item__criticality_tab,
        ___TAIListForPagingItem_iE_Extensions__item__criticality,
        ____TAIListForPagingItem_iE_Extensions__item__extensionValue_tab,
        ___TAIListForPagingItem_iE_Extensions__item__extensionValue,
        __TAIListForPagingItem_iE_Extensions__item_,
        _TAIListForPagingItem_iE_Extensions,
        TAIListForPagingItem,
        TAIListForPagingItem_ExtIEs,
        _TAIListForRestart__item_,
        TAIListForRestart,
        _TAIListForWarning__item_,
        TAIListForWarning,
        _TAINSAGSupportList__item_,
        TAINSAGSupportList,
        _TAINSAGSupportItem_nSAG_ID,
        _TAINSAGSupportItem_nSAGSliceSupportList,
        ____TAINSAGSupportItem_iE_Extensions__item__id_tab,
        ___TAINSAGSupportItem_iE_Extensions__item__id,
        ____TAINSAGSupportItem_iE_Extensions__item__criticality_tab,
        ___TAINSAGSupportItem_iE_Extensions__item__criticality,
        ____TAINSAGSupportItem_iE_Extensions__item__extensionValue_tab,
        ___TAINSAGSupportItem_iE_Extensions__item__extensionValue,
        __TAINSAGSupportItem_iE_Extensions__item_,
        _TAINSAGSupportItem_iE_Extensions,
        TAINSAGSupportItem,
        TAINSAGSupportItem_ExtIEs,
        _TargeteNB_ID_globalENB_ID,
        _TargeteNB_ID_selected_EPS_TAI,
        ____TargeteNB_ID_iE_Extensions__item__id_tab,
        ___TargeteNB_ID_iE_Extensions__item__id,
        ____TargeteNB_ID_iE_Extensions__item__criticality_tab,
        ___TargeteNB_ID_iE_Extensions__item__criticality,
        ____TargeteNB_ID_iE_Extensions__item__extensionValue_tab,
        ___TargeteNB_ID_iE_Extensions__item__extensionValue,
        __TargeteNB_ID_iE_Extensions__item_,
        _TargeteNB_ID_iE_Extensions,
        TargeteNB_ID,
        TargeteNB_ID_ExtIEs,
        _TargetHomeENB_ID_pLMNidentity,
        _TargetHomeENB_ID_homeENB_ID,
        _TargetHomeENB_ID_selected_EPS_TAI,
        ____TargetHomeENB_ID_iE_Extensions__item__id_tab,
        ___TargetHomeENB_ID_iE_Extensions__item__id,
        ____TargetHomeENB_ID_iE_Extensions__item__criticality_tab,
        ___TargetHomeENB_ID_iE_Extensions__item__criticality,
        ____TargetHomeENB_ID_iE_Extensions__item__extensionValue_tab,
        ___TargetHomeENB_ID_iE_Extensions__item__extensionValue,
        __TargetHomeENB_ID_iE_Extensions__item_,
        _TargetHomeENB_ID_iE_Extensions,
        TargetHomeENB_ID,
        TargetHomeENB_ID_ExtIEs,
        _TargetID_targetRANNodeID,
        _TargetID_targeteNB_ID,
        ___TargetID_choice_Extensions_id_tab,
        ____TargetID_choice_Extensions_id_tab_val_Value_0,
        ____TargetID_choice_Extensions_id_tab_val_Value_1,
        __TargetID_choice_Extensions_id,
        __TargetID_choice_Extensions_criticality,
        __TargetID_choice_Extensions_value,
        _TargetID_choice_Extensions,
        TargetID,
        TargetID_ExtIEs,
        _TargetID_ExtIEs_val_Value_0,
        _TargetID_ExtIEs_val_Value_1,
        _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_rRCContainer,
        ____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab,
        _____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0,
        _____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1,
        _____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_2,
        _____TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_3,
        ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__id,
        ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__criticality,
        ___TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item__extensionValue,
        __TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions__item_,
        _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_iE_Extensions,
        TargetNGRANNode_ToSourceNGRANNode_TransparentContainer,
        TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_ExtIEs,
        _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_ExtIEs_val_Extension_0,
        _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_ExtIEs_val_Extension_1,
        _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_ExtIEs_val_Extension_2,
        _TargetNGRANNode_ToSourceNGRANNode_TransparentContainer_ExtIEs_val_Extension_3,
        _TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_cell_CAGInformation,
        ____TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__id_tab,
        _____TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__id_tab_val_Extension_0,
        ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__id,
        ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__criticality,
        ___TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item__extensionValue,
        __TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions__item_,
        _TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_iE_Extensions,
        TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer,
        TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_ExtIEs,
        _TargetNGRANNode_ToSourceNGRANNode_FailureTransparentContainer_ExtIEs_val_Extension_0,
        _TargetNSSAI__item_,
        TargetNSSAI,
        _TargetNSSAI_Item_s_NSSAI,
        ____TargetNSSAI_Item_iE_Extensions__item__id_tab,
        ___TargetNSSAI_Item_iE_Extensions__item__id,
        ____TargetNSSAI_Item_iE_Extensions__item__criticality_tab,
        ___TargetNSSAI_Item_iE_Extensions__item__criticality,
        ____TargetNSSAI_Item_iE_Extensions__item__extensionValue_tab,
        ___TargetNSSAI_Item_iE_Extensions__item__extensionValue,
        __TargetNSSAI_Item_iE_Extensions__item_,
        _TargetNSSAI_Item_iE_Extensions,
        TargetNSSAI_Item,
        TargetNSSAI_Item_ExtIEs,
        _TargetNSSAIInformation_targetNSSAI,
        _TargetNSSAIInformation_indexToRFSP,
        ____TargetNSSAIInformation_iE_Extensions__item__id_tab,
        ___TargetNSSAIInformation_iE_Extensions__item__id,
        ____TargetNSSAIInformation_iE_Extensions__item__criticality_tab,
        ___TargetNSSAIInformation_iE_Extensions__item__criticality,
        ____TargetNSSAIInformation_iE_Extensions__item__extensionValue_tab,
        ___TargetNSSAIInformation_iE_Extensions__item__extensionValue,
        __TargetNSSAIInformation_iE_Extensions__item_,
        _TargetNSSAIInformation_iE_Extensions,
        TargetNSSAIInformation,
        TargetNSSAIInformation_Item_ExtIEs,
        _TargetRANNodeID_globalRANNodeID,
        _TargetRANNodeID_selectedTAI,
        ____TargetRANNodeID_iE_Extensions__item__id_tab,
        ___TargetRANNodeID_iE_Extensions__item__id,
        ____TargetRANNodeID_iE_Extensions__item__criticality_tab,
        ___TargetRANNodeID_iE_Extensions__item__criticality,
        ____TargetRANNodeID_iE_Extensions__item__extensionValue_tab,
        ___TargetRANNodeID_iE_Extensions__item__extensionValue,
        __TargetRANNodeID_iE_Extensions__item_,
        _TargetRANNodeID_iE_Extensions,
        TargetRANNodeID,
        TargetRANNodeID_ExtIEs,
        _TargetRANNodeID_RIM_globalRANNodeID,
        _TargetRANNodeID_RIM_selectedTAI,
        ____TargetRANNodeID_RIM_iE_Extensions__item__id_tab,
        ___TargetRANNodeID_RIM_iE_Extensions__item__id,
        ____TargetRANNodeID_RIM_iE_Extensions__item__criticality_tab,
        ___TargetRANNodeID_RIM_iE_Extensions__item__criticality,
        ____TargetRANNodeID_RIM_iE_Extensions__item__extensionValue_tab,
        ___TargetRANNodeID_RIM_iE_Extensions__item__extensionValue,
        __TargetRANNodeID_RIM_iE_Extensions__item_,
        _TargetRANNodeID_RIM_iE_Extensions,
        TargetRANNodeID_RIM,
        TargetRANNodeID_RIM_ExtIEs,
        _TargetRANNodeID_SON_globalRANNodeID,
        _TargetRANNodeID_SON_selectedTAI,
        ____TargetRANNodeID_SON_iE_Extensions__item__id_tab,
        _____TargetRANNodeID_SON_iE_Extensions__item__id_tab_val_Extension_0,
        ___TargetRANNodeID_SON_iE_Extensions__item__id,
        ___TargetRANNodeID_SON_iE_Extensions__item__criticality,
        ___TargetRANNodeID_SON_iE_Extensions__item__extensionValue,
        __TargetRANNodeID_SON_iE_Extensions__item_,
        _TargetRANNodeID_SON_iE_Extensions,
        TargetRANNodeID_SON,
        TargetRANNodeID_SON_ExtIEs,
        _TargetRANNodeID_SON_ExtIEs_val_Extension_0,
        _TargetRNC_ID_lAI,
        _TargetRNC_ID_rNC_ID,
        _TargetRNC_ID_extendedRNC_ID,
        ____TargetRNC_ID_iE_Extensions__item__id_tab,
        ___TargetRNC_ID_iE_Extensions__item__id,
        ____TargetRNC_ID_iE_Extensions__item__criticality_tab,
        ___TargetRNC_ID_iE_Extensions__item__criticality,
        ____TargetRNC_ID_iE_Extensions__item__extensionValue_tab,
        ___TargetRNC_ID_iE_Extensions__item__extensionValue,
        __TargetRNC_ID_iE_Extensions__item_,
        _TargetRNC_ID_iE_Extensions,
        TargetRNC_ID,
        TargetRNC_ID_ExtIEs,
        TargetToSource_TransparentContainer,
        TargettoSource_Failure_TransparentContainer,
        TimerApproachForGUAMIRemoval,
        TimeStamp,
        _TimeSyncAssistanceInfo_timeDistributionIndication,
        _TimeSyncAssistanceInfo_uUTimeSyncErrorBudget,
        ____TimeSyncAssistanceInfo_iE_Extensions__item__id_tab,
        ___TimeSyncAssistanceInfo_iE_Extensions__item__id,
        ____TimeSyncAssistanceInfo_iE_Extensions__item__criticality_tab,
        ___TimeSyncAssistanceInfo_iE_Extensions__item__criticality,
        ____TimeSyncAssistanceInfo_iE_Extensions__item__extensionValue_tab,
        ___TimeSyncAssistanceInfo_iE_Extensions__item__extensionValue,
        __TimeSyncAssistanceInfo_iE_Extensions__item_,
        _TimeSyncAssistanceInfo_iE_Extensions,
        TimeSyncAssistanceInfo,
        TimeSyncAssistanceInfo_ExtIEs,
        TimeToWait,
        TimeUEStayedInCell,
        TimeUEStayedInCellEnhancedGranularity,
        TMGI,
        TNAP_ID,
        _TNGF_ID_tNGF_ID,
        ___TNGF_ID_choice_Extensions_id_tab,
        __TNGF_ID_choice_Extensions_id,
        ___TNGF_ID_choice_Extensions_criticality_tab,
        __TNGF_ID_choice_Extensions_criticality,
        ___TNGF_ID_choice_Extensions_value_tab,
        __TNGF_ID_choice_Extensions_value,
        _TNGF_ID_choice_Extensions,
        TNGF_ID,
        TNGF_ID_ExtIEs,
        TNLAddressWeightFactor,
        _TNLAssociationList__item_,
        TNLAssociationList,
        _TNLAssociationItem_tNLAssociationAddress,
        _TNLAssociationItem_cause,
        ____TNLAssociationItem_iE_Extensions__item__id_tab,
        ___TNLAssociationItem_iE_Extensions__item__id,
        ____TNLAssociationItem_iE_Extensions__item__criticality_tab,
        ___TNLAssociationItem_iE_Extensions__item__criticality,
        ____TNLAssociationItem_iE_Extensions__item__extensionValue_tab,
        ___TNLAssociationItem_iE_Extensions__item__extensionValue,
        __TNLAssociationItem_iE_Extensions__item_,
        _TNLAssociationItem_iE_Extensions,
        TNLAssociationItem,
        TNLAssociationItem_ExtIEs,
        TNLAssociationUsage,
        _TooearlyIntersystemHO_sourcecellID,
        _TooearlyIntersystemHO_failurecellID,
        _TooearlyIntersystemHO_uERLFReportContainer,
        ____TooearlyIntersystemHO_iE_Extensions__item__id_tab,
        ___TooearlyIntersystemHO_iE_Extensions__item__id,
        ____TooearlyIntersystemHO_iE_Extensions__item__criticality_tab,
        ___TooearlyIntersystemHO_iE_Extensions__item__criticality,
        ____TooearlyIntersystemHO_iE_Extensions__item__extensionValue_tab,
        ___TooearlyIntersystemHO_iE_Extensions__item__extensionValue,
        __TooearlyIntersystemHO_iE_Extensions__item_,
        _TooearlyIntersystemHO_iE_Extensions,
        TooearlyIntersystemHO,
        TooearlyIntersystemHO_ExtIEs,
        _TraceActivation_nGRANTraceID,
        _TraceActivation_interfacesToTrace,
        _TraceActivation_traceDepth,
        _TraceActivation_traceCollectionEntityIPAddress,
        ____TraceActivation_iE_Extensions__item__id_tab,
        _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0,
        _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_1,
        ___TraceActivation_iE_Extensions__item__id,
        ___TraceActivation_iE_Extensions__item__criticality,
        ___TraceActivation_iE_Extensions__item__extensionValue,
        __TraceActivation_iE_Extensions__item_,
        _TraceActivation_iE_Extensions,
        TraceActivation,
        TraceActivation_ExtIEs,
        _TraceActivation_ExtIEs_val_Extension_0,
        _TraceActivation_ExtIEs_val_Extension_1,
        TraceDepth,
        TrafficLoadReductionIndication,
        TransportLayerAddress,
        TypeOfError,
        _TAIBasedMDT_tAIListforMDT,
        ____TAIBasedMDT_iE_Extensions__item__id_tab,
        ___TAIBasedMDT_iE_Extensions__item__id,
        ____TAIBasedMDT_iE_Extensions__item__criticality_tab,
        ___TAIBasedMDT_iE_Extensions__item__criticality,
        ____TAIBasedMDT_iE_Extensions__item__extensionValue_tab,
        ___TAIBasedMDT_iE_Extensions__item__extensionValue,
        __TAIBasedMDT_iE_Extensions__item_,
        _TAIBasedMDT_iE_Extensions,
        TAIBasedMDT,
        TAIBasedMDT_ExtIEs,
        _TAIListforMDT__item_,
        TAIListforMDT,
        _TAIBasedQMC_tAIListforQMC,
        ____TAIBasedQMC_iE_Extensions__item__id_tab,
        ___TAIBasedQMC_iE_Extensions__item__id,
        ____TAIBasedQMC_iE_Extensions__item__criticality_tab,
        ___TAIBasedQMC_iE_Extensions__item__criticality,
        ____TAIBasedQMC_iE_Extensions__item__extensionValue_tab,
        ___TAIBasedQMC_iE_Extensions__item__extensionValue,
        __TAIBasedQMC_iE_Extensions__item_,
        _TAIBasedQMC_iE_Extensions,
        TAIBasedQMC,
        TAIBasedQMC_ExtIEs,
        _TAIListforQMC__item_,
        TAIListforQMC,
        _TABasedQMC_tAListforQMC,
        ____TABasedQMC_iE_Extensions__item__id_tab,
        ___TABasedQMC_iE_Extensions__item__id,
        ____TABasedQMC_iE_Extensions__item__criticality_tab,
        ___TABasedQMC_iE_Extensions__item__criticality,
        ____TABasedQMC_iE_Extensions__item__extensionValue_tab,
        ___TABasedQMC_iE_Extensions__item__extensionValue,
        __TABasedQMC_iE_Extensions__item_,
        _TABasedQMC_iE_Extensions,
        TABasedQMC,
        TABasedQMC_ExtIEs,
        _TAListforQMC__item_,
        TAListforQMC,
        _TABasedMDT_tAListforMDT,
        ____TABasedMDT_iE_Extensions__item__id_tab,
        ___TABasedMDT_iE_Extensions__item__id,
        ____TABasedMDT_iE_Extensions__item__criticality_tab,
        ___TABasedMDT_iE_Extensions__item__criticality,
        ____TABasedMDT_iE_Extensions__item__extensionValue_tab,
        ___TABasedMDT_iE_Extensions__item__extensionValue,
        __TABasedMDT_iE_Extensions__item_,
        _TABasedMDT_iE_Extensions,
        TABasedMDT,
        TABasedMDT_ExtIEs,
        _TAListforMDT__item_,
        TAListforMDT,
        Threshold_RSRP,
        Threshold_RSRQ,
        Threshold_SINR,
        TimeToTrigger,
        TWAP_ID,
        _TWIF_ID_tWIF_ID,
        ___TWIF_ID_choice_Extensions_id_tab,
        __TWIF_ID_choice_Extensions_id,
        ___TWIF_ID_choice_Extensions_criticality_tab,
        __TWIF_ID_choice_Extensions_criticality,
        ___TWIF_ID_choice_Extensions_value_tab,
        __TWIF_ID_choice_Extensions_value,
        _TWIF_ID_choice_Extensions,
        TWIF_ID,
        TWIF_ID_ExtIEs,
        _TSCAssistanceInformation_periodicity,
        _TSCAssistanceInformation_burstArrivalTime,
        ____TSCAssistanceInformation_iE_Extensions__item__id_tab,
        _____TSCAssistanceInformation_iE_Extensions__item__id_tab_val_Extension_0,
        ___TSCAssistanceInformation_iE_Extensions__item__id,
        ___TSCAssistanceInformation_iE_Extensions__item__criticality,
        ___TSCAssistanceInformation_iE_Extensions__item__extensionValue,
        __TSCAssistanceInformation_iE_Extensions__item_,
        _TSCAssistanceInformation_iE_Extensions,
        TSCAssistanceInformation,
        TSCAssistanceInformation_ExtIEs,
        _TSCAssistanceInformation_ExtIEs_val_Extension_0,
        _TSCTrafficCharacteristics_tSCAssistanceInformationDL,
        _TSCTrafficCharacteristics_tSCAssistanceInformationUL,
        ____TSCTrafficCharacteristics_iE_Extensions__item__id_tab,
        ___TSCTrafficCharacteristics_iE_Extensions__item__id,
        ____TSCTrafficCharacteristics_iE_Extensions__item__criticality_tab,
        ___TSCTrafficCharacteristics_iE_Extensions__item__criticality,
        ____TSCTrafficCharacteristics_iE_Extensions__item__extensionValue_tab,
        ___TSCTrafficCharacteristics_iE_Extensions__item__extensionValue,
        __TSCTrafficCharacteristics_iE_Extensions__item_,
        _TSCTrafficCharacteristics_iE_Extensions,
        TSCTrafficCharacteristics,
        TSCTrafficCharacteristics_ExtIEs,
        _UEAggregateMaximumBitRate_uEAggregateMaximumBitRateDL,
        _UEAggregateMaximumBitRate_uEAggregateMaximumBitRateUL,
        ____UEAggregateMaximumBitRate_iE_Extensions__item__id_tab,
        ___UEAggregateMaximumBitRate_iE_Extensions__item__id,
        ____UEAggregateMaximumBitRate_iE_Extensions__item__criticality_tab,
        ___UEAggregateMaximumBitRate_iE_Extensions__item__criticality,
        ____UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue_tab,
        ___UEAggregateMaximumBitRate_iE_Extensions__item__extensionValue,
        __UEAggregateMaximumBitRate_iE_Extensions__item_,
        _UEAggregateMaximumBitRate_iE_Extensions,
        UEAggregateMaximumBitRate,
        UEAggregateMaximumBitRate_ExtIEs,
        _UEAppLayerMeasInfoList__item_,
        UEAppLayerMeasInfoList,
        _UEAppLayerMeasInfoItem_uEAppLayerMeasConfigInfo,
        ____UEAppLayerMeasInfoItem_iE_Extensions__item__id_tab,
        ___UEAppLayerMeasInfoItem_iE_Extensions__item__id,
        ____UEAppLayerMeasInfoItem_iE_Extensions__item__criticality_tab,
        ___UEAppLayerMeasInfoItem_iE_Extensions__item__criticality,
        ____UEAppLayerMeasInfoItem_iE_Extensions__item__extensionValue_tab,
        ___UEAppLayerMeasInfoItem_iE_Extensions__item__extensionValue,
        __UEAppLayerMeasInfoItem_iE_Extensions__item_,
        _UEAppLayerMeasInfoItem_iE_Extensions,
        UEAppLayerMeasInfoItem,
        UEAppLayerMeasInfoItem_ExtIEs,
        _UEAppLayerMeasConfigInfo_qoEReference,
        _UEAppLayerMeasConfigInfo_serviceType,
        _UEAppLayerMeasConfigInfo_areaScopeOfQMC,
        _UEAppLayerMeasConfigInfo_measCollEntityIPAddress,
        _UEAppLayerMeasConfigInfo_qoEMeasurementStatus,
        _UEAppLayerMeasConfigInfo_containerForAppLayerMeasConfig,
        _UEAppLayerMeasConfigInfo_measConfigAppLayerID,
        _UEAppLayerMeasConfigInfo_sliceSupportListQMC,
        _UEAppLayerMeasConfigInfo_mDT_AlignmentInfo,
        _UEAppLayerMeasConfigInfo_availableRANVisibleQoEMetrics,
        ____UEAppLayerMeasConfigInfo_iE_Extensions__item__id_tab,
        ___UEAppLayerMeasConfigInfo_iE_Extensions__item__id,
        ____UEAppLayerMeasConfigInfo_iE_Extensions__item__criticality_tab,
        ___UEAppLayerMeasConfigInfo_iE_Extensions__item__criticality,
        ____UEAppLayerMeasConfigInfo_iE_Extensions__item__extensionValue_tab,
        ___UEAppLayerMeasConfigInfo_iE_Extensions__item__extensionValue,
        __UEAppLayerMeasConfigInfo_iE_Extensions__item_,
        _UEAppLayerMeasConfigInfo_iE_Extensions,
        UEAppLayerMeasConfigInfo,
        UEAppLayerMeasConfigInfo_ExtIEs,
        _UE_associatedLogicalNG_connectionList__item_,
        UE_associatedLogicalNG_connectionList,
        _UE_associatedLogicalNG_connectionItem_aMF_UE_NGAP_ID,
        _UE_associatedLogicalNG_connectionItem_rAN_UE_NGAP_ID,
        ____UE_associatedLogicalNG_connectionItem_iE_Extensions__item__id_tab,
        ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__id,
        ____UE_associatedLogicalNG_connectionItem_iE_Extensions__item__criticality_tab,
        ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__criticality,
        ____UE_associatedLogicalNG_connectionItem_iE_Extensions__item__extensionValue_tab,
        ___UE_associatedLogicalNG_connectionItem_iE_Extensions__item__extensionValue,
        __UE_associatedLogicalNG_connectionItem_iE_Extensions__item_,
        _UE_associatedLogicalNG_connectionItem_iE_Extensions,
        UE_associatedLogicalNG_connectionItem,
        UE_associatedLogicalNG_connectionItem_ExtIEs,
        UECapabilityInfoRequest,
        UEContextRequest,
        _UEContextResumeRequestTransfer_qosFlowFailedToResumeList,
        ____UEContextResumeRequestTransfer_iE_Extensions__item__id_tab,
        ___UEContextResumeRequestTransfer_iE_Extensions__item__id,
        ____UEContextResumeRequestTransfer_iE_Extensions__item__criticality_tab,
        ___UEContextResumeRequestTransfer_iE_Extensions__item__criticality,
        ____UEContextResumeRequestTransfer_iE_Extensions__item__extensionValue_tab,
        ___UEContextResumeRequestTransfer_iE_Extensions__item__extensionValue,
        __UEContextResumeRequestTransfer_iE_Extensions__item_,
        _UEContextResumeRequestTransfer_iE_Extensions,
        UEContextResumeRequestTransfer,
        UEContextResumeRequestTransfer_ExtIEs,
        _UEContextResumeResponseTransfer_qosFlowFailedToResumeList,
        ____UEContextResumeResponseTransfer_iE_Extensions__item__id_tab,
        ___UEContextResumeResponseTransfer_iE_Extensions__item__id,
        ____UEContextResumeResponseTransfer_iE_Extensions__item__criticality_tab,
        ___UEContextResumeResponseTransfer_iE_Extensions__item__criticality,
        ____UEContextResumeResponseTransfer_iE_Extensions__item__extensionValue_tab,
        ___UEContextResumeResponseTransfer_iE_Extensions__item__extensionValue,
        __UEContextResumeResponseTransfer_iE_Extensions__item_,
        _UEContextResumeResponseTransfer_iE_Extensions,
        UEContextResumeResponseTransfer,
        UEContextResumeResponseTransfer_ExtIEs,
        _UEContextSuspendRequestTransfer_suspendIndicator,
        ____UEContextSuspendRequestTransfer_iE_Extensions__item__id_tab,
        ___UEContextSuspendRequestTransfer_iE_Extensions__item__id,
        ____UEContextSuspendRequestTransfer_iE_Extensions__item__criticality_tab,
        ___UEContextSuspendRequestTransfer_iE_Extensions__item__criticality,
        ____UEContextSuspendRequestTransfer_iE_Extensions__item__extensionValue_tab,
        ___UEContextSuspendRequestTransfer_iE_Extensions__item__extensionValue,
        __UEContextSuspendRequestTransfer_iE_Extensions__item_,
        _UEContextSuspendRequestTransfer_iE_Extensions,
        UEContextSuspendRequestTransfer,
        UEContextSuspendRequestTransfer_ExtIEs,
        _UE_DifferentiationInfo_periodicCommunicationIndicator,
        _UE_DifferentiationInfo_periodicTime,
        _UE_DifferentiationInfo_scheduledCommunicationTime,
        _UE_DifferentiationInfo_stationaryIndication,
        _UE_DifferentiationInfo_trafficProfile,
        _UE_DifferentiationInfo_batteryIndication,
        ____UE_DifferentiationInfo_iE_Extensions__item__id_tab,
        ___UE_DifferentiationInfo_iE_Extensions__item__id,
        ____UE_DifferentiationInfo_iE_Extensions__item__criticality_tab,
        ___UE_DifferentiationInfo_iE_Extensions__item__criticality,
        ____UE_DifferentiationInfo_iE_Extensions__item__extensionValue_tab,
        ___UE_DifferentiationInfo_iE_Extensions__item__extensionValue,
        __UE_DifferentiationInfo_iE_Extensions__item_,
        _UE_DifferentiationInfo_iE_Extensions,
        UE_DifferentiationInfo,
        UE_DifferentiationInfo_ExtIEs,
        _UEHistoryInformation__item_,
        UEHistoryInformation,
        _UEHistoryInformationFromTheUE_nR,
        ___UEHistoryInformationFromTheUE_choice_Extensions_id_tab,
        __UEHistoryInformationFromTheUE_choice_Extensions_id,
        ___UEHistoryInformationFromTheUE_choice_Extensions_criticality_tab,
        __UEHistoryInformationFromTheUE_choice_Extensions_criticality,
        ___UEHistoryInformationFromTheUE_choice_Extensions_value_tab,
        __UEHistoryInformationFromTheUE_choice_Extensions_value,
        _UEHistoryInformationFromTheUE_choice_Extensions,
        UEHistoryInformationFromTheUE,
        UEHistoryInformationFromTheUE_ExtIEs,
        _UEIdentityIndexValue_indexLength10,
        ___UEIdentityIndexValue_choice_Extensions_id_tab,
        __UEIdentityIndexValue_choice_Extensions_id,
        ___UEIdentityIndexValue_choice_Extensions_criticality_tab,
        __UEIdentityIndexValue_choice_Extensions_criticality,
        ___UEIdentityIndexValue_choice_Extensions_value_tab,
        __UEIdentityIndexValue_choice_Extensions_value,
        _UEIdentityIndexValue_choice_Extensions,
        UEIdentityIndexValue,
        UEIdentityIndexValue_ExtIEs,
        _UE_NGAP_IDs_uE_NGAP_ID_pair,
        _UE_NGAP_IDs_aMF_UE_NGAP_ID,
        ___UE_NGAP_IDs_choice_Extensions_id_tab,
        __UE_NGAP_IDs_choice_Extensions_id,
        ___UE_NGAP_IDs_choice_Extensions_criticality_tab,
        __UE_NGAP_IDs_choice_Extensions_criticality,
        ___UE_NGAP_IDs_choice_Extensions_value_tab,
        __UE_NGAP_IDs_choice_Extensions_value,
        _UE_NGAP_IDs_choice_Extensions,
        UE_NGAP_IDs,
        UE_NGAP_IDs_ExtIEs,
        _UE_NGAP_ID_pair_aMF_UE_NGAP_ID,
        _UE_NGAP_ID_pair_rAN_UE_NGAP_ID,
        ____UE_NGAP_ID_pair_iE_Extensions__item__id_tab,
        ___UE_NGAP_ID_pair_iE_Extensions__item__id,
        ____UE_NGAP_ID_pair_iE_Extensions__item__criticality_tab,
        ___UE_NGAP_ID_pair_iE_Extensions__item__criticality,
        ____UE_NGAP_ID_pair_iE_Extensions__item__extensionValue_tab,
        ___UE_NGAP_ID_pair_iE_Extensions__item__extensionValue,
        __UE_NGAP_ID_pair_iE_Extensions__item_,
        _UE_NGAP_ID_pair_iE_Extensions,
        UE_NGAP_ID_pair,
        UE_NGAP_ID_pair_ExtIEs,
        _UEPagingIdentity_fiveG_S_TMSI,
        ___UEPagingIdentity_choice_Extensions_id_tab,
        __UEPagingIdentity_choice_Extensions_id,
        ___UEPagingIdentity_choice_Extensions_criticality_tab,
        __UEPagingIdentity_choice_Extensions_criticality,
        ___UEPagingIdentity_choice_Extensions_value_tab,
        __UEPagingIdentity_choice_Extensions_value,
        _UEPagingIdentity_choice_Extensions,
        UEPagingIdentity,
        UEPagingIdentity_ExtIEs,
        UEPresence,
        _UEPresenceInAreaOfInterestList__item_,
        UEPresenceInAreaOfInterestList,
        _UEPresenceInAreaOfInterestItem_locationReportingReferenceID,
        _UEPresenceInAreaOfInterestItem_uEPresence,
        ____UEPresenceInAreaOfInterestItem_iE_Extensions__item__id_tab,
        ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__id,
        ____UEPresenceInAreaOfInterestItem_iE_Extensions__item__criticality_tab,
        ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__criticality,
        ____UEPresenceInAreaOfInterestItem_iE_Extensions__item__extensionValue_tab,
        ___UEPresenceInAreaOfInterestItem_iE_Extensions__item__extensionValue,
        __UEPresenceInAreaOfInterestItem_iE_Extensions__item_,
        _UEPresenceInAreaOfInterestItem_iE_Extensions,
        UEPresenceInAreaOfInterestItem,
        UEPresenceInAreaOfInterestItem_ExtIEs,
        UERadioCapability,
        _UERadioCapabilityForPaging_uERadioCapabilityForPagingOfNR,
        _UERadioCapabilityForPaging_uERadioCapabilityForPagingOfEUTRA,
        ____UERadioCapabilityForPaging_iE_Extensions__item__id_tab,
        _____UERadioCapabilityForPaging_iE_Extensions__item__id_tab_val_Extension_0,
        ___UERadioCapabilityForPaging_iE_Extensions__item__id,
        ___UERadioCapabilityForPaging_iE_Extensions__item__criticality,
        ___UERadioCapabilityForPaging_iE_Extensions__item__extensionValue,
        __UERadioCapabilityForPaging_iE_Extensions__item_,
        _UERadioCapabilityForPaging_iE_Extensions,
        UERadioCapabilityForPaging,
        UERadioCapabilityForPaging_ExtIEs,
        _UERadioCapabilityForPaging_ExtIEs_val_Extension_0,
        UERadioCapabilityForPagingOfNB_IoT,
        UERadioCapabilityForPagingOfNR,
        UERadioCapabilityForPagingOfEUTRA,
        UERadioCapabilityID,
        UERetentionInformation,
        _UERLFReportContainer_nR,
        _UERLFReportContainer_lTE,
        ___UERLFReportContainer_choice_Extensions_id_tab,
        __UERLFReportContainer_choice_Extensions_id,
        ___UERLFReportContainer_choice_Extensions_criticality_tab,
        __UERLFReportContainer_choice_Extensions_criticality,
        ___UERLFReportContainer_choice_Extensions_value_tab,
        __UERLFReportContainer_choice_Extensions_value,
        _UERLFReportContainer_choice_Extensions,
        UERLFReportContainer,
        UERLFReportContainer_ExtIEs,
        _UESecurityCapabilities_nRencryptionAlgorithms,
        _UESecurityCapabilities_nRintegrityProtectionAlgorithms,
        _UESecurityCapabilities_eUTRAencryptionAlgorithms,
        _UESecurityCapabilities_eUTRAintegrityProtectionAlgorithms,
        ____UESecurityCapabilities_iE_Extensions__item__id_tab,
        ___UESecurityCapabilities_iE_Extensions__item__id,
        ____UESecurityCapabilities_iE_Extensions__item__criticality_tab,
        ___UESecurityCapabilities_iE_Extensions__item__criticality,
        ____UESecurityCapabilities_iE_Extensions__item__extensionValue_tab,
        ___UESecurityCapabilities_iE_Extensions__item__extensionValue,
        __UESecurityCapabilities_iE_Extensions__item_,
        _UESecurityCapabilities_iE_Extensions,
        UESecurityCapabilities,
        UESecurityCapabilities_ExtIEs,
        _UESliceMaximumBitRateList__item_,
        UESliceMaximumBitRateList,
        _UESliceMaximumBitRateItem_s_NSSAI,
        _UESliceMaximumBitRateItem_uESliceMaximumBitRateDL,
        _UESliceMaximumBitRateItem_uESliceMaximumBitRateUL,
        ____UESliceMaximumBitRateItem_iE_Extensions__item__id_tab,
        ___UESliceMaximumBitRateItem_iE_Extensions__item__id,
        ____UESliceMaximumBitRateItem_iE_Extensions__item__criticality_tab,
        ___UESliceMaximumBitRateItem_iE_Extensions__item__criticality,
        ____UESliceMaximumBitRateItem_iE_Extensions__item__extensionValue_tab,
        ___UESliceMaximumBitRateItem_iE_Extensions__item__extensionValue,
        __UESliceMaximumBitRateItem_iE_Extensions__item_,
        _UESliceMaximumBitRateItem_iE_Extensions,
        UESliceMaximumBitRateItem,
        UESliceMaximumBitRateItem_ExtIEs,
        UE_UP_CIoT_Support,
        _UL_CP_SecurityInformation_ul_NAS_MAC,
        _UL_CP_SecurityInformation_ul_NAS_Count,
        ____UL_CP_SecurityInformation_iE_Extensions__item__id_tab,
        ___UL_CP_SecurityInformation_iE_Extensions__item__id,
        ____UL_CP_SecurityInformation_iE_Extensions__item__criticality_tab,
        ___UL_CP_SecurityInformation_iE_Extensions__item__criticality,
        ____UL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab,
        ___UL_CP_SecurityInformation_iE_Extensions__item__extensionValue,
        __UL_CP_SecurityInformation_iE_Extensions__item_,
        _UL_CP_SecurityInformation_iE_Extensions,
        UL_CP_SecurityInformation,
        UL_CP_SecurityInformation_ExtIEs,
        UL_NAS_MAC,
        UL_NAS_Count,
        _UL_NGU_UP_TNLModifyList__item_,
        UL_NGU_UP_TNLModifyList,
        _UL_NGU_UP_TNLModifyItem_uL_NGU_UP_TNLInformation,
        _UL_NGU_UP_TNLModifyItem_dL_NGU_UP_TNLInformation,
        ____UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id_tab,
        _____UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id_tab_val_Extension_1,
        ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__id,
        ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__criticality,
        ___UL_NGU_UP_TNLModifyItem_iE_Extensions__item__extensionValue,
        __UL_NGU_UP_TNLModifyItem_iE_Extensions__item_,
        _UL_NGU_UP_TNLModifyItem_iE_Extensions,
        UL_NGU_UP_TNLModifyItem,
        UL_NGU_UP_TNLModifyItem_ExtIEs,
        _UL_NGU_UP_TNLModifyItem_ExtIEs_val_Extension_0,
        _UL_NGU_UP_TNLModifyItem_ExtIEs_val_Extension_1,
        _UnavailableGUAMIList__item_,
        UnavailableGUAMIList,
        _UnavailableGUAMIItem_gUAMI,
        _UnavailableGUAMIItem_timerApproachForGUAMIRemoval,
        _UnavailableGUAMIItem_backupAMFName,
        ____UnavailableGUAMIItem_iE_Extensions__item__id_tab,
        ___UnavailableGUAMIItem_iE_Extensions__item__id,
        ____UnavailableGUAMIItem_iE_Extensions__item__criticality_tab,
        ___UnavailableGUAMIItem_iE_Extensions__item__criticality,
        ____UnavailableGUAMIItem_iE_Extensions__item__extensionValue_tab,
        ___UnavailableGUAMIItem_iE_Extensions__item__extensionValue,
        __UnavailableGUAMIItem_iE_Extensions__item_,
        _UnavailableGUAMIItem_iE_Extensions,
        UnavailableGUAMIItem,
        UnavailableGUAMIItem_ExtIEs,
        ULForwarding,
        UpdateFeedback,
        _UPTransportLayerInformation_gTPTunnel,
        ___UPTransportLayerInformation_choice_Extensions_id_tab,
        __UPTransportLayerInformation_choice_Extensions_id,
        ___UPTransportLayerInformation_choice_Extensions_criticality_tab,
        __UPTransportLayerInformation_choice_Extensions_criticality,
        ___UPTransportLayerInformation_choice_Extensions_value_tab,
        __UPTransportLayerInformation_choice_Extensions_value,
        _UPTransportLayerInformation_choice_Extensions,
        UPTransportLayerInformation,
        UPTransportLayerInformation_ExtIEs,
        _UPTransportLayerInformationList__item_,
        UPTransportLayerInformationList,
        _UPTransportLayerInformationItem_nGU_UP_TNLInformation,
        ____UPTransportLayerInformationItem_iE_Extensions__item__id_tab,
        _____UPTransportLayerInformationItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___UPTransportLayerInformationItem_iE_Extensions__item__id,
        ___UPTransportLayerInformationItem_iE_Extensions__item__criticality,
        ___UPTransportLayerInformationItem_iE_Extensions__item__extensionValue,
        __UPTransportLayerInformationItem_iE_Extensions__item_,
        _UPTransportLayerInformationItem_iE_Extensions,
        UPTransportLayerInformationItem,
        UPTransportLayerInformationItem_ExtIEs,
        _UPTransportLayerInformationItem_ExtIEs_val_Extension_0,
        _UPTransportLayerInformationPairList__item_,
        UPTransportLayerInformationPairList,
        _UPTransportLayerInformationPairItem_uL_NGU_UP_TNLInformation,
        _UPTransportLayerInformationPairItem_dL_NGU_UP_TNLInformation,
        ____UPTransportLayerInformationPairItem_iE_Extensions__item__id_tab,
        ___UPTransportLayerInformationPairItem_iE_Extensions__item__id,
        ____UPTransportLayerInformationPairItem_iE_Extensions__item__criticality_tab,
        ___UPTransportLayerInformationPairItem_iE_Extensions__item__criticality,
        ____UPTransportLayerInformationPairItem_iE_Extensions__item__extensionValue_tab,
        ___UPTransportLayerInformationPairItem_iE_Extensions__item__extensionValue,
        __UPTransportLayerInformationPairItem_iE_Extensions__item_,
        _UPTransportLayerInformationPairItem_iE_Extensions,
        UPTransportLayerInformationPairItem,
        UPTransportLayerInformationPairItem_ExtIEs,
        URI_address,
        _UserLocationInformation_userLocationInformationEUTRA,
        _UserLocationInformation_userLocationInformationNR,
        _UserLocationInformation_userLocationInformationN3IWF,
        ___UserLocationInformation_choice_Extensions_id_tab,
        ____UserLocationInformation_choice_Extensions_id_tab_val_Value_0,
        ____UserLocationInformation_choice_Extensions_id_tab_val_Value_1,
        ____UserLocationInformation_choice_Extensions_id_tab_val_Value_2,
        __UserLocationInformation_choice_Extensions_id,
        __UserLocationInformation_choice_Extensions_criticality,
        __UserLocationInformation_choice_Extensions_value,
        _UserLocationInformation_choice_Extensions,
        UserLocationInformation,
        UserLocationInformation_ExtIEs,
        _UserLocationInformation_ExtIEs_val_Value_0,
        _UserLocationInformation_ExtIEs_val_Value_1,
        _UserLocationInformation_ExtIEs_val_Value_2,
        _UserLocationInformationEUTRA_eUTRA_CGI,
        _UserLocationInformationEUTRA_tAI,
        _UserLocationInformationEUTRA_timeStamp,
        ____UserLocationInformationEUTRA_iE_Extensions__item__id_tab,
        _____UserLocationInformationEUTRA_iE_Extensions__item__id_tab_val_Extension_0,
        ___UserLocationInformationEUTRA_iE_Extensions__item__id,
        ___UserLocationInformationEUTRA_iE_Extensions__item__criticality,
        ___UserLocationInformationEUTRA_iE_Extensions__item__extensionValue,
        __UserLocationInformationEUTRA_iE_Extensions__item_,
        _UserLocationInformationEUTRA_iE_Extensions,
        UserLocationInformationEUTRA,
        UserLocationInformationEUTRA_ExtIEs,
        _UserLocationInformationEUTRA_ExtIEs_val_Extension_0,
        _UserLocationInformationN3IWF_iPAddress,
        _UserLocationInformationN3IWF_portNumber,
        ____UserLocationInformationN3IWF_iE_Extensions__item__id_tab,
        _____UserLocationInformationN3IWF_iE_Extensions__item__id_tab_val_Extension_0,
        ___UserLocationInformationN3IWF_iE_Extensions__item__id,
        ___UserLocationInformationN3IWF_iE_Extensions__item__criticality,
        ___UserLocationInformationN3IWF_iE_Extensions__item__extensionValue,
        __UserLocationInformationN3IWF_iE_Extensions__item_,
        _UserLocationInformationN3IWF_iE_Extensions,
        UserLocationInformationN3IWF,
        UserLocationInformationN3IWF_ExtIEs,
        _UserLocationInformationN3IWF_ExtIEs_val_Extension_0,
        _UserLocationInformationTNGF_tNAP_ID,
        _UserLocationInformationTNGF_iPAddress,
        _UserLocationInformationTNGF_portNumber,
        ____UserLocationInformationTNGF_iE_Extensions__item__id_tab,
        _____UserLocationInformationTNGF_iE_Extensions__item__id_tab_val_Extension_0,
        ___UserLocationInformationTNGF_iE_Extensions__item__id,
        ___UserLocationInformationTNGF_iE_Extensions__item__criticality,
        ___UserLocationInformationTNGF_iE_Extensions__item__extensionValue,
        __UserLocationInformationTNGF_iE_Extensions__item_,
        _UserLocationInformationTNGF_iE_Extensions,
        UserLocationInformationTNGF,
        UserLocationInformationTNGF_ExtIEs,
        _UserLocationInformationTNGF_ExtIEs_val_Extension_0,
        _UserLocationInformationTWIF_tWAP_ID,
        _UserLocationInformationTWIF_iPAddress,
        _UserLocationInformationTWIF_portNumber,
        ____UserLocationInformationTWIF_iE_Extensions__item__id_tab,
        _____UserLocationInformationTWIF_iE_Extensions__item__id_tab_val_Extension_0,
        ___UserLocationInformationTWIF_iE_Extensions__item__id,
        ___UserLocationInformationTWIF_iE_Extensions__item__criticality,
        ___UserLocationInformationTWIF_iE_Extensions__item__extensionValue,
        __UserLocationInformationTWIF_iE_Extensions__item_,
        _UserLocationInformationTWIF_iE_Extensions,
        UserLocationInformationTWIF,
        UserLocationInformationTWIF_ExtIEs,
        _UserLocationInformationTWIF_ExtIEs_val_Extension_0,
        _UserLocationInformationW_AGF_globalLine_ID,
        _UserLocationInformationW_AGF_hFCNode_ID,
        ___UserLocationInformationW_AGF_choice_Extensions_id_tab,
        ____UserLocationInformationW_AGF_choice_Extensions_id_tab_val_Value_0,
        ____UserLocationInformationW_AGF_choice_Extensions_id_tab_val_Value_1,
        ____UserLocationInformationW_AGF_choice_Extensions_id_tab_val_Value_2,
        __UserLocationInformationW_AGF_choice_Extensions_id,
        __UserLocationInformationW_AGF_choice_Extensions_criticality,
        __UserLocationInformationW_AGF_choice_Extensions_value,
        _UserLocationInformationW_AGF_choice_Extensions,
        UserLocationInformationW_AGF,
        UserLocationInformationW_AGF_ExtIEs,
        _UserLocationInformationW_AGF_ExtIEs_val_Value_0,
        _UserLocationInformationW_AGF_ExtIEs_val_Value_1,
        _UserLocationInformationW_AGF_ExtIEs_val_Value_2,
        _UserLocationInformationNR_nR_CGI,
        _UserLocationInformationNR_tAI,
        _UserLocationInformationNR_timeStamp,
        ____UserLocationInformationNR_iE_Extensions__item__id_tab,
        _____UserLocationInformationNR_iE_Extensions__item__id_tab_val_Extension_0,
        _____UserLocationInformationNR_iE_Extensions__item__id_tab_val_Extension_1,
        _____UserLocationInformationNR_iE_Extensions__item__id_tab_val_Extension_2,
        ___UserLocationInformationNR_iE_Extensions__item__id,
        ___UserLocationInformationNR_iE_Extensions__item__criticality,
        ___UserLocationInformationNR_iE_Extensions__item__extensionValue,
        __UserLocationInformationNR_iE_Extensions__item_,
        _UserLocationInformationNR_iE_Extensions,
        UserLocationInformationNR,
        UserLocationInformationNR_ExtIEs,
        _UserLocationInformationNR_ExtIEs_val_Extension_0,
        _UserLocationInformationNR_ExtIEs_val_Extension_1,
        _UserLocationInformationNR_ExtIEs_val_Extension_2,
        _UserPlaneSecurityInformation_securityResult,
        _UserPlaneSecurityInformation_securityIndication,
        ____UserPlaneSecurityInformation_iE_Extensions__item__id_tab,
        ___UserPlaneSecurityInformation_iE_Extensions__item__id,
        ____UserPlaneSecurityInformation_iE_Extensions__item__criticality_tab,
        ___UserPlaneSecurityInformation_iE_Extensions__item__criticality,
        ____UserPlaneSecurityInformation_iE_Extensions__item__extensionValue_tab,
        ___UserPlaneSecurityInformation_iE_Extensions__item__extensionValue,
        __UserPlaneSecurityInformation_iE_Extensions__item_,
        _UserPlaneSecurityInformation_iE_Extensions,
        UserPlaneSecurityInformation,
        UserPlaneSecurityInformation_ExtIEs,
        _VolumeTimedReportList__item_,
        VolumeTimedReportList,
        _VolumeTimedReport_Item_startTimeStamp,
        _VolumeTimedReport_Item_endTimeStamp,
        _VolumeTimedReport_Item_usageCountUL,
        _VolumeTimedReport_Item_usageCountDL,
        ____VolumeTimedReport_Item_iE_Extensions__item__id_tab,
        ___VolumeTimedReport_Item_iE_Extensions__item__id,
        ____VolumeTimedReport_Item_iE_Extensions__item__criticality_tab,
        ___VolumeTimedReport_Item_iE_Extensions__item__criticality,
        ____VolumeTimedReport_Item_iE_Extensions__item__extensionValue_tab,
        ___VolumeTimedReport_Item_iE_Extensions__item__extensionValue,
        __VolumeTimedReport_Item_iE_Extensions__item_,
        _VolumeTimedReport_Item_iE_Extensions,
        VolumeTimedReport_Item,
        VolumeTimedReport_Item_ExtIEs,
        _W_AGF_ID_w_AGF_ID,
        ___W_AGF_ID_choice_Extensions_id_tab,
        __W_AGF_ID_choice_Extensions_id,
        ___W_AGF_ID_choice_Extensions_criticality_tab,
        __W_AGF_ID_choice_Extensions_criticality,
        ___W_AGF_ID_choice_Extensions_value_tab,
        __W_AGF_ID_choice_Extensions_value,
        _W_AGF_ID_choice_Extensions,
        W_AGF_ID,
        W_AGF_ID_ExtIEs,
        WarningAreaCoordinates,
        _WarningAreaList_eUTRA_CGIListForWarning,
        _WarningAreaList_nR_CGIListForWarning,
        _WarningAreaList_tAIListForWarning,
        _WarningAreaList_emergencyAreaIDList,
        ___WarningAreaList_choice_Extensions_id_tab,
        __WarningAreaList_choice_Extensions_id,
        ___WarningAreaList_choice_Extensions_criticality_tab,
        __WarningAreaList_choice_Extensions_criticality,
        ___WarningAreaList_choice_Extensions_value_tab,
        __WarningAreaList_choice_Extensions_value,
        _WarningAreaList_choice_Extensions,
        WarningAreaList,
        WarningAreaList_ExtIEs,
        WarningMessageContents,
        WarningSecurityInfo,
        WarningType,
        _WLANMeasurementConfiguration_wlanMeasConfig,
        _WLANMeasurementConfiguration_wlanMeasConfigNameList,
        _WLANMeasurementConfiguration_wlan_rssi,
        _WLANMeasurementConfiguration_wlan_rtt,
        ____WLANMeasurementConfiguration_iE_Extensions__item__id_tab,
        ___WLANMeasurementConfiguration_iE_Extensions__item__id,
        ____WLANMeasurementConfiguration_iE_Extensions__item__criticality_tab,
        ___WLANMeasurementConfiguration_iE_Extensions__item__criticality,
        ____WLANMeasurementConfiguration_iE_Extensions__item__extensionValue_tab,
        ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue,
        __WLANMeasurementConfiguration_iE_Extensions__item_,
        _WLANMeasurementConfiguration_iE_Extensions,
        WLANMeasurementConfiguration,
        WLANMeasurementConfiguration_ExtIEs,
        _WLANMeasConfigNameList__item_,
        WLANMeasConfigNameList,
        _WLANMeasConfigNameItem_wLANName,
        ____WLANMeasConfigNameItem_iE_Extensions__item__id_tab,
        ___WLANMeasConfigNameItem_iE_Extensions__item__id,
        ____WLANMeasConfigNameItem_iE_Extensions__item__criticality_tab,
        ___WLANMeasConfigNameItem_iE_Extensions__item__criticality,
        ____WLANMeasConfigNameItem_iE_Extensions__item__extensionValue_tab,
        ___WLANMeasConfigNameItem_iE_Extensions__item__extensionValue,
        __WLANMeasConfigNameItem_iE_Extensions__item_,
        _WLANMeasConfigNameItem_iE_Extensions,
        WLANMeasConfigNameItem,
        WLANMeasConfigNameItem_ExtIEs,
        WLANMeasConfig,
        WLANName,
        _WUS_Assistance_Information_pagingProbabilityInformation,
        ____WUS_Assistance_Information_iE_Extensions__item__id_tab,
        ___WUS_Assistance_Information_iE_Extensions__item__id,
        ____WUS_Assistance_Information_iE_Extensions__item__criticality_tab,
        ___WUS_Assistance_Information_iE_Extensions__item__criticality,
        ____WUS_Assistance_Information_iE_Extensions__item__extensionValue_tab,
        ___WUS_Assistance_Information_iE_Extensions__item__extensionValue,
        __WUS_Assistance_Information_iE_Extensions__item_,
        _WUS_Assistance_Information_iE_Extensions,
        WUS_Assistance_Information,
        WUS_Assistance_Information_ExtIEs,
        _XnExtTLAs__item_,
        XnExtTLAs,
        _XnExtTLA_Item_iPsecTLA,
        _XnExtTLA_Item_gTP_TLAs,
        ____XnExtTLA_Item_iE_Extensions__item__id_tab,
        _____XnExtTLA_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___XnExtTLA_Item_iE_Extensions__item__id,
        ___XnExtTLA_Item_iE_Extensions__item__criticality,
        ___XnExtTLA_Item_iE_Extensions__item__extensionValue,
        __XnExtTLA_Item_iE_Extensions__item_,
        _XnExtTLA_Item_iE_Extensions,
        XnExtTLA_Item,
        XnExtTLA_Item_ExtIEs,
        _XnExtTLA_Item_ExtIEs_val_Extension_0,
        _XnGTP_TLAs__item_,
        XnGTP_TLAs,
        _XnTLAs__item_,
        XnTLAs,
        _XnTNLConfigurationInfo_xnTransportLayerAddresses,
        _XnTNLConfigurationInfo_xnExtendedTransportLayerAddresses,
        ____XnTNLConfigurationInfo_iE_Extensions__item__id_tab,
        ___XnTNLConfigurationInfo_iE_Extensions__item__id,
        ____XnTNLConfigurationInfo_iE_Extensions__item__criticality_tab,
        ___XnTNLConfigurationInfo_iE_Extensions__item__criticality,
        ____XnTNLConfigurationInfo_iE_Extensions__item__extensionValue_tab,
        ___XnTNLConfigurationInfo_iE_Extensions__item__extensionValue,
        __XnTNLConfigurationInfo_iE_Extensions__item_,
        _XnTNLConfigurationInfo_iE_Extensions,
        XnTNLConfigurationInfo,
        XnTNLConfigurationInfo_ExtIEs,
    ]

class NGAP_PDU_Contents:

    _name_  = 'NGAP-PDU-Contents'
    _oid_   = [0, 4, 0, 0, 22, 3, 1, 1, 1]
    
    _obj_ = [
        'PDUSessionResourceSetupRequest',
        'PDUSessionResourceSetupRequestIEs',
        'PDUSessionResourceSetupResponse',
        'PDUSessionResourceSetupResponseIEs',
        'PDUSessionResourceReleaseCommand',
        'PDUSessionResourceReleaseCommandIEs',
        'PDUSessionResourceReleaseResponse',
        'PDUSessionResourceReleaseResponseIEs',
        'PDUSessionResourceModifyRequest',
        'PDUSessionResourceModifyRequestIEs',
        'PDUSessionResourceModifyResponse',
        'PDUSessionResourceModifyResponseIEs',
        'PDUSessionResourceNotify',
        'PDUSessionResourceNotifyIEs',
        'PDUSessionResourceModifyIndication',
        'PDUSessionResourceModifyIndicationIEs',
        'PDUSessionResourceModifyConfirm',
        'PDUSessionResourceModifyConfirmIEs',
        'InitialContextSetupRequest',
        'InitialContextSetupRequestIEs',
        'InitialContextSetupResponse',
        'InitialContextSetupResponseIEs',
        'InitialContextSetupFailure',
        'InitialContextSetupFailureIEs',
        'UEContextReleaseRequest',
        'UEContextReleaseRequest-IEs',
        'UEContextReleaseCommand',
        'UEContextReleaseCommand-IEs',
        'UEContextReleaseComplete',
        'UEContextReleaseComplete-IEs',
        'UEContextResumeRequest',
        'UEContextResumeRequestIEs',
        'UEContextResumeResponse',
        'UEContextResumeResponseIEs',
        'UEContextResumeFailure',
        'UEContextResumeFailureIEs',
        'UEContextSuspendRequest',
        'UEContextSuspendRequestIEs',
        'UEContextSuspendResponse',
        'UEContextSuspendResponseIEs',
        'UEContextSuspendFailure',
        'UEContextSuspendFailureIEs',
        'UEContextModificationRequest',
        'UEContextModificationRequestIEs',
        'UEContextModificationResponse',
        'UEContextModificationResponseIEs',
        'UEContextModificationFailure',
        'UEContextModificationFailureIEs',
        'RRCInactiveTransitionReport',
        'RRCInactiveTransitionReportIEs',
        'RetrieveUEInformation',
        'RetrieveUEInformationIEs',
        'UEInformationTransfer',
        'UEInformationTransferIEs',
        'RANCPRelocationIndication',
        'RANCPRelocationIndicationIEs',
        'HandoverRequired',
        'HandoverRequiredIEs',
        'HandoverCommand',
        'HandoverCommandIEs',
        'HandoverPreparationFailure',
        'HandoverPreparationFailureIEs',
        'HandoverRequest',
        'HandoverRequestIEs',
        'HandoverRequestAcknowledge',
        'HandoverRequestAcknowledgeIEs',
        'HandoverFailure',
        'HandoverFailureIEs',
        'HandoverNotify',
        'HandoverNotifyIEs',
        'PathSwitchRequest',
        'PathSwitchRequestIEs',
        'PathSwitchRequestAcknowledge',
        'PathSwitchRequestAcknowledgeIEs',
        'PathSwitchRequestFailure',
        'PathSwitchRequestFailureIEs',
        'HandoverCancel',
        'HandoverCancelIEs',
        'HandoverCancelAcknowledge',
        'HandoverCancelAcknowledgeIEs',
        'HandoverSuccess',
        'HandoverSuccessIEs',
        'UplinkRANEarlyStatusTransfer',
        'UplinkRANEarlyStatusTransferIEs',
        'DownlinkRANEarlyStatusTransfer',
        'DownlinkRANEarlyStatusTransferIEs',
        'UplinkRANStatusTransfer',
        'UplinkRANStatusTransferIEs',
        'DownlinkRANStatusTransfer',
        'DownlinkRANStatusTransferIEs',
        'Paging',
        'PagingIEs',
        'InitialUEMessage',
        'InitialUEMessage-IEs',
        'DownlinkNASTransport',
        'DownlinkNASTransport-IEs',
        'UplinkNASTransport',
        'UplinkNASTransport-IEs',
        'NASNonDeliveryIndication',
        'NASNonDeliveryIndication-IEs',
        'RerouteNASRequest',
        'RerouteNASRequest-IEs',
        'NGSetupRequest',
        'NGSetupRequestIEs',
        'NGSetupResponse',
        'NGSetupResponseIEs',
        'NGSetupFailure',
        'NGSetupFailureIEs',
        'RANConfigurationUpdate',
        'RANConfigurationUpdateIEs',
        'RANConfigurationUpdateAcknowledge',
        'RANConfigurationUpdateAcknowledgeIEs',
        'RANConfigurationUpdateFailure',
        'RANConfigurationUpdateFailureIEs',
        'AMFConfigurationUpdate',
        'AMFConfigurationUpdateIEs',
        'AMFConfigurationUpdateAcknowledge',
        'AMFConfigurationUpdateAcknowledgeIEs',
        'AMFConfigurationUpdateFailure',
        'AMFConfigurationUpdateFailureIEs',
        'AMFStatusIndication',
        'AMFStatusIndicationIEs',
        'NGReset',
        'NGResetIEs',
        'NGResetAcknowledge',
        'NGResetAcknowledgeIEs',
        'ErrorIndication',
        'ErrorIndicationIEs',
        'OverloadStart',
        'OverloadStartIEs',
        'OverloadStop',
        'OverloadStopIEs',
        'UplinkRANConfigurationTransfer',
        'UplinkRANConfigurationTransferIEs',
        'DownlinkRANConfigurationTransfer',
        'DownlinkRANConfigurationTransferIEs',
        'WriteReplaceWarningRequest',
        'WriteReplaceWarningRequestIEs',
        'WriteReplaceWarningResponse',
        'WriteReplaceWarningResponseIEs',
        'PWSCancelRequest',
        'PWSCancelRequestIEs',
        'PWSCancelResponse',
        'PWSCancelResponseIEs',
        'PWSRestartIndication',
        'PWSRestartIndicationIEs',
        'PWSFailureIndication',
        'PWSFailureIndicationIEs',
        'DownlinkUEAssociatedNRPPaTransport',
        'DownlinkUEAssociatedNRPPaTransportIEs',
        'UplinkUEAssociatedNRPPaTransport',
        'UplinkUEAssociatedNRPPaTransportIEs',
        'DownlinkNonUEAssociatedNRPPaTransport',
        'DownlinkNonUEAssociatedNRPPaTransportIEs',
        'UplinkNonUEAssociatedNRPPaTransport',
        'UplinkNonUEAssociatedNRPPaTransportIEs',
        'TraceStart',
        'TraceStartIEs',
        'TraceFailureIndication',
        'TraceFailureIndicationIEs',
        'DeactivateTrace',
        'DeactivateTraceIEs',
        'CellTrafficTrace',
        'CellTrafficTraceIEs',
        'LocationReportingControl',
        'LocationReportingControlIEs',
        'LocationReportingFailureIndication',
        'LocationReportingFailureIndicationIEs',
        'LocationReport',
        'LocationReportIEs',
        'UETNLABindingReleaseRequest',
        'UETNLABindingReleaseRequestIEs',
        'UERadioCapabilityInfoIndication',
        'UERadioCapabilityInfoIndicationIEs',
        'UERadioCapabilityCheckRequest',
        'UERadioCapabilityCheckRequestIEs',
        'UERadioCapabilityCheckResponse',
        'UERadioCapabilityCheckResponseIEs',
        'PrivateMessage',
        'PrivateMessageIEs',
        'SecondaryRATDataUsageReport',
        'SecondaryRATDataUsageReportIEs',
        'UplinkRIMInformationTransfer',
        'UplinkRIMInformationTransferIEs',
        'DownlinkRIMInformationTransfer',
        'DownlinkRIMInformationTransferIEs',
        'ConnectionEstablishmentIndication',
        'ConnectionEstablishmentIndicationIEs',
        'UERadioCapabilityIDMappingRequest',
        'UERadioCapabilityIDMappingRequestIEs',
        'UERadioCapabilityIDMappingResponse',
        'UERadioCapabilityIDMappingResponseIEs',
        'AMFCPRelocationIndication',
        'AMFCPRelocationIndicationIEs',
        'BroadcastSessionSetupRequest',
        'BroadcastSessionSetupRequestIEs',
        'BroadcastSessionSetupResponse',
        'BroadcastSessionSetupResponseIEs',
        'BroadcastSessionSetupFailure',
        'BroadcastSessionSetupFailureIEs',
        'BroadcastSessionModificationRequest',
        'BroadcastSessionModificationRequestIEs',
        'BroadcastSessionModificationResponse',
        'BroadcastSessionModificationResponseIEs',
        'BroadcastSessionModificationFailure',
        'BroadcastSessionModificationFailureIEs',
        'BroadcastSessionReleaseRequest',
        'BroadcastSessionReleaseRequestIEs',
        'BroadcastSessionReleaseRequired',
        'BroadcastSessionReleaseRequiredIEs',
        'BroadcastSessionReleaseResponse',
        'BroadcastSessionReleaseResponseIEs',
        'DistributionSetupRequest',
        'DistributionSetupRequestIEs',
        'DistributionSetupResponse',
        'DistributionSetupResponseIEs',
        'DistributionSetupFailure',
        'DistributionSetupFailureIEs',
        'DistributionReleaseRequest',
        'DistributionReleaseRequestIEs',
        'DistributionReleaseResponse',
        'DistributionReleaseResponseIEs',
        'MulticastSessionActivationRequest',
        'MulticastSessionActivationRequestIEs',
        'MulticastSessionActivationResponse',
        'MulticastSessionActivationResponseIEs',
        'MulticastSessionActivationFailure',
        'MulticastSessionActivationFailureIEs',
        'MulticastSessionDeactivationRequest',
        'MulticastSessionDeactivationRequestIEs',
        'MulticastSessionDeactivationResponse',
        'MulticastSessionDeactivationResponseIEs',
        'MulticastSessionUpdateRequest',
        'MulticastSessionUpdateRequestIEs',
        'MulticastSessionUpdateResponse',
        'MulticastSessionUpdateResponseIEs',
        'MulticastSessionUpdateFailure',
        'MulticastSessionUpdateFailureIEs',
        'MulticastGroupPaging',
        'MulticastGroupPagingIEs',
        ]
    _type_ = [
        'PDUSessionResourceSetupRequest',
        'PDUSessionResourceSetupResponse',
        'PDUSessionResourceReleaseCommand',
        'PDUSessionResourceReleaseResponse',
        'PDUSessionResourceModifyRequest',
        'PDUSessionResourceModifyResponse',
        'PDUSessionResourceNotify',
        'PDUSessionResourceModifyIndication',
        'PDUSessionResourceModifyConfirm',
        'InitialContextSetupRequest',
        'InitialContextSetupResponse',
        'InitialContextSetupFailure',
        'UEContextReleaseRequest',
        'UEContextReleaseCommand',
        'UEContextReleaseComplete',
        'UEContextResumeRequest',
        'UEContextResumeResponse',
        'UEContextResumeFailure',
        'UEContextSuspendRequest',
        'UEContextSuspendResponse',
        'UEContextSuspendFailure',
        'UEContextModificationRequest',
        'UEContextModificationResponse',
        'UEContextModificationFailure',
        'RRCInactiveTransitionReport',
        'RetrieveUEInformation',
        'UEInformationTransfer',
        'RANCPRelocationIndication',
        'HandoverRequired',
        'HandoverCommand',
        'HandoverPreparationFailure',
        'HandoverRequest',
        'HandoverRequestAcknowledge',
        'HandoverFailure',
        'HandoverNotify',
        'PathSwitchRequest',
        'PathSwitchRequestAcknowledge',
        'PathSwitchRequestFailure',
        'HandoverCancel',
        'HandoverCancelAcknowledge',
        'HandoverSuccess',
        'UplinkRANEarlyStatusTransfer',
        'DownlinkRANEarlyStatusTransfer',
        'UplinkRANStatusTransfer',
        'DownlinkRANStatusTransfer',
        'Paging',
        'InitialUEMessage',
        'DownlinkNASTransport',
        'UplinkNASTransport',
        'NASNonDeliveryIndication',
        'RerouteNASRequest',
        'NGSetupRequest',
        'NGSetupResponse',
        'NGSetupFailure',
        'RANConfigurationUpdate',
        'RANConfigurationUpdateAcknowledge',
        'RANConfigurationUpdateFailure',
        'AMFConfigurationUpdate',
        'AMFConfigurationUpdateAcknowledge',
        'AMFConfigurationUpdateFailure',
        'AMFStatusIndication',
        'NGReset',
        'NGResetAcknowledge',
        'ErrorIndication',
        'OverloadStart',
        'OverloadStop',
        'UplinkRANConfigurationTransfer',
        'DownlinkRANConfigurationTransfer',
        'WriteReplaceWarningRequest',
        'WriteReplaceWarningResponse',
        'PWSCancelRequest',
        'PWSCancelResponse',
        'PWSRestartIndication',
        'PWSFailureIndication',
        'DownlinkUEAssociatedNRPPaTransport',
        'UplinkUEAssociatedNRPPaTransport',
        'DownlinkNonUEAssociatedNRPPaTransport',
        'UplinkNonUEAssociatedNRPPaTransport',
        'TraceStart',
        'TraceFailureIndication',
        'DeactivateTrace',
        'CellTrafficTrace',
        'LocationReportingControl',
        'LocationReportingFailureIndication',
        'LocationReport',
        'UETNLABindingReleaseRequest',
        'UERadioCapabilityInfoIndication',
        'UERadioCapabilityCheckRequest',
        'UERadioCapabilityCheckResponse',
        'PrivateMessage',
        'SecondaryRATDataUsageReport',
        'UplinkRIMInformationTransfer',
        'DownlinkRIMInformationTransfer',
        'ConnectionEstablishmentIndication',
        'UERadioCapabilityIDMappingRequest',
        'UERadioCapabilityIDMappingResponse',
        'AMFCPRelocationIndication',
        'BroadcastSessionSetupRequest',
        'BroadcastSessionSetupResponse',
        'BroadcastSessionSetupFailure',
        'BroadcastSessionModificationRequest',
        'BroadcastSessionModificationResponse',
        'BroadcastSessionModificationFailure',
        'BroadcastSessionReleaseRequest',
        'BroadcastSessionReleaseRequired',
        'BroadcastSessionReleaseResponse',
        'DistributionSetupRequest',
        'DistributionSetupResponse',
        'DistributionSetupFailure',
        'DistributionReleaseRequest',
        'DistributionReleaseResponse',
        'MulticastSessionActivationRequest',
        'MulticastSessionActivationResponse',
        'MulticastSessionActivationFailure',
        'MulticastSessionDeactivationRequest',
        'MulticastSessionDeactivationResponse',
        'MulticastSessionUpdateRequest',
        'MulticastSessionUpdateResponse',
        'MulticastSessionUpdateFailure',
        'MulticastGroupPaging',
        ]
    _set_ = [
        'PDUSessionResourceSetupRequestIEs',
        'PDUSessionResourceSetupResponseIEs',
        'PDUSessionResourceReleaseCommandIEs',
        'PDUSessionResourceReleaseResponseIEs',
        'PDUSessionResourceModifyRequestIEs',
        'PDUSessionResourceModifyResponseIEs',
        'PDUSessionResourceNotifyIEs',
        'PDUSessionResourceModifyIndicationIEs',
        'PDUSessionResourceModifyConfirmIEs',
        'InitialContextSetupRequestIEs',
        'InitialContextSetupResponseIEs',
        'InitialContextSetupFailureIEs',
        'UEContextReleaseRequest-IEs',
        'UEContextReleaseCommand-IEs',
        'UEContextReleaseComplete-IEs',
        'UEContextResumeRequestIEs',
        'UEContextResumeResponseIEs',
        'UEContextResumeFailureIEs',
        'UEContextSuspendRequestIEs',
        'UEContextSuspendResponseIEs',
        'UEContextSuspendFailureIEs',
        'UEContextModificationRequestIEs',
        'UEContextModificationResponseIEs',
        'UEContextModificationFailureIEs',
        'RRCInactiveTransitionReportIEs',
        'RetrieveUEInformationIEs',
        'UEInformationTransferIEs',
        'RANCPRelocationIndicationIEs',
        'HandoverRequiredIEs',
        'HandoverCommandIEs',
        'HandoverPreparationFailureIEs',
        'HandoverRequestIEs',
        'HandoverRequestAcknowledgeIEs',
        'HandoverFailureIEs',
        'HandoverNotifyIEs',
        'PathSwitchRequestIEs',
        'PathSwitchRequestAcknowledgeIEs',
        'PathSwitchRequestFailureIEs',
        'HandoverCancelIEs',
        'HandoverCancelAcknowledgeIEs',
        'HandoverSuccessIEs',
        'UplinkRANEarlyStatusTransferIEs',
        'DownlinkRANEarlyStatusTransferIEs',
        'UplinkRANStatusTransferIEs',
        'DownlinkRANStatusTransferIEs',
        'PagingIEs',
        'InitialUEMessage-IEs',
        'DownlinkNASTransport-IEs',
        'UplinkNASTransport-IEs',
        'NASNonDeliveryIndication-IEs',
        'RerouteNASRequest-IEs',
        'NGSetupRequestIEs',
        'NGSetupResponseIEs',
        'NGSetupFailureIEs',
        'RANConfigurationUpdateIEs',
        'RANConfigurationUpdateAcknowledgeIEs',
        'RANConfigurationUpdateFailureIEs',
        'AMFConfigurationUpdateIEs',
        'AMFConfigurationUpdateAcknowledgeIEs',
        'AMFConfigurationUpdateFailureIEs',
        'AMFStatusIndicationIEs',
        'NGResetIEs',
        'NGResetAcknowledgeIEs',
        'ErrorIndicationIEs',
        'OverloadStartIEs',
        'OverloadStopIEs',
        'UplinkRANConfigurationTransferIEs',
        'DownlinkRANConfigurationTransferIEs',
        'WriteReplaceWarningRequestIEs',
        'WriteReplaceWarningResponseIEs',
        'PWSCancelRequestIEs',
        'PWSCancelResponseIEs',
        'PWSRestartIndicationIEs',
        'PWSFailureIndicationIEs',
        'DownlinkUEAssociatedNRPPaTransportIEs',
        'UplinkUEAssociatedNRPPaTransportIEs',
        'DownlinkNonUEAssociatedNRPPaTransportIEs',
        'UplinkNonUEAssociatedNRPPaTransportIEs',
        'TraceStartIEs',
        'TraceFailureIndicationIEs',
        'DeactivateTraceIEs',
        'CellTrafficTraceIEs',
        'LocationReportingControlIEs',
        'LocationReportingFailureIndicationIEs',
        'LocationReportIEs',
        'UETNLABindingReleaseRequestIEs',
        'UERadioCapabilityInfoIndicationIEs',
        'UERadioCapabilityCheckRequestIEs',
        'UERadioCapabilityCheckResponseIEs',
        'PrivateMessageIEs',
        'SecondaryRATDataUsageReportIEs',
        'UplinkRIMInformationTransferIEs',
        'DownlinkRIMInformationTransferIEs',
        'ConnectionEstablishmentIndicationIEs',
        'UERadioCapabilityIDMappingRequestIEs',
        'UERadioCapabilityIDMappingResponseIEs',
        'AMFCPRelocationIndicationIEs',
        'BroadcastSessionSetupRequestIEs',
        'BroadcastSessionSetupResponseIEs',
        'BroadcastSessionSetupFailureIEs',
        'BroadcastSessionModificationRequestIEs',
        'BroadcastSessionModificationResponseIEs',
        'BroadcastSessionModificationFailureIEs',
        'BroadcastSessionReleaseRequestIEs',
        'BroadcastSessionReleaseRequiredIEs',
        'BroadcastSessionReleaseResponseIEs',
        'DistributionSetupRequestIEs',
        'DistributionSetupResponseIEs',
        'DistributionSetupFailureIEs',
        'DistributionReleaseRequestIEs',
        'DistributionReleaseResponseIEs',
        'MulticastSessionActivationRequestIEs',
        'MulticastSessionActivationResponseIEs',
        'MulticastSessionActivationFailureIEs',
        'MulticastSessionDeactivationRequestIEs',
        'MulticastSessionDeactivationResponseIEs',
        'MulticastSessionUpdateRequestIEs',
        'MulticastSessionUpdateResponseIEs',
        'MulticastSessionUpdateFailureIEs',
        'MulticastGroupPagingIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        'PDUSessionResourceSetupRequestIEs',
        'PDUSessionResourceSetupResponseIEs',
        'PDUSessionResourceReleaseCommandIEs',
        'PDUSessionResourceReleaseResponseIEs',
        'PDUSessionResourceModifyRequestIEs',
        'PDUSessionResourceModifyResponseIEs',
        'PDUSessionResourceNotifyIEs',
        'PDUSessionResourceModifyIndicationIEs',
        'PDUSessionResourceModifyConfirmIEs',
        'InitialContextSetupRequestIEs',
        'InitialContextSetupResponseIEs',
        'InitialContextSetupFailureIEs',
        'UEContextReleaseRequest-IEs',
        'UEContextReleaseCommand-IEs',
        'UEContextReleaseComplete-IEs',
        'UEContextResumeRequestIEs',
        'UEContextResumeResponseIEs',
        'UEContextResumeFailureIEs',
        'UEContextSuspendRequestIEs',
        'UEContextSuspendResponseIEs',
        'UEContextSuspendFailureIEs',
        'UEContextModificationRequestIEs',
        'UEContextModificationResponseIEs',
        'UEContextModificationFailureIEs',
        'RRCInactiveTransitionReportIEs',
        'RetrieveUEInformationIEs',
        'UEInformationTransferIEs',
        'RANCPRelocationIndicationIEs',
        'HandoverRequiredIEs',
        'HandoverCommandIEs',
        'HandoverPreparationFailureIEs',
        'HandoverRequestIEs',
        'HandoverRequestAcknowledgeIEs',
        'HandoverFailureIEs',
        'HandoverNotifyIEs',
        'PathSwitchRequestIEs',
        'PathSwitchRequestAcknowledgeIEs',
        'PathSwitchRequestFailureIEs',
        'HandoverCancelIEs',
        'HandoverCancelAcknowledgeIEs',
        'HandoverSuccessIEs',
        'UplinkRANEarlyStatusTransferIEs',
        'DownlinkRANEarlyStatusTransferIEs',
        'UplinkRANStatusTransferIEs',
        'DownlinkRANStatusTransferIEs',
        'PagingIEs',
        'InitialUEMessage-IEs',
        'DownlinkNASTransport-IEs',
        'UplinkNASTransport-IEs',
        'NASNonDeliveryIndication-IEs',
        'RerouteNASRequest-IEs',
        'NGSetupRequestIEs',
        'NGSetupResponseIEs',
        'NGSetupFailureIEs',
        'RANConfigurationUpdateIEs',
        'RANConfigurationUpdateAcknowledgeIEs',
        'RANConfigurationUpdateFailureIEs',
        'AMFConfigurationUpdateIEs',
        'AMFConfigurationUpdateAcknowledgeIEs',
        'AMFConfigurationUpdateFailureIEs',
        'AMFStatusIndicationIEs',
        'NGResetIEs',
        'NGResetAcknowledgeIEs',
        'ErrorIndicationIEs',
        'OverloadStartIEs',
        'OverloadStopIEs',
        'UplinkRANConfigurationTransferIEs',
        'DownlinkRANConfigurationTransferIEs',
        'WriteReplaceWarningRequestIEs',
        'WriteReplaceWarningResponseIEs',
        'PWSCancelRequestIEs',
        'PWSCancelResponseIEs',
        'PWSRestartIndicationIEs',
        'PWSFailureIndicationIEs',
        'DownlinkUEAssociatedNRPPaTransportIEs',
        'UplinkUEAssociatedNRPPaTransportIEs',
        'DownlinkNonUEAssociatedNRPPaTransportIEs',
        'UplinkNonUEAssociatedNRPPaTransportIEs',
        'TraceStartIEs',
        'TraceFailureIndicationIEs',
        'DeactivateTraceIEs',
        'CellTrafficTraceIEs',
        'LocationReportingControlIEs',
        'LocationReportingFailureIndicationIEs',
        'LocationReportIEs',
        'UETNLABindingReleaseRequestIEs',
        'UERadioCapabilityInfoIndicationIEs',
        'UERadioCapabilityCheckRequestIEs',
        'UERadioCapabilityCheckResponseIEs',
        'PrivateMessageIEs',
        'SecondaryRATDataUsageReportIEs',
        'UplinkRIMInformationTransferIEs',
        'DownlinkRIMInformationTransferIEs',
        'ConnectionEstablishmentIndicationIEs',
        'UERadioCapabilityIDMappingRequestIEs',
        'UERadioCapabilityIDMappingResponseIEs',
        'AMFCPRelocationIndicationIEs',
        'BroadcastSessionSetupRequestIEs',
        'BroadcastSessionSetupResponseIEs',
        'BroadcastSessionSetupFailureIEs',
        'BroadcastSessionModificationRequestIEs',
        'BroadcastSessionModificationResponseIEs',
        'BroadcastSessionModificationFailureIEs',
        'BroadcastSessionReleaseRequestIEs',
        'BroadcastSessionReleaseRequiredIEs',
        'BroadcastSessionReleaseResponseIEs',
        'DistributionSetupRequestIEs',
        'DistributionSetupResponseIEs',
        'DistributionSetupFailureIEs',
        'DistributionReleaseRequestIEs',
        'DistributionReleaseResponseIEs',
        'MulticastSessionActivationRequestIEs',
        'MulticastSessionActivationResponseIEs',
        'MulticastSessionActivationFailureIEs',
        'MulticastSessionDeactivationRequestIEs',
        'MulticastSessionDeactivationResponseIEs',
        'MulticastSessionUpdateRequestIEs',
        'MulticastSessionUpdateResponseIEs',
        'MulticastSessionUpdateFailureIEs',
        'MulticastGroupPagingIEs',
        ]
    _param_ = [
        ]
    
    #-----< PDUSessionResourceSetupRequest >-----#
    PDUSessionResourceSetupRequest = SEQ(name='PDUSessionResourceSetupRequest', mode=MODE_TYPE)
    _PDUSessionResourceSetupRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PDUSessionResourceSetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PDUSessionResourceSetupRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANPagingPriority')))
    _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupListSUReq')))
    _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEAggregateMaximumBitRate')))
    _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESliceMaximumBitRateList')))
    ____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 83), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 38), ('criticality', 'reject'), ('Value', _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 74), ('criticality', 'reject'), ('Value', _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 110), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupRequest_protocolIEs__item__id._const_tab = ____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab
    ___PDUSessionResourceSetupRequest_protocolIEs__item__id._const_tab_at = None
    ___PDUSessionResourceSetupRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___PDUSessionResourceSetupRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___PDUSessionResourceSetupRequest_protocolIEs__item__criticality._const_tab = ____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab
    ___PDUSessionResourceSetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceSetupRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceSetupRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___PDUSessionResourceSetupRequest_protocolIEs__item__value._const_tab = ____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab
    ___PDUSessionResourceSetupRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PDUSessionResourceSetupRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __PDUSessionResourceSetupRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceSetupRequest_protocolIEs__item__id),
        ('criticality', ___PDUSessionResourceSetupRequest_protocolIEs__item__criticality),
        ('value', ___PDUSessionResourceSetupRequest_protocolIEs__item__value),
        ])
    __PDUSessionResourceSetupRequest_protocolIEs__item_._ext = None
    _PDUSessionResourceSetupRequest_protocolIEs._cont = __PDUSessionResourceSetupRequest_protocolIEs__item_
    _PDUSessionResourceSetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDUSessionResourceSetupRequest._cont = ASN1Dict([
        ('protocolIEs', _PDUSessionResourceSetupRequest_protocolIEs),
        ])
    PDUSessionResourceSetupRequest._ext = []
    
    #-----< PDUSessionResourceSetupRequestIEs >-----#
    PDUSessionResourceSetupRequestIEs = CLASS(name='PDUSessionResourceSetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PDUSessionResourceSetupRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _PDUSessionResourceSetupRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _PDUSessionResourceSetupRequestIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANPagingPriority')))
    _PDUSessionResourceSetupRequestIEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _PDUSessionResourceSetupRequestIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupListSUReq')))
    _PDUSessionResourceSetupRequestIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEAggregateMaximumBitRate')))
    _PDUSessionResourceSetupRequestIEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESliceMaximumBitRateList')))
    PDUSessionResourceSetupRequestIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _PDUSessionResourceSetupRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _PDUSessionResourceSetupRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 83), ('criticality', 'ignore'), ('Value', _PDUSessionResourceSetupRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 38), ('criticality', 'reject'), ('Value', _PDUSessionResourceSetupRequestIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 74), ('criticality', 'reject'), ('Value', _PDUSessionResourceSetupRequestIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 110), ('criticality', 'ignore'), ('Value', _PDUSessionResourceSetupRequestIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'ignore'), ('Value', _PDUSessionResourceSetupRequestIEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceSetupResponse >-----#
    PDUSessionResourceSetupResponse = SEQ(name='PDUSessionResourceSetupResponse', mode=MODE_TYPE)
    _PDUSessionResourceSetupResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PDUSessionResourceSetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PDUSessionResourceSetupResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupListSURes')))
    _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupListSURes')))
    _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_5 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    ____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 75), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceSetupResponse_protocolIEs__item__id._const_tab = ____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab
    ___PDUSessionResourceSetupResponse_protocolIEs__item__id._const_tab_at = None
    ___PDUSessionResourceSetupResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___PDUSessionResourceSetupResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___PDUSessionResourceSetupResponse_protocolIEs__item__criticality._const_tab = ____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab
    ___PDUSessionResourceSetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceSetupResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceSetupResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___PDUSessionResourceSetupResponse_protocolIEs__item__value._const_tab = ____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab
    ___PDUSessionResourceSetupResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PDUSessionResourceSetupResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __PDUSessionResourceSetupResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceSetupResponse_protocolIEs__item__id),
        ('criticality', ___PDUSessionResourceSetupResponse_protocolIEs__item__criticality),
        ('value', ___PDUSessionResourceSetupResponse_protocolIEs__item__value),
        ])
    __PDUSessionResourceSetupResponse_protocolIEs__item_._ext = None
    _PDUSessionResourceSetupResponse_protocolIEs._cont = __PDUSessionResourceSetupResponse_protocolIEs__item_
    _PDUSessionResourceSetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDUSessionResourceSetupResponse._cont = ASN1Dict([
        ('protocolIEs', _PDUSessionResourceSetupResponse_protocolIEs),
        ])
    PDUSessionResourceSetupResponse._ext = []
    
    #-----< PDUSessionResourceSetupResponseIEs >-----#
    PDUSessionResourceSetupResponseIEs = CLASS(name='PDUSessionResourceSetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PDUSessionResourceSetupResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _PDUSessionResourceSetupResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _PDUSessionResourceSetupResponseIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupListSURes')))
    _PDUSessionResourceSetupResponseIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupListSURes')))
    _PDUSessionResourceSetupResponseIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _PDUSessionResourceSetupResponseIEs_val_Value_5 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    PDUSessionResourceSetupResponseIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _PDUSessionResourceSetupResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _PDUSessionResourceSetupResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 75), ('criticality', 'ignore'), ('Value', _PDUSessionResourceSetupResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _PDUSessionResourceSetupResponseIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _PDUSessionResourceSetupResponseIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _PDUSessionResourceSetupResponseIEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceReleaseCommand >-----#
    PDUSessionResourceReleaseCommand = SEQ(name='PDUSessionResourceReleaseCommand', mode=MODE_TYPE)
    _PDUSessionResourceReleaseCommand_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PDUSessionResourceReleaseCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PDUSessionResourceReleaseCommand_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANPagingPriority')))
    _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceToReleaseListRelCmd')))
    ____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 83), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 38), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 79), ('criticality', 'reject'), ('Value', _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleaseCommand_protocolIEs__item__id._const_tab = ____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab
    ___PDUSessionResourceReleaseCommand_protocolIEs__item__id._const_tab_at = None
    ___PDUSessionResourceReleaseCommand_protocolIEs__item__id._const_tab_id = 'id'
    ___PDUSessionResourceReleaseCommand_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___PDUSessionResourceReleaseCommand_protocolIEs__item__criticality._const_tab = ____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab
    ___PDUSessionResourceReleaseCommand_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceReleaseCommand_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceReleaseCommand_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___PDUSessionResourceReleaseCommand_protocolIEs__item__value._const_tab = ____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab
    ___PDUSessionResourceReleaseCommand_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PDUSessionResourceReleaseCommand_protocolIEs__item__value._const_tab_id = 'Value'
    __PDUSessionResourceReleaseCommand_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceReleaseCommand_protocolIEs__item__id),
        ('criticality', ___PDUSessionResourceReleaseCommand_protocolIEs__item__criticality),
        ('value', ___PDUSessionResourceReleaseCommand_protocolIEs__item__value),
        ])
    __PDUSessionResourceReleaseCommand_protocolIEs__item_._ext = None
    _PDUSessionResourceReleaseCommand_protocolIEs._cont = __PDUSessionResourceReleaseCommand_protocolIEs__item_
    _PDUSessionResourceReleaseCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDUSessionResourceReleaseCommand._cont = ASN1Dict([
        ('protocolIEs', _PDUSessionResourceReleaseCommand_protocolIEs),
        ])
    PDUSessionResourceReleaseCommand._ext = []
    
    #-----< PDUSessionResourceReleaseCommandIEs >-----#
    PDUSessionResourceReleaseCommandIEs = CLASS(name='PDUSessionResourceReleaseCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PDUSessionResourceReleaseCommandIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _PDUSessionResourceReleaseCommandIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _PDUSessionResourceReleaseCommandIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANPagingPriority')))
    _PDUSessionResourceReleaseCommandIEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _PDUSessionResourceReleaseCommandIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceToReleaseListRelCmd')))
    PDUSessionResourceReleaseCommandIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _PDUSessionResourceReleaseCommandIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _PDUSessionResourceReleaseCommandIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 83), ('criticality', 'ignore'), ('Value', _PDUSessionResourceReleaseCommandIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 38), ('criticality', 'ignore'), ('Value', _PDUSessionResourceReleaseCommandIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 79), ('criticality', 'reject'), ('Value', _PDUSessionResourceReleaseCommandIEs_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceReleaseResponse >-----#
    PDUSessionResourceReleaseResponse = SEQ(name='PDUSessionResourceReleaseResponse', mode=MODE_TYPE)
    _PDUSessionResourceReleaseResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PDUSessionResourceReleaseResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PDUSessionResourceReleaseResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleasedListRelRes')))
    _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 70), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceReleaseResponse_protocolIEs__item__id._const_tab = ____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab
    ___PDUSessionResourceReleaseResponse_protocolIEs__item__id._const_tab_at = None
    ___PDUSessionResourceReleaseResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___PDUSessionResourceReleaseResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___PDUSessionResourceReleaseResponse_protocolIEs__item__criticality._const_tab = ____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab
    ___PDUSessionResourceReleaseResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceReleaseResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceReleaseResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___PDUSessionResourceReleaseResponse_protocolIEs__item__value._const_tab = ____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab
    ___PDUSessionResourceReleaseResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PDUSessionResourceReleaseResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __PDUSessionResourceReleaseResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceReleaseResponse_protocolIEs__item__id),
        ('criticality', ___PDUSessionResourceReleaseResponse_protocolIEs__item__criticality),
        ('value', ___PDUSessionResourceReleaseResponse_protocolIEs__item__value),
        ])
    __PDUSessionResourceReleaseResponse_protocolIEs__item_._ext = None
    _PDUSessionResourceReleaseResponse_protocolIEs._cont = __PDUSessionResourceReleaseResponse_protocolIEs__item_
    _PDUSessionResourceReleaseResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDUSessionResourceReleaseResponse._cont = ASN1Dict([
        ('protocolIEs', _PDUSessionResourceReleaseResponse_protocolIEs),
        ])
    PDUSessionResourceReleaseResponse._ext = []
    
    #-----< PDUSessionResourceReleaseResponseIEs >-----#
    PDUSessionResourceReleaseResponseIEs = CLASS(name='PDUSessionResourceReleaseResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PDUSessionResourceReleaseResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _PDUSessionResourceReleaseResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _PDUSessionResourceReleaseResponseIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleasedListRelRes')))
    _PDUSessionResourceReleaseResponseIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _PDUSessionResourceReleaseResponseIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    PDUSessionResourceReleaseResponseIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _PDUSessionResourceReleaseResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _PDUSessionResourceReleaseResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 70), ('criticality', 'ignore'), ('Value', _PDUSessionResourceReleaseResponseIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _PDUSessionResourceReleaseResponseIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _PDUSessionResourceReleaseResponseIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyRequest >-----#
    PDUSessionResourceModifyRequest = SEQ(name='PDUSessionResourceModifyRequest', mode=MODE_TYPE)
    _PDUSessionResourceModifyRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PDUSessionResourceModifyRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PDUSessionResourceModifyRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANPagingPriority')))
    _____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyListModReq')))
    ____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 83), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 64), ('criticality', 'reject'), ('Value', _____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyRequest_protocolIEs__item__id._const_tab = ____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyRequest_protocolIEs__item__id._const_tab_at = None
    ___PDUSessionResourceModifyRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___PDUSessionResourceModifyRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___PDUSessionResourceModifyRequest_protocolIEs__item__criticality._const_tab = ____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceModifyRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___PDUSessionResourceModifyRequest_protocolIEs__item__value._const_tab = ____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __PDUSessionResourceModifyRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceModifyRequest_protocolIEs__item__id),
        ('criticality', ___PDUSessionResourceModifyRequest_protocolIEs__item__criticality),
        ('value', ___PDUSessionResourceModifyRequest_protocolIEs__item__value),
        ])
    __PDUSessionResourceModifyRequest_protocolIEs__item_._ext = None
    _PDUSessionResourceModifyRequest_protocolIEs._cont = __PDUSessionResourceModifyRequest_protocolIEs__item_
    _PDUSessionResourceModifyRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyRequest._cont = ASN1Dict([
        ('protocolIEs', _PDUSessionResourceModifyRequest_protocolIEs),
        ])
    PDUSessionResourceModifyRequest._ext = []
    
    #-----< PDUSessionResourceModifyRequestIEs >-----#
    PDUSessionResourceModifyRequestIEs = CLASS(name='PDUSessionResourceModifyRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PDUSessionResourceModifyRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _PDUSessionResourceModifyRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _PDUSessionResourceModifyRequestIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANPagingPriority')))
    _PDUSessionResourceModifyRequestIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyListModReq')))
    PDUSessionResourceModifyRequestIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _PDUSessionResourceModifyRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _PDUSessionResourceModifyRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 83), ('criticality', 'ignore'), ('Value', _PDUSessionResourceModifyRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 64), ('criticality', 'reject'), ('Value', _PDUSessionResourceModifyRequestIEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyResponse >-----#
    PDUSessionResourceModifyResponse = SEQ(name='PDUSessionResourceModifyResponse', mode=MODE_TYPE)
    _PDUSessionResourceModifyResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PDUSessionResourceModifyResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PDUSessionResourceModifyResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyListModRes')))
    _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToModifyListModRes')))
    _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 65), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 54), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyResponse_protocolIEs__item__id._const_tab = ____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyResponse_protocolIEs__item__id._const_tab_at = None
    ___PDUSessionResourceModifyResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___PDUSessionResourceModifyResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___PDUSessionResourceModifyResponse_protocolIEs__item__criticality._const_tab = ____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceModifyResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___PDUSessionResourceModifyResponse_protocolIEs__item__value._const_tab = ____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __PDUSessionResourceModifyResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceModifyResponse_protocolIEs__item__id),
        ('criticality', ___PDUSessionResourceModifyResponse_protocolIEs__item__criticality),
        ('value', ___PDUSessionResourceModifyResponse_protocolIEs__item__value),
        ])
    __PDUSessionResourceModifyResponse_protocolIEs__item_._ext = None
    _PDUSessionResourceModifyResponse_protocolIEs._cont = __PDUSessionResourceModifyResponse_protocolIEs__item_
    _PDUSessionResourceModifyResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyResponse._cont = ASN1Dict([
        ('protocolIEs', _PDUSessionResourceModifyResponse_protocolIEs),
        ])
    PDUSessionResourceModifyResponse._ext = []
    
    #-----< PDUSessionResourceModifyResponseIEs >-----#
    PDUSessionResourceModifyResponseIEs = CLASS(name='PDUSessionResourceModifyResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PDUSessionResourceModifyResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _PDUSessionResourceModifyResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _PDUSessionResourceModifyResponseIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyListModRes')))
    _PDUSessionResourceModifyResponseIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToModifyListModRes')))
    _PDUSessionResourceModifyResponseIEs_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _PDUSessionResourceModifyResponseIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    PDUSessionResourceModifyResponseIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _PDUSessionResourceModifyResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _PDUSessionResourceModifyResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 65), ('criticality', 'ignore'), ('Value', _PDUSessionResourceModifyResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 54), ('criticality', 'ignore'), ('Value', _PDUSessionResourceModifyResponseIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _PDUSessionResourceModifyResponseIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _PDUSessionResourceModifyResponseIEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceNotify >-----#
    PDUSessionResourceNotify = SEQ(name='PDUSessionResourceNotify', mode=MODE_TYPE)
    _PDUSessionResourceNotify_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PDUSessionResourceNotify_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PDUSessionResourceNotify_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____PDUSessionResourceNotify_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceNotifyList')))
    _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleasedListNot')))
    _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    ____PDUSessionResourceNotify_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 66), ('criticality', 'reject'), ('Value', _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 67), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceNotify_protocolIEs__item__id._const_tab = ____PDUSessionResourceNotify_protocolIEs__item__id_tab
    ___PDUSessionResourceNotify_protocolIEs__item__id._const_tab_at = None
    ___PDUSessionResourceNotify_protocolIEs__item__id._const_tab_id = 'id'
    ___PDUSessionResourceNotify_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___PDUSessionResourceNotify_protocolIEs__item__criticality._const_tab = ____PDUSessionResourceNotify_protocolIEs__item__id_tab
    ___PDUSessionResourceNotify_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceNotify_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceNotify_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___PDUSessionResourceNotify_protocolIEs__item__value._const_tab = ____PDUSessionResourceNotify_protocolIEs__item__id_tab
    ___PDUSessionResourceNotify_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PDUSessionResourceNotify_protocolIEs__item__value._const_tab_id = 'Value'
    __PDUSessionResourceNotify_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceNotify_protocolIEs__item__id),
        ('criticality', ___PDUSessionResourceNotify_protocolIEs__item__criticality),
        ('value', ___PDUSessionResourceNotify_protocolIEs__item__value),
        ])
    __PDUSessionResourceNotify_protocolIEs__item_._ext = None
    _PDUSessionResourceNotify_protocolIEs._cont = __PDUSessionResourceNotify_protocolIEs__item_
    _PDUSessionResourceNotify_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDUSessionResourceNotify._cont = ASN1Dict([
        ('protocolIEs', _PDUSessionResourceNotify_protocolIEs),
        ])
    PDUSessionResourceNotify._ext = []
    
    #-----< PDUSessionResourceNotifyIEs >-----#
    PDUSessionResourceNotifyIEs = CLASS(name='PDUSessionResourceNotifyIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PDUSessionResourceNotifyIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _PDUSessionResourceNotifyIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _PDUSessionResourceNotifyIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceNotifyList')))
    _PDUSessionResourceNotifyIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleasedListNot')))
    _PDUSessionResourceNotifyIEs_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    PDUSessionResourceNotifyIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _PDUSessionResourceNotifyIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _PDUSessionResourceNotifyIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 66), ('criticality', 'reject'), ('Value', _PDUSessionResourceNotifyIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 67), ('criticality', 'ignore'), ('Value', _PDUSessionResourceNotifyIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _PDUSessionResourceNotifyIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyIndication >-----#
    PDUSessionResourceModifyIndication = SEQ(name='PDUSessionResourceModifyIndication', mode=MODE_TYPE)
    _PDUSessionResourceModifyIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PDUSessionResourceModifyIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PDUSessionResourceModifyIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyListModInd')))
    _____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    ____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 63), ('criticality', 'reject'), ('Value', _____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyIndication_protocolIEs__item__id._const_tab = ____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyIndication_protocolIEs__item__id._const_tab_at = None
    ___PDUSessionResourceModifyIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___PDUSessionResourceModifyIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___PDUSessionResourceModifyIndication_protocolIEs__item__criticality._const_tab = ____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceModifyIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___PDUSessionResourceModifyIndication_protocolIEs__item__value._const_tab = ____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __PDUSessionResourceModifyIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceModifyIndication_protocolIEs__item__id),
        ('criticality', ___PDUSessionResourceModifyIndication_protocolIEs__item__criticality),
        ('value', ___PDUSessionResourceModifyIndication_protocolIEs__item__value),
        ])
    __PDUSessionResourceModifyIndication_protocolIEs__item_._ext = None
    _PDUSessionResourceModifyIndication_protocolIEs._cont = __PDUSessionResourceModifyIndication_protocolIEs__item_
    _PDUSessionResourceModifyIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyIndication._cont = ASN1Dict([
        ('protocolIEs', _PDUSessionResourceModifyIndication_protocolIEs),
        ])
    PDUSessionResourceModifyIndication._ext = []
    
    #-----< PDUSessionResourceModifyIndicationIEs >-----#
    PDUSessionResourceModifyIndicationIEs = CLASS(name='PDUSessionResourceModifyIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PDUSessionResourceModifyIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _PDUSessionResourceModifyIndicationIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _PDUSessionResourceModifyIndicationIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyListModInd')))
    _PDUSessionResourceModifyIndicationIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    PDUSessionResourceModifyIndicationIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _PDUSessionResourceModifyIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _PDUSessionResourceModifyIndicationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 63), ('criticality', 'reject'), ('Value', _PDUSessionResourceModifyIndicationIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _PDUSessionResourceModifyIndicationIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PDUSessionResourceModifyConfirm >-----#
    PDUSessionResourceModifyConfirm = SEQ(name='PDUSessionResourceModifyConfirm', mode=MODE_TYPE)
    _PDUSessionResourceModifyConfirm_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PDUSessionResourceModifyConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PDUSessionResourceModifyConfirm_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyListModCfm')))
    _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToModifyListModCfm')))
    _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 62), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 131), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PDUSessionResourceModifyConfirm_protocolIEs__item__id._const_tab = ____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyConfirm_protocolIEs__item__id._const_tab_at = None
    ___PDUSessionResourceModifyConfirm_protocolIEs__item__id._const_tab_id = 'id'
    ___PDUSessionResourceModifyConfirm_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___PDUSessionResourceModifyConfirm_protocolIEs__item__criticality._const_tab = ____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyConfirm_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyConfirm_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PDUSessionResourceModifyConfirm_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___PDUSessionResourceModifyConfirm_protocolIEs__item__value._const_tab = ____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab
    ___PDUSessionResourceModifyConfirm_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PDUSessionResourceModifyConfirm_protocolIEs__item__value._const_tab_id = 'Value'
    __PDUSessionResourceModifyConfirm_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PDUSessionResourceModifyConfirm_protocolIEs__item__id),
        ('criticality', ___PDUSessionResourceModifyConfirm_protocolIEs__item__criticality),
        ('value', ___PDUSessionResourceModifyConfirm_protocolIEs__item__value),
        ])
    __PDUSessionResourceModifyConfirm_protocolIEs__item_._ext = None
    _PDUSessionResourceModifyConfirm_protocolIEs._cont = __PDUSessionResourceModifyConfirm_protocolIEs__item_
    _PDUSessionResourceModifyConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PDUSessionResourceModifyConfirm._cont = ASN1Dict([
        ('protocolIEs', _PDUSessionResourceModifyConfirm_protocolIEs),
        ])
    PDUSessionResourceModifyConfirm._ext = []
    
    #-----< PDUSessionResourceModifyConfirmIEs >-----#
    PDUSessionResourceModifyConfirmIEs = CLASS(name='PDUSessionResourceModifyConfirmIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PDUSessionResourceModifyConfirmIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _PDUSessionResourceModifyConfirmIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _PDUSessionResourceModifyConfirmIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceModifyListModCfm')))
    _PDUSessionResourceModifyConfirmIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToModifyListModCfm')))
    _PDUSessionResourceModifyConfirmIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    PDUSessionResourceModifyConfirmIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _PDUSessionResourceModifyConfirmIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _PDUSessionResourceModifyConfirmIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 62), ('criticality', 'ignore'), ('Value', _PDUSessionResourceModifyConfirmIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 131), ('criticality', 'ignore'), ('Value', _PDUSessionResourceModifyConfirmIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _PDUSessionResourceModifyConfirmIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< InitialContextSetupRequest >-----#
    InitialContextSetupRequest = SEQ(name='InitialContextSetupRequest', mode=MODE_TYPE)
    _InitialContextSetupRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __InitialContextSetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___InitialContextSetupRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____InitialContextSetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_2 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMFName')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEAggregateMaximumBitRate')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CoreNetworkAssistanceInformationForInactive')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GUAMI')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupListCxtReq')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESecurityCapabilities')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_9 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityKey')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TraceActivation')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MobilityRestrictionList')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_12 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_13 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IndexToRFSP')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_14 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MaskedIMEISV')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_15 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_16 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EmergencyFallbackIndicator')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_17 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCInactiveTransitionReportRequest')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_18 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityForPaging')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_19 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedirectionVoiceFallback')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_20 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LocationReportingRequestType')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_21 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CNAssistedRANTuning')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_22 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SRVCCOperationPossible')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_23 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IAB-Authorized')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_24 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Enhanced-CoverageRestriction')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_25 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-ConnectedTime')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_26 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-DifferentiationInfo')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_27 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRV2XServicesAuthorized')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_28 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEV2XServicesAuthorized')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_29 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_30 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEUESidelinkAggregateMaximumBitrate')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_31 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PC5QoSParameters')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_32 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBrestricted')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_33 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-UP-CIoT-Support')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_34 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RGLevelWirelineAccessCharacteristics')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_35 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MDTPLMNList')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_36 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_37 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TimeSyncAssistanceInfo')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_38 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QMCConfigInfo')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_39 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargetNSSAIInformation')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_40 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESliceMaximumBitRateList')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_41 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-ProSeAuthorized')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_42 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_43 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-ProSePC5QoSParameters')))
    ____InitialContextSetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 48), ('criticality', 'reject'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 110), ('criticality', 'reject'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'conditional')]), dict([('id', 18), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 28), ('criticality', 'reject'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'mandatory')]), dict([('id', 71), ('criticality', 'reject'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'reject'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'mandatory')]), dict([('id', 119), ('criticality', 'reject'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_8), ('presence', 'mandatory')]), dict([('id', 94), ('criticality', 'reject'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_9), ('presence', 'mandatory')]), dict([('id', 108), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 36), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 117), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 31), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 34), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 38), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')]), dict([('id', 24), ('criticality', 'reject'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')]), dict([('id', 91), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_17), ('presence', 'optional')]), dict([('id', 118), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_18), ('presence', 'optional')]), dict([('id', 146), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_19), ('presence', 'optional')]), dict([('id', 33), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_20), ('presence', 'optional')]), dict([('id', 165), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_21), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_22), ('presence', 'optional')]), dict([('id', 199), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_23), ('presence', 'optional')]), dict([('id', 205), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_24), ('presence', 'optional')]), dict([('id', 206), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_25), ('presence', 'optional')]), dict([('id', 209), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_26), ('presence', 'optional')]), dict([('id', 216), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_27), ('presence', 'optional')]), dict([('id', 215), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_28), ('presence', 'optional')]), dict([('id', 218), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_29), ('presence', 'optional')]), dict([('id', 217), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_30), ('presence', 'optional')]), dict([('id', 219), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_31), ('presence', 'optional')]), dict([('id', 222), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_32), ('presence', 'optional')]), dict([('id', 234), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_33), ('presence', 'optional')]), dict([('id', 238), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_34), ('presence', 'optional')]), dict([('id', 254), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_35), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'reject'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_36), ('presence', 'optional')]), dict([('id', 326), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_37), ('presence', 'optional')]), dict([('id', 328), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_38), ('presence', 'optional')]), dict([('id', 334), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_39), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_40), ('presence', 'optional')]), dict([('id', 345), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_41), ('presence', 'optional')]), dict([('id', 346), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_42), ('presence', 'optional')]), dict([('id', 347), ('criticality', 'ignore'), ('Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_43), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___InitialContextSetupRequest_protocolIEs__item__id._const_tab = ____InitialContextSetupRequest_protocolIEs__item__id_tab
    ___InitialContextSetupRequest_protocolIEs__item__id._const_tab_at = None
    ___InitialContextSetupRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___InitialContextSetupRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___InitialContextSetupRequest_protocolIEs__item__criticality._const_tab = ____InitialContextSetupRequest_protocolIEs__item__id_tab
    ___InitialContextSetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___InitialContextSetupRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___InitialContextSetupRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___InitialContextSetupRequest_protocolIEs__item__value._const_tab = ____InitialContextSetupRequest_protocolIEs__item__id_tab
    ___InitialContextSetupRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___InitialContextSetupRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __InitialContextSetupRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___InitialContextSetupRequest_protocolIEs__item__id),
        ('criticality', ___InitialContextSetupRequest_protocolIEs__item__criticality),
        ('value', ___InitialContextSetupRequest_protocolIEs__item__value),
        ])
    __InitialContextSetupRequest_protocolIEs__item_._ext = None
    _InitialContextSetupRequest_protocolIEs._cont = __InitialContextSetupRequest_protocolIEs__item_
    _InitialContextSetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    InitialContextSetupRequest._cont = ASN1Dict([
        ('protocolIEs', _InitialContextSetupRequest_protocolIEs),
        ])
    InitialContextSetupRequest._ext = []
    
    #-----< InitialContextSetupRequestIEs >-----#
    InitialContextSetupRequestIEs = CLASS(name='InitialContextSetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _InitialContextSetupRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _InitialContextSetupRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _InitialContextSetupRequestIEs_val_Value_2 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMFName')))
    _InitialContextSetupRequestIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEAggregateMaximumBitRate')))
    _InitialContextSetupRequestIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CoreNetworkAssistanceInformationForInactive')))
    _InitialContextSetupRequestIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GUAMI')))
    _InitialContextSetupRequestIEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupListCxtReq')))
    _InitialContextSetupRequestIEs_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _InitialContextSetupRequestIEs_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESecurityCapabilities')))
    _InitialContextSetupRequestIEs_val_Value_9 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityKey')))
    _InitialContextSetupRequestIEs_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TraceActivation')))
    _InitialContextSetupRequestIEs_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MobilityRestrictionList')))
    _InitialContextSetupRequestIEs_val_Value_12 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _InitialContextSetupRequestIEs_val_Value_13 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IndexToRFSP')))
    _InitialContextSetupRequestIEs_val_Value_14 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MaskedIMEISV')))
    _InitialContextSetupRequestIEs_val_Value_15 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _InitialContextSetupRequestIEs_val_Value_16 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EmergencyFallbackIndicator')))
    _InitialContextSetupRequestIEs_val_Value_17 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCInactiveTransitionReportRequest')))
    _InitialContextSetupRequestIEs_val_Value_18 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityForPaging')))
    _InitialContextSetupRequestIEs_val_Value_19 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedirectionVoiceFallback')))
    _InitialContextSetupRequestIEs_val_Value_20 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LocationReportingRequestType')))
    _InitialContextSetupRequestIEs_val_Value_21 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CNAssistedRANTuning')))
    _InitialContextSetupRequestIEs_val_Value_22 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SRVCCOperationPossible')))
    _InitialContextSetupRequestIEs_val_Value_23 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IAB-Authorized')))
    _InitialContextSetupRequestIEs_val_Value_24 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Enhanced-CoverageRestriction')))
    _InitialContextSetupRequestIEs_val_Value_25 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-ConnectedTime')))
    _InitialContextSetupRequestIEs_val_Value_26 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-DifferentiationInfo')))
    _InitialContextSetupRequestIEs_val_Value_27 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRV2XServicesAuthorized')))
    _InitialContextSetupRequestIEs_val_Value_28 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEV2XServicesAuthorized')))
    _InitialContextSetupRequestIEs_val_Value_29 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _InitialContextSetupRequestIEs_val_Value_30 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEUESidelinkAggregateMaximumBitrate')))
    _InitialContextSetupRequestIEs_val_Value_31 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PC5QoSParameters')))
    _InitialContextSetupRequestIEs_val_Value_32 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBrestricted')))
    _InitialContextSetupRequestIEs_val_Value_33 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-UP-CIoT-Support')))
    _InitialContextSetupRequestIEs_val_Value_34 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RGLevelWirelineAccessCharacteristics')))
    _InitialContextSetupRequestIEs_val_Value_35 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MDTPLMNList')))
    _InitialContextSetupRequestIEs_val_Value_36 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    _InitialContextSetupRequestIEs_val_Value_37 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TimeSyncAssistanceInfo')))
    _InitialContextSetupRequestIEs_val_Value_38 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QMCConfigInfo')))
    _InitialContextSetupRequestIEs_val_Value_39 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargetNSSAIInformation')))
    _InitialContextSetupRequestIEs_val_Value_40 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESliceMaximumBitRateList')))
    _InitialContextSetupRequestIEs_val_Value_41 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-ProSeAuthorized')))
    _InitialContextSetupRequestIEs_val_Value_42 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _InitialContextSetupRequestIEs_val_Value_43 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-ProSePC5QoSParameters')))
    InitialContextSetupRequestIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _InitialContextSetupRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _InitialContextSetupRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 48), ('criticality', 'reject'), ('Value', _InitialContextSetupRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 110), ('criticality', 'reject'), ('Value', _InitialContextSetupRequestIEs_val_Value_3), ('presence', 'conditional')]), dict([('id', 18), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 28), ('criticality', 'reject'), ('Value', _InitialContextSetupRequestIEs_val_Value_5), ('presence', 'mandatory')]), dict([('id', 71), ('criticality', 'reject'), ('Value', _InitialContextSetupRequestIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'reject'), ('Value', _InitialContextSetupRequestIEs_val_Value_7), ('presence', 'mandatory')]), dict([('id', 119), ('criticality', 'reject'), ('Value', _InitialContextSetupRequestIEs_val_Value_8), ('presence', 'mandatory')]), dict([('id', 94), ('criticality', 'reject'), ('Value', _InitialContextSetupRequestIEs_val_Value_9), ('presence', 'mandatory')]), dict([('id', 108), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 36), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_11), ('presence', 'optional')]), dict([('id', 117), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_12), ('presence', 'optional')]), dict([('id', 31), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_13), ('presence', 'optional')]), dict([('id', 34), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_14), ('presence', 'optional')]), dict([('id', 38), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_15), ('presence', 'optional')]), dict([('id', 24), ('criticality', 'reject'), ('Value', _InitialContextSetupRequestIEs_val_Value_16), ('presence', 'optional')]), dict([('id', 91), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_17), ('presence', 'optional')]), dict([('id', 118), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_18), ('presence', 'optional')]), dict([('id', 146), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_19), ('presence', 'optional')]), dict([('id', 33), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_20), ('presence', 'optional')]), dict([('id', 165), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_21), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_22), ('presence', 'optional')]), dict([('id', 199), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_23), ('presence', 'optional')]), dict([('id', 205), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_24), ('presence', 'optional')]), dict([('id', 206), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_25), ('presence', 'optional')]), dict([('id', 209), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_26), ('presence', 'optional')]), dict([('id', 216), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_27), ('presence', 'optional')]), dict([('id', 215), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_28), ('presence', 'optional')]), dict([('id', 218), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_29), ('presence', 'optional')]), dict([('id', 217), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_30), ('presence', 'optional')]), dict([('id', 219), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_31), ('presence', 'optional')]), dict([('id', 222), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_32), ('presence', 'optional')]), dict([('id', 234), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_33), ('presence', 'optional')]), dict([('id', 238), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_34), ('presence', 'optional')]), dict([('id', 254), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_35), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'reject'), ('Value', _InitialContextSetupRequestIEs_val_Value_36), ('presence', 'optional')]), dict([('id', 326), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_37), ('presence', 'optional')]), dict([('id', 328), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_38), ('presence', 'optional')]), dict([('id', 334), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_39), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_40), ('presence', 'optional')]), dict([('id', 345), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_41), ('presence', 'optional')]), dict([('id', 346), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_42), ('presence', 'optional')]), dict([('id', 347), ('criticality', 'ignore'), ('Value', _InitialContextSetupRequestIEs_val_Value_43), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< InitialContextSetupResponse >-----#
    InitialContextSetupResponse = SEQ(name='InitialContextSetupResponse', mode=MODE_TYPE)
    _InitialContextSetupResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __InitialContextSetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___InitialContextSetupResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____InitialContextSetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupListCxtRes')))
    _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupListCxtRes')))
    _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____InitialContextSetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 72), ('criticality', 'ignore'), ('Value', _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 55), ('criticality', 'ignore'), ('Value', _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___InitialContextSetupResponse_protocolIEs__item__id._const_tab = ____InitialContextSetupResponse_protocolIEs__item__id_tab
    ___InitialContextSetupResponse_protocolIEs__item__id._const_tab_at = None
    ___InitialContextSetupResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___InitialContextSetupResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___InitialContextSetupResponse_protocolIEs__item__criticality._const_tab = ____InitialContextSetupResponse_protocolIEs__item__id_tab
    ___InitialContextSetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___InitialContextSetupResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___InitialContextSetupResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___InitialContextSetupResponse_protocolIEs__item__value._const_tab = ____InitialContextSetupResponse_protocolIEs__item__id_tab
    ___InitialContextSetupResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___InitialContextSetupResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __InitialContextSetupResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___InitialContextSetupResponse_protocolIEs__item__id),
        ('criticality', ___InitialContextSetupResponse_protocolIEs__item__criticality),
        ('value', ___InitialContextSetupResponse_protocolIEs__item__value),
        ])
    __InitialContextSetupResponse_protocolIEs__item_._ext = None
    _InitialContextSetupResponse_protocolIEs._cont = __InitialContextSetupResponse_protocolIEs__item_
    _InitialContextSetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    InitialContextSetupResponse._cont = ASN1Dict([
        ('protocolIEs', _InitialContextSetupResponse_protocolIEs),
        ])
    InitialContextSetupResponse._ext = []
    
    #-----< InitialContextSetupResponseIEs >-----#
    InitialContextSetupResponseIEs = CLASS(name='InitialContextSetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _InitialContextSetupResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _InitialContextSetupResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _InitialContextSetupResponseIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupListCxtRes')))
    _InitialContextSetupResponseIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupListCxtRes')))
    _InitialContextSetupResponseIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    InitialContextSetupResponseIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _InitialContextSetupResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _InitialContextSetupResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 72), ('criticality', 'ignore'), ('Value', _InitialContextSetupResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 55), ('criticality', 'ignore'), ('Value', _InitialContextSetupResponseIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _InitialContextSetupResponseIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< InitialContextSetupFailure >-----#
    InitialContextSetupFailure = SEQ(name='InitialContextSetupFailure', mode=MODE_TYPE)
    _InitialContextSetupFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __InitialContextSetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___InitialContextSetupFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____InitialContextSetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupListCxtFail')))
    _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____InitialContextSetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 132), ('criticality', 'ignore'), ('Value', _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___InitialContextSetupFailure_protocolIEs__item__id._const_tab = ____InitialContextSetupFailure_protocolIEs__item__id_tab
    ___InitialContextSetupFailure_protocolIEs__item__id._const_tab_at = None
    ___InitialContextSetupFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___InitialContextSetupFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___InitialContextSetupFailure_protocolIEs__item__criticality._const_tab = ____InitialContextSetupFailure_protocolIEs__item__id_tab
    ___InitialContextSetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___InitialContextSetupFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___InitialContextSetupFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___InitialContextSetupFailure_protocolIEs__item__value._const_tab = ____InitialContextSetupFailure_protocolIEs__item__id_tab
    ___InitialContextSetupFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___InitialContextSetupFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __InitialContextSetupFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___InitialContextSetupFailure_protocolIEs__item__id),
        ('criticality', ___InitialContextSetupFailure_protocolIEs__item__criticality),
        ('value', ___InitialContextSetupFailure_protocolIEs__item__value),
        ])
    __InitialContextSetupFailure_protocolIEs__item_._ext = None
    _InitialContextSetupFailure_protocolIEs._cont = __InitialContextSetupFailure_protocolIEs__item_
    _InitialContextSetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    InitialContextSetupFailure._cont = ASN1Dict([
        ('protocolIEs', _InitialContextSetupFailure_protocolIEs),
        ])
    InitialContextSetupFailure._ext = []
    
    #-----< InitialContextSetupFailureIEs >-----#
    InitialContextSetupFailureIEs = CLASS(name='InitialContextSetupFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _InitialContextSetupFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _InitialContextSetupFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _InitialContextSetupFailureIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupListCxtFail')))
    _InitialContextSetupFailureIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _InitialContextSetupFailureIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    InitialContextSetupFailureIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _InitialContextSetupFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _InitialContextSetupFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 132), ('criticality', 'ignore'), ('Value', _InitialContextSetupFailureIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _InitialContextSetupFailureIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _InitialContextSetupFailureIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextReleaseRequest >-----#
    UEContextReleaseRequest = SEQ(name='UEContextReleaseRequest', mode=MODE_TYPE)
    _UEContextReleaseRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UEContextReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UEContextReleaseRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____UEContextReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceListCxtRelReq')))
    _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    ____UEContextReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 133), ('criticality', 'reject'), ('Value', _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___UEContextReleaseRequest_protocolIEs__item__id._const_tab = ____UEContextReleaseRequest_protocolIEs__item__id_tab
    ___UEContextReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___UEContextReleaseRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextReleaseRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UEContextReleaseRequest_protocolIEs__item__criticality._const_tab = ____UEContextReleaseRequest_protocolIEs__item__id_tab
    ___UEContextReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextReleaseRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextReleaseRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UEContextReleaseRequest_protocolIEs__item__value._const_tab = ____UEContextReleaseRequest_protocolIEs__item__id_tab
    ___UEContextReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextReleaseRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextReleaseRequest_protocolIEs__item__id),
        ('criticality', ___UEContextReleaseRequest_protocolIEs__item__criticality),
        ('value', ___UEContextReleaseRequest_protocolIEs__item__value),
        ])
    __UEContextReleaseRequest_protocolIEs__item_._ext = None
    _UEContextReleaseRequest_protocolIEs._cont = __UEContextReleaseRequest_protocolIEs__item_
    _UEContextReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextReleaseRequest._cont = ASN1Dict([
        ('protocolIEs', _UEContextReleaseRequest_protocolIEs),
        ])
    UEContextReleaseRequest._ext = []
    
    #-----< UEContextReleaseRequest-IEs >-----#
    UEContextReleaseRequest_IEs = CLASS(name='UEContextReleaseRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UEContextReleaseRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UEContextReleaseRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UEContextReleaseRequest_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceListCxtRelReq')))
    _UEContextReleaseRequest_IEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    UEContextReleaseRequest_IEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _UEContextReleaseRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _UEContextReleaseRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 133), ('criticality', 'reject'), ('Value', _UEContextReleaseRequest_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _UEContextReleaseRequest_IEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEContextReleaseCommand >-----#
    UEContextReleaseCommand = SEQ(name='UEContextReleaseCommand', mode=MODE_TYPE)
    _UEContextReleaseCommand_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UEContextReleaseCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UEContextReleaseCommand_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____UEContextReleaseCommand_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-NGAP-IDs')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    ____UEContextReleaseCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 114), ('criticality', 'reject'), ('Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___UEContextReleaseCommand_protocolIEs__item__id._const_tab = ____UEContextReleaseCommand_protocolIEs__item__id_tab
    ___UEContextReleaseCommand_protocolIEs__item__id._const_tab_at = None
    ___UEContextReleaseCommand_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextReleaseCommand_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UEContextReleaseCommand_protocolIEs__item__criticality._const_tab = ____UEContextReleaseCommand_protocolIEs__item__id_tab
    ___UEContextReleaseCommand_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextReleaseCommand_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextReleaseCommand_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UEContextReleaseCommand_protocolIEs__item__value._const_tab = ____UEContextReleaseCommand_protocolIEs__item__id_tab
    ___UEContextReleaseCommand_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextReleaseCommand_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextReleaseCommand_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextReleaseCommand_protocolIEs__item__id),
        ('criticality', ___UEContextReleaseCommand_protocolIEs__item__criticality),
        ('value', ___UEContextReleaseCommand_protocolIEs__item__value),
        ])
    __UEContextReleaseCommand_protocolIEs__item_._ext = None
    _UEContextReleaseCommand_protocolIEs._cont = __UEContextReleaseCommand_protocolIEs__item_
    _UEContextReleaseCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextReleaseCommand._cont = ASN1Dict([
        ('protocolIEs', _UEContextReleaseCommand_protocolIEs),
        ])
    UEContextReleaseCommand._ext = []
    
    #-----< UEContextReleaseCommand-IEs >-----#
    UEContextReleaseCommand_IEs = CLASS(name='UEContextReleaseCommand-IEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UEContextReleaseCommand_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-NGAP-IDs')))
    _UEContextReleaseCommand_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    UEContextReleaseCommand_IEs._val = ASN1Set(rv=[dict([('id', 114), ('criticality', 'reject'), ('Value', _UEContextReleaseCommand_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _UEContextReleaseCommand_IEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEContextReleaseComplete >-----#
    UEContextReleaseComplete = SEQ(name='UEContextReleaseComplete', mode=MODE_TYPE)
    _UEContextReleaseComplete_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UEContextReleaseComplete_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UEContextReleaseComplete_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____UEContextReleaseComplete_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'InfoOnRecommendedCellsAndRANNodesForPaging')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceListCxtRelCpl')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingAssisDataforCEcapabUE')))
    ____UEContextReleaseComplete_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 32), ('criticality', 'ignore'), ('Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 60), ('criticality', 'reject'), ('Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextReleaseComplete_protocolIEs__item__id._const_tab = ____UEContextReleaseComplete_protocolIEs__item__id_tab
    ___UEContextReleaseComplete_protocolIEs__item__id._const_tab_at = None
    ___UEContextReleaseComplete_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextReleaseComplete_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UEContextReleaseComplete_protocolIEs__item__criticality._const_tab = ____UEContextReleaseComplete_protocolIEs__item__id_tab
    ___UEContextReleaseComplete_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextReleaseComplete_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextReleaseComplete_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UEContextReleaseComplete_protocolIEs__item__value._const_tab = ____UEContextReleaseComplete_protocolIEs__item__id_tab
    ___UEContextReleaseComplete_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextReleaseComplete_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextReleaseComplete_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextReleaseComplete_protocolIEs__item__id),
        ('criticality', ___UEContextReleaseComplete_protocolIEs__item__criticality),
        ('value', ___UEContextReleaseComplete_protocolIEs__item__value),
        ])
    __UEContextReleaseComplete_protocolIEs__item_._ext = None
    _UEContextReleaseComplete_protocolIEs._cont = __UEContextReleaseComplete_protocolIEs__item_
    _UEContextReleaseComplete_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextReleaseComplete._cont = ASN1Dict([
        ('protocolIEs', _UEContextReleaseComplete_protocolIEs),
        ])
    UEContextReleaseComplete._ext = []
    
    #-----< UEContextReleaseComplete-IEs >-----#
    UEContextReleaseComplete_IEs = CLASS(name='UEContextReleaseComplete-IEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UEContextReleaseComplete_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UEContextReleaseComplete_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UEContextReleaseComplete_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _UEContextReleaseComplete_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'InfoOnRecommendedCellsAndRANNodesForPaging')))
    _UEContextReleaseComplete_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceListCxtRelCpl')))
    _UEContextReleaseComplete_IEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _UEContextReleaseComplete_IEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingAssisDataforCEcapabUE')))
    UEContextReleaseComplete_IEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _UEContextReleaseComplete_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _UEContextReleaseComplete_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _UEContextReleaseComplete_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 32), ('criticality', 'ignore'), ('Value', _UEContextReleaseComplete_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 60), ('criticality', 'reject'), ('Value', _UEContextReleaseComplete_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _UEContextReleaseComplete_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _UEContextReleaseComplete_IEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextResumeRequest >-----#
    UEContextResumeRequest = SEQ(name='UEContextResumeRequest', mode=MODE_TYPE)
    _UEContextResumeRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UEContextResumeRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UEContextResumeRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____UEContextResumeRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCEstablishmentCause')))
    _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceResumeListRESReq')))
    _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToResumeListRESReq')))
    _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Suspend-Request-Indication')))
    _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'InfoOnRecommendedCellsAndRANNodesForPaging')))
    _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingAssisDataforCEcapabUE')))
    ____UEContextResumeRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 237), ('criticality', 'ignore'), ('Value', _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 232), ('criticality', 'reject'), ('Value', _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 229), ('criticality', 'reject'), ('Value', _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 235), ('criticality', 'ignore'), ('Value', _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 32), ('criticality', 'ignore'), ('Value', _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextResumeRequest_protocolIEs__item__id._const_tab = ____UEContextResumeRequest_protocolIEs__item__id_tab
    ___UEContextResumeRequest_protocolIEs__item__id._const_tab_at = None
    ___UEContextResumeRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextResumeRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UEContextResumeRequest_protocolIEs__item__criticality._const_tab = ____UEContextResumeRequest_protocolIEs__item__id_tab
    ___UEContextResumeRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextResumeRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextResumeRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UEContextResumeRequest_protocolIEs__item__value._const_tab = ____UEContextResumeRequest_protocolIEs__item__id_tab
    ___UEContextResumeRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextResumeRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextResumeRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextResumeRequest_protocolIEs__item__id),
        ('criticality', ___UEContextResumeRequest_protocolIEs__item__criticality),
        ('value', ___UEContextResumeRequest_protocolIEs__item__value),
        ])
    __UEContextResumeRequest_protocolIEs__item_._ext = None
    _UEContextResumeRequest_protocolIEs._cont = __UEContextResumeRequest_protocolIEs__item_
    _UEContextResumeRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextResumeRequest._cont = ASN1Dict([
        ('protocolIEs', _UEContextResumeRequest_protocolIEs),
        ])
    UEContextResumeRequest._ext = []
    
    #-----< UEContextResumeRequestIEs >-----#
    UEContextResumeRequestIEs = CLASS(name='UEContextResumeRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UEContextResumeRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UEContextResumeRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UEContextResumeRequestIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCEstablishmentCause')))
    _UEContextResumeRequestIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceResumeListRESReq')))
    _UEContextResumeRequestIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToResumeListRESReq')))
    _UEContextResumeRequestIEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Suspend-Request-Indication')))
    _UEContextResumeRequestIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'InfoOnRecommendedCellsAndRANNodesForPaging')))
    _UEContextResumeRequestIEs_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingAssisDataforCEcapabUE')))
    UEContextResumeRequestIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _UEContextResumeRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _UEContextResumeRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 237), ('criticality', 'ignore'), ('Value', _UEContextResumeRequestIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 232), ('criticality', 'reject'), ('Value', _UEContextResumeRequestIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 229), ('criticality', 'reject'), ('Value', _UEContextResumeRequestIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 235), ('criticality', 'ignore'), ('Value', _UEContextResumeRequestIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 32), ('criticality', 'ignore'), ('Value', _UEContextResumeRequestIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _UEContextResumeRequestIEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextResumeResponse >-----#
    UEContextResumeResponse = SEQ(name='UEContextResumeResponse', mode=MODE_TYPE)
    _UEContextResumeResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UEContextResumeResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UEContextResumeResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____UEContextResumeResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceResumeListRESRes')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToResumeListRESRes')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityContext')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Suspend-Response-Indication')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-ConnectedTime')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____UEContextResumeResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 233), ('criticality', 'reject'), ('Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 230), ('criticality', 'reject'), ('Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 93), ('criticality', 'reject'), ('Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 236), ('criticality', 'ignore'), ('Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 206), ('criticality', 'ignore'), ('Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextResumeResponse_protocolIEs__item__id._const_tab = ____UEContextResumeResponse_protocolIEs__item__id_tab
    ___UEContextResumeResponse_protocolIEs__item__id._const_tab_at = None
    ___UEContextResumeResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextResumeResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UEContextResumeResponse_protocolIEs__item__criticality._const_tab = ____UEContextResumeResponse_protocolIEs__item__id_tab
    ___UEContextResumeResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextResumeResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextResumeResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UEContextResumeResponse_protocolIEs__item__value._const_tab = ____UEContextResumeResponse_protocolIEs__item__id_tab
    ___UEContextResumeResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextResumeResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextResumeResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextResumeResponse_protocolIEs__item__id),
        ('criticality', ___UEContextResumeResponse_protocolIEs__item__criticality),
        ('value', ___UEContextResumeResponse_protocolIEs__item__value),
        ])
    __UEContextResumeResponse_protocolIEs__item_._ext = None
    _UEContextResumeResponse_protocolIEs._cont = __UEContextResumeResponse_protocolIEs__item_
    _UEContextResumeResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextResumeResponse._cont = ASN1Dict([
        ('protocolIEs', _UEContextResumeResponse_protocolIEs),
        ])
    UEContextResumeResponse._ext = []
    
    #-----< UEContextResumeResponseIEs >-----#
    UEContextResumeResponseIEs = CLASS(name='UEContextResumeResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UEContextResumeResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UEContextResumeResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UEContextResumeResponseIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceResumeListRESRes')))
    _UEContextResumeResponseIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToResumeListRESRes')))
    _UEContextResumeResponseIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityContext')))
    _UEContextResumeResponseIEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Suspend-Response-Indication')))
    _UEContextResumeResponseIEs_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-ConnectedTime')))
    _UEContextResumeResponseIEs_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    UEContextResumeResponseIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _UEContextResumeResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _UEContextResumeResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 233), ('criticality', 'reject'), ('Value', _UEContextResumeResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 230), ('criticality', 'reject'), ('Value', _UEContextResumeResponseIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 93), ('criticality', 'reject'), ('Value', _UEContextResumeResponseIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 236), ('criticality', 'ignore'), ('Value', _UEContextResumeResponseIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 206), ('criticality', 'ignore'), ('Value', _UEContextResumeResponseIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _UEContextResumeResponseIEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextResumeFailure >-----#
    UEContextResumeFailure = SEQ(name='UEContextResumeFailure', mode=MODE_TYPE)
    _UEContextResumeFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UEContextResumeFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UEContextResumeFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____UEContextResumeFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____UEContextResumeFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextResumeFailure_protocolIEs__item__id._const_tab = ____UEContextResumeFailure_protocolIEs__item__id_tab
    ___UEContextResumeFailure_protocolIEs__item__id._const_tab_at = None
    ___UEContextResumeFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextResumeFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UEContextResumeFailure_protocolIEs__item__criticality._const_tab = ____UEContextResumeFailure_protocolIEs__item__id_tab
    ___UEContextResumeFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextResumeFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextResumeFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UEContextResumeFailure_protocolIEs__item__value._const_tab = ____UEContextResumeFailure_protocolIEs__item__id_tab
    ___UEContextResumeFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextResumeFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextResumeFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextResumeFailure_protocolIEs__item__id),
        ('criticality', ___UEContextResumeFailure_protocolIEs__item__criticality),
        ('value', ___UEContextResumeFailure_protocolIEs__item__value),
        ])
    __UEContextResumeFailure_protocolIEs__item_._ext = None
    _UEContextResumeFailure_protocolIEs._cont = __UEContextResumeFailure_protocolIEs__item_
    _UEContextResumeFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextResumeFailure._cont = ASN1Dict([
        ('protocolIEs', _UEContextResumeFailure_protocolIEs),
        ])
    UEContextResumeFailure._ext = []
    
    #-----< UEContextResumeFailureIEs >-----#
    UEContextResumeFailureIEs = CLASS(name='UEContextResumeFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UEContextResumeFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UEContextResumeFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UEContextResumeFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _UEContextResumeFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    UEContextResumeFailureIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _UEContextResumeFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _UEContextResumeFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _UEContextResumeFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _UEContextResumeFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextSuspendRequest >-----#
    UEContextSuspendRequest = SEQ(name='UEContextSuspendRequest', mode=MODE_TYPE)
    _UEContextSuspendRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UEContextSuspendRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UEContextSuspendRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____UEContextSuspendRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'InfoOnRecommendedCellsAndRANNodesForPaging')))
    _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingAssisDataforCEcapabUE')))
    _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSuspendListSUSReq')))
    ____UEContextSuspendRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 32), ('criticality', 'ignore'), ('Value', _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 231), ('criticality', 'reject'), ('Value', _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextSuspendRequest_protocolIEs__item__id._const_tab = ____UEContextSuspendRequest_protocolIEs__item__id_tab
    ___UEContextSuspendRequest_protocolIEs__item__id._const_tab_at = None
    ___UEContextSuspendRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextSuspendRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UEContextSuspendRequest_protocolIEs__item__criticality._const_tab = ____UEContextSuspendRequest_protocolIEs__item__id_tab
    ___UEContextSuspendRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextSuspendRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextSuspendRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UEContextSuspendRequest_protocolIEs__item__value._const_tab = ____UEContextSuspendRequest_protocolIEs__item__id_tab
    ___UEContextSuspendRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextSuspendRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextSuspendRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextSuspendRequest_protocolIEs__item__id),
        ('criticality', ___UEContextSuspendRequest_protocolIEs__item__criticality),
        ('value', ___UEContextSuspendRequest_protocolIEs__item__value),
        ])
    __UEContextSuspendRequest_protocolIEs__item_._ext = None
    _UEContextSuspendRequest_protocolIEs._cont = __UEContextSuspendRequest_protocolIEs__item_
    _UEContextSuspendRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextSuspendRequest._cont = ASN1Dict([
        ('protocolIEs', _UEContextSuspendRequest_protocolIEs),
        ])
    UEContextSuspendRequest._ext = []
    
    #-----< UEContextSuspendRequestIEs >-----#
    UEContextSuspendRequestIEs = CLASS(name='UEContextSuspendRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UEContextSuspendRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UEContextSuspendRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UEContextSuspendRequestIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'InfoOnRecommendedCellsAndRANNodesForPaging')))
    _UEContextSuspendRequestIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingAssisDataforCEcapabUE')))
    _UEContextSuspendRequestIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSuspendListSUSReq')))
    UEContextSuspendRequestIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _UEContextSuspendRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _UEContextSuspendRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 32), ('criticality', 'ignore'), ('Value', _UEContextSuspendRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 207), ('criticality', 'ignore'), ('Value', _UEContextSuspendRequestIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 231), ('criticality', 'reject'), ('Value', _UEContextSuspendRequestIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextSuspendResponse >-----#
    UEContextSuspendResponse = SEQ(name='UEContextSuspendResponse', mode=MODE_TYPE)
    _UEContextSuspendResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UEContextSuspendResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UEContextSuspendResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____UEContextSuspendResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityContext')))
    _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____UEContextSuspendResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 93), ('criticality', 'reject'), ('Value', _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextSuspendResponse_protocolIEs__item__id._const_tab = ____UEContextSuspendResponse_protocolIEs__item__id_tab
    ___UEContextSuspendResponse_protocolIEs__item__id._const_tab_at = None
    ___UEContextSuspendResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextSuspendResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UEContextSuspendResponse_protocolIEs__item__criticality._const_tab = ____UEContextSuspendResponse_protocolIEs__item__id_tab
    ___UEContextSuspendResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextSuspendResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextSuspendResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UEContextSuspendResponse_protocolIEs__item__value._const_tab = ____UEContextSuspendResponse_protocolIEs__item__id_tab
    ___UEContextSuspendResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextSuspendResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextSuspendResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextSuspendResponse_protocolIEs__item__id),
        ('criticality', ___UEContextSuspendResponse_protocolIEs__item__criticality),
        ('value', ___UEContextSuspendResponse_protocolIEs__item__value),
        ])
    __UEContextSuspendResponse_protocolIEs__item_._ext = None
    _UEContextSuspendResponse_protocolIEs._cont = __UEContextSuspendResponse_protocolIEs__item_
    _UEContextSuspendResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextSuspendResponse._cont = ASN1Dict([
        ('protocolIEs', _UEContextSuspendResponse_protocolIEs),
        ])
    UEContextSuspendResponse._ext = []
    
    #-----< UEContextSuspendResponseIEs >-----#
    UEContextSuspendResponseIEs = CLASS(name='UEContextSuspendResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UEContextSuspendResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UEContextSuspendResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UEContextSuspendResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityContext')))
    _UEContextSuspendResponseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    UEContextSuspendResponseIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _UEContextSuspendResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _UEContextSuspendResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 93), ('criticality', 'reject'), ('Value', _UEContextSuspendResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _UEContextSuspendResponseIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextSuspendFailure >-----#
    UEContextSuspendFailure = SEQ(name='UEContextSuspendFailure', mode=MODE_TYPE)
    _UEContextSuspendFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UEContextSuspendFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UEContextSuspendFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____UEContextSuspendFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UEContextSuspendFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UEContextSuspendFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UEContextSuspendFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____UEContextSuspendFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____UEContextSuspendFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _____UEContextSuspendFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____UEContextSuspendFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____UEContextSuspendFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____UEContextSuspendFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextSuspendFailure_protocolIEs__item__id._const_tab = ____UEContextSuspendFailure_protocolIEs__item__id_tab
    ___UEContextSuspendFailure_protocolIEs__item__id._const_tab_at = None
    ___UEContextSuspendFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextSuspendFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UEContextSuspendFailure_protocolIEs__item__criticality._const_tab = ____UEContextSuspendFailure_protocolIEs__item__id_tab
    ___UEContextSuspendFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextSuspendFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextSuspendFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UEContextSuspendFailure_protocolIEs__item__value._const_tab = ____UEContextSuspendFailure_protocolIEs__item__id_tab
    ___UEContextSuspendFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextSuspendFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextSuspendFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextSuspendFailure_protocolIEs__item__id),
        ('criticality', ___UEContextSuspendFailure_protocolIEs__item__criticality),
        ('value', ___UEContextSuspendFailure_protocolIEs__item__value),
        ])
    __UEContextSuspendFailure_protocolIEs__item_._ext = None
    _UEContextSuspendFailure_protocolIEs._cont = __UEContextSuspendFailure_protocolIEs__item_
    _UEContextSuspendFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextSuspendFailure._cont = ASN1Dict([
        ('protocolIEs', _UEContextSuspendFailure_protocolIEs),
        ])
    UEContextSuspendFailure._ext = []
    
    #-----< UEContextSuspendFailureIEs >-----#
    UEContextSuspendFailureIEs = CLASS(name='UEContextSuspendFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UEContextSuspendFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UEContextSuspendFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UEContextSuspendFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _UEContextSuspendFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    UEContextSuspendFailureIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _UEContextSuspendFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _UEContextSuspendFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _UEContextSuspendFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _UEContextSuspendFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationRequest >-----#
    UEContextModificationRequest = SEQ(name='UEContextModificationRequest', mode=MODE_TYPE)
    _UEContextModificationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____UEContextModificationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANPagingPriority')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityKey')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IndexToRFSP')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEAggregateMaximumBitRate')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESecurityCapabilities')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CoreNetworkAssistanceInformationForInactive')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EmergencyFallbackIndicator')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCInactiveTransitionReportRequest')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GUAMI')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_12 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CNAssistedRANTuning')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SRVCCOperationPossible')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_14 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IAB-Authorized')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_15 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRV2XServicesAuthorized')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_16 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEV2XServicesAuthorized')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_17 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_18 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEUESidelinkAggregateMaximumBitrate')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_19 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PC5QoSParameters')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_20 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_21 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RGLevelWirelineAccessCharacteristics')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_22 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TimeSyncAssistanceInfo')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_23 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QMCConfigInfo')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_24 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QMCDeactivation')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_25 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESliceMaximumBitRateList')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_26 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MDTPLMNModificationList')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_27 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-ProSeAuthorized')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_28 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_29 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-ProSePC5QoSParameters')))
    ____UEContextModificationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 83), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 94), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 31), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 110), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 119), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 18), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 24), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 91), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 162), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 165), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 199), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 216), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')]), dict([('id', 215), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')]), dict([('id', 218), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_17), ('presence', 'optional')]), dict([('id', 217), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_18), ('presence', 'optional')]), dict([('id', 219), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_19), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'reject'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_20), ('presence', 'optional')]), dict([('id', 238), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_21), ('presence', 'optional')]), dict([('id', 326), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_22), ('presence', 'optional')]), dict([('id', 328), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_23), ('presence', 'optional')]), dict([('id', 329), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_24), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_25), ('presence', 'optional')]), dict([('id', 359), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_26), ('presence', 'optional')]), dict([('id', 345), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_27), ('presence', 'optional')]), dict([('id', 346), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_28), ('presence', 'optional')]), dict([('id', 347), ('criticality', 'ignore'), ('Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_29), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationRequest_protocolIEs__item__id._const_tab = ____UEContextModificationRequest_protocolIEs__item__id_tab
    ___UEContextModificationRequest_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextModificationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UEContextModificationRequest_protocolIEs__item__criticality._const_tab = ____UEContextModificationRequest_protocolIEs__item__id_tab
    ___UEContextModificationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextModificationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextModificationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UEContextModificationRequest_protocolIEs__item__value._const_tab = ____UEContextModificationRequest_protocolIEs__item__id_tab
    ___UEContextModificationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextModificationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextModificationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextModificationRequest_protocolIEs__item__id),
        ('criticality', ___UEContextModificationRequest_protocolIEs__item__criticality),
        ('value', ___UEContextModificationRequest_protocolIEs__item__value),
        ])
    __UEContextModificationRequest_protocolIEs__item_._ext = None
    _UEContextModificationRequest_protocolIEs._cont = __UEContextModificationRequest_protocolIEs__item_
    _UEContextModificationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationRequest._cont = ASN1Dict([
        ('protocolIEs', _UEContextModificationRequest_protocolIEs),
        ])
    UEContextModificationRequest._ext = []
    
    #-----< UEContextModificationRequestIEs >-----#
    UEContextModificationRequestIEs = CLASS(name='UEContextModificationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UEContextModificationRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UEContextModificationRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UEContextModificationRequestIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANPagingPriority')))
    _UEContextModificationRequestIEs_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityKey')))
    _UEContextModificationRequestIEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IndexToRFSP')))
    _UEContextModificationRequestIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEAggregateMaximumBitRate')))
    _UEContextModificationRequestIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESecurityCapabilities')))
    _UEContextModificationRequestIEs_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CoreNetworkAssistanceInformationForInactive')))
    _UEContextModificationRequestIEs_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EmergencyFallbackIndicator')))
    _UEContextModificationRequestIEs_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UEContextModificationRequestIEs_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCInactiveTransitionReportRequest')))
    _UEContextModificationRequestIEs_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GUAMI')))
    _UEContextModificationRequestIEs_val_Value_12 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CNAssistedRANTuning')))
    _UEContextModificationRequestIEs_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SRVCCOperationPossible')))
    _UEContextModificationRequestIEs_val_Value_14 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IAB-Authorized')))
    _UEContextModificationRequestIEs_val_Value_15 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRV2XServicesAuthorized')))
    _UEContextModificationRequestIEs_val_Value_16 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEV2XServicesAuthorized')))
    _UEContextModificationRequestIEs_val_Value_17 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _UEContextModificationRequestIEs_val_Value_18 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEUESidelinkAggregateMaximumBitrate')))
    _UEContextModificationRequestIEs_val_Value_19 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PC5QoSParameters')))
    _UEContextModificationRequestIEs_val_Value_20 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    _UEContextModificationRequestIEs_val_Value_21 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RGLevelWirelineAccessCharacteristics')))
    _UEContextModificationRequestIEs_val_Value_22 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TimeSyncAssistanceInfo')))
    _UEContextModificationRequestIEs_val_Value_23 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QMCConfigInfo')))
    _UEContextModificationRequestIEs_val_Value_24 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'QMCDeactivation')))
    _UEContextModificationRequestIEs_val_Value_25 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESliceMaximumBitRateList')))
    _UEContextModificationRequestIEs_val_Value_26 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MDTPLMNModificationList')))
    _UEContextModificationRequestIEs_val_Value_27 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-ProSeAuthorized')))
    _UEContextModificationRequestIEs_val_Value_28 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _UEContextModificationRequestIEs_val_Value_29 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-ProSePC5QoSParameters')))
    UEContextModificationRequestIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 83), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 94), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 31), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 110), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 119), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 18), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 24), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 91), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 162), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_11), ('presence', 'optional')]), dict([('id', 165), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_12), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_13), ('presence', 'optional')]), dict([('id', 199), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_14), ('presence', 'optional')]), dict([('id', 216), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_15), ('presence', 'optional')]), dict([('id', 215), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_16), ('presence', 'optional')]), dict([('id', 218), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_17), ('presence', 'optional')]), dict([('id', 217), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_18), ('presence', 'optional')]), dict([('id', 219), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_19), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'reject'), ('Value', _UEContextModificationRequestIEs_val_Value_20), ('presence', 'optional')]), dict([('id', 238), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_21), ('presence', 'optional')]), dict([('id', 326), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_22), ('presence', 'optional')]), dict([('id', 328), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_23), ('presence', 'optional')]), dict([('id', 329), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_24), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_25), ('presence', 'optional')]), dict([('id', 359), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_26), ('presence', 'optional')]), dict([('id', 345), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_27), ('presence', 'optional')]), dict([('id', 346), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_28), ('presence', 'optional')]), dict([('id', 347), ('criticality', 'ignore'), ('Value', _UEContextModificationRequestIEs_val_Value_29), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationResponse >-----#
    UEContextModificationResponse = SEQ(name='UEContextModificationResponse', mode=MODE_TYPE)
    _UEContextModificationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____UEContextModificationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCState')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____UEContextModificationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 92), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationResponse_protocolIEs__item__id._const_tab = ____UEContextModificationResponse_protocolIEs__item__id_tab
    ___UEContextModificationResponse_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextModificationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UEContextModificationResponse_protocolIEs__item__criticality._const_tab = ____UEContextModificationResponse_protocolIEs__item__id_tab
    ___UEContextModificationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextModificationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextModificationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UEContextModificationResponse_protocolIEs__item__value._const_tab = ____UEContextModificationResponse_protocolIEs__item__id_tab
    ___UEContextModificationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextModificationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextModificationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextModificationResponse_protocolIEs__item__id),
        ('criticality', ___UEContextModificationResponse_protocolIEs__item__criticality),
        ('value', ___UEContextModificationResponse_protocolIEs__item__value),
        ])
    __UEContextModificationResponse_protocolIEs__item_._ext = None
    _UEContextModificationResponse_protocolIEs._cont = __UEContextModificationResponse_protocolIEs__item_
    _UEContextModificationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationResponse._cont = ASN1Dict([
        ('protocolIEs', _UEContextModificationResponse_protocolIEs),
        ])
    UEContextModificationResponse._ext = []
    
    #-----< UEContextModificationResponseIEs >-----#
    UEContextModificationResponseIEs = CLASS(name='UEContextModificationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UEContextModificationResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UEContextModificationResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UEContextModificationResponseIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCState')))
    _UEContextModificationResponseIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _UEContextModificationResponseIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    UEContextModificationResponseIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 92), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _UEContextModificationResponseIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationFailure >-----#
    UEContextModificationFailure = SEQ(name='UEContextModificationFailure', mode=MODE_TYPE)
    _UEContextModificationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____UEContextModificationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____UEContextModificationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationFailure_protocolIEs__item__id._const_tab = ____UEContextModificationFailure_protocolIEs__item__id_tab
    ___UEContextModificationFailure_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___UEContextModificationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UEContextModificationFailure_protocolIEs__item__criticality._const_tab = ____UEContextModificationFailure_protocolIEs__item__id_tab
    ___UEContextModificationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEContextModificationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEContextModificationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UEContextModificationFailure_protocolIEs__item__value._const_tab = ____UEContextModificationFailure_protocolIEs__item__id_tab
    ___UEContextModificationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEContextModificationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __UEContextModificationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEContextModificationFailure_protocolIEs__item__id),
        ('criticality', ___UEContextModificationFailure_protocolIEs__item__criticality),
        ('value', ___UEContextModificationFailure_protocolIEs__item__value),
        ])
    __UEContextModificationFailure_protocolIEs__item_._ext = None
    _UEContextModificationFailure_protocolIEs._cont = __UEContextModificationFailure_protocolIEs__item_
    _UEContextModificationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationFailure._cont = ASN1Dict([
        ('protocolIEs', _UEContextModificationFailure_protocolIEs),
        ])
    UEContextModificationFailure._ext = []
    
    #-----< UEContextModificationFailureIEs >-----#
    UEContextModificationFailureIEs = CLASS(name='UEContextModificationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UEContextModificationFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UEContextModificationFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UEContextModificationFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _UEContextModificationFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    UEContextModificationFailureIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _UEContextModificationFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _UEContextModificationFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _UEContextModificationFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _UEContextModificationFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RRCInactiveTransitionReport >-----#
    RRCInactiveTransitionReport = SEQ(name='RRCInactiveTransitionReport', mode=MODE_TYPE)
    _RRCInactiveTransitionReport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __RRCInactiveTransitionReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___RRCInactiveTransitionReport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____RRCInactiveTransitionReport_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____RRCInactiveTransitionReport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____RRCInactiveTransitionReport_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____RRCInactiveTransitionReport_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCState')))
    _____RRCInactiveTransitionReport_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    ____RRCInactiveTransitionReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____RRCInactiveTransitionReport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____RRCInactiveTransitionReport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 92), ('criticality', 'ignore'), ('Value', _____RRCInactiveTransitionReport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _____RRCInactiveTransitionReport_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RRCInactiveTransitionReport_protocolIEs__item__id._const_tab = ____RRCInactiveTransitionReport_protocolIEs__item__id_tab
    ___RRCInactiveTransitionReport_protocolIEs__item__id._const_tab_at = None
    ___RRCInactiveTransitionReport_protocolIEs__item__id._const_tab_id = 'id'
    ___RRCInactiveTransitionReport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___RRCInactiveTransitionReport_protocolIEs__item__criticality._const_tab = ____RRCInactiveTransitionReport_protocolIEs__item__id_tab
    ___RRCInactiveTransitionReport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RRCInactiveTransitionReport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RRCInactiveTransitionReport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___RRCInactiveTransitionReport_protocolIEs__item__value._const_tab = ____RRCInactiveTransitionReport_protocolIEs__item__id_tab
    ___RRCInactiveTransitionReport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RRCInactiveTransitionReport_protocolIEs__item__value._const_tab_id = 'Value'
    __RRCInactiveTransitionReport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RRCInactiveTransitionReport_protocolIEs__item__id),
        ('criticality', ___RRCInactiveTransitionReport_protocolIEs__item__criticality),
        ('value', ___RRCInactiveTransitionReport_protocolIEs__item__value),
        ])
    __RRCInactiveTransitionReport_protocolIEs__item_._ext = None
    _RRCInactiveTransitionReport_protocolIEs._cont = __RRCInactiveTransitionReport_protocolIEs__item_
    _RRCInactiveTransitionReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RRCInactiveTransitionReport._cont = ASN1Dict([
        ('protocolIEs', _RRCInactiveTransitionReport_protocolIEs),
        ])
    RRCInactiveTransitionReport._ext = []
    
    #-----< RRCInactiveTransitionReportIEs >-----#
    RRCInactiveTransitionReportIEs = CLASS(name='RRCInactiveTransitionReportIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _RRCInactiveTransitionReportIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _RRCInactiveTransitionReportIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _RRCInactiveTransitionReportIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCState')))
    _RRCInactiveTransitionReportIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    RRCInactiveTransitionReportIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _RRCInactiveTransitionReportIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _RRCInactiveTransitionReportIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 92), ('criticality', 'ignore'), ('Value', _RRCInactiveTransitionReportIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _RRCInactiveTransitionReportIEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RetrieveUEInformation >-----#
    RetrieveUEInformation = SEQ(name='RetrieveUEInformation', mode=MODE_TYPE)
    _RetrieveUEInformation_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __RetrieveUEInformation_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___RetrieveUEInformation_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____RetrieveUEInformation_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____RetrieveUEInformation_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-S-TMSI')))
    ____RetrieveUEInformation_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 26), ('criticality', 'reject'), ('Value', _____RetrieveUEInformation_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RetrieveUEInformation_protocolIEs__item__id._const_tab = ____RetrieveUEInformation_protocolIEs__item__id_tab
    ___RetrieveUEInformation_protocolIEs__item__id._const_tab_at = None
    ___RetrieveUEInformation_protocolIEs__item__id._const_tab_id = 'id'
    ___RetrieveUEInformation_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___RetrieveUEInformation_protocolIEs__item__criticality._const_tab = ____RetrieveUEInformation_protocolIEs__item__id_tab
    ___RetrieveUEInformation_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RetrieveUEInformation_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RetrieveUEInformation_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___RetrieveUEInformation_protocolIEs__item__value._const_tab = ____RetrieveUEInformation_protocolIEs__item__id_tab
    ___RetrieveUEInformation_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RetrieveUEInformation_protocolIEs__item__value._const_tab_id = 'Value'
    __RetrieveUEInformation_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RetrieveUEInformation_protocolIEs__item__id),
        ('criticality', ___RetrieveUEInformation_protocolIEs__item__criticality),
        ('value', ___RetrieveUEInformation_protocolIEs__item__value),
        ])
    __RetrieveUEInformation_protocolIEs__item_._ext = None
    _RetrieveUEInformation_protocolIEs._cont = __RetrieveUEInformation_protocolIEs__item_
    _RetrieveUEInformation_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RetrieveUEInformation._cont = ASN1Dict([
        ('protocolIEs', _RetrieveUEInformation_protocolIEs),
        ])
    RetrieveUEInformation._ext = []
    
    #-----< RetrieveUEInformationIEs >-----#
    RetrieveUEInformationIEs = CLASS(name='RetrieveUEInformationIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _RetrieveUEInformationIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-S-TMSI')))
    RetrieveUEInformationIEs._val = ASN1Set(rv=[dict([('id', 26), ('criticality', 'reject'), ('Value', _RetrieveUEInformationIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEInformationTransfer >-----#
    UEInformationTransfer = SEQ(name='UEInformationTransfer', mode=MODE_TYPE)
    _UEInformationTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UEInformationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UEInformationTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____UEInformationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-S-TMSI')))
    _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-UEPriority')))
    _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-DifferentiationInfo')))
    _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_6 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MaskedIMEISV')))
    ____UEInformationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 26), ('criticality', 'reject'), ('Value', _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 210), ('criticality', 'ignore'), ('Value', _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 117), ('criticality', 'ignore'), ('Value', _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 148), ('criticality', 'ignore'), ('Value', _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 209), ('criticality', 'ignore'), ('Value', _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 34), ('criticality', 'ignore'), ('Value', _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UEInformationTransfer_protocolIEs__item__id._const_tab = ____UEInformationTransfer_protocolIEs__item__id_tab
    ___UEInformationTransfer_protocolIEs__item__id._const_tab_at = None
    ___UEInformationTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___UEInformationTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UEInformationTransfer_protocolIEs__item__criticality._const_tab = ____UEInformationTransfer_protocolIEs__item__id_tab
    ___UEInformationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UEInformationTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UEInformationTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UEInformationTransfer_protocolIEs__item__value._const_tab = ____UEInformationTransfer_protocolIEs__item__id_tab
    ___UEInformationTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UEInformationTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __UEInformationTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UEInformationTransfer_protocolIEs__item__id),
        ('criticality', ___UEInformationTransfer_protocolIEs__item__criticality),
        ('value', ___UEInformationTransfer_protocolIEs__item__value),
        ])
    __UEInformationTransfer_protocolIEs__item_._ext = None
    _UEInformationTransfer_protocolIEs._cont = __UEInformationTransfer_protocolIEs__item_
    _UEInformationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEInformationTransfer._cont = ASN1Dict([
        ('protocolIEs', _UEInformationTransfer_protocolIEs),
        ])
    UEInformationTransfer._ext = []
    
    #-----< UEInformationTransferIEs >-----#
    UEInformationTransferIEs = CLASS(name='UEInformationTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UEInformationTransferIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-S-TMSI')))
    _UEInformationTransferIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-UEPriority')))
    _UEInformationTransferIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _UEInformationTransferIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _UEInformationTransferIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _UEInformationTransferIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-DifferentiationInfo')))
    _UEInformationTransferIEs_val_Value_6 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MaskedIMEISV')))
    UEInformationTransferIEs._val = ASN1Set(rv=[dict([('id', 26), ('criticality', 'reject'), ('Value', _UEInformationTransferIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 210), ('criticality', 'ignore'), ('Value', _UEInformationTransferIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 117), ('criticality', 'ignore'), ('Value', _UEInformationTransferIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 148), ('criticality', 'ignore'), ('Value', _UEInformationTransferIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _UEInformationTransferIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 209), ('criticality', 'ignore'), ('Value', _UEInformationTransferIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 34), ('criticality', 'ignore'), ('Value', _UEInformationTransferIEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RANCPRelocationIndication >-----#
    RANCPRelocationIndication = SEQ(name='RANCPRelocationIndication', mode=MODE_TYPE)
    _RANCPRelocationIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __RANCPRelocationIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___RANCPRelocationIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____RANCPRelocationIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-S-TMSI')))
    _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UL-CP-SecurityInformation')))
    ____RANCPRelocationIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 85), ('criticality', 'reject'), ('Value', _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 26), ('criticality', 'reject'), ('Value', _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 25), ('criticality', 'ignore'), ('Value', _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 213), ('criticality', 'ignore'), ('Value', _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 211), ('criticality', 'reject'), ('Value', _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RANCPRelocationIndication_protocolIEs__item__id._const_tab = ____RANCPRelocationIndication_protocolIEs__item__id_tab
    ___RANCPRelocationIndication_protocolIEs__item__id._const_tab_at = None
    ___RANCPRelocationIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___RANCPRelocationIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___RANCPRelocationIndication_protocolIEs__item__criticality._const_tab = ____RANCPRelocationIndication_protocolIEs__item__id_tab
    ___RANCPRelocationIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RANCPRelocationIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RANCPRelocationIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___RANCPRelocationIndication_protocolIEs__item__value._const_tab = ____RANCPRelocationIndication_protocolIEs__item__id_tab
    ___RANCPRelocationIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RANCPRelocationIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __RANCPRelocationIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RANCPRelocationIndication_protocolIEs__item__id),
        ('criticality', ___RANCPRelocationIndication_protocolIEs__item__criticality),
        ('value', ___RANCPRelocationIndication_protocolIEs__item__value),
        ])
    __RANCPRelocationIndication_protocolIEs__item_._ext = None
    _RANCPRelocationIndication_protocolIEs._cont = __RANCPRelocationIndication_protocolIEs__item_
    _RANCPRelocationIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RANCPRelocationIndication._cont = ASN1Dict([
        ('protocolIEs', _RANCPRelocationIndication_protocolIEs),
        ])
    RANCPRelocationIndication._ext = []
    
    #-----< RANCPRelocationIndicationIEs >-----#
    RANCPRelocationIndicationIEs = CLASS(name='RANCPRelocationIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _RANCPRelocationIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _RANCPRelocationIndicationIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-S-TMSI')))
    _RANCPRelocationIndicationIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-CGI')))
    _RANCPRelocationIndicationIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAI')))
    _RANCPRelocationIndicationIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UL-CP-SecurityInformation')))
    RANCPRelocationIndicationIEs._val = ASN1Set(rv=[dict([('id', 85), ('criticality', 'reject'), ('Value', _RANCPRelocationIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 26), ('criticality', 'reject'), ('Value', _RANCPRelocationIndicationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 25), ('criticality', 'ignore'), ('Value', _RANCPRelocationIndicationIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 213), ('criticality', 'ignore'), ('Value', _RANCPRelocationIndicationIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 211), ('criticality', 'reject'), ('Value', _RANCPRelocationIndicationIEs_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< HandoverRequired >-----#
    HandoverRequired = SEQ(name='HandoverRequired', mode=MODE_TYPE)
    _HandoverRequired_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __HandoverRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___HandoverRequired_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____HandoverRequired_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HandoverType')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargetID')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DirectForwardingPathAvailability')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceListHORqd')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SourceToTarget-TransparentContainer')))
    ____HandoverRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 29), ('criticality', 'reject'), ('Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 105), ('criticality', 'reject'), ('Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 22), ('criticality', 'ignore'), ('Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 61), ('criticality', 'reject'), ('Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_6), ('presence', 'mandatory')]), dict([('id', 101), ('criticality', 'reject'), ('Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_7), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___HandoverRequired_protocolIEs__item__id._const_tab = ____HandoverRequired_protocolIEs__item__id_tab
    ___HandoverRequired_protocolIEs__item__id._const_tab_at = None
    ___HandoverRequired_protocolIEs__item__id._const_tab_id = 'id'
    ___HandoverRequired_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___HandoverRequired_protocolIEs__item__criticality._const_tab = ____HandoverRequired_protocolIEs__item__id_tab
    ___HandoverRequired_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverRequired_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HandoverRequired_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___HandoverRequired_protocolIEs__item__value._const_tab = ____HandoverRequired_protocolIEs__item__id_tab
    ___HandoverRequired_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HandoverRequired_protocolIEs__item__value._const_tab_id = 'Value'
    __HandoverRequired_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HandoverRequired_protocolIEs__item__id),
        ('criticality', ___HandoverRequired_protocolIEs__item__criticality),
        ('value', ___HandoverRequired_protocolIEs__item__value),
        ])
    __HandoverRequired_protocolIEs__item_._ext = None
    _HandoverRequired_protocolIEs._cont = __HandoverRequired_protocolIEs__item_
    _HandoverRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverRequired._cont = ASN1Dict([
        ('protocolIEs', _HandoverRequired_protocolIEs),
        ])
    HandoverRequired._ext = []
    
    #-----< HandoverRequiredIEs >-----#
    HandoverRequiredIEs = CLASS(name='HandoverRequiredIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _HandoverRequiredIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _HandoverRequiredIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _HandoverRequiredIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HandoverType')))
    _HandoverRequiredIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _HandoverRequiredIEs_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargetID')))
    _HandoverRequiredIEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DirectForwardingPathAvailability')))
    _HandoverRequiredIEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceListHORqd')))
    _HandoverRequiredIEs_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SourceToTarget-TransparentContainer')))
    HandoverRequiredIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _HandoverRequiredIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _HandoverRequiredIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 29), ('criticality', 'reject'), ('Value', _HandoverRequiredIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _HandoverRequiredIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 105), ('criticality', 'reject'), ('Value', _HandoverRequiredIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 22), ('criticality', 'ignore'), ('Value', _HandoverRequiredIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 61), ('criticality', 'reject'), ('Value', _HandoverRequiredIEs_val_Value_6), ('presence', 'mandatory')]), dict([('id', 101), ('criticality', 'reject'), ('Value', _HandoverRequiredIEs_val_Value_7), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< HandoverCommand >-----#
    HandoverCommand = SEQ(name='HandoverCommand', mode=MODE_TYPE)
    _HandoverCommand_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __HandoverCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___HandoverCommand_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____HandoverCommand_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HandoverType')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NASSecurityParametersFromNGRAN')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceHandoverList')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceToReleaseListHOCmd')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargetToSource-TransparentContainer')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____HandoverCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 29), ('criticality', 'reject'), ('Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 39), ('criticality', 'reject'), ('Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_3), ('presence', 'conditional')]), dict([('id', 59), ('criticality', 'ignore'), ('Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 78), ('criticality', 'ignore'), ('Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 106), ('criticality', 'reject'), ('Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_6), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HandoverCommand_protocolIEs__item__id._const_tab = ____HandoverCommand_protocolIEs__item__id_tab
    ___HandoverCommand_protocolIEs__item__id._const_tab_at = None
    ___HandoverCommand_protocolIEs__item__id._const_tab_id = 'id'
    ___HandoverCommand_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___HandoverCommand_protocolIEs__item__criticality._const_tab = ____HandoverCommand_protocolIEs__item__id_tab
    ___HandoverCommand_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverCommand_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HandoverCommand_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___HandoverCommand_protocolIEs__item__value._const_tab = ____HandoverCommand_protocolIEs__item__id_tab
    ___HandoverCommand_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HandoverCommand_protocolIEs__item__value._const_tab_id = 'Value'
    __HandoverCommand_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HandoverCommand_protocolIEs__item__id),
        ('criticality', ___HandoverCommand_protocolIEs__item__criticality),
        ('value', ___HandoverCommand_protocolIEs__item__value),
        ])
    __HandoverCommand_protocolIEs__item_._ext = None
    _HandoverCommand_protocolIEs._cont = __HandoverCommand_protocolIEs__item_
    _HandoverCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverCommand._cont = ASN1Dict([
        ('protocolIEs', _HandoverCommand_protocolIEs),
        ])
    HandoverCommand._ext = []
    
    #-----< HandoverCommandIEs >-----#
    HandoverCommandIEs = CLASS(name='HandoverCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _HandoverCommandIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _HandoverCommandIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _HandoverCommandIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HandoverType')))
    _HandoverCommandIEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NASSecurityParametersFromNGRAN')))
    _HandoverCommandIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceHandoverList')))
    _HandoverCommandIEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceToReleaseListHOCmd')))
    _HandoverCommandIEs_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargetToSource-TransparentContainer')))
    _HandoverCommandIEs_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    HandoverCommandIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _HandoverCommandIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _HandoverCommandIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 29), ('criticality', 'reject'), ('Value', _HandoverCommandIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 39), ('criticality', 'reject'), ('Value', _HandoverCommandIEs_val_Value_3), ('presence', 'conditional')]), dict([('id', 59), ('criticality', 'ignore'), ('Value', _HandoverCommandIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 78), ('criticality', 'ignore'), ('Value', _HandoverCommandIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 106), ('criticality', 'reject'), ('Value', _HandoverCommandIEs_val_Value_6), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _HandoverCommandIEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverPreparationFailure >-----#
    HandoverPreparationFailure = SEQ(name='HandoverPreparationFailure', mode=MODE_TYPE)
    _HandoverPreparationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __HandoverPreparationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___HandoverPreparationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____HandoverPreparationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargettoSource-Failure-TransparentContainer')))
    ____HandoverPreparationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 262), ('criticality', 'ignore'), ('Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HandoverPreparationFailure_protocolIEs__item__id._const_tab = ____HandoverPreparationFailure_protocolIEs__item__id_tab
    ___HandoverPreparationFailure_protocolIEs__item__id._const_tab_at = None
    ___HandoverPreparationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___HandoverPreparationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___HandoverPreparationFailure_protocolIEs__item__criticality._const_tab = ____HandoverPreparationFailure_protocolIEs__item__id_tab
    ___HandoverPreparationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverPreparationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HandoverPreparationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___HandoverPreparationFailure_protocolIEs__item__value._const_tab = ____HandoverPreparationFailure_protocolIEs__item__id_tab
    ___HandoverPreparationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HandoverPreparationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __HandoverPreparationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HandoverPreparationFailure_protocolIEs__item__id),
        ('criticality', ___HandoverPreparationFailure_protocolIEs__item__criticality),
        ('value', ___HandoverPreparationFailure_protocolIEs__item__value),
        ])
    __HandoverPreparationFailure_protocolIEs__item_._ext = None
    _HandoverPreparationFailure_protocolIEs._cont = __HandoverPreparationFailure_protocolIEs__item_
    _HandoverPreparationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverPreparationFailure._cont = ASN1Dict([
        ('protocolIEs', _HandoverPreparationFailure_protocolIEs),
        ])
    HandoverPreparationFailure._ext = []
    
    #-----< HandoverPreparationFailureIEs >-----#
    HandoverPreparationFailureIEs = CLASS(name='HandoverPreparationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _HandoverPreparationFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _HandoverPreparationFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _HandoverPreparationFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _HandoverPreparationFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _HandoverPreparationFailureIEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargettoSource-Failure-TransparentContainer')))
    HandoverPreparationFailureIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _HandoverPreparationFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _HandoverPreparationFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _HandoverPreparationFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _HandoverPreparationFailureIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 262), ('criticality', 'ignore'), ('Value', _HandoverPreparationFailureIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverRequest >-----#
    HandoverRequest = SEQ(name='HandoverRequest', mode=MODE_TYPE)
    _HandoverRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __HandoverRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___HandoverRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____HandoverRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HandoverType')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEAggregateMaximumBitRate')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CoreNetworkAssistanceInformationForInactive')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESecurityCapabilities')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityContext')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NewSecurityContextInd')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_8 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_9 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupListHOReq')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_10 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TraceActivation')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_12 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MaskedIMEISV')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_13 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SourceToTarget-TransparentContainer')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_14 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MobilityRestrictionList')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_15 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LocationReportingRequestType')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_16 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCInactiveTransitionReportRequest')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_17 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GUAMI')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_18 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedirectionVoiceFallback')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_19 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CNAssistedRANTuning')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_20 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SRVCCOperationPossible')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_21 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IAB-Authorized')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_22 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Enhanced-CoverageRestriction')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_23 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-DifferentiationInfo')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_24 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRV2XServicesAuthorized')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_25 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEV2XServicesAuthorized')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_26 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_27 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEUESidelinkAggregateMaximumBitrate')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_28 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PC5QoSParameters')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_29 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBrestricted')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_30 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-UP-CIoT-Support')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_31 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MDTPLMNList')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_32 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_33 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-ConnectedTime')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_34 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TimeSyncAssistanceInfo')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_35 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESliceMaximumBitRateList')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_36 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-ProSeAuthorized')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_37 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_38 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-ProSePC5QoSParameters')))
    ____HandoverRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 29), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 110), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 18), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 119), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'mandatory')]), dict([('id', 93), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 37), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 73), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_9), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_10), ('presence', 'mandatory')]), dict([('id', 108), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 34), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 101), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_13), ('presence', 'mandatory')]), dict([('id', 36), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 33), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')]), dict([('id', 91), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')]), dict([('id', 28), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_17), ('presence', 'mandatory')]), dict([('id', 146), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_18), ('presence', 'optional')]), dict([('id', 165), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_19), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_20), ('presence', 'optional')]), dict([('id', 199), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_21), ('presence', 'optional')]), dict([('id', 205), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_22), ('presence', 'optional')]), dict([('id', 209), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_23), ('presence', 'optional')]), dict([('id', 216), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_24), ('presence', 'optional')]), dict([('id', 215), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_25), ('presence', 'optional')]), dict([('id', 218), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_26), ('presence', 'optional')]), dict([('id', 217), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_27), ('presence', 'optional')]), dict([('id', 219), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_28), ('presence', 'optional')]), dict([('id', 222), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_29), ('presence', 'optional')]), dict([('id', 234), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_30), ('presence', 'optional')]), dict([('id', 254), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_31), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'reject'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_32), ('presence', 'optional')]), dict([('id', 206), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_33), ('presence', 'optional')]), dict([('id', 326), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_34), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_35), ('presence', 'optional')]), dict([('id', 345), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_36), ('presence', 'optional')]), dict([('id', 346), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_37), ('presence', 'optional')]), dict([('id', 347), ('criticality', 'ignore'), ('Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_38), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HandoverRequest_protocolIEs__item__id._const_tab = ____HandoverRequest_protocolIEs__item__id_tab
    ___HandoverRequest_protocolIEs__item__id._const_tab_at = None
    ___HandoverRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___HandoverRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___HandoverRequest_protocolIEs__item__criticality._const_tab = ____HandoverRequest_protocolIEs__item__id_tab
    ___HandoverRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HandoverRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___HandoverRequest_protocolIEs__item__value._const_tab = ____HandoverRequest_protocolIEs__item__id_tab
    ___HandoverRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HandoverRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __HandoverRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HandoverRequest_protocolIEs__item__id),
        ('criticality', ___HandoverRequest_protocolIEs__item__criticality),
        ('value', ___HandoverRequest_protocolIEs__item__value),
        ])
    __HandoverRequest_protocolIEs__item_._ext = None
    _HandoverRequest_protocolIEs._cont = __HandoverRequest_protocolIEs__item_
    _HandoverRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverRequest._cont = ASN1Dict([
        ('protocolIEs', _HandoverRequest_protocolIEs),
        ])
    HandoverRequest._ext = []
    
    #-----< HandoverRequestIEs >-----#
    HandoverRequestIEs = CLASS(name='HandoverRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _HandoverRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _HandoverRequestIEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HandoverType')))
    _HandoverRequestIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _HandoverRequestIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEAggregateMaximumBitRate')))
    _HandoverRequestIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CoreNetworkAssistanceInformationForInactive')))
    _HandoverRequestIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESecurityCapabilities')))
    _HandoverRequestIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityContext')))
    _HandoverRequestIEs_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NewSecurityContextInd')))
    _HandoverRequestIEs_val_Value_8 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _HandoverRequestIEs_val_Value_9 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSetupListHOReq')))
    _HandoverRequestIEs_val_Value_10 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _HandoverRequestIEs_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TraceActivation')))
    _HandoverRequestIEs_val_Value_12 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MaskedIMEISV')))
    _HandoverRequestIEs_val_Value_13 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SourceToTarget-TransparentContainer')))
    _HandoverRequestIEs_val_Value_14 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MobilityRestrictionList')))
    _HandoverRequestIEs_val_Value_15 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LocationReportingRequestType')))
    _HandoverRequestIEs_val_Value_16 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCInactiveTransitionReportRequest')))
    _HandoverRequestIEs_val_Value_17 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GUAMI')))
    _HandoverRequestIEs_val_Value_18 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedirectionVoiceFallback')))
    _HandoverRequestIEs_val_Value_19 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CNAssistedRANTuning')))
    _HandoverRequestIEs_val_Value_20 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SRVCCOperationPossible')))
    _HandoverRequestIEs_val_Value_21 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IAB-Authorized')))
    _HandoverRequestIEs_val_Value_22 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Enhanced-CoverageRestriction')))
    _HandoverRequestIEs_val_Value_23 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-DifferentiationInfo')))
    _HandoverRequestIEs_val_Value_24 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRV2XServicesAuthorized')))
    _HandoverRequestIEs_val_Value_25 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEV2XServicesAuthorized')))
    _HandoverRequestIEs_val_Value_26 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _HandoverRequestIEs_val_Value_27 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEUESidelinkAggregateMaximumBitrate')))
    _HandoverRequestIEs_val_Value_28 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PC5QoSParameters')))
    _HandoverRequestIEs_val_Value_29 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBrestricted')))
    _HandoverRequestIEs_val_Value_30 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-UP-CIoT-Support')))
    _HandoverRequestIEs_val_Value_31 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MDTPLMNList')))
    _HandoverRequestIEs_val_Value_32 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    _HandoverRequestIEs_val_Value_33 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-ConnectedTime')))
    _HandoverRequestIEs_val_Value_34 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TimeSyncAssistanceInfo')))
    _HandoverRequestIEs_val_Value_35 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESliceMaximumBitRateList')))
    _HandoverRequestIEs_val_Value_36 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-ProSeAuthorized')))
    _HandoverRequestIEs_val_Value_37 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _HandoverRequestIEs_val_Value_38 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-ProSePC5QoSParameters')))
    HandoverRequestIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _HandoverRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 29), ('criticality', 'reject'), ('Value', _HandoverRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 110), ('criticality', 'reject'), ('Value', _HandoverRequestIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 18), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 119), ('criticality', 'reject'), ('Value', _HandoverRequestIEs_val_Value_5), ('presence', 'mandatory')]), dict([('id', 93), ('criticality', 'reject'), ('Value', _HandoverRequestIEs_val_Value_6), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _HandoverRequestIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 37), ('criticality', 'reject'), ('Value', _HandoverRequestIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 73), ('criticality', 'reject'), ('Value', _HandoverRequestIEs_val_Value_9), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'reject'), ('Value', _HandoverRequestIEs_val_Value_10), ('presence', 'mandatory')]), dict([('id', 108), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_11), ('presence', 'optional')]), dict([('id', 34), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_12), ('presence', 'optional')]), dict([('id', 101), ('criticality', 'reject'), ('Value', _HandoverRequestIEs_val_Value_13), ('presence', 'mandatory')]), dict([('id', 36), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_14), ('presence', 'optional')]), dict([('id', 33), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_15), ('presence', 'optional')]), dict([('id', 91), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_16), ('presence', 'optional')]), dict([('id', 28), ('criticality', 'reject'), ('Value', _HandoverRequestIEs_val_Value_17), ('presence', 'mandatory')]), dict([('id', 146), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_18), ('presence', 'optional')]), dict([('id', 165), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_19), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_20), ('presence', 'optional')]), dict([('id', 199), ('criticality', 'reject'), ('Value', _HandoverRequestIEs_val_Value_21), ('presence', 'optional')]), dict([('id', 205), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_22), ('presence', 'optional')]), dict([('id', 209), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_23), ('presence', 'optional')]), dict([('id', 216), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_24), ('presence', 'optional')]), dict([('id', 215), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_25), ('presence', 'optional')]), dict([('id', 218), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_26), ('presence', 'optional')]), dict([('id', 217), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_27), ('presence', 'optional')]), dict([('id', 219), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_28), ('presence', 'optional')]), dict([('id', 222), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_29), ('presence', 'optional')]), dict([('id', 234), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_30), ('presence', 'optional')]), dict([('id', 254), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_31), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'reject'), ('Value', _HandoverRequestIEs_val_Value_32), ('presence', 'optional')]), dict([('id', 206), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_33), ('presence', 'optional')]), dict([('id', 326), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_34), ('presence', 'optional')]), dict([('id', 335), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_35), ('presence', 'optional')]), dict([('id', 345), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_36), ('presence', 'optional')]), dict([('id', 346), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_37), ('presence', 'optional')]), dict([('id', 347), ('criticality', 'ignore'), ('Value', _HandoverRequestIEs_val_Value_38), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverRequestAcknowledge >-----#
    HandoverRequestAcknowledge = SEQ(name='HandoverRequestAcknowledge', mode=MODE_TYPE)
    _HandoverRequestAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __HandoverRequestAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___HandoverRequestAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____HandoverRequestAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceAdmittedList')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupListHOAck')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargetToSource-TransparentContainer')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NPN-AccessInformation')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedCapIndication')))
    ____HandoverRequestAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 53), ('criticality', 'ignore'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 56), ('criticality', 'ignore'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 106), ('criticality', 'reject'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 259), ('criticality', 'reject'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 333), ('criticality', 'ignore'), ('Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HandoverRequestAcknowledge_protocolIEs__item__id._const_tab = ____HandoverRequestAcknowledge_protocolIEs__item__id_tab
    ___HandoverRequestAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___HandoverRequestAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___HandoverRequestAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___HandoverRequestAcknowledge_protocolIEs__item__criticality._const_tab = ____HandoverRequestAcknowledge_protocolIEs__item__id_tab
    ___HandoverRequestAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverRequestAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HandoverRequestAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___HandoverRequestAcknowledge_protocolIEs__item__value._const_tab = ____HandoverRequestAcknowledge_protocolIEs__item__id_tab
    ___HandoverRequestAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HandoverRequestAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __HandoverRequestAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HandoverRequestAcknowledge_protocolIEs__item__id),
        ('criticality', ___HandoverRequestAcknowledge_protocolIEs__item__criticality),
        ('value', ___HandoverRequestAcknowledge_protocolIEs__item__value),
        ])
    __HandoverRequestAcknowledge_protocolIEs__item_._ext = None
    _HandoverRequestAcknowledge_protocolIEs._cont = __HandoverRequestAcknowledge_protocolIEs__item_
    _HandoverRequestAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverRequestAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _HandoverRequestAcknowledge_protocolIEs),
        ])
    HandoverRequestAcknowledge._ext = []
    
    #-----< HandoverRequestAcknowledgeIEs >-----#
    HandoverRequestAcknowledgeIEs = CLASS(name='HandoverRequestAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _HandoverRequestAcknowledgeIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _HandoverRequestAcknowledgeIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _HandoverRequestAcknowledgeIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceAdmittedList')))
    _HandoverRequestAcknowledgeIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupListHOAck')))
    _HandoverRequestAcknowledgeIEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargetToSource-TransparentContainer')))
    _HandoverRequestAcknowledgeIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _HandoverRequestAcknowledgeIEs_val_Value_6 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NPN-AccessInformation')))
    _HandoverRequestAcknowledgeIEs_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedCapIndication')))
    HandoverRequestAcknowledgeIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _HandoverRequestAcknowledgeIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _HandoverRequestAcknowledgeIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 53), ('criticality', 'ignore'), ('Value', _HandoverRequestAcknowledgeIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 56), ('criticality', 'ignore'), ('Value', _HandoverRequestAcknowledgeIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 106), ('criticality', 'reject'), ('Value', _HandoverRequestAcknowledgeIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _HandoverRequestAcknowledgeIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 259), ('criticality', 'reject'), ('Value', _HandoverRequestAcknowledgeIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 333), ('criticality', 'ignore'), ('Value', _HandoverRequestAcknowledgeIEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverFailure >-----#
    HandoverFailure = SEQ(name='HandoverFailure', mode=MODE_TYPE)
    _HandoverFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __HandoverFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___HandoverFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____HandoverFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____HandoverFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____HandoverFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____HandoverFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _____HandoverFailure_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargettoSource-Failure-TransparentContainer')))
    ____HandoverFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _____HandoverFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____HandoverFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____HandoverFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 262), ('criticality', 'ignore'), ('Value', _____HandoverFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HandoverFailure_protocolIEs__item__id._const_tab = ____HandoverFailure_protocolIEs__item__id_tab
    ___HandoverFailure_protocolIEs__item__id._const_tab_at = None
    ___HandoverFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___HandoverFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___HandoverFailure_protocolIEs__item__criticality._const_tab = ____HandoverFailure_protocolIEs__item__id_tab
    ___HandoverFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HandoverFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___HandoverFailure_protocolIEs__item__value._const_tab = ____HandoverFailure_protocolIEs__item__id_tab
    ___HandoverFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HandoverFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __HandoverFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HandoverFailure_protocolIEs__item__id),
        ('criticality', ___HandoverFailure_protocolIEs__item__criticality),
        ('value', ___HandoverFailure_protocolIEs__item__value),
        ])
    __HandoverFailure_protocolIEs__item_._ext = None
    _HandoverFailure_protocolIEs._cont = __HandoverFailure_protocolIEs__item_
    _HandoverFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverFailure._cont = ASN1Dict([
        ('protocolIEs', _HandoverFailure_protocolIEs),
        ])
    HandoverFailure._ext = []
    
    #-----< HandoverFailureIEs >-----#
    HandoverFailureIEs = CLASS(name='HandoverFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _HandoverFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _HandoverFailureIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _HandoverFailureIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _HandoverFailureIEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargettoSource-Failure-TransparentContainer')))
    HandoverFailureIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _HandoverFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _HandoverFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _HandoverFailureIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 262), ('criticality', 'ignore'), ('Value', _HandoverFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverNotify >-----#
    HandoverNotify = SEQ(name='HandoverNotify', mode=MODE_TYPE)
    _HandoverNotify_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __HandoverNotify_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___HandoverNotify_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____HandoverNotify_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____HandoverNotify_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____HandoverNotify_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____HandoverNotify_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _____HandoverNotify_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NotifySourceNGRANNode')))
    ____HandoverNotify_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____HandoverNotify_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____HandoverNotify_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _____HandoverNotify_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 269), ('criticality', 'ignore'), ('Value', _____HandoverNotify_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HandoverNotify_protocolIEs__item__id._const_tab = ____HandoverNotify_protocolIEs__item__id_tab
    ___HandoverNotify_protocolIEs__item__id._const_tab_at = None
    ___HandoverNotify_protocolIEs__item__id._const_tab_id = 'id'
    ___HandoverNotify_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___HandoverNotify_protocolIEs__item__criticality._const_tab = ____HandoverNotify_protocolIEs__item__id_tab
    ___HandoverNotify_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverNotify_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HandoverNotify_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___HandoverNotify_protocolIEs__item__value._const_tab = ____HandoverNotify_protocolIEs__item__id_tab
    ___HandoverNotify_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HandoverNotify_protocolIEs__item__value._const_tab_id = 'Value'
    __HandoverNotify_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HandoverNotify_protocolIEs__item__id),
        ('criticality', ___HandoverNotify_protocolIEs__item__criticality),
        ('value', ___HandoverNotify_protocolIEs__item__value),
        ])
    __HandoverNotify_protocolIEs__item_._ext = None
    _HandoverNotify_protocolIEs._cont = __HandoverNotify_protocolIEs__item_
    _HandoverNotify_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverNotify._cont = ASN1Dict([
        ('protocolIEs', _HandoverNotify_protocolIEs),
        ])
    HandoverNotify._ext = []
    
    #-----< HandoverNotifyIEs >-----#
    HandoverNotifyIEs = CLASS(name='HandoverNotifyIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _HandoverNotifyIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _HandoverNotifyIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _HandoverNotifyIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _HandoverNotifyIEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NotifySourceNGRANNode')))
    HandoverNotifyIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _HandoverNotifyIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _HandoverNotifyIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _HandoverNotifyIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 269), ('criticality', 'ignore'), ('Value', _HandoverNotifyIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PathSwitchRequest >-----#
    PathSwitchRequest = SEQ(name='PathSwitchRequest', mode=MODE_TYPE)
    _PathSwitchRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PathSwitchRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PathSwitchRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____PathSwitchRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESecurityCapabilities')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceToBeSwitchedDLList')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupListPSReq')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCEstablishmentCause')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedCapIndication')))
    ____PathSwitchRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 85), ('criticality', 'reject'), ('Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 100), ('criticality', 'reject'), ('Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 119), ('criticality', 'ignore'), ('Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 76), ('criticality', 'reject'), ('Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 57), ('criticality', 'ignore'), ('Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 237), ('criticality', 'ignore'), ('Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 333), ('criticality', 'ignore'), ('Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PathSwitchRequest_protocolIEs__item__id._const_tab = ____PathSwitchRequest_protocolIEs__item__id_tab
    ___PathSwitchRequest_protocolIEs__item__id._const_tab_at = None
    ___PathSwitchRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___PathSwitchRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___PathSwitchRequest_protocolIEs__item__criticality._const_tab = ____PathSwitchRequest_protocolIEs__item__id_tab
    ___PathSwitchRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PathSwitchRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PathSwitchRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___PathSwitchRequest_protocolIEs__item__value._const_tab = ____PathSwitchRequest_protocolIEs__item__id_tab
    ___PathSwitchRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PathSwitchRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __PathSwitchRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PathSwitchRequest_protocolIEs__item__id),
        ('criticality', ___PathSwitchRequest_protocolIEs__item__criticality),
        ('value', ___PathSwitchRequest_protocolIEs__item__value),
        ])
    __PathSwitchRequest_protocolIEs__item_._ext = None
    _PathSwitchRequest_protocolIEs._cont = __PathSwitchRequest_protocolIEs__item_
    _PathSwitchRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PathSwitchRequest._cont = ASN1Dict([
        ('protocolIEs', _PathSwitchRequest_protocolIEs),
        ])
    PathSwitchRequest._ext = []
    
    #-----< PathSwitchRequestIEs >-----#
    PathSwitchRequestIEs = CLASS(name='PathSwitchRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PathSwitchRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _PathSwitchRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _PathSwitchRequestIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _PathSwitchRequestIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESecurityCapabilities')))
    _PathSwitchRequestIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceToBeSwitchedDLList')))
    _PathSwitchRequestIEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceFailedToSetupListPSReq')))
    _PathSwitchRequestIEs_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCEstablishmentCause')))
    _PathSwitchRequestIEs_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedCapIndication')))
    PathSwitchRequestIEs._val = ASN1Set(rv=[dict([('id', 85), ('criticality', 'reject'), ('Value', _PathSwitchRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 100), ('criticality', 'reject'), ('Value', _PathSwitchRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _PathSwitchRequestIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 119), ('criticality', 'ignore'), ('Value', _PathSwitchRequestIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 76), ('criticality', 'reject'), ('Value', _PathSwitchRequestIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 57), ('criticality', 'ignore'), ('Value', _PathSwitchRequestIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 237), ('criticality', 'ignore'), ('Value', _PathSwitchRequestIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 333), ('criticality', 'ignore'), ('Value', _PathSwitchRequestIEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PathSwitchRequestAcknowledge >-----#
    PathSwitchRequestAcknowledge = SEQ(name='PathSwitchRequestAcknowledge', mode=MODE_TYPE)
    _PathSwitchRequestAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PathSwitchRequestAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PathSwitchRequestAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESecurityCapabilities')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityContext')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NewSecurityContextInd')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSwitchedList')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleasedListPSAck')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CoreNetworkAssistanceInformationForInactive')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCInactiveTransitionReportRequest')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_11 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedirectionVoiceFallback')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_12 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CNAssistedRANTuning')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SRVCCOperationPossible')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_14 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Enhanced-CoverageRestriction')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_15 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-ConnectedTime')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_16 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-DifferentiationInfo')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_17 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRV2XServicesAuthorized')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_18 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEV2XServicesAuthorized')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_19 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_20 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEUESidelinkAggregateMaximumBitrate')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_21 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PC5QoSParameters')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_22 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBrestricted')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_23 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-UP-CIoT-Support')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_24 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_25 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MDTPLMNList')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_26 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TimeSyncAssistanceInfo')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_27 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-ProSeAuthorized')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_28 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_29 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-ProSePC5QoSParameters')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_30 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MDTPLMNModificationList')))
    ____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 119), ('criticality', 'reject'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 93), ('criticality', 'reject'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 77), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5), ('presence', 'mandatory')]), dict([('id', 68), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'reject'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7), ('presence', 'mandatory')]), dict([('id', 18), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 91), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 146), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 165), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 205), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 206), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')]), dict([('id', 209), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')]), dict([('id', 216), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_17), ('presence', 'optional')]), dict([('id', 215), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_18), ('presence', 'optional')]), dict([('id', 218), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_19), ('presence', 'optional')]), dict([('id', 217), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_20), ('presence', 'optional')]), dict([('id', 219), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_21), ('presence', 'optional')]), dict([('id', 222), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_22), ('presence', 'optional')]), dict([('id', 234), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_23), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'reject'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_24), ('presence', 'optional')]), dict([('id', 254), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_25), ('presence', 'optional')]), dict([('id', 326), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_26), ('presence', 'optional')]), dict([('id', 345), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_27), ('presence', 'optional')]), dict([('id', 346), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_28), ('presence', 'optional')]), dict([('id', 347), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_29), ('presence', 'optional')]), dict([('id', 359), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_30), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PathSwitchRequestAcknowledge_protocolIEs__item__id._const_tab = ____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab
    ___PathSwitchRequestAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___PathSwitchRequestAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___PathSwitchRequestAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___PathSwitchRequestAcknowledge_protocolIEs__item__criticality._const_tab = ____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab
    ___PathSwitchRequestAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PathSwitchRequestAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PathSwitchRequestAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___PathSwitchRequestAcknowledge_protocolIEs__item__value._const_tab = ____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab
    ___PathSwitchRequestAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PathSwitchRequestAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __PathSwitchRequestAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PathSwitchRequestAcknowledge_protocolIEs__item__id),
        ('criticality', ___PathSwitchRequestAcknowledge_protocolIEs__item__criticality),
        ('value', ___PathSwitchRequestAcknowledge_protocolIEs__item__value),
        ])
    __PathSwitchRequestAcknowledge_protocolIEs__item_._ext = None
    _PathSwitchRequestAcknowledge_protocolIEs._cont = __PathSwitchRequestAcknowledge_protocolIEs__item_
    _PathSwitchRequestAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PathSwitchRequestAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _PathSwitchRequestAcknowledge_protocolIEs),
        ])
    PathSwitchRequestAcknowledge._ext = []
    
    #-----< PathSwitchRequestAcknowledgeIEs >-----#
    PathSwitchRequestAcknowledgeIEs = CLASS(name='PathSwitchRequestAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UESecurityCapabilities')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SecurityContext')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NewSecurityContextInd')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSwitchedList')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleasedListPSAck')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CoreNetworkAssistanceInformationForInactive')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCInactiveTransitionReportRequest')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_11 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedirectionVoiceFallback')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_12 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CNAssistedRANTuning')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SRVCCOperationPossible')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_14 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Enhanced-CoverageRestriction')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_15 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-ConnectedTime')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_16 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-DifferentiationInfo')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_17 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRV2XServicesAuthorized')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_18 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEV2XServicesAuthorized')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_19 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_20 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEUESidelinkAggregateMaximumBitrate')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_21 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PC5QoSParameters')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_22 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBrestricted')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_23 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-UP-CIoT-Support')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_24 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_25 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MDTPLMNList')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_26 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TimeSyncAssistanceInfo')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_27 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-ProSeAuthorized')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_28 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_29 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-ProSePC5QoSParameters')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_30 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MDTPLMNModificationList')))
    PathSwitchRequestAcknowledgeIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 119), ('criticality', 'reject'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 93), ('criticality', 'reject'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 77), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_5), ('presence', 'mandatory')]), dict([('id', 68), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'reject'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_7), ('presence', 'mandatory')]), dict([('id', 18), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 91), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 146), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_11), ('presence', 'optional')]), dict([('id', 165), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_12), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_13), ('presence', 'optional')]), dict([('id', 205), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_14), ('presence', 'optional')]), dict([('id', 206), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_15), ('presence', 'optional')]), dict([('id', 209), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_16), ('presence', 'optional')]), dict([('id', 216), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_17), ('presence', 'optional')]), dict([('id', 215), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_18), ('presence', 'optional')]), dict([('id', 218), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_19), ('presence', 'optional')]), dict([('id', 217), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_20), ('presence', 'optional')]), dict([('id', 219), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_21), ('presence', 'optional')]), dict([('id', 222), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_22), ('presence', 'optional')]), dict([('id', 234), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_23), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'reject'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_24), ('presence', 'optional')]), dict([('id', 254), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_25), ('presence', 'optional')]), dict([('id', 326), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_26), ('presence', 'optional')]), dict([('id', 345), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_27), ('presence', 'optional')]), dict([('id', 346), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_28), ('presence', 'optional')]), dict([('id', 347), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_29), ('presence', 'optional')]), dict([('id', 359), ('criticality', 'ignore'), ('Value', _PathSwitchRequestAcknowledgeIEs_val_Value_30), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PathSwitchRequestFailure >-----#
    PathSwitchRequestFailure = SEQ(name='PathSwitchRequestFailure', mode=MODE_TYPE)
    _PathSwitchRequestFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PathSwitchRequestFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PathSwitchRequestFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____PathSwitchRequestFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleasedListPSFail')))
    _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____PathSwitchRequestFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 69), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PathSwitchRequestFailure_protocolIEs__item__id._const_tab = ____PathSwitchRequestFailure_protocolIEs__item__id_tab
    ___PathSwitchRequestFailure_protocolIEs__item__id._const_tab_at = None
    ___PathSwitchRequestFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___PathSwitchRequestFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___PathSwitchRequestFailure_protocolIEs__item__criticality._const_tab = ____PathSwitchRequestFailure_protocolIEs__item__id_tab
    ___PathSwitchRequestFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PathSwitchRequestFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PathSwitchRequestFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___PathSwitchRequestFailure_protocolIEs__item__value._const_tab = ____PathSwitchRequestFailure_protocolIEs__item__id_tab
    ___PathSwitchRequestFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PathSwitchRequestFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __PathSwitchRequestFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PathSwitchRequestFailure_protocolIEs__item__id),
        ('criticality', ___PathSwitchRequestFailure_protocolIEs__item__criticality),
        ('value', ___PathSwitchRequestFailure_protocolIEs__item__value),
        ])
    __PathSwitchRequestFailure_protocolIEs__item_._ext = None
    _PathSwitchRequestFailure_protocolIEs._cont = __PathSwitchRequestFailure_protocolIEs__item_
    _PathSwitchRequestFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PathSwitchRequestFailure._cont = ASN1Dict([
        ('protocolIEs', _PathSwitchRequestFailure_protocolIEs),
        ])
    PathSwitchRequestFailure._ext = []
    
    #-----< PathSwitchRequestFailureIEs >-----#
    PathSwitchRequestFailureIEs = CLASS(name='PathSwitchRequestFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PathSwitchRequestFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _PathSwitchRequestFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _PathSwitchRequestFailureIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceReleasedListPSFail')))
    _PathSwitchRequestFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    PathSwitchRequestFailureIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _PathSwitchRequestFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _PathSwitchRequestFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 69), ('criticality', 'ignore'), ('Value', _PathSwitchRequestFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _PathSwitchRequestFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverCancel >-----#
    HandoverCancel = SEQ(name='HandoverCancel', mode=MODE_TYPE)
    _HandoverCancel_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __HandoverCancel_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___HandoverCancel_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____HandoverCancel_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____HandoverCancel_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____HandoverCancel_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____HandoverCancel_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    ____HandoverCancel_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____HandoverCancel_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____HandoverCancel_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____HandoverCancel_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___HandoverCancel_protocolIEs__item__id._const_tab = ____HandoverCancel_protocolIEs__item__id_tab
    ___HandoverCancel_protocolIEs__item__id._const_tab_at = None
    ___HandoverCancel_protocolIEs__item__id._const_tab_id = 'id'
    ___HandoverCancel_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___HandoverCancel_protocolIEs__item__criticality._const_tab = ____HandoverCancel_protocolIEs__item__id_tab
    ___HandoverCancel_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverCancel_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HandoverCancel_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___HandoverCancel_protocolIEs__item__value._const_tab = ____HandoverCancel_protocolIEs__item__id_tab
    ___HandoverCancel_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HandoverCancel_protocolIEs__item__value._const_tab_id = 'Value'
    __HandoverCancel_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HandoverCancel_protocolIEs__item__id),
        ('criticality', ___HandoverCancel_protocolIEs__item__criticality),
        ('value', ___HandoverCancel_protocolIEs__item__value),
        ])
    __HandoverCancel_protocolIEs__item_._ext = None
    _HandoverCancel_protocolIEs._cont = __HandoverCancel_protocolIEs__item_
    _HandoverCancel_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverCancel._cont = ASN1Dict([
        ('protocolIEs', _HandoverCancel_protocolIEs),
        ])
    HandoverCancel._ext = []
    
    #-----< HandoverCancelIEs >-----#
    HandoverCancelIEs = CLASS(name='HandoverCancelIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _HandoverCancelIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _HandoverCancelIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _HandoverCancelIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    HandoverCancelIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _HandoverCancelIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _HandoverCancelIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _HandoverCancelIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< HandoverCancelAcknowledge >-----#
    HandoverCancelAcknowledge = SEQ(name='HandoverCancelAcknowledge', mode=MODE_TYPE)
    _HandoverCancelAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __HandoverCancelAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___HandoverCancelAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____HandoverCancelAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____HandoverCancelAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___HandoverCancelAcknowledge_protocolIEs__item__id._const_tab = ____HandoverCancelAcknowledge_protocolIEs__item__id_tab
    ___HandoverCancelAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___HandoverCancelAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___HandoverCancelAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___HandoverCancelAcknowledge_protocolIEs__item__criticality._const_tab = ____HandoverCancelAcknowledge_protocolIEs__item__id_tab
    ___HandoverCancelAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverCancelAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HandoverCancelAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___HandoverCancelAcknowledge_protocolIEs__item__value._const_tab = ____HandoverCancelAcknowledge_protocolIEs__item__id_tab
    ___HandoverCancelAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HandoverCancelAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __HandoverCancelAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HandoverCancelAcknowledge_protocolIEs__item__id),
        ('criticality', ___HandoverCancelAcknowledge_protocolIEs__item__criticality),
        ('value', ___HandoverCancelAcknowledge_protocolIEs__item__value),
        ])
    __HandoverCancelAcknowledge_protocolIEs__item_._ext = None
    _HandoverCancelAcknowledge_protocolIEs._cont = __HandoverCancelAcknowledge_protocolIEs__item_
    _HandoverCancelAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverCancelAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _HandoverCancelAcknowledge_protocolIEs),
        ])
    HandoverCancelAcknowledge._ext = []
    
    #-----< HandoverCancelAcknowledgeIEs >-----#
    HandoverCancelAcknowledgeIEs = CLASS(name='HandoverCancelAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _HandoverCancelAcknowledgeIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _HandoverCancelAcknowledgeIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _HandoverCancelAcknowledgeIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    HandoverCancelAcknowledgeIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _HandoverCancelAcknowledgeIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _HandoverCancelAcknowledgeIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _HandoverCancelAcknowledgeIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverSuccess >-----#
    HandoverSuccess = SEQ(name='HandoverSuccess', mode=MODE_TYPE)
    _HandoverSuccess_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __HandoverSuccess_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___HandoverSuccess_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____HandoverSuccess_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    ____HandoverSuccess_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___HandoverSuccess_protocolIEs__item__id._const_tab = ____HandoverSuccess_protocolIEs__item__id_tab
    ___HandoverSuccess_protocolIEs__item__id._const_tab_at = None
    ___HandoverSuccess_protocolIEs__item__id._const_tab_id = 'id'
    ___HandoverSuccess_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___HandoverSuccess_protocolIEs__item__criticality._const_tab = ____HandoverSuccess_protocolIEs__item__id_tab
    ___HandoverSuccess_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___HandoverSuccess_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___HandoverSuccess_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___HandoverSuccess_protocolIEs__item__value._const_tab = ____HandoverSuccess_protocolIEs__item__id_tab
    ___HandoverSuccess_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___HandoverSuccess_protocolIEs__item__value._const_tab_id = 'Value'
    __HandoverSuccess_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___HandoverSuccess_protocolIEs__item__id),
        ('criticality', ___HandoverSuccess_protocolIEs__item__criticality),
        ('value', ___HandoverSuccess_protocolIEs__item__value),
        ])
    __HandoverSuccess_protocolIEs__item_._ext = None
    _HandoverSuccess_protocolIEs._cont = __HandoverSuccess_protocolIEs__item_
    _HandoverSuccess_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverSuccess._cont = ASN1Dict([
        ('protocolIEs', _HandoverSuccess_protocolIEs),
        ])
    HandoverSuccess._ext = []
    
    #-----< HandoverSuccessIEs >-----#
    HandoverSuccessIEs = CLASS(name='HandoverSuccessIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _HandoverSuccessIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _HandoverSuccessIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    HandoverSuccessIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _HandoverSuccessIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _HandoverSuccessIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UplinkRANEarlyStatusTransfer >-----#
    UplinkRANEarlyStatusTransfer = SEQ(name='UplinkRANEarlyStatusTransfer', mode=MODE_TYPE)
    _UplinkRANEarlyStatusTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UplinkRANEarlyStatusTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UplinkRANEarlyStatusTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EarlyStatusTransfer-TransparentContainer')))
    ____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 268), ('criticality', 'reject'), ('Value', _____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___UplinkRANEarlyStatusTransfer_protocolIEs__item__id._const_tab = ____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab
    ___UplinkRANEarlyStatusTransfer_protocolIEs__item__id._const_tab_at = None
    ___UplinkRANEarlyStatusTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___UplinkRANEarlyStatusTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UplinkRANEarlyStatusTransfer_protocolIEs__item__criticality._const_tab = ____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab
    ___UplinkRANEarlyStatusTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UplinkRANEarlyStatusTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UplinkRANEarlyStatusTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UplinkRANEarlyStatusTransfer_protocolIEs__item__value._const_tab = ____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab
    ___UplinkRANEarlyStatusTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UplinkRANEarlyStatusTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __UplinkRANEarlyStatusTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UplinkRANEarlyStatusTransfer_protocolIEs__item__id),
        ('criticality', ___UplinkRANEarlyStatusTransfer_protocolIEs__item__criticality),
        ('value', ___UplinkRANEarlyStatusTransfer_protocolIEs__item__value),
        ])
    __UplinkRANEarlyStatusTransfer_protocolIEs__item_._ext = None
    _UplinkRANEarlyStatusTransfer_protocolIEs._cont = __UplinkRANEarlyStatusTransfer_protocolIEs__item_
    _UplinkRANEarlyStatusTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UplinkRANEarlyStatusTransfer._cont = ASN1Dict([
        ('protocolIEs', _UplinkRANEarlyStatusTransfer_protocolIEs),
        ])
    UplinkRANEarlyStatusTransfer._ext = []
    
    #-----< UplinkRANEarlyStatusTransferIEs >-----#
    UplinkRANEarlyStatusTransferIEs = CLASS(name='UplinkRANEarlyStatusTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UplinkRANEarlyStatusTransferIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UplinkRANEarlyStatusTransferIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UplinkRANEarlyStatusTransferIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EarlyStatusTransfer-TransparentContainer')))
    UplinkRANEarlyStatusTransferIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _UplinkRANEarlyStatusTransferIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _UplinkRANEarlyStatusTransferIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 268), ('criticality', 'reject'), ('Value', _UplinkRANEarlyStatusTransferIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DownlinkRANEarlyStatusTransfer >-----#
    DownlinkRANEarlyStatusTransfer = SEQ(name='DownlinkRANEarlyStatusTransfer', mode=MODE_TYPE)
    _DownlinkRANEarlyStatusTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __DownlinkRANEarlyStatusTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EarlyStatusTransfer-TransparentContainer')))
    ____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 268), ('criticality', 'reject'), ('Value', _____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__id._const_tab = ____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab
    ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__id._const_tab_at = None
    ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__criticality._const_tab = ____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab
    ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__value._const_tab = ____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab
    ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __DownlinkRANEarlyStatusTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__id),
        ('criticality', ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__criticality),
        ('value', ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__value),
        ])
    __DownlinkRANEarlyStatusTransfer_protocolIEs__item_._ext = None
    _DownlinkRANEarlyStatusTransfer_protocolIEs._cont = __DownlinkRANEarlyStatusTransfer_protocolIEs__item_
    _DownlinkRANEarlyStatusTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DownlinkRANEarlyStatusTransfer._cont = ASN1Dict([
        ('protocolIEs', _DownlinkRANEarlyStatusTransfer_protocolIEs),
        ])
    DownlinkRANEarlyStatusTransfer._ext = []
    
    #-----< DownlinkRANEarlyStatusTransferIEs >-----#
    DownlinkRANEarlyStatusTransferIEs = CLASS(name='DownlinkRANEarlyStatusTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _DownlinkRANEarlyStatusTransferIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _DownlinkRANEarlyStatusTransferIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _DownlinkRANEarlyStatusTransferIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EarlyStatusTransfer-TransparentContainer')))
    DownlinkRANEarlyStatusTransferIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _DownlinkRANEarlyStatusTransferIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _DownlinkRANEarlyStatusTransferIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 268), ('criticality', 'reject'), ('Value', _DownlinkRANEarlyStatusTransferIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UplinkRANStatusTransfer >-----#
    UplinkRANStatusTransfer = SEQ(name='UplinkRANStatusTransfer', mode=MODE_TYPE)
    _UplinkRANStatusTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UplinkRANStatusTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UplinkRANStatusTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____UplinkRANStatusTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UplinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UplinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UplinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANStatusTransfer-TransparentContainer')))
    ____UplinkRANStatusTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____UplinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____UplinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 84), ('criticality', 'reject'), ('Value', _____UplinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___UplinkRANStatusTransfer_protocolIEs__item__id._const_tab = ____UplinkRANStatusTransfer_protocolIEs__item__id_tab
    ___UplinkRANStatusTransfer_protocolIEs__item__id._const_tab_at = None
    ___UplinkRANStatusTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___UplinkRANStatusTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UplinkRANStatusTransfer_protocolIEs__item__criticality._const_tab = ____UplinkRANStatusTransfer_protocolIEs__item__id_tab
    ___UplinkRANStatusTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UplinkRANStatusTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UplinkRANStatusTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UplinkRANStatusTransfer_protocolIEs__item__value._const_tab = ____UplinkRANStatusTransfer_protocolIEs__item__id_tab
    ___UplinkRANStatusTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UplinkRANStatusTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __UplinkRANStatusTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UplinkRANStatusTransfer_protocolIEs__item__id),
        ('criticality', ___UplinkRANStatusTransfer_protocolIEs__item__criticality),
        ('value', ___UplinkRANStatusTransfer_protocolIEs__item__value),
        ])
    __UplinkRANStatusTransfer_protocolIEs__item_._ext = None
    _UplinkRANStatusTransfer_protocolIEs._cont = __UplinkRANStatusTransfer_protocolIEs__item_
    _UplinkRANStatusTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UplinkRANStatusTransfer._cont = ASN1Dict([
        ('protocolIEs', _UplinkRANStatusTransfer_protocolIEs),
        ])
    UplinkRANStatusTransfer._ext = []
    
    #-----< UplinkRANStatusTransferIEs >-----#
    UplinkRANStatusTransferIEs = CLASS(name='UplinkRANStatusTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UplinkRANStatusTransferIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UplinkRANStatusTransferIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UplinkRANStatusTransferIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANStatusTransfer-TransparentContainer')))
    UplinkRANStatusTransferIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _UplinkRANStatusTransferIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _UplinkRANStatusTransferIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 84), ('criticality', 'reject'), ('Value', _UplinkRANStatusTransferIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DownlinkRANStatusTransfer >-----#
    DownlinkRANStatusTransfer = SEQ(name='DownlinkRANStatusTransfer', mode=MODE_TYPE)
    _DownlinkRANStatusTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __DownlinkRANStatusTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___DownlinkRANStatusTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____DownlinkRANStatusTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____DownlinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____DownlinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____DownlinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANStatusTransfer-TransparentContainer')))
    ____DownlinkRANStatusTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____DownlinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____DownlinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 84), ('criticality', 'reject'), ('Value', _____DownlinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___DownlinkRANStatusTransfer_protocolIEs__item__id._const_tab = ____DownlinkRANStatusTransfer_protocolIEs__item__id_tab
    ___DownlinkRANStatusTransfer_protocolIEs__item__id._const_tab_at = None
    ___DownlinkRANStatusTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___DownlinkRANStatusTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___DownlinkRANStatusTransfer_protocolIEs__item__criticality._const_tab = ____DownlinkRANStatusTransfer_protocolIEs__item__id_tab
    ___DownlinkRANStatusTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DownlinkRANStatusTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DownlinkRANStatusTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___DownlinkRANStatusTransfer_protocolIEs__item__value._const_tab = ____DownlinkRANStatusTransfer_protocolIEs__item__id_tab
    ___DownlinkRANStatusTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DownlinkRANStatusTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __DownlinkRANStatusTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DownlinkRANStatusTransfer_protocolIEs__item__id),
        ('criticality', ___DownlinkRANStatusTransfer_protocolIEs__item__criticality),
        ('value', ___DownlinkRANStatusTransfer_protocolIEs__item__value),
        ])
    __DownlinkRANStatusTransfer_protocolIEs__item_._ext = None
    _DownlinkRANStatusTransfer_protocolIEs._cont = __DownlinkRANStatusTransfer_protocolIEs__item_
    _DownlinkRANStatusTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DownlinkRANStatusTransfer._cont = ASN1Dict([
        ('protocolIEs', _DownlinkRANStatusTransfer_protocolIEs),
        ])
    DownlinkRANStatusTransfer._ext = []
    
    #-----< DownlinkRANStatusTransferIEs >-----#
    DownlinkRANStatusTransferIEs = CLASS(name='DownlinkRANStatusTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _DownlinkRANStatusTransferIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _DownlinkRANStatusTransferIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _DownlinkRANStatusTransferIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANStatusTransfer-TransparentContainer')))
    DownlinkRANStatusTransferIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _DownlinkRANStatusTransferIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _DownlinkRANStatusTransferIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 84), ('criticality', 'reject'), ('Value', _DownlinkRANStatusTransferIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Paging >-----#
    Paging = SEQ(name='Paging', mode=MODE_TYPE)
    _Paging_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __Paging_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___Paging_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____Paging_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____Paging_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEPagingIdentity')))
    _____Paging_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingDRX')))
    _____Paging_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAIListForPaging')))
    _____Paging_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingPriority')))
    _____Paging_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityForPaging')))
    _____Paging_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingOrigin')))
    _____Paging_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AssistanceDataForPaging')))
    _____Paging_protocolIEs__item__id_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-Paging-eDRXInfo')))
    _____Paging_protocolIEs__item__id_tab_val_Value_8 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-PagingDRX')))
    _____Paging_protocolIEs__item__id_tab_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Enhanced-CoverageRestriction')))
    _____Paging_protocolIEs__item__id_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WUS-Assistance-Information')))
    _____Paging_protocolIEs__item__id_tab_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-PagingeDRXInformation')))
    _____Paging_protocolIEs__item__id_tab_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBrestricted')))
    _____Paging_protocolIEs__item__id_tab_val_Value_13 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NR-PagingeDRXInformation')))
    _____Paging_protocolIEs__item__id_tab_val_Value_14 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingCause')))
    _____Paging_protocolIEs__item__id_tab_val_Value_15 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PEIPSassistanceInformation')))
    ____Paging_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 115), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 50), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 103), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 52), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 118), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 51), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 11), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 203), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 202), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 205), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 208), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 223), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 222), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 332), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 342), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 344), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Paging_protocolIEs__item__id._const_tab = ____Paging_protocolIEs__item__id_tab
    ___Paging_protocolIEs__item__id._const_tab_at = None
    ___Paging_protocolIEs__item__id._const_tab_id = 'id'
    ___Paging_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___Paging_protocolIEs__item__criticality._const_tab = ____Paging_protocolIEs__item__id_tab
    ___Paging_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___Paging_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___Paging_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___Paging_protocolIEs__item__value._const_tab = ____Paging_protocolIEs__item__id_tab
    ___Paging_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___Paging_protocolIEs__item__value._const_tab_id = 'Value'
    __Paging_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___Paging_protocolIEs__item__id),
        ('criticality', ___Paging_protocolIEs__item__criticality),
        ('value', ___Paging_protocolIEs__item__value),
        ])
    __Paging_protocolIEs__item_._ext = None
    _Paging_protocolIEs._cont = __Paging_protocolIEs__item_
    _Paging_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    Paging._cont = ASN1Dict([
        ('protocolIEs', _Paging_protocolIEs),
        ])
    Paging._ext = []
    
    #-----< PagingIEs >-----#
    PagingIEs = CLASS(name='PagingIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PagingIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEPagingIdentity')))
    _PagingIEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingDRX')))
    _PagingIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAIListForPaging')))
    _PagingIEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingPriority')))
    _PagingIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityForPaging')))
    _PagingIEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingOrigin')))
    _PagingIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AssistanceDataForPaging')))
    _PagingIEs_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-Paging-eDRXInfo')))
    _PagingIEs_val_Value_8 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-PagingDRX')))
    _PagingIEs_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Enhanced-CoverageRestriction')))
    _PagingIEs_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WUS-Assistance-Information')))
    _PagingIEs_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EUTRA-PagingeDRXInformation')))
    _PagingIEs_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBrestricted')))
    _PagingIEs_val_Value_13 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NR-PagingeDRXInformation')))
    _PagingIEs_val_Value_14 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingCause')))
    _PagingIEs_val_Value_15 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PEIPSassistanceInformation')))
    PagingIEs._val = ASN1Set(rv=[dict([('id', 115), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 50), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 103), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 52), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 118), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 51), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 11), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 203), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 202), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 205), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 208), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 223), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_11), ('presence', 'optional')]), dict([('id', 222), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_12), ('presence', 'optional')]), dict([('id', 332), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_13), ('presence', 'optional')]), dict([('id', 342), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_14), ('presence', 'optional')]), dict([('id', 344), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_15), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< InitialUEMessage >-----#
    InitialUEMessage = SEQ(name='InitialUEMessage', mode=MODE_TYPE)
    _InitialUEMessage_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __InitialUEMessage_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___InitialUEMessage_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____InitialUEMessage_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCEstablishmentCause')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-S-TMSI')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_5 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMFSetID')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEContextRequest')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SourceToTarget-AMFInformationReroute')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_9 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IABNodeIndication')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_11 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBSupport-Indicator')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEM-Indication')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EDT-Session')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_14 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AuthenticatedIndication')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_15 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NPN-AccessInformation')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_16 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedCapIndication')))
    ____InitialUEMessage_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 85), ('criticality', 'reject'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 38), ('criticality', 'reject'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 121), ('criticality', 'reject'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 90), ('criticality', 'ignore'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 26), ('criticality', 'reject'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 112), ('criticality', 'ignore'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'reject'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'ignore'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 174), ('criticality', 'ignore'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 201), ('criticality', 'reject'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 224), ('criticality', 'reject'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 225), ('criticality', 'ignore'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 227), ('criticality', 'ignore'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 245), ('criticality', 'ignore'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 259), ('criticality', 'reject'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')]), dict([('id', 333), ('criticality', 'ignore'), ('Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___InitialUEMessage_protocolIEs__item__id._const_tab = ____InitialUEMessage_protocolIEs__item__id_tab
    ___InitialUEMessage_protocolIEs__item__id._const_tab_at = None
    ___InitialUEMessage_protocolIEs__item__id._const_tab_id = 'id'
    ___InitialUEMessage_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___InitialUEMessage_protocolIEs__item__criticality._const_tab = ____InitialUEMessage_protocolIEs__item__id_tab
    ___InitialUEMessage_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___InitialUEMessage_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___InitialUEMessage_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___InitialUEMessage_protocolIEs__item__value._const_tab = ____InitialUEMessage_protocolIEs__item__id_tab
    ___InitialUEMessage_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___InitialUEMessage_protocolIEs__item__value._const_tab_id = 'Value'
    __InitialUEMessage_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___InitialUEMessage_protocolIEs__item__id),
        ('criticality', ___InitialUEMessage_protocolIEs__item__criticality),
        ('value', ___InitialUEMessage_protocolIEs__item__value),
        ])
    __InitialUEMessage_protocolIEs__item_._ext = None
    _InitialUEMessage_protocolIEs._cont = __InitialUEMessage_protocolIEs__item_
    _InitialUEMessage_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    InitialUEMessage._cont = ASN1Dict([
        ('protocolIEs', _InitialUEMessage_protocolIEs),
        ])
    InitialUEMessage._ext = []
    
    #-----< InitialUEMessage-IEs >-----#
    InitialUEMessage_IEs = CLASS(name='InitialUEMessage-IEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _InitialUEMessage_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _InitialUEMessage_IEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _InitialUEMessage_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _InitialUEMessage_IEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RRCEstablishmentCause')))
    _InitialUEMessage_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-S-TMSI')))
    _InitialUEMessage_IEs_val_Value_5 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMFSetID')))
    _InitialUEMessage_IEs_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEContextRequest')))
    _InitialUEMessage_IEs_val_Value_7 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _InitialUEMessage_IEs_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SourceToTarget-AMFInformationReroute')))
    _InitialUEMessage_IEs_val_Value_9 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PLMNIdentity')))
    _InitialUEMessage_IEs_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IABNodeIndication')))
    _InitialUEMessage_IEs_val_Value_11 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBSupport-Indicator')))
    _InitialUEMessage_IEs_val_Value_12 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LTEM-Indication')))
    _InitialUEMessage_IEs_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EDT-Session')))
    _InitialUEMessage_IEs_val_Value_14 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AuthenticatedIndication')))
    _InitialUEMessage_IEs_val_Value_15 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NPN-AccessInformation')))
    _InitialUEMessage_IEs_val_Value_16 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RedCapIndication')))
    InitialUEMessage_IEs._val = ASN1Set(rv=[dict([('id', 85), ('criticality', 'reject'), ('Value', _InitialUEMessage_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 38), ('criticality', 'reject'), ('Value', _InitialUEMessage_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 121), ('criticality', 'reject'), ('Value', _InitialUEMessage_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 90), ('criticality', 'ignore'), ('Value', _InitialUEMessage_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 26), ('criticality', 'reject'), ('Value', _InitialUEMessage_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _InitialUEMessage_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 112), ('criticality', 'ignore'), ('Value', _InitialUEMessage_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'reject'), ('Value', _InitialUEMessage_IEs_val_Value_7), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'ignore'), ('Value', _InitialUEMessage_IEs_val_Value_8), ('presence', 'optional')]), dict([('id', 174), ('criticality', 'ignore'), ('Value', _InitialUEMessage_IEs_val_Value_9), ('presence', 'optional')]), dict([('id', 201), ('criticality', 'reject'), ('Value', _InitialUEMessage_IEs_val_Value_10), ('presence', 'optional')]), dict([('id', 224), ('criticality', 'reject'), ('Value', _InitialUEMessage_IEs_val_Value_11), ('presence', 'optional')]), dict([('id', 225), ('criticality', 'ignore'), ('Value', _InitialUEMessage_IEs_val_Value_12), ('presence', 'optional')]), dict([('id', 227), ('criticality', 'ignore'), ('Value', _InitialUEMessage_IEs_val_Value_13), ('presence', 'optional')]), dict([('id', 245), ('criticality', 'ignore'), ('Value', _InitialUEMessage_IEs_val_Value_14), ('presence', 'optional')]), dict([('id', 259), ('criticality', 'reject'), ('Value', _InitialUEMessage_IEs_val_Value_15), ('presence', 'optional')]), dict([('id', 333), ('criticality', 'ignore'), ('Value', _InitialUEMessage_IEs_val_Value_16), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DownlinkNASTransport >-----#
    DownlinkNASTransport = SEQ(name='DownlinkNASTransport', mode=MODE_TYPE)
    _DownlinkNASTransport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __DownlinkNASTransport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___DownlinkNASTransport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____DownlinkNASTransport_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_2 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMFName')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANPagingPriority')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MobilityRestrictionList')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IndexToRFSP')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEAggregateMaximumBitRate')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_8 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SRVCCOperationPossible')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Enhanced-CoverageRestriction')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_11 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-ConnectedTime')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_12 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-DifferentiationInfo')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBrestricted')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_14 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_15 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UECapabilityInfoRequest')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_16 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EndIndication')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_17 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_18 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargetNSSAIInformation')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_19 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MaskedIMEISV')))
    ____DownlinkNASTransport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 48), ('criticality', 'reject'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 83), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 38), ('criticality', 'reject'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 36), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 31), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 110), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'reject'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 205), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 206), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 209), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 222), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 117), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')]), dict([('id', 228), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_15), ('presence', 'optional')]), dict([('id', 226), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_16), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'reject'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_17), ('presence', 'optional')]), dict([('id', 334), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_18), ('presence', 'optional')]), dict([('id', 34), ('criticality', 'ignore'), ('Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_19), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DownlinkNASTransport_protocolIEs__item__id._const_tab = ____DownlinkNASTransport_protocolIEs__item__id_tab
    ___DownlinkNASTransport_protocolIEs__item__id._const_tab_at = None
    ___DownlinkNASTransport_protocolIEs__item__id._const_tab_id = 'id'
    ___DownlinkNASTransport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___DownlinkNASTransport_protocolIEs__item__criticality._const_tab = ____DownlinkNASTransport_protocolIEs__item__id_tab
    ___DownlinkNASTransport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DownlinkNASTransport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DownlinkNASTransport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___DownlinkNASTransport_protocolIEs__item__value._const_tab = ____DownlinkNASTransport_protocolIEs__item__id_tab
    ___DownlinkNASTransport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DownlinkNASTransport_protocolIEs__item__value._const_tab_id = 'Value'
    __DownlinkNASTransport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DownlinkNASTransport_protocolIEs__item__id),
        ('criticality', ___DownlinkNASTransport_protocolIEs__item__criticality),
        ('value', ___DownlinkNASTransport_protocolIEs__item__value),
        ])
    __DownlinkNASTransport_protocolIEs__item_._ext = None
    _DownlinkNASTransport_protocolIEs._cont = __DownlinkNASTransport_protocolIEs__item_
    _DownlinkNASTransport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DownlinkNASTransport._cont = ASN1Dict([
        ('protocolIEs', _DownlinkNASTransport_protocolIEs),
        ])
    DownlinkNASTransport._ext = []
    
    #-----< DownlinkNASTransport-IEs >-----#
    DownlinkNASTransport_IEs = CLASS(name='DownlinkNASTransport-IEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _DownlinkNASTransport_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _DownlinkNASTransport_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _DownlinkNASTransport_IEs_val_Value_2 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMFName')))
    _DownlinkNASTransport_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANPagingPriority')))
    _DownlinkNASTransport_IEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _DownlinkNASTransport_IEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MobilityRestrictionList')))
    _DownlinkNASTransport_IEs_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IndexToRFSP')))
    _DownlinkNASTransport_IEs_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEAggregateMaximumBitRate')))
    _DownlinkNASTransport_IEs_val_Value_8 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _DownlinkNASTransport_IEs_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SRVCCOperationPossible')))
    _DownlinkNASTransport_IEs_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Enhanced-CoverageRestriction')))
    _DownlinkNASTransport_IEs_val_Value_11 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-ConnectedTime')))
    _DownlinkNASTransport_IEs_val_Value_12 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-DifferentiationInfo')))
    _DownlinkNASTransport_IEs_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBrestricted')))
    _DownlinkNASTransport_IEs_val_Value_14 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _DownlinkNASTransport_IEs_val_Value_15 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UECapabilityInfoRequest')))
    _DownlinkNASTransport_IEs_val_Value_16 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EndIndication')))
    _DownlinkNASTransport_IEs_val_Value_17 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    _DownlinkNASTransport_IEs_val_Value_18 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TargetNSSAIInformation')))
    _DownlinkNASTransport_IEs_val_Value_19 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MaskedIMEISV')))
    DownlinkNASTransport_IEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _DownlinkNASTransport_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _DownlinkNASTransport_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 48), ('criticality', 'reject'), ('Value', _DownlinkNASTransport_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 83), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 38), ('criticality', 'reject'), ('Value', _DownlinkNASTransport_IEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 36), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 31), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 110), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_7), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'reject'), ('Value', _DownlinkNASTransport_IEs_val_Value_8), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_9), ('presence', 'optional')]), dict([('id', 205), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_10), ('presence', 'optional')]), dict([('id', 206), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_11), ('presence', 'optional')]), dict([('id', 209), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_12), ('presence', 'optional')]), dict([('id', 222), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_13), ('presence', 'optional')]), dict([('id', 117), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_14), ('presence', 'optional')]), dict([('id', 228), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_15), ('presence', 'optional')]), dict([('id', 226), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_16), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'reject'), ('Value', _DownlinkNASTransport_IEs_val_Value_17), ('presence', 'optional')]), dict([('id', 334), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_18), ('presence', 'optional')]), dict([('id', 34), ('criticality', 'ignore'), ('Value', _DownlinkNASTransport_IEs_val_Value_19), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UplinkNASTransport >-----#
    UplinkNASTransport = SEQ(name='UplinkNASTransport', mode=MODE_TYPE)
    _UplinkNASTransport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UplinkNASTransport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UplinkNASTransport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____UplinkNASTransport_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE)
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE)
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE)
    ____UplinkNASTransport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 38), ('criticality', 'reject'), ('Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 239), ('criticality', 'reject'), ('Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 246), ('criticality', 'reject'), ('Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 247), ('criticality', 'reject'), ('Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UplinkNASTransport_protocolIEs__item__id._const_tab = ____UplinkNASTransport_protocolIEs__item__id_tab
    ___UplinkNASTransport_protocolIEs__item__id._const_tab_at = None
    ___UplinkNASTransport_protocolIEs__item__id._const_tab_id = 'id'
    ___UplinkNASTransport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UplinkNASTransport_protocolIEs__item__criticality._const_tab = ____UplinkNASTransport_protocolIEs__item__id_tab
    ___UplinkNASTransport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UplinkNASTransport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UplinkNASTransport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UplinkNASTransport_protocolIEs__item__value._const_tab = ____UplinkNASTransport_protocolIEs__item__id_tab
    ___UplinkNASTransport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UplinkNASTransport_protocolIEs__item__value._const_tab_id = 'Value'
    __UplinkNASTransport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UplinkNASTransport_protocolIEs__item__id),
        ('criticality', ___UplinkNASTransport_protocolIEs__item__criticality),
        ('value', ___UplinkNASTransport_protocolIEs__item__value),
        ])
    __UplinkNASTransport_protocolIEs__item_._ext = None
    _UplinkNASTransport_protocolIEs._cont = __UplinkNASTransport_protocolIEs__item_
    _UplinkNASTransport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UplinkNASTransport._cont = ASN1Dict([
        ('protocolIEs', _UplinkNASTransport_protocolIEs),
        ])
    UplinkNASTransport._ext = []
    
    #-----< UplinkNASTransport-IEs >-----#
    UplinkNASTransport_IEs = CLASS(name='UplinkNASTransport-IEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UplinkNASTransport_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UplinkNASTransport_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UplinkNASTransport_IEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _UplinkNASTransport_IEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _UplinkNASTransport_IEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE)
    _UplinkNASTransport_IEs_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE)
    _UplinkNASTransport_IEs_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE)
    UplinkNASTransport_IEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _UplinkNASTransport_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _UplinkNASTransport_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 38), ('criticality', 'reject'), ('Value', _UplinkNASTransport_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _UplinkNASTransport_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 239), ('criticality', 'reject'), ('Value', _UplinkNASTransport_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 246), ('criticality', 'reject'), ('Value', _UplinkNASTransport_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 247), ('criticality', 'reject'), ('Value', _UplinkNASTransport_IEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< NASNonDeliveryIndication >-----#
    NASNonDeliveryIndication = SEQ(name='NASNonDeliveryIndication', mode=MODE_TYPE)
    _NASNonDeliveryIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __NASNonDeliveryIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___NASNonDeliveryIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____NASNonDeliveryIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    ____NASNonDeliveryIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 38), ('criticality', 'ignore'), ('Value', _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___NASNonDeliveryIndication_protocolIEs__item__id._const_tab = ____NASNonDeliveryIndication_protocolIEs__item__id_tab
    ___NASNonDeliveryIndication_protocolIEs__item__id._const_tab_at = None
    ___NASNonDeliveryIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___NASNonDeliveryIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___NASNonDeliveryIndication_protocolIEs__item__criticality._const_tab = ____NASNonDeliveryIndication_protocolIEs__item__id_tab
    ___NASNonDeliveryIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___NASNonDeliveryIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___NASNonDeliveryIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___NASNonDeliveryIndication_protocolIEs__item__value._const_tab = ____NASNonDeliveryIndication_protocolIEs__item__id_tab
    ___NASNonDeliveryIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___NASNonDeliveryIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __NASNonDeliveryIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___NASNonDeliveryIndication_protocolIEs__item__id),
        ('criticality', ___NASNonDeliveryIndication_protocolIEs__item__criticality),
        ('value', ___NASNonDeliveryIndication_protocolIEs__item__value),
        ])
    __NASNonDeliveryIndication_protocolIEs__item_._ext = None
    _NASNonDeliveryIndication_protocolIEs._cont = __NASNonDeliveryIndication_protocolIEs__item_
    _NASNonDeliveryIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    NASNonDeliveryIndication._cont = ASN1Dict([
        ('protocolIEs', _NASNonDeliveryIndication_protocolIEs),
        ])
    NASNonDeliveryIndication._ext = []
    
    #-----< NASNonDeliveryIndication-IEs >-----#
    NASNonDeliveryIndication_IEs = CLASS(name='NASNonDeliveryIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _NASNonDeliveryIndication_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _NASNonDeliveryIndication_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _NASNonDeliveryIndication_IEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NAS-PDU')))
    _NASNonDeliveryIndication_IEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    NASNonDeliveryIndication_IEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _NASNonDeliveryIndication_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _NASNonDeliveryIndication_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 38), ('criticality', 'ignore'), ('Value', _NASNonDeliveryIndication_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _NASNonDeliveryIndication_IEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RerouteNASRequest >-----#
    RerouteNASRequest = SEQ(name='RerouteNASRequest', mode=MODE_TYPE)
    _RerouteNASRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __RerouteNASRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___RerouteNASRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____RerouteNASRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE)
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMFSetID')))
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SourceToTarget-AMFInformationReroute')))
    ____RerouteNASRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 85), ('criticality', 'reject'), ('Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 10), ('criticality', 'ignore'), ('Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 42), ('criticality', 'reject'), ('Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'reject'), ('Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'ignore'), ('Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RerouteNASRequest_protocolIEs__item__id._const_tab = ____RerouteNASRequest_protocolIEs__item__id_tab
    ___RerouteNASRequest_protocolIEs__item__id._const_tab_at = None
    ___RerouteNASRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___RerouteNASRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___RerouteNASRequest_protocolIEs__item__criticality._const_tab = ____RerouteNASRequest_protocolIEs__item__id_tab
    ___RerouteNASRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RerouteNASRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RerouteNASRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___RerouteNASRequest_protocolIEs__item__value._const_tab = ____RerouteNASRequest_protocolIEs__item__id_tab
    ___RerouteNASRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RerouteNASRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __RerouteNASRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RerouteNASRequest_protocolIEs__item__id),
        ('criticality', ___RerouteNASRequest_protocolIEs__item__criticality),
        ('value', ___RerouteNASRequest_protocolIEs__item__value),
        ])
    __RerouteNASRequest_protocolIEs__item_._ext = None
    _RerouteNASRequest_protocolIEs._cont = __RerouteNASRequest_protocolIEs__item_
    _RerouteNASRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RerouteNASRequest._cont = ASN1Dict([
        ('protocolIEs', _RerouteNASRequest_protocolIEs),
        ])
    RerouteNASRequest._ext = []
    
    #-----< RerouteNASRequest-IEs >-----#
    RerouteNASRequest_IEs = CLASS(name='RerouteNASRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _RerouteNASRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _RerouteNASRequest_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _RerouteNASRequest_IEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE)
    _RerouteNASRequest_IEs_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMFSetID')))
    _RerouteNASRequest_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _RerouteNASRequest_IEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SourceToTarget-AMFInformationReroute')))
    RerouteNASRequest_IEs._val = ASN1Set(rv=[dict([('id', 85), ('criticality', 'reject'), ('Value', _RerouteNASRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 10), ('criticality', 'ignore'), ('Value', _RerouteNASRequest_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 42), ('criticality', 'reject'), ('Value', _RerouteNASRequest_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _RerouteNASRequest_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'reject'), ('Value', _RerouteNASRequest_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'ignore'), ('Value', _RerouteNASRequest_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< NGSetupRequest >-----#
    NGSetupRequest = SEQ(name='NGSetupRequest', mode=MODE_TYPE)
    _NGSetupRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __NGSetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___NGSetupRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____NGSetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_1 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANNodeName')))
    _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SupportedTAList')))
    _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingDRX')))
    _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERetentionInformation')))
    _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-DefaultPagingDRX')))
    _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-RANNodeName')))
    ____NGSetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 27), ('criticality', 'reject'), ('Value', _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 82), ('criticality', 'ignore'), ('Value', _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 102), ('criticality', 'reject'), ('Value', _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 21), ('criticality', 'ignore'), ('Value', _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 147), ('criticality', 'ignore'), ('Value', _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 204), ('criticality', 'ignore'), ('Value', _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 273), ('criticality', 'ignore'), ('Value', _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___NGSetupRequest_protocolIEs__item__id._const_tab = ____NGSetupRequest_protocolIEs__item__id_tab
    ___NGSetupRequest_protocolIEs__item__id._const_tab_at = None
    ___NGSetupRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___NGSetupRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___NGSetupRequest_protocolIEs__item__criticality._const_tab = ____NGSetupRequest_protocolIEs__item__id_tab
    ___NGSetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___NGSetupRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___NGSetupRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___NGSetupRequest_protocolIEs__item__value._const_tab = ____NGSetupRequest_protocolIEs__item__id_tab
    ___NGSetupRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___NGSetupRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __NGSetupRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___NGSetupRequest_protocolIEs__item__id),
        ('criticality', ___NGSetupRequest_protocolIEs__item__criticality),
        ('value', ___NGSetupRequest_protocolIEs__item__value),
        ])
    __NGSetupRequest_protocolIEs__item_._ext = None
    _NGSetupRequest_protocolIEs._cont = __NGSetupRequest_protocolIEs__item_
    _NGSetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    NGSetupRequest._cont = ASN1Dict([
        ('protocolIEs', _NGSetupRequest_protocolIEs),
        ])
    NGSetupRequest._ext = []
    
    #-----< NGSetupRequestIEs >-----#
    NGSetupRequestIEs = CLASS(name='NGSetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _NGSetupRequestIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _NGSetupRequestIEs_val_Value_1 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANNodeName')))
    _NGSetupRequestIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SupportedTAList')))
    _NGSetupRequestIEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingDRX')))
    _NGSetupRequestIEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERetentionInformation')))
    _NGSetupRequestIEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-DefaultPagingDRX')))
    _NGSetupRequestIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-RANNodeName')))
    NGSetupRequestIEs._val = ASN1Set(rv=[dict([('id', 27), ('criticality', 'reject'), ('Value', _NGSetupRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 82), ('criticality', 'ignore'), ('Value', _NGSetupRequestIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 102), ('criticality', 'reject'), ('Value', _NGSetupRequestIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 21), ('criticality', 'ignore'), ('Value', _NGSetupRequestIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 147), ('criticality', 'ignore'), ('Value', _NGSetupRequestIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 204), ('criticality', 'ignore'), ('Value', _NGSetupRequestIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 273), ('criticality', 'ignore'), ('Value', _NGSetupRequestIEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< NGSetupResponse >-----#
    NGSetupResponse = SEQ(name='NGSetupResponse', mode=MODE_TYPE)
    _NGSetupResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __NGSetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___NGSetupResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____NGSetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_0 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMFName')))
    _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ServedGUAMIList')))
    _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RelativeAMFCapacity')))
    _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PLMNSupportList')))
    _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERetentionInformation')))
    _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IAB-Supported')))
    _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-AMFName')))
    ____NGSetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'reject'), ('Value', _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 96), ('criticality', 'reject'), ('Value', _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 80), ('criticality', 'reject'), ('Value', _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 147), ('criticality', 'ignore'), ('Value', _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 200), ('criticality', 'ignore'), ('Value', _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 274), ('criticality', 'ignore'), ('Value', _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___NGSetupResponse_protocolIEs__item__id._const_tab = ____NGSetupResponse_protocolIEs__item__id_tab
    ___NGSetupResponse_protocolIEs__item__id._const_tab_at = None
    ___NGSetupResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___NGSetupResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___NGSetupResponse_protocolIEs__item__criticality._const_tab = ____NGSetupResponse_protocolIEs__item__id_tab
    ___NGSetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___NGSetupResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___NGSetupResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___NGSetupResponse_protocolIEs__item__value._const_tab = ____NGSetupResponse_protocolIEs__item__id_tab
    ___NGSetupResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___NGSetupResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __NGSetupResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___NGSetupResponse_protocolIEs__item__id),
        ('criticality', ___NGSetupResponse_protocolIEs__item__criticality),
        ('value', ___NGSetupResponse_protocolIEs__item__value),
        ])
    __NGSetupResponse_protocolIEs__item_._ext = None
    _NGSetupResponse_protocolIEs._cont = __NGSetupResponse_protocolIEs__item_
    _NGSetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    NGSetupResponse._cont = ASN1Dict([
        ('protocolIEs', _NGSetupResponse_protocolIEs),
        ])
    NGSetupResponse._ext = []
    
    #-----< NGSetupResponseIEs >-----#
    NGSetupResponseIEs = CLASS(name='NGSetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _NGSetupResponseIEs_val_Value_0 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMFName')))
    _NGSetupResponseIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ServedGUAMIList')))
    _NGSetupResponseIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RelativeAMFCapacity')))
    _NGSetupResponseIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PLMNSupportList')))
    _NGSetupResponseIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _NGSetupResponseIEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERetentionInformation')))
    _NGSetupResponseIEs_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IAB-Supported')))
    _NGSetupResponseIEs_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-AMFName')))
    NGSetupResponseIEs._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'reject'), ('Value', _NGSetupResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 96), ('criticality', 'reject'), ('Value', _NGSetupResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _NGSetupResponseIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 80), ('criticality', 'reject'), ('Value', _NGSetupResponseIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _NGSetupResponseIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 147), ('criticality', 'ignore'), ('Value', _NGSetupResponseIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 200), ('criticality', 'ignore'), ('Value', _NGSetupResponseIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 274), ('criticality', 'ignore'), ('Value', _NGSetupResponseIEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< NGSetupFailure >-----#
    NGSetupFailure = SEQ(name='NGSetupFailure', mode=MODE_TYPE)
    _NGSetupFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __NGSetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___NGSetupFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____NGSetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____NGSetupFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____NGSetupFailure_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TimeToWait')))
    _____NGSetupFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____NGSetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 15), ('criticality', 'ignore'), ('Value', _____NGSetupFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 107), ('criticality', 'ignore'), ('Value', _____NGSetupFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____NGSetupFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___NGSetupFailure_protocolIEs__item__id._const_tab = ____NGSetupFailure_protocolIEs__item__id_tab
    ___NGSetupFailure_protocolIEs__item__id._const_tab_at = None
    ___NGSetupFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___NGSetupFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___NGSetupFailure_protocolIEs__item__criticality._const_tab = ____NGSetupFailure_protocolIEs__item__id_tab
    ___NGSetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___NGSetupFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___NGSetupFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___NGSetupFailure_protocolIEs__item__value._const_tab = ____NGSetupFailure_protocolIEs__item__id_tab
    ___NGSetupFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___NGSetupFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __NGSetupFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___NGSetupFailure_protocolIEs__item__id),
        ('criticality', ___NGSetupFailure_protocolIEs__item__criticality),
        ('value', ___NGSetupFailure_protocolIEs__item__value),
        ])
    __NGSetupFailure_protocolIEs__item_._ext = None
    _NGSetupFailure_protocolIEs._cont = __NGSetupFailure_protocolIEs__item_
    _NGSetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    NGSetupFailure._cont = ASN1Dict([
        ('protocolIEs', _NGSetupFailure_protocolIEs),
        ])
    NGSetupFailure._ext = []
    
    #-----< NGSetupFailureIEs >-----#
    NGSetupFailureIEs = CLASS(name='NGSetupFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _NGSetupFailureIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _NGSetupFailureIEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TimeToWait')))
    _NGSetupFailureIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    NGSetupFailureIEs._val = ASN1Set(rv=[dict([('id', 15), ('criticality', 'ignore'), ('Value', _NGSetupFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 107), ('criticality', 'ignore'), ('Value', _NGSetupFailureIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _NGSetupFailureIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RANConfigurationUpdate >-----#
    RANConfigurationUpdate = SEQ(name='RANConfigurationUpdate', mode=MODE_TYPE)
    _RANConfigurationUpdate_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __RANConfigurationUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___RANConfigurationUpdate_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____RANConfigurationUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANNodeName')))
    _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SupportedTAList')))
    _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingDRX')))
    _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-TNLAssociationToRemoveList')))
    _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-DefaultPagingDRX')))
    _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-RANNodeName')))
    ____RANConfigurationUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 82), ('criticality', 'ignore'), ('Value', _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 102), ('criticality', 'reject'), ('Value', _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 21), ('criticality', 'ignore'), ('Value', _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 27), ('criticality', 'ignore'), ('Value', _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 167), ('criticality', 'reject'), ('Value', _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 204), ('criticality', 'ignore'), ('Value', _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 273), ('criticality', 'ignore'), ('Value', _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RANConfigurationUpdate_protocolIEs__item__id._const_tab = ____RANConfigurationUpdate_protocolIEs__item__id_tab
    ___RANConfigurationUpdate_protocolIEs__item__id._const_tab_at = None
    ___RANConfigurationUpdate_protocolIEs__item__id._const_tab_id = 'id'
    ___RANConfigurationUpdate_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___RANConfigurationUpdate_protocolIEs__item__criticality._const_tab = ____RANConfigurationUpdate_protocolIEs__item__id_tab
    ___RANConfigurationUpdate_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RANConfigurationUpdate_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RANConfigurationUpdate_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___RANConfigurationUpdate_protocolIEs__item__value._const_tab = ____RANConfigurationUpdate_protocolIEs__item__id_tab
    ___RANConfigurationUpdate_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RANConfigurationUpdate_protocolIEs__item__value._const_tab_id = 'Value'
    __RANConfigurationUpdate_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RANConfigurationUpdate_protocolIEs__item__id),
        ('criticality', ___RANConfigurationUpdate_protocolIEs__item__criticality),
        ('value', ___RANConfigurationUpdate_protocolIEs__item__value),
        ])
    __RANConfigurationUpdate_protocolIEs__item_._ext = None
    _RANConfigurationUpdate_protocolIEs._cont = __RANConfigurationUpdate_protocolIEs__item_
    _RANConfigurationUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RANConfigurationUpdate._cont = ASN1Dict([
        ('protocolIEs', _RANConfigurationUpdate_protocolIEs),
        ])
    RANConfigurationUpdate._ext = []
    
    #-----< RANConfigurationUpdateIEs >-----#
    RANConfigurationUpdateIEs = CLASS(name='RANConfigurationUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _RANConfigurationUpdateIEs_val_Value_0 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RANNodeName')))
    _RANConfigurationUpdateIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SupportedTAList')))
    _RANConfigurationUpdateIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PagingDRX')))
    _RANConfigurationUpdateIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _RANConfigurationUpdateIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-TNLAssociationToRemoveList')))
    _RANConfigurationUpdateIEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-DefaultPagingDRX')))
    _RANConfigurationUpdateIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-RANNodeName')))
    RANConfigurationUpdateIEs._val = ASN1Set(rv=[dict([('id', 82), ('criticality', 'ignore'), ('Value', _RANConfigurationUpdateIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 102), ('criticality', 'reject'), ('Value', _RANConfigurationUpdateIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 21), ('criticality', 'ignore'), ('Value', _RANConfigurationUpdateIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 27), ('criticality', 'ignore'), ('Value', _RANConfigurationUpdateIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 167), ('criticality', 'reject'), ('Value', _RANConfigurationUpdateIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 204), ('criticality', 'ignore'), ('Value', _RANConfigurationUpdateIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 273), ('criticality', 'ignore'), ('Value', _RANConfigurationUpdateIEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RANConfigurationUpdateAcknowledge >-----#
    RANConfigurationUpdateAcknowledge = SEQ(name='RANConfigurationUpdateAcknowledge', mode=MODE_TYPE)
    _RANConfigurationUpdateAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __RANConfigurationUpdateAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___RANConfigurationUpdateAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____RANConfigurationUpdateAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____RANConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____RANConfigurationUpdateAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 19), ('criticality', 'ignore'), ('Value', _____RANConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RANConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab = ____RANConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___RANConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___RANConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___RANConfigurationUpdateAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___RANConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab = ____RANConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___RANConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RANConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RANConfigurationUpdateAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___RANConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab = ____RANConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___RANConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RANConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __RANConfigurationUpdateAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RANConfigurationUpdateAcknowledge_protocolIEs__item__id),
        ('criticality', ___RANConfigurationUpdateAcknowledge_protocolIEs__item__criticality),
        ('value', ___RANConfigurationUpdateAcknowledge_protocolIEs__item__value),
        ])
    __RANConfigurationUpdateAcknowledge_protocolIEs__item_._ext = None
    _RANConfigurationUpdateAcknowledge_protocolIEs._cont = __RANConfigurationUpdateAcknowledge_protocolIEs__item_
    _RANConfigurationUpdateAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RANConfigurationUpdateAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _RANConfigurationUpdateAcknowledge_protocolIEs),
        ])
    RANConfigurationUpdateAcknowledge._ext = []
    
    #-----< RANConfigurationUpdateAcknowledgeIEs >-----#
    RANConfigurationUpdateAcknowledgeIEs = CLASS(name='RANConfigurationUpdateAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _RANConfigurationUpdateAcknowledgeIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    RANConfigurationUpdateAcknowledgeIEs._val = ASN1Set(rv=[dict([('id', 19), ('criticality', 'ignore'), ('Value', _RANConfigurationUpdateAcknowledgeIEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RANConfigurationUpdateFailure >-----#
    RANConfigurationUpdateFailure = SEQ(name='RANConfigurationUpdateFailure', mode=MODE_TYPE)
    _RANConfigurationUpdateFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __RANConfigurationUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___RANConfigurationUpdateFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____RANConfigurationUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____RANConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____RANConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TimeToWait')))
    _____RANConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____RANConfigurationUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 15), ('criticality', 'ignore'), ('Value', _____RANConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 107), ('criticality', 'ignore'), ('Value', _____RANConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____RANConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RANConfigurationUpdateFailure_protocolIEs__item__id._const_tab = ____RANConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___RANConfigurationUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___RANConfigurationUpdateFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___RANConfigurationUpdateFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___RANConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab = ____RANConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___RANConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RANConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RANConfigurationUpdateFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___RANConfigurationUpdateFailure_protocolIEs__item__value._const_tab = ____RANConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___RANConfigurationUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RANConfigurationUpdateFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __RANConfigurationUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RANConfigurationUpdateFailure_protocolIEs__item__id),
        ('criticality', ___RANConfigurationUpdateFailure_protocolIEs__item__criticality),
        ('value', ___RANConfigurationUpdateFailure_protocolIEs__item__value),
        ])
    __RANConfigurationUpdateFailure_protocolIEs__item_._ext = None
    _RANConfigurationUpdateFailure_protocolIEs._cont = __RANConfigurationUpdateFailure_protocolIEs__item_
    _RANConfigurationUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RANConfigurationUpdateFailure._cont = ASN1Dict([
        ('protocolIEs', _RANConfigurationUpdateFailure_protocolIEs),
        ])
    RANConfigurationUpdateFailure._ext = []
    
    #-----< RANConfigurationUpdateFailureIEs >-----#
    RANConfigurationUpdateFailureIEs = CLASS(name='RANConfigurationUpdateFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _RANConfigurationUpdateFailureIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _RANConfigurationUpdateFailureIEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TimeToWait')))
    _RANConfigurationUpdateFailureIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    RANConfigurationUpdateFailureIEs._val = ASN1Set(rv=[dict([('id', 15), ('criticality', 'ignore'), ('Value', _RANConfigurationUpdateFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 107), ('criticality', 'ignore'), ('Value', _RANConfigurationUpdateFailureIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _RANConfigurationUpdateFailureIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< AMFConfigurationUpdate >-----#
    AMFConfigurationUpdate = SEQ(name='AMFConfigurationUpdate', mode=MODE_TYPE)
    _AMFConfigurationUpdate_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __AMFConfigurationUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___AMFConfigurationUpdate_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____AMFConfigurationUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMFName')))
    _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ServedGUAMIList')))
    _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RelativeAMFCapacity')))
    _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PLMNSupportList')))
    _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-TNLAssociationToAddList')))
    _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-TNLAssociationToRemoveList')))
    _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-TNLAssociationToUpdateList')))
    _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-AMFName')))
    ____AMFConfigurationUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'reject'), ('Value', _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'reject'), ('Value', _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 80), ('criticality', 'reject'), ('Value', _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 6), ('criticality', 'ignore'), ('Value', _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 274), ('criticality', 'ignore'), ('Value', _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___AMFConfigurationUpdate_protocolIEs__item__id._const_tab = ____AMFConfigurationUpdate_protocolIEs__item__id_tab
    ___AMFConfigurationUpdate_protocolIEs__item__id._const_tab_at = None
    ___AMFConfigurationUpdate_protocolIEs__item__id._const_tab_id = 'id'
    ___AMFConfigurationUpdate_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___AMFConfigurationUpdate_protocolIEs__item__criticality._const_tab = ____AMFConfigurationUpdate_protocolIEs__item__id_tab
    ___AMFConfigurationUpdate_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___AMFConfigurationUpdate_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___AMFConfigurationUpdate_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___AMFConfigurationUpdate_protocolIEs__item__value._const_tab = ____AMFConfigurationUpdate_protocolIEs__item__id_tab
    ___AMFConfigurationUpdate_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___AMFConfigurationUpdate_protocolIEs__item__value._const_tab_id = 'Value'
    __AMFConfigurationUpdate_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___AMFConfigurationUpdate_protocolIEs__item__id),
        ('criticality', ___AMFConfigurationUpdate_protocolIEs__item__criticality),
        ('value', ___AMFConfigurationUpdate_protocolIEs__item__value),
        ])
    __AMFConfigurationUpdate_protocolIEs__item_._ext = None
    _AMFConfigurationUpdate_protocolIEs._cont = __AMFConfigurationUpdate_protocolIEs__item_
    _AMFConfigurationUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    AMFConfigurationUpdate._cont = ASN1Dict([
        ('protocolIEs', _AMFConfigurationUpdate_protocolIEs),
        ])
    AMFConfigurationUpdate._ext = []
    
    #-----< AMFConfigurationUpdateIEs >-----#
    AMFConfigurationUpdateIEs = CLASS(name='AMFConfigurationUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _AMFConfigurationUpdateIEs_val_Value_0 = STR_PRINT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMFName')))
    _AMFConfigurationUpdateIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ServedGUAMIList')))
    _AMFConfigurationUpdateIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RelativeAMFCapacity')))
    _AMFConfigurationUpdateIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PLMNSupportList')))
    _AMFConfigurationUpdateIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-TNLAssociationToAddList')))
    _AMFConfigurationUpdateIEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-TNLAssociationToRemoveList')))
    _AMFConfigurationUpdateIEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-TNLAssociationToUpdateList')))
    _AMFConfigurationUpdateIEs_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Extended-AMFName')))
    AMFConfigurationUpdateIEs._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'reject'), ('Value', _AMFConfigurationUpdateIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'reject'), ('Value', _AMFConfigurationUpdateIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _AMFConfigurationUpdateIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 80), ('criticality', 'reject'), ('Value', _AMFConfigurationUpdateIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 6), ('criticality', 'ignore'), ('Value', _AMFConfigurationUpdateIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _AMFConfigurationUpdateIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _AMFConfigurationUpdateIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 274), ('criticality', 'ignore'), ('Value', _AMFConfigurationUpdateIEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< AMFConfigurationUpdateAcknowledge >-----#
    AMFConfigurationUpdateAcknowledge = SEQ(name='AMFConfigurationUpdateAcknowledge', mode=MODE_TYPE)
    _AMFConfigurationUpdateAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __AMFConfigurationUpdateAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-TNLAssociationSetupList')))
    _____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TNLAssociationList')))
    _____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'ignore'), ('Value', _____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 4), ('criticality', 'ignore'), ('Value', _____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab = ____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab = ____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab = ____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __AMFConfigurationUpdateAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__id),
        ('criticality', ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__criticality),
        ('value', ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__value),
        ])
    __AMFConfigurationUpdateAcknowledge_protocolIEs__item_._ext = None
    _AMFConfigurationUpdateAcknowledge_protocolIEs._cont = __AMFConfigurationUpdateAcknowledge_protocolIEs__item_
    _AMFConfigurationUpdateAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    AMFConfigurationUpdateAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _AMFConfigurationUpdateAcknowledge_protocolIEs),
        ])
    AMFConfigurationUpdateAcknowledge._ext = []
    
    #-----< AMFConfigurationUpdateAcknowledgeIEs >-----#
    AMFConfigurationUpdateAcknowledgeIEs = CLASS(name='AMFConfigurationUpdateAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _AMFConfigurationUpdateAcknowledgeIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-TNLAssociationSetupList')))
    _AMFConfigurationUpdateAcknowledgeIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TNLAssociationList')))
    _AMFConfigurationUpdateAcknowledgeIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    AMFConfigurationUpdateAcknowledgeIEs._val = ASN1Set(rv=[dict([('id', 5), ('criticality', 'ignore'), ('Value', _AMFConfigurationUpdateAcknowledgeIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 4), ('criticality', 'ignore'), ('Value', _AMFConfigurationUpdateAcknowledgeIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _AMFConfigurationUpdateAcknowledgeIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< AMFConfigurationUpdateFailure >-----#
    AMFConfigurationUpdateFailure = SEQ(name='AMFConfigurationUpdateFailure', mode=MODE_TYPE)
    _AMFConfigurationUpdateFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __AMFConfigurationUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___AMFConfigurationUpdateFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TimeToWait')))
    _____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 15), ('criticality', 'ignore'), ('Value', _____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 107), ('criticality', 'ignore'), ('Value', _____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___AMFConfigurationUpdateFailure_protocolIEs__item__id._const_tab = ____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___AMFConfigurationUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___AMFConfigurationUpdateFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___AMFConfigurationUpdateFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___AMFConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab = ____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___AMFConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___AMFConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___AMFConfigurationUpdateFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___AMFConfigurationUpdateFailure_protocolIEs__item__value._const_tab = ____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___AMFConfigurationUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___AMFConfigurationUpdateFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __AMFConfigurationUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___AMFConfigurationUpdateFailure_protocolIEs__item__id),
        ('criticality', ___AMFConfigurationUpdateFailure_protocolIEs__item__criticality),
        ('value', ___AMFConfigurationUpdateFailure_protocolIEs__item__value),
        ])
    __AMFConfigurationUpdateFailure_protocolIEs__item_._ext = None
    _AMFConfigurationUpdateFailure_protocolIEs._cont = __AMFConfigurationUpdateFailure_protocolIEs__item_
    _AMFConfigurationUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    AMFConfigurationUpdateFailure._cont = ASN1Dict([
        ('protocolIEs', _AMFConfigurationUpdateFailure_protocolIEs),
        ])
    AMFConfigurationUpdateFailure._ext = []
    
    #-----< AMFConfigurationUpdateFailureIEs >-----#
    AMFConfigurationUpdateFailureIEs = CLASS(name='AMFConfigurationUpdateFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _AMFConfigurationUpdateFailureIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _AMFConfigurationUpdateFailureIEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TimeToWait')))
    _AMFConfigurationUpdateFailureIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    AMFConfigurationUpdateFailureIEs._val = ASN1Set(rv=[dict([('id', 15), ('criticality', 'ignore'), ('Value', _AMFConfigurationUpdateFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 107), ('criticality', 'ignore'), ('Value', _AMFConfigurationUpdateFailureIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _AMFConfigurationUpdateFailureIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< AMFStatusIndication >-----#
    AMFStatusIndication = SEQ(name='AMFStatusIndication', mode=MODE_TYPE)
    _AMFStatusIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __AMFStatusIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___AMFStatusIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____AMFStatusIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____AMFStatusIndication_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UnavailableGUAMIList')))
    ____AMFStatusIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 120), ('criticality', 'reject'), ('Value', _____AMFStatusIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___AMFStatusIndication_protocolIEs__item__id._const_tab = ____AMFStatusIndication_protocolIEs__item__id_tab
    ___AMFStatusIndication_protocolIEs__item__id._const_tab_at = None
    ___AMFStatusIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___AMFStatusIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___AMFStatusIndication_protocolIEs__item__criticality._const_tab = ____AMFStatusIndication_protocolIEs__item__id_tab
    ___AMFStatusIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___AMFStatusIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___AMFStatusIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___AMFStatusIndication_protocolIEs__item__value._const_tab = ____AMFStatusIndication_protocolIEs__item__id_tab
    ___AMFStatusIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___AMFStatusIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __AMFStatusIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___AMFStatusIndication_protocolIEs__item__id),
        ('criticality', ___AMFStatusIndication_protocolIEs__item__criticality),
        ('value', ___AMFStatusIndication_protocolIEs__item__value),
        ])
    __AMFStatusIndication_protocolIEs__item_._ext = None
    _AMFStatusIndication_protocolIEs._cont = __AMFStatusIndication_protocolIEs__item_
    _AMFStatusIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    AMFStatusIndication._cont = ASN1Dict([
        ('protocolIEs', _AMFStatusIndication_protocolIEs),
        ])
    AMFStatusIndication._ext = []
    
    #-----< AMFStatusIndicationIEs >-----#
    AMFStatusIndicationIEs = CLASS(name='AMFStatusIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _AMFStatusIndicationIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UnavailableGUAMIList')))
    AMFStatusIndicationIEs._val = ASN1Set(rv=[dict([('id', 120), ('criticality', 'reject'), ('Value', _AMFStatusIndicationIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< NGReset >-----#
    NGReset = SEQ(name='NGReset', mode=MODE_TYPE)
    _NGReset_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __NGReset_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___NGReset_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____NGReset_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____NGReset_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____NGReset_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ResetType')))
    ____NGReset_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 15), ('criticality', 'ignore'), ('Value', _____NGReset_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 88), ('criticality', 'reject'), ('Value', _____NGReset_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___NGReset_protocolIEs__item__id._const_tab = ____NGReset_protocolIEs__item__id_tab
    ___NGReset_protocolIEs__item__id._const_tab_at = None
    ___NGReset_protocolIEs__item__id._const_tab_id = 'id'
    ___NGReset_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___NGReset_protocolIEs__item__criticality._const_tab = ____NGReset_protocolIEs__item__id_tab
    ___NGReset_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___NGReset_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___NGReset_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___NGReset_protocolIEs__item__value._const_tab = ____NGReset_protocolIEs__item__id_tab
    ___NGReset_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___NGReset_protocolIEs__item__value._const_tab_id = 'Value'
    __NGReset_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___NGReset_protocolIEs__item__id),
        ('criticality', ___NGReset_protocolIEs__item__criticality),
        ('value', ___NGReset_protocolIEs__item__value),
        ])
    __NGReset_protocolIEs__item_._ext = None
    _NGReset_protocolIEs._cont = __NGReset_protocolIEs__item_
    _NGReset_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    NGReset._cont = ASN1Dict([
        ('protocolIEs', _NGReset_protocolIEs),
        ])
    NGReset._ext = []
    
    #-----< NGResetIEs >-----#
    NGResetIEs = CLASS(name='NGResetIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _NGResetIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _NGResetIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ResetType')))
    NGResetIEs._val = ASN1Set(rv=[dict([('id', 15), ('criticality', 'ignore'), ('Value', _NGResetIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 88), ('criticality', 'reject'), ('Value', _NGResetIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< NGResetAcknowledge >-----#
    NGResetAcknowledge = SEQ(name='NGResetAcknowledge', mode=MODE_TYPE)
    _NGResetAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __NGResetAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___NGResetAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____NGResetAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____NGResetAcknowledge_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-associatedLogicalNG-connectionList')))
    _____NGResetAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____NGResetAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _____NGResetAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____NGResetAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___NGResetAcknowledge_protocolIEs__item__id._const_tab = ____NGResetAcknowledge_protocolIEs__item__id_tab
    ___NGResetAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___NGResetAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___NGResetAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___NGResetAcknowledge_protocolIEs__item__criticality._const_tab = ____NGResetAcknowledge_protocolIEs__item__id_tab
    ___NGResetAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___NGResetAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___NGResetAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___NGResetAcknowledge_protocolIEs__item__value._const_tab = ____NGResetAcknowledge_protocolIEs__item__id_tab
    ___NGResetAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___NGResetAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __NGResetAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___NGResetAcknowledge_protocolIEs__item__id),
        ('criticality', ___NGResetAcknowledge_protocolIEs__item__criticality),
        ('value', ___NGResetAcknowledge_protocolIEs__item__value),
        ])
    __NGResetAcknowledge_protocolIEs__item_._ext = None
    _NGResetAcknowledge_protocolIEs._cont = __NGResetAcknowledge_protocolIEs__item_
    _NGResetAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    NGResetAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _NGResetAcknowledge_protocolIEs),
        ])
    NGResetAcknowledge._ext = []
    
    #-----< NGResetAcknowledgeIEs >-----#
    NGResetAcknowledgeIEs = CLASS(name='NGResetAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _NGResetAcknowledgeIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-associatedLogicalNG-connectionList')))
    _NGResetAcknowledgeIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    NGResetAcknowledgeIEs._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Value', _NGResetAcknowledgeIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _NGResetAcknowledgeIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ErrorIndication >-----#
    ErrorIndication = SEQ(name='ErrorIndication', mode=MODE_TYPE)
    _ErrorIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __ErrorIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___ErrorIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____ErrorIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-S-TMSI')))
    ____ErrorIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 26), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolIEs__item__id._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__id._const_tab_at = None
    ___ErrorIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___ErrorIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___ErrorIndication_protocolIEs__item__criticality._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ErrorIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___ErrorIndication_protocolIEs__item__value._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __ErrorIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ErrorIndication_protocolIEs__item__id),
        ('criticality', ___ErrorIndication_protocolIEs__item__criticality),
        ('value', ___ErrorIndication_protocolIEs__item__value),
        ])
    __ErrorIndication_protocolIEs__item_._ext = None
    _ErrorIndication_protocolIEs._cont = __ErrorIndication_protocolIEs__item_
    _ErrorIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ErrorIndication._cont = ASN1Dict([
        ('protocolIEs', _ErrorIndication_protocolIEs),
        ])
    ErrorIndication._ext = []
    
    #-----< ErrorIndicationIEs >-----#
    ErrorIndicationIEs = CLASS(name='ErrorIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _ErrorIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _ErrorIndicationIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _ErrorIndicationIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _ErrorIndicationIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    _ErrorIndicationIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'FiveG-S-TMSI')))
    ErrorIndicationIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 26), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< OverloadStart >-----#
    OverloadStart = SEQ(name='OverloadStart', mode=MODE_TYPE)
    _OverloadStart_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __OverloadStart_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___OverloadStart_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____OverloadStart_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____OverloadStart_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'OverloadResponse')))
    _____OverloadStart_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TrafficLoadReductionIndication')))
    _____OverloadStart_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'OverloadStartNSSAIList')))
    ____OverloadStart_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____OverloadStart_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____OverloadStart_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 49), ('criticality', 'ignore'), ('Value', _____OverloadStart_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___OverloadStart_protocolIEs__item__id._const_tab = ____OverloadStart_protocolIEs__item__id_tab
    ___OverloadStart_protocolIEs__item__id._const_tab_at = None
    ___OverloadStart_protocolIEs__item__id._const_tab_id = 'id'
    ___OverloadStart_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___OverloadStart_protocolIEs__item__criticality._const_tab = ____OverloadStart_protocolIEs__item__id_tab
    ___OverloadStart_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___OverloadStart_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___OverloadStart_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___OverloadStart_protocolIEs__item__value._const_tab = ____OverloadStart_protocolIEs__item__id_tab
    ___OverloadStart_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___OverloadStart_protocolIEs__item__value._const_tab_id = 'Value'
    __OverloadStart_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___OverloadStart_protocolIEs__item__id),
        ('criticality', ___OverloadStart_protocolIEs__item__criticality),
        ('value', ___OverloadStart_protocolIEs__item__value),
        ])
    __OverloadStart_protocolIEs__item_._ext = None
    _OverloadStart_protocolIEs._cont = __OverloadStart_protocolIEs__item_
    _OverloadStart_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    OverloadStart._cont = ASN1Dict([
        ('protocolIEs', _OverloadStart_protocolIEs),
        ])
    OverloadStart._ext = []
    
    #-----< OverloadStartIEs >-----#
    OverloadStartIEs = CLASS(name='OverloadStartIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _OverloadStartIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'OverloadResponse')))
    _OverloadStartIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TrafficLoadReductionIndication')))
    _OverloadStartIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'OverloadStartNSSAIList')))
    OverloadStartIEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _OverloadStartIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _OverloadStartIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 49), ('criticality', 'ignore'), ('Value', _OverloadStartIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< OverloadStop >-----#
    OverloadStop = SEQ(name='OverloadStop', mode=MODE_TYPE)
    _OverloadStop_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __OverloadStop_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___OverloadStop_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____OverloadStop_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ____OverloadStop_protocolIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OverloadStop_protocolIEs__item__id._const_tab = ____OverloadStop_protocolIEs__item__id_tab
    ___OverloadStop_protocolIEs__item__id._const_tab_at = None
    ___OverloadStop_protocolIEs__item__id._const_tab_id = 'id'
    ___OverloadStop_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ____OverloadStop_protocolIEs__item__criticality_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ____OverloadStop_protocolIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OverloadStop_protocolIEs__item__criticality._const_tab = ____OverloadStop_protocolIEs__item__criticality_tab
    ___OverloadStop_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___OverloadStop_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___OverloadStop_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ____OverloadStop_protocolIEs__item__value_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    ____OverloadStop_protocolIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OverloadStop_protocolIEs__item__value._const_tab = ____OverloadStop_protocolIEs__item__value_tab
    ___OverloadStop_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___OverloadStop_protocolIEs__item__value._const_tab_id = 'Value'
    __OverloadStop_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___OverloadStop_protocolIEs__item__id),
        ('criticality', ___OverloadStop_protocolIEs__item__criticality),
        ('value', ___OverloadStop_protocolIEs__item__value),
        ])
    __OverloadStop_protocolIEs__item_._ext = None
    _OverloadStop_protocolIEs._cont = __OverloadStop_protocolIEs__item_
    _OverloadStop_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    OverloadStop._cont = ASN1Dict([
        ('protocolIEs', _OverloadStop_protocolIEs),
        ])
    OverloadStop._ext = []
    
    #-----< OverloadStopIEs >-----#
    OverloadStopIEs = CLASS(name='OverloadStopIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    OverloadStopIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UplinkRANConfigurationTransfer >-----#
    UplinkRANConfigurationTransfer = SEQ(name='UplinkRANConfigurationTransfer', mode=MODE_TYPE)
    _UplinkRANConfigurationTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UplinkRANConfigurationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UplinkRANConfigurationTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SONConfigurationTransfer')))
    _____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EN-DCSONConfigurationTransfer')))
    _____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IntersystemSONConfigurationTransfer')))
    ____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 99), ('criticality', 'ignore'), ('Value', _____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'ignore'), ('Value', _____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 251), ('criticality', 'ignore'), ('Value', _____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UplinkRANConfigurationTransfer_protocolIEs__item__id._const_tab = ____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab
    ___UplinkRANConfigurationTransfer_protocolIEs__item__id._const_tab_at = None
    ___UplinkRANConfigurationTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___UplinkRANConfigurationTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UplinkRANConfigurationTransfer_protocolIEs__item__criticality._const_tab = ____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab
    ___UplinkRANConfigurationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UplinkRANConfigurationTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UplinkRANConfigurationTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UplinkRANConfigurationTransfer_protocolIEs__item__value._const_tab = ____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab
    ___UplinkRANConfigurationTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UplinkRANConfigurationTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __UplinkRANConfigurationTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UplinkRANConfigurationTransfer_protocolIEs__item__id),
        ('criticality', ___UplinkRANConfigurationTransfer_protocolIEs__item__criticality),
        ('value', ___UplinkRANConfigurationTransfer_protocolIEs__item__value),
        ])
    __UplinkRANConfigurationTransfer_protocolIEs__item_._ext = None
    _UplinkRANConfigurationTransfer_protocolIEs._cont = __UplinkRANConfigurationTransfer_protocolIEs__item_
    _UplinkRANConfigurationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UplinkRANConfigurationTransfer._cont = ASN1Dict([
        ('protocolIEs', _UplinkRANConfigurationTransfer_protocolIEs),
        ])
    UplinkRANConfigurationTransfer._ext = []
    
    #-----< UplinkRANConfigurationTransferIEs >-----#
    UplinkRANConfigurationTransferIEs = CLASS(name='UplinkRANConfigurationTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UplinkRANConfigurationTransferIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SONConfigurationTransfer')))
    _UplinkRANConfigurationTransferIEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EN-DCSONConfigurationTransfer')))
    _UplinkRANConfigurationTransferIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IntersystemSONConfigurationTransfer')))
    UplinkRANConfigurationTransferIEs._val = ASN1Set(rv=[dict([('id', 99), ('criticality', 'ignore'), ('Value', _UplinkRANConfigurationTransferIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 158), ('criticality', 'ignore'), ('Value', _UplinkRANConfigurationTransferIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 251), ('criticality', 'ignore'), ('Value', _UplinkRANConfigurationTransferIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DownlinkRANConfigurationTransfer >-----#
    DownlinkRANConfigurationTransfer = SEQ(name='DownlinkRANConfigurationTransfer', mode=MODE_TYPE)
    _DownlinkRANConfigurationTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __DownlinkRANConfigurationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___DownlinkRANConfigurationTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SONConfigurationTransfer')))
    _____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EN-DCSONConfigurationTransfer')))
    _____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IntersystemSONConfigurationTransfer')))
    ____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 98), ('criticality', 'ignore'), ('Value', _____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 250), ('criticality', 'ignore'), ('Value', _____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DownlinkRANConfigurationTransfer_protocolIEs__item__id._const_tab = ____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab
    ___DownlinkRANConfigurationTransfer_protocolIEs__item__id._const_tab_at = None
    ___DownlinkRANConfigurationTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___DownlinkRANConfigurationTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___DownlinkRANConfigurationTransfer_protocolIEs__item__criticality._const_tab = ____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab
    ___DownlinkRANConfigurationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DownlinkRANConfigurationTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DownlinkRANConfigurationTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___DownlinkRANConfigurationTransfer_protocolIEs__item__value._const_tab = ____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab
    ___DownlinkRANConfigurationTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DownlinkRANConfigurationTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __DownlinkRANConfigurationTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DownlinkRANConfigurationTransfer_protocolIEs__item__id),
        ('criticality', ___DownlinkRANConfigurationTransfer_protocolIEs__item__criticality),
        ('value', ___DownlinkRANConfigurationTransfer_protocolIEs__item__value),
        ])
    __DownlinkRANConfigurationTransfer_protocolIEs__item_._ext = None
    _DownlinkRANConfigurationTransfer_protocolIEs._cont = __DownlinkRANConfigurationTransfer_protocolIEs__item_
    _DownlinkRANConfigurationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DownlinkRANConfigurationTransfer._cont = ASN1Dict([
        ('protocolIEs', _DownlinkRANConfigurationTransfer_protocolIEs),
        ])
    DownlinkRANConfigurationTransfer._ext = []
    
    #-----< DownlinkRANConfigurationTransferIEs >-----#
    DownlinkRANConfigurationTransferIEs = CLASS(name='DownlinkRANConfigurationTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _DownlinkRANConfigurationTransferIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SONConfigurationTransfer')))
    _DownlinkRANConfigurationTransferIEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EN-DCSONConfigurationTransfer')))
    _DownlinkRANConfigurationTransferIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IntersystemSONConfigurationTransfer')))
    DownlinkRANConfigurationTransferIEs._val = ASN1Set(rv=[dict([('id', 98), ('criticality', 'ignore'), ('Value', _DownlinkRANConfigurationTransferIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _DownlinkRANConfigurationTransferIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 250), ('criticality', 'ignore'), ('Value', _DownlinkRANConfigurationTransferIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< WriteReplaceWarningRequest >-----#
    WriteReplaceWarningRequest = SEQ(name='WriteReplaceWarningRequest', mode=MODE_TYPE)
    _WriteReplaceWarningRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __WriteReplaceWarningRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___WriteReplaceWarningRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____WriteReplaceWarningRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MessageIdentifier')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SerialNumber')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WarningAreaList')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RepetitionPeriod')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NumberOfBroadcastsRequested')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WarningType')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WarningSecurityInfo')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_7 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DataCodingScheme')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_8 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WarningMessageContents')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ConcurrentWarningMessageInd')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_10 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WarningAreaCoordinates')))
    ____WriteReplaceWarningRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 35), ('criticality', 'reject'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 95), ('criticality', 'reject'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 122), ('criticality', 'ignore'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 87), ('criticality', 'reject'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 47), ('criticality', 'reject'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 125), ('criticality', 'ignore'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 124), ('criticality', 'ignore'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 20), ('criticality', 'ignore'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 123), ('criticality', 'ignore'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'reject'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 141), ('criticality', 'ignore'), ('Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___WriteReplaceWarningRequest_protocolIEs__item__id._const_tab = ____WriteReplaceWarningRequest_protocolIEs__item__id_tab
    ___WriteReplaceWarningRequest_protocolIEs__item__id._const_tab_at = None
    ___WriteReplaceWarningRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___WriteReplaceWarningRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___WriteReplaceWarningRequest_protocolIEs__item__criticality._const_tab = ____WriteReplaceWarningRequest_protocolIEs__item__id_tab
    ___WriteReplaceWarningRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___WriteReplaceWarningRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___WriteReplaceWarningRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___WriteReplaceWarningRequest_protocolIEs__item__value._const_tab = ____WriteReplaceWarningRequest_protocolIEs__item__id_tab
    ___WriteReplaceWarningRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___WriteReplaceWarningRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __WriteReplaceWarningRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___WriteReplaceWarningRequest_protocolIEs__item__id),
        ('criticality', ___WriteReplaceWarningRequest_protocolIEs__item__criticality),
        ('value', ___WriteReplaceWarningRequest_protocolIEs__item__value),
        ])
    __WriteReplaceWarningRequest_protocolIEs__item_._ext = None
    _WriteReplaceWarningRequest_protocolIEs._cont = __WriteReplaceWarningRequest_protocolIEs__item_
    _WriteReplaceWarningRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WriteReplaceWarningRequest._cont = ASN1Dict([
        ('protocolIEs', _WriteReplaceWarningRequest_protocolIEs),
        ])
    WriteReplaceWarningRequest._ext = []
    
    #-----< WriteReplaceWarningRequestIEs >-----#
    WriteReplaceWarningRequestIEs = CLASS(name='WriteReplaceWarningRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _WriteReplaceWarningRequestIEs_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MessageIdentifier')))
    _WriteReplaceWarningRequestIEs_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SerialNumber')))
    _WriteReplaceWarningRequestIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WarningAreaList')))
    _WriteReplaceWarningRequestIEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RepetitionPeriod')))
    _WriteReplaceWarningRequestIEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NumberOfBroadcastsRequested')))
    _WriteReplaceWarningRequestIEs_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WarningType')))
    _WriteReplaceWarningRequestIEs_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WarningSecurityInfo')))
    _WriteReplaceWarningRequestIEs_val_Value_7 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DataCodingScheme')))
    _WriteReplaceWarningRequestIEs_val_Value_8 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WarningMessageContents')))
    _WriteReplaceWarningRequestIEs_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'ConcurrentWarningMessageInd')))
    _WriteReplaceWarningRequestIEs_val_Value_10 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WarningAreaCoordinates')))
    WriteReplaceWarningRequestIEs._val = ASN1Set(rv=[dict([('id', 35), ('criticality', 'reject'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 95), ('criticality', 'reject'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 122), ('criticality', 'ignore'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 87), ('criticality', 'reject'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 47), ('criticality', 'reject'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 125), ('criticality', 'ignore'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 124), ('criticality', 'ignore'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 20), ('criticality', 'ignore'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 123), ('criticality', 'ignore'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'reject'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 141), ('criticality', 'ignore'), ('Value', _WriteReplaceWarningRequestIEs_val_Value_10), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< WriteReplaceWarningResponse >-----#
    WriteReplaceWarningResponse = SEQ(name='WriteReplaceWarningResponse', mode=MODE_TYPE)
    _WriteReplaceWarningResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __WriteReplaceWarningResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___WriteReplaceWarningResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____WriteReplaceWarningResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MessageIdentifier')))
    _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SerialNumber')))
    _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'BroadcastCompletedAreaList')))
    _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____WriteReplaceWarningResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 35), ('criticality', 'reject'), ('Value', _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 95), ('criticality', 'reject'), ('Value', _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___WriteReplaceWarningResponse_protocolIEs__item__id._const_tab = ____WriteReplaceWarningResponse_protocolIEs__item__id_tab
    ___WriteReplaceWarningResponse_protocolIEs__item__id._const_tab_at = None
    ___WriteReplaceWarningResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___WriteReplaceWarningResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___WriteReplaceWarningResponse_protocolIEs__item__criticality._const_tab = ____WriteReplaceWarningResponse_protocolIEs__item__id_tab
    ___WriteReplaceWarningResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___WriteReplaceWarningResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___WriteReplaceWarningResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___WriteReplaceWarningResponse_protocolIEs__item__value._const_tab = ____WriteReplaceWarningResponse_protocolIEs__item__id_tab
    ___WriteReplaceWarningResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___WriteReplaceWarningResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __WriteReplaceWarningResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___WriteReplaceWarningResponse_protocolIEs__item__id),
        ('criticality', ___WriteReplaceWarningResponse_protocolIEs__item__criticality),
        ('value', ___WriteReplaceWarningResponse_protocolIEs__item__value),
        ])
    __WriteReplaceWarningResponse_protocolIEs__item_._ext = None
    _WriteReplaceWarningResponse_protocolIEs._cont = __WriteReplaceWarningResponse_protocolIEs__item_
    _WriteReplaceWarningResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WriteReplaceWarningResponse._cont = ASN1Dict([
        ('protocolIEs', _WriteReplaceWarningResponse_protocolIEs),
        ])
    WriteReplaceWarningResponse._ext = []
    
    #-----< WriteReplaceWarningResponseIEs >-----#
    WriteReplaceWarningResponseIEs = CLASS(name='WriteReplaceWarningResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _WriteReplaceWarningResponseIEs_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MessageIdentifier')))
    _WriteReplaceWarningResponseIEs_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SerialNumber')))
    _WriteReplaceWarningResponseIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'BroadcastCompletedAreaList')))
    _WriteReplaceWarningResponseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    WriteReplaceWarningResponseIEs._val = ASN1Set(rv=[dict([('id', 35), ('criticality', 'reject'), ('Value', _WriteReplaceWarningResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 95), ('criticality', 'reject'), ('Value', _WriteReplaceWarningResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 13), ('criticality', 'ignore'), ('Value', _WriteReplaceWarningResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _WriteReplaceWarningResponseIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PWSCancelRequest >-----#
    PWSCancelRequest = SEQ(name='PWSCancelRequest', mode=MODE_TYPE)
    _PWSCancelRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PWSCancelRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PWSCancelRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____PWSCancelRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MessageIdentifier')))
    _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SerialNumber')))
    _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WarningAreaList')))
    _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CancelAllWarningMessages')))
    ____PWSCancelRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 35), ('criticality', 'reject'), ('Value', _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 95), ('criticality', 'reject'), ('Value', _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 122), ('criticality', 'ignore'), ('Value', _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 14), ('criticality', 'reject'), ('Value', _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PWSCancelRequest_protocolIEs__item__id._const_tab = ____PWSCancelRequest_protocolIEs__item__id_tab
    ___PWSCancelRequest_protocolIEs__item__id._const_tab_at = None
    ___PWSCancelRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___PWSCancelRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___PWSCancelRequest_protocolIEs__item__criticality._const_tab = ____PWSCancelRequest_protocolIEs__item__id_tab
    ___PWSCancelRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PWSCancelRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PWSCancelRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___PWSCancelRequest_protocolIEs__item__value._const_tab = ____PWSCancelRequest_protocolIEs__item__id_tab
    ___PWSCancelRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PWSCancelRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __PWSCancelRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PWSCancelRequest_protocolIEs__item__id),
        ('criticality', ___PWSCancelRequest_protocolIEs__item__criticality),
        ('value', ___PWSCancelRequest_protocolIEs__item__value),
        ])
    __PWSCancelRequest_protocolIEs__item_._ext = None
    _PWSCancelRequest_protocolIEs._cont = __PWSCancelRequest_protocolIEs__item_
    _PWSCancelRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PWSCancelRequest._cont = ASN1Dict([
        ('protocolIEs', _PWSCancelRequest_protocolIEs),
        ])
    PWSCancelRequest._ext = []
    
    #-----< PWSCancelRequestIEs >-----#
    PWSCancelRequestIEs = CLASS(name='PWSCancelRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PWSCancelRequestIEs_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MessageIdentifier')))
    _PWSCancelRequestIEs_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SerialNumber')))
    _PWSCancelRequestIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'WarningAreaList')))
    _PWSCancelRequestIEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CancelAllWarningMessages')))
    PWSCancelRequestIEs._val = ASN1Set(rv=[dict([('id', 35), ('criticality', 'reject'), ('Value', _PWSCancelRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 95), ('criticality', 'reject'), ('Value', _PWSCancelRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 122), ('criticality', 'ignore'), ('Value', _PWSCancelRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 14), ('criticality', 'reject'), ('Value', _PWSCancelRequestIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PWSCancelResponse >-----#
    PWSCancelResponse = SEQ(name='PWSCancelResponse', mode=MODE_TYPE)
    _PWSCancelResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PWSCancelResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PWSCancelResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____PWSCancelResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MessageIdentifier')))
    _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SerialNumber')))
    _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'BroadcastCancelledAreaList')))
    _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____PWSCancelResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 35), ('criticality', 'reject'), ('Value', _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 95), ('criticality', 'reject'), ('Value', _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 12), ('criticality', 'ignore'), ('Value', _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PWSCancelResponse_protocolIEs__item__id._const_tab = ____PWSCancelResponse_protocolIEs__item__id_tab
    ___PWSCancelResponse_protocolIEs__item__id._const_tab_at = None
    ___PWSCancelResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___PWSCancelResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___PWSCancelResponse_protocolIEs__item__criticality._const_tab = ____PWSCancelResponse_protocolIEs__item__id_tab
    ___PWSCancelResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PWSCancelResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PWSCancelResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___PWSCancelResponse_protocolIEs__item__value._const_tab = ____PWSCancelResponse_protocolIEs__item__id_tab
    ___PWSCancelResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PWSCancelResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __PWSCancelResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PWSCancelResponse_protocolIEs__item__id),
        ('criticality', ___PWSCancelResponse_protocolIEs__item__criticality),
        ('value', ___PWSCancelResponse_protocolIEs__item__value),
        ])
    __PWSCancelResponse_protocolIEs__item_._ext = None
    _PWSCancelResponse_protocolIEs._cont = __PWSCancelResponse_protocolIEs__item_
    _PWSCancelResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PWSCancelResponse._cont = ASN1Dict([
        ('protocolIEs', _PWSCancelResponse_protocolIEs),
        ])
    PWSCancelResponse._ext = []
    
    #-----< PWSCancelResponseIEs >-----#
    PWSCancelResponseIEs = CLASS(name='PWSCancelResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PWSCancelResponseIEs_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MessageIdentifier')))
    _PWSCancelResponseIEs_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'SerialNumber')))
    _PWSCancelResponseIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'BroadcastCancelledAreaList')))
    _PWSCancelResponseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    PWSCancelResponseIEs._val = ASN1Set(rv=[dict([('id', 35), ('criticality', 'reject'), ('Value', _PWSCancelResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 95), ('criticality', 'reject'), ('Value', _PWSCancelResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 12), ('criticality', 'ignore'), ('Value', _PWSCancelResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _PWSCancelResponseIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PWSRestartIndication >-----#
    PWSRestartIndication = SEQ(name='PWSRestartIndication', mode=MODE_TYPE)
    _PWSRestartIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PWSRestartIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PWSRestartIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____PWSRestartIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CellIDListForRestart')))
    _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAIListForRestart')))
    _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaIDListForRestart')))
    ____PWSRestartIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 16), ('criticality', 'reject'), ('Value', _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 27), ('criticality', 'reject'), ('Value', _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 104), ('criticality', 'reject'), ('Value', _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 23), ('criticality', 'reject'), ('Value', _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PWSRestartIndication_protocolIEs__item__id._const_tab = ____PWSRestartIndication_protocolIEs__item__id_tab
    ___PWSRestartIndication_protocolIEs__item__id._const_tab_at = None
    ___PWSRestartIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___PWSRestartIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___PWSRestartIndication_protocolIEs__item__criticality._const_tab = ____PWSRestartIndication_protocolIEs__item__id_tab
    ___PWSRestartIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PWSRestartIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PWSRestartIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___PWSRestartIndication_protocolIEs__item__value._const_tab = ____PWSRestartIndication_protocolIEs__item__id_tab
    ___PWSRestartIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PWSRestartIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __PWSRestartIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PWSRestartIndication_protocolIEs__item__id),
        ('criticality', ___PWSRestartIndication_protocolIEs__item__criticality),
        ('value', ___PWSRestartIndication_protocolIEs__item__value),
        ])
    __PWSRestartIndication_protocolIEs__item_._ext = None
    _PWSRestartIndication_protocolIEs._cont = __PWSRestartIndication_protocolIEs__item_
    _PWSRestartIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PWSRestartIndication._cont = ASN1Dict([
        ('protocolIEs', _PWSRestartIndication_protocolIEs),
        ])
    PWSRestartIndication._ext = []
    
    #-----< PWSRestartIndicationIEs >-----#
    PWSRestartIndicationIEs = CLASS(name='PWSRestartIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PWSRestartIndicationIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CellIDListForRestart')))
    _PWSRestartIndicationIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    _PWSRestartIndicationIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TAIListForRestart')))
    _PWSRestartIndicationIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EmergencyAreaIDListForRestart')))
    PWSRestartIndicationIEs._val = ASN1Set(rv=[dict([('id', 16), ('criticality', 'reject'), ('Value', _PWSRestartIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 27), ('criticality', 'reject'), ('Value', _PWSRestartIndicationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 104), ('criticality', 'reject'), ('Value', _PWSRestartIndicationIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 23), ('criticality', 'reject'), ('Value', _PWSRestartIndicationIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PWSFailureIndication >-----#
    PWSFailureIndication = SEQ(name='PWSFailureIndication', mode=MODE_TYPE)
    _PWSFailureIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __PWSFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___PWSFailureIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____PWSFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PWSFailedCellIDList')))
    _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    ____PWSFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 81), ('criticality', 'reject'), ('Value', _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 27), ('criticality', 'reject'), ('Value', _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___PWSFailureIndication_protocolIEs__item__id._const_tab = ____PWSFailureIndication_protocolIEs__item__id_tab
    ___PWSFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___PWSFailureIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___PWSFailureIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___PWSFailureIndication_protocolIEs__item__criticality._const_tab = ____PWSFailureIndication_protocolIEs__item__id_tab
    ___PWSFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PWSFailureIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PWSFailureIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___PWSFailureIndication_protocolIEs__item__value._const_tab = ____PWSFailureIndication_protocolIEs__item__id_tab
    ___PWSFailureIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PWSFailureIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __PWSFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PWSFailureIndication_protocolIEs__item__id),
        ('criticality', ___PWSFailureIndication_protocolIEs__item__criticality),
        ('value', ___PWSFailureIndication_protocolIEs__item__value),
        ])
    __PWSFailureIndication_protocolIEs__item_._ext = None
    _PWSFailureIndication_protocolIEs._cont = __PWSFailureIndication_protocolIEs__item_
    _PWSFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PWSFailureIndication._cont = ASN1Dict([
        ('protocolIEs', _PWSFailureIndication_protocolIEs),
        ])
    PWSFailureIndication._ext = []
    
    #-----< PWSFailureIndicationIEs >-----#
    PWSFailureIndicationIEs = CLASS(name='PWSFailureIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _PWSFailureIndicationIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PWSFailedCellIDList')))
    _PWSFailureIndicationIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'GlobalRANNodeID')))
    PWSFailureIndicationIEs._val = ASN1Set(rv=[dict([('id', 81), ('criticality', 'reject'), ('Value', _PWSFailureIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 27), ('criticality', 'reject'), ('Value', _PWSFailureIndicationIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DownlinkUEAssociatedNRPPaTransport >-----#
    DownlinkUEAssociatedNRPPaTransport = SEQ(name='DownlinkUEAssociatedNRPPaTransport', mode=MODE_TYPE)
    _DownlinkUEAssociatedNRPPaTransport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __DownlinkUEAssociatedNRPPaTransport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RoutingID')))
    _____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRPPa-PDU')))
    ____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 89), ('criticality', 'reject'), ('Value', _____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 46), ('criticality', 'reject'), ('Value', _____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id._const_tab = ____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab
    ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id._const_tab_at = None
    ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id._const_tab_id = 'id'
    ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__criticality._const_tab = ____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab
    ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__value._const_tab = ____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab
    ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__value._const_tab_id = 'Value'
    __DownlinkUEAssociatedNRPPaTransport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id),
        ('criticality', ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__criticality),
        ('value', ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__value),
        ])
    __DownlinkUEAssociatedNRPPaTransport_protocolIEs__item_._ext = None
    _DownlinkUEAssociatedNRPPaTransport_protocolIEs._cont = __DownlinkUEAssociatedNRPPaTransport_protocolIEs__item_
    _DownlinkUEAssociatedNRPPaTransport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DownlinkUEAssociatedNRPPaTransport._cont = ASN1Dict([
        ('protocolIEs', _DownlinkUEAssociatedNRPPaTransport_protocolIEs),
        ])
    DownlinkUEAssociatedNRPPaTransport._ext = []
    
    #-----< DownlinkUEAssociatedNRPPaTransportIEs >-----#
    DownlinkUEAssociatedNRPPaTransportIEs = CLASS(name='DownlinkUEAssociatedNRPPaTransportIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _DownlinkUEAssociatedNRPPaTransportIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _DownlinkUEAssociatedNRPPaTransportIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _DownlinkUEAssociatedNRPPaTransportIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RoutingID')))
    _DownlinkUEAssociatedNRPPaTransportIEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRPPa-PDU')))
    DownlinkUEAssociatedNRPPaTransportIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _DownlinkUEAssociatedNRPPaTransportIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _DownlinkUEAssociatedNRPPaTransportIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 89), ('criticality', 'reject'), ('Value', _DownlinkUEAssociatedNRPPaTransportIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 46), ('criticality', 'reject'), ('Value', _DownlinkUEAssociatedNRPPaTransportIEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UplinkUEAssociatedNRPPaTransport >-----#
    UplinkUEAssociatedNRPPaTransport = SEQ(name='UplinkUEAssociatedNRPPaTransport', mode=MODE_TYPE)
    _UplinkUEAssociatedNRPPaTransport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UplinkUEAssociatedNRPPaTransport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RoutingID')))
    _____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRPPa-PDU')))
    ____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 89), ('criticality', 'reject'), ('Value', _____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 46), ('criticality', 'reject'), ('Value', _____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id._const_tab = ____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab
    ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id._const_tab_at = None
    ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id._const_tab_id = 'id'
    ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__criticality._const_tab = ____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab
    ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__value._const_tab = ____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab
    ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__value._const_tab_id = 'Value'
    __UplinkUEAssociatedNRPPaTransport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id),
        ('criticality', ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__criticality),
        ('value', ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__value),
        ])
    __UplinkUEAssociatedNRPPaTransport_protocolIEs__item_._ext = None
    _UplinkUEAssociatedNRPPaTransport_protocolIEs._cont = __UplinkUEAssociatedNRPPaTransport_protocolIEs__item_
    _UplinkUEAssociatedNRPPaTransport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UplinkUEAssociatedNRPPaTransport._cont = ASN1Dict([
        ('protocolIEs', _UplinkUEAssociatedNRPPaTransport_protocolIEs),
        ])
    UplinkUEAssociatedNRPPaTransport._ext = []
    
    #-----< UplinkUEAssociatedNRPPaTransportIEs >-----#
    UplinkUEAssociatedNRPPaTransportIEs = CLASS(name='UplinkUEAssociatedNRPPaTransportIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UplinkUEAssociatedNRPPaTransportIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UplinkUEAssociatedNRPPaTransportIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UplinkUEAssociatedNRPPaTransportIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RoutingID')))
    _UplinkUEAssociatedNRPPaTransportIEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRPPa-PDU')))
    UplinkUEAssociatedNRPPaTransportIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _UplinkUEAssociatedNRPPaTransportIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _UplinkUEAssociatedNRPPaTransportIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 89), ('criticality', 'reject'), ('Value', _UplinkUEAssociatedNRPPaTransportIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 46), ('criticality', 'reject'), ('Value', _UplinkUEAssociatedNRPPaTransportIEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DownlinkNonUEAssociatedNRPPaTransport >-----#
    DownlinkNonUEAssociatedNRPPaTransport = SEQ(name='DownlinkNonUEAssociatedNRPPaTransport', mode=MODE_TYPE)
    _DownlinkNonUEAssociatedNRPPaTransport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RoutingID')))
    _____DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRPPa-PDU')))
    ____DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 89), ('criticality', 'reject'), ('Value', _____DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 46), ('criticality', 'reject'), ('Value', _____DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id._const_tab = ____DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab
    ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id._const_tab_at = None
    ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id._const_tab_id = 'id'
    ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__criticality._const_tab = ____DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab
    ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__value._const_tab = ____DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab
    ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__value._const_tab_id = 'Value'
    __DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id),
        ('criticality', ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__criticality),
        ('value', ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__value),
        ])
    __DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item_._ext = None
    _DownlinkNonUEAssociatedNRPPaTransport_protocolIEs._cont = __DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item_
    _DownlinkNonUEAssociatedNRPPaTransport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DownlinkNonUEAssociatedNRPPaTransport._cont = ASN1Dict([
        ('protocolIEs', _DownlinkNonUEAssociatedNRPPaTransport_protocolIEs),
        ])
    DownlinkNonUEAssociatedNRPPaTransport._ext = []
    
    #-----< DownlinkNonUEAssociatedNRPPaTransportIEs >-----#
    DownlinkNonUEAssociatedNRPPaTransportIEs = CLASS(name='DownlinkNonUEAssociatedNRPPaTransportIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _DownlinkNonUEAssociatedNRPPaTransportIEs_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RoutingID')))
    _DownlinkNonUEAssociatedNRPPaTransportIEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRPPa-PDU')))
    DownlinkNonUEAssociatedNRPPaTransportIEs._val = ASN1Set(rv=[dict([('id', 89), ('criticality', 'reject'), ('Value', _DownlinkNonUEAssociatedNRPPaTransportIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 46), ('criticality', 'reject'), ('Value', _DownlinkNonUEAssociatedNRPPaTransportIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UplinkNonUEAssociatedNRPPaTransport >-----#
    UplinkNonUEAssociatedNRPPaTransport = SEQ(name='UplinkNonUEAssociatedNRPPaTransport', mode=MODE_TYPE)
    _UplinkNonUEAssociatedNRPPaTransport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RoutingID')))
    _____UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRPPa-PDU')))
    ____UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 89), ('criticality', 'reject'), ('Value', _____UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 46), ('criticality', 'reject'), ('Value', _____UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id._const_tab = ____UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab
    ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id._const_tab_at = None
    ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id._const_tab_id = 'id'
    ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__criticality._const_tab = ____UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab
    ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__value._const_tab = ____UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab
    ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__value._const_tab_id = 'Value'
    __UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id),
        ('criticality', ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__criticality),
        ('value', ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__value),
        ])
    __UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item_._ext = None
    _UplinkNonUEAssociatedNRPPaTransport_protocolIEs._cont = __UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item_
    _UplinkNonUEAssociatedNRPPaTransport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UplinkNonUEAssociatedNRPPaTransport._cont = ASN1Dict([
        ('protocolIEs', _UplinkNonUEAssociatedNRPPaTransport_protocolIEs),
        ])
    UplinkNonUEAssociatedNRPPaTransport._ext = []
    
    #-----< UplinkNonUEAssociatedNRPPaTransportIEs >-----#
    UplinkNonUEAssociatedNRPPaTransportIEs = CLASS(name='UplinkNonUEAssociatedNRPPaTransportIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UplinkNonUEAssociatedNRPPaTransportIEs_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RoutingID')))
    _UplinkNonUEAssociatedNRPPaTransportIEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NRPPa-PDU')))
    UplinkNonUEAssociatedNRPPaTransportIEs._val = ASN1Set(rv=[dict([('id', 89), ('criticality', 'reject'), ('Value', _UplinkNonUEAssociatedNRPPaTransportIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 46), ('criticality', 'reject'), ('Value', _UplinkNonUEAssociatedNRPPaTransportIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TraceStart >-----#
    TraceStart = SEQ(name='TraceStart', mode=MODE_TYPE)
    _TraceStart_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __TraceStart_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___TraceStart_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____TraceStart_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____TraceStart_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____TraceStart_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____TraceStart_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TraceActivation')))
    ____TraceStart_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____TraceStart_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____TraceStart_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 108), ('criticality', 'ignore'), ('Value', _____TraceStart_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___TraceStart_protocolIEs__item__id._const_tab = ____TraceStart_protocolIEs__item__id_tab
    ___TraceStart_protocolIEs__item__id._const_tab_at = None
    ___TraceStart_protocolIEs__item__id._const_tab_id = 'id'
    ___TraceStart_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___TraceStart_protocolIEs__item__criticality._const_tab = ____TraceStart_protocolIEs__item__id_tab
    ___TraceStart_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___TraceStart_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___TraceStart_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___TraceStart_protocolIEs__item__value._const_tab = ____TraceStart_protocolIEs__item__id_tab
    ___TraceStart_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___TraceStart_protocolIEs__item__value._const_tab_id = 'Value'
    __TraceStart_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___TraceStart_protocolIEs__item__id),
        ('criticality', ___TraceStart_protocolIEs__item__criticality),
        ('value', ___TraceStart_protocolIEs__item__value),
        ])
    __TraceStart_protocolIEs__item_._ext = None
    _TraceStart_protocolIEs._cont = __TraceStart_protocolIEs__item_
    _TraceStart_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    TraceStart._cont = ASN1Dict([
        ('protocolIEs', _TraceStart_protocolIEs),
        ])
    TraceStart._ext = []
    
    #-----< TraceStartIEs >-----#
    TraceStartIEs = CLASS(name='TraceStartIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _TraceStartIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _TraceStartIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _TraceStartIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TraceActivation')))
    TraceStartIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _TraceStartIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _TraceStartIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 108), ('criticality', 'ignore'), ('Value', _TraceStartIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TraceFailureIndication >-----#
    TraceFailureIndication = SEQ(name='TraceFailureIndication', mode=MODE_TYPE)
    _TraceFailureIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __TraceFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___TraceFailureIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____TraceFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRANTraceID')))
    _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    ____TraceFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 44), ('criticality', 'ignore'), ('Value', _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___TraceFailureIndication_protocolIEs__item__id._const_tab = ____TraceFailureIndication_protocolIEs__item__id_tab
    ___TraceFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___TraceFailureIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___TraceFailureIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___TraceFailureIndication_protocolIEs__item__criticality._const_tab = ____TraceFailureIndication_protocolIEs__item__id_tab
    ___TraceFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___TraceFailureIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___TraceFailureIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___TraceFailureIndication_protocolIEs__item__value._const_tab = ____TraceFailureIndication_protocolIEs__item__id_tab
    ___TraceFailureIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___TraceFailureIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __TraceFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___TraceFailureIndication_protocolIEs__item__id),
        ('criticality', ___TraceFailureIndication_protocolIEs__item__criticality),
        ('value', ___TraceFailureIndication_protocolIEs__item__value),
        ])
    __TraceFailureIndication_protocolIEs__item_._ext = None
    _TraceFailureIndication_protocolIEs._cont = __TraceFailureIndication_protocolIEs__item_
    _TraceFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    TraceFailureIndication._cont = ASN1Dict([
        ('protocolIEs', _TraceFailureIndication_protocolIEs),
        ])
    TraceFailureIndication._ext = []
    
    #-----< TraceFailureIndicationIEs >-----#
    TraceFailureIndicationIEs = CLASS(name='TraceFailureIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _TraceFailureIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _TraceFailureIndicationIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _TraceFailureIndicationIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRANTraceID')))
    _TraceFailureIndicationIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    TraceFailureIndicationIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _TraceFailureIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _TraceFailureIndicationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 44), ('criticality', 'ignore'), ('Value', _TraceFailureIndicationIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _TraceFailureIndicationIEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DeactivateTrace >-----#
    DeactivateTrace = SEQ(name='DeactivateTrace', mode=MODE_TYPE)
    _DeactivateTrace_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __DeactivateTrace_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___DeactivateTrace_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____DeactivateTrace_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRANTraceID')))
    ____DeactivateTrace_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 44), ('criticality', 'ignore'), ('Value', _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___DeactivateTrace_protocolIEs__item__id._const_tab = ____DeactivateTrace_protocolIEs__item__id_tab
    ___DeactivateTrace_protocolIEs__item__id._const_tab_at = None
    ___DeactivateTrace_protocolIEs__item__id._const_tab_id = 'id'
    ___DeactivateTrace_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___DeactivateTrace_protocolIEs__item__criticality._const_tab = ____DeactivateTrace_protocolIEs__item__id_tab
    ___DeactivateTrace_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DeactivateTrace_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DeactivateTrace_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___DeactivateTrace_protocolIEs__item__value._const_tab = ____DeactivateTrace_protocolIEs__item__id_tab
    ___DeactivateTrace_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DeactivateTrace_protocolIEs__item__value._const_tab_id = 'Value'
    __DeactivateTrace_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DeactivateTrace_protocolIEs__item__id),
        ('criticality', ___DeactivateTrace_protocolIEs__item__criticality),
        ('value', ___DeactivateTrace_protocolIEs__item__value),
        ])
    __DeactivateTrace_protocolIEs__item_._ext = None
    _DeactivateTrace_protocolIEs._cont = __DeactivateTrace_protocolIEs__item_
    _DeactivateTrace_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DeactivateTrace._cont = ASN1Dict([
        ('protocolIEs', _DeactivateTrace_protocolIEs),
        ])
    DeactivateTrace._ext = []
    
    #-----< DeactivateTraceIEs >-----#
    DeactivateTraceIEs = CLASS(name='DeactivateTraceIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _DeactivateTraceIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _DeactivateTraceIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _DeactivateTraceIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRANTraceID')))
    DeactivateTraceIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _DeactivateTraceIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _DeactivateTraceIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 44), ('criticality', 'ignore'), ('Value', _DeactivateTraceIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CellTrafficTrace >-----#
    CellTrafficTrace = SEQ(name='CellTrafficTrace', mode=MODE_TYPE)
    _CellTrafficTrace_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __CellTrafficTrace_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___CellTrafficTrace_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____CellTrafficTrace_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRANTraceID')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_4 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PrivacyIndicator')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_6 = STR_VIS(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'URI-address')))
    ____CellTrafficTrace_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 44), ('criticality', 'ignore'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 43), ('criticality', 'ignore'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 109), ('criticality', 'ignore'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 256), ('criticality', 'ignore'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 257), ('criticality', 'ignore'), ('Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellTrafficTrace_protocolIEs__item__id._const_tab = ____CellTrafficTrace_protocolIEs__item__id_tab
    ___CellTrafficTrace_protocolIEs__item__id._const_tab_at = None
    ___CellTrafficTrace_protocolIEs__item__id._const_tab_id = 'id'
    ___CellTrafficTrace_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___CellTrafficTrace_protocolIEs__item__criticality._const_tab = ____CellTrafficTrace_protocolIEs__item__id_tab
    ___CellTrafficTrace_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CellTrafficTrace_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CellTrafficTrace_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___CellTrafficTrace_protocolIEs__item__value._const_tab = ____CellTrafficTrace_protocolIEs__item__id_tab
    ___CellTrafficTrace_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CellTrafficTrace_protocolIEs__item__value._const_tab_id = 'Value'
    __CellTrafficTrace_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CellTrafficTrace_protocolIEs__item__id),
        ('criticality', ___CellTrafficTrace_protocolIEs__item__criticality),
        ('value', ___CellTrafficTrace_protocolIEs__item__value),
        ])
    __CellTrafficTrace_protocolIEs__item_._ext = None
    _CellTrafficTrace_protocolIEs._cont = __CellTrafficTrace_protocolIEs__item_
    _CellTrafficTrace_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    CellTrafficTrace._cont = ASN1Dict([
        ('protocolIEs', _CellTrafficTrace_protocolIEs),
        ])
    CellTrafficTrace._ext = []
    
    #-----< CellTrafficTraceIEs >-----#
    CellTrafficTraceIEs = CLASS(name='CellTrafficTraceIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _CellTrafficTraceIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _CellTrafficTraceIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _CellTrafficTraceIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRANTraceID')))
    _CellTrafficTraceIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NGRAN-CGI')))
    _CellTrafficTraceIEs_val_Value_4 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'TransportLayerAddress')))
    _CellTrafficTraceIEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PrivacyIndicator')))
    _CellTrafficTraceIEs_val_Value_6 = STR_VIS(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'URI-address')))
    CellTrafficTraceIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _CellTrafficTraceIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _CellTrafficTraceIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 44), ('criticality', 'ignore'), ('Value', _CellTrafficTraceIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 43), ('criticality', 'ignore'), ('Value', _CellTrafficTraceIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 109), ('criticality', 'ignore'), ('Value', _CellTrafficTraceIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 256), ('criticality', 'ignore'), ('Value', _CellTrafficTraceIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 257), ('criticality', 'ignore'), ('Value', _CellTrafficTraceIEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< LocationReportingControl >-----#
    LocationReportingControl = SEQ(name='LocationReportingControl', mode=MODE_TYPE)
    _LocationReportingControl_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __LocationReportingControl_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___LocationReportingControl_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____LocationReportingControl_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LocationReportingRequestType')))
    ____LocationReportingControl_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 33), ('criticality', 'ignore'), ('Value', _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___LocationReportingControl_protocolIEs__item__id._const_tab = ____LocationReportingControl_protocolIEs__item__id_tab
    ___LocationReportingControl_protocolIEs__item__id._const_tab_at = None
    ___LocationReportingControl_protocolIEs__item__id._const_tab_id = 'id'
    ___LocationReportingControl_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___LocationReportingControl_protocolIEs__item__criticality._const_tab = ____LocationReportingControl_protocolIEs__item__id_tab
    ___LocationReportingControl_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___LocationReportingControl_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___LocationReportingControl_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___LocationReportingControl_protocolIEs__item__value._const_tab = ____LocationReportingControl_protocolIEs__item__id_tab
    ___LocationReportingControl_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___LocationReportingControl_protocolIEs__item__value._const_tab_id = 'Value'
    __LocationReportingControl_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___LocationReportingControl_protocolIEs__item__id),
        ('criticality', ___LocationReportingControl_protocolIEs__item__criticality),
        ('value', ___LocationReportingControl_protocolIEs__item__value),
        ])
    __LocationReportingControl_protocolIEs__item_._ext = None
    _LocationReportingControl_protocolIEs._cont = __LocationReportingControl_protocolIEs__item_
    _LocationReportingControl_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    LocationReportingControl._cont = ASN1Dict([
        ('protocolIEs', _LocationReportingControl_protocolIEs),
        ])
    LocationReportingControl._ext = []
    
    #-----< LocationReportingControlIEs >-----#
    LocationReportingControlIEs = CLASS(name='LocationReportingControlIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _LocationReportingControlIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _LocationReportingControlIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _LocationReportingControlIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LocationReportingRequestType')))
    LocationReportingControlIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _LocationReportingControlIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _LocationReportingControlIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 33), ('criticality', 'ignore'), ('Value', _LocationReportingControlIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< LocationReportingFailureIndication >-----#
    LocationReportingFailureIndication = SEQ(name='LocationReportingFailureIndication', mode=MODE_TYPE)
    _LocationReportingFailureIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __LocationReportingFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___LocationReportingFailureIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____LocationReportingFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    ____LocationReportingFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___LocationReportingFailureIndication_protocolIEs__item__id._const_tab = ____LocationReportingFailureIndication_protocolIEs__item__id_tab
    ___LocationReportingFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___LocationReportingFailureIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___LocationReportingFailureIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___LocationReportingFailureIndication_protocolIEs__item__criticality._const_tab = ____LocationReportingFailureIndication_protocolIEs__item__id_tab
    ___LocationReportingFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___LocationReportingFailureIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___LocationReportingFailureIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___LocationReportingFailureIndication_protocolIEs__item__value._const_tab = ____LocationReportingFailureIndication_protocolIEs__item__id_tab
    ___LocationReportingFailureIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___LocationReportingFailureIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __LocationReportingFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___LocationReportingFailureIndication_protocolIEs__item__id),
        ('criticality', ___LocationReportingFailureIndication_protocolIEs__item__criticality),
        ('value', ___LocationReportingFailureIndication_protocolIEs__item__value),
        ])
    __LocationReportingFailureIndication_protocolIEs__item_._ext = None
    _LocationReportingFailureIndication_protocolIEs._cont = __LocationReportingFailureIndication_protocolIEs__item_
    _LocationReportingFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    LocationReportingFailureIndication._cont = ASN1Dict([
        ('protocolIEs', _LocationReportingFailureIndication_protocolIEs),
        ])
    LocationReportingFailureIndication._ext = []
    
    #-----< LocationReportingFailureIndicationIEs >-----#
    LocationReportingFailureIndicationIEs = CLASS(name='LocationReportingFailureIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _LocationReportingFailureIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _LocationReportingFailureIndicationIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _LocationReportingFailureIndicationIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    LocationReportingFailureIndicationIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _LocationReportingFailureIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _LocationReportingFailureIndicationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _LocationReportingFailureIndicationIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< LocationReport >-----#
    LocationReport = SEQ(name='LocationReport', mode=MODE_TYPE)
    _LocationReport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __LocationReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___LocationReport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____LocationReport_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEPresenceInAreaOfInterestList')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LocationReportingRequestType')))
    ____LocationReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 116), ('criticality', 'ignore'), ('Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 33), ('criticality', 'ignore'), ('Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___LocationReport_protocolIEs__item__id._const_tab = ____LocationReport_protocolIEs__item__id_tab
    ___LocationReport_protocolIEs__item__id._const_tab_at = None
    ___LocationReport_protocolIEs__item__id._const_tab_id = 'id'
    ___LocationReport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___LocationReport_protocolIEs__item__criticality._const_tab = ____LocationReport_protocolIEs__item__id_tab
    ___LocationReport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___LocationReport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___LocationReport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___LocationReport_protocolIEs__item__value._const_tab = ____LocationReport_protocolIEs__item__id_tab
    ___LocationReport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___LocationReport_protocolIEs__item__value._const_tab_id = 'Value'
    __LocationReport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___LocationReport_protocolIEs__item__id),
        ('criticality', ___LocationReport_protocolIEs__item__criticality),
        ('value', ___LocationReport_protocolIEs__item__value),
        ])
    __LocationReport_protocolIEs__item_._ext = None
    _LocationReport_protocolIEs._cont = __LocationReport_protocolIEs__item_
    _LocationReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    LocationReport._cont = ASN1Dict([
        ('protocolIEs', _LocationReport_protocolIEs),
        ])
    LocationReport._ext = []
    
    #-----< LocationReportIEs >-----#
    LocationReportIEs = CLASS(name='LocationReportIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _LocationReportIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _LocationReportIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _LocationReportIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    _LocationReportIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UEPresenceInAreaOfInterestList')))
    _LocationReportIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'LocationReportingRequestType')))
    LocationReportIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _LocationReportIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _LocationReportIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _LocationReportIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 116), ('criticality', 'ignore'), ('Value', _LocationReportIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 33), ('criticality', 'ignore'), ('Value', _LocationReportIEs_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UETNLABindingReleaseRequest >-----#
    UETNLABindingReleaseRequest = SEQ(name='UETNLABindingReleaseRequest', mode=MODE_TYPE)
    _UETNLABindingReleaseRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UETNLABindingReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UETNLABindingReleaseRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____UETNLABindingReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UETNLABindingReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UETNLABindingReleaseRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    ____UETNLABindingReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____UETNLABindingReleaseRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____UETNLABindingReleaseRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___UETNLABindingReleaseRequest_protocolIEs__item__id._const_tab = ____UETNLABindingReleaseRequest_protocolIEs__item__id_tab
    ___UETNLABindingReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___UETNLABindingReleaseRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___UETNLABindingReleaseRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UETNLABindingReleaseRequest_protocolIEs__item__criticality._const_tab = ____UETNLABindingReleaseRequest_protocolIEs__item__id_tab
    ___UETNLABindingReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UETNLABindingReleaseRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UETNLABindingReleaseRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UETNLABindingReleaseRequest_protocolIEs__item__value._const_tab = ____UETNLABindingReleaseRequest_protocolIEs__item__id_tab
    ___UETNLABindingReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UETNLABindingReleaseRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __UETNLABindingReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UETNLABindingReleaseRequest_protocolIEs__item__id),
        ('criticality', ___UETNLABindingReleaseRequest_protocolIEs__item__criticality),
        ('value', ___UETNLABindingReleaseRequest_protocolIEs__item__value),
        ])
    __UETNLABindingReleaseRequest_protocolIEs__item_._ext = None
    _UETNLABindingReleaseRequest_protocolIEs._cont = __UETNLABindingReleaseRequest_protocolIEs__item_
    _UETNLABindingReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UETNLABindingReleaseRequest._cont = ASN1Dict([
        ('protocolIEs', _UETNLABindingReleaseRequest_protocolIEs),
        ])
    UETNLABindingReleaseRequest._ext = []
    
    #-----< UETNLABindingReleaseRequestIEs >-----#
    UETNLABindingReleaseRequestIEs = CLASS(name='UETNLABindingReleaseRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UETNLABindingReleaseRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UETNLABindingReleaseRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    UETNLABindingReleaseRequestIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _UETNLABindingReleaseRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _UETNLABindingReleaseRequestIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UERadioCapabilityInfoIndication >-----#
    UERadioCapabilityInfoIndication = SEQ(name='UERadioCapabilityInfoIndication', mode=MODE_TYPE)
    _UERadioCapabilityInfoIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UERadioCapabilityInfoIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UERadioCapabilityInfoIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityForPaging')))
    _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    ____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 117), ('criticality', 'ignore'), ('Value', _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 118), ('criticality', 'ignore'), ('Value', _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 265), ('criticality', 'ignore'), ('Value', _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UERadioCapabilityInfoIndication_protocolIEs__item__id._const_tab = ____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab
    ___UERadioCapabilityInfoIndication_protocolIEs__item__id._const_tab_at = None
    ___UERadioCapabilityInfoIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___UERadioCapabilityInfoIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UERadioCapabilityInfoIndication_protocolIEs__item__criticality._const_tab = ____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab
    ___UERadioCapabilityInfoIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UERadioCapabilityInfoIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UERadioCapabilityInfoIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UERadioCapabilityInfoIndication_protocolIEs__item__value._const_tab = ____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab
    ___UERadioCapabilityInfoIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UERadioCapabilityInfoIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __UERadioCapabilityInfoIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UERadioCapabilityInfoIndication_protocolIEs__item__id),
        ('criticality', ___UERadioCapabilityInfoIndication_protocolIEs__item__criticality),
        ('value', ___UERadioCapabilityInfoIndication_protocolIEs__item__value),
        ])
    __UERadioCapabilityInfoIndication_protocolIEs__item_._ext = None
    _UERadioCapabilityInfoIndication_protocolIEs._cont = __UERadioCapabilityInfoIndication_protocolIEs__item_
    _UERadioCapabilityInfoIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UERadioCapabilityInfoIndication._cont = ASN1Dict([
        ('protocolIEs', _UERadioCapabilityInfoIndication_protocolIEs),
        ])
    UERadioCapabilityInfoIndication._ext = []
    
    #-----< UERadioCapabilityInfoIndicationIEs >-----#
    UERadioCapabilityInfoIndicationIEs = CLASS(name='UERadioCapabilityInfoIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UERadioCapabilityInfoIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UERadioCapabilityInfoIndicationIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UERadioCapabilityInfoIndicationIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _UERadioCapabilityInfoIndicationIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityForPaging')))
    _UERadioCapabilityInfoIndicationIEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    UERadioCapabilityInfoIndicationIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _UERadioCapabilityInfoIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _UERadioCapabilityInfoIndicationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 117), ('criticality', 'ignore'), ('Value', _UERadioCapabilityInfoIndicationIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 118), ('criticality', 'ignore'), ('Value', _UERadioCapabilityInfoIndicationIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 265), ('criticality', 'ignore'), ('Value', _UERadioCapabilityInfoIndicationIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UERadioCapabilityCheckRequest >-----#
    UERadioCapabilityCheckRequest = SEQ(name='UERadioCapabilityCheckRequest', mode=MODE_TYPE)
    _UERadioCapabilityCheckRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UERadioCapabilityCheckRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UERadioCapabilityCheckRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    ____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 117), ('criticality', 'ignore'), ('Value', _____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'reject'), ('Value', _____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UERadioCapabilityCheckRequest_protocolIEs__item__id._const_tab = ____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityCheckRequest_protocolIEs__item__id._const_tab_at = None
    ___UERadioCapabilityCheckRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___UERadioCapabilityCheckRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UERadioCapabilityCheckRequest_protocolIEs__item__criticality._const_tab = ____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityCheckRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UERadioCapabilityCheckRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UERadioCapabilityCheckRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UERadioCapabilityCheckRequest_protocolIEs__item__value._const_tab = ____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityCheckRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UERadioCapabilityCheckRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __UERadioCapabilityCheckRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UERadioCapabilityCheckRequest_protocolIEs__item__id),
        ('criticality', ___UERadioCapabilityCheckRequest_protocolIEs__item__criticality),
        ('value', ___UERadioCapabilityCheckRequest_protocolIEs__item__value),
        ])
    __UERadioCapabilityCheckRequest_protocolIEs__item_._ext = None
    _UERadioCapabilityCheckRequest_protocolIEs._cont = __UERadioCapabilityCheckRequest_protocolIEs__item_
    _UERadioCapabilityCheckRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UERadioCapabilityCheckRequest._cont = ASN1Dict([
        ('protocolIEs', _UERadioCapabilityCheckRequest_protocolIEs),
        ])
    UERadioCapabilityCheckRequest._ext = []
    
    #-----< UERadioCapabilityCheckRequestIEs >-----#
    UERadioCapabilityCheckRequestIEs = CLASS(name='UERadioCapabilityCheckRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UERadioCapabilityCheckRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UERadioCapabilityCheckRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UERadioCapabilityCheckRequestIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _UERadioCapabilityCheckRequestIEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    UERadioCapabilityCheckRequestIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _UERadioCapabilityCheckRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _UERadioCapabilityCheckRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 117), ('criticality', 'ignore'), ('Value', _UERadioCapabilityCheckRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'reject'), ('Value', _UERadioCapabilityCheckRequestIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UERadioCapabilityCheckResponse >-----#
    UERadioCapabilityCheckResponse = SEQ(name='UERadioCapabilityCheckResponse', mode=MODE_TYPE)
    _UERadioCapabilityCheckResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UERadioCapabilityCheckResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UERadioCapabilityCheckResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IMSVoiceSupportIndicator')))
    _____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 30), ('criticality', 'reject'), ('Value', _____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UERadioCapabilityCheckResponse_protocolIEs__item__id._const_tab = ____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityCheckResponse_protocolIEs__item__id._const_tab_at = None
    ___UERadioCapabilityCheckResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___UERadioCapabilityCheckResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UERadioCapabilityCheckResponse_protocolIEs__item__criticality._const_tab = ____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityCheckResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UERadioCapabilityCheckResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UERadioCapabilityCheckResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UERadioCapabilityCheckResponse_protocolIEs__item__value._const_tab = ____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityCheckResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UERadioCapabilityCheckResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __UERadioCapabilityCheckResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UERadioCapabilityCheckResponse_protocolIEs__item__id),
        ('criticality', ___UERadioCapabilityCheckResponse_protocolIEs__item__criticality),
        ('value', ___UERadioCapabilityCheckResponse_protocolIEs__item__value),
        ])
    __UERadioCapabilityCheckResponse_protocolIEs__item_._ext = None
    _UERadioCapabilityCheckResponse_protocolIEs._cont = __UERadioCapabilityCheckResponse_protocolIEs__item_
    _UERadioCapabilityCheckResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UERadioCapabilityCheckResponse._cont = ASN1Dict([
        ('protocolIEs', _UERadioCapabilityCheckResponse_protocolIEs),
        ])
    UERadioCapabilityCheckResponse._ext = []
    
    #-----< UERadioCapabilityCheckResponseIEs >-----#
    UERadioCapabilityCheckResponseIEs = CLASS(name='UERadioCapabilityCheckResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UERadioCapabilityCheckResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _UERadioCapabilityCheckResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _UERadioCapabilityCheckResponseIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'IMSVoiceSupportIndicator')))
    _UERadioCapabilityCheckResponseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    UERadioCapabilityCheckResponseIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _UERadioCapabilityCheckResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _UERadioCapabilityCheckResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 30), ('criticality', 'reject'), ('Value', _UERadioCapabilityCheckResponseIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _UERadioCapabilityCheckResponseIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PrivateMessage >-----#
    PrivateMessage = SEQ(name='PrivateMessage', mode=MODE_TYPE)
    _PrivateMessage_privateIEs = SEQ_OF(name='privateIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'PrivateIE-Container')))
    __PrivateMessage_privateIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'PrivateIE-Field')))
    ___PrivateMessage_privateIEs__item__id = CHOICE(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PRIVATE-IES'), ['id']))
    ____PrivateMessage_privateIEs__item__id_tab = CLASS(name='_tab_NGAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__id._const_tab = ____PrivateMessage_privateIEs__item__id_tab
    ___PrivateMessage_privateIEs__item__id._const_tab_at = None
    ___PrivateMessage_privateIEs__item__id._const_tab_id = 'id'
    ___PrivateMessage_privateIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PRIVATE-IES'), ['criticality']))
    ____PrivateMessage_privateIEs__item__criticality_tab = CLASS(name='_tab_NGAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__criticality._const_tab = ____PrivateMessage_privateIEs__item__criticality_tab
    ___PrivateMessage_privateIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PrivateMessage_privateIEs__item__criticality._const_tab_id = 'criticality'
    ___PrivateMessage_privateIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PRIVATE-IES'), ['Value']))
    ____PrivateMessage_privateIEs__item__value_tab = CLASS(name='_tab_NGAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__value._const_tab = ____PrivateMessage_privateIEs__item__value_tab
    ___PrivateMessage_privateIEs__item__value._const_tab_at = ('..', 'id')
    ___PrivateMessage_privateIEs__item__value._const_tab_id = 'Value'
    __PrivateMessage_privateIEs__item_._cont = ASN1Dict([
        ('id', ___PrivateMessage_privateIEs__item__id),
        ('criticality', ___PrivateMessage_privateIEs__item__criticality),
        ('value', ___PrivateMessage_privateIEs__item__value),
        ])
    __PrivateMessage_privateIEs__item_._ext = None
    _PrivateMessage_privateIEs._cont = __PrivateMessage_privateIEs__item_
    _PrivateMessage_privateIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrivateMessage._cont = ASN1Dict([
        ('privateIEs', _PrivateMessage_privateIEs),
        ])
    PrivateMessage._ext = []
    
    #-----< PrivateMessageIEs >-----#
    PrivateMessageIEs = CLASS(name='PrivateMessageIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PRIVATE-IES')))
    PrivateMessageIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecondaryRATDataUsageReport >-----#
    SecondaryRATDataUsageReport = SEQ(name='SecondaryRATDataUsageReport', mode=MODE_TYPE)
    _SecondaryRATDataUsageReport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __SecondaryRATDataUsageReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___SecondaryRATDataUsageReport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSecondaryRATUsageList')))
    _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HandoverFlag')))
    _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 142), ('criticality', 'ignore'), ('Value', _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 143), ('criticality', 'ignore'), ('Value', _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SecondaryRATDataUsageReport_protocolIEs__item__id._const_tab = ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab
    ___SecondaryRATDataUsageReport_protocolIEs__item__id._const_tab_at = None
    ___SecondaryRATDataUsageReport_protocolIEs__item__id._const_tab_id = 'id'
    ___SecondaryRATDataUsageReport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___SecondaryRATDataUsageReport_protocolIEs__item__criticality._const_tab = ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab
    ___SecondaryRATDataUsageReport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SecondaryRATDataUsageReport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SecondaryRATDataUsageReport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___SecondaryRATDataUsageReport_protocolIEs__item__value._const_tab = ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab
    ___SecondaryRATDataUsageReport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SecondaryRATDataUsageReport_protocolIEs__item__value._const_tab_id = 'Value'
    __SecondaryRATDataUsageReport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SecondaryRATDataUsageReport_protocolIEs__item__id),
        ('criticality', ___SecondaryRATDataUsageReport_protocolIEs__item__criticality),
        ('value', ___SecondaryRATDataUsageReport_protocolIEs__item__value),
        ])
    __SecondaryRATDataUsageReport_protocolIEs__item_._ext = None
    _SecondaryRATDataUsageReport_protocolIEs._cont = __SecondaryRATDataUsageReport_protocolIEs__item_
    _SecondaryRATDataUsageReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SecondaryRATDataUsageReport._cont = ASN1Dict([
        ('protocolIEs', _SecondaryRATDataUsageReport_protocolIEs),
        ])
    SecondaryRATDataUsageReport._ext = []
    
    #-----< SecondaryRATDataUsageReportIEs >-----#
    SecondaryRATDataUsageReportIEs = CLASS(name='SecondaryRATDataUsageReportIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _SecondaryRATDataUsageReportIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _SecondaryRATDataUsageReportIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _SecondaryRATDataUsageReportIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'PDUSessionResourceSecondaryRATUsageList')))
    _SecondaryRATDataUsageReportIEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'HandoverFlag')))
    _SecondaryRATDataUsageReportIEs_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UserLocationInformation')))
    SecondaryRATDataUsageReportIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'ignore'), ('Value', _SecondaryRATDataUsageReportIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _SecondaryRATDataUsageReportIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 142), ('criticality', 'ignore'), ('Value', _SecondaryRATDataUsageReportIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 143), ('criticality', 'ignore'), ('Value', _SecondaryRATDataUsageReportIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 121), ('criticality', 'ignore'), ('Value', _SecondaryRATDataUsageReportIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UplinkRIMInformationTransfer >-----#
    UplinkRIMInformationTransfer = SEQ(name='UplinkRIMInformationTransfer', mode=MODE_TYPE)
    _UplinkRIMInformationTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UplinkRIMInformationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UplinkRIMInformationTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____UplinkRIMInformationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UplinkRIMInformationTransfer_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RIMInformationTransfer')))
    ____UplinkRIMInformationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 175), ('criticality', 'ignore'), ('Value', _____UplinkRIMInformationTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UplinkRIMInformationTransfer_protocolIEs__item__id._const_tab = ____UplinkRIMInformationTransfer_protocolIEs__item__id_tab
    ___UplinkRIMInformationTransfer_protocolIEs__item__id._const_tab_at = None
    ___UplinkRIMInformationTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___UplinkRIMInformationTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UplinkRIMInformationTransfer_protocolIEs__item__criticality._const_tab = ____UplinkRIMInformationTransfer_protocolIEs__item__id_tab
    ___UplinkRIMInformationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UplinkRIMInformationTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UplinkRIMInformationTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UplinkRIMInformationTransfer_protocolIEs__item__value._const_tab = ____UplinkRIMInformationTransfer_protocolIEs__item__id_tab
    ___UplinkRIMInformationTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UplinkRIMInformationTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __UplinkRIMInformationTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UplinkRIMInformationTransfer_protocolIEs__item__id),
        ('criticality', ___UplinkRIMInformationTransfer_protocolIEs__item__criticality),
        ('value', ___UplinkRIMInformationTransfer_protocolIEs__item__value),
        ])
    __UplinkRIMInformationTransfer_protocolIEs__item_._ext = None
    _UplinkRIMInformationTransfer_protocolIEs._cont = __UplinkRIMInformationTransfer_protocolIEs__item_
    _UplinkRIMInformationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UplinkRIMInformationTransfer._cont = ASN1Dict([
        ('protocolIEs', _UplinkRIMInformationTransfer_protocolIEs),
        ])
    UplinkRIMInformationTransfer._ext = []
    
    #-----< UplinkRIMInformationTransferIEs >-----#
    UplinkRIMInformationTransferIEs = CLASS(name='UplinkRIMInformationTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UplinkRIMInformationTransferIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RIMInformationTransfer')))
    UplinkRIMInformationTransferIEs._val = ASN1Set(rv=[dict([('id', 175), ('criticality', 'ignore'), ('Value', _UplinkRIMInformationTransferIEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DownlinkRIMInformationTransfer >-----#
    DownlinkRIMInformationTransfer = SEQ(name='DownlinkRIMInformationTransfer', mode=MODE_TYPE)
    _DownlinkRIMInformationTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __DownlinkRIMInformationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___DownlinkRIMInformationTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____DownlinkRIMInformationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____DownlinkRIMInformationTransfer_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RIMInformationTransfer')))
    ____DownlinkRIMInformationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 175), ('criticality', 'ignore'), ('Value', _____DownlinkRIMInformationTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DownlinkRIMInformationTransfer_protocolIEs__item__id._const_tab = ____DownlinkRIMInformationTransfer_protocolIEs__item__id_tab
    ___DownlinkRIMInformationTransfer_protocolIEs__item__id._const_tab_at = None
    ___DownlinkRIMInformationTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___DownlinkRIMInformationTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___DownlinkRIMInformationTransfer_protocolIEs__item__criticality._const_tab = ____DownlinkRIMInformationTransfer_protocolIEs__item__id_tab
    ___DownlinkRIMInformationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DownlinkRIMInformationTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DownlinkRIMInformationTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___DownlinkRIMInformationTransfer_protocolIEs__item__value._const_tab = ____DownlinkRIMInformationTransfer_protocolIEs__item__id_tab
    ___DownlinkRIMInformationTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DownlinkRIMInformationTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __DownlinkRIMInformationTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DownlinkRIMInformationTransfer_protocolIEs__item__id),
        ('criticality', ___DownlinkRIMInformationTransfer_protocolIEs__item__criticality),
        ('value', ___DownlinkRIMInformationTransfer_protocolIEs__item__value),
        ])
    __DownlinkRIMInformationTransfer_protocolIEs__item_._ext = None
    _DownlinkRIMInformationTransfer_protocolIEs._cont = __DownlinkRIMInformationTransfer_protocolIEs__item_
    _DownlinkRIMInformationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DownlinkRIMInformationTransfer._cont = ASN1Dict([
        ('protocolIEs', _DownlinkRIMInformationTransfer_protocolIEs),
        ])
    DownlinkRIMInformationTransfer._ext = []
    
    #-----< DownlinkRIMInformationTransferIEs >-----#
    DownlinkRIMInformationTransferIEs = CLASS(name='DownlinkRIMInformationTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _DownlinkRIMInformationTransferIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RIMInformationTransfer')))
    DownlinkRIMInformationTransferIEs._val = ASN1Set(rv=[dict([('id', 175), ('criticality', 'ignore'), ('Value', _DownlinkRIMInformationTransferIEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ConnectionEstablishmentIndication >-----#
    ConnectionEstablishmentIndication = SEQ(name='ConnectionEstablishmentIndication', mode=MODE_TYPE)
    _ConnectionEstablishmentIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __ConnectionEstablishmentIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___ConnectionEstablishmentIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____ConnectionEstablishmentIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EndIndication')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-DifferentiationInfo')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DL-CP-SecurityInformation')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-UEPriority')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Enhanced-CoverageRestriction')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBrestricted')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_11 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_12 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MaskedIMEISV')))
    ____ConnectionEstablishmentIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 117), ('criticality', 'ignore'), ('Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 226), ('criticality', 'ignore'), ('Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 148), ('criticality', 'ignore'), ('Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 209), ('criticality', 'ignore'), ('Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 212), ('criticality', 'ignore'), ('Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 210), ('criticality', 'ignore'), ('Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 205), ('criticality', 'ignore'), ('Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 222), ('criticality', 'ignore'), ('Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'reject'), ('Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 34), ('criticality', 'ignore'), ('Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ConnectionEstablishmentIndication_protocolIEs__item__id._const_tab = ____ConnectionEstablishmentIndication_protocolIEs__item__id_tab
    ___ConnectionEstablishmentIndication_protocolIEs__item__id._const_tab_at = None
    ___ConnectionEstablishmentIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___ConnectionEstablishmentIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___ConnectionEstablishmentIndication_protocolIEs__item__criticality._const_tab = ____ConnectionEstablishmentIndication_protocolIEs__item__id_tab
    ___ConnectionEstablishmentIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ConnectionEstablishmentIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ConnectionEstablishmentIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___ConnectionEstablishmentIndication_protocolIEs__item__value._const_tab = ____ConnectionEstablishmentIndication_protocolIEs__item__id_tab
    ___ConnectionEstablishmentIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ConnectionEstablishmentIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __ConnectionEstablishmentIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ConnectionEstablishmentIndication_protocolIEs__item__id),
        ('criticality', ___ConnectionEstablishmentIndication_protocolIEs__item__criticality),
        ('value', ___ConnectionEstablishmentIndication_protocolIEs__item__value),
        ])
    __ConnectionEstablishmentIndication_protocolIEs__item_._ext = None
    _ConnectionEstablishmentIndication_protocolIEs._cont = __ConnectionEstablishmentIndication_protocolIEs__item_
    _ConnectionEstablishmentIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ConnectionEstablishmentIndication._cont = ASN1Dict([
        ('protocolIEs', _ConnectionEstablishmentIndication_protocolIEs),
        ])
    ConnectionEstablishmentIndication._ext = []
    
    #-----< ConnectionEstablishmentIndicationIEs >-----#
    ConnectionEstablishmentIndicationIEs = CLASS(name='ConnectionEstablishmentIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _ConnectionEstablishmentIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _ConnectionEstablishmentIndicationIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _ConnectionEstablishmentIndicationIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _ConnectionEstablishmentIndicationIEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'EndIndication')))
    _ConnectionEstablishmentIndicationIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _ConnectionEstablishmentIndicationIEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    _ConnectionEstablishmentIndicationIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UE-DifferentiationInfo')))
    _ConnectionEstablishmentIndicationIEs_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'DL-CP-SecurityInformation')))
    _ConnectionEstablishmentIndicationIEs_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'NB-IoT-UEPriority')))
    _ConnectionEstablishmentIndicationIEs_val_Value_9 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Enhanced-CoverageRestriction')))
    _ConnectionEstablishmentIndicationIEs_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CEmodeBrestricted')))
    _ConnectionEstablishmentIndicationIEs_val_Value_11 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    _ConnectionEstablishmentIndicationIEs_val_Value_12 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MaskedIMEISV')))
    ConnectionEstablishmentIndicationIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _ConnectionEstablishmentIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _ConnectionEstablishmentIndicationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 117), ('criticality', 'ignore'), ('Value', _ConnectionEstablishmentIndicationIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 226), ('criticality', 'ignore'), ('Value', _ConnectionEstablishmentIndicationIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 148), ('criticality', 'ignore'), ('Value', _ConnectionEstablishmentIndicationIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _ConnectionEstablishmentIndicationIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 209), ('criticality', 'ignore'), ('Value', _ConnectionEstablishmentIndicationIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 212), ('criticality', 'ignore'), ('Value', _ConnectionEstablishmentIndicationIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 210), ('criticality', 'ignore'), ('Value', _ConnectionEstablishmentIndicationIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 205), ('criticality', 'ignore'), ('Value', _ConnectionEstablishmentIndicationIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 222), ('criticality', 'ignore'), ('Value', _ConnectionEstablishmentIndicationIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 264), ('criticality', 'reject'), ('Value', _ConnectionEstablishmentIndicationIEs_val_Value_11), ('presence', 'optional')]), dict([('id', 34), ('criticality', 'ignore'), ('Value', _ConnectionEstablishmentIndicationIEs_val_Value_12), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UERadioCapabilityIDMappingRequest >-----#
    UERadioCapabilityIDMappingRequest = SEQ(name='UERadioCapabilityIDMappingRequest', mode=MODE_TYPE)
    _UERadioCapabilityIDMappingRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UERadioCapabilityIDMappingRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 264), ('criticality', 'reject'), ('Value', _____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id._const_tab = ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id._const_tab_at = None
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality._const_tab = ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value._const_tab = ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __UERadioCapabilityIDMappingRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id),
        ('criticality', ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality),
        ('value', ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value),
        ])
    __UERadioCapabilityIDMappingRequest_protocolIEs__item_._ext = None
    _UERadioCapabilityIDMappingRequest_protocolIEs._cont = __UERadioCapabilityIDMappingRequest_protocolIEs__item_
    _UERadioCapabilityIDMappingRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UERadioCapabilityIDMappingRequest._cont = ASN1Dict([
        ('protocolIEs', _UERadioCapabilityIDMappingRequest_protocolIEs),
        ])
    UERadioCapabilityIDMappingRequest._ext = []
    
    #-----< UERadioCapabilityIDMappingRequestIEs >-----#
    UERadioCapabilityIDMappingRequestIEs = CLASS(name='UERadioCapabilityIDMappingRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UERadioCapabilityIDMappingRequestIEs_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    UERadioCapabilityIDMappingRequestIEs._val = ASN1Set(rv=[dict([('id', 264), ('criticality', 'reject'), ('Value', _UERadioCapabilityIDMappingRequestIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UERadioCapabilityIDMappingResponse >-----#
    UERadioCapabilityIDMappingResponse = SEQ(name='UERadioCapabilityIDMappingResponse', mode=MODE_TYPE)
    _UERadioCapabilityIDMappingResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __UERadioCapabilityIDMappingResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 264), ('criticality', 'reject'), ('Value', _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 117), ('criticality', 'ignore'), ('Value', _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id._const_tab = ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id._const_tab_at = None
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality._const_tab = ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value._const_tab = ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __UERadioCapabilityIDMappingResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id),
        ('criticality', ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality),
        ('value', ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value),
        ])
    __UERadioCapabilityIDMappingResponse_protocolIEs__item_._ext = None
    _UERadioCapabilityIDMappingResponse_protocolIEs._cont = __UERadioCapabilityIDMappingResponse_protocolIEs__item_
    _UERadioCapabilityIDMappingResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UERadioCapabilityIDMappingResponse._cont = ASN1Dict([
        ('protocolIEs', _UERadioCapabilityIDMappingResponse_protocolIEs),
        ])
    UERadioCapabilityIDMappingResponse._ext = []
    
    #-----< UERadioCapabilityIDMappingResponseIEs >-----#
    UERadioCapabilityIDMappingResponseIEs = CLASS(name='UERadioCapabilityIDMappingResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _UERadioCapabilityIDMappingResponseIEs_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapabilityID')))
    _UERadioCapabilityIDMappingResponseIEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'UERadioCapability')))
    _UERadioCapabilityIDMappingResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    UERadioCapabilityIDMappingResponseIEs._val = ASN1Set(rv=[dict([('id', 264), ('criticality', 'reject'), ('Value', _UERadioCapabilityIDMappingResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 117), ('criticality', 'ignore'), ('Value', _UERadioCapabilityIDMappingResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _UERadioCapabilityIDMappingResponseIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< AMFCPRelocationIndication >-----#
    AMFCPRelocationIndication = SEQ(name='AMFCPRelocationIndication', mode=MODE_TYPE)
    _AMFCPRelocationIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __AMFCPRelocationIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___AMFCPRelocationIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____AMFCPRelocationIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____AMFCPRelocationIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _____AMFCPRelocationIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _____AMFCPRelocationIndication_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _____AMFCPRelocationIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    ____AMFCPRelocationIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _____AMFCPRelocationIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _____AMFCPRelocationIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 148), ('criticality', 'ignore'), ('Value', _____AMFCPRelocationIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____AMFCPRelocationIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___AMFCPRelocationIndication_protocolIEs__item__id._const_tab = ____AMFCPRelocationIndication_protocolIEs__item__id_tab
    ___AMFCPRelocationIndication_protocolIEs__item__id._const_tab_at = None
    ___AMFCPRelocationIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___AMFCPRelocationIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___AMFCPRelocationIndication_protocolIEs__item__criticality._const_tab = ____AMFCPRelocationIndication_protocolIEs__item__id_tab
    ___AMFCPRelocationIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___AMFCPRelocationIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___AMFCPRelocationIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___AMFCPRelocationIndication_protocolIEs__item__value._const_tab = ____AMFCPRelocationIndication_protocolIEs__item__id_tab
    ___AMFCPRelocationIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___AMFCPRelocationIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __AMFCPRelocationIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___AMFCPRelocationIndication_protocolIEs__item__id),
        ('criticality', ___AMFCPRelocationIndication_protocolIEs__item__criticality),
        ('value', ___AMFCPRelocationIndication_protocolIEs__item__value),
        ])
    __AMFCPRelocationIndication_protocolIEs__item_._ext = None
    _AMFCPRelocationIndication_protocolIEs._cont = __AMFCPRelocationIndication_protocolIEs__item_
    _AMFCPRelocationIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    AMFCPRelocationIndication._cont = ASN1Dict([
        ('protocolIEs', _AMFCPRelocationIndication_protocolIEs),
        ])
    AMFCPRelocationIndication._ext = []
    
    #-----< AMFCPRelocationIndicationIEs >-----#
    AMFCPRelocationIndicationIEs = CLASS(name='AMFCPRelocationIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _AMFCPRelocationIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AMF-UE-NGAP-ID')))
    _AMFCPRelocationIndicationIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'RAN-UE-NGAP-ID')))
    _AMFCPRelocationIndicationIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _AMFCPRelocationIndicationIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'AllowedNSSAI')))
    AMFCPRelocationIndicationIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _AMFCPRelocationIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 85), ('criticality', 'reject'), ('Value', _AMFCPRelocationIndicationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 148), ('criticality', 'ignore'), ('Value', _AMFCPRelocationIndicationIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _AMFCPRelocationIndicationIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastSessionSetupRequest >-----#
    BroadcastSessionSetupRequest = SEQ(name='BroadcastSessionSetupRequest', mode=MODE_TYPE)
    _BroadcastSessionSetupRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __BroadcastSessionSetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___BroadcastSessionSetupRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____BroadcastSessionSetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____BroadcastSessionSetupRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _____BroadcastSessionSetupRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _____BroadcastSessionSetupRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-ServiceArea')))
    _____BroadcastSessionSetupRequest_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE)
    ______BroadcastSessionSetupRequest_protocolIEs__item__id_tab_val_Value_3_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionSetupOrModRequestTransfer')))
    _____BroadcastSessionSetupRequest_protocolIEs__item__id_tab_val_Value_3._const_cont = ______BroadcastSessionSetupRequest_protocolIEs__item__id_tab_val_Value_3_contain
    ____BroadcastSessionSetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _____BroadcastSessionSetupRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 148), ('criticality', 'reject'), ('Value', _____BroadcastSessionSetupRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 298), ('criticality', 'reject'), ('Value', _____BroadcastSessionSetupRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 315), ('criticality', 'reject'), ('Value', _____BroadcastSessionSetupRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___BroadcastSessionSetupRequest_protocolIEs__item__id._const_tab = ____BroadcastSessionSetupRequest_protocolIEs__item__id_tab
    ___BroadcastSessionSetupRequest_protocolIEs__item__id._const_tab_at = None
    ___BroadcastSessionSetupRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___BroadcastSessionSetupRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___BroadcastSessionSetupRequest_protocolIEs__item__criticality._const_tab = ____BroadcastSessionSetupRequest_protocolIEs__item__id_tab
    ___BroadcastSessionSetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastSessionSetupRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BroadcastSessionSetupRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___BroadcastSessionSetupRequest_protocolIEs__item__value._const_tab = ____BroadcastSessionSetupRequest_protocolIEs__item__id_tab
    ___BroadcastSessionSetupRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BroadcastSessionSetupRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __BroadcastSessionSetupRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BroadcastSessionSetupRequest_protocolIEs__item__id),
        ('criticality', ___BroadcastSessionSetupRequest_protocolIEs__item__criticality),
        ('value', ___BroadcastSessionSetupRequest_protocolIEs__item__value),
        ])
    __BroadcastSessionSetupRequest_protocolIEs__item_._ext = None
    _BroadcastSessionSetupRequest_protocolIEs._cont = __BroadcastSessionSetupRequest_protocolIEs__item_
    _BroadcastSessionSetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BroadcastSessionSetupRequest._cont = ASN1Dict([
        ('protocolIEs', _BroadcastSessionSetupRequest_protocolIEs),
        ])
    BroadcastSessionSetupRequest._ext = []
    
    #-----< BroadcastSessionSetupRequestIEs >-----#
    BroadcastSessionSetupRequestIEs = CLASS(name='BroadcastSessionSetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _BroadcastSessionSetupRequestIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _BroadcastSessionSetupRequestIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'S-NSSAI')))
    _BroadcastSessionSetupRequestIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-ServiceArea')))
    _BroadcastSessionSetupRequestIEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE)
    __BroadcastSessionSetupRequestIEs_val_Value_3_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionSetupOrModRequestTransfer')))
    _BroadcastSessionSetupRequestIEs_val_Value_3._const_cont = __BroadcastSessionSetupRequestIEs_val_Value_3_contain
    BroadcastSessionSetupRequestIEs._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _BroadcastSessionSetupRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 148), ('criticality', 'reject'), ('Value', _BroadcastSessionSetupRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 298), ('criticality', 'reject'), ('Value', _BroadcastSessionSetupRequestIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 315), ('criticality', 'reject'), ('Value', _BroadcastSessionSetupRequestIEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastSessionSetupResponse >-----#
    BroadcastSessionSetupResponse = SEQ(name='BroadcastSessionSetupResponse', mode=MODE_TYPE)
    _BroadcastSessionSetupResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __BroadcastSessionSetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___BroadcastSessionSetupResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____BroadcastSessionSetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____BroadcastSessionSetupResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _____BroadcastSessionSetupResponse_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE)
    ______BroadcastSessionSetupResponse_protocolIEs__item__id_tab_val_Value_1_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionSetupOrModResponseTransfer')))
    _____BroadcastSessionSetupResponse_protocolIEs__item__id_tab_val_Value_1._const_cont = ______BroadcastSessionSetupResponse_protocolIEs__item__id_tab_val_Value_1_contain
    _____BroadcastSessionSetupResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____BroadcastSessionSetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _____BroadcastSessionSetupResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 316), ('criticality', 'reject'), ('Value', _____BroadcastSessionSetupResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____BroadcastSessionSetupResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BroadcastSessionSetupResponse_protocolIEs__item__id._const_tab = ____BroadcastSessionSetupResponse_protocolIEs__item__id_tab
    ___BroadcastSessionSetupResponse_protocolIEs__item__id._const_tab_at = None
    ___BroadcastSessionSetupResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___BroadcastSessionSetupResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___BroadcastSessionSetupResponse_protocolIEs__item__criticality._const_tab = ____BroadcastSessionSetupResponse_protocolIEs__item__id_tab
    ___BroadcastSessionSetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastSessionSetupResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BroadcastSessionSetupResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___BroadcastSessionSetupResponse_protocolIEs__item__value._const_tab = ____BroadcastSessionSetupResponse_protocolIEs__item__id_tab
    ___BroadcastSessionSetupResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BroadcastSessionSetupResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __BroadcastSessionSetupResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BroadcastSessionSetupResponse_protocolIEs__item__id),
        ('criticality', ___BroadcastSessionSetupResponse_protocolIEs__item__criticality),
        ('value', ___BroadcastSessionSetupResponse_protocolIEs__item__value),
        ])
    __BroadcastSessionSetupResponse_protocolIEs__item_._ext = None
    _BroadcastSessionSetupResponse_protocolIEs._cont = __BroadcastSessionSetupResponse_protocolIEs__item_
    _BroadcastSessionSetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BroadcastSessionSetupResponse._cont = ASN1Dict([
        ('protocolIEs', _BroadcastSessionSetupResponse_protocolIEs),
        ])
    BroadcastSessionSetupResponse._ext = []
    
    #-----< BroadcastSessionSetupResponseIEs >-----#
    BroadcastSessionSetupResponseIEs = CLASS(name='BroadcastSessionSetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _BroadcastSessionSetupResponseIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _BroadcastSessionSetupResponseIEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE)
    __BroadcastSessionSetupResponseIEs_val_Value_1_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionSetupOrModResponseTransfer')))
    _BroadcastSessionSetupResponseIEs_val_Value_1._const_cont = __BroadcastSessionSetupResponseIEs_val_Value_1_contain
    _BroadcastSessionSetupResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    BroadcastSessionSetupResponseIEs._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _BroadcastSessionSetupResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 316), ('criticality', 'reject'), ('Value', _BroadcastSessionSetupResponseIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _BroadcastSessionSetupResponseIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastSessionSetupFailure >-----#
    BroadcastSessionSetupFailure = SEQ(name='BroadcastSessionSetupFailure', mode=MODE_TYPE)
    _BroadcastSessionSetupFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __BroadcastSessionSetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___BroadcastSessionSetupFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____BroadcastSessionSetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____BroadcastSessionSetupFailure_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _____BroadcastSessionSetupFailure_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE)
    ______BroadcastSessionSetupFailure_protocolIEs__item__id_tab_val_Value_1_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionSetupOrModFailureTransfer')))
    _____BroadcastSessionSetupFailure_protocolIEs__item__id_tab_val_Value_1._const_cont = ______BroadcastSessionSetupFailure_protocolIEs__item__id_tab_val_Value_1_contain
    _____BroadcastSessionSetupFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____BroadcastSessionSetupFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____BroadcastSessionSetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _____BroadcastSessionSetupFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 314), ('criticality', 'reject'), ('Value', _____BroadcastSessionSetupFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____BroadcastSessionSetupFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____BroadcastSessionSetupFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BroadcastSessionSetupFailure_protocolIEs__item__id._const_tab = ____BroadcastSessionSetupFailure_protocolIEs__item__id_tab
    ___BroadcastSessionSetupFailure_protocolIEs__item__id._const_tab_at = None
    ___BroadcastSessionSetupFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___BroadcastSessionSetupFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___BroadcastSessionSetupFailure_protocolIEs__item__criticality._const_tab = ____BroadcastSessionSetupFailure_protocolIEs__item__id_tab
    ___BroadcastSessionSetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastSessionSetupFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BroadcastSessionSetupFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___BroadcastSessionSetupFailure_protocolIEs__item__value._const_tab = ____BroadcastSessionSetupFailure_protocolIEs__item__id_tab
    ___BroadcastSessionSetupFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BroadcastSessionSetupFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __BroadcastSessionSetupFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BroadcastSessionSetupFailure_protocolIEs__item__id),
        ('criticality', ___BroadcastSessionSetupFailure_protocolIEs__item__criticality),
        ('value', ___BroadcastSessionSetupFailure_protocolIEs__item__value),
        ])
    __BroadcastSessionSetupFailure_protocolIEs__item_._ext = None
    _BroadcastSessionSetupFailure_protocolIEs._cont = __BroadcastSessionSetupFailure_protocolIEs__item_
    _BroadcastSessionSetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BroadcastSessionSetupFailure._cont = ASN1Dict([
        ('protocolIEs', _BroadcastSessionSetupFailure_protocolIEs),
        ])
    BroadcastSessionSetupFailure._ext = []
    
    #-----< BroadcastSessionSetupFailureIEs >-----#
    BroadcastSessionSetupFailureIEs = CLASS(name='BroadcastSessionSetupFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _BroadcastSessionSetupFailureIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _BroadcastSessionSetupFailureIEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE)
    __BroadcastSessionSetupFailureIEs_val_Value_1_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionSetupOrModFailureTransfer')))
    _BroadcastSessionSetupFailureIEs_val_Value_1._const_cont = __BroadcastSessionSetupFailureIEs_val_Value_1_contain
    _BroadcastSessionSetupFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _BroadcastSessionSetupFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    BroadcastSessionSetupFailureIEs._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _BroadcastSessionSetupFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 314), ('criticality', 'reject'), ('Value', _BroadcastSessionSetupFailureIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _BroadcastSessionSetupFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _BroadcastSessionSetupFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastSessionModificationRequest >-----#
    BroadcastSessionModificationRequest = SEQ(name='BroadcastSessionModificationRequest', mode=MODE_TYPE)
    _BroadcastSessionModificationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __BroadcastSessionModificationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___BroadcastSessionModificationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____BroadcastSessionModificationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____BroadcastSessionModificationRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _____BroadcastSessionModificationRequest_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-ServiceArea')))
    _____BroadcastSessionModificationRequest_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE)
    ______BroadcastSessionModificationRequest_protocolIEs__item__id_tab_val_Value_2_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionSetupOrModRequestTransfer')))
    _____BroadcastSessionModificationRequest_protocolIEs__item__id_tab_val_Value_2._const_cont = ______BroadcastSessionModificationRequest_protocolIEs__item__id_tab_val_Value_2_contain
    ____BroadcastSessionModificationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _____BroadcastSessionModificationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 298), ('criticality', 'reject'), ('Value', _____BroadcastSessionModificationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 349), ('criticality', 'reject'), ('Value', _____BroadcastSessionModificationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BroadcastSessionModificationRequest_protocolIEs__item__id._const_tab = ____BroadcastSessionModificationRequest_protocolIEs__item__id_tab
    ___BroadcastSessionModificationRequest_protocolIEs__item__id._const_tab_at = None
    ___BroadcastSessionModificationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___BroadcastSessionModificationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___BroadcastSessionModificationRequest_protocolIEs__item__criticality._const_tab = ____BroadcastSessionModificationRequest_protocolIEs__item__id_tab
    ___BroadcastSessionModificationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastSessionModificationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BroadcastSessionModificationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___BroadcastSessionModificationRequest_protocolIEs__item__value._const_tab = ____BroadcastSessionModificationRequest_protocolIEs__item__id_tab
    ___BroadcastSessionModificationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BroadcastSessionModificationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __BroadcastSessionModificationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BroadcastSessionModificationRequest_protocolIEs__item__id),
        ('criticality', ___BroadcastSessionModificationRequest_protocolIEs__item__criticality),
        ('value', ___BroadcastSessionModificationRequest_protocolIEs__item__value),
        ])
    __BroadcastSessionModificationRequest_protocolIEs__item_._ext = None
    _BroadcastSessionModificationRequest_protocolIEs._cont = __BroadcastSessionModificationRequest_protocolIEs__item_
    _BroadcastSessionModificationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BroadcastSessionModificationRequest._cont = ASN1Dict([
        ('protocolIEs', _BroadcastSessionModificationRequest_protocolIEs),
        ])
    BroadcastSessionModificationRequest._ext = []
    
    #-----< BroadcastSessionModificationRequestIEs >-----#
    BroadcastSessionModificationRequestIEs = CLASS(name='BroadcastSessionModificationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _BroadcastSessionModificationRequestIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _BroadcastSessionModificationRequestIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-ServiceArea')))
    _BroadcastSessionModificationRequestIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE)
    __BroadcastSessionModificationRequestIEs_val_Value_2_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionSetupOrModRequestTransfer')))
    _BroadcastSessionModificationRequestIEs_val_Value_2._const_cont = __BroadcastSessionModificationRequestIEs_val_Value_2_contain
    BroadcastSessionModificationRequestIEs._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _BroadcastSessionModificationRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 298), ('criticality', 'reject'), ('Value', _BroadcastSessionModificationRequestIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 349), ('criticality', 'reject'), ('Value', _BroadcastSessionModificationRequestIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastSessionModificationResponse >-----#
    BroadcastSessionModificationResponse = SEQ(name='BroadcastSessionModificationResponse', mode=MODE_TYPE)
    _BroadcastSessionModificationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __BroadcastSessionModificationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___BroadcastSessionModificationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____BroadcastSessionModificationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____BroadcastSessionModificationResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _____BroadcastSessionModificationResponse_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE)
    ______BroadcastSessionModificationResponse_protocolIEs__item__id_tab_val_Value_1_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionSetupOrModResponseTransfer')))
    _____BroadcastSessionModificationResponse_protocolIEs__item__id_tab_val_Value_1._const_cont = ______BroadcastSessionModificationResponse_protocolIEs__item__id_tab_val_Value_1_contain
    _____BroadcastSessionModificationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____BroadcastSessionModificationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _____BroadcastSessionModificationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 350), ('criticality', 'reject'), ('Value', _____BroadcastSessionModificationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____BroadcastSessionModificationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BroadcastSessionModificationResponse_protocolIEs__item__id._const_tab = ____BroadcastSessionModificationResponse_protocolIEs__item__id_tab
    ___BroadcastSessionModificationResponse_protocolIEs__item__id._const_tab_at = None
    ___BroadcastSessionModificationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___BroadcastSessionModificationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___BroadcastSessionModificationResponse_protocolIEs__item__criticality._const_tab = ____BroadcastSessionModificationResponse_protocolIEs__item__id_tab
    ___BroadcastSessionModificationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastSessionModificationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BroadcastSessionModificationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___BroadcastSessionModificationResponse_protocolIEs__item__value._const_tab = ____BroadcastSessionModificationResponse_protocolIEs__item__id_tab
    ___BroadcastSessionModificationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BroadcastSessionModificationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __BroadcastSessionModificationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BroadcastSessionModificationResponse_protocolIEs__item__id),
        ('criticality', ___BroadcastSessionModificationResponse_protocolIEs__item__criticality),
        ('value', ___BroadcastSessionModificationResponse_protocolIEs__item__value),
        ])
    __BroadcastSessionModificationResponse_protocolIEs__item_._ext = None
    _BroadcastSessionModificationResponse_protocolIEs._cont = __BroadcastSessionModificationResponse_protocolIEs__item_
    _BroadcastSessionModificationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BroadcastSessionModificationResponse._cont = ASN1Dict([
        ('protocolIEs', _BroadcastSessionModificationResponse_protocolIEs),
        ])
    BroadcastSessionModificationResponse._ext = []
    
    #-----< BroadcastSessionModificationResponseIEs >-----#
    BroadcastSessionModificationResponseIEs = CLASS(name='BroadcastSessionModificationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _BroadcastSessionModificationResponseIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _BroadcastSessionModificationResponseIEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE)
    __BroadcastSessionModificationResponseIEs_val_Value_1_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionSetupOrModResponseTransfer')))
    _BroadcastSessionModificationResponseIEs_val_Value_1._const_cont = __BroadcastSessionModificationResponseIEs_val_Value_1_contain
    _BroadcastSessionModificationResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    BroadcastSessionModificationResponseIEs._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _BroadcastSessionModificationResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 350), ('criticality', 'reject'), ('Value', _BroadcastSessionModificationResponseIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _BroadcastSessionModificationResponseIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastSessionModificationFailure >-----#
    BroadcastSessionModificationFailure = SEQ(name='BroadcastSessionModificationFailure', mode=MODE_TYPE)
    _BroadcastSessionModificationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __BroadcastSessionModificationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___BroadcastSessionModificationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____BroadcastSessionModificationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____BroadcastSessionModificationFailure_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _____BroadcastSessionModificationFailure_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE)
    ______BroadcastSessionModificationFailure_protocolIEs__item__id_tab_val_Value_1_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionSetupOrModFailureTransfer')))
    _____BroadcastSessionModificationFailure_protocolIEs__item__id_tab_val_Value_1._const_cont = ______BroadcastSessionModificationFailure_protocolIEs__item__id_tab_val_Value_1_contain
    _____BroadcastSessionModificationFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____BroadcastSessionModificationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____BroadcastSessionModificationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _____BroadcastSessionModificationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 348), ('criticality', 'reject'), ('Value', _____BroadcastSessionModificationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____BroadcastSessionModificationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____BroadcastSessionModificationFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BroadcastSessionModificationFailure_protocolIEs__item__id._const_tab = ____BroadcastSessionModificationFailure_protocolIEs__item__id_tab
    ___BroadcastSessionModificationFailure_protocolIEs__item__id._const_tab_at = None
    ___BroadcastSessionModificationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___BroadcastSessionModificationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___BroadcastSessionModificationFailure_protocolIEs__item__criticality._const_tab = ____BroadcastSessionModificationFailure_protocolIEs__item__id_tab
    ___BroadcastSessionModificationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastSessionModificationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BroadcastSessionModificationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___BroadcastSessionModificationFailure_protocolIEs__item__value._const_tab = ____BroadcastSessionModificationFailure_protocolIEs__item__id_tab
    ___BroadcastSessionModificationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BroadcastSessionModificationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __BroadcastSessionModificationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BroadcastSessionModificationFailure_protocolIEs__item__id),
        ('criticality', ___BroadcastSessionModificationFailure_protocolIEs__item__criticality),
        ('value', ___BroadcastSessionModificationFailure_protocolIEs__item__value),
        ])
    __BroadcastSessionModificationFailure_protocolIEs__item_._ext = None
    _BroadcastSessionModificationFailure_protocolIEs._cont = __BroadcastSessionModificationFailure_protocolIEs__item_
    _BroadcastSessionModificationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BroadcastSessionModificationFailure._cont = ASN1Dict([
        ('protocolIEs', _BroadcastSessionModificationFailure_protocolIEs),
        ])
    BroadcastSessionModificationFailure._ext = []
    
    #-----< BroadcastSessionModificationFailureIEs >-----#
    BroadcastSessionModificationFailureIEs = CLASS(name='BroadcastSessionModificationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _BroadcastSessionModificationFailureIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _BroadcastSessionModificationFailureIEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE)
    __BroadcastSessionModificationFailureIEs_val_Value_1_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionSetupOrModFailureTransfer')))
    _BroadcastSessionModificationFailureIEs_val_Value_1._const_cont = __BroadcastSessionModificationFailureIEs_val_Value_1_contain
    _BroadcastSessionModificationFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _BroadcastSessionModificationFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    BroadcastSessionModificationFailureIEs._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _BroadcastSessionModificationFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 348), ('criticality', 'reject'), ('Value', _BroadcastSessionModificationFailureIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _BroadcastSessionModificationFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _BroadcastSessionModificationFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastSessionReleaseRequest >-----#
    BroadcastSessionReleaseRequest = SEQ(name='BroadcastSessionReleaseRequest', mode=MODE_TYPE)
    _BroadcastSessionReleaseRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __BroadcastSessionReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___BroadcastSessionReleaseRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____BroadcastSessionReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____BroadcastSessionReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _____BroadcastSessionReleaseRequest_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    ____BroadcastSessionReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _____BroadcastSessionReleaseRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____BroadcastSessionReleaseRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___BroadcastSessionReleaseRequest_protocolIEs__item__id._const_tab = ____BroadcastSessionReleaseRequest_protocolIEs__item__id_tab
    ___BroadcastSessionReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___BroadcastSessionReleaseRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___BroadcastSessionReleaseRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___BroadcastSessionReleaseRequest_protocolIEs__item__criticality._const_tab = ____BroadcastSessionReleaseRequest_protocolIEs__item__id_tab
    ___BroadcastSessionReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastSessionReleaseRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BroadcastSessionReleaseRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___BroadcastSessionReleaseRequest_protocolIEs__item__value._const_tab = ____BroadcastSessionReleaseRequest_protocolIEs__item__id_tab
    ___BroadcastSessionReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BroadcastSessionReleaseRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __BroadcastSessionReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BroadcastSessionReleaseRequest_protocolIEs__item__id),
        ('criticality', ___BroadcastSessionReleaseRequest_protocolIEs__item__criticality),
        ('value', ___BroadcastSessionReleaseRequest_protocolIEs__item__value),
        ])
    __BroadcastSessionReleaseRequest_protocolIEs__item_._ext = None
    _BroadcastSessionReleaseRequest_protocolIEs._cont = __BroadcastSessionReleaseRequest_protocolIEs__item_
    _BroadcastSessionReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BroadcastSessionReleaseRequest._cont = ASN1Dict([
        ('protocolIEs', _BroadcastSessionReleaseRequest_protocolIEs),
        ])
    BroadcastSessionReleaseRequest._ext = []
    
    #-----< BroadcastSessionReleaseRequestIEs >-----#
    BroadcastSessionReleaseRequestIEs = CLASS(name='BroadcastSessionReleaseRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _BroadcastSessionReleaseRequestIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _BroadcastSessionReleaseRequestIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    BroadcastSessionReleaseRequestIEs._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _BroadcastSessionReleaseRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _BroadcastSessionReleaseRequestIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastSessionReleaseRequired >-----#
    BroadcastSessionReleaseRequired = SEQ(name='BroadcastSessionReleaseRequired', mode=MODE_TYPE)
    _BroadcastSessionReleaseRequired_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __BroadcastSessionReleaseRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___BroadcastSessionReleaseRequired_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____BroadcastSessionReleaseRequired_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____BroadcastSessionReleaseRequired_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _____BroadcastSessionReleaseRequired_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    ____BroadcastSessionReleaseRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _____BroadcastSessionReleaseRequired_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____BroadcastSessionReleaseRequired_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___BroadcastSessionReleaseRequired_protocolIEs__item__id._const_tab = ____BroadcastSessionReleaseRequired_protocolIEs__item__id_tab
    ___BroadcastSessionReleaseRequired_protocolIEs__item__id._const_tab_at = None
    ___BroadcastSessionReleaseRequired_protocolIEs__item__id._const_tab_id = 'id'
    ___BroadcastSessionReleaseRequired_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___BroadcastSessionReleaseRequired_protocolIEs__item__criticality._const_tab = ____BroadcastSessionReleaseRequired_protocolIEs__item__id_tab
    ___BroadcastSessionReleaseRequired_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastSessionReleaseRequired_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BroadcastSessionReleaseRequired_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___BroadcastSessionReleaseRequired_protocolIEs__item__value._const_tab = ____BroadcastSessionReleaseRequired_protocolIEs__item__id_tab
    ___BroadcastSessionReleaseRequired_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BroadcastSessionReleaseRequired_protocolIEs__item__value._const_tab_id = 'Value'
    __BroadcastSessionReleaseRequired_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BroadcastSessionReleaseRequired_protocolIEs__item__id),
        ('criticality', ___BroadcastSessionReleaseRequired_protocolIEs__item__criticality),
        ('value', ___BroadcastSessionReleaseRequired_protocolIEs__item__value),
        ])
    __BroadcastSessionReleaseRequired_protocolIEs__item_._ext = None
    _BroadcastSessionReleaseRequired_protocolIEs._cont = __BroadcastSessionReleaseRequired_protocolIEs__item_
    _BroadcastSessionReleaseRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BroadcastSessionReleaseRequired._cont = ASN1Dict([
        ('protocolIEs', _BroadcastSessionReleaseRequired_protocolIEs),
        ])
    BroadcastSessionReleaseRequired._ext = []
    
    #-----< BroadcastSessionReleaseRequiredIEs >-----#
    BroadcastSessionReleaseRequiredIEs = CLASS(name='BroadcastSessionReleaseRequiredIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _BroadcastSessionReleaseRequiredIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _BroadcastSessionReleaseRequiredIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    BroadcastSessionReleaseRequiredIEs._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _BroadcastSessionReleaseRequiredIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _BroadcastSessionReleaseRequiredIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BroadcastSessionReleaseResponse >-----#
    BroadcastSessionReleaseResponse = SEQ(name='BroadcastSessionReleaseResponse', mode=MODE_TYPE)
    _BroadcastSessionReleaseResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __BroadcastSessionReleaseResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___BroadcastSessionReleaseResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____BroadcastSessionReleaseResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____BroadcastSessionReleaseResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _____BroadcastSessionReleaseResponse_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE)
    ______BroadcastSessionReleaseResponse_protocolIEs__item__id_tab_val_Value_1_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionReleaseResponseTransfer')))
    _____BroadcastSessionReleaseResponse_protocolIEs__item__id_tab_val_Value_1._const_cont = ______BroadcastSessionReleaseResponse_protocolIEs__item__id_tab_val_Value_1_contain
    _____BroadcastSessionReleaseResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____BroadcastSessionReleaseResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _____BroadcastSessionReleaseResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 358), ('criticality', 'ignore'), ('Value', _____BroadcastSessionReleaseResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____BroadcastSessionReleaseResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___BroadcastSessionReleaseResponse_protocolIEs__item__id._const_tab = ____BroadcastSessionReleaseResponse_protocolIEs__item__id_tab
    ___BroadcastSessionReleaseResponse_protocolIEs__item__id._const_tab_at = None
    ___BroadcastSessionReleaseResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___BroadcastSessionReleaseResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___BroadcastSessionReleaseResponse_protocolIEs__item__criticality._const_tab = ____BroadcastSessionReleaseResponse_protocolIEs__item__id_tab
    ___BroadcastSessionReleaseResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___BroadcastSessionReleaseResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___BroadcastSessionReleaseResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___BroadcastSessionReleaseResponse_protocolIEs__item__value._const_tab = ____BroadcastSessionReleaseResponse_protocolIEs__item__id_tab
    ___BroadcastSessionReleaseResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___BroadcastSessionReleaseResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __BroadcastSessionReleaseResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___BroadcastSessionReleaseResponse_protocolIEs__item__id),
        ('criticality', ___BroadcastSessionReleaseResponse_protocolIEs__item__criticality),
        ('value', ___BroadcastSessionReleaseResponse_protocolIEs__item__value),
        ])
    __BroadcastSessionReleaseResponse_protocolIEs__item_._ext = None
    _BroadcastSessionReleaseResponse_protocolIEs._cont = __BroadcastSessionReleaseResponse_protocolIEs__item_
    _BroadcastSessionReleaseResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    BroadcastSessionReleaseResponse._cont = ASN1Dict([
        ('protocolIEs', _BroadcastSessionReleaseResponse_protocolIEs),
        ])
    BroadcastSessionReleaseResponse._ext = []
    
    #-----< BroadcastSessionReleaseResponseIEs >-----#
    BroadcastSessionReleaseResponseIEs = CLASS(name='BroadcastSessionReleaseResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _BroadcastSessionReleaseResponseIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _BroadcastSessionReleaseResponseIEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE)
    __BroadcastSessionReleaseResponseIEs_val_Value_1_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBSSessionReleaseResponseTransfer')))
    _BroadcastSessionReleaseResponseIEs_val_Value_1._const_cont = __BroadcastSessionReleaseResponseIEs_val_Value_1_contain
    _BroadcastSessionReleaseResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    BroadcastSessionReleaseResponseIEs._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _BroadcastSessionReleaseResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 358), ('criticality', 'ignore'), ('Value', _BroadcastSessionReleaseResponseIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _BroadcastSessionReleaseResponseIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DistributionSetupRequest >-----#
    DistributionSetupRequest = SEQ(name='DistributionSetupRequest', mode=MODE_TYPE)
    _DistributionSetupRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __DistributionSetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___DistributionSetupRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____DistributionSetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____DistributionSetupRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _____DistributionSetupRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')))
    _____DistributionSetupRequest_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE)
    ______DistributionSetupRequest_protocolIEs__item__id_tab_val_Value_2_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-DistributionSetupRequestTransfer')))
    _____DistributionSetupRequest_protocolIEs__item__id_tab_val_Value_2._const_cont = ______DistributionSetupRequest_protocolIEs__item__id_tab_val_Value_2_contain
    ____DistributionSetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _____DistributionSetupRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 295), ('criticality', 'reject'), ('Value', _____DistributionSetupRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 301), ('criticality', 'reject'), ('Value', _____DistributionSetupRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___DistributionSetupRequest_protocolIEs__item__id._const_tab = ____DistributionSetupRequest_protocolIEs__item__id_tab
    ___DistributionSetupRequest_protocolIEs__item__id._const_tab_at = None
    ___DistributionSetupRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___DistributionSetupRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___DistributionSetupRequest_protocolIEs__item__criticality._const_tab = ____DistributionSetupRequest_protocolIEs__item__id_tab
    ___DistributionSetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DistributionSetupRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DistributionSetupRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___DistributionSetupRequest_protocolIEs__item__value._const_tab = ____DistributionSetupRequest_protocolIEs__item__id_tab
    ___DistributionSetupRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DistributionSetupRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __DistributionSetupRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DistributionSetupRequest_protocolIEs__item__id),
        ('criticality', ___DistributionSetupRequest_protocolIEs__item__criticality),
        ('value', ___DistributionSetupRequest_protocolIEs__item__value),
        ])
    __DistributionSetupRequest_protocolIEs__item_._ext = None
    _DistributionSetupRequest_protocolIEs._cont = __DistributionSetupRequest_protocolIEs__item_
    _DistributionSetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DistributionSetupRequest._cont = ASN1Dict([
        ('protocolIEs', _DistributionSetupRequest_protocolIEs),
        ])
    DistributionSetupRequest._ext = []
    
    #-----< DistributionSetupRequestIEs >-----#
    DistributionSetupRequestIEs = CLASS(name='DistributionSetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _DistributionSetupRequestIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _DistributionSetupRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')))
    _DistributionSetupRequestIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE)
    __DistributionSetupRequestIEs_val_Value_2_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-DistributionSetupRequestTransfer')))
    _DistributionSetupRequestIEs_val_Value_2._const_cont = __DistributionSetupRequestIEs_val_Value_2_contain
    DistributionSetupRequestIEs._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _DistributionSetupRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 295), ('criticality', 'reject'), ('Value', _DistributionSetupRequestIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 301), ('criticality', 'reject'), ('Value', _DistributionSetupRequestIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DistributionSetupResponse >-----#
    DistributionSetupResponse = SEQ(name='DistributionSetupResponse', mode=MODE_TYPE)
    _DistributionSetupResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __DistributionSetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___DistributionSetupResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____DistributionSetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____DistributionSetupResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _____DistributionSetupResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')))
    _____DistributionSetupResponse_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE)
    ______DistributionSetupResponse_protocolIEs__item__id_tab_val_Value_2_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-DistributionSetupResponseTransfer')))
    _____DistributionSetupResponse_protocolIEs__item__id_tab_val_Value_2._const_cont = ______DistributionSetupResponse_protocolIEs__item__id_tab_val_Value_2_contain
    _____DistributionSetupResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____DistributionSetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _____DistributionSetupResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 295), ('criticality', 'reject'), ('Value', _____DistributionSetupResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 302), ('criticality', 'reject'), ('Value', _____DistributionSetupResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____DistributionSetupResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DistributionSetupResponse_protocolIEs__item__id._const_tab = ____DistributionSetupResponse_protocolIEs__item__id_tab
    ___DistributionSetupResponse_protocolIEs__item__id._const_tab_at = None
    ___DistributionSetupResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___DistributionSetupResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___DistributionSetupResponse_protocolIEs__item__criticality._const_tab = ____DistributionSetupResponse_protocolIEs__item__id_tab
    ___DistributionSetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DistributionSetupResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DistributionSetupResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___DistributionSetupResponse_protocolIEs__item__value._const_tab = ____DistributionSetupResponse_protocolIEs__item__id_tab
    ___DistributionSetupResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DistributionSetupResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __DistributionSetupResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DistributionSetupResponse_protocolIEs__item__id),
        ('criticality', ___DistributionSetupResponse_protocolIEs__item__criticality),
        ('value', ___DistributionSetupResponse_protocolIEs__item__value),
        ])
    __DistributionSetupResponse_protocolIEs__item_._ext = None
    _DistributionSetupResponse_protocolIEs._cont = __DistributionSetupResponse_protocolIEs__item_
    _DistributionSetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DistributionSetupResponse._cont = ASN1Dict([
        ('protocolIEs', _DistributionSetupResponse_protocolIEs),
        ])
    DistributionSetupResponse._ext = []
    
    #-----< DistributionSetupResponseIEs >-----#
    DistributionSetupResponseIEs = CLASS(name='DistributionSetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _DistributionSetupResponseIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _DistributionSetupResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')))
    _DistributionSetupResponseIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE)
    __DistributionSetupResponseIEs_val_Value_2_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-DistributionSetupResponseTransfer')))
    _DistributionSetupResponseIEs_val_Value_2._const_cont = __DistributionSetupResponseIEs_val_Value_2_contain
    _DistributionSetupResponseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    DistributionSetupResponseIEs._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _DistributionSetupResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 295), ('criticality', 'reject'), ('Value', _DistributionSetupResponseIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 302), ('criticality', 'reject'), ('Value', _DistributionSetupResponseIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _DistributionSetupResponseIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DistributionSetupFailure >-----#
    DistributionSetupFailure = SEQ(name='DistributionSetupFailure', mode=MODE_TYPE)
    _DistributionSetupFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __DistributionSetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___DistributionSetupFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____DistributionSetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____DistributionSetupFailure_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _____DistributionSetupFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')))
    _____DistributionSetupFailure_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE)
    ______DistributionSetupFailure_protocolIEs__item__id_tab_val_Value_2_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-DistributionSetupUnsuccessfulTransfer')))
    _____DistributionSetupFailure_protocolIEs__item__id_tab_val_Value_2._const_cont = ______DistributionSetupFailure_protocolIEs__item__id_tab_val_Value_2_contain
    _____DistributionSetupFailure_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____DistributionSetupFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____DistributionSetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _____DistributionSetupFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 295), ('criticality', 'reject'), ('Value', _____DistributionSetupFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 303), ('criticality', 'ignore'), ('Value', _____DistributionSetupFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____DistributionSetupFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____DistributionSetupFailure_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DistributionSetupFailure_protocolIEs__item__id._const_tab = ____DistributionSetupFailure_protocolIEs__item__id_tab
    ___DistributionSetupFailure_protocolIEs__item__id._const_tab_at = None
    ___DistributionSetupFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___DistributionSetupFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___DistributionSetupFailure_protocolIEs__item__criticality._const_tab = ____DistributionSetupFailure_protocolIEs__item__id_tab
    ___DistributionSetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DistributionSetupFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DistributionSetupFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___DistributionSetupFailure_protocolIEs__item__value._const_tab = ____DistributionSetupFailure_protocolIEs__item__id_tab
    ___DistributionSetupFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DistributionSetupFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __DistributionSetupFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DistributionSetupFailure_protocolIEs__item__id),
        ('criticality', ___DistributionSetupFailure_protocolIEs__item__criticality),
        ('value', ___DistributionSetupFailure_protocolIEs__item__value),
        ])
    __DistributionSetupFailure_protocolIEs__item_._ext = None
    _DistributionSetupFailure_protocolIEs._cont = __DistributionSetupFailure_protocolIEs__item_
    _DistributionSetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DistributionSetupFailure._cont = ASN1Dict([
        ('protocolIEs', _DistributionSetupFailure_protocolIEs),
        ])
    DistributionSetupFailure._ext = []
    
    #-----< DistributionSetupFailureIEs >-----#
    DistributionSetupFailureIEs = CLASS(name='DistributionSetupFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _DistributionSetupFailureIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _DistributionSetupFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')))
    _DistributionSetupFailureIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE)
    __DistributionSetupFailureIEs_val_Value_2_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-DistributionSetupUnsuccessfulTransfer')))
    _DistributionSetupFailureIEs_val_Value_2._const_cont = __DistributionSetupFailureIEs_val_Value_2_contain
    _DistributionSetupFailureIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _DistributionSetupFailureIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    DistributionSetupFailureIEs._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _DistributionSetupFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 295), ('criticality', 'reject'), ('Value', _DistributionSetupFailureIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 303), ('criticality', 'ignore'), ('Value', _DistributionSetupFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _DistributionSetupFailureIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _DistributionSetupFailureIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DistributionReleaseRequest >-----#
    DistributionReleaseRequest = SEQ(name='DistributionReleaseRequest', mode=MODE_TYPE)
    _DistributionReleaseRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __DistributionReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___DistributionReleaseRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____DistributionReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____DistributionReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _____DistributionReleaseRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')))
    _____DistributionReleaseRequest_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE)
    ______DistributionReleaseRequest_protocolIEs__item__id_tab_val_Value_2_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-DistributionReleaseRequestTransfer')))
    _____DistributionReleaseRequest_protocolIEs__item__id_tab_val_Value_2._const_cont = ______DistributionReleaseRequest_protocolIEs__item__id_tab_val_Value_2_contain
    _____DistributionReleaseRequest_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    ____DistributionReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _____DistributionReleaseRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 295), ('criticality', 'reject'), ('Value', _____DistributionReleaseRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 300), ('criticality', 'reject'), ('Value', _____DistributionReleaseRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____DistributionReleaseRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___DistributionReleaseRequest_protocolIEs__item__id._const_tab = ____DistributionReleaseRequest_protocolIEs__item__id_tab
    ___DistributionReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___DistributionReleaseRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___DistributionReleaseRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___DistributionReleaseRequest_protocolIEs__item__criticality._const_tab = ____DistributionReleaseRequest_protocolIEs__item__id_tab
    ___DistributionReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DistributionReleaseRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DistributionReleaseRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___DistributionReleaseRequest_protocolIEs__item__value._const_tab = ____DistributionReleaseRequest_protocolIEs__item__id_tab
    ___DistributionReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DistributionReleaseRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __DistributionReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DistributionReleaseRequest_protocolIEs__item__id),
        ('criticality', ___DistributionReleaseRequest_protocolIEs__item__criticality),
        ('value', ___DistributionReleaseRequest_protocolIEs__item__value),
        ])
    __DistributionReleaseRequest_protocolIEs__item_._ext = None
    _DistributionReleaseRequest_protocolIEs._cont = __DistributionReleaseRequest_protocolIEs__item_
    _DistributionReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DistributionReleaseRequest._cont = ASN1Dict([
        ('protocolIEs', _DistributionReleaseRequest_protocolIEs),
        ])
    DistributionReleaseRequest._ext = []
    
    #-----< DistributionReleaseRequestIEs >-----#
    DistributionReleaseRequestIEs = CLASS(name='DistributionReleaseRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _DistributionReleaseRequestIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _DistributionReleaseRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')))
    _DistributionReleaseRequestIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE)
    __DistributionReleaseRequestIEs_val_Value_2_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-DistributionReleaseRequestTransfer')))
    _DistributionReleaseRequestIEs_val_Value_2._const_cont = __DistributionReleaseRequestIEs_val_Value_2_contain
    _DistributionReleaseRequestIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    DistributionReleaseRequestIEs._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _DistributionReleaseRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 295), ('criticality', 'reject'), ('Value', _DistributionReleaseRequestIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 300), ('criticality', 'reject'), ('Value', _DistributionReleaseRequestIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _DistributionReleaseRequestIEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DistributionReleaseResponse >-----#
    DistributionReleaseResponse = SEQ(name='DistributionReleaseResponse', mode=MODE_TYPE)
    _DistributionReleaseResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __DistributionReleaseResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___DistributionReleaseResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____DistributionReleaseResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____DistributionReleaseResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _____DistributionReleaseResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')))
    _____DistributionReleaseResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____DistributionReleaseResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _____DistributionReleaseResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 295), ('criticality', 'reject'), ('Value', _____DistributionReleaseResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____DistributionReleaseResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DistributionReleaseResponse_protocolIEs__item__id._const_tab = ____DistributionReleaseResponse_protocolIEs__item__id_tab
    ___DistributionReleaseResponse_protocolIEs__item__id._const_tab_at = None
    ___DistributionReleaseResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___DistributionReleaseResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___DistributionReleaseResponse_protocolIEs__item__criticality._const_tab = ____DistributionReleaseResponse_protocolIEs__item__id_tab
    ___DistributionReleaseResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DistributionReleaseResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DistributionReleaseResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___DistributionReleaseResponse_protocolIEs__item__value._const_tab = ____DistributionReleaseResponse_protocolIEs__item__id_tab
    ___DistributionReleaseResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DistributionReleaseResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __DistributionReleaseResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DistributionReleaseResponse_protocolIEs__item__id),
        ('criticality', ___DistributionReleaseResponse_protocolIEs__item__criticality),
        ('value', ___DistributionReleaseResponse_protocolIEs__item__value),
        ])
    __DistributionReleaseResponse_protocolIEs__item_._ext = None
    _DistributionReleaseResponse_protocolIEs._cont = __DistributionReleaseResponse_protocolIEs__item_
    _DistributionReleaseResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DistributionReleaseResponse._cont = ASN1Dict([
        ('protocolIEs', _DistributionReleaseResponse_protocolIEs),
        ])
    DistributionReleaseResponse._ext = []
    
    #-----< DistributionReleaseResponseIEs >-----#
    DistributionReleaseResponseIEs = CLASS(name='DistributionReleaseResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _DistributionReleaseResponseIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _DistributionReleaseResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')))
    _DistributionReleaseResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    DistributionReleaseResponseIEs._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _DistributionReleaseResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 295), ('criticality', 'reject'), ('Value', _DistributionReleaseResponseIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _DistributionReleaseResponseIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MulticastSessionActivationRequest >-----#
    MulticastSessionActivationRequest = SEQ(name='MulticastSessionActivationRequest', mode=MODE_TYPE)
    _MulticastSessionActivationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __MulticastSessionActivationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___MulticastSessionActivationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____MulticastSessionActivationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____MulticastSessionActivationRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _____MulticastSessionActivationRequest_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE)
    ______MulticastSessionActivationRequest_protocolIEs__item__id_tab_val_Value_1_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MulticastSessionActivationRequestTransfer')))
    _____MulticastSessionActivationRequest_protocolIEs__item__id_tab_val_Value_1._const_cont = ______MulticastSessionActivationRequest_protocolIEs__item__id_tab_val_Value_1_contain
    ____MulticastSessionActivationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _____MulticastSessionActivationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 304), ('criticality', 'reject'), ('Value', _____MulticastSessionActivationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MulticastSessionActivationRequest_protocolIEs__item__id._const_tab = ____MulticastSessionActivationRequest_protocolIEs__item__id_tab
    ___MulticastSessionActivationRequest_protocolIEs__item__id._const_tab_at = None
    ___MulticastSessionActivationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___MulticastSessionActivationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___MulticastSessionActivationRequest_protocolIEs__item__criticality._const_tab = ____MulticastSessionActivationRequest_protocolIEs__item__id_tab
    ___MulticastSessionActivationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastSessionActivationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MulticastSessionActivationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___MulticastSessionActivationRequest_protocolIEs__item__value._const_tab = ____MulticastSessionActivationRequest_protocolIEs__item__id_tab
    ___MulticastSessionActivationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MulticastSessionActivationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __MulticastSessionActivationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MulticastSessionActivationRequest_protocolIEs__item__id),
        ('criticality', ___MulticastSessionActivationRequest_protocolIEs__item__criticality),
        ('value', ___MulticastSessionActivationRequest_protocolIEs__item__value),
        ])
    __MulticastSessionActivationRequest_protocolIEs__item_._ext = None
    _MulticastSessionActivationRequest_protocolIEs._cont = __MulticastSessionActivationRequest_protocolIEs__item_
    _MulticastSessionActivationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MulticastSessionActivationRequest._cont = ASN1Dict([
        ('protocolIEs', _MulticastSessionActivationRequest_protocolIEs),
        ])
    MulticastSessionActivationRequest._ext = []
    
    #-----< MulticastSessionActivationRequestIEs >-----#
    MulticastSessionActivationRequestIEs = CLASS(name='MulticastSessionActivationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _MulticastSessionActivationRequestIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _MulticastSessionActivationRequestIEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE)
    __MulticastSessionActivationRequestIEs_val_Value_1_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MulticastSessionActivationRequestTransfer')))
    _MulticastSessionActivationRequestIEs_val_Value_1._const_cont = __MulticastSessionActivationRequestIEs_val_Value_1_contain
    MulticastSessionActivationRequestIEs._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _MulticastSessionActivationRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 304), ('criticality', 'reject'), ('Value', _MulticastSessionActivationRequestIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MulticastSessionActivationResponse >-----#
    MulticastSessionActivationResponse = SEQ(name='MulticastSessionActivationResponse', mode=MODE_TYPE)
    _MulticastSessionActivationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __MulticastSessionActivationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___MulticastSessionActivationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____MulticastSessionActivationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____MulticastSessionActivationResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _____MulticastSessionActivationResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____MulticastSessionActivationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _____MulticastSessionActivationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____MulticastSessionActivationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MulticastSessionActivationResponse_protocolIEs__item__id._const_tab = ____MulticastSessionActivationResponse_protocolIEs__item__id_tab
    ___MulticastSessionActivationResponse_protocolIEs__item__id._const_tab_at = None
    ___MulticastSessionActivationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___MulticastSessionActivationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___MulticastSessionActivationResponse_protocolIEs__item__criticality._const_tab = ____MulticastSessionActivationResponse_protocolIEs__item__id_tab
    ___MulticastSessionActivationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastSessionActivationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MulticastSessionActivationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___MulticastSessionActivationResponse_protocolIEs__item__value._const_tab = ____MulticastSessionActivationResponse_protocolIEs__item__id_tab
    ___MulticastSessionActivationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MulticastSessionActivationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __MulticastSessionActivationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MulticastSessionActivationResponse_protocolIEs__item__id),
        ('criticality', ___MulticastSessionActivationResponse_protocolIEs__item__criticality),
        ('value', ___MulticastSessionActivationResponse_protocolIEs__item__value),
        ])
    __MulticastSessionActivationResponse_protocolIEs__item_._ext = None
    _MulticastSessionActivationResponse_protocolIEs._cont = __MulticastSessionActivationResponse_protocolIEs__item_
    _MulticastSessionActivationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MulticastSessionActivationResponse._cont = ASN1Dict([
        ('protocolIEs', _MulticastSessionActivationResponse_protocolIEs),
        ])
    MulticastSessionActivationResponse._ext = []
    
    #-----< MulticastSessionActivationResponseIEs >-----#
    MulticastSessionActivationResponseIEs = CLASS(name='MulticastSessionActivationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _MulticastSessionActivationResponseIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _MulticastSessionActivationResponseIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    MulticastSessionActivationResponseIEs._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _MulticastSessionActivationResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _MulticastSessionActivationResponseIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MulticastSessionActivationFailure >-----#
    MulticastSessionActivationFailure = SEQ(name='MulticastSessionActivationFailure', mode=MODE_TYPE)
    _MulticastSessionActivationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __MulticastSessionActivationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___MulticastSessionActivationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____MulticastSessionActivationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____MulticastSessionActivationFailure_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _____MulticastSessionActivationFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____MulticastSessionActivationFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____MulticastSessionActivationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _____MulticastSessionActivationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____MulticastSessionActivationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____MulticastSessionActivationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MulticastSessionActivationFailure_protocolIEs__item__id._const_tab = ____MulticastSessionActivationFailure_protocolIEs__item__id_tab
    ___MulticastSessionActivationFailure_protocolIEs__item__id._const_tab_at = None
    ___MulticastSessionActivationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___MulticastSessionActivationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___MulticastSessionActivationFailure_protocolIEs__item__criticality._const_tab = ____MulticastSessionActivationFailure_protocolIEs__item__id_tab
    ___MulticastSessionActivationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastSessionActivationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MulticastSessionActivationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___MulticastSessionActivationFailure_protocolIEs__item__value._const_tab = ____MulticastSessionActivationFailure_protocolIEs__item__id_tab
    ___MulticastSessionActivationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MulticastSessionActivationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __MulticastSessionActivationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MulticastSessionActivationFailure_protocolIEs__item__id),
        ('criticality', ___MulticastSessionActivationFailure_protocolIEs__item__criticality),
        ('value', ___MulticastSessionActivationFailure_protocolIEs__item__value),
        ])
    __MulticastSessionActivationFailure_protocolIEs__item_._ext = None
    _MulticastSessionActivationFailure_protocolIEs._cont = __MulticastSessionActivationFailure_protocolIEs__item_
    _MulticastSessionActivationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MulticastSessionActivationFailure._cont = ASN1Dict([
        ('protocolIEs', _MulticastSessionActivationFailure_protocolIEs),
        ])
    MulticastSessionActivationFailure._ext = []
    
    #-----< MulticastSessionActivationFailureIEs >-----#
    MulticastSessionActivationFailureIEs = CLASS(name='MulticastSessionActivationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _MulticastSessionActivationFailureIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _MulticastSessionActivationFailureIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _MulticastSessionActivationFailureIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    MulticastSessionActivationFailureIEs._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _MulticastSessionActivationFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _MulticastSessionActivationFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _MulticastSessionActivationFailureIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MulticastSessionDeactivationRequest >-----#
    MulticastSessionDeactivationRequest = SEQ(name='MulticastSessionDeactivationRequest', mode=MODE_TYPE)
    _MulticastSessionDeactivationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __MulticastSessionDeactivationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___MulticastSessionDeactivationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____MulticastSessionDeactivationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____MulticastSessionDeactivationRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _____MulticastSessionDeactivationRequest_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE)
    ______MulticastSessionDeactivationRequest_protocolIEs__item__id_tab_val_Value_1_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MulticastSessionDeactivationRequestTransfer')))
    _____MulticastSessionDeactivationRequest_protocolIEs__item__id_tab_val_Value_1._const_cont = ______MulticastSessionDeactivationRequest_protocolIEs__item__id_tab_val_Value_1_contain
    ____MulticastSessionDeactivationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _____MulticastSessionDeactivationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 305), ('criticality', 'reject'), ('Value', _____MulticastSessionDeactivationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MulticastSessionDeactivationRequest_protocolIEs__item__id._const_tab = ____MulticastSessionDeactivationRequest_protocolIEs__item__id_tab
    ___MulticastSessionDeactivationRequest_protocolIEs__item__id._const_tab_at = None
    ___MulticastSessionDeactivationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___MulticastSessionDeactivationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___MulticastSessionDeactivationRequest_protocolIEs__item__criticality._const_tab = ____MulticastSessionDeactivationRequest_protocolIEs__item__id_tab
    ___MulticastSessionDeactivationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastSessionDeactivationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MulticastSessionDeactivationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___MulticastSessionDeactivationRequest_protocolIEs__item__value._const_tab = ____MulticastSessionDeactivationRequest_protocolIEs__item__id_tab
    ___MulticastSessionDeactivationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MulticastSessionDeactivationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __MulticastSessionDeactivationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MulticastSessionDeactivationRequest_protocolIEs__item__id),
        ('criticality', ___MulticastSessionDeactivationRequest_protocolIEs__item__criticality),
        ('value', ___MulticastSessionDeactivationRequest_protocolIEs__item__value),
        ])
    __MulticastSessionDeactivationRequest_protocolIEs__item_._ext = None
    _MulticastSessionDeactivationRequest_protocolIEs._cont = __MulticastSessionDeactivationRequest_protocolIEs__item_
    _MulticastSessionDeactivationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MulticastSessionDeactivationRequest._cont = ASN1Dict([
        ('protocolIEs', _MulticastSessionDeactivationRequest_protocolIEs),
        ])
    MulticastSessionDeactivationRequest._ext = []
    
    #-----< MulticastSessionDeactivationRequestIEs >-----#
    MulticastSessionDeactivationRequestIEs = CLASS(name='MulticastSessionDeactivationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _MulticastSessionDeactivationRequestIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _MulticastSessionDeactivationRequestIEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE)
    __MulticastSessionDeactivationRequestIEs_val_Value_1_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MulticastSessionDeactivationRequestTransfer')))
    _MulticastSessionDeactivationRequestIEs_val_Value_1._const_cont = __MulticastSessionDeactivationRequestIEs_val_Value_1_contain
    MulticastSessionDeactivationRequestIEs._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _MulticastSessionDeactivationRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 305), ('criticality', 'reject'), ('Value', _MulticastSessionDeactivationRequestIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MulticastSessionDeactivationResponse >-----#
    MulticastSessionDeactivationResponse = SEQ(name='MulticastSessionDeactivationResponse', mode=MODE_TYPE)
    _MulticastSessionDeactivationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __MulticastSessionDeactivationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___MulticastSessionDeactivationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____MulticastSessionDeactivationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____MulticastSessionDeactivationResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _____MulticastSessionDeactivationResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____MulticastSessionDeactivationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _____MulticastSessionDeactivationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____MulticastSessionDeactivationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MulticastSessionDeactivationResponse_protocolIEs__item__id._const_tab = ____MulticastSessionDeactivationResponse_protocolIEs__item__id_tab
    ___MulticastSessionDeactivationResponse_protocolIEs__item__id._const_tab_at = None
    ___MulticastSessionDeactivationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___MulticastSessionDeactivationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___MulticastSessionDeactivationResponse_protocolIEs__item__criticality._const_tab = ____MulticastSessionDeactivationResponse_protocolIEs__item__id_tab
    ___MulticastSessionDeactivationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastSessionDeactivationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MulticastSessionDeactivationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___MulticastSessionDeactivationResponse_protocolIEs__item__value._const_tab = ____MulticastSessionDeactivationResponse_protocolIEs__item__id_tab
    ___MulticastSessionDeactivationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MulticastSessionDeactivationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __MulticastSessionDeactivationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MulticastSessionDeactivationResponse_protocolIEs__item__id),
        ('criticality', ___MulticastSessionDeactivationResponse_protocolIEs__item__criticality),
        ('value', ___MulticastSessionDeactivationResponse_protocolIEs__item__value),
        ])
    __MulticastSessionDeactivationResponse_protocolIEs__item_._ext = None
    _MulticastSessionDeactivationResponse_protocolIEs._cont = __MulticastSessionDeactivationResponse_protocolIEs__item_
    _MulticastSessionDeactivationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MulticastSessionDeactivationResponse._cont = ASN1Dict([
        ('protocolIEs', _MulticastSessionDeactivationResponse_protocolIEs),
        ])
    MulticastSessionDeactivationResponse._ext = []
    
    #-----< MulticastSessionDeactivationResponseIEs >-----#
    MulticastSessionDeactivationResponseIEs = CLASS(name='MulticastSessionDeactivationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _MulticastSessionDeactivationResponseIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _MulticastSessionDeactivationResponseIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    MulticastSessionDeactivationResponseIEs._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _MulticastSessionDeactivationResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _MulticastSessionDeactivationResponseIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MulticastSessionUpdateRequest >-----#
    MulticastSessionUpdateRequest = SEQ(name='MulticastSessionUpdateRequest', mode=MODE_TYPE)
    _MulticastSessionUpdateRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __MulticastSessionUpdateRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___MulticastSessionUpdateRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____MulticastSessionUpdateRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____MulticastSessionUpdateRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _____MulticastSessionUpdateRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')))
    _____MulticastSessionUpdateRequest_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE)
    ______MulticastSessionUpdateRequest_protocolIEs__item__id_tab_val_Value_2_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MulticastSessionUpdateRequestTransfer')))
    _____MulticastSessionUpdateRequest_protocolIEs__item__id_tab_val_Value_2._const_cont = ______MulticastSessionUpdateRequest_protocolIEs__item__id_tab_val_Value_2_contain
    ____MulticastSessionUpdateRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _____MulticastSessionUpdateRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 295), ('criticality', 'reject'), ('Value', _____MulticastSessionUpdateRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 306), ('criticality', 'reject'), ('Value', _____MulticastSessionUpdateRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MulticastSessionUpdateRequest_protocolIEs__item__id._const_tab = ____MulticastSessionUpdateRequest_protocolIEs__item__id_tab
    ___MulticastSessionUpdateRequest_protocolIEs__item__id._const_tab_at = None
    ___MulticastSessionUpdateRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___MulticastSessionUpdateRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___MulticastSessionUpdateRequest_protocolIEs__item__criticality._const_tab = ____MulticastSessionUpdateRequest_protocolIEs__item__id_tab
    ___MulticastSessionUpdateRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastSessionUpdateRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MulticastSessionUpdateRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___MulticastSessionUpdateRequest_protocolIEs__item__value._const_tab = ____MulticastSessionUpdateRequest_protocolIEs__item__id_tab
    ___MulticastSessionUpdateRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MulticastSessionUpdateRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __MulticastSessionUpdateRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MulticastSessionUpdateRequest_protocolIEs__item__id),
        ('criticality', ___MulticastSessionUpdateRequest_protocolIEs__item__criticality),
        ('value', ___MulticastSessionUpdateRequest_protocolIEs__item__value),
        ])
    __MulticastSessionUpdateRequest_protocolIEs__item_._ext = None
    _MulticastSessionUpdateRequest_protocolIEs._cont = __MulticastSessionUpdateRequest_protocolIEs__item_
    _MulticastSessionUpdateRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MulticastSessionUpdateRequest._cont = ASN1Dict([
        ('protocolIEs', _MulticastSessionUpdateRequest_protocolIEs),
        ])
    MulticastSessionUpdateRequest._ext = []
    
    #-----< MulticastSessionUpdateRequestIEs >-----#
    MulticastSessionUpdateRequestIEs = CLASS(name='MulticastSessionUpdateRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _MulticastSessionUpdateRequestIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _MulticastSessionUpdateRequestIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')))
    _MulticastSessionUpdateRequestIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE)
    __MulticastSessionUpdateRequestIEs_val_Value_2_contain = SEQ(name='_cont_Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MulticastSessionUpdateRequestTransfer')))
    _MulticastSessionUpdateRequestIEs_val_Value_2._const_cont = __MulticastSessionUpdateRequestIEs_val_Value_2_contain
    MulticastSessionUpdateRequestIEs._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _MulticastSessionUpdateRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 295), ('criticality', 'reject'), ('Value', _MulticastSessionUpdateRequestIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 306), ('criticality', 'reject'), ('Value', _MulticastSessionUpdateRequestIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MulticastSessionUpdateResponse >-----#
    MulticastSessionUpdateResponse = SEQ(name='MulticastSessionUpdateResponse', mode=MODE_TYPE)
    _MulticastSessionUpdateResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __MulticastSessionUpdateResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___MulticastSessionUpdateResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____MulticastSessionUpdateResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____MulticastSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _____MulticastSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')))
    _____MulticastSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____MulticastSessionUpdateResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _____MulticastSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 295), ('criticality', 'reject'), ('Value', _____MulticastSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____MulticastSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MulticastSessionUpdateResponse_protocolIEs__item__id._const_tab = ____MulticastSessionUpdateResponse_protocolIEs__item__id_tab
    ___MulticastSessionUpdateResponse_protocolIEs__item__id._const_tab_at = None
    ___MulticastSessionUpdateResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___MulticastSessionUpdateResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___MulticastSessionUpdateResponse_protocolIEs__item__criticality._const_tab = ____MulticastSessionUpdateResponse_protocolIEs__item__id_tab
    ___MulticastSessionUpdateResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastSessionUpdateResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MulticastSessionUpdateResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___MulticastSessionUpdateResponse_protocolIEs__item__value._const_tab = ____MulticastSessionUpdateResponse_protocolIEs__item__id_tab
    ___MulticastSessionUpdateResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MulticastSessionUpdateResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __MulticastSessionUpdateResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MulticastSessionUpdateResponse_protocolIEs__item__id),
        ('criticality', ___MulticastSessionUpdateResponse_protocolIEs__item__criticality),
        ('value', ___MulticastSessionUpdateResponse_protocolIEs__item__value),
        ])
    __MulticastSessionUpdateResponse_protocolIEs__item_._ext = None
    _MulticastSessionUpdateResponse_protocolIEs._cont = __MulticastSessionUpdateResponse_protocolIEs__item_
    _MulticastSessionUpdateResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MulticastSessionUpdateResponse._cont = ASN1Dict([
        ('protocolIEs', _MulticastSessionUpdateResponse_protocolIEs),
        ])
    MulticastSessionUpdateResponse._ext = []
    
    #-----< MulticastSessionUpdateResponseIEs >-----#
    MulticastSessionUpdateResponseIEs = CLASS(name='MulticastSessionUpdateResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _MulticastSessionUpdateResponseIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _MulticastSessionUpdateResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')))
    _MulticastSessionUpdateResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    MulticastSessionUpdateResponseIEs._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _MulticastSessionUpdateResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 295), ('criticality', 'reject'), ('Value', _MulticastSessionUpdateResponseIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _MulticastSessionUpdateResponseIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MulticastSessionUpdateFailure >-----#
    MulticastSessionUpdateFailure = SEQ(name='MulticastSessionUpdateFailure', mode=MODE_TYPE)
    _MulticastSessionUpdateFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __MulticastSessionUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___MulticastSessionUpdateFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____MulticastSessionUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____MulticastSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _____MulticastSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')))
    _____MulticastSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _____MulticastSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    ____MulticastSessionUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _____MulticastSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 295), ('criticality', 'reject'), ('Value', _____MulticastSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____MulticastSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____MulticastSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MulticastSessionUpdateFailure_protocolIEs__item__id._const_tab = ____MulticastSessionUpdateFailure_protocolIEs__item__id_tab
    ___MulticastSessionUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___MulticastSessionUpdateFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___MulticastSessionUpdateFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___MulticastSessionUpdateFailure_protocolIEs__item__criticality._const_tab = ____MulticastSessionUpdateFailure_protocolIEs__item__id_tab
    ___MulticastSessionUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastSessionUpdateFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MulticastSessionUpdateFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___MulticastSessionUpdateFailure_protocolIEs__item__value._const_tab = ____MulticastSessionUpdateFailure_protocolIEs__item__id_tab
    ___MulticastSessionUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MulticastSessionUpdateFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __MulticastSessionUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MulticastSessionUpdateFailure_protocolIEs__item__id),
        ('criticality', ___MulticastSessionUpdateFailure_protocolIEs__item__criticality),
        ('value', ___MulticastSessionUpdateFailure_protocolIEs__item__value),
        ])
    __MulticastSessionUpdateFailure_protocolIEs__item_._ext = None
    _MulticastSessionUpdateFailure_protocolIEs._cont = __MulticastSessionUpdateFailure_protocolIEs__item_
    _MulticastSessionUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MulticastSessionUpdateFailure._cont = ASN1Dict([
        ('protocolIEs', _MulticastSessionUpdateFailure_protocolIEs),
        ])
    MulticastSessionUpdateFailure._ext = []
    
    #-----< MulticastSessionUpdateFailureIEs >-----#
    MulticastSessionUpdateFailureIEs = CLASS(name='MulticastSessionUpdateFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _MulticastSessionUpdateFailureIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _MulticastSessionUpdateFailureIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-AreaSessionID')))
    _MulticastSessionUpdateFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'Cause')))
    _MulticastSessionUpdateFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'CriticalityDiagnostics')))
    MulticastSessionUpdateFailureIEs._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'reject'), ('Value', _MulticastSessionUpdateFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 295), ('criticality', 'reject'), ('Value', _MulticastSessionUpdateFailureIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _MulticastSessionUpdateFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _MulticastSessionUpdateFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MulticastGroupPaging >-----#
    MulticastGroupPaging = SEQ(name='MulticastGroupPaging', mode=MODE_TYPE)
    _MulticastGroupPaging_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Container')))
    __MulticastGroupPaging_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-Containers', 'ProtocolIE-Field')))
    ___MulticastGroupPaging_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['id']))
    ____MulticastGroupPaging_protocolIEs__item__id_tab = CLASS(name='_tab_NGAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _____MulticastGroupPaging_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _____MulticastGroupPaging_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-ServiceArea')))
    _____MulticastGroupPaging_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MulticastGroupPagingAreaList')))
    ____MulticastGroupPaging_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'ignore'), ('Value', _____MulticastGroupPaging_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 298), ('criticality', 'ignore'), ('Value', _____MulticastGroupPaging_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 307), ('criticality', 'ignore'), ('Value', _____MulticastGroupPaging_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MulticastGroupPaging_protocolIEs__item__id._const_tab = ____MulticastGroupPaging_protocolIEs__item__id_tab
    ___MulticastGroupPaging_protocolIEs__item__id._const_tab_at = None
    ___MulticastGroupPaging_protocolIEs__item__id._const_tab_id = 'id'
    ___MulticastGroupPaging_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['criticality']))
    ___MulticastGroupPaging_protocolIEs__item__criticality._const_tab = ____MulticastGroupPaging_protocolIEs__item__id_tab
    ___MulticastGroupPaging_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MulticastGroupPaging_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MulticastGroupPaging_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-Containers', 'NGAP-PROTOCOL-IES'), ['Value']))
    ___MulticastGroupPaging_protocolIEs__item__value._const_tab = ____MulticastGroupPaging_protocolIEs__item__id_tab
    ___MulticastGroupPaging_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MulticastGroupPaging_protocolIEs__item__value._const_tab_id = 'Value'
    __MulticastGroupPaging_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MulticastGroupPaging_protocolIEs__item__id),
        ('criticality', ___MulticastGroupPaging_protocolIEs__item__criticality),
        ('value', ___MulticastGroupPaging_protocolIEs__item__value),
        ])
    __MulticastGroupPaging_protocolIEs__item_._ext = None
    _MulticastGroupPaging_protocolIEs._cont = __MulticastGroupPaging_protocolIEs__item_
    _MulticastGroupPaging_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MulticastGroupPaging._cont = ASN1Dict([
        ('protocolIEs', _MulticastGroupPaging_protocolIEs),
        ])
    MulticastGroupPaging._ext = []
    
    #-----< MulticastGroupPagingIEs >-----#
    MulticastGroupPagingIEs = CLASS(name='MulticastGroupPagingIEs', mode=MODE_SET, typeref=ASN1RefType(('NGAP-Containers', 'NGAP-PROTOCOL-IES')))
    _MulticastGroupPagingIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-SessionID')))
    _MulticastGroupPagingIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MBS-ServiceArea')))
    _MulticastGroupPagingIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-IEs', 'MulticastGroupPagingAreaList')))
    MulticastGroupPagingIEs._val = ASN1Set(rv=[dict([('id', 299), ('criticality', 'ignore'), ('Value', _MulticastGroupPagingIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 298), ('criticality', 'ignore'), ('Value', _MulticastGroupPagingIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 307), ('criticality', 'ignore'), ('Value', _MulticastGroupPagingIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    _all_ = [
        ____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab,
        _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_2,
        _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_3,
        _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_4,
        _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_5,
        _____PDUSessionResourceSetupRequest_protocolIEs__item__id_tab_val_Value_6,
        ___PDUSessionResourceSetupRequest_protocolIEs__item__id,
        ___PDUSessionResourceSetupRequest_protocolIEs__item__criticality,
        ___PDUSessionResourceSetupRequest_protocolIEs__item__value,
        __PDUSessionResourceSetupRequest_protocolIEs__item_,
        _PDUSessionResourceSetupRequest_protocolIEs,
        PDUSessionResourceSetupRequest,
        PDUSessionResourceSetupRequestIEs,
        _PDUSessionResourceSetupRequestIEs_val_Value_0,
        _PDUSessionResourceSetupRequestIEs_val_Value_1,
        _PDUSessionResourceSetupRequestIEs_val_Value_2,
        _PDUSessionResourceSetupRequestIEs_val_Value_3,
        _PDUSessionResourceSetupRequestIEs_val_Value_4,
        _PDUSessionResourceSetupRequestIEs_val_Value_5,
        _PDUSessionResourceSetupRequestIEs_val_Value_6,
        ____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab,
        _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_3,
        _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_4,
        _____PDUSessionResourceSetupResponse_protocolIEs__item__id_tab_val_Value_5,
        ___PDUSessionResourceSetupResponse_protocolIEs__item__id,
        ___PDUSessionResourceSetupResponse_protocolIEs__item__criticality,
        ___PDUSessionResourceSetupResponse_protocolIEs__item__value,
        __PDUSessionResourceSetupResponse_protocolIEs__item_,
        _PDUSessionResourceSetupResponse_protocolIEs,
        PDUSessionResourceSetupResponse,
        PDUSessionResourceSetupResponseIEs,
        _PDUSessionResourceSetupResponseIEs_val_Value_0,
        _PDUSessionResourceSetupResponseIEs_val_Value_1,
        _PDUSessionResourceSetupResponseIEs_val_Value_2,
        _PDUSessionResourceSetupResponseIEs_val_Value_3,
        _PDUSessionResourceSetupResponseIEs_val_Value_4,
        _PDUSessionResourceSetupResponseIEs_val_Value_5,
        ____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab,
        _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_0,
        _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_1,
        _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_2,
        _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_3,
        _____PDUSessionResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_4,
        ___PDUSessionResourceReleaseCommand_protocolIEs__item__id,
        ___PDUSessionResourceReleaseCommand_protocolIEs__item__criticality,
        ___PDUSessionResourceReleaseCommand_protocolIEs__item__value,
        __PDUSessionResourceReleaseCommand_protocolIEs__item_,
        _PDUSessionResourceReleaseCommand_protocolIEs,
        PDUSessionResourceReleaseCommand,
        PDUSessionResourceReleaseCommandIEs,
        _PDUSessionResourceReleaseCommandIEs_val_Value_0,
        _PDUSessionResourceReleaseCommandIEs_val_Value_1,
        _PDUSessionResourceReleaseCommandIEs_val_Value_2,
        _PDUSessionResourceReleaseCommandIEs_val_Value_3,
        _PDUSessionResourceReleaseCommandIEs_val_Value_4,
        ____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab,
        _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_0,
        _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_1,
        _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_2,
        _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_3,
        _____PDUSessionResourceReleaseResponse_protocolIEs__item__id_tab_val_Value_4,
        ___PDUSessionResourceReleaseResponse_protocolIEs__item__id,
        ___PDUSessionResourceReleaseResponse_protocolIEs__item__criticality,
        ___PDUSessionResourceReleaseResponse_protocolIEs__item__value,
        __PDUSessionResourceReleaseResponse_protocolIEs__item_,
        _PDUSessionResourceReleaseResponse_protocolIEs,
        PDUSessionResourceReleaseResponse,
        PDUSessionResourceReleaseResponseIEs,
        _PDUSessionResourceReleaseResponseIEs_val_Value_0,
        _PDUSessionResourceReleaseResponseIEs_val_Value_1,
        _PDUSessionResourceReleaseResponseIEs_val_Value_2,
        _PDUSessionResourceReleaseResponseIEs_val_Value_3,
        _PDUSessionResourceReleaseResponseIEs_val_Value_4,
        ____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab,
        _____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab_val_Value_1,
        _____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab_val_Value_2,
        _____PDUSessionResourceModifyRequest_protocolIEs__item__id_tab_val_Value_3,
        ___PDUSessionResourceModifyRequest_protocolIEs__item__id,
        ___PDUSessionResourceModifyRequest_protocolIEs__item__criticality,
        ___PDUSessionResourceModifyRequest_protocolIEs__item__value,
        __PDUSessionResourceModifyRequest_protocolIEs__item_,
        _PDUSessionResourceModifyRequest_protocolIEs,
        PDUSessionResourceModifyRequest,
        PDUSessionResourceModifyRequestIEs,
        _PDUSessionResourceModifyRequestIEs_val_Value_0,
        _PDUSessionResourceModifyRequestIEs_val_Value_1,
        _PDUSessionResourceModifyRequestIEs_val_Value_2,
        _PDUSessionResourceModifyRequestIEs_val_Value_3,
        ____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab,
        _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_0,
        _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_1,
        _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_2,
        _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_3,
        _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_4,
        _____PDUSessionResourceModifyResponse_protocolIEs__item__id_tab_val_Value_5,
        ___PDUSessionResourceModifyResponse_protocolIEs__item__id,
        ___PDUSessionResourceModifyResponse_protocolIEs__item__criticality,
        ___PDUSessionResourceModifyResponse_protocolIEs__item__value,
        __PDUSessionResourceModifyResponse_protocolIEs__item_,
        _PDUSessionResourceModifyResponse_protocolIEs,
        PDUSessionResourceModifyResponse,
        PDUSessionResourceModifyResponseIEs,
        _PDUSessionResourceModifyResponseIEs_val_Value_0,
        _PDUSessionResourceModifyResponseIEs_val_Value_1,
        _PDUSessionResourceModifyResponseIEs_val_Value_2,
        _PDUSessionResourceModifyResponseIEs_val_Value_3,
        _PDUSessionResourceModifyResponseIEs_val_Value_4,
        _PDUSessionResourceModifyResponseIEs_val_Value_5,
        ____PDUSessionResourceNotify_protocolIEs__item__id_tab,
        _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_0,
        _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_1,
        _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_2,
        _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_3,
        _____PDUSessionResourceNotify_protocolIEs__item__id_tab_val_Value_4,
        ___PDUSessionResourceNotify_protocolIEs__item__id,
        ___PDUSessionResourceNotify_protocolIEs__item__criticality,
        ___PDUSessionResourceNotify_protocolIEs__item__value,
        __PDUSessionResourceNotify_protocolIEs__item_,
        _PDUSessionResourceNotify_protocolIEs,
        PDUSessionResourceNotify,
        PDUSessionResourceNotifyIEs,
        _PDUSessionResourceNotifyIEs_val_Value_0,
        _PDUSessionResourceNotifyIEs_val_Value_1,
        _PDUSessionResourceNotifyIEs_val_Value_2,
        _PDUSessionResourceNotifyIEs_val_Value_3,
        _PDUSessionResourceNotifyIEs_val_Value_4,
        ____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab,
        _____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab_val_Value_0,
        _____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab_val_Value_1,
        _____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab_val_Value_2,
        _____PDUSessionResourceModifyIndication_protocolIEs__item__id_tab_val_Value_3,
        ___PDUSessionResourceModifyIndication_protocolIEs__item__id,
        ___PDUSessionResourceModifyIndication_protocolIEs__item__criticality,
        ___PDUSessionResourceModifyIndication_protocolIEs__item__value,
        __PDUSessionResourceModifyIndication_protocolIEs__item_,
        _PDUSessionResourceModifyIndication_protocolIEs,
        PDUSessionResourceModifyIndication,
        PDUSessionResourceModifyIndicationIEs,
        _PDUSessionResourceModifyIndicationIEs_val_Value_0,
        _PDUSessionResourceModifyIndicationIEs_val_Value_1,
        _PDUSessionResourceModifyIndicationIEs_val_Value_2,
        _PDUSessionResourceModifyIndicationIEs_val_Value_3,
        ____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab,
        _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_0,
        _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_1,
        _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_2,
        _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_3,
        _____PDUSessionResourceModifyConfirm_protocolIEs__item__id_tab_val_Value_4,
        ___PDUSessionResourceModifyConfirm_protocolIEs__item__id,
        ___PDUSessionResourceModifyConfirm_protocolIEs__item__criticality,
        ___PDUSessionResourceModifyConfirm_protocolIEs__item__value,
        __PDUSessionResourceModifyConfirm_protocolIEs__item_,
        _PDUSessionResourceModifyConfirm_protocolIEs,
        PDUSessionResourceModifyConfirm,
        PDUSessionResourceModifyConfirmIEs,
        _PDUSessionResourceModifyConfirmIEs_val_Value_0,
        _PDUSessionResourceModifyConfirmIEs_val_Value_1,
        _PDUSessionResourceModifyConfirmIEs_val_Value_2,
        _PDUSessionResourceModifyConfirmIEs_val_Value_3,
        _PDUSessionResourceModifyConfirmIEs_val_Value_4,
        ____InitialContextSetupRequest_protocolIEs__item__id_tab,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_2,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_3,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_4,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_5,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_6,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_7,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_8,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_9,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_10,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_11,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_12,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_13,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_14,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_15,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_16,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_17,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_18,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_19,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_20,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_21,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_22,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_23,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_24,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_25,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_26,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_27,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_28,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_29,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_30,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_31,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_32,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_33,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_34,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_35,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_36,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_37,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_38,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_39,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_40,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_41,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_42,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_43,
        ___InitialContextSetupRequest_protocolIEs__item__id,
        ___InitialContextSetupRequest_protocolIEs__item__criticality,
        ___InitialContextSetupRequest_protocolIEs__item__value,
        __InitialContextSetupRequest_protocolIEs__item_,
        _InitialContextSetupRequest_protocolIEs,
        InitialContextSetupRequest,
        InitialContextSetupRequestIEs,
        _InitialContextSetupRequestIEs_val_Value_0,
        _InitialContextSetupRequestIEs_val_Value_1,
        _InitialContextSetupRequestIEs_val_Value_2,
        _InitialContextSetupRequestIEs_val_Value_3,
        _InitialContextSetupRequestIEs_val_Value_4,
        _InitialContextSetupRequestIEs_val_Value_5,
        _InitialContextSetupRequestIEs_val_Value_6,
        _InitialContextSetupRequestIEs_val_Value_7,
        _InitialContextSetupRequestIEs_val_Value_8,
        _InitialContextSetupRequestIEs_val_Value_9,
        _InitialContextSetupRequestIEs_val_Value_10,
        _InitialContextSetupRequestIEs_val_Value_11,
        _InitialContextSetupRequestIEs_val_Value_12,
        _InitialContextSetupRequestIEs_val_Value_13,
        _InitialContextSetupRequestIEs_val_Value_14,
        _InitialContextSetupRequestIEs_val_Value_15,
        _InitialContextSetupRequestIEs_val_Value_16,
        _InitialContextSetupRequestIEs_val_Value_17,
        _InitialContextSetupRequestIEs_val_Value_18,
        _InitialContextSetupRequestIEs_val_Value_19,
        _InitialContextSetupRequestIEs_val_Value_20,
        _InitialContextSetupRequestIEs_val_Value_21,
        _InitialContextSetupRequestIEs_val_Value_22,
        _InitialContextSetupRequestIEs_val_Value_23,
        _InitialContextSetupRequestIEs_val_Value_24,
        _InitialContextSetupRequestIEs_val_Value_25,
        _InitialContextSetupRequestIEs_val_Value_26,
        _InitialContextSetupRequestIEs_val_Value_27,
        _InitialContextSetupRequestIEs_val_Value_28,
        _InitialContextSetupRequestIEs_val_Value_29,
        _InitialContextSetupRequestIEs_val_Value_30,
        _InitialContextSetupRequestIEs_val_Value_31,
        _InitialContextSetupRequestIEs_val_Value_32,
        _InitialContextSetupRequestIEs_val_Value_33,
        _InitialContextSetupRequestIEs_val_Value_34,
        _InitialContextSetupRequestIEs_val_Value_35,
        _InitialContextSetupRequestIEs_val_Value_36,
        _InitialContextSetupRequestIEs_val_Value_37,
        _InitialContextSetupRequestIEs_val_Value_38,
        _InitialContextSetupRequestIEs_val_Value_39,
        _InitialContextSetupRequestIEs_val_Value_40,
        _InitialContextSetupRequestIEs_val_Value_41,
        _InitialContextSetupRequestIEs_val_Value_42,
        _InitialContextSetupRequestIEs_val_Value_43,
        ____InitialContextSetupResponse_protocolIEs__item__id_tab,
        _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_3,
        _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_4,
        ___InitialContextSetupResponse_protocolIEs__item__id,
        ___InitialContextSetupResponse_protocolIEs__item__criticality,
        ___InitialContextSetupResponse_protocolIEs__item__value,
        __InitialContextSetupResponse_protocolIEs__item_,
        _InitialContextSetupResponse_protocolIEs,
        InitialContextSetupResponse,
        InitialContextSetupResponseIEs,
        _InitialContextSetupResponseIEs_val_Value_0,
        _InitialContextSetupResponseIEs_val_Value_1,
        _InitialContextSetupResponseIEs_val_Value_2,
        _InitialContextSetupResponseIEs_val_Value_3,
        _InitialContextSetupResponseIEs_val_Value_4,
        ____InitialContextSetupFailure_protocolIEs__item__id_tab,
        _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_2,
        _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_3,
        _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_4,
        ___InitialContextSetupFailure_protocolIEs__item__id,
        ___InitialContextSetupFailure_protocolIEs__item__criticality,
        ___InitialContextSetupFailure_protocolIEs__item__value,
        __InitialContextSetupFailure_protocolIEs__item_,
        _InitialContextSetupFailure_protocolIEs,
        InitialContextSetupFailure,
        InitialContextSetupFailureIEs,
        _InitialContextSetupFailureIEs_val_Value_0,
        _InitialContextSetupFailureIEs_val_Value_1,
        _InitialContextSetupFailureIEs_val_Value_2,
        _InitialContextSetupFailureIEs_val_Value_3,
        _InitialContextSetupFailureIEs_val_Value_4,
        ____UEContextReleaseRequest_protocolIEs__item__id_tab,
        _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_3,
        ___UEContextReleaseRequest_protocolIEs__item__id,
        ___UEContextReleaseRequest_protocolIEs__item__criticality,
        ___UEContextReleaseRequest_protocolIEs__item__value,
        __UEContextReleaseRequest_protocolIEs__item_,
        _UEContextReleaseRequest_protocolIEs,
        UEContextReleaseRequest,
        UEContextReleaseRequest_IEs,
        _UEContextReleaseRequest_IEs_val_Value_0,
        _UEContextReleaseRequest_IEs_val_Value_1,
        _UEContextReleaseRequest_IEs_val_Value_2,
        _UEContextReleaseRequest_IEs_val_Value_3,
        ____UEContextReleaseCommand_protocolIEs__item__id_tab,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1,
        ___UEContextReleaseCommand_protocolIEs__item__id,
        ___UEContextReleaseCommand_protocolIEs__item__criticality,
        ___UEContextReleaseCommand_protocolIEs__item__value,
        __UEContextReleaseCommand_protocolIEs__item_,
        _UEContextReleaseCommand_protocolIEs,
        UEContextReleaseCommand,
        UEContextReleaseCommand_IEs,
        _UEContextReleaseCommand_IEs_val_Value_0,
        _UEContextReleaseCommand_IEs_val_Value_1,
        ____UEContextReleaseComplete_protocolIEs__item__id_tab,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_6,
        ___UEContextReleaseComplete_protocolIEs__item__id,
        ___UEContextReleaseComplete_protocolIEs__item__criticality,
        ___UEContextReleaseComplete_protocolIEs__item__value,
        __UEContextReleaseComplete_protocolIEs__item_,
        _UEContextReleaseComplete_protocolIEs,
        UEContextReleaseComplete,
        UEContextReleaseComplete_IEs,
        _UEContextReleaseComplete_IEs_val_Value_0,
        _UEContextReleaseComplete_IEs_val_Value_1,
        _UEContextReleaseComplete_IEs_val_Value_2,
        _UEContextReleaseComplete_IEs_val_Value_3,
        _UEContextReleaseComplete_IEs_val_Value_4,
        _UEContextReleaseComplete_IEs_val_Value_5,
        _UEContextReleaseComplete_IEs_val_Value_6,
        ____UEContextResumeRequest_protocolIEs__item__id_tab,
        _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_6,
        _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_7,
        ___UEContextResumeRequest_protocolIEs__item__id,
        ___UEContextResumeRequest_protocolIEs__item__criticality,
        ___UEContextResumeRequest_protocolIEs__item__value,
        __UEContextResumeRequest_protocolIEs__item_,
        _UEContextResumeRequest_protocolIEs,
        UEContextResumeRequest,
        UEContextResumeRequestIEs,
        _UEContextResumeRequestIEs_val_Value_0,
        _UEContextResumeRequestIEs_val_Value_1,
        _UEContextResumeRequestIEs_val_Value_2,
        _UEContextResumeRequestIEs_val_Value_3,
        _UEContextResumeRequestIEs_val_Value_4,
        _UEContextResumeRequestIEs_val_Value_5,
        _UEContextResumeRequestIEs_val_Value_6,
        _UEContextResumeRequestIEs_val_Value_7,
        ____UEContextResumeResponse_protocolIEs__item__id_tab,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_6,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_7,
        ___UEContextResumeResponse_protocolIEs__item__id,
        ___UEContextResumeResponse_protocolIEs__item__criticality,
        ___UEContextResumeResponse_protocolIEs__item__value,
        __UEContextResumeResponse_protocolIEs__item_,
        _UEContextResumeResponse_protocolIEs,
        UEContextResumeResponse,
        UEContextResumeResponseIEs,
        _UEContextResumeResponseIEs_val_Value_0,
        _UEContextResumeResponseIEs_val_Value_1,
        _UEContextResumeResponseIEs_val_Value_2,
        _UEContextResumeResponseIEs_val_Value_3,
        _UEContextResumeResponseIEs_val_Value_4,
        _UEContextResumeResponseIEs_val_Value_5,
        _UEContextResumeResponseIEs_val_Value_6,
        _UEContextResumeResponseIEs_val_Value_7,
        ____UEContextResumeFailure_protocolIEs__item__id_tab,
        _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_3,
        ___UEContextResumeFailure_protocolIEs__item__id,
        ___UEContextResumeFailure_protocolIEs__item__criticality,
        ___UEContextResumeFailure_protocolIEs__item__value,
        __UEContextResumeFailure_protocolIEs__item_,
        _UEContextResumeFailure_protocolIEs,
        UEContextResumeFailure,
        UEContextResumeFailureIEs,
        _UEContextResumeFailureIEs_val_Value_0,
        _UEContextResumeFailureIEs_val_Value_1,
        _UEContextResumeFailureIEs_val_Value_2,
        _UEContextResumeFailureIEs_val_Value_3,
        ____UEContextSuspendRequest_protocolIEs__item__id_tab,
        _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_4,
        ___UEContextSuspendRequest_protocolIEs__item__id,
        ___UEContextSuspendRequest_protocolIEs__item__criticality,
        ___UEContextSuspendRequest_protocolIEs__item__value,
        __UEContextSuspendRequest_protocolIEs__item_,
        _UEContextSuspendRequest_protocolIEs,
        UEContextSuspendRequest,
        UEContextSuspendRequestIEs,
        _UEContextSuspendRequestIEs_val_Value_0,
        _UEContextSuspendRequestIEs_val_Value_1,
        _UEContextSuspendRequestIEs_val_Value_2,
        _UEContextSuspendRequestIEs_val_Value_3,
        _UEContextSuspendRequestIEs_val_Value_4,
        ____UEContextSuspendResponse_protocolIEs__item__id_tab,
        _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_3,
        ___UEContextSuspendResponse_protocolIEs__item__id,
        ___UEContextSuspendResponse_protocolIEs__item__criticality,
        ___UEContextSuspendResponse_protocolIEs__item__value,
        __UEContextSuspendResponse_protocolIEs__item_,
        _UEContextSuspendResponse_protocolIEs,
        UEContextSuspendResponse,
        UEContextSuspendResponseIEs,
        _UEContextSuspendResponseIEs_val_Value_0,
        _UEContextSuspendResponseIEs_val_Value_1,
        _UEContextSuspendResponseIEs_val_Value_2,
        _UEContextSuspendResponseIEs_val_Value_3,
        ____UEContextSuspendFailure_protocolIEs__item__id_tab,
        _____UEContextSuspendFailure_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextSuspendFailure_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextSuspendFailure_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextSuspendFailure_protocolIEs__item__id_tab_val_Value_3,
        ___UEContextSuspendFailure_protocolIEs__item__id,
        ___UEContextSuspendFailure_protocolIEs__item__criticality,
        ___UEContextSuspendFailure_protocolIEs__item__value,
        __UEContextSuspendFailure_protocolIEs__item_,
        _UEContextSuspendFailure_protocolIEs,
        UEContextSuspendFailure,
        UEContextSuspendFailureIEs,
        _UEContextSuspendFailureIEs_val_Value_0,
        _UEContextSuspendFailureIEs_val_Value_1,
        _UEContextSuspendFailureIEs_val_Value_2,
        _UEContextSuspendFailureIEs_val_Value_3,
        ____UEContextModificationRequest_protocolIEs__item__id_tab,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_6,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_7,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_8,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_9,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_10,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_11,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_12,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_13,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_14,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_15,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_16,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_17,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_18,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_19,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_20,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_21,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_22,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_23,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_24,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_25,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_26,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_27,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_28,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_29,
        ___UEContextModificationRequest_protocolIEs__item__id,
        ___UEContextModificationRequest_protocolIEs__item__criticality,
        ___UEContextModificationRequest_protocolIEs__item__value,
        __UEContextModificationRequest_protocolIEs__item_,
        _UEContextModificationRequest_protocolIEs,
        UEContextModificationRequest,
        UEContextModificationRequestIEs,
        _UEContextModificationRequestIEs_val_Value_0,
        _UEContextModificationRequestIEs_val_Value_1,
        _UEContextModificationRequestIEs_val_Value_2,
        _UEContextModificationRequestIEs_val_Value_3,
        _UEContextModificationRequestIEs_val_Value_4,
        _UEContextModificationRequestIEs_val_Value_5,
        _UEContextModificationRequestIEs_val_Value_6,
        _UEContextModificationRequestIEs_val_Value_7,
        _UEContextModificationRequestIEs_val_Value_8,
        _UEContextModificationRequestIEs_val_Value_9,
        _UEContextModificationRequestIEs_val_Value_10,
        _UEContextModificationRequestIEs_val_Value_11,
        _UEContextModificationRequestIEs_val_Value_12,
        _UEContextModificationRequestIEs_val_Value_13,
        _UEContextModificationRequestIEs_val_Value_14,
        _UEContextModificationRequestIEs_val_Value_15,
        _UEContextModificationRequestIEs_val_Value_16,
        _UEContextModificationRequestIEs_val_Value_17,
        _UEContextModificationRequestIEs_val_Value_18,
        _UEContextModificationRequestIEs_val_Value_19,
        _UEContextModificationRequestIEs_val_Value_20,
        _UEContextModificationRequestIEs_val_Value_21,
        _UEContextModificationRequestIEs_val_Value_22,
        _UEContextModificationRequestIEs_val_Value_23,
        _UEContextModificationRequestIEs_val_Value_24,
        _UEContextModificationRequestIEs_val_Value_25,
        _UEContextModificationRequestIEs_val_Value_26,
        _UEContextModificationRequestIEs_val_Value_27,
        _UEContextModificationRequestIEs_val_Value_28,
        _UEContextModificationRequestIEs_val_Value_29,
        ____UEContextModificationResponse_protocolIEs__item__id_tab,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_4,
        ___UEContextModificationResponse_protocolIEs__item__id,
        ___UEContextModificationResponse_protocolIEs__item__criticality,
        ___UEContextModificationResponse_protocolIEs__item__value,
        __UEContextModificationResponse_protocolIEs__item_,
        _UEContextModificationResponse_protocolIEs,
        UEContextModificationResponse,
        UEContextModificationResponseIEs,
        _UEContextModificationResponseIEs_val_Value_0,
        _UEContextModificationResponseIEs_val_Value_1,
        _UEContextModificationResponseIEs_val_Value_2,
        _UEContextModificationResponseIEs_val_Value_3,
        _UEContextModificationResponseIEs_val_Value_4,
        ____UEContextModificationFailure_protocolIEs__item__id_tab,
        _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_3,
        ___UEContextModificationFailure_protocolIEs__item__id,
        ___UEContextModificationFailure_protocolIEs__item__criticality,
        ___UEContextModificationFailure_protocolIEs__item__value,
        __UEContextModificationFailure_protocolIEs__item_,
        _UEContextModificationFailure_protocolIEs,
        UEContextModificationFailure,
        UEContextModificationFailureIEs,
        _UEContextModificationFailureIEs_val_Value_0,
        _UEContextModificationFailureIEs_val_Value_1,
        _UEContextModificationFailureIEs_val_Value_2,
        _UEContextModificationFailureIEs_val_Value_3,
        ____RRCInactiveTransitionReport_protocolIEs__item__id_tab,
        _____RRCInactiveTransitionReport_protocolIEs__item__id_tab_val_Value_0,
        _____RRCInactiveTransitionReport_protocolIEs__item__id_tab_val_Value_1,
        _____RRCInactiveTransitionReport_protocolIEs__item__id_tab_val_Value_2,
        _____RRCInactiveTransitionReport_protocolIEs__item__id_tab_val_Value_3,
        ___RRCInactiveTransitionReport_protocolIEs__item__id,
        ___RRCInactiveTransitionReport_protocolIEs__item__criticality,
        ___RRCInactiveTransitionReport_protocolIEs__item__value,
        __RRCInactiveTransitionReport_protocolIEs__item_,
        _RRCInactiveTransitionReport_protocolIEs,
        RRCInactiveTransitionReport,
        RRCInactiveTransitionReportIEs,
        _RRCInactiveTransitionReportIEs_val_Value_0,
        _RRCInactiveTransitionReportIEs_val_Value_1,
        _RRCInactiveTransitionReportIEs_val_Value_2,
        _RRCInactiveTransitionReportIEs_val_Value_3,
        ____RetrieveUEInformation_protocolIEs__item__id_tab,
        _____RetrieveUEInformation_protocolIEs__item__id_tab_val_Value_0,
        ___RetrieveUEInformation_protocolIEs__item__id,
        ___RetrieveUEInformation_protocolIEs__item__criticality,
        ___RetrieveUEInformation_protocolIEs__item__value,
        __RetrieveUEInformation_protocolIEs__item_,
        _RetrieveUEInformation_protocolIEs,
        RetrieveUEInformation,
        RetrieveUEInformationIEs,
        _RetrieveUEInformationIEs_val_Value_0,
        ____UEInformationTransfer_protocolIEs__item__id_tab,
        _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_2,
        _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_3,
        _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_4,
        _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_5,
        _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_6,
        ___UEInformationTransfer_protocolIEs__item__id,
        ___UEInformationTransfer_protocolIEs__item__criticality,
        ___UEInformationTransfer_protocolIEs__item__value,
        __UEInformationTransfer_protocolIEs__item_,
        _UEInformationTransfer_protocolIEs,
        UEInformationTransfer,
        UEInformationTransferIEs,
        _UEInformationTransferIEs_val_Value_0,
        _UEInformationTransferIEs_val_Value_1,
        _UEInformationTransferIEs_val_Value_2,
        _UEInformationTransferIEs_val_Value_3,
        _UEInformationTransferIEs_val_Value_4,
        _UEInformationTransferIEs_val_Value_5,
        _UEInformationTransferIEs_val_Value_6,
        ____RANCPRelocationIndication_protocolIEs__item__id_tab,
        _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_0,
        _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_1,
        _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_2,
        _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_3,
        _____RANCPRelocationIndication_protocolIEs__item__id_tab_val_Value_4,
        ___RANCPRelocationIndication_protocolIEs__item__id,
        ___RANCPRelocationIndication_protocolIEs__item__criticality,
        ___RANCPRelocationIndication_protocolIEs__item__value,
        __RANCPRelocationIndication_protocolIEs__item_,
        _RANCPRelocationIndication_protocolIEs,
        RANCPRelocationIndication,
        RANCPRelocationIndicationIEs,
        _RANCPRelocationIndicationIEs_val_Value_0,
        _RANCPRelocationIndicationIEs_val_Value_1,
        _RANCPRelocationIndicationIEs_val_Value_2,
        _RANCPRelocationIndicationIEs_val_Value_3,
        _RANCPRelocationIndicationIEs_val_Value_4,
        ____HandoverRequired_protocolIEs__item__id_tab,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_4,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_5,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_6,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_7,
        ___HandoverRequired_protocolIEs__item__id,
        ___HandoverRequired_protocolIEs__item__criticality,
        ___HandoverRequired_protocolIEs__item__value,
        __HandoverRequired_protocolIEs__item_,
        _HandoverRequired_protocolIEs,
        HandoverRequired,
        HandoverRequiredIEs,
        _HandoverRequiredIEs_val_Value_0,
        _HandoverRequiredIEs_val_Value_1,
        _HandoverRequiredIEs_val_Value_2,
        _HandoverRequiredIEs_val_Value_3,
        _HandoverRequiredIEs_val_Value_4,
        _HandoverRequiredIEs_val_Value_5,
        _HandoverRequiredIEs_val_Value_6,
        _HandoverRequiredIEs_val_Value_7,
        ____HandoverCommand_protocolIEs__item__id_tab,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_4,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_5,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_6,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_7,
        ___HandoverCommand_protocolIEs__item__id,
        ___HandoverCommand_protocolIEs__item__criticality,
        ___HandoverCommand_protocolIEs__item__value,
        __HandoverCommand_protocolIEs__item_,
        _HandoverCommand_protocolIEs,
        HandoverCommand,
        HandoverCommandIEs,
        _HandoverCommandIEs_val_Value_0,
        _HandoverCommandIEs_val_Value_1,
        _HandoverCommandIEs_val_Value_2,
        _HandoverCommandIEs_val_Value_3,
        _HandoverCommandIEs_val_Value_4,
        _HandoverCommandIEs_val_Value_5,
        _HandoverCommandIEs_val_Value_6,
        _HandoverCommandIEs_val_Value_7,
        ____HandoverPreparationFailure_protocolIEs__item__id_tab,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_4,
        ___HandoverPreparationFailure_protocolIEs__item__id,
        ___HandoverPreparationFailure_protocolIEs__item__criticality,
        ___HandoverPreparationFailure_protocolIEs__item__value,
        __HandoverPreparationFailure_protocolIEs__item_,
        _HandoverPreparationFailure_protocolIEs,
        HandoverPreparationFailure,
        HandoverPreparationFailureIEs,
        _HandoverPreparationFailureIEs_val_Value_0,
        _HandoverPreparationFailureIEs_val_Value_1,
        _HandoverPreparationFailureIEs_val_Value_2,
        _HandoverPreparationFailureIEs_val_Value_3,
        _HandoverPreparationFailureIEs_val_Value_4,
        ____HandoverRequest_protocolIEs__item__id_tab,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_4,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_5,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_6,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_7,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_8,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_9,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_10,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_11,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_12,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_13,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_14,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_15,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_16,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_17,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_18,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_19,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_20,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_21,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_22,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_23,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_24,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_25,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_26,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_27,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_28,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_29,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_30,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_31,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_32,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_33,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_34,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_35,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_36,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_37,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_38,
        ___HandoverRequest_protocolIEs__item__id,
        ___HandoverRequest_protocolIEs__item__criticality,
        ___HandoverRequest_protocolIEs__item__value,
        __HandoverRequest_protocolIEs__item_,
        _HandoverRequest_protocolIEs,
        HandoverRequest,
        HandoverRequestIEs,
        _HandoverRequestIEs_val_Value_0,
        _HandoverRequestIEs_val_Value_1,
        _HandoverRequestIEs_val_Value_2,
        _HandoverRequestIEs_val_Value_3,
        _HandoverRequestIEs_val_Value_4,
        _HandoverRequestIEs_val_Value_5,
        _HandoverRequestIEs_val_Value_6,
        _HandoverRequestIEs_val_Value_7,
        _HandoverRequestIEs_val_Value_8,
        _HandoverRequestIEs_val_Value_9,
        _HandoverRequestIEs_val_Value_10,
        _HandoverRequestIEs_val_Value_11,
        _HandoverRequestIEs_val_Value_12,
        _HandoverRequestIEs_val_Value_13,
        _HandoverRequestIEs_val_Value_14,
        _HandoverRequestIEs_val_Value_15,
        _HandoverRequestIEs_val_Value_16,
        _HandoverRequestIEs_val_Value_17,
        _HandoverRequestIEs_val_Value_18,
        _HandoverRequestIEs_val_Value_19,
        _HandoverRequestIEs_val_Value_20,
        _HandoverRequestIEs_val_Value_21,
        _HandoverRequestIEs_val_Value_22,
        _HandoverRequestIEs_val_Value_23,
        _HandoverRequestIEs_val_Value_24,
        _HandoverRequestIEs_val_Value_25,
        _HandoverRequestIEs_val_Value_26,
        _HandoverRequestIEs_val_Value_27,
        _HandoverRequestIEs_val_Value_28,
        _HandoverRequestIEs_val_Value_29,
        _HandoverRequestIEs_val_Value_30,
        _HandoverRequestIEs_val_Value_31,
        _HandoverRequestIEs_val_Value_32,
        _HandoverRequestIEs_val_Value_33,
        _HandoverRequestIEs_val_Value_34,
        _HandoverRequestIEs_val_Value_35,
        _HandoverRequestIEs_val_Value_36,
        _HandoverRequestIEs_val_Value_37,
        _HandoverRequestIEs_val_Value_38,
        ____HandoverRequestAcknowledge_protocolIEs__item__id_tab,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7,
        ___HandoverRequestAcknowledge_protocolIEs__item__id,
        ___HandoverRequestAcknowledge_protocolIEs__item__criticality,
        ___HandoverRequestAcknowledge_protocolIEs__item__value,
        __HandoverRequestAcknowledge_protocolIEs__item_,
        _HandoverRequestAcknowledge_protocolIEs,
        HandoverRequestAcknowledge,
        HandoverRequestAcknowledgeIEs,
        _HandoverRequestAcknowledgeIEs_val_Value_0,
        _HandoverRequestAcknowledgeIEs_val_Value_1,
        _HandoverRequestAcknowledgeIEs_val_Value_2,
        _HandoverRequestAcknowledgeIEs_val_Value_3,
        _HandoverRequestAcknowledgeIEs_val_Value_4,
        _HandoverRequestAcknowledgeIEs_val_Value_5,
        _HandoverRequestAcknowledgeIEs_val_Value_6,
        _HandoverRequestAcknowledgeIEs_val_Value_7,
        ____HandoverFailure_protocolIEs__item__id_tab,
        _____HandoverFailure_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverFailure_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverFailure_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverFailure_protocolIEs__item__id_tab_val_Value_3,
        ___HandoverFailure_protocolIEs__item__id,
        ___HandoverFailure_protocolIEs__item__criticality,
        ___HandoverFailure_protocolIEs__item__value,
        __HandoverFailure_protocolIEs__item_,
        _HandoverFailure_protocolIEs,
        HandoverFailure,
        HandoverFailureIEs,
        _HandoverFailureIEs_val_Value_0,
        _HandoverFailureIEs_val_Value_1,
        _HandoverFailureIEs_val_Value_2,
        _HandoverFailureIEs_val_Value_3,
        ____HandoverNotify_protocolIEs__item__id_tab,
        _____HandoverNotify_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverNotify_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverNotify_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverNotify_protocolIEs__item__id_tab_val_Value_3,
        ___HandoverNotify_protocolIEs__item__id,
        ___HandoverNotify_protocolIEs__item__criticality,
        ___HandoverNotify_protocolIEs__item__value,
        __HandoverNotify_protocolIEs__item_,
        _HandoverNotify_protocolIEs,
        HandoverNotify,
        HandoverNotifyIEs,
        _HandoverNotifyIEs_val_Value_0,
        _HandoverNotifyIEs_val_Value_1,
        _HandoverNotifyIEs_val_Value_2,
        _HandoverNotifyIEs_val_Value_3,
        ____PathSwitchRequest_protocolIEs__item__id_tab,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_1,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_2,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_3,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_4,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_5,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_6,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_7,
        ___PathSwitchRequest_protocolIEs__item__id,
        ___PathSwitchRequest_protocolIEs__item__criticality,
        ___PathSwitchRequest_protocolIEs__item__value,
        __PathSwitchRequest_protocolIEs__item_,
        _PathSwitchRequest_protocolIEs,
        PathSwitchRequest,
        PathSwitchRequestIEs,
        _PathSwitchRequestIEs_val_Value_0,
        _PathSwitchRequestIEs_val_Value_1,
        _PathSwitchRequestIEs_val_Value_2,
        _PathSwitchRequestIEs_val_Value_3,
        _PathSwitchRequestIEs_val_Value_4,
        _PathSwitchRequestIEs_val_Value_5,
        _PathSwitchRequestIEs_val_Value_6,
        _PathSwitchRequestIEs_val_Value_7,
        ____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_11,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_12,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_13,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_14,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_15,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_16,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_17,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_18,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_19,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_20,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_21,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_22,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_23,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_24,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_25,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_26,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_27,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_28,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_29,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_30,
        ___PathSwitchRequestAcknowledge_protocolIEs__item__id,
        ___PathSwitchRequestAcknowledge_protocolIEs__item__criticality,
        ___PathSwitchRequestAcknowledge_protocolIEs__item__value,
        __PathSwitchRequestAcknowledge_protocolIEs__item_,
        _PathSwitchRequestAcknowledge_protocolIEs,
        PathSwitchRequestAcknowledge,
        PathSwitchRequestAcknowledgeIEs,
        _PathSwitchRequestAcknowledgeIEs_val_Value_0,
        _PathSwitchRequestAcknowledgeIEs_val_Value_1,
        _PathSwitchRequestAcknowledgeIEs_val_Value_2,
        _PathSwitchRequestAcknowledgeIEs_val_Value_3,
        _PathSwitchRequestAcknowledgeIEs_val_Value_4,
        _PathSwitchRequestAcknowledgeIEs_val_Value_5,
        _PathSwitchRequestAcknowledgeIEs_val_Value_6,
        _PathSwitchRequestAcknowledgeIEs_val_Value_7,
        _PathSwitchRequestAcknowledgeIEs_val_Value_8,
        _PathSwitchRequestAcknowledgeIEs_val_Value_9,
        _PathSwitchRequestAcknowledgeIEs_val_Value_10,
        _PathSwitchRequestAcknowledgeIEs_val_Value_11,
        _PathSwitchRequestAcknowledgeIEs_val_Value_12,
        _PathSwitchRequestAcknowledgeIEs_val_Value_13,
        _PathSwitchRequestAcknowledgeIEs_val_Value_14,
        _PathSwitchRequestAcknowledgeIEs_val_Value_15,
        _PathSwitchRequestAcknowledgeIEs_val_Value_16,
        _PathSwitchRequestAcknowledgeIEs_val_Value_17,
        _PathSwitchRequestAcknowledgeIEs_val_Value_18,
        _PathSwitchRequestAcknowledgeIEs_val_Value_19,
        _PathSwitchRequestAcknowledgeIEs_val_Value_20,
        _PathSwitchRequestAcknowledgeIEs_val_Value_21,
        _PathSwitchRequestAcknowledgeIEs_val_Value_22,
        _PathSwitchRequestAcknowledgeIEs_val_Value_23,
        _PathSwitchRequestAcknowledgeIEs_val_Value_24,
        _PathSwitchRequestAcknowledgeIEs_val_Value_25,
        _PathSwitchRequestAcknowledgeIEs_val_Value_26,
        _PathSwitchRequestAcknowledgeIEs_val_Value_27,
        _PathSwitchRequestAcknowledgeIEs_val_Value_28,
        _PathSwitchRequestAcknowledgeIEs_val_Value_29,
        _PathSwitchRequestAcknowledgeIEs_val_Value_30,
        ____PathSwitchRequestFailure_protocolIEs__item__id_tab,
        _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_0,
        _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_1,
        _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_2,
        _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_3,
        ___PathSwitchRequestFailure_protocolIEs__item__id,
        ___PathSwitchRequestFailure_protocolIEs__item__criticality,
        ___PathSwitchRequestFailure_protocolIEs__item__value,
        __PathSwitchRequestFailure_protocolIEs__item_,
        _PathSwitchRequestFailure_protocolIEs,
        PathSwitchRequestFailure,
        PathSwitchRequestFailureIEs,
        _PathSwitchRequestFailureIEs_val_Value_0,
        _PathSwitchRequestFailureIEs_val_Value_1,
        _PathSwitchRequestFailureIEs_val_Value_2,
        _PathSwitchRequestFailureIEs_val_Value_3,
        ____HandoverCancel_protocolIEs__item__id_tab,
        _____HandoverCancel_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverCancel_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverCancel_protocolIEs__item__id_tab_val_Value_2,
        ___HandoverCancel_protocolIEs__item__id,
        ___HandoverCancel_protocolIEs__item__criticality,
        ___HandoverCancel_protocolIEs__item__value,
        __HandoverCancel_protocolIEs__item_,
        _HandoverCancel_protocolIEs,
        HandoverCancel,
        HandoverCancelIEs,
        _HandoverCancelIEs_val_Value_0,
        _HandoverCancelIEs_val_Value_1,
        _HandoverCancelIEs_val_Value_2,
        ____HandoverCancelAcknowledge_protocolIEs__item__id_tab,
        _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        ___HandoverCancelAcknowledge_protocolIEs__item__id,
        ___HandoverCancelAcknowledge_protocolIEs__item__criticality,
        ___HandoverCancelAcknowledge_protocolIEs__item__value,
        __HandoverCancelAcknowledge_protocolIEs__item_,
        _HandoverCancelAcknowledge_protocolIEs,
        HandoverCancelAcknowledge,
        HandoverCancelAcknowledgeIEs,
        _HandoverCancelAcknowledgeIEs_val_Value_0,
        _HandoverCancelAcknowledgeIEs_val_Value_1,
        _HandoverCancelAcknowledgeIEs_val_Value_2,
        ____HandoverSuccess_protocolIEs__item__id_tab,
        _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_1,
        ___HandoverSuccess_protocolIEs__item__id,
        ___HandoverSuccess_protocolIEs__item__criticality,
        ___HandoverSuccess_protocolIEs__item__value,
        __HandoverSuccess_protocolIEs__item_,
        _HandoverSuccess_protocolIEs,
        HandoverSuccess,
        HandoverSuccessIEs,
        _HandoverSuccessIEs_val_Value_0,
        _HandoverSuccessIEs_val_Value_1,
        ____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab,
        _____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____UplinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___UplinkRANEarlyStatusTransfer_protocolIEs__item__id,
        ___UplinkRANEarlyStatusTransfer_protocolIEs__item__criticality,
        ___UplinkRANEarlyStatusTransfer_protocolIEs__item__value,
        __UplinkRANEarlyStatusTransfer_protocolIEs__item_,
        _UplinkRANEarlyStatusTransfer_protocolIEs,
        UplinkRANEarlyStatusTransfer,
        UplinkRANEarlyStatusTransferIEs,
        _UplinkRANEarlyStatusTransferIEs_val_Value_0,
        _UplinkRANEarlyStatusTransferIEs_val_Value_1,
        _UplinkRANEarlyStatusTransferIEs_val_Value_2,
        ____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab,
        _____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____DownlinkRANEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__id,
        ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__criticality,
        ___DownlinkRANEarlyStatusTransfer_protocolIEs__item__value,
        __DownlinkRANEarlyStatusTransfer_protocolIEs__item_,
        _DownlinkRANEarlyStatusTransfer_protocolIEs,
        DownlinkRANEarlyStatusTransfer,
        DownlinkRANEarlyStatusTransferIEs,
        _DownlinkRANEarlyStatusTransferIEs_val_Value_0,
        _DownlinkRANEarlyStatusTransferIEs_val_Value_1,
        _DownlinkRANEarlyStatusTransferIEs_val_Value_2,
        ____UplinkRANStatusTransfer_protocolIEs__item__id_tab,
        _____UplinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____UplinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___UplinkRANStatusTransfer_protocolIEs__item__id,
        ___UplinkRANStatusTransfer_protocolIEs__item__criticality,
        ___UplinkRANStatusTransfer_protocolIEs__item__value,
        __UplinkRANStatusTransfer_protocolIEs__item_,
        _UplinkRANStatusTransfer_protocolIEs,
        UplinkRANStatusTransfer,
        UplinkRANStatusTransferIEs,
        _UplinkRANStatusTransferIEs_val_Value_0,
        _UplinkRANStatusTransferIEs_val_Value_1,
        _UplinkRANStatusTransferIEs_val_Value_2,
        ____DownlinkRANStatusTransfer_protocolIEs__item__id_tab,
        _____DownlinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____DownlinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____DownlinkRANStatusTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___DownlinkRANStatusTransfer_protocolIEs__item__id,
        ___DownlinkRANStatusTransfer_protocolIEs__item__criticality,
        ___DownlinkRANStatusTransfer_protocolIEs__item__value,
        __DownlinkRANStatusTransfer_protocolIEs__item_,
        _DownlinkRANStatusTransfer_protocolIEs,
        DownlinkRANStatusTransfer,
        DownlinkRANStatusTransferIEs,
        _DownlinkRANStatusTransferIEs_val_Value_0,
        _DownlinkRANStatusTransferIEs_val_Value_1,
        _DownlinkRANStatusTransferIEs_val_Value_2,
        ____Paging_protocolIEs__item__id_tab,
        _____Paging_protocolIEs__item__id_tab_val_Value_0,
        _____Paging_protocolIEs__item__id_tab_val_Value_1,
        _____Paging_protocolIEs__item__id_tab_val_Value_2,
        _____Paging_protocolIEs__item__id_tab_val_Value_3,
        _____Paging_protocolIEs__item__id_tab_val_Value_4,
        _____Paging_protocolIEs__item__id_tab_val_Value_5,
        _____Paging_protocolIEs__item__id_tab_val_Value_6,
        _____Paging_protocolIEs__item__id_tab_val_Value_7,
        _____Paging_protocolIEs__item__id_tab_val_Value_8,
        _____Paging_protocolIEs__item__id_tab_val_Value_9,
        _____Paging_protocolIEs__item__id_tab_val_Value_10,
        _____Paging_protocolIEs__item__id_tab_val_Value_11,
        _____Paging_protocolIEs__item__id_tab_val_Value_12,
        _____Paging_protocolIEs__item__id_tab_val_Value_13,
        _____Paging_protocolIEs__item__id_tab_val_Value_14,
        _____Paging_protocolIEs__item__id_tab_val_Value_15,
        ___Paging_protocolIEs__item__id,
        ___Paging_protocolIEs__item__criticality,
        ___Paging_protocolIEs__item__value,
        __Paging_protocolIEs__item_,
        _Paging_protocolIEs,
        Paging,
        PagingIEs,
        _PagingIEs_val_Value_0,
        _PagingIEs_val_Value_1,
        _PagingIEs_val_Value_2,
        _PagingIEs_val_Value_3,
        _PagingIEs_val_Value_4,
        _PagingIEs_val_Value_5,
        _PagingIEs_val_Value_6,
        _PagingIEs_val_Value_7,
        _PagingIEs_val_Value_8,
        _PagingIEs_val_Value_9,
        _PagingIEs_val_Value_10,
        _PagingIEs_val_Value_11,
        _PagingIEs_val_Value_12,
        _PagingIEs_val_Value_13,
        _PagingIEs_val_Value_14,
        _PagingIEs_val_Value_15,
        ____InitialUEMessage_protocolIEs__item__id_tab,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_0,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_1,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_2,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_3,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_4,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_5,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_6,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_7,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_8,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_9,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_10,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_11,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_12,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_13,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_14,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_15,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_16,
        ___InitialUEMessage_protocolIEs__item__id,
        ___InitialUEMessage_protocolIEs__item__criticality,
        ___InitialUEMessage_protocolIEs__item__value,
        __InitialUEMessage_protocolIEs__item_,
        _InitialUEMessage_protocolIEs,
        InitialUEMessage,
        InitialUEMessage_IEs,
        _InitialUEMessage_IEs_val_Value_0,
        _InitialUEMessage_IEs_val_Value_1,
        _InitialUEMessage_IEs_val_Value_2,
        _InitialUEMessage_IEs_val_Value_3,
        _InitialUEMessage_IEs_val_Value_4,
        _InitialUEMessage_IEs_val_Value_5,
        _InitialUEMessage_IEs_val_Value_6,
        _InitialUEMessage_IEs_val_Value_7,
        _InitialUEMessage_IEs_val_Value_8,
        _InitialUEMessage_IEs_val_Value_9,
        _InitialUEMessage_IEs_val_Value_10,
        _InitialUEMessage_IEs_val_Value_11,
        _InitialUEMessage_IEs_val_Value_12,
        _InitialUEMessage_IEs_val_Value_13,
        _InitialUEMessage_IEs_val_Value_14,
        _InitialUEMessage_IEs_val_Value_15,
        _InitialUEMessage_IEs_val_Value_16,
        ____DownlinkNASTransport_protocolIEs__item__id_tab,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_0,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_1,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_2,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_3,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_4,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_5,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_6,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_7,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_8,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_9,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_10,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_11,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_12,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_13,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_14,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_15,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_16,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_17,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_18,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_19,
        ___DownlinkNASTransport_protocolIEs__item__id,
        ___DownlinkNASTransport_protocolIEs__item__criticality,
        ___DownlinkNASTransport_protocolIEs__item__value,
        __DownlinkNASTransport_protocolIEs__item_,
        _DownlinkNASTransport_protocolIEs,
        DownlinkNASTransport,
        DownlinkNASTransport_IEs,
        _DownlinkNASTransport_IEs_val_Value_0,
        _DownlinkNASTransport_IEs_val_Value_1,
        _DownlinkNASTransport_IEs_val_Value_2,
        _DownlinkNASTransport_IEs_val_Value_3,
        _DownlinkNASTransport_IEs_val_Value_4,
        _DownlinkNASTransport_IEs_val_Value_5,
        _DownlinkNASTransport_IEs_val_Value_6,
        _DownlinkNASTransport_IEs_val_Value_7,
        _DownlinkNASTransport_IEs_val_Value_8,
        _DownlinkNASTransport_IEs_val_Value_9,
        _DownlinkNASTransport_IEs_val_Value_10,
        _DownlinkNASTransport_IEs_val_Value_11,
        _DownlinkNASTransport_IEs_val_Value_12,
        _DownlinkNASTransport_IEs_val_Value_13,
        _DownlinkNASTransport_IEs_val_Value_14,
        _DownlinkNASTransport_IEs_val_Value_15,
        _DownlinkNASTransport_IEs_val_Value_16,
        _DownlinkNASTransport_IEs_val_Value_17,
        _DownlinkNASTransport_IEs_val_Value_18,
        _DownlinkNASTransport_IEs_val_Value_19,
        ____UplinkNASTransport_protocolIEs__item__id_tab,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_1,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_2,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_3,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_4,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_5,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_6,
        ___UplinkNASTransport_protocolIEs__item__id,
        ___UplinkNASTransport_protocolIEs__item__criticality,
        ___UplinkNASTransport_protocolIEs__item__value,
        __UplinkNASTransport_protocolIEs__item_,
        _UplinkNASTransport_protocolIEs,
        UplinkNASTransport,
        UplinkNASTransport_IEs,
        _UplinkNASTransport_IEs_val_Value_0,
        _UplinkNASTransport_IEs_val_Value_1,
        _UplinkNASTransport_IEs_val_Value_2,
        _UplinkNASTransport_IEs_val_Value_3,
        _UplinkNASTransport_IEs_val_Value_4,
        _UplinkNASTransport_IEs_val_Value_5,
        _UplinkNASTransport_IEs_val_Value_6,
        ____NASNonDeliveryIndication_protocolIEs__item__id_tab,
        _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_0,
        _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_1,
        _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_2,
        _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_3,
        ___NASNonDeliveryIndication_protocolIEs__item__id,
        ___NASNonDeliveryIndication_protocolIEs__item__criticality,
        ___NASNonDeliveryIndication_protocolIEs__item__value,
        __NASNonDeliveryIndication_protocolIEs__item_,
        _NASNonDeliveryIndication_protocolIEs,
        NASNonDeliveryIndication,
        NASNonDeliveryIndication_IEs,
        _NASNonDeliveryIndication_IEs_val_Value_0,
        _NASNonDeliveryIndication_IEs_val_Value_1,
        _NASNonDeliveryIndication_IEs_val_Value_2,
        _NASNonDeliveryIndication_IEs_val_Value_3,
        ____RerouteNASRequest_protocolIEs__item__id_tab,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_0,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_1,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_2,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_3,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_4,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_5,
        ___RerouteNASRequest_protocolIEs__item__id,
        ___RerouteNASRequest_protocolIEs__item__criticality,
        ___RerouteNASRequest_protocolIEs__item__value,
        __RerouteNASRequest_protocolIEs__item_,
        _RerouteNASRequest_protocolIEs,
        RerouteNASRequest,
        RerouteNASRequest_IEs,
        _RerouteNASRequest_IEs_val_Value_0,
        _RerouteNASRequest_IEs_val_Value_1,
        _RerouteNASRequest_IEs_val_Value_2,
        _RerouteNASRequest_IEs_val_Value_3,
        _RerouteNASRequest_IEs_val_Value_4,
        _RerouteNASRequest_IEs_val_Value_5,
        ____NGSetupRequest_protocolIEs__item__id_tab,
        _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_2,
        _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_3,
        _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_4,
        _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_5,
        _____NGSetupRequest_protocolIEs__item__id_tab_val_Value_6,
        ___NGSetupRequest_protocolIEs__item__id,
        ___NGSetupRequest_protocolIEs__item__criticality,
        ___NGSetupRequest_protocolIEs__item__value,
        __NGSetupRequest_protocolIEs__item_,
        _NGSetupRequest_protocolIEs,
        NGSetupRequest,
        NGSetupRequestIEs,
        _NGSetupRequestIEs_val_Value_0,
        _NGSetupRequestIEs_val_Value_1,
        _NGSetupRequestIEs_val_Value_2,
        _NGSetupRequestIEs_val_Value_3,
        _NGSetupRequestIEs_val_Value_4,
        _NGSetupRequestIEs_val_Value_5,
        _NGSetupRequestIEs_val_Value_6,
        ____NGSetupResponse_protocolIEs__item__id_tab,
        _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_3,
        _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_4,
        _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_5,
        _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_6,
        _____NGSetupResponse_protocolIEs__item__id_tab_val_Value_7,
        ___NGSetupResponse_protocolIEs__item__id,
        ___NGSetupResponse_protocolIEs__item__criticality,
        ___NGSetupResponse_protocolIEs__item__value,
        __NGSetupResponse_protocolIEs__item_,
        _NGSetupResponse_protocolIEs,
        NGSetupResponse,
        NGSetupResponseIEs,
        _NGSetupResponseIEs_val_Value_0,
        _NGSetupResponseIEs_val_Value_1,
        _NGSetupResponseIEs_val_Value_2,
        _NGSetupResponseIEs_val_Value_3,
        _NGSetupResponseIEs_val_Value_4,
        _NGSetupResponseIEs_val_Value_5,
        _NGSetupResponseIEs_val_Value_6,
        _NGSetupResponseIEs_val_Value_7,
        ____NGSetupFailure_protocolIEs__item__id_tab,
        _____NGSetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____NGSetupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____NGSetupFailure_protocolIEs__item__id_tab_val_Value_2,
        ___NGSetupFailure_protocolIEs__item__id,
        ___NGSetupFailure_protocolIEs__item__criticality,
        ___NGSetupFailure_protocolIEs__item__value,
        __NGSetupFailure_protocolIEs__item_,
        _NGSetupFailure_protocolIEs,
        NGSetupFailure,
        NGSetupFailureIEs,
        _NGSetupFailureIEs_val_Value_0,
        _NGSetupFailureIEs_val_Value_1,
        _NGSetupFailureIEs_val_Value_2,
        ____RANConfigurationUpdate_protocolIEs__item__id_tab,
        _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3,
        _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4,
        _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5,
        _____RANConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6,
        ___RANConfigurationUpdate_protocolIEs__item__id,
        ___RANConfigurationUpdate_protocolIEs__item__criticality,
        ___RANConfigurationUpdate_protocolIEs__item__value,
        __RANConfigurationUpdate_protocolIEs__item_,
        _RANConfigurationUpdate_protocolIEs,
        RANConfigurationUpdate,
        RANConfigurationUpdateIEs,
        _RANConfigurationUpdateIEs_val_Value_0,
        _RANConfigurationUpdateIEs_val_Value_1,
        _RANConfigurationUpdateIEs_val_Value_2,
        _RANConfigurationUpdateIEs_val_Value_3,
        _RANConfigurationUpdateIEs_val_Value_4,
        _RANConfigurationUpdateIEs_val_Value_5,
        _RANConfigurationUpdateIEs_val_Value_6,
        ____RANConfigurationUpdateAcknowledge_protocolIEs__item__id_tab,
        _____RANConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        ___RANConfigurationUpdateAcknowledge_protocolIEs__item__id,
        ___RANConfigurationUpdateAcknowledge_protocolIEs__item__criticality,
        ___RANConfigurationUpdateAcknowledge_protocolIEs__item__value,
        __RANConfigurationUpdateAcknowledge_protocolIEs__item_,
        _RANConfigurationUpdateAcknowledge_protocolIEs,
        RANConfigurationUpdateAcknowledge,
        RANConfigurationUpdateAcknowledgeIEs,
        _RANConfigurationUpdateAcknowledgeIEs_val_Value_0,
        ____RANConfigurationUpdateFailure_protocolIEs__item__id_tab,
        _____RANConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____RANConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____RANConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        ___RANConfigurationUpdateFailure_protocolIEs__item__id,
        ___RANConfigurationUpdateFailure_protocolIEs__item__criticality,
        ___RANConfigurationUpdateFailure_protocolIEs__item__value,
        __RANConfigurationUpdateFailure_protocolIEs__item_,
        _RANConfigurationUpdateFailure_protocolIEs,
        RANConfigurationUpdateFailure,
        RANConfigurationUpdateFailureIEs,
        _RANConfigurationUpdateFailureIEs_val_Value_0,
        _RANConfigurationUpdateFailureIEs_val_Value_1,
        _RANConfigurationUpdateFailureIEs_val_Value_2,
        ____AMFConfigurationUpdate_protocolIEs__item__id_tab,
        _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3,
        _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4,
        _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5,
        _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6,
        _____AMFConfigurationUpdate_protocolIEs__item__id_tab_val_Value_7,
        ___AMFConfigurationUpdate_protocolIEs__item__id,
        ___AMFConfigurationUpdate_protocolIEs__item__criticality,
        ___AMFConfigurationUpdate_protocolIEs__item__value,
        __AMFConfigurationUpdate_protocolIEs__item_,
        _AMFConfigurationUpdate_protocolIEs,
        AMFConfigurationUpdate,
        AMFConfigurationUpdateIEs,
        _AMFConfigurationUpdateIEs_val_Value_0,
        _AMFConfigurationUpdateIEs_val_Value_1,
        _AMFConfigurationUpdateIEs_val_Value_2,
        _AMFConfigurationUpdateIEs_val_Value_3,
        _AMFConfigurationUpdateIEs_val_Value_4,
        _AMFConfigurationUpdateIEs_val_Value_5,
        _AMFConfigurationUpdateIEs_val_Value_6,
        _AMFConfigurationUpdateIEs_val_Value_7,
        ____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab,
        _____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____AMFConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__id,
        ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__criticality,
        ___AMFConfigurationUpdateAcknowledge_protocolIEs__item__value,
        __AMFConfigurationUpdateAcknowledge_protocolIEs__item_,
        _AMFConfigurationUpdateAcknowledge_protocolIEs,
        AMFConfigurationUpdateAcknowledge,
        AMFConfigurationUpdateAcknowledgeIEs,
        _AMFConfigurationUpdateAcknowledgeIEs_val_Value_0,
        _AMFConfigurationUpdateAcknowledgeIEs_val_Value_1,
        _AMFConfigurationUpdateAcknowledgeIEs_val_Value_2,
        ____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab,
        _____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____AMFConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        ___AMFConfigurationUpdateFailure_protocolIEs__item__id,
        ___AMFConfigurationUpdateFailure_protocolIEs__item__criticality,
        ___AMFConfigurationUpdateFailure_protocolIEs__item__value,
        __AMFConfigurationUpdateFailure_protocolIEs__item_,
        _AMFConfigurationUpdateFailure_protocolIEs,
        AMFConfigurationUpdateFailure,
        AMFConfigurationUpdateFailureIEs,
        _AMFConfigurationUpdateFailureIEs_val_Value_0,
        _AMFConfigurationUpdateFailureIEs_val_Value_1,
        _AMFConfigurationUpdateFailureIEs_val_Value_2,
        ____AMFStatusIndication_protocolIEs__item__id_tab,
        _____AMFStatusIndication_protocolIEs__item__id_tab_val_Value_0,
        ___AMFStatusIndication_protocolIEs__item__id,
        ___AMFStatusIndication_protocolIEs__item__criticality,
        ___AMFStatusIndication_protocolIEs__item__value,
        __AMFStatusIndication_protocolIEs__item_,
        _AMFStatusIndication_protocolIEs,
        AMFStatusIndication,
        AMFStatusIndicationIEs,
        _AMFStatusIndicationIEs_val_Value_0,
        ____NGReset_protocolIEs__item__id_tab,
        _____NGReset_protocolIEs__item__id_tab_val_Value_0,
        _____NGReset_protocolIEs__item__id_tab_val_Value_1,
        ___NGReset_protocolIEs__item__id,
        ___NGReset_protocolIEs__item__criticality,
        ___NGReset_protocolIEs__item__value,
        __NGReset_protocolIEs__item_,
        _NGReset_protocolIEs,
        NGReset,
        NGResetIEs,
        _NGResetIEs_val_Value_0,
        _NGResetIEs_val_Value_1,
        ____NGResetAcknowledge_protocolIEs__item__id_tab,
        _____NGResetAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____NGResetAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        ___NGResetAcknowledge_protocolIEs__item__id,
        ___NGResetAcknowledge_protocolIEs__item__criticality,
        ___NGResetAcknowledge_protocolIEs__item__value,
        __NGResetAcknowledge_protocolIEs__item_,
        _NGResetAcknowledge_protocolIEs,
        NGResetAcknowledge,
        NGResetAcknowledgeIEs,
        _NGResetAcknowledgeIEs_val_Value_0,
        _NGResetAcknowledgeIEs_val_Value_1,
        ____ErrorIndication_protocolIEs__item__id_tab,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4,
        ___ErrorIndication_protocolIEs__item__id,
        ___ErrorIndication_protocolIEs__item__criticality,
        ___ErrorIndication_protocolIEs__item__value,
        __ErrorIndication_protocolIEs__item_,
        _ErrorIndication_protocolIEs,
        ErrorIndication,
        ErrorIndicationIEs,
        _ErrorIndicationIEs_val_Value_0,
        _ErrorIndicationIEs_val_Value_1,
        _ErrorIndicationIEs_val_Value_2,
        _ErrorIndicationIEs_val_Value_3,
        _ErrorIndicationIEs_val_Value_4,
        ____OverloadStart_protocolIEs__item__id_tab,
        _____OverloadStart_protocolIEs__item__id_tab_val_Value_0,
        _____OverloadStart_protocolIEs__item__id_tab_val_Value_1,
        _____OverloadStart_protocolIEs__item__id_tab_val_Value_2,
        ___OverloadStart_protocolIEs__item__id,
        ___OverloadStart_protocolIEs__item__criticality,
        ___OverloadStart_protocolIEs__item__value,
        __OverloadStart_protocolIEs__item_,
        _OverloadStart_protocolIEs,
        OverloadStart,
        OverloadStartIEs,
        _OverloadStartIEs_val_Value_0,
        _OverloadStartIEs_val_Value_1,
        _OverloadStartIEs_val_Value_2,
        ____OverloadStop_protocolIEs__item__id_tab,
        ___OverloadStop_protocolIEs__item__id,
        ____OverloadStop_protocolIEs__item__criticality_tab,
        ___OverloadStop_protocolIEs__item__criticality,
        ____OverloadStop_protocolIEs__item__value_tab,
        ___OverloadStop_protocolIEs__item__value,
        __OverloadStop_protocolIEs__item_,
        _OverloadStop_protocolIEs,
        OverloadStop,
        OverloadStopIEs,
        ____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab,
        _____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____UplinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___UplinkRANConfigurationTransfer_protocolIEs__item__id,
        ___UplinkRANConfigurationTransfer_protocolIEs__item__criticality,
        ___UplinkRANConfigurationTransfer_protocolIEs__item__value,
        __UplinkRANConfigurationTransfer_protocolIEs__item_,
        _UplinkRANConfigurationTransfer_protocolIEs,
        UplinkRANConfigurationTransfer,
        UplinkRANConfigurationTransferIEs,
        _UplinkRANConfigurationTransferIEs_val_Value_0,
        _UplinkRANConfigurationTransferIEs_val_Value_1,
        _UplinkRANConfigurationTransferIEs_val_Value_2,
        ____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab,
        _____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____DownlinkRANConfigurationTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___DownlinkRANConfigurationTransfer_protocolIEs__item__id,
        ___DownlinkRANConfigurationTransfer_protocolIEs__item__criticality,
        ___DownlinkRANConfigurationTransfer_protocolIEs__item__value,
        __DownlinkRANConfigurationTransfer_protocolIEs__item_,
        _DownlinkRANConfigurationTransfer_protocolIEs,
        DownlinkRANConfigurationTransfer,
        DownlinkRANConfigurationTransferIEs,
        _DownlinkRANConfigurationTransferIEs_val_Value_0,
        _DownlinkRANConfigurationTransferIEs_val_Value_1,
        _DownlinkRANConfigurationTransferIEs_val_Value_2,
        ____WriteReplaceWarningRequest_protocolIEs__item__id_tab,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_0,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_1,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_2,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_3,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_4,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_5,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_6,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_7,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_8,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_9,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_10,
        ___WriteReplaceWarningRequest_protocolIEs__item__id,
        ___WriteReplaceWarningRequest_protocolIEs__item__criticality,
        ___WriteReplaceWarningRequest_protocolIEs__item__value,
        __WriteReplaceWarningRequest_protocolIEs__item_,
        _WriteReplaceWarningRequest_protocolIEs,
        WriteReplaceWarningRequest,
        WriteReplaceWarningRequestIEs,
        _WriteReplaceWarningRequestIEs_val_Value_0,
        _WriteReplaceWarningRequestIEs_val_Value_1,
        _WriteReplaceWarningRequestIEs_val_Value_2,
        _WriteReplaceWarningRequestIEs_val_Value_3,
        _WriteReplaceWarningRequestIEs_val_Value_4,
        _WriteReplaceWarningRequestIEs_val_Value_5,
        _WriteReplaceWarningRequestIEs_val_Value_6,
        _WriteReplaceWarningRequestIEs_val_Value_7,
        _WriteReplaceWarningRequestIEs_val_Value_8,
        _WriteReplaceWarningRequestIEs_val_Value_9,
        _WriteReplaceWarningRequestIEs_val_Value_10,
        ____WriteReplaceWarningResponse_protocolIEs__item__id_tab,
        _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_0,
        _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_1,
        _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_2,
        _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_3,
        ___WriteReplaceWarningResponse_protocolIEs__item__id,
        ___WriteReplaceWarningResponse_protocolIEs__item__criticality,
        ___WriteReplaceWarningResponse_protocolIEs__item__value,
        __WriteReplaceWarningResponse_protocolIEs__item_,
        _WriteReplaceWarningResponse_protocolIEs,
        WriteReplaceWarningResponse,
        WriteReplaceWarningResponseIEs,
        _WriteReplaceWarningResponseIEs_val_Value_0,
        _WriteReplaceWarningResponseIEs_val_Value_1,
        _WriteReplaceWarningResponseIEs_val_Value_2,
        _WriteReplaceWarningResponseIEs_val_Value_3,
        ____PWSCancelRequest_protocolIEs__item__id_tab,
        _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_1,
        _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_2,
        _____PWSCancelRequest_protocolIEs__item__id_tab_val_Value_3,
        ___PWSCancelRequest_protocolIEs__item__id,
        ___PWSCancelRequest_protocolIEs__item__criticality,
        ___PWSCancelRequest_protocolIEs__item__value,
        __PWSCancelRequest_protocolIEs__item_,
        _PWSCancelRequest_protocolIEs,
        PWSCancelRequest,
        PWSCancelRequestIEs,
        _PWSCancelRequestIEs_val_Value_0,
        _PWSCancelRequestIEs_val_Value_1,
        _PWSCancelRequestIEs_val_Value_2,
        _PWSCancelRequestIEs_val_Value_3,
        ____PWSCancelResponse_protocolIEs__item__id_tab,
        _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_0,
        _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_1,
        _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_2,
        _____PWSCancelResponse_protocolIEs__item__id_tab_val_Value_3,
        ___PWSCancelResponse_protocolIEs__item__id,
        ___PWSCancelResponse_protocolIEs__item__criticality,
        ___PWSCancelResponse_protocolIEs__item__value,
        __PWSCancelResponse_protocolIEs__item_,
        _PWSCancelResponse_protocolIEs,
        PWSCancelResponse,
        PWSCancelResponseIEs,
        _PWSCancelResponseIEs_val_Value_0,
        _PWSCancelResponseIEs_val_Value_1,
        _PWSCancelResponseIEs_val_Value_2,
        _PWSCancelResponseIEs_val_Value_3,
        ____PWSRestartIndication_protocolIEs__item__id_tab,
        _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_0,
        _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_1,
        _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_2,
        _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_3,
        ___PWSRestartIndication_protocolIEs__item__id,
        ___PWSRestartIndication_protocolIEs__item__criticality,
        ___PWSRestartIndication_protocolIEs__item__value,
        __PWSRestartIndication_protocolIEs__item_,
        _PWSRestartIndication_protocolIEs,
        PWSRestartIndication,
        PWSRestartIndicationIEs,
        _PWSRestartIndicationIEs_val_Value_0,
        _PWSRestartIndicationIEs_val_Value_1,
        _PWSRestartIndicationIEs_val_Value_2,
        _PWSRestartIndicationIEs_val_Value_3,
        ____PWSFailureIndication_protocolIEs__item__id_tab,
        _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        ___PWSFailureIndication_protocolIEs__item__id,
        ___PWSFailureIndication_protocolIEs__item__criticality,
        ___PWSFailureIndication_protocolIEs__item__value,
        __PWSFailureIndication_protocolIEs__item_,
        _PWSFailureIndication_protocolIEs,
        PWSFailureIndication,
        PWSFailureIndicationIEs,
        _PWSFailureIndicationIEs_val_Value_0,
        _PWSFailureIndicationIEs_val_Value_1,
        ____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab,
        _____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_0,
        _____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_1,
        _____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_2,
        _____DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_3,
        ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__id,
        ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__criticality,
        ___DownlinkUEAssociatedNRPPaTransport_protocolIEs__item__value,
        __DownlinkUEAssociatedNRPPaTransport_protocolIEs__item_,
        _DownlinkUEAssociatedNRPPaTransport_protocolIEs,
        DownlinkUEAssociatedNRPPaTransport,
        DownlinkUEAssociatedNRPPaTransportIEs,
        _DownlinkUEAssociatedNRPPaTransportIEs_val_Value_0,
        _DownlinkUEAssociatedNRPPaTransportIEs_val_Value_1,
        _DownlinkUEAssociatedNRPPaTransportIEs_val_Value_2,
        _DownlinkUEAssociatedNRPPaTransportIEs_val_Value_3,
        ____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab,
        _____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_1,
        _____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_2,
        _____UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_3,
        ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__id,
        ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__criticality,
        ___UplinkUEAssociatedNRPPaTransport_protocolIEs__item__value,
        __UplinkUEAssociatedNRPPaTransport_protocolIEs__item_,
        _UplinkUEAssociatedNRPPaTransport_protocolIEs,
        UplinkUEAssociatedNRPPaTransport,
        UplinkUEAssociatedNRPPaTransportIEs,
        _UplinkUEAssociatedNRPPaTransportIEs_val_Value_0,
        _UplinkUEAssociatedNRPPaTransportIEs_val_Value_1,
        _UplinkUEAssociatedNRPPaTransportIEs_val_Value_2,
        _UplinkUEAssociatedNRPPaTransportIEs_val_Value_3,
        ____DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab,
        _____DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_0,
        _____DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_1,
        ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id,
        ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__criticality,
        ___DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item__value,
        __DownlinkNonUEAssociatedNRPPaTransport_protocolIEs__item_,
        _DownlinkNonUEAssociatedNRPPaTransport_protocolIEs,
        DownlinkNonUEAssociatedNRPPaTransport,
        DownlinkNonUEAssociatedNRPPaTransportIEs,
        _DownlinkNonUEAssociatedNRPPaTransportIEs_val_Value_0,
        _DownlinkNonUEAssociatedNRPPaTransportIEs_val_Value_1,
        ____UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab,
        _____UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id_tab_val_Value_1,
        ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__id,
        ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__criticality,
        ___UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item__value,
        __UplinkNonUEAssociatedNRPPaTransport_protocolIEs__item_,
        _UplinkNonUEAssociatedNRPPaTransport_protocolIEs,
        UplinkNonUEAssociatedNRPPaTransport,
        UplinkNonUEAssociatedNRPPaTransportIEs,
        _UplinkNonUEAssociatedNRPPaTransportIEs_val_Value_0,
        _UplinkNonUEAssociatedNRPPaTransportIEs_val_Value_1,
        ____TraceStart_protocolIEs__item__id_tab,
        _____TraceStart_protocolIEs__item__id_tab_val_Value_0,
        _____TraceStart_protocolIEs__item__id_tab_val_Value_1,
        _____TraceStart_protocolIEs__item__id_tab_val_Value_2,
        ___TraceStart_protocolIEs__item__id,
        ___TraceStart_protocolIEs__item__criticality,
        ___TraceStart_protocolIEs__item__value,
        __TraceStart_protocolIEs__item_,
        _TraceStart_protocolIEs,
        TraceStart,
        TraceStartIEs,
        _TraceStartIEs_val_Value_0,
        _TraceStartIEs_val_Value_1,
        _TraceStartIEs_val_Value_2,
        ____TraceFailureIndication_protocolIEs__item__id_tab,
        _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_2,
        _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_3,
        ___TraceFailureIndication_protocolIEs__item__id,
        ___TraceFailureIndication_protocolIEs__item__criticality,
        ___TraceFailureIndication_protocolIEs__item__value,
        __TraceFailureIndication_protocolIEs__item_,
        _TraceFailureIndication_protocolIEs,
        TraceFailureIndication,
        TraceFailureIndicationIEs,
        _TraceFailureIndicationIEs_val_Value_0,
        _TraceFailureIndicationIEs_val_Value_1,
        _TraceFailureIndicationIEs_val_Value_2,
        _TraceFailureIndicationIEs_val_Value_3,
        ____DeactivateTrace_protocolIEs__item__id_tab,
        _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_0,
        _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_1,
        _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_2,
        ___DeactivateTrace_protocolIEs__item__id,
        ___DeactivateTrace_protocolIEs__item__criticality,
        ___DeactivateTrace_protocolIEs__item__value,
        __DeactivateTrace_protocolIEs__item_,
        _DeactivateTrace_protocolIEs,
        DeactivateTrace,
        DeactivateTraceIEs,
        _DeactivateTraceIEs_val_Value_0,
        _DeactivateTraceIEs_val_Value_1,
        _DeactivateTraceIEs_val_Value_2,
        ____CellTrafficTrace_protocolIEs__item__id_tab,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_0,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_1,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_2,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_3,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_4,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_5,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_6,
        ___CellTrafficTrace_protocolIEs__item__id,
        ___CellTrafficTrace_protocolIEs__item__criticality,
        ___CellTrafficTrace_protocolIEs__item__value,
        __CellTrafficTrace_protocolIEs__item_,
        _CellTrafficTrace_protocolIEs,
        CellTrafficTrace,
        CellTrafficTraceIEs,
        _CellTrafficTraceIEs_val_Value_0,
        _CellTrafficTraceIEs_val_Value_1,
        _CellTrafficTraceIEs_val_Value_2,
        _CellTrafficTraceIEs_val_Value_3,
        _CellTrafficTraceIEs_val_Value_4,
        _CellTrafficTraceIEs_val_Value_5,
        _CellTrafficTraceIEs_val_Value_6,
        ____LocationReportingControl_protocolIEs__item__id_tab,
        _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_0,
        _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_1,
        _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_2,
        ___LocationReportingControl_protocolIEs__item__id,
        ___LocationReportingControl_protocolIEs__item__criticality,
        ___LocationReportingControl_protocolIEs__item__value,
        __LocationReportingControl_protocolIEs__item_,
        _LocationReportingControl_protocolIEs,
        LocationReportingControl,
        LocationReportingControlIEs,
        _LocationReportingControlIEs_val_Value_0,
        _LocationReportingControlIEs_val_Value_1,
        _LocationReportingControlIEs_val_Value_2,
        ____LocationReportingFailureIndication_protocolIEs__item__id_tab,
        _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_2,
        ___LocationReportingFailureIndication_protocolIEs__item__id,
        ___LocationReportingFailureIndication_protocolIEs__item__criticality,
        ___LocationReportingFailureIndication_protocolIEs__item__value,
        __LocationReportingFailureIndication_protocolIEs__item_,
        _LocationReportingFailureIndication_protocolIEs,
        LocationReportingFailureIndication,
        LocationReportingFailureIndicationIEs,
        _LocationReportingFailureIndicationIEs_val_Value_0,
        _LocationReportingFailureIndicationIEs_val_Value_1,
        _LocationReportingFailureIndicationIEs_val_Value_2,
        ____LocationReport_protocolIEs__item__id_tab,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_0,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_1,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_2,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_3,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_4,
        ___LocationReport_protocolIEs__item__id,
        ___LocationReport_protocolIEs__item__criticality,
        ___LocationReport_protocolIEs__item__value,
        __LocationReport_protocolIEs__item_,
        _LocationReport_protocolIEs,
        LocationReport,
        LocationReportIEs,
        _LocationReportIEs_val_Value_0,
        _LocationReportIEs_val_Value_1,
        _LocationReportIEs_val_Value_2,
        _LocationReportIEs_val_Value_3,
        _LocationReportIEs_val_Value_4,
        ____UETNLABindingReleaseRequest_protocolIEs__item__id_tab,
        _____UETNLABindingReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UETNLABindingReleaseRequest_protocolIEs__item__id_tab_val_Value_1,
        ___UETNLABindingReleaseRequest_protocolIEs__item__id,
        ___UETNLABindingReleaseRequest_protocolIEs__item__criticality,
        ___UETNLABindingReleaseRequest_protocolIEs__item__value,
        __UETNLABindingReleaseRequest_protocolIEs__item_,
        _UETNLABindingReleaseRequest_protocolIEs,
        UETNLABindingReleaseRequest,
        UETNLABindingReleaseRequestIEs,
        _UETNLABindingReleaseRequestIEs_val_Value_0,
        _UETNLABindingReleaseRequestIEs_val_Value_1,
        ____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab,
        _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_0,
        _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_1,
        _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_2,
        _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_3,
        _____UERadioCapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_4,
        ___UERadioCapabilityInfoIndication_protocolIEs__item__id,
        ___UERadioCapabilityInfoIndication_protocolIEs__item__criticality,
        ___UERadioCapabilityInfoIndication_protocolIEs__item__value,
        __UERadioCapabilityInfoIndication_protocolIEs__item_,
        _UERadioCapabilityInfoIndication_protocolIEs,
        UERadioCapabilityInfoIndication,
        UERadioCapabilityInfoIndicationIEs,
        _UERadioCapabilityInfoIndicationIEs_val_Value_0,
        _UERadioCapabilityInfoIndicationIEs_val_Value_1,
        _UERadioCapabilityInfoIndicationIEs_val_Value_2,
        _UERadioCapabilityInfoIndicationIEs_val_Value_3,
        _UERadioCapabilityInfoIndicationIEs_val_Value_4,
        ____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab,
        _____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UERadioCapabilityCheckRequest_protocolIEs__item__id_tab_val_Value_3,
        ___UERadioCapabilityCheckRequest_protocolIEs__item__id,
        ___UERadioCapabilityCheckRequest_protocolIEs__item__criticality,
        ___UERadioCapabilityCheckRequest_protocolIEs__item__value,
        __UERadioCapabilityCheckRequest_protocolIEs__item_,
        _UERadioCapabilityCheckRequest_protocolIEs,
        UERadioCapabilityCheckRequest,
        UERadioCapabilityCheckRequestIEs,
        _UERadioCapabilityCheckRequestIEs_val_Value_0,
        _UERadioCapabilityCheckRequestIEs_val_Value_1,
        _UERadioCapabilityCheckRequestIEs_val_Value_2,
        _UERadioCapabilityCheckRequestIEs_val_Value_3,
        ____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab,
        _____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab_val_Value_2,
        _____UERadioCapabilityCheckResponse_protocolIEs__item__id_tab_val_Value_3,
        ___UERadioCapabilityCheckResponse_protocolIEs__item__id,
        ___UERadioCapabilityCheckResponse_protocolIEs__item__criticality,
        ___UERadioCapabilityCheckResponse_protocolIEs__item__value,
        __UERadioCapabilityCheckResponse_protocolIEs__item_,
        _UERadioCapabilityCheckResponse_protocolIEs,
        UERadioCapabilityCheckResponse,
        UERadioCapabilityCheckResponseIEs,
        _UERadioCapabilityCheckResponseIEs_val_Value_0,
        _UERadioCapabilityCheckResponseIEs_val_Value_1,
        _UERadioCapabilityCheckResponseIEs_val_Value_2,
        _UERadioCapabilityCheckResponseIEs_val_Value_3,
        ____PrivateMessage_privateIEs__item__id_tab,
        ___PrivateMessage_privateIEs__item__id,
        ____PrivateMessage_privateIEs__item__criticality_tab,
        ___PrivateMessage_privateIEs__item__criticality,
        ____PrivateMessage_privateIEs__item__value_tab,
        ___PrivateMessage_privateIEs__item__value,
        __PrivateMessage_privateIEs__item_,
        _PrivateMessage_privateIEs,
        PrivateMessage,
        PrivateMessageIEs,
        ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab,
        _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_0,
        _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_1,
        _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_2,
        _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_3,
        _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_4,
        ___SecondaryRATDataUsageReport_protocolIEs__item__id,
        ___SecondaryRATDataUsageReport_protocolIEs__item__criticality,
        ___SecondaryRATDataUsageReport_protocolIEs__item__value,
        __SecondaryRATDataUsageReport_protocolIEs__item_,
        _SecondaryRATDataUsageReport_protocolIEs,
        SecondaryRATDataUsageReport,
        SecondaryRATDataUsageReportIEs,
        _SecondaryRATDataUsageReportIEs_val_Value_0,
        _SecondaryRATDataUsageReportIEs_val_Value_1,
        _SecondaryRATDataUsageReportIEs_val_Value_2,
        _SecondaryRATDataUsageReportIEs_val_Value_3,
        _SecondaryRATDataUsageReportIEs_val_Value_4,
        ____UplinkRIMInformationTransfer_protocolIEs__item__id_tab,
        _____UplinkRIMInformationTransfer_protocolIEs__item__id_tab_val_Value_0,
        ___UplinkRIMInformationTransfer_protocolIEs__item__id,
        ___UplinkRIMInformationTransfer_protocolIEs__item__criticality,
        ___UplinkRIMInformationTransfer_protocolIEs__item__value,
        __UplinkRIMInformationTransfer_protocolIEs__item_,
        _UplinkRIMInformationTransfer_protocolIEs,
        UplinkRIMInformationTransfer,
        UplinkRIMInformationTransferIEs,
        _UplinkRIMInformationTransferIEs_val_Value_0,
        ____DownlinkRIMInformationTransfer_protocolIEs__item__id_tab,
        _____DownlinkRIMInformationTransfer_protocolIEs__item__id_tab_val_Value_0,
        ___DownlinkRIMInformationTransfer_protocolIEs__item__id,
        ___DownlinkRIMInformationTransfer_protocolIEs__item__criticality,
        ___DownlinkRIMInformationTransfer_protocolIEs__item__value,
        __DownlinkRIMInformationTransfer_protocolIEs__item_,
        _DownlinkRIMInformationTransfer_protocolIEs,
        DownlinkRIMInformationTransfer,
        DownlinkRIMInformationTransferIEs,
        _DownlinkRIMInformationTransferIEs_val_Value_0,
        ____ConnectionEstablishmentIndication_protocolIEs__item__id_tab,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_1,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_2,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_3,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_4,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_5,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_6,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_7,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_8,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_9,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_10,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_11,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_12,
        ___ConnectionEstablishmentIndication_protocolIEs__item__id,
        ___ConnectionEstablishmentIndication_protocolIEs__item__criticality,
        ___ConnectionEstablishmentIndication_protocolIEs__item__value,
        __ConnectionEstablishmentIndication_protocolIEs__item_,
        _ConnectionEstablishmentIndication_protocolIEs,
        ConnectionEstablishmentIndication,
        ConnectionEstablishmentIndicationIEs,
        _ConnectionEstablishmentIndicationIEs_val_Value_0,
        _ConnectionEstablishmentIndicationIEs_val_Value_1,
        _ConnectionEstablishmentIndicationIEs_val_Value_2,
        _ConnectionEstablishmentIndicationIEs_val_Value_3,
        _ConnectionEstablishmentIndicationIEs_val_Value_4,
        _ConnectionEstablishmentIndicationIEs_val_Value_5,
        _ConnectionEstablishmentIndicationIEs_val_Value_6,
        _ConnectionEstablishmentIndicationIEs_val_Value_7,
        _ConnectionEstablishmentIndicationIEs_val_Value_8,
        _ConnectionEstablishmentIndicationIEs_val_Value_9,
        _ConnectionEstablishmentIndicationIEs_val_Value_10,
        _ConnectionEstablishmentIndicationIEs_val_Value_11,
        _ConnectionEstablishmentIndicationIEs_val_Value_12,
        ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab,
        _____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab_val_Value_0,
        ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id,
        ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality,
        ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value,
        __UERadioCapabilityIDMappingRequest_protocolIEs__item_,
        _UERadioCapabilityIDMappingRequest_protocolIEs,
        UERadioCapabilityIDMappingRequest,
        UERadioCapabilityIDMappingRequestIEs,
        _UERadioCapabilityIDMappingRequestIEs_val_Value_0,
        ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab,
        _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_2,
        ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id,
        ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality,
        ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value,
        __UERadioCapabilityIDMappingResponse_protocolIEs__item_,
        _UERadioCapabilityIDMappingResponse_protocolIEs,
        UERadioCapabilityIDMappingResponse,
        UERadioCapabilityIDMappingResponseIEs,
        _UERadioCapabilityIDMappingResponseIEs_val_Value_0,
        _UERadioCapabilityIDMappingResponseIEs_val_Value_1,
        _UERadioCapabilityIDMappingResponseIEs_val_Value_2,
        ____AMFCPRelocationIndication_protocolIEs__item__id_tab,
        _____AMFCPRelocationIndication_protocolIEs__item__id_tab_val_Value_0,
        _____AMFCPRelocationIndication_protocolIEs__item__id_tab_val_Value_1,
        _____AMFCPRelocationIndication_protocolIEs__item__id_tab_val_Value_2,
        _____AMFCPRelocationIndication_protocolIEs__item__id_tab_val_Value_3,
        ___AMFCPRelocationIndication_protocolIEs__item__id,
        ___AMFCPRelocationIndication_protocolIEs__item__criticality,
        ___AMFCPRelocationIndication_protocolIEs__item__value,
        __AMFCPRelocationIndication_protocolIEs__item_,
        _AMFCPRelocationIndication_protocolIEs,
        AMFCPRelocationIndication,
        AMFCPRelocationIndicationIEs,
        _AMFCPRelocationIndicationIEs_val_Value_0,
        _AMFCPRelocationIndicationIEs_val_Value_1,
        _AMFCPRelocationIndicationIEs_val_Value_2,
        _AMFCPRelocationIndicationIEs_val_Value_3,
        ____BroadcastSessionSetupRequest_protocolIEs__item__id_tab,
        _____BroadcastSessionSetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____BroadcastSessionSetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____BroadcastSessionSetupRequest_protocolIEs__item__id_tab_val_Value_2,
        ______BroadcastSessionSetupRequest_protocolIEs__item__id_tab_val_Value_3_contain,
        _____BroadcastSessionSetupRequest_protocolIEs__item__id_tab_val_Value_3,
        ___BroadcastSessionSetupRequest_protocolIEs__item__id,
        ___BroadcastSessionSetupRequest_protocolIEs__item__criticality,
        ___BroadcastSessionSetupRequest_protocolIEs__item__value,
        __BroadcastSessionSetupRequest_protocolIEs__item_,
        _BroadcastSessionSetupRequest_protocolIEs,
        BroadcastSessionSetupRequest,
        BroadcastSessionSetupRequestIEs,
        _BroadcastSessionSetupRequestIEs_val_Value_0,
        _BroadcastSessionSetupRequestIEs_val_Value_1,
        _BroadcastSessionSetupRequestIEs_val_Value_2,
        __BroadcastSessionSetupRequestIEs_val_Value_3_contain,
        _BroadcastSessionSetupRequestIEs_val_Value_3,
        ____BroadcastSessionSetupResponse_protocolIEs__item__id_tab,
        _____BroadcastSessionSetupResponse_protocolIEs__item__id_tab_val_Value_0,
        ______BroadcastSessionSetupResponse_protocolIEs__item__id_tab_val_Value_1_contain,
        _____BroadcastSessionSetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____BroadcastSessionSetupResponse_protocolIEs__item__id_tab_val_Value_2,
        ___BroadcastSessionSetupResponse_protocolIEs__item__id,
        ___BroadcastSessionSetupResponse_protocolIEs__item__criticality,
        ___BroadcastSessionSetupResponse_protocolIEs__item__value,
        __BroadcastSessionSetupResponse_protocolIEs__item_,
        _BroadcastSessionSetupResponse_protocolIEs,
        BroadcastSessionSetupResponse,
        BroadcastSessionSetupResponseIEs,
        _BroadcastSessionSetupResponseIEs_val_Value_0,
        __BroadcastSessionSetupResponseIEs_val_Value_1_contain,
        _BroadcastSessionSetupResponseIEs_val_Value_1,
        _BroadcastSessionSetupResponseIEs_val_Value_2,
        ____BroadcastSessionSetupFailure_protocolIEs__item__id_tab,
        _____BroadcastSessionSetupFailure_protocolIEs__item__id_tab_val_Value_0,
        ______BroadcastSessionSetupFailure_protocolIEs__item__id_tab_val_Value_1_contain,
        _____BroadcastSessionSetupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____BroadcastSessionSetupFailure_protocolIEs__item__id_tab_val_Value_2,
        _____BroadcastSessionSetupFailure_protocolIEs__item__id_tab_val_Value_3,
        ___BroadcastSessionSetupFailure_protocolIEs__item__id,
        ___BroadcastSessionSetupFailure_protocolIEs__item__criticality,
        ___BroadcastSessionSetupFailure_protocolIEs__item__value,
        __BroadcastSessionSetupFailure_protocolIEs__item_,
        _BroadcastSessionSetupFailure_protocolIEs,
        BroadcastSessionSetupFailure,
        BroadcastSessionSetupFailureIEs,
        _BroadcastSessionSetupFailureIEs_val_Value_0,
        __BroadcastSessionSetupFailureIEs_val_Value_1_contain,
        _BroadcastSessionSetupFailureIEs_val_Value_1,
        _BroadcastSessionSetupFailureIEs_val_Value_2,
        _BroadcastSessionSetupFailureIEs_val_Value_3,
        ____BroadcastSessionModificationRequest_protocolIEs__item__id_tab,
        _____BroadcastSessionModificationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____BroadcastSessionModificationRequest_protocolIEs__item__id_tab_val_Value_1,
        ______BroadcastSessionModificationRequest_protocolIEs__item__id_tab_val_Value_2_contain,
        _____BroadcastSessionModificationRequest_protocolIEs__item__id_tab_val_Value_2,
        ___BroadcastSessionModificationRequest_protocolIEs__item__id,
        ___BroadcastSessionModificationRequest_protocolIEs__item__criticality,
        ___BroadcastSessionModificationRequest_protocolIEs__item__value,
        __BroadcastSessionModificationRequest_protocolIEs__item_,
        _BroadcastSessionModificationRequest_protocolIEs,
        BroadcastSessionModificationRequest,
        BroadcastSessionModificationRequestIEs,
        _BroadcastSessionModificationRequestIEs_val_Value_0,
        _BroadcastSessionModificationRequestIEs_val_Value_1,
        __BroadcastSessionModificationRequestIEs_val_Value_2_contain,
        _BroadcastSessionModificationRequestIEs_val_Value_2,
        ____BroadcastSessionModificationResponse_protocolIEs__item__id_tab,
        _____BroadcastSessionModificationResponse_protocolIEs__item__id_tab_val_Value_0,
        ______BroadcastSessionModificationResponse_protocolIEs__item__id_tab_val_Value_1_contain,
        _____BroadcastSessionModificationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____BroadcastSessionModificationResponse_protocolIEs__item__id_tab_val_Value_2,
        ___BroadcastSessionModificationResponse_protocolIEs__item__id,
        ___BroadcastSessionModificationResponse_protocolIEs__item__criticality,
        ___BroadcastSessionModificationResponse_protocolIEs__item__value,
        __BroadcastSessionModificationResponse_protocolIEs__item_,
        _BroadcastSessionModificationResponse_protocolIEs,
        BroadcastSessionModificationResponse,
        BroadcastSessionModificationResponseIEs,
        _BroadcastSessionModificationResponseIEs_val_Value_0,
        __BroadcastSessionModificationResponseIEs_val_Value_1_contain,
        _BroadcastSessionModificationResponseIEs_val_Value_1,
        _BroadcastSessionModificationResponseIEs_val_Value_2,
        ____BroadcastSessionModificationFailure_protocolIEs__item__id_tab,
        _____BroadcastSessionModificationFailure_protocolIEs__item__id_tab_val_Value_0,
        ______BroadcastSessionModificationFailure_protocolIEs__item__id_tab_val_Value_1_contain,
        _____BroadcastSessionModificationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____BroadcastSessionModificationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____BroadcastSessionModificationFailure_protocolIEs__item__id_tab_val_Value_3,
        ___BroadcastSessionModificationFailure_protocolIEs__item__id,
        ___BroadcastSessionModificationFailure_protocolIEs__item__criticality,
        ___BroadcastSessionModificationFailure_protocolIEs__item__value,
        __BroadcastSessionModificationFailure_protocolIEs__item_,
        _BroadcastSessionModificationFailure_protocolIEs,
        BroadcastSessionModificationFailure,
        BroadcastSessionModificationFailureIEs,
        _BroadcastSessionModificationFailureIEs_val_Value_0,
        __BroadcastSessionModificationFailureIEs_val_Value_1_contain,
        _BroadcastSessionModificationFailureIEs_val_Value_1,
        _BroadcastSessionModificationFailureIEs_val_Value_2,
        _BroadcastSessionModificationFailureIEs_val_Value_3,
        ____BroadcastSessionReleaseRequest_protocolIEs__item__id_tab,
        _____BroadcastSessionReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        _____BroadcastSessionReleaseRequest_protocolIEs__item__id_tab_val_Value_1,
        ___BroadcastSessionReleaseRequest_protocolIEs__item__id,
        ___BroadcastSessionReleaseRequest_protocolIEs__item__criticality,
        ___BroadcastSessionReleaseRequest_protocolIEs__item__value,
        __BroadcastSessionReleaseRequest_protocolIEs__item_,
        _BroadcastSessionReleaseRequest_protocolIEs,
        BroadcastSessionReleaseRequest,
        BroadcastSessionReleaseRequestIEs,
        _BroadcastSessionReleaseRequestIEs_val_Value_0,
        _BroadcastSessionReleaseRequestIEs_val_Value_1,
        ____BroadcastSessionReleaseRequired_protocolIEs__item__id_tab,
        _____BroadcastSessionReleaseRequired_protocolIEs__item__id_tab_val_Value_0,
        _____BroadcastSessionReleaseRequired_protocolIEs__item__id_tab_val_Value_1,
        ___BroadcastSessionReleaseRequired_protocolIEs__item__id,
        ___BroadcastSessionReleaseRequired_protocolIEs__item__criticality,
        ___BroadcastSessionReleaseRequired_protocolIEs__item__value,
        __BroadcastSessionReleaseRequired_protocolIEs__item_,
        _BroadcastSessionReleaseRequired_protocolIEs,
        BroadcastSessionReleaseRequired,
        BroadcastSessionReleaseRequiredIEs,
        _BroadcastSessionReleaseRequiredIEs_val_Value_0,
        _BroadcastSessionReleaseRequiredIEs_val_Value_1,
        ____BroadcastSessionReleaseResponse_protocolIEs__item__id_tab,
        _____BroadcastSessionReleaseResponse_protocolIEs__item__id_tab_val_Value_0,
        ______BroadcastSessionReleaseResponse_protocolIEs__item__id_tab_val_Value_1_contain,
        _____BroadcastSessionReleaseResponse_protocolIEs__item__id_tab_val_Value_1,
        _____BroadcastSessionReleaseResponse_protocolIEs__item__id_tab_val_Value_2,
        ___BroadcastSessionReleaseResponse_protocolIEs__item__id,
        ___BroadcastSessionReleaseResponse_protocolIEs__item__criticality,
        ___BroadcastSessionReleaseResponse_protocolIEs__item__value,
        __BroadcastSessionReleaseResponse_protocolIEs__item_,
        _BroadcastSessionReleaseResponse_protocolIEs,
        BroadcastSessionReleaseResponse,
        BroadcastSessionReleaseResponseIEs,
        _BroadcastSessionReleaseResponseIEs_val_Value_0,
        __BroadcastSessionReleaseResponseIEs_val_Value_1_contain,
        _BroadcastSessionReleaseResponseIEs_val_Value_1,
        _BroadcastSessionReleaseResponseIEs_val_Value_2,
        ____DistributionSetupRequest_protocolIEs__item__id_tab,
        _____DistributionSetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____DistributionSetupRequest_protocolIEs__item__id_tab_val_Value_1,
        ______DistributionSetupRequest_protocolIEs__item__id_tab_val_Value_2_contain,
        _____DistributionSetupRequest_protocolIEs__item__id_tab_val_Value_2,
        ___DistributionSetupRequest_protocolIEs__item__id,
        ___DistributionSetupRequest_protocolIEs__item__criticality,
        ___DistributionSetupRequest_protocolIEs__item__value,
        __DistributionSetupRequest_protocolIEs__item_,
        _DistributionSetupRequest_protocolIEs,
        DistributionSetupRequest,
        DistributionSetupRequestIEs,
        _DistributionSetupRequestIEs_val_Value_0,
        _DistributionSetupRequestIEs_val_Value_1,
        __DistributionSetupRequestIEs_val_Value_2_contain,
        _DistributionSetupRequestIEs_val_Value_2,
        ____DistributionSetupResponse_protocolIEs__item__id_tab,
        _____DistributionSetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____DistributionSetupResponse_protocolIEs__item__id_tab_val_Value_1,
        ______DistributionSetupResponse_protocolIEs__item__id_tab_val_Value_2_contain,
        _____DistributionSetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____DistributionSetupResponse_protocolIEs__item__id_tab_val_Value_3,
        ___DistributionSetupResponse_protocolIEs__item__id,
        ___DistributionSetupResponse_protocolIEs__item__criticality,
        ___DistributionSetupResponse_protocolIEs__item__value,
        __DistributionSetupResponse_protocolIEs__item_,
        _DistributionSetupResponse_protocolIEs,
        DistributionSetupResponse,
        DistributionSetupResponseIEs,
        _DistributionSetupResponseIEs_val_Value_0,
        _DistributionSetupResponseIEs_val_Value_1,
        __DistributionSetupResponseIEs_val_Value_2_contain,
        _DistributionSetupResponseIEs_val_Value_2,
        _DistributionSetupResponseIEs_val_Value_3,
        ____DistributionSetupFailure_protocolIEs__item__id_tab,
        _____DistributionSetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____DistributionSetupFailure_protocolIEs__item__id_tab_val_Value_1,
        ______DistributionSetupFailure_protocolIEs__item__id_tab_val_Value_2_contain,
        _____DistributionSetupFailure_protocolIEs__item__id_tab_val_Value_2,
        _____DistributionSetupFailure_protocolIEs__item__id_tab_val_Value_3,
        _____DistributionSetupFailure_protocolIEs__item__id_tab_val_Value_4,
        ___DistributionSetupFailure_protocolIEs__item__id,
        ___DistributionSetupFailure_protocolIEs__item__criticality,
        ___DistributionSetupFailure_protocolIEs__item__value,
        __DistributionSetupFailure_protocolIEs__item_,
        _DistributionSetupFailure_protocolIEs,
        DistributionSetupFailure,
        DistributionSetupFailureIEs,
        _DistributionSetupFailureIEs_val_Value_0,
        _DistributionSetupFailureIEs_val_Value_1,
        __DistributionSetupFailureIEs_val_Value_2_contain,
        _DistributionSetupFailureIEs_val_Value_2,
        _DistributionSetupFailureIEs_val_Value_3,
        _DistributionSetupFailureIEs_val_Value_4,
        ____DistributionReleaseRequest_protocolIEs__item__id_tab,
        _____DistributionReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        _____DistributionReleaseRequest_protocolIEs__item__id_tab_val_Value_1,
        ______DistributionReleaseRequest_protocolIEs__item__id_tab_val_Value_2_contain,
        _____DistributionReleaseRequest_protocolIEs__item__id_tab_val_Value_2,
        _____DistributionReleaseRequest_protocolIEs__item__id_tab_val_Value_3,
        ___DistributionReleaseRequest_protocolIEs__item__id,
        ___DistributionReleaseRequest_protocolIEs__item__criticality,
        ___DistributionReleaseRequest_protocolIEs__item__value,
        __DistributionReleaseRequest_protocolIEs__item_,
        _DistributionReleaseRequest_protocolIEs,
        DistributionReleaseRequest,
        DistributionReleaseRequestIEs,
        _DistributionReleaseRequestIEs_val_Value_0,
        _DistributionReleaseRequestIEs_val_Value_1,
        __DistributionReleaseRequestIEs_val_Value_2_contain,
        _DistributionReleaseRequestIEs_val_Value_2,
        _DistributionReleaseRequestIEs_val_Value_3,
        ____DistributionReleaseResponse_protocolIEs__item__id_tab,
        _____DistributionReleaseResponse_protocolIEs__item__id_tab_val_Value_0,
        _____DistributionReleaseResponse_protocolIEs__item__id_tab_val_Value_1,
        _____DistributionReleaseResponse_protocolIEs__item__id_tab_val_Value_2,
        ___DistributionReleaseResponse_protocolIEs__item__id,
        ___DistributionReleaseResponse_protocolIEs__item__criticality,
        ___DistributionReleaseResponse_protocolIEs__item__value,
        __DistributionReleaseResponse_protocolIEs__item_,
        _DistributionReleaseResponse_protocolIEs,
        DistributionReleaseResponse,
        DistributionReleaseResponseIEs,
        _DistributionReleaseResponseIEs_val_Value_0,
        _DistributionReleaseResponseIEs_val_Value_1,
        _DistributionReleaseResponseIEs_val_Value_2,
        ____MulticastSessionActivationRequest_protocolIEs__item__id_tab,
        _____MulticastSessionActivationRequest_protocolIEs__item__id_tab_val_Value_0,
        ______MulticastSessionActivationRequest_protocolIEs__item__id_tab_val_Value_1_contain,
        _____MulticastSessionActivationRequest_protocolIEs__item__id_tab_val_Value_1,
        ___MulticastSessionActivationRequest_protocolIEs__item__id,
        ___MulticastSessionActivationRequest_protocolIEs__item__criticality,
        ___MulticastSessionActivationRequest_protocolIEs__item__value,
        __MulticastSessionActivationRequest_protocolIEs__item_,
        _MulticastSessionActivationRequest_protocolIEs,
        MulticastSessionActivationRequest,
        MulticastSessionActivationRequestIEs,
        _MulticastSessionActivationRequestIEs_val_Value_0,
        __MulticastSessionActivationRequestIEs_val_Value_1_contain,
        _MulticastSessionActivationRequestIEs_val_Value_1,
        ____MulticastSessionActivationResponse_protocolIEs__item__id_tab,
        _____MulticastSessionActivationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____MulticastSessionActivationResponse_protocolIEs__item__id_tab_val_Value_1,
        ___MulticastSessionActivationResponse_protocolIEs__item__id,
        ___MulticastSessionActivationResponse_protocolIEs__item__criticality,
        ___MulticastSessionActivationResponse_protocolIEs__item__value,
        __MulticastSessionActivationResponse_protocolIEs__item_,
        _MulticastSessionActivationResponse_protocolIEs,
        MulticastSessionActivationResponse,
        MulticastSessionActivationResponseIEs,
        _MulticastSessionActivationResponseIEs_val_Value_0,
        _MulticastSessionActivationResponseIEs_val_Value_1,
        ____MulticastSessionActivationFailure_protocolIEs__item__id_tab,
        _____MulticastSessionActivationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____MulticastSessionActivationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____MulticastSessionActivationFailure_protocolIEs__item__id_tab_val_Value_2,
        ___MulticastSessionActivationFailure_protocolIEs__item__id,
        ___MulticastSessionActivationFailure_protocolIEs__item__criticality,
        ___MulticastSessionActivationFailure_protocolIEs__item__value,
        __MulticastSessionActivationFailure_protocolIEs__item_,
        _MulticastSessionActivationFailure_protocolIEs,
        MulticastSessionActivationFailure,
        MulticastSessionActivationFailureIEs,
        _MulticastSessionActivationFailureIEs_val_Value_0,
        _MulticastSessionActivationFailureIEs_val_Value_1,
        _MulticastSessionActivationFailureIEs_val_Value_2,
        ____MulticastSessionDeactivationRequest_protocolIEs__item__id_tab,
        _____MulticastSessionDeactivationRequest_protocolIEs__item__id_tab_val_Value_0,
        ______MulticastSessionDeactivationRequest_protocolIEs__item__id_tab_val_Value_1_contain,
        _____MulticastSessionDeactivationRequest_protocolIEs__item__id_tab_val_Value_1,
        ___MulticastSessionDeactivationRequest_protocolIEs__item__id,
        ___MulticastSessionDeactivationRequest_protocolIEs__item__criticality,
        ___MulticastSessionDeactivationRequest_protocolIEs__item__value,
        __MulticastSessionDeactivationRequest_protocolIEs__item_,
        _MulticastSessionDeactivationRequest_protocolIEs,
        MulticastSessionDeactivationRequest,
        MulticastSessionDeactivationRequestIEs,
        _MulticastSessionDeactivationRequestIEs_val_Value_0,
        __MulticastSessionDeactivationRequestIEs_val_Value_1_contain,
        _MulticastSessionDeactivationRequestIEs_val_Value_1,
        ____MulticastSessionDeactivationResponse_protocolIEs__item__id_tab,
        _____MulticastSessionDeactivationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____MulticastSessionDeactivationResponse_protocolIEs__item__id_tab_val_Value_1,
        ___MulticastSessionDeactivationResponse_protocolIEs__item__id,
        ___MulticastSessionDeactivationResponse_protocolIEs__item__criticality,
        ___MulticastSessionDeactivationResponse_protocolIEs__item__value,
        __MulticastSessionDeactivationResponse_protocolIEs__item_,
        _MulticastSessionDeactivationResponse_protocolIEs,
        MulticastSessionDeactivationResponse,
        MulticastSessionDeactivationResponseIEs,
        _MulticastSessionDeactivationResponseIEs_val_Value_0,
        _MulticastSessionDeactivationResponseIEs_val_Value_1,
        ____MulticastSessionUpdateRequest_protocolIEs__item__id_tab,
        _____MulticastSessionUpdateRequest_protocolIEs__item__id_tab_val_Value_0,
        _____MulticastSessionUpdateRequest_protocolIEs__item__id_tab_val_Value_1,
        ______MulticastSessionUpdateRequest_protocolIEs__item__id_tab_val_Value_2_contain,
        _____MulticastSessionUpdateRequest_protocolIEs__item__id_tab_val_Value_2,
        ___MulticastSessionUpdateRequest_protocolIEs__item__id,
        ___MulticastSessionUpdateRequest_protocolIEs__item__criticality,
        ___MulticastSessionUpdateRequest_protocolIEs__item__value,
        __MulticastSessionUpdateRequest_protocolIEs__item_,
        _MulticastSessionUpdateRequest_protocolIEs,
        MulticastSessionUpdateRequest,
        MulticastSessionUpdateRequestIEs,
        _MulticastSessionUpdateRequestIEs_val_Value_0,
        _MulticastSessionUpdateRequestIEs_val_Value_1,
        __MulticastSessionUpdateRequestIEs_val_Value_2_contain,
        _MulticastSessionUpdateRequestIEs_val_Value_2,
        ____MulticastSessionUpdateResponse_protocolIEs__item__id_tab,
        _____MulticastSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_0,
        _____MulticastSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_1,
        _____MulticastSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_2,
        ___MulticastSessionUpdateResponse_protocolIEs__item__id,
        ___MulticastSessionUpdateResponse_protocolIEs__item__criticality,
        ___MulticastSessionUpdateResponse_protocolIEs__item__value,
        __MulticastSessionUpdateResponse_protocolIEs__item_,
        _MulticastSessionUpdateResponse_protocolIEs,
        MulticastSessionUpdateResponse,
        MulticastSessionUpdateResponseIEs,
        _MulticastSessionUpdateResponseIEs_val_Value_0,
        _MulticastSessionUpdateResponseIEs_val_Value_1,
        _MulticastSessionUpdateResponseIEs_val_Value_2,
        ____MulticastSessionUpdateFailure_protocolIEs__item__id_tab,
        _____MulticastSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____MulticastSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____MulticastSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        _____MulticastSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_3,
        ___MulticastSessionUpdateFailure_protocolIEs__item__id,
        ___MulticastSessionUpdateFailure_protocolIEs__item__criticality,
        ___MulticastSessionUpdateFailure_protocolIEs__item__value,
        __MulticastSessionUpdateFailure_protocolIEs__item_,
        _MulticastSessionUpdateFailure_protocolIEs,
        MulticastSessionUpdateFailure,
        MulticastSessionUpdateFailureIEs,
        _MulticastSessionUpdateFailureIEs_val_Value_0,
        _MulticastSessionUpdateFailureIEs_val_Value_1,
        _MulticastSessionUpdateFailureIEs_val_Value_2,
        _MulticastSessionUpdateFailureIEs_val_Value_3,
        ____MulticastGroupPaging_protocolIEs__item__id_tab,
        _____MulticastGroupPaging_protocolIEs__item__id_tab_val_Value_0,
        _____MulticastGroupPaging_protocolIEs__item__id_tab_val_Value_1,
        _____MulticastGroupPaging_protocolIEs__item__id_tab_val_Value_2,
        ___MulticastGroupPaging_protocolIEs__item__id,
        ___MulticastGroupPaging_protocolIEs__item__criticality,
        ___MulticastGroupPaging_protocolIEs__item__value,
        __MulticastGroupPaging_protocolIEs__item_,
        _MulticastGroupPaging_protocolIEs,
        MulticastGroupPaging,
        MulticastGroupPagingIEs,
        _MulticastGroupPagingIEs_val_Value_0,
        _MulticastGroupPagingIEs_val_Value_1,
        _MulticastGroupPagingIEs_val_Value_2,
    ]

class NGAP_PDU_Descriptions:

    _name_  = 'NGAP-PDU-Descriptions'
    _oid_   = [0, 4, 0, 0, 22, 3, 1, 1, 0]
    
    _obj_ = [
        'NGAP-ELEMENTARY-PROCEDURE',
        'NGAP-PDU',
        'InitiatingMessage',
        'SuccessfulOutcome',
        'UnsuccessfulOutcome',
        'NGAP-ELEMENTARY-PROCEDURES',
        'NGAP-ELEMENTARY-PROCEDURES-CLASS-1',
        'NGAP-ELEMENTARY-PROCEDURES-CLASS-2',
        'aMFConfigurationUpdate',
        'aMFCPRelocationIndication',
        'aMFStatusIndication',
        'broadcastSessionModification',
        'broadcastSessionRelease',
        'broadcastSessionReleaseRequired',
        'broadcastSessionSetup',
        'cellTrafficTrace',
        'connectionEstablishmentIndication',
        'deactivateTrace',
        'distributionSetup',
        'distributionRelease',
        'downlinkNASTransport',
        'downlinkNonUEAssociatedNRPPaTransport',
        'downlinkRANConfigurationTransfer',
        'downlinkRANEarlyStatusTransfer',
        'downlinkRANStatusTransfer',
        'downlinkUEAssociatedNRPPaTransport',
        'errorIndication',
        'handoverCancel',
        'handoverNotification',
        'handoverPreparation',
        'handoverResourceAllocation',
        'handoverSuccess',
        'initialContextSetup',
        'initialUEMessage',
        'locationReport',
        'locationReportingControl',
        'locationReportingFailureIndication',
        'multicastSessionActivation',
        'multicastSessionDeactivation',
        'multicastSessionUpdate',
        'multicastGroupPaging',
        'nASNonDeliveryIndication',
        'nGReset',
        'nGSetup',
        'overloadStart',
        'overloadStop',
        'paging',
        'pathSwitchRequest',
        'pDUSessionResourceModify',
        'pDUSessionResourceModifyIndication',
        'pDUSessionResourceNotify',
        'pDUSessionResourceRelease',
        'pDUSessionResourceSetup',
        'privateMessage',
        'pWSCancel',
        'pWSFailureIndication',
        'pWSRestartIndication',
        'rANConfigurationUpdate',
        'rANCPRelocationIndication',
        'rerouteNASRequest',
        'retrieveUEInformation',
        'rRCInactiveTransitionReport',
        'secondaryRATDataUsageReport',
        'traceFailureIndication',
        'traceStart',
        'uEContextModification',
        'uEContextRelease',
        'uEContextReleaseRequest',
        'uEContextResume',
        'uEContextSuspend',
        'uEInformationTransfer',
        'uERadioCapabilityCheck',
        'uERadioCapabilityIDMapping',
        'uERadioCapabilityInfoIndication',
        'uETNLABindingRelease',
        'uplinkNASTransport',
        'uplinkNonUEAssociatedNRPPaTransport',
        'uplinkRANConfigurationTransfer',
        'uplinkRANEarlyStatusTransfer',
        'uplinkRANStatusTransfer',
        'uplinkUEAssociatedNRPPaTransport',
        'writeReplaceWarning',
        'uplinkRIMInformationTransfer',
        'downlinkRIMInformationTransfer',
        ]
    _type_ = [
        'NGAP-ELEMENTARY-PROCEDURE',
        'NGAP-PDU',
        'InitiatingMessage',
        'SuccessfulOutcome',
        'UnsuccessfulOutcome',
        ]
    _set_ = [
        'NGAP-ELEMENTARY-PROCEDURES',
        'NGAP-ELEMENTARY-PROCEDURES-CLASS-1',
        'NGAP-ELEMENTARY-PROCEDURES-CLASS-2',
        ]
    _val_ = [
        'aMFConfigurationUpdate',
        'aMFCPRelocationIndication',
        'aMFStatusIndication',
        'broadcastSessionModification',
        'broadcastSessionRelease',
        'broadcastSessionReleaseRequired',
        'broadcastSessionSetup',
        'cellTrafficTrace',
        'connectionEstablishmentIndication',
        'deactivateTrace',
        'distributionSetup',
        'distributionRelease',
        'downlinkNASTransport',
        'downlinkNonUEAssociatedNRPPaTransport',
        'downlinkRANConfigurationTransfer',
        'downlinkRANEarlyStatusTransfer',
        'downlinkRANStatusTransfer',
        'downlinkUEAssociatedNRPPaTransport',
        'errorIndication',
        'handoverCancel',
        'handoverNotification',
        'handoverPreparation',
        'handoverResourceAllocation',
        'handoverSuccess',
        'initialContextSetup',
        'initialUEMessage',
        'locationReport',
        'locationReportingControl',
        'locationReportingFailureIndication',
        'multicastSessionActivation',
        'multicastSessionDeactivation',
        'multicastSessionUpdate',
        'multicastGroupPaging',
        'nASNonDeliveryIndication',
        'nGReset',
        'nGSetup',
        'overloadStart',
        'overloadStop',
        'paging',
        'pathSwitchRequest',
        'pDUSessionResourceModify',
        'pDUSessionResourceModifyIndication',
        'pDUSessionResourceNotify',
        'pDUSessionResourceRelease',
        'pDUSessionResourceSetup',
        'privateMessage',
        'pWSCancel',
        'pWSFailureIndication',
        'pWSRestartIndication',
        'rANConfigurationUpdate',
        'rANCPRelocationIndication',
        'rerouteNASRequest',
        'retrieveUEInformation',
        'rRCInactiveTransitionReport',
        'secondaryRATDataUsageReport',
        'traceFailureIndication',
        'traceStart',
        'uEContextModification',
        'uEContextRelease',
        'uEContextReleaseRequest',
        'uEContextResume',
        'uEContextSuspend',
        'uEInformationTransfer',
        'uERadioCapabilityCheck',
        'uERadioCapabilityIDMapping',
        'uERadioCapabilityInfoIndication',
        'uETNLABindingRelease',
        'uplinkNASTransport',
        'uplinkNonUEAssociatedNRPPaTransport',
        'uplinkRANConfigurationTransfer',
        'uplinkRANEarlyStatusTransfer',
        'uplinkRANStatusTransfer',
        'uplinkUEAssociatedNRPPaTransport',
        'writeReplaceWarning',
        'uplinkRIMInformationTransfer',
        'downlinkRIMInformationTransfer',
        ]
    _class_ = [
        'NGAP-ELEMENTARY-PROCEDURE',
        'NGAP-ELEMENTARY-PROCEDURES',
        'NGAP-ELEMENTARY-PROCEDURES-CLASS-1',
        'NGAP-ELEMENTARY-PROCEDURES-CLASS-2',
        'aMFConfigurationUpdate',
        'aMFCPRelocationIndication',
        'aMFStatusIndication',
        'broadcastSessionModification',
        'broadcastSessionRelease',
        'broadcastSessionReleaseRequired',
        'broadcastSessionSetup',
        'cellTrafficTrace',
        'connectionEstablishmentIndication',
        'deactivateTrace',
        'distributionSetup',
        'distributionRelease',
        'downlinkNASTransport',
        'downlinkNonUEAssociatedNRPPaTransport',
        'downlinkRANConfigurationTransfer',
        'downlinkRANEarlyStatusTransfer',
        'downlinkRANStatusTransfer',
        'downlinkUEAssociatedNRPPaTransport',
        'errorIndication',
        'handoverCancel',
        'handoverNotification',
        'handoverPreparation',
        'handoverResourceAllocation',
        'handoverSuccess',
        'initialContextSetup',
        'initialUEMessage',
        'locationReport',
        'locationReportingControl',
        'locationReportingFailureIndication',
        'multicastSessionActivation',
        'multicastSessionDeactivation',
        'multicastSessionUpdate',
        'multicastGroupPaging',
        'nASNonDeliveryIndication',
        'nGReset',
        'nGSetup',
        'overloadStart',
        'overloadStop',
        'paging',
        'pathSwitchRequest',
        'pDUSessionResourceModify',
        'pDUSessionResourceModifyIndication',
        'pDUSessionResourceNotify',
        'pDUSessionResourceRelease',
        'pDUSessionResourceSetup',
        'privateMessage',
        'pWSCancel',
        'pWSFailureIndication',
        'pWSRestartIndication',
        'rANConfigurationUpdate',
        'rANCPRelocationIndication',
        'rerouteNASRequest',
        'retrieveUEInformation',
        'rRCInactiveTransitionReport',
        'secondaryRATDataUsageReport',
        'traceFailureIndication',
        'traceStart',
        'uEContextModification',
        'uEContextRelease',
        'uEContextReleaseRequest',
        'uEContextResume',
        'uEContextSuspend',
        'uEInformationTransfer',
        'uERadioCapabilityCheck',
        'uERadioCapabilityIDMapping',
        'uERadioCapabilityInfoIndication',
        'uETNLABindingRelease',
        'uplinkNASTransport',
        'uplinkNonUEAssociatedNRPPaTransport',
        'uplinkRANConfigurationTransfer',
        'uplinkRANEarlyStatusTransfer',
        'uplinkRANStatusTransfer',
        'uplinkUEAssociatedNRPPaTransport',
        'writeReplaceWarning',
        'uplinkRIMInformationTransfer',
        'downlinkRIMInformationTransfer',
        ]
    _param_ = [
        ]
    
    #-----< NGAP-ELEMENTARY-PROCEDURE >-----#
    NGAP_ELEMENTARY_PROCEDURE = CLASS(name='NGAP-ELEMENTARY-PROCEDURE', mode=MODE_TYPE)
    _NGAP_ELEMENTARY_PROCEDURE_InitiatingMessage = OPEN(name='InitiatingMessage', mode=MODE_TYPE)
    _NGAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome = OPEN(name='SuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _NGAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome = OPEN(name='UnsuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _NGAP_ELEMENTARY_PROCEDURE_procedureCode = INT(name='procedureCode', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'ProcedureCode')), uniq=True)
    _NGAP_ELEMENTARY_PROCEDURE_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-CommonDataTypes', 'Criticality')), default='ignore')
    NGAP_ELEMENTARY_PROCEDURE._cont = ASN1Dict([
        ('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURE_InitiatingMessage),
        ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome),
        ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome),
        ('procedureCode', _NGAP_ELEMENTARY_PROCEDURE_procedureCode),
        ('criticality', _NGAP_ELEMENTARY_PROCEDURE_criticality),
        ])
    
    #-----< NGAP-PDU >-----#
    NGAP_PDU = CHOICE(name='NGAP-PDU', mode=MODE_TYPE)
    _NGAP_PDU_initiatingMessage = SEQ(name='initiatingMessage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'InitiatingMessage')))
    _NGAP_PDU_successfulOutcome = SEQ(name='successfulOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'SuccessfulOutcome')))
    _NGAP_PDU_unsuccessfulOutcome = SEQ(name='unsuccessfulOutcome', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'UnsuccessfulOutcome')))
    NGAP_PDU._cont = ASN1Dict([
        ('initiatingMessage', _NGAP_PDU_initiatingMessage),
        ('successfulOutcome', _NGAP_PDU_successfulOutcome),
        ('unsuccessfulOutcome', _NGAP_PDU_unsuccessfulOutcome),
        ])
    NGAP_PDU._ext = []
    
    #-----< InitiatingMessage >-----#
    InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE)
    _InitiatingMessage_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __InitiatingMessage_procedureCode_tab = CLASS(name='_tab_NGAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdateAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionModificationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionModificationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionModificationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionReleaseRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionReleaseResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionSetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionSetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionSetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionSetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionSetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionSetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionReleaseRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionReleaseResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCancel')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCancelAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequired')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCommand')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverPreparationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequestAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_8 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_9 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionActivationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionActivationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionActivationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionDeactivationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionDeactivationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionUpdateRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionUpdateResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGReset')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGResetAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_14 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequestAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_15 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequestFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyIndication')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceReleaseCommand')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceReleaseResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceSetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceSetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSCancelRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_20 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSCancelResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_21 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdateAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_21 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_22 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_22 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseCommand')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_23 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseComplete')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_24 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_24 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_25 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_25 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityCheckRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_26 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityCheckResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_27 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'WriteReplaceWarningRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_28 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'WriteReplaceWarningResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFCPRelocationIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFStatusIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionReleaseRequired')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'CellTrafficTrace')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'ConnectionEstablishmentIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DeactivateTrace')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkNASTransport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkNonUEAssociatedNRPPaTransport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANConfigurationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANEarlyStatusTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANStatusTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRIMInformationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkUEAssociatedNRPPaTransport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'ErrorIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverNotify')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverSuccess')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialUEMessage')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReportingControl')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReportingFailureIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_49 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastGroupPaging')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_50 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NASNonDeliveryIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_51 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'OverloadStart')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_52 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'OverloadStop')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_53 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'Paging')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_54 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceNotify')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_55 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PrivateMessage')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_56 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSFailureIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_57 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSRestartIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_58 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANCPRelocationIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_59 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RerouteNASRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_60 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RetrieveUEInformation')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_61 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RRCInactiveTransitionReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_62 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_63 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'TraceFailureIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_64 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'TraceStart')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_65 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_66 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEInformationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_67 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityInfoIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_68 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UETNLABindingReleaseRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_69 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkNASTransport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_70 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkNonUEAssociatedNRPPaTransport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_71 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANConfigurationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_72 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANEarlyStatusTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_73 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANStatusTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_74 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRIMInformationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_75 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkUEAssociatedNRPPaTransport')))
    __InitiatingMessage_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0), ('procedureCode', 0), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 66), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2), ('procedureCode', 67), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3), ('procedureCode', 68), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4), ('procedureCode', 69), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5), ('procedureCode', 70), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6), ('procedureCode', 10), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7), ('procedureCode', 12), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_8), ('procedureCode', 13), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_9), ('procedureCode', 14), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_10), ('procedureCode', 71), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11), ('procedureCode', 72), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_12), ('procedureCode', 73), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_13), ('procedureCode', 20), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_14), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_14), ('procedureCode', 21), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_15), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_15), ('procedureCode', 25), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_16), ('procedureCode', 26), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_17), ('procedureCode', 27), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_18), ('procedureCode', 28), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_19), ('procedureCode', 29), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_20), ('procedureCode', 32), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_21), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_21), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_22), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_22), ('procedureCode', 40), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_23), ('procedureCode', 41), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_24), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_24), ('procedureCode', 58), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_25), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_25), ('procedureCode', 59), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_26), ('procedureCode', 43), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_27), ('procedureCode', 60), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_28), ('procedureCode', 51), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29), ('procedureCode', 64), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30), ('procedureCode', 1), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31), ('procedureCode', 75), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33), ('procedureCode', 65), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37), ('procedureCode', 6), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38), ('procedureCode', 63), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39), ('procedureCode', 7), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40), ('procedureCode', 54), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41), ('procedureCode', 8), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42), ('procedureCode', 9), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44), ('procedureCode', 61), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47), ('procedureCode', 16), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48), ('procedureCode', 17), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_49), ('procedureCode', 74), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_50), ('procedureCode', 19), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_51), ('procedureCode', 22), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_52), ('procedureCode', 23), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_53), ('procedureCode', 24), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_54), ('procedureCode', 30), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_55), ('procedureCode', 31), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_56), ('procedureCode', 33), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_57), ('procedureCode', 34), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_58), ('procedureCode', 57), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_59), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_60), ('procedureCode', 55), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_61), ('procedureCode', 37), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_62), ('procedureCode', 52), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_63), ('procedureCode', 38), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_64), ('procedureCode', 39), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_65), ('procedureCode', 42), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_66), ('procedureCode', 56), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_67), ('procedureCode', 44), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_68), ('procedureCode', 45), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_69), ('procedureCode', 46), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_70), ('procedureCode', 47), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_71), ('procedureCode', 48), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_72), ('procedureCode', 62), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_73), ('procedureCode', 49), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_74), ('procedureCode', 53), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_75), ('procedureCode', 50), ('criticality', 'ignore')])], rr=[], ev=None, er=[])
    _InitiatingMessage_procedureCode._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_procedureCode._const_tab_at = None
    _InitiatingMessage_procedureCode._const_tab_id = 'procedureCode'
    _InitiatingMessage_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _InitiatingMessage_criticality._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_criticality._const_tab_at = ('..', 'procedureCode')
    _InitiatingMessage_criticality._const_tab_id = 'criticality'
    _InitiatingMessage_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE'), ['InitiatingMessage']))
    _InitiatingMessage_value._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_value._const_tab_at = ('..', 'procedureCode')
    _InitiatingMessage_value._const_tab_id = 'InitiatingMessage'
    InitiatingMessage._cont = ASN1Dict([
        ('procedureCode', _InitiatingMessage_procedureCode),
        ('criticality', _InitiatingMessage_criticality),
        ('value', _InitiatingMessage_value),
        ])
    InitiatingMessage._ext = None
    
    #-----< SuccessfulOutcome >-----#
    SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE)
    _SuccessfulOutcome_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __SuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_NGAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdateAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionModificationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionModificationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionModificationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionReleaseRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionReleaseResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionSetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionSetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionSetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionSetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionSetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionSetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionReleaseRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionReleaseResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCancel')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCancelAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequired')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverPreparationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequestAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionActivationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionActivationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionActivationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionDeactivationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionDeactivationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionUpdateRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionUpdateResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGReset')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGResetAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequestAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_15 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequestFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceReleaseCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceReleaseResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceSetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceSetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSCancelRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSCancelResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_21 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdateAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_21 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_22 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_22 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_23 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseComplete')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_24 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_24 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_25 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_25 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityCheckRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_26 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityCheckResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_27 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'WriteReplaceWarningRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_28 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'WriteReplaceWarningResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFCPRelocationIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFStatusIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionReleaseRequired')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'CellTrafficTrace')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'ConnectionEstablishmentIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DeactivateTrace')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkNASTransport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkNonUEAssociatedNRPPaTransport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANConfigurationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANEarlyStatusTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANStatusTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRIMInformationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkUEAssociatedNRPPaTransport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'ErrorIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverNotify')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverSuccess')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialUEMessage')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReportingControl')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReportingFailureIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastGroupPaging')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NASNonDeliveryIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'OverloadStart')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'OverloadStop')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'Paging')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceNotify')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PrivateMessage')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSFailureIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSRestartIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANCPRelocationIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RerouteNASRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RetrieveUEInformation')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RRCInactiveTransitionReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'TraceFailureIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'TraceStart')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_66 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEInformationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_67 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityInfoIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_68 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UETNLABindingReleaseRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_69 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkNASTransport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_70 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkNonUEAssociatedNRPPaTransport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_71 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANConfigurationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_72 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANEarlyStatusTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_73 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANStatusTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_74 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRIMInformationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_75 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkUEAssociatedNRPPaTransport')))
    __SuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0), ('procedureCode', 0), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 66), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), ('procedureCode', 67), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3), ('procedureCode', 68), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4), ('procedureCode', 69), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), ('procedureCode', 70), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), ('procedureCode', 10), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7), ('procedureCode', 12), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8), ('procedureCode', 13), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9), ('procedureCode', 14), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10), ('procedureCode', 71), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11), ('procedureCode', 72), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12), ('procedureCode', 73), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13), ('procedureCode', 20), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14), ('procedureCode', 21), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_15), ('procedureCode', 25), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16), ('procedureCode', 26), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17), ('procedureCode', 27), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18), ('procedureCode', 28), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19), ('procedureCode', 29), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20), ('procedureCode', 32), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_21), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_21), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_22), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_22), ('procedureCode', 40), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_23), ('procedureCode', 41), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_24), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_24), ('procedureCode', 58), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_25), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_25), ('procedureCode', 59), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_26), ('procedureCode', 43), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_27), ('procedureCode', 60), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_28), ('procedureCode', 51), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29), ('procedureCode', 64), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30), ('procedureCode', 1), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31), ('procedureCode', 75), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33), ('procedureCode', 65), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37), ('procedureCode', 6), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38), ('procedureCode', 63), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39), ('procedureCode', 7), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40), ('procedureCode', 54), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41), ('procedureCode', 8), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42), ('procedureCode', 9), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44), ('procedureCode', 61), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47), ('procedureCode', 16), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48), ('procedureCode', 17), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49), ('procedureCode', 74), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50), ('procedureCode', 19), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51), ('procedureCode', 22), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52), ('procedureCode', 23), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53), ('procedureCode', 24), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54), ('procedureCode', 30), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55), ('procedureCode', 31), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56), ('procedureCode', 33), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57), ('procedureCode', 34), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58), ('procedureCode', 57), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60), ('procedureCode', 55), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61), ('procedureCode', 37), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62), ('procedureCode', 52), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63), ('procedureCode', 38), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64), ('procedureCode', 39), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65), ('procedureCode', 42), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_66), ('procedureCode', 56), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_67), ('procedureCode', 44), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_68), ('procedureCode', 45), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_69), ('procedureCode', 46), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_70), ('procedureCode', 47), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_71), ('procedureCode', 48), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_72), ('procedureCode', 62), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_73), ('procedureCode', 49), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_74), ('procedureCode', 53), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_75), ('procedureCode', 50), ('criticality', 'ignore')])], rr=[], ev=None, er=[])
    _SuccessfulOutcome_procedureCode._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_procedureCode._const_tab_at = None
    _SuccessfulOutcome_procedureCode._const_tab_id = 'procedureCode'
    _SuccessfulOutcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _SuccessfulOutcome_criticality._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_criticality._const_tab_at = ('..', 'procedureCode')
    _SuccessfulOutcome_criticality._const_tab_id = 'criticality'
    _SuccessfulOutcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE'), ['SuccessfulOutcome']))
    _SuccessfulOutcome_value._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_value._const_tab_at = ('..', 'procedureCode')
    _SuccessfulOutcome_value._const_tab_id = 'SuccessfulOutcome'
    SuccessfulOutcome._cont = ASN1Dict([
        ('procedureCode', _SuccessfulOutcome_procedureCode),
        ('criticality', _SuccessfulOutcome_criticality),
        ('value', _SuccessfulOutcome_value),
        ])
    SuccessfulOutcome._ext = None
    
    #-----< UnsuccessfulOutcome >-----#
    UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE)
    _UnsuccessfulOutcome_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __UnsuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_NGAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdateAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionModificationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionModificationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionModificationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionReleaseRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionReleaseResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionSetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionSetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionSetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionSetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionSetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionSetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionReleaseRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionReleaseResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCancel')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCancelAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequired')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverPreparationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequestAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionActivationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionActivationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionActivationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionDeactivationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionDeactivationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionUpdateRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionUpdateResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGReset')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGResetAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequestAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_15 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequestFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceReleaseCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceReleaseResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceSetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceSetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSCancelRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSCancelResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_21 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdateAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_21 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_22 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_22 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_23 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseComplete')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_24 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_24 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_25 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_25 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityCheckRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_26 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityCheckResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_27 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'WriteReplaceWarningRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_28 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'WriteReplaceWarningResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFCPRelocationIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFStatusIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionReleaseRequired')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'CellTrafficTrace')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'ConnectionEstablishmentIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DeactivateTrace')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkNASTransport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkNonUEAssociatedNRPPaTransport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANConfigurationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANEarlyStatusTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANStatusTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRIMInformationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkUEAssociatedNRPPaTransport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'ErrorIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverNotify')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverSuccess')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialUEMessage')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReportingControl')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReportingFailureIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastGroupPaging')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NASNonDeliveryIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'OverloadStart')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'OverloadStop')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'Paging')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceNotify')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PrivateMessage')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSFailureIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSRestartIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANCPRelocationIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RerouteNASRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RetrieveUEInformation')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RRCInactiveTransitionReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'TraceFailureIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'TraceStart')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_66 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEInformationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_67 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityInfoIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_68 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UETNLABindingReleaseRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_69 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkNASTransport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_70 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkNonUEAssociatedNRPPaTransport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_71 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANConfigurationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_72 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANEarlyStatusTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_73 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANStatusTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_74 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRIMInformationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_75 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkUEAssociatedNRPPaTransport')))
    __UnsuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0), ('procedureCode', 0), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 66), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), ('procedureCode', 67), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3), ('procedureCode', 68), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4), ('procedureCode', 69), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), ('procedureCode', 70), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), ('procedureCode', 10), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7), ('procedureCode', 12), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8), ('procedureCode', 13), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9), ('procedureCode', 14), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10), ('procedureCode', 71), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11), ('procedureCode', 72), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12), ('procedureCode', 73), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13), ('procedureCode', 20), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14), ('procedureCode', 21), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_15), ('procedureCode', 25), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16), ('procedureCode', 26), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17), ('procedureCode', 27), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18), ('procedureCode', 28), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19), ('procedureCode', 29), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20), ('procedureCode', 32), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_21), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_21), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_22), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_22), ('procedureCode', 40), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_23), ('procedureCode', 41), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_24), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_24), ('procedureCode', 58), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_25), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_25), ('procedureCode', 59), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_26), ('procedureCode', 43), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_27), ('procedureCode', 60), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_28), ('procedureCode', 51), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29), ('procedureCode', 64), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30), ('procedureCode', 1), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31), ('procedureCode', 75), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33), ('procedureCode', 65), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37), ('procedureCode', 6), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38), ('procedureCode', 63), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39), ('procedureCode', 7), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40), ('procedureCode', 54), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41), ('procedureCode', 8), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42), ('procedureCode', 9), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44), ('procedureCode', 61), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47), ('procedureCode', 16), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48), ('procedureCode', 17), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49), ('procedureCode', 74), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50), ('procedureCode', 19), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51), ('procedureCode', 22), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52), ('procedureCode', 23), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53), ('procedureCode', 24), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54), ('procedureCode', 30), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55), ('procedureCode', 31), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56), ('procedureCode', 33), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57), ('procedureCode', 34), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58), ('procedureCode', 57), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60), ('procedureCode', 55), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61), ('procedureCode', 37), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62), ('procedureCode', 52), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63), ('procedureCode', 38), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64), ('procedureCode', 39), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65), ('procedureCode', 42), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_66), ('procedureCode', 56), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_67), ('procedureCode', 44), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_68), ('procedureCode', 45), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_69), ('procedureCode', 46), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_70), ('procedureCode', 47), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_71), ('procedureCode', 48), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_72), ('procedureCode', 62), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_73), ('procedureCode', 49), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_74), ('procedureCode', 53), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_75), ('procedureCode', 50), ('criticality', 'ignore')])], rr=[], ev=None, er=[])
    _UnsuccessfulOutcome_procedureCode._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_procedureCode._const_tab_at = None
    _UnsuccessfulOutcome_procedureCode._const_tab_id = 'procedureCode'
    _UnsuccessfulOutcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _UnsuccessfulOutcome_criticality._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_criticality._const_tab_at = ('..', 'procedureCode')
    _UnsuccessfulOutcome_criticality._const_tab_id = 'criticality'
    _UnsuccessfulOutcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE'), ['UnsuccessfulOutcome']))
    _UnsuccessfulOutcome_value._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_value._const_tab_at = ('..', 'procedureCode')
    _UnsuccessfulOutcome_value._const_tab_id = 'UnsuccessfulOutcome'
    UnsuccessfulOutcome._cont = ASN1Dict([
        ('procedureCode', _UnsuccessfulOutcome_procedureCode),
        ('criticality', _UnsuccessfulOutcome_criticality),
        ('value', _UnsuccessfulOutcome_value),
        ])
    UnsuccessfulOutcome._ext = None
    
    #-----< NGAP-ELEMENTARY-PROCEDURES >-----#
    NGAP_ELEMENTARY_PROCEDURES = CLASS(name='NGAP-ELEMENTARY-PROCEDURES', mode=MODE_SET, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdate')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdateAcknowledge')))
    _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdateFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionModificationRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionModificationResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionModificationFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionReleaseRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionReleaseResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionSetupRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionSetupResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionSetupFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionSetupRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionSetupResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionSetupFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionReleaseRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionReleaseResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCancel')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCancelAcknowledge')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequired')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCommand')))
    _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverPreparationFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequestAcknowledge')))
    _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_8 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_9 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionActivationRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionActivationResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionActivationFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionDeactivationRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionDeactivationResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionUpdateRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionUpdateResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionUpdateFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGReset')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGResetAcknowledge')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_14 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequestAcknowledge')))
    _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_15 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequestFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyConfirm')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceReleaseCommand')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceReleaseResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceSetupRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceSetupResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSCancelRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_20 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSCancelResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdate')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_21 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdateAcknowledge')))
    _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_21 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdateFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_22 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_22 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseCommand')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_23 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseComplete')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_24 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_24 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_25 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_25 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityCheckRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_26 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityCheckResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_27 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'WriteReplaceWarningRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_28 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'WriteReplaceWarningResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFCPRelocationIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFStatusIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionReleaseRequired')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'CellTrafficTrace')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'ConnectionEstablishmentIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DeactivateTrace')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkNASTransport')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkNonUEAssociatedNRPPaTransport')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANConfigurationTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANEarlyStatusTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANStatusTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRIMInformationTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkUEAssociatedNRPPaTransport')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'ErrorIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverNotify')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverSuccess')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialUEMessage')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReport')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReportingControl')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReportingFailureIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastGroupPaging')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NASNonDeliveryIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'OverloadStart')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'OverloadStop')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'Paging')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceNotify')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PrivateMessage')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSFailureIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSRestartIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_58 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANCPRelocationIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_59 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RerouteNASRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_60 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RetrieveUEInformation')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_61 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RRCInactiveTransitionReport')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_62 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_63 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'TraceFailureIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_64 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'TraceStart')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_65 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_66 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEInformationTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_67 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityInfoIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_68 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UETNLABindingReleaseRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_69 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkNASTransport')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_70 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkNonUEAssociatedNRPPaTransport')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_71 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANConfigurationTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_72 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANEarlyStatusTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_73 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANStatusTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_74 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRIMInformationTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_75 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkUEAssociatedNRPPaTransport')))
    NGAP_ELEMENTARY_PROCEDURES._val = ASN1Set(rv=[dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0), ('procedureCode', 0), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1), ('procedureCode', 66), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2), ('procedureCode', 67), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3), ('procedureCode', 68), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4), ('procedureCode', 69), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5), ('procedureCode', 70), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6), ('procedureCode', 10), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7), ('procedureCode', 12), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_8), ('procedureCode', 13), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_9), ('procedureCode', 14), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_10), ('procedureCode', 71), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11), ('procedureCode', 72), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12), ('procedureCode', 73), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13), ('procedureCode', 20), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_14), ('procedureCode', 21), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_15), ('procedureCode', 25), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_16), ('procedureCode', 26), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_17), ('procedureCode', 27), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_18), ('procedureCode', 28), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_19), ('procedureCode', 29), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_20), ('procedureCode', 32), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_21), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_21), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_22), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_22), ('procedureCode', 40), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_23), ('procedureCode', 41), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_24), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_24), ('procedureCode', 58), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_25), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_25), ('procedureCode', 59), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_26), ('procedureCode', 43), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_27), ('procedureCode', 60), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_28), ('procedureCode', 51), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29), ('procedureCode', 64), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30), ('procedureCode', 1), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31), ('procedureCode', 75), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33), ('procedureCode', 65), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37), ('procedureCode', 6), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38), ('procedureCode', 63), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39), ('procedureCode', 7), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40), ('procedureCode', 54), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41), ('procedureCode', 8), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42), ('procedureCode', 9), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44), ('procedureCode', 61), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47), ('procedureCode', 16), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48), ('procedureCode', 17), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49), ('procedureCode', 74), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50), ('procedureCode', 19), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51), ('procedureCode', 22), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52), ('procedureCode', 23), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53), ('procedureCode', 24), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54), ('procedureCode', 30), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55), ('procedureCode', 31), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56), ('procedureCode', 33), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57), ('procedureCode', 34), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_58), ('procedureCode', 57), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_59), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_60), ('procedureCode', 55), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_61), ('procedureCode', 37), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_62), ('procedureCode', 52), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_63), ('procedureCode', 38), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_64), ('procedureCode', 39), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_65), ('procedureCode', 42), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_66), ('procedureCode', 56), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_67), ('procedureCode', 44), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_68), ('procedureCode', 45), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_69), ('procedureCode', 46), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_70), ('procedureCode', 47), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_71), ('procedureCode', 48), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_72), ('procedureCode', 62), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_73), ('procedureCode', 49), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_74), ('procedureCode', 53), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_75), ('procedureCode', 50), ('criticality', 'ignore')])], rr=[], ev=[], er=[])
    
    #-----< NGAP-ELEMENTARY-PROCEDURES-CLASS-1 >-----#
    NGAP_ELEMENTARY_PROCEDURES_CLASS_1 = CLASS(name='NGAP-ELEMENTARY-PROCEDURES-CLASS-1', mode=MODE_SET, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdate')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdateAcknowledge')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdateFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionModificationRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionModificationResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionModificationFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionReleaseRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionReleaseResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionSetupRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionSetupResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionSetupFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionSetupRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionSetupResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionSetupFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionReleaseRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionReleaseResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCancel')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCancelAcknowledge')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequired')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCommand')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverPreparationFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequestAcknowledge')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_8 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_9 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionActivationRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionActivationResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionActivationFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionDeactivationRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionDeactivationResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionUpdateRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionUpdateResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionUpdateFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGReset')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGResetAcknowledge')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequestAcknowledge')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_15 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequestFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyConfirm')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceReleaseCommand')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceReleaseResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceSetupRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceSetupResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSCancelRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSCancelResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdate')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_21 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdateAcknowledge')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_21 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdateFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_22 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_22 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseCommand')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_23 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseComplete')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_24 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_24 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_25 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_25 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendFailure')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityCheckRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_26 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityCheckResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_27 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'WriteReplaceWarningRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_28 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'WriteReplaceWarningResponse')))
    NGAP_ELEMENTARY_PROCEDURES_CLASS_1._val = ASN1Set(rv=[dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0), ('procedureCode', 0), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1), ('procedureCode', 66), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2), ('procedureCode', 67), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3), ('procedureCode', 68), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4), ('procedureCode', 69), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5), ('procedureCode', 70), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6), ('procedureCode', 10), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7), ('procedureCode', 12), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_8), ('procedureCode', 13), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_9), ('procedureCode', 14), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10), ('procedureCode', 71), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11), ('procedureCode', 72), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12), ('procedureCode', 73), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13), ('procedureCode', 20), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14), ('procedureCode', 21), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_15), ('procedureCode', 25), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16), ('procedureCode', 26), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17), ('procedureCode', 27), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18), ('procedureCode', 28), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19), ('procedureCode', 29), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20), ('procedureCode', 32), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_21), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_21), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_22), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_22), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_22), ('procedureCode', 40), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_23), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_23), ('procedureCode', 41), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_24), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_24), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_24), ('procedureCode', 58), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_25), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_25), ('UnsuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_25), ('procedureCode', 59), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_26), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_26), ('procedureCode', 43), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_27), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_27), ('procedureCode', 60), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_28), ('SuccessfulOutcome', _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_28), ('procedureCode', 51), ('criticality', 'reject')])], rr=[], ev=[], er=[])
    
    #-----< NGAP-ELEMENTARY-PROCEDURES-CLASS-2 >-----#
    NGAP_ELEMENTARY_PROCEDURES_CLASS_2 = CLASS(name='NGAP-ELEMENTARY-PROCEDURES-CLASS-2', mode=MODE_SET, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFCPRelocationIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFStatusIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionReleaseRequired')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'CellTrafficTrace')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'ConnectionEstablishmentIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DeactivateTrace')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkNASTransport')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkNonUEAssociatedNRPPaTransport')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANConfigurationTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANEarlyStatusTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANStatusTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRIMInformationTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkUEAssociatedNRPPaTransport')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'ErrorIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverNotify')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverSuccess')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialUEMessage')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReport')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReportingControl')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReportingFailureIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastGroupPaging')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NASNonDeliveryIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'OverloadStart')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'OverloadStop')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'Paging')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceNotify')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PrivateMessage')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSFailureIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSRestartIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANCPRelocationIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RerouteNASRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RetrieveUEInformation')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RRCInactiveTransitionReport')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'TraceFailureIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'TraceStart')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEInformationTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityInfoIndication')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UETNLABindingReleaseRequest')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkNASTransport')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkNonUEAssociatedNRPPaTransport')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANConfigurationTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANEarlyStatusTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANStatusTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRIMInformationTransfer')))
    _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkUEAssociatedNRPPaTransport')))
    NGAP_ELEMENTARY_PROCEDURES_CLASS_2._val = ASN1Set(rv=[dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0), ('procedureCode', 64), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1), ('procedureCode', 1), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2), ('procedureCode', 75), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3), ('procedureCode', 2), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4), ('procedureCode', 65), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8), ('procedureCode', 6), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9), ('procedureCode', 63), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10), ('procedureCode', 7), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11), ('procedureCode', 54), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12), ('procedureCode', 8), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13), ('procedureCode', 9), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15), ('procedureCode', 61), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18), ('procedureCode', 16), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19), ('procedureCode', 17), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20), ('procedureCode', 74), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21), ('procedureCode', 19), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22), ('procedureCode', 22), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23), ('procedureCode', 23), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24), ('procedureCode', 24), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25), ('procedureCode', 30), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26), ('procedureCode', 31), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27), ('procedureCode', 33), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28), ('procedureCode', 34), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29), ('procedureCode', 57), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31), ('procedureCode', 55), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_32), ('procedureCode', 37), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_33), ('procedureCode', 52), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_34), ('procedureCode', 38), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_35), ('procedureCode', 39), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_36), ('procedureCode', 42), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_37), ('procedureCode', 56), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_38), ('procedureCode', 44), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_39), ('procedureCode', 45), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_40), ('procedureCode', 46), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_41), ('procedureCode', 47), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_42), ('procedureCode', 48), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_43), ('procedureCode', 62), ('criticality', 'reject')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_44), ('procedureCode', 49), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_45), ('procedureCode', 53), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_46), ('procedureCode', 50), ('criticality', 'ignore')])], rr=[], ev=[], er=[])
    
    #-----< aMFConfigurationUpdate >-----#
    aMFConfigurationUpdate = CLASS(name='aMFConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _aMFConfigurationUpdate_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdate')))
    _aMFConfigurationUpdate_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdateAcknowledge')))
    _aMFConfigurationUpdate_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFConfigurationUpdateFailure')))
    aMFConfigurationUpdate._val = dict([('InitiatingMessage', _aMFConfigurationUpdate_val_InitiatingMessage), ('SuccessfulOutcome', _aMFConfigurationUpdate_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _aMFConfigurationUpdate_val_UnsuccessfulOutcome), ('procedureCode', 0), ('criticality', 'reject')])
    
    #-----< aMFCPRelocationIndication >-----#
    aMFCPRelocationIndication = CLASS(name='aMFCPRelocationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _aMFCPRelocationIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFCPRelocationIndication')))
    aMFCPRelocationIndication._val = dict([('InitiatingMessage', _aMFCPRelocationIndication_val_InitiatingMessage), ('procedureCode', 64), ('criticality', 'reject')])
    
    #-----< aMFStatusIndication >-----#
    aMFStatusIndication = CLASS(name='aMFStatusIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _aMFStatusIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'AMFStatusIndication')))
    aMFStatusIndication._val = dict([('InitiatingMessage', _aMFStatusIndication_val_InitiatingMessage), ('procedureCode', 1), ('criticality', 'ignore')])
    
    #-----< broadcastSessionModification >-----#
    broadcastSessionModification = CLASS(name='broadcastSessionModification', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _broadcastSessionModification_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionModificationRequest')))
    _broadcastSessionModification_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionModificationResponse')))
    _broadcastSessionModification_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionModificationFailure')))
    broadcastSessionModification._val = dict([('InitiatingMessage', _broadcastSessionModification_val_InitiatingMessage), ('SuccessfulOutcome', _broadcastSessionModification_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _broadcastSessionModification_val_UnsuccessfulOutcome), ('procedureCode', 66), ('criticality', 'reject')])
    
    #-----< broadcastSessionRelease >-----#
    broadcastSessionRelease = CLASS(name='broadcastSessionRelease', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _broadcastSessionRelease_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionReleaseRequest')))
    _broadcastSessionRelease_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionReleaseResponse')))
    broadcastSessionRelease._val = dict([('InitiatingMessage', _broadcastSessionRelease_val_InitiatingMessage), ('SuccessfulOutcome', _broadcastSessionRelease_val_SuccessfulOutcome), ('procedureCode', 67), ('criticality', 'reject')])
    
    #-----< broadcastSessionReleaseRequired >-----#
    broadcastSessionReleaseRequired = CLASS(name='broadcastSessionReleaseRequired', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _broadcastSessionReleaseRequired_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionReleaseRequired')))
    broadcastSessionReleaseRequired._val = dict([('InitiatingMessage', _broadcastSessionReleaseRequired_val_InitiatingMessage), ('procedureCode', 75), ('criticality', 'reject')])
    
    #-----< broadcastSessionSetup >-----#
    broadcastSessionSetup = CLASS(name='broadcastSessionSetup', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _broadcastSessionSetup_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionSetupRequest')))
    _broadcastSessionSetup_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionSetupResponse')))
    _broadcastSessionSetup_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'BroadcastSessionSetupFailure')))
    broadcastSessionSetup._val = dict([('InitiatingMessage', _broadcastSessionSetup_val_InitiatingMessage), ('SuccessfulOutcome', _broadcastSessionSetup_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _broadcastSessionSetup_val_UnsuccessfulOutcome), ('procedureCode', 68), ('criticality', 'reject')])
    
    #-----< cellTrafficTrace >-----#
    cellTrafficTrace = CLASS(name='cellTrafficTrace', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _cellTrafficTrace_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'CellTrafficTrace')))
    cellTrafficTrace._val = dict([('InitiatingMessage', _cellTrafficTrace_val_InitiatingMessage), ('procedureCode', 2), ('criticality', 'ignore')])
    
    #-----< connectionEstablishmentIndication >-----#
    connectionEstablishmentIndication = CLASS(name='connectionEstablishmentIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _connectionEstablishmentIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'ConnectionEstablishmentIndication')))
    connectionEstablishmentIndication._val = dict([('InitiatingMessage', _connectionEstablishmentIndication_val_InitiatingMessage), ('procedureCode', 65), ('criticality', 'reject')])
    
    #-----< deactivateTrace >-----#
    deactivateTrace = CLASS(name='deactivateTrace', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _deactivateTrace_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DeactivateTrace')))
    deactivateTrace._val = dict([('InitiatingMessage', _deactivateTrace_val_InitiatingMessage), ('procedureCode', 3), ('criticality', 'ignore')])
    
    #-----< distributionSetup >-----#
    distributionSetup = CLASS(name='distributionSetup', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _distributionSetup_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionSetupRequest')))
    _distributionSetup_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionSetupResponse')))
    _distributionSetup_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionSetupFailure')))
    distributionSetup._val = dict([('InitiatingMessage', _distributionSetup_val_InitiatingMessage), ('SuccessfulOutcome', _distributionSetup_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _distributionSetup_val_UnsuccessfulOutcome), ('procedureCode', 69), ('criticality', 'reject')])
    
    #-----< distributionRelease >-----#
    distributionRelease = CLASS(name='distributionRelease', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _distributionRelease_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionReleaseRequest')))
    _distributionRelease_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DistributionReleaseResponse')))
    distributionRelease._val = dict([('InitiatingMessage', _distributionRelease_val_InitiatingMessage), ('SuccessfulOutcome', _distributionRelease_val_SuccessfulOutcome), ('procedureCode', 70), ('criticality', 'reject')])
    
    #-----< downlinkNASTransport >-----#
    downlinkNASTransport = CLASS(name='downlinkNASTransport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _downlinkNASTransport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkNASTransport')))
    downlinkNASTransport._val = dict([('InitiatingMessage', _downlinkNASTransport_val_InitiatingMessage), ('procedureCode', 4), ('criticality', 'ignore')])
    
    #-----< downlinkNonUEAssociatedNRPPaTransport >-----#
    downlinkNonUEAssociatedNRPPaTransport = CLASS(name='downlinkNonUEAssociatedNRPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _downlinkNonUEAssociatedNRPPaTransport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkNonUEAssociatedNRPPaTransport')))
    downlinkNonUEAssociatedNRPPaTransport._val = dict([('InitiatingMessage', _downlinkNonUEAssociatedNRPPaTransport_val_InitiatingMessage), ('procedureCode', 5), ('criticality', 'ignore')])
    
    #-----< downlinkRANConfigurationTransfer >-----#
    downlinkRANConfigurationTransfer = CLASS(name='downlinkRANConfigurationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _downlinkRANConfigurationTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANConfigurationTransfer')))
    downlinkRANConfigurationTransfer._val = dict([('InitiatingMessage', _downlinkRANConfigurationTransfer_val_InitiatingMessage), ('procedureCode', 6), ('criticality', 'ignore')])
    
    #-----< downlinkRANEarlyStatusTransfer >-----#
    downlinkRANEarlyStatusTransfer = CLASS(name='downlinkRANEarlyStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _downlinkRANEarlyStatusTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANEarlyStatusTransfer')))
    downlinkRANEarlyStatusTransfer._val = dict([('InitiatingMessage', _downlinkRANEarlyStatusTransfer_val_InitiatingMessage), ('procedureCode', 63), ('criticality', 'ignore')])
    
    #-----< downlinkRANStatusTransfer >-----#
    downlinkRANStatusTransfer = CLASS(name='downlinkRANStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _downlinkRANStatusTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRANStatusTransfer')))
    downlinkRANStatusTransfer._val = dict([('InitiatingMessage', _downlinkRANStatusTransfer_val_InitiatingMessage), ('procedureCode', 7), ('criticality', 'ignore')])
    
    #-----< downlinkUEAssociatedNRPPaTransport >-----#
    downlinkUEAssociatedNRPPaTransport = CLASS(name='downlinkUEAssociatedNRPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _downlinkUEAssociatedNRPPaTransport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkUEAssociatedNRPPaTransport')))
    downlinkUEAssociatedNRPPaTransport._val = dict([('InitiatingMessage', _downlinkUEAssociatedNRPPaTransport_val_InitiatingMessage), ('procedureCode', 8), ('criticality', 'ignore')])
    
    #-----< errorIndication >-----#
    errorIndication = CLASS(name='errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _errorIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'ErrorIndication')))
    errorIndication._val = dict([('InitiatingMessage', _errorIndication_val_InitiatingMessage), ('procedureCode', 9), ('criticality', 'ignore')])
    
    #-----< handoverCancel >-----#
    handoverCancel = CLASS(name='handoverCancel', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _handoverCancel_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCancel')))
    _handoverCancel_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCancelAcknowledge')))
    handoverCancel._val = dict([('InitiatingMessage', _handoverCancel_val_InitiatingMessage), ('SuccessfulOutcome', _handoverCancel_val_SuccessfulOutcome), ('procedureCode', 10), ('criticality', 'reject')])
    
    #-----< handoverNotification >-----#
    handoverNotification = CLASS(name='handoverNotification', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _handoverNotification_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverNotify')))
    handoverNotification._val = dict([('InitiatingMessage', _handoverNotification_val_InitiatingMessage), ('procedureCode', 11), ('criticality', 'ignore')])
    
    #-----< handoverPreparation >-----#
    handoverPreparation = CLASS(name='handoverPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _handoverPreparation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequired')))
    _handoverPreparation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverCommand')))
    _handoverPreparation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverPreparationFailure')))
    handoverPreparation._val = dict([('InitiatingMessage', _handoverPreparation_val_InitiatingMessage), ('SuccessfulOutcome', _handoverPreparation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _handoverPreparation_val_UnsuccessfulOutcome), ('procedureCode', 12), ('criticality', 'reject')])
    
    #-----< handoverResourceAllocation >-----#
    handoverResourceAllocation = CLASS(name='handoverResourceAllocation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _handoverResourceAllocation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequest')))
    _handoverResourceAllocation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverRequestAcknowledge')))
    _handoverResourceAllocation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverFailure')))
    handoverResourceAllocation._val = dict([('InitiatingMessage', _handoverResourceAllocation_val_InitiatingMessage), ('SuccessfulOutcome', _handoverResourceAllocation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _handoverResourceAllocation_val_UnsuccessfulOutcome), ('procedureCode', 13), ('criticality', 'reject')])
    
    #-----< handoverSuccess >-----#
    handoverSuccess = CLASS(name='handoverSuccess', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _handoverSuccess_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'HandoverSuccess')))
    handoverSuccess._val = dict([('InitiatingMessage', _handoverSuccess_val_InitiatingMessage), ('procedureCode', 61), ('criticality', 'ignore')])
    
    #-----< initialContextSetup >-----#
    initialContextSetup = CLASS(name='initialContextSetup', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _initialContextSetup_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupRequest')))
    _initialContextSetup_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupResponse')))
    _initialContextSetup_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialContextSetupFailure')))
    initialContextSetup._val = dict([('InitiatingMessage', _initialContextSetup_val_InitiatingMessage), ('SuccessfulOutcome', _initialContextSetup_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _initialContextSetup_val_UnsuccessfulOutcome), ('procedureCode', 14), ('criticality', 'reject')])
    
    #-----< initialUEMessage >-----#
    initialUEMessage = CLASS(name='initialUEMessage', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _initialUEMessage_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'InitialUEMessage')))
    initialUEMessage._val = dict([('InitiatingMessage', _initialUEMessage_val_InitiatingMessage), ('procedureCode', 15), ('criticality', 'ignore')])
    
    #-----< locationReport >-----#
    locationReport = CLASS(name='locationReport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _locationReport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReport')))
    locationReport._val = dict([('InitiatingMessage', _locationReport_val_InitiatingMessage), ('procedureCode', 18), ('criticality', 'ignore')])
    
    #-----< locationReportingControl >-----#
    locationReportingControl = CLASS(name='locationReportingControl', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _locationReportingControl_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReportingControl')))
    locationReportingControl._val = dict([('InitiatingMessage', _locationReportingControl_val_InitiatingMessage), ('procedureCode', 16), ('criticality', 'ignore')])
    
    #-----< locationReportingFailureIndication >-----#
    locationReportingFailureIndication = CLASS(name='locationReportingFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _locationReportingFailureIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'LocationReportingFailureIndication')))
    locationReportingFailureIndication._val = dict([('InitiatingMessage', _locationReportingFailureIndication_val_InitiatingMessage), ('procedureCode', 17), ('criticality', 'ignore')])
    
    #-----< multicastSessionActivation >-----#
    multicastSessionActivation = CLASS(name='multicastSessionActivation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _multicastSessionActivation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionActivationRequest')))
    _multicastSessionActivation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionActivationResponse')))
    _multicastSessionActivation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionActivationFailure')))
    multicastSessionActivation._val = dict([('InitiatingMessage', _multicastSessionActivation_val_InitiatingMessage), ('SuccessfulOutcome', _multicastSessionActivation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _multicastSessionActivation_val_UnsuccessfulOutcome), ('procedureCode', 71), ('criticality', 'reject')])
    
    #-----< multicastSessionDeactivation >-----#
    multicastSessionDeactivation = CLASS(name='multicastSessionDeactivation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _multicastSessionDeactivation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionDeactivationRequest')))
    _multicastSessionDeactivation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionDeactivationResponse')))
    multicastSessionDeactivation._val = dict([('InitiatingMessage', _multicastSessionDeactivation_val_InitiatingMessage), ('SuccessfulOutcome', _multicastSessionDeactivation_val_SuccessfulOutcome), ('procedureCode', 72), ('criticality', 'reject')])
    
    #-----< multicastSessionUpdate >-----#
    multicastSessionUpdate = CLASS(name='multicastSessionUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _multicastSessionUpdate_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionUpdateRequest')))
    _multicastSessionUpdate_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionUpdateResponse')))
    _multicastSessionUpdate_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastSessionUpdateFailure')))
    multicastSessionUpdate._val = dict([('InitiatingMessage', _multicastSessionUpdate_val_InitiatingMessage), ('SuccessfulOutcome', _multicastSessionUpdate_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _multicastSessionUpdate_val_UnsuccessfulOutcome), ('procedureCode', 73), ('criticality', 'reject')])
    
    #-----< multicastGroupPaging >-----#
    multicastGroupPaging = CLASS(name='multicastGroupPaging', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _multicastGroupPaging_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'MulticastGroupPaging')))
    multicastGroupPaging._val = dict([('InitiatingMessage', _multicastGroupPaging_val_InitiatingMessage), ('procedureCode', 74), ('criticality', 'ignore')])
    
    #-----< nASNonDeliveryIndication >-----#
    nASNonDeliveryIndication = CLASS(name='nASNonDeliveryIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _nASNonDeliveryIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NASNonDeliveryIndication')))
    nASNonDeliveryIndication._val = dict([('InitiatingMessage', _nASNonDeliveryIndication_val_InitiatingMessage), ('procedureCode', 19), ('criticality', 'ignore')])
    
    #-----< nGReset >-----#
    nGReset = CLASS(name='nGReset', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _nGReset_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGReset')))
    _nGReset_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGResetAcknowledge')))
    nGReset._val = dict([('InitiatingMessage', _nGReset_val_InitiatingMessage), ('SuccessfulOutcome', _nGReset_val_SuccessfulOutcome), ('procedureCode', 20), ('criticality', 'reject')])
    
    #-----< nGSetup >-----#
    nGSetup = CLASS(name='nGSetup', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _nGSetup_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupRequest')))
    _nGSetup_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupResponse')))
    _nGSetup_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'NGSetupFailure')))
    nGSetup._val = dict([('InitiatingMessage', _nGSetup_val_InitiatingMessage), ('SuccessfulOutcome', _nGSetup_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _nGSetup_val_UnsuccessfulOutcome), ('procedureCode', 21), ('criticality', 'reject')])
    
    #-----< overloadStart >-----#
    overloadStart = CLASS(name='overloadStart', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _overloadStart_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'OverloadStart')))
    overloadStart._val = dict([('InitiatingMessage', _overloadStart_val_InitiatingMessage), ('procedureCode', 22), ('criticality', 'ignore')])
    
    #-----< overloadStop >-----#
    overloadStop = CLASS(name='overloadStop', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _overloadStop_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'OverloadStop')))
    overloadStop._val = dict([('InitiatingMessage', _overloadStop_val_InitiatingMessage), ('procedureCode', 23), ('criticality', 'reject')])
    
    #-----< paging >-----#
    paging = CLASS(name='paging', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _paging_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'Paging')))
    paging._val = dict([('InitiatingMessage', _paging_val_InitiatingMessage), ('procedureCode', 24), ('criticality', 'ignore')])
    
    #-----< pathSwitchRequest >-----#
    pathSwitchRequest = CLASS(name='pathSwitchRequest', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _pathSwitchRequest_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequest')))
    _pathSwitchRequest_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequestAcknowledge')))
    _pathSwitchRequest_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PathSwitchRequestFailure')))
    pathSwitchRequest._val = dict([('InitiatingMessage', _pathSwitchRequest_val_InitiatingMessage), ('SuccessfulOutcome', _pathSwitchRequest_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _pathSwitchRequest_val_UnsuccessfulOutcome), ('procedureCode', 25), ('criticality', 'reject')])
    
    #-----< pDUSessionResourceModify >-----#
    pDUSessionResourceModify = CLASS(name='pDUSessionResourceModify', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _pDUSessionResourceModify_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyRequest')))
    _pDUSessionResourceModify_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyResponse')))
    pDUSessionResourceModify._val = dict([('InitiatingMessage', _pDUSessionResourceModify_val_InitiatingMessage), ('SuccessfulOutcome', _pDUSessionResourceModify_val_SuccessfulOutcome), ('procedureCode', 26), ('criticality', 'reject')])
    
    #-----< pDUSessionResourceModifyIndication >-----#
    pDUSessionResourceModifyIndication = CLASS(name='pDUSessionResourceModifyIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _pDUSessionResourceModifyIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyIndication')))
    _pDUSessionResourceModifyIndication_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceModifyConfirm')))
    pDUSessionResourceModifyIndication._val = dict([('InitiatingMessage', _pDUSessionResourceModifyIndication_val_InitiatingMessage), ('SuccessfulOutcome', _pDUSessionResourceModifyIndication_val_SuccessfulOutcome), ('procedureCode', 27), ('criticality', 'reject')])
    
    #-----< pDUSessionResourceNotify >-----#
    pDUSessionResourceNotify = CLASS(name='pDUSessionResourceNotify', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _pDUSessionResourceNotify_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceNotify')))
    pDUSessionResourceNotify._val = dict([('InitiatingMessage', _pDUSessionResourceNotify_val_InitiatingMessage), ('procedureCode', 30), ('criticality', 'ignore')])
    
    #-----< pDUSessionResourceRelease >-----#
    pDUSessionResourceRelease = CLASS(name='pDUSessionResourceRelease', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _pDUSessionResourceRelease_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceReleaseCommand')))
    _pDUSessionResourceRelease_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceReleaseResponse')))
    pDUSessionResourceRelease._val = dict([('InitiatingMessage', _pDUSessionResourceRelease_val_InitiatingMessage), ('SuccessfulOutcome', _pDUSessionResourceRelease_val_SuccessfulOutcome), ('procedureCode', 28), ('criticality', 'reject')])
    
    #-----< pDUSessionResourceSetup >-----#
    pDUSessionResourceSetup = CLASS(name='pDUSessionResourceSetup', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _pDUSessionResourceSetup_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceSetupRequest')))
    _pDUSessionResourceSetup_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PDUSessionResourceSetupResponse')))
    pDUSessionResourceSetup._val = dict([('InitiatingMessage', _pDUSessionResourceSetup_val_InitiatingMessage), ('SuccessfulOutcome', _pDUSessionResourceSetup_val_SuccessfulOutcome), ('procedureCode', 29), ('criticality', 'reject')])
    
    #-----< privateMessage >-----#
    privateMessage = CLASS(name='privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _privateMessage_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PrivateMessage')))
    privateMessage._val = dict([('InitiatingMessage', _privateMessage_val_InitiatingMessage), ('procedureCode', 31), ('criticality', 'ignore')])
    
    #-----< pWSCancel >-----#
    pWSCancel = CLASS(name='pWSCancel', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _pWSCancel_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSCancelRequest')))
    _pWSCancel_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSCancelResponse')))
    pWSCancel._val = dict([('InitiatingMessage', _pWSCancel_val_InitiatingMessage), ('SuccessfulOutcome', _pWSCancel_val_SuccessfulOutcome), ('procedureCode', 32), ('criticality', 'reject')])
    
    #-----< pWSFailureIndication >-----#
    pWSFailureIndication = CLASS(name='pWSFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _pWSFailureIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSFailureIndication')))
    pWSFailureIndication._val = dict([('InitiatingMessage', _pWSFailureIndication_val_InitiatingMessage), ('procedureCode', 33), ('criticality', 'ignore')])
    
    #-----< pWSRestartIndication >-----#
    pWSRestartIndication = CLASS(name='pWSRestartIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _pWSRestartIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'PWSRestartIndication')))
    pWSRestartIndication._val = dict([('InitiatingMessage', _pWSRestartIndication_val_InitiatingMessage), ('procedureCode', 34), ('criticality', 'ignore')])
    
    #-----< rANConfigurationUpdate >-----#
    rANConfigurationUpdate = CLASS(name='rANConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _rANConfigurationUpdate_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdate')))
    _rANConfigurationUpdate_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdateAcknowledge')))
    _rANConfigurationUpdate_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANConfigurationUpdateFailure')))
    rANConfigurationUpdate._val = dict([('InitiatingMessage', _rANConfigurationUpdate_val_InitiatingMessage), ('SuccessfulOutcome', _rANConfigurationUpdate_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _rANConfigurationUpdate_val_UnsuccessfulOutcome), ('procedureCode', 35), ('criticality', 'reject')])
    
    #-----< rANCPRelocationIndication >-----#
    rANCPRelocationIndication = CLASS(name='rANCPRelocationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _rANCPRelocationIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RANCPRelocationIndication')))
    rANCPRelocationIndication._val = dict([('InitiatingMessage', _rANCPRelocationIndication_val_InitiatingMessage), ('procedureCode', 57), ('criticality', 'reject')])
    
    #-----< rerouteNASRequest >-----#
    rerouteNASRequest = CLASS(name='rerouteNASRequest', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _rerouteNASRequest_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RerouteNASRequest')))
    rerouteNASRequest._val = dict([('InitiatingMessage', _rerouteNASRequest_val_InitiatingMessage), ('procedureCode', 36), ('criticality', 'reject')])
    
    #-----< retrieveUEInformation >-----#
    retrieveUEInformation = CLASS(name='retrieveUEInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _retrieveUEInformation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RetrieveUEInformation')))
    retrieveUEInformation._val = dict([('InitiatingMessage', _retrieveUEInformation_val_InitiatingMessage), ('procedureCode', 55), ('criticality', 'reject')])
    
    #-----< rRCInactiveTransitionReport >-----#
    rRCInactiveTransitionReport = CLASS(name='rRCInactiveTransitionReport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _rRCInactiveTransitionReport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'RRCInactiveTransitionReport')))
    rRCInactiveTransitionReport._val = dict([('InitiatingMessage', _rRCInactiveTransitionReport_val_InitiatingMessage), ('procedureCode', 37), ('criticality', 'ignore')])
    
    #-----< secondaryRATDataUsageReport >-----#
    secondaryRATDataUsageReport = CLASS(name='secondaryRATDataUsageReport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _secondaryRATDataUsageReport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    secondaryRATDataUsageReport._val = dict([('InitiatingMessage', _secondaryRATDataUsageReport_val_InitiatingMessage), ('procedureCode', 52), ('criticality', 'ignore')])
    
    #-----< traceFailureIndication >-----#
    traceFailureIndication = CLASS(name='traceFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _traceFailureIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'TraceFailureIndication')))
    traceFailureIndication._val = dict([('InitiatingMessage', _traceFailureIndication_val_InitiatingMessage), ('procedureCode', 38), ('criticality', 'ignore')])
    
    #-----< traceStart >-----#
    traceStart = CLASS(name='traceStart', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _traceStart_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'TraceStart')))
    traceStart._val = dict([('InitiatingMessage', _traceStart_val_InitiatingMessage), ('procedureCode', 39), ('criticality', 'ignore')])
    
    #-----< uEContextModification >-----#
    uEContextModification = CLASS(name='uEContextModification', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uEContextModification_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationRequest')))
    _uEContextModification_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationResponse')))
    _uEContextModification_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextModificationFailure')))
    uEContextModification._val = dict([('InitiatingMessage', _uEContextModification_val_InitiatingMessage), ('SuccessfulOutcome', _uEContextModification_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _uEContextModification_val_UnsuccessfulOutcome), ('procedureCode', 40), ('criticality', 'reject')])
    
    #-----< uEContextRelease >-----#
    uEContextRelease = CLASS(name='uEContextRelease', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uEContextRelease_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseCommand')))
    _uEContextRelease_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseComplete')))
    uEContextRelease._val = dict([('InitiatingMessage', _uEContextRelease_val_InitiatingMessage), ('SuccessfulOutcome', _uEContextRelease_val_SuccessfulOutcome), ('procedureCode', 41), ('criticality', 'reject')])
    
    #-----< uEContextReleaseRequest >-----#
    uEContextReleaseRequest = CLASS(name='uEContextReleaseRequest', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uEContextReleaseRequest_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextReleaseRequest')))
    uEContextReleaseRequest._val = dict([('InitiatingMessage', _uEContextReleaseRequest_val_InitiatingMessage), ('procedureCode', 42), ('criticality', 'ignore')])
    
    #-----< uEContextResume >-----#
    uEContextResume = CLASS(name='uEContextResume', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uEContextResume_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeRequest')))
    _uEContextResume_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeResponse')))
    _uEContextResume_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextResumeFailure')))
    uEContextResume._val = dict([('InitiatingMessage', _uEContextResume_val_InitiatingMessage), ('SuccessfulOutcome', _uEContextResume_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _uEContextResume_val_UnsuccessfulOutcome), ('procedureCode', 58), ('criticality', 'reject')])
    
    #-----< uEContextSuspend >-----#
    uEContextSuspend = CLASS(name='uEContextSuspend', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uEContextSuspend_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendRequest')))
    _uEContextSuspend_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendResponse')))
    _uEContextSuspend_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEContextSuspendFailure')))
    uEContextSuspend._val = dict([('InitiatingMessage', _uEContextSuspend_val_InitiatingMessage), ('SuccessfulOutcome', _uEContextSuspend_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _uEContextSuspend_val_UnsuccessfulOutcome), ('procedureCode', 59), ('criticality', 'reject')])
    
    #-----< uEInformationTransfer >-----#
    uEInformationTransfer = CLASS(name='uEInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uEInformationTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UEInformationTransfer')))
    uEInformationTransfer._val = dict([('InitiatingMessage', _uEInformationTransfer_val_InitiatingMessage), ('procedureCode', 56), ('criticality', 'reject')])
    
    #-----< uERadioCapabilityCheck >-----#
    uERadioCapabilityCheck = CLASS(name='uERadioCapabilityCheck', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uERadioCapabilityCheck_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityCheckRequest')))
    _uERadioCapabilityCheck_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityCheckResponse')))
    uERadioCapabilityCheck._val = dict([('InitiatingMessage', _uERadioCapabilityCheck_val_InitiatingMessage), ('SuccessfulOutcome', _uERadioCapabilityCheck_val_SuccessfulOutcome), ('procedureCode', 43), ('criticality', 'reject')])
    
    #-----< uERadioCapabilityIDMapping >-----#
    uERadioCapabilityIDMapping = CLASS(name='uERadioCapabilityIDMapping', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uERadioCapabilityIDMapping_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    _uERadioCapabilityIDMapping_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    uERadioCapabilityIDMapping._val = dict([('InitiatingMessage', _uERadioCapabilityIDMapping_val_InitiatingMessage), ('SuccessfulOutcome', _uERadioCapabilityIDMapping_val_SuccessfulOutcome), ('procedureCode', 60), ('criticality', 'reject')])
    
    #-----< uERadioCapabilityInfoIndication >-----#
    uERadioCapabilityInfoIndication = CLASS(name='uERadioCapabilityInfoIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uERadioCapabilityInfoIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UERadioCapabilityInfoIndication')))
    uERadioCapabilityInfoIndication._val = dict([('InitiatingMessage', _uERadioCapabilityInfoIndication_val_InitiatingMessage), ('procedureCode', 44), ('criticality', 'ignore')])
    
    #-----< uETNLABindingRelease >-----#
    uETNLABindingRelease = CLASS(name='uETNLABindingRelease', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uETNLABindingRelease_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UETNLABindingReleaseRequest')))
    uETNLABindingRelease._val = dict([('InitiatingMessage', _uETNLABindingRelease_val_InitiatingMessage), ('procedureCode', 45), ('criticality', 'ignore')])
    
    #-----< uplinkNASTransport >-----#
    uplinkNASTransport = CLASS(name='uplinkNASTransport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uplinkNASTransport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkNASTransport')))
    uplinkNASTransport._val = dict([('InitiatingMessage', _uplinkNASTransport_val_InitiatingMessage), ('procedureCode', 46), ('criticality', 'ignore')])
    
    #-----< uplinkNonUEAssociatedNRPPaTransport >-----#
    uplinkNonUEAssociatedNRPPaTransport = CLASS(name='uplinkNonUEAssociatedNRPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uplinkNonUEAssociatedNRPPaTransport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkNonUEAssociatedNRPPaTransport')))
    uplinkNonUEAssociatedNRPPaTransport._val = dict([('InitiatingMessage', _uplinkNonUEAssociatedNRPPaTransport_val_InitiatingMessage), ('procedureCode', 47), ('criticality', 'ignore')])
    
    #-----< uplinkRANConfigurationTransfer >-----#
    uplinkRANConfigurationTransfer = CLASS(name='uplinkRANConfigurationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uplinkRANConfigurationTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANConfigurationTransfer')))
    uplinkRANConfigurationTransfer._val = dict([('InitiatingMessage', _uplinkRANConfigurationTransfer_val_InitiatingMessage), ('procedureCode', 48), ('criticality', 'ignore')])
    
    #-----< uplinkRANEarlyStatusTransfer >-----#
    uplinkRANEarlyStatusTransfer = CLASS(name='uplinkRANEarlyStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uplinkRANEarlyStatusTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANEarlyStatusTransfer')))
    uplinkRANEarlyStatusTransfer._val = dict([('InitiatingMessage', _uplinkRANEarlyStatusTransfer_val_InitiatingMessage), ('procedureCode', 62), ('criticality', 'reject')])
    
    #-----< uplinkRANStatusTransfer >-----#
    uplinkRANStatusTransfer = CLASS(name='uplinkRANStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uplinkRANStatusTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRANStatusTransfer')))
    uplinkRANStatusTransfer._val = dict([('InitiatingMessage', _uplinkRANStatusTransfer_val_InitiatingMessage), ('procedureCode', 49), ('criticality', 'ignore')])
    
    #-----< uplinkUEAssociatedNRPPaTransport >-----#
    uplinkUEAssociatedNRPPaTransport = CLASS(name='uplinkUEAssociatedNRPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uplinkUEAssociatedNRPPaTransport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkUEAssociatedNRPPaTransport')))
    uplinkUEAssociatedNRPPaTransport._val = dict([('InitiatingMessage', _uplinkUEAssociatedNRPPaTransport_val_InitiatingMessage), ('procedureCode', 50), ('criticality', 'ignore')])
    
    #-----< writeReplaceWarning >-----#
    writeReplaceWarning = CLASS(name='writeReplaceWarning', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _writeReplaceWarning_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'WriteReplaceWarningRequest')))
    _writeReplaceWarning_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'WriteReplaceWarningResponse')))
    writeReplaceWarning._val = dict([('InitiatingMessage', _writeReplaceWarning_val_InitiatingMessage), ('SuccessfulOutcome', _writeReplaceWarning_val_SuccessfulOutcome), ('procedureCode', 51), ('criticality', 'reject')])
    
    #-----< uplinkRIMInformationTransfer >-----#
    uplinkRIMInformationTransfer = CLASS(name='uplinkRIMInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _uplinkRIMInformationTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'UplinkRIMInformationTransfer')))
    uplinkRIMInformationTransfer._val = dict([('InitiatingMessage', _uplinkRIMInformationTransfer_val_InitiatingMessage), ('procedureCode', 53), ('criticality', 'ignore')])
    
    #-----< downlinkRIMInformationTransfer >-----#
    downlinkRIMInformationTransfer = CLASS(name='downlinkRIMInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('NGAP-PDU-Descriptions', 'NGAP-ELEMENTARY-PROCEDURE')))
    _downlinkRIMInformationTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NGAP-PDU-Contents', 'DownlinkRIMInformationTransfer')))
    downlinkRIMInformationTransfer._val = dict([('InitiatingMessage', _downlinkRIMInformationTransfer_val_InitiatingMessage), ('procedureCode', 54), ('criticality', 'ignore')])
    
    _all_ = [
        _NGAP_ELEMENTARY_PROCEDURE_InitiatingMessage,
        _NGAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome,
        _NGAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome,
        _NGAP_ELEMENTARY_PROCEDURE_procedureCode,
        _NGAP_ELEMENTARY_PROCEDURE_criticality,
        NGAP_ELEMENTARY_PROCEDURE,
        _NGAP_PDU_initiatingMessage,
        _NGAP_PDU_successfulOutcome,
        _NGAP_PDU_unsuccessfulOutcome,
        NGAP_PDU,
        __InitiatingMessage_procedureCode_tab,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_8,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_9,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_10,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_12,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_13,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_14,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_14,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_15,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_15,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_16,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_17,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_18,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_19,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_20,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_21,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_21,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_22,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_22,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_23,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_24,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_24,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_25,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_25,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_26,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_27,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_28,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_49,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_50,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_51,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_52,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_53,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_54,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_55,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_56,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_57,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_58,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_59,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_60,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_61,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_62,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_63,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_64,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_65,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_66,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_67,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_68,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_69,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_70,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_71,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_72,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_73,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_74,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_75,
        _InitiatingMessage_procedureCode,
        _InitiatingMessage_criticality,
        _InitiatingMessage_value,
        InitiatingMessage,
        __SuccessfulOutcome_procedureCode_tab,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_15,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_21,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_21,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_22,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_22,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_23,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_24,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_24,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_25,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_25,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_26,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_27,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_28,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_66,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_67,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_68,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_69,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_70,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_71,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_72,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_73,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_74,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_75,
        _SuccessfulOutcome_procedureCode,
        _SuccessfulOutcome_criticality,
        _SuccessfulOutcome_value,
        SuccessfulOutcome,
        __UnsuccessfulOutcome_procedureCode_tab,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_16,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_17,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_18,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_19,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_20,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_21,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_21,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_22,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_22,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_23,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_24,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_24,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_25,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_25,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_26,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_27,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_28,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_66,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_67,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_68,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_69,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_70,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_71,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_72,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_73,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_74,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_75,
        _UnsuccessfulOutcome_procedureCode,
        _UnsuccessfulOutcome_criticality,
        _UnsuccessfulOutcome_value,
        UnsuccessfulOutcome,
        NGAP_ELEMENTARY_PROCEDURES,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0,
        _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1,
        _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3,
        _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4,
        _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7,
        _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8,
        _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_8,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9,
        _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_9,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10,
        _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_10,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12,
        _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14,
        _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_14,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15,
        _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_15,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_16,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_17,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_18,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_19,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_20,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_21,
        _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_21,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_22,
        _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_22,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_23,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_24,
        _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_24,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_25,
        _NGAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_25,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_26,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_27,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28,
        _NGAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_28,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_58,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_59,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_60,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_61,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_62,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_63,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_64,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_65,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_66,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_67,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_68,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_69,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_70,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_71,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_72,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_73,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_74,
        _NGAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_75,
        NGAP_ELEMENTARY_PROCEDURES_CLASS_1,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_8,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_9,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_15,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_21,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_21,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_22,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_22,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_22,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_23,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_23,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_24,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_24,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_24,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_25,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_25,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_25,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_26,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_26,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_27,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_27,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_28,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_28,
        NGAP_ELEMENTARY_PROCEDURES_CLASS_2,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_32,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_33,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_34,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_35,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_36,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_37,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_38,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_39,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_40,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_41,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_42,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_43,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_44,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_45,
        _NGAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_46,
        aMFConfigurationUpdate,
        _aMFConfigurationUpdate_val_InitiatingMessage,
        _aMFConfigurationUpdate_val_SuccessfulOutcome,
        _aMFConfigurationUpdate_val_UnsuccessfulOutcome,
        aMFCPRelocationIndication,
        _aMFCPRelocationIndication_val_InitiatingMessage,
        aMFStatusIndication,
        _aMFStatusIndication_val_InitiatingMessage,
        broadcastSessionModification,
        _broadcastSessionModification_val_InitiatingMessage,
        _broadcastSessionModification_val_SuccessfulOutcome,
        _broadcastSessionModification_val_UnsuccessfulOutcome,
        broadcastSessionRelease,
        _broadcastSessionRelease_val_InitiatingMessage,
        _broadcastSessionRelease_val_SuccessfulOutcome,
        broadcastSessionReleaseRequired,
        _broadcastSessionReleaseRequired_val_InitiatingMessage,
        broadcastSessionSetup,
        _broadcastSessionSetup_val_InitiatingMessage,
        _broadcastSessionSetup_val_SuccessfulOutcome,
        _broadcastSessionSetup_val_UnsuccessfulOutcome,
        cellTrafficTrace,
        _cellTrafficTrace_val_InitiatingMessage,
        connectionEstablishmentIndication,
        _connectionEstablishmentIndication_val_InitiatingMessage,
        deactivateTrace,
        _deactivateTrace_val_InitiatingMessage,
        distributionSetup,
        _distributionSetup_val_InitiatingMessage,
        _distributionSetup_val_SuccessfulOutcome,
        _distributionSetup_val_UnsuccessfulOutcome,
        distributionRelease,
        _distributionRelease_val_InitiatingMessage,
        _distributionRelease_val_SuccessfulOutcome,
        downlinkNASTransport,
        _downlinkNASTransport_val_InitiatingMessage,
        downlinkNonUEAssociatedNRPPaTransport,
        _downlinkNonUEAssociatedNRPPaTransport_val_InitiatingMessage,
        downlinkRANConfigurationTransfer,
        _downlinkRANConfigurationTransfer_val_InitiatingMessage,
        downlinkRANEarlyStatusTransfer,
        _downlinkRANEarlyStatusTransfer_val_InitiatingMessage,
        downlinkRANStatusTransfer,
        _downlinkRANStatusTransfer_val_InitiatingMessage,
        downlinkUEAssociatedNRPPaTransport,
        _downlinkUEAssociatedNRPPaTransport_val_InitiatingMessage,
        errorIndication,
        _errorIndication_val_InitiatingMessage,
        handoverCancel,
        _handoverCancel_val_InitiatingMessage,
        _handoverCancel_val_SuccessfulOutcome,
        handoverNotification,
        _handoverNotification_val_InitiatingMessage,
        handoverPreparation,
        _handoverPreparation_val_InitiatingMessage,
        _handoverPreparation_val_SuccessfulOutcome,
        _handoverPreparation_val_UnsuccessfulOutcome,
        handoverResourceAllocation,
        _handoverResourceAllocation_val_InitiatingMessage,
        _handoverResourceAllocation_val_SuccessfulOutcome,
        _handoverResourceAllocation_val_UnsuccessfulOutcome,
        handoverSuccess,
        _handoverSuccess_val_InitiatingMessage,
        initialContextSetup,
        _initialContextSetup_val_InitiatingMessage,
        _initialContextSetup_val_SuccessfulOutcome,
        _initialContextSetup_val_UnsuccessfulOutcome,
        initialUEMessage,
        _initialUEMessage_val_InitiatingMessage,
        locationReport,
        _locationReport_val_InitiatingMessage,
        locationReportingControl,
        _locationReportingControl_val_InitiatingMessage,
        locationReportingFailureIndication,
        _locationReportingFailureIndication_val_InitiatingMessage,
        multicastSessionActivation,
        _multicastSessionActivation_val_InitiatingMessage,
        _multicastSessionActivation_val_SuccessfulOutcome,
        _multicastSessionActivation_val_UnsuccessfulOutcome,
        multicastSessionDeactivation,
        _multicastSessionDeactivation_val_InitiatingMessage,
        _multicastSessionDeactivation_val_SuccessfulOutcome,
        multicastSessionUpdate,
        _multicastSessionUpdate_val_InitiatingMessage,
        _multicastSessionUpdate_val_SuccessfulOutcome,
        _multicastSessionUpdate_val_UnsuccessfulOutcome,
        multicastGroupPaging,
        _multicastGroupPaging_val_InitiatingMessage,
        nASNonDeliveryIndication,
        _nASNonDeliveryIndication_val_InitiatingMessage,
        nGReset,
        _nGReset_val_InitiatingMessage,
        _nGReset_val_SuccessfulOutcome,
        nGSetup,
        _nGSetup_val_InitiatingMessage,
        _nGSetup_val_SuccessfulOutcome,
        _nGSetup_val_UnsuccessfulOutcome,
        overloadStart,
        _overloadStart_val_InitiatingMessage,
        overloadStop,
        _overloadStop_val_InitiatingMessage,
        paging,
        _paging_val_InitiatingMessage,
        pathSwitchRequest,
        _pathSwitchRequest_val_InitiatingMessage,
        _pathSwitchRequest_val_SuccessfulOutcome,
        _pathSwitchRequest_val_UnsuccessfulOutcome,
        pDUSessionResourceModify,
        _pDUSessionResourceModify_val_InitiatingMessage,
        _pDUSessionResourceModify_val_SuccessfulOutcome,
        pDUSessionResourceModifyIndication,
        _pDUSessionResourceModifyIndication_val_InitiatingMessage,
        _pDUSessionResourceModifyIndication_val_SuccessfulOutcome,
        pDUSessionResourceNotify,
        _pDUSessionResourceNotify_val_InitiatingMessage,
        pDUSessionResourceRelease,
        _pDUSessionResourceRelease_val_InitiatingMessage,
        _pDUSessionResourceRelease_val_SuccessfulOutcome,
        pDUSessionResourceSetup,
        _pDUSessionResourceSetup_val_InitiatingMessage,
        _pDUSessionResourceSetup_val_SuccessfulOutcome,
        privateMessage,
        _privateMessage_val_InitiatingMessage,
        pWSCancel,
        _pWSCancel_val_InitiatingMessage,
        _pWSCancel_val_SuccessfulOutcome,
        pWSFailureIndication,
        _pWSFailureIndication_val_InitiatingMessage,
        pWSRestartIndication,
        _pWSRestartIndication_val_InitiatingMessage,
        rANConfigurationUpdate,
        _rANConfigurationUpdate_val_InitiatingMessage,
        _rANConfigurationUpdate_val_SuccessfulOutcome,
        _rANConfigurationUpdate_val_UnsuccessfulOutcome,
        rANCPRelocationIndication,
        _rANCPRelocationIndication_val_InitiatingMessage,
        rerouteNASRequest,
        _rerouteNASRequest_val_InitiatingMessage,
        retrieveUEInformation,
        _retrieveUEInformation_val_InitiatingMessage,
        rRCInactiveTransitionReport,
        _rRCInactiveTransitionReport_val_InitiatingMessage,
        secondaryRATDataUsageReport,
        _secondaryRATDataUsageReport_val_InitiatingMessage,
        traceFailureIndication,
        _traceFailureIndication_val_InitiatingMessage,
        traceStart,
        _traceStart_val_InitiatingMessage,
        uEContextModification,
        _uEContextModification_val_InitiatingMessage,
        _uEContextModification_val_SuccessfulOutcome,
        _uEContextModification_val_UnsuccessfulOutcome,
        uEContextRelease,
        _uEContextRelease_val_InitiatingMessage,
        _uEContextRelease_val_SuccessfulOutcome,
        uEContextReleaseRequest,
        _uEContextReleaseRequest_val_InitiatingMessage,
        uEContextResume,
        _uEContextResume_val_InitiatingMessage,
        _uEContextResume_val_SuccessfulOutcome,
        _uEContextResume_val_UnsuccessfulOutcome,
        uEContextSuspend,
        _uEContextSuspend_val_InitiatingMessage,
        _uEContextSuspend_val_SuccessfulOutcome,
        _uEContextSuspend_val_UnsuccessfulOutcome,
        uEInformationTransfer,
        _uEInformationTransfer_val_InitiatingMessage,
        uERadioCapabilityCheck,
        _uERadioCapabilityCheck_val_InitiatingMessage,
        _uERadioCapabilityCheck_val_SuccessfulOutcome,
        uERadioCapabilityIDMapping,
        _uERadioCapabilityIDMapping_val_InitiatingMessage,
        _uERadioCapabilityIDMapping_val_SuccessfulOutcome,
        uERadioCapabilityInfoIndication,
        _uERadioCapabilityInfoIndication_val_InitiatingMessage,
        uETNLABindingRelease,
        _uETNLABindingRelease_val_InitiatingMessage,
        uplinkNASTransport,
        _uplinkNASTransport_val_InitiatingMessage,
        uplinkNonUEAssociatedNRPPaTransport,
        _uplinkNonUEAssociatedNRPPaTransport_val_InitiatingMessage,
        uplinkRANConfigurationTransfer,
        _uplinkRANConfigurationTransfer_val_InitiatingMessage,
        uplinkRANEarlyStatusTransfer,
        _uplinkRANEarlyStatusTransfer_val_InitiatingMessage,
        uplinkRANStatusTransfer,
        _uplinkRANStatusTransfer_val_InitiatingMessage,
        uplinkUEAssociatedNRPPaTransport,
        _uplinkUEAssociatedNRPPaTransport_val_InitiatingMessage,
        writeReplaceWarning,
        _writeReplaceWarning_val_InitiatingMessage,
        _writeReplaceWarning_val_SuccessfulOutcome,
        uplinkRIMInformationTransfer,
        _uplinkRIMInformationTransfer_val_InitiatingMessage,
        downlinkRIMInformationTransfer,
        _downlinkRIMInformationTransfer_val_InitiatingMessage,
    ]

init_modules(NGAP_CommonDataTypes, NGAP_Constants, NGAP_Containers, NGAP_IEs, NGAP_PDU_Contents, NGAP_PDU_Descriptions)
