# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class NRPPA_CommonDataTypes:

    _name_  = 'NRPPA-CommonDataTypes'
    _oid_   = [0, 4, 0, 0, 22, 3, 4, 1, 3]
    
    _obj_ = [
        'maxPrivateIEs',
        'maxProtocolExtensions',
        'maxProtocolIEs',
        'Criticality',
        'NRPPATransactionID',
        'Presence',
        'PrivateIE-ID',
        'ProcedureCode',
        'ProtocolIE-ID',
        'TriggeringMessage',
        ]
    _type_ = [
        'Criticality',
        'NRPPATransactionID',
        'Presence',
        'PrivateIE-ID',
        'ProcedureCode',
        'ProtocolIE-ID',
        'TriggeringMessage',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxPrivateIEs',
        'maxProtocolExtensions',
        'maxProtocolIEs',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< maxPrivateIEs >-----#
    maxPrivateIEs = INT(name='maxPrivateIEs', mode=MODE_VALUE)
    maxPrivateIEs._val = 65535
    
    #-----< maxProtocolExtensions >-----#
    maxProtocolExtensions = INT(name='maxProtocolExtensions', mode=MODE_VALUE)
    maxProtocolExtensions._val = 65535
    
    #-----< maxProtocolIEs >-----#
    maxProtocolIEs = INT(name='maxProtocolIEs', mode=MODE_VALUE)
    maxProtocolIEs._val = 65535
    
    #-----< Criticality >-----#
    Criticality = ENUM(name='Criticality', mode=MODE_TYPE)
    Criticality._cont = ASN1Dict([('reject', 0), ('ignore', 1), ('notify', 2)])
    Criticality._ext = None
    
    #-----< NRPPATransactionID >-----#
    NRPPATransactionID = INT(name='NRPPATransactionID', mode=MODE_TYPE)
    NRPPATransactionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    
    #-----< Presence >-----#
    Presence = ENUM(name='Presence', mode=MODE_TYPE)
    Presence._cont = ASN1Dict([('optional', 0), ('conditional', 1), ('mandatory', 2)])
    Presence._ext = None
    
    #-----< PrivateIE-ID >-----#
    PrivateIE_ID = CHOICE(name='PrivateIE-ID', mode=MODE_TYPE)
    _PrivateIE_ID_local = INT(name='local', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrivateIE_ID_local._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PrivateIE_ID_global_ = OID(name='global', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    PrivateIE_ID._cont = ASN1Dict([
        ('local', _PrivateIE_ID_local),
        ('global', _PrivateIE_ID_global_),
        ])
    PrivateIE_ID._ext = None
    
    #-----< ProcedureCode >-----#
    ProcedureCode = INT(name='ProcedureCode', mode=MODE_TYPE)
    ProcedureCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ProtocolIE-ID >-----#
    ProtocolIE_ID = INT(name='ProtocolIE-ID', mode=MODE_TYPE)
    ProtocolIE_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TriggeringMessage >-----#
    TriggeringMessage = ENUM(name='TriggeringMessage', mode=MODE_TYPE)
    TriggeringMessage._cont = ASN1Dict([('initiating-message', 0), ('successful-outcome', 1), ('unsuccessful-outcome', 2)])
    TriggeringMessage._ext = None
    
    _all_ = [
        maxPrivateIEs,
        maxProtocolExtensions,
        maxProtocolIEs,
        Criticality,
        NRPPATransactionID,
        Presence,
        _PrivateIE_ID_local,
        _PrivateIE_ID_global_,
        PrivateIE_ID,
        ProcedureCode,
        ProtocolIE_ID,
        TriggeringMessage,
    ]

class NRPPA_Constants:

    _name_  = 'NRPPA-Constants'
    _oid_   = [0, 4, 0, 0, 22, 3, 4, 1, 4]
    
    _obj_ = [
        'id-errorIndication',
        'id-privateMessage',
        'id-e-CIDMeasurementInitiation',
        'id-e-CIDMeasurementFailureIndication',
        'id-e-CIDMeasurementReport',
        'id-e-CIDMeasurementTermination',
        'id-oTDOAInformationExchange',
        'id-assistanceInformationControl',
        'id-assistanceInformationFeedback',
        'id-positioningInformationExchange',
        'id-positioningInformationUpdate',
        'id-Measurement',
        'id-MeasurementReport',
        'id-MeasurementUpdate',
        'id-MeasurementAbort',
        'id-MeasurementFailureIndication',
        'id-tRPInformationExchange',
        'id-positioningActivation',
        'id-positioningDeactivation',
        'id-pRSConfigurationExchange',
        'id-measurementPreconfiguration',
        'id-measurementActivation',
        'maxNrOfErrors',
        'maxCellinRANnode',
        'maxIndexesReport',
        'maxNoMeas',
        'maxCellReport',
        'maxCellReportNR',
        'maxnoOTDOAtypes',
        'maxServCell',
        'maxEUTRAMeas',
        'maxGERANMeas',
        'maxNRMeas',
        'maxUTRANMeas',
        'maxWLANchannels',
        'maxnoFreqHoppingBandsMinusOne',
        'maxNoPath',
        'maxNrOfPosSImessage',
        'maxnoAssistInfoFailureListItems',
        'maxNrOfSegments',
        'maxNrOfPosSIBs',
        'maxNoOfMeasTRPs',
        'maxnoTRPs',
        'maxnoTRPInfoTypes',
        'maxnoofAngleInfo',
        'maxnolcs-gcs-translation',
        'maxnoBcastCell',
        'maxnoSRSTriggerStates',
        'maxnoSpatialRelations',
        'maxnoPosMeas',
        'maxnoSRS-Carriers',
        'maxnoSCSs',
        'maxnoSRS-Resources',
        'maxnoSRS-PosResources',
        'maxnoSRS-ResourceSets',
        'maxnoSRS-ResourcePerSet',
        'maxnoSRS-PosResourceSets',
        'maxnoSRS-PosResourcePerSet',
        'maxPRS-ResourceSets',
        'maxPRS-ResourcesPerSet',
        'maxNoSSBs',
        'maxnoofPRSresourceSet',
        'maxnoofPRSresource',
        'maxnoofULAoAs',
        'maxNoPathExtended',
        'maxnoARPs',
        'maxnoUETEGs',
        'maxnoTRPTEGs',
        'maxFreqLayers',
        'maxNumResourcesPerAngle',
        'maxnoAzimuthAngles',
        'maxnoElevationAngles',
        'maxnoPRSTRPs',
        'id-Cause',
        'id-CriticalityDiagnostics',
        'id-LMF-UE-Measurement-ID',
        'id-ReportCharacteristics',
        'id-MeasurementPeriodicity',
        'id-MeasurementQuantities',
        'id-RAN-UE-Measurement-ID',
        'id-E-CID-MeasurementResult',
        'id-OTDOACells',
        'id-OTDOA-Information-Type-Group',
        'id-OTDOA-Information-Type-Item',
        'id-MeasurementQuantities-Item',
        'id-RequestedSRSTransmissionCharacteristics',
        'id-Cell-Portion-ID',
        'id-OtherRATMeasurementQuantities',
        'id-OtherRATMeasurementQuantities-Item',
        'id-OtherRATMeasurementResult',
        'id-WLANMeasurementQuantities',
        'id-WLANMeasurementQuantities-Item',
        'id-WLANMeasurementResult',
        'id-TDD-Config-EUTRA-Item',
        'id-Assistance-Information',
        'id-Broadcast',
        'id-AssistanceInformationFailureList',
        'id-SRSConfiguration',
        'id-MeasurementResult',
        'id-TRP-ID',
        'id-TRPInformationTypeListTRPReq',
        'id-TRPInformationListTRPResp',
        'id-MeasurementBeamInfoRequest',
        'id-ResultSS-RSRP',
        'id-ResultSS-RSRQ',
        'id-ResultCSI-RSRP',
        'id-ResultCSI-RSRQ',
        'id-AngleOfArrivalNR',
        'id-GeographicalCoordinates',
        'id-PositioningBroadcastCells',
        'id-LMF-Measurement-ID',
        'id-RAN-Measurement-ID',
        'id-TRP-MeasurementRequestList',
        'id-TRP-MeasurementResponseList',
        'id-TRP-MeasurementReportList',
        'id-SRSType',
        'id-ActivationTime',
        'id-SRSResourceSetID',
        'id-TRPList',
        'id-SRSSpatialRelation',
        'id-SystemFrameNumber',
        'id-SlotNumber',
        'id-SRSResourceTrigger',
        'id-TRPMeasurementQuantities',
        'id-AbortTransmission',
        'id-SFNInitialisationTime',
        'id-ResultNR',
        'id-ResultEUTRA',
        'id-TRPInformationTypeItem',
        'id-CGI-NR',
        'id-SFNInitialisationTime-NR',
        'id-Cell-ID',
        'id-SrsFrequency',
        'id-TRPType',
        'id-SRSSpatialRelationPerSRSResource',
        'id-MeasurementPeriodicityExtended',
        'id-PRS-Resource-ID',
        'id-PRSTRPList',
        'id-PRSTransmissionTRPList',
        'id-OnDemandPRS',
        'id-AoA-SearchWindow',
        'id-TRP-MeasurementUpdateList',
        'id-ZoA',
        'id-ResponseTime',
        'id-UEReportingInformation',
        'id-MultipleULAoA',
        'id-UL-SRS-RSRPP',
        'id-SRSResourcetype',
        'id-ExtendedAdditionalPathList',
        'id-ARPLocationInfo',
        'id-ARP-ID',
        'id-LoS-NLoSInformation',
        'id-UETxTEGAssociationList',
        'id-NumberOfTRPRxTEG',
        'id-NumberOfTRPRxTxTEG',
        'id-TRPTxTEGAssociation',
        'id-TRPTEGInformation',
        'id-TRP-Rx-TEGInformation',
        'id-TRP-PRS-Information-List',
        'id-PRS-Measurements-Info-List',
        'id-PRSConfigRequestType',
        'id-UE-TEG-Info-Request',
        'id-MeasurementTimeOccasion',
        'id-MeasurementCharacteristicsRequestIndicator',
        'id-TRPBeamAntennaInformation',
        'id-NR-TADV',
        'id-MeasurementAmount',
        'id-pathPower',
        'id-PreconfigurationResult',
        'id-RequestType',
        'id-UE-TEG-ReportingPeriodicity',
        'id-SRSPortIndex',
        'id-procedure-code-101-not-to-be-used',
        'id-procedure-code-102-not-to-be-used',
        'id-procedure-code-103-not-to-be-used',
        'id-UETxTimingErrorMargin',
        'id-MeasurementPeriodicityNR-AoA',
        'id-SRSTransmissionStatus',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        'id-errorIndication',
        'id-privateMessage',
        'id-e-CIDMeasurementInitiation',
        'id-e-CIDMeasurementFailureIndication',
        'id-e-CIDMeasurementReport',
        'id-e-CIDMeasurementTermination',
        'id-oTDOAInformationExchange',
        'id-assistanceInformationControl',
        'id-assistanceInformationFeedback',
        'id-positioningInformationExchange',
        'id-positioningInformationUpdate',
        'id-Measurement',
        'id-MeasurementReport',
        'id-MeasurementUpdate',
        'id-MeasurementAbort',
        'id-MeasurementFailureIndication',
        'id-tRPInformationExchange',
        'id-positioningActivation',
        'id-positioningDeactivation',
        'id-pRSConfigurationExchange',
        'id-measurementPreconfiguration',
        'id-measurementActivation',
        'maxNrOfErrors',
        'maxCellinRANnode',
        'maxIndexesReport',
        'maxNoMeas',
        'maxCellReport',
        'maxCellReportNR',
        'maxnoOTDOAtypes',
        'maxServCell',
        'maxEUTRAMeas',
        'maxGERANMeas',
        'maxNRMeas',
        'maxUTRANMeas',
        'maxWLANchannels',
        'maxnoFreqHoppingBandsMinusOne',
        'maxNoPath',
        'maxNrOfPosSImessage',
        'maxnoAssistInfoFailureListItems',
        'maxNrOfSegments',
        'maxNrOfPosSIBs',
        'maxNoOfMeasTRPs',
        'maxnoTRPs',
        'maxnoTRPInfoTypes',
        'maxnoofAngleInfo',
        'maxnolcs-gcs-translation',
        'maxnoBcastCell',
        'maxnoSRSTriggerStates',
        'maxnoSpatialRelations',
        'maxnoPosMeas',
        'maxnoSRS-Carriers',
        'maxnoSCSs',
        'maxnoSRS-Resources',
        'maxnoSRS-PosResources',
        'maxnoSRS-ResourceSets',
        'maxnoSRS-ResourcePerSet',
        'maxnoSRS-PosResourceSets',
        'maxnoSRS-PosResourcePerSet',
        'maxPRS-ResourceSets',
        'maxPRS-ResourcesPerSet',
        'maxNoSSBs',
        'maxnoofPRSresourceSet',
        'maxnoofPRSresource',
        'maxnoofULAoAs',
        'maxNoPathExtended',
        'maxnoARPs',
        'maxnoUETEGs',
        'maxnoTRPTEGs',
        'maxFreqLayers',
        'maxNumResourcesPerAngle',
        'maxnoAzimuthAngles',
        'maxnoElevationAngles',
        'maxnoPRSTRPs',
        'id-Cause',
        'id-CriticalityDiagnostics',
        'id-LMF-UE-Measurement-ID',
        'id-ReportCharacteristics',
        'id-MeasurementPeriodicity',
        'id-MeasurementQuantities',
        'id-RAN-UE-Measurement-ID',
        'id-E-CID-MeasurementResult',
        'id-OTDOACells',
        'id-OTDOA-Information-Type-Group',
        'id-OTDOA-Information-Type-Item',
        'id-MeasurementQuantities-Item',
        'id-RequestedSRSTransmissionCharacteristics',
        'id-Cell-Portion-ID',
        'id-OtherRATMeasurementQuantities',
        'id-OtherRATMeasurementQuantities-Item',
        'id-OtherRATMeasurementResult',
        'id-WLANMeasurementQuantities',
        'id-WLANMeasurementQuantities-Item',
        'id-WLANMeasurementResult',
        'id-TDD-Config-EUTRA-Item',
        'id-Assistance-Information',
        'id-Broadcast',
        'id-AssistanceInformationFailureList',
        'id-SRSConfiguration',
        'id-MeasurementResult',
        'id-TRP-ID',
        'id-TRPInformationTypeListTRPReq',
        'id-TRPInformationListTRPResp',
        'id-MeasurementBeamInfoRequest',
        'id-ResultSS-RSRP',
        'id-ResultSS-RSRQ',
        'id-ResultCSI-RSRP',
        'id-ResultCSI-RSRQ',
        'id-AngleOfArrivalNR',
        'id-GeographicalCoordinates',
        'id-PositioningBroadcastCells',
        'id-LMF-Measurement-ID',
        'id-RAN-Measurement-ID',
        'id-TRP-MeasurementRequestList',
        'id-TRP-MeasurementResponseList',
        'id-TRP-MeasurementReportList',
        'id-SRSType',
        'id-ActivationTime',
        'id-SRSResourceSetID',
        'id-TRPList',
        'id-SRSSpatialRelation',
        'id-SystemFrameNumber',
        'id-SlotNumber',
        'id-SRSResourceTrigger',
        'id-TRPMeasurementQuantities',
        'id-AbortTransmission',
        'id-SFNInitialisationTime',
        'id-ResultNR',
        'id-ResultEUTRA',
        'id-TRPInformationTypeItem',
        'id-CGI-NR',
        'id-SFNInitialisationTime-NR',
        'id-Cell-ID',
        'id-SrsFrequency',
        'id-TRPType',
        'id-SRSSpatialRelationPerSRSResource',
        'id-MeasurementPeriodicityExtended',
        'id-PRS-Resource-ID',
        'id-PRSTRPList',
        'id-PRSTransmissionTRPList',
        'id-OnDemandPRS',
        'id-AoA-SearchWindow',
        'id-TRP-MeasurementUpdateList',
        'id-ZoA',
        'id-ResponseTime',
        'id-UEReportingInformation',
        'id-MultipleULAoA',
        'id-UL-SRS-RSRPP',
        'id-SRSResourcetype',
        'id-ExtendedAdditionalPathList',
        'id-ARPLocationInfo',
        'id-ARP-ID',
        'id-LoS-NLoSInformation',
        'id-UETxTEGAssociationList',
        'id-NumberOfTRPRxTEG',
        'id-NumberOfTRPRxTxTEG',
        'id-TRPTxTEGAssociation',
        'id-TRPTEGInformation',
        'id-TRP-Rx-TEGInformation',
        'id-TRP-PRS-Information-List',
        'id-PRS-Measurements-Info-List',
        'id-PRSConfigRequestType',
        'id-UE-TEG-Info-Request',
        'id-MeasurementTimeOccasion',
        'id-MeasurementCharacteristicsRequestIndicator',
        'id-TRPBeamAntennaInformation',
        'id-NR-TADV',
        'id-MeasurementAmount',
        'id-pathPower',
        'id-PreconfigurationResult',
        'id-RequestType',
        'id-UE-TEG-ReportingPeriodicity',
        'id-SRSPortIndex',
        'id-procedure-code-101-not-to-be-used',
        'id-procedure-code-102-not-to-be-used',
        'id-procedure-code-103-not-to-be-used',
        'id-UETxTimingErrorMargin',
        'id-MeasurementPeriodicityNR-AoA',
        'id-SRSTransmissionStatus',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< id-errorIndication >-----#
    id_errorIndication = INT(name='id-errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_errorIndication._val = 0
    
    #-----< id-privateMessage >-----#
    id_privateMessage = INT(name='id-privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_privateMessage._val = 1
    
    #-----< id-e-CIDMeasurementInitiation >-----#
    id_e_CIDMeasurementInitiation = INT(name='id-e-CIDMeasurementInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_e_CIDMeasurementInitiation._val = 2
    
    #-----< id-e-CIDMeasurementFailureIndication >-----#
    id_e_CIDMeasurementFailureIndication = INT(name='id-e-CIDMeasurementFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_e_CIDMeasurementFailureIndication._val = 3
    
    #-----< id-e-CIDMeasurementReport >-----#
    id_e_CIDMeasurementReport = INT(name='id-e-CIDMeasurementReport', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_e_CIDMeasurementReport._val = 4
    
    #-----< id-e-CIDMeasurementTermination >-----#
    id_e_CIDMeasurementTermination = INT(name='id-e-CIDMeasurementTermination', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_e_CIDMeasurementTermination._val = 5
    
    #-----< id-oTDOAInformationExchange >-----#
    id_oTDOAInformationExchange = INT(name='id-oTDOAInformationExchange', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_oTDOAInformationExchange._val = 6
    
    #-----< id-assistanceInformationControl >-----#
    id_assistanceInformationControl = INT(name='id-assistanceInformationControl', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_assistanceInformationControl._val = 7
    
    #-----< id-assistanceInformationFeedback >-----#
    id_assistanceInformationFeedback = INT(name='id-assistanceInformationFeedback', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_assistanceInformationFeedback._val = 8
    
    #-----< id-positioningInformationExchange >-----#
    id_positioningInformationExchange = INT(name='id-positioningInformationExchange', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_positioningInformationExchange._val = 9
    
    #-----< id-positioningInformationUpdate >-----#
    id_positioningInformationUpdate = INT(name='id-positioningInformationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_positioningInformationUpdate._val = 10
    
    #-----< id-Measurement >-----#
    id_Measurement = INT(name='id-Measurement', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_Measurement._val = 11
    
    #-----< id-MeasurementReport >-----#
    id_MeasurementReport = INT(name='id-MeasurementReport', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_MeasurementReport._val = 12
    
    #-----< id-MeasurementUpdate >-----#
    id_MeasurementUpdate = INT(name='id-MeasurementUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_MeasurementUpdate._val = 13
    
    #-----< id-MeasurementAbort >-----#
    id_MeasurementAbort = INT(name='id-MeasurementAbort', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_MeasurementAbort._val = 14
    
    #-----< id-MeasurementFailureIndication >-----#
    id_MeasurementFailureIndication = INT(name='id-MeasurementFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_MeasurementFailureIndication._val = 15
    
    #-----< id-tRPInformationExchange >-----#
    id_tRPInformationExchange = INT(name='id-tRPInformationExchange', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_tRPInformationExchange._val = 16
    
    #-----< id-positioningActivation >-----#
    id_positioningActivation = INT(name='id-positioningActivation', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_positioningActivation._val = 17
    
    #-----< id-positioningDeactivation >-----#
    id_positioningDeactivation = INT(name='id-positioningDeactivation', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_positioningDeactivation._val = 18
    
    #-----< id-pRSConfigurationExchange >-----#
    id_pRSConfigurationExchange = INT(name='id-pRSConfigurationExchange', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_pRSConfigurationExchange._val = 19
    
    #-----< id-measurementPreconfiguration >-----#
    id_measurementPreconfiguration = INT(name='id-measurementPreconfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_measurementPreconfiguration._val = 20
    
    #-----< id-measurementActivation >-----#
    id_measurementActivation = INT(name='id-measurementActivation', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')))
    id_measurementActivation._val = 21
    
    #-----< maxNrOfErrors >-----#
    maxNrOfErrors = INT(name='maxNrOfErrors', mode=MODE_VALUE)
    maxNrOfErrors._val = 256
    
    #-----< maxCellinRANnode >-----#
    maxCellinRANnode = INT(name='maxCellinRANnode', mode=MODE_VALUE)
    maxCellinRANnode._val = 3840
    
    #-----< maxIndexesReport >-----#
    maxIndexesReport = INT(name='maxIndexesReport', mode=MODE_VALUE)
    maxIndexesReport._val = 64
    
    #-----< maxNoMeas >-----#
    maxNoMeas = INT(name='maxNoMeas', mode=MODE_VALUE)
    maxNoMeas._val = 64
    
    #-----< maxCellReport >-----#
    maxCellReport = INT(name='maxCellReport', mode=MODE_VALUE)
    maxCellReport._val = 9
    
    #-----< maxCellReportNR >-----#
    maxCellReportNR = INT(name='maxCellReportNR', mode=MODE_VALUE)
    maxCellReportNR._val = 9
    
    #-----< maxnoOTDOAtypes >-----#
    maxnoOTDOAtypes = INT(name='maxnoOTDOAtypes', mode=MODE_VALUE)
    maxnoOTDOAtypes._val = 63
    
    #-----< maxServCell >-----#
    maxServCell = INT(name='maxServCell', mode=MODE_VALUE)
    maxServCell._val = 5
    
    #-----< maxEUTRAMeas >-----#
    maxEUTRAMeas = INT(name='maxEUTRAMeas', mode=MODE_VALUE)
    maxEUTRAMeas._val = 8
    
    #-----< maxGERANMeas >-----#
    maxGERANMeas = INT(name='maxGERANMeas', mode=MODE_VALUE)
    maxGERANMeas._val = 8
    
    #-----< maxNRMeas >-----#
    maxNRMeas = INT(name='maxNRMeas', mode=MODE_VALUE)
    maxNRMeas._val = 8
    
    #-----< maxUTRANMeas >-----#
    maxUTRANMeas = INT(name='maxUTRANMeas', mode=MODE_VALUE)
    maxUTRANMeas._val = 8
    
    #-----< maxWLANchannels >-----#
    maxWLANchannels = INT(name='maxWLANchannels', mode=MODE_VALUE)
    maxWLANchannels._val = 16
    
    #-----< maxnoFreqHoppingBandsMinusOne >-----#
    maxnoFreqHoppingBandsMinusOne = INT(name='maxnoFreqHoppingBandsMinusOne', mode=MODE_VALUE)
    maxnoFreqHoppingBandsMinusOne._val = 7
    
    #-----< maxNoPath >-----#
    maxNoPath = INT(name='maxNoPath', mode=MODE_VALUE)
    maxNoPath._val = 2
    
    #-----< maxNrOfPosSImessage >-----#
    maxNrOfPosSImessage = INT(name='maxNrOfPosSImessage', mode=MODE_VALUE)
    maxNrOfPosSImessage._val = 32
    
    #-----< maxnoAssistInfoFailureListItems >-----#
    maxnoAssistInfoFailureListItems = INT(name='maxnoAssistInfoFailureListItems', mode=MODE_VALUE)
    maxnoAssistInfoFailureListItems._val = 32
    
    #-----< maxNrOfSegments >-----#
    maxNrOfSegments = INT(name='maxNrOfSegments', mode=MODE_VALUE)
    maxNrOfSegments._val = 64
    
    #-----< maxNrOfPosSIBs >-----#
    maxNrOfPosSIBs = INT(name='maxNrOfPosSIBs', mode=MODE_VALUE)
    maxNrOfPosSIBs._val = 32
    
    #-----< maxNoOfMeasTRPs >-----#
    maxNoOfMeasTRPs = INT(name='maxNoOfMeasTRPs', mode=MODE_VALUE)
    maxNoOfMeasTRPs._val = 64
    
    #-----< maxnoTRPs >-----#
    maxnoTRPs = INT(name='maxnoTRPs', mode=MODE_VALUE)
    maxnoTRPs._val = 65535
    
    #-----< maxnoTRPInfoTypes >-----#
    maxnoTRPInfoTypes = INT(name='maxnoTRPInfoTypes', mode=MODE_VALUE)
    maxnoTRPInfoTypes._val = 64
    
    #-----< maxnoofAngleInfo >-----#
    maxnoofAngleInfo = INT(name='maxnoofAngleInfo', mode=MODE_VALUE)
    maxnoofAngleInfo._val = 65535
    
    #-----< maxnolcs-gcs-translation >-----#
    maxnolcs_gcs_translation = INT(name='maxnolcs-gcs-translation', mode=MODE_VALUE)
    maxnolcs_gcs_translation._val = 3
    
    #-----< maxnoBcastCell >-----#
    maxnoBcastCell = INT(name='maxnoBcastCell', mode=MODE_VALUE)
    maxnoBcastCell._val = 16384
    
    #-----< maxnoSRSTriggerStates >-----#
    maxnoSRSTriggerStates = INT(name='maxnoSRSTriggerStates', mode=MODE_VALUE)
    maxnoSRSTriggerStates._val = 3
    
    #-----< maxnoSpatialRelations >-----#
    maxnoSpatialRelations = INT(name='maxnoSpatialRelations', mode=MODE_VALUE)
    maxnoSpatialRelations._val = 64
    
    #-----< maxnoPosMeas >-----#
    maxnoPosMeas = INT(name='maxnoPosMeas', mode=MODE_VALUE)
    maxnoPosMeas._val = 16384
    
    #-----< maxnoSRS-Carriers >-----#
    maxnoSRS_Carriers = INT(name='maxnoSRS-Carriers', mode=MODE_VALUE)
    maxnoSRS_Carriers._val = 32
    
    #-----< maxnoSCSs >-----#
    maxnoSCSs = INT(name='maxnoSCSs', mode=MODE_VALUE)
    maxnoSCSs._val = 5
    
    #-----< maxnoSRS-Resources >-----#
    maxnoSRS_Resources = INT(name='maxnoSRS-Resources', mode=MODE_VALUE)
    maxnoSRS_Resources._val = 64
    
    #-----< maxnoSRS-PosResources >-----#
    maxnoSRS_PosResources = INT(name='maxnoSRS-PosResources', mode=MODE_VALUE)
    maxnoSRS_PosResources._val = 64
    
    #-----< maxnoSRS-ResourceSets >-----#
    maxnoSRS_ResourceSets = INT(name='maxnoSRS-ResourceSets', mode=MODE_VALUE)
    maxnoSRS_ResourceSets._val = 16
    
    #-----< maxnoSRS-ResourcePerSet >-----#
    maxnoSRS_ResourcePerSet = INT(name='maxnoSRS-ResourcePerSet', mode=MODE_VALUE)
    maxnoSRS_ResourcePerSet._val = 16
    
    #-----< maxnoSRS-PosResourceSets >-----#
    maxnoSRS_PosResourceSets = INT(name='maxnoSRS-PosResourceSets', mode=MODE_VALUE)
    maxnoSRS_PosResourceSets._val = 16
    
    #-----< maxnoSRS-PosResourcePerSet >-----#
    maxnoSRS_PosResourcePerSet = INT(name='maxnoSRS-PosResourcePerSet', mode=MODE_VALUE)
    maxnoSRS_PosResourcePerSet._val = 16
    
    #-----< maxPRS-ResourceSets >-----#
    maxPRS_ResourceSets = INT(name='maxPRS-ResourceSets', mode=MODE_VALUE)
    maxPRS_ResourceSets._val = 2
    
    #-----< maxPRS-ResourcesPerSet >-----#
    maxPRS_ResourcesPerSet = INT(name='maxPRS-ResourcesPerSet', mode=MODE_VALUE)
    maxPRS_ResourcesPerSet._val = 64
    
    #-----< maxNoSSBs >-----#
    maxNoSSBs = INT(name='maxNoSSBs', mode=MODE_VALUE)
    maxNoSSBs._val = 255
    
    #-----< maxnoofPRSresourceSet >-----#
    maxnoofPRSresourceSet = INT(name='maxnoofPRSresourceSet', mode=MODE_VALUE)
    maxnoofPRSresourceSet._val = 8
    
    #-----< maxnoofPRSresource >-----#
    maxnoofPRSresource = INT(name='maxnoofPRSresource', mode=MODE_VALUE)
    maxnoofPRSresource._val = 64
    
    #-----< maxnoofULAoAs >-----#
    maxnoofULAoAs = INT(name='maxnoofULAoAs', mode=MODE_VALUE)
    maxnoofULAoAs._val = 8
    
    #-----< maxNoPathExtended >-----#
    maxNoPathExtended = INT(name='maxNoPathExtended', mode=MODE_VALUE)
    maxNoPathExtended._val = 8
    
    #-----< maxnoARPs >-----#
    maxnoARPs = INT(name='maxnoARPs', mode=MODE_VALUE)
    maxnoARPs._val = 16
    
    #-----< maxnoUETEGs >-----#
    maxnoUETEGs = INT(name='maxnoUETEGs', mode=MODE_VALUE)
    maxnoUETEGs._val = 256
    
    #-----< maxnoTRPTEGs >-----#
    maxnoTRPTEGs = INT(name='maxnoTRPTEGs', mode=MODE_VALUE)
    maxnoTRPTEGs._val = 8
    
    #-----< maxFreqLayers >-----#
    maxFreqLayers = INT(name='maxFreqLayers', mode=MODE_VALUE)
    maxFreqLayers._val = 4
    
    #-----< maxNumResourcesPerAngle >-----#
    maxNumResourcesPerAngle = INT(name='maxNumResourcesPerAngle', mode=MODE_VALUE)
    maxNumResourcesPerAngle._val = 24
    
    #-----< maxnoAzimuthAngles >-----#
    maxnoAzimuthAngles = INT(name='maxnoAzimuthAngles', mode=MODE_VALUE)
    maxnoAzimuthAngles._val = 3600
    
    #-----< maxnoElevationAngles >-----#
    maxnoElevationAngles = INT(name='maxnoElevationAngles', mode=MODE_VALUE)
    maxnoElevationAngles._val = 1801
    
    #-----< maxnoPRSTRPs >-----#
    maxnoPRSTRPs = INT(name='maxnoPRSTRPs', mode=MODE_VALUE)
    maxnoPRSTRPs._val = 256
    
    #-----< id-Cause >-----#
    id_Cause = INT(name='id-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cause._val = 0
    
    #-----< id-CriticalityDiagnostics >-----#
    id_CriticalityDiagnostics = INT(name='id-CriticalityDiagnostics', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_CriticalityDiagnostics._val = 1
    
    #-----< id-LMF-UE-Measurement-ID >-----#
    id_LMF_UE_Measurement_ID = INT(name='id-LMF-UE-Measurement-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_LMF_UE_Measurement_ID._val = 2
    
    #-----< id-ReportCharacteristics >-----#
    id_ReportCharacteristics = INT(name='id-ReportCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReportCharacteristics._val = 3
    
    #-----< id-MeasurementPeriodicity >-----#
    id_MeasurementPeriodicity = INT(name='id-MeasurementPeriodicity', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementPeriodicity._val = 4
    
    #-----< id-MeasurementQuantities >-----#
    id_MeasurementQuantities = INT(name='id-MeasurementQuantities', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementQuantities._val = 5
    
    #-----< id-RAN-UE-Measurement-ID >-----#
    id_RAN_UE_Measurement_ID = INT(name='id-RAN-UE-Measurement-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_RAN_UE_Measurement_ID._val = 6
    
    #-----< id-E-CID-MeasurementResult >-----#
    id_E_CID_MeasurementResult = INT(name='id-E-CID-MeasurementResult', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_CID_MeasurementResult._val = 7
    
    #-----< id-OTDOACells >-----#
    id_OTDOACells = INT(name='id-OTDOACells', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_OTDOACells._val = 8
    
    #-----< id-OTDOA-Information-Type-Group >-----#
    id_OTDOA_Information_Type_Group = INT(name='id-OTDOA-Information-Type-Group', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_OTDOA_Information_Type_Group._val = 9
    
    #-----< id-OTDOA-Information-Type-Item >-----#
    id_OTDOA_Information_Type_Item = INT(name='id-OTDOA-Information-Type-Item', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_OTDOA_Information_Type_Item._val = 10
    
    #-----< id-MeasurementQuantities-Item >-----#
    id_MeasurementQuantities_Item = INT(name='id-MeasurementQuantities-Item', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementQuantities_Item._val = 11
    
    #-----< id-RequestedSRSTransmissionCharacteristics >-----#
    id_RequestedSRSTransmissionCharacteristics = INT(name='id-RequestedSRSTransmissionCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_RequestedSRSTransmissionCharacteristics._val = 12
    
    #-----< id-Cell-Portion-ID >-----#
    id_Cell_Portion_ID = INT(name='id-Cell-Portion-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cell_Portion_ID._val = 14
    
    #-----< id-OtherRATMeasurementQuantities >-----#
    id_OtherRATMeasurementQuantities = INT(name='id-OtherRATMeasurementQuantities', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_OtherRATMeasurementQuantities._val = 15
    
    #-----< id-OtherRATMeasurementQuantities-Item >-----#
    id_OtherRATMeasurementQuantities_Item = INT(name='id-OtherRATMeasurementQuantities-Item', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_OtherRATMeasurementQuantities_Item._val = 16
    
    #-----< id-OtherRATMeasurementResult >-----#
    id_OtherRATMeasurementResult = INT(name='id-OtherRATMeasurementResult', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_OtherRATMeasurementResult._val = 17
    
    #-----< id-WLANMeasurementQuantities >-----#
    id_WLANMeasurementQuantities = INT(name='id-WLANMeasurementQuantities', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_WLANMeasurementQuantities._val = 19
    
    #-----< id-WLANMeasurementQuantities-Item >-----#
    id_WLANMeasurementQuantities_Item = INT(name='id-WLANMeasurementQuantities-Item', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_WLANMeasurementQuantities_Item._val = 20
    
    #-----< id-WLANMeasurementResult >-----#
    id_WLANMeasurementResult = INT(name='id-WLANMeasurementResult', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_WLANMeasurementResult._val = 21
    
    #-----< id-TDD-Config-EUTRA-Item >-----#
    id_TDD_Config_EUTRA_Item = INT(name='id-TDD-Config-EUTRA-Item', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD_Config_EUTRA_Item._val = 22
    
    #-----< id-Assistance-Information >-----#
    id_Assistance_Information = INT(name='id-Assistance-Information', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_Assistance_Information._val = 23
    
    #-----< id-Broadcast >-----#
    id_Broadcast = INT(name='id-Broadcast', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_Broadcast._val = 24
    
    #-----< id-AssistanceInformationFailureList >-----#
    id_AssistanceInformationFailureList = INT(name='id-AssistanceInformationFailureList', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_AssistanceInformationFailureList._val = 25
    
    #-----< id-SRSConfiguration >-----#
    id_SRSConfiguration = INT(name='id-SRSConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRSConfiguration._val = 26
    
    #-----< id-MeasurementResult >-----#
    id_MeasurementResult = INT(name='id-MeasurementResult', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementResult._val = 27
    
    #-----< id-TRP-ID >-----#
    id_TRP_ID = INT(name='id-TRP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRP_ID._val = 28
    
    #-----< id-TRPInformationTypeListTRPReq >-----#
    id_TRPInformationTypeListTRPReq = INT(name='id-TRPInformationTypeListTRPReq', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPInformationTypeListTRPReq._val = 29
    
    #-----< id-TRPInformationListTRPResp >-----#
    id_TRPInformationListTRPResp = INT(name='id-TRPInformationListTRPResp', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPInformationListTRPResp._val = 30
    
    #-----< id-MeasurementBeamInfoRequest >-----#
    id_MeasurementBeamInfoRequest = INT(name='id-MeasurementBeamInfoRequest', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementBeamInfoRequest._val = 31
    
    #-----< id-ResultSS-RSRP >-----#
    id_ResultSS_RSRP = INT(name='id-ResultSS-RSRP', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResultSS_RSRP._val = 32
    
    #-----< id-ResultSS-RSRQ >-----#
    id_ResultSS_RSRQ = INT(name='id-ResultSS-RSRQ', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResultSS_RSRQ._val = 33
    
    #-----< id-ResultCSI-RSRP >-----#
    id_ResultCSI_RSRP = INT(name='id-ResultCSI-RSRP', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResultCSI_RSRP._val = 34
    
    #-----< id-ResultCSI-RSRQ >-----#
    id_ResultCSI_RSRQ = INT(name='id-ResultCSI-RSRQ', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResultCSI_RSRQ._val = 35
    
    #-----< id-AngleOfArrivalNR >-----#
    id_AngleOfArrivalNR = INT(name='id-AngleOfArrivalNR', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_AngleOfArrivalNR._val = 36
    
    #-----< id-GeographicalCoordinates >-----#
    id_GeographicalCoordinates = INT(name='id-GeographicalCoordinates', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_GeographicalCoordinates._val = 37
    
    #-----< id-PositioningBroadcastCells >-----#
    id_PositioningBroadcastCells = INT(name='id-PositioningBroadcastCells', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_PositioningBroadcastCells._val = 38
    
    #-----< id-LMF-Measurement-ID >-----#
    id_LMF_Measurement_ID = INT(name='id-LMF-Measurement-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_LMF_Measurement_ID._val = 39
    
    #-----< id-RAN-Measurement-ID >-----#
    id_RAN_Measurement_ID = INT(name='id-RAN-Measurement-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_RAN_Measurement_ID._val = 40
    
    #-----< id-TRP-MeasurementRequestList >-----#
    id_TRP_MeasurementRequestList = INT(name='id-TRP-MeasurementRequestList', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRP_MeasurementRequestList._val = 41
    
    #-----< id-TRP-MeasurementResponseList >-----#
    id_TRP_MeasurementResponseList = INT(name='id-TRP-MeasurementResponseList', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRP_MeasurementResponseList._val = 42
    
    #-----< id-TRP-MeasurementReportList >-----#
    id_TRP_MeasurementReportList = INT(name='id-TRP-MeasurementReportList', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRP_MeasurementReportList._val = 43
    
    #-----< id-SRSType >-----#
    id_SRSType = INT(name='id-SRSType', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRSType._val = 44
    
    #-----< id-ActivationTime >-----#
    id_ActivationTime = INT(name='id-ActivationTime', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_ActivationTime._val = 45
    
    #-----< id-SRSResourceSetID >-----#
    id_SRSResourceSetID = INT(name='id-SRSResourceSetID', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRSResourceSetID._val = 46
    
    #-----< id-TRPList >-----#
    id_TRPList = INT(name='id-TRPList', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPList._val = 47
    
    #-----< id-SRSSpatialRelation >-----#
    id_SRSSpatialRelation = INT(name='id-SRSSpatialRelation', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRSSpatialRelation._val = 48
    
    #-----< id-SystemFrameNumber >-----#
    id_SystemFrameNumber = INT(name='id-SystemFrameNumber', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_SystemFrameNumber._val = 49
    
    #-----< id-SlotNumber >-----#
    id_SlotNumber = INT(name='id-SlotNumber', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_SlotNumber._val = 50
    
    #-----< id-SRSResourceTrigger >-----#
    id_SRSResourceTrigger = INT(name='id-SRSResourceTrigger', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRSResourceTrigger._val = 51
    
    #-----< id-TRPMeasurementQuantities >-----#
    id_TRPMeasurementQuantities = INT(name='id-TRPMeasurementQuantities', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPMeasurementQuantities._val = 52
    
    #-----< id-AbortTransmission >-----#
    id_AbortTransmission = INT(name='id-AbortTransmission', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_AbortTransmission._val = 53
    
    #-----< id-SFNInitialisationTime >-----#
    id_SFNInitialisationTime = INT(name='id-SFNInitialisationTime', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_SFNInitialisationTime._val = 54
    
    #-----< id-ResultNR >-----#
    id_ResultNR = INT(name='id-ResultNR', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResultNR._val = 55
    
    #-----< id-ResultEUTRA >-----#
    id_ResultEUTRA = INT(name='id-ResultEUTRA', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResultEUTRA._val = 56
    
    #-----< id-TRPInformationTypeItem >-----#
    id_TRPInformationTypeItem = INT(name='id-TRPInformationTypeItem', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPInformationTypeItem._val = 57
    
    #-----< id-CGI-NR >-----#
    id_CGI_NR = INT(name='id-CGI-NR', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_CGI_NR._val = 58
    
    #-----< id-SFNInitialisationTime-NR >-----#
    id_SFNInitialisationTime_NR = INT(name='id-SFNInitialisationTime-NR', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_SFNInitialisationTime_NR._val = 59
    
    #-----< id-Cell-ID >-----#
    id_Cell_ID = INT(name='id-Cell-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cell_ID._val = 60
    
    #-----< id-SrsFrequency >-----#
    id_SrsFrequency = INT(name='id-SrsFrequency', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_SrsFrequency._val = 61
    
    #-----< id-TRPType >-----#
    id_TRPType = INT(name='id-TRPType', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPType._val = 62
    
    #-----< id-SRSSpatialRelationPerSRSResource >-----#
    id_SRSSpatialRelationPerSRSResource = INT(name='id-SRSSpatialRelationPerSRSResource', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRSSpatialRelationPerSRSResource._val = 63
    
    #-----< id-MeasurementPeriodicityExtended >-----#
    id_MeasurementPeriodicityExtended = INT(name='id-MeasurementPeriodicityExtended', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementPeriodicityExtended._val = 64
    
    #-----< id-PRS-Resource-ID >-----#
    id_PRS_Resource_ID = INT(name='id-PRS-Resource-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_PRS_Resource_ID._val = 65
    
    #-----< id-PRSTRPList >-----#
    id_PRSTRPList = INT(name='id-PRSTRPList', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_PRSTRPList._val = 66
    
    #-----< id-PRSTransmissionTRPList >-----#
    id_PRSTransmissionTRPList = INT(name='id-PRSTransmissionTRPList', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_PRSTransmissionTRPList._val = 67
    
    #-----< id-OnDemandPRS >-----#
    id_OnDemandPRS = INT(name='id-OnDemandPRS', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_OnDemandPRS._val = 68
    
    #-----< id-AoA-SearchWindow >-----#
    id_AoA_SearchWindow = INT(name='id-AoA-SearchWindow', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_AoA_SearchWindow._val = 69
    
    #-----< id-TRP-MeasurementUpdateList >-----#
    id_TRP_MeasurementUpdateList = INT(name='id-TRP-MeasurementUpdateList', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRP_MeasurementUpdateList._val = 70
    
    #-----< id-ZoA >-----#
    id_ZoA = INT(name='id-ZoA', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_ZoA._val = 71
    
    #-----< id-ResponseTime >-----#
    id_ResponseTime = INT(name='id-ResponseTime', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResponseTime._val = 72
    
    #-----< id-UEReportingInformation >-----#
    id_UEReportingInformation = INT(name='id-UEReportingInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEReportingInformation._val = 73
    
    #-----< id-MultipleULAoA >-----#
    id_MultipleULAoA = INT(name='id-MultipleULAoA', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_MultipleULAoA._val = 74
    
    #-----< id-UL-SRS-RSRPP >-----#
    id_UL_SRS_RSRPP = INT(name='id-UL-SRS-RSRPP', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_SRS_RSRPP._val = 75
    
    #-----< id-SRSResourcetype >-----#
    id_SRSResourcetype = INT(name='id-SRSResourcetype', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRSResourcetype._val = 76
    
    #-----< id-ExtendedAdditionalPathList >-----#
    id_ExtendedAdditionalPathList = INT(name='id-ExtendedAdditionalPathList', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedAdditionalPathList._val = 77
    
    #-----< id-ARPLocationInfo >-----#
    id_ARPLocationInfo = INT(name='id-ARPLocationInfo', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_ARPLocationInfo._val = 78
    
    #-----< id-ARP-ID >-----#
    id_ARP_ID = INT(name='id-ARP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_ARP_ID._val = 79
    
    #-----< id-LoS-NLoSInformation >-----#
    id_LoS_NLoSInformation = INT(name='id-LoS-NLoSInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_LoS_NLoSInformation._val = 80
    
    #-----< id-UETxTEGAssociationList >-----#
    id_UETxTEGAssociationList = INT(name='id-UETxTEGAssociationList', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_UETxTEGAssociationList._val = 81
    
    #-----< id-NumberOfTRPRxTEG >-----#
    id_NumberOfTRPRxTEG = INT(name='id-NumberOfTRPRxTEG', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_NumberOfTRPRxTEG._val = 82
    
    #-----< id-NumberOfTRPRxTxTEG >-----#
    id_NumberOfTRPRxTxTEG = INT(name='id-NumberOfTRPRxTxTEG', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_NumberOfTRPRxTxTEG._val = 83
    
    #-----< id-TRPTxTEGAssociation >-----#
    id_TRPTxTEGAssociation = INT(name='id-TRPTxTEGAssociation', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPTxTEGAssociation._val = 84
    
    #-----< id-TRPTEGInformation >-----#
    id_TRPTEGInformation = INT(name='id-TRPTEGInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPTEGInformation._val = 85
    
    #-----< id-TRP-Rx-TEGInformation >-----#
    id_TRP_Rx_TEGInformation = INT(name='id-TRP-Rx-TEGInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRP_Rx_TEGInformation._val = 86
    
    #-----< id-TRP-PRS-Information-List >-----#
    id_TRP_PRS_Information_List = INT(name='id-TRP-PRS-Information-List', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRP_PRS_Information_List._val = 87
    
    #-----< id-PRS-Measurements-Info-List >-----#
    id_PRS_Measurements_Info_List = INT(name='id-PRS-Measurements-Info-List', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_PRS_Measurements_Info_List._val = 88
    
    #-----< id-PRSConfigRequestType >-----#
    id_PRSConfigRequestType = INT(name='id-PRSConfigRequestType', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_PRSConfigRequestType._val = 89
    
    #-----< id-UE-TEG-Info-Request >-----#
    id_UE_TEG_Info_Request = INT(name='id-UE-TEG-Info-Request', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_TEG_Info_Request._val = 90
    
    #-----< id-MeasurementTimeOccasion >-----#
    id_MeasurementTimeOccasion = INT(name='id-MeasurementTimeOccasion', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementTimeOccasion._val = 91
    
    #-----< id-MeasurementCharacteristicsRequestIndicator >-----#
    id_MeasurementCharacteristicsRequestIndicator = INT(name='id-MeasurementCharacteristicsRequestIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementCharacteristicsRequestIndicator._val = 92
    
    #-----< id-TRPBeamAntennaInformation >-----#
    id_TRPBeamAntennaInformation = INT(name='id-TRPBeamAntennaInformation', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_TRPBeamAntennaInformation._val = 93
    
    #-----< id-NR-TADV >-----#
    id_NR_TADV = INT(name='id-NR-TADV', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_NR_TADV._val = 94
    
    #-----< id-MeasurementAmount >-----#
    id_MeasurementAmount = INT(name='id-MeasurementAmount', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementAmount._val = 95
    
    #-----< id-pathPower >-----#
    id_pathPower = INT(name='id-pathPower', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_pathPower._val = 96
    
    #-----< id-PreconfigurationResult >-----#
    id_PreconfigurationResult = INT(name='id-PreconfigurationResult', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_PreconfigurationResult._val = 97
    
    #-----< id-RequestType >-----#
    id_RequestType = INT(name='id-RequestType', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_RequestType._val = 98
    
    #-----< id-UE-TEG-ReportingPeriodicity >-----#
    id_UE_TEG_ReportingPeriodicity = INT(name='id-UE-TEG-ReportingPeriodicity', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_TEG_ReportingPeriodicity._val = 99
    
    #-----< id-SRSPortIndex >-----#
    id_SRSPortIndex = INT(name='id-SRSPortIndex', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRSPortIndex._val = 100
    
    #-----< id-procedure-code-101-not-to-be-used >-----#
    id_procedure_code_101_not_to_be_used = INT(name='id-procedure-code-101-not-to-be-used', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_procedure_code_101_not_to_be_used._val = 101
    
    #-----< id-procedure-code-102-not-to-be-used >-----#
    id_procedure_code_102_not_to_be_used = INT(name='id-procedure-code-102-not-to-be-used', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_procedure_code_102_not_to_be_used._val = 102
    
    #-----< id-procedure-code-103-not-to-be-used >-----#
    id_procedure_code_103_not_to_be_used = INT(name='id-procedure-code-103-not-to-be-used', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_procedure_code_103_not_to_be_used._val = 103
    
    #-----< id-UETxTimingErrorMargin >-----#
    id_UETxTimingErrorMargin = INT(name='id-UETxTimingErrorMargin', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_UETxTimingErrorMargin._val = 104
    
    #-----< id-MeasurementPeriodicityNR-AoA >-----#
    id_MeasurementPeriodicityNR_AoA = INT(name='id-MeasurementPeriodicityNR-AoA', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementPeriodicityNR_AoA._val = 105
    
    #-----< id-SRSTransmissionStatus >-----#
    id_SRSTransmissionStatus = INT(name='id-SRSTransmissionStatus', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRSTransmissionStatus._val = 106
    
    _all_ = [
        id_errorIndication,
        id_privateMessage,
        id_e_CIDMeasurementInitiation,
        id_e_CIDMeasurementFailureIndication,
        id_e_CIDMeasurementReport,
        id_e_CIDMeasurementTermination,
        id_oTDOAInformationExchange,
        id_assistanceInformationControl,
        id_assistanceInformationFeedback,
        id_positioningInformationExchange,
        id_positioningInformationUpdate,
        id_Measurement,
        id_MeasurementReport,
        id_MeasurementUpdate,
        id_MeasurementAbort,
        id_MeasurementFailureIndication,
        id_tRPInformationExchange,
        id_positioningActivation,
        id_positioningDeactivation,
        id_pRSConfigurationExchange,
        id_measurementPreconfiguration,
        id_measurementActivation,
        maxNrOfErrors,
        maxCellinRANnode,
        maxIndexesReport,
        maxNoMeas,
        maxCellReport,
        maxCellReportNR,
        maxnoOTDOAtypes,
        maxServCell,
        maxEUTRAMeas,
        maxGERANMeas,
        maxNRMeas,
        maxUTRANMeas,
        maxWLANchannels,
        maxnoFreqHoppingBandsMinusOne,
        maxNoPath,
        maxNrOfPosSImessage,
        maxnoAssistInfoFailureListItems,
        maxNrOfSegments,
        maxNrOfPosSIBs,
        maxNoOfMeasTRPs,
        maxnoTRPs,
        maxnoTRPInfoTypes,
        maxnoofAngleInfo,
        maxnolcs_gcs_translation,
        maxnoBcastCell,
        maxnoSRSTriggerStates,
        maxnoSpatialRelations,
        maxnoPosMeas,
        maxnoSRS_Carriers,
        maxnoSCSs,
        maxnoSRS_Resources,
        maxnoSRS_PosResources,
        maxnoSRS_ResourceSets,
        maxnoSRS_ResourcePerSet,
        maxnoSRS_PosResourceSets,
        maxnoSRS_PosResourcePerSet,
        maxPRS_ResourceSets,
        maxPRS_ResourcesPerSet,
        maxNoSSBs,
        maxnoofPRSresourceSet,
        maxnoofPRSresource,
        maxnoofULAoAs,
        maxNoPathExtended,
        maxnoARPs,
        maxnoUETEGs,
        maxnoTRPTEGs,
        maxFreqLayers,
        maxNumResourcesPerAngle,
        maxnoAzimuthAngles,
        maxnoElevationAngles,
        maxnoPRSTRPs,
        id_Cause,
        id_CriticalityDiagnostics,
        id_LMF_UE_Measurement_ID,
        id_ReportCharacteristics,
        id_MeasurementPeriodicity,
        id_MeasurementQuantities,
        id_RAN_UE_Measurement_ID,
        id_E_CID_MeasurementResult,
        id_OTDOACells,
        id_OTDOA_Information_Type_Group,
        id_OTDOA_Information_Type_Item,
        id_MeasurementQuantities_Item,
        id_RequestedSRSTransmissionCharacteristics,
        id_Cell_Portion_ID,
        id_OtherRATMeasurementQuantities,
        id_OtherRATMeasurementQuantities_Item,
        id_OtherRATMeasurementResult,
        id_WLANMeasurementQuantities,
        id_WLANMeasurementQuantities_Item,
        id_WLANMeasurementResult,
        id_TDD_Config_EUTRA_Item,
        id_Assistance_Information,
        id_Broadcast,
        id_AssistanceInformationFailureList,
        id_SRSConfiguration,
        id_MeasurementResult,
        id_TRP_ID,
        id_TRPInformationTypeListTRPReq,
        id_TRPInformationListTRPResp,
        id_MeasurementBeamInfoRequest,
        id_ResultSS_RSRP,
        id_ResultSS_RSRQ,
        id_ResultCSI_RSRP,
        id_ResultCSI_RSRQ,
        id_AngleOfArrivalNR,
        id_GeographicalCoordinates,
        id_PositioningBroadcastCells,
        id_LMF_Measurement_ID,
        id_RAN_Measurement_ID,
        id_TRP_MeasurementRequestList,
        id_TRP_MeasurementResponseList,
        id_TRP_MeasurementReportList,
        id_SRSType,
        id_ActivationTime,
        id_SRSResourceSetID,
        id_TRPList,
        id_SRSSpatialRelation,
        id_SystemFrameNumber,
        id_SlotNumber,
        id_SRSResourceTrigger,
        id_TRPMeasurementQuantities,
        id_AbortTransmission,
        id_SFNInitialisationTime,
        id_ResultNR,
        id_ResultEUTRA,
        id_TRPInformationTypeItem,
        id_CGI_NR,
        id_SFNInitialisationTime_NR,
        id_Cell_ID,
        id_SrsFrequency,
        id_TRPType,
        id_SRSSpatialRelationPerSRSResource,
        id_MeasurementPeriodicityExtended,
        id_PRS_Resource_ID,
        id_PRSTRPList,
        id_PRSTransmissionTRPList,
        id_OnDemandPRS,
        id_AoA_SearchWindow,
        id_TRP_MeasurementUpdateList,
        id_ZoA,
        id_ResponseTime,
        id_UEReportingInformation,
        id_MultipleULAoA,
        id_UL_SRS_RSRPP,
        id_SRSResourcetype,
        id_ExtendedAdditionalPathList,
        id_ARPLocationInfo,
        id_ARP_ID,
        id_LoS_NLoSInformation,
        id_UETxTEGAssociationList,
        id_NumberOfTRPRxTEG,
        id_NumberOfTRPRxTxTEG,
        id_TRPTxTEGAssociation,
        id_TRPTEGInformation,
        id_TRP_Rx_TEGInformation,
        id_TRP_PRS_Information_List,
        id_PRS_Measurements_Info_List,
        id_PRSConfigRequestType,
        id_UE_TEG_Info_Request,
        id_MeasurementTimeOccasion,
        id_MeasurementCharacteristicsRequestIndicator,
        id_TRPBeamAntennaInformation,
        id_NR_TADV,
        id_MeasurementAmount,
        id_pathPower,
        id_PreconfigurationResult,
        id_RequestType,
        id_UE_TEG_ReportingPeriodicity,
        id_SRSPortIndex,
        id_procedure_code_101_not_to_be_used,
        id_procedure_code_102_not_to_be_used,
        id_procedure_code_103_not_to_be_used,
        id_UETxTimingErrorMargin,
        id_MeasurementPeriodicityNR_AoA,
        id_SRSTransmissionStatus,
    ]

class NRPPA_Containers:

    _name_  = 'NRPPA-Containers'
    _oid_   = [0, 4, 0, 0, 22, 3, 4, 1, 5]
    
    _obj_ = [
        'NRPPA-PROTOCOL-IES',
        'NRPPA-PROTOCOL-EXTENSION',
        'NRPPA-PRIVATE-IES',
        'ProtocolIE-Container',
        'ProtocolIE-Single-Container',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    _type_ = [
        'NRPPA-PROTOCOL-IES',
        'NRPPA-PROTOCOL-EXTENSION',
        'NRPPA-PRIVATE-IES',
        'ProtocolIE-Container',
        'ProtocolIE-Single-Container',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        'NRPPA-PROTOCOL-IES',
        'NRPPA-PROTOCOL-EXTENSION',
        'NRPPA-PRIVATE-IES',
        ]
    _param_ = [
        'ProtocolIE-Container',
        'ProtocolIE-Single-Container',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    
    #-----< NRPPA-PROTOCOL-IES >-----#
    NRPPA_PROTOCOL_IES = CLASS(name='NRPPA-PROTOCOL-IES', mode=MODE_TYPE)
    _NRPPA_PROTOCOL_IES_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _NRPPA_PROTOCOL_IES_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'Criticality')))
    _NRPPA_PROTOCOL_IES_Value = OPEN(name='Value', mode=MODE_TYPE)
    _NRPPA_PROTOCOL_IES_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'Presence')))
    NRPPA_PROTOCOL_IES._cont = ASN1Dict([
        ('id', _NRPPA_PROTOCOL_IES_id),
        ('criticality', _NRPPA_PROTOCOL_IES_criticality),
        ('Value', _NRPPA_PROTOCOL_IES_Value),
        ('presence', _NRPPA_PROTOCOL_IES_presence),
        ])
    
    #-----< NRPPA-PROTOCOL-EXTENSION >-----#
    NRPPA_PROTOCOL_EXTENSION = CLASS(name='NRPPA-PROTOCOL-EXTENSION', mode=MODE_TYPE)
    _NRPPA_PROTOCOL_EXTENSION_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _NRPPA_PROTOCOL_EXTENSION_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'Criticality')))
    _NRPPA_PROTOCOL_EXTENSION_Extension = OPEN(name='Extension', mode=MODE_TYPE)
    _NRPPA_PROTOCOL_EXTENSION_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'Presence')))
    NRPPA_PROTOCOL_EXTENSION._cont = ASN1Dict([
        ('id', _NRPPA_PROTOCOL_EXTENSION_id),
        ('criticality', _NRPPA_PROTOCOL_EXTENSION_criticality),
        ('Extension', _NRPPA_PROTOCOL_EXTENSION_Extension),
        ('presence', _NRPPA_PROTOCOL_EXTENSION_presence),
        ])
    
    #-----< NRPPA-PRIVATE-IES >-----#
    NRPPA_PRIVATE_IES = CLASS(name='NRPPA-PRIVATE-IES', mode=MODE_TYPE)
    _NRPPA_PRIVATE_IES_id = CHOICE(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'PrivateIE-ID')))
    _NRPPA_PRIVATE_IES_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'Criticality')))
    _NRPPA_PRIVATE_IES_Value = OPEN(name='Value', mode=MODE_TYPE)
    _NRPPA_PRIVATE_IES_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'Presence')))
    NRPPA_PRIVATE_IES._cont = ASN1Dict([
        ('id', _NRPPA_PRIVATE_IES_id),
        ('criticality', _NRPPA_PRIVATE_IES_criticality),
        ('Value', _NRPPA_PRIVATE_IES_Value),
        ('presence', _NRPPA_PRIVATE_IES_presence),
        ])
    
    #-----< ProtocolIE-Container >-----#
    ProtocolIE_Container = SEQ_OF(name='ProtocolIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-Single-Container >-----#
    ProtocolIE_Single_Container = SEQ(name='ProtocolIE-Single-Container', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')), param=True)
    
    #-----< ProtocolIE-Field >-----#
    ProtocolIE_Field = SEQ(name='ProtocolIE-Field', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerList >-----#
    ProtocolIE_ContainerList = SEQ_OF(name='ProtocolIE-ContainerList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionContainer >-----#
    ProtocolExtensionContainer = SEQ_OF(name='ProtocolExtensionContainer', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionField >-----#
    ProtocolExtensionField = SEQ(name='ProtocolExtensionField', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Container >-----#
    PrivateIE_Container = SEQ_OF(name='PrivateIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Field >-----#
    PrivateIE_Field = SEQ(name='PrivateIE-Field', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _NRPPA_PROTOCOL_IES_id,
        _NRPPA_PROTOCOL_IES_criticality,
        _NRPPA_PROTOCOL_IES_Value,
        _NRPPA_PROTOCOL_IES_presence,
        NRPPA_PROTOCOL_IES,
        _NRPPA_PROTOCOL_EXTENSION_id,
        _NRPPA_PROTOCOL_EXTENSION_criticality,
        _NRPPA_PROTOCOL_EXTENSION_Extension,
        _NRPPA_PROTOCOL_EXTENSION_presence,
        NRPPA_PROTOCOL_EXTENSION,
        _NRPPA_PRIVATE_IES_id,
        _NRPPA_PRIVATE_IES_criticality,
        _NRPPA_PRIVATE_IES_Value,
        _NRPPA_PRIVATE_IES_presence,
        NRPPA_PRIVATE_IES,
    ]

class NRPPA_IEs:

    _name_  = 'NRPPA-IEs'
    _oid_   = [0, 4, 0, 0, 22, 3, 4, 1, 2]
    
    _obj_ = [
        'AbortTransmission',
        'AbortTransmission-ExtIEs',
        'ActiveULBWP',
        'ActiveULBWP-ExtIEs',
        'AdditionalPathList',
        'AdditionalPathListItem',
        'AdditionalPathListItem-ExtIEs',
        'ExtendedAdditionalPathList',
        'ExtendedAdditionalPathList-Item',
        'ExtendedAdditionalPathList-Item-ExtIEs',
        'AoA-AssistanceInfo',
        'AoA-AssistanceInfo-ExtIEs',
        'AperiodicSRSResourceTriggerList',
        'AperiodicSRSResourceTrigger',
        'AngleMeasurementType',
        'AngleMeasurementType-ExtIEs',
        'Expected-UL-AoA',
        'Expected-UL-AoA-ExtIEs',
        'Expected-ZoA-only',
        'Expected-ZoA-only-ExtIEs',
        'Expected-Azimuth-AoA',
        'Expected-Azimuth-AoA-ExtIEs',
        'Expected-Zenith-AoA',
        'Expected-Zenith-AoA-ExtIEs',
        'ARP-ID',
        'ARPLocationInformation',
        'ARPLocationInformation-Item',
        'ARPLocationInformation-ExtIEs',
        'ARPLocationType',
        'ARPLocationType-ExtIEs',
        'Assistance-Information',
        'Assistance-Information-ExtIEs',
        'AssistanceInformationFailureList',
        'AssistanceInformationFailureList-ExtIEs',
        'AssistanceInformationMetaData',
        'AssistanceInformationMetaData-ExtIEs',
        'BandwidthSRS',
        'BandwidthSRS-ExtIEs',
        'BCCH',
        'Broadcast',
        'BroadcastPeriodicity',
        'PositioningBroadcastCells',
        'BSSID',
        'CarrierFreq',
        'CarrierFreq-ExtIEs',
        'Cause',
        'Cause-ExtensionIE',
        'CauseMisc',
        'CauseProtocol',
        'CauseRadioNetwork',
        'Cell-Portion-ID',
        'CGI-EUTRA',
        'CGI-EUTRA-ExtIEs',
        'CGI-NR',
        'CGI-NR-ExtIEs',
        'CPLength-EUTRA',
        'CriticalityDiagnostics',
        'CriticalityDiagnostics-ExtIEs',
        'CriticalityDiagnostics-IE-List',
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'DL-Bandwidth-EUTRA',
        'DL-PRS',
        'DL-PRS-ExtIEs',
        'DL-PRSMutingPattern',
        'DL-PRSMutingPattern-ExtIEs',
        'DLPRSResourceCoordinates',
        'DLPRSResourceCoordinates-ExtIEs',
        'DLPRSResourceSetARP',
        'DLPRSResourceSetARP-ExtIEs',
        'DL-PRSResourceSetARPLocation',
        'DL-PRSResourceSetARPLocation-ExtIEs',
        'DLPRSResourceARP',
        'DLPRSResourceARP-ExtIEs',
        'DL-PRSResourceARPLocation',
        'DL-PRSResourceARPLocation-ExtIEs',
        'E-CID-MeasurementResult',
        'E-CID-MeasurementResult-ExtIEs',
        'EUTRACellIdentifier',
        'EARFCN',
        'Expected-Value-AoA',
        'Expected-Value-ZoA',
        'GeographicalCoordinates',
        'GeographicalCoordinates-ExtIEs',
        'GNB-RxTxTimeDiff',
        'GNB-RxTxTimeDiff-ExtIEs',
        'GNBRxTxTimeDiffMeas',
        'GNBRxTxTimeDiffMeas-ExtIEs',
        'HESSID',
        'LCS-to-GCS-Translation',
        'LCS-to-GCS-Translation-ExtIEs',
        'LCS-to-GCS-TranslationItem',
        'LCS-to-GCS-TranslationItem-ExtIEs',
        'LocationUncertainty',
        'LocationUncertainty-ExtIEs',
        'LoS-NLoSIndicatorHard',
        'LoS-NLoSIndicatorSoft',
        'LoS-NLoSInformation',
        'LoS-NLoSInformation-ExtIEs',
        'Measurement-ID',
        'MeasurementAmount',
        'MeasurementBeamInfoRequest',
        'MeasurementBeamInfo',
        'MeasurementBeamInfo-ExtIEs',
        'MeasurementPeriodicity',
        'MeasurementPeriodicityExtended',
        'MeasurementPeriodicityNR-AoA',
        'MeasurementQuantities',
        'MeasurementQuantities-ItemIEs',
        'MeasurementQuantities-Item',
        'MeasurementQuantitiesValue-ExtIEs',
        'MeasurementQuantitiesValue',
        'MeasurementTimeOccasion',
        'MeasurementCharacteristicsRequestIndicator',
        'MeasuredResults',
        'MeasuredResultsValue',
        'MeasuredResultsValue-ExtensionIE',
        'MultipleULAoA',
        'MultipleULAoA-ExtIEs',
        'MultipleULAoA-List',
        'MultipleULAoA-Item',
        'MultipleULAoA-Item-ExtIEs',
        'NarrowBandIndex',
        'NG-RANAccessPointPosition',
        'NG-RANAccessPointPosition-ExtIEs',
        'NGRANHighAccuracyAccessPointPosition',
        'NGRANHighAccuracyAccessPointPosition-ExtIEs',
        'NG-RAN-CGI',
        'NG-RAN-CGI-ExtIEs',
        'NG-RANCell',
        'NG-RANCell-ExtensionIE',
        'NR-ARFCN',
        'NRCellIdentifier',
        'NR-PCI',
        'NR-PRS-Beam-Information',
        'NR-PRS-Beam-Information-IEs',
        'NR-PRS-Beam-InformationItem',
        'NR-PRS-Beam-InformationItem-ExtIEs',
        'NR-TADV',
        'NumberOfAntennaPorts-EUTRA',
        'NumberOfDlFrames-EUTRA',
        'NumberOfDlFrames-Extended-EUTRA',
        'NumberOfFrequencyHoppingBands',
        'NumberOfTRPRxTEG',
        'NumberOfTRPRxTxTEG',
        'NZP-CSI-RS-ResourceID',
        'OnDemandPRS-Info',
        'OnDemandPRS-Info-ExtIEs',
        'OTDOACells',
        'OTDOACells-ExtIEs',
        'OTDOACell-Information',
        'OTDOACell-Information-Item',
        'OTDOACell-Information-Item-ExtensionIE',
        'OTDOA-Information-Item',
        'OtherRATMeasurementQuantities',
        'OtherRATMeasurementQuantities-ItemIEs',
        'OtherRATMeasurementQuantities-Item',
        'OtherRATMeasurementQuantitiesValue-ExtIEs',
        'OtherRATMeasurementQuantitiesValue',
        'OtherRATMeasurementResult',
        'OtherRATMeasuredResultsValue',
        'OtherRATMeasuredResultsValue-ExtensionIE',
        'Outcome',
        'PathlossReferenceInformation',
        'PathlossReferenceInformation-ExtIEs',
        'PathlossReferenceSignal',
        'PathlossReferenceSignal-ExtensionIE',
        'PCI-EUTRA',
        'PhysCellIDGERAN',
        'PhysCellIDUTRA-FDD',
        'PhysCellIDUTRA-TDD',
        'PLMN-Identity',
        'PeriodicityList',
        'PeriodicityItem',
        'PosSIBs',
        'PosSIBs-ExtIEs',
        'PosSIB-Segments',
        'PosSIB-Segments-ExtIEs',
        'PosSIB-Type',
        'PosSRSResource-List',
        'PosSRSResource-Item',
        'PosSRSResource-Item-ExtIEs',
        'PosSRSResourceID-List',
        'PosSRSResourceSet-List',
        'PosSRSResourceIDPerSet-List',
        'PosSRSResourceSet-Item',
        'PosSRSResourceSet-Item-ExtIEs',
        'PosResourceSetType',
        'PosResourceSetType-ExtIEs',
        'PosResourceSetTypePeriodic',
        'PosResourceSetTypePeriodic-ExtIEs',
        'PosResourceSetTypeSemi-persistent',
        'PosResourceSetTypeSemi-persistent-ExtIEs',
        'PosResourceSetTypeAperiodic',
        'PosResourceSetTypeAperiodic-ExtIEs',
        'PreconfigurationResult',
        'PRS-Bandwidth-EUTRA',
        'PRSAngleItem',
        'PRSAngleItem-ExtIEs',
        'PRSInformationPos',
        'PRSInformationPos-ExtIEs',
        'PRSConfigRequestType',
        'PRSConfiguration',
        'PRSConfiguration-ExtIEs',
        'PRS-ConfigurationIndex-EUTRA',
        'PRS-ID-EUTRA',
        'PRSMutingConfiguration-EUTRA',
        'PRSMutingConfiguration-EUTRA-ExtensionIE',
        'PRSOccasionGroup-EUTRA',
        'PRSFrequencyHoppingConfiguration-EUTRA',
        'PRSFrequencyHoppingConfiguration-EUTRA-Item-IEs',
        'PRS-Measurements-Info-List',
        'PRS-Measurements-Info-List-Item',
        'PRS-Measurements-Info-List-Item-ExtIEs',
        'PRSMuting',
        'PRSMuting-ExtIEs',
        'PRSMutingOption1',
        'PRSMutingOption1-ExtIEs',
        'PRSMutingOption2',
        'PRSMutingOption2-ExtIEs',
        'PRSResource-List',
        'PRSResource-Item',
        'PRSResource-Item-ExtIEs',
        'PRSResource-QCLInfo',
        'PRSResource-QCLInfo-ExtIEs',
        'PRSResource-QCLSourceSSB',
        'PRSResource-QCLSourceSSB-ExtIEs',
        'PRSResource-QCLSourcePRS',
        'PRSResource-QCLSourcePRS-ExtIEs',
        'PRSResourceSet-List',
        'PRSResourceSet-Item',
        'PRSResourceSet-Item-ExtIEs',
        'PRS-Resource-ID',
        'PRS-Resource-Set-ID',
        'PRS-ID',
        'PRSTransmissionOffIndication',
        'PRSTransmissionOffIndication-ExtIEs',
        'PRSTransmissionOffPerResource',
        'PRSTransmissionOffPerResource-Item',
        'PRSTransmissionOffPerResource-Item-ExtIEs',
        'PRSTransmissionOffIndicationPerResource-Item',
        'PRSTransmissionOffIndicationPerResource-Item-ExtIEs',
        'PRSTransmissionOffInformation',
        'PRSTransmissionOffInformation-ExtIEs',
        'PRSTransmissionOffPerResourceSet',
        'PRSTransmissionOffPerResourceSet-Item',
        'PRSTransmissionOffPerResourceSet-Item-ExtIEs',
        'PRSTRPList',
        'PRSTRPItem',
        'PRSTRPItem-ExtIEs',
        'PRSTransmissionTRPList',
        'PRSTransmissionTRPItem',
        'PRSTransmissionTRPItem-ExtIEs',
        'ReferenceSignal',
        'ReferenceSignal-ExtensionIE',
        'ReferencePoint',
        'ReferencePoint-ExtIEs',
        'CoordinateID',
        'RelativeGeodeticLocation',
        'RelativeGeodeticLocation-ExtIEs',
        'RelativeCartesianLocation',
        'RelativeCartesianLocation-ExtIEs',
        'RelativePathDelay',
        'RelativePathDelay-ExtIEs',
        'ReportCharacteristics',
        'RequestedDLPRSTransmissionCharacteristics',
        'RequestedDLPRSTransmissionCharacteristics-ExtIEs',
        'RequestedDLPRSResourceSet-List',
        'RequestedDLPRSResourceSet-Item',
        'RequestedDLPRSResourceSet-Item-ExtIEs',
        'RequestedDLPRSResource-List',
        'RequestedDLPRSResource-Item',
        'RequestedDLPRSResource-Item-ExtIEs',
        'RequestedSRSTransmissionCharacteristics',
        'RequestedSRSTransmissionCharacteristics-ExtIEs',
        'SRSResourceSet-Item',
        'SRSResourceSet-Item-ExtIEs',
        'RequestType',
        'ResourceSetType',
        'ResourceSetType-ExtIEs',
        'ResourceSetTypePeriodic',
        'ResourceSetTypePeriodic-ExtIEs',
        'ResourceSetTypeSemi-persistent',
        'ResourceSetTypeSemi-persistent-ExtIEs',
        'ResourceSetTypeAperiodic',
        'ResourceSetTypeAperiodic-ExtIEs',
        'ResourceType',
        'ResourceType-ExtIEs',
        'ResourceTypePeriodic',
        'ResourceTypePeriodic-ExtIEs',
        'ResourceTypeSemi-persistent',
        'ResourceTypeSemi-persistent-ExtIEs',
        'ResourceTypeAperiodic',
        'ResourceTypeAperiodic-ExtIEs',
        'ResourceTypePos',
        'ResourceTypePos-ExtIEs',
        'ResourceTypePeriodicPos',
        'ResourceTypePeriodicPos-ExtIEs',
        'ResourceTypeSemi-persistentPos',
        'ResourceTypeSemi-persistentPos-ExtIEs',
        'ResourceTypeAperiodicPos',
        'ResourceTypeAperiodicPos-ExtIEs',
        'ResponseTime',
        'ResponseTime-ExtIEs',
        'ResultCSI-RSRP',
        'ResultCSI-RSRP-Item',
        'ResultCSI-RSRP-Item-ExtIEs',
        'ResultCSI-RSRP-PerCSI-RS',
        'ResultCSI-RSRP-PerCSI-RS-Item',
        'ResultCSI-RSRP-PerCSI-RS-Item-ExtIEs',
        'ResultCSI-RSRQ',
        'ResultCSI-RSRQ-Item',
        'ResultCSI-RSRQ-Item-ExtIEs',
        'ResultCSI-RSRQ-PerCSI-RS',
        'ResultCSI-RSRQ-PerCSI-RS-Item',
        'ResultCSI-RSRQ-PerCSI-RS-Item-ExtIEs',
        'ResultEUTRA',
        'ResultEUTRA-Item',
        'ResultEUTRA-Item-ExtIEs',
        'ResultRSRP-EUTRA',
        'ResultRSRP-EUTRA-Item',
        'ResultRSRP-EUTRA-Item-ExtIEs',
        'ResultRSRQ-EUTRA',
        'ResultRSRQ-EUTRA-Item',
        'ResultRSRQ-EUTRA-Item-ExtIEs',
        'ResultSS-RSRP',
        'ResultSS-RSRP-Item',
        'ResultSS-RSRP-Item-ExtIEs',
        'ResultSS-RSRP-PerSSB',
        'ResultSS-RSRP-PerSSB-Item',
        'ResultSS-RSRP-PerSSB-Item-ExtIEs',
        'ResultSS-RSRQ',
        'ResultSS-RSRQ-Item',
        'ResultSS-RSRQ-Item-ExtIEs',
        'ResultSS-RSRQ-PerSSB',
        'ResultSS-RSRQ-PerSSB-Item',
        'ResultSS-RSRQ-PerSSB-Item-ExtIEs',
        'ResultGERAN',
        'ResultGERAN-Item',
        'ResultGERAN-Item-ExtIEs',
        'ResultNR',
        'ResultNR-Item',
        'ResultNR-Item-ExtIEs',
        'ResultUTRAN',
        'ResultUTRAN-Item',
        'ResultUTRAN-Item-ExtIEs',
        'RSSI',
        'RxTxTimingErrorMargin',
        'SCS-SpecificCarrier',
        'SCS-SpecificCarrier-ExtIEs',
        'Search-window-information',
        'Search-window-information-ExtIEs',
        'RelativeTime1900',
        'SFNInitialisationTime-EUTRA',
        'SlotNumber',
        'SpatialDirectionInformation',
        'SpatialDirectionInformation-ExtIEs',
        'SpatialRelationInfo',
        'SpatialRelationInfo-ExtIEs',
        'SpatialRelationforResourceID',
        'SpatialRelationforResourceIDItem',
        'SpatialRelationforResourceIDItem-ExtIEs',
        'SpatialRelationPerSRSResource',
        'SpatialRelationPerSRSResource-ExtIEs',
        'SpatialRelationPerSRSResource-List',
        'SpatialRelationPerSRSResourceItem',
        'SpatialRelationPerSRSResourceItem-ExtIEs',
        'SpatialRelationPos',
        'SpatialInformationPos-ExtIEs',
        'SRSConfig',
        'SRSConfig-ExtIEs',
        'SRSCarrier-List',
        'SRSCarrier-List-Item',
        'SRSCarrier-List-Item-ExtIEs',
        'SRSConfiguration',
        'SRSConfiguration-ExtIEs',
        'SrsFrequency',
        'SRSPortIndex',
        'SRSPosResourceID',
        'SRSResource',
        'SRSResource-ExtIEs',
        'SRSResourceID',
        'SRSResource-List',
        'SRSResourceSet-List',
        'SRSResourceID-List',
        'SRSResourceSet',
        'SRSResourceSet-ExtIEs',
        'SRSResourceSetID',
        'SRSResourceTrigger',
        'SRSResourceTrigger-ExtIEs',
        'SRSResourcetype',
        'SRSResourcetype-ExtIEs',
        'SRSResourceTypeChoice',
        'SRSInfo',
        'SRSTransmissionStatus',
        'PosSRSInfo',
        'SSBInfo',
        'SSBInfo-ExtIEs',
        'SSBInfoItem',
        'SSBInfoItem-ExtIEs',
        'SSB',
        'SSB-ExtIEs',
        'SSBBurstPosition',
        'SSBBurstPosition-ExtIEs',
        'SSB-Index',
        'SSID',
        'StartTimeAndDuration',
        'StartTimeAndDuration-ExtIEs',
        'SystemFrameNumber',
        'SystemInformation',
        'SystemInformation-ExtIEs',
        'TAC',
        'TDD-Config-EUTRA-Item',
        'TDD-Config-EUTRA-Item-Item-ExtIEs',
        'TRPTEGInformation',
        'TRPTEGInformation-ExtIEs',
        'RxTxTEG',
        'RxTxTEG-ExtIEs',
        'RxTEG',
        'RxTEG-ExtIEs',
        'TimingErrorMargin',
        'TF-Configuration',
        'TF-Configuration-ExtIEs',
        'TimeStamp',
        'TimeStamp-ExtIEs',
        'TimeStampSlotIndex',
        'TimeStampSlotIndex-ExtIEs',
        'TP-ID-EUTRA',
        'TP-Type-EUTRA',
        'TransmissionComb',
        'TransmissionComb-ExtIEs',
        'TransmissionCombPos',
        'TransmissionCombPos-ExtIEs',
        'TRPBeamAntennaInformation',
        'TRPBeamAntennaInformation-ExtIEs',
        'Choice-TRP-Beam-Antenna-Info-Item',
        'Choice-TRP-Beam-Info-Item-ExtIEs',
        'TRP-BeamAntennaExplicitInformation',
        'TRP-BeamAntennaExplicitInformation-ExtIEs',
        'TRP-BeamAntennaAngles',
        'TRP-BeamAntennaAnglesList-Item',
        'TRP-BeamAntennaAnglesList-Item-ExtIEs',
        'TRP-ElevationAngleList-Item',
        'TRP-ElevationAngleList-Item-ExtIEs',
        'TRP-Beam-Power-Item',
        'TRP-Beam-Power-Item-ExtIEs',
        'TRPMeasurementQuantities',
        'TRPMeasurementQuantitiesList-Item',
        'TRPMeasurementQuantitiesList-Item-ExtIEs',
        'TRPMeasurementQuantities-Item',
        'TrpMeasurementResult',
        'TrpMeasurementResultItem',
        'TrpMeasurementResultItem-ExtIEs',
        'TrpMeasuredResultsValue',
        'TrpMeasuredResultsValue-ExtIEs',
        'TrpMeasurementQuality',
        'TrpMeasurementQuality-ExtIEs',
        'TrpMeasurementTimingQuality',
        'TrpMeasurementTimingQuality-ExtIEs',
        'TrpMeasurementAngleQuality',
        'TrpMeasurementAngleQuality-ExtIEs',
        'TRP-MeasurementRequestList',
        'TRP-MeasurementRequestItem',
        'TRP-MeasurementRequestItem-ExtIEs',
        'TRP-MeasurementResponseList',
        'TRP-MeasurementResponseItem',
        'TRP-MeasurementResponseItem-ExtIEs',
        'TRP-MeasurementUpdateList',
        'TRP-MeasurementUpdateItem',
        'TRP-MeasurementUpdateItem-ExtIEs',
        'TRPInformationListTRPResp',
        'TRPInformationTRPResp-ExtIEs',
        'TRPInformation',
        'TRPInformation-ExtIEs',
        'TRPInformationTypeResponseList',
        'TRPInformationTypeResponseItem',
        'TRPInformationTypeResponseItem-ExtIEs',
        'TRPInformationTypeListTRPReq',
        'TRPInformationTypeItemTRPReq',
        'TRPInformationTypeItem',
        'TRPList',
        'TRPItem',
        'TRPItem-ExtIEs',
        'TRP-ID',
        'TRPPositionDefinitionType',
        'TRPPositionDefinitionType-ExtIEs',
        'TRPPositionDirect',
        'TRPPositionDirect-ExtIEs',
        'TRPPositionDirectAccuracy',
        'TRPPositionDirectAccuracy-ExtIEs',
        'TRPPositionReferenced',
        'TRPPositionReferenced-ExtIEs',
        'TRP-PRS-Information-List',
        'TRP-PRS-Information-List-Item',
        'TRP-PRS-Information-List-Item-ExtIEs',
        'TRPReferencePointType',
        'TRPReferencePointType-ExtIEs',
        'TRP-Rx-TEGInformation',
        'TRP-Rx-TEGInformation-ExtIEs',
        'TRP-RxTx-TEGInformation',
        'TRP-RxTx-TEGInformation-ExtIEs',
        'TRP-Tx-TEGInformation',
        'TRP-Tx-TEGInformation-ExtIEs',
        'TRPTxTEGAssociation',
        'TRPTEGItem',
        'TRPTEGItem-ExtIEs',
        'DLPRSResourceID-Item',
        'DLPRSResource-Item-ExtIEs',
        'TRPType',
        'TypeOfError',
        'UARFCN',
        'UE-Measurement-ID',
        'UEReportingInformation',
        'UEReportingInformation-ExtIEs',
        'UE-TEG-ReportingPeriodicity',
        'UETxTEGAssociationList',
        'UETxTEGAssociationItem',
        'UETxTEGAssociationItem-ExtIEs',
        'SRSResourceID-Item',
        'SRSResourceID-Item-ExtIEs',
        'UE-TEG-Info-Request',
        'UTRA-EcN0',
        'UTRA-RSCP',
        'UL-AoA',
        'UL-AoA-ExtIEs',
        'UL-RTOAMeasurement',
        'UL-RTOAMeasurement-ExtIEs',
        'ULRTOAMeas',
        'ULRTOAMeas-ExtIEs',
        'UL-SRS-RSRP',
        'UL-SRS-RSRPP',
        'UL-SRS-RSRPP-ExtIEs',
        'UplinkChannelBW-PerSCS-List',
        'Uncertainty-range-AoA',
        'Uncertainty-range-ZoA',
        'ValueRSRP-EUTRA',
        'ValueRSRQ-EUTRA',
        'ValueRSRP-NR',
        'ValueRSRQ-NR',
        'WLANMeasurementQuantities',
        'WLANMeasurementQuantities-ItemIEs',
        'WLANMeasurementQuantities-Item',
        'WLANMeasurementQuantitiesValue-ExtIEs',
        'WLANMeasurementQuantitiesValue',
        'WLANMeasurementResult',
        'WLANMeasurementResult-Item',
        'WLANMeasurementResult-Item-ExtIEs',
        'WLAN-RSSI',
        'WLANBand',
        'WLANChannelList',
        'WLANChannel',
        'WLANCountryCode',
        'WLANOperatingClass',
        'ZoA',
        'ZoA-ExtIEs',
        ]
    _type_ = [
        'AbortTransmission',
        'ActiveULBWP',
        'AdditionalPathList',
        'AdditionalPathListItem',
        'ExtendedAdditionalPathList',
        'ExtendedAdditionalPathList-Item',
        'AoA-AssistanceInfo',
        'AperiodicSRSResourceTriggerList',
        'AperiodicSRSResourceTrigger',
        'AngleMeasurementType',
        'Expected-UL-AoA',
        'Expected-ZoA-only',
        'Expected-Azimuth-AoA',
        'Expected-Zenith-AoA',
        'ARP-ID',
        'ARPLocationInformation',
        'ARPLocationInformation-Item',
        'ARPLocationType',
        'Assistance-Information',
        'AssistanceInformationFailureList',
        'AssistanceInformationMetaData',
        'BandwidthSRS',
        'BCCH',
        'Broadcast',
        'BroadcastPeriodicity',
        'PositioningBroadcastCells',
        'BSSID',
        'CarrierFreq',
        'Cause',
        'CauseMisc',
        'CauseProtocol',
        'CauseRadioNetwork',
        'Cell-Portion-ID',
        'CGI-EUTRA',
        'CGI-NR',
        'CPLength-EUTRA',
        'CriticalityDiagnostics',
        'CriticalityDiagnostics-IE-List',
        'DL-Bandwidth-EUTRA',
        'DL-PRS',
        'DL-PRSMutingPattern',
        'DLPRSResourceCoordinates',
        'DLPRSResourceSetARP',
        'DL-PRSResourceSetARPLocation',
        'DLPRSResourceARP',
        'DL-PRSResourceARPLocation',
        'E-CID-MeasurementResult',
        'EUTRACellIdentifier',
        'EARFCN',
        'Expected-Value-AoA',
        'Expected-Value-ZoA',
        'GeographicalCoordinates',
        'GNB-RxTxTimeDiff',
        'GNBRxTxTimeDiffMeas',
        'HESSID',
        'LCS-to-GCS-Translation',
        'LCS-to-GCS-TranslationItem',
        'LocationUncertainty',
        'LoS-NLoSIndicatorHard',
        'LoS-NLoSIndicatorSoft',
        'LoS-NLoSInformation',
        'Measurement-ID',
        'MeasurementAmount',
        'MeasurementBeamInfoRequest',
        'MeasurementBeamInfo',
        'MeasurementPeriodicity',
        'MeasurementPeriodicityExtended',
        'MeasurementPeriodicityNR-AoA',
        'MeasurementQuantities',
        'MeasurementQuantities-Item',
        'MeasurementQuantitiesValue',
        'MeasurementTimeOccasion',
        'MeasurementCharacteristicsRequestIndicator',
        'MeasuredResults',
        'MeasuredResultsValue',
        'MultipleULAoA',
        'MultipleULAoA-List',
        'MultipleULAoA-Item',
        'NarrowBandIndex',
        'NG-RANAccessPointPosition',
        'NGRANHighAccuracyAccessPointPosition',
        'NG-RAN-CGI',
        'NG-RANCell',
        'NR-ARFCN',
        'NRCellIdentifier',
        'NR-PCI',
        'NR-PRS-Beam-Information',
        'NR-PRS-Beam-InformationItem',
        'NR-TADV',
        'NumberOfAntennaPorts-EUTRA',
        'NumberOfDlFrames-EUTRA',
        'NumberOfDlFrames-Extended-EUTRA',
        'NumberOfFrequencyHoppingBands',
        'NumberOfTRPRxTEG',
        'NumberOfTRPRxTxTEG',
        'NZP-CSI-RS-ResourceID',
        'OnDemandPRS-Info',
        'OTDOACells',
        'OTDOACell-Information',
        'OTDOACell-Information-Item',
        'OTDOA-Information-Item',
        'OtherRATMeasurementQuantities',
        'OtherRATMeasurementQuantities-Item',
        'OtherRATMeasurementQuantitiesValue',
        'OtherRATMeasurementResult',
        'OtherRATMeasuredResultsValue',
        'Outcome',
        'PathlossReferenceInformation',
        'PathlossReferenceSignal',
        'PCI-EUTRA',
        'PhysCellIDGERAN',
        'PhysCellIDUTRA-FDD',
        'PhysCellIDUTRA-TDD',
        'PLMN-Identity',
        'PeriodicityList',
        'PeriodicityItem',
        'PosSIBs',
        'PosSIB-Segments',
        'PosSIB-Type',
        'PosSRSResource-List',
        'PosSRSResource-Item',
        'PosSRSResourceID-List',
        'PosSRSResourceSet-List',
        'PosSRSResourceIDPerSet-List',
        'PosSRSResourceSet-Item',
        'PosResourceSetType',
        'PosResourceSetTypePeriodic',
        'PosResourceSetTypeSemi-persistent',
        'PosResourceSetTypeAperiodic',
        'PreconfigurationResult',
        'PRS-Bandwidth-EUTRA',
        'PRSAngleItem',
        'PRSInformationPos',
        'PRSConfigRequestType',
        'PRSConfiguration',
        'PRS-ConfigurationIndex-EUTRA',
        'PRS-ID-EUTRA',
        'PRSMutingConfiguration-EUTRA',
        'PRSOccasionGroup-EUTRA',
        'PRSFrequencyHoppingConfiguration-EUTRA',
        'PRS-Measurements-Info-List',
        'PRS-Measurements-Info-List-Item',
        'PRSMuting',
        'PRSMutingOption1',
        'PRSMutingOption2',
        'PRSResource-List',
        'PRSResource-Item',
        'PRSResource-QCLInfo',
        'PRSResource-QCLSourceSSB',
        'PRSResource-QCLSourcePRS',
        'PRSResourceSet-List',
        'PRSResourceSet-Item',
        'PRS-Resource-ID',
        'PRS-Resource-Set-ID',
        'PRS-ID',
        'PRSTransmissionOffIndication',
        'PRSTransmissionOffPerResource',
        'PRSTransmissionOffPerResource-Item',
        'PRSTransmissionOffIndicationPerResource-Item',
        'PRSTransmissionOffInformation',
        'PRSTransmissionOffPerResourceSet',
        'PRSTransmissionOffPerResourceSet-Item',
        'PRSTRPList',
        'PRSTRPItem',
        'PRSTransmissionTRPList',
        'PRSTransmissionTRPItem',
        'ReferenceSignal',
        'ReferencePoint',
        'CoordinateID',
        'RelativeGeodeticLocation',
        'RelativeCartesianLocation',
        'RelativePathDelay',
        'ReportCharacteristics',
        'RequestedDLPRSTransmissionCharacteristics',
        'RequestedDLPRSResourceSet-List',
        'RequestedDLPRSResourceSet-Item',
        'RequestedDLPRSResource-List',
        'RequestedDLPRSResource-Item',
        'RequestedSRSTransmissionCharacteristics',
        'SRSResourceSet-Item',
        'RequestType',
        'ResourceSetType',
        'ResourceSetTypePeriodic',
        'ResourceSetTypeSemi-persistent',
        'ResourceSetTypeAperiodic',
        'ResourceType',
        'ResourceTypePeriodic',
        'ResourceTypeSemi-persistent',
        'ResourceTypeAperiodic',
        'ResourceTypePos',
        'ResourceTypePeriodicPos',
        'ResourceTypeSemi-persistentPos',
        'ResourceTypeAperiodicPos',
        'ResponseTime',
        'ResultCSI-RSRP',
        'ResultCSI-RSRP-Item',
        'ResultCSI-RSRP-PerCSI-RS',
        'ResultCSI-RSRP-PerCSI-RS-Item',
        'ResultCSI-RSRQ',
        'ResultCSI-RSRQ-Item',
        'ResultCSI-RSRQ-PerCSI-RS',
        'ResultCSI-RSRQ-PerCSI-RS-Item',
        'ResultEUTRA',
        'ResultEUTRA-Item',
        'ResultRSRP-EUTRA',
        'ResultRSRP-EUTRA-Item',
        'ResultRSRQ-EUTRA',
        'ResultRSRQ-EUTRA-Item',
        'ResultSS-RSRP',
        'ResultSS-RSRP-Item',
        'ResultSS-RSRP-PerSSB',
        'ResultSS-RSRP-PerSSB-Item',
        'ResultSS-RSRQ',
        'ResultSS-RSRQ-Item',
        'ResultSS-RSRQ-PerSSB',
        'ResultSS-RSRQ-PerSSB-Item',
        'ResultGERAN',
        'ResultGERAN-Item',
        'ResultNR',
        'ResultNR-Item',
        'ResultUTRAN',
        'ResultUTRAN-Item',
        'RSSI',
        'RxTxTimingErrorMargin',
        'SCS-SpecificCarrier',
        'Search-window-information',
        'RelativeTime1900',
        'SFNInitialisationTime-EUTRA',
        'SlotNumber',
        'SpatialDirectionInformation',
        'SpatialRelationInfo',
        'SpatialRelationforResourceID',
        'SpatialRelationforResourceIDItem',
        'SpatialRelationPerSRSResource',
        'SpatialRelationPerSRSResource-List',
        'SpatialRelationPerSRSResourceItem',
        'SpatialRelationPos',
        'SRSConfig',
        'SRSCarrier-List',
        'SRSCarrier-List-Item',
        'SRSConfiguration',
        'SrsFrequency',
        'SRSPortIndex',
        'SRSPosResourceID',
        'SRSResource',
        'SRSResourceID',
        'SRSResource-List',
        'SRSResourceSet-List',
        'SRSResourceID-List',
        'SRSResourceSet',
        'SRSResourceSetID',
        'SRSResourceTrigger',
        'SRSResourcetype',
        'SRSResourceTypeChoice',
        'SRSInfo',
        'SRSTransmissionStatus',
        'PosSRSInfo',
        'SSBInfo',
        'SSBInfoItem',
        'SSB',
        'SSBBurstPosition',
        'SSB-Index',
        'SSID',
        'StartTimeAndDuration',
        'SystemFrameNumber',
        'SystemInformation',
        'TAC',
        'TDD-Config-EUTRA-Item',
        'TRPTEGInformation',
        'RxTxTEG',
        'RxTEG',
        'TimingErrorMargin',
        'TF-Configuration',
        'TimeStamp',
        'TimeStampSlotIndex',
        'TP-ID-EUTRA',
        'TP-Type-EUTRA',
        'TransmissionComb',
        'TransmissionCombPos',
        'TRPBeamAntennaInformation',
        'Choice-TRP-Beam-Antenna-Info-Item',
        'TRP-BeamAntennaExplicitInformation',
        'TRP-BeamAntennaAngles',
        'TRP-BeamAntennaAnglesList-Item',
        'TRP-ElevationAngleList-Item',
        'TRP-Beam-Power-Item',
        'TRPMeasurementQuantities',
        'TRPMeasurementQuantitiesList-Item',
        'TRPMeasurementQuantities-Item',
        'TrpMeasurementResult',
        'TrpMeasurementResultItem',
        'TrpMeasuredResultsValue',
        'TrpMeasurementQuality',
        'TrpMeasurementTimingQuality',
        'TrpMeasurementAngleQuality',
        'TRP-MeasurementRequestList',
        'TRP-MeasurementRequestItem',
        'TRP-MeasurementResponseList',
        'TRP-MeasurementResponseItem',
        'TRP-MeasurementUpdateList',
        'TRP-MeasurementUpdateItem',
        'TRPInformationListTRPResp',
        'TRPInformation',
        'TRPInformationTypeResponseList',
        'TRPInformationTypeResponseItem',
        'TRPInformationTypeListTRPReq',
        'TRPInformationTypeItem',
        'TRPList',
        'TRPItem',
        'TRP-ID',
        'TRPPositionDefinitionType',
        'TRPPositionDirect',
        'TRPPositionDirectAccuracy',
        'TRPPositionReferenced',
        'TRP-PRS-Information-List',
        'TRP-PRS-Information-List-Item',
        'TRPReferencePointType',
        'TRP-Rx-TEGInformation',
        'TRP-RxTx-TEGInformation',
        'TRP-Tx-TEGInformation',
        'TRPTxTEGAssociation',
        'TRPTEGItem',
        'DLPRSResourceID-Item',
        'TRPType',
        'TypeOfError',
        'UARFCN',
        'UE-Measurement-ID',
        'UEReportingInformation',
        'UE-TEG-ReportingPeriodicity',
        'UETxTEGAssociationList',
        'UETxTEGAssociationItem',
        'SRSResourceID-Item',
        'UE-TEG-Info-Request',
        'UTRA-EcN0',
        'UTRA-RSCP',
        'UL-AoA',
        'UL-RTOAMeasurement',
        'ULRTOAMeas',
        'UL-SRS-RSRP',
        'UL-SRS-RSRPP',
        'UplinkChannelBW-PerSCS-List',
        'Uncertainty-range-AoA',
        'Uncertainty-range-ZoA',
        'ValueRSRP-EUTRA',
        'ValueRSRQ-EUTRA',
        'ValueRSRP-NR',
        'ValueRSRQ-NR',
        'WLANMeasurementQuantities',
        'WLANMeasurementQuantities-Item',
        'WLANMeasurementQuantitiesValue',
        'WLANMeasurementResult',
        'WLANMeasurementResult-Item',
        'WLAN-RSSI',
        'WLANBand',
        'WLANChannelList',
        'WLANChannel',
        'WLANCountryCode',
        'WLANOperatingClass',
        'ZoA',
        ]
    _set_ = [
        'AbortTransmission-ExtIEs',
        'ActiveULBWP-ExtIEs',
        'AdditionalPathListItem-ExtIEs',
        'ExtendedAdditionalPathList-Item-ExtIEs',
        'AoA-AssistanceInfo-ExtIEs',
        'AngleMeasurementType-ExtIEs',
        'Expected-UL-AoA-ExtIEs',
        'Expected-ZoA-only-ExtIEs',
        'Expected-Azimuth-AoA-ExtIEs',
        'Expected-Zenith-AoA-ExtIEs',
        'ARPLocationInformation-ExtIEs',
        'ARPLocationType-ExtIEs',
        'Assistance-Information-ExtIEs',
        'AssistanceInformationFailureList-ExtIEs',
        'AssistanceInformationMetaData-ExtIEs',
        'BandwidthSRS-ExtIEs',
        'CarrierFreq-ExtIEs',
        'Cause-ExtensionIE',
        'CGI-EUTRA-ExtIEs',
        'CGI-NR-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'DL-PRS-ExtIEs',
        'DL-PRSMutingPattern-ExtIEs',
        'DLPRSResourceCoordinates-ExtIEs',
        'DLPRSResourceSetARP-ExtIEs',
        'DL-PRSResourceSetARPLocation-ExtIEs',
        'DLPRSResourceARP-ExtIEs',
        'DL-PRSResourceARPLocation-ExtIEs',
        'E-CID-MeasurementResult-ExtIEs',
        'GeographicalCoordinates-ExtIEs',
        'GNB-RxTxTimeDiff-ExtIEs',
        'GNBRxTxTimeDiffMeas-ExtIEs',
        'LCS-to-GCS-Translation-ExtIEs',
        'LCS-to-GCS-TranslationItem-ExtIEs',
        'LocationUncertainty-ExtIEs',
        'LoS-NLoSInformation-ExtIEs',
        'MeasurementBeamInfo-ExtIEs',
        'MeasurementQuantities-ItemIEs',
        'MeasurementQuantitiesValue-ExtIEs',
        'MeasuredResultsValue-ExtensionIE',
        'MultipleULAoA-ExtIEs',
        'MultipleULAoA-Item-ExtIEs',
        'NG-RANAccessPointPosition-ExtIEs',
        'NGRANHighAccuracyAccessPointPosition-ExtIEs',
        'NG-RAN-CGI-ExtIEs',
        'NG-RANCell-ExtensionIE',
        'NR-PRS-Beam-Information-IEs',
        'NR-PRS-Beam-InformationItem-ExtIEs',
        'OnDemandPRS-Info-ExtIEs',
        'OTDOACells-ExtIEs',
        'OTDOACell-Information-Item-ExtensionIE',
        'OtherRATMeasurementQuantities-ItemIEs',
        'OtherRATMeasurementQuantitiesValue-ExtIEs',
        'OtherRATMeasuredResultsValue-ExtensionIE',
        'PathlossReferenceInformation-ExtIEs',
        'PathlossReferenceSignal-ExtensionIE',
        'PosSIBs-ExtIEs',
        'PosSIB-Segments-ExtIEs',
        'PosSRSResource-Item-ExtIEs',
        'PosSRSResourceSet-Item-ExtIEs',
        'PosResourceSetType-ExtIEs',
        'PosResourceSetTypePeriodic-ExtIEs',
        'PosResourceSetTypeSemi-persistent-ExtIEs',
        'PosResourceSetTypeAperiodic-ExtIEs',
        'PRSAngleItem-ExtIEs',
        'PRSInformationPos-ExtIEs',
        'PRSConfiguration-ExtIEs',
        'PRSMutingConfiguration-EUTRA-ExtensionIE',
        'PRSFrequencyHoppingConfiguration-EUTRA-Item-IEs',
        'PRS-Measurements-Info-List-Item-ExtIEs',
        'PRSMuting-ExtIEs',
        'PRSMutingOption1-ExtIEs',
        'PRSMutingOption2-ExtIEs',
        'PRSResource-Item-ExtIEs',
        'PRSResource-QCLInfo-ExtIEs',
        'PRSResource-QCLSourceSSB-ExtIEs',
        'PRSResource-QCLSourcePRS-ExtIEs',
        'PRSResourceSet-Item-ExtIEs',
        'PRSTransmissionOffIndication-ExtIEs',
        'PRSTransmissionOffPerResource-Item-ExtIEs',
        'PRSTransmissionOffIndicationPerResource-Item-ExtIEs',
        'PRSTransmissionOffInformation-ExtIEs',
        'PRSTransmissionOffPerResourceSet-Item-ExtIEs',
        'PRSTRPItem-ExtIEs',
        'PRSTransmissionTRPItem-ExtIEs',
        'ReferenceSignal-ExtensionIE',
        'ReferencePoint-ExtIEs',
        'RelativeGeodeticLocation-ExtIEs',
        'RelativeCartesianLocation-ExtIEs',
        'RelativePathDelay-ExtIEs',
        'RequestedDLPRSTransmissionCharacteristics-ExtIEs',
        'RequestedDLPRSResourceSet-Item-ExtIEs',
        'RequestedDLPRSResource-Item-ExtIEs',
        'RequestedSRSTransmissionCharacteristics-ExtIEs',
        'SRSResourceSet-Item-ExtIEs',
        'ResourceSetType-ExtIEs',
        'ResourceSetTypePeriodic-ExtIEs',
        'ResourceSetTypeSemi-persistent-ExtIEs',
        'ResourceSetTypeAperiodic-ExtIEs',
        'ResourceType-ExtIEs',
        'ResourceTypePeriodic-ExtIEs',
        'ResourceTypeSemi-persistent-ExtIEs',
        'ResourceTypeAperiodic-ExtIEs',
        'ResourceTypePos-ExtIEs',
        'ResourceTypePeriodicPos-ExtIEs',
        'ResourceTypeSemi-persistentPos-ExtIEs',
        'ResourceTypeAperiodicPos-ExtIEs',
        'ResponseTime-ExtIEs',
        'ResultCSI-RSRP-Item-ExtIEs',
        'ResultCSI-RSRP-PerCSI-RS-Item-ExtIEs',
        'ResultCSI-RSRQ-Item-ExtIEs',
        'ResultCSI-RSRQ-PerCSI-RS-Item-ExtIEs',
        'ResultEUTRA-Item-ExtIEs',
        'ResultRSRP-EUTRA-Item-ExtIEs',
        'ResultRSRQ-EUTRA-Item-ExtIEs',
        'ResultSS-RSRP-Item-ExtIEs',
        'ResultSS-RSRP-PerSSB-Item-ExtIEs',
        'ResultSS-RSRQ-Item-ExtIEs',
        'ResultSS-RSRQ-PerSSB-Item-ExtIEs',
        'ResultGERAN-Item-ExtIEs',
        'ResultNR-Item-ExtIEs',
        'ResultUTRAN-Item-ExtIEs',
        'SCS-SpecificCarrier-ExtIEs',
        'Search-window-information-ExtIEs',
        'SpatialDirectionInformation-ExtIEs',
        'SpatialRelationInfo-ExtIEs',
        'SpatialRelationforResourceIDItem-ExtIEs',
        'SpatialRelationPerSRSResource-ExtIEs',
        'SpatialRelationPerSRSResourceItem-ExtIEs',
        'SpatialInformationPos-ExtIEs',
        'SRSConfig-ExtIEs',
        'SRSCarrier-List-Item-ExtIEs',
        'SRSConfiguration-ExtIEs',
        'SRSResource-ExtIEs',
        'SRSResourceSet-ExtIEs',
        'SRSResourceTrigger-ExtIEs',
        'SRSResourcetype-ExtIEs',
        'SSBInfo-ExtIEs',
        'SSBInfoItem-ExtIEs',
        'SSB-ExtIEs',
        'SSBBurstPosition-ExtIEs',
        'StartTimeAndDuration-ExtIEs',
        'SystemInformation-ExtIEs',
        'TDD-Config-EUTRA-Item-Item-ExtIEs',
        'TRPTEGInformation-ExtIEs',
        'RxTxTEG-ExtIEs',
        'RxTEG-ExtIEs',
        'TF-Configuration-ExtIEs',
        'TimeStamp-ExtIEs',
        'TimeStampSlotIndex-ExtIEs',
        'TransmissionComb-ExtIEs',
        'TransmissionCombPos-ExtIEs',
        'TRPBeamAntennaInformation-ExtIEs',
        'Choice-TRP-Beam-Info-Item-ExtIEs',
        'TRP-BeamAntennaExplicitInformation-ExtIEs',
        'TRP-BeamAntennaAnglesList-Item-ExtIEs',
        'TRP-ElevationAngleList-Item-ExtIEs',
        'TRP-Beam-Power-Item-ExtIEs',
        'TRPMeasurementQuantitiesList-Item-ExtIEs',
        'TrpMeasurementResultItem-ExtIEs',
        'TrpMeasuredResultsValue-ExtIEs',
        'TrpMeasurementQuality-ExtIEs',
        'TrpMeasurementTimingQuality-ExtIEs',
        'TrpMeasurementAngleQuality-ExtIEs',
        'TRP-MeasurementRequestItem-ExtIEs',
        'TRP-MeasurementResponseItem-ExtIEs',
        'TRP-MeasurementUpdateItem-ExtIEs',
        'TRPInformationTRPResp-ExtIEs',
        'TRPInformation-ExtIEs',
        'TRPInformationTypeResponseItem-ExtIEs',
        'TRPInformationTypeItemTRPReq',
        'TRPItem-ExtIEs',
        'TRPPositionDefinitionType-ExtIEs',
        'TRPPositionDirect-ExtIEs',
        'TRPPositionDirectAccuracy-ExtIEs',
        'TRPPositionReferenced-ExtIEs',
        'TRP-PRS-Information-List-Item-ExtIEs',
        'TRPReferencePointType-ExtIEs',
        'TRP-Rx-TEGInformation-ExtIEs',
        'TRP-RxTx-TEGInformation-ExtIEs',
        'TRP-Tx-TEGInformation-ExtIEs',
        'TRPTEGItem-ExtIEs',
        'DLPRSResource-Item-ExtIEs',
        'UEReportingInformation-ExtIEs',
        'UETxTEGAssociationItem-ExtIEs',
        'SRSResourceID-Item-ExtIEs',
        'UL-AoA-ExtIEs',
        'UL-RTOAMeasurement-ExtIEs',
        'ULRTOAMeas-ExtIEs',
        'UL-SRS-RSRPP-ExtIEs',
        'WLANMeasurementQuantities-ItemIEs',
        'WLANMeasurementQuantitiesValue-ExtIEs',
        'WLANMeasurementResult-Item-ExtIEs',
        'ZoA-ExtIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        'AbortTransmission-ExtIEs',
        'ActiveULBWP-ExtIEs',
        'AdditionalPathListItem-ExtIEs',
        'ExtendedAdditionalPathList-Item-ExtIEs',
        'AoA-AssistanceInfo-ExtIEs',
        'AngleMeasurementType-ExtIEs',
        'Expected-UL-AoA-ExtIEs',
        'Expected-ZoA-only-ExtIEs',
        'Expected-Azimuth-AoA-ExtIEs',
        'Expected-Zenith-AoA-ExtIEs',
        'ARPLocationInformation-ExtIEs',
        'ARPLocationType-ExtIEs',
        'Assistance-Information-ExtIEs',
        'AssistanceInformationFailureList-ExtIEs',
        'AssistanceInformationMetaData-ExtIEs',
        'BandwidthSRS-ExtIEs',
        'CarrierFreq-ExtIEs',
        'Cause-ExtensionIE',
        'CGI-EUTRA-ExtIEs',
        'CGI-NR-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'DL-PRS-ExtIEs',
        'DL-PRSMutingPattern-ExtIEs',
        'DLPRSResourceCoordinates-ExtIEs',
        'DLPRSResourceSetARP-ExtIEs',
        'DL-PRSResourceSetARPLocation-ExtIEs',
        'DLPRSResourceARP-ExtIEs',
        'DL-PRSResourceARPLocation-ExtIEs',
        'E-CID-MeasurementResult-ExtIEs',
        'GeographicalCoordinates-ExtIEs',
        'GNB-RxTxTimeDiff-ExtIEs',
        'GNBRxTxTimeDiffMeas-ExtIEs',
        'LCS-to-GCS-Translation-ExtIEs',
        'LCS-to-GCS-TranslationItem-ExtIEs',
        'LocationUncertainty-ExtIEs',
        'LoS-NLoSInformation-ExtIEs',
        'MeasurementBeamInfo-ExtIEs',
        'MeasurementQuantities-ItemIEs',
        'MeasurementQuantitiesValue-ExtIEs',
        'MeasuredResultsValue-ExtensionIE',
        'MultipleULAoA-ExtIEs',
        'MultipleULAoA-Item-ExtIEs',
        'NG-RANAccessPointPosition-ExtIEs',
        'NGRANHighAccuracyAccessPointPosition-ExtIEs',
        'NG-RAN-CGI-ExtIEs',
        'NG-RANCell-ExtensionIE',
        'NR-PRS-Beam-Information-IEs',
        'NR-PRS-Beam-InformationItem-ExtIEs',
        'OnDemandPRS-Info-ExtIEs',
        'OTDOACells-ExtIEs',
        'OTDOACell-Information-Item-ExtensionIE',
        'OtherRATMeasurementQuantities-ItemIEs',
        'OtherRATMeasurementQuantitiesValue-ExtIEs',
        'OtherRATMeasuredResultsValue-ExtensionIE',
        'PathlossReferenceInformation-ExtIEs',
        'PathlossReferenceSignal-ExtensionIE',
        'PosSIBs-ExtIEs',
        'PosSIB-Segments-ExtIEs',
        'PosSRSResource-Item-ExtIEs',
        'PosSRSResourceSet-Item-ExtIEs',
        'PosResourceSetType-ExtIEs',
        'PosResourceSetTypePeriodic-ExtIEs',
        'PosResourceSetTypeSemi-persistent-ExtIEs',
        'PosResourceSetTypeAperiodic-ExtIEs',
        'PRSAngleItem-ExtIEs',
        'PRSInformationPos-ExtIEs',
        'PRSConfiguration-ExtIEs',
        'PRSMutingConfiguration-EUTRA-ExtensionIE',
        'PRSFrequencyHoppingConfiguration-EUTRA-Item-IEs',
        'PRS-Measurements-Info-List-Item-ExtIEs',
        'PRSMuting-ExtIEs',
        'PRSMutingOption1-ExtIEs',
        'PRSMutingOption2-ExtIEs',
        'PRSResource-Item-ExtIEs',
        'PRSResource-QCLInfo-ExtIEs',
        'PRSResource-QCLSourceSSB-ExtIEs',
        'PRSResource-QCLSourcePRS-ExtIEs',
        'PRSResourceSet-Item-ExtIEs',
        'PRSTransmissionOffIndication-ExtIEs',
        'PRSTransmissionOffPerResource-Item-ExtIEs',
        'PRSTransmissionOffIndicationPerResource-Item-ExtIEs',
        'PRSTransmissionOffInformation-ExtIEs',
        'PRSTransmissionOffPerResourceSet-Item-ExtIEs',
        'PRSTRPItem-ExtIEs',
        'PRSTransmissionTRPItem-ExtIEs',
        'ReferenceSignal-ExtensionIE',
        'ReferencePoint-ExtIEs',
        'RelativeGeodeticLocation-ExtIEs',
        'RelativeCartesianLocation-ExtIEs',
        'RelativePathDelay-ExtIEs',
        'RequestedDLPRSTransmissionCharacteristics-ExtIEs',
        'RequestedDLPRSResourceSet-Item-ExtIEs',
        'RequestedDLPRSResource-Item-ExtIEs',
        'RequestedSRSTransmissionCharacteristics-ExtIEs',
        'SRSResourceSet-Item-ExtIEs',
        'ResourceSetType-ExtIEs',
        'ResourceSetTypePeriodic-ExtIEs',
        'ResourceSetTypeSemi-persistent-ExtIEs',
        'ResourceSetTypeAperiodic-ExtIEs',
        'ResourceType-ExtIEs',
        'ResourceTypePeriodic-ExtIEs',
        'ResourceTypeSemi-persistent-ExtIEs',
        'ResourceTypeAperiodic-ExtIEs',
        'ResourceTypePos-ExtIEs',
        'ResourceTypePeriodicPos-ExtIEs',
        'ResourceTypeSemi-persistentPos-ExtIEs',
        'ResourceTypeAperiodicPos-ExtIEs',
        'ResponseTime-ExtIEs',
        'ResultCSI-RSRP-Item-ExtIEs',
        'ResultCSI-RSRP-PerCSI-RS-Item-ExtIEs',
        'ResultCSI-RSRQ-Item-ExtIEs',
        'ResultCSI-RSRQ-PerCSI-RS-Item-ExtIEs',
        'ResultEUTRA-Item-ExtIEs',
        'ResultRSRP-EUTRA-Item-ExtIEs',
        'ResultRSRQ-EUTRA-Item-ExtIEs',
        'ResultSS-RSRP-Item-ExtIEs',
        'ResultSS-RSRP-PerSSB-Item-ExtIEs',
        'ResultSS-RSRQ-Item-ExtIEs',
        'ResultSS-RSRQ-PerSSB-Item-ExtIEs',
        'ResultGERAN-Item-ExtIEs',
        'ResultNR-Item-ExtIEs',
        'ResultUTRAN-Item-ExtIEs',
        'SCS-SpecificCarrier-ExtIEs',
        'Search-window-information-ExtIEs',
        'SpatialDirectionInformation-ExtIEs',
        'SpatialRelationInfo-ExtIEs',
        'SpatialRelationforResourceIDItem-ExtIEs',
        'SpatialRelationPerSRSResource-ExtIEs',
        'SpatialRelationPerSRSResourceItem-ExtIEs',
        'SpatialInformationPos-ExtIEs',
        'SRSConfig-ExtIEs',
        'SRSCarrier-List-Item-ExtIEs',
        'SRSConfiguration-ExtIEs',
        'SRSResource-ExtIEs',
        'SRSResourceSet-ExtIEs',
        'SRSResourceTrigger-ExtIEs',
        'SRSResourcetype-ExtIEs',
        'SSBInfo-ExtIEs',
        'SSBInfoItem-ExtIEs',
        'SSB-ExtIEs',
        'SSBBurstPosition-ExtIEs',
        'StartTimeAndDuration-ExtIEs',
        'SystemInformation-ExtIEs',
        'TDD-Config-EUTRA-Item-Item-ExtIEs',
        'TRPTEGInformation-ExtIEs',
        'RxTxTEG-ExtIEs',
        'RxTEG-ExtIEs',
        'TF-Configuration-ExtIEs',
        'TimeStamp-ExtIEs',
        'TimeStampSlotIndex-ExtIEs',
        'TransmissionComb-ExtIEs',
        'TransmissionCombPos-ExtIEs',
        'TRPBeamAntennaInformation-ExtIEs',
        'Choice-TRP-Beam-Info-Item-ExtIEs',
        'TRP-BeamAntennaExplicitInformation-ExtIEs',
        'TRP-BeamAntennaAnglesList-Item-ExtIEs',
        'TRP-ElevationAngleList-Item-ExtIEs',
        'TRP-Beam-Power-Item-ExtIEs',
        'TRPMeasurementQuantitiesList-Item-ExtIEs',
        'TrpMeasurementResultItem-ExtIEs',
        'TrpMeasuredResultsValue-ExtIEs',
        'TrpMeasurementQuality-ExtIEs',
        'TrpMeasurementTimingQuality-ExtIEs',
        'TrpMeasurementAngleQuality-ExtIEs',
        'TRP-MeasurementRequestItem-ExtIEs',
        'TRP-MeasurementResponseItem-ExtIEs',
        'TRP-MeasurementUpdateItem-ExtIEs',
        'TRPInformationTRPResp-ExtIEs',
        'TRPInformation-ExtIEs',
        'TRPInformationTypeResponseItem-ExtIEs',
        'TRPInformationTypeItemTRPReq',
        'TRPItem-ExtIEs',
        'TRPPositionDefinitionType-ExtIEs',
        'TRPPositionDirect-ExtIEs',
        'TRPPositionDirectAccuracy-ExtIEs',
        'TRPPositionReferenced-ExtIEs',
        'TRP-PRS-Information-List-Item-ExtIEs',
        'TRPReferencePointType-ExtIEs',
        'TRP-Rx-TEGInformation-ExtIEs',
        'TRP-RxTx-TEGInformation-ExtIEs',
        'TRP-Tx-TEGInformation-ExtIEs',
        'TRPTEGItem-ExtIEs',
        'DLPRSResource-Item-ExtIEs',
        'UEReportingInformation-ExtIEs',
        'UETxTEGAssociationItem-ExtIEs',
        'SRSResourceID-Item-ExtIEs',
        'UL-AoA-ExtIEs',
        'UL-RTOAMeasurement-ExtIEs',
        'ULRTOAMeas-ExtIEs',
        'UL-SRS-RSRPP-ExtIEs',
        'WLANMeasurementQuantities-ItemIEs',
        'WLANMeasurementQuantitiesValue-ExtIEs',
        'WLANMeasurementResult-Item-ExtIEs',
        'ZoA-ExtIEs',
        ]
    _param_ = [
        ]
    
    #-----< AbortTransmission >-----#
    AbortTransmission = CHOICE(name='AbortTransmission', mode=MODE_TYPE)
    _AbortTransmission_deactivateSRSResourceSetID = INT(name='deactivateSRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSResourceSetID')))
    _AbortTransmission_releaseALL = NULL(name='releaseALL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AbortTransmission_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __AbortTransmission_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___AbortTransmission_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___AbortTransmission_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AbortTransmission_choice_extension_id._const_tab = ___AbortTransmission_choice_extension_id_tab
    __AbortTransmission_choice_extension_id._const_tab_at = None
    __AbortTransmission_choice_extension_id._const_tab_id = 'id'
    __AbortTransmission_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___AbortTransmission_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___AbortTransmission_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AbortTransmission_choice_extension_criticality._const_tab = ___AbortTransmission_choice_extension_criticality_tab
    __AbortTransmission_choice_extension_criticality._const_tab_at = ('..', 'id')
    __AbortTransmission_choice_extension_criticality._const_tab_id = 'criticality'
    __AbortTransmission_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___AbortTransmission_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___AbortTransmission_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AbortTransmission_choice_extension_value._const_tab = ___AbortTransmission_choice_extension_value_tab
    __AbortTransmission_choice_extension_value._const_tab_at = ('..', 'id')
    __AbortTransmission_choice_extension_value._const_tab_id = 'Value'
    _AbortTransmission_choice_extension._cont = ASN1Dict([
        ('id', __AbortTransmission_choice_extension_id),
        ('criticality', __AbortTransmission_choice_extension_criticality),
        ('value', __AbortTransmission_choice_extension_value),
        ])
    _AbortTransmission_choice_extension._ext = None
    AbortTransmission._cont = ASN1Dict([
        ('deactivateSRSResourceSetID', _AbortTransmission_deactivateSRSResourceSetID),
        ('releaseALL', _AbortTransmission_releaseALL),
        ('choice-extension', _AbortTransmission_choice_extension),
        ])
    AbortTransmission._ext = None
    
    #-----< AbortTransmission-ExtIEs >-----#
    AbortTransmission_ExtIEs = CLASS(name='AbortTransmission-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    AbortTransmission_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ActiveULBWP >-----#
    ActiveULBWP = SEQ(name='ActiveULBWP', mode=MODE_TYPE)
    _ActiveULBWP_locationAndBandwidth = INT(name='locationAndBandwidth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ActiveULBWP_locationAndBandwidth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=37949)], ev=[], er=[])
    _ActiveULBWP_subcarrierSpacing = ENUM(name='subcarrierSpacing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ActiveULBWP_subcarrierSpacing._cont = ASN1Dict([('kHz15', 0), ('kHz30', 1), ('kHz60', 2), ('kHz120', 3)])
    _ActiveULBWP_subcarrierSpacing._ext = []
    _ActiveULBWP_cyclicPrefix = ENUM(name='cyclicPrefix', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ActiveULBWP_cyclicPrefix._cont = ASN1Dict([('normal', 0), ('extended', 1)])
    _ActiveULBWP_cyclicPrefix._ext = None
    _ActiveULBWP_txDirectCurrentLocation = INT(name='txDirectCurrentLocation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ActiveULBWP_txDirectCurrentLocation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3301)], ev=[], er=[])
    _ActiveULBWP_shift7dot5kHz = ENUM(name='shift7dot5kHz', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ActiveULBWP_shift7dot5kHz._cont = ASN1Dict([('true', 0)])
    _ActiveULBWP_shift7dot5kHz._ext = []
    _ActiveULBWP_sRSConfig = SEQ(name='sRSConfig', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSConfig')))
    _ActiveULBWP_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ActiveULBWP_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ActiveULBWP_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ActiveULBWP_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ActiveULBWP_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ActiveULBWP_iE_Extensions__item__id._const_tab = ____ActiveULBWP_iE_Extensions__item__id_tab
    ___ActiveULBWP_iE_Extensions__item__id._const_tab_at = None
    ___ActiveULBWP_iE_Extensions__item__id._const_tab_id = 'id'
    ___ActiveULBWP_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ActiveULBWP_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ActiveULBWP_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ActiveULBWP_iE_Extensions__item__criticality._const_tab = ____ActiveULBWP_iE_Extensions__item__criticality_tab
    ___ActiveULBWP_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ActiveULBWP_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ActiveULBWP_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ActiveULBWP_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ActiveULBWP_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ActiveULBWP_iE_Extensions__item__extensionValue._const_tab = ____ActiveULBWP_iE_Extensions__item__extensionValue_tab
    ___ActiveULBWP_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ActiveULBWP_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ActiveULBWP_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ActiveULBWP_iE_Extensions__item__id),
        ('criticality', ___ActiveULBWP_iE_Extensions__item__criticality),
        ('extensionValue', ___ActiveULBWP_iE_Extensions__item__extensionValue),
        ])
    __ActiveULBWP_iE_Extensions__item_._ext = None
    _ActiveULBWP_iE_Extensions._cont = __ActiveULBWP_iE_Extensions__item_
    _ActiveULBWP_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ActiveULBWP._cont = ASN1Dict([
        ('locationAndBandwidth', _ActiveULBWP_locationAndBandwidth),
        ('subcarrierSpacing', _ActiveULBWP_subcarrierSpacing),
        ('cyclicPrefix', _ActiveULBWP_cyclicPrefix),
        ('txDirectCurrentLocation', _ActiveULBWP_txDirectCurrentLocation),
        ('shift7dot5kHz', _ActiveULBWP_shift7dot5kHz),
        ('sRSConfig', _ActiveULBWP_sRSConfig),
        ('iE-Extensions', _ActiveULBWP_iE_Extensions),
        ])
    ActiveULBWP._ext = []
    
    #-----< ActiveULBWP-ExtIEs >-----#
    ActiveULBWP_ExtIEs = CLASS(name='ActiveULBWP-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ActiveULBWP_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AdditionalPathList >-----#
    AdditionalPathList = SEQ_OF(name='AdditionalPathList', mode=MODE_TYPE)
    _AdditionalPathList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'AdditionalPathListItem')))
    AdditionalPathList._cont = _AdditionalPathList__item_
    AdditionalPathList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< AdditionalPathListItem >-----#
    AdditionalPathListItem = SEQ(name='AdditionalPathListItem', mode=MODE_TYPE)
    _AdditionalPathListItem_relativeTimeOfPath = CHOICE(name='relativeTimeOfPath', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RelativePathDelay')))
    _AdditionalPathListItem_pathQuality = CHOICE(name='pathQuality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TrpMeasurementQuality')), opt=True)
    _AdditionalPathListItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AdditionalPathListItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___AdditionalPathListItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____AdditionalPathListItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____AdditionalPathListItem_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MultipleULAoA')))
    _____AdditionalPathListItem_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UL-SRS-RSRPP')))
    ____AdditionalPathListItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 74), ('criticality', 'ignore'), ('Extension', _____AdditionalPathListItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'ignore'), ('Extension', _____AdditionalPathListItem_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___AdditionalPathListItem_iE_Extensions__item__id._const_tab = ____AdditionalPathListItem_iE_Extensions__item__id_tab
    ___AdditionalPathListItem_iE_Extensions__item__id._const_tab_at = None
    ___AdditionalPathListItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___AdditionalPathListItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ___AdditionalPathListItem_iE_Extensions__item__criticality._const_tab = ____AdditionalPathListItem_iE_Extensions__item__id_tab
    ___AdditionalPathListItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AdditionalPathListItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AdditionalPathListItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ___AdditionalPathListItem_iE_Extensions__item__extensionValue._const_tab = ____AdditionalPathListItem_iE_Extensions__item__id_tab
    ___AdditionalPathListItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AdditionalPathListItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AdditionalPathListItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AdditionalPathListItem_iE_Extensions__item__id),
        ('criticality', ___AdditionalPathListItem_iE_Extensions__item__criticality),
        ('extensionValue', ___AdditionalPathListItem_iE_Extensions__item__extensionValue),
        ])
    __AdditionalPathListItem_iE_Extensions__item_._ext = None
    _AdditionalPathListItem_iE_Extensions._cont = __AdditionalPathListItem_iE_Extensions__item_
    _AdditionalPathListItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AdditionalPathListItem._cont = ASN1Dict([
        ('relativeTimeOfPath', _AdditionalPathListItem_relativeTimeOfPath),
        ('pathQuality', _AdditionalPathListItem_pathQuality),
        ('iE-Extensions', _AdditionalPathListItem_iE_Extensions),
        ])
    AdditionalPathListItem._ext = []
    
    #-----< AdditionalPathListItem-ExtIEs >-----#
    AdditionalPathListItem_ExtIEs = CLASS(name='AdditionalPathListItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _AdditionalPathListItem_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MultipleULAoA')))
    _AdditionalPathListItem_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UL-SRS-RSRPP')))
    AdditionalPathListItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 74), ('criticality', 'ignore'), ('Extension', _AdditionalPathListItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'ignore'), ('Extension', _AdditionalPathListItem_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ExtendedAdditionalPathList >-----#
    ExtendedAdditionalPathList = SEQ_OF(name='ExtendedAdditionalPathList', mode=MODE_TYPE)
    _ExtendedAdditionalPathList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ExtendedAdditionalPathList-Item')))
    ExtendedAdditionalPathList._cont = _ExtendedAdditionalPathList__item_
    ExtendedAdditionalPathList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< ExtendedAdditionalPathList-Item >-----#
    ExtendedAdditionalPathList_Item = SEQ(name='ExtendedAdditionalPathList-Item', mode=MODE_TYPE)
    _ExtendedAdditionalPathList_Item_relativeTimeOfPath = CHOICE(name='relativeTimeOfPath', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RelativePathDelay')))
    _ExtendedAdditionalPathList_Item_pathQuality = CHOICE(name='pathQuality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TrpMeasurementQuality')), opt=True)
    _ExtendedAdditionalPathList_Item_multipleULAoA = SEQ(name='multipleULAoA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'MultipleULAoA')), opt=True)
    _ExtendedAdditionalPathList_Item_pathPower = SEQ(name='pathPower', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'UL-SRS-RSRPP')), opt=True)
    _ExtendedAdditionalPathList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExtendedAdditionalPathList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ExtendedAdditionalPathList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ExtendedAdditionalPathList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ExtendedAdditionalPathList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtendedAdditionalPathList_Item_iE_Extensions__item__id._const_tab = ____ExtendedAdditionalPathList_Item_iE_Extensions__item__id_tab
    ___ExtendedAdditionalPathList_Item_iE_Extensions__item__id._const_tab_at = None
    ___ExtendedAdditionalPathList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ExtendedAdditionalPathList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ExtendedAdditionalPathList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ExtendedAdditionalPathList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtendedAdditionalPathList_Item_iE_Extensions__item__criticality._const_tab = ____ExtendedAdditionalPathList_Item_iE_Extensions__item__criticality_tab
    ___ExtendedAdditionalPathList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ExtendedAdditionalPathList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ExtendedAdditionalPathList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ExtendedAdditionalPathList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ExtendedAdditionalPathList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtendedAdditionalPathList_Item_iE_Extensions__item__extensionValue._const_tab = ____ExtendedAdditionalPathList_Item_iE_Extensions__item__extensionValue_tab
    ___ExtendedAdditionalPathList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ExtendedAdditionalPathList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ExtendedAdditionalPathList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ExtendedAdditionalPathList_Item_iE_Extensions__item__id),
        ('criticality', ___ExtendedAdditionalPathList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ExtendedAdditionalPathList_Item_iE_Extensions__item__extensionValue),
        ])
    __ExtendedAdditionalPathList_Item_iE_Extensions__item_._ext = None
    _ExtendedAdditionalPathList_Item_iE_Extensions._cont = __ExtendedAdditionalPathList_Item_iE_Extensions__item_
    _ExtendedAdditionalPathList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExtendedAdditionalPathList_Item._cont = ASN1Dict([
        ('relativeTimeOfPath', _ExtendedAdditionalPathList_Item_relativeTimeOfPath),
        ('pathQuality', _ExtendedAdditionalPathList_Item_pathQuality),
        ('multipleULAoA', _ExtendedAdditionalPathList_Item_multipleULAoA),
        ('pathPower', _ExtendedAdditionalPathList_Item_pathPower),
        ('iE-Extensions', _ExtendedAdditionalPathList_Item_iE_Extensions),
        ])
    ExtendedAdditionalPathList_Item._ext = []
    
    #-----< ExtendedAdditionalPathList-Item-ExtIEs >-----#
    ExtendedAdditionalPathList_Item_ExtIEs = CLASS(name='ExtendedAdditionalPathList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ExtendedAdditionalPathList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AoA-AssistanceInfo >-----#
    AoA_AssistanceInfo = SEQ(name='AoA-AssistanceInfo', mode=MODE_TYPE)
    _AoA_AssistanceInfo_angleMeasurement = CHOICE(name='angleMeasurement', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'AngleMeasurementType')))
    _AoA_AssistanceInfo_lCS_to_GCS_Translation = SEQ(name='lCS-to-GCS-Translation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'LCS-to-GCS-Translation')), opt=True)
    _AoA_AssistanceInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AoA_AssistanceInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___AoA_AssistanceInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____AoA_AssistanceInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____AoA_AssistanceInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AoA_AssistanceInfo_iE_Extensions__item__id._const_tab = ____AoA_AssistanceInfo_iE_Extensions__item__id_tab
    ___AoA_AssistanceInfo_iE_Extensions__item__id._const_tab_at = None
    ___AoA_AssistanceInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___AoA_AssistanceInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____AoA_AssistanceInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____AoA_AssistanceInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AoA_AssistanceInfo_iE_Extensions__item__criticality._const_tab = ____AoA_AssistanceInfo_iE_Extensions__item__criticality_tab
    ___AoA_AssistanceInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AoA_AssistanceInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AoA_AssistanceInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____AoA_AssistanceInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____AoA_AssistanceInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AoA_AssistanceInfo_iE_Extensions__item__extensionValue._const_tab = ____AoA_AssistanceInfo_iE_Extensions__item__extensionValue_tab
    ___AoA_AssistanceInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AoA_AssistanceInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AoA_AssistanceInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AoA_AssistanceInfo_iE_Extensions__item__id),
        ('criticality', ___AoA_AssistanceInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___AoA_AssistanceInfo_iE_Extensions__item__extensionValue),
        ])
    __AoA_AssistanceInfo_iE_Extensions__item_._ext = None
    _AoA_AssistanceInfo_iE_Extensions._cont = __AoA_AssistanceInfo_iE_Extensions__item_
    _AoA_AssistanceInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AoA_AssistanceInfo._cont = ASN1Dict([
        ('angleMeasurement', _AoA_AssistanceInfo_angleMeasurement),
        ('lCS-to-GCS-Translation', _AoA_AssistanceInfo_lCS_to_GCS_Translation),
        ('iE-Extensions', _AoA_AssistanceInfo_iE_Extensions),
        ])
    AoA_AssistanceInfo._ext = []
    
    #-----< AoA-AssistanceInfo-ExtIEs >-----#
    AoA_AssistanceInfo_ExtIEs = CLASS(name='AoA-AssistanceInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    AoA_AssistanceInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AperiodicSRSResourceTriggerList >-----#
    AperiodicSRSResourceTriggerList = SEQ_OF(name='AperiodicSRSResourceTriggerList', mode=MODE_TYPE)
    _AperiodicSRSResourceTriggerList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'AperiodicSRSResourceTrigger')))
    AperiodicSRSResourceTriggerList._cont = _AperiodicSRSResourceTriggerList__item_
    AperiodicSRSResourceTriggerList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< AperiodicSRSResourceTrigger >-----#
    AperiodicSRSResourceTrigger = INT(name='AperiodicSRSResourceTrigger', mode=MODE_TYPE)
    AperiodicSRSResourceTrigger._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< AngleMeasurementType >-----#
    AngleMeasurementType = CHOICE(name='AngleMeasurementType', mode=MODE_TYPE)
    _AngleMeasurementType_expected_ULAoA = SEQ(name='expected-ULAoA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'Expected-UL-AoA')))
    _AngleMeasurementType_expected_ZoA = SEQ(name='expected-ZoA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'Expected-ZoA-only')))
    _AngleMeasurementType_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __AngleMeasurementType_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___AngleMeasurementType_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___AngleMeasurementType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AngleMeasurementType_choice_extension_id._const_tab = ___AngleMeasurementType_choice_extension_id_tab
    __AngleMeasurementType_choice_extension_id._const_tab_at = None
    __AngleMeasurementType_choice_extension_id._const_tab_id = 'id'
    __AngleMeasurementType_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___AngleMeasurementType_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___AngleMeasurementType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AngleMeasurementType_choice_extension_criticality._const_tab = ___AngleMeasurementType_choice_extension_criticality_tab
    __AngleMeasurementType_choice_extension_criticality._const_tab_at = ('..', 'id')
    __AngleMeasurementType_choice_extension_criticality._const_tab_id = 'criticality'
    __AngleMeasurementType_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___AngleMeasurementType_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___AngleMeasurementType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AngleMeasurementType_choice_extension_value._const_tab = ___AngleMeasurementType_choice_extension_value_tab
    __AngleMeasurementType_choice_extension_value._const_tab_at = ('..', 'id')
    __AngleMeasurementType_choice_extension_value._const_tab_id = 'Value'
    _AngleMeasurementType_choice_extension._cont = ASN1Dict([
        ('id', __AngleMeasurementType_choice_extension_id),
        ('criticality', __AngleMeasurementType_choice_extension_criticality),
        ('value', __AngleMeasurementType_choice_extension_value),
        ])
    _AngleMeasurementType_choice_extension._ext = None
    AngleMeasurementType._cont = ASN1Dict([
        ('expected-ULAoA', _AngleMeasurementType_expected_ULAoA),
        ('expected-ZoA', _AngleMeasurementType_expected_ZoA),
        ('choice-extension', _AngleMeasurementType_choice_extension),
        ])
    AngleMeasurementType._ext = None
    
    #-----< AngleMeasurementType-ExtIEs >-----#
    AngleMeasurementType_ExtIEs = CLASS(name='AngleMeasurementType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    AngleMeasurementType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Expected-UL-AoA >-----#
    Expected_UL_AoA = SEQ(name='Expected-UL-AoA', mode=MODE_TYPE)
    _Expected_UL_AoA_expected_Azimuth_AoA = SEQ(name='expected-Azimuth-AoA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'Expected-Azimuth-AoA')))
    _Expected_UL_AoA_expected_Zenith_AoA = SEQ(name='expected-Zenith-AoA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'Expected-Zenith-AoA')), opt=True)
    _Expected_UL_AoA_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Expected_UL_AoA_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___Expected_UL_AoA_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____Expected_UL_AoA_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____Expected_UL_AoA_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Expected_UL_AoA_iE_extensions__item__id._const_tab = ____Expected_UL_AoA_iE_extensions__item__id_tab
    ___Expected_UL_AoA_iE_extensions__item__id._const_tab_at = None
    ___Expected_UL_AoA_iE_extensions__item__id._const_tab_id = 'id'
    ___Expected_UL_AoA_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____Expected_UL_AoA_iE_extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____Expected_UL_AoA_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Expected_UL_AoA_iE_extensions__item__criticality._const_tab = ____Expected_UL_AoA_iE_extensions__item__criticality_tab
    ___Expected_UL_AoA_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Expected_UL_AoA_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___Expected_UL_AoA_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____Expected_UL_AoA_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____Expected_UL_AoA_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Expected_UL_AoA_iE_extensions__item__extensionValue._const_tab = ____Expected_UL_AoA_iE_extensions__item__extensionValue_tab
    ___Expected_UL_AoA_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Expected_UL_AoA_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __Expected_UL_AoA_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___Expected_UL_AoA_iE_extensions__item__id),
        ('criticality', ___Expected_UL_AoA_iE_extensions__item__criticality),
        ('extensionValue', ___Expected_UL_AoA_iE_extensions__item__extensionValue),
        ])
    __Expected_UL_AoA_iE_extensions__item_._ext = None
    _Expected_UL_AoA_iE_extensions._cont = __Expected_UL_AoA_iE_extensions__item_
    _Expected_UL_AoA_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Expected_UL_AoA._cont = ASN1Dict([
        ('expected-Azimuth-AoA', _Expected_UL_AoA_expected_Azimuth_AoA),
        ('expected-Zenith-AoA', _Expected_UL_AoA_expected_Zenith_AoA),
        ('iE-extensions', _Expected_UL_AoA_iE_extensions),
        ])
    Expected_UL_AoA._ext = []
    
    #-----< Expected-UL-AoA-ExtIEs >-----#
    Expected_UL_AoA_ExtIEs = CLASS(name='Expected-UL-AoA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    Expected_UL_AoA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Expected-ZoA-only >-----#
    Expected_ZoA_only = SEQ(name='Expected-ZoA-only', mode=MODE_TYPE)
    _Expected_ZoA_only_expected_ZoA_only = SEQ(name='expected-ZoA-only', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'Expected-Zenith-AoA')))
    _Expected_ZoA_only_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Expected_ZoA_only_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___Expected_ZoA_only_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____Expected_ZoA_only_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____Expected_ZoA_only_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Expected_ZoA_only_iE_extensions__item__id._const_tab = ____Expected_ZoA_only_iE_extensions__item__id_tab
    ___Expected_ZoA_only_iE_extensions__item__id._const_tab_at = None
    ___Expected_ZoA_only_iE_extensions__item__id._const_tab_id = 'id'
    ___Expected_ZoA_only_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____Expected_ZoA_only_iE_extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____Expected_ZoA_only_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Expected_ZoA_only_iE_extensions__item__criticality._const_tab = ____Expected_ZoA_only_iE_extensions__item__criticality_tab
    ___Expected_ZoA_only_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Expected_ZoA_only_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___Expected_ZoA_only_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____Expected_ZoA_only_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____Expected_ZoA_only_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Expected_ZoA_only_iE_extensions__item__extensionValue._const_tab = ____Expected_ZoA_only_iE_extensions__item__extensionValue_tab
    ___Expected_ZoA_only_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Expected_ZoA_only_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __Expected_ZoA_only_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___Expected_ZoA_only_iE_extensions__item__id),
        ('criticality', ___Expected_ZoA_only_iE_extensions__item__criticality),
        ('extensionValue', ___Expected_ZoA_only_iE_extensions__item__extensionValue),
        ])
    __Expected_ZoA_only_iE_extensions__item_._ext = None
    _Expected_ZoA_only_iE_extensions._cont = __Expected_ZoA_only_iE_extensions__item_
    _Expected_ZoA_only_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Expected_ZoA_only._cont = ASN1Dict([
        ('expected-ZoA-only', _Expected_ZoA_only_expected_ZoA_only),
        ('iE-extensions', _Expected_ZoA_only_iE_extensions),
        ])
    Expected_ZoA_only._ext = []
    
    #-----< Expected-ZoA-only-ExtIEs >-----#
    Expected_ZoA_only_ExtIEs = CLASS(name='Expected-ZoA-only-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    Expected_ZoA_only_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Expected-Azimuth-AoA >-----#
    Expected_Azimuth_AoA = SEQ(name='Expected-Azimuth-AoA', mode=MODE_TYPE)
    _Expected_Azimuth_AoA_expected_Azimuth_AoA_value = INT(name='expected-Azimuth-AoA-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'Expected-Value-AoA')))
    _Expected_Azimuth_AoA_expected_Azimuth_AoA_uncertainty = INT(name='expected-Azimuth-AoA-uncertainty', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'Uncertainty-range-AoA')))
    _Expected_Azimuth_AoA_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Expected_Azimuth_AoA_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___Expected_Azimuth_AoA_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____Expected_Azimuth_AoA_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____Expected_Azimuth_AoA_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Expected_Azimuth_AoA_iE_extensions__item__id._const_tab = ____Expected_Azimuth_AoA_iE_extensions__item__id_tab
    ___Expected_Azimuth_AoA_iE_extensions__item__id._const_tab_at = None
    ___Expected_Azimuth_AoA_iE_extensions__item__id._const_tab_id = 'id'
    ___Expected_Azimuth_AoA_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____Expected_Azimuth_AoA_iE_extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____Expected_Azimuth_AoA_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Expected_Azimuth_AoA_iE_extensions__item__criticality._const_tab = ____Expected_Azimuth_AoA_iE_extensions__item__criticality_tab
    ___Expected_Azimuth_AoA_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Expected_Azimuth_AoA_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___Expected_Azimuth_AoA_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____Expected_Azimuth_AoA_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____Expected_Azimuth_AoA_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Expected_Azimuth_AoA_iE_extensions__item__extensionValue._const_tab = ____Expected_Azimuth_AoA_iE_extensions__item__extensionValue_tab
    ___Expected_Azimuth_AoA_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Expected_Azimuth_AoA_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __Expected_Azimuth_AoA_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___Expected_Azimuth_AoA_iE_extensions__item__id),
        ('criticality', ___Expected_Azimuth_AoA_iE_extensions__item__criticality),
        ('extensionValue', ___Expected_Azimuth_AoA_iE_extensions__item__extensionValue),
        ])
    __Expected_Azimuth_AoA_iE_extensions__item_._ext = None
    _Expected_Azimuth_AoA_iE_extensions._cont = __Expected_Azimuth_AoA_iE_extensions__item_
    _Expected_Azimuth_AoA_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Expected_Azimuth_AoA._cont = ASN1Dict([
        ('expected-Azimuth-AoA-value', _Expected_Azimuth_AoA_expected_Azimuth_AoA_value),
        ('expected-Azimuth-AoA-uncertainty', _Expected_Azimuth_AoA_expected_Azimuth_AoA_uncertainty),
        ('iE-extensions', _Expected_Azimuth_AoA_iE_extensions),
        ])
    Expected_Azimuth_AoA._ext = []
    
    #-----< Expected-Azimuth-AoA-ExtIEs >-----#
    Expected_Azimuth_AoA_ExtIEs = CLASS(name='Expected-Azimuth-AoA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    Expected_Azimuth_AoA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Expected-Zenith-AoA >-----#
    Expected_Zenith_AoA = SEQ(name='Expected-Zenith-AoA', mode=MODE_TYPE)
    _Expected_Zenith_AoA_expected_Zenith_AoA_value = INT(name='expected-Zenith-AoA-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'Expected-Value-ZoA')))
    _Expected_Zenith_AoA_expected_Zenith_AoA_uncertainty = INT(name='expected-Zenith-AoA-uncertainty', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'Uncertainty-range-ZoA')))
    _Expected_Zenith_AoA_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Expected_Zenith_AoA_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___Expected_Zenith_AoA_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____Expected_Zenith_AoA_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____Expected_Zenith_AoA_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Expected_Zenith_AoA_iE_extensions__item__id._const_tab = ____Expected_Zenith_AoA_iE_extensions__item__id_tab
    ___Expected_Zenith_AoA_iE_extensions__item__id._const_tab_at = None
    ___Expected_Zenith_AoA_iE_extensions__item__id._const_tab_id = 'id'
    ___Expected_Zenith_AoA_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____Expected_Zenith_AoA_iE_extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____Expected_Zenith_AoA_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Expected_Zenith_AoA_iE_extensions__item__criticality._const_tab = ____Expected_Zenith_AoA_iE_extensions__item__criticality_tab
    ___Expected_Zenith_AoA_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Expected_Zenith_AoA_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___Expected_Zenith_AoA_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____Expected_Zenith_AoA_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____Expected_Zenith_AoA_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Expected_Zenith_AoA_iE_extensions__item__extensionValue._const_tab = ____Expected_Zenith_AoA_iE_extensions__item__extensionValue_tab
    ___Expected_Zenith_AoA_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Expected_Zenith_AoA_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __Expected_Zenith_AoA_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___Expected_Zenith_AoA_iE_extensions__item__id),
        ('criticality', ___Expected_Zenith_AoA_iE_extensions__item__criticality),
        ('extensionValue', ___Expected_Zenith_AoA_iE_extensions__item__extensionValue),
        ])
    __Expected_Zenith_AoA_iE_extensions__item_._ext = None
    _Expected_Zenith_AoA_iE_extensions._cont = __Expected_Zenith_AoA_iE_extensions__item_
    _Expected_Zenith_AoA_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Expected_Zenith_AoA._cont = ASN1Dict([
        ('expected-Zenith-AoA-value', _Expected_Zenith_AoA_expected_Zenith_AoA_value),
        ('expected-Zenith-AoA-uncertainty', _Expected_Zenith_AoA_expected_Zenith_AoA_uncertainty),
        ('iE-extensions', _Expected_Zenith_AoA_iE_extensions),
        ])
    Expected_Zenith_AoA._ext = []
    
    #-----< Expected-Zenith-AoA-ExtIEs >-----#
    Expected_Zenith_AoA_ExtIEs = CLASS(name='Expected-Zenith-AoA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    Expected_Zenith_AoA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ARP-ID >-----#
    ARP_ID = INT(name='ARP-ID', mode=MODE_TYPE)
    ARP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=[], er=[])
    
    #-----< ARPLocationInformation >-----#
    ARPLocationInformation = SEQ_OF(name='ARPLocationInformation', mode=MODE_TYPE)
    _ARPLocationInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ARPLocationInformation-Item')))
    ARPLocationInformation._cont = _ARPLocationInformation__item_
    ARPLocationInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< ARPLocationInformation-Item >-----#
    ARPLocationInformation_Item = SEQ(name='ARPLocationInformation-Item', mode=MODE_TYPE)
    _ARPLocationInformation_Item_aRP_ID = INT(name='aRP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ARP-ID')))
    _ARPLocationInformation_Item_aRPLocationType = CHOICE(name='aRPLocationType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ARPLocationType')))
    _ARPLocationInformation_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ARPLocationInformation_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ARPLocationInformation_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ARPLocationInformation_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ARPLocationInformation_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ARPLocationInformation_Item_iE_Extensions__item__id._const_tab = ____ARPLocationInformation_Item_iE_Extensions__item__id_tab
    ___ARPLocationInformation_Item_iE_Extensions__item__id._const_tab_at = None
    ___ARPLocationInformation_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ARPLocationInformation_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ARPLocationInformation_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ARPLocationInformation_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ARPLocationInformation_Item_iE_Extensions__item__criticality._const_tab = ____ARPLocationInformation_Item_iE_Extensions__item__criticality_tab
    ___ARPLocationInformation_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ARPLocationInformation_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ARPLocationInformation_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ARPLocationInformation_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ARPLocationInformation_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ARPLocationInformation_Item_iE_Extensions__item__extensionValue._const_tab = ____ARPLocationInformation_Item_iE_Extensions__item__extensionValue_tab
    ___ARPLocationInformation_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ARPLocationInformation_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ARPLocationInformation_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ARPLocationInformation_Item_iE_Extensions__item__id),
        ('criticality', ___ARPLocationInformation_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ARPLocationInformation_Item_iE_Extensions__item__extensionValue),
        ])
    __ARPLocationInformation_Item_iE_Extensions__item_._ext = None
    _ARPLocationInformation_Item_iE_Extensions._cont = __ARPLocationInformation_Item_iE_Extensions__item_
    _ARPLocationInformation_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ARPLocationInformation_Item._cont = ASN1Dict([
        ('aRP-ID', _ARPLocationInformation_Item_aRP_ID),
        ('aRPLocationType', _ARPLocationInformation_Item_aRPLocationType),
        ('iE-Extensions', _ARPLocationInformation_Item_iE_Extensions),
        ])
    ARPLocationInformation_Item._ext = []
    
    #-----< ARPLocationInformation-ExtIEs >-----#
    ARPLocationInformation_ExtIEs = CLASS(name='ARPLocationInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ARPLocationInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ARPLocationType >-----#
    ARPLocationType = CHOICE(name='ARPLocationType', mode=MODE_TYPE)
    _ARPLocationType_aRPPositionRelativeGeodetic = SEQ(name='aRPPositionRelativeGeodetic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RelativeGeodeticLocation')))
    _ARPLocationType_aRPPositionRelativeCartesian = SEQ(name='aRPPositionRelativeCartesian', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RelativeCartesianLocation')))
    _ARPLocationType_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __ARPLocationType_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___ARPLocationType_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ARPLocationType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ARPLocationType_choice_extension_id._const_tab = ___ARPLocationType_choice_extension_id_tab
    __ARPLocationType_choice_extension_id._const_tab_at = None
    __ARPLocationType_choice_extension_id._const_tab_id = 'id'
    __ARPLocationType_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___ARPLocationType_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ARPLocationType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ARPLocationType_choice_extension_criticality._const_tab = ___ARPLocationType_choice_extension_criticality_tab
    __ARPLocationType_choice_extension_criticality._const_tab_at = ('..', 'id')
    __ARPLocationType_choice_extension_criticality._const_tab_id = 'criticality'
    __ARPLocationType_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___ARPLocationType_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ARPLocationType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ARPLocationType_choice_extension_value._const_tab = ___ARPLocationType_choice_extension_value_tab
    __ARPLocationType_choice_extension_value._const_tab_at = ('..', 'id')
    __ARPLocationType_choice_extension_value._const_tab_id = 'Value'
    _ARPLocationType_choice_extension._cont = ASN1Dict([
        ('id', __ARPLocationType_choice_extension_id),
        ('criticality', __ARPLocationType_choice_extension_criticality),
        ('value', __ARPLocationType_choice_extension_value),
        ])
    _ARPLocationType_choice_extension._ext = None
    ARPLocationType._cont = ASN1Dict([
        ('aRPPositionRelativeGeodetic', _ARPLocationType_aRPPositionRelativeGeodetic),
        ('aRPPositionRelativeCartesian', _ARPLocationType_aRPPositionRelativeCartesian),
        ('choice-extension', _ARPLocationType_choice_extension),
        ])
    ARPLocationType._ext = None
    
    #-----< ARPLocationType-ExtIEs >-----#
    ARPLocationType_ExtIEs = CLASS(name='ARPLocationType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ARPLocationType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Assistance-Information >-----#
    Assistance_Information = SEQ(name='Assistance-Information', mode=MODE_TYPE)
    _Assistance_Information_systemInformation = SEQ_OF(name='systemInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SystemInformation')))
    _Assistance_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Assistance_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___Assistance_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____Assistance_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____Assistance_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Assistance_Information_iE_Extensions__item__id._const_tab = ____Assistance_Information_iE_Extensions__item__id_tab
    ___Assistance_Information_iE_Extensions__item__id._const_tab_at = None
    ___Assistance_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___Assistance_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____Assistance_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____Assistance_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Assistance_Information_iE_Extensions__item__criticality._const_tab = ____Assistance_Information_iE_Extensions__item__criticality_tab
    ___Assistance_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Assistance_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Assistance_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____Assistance_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____Assistance_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Assistance_Information_iE_Extensions__item__extensionValue._const_tab = ____Assistance_Information_iE_Extensions__item__extensionValue_tab
    ___Assistance_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Assistance_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Assistance_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Assistance_Information_iE_Extensions__item__id),
        ('criticality', ___Assistance_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___Assistance_Information_iE_Extensions__item__extensionValue),
        ])
    __Assistance_Information_iE_Extensions__item_._ext = None
    _Assistance_Information_iE_Extensions._cont = __Assistance_Information_iE_Extensions__item_
    _Assistance_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Assistance_Information._cont = ASN1Dict([
        ('systemInformation', _Assistance_Information_systemInformation),
        ('iE-Extensions', _Assistance_Information_iE_Extensions),
        ])
    Assistance_Information._ext = []
    
    #-----< Assistance-Information-ExtIEs >-----#
    Assistance_Information_ExtIEs = CLASS(name='Assistance-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    Assistance_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AssistanceInformationFailureList >-----#
    AssistanceInformationFailureList = SEQ_OF(name='AssistanceInformationFailureList', mode=MODE_TYPE)
    _AssistanceInformationFailureList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __AssistanceInformationFailureList__item__posSIB_Type = ENUM(name='posSIB-Type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PosSIB-Type')))
    __AssistanceInformationFailureList__item__outcome = ENUM(name='outcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'Outcome')))
    __AssistanceInformationFailureList__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___AssistanceInformationFailureList__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ____AssistanceInformationFailureList__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    _____AssistanceInformationFailureList__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____AssistanceInformationFailureList__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AssistanceInformationFailureList__item__iE_Extensions__item__id._const_tab = _____AssistanceInformationFailureList__item__iE_Extensions__item__id_tab
    ____AssistanceInformationFailureList__item__iE_Extensions__item__id._const_tab_at = None
    ____AssistanceInformationFailureList__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____AssistanceInformationFailureList__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    _____AssistanceInformationFailureList__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____AssistanceInformationFailureList__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AssistanceInformationFailureList__item__iE_Extensions__item__criticality._const_tab = _____AssistanceInformationFailureList__item__iE_Extensions__item__criticality_tab
    ____AssistanceInformationFailureList__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____AssistanceInformationFailureList__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____AssistanceInformationFailureList__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    _____AssistanceInformationFailureList__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____AssistanceInformationFailureList__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AssistanceInformationFailureList__item__iE_Extensions__item__extensionValue._const_tab = _____AssistanceInformationFailureList__item__iE_Extensions__item__extensionValue_tab
    ____AssistanceInformationFailureList__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____AssistanceInformationFailureList__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___AssistanceInformationFailureList__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____AssistanceInformationFailureList__item__iE_Extensions__item__id),
        ('criticality', ____AssistanceInformationFailureList__item__iE_Extensions__item__criticality),
        ('extensionValue', ____AssistanceInformationFailureList__item__iE_Extensions__item__extensionValue),
        ])
    ___AssistanceInformationFailureList__item__iE_Extensions__item_._ext = None
    __AssistanceInformationFailureList__item__iE_Extensions._cont = ___AssistanceInformationFailureList__item__iE_Extensions__item_
    __AssistanceInformationFailureList__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _AssistanceInformationFailureList__item_._cont = ASN1Dict([
        ('posSIB-Type', __AssistanceInformationFailureList__item__posSIB_Type),
        ('outcome', __AssistanceInformationFailureList__item__outcome),
        ('iE-Extensions', __AssistanceInformationFailureList__item__iE_Extensions),
        ])
    _AssistanceInformationFailureList__item_._ext = []
    AssistanceInformationFailureList._cont = _AssistanceInformationFailureList__item_
    AssistanceInformationFailureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< AssistanceInformationFailureList-ExtIEs >-----#
    AssistanceInformationFailureList_ExtIEs = CLASS(name='AssistanceInformationFailureList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    AssistanceInformationFailureList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AssistanceInformationMetaData >-----#
    AssistanceInformationMetaData = SEQ(name='AssistanceInformationMetaData', mode=MODE_TYPE)
    _AssistanceInformationMetaData_encrypted = ENUM(name='encrypted', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AssistanceInformationMetaData_encrypted._cont = ASN1Dict([('true', 0)])
    _AssistanceInformationMetaData_encrypted._ext = []
    _AssistanceInformationMetaData_gNSSID = ENUM(name='gNSSID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AssistanceInformationMetaData_gNSSID._cont = ASN1Dict([('gps', 0), ('sbas', 1), ('qzss', 2), ('galileo', 3), ('glonass', 4), ('bds', 5), ('navic', 6)])
    _AssistanceInformationMetaData_gNSSID._ext = []
    _AssistanceInformationMetaData_sBASID = ENUM(name='sBASID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AssistanceInformationMetaData_sBASID._cont = ASN1Dict([('waas', 0), ('egnos', 1), ('msas', 2), ('gagan', 3)])
    _AssistanceInformationMetaData_sBASID._ext = []
    _AssistanceInformationMetaData_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AssistanceInformationMetaData_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___AssistanceInformationMetaData_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____AssistanceInformationMetaData_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____AssistanceInformationMetaData_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceInformationMetaData_iE_Extensions__item__id._const_tab = ____AssistanceInformationMetaData_iE_Extensions__item__id_tab
    ___AssistanceInformationMetaData_iE_Extensions__item__id._const_tab_at = None
    ___AssistanceInformationMetaData_iE_Extensions__item__id._const_tab_id = 'id'
    ___AssistanceInformationMetaData_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____AssistanceInformationMetaData_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____AssistanceInformationMetaData_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceInformationMetaData_iE_Extensions__item__criticality._const_tab = ____AssistanceInformationMetaData_iE_Extensions__item__criticality_tab
    ___AssistanceInformationMetaData_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AssistanceInformationMetaData_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AssistanceInformationMetaData_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____AssistanceInformationMetaData_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____AssistanceInformationMetaData_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceInformationMetaData_iE_Extensions__item__extensionValue._const_tab = ____AssistanceInformationMetaData_iE_Extensions__item__extensionValue_tab
    ___AssistanceInformationMetaData_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AssistanceInformationMetaData_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AssistanceInformationMetaData_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AssistanceInformationMetaData_iE_Extensions__item__id),
        ('criticality', ___AssistanceInformationMetaData_iE_Extensions__item__criticality),
        ('extensionValue', ___AssistanceInformationMetaData_iE_Extensions__item__extensionValue),
        ])
    __AssistanceInformationMetaData_iE_Extensions__item_._ext = None
    _AssistanceInformationMetaData_iE_Extensions._cont = __AssistanceInformationMetaData_iE_Extensions__item_
    _AssistanceInformationMetaData_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AssistanceInformationMetaData._cont = ASN1Dict([
        ('encrypted', _AssistanceInformationMetaData_encrypted),
        ('gNSSID', _AssistanceInformationMetaData_gNSSID),
        ('sBASID', _AssistanceInformationMetaData_sBASID),
        ('iE-Extensions', _AssistanceInformationMetaData_iE_Extensions),
        ])
    AssistanceInformationMetaData._ext = []
    
    #-----< AssistanceInformationMetaData-ExtIEs >-----#
    AssistanceInformationMetaData_ExtIEs = CLASS(name='AssistanceInformationMetaData-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    AssistanceInformationMetaData_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BandwidthSRS >-----#
    BandwidthSRS = CHOICE(name='BandwidthSRS', mode=MODE_TYPE)
    _BandwidthSRS_fR1 = ENUM(name='fR1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BandwidthSRS_fR1._cont = ASN1Dict([('mHz5', 0), ('mHz10', 1), ('mHz20', 2), ('mHz40', 3), ('mHz50', 4), ('mHz80', 5), ('mHz100', 6)])
    _BandwidthSRS_fR1._ext = []
    _BandwidthSRS_fR2 = ENUM(name='fR2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BandwidthSRS_fR2._cont = ASN1Dict([('mHz50', 0), ('mHz100', 1), ('mHz200', 2), ('mHz400', 3)])
    _BandwidthSRS_fR2._ext = []
    _BandwidthSRS_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __BandwidthSRS_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___BandwidthSRS_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___BandwidthSRS_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BandwidthSRS_choice_extension_id._const_tab = ___BandwidthSRS_choice_extension_id_tab
    __BandwidthSRS_choice_extension_id._const_tab_at = None
    __BandwidthSRS_choice_extension_id._const_tab_id = 'id'
    __BandwidthSRS_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___BandwidthSRS_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___BandwidthSRS_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BandwidthSRS_choice_extension_criticality._const_tab = ___BandwidthSRS_choice_extension_criticality_tab
    __BandwidthSRS_choice_extension_criticality._const_tab_at = ('..', 'id')
    __BandwidthSRS_choice_extension_criticality._const_tab_id = 'criticality'
    __BandwidthSRS_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___BandwidthSRS_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___BandwidthSRS_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __BandwidthSRS_choice_extension_value._const_tab = ___BandwidthSRS_choice_extension_value_tab
    __BandwidthSRS_choice_extension_value._const_tab_at = ('..', 'id')
    __BandwidthSRS_choice_extension_value._const_tab_id = 'Value'
    _BandwidthSRS_choice_extension._cont = ASN1Dict([
        ('id', __BandwidthSRS_choice_extension_id),
        ('criticality', __BandwidthSRS_choice_extension_criticality),
        ('value', __BandwidthSRS_choice_extension_value),
        ])
    _BandwidthSRS_choice_extension._ext = None
    BandwidthSRS._cont = ASN1Dict([
        ('fR1', _BandwidthSRS_fR1),
        ('fR2', _BandwidthSRS_fR2),
        ('choice-extension', _BandwidthSRS_choice_extension),
        ])
    BandwidthSRS._ext = None
    
    #-----< BandwidthSRS-ExtIEs >-----#
    BandwidthSRS_ExtIEs = CLASS(name='BandwidthSRS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    BandwidthSRS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BCCH >-----#
    BCCH = INT(name='BCCH', mode=MODE_TYPE)
    BCCH._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=[], er=[])
    
    #-----< Broadcast >-----#
    Broadcast = ENUM(name='Broadcast', mode=MODE_TYPE)
    Broadcast._cont = ASN1Dict([('start', 0), ('stop', 1)])
    Broadcast._ext = []
    
    #-----< BroadcastPeriodicity >-----#
    BroadcastPeriodicity = ENUM(name='BroadcastPeriodicity', mode=MODE_TYPE)
    BroadcastPeriodicity._cont = ASN1Dict([('ms80', 0), ('ms160', 1), ('ms320', 2), ('ms640', 3), ('ms1280', 4), ('ms2560', 5), ('ms5120', 6)])
    BroadcastPeriodicity._ext = []
    
    #-----< PositioningBroadcastCells >-----#
    PositioningBroadcastCells = SEQ_OF(name='PositioningBroadcastCells', mode=MODE_TYPE)
    _PositioningBroadcastCells__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'NG-RAN-CGI')))
    PositioningBroadcastCells._cont = _PositioningBroadcastCells__item_
    PositioningBroadcastCells._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< BSSID >-----#
    BSSID = OCT_STR(name='BSSID', mode=MODE_TYPE)
    BSSID._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< CarrierFreq >-----#
    CarrierFreq = SEQ(name='CarrierFreq', mode=MODE_TYPE)
    _CarrierFreq_pointA = INT(name='pointA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CarrierFreq_pointA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _CarrierFreq_offsetToCarrier = INT(name='offsetToCarrier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CarrierFreq_offsetToCarrier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2199)], ev=[], er=[])
    _CarrierFreq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CarrierFreq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___CarrierFreq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____CarrierFreq_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____CarrierFreq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CarrierFreq_iE_Extensions__item__id._const_tab = ____CarrierFreq_iE_Extensions__item__id_tab
    ___CarrierFreq_iE_Extensions__item__id._const_tab_at = None
    ___CarrierFreq_iE_Extensions__item__id._const_tab_id = 'id'
    ___CarrierFreq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____CarrierFreq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____CarrierFreq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CarrierFreq_iE_Extensions__item__criticality._const_tab = ____CarrierFreq_iE_Extensions__item__criticality_tab
    ___CarrierFreq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CarrierFreq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CarrierFreq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____CarrierFreq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____CarrierFreq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CarrierFreq_iE_Extensions__item__extensionValue._const_tab = ____CarrierFreq_iE_Extensions__item__extensionValue_tab
    ___CarrierFreq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CarrierFreq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CarrierFreq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CarrierFreq_iE_Extensions__item__id),
        ('criticality', ___CarrierFreq_iE_Extensions__item__criticality),
        ('extensionValue', ___CarrierFreq_iE_Extensions__item__extensionValue),
        ])
    __CarrierFreq_iE_Extensions__item_._ext = None
    _CarrierFreq_iE_Extensions._cont = __CarrierFreq_iE_Extensions__item_
    _CarrierFreq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CarrierFreq._cont = ASN1Dict([
        ('pointA', _CarrierFreq_pointA),
        ('offsetToCarrier', _CarrierFreq_offsetToCarrier),
        ('iE-Extensions', _CarrierFreq_iE_Extensions),
        ])
    CarrierFreq._ext = []
    
    #-----< CarrierFreq-ExtIEs >-----#
    CarrierFreq_ExtIEs = CLASS(name='CarrierFreq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    CarrierFreq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cause >-----#
    Cause = CHOICE(name='Cause', mode=MODE_TYPE)
    _Cause_radioNetwork = ENUM(name='radioNetwork', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CauseRadioNetwork')))
    _Cause_protocol = ENUM(name='protocol', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CauseProtocol')))
    _Cause_misc = ENUM(name='misc', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CauseMisc')))
    _Cause_choice_Extension = SEQ(name='choice-Extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __Cause_choice_Extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___Cause_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___Cause_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Cause_choice_Extension_id._const_tab = ___Cause_choice_Extension_id_tab
    __Cause_choice_Extension_id._const_tab_at = None
    __Cause_choice_Extension_id._const_tab_id = 'id'
    __Cause_choice_Extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___Cause_choice_Extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___Cause_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Cause_choice_Extension_criticality._const_tab = ___Cause_choice_Extension_criticality_tab
    __Cause_choice_Extension_criticality._const_tab_at = ('..', 'id')
    __Cause_choice_Extension_criticality._const_tab_id = 'criticality'
    __Cause_choice_Extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___Cause_choice_Extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___Cause_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Cause_choice_Extension_value._const_tab = ___Cause_choice_Extension_value_tab
    __Cause_choice_Extension_value._const_tab_at = ('..', 'id')
    __Cause_choice_Extension_value._const_tab_id = 'Value'
    _Cause_choice_Extension._cont = ASN1Dict([
        ('id', __Cause_choice_Extension_id),
        ('criticality', __Cause_choice_Extension_criticality),
        ('value', __Cause_choice_Extension_value),
        ])
    _Cause_choice_Extension._ext = None
    Cause._cont = ASN1Dict([
        ('radioNetwork', _Cause_radioNetwork),
        ('protocol', _Cause_protocol),
        ('misc', _Cause_misc),
        ('choice-Extension', _Cause_choice_Extension),
        ])
    Cause._ext = None
    
    #-----< Cause-ExtensionIE >-----#
    Cause_ExtensionIE = CLASS(name='Cause-ExtensionIE', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    Cause_ExtensionIE._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CauseMisc >-----#
    CauseMisc = ENUM(name='CauseMisc', mode=MODE_TYPE)
    CauseMisc._cont = ASN1Dict([('unspecified', 0)])
    CauseMisc._ext = []
    
    #-----< CauseProtocol >-----#
    CauseProtocol = ENUM(name='CauseProtocol', mode=MODE_TYPE)
    CauseProtocol._cont = ASN1Dict([('transfer-syntax-error', 0), ('abstract-syntax-error-reject', 1), ('abstract-syntax-error-ignore-and-notify', 2), ('message-not-compatible-with-receiver-state', 3), ('semantic-error', 4), ('unspecified', 5), ('abstract-syntax-error-falsely-constructed-message', 6)])
    CauseProtocol._ext = []
    
    #-----< CauseRadioNetwork >-----#
    CauseRadioNetwork = ENUM(name='CauseRadioNetwork', mode=MODE_TYPE)
    CauseRadioNetwork._cont = ASN1Dict([('unspecified', 0), ('requested-item-not-supported', 1), ('requested-item-temporarily-not-available', 2), ('serving-NG-RAN-node-changed', 3), ('requested-item-not-supported-on-time', 4)])
    CauseRadioNetwork._ext = ['serving-NG-RAN-node-changed', 'requested-item-not-supported-on-time']
    
    #-----< Cell-Portion-ID >-----#
    Cell_Portion_ID = INT(name='Cell-Portion-ID', mode=MODE_TYPE)
    Cell_Portion_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=[], er=[])
    
    #-----< CGI-EUTRA >-----#
    CGI_EUTRA = SEQ(name='CGI-EUTRA', mode=MODE_TYPE)
    _CGI_EUTRA_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PLMN-Identity')))
    _CGI_EUTRA_eUTRAcellIdentifier = BIT_STR(name='eUTRAcellIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'EUTRACellIdentifier')))
    _CGI_EUTRA_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CGI_EUTRA_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___CGI_EUTRA_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____CGI_EUTRA_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____CGI_EUTRA_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CGI_EUTRA_iE_Extensions__item__id._const_tab = ____CGI_EUTRA_iE_Extensions__item__id_tab
    ___CGI_EUTRA_iE_Extensions__item__id._const_tab_at = None
    ___CGI_EUTRA_iE_Extensions__item__id._const_tab_id = 'id'
    ___CGI_EUTRA_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____CGI_EUTRA_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____CGI_EUTRA_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CGI_EUTRA_iE_Extensions__item__criticality._const_tab = ____CGI_EUTRA_iE_Extensions__item__criticality_tab
    ___CGI_EUTRA_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CGI_EUTRA_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CGI_EUTRA_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____CGI_EUTRA_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____CGI_EUTRA_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CGI_EUTRA_iE_Extensions__item__extensionValue._const_tab = ____CGI_EUTRA_iE_Extensions__item__extensionValue_tab
    ___CGI_EUTRA_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CGI_EUTRA_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CGI_EUTRA_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CGI_EUTRA_iE_Extensions__item__id),
        ('criticality', ___CGI_EUTRA_iE_Extensions__item__criticality),
        ('extensionValue', ___CGI_EUTRA_iE_Extensions__item__extensionValue),
        ])
    __CGI_EUTRA_iE_Extensions__item_._ext = None
    _CGI_EUTRA_iE_Extensions._cont = __CGI_EUTRA_iE_Extensions__item_
    _CGI_EUTRA_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CGI_EUTRA._cont = ASN1Dict([
        ('pLMN-Identity', _CGI_EUTRA_pLMN_Identity),
        ('eUTRAcellIdentifier', _CGI_EUTRA_eUTRAcellIdentifier),
        ('iE-Extensions', _CGI_EUTRA_iE_Extensions),
        ])
    CGI_EUTRA._ext = []
    
    #-----< CGI-EUTRA-ExtIEs >-----#
    CGI_EUTRA_ExtIEs = CLASS(name='CGI-EUTRA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    CGI_EUTRA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CGI-NR >-----#
    CGI_NR = SEQ(name='CGI-NR', mode=MODE_TYPE)
    _CGI_NR_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PLMN-Identity')))
    _CGI_NR_nRcellIdentifier = BIT_STR(name='nRcellIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NRCellIdentifier')))
    _CGI_NR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CGI_NR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___CGI_NR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____CGI_NR_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____CGI_NR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CGI_NR_iE_Extensions__item__id._const_tab = ____CGI_NR_iE_Extensions__item__id_tab
    ___CGI_NR_iE_Extensions__item__id._const_tab_at = None
    ___CGI_NR_iE_Extensions__item__id._const_tab_id = 'id'
    ___CGI_NR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____CGI_NR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____CGI_NR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CGI_NR_iE_Extensions__item__criticality._const_tab = ____CGI_NR_iE_Extensions__item__criticality_tab
    ___CGI_NR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CGI_NR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CGI_NR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____CGI_NR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____CGI_NR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CGI_NR_iE_Extensions__item__extensionValue._const_tab = ____CGI_NR_iE_Extensions__item__extensionValue_tab
    ___CGI_NR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CGI_NR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CGI_NR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CGI_NR_iE_Extensions__item__id),
        ('criticality', ___CGI_NR_iE_Extensions__item__criticality),
        ('extensionValue', ___CGI_NR_iE_Extensions__item__extensionValue),
        ])
    __CGI_NR_iE_Extensions__item_._ext = None
    _CGI_NR_iE_Extensions._cont = __CGI_NR_iE_Extensions__item_
    _CGI_NR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CGI_NR._cont = ASN1Dict([
        ('pLMN-Identity', _CGI_NR_pLMN_Identity),
        ('nRcellIdentifier', _CGI_NR_nRcellIdentifier),
        ('iE-Extensions', _CGI_NR_iE_Extensions),
        ])
    CGI_NR._ext = []
    
    #-----< CGI-NR-ExtIEs >-----#
    CGI_NR_ExtIEs = CLASS(name='CGI-NR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    CGI_NR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CPLength-EUTRA >-----#
    CPLength_EUTRA = ENUM(name='CPLength-EUTRA', mode=MODE_TYPE)
    CPLength_EUTRA._cont = ASN1Dict([('normal', 0), ('extended', 1)])
    CPLength_EUTRA._ext = []
    
    #-----< CriticalityDiagnostics >-----#
    CriticalityDiagnostics = SEQ(name='CriticalityDiagnostics', mode=MODE_TYPE)
    _CriticalityDiagnostics_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')), opt=True)
    _CriticalityDiagnostics_triggeringMessage = ENUM(name='triggeringMessage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'TriggeringMessage')), opt=True)
    _CriticalityDiagnostics_procedureCriticality = ENUM(name='procedureCriticality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'Criticality')), opt=True)
    _CriticalityDiagnostics_nrppatransactionID = INT(name='nrppatransactionID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'NRPPATransactionID')), opt=True)
    _CriticalityDiagnostics_iEsCriticalityDiagnostics = SEQ_OF(name='iEsCriticalityDiagnostics', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics-IE-List')), opt=True)
    _CriticalityDiagnostics_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_id = 'id'
    ___CriticalityDiagnostics_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CriticalityDiagnostics_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CriticalityDiagnostics_iE_Extensions__item__id),
        ('criticality', ___CriticalityDiagnostics_iE_Extensions__item__criticality),
        ('extensionValue', ___CriticalityDiagnostics_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_iE_Extensions._cont = __CriticalityDiagnostics_iE_Extensions__item_
    _CriticalityDiagnostics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics._cont = ASN1Dict([
        ('procedureCode', _CriticalityDiagnostics_procedureCode),
        ('triggeringMessage', _CriticalityDiagnostics_triggeringMessage),
        ('procedureCriticality', _CriticalityDiagnostics_procedureCriticality),
        ('nrppatransactionID', _CriticalityDiagnostics_nrppatransactionID),
        ('iEsCriticalityDiagnostics', _CriticalityDiagnostics_iEsCriticalityDiagnostics),
        ('iE-Extensions', _CriticalityDiagnostics_iE_Extensions),
        ])
    CriticalityDiagnostics._ext = []
    
    #-----< CriticalityDiagnostics-ExtIEs >-----#
    CriticalityDiagnostics_ExtIEs = CLASS(name='CriticalityDiagnostics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CriticalityDiagnostics-IE-List >-----#
    CriticalityDiagnostics_IE_List = SEQ_OF(name='CriticalityDiagnostics-IE-List', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_List__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CriticalityDiagnostics_IE_List__item__iECriticality = ENUM(name='iECriticality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'Criticality')))
    __CriticalityDiagnostics_IE_List__item__iE_ID = INT(name='iE-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProtocolIE-ID')))
    __CriticalityDiagnostics_IE_List__item__typeOfError = ENUM(name='typeOfError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TypeOfError')))
    __CriticalityDiagnostics_IE_List__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab_at = None
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id),
        ('criticality', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality),
        ('extensionValue', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue),
        ])
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_._ext = None
    __CriticalityDiagnostics_IE_List__item__iE_Extensions._cont = ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_
    __CriticalityDiagnostics_IE_List__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _CriticalityDiagnostics_IE_List__item_._cont = ASN1Dict([
        ('iECriticality', __CriticalityDiagnostics_IE_List__item__iECriticality),
        ('iE-ID', __CriticalityDiagnostics_IE_List__item__iE_ID),
        ('typeOfError', __CriticalityDiagnostics_IE_List__item__typeOfError),
        ('iE-Extensions', __CriticalityDiagnostics_IE_List__item__iE_Extensions),
        ])
    _CriticalityDiagnostics_IE_List__item_._ext = []
    CriticalityDiagnostics_IE_List._cont = _CriticalityDiagnostics_IE_List__item_
    CriticalityDiagnostics_IE_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CriticalityDiagnostics-IE-List-ExtIEs >-----#
    CriticalityDiagnostics_IE_List_ExtIEs = CLASS(name='CriticalityDiagnostics-IE-List-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_IE_List_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-Bandwidth-EUTRA >-----#
    DL_Bandwidth_EUTRA = ENUM(name='DL-Bandwidth-EUTRA', mode=MODE_TYPE)
    DL_Bandwidth_EUTRA._cont = ASN1Dict([('bw6', 0), ('bw15', 1), ('bw25', 2), ('bw50', 3), ('bw75', 4), ('bw100', 5)])
    DL_Bandwidth_EUTRA._ext = []
    
    #-----< DL-PRS >-----#
    DL_PRS = SEQ(name='DL-PRS', mode=MODE_TYPE)
    _DL_PRS_prsid = INT(name='prsid', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRS_prsid._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _DL_PRS_dl_PRSResourceSetID = INT(name='dl-PRSResourceSetID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-Set-ID')))
    _DL_PRS_dl_PRSResourceID = INT(name='dl-PRSResourceID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-ID')), opt=True)
    _DL_PRS_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_PRS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___DL_PRS_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____DL_PRS_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DL_PRS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_PRS_iE_Extensions__item__id._const_tab = ____DL_PRS_iE_Extensions__item__id_tab
    ___DL_PRS_iE_Extensions__item__id._const_tab_at = None
    ___DL_PRS_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_PRS_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_PRS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DL_PRS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_PRS_iE_Extensions__item__criticality._const_tab = ____DL_PRS_iE_Extensions__item__criticality_tab
    ___DL_PRS_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_PRS_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_PRS_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_PRS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DL_PRS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_PRS_iE_Extensions__item__extensionValue._const_tab = ____DL_PRS_iE_Extensions__item__extensionValue_tab
    ___DL_PRS_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_PRS_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_PRS_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_PRS_iE_Extensions__item__id),
        ('criticality', ___DL_PRS_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_PRS_iE_Extensions__item__extensionValue),
        ])
    __DL_PRS_iE_Extensions__item_._ext = None
    _DL_PRS_iE_Extensions._cont = __DL_PRS_iE_Extensions__item_
    _DL_PRS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_PRS._cont = ASN1Dict([
        ('prsid', _DL_PRS_prsid),
        ('dl-PRSResourceSetID', _DL_PRS_dl_PRSResourceSetID),
        ('dl-PRSResourceID', _DL_PRS_dl_PRSResourceID),
        ('iE-Extensions', _DL_PRS_iE_Extensions),
        ])
    DL_PRS._ext = []
    
    #-----< DL-PRS-ExtIEs >-----#
    DL_PRS_ExtIEs = CLASS(name='DL-PRS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    DL_PRS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-PRSMutingPattern >-----#
    DL_PRSMutingPattern = CHOICE(name='DL-PRSMutingPattern', mode=MODE_TYPE)
    _DL_PRSMutingPattern_two = BIT_STR(name='two', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRSMutingPattern_two._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _DL_PRSMutingPattern_four = BIT_STR(name='four', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRSMutingPattern_four._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _DL_PRSMutingPattern_six = BIT_STR(name='six', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRSMutingPattern_six._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    _DL_PRSMutingPattern_eight = BIT_STR(name='eight', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRSMutingPattern_eight._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _DL_PRSMutingPattern_sixteen = BIT_STR(name='sixteen', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRSMutingPattern_sixteen._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _DL_PRSMutingPattern_thirty_two = BIT_STR(name='thirty-two', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DL_PRSMutingPattern_thirty_two._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _DL_PRSMutingPattern_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __DL_PRSMutingPattern_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___DL_PRSMutingPattern_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___DL_PRSMutingPattern_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSMutingPattern_choice_extension_id._const_tab = ___DL_PRSMutingPattern_choice_extension_id_tab
    __DL_PRSMutingPattern_choice_extension_id._const_tab_at = None
    __DL_PRSMutingPattern_choice_extension_id._const_tab_id = 'id'
    __DL_PRSMutingPattern_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___DL_PRSMutingPattern_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___DL_PRSMutingPattern_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSMutingPattern_choice_extension_criticality._const_tab = ___DL_PRSMutingPattern_choice_extension_criticality_tab
    __DL_PRSMutingPattern_choice_extension_criticality._const_tab_at = ('..', 'id')
    __DL_PRSMutingPattern_choice_extension_criticality._const_tab_id = 'criticality'
    __DL_PRSMutingPattern_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___DL_PRSMutingPattern_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___DL_PRSMutingPattern_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSMutingPattern_choice_extension_value._const_tab = ___DL_PRSMutingPattern_choice_extension_value_tab
    __DL_PRSMutingPattern_choice_extension_value._const_tab_at = ('..', 'id')
    __DL_PRSMutingPattern_choice_extension_value._const_tab_id = 'Value'
    _DL_PRSMutingPattern_choice_extension._cont = ASN1Dict([
        ('id', __DL_PRSMutingPattern_choice_extension_id),
        ('criticality', __DL_PRSMutingPattern_choice_extension_criticality),
        ('value', __DL_PRSMutingPattern_choice_extension_value),
        ])
    _DL_PRSMutingPattern_choice_extension._ext = None
    DL_PRSMutingPattern._cont = ASN1Dict([
        ('two', _DL_PRSMutingPattern_two),
        ('four', _DL_PRSMutingPattern_four),
        ('six', _DL_PRSMutingPattern_six),
        ('eight', _DL_PRSMutingPattern_eight),
        ('sixteen', _DL_PRSMutingPattern_sixteen),
        ('thirty-two', _DL_PRSMutingPattern_thirty_two),
        ('choice-extension', _DL_PRSMutingPattern_choice_extension),
        ])
    DL_PRSMutingPattern._ext = None
    
    #-----< DL-PRSMutingPattern-ExtIEs >-----#
    DL_PRSMutingPattern_ExtIEs = CLASS(name='DL-PRSMutingPattern-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    DL_PRSMutingPattern_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DLPRSResourceCoordinates >-----#
    DLPRSResourceCoordinates = SEQ(name='DLPRSResourceCoordinates', mode=MODE_TYPE)
    _DLPRSResourceCoordinates_listofDL_PRSResourceSetARP = SEQ_OF(name='listofDL-PRSResourceSetARP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DLPRSResourceCoordinates_listofDL_PRSResourceSetARP__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'DLPRSResourceSetARP')))
    _DLPRSResourceCoordinates_listofDL_PRSResourceSetARP._cont = __DLPRSResourceCoordinates_listofDL_PRSResourceSetARP__item_
    _DLPRSResourceCoordinates_listofDL_PRSResourceSetARP._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _DLPRSResourceCoordinates_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DLPRSResourceCoordinates_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___DLPRSResourceCoordinates_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____DLPRSResourceCoordinates_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DLPRSResourceCoordinates_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceCoordinates_iE_Extensions__item__id._const_tab = ____DLPRSResourceCoordinates_iE_Extensions__item__id_tab
    ___DLPRSResourceCoordinates_iE_Extensions__item__id._const_tab_at = None
    ___DLPRSResourceCoordinates_iE_Extensions__item__id._const_tab_id = 'id'
    ___DLPRSResourceCoordinates_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____DLPRSResourceCoordinates_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DLPRSResourceCoordinates_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceCoordinates_iE_Extensions__item__criticality._const_tab = ____DLPRSResourceCoordinates_iE_Extensions__item__criticality_tab
    ___DLPRSResourceCoordinates_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DLPRSResourceCoordinates_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DLPRSResourceCoordinates_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____DLPRSResourceCoordinates_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DLPRSResourceCoordinates_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceCoordinates_iE_Extensions__item__extensionValue._const_tab = ____DLPRSResourceCoordinates_iE_Extensions__item__extensionValue_tab
    ___DLPRSResourceCoordinates_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DLPRSResourceCoordinates_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DLPRSResourceCoordinates_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DLPRSResourceCoordinates_iE_Extensions__item__id),
        ('criticality', ___DLPRSResourceCoordinates_iE_Extensions__item__criticality),
        ('extensionValue', ___DLPRSResourceCoordinates_iE_Extensions__item__extensionValue),
        ])
    __DLPRSResourceCoordinates_iE_Extensions__item_._ext = None
    _DLPRSResourceCoordinates_iE_Extensions._cont = __DLPRSResourceCoordinates_iE_Extensions__item_
    _DLPRSResourceCoordinates_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DLPRSResourceCoordinates._cont = ASN1Dict([
        ('listofDL-PRSResourceSetARP', _DLPRSResourceCoordinates_listofDL_PRSResourceSetARP),
        ('iE-Extensions', _DLPRSResourceCoordinates_iE_Extensions),
        ])
    DLPRSResourceCoordinates._ext = []
    
    #-----< DLPRSResourceCoordinates-ExtIEs >-----#
    DLPRSResourceCoordinates_ExtIEs = CLASS(name='DLPRSResourceCoordinates-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    DLPRSResourceCoordinates_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DLPRSResourceSetARP >-----#
    DLPRSResourceSetARP = SEQ(name='DLPRSResourceSetARP', mode=MODE_TYPE)
    _DLPRSResourceSetARP_dl_PRSResourceSetID = INT(name='dl-PRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-Set-ID')))
    _DLPRSResourceSetARP_dL_PRSResourceSetARPLocation = CHOICE(name='dL-PRSResourceSetARPLocation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'DL-PRSResourceSetARPLocation')))
    _DLPRSResourceSetARP_listofDL_PRSResourceARP = SEQ_OF(name='listofDL-PRSResourceARP', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DLPRSResourceSetARP_listofDL_PRSResourceARP__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'DLPRSResourceARP')))
    _DLPRSResourceSetARP_listofDL_PRSResourceARP._cont = __DLPRSResourceSetARP_listofDL_PRSResourceARP__item_
    _DLPRSResourceSetARP_listofDL_PRSResourceARP._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _DLPRSResourceSetARP_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DLPRSResourceSetARP_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___DLPRSResourceSetARP_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____DLPRSResourceSetARP_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DLPRSResourceSetARP_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceSetARP_iE_Extensions__item__id._const_tab = ____DLPRSResourceSetARP_iE_Extensions__item__id_tab
    ___DLPRSResourceSetARP_iE_Extensions__item__id._const_tab_at = None
    ___DLPRSResourceSetARP_iE_Extensions__item__id._const_tab_id = 'id'
    ___DLPRSResourceSetARP_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____DLPRSResourceSetARP_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DLPRSResourceSetARP_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceSetARP_iE_Extensions__item__criticality._const_tab = ____DLPRSResourceSetARP_iE_Extensions__item__criticality_tab
    ___DLPRSResourceSetARP_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DLPRSResourceSetARP_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DLPRSResourceSetARP_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____DLPRSResourceSetARP_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DLPRSResourceSetARP_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceSetARP_iE_Extensions__item__extensionValue._const_tab = ____DLPRSResourceSetARP_iE_Extensions__item__extensionValue_tab
    ___DLPRSResourceSetARP_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DLPRSResourceSetARP_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DLPRSResourceSetARP_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DLPRSResourceSetARP_iE_Extensions__item__id),
        ('criticality', ___DLPRSResourceSetARP_iE_Extensions__item__criticality),
        ('extensionValue', ___DLPRSResourceSetARP_iE_Extensions__item__extensionValue),
        ])
    __DLPRSResourceSetARP_iE_Extensions__item_._ext = None
    _DLPRSResourceSetARP_iE_Extensions._cont = __DLPRSResourceSetARP_iE_Extensions__item_
    _DLPRSResourceSetARP_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DLPRSResourceSetARP._cont = ASN1Dict([
        ('dl-PRSResourceSetID', _DLPRSResourceSetARP_dl_PRSResourceSetID),
        ('dL-PRSResourceSetARPLocation', _DLPRSResourceSetARP_dL_PRSResourceSetARPLocation),
        ('listofDL-PRSResourceARP', _DLPRSResourceSetARP_listofDL_PRSResourceARP),
        ('iE-Extensions', _DLPRSResourceSetARP_iE_Extensions),
        ])
    DLPRSResourceSetARP._ext = []
    
    #-----< DLPRSResourceSetARP-ExtIEs >-----#
    DLPRSResourceSetARP_ExtIEs = CLASS(name='DLPRSResourceSetARP-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    DLPRSResourceSetARP_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-PRSResourceSetARPLocation >-----#
    DL_PRSResourceSetARPLocation = CHOICE(name='DL-PRSResourceSetARPLocation', mode=MODE_TYPE)
    _DL_PRSResourceSetARPLocation_relativeGeodeticLocation = SEQ(name='relativeGeodeticLocation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RelativeGeodeticLocation')))
    _DL_PRSResourceSetARPLocation_relativeCartesianLocation = SEQ(name='relativeCartesianLocation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RelativeCartesianLocation')))
    _DL_PRSResourceSetARPLocation_choice_Extension = SEQ(name='choice-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __DL_PRSResourceSetARPLocation_choice_Extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___DL_PRSResourceSetARPLocation_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___DL_PRSResourceSetARPLocation_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSResourceSetARPLocation_choice_Extension_id._const_tab = ___DL_PRSResourceSetARPLocation_choice_Extension_id_tab
    __DL_PRSResourceSetARPLocation_choice_Extension_id._const_tab_at = None
    __DL_PRSResourceSetARPLocation_choice_Extension_id._const_tab_id = 'id'
    __DL_PRSResourceSetARPLocation_choice_Extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___DL_PRSResourceSetARPLocation_choice_Extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___DL_PRSResourceSetARPLocation_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSResourceSetARPLocation_choice_Extension_criticality._const_tab = ___DL_PRSResourceSetARPLocation_choice_Extension_criticality_tab
    __DL_PRSResourceSetARPLocation_choice_Extension_criticality._const_tab_at = ('..', 'id')
    __DL_PRSResourceSetARPLocation_choice_Extension_criticality._const_tab_id = 'criticality'
    __DL_PRSResourceSetARPLocation_choice_Extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___DL_PRSResourceSetARPLocation_choice_Extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___DL_PRSResourceSetARPLocation_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSResourceSetARPLocation_choice_Extension_value._const_tab = ___DL_PRSResourceSetARPLocation_choice_Extension_value_tab
    __DL_PRSResourceSetARPLocation_choice_Extension_value._const_tab_at = ('..', 'id')
    __DL_PRSResourceSetARPLocation_choice_Extension_value._const_tab_id = 'Value'
    _DL_PRSResourceSetARPLocation_choice_Extension._cont = ASN1Dict([
        ('id', __DL_PRSResourceSetARPLocation_choice_Extension_id),
        ('criticality', __DL_PRSResourceSetARPLocation_choice_Extension_criticality),
        ('value', __DL_PRSResourceSetARPLocation_choice_Extension_value),
        ])
    _DL_PRSResourceSetARPLocation_choice_Extension._ext = None
    DL_PRSResourceSetARPLocation._cont = ASN1Dict([
        ('relativeGeodeticLocation', _DL_PRSResourceSetARPLocation_relativeGeodeticLocation),
        ('relativeCartesianLocation', _DL_PRSResourceSetARPLocation_relativeCartesianLocation),
        ('choice-Extension', _DL_PRSResourceSetARPLocation_choice_Extension),
        ])
    DL_PRSResourceSetARPLocation._ext = None
    
    #-----< DL-PRSResourceSetARPLocation-ExtIEs >-----#
    DL_PRSResourceSetARPLocation_ExtIEs = CLASS(name='DL-PRSResourceSetARPLocation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    DL_PRSResourceSetARPLocation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DLPRSResourceARP >-----#
    DLPRSResourceARP = SEQ(name='DLPRSResourceARP', mode=MODE_TYPE)
    _DLPRSResourceARP_dl_PRSResourceID = INT(name='dl-PRSResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-ID')))
    _DLPRSResourceARP_dL_PRSResourceARPLocation = CHOICE(name='dL-PRSResourceARPLocation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'DL-PRSResourceARPLocation')))
    _DLPRSResourceARP_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DLPRSResourceARP_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___DLPRSResourceARP_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____DLPRSResourceARP_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DLPRSResourceARP_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceARP_iE_Extensions__item__id._const_tab = ____DLPRSResourceARP_iE_Extensions__item__id_tab
    ___DLPRSResourceARP_iE_Extensions__item__id._const_tab_at = None
    ___DLPRSResourceARP_iE_Extensions__item__id._const_tab_id = 'id'
    ___DLPRSResourceARP_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____DLPRSResourceARP_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DLPRSResourceARP_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceARP_iE_Extensions__item__criticality._const_tab = ____DLPRSResourceARP_iE_Extensions__item__criticality_tab
    ___DLPRSResourceARP_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DLPRSResourceARP_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DLPRSResourceARP_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____DLPRSResourceARP_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DLPRSResourceARP_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceARP_iE_Extensions__item__extensionValue._const_tab = ____DLPRSResourceARP_iE_Extensions__item__extensionValue_tab
    ___DLPRSResourceARP_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DLPRSResourceARP_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DLPRSResourceARP_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DLPRSResourceARP_iE_Extensions__item__id),
        ('criticality', ___DLPRSResourceARP_iE_Extensions__item__criticality),
        ('extensionValue', ___DLPRSResourceARP_iE_Extensions__item__extensionValue),
        ])
    __DLPRSResourceARP_iE_Extensions__item_._ext = None
    _DLPRSResourceARP_iE_Extensions._cont = __DLPRSResourceARP_iE_Extensions__item_
    _DLPRSResourceARP_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DLPRSResourceARP._cont = ASN1Dict([
        ('dl-PRSResourceID', _DLPRSResourceARP_dl_PRSResourceID),
        ('dL-PRSResourceARPLocation', _DLPRSResourceARP_dL_PRSResourceARPLocation),
        ('iE-Extensions', _DLPRSResourceARP_iE_Extensions),
        ])
    DLPRSResourceARP._ext = []
    
    #-----< DLPRSResourceARP-ExtIEs >-----#
    DLPRSResourceARP_ExtIEs = CLASS(name='DLPRSResourceARP-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    DLPRSResourceARP_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-PRSResourceARPLocation >-----#
    DL_PRSResourceARPLocation = CHOICE(name='DL-PRSResourceARPLocation', mode=MODE_TYPE)
    _DL_PRSResourceARPLocation_relativeGeodeticLocation = SEQ(name='relativeGeodeticLocation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RelativeGeodeticLocation')))
    _DL_PRSResourceARPLocation_relativeCartesianLocation = SEQ(name='relativeCartesianLocation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RelativeCartesianLocation')))
    _DL_PRSResourceARPLocation_choice_Extension = SEQ(name='choice-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __DL_PRSResourceARPLocation_choice_Extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___DL_PRSResourceARPLocation_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___DL_PRSResourceARPLocation_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSResourceARPLocation_choice_Extension_id._const_tab = ___DL_PRSResourceARPLocation_choice_Extension_id_tab
    __DL_PRSResourceARPLocation_choice_Extension_id._const_tab_at = None
    __DL_PRSResourceARPLocation_choice_Extension_id._const_tab_id = 'id'
    __DL_PRSResourceARPLocation_choice_Extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___DL_PRSResourceARPLocation_choice_Extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___DL_PRSResourceARPLocation_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSResourceARPLocation_choice_Extension_criticality._const_tab = ___DL_PRSResourceARPLocation_choice_Extension_criticality_tab
    __DL_PRSResourceARPLocation_choice_Extension_criticality._const_tab_at = ('..', 'id')
    __DL_PRSResourceARPLocation_choice_Extension_criticality._const_tab_id = 'criticality'
    __DL_PRSResourceARPLocation_choice_Extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___DL_PRSResourceARPLocation_choice_Extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___DL_PRSResourceARPLocation_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __DL_PRSResourceARPLocation_choice_Extension_value._const_tab = ___DL_PRSResourceARPLocation_choice_Extension_value_tab
    __DL_PRSResourceARPLocation_choice_Extension_value._const_tab_at = ('..', 'id')
    __DL_PRSResourceARPLocation_choice_Extension_value._const_tab_id = 'Value'
    _DL_PRSResourceARPLocation_choice_Extension._cont = ASN1Dict([
        ('id', __DL_PRSResourceARPLocation_choice_Extension_id),
        ('criticality', __DL_PRSResourceARPLocation_choice_Extension_criticality),
        ('value', __DL_PRSResourceARPLocation_choice_Extension_value),
        ])
    _DL_PRSResourceARPLocation_choice_Extension._ext = None
    DL_PRSResourceARPLocation._cont = ASN1Dict([
        ('relativeGeodeticLocation', _DL_PRSResourceARPLocation_relativeGeodeticLocation),
        ('relativeCartesianLocation', _DL_PRSResourceARPLocation_relativeCartesianLocation),
        ('choice-Extension', _DL_PRSResourceARPLocation_choice_Extension),
        ])
    DL_PRSResourceARPLocation._ext = None
    
    #-----< DL-PRSResourceARPLocation-ExtIEs >-----#
    DL_PRSResourceARPLocation_ExtIEs = CLASS(name='DL-PRSResourceARPLocation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    DL_PRSResourceARPLocation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-CID-MeasurementResult >-----#
    E_CID_MeasurementResult = SEQ(name='E-CID-MeasurementResult', mode=MODE_TYPE)
    _E_CID_MeasurementResult_servingCell_ID = SEQ(name='servingCell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NG-RAN-CGI')))
    _E_CID_MeasurementResult_servingCellTAC = OCT_STR(name='servingCellTAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TAC')))
    _E_CID_MeasurementResult_nG_RANAccessPointPosition = SEQ(name='nG-RANAccessPointPosition', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NG-RANAccessPointPosition')), opt=True)
    _E_CID_MeasurementResult_measuredResults = SEQ_OF(name='measuredResults', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'MeasuredResults')), opt=True)
    _E_CID_MeasurementResult_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_CID_MeasurementResult_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___E_CID_MeasurementResult_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____E_CID_MeasurementResult_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____E_CID_MeasurementResult_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'GeographicalCoordinates')))
    ____E_CID_MeasurementResult_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 37), ('criticality', 'ignore'), ('Extension', _____E_CID_MeasurementResult_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_CID_MeasurementResult_iE_Extensions__item__id._const_tab = ____E_CID_MeasurementResult_iE_Extensions__item__id_tab
    ___E_CID_MeasurementResult_iE_Extensions__item__id._const_tab_at = None
    ___E_CID_MeasurementResult_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_CID_MeasurementResult_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ___E_CID_MeasurementResult_iE_Extensions__item__criticality._const_tab = ____E_CID_MeasurementResult_iE_Extensions__item__id_tab
    ___E_CID_MeasurementResult_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_CID_MeasurementResult_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_CID_MeasurementResult_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ___E_CID_MeasurementResult_iE_Extensions__item__extensionValue._const_tab = ____E_CID_MeasurementResult_iE_Extensions__item__id_tab
    ___E_CID_MeasurementResult_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_CID_MeasurementResult_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_CID_MeasurementResult_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_CID_MeasurementResult_iE_Extensions__item__id),
        ('criticality', ___E_CID_MeasurementResult_iE_Extensions__item__criticality),
        ('extensionValue', ___E_CID_MeasurementResult_iE_Extensions__item__extensionValue),
        ])
    __E_CID_MeasurementResult_iE_Extensions__item_._ext = None
    _E_CID_MeasurementResult_iE_Extensions._cont = __E_CID_MeasurementResult_iE_Extensions__item_
    _E_CID_MeasurementResult_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_CID_MeasurementResult._cont = ASN1Dict([
        ('servingCell-ID', _E_CID_MeasurementResult_servingCell_ID),
        ('servingCellTAC', _E_CID_MeasurementResult_servingCellTAC),
        ('nG-RANAccessPointPosition', _E_CID_MeasurementResult_nG_RANAccessPointPosition),
        ('measuredResults', _E_CID_MeasurementResult_measuredResults),
        ('iE-Extensions', _E_CID_MeasurementResult_iE_Extensions),
        ])
    E_CID_MeasurementResult._ext = []
    
    #-----< E-CID-MeasurementResult-ExtIEs >-----#
    E_CID_MeasurementResult_ExtIEs = CLASS(name='E-CID-MeasurementResult-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _E_CID_MeasurementResult_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'GeographicalCoordinates')))
    E_CID_MeasurementResult_ExtIEs._val = ASN1Set(rv=[dict([('id', 37), ('criticality', 'ignore'), ('Extension', _E_CID_MeasurementResult_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< EUTRACellIdentifier >-----#
    EUTRACellIdentifier = BIT_STR(name='EUTRACellIdentifier', mode=MODE_TYPE)
    EUTRACellIdentifier._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    
    #-----< EARFCN >-----#
    EARFCN = INT(name='EARFCN', mode=MODE_TYPE)
    EARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=262143)], ev=[], er=[])
    
    #-----< Expected-Value-AoA >-----#
    Expected_Value_AoA = INT(name='Expected-Value-AoA', mode=MODE_TYPE)
    Expected_Value_AoA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599)], ev=None, er=[])
    
    #-----< Expected-Value-ZoA >-----#
    Expected_Value_ZoA = INT(name='Expected-Value-ZoA', mode=MODE_TYPE)
    Expected_Value_ZoA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1799)], ev=None, er=[])
    
    #-----< GeographicalCoordinates >-----#
    GeographicalCoordinates = SEQ(name='GeographicalCoordinates', mode=MODE_TYPE)
    _GeographicalCoordinates_tRPPositionDefinitionType = CHOICE(name='tRPPositionDefinitionType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRPPositionDefinitionType')))
    _GeographicalCoordinates_dLPRSResourceCoordinates = SEQ(name='dLPRSResourceCoordinates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'DLPRSResourceCoordinates')), opt=True)
    _GeographicalCoordinates_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GeographicalCoordinates_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___GeographicalCoordinates_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____GeographicalCoordinates_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____GeographicalCoordinates_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ARPLocationInformation')))
    ____GeographicalCoordinates_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'ignore'), ('Extension', _____GeographicalCoordinates_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GeographicalCoordinates_iE_Extensions__item__id._const_tab = ____GeographicalCoordinates_iE_Extensions__item__id_tab
    ___GeographicalCoordinates_iE_Extensions__item__id._const_tab_at = None
    ___GeographicalCoordinates_iE_Extensions__item__id._const_tab_id = 'id'
    ___GeographicalCoordinates_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ___GeographicalCoordinates_iE_Extensions__item__criticality._const_tab = ____GeographicalCoordinates_iE_Extensions__item__id_tab
    ___GeographicalCoordinates_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GeographicalCoordinates_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue._const_tab = ____GeographicalCoordinates_iE_Extensions__item__id_tab
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GeographicalCoordinates_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GeographicalCoordinates_iE_Extensions__item__id),
        ('criticality', ___GeographicalCoordinates_iE_Extensions__item__criticality),
        ('extensionValue', ___GeographicalCoordinates_iE_Extensions__item__extensionValue),
        ])
    __GeographicalCoordinates_iE_Extensions__item_._ext = None
    _GeographicalCoordinates_iE_Extensions._cont = __GeographicalCoordinates_iE_Extensions__item_
    _GeographicalCoordinates_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GeographicalCoordinates._cont = ASN1Dict([
        ('tRPPositionDefinitionType', _GeographicalCoordinates_tRPPositionDefinitionType),
        ('dLPRSResourceCoordinates', _GeographicalCoordinates_dLPRSResourceCoordinates),
        ('iE-Extensions', _GeographicalCoordinates_iE_Extensions),
        ])
    GeographicalCoordinates._ext = []
    
    #-----< GeographicalCoordinates-ExtIEs >-----#
    GeographicalCoordinates_ExtIEs = CLASS(name='GeographicalCoordinates-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _GeographicalCoordinates_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ARPLocationInformation')))
    GeographicalCoordinates_ExtIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'ignore'), ('Extension', _GeographicalCoordinates_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNB-RxTxTimeDiff >-----#
    GNB_RxTxTimeDiff = SEQ(name='GNB-RxTxTimeDiff', mode=MODE_TYPE)
    _GNB_RxTxTimeDiff_rxTxTimeDiff = CHOICE(name='rxTxTimeDiff', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'GNBRxTxTimeDiffMeas')))
    _GNB_RxTxTimeDiff_additionalPathList = SEQ_OF(name='additionalPathList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'AdditionalPathList')), opt=True)
    _GNB_RxTxTimeDiff_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_RxTxTimeDiff_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___GNB_RxTxTimeDiff_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ExtendedAdditionalPathList')))
    _____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPTEGInformation')))
    ____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 77), ('criticality', 'ignore'), ('Extension', _____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 85), ('criticality', 'ignore'), ('Extension', _____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GNB_RxTxTimeDiff_iE_Extensions__item__id._const_tab = ____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab
    ___GNB_RxTxTimeDiff_iE_Extensions__item__id._const_tab_at = None
    ___GNB_RxTxTimeDiff_iE_Extensions__item__id._const_tab_id = 'id'
    ___GNB_RxTxTimeDiff_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ___GNB_RxTxTimeDiff_iE_Extensions__item__criticality._const_tab = ____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab
    ___GNB_RxTxTimeDiff_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GNB_RxTxTimeDiff_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ___GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue._const_tab = ____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab
    ___GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GNB_RxTxTimeDiff_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GNB_RxTxTimeDiff_iE_Extensions__item__id),
        ('criticality', ___GNB_RxTxTimeDiff_iE_Extensions__item__criticality),
        ('extensionValue', ___GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue),
        ])
    __GNB_RxTxTimeDiff_iE_Extensions__item_._ext = None
    _GNB_RxTxTimeDiff_iE_Extensions._cont = __GNB_RxTxTimeDiff_iE_Extensions__item_
    _GNB_RxTxTimeDiff_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB_RxTxTimeDiff._cont = ASN1Dict([
        ('rxTxTimeDiff', _GNB_RxTxTimeDiff_rxTxTimeDiff),
        ('additionalPathList', _GNB_RxTxTimeDiff_additionalPathList),
        ('iE-Extensions', _GNB_RxTxTimeDiff_iE_Extensions),
        ])
    GNB_RxTxTimeDiff._ext = []
    
    #-----< GNB-RxTxTimeDiff-ExtIEs >-----#
    GNB_RxTxTimeDiff_ExtIEs = CLASS(name='GNB-RxTxTimeDiff-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _GNB_RxTxTimeDiff_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ExtendedAdditionalPathList')))
    _GNB_RxTxTimeDiff_ExtIEs_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPTEGInformation')))
    GNB_RxTxTimeDiff_ExtIEs._val = ASN1Set(rv=[dict([('id', 77), ('criticality', 'ignore'), ('Extension', _GNB_RxTxTimeDiff_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 85), ('criticality', 'ignore'), ('Extension', _GNB_RxTxTimeDiff_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GNBRxTxTimeDiffMeas >-----#
    GNBRxTxTimeDiffMeas = CHOICE(name='GNBRxTxTimeDiffMeas', mode=MODE_TYPE)
    _GNBRxTxTimeDiffMeas_k0 = INT(name='k0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNBRxTxTimeDiffMeas_k0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1970049)], ev=None, er=[])
    _GNBRxTxTimeDiffMeas_k1 = INT(name='k1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNBRxTxTimeDiffMeas_k1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=985025)], ev=None, er=[])
    _GNBRxTxTimeDiffMeas_k2 = INT(name='k2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNBRxTxTimeDiffMeas_k2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=492513)], ev=None, er=[])
    _GNBRxTxTimeDiffMeas_k3 = INT(name='k3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNBRxTxTimeDiffMeas_k3._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=246257)], ev=None, er=[])
    _GNBRxTxTimeDiffMeas_k4 = INT(name='k4', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNBRxTxTimeDiffMeas_k4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=123129)], ev=None, er=[])
    _GNBRxTxTimeDiffMeas_k5 = INT(name='k5', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNBRxTxTimeDiffMeas_k5._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=61565)], ev=None, er=[])
    _GNBRxTxTimeDiffMeas_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __GNBRxTxTimeDiffMeas_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___GNBRxTxTimeDiffMeas_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___GNBRxTxTimeDiffMeas_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __GNBRxTxTimeDiffMeas_choice_extension_id._const_tab = ___GNBRxTxTimeDiffMeas_choice_extension_id_tab
    __GNBRxTxTimeDiffMeas_choice_extension_id._const_tab_at = None
    __GNBRxTxTimeDiffMeas_choice_extension_id._const_tab_id = 'id'
    __GNBRxTxTimeDiffMeas_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___GNBRxTxTimeDiffMeas_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___GNBRxTxTimeDiffMeas_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __GNBRxTxTimeDiffMeas_choice_extension_criticality._const_tab = ___GNBRxTxTimeDiffMeas_choice_extension_criticality_tab
    __GNBRxTxTimeDiffMeas_choice_extension_criticality._const_tab_at = ('..', 'id')
    __GNBRxTxTimeDiffMeas_choice_extension_criticality._const_tab_id = 'criticality'
    __GNBRxTxTimeDiffMeas_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___GNBRxTxTimeDiffMeas_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___GNBRxTxTimeDiffMeas_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __GNBRxTxTimeDiffMeas_choice_extension_value._const_tab = ___GNBRxTxTimeDiffMeas_choice_extension_value_tab
    __GNBRxTxTimeDiffMeas_choice_extension_value._const_tab_at = ('..', 'id')
    __GNBRxTxTimeDiffMeas_choice_extension_value._const_tab_id = 'Value'
    _GNBRxTxTimeDiffMeas_choice_extension._cont = ASN1Dict([
        ('id', __GNBRxTxTimeDiffMeas_choice_extension_id),
        ('criticality', __GNBRxTxTimeDiffMeas_choice_extension_criticality),
        ('value', __GNBRxTxTimeDiffMeas_choice_extension_value),
        ])
    _GNBRxTxTimeDiffMeas_choice_extension._ext = None
    GNBRxTxTimeDiffMeas._cont = ASN1Dict([
        ('k0', _GNBRxTxTimeDiffMeas_k0),
        ('k1', _GNBRxTxTimeDiffMeas_k1),
        ('k2', _GNBRxTxTimeDiffMeas_k2),
        ('k3', _GNBRxTxTimeDiffMeas_k3),
        ('k4', _GNBRxTxTimeDiffMeas_k4),
        ('k5', _GNBRxTxTimeDiffMeas_k5),
        ('choice-extension', _GNBRxTxTimeDiffMeas_choice_extension),
        ])
    GNBRxTxTimeDiffMeas._ext = None
    
    #-----< GNBRxTxTimeDiffMeas-ExtIEs >-----#
    GNBRxTxTimeDiffMeas_ExtIEs = CLASS(name='GNBRxTxTimeDiffMeas-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    GNBRxTxTimeDiffMeas_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HESSID >-----#
    HESSID = OCT_STR(name='HESSID', mode=MODE_TYPE)
    HESSID._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< LCS-to-GCS-Translation >-----#
    LCS_to_GCS_Translation = SEQ(name='LCS-to-GCS-Translation', mode=MODE_TYPE)
    _LCS_to_GCS_Translation_alpha = INT(name='alpha', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCS_to_GCS_Translation_alpha._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599)], ev=None, er=[])
    _LCS_to_GCS_Translation_beta = INT(name='beta', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCS_to_GCS_Translation_beta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599)], ev=None, er=[])
    _LCS_to_GCS_Translation_gamma = INT(name='gamma', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCS_to_GCS_Translation_gamma._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599)], ev=None, er=[])
    _LCS_to_GCS_Translation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LCS_to_GCS_Translation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___LCS_to_GCS_Translation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____LCS_to_GCS_Translation_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____LCS_to_GCS_Translation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCS_to_GCS_Translation_iE_Extensions__item__id._const_tab = ____LCS_to_GCS_Translation_iE_Extensions__item__id_tab
    ___LCS_to_GCS_Translation_iE_Extensions__item__id._const_tab_at = None
    ___LCS_to_GCS_Translation_iE_Extensions__item__id._const_tab_id = 'id'
    ___LCS_to_GCS_Translation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____LCS_to_GCS_Translation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____LCS_to_GCS_Translation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCS_to_GCS_Translation_iE_Extensions__item__criticality._const_tab = ____LCS_to_GCS_Translation_iE_Extensions__item__criticality_tab
    ___LCS_to_GCS_Translation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LCS_to_GCS_Translation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LCS_to_GCS_Translation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____LCS_to_GCS_Translation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____LCS_to_GCS_Translation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCS_to_GCS_Translation_iE_Extensions__item__extensionValue._const_tab = ____LCS_to_GCS_Translation_iE_Extensions__item__extensionValue_tab
    ___LCS_to_GCS_Translation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LCS_to_GCS_Translation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LCS_to_GCS_Translation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LCS_to_GCS_Translation_iE_Extensions__item__id),
        ('criticality', ___LCS_to_GCS_Translation_iE_Extensions__item__criticality),
        ('extensionValue', ___LCS_to_GCS_Translation_iE_Extensions__item__extensionValue),
        ])
    __LCS_to_GCS_Translation_iE_Extensions__item_._ext = None
    _LCS_to_GCS_Translation_iE_Extensions._cont = __LCS_to_GCS_Translation_iE_Extensions__item_
    _LCS_to_GCS_Translation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LCS_to_GCS_Translation._cont = ASN1Dict([
        ('alpha', _LCS_to_GCS_Translation_alpha),
        ('beta', _LCS_to_GCS_Translation_beta),
        ('gamma', _LCS_to_GCS_Translation_gamma),
        ('iE-Extensions', _LCS_to_GCS_Translation_iE_Extensions),
        ])
    LCS_to_GCS_Translation._ext = []
    
    #-----< LCS-to-GCS-Translation-ExtIEs >-----#
    LCS_to_GCS_Translation_ExtIEs = CLASS(name='LCS-to-GCS-Translation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    LCS_to_GCS_Translation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LCS-to-GCS-TranslationItem >-----#
    LCS_to_GCS_TranslationItem = SEQ(name='LCS-to-GCS-TranslationItem', mode=MODE_TYPE)
    _LCS_to_GCS_TranslationItem_alpha = INT(name='alpha', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCS_to_GCS_TranslationItem_alpha._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _LCS_to_GCS_TranslationItem_alphaFine = INT(name='alphaFine', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LCS_to_GCS_TranslationItem_alphaFine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _LCS_to_GCS_TranslationItem_beta = INT(name='beta', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCS_to_GCS_TranslationItem_beta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _LCS_to_GCS_TranslationItem_betaFine = INT(name='betaFine', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LCS_to_GCS_TranslationItem_betaFine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _LCS_to_GCS_TranslationItem_gamma = INT(name='gamma', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCS_to_GCS_TranslationItem_gamma._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _LCS_to_GCS_TranslationItem_gammaFine = INT(name='gammaFine', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LCS_to_GCS_TranslationItem_gammaFine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _LCS_to_GCS_TranslationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LCS_to_GCS_TranslationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___LCS_to_GCS_TranslationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____LCS_to_GCS_TranslationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____LCS_to_GCS_TranslationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCS_to_GCS_TranslationItem_iE_Extensions__item__id._const_tab = ____LCS_to_GCS_TranslationItem_iE_Extensions__item__id_tab
    ___LCS_to_GCS_TranslationItem_iE_Extensions__item__id._const_tab_at = None
    ___LCS_to_GCS_TranslationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___LCS_to_GCS_TranslationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____LCS_to_GCS_TranslationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____LCS_to_GCS_TranslationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCS_to_GCS_TranslationItem_iE_Extensions__item__criticality._const_tab = ____LCS_to_GCS_TranslationItem_iE_Extensions__item__criticality_tab
    ___LCS_to_GCS_TranslationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LCS_to_GCS_TranslationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LCS_to_GCS_TranslationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____LCS_to_GCS_TranslationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____LCS_to_GCS_TranslationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCS_to_GCS_TranslationItem_iE_Extensions__item__extensionValue._const_tab = ____LCS_to_GCS_TranslationItem_iE_Extensions__item__extensionValue_tab
    ___LCS_to_GCS_TranslationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LCS_to_GCS_TranslationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LCS_to_GCS_TranslationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LCS_to_GCS_TranslationItem_iE_Extensions__item__id),
        ('criticality', ___LCS_to_GCS_TranslationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___LCS_to_GCS_TranslationItem_iE_Extensions__item__extensionValue),
        ])
    __LCS_to_GCS_TranslationItem_iE_Extensions__item_._ext = None
    _LCS_to_GCS_TranslationItem_iE_Extensions._cont = __LCS_to_GCS_TranslationItem_iE_Extensions__item_
    _LCS_to_GCS_TranslationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LCS_to_GCS_TranslationItem._cont = ASN1Dict([
        ('alpha', _LCS_to_GCS_TranslationItem_alpha),
        ('alphaFine', _LCS_to_GCS_TranslationItem_alphaFine),
        ('beta', _LCS_to_GCS_TranslationItem_beta),
        ('betaFine', _LCS_to_GCS_TranslationItem_betaFine),
        ('gamma', _LCS_to_GCS_TranslationItem_gamma),
        ('gammaFine', _LCS_to_GCS_TranslationItem_gammaFine),
        ('iE-Extensions', _LCS_to_GCS_TranslationItem_iE_Extensions),
        ])
    LCS_to_GCS_TranslationItem._ext = []
    
    #-----< LCS-to-GCS-TranslationItem-ExtIEs >-----#
    LCS_to_GCS_TranslationItem_ExtIEs = CLASS(name='LCS-to-GCS-TranslationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    LCS_to_GCS_TranslationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LocationUncertainty >-----#
    LocationUncertainty = SEQ(name='LocationUncertainty', mode=MODE_TYPE)
    _LocationUncertainty_horizontalUncertainty = INT(name='horizontalUncertainty', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationUncertainty_horizontalUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _LocationUncertainty_horizontalConfidence = INT(name='horizontalConfidence', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationUncertainty_horizontalConfidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _LocationUncertainty_verticalUncertainty = INT(name='verticalUncertainty', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationUncertainty_verticalUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _LocationUncertainty_verticalConfidence = INT(name='verticalConfidence', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationUncertainty_verticalConfidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _LocationUncertainty_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LocationUncertainty_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___LocationUncertainty_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____LocationUncertainty_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____LocationUncertainty_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationUncertainty_iE_Extensions__item__id._const_tab = ____LocationUncertainty_iE_Extensions__item__id_tab
    ___LocationUncertainty_iE_Extensions__item__id._const_tab_at = None
    ___LocationUncertainty_iE_Extensions__item__id._const_tab_id = 'id'
    ___LocationUncertainty_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____LocationUncertainty_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____LocationUncertainty_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationUncertainty_iE_Extensions__item__criticality._const_tab = ____LocationUncertainty_iE_Extensions__item__criticality_tab
    ___LocationUncertainty_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LocationUncertainty_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LocationUncertainty_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____LocationUncertainty_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____LocationUncertainty_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationUncertainty_iE_Extensions__item__extensionValue._const_tab = ____LocationUncertainty_iE_Extensions__item__extensionValue_tab
    ___LocationUncertainty_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LocationUncertainty_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LocationUncertainty_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LocationUncertainty_iE_Extensions__item__id),
        ('criticality', ___LocationUncertainty_iE_Extensions__item__criticality),
        ('extensionValue', ___LocationUncertainty_iE_Extensions__item__extensionValue),
        ])
    __LocationUncertainty_iE_Extensions__item_._ext = None
    _LocationUncertainty_iE_Extensions._cont = __LocationUncertainty_iE_Extensions__item_
    _LocationUncertainty_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LocationUncertainty._cont = ASN1Dict([
        ('horizontalUncertainty', _LocationUncertainty_horizontalUncertainty),
        ('horizontalConfidence', _LocationUncertainty_horizontalConfidence),
        ('verticalUncertainty', _LocationUncertainty_verticalUncertainty),
        ('verticalConfidence', _LocationUncertainty_verticalConfidence),
        ('iE-Extensions', _LocationUncertainty_iE_Extensions),
        ])
    LocationUncertainty._ext = []
    
    #-----< LocationUncertainty-ExtIEs >-----#
    LocationUncertainty_ExtIEs = CLASS(name='LocationUncertainty-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    LocationUncertainty_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LoS-NLoSIndicatorHard >-----#
    LoS_NLoSIndicatorHard = ENUM(name='LoS-NLoSIndicatorHard', mode=MODE_TYPE)
    LoS_NLoSIndicatorHard._cont = ASN1Dict([('nlos', 0), ('los', 1)])
    LoS_NLoSIndicatorHard._ext = None
    
    #-----< LoS-NLoSIndicatorSoft >-----#
    LoS_NLoSIndicatorSoft = INT(name='LoS-NLoSIndicatorSoft', mode=MODE_TYPE)
    LoS_NLoSIndicatorSoft._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    
    #-----< LoS-NLoSInformation >-----#
    LoS_NLoSInformation = CHOICE(name='LoS-NLoSInformation', mode=MODE_TYPE)
    _LoS_NLoSInformation_loS_NLoSIndicatorSoft = INT(name='loS-NLoSIndicatorSoft', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'LoS-NLoSIndicatorSoft')))
    _LoS_NLoSInformation_loS_NLoSIndicatorHard = ENUM(name='loS-NLoSIndicatorHard', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'LoS-NLoSIndicatorHard')))
    _LoS_NLoSInformation_choice_Extension = SEQ(name='choice-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __LoS_NLoSInformation_choice_Extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___LoS_NLoSInformation_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___LoS_NLoSInformation_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __LoS_NLoSInformation_choice_Extension_id._const_tab = ___LoS_NLoSInformation_choice_Extension_id_tab
    __LoS_NLoSInformation_choice_Extension_id._const_tab_at = None
    __LoS_NLoSInformation_choice_Extension_id._const_tab_id = 'id'
    __LoS_NLoSInformation_choice_Extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___LoS_NLoSInformation_choice_Extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___LoS_NLoSInformation_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __LoS_NLoSInformation_choice_Extension_criticality._const_tab = ___LoS_NLoSInformation_choice_Extension_criticality_tab
    __LoS_NLoSInformation_choice_Extension_criticality._const_tab_at = ('..', 'id')
    __LoS_NLoSInformation_choice_Extension_criticality._const_tab_id = 'criticality'
    __LoS_NLoSInformation_choice_Extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___LoS_NLoSInformation_choice_Extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___LoS_NLoSInformation_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __LoS_NLoSInformation_choice_Extension_value._const_tab = ___LoS_NLoSInformation_choice_Extension_value_tab
    __LoS_NLoSInformation_choice_Extension_value._const_tab_at = ('..', 'id')
    __LoS_NLoSInformation_choice_Extension_value._const_tab_id = 'Value'
    _LoS_NLoSInformation_choice_Extension._cont = ASN1Dict([
        ('id', __LoS_NLoSInformation_choice_Extension_id),
        ('criticality', __LoS_NLoSInformation_choice_Extension_criticality),
        ('value', __LoS_NLoSInformation_choice_Extension_value),
        ])
    _LoS_NLoSInformation_choice_Extension._ext = None
    LoS_NLoSInformation._cont = ASN1Dict([
        ('loS-NLoSIndicatorSoft', _LoS_NLoSInformation_loS_NLoSIndicatorSoft),
        ('loS-NLoSIndicatorHard', _LoS_NLoSInformation_loS_NLoSIndicatorHard),
        ('choice-Extension', _LoS_NLoSInformation_choice_Extension),
        ])
    LoS_NLoSInformation._ext = None
    
    #-----< LoS-NLoSInformation-ExtIEs >-----#
    LoS_NLoSInformation_ExtIEs = CLASS(name='LoS-NLoSInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    LoS_NLoSInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Measurement-ID >-----#
    Measurement_ID = INT(name='Measurement-ID', mode=MODE_TYPE)
    Measurement_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=[], er=[])
    
    #-----< MeasurementAmount >-----#
    MeasurementAmount = ENUM(name='MeasurementAmount', mode=MODE_TYPE)
    MeasurementAmount._cont = ASN1Dict([('ma0', 0), ('ma1', 1), ('ma2', 2), ('ma4', 3), ('ma8', 4), ('ma16', 5), ('ma32', 6), ('ma64', 7)])
    MeasurementAmount._ext = None
    
    #-----< MeasurementBeamInfoRequest >-----#
    MeasurementBeamInfoRequest = ENUM(name='MeasurementBeamInfoRequest', mode=MODE_TYPE)
    MeasurementBeamInfoRequest._cont = ASN1Dict([('true', 0)])
    MeasurementBeamInfoRequest._ext = []
    
    #-----< MeasurementBeamInfo >-----#
    MeasurementBeamInfo = SEQ(name='MeasurementBeamInfo', mode=MODE_TYPE)
    _MeasurementBeamInfo_pRS_Resource_ID = INT(name='pRS-Resource-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-ID')), opt=True)
    _MeasurementBeamInfo_pRS_Resource_Set_ID = INT(name='pRS-Resource-Set-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-Set-ID')), opt=True)
    _MeasurementBeamInfo_sSB_Index = INT(name='sSB-Index', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SSB-Index')), opt=True)
    _MeasurementBeamInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MeasurementBeamInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___MeasurementBeamInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____MeasurementBeamInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____MeasurementBeamInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementBeamInfo_iE_Extensions__item__id._const_tab = ____MeasurementBeamInfo_iE_Extensions__item__id_tab
    ___MeasurementBeamInfo_iE_Extensions__item__id._const_tab_at = None
    ___MeasurementBeamInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___MeasurementBeamInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____MeasurementBeamInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____MeasurementBeamInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementBeamInfo_iE_Extensions__item__criticality._const_tab = ____MeasurementBeamInfo_iE_Extensions__item__criticality_tab
    ___MeasurementBeamInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MeasurementBeamInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MeasurementBeamInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____MeasurementBeamInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____MeasurementBeamInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementBeamInfo_iE_Extensions__item__extensionValue._const_tab = ____MeasurementBeamInfo_iE_Extensions__item__extensionValue_tab
    ___MeasurementBeamInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MeasurementBeamInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MeasurementBeamInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MeasurementBeamInfo_iE_Extensions__item__id),
        ('criticality', ___MeasurementBeamInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___MeasurementBeamInfo_iE_Extensions__item__extensionValue),
        ])
    __MeasurementBeamInfo_iE_Extensions__item_._ext = None
    _MeasurementBeamInfo_iE_Extensions._cont = __MeasurementBeamInfo_iE_Extensions__item_
    _MeasurementBeamInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MeasurementBeamInfo._cont = ASN1Dict([
        ('pRS-Resource-ID', _MeasurementBeamInfo_pRS_Resource_ID),
        ('pRS-Resource-Set-ID', _MeasurementBeamInfo_pRS_Resource_Set_ID),
        ('sSB-Index', _MeasurementBeamInfo_sSB_Index),
        ('iE-Extensions', _MeasurementBeamInfo_iE_Extensions),
        ])
    MeasurementBeamInfo._ext = []
    
    #-----< MeasurementBeamInfo-ExtIEs >-----#
    MeasurementBeamInfo_ExtIEs = CLASS(name='MeasurementBeamInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    MeasurementBeamInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MeasurementPeriodicity >-----#
    MeasurementPeriodicity = ENUM(name='MeasurementPeriodicity', mode=MODE_TYPE)
    MeasurementPeriodicity._cont = ASN1Dict([('ms120', 0), ('ms240', 1), ('ms480', 2), ('ms640', 3), ('ms1024', 4), ('ms2048', 5), ('ms5120', 6), ('ms10240', 7), ('min1', 8), ('min6', 9), ('min12', 10), ('min30', 11), ('min60', 12), ('ms20480', 13), ('ms40960', 14), ('extended', 15)])
    MeasurementPeriodicity._ext = ['ms20480', 'ms40960', 'extended']
    
    #-----< MeasurementPeriodicityExtended >-----#
    MeasurementPeriodicityExtended = ENUM(name='MeasurementPeriodicityExtended', mode=MODE_TYPE)
    MeasurementPeriodicityExtended._cont = ASN1Dict([('ms160', 0), ('ms320', 1), ('ms1280', 2), ('ms2560', 3), ('ms61440', 4), ('ms81920', 5), ('ms368640', 6), ('ms737280', 7), ('ms1843200', 8)])
    MeasurementPeriodicityExtended._ext = []
    
    #-----< MeasurementPeriodicityNR-AoA >-----#
    MeasurementPeriodicityNR_AoA = ENUM(name='MeasurementPeriodicityNR-AoA', mode=MODE_TYPE)
    MeasurementPeriodicityNR_AoA._cont = ASN1Dict([('ms160', 0), ('ms320', 1), ('ms640', 2), ('ms1280', 3), ('ms2560', 4), ('ms5120', 5), ('ms10240', 6), ('ms20480', 7), ('ms40960', 8), ('ms61440', 9), ('ms81920', 10), ('ms368640', 11), ('ms737280', 12), ('ms1843200', 13)])
    MeasurementPeriodicityNR_AoA._ext = []
    
    #-----< MeasurementQuantities >-----#
    MeasurementQuantities = SEQ_OF(name='MeasurementQuantities', mode=MODE_TYPE)
    _MeasurementQuantities__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __MeasurementQuantities__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___MeasurementQuantities__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ____MeasurementQuantities__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementQuantities-Item')))
    ___MeasurementQuantities__item__id_tab._val = ASN1Set(rv=[dict([('id', 11), ('criticality', 'reject'), ('Value', ____MeasurementQuantities__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __MeasurementQuantities__item__id._const_tab = ___MeasurementQuantities__item__id_tab
    __MeasurementQuantities__item__id._const_tab_at = None
    __MeasurementQuantities__item__id._const_tab_id = 'id'
    __MeasurementQuantities__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    __MeasurementQuantities__item__criticality._const_tab = ___MeasurementQuantities__item__id_tab
    __MeasurementQuantities__item__criticality._const_tab_at = ('..', 'id')
    __MeasurementQuantities__item__criticality._const_tab_id = 'criticality'
    __MeasurementQuantities__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    __MeasurementQuantities__item__value._const_tab = ___MeasurementQuantities__item__id_tab
    __MeasurementQuantities__item__value._const_tab_at = ('..', 'id')
    __MeasurementQuantities__item__value._const_tab_id = 'Value'
    _MeasurementQuantities__item_._cont = ASN1Dict([
        ('id', __MeasurementQuantities__item__id),
        ('criticality', __MeasurementQuantities__item__criticality),
        ('value', __MeasurementQuantities__item__value),
        ])
    _MeasurementQuantities__item_._ext = None
    MeasurementQuantities._cont = _MeasurementQuantities__item_
    MeasurementQuantities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< MeasurementQuantities-ItemIEs >-----#
    MeasurementQuantities_ItemIEs = CLASS(name='MeasurementQuantities-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _MeasurementQuantities_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementQuantities-Item')))
    MeasurementQuantities_ItemIEs._val = ASN1Set(rv=[dict([('id', 11), ('criticality', 'reject'), ('Value', _MeasurementQuantities_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< MeasurementQuantities-Item >-----#
    MeasurementQuantities_Item = SEQ(name='MeasurementQuantities-Item', mode=MODE_TYPE)
    _MeasurementQuantities_Item_measurementQuantitiesValue = ENUM(name='measurementQuantitiesValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementQuantitiesValue')))
    _MeasurementQuantities_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MeasurementQuantities_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___MeasurementQuantities_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____MeasurementQuantities_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____MeasurementQuantities_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementQuantities_Item_iE_Extensions__item__id._const_tab = ____MeasurementQuantities_Item_iE_Extensions__item__id_tab
    ___MeasurementQuantities_Item_iE_Extensions__item__id._const_tab_at = None
    ___MeasurementQuantities_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___MeasurementQuantities_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____MeasurementQuantities_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____MeasurementQuantities_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab = ____MeasurementQuantities_Item_iE_Extensions__item__criticality_tab
    ___MeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MeasurementQuantities_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____MeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____MeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab = ____MeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab
    ___MeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MeasurementQuantities_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MeasurementQuantities_Item_iE_Extensions__item__id),
        ('criticality', ___MeasurementQuantities_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___MeasurementQuantities_Item_iE_Extensions__item__extensionValue),
        ])
    __MeasurementQuantities_Item_iE_Extensions__item_._ext = None
    _MeasurementQuantities_Item_iE_Extensions._cont = __MeasurementQuantities_Item_iE_Extensions__item_
    _MeasurementQuantities_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MeasurementQuantities_Item._cont = ASN1Dict([
        ('measurementQuantitiesValue', _MeasurementQuantities_Item_measurementQuantitiesValue),
        ('iE-Extensions', _MeasurementQuantities_Item_iE_Extensions),
        ])
    MeasurementQuantities_Item._ext = []
    
    #-----< MeasurementQuantitiesValue-ExtIEs >-----#
    MeasurementQuantitiesValue_ExtIEs = CLASS(name='MeasurementQuantitiesValue-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    MeasurementQuantitiesValue_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MeasurementQuantitiesValue >-----#
    MeasurementQuantitiesValue = ENUM(name='MeasurementQuantitiesValue', mode=MODE_TYPE)
    MeasurementQuantitiesValue._cont = ASN1Dict([('cell-ID', 0), ('angleOfArrival', 1), ('timingAdvanceType1', 2), ('timingAdvanceType2', 3), ('rSRP', 4), ('rSRQ', 5), ('sS-RSRP', 6), ('sS-RSRQ', 7), ('cSI-RSRP', 8), ('cSI-RSRQ', 9), ('angleOfArrivalNR', 10), ('timingAdvanceNR', 11)])
    MeasurementQuantitiesValue._ext = ['sS-RSRP', 'sS-RSRQ', 'cSI-RSRP', 'cSI-RSRQ', 'angleOfArrivalNR', 'timingAdvanceNR']
    
    #-----< MeasurementTimeOccasion >-----#
    MeasurementTimeOccasion = ENUM(name='MeasurementTimeOccasion', mode=MODE_TYPE)
    MeasurementTimeOccasion._cont = ASN1Dict([('o1', 0), ('o4', 1)])
    MeasurementTimeOccasion._ext = []
    
    #-----< MeasurementCharacteristicsRequestIndicator >-----#
    MeasurementCharacteristicsRequestIndicator = BIT_STR(name='MeasurementCharacteristicsRequestIndicator', mode=MODE_TYPE)
    MeasurementCharacteristicsRequestIndicator._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< MeasuredResults >-----#
    MeasuredResults = SEQ_OF(name='MeasuredResults', mode=MODE_TYPE)
    _MeasuredResults__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasuredResultsValue')))
    MeasuredResults._cont = _MeasuredResults__item_
    MeasuredResults._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< MeasuredResultsValue >-----#
    MeasuredResultsValue = CHOICE(name='MeasuredResultsValue', mode=MODE_TYPE)
    _MeasuredResultsValue_valueAngleOfArrival_EUTRA = INT(name='valueAngleOfArrival-EUTRA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MeasuredResultsValue_valueAngleOfArrival_EUTRA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=719)], ev=None, er=[])
    _MeasuredResultsValue_valueTimingAdvanceType1_EUTRA = INT(name='valueTimingAdvanceType1-EUTRA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MeasuredResultsValue_valueTimingAdvanceType1_EUTRA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7690)], ev=None, er=[])
    _MeasuredResultsValue_valueTimingAdvanceType2_EUTRA = INT(name='valueTimingAdvanceType2-EUTRA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MeasuredResultsValue_valueTimingAdvanceType2_EUTRA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7690)], ev=None, er=[])
    _MeasuredResultsValue_resultRSRP_EUTRA = SEQ_OF(name='resultRSRP-EUTRA', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResultRSRP-EUTRA')))
    _MeasuredResultsValue_resultRSRQ_EUTRA = SEQ_OF(name='resultRSRQ-EUTRA', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResultRSRQ-EUTRA')))
    _MeasuredResultsValue_choice_Extension = SEQ(name='choice-Extension', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __MeasuredResultsValue_choice_Extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___MeasuredResultsValue_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultSS-RSRP')))
    ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultSS-RSRQ')))
    ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultCSI-RSRP')))
    ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultCSI-RSRQ')))
    ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UL-AoA')))
    ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'NR-TADV')))
    ___MeasuredResultsValue_choice_Extension_id_tab._val = ASN1Set(rv=[dict([('id', 32), ('criticality', 'ignore'), ('Value', ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 33), ('criticality', 'ignore'), ('Value', ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 34), ('criticality', 'ignore'), ('Value', ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 35), ('criticality', 'ignore'), ('Value', ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 36), ('criticality', 'ignore'), ('Value', ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 94), ('criticality', 'ignore'), ('Value', ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_5), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __MeasuredResultsValue_choice_Extension_id._const_tab = ___MeasuredResultsValue_choice_Extension_id_tab
    __MeasuredResultsValue_choice_Extension_id._const_tab_at = None
    __MeasuredResultsValue_choice_Extension_id._const_tab_id = 'id'
    __MeasuredResultsValue_choice_Extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    __MeasuredResultsValue_choice_Extension_criticality._const_tab = ___MeasuredResultsValue_choice_Extension_id_tab
    __MeasuredResultsValue_choice_Extension_criticality._const_tab_at = ('..', 'id')
    __MeasuredResultsValue_choice_Extension_criticality._const_tab_id = 'criticality'
    __MeasuredResultsValue_choice_Extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    __MeasuredResultsValue_choice_Extension_value._const_tab = ___MeasuredResultsValue_choice_Extension_id_tab
    __MeasuredResultsValue_choice_Extension_value._const_tab_at = ('..', 'id')
    __MeasuredResultsValue_choice_Extension_value._const_tab_id = 'Value'
    _MeasuredResultsValue_choice_Extension._cont = ASN1Dict([
        ('id', __MeasuredResultsValue_choice_Extension_id),
        ('criticality', __MeasuredResultsValue_choice_Extension_criticality),
        ('value', __MeasuredResultsValue_choice_Extension_value),
        ])
    _MeasuredResultsValue_choice_Extension._ext = None
    MeasuredResultsValue._cont = ASN1Dict([
        ('valueAngleOfArrival-EUTRA', _MeasuredResultsValue_valueAngleOfArrival_EUTRA),
        ('valueTimingAdvanceType1-EUTRA', _MeasuredResultsValue_valueTimingAdvanceType1_EUTRA),
        ('valueTimingAdvanceType2-EUTRA', _MeasuredResultsValue_valueTimingAdvanceType2_EUTRA),
        ('resultRSRP-EUTRA', _MeasuredResultsValue_resultRSRP_EUTRA),
        ('resultRSRQ-EUTRA', _MeasuredResultsValue_resultRSRQ_EUTRA),
        ('choice-Extension', _MeasuredResultsValue_choice_Extension),
        ])
    MeasuredResultsValue._ext = None
    
    #-----< MeasuredResultsValue-ExtensionIE >-----#
    MeasuredResultsValue_ExtensionIE = CLASS(name='MeasuredResultsValue-ExtensionIE', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _MeasuredResultsValue_ExtensionIE_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultSS-RSRP')))
    _MeasuredResultsValue_ExtensionIE_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultSS-RSRQ')))
    _MeasuredResultsValue_ExtensionIE_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultCSI-RSRP')))
    _MeasuredResultsValue_ExtensionIE_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultCSI-RSRQ')))
    _MeasuredResultsValue_ExtensionIE_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UL-AoA')))
    _MeasuredResultsValue_ExtensionIE_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'NR-TADV')))
    MeasuredResultsValue_ExtensionIE._val = ASN1Set(rv=[dict([('id', 32), ('criticality', 'ignore'), ('Value', _MeasuredResultsValue_ExtensionIE_val_Value_0), ('presence', 'mandatory')]), dict([('id', 33), ('criticality', 'ignore'), ('Value', _MeasuredResultsValue_ExtensionIE_val_Value_1), ('presence', 'mandatory')]), dict([('id', 34), ('criticality', 'ignore'), ('Value', _MeasuredResultsValue_ExtensionIE_val_Value_2), ('presence', 'mandatory')]), dict([('id', 35), ('criticality', 'ignore'), ('Value', _MeasuredResultsValue_ExtensionIE_val_Value_3), ('presence', 'mandatory')]), dict([('id', 36), ('criticality', 'ignore'), ('Value', _MeasuredResultsValue_ExtensionIE_val_Value_4), ('presence', 'mandatory')]), dict([('id', 94), ('criticality', 'ignore'), ('Value', _MeasuredResultsValue_ExtensionIE_val_Value_5), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MultipleULAoA >-----#
    MultipleULAoA = SEQ(name='MultipleULAoA', mode=MODE_TYPE)
    _MultipleULAoA_multipleULAoA = SEQ_OF(name='multipleULAoA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'MultipleULAoA-List')))
    _MultipleULAoA_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MultipleULAoA_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___MultipleULAoA_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____MultipleULAoA_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____MultipleULAoA_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultipleULAoA_iE_Extensions__item__id._const_tab = ____MultipleULAoA_iE_Extensions__item__id_tab
    ___MultipleULAoA_iE_Extensions__item__id._const_tab_at = None
    ___MultipleULAoA_iE_Extensions__item__id._const_tab_id = 'id'
    ___MultipleULAoA_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____MultipleULAoA_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____MultipleULAoA_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultipleULAoA_iE_Extensions__item__criticality._const_tab = ____MultipleULAoA_iE_Extensions__item__criticality_tab
    ___MultipleULAoA_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MultipleULAoA_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MultipleULAoA_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____MultipleULAoA_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____MultipleULAoA_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultipleULAoA_iE_Extensions__item__extensionValue._const_tab = ____MultipleULAoA_iE_Extensions__item__extensionValue_tab
    ___MultipleULAoA_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MultipleULAoA_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MultipleULAoA_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MultipleULAoA_iE_Extensions__item__id),
        ('criticality', ___MultipleULAoA_iE_Extensions__item__criticality),
        ('extensionValue', ___MultipleULAoA_iE_Extensions__item__extensionValue),
        ])
    __MultipleULAoA_iE_Extensions__item_._ext = None
    _MultipleULAoA_iE_Extensions._cont = __MultipleULAoA_iE_Extensions__item_
    _MultipleULAoA_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MultipleULAoA._cont = ASN1Dict([
        ('multipleULAoA', _MultipleULAoA_multipleULAoA),
        ('iE-Extensions', _MultipleULAoA_iE_Extensions),
        ])
    MultipleULAoA._ext = []
    
    #-----< MultipleULAoA-ExtIEs >-----#
    MultipleULAoA_ExtIEs = CLASS(name='MultipleULAoA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    MultipleULAoA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MultipleULAoA-List >-----#
    MultipleULAoA_List = SEQ_OF(name='MultipleULAoA-List', mode=MODE_TYPE)
    _MultipleULAoA_List__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MultipleULAoA-Item')))
    MultipleULAoA_List._cont = _MultipleULAoA_List__item_
    MultipleULAoA_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MultipleULAoA-Item >-----#
    MultipleULAoA_Item = CHOICE(name='MultipleULAoA-Item', mode=MODE_TYPE)
    _MultipleULAoA_Item_uL_AoA = SEQ(name='uL-AoA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'UL-AoA')))
    _MultipleULAoA_Item_ul_ZoA = SEQ(name='ul-ZoA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ZoA')))
    _MultipleULAoA_Item_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __MultipleULAoA_Item_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___MultipleULAoA_Item_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___MultipleULAoA_Item_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MultipleULAoA_Item_choice_extension_id._const_tab = ___MultipleULAoA_Item_choice_extension_id_tab
    __MultipleULAoA_Item_choice_extension_id._const_tab_at = None
    __MultipleULAoA_Item_choice_extension_id._const_tab_id = 'id'
    __MultipleULAoA_Item_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___MultipleULAoA_Item_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___MultipleULAoA_Item_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MultipleULAoA_Item_choice_extension_criticality._const_tab = ___MultipleULAoA_Item_choice_extension_criticality_tab
    __MultipleULAoA_Item_choice_extension_criticality._const_tab_at = ('..', 'id')
    __MultipleULAoA_Item_choice_extension_criticality._const_tab_id = 'criticality'
    __MultipleULAoA_Item_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___MultipleULAoA_Item_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___MultipleULAoA_Item_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __MultipleULAoA_Item_choice_extension_value._const_tab = ___MultipleULAoA_Item_choice_extension_value_tab
    __MultipleULAoA_Item_choice_extension_value._const_tab_at = ('..', 'id')
    __MultipleULAoA_Item_choice_extension_value._const_tab_id = 'Value'
    _MultipleULAoA_Item_choice_extension._cont = ASN1Dict([
        ('id', __MultipleULAoA_Item_choice_extension_id),
        ('criticality', __MultipleULAoA_Item_choice_extension_criticality),
        ('value', __MultipleULAoA_Item_choice_extension_value),
        ])
    _MultipleULAoA_Item_choice_extension._ext = None
    MultipleULAoA_Item._cont = ASN1Dict([
        ('uL-AoA', _MultipleULAoA_Item_uL_AoA),
        ('ul-ZoA', _MultipleULAoA_Item_ul_ZoA),
        ('choice-extension', _MultipleULAoA_Item_choice_extension),
        ])
    MultipleULAoA_Item._ext = None
    
    #-----< MultipleULAoA-Item-ExtIEs >-----#
    MultipleULAoA_Item_ExtIEs = CLASS(name='MultipleULAoA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    MultipleULAoA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NarrowBandIndex >-----#
    NarrowBandIndex = INT(name='NarrowBandIndex', mode=MODE_TYPE)
    NarrowBandIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    
    #-----< NG-RANAccessPointPosition >-----#
    NG_RANAccessPointPosition = SEQ(name='NG-RANAccessPointPosition', mode=MODE_TYPE)
    _NG_RANAccessPointPosition_latitudeSign = ENUM(name='latitudeSign', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NG_RANAccessPointPosition_latitudeSign._cont = ASN1Dict([('north', 0), ('south', 1)])
    _NG_RANAccessPointPosition_latitudeSign._ext = None
    _NG_RANAccessPointPosition_latitude = INT(name='latitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NG_RANAccessPointPosition_latitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8388607)], ev=None, er=[])
    _NG_RANAccessPointPosition_longitude = INT(name='longitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NG_RANAccessPointPosition_longitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _NG_RANAccessPointPosition_directionOfAltitude = ENUM(name='directionOfAltitude', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NG_RANAccessPointPosition_directionOfAltitude._cont = ASN1Dict([('height', 0), ('depth', 1)])
    _NG_RANAccessPointPosition_directionOfAltitude._ext = None
    _NG_RANAccessPointPosition_altitude = INT(name='altitude', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NG_RANAccessPointPosition_altitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _NG_RANAccessPointPosition_uncertaintySemi_major = INT(name='uncertaintySemi-major', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NG_RANAccessPointPosition_uncertaintySemi_major._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _NG_RANAccessPointPosition_uncertaintySemi_minor = INT(name='uncertaintySemi-minor', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NG_RANAccessPointPosition_uncertaintySemi_minor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _NG_RANAccessPointPosition_orientationOfMajorAxis = INT(name='orientationOfMajorAxis', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NG_RANAccessPointPosition_orientationOfMajorAxis._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    _NG_RANAccessPointPosition_uncertaintyAltitude = INT(name='uncertaintyAltitude', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NG_RANAccessPointPosition_uncertaintyAltitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _NG_RANAccessPointPosition_confidence = INT(name='confidence', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NG_RANAccessPointPosition_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _NG_RANAccessPointPosition_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NG_RANAccessPointPosition_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___NG_RANAccessPointPosition_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____NG_RANAccessPointPosition_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NG_RANAccessPointPosition_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NG_RANAccessPointPosition_iE_Extensions__item__id._const_tab = ____NG_RANAccessPointPosition_iE_Extensions__item__id_tab
    ___NG_RANAccessPointPosition_iE_Extensions__item__id._const_tab_at = None
    ___NG_RANAccessPointPosition_iE_Extensions__item__id._const_tab_id = 'id'
    ___NG_RANAccessPointPosition_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____NG_RANAccessPointPosition_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NG_RANAccessPointPosition_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NG_RANAccessPointPosition_iE_Extensions__item__criticality._const_tab = ____NG_RANAccessPointPosition_iE_Extensions__item__criticality_tab
    ___NG_RANAccessPointPosition_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NG_RANAccessPointPosition_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NG_RANAccessPointPosition_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____NG_RANAccessPointPosition_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NG_RANAccessPointPosition_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NG_RANAccessPointPosition_iE_Extensions__item__extensionValue._const_tab = ____NG_RANAccessPointPosition_iE_Extensions__item__extensionValue_tab
    ___NG_RANAccessPointPosition_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NG_RANAccessPointPosition_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NG_RANAccessPointPosition_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NG_RANAccessPointPosition_iE_Extensions__item__id),
        ('criticality', ___NG_RANAccessPointPosition_iE_Extensions__item__criticality),
        ('extensionValue', ___NG_RANAccessPointPosition_iE_Extensions__item__extensionValue),
        ])
    __NG_RANAccessPointPosition_iE_Extensions__item_._ext = None
    _NG_RANAccessPointPosition_iE_Extensions._cont = __NG_RANAccessPointPosition_iE_Extensions__item_
    _NG_RANAccessPointPosition_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NG_RANAccessPointPosition._cont = ASN1Dict([
        ('latitudeSign', _NG_RANAccessPointPosition_latitudeSign),
        ('latitude', _NG_RANAccessPointPosition_latitude),
        ('longitude', _NG_RANAccessPointPosition_longitude),
        ('directionOfAltitude', _NG_RANAccessPointPosition_directionOfAltitude),
        ('altitude', _NG_RANAccessPointPosition_altitude),
        ('uncertaintySemi-major', _NG_RANAccessPointPosition_uncertaintySemi_major),
        ('uncertaintySemi-minor', _NG_RANAccessPointPosition_uncertaintySemi_minor),
        ('orientationOfMajorAxis', _NG_RANAccessPointPosition_orientationOfMajorAxis),
        ('uncertaintyAltitude', _NG_RANAccessPointPosition_uncertaintyAltitude),
        ('confidence', _NG_RANAccessPointPosition_confidence),
        ('iE-Extensions', _NG_RANAccessPointPosition_iE_Extensions),
        ])
    NG_RANAccessPointPosition._ext = []
    
    #-----< NG-RANAccessPointPosition-ExtIEs >-----#
    NG_RANAccessPointPosition_ExtIEs = CLASS(name='NG-RANAccessPointPosition-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    NG_RANAccessPointPosition_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NGRANHighAccuracyAccessPointPosition >-----#
    NGRANHighAccuracyAccessPointPosition = SEQ(name='NGRANHighAccuracyAccessPointPosition', mode=MODE_TYPE)
    _NGRANHighAccuracyAccessPointPosition_latitude = INT(name='latitude', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_latitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_longitude = INT(name='longitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_longitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_altitude = INT(name='altitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_altitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-64000, ub=1280000)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_major = INT(name='uncertaintySemi-major', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_major._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_minor = INT(name='uncertaintySemi-minor', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_minor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_orientationOfMajorAxis = INT(name='orientationOfMajorAxis', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_orientationOfMajorAxis._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_horizontalConfidence = INT(name='horizontalConfidence', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_horizontalConfidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_uncertaintyAltitude = INT(name='uncertaintyAltitude', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_uncertaintyAltitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_verticalConfidence = INT(name='verticalConfidence', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NGRANHighAccuracyAccessPointPosition_verticalConfidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _NGRANHighAccuracyAccessPointPosition_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NGRANHighAccuracyAccessPointPosition_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id._const_tab = ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id_tab
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id._const_tab_at = None
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id._const_tab_id = 'id'
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality._const_tab = ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality_tab
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue._const_tab = ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue_tab
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NGRANHighAccuracyAccessPointPosition_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id),
        ('criticality', ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality),
        ('extensionValue', ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue),
        ])
    __NGRANHighAccuracyAccessPointPosition_iE_Extensions__item_._ext = None
    _NGRANHighAccuracyAccessPointPosition_iE_Extensions._cont = __NGRANHighAccuracyAccessPointPosition_iE_Extensions__item_
    _NGRANHighAccuracyAccessPointPosition_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NGRANHighAccuracyAccessPointPosition._cont = ASN1Dict([
        ('latitude', _NGRANHighAccuracyAccessPointPosition_latitude),
        ('longitude', _NGRANHighAccuracyAccessPointPosition_longitude),
        ('altitude', _NGRANHighAccuracyAccessPointPosition_altitude),
        ('uncertaintySemi-major', _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_major),
        ('uncertaintySemi-minor', _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_minor),
        ('orientationOfMajorAxis', _NGRANHighAccuracyAccessPointPosition_orientationOfMajorAxis),
        ('horizontalConfidence', _NGRANHighAccuracyAccessPointPosition_horizontalConfidence),
        ('uncertaintyAltitude', _NGRANHighAccuracyAccessPointPosition_uncertaintyAltitude),
        ('verticalConfidence', _NGRANHighAccuracyAccessPointPosition_verticalConfidence),
        ('iE-Extensions', _NGRANHighAccuracyAccessPointPosition_iE_Extensions),
        ])
    NGRANHighAccuracyAccessPointPosition._ext = []
    
    #-----< NGRANHighAccuracyAccessPointPosition-ExtIEs >-----#
    NGRANHighAccuracyAccessPointPosition_ExtIEs = CLASS(name='NGRANHighAccuracyAccessPointPosition-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    NGRANHighAccuracyAccessPointPosition_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NG-RAN-CGI >-----#
    NG_RAN_CGI = SEQ(name='NG-RAN-CGI', mode=MODE_TYPE)
    _NG_RAN_CGI_pLMN_Identity = OCT_STR(name='pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PLMN-Identity')))
    _NG_RAN_CGI_nG_RANcell = CHOICE(name='nG-RANcell', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NG-RANCell')))
    _NG_RAN_CGI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NG_RAN_CGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___NG_RAN_CGI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____NG_RAN_CGI_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NG_RAN_CGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NG_RAN_CGI_iE_Extensions__item__id._const_tab = ____NG_RAN_CGI_iE_Extensions__item__id_tab
    ___NG_RAN_CGI_iE_Extensions__item__id._const_tab_at = None
    ___NG_RAN_CGI_iE_Extensions__item__id._const_tab_id = 'id'
    ___NG_RAN_CGI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____NG_RAN_CGI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NG_RAN_CGI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NG_RAN_CGI_iE_Extensions__item__criticality._const_tab = ____NG_RAN_CGI_iE_Extensions__item__criticality_tab
    ___NG_RAN_CGI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NG_RAN_CGI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NG_RAN_CGI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____NG_RAN_CGI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NG_RAN_CGI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NG_RAN_CGI_iE_Extensions__item__extensionValue._const_tab = ____NG_RAN_CGI_iE_Extensions__item__extensionValue_tab
    ___NG_RAN_CGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NG_RAN_CGI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NG_RAN_CGI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NG_RAN_CGI_iE_Extensions__item__id),
        ('criticality', ___NG_RAN_CGI_iE_Extensions__item__criticality),
        ('extensionValue', ___NG_RAN_CGI_iE_Extensions__item__extensionValue),
        ])
    __NG_RAN_CGI_iE_Extensions__item_._ext = None
    _NG_RAN_CGI_iE_Extensions._cont = __NG_RAN_CGI_iE_Extensions__item_
    _NG_RAN_CGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NG_RAN_CGI._cont = ASN1Dict([
        ('pLMN-Identity', _NG_RAN_CGI_pLMN_Identity),
        ('nG-RANcell', _NG_RAN_CGI_nG_RANcell),
        ('iE-Extensions', _NG_RAN_CGI_iE_Extensions),
        ])
    NG_RAN_CGI._ext = []
    
    #-----< NG-RAN-CGI-ExtIEs >-----#
    NG_RAN_CGI_ExtIEs = CLASS(name='NG-RAN-CGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    NG_RAN_CGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NG-RANCell >-----#
    NG_RANCell = CHOICE(name='NG-RANCell', mode=MODE_TYPE)
    _NG_RANCell_eUTRA_CellID = BIT_STR(name='eUTRA-CellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'EUTRACellIdentifier')))
    _NG_RANCell_nR_CellID = BIT_STR(name='nR-CellID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NRCellIdentifier')))
    _NG_RANCell_choice_Extension = SEQ(name='choice-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __NG_RANCell_choice_Extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___NG_RANCell_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___NG_RANCell_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NG_RANCell_choice_Extension_id._const_tab = ___NG_RANCell_choice_Extension_id_tab
    __NG_RANCell_choice_Extension_id._const_tab_at = None
    __NG_RANCell_choice_Extension_id._const_tab_id = 'id'
    __NG_RANCell_choice_Extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___NG_RANCell_choice_Extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___NG_RANCell_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NG_RANCell_choice_Extension_criticality._const_tab = ___NG_RANCell_choice_Extension_criticality_tab
    __NG_RANCell_choice_Extension_criticality._const_tab_at = ('..', 'id')
    __NG_RANCell_choice_Extension_criticality._const_tab_id = 'criticality'
    __NG_RANCell_choice_Extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___NG_RANCell_choice_Extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___NG_RANCell_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NG_RANCell_choice_Extension_value._const_tab = ___NG_RANCell_choice_Extension_value_tab
    __NG_RANCell_choice_Extension_value._const_tab_at = ('..', 'id')
    __NG_RANCell_choice_Extension_value._const_tab_id = 'Value'
    _NG_RANCell_choice_Extension._cont = ASN1Dict([
        ('id', __NG_RANCell_choice_Extension_id),
        ('criticality', __NG_RANCell_choice_Extension_criticality),
        ('value', __NG_RANCell_choice_Extension_value),
        ])
    _NG_RANCell_choice_Extension._ext = None
    NG_RANCell._cont = ASN1Dict([
        ('eUTRA-CellID', _NG_RANCell_eUTRA_CellID),
        ('nR-CellID', _NG_RANCell_nR_CellID),
        ('choice-Extension', _NG_RANCell_choice_Extension),
        ])
    NG_RANCell._ext = None
    
    #-----< NG-RANCell-ExtensionIE >-----#
    NG_RANCell_ExtensionIE = CLASS(name='NG-RANCell-ExtensionIE', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    NG_RANCell_ExtensionIE._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NR-ARFCN >-----#
    NR_ARFCN = INT(name='NR-ARFCN', mode=MODE_TYPE)
    NR_ARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    
    #-----< NRCellIdentifier >-----#
    NRCellIdentifier = BIT_STR(name='NRCellIdentifier', mode=MODE_TYPE)
    NRCellIdentifier._const_sz = ASN1Set(rv=[36], rr=[], ev=None, er=[])
    
    #-----< NR-PCI >-----#
    NR_PCI = INT(name='NR-PCI', mode=MODE_TYPE)
    NR_PCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1007)], ev=None, er=[])
    
    #-----< NR-PRS-Beam-Information >-----#
    NR_PRS_Beam_Information = SEQ(name='NR-PRS-Beam-Information', mode=MODE_TYPE)
    _NR_PRS_Beam_Information_nR_PRS_Beam_InformationList = SEQ_OF(name='nR-PRS-Beam-InformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NR_PRS_Beam_Information_nR_PRS_Beam_InformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'NR-PRS-Beam-InformationItem')))
    _NR_PRS_Beam_Information_nR_PRS_Beam_InformationList._cont = __NR_PRS_Beam_Information_nR_PRS_Beam_InformationList__item_
    _NR_PRS_Beam_Information_nR_PRS_Beam_InformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _NR_PRS_Beam_Information_lCS_to_GCS_TranslationList = SEQ_OF(name='lCS-to-GCS-TranslationList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __NR_PRS_Beam_Information_lCS_to_GCS_TranslationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'LCS-to-GCS-TranslationItem')))
    _NR_PRS_Beam_Information_lCS_to_GCS_TranslationList._cont = __NR_PRS_Beam_Information_lCS_to_GCS_TranslationList__item_
    _NR_PRS_Beam_Information_lCS_to_GCS_TranslationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    _NR_PRS_Beam_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NR_PRS_Beam_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___NR_PRS_Beam_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____NR_PRS_Beam_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NR_PRS_Beam_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PRS_Beam_Information_iE_Extensions__item__id._const_tab = ____NR_PRS_Beam_Information_iE_Extensions__item__id_tab
    ___NR_PRS_Beam_Information_iE_Extensions__item__id._const_tab_at = None
    ___NR_PRS_Beam_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___NR_PRS_Beam_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____NR_PRS_Beam_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NR_PRS_Beam_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PRS_Beam_Information_iE_Extensions__item__criticality._const_tab = ____NR_PRS_Beam_Information_iE_Extensions__item__criticality_tab
    ___NR_PRS_Beam_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NR_PRS_Beam_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NR_PRS_Beam_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____NR_PRS_Beam_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NR_PRS_Beam_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PRS_Beam_Information_iE_Extensions__item__extensionValue._const_tab = ____NR_PRS_Beam_Information_iE_Extensions__item__extensionValue_tab
    ___NR_PRS_Beam_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NR_PRS_Beam_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NR_PRS_Beam_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NR_PRS_Beam_Information_iE_Extensions__item__id),
        ('criticality', ___NR_PRS_Beam_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___NR_PRS_Beam_Information_iE_Extensions__item__extensionValue),
        ])
    __NR_PRS_Beam_Information_iE_Extensions__item_._ext = None
    _NR_PRS_Beam_Information_iE_Extensions._cont = __NR_PRS_Beam_Information_iE_Extensions__item_
    _NR_PRS_Beam_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NR_PRS_Beam_Information._cont = ASN1Dict([
        ('nR-PRS-Beam-InformationList', _NR_PRS_Beam_Information_nR_PRS_Beam_InformationList),
        ('lCS-to-GCS-TranslationList', _NR_PRS_Beam_Information_lCS_to_GCS_TranslationList),
        ('iE-Extensions', _NR_PRS_Beam_Information_iE_Extensions),
        ])
    NR_PRS_Beam_Information._ext = []
    
    #-----< NR-PRS-Beam-Information-IEs >-----#
    NR_PRS_Beam_Information_IEs = CLASS(name='NR-PRS-Beam-Information-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    NR_PRS_Beam_Information_IEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NR-PRS-Beam-InformationItem >-----#
    NR_PRS_Beam_InformationItem = SEQ(name='NR-PRS-Beam-InformationItem', mode=MODE_TYPE)
    _NR_PRS_Beam_InformationItem_pRSresourceSetID = INT(name='pRSresourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-Set-ID')))
    _NR_PRS_Beam_InformationItem_pRSAngle = SEQ_OF(name='pRSAngle', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NR_PRS_Beam_InformationItem_pRSAngle__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PRSAngleItem')))
    _NR_PRS_Beam_InformationItem_pRSAngle._cont = __NR_PRS_Beam_InformationItem_pRSAngle__item_
    _NR_PRS_Beam_InformationItem_pRSAngle._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _NR_PRS_Beam_InformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NR_PRS_Beam_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___NR_PRS_Beam_InformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____NR_PRS_Beam_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NR_PRS_Beam_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PRS_Beam_InformationItem_iE_Extensions__item__id._const_tab = ____NR_PRS_Beam_InformationItem_iE_Extensions__item__id_tab
    ___NR_PRS_Beam_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___NR_PRS_Beam_InformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___NR_PRS_Beam_InformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____NR_PRS_Beam_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NR_PRS_Beam_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PRS_Beam_InformationItem_iE_Extensions__item__criticality._const_tab = ____NR_PRS_Beam_InformationItem_iE_Extensions__item__criticality_tab
    ___NR_PRS_Beam_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NR_PRS_Beam_InformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NR_PRS_Beam_InformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____NR_PRS_Beam_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____NR_PRS_Beam_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_PRS_Beam_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____NR_PRS_Beam_InformationItem_iE_Extensions__item__extensionValue_tab
    ___NR_PRS_Beam_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NR_PRS_Beam_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NR_PRS_Beam_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NR_PRS_Beam_InformationItem_iE_Extensions__item__id),
        ('criticality', ___NR_PRS_Beam_InformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___NR_PRS_Beam_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __NR_PRS_Beam_InformationItem_iE_Extensions__item_._ext = None
    _NR_PRS_Beam_InformationItem_iE_Extensions._cont = __NR_PRS_Beam_InformationItem_iE_Extensions__item_
    _NR_PRS_Beam_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NR_PRS_Beam_InformationItem._cont = ASN1Dict([
        ('pRSresourceSetID', _NR_PRS_Beam_InformationItem_pRSresourceSetID),
        ('pRSAngle', _NR_PRS_Beam_InformationItem_pRSAngle),
        ('iE-Extensions', _NR_PRS_Beam_InformationItem_iE_Extensions),
        ])
    NR_PRS_Beam_InformationItem._ext = []
    
    #-----< NR-PRS-Beam-InformationItem-ExtIEs >-----#
    NR_PRS_Beam_InformationItem_ExtIEs = CLASS(name='NR-PRS-Beam-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    NR_PRS_Beam_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NR-TADV >-----#
    NR_TADV = INT(name='NR-TADV', mode=MODE_TYPE)
    NR_TADV._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7690)], ev=None, er=[])
    
    #-----< NumberOfAntennaPorts-EUTRA >-----#
    NumberOfAntennaPorts_EUTRA = ENUM(name='NumberOfAntennaPorts-EUTRA', mode=MODE_TYPE)
    NumberOfAntennaPorts_EUTRA._cont = ASN1Dict([('n1-or-n2', 0), ('n4', 1)])
    NumberOfAntennaPorts_EUTRA._ext = []
    
    #-----< NumberOfDlFrames-EUTRA >-----#
    NumberOfDlFrames_EUTRA = ENUM(name='NumberOfDlFrames-EUTRA', mode=MODE_TYPE)
    NumberOfDlFrames_EUTRA._cont = ASN1Dict([('sf1', 0), ('sf2', 1), ('sf4', 2), ('sf6', 3)])
    NumberOfDlFrames_EUTRA._ext = []
    
    #-----< NumberOfDlFrames-Extended-EUTRA >-----#
    NumberOfDlFrames_Extended_EUTRA = INT(name='NumberOfDlFrames-Extended-EUTRA', mode=MODE_TYPE)
    NumberOfDlFrames_Extended_EUTRA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=[], er=[])
    
    #-----< NumberOfFrequencyHoppingBands >-----#
    NumberOfFrequencyHoppingBands = ENUM(name='NumberOfFrequencyHoppingBands', mode=MODE_TYPE)
    NumberOfFrequencyHoppingBands._cont = ASN1Dict([('twobands', 0), ('fourbands', 1)])
    NumberOfFrequencyHoppingBands._ext = []
    
    #-----< NumberOfTRPRxTEG >-----#
    NumberOfTRPRxTEG = ENUM(name='NumberOfTRPRxTEG', mode=MODE_TYPE)
    NumberOfTRPRxTEG._cont = ASN1Dict([('two', 0), ('three', 1), ('four', 2), ('six', 3), ('eight', 4)])
    NumberOfTRPRxTEG._ext = []
    
    #-----< NumberOfTRPRxTxTEG >-----#
    NumberOfTRPRxTxTEG = ENUM(name='NumberOfTRPRxTxTEG', mode=MODE_TYPE)
    NumberOfTRPRxTxTEG._cont = ASN1Dict([('two', 0), ('three', 1), ('four', 2), ('six', 3), ('eight', 4)])
    NumberOfTRPRxTxTEG._ext = []
    
    #-----< NZP-CSI-RS-ResourceID >-----#
    NZP_CSI_RS_ResourceID = INT(name='NZP-CSI-RS-ResourceID', mode=MODE_TYPE)
    NZP_CSI_RS_ResourceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=191)], ev=None, er=[])
    
    #-----< OnDemandPRS-Info >-----#
    OnDemandPRS_Info = SEQ(name='OnDemandPRS-Info', mode=MODE_TYPE)
    _OnDemandPRS_Info_onDemandPRSRequestAllowed = BIT_STR(name='onDemandPRSRequestAllowed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OnDemandPRS_Info_onDemandPRSRequestAllowed._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _OnDemandPRS_Info_allowedResourceSetPeriodicityValues = BIT_STR(name='allowedResourceSetPeriodicityValues', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OnDemandPRS_Info_allowedResourceSetPeriodicityValues._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _OnDemandPRS_Info_allowedPRSBandwidthValues = BIT_STR(name='allowedPRSBandwidthValues', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OnDemandPRS_Info_allowedPRSBandwidthValues._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    _OnDemandPRS_Info_allowedResourceRepetitionFactorValues = BIT_STR(name='allowedResourceRepetitionFactorValues', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OnDemandPRS_Info_allowedResourceRepetitionFactorValues._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _OnDemandPRS_Info_allowedResourceNumberOfSymbolsValues = BIT_STR(name='allowedResourceNumberOfSymbolsValues', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OnDemandPRS_Info_allowedResourceNumberOfSymbolsValues._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _OnDemandPRS_Info_allowedCombSizeValues = BIT_STR(name='allowedCombSizeValues', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OnDemandPRS_Info_allowedCombSizeValues._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _OnDemandPRS_Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __OnDemandPRS_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___OnDemandPRS_Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____OnDemandPRS_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____OnDemandPRS_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OnDemandPRS_Info_iE_Extensions__item__id._const_tab = ____OnDemandPRS_Info_iE_Extensions__item__id_tab
    ___OnDemandPRS_Info_iE_Extensions__item__id._const_tab_at = None
    ___OnDemandPRS_Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___OnDemandPRS_Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____OnDemandPRS_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____OnDemandPRS_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OnDemandPRS_Info_iE_Extensions__item__criticality._const_tab = ____OnDemandPRS_Info_iE_Extensions__item__criticality_tab
    ___OnDemandPRS_Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___OnDemandPRS_Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___OnDemandPRS_Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____OnDemandPRS_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____OnDemandPRS_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OnDemandPRS_Info_iE_Extensions__item__extensionValue._const_tab = ____OnDemandPRS_Info_iE_Extensions__item__extensionValue_tab
    ___OnDemandPRS_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___OnDemandPRS_Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __OnDemandPRS_Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___OnDemandPRS_Info_iE_Extensions__item__id),
        ('criticality', ___OnDemandPRS_Info_iE_Extensions__item__criticality),
        ('extensionValue', ___OnDemandPRS_Info_iE_Extensions__item__extensionValue),
        ])
    __OnDemandPRS_Info_iE_Extensions__item_._ext = None
    _OnDemandPRS_Info_iE_Extensions._cont = __OnDemandPRS_Info_iE_Extensions__item_
    _OnDemandPRS_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    OnDemandPRS_Info._cont = ASN1Dict([
        ('onDemandPRSRequestAllowed', _OnDemandPRS_Info_onDemandPRSRequestAllowed),
        ('allowedResourceSetPeriodicityValues', _OnDemandPRS_Info_allowedResourceSetPeriodicityValues),
        ('allowedPRSBandwidthValues', _OnDemandPRS_Info_allowedPRSBandwidthValues),
        ('allowedResourceRepetitionFactorValues', _OnDemandPRS_Info_allowedResourceRepetitionFactorValues),
        ('allowedResourceNumberOfSymbolsValues', _OnDemandPRS_Info_allowedResourceNumberOfSymbolsValues),
        ('allowedCombSizeValues', _OnDemandPRS_Info_allowedCombSizeValues),
        ('iE-Extensions', _OnDemandPRS_Info_iE_Extensions),
        ])
    OnDemandPRS_Info._ext = []
    
    #-----< OnDemandPRS-Info-ExtIEs >-----#
    OnDemandPRS_Info_ExtIEs = CLASS(name='OnDemandPRS-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    OnDemandPRS_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< OTDOACells >-----#
    OTDOACells = SEQ_OF(name='OTDOACells', mode=MODE_TYPE)
    _OTDOACells__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __OTDOACells__item__oTDOACellInfo = SEQ_OF(name='oTDOACellInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'OTDOACell-Information')))
    __OTDOACells__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___OTDOACells__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ____OTDOACells__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    _____OTDOACells__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____OTDOACells__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____OTDOACells__item__iE_Extensions__item__id._const_tab = _____OTDOACells__item__iE_Extensions__item__id_tab
    ____OTDOACells__item__iE_Extensions__item__id._const_tab_at = None
    ____OTDOACells__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____OTDOACells__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    _____OTDOACells__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____OTDOACells__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____OTDOACells__item__iE_Extensions__item__criticality._const_tab = _____OTDOACells__item__iE_Extensions__item__criticality_tab
    ____OTDOACells__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____OTDOACells__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____OTDOACells__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    _____OTDOACells__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____OTDOACells__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____OTDOACells__item__iE_Extensions__item__extensionValue._const_tab = _____OTDOACells__item__iE_Extensions__item__extensionValue_tab
    ____OTDOACells__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____OTDOACells__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___OTDOACells__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____OTDOACells__item__iE_Extensions__item__id),
        ('criticality', ____OTDOACells__item__iE_Extensions__item__criticality),
        ('extensionValue', ____OTDOACells__item__iE_Extensions__item__extensionValue),
        ])
    ___OTDOACells__item__iE_Extensions__item_._ext = None
    __OTDOACells__item__iE_Extensions._cont = ___OTDOACells__item__iE_Extensions__item_
    __OTDOACells__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _OTDOACells__item_._cont = ASN1Dict([
        ('oTDOACellInfo', __OTDOACells__item__oTDOACellInfo),
        ('iE-Extensions', __OTDOACells__item__iE_Extensions),
        ])
    _OTDOACells__item_._ext = []
    OTDOACells._cont = _OTDOACells__item_
    OTDOACells._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3840)], ev=None, er=[])
    
    #-----< OTDOACells-ExtIEs >-----#
    OTDOACells_ExtIEs = CLASS(name='OTDOACells-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    OTDOACells_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< OTDOACell-Information >-----#
    OTDOACell_Information = SEQ_OF(name='OTDOACell-Information', mode=MODE_TYPE)
    _OTDOACell_Information__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'OTDOACell-Information-Item')))
    OTDOACell_Information._cont = _OTDOACell_Information__item_
    OTDOACell_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    
    #-----< OTDOACell-Information-Item >-----#
    OTDOACell_Information_Item = CHOICE(name='OTDOACell-Information-Item', mode=MODE_TYPE)
    _OTDOACell_Information_Item_pCI_EUTRA = INT(name='pCI-EUTRA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PCI-EUTRA')))
    _OTDOACell_Information_Item_cGI_EUTRA = SEQ(name='cGI-EUTRA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CGI-EUTRA')))
    _OTDOACell_Information_Item_tAC = OCT_STR(name='tAC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TAC')))
    _OTDOACell_Information_Item_eARFCN = INT(name='eARFCN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'EARFCN')))
    _OTDOACell_Information_Item_pRS_Bandwidth_EUTRA = ENUM(name='pRS-Bandwidth-EUTRA', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Bandwidth-EUTRA')))
    _OTDOACell_Information_Item_pRS_ConfigurationIndex_EUTRA = INT(name='pRS-ConfigurationIndex-EUTRA', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-ConfigurationIndex-EUTRA')))
    _OTDOACell_Information_Item_cPLength_EUTRA = ENUM(name='cPLength-EUTRA', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CPLength-EUTRA')))
    _OTDOACell_Information_Item_numberOfDlFrames_EUTRA = ENUM(name='numberOfDlFrames-EUTRA', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NumberOfDlFrames-EUTRA')))
    _OTDOACell_Information_Item_numberOfAntennaPorts_EUTRA = ENUM(name='numberOfAntennaPorts-EUTRA', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NumberOfAntennaPorts-EUTRA')))
    _OTDOACell_Information_Item_sFNInitialisationTime_EUTRA = BIT_STR(name='sFNInitialisationTime-EUTRA', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SFNInitialisationTime-EUTRA')))
    _OTDOACell_Information_Item_nG_RANAccessPointPosition = SEQ(name='nG-RANAccessPointPosition', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NG-RANAccessPointPosition')))
    _OTDOACell_Information_Item_pRSMutingConfiguration_EUTRA = CHOICE(name='pRSMutingConfiguration-EUTRA', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSMutingConfiguration-EUTRA')))
    _OTDOACell_Information_Item_prsid_EUTRA = INT(name='prsid-EUTRA', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-ID-EUTRA')))
    _OTDOACell_Information_Item_tpid_EUTRA = INT(name='tpid-EUTRA', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TP-ID-EUTRA')))
    _OTDOACell_Information_Item_tpType_EUTRA = ENUM(name='tpType-EUTRA', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TP-Type-EUTRA')))
    _OTDOACell_Information_Item_numberOfDlFrames_Extended_EUTRA = INT(name='numberOfDlFrames-Extended-EUTRA', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NumberOfDlFrames-Extended-EUTRA')))
    _OTDOACell_Information_Item_crsCPlength_EUTRA = ENUM(name='crsCPlength-EUTRA', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CPLength-EUTRA')))
    _OTDOACell_Information_Item_dL_Bandwidth_EUTRA = ENUM(name='dL-Bandwidth-EUTRA', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'DL-Bandwidth-EUTRA')))
    _OTDOACell_Information_Item_pRSOccasionGroup_EUTRA = ENUM(name='pRSOccasionGroup-EUTRA', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSOccasionGroup-EUTRA')))
    _OTDOACell_Information_Item_pRSFrequencyHoppingConfiguration_EUTRA = SEQ(name='pRSFrequencyHoppingConfiguration-EUTRA', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSFrequencyHoppingConfiguration-EUTRA')))
    _OTDOACell_Information_Item_choice_Extension = SEQ(name='choice-Extension', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __OTDOACell_Information_Item_choice_Extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___OTDOACell_Information_Item_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ____OTDOACell_Information_Item_choice_Extension_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TDD-Config-EUTRA-Item')))
    ____OTDOACell_Information_Item_choice_Extension_id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CGI-NR')))
    ____OTDOACell_Information_Item_choice_Extension_id_tab_val_Value_2 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SFNInitialisationTime-EUTRA')))
    ___OTDOACell_Information_Item_choice_Extension_id_tab._val = ASN1Set(rv=[dict([('id', 22), ('criticality', 'ignore'), ('Value', ____OTDOACell_Information_Item_choice_Extension_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', ____OTDOACell_Information_Item_choice_Extension_id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 59), ('criticality', 'ignore'), ('Value', ____OTDOACell_Information_Item_choice_Extension_id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __OTDOACell_Information_Item_choice_Extension_id._const_tab = ___OTDOACell_Information_Item_choice_Extension_id_tab
    __OTDOACell_Information_Item_choice_Extension_id._const_tab_at = None
    __OTDOACell_Information_Item_choice_Extension_id._const_tab_id = 'id'
    __OTDOACell_Information_Item_choice_Extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    __OTDOACell_Information_Item_choice_Extension_criticality._const_tab = ___OTDOACell_Information_Item_choice_Extension_id_tab
    __OTDOACell_Information_Item_choice_Extension_criticality._const_tab_at = ('..', 'id')
    __OTDOACell_Information_Item_choice_Extension_criticality._const_tab_id = 'criticality'
    __OTDOACell_Information_Item_choice_Extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    __OTDOACell_Information_Item_choice_Extension_value._const_tab = ___OTDOACell_Information_Item_choice_Extension_id_tab
    __OTDOACell_Information_Item_choice_Extension_value._const_tab_at = ('..', 'id')
    __OTDOACell_Information_Item_choice_Extension_value._const_tab_id = 'Value'
    _OTDOACell_Information_Item_choice_Extension._cont = ASN1Dict([
        ('id', __OTDOACell_Information_Item_choice_Extension_id),
        ('criticality', __OTDOACell_Information_Item_choice_Extension_criticality),
        ('value', __OTDOACell_Information_Item_choice_Extension_value),
        ])
    _OTDOACell_Information_Item_choice_Extension._ext = None
    OTDOACell_Information_Item._cont = ASN1Dict([
        ('pCI-EUTRA', _OTDOACell_Information_Item_pCI_EUTRA),
        ('cGI-EUTRA', _OTDOACell_Information_Item_cGI_EUTRA),
        ('tAC', _OTDOACell_Information_Item_tAC),
        ('eARFCN', _OTDOACell_Information_Item_eARFCN),
        ('pRS-Bandwidth-EUTRA', _OTDOACell_Information_Item_pRS_Bandwidth_EUTRA),
        ('pRS-ConfigurationIndex-EUTRA', _OTDOACell_Information_Item_pRS_ConfigurationIndex_EUTRA),
        ('cPLength-EUTRA', _OTDOACell_Information_Item_cPLength_EUTRA),
        ('numberOfDlFrames-EUTRA', _OTDOACell_Information_Item_numberOfDlFrames_EUTRA),
        ('numberOfAntennaPorts-EUTRA', _OTDOACell_Information_Item_numberOfAntennaPorts_EUTRA),
        ('sFNInitialisationTime-EUTRA', _OTDOACell_Information_Item_sFNInitialisationTime_EUTRA),
        ('nG-RANAccessPointPosition', _OTDOACell_Information_Item_nG_RANAccessPointPosition),
        ('pRSMutingConfiguration-EUTRA', _OTDOACell_Information_Item_pRSMutingConfiguration_EUTRA),
        ('prsid-EUTRA', _OTDOACell_Information_Item_prsid_EUTRA),
        ('tpid-EUTRA', _OTDOACell_Information_Item_tpid_EUTRA),
        ('tpType-EUTRA', _OTDOACell_Information_Item_tpType_EUTRA),
        ('numberOfDlFrames-Extended-EUTRA', _OTDOACell_Information_Item_numberOfDlFrames_Extended_EUTRA),
        ('crsCPlength-EUTRA', _OTDOACell_Information_Item_crsCPlength_EUTRA),
        ('dL-Bandwidth-EUTRA', _OTDOACell_Information_Item_dL_Bandwidth_EUTRA),
        ('pRSOccasionGroup-EUTRA', _OTDOACell_Information_Item_pRSOccasionGroup_EUTRA),
        ('pRSFrequencyHoppingConfiguration-EUTRA', _OTDOACell_Information_Item_pRSFrequencyHoppingConfiguration_EUTRA),
        ('choice-Extension', _OTDOACell_Information_Item_choice_Extension),
        ])
    OTDOACell_Information_Item._ext = None
    
    #-----< OTDOACell-Information-Item-ExtensionIE >-----#
    OTDOACell_Information_Item_ExtensionIE = CLASS(name='OTDOACell-Information-Item-ExtensionIE', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _OTDOACell_Information_Item_ExtensionIE_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TDD-Config-EUTRA-Item')))
    _OTDOACell_Information_Item_ExtensionIE_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CGI-NR')))
    _OTDOACell_Information_Item_ExtensionIE_val_Value_2 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SFNInitialisationTime-EUTRA')))
    OTDOACell_Information_Item_ExtensionIE._val = ASN1Set(rv=[dict([('id', 22), ('criticality', 'ignore'), ('Value', _OTDOACell_Information_Item_ExtensionIE_val_Value_0), ('presence', 'mandatory')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _OTDOACell_Information_Item_ExtensionIE_val_Value_1), ('presence', 'mandatory')]), dict([('id', 59), ('criticality', 'ignore'), ('Value', _OTDOACell_Information_Item_ExtensionIE_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< OTDOA-Information-Item >-----#
    OTDOA_Information_Item = ENUM(name='OTDOA-Information-Item', mode=MODE_TYPE)
    OTDOA_Information_Item._cont = ASN1Dict([('pci', 0), ('cGI', 1), ('tac', 2), ('earfcn', 3), ('prsBandwidth', 4), ('prsConfigIndex', 5), ('cpLength', 6), ('noDlFrames', 7), ('noAntennaPorts', 8), ('sFNInitTime', 9), ('nG-RANAccessPointPosition', 10), ('prsmutingconfiguration', 11), ('prsid', 12), ('tpid', 13), ('tpType', 14), ('crsCPlength', 15), ('dlBandwidth', 16), ('multipleprsConfigurationsperCell', 17), ('prsOccasionGroup', 18), ('prsFrequencyHoppingConfiguration', 19), ('tddConfig', 20)])
    OTDOA_Information_Item._ext = ['tddConfig']
    
    #-----< OtherRATMeasurementQuantities >-----#
    OtherRATMeasurementQuantities = SEQ_OF(name='OtherRATMeasurementQuantities', mode=MODE_TYPE)
    _OtherRATMeasurementQuantities__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __OtherRATMeasurementQuantities__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___OtherRATMeasurementQuantities__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ____OtherRATMeasurementQuantities__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'OtherRATMeasurementQuantities-Item')))
    ___OtherRATMeasurementQuantities__item__id_tab._val = ASN1Set(rv=[dict([('id', 16), ('criticality', 'reject'), ('Value', ____OtherRATMeasurementQuantities__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __OtherRATMeasurementQuantities__item__id._const_tab = ___OtherRATMeasurementQuantities__item__id_tab
    __OtherRATMeasurementQuantities__item__id._const_tab_at = None
    __OtherRATMeasurementQuantities__item__id._const_tab_id = 'id'
    __OtherRATMeasurementQuantities__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    __OtherRATMeasurementQuantities__item__criticality._const_tab = ___OtherRATMeasurementQuantities__item__id_tab
    __OtherRATMeasurementQuantities__item__criticality._const_tab_at = ('..', 'id')
    __OtherRATMeasurementQuantities__item__criticality._const_tab_id = 'criticality'
    __OtherRATMeasurementQuantities__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    __OtherRATMeasurementQuantities__item__value._const_tab = ___OtherRATMeasurementQuantities__item__id_tab
    __OtherRATMeasurementQuantities__item__value._const_tab_at = ('..', 'id')
    __OtherRATMeasurementQuantities__item__value._const_tab_id = 'Value'
    _OtherRATMeasurementQuantities__item_._cont = ASN1Dict([
        ('id', __OtherRATMeasurementQuantities__item__id),
        ('criticality', __OtherRATMeasurementQuantities__item__criticality),
        ('value', __OtherRATMeasurementQuantities__item__value),
        ])
    _OtherRATMeasurementQuantities__item_._ext = None
    OtherRATMeasurementQuantities._cont = _OtherRATMeasurementQuantities__item_
    OtherRATMeasurementQuantities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=64)], ev=None, er=[])
    
    #-----< OtherRATMeasurementQuantities-ItemIEs >-----#
    OtherRATMeasurementQuantities_ItemIEs = CLASS(name='OtherRATMeasurementQuantities-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _OtherRATMeasurementQuantities_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'OtherRATMeasurementQuantities-Item')))
    OtherRATMeasurementQuantities_ItemIEs._val = ASN1Set(rv=[dict([('id', 16), ('criticality', 'reject'), ('Value', _OtherRATMeasurementQuantities_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< OtherRATMeasurementQuantities-Item >-----#
    OtherRATMeasurementQuantities_Item = SEQ(name='OtherRATMeasurementQuantities-Item', mode=MODE_TYPE)
    _OtherRATMeasurementQuantities_Item_otherRATMeasurementQuantitiesValue = ENUM(name='otherRATMeasurementQuantitiesValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'OtherRATMeasurementQuantitiesValue')))
    _OtherRATMeasurementQuantities_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __OtherRATMeasurementQuantities_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____OtherRATMeasurementQuantities_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____OtherRATMeasurementQuantities_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__id._const_tab = ____OtherRATMeasurementQuantities_Item_iE_Extensions__item__id_tab
    ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__id._const_tab_at = None
    ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____OtherRATMeasurementQuantities_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____OtherRATMeasurementQuantities_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab = ____OtherRATMeasurementQuantities_Item_iE_Extensions__item__criticality_tab
    ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____OtherRATMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____OtherRATMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab = ____OtherRATMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab
    ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __OtherRATMeasurementQuantities_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__id),
        ('criticality', ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__extensionValue),
        ])
    __OtherRATMeasurementQuantities_Item_iE_Extensions__item_._ext = None
    _OtherRATMeasurementQuantities_Item_iE_Extensions._cont = __OtherRATMeasurementQuantities_Item_iE_Extensions__item_
    _OtherRATMeasurementQuantities_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    OtherRATMeasurementQuantities_Item._cont = ASN1Dict([
        ('otherRATMeasurementQuantitiesValue', _OtherRATMeasurementQuantities_Item_otherRATMeasurementQuantitiesValue),
        ('iE-Extensions', _OtherRATMeasurementQuantities_Item_iE_Extensions),
        ])
    OtherRATMeasurementQuantities_Item._ext = []
    
    #-----< OtherRATMeasurementQuantitiesValue-ExtIEs >-----#
    OtherRATMeasurementQuantitiesValue_ExtIEs = CLASS(name='OtherRATMeasurementQuantitiesValue-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    OtherRATMeasurementQuantitiesValue_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< OtherRATMeasurementQuantitiesValue >-----#
    OtherRATMeasurementQuantitiesValue = ENUM(name='OtherRATMeasurementQuantitiesValue', mode=MODE_TYPE)
    OtherRATMeasurementQuantitiesValue._cont = ASN1Dict([('geran', 0), ('utran', 1), ('nR', 2), ('eUTRA', 3)])
    OtherRATMeasurementQuantitiesValue._ext = ['nR', 'eUTRA']
    
    #-----< OtherRATMeasurementResult >-----#
    OtherRATMeasurementResult = SEQ_OF(name='OtherRATMeasurementResult', mode=MODE_TYPE)
    _OtherRATMeasurementResult__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'OtherRATMeasuredResultsValue')))
    OtherRATMeasurementResult._cont = _OtherRATMeasurementResult__item_
    OtherRATMeasurementResult._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< OtherRATMeasuredResultsValue >-----#
    OtherRATMeasuredResultsValue = CHOICE(name='OtherRATMeasuredResultsValue', mode=MODE_TYPE)
    _OtherRATMeasuredResultsValue_resultGERAN = SEQ_OF(name='resultGERAN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResultGERAN')))
    _OtherRATMeasuredResultsValue_resultUTRAN = SEQ_OF(name='resultUTRAN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResultUTRAN')))
    _OtherRATMeasuredResultsValue_choice_Extension = SEQ(name='choice-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __OtherRATMeasuredResultsValue_choice_Extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___OtherRATMeasuredResultsValue_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ____OtherRATMeasuredResultsValue_choice_Extension_id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultNR')))
    ____OtherRATMeasuredResultsValue_choice_Extension_id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultEUTRA')))
    ___OtherRATMeasuredResultsValue_choice_Extension_id_tab._val = ASN1Set(rv=[dict([('id', 55), ('criticality', 'ignore'), ('Value', ____OtherRATMeasuredResultsValue_choice_Extension_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 56), ('criticality', 'ignore'), ('Value', ____OtherRATMeasuredResultsValue_choice_Extension_id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __OtherRATMeasuredResultsValue_choice_Extension_id._const_tab = ___OtherRATMeasuredResultsValue_choice_Extension_id_tab
    __OtherRATMeasuredResultsValue_choice_Extension_id._const_tab_at = None
    __OtherRATMeasuredResultsValue_choice_Extension_id._const_tab_id = 'id'
    __OtherRATMeasuredResultsValue_choice_Extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    __OtherRATMeasuredResultsValue_choice_Extension_criticality._const_tab = ___OtherRATMeasuredResultsValue_choice_Extension_id_tab
    __OtherRATMeasuredResultsValue_choice_Extension_criticality._const_tab_at = ('..', 'id')
    __OtherRATMeasuredResultsValue_choice_Extension_criticality._const_tab_id = 'criticality'
    __OtherRATMeasuredResultsValue_choice_Extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    __OtherRATMeasuredResultsValue_choice_Extension_value._const_tab = ___OtherRATMeasuredResultsValue_choice_Extension_id_tab
    __OtherRATMeasuredResultsValue_choice_Extension_value._const_tab_at = ('..', 'id')
    __OtherRATMeasuredResultsValue_choice_Extension_value._const_tab_id = 'Value'
    _OtherRATMeasuredResultsValue_choice_Extension._cont = ASN1Dict([
        ('id', __OtherRATMeasuredResultsValue_choice_Extension_id),
        ('criticality', __OtherRATMeasuredResultsValue_choice_Extension_criticality),
        ('value', __OtherRATMeasuredResultsValue_choice_Extension_value),
        ])
    _OtherRATMeasuredResultsValue_choice_Extension._ext = None
    OtherRATMeasuredResultsValue._cont = ASN1Dict([
        ('resultGERAN', _OtherRATMeasuredResultsValue_resultGERAN),
        ('resultUTRAN', _OtherRATMeasuredResultsValue_resultUTRAN),
        ('choice-Extension', _OtherRATMeasuredResultsValue_choice_Extension),
        ])
    OtherRATMeasuredResultsValue._ext = None
    
    #-----< OtherRATMeasuredResultsValue-ExtensionIE >-----#
    OtherRATMeasuredResultsValue_ExtensionIE = CLASS(name='OtherRATMeasuredResultsValue-ExtensionIE', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _OtherRATMeasuredResultsValue_ExtensionIE_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultNR')))
    _OtherRATMeasuredResultsValue_ExtensionIE_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultEUTRA')))
    OtherRATMeasuredResultsValue_ExtensionIE._val = ASN1Set(rv=[dict([('id', 55), ('criticality', 'ignore'), ('Value', _OtherRATMeasuredResultsValue_ExtensionIE_val_Value_0), ('presence', 'mandatory')]), dict([('id', 56), ('criticality', 'ignore'), ('Value', _OtherRATMeasuredResultsValue_ExtensionIE_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Outcome >-----#
    Outcome = ENUM(name='Outcome', mode=MODE_TYPE)
    Outcome._cont = ASN1Dict([('failed', 0)])
    Outcome._ext = []
    
    #-----< PathlossReferenceInformation >-----#
    PathlossReferenceInformation = SEQ(name='PathlossReferenceInformation', mode=MODE_TYPE)
    _PathlossReferenceInformation_pathlossReferenceSignal = CHOICE(name='pathlossReferenceSignal', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PathlossReferenceSignal')))
    _PathlossReferenceInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PathlossReferenceInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PathlossReferenceInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____PathlossReferenceInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PathlossReferenceInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathlossReferenceInformation_iE_Extensions__item__id._const_tab = ____PathlossReferenceInformation_iE_Extensions__item__id_tab
    ___PathlossReferenceInformation_iE_Extensions__item__id._const_tab_at = None
    ___PathlossReferenceInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___PathlossReferenceInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____PathlossReferenceInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PathlossReferenceInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathlossReferenceInformation_iE_Extensions__item__criticality._const_tab = ____PathlossReferenceInformation_iE_Extensions__item__criticality_tab
    ___PathlossReferenceInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PathlossReferenceInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PathlossReferenceInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____PathlossReferenceInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PathlossReferenceInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PathlossReferenceInformation_iE_Extensions__item__extensionValue._const_tab = ____PathlossReferenceInformation_iE_Extensions__item__extensionValue_tab
    ___PathlossReferenceInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PathlossReferenceInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PathlossReferenceInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PathlossReferenceInformation_iE_Extensions__item__id),
        ('criticality', ___PathlossReferenceInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___PathlossReferenceInformation_iE_Extensions__item__extensionValue),
        ])
    __PathlossReferenceInformation_iE_Extensions__item_._ext = None
    _PathlossReferenceInformation_iE_Extensions._cont = __PathlossReferenceInformation_iE_Extensions__item_
    _PathlossReferenceInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PathlossReferenceInformation._cont = ASN1Dict([
        ('pathlossReferenceSignal', _PathlossReferenceInformation_pathlossReferenceSignal),
        ('iE-Extensions', _PathlossReferenceInformation_iE_Extensions),
        ])
    PathlossReferenceInformation._ext = []
    
    #-----< PathlossReferenceInformation-ExtIEs >-----#
    PathlossReferenceInformation_ExtIEs = CLASS(name='PathlossReferenceInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PathlossReferenceInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PathlossReferenceSignal >-----#
    PathlossReferenceSignal = CHOICE(name='PathlossReferenceSignal', mode=MODE_TYPE)
    _PathlossReferenceSignal_sSB_Reference = SEQ(name='sSB-Reference', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SSB')))
    _PathlossReferenceSignal_dL_PRS_Reference = SEQ(name='dL-PRS-Reference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'DL-PRS')))
    _PathlossReferenceSignal_choice_Extension = SEQ(name='choice-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __PathlossReferenceSignal_choice_Extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___PathlossReferenceSignal_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PathlossReferenceSignal_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PathlossReferenceSignal_choice_Extension_id._const_tab = ___PathlossReferenceSignal_choice_Extension_id_tab
    __PathlossReferenceSignal_choice_Extension_id._const_tab_at = None
    __PathlossReferenceSignal_choice_Extension_id._const_tab_id = 'id'
    __PathlossReferenceSignal_choice_Extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___PathlossReferenceSignal_choice_Extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PathlossReferenceSignal_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PathlossReferenceSignal_choice_Extension_criticality._const_tab = ___PathlossReferenceSignal_choice_Extension_criticality_tab
    __PathlossReferenceSignal_choice_Extension_criticality._const_tab_at = ('..', 'id')
    __PathlossReferenceSignal_choice_Extension_criticality._const_tab_id = 'criticality'
    __PathlossReferenceSignal_choice_Extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___PathlossReferenceSignal_choice_Extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PathlossReferenceSignal_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PathlossReferenceSignal_choice_Extension_value._const_tab = ___PathlossReferenceSignal_choice_Extension_value_tab
    __PathlossReferenceSignal_choice_Extension_value._const_tab_at = ('..', 'id')
    __PathlossReferenceSignal_choice_Extension_value._const_tab_id = 'Value'
    _PathlossReferenceSignal_choice_Extension._cont = ASN1Dict([
        ('id', __PathlossReferenceSignal_choice_Extension_id),
        ('criticality', __PathlossReferenceSignal_choice_Extension_criticality),
        ('value', __PathlossReferenceSignal_choice_Extension_value),
        ])
    _PathlossReferenceSignal_choice_Extension._ext = None
    PathlossReferenceSignal._cont = ASN1Dict([
        ('sSB-Reference', _PathlossReferenceSignal_sSB_Reference),
        ('dL-PRS-Reference', _PathlossReferenceSignal_dL_PRS_Reference),
        ('choice-Extension', _PathlossReferenceSignal_choice_Extension),
        ])
    PathlossReferenceSignal._ext = None
    
    #-----< PathlossReferenceSignal-ExtensionIE >-----#
    PathlossReferenceSignal_ExtensionIE = CLASS(name='PathlossReferenceSignal-ExtensionIE', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    PathlossReferenceSignal_ExtensionIE._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PCI-EUTRA >-----#
    PCI_EUTRA = INT(name='PCI-EUTRA', mode=MODE_TYPE)
    PCI_EUTRA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=503)], ev=[], er=[])
    
    #-----< PhysCellIDGERAN >-----#
    PhysCellIDGERAN = INT(name='PhysCellIDGERAN', mode=MODE_TYPE)
    PhysCellIDGERAN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=[], er=[])
    
    #-----< PhysCellIDUTRA-FDD >-----#
    PhysCellIDUTRA_FDD = INT(name='PhysCellIDUTRA-FDD', mode=MODE_TYPE)
    PhysCellIDUTRA_FDD._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=[], er=[])
    
    #-----< PhysCellIDUTRA-TDD >-----#
    PhysCellIDUTRA_TDD = INT(name='PhysCellIDUTRA-TDD', mode=MODE_TYPE)
    PhysCellIDUTRA_TDD._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=[], er=[])
    
    #-----< PLMN-Identity >-----#
    PLMN_Identity = OCT_STR(name='PLMN-Identity', mode=MODE_TYPE)
    PLMN_Identity._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< PeriodicityList >-----#
    PeriodicityList = SEQ_OF(name='PeriodicityList', mode=MODE_TYPE)
    _PeriodicityList__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PeriodicityItem')))
    PeriodicityList._cont = _PeriodicityList__item_
    PeriodicityList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PeriodicityItem >-----#
    PeriodicityItem = ENUM(name='PeriodicityItem', mode=MODE_TYPE)
    PeriodicityItem._cont = ASN1Dict([('ms0dot125', 0), ('ms0dot25', 1), ('ms0dot5', 2), ('ms0dot625', 3), ('ms1', 4), ('ms1dot25', 5), ('ms2', 6), ('ms2dot5', 7), ('ms4dot', 8), ('ms5', 9), ('ms8', 10), ('ms10', 11), ('ms16', 12), ('ms20', 13), ('ms32', 14), ('ms40', 15), ('ms64', 16), ('ms80m', 17), ('ms160', 18), ('ms320', 19), ('ms640m', 20), ('ms1280', 21), ('ms2560', 22), ('ms5120', 23), ('ms10240', 24)])
    PeriodicityItem._ext = []
    
    #-----< PosSIBs >-----#
    PosSIBs = SEQ_OF(name='PosSIBs', mode=MODE_TYPE)
    _PosSIBs__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __PosSIBs__item__posSIB_Type = ENUM(name='posSIB-Type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PosSIB-Type')))
    __PosSIBs__item__posSIB_Segments = SEQ_OF(name='posSIB-Segments', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PosSIB-Segments')))
    __PosSIBs__item__assistanceInformationMetaData = SEQ(name='assistanceInformationMetaData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'AssistanceInformationMetaData')), opt=True)
    __PosSIBs__item__broadcastPriority = INT(name='broadcastPriority', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PosSIBs__item__broadcastPriority._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=[], er=[])
    __PosSIBs__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___PosSIBs__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ____PosSIBs__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    _____PosSIBs__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____PosSIBs__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____PosSIBs__item__iE_Extensions__item__id._const_tab = _____PosSIBs__item__iE_Extensions__item__id_tab
    ____PosSIBs__item__iE_Extensions__item__id._const_tab_at = None
    ____PosSIBs__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____PosSIBs__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    _____PosSIBs__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____PosSIBs__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____PosSIBs__item__iE_Extensions__item__criticality._const_tab = _____PosSIBs__item__iE_Extensions__item__criticality_tab
    ____PosSIBs__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____PosSIBs__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____PosSIBs__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    _____PosSIBs__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____PosSIBs__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____PosSIBs__item__iE_Extensions__item__extensionValue._const_tab = _____PosSIBs__item__iE_Extensions__item__extensionValue_tab
    ____PosSIBs__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____PosSIBs__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___PosSIBs__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____PosSIBs__item__iE_Extensions__item__id),
        ('criticality', ____PosSIBs__item__iE_Extensions__item__criticality),
        ('extensionValue', ____PosSIBs__item__iE_Extensions__item__extensionValue),
        ])
    ___PosSIBs__item__iE_Extensions__item_._ext = None
    __PosSIBs__item__iE_Extensions._cont = ___PosSIBs__item__iE_Extensions__item_
    __PosSIBs__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _PosSIBs__item_._cont = ASN1Dict([
        ('posSIB-Type', __PosSIBs__item__posSIB_Type),
        ('posSIB-Segments', __PosSIBs__item__posSIB_Segments),
        ('assistanceInformationMetaData', __PosSIBs__item__assistanceInformationMetaData),
        ('broadcastPriority', __PosSIBs__item__broadcastPriority),
        ('iE-Extensions', __PosSIBs__item__iE_Extensions),
        ])
    _PosSIBs__item_._ext = []
    PosSIBs._cont = _PosSIBs__item_
    PosSIBs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< PosSIBs-ExtIEs >-----#
    PosSIBs_ExtIEs = CLASS(name='PosSIBs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PosSIBs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosSIB-Segments >-----#
    PosSIB_Segments = SEQ_OF(name='PosSIB-Segments', mode=MODE_TYPE)
    _PosSIB_Segments__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __PosSIB_Segments__item__assistanceDataSIBelement = OCT_STR(name='assistanceDataSIBelement', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PosSIB_Segments__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___PosSIB_Segments__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ____PosSIB_Segments__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    _____PosSIB_Segments__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____PosSIB_Segments__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____PosSIB_Segments__item__iE_Extensions__item__id._const_tab = _____PosSIB_Segments__item__iE_Extensions__item__id_tab
    ____PosSIB_Segments__item__iE_Extensions__item__id._const_tab_at = None
    ____PosSIB_Segments__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____PosSIB_Segments__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    _____PosSIB_Segments__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____PosSIB_Segments__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____PosSIB_Segments__item__iE_Extensions__item__criticality._const_tab = _____PosSIB_Segments__item__iE_Extensions__item__criticality_tab
    ____PosSIB_Segments__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____PosSIB_Segments__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____PosSIB_Segments__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    _____PosSIB_Segments__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____PosSIB_Segments__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____PosSIB_Segments__item__iE_Extensions__item__extensionValue._const_tab = _____PosSIB_Segments__item__iE_Extensions__item__extensionValue_tab
    ____PosSIB_Segments__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____PosSIB_Segments__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___PosSIB_Segments__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____PosSIB_Segments__item__iE_Extensions__item__id),
        ('criticality', ____PosSIB_Segments__item__iE_Extensions__item__criticality),
        ('extensionValue', ____PosSIB_Segments__item__iE_Extensions__item__extensionValue),
        ])
    ___PosSIB_Segments__item__iE_Extensions__item_._ext = None
    __PosSIB_Segments__item__iE_Extensions._cont = ___PosSIB_Segments__item__iE_Extensions__item_
    __PosSIB_Segments__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _PosSIB_Segments__item_._cont = ASN1Dict([
        ('assistanceDataSIBelement', __PosSIB_Segments__item__assistanceDataSIBelement),
        ('iE-Extensions', __PosSIB_Segments__item__iE_Extensions),
        ])
    _PosSIB_Segments__item_._ext = []
    PosSIB_Segments._cont = _PosSIB_Segments__item_
    PosSIB_Segments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< PosSIB-Segments-ExtIEs >-----#
    PosSIB_Segments_ExtIEs = CLASS(name='PosSIB-Segments-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PosSIB_Segments_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosSIB-Type >-----#
    PosSIB_Type = ENUM(name='PosSIB-Type', mode=MODE_TYPE)
    PosSIB_Type._cont = ASN1Dict([('posSibType1-1', 0), ('posSibType1-2', 1), ('posSibType1-3', 2), ('posSibType1-4', 3), ('posSibType1-5', 4), ('posSibType1-6', 5), ('posSibType1-7', 6), ('posSibType1-8', 7), ('posSibType2-1', 8), ('posSibType2-2', 9), ('posSibType2-3', 10), ('posSibType2-4', 11), ('posSibType2-5', 12), ('posSibType2-6', 13), ('posSibType2-7', 14), ('posSibType2-8', 15), ('posSibType2-9', 16), ('posSibType2-10', 17), ('posSibType2-11', 18), ('posSibType2-12', 19), ('posSibType2-13', 20), ('posSibType2-14', 21), ('posSibType2-15', 22), ('posSibType2-16', 23), ('posSibType2-17', 24), ('posSibType2-18', 25), ('posSibType2-19', 26), ('posSibType2-20', 27), ('posSibType2-21', 28), ('posSibType2-22', 29), ('posSibType2-23', 30), ('posSibType2-24', 31), ('posSibType2-25', 32), ('posSibType3-1', 33), ('posSibType4-1', 34), ('posSibType5-1', 35), ('posSibType6-1', 36), ('posSibType6-2', 37), ('posSibType6-3', 38), ('posSibType1-9', 39), ('posSibType1-10', 40), ('posSibType6-4', 41), ('posSibType6-5', 42), ('posSibType6-6', 43)])
    PosSIB_Type._ext = ['posSibType1-9', 'posSibType1-10', 'posSibType6-4', 'posSibType6-5', 'posSibType6-6']
    
    #-----< PosSRSResource-List >-----#
    PosSRSResource_List = SEQ_OF(name='PosSRSResource-List', mode=MODE_TYPE)
    _PosSRSResource_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PosSRSResource-Item')))
    PosSRSResource_List._cont = _PosSRSResource_List__item_
    PosSRSResource_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< PosSRSResource-Item >-----#
    PosSRSResource_Item = SEQ(name='PosSRSResource-Item', mode=MODE_TYPE)
    _PosSRSResource_Item_srs_PosResourceId = INT(name='srs-PosResourceId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSPosResourceID')))
    _PosSRSResource_Item_transmissionCombPos = CHOICE(name='transmissionCombPos', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TransmissionCombPos')))
    _PosSRSResource_Item_startPosition = INT(name='startPosition', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResource_Item_startPosition._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=13)], ev=None, er=[])
    _PosSRSResource_Item_nrofSymbols = ENUM(name='nrofSymbols', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResource_Item_nrofSymbols._cont = ASN1Dict([('n1', 0), ('n2', 1), ('n4', 2), ('n8', 3), ('n12', 4)])
    _PosSRSResource_Item_nrofSymbols._ext = None
    _PosSRSResource_Item_freqDomainShift = INT(name='freqDomainShift', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResource_Item_freqDomainShift._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=268)], ev=None, er=[])
    _PosSRSResource_Item_c_SRS = INT(name='c-SRS', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResource_Item_c_SRS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _PosSRSResource_Item_groupOrSequenceHopping = ENUM(name='groupOrSequenceHopping', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResource_Item_groupOrSequenceHopping._cont = ASN1Dict([('neither', 0), ('groupHopping', 1), ('sequenceHopping', 2)])
    _PosSRSResource_Item_groupOrSequenceHopping._ext = None
    _PosSRSResource_Item_resourceTypePos = CHOICE(name='resourceTypePos', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResourceTypePos')))
    _PosSRSResource_Item_sequenceId = INT(name='sequenceId', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResource_Item_sequenceId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PosSRSResource_Item_spatialRelationPos = CHOICE(name='spatialRelationPos', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SpatialRelationPos')), opt=True)
    _PosSRSResource_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosSRSResource_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PosSRSResource_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____PosSRSResource_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosSRSResource_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSRSResource_Item_iE_Extensions__item__id._const_tab = ____PosSRSResource_Item_iE_Extensions__item__id_tab
    ___PosSRSResource_Item_iE_Extensions__item__id._const_tab_at = None
    ___PosSRSResource_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PosSRSResource_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____PosSRSResource_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosSRSResource_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSRSResource_Item_iE_Extensions__item__criticality._const_tab = ____PosSRSResource_Item_iE_Extensions__item__criticality_tab
    ___PosSRSResource_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PosSRSResource_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PosSRSResource_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____PosSRSResource_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosSRSResource_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSRSResource_Item_iE_Extensions__item__extensionValue._const_tab = ____PosSRSResource_Item_iE_Extensions__item__extensionValue_tab
    ___PosSRSResource_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PosSRSResource_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PosSRSResource_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PosSRSResource_Item_iE_Extensions__item__id),
        ('criticality', ___PosSRSResource_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PosSRSResource_Item_iE_Extensions__item__extensionValue),
        ])
    __PosSRSResource_Item_iE_Extensions__item_._ext = None
    _PosSRSResource_Item_iE_Extensions._cont = __PosSRSResource_Item_iE_Extensions__item_
    _PosSRSResource_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosSRSResource_Item._cont = ASN1Dict([
        ('srs-PosResourceId', _PosSRSResource_Item_srs_PosResourceId),
        ('transmissionCombPos', _PosSRSResource_Item_transmissionCombPos),
        ('startPosition', _PosSRSResource_Item_startPosition),
        ('nrofSymbols', _PosSRSResource_Item_nrofSymbols),
        ('freqDomainShift', _PosSRSResource_Item_freqDomainShift),
        ('c-SRS', _PosSRSResource_Item_c_SRS),
        ('groupOrSequenceHopping', _PosSRSResource_Item_groupOrSequenceHopping),
        ('resourceTypePos', _PosSRSResource_Item_resourceTypePos),
        ('sequenceId', _PosSRSResource_Item_sequenceId),
        ('spatialRelationPos', _PosSRSResource_Item_spatialRelationPos),
        ('iE-Extensions', _PosSRSResource_Item_iE_Extensions),
        ])
    PosSRSResource_Item._ext = []
    
    #-----< PosSRSResource-Item-ExtIEs >-----#
    PosSRSResource_Item_ExtIEs = CLASS(name='PosSRSResource-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PosSRSResource_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosSRSResourceID-List >-----#
    PosSRSResourceID_List = SEQ_OF(name='PosSRSResourceID-List', mode=MODE_TYPE)
    _PosSRSResourceID_List__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSPosResourceID')))
    PosSRSResourceID_List._cont = _PosSRSResourceID_List__item_
    PosSRSResourceID_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< PosSRSResourceSet-List >-----#
    PosSRSResourceSet_List = SEQ_OF(name='PosSRSResourceSet-List', mode=MODE_TYPE)
    _PosSRSResourceSet_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PosSRSResourceSet-Item')))
    PosSRSResourceSet_List._cont = _PosSRSResourceSet_List__item_
    PosSRSResourceSet_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PosSRSResourceIDPerSet-List >-----#
    PosSRSResourceIDPerSet_List = SEQ_OF(name='PosSRSResourceIDPerSet-List', mode=MODE_TYPE)
    _PosSRSResourceIDPerSet_List__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSPosResourceID')))
    PosSRSResourceIDPerSet_List._cont = _PosSRSResourceIDPerSet_List__item_
    PosSRSResourceIDPerSet_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PosSRSResourceSet-Item >-----#
    PosSRSResourceSet_Item = SEQ(name='PosSRSResourceSet-Item', mode=MODE_TYPE)
    _PosSRSResourceSet_Item_possrsResourceSetID = INT(name='possrsResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosSRSResourceSet_Item_possrsResourceSetID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _PosSRSResourceSet_Item_possRSResourceIDPerSet_List = SEQ_OF(name='possRSResourceIDPerSet-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PosSRSResourceIDPerSet-List')))
    _PosSRSResourceSet_Item_posresourceSetType = CHOICE(name='posresourceSetType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PosResourceSetType')))
    _PosSRSResourceSet_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosSRSResourceSet_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PosSRSResourceSet_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____PosSRSResourceSet_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosSRSResourceSet_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSRSResourceSet_Item_iE_Extensions__item__id._const_tab = ____PosSRSResourceSet_Item_iE_Extensions__item__id_tab
    ___PosSRSResourceSet_Item_iE_Extensions__item__id._const_tab_at = None
    ___PosSRSResourceSet_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PosSRSResourceSet_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____PosSRSResourceSet_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosSRSResourceSet_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSRSResourceSet_Item_iE_Extensions__item__criticality._const_tab = ____PosSRSResourceSet_Item_iE_Extensions__item__criticality_tab
    ___PosSRSResourceSet_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PosSRSResourceSet_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PosSRSResourceSet_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____PosSRSResourceSet_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosSRSResourceSet_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosSRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab = ____PosSRSResourceSet_Item_iE_Extensions__item__extensionValue_tab
    ___PosSRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PosSRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PosSRSResourceSet_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PosSRSResourceSet_Item_iE_Extensions__item__id),
        ('criticality', ___PosSRSResourceSet_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PosSRSResourceSet_Item_iE_Extensions__item__extensionValue),
        ])
    __PosSRSResourceSet_Item_iE_Extensions__item_._ext = None
    _PosSRSResourceSet_Item_iE_Extensions._cont = __PosSRSResourceSet_Item_iE_Extensions__item_
    _PosSRSResourceSet_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosSRSResourceSet_Item._cont = ASN1Dict([
        ('possrsResourceSetID', _PosSRSResourceSet_Item_possrsResourceSetID),
        ('possRSResourceIDPerSet-List', _PosSRSResourceSet_Item_possRSResourceIDPerSet_List),
        ('posresourceSetType', _PosSRSResourceSet_Item_posresourceSetType),
        ('iE-Extensions', _PosSRSResourceSet_Item_iE_Extensions),
        ])
    PosSRSResourceSet_Item._ext = []
    
    #-----< PosSRSResourceSet-Item-ExtIEs >-----#
    PosSRSResourceSet_Item_ExtIEs = CLASS(name='PosSRSResourceSet-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PosSRSResourceSet_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosResourceSetType >-----#
    PosResourceSetType = CHOICE(name='PosResourceSetType', mode=MODE_TYPE)
    _PosResourceSetType_periodic = SEQ(name='periodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PosResourceSetTypePeriodic')))
    _PosResourceSetType_semi_persistent = SEQ(name='semi-persistent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PosResourceSetTypeSemi-persistent')))
    _PosResourceSetType_aperiodic = SEQ(name='aperiodic', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PosResourceSetTypeAperiodic')))
    _PosResourceSetType_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __PosResourceSetType_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___PosResourceSetType_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PosResourceSetType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PosResourceSetType_choice_extension_id._const_tab = ___PosResourceSetType_choice_extension_id_tab
    __PosResourceSetType_choice_extension_id._const_tab_at = None
    __PosResourceSetType_choice_extension_id._const_tab_id = 'id'
    __PosResourceSetType_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___PosResourceSetType_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PosResourceSetType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PosResourceSetType_choice_extension_criticality._const_tab = ___PosResourceSetType_choice_extension_criticality_tab
    __PosResourceSetType_choice_extension_criticality._const_tab_at = ('..', 'id')
    __PosResourceSetType_choice_extension_criticality._const_tab_id = 'criticality'
    __PosResourceSetType_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___PosResourceSetType_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PosResourceSetType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PosResourceSetType_choice_extension_value._const_tab = ___PosResourceSetType_choice_extension_value_tab
    __PosResourceSetType_choice_extension_value._const_tab_at = ('..', 'id')
    __PosResourceSetType_choice_extension_value._const_tab_id = 'Value'
    _PosResourceSetType_choice_extension._cont = ASN1Dict([
        ('id', __PosResourceSetType_choice_extension_id),
        ('criticality', __PosResourceSetType_choice_extension_criticality),
        ('value', __PosResourceSetType_choice_extension_value),
        ])
    _PosResourceSetType_choice_extension._ext = None
    PosResourceSetType._cont = ASN1Dict([
        ('periodic', _PosResourceSetType_periodic),
        ('semi-persistent', _PosResourceSetType_semi_persistent),
        ('aperiodic', _PosResourceSetType_aperiodic),
        ('choice-extension', _PosResourceSetType_choice_extension),
        ])
    PosResourceSetType._ext = None
    
    #-----< PosResourceSetType-ExtIEs >-----#
    PosResourceSetType_ExtIEs = CLASS(name='PosResourceSetType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    PosResourceSetType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosResourceSetTypePeriodic >-----#
    PosResourceSetTypePeriodic = SEQ(name='PosResourceSetTypePeriodic', mode=MODE_TYPE)
    _PosResourceSetTypePeriodic_posperiodicSet = ENUM(name='posperiodicSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosResourceSetTypePeriodic_posperiodicSet._cont = ASN1Dict([('true', 0)])
    _PosResourceSetTypePeriodic_posperiodicSet._ext = []
    _PosResourceSetTypePeriodic_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosResourceSetTypePeriodic_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PosResourceSetTypePeriodic_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____PosResourceSetTypePeriodic_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypePeriodic_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypePeriodic_iE_Extensions__item__id._const_tab = ____PosResourceSetTypePeriodic_iE_Extensions__item__id_tab
    ___PosResourceSetTypePeriodic_iE_Extensions__item__id._const_tab_at = None
    ___PosResourceSetTypePeriodic_iE_Extensions__item__id._const_tab_id = 'id'
    ___PosResourceSetTypePeriodic_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____PosResourceSetTypePeriodic_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypePeriodic_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypePeriodic_iE_Extensions__item__criticality._const_tab = ____PosResourceSetTypePeriodic_iE_Extensions__item__criticality_tab
    ___PosResourceSetTypePeriodic_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PosResourceSetTypePeriodic_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PosResourceSetTypePeriodic_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____PosResourceSetTypePeriodic_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypePeriodic_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypePeriodic_iE_Extensions__item__extensionValue._const_tab = ____PosResourceSetTypePeriodic_iE_Extensions__item__extensionValue_tab
    ___PosResourceSetTypePeriodic_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PosResourceSetTypePeriodic_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PosResourceSetTypePeriodic_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PosResourceSetTypePeriodic_iE_Extensions__item__id),
        ('criticality', ___PosResourceSetTypePeriodic_iE_Extensions__item__criticality),
        ('extensionValue', ___PosResourceSetTypePeriodic_iE_Extensions__item__extensionValue),
        ])
    __PosResourceSetTypePeriodic_iE_Extensions__item_._ext = None
    _PosResourceSetTypePeriodic_iE_Extensions._cont = __PosResourceSetTypePeriodic_iE_Extensions__item_
    _PosResourceSetTypePeriodic_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosResourceSetTypePeriodic._cont = ASN1Dict([
        ('posperiodicSet', _PosResourceSetTypePeriodic_posperiodicSet),
        ('iE-Extensions', _PosResourceSetTypePeriodic_iE_Extensions),
        ])
    PosResourceSetTypePeriodic._ext = []
    
    #-----< PosResourceSetTypePeriodic-ExtIEs >-----#
    PosResourceSetTypePeriodic_ExtIEs = CLASS(name='PosResourceSetTypePeriodic-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PosResourceSetTypePeriodic_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosResourceSetTypeSemi-persistent >-----#
    PosResourceSetTypeSemi_persistent = SEQ(name='PosResourceSetTypeSemi-persistent', mode=MODE_TYPE)
    _PosResourceSetTypeSemi_persistent_possemi_persistentSet = ENUM(name='possemi-persistentSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosResourceSetTypeSemi_persistent_possemi_persistentSet._cont = ASN1Dict([('true', 0)])
    _PosResourceSetTypeSemi_persistent_possemi_persistentSet._ext = []
    _PosResourceSetTypeSemi_persistent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosResourceSetTypeSemi_persistent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____PosResourceSetTypeSemi_persistent_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypeSemi_persistent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__id._const_tab = ____PosResourceSetTypeSemi_persistent_iE_Extensions__item__id_tab
    ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__id._const_tab_at = None
    ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__id._const_tab_id = 'id'
    ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____PosResourceSetTypeSemi_persistent_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypeSemi_persistent_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__criticality._const_tab = ____PosResourceSetTypeSemi_persistent_iE_Extensions__item__criticality_tab
    ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____PosResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab = ____PosResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue_tab
    ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PosResourceSetTypeSemi_persistent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__id),
        ('criticality', ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__criticality),
        ('extensionValue', ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue),
        ])
    __PosResourceSetTypeSemi_persistent_iE_Extensions__item_._ext = None
    _PosResourceSetTypeSemi_persistent_iE_Extensions._cont = __PosResourceSetTypeSemi_persistent_iE_Extensions__item_
    _PosResourceSetTypeSemi_persistent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosResourceSetTypeSemi_persistent._cont = ASN1Dict([
        ('possemi-persistentSet', _PosResourceSetTypeSemi_persistent_possemi_persistentSet),
        ('iE-Extensions', _PosResourceSetTypeSemi_persistent_iE_Extensions),
        ])
    PosResourceSetTypeSemi_persistent._ext = []
    
    #-----< PosResourceSetTypeSemi-persistent-ExtIEs >-----#
    PosResourceSetTypeSemi_persistent_ExtIEs = CLASS(name='PosResourceSetTypeSemi-persistent-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PosResourceSetTypeSemi_persistent_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PosResourceSetTypeAperiodic >-----#
    PosResourceSetTypeAperiodic = SEQ(name='PosResourceSetTypeAperiodic', mode=MODE_TYPE)
    _PosResourceSetTypeAperiodic_sRSResourceTrigger = INT(name='sRSResourceTrigger', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosResourceSetTypeAperiodic_sRSResourceTrigger._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    _PosResourceSetTypeAperiodic_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PosResourceSetTypeAperiodic_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PosResourceSetTypeAperiodic_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____PosResourceSetTypeAperiodic_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypeAperiodic_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypeAperiodic_iE_Extensions__item__id._const_tab = ____PosResourceSetTypeAperiodic_iE_Extensions__item__id_tab
    ___PosResourceSetTypeAperiodic_iE_Extensions__item__id._const_tab_at = None
    ___PosResourceSetTypeAperiodic_iE_Extensions__item__id._const_tab_id = 'id'
    ___PosResourceSetTypeAperiodic_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____PosResourceSetTypeAperiodic_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypeAperiodic_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypeAperiodic_iE_Extensions__item__criticality._const_tab = ____PosResourceSetTypeAperiodic_iE_Extensions__item__criticality_tab
    ___PosResourceSetTypeAperiodic_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PosResourceSetTypeAperiodic_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PosResourceSetTypeAperiodic_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____PosResourceSetTypeAperiodic_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PosResourceSetTypeAperiodic_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PosResourceSetTypeAperiodic_iE_Extensions__item__extensionValue._const_tab = ____PosResourceSetTypeAperiodic_iE_Extensions__item__extensionValue_tab
    ___PosResourceSetTypeAperiodic_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PosResourceSetTypeAperiodic_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PosResourceSetTypeAperiodic_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PosResourceSetTypeAperiodic_iE_Extensions__item__id),
        ('criticality', ___PosResourceSetTypeAperiodic_iE_Extensions__item__criticality),
        ('extensionValue', ___PosResourceSetTypeAperiodic_iE_Extensions__item__extensionValue),
        ])
    __PosResourceSetTypeAperiodic_iE_Extensions__item_._ext = None
    _PosResourceSetTypeAperiodic_iE_Extensions._cont = __PosResourceSetTypeAperiodic_iE_Extensions__item_
    _PosResourceSetTypeAperiodic_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PosResourceSetTypeAperiodic._cont = ASN1Dict([
        ('sRSResourceTrigger', _PosResourceSetTypeAperiodic_sRSResourceTrigger),
        ('iE-Extensions', _PosResourceSetTypeAperiodic_iE_Extensions),
        ])
    PosResourceSetTypeAperiodic._ext = []
    
    #-----< PosResourceSetTypeAperiodic-ExtIEs >-----#
    PosResourceSetTypeAperiodic_ExtIEs = CLASS(name='PosResourceSetTypeAperiodic-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PosResourceSetTypeAperiodic_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PreconfigurationResult >-----#
    PreconfigurationResult = BIT_STR(name='PreconfigurationResult', mode=MODE_TYPE)
    PreconfigurationResult._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< PRS-Bandwidth-EUTRA >-----#
    PRS_Bandwidth_EUTRA = ENUM(name='PRS-Bandwidth-EUTRA', mode=MODE_TYPE)
    PRS_Bandwidth_EUTRA._cont = ASN1Dict([('bw6', 0), ('bw15', 1), ('bw25', 2), ('bw50', 3), ('bw75', 4), ('bw100', 5)])
    PRS_Bandwidth_EUTRA._ext = []
    
    #-----< PRSAngleItem >-----#
    PRSAngleItem = SEQ(name='PRSAngleItem', mode=MODE_TYPE)
    _PRSAngleItem_nRPRSAzimuth = INT(name='nRPRSAzimuth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSAngleItem_nRPRSAzimuth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _PRSAngleItem_nRPRSAzimuthFine = INT(name='nRPRSAzimuthFine', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PRSAngleItem_nRPRSAzimuthFine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _PRSAngleItem_nRPRSElevation = INT(name='nRPRSElevation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PRSAngleItem_nRPRSElevation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=180)], ev=None, er=[])
    _PRSAngleItem_nRPRSElevationFine = INT(name='nRPRSElevationFine', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PRSAngleItem_nRPRSElevationFine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _PRSAngleItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSAngleItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSAngleItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____PRSAngleItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____PRSAngleItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-ID')))
    ____PRSAngleItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 65), ('criticality', 'ignore'), ('Extension', _____PRSAngleItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PRSAngleItem_iE_Extensions__item__id._const_tab = ____PRSAngleItem_iE_Extensions__item__id_tab
    ___PRSAngleItem_iE_Extensions__item__id._const_tab_at = None
    ___PRSAngleItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSAngleItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ___PRSAngleItem_iE_Extensions__item__criticality._const_tab = ____PRSAngleItem_iE_Extensions__item__id_tab
    ___PRSAngleItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSAngleItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSAngleItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ___PRSAngleItem_iE_Extensions__item__extensionValue._const_tab = ____PRSAngleItem_iE_Extensions__item__id_tab
    ___PRSAngleItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSAngleItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSAngleItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSAngleItem_iE_Extensions__item__id),
        ('criticality', ___PRSAngleItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSAngleItem_iE_Extensions__item__extensionValue),
        ])
    __PRSAngleItem_iE_Extensions__item_._ext = None
    _PRSAngleItem_iE_Extensions._cont = __PRSAngleItem_iE_Extensions__item_
    _PRSAngleItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSAngleItem._cont = ASN1Dict([
        ('nRPRSAzimuth', _PRSAngleItem_nRPRSAzimuth),
        ('nRPRSAzimuthFine', _PRSAngleItem_nRPRSAzimuthFine),
        ('nRPRSElevation', _PRSAngleItem_nRPRSElevation),
        ('nRPRSElevationFine', _PRSAngleItem_nRPRSElevationFine),
        ('iE-Extensions', _PRSAngleItem_iE_Extensions),
        ])
    PRSAngleItem._ext = []
    
    #-----< PRSAngleItem-ExtIEs >-----#
    PRSAngleItem_ExtIEs = CLASS(name='PRSAngleItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _PRSAngleItem_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-ID')))
    PRSAngleItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 65), ('criticality', 'ignore'), ('Extension', _PRSAngleItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PRSInformationPos >-----#
    PRSInformationPos = SEQ(name='PRSInformationPos', mode=MODE_TYPE)
    _PRSInformationPos_pRS_IDPos = INT(name='pRS-IDPos', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSInformationPos_pRS_IDPos._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _PRSInformationPos_pRS_Resource_Set_IDPos = INT(name='pRS-Resource-Set-IDPos', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSInformationPos_pRS_Resource_Set_IDPos._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _PRSInformationPos_pRS_Resource_IDPos = INT(name='pRS-Resource-IDPos', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PRSInformationPos_pRS_Resource_IDPos._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _PRSInformationPos_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSInformationPos_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSInformationPos_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____PRSInformationPos_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSInformationPos_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSInformationPos_iE_Extensions__item__id._const_tab = ____PRSInformationPos_iE_Extensions__item__id_tab
    ___PRSInformationPos_iE_Extensions__item__id._const_tab_at = None
    ___PRSInformationPos_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSInformationPos_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSInformationPos_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSInformationPos_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSInformationPos_iE_Extensions__item__criticality._const_tab = ____PRSInformationPos_iE_Extensions__item__criticality_tab
    ___PRSInformationPos_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSInformationPos_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSInformationPos_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSInformationPos_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSInformationPos_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSInformationPos_iE_Extensions__item__extensionValue._const_tab = ____PRSInformationPos_iE_Extensions__item__extensionValue_tab
    ___PRSInformationPos_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSInformationPos_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSInformationPos_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSInformationPos_iE_Extensions__item__id),
        ('criticality', ___PRSInformationPos_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSInformationPos_iE_Extensions__item__extensionValue),
        ])
    __PRSInformationPos_iE_Extensions__item_._ext = None
    _PRSInformationPos_iE_Extensions._cont = __PRSInformationPos_iE_Extensions__item_
    _PRSInformationPos_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSInformationPos._cont = ASN1Dict([
        ('pRS-IDPos', _PRSInformationPos_pRS_IDPos),
        ('pRS-Resource-Set-IDPos', _PRSInformationPos_pRS_Resource_Set_IDPos),
        ('pRS-Resource-IDPos', _PRSInformationPos_pRS_Resource_IDPos),
        ('iE-Extensions', _PRSInformationPos_iE_Extensions),
        ])
    PRSInformationPos._ext = []
    
    #-----< PRSInformationPos-ExtIEs >-----#
    PRSInformationPos_ExtIEs = CLASS(name='PRSInformationPos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRSInformationPos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSConfigRequestType >-----#
    PRSConfigRequestType = ENUM(name='PRSConfigRequestType', mode=MODE_TYPE)
    PRSConfigRequestType._cont = ASN1Dict([('configure', 0), ('off', 1)])
    PRSConfigRequestType._ext = []
    
    #-----< PRSConfiguration >-----#
    PRSConfiguration = SEQ(name='PRSConfiguration', mode=MODE_TYPE)
    _PRSConfiguration_pRSResourceSet_List = SEQ_OF(name='pRSResourceSet-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSResourceSet-List')))
    _PRSConfiguration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSConfiguration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____PRSConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSConfiguration_iE_Extensions__item__id._const_tab = ____PRSConfiguration_iE_Extensions__item__id_tab
    ___PRSConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___PRSConfiguration_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSConfiguration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSConfiguration_iE_Extensions__item__criticality._const_tab = ____PRSConfiguration_iE_Extensions__item__criticality_tab
    ___PRSConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSConfiguration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSConfiguration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSConfiguration_iE_Extensions__item__extensionValue._const_tab = ____PRSConfiguration_iE_Extensions__item__extensionValue_tab
    ___PRSConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSConfiguration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSConfiguration_iE_Extensions__item__id),
        ('criticality', ___PRSConfiguration_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSConfiguration_iE_Extensions__item__extensionValue),
        ])
    __PRSConfiguration_iE_Extensions__item_._ext = None
    _PRSConfiguration_iE_Extensions._cont = __PRSConfiguration_iE_Extensions__item_
    _PRSConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSConfiguration._cont = ASN1Dict([
        ('pRSResourceSet-List', _PRSConfiguration_pRSResourceSet_List),
        ('iE-Extensions', _PRSConfiguration_iE_Extensions),
        ])
    PRSConfiguration._ext = []
    
    #-----< PRSConfiguration-ExtIEs >-----#
    PRSConfiguration_ExtIEs = CLASS(name='PRSConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRSConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRS-ConfigurationIndex-EUTRA >-----#
    PRS_ConfigurationIndex_EUTRA = INT(name='PRS-ConfigurationIndex-EUTRA', mode=MODE_TYPE)
    PRS_ConfigurationIndex_EUTRA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=[], er=[])
    
    #-----< PRS-ID-EUTRA >-----#
    PRS_ID_EUTRA = INT(name='PRS-ID-EUTRA', mode=MODE_TYPE)
    PRS_ID_EUTRA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=[], er=[])
    
    #-----< PRSMutingConfiguration-EUTRA >-----#
    PRSMutingConfiguration_EUTRA = CHOICE(name='PRSMutingConfiguration-EUTRA', mode=MODE_TYPE)
    _PRSMutingConfiguration_EUTRA_two = BIT_STR(name='two', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSMutingConfiguration_EUTRA_two._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _PRSMutingConfiguration_EUTRA_four = BIT_STR(name='four', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSMutingConfiguration_EUTRA_four._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _PRSMutingConfiguration_EUTRA_eight = BIT_STR(name='eight', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSMutingConfiguration_EUTRA_eight._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _PRSMutingConfiguration_EUTRA_sixteen = BIT_STR(name='sixteen', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSMutingConfiguration_EUTRA_sixteen._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _PRSMutingConfiguration_EUTRA_thirty_two = BIT_STR(name='thirty-two', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSMutingConfiguration_EUTRA_thirty_two._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _PRSMutingConfiguration_EUTRA_sixty_four = BIT_STR(name='sixty-four', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSMutingConfiguration_EUTRA_sixty_four._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    _PRSMutingConfiguration_EUTRA_one_hundred_and_twenty_eight = BIT_STR(name='one-hundred-and-twenty-eight', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSMutingConfiguration_EUTRA_one_hundred_and_twenty_eight._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    _PRSMutingConfiguration_EUTRA_two_hundred_and_fifty_six = BIT_STR(name='two-hundred-and-fifty-six', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSMutingConfiguration_EUTRA_two_hundred_and_fifty_six._const_sz = ASN1Set(rv=[256], rr=[], ev=None, er=[])
    _PRSMutingConfiguration_EUTRA_five_hundred_and_twelve = BIT_STR(name='five-hundred-and-twelve', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSMutingConfiguration_EUTRA_five_hundred_and_twelve._const_sz = ASN1Set(rv=[512], rr=[], ev=None, er=[])
    _PRSMutingConfiguration_EUTRA_one_thousand_and_twenty_four = BIT_STR(name='one-thousand-and-twenty-four', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSMutingConfiguration_EUTRA_one_thousand_and_twenty_four._const_sz = ASN1Set(rv=[1024], rr=[], ev=None, er=[])
    _PRSMutingConfiguration_EUTRA_choice_Extension = SEQ(name='choice-Extension', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __PRSMutingConfiguration_EUTRA_choice_Extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___PRSMutingConfiguration_EUTRA_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PRSMutingConfiguration_EUTRA_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PRSMutingConfiguration_EUTRA_choice_Extension_id._const_tab = ___PRSMutingConfiguration_EUTRA_choice_Extension_id_tab
    __PRSMutingConfiguration_EUTRA_choice_Extension_id._const_tab_at = None
    __PRSMutingConfiguration_EUTRA_choice_Extension_id._const_tab_id = 'id'
    __PRSMutingConfiguration_EUTRA_choice_Extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___PRSMutingConfiguration_EUTRA_choice_Extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PRSMutingConfiguration_EUTRA_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PRSMutingConfiguration_EUTRA_choice_Extension_criticality._const_tab = ___PRSMutingConfiguration_EUTRA_choice_Extension_criticality_tab
    __PRSMutingConfiguration_EUTRA_choice_Extension_criticality._const_tab_at = ('..', 'id')
    __PRSMutingConfiguration_EUTRA_choice_Extension_criticality._const_tab_id = 'criticality'
    __PRSMutingConfiguration_EUTRA_choice_Extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___PRSMutingConfiguration_EUTRA_choice_Extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PRSMutingConfiguration_EUTRA_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PRSMutingConfiguration_EUTRA_choice_Extension_value._const_tab = ___PRSMutingConfiguration_EUTRA_choice_Extension_value_tab
    __PRSMutingConfiguration_EUTRA_choice_Extension_value._const_tab_at = ('..', 'id')
    __PRSMutingConfiguration_EUTRA_choice_Extension_value._const_tab_id = 'Value'
    _PRSMutingConfiguration_EUTRA_choice_Extension._cont = ASN1Dict([
        ('id', __PRSMutingConfiguration_EUTRA_choice_Extension_id),
        ('criticality', __PRSMutingConfiguration_EUTRA_choice_Extension_criticality),
        ('value', __PRSMutingConfiguration_EUTRA_choice_Extension_value),
        ])
    _PRSMutingConfiguration_EUTRA_choice_Extension._ext = None
    PRSMutingConfiguration_EUTRA._cont = ASN1Dict([
        ('two', _PRSMutingConfiguration_EUTRA_two),
        ('four', _PRSMutingConfiguration_EUTRA_four),
        ('eight', _PRSMutingConfiguration_EUTRA_eight),
        ('sixteen', _PRSMutingConfiguration_EUTRA_sixteen),
        ('thirty-two', _PRSMutingConfiguration_EUTRA_thirty_two),
        ('sixty-four', _PRSMutingConfiguration_EUTRA_sixty_four),
        ('one-hundred-and-twenty-eight', _PRSMutingConfiguration_EUTRA_one_hundred_and_twenty_eight),
        ('two-hundred-and-fifty-six', _PRSMutingConfiguration_EUTRA_two_hundred_and_fifty_six),
        ('five-hundred-and-twelve', _PRSMutingConfiguration_EUTRA_five_hundred_and_twelve),
        ('one-thousand-and-twenty-four', _PRSMutingConfiguration_EUTRA_one_thousand_and_twenty_four),
        ('choice-Extension', _PRSMutingConfiguration_EUTRA_choice_Extension),
        ])
    PRSMutingConfiguration_EUTRA._ext = None
    
    #-----< PRSMutingConfiguration-EUTRA-ExtensionIE >-----#
    PRSMutingConfiguration_EUTRA_ExtensionIE = CLASS(name='PRSMutingConfiguration-EUTRA-ExtensionIE', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    PRSMutingConfiguration_EUTRA_ExtensionIE._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSOccasionGroup-EUTRA >-----#
    PRSOccasionGroup_EUTRA = ENUM(name='PRSOccasionGroup-EUTRA', mode=MODE_TYPE)
    PRSOccasionGroup_EUTRA._cont = ASN1Dict([('og2', 0), ('og4', 1), ('og8', 2), ('og16', 3), ('og32', 4), ('og64', 5), ('og128', 6)])
    PRSOccasionGroup_EUTRA._ext = []
    
    #-----< PRSFrequencyHoppingConfiguration-EUTRA >-----#
    PRSFrequencyHoppingConfiguration_EUTRA = SEQ(name='PRSFrequencyHoppingConfiguration-EUTRA', mode=MODE_TYPE)
    _PRSFrequencyHoppingConfiguration_EUTRA_noOfFreqHoppingBands = ENUM(name='noOfFreqHoppingBands', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NumberOfFrequencyHoppingBands')))
    _PRSFrequencyHoppingConfiguration_EUTRA_bandPositions = SEQ_OF(name='bandPositions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PRSFrequencyHoppingConfiguration_EUTRA_bandPositions__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'NarrowBandIndex')))
    _PRSFrequencyHoppingConfiguration_EUTRA_bandPositions._cont = __PRSFrequencyHoppingConfiguration_EUTRA_bandPositions__item_
    _PRSFrequencyHoppingConfiguration_EUTRA_bandPositions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    _PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__id._const_tab = ____PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__id_tab
    ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__id._const_tab_at = None
    ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__criticality._const_tab = ____PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__criticality_tab
    ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__extensionValue._const_tab = ____PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__extensionValue_tab
    ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__id),
        ('criticality', ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__extensionValue),
        ])
    __PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item_._ext = None
    _PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions._cont = __PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item_
    _PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSFrequencyHoppingConfiguration_EUTRA._cont = ASN1Dict([
        ('noOfFreqHoppingBands', _PRSFrequencyHoppingConfiguration_EUTRA_noOfFreqHoppingBands),
        ('bandPositions', _PRSFrequencyHoppingConfiguration_EUTRA_bandPositions),
        ('iE-Extensions', _PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions),
        ])
    PRSFrequencyHoppingConfiguration_EUTRA._ext = []
    
    #-----< PRSFrequencyHoppingConfiguration-EUTRA-Item-IEs >-----#
    PRSFrequencyHoppingConfiguration_EUTRA_Item_IEs = CLASS(name='PRSFrequencyHoppingConfiguration-EUTRA-Item-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRSFrequencyHoppingConfiguration_EUTRA_Item_IEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRS-Measurements-Info-List >-----#
    PRS_Measurements_Info_List = SEQ_OF(name='PRS-Measurements-Info-List', mode=MODE_TYPE)
    _PRS_Measurements_Info_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Measurements-Info-List-Item')))
    PRS_Measurements_Info_List._cont = _PRS_Measurements_Info_List__item_
    PRS_Measurements_Info_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< PRS-Measurements-Info-List-Item >-----#
    PRS_Measurements_Info_List_Item = SEQ(name='PRS-Measurements-Info-List-Item', mode=MODE_TYPE)
    _PRS_Measurements_Info_List_Item_pointA = INT(name='pointA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRS_Measurements_Info_List_Item_pointA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _PRS_Measurements_Info_List_Item_measPRSPeriodicity = ENUM(name='measPRSPeriodicity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRS_Measurements_Info_List_Item_measPRSPeriodicity._cont = ASN1Dict([('ms20', 0), ('ms40', 1), ('ms80', 2), ('ms160', 3)])
    _PRS_Measurements_Info_List_Item_measPRSPeriodicity._ext = []
    _PRS_Measurements_Info_List_Item_measPRSOffset = INT(name='measPRSOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRS_Measurements_Info_List_Item_measPRSOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=159)], ev=[], er=[])
    _PRS_Measurements_Info_List_Item_measurementPRSLength = ENUM(name='measurementPRSLength', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRS_Measurements_Info_List_Item_measurementPRSLength._cont = ASN1Dict([('ms1dot5', 0), ('ms3', 1), ('ms3dot5', 2), ('ms4', 3), ('ms5dot5', 4), ('ms6', 5), ('ms10', 6), ('ms20', 7)])
    _PRS_Measurements_Info_List_Item_measurementPRSLength._ext = None
    _PRS_Measurements_Info_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRS_Measurements_Info_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRS_Measurements_Info_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____PRS_Measurements_Info_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRS_Measurements_Info_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRS_Measurements_Info_List_Item_iE_Extensions__item__id._const_tab = ____PRS_Measurements_Info_List_Item_iE_Extensions__item__id_tab
    ___PRS_Measurements_Info_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___PRS_Measurements_Info_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRS_Measurements_Info_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRS_Measurements_Info_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRS_Measurements_Info_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRS_Measurements_Info_List_Item_iE_Extensions__item__criticality._const_tab = ____PRS_Measurements_Info_List_Item_iE_Extensions__item__criticality_tab
    ___PRS_Measurements_Info_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRS_Measurements_Info_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRS_Measurements_Info_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRS_Measurements_Info_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRS_Measurements_Info_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRS_Measurements_Info_List_Item_iE_Extensions__item__extensionValue._const_tab = ____PRS_Measurements_Info_List_Item_iE_Extensions__item__extensionValue_tab
    ___PRS_Measurements_Info_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRS_Measurements_Info_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRS_Measurements_Info_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRS_Measurements_Info_List_Item_iE_Extensions__item__id),
        ('criticality', ___PRS_Measurements_Info_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PRS_Measurements_Info_List_Item_iE_Extensions__item__extensionValue),
        ])
    __PRS_Measurements_Info_List_Item_iE_Extensions__item_._ext = None
    _PRS_Measurements_Info_List_Item_iE_Extensions._cont = __PRS_Measurements_Info_List_Item_iE_Extensions__item_
    _PRS_Measurements_Info_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRS_Measurements_Info_List_Item._cont = ASN1Dict([
        ('pointA', _PRS_Measurements_Info_List_Item_pointA),
        ('measPRSPeriodicity', _PRS_Measurements_Info_List_Item_measPRSPeriodicity),
        ('measPRSOffset', _PRS_Measurements_Info_List_Item_measPRSOffset),
        ('measurementPRSLength', _PRS_Measurements_Info_List_Item_measurementPRSLength),
        ('iE-Extensions', _PRS_Measurements_Info_List_Item_iE_Extensions),
        ])
    PRS_Measurements_Info_List_Item._ext = []
    
    #-----< PRS-Measurements-Info-List-Item-ExtIEs >-----#
    PRS_Measurements_Info_List_Item_ExtIEs = CLASS(name='PRS-Measurements-Info-List-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRS_Measurements_Info_List_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSMuting >-----#
    PRSMuting = SEQ(name='PRSMuting', mode=MODE_TYPE)
    _PRSMuting_pRSMutingOption1 = SEQ(name='pRSMutingOption1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSMutingOption1')), opt=True)
    _PRSMuting_pRSMutingOption2 = SEQ(name='pRSMutingOption2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSMutingOption2')), opt=True)
    _PRSMuting_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSMuting_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSMuting_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____PRSMuting_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSMuting_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMuting_iE_Extensions__item__id._const_tab = ____PRSMuting_iE_Extensions__item__id_tab
    ___PRSMuting_iE_Extensions__item__id._const_tab_at = None
    ___PRSMuting_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSMuting_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSMuting_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSMuting_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMuting_iE_Extensions__item__criticality._const_tab = ____PRSMuting_iE_Extensions__item__criticality_tab
    ___PRSMuting_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSMuting_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSMuting_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSMuting_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSMuting_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMuting_iE_Extensions__item__extensionValue._const_tab = ____PRSMuting_iE_Extensions__item__extensionValue_tab
    ___PRSMuting_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSMuting_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSMuting_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSMuting_iE_Extensions__item__id),
        ('criticality', ___PRSMuting_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSMuting_iE_Extensions__item__extensionValue),
        ])
    __PRSMuting_iE_Extensions__item_._ext = None
    _PRSMuting_iE_Extensions._cont = __PRSMuting_iE_Extensions__item_
    _PRSMuting_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSMuting._cont = ASN1Dict([
        ('pRSMutingOption1', _PRSMuting_pRSMutingOption1),
        ('pRSMutingOption2', _PRSMuting_pRSMutingOption2),
        ('iE-Extensions', _PRSMuting_iE_Extensions),
        ])
    PRSMuting._ext = []
    
    #-----< PRSMuting-ExtIEs >-----#
    PRSMuting_ExtIEs = CLASS(name='PRSMuting-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRSMuting_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSMutingOption1 >-----#
    PRSMutingOption1 = SEQ(name='PRSMutingOption1', mode=MODE_TYPE)
    _PRSMutingOption1_mutingPattern = CHOICE(name='mutingPattern', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'DL-PRSMutingPattern')))
    _PRSMutingOption1_mutingBitRepetitionFactor = ENUM(name='mutingBitRepetitionFactor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSMutingOption1_mutingBitRepetitionFactor._cont = ASN1Dict([('n1', 0), ('n2', 1), ('n4', 2), ('n8', 3)])
    _PRSMutingOption1_mutingBitRepetitionFactor._ext = []
    _PRSMutingOption1_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSMutingOption1_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSMutingOption1_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____PRSMutingOption1_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSMutingOption1_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMutingOption1_iE_Extensions__item__id._const_tab = ____PRSMutingOption1_iE_Extensions__item__id_tab
    ___PRSMutingOption1_iE_Extensions__item__id._const_tab_at = None
    ___PRSMutingOption1_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSMutingOption1_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSMutingOption1_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSMutingOption1_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMutingOption1_iE_Extensions__item__criticality._const_tab = ____PRSMutingOption1_iE_Extensions__item__criticality_tab
    ___PRSMutingOption1_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSMutingOption1_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSMutingOption1_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSMutingOption1_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSMutingOption1_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMutingOption1_iE_Extensions__item__extensionValue._const_tab = ____PRSMutingOption1_iE_Extensions__item__extensionValue_tab
    ___PRSMutingOption1_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSMutingOption1_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSMutingOption1_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSMutingOption1_iE_Extensions__item__id),
        ('criticality', ___PRSMutingOption1_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSMutingOption1_iE_Extensions__item__extensionValue),
        ])
    __PRSMutingOption1_iE_Extensions__item_._ext = None
    _PRSMutingOption1_iE_Extensions._cont = __PRSMutingOption1_iE_Extensions__item_
    _PRSMutingOption1_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSMutingOption1._cont = ASN1Dict([
        ('mutingPattern', _PRSMutingOption1_mutingPattern),
        ('mutingBitRepetitionFactor', _PRSMutingOption1_mutingBitRepetitionFactor),
        ('iE-Extensions', _PRSMutingOption1_iE_Extensions),
        ])
    PRSMutingOption1._ext = []
    
    #-----< PRSMutingOption1-ExtIEs >-----#
    PRSMutingOption1_ExtIEs = CLASS(name='PRSMutingOption1-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRSMutingOption1_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSMutingOption2 >-----#
    PRSMutingOption2 = SEQ(name='PRSMutingOption2', mode=MODE_TYPE)
    _PRSMutingOption2_mutingPattern = CHOICE(name='mutingPattern', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'DL-PRSMutingPattern')))
    _PRSMutingOption2_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSMutingOption2_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSMutingOption2_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____PRSMutingOption2_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSMutingOption2_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMutingOption2_iE_Extensions__item__id._const_tab = ____PRSMutingOption2_iE_Extensions__item__id_tab
    ___PRSMutingOption2_iE_Extensions__item__id._const_tab_at = None
    ___PRSMutingOption2_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSMutingOption2_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSMutingOption2_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSMutingOption2_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMutingOption2_iE_Extensions__item__criticality._const_tab = ____PRSMutingOption2_iE_Extensions__item__criticality_tab
    ___PRSMutingOption2_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSMutingOption2_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSMutingOption2_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSMutingOption2_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSMutingOption2_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSMutingOption2_iE_Extensions__item__extensionValue._const_tab = ____PRSMutingOption2_iE_Extensions__item__extensionValue_tab
    ___PRSMutingOption2_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSMutingOption2_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSMutingOption2_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSMutingOption2_iE_Extensions__item__id),
        ('criticality', ___PRSMutingOption2_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSMutingOption2_iE_Extensions__item__extensionValue),
        ])
    __PRSMutingOption2_iE_Extensions__item_._ext = None
    _PRSMutingOption2_iE_Extensions._cont = __PRSMutingOption2_iE_Extensions__item_
    _PRSMutingOption2_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSMutingOption2._cont = ASN1Dict([
        ('mutingPattern', _PRSMutingOption2_mutingPattern),
        ('iE-Extensions', _PRSMutingOption2_iE_Extensions),
        ])
    PRSMutingOption2._ext = []
    
    #-----< PRSMutingOption2-ExtIEs >-----#
    PRSMutingOption2_ExtIEs = CLASS(name='PRSMutingOption2-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRSMutingOption2_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSResource-List >-----#
    PRSResource_List = SEQ_OF(name='PRSResource-List', mode=MODE_TYPE)
    _PRSResource_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PRSResource-Item')))
    PRSResource_List._cont = _PRSResource_List__item_
    PRSResource_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< PRSResource-Item >-----#
    PRSResource_Item = SEQ(name='PRSResource-Item', mode=MODE_TYPE)
    _PRSResource_Item_pRSResourceID = INT(name='pRSResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-ID')))
    _PRSResource_Item_sequenceID = INT(name='sequenceID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResource_Item_sequenceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _PRSResource_Item_rEOffset = INT(name='rEOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResource_Item_rEOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=11)], ev=[], er=[])
    _PRSResource_Item_resourceSlotOffset = INT(name='resourceSlotOffset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResource_Item_resourceSlotOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    _PRSResource_Item_resourceSymbolOffset = INT(name='resourceSymbolOffset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResource_Item_resourceSymbolOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=12)], ev=None, er=[])
    _PRSResource_Item_qCLInfo = CHOICE(name='qCLInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSResource-QCLInfo')), opt=True)
    _PRSResource_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSResource_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSResource_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____PRSResource_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSResource_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_Item_iE_Extensions__item__id._const_tab = ____PRSResource_Item_iE_Extensions__item__id_tab
    ___PRSResource_Item_iE_Extensions__item__id._const_tab_at = None
    ___PRSResource_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSResource_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSResource_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSResource_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_Item_iE_Extensions__item__criticality._const_tab = ____PRSResource_Item_iE_Extensions__item__criticality_tab
    ___PRSResource_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSResource_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSResource_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSResource_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSResource_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_Item_iE_Extensions__item__extensionValue._const_tab = ____PRSResource_Item_iE_Extensions__item__extensionValue_tab
    ___PRSResource_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSResource_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSResource_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSResource_Item_iE_Extensions__item__id),
        ('criticality', ___PRSResource_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSResource_Item_iE_Extensions__item__extensionValue),
        ])
    __PRSResource_Item_iE_Extensions__item_._ext = None
    _PRSResource_Item_iE_Extensions._cont = __PRSResource_Item_iE_Extensions__item_
    _PRSResource_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSResource_Item._cont = ASN1Dict([
        ('pRSResourceID', _PRSResource_Item_pRSResourceID),
        ('sequenceID', _PRSResource_Item_sequenceID),
        ('rEOffset', _PRSResource_Item_rEOffset),
        ('resourceSlotOffset', _PRSResource_Item_resourceSlotOffset),
        ('resourceSymbolOffset', _PRSResource_Item_resourceSymbolOffset),
        ('qCLInfo', _PRSResource_Item_qCLInfo),
        ('iE-Extensions', _PRSResource_Item_iE_Extensions),
        ])
    PRSResource_Item._ext = []
    
    #-----< PRSResource-Item-ExtIEs >-----#
    PRSResource_Item_ExtIEs = CLASS(name='PRSResource-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRSResource_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSResource-QCLInfo >-----#
    PRSResource_QCLInfo = CHOICE(name='PRSResource-QCLInfo', mode=MODE_TYPE)
    _PRSResource_QCLInfo_qCLSourceSSB = SEQ(name='qCLSourceSSB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSResource-QCLSourceSSB')))
    _PRSResource_QCLInfo_qCLSourcePRS = SEQ(name='qCLSourcePRS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSResource-QCLSourcePRS')))
    _PRSResource_QCLInfo_choice_Extension = SEQ(name='choice-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __PRSResource_QCLInfo_choice_Extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___PRSResource_QCLInfo_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PRSResource_QCLInfo_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PRSResource_QCLInfo_choice_Extension_id._const_tab = ___PRSResource_QCLInfo_choice_Extension_id_tab
    __PRSResource_QCLInfo_choice_Extension_id._const_tab_at = None
    __PRSResource_QCLInfo_choice_Extension_id._const_tab_id = 'id'
    __PRSResource_QCLInfo_choice_Extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___PRSResource_QCLInfo_choice_Extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PRSResource_QCLInfo_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PRSResource_QCLInfo_choice_Extension_criticality._const_tab = ___PRSResource_QCLInfo_choice_Extension_criticality_tab
    __PRSResource_QCLInfo_choice_Extension_criticality._const_tab_at = ('..', 'id')
    __PRSResource_QCLInfo_choice_Extension_criticality._const_tab_id = 'criticality'
    __PRSResource_QCLInfo_choice_Extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___PRSResource_QCLInfo_choice_Extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PRSResource_QCLInfo_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PRSResource_QCLInfo_choice_Extension_value._const_tab = ___PRSResource_QCLInfo_choice_Extension_value_tab
    __PRSResource_QCLInfo_choice_Extension_value._const_tab_at = ('..', 'id')
    __PRSResource_QCLInfo_choice_Extension_value._const_tab_id = 'Value'
    _PRSResource_QCLInfo_choice_Extension._cont = ASN1Dict([
        ('id', __PRSResource_QCLInfo_choice_Extension_id),
        ('criticality', __PRSResource_QCLInfo_choice_Extension_criticality),
        ('value', __PRSResource_QCLInfo_choice_Extension_value),
        ])
    _PRSResource_QCLInfo_choice_Extension._ext = None
    PRSResource_QCLInfo._cont = ASN1Dict([
        ('qCLSourceSSB', _PRSResource_QCLInfo_qCLSourceSSB),
        ('qCLSourcePRS', _PRSResource_QCLInfo_qCLSourcePRS),
        ('choice-Extension', _PRSResource_QCLInfo_choice_Extension),
        ])
    PRSResource_QCLInfo._ext = None
    
    #-----< PRSResource-QCLInfo-ExtIEs >-----#
    PRSResource_QCLInfo_ExtIEs = CLASS(name='PRSResource-QCLInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    PRSResource_QCLInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSResource-QCLSourceSSB >-----#
    PRSResource_QCLSourceSSB = SEQ(name='PRSResource-QCLSourceSSB', mode=MODE_TYPE)
    _PRSResource_QCLSourceSSB_pCI_NR = INT(name='pCI-NR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResource_QCLSourceSSB_pCI_NR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1007)], ev=None, er=[])
    _PRSResource_QCLSourceSSB_sSB_Index = INT(name='sSB-Index', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SSB-Index')), opt=True)
    _PRSResource_QCLSourceSSB_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSResource_QCLSourceSSB_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____PRSResource_QCLSourceSSB_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSResource_QCLSourceSSB_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__id._const_tab = ____PRSResource_QCLSourceSSB_iE_Extensions__item__id_tab
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__id._const_tab_at = None
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSResource_QCLSourceSSB_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSResource_QCLSourceSSB_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__criticality._const_tab = ____PRSResource_QCLSourceSSB_iE_Extensions__item__criticality_tab
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue._const_tab = ____PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue_tab
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSResource_QCLSourceSSB_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSResource_QCLSourceSSB_iE_Extensions__item__id),
        ('criticality', ___PRSResource_QCLSourceSSB_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue),
        ])
    __PRSResource_QCLSourceSSB_iE_Extensions__item_._ext = None
    _PRSResource_QCLSourceSSB_iE_Extensions._cont = __PRSResource_QCLSourceSSB_iE_Extensions__item_
    _PRSResource_QCLSourceSSB_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSResource_QCLSourceSSB._cont = ASN1Dict([
        ('pCI-NR', _PRSResource_QCLSourceSSB_pCI_NR),
        ('sSB-Index', _PRSResource_QCLSourceSSB_sSB_Index),
        ('iE-Extensions', _PRSResource_QCLSourceSSB_iE_Extensions),
        ])
    PRSResource_QCLSourceSSB._ext = []
    
    #-----< PRSResource-QCLSourceSSB-ExtIEs >-----#
    PRSResource_QCLSourceSSB_ExtIEs = CLASS(name='PRSResource-QCLSourceSSB-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRSResource_QCLSourceSSB_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSResource-QCLSourcePRS >-----#
    PRSResource_QCLSourcePRS = SEQ(name='PRSResource-QCLSourcePRS', mode=MODE_TYPE)
    _PRSResource_QCLSourcePRS_qCLSourcePRSResourceSetID = INT(name='qCLSourcePRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-Set-ID')))
    _PRSResource_QCLSourcePRS_qCLSourcePRSResourceID = INT(name='qCLSourcePRSResourceID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-ID')), opt=True)
    _PRSResource_QCLSourcePRS_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSResource_QCLSourcePRS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____PRSResource_QCLSourcePRS_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSResource_QCLSourcePRS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__id._const_tab = ____PRSResource_QCLSourcePRS_iE_Extensions__item__id_tab
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__id._const_tab_at = None
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSResource_QCLSourcePRS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSResource_QCLSourcePRS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__criticality._const_tab = ____PRSResource_QCLSourcePRS_iE_Extensions__item__criticality_tab
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue._const_tab = ____PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue_tab
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSResource_QCLSourcePRS_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSResource_QCLSourcePRS_iE_Extensions__item__id),
        ('criticality', ___PRSResource_QCLSourcePRS_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue),
        ])
    __PRSResource_QCLSourcePRS_iE_Extensions__item_._ext = None
    _PRSResource_QCLSourcePRS_iE_Extensions._cont = __PRSResource_QCLSourcePRS_iE_Extensions__item_
    _PRSResource_QCLSourcePRS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSResource_QCLSourcePRS._cont = ASN1Dict([
        ('qCLSourcePRSResourceSetID', _PRSResource_QCLSourcePRS_qCLSourcePRSResourceSetID),
        ('qCLSourcePRSResourceID', _PRSResource_QCLSourcePRS_qCLSourcePRSResourceID),
        ('iE-Extensions', _PRSResource_QCLSourcePRS_iE_Extensions),
        ])
    PRSResource_QCLSourcePRS._ext = []
    
    #-----< PRSResource-QCLSourcePRS-ExtIEs >-----#
    PRSResource_QCLSourcePRS_ExtIEs = CLASS(name='PRSResource-QCLSourcePRS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRSResource_QCLSourcePRS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSResourceSet-List >-----#
    PRSResourceSet_List = SEQ_OF(name='PRSResourceSet-List', mode=MODE_TYPE)
    _PRSResourceSet_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PRSResourceSet-Item')))
    PRSResourceSet_List._cont = _PRSResourceSet_List__item_
    PRSResourceSet_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< PRSResourceSet-Item >-----#
    PRSResourceSet_Item = SEQ(name='PRSResourceSet-Item', mode=MODE_TYPE)
    _PRSResourceSet_Item_pRSResourceSetID = INT(name='pRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-Set-ID')))
    _PRSResourceSet_Item_subcarrierSpacing = ENUM(name='subcarrierSpacing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_subcarrierSpacing._cont = ASN1Dict([('kHz15', 0), ('kHz30', 1), ('kHz60', 2), ('kHz120', 3)])
    _PRSResourceSet_Item_subcarrierSpacing._ext = []
    _PRSResourceSet_Item_pRSbandwidth = INT(name='pRSbandwidth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_pRSbandwidth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _PRSResourceSet_Item_startPRB = INT(name='startPRB', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_startPRB._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2176)], ev=None, er=[])
    _PRSResourceSet_Item_pointA = INT(name='pointA', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_pointA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _PRSResourceSet_Item_combSize = ENUM(name='combSize', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_combSize._cont = ASN1Dict([('n2', 0), ('n4', 1), ('n6', 2), ('n12', 3)])
    _PRSResourceSet_Item_combSize._ext = []
    _PRSResourceSet_Item_cPType = ENUM(name='cPType', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_cPType._cont = ASN1Dict([('normal', 0), ('extended', 1)])
    _PRSResourceSet_Item_cPType._ext = []
    _PRSResourceSet_Item_resourceSetPeriodicity = ENUM(name='resourceSetPeriodicity', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_resourceSetPeriodicity._cont = ASN1Dict([('n4', 0), ('n5', 1), ('n8', 2), ('n10', 3), ('n16', 4), ('n20', 5), ('n32', 6), ('n40', 7), ('n64', 8), ('n80', 9), ('n160', 10), ('n320', 11), ('n640', 12), ('n1280', 13), ('n2560', 14), ('n5120', 15), ('n10240', 16), ('n20480', 17), ('n40960', 18), ('n81920', 19)])
    _PRSResourceSet_Item_resourceSetPeriodicity._ext = []
    _PRSResourceSet_Item_resourceSetSlotOffset = INT(name='resourceSetSlotOffset', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_resourceSetSlotOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=81919)], ev=[], er=[])
    _PRSResourceSet_Item_resourceRepetitionFactor = ENUM(name='resourceRepetitionFactor', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_resourceRepetitionFactor._cont = ASN1Dict([('rf1', 0), ('rf2', 1), ('rf4', 2), ('rf6', 3), ('rf8', 4), ('rf16', 5), ('rf32', 6)])
    _PRSResourceSet_Item_resourceRepetitionFactor._ext = []
    _PRSResourceSet_Item_resourceTimeGap = ENUM(name='resourceTimeGap', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_resourceTimeGap._cont = ASN1Dict([('tg1', 0), ('tg2', 1), ('tg4', 2), ('tg8', 3), ('tg16', 4), ('tg32', 5)])
    _PRSResourceSet_Item_resourceTimeGap._ext = []
    _PRSResourceSet_Item_resourceNumberofSymbols = ENUM(name='resourceNumberofSymbols', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_resourceNumberofSymbols._cont = ASN1Dict([('n2', 0), ('n4', 1), ('n6', 2), ('n12', 3)])
    _PRSResourceSet_Item_resourceNumberofSymbols._ext = []
    _PRSResourceSet_Item_pRSMuting = SEQ(name='pRSMuting', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSMuting')), opt=True)
    _PRSResourceSet_Item_pRSResourceTransmitPower = INT(name='pRSResourceTransmitPower', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSResourceSet_Item_pRSResourceTransmitPower._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-60, ub=50)], ev=None, er=[])
    _PRSResourceSet_Item_pRSResource_List = SEQ_OF(name='pRSResource-List', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSResource-List')))
    _PRSResourceSet_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSResourceSet_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSResourceSet_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____PRSResourceSet_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSResourceSet_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResourceSet_Item_iE_Extensions__item__id._const_tab = ____PRSResourceSet_Item_iE_Extensions__item__id_tab
    ___PRSResourceSet_Item_iE_Extensions__item__id._const_tab_at = None
    ___PRSResourceSet_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSResourceSet_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSResourceSet_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSResourceSet_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResourceSet_Item_iE_Extensions__item__criticality._const_tab = ____PRSResourceSet_Item_iE_Extensions__item__criticality_tab
    ___PRSResourceSet_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSResourceSet_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSResourceSet_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSResourceSet_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSResourceSet_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab = ____PRSResourceSet_Item_iE_Extensions__item__extensionValue_tab
    ___PRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSResourceSet_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSResourceSet_Item_iE_Extensions__item__id),
        ('criticality', ___PRSResourceSet_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSResourceSet_Item_iE_Extensions__item__extensionValue),
        ])
    __PRSResourceSet_Item_iE_Extensions__item_._ext = None
    _PRSResourceSet_Item_iE_Extensions._cont = __PRSResourceSet_Item_iE_Extensions__item_
    _PRSResourceSet_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSResourceSet_Item._cont = ASN1Dict([
        ('pRSResourceSetID', _PRSResourceSet_Item_pRSResourceSetID),
        ('subcarrierSpacing', _PRSResourceSet_Item_subcarrierSpacing),
        ('pRSbandwidth', _PRSResourceSet_Item_pRSbandwidth),
        ('startPRB', _PRSResourceSet_Item_startPRB),
        ('pointA', _PRSResourceSet_Item_pointA),
        ('combSize', _PRSResourceSet_Item_combSize),
        ('cPType', _PRSResourceSet_Item_cPType),
        ('resourceSetPeriodicity', _PRSResourceSet_Item_resourceSetPeriodicity),
        ('resourceSetSlotOffset', _PRSResourceSet_Item_resourceSetSlotOffset),
        ('resourceRepetitionFactor', _PRSResourceSet_Item_resourceRepetitionFactor),
        ('resourceTimeGap', _PRSResourceSet_Item_resourceTimeGap),
        ('resourceNumberofSymbols', _PRSResourceSet_Item_resourceNumberofSymbols),
        ('pRSMuting', _PRSResourceSet_Item_pRSMuting),
        ('pRSResourceTransmitPower', _PRSResourceSet_Item_pRSResourceTransmitPower),
        ('pRSResource-List', _PRSResourceSet_Item_pRSResource_List),
        ('iE-Extensions', _PRSResourceSet_Item_iE_Extensions),
        ])
    PRSResourceSet_Item._ext = []
    
    #-----< PRSResourceSet-Item-ExtIEs >-----#
    PRSResourceSet_Item_ExtIEs = CLASS(name='PRSResourceSet-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRSResourceSet_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRS-Resource-ID >-----#
    PRS_Resource_ID = INT(name='PRS-Resource-ID', mode=MODE_TYPE)
    PRS_Resource_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< PRS-Resource-Set-ID >-----#
    PRS_Resource_Set_ID = INT(name='PRS-Resource-Set-ID', mode=MODE_TYPE)
    PRS_Resource_Set_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< PRS-ID >-----#
    PRS_ID = INT(name='PRS-ID', mode=MODE_TYPE)
    PRS_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< PRSTransmissionOffIndication >-----#
    PRSTransmissionOffIndication = CHOICE(name='PRSTransmissionOffIndication', mode=MODE_TYPE)
    _PRSTransmissionOffIndication_pRSTransmissionOffPerTRP = NULL(name='pRSTransmissionOffPerTRP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PRSTransmissionOffIndication_pRSTransmissionOffPerResourceSet = SEQ_OF(name='pRSTransmissionOffPerResourceSet', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSTransmissionOffPerResourceSet')))
    _PRSTransmissionOffIndication_pRSTransmissionOffPerResource = SEQ_OF(name='pRSTransmissionOffPerResource', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSTransmissionOffPerResource')))
    _PRSTransmissionOffIndication_choice_Extension = SEQ(name='choice-Extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __PRSTransmissionOffIndication_choice_Extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___PRSTransmissionOffIndication_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PRSTransmissionOffIndication_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PRSTransmissionOffIndication_choice_Extension_id._const_tab = ___PRSTransmissionOffIndication_choice_Extension_id_tab
    __PRSTransmissionOffIndication_choice_Extension_id._const_tab_at = None
    __PRSTransmissionOffIndication_choice_Extension_id._const_tab_id = 'id'
    __PRSTransmissionOffIndication_choice_Extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___PRSTransmissionOffIndication_choice_Extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PRSTransmissionOffIndication_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PRSTransmissionOffIndication_choice_Extension_criticality._const_tab = ___PRSTransmissionOffIndication_choice_Extension_criticality_tab
    __PRSTransmissionOffIndication_choice_Extension_criticality._const_tab_at = ('..', 'id')
    __PRSTransmissionOffIndication_choice_Extension_criticality._const_tab_id = 'criticality'
    __PRSTransmissionOffIndication_choice_Extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___PRSTransmissionOffIndication_choice_Extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___PRSTransmissionOffIndication_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __PRSTransmissionOffIndication_choice_Extension_value._const_tab = ___PRSTransmissionOffIndication_choice_Extension_value_tab
    __PRSTransmissionOffIndication_choice_Extension_value._const_tab_at = ('..', 'id')
    __PRSTransmissionOffIndication_choice_Extension_value._const_tab_id = 'Value'
    _PRSTransmissionOffIndication_choice_Extension._cont = ASN1Dict([
        ('id', __PRSTransmissionOffIndication_choice_Extension_id),
        ('criticality', __PRSTransmissionOffIndication_choice_Extension_criticality),
        ('value', __PRSTransmissionOffIndication_choice_Extension_value),
        ])
    _PRSTransmissionOffIndication_choice_Extension._ext = None
    PRSTransmissionOffIndication._cont = ASN1Dict([
        ('pRSTransmissionOffPerTRP', _PRSTransmissionOffIndication_pRSTransmissionOffPerTRP),
        ('pRSTransmissionOffPerResourceSet', _PRSTransmissionOffIndication_pRSTransmissionOffPerResourceSet),
        ('pRSTransmissionOffPerResource', _PRSTransmissionOffIndication_pRSTransmissionOffPerResource),
        ('choice-Extension', _PRSTransmissionOffIndication_choice_Extension),
        ])
    PRSTransmissionOffIndication._ext = None
    
    #-----< PRSTransmissionOffIndication-ExtIEs >-----#
    PRSTransmissionOffIndication_ExtIEs = CLASS(name='PRSTransmissionOffIndication-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    PRSTransmissionOffIndication_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSTransmissionOffPerResource >-----#
    PRSTransmissionOffPerResource = SEQ_OF(name='PRSTransmissionOffPerResource', mode=MODE_TYPE)
    _PRSTransmissionOffPerResource__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PRSTransmissionOffPerResource-Item')))
    PRSTransmissionOffPerResource._cont = _PRSTransmissionOffPerResource__item_
    PRSTransmissionOffPerResource._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< PRSTransmissionOffPerResource-Item >-----#
    PRSTransmissionOffPerResource_Item = SEQ(name='PRSTransmissionOffPerResource-Item', mode=MODE_TYPE)
    _PRSTransmissionOffPerResource_Item_pRSResourceSetID = INT(name='pRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-Set-ID')))
    _PRSTransmissionOffPerResource_Item_pRSTransmissionOffIndicationPerResourceList = SEQ_OF(name='pRSTransmissionOffIndicationPerResourceList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PRSTransmissionOffPerResource_Item_pRSTransmissionOffIndicationPerResourceList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PRSTransmissionOffIndicationPerResource-Item')))
    _PRSTransmissionOffPerResource_Item_pRSTransmissionOffIndicationPerResourceList._cont = __PRSTransmissionOffPerResource_Item_pRSTransmissionOffIndicationPerResourceList__item_
    _PRSTransmissionOffPerResource_Item_pRSTransmissionOffIndicationPerResourceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _PRSTransmissionOffPerResource_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSTransmissionOffPerResource_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____PRSTransmissionOffPerResource_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSTransmissionOffPerResource_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__id._const_tab = ____PRSTransmissionOffPerResource_Item_iE_Extensions__item__id_tab
    ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__id._const_tab_at = None
    ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSTransmissionOffPerResource_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSTransmissionOffPerResource_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__criticality._const_tab = ____PRSTransmissionOffPerResource_Item_iE_Extensions__item__criticality_tab
    ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSTransmissionOffPerResource_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSTransmissionOffPerResource_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__extensionValue._const_tab = ____PRSTransmissionOffPerResource_Item_iE_Extensions__item__extensionValue_tab
    ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSTransmissionOffPerResource_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__id),
        ('criticality', ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__extensionValue),
        ])
    __PRSTransmissionOffPerResource_Item_iE_Extensions__item_._ext = None
    _PRSTransmissionOffPerResource_Item_iE_Extensions._cont = __PRSTransmissionOffPerResource_Item_iE_Extensions__item_
    _PRSTransmissionOffPerResource_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSTransmissionOffPerResource_Item._cont = ASN1Dict([
        ('pRSResourceSetID', _PRSTransmissionOffPerResource_Item_pRSResourceSetID),
        ('pRSTransmissionOffIndicationPerResourceList', _PRSTransmissionOffPerResource_Item_pRSTransmissionOffIndicationPerResourceList),
        ('iE-Extensions', _PRSTransmissionOffPerResource_Item_iE_Extensions),
        ])
    PRSTransmissionOffPerResource_Item._ext = []
    
    #-----< PRSTransmissionOffPerResource-Item-ExtIEs >-----#
    PRSTransmissionOffPerResource_Item_ExtIEs = CLASS(name='PRSTransmissionOffPerResource-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRSTransmissionOffPerResource_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSTransmissionOffIndicationPerResource-Item >-----#
    PRSTransmissionOffIndicationPerResource_Item = SEQ(name='PRSTransmissionOffIndicationPerResource-Item', mode=MODE_TYPE)
    _PRSTransmissionOffIndicationPerResource_Item_pRSResourceID = INT(name='pRSResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-ID')))
    _PRSTransmissionOffIndicationPerResource_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__id._const_tab = ____PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__id_tab
    ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__id._const_tab_at = None
    ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__criticality._const_tab = ____PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__criticality_tab
    ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__extensionValue._const_tab = ____PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__extensionValue_tab
    ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__id),
        ('criticality', ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__extensionValue),
        ])
    __PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item_._ext = None
    _PRSTransmissionOffIndicationPerResource_Item_iE_Extensions._cont = __PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item_
    _PRSTransmissionOffIndicationPerResource_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSTransmissionOffIndicationPerResource_Item._cont = ASN1Dict([
        ('pRSResourceID', _PRSTransmissionOffIndicationPerResource_Item_pRSResourceID),
        ('iE-Extensions', _PRSTransmissionOffIndicationPerResource_Item_iE_Extensions),
        ])
    PRSTransmissionOffIndicationPerResource_Item._ext = []
    
    #-----< PRSTransmissionOffIndicationPerResource-Item-ExtIEs >-----#
    PRSTransmissionOffIndicationPerResource_Item_ExtIEs = CLASS(name='PRSTransmissionOffIndicationPerResource-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRSTransmissionOffIndicationPerResource_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSTransmissionOffInformation >-----#
    PRSTransmissionOffInformation = SEQ(name='PRSTransmissionOffInformation', mode=MODE_TYPE)
    _PRSTransmissionOffInformation_pRSTransmissionOffIndication = CHOICE(name='pRSTransmissionOffIndication', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSTransmissionOffIndication')))
    _PRSTransmissionOffInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSTransmissionOffInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSTransmissionOffInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____PRSTransmissionOffInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSTransmissionOffInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionOffInformation_iE_Extensions__item__id._const_tab = ____PRSTransmissionOffInformation_iE_Extensions__item__id_tab
    ___PRSTransmissionOffInformation_iE_Extensions__item__id._const_tab_at = None
    ___PRSTransmissionOffInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSTransmissionOffInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSTransmissionOffInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSTransmissionOffInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionOffInformation_iE_Extensions__item__criticality._const_tab = ____PRSTransmissionOffInformation_iE_Extensions__item__criticality_tab
    ___PRSTransmissionOffInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSTransmissionOffInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSTransmissionOffInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSTransmissionOffInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSTransmissionOffInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionOffInformation_iE_Extensions__item__extensionValue._const_tab = ____PRSTransmissionOffInformation_iE_Extensions__item__extensionValue_tab
    ___PRSTransmissionOffInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSTransmissionOffInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSTransmissionOffInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSTransmissionOffInformation_iE_Extensions__item__id),
        ('criticality', ___PRSTransmissionOffInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSTransmissionOffInformation_iE_Extensions__item__extensionValue),
        ])
    __PRSTransmissionOffInformation_iE_Extensions__item_._ext = None
    _PRSTransmissionOffInformation_iE_Extensions._cont = __PRSTransmissionOffInformation_iE_Extensions__item_
    _PRSTransmissionOffInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSTransmissionOffInformation._cont = ASN1Dict([
        ('pRSTransmissionOffIndication', _PRSTransmissionOffInformation_pRSTransmissionOffIndication),
        ('iE-Extensions', _PRSTransmissionOffInformation_iE_Extensions),
        ])
    PRSTransmissionOffInformation._ext = []
    
    #-----< PRSTransmissionOffInformation-ExtIEs >-----#
    PRSTransmissionOffInformation_ExtIEs = CLASS(name='PRSTransmissionOffInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRSTransmissionOffInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSTransmissionOffPerResourceSet >-----#
    PRSTransmissionOffPerResourceSet = SEQ_OF(name='PRSTransmissionOffPerResourceSet', mode=MODE_TYPE)
    _PRSTransmissionOffPerResourceSet__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PRSTransmissionOffPerResourceSet-Item')))
    PRSTransmissionOffPerResourceSet._cont = _PRSTransmissionOffPerResourceSet__item_
    PRSTransmissionOffPerResourceSet._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< PRSTransmissionOffPerResourceSet-Item >-----#
    PRSTransmissionOffPerResourceSet_Item = SEQ(name='PRSTransmissionOffPerResourceSet-Item', mode=MODE_TYPE)
    _PRSTransmissionOffPerResourceSet_Item_pRSResourceSetID = INT(name='pRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-Set-ID')))
    _PRSTransmissionOffPerResourceSet_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__id._const_tab = ____PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__id_tab
    ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__id._const_tab_at = None
    ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__criticality._const_tab = ____PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__criticality_tab
    ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__extensionValue._const_tab = ____PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__extensionValue_tab
    ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__id),
        ('criticality', ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__extensionValue),
        ])
    __PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item_._ext = None
    _PRSTransmissionOffPerResourceSet_Item_iE_Extensions._cont = __PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item_
    _PRSTransmissionOffPerResourceSet_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSTransmissionOffPerResourceSet_Item._cont = ASN1Dict([
        ('pRSResourceSetID', _PRSTransmissionOffPerResourceSet_Item_pRSResourceSetID),
        ('iE-Extensions', _PRSTransmissionOffPerResourceSet_Item_iE_Extensions),
        ])
    PRSTransmissionOffPerResourceSet_Item._ext = []
    
    #-----< PRSTransmissionOffPerResourceSet-Item-ExtIEs >-----#
    PRSTransmissionOffPerResourceSet_Item_ExtIEs = CLASS(name='PRSTransmissionOffPerResourceSet-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRSTransmissionOffPerResourceSet_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSTRPList >-----#
    PRSTRPList = SEQ_OF(name='PRSTRPList', mode=MODE_TYPE)
    _PRSTRPList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PRSTRPItem')))
    PRSTRPList._cont = _PRSTRPList__item_
    PRSTRPList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< PRSTRPItem >-----#
    PRSTRPItem = SEQ(name='PRSTRPItem', mode=MODE_TYPE)
    _PRSTRPItem_tRP_ID = INT(name='tRP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRP-ID')))
    _PRSTRPItem_requestedDLPRSTransmissionCharacteristics = SEQ(name='requestedDLPRSTransmissionCharacteristics', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RequestedDLPRSTransmissionCharacteristics')), opt=True)
    _PRSTRPItem_pRSTransmissionOffInformation = SEQ(name='pRSTransmissionOffInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSTransmissionOffInformation')), opt=True)
    _PRSTRPItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSTRPItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSTRPItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____PRSTRPItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSTRPItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTRPItem_iE_Extensions__item__id._const_tab = ____PRSTRPItem_iE_Extensions__item__id_tab
    ___PRSTRPItem_iE_Extensions__item__id._const_tab_at = None
    ___PRSTRPItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSTRPItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSTRPItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSTRPItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTRPItem_iE_Extensions__item__criticality._const_tab = ____PRSTRPItem_iE_Extensions__item__criticality_tab
    ___PRSTRPItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSTRPItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSTRPItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSTRPItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSTRPItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTRPItem_iE_Extensions__item__extensionValue._const_tab = ____PRSTRPItem_iE_Extensions__item__extensionValue_tab
    ___PRSTRPItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSTRPItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSTRPItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSTRPItem_iE_Extensions__item__id),
        ('criticality', ___PRSTRPItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSTRPItem_iE_Extensions__item__extensionValue),
        ])
    __PRSTRPItem_iE_Extensions__item_._ext = None
    _PRSTRPItem_iE_Extensions._cont = __PRSTRPItem_iE_Extensions__item_
    _PRSTRPItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSTRPItem._cont = ASN1Dict([
        ('tRP-ID', _PRSTRPItem_tRP_ID),
        ('requestedDLPRSTransmissionCharacteristics', _PRSTRPItem_requestedDLPRSTransmissionCharacteristics),
        ('pRSTransmissionOffInformation', _PRSTRPItem_pRSTransmissionOffInformation),
        ('iE-Extensions', _PRSTRPItem_iE_Extensions),
        ])
    PRSTRPItem._ext = []
    
    #-----< PRSTRPItem-ExtIEs >-----#
    PRSTRPItem_ExtIEs = CLASS(name='PRSTRPItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRSTRPItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRSTransmissionTRPList >-----#
    PRSTransmissionTRPList = SEQ_OF(name='PRSTransmissionTRPList', mode=MODE_TYPE)
    _PRSTransmissionTRPList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PRSTransmissionTRPItem')))
    PRSTransmissionTRPList._cont = _PRSTransmissionTRPList__item_
    PRSTransmissionTRPList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< PRSTransmissionTRPItem >-----#
    PRSTransmissionTRPItem = SEQ(name='PRSTransmissionTRPItem', mode=MODE_TYPE)
    _PRSTransmissionTRPItem_tRP_ID = INT(name='tRP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRP-ID')))
    _PRSTransmissionTRPItem_pRSConfiguration = SEQ(name='pRSConfiguration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSConfiguration')))
    _PRSTransmissionTRPItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRSTransmissionTRPItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___PRSTransmissionTRPItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____PRSTransmissionTRPItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSTransmissionTRPItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionTRPItem_iE_Extensions__item__id._const_tab = ____PRSTransmissionTRPItem_iE_Extensions__item__id_tab
    ___PRSTransmissionTRPItem_iE_Extensions__item__id._const_tab_at = None
    ___PRSTransmissionTRPItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRSTransmissionTRPItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRSTransmissionTRPItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSTransmissionTRPItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionTRPItem_iE_Extensions__item__criticality._const_tab = ____PRSTransmissionTRPItem_iE_Extensions__item__criticality_tab
    ___PRSTransmissionTRPItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRSTransmissionTRPItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRSTransmissionTRPItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRSTransmissionTRPItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____PRSTransmissionTRPItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRSTransmissionTRPItem_iE_Extensions__item__extensionValue._const_tab = ____PRSTransmissionTRPItem_iE_Extensions__item__extensionValue_tab
    ___PRSTransmissionTRPItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRSTransmissionTRPItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRSTransmissionTRPItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRSTransmissionTRPItem_iE_Extensions__item__id),
        ('criticality', ___PRSTransmissionTRPItem_iE_Extensions__item__criticality),
        ('extensionValue', ___PRSTransmissionTRPItem_iE_Extensions__item__extensionValue),
        ])
    __PRSTransmissionTRPItem_iE_Extensions__item_._ext = None
    _PRSTransmissionTRPItem_iE_Extensions._cont = __PRSTransmissionTRPItem_iE_Extensions__item_
    _PRSTransmissionTRPItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRSTransmissionTRPItem._cont = ASN1Dict([
        ('tRP-ID', _PRSTransmissionTRPItem_tRP_ID),
        ('pRSConfiguration', _PRSTransmissionTRPItem_pRSConfiguration),
        ('iE-Extensions', _PRSTransmissionTRPItem_iE_Extensions),
        ])
    PRSTransmissionTRPItem._ext = []
    
    #-----< PRSTransmissionTRPItem-ExtIEs >-----#
    PRSTransmissionTRPItem_ExtIEs = CLASS(name='PRSTransmissionTRPItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    PRSTransmissionTRPItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ReferenceSignal >-----#
    ReferenceSignal = CHOICE(name='ReferenceSignal', mode=MODE_TYPE)
    _ReferenceSignal_nZP_CSI_RS = INT(name='nZP-CSI-RS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NZP-CSI-RS-ResourceID')))
    _ReferenceSignal_sSB = SEQ(name='sSB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SSB')))
    _ReferenceSignal_sRS = INT(name='sRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSResourceID')))
    _ReferenceSignal_positioningSRS = INT(name='positioningSRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSPosResourceID')))
    _ReferenceSignal_dL_PRS = SEQ(name='dL-PRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'DL-PRS')))
    _ReferenceSignal_choice_Extension = SEQ(name='choice-Extension', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __ReferenceSignal_choice_Extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___ReferenceSignal_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ReferenceSignal_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReferenceSignal_choice_Extension_id._const_tab = ___ReferenceSignal_choice_Extension_id_tab
    __ReferenceSignal_choice_Extension_id._const_tab_at = None
    __ReferenceSignal_choice_Extension_id._const_tab_id = 'id'
    __ReferenceSignal_choice_Extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___ReferenceSignal_choice_Extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ReferenceSignal_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReferenceSignal_choice_Extension_criticality._const_tab = ___ReferenceSignal_choice_Extension_criticality_tab
    __ReferenceSignal_choice_Extension_criticality._const_tab_at = ('..', 'id')
    __ReferenceSignal_choice_Extension_criticality._const_tab_id = 'criticality'
    __ReferenceSignal_choice_Extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___ReferenceSignal_choice_Extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ReferenceSignal_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReferenceSignal_choice_Extension_value._const_tab = ___ReferenceSignal_choice_Extension_value_tab
    __ReferenceSignal_choice_Extension_value._const_tab_at = ('..', 'id')
    __ReferenceSignal_choice_Extension_value._const_tab_id = 'Value'
    _ReferenceSignal_choice_Extension._cont = ASN1Dict([
        ('id', __ReferenceSignal_choice_Extension_id),
        ('criticality', __ReferenceSignal_choice_Extension_criticality),
        ('value', __ReferenceSignal_choice_Extension_value),
        ])
    _ReferenceSignal_choice_Extension._ext = None
    ReferenceSignal._cont = ASN1Dict([
        ('nZP-CSI-RS', _ReferenceSignal_nZP_CSI_RS),
        ('sSB', _ReferenceSignal_sSB),
        ('sRS', _ReferenceSignal_sRS),
        ('positioningSRS', _ReferenceSignal_positioningSRS),
        ('dL-PRS', _ReferenceSignal_dL_PRS),
        ('choice-Extension', _ReferenceSignal_choice_Extension),
        ])
    ReferenceSignal._ext = None
    
    #-----< ReferenceSignal-ExtensionIE >-----#
    ReferenceSignal_ExtensionIE = CLASS(name='ReferenceSignal-ExtensionIE', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ReferenceSignal_ExtensionIE._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ReferencePoint >-----#
    ReferencePoint = CHOICE(name='ReferencePoint', mode=MODE_TYPE)
    _ReferencePoint_relativeCoordinateID = INT(name='relativeCoordinateID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CoordinateID')))
    _ReferencePoint_referencePointCoordinate = SEQ(name='referencePointCoordinate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NG-RANAccessPointPosition')))
    _ReferencePoint_referencePointCoordinateHA = SEQ(name='referencePointCoordinateHA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NGRANHighAccuracyAccessPointPosition')))
    _ReferencePoint_choice_Extension = SEQ(name='choice-Extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __ReferencePoint_choice_Extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___ReferencePoint_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ReferencePoint_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReferencePoint_choice_Extension_id._const_tab = ___ReferencePoint_choice_Extension_id_tab
    __ReferencePoint_choice_Extension_id._const_tab_at = None
    __ReferencePoint_choice_Extension_id._const_tab_id = 'id'
    __ReferencePoint_choice_Extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___ReferencePoint_choice_Extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ReferencePoint_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReferencePoint_choice_Extension_criticality._const_tab = ___ReferencePoint_choice_Extension_criticality_tab
    __ReferencePoint_choice_Extension_criticality._const_tab_at = ('..', 'id')
    __ReferencePoint_choice_Extension_criticality._const_tab_id = 'criticality'
    __ReferencePoint_choice_Extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___ReferencePoint_choice_Extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ReferencePoint_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ReferencePoint_choice_Extension_value._const_tab = ___ReferencePoint_choice_Extension_value_tab
    __ReferencePoint_choice_Extension_value._const_tab_at = ('..', 'id')
    __ReferencePoint_choice_Extension_value._const_tab_id = 'Value'
    _ReferencePoint_choice_Extension._cont = ASN1Dict([
        ('id', __ReferencePoint_choice_Extension_id),
        ('criticality', __ReferencePoint_choice_Extension_criticality),
        ('value', __ReferencePoint_choice_Extension_value),
        ])
    _ReferencePoint_choice_Extension._ext = None
    ReferencePoint._cont = ASN1Dict([
        ('relativeCoordinateID', _ReferencePoint_relativeCoordinateID),
        ('referencePointCoordinate', _ReferencePoint_referencePointCoordinate),
        ('referencePointCoordinateHA', _ReferencePoint_referencePointCoordinateHA),
        ('choice-Extension', _ReferencePoint_choice_Extension),
        ])
    ReferencePoint._ext = None
    
    #-----< ReferencePoint-ExtIEs >-----#
    ReferencePoint_ExtIEs = CLASS(name='ReferencePoint-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ReferencePoint_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CoordinateID >-----#
    CoordinateID = INT(name='CoordinateID', mode=MODE_TYPE)
    CoordinateID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=[], er=[])
    
    #-----< RelativeGeodeticLocation >-----#
    RelativeGeodeticLocation = SEQ(name='RelativeGeodeticLocation', mode=MODE_TYPE)
    _RelativeGeodeticLocation_milli_Arc_SecondUnits = ENUM(name='milli-Arc-SecondUnits', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeGeodeticLocation_milli_Arc_SecondUnits._cont = ASN1Dict([('zerodot03', 0), ('zerodot3', 1), ('three', 2)])
    _RelativeGeodeticLocation_milli_Arc_SecondUnits._ext = []
    _RelativeGeodeticLocation_heightUnits = ENUM(name='heightUnits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeGeodeticLocation_heightUnits._cont = ASN1Dict([('mm', 0), ('cm', 1), ('m', 2)])
    _RelativeGeodeticLocation_heightUnits._ext = []
    _RelativeGeodeticLocation_deltaLatitude = INT(name='deltaLatitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeGeodeticLocation_deltaLatitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _RelativeGeodeticLocation_deltaLongitude = INT(name='deltaLongitude', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeGeodeticLocation_deltaLongitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _RelativeGeodeticLocation_deltaHeight = INT(name='deltaHeight', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeGeodeticLocation_deltaHeight._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1024, ub=1023)], ev=None, er=[])
    _RelativeGeodeticLocation_locationUncertainty = SEQ(name='locationUncertainty', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'LocationUncertainty')))
    _RelativeGeodeticLocation_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelativeGeodeticLocation_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___RelativeGeodeticLocation_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____RelativeGeodeticLocation_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RelativeGeodeticLocation_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelativeGeodeticLocation_iE_extensions__item__id._const_tab = ____RelativeGeodeticLocation_iE_extensions__item__id_tab
    ___RelativeGeodeticLocation_iE_extensions__item__id._const_tab_at = None
    ___RelativeGeodeticLocation_iE_extensions__item__id._const_tab_id = 'id'
    ___RelativeGeodeticLocation_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____RelativeGeodeticLocation_iE_extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RelativeGeodeticLocation_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelativeGeodeticLocation_iE_extensions__item__criticality._const_tab = ____RelativeGeodeticLocation_iE_extensions__item__criticality_tab
    ___RelativeGeodeticLocation_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RelativeGeodeticLocation_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___RelativeGeodeticLocation_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____RelativeGeodeticLocation_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RelativeGeodeticLocation_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelativeGeodeticLocation_iE_extensions__item__extensionValue._const_tab = ____RelativeGeodeticLocation_iE_extensions__item__extensionValue_tab
    ___RelativeGeodeticLocation_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RelativeGeodeticLocation_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __RelativeGeodeticLocation_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___RelativeGeodeticLocation_iE_extensions__item__id),
        ('criticality', ___RelativeGeodeticLocation_iE_extensions__item__criticality),
        ('extensionValue', ___RelativeGeodeticLocation_iE_extensions__item__extensionValue),
        ])
    __RelativeGeodeticLocation_iE_extensions__item_._ext = None
    _RelativeGeodeticLocation_iE_extensions._cont = __RelativeGeodeticLocation_iE_extensions__item_
    _RelativeGeodeticLocation_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelativeGeodeticLocation._cont = ASN1Dict([
        ('milli-Arc-SecondUnits', _RelativeGeodeticLocation_milli_Arc_SecondUnits),
        ('heightUnits', _RelativeGeodeticLocation_heightUnits),
        ('deltaLatitude', _RelativeGeodeticLocation_deltaLatitude),
        ('deltaLongitude', _RelativeGeodeticLocation_deltaLongitude),
        ('deltaHeight', _RelativeGeodeticLocation_deltaHeight),
        ('locationUncertainty', _RelativeGeodeticLocation_locationUncertainty),
        ('iE-extensions', _RelativeGeodeticLocation_iE_extensions),
        ])
    RelativeGeodeticLocation._ext = []
    
    #-----< RelativeGeodeticLocation-ExtIEs >-----#
    RelativeGeodeticLocation_ExtIEs = CLASS(name='RelativeGeodeticLocation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    RelativeGeodeticLocation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelativeCartesianLocation >-----#
    RelativeCartesianLocation = SEQ(name='RelativeCartesianLocation', mode=MODE_TYPE)
    _RelativeCartesianLocation_xYZunit = ENUM(name='xYZunit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeCartesianLocation_xYZunit._cont = ASN1Dict([('mm', 0), ('cm', 1), ('dm', 2)])
    _RelativeCartesianLocation_xYZunit._ext = []
    _RelativeCartesianLocation_xvalue = INT(name='xvalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeCartesianLocation_xvalue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-65536, ub=65535)], ev=None, er=[])
    _RelativeCartesianLocation_yvalue = INT(name='yvalue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeCartesianLocation_yvalue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-65536, ub=65535)], ev=None, er=[])
    _RelativeCartesianLocation_zvalue = INT(name='zvalue', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativeCartesianLocation_zvalue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _RelativeCartesianLocation_locationUncertainty = SEQ(name='locationUncertainty', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'LocationUncertainty')))
    _RelativeCartesianLocation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelativeCartesianLocation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___RelativeCartesianLocation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____RelativeCartesianLocation_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RelativeCartesianLocation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelativeCartesianLocation_iE_Extensions__item__id._const_tab = ____RelativeCartesianLocation_iE_Extensions__item__id_tab
    ___RelativeCartesianLocation_iE_Extensions__item__id._const_tab_at = None
    ___RelativeCartesianLocation_iE_Extensions__item__id._const_tab_id = 'id'
    ___RelativeCartesianLocation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____RelativeCartesianLocation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RelativeCartesianLocation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelativeCartesianLocation_iE_Extensions__item__criticality._const_tab = ____RelativeCartesianLocation_iE_Extensions__item__criticality_tab
    ___RelativeCartesianLocation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RelativeCartesianLocation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RelativeCartesianLocation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____RelativeCartesianLocation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RelativeCartesianLocation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelativeCartesianLocation_iE_Extensions__item__extensionValue._const_tab = ____RelativeCartesianLocation_iE_Extensions__item__extensionValue_tab
    ___RelativeCartesianLocation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RelativeCartesianLocation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RelativeCartesianLocation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RelativeCartesianLocation_iE_Extensions__item__id),
        ('criticality', ___RelativeCartesianLocation_iE_Extensions__item__criticality),
        ('extensionValue', ___RelativeCartesianLocation_iE_Extensions__item__extensionValue),
        ])
    __RelativeCartesianLocation_iE_Extensions__item_._ext = None
    _RelativeCartesianLocation_iE_Extensions._cont = __RelativeCartesianLocation_iE_Extensions__item_
    _RelativeCartesianLocation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelativeCartesianLocation._cont = ASN1Dict([
        ('xYZunit', _RelativeCartesianLocation_xYZunit),
        ('xvalue', _RelativeCartesianLocation_xvalue),
        ('yvalue', _RelativeCartesianLocation_yvalue),
        ('zvalue', _RelativeCartesianLocation_zvalue),
        ('locationUncertainty', _RelativeCartesianLocation_locationUncertainty),
        ('iE-Extensions', _RelativeCartesianLocation_iE_Extensions),
        ])
    RelativeCartesianLocation._ext = []
    
    #-----< RelativeCartesianLocation-ExtIEs >-----#
    RelativeCartesianLocation_ExtIEs = CLASS(name='RelativeCartesianLocation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    RelativeCartesianLocation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelativePathDelay >-----#
    RelativePathDelay = CHOICE(name='RelativePathDelay', mode=MODE_TYPE)
    _RelativePathDelay_k0 = INT(name='k0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativePathDelay_k0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16351)], ev=None, er=[])
    _RelativePathDelay_k1 = INT(name='k1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativePathDelay_k1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8176)], ev=None, er=[])
    _RelativePathDelay_k2 = INT(name='k2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativePathDelay_k2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4088)], ev=None, er=[])
    _RelativePathDelay_k3 = INT(name='k3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativePathDelay_k3._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2044)], ev=None, er=[])
    _RelativePathDelay_k4 = INT(name='k4', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativePathDelay_k4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1022)], ev=None, er=[])
    _RelativePathDelay_k5 = INT(name='k5', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RelativePathDelay_k5._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    _RelativePathDelay_choice_Extension = SEQ(name='choice-Extension', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __RelativePathDelay_choice_Extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___RelativePathDelay_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___RelativePathDelay_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __RelativePathDelay_choice_Extension_id._const_tab = ___RelativePathDelay_choice_Extension_id_tab
    __RelativePathDelay_choice_Extension_id._const_tab_at = None
    __RelativePathDelay_choice_Extension_id._const_tab_id = 'id'
    __RelativePathDelay_choice_Extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___RelativePathDelay_choice_Extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___RelativePathDelay_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __RelativePathDelay_choice_Extension_criticality._const_tab = ___RelativePathDelay_choice_Extension_criticality_tab
    __RelativePathDelay_choice_Extension_criticality._const_tab_at = ('..', 'id')
    __RelativePathDelay_choice_Extension_criticality._const_tab_id = 'criticality'
    __RelativePathDelay_choice_Extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___RelativePathDelay_choice_Extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___RelativePathDelay_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __RelativePathDelay_choice_Extension_value._const_tab = ___RelativePathDelay_choice_Extension_value_tab
    __RelativePathDelay_choice_Extension_value._const_tab_at = ('..', 'id')
    __RelativePathDelay_choice_Extension_value._const_tab_id = 'Value'
    _RelativePathDelay_choice_Extension._cont = ASN1Dict([
        ('id', __RelativePathDelay_choice_Extension_id),
        ('criticality', __RelativePathDelay_choice_Extension_criticality),
        ('value', __RelativePathDelay_choice_Extension_value),
        ])
    _RelativePathDelay_choice_Extension._ext = None
    RelativePathDelay._cont = ASN1Dict([
        ('k0', _RelativePathDelay_k0),
        ('k1', _RelativePathDelay_k1),
        ('k2', _RelativePathDelay_k2),
        ('k3', _RelativePathDelay_k3),
        ('k4', _RelativePathDelay_k4),
        ('k5', _RelativePathDelay_k5),
        ('choice-Extension', _RelativePathDelay_choice_Extension),
        ])
    RelativePathDelay._ext = None
    
    #-----< RelativePathDelay-ExtIEs >-----#
    RelativePathDelay_ExtIEs = CLASS(name='RelativePathDelay-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    RelativePathDelay_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ReportCharacteristics >-----#
    ReportCharacteristics = ENUM(name='ReportCharacteristics', mode=MODE_TYPE)
    ReportCharacteristics._cont = ASN1Dict([('onDemand', 0), ('periodic', 1)])
    ReportCharacteristics._ext = []
    
    #-----< RequestedDLPRSTransmissionCharacteristics >-----#
    RequestedDLPRSTransmissionCharacteristics = SEQ(name='RequestedDLPRSTransmissionCharacteristics', mode=MODE_TYPE)
    _RequestedDLPRSTransmissionCharacteristics_requestedDLPRSResourceSet_List = SEQ_OF(name='requestedDLPRSResourceSet-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RequestedDLPRSResourceSet-List')))
    _RequestedDLPRSTransmissionCharacteristics_numberofFrequencyLayers = INT(name='numberofFrequencyLayers', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedDLPRSTransmissionCharacteristics_numberofFrequencyLayers._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _RequestedDLPRSTransmissionCharacteristics_startTimeAndDuration = SEQ(name='startTimeAndDuration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'StartTimeAndDuration')), opt=True)
    _RequestedDLPRSTransmissionCharacteristics_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__id._const_tab = ____RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__id_tab
    ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__id._const_tab_at = None
    ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__id._const_tab_id = 'id'
    ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__criticality._const_tab = ____RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__criticality_tab
    ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__extensionValue._const_tab = ____RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__extensionValue_tab
    ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__id),
        ('criticality', ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__criticality),
        ('extensionValue', ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__extensionValue),
        ])
    __RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item_._ext = None
    _RequestedDLPRSTransmissionCharacteristics_iE_Extensions._cont = __RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item_
    _RequestedDLPRSTransmissionCharacteristics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RequestedDLPRSTransmissionCharacteristics._cont = ASN1Dict([
        ('requestedDLPRSResourceSet-List', _RequestedDLPRSTransmissionCharacteristics_requestedDLPRSResourceSet_List),
        ('numberofFrequencyLayers', _RequestedDLPRSTransmissionCharacteristics_numberofFrequencyLayers),
        ('startTimeAndDuration', _RequestedDLPRSTransmissionCharacteristics_startTimeAndDuration),
        ('iE-Extensions', _RequestedDLPRSTransmissionCharacteristics_iE_Extensions),
        ])
    RequestedDLPRSTransmissionCharacteristics._ext = []
    
    #-----< RequestedDLPRSTransmissionCharacteristics-ExtIEs >-----#
    RequestedDLPRSTransmissionCharacteristics_ExtIEs = CLASS(name='RequestedDLPRSTransmissionCharacteristics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    RequestedDLPRSTransmissionCharacteristics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RequestedDLPRSResourceSet-List >-----#
    RequestedDLPRSResourceSet_List = SEQ_OF(name='RequestedDLPRSResourceSet-List', mode=MODE_TYPE)
    _RequestedDLPRSResourceSet_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'RequestedDLPRSResourceSet-Item')))
    RequestedDLPRSResourceSet_List._cont = _RequestedDLPRSResourceSet_List__item_
    RequestedDLPRSResourceSet_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< RequestedDLPRSResourceSet-Item >-----#
    RequestedDLPRSResourceSet_Item = SEQ(name='RequestedDLPRSResourceSet-Item', mode=MODE_TYPE)
    _RequestedDLPRSResourceSet_Item_pRSbandwidth = INT(name='pRSbandwidth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedDLPRSResourceSet_Item_pRSbandwidth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _RequestedDLPRSResourceSet_Item_combSize = ENUM(name='combSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedDLPRSResourceSet_Item_combSize._cont = ASN1Dict([('n2', 0), ('n4', 1), ('n6', 2), ('n12', 3)])
    _RequestedDLPRSResourceSet_Item_combSize._ext = []
    _RequestedDLPRSResourceSet_Item_resourceSetPeriodicity = ENUM(name='resourceSetPeriodicity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedDLPRSResourceSet_Item_resourceSetPeriodicity._cont = ASN1Dict([('n4', 0), ('n5', 1), ('n8', 2), ('n10', 3), ('n16', 4), ('n20', 5), ('n32', 6), ('n40', 7), ('n64', 8), ('n80', 9), ('n160', 10), ('n320', 11), ('n640', 12), ('n1280', 13), ('n2560', 14), ('n5120', 15), ('n10240', 16), ('n20480', 17), ('n40960', 18), ('n81920', 19)])
    _RequestedDLPRSResourceSet_Item_resourceSetPeriodicity._ext = []
    _RequestedDLPRSResourceSet_Item_resourceRepetitionFactor = ENUM(name='resourceRepetitionFactor', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedDLPRSResourceSet_Item_resourceRepetitionFactor._cont = ASN1Dict([('rf1', 0), ('rf2', 1), ('rf4', 2), ('rf6', 3), ('rf8', 4), ('rf16', 5), ('rf32', 6)])
    _RequestedDLPRSResourceSet_Item_resourceRepetitionFactor._ext = []
    _RequestedDLPRSResourceSet_Item_resourceNumberofSymbols = ENUM(name='resourceNumberofSymbols', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedDLPRSResourceSet_Item_resourceNumberofSymbols._cont = ASN1Dict([('n2', 0), ('n4', 1), ('n6', 2), ('n12', 3)])
    _RequestedDLPRSResourceSet_Item_resourceNumberofSymbols._ext = []
    _RequestedDLPRSResourceSet_Item_requestedDLPRSResource_List = SEQ_OF(name='requestedDLPRSResource-List', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RequestedDLPRSResource-List')), opt=True)
    _RequestedDLPRSResourceSet_Item_resourceSetStartTimeAndDuration = SEQ(name='resourceSetStartTimeAndDuration', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'StartTimeAndDuration')), opt=True)
    _RequestedDLPRSResourceSet_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RequestedDLPRSResourceSet_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____RequestedDLPRSResourceSet_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RequestedDLPRSResourceSet_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__id._const_tab = ____RequestedDLPRSResourceSet_Item_iE_Extensions__item__id_tab
    ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__id._const_tab_at = None
    ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____RequestedDLPRSResourceSet_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RequestedDLPRSResourceSet_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__criticality._const_tab = ____RequestedDLPRSResourceSet_Item_iE_Extensions__item__criticality_tab
    ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____RequestedDLPRSResourceSet_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RequestedDLPRSResourceSet_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab = ____RequestedDLPRSResourceSet_Item_iE_Extensions__item__extensionValue_tab
    ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RequestedDLPRSResourceSet_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__id),
        ('criticality', ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__extensionValue),
        ])
    __RequestedDLPRSResourceSet_Item_iE_Extensions__item_._ext = None
    _RequestedDLPRSResourceSet_Item_iE_Extensions._cont = __RequestedDLPRSResourceSet_Item_iE_Extensions__item_
    _RequestedDLPRSResourceSet_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RequestedDLPRSResourceSet_Item._cont = ASN1Dict([
        ('pRSbandwidth', _RequestedDLPRSResourceSet_Item_pRSbandwidth),
        ('combSize', _RequestedDLPRSResourceSet_Item_combSize),
        ('resourceSetPeriodicity', _RequestedDLPRSResourceSet_Item_resourceSetPeriodicity),
        ('resourceRepetitionFactor', _RequestedDLPRSResourceSet_Item_resourceRepetitionFactor),
        ('resourceNumberofSymbols', _RequestedDLPRSResourceSet_Item_resourceNumberofSymbols),
        ('requestedDLPRSResource-List', _RequestedDLPRSResourceSet_Item_requestedDLPRSResource_List),
        ('resourceSetStartTimeAndDuration', _RequestedDLPRSResourceSet_Item_resourceSetStartTimeAndDuration),
        ('iE-Extensions', _RequestedDLPRSResourceSet_Item_iE_Extensions),
        ])
    RequestedDLPRSResourceSet_Item._ext = []
    
    #-----< RequestedDLPRSResourceSet-Item-ExtIEs >-----#
    RequestedDLPRSResourceSet_Item_ExtIEs = CLASS(name='RequestedDLPRSResourceSet-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    RequestedDLPRSResourceSet_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RequestedDLPRSResource-List >-----#
    RequestedDLPRSResource_List = SEQ_OF(name='RequestedDLPRSResource-List', mode=MODE_TYPE)
    _RequestedDLPRSResource_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'RequestedDLPRSResource-Item')))
    RequestedDLPRSResource_List._cont = _RequestedDLPRSResource_List__item_
    RequestedDLPRSResource_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< RequestedDLPRSResource-Item >-----#
    RequestedDLPRSResource_Item = SEQ(name='RequestedDLPRSResource-Item', mode=MODE_TYPE)
    _RequestedDLPRSResource_Item_qCLInfo = CHOICE(name='qCLInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSResource-QCLInfo')), opt=True)
    _RequestedDLPRSResource_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RequestedDLPRSResource_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___RequestedDLPRSResource_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____RequestedDLPRSResource_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RequestedDLPRSResource_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestedDLPRSResource_Item_iE_Extensions__item__id._const_tab = ____RequestedDLPRSResource_Item_iE_Extensions__item__id_tab
    ___RequestedDLPRSResource_Item_iE_Extensions__item__id._const_tab_at = None
    ___RequestedDLPRSResource_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___RequestedDLPRSResource_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____RequestedDLPRSResource_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RequestedDLPRSResource_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestedDLPRSResource_Item_iE_Extensions__item__criticality._const_tab = ____RequestedDLPRSResource_Item_iE_Extensions__item__criticality_tab
    ___RequestedDLPRSResource_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RequestedDLPRSResource_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RequestedDLPRSResource_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____RequestedDLPRSResource_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RequestedDLPRSResource_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestedDLPRSResource_Item_iE_Extensions__item__extensionValue._const_tab = ____RequestedDLPRSResource_Item_iE_Extensions__item__extensionValue_tab
    ___RequestedDLPRSResource_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RequestedDLPRSResource_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RequestedDLPRSResource_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RequestedDLPRSResource_Item_iE_Extensions__item__id),
        ('criticality', ___RequestedDLPRSResource_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___RequestedDLPRSResource_Item_iE_Extensions__item__extensionValue),
        ])
    __RequestedDLPRSResource_Item_iE_Extensions__item_._ext = None
    _RequestedDLPRSResource_Item_iE_Extensions._cont = __RequestedDLPRSResource_Item_iE_Extensions__item_
    _RequestedDLPRSResource_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RequestedDLPRSResource_Item._cont = ASN1Dict([
        ('qCLInfo', _RequestedDLPRSResource_Item_qCLInfo),
        ('iE-Extensions', _RequestedDLPRSResource_Item_iE_Extensions),
        ])
    RequestedDLPRSResource_Item._ext = []
    
    #-----< RequestedDLPRSResource-Item-ExtIEs >-----#
    RequestedDLPRSResource_Item_ExtIEs = CLASS(name='RequestedDLPRSResource-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    RequestedDLPRSResource_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RequestedSRSTransmissionCharacteristics >-----#
    RequestedSRSTransmissionCharacteristics = SEQ(name='RequestedSRSTransmissionCharacteristics', mode=MODE_TYPE)
    _RequestedSRSTransmissionCharacteristics_numberOfTransmissions = INT(name='numberOfTransmissions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSRSTransmissionCharacteristics_numberOfTransmissions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=500)], ev=[], er=[])
    _RequestedSRSTransmissionCharacteristics_resourceType = ENUM(name='resourceType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RequestedSRSTransmissionCharacteristics_resourceType._cont = ASN1Dict([('periodic', 0), ('semi-persistent', 1), ('aperiodic', 2)])
    _RequestedSRSTransmissionCharacteristics_resourceType._ext = []
    _RequestedSRSTransmissionCharacteristics_bandwidth = CHOICE(name='bandwidth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'BandwidthSRS')))
    _RequestedSRSTransmissionCharacteristics_listOfSRSResourceSet = SEQ_OF(name='listOfSRSResourceSet', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RequestedSRSTransmissionCharacteristics_listOfSRSResourceSet__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSResourceSet-Item')))
    _RequestedSRSTransmissionCharacteristics_listOfSRSResourceSet._cont = __RequestedSRSTransmissionCharacteristics_listOfSRSResourceSet__item_
    _RequestedSRSTransmissionCharacteristics_listOfSRSResourceSet._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _RequestedSRSTransmissionCharacteristics_sSBInformation = SEQ(name='sSBInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SSBInfo')), opt=True)
    _RequestedSRSTransmissionCharacteristics_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RequestedSRSTransmissionCharacteristics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SrsFrequency')))
    ____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 61), ('criticality', 'ignore'), ('Extension', _____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id._const_tab = ____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id._const_tab_at = None
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id._const_tab_id = 'id'
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__criticality._const_tab = ____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__extensionValue._const_tab = ____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RequestedSRSTransmissionCharacteristics_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id),
        ('criticality', ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__criticality),
        ('extensionValue', ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__extensionValue),
        ])
    __RequestedSRSTransmissionCharacteristics_iE_Extensions__item_._ext = None
    _RequestedSRSTransmissionCharacteristics_iE_Extensions._cont = __RequestedSRSTransmissionCharacteristics_iE_Extensions__item_
    _RequestedSRSTransmissionCharacteristics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RequestedSRSTransmissionCharacteristics._cont = ASN1Dict([
        ('numberOfTransmissions', _RequestedSRSTransmissionCharacteristics_numberOfTransmissions),
        ('resourceType', _RequestedSRSTransmissionCharacteristics_resourceType),
        ('bandwidth', _RequestedSRSTransmissionCharacteristics_bandwidth),
        ('listOfSRSResourceSet', _RequestedSRSTransmissionCharacteristics_listOfSRSResourceSet),
        ('sSBInformation', _RequestedSRSTransmissionCharacteristics_sSBInformation),
        ('iE-Extensions', _RequestedSRSTransmissionCharacteristics_iE_Extensions),
        ])
    RequestedSRSTransmissionCharacteristics._ext = []
    
    #-----< RequestedSRSTransmissionCharacteristics-ExtIEs >-----#
    RequestedSRSTransmissionCharacteristics_ExtIEs = CLASS(name='RequestedSRSTransmissionCharacteristics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _RequestedSRSTransmissionCharacteristics_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SrsFrequency')))
    RequestedSRSTransmissionCharacteristics_ExtIEs._val = ASN1Set(rv=[dict([('id', 61), ('criticality', 'ignore'), ('Extension', _RequestedSRSTransmissionCharacteristics_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SRSResourceSet-Item >-----#
    SRSResourceSet_Item = SEQ(name='SRSResourceSet-Item', mode=MODE_TYPE)
    _SRSResourceSet_Item_numberOfSRSResourcePerSet = INT(name='numberOfSRSResourcePerSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SRSResourceSet_Item_numberOfSRSResourcePerSet._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=[], er=[])
    _SRSResourceSet_Item_periodicityList = SEQ_OF(name='periodicityList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PeriodicityList')), opt=True)
    _SRSResourceSet_Item_spatialRelationInformation = SEQ(name='spatialRelationInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SpatialRelationInfo')), opt=True)
    _SRSResourceSet_Item_pathlossReferenceInformation = SEQ(name='pathlossReferenceInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PathlossReferenceInformation')), opt=True)
    _SRSResourceSet_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSResourceSet_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SRSResourceSet_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____SRSResourceSet_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____SRSResourceSet_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SpatialRelationPerSRSResource')))
    ____SRSResourceSet_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 63), ('criticality', 'ignore'), ('Extension', _____SRSResourceSet_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SRSResourceSet_Item_iE_Extensions__item__id._const_tab = ____SRSResourceSet_Item_iE_Extensions__item__id_tab
    ___SRSResourceSet_Item_iE_Extensions__item__id._const_tab_at = None
    ___SRSResourceSet_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRSResourceSet_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ___SRSResourceSet_Item_iE_Extensions__item__criticality._const_tab = ____SRSResourceSet_Item_iE_Extensions__item__id_tab
    ___SRSResourceSet_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRSResourceSet_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRSResourceSet_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ___SRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab = ____SRSResourceSet_Item_iE_Extensions__item__id_tab
    ___SRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRSResourceSet_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRSResourceSet_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRSResourceSet_Item_iE_Extensions__item__id),
        ('criticality', ___SRSResourceSet_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SRSResourceSet_Item_iE_Extensions__item__extensionValue),
        ])
    __SRSResourceSet_Item_iE_Extensions__item_._ext = None
    _SRSResourceSet_Item_iE_Extensions._cont = __SRSResourceSet_Item_iE_Extensions__item_
    _SRSResourceSet_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSResourceSet_Item._cont = ASN1Dict([
        ('numberOfSRSResourcePerSet', _SRSResourceSet_Item_numberOfSRSResourcePerSet),
        ('periodicityList', _SRSResourceSet_Item_periodicityList),
        ('spatialRelationInformation', _SRSResourceSet_Item_spatialRelationInformation),
        ('pathlossReferenceInformation', _SRSResourceSet_Item_pathlossReferenceInformation),
        ('iE-Extensions', _SRSResourceSet_Item_iE_Extensions),
        ])
    SRSResourceSet_Item._ext = []
    
    #-----< SRSResourceSet-Item-ExtIEs >-----#
    SRSResourceSet_Item_ExtIEs = CLASS(name='SRSResourceSet-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _SRSResourceSet_Item_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SpatialRelationPerSRSResource')))
    SRSResourceSet_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 63), ('criticality', 'ignore'), ('Extension', _SRSResourceSet_Item_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RequestType >-----#
    RequestType = ENUM(name='RequestType', mode=MODE_TYPE)
    RequestType._cont = ASN1Dict([('activate', 0), ('deactivate', 1)])
    RequestType._ext = []
    
    #-----< ResourceSetType >-----#
    ResourceSetType = CHOICE(name='ResourceSetType', mode=MODE_TYPE)
    _ResourceSetType_periodic = SEQ(name='periodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResourceSetTypePeriodic')))
    _ResourceSetType_semi_persistent = SEQ(name='semi-persistent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResourceSetTypeSemi-persistent')))
    _ResourceSetType_aperiodic = SEQ(name='aperiodic', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResourceSetTypeAperiodic')))
    _ResourceSetType_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __ResourceSetType_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___ResourceSetType_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ResourceSetType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceSetType_choice_extension_id._const_tab = ___ResourceSetType_choice_extension_id_tab
    __ResourceSetType_choice_extension_id._const_tab_at = None
    __ResourceSetType_choice_extension_id._const_tab_id = 'id'
    __ResourceSetType_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___ResourceSetType_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ResourceSetType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceSetType_choice_extension_criticality._const_tab = ___ResourceSetType_choice_extension_criticality_tab
    __ResourceSetType_choice_extension_criticality._const_tab_at = ('..', 'id')
    __ResourceSetType_choice_extension_criticality._const_tab_id = 'criticality'
    __ResourceSetType_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___ResourceSetType_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ResourceSetType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceSetType_choice_extension_value._const_tab = ___ResourceSetType_choice_extension_value_tab
    __ResourceSetType_choice_extension_value._const_tab_at = ('..', 'id')
    __ResourceSetType_choice_extension_value._const_tab_id = 'Value'
    _ResourceSetType_choice_extension._cont = ASN1Dict([
        ('id', __ResourceSetType_choice_extension_id),
        ('criticality', __ResourceSetType_choice_extension_criticality),
        ('value', __ResourceSetType_choice_extension_value),
        ])
    _ResourceSetType_choice_extension._ext = None
    ResourceSetType._cont = ASN1Dict([
        ('periodic', _ResourceSetType_periodic),
        ('semi-persistent', _ResourceSetType_semi_persistent),
        ('aperiodic', _ResourceSetType_aperiodic),
        ('choice-extension', _ResourceSetType_choice_extension),
        ])
    ResourceSetType._ext = None
    
    #-----< ResourceSetType-ExtIEs >-----#
    ResourceSetType_ExtIEs = CLASS(name='ResourceSetType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ResourceSetType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceSetTypePeriodic >-----#
    ResourceSetTypePeriodic = SEQ(name='ResourceSetTypePeriodic', mode=MODE_TYPE)
    _ResourceSetTypePeriodic_periodicSet = ENUM(name='periodicSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceSetTypePeriodic_periodicSet._cont = ASN1Dict([('true', 0)])
    _ResourceSetTypePeriodic_periodicSet._ext = []
    _ResourceSetTypePeriodic_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceSetTypePeriodic_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResourceSetTypePeriodic_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ResourceSetTypePeriodic_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceSetTypePeriodic_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypePeriodic_iE_Extensions__item__id._const_tab = ____ResourceSetTypePeriodic_iE_Extensions__item__id_tab
    ___ResourceSetTypePeriodic_iE_Extensions__item__id._const_tab_at = None
    ___ResourceSetTypePeriodic_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResourceSetTypePeriodic_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResourceSetTypePeriodic_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceSetTypePeriodic_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypePeriodic_iE_Extensions__item__criticality._const_tab = ____ResourceSetTypePeriodic_iE_Extensions__item__criticality_tab
    ___ResourceSetTypePeriodic_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceSetTypePeriodic_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResourceSetTypePeriodic_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResourceSetTypePeriodic_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceSetTypePeriodic_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypePeriodic_iE_Extensions__item__extensionValue._const_tab = ____ResourceSetTypePeriodic_iE_Extensions__item__extensionValue_tab
    ___ResourceSetTypePeriodic_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResourceSetTypePeriodic_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResourceSetTypePeriodic_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResourceSetTypePeriodic_iE_Extensions__item__id),
        ('criticality', ___ResourceSetTypePeriodic_iE_Extensions__item__criticality),
        ('extensionValue', ___ResourceSetTypePeriodic_iE_Extensions__item__extensionValue),
        ])
    __ResourceSetTypePeriodic_iE_Extensions__item_._ext = None
    _ResourceSetTypePeriodic_iE_Extensions._cont = __ResourceSetTypePeriodic_iE_Extensions__item_
    _ResourceSetTypePeriodic_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceSetTypePeriodic._cont = ASN1Dict([
        ('periodicSet', _ResourceSetTypePeriodic_periodicSet),
        ('iE-Extensions', _ResourceSetTypePeriodic_iE_Extensions),
        ])
    ResourceSetTypePeriodic._ext = []
    
    #-----< ResourceSetTypePeriodic-ExtIEs >-----#
    ResourceSetTypePeriodic_ExtIEs = CLASS(name='ResourceSetTypePeriodic-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResourceSetTypePeriodic_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceSetTypeSemi-persistent >-----#
    ResourceSetTypeSemi_persistent = SEQ(name='ResourceSetTypeSemi-persistent', mode=MODE_TYPE)
    _ResourceSetTypeSemi_persistent_semi_persistentSet = ENUM(name='semi-persistentSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceSetTypeSemi_persistent_semi_persistentSet._cont = ASN1Dict([('true', 0)])
    _ResourceSetTypeSemi_persistent_semi_persistentSet._ext = []
    _ResourceSetTypeSemi_persistent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceSetTypeSemi_persistent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ResourceSetTypeSemi_persistent_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceSetTypeSemi_persistent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__id._const_tab = ____ResourceSetTypeSemi_persistent_iE_Extensions__item__id_tab
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__id._const_tab_at = None
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality._const_tab = ____ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality_tab
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab = ____ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue_tab
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResourceSetTypeSemi_persistent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResourceSetTypeSemi_persistent_iE_Extensions__item__id),
        ('criticality', ___ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality),
        ('extensionValue', ___ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue),
        ])
    __ResourceSetTypeSemi_persistent_iE_Extensions__item_._ext = None
    _ResourceSetTypeSemi_persistent_iE_Extensions._cont = __ResourceSetTypeSemi_persistent_iE_Extensions__item_
    _ResourceSetTypeSemi_persistent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceSetTypeSemi_persistent._cont = ASN1Dict([
        ('semi-persistentSet', _ResourceSetTypeSemi_persistent_semi_persistentSet),
        ('iE-Extensions', _ResourceSetTypeSemi_persistent_iE_Extensions),
        ])
    ResourceSetTypeSemi_persistent._ext = []
    
    #-----< ResourceSetTypeSemi-persistent-ExtIEs >-----#
    ResourceSetTypeSemi_persistent_ExtIEs = CLASS(name='ResourceSetTypeSemi-persistent-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResourceSetTypeSemi_persistent_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceSetTypeAperiodic >-----#
    ResourceSetTypeAperiodic = SEQ(name='ResourceSetTypeAperiodic', mode=MODE_TYPE)
    _ResourceSetTypeAperiodic_sRSResourceTrigger = INT(name='sRSResourceTrigger', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceSetTypeAperiodic_sRSResourceTrigger._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    _ResourceSetTypeAperiodic_slotoffset = INT(name='slotoffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceSetTypeAperiodic_slotoffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32)], ev=None, er=[])
    _ResourceSetTypeAperiodic_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceSetTypeAperiodic_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResourceSetTypeAperiodic_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ResourceSetTypeAperiodic_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceSetTypeAperiodic_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypeAperiodic_iE_Extensions__item__id._const_tab = ____ResourceSetTypeAperiodic_iE_Extensions__item__id_tab
    ___ResourceSetTypeAperiodic_iE_Extensions__item__id._const_tab_at = None
    ___ResourceSetTypeAperiodic_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResourceSetTypeAperiodic_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResourceSetTypeAperiodic_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceSetTypeAperiodic_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypeAperiodic_iE_Extensions__item__criticality._const_tab = ____ResourceSetTypeAperiodic_iE_Extensions__item__criticality_tab
    ___ResourceSetTypeAperiodic_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceSetTypeAperiodic_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue._const_tab = ____ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue_tab
    ___ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResourceSetTypeAperiodic_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResourceSetTypeAperiodic_iE_Extensions__item__id),
        ('criticality', ___ResourceSetTypeAperiodic_iE_Extensions__item__criticality),
        ('extensionValue', ___ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue),
        ])
    __ResourceSetTypeAperiodic_iE_Extensions__item_._ext = None
    _ResourceSetTypeAperiodic_iE_Extensions._cont = __ResourceSetTypeAperiodic_iE_Extensions__item_
    _ResourceSetTypeAperiodic_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceSetTypeAperiodic._cont = ASN1Dict([
        ('sRSResourceTrigger', _ResourceSetTypeAperiodic_sRSResourceTrigger),
        ('slotoffset', _ResourceSetTypeAperiodic_slotoffset),
        ('iE-Extensions', _ResourceSetTypeAperiodic_iE_Extensions),
        ])
    ResourceSetTypeAperiodic._ext = []
    
    #-----< ResourceSetTypeAperiodic-ExtIEs >-----#
    ResourceSetTypeAperiodic_ExtIEs = CLASS(name='ResourceSetTypeAperiodic-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResourceSetTypeAperiodic_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceType >-----#
    ResourceType = CHOICE(name='ResourceType', mode=MODE_TYPE)
    _ResourceType_periodic = SEQ(name='periodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResourceTypePeriodic')))
    _ResourceType_semi_persistent = SEQ(name='semi-persistent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResourceTypeSemi-persistent')))
    _ResourceType_aperiodic = SEQ(name='aperiodic', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResourceTypeAperiodic')))
    _ResourceType_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __ResourceType_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___ResourceType_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ResourceType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceType_choice_extension_id._const_tab = ___ResourceType_choice_extension_id_tab
    __ResourceType_choice_extension_id._const_tab_at = None
    __ResourceType_choice_extension_id._const_tab_id = 'id'
    __ResourceType_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___ResourceType_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ResourceType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceType_choice_extension_criticality._const_tab = ___ResourceType_choice_extension_criticality_tab
    __ResourceType_choice_extension_criticality._const_tab_at = ('..', 'id')
    __ResourceType_choice_extension_criticality._const_tab_id = 'criticality'
    __ResourceType_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___ResourceType_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ResourceType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceType_choice_extension_value._const_tab = ___ResourceType_choice_extension_value_tab
    __ResourceType_choice_extension_value._const_tab_at = ('..', 'id')
    __ResourceType_choice_extension_value._const_tab_id = 'Value'
    _ResourceType_choice_extension._cont = ASN1Dict([
        ('id', __ResourceType_choice_extension_id),
        ('criticality', __ResourceType_choice_extension_criticality),
        ('value', __ResourceType_choice_extension_value),
        ])
    _ResourceType_choice_extension._ext = None
    ResourceType._cont = ASN1Dict([
        ('periodic', _ResourceType_periodic),
        ('semi-persistent', _ResourceType_semi_persistent),
        ('aperiodic', _ResourceType_aperiodic),
        ('choice-extension', _ResourceType_choice_extension),
        ])
    ResourceType._ext = None
    
    #-----< ResourceType-ExtIEs >-----#
    ResourceType_ExtIEs = CLASS(name='ResourceType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ResourceType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypePeriodic >-----#
    ResourceTypePeriodic = SEQ(name='ResourceTypePeriodic', mode=MODE_TYPE)
    _ResourceTypePeriodic_periodicity = ENUM(name='periodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypePeriodic_periodicity._cont = ASN1Dict([('slot1', 0), ('slot2', 1), ('slot4', 2), ('slot5', 3), ('slot8', 4), ('slot10', 5), ('slot16', 6), ('slot20', 7), ('slot32', 8), ('slot40', 9), ('slot64', 10), ('slot80', 11), ('slot160', 12), ('slot320', 13), ('slot640', 14), ('slot1280', 15), ('slot2560', 16)])
    _ResourceTypePeriodic_periodicity._ext = []
    _ResourceTypePeriodic_offset = INT(name='offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypePeriodic_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2559)], ev=[], er=[])
    _ResourceTypePeriodic_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceTypePeriodic_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResourceTypePeriodic_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ResourceTypePeriodic_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypePeriodic_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypePeriodic_iE_Extensions__item__id._const_tab = ____ResourceTypePeriodic_iE_Extensions__item__id_tab
    ___ResourceTypePeriodic_iE_Extensions__item__id._const_tab_at = None
    ___ResourceTypePeriodic_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResourceTypePeriodic_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResourceTypePeriodic_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypePeriodic_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypePeriodic_iE_Extensions__item__criticality._const_tab = ____ResourceTypePeriodic_iE_Extensions__item__criticality_tab
    ___ResourceTypePeriodic_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceTypePeriodic_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResourceTypePeriodic_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResourceTypePeriodic_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypePeriodic_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypePeriodic_iE_Extensions__item__extensionValue._const_tab = ____ResourceTypePeriodic_iE_Extensions__item__extensionValue_tab
    ___ResourceTypePeriodic_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResourceTypePeriodic_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResourceTypePeriodic_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResourceTypePeriodic_iE_Extensions__item__id),
        ('criticality', ___ResourceTypePeriodic_iE_Extensions__item__criticality),
        ('extensionValue', ___ResourceTypePeriodic_iE_Extensions__item__extensionValue),
        ])
    __ResourceTypePeriodic_iE_Extensions__item_._ext = None
    _ResourceTypePeriodic_iE_Extensions._cont = __ResourceTypePeriodic_iE_Extensions__item_
    _ResourceTypePeriodic_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceTypePeriodic._cont = ASN1Dict([
        ('periodicity', _ResourceTypePeriodic_periodicity),
        ('offset', _ResourceTypePeriodic_offset),
        ('iE-Extensions', _ResourceTypePeriodic_iE_Extensions),
        ])
    ResourceTypePeriodic._ext = []
    
    #-----< ResourceTypePeriodic-ExtIEs >-----#
    ResourceTypePeriodic_ExtIEs = CLASS(name='ResourceTypePeriodic-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResourceTypePeriodic_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypeSemi-persistent >-----#
    ResourceTypeSemi_persistent = SEQ(name='ResourceTypeSemi-persistent', mode=MODE_TYPE)
    _ResourceTypeSemi_persistent_periodicity = ENUM(name='periodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypeSemi_persistent_periodicity._cont = ASN1Dict([('slot1', 0), ('slot2', 1), ('slot4', 2), ('slot5', 3), ('slot8', 4), ('slot10', 5), ('slot16', 6), ('slot20', 7), ('slot32', 8), ('slot40', 9), ('slot64', 10), ('slot80', 11), ('slot160', 12), ('slot320', 13), ('slot640', 14), ('slot1280', 15), ('slot2560', 16)])
    _ResourceTypeSemi_persistent_periodicity._ext = []
    _ResourceTypeSemi_persistent_offset = INT(name='offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypeSemi_persistent_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2559)], ev=[], er=[])
    _ResourceTypeSemi_persistent_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceTypeSemi_persistent_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResourceTypeSemi_persistent_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ResourceTypeSemi_persistent_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypeSemi_persistent_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeSemi_persistent_iE_Extensions__item__id._const_tab = ____ResourceTypeSemi_persistent_iE_Extensions__item__id_tab
    ___ResourceTypeSemi_persistent_iE_Extensions__item__id._const_tab_at = None
    ___ResourceTypeSemi_persistent_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResourceTypeSemi_persistent_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResourceTypeSemi_persistent_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypeSemi_persistent_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeSemi_persistent_iE_Extensions__item__criticality._const_tab = ____ResourceTypeSemi_persistent_iE_Extensions__item__criticality_tab
    ___ResourceTypeSemi_persistent_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceTypeSemi_persistent_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab = ____ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue_tab
    ___ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResourceTypeSemi_persistent_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResourceTypeSemi_persistent_iE_Extensions__item__id),
        ('criticality', ___ResourceTypeSemi_persistent_iE_Extensions__item__criticality),
        ('extensionValue', ___ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue),
        ])
    __ResourceTypeSemi_persistent_iE_Extensions__item_._ext = None
    _ResourceTypeSemi_persistent_iE_Extensions._cont = __ResourceTypeSemi_persistent_iE_Extensions__item_
    _ResourceTypeSemi_persistent_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceTypeSemi_persistent._cont = ASN1Dict([
        ('periodicity', _ResourceTypeSemi_persistent_periodicity),
        ('offset', _ResourceTypeSemi_persistent_offset),
        ('iE-Extensions', _ResourceTypeSemi_persistent_iE_Extensions),
        ])
    ResourceTypeSemi_persistent._ext = []
    
    #-----< ResourceTypeSemi-persistent-ExtIEs >-----#
    ResourceTypeSemi_persistent_ExtIEs = CLASS(name='ResourceTypeSemi-persistent-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResourceTypeSemi_persistent_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypeAperiodic >-----#
    ResourceTypeAperiodic = SEQ(name='ResourceTypeAperiodic', mode=MODE_TYPE)
    _ResourceTypeAperiodic_aperiodicResourceType = ENUM(name='aperiodicResourceType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypeAperiodic_aperiodicResourceType._cont = ASN1Dict([('true', 0)])
    _ResourceTypeAperiodic_aperiodicResourceType._ext = []
    _ResourceTypeAperiodic_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceTypeAperiodic_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResourceTypeAperiodic_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ResourceTypeAperiodic_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypeAperiodic_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeAperiodic_iE_Extensions__item__id._const_tab = ____ResourceTypeAperiodic_iE_Extensions__item__id_tab
    ___ResourceTypeAperiodic_iE_Extensions__item__id._const_tab_at = None
    ___ResourceTypeAperiodic_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResourceTypeAperiodic_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResourceTypeAperiodic_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypeAperiodic_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeAperiodic_iE_Extensions__item__criticality._const_tab = ____ResourceTypeAperiodic_iE_Extensions__item__criticality_tab
    ___ResourceTypeAperiodic_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceTypeAperiodic_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResourceTypeAperiodic_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResourceTypeAperiodic_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypeAperiodic_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeAperiodic_iE_Extensions__item__extensionValue._const_tab = ____ResourceTypeAperiodic_iE_Extensions__item__extensionValue_tab
    ___ResourceTypeAperiodic_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResourceTypeAperiodic_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResourceTypeAperiodic_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResourceTypeAperiodic_iE_Extensions__item__id),
        ('criticality', ___ResourceTypeAperiodic_iE_Extensions__item__criticality),
        ('extensionValue', ___ResourceTypeAperiodic_iE_Extensions__item__extensionValue),
        ])
    __ResourceTypeAperiodic_iE_Extensions__item_._ext = None
    _ResourceTypeAperiodic_iE_Extensions._cont = __ResourceTypeAperiodic_iE_Extensions__item_
    _ResourceTypeAperiodic_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceTypeAperiodic._cont = ASN1Dict([
        ('aperiodicResourceType', _ResourceTypeAperiodic_aperiodicResourceType),
        ('iE-Extensions', _ResourceTypeAperiodic_iE_Extensions),
        ])
    ResourceTypeAperiodic._ext = []
    
    #-----< ResourceTypeAperiodic-ExtIEs >-----#
    ResourceTypeAperiodic_ExtIEs = CLASS(name='ResourceTypeAperiodic-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResourceTypeAperiodic_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypePos >-----#
    ResourceTypePos = CHOICE(name='ResourceTypePos', mode=MODE_TYPE)
    _ResourceTypePos_periodic = SEQ(name='periodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResourceTypePeriodicPos')))
    _ResourceTypePos_semi_persistent = SEQ(name='semi-persistent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResourceTypeSemi-persistentPos')))
    _ResourceTypePos_aperiodic = SEQ(name='aperiodic', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResourceTypeAperiodicPos')))
    _ResourceTypePos_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __ResourceTypePos_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___ResourceTypePos_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ResourceTypePos_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceTypePos_choice_extension_id._const_tab = ___ResourceTypePos_choice_extension_id_tab
    __ResourceTypePos_choice_extension_id._const_tab_at = None
    __ResourceTypePos_choice_extension_id._const_tab_id = 'id'
    __ResourceTypePos_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___ResourceTypePos_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ResourceTypePos_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceTypePos_choice_extension_criticality._const_tab = ___ResourceTypePos_choice_extension_criticality_tab
    __ResourceTypePos_choice_extension_criticality._const_tab_at = ('..', 'id')
    __ResourceTypePos_choice_extension_criticality._const_tab_id = 'criticality'
    __ResourceTypePos_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___ResourceTypePos_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ResourceTypePos_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ResourceTypePos_choice_extension_value._const_tab = ___ResourceTypePos_choice_extension_value_tab
    __ResourceTypePos_choice_extension_value._const_tab_at = ('..', 'id')
    __ResourceTypePos_choice_extension_value._const_tab_id = 'Value'
    _ResourceTypePos_choice_extension._cont = ASN1Dict([
        ('id', __ResourceTypePos_choice_extension_id),
        ('criticality', __ResourceTypePos_choice_extension_criticality),
        ('value', __ResourceTypePos_choice_extension_value),
        ])
    _ResourceTypePos_choice_extension._ext = None
    ResourceTypePos._cont = ASN1Dict([
        ('periodic', _ResourceTypePos_periodic),
        ('semi-persistent', _ResourceTypePos_semi_persistent),
        ('aperiodic', _ResourceTypePos_aperiodic),
        ('choice-extension', _ResourceTypePos_choice_extension),
        ])
    ResourceTypePos._ext = None
    
    #-----< ResourceTypePos-ExtIEs >-----#
    ResourceTypePos_ExtIEs = CLASS(name='ResourceTypePos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ResourceTypePos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypePeriodicPos >-----#
    ResourceTypePeriodicPos = SEQ(name='ResourceTypePeriodicPos', mode=MODE_TYPE)
    _ResourceTypePeriodicPos_periodicity = ENUM(name='periodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypePeriodicPos_periodicity._cont = ASN1Dict([('slot1', 0), ('slot2', 1), ('slot4', 2), ('slot5', 3), ('slot8', 4), ('slot10', 5), ('slot16', 6), ('slot20', 7), ('slot32', 8), ('slot40', 9), ('slot64', 10), ('slot80', 11), ('slot160', 12), ('slot320', 13), ('slot640', 14), ('slot1280', 15), ('slot2560', 16), ('slot5120', 17), ('slot10240', 18), ('slot40960', 19), ('slot81920', 20), ('slot128', 21), ('slot256', 22), ('slot512', 23), ('slot20480', 24)])
    _ResourceTypePeriodicPos_periodicity._ext = ['slot128', 'slot256', 'slot512', 'slot20480']
    _ResourceTypePeriodicPos_offset = INT(name='offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypePeriodicPos_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=81919)], ev=[], er=[])
    _ResourceTypePeriodicPos_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceTypePeriodicPos_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResourceTypePeriodicPos_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ResourceTypePeriodicPos_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypePeriodicPos_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypePeriodicPos_iE_Extensions__item__id._const_tab = ____ResourceTypePeriodicPos_iE_Extensions__item__id_tab
    ___ResourceTypePeriodicPos_iE_Extensions__item__id._const_tab_at = None
    ___ResourceTypePeriodicPos_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResourceTypePeriodicPos_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResourceTypePeriodicPos_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypePeriodicPos_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypePeriodicPos_iE_Extensions__item__criticality._const_tab = ____ResourceTypePeriodicPos_iE_Extensions__item__criticality_tab
    ___ResourceTypePeriodicPos_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceTypePeriodicPos_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResourceTypePeriodicPos_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResourceTypePeriodicPos_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypePeriodicPos_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypePeriodicPos_iE_Extensions__item__extensionValue._const_tab = ____ResourceTypePeriodicPos_iE_Extensions__item__extensionValue_tab
    ___ResourceTypePeriodicPos_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResourceTypePeriodicPos_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResourceTypePeriodicPos_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResourceTypePeriodicPos_iE_Extensions__item__id),
        ('criticality', ___ResourceTypePeriodicPos_iE_Extensions__item__criticality),
        ('extensionValue', ___ResourceTypePeriodicPos_iE_Extensions__item__extensionValue),
        ])
    __ResourceTypePeriodicPos_iE_Extensions__item_._ext = None
    _ResourceTypePeriodicPos_iE_Extensions._cont = __ResourceTypePeriodicPos_iE_Extensions__item_
    _ResourceTypePeriodicPos_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceTypePeriodicPos._cont = ASN1Dict([
        ('periodicity', _ResourceTypePeriodicPos_periodicity),
        ('offset', _ResourceTypePeriodicPos_offset),
        ('iE-Extensions', _ResourceTypePeriodicPos_iE_Extensions),
        ])
    ResourceTypePeriodicPos._ext = []
    
    #-----< ResourceTypePeriodicPos-ExtIEs >-----#
    ResourceTypePeriodicPos_ExtIEs = CLASS(name='ResourceTypePeriodicPos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResourceTypePeriodicPos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypeSemi-persistentPos >-----#
    ResourceTypeSemi_persistentPos = SEQ(name='ResourceTypeSemi-persistentPos', mode=MODE_TYPE)
    _ResourceTypeSemi_persistentPos_periodicity = ENUM(name='periodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypeSemi_persistentPos_periodicity._cont = ASN1Dict([('slot1', 0), ('slot2', 1), ('slot4', 2), ('slot5', 3), ('slot8', 4), ('slot10', 5), ('slot16', 6), ('slot20', 7), ('slot32', 8), ('slot40', 9), ('slot64', 10), ('slot80', 11), ('slot160', 12), ('slot320', 13), ('slot640', 14), ('slot1280', 15), ('slot2560', 16), ('slot5120', 17), ('slot10240', 18), ('slot40960', 19), ('slot81920', 20), ('slot128', 21), ('slot256', 22), ('slot512', 23), ('slot20480', 24)])
    _ResourceTypeSemi_persistentPos_periodicity._ext = ['slot128', 'slot256', 'slot512', 'slot20480']
    _ResourceTypeSemi_persistentPos_offset = INT(name='offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypeSemi_persistentPos_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=81919)], ev=[], er=[])
    _ResourceTypeSemi_persistentPos_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceTypeSemi_persistentPos_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ResourceTypeSemi_persistentPos_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypeSemi_persistentPos_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__id._const_tab = ____ResourceTypeSemi_persistentPos_iE_Extensions__item__id_tab
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__id._const_tab_at = None
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality._const_tab = ____ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality_tab
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue._const_tab = ____ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue_tab
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResourceTypeSemi_persistentPos_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResourceTypeSemi_persistentPos_iE_Extensions__item__id),
        ('criticality', ___ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality),
        ('extensionValue', ___ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue),
        ])
    __ResourceTypeSemi_persistentPos_iE_Extensions__item_._ext = None
    _ResourceTypeSemi_persistentPos_iE_Extensions._cont = __ResourceTypeSemi_persistentPos_iE_Extensions__item_
    _ResourceTypeSemi_persistentPos_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceTypeSemi_persistentPos._cont = ASN1Dict([
        ('periodicity', _ResourceTypeSemi_persistentPos_periodicity),
        ('offset', _ResourceTypeSemi_persistentPos_offset),
        ('iE-Extensions', _ResourceTypeSemi_persistentPos_iE_Extensions),
        ])
    ResourceTypeSemi_persistentPos._ext = []
    
    #-----< ResourceTypeSemi-persistentPos-ExtIEs >-----#
    ResourceTypeSemi_persistentPos_ExtIEs = CLASS(name='ResourceTypeSemi-persistentPos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResourceTypeSemi_persistentPos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResourceTypeAperiodicPos >-----#
    ResourceTypeAperiodicPos = SEQ(name='ResourceTypeAperiodicPos', mode=MODE_TYPE)
    _ResourceTypeAperiodicPos_slotOffset = INT(name='slotOffset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResourceTypeAperiodicPos_slotOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32)], ev=None, er=[])
    _ResourceTypeAperiodicPos_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResourceTypeAperiodicPos_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResourceTypeAperiodicPos_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ResourceTypeAperiodicPos_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypeAperiodicPos_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeAperiodicPos_iE_Extensions__item__id._const_tab = ____ResourceTypeAperiodicPos_iE_Extensions__item__id_tab
    ___ResourceTypeAperiodicPos_iE_Extensions__item__id._const_tab_at = None
    ___ResourceTypeAperiodicPos_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResourceTypeAperiodicPos_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResourceTypeAperiodicPos_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypeAperiodicPos_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeAperiodicPos_iE_Extensions__item__criticality._const_tab = ____ResourceTypeAperiodicPos_iE_Extensions__item__criticality_tab
    ___ResourceTypeAperiodicPos_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResourceTypeAperiodicPos_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue._const_tab = ____ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue_tab
    ___ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResourceTypeAperiodicPos_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResourceTypeAperiodicPos_iE_Extensions__item__id),
        ('criticality', ___ResourceTypeAperiodicPos_iE_Extensions__item__criticality),
        ('extensionValue', ___ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue),
        ])
    __ResourceTypeAperiodicPos_iE_Extensions__item_._ext = None
    _ResourceTypeAperiodicPos_iE_Extensions._cont = __ResourceTypeAperiodicPos_iE_Extensions__item_
    _ResourceTypeAperiodicPos_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResourceTypeAperiodicPos._cont = ASN1Dict([
        ('slotOffset', _ResourceTypeAperiodicPos_slotOffset),
        ('iE-Extensions', _ResourceTypeAperiodicPos_iE_Extensions),
        ])
    ResourceTypeAperiodicPos._ext = []
    
    #-----< ResourceTypeAperiodicPos-ExtIEs >-----#
    ResourceTypeAperiodicPos_ExtIEs = CLASS(name='ResourceTypeAperiodicPos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResourceTypeAperiodicPos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResponseTime >-----#
    ResponseTime = SEQ(name='ResponseTime', mode=MODE_TYPE)
    _ResponseTime_time = INT(name='time', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResponseTime_time._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=[], er=[])
    _ResponseTime_timeUnit = ENUM(name='timeUnit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResponseTime_timeUnit._cont = ASN1Dict([('second', 0), ('ten-seconds', 1), ('ten-milliseconds', 2)])
    _ResponseTime_timeUnit._ext = []
    _ResponseTime_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResponseTime_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResponseTime_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ResponseTime_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResponseTime_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResponseTime_iE_Extensions__item__id._const_tab = ____ResponseTime_iE_Extensions__item__id_tab
    ___ResponseTime_iE_Extensions__item__id._const_tab_at = None
    ___ResponseTime_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResponseTime_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResponseTime_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResponseTime_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResponseTime_iE_Extensions__item__criticality._const_tab = ____ResponseTime_iE_Extensions__item__criticality_tab
    ___ResponseTime_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResponseTime_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResponseTime_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResponseTime_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResponseTime_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResponseTime_iE_Extensions__item__extensionValue._const_tab = ____ResponseTime_iE_Extensions__item__extensionValue_tab
    ___ResponseTime_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResponseTime_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResponseTime_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResponseTime_iE_Extensions__item__id),
        ('criticality', ___ResponseTime_iE_Extensions__item__criticality),
        ('extensionValue', ___ResponseTime_iE_Extensions__item__extensionValue),
        ])
    __ResponseTime_iE_Extensions__item_._ext = None
    _ResponseTime_iE_Extensions._cont = __ResponseTime_iE_Extensions__item_
    _ResponseTime_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResponseTime._cont = ASN1Dict([
        ('time', _ResponseTime_time),
        ('timeUnit', _ResponseTime_timeUnit),
        ('iE-Extensions', _ResponseTime_iE_Extensions),
        ])
    ResponseTime._ext = []
    
    #-----< ResponseTime-ExtIEs >-----#
    ResponseTime_ExtIEs = CLASS(name='ResponseTime-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResponseTime_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultCSI-RSRP >-----#
    ResultCSI_RSRP = SEQ_OF(name='ResultCSI-RSRP', mode=MODE_TYPE)
    _ResultCSI_RSRP__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultCSI-RSRP-Item')))
    ResultCSI_RSRP._cont = _ResultCSI_RSRP__item_
    ResultCSI_RSRP._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< ResultCSI-RSRP-Item >-----#
    ResultCSI_RSRP_Item = SEQ(name='ResultCSI-RSRP-Item', mode=MODE_TYPE)
    _ResultCSI_RSRP_Item_nR_PCI = INT(name='nR-PCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NR-PCI')))
    _ResultCSI_RSRP_Item_nR_ARFCN = INT(name='nR-ARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NR-ARFCN')))
    _ResultCSI_RSRP_Item_cGI_NR = SEQ(name='cGI-NR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CGI-NR')), opt=True)
    _ResultCSI_RSRP_Item_valueCSI_RSRP_Cell = INT(name='valueCSI-RSRP-Cell', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRP-NR')), opt=True)
    _ResultCSI_RSRP_Item_cSI_RSRP_PerCSI_RS = SEQ_OF(name='cSI-RSRP-PerCSI-RS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResultCSI-RSRP-PerCSI-RS')), opt=True)
    _ResultCSI_RSRP_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultCSI_RSRP_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultCSI_RSRP_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ResultCSI_RSRP_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultCSI_RSRP_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultCSI_RSRP_Item_iE_Extensions__item__id._const_tab = ____ResultCSI_RSRP_Item_iE_Extensions__item__id_tab
    ___ResultCSI_RSRP_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultCSI_RSRP_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResultCSI_RSRP_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResultCSI_RSRP_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultCSI_RSRP_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultCSI_RSRP_Item_iE_Extensions__item__criticality._const_tab = ____ResultCSI_RSRP_Item_iE_Extensions__item__criticality_tab
    ___ResultCSI_RSRP_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResultCSI_RSRP_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResultCSI_RSRP_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResultCSI_RSRP_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultCSI_RSRP_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultCSI_RSRP_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultCSI_RSRP_Item_iE_Extensions__item__extensionValue_tab
    ___ResultCSI_RSRP_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResultCSI_RSRP_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResultCSI_RSRP_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResultCSI_RSRP_Item_iE_Extensions__item__id),
        ('criticality', ___ResultCSI_RSRP_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ResultCSI_RSRP_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultCSI_RSRP_Item_iE_Extensions__item_._ext = None
    _ResultCSI_RSRP_Item_iE_Extensions._cont = __ResultCSI_RSRP_Item_iE_Extensions__item_
    _ResultCSI_RSRP_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultCSI_RSRP_Item._cont = ASN1Dict([
        ('nR-PCI', _ResultCSI_RSRP_Item_nR_PCI),
        ('nR-ARFCN', _ResultCSI_RSRP_Item_nR_ARFCN),
        ('cGI-NR', _ResultCSI_RSRP_Item_cGI_NR),
        ('valueCSI-RSRP-Cell', _ResultCSI_RSRP_Item_valueCSI_RSRP_Cell),
        ('cSI-RSRP-PerCSI-RS', _ResultCSI_RSRP_Item_cSI_RSRP_PerCSI_RS),
        ('iE-Extensions', _ResultCSI_RSRP_Item_iE_Extensions),
        ])
    ResultCSI_RSRP_Item._ext = []
    
    #-----< ResultCSI-RSRP-Item-ExtIEs >-----#
    ResultCSI_RSRP_Item_ExtIEs = CLASS(name='ResultCSI-RSRP-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultCSI_RSRP_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultCSI-RSRP-PerCSI-RS >-----#
    ResultCSI_RSRP_PerCSI_RS = SEQ_OF(name='ResultCSI-RSRP-PerCSI-RS', mode=MODE_TYPE)
    _ResultCSI_RSRP_PerCSI_RS__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultCSI-RSRP-PerCSI-RS-Item')))
    ResultCSI_RSRP_PerCSI_RS._cont = _ResultCSI_RSRP_PerCSI_RS__item_
    ResultCSI_RSRP_PerCSI_RS._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< ResultCSI-RSRP-PerCSI-RS-Item >-----#
    ResultCSI_RSRP_PerCSI_RS_Item = SEQ(name='ResultCSI-RSRP-PerCSI-RS-Item', mode=MODE_TYPE)
    _ResultCSI_RSRP_PerCSI_RS_Item_cSI_RS_Index = INT(name='cSI-RS-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResultCSI_RSRP_PerCSI_RS_Item_cSI_RS_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=95)], ev=None, er=[])
    _ResultCSI_RSRP_PerCSI_RS_Item_valueCSI_RSRP = INT(name='valueCSI-RSRP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRP-NR')))
    _ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__id._const_tab = ____ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__id_tab
    ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__criticality._const_tab = ____ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__criticality_tab
    ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__extensionValue_tab
    ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__id),
        ('criticality', ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item_._ext = None
    _ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions._cont = __ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item_
    _ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultCSI_RSRP_PerCSI_RS_Item._cont = ASN1Dict([
        ('cSI-RS-Index', _ResultCSI_RSRP_PerCSI_RS_Item_cSI_RS_Index),
        ('valueCSI-RSRP', _ResultCSI_RSRP_PerCSI_RS_Item_valueCSI_RSRP),
        ('iE-Extensions', _ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions),
        ])
    ResultCSI_RSRP_PerCSI_RS_Item._ext = []
    
    #-----< ResultCSI-RSRP-PerCSI-RS-Item-ExtIEs >-----#
    ResultCSI_RSRP_PerCSI_RS_Item_ExtIEs = CLASS(name='ResultCSI-RSRP-PerCSI-RS-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultCSI_RSRP_PerCSI_RS_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultCSI-RSRQ >-----#
    ResultCSI_RSRQ = SEQ_OF(name='ResultCSI-RSRQ', mode=MODE_TYPE)
    _ResultCSI_RSRQ__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultCSI-RSRQ-Item')))
    ResultCSI_RSRQ._cont = _ResultCSI_RSRQ__item_
    ResultCSI_RSRQ._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< ResultCSI-RSRQ-Item >-----#
    ResultCSI_RSRQ_Item = SEQ(name='ResultCSI-RSRQ-Item', mode=MODE_TYPE)
    _ResultCSI_RSRQ_Item_nR_PCI = INT(name='nR-PCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NR-PCI')))
    _ResultCSI_RSRQ_Item_nR_ARFCN = INT(name='nR-ARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NR-ARFCN')))
    _ResultCSI_RSRQ_Item_cGI_NR = SEQ(name='cGI-NR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CGI-NR')), opt=True)
    _ResultCSI_RSRQ_Item_valueCSI_RSRQ_Cell = INT(name='valueCSI-RSRQ-Cell', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRQ-NR')), opt=True)
    _ResultCSI_RSRQ_Item_cSI_RSRQ_PerCSI_RS = SEQ_OF(name='cSI-RSRQ-PerCSI-RS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResultCSI-RSRQ-PerCSI-RS')), opt=True)
    _ResultCSI_RSRQ_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultCSI_RSRQ_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultCSI_RSRQ_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ResultCSI_RSRQ_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultCSI_RSRQ_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultCSI_RSRQ_Item_iE_Extensions__item__id._const_tab = ____ResultCSI_RSRQ_Item_iE_Extensions__item__id_tab
    ___ResultCSI_RSRQ_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultCSI_RSRQ_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResultCSI_RSRQ_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResultCSI_RSRQ_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultCSI_RSRQ_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultCSI_RSRQ_Item_iE_Extensions__item__criticality._const_tab = ____ResultCSI_RSRQ_Item_iE_Extensions__item__criticality_tab
    ___ResultCSI_RSRQ_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResultCSI_RSRQ_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResultCSI_RSRQ_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResultCSI_RSRQ_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultCSI_RSRQ_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultCSI_RSRQ_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultCSI_RSRQ_Item_iE_Extensions__item__extensionValue_tab
    ___ResultCSI_RSRQ_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResultCSI_RSRQ_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResultCSI_RSRQ_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResultCSI_RSRQ_Item_iE_Extensions__item__id),
        ('criticality', ___ResultCSI_RSRQ_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ResultCSI_RSRQ_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultCSI_RSRQ_Item_iE_Extensions__item_._ext = None
    _ResultCSI_RSRQ_Item_iE_Extensions._cont = __ResultCSI_RSRQ_Item_iE_Extensions__item_
    _ResultCSI_RSRQ_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultCSI_RSRQ_Item._cont = ASN1Dict([
        ('nR-PCI', _ResultCSI_RSRQ_Item_nR_PCI),
        ('nR-ARFCN', _ResultCSI_RSRQ_Item_nR_ARFCN),
        ('cGI-NR', _ResultCSI_RSRQ_Item_cGI_NR),
        ('valueCSI-RSRQ-Cell', _ResultCSI_RSRQ_Item_valueCSI_RSRQ_Cell),
        ('cSI-RSRQ-PerCSI-RS', _ResultCSI_RSRQ_Item_cSI_RSRQ_PerCSI_RS),
        ('iE-Extensions', _ResultCSI_RSRQ_Item_iE_Extensions),
        ])
    ResultCSI_RSRQ_Item._ext = []
    
    #-----< ResultCSI-RSRQ-Item-ExtIEs >-----#
    ResultCSI_RSRQ_Item_ExtIEs = CLASS(name='ResultCSI-RSRQ-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultCSI_RSRQ_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultCSI-RSRQ-PerCSI-RS >-----#
    ResultCSI_RSRQ_PerCSI_RS = SEQ_OF(name='ResultCSI-RSRQ-PerCSI-RS', mode=MODE_TYPE)
    _ResultCSI_RSRQ_PerCSI_RS__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultCSI-RSRQ-PerCSI-RS-Item')))
    ResultCSI_RSRQ_PerCSI_RS._cont = _ResultCSI_RSRQ_PerCSI_RS__item_
    ResultCSI_RSRQ_PerCSI_RS._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< ResultCSI-RSRQ-PerCSI-RS-Item >-----#
    ResultCSI_RSRQ_PerCSI_RS_Item = SEQ(name='ResultCSI-RSRQ-PerCSI-RS-Item', mode=MODE_TYPE)
    _ResultCSI_RSRQ_PerCSI_RS_Item_cSI_RS_Index = INT(name='cSI-RS-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResultCSI_RSRQ_PerCSI_RS_Item_cSI_RS_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=95)], ev=None, er=[])
    _ResultCSI_RSRQ_PerCSI_RS_Item_valueCSI_RSRQ = INT(name='valueCSI-RSRQ', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRQ-NR')))
    _ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__id._const_tab = ____ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__id_tab
    ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__criticality._const_tab = ____ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__criticality_tab
    ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__extensionValue_tab
    ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__id),
        ('criticality', ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item_._ext = None
    _ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions._cont = __ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item_
    _ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultCSI_RSRQ_PerCSI_RS_Item._cont = ASN1Dict([
        ('cSI-RS-Index', _ResultCSI_RSRQ_PerCSI_RS_Item_cSI_RS_Index),
        ('valueCSI-RSRQ', _ResultCSI_RSRQ_PerCSI_RS_Item_valueCSI_RSRQ),
        ('iE-Extensions', _ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions),
        ])
    ResultCSI_RSRQ_PerCSI_RS_Item._ext = []
    
    #-----< ResultCSI-RSRQ-PerCSI-RS-Item-ExtIEs >-----#
    ResultCSI_RSRQ_PerCSI_RS_Item_ExtIEs = CLASS(name='ResultCSI-RSRQ-PerCSI-RS-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultCSI_RSRQ_PerCSI_RS_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultEUTRA >-----#
    ResultEUTRA = SEQ_OF(name='ResultEUTRA', mode=MODE_TYPE)
    _ResultEUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultEUTRA-Item')))
    ResultEUTRA._cont = _ResultEUTRA__item_
    ResultEUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< ResultEUTRA-Item >-----#
    ResultEUTRA_Item = SEQ(name='ResultEUTRA-Item', mode=MODE_TYPE)
    _ResultEUTRA_Item_pCI_EUTRA = INT(name='pCI-EUTRA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PCI-EUTRA')))
    _ResultEUTRA_Item_eARFCN = INT(name='eARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'EARFCN')))
    _ResultEUTRA_Item_valueRSRP_EUTRA = INT(name='valueRSRP-EUTRA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRP-EUTRA')), opt=True)
    _ResultEUTRA_Item_valueRSRQ_EUTRA = INT(name='valueRSRQ-EUTRA', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRQ-EUTRA')), opt=True)
    _ResultEUTRA_Item_cGI_EUTRA = SEQ(name='cGI-EUTRA', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CGI-EUTRA')), opt=True)
    _ResultEUTRA_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultEUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultEUTRA_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ResultEUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultEUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultEUTRA_Item_iE_Extensions__item__id._const_tab = ____ResultEUTRA_Item_iE_Extensions__item__id_tab
    ___ResultEUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultEUTRA_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResultEUTRA_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResultEUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultEUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultEUTRA_Item_iE_Extensions__item__criticality._const_tab = ____ResultEUTRA_Item_iE_Extensions__item__criticality_tab
    ___ResultEUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResultEUTRA_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResultEUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResultEUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultEUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultEUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultEUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___ResultEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResultEUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResultEUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResultEUTRA_Item_iE_Extensions__item__id),
        ('criticality', ___ResultEUTRA_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ResultEUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultEUTRA_Item_iE_Extensions__item_._ext = None
    _ResultEUTRA_Item_iE_Extensions._cont = __ResultEUTRA_Item_iE_Extensions__item_
    _ResultEUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultEUTRA_Item._cont = ASN1Dict([
        ('pCI-EUTRA', _ResultEUTRA_Item_pCI_EUTRA),
        ('eARFCN', _ResultEUTRA_Item_eARFCN),
        ('valueRSRP-EUTRA', _ResultEUTRA_Item_valueRSRP_EUTRA),
        ('valueRSRQ-EUTRA', _ResultEUTRA_Item_valueRSRQ_EUTRA),
        ('cGI-EUTRA', _ResultEUTRA_Item_cGI_EUTRA),
        ('iE-Extensions', _ResultEUTRA_Item_iE_Extensions),
        ])
    ResultEUTRA_Item._ext = []
    
    #-----< ResultEUTRA-Item-ExtIEs >-----#
    ResultEUTRA_Item_ExtIEs = CLASS(name='ResultEUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultEUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultRSRP-EUTRA >-----#
    ResultRSRP_EUTRA = SEQ_OF(name='ResultRSRP-EUTRA', mode=MODE_TYPE)
    _ResultRSRP_EUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultRSRP-EUTRA-Item')))
    ResultRSRP_EUTRA._cont = _ResultRSRP_EUTRA__item_
    ResultRSRP_EUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< ResultRSRP-EUTRA-Item >-----#
    ResultRSRP_EUTRA_Item = SEQ(name='ResultRSRP-EUTRA-Item', mode=MODE_TYPE)
    _ResultRSRP_EUTRA_Item_pCI_EUTRA = INT(name='pCI-EUTRA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PCI-EUTRA')))
    _ResultRSRP_EUTRA_Item_eARFCN = INT(name='eARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'EARFCN')))
    _ResultRSRP_EUTRA_Item_cGI_EUTRA = SEQ(name='cGI-EUTRA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CGI-EUTRA')), opt=True)
    _ResultRSRP_EUTRA_Item_valueRSRP_EUTRA = INT(name='valueRSRP-EUTRA', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRP-EUTRA')))
    _ResultRSRP_EUTRA_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultRSRP_EUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultRSRP_EUTRA_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ResultRSRP_EUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultRSRP_EUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultRSRP_EUTRA_Item_iE_Extensions__item__id._const_tab = ____ResultRSRP_EUTRA_Item_iE_Extensions__item__id_tab
    ___ResultRSRP_EUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultRSRP_EUTRA_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResultRSRP_EUTRA_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResultRSRP_EUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultRSRP_EUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultRSRP_EUTRA_Item_iE_Extensions__item__criticality._const_tab = ____ResultRSRP_EUTRA_Item_iE_Extensions__item__criticality_tab
    ___ResultRSRP_EUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResultRSRP_EUTRA_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResultRSRP_EUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResultRSRP_EUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultRSRP_EUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultRSRP_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultRSRP_EUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___ResultRSRP_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResultRSRP_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResultRSRP_EUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResultRSRP_EUTRA_Item_iE_Extensions__item__id),
        ('criticality', ___ResultRSRP_EUTRA_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ResultRSRP_EUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultRSRP_EUTRA_Item_iE_Extensions__item_._ext = None
    _ResultRSRP_EUTRA_Item_iE_Extensions._cont = __ResultRSRP_EUTRA_Item_iE_Extensions__item_
    _ResultRSRP_EUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultRSRP_EUTRA_Item._cont = ASN1Dict([
        ('pCI-EUTRA', _ResultRSRP_EUTRA_Item_pCI_EUTRA),
        ('eARFCN', _ResultRSRP_EUTRA_Item_eARFCN),
        ('cGI-EUTRA', _ResultRSRP_EUTRA_Item_cGI_EUTRA),
        ('valueRSRP-EUTRA', _ResultRSRP_EUTRA_Item_valueRSRP_EUTRA),
        ('iE-Extensions', _ResultRSRP_EUTRA_Item_iE_Extensions),
        ])
    ResultRSRP_EUTRA_Item._ext = []
    
    #-----< ResultRSRP-EUTRA-Item-ExtIEs >-----#
    ResultRSRP_EUTRA_Item_ExtIEs = CLASS(name='ResultRSRP-EUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultRSRP_EUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultRSRQ-EUTRA >-----#
    ResultRSRQ_EUTRA = SEQ_OF(name='ResultRSRQ-EUTRA', mode=MODE_TYPE)
    _ResultRSRQ_EUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultRSRQ-EUTRA-Item')))
    ResultRSRQ_EUTRA._cont = _ResultRSRQ_EUTRA__item_
    ResultRSRQ_EUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< ResultRSRQ-EUTRA-Item >-----#
    ResultRSRQ_EUTRA_Item = SEQ(name='ResultRSRQ-EUTRA-Item', mode=MODE_TYPE)
    _ResultRSRQ_EUTRA_Item_pCI_EUTRA = INT(name='pCI-EUTRA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PCI-EUTRA')))
    _ResultRSRQ_EUTRA_Item_eARFCN = INT(name='eARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'EARFCN')))
    _ResultRSRQ_EUTRA_Item_cGI_UTRA = SEQ(name='cGI-UTRA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CGI-EUTRA')), opt=True)
    _ResultRSRQ_EUTRA_Item_valueRSRQ_EUTRA = INT(name='valueRSRQ-EUTRA', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRQ-EUTRA')))
    _ResultRSRQ_EUTRA_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultRSRQ_EUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ResultRSRQ_EUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultRSRQ_EUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__id._const_tab = ____ResultRSRQ_EUTRA_Item_iE_Extensions__item__id_tab
    ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResultRSRQ_EUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultRSRQ_EUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__criticality._const_tab = ____ResultRSRQ_EUTRA_Item_iE_Extensions__item__criticality_tab
    ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResultRSRQ_EUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultRSRQ_EUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultRSRQ_EUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResultRSRQ_EUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__id),
        ('criticality', ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultRSRQ_EUTRA_Item_iE_Extensions__item_._ext = None
    _ResultRSRQ_EUTRA_Item_iE_Extensions._cont = __ResultRSRQ_EUTRA_Item_iE_Extensions__item_
    _ResultRSRQ_EUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultRSRQ_EUTRA_Item._cont = ASN1Dict([
        ('pCI-EUTRA', _ResultRSRQ_EUTRA_Item_pCI_EUTRA),
        ('eARFCN', _ResultRSRQ_EUTRA_Item_eARFCN),
        ('cGI-UTRA', _ResultRSRQ_EUTRA_Item_cGI_UTRA),
        ('valueRSRQ-EUTRA', _ResultRSRQ_EUTRA_Item_valueRSRQ_EUTRA),
        ('iE-Extensions', _ResultRSRQ_EUTRA_Item_iE_Extensions),
        ])
    ResultRSRQ_EUTRA_Item._ext = []
    
    #-----< ResultRSRQ-EUTRA-Item-ExtIEs >-----#
    ResultRSRQ_EUTRA_Item_ExtIEs = CLASS(name='ResultRSRQ-EUTRA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultRSRQ_EUTRA_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultSS-RSRP >-----#
    ResultSS_RSRP = SEQ_OF(name='ResultSS-RSRP', mode=MODE_TYPE)
    _ResultSS_RSRP__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultSS-RSRP-Item')))
    ResultSS_RSRP._cont = _ResultSS_RSRP__item_
    ResultSS_RSRP._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< ResultSS-RSRP-Item >-----#
    ResultSS_RSRP_Item = SEQ(name='ResultSS-RSRP-Item', mode=MODE_TYPE)
    _ResultSS_RSRP_Item_nR_PCI = INT(name='nR-PCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NR-PCI')))
    _ResultSS_RSRP_Item_nR_ARFCN = INT(name='nR-ARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NR-ARFCN')))
    _ResultSS_RSRP_Item_cGI_NR = SEQ(name='cGI-NR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CGI-NR')), opt=True)
    _ResultSS_RSRP_Item_valueSS_RSRP_Cell = INT(name='valueSS-RSRP-Cell', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRP-NR')), opt=True)
    _ResultSS_RSRP_Item_sS_RSRP_PerSSB = SEQ_OF(name='sS-RSRP-PerSSB', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResultSS-RSRP-PerSSB')), opt=True)
    _ResultSS_RSRP_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultSS_RSRP_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultSS_RSRP_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ResultSS_RSRP_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultSS_RSRP_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultSS_RSRP_Item_iE_Extensions__item__id._const_tab = ____ResultSS_RSRP_Item_iE_Extensions__item__id_tab
    ___ResultSS_RSRP_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultSS_RSRP_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResultSS_RSRP_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResultSS_RSRP_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultSS_RSRP_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultSS_RSRP_Item_iE_Extensions__item__criticality._const_tab = ____ResultSS_RSRP_Item_iE_Extensions__item__criticality_tab
    ___ResultSS_RSRP_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResultSS_RSRP_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResultSS_RSRP_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResultSS_RSRP_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultSS_RSRP_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultSS_RSRP_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultSS_RSRP_Item_iE_Extensions__item__extensionValue_tab
    ___ResultSS_RSRP_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResultSS_RSRP_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResultSS_RSRP_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResultSS_RSRP_Item_iE_Extensions__item__id),
        ('criticality', ___ResultSS_RSRP_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ResultSS_RSRP_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultSS_RSRP_Item_iE_Extensions__item_._ext = None
    _ResultSS_RSRP_Item_iE_Extensions._cont = __ResultSS_RSRP_Item_iE_Extensions__item_
    _ResultSS_RSRP_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultSS_RSRP_Item._cont = ASN1Dict([
        ('nR-PCI', _ResultSS_RSRP_Item_nR_PCI),
        ('nR-ARFCN', _ResultSS_RSRP_Item_nR_ARFCN),
        ('cGI-NR', _ResultSS_RSRP_Item_cGI_NR),
        ('valueSS-RSRP-Cell', _ResultSS_RSRP_Item_valueSS_RSRP_Cell),
        ('sS-RSRP-PerSSB', _ResultSS_RSRP_Item_sS_RSRP_PerSSB),
        ('iE-Extensions', _ResultSS_RSRP_Item_iE_Extensions),
        ])
    ResultSS_RSRP_Item._ext = []
    
    #-----< ResultSS-RSRP-Item-ExtIEs >-----#
    ResultSS_RSRP_Item_ExtIEs = CLASS(name='ResultSS-RSRP-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultSS_RSRP_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultSS-RSRP-PerSSB >-----#
    ResultSS_RSRP_PerSSB = SEQ_OF(name='ResultSS-RSRP-PerSSB', mode=MODE_TYPE)
    _ResultSS_RSRP_PerSSB__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultSS-RSRP-PerSSB-Item')))
    ResultSS_RSRP_PerSSB._cont = _ResultSS_RSRP_PerSSB__item_
    ResultSS_RSRP_PerSSB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< ResultSS-RSRP-PerSSB-Item >-----#
    ResultSS_RSRP_PerSSB_Item = SEQ(name='ResultSS-RSRP-PerSSB-Item', mode=MODE_TYPE)
    _ResultSS_RSRP_PerSSB_Item_sSB_Index = INT(name='sSB-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SSB-Index')))
    _ResultSS_RSRP_PerSSB_Item_valueSS_RSRP = INT(name='valueSS-RSRP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRP-NR')))
    _ResultSS_RSRP_PerSSB_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultSS_RSRP_PerSSB_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__id._const_tab = ____ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__id_tab
    ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__criticality._const_tab = ____ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__criticality_tab
    ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__extensionValue_tab
    ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResultSS_RSRP_PerSSB_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__id),
        ('criticality', ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultSS_RSRP_PerSSB_Item_iE_Extensions__item_._ext = None
    _ResultSS_RSRP_PerSSB_Item_iE_Extensions._cont = __ResultSS_RSRP_PerSSB_Item_iE_Extensions__item_
    _ResultSS_RSRP_PerSSB_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultSS_RSRP_PerSSB_Item._cont = ASN1Dict([
        ('sSB-Index', _ResultSS_RSRP_PerSSB_Item_sSB_Index),
        ('valueSS-RSRP', _ResultSS_RSRP_PerSSB_Item_valueSS_RSRP),
        ('iE-Extensions', _ResultSS_RSRP_PerSSB_Item_iE_Extensions),
        ])
    ResultSS_RSRP_PerSSB_Item._ext = []
    
    #-----< ResultSS-RSRP-PerSSB-Item-ExtIEs >-----#
    ResultSS_RSRP_PerSSB_Item_ExtIEs = CLASS(name='ResultSS-RSRP-PerSSB-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultSS_RSRP_PerSSB_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultSS-RSRQ >-----#
    ResultSS_RSRQ = SEQ_OF(name='ResultSS-RSRQ', mode=MODE_TYPE)
    _ResultSS_RSRQ__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultSS-RSRQ-Item')))
    ResultSS_RSRQ._cont = _ResultSS_RSRQ__item_
    ResultSS_RSRQ._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< ResultSS-RSRQ-Item >-----#
    ResultSS_RSRQ_Item = SEQ(name='ResultSS-RSRQ-Item', mode=MODE_TYPE)
    _ResultSS_RSRQ_Item_nR_PCI = INT(name='nR-PCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NR-PCI')))
    _ResultSS_RSRQ_Item_nR_ARFCN = INT(name='nR-ARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NR-ARFCN')))
    _ResultSS_RSRQ_Item_cGI_NR = SEQ(name='cGI-NR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CGI-NR')), opt=True)
    _ResultSS_RSRQ_Item_valueSS_RSRQ_Cell = INT(name='valueSS-RSRQ-Cell', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRQ-NR')), opt=True)
    _ResultSS_RSRQ_Item_sS_RSRQ_PerSSB = SEQ_OF(name='sS-RSRQ-PerSSB', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResultSS-RSRQ-PerSSB')), opt=True)
    _ResultSS_RSRQ_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultSS_RSRQ_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultSS_RSRQ_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ResultSS_RSRQ_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultSS_RSRQ_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultSS_RSRQ_Item_iE_Extensions__item__id._const_tab = ____ResultSS_RSRQ_Item_iE_Extensions__item__id_tab
    ___ResultSS_RSRQ_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultSS_RSRQ_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResultSS_RSRQ_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResultSS_RSRQ_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultSS_RSRQ_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultSS_RSRQ_Item_iE_Extensions__item__criticality._const_tab = ____ResultSS_RSRQ_Item_iE_Extensions__item__criticality_tab
    ___ResultSS_RSRQ_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResultSS_RSRQ_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResultSS_RSRQ_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResultSS_RSRQ_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultSS_RSRQ_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultSS_RSRQ_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultSS_RSRQ_Item_iE_Extensions__item__extensionValue_tab
    ___ResultSS_RSRQ_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResultSS_RSRQ_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResultSS_RSRQ_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResultSS_RSRQ_Item_iE_Extensions__item__id),
        ('criticality', ___ResultSS_RSRQ_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ResultSS_RSRQ_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultSS_RSRQ_Item_iE_Extensions__item_._ext = None
    _ResultSS_RSRQ_Item_iE_Extensions._cont = __ResultSS_RSRQ_Item_iE_Extensions__item_
    _ResultSS_RSRQ_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultSS_RSRQ_Item._cont = ASN1Dict([
        ('nR-PCI', _ResultSS_RSRQ_Item_nR_PCI),
        ('nR-ARFCN', _ResultSS_RSRQ_Item_nR_ARFCN),
        ('cGI-NR', _ResultSS_RSRQ_Item_cGI_NR),
        ('valueSS-RSRQ-Cell', _ResultSS_RSRQ_Item_valueSS_RSRQ_Cell),
        ('sS-RSRQ-PerSSB', _ResultSS_RSRQ_Item_sS_RSRQ_PerSSB),
        ('iE-Extensions', _ResultSS_RSRQ_Item_iE_Extensions),
        ])
    ResultSS_RSRQ_Item._ext = []
    
    #-----< ResultSS-RSRQ-Item-ExtIEs >-----#
    ResultSS_RSRQ_Item_ExtIEs = CLASS(name='ResultSS-RSRQ-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultSS_RSRQ_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultSS-RSRQ-PerSSB >-----#
    ResultSS_RSRQ_PerSSB = SEQ_OF(name='ResultSS-RSRQ-PerSSB', mode=MODE_TYPE)
    _ResultSS_RSRQ_PerSSB__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultSS-RSRQ-PerSSB-Item')))
    ResultSS_RSRQ_PerSSB._cont = _ResultSS_RSRQ_PerSSB__item_
    ResultSS_RSRQ_PerSSB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< ResultSS-RSRQ-PerSSB-Item >-----#
    ResultSS_RSRQ_PerSSB_Item = SEQ(name='ResultSS-RSRQ-PerSSB-Item', mode=MODE_TYPE)
    _ResultSS_RSRQ_PerSSB_Item_sSB_Index = INT(name='sSB-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SSB-Index')))
    _ResultSS_RSRQ_PerSSB_Item_valueSS_RSRQ = INT(name='valueSS-RSRQ', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRQ-NR')))
    _ResultSS_RSRQ_PerSSB_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__id._const_tab = ____ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__id_tab
    ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__criticality._const_tab = ____ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__criticality_tab
    ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__extensionValue_tab
    ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__id),
        ('criticality', ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item_._ext = None
    _ResultSS_RSRQ_PerSSB_Item_iE_Extensions._cont = __ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item_
    _ResultSS_RSRQ_PerSSB_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultSS_RSRQ_PerSSB_Item._cont = ASN1Dict([
        ('sSB-Index', _ResultSS_RSRQ_PerSSB_Item_sSB_Index),
        ('valueSS-RSRQ', _ResultSS_RSRQ_PerSSB_Item_valueSS_RSRQ),
        ('iE-Extensions', _ResultSS_RSRQ_PerSSB_Item_iE_Extensions),
        ])
    ResultSS_RSRQ_PerSSB_Item._ext = []
    
    #-----< ResultSS-RSRQ-PerSSB-Item-ExtIEs >-----#
    ResultSS_RSRQ_PerSSB_Item_ExtIEs = CLASS(name='ResultSS-RSRQ-PerSSB-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultSS_RSRQ_PerSSB_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultGERAN >-----#
    ResultGERAN = SEQ_OF(name='ResultGERAN', mode=MODE_TYPE)
    _ResultGERAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultGERAN-Item')))
    ResultGERAN._cont = _ResultGERAN__item_
    ResultGERAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< ResultGERAN-Item >-----#
    ResultGERAN_Item = SEQ(name='ResultGERAN-Item', mode=MODE_TYPE)
    _ResultGERAN_Item_bCCH = INT(name='bCCH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'BCCH')))
    _ResultGERAN_Item_physCellIDGERAN = INT(name='physCellIDGERAN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PhysCellIDGERAN')))
    _ResultGERAN_Item_rSSI = INT(name='rSSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RSSI')))
    _ResultGERAN_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultGERAN_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultGERAN_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ResultGERAN_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultGERAN_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultGERAN_Item_iE_Extensions__item__id._const_tab = ____ResultGERAN_Item_iE_Extensions__item__id_tab
    ___ResultGERAN_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultGERAN_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResultGERAN_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResultGERAN_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultGERAN_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultGERAN_Item_iE_Extensions__item__criticality._const_tab = ____ResultGERAN_Item_iE_Extensions__item__criticality_tab
    ___ResultGERAN_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResultGERAN_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResultGERAN_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResultGERAN_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultGERAN_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultGERAN_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultGERAN_Item_iE_Extensions__item__extensionValue_tab
    ___ResultGERAN_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResultGERAN_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResultGERAN_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResultGERAN_Item_iE_Extensions__item__id),
        ('criticality', ___ResultGERAN_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ResultGERAN_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultGERAN_Item_iE_Extensions__item_._ext = None
    _ResultGERAN_Item_iE_Extensions._cont = __ResultGERAN_Item_iE_Extensions__item_
    _ResultGERAN_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultGERAN_Item._cont = ASN1Dict([
        ('bCCH', _ResultGERAN_Item_bCCH),
        ('physCellIDGERAN', _ResultGERAN_Item_physCellIDGERAN),
        ('rSSI', _ResultGERAN_Item_rSSI),
        ('iE-Extensions', _ResultGERAN_Item_iE_Extensions),
        ])
    ResultGERAN_Item._ext = []
    
    #-----< ResultGERAN-Item-ExtIEs >-----#
    ResultGERAN_Item_ExtIEs = CLASS(name='ResultGERAN-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultGERAN_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultNR >-----#
    ResultNR = SEQ_OF(name='ResultNR', mode=MODE_TYPE)
    _ResultNR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultNR-Item')))
    ResultNR._cont = _ResultNR__item_
    ResultNR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< ResultNR-Item >-----#
    ResultNR_Item = SEQ(name='ResultNR-Item', mode=MODE_TYPE)
    _ResultNR_Item_nR_PCI = INT(name='nR-PCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NR-PCI')))
    _ResultNR_Item_nR_ARFCN = INT(name='nR-ARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NR-ARFCN')))
    _ResultNR_Item_valueSS_RSRP_Cell = INT(name='valueSS-RSRP-Cell', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRP-NR')), opt=True)
    _ResultNR_Item_valueSS_RSRQ_Cell = INT(name='valueSS-RSRQ-Cell', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ValueRSRQ-NR')), opt=True)
    _ResultNR_Item_sS_RSRP_PerSSB = SEQ_OF(name='sS-RSRP-PerSSB', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResultSS-RSRP-PerSSB')), opt=True)
    _ResultNR_Item_sS_RSRQ_PerSSB = SEQ_OF(name='sS-RSRQ-PerSSB', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResultSS-RSRQ-PerSSB')), opt=True)
    _ResultNR_Item_cGI_NR = SEQ(name='cGI-NR', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CGI-NR')), opt=True)
    _ResultNR_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultNR_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultNR_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ResultNR_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultNR_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultNR_Item_iE_Extensions__item__id._const_tab = ____ResultNR_Item_iE_Extensions__item__id_tab
    ___ResultNR_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultNR_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResultNR_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResultNR_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultNR_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultNR_Item_iE_Extensions__item__criticality._const_tab = ____ResultNR_Item_iE_Extensions__item__criticality_tab
    ___ResultNR_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResultNR_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResultNR_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResultNR_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultNR_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultNR_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultNR_Item_iE_Extensions__item__extensionValue_tab
    ___ResultNR_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResultNR_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResultNR_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResultNR_Item_iE_Extensions__item__id),
        ('criticality', ___ResultNR_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ResultNR_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultNR_Item_iE_Extensions__item_._ext = None
    _ResultNR_Item_iE_Extensions._cont = __ResultNR_Item_iE_Extensions__item_
    _ResultNR_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultNR_Item._cont = ASN1Dict([
        ('nR-PCI', _ResultNR_Item_nR_PCI),
        ('nR-ARFCN', _ResultNR_Item_nR_ARFCN),
        ('valueSS-RSRP-Cell', _ResultNR_Item_valueSS_RSRP_Cell),
        ('valueSS-RSRQ-Cell', _ResultNR_Item_valueSS_RSRQ_Cell),
        ('sS-RSRP-PerSSB', _ResultNR_Item_sS_RSRP_PerSSB),
        ('sS-RSRQ-PerSSB', _ResultNR_Item_sS_RSRQ_PerSSB),
        ('cGI-NR', _ResultNR_Item_cGI_NR),
        ('iE-Extensions', _ResultNR_Item_iE_Extensions),
        ])
    ResultNR_Item._ext = []
    
    #-----< ResultNR-Item-ExtIEs >-----#
    ResultNR_Item_ExtIEs = CLASS(name='ResultNR-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultNR_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResultUTRAN >-----#
    ResultUTRAN = SEQ_OF(name='ResultUTRAN', mode=MODE_TYPE)
    _ResultUTRAN__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResultUTRAN-Item')))
    ResultUTRAN._cont = _ResultUTRAN__item_
    ResultUTRAN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< ResultUTRAN-Item >-----#
    ResultUTRAN_Item = SEQ(name='ResultUTRAN-Item', mode=MODE_TYPE)
    _ResultUTRAN_Item_uARFCN = INT(name='uARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'UARFCN')))
    _ResultUTRAN_Item_physCellIDUTRAN = CHOICE(name='physCellIDUTRAN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ResultUTRAN_Item_physCellIDUTRAN_physCellIDUTRA_FDD = INT(name='physCellIDUTRA-FDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PhysCellIDUTRA-FDD')))
    __ResultUTRAN_Item_physCellIDUTRAN_physCellIDUTRA_TDD = INT(name='physCellIDUTRA-TDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PhysCellIDUTRA-TDD')))
    _ResultUTRAN_Item_physCellIDUTRAN._cont = ASN1Dict([
        ('physCellIDUTRA-FDD', __ResultUTRAN_Item_physCellIDUTRAN_physCellIDUTRA_FDD),
        ('physCellIDUTRA-TDD', __ResultUTRAN_Item_physCellIDUTRAN_physCellIDUTRA_TDD),
        ])
    _ResultUTRAN_Item_physCellIDUTRAN._ext = None
    _ResultUTRAN_Item_uTRA_RSCP = INT(name='uTRA-RSCP', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'UTRA-RSCP')), opt=True)
    _ResultUTRAN_Item_uTRA_EcN0 = INT(name='uTRA-EcN0', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'UTRA-EcN0')), opt=True)
    _ResultUTRAN_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResultUTRAN_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ResultUTRAN_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ResultUTRAN_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultUTRAN_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultUTRAN_Item_iE_Extensions__item__id._const_tab = ____ResultUTRAN_Item_iE_Extensions__item__id_tab
    ___ResultUTRAN_Item_iE_Extensions__item__id._const_tab_at = None
    ___ResultUTRAN_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResultUTRAN_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResultUTRAN_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultUTRAN_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultUTRAN_Item_iE_Extensions__item__criticality._const_tab = ____ResultUTRAN_Item_iE_Extensions__item__criticality_tab
    ___ResultUTRAN_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResultUTRAN_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResultUTRAN_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResultUTRAN_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ResultUTRAN_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResultUTRAN_Item_iE_Extensions__item__extensionValue._const_tab = ____ResultUTRAN_Item_iE_Extensions__item__extensionValue_tab
    ___ResultUTRAN_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResultUTRAN_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResultUTRAN_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResultUTRAN_Item_iE_Extensions__item__id),
        ('criticality', ___ResultUTRAN_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___ResultUTRAN_Item_iE_Extensions__item__extensionValue),
        ])
    __ResultUTRAN_Item_iE_Extensions__item_._ext = None
    _ResultUTRAN_Item_iE_Extensions._cont = __ResultUTRAN_Item_iE_Extensions__item_
    _ResultUTRAN_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResultUTRAN_Item._cont = ASN1Dict([
        ('uARFCN', _ResultUTRAN_Item_uARFCN),
        ('physCellIDUTRAN', _ResultUTRAN_Item_physCellIDUTRAN),
        ('uTRA-RSCP', _ResultUTRAN_Item_uTRA_RSCP),
        ('uTRA-EcN0', _ResultUTRAN_Item_uTRA_EcN0),
        ('iE-Extensions', _ResultUTRAN_Item_iE_Extensions),
        ])
    ResultUTRAN_Item._ext = []
    
    #-----< ResultUTRAN-Item-ExtIEs >-----#
    ResultUTRAN_Item_ExtIEs = CLASS(name='ResultUTRAN-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ResultUTRAN_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RSSI >-----#
    RSSI = INT(name='RSSI', mode=MODE_TYPE)
    RSSI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=[], er=[])
    
    #-----< RxTxTimingErrorMargin >-----#
    RxTxTimingErrorMargin = ENUM(name='RxTxTimingErrorMargin', mode=MODE_TYPE)
    RxTxTimingErrorMargin._cont = ASN1Dict([('tc0dot5', 0), ('tc1', 1), ('tc2', 2), ('tc4', 3), ('tc8', 4), ('tc12', 5), ('tc16', 6), ('tc20', 7), ('tc24', 8), ('tc32', 9), ('tc40', 10), ('tc48', 11), ('tc64', 12), ('tc80', 13), ('tc96', 14), ('tc128', 15)])
    RxTxTimingErrorMargin._ext = []
    
    #-----< SCS-SpecificCarrier >-----#
    SCS_SpecificCarrier = SEQ(name='SCS-SpecificCarrier', mode=MODE_TYPE)
    _SCS_SpecificCarrier_offsetToCarrier = INT(name='offsetToCarrier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SCS_SpecificCarrier_offsetToCarrier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2199)], ev=[], er=[])
    _SCS_SpecificCarrier_subcarrierSpacing = ENUM(name='subcarrierSpacing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SCS_SpecificCarrier_subcarrierSpacing._cont = ASN1Dict([('kHz15', 0), ('kHz30', 1), ('kHz60', 2), ('kHz120', 3)])
    _SCS_SpecificCarrier_subcarrierSpacing._ext = []
    _SCS_SpecificCarrier_carrierBandwidth = INT(name='carrierBandwidth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SCS_SpecificCarrier_carrierBandwidth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=275)], ev=[], er=[])
    _SCS_SpecificCarrier_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SCS_SpecificCarrier_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SCS_SpecificCarrier_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____SCS_SpecificCarrier_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SCS_SpecificCarrier_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCS_SpecificCarrier_iE_Extensions__item__id._const_tab = ____SCS_SpecificCarrier_iE_Extensions__item__id_tab
    ___SCS_SpecificCarrier_iE_Extensions__item__id._const_tab_at = None
    ___SCS_SpecificCarrier_iE_Extensions__item__id._const_tab_id = 'id'
    ___SCS_SpecificCarrier_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____SCS_SpecificCarrier_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SCS_SpecificCarrier_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCS_SpecificCarrier_iE_Extensions__item__criticality._const_tab = ____SCS_SpecificCarrier_iE_Extensions__item__criticality_tab
    ___SCS_SpecificCarrier_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SCS_SpecificCarrier_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SCS_SpecificCarrier_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____SCS_SpecificCarrier_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SCS_SpecificCarrier_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SCS_SpecificCarrier_iE_Extensions__item__extensionValue._const_tab = ____SCS_SpecificCarrier_iE_Extensions__item__extensionValue_tab
    ___SCS_SpecificCarrier_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SCS_SpecificCarrier_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SCS_SpecificCarrier_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SCS_SpecificCarrier_iE_Extensions__item__id),
        ('criticality', ___SCS_SpecificCarrier_iE_Extensions__item__criticality),
        ('extensionValue', ___SCS_SpecificCarrier_iE_Extensions__item__extensionValue),
        ])
    __SCS_SpecificCarrier_iE_Extensions__item_._ext = None
    _SCS_SpecificCarrier_iE_Extensions._cont = __SCS_SpecificCarrier_iE_Extensions__item_
    _SCS_SpecificCarrier_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SCS_SpecificCarrier._cont = ASN1Dict([
        ('offsetToCarrier', _SCS_SpecificCarrier_offsetToCarrier),
        ('subcarrierSpacing', _SCS_SpecificCarrier_subcarrierSpacing),
        ('carrierBandwidth', _SCS_SpecificCarrier_carrierBandwidth),
        ('iE-Extensions', _SCS_SpecificCarrier_iE_Extensions),
        ])
    SCS_SpecificCarrier._ext = []
    
    #-----< SCS-SpecificCarrier-ExtIEs >-----#
    SCS_SpecificCarrier_ExtIEs = CLASS(name='SCS-SpecificCarrier-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SCS_SpecificCarrier_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Search-window-information >-----#
    Search_window_information = SEQ(name='Search-window-information', mode=MODE_TYPE)
    _Search_window_information_expectedPropagationDelay = INT(name='expectedPropagationDelay', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Search_window_information_expectedPropagationDelay._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-3841, ub=3841)], ev=[], er=[])
    _Search_window_information_delayUncertainty = INT(name='delayUncertainty', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Search_window_information_delayUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=246)], ev=[], er=[])
    _Search_window_information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Search_window_information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___Search_window_information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____Search_window_information_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____Search_window_information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Search_window_information_iE_Extensions__item__id._const_tab = ____Search_window_information_iE_Extensions__item__id_tab
    ___Search_window_information_iE_Extensions__item__id._const_tab_at = None
    ___Search_window_information_iE_Extensions__item__id._const_tab_id = 'id'
    ___Search_window_information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____Search_window_information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____Search_window_information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Search_window_information_iE_Extensions__item__criticality._const_tab = ____Search_window_information_iE_Extensions__item__criticality_tab
    ___Search_window_information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Search_window_information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Search_window_information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____Search_window_information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____Search_window_information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Search_window_information_iE_Extensions__item__extensionValue._const_tab = ____Search_window_information_iE_Extensions__item__extensionValue_tab
    ___Search_window_information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Search_window_information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Search_window_information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Search_window_information_iE_Extensions__item__id),
        ('criticality', ___Search_window_information_iE_Extensions__item__criticality),
        ('extensionValue', ___Search_window_information_iE_Extensions__item__extensionValue),
        ])
    __Search_window_information_iE_Extensions__item_._ext = None
    _Search_window_information_iE_Extensions._cont = __Search_window_information_iE_Extensions__item_
    _Search_window_information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Search_window_information._cont = ASN1Dict([
        ('expectedPropagationDelay', _Search_window_information_expectedPropagationDelay),
        ('delayUncertainty', _Search_window_information_delayUncertainty),
        ('iE-Extensions', _Search_window_information_iE_Extensions),
        ])
    Search_window_information._ext = []
    
    #-----< Search-window-information-ExtIEs >-----#
    Search_window_information_ExtIEs = CLASS(name='Search-window-information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    Search_window_information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelativeTime1900 >-----#
    RelativeTime1900 = BIT_STR(name='RelativeTime1900', mode=MODE_TYPE)
    RelativeTime1900._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    
    #-----< SFNInitialisationTime-EUTRA >-----#
    SFNInitialisationTime_EUTRA = BIT_STR(name='SFNInitialisationTime-EUTRA', mode=MODE_TYPE)
    SFNInitialisationTime_EUTRA._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    
    #-----< SlotNumber >-----#
    SlotNumber = INT(name='SlotNumber', mode=MODE_TYPE)
    SlotNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=79)], ev=None, er=[])
    
    #-----< SpatialDirectionInformation >-----#
    SpatialDirectionInformation = SEQ(name='SpatialDirectionInformation', mode=MODE_TYPE)
    _SpatialDirectionInformation_nR_PRS_Beam_Information = SEQ(name='nR-PRS-Beam-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NR-PRS-Beam-Information')))
    _SpatialDirectionInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SpatialDirectionInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SpatialDirectionInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____SpatialDirectionInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialDirectionInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialDirectionInformation_iE_Extensions__item__id._const_tab = ____SpatialDirectionInformation_iE_Extensions__item__id_tab
    ___SpatialDirectionInformation_iE_Extensions__item__id._const_tab_at = None
    ___SpatialDirectionInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___SpatialDirectionInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____SpatialDirectionInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialDirectionInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialDirectionInformation_iE_Extensions__item__criticality._const_tab = ____SpatialDirectionInformation_iE_Extensions__item__criticality_tab
    ___SpatialDirectionInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SpatialDirectionInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SpatialDirectionInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____SpatialDirectionInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialDirectionInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialDirectionInformation_iE_Extensions__item__extensionValue._const_tab = ____SpatialDirectionInformation_iE_Extensions__item__extensionValue_tab
    ___SpatialDirectionInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SpatialDirectionInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SpatialDirectionInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SpatialDirectionInformation_iE_Extensions__item__id),
        ('criticality', ___SpatialDirectionInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___SpatialDirectionInformation_iE_Extensions__item__extensionValue),
        ])
    __SpatialDirectionInformation_iE_Extensions__item_._ext = None
    _SpatialDirectionInformation_iE_Extensions._cont = __SpatialDirectionInformation_iE_Extensions__item_
    _SpatialDirectionInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SpatialDirectionInformation._cont = ASN1Dict([
        ('nR-PRS-Beam-Information', _SpatialDirectionInformation_nR_PRS_Beam_Information),
        ('iE-Extensions', _SpatialDirectionInformation_iE_Extensions),
        ])
    SpatialDirectionInformation._ext = []
    
    #-----< SpatialDirectionInformation-ExtIEs >-----#
    SpatialDirectionInformation_ExtIEs = CLASS(name='SpatialDirectionInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SpatialDirectionInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SpatialRelationInfo >-----#
    SpatialRelationInfo = SEQ(name='SpatialRelationInfo', mode=MODE_TYPE)
    _SpatialRelationInfo_spatialRelationforResourceID = SEQ_OF(name='spatialRelationforResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SpatialRelationforResourceID')))
    _SpatialRelationInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SpatialRelationInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SpatialRelationInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____SpatialRelationInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialRelationInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationInfo_iE_Extensions__item__id._const_tab = ____SpatialRelationInfo_iE_Extensions__item__id_tab
    ___SpatialRelationInfo_iE_Extensions__item__id._const_tab_at = None
    ___SpatialRelationInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___SpatialRelationInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____SpatialRelationInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialRelationInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationInfo_iE_Extensions__item__criticality._const_tab = ____SpatialRelationInfo_iE_Extensions__item__criticality_tab
    ___SpatialRelationInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SpatialRelationInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SpatialRelationInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____SpatialRelationInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialRelationInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationInfo_iE_Extensions__item__extensionValue._const_tab = ____SpatialRelationInfo_iE_Extensions__item__extensionValue_tab
    ___SpatialRelationInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SpatialRelationInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SpatialRelationInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SpatialRelationInfo_iE_Extensions__item__id),
        ('criticality', ___SpatialRelationInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___SpatialRelationInfo_iE_Extensions__item__extensionValue),
        ])
    __SpatialRelationInfo_iE_Extensions__item_._ext = None
    _SpatialRelationInfo_iE_Extensions._cont = __SpatialRelationInfo_iE_Extensions__item_
    _SpatialRelationInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SpatialRelationInfo._cont = ASN1Dict([
        ('spatialRelationforResourceID', _SpatialRelationInfo_spatialRelationforResourceID),
        ('iE-Extensions', _SpatialRelationInfo_iE_Extensions),
        ])
    SpatialRelationInfo._ext = []
    
    #-----< SpatialRelationInfo-ExtIEs >-----#
    SpatialRelationInfo_ExtIEs = CLASS(name='SpatialRelationInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SpatialRelationInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SpatialRelationforResourceID >-----#
    SpatialRelationforResourceID = SEQ_OF(name='SpatialRelationforResourceID', mode=MODE_TYPE)
    _SpatialRelationforResourceID__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SpatialRelationforResourceIDItem')))
    SpatialRelationforResourceID._cont = _SpatialRelationforResourceID__item_
    SpatialRelationforResourceID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SpatialRelationforResourceIDItem >-----#
    SpatialRelationforResourceIDItem = SEQ(name='SpatialRelationforResourceIDItem', mode=MODE_TYPE)
    _SpatialRelationforResourceIDItem_referenceSignal = CHOICE(name='referenceSignal', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ReferenceSignal')))
    _SpatialRelationforResourceIDItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SpatialRelationforResourceIDItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____SpatialRelationforResourceIDItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialRelationforResourceIDItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__id._const_tab = ____SpatialRelationforResourceIDItem_iE_Extensions__item__id_tab
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__id._const_tab_at = None
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____SpatialRelationforResourceIDItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialRelationforResourceIDItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__criticality._const_tab = ____SpatialRelationforResourceIDItem_iE_Extensions__item__criticality_tab
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue._const_tab = ____SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue_tab
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SpatialRelationforResourceIDItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SpatialRelationforResourceIDItem_iE_Extensions__item__id),
        ('criticality', ___SpatialRelationforResourceIDItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue),
        ])
    __SpatialRelationforResourceIDItem_iE_Extensions__item_._ext = None
    _SpatialRelationforResourceIDItem_iE_Extensions._cont = __SpatialRelationforResourceIDItem_iE_Extensions__item_
    _SpatialRelationforResourceIDItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SpatialRelationforResourceIDItem._cont = ASN1Dict([
        ('referenceSignal', _SpatialRelationforResourceIDItem_referenceSignal),
        ('iE-Extensions', _SpatialRelationforResourceIDItem_iE_Extensions),
        ])
    SpatialRelationforResourceIDItem._ext = []
    
    #-----< SpatialRelationforResourceIDItem-ExtIEs >-----#
    SpatialRelationforResourceIDItem_ExtIEs = CLASS(name='SpatialRelationforResourceIDItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SpatialRelationforResourceIDItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SpatialRelationPerSRSResource >-----#
    SpatialRelationPerSRSResource = SEQ(name='SpatialRelationPerSRSResource', mode=MODE_TYPE)
    _SpatialRelationPerSRSResource_spatialRelationPerSRSResource_List = SEQ_OF(name='spatialRelationPerSRSResource-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SpatialRelationPerSRSResource-List')))
    _SpatialRelationPerSRSResource_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SpatialRelationPerSRSResource_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SpatialRelationPerSRSResource_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____SpatialRelationPerSRSResource_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialRelationPerSRSResource_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationPerSRSResource_iE_Extensions__item__id._const_tab = ____SpatialRelationPerSRSResource_iE_Extensions__item__id_tab
    ___SpatialRelationPerSRSResource_iE_Extensions__item__id._const_tab_at = None
    ___SpatialRelationPerSRSResource_iE_Extensions__item__id._const_tab_id = 'id'
    ___SpatialRelationPerSRSResource_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____SpatialRelationPerSRSResource_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialRelationPerSRSResource_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationPerSRSResource_iE_Extensions__item__criticality._const_tab = ____SpatialRelationPerSRSResource_iE_Extensions__item__criticality_tab
    ___SpatialRelationPerSRSResource_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SpatialRelationPerSRSResource_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue._const_tab = ____SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue_tab
    ___SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SpatialRelationPerSRSResource_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SpatialRelationPerSRSResource_iE_Extensions__item__id),
        ('criticality', ___SpatialRelationPerSRSResource_iE_Extensions__item__criticality),
        ('extensionValue', ___SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue),
        ])
    __SpatialRelationPerSRSResource_iE_Extensions__item_._ext = None
    _SpatialRelationPerSRSResource_iE_Extensions._cont = __SpatialRelationPerSRSResource_iE_Extensions__item_
    _SpatialRelationPerSRSResource_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SpatialRelationPerSRSResource._cont = ASN1Dict([
        ('spatialRelationPerSRSResource-List', _SpatialRelationPerSRSResource_spatialRelationPerSRSResource_List),
        ('iE-Extensions', _SpatialRelationPerSRSResource_iE_Extensions),
        ])
    SpatialRelationPerSRSResource._ext = []
    
    #-----< SpatialRelationPerSRSResource-ExtIEs >-----#
    SpatialRelationPerSRSResource_ExtIEs = CLASS(name='SpatialRelationPerSRSResource-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SpatialRelationPerSRSResource_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SpatialRelationPerSRSResource-List >-----#
    SpatialRelationPerSRSResource_List = SEQ_OF(name='SpatialRelationPerSRSResource-List', mode=MODE_TYPE)
    _SpatialRelationPerSRSResource_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SpatialRelationPerSRSResourceItem')))
    SpatialRelationPerSRSResource_List._cont = _SpatialRelationPerSRSResource_List__item_
    SpatialRelationPerSRSResource_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< SpatialRelationPerSRSResourceItem >-----#
    SpatialRelationPerSRSResourceItem = SEQ(name='SpatialRelationPerSRSResourceItem', mode=MODE_TYPE)
    _SpatialRelationPerSRSResourceItem_referenceSignal = CHOICE(name='referenceSignal', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ReferenceSignal')))
    _SpatialRelationPerSRSResourceItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SpatialRelationPerSRSResourceItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__id._const_tab = ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__id_tab
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__id._const_tab_at = None
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality._const_tab = ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality_tab
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue._const_tab = ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue_tab
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SpatialRelationPerSRSResourceItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__id),
        ('criticality', ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue),
        ])
    __SpatialRelationPerSRSResourceItem_iE_Extensions__item_._ext = None
    _SpatialRelationPerSRSResourceItem_iE_Extensions._cont = __SpatialRelationPerSRSResourceItem_iE_Extensions__item_
    _SpatialRelationPerSRSResourceItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SpatialRelationPerSRSResourceItem._cont = ASN1Dict([
        ('referenceSignal', _SpatialRelationPerSRSResourceItem_referenceSignal),
        ('iE-Extensions', _SpatialRelationPerSRSResourceItem_iE_Extensions),
        ])
    SpatialRelationPerSRSResourceItem._ext = []
    
    #-----< SpatialRelationPerSRSResourceItem-ExtIEs >-----#
    SpatialRelationPerSRSResourceItem_ExtIEs = CLASS(name='SpatialRelationPerSRSResourceItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SpatialRelationPerSRSResourceItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SpatialRelationPos >-----#
    SpatialRelationPos = CHOICE(name='SpatialRelationPos', mode=MODE_TYPE)
    _SpatialRelationPos_sSBPos = SEQ(name='sSBPos', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SSB')))
    _SpatialRelationPos_pRSInformationPos = SEQ(name='pRSInformationPos', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSInformationPos')))
    _SpatialRelationPos_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __SpatialRelationPos_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___SpatialRelationPos_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___SpatialRelationPos_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SpatialRelationPos_choice_extension_id._const_tab = ___SpatialRelationPos_choice_extension_id_tab
    __SpatialRelationPos_choice_extension_id._const_tab_at = None
    __SpatialRelationPos_choice_extension_id._const_tab_id = 'id'
    __SpatialRelationPos_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___SpatialRelationPos_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___SpatialRelationPos_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SpatialRelationPos_choice_extension_criticality._const_tab = ___SpatialRelationPos_choice_extension_criticality_tab
    __SpatialRelationPos_choice_extension_criticality._const_tab_at = ('..', 'id')
    __SpatialRelationPos_choice_extension_criticality._const_tab_id = 'criticality'
    __SpatialRelationPos_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___SpatialRelationPos_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___SpatialRelationPos_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SpatialRelationPos_choice_extension_value._const_tab = ___SpatialRelationPos_choice_extension_value_tab
    __SpatialRelationPos_choice_extension_value._const_tab_at = ('..', 'id')
    __SpatialRelationPos_choice_extension_value._const_tab_id = 'Value'
    _SpatialRelationPos_choice_extension._cont = ASN1Dict([
        ('id', __SpatialRelationPos_choice_extension_id),
        ('criticality', __SpatialRelationPos_choice_extension_criticality),
        ('value', __SpatialRelationPos_choice_extension_value),
        ])
    _SpatialRelationPos_choice_extension._ext = None
    SpatialRelationPos._cont = ASN1Dict([
        ('sSBPos', _SpatialRelationPos_sSBPos),
        ('pRSInformationPos', _SpatialRelationPos_pRSInformationPos),
        ('choice-extension', _SpatialRelationPos_choice_extension),
        ])
    SpatialRelationPos._ext = None
    
    #-----< SpatialInformationPos-ExtIEs >-----#
    SpatialInformationPos_ExtIEs = CLASS(name='SpatialInformationPos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    SpatialInformationPos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRSConfig >-----#
    SRSConfig = SEQ(name='SRSConfig', mode=MODE_TYPE)
    _SRSConfig_sRSResource_List = SEQ_OF(name='sRSResource-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSResource-List')), opt=True)
    _SRSConfig_posSRSResource_List = SEQ_OF(name='posSRSResource-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PosSRSResource-List')), opt=True)
    _SRSConfig_sRSResourceSet_List = SEQ_OF(name='sRSResourceSet-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSResourceSet-List')), opt=True)
    _SRSConfig_posSRSResourceSet_List = SEQ_OF(name='posSRSResourceSet-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PosSRSResourceSet-List')), opt=True)
    _SRSConfig_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSConfig_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SRSConfig_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____SRSConfig_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSConfig_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSConfig_iE_Extensions__item__id._const_tab = ____SRSConfig_iE_Extensions__item__id_tab
    ___SRSConfig_iE_Extensions__item__id._const_tab_at = None
    ___SRSConfig_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRSConfig_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____SRSConfig_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSConfig_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSConfig_iE_Extensions__item__criticality._const_tab = ____SRSConfig_iE_Extensions__item__criticality_tab
    ___SRSConfig_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRSConfig_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRSConfig_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____SRSConfig_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSConfig_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSConfig_iE_Extensions__item__extensionValue._const_tab = ____SRSConfig_iE_Extensions__item__extensionValue_tab
    ___SRSConfig_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRSConfig_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRSConfig_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRSConfig_iE_Extensions__item__id),
        ('criticality', ___SRSConfig_iE_Extensions__item__criticality),
        ('extensionValue', ___SRSConfig_iE_Extensions__item__extensionValue),
        ])
    __SRSConfig_iE_Extensions__item_._ext = None
    _SRSConfig_iE_Extensions._cont = __SRSConfig_iE_Extensions__item_
    _SRSConfig_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSConfig._cont = ASN1Dict([
        ('sRSResource-List', _SRSConfig_sRSResource_List),
        ('posSRSResource-List', _SRSConfig_posSRSResource_List),
        ('sRSResourceSet-List', _SRSConfig_sRSResourceSet_List),
        ('posSRSResourceSet-List', _SRSConfig_posSRSResourceSet_List),
        ('iE-Extensions', _SRSConfig_iE_Extensions),
        ])
    SRSConfig._ext = []
    
    #-----< SRSConfig-ExtIEs >-----#
    SRSConfig_ExtIEs = CLASS(name='SRSConfig-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SRSConfig_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRSCarrier-List >-----#
    SRSCarrier_List = SEQ_OF(name='SRSCarrier-List', mode=MODE_TYPE)
    _SRSCarrier_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSCarrier-List-Item')))
    SRSCarrier_List._cont = _SRSCarrier_List__item_
    SRSCarrier_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SRSCarrier-List-Item >-----#
    SRSCarrier_List_Item = SEQ(name='SRSCarrier-List-Item', mode=MODE_TYPE)
    _SRSCarrier_List_Item_pointA = INT(name='pointA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSCarrier_List_Item_pointA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _SRSCarrier_List_Item_uplinkChannelBW_PerSCS_List = SEQ_OF(name='uplinkChannelBW-PerSCS-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'UplinkChannelBW-PerSCS-List')))
    _SRSCarrier_List_Item_activeULBWP = SEQ(name='activeULBWP', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ActiveULBWP')))
    _SRSCarrier_List_Item_pCI_NR = INT(name='pCI-NR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SRSCarrier_List_Item_pCI_NR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1007)], ev=None, er=[])
    _SRSCarrier_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSCarrier_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SRSCarrier_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____SRSCarrier_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSCarrier_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSCarrier_List_Item_iE_Extensions__item__id._const_tab = ____SRSCarrier_List_Item_iE_Extensions__item__id_tab
    ___SRSCarrier_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___SRSCarrier_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRSCarrier_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____SRSCarrier_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSCarrier_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSCarrier_List_Item_iE_Extensions__item__criticality._const_tab = ____SRSCarrier_List_Item_iE_Extensions__item__criticality_tab
    ___SRSCarrier_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRSCarrier_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRSCarrier_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____SRSCarrier_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSCarrier_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSCarrier_List_Item_iE_Extensions__item__extensionValue._const_tab = ____SRSCarrier_List_Item_iE_Extensions__item__extensionValue_tab
    ___SRSCarrier_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRSCarrier_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRSCarrier_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRSCarrier_List_Item_iE_Extensions__item__id),
        ('criticality', ___SRSCarrier_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SRSCarrier_List_Item_iE_Extensions__item__extensionValue),
        ])
    __SRSCarrier_List_Item_iE_Extensions__item_._ext = None
    _SRSCarrier_List_Item_iE_Extensions._cont = __SRSCarrier_List_Item_iE_Extensions__item_
    _SRSCarrier_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSCarrier_List_Item._cont = ASN1Dict([
        ('pointA', _SRSCarrier_List_Item_pointA),
        ('uplinkChannelBW-PerSCS-List', _SRSCarrier_List_Item_uplinkChannelBW_PerSCS_List),
        ('activeULBWP', _SRSCarrier_List_Item_activeULBWP),
        ('pCI-NR', _SRSCarrier_List_Item_pCI_NR),
        ('iE-Extensions', _SRSCarrier_List_Item_iE_Extensions),
        ])
    SRSCarrier_List_Item._ext = []
    
    #-----< SRSCarrier-List-Item-ExtIEs >-----#
    SRSCarrier_List_Item_ExtIEs = CLASS(name='SRSCarrier-List-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SRSCarrier_List_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRSConfiguration >-----#
    SRSConfiguration = SEQ(name='SRSConfiguration', mode=MODE_TYPE)
    _SRSConfiguration_sRSCarrier_List = SEQ_OF(name='sRSCarrier-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSCarrier-List')))
    _SRSConfiguration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SRSConfiguration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____SRSConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSConfiguration_iE_Extensions__item__id._const_tab = ____SRSConfiguration_iE_Extensions__item__id_tab
    ___SRSConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___SRSConfiguration_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRSConfiguration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____SRSConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSConfiguration_iE_Extensions__item__criticality._const_tab = ____SRSConfiguration_iE_Extensions__item__criticality_tab
    ___SRSConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRSConfiguration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRSConfiguration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____SRSConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSConfiguration_iE_Extensions__item__extensionValue._const_tab = ____SRSConfiguration_iE_Extensions__item__extensionValue_tab
    ___SRSConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRSConfiguration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRSConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRSConfiguration_iE_Extensions__item__id),
        ('criticality', ___SRSConfiguration_iE_Extensions__item__criticality),
        ('extensionValue', ___SRSConfiguration_iE_Extensions__item__extensionValue),
        ])
    __SRSConfiguration_iE_Extensions__item_._ext = None
    _SRSConfiguration_iE_Extensions._cont = __SRSConfiguration_iE_Extensions__item_
    _SRSConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSConfiguration._cont = ASN1Dict([
        ('sRSCarrier-List', _SRSConfiguration_sRSCarrier_List),
        ('iE-Extensions', _SRSConfiguration_iE_Extensions),
        ])
    SRSConfiguration._ext = []
    
    #-----< SRSConfiguration-ExtIEs >-----#
    SRSConfiguration_ExtIEs = CLASS(name='SRSConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SRSConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SrsFrequency >-----#
    SrsFrequency = INT(name='SrsFrequency', mode=MODE_TYPE)
    SrsFrequency._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    
    #-----< SRSPortIndex >-----#
    SRSPortIndex = ENUM(name='SRSPortIndex', mode=MODE_TYPE)
    SRSPortIndex._cont = ASN1Dict([('id1000', 0), ('id1001', 1), ('id1002', 2), ('id1003', 3)])
    SRSPortIndex._ext = []
    
    #-----< SRSPosResourceID >-----#
    SRSPosResourceID = INT(name='SRSPosResourceID', mode=MODE_TYPE)
    SRSPosResourceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< SRSResource >-----#
    SRSResource = SEQ(name='SRSResource', mode=MODE_TYPE)
    _SRSResource_sRSResourceID = INT(name='sRSResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSResourceID')))
    _SRSResource_nrofSRS_Ports = ENUM(name='nrofSRS-Ports', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_nrofSRS_Ports._cont = ASN1Dict([('port1', 0), ('ports2', 1), ('ports4', 2)])
    _SRSResource_nrofSRS_Ports._ext = None
    _SRSResource_transmissionComb = CHOICE(name='transmissionComb', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TransmissionComb')))
    _SRSResource_startPosition = INT(name='startPosition', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_startPosition._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=13)], ev=None, er=[])
    _SRSResource_nrofSymbols = ENUM(name='nrofSymbols', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_nrofSymbols._cont = ASN1Dict([('n1', 0), ('n2', 1), ('n4', 2)])
    _SRSResource_nrofSymbols._ext = None
    _SRSResource_repetitionFactor = ENUM(name='repetitionFactor', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_repetitionFactor._cont = ASN1Dict([('n1', 0), ('n2', 1), ('n4', 2)])
    _SRSResource_repetitionFactor._ext = None
    _SRSResource_freqDomainPosition = INT(name='freqDomainPosition', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_freqDomainPosition._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=67)], ev=None, er=[])
    _SRSResource_freqDomainShift = INT(name='freqDomainShift', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_freqDomainShift._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=268)], ev=None, er=[])
    _SRSResource_c_SRS = INT(name='c-SRS', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_c_SRS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _SRSResource_b_SRS = INT(name='b-SRS', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_b_SRS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _SRSResource_b_hop = INT(name='b-hop', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_b_hop._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _SRSResource_groupOrSequenceHopping = ENUM(name='groupOrSequenceHopping', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_groupOrSequenceHopping._cont = ASN1Dict([('neither', 0), ('groupHopping', 1), ('sequenceHopping', 2)])
    _SRSResource_groupOrSequenceHopping._ext = None
    _SRSResource_resourceType = CHOICE(name='resourceType', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResourceType')))
    _SRSResource_sequenceId = INT(name='sequenceId', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResource_sequenceId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    _SRSResource_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSResource_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SRSResource_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____SRSResource_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSResource_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResource_iE_Extensions__item__id._const_tab = ____SRSResource_iE_Extensions__item__id_tab
    ___SRSResource_iE_Extensions__item__id._const_tab_at = None
    ___SRSResource_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRSResource_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____SRSResource_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSResource_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResource_iE_Extensions__item__criticality._const_tab = ____SRSResource_iE_Extensions__item__criticality_tab
    ___SRSResource_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRSResource_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRSResource_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____SRSResource_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSResource_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResource_iE_Extensions__item__extensionValue._const_tab = ____SRSResource_iE_Extensions__item__extensionValue_tab
    ___SRSResource_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRSResource_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRSResource_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRSResource_iE_Extensions__item__id),
        ('criticality', ___SRSResource_iE_Extensions__item__criticality),
        ('extensionValue', ___SRSResource_iE_Extensions__item__extensionValue),
        ])
    __SRSResource_iE_Extensions__item_._ext = None
    _SRSResource_iE_Extensions._cont = __SRSResource_iE_Extensions__item_
    _SRSResource_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSResource._cont = ASN1Dict([
        ('sRSResourceID', _SRSResource_sRSResourceID),
        ('nrofSRS-Ports', _SRSResource_nrofSRS_Ports),
        ('transmissionComb', _SRSResource_transmissionComb),
        ('startPosition', _SRSResource_startPosition),
        ('nrofSymbols', _SRSResource_nrofSymbols),
        ('repetitionFactor', _SRSResource_repetitionFactor),
        ('freqDomainPosition', _SRSResource_freqDomainPosition),
        ('freqDomainShift', _SRSResource_freqDomainShift),
        ('c-SRS', _SRSResource_c_SRS),
        ('b-SRS', _SRSResource_b_SRS),
        ('b-hop', _SRSResource_b_hop),
        ('groupOrSequenceHopping', _SRSResource_groupOrSequenceHopping),
        ('resourceType', _SRSResource_resourceType),
        ('sequenceId', _SRSResource_sequenceId),
        ('iE-Extensions', _SRSResource_iE_Extensions),
        ])
    SRSResource._ext = []
    
    #-----< SRSResource-ExtIEs >-----#
    SRSResource_ExtIEs = CLASS(name='SRSResource-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SRSResource_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRSResourceID >-----#
    SRSResourceID = INT(name='SRSResourceID', mode=MODE_TYPE)
    SRSResourceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< SRSResource-List >-----#
    SRSResource_List = SEQ_OF(name='SRSResource-List', mode=MODE_TYPE)
    _SRSResource_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSResource')))
    SRSResource_List._cont = _SRSResource_List__item_
    SRSResource_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SRSResourceSet-List >-----#
    SRSResourceSet_List = SEQ_OF(name='SRSResourceSet-List', mode=MODE_TYPE)
    _SRSResourceSet_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSResourceSet')))
    SRSResourceSet_List._cont = _SRSResourceSet_List__item_
    SRSResourceSet_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< SRSResourceID-List >-----#
    SRSResourceID_List = SEQ_OF(name='SRSResourceID-List', mode=MODE_TYPE)
    _SRSResourceID_List__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSResourceID')))
    SRSResourceID_List._cont = _SRSResourceID_List__item_
    SRSResourceID_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< SRSResourceSet >-----#
    SRSResourceSet = SEQ(name='SRSResourceSet', mode=MODE_TYPE)
    _SRSResourceSet_sRSResourceSetID = INT(name='sRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRSResourceSet_sRSResourceSetID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _SRSResourceSet_sRSResourceID_List = SEQ_OF(name='sRSResourceID-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSResourceID-List')))
    _SRSResourceSet_resourceSetType = CHOICE(name='resourceSetType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ResourceSetType')))
    _SRSResourceSet_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSResourceSet_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SRSResourceSet_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____SRSResourceSet_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSResourceSet_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceSet_iE_Extensions__item__id._const_tab = ____SRSResourceSet_iE_Extensions__item__id_tab
    ___SRSResourceSet_iE_Extensions__item__id._const_tab_at = None
    ___SRSResourceSet_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRSResourceSet_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____SRSResourceSet_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSResourceSet_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceSet_iE_Extensions__item__criticality._const_tab = ____SRSResourceSet_iE_Extensions__item__criticality_tab
    ___SRSResourceSet_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRSResourceSet_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRSResourceSet_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____SRSResourceSet_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSResourceSet_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceSet_iE_Extensions__item__extensionValue._const_tab = ____SRSResourceSet_iE_Extensions__item__extensionValue_tab
    ___SRSResourceSet_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRSResourceSet_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRSResourceSet_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRSResourceSet_iE_Extensions__item__id),
        ('criticality', ___SRSResourceSet_iE_Extensions__item__criticality),
        ('extensionValue', ___SRSResourceSet_iE_Extensions__item__extensionValue),
        ])
    __SRSResourceSet_iE_Extensions__item_._ext = None
    _SRSResourceSet_iE_Extensions._cont = __SRSResourceSet_iE_Extensions__item_
    _SRSResourceSet_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSResourceSet._cont = ASN1Dict([
        ('sRSResourceSetID', _SRSResourceSet_sRSResourceSetID),
        ('sRSResourceID-List', _SRSResourceSet_sRSResourceID_List),
        ('resourceSetType', _SRSResourceSet_resourceSetType),
        ('iE-Extensions', _SRSResourceSet_iE_Extensions),
        ])
    SRSResourceSet._ext = []
    
    #-----< SRSResourceSet-ExtIEs >-----#
    SRSResourceSet_ExtIEs = CLASS(name='SRSResourceSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SRSResourceSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRSResourceSetID >-----#
    SRSResourceSetID = INT(name='SRSResourceSetID', mode=MODE_TYPE)
    SRSResourceSetID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    
    #-----< SRSResourceTrigger >-----#
    SRSResourceTrigger = SEQ(name='SRSResourceTrigger', mode=MODE_TYPE)
    _SRSResourceTrigger_aperiodicSRSResourceTriggerList = SEQ_OF(name='aperiodicSRSResourceTriggerList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'AperiodicSRSResourceTriggerList')))
    _SRSResourceTrigger_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSResourceTrigger_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SRSResourceTrigger_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____SRSResourceTrigger_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSResourceTrigger_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceTrigger_iE_Extensions__item__id._const_tab = ____SRSResourceTrigger_iE_Extensions__item__id_tab
    ___SRSResourceTrigger_iE_Extensions__item__id._const_tab_at = None
    ___SRSResourceTrigger_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRSResourceTrigger_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____SRSResourceTrigger_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSResourceTrigger_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceTrigger_iE_Extensions__item__criticality._const_tab = ____SRSResourceTrigger_iE_Extensions__item__criticality_tab
    ___SRSResourceTrigger_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRSResourceTrigger_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRSResourceTrigger_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____SRSResourceTrigger_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSResourceTrigger_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceTrigger_iE_Extensions__item__extensionValue._const_tab = ____SRSResourceTrigger_iE_Extensions__item__extensionValue_tab
    ___SRSResourceTrigger_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRSResourceTrigger_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRSResourceTrigger_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRSResourceTrigger_iE_Extensions__item__id),
        ('criticality', ___SRSResourceTrigger_iE_Extensions__item__criticality),
        ('extensionValue', ___SRSResourceTrigger_iE_Extensions__item__extensionValue),
        ])
    __SRSResourceTrigger_iE_Extensions__item_._ext = None
    _SRSResourceTrigger_iE_Extensions._cont = __SRSResourceTrigger_iE_Extensions__item_
    _SRSResourceTrigger_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSResourceTrigger._cont = ASN1Dict([
        ('aperiodicSRSResourceTriggerList', _SRSResourceTrigger_aperiodicSRSResourceTriggerList),
        ('iE-Extensions', _SRSResourceTrigger_iE_Extensions),
        ])
    SRSResourceTrigger._ext = []
    
    #-----< SRSResourceTrigger-ExtIEs >-----#
    SRSResourceTrigger_ExtIEs = CLASS(name='SRSResourceTrigger-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SRSResourceTrigger_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRSResourcetype >-----#
    SRSResourcetype = SEQ(name='SRSResourcetype', mode=MODE_TYPE)
    _SRSResourcetype_sRSResourceTypeChoice = CHOICE(name='sRSResourceTypeChoice', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSResourceTypeChoice')))
    _SRSResourcetype_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSResourcetype_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SRSResourcetype_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____SRSResourcetype_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____SRSResourcetype_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSPortIndex')))
    ____SRSResourcetype_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 100), ('criticality', 'ignore'), ('Extension', _____SRSResourcetype_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SRSResourcetype_iE_Extensions__item__id._const_tab = ____SRSResourcetype_iE_Extensions__item__id_tab
    ___SRSResourcetype_iE_Extensions__item__id._const_tab_at = None
    ___SRSResourcetype_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRSResourcetype_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ___SRSResourcetype_iE_Extensions__item__criticality._const_tab = ____SRSResourcetype_iE_Extensions__item__id_tab
    ___SRSResourcetype_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRSResourcetype_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRSResourcetype_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ___SRSResourcetype_iE_Extensions__item__extensionValue._const_tab = ____SRSResourcetype_iE_Extensions__item__id_tab
    ___SRSResourcetype_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRSResourcetype_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRSResourcetype_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRSResourcetype_iE_Extensions__item__id),
        ('criticality', ___SRSResourcetype_iE_Extensions__item__criticality),
        ('extensionValue', ___SRSResourcetype_iE_Extensions__item__extensionValue),
        ])
    __SRSResourcetype_iE_Extensions__item_._ext = None
    _SRSResourcetype_iE_Extensions._cont = __SRSResourcetype_iE_Extensions__item_
    _SRSResourcetype_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSResourcetype._cont = ASN1Dict([
        ('sRSResourceTypeChoice', _SRSResourcetype_sRSResourceTypeChoice),
        ('iE-Extensions', _SRSResourcetype_iE_Extensions),
        ])
    SRSResourcetype._ext = []
    
    #-----< SRSResourcetype-ExtIEs >-----#
    SRSResourcetype_ExtIEs = CLASS(name='SRSResourcetype-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _SRSResourcetype_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSPortIndex')))
    SRSResourcetype_ExtIEs._val = ASN1Set(rv=[dict([('id', 100), ('criticality', 'ignore'), ('Extension', _SRSResourcetype_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SRSResourceTypeChoice >-----#
    SRSResourceTypeChoice = CHOICE(name='SRSResourceTypeChoice', mode=MODE_TYPE)
    _SRSResourceTypeChoice_sRSResourceInfo = SEQ(name='sRSResourceInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSInfo')))
    _SRSResourceTypeChoice_posSRSResourceInfo = SEQ(name='posSRSResourceInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PosSRSInfo')))
    SRSResourceTypeChoice._cont = ASN1Dict([
        ('sRSResourceInfo', _SRSResourceTypeChoice_sRSResourceInfo),
        ('posSRSResourceInfo', _SRSResourceTypeChoice_posSRSResourceInfo),
        ])
    SRSResourceTypeChoice._ext = []
    
    #-----< SRSInfo >-----#
    SRSInfo = SEQ(name='SRSInfo', mode=MODE_TYPE)
    _SRSInfo_sRSResource = INT(name='sRSResource', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSResourceID')))
    SRSInfo._cont = ASN1Dict([
        ('sRSResource', _SRSInfo_sRSResource),
        ])
    SRSInfo._ext = []
    
    #-----< SRSTransmissionStatus >-----#
    SRSTransmissionStatus = ENUM(name='SRSTransmissionStatus', mode=MODE_TYPE)
    SRSTransmissionStatus._cont = ASN1Dict([('stopped', 0)])
    SRSTransmissionStatus._ext = []
    
    #-----< PosSRSInfo >-----#
    PosSRSInfo = SEQ(name='PosSRSInfo', mode=MODE_TYPE)
    _PosSRSInfo_posSRSResourceID = INT(name='posSRSResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSPosResourceID')))
    PosSRSInfo._cont = ASN1Dict([
        ('posSRSResourceID', _PosSRSInfo_posSRSResourceID),
        ])
    PosSRSInfo._ext = []
    
    #-----< SSBInfo >-----#
    SSBInfo = SEQ(name='SSBInfo', mode=MODE_TYPE)
    _SSBInfo_listOfSSBInfo = SEQ_OF(name='listOfSSBInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SSBInfo_listOfSSBInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SSBInfoItem')))
    _SSBInfo_listOfSSBInfo._cont = __SSBInfo_listOfSSBInfo__item_
    _SSBInfo_listOfSSBInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    _SSBInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SSBInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SSBInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____SSBInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SSBInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBInfo_iE_Extensions__item__id._const_tab = ____SSBInfo_iE_Extensions__item__id_tab
    ___SSBInfo_iE_Extensions__item__id._const_tab_at = None
    ___SSBInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___SSBInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____SSBInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SSBInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBInfo_iE_Extensions__item__criticality._const_tab = ____SSBInfo_iE_Extensions__item__criticality_tab
    ___SSBInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SSBInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SSBInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____SSBInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SSBInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBInfo_iE_Extensions__item__extensionValue._const_tab = ____SSBInfo_iE_Extensions__item__extensionValue_tab
    ___SSBInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SSBInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SSBInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SSBInfo_iE_Extensions__item__id),
        ('criticality', ___SSBInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___SSBInfo_iE_Extensions__item__extensionValue),
        ])
    __SSBInfo_iE_Extensions__item_._ext = None
    _SSBInfo_iE_Extensions._cont = __SSBInfo_iE_Extensions__item_
    _SSBInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SSBInfo._cont = ASN1Dict([
        ('listOfSSBInfo', _SSBInfo_listOfSSBInfo),
        ('iE-Extensions', _SSBInfo_iE_Extensions),
        ])
    SSBInfo._ext = []
    
    #-----< SSBInfo-ExtIEs >-----#
    SSBInfo_ExtIEs = CLASS(name='SSBInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SSBInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSBInfoItem >-----#
    SSBInfoItem = SEQ(name='SSBInfoItem', mode=MODE_TYPE)
    _SSBInfoItem_sSB_Configuration = SEQ(name='sSB-Configuration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TF-Configuration')))
    _SSBInfoItem_pCI_NR = INT(name='pCI-NR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBInfoItem_pCI_NR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1007)], ev=None, er=[])
    _SSBInfoItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SSBInfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SSBInfoItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____SSBInfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SSBInfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBInfoItem_iE_Extensions__item__id._const_tab = ____SSBInfoItem_iE_Extensions__item__id_tab
    ___SSBInfoItem_iE_Extensions__item__id._const_tab_at = None
    ___SSBInfoItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SSBInfoItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____SSBInfoItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SSBInfoItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBInfoItem_iE_Extensions__item__criticality._const_tab = ____SSBInfoItem_iE_Extensions__item__criticality_tab
    ___SSBInfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SSBInfoItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SSBInfoItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____SSBInfoItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SSBInfoItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSBInfoItem_iE_Extensions__item__extensionValue._const_tab = ____SSBInfoItem_iE_Extensions__item__extensionValue_tab
    ___SSBInfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SSBInfoItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SSBInfoItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SSBInfoItem_iE_Extensions__item__id),
        ('criticality', ___SSBInfoItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SSBInfoItem_iE_Extensions__item__extensionValue),
        ])
    __SSBInfoItem_iE_Extensions__item_._ext = None
    _SSBInfoItem_iE_Extensions._cont = __SSBInfoItem_iE_Extensions__item_
    _SSBInfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SSBInfoItem._cont = ASN1Dict([
        ('sSB-Configuration', _SSBInfoItem_sSB_Configuration),
        ('pCI-NR', _SSBInfoItem_pCI_NR),
        ('iE-Extensions', _SSBInfoItem_iE_Extensions),
        ])
    SSBInfoItem._ext = []
    
    #-----< SSBInfoItem-ExtIEs >-----#
    SSBInfoItem_ExtIEs = CLASS(name='SSBInfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SSBInfoItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSB >-----#
    SSB = SEQ(name='SSB', mode=MODE_TYPE)
    _SSB_pCI_NR = INT(name='pCI-NR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSB_pCI_NR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1007)], ev=None, er=[])
    _SSB_ssb_index = INT(name='ssb-index', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SSB-Index')), opt=True)
    _SSB_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SSB_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SSB_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____SSB_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SSB_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSB_iE_Extensions__item__id._const_tab = ____SSB_iE_Extensions__item__id_tab
    ___SSB_iE_Extensions__item__id._const_tab_at = None
    ___SSB_iE_Extensions__item__id._const_tab_id = 'id'
    ___SSB_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____SSB_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SSB_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSB_iE_Extensions__item__criticality._const_tab = ____SSB_iE_Extensions__item__criticality_tab
    ___SSB_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SSB_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SSB_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____SSB_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SSB_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SSB_iE_Extensions__item__extensionValue._const_tab = ____SSB_iE_Extensions__item__extensionValue_tab
    ___SSB_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SSB_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SSB_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SSB_iE_Extensions__item__id),
        ('criticality', ___SSB_iE_Extensions__item__criticality),
        ('extensionValue', ___SSB_iE_Extensions__item__extensionValue),
        ])
    __SSB_iE_Extensions__item_._ext = None
    _SSB_iE_Extensions._cont = __SSB_iE_Extensions__item_
    _SSB_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SSB._cont = ASN1Dict([
        ('pCI-NR', _SSB_pCI_NR),
        ('ssb-index', _SSB_ssb_index),
        ('iE-Extensions', _SSB_iE_Extensions),
        ])
    SSB._ext = []
    
    #-----< SSB-ExtIEs >-----#
    SSB_ExtIEs = CLASS(name='SSB-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SSB_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSBBurstPosition >-----#
    SSBBurstPosition = CHOICE(name='SSBBurstPosition', mode=MODE_TYPE)
    _SSBBurstPosition_shortBitmap = BIT_STR(name='shortBitmap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBBurstPosition_shortBitmap._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _SSBBurstPosition_mediumBitmap = BIT_STR(name='mediumBitmap', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBBurstPosition_mediumBitmap._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _SSBBurstPosition_longBitmap = BIT_STR(name='longBitmap', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SSBBurstPosition_longBitmap._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    _SSBBurstPosition_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __SSBBurstPosition_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___SSBBurstPosition_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___SSBBurstPosition_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SSBBurstPosition_choice_extension_id._const_tab = ___SSBBurstPosition_choice_extension_id_tab
    __SSBBurstPosition_choice_extension_id._const_tab_at = None
    __SSBBurstPosition_choice_extension_id._const_tab_id = 'id'
    __SSBBurstPosition_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___SSBBurstPosition_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___SSBBurstPosition_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SSBBurstPosition_choice_extension_criticality._const_tab = ___SSBBurstPosition_choice_extension_criticality_tab
    __SSBBurstPosition_choice_extension_criticality._const_tab_at = ('..', 'id')
    __SSBBurstPosition_choice_extension_criticality._const_tab_id = 'criticality'
    __SSBBurstPosition_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___SSBBurstPosition_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___SSBBurstPosition_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SSBBurstPosition_choice_extension_value._const_tab = ___SSBBurstPosition_choice_extension_value_tab
    __SSBBurstPosition_choice_extension_value._const_tab_at = ('..', 'id')
    __SSBBurstPosition_choice_extension_value._const_tab_id = 'Value'
    _SSBBurstPosition_choice_extension._cont = ASN1Dict([
        ('id', __SSBBurstPosition_choice_extension_id),
        ('criticality', __SSBBurstPosition_choice_extension_criticality),
        ('value', __SSBBurstPosition_choice_extension_value),
        ])
    _SSBBurstPosition_choice_extension._ext = None
    SSBBurstPosition._cont = ASN1Dict([
        ('shortBitmap', _SSBBurstPosition_shortBitmap),
        ('mediumBitmap', _SSBBurstPosition_mediumBitmap),
        ('longBitmap', _SSBBurstPosition_longBitmap),
        ('choice-extension', _SSBBurstPosition_choice_extension),
        ])
    SSBBurstPosition._ext = None
    
    #-----< SSBBurstPosition-ExtIEs >-----#
    SSBBurstPosition_ExtIEs = CLASS(name='SSBBurstPosition-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    SSBBurstPosition_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SSB-Index >-----#
    SSB_Index = INT(name='SSB-Index', mode=MODE_TYPE)
    SSB_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< SSID >-----#
    SSID = OCT_STR(name='SSID', mode=MODE_TYPE)
    SSID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< StartTimeAndDuration >-----#
    StartTimeAndDuration = SEQ(name='StartTimeAndDuration', mode=MODE_TYPE)
    _StartTimeAndDuration_startTime = BIT_STR(name='startTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RelativeTime1900')), opt=True)
    _StartTimeAndDuration_duration = INT(name='duration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _StartTimeAndDuration_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=90060)], ev=[], er=[])
    _StartTimeAndDuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __StartTimeAndDuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___StartTimeAndDuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____StartTimeAndDuration_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____StartTimeAndDuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___StartTimeAndDuration_iE_Extensions__item__id._const_tab = ____StartTimeAndDuration_iE_Extensions__item__id_tab
    ___StartTimeAndDuration_iE_Extensions__item__id._const_tab_at = None
    ___StartTimeAndDuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___StartTimeAndDuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____StartTimeAndDuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____StartTimeAndDuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___StartTimeAndDuration_iE_Extensions__item__criticality._const_tab = ____StartTimeAndDuration_iE_Extensions__item__criticality_tab
    ___StartTimeAndDuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___StartTimeAndDuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___StartTimeAndDuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____StartTimeAndDuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____StartTimeAndDuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___StartTimeAndDuration_iE_Extensions__item__extensionValue._const_tab = ____StartTimeAndDuration_iE_Extensions__item__extensionValue_tab
    ___StartTimeAndDuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___StartTimeAndDuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __StartTimeAndDuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___StartTimeAndDuration_iE_Extensions__item__id),
        ('criticality', ___StartTimeAndDuration_iE_Extensions__item__criticality),
        ('extensionValue', ___StartTimeAndDuration_iE_Extensions__item__extensionValue),
        ])
    __StartTimeAndDuration_iE_Extensions__item_._ext = None
    _StartTimeAndDuration_iE_Extensions._cont = __StartTimeAndDuration_iE_Extensions__item_
    _StartTimeAndDuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    StartTimeAndDuration._cont = ASN1Dict([
        ('startTime', _StartTimeAndDuration_startTime),
        ('duration', _StartTimeAndDuration_duration),
        ('iE-Extensions', _StartTimeAndDuration_iE_Extensions),
        ])
    StartTimeAndDuration._ext = []
    
    #-----< StartTimeAndDuration-ExtIEs >-----#
    StartTimeAndDuration_ExtIEs = CLASS(name='StartTimeAndDuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    StartTimeAndDuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SystemFrameNumber >-----#
    SystemFrameNumber = INT(name='SystemFrameNumber', mode=MODE_TYPE)
    SystemFrameNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    
    #-----< SystemInformation >-----#
    SystemInformation = SEQ_OF(name='SystemInformation', mode=MODE_TYPE)
    _SystemInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __SystemInformation__item__broadcastPeriodicity = ENUM(name='broadcastPeriodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'BroadcastPeriodicity')))
    __SystemInformation__item__posSIBs = SEQ_OF(name='posSIBs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PosSIBs')))
    __SystemInformation__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___SystemInformation__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ____SystemInformation__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    _____SystemInformation__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____SystemInformation__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____SystemInformation__item__iE_Extensions__item__id._const_tab = _____SystemInformation__item__iE_Extensions__item__id_tab
    ____SystemInformation__item__iE_Extensions__item__id._const_tab_at = None
    ____SystemInformation__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____SystemInformation__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    _____SystemInformation__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____SystemInformation__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____SystemInformation__item__iE_Extensions__item__criticality._const_tab = _____SystemInformation__item__iE_Extensions__item__criticality_tab
    ____SystemInformation__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____SystemInformation__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____SystemInformation__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    _____SystemInformation__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____SystemInformation__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____SystemInformation__item__iE_Extensions__item__extensionValue._const_tab = _____SystemInformation__item__iE_Extensions__item__extensionValue_tab
    ____SystemInformation__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____SystemInformation__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___SystemInformation__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____SystemInformation__item__iE_Extensions__item__id),
        ('criticality', ____SystemInformation__item__iE_Extensions__item__criticality),
        ('extensionValue', ____SystemInformation__item__iE_Extensions__item__extensionValue),
        ])
    ___SystemInformation__item__iE_Extensions__item_._ext = None
    __SystemInformation__item__iE_Extensions._cont = ___SystemInformation__item__iE_Extensions__item_
    __SystemInformation__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _SystemInformation__item_._cont = ASN1Dict([
        ('broadcastPeriodicity', __SystemInformation__item__broadcastPeriodicity),
        ('posSIBs', __SystemInformation__item__posSIBs),
        ('iE-Extensions', __SystemInformation__item__iE_Extensions),
        ])
    _SystemInformation__item_._ext = []
    SystemInformation._cont = _SystemInformation__item_
    SystemInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SystemInformation-ExtIEs >-----#
    SystemInformation_ExtIEs = CLASS(name='SystemInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SystemInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAC >-----#
    TAC = OCT_STR(name='TAC', mode=MODE_TYPE)
    TAC._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< TDD-Config-EUTRA-Item >-----#
    TDD_Config_EUTRA_Item = SEQ(name='TDD-Config-EUTRA-Item', mode=MODE_TYPE)
    _TDD_Config_EUTRA_Item_subframeAssignment = ENUM(name='subframeAssignment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TDD_Config_EUTRA_Item_subframeAssignment._cont = ASN1Dict([('sa0', 0), ('sa1', 1), ('sa2', 2), ('sa3', 3), ('sa4', 4), ('sa5', 5), ('sa6', 6)])
    _TDD_Config_EUTRA_Item_subframeAssignment._ext = []
    _TDD_Config_EUTRA_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_Config_EUTRA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TDD_Config_EUTRA_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____TDD_Config_EUTRA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TDD_Config_EUTRA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_Config_EUTRA_Item_iE_Extensions__item__id._const_tab = ____TDD_Config_EUTRA_Item_iE_Extensions__item__id_tab
    ___TDD_Config_EUTRA_Item_iE_Extensions__item__id._const_tab_at = None
    ___TDD_Config_EUTRA_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TDD_Config_EUTRA_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____TDD_Config_EUTRA_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TDD_Config_EUTRA_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_Config_EUTRA_Item_iE_Extensions__item__criticality._const_tab = ____TDD_Config_EUTRA_Item_iE_Extensions__item__criticality_tab
    ___TDD_Config_EUTRA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TDD_Config_EUTRA_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TDD_Config_EUTRA_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____TDD_Config_EUTRA_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TDD_Config_EUTRA_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_Config_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab = ____TDD_Config_EUTRA_Item_iE_Extensions__item__extensionValue_tab
    ___TDD_Config_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TDD_Config_EUTRA_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TDD_Config_EUTRA_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TDD_Config_EUTRA_Item_iE_Extensions__item__id),
        ('criticality', ___TDD_Config_EUTRA_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TDD_Config_EUTRA_Item_iE_Extensions__item__extensionValue),
        ])
    __TDD_Config_EUTRA_Item_iE_Extensions__item_._ext = None
    _TDD_Config_EUTRA_Item_iE_Extensions._cont = __TDD_Config_EUTRA_Item_iE_Extensions__item_
    _TDD_Config_EUTRA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_Config_EUTRA_Item._cont = ASN1Dict([
        ('subframeAssignment', _TDD_Config_EUTRA_Item_subframeAssignment),
        ('iE-Extensions', _TDD_Config_EUTRA_Item_iE_Extensions),
        ])
    TDD_Config_EUTRA_Item._ext = []
    
    #-----< TDD-Config-EUTRA-Item-Item-ExtIEs >-----#
    TDD_Config_EUTRA_Item_Item_ExtIEs = CLASS(name='TDD-Config-EUTRA-Item-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TDD_Config_EUTRA_Item_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPTEGInformation >-----#
    TRPTEGInformation = CHOICE(name='TRPTEGInformation', mode=MODE_TYPE)
    _TRPTEGInformation_rxTx_TEG = SEQ(name='rxTx-TEG', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RxTxTEG')))
    _TRPTEGInformation_rx_TEG = SEQ(name='rx-TEG', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RxTEG')))
    _TRPTEGInformation_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __TRPTEGInformation_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___TRPTEGInformation_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TRPTEGInformation_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPTEGInformation_choice_extension_id._const_tab = ___TRPTEGInformation_choice_extension_id_tab
    __TRPTEGInformation_choice_extension_id._const_tab_at = None
    __TRPTEGInformation_choice_extension_id._const_tab_id = 'id'
    __TRPTEGInformation_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___TRPTEGInformation_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TRPTEGInformation_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPTEGInformation_choice_extension_criticality._const_tab = ___TRPTEGInformation_choice_extension_criticality_tab
    __TRPTEGInformation_choice_extension_criticality._const_tab_at = ('..', 'id')
    __TRPTEGInformation_choice_extension_criticality._const_tab_id = 'criticality'
    __TRPTEGInformation_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___TRPTEGInformation_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TRPTEGInformation_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPTEGInformation_choice_extension_value._const_tab = ___TRPTEGInformation_choice_extension_value_tab
    __TRPTEGInformation_choice_extension_value._const_tab_at = ('..', 'id')
    __TRPTEGInformation_choice_extension_value._const_tab_id = 'Value'
    _TRPTEGInformation_choice_extension._cont = ASN1Dict([
        ('id', __TRPTEGInformation_choice_extension_id),
        ('criticality', __TRPTEGInformation_choice_extension_criticality),
        ('value', __TRPTEGInformation_choice_extension_value),
        ])
    _TRPTEGInformation_choice_extension._ext = None
    TRPTEGInformation._cont = ASN1Dict([
        ('rxTx-TEG', _TRPTEGInformation_rxTx_TEG),
        ('rx-TEG', _TRPTEGInformation_rx_TEG),
        ('choice-extension', _TRPTEGInformation_choice_extension),
        ])
    TRPTEGInformation._ext = None
    
    #-----< TRPTEGInformation-ExtIEs >-----#
    TRPTEGInformation_ExtIEs = CLASS(name='TRPTEGInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    TRPTEGInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RxTxTEG >-----#
    RxTxTEG = SEQ(name='RxTxTEG', mode=MODE_TYPE)
    _RxTxTEG_tRP_RxTx_TEGInformation = SEQ(name='tRP-RxTx-TEGInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRP-RxTx-TEGInformation')))
    _RxTxTEG_tRP_Tx_TEGInformation = SEQ(name='tRP-Tx-TEGInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRP-Tx-TEGInformation')), opt=True)
    _RxTxTEG_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RxTxTEG_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___RxTxTEG_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____RxTxTEG_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RxTxTEG_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RxTxTEG_iE_extensions__item__id._const_tab = ____RxTxTEG_iE_extensions__item__id_tab
    ___RxTxTEG_iE_extensions__item__id._const_tab_at = None
    ___RxTxTEG_iE_extensions__item__id._const_tab_id = 'id'
    ___RxTxTEG_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____RxTxTEG_iE_extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RxTxTEG_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RxTxTEG_iE_extensions__item__criticality._const_tab = ____RxTxTEG_iE_extensions__item__criticality_tab
    ___RxTxTEG_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RxTxTEG_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___RxTxTEG_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____RxTxTEG_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RxTxTEG_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RxTxTEG_iE_extensions__item__extensionValue._const_tab = ____RxTxTEG_iE_extensions__item__extensionValue_tab
    ___RxTxTEG_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RxTxTEG_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __RxTxTEG_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___RxTxTEG_iE_extensions__item__id),
        ('criticality', ___RxTxTEG_iE_extensions__item__criticality),
        ('extensionValue', ___RxTxTEG_iE_extensions__item__extensionValue),
        ])
    __RxTxTEG_iE_extensions__item_._ext = None
    _RxTxTEG_iE_extensions._cont = __RxTxTEG_iE_extensions__item_
    _RxTxTEG_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RxTxTEG._cont = ASN1Dict([
        ('tRP-RxTx-TEGInformation', _RxTxTEG_tRP_RxTx_TEGInformation),
        ('tRP-Tx-TEGInformation', _RxTxTEG_tRP_Tx_TEGInformation),
        ('iE-extensions', _RxTxTEG_iE_extensions),
        ])
    RxTxTEG._ext = []
    
    #-----< RxTxTEG-ExtIEs >-----#
    RxTxTEG_ExtIEs = CLASS(name='RxTxTEG-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    RxTxTEG_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RxTEG >-----#
    RxTEG = SEQ(name='RxTEG', mode=MODE_TYPE)
    _RxTEG_tRP_Rx_TEGInformation = SEQ(name='tRP-Rx-TEGInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRP-Rx-TEGInformation')))
    _RxTEG_tRP_Tx_TEGInformation = SEQ(name='tRP-Tx-TEGInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRP-Tx-TEGInformation')))
    _RxTEG_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RxTEG_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___RxTEG_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____RxTEG_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RxTEG_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RxTEG_iE_extensions__item__id._const_tab = ____RxTEG_iE_extensions__item__id_tab
    ___RxTEG_iE_extensions__item__id._const_tab_at = None
    ___RxTEG_iE_extensions__item__id._const_tab_id = 'id'
    ___RxTEG_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____RxTEG_iE_extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RxTEG_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RxTEG_iE_extensions__item__criticality._const_tab = ____RxTEG_iE_extensions__item__criticality_tab
    ___RxTEG_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RxTEG_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___RxTEG_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____RxTEG_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____RxTEG_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RxTEG_iE_extensions__item__extensionValue._const_tab = ____RxTEG_iE_extensions__item__extensionValue_tab
    ___RxTEG_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RxTEG_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __RxTEG_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___RxTEG_iE_extensions__item__id),
        ('criticality', ___RxTEG_iE_extensions__item__criticality),
        ('extensionValue', ___RxTEG_iE_extensions__item__extensionValue),
        ])
    __RxTEG_iE_extensions__item_._ext = None
    _RxTEG_iE_extensions._cont = __RxTEG_iE_extensions__item_
    _RxTEG_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RxTEG._cont = ASN1Dict([
        ('tRP-Rx-TEGInformation', _RxTEG_tRP_Rx_TEGInformation),
        ('tRP-Tx-TEGInformation', _RxTEG_tRP_Tx_TEGInformation),
        ('iE-extensions', _RxTEG_iE_extensions),
        ])
    RxTEG._ext = []
    
    #-----< RxTEG-ExtIEs >-----#
    RxTEG_ExtIEs = CLASS(name='RxTEG-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    RxTEG_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TimingErrorMargin >-----#
    TimingErrorMargin = ENUM(name='TimingErrorMargin', mode=MODE_TYPE)
    TimingErrorMargin._cont = ASN1Dict([('tc0', 0), ('tc2', 1), ('tc4', 2), ('tc6', 3), ('tc8', 4), ('tc12', 5), ('tc16', 6), ('tc20', 7), ('tc24', 8), ('tc32', 9), ('tc40', 10), ('tc48', 11), ('tc56', 12), ('tc64', 13), ('tc72', 14), ('tc80', 15)])
    TimingErrorMargin._ext = []
    
    #-----< TF-Configuration >-----#
    TF_Configuration = SEQ(name='TF-Configuration', mode=MODE_TYPE)
    _TF_Configuration_sSB_frequency = INT(name='sSB-frequency', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TF_Configuration_sSB_frequency._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _TF_Configuration_sSB_subcarrier_spacing = ENUM(name='sSB-subcarrier-spacing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TF_Configuration_sSB_subcarrier_spacing._cont = ASN1Dict([('kHz15', 0), ('kHz30', 1), ('kHz120', 2), ('kHz240', 3), ('kHz60', 4)])
    _TF_Configuration_sSB_subcarrier_spacing._ext = ['kHz60']
    _TF_Configuration_sSB_Transmit_power = INT(name='sSB-Transmit-power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TF_Configuration_sSB_Transmit_power._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-60, ub=50)], ev=None, er=[])
    _TF_Configuration_sSB_periodicity = ENUM(name='sSB-periodicity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TF_Configuration_sSB_periodicity._cont = ASN1Dict([('ms5', 0), ('ms10', 1), ('ms20', 2), ('ms40', 3), ('ms80', 4), ('ms160', 5)])
    _TF_Configuration_sSB_periodicity._ext = []
    _TF_Configuration_sSB_half_frame_offset = INT(name='sSB-half-frame-offset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TF_Configuration_sSB_half_frame_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    _TF_Configuration_sSB_SFN_offset = INT(name='sSB-SFN-offset', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TF_Configuration_sSB_SFN_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _TF_Configuration_sSB_BurstPosition = CHOICE(name='sSB-BurstPosition', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SSBBurstPosition')), opt=True)
    _TF_Configuration_sFN_initialisation_time = BIT_STR(name='sFN-initialisation-time', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RelativeTime1900')), opt=True)
    _TF_Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TF_Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TF_Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____TF_Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TF_Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TF_Configuration_iE_Extensions__item__id._const_tab = ____TF_Configuration_iE_Extensions__item__id_tab
    ___TF_Configuration_iE_Extensions__item__id._const_tab_at = None
    ___TF_Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___TF_Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____TF_Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TF_Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TF_Configuration_iE_Extensions__item__criticality._const_tab = ____TF_Configuration_iE_Extensions__item__criticality_tab
    ___TF_Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TF_Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TF_Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____TF_Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TF_Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TF_Configuration_iE_Extensions__item__extensionValue._const_tab = ____TF_Configuration_iE_Extensions__item__extensionValue_tab
    ___TF_Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TF_Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TF_Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TF_Configuration_iE_Extensions__item__id),
        ('criticality', ___TF_Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___TF_Configuration_iE_Extensions__item__extensionValue),
        ])
    __TF_Configuration_iE_Extensions__item_._ext = None
    _TF_Configuration_iE_Extensions._cont = __TF_Configuration_iE_Extensions__item_
    _TF_Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TF_Configuration._cont = ASN1Dict([
        ('sSB-frequency', _TF_Configuration_sSB_frequency),
        ('sSB-subcarrier-spacing', _TF_Configuration_sSB_subcarrier_spacing),
        ('sSB-Transmit-power', _TF_Configuration_sSB_Transmit_power),
        ('sSB-periodicity', _TF_Configuration_sSB_periodicity),
        ('sSB-half-frame-offset', _TF_Configuration_sSB_half_frame_offset),
        ('sSB-SFN-offset', _TF_Configuration_sSB_SFN_offset),
        ('sSB-BurstPosition', _TF_Configuration_sSB_BurstPosition),
        ('sFN-initialisation-time', _TF_Configuration_sFN_initialisation_time),
        ('iE-Extensions', _TF_Configuration_iE_Extensions),
        ])
    TF_Configuration._ext = []
    
    #-----< TF-Configuration-ExtIEs >-----#
    TF_Configuration_ExtIEs = CLASS(name='TF-Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TF_Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TimeStamp >-----#
    TimeStamp = SEQ(name='TimeStamp', mode=MODE_TYPE)
    _TimeStamp_systemFrameNumber = INT(name='systemFrameNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SystemFrameNumber')))
    _TimeStamp_slotIndex = CHOICE(name='slotIndex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TimeStampSlotIndex')))
    _TimeStamp_measurementTime = BIT_STR(name='measurementTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RelativeTime1900')), opt=True)
    _TimeStamp_iE_Extension = SEQ_OF(name='iE-Extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TimeStamp_iE_Extension__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TimeStamp_iE_Extension__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____TimeStamp_iE_Extension__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TimeStamp_iE_Extension__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeStamp_iE_Extension__item__id._const_tab = ____TimeStamp_iE_Extension__item__id_tab
    ___TimeStamp_iE_Extension__item__id._const_tab_at = None
    ___TimeStamp_iE_Extension__item__id._const_tab_id = 'id'
    ___TimeStamp_iE_Extension__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____TimeStamp_iE_Extension__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TimeStamp_iE_Extension__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeStamp_iE_Extension__item__criticality._const_tab = ____TimeStamp_iE_Extension__item__criticality_tab
    ___TimeStamp_iE_Extension__item__criticality._const_tab_at = ('..', 'id')
    ___TimeStamp_iE_Extension__item__criticality._const_tab_id = 'criticality'
    ___TimeStamp_iE_Extension__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____TimeStamp_iE_Extension__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TimeStamp_iE_Extension__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TimeStamp_iE_Extension__item__extensionValue._const_tab = ____TimeStamp_iE_Extension__item__extensionValue_tab
    ___TimeStamp_iE_Extension__item__extensionValue._const_tab_at = ('..', 'id')
    ___TimeStamp_iE_Extension__item__extensionValue._const_tab_id = 'Extension'
    __TimeStamp_iE_Extension__item_._cont = ASN1Dict([
        ('id', ___TimeStamp_iE_Extension__item__id),
        ('criticality', ___TimeStamp_iE_Extension__item__criticality),
        ('extensionValue', ___TimeStamp_iE_Extension__item__extensionValue),
        ])
    __TimeStamp_iE_Extension__item_._ext = None
    _TimeStamp_iE_Extension._cont = __TimeStamp_iE_Extension__item_
    _TimeStamp_iE_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TimeStamp._cont = ASN1Dict([
        ('systemFrameNumber', _TimeStamp_systemFrameNumber),
        ('slotIndex', _TimeStamp_slotIndex),
        ('measurementTime', _TimeStamp_measurementTime),
        ('iE-Extension', _TimeStamp_iE_Extension),
        ])
    TimeStamp._ext = []
    
    #-----< TimeStamp-ExtIEs >-----#
    TimeStamp_ExtIEs = CLASS(name='TimeStamp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TimeStamp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TimeStampSlotIndex >-----#
    TimeStampSlotIndex = CHOICE(name='TimeStampSlotIndex', mode=MODE_TYPE)
    _TimeStampSlotIndex_sCS_15 = INT(name='sCS-15', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimeStampSlotIndex_sCS_15._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _TimeStampSlotIndex_sCS_30 = INT(name='sCS-30', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimeStampSlotIndex_sCS_30._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=19)], ev=None, er=[])
    _TimeStampSlotIndex_sCS_60 = INT(name='sCS-60', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimeStampSlotIndex_sCS_60._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=39)], ev=None, er=[])
    _TimeStampSlotIndex_sCS_120 = INT(name='sCS-120', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimeStampSlotIndex_sCS_120._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=79)], ev=None, er=[])
    _TimeStampSlotIndex_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __TimeStampSlotIndex_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___TimeStampSlotIndex_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TimeStampSlotIndex_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TimeStampSlotIndex_choice_extension_id._const_tab = ___TimeStampSlotIndex_choice_extension_id_tab
    __TimeStampSlotIndex_choice_extension_id._const_tab_at = None
    __TimeStampSlotIndex_choice_extension_id._const_tab_id = 'id'
    __TimeStampSlotIndex_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___TimeStampSlotIndex_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TimeStampSlotIndex_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TimeStampSlotIndex_choice_extension_criticality._const_tab = ___TimeStampSlotIndex_choice_extension_criticality_tab
    __TimeStampSlotIndex_choice_extension_criticality._const_tab_at = ('..', 'id')
    __TimeStampSlotIndex_choice_extension_criticality._const_tab_id = 'criticality'
    __TimeStampSlotIndex_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___TimeStampSlotIndex_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TimeStampSlotIndex_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TimeStampSlotIndex_choice_extension_value._const_tab = ___TimeStampSlotIndex_choice_extension_value_tab
    __TimeStampSlotIndex_choice_extension_value._const_tab_at = ('..', 'id')
    __TimeStampSlotIndex_choice_extension_value._const_tab_id = 'Value'
    _TimeStampSlotIndex_choice_extension._cont = ASN1Dict([
        ('id', __TimeStampSlotIndex_choice_extension_id),
        ('criticality', __TimeStampSlotIndex_choice_extension_criticality),
        ('value', __TimeStampSlotIndex_choice_extension_value),
        ])
    _TimeStampSlotIndex_choice_extension._ext = None
    TimeStampSlotIndex._cont = ASN1Dict([
        ('sCS-15', _TimeStampSlotIndex_sCS_15),
        ('sCS-30', _TimeStampSlotIndex_sCS_30),
        ('sCS-60', _TimeStampSlotIndex_sCS_60),
        ('sCS-120', _TimeStampSlotIndex_sCS_120),
        ('choice-extension', _TimeStampSlotIndex_choice_extension),
        ])
    TimeStampSlotIndex._ext = None
    
    #-----< TimeStampSlotIndex-ExtIEs >-----#
    TimeStampSlotIndex_ExtIEs = CLASS(name='TimeStampSlotIndex-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    TimeStampSlotIndex_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TP-ID-EUTRA >-----#
    TP_ID_EUTRA = INT(name='TP-ID-EUTRA', mode=MODE_TYPE)
    TP_ID_EUTRA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=[], er=[])
    
    #-----< TP-Type-EUTRA >-----#
    TP_Type_EUTRA = ENUM(name='TP-Type-EUTRA', mode=MODE_TYPE)
    TP_Type_EUTRA._cont = ASN1Dict([('prs-only-tp', 0)])
    TP_Type_EUTRA._ext = []
    
    #-----< TransmissionComb >-----#
    TransmissionComb = CHOICE(name='TransmissionComb', mode=MODE_TYPE)
    _TransmissionComb_n2 = SEQ(name='n2', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionComb_n2_combOffset_n2 = INT(name='combOffset-n2', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionComb_n2_combOffset_n2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    __TransmissionComb_n2_cyclicShift_n2 = INT(name='cyclicShift-n2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionComb_n2_cyclicShift_n2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _TransmissionComb_n2._cont = ASN1Dict([
        ('combOffset-n2', __TransmissionComb_n2_combOffset_n2),
        ('cyclicShift-n2', __TransmissionComb_n2_cyclicShift_n2),
        ])
    _TransmissionComb_n2._ext = None
    _TransmissionComb_n4 = SEQ(name='n4', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionComb_n4_combOffset_n4 = INT(name='combOffset-n4', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionComb_n4_combOffset_n4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    __TransmissionComb_n4_cyclicShift_n4 = INT(name='cyclicShift-n4', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionComb_n4_cyclicShift_n4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=11)], ev=None, er=[])
    _TransmissionComb_n4._cont = ASN1Dict([
        ('combOffset-n4', __TransmissionComb_n4_combOffset_n4),
        ('cyclicShift-n4', __TransmissionComb_n4_cyclicShift_n4),
        ])
    _TransmissionComb_n4._ext = None
    _TransmissionComb_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __TransmissionComb_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___TransmissionComb_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TransmissionComb_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TransmissionComb_choice_extension_id._const_tab = ___TransmissionComb_choice_extension_id_tab
    __TransmissionComb_choice_extension_id._const_tab_at = None
    __TransmissionComb_choice_extension_id._const_tab_id = 'id'
    __TransmissionComb_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___TransmissionComb_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TransmissionComb_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TransmissionComb_choice_extension_criticality._const_tab = ___TransmissionComb_choice_extension_criticality_tab
    __TransmissionComb_choice_extension_criticality._const_tab_at = ('..', 'id')
    __TransmissionComb_choice_extension_criticality._const_tab_id = 'criticality'
    __TransmissionComb_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___TransmissionComb_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TransmissionComb_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TransmissionComb_choice_extension_value._const_tab = ___TransmissionComb_choice_extension_value_tab
    __TransmissionComb_choice_extension_value._const_tab_at = ('..', 'id')
    __TransmissionComb_choice_extension_value._const_tab_id = 'Value'
    _TransmissionComb_choice_extension._cont = ASN1Dict([
        ('id', __TransmissionComb_choice_extension_id),
        ('criticality', __TransmissionComb_choice_extension_criticality),
        ('value', __TransmissionComb_choice_extension_value),
        ])
    _TransmissionComb_choice_extension._ext = None
    TransmissionComb._cont = ASN1Dict([
        ('n2', _TransmissionComb_n2),
        ('n4', _TransmissionComb_n4),
        ('choice-extension', _TransmissionComb_choice_extension),
        ])
    TransmissionComb._ext = None
    
    #-----< TransmissionComb-ExtIEs >-----#
    TransmissionComb_ExtIEs = CLASS(name='TransmissionComb-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    TransmissionComb_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransmissionCombPos >-----#
    TransmissionCombPos = CHOICE(name='TransmissionCombPos', mode=MODE_TYPE)
    _TransmissionCombPos_n2 = SEQ(name='n2', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n2_combOffset_n2 = INT(name='combOffset-n2', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n2_combOffset_n2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    __TransmissionCombPos_n2_cyclicShift_n2 = INT(name='cyclicShift-n2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n2_cyclicShift_n2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _TransmissionCombPos_n2._cont = ASN1Dict([
        ('combOffset-n2', __TransmissionCombPos_n2_combOffset_n2),
        ('cyclicShift-n2', __TransmissionCombPos_n2_cyclicShift_n2),
        ])
    _TransmissionCombPos_n2._ext = None
    _TransmissionCombPos_n4 = SEQ(name='n4', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n4_combOffset_n4 = INT(name='combOffset-n4', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n4_combOffset_n4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    __TransmissionCombPos_n4_cyclicShift_n4 = INT(name='cyclicShift-n4', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n4_cyclicShift_n4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=11)], ev=None, er=[])
    _TransmissionCombPos_n4._cont = ASN1Dict([
        ('combOffset-n4', __TransmissionCombPos_n4_combOffset_n4),
        ('cyclicShift-n4', __TransmissionCombPos_n4_cyclicShift_n4),
        ])
    _TransmissionCombPos_n4._ext = None
    _TransmissionCombPos_n8 = SEQ(name='n8', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n8_combOffset_n8 = INT(name='combOffset-n8', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n8_combOffset_n8._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    __TransmissionCombPos_n8_cyclicShift_n8 = INT(name='cyclicShift-n8', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransmissionCombPos_n8_cyclicShift_n8._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5)], ev=None, er=[])
    _TransmissionCombPos_n8._cont = ASN1Dict([
        ('combOffset-n8', __TransmissionCombPos_n8_combOffset_n8),
        ('cyclicShift-n8', __TransmissionCombPos_n8_cyclicShift_n8),
        ])
    _TransmissionCombPos_n8._ext = None
    _TransmissionCombPos_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __TransmissionCombPos_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___TransmissionCombPos_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TransmissionCombPos_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TransmissionCombPos_choice_extension_id._const_tab = ___TransmissionCombPos_choice_extension_id_tab
    __TransmissionCombPos_choice_extension_id._const_tab_at = None
    __TransmissionCombPos_choice_extension_id._const_tab_id = 'id'
    __TransmissionCombPos_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___TransmissionCombPos_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TransmissionCombPos_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TransmissionCombPos_choice_extension_criticality._const_tab = ___TransmissionCombPos_choice_extension_criticality_tab
    __TransmissionCombPos_choice_extension_criticality._const_tab_at = ('..', 'id')
    __TransmissionCombPos_choice_extension_criticality._const_tab_id = 'criticality'
    __TransmissionCombPos_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___TransmissionCombPos_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TransmissionCombPos_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TransmissionCombPos_choice_extension_value._const_tab = ___TransmissionCombPos_choice_extension_value_tab
    __TransmissionCombPos_choice_extension_value._const_tab_at = ('..', 'id')
    __TransmissionCombPos_choice_extension_value._const_tab_id = 'Value'
    _TransmissionCombPos_choice_extension._cont = ASN1Dict([
        ('id', __TransmissionCombPos_choice_extension_id),
        ('criticality', __TransmissionCombPos_choice_extension_criticality),
        ('value', __TransmissionCombPos_choice_extension_value),
        ])
    _TransmissionCombPos_choice_extension._ext = None
    TransmissionCombPos._cont = ASN1Dict([
        ('n2', _TransmissionCombPos_n2),
        ('n4', _TransmissionCombPos_n4),
        ('n8', _TransmissionCombPos_n8),
        ('choice-extension', _TransmissionCombPos_choice_extension),
        ])
    TransmissionCombPos._ext = None
    
    #-----< TransmissionCombPos-ExtIEs >-----#
    TransmissionCombPos_ExtIEs = CLASS(name='TransmissionCombPos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    TransmissionCombPos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPBeamAntennaInformation >-----#
    TRPBeamAntennaInformation = SEQ(name='TRPBeamAntennaInformation', mode=MODE_TYPE)
    _TRPBeamAntennaInformation_choice_TRP_Beam_Antenna_Info_Item = CHOICE(name='choice-TRP-Beam-Antenna-Info-Item', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'Choice-TRP-Beam-Antenna-Info-Item')))
    _TRPBeamAntennaInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRPBeamAntennaInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TRPBeamAntennaInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____TRPBeamAntennaInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPBeamAntennaInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPBeamAntennaInformation_iE_Extensions__item__id._const_tab = ____TRPBeamAntennaInformation_iE_Extensions__item__id_tab
    ___TRPBeamAntennaInformation_iE_Extensions__item__id._const_tab_at = None
    ___TRPBeamAntennaInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRPBeamAntennaInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRPBeamAntennaInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPBeamAntennaInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPBeamAntennaInformation_iE_Extensions__item__criticality._const_tab = ____TRPBeamAntennaInformation_iE_Extensions__item__criticality_tab
    ___TRPBeamAntennaInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRPBeamAntennaInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRPBeamAntennaInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRPBeamAntennaInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPBeamAntennaInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPBeamAntennaInformation_iE_Extensions__item__extensionValue._const_tab = ____TRPBeamAntennaInformation_iE_Extensions__item__extensionValue_tab
    ___TRPBeamAntennaInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRPBeamAntennaInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRPBeamAntennaInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRPBeamAntennaInformation_iE_Extensions__item__id),
        ('criticality', ___TRPBeamAntennaInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___TRPBeamAntennaInformation_iE_Extensions__item__extensionValue),
        ])
    __TRPBeamAntennaInformation_iE_Extensions__item_._ext = None
    _TRPBeamAntennaInformation_iE_Extensions._cont = __TRPBeamAntennaInformation_iE_Extensions__item_
    _TRPBeamAntennaInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRPBeamAntennaInformation._cont = ASN1Dict([
        ('choice-TRP-Beam-Antenna-Info-Item', _TRPBeamAntennaInformation_choice_TRP_Beam_Antenna_Info_Item),
        ('iE-Extensions', _TRPBeamAntennaInformation_iE_Extensions),
        ])
    TRPBeamAntennaInformation._ext = []
    
    #-----< TRPBeamAntennaInformation-ExtIEs >-----#
    TRPBeamAntennaInformation_ExtIEs = CLASS(name='TRPBeamAntennaInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TRPBeamAntennaInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Choice-TRP-Beam-Antenna-Info-Item >-----#
    Choice_TRP_Beam_Antenna_Info_Item = CHOICE(name='Choice-TRP-Beam-Antenna-Info-Item', mode=MODE_TYPE)
    _Choice_TRP_Beam_Antenna_Info_Item_reference = INT(name='reference', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRP-ID')))
    _Choice_TRP_Beam_Antenna_Info_Item_explicit = SEQ(name='explicit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRP-BeamAntennaExplicitInformation')))
    _Choice_TRP_Beam_Antenna_Info_Item_noChange = NULL(name='noChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Choice_TRP_Beam_Antenna_Info_Item_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___Choice_TRP_Beam_Antenna_Info_Item_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___Choice_TRP_Beam_Antenna_Info_Item_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_id._const_tab = ___Choice_TRP_Beam_Antenna_Info_Item_choice_extension_id_tab
    __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_id._const_tab_at = None
    __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_id._const_tab_id = 'id'
    __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___Choice_TRP_Beam_Antenna_Info_Item_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___Choice_TRP_Beam_Antenna_Info_Item_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_criticality._const_tab = ___Choice_TRP_Beam_Antenna_Info_Item_choice_extension_criticality_tab
    __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_criticality._const_tab_at = ('..', 'id')
    __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_criticality._const_tab_id = 'criticality'
    __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___Choice_TRP_Beam_Antenna_Info_Item_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___Choice_TRP_Beam_Antenna_Info_Item_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_value._const_tab = ___Choice_TRP_Beam_Antenna_Info_Item_choice_extension_value_tab
    __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_value._const_tab_at = ('..', 'id')
    __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_value._const_tab_id = 'Value'
    _Choice_TRP_Beam_Antenna_Info_Item_choice_extension._cont = ASN1Dict([
        ('id', __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_id),
        ('criticality', __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_criticality),
        ('value', __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_value),
        ])
    _Choice_TRP_Beam_Antenna_Info_Item_choice_extension._ext = None
    Choice_TRP_Beam_Antenna_Info_Item._cont = ASN1Dict([
        ('reference', _Choice_TRP_Beam_Antenna_Info_Item_reference),
        ('explicit', _Choice_TRP_Beam_Antenna_Info_Item_explicit),
        ('noChange', _Choice_TRP_Beam_Antenna_Info_Item_noChange),
        ('choice-extension', _Choice_TRP_Beam_Antenna_Info_Item_choice_extension),
        ])
    Choice_TRP_Beam_Antenna_Info_Item._ext = None
    
    #-----< Choice-TRP-Beam-Info-Item-ExtIEs >-----#
    Choice_TRP_Beam_Info_Item_ExtIEs = CLASS(name='Choice-TRP-Beam-Info-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    Choice_TRP_Beam_Info_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRP-BeamAntennaExplicitInformation >-----#
    TRP_BeamAntennaExplicitInformation = SEQ(name='TRP-BeamAntennaExplicitInformation', mode=MODE_TYPE)
    _TRP_BeamAntennaExplicitInformation_trp_BeamAntennaAngles = SEQ_OF(name='trp-BeamAntennaAngles', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRP-BeamAntennaAngles')))
    _TRP_BeamAntennaExplicitInformation_lcs_to_gcs_translation = SEQ(name='lcs-to-gcs-translation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'LCS-to-GCS-Translation')), opt=True)
    _TRP_BeamAntennaExplicitInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRP_BeamAntennaExplicitInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____TRP_BeamAntennaExplicitInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRP_BeamAntennaExplicitInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__id._const_tab = ____TRP_BeamAntennaExplicitInformation_iE_Extensions__item__id_tab
    ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__id._const_tab_at = None
    ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRP_BeamAntennaExplicitInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRP_BeamAntennaExplicitInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__criticality._const_tab = ____TRP_BeamAntennaExplicitInformation_iE_Extensions__item__criticality_tab
    ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRP_BeamAntennaExplicitInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRP_BeamAntennaExplicitInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__extensionValue._const_tab = ____TRP_BeamAntennaExplicitInformation_iE_Extensions__item__extensionValue_tab
    ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRP_BeamAntennaExplicitInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__id),
        ('criticality', ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__extensionValue),
        ])
    __TRP_BeamAntennaExplicitInformation_iE_Extensions__item_._ext = None
    _TRP_BeamAntennaExplicitInformation_iE_Extensions._cont = __TRP_BeamAntennaExplicitInformation_iE_Extensions__item_
    _TRP_BeamAntennaExplicitInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRP_BeamAntennaExplicitInformation._cont = ASN1Dict([
        ('trp-BeamAntennaAngles', _TRP_BeamAntennaExplicitInformation_trp_BeamAntennaAngles),
        ('lcs-to-gcs-translation', _TRP_BeamAntennaExplicitInformation_lcs_to_gcs_translation),
        ('iE-Extensions', _TRP_BeamAntennaExplicitInformation_iE_Extensions),
        ])
    TRP_BeamAntennaExplicitInformation._ext = []
    
    #-----< TRP-BeamAntennaExplicitInformation-ExtIEs >-----#
    TRP_BeamAntennaExplicitInformation_ExtIEs = CLASS(name='TRP-BeamAntennaExplicitInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TRP_BeamAntennaExplicitInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRP-BeamAntennaAngles >-----#
    TRP_BeamAntennaAngles = SEQ_OF(name='TRP-BeamAntennaAngles', mode=MODE_TYPE)
    _TRP_BeamAntennaAngles__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-BeamAntennaAnglesList-Item')))
    TRP_BeamAntennaAngles._cont = _TRP_BeamAntennaAngles__item_
    TRP_BeamAntennaAngles._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3600)], ev=None, er=[])
    
    #-----< TRP-BeamAntennaAnglesList-Item >-----#
    TRP_BeamAntennaAnglesList_Item = SEQ(name='TRP-BeamAntennaAnglesList-Item', mode=MODE_TYPE)
    _TRP_BeamAntennaAnglesList_Item_trp_azimuth_angle = INT(name='trp-azimuth-angle', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TRP_BeamAntennaAnglesList_Item_trp_azimuth_angle._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _TRP_BeamAntennaAnglesList_Item_trp_azimuth_angle_fine = INT(name='trp-azimuth-angle-fine', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TRP_BeamAntennaAnglesList_Item_trp_azimuth_angle_fine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _TRP_BeamAntennaAnglesList_Item_trp_elevation_angle_list = SEQ_OF(name='trp-elevation-angle-list', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TRP_BeamAntennaAnglesList_Item_trp_elevation_angle_list__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-ElevationAngleList-Item')))
    _TRP_BeamAntennaAnglesList_Item_trp_elevation_angle_list._cont = __TRP_BeamAntennaAnglesList_Item_trp_elevation_angle_list__item_
    _TRP_BeamAntennaAnglesList_Item_trp_elevation_angle_list._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1801)], ev=None, er=[])
    _TRP_BeamAntennaAnglesList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRP_BeamAntennaAnglesList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__id._const_tab = ____TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__id_tab
    ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__id._const_tab_at = None
    ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__criticality._const_tab = ____TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__criticality_tab
    ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__extensionValue._const_tab = ____TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__extensionValue_tab
    ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRP_BeamAntennaAnglesList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__id),
        ('criticality', ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__extensionValue),
        ])
    __TRP_BeamAntennaAnglesList_Item_iE_Extensions__item_._ext = None
    _TRP_BeamAntennaAnglesList_Item_iE_Extensions._cont = __TRP_BeamAntennaAnglesList_Item_iE_Extensions__item_
    _TRP_BeamAntennaAnglesList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRP_BeamAntennaAnglesList_Item._cont = ASN1Dict([
        ('trp-azimuth-angle', _TRP_BeamAntennaAnglesList_Item_trp_azimuth_angle),
        ('trp-azimuth-angle-fine', _TRP_BeamAntennaAnglesList_Item_trp_azimuth_angle_fine),
        ('trp-elevation-angle-list', _TRP_BeamAntennaAnglesList_Item_trp_elevation_angle_list),
        ('iE-Extensions', _TRP_BeamAntennaAnglesList_Item_iE_Extensions),
        ])
    TRP_BeamAntennaAnglesList_Item._ext = []
    
    #-----< TRP-BeamAntennaAnglesList-Item-ExtIEs >-----#
    TRP_BeamAntennaAnglesList_Item_ExtIEs = CLASS(name='TRP-BeamAntennaAnglesList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TRP_BeamAntennaAnglesList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRP-ElevationAngleList-Item >-----#
    TRP_ElevationAngleList_Item = SEQ(name='TRP-ElevationAngleList-Item', mode=MODE_TYPE)
    _TRP_ElevationAngleList_Item_trp_elevation_angle = INT(name='trp-elevation-angle', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TRP_ElevationAngleList_Item_trp_elevation_angle._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=180)], ev=None, er=[])
    _TRP_ElevationAngleList_Item_trp_elevation_angle_fine = INT(name='trp-elevation-angle-fine', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TRP_ElevationAngleList_Item_trp_elevation_angle_fine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _TRP_ElevationAngleList_Item_trp_beam_power_list = SEQ_OF(name='trp-beam-power-list', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TRP_ElevationAngleList_Item_trp_beam_power_list__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-Beam-Power-Item')))
    _TRP_ElevationAngleList_Item_trp_beam_power_list._cont = __TRP_ElevationAngleList_Item_trp_beam_power_list__item_
    _TRP_ElevationAngleList_Item_trp_beam_power_list._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=24)], ev=None, er=[])
    _TRP_ElevationAngleList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRP_ElevationAngleList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TRP_ElevationAngleList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____TRP_ElevationAngleList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRP_ElevationAngleList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_ElevationAngleList_Item_iE_Extensions__item__id._const_tab = ____TRP_ElevationAngleList_Item_iE_Extensions__item__id_tab
    ___TRP_ElevationAngleList_Item_iE_Extensions__item__id._const_tab_at = None
    ___TRP_ElevationAngleList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRP_ElevationAngleList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRP_ElevationAngleList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRP_ElevationAngleList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_ElevationAngleList_Item_iE_Extensions__item__criticality._const_tab = ____TRP_ElevationAngleList_Item_iE_Extensions__item__criticality_tab
    ___TRP_ElevationAngleList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRP_ElevationAngleList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRP_ElevationAngleList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRP_ElevationAngleList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRP_ElevationAngleList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_ElevationAngleList_Item_iE_Extensions__item__extensionValue._const_tab = ____TRP_ElevationAngleList_Item_iE_Extensions__item__extensionValue_tab
    ___TRP_ElevationAngleList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRP_ElevationAngleList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRP_ElevationAngleList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRP_ElevationAngleList_Item_iE_Extensions__item__id),
        ('criticality', ___TRP_ElevationAngleList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TRP_ElevationAngleList_Item_iE_Extensions__item__extensionValue),
        ])
    __TRP_ElevationAngleList_Item_iE_Extensions__item_._ext = None
    _TRP_ElevationAngleList_Item_iE_Extensions._cont = __TRP_ElevationAngleList_Item_iE_Extensions__item_
    _TRP_ElevationAngleList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRP_ElevationAngleList_Item._cont = ASN1Dict([
        ('trp-elevation-angle', _TRP_ElevationAngleList_Item_trp_elevation_angle),
        ('trp-elevation-angle-fine', _TRP_ElevationAngleList_Item_trp_elevation_angle_fine),
        ('trp-beam-power-list', _TRP_ElevationAngleList_Item_trp_beam_power_list),
        ('iE-Extensions', _TRP_ElevationAngleList_Item_iE_Extensions),
        ])
    TRP_ElevationAngleList_Item._ext = []
    
    #-----< TRP-ElevationAngleList-Item-ExtIEs >-----#
    TRP_ElevationAngleList_Item_ExtIEs = CLASS(name='TRP-ElevationAngleList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TRP_ElevationAngleList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRP-Beam-Power-Item >-----#
    TRP_Beam_Power_Item = SEQ(name='TRP-Beam-Power-Item', mode=MODE_TYPE)
    _TRP_Beam_Power_Item_pRSResourceSetID = INT(name='pRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-Set-ID')), opt=True)
    _TRP_Beam_Power_Item_pRSResourceID = INT(name='pRSResourceID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-ID')))
    _TRP_Beam_Power_Item_relativePower = INT(name='relativePower', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TRP_Beam_Power_Item_relativePower._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=30)], ev=None, er=[])
    _TRP_Beam_Power_Item_relativePowerFine = INT(name='relativePowerFine', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TRP_Beam_Power_Item_relativePowerFine._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    _TRP_Beam_Power_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRP_Beam_Power_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TRP_Beam_Power_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____TRP_Beam_Power_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRP_Beam_Power_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_Beam_Power_Item_iE_Extensions__item__id._const_tab = ____TRP_Beam_Power_Item_iE_Extensions__item__id_tab
    ___TRP_Beam_Power_Item_iE_Extensions__item__id._const_tab_at = None
    ___TRP_Beam_Power_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRP_Beam_Power_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRP_Beam_Power_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRP_Beam_Power_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_Beam_Power_Item_iE_Extensions__item__criticality._const_tab = ____TRP_Beam_Power_Item_iE_Extensions__item__criticality_tab
    ___TRP_Beam_Power_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRP_Beam_Power_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRP_Beam_Power_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRP_Beam_Power_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRP_Beam_Power_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_Beam_Power_Item_iE_Extensions__item__extensionValue._const_tab = ____TRP_Beam_Power_Item_iE_Extensions__item__extensionValue_tab
    ___TRP_Beam_Power_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRP_Beam_Power_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRP_Beam_Power_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRP_Beam_Power_Item_iE_Extensions__item__id),
        ('criticality', ___TRP_Beam_Power_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TRP_Beam_Power_Item_iE_Extensions__item__extensionValue),
        ])
    __TRP_Beam_Power_Item_iE_Extensions__item_._ext = None
    _TRP_Beam_Power_Item_iE_Extensions._cont = __TRP_Beam_Power_Item_iE_Extensions__item_
    _TRP_Beam_Power_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRP_Beam_Power_Item._cont = ASN1Dict([
        ('pRSResourceSetID', _TRP_Beam_Power_Item_pRSResourceSetID),
        ('pRSResourceID', _TRP_Beam_Power_Item_pRSResourceID),
        ('relativePower', _TRP_Beam_Power_Item_relativePower),
        ('relativePowerFine', _TRP_Beam_Power_Item_relativePowerFine),
        ('iE-Extensions', _TRP_Beam_Power_Item_iE_Extensions),
        ])
    TRP_Beam_Power_Item._ext = []
    
    #-----< TRP-Beam-Power-Item-ExtIEs >-----#
    TRP_Beam_Power_Item_ExtIEs = CLASS(name='TRP-Beam-Power-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TRP_Beam_Power_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPMeasurementQuantities >-----#
    TRPMeasurementQuantities = SEQ_OF(name='TRPMeasurementQuantities', mode=MODE_TYPE)
    _TRPMeasurementQuantities__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPMeasurementQuantitiesList-Item')))
    TRPMeasurementQuantities._cont = _TRPMeasurementQuantities__item_
    TRPMeasurementQuantities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< TRPMeasurementQuantitiesList-Item >-----#
    TRPMeasurementQuantitiesList_Item = SEQ(name='TRPMeasurementQuantitiesList-Item', mode=MODE_TYPE)
    _TRPMeasurementQuantitiesList_Item_tRPMeasurementQuantities_Item = ENUM(name='tRPMeasurementQuantities-Item', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRPMeasurementQuantities-Item')))
    _TRPMeasurementQuantitiesList_Item_timingReportingGranularityFactor = INT(name='timingReportingGranularityFactor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TRPMeasurementQuantitiesList_Item_timingReportingGranularityFactor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5)], ev=None, er=[])
    _TRPMeasurementQuantitiesList_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRPMeasurementQuantitiesList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____TRPMeasurementQuantitiesList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPMeasurementQuantitiesList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__id._const_tab = ____TRPMeasurementQuantitiesList_Item_iE_Extensions__item__id_tab
    ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__id._const_tab_at = None
    ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRPMeasurementQuantitiesList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPMeasurementQuantitiesList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__criticality._const_tab = ____TRPMeasurementQuantitiesList_Item_iE_Extensions__item__criticality_tab
    ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRPMeasurementQuantitiesList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPMeasurementQuantitiesList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__extensionValue._const_tab = ____TRPMeasurementQuantitiesList_Item_iE_Extensions__item__extensionValue_tab
    ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRPMeasurementQuantitiesList_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__id),
        ('criticality', ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__extensionValue),
        ])
    __TRPMeasurementQuantitiesList_Item_iE_Extensions__item_._ext = None
    _TRPMeasurementQuantitiesList_Item_iE_Extensions._cont = __TRPMeasurementQuantitiesList_Item_iE_Extensions__item_
    _TRPMeasurementQuantitiesList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRPMeasurementQuantitiesList_Item._cont = ASN1Dict([
        ('tRPMeasurementQuantities-Item', _TRPMeasurementQuantitiesList_Item_tRPMeasurementQuantities_Item),
        ('timingReportingGranularityFactor', _TRPMeasurementQuantitiesList_Item_timingReportingGranularityFactor),
        ('iE-Extensions', _TRPMeasurementQuantitiesList_Item_iE_Extensions),
        ])
    TRPMeasurementQuantitiesList_Item._ext = []
    
    #-----< TRPMeasurementQuantitiesList-Item-ExtIEs >-----#
    TRPMeasurementQuantitiesList_Item_ExtIEs = CLASS(name='TRPMeasurementQuantitiesList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TRPMeasurementQuantitiesList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPMeasurementQuantities-Item >-----#
    TRPMeasurementQuantities_Item = ENUM(name='TRPMeasurementQuantities-Item', mode=MODE_TYPE)
    TRPMeasurementQuantities_Item._cont = ASN1Dict([('gNB-RxTxTimeDiff', 0), ('uL-SRS-RSRP', 1), ('uL-AoA', 2), ('uL-RTOA', 3), ('multiple-UL-AoA', 4), ('uL-SRS-RSRPP', 5)])
    TRPMeasurementQuantities_Item._ext = ['multiple-UL-AoA', 'uL-SRS-RSRPP']
    
    #-----< TrpMeasurementResult >-----#
    TrpMeasurementResult = SEQ_OF(name='TrpMeasurementResult', mode=MODE_TYPE)
    _TrpMeasurementResult__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TrpMeasurementResultItem')))
    TrpMeasurementResult._cont = _TrpMeasurementResult__item_
    TrpMeasurementResult._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< TrpMeasurementResultItem >-----#
    TrpMeasurementResultItem = SEQ(name='TrpMeasurementResultItem', mode=MODE_TYPE)
    _TrpMeasurementResultItem_measuredResultsValue = CHOICE(name='measuredResultsValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TrpMeasuredResultsValue')))
    _TrpMeasurementResultItem_timeStamp = SEQ(name='timeStamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TimeStamp')))
    _TrpMeasurementResultItem_measurementQuality = CHOICE(name='measurementQuality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TrpMeasurementQuality')), opt=True)
    _TrpMeasurementResultItem_measurementBeamInfo = SEQ(name='measurementBeamInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementBeamInfo')), opt=True)
    _TrpMeasurementResultItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TrpMeasurementResultItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TrpMeasurementResultItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____TrpMeasurementResultItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____TrpMeasurementResultItem_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSResourcetype')))
    _____TrpMeasurementResultItem_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ARP-ID')))
    _____TrpMeasurementResultItem_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'LoS-NLoSInformation')))
    ____TrpMeasurementResultItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 76), ('criticality', 'ignore'), ('Extension', _____TrpMeasurementResultItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 79), ('criticality', 'ignore'), ('Extension', _____TrpMeasurementResultItem_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 80), ('criticality', 'ignore'), ('Extension', _____TrpMeasurementResultItem_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TrpMeasurementResultItem_iE_Extensions__item__id._const_tab = ____TrpMeasurementResultItem_iE_Extensions__item__id_tab
    ___TrpMeasurementResultItem_iE_Extensions__item__id._const_tab_at = None
    ___TrpMeasurementResultItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___TrpMeasurementResultItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ___TrpMeasurementResultItem_iE_Extensions__item__criticality._const_tab = ____TrpMeasurementResultItem_iE_Extensions__item__id_tab
    ___TrpMeasurementResultItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TrpMeasurementResultItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TrpMeasurementResultItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ___TrpMeasurementResultItem_iE_Extensions__item__extensionValue._const_tab = ____TrpMeasurementResultItem_iE_Extensions__item__id_tab
    ___TrpMeasurementResultItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TrpMeasurementResultItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TrpMeasurementResultItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TrpMeasurementResultItem_iE_Extensions__item__id),
        ('criticality', ___TrpMeasurementResultItem_iE_Extensions__item__criticality),
        ('extensionValue', ___TrpMeasurementResultItem_iE_Extensions__item__extensionValue),
        ])
    __TrpMeasurementResultItem_iE_Extensions__item_._ext = None
    _TrpMeasurementResultItem_iE_Extensions._cont = __TrpMeasurementResultItem_iE_Extensions__item_
    _TrpMeasurementResultItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TrpMeasurementResultItem._cont = ASN1Dict([
        ('measuredResultsValue', _TrpMeasurementResultItem_measuredResultsValue),
        ('timeStamp', _TrpMeasurementResultItem_timeStamp),
        ('measurementQuality', _TrpMeasurementResultItem_measurementQuality),
        ('measurementBeamInfo', _TrpMeasurementResultItem_measurementBeamInfo),
        ('iE-Extensions', _TrpMeasurementResultItem_iE_Extensions),
        ])
    TrpMeasurementResultItem._ext = []
    
    #-----< TrpMeasurementResultItem-ExtIEs >-----#
    TrpMeasurementResultItem_ExtIEs = CLASS(name='TrpMeasurementResultItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _TrpMeasurementResultItem_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSResourcetype')))
    _TrpMeasurementResultItem_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ARP-ID')))
    _TrpMeasurementResultItem_ExtIEs_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'LoS-NLoSInformation')))
    TrpMeasurementResultItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 76), ('criticality', 'ignore'), ('Extension', _TrpMeasurementResultItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 79), ('criticality', 'ignore'), ('Extension', _TrpMeasurementResultItem_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 80), ('criticality', 'ignore'), ('Extension', _TrpMeasurementResultItem_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TrpMeasuredResultsValue >-----#
    TrpMeasuredResultsValue = CHOICE(name='TrpMeasuredResultsValue', mode=MODE_TYPE)
    _TrpMeasuredResultsValue_uL_AngleOfArrival = SEQ(name='uL-AngleOfArrival', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'UL-AoA')))
    _TrpMeasuredResultsValue_uL_SRS_RSRP = INT(name='uL-SRS-RSRP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'UL-SRS-RSRP')))
    _TrpMeasuredResultsValue_uL_RTOA = SEQ(name='uL-RTOA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'UL-RTOAMeasurement')))
    _TrpMeasuredResultsValue_gNB_RxTxTimeDiff = SEQ(name='gNB-RxTxTimeDiff', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'GNB-RxTxTimeDiff')))
    _TrpMeasuredResultsValue_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __TrpMeasuredResultsValue_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___TrpMeasuredResultsValue_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ____TrpMeasuredResultsValue_choice_extension_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ZoA')))
    ____TrpMeasuredResultsValue_choice_extension_id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MultipleULAoA')))
    ____TrpMeasuredResultsValue_choice_extension_id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UL-SRS-RSRPP')))
    ___TrpMeasuredResultsValue_choice_extension_id_tab._val = ASN1Set(rv=[dict([('id', 71), ('criticality', 'reject'), ('Value', ____TrpMeasuredResultsValue_choice_extension_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 74), ('criticality', 'reject'), ('Value', ____TrpMeasuredResultsValue_choice_extension_id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 75), ('criticality', 'reject'), ('Value', ____TrpMeasuredResultsValue_choice_extension_id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __TrpMeasuredResultsValue_choice_extension_id._const_tab = ___TrpMeasuredResultsValue_choice_extension_id_tab
    __TrpMeasuredResultsValue_choice_extension_id._const_tab_at = None
    __TrpMeasuredResultsValue_choice_extension_id._const_tab_id = 'id'
    __TrpMeasuredResultsValue_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    __TrpMeasuredResultsValue_choice_extension_criticality._const_tab = ___TrpMeasuredResultsValue_choice_extension_id_tab
    __TrpMeasuredResultsValue_choice_extension_criticality._const_tab_at = ('..', 'id')
    __TrpMeasuredResultsValue_choice_extension_criticality._const_tab_id = 'criticality'
    __TrpMeasuredResultsValue_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    __TrpMeasuredResultsValue_choice_extension_value._const_tab = ___TrpMeasuredResultsValue_choice_extension_id_tab
    __TrpMeasuredResultsValue_choice_extension_value._const_tab_at = ('..', 'id')
    __TrpMeasuredResultsValue_choice_extension_value._const_tab_id = 'Value'
    _TrpMeasuredResultsValue_choice_extension._cont = ASN1Dict([
        ('id', __TrpMeasuredResultsValue_choice_extension_id),
        ('criticality', __TrpMeasuredResultsValue_choice_extension_criticality),
        ('value', __TrpMeasuredResultsValue_choice_extension_value),
        ])
    _TrpMeasuredResultsValue_choice_extension._ext = None
    TrpMeasuredResultsValue._cont = ASN1Dict([
        ('uL-AngleOfArrival', _TrpMeasuredResultsValue_uL_AngleOfArrival),
        ('uL-SRS-RSRP', _TrpMeasuredResultsValue_uL_SRS_RSRP),
        ('uL-RTOA', _TrpMeasuredResultsValue_uL_RTOA),
        ('gNB-RxTxTimeDiff', _TrpMeasuredResultsValue_gNB_RxTxTimeDiff),
        ('choice-extension', _TrpMeasuredResultsValue_choice_extension),
        ])
    TrpMeasuredResultsValue._ext = None
    
    #-----< TrpMeasuredResultsValue-ExtIEs >-----#
    TrpMeasuredResultsValue_ExtIEs = CLASS(name='TrpMeasuredResultsValue-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _TrpMeasuredResultsValue_ExtIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ZoA')))
    _TrpMeasuredResultsValue_ExtIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MultipleULAoA')))
    _TrpMeasuredResultsValue_ExtIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UL-SRS-RSRPP')))
    TrpMeasuredResultsValue_ExtIEs._val = ASN1Set(rv=[dict([('id', 71), ('criticality', 'reject'), ('Value', _TrpMeasuredResultsValue_ExtIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 74), ('criticality', 'reject'), ('Value', _TrpMeasuredResultsValue_ExtIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 75), ('criticality', 'reject'), ('Value', _TrpMeasuredResultsValue_ExtIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TrpMeasurementQuality >-----#
    TrpMeasurementQuality = CHOICE(name='TrpMeasurementQuality', mode=MODE_TYPE)
    _TrpMeasurementQuality_timingMeasQuality = SEQ(name='timingMeasQuality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TrpMeasurementTimingQuality')))
    _TrpMeasurementQuality_angleMeasQuality = SEQ(name='angleMeasQuality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TrpMeasurementAngleQuality')))
    _TrpMeasurementQuality_choice_Extension = SEQ(name='choice-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __TrpMeasurementQuality_choice_Extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___TrpMeasurementQuality_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TrpMeasurementQuality_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TrpMeasurementQuality_choice_Extension_id._const_tab = ___TrpMeasurementQuality_choice_Extension_id_tab
    __TrpMeasurementQuality_choice_Extension_id._const_tab_at = None
    __TrpMeasurementQuality_choice_Extension_id._const_tab_id = 'id'
    __TrpMeasurementQuality_choice_Extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___TrpMeasurementQuality_choice_Extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TrpMeasurementQuality_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TrpMeasurementQuality_choice_Extension_criticality._const_tab = ___TrpMeasurementQuality_choice_Extension_criticality_tab
    __TrpMeasurementQuality_choice_Extension_criticality._const_tab_at = ('..', 'id')
    __TrpMeasurementQuality_choice_Extension_criticality._const_tab_id = 'criticality'
    __TrpMeasurementQuality_choice_Extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___TrpMeasurementQuality_choice_Extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TrpMeasurementQuality_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TrpMeasurementQuality_choice_Extension_value._const_tab = ___TrpMeasurementQuality_choice_Extension_value_tab
    __TrpMeasurementQuality_choice_Extension_value._const_tab_at = ('..', 'id')
    __TrpMeasurementQuality_choice_Extension_value._const_tab_id = 'Value'
    _TrpMeasurementQuality_choice_Extension._cont = ASN1Dict([
        ('id', __TrpMeasurementQuality_choice_Extension_id),
        ('criticality', __TrpMeasurementQuality_choice_Extension_criticality),
        ('value', __TrpMeasurementQuality_choice_Extension_value),
        ])
    _TrpMeasurementQuality_choice_Extension._ext = None
    TrpMeasurementQuality._cont = ASN1Dict([
        ('timingMeasQuality', _TrpMeasurementQuality_timingMeasQuality),
        ('angleMeasQuality', _TrpMeasurementQuality_angleMeasQuality),
        ('choice-Extension', _TrpMeasurementQuality_choice_Extension),
        ])
    TrpMeasurementQuality._ext = None
    
    #-----< TrpMeasurementQuality-ExtIEs >-----#
    TrpMeasurementQuality_ExtIEs = CLASS(name='TrpMeasurementQuality-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    TrpMeasurementQuality_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TrpMeasurementTimingQuality >-----#
    TrpMeasurementTimingQuality = SEQ(name='TrpMeasurementTimingQuality', mode=MODE_TYPE)
    _TrpMeasurementTimingQuality_measurementQuality = INT(name='measurementQuality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TrpMeasurementTimingQuality_measurementQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    _TrpMeasurementTimingQuality_resolution = ENUM(name='resolution', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TrpMeasurementTimingQuality_resolution._cont = ASN1Dict([('m0dot1', 0), ('m1', 1), ('m10', 2), ('m30', 3)])
    _TrpMeasurementTimingQuality_resolution._ext = []
    _TrpMeasurementTimingQuality_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TrpMeasurementTimingQuality_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TrpMeasurementTimingQuality_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____TrpMeasurementTimingQuality_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TrpMeasurementTimingQuality_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TrpMeasurementTimingQuality_iE_extensions__item__id._const_tab = ____TrpMeasurementTimingQuality_iE_extensions__item__id_tab
    ___TrpMeasurementTimingQuality_iE_extensions__item__id._const_tab_at = None
    ___TrpMeasurementTimingQuality_iE_extensions__item__id._const_tab_id = 'id'
    ___TrpMeasurementTimingQuality_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____TrpMeasurementTimingQuality_iE_extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TrpMeasurementTimingQuality_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TrpMeasurementTimingQuality_iE_extensions__item__criticality._const_tab = ____TrpMeasurementTimingQuality_iE_extensions__item__criticality_tab
    ___TrpMeasurementTimingQuality_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TrpMeasurementTimingQuality_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___TrpMeasurementTimingQuality_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____TrpMeasurementTimingQuality_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TrpMeasurementTimingQuality_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TrpMeasurementTimingQuality_iE_extensions__item__extensionValue._const_tab = ____TrpMeasurementTimingQuality_iE_extensions__item__extensionValue_tab
    ___TrpMeasurementTimingQuality_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TrpMeasurementTimingQuality_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __TrpMeasurementTimingQuality_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___TrpMeasurementTimingQuality_iE_extensions__item__id),
        ('criticality', ___TrpMeasurementTimingQuality_iE_extensions__item__criticality),
        ('extensionValue', ___TrpMeasurementTimingQuality_iE_extensions__item__extensionValue),
        ])
    __TrpMeasurementTimingQuality_iE_extensions__item_._ext = None
    _TrpMeasurementTimingQuality_iE_extensions._cont = __TrpMeasurementTimingQuality_iE_extensions__item_
    _TrpMeasurementTimingQuality_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TrpMeasurementTimingQuality._cont = ASN1Dict([
        ('measurementQuality', _TrpMeasurementTimingQuality_measurementQuality),
        ('resolution', _TrpMeasurementTimingQuality_resolution),
        ('iE-extensions', _TrpMeasurementTimingQuality_iE_extensions),
        ])
    TrpMeasurementTimingQuality._ext = []
    
    #-----< TrpMeasurementTimingQuality-ExtIEs >-----#
    TrpMeasurementTimingQuality_ExtIEs = CLASS(name='TrpMeasurementTimingQuality-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TrpMeasurementTimingQuality_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TrpMeasurementAngleQuality >-----#
    TrpMeasurementAngleQuality = SEQ(name='TrpMeasurementAngleQuality', mode=MODE_TYPE)
    _TrpMeasurementAngleQuality_azimuthQuality = INT(name='azimuthQuality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TrpMeasurementAngleQuality_azimuthQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _TrpMeasurementAngleQuality_zenithQuality = INT(name='zenithQuality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TrpMeasurementAngleQuality_zenithQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _TrpMeasurementAngleQuality_resolution = ENUM(name='resolution', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TrpMeasurementAngleQuality_resolution._cont = ASN1Dict([('deg0dot1', 0)])
    _TrpMeasurementAngleQuality_resolution._ext = []
    _TrpMeasurementAngleQuality_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TrpMeasurementAngleQuality_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TrpMeasurementAngleQuality_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____TrpMeasurementAngleQuality_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TrpMeasurementAngleQuality_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TrpMeasurementAngleQuality_iE_extensions__item__id._const_tab = ____TrpMeasurementAngleQuality_iE_extensions__item__id_tab
    ___TrpMeasurementAngleQuality_iE_extensions__item__id._const_tab_at = None
    ___TrpMeasurementAngleQuality_iE_extensions__item__id._const_tab_id = 'id'
    ___TrpMeasurementAngleQuality_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____TrpMeasurementAngleQuality_iE_extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TrpMeasurementAngleQuality_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TrpMeasurementAngleQuality_iE_extensions__item__criticality._const_tab = ____TrpMeasurementAngleQuality_iE_extensions__item__criticality_tab
    ___TrpMeasurementAngleQuality_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TrpMeasurementAngleQuality_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___TrpMeasurementAngleQuality_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____TrpMeasurementAngleQuality_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TrpMeasurementAngleQuality_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TrpMeasurementAngleQuality_iE_extensions__item__extensionValue._const_tab = ____TrpMeasurementAngleQuality_iE_extensions__item__extensionValue_tab
    ___TrpMeasurementAngleQuality_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TrpMeasurementAngleQuality_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __TrpMeasurementAngleQuality_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___TrpMeasurementAngleQuality_iE_extensions__item__id),
        ('criticality', ___TrpMeasurementAngleQuality_iE_extensions__item__criticality),
        ('extensionValue', ___TrpMeasurementAngleQuality_iE_extensions__item__extensionValue),
        ])
    __TrpMeasurementAngleQuality_iE_extensions__item_._ext = None
    _TrpMeasurementAngleQuality_iE_extensions._cont = __TrpMeasurementAngleQuality_iE_extensions__item_
    _TrpMeasurementAngleQuality_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TrpMeasurementAngleQuality._cont = ASN1Dict([
        ('azimuthQuality', _TrpMeasurementAngleQuality_azimuthQuality),
        ('zenithQuality', _TrpMeasurementAngleQuality_zenithQuality),
        ('resolution', _TrpMeasurementAngleQuality_resolution),
        ('iE-extensions', _TrpMeasurementAngleQuality_iE_extensions),
        ])
    TrpMeasurementAngleQuality._ext = []
    
    #-----< TrpMeasurementAngleQuality-ExtIEs >-----#
    TrpMeasurementAngleQuality_ExtIEs = CLASS(name='TrpMeasurementAngleQuality-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TrpMeasurementAngleQuality_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRP-MeasurementRequestList >-----#
    TRP_MeasurementRequestList = SEQ_OF(name='TRP-MeasurementRequestList', mode=MODE_TYPE)
    _TRP_MeasurementRequestList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-MeasurementRequestItem')))
    TRP_MeasurementRequestList._cont = _TRP_MeasurementRequestList__item_
    TRP_MeasurementRequestList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< TRP-MeasurementRequestItem >-----#
    TRP_MeasurementRequestItem = SEQ(name='TRP-MeasurementRequestItem', mode=MODE_TYPE)
    _TRP_MeasurementRequestItem_tRP_ID = INT(name='tRP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRP-ID')))
    _TRP_MeasurementRequestItem_search_window_information = SEQ(name='search-window-information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'Search-window-information')), opt=True)
    _TRP_MeasurementRequestItem_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRP_MeasurementRequestItem_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TRP_MeasurementRequestItem_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____TRP_MeasurementRequestItem_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CGI-NR')))
    _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'AoA-AssistanceInfo')))
    _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'NumberOfTRPRxTEG')))
    _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'NumberOfTRPRxTxTEG')))
    ____TRP_MeasurementRequestItem_iE_extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 60), ('criticality', 'ignore'), ('Extension', _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 69), ('criticality', 'ignore'), ('Extension', _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 82), ('criticality', 'ignore'), ('Extension', _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 83), ('criticality', 'ignore'), ('Extension', _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TRP_MeasurementRequestItem_iE_extensions__item__id._const_tab = ____TRP_MeasurementRequestItem_iE_extensions__item__id_tab
    ___TRP_MeasurementRequestItem_iE_extensions__item__id._const_tab_at = None
    ___TRP_MeasurementRequestItem_iE_extensions__item__id._const_tab_id = 'id'
    ___TRP_MeasurementRequestItem_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ___TRP_MeasurementRequestItem_iE_extensions__item__criticality._const_tab = ____TRP_MeasurementRequestItem_iE_extensions__item__id_tab
    ___TRP_MeasurementRequestItem_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRP_MeasurementRequestItem_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___TRP_MeasurementRequestItem_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ___TRP_MeasurementRequestItem_iE_extensions__item__extensionValue._const_tab = ____TRP_MeasurementRequestItem_iE_extensions__item__id_tab
    ___TRP_MeasurementRequestItem_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRP_MeasurementRequestItem_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRP_MeasurementRequestItem_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___TRP_MeasurementRequestItem_iE_extensions__item__id),
        ('criticality', ___TRP_MeasurementRequestItem_iE_extensions__item__criticality),
        ('extensionValue', ___TRP_MeasurementRequestItem_iE_extensions__item__extensionValue),
        ])
    __TRP_MeasurementRequestItem_iE_extensions__item_._ext = None
    _TRP_MeasurementRequestItem_iE_extensions._cont = __TRP_MeasurementRequestItem_iE_extensions__item_
    _TRP_MeasurementRequestItem_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRP_MeasurementRequestItem._cont = ASN1Dict([
        ('tRP-ID', _TRP_MeasurementRequestItem_tRP_ID),
        ('search-window-information', _TRP_MeasurementRequestItem_search_window_information),
        ('iE-extensions', _TRP_MeasurementRequestItem_iE_extensions),
        ])
    TRP_MeasurementRequestItem._ext = []
    
    #-----< TRP-MeasurementRequestItem-ExtIEs >-----#
    TRP_MeasurementRequestItem_ExtIEs = CLASS(name='TRP-MeasurementRequestItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _TRP_MeasurementRequestItem_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CGI-NR')))
    _TRP_MeasurementRequestItem_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'AoA-AssistanceInfo')))
    _TRP_MeasurementRequestItem_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'NumberOfTRPRxTEG')))
    _TRP_MeasurementRequestItem_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'NumberOfTRPRxTxTEG')))
    TRP_MeasurementRequestItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 60), ('criticality', 'ignore'), ('Extension', _TRP_MeasurementRequestItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 69), ('criticality', 'ignore'), ('Extension', _TRP_MeasurementRequestItem_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 82), ('criticality', 'ignore'), ('Extension', _TRP_MeasurementRequestItem_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 83), ('criticality', 'ignore'), ('Extension', _TRP_MeasurementRequestItem_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TRP-MeasurementResponseList >-----#
    TRP_MeasurementResponseList = SEQ_OF(name='TRP-MeasurementResponseList', mode=MODE_TYPE)
    _TRP_MeasurementResponseList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-MeasurementResponseItem')))
    TRP_MeasurementResponseList._cont = _TRP_MeasurementResponseList__item_
    TRP_MeasurementResponseList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< TRP-MeasurementResponseItem >-----#
    TRP_MeasurementResponseItem = SEQ(name='TRP-MeasurementResponseItem', mode=MODE_TYPE)
    _TRP_MeasurementResponseItem_tRP_ID = INT(name='tRP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRP-ID')))
    _TRP_MeasurementResponseItem_measurementResult = SEQ_OF(name='measurementResult', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TrpMeasurementResult')))
    _TRP_MeasurementResponseItem_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRP_MeasurementResponseItem_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TRP_MeasurementResponseItem_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____TRP_MeasurementResponseItem_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____TRP_MeasurementResponseItem_iE_extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CGI-NR')))
    ____TRP_MeasurementResponseItem_iE_extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 60), ('criticality', 'ignore'), ('Extension', _____TRP_MeasurementResponseItem_iE_extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TRP_MeasurementResponseItem_iE_extensions__item__id._const_tab = ____TRP_MeasurementResponseItem_iE_extensions__item__id_tab
    ___TRP_MeasurementResponseItem_iE_extensions__item__id._const_tab_at = None
    ___TRP_MeasurementResponseItem_iE_extensions__item__id._const_tab_id = 'id'
    ___TRP_MeasurementResponseItem_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ___TRP_MeasurementResponseItem_iE_extensions__item__criticality._const_tab = ____TRP_MeasurementResponseItem_iE_extensions__item__id_tab
    ___TRP_MeasurementResponseItem_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRP_MeasurementResponseItem_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___TRP_MeasurementResponseItem_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ___TRP_MeasurementResponseItem_iE_extensions__item__extensionValue._const_tab = ____TRP_MeasurementResponseItem_iE_extensions__item__id_tab
    ___TRP_MeasurementResponseItem_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRP_MeasurementResponseItem_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRP_MeasurementResponseItem_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___TRP_MeasurementResponseItem_iE_extensions__item__id),
        ('criticality', ___TRP_MeasurementResponseItem_iE_extensions__item__criticality),
        ('extensionValue', ___TRP_MeasurementResponseItem_iE_extensions__item__extensionValue),
        ])
    __TRP_MeasurementResponseItem_iE_extensions__item_._ext = None
    _TRP_MeasurementResponseItem_iE_extensions._cont = __TRP_MeasurementResponseItem_iE_extensions__item_
    _TRP_MeasurementResponseItem_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRP_MeasurementResponseItem._cont = ASN1Dict([
        ('tRP-ID', _TRP_MeasurementResponseItem_tRP_ID),
        ('measurementResult', _TRP_MeasurementResponseItem_measurementResult),
        ('iE-extensions', _TRP_MeasurementResponseItem_iE_extensions),
        ])
    TRP_MeasurementResponseItem._ext = []
    
    #-----< TRP-MeasurementResponseItem-ExtIEs >-----#
    TRP_MeasurementResponseItem_ExtIEs = CLASS(name='TRP-MeasurementResponseItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _TRP_MeasurementResponseItem_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CGI-NR')))
    TRP_MeasurementResponseItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 60), ('criticality', 'ignore'), ('Extension', _TRP_MeasurementResponseItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TRP-MeasurementUpdateList >-----#
    TRP_MeasurementUpdateList = SEQ_OF(name='TRP-MeasurementUpdateList', mode=MODE_TYPE)
    _TRP_MeasurementUpdateList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-MeasurementUpdateItem')))
    TRP_MeasurementUpdateList._cont = _TRP_MeasurementUpdateList__item_
    TRP_MeasurementUpdateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< TRP-MeasurementUpdateItem >-----#
    TRP_MeasurementUpdateItem = SEQ(name='TRP-MeasurementUpdateItem', mode=MODE_TYPE)
    _TRP_MeasurementUpdateItem_tRP_ID = INT(name='tRP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRP-ID')))
    _TRP_MeasurementUpdateItem_aoA_window_information = SEQ(name='aoA-window-information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'AoA-AssistanceInfo')), opt=True)
    _TRP_MeasurementUpdateItem_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRP_MeasurementUpdateItem_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TRP_MeasurementUpdateItem_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____TRP_MeasurementUpdateItem_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____TRP_MeasurementUpdateItem_iE_extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'NumberOfTRPRxTEG')))
    _____TRP_MeasurementUpdateItem_iE_extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'NumberOfTRPRxTxTEG')))
    ____TRP_MeasurementUpdateItem_iE_extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 82), ('criticality', 'ignore'), ('Extension', _____TRP_MeasurementUpdateItem_iE_extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 83), ('criticality', 'ignore'), ('Extension', _____TRP_MeasurementUpdateItem_iE_extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TRP_MeasurementUpdateItem_iE_extensions__item__id._const_tab = ____TRP_MeasurementUpdateItem_iE_extensions__item__id_tab
    ___TRP_MeasurementUpdateItem_iE_extensions__item__id._const_tab_at = None
    ___TRP_MeasurementUpdateItem_iE_extensions__item__id._const_tab_id = 'id'
    ___TRP_MeasurementUpdateItem_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ___TRP_MeasurementUpdateItem_iE_extensions__item__criticality._const_tab = ____TRP_MeasurementUpdateItem_iE_extensions__item__id_tab
    ___TRP_MeasurementUpdateItem_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRP_MeasurementUpdateItem_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___TRP_MeasurementUpdateItem_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ___TRP_MeasurementUpdateItem_iE_extensions__item__extensionValue._const_tab = ____TRP_MeasurementUpdateItem_iE_extensions__item__id_tab
    ___TRP_MeasurementUpdateItem_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRP_MeasurementUpdateItem_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRP_MeasurementUpdateItem_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___TRP_MeasurementUpdateItem_iE_extensions__item__id),
        ('criticality', ___TRP_MeasurementUpdateItem_iE_extensions__item__criticality),
        ('extensionValue', ___TRP_MeasurementUpdateItem_iE_extensions__item__extensionValue),
        ])
    __TRP_MeasurementUpdateItem_iE_extensions__item_._ext = None
    _TRP_MeasurementUpdateItem_iE_extensions._cont = __TRP_MeasurementUpdateItem_iE_extensions__item_
    _TRP_MeasurementUpdateItem_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRP_MeasurementUpdateItem._cont = ASN1Dict([
        ('tRP-ID', _TRP_MeasurementUpdateItem_tRP_ID),
        ('aoA-window-information', _TRP_MeasurementUpdateItem_aoA_window_information),
        ('iE-extensions', _TRP_MeasurementUpdateItem_iE_extensions),
        ])
    TRP_MeasurementUpdateItem._ext = []
    
    #-----< TRP-MeasurementUpdateItem-ExtIEs >-----#
    TRP_MeasurementUpdateItem_ExtIEs = CLASS(name='TRP-MeasurementUpdateItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _TRP_MeasurementUpdateItem_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'NumberOfTRPRxTEG')))
    _TRP_MeasurementUpdateItem_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'NumberOfTRPRxTxTEG')))
    TRP_MeasurementUpdateItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 82), ('criticality', 'ignore'), ('Extension', _TRP_MeasurementUpdateItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 83), ('criticality', 'ignore'), ('Extension', _TRP_MeasurementUpdateItem_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TRPInformationListTRPResp >-----#
    TRPInformationListTRPResp = SEQ_OF(name='TRPInformationListTRPResp', mode=MODE_TYPE)
    _TRPInformationListTRPResp__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __TRPInformationListTRPResp__item__tRPInformation = SEQ(name='tRPInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRPInformation')))
    __TRPInformationListTRPResp__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___TRPInformationListTRPResp__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ____TRPInformationListTRPResp__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    _____TRPInformationListTRPResp__item__iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____TRPInformationListTRPResp__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TRPInformationListTRPResp__item__iE_Extensions__item__id._const_tab = _____TRPInformationListTRPResp__item__iE_Extensions__item__id_tab
    ____TRPInformationListTRPResp__item__iE_Extensions__item__id._const_tab_at = None
    ____TRPInformationListTRPResp__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____TRPInformationListTRPResp__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    _____TRPInformationListTRPResp__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____TRPInformationListTRPResp__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TRPInformationListTRPResp__item__iE_Extensions__item__criticality._const_tab = _____TRPInformationListTRPResp__item__iE_Extensions__item__criticality_tab
    ____TRPInformationListTRPResp__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____TRPInformationListTRPResp__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____TRPInformationListTRPResp__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    _____TRPInformationListTRPResp__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____TRPInformationListTRPResp__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TRPInformationListTRPResp__item__iE_Extensions__item__extensionValue._const_tab = _____TRPInformationListTRPResp__item__iE_Extensions__item__extensionValue_tab
    ____TRPInformationListTRPResp__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____TRPInformationListTRPResp__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___TRPInformationListTRPResp__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____TRPInformationListTRPResp__item__iE_Extensions__item__id),
        ('criticality', ____TRPInformationListTRPResp__item__iE_Extensions__item__criticality),
        ('extensionValue', ____TRPInformationListTRPResp__item__iE_Extensions__item__extensionValue),
        ])
    ___TRPInformationListTRPResp__item__iE_Extensions__item_._ext = None
    __TRPInformationListTRPResp__item__iE_Extensions._cont = ___TRPInformationListTRPResp__item__iE_Extensions__item_
    __TRPInformationListTRPResp__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _TRPInformationListTRPResp__item_._cont = ASN1Dict([
        ('tRPInformation', __TRPInformationListTRPResp__item__tRPInformation),
        ('iE-Extensions', __TRPInformationListTRPResp__item__iE_Extensions),
        ])
    _TRPInformationListTRPResp__item_._ext = []
    TRPInformationListTRPResp._cont = _TRPInformationListTRPResp__item_
    TRPInformationListTRPResp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< TRPInformationTRPResp-ExtIEs >-----#
    TRPInformationTRPResp_ExtIEs = CLASS(name='TRPInformationTRPResp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TRPInformationTRPResp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPInformation >-----#
    TRPInformation = SEQ(name='TRPInformation', mode=MODE_TYPE)
    _TRPInformation_tRP_ID = INT(name='tRP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRP-ID')))
    _TRPInformation_tRPInformationTypeResponseList = SEQ_OF(name='tRPInformationTypeResponseList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRPInformationTypeResponseList')))
    _TRPInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRPInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TRPInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____TRPInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPInformation_iE_Extensions__item__id._const_tab = ____TRPInformation_iE_Extensions__item__id_tab
    ___TRPInformation_iE_Extensions__item__id._const_tab_at = None
    ___TRPInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRPInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRPInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPInformation_iE_Extensions__item__criticality._const_tab = ____TRPInformation_iE_Extensions__item__criticality_tab
    ___TRPInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRPInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRPInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRPInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPInformation_iE_Extensions__item__extensionValue._const_tab = ____TRPInformation_iE_Extensions__item__extensionValue_tab
    ___TRPInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRPInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRPInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRPInformation_iE_Extensions__item__id),
        ('criticality', ___TRPInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___TRPInformation_iE_Extensions__item__extensionValue),
        ])
    __TRPInformation_iE_Extensions__item_._ext = None
    _TRPInformation_iE_Extensions._cont = __TRPInformation_iE_Extensions__item_
    _TRPInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRPInformation._cont = ASN1Dict([
        ('tRP-ID', _TRPInformation_tRP_ID),
        ('tRPInformationTypeResponseList', _TRPInformation_tRPInformationTypeResponseList),
        ('iE-Extensions', _TRPInformation_iE_Extensions),
        ])
    TRPInformation._ext = []
    
    #-----< TRPInformation-ExtIEs >-----#
    TRPInformation_ExtIEs = CLASS(name='TRPInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TRPInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPInformationTypeResponseList >-----#
    TRPInformationTypeResponseList = SEQ_OF(name='TRPInformationTypeResponseList', mode=MODE_TYPE)
    _TRPInformationTypeResponseList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPInformationTypeResponseItem')))
    TRPInformationTypeResponseList._cont = _TRPInformationTypeResponseList__item_
    TRPInformationTypeResponseList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< TRPInformationTypeResponseItem >-----#
    TRPInformationTypeResponseItem = CHOICE(name='TRPInformationTypeResponseItem', mode=MODE_TYPE)
    _TRPInformationTypeResponseItem_pCI_NR = INT(name='pCI-NR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TRPInformationTypeResponseItem_pCI_NR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1007)], ev=None, er=[])
    _TRPInformationTypeResponseItem_cGI_NR = SEQ(name='cGI-NR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CGI-NR')))
    _TRPInformationTypeResponseItem_aRFCN = INT(name='aRFCN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TRPInformationTypeResponseItem_aRFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _TRPInformationTypeResponseItem_pRSConfiguration = SEQ(name='pRSConfiguration', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSConfiguration')))
    _TRPInformationTypeResponseItem_sSBinformation = SEQ(name='sSBinformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SSBInfo')))
    _TRPInformationTypeResponseItem_sFNInitialisationTime = BIT_STR(name='sFNInitialisationTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RelativeTime1900')))
    _TRPInformationTypeResponseItem_spatialDirectionInformation = SEQ(name='spatialDirectionInformation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SpatialDirectionInformation')))
    _TRPInformationTypeResponseItem_geographicalCoordinates = SEQ(name='geographicalCoordinates', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'GeographicalCoordinates')))
    _TRPInformationTypeResponseItem_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __TRPInformationTypeResponseItem_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___TRPInformationTypeResponseItem_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPType')))
    ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'OnDemandPRS-Info')))
    ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPTxTEGAssociation')))
    ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPBeamAntennaInformation')))
    ___TRPInformationTypeResponseItem_choice_extension_id_tab._val = ASN1Set(rv=[dict([('id', 62), ('criticality', 'reject'), ('Value', ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 68), ('criticality', 'reject'), ('Value', ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 84), ('criticality', 'reject'), ('Value', ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 93), ('criticality', 'reject'), ('Value', ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __TRPInformationTypeResponseItem_choice_extension_id._const_tab = ___TRPInformationTypeResponseItem_choice_extension_id_tab
    __TRPInformationTypeResponseItem_choice_extension_id._const_tab_at = None
    __TRPInformationTypeResponseItem_choice_extension_id._const_tab_id = 'id'
    __TRPInformationTypeResponseItem_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    __TRPInformationTypeResponseItem_choice_extension_criticality._const_tab = ___TRPInformationTypeResponseItem_choice_extension_id_tab
    __TRPInformationTypeResponseItem_choice_extension_criticality._const_tab_at = ('..', 'id')
    __TRPInformationTypeResponseItem_choice_extension_criticality._const_tab_id = 'criticality'
    __TRPInformationTypeResponseItem_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    __TRPInformationTypeResponseItem_choice_extension_value._const_tab = ___TRPInformationTypeResponseItem_choice_extension_id_tab
    __TRPInformationTypeResponseItem_choice_extension_value._const_tab_at = ('..', 'id')
    __TRPInformationTypeResponseItem_choice_extension_value._const_tab_id = 'Value'
    _TRPInformationTypeResponseItem_choice_extension._cont = ASN1Dict([
        ('id', __TRPInformationTypeResponseItem_choice_extension_id),
        ('criticality', __TRPInformationTypeResponseItem_choice_extension_criticality),
        ('value', __TRPInformationTypeResponseItem_choice_extension_value),
        ])
    _TRPInformationTypeResponseItem_choice_extension._ext = None
    TRPInformationTypeResponseItem._cont = ASN1Dict([
        ('pCI-NR', _TRPInformationTypeResponseItem_pCI_NR),
        ('cGI-NR', _TRPInformationTypeResponseItem_cGI_NR),
        ('aRFCN', _TRPInformationTypeResponseItem_aRFCN),
        ('pRSConfiguration', _TRPInformationTypeResponseItem_pRSConfiguration),
        ('sSBinformation', _TRPInformationTypeResponseItem_sSBinformation),
        ('sFNInitialisationTime', _TRPInformationTypeResponseItem_sFNInitialisationTime),
        ('spatialDirectionInformation', _TRPInformationTypeResponseItem_spatialDirectionInformation),
        ('geographicalCoordinates', _TRPInformationTypeResponseItem_geographicalCoordinates),
        ('choice-extension', _TRPInformationTypeResponseItem_choice_extension),
        ])
    TRPInformationTypeResponseItem._ext = None
    
    #-----< TRPInformationTypeResponseItem-ExtIEs >-----#
    TRPInformationTypeResponseItem_ExtIEs = CLASS(name='TRPInformationTypeResponseItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _TRPInformationTypeResponseItem_ExtIEs_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPType')))
    _TRPInformationTypeResponseItem_ExtIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'OnDemandPRS-Info')))
    _TRPInformationTypeResponseItem_ExtIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPTxTEGAssociation')))
    _TRPInformationTypeResponseItem_ExtIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPBeamAntennaInformation')))
    TRPInformationTypeResponseItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 62), ('criticality', 'reject'), ('Value', _TRPInformationTypeResponseItem_ExtIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 68), ('criticality', 'reject'), ('Value', _TRPInformationTypeResponseItem_ExtIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 84), ('criticality', 'reject'), ('Value', _TRPInformationTypeResponseItem_ExtIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 93), ('criticality', 'reject'), ('Value', _TRPInformationTypeResponseItem_ExtIEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TRPInformationTypeListTRPReq >-----#
    TRPInformationTypeListTRPReq = SEQ_OF(name='TRPInformationTypeListTRPReq', mode=MODE_TYPE)
    _TRPInformationTypeListTRPReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __TRPInformationTypeListTRPReq__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___TRPInformationTypeListTRPReq__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ____TRPInformationTypeListTRPReq__item__id_tab_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPInformationTypeItem')))
    ___TRPInformationTypeListTRPReq__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', ____TRPInformationTypeListTRPReq__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __TRPInformationTypeListTRPReq__item__id._const_tab = ___TRPInformationTypeListTRPReq__item__id_tab
    __TRPInformationTypeListTRPReq__item__id._const_tab_at = None
    __TRPInformationTypeListTRPReq__item__id._const_tab_id = 'id'
    __TRPInformationTypeListTRPReq__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    __TRPInformationTypeListTRPReq__item__criticality._const_tab = ___TRPInformationTypeListTRPReq__item__id_tab
    __TRPInformationTypeListTRPReq__item__criticality._const_tab_at = ('..', 'id')
    __TRPInformationTypeListTRPReq__item__criticality._const_tab_id = 'criticality'
    __TRPInformationTypeListTRPReq__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    __TRPInformationTypeListTRPReq__item__value._const_tab = ___TRPInformationTypeListTRPReq__item__id_tab
    __TRPInformationTypeListTRPReq__item__value._const_tab_at = ('..', 'id')
    __TRPInformationTypeListTRPReq__item__value._const_tab_id = 'Value'
    _TRPInformationTypeListTRPReq__item_._cont = ASN1Dict([
        ('id', __TRPInformationTypeListTRPReq__item__id),
        ('criticality', __TRPInformationTypeListTRPReq__item__criticality),
        ('value', __TRPInformationTypeListTRPReq__item__value),
        ])
    _TRPInformationTypeListTRPReq__item_._ext = None
    TRPInformationTypeListTRPReq._cont = _TRPInformationTypeListTRPReq__item_
    TRPInformationTypeListTRPReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< TRPInformationTypeItemTRPReq >-----#
    TRPInformationTypeItemTRPReq = CLASS(name='TRPInformationTypeItemTRPReq', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _TRPInformationTypeItemTRPReq_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPInformationTypeItem')))
    TRPInformationTypeItemTRPReq._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'reject'), ('Value', _TRPInformationTypeItemTRPReq_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TRPInformationTypeItem >-----#
    TRPInformationTypeItem = ENUM(name='TRPInformationTypeItem', mode=MODE_TYPE)
    TRPInformationTypeItem._cont = ASN1Dict([('nrPCI', 0), ('nG-RAN-CGI', 1), ('arfcn', 2), ('pRSConfig', 3), ('sSBInfo', 4), ('sFNInitTime', 5), ('spatialDirectInfo', 6), ('geoCoord', 7), ('trp-type', 8), ('ondemandPRSInfo', 9), ('trpTxTeg', 10), ('beam-antenna-info', 11)])
    TRPInformationTypeItem._ext = ['trp-type', 'ondemandPRSInfo', 'trpTxTeg', 'beam-antenna-info']
    
    #-----< TRPList >-----#
    TRPList = SEQ_OF(name='TRPList', mode=MODE_TYPE)
    _TRPList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPItem')))
    TRPList._cont = _TRPList__item_
    TRPList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< TRPItem >-----#
    TRPItem = SEQ(name='TRPItem', mode=MODE_TYPE)
    _TRPItem_tRP_ID = INT(name='tRP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRP-ID')))
    _TRPItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRPItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TRPItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____TRPItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPItem_iE_Extensions__item__id._const_tab = ____TRPItem_iE_Extensions__item__id_tab
    ___TRPItem_iE_Extensions__item__id._const_tab_at = None
    ___TRPItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRPItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRPItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPItem_iE_Extensions__item__criticality._const_tab = ____TRPItem_iE_Extensions__item__criticality_tab
    ___TRPItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRPItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRPItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRPItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPItem_iE_Extensions__item__extensionValue._const_tab = ____TRPItem_iE_Extensions__item__extensionValue_tab
    ___TRPItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRPItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRPItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRPItem_iE_Extensions__item__id),
        ('criticality', ___TRPItem_iE_Extensions__item__criticality),
        ('extensionValue', ___TRPItem_iE_Extensions__item__extensionValue),
        ])
    __TRPItem_iE_Extensions__item_._ext = None
    _TRPItem_iE_Extensions._cont = __TRPItem_iE_Extensions__item_
    _TRPItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRPItem._cont = ASN1Dict([
        ('tRP-ID', _TRPItem_tRP_ID),
        ('iE-Extensions', _TRPItem_iE_Extensions),
        ])
    TRPItem._ext = []
    
    #-----< TRPItem-ExtIEs >-----#
    TRPItem_ExtIEs = CLASS(name='TRPItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TRPItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRP-ID >-----#
    TRP_ID = INT(name='TRP-ID', mode=MODE_TYPE)
    TRP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=[], er=[])
    
    #-----< TRPPositionDefinitionType >-----#
    TRPPositionDefinitionType = CHOICE(name='TRPPositionDefinitionType', mode=MODE_TYPE)
    _TRPPositionDefinitionType_direct = SEQ(name='direct', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRPPositionDirect')))
    _TRPPositionDefinitionType_referenced = SEQ(name='referenced', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRPPositionReferenced')))
    _TRPPositionDefinitionType_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __TRPPositionDefinitionType_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___TRPPositionDefinitionType_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TRPPositionDefinitionType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPPositionDefinitionType_choice_extension_id._const_tab = ___TRPPositionDefinitionType_choice_extension_id_tab
    __TRPPositionDefinitionType_choice_extension_id._const_tab_at = None
    __TRPPositionDefinitionType_choice_extension_id._const_tab_id = 'id'
    __TRPPositionDefinitionType_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___TRPPositionDefinitionType_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TRPPositionDefinitionType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPPositionDefinitionType_choice_extension_criticality._const_tab = ___TRPPositionDefinitionType_choice_extension_criticality_tab
    __TRPPositionDefinitionType_choice_extension_criticality._const_tab_at = ('..', 'id')
    __TRPPositionDefinitionType_choice_extension_criticality._const_tab_id = 'criticality'
    __TRPPositionDefinitionType_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___TRPPositionDefinitionType_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TRPPositionDefinitionType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPPositionDefinitionType_choice_extension_value._const_tab = ___TRPPositionDefinitionType_choice_extension_value_tab
    __TRPPositionDefinitionType_choice_extension_value._const_tab_at = ('..', 'id')
    __TRPPositionDefinitionType_choice_extension_value._const_tab_id = 'Value'
    _TRPPositionDefinitionType_choice_extension._cont = ASN1Dict([
        ('id', __TRPPositionDefinitionType_choice_extension_id),
        ('criticality', __TRPPositionDefinitionType_choice_extension_criticality),
        ('value', __TRPPositionDefinitionType_choice_extension_value),
        ])
    _TRPPositionDefinitionType_choice_extension._ext = None
    TRPPositionDefinitionType._cont = ASN1Dict([
        ('direct', _TRPPositionDefinitionType_direct),
        ('referenced', _TRPPositionDefinitionType_referenced),
        ('choice-extension', _TRPPositionDefinitionType_choice_extension),
        ])
    TRPPositionDefinitionType._ext = None
    
    #-----< TRPPositionDefinitionType-ExtIEs >-----#
    TRPPositionDefinitionType_ExtIEs = CLASS(name='TRPPositionDefinitionType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    TRPPositionDefinitionType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPPositionDirect >-----#
    TRPPositionDirect = SEQ(name='TRPPositionDirect', mode=MODE_TYPE)
    _TRPPositionDirect_accuracy = CHOICE(name='accuracy', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRPPositionDirectAccuracy')))
    _TRPPositionDirect_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRPPositionDirect_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TRPPositionDirect_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____TRPPositionDirect_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPPositionDirect_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPPositionDirect_iE_extensions__item__id._const_tab = ____TRPPositionDirect_iE_extensions__item__id_tab
    ___TRPPositionDirect_iE_extensions__item__id._const_tab_at = None
    ___TRPPositionDirect_iE_extensions__item__id._const_tab_id = 'id'
    ___TRPPositionDirect_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRPPositionDirect_iE_extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPPositionDirect_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPPositionDirect_iE_extensions__item__criticality._const_tab = ____TRPPositionDirect_iE_extensions__item__criticality_tab
    ___TRPPositionDirect_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRPPositionDirect_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___TRPPositionDirect_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRPPositionDirect_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPPositionDirect_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPPositionDirect_iE_extensions__item__extensionValue._const_tab = ____TRPPositionDirect_iE_extensions__item__extensionValue_tab
    ___TRPPositionDirect_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRPPositionDirect_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRPPositionDirect_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___TRPPositionDirect_iE_extensions__item__id),
        ('criticality', ___TRPPositionDirect_iE_extensions__item__criticality),
        ('extensionValue', ___TRPPositionDirect_iE_extensions__item__extensionValue),
        ])
    __TRPPositionDirect_iE_extensions__item_._ext = None
    _TRPPositionDirect_iE_extensions._cont = __TRPPositionDirect_iE_extensions__item_
    _TRPPositionDirect_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRPPositionDirect._cont = ASN1Dict([
        ('accuracy', _TRPPositionDirect_accuracy),
        ('iE-extensions', _TRPPositionDirect_iE_extensions),
        ])
    TRPPositionDirect._ext = []
    
    #-----< TRPPositionDirect-ExtIEs >-----#
    TRPPositionDirect_ExtIEs = CLASS(name='TRPPositionDirect-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TRPPositionDirect_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPPositionDirectAccuracy >-----#
    TRPPositionDirectAccuracy = CHOICE(name='TRPPositionDirectAccuracy', mode=MODE_TYPE)
    _TRPPositionDirectAccuracy_tRPPosition = SEQ(name='tRPPosition', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NG-RANAccessPointPosition')))
    _TRPPositionDirectAccuracy_tRPHAposition = SEQ(name='tRPHAposition', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NGRANHighAccuracyAccessPointPosition')))
    _TRPPositionDirectAccuracy_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __TRPPositionDirectAccuracy_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___TRPPositionDirectAccuracy_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TRPPositionDirectAccuracy_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPPositionDirectAccuracy_choice_extension_id._const_tab = ___TRPPositionDirectAccuracy_choice_extension_id_tab
    __TRPPositionDirectAccuracy_choice_extension_id._const_tab_at = None
    __TRPPositionDirectAccuracy_choice_extension_id._const_tab_id = 'id'
    __TRPPositionDirectAccuracy_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___TRPPositionDirectAccuracy_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TRPPositionDirectAccuracy_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPPositionDirectAccuracy_choice_extension_criticality._const_tab = ___TRPPositionDirectAccuracy_choice_extension_criticality_tab
    __TRPPositionDirectAccuracy_choice_extension_criticality._const_tab_at = ('..', 'id')
    __TRPPositionDirectAccuracy_choice_extension_criticality._const_tab_id = 'criticality'
    __TRPPositionDirectAccuracy_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___TRPPositionDirectAccuracy_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TRPPositionDirectAccuracy_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPPositionDirectAccuracy_choice_extension_value._const_tab = ___TRPPositionDirectAccuracy_choice_extension_value_tab
    __TRPPositionDirectAccuracy_choice_extension_value._const_tab_at = ('..', 'id')
    __TRPPositionDirectAccuracy_choice_extension_value._const_tab_id = 'Value'
    _TRPPositionDirectAccuracy_choice_extension._cont = ASN1Dict([
        ('id', __TRPPositionDirectAccuracy_choice_extension_id),
        ('criticality', __TRPPositionDirectAccuracy_choice_extension_criticality),
        ('value', __TRPPositionDirectAccuracy_choice_extension_value),
        ])
    _TRPPositionDirectAccuracy_choice_extension._ext = None
    TRPPositionDirectAccuracy._cont = ASN1Dict([
        ('tRPPosition', _TRPPositionDirectAccuracy_tRPPosition),
        ('tRPHAposition', _TRPPositionDirectAccuracy_tRPHAposition),
        ('choice-extension', _TRPPositionDirectAccuracy_choice_extension),
        ])
    TRPPositionDirectAccuracy._ext = None
    
    #-----< TRPPositionDirectAccuracy-ExtIEs >-----#
    TRPPositionDirectAccuracy_ExtIEs = CLASS(name='TRPPositionDirectAccuracy-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    TRPPositionDirectAccuracy_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPPositionReferenced >-----#
    TRPPositionReferenced = SEQ(name='TRPPositionReferenced', mode=MODE_TYPE)
    _TRPPositionReferenced_referencePoint = CHOICE(name='referencePoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ReferencePoint')))
    _TRPPositionReferenced_referencePointType = CHOICE(name='referencePointType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRPReferencePointType')))
    _TRPPositionReferenced_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRPPositionReferenced_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TRPPositionReferenced_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____TRPPositionReferenced_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPPositionReferenced_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPPositionReferenced_iE_extensions__item__id._const_tab = ____TRPPositionReferenced_iE_extensions__item__id_tab
    ___TRPPositionReferenced_iE_extensions__item__id._const_tab_at = None
    ___TRPPositionReferenced_iE_extensions__item__id._const_tab_id = 'id'
    ___TRPPositionReferenced_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRPPositionReferenced_iE_extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPPositionReferenced_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPPositionReferenced_iE_extensions__item__criticality._const_tab = ____TRPPositionReferenced_iE_extensions__item__criticality_tab
    ___TRPPositionReferenced_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRPPositionReferenced_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___TRPPositionReferenced_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRPPositionReferenced_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPPositionReferenced_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPPositionReferenced_iE_extensions__item__extensionValue._const_tab = ____TRPPositionReferenced_iE_extensions__item__extensionValue_tab
    ___TRPPositionReferenced_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRPPositionReferenced_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRPPositionReferenced_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___TRPPositionReferenced_iE_extensions__item__id),
        ('criticality', ___TRPPositionReferenced_iE_extensions__item__criticality),
        ('extensionValue', ___TRPPositionReferenced_iE_extensions__item__extensionValue),
        ])
    __TRPPositionReferenced_iE_extensions__item_._ext = None
    _TRPPositionReferenced_iE_extensions._cont = __TRPPositionReferenced_iE_extensions__item_
    _TRPPositionReferenced_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRPPositionReferenced._cont = ASN1Dict([
        ('referencePoint', _TRPPositionReferenced_referencePoint),
        ('referencePointType', _TRPPositionReferenced_referencePointType),
        ('iE-extensions', _TRPPositionReferenced_iE_extensions),
        ])
    TRPPositionReferenced._ext = []
    
    #-----< TRPPositionReferenced-ExtIEs >-----#
    TRPPositionReferenced_ExtIEs = CLASS(name='TRPPositionReferenced-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TRPPositionReferenced_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRP-PRS-Information-List >-----#
    TRP_PRS_Information_List = SEQ_OF(name='TRP-PRS-Information-List', mode=MODE_TYPE)
    _TRP_PRS_Information_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-PRS-Information-List-Item')))
    TRP_PRS_Information_List._cont = _TRP_PRS_Information_List__item_
    TRP_PRS_Information_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< TRP-PRS-Information-List-Item >-----#
    TRP_PRS_Information_List_Item = SEQ(name='TRP-PRS-Information-List-Item', mode=MODE_TYPE)
    _TRP_PRS_Information_List_Item_tRP_ID = INT(name='tRP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRP-ID')))
    _TRP_PRS_Information_List_Item_nR_PCI = INT(name='nR-PCI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'NR-PCI')))
    _TRP_PRS_Information_List_Item_cGI_NR = SEQ(name='cGI-NR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CGI-NR')), opt=True)
    _TRP_PRS_Information_List_Item_pRSConfiguration = SEQ(name='pRSConfiguration', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRSConfiguration')))
    _TRP_PRS_Information_List_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRP_PRS_Information_List_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TRP_PRS_Information_List_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____TRP_PRS_Information_List_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRP_PRS_Information_List_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_PRS_Information_List_Item_iE_Extensions__item__id._const_tab = ____TRP_PRS_Information_List_Item_iE_Extensions__item__id_tab
    ___TRP_PRS_Information_List_Item_iE_Extensions__item__id._const_tab_at = None
    ___TRP_PRS_Information_List_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRP_PRS_Information_List_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRP_PRS_Information_List_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRP_PRS_Information_List_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_PRS_Information_List_Item_iE_Extensions__item__criticality._const_tab = ____TRP_PRS_Information_List_Item_iE_Extensions__item__criticality_tab
    ___TRP_PRS_Information_List_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRP_PRS_Information_List_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRP_PRS_Information_List_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRP_PRS_Information_List_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRP_PRS_Information_List_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_PRS_Information_List_Item_iE_Extensions__item__extensionValue._const_tab = ____TRP_PRS_Information_List_Item_iE_Extensions__item__extensionValue_tab
    ___TRP_PRS_Information_List_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRP_PRS_Information_List_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRP_PRS_Information_List_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRP_PRS_Information_List_Item_iE_Extensions__item__id),
        ('criticality', ___TRP_PRS_Information_List_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___TRP_PRS_Information_List_Item_iE_Extensions__item__extensionValue),
        ])
    __TRP_PRS_Information_List_Item_iE_Extensions__item_._ext = None
    _TRP_PRS_Information_List_Item_iE_Extensions._cont = __TRP_PRS_Information_List_Item_iE_Extensions__item_
    _TRP_PRS_Information_List_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRP_PRS_Information_List_Item._cont = ASN1Dict([
        ('tRP-ID', _TRP_PRS_Information_List_Item_tRP_ID),
        ('nR-PCI', _TRP_PRS_Information_List_Item_nR_PCI),
        ('cGI-NR', _TRP_PRS_Information_List_Item_cGI_NR),
        ('pRSConfiguration', _TRP_PRS_Information_List_Item_pRSConfiguration),
        ('iE-Extensions', _TRP_PRS_Information_List_Item_iE_Extensions),
        ])
    TRP_PRS_Information_List_Item._ext = []
    
    #-----< TRP-PRS-Information-List-Item-ExtIEs >-----#
    TRP_PRS_Information_List_Item_ExtIEs = CLASS(name='TRP-PRS-Information-List-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TRP_PRS_Information_List_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPReferencePointType >-----#
    TRPReferencePointType = CHOICE(name='TRPReferencePointType', mode=MODE_TYPE)
    _TRPReferencePointType_tRPPositionRelativeGeodetic = SEQ(name='tRPPositionRelativeGeodetic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RelativeGeodeticLocation')))
    _TRPReferencePointType_tRPPositionRelativeCartesian = SEQ(name='tRPPositionRelativeCartesian', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RelativeCartesianLocation')))
    _TRPReferencePointType_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __TRPReferencePointType_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___TRPReferencePointType_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TRPReferencePointType_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPReferencePointType_choice_extension_id._const_tab = ___TRPReferencePointType_choice_extension_id_tab
    __TRPReferencePointType_choice_extension_id._const_tab_at = None
    __TRPReferencePointType_choice_extension_id._const_tab_id = 'id'
    __TRPReferencePointType_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___TRPReferencePointType_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TRPReferencePointType_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPReferencePointType_choice_extension_criticality._const_tab = ___TRPReferencePointType_choice_extension_criticality_tab
    __TRPReferencePointType_choice_extension_criticality._const_tab_at = ('..', 'id')
    __TRPReferencePointType_choice_extension_criticality._const_tab_id = 'criticality'
    __TRPReferencePointType_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___TRPReferencePointType_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___TRPReferencePointType_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TRPReferencePointType_choice_extension_value._const_tab = ___TRPReferencePointType_choice_extension_value_tab
    __TRPReferencePointType_choice_extension_value._const_tab_at = ('..', 'id')
    __TRPReferencePointType_choice_extension_value._const_tab_id = 'Value'
    _TRPReferencePointType_choice_extension._cont = ASN1Dict([
        ('id', __TRPReferencePointType_choice_extension_id),
        ('criticality', __TRPReferencePointType_choice_extension_criticality),
        ('value', __TRPReferencePointType_choice_extension_value),
        ])
    _TRPReferencePointType_choice_extension._ext = None
    TRPReferencePointType._cont = ASN1Dict([
        ('tRPPositionRelativeGeodetic', _TRPReferencePointType_tRPPositionRelativeGeodetic),
        ('tRPPositionRelativeCartesian', _TRPReferencePointType_tRPPositionRelativeCartesian),
        ('choice-extension', _TRPReferencePointType_choice_extension),
        ])
    TRPReferencePointType._ext = None
    
    #-----< TRPReferencePointType-ExtIEs >-----#
    TRPReferencePointType_ExtIEs = CLASS(name='TRPReferencePointType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    TRPReferencePointType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRP-Rx-TEGInformation >-----#
    TRP_Rx_TEGInformation = SEQ(name='TRP-Rx-TEGInformation', mode=MODE_TYPE)
    _TRP_Rx_TEGInformation_tRP_Rx_TEGID = INT(name='tRP-Rx-TEGID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TRP_Rx_TEGInformation_tRP_Rx_TEGID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    _TRP_Rx_TEGInformation_tRP_Rx_TimingErrorMargin = ENUM(name='tRP-Rx-TimingErrorMargin', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TimingErrorMargin')))
    _TRP_Rx_TEGInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRP_Rx_TEGInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TRP_Rx_TEGInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____TRP_Rx_TEGInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRP_Rx_TEGInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_Rx_TEGInformation_iE_Extensions__item__id._const_tab = ____TRP_Rx_TEGInformation_iE_Extensions__item__id_tab
    ___TRP_Rx_TEGInformation_iE_Extensions__item__id._const_tab_at = None
    ___TRP_Rx_TEGInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRP_Rx_TEGInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRP_Rx_TEGInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRP_Rx_TEGInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_Rx_TEGInformation_iE_Extensions__item__criticality._const_tab = ____TRP_Rx_TEGInformation_iE_Extensions__item__criticality_tab
    ___TRP_Rx_TEGInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRP_Rx_TEGInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRP_Rx_TEGInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRP_Rx_TEGInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRP_Rx_TEGInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_Rx_TEGInformation_iE_Extensions__item__extensionValue._const_tab = ____TRP_Rx_TEGInformation_iE_Extensions__item__extensionValue_tab
    ___TRP_Rx_TEGInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRP_Rx_TEGInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRP_Rx_TEGInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRP_Rx_TEGInformation_iE_Extensions__item__id),
        ('criticality', ___TRP_Rx_TEGInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___TRP_Rx_TEGInformation_iE_Extensions__item__extensionValue),
        ])
    __TRP_Rx_TEGInformation_iE_Extensions__item_._ext = None
    _TRP_Rx_TEGInformation_iE_Extensions._cont = __TRP_Rx_TEGInformation_iE_Extensions__item_
    _TRP_Rx_TEGInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRP_Rx_TEGInformation._cont = ASN1Dict([
        ('tRP-Rx-TEGID', _TRP_Rx_TEGInformation_tRP_Rx_TEGID),
        ('tRP-Rx-TimingErrorMargin', _TRP_Rx_TEGInformation_tRP_Rx_TimingErrorMargin),
        ('iE-Extensions', _TRP_Rx_TEGInformation_iE_Extensions),
        ])
    TRP_Rx_TEGInformation._ext = []
    
    #-----< TRP-Rx-TEGInformation-ExtIEs >-----#
    TRP_Rx_TEGInformation_ExtIEs = CLASS(name='TRP-Rx-TEGInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TRP_Rx_TEGInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRP-RxTx-TEGInformation >-----#
    TRP_RxTx_TEGInformation = SEQ(name='TRP-RxTx-TEGInformation', mode=MODE_TYPE)
    _TRP_RxTx_TEGInformation_tRP_RxTx_TEGID = INT(name='tRP-RxTx-TEGID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TRP_RxTx_TEGInformation_tRP_RxTx_TEGID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _TRP_RxTx_TEGInformation_tRP_RxTx_TimingErrorMargin = ENUM(name='tRP-RxTx-TimingErrorMargin', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'RxTxTimingErrorMargin')))
    _TRP_RxTx_TEGInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRP_RxTx_TEGInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TRP_RxTx_TEGInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____TRP_RxTx_TEGInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRP_RxTx_TEGInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_RxTx_TEGInformation_iE_Extensions__item__id._const_tab = ____TRP_RxTx_TEGInformation_iE_Extensions__item__id_tab
    ___TRP_RxTx_TEGInformation_iE_Extensions__item__id._const_tab_at = None
    ___TRP_RxTx_TEGInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRP_RxTx_TEGInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRP_RxTx_TEGInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRP_RxTx_TEGInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_RxTx_TEGInformation_iE_Extensions__item__criticality._const_tab = ____TRP_RxTx_TEGInformation_iE_Extensions__item__criticality_tab
    ___TRP_RxTx_TEGInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRP_RxTx_TEGInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRP_RxTx_TEGInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRP_RxTx_TEGInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRP_RxTx_TEGInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_RxTx_TEGInformation_iE_Extensions__item__extensionValue._const_tab = ____TRP_RxTx_TEGInformation_iE_Extensions__item__extensionValue_tab
    ___TRP_RxTx_TEGInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRP_RxTx_TEGInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRP_RxTx_TEGInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRP_RxTx_TEGInformation_iE_Extensions__item__id),
        ('criticality', ___TRP_RxTx_TEGInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___TRP_RxTx_TEGInformation_iE_Extensions__item__extensionValue),
        ])
    __TRP_RxTx_TEGInformation_iE_Extensions__item_._ext = None
    _TRP_RxTx_TEGInformation_iE_Extensions._cont = __TRP_RxTx_TEGInformation_iE_Extensions__item_
    _TRP_RxTx_TEGInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRP_RxTx_TEGInformation._cont = ASN1Dict([
        ('tRP-RxTx-TEGID', _TRP_RxTx_TEGInformation_tRP_RxTx_TEGID),
        ('tRP-RxTx-TimingErrorMargin', _TRP_RxTx_TEGInformation_tRP_RxTx_TimingErrorMargin),
        ('iE-Extensions', _TRP_RxTx_TEGInformation_iE_Extensions),
        ])
    TRP_RxTx_TEGInformation._ext = []
    
    #-----< TRP-RxTx-TEGInformation-ExtIEs >-----#
    TRP_RxTx_TEGInformation_ExtIEs = CLASS(name='TRP-RxTx-TEGInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TRP_RxTx_TEGInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRP-Tx-TEGInformation >-----#
    TRP_Tx_TEGInformation = SEQ(name='TRP-Tx-TEGInformation', mode=MODE_TYPE)
    _TRP_Tx_TEGInformation_tRP_Tx_TEGID = INT(name='tRP-Tx-TEGID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TRP_Tx_TEGInformation_tRP_Tx_TEGID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _TRP_Tx_TEGInformation_tRP_Tx_TimingErrorMargin = ENUM(name='tRP-Tx-TimingErrorMargin', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TimingErrorMargin')))
    _TRP_Tx_TEGInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRP_Tx_TEGInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TRP_Tx_TEGInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____TRP_Tx_TEGInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRP_Tx_TEGInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_Tx_TEGInformation_iE_Extensions__item__id._const_tab = ____TRP_Tx_TEGInformation_iE_Extensions__item__id_tab
    ___TRP_Tx_TEGInformation_iE_Extensions__item__id._const_tab_at = None
    ___TRP_Tx_TEGInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRP_Tx_TEGInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRP_Tx_TEGInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRP_Tx_TEGInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_Tx_TEGInformation_iE_Extensions__item__criticality._const_tab = ____TRP_Tx_TEGInformation_iE_Extensions__item__criticality_tab
    ___TRP_Tx_TEGInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRP_Tx_TEGInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRP_Tx_TEGInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRP_Tx_TEGInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRP_Tx_TEGInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRP_Tx_TEGInformation_iE_Extensions__item__extensionValue._const_tab = ____TRP_Tx_TEGInformation_iE_Extensions__item__extensionValue_tab
    ___TRP_Tx_TEGInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRP_Tx_TEGInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRP_Tx_TEGInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRP_Tx_TEGInformation_iE_Extensions__item__id),
        ('criticality', ___TRP_Tx_TEGInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___TRP_Tx_TEGInformation_iE_Extensions__item__extensionValue),
        ])
    __TRP_Tx_TEGInformation_iE_Extensions__item_._ext = None
    _TRP_Tx_TEGInformation_iE_Extensions._cont = __TRP_Tx_TEGInformation_iE_Extensions__item_
    _TRP_Tx_TEGInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRP_Tx_TEGInformation._cont = ASN1Dict([
        ('tRP-Tx-TEGID', _TRP_Tx_TEGInformation_tRP_Tx_TEGID),
        ('tRP-Tx-TimingErrorMargin', _TRP_Tx_TEGInformation_tRP_Tx_TimingErrorMargin),
        ('iE-Extensions', _TRP_Tx_TEGInformation_iE_Extensions),
        ])
    TRP_Tx_TEGInformation._ext = []
    
    #-----< TRP-Tx-TEGInformation-ExtIEs >-----#
    TRP_Tx_TEGInformation_ExtIEs = CLASS(name='TRP-Tx-TEGInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TRP_Tx_TEGInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPTxTEGAssociation >-----#
    TRPTxTEGAssociation = SEQ_OF(name='TRPTxTEGAssociation', mode=MODE_TYPE)
    _TRPTxTEGAssociation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPTEGItem')))
    TRPTxTEGAssociation._cont = _TRPTxTEGAssociation__item_
    TRPTxTEGAssociation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TRPTEGItem >-----#
    TRPTEGItem = SEQ(name='TRPTEGItem', mode=MODE_TYPE)
    _TRPTEGItem_tRP_Tx_TEGInformation = SEQ(name='tRP-Tx-TEGInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TRP-Tx-TEGInformation')))
    _TRPTEGItem_dl_PRSResourceSetID = INT(name='dl-PRSResourceSetID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-Set-ID')))
    _TRPTEGItem_dl_PRSResourceID_List = SEQ_OF(name='dl-PRSResourceID-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TRPTEGItem_dl_PRSResourceID_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'DLPRSResourceID-Item')))
    _TRPTEGItem_dl_PRSResourceID_List._cont = __TRPTEGItem_dl_PRSResourceID_List__item_
    _TRPTEGItem_dl_PRSResourceID_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _TRPTEGItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TRPTEGItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___TRPTEGItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____TRPTEGItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPTEGItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPTEGItem_iE_Extensions__item__id._const_tab = ____TRPTEGItem_iE_Extensions__item__id_tab
    ___TRPTEGItem_iE_Extensions__item__id._const_tab_at = None
    ___TRPTEGItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___TRPTEGItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____TRPTEGItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPTEGItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPTEGItem_iE_Extensions__item__criticality._const_tab = ____TRPTEGItem_iE_Extensions__item__criticality_tab
    ___TRPTEGItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TRPTEGItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TRPTEGItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____TRPTEGItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____TRPTEGItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TRPTEGItem_iE_Extensions__item__extensionValue._const_tab = ____TRPTEGItem_iE_Extensions__item__extensionValue_tab
    ___TRPTEGItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TRPTEGItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TRPTEGItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TRPTEGItem_iE_Extensions__item__id),
        ('criticality', ___TRPTEGItem_iE_Extensions__item__criticality),
        ('extensionValue', ___TRPTEGItem_iE_Extensions__item__extensionValue),
        ])
    __TRPTEGItem_iE_Extensions__item_._ext = None
    _TRPTEGItem_iE_Extensions._cont = __TRPTEGItem_iE_Extensions__item_
    _TRPTEGItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TRPTEGItem._cont = ASN1Dict([
        ('tRP-Tx-TEGInformation', _TRPTEGItem_tRP_Tx_TEGInformation),
        ('dl-PRSResourceSetID', _TRPTEGItem_dl_PRSResourceSetID),
        ('dl-PRSResourceID-List', _TRPTEGItem_dl_PRSResourceID_List),
        ('iE-Extensions', _TRPTEGItem_iE_Extensions),
        ])
    TRPTEGItem._ext = []
    
    #-----< TRPTEGItem-ExtIEs >-----#
    TRPTEGItem_ExtIEs = CLASS(name='TRPTEGItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    TRPTEGItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DLPRSResourceID-Item >-----#
    DLPRSResourceID_Item = SEQ(name='DLPRSResourceID-Item', mode=MODE_TYPE)
    _DLPRSResourceID_Item_dl_PRSResourceID = INT(name='dl-PRSResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Resource-ID')))
    _DLPRSResourceID_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DLPRSResourceID_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___DLPRSResourceID_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____DLPRSResourceID_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DLPRSResourceID_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceID_Item_iE_Extensions__item__id._const_tab = ____DLPRSResourceID_Item_iE_Extensions__item__id_tab
    ___DLPRSResourceID_Item_iE_Extensions__item__id._const_tab_at = None
    ___DLPRSResourceID_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___DLPRSResourceID_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____DLPRSResourceID_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DLPRSResourceID_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceID_Item_iE_Extensions__item__criticality._const_tab = ____DLPRSResourceID_Item_iE_Extensions__item__criticality_tab
    ___DLPRSResourceID_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DLPRSResourceID_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DLPRSResourceID_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____DLPRSResourceID_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____DLPRSResourceID_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DLPRSResourceID_Item_iE_Extensions__item__extensionValue._const_tab = ____DLPRSResourceID_Item_iE_Extensions__item__extensionValue_tab
    ___DLPRSResourceID_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DLPRSResourceID_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DLPRSResourceID_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DLPRSResourceID_Item_iE_Extensions__item__id),
        ('criticality', ___DLPRSResourceID_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___DLPRSResourceID_Item_iE_Extensions__item__extensionValue),
        ])
    __DLPRSResourceID_Item_iE_Extensions__item_._ext = None
    _DLPRSResourceID_Item_iE_Extensions._cont = __DLPRSResourceID_Item_iE_Extensions__item_
    _DLPRSResourceID_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DLPRSResourceID_Item._cont = ASN1Dict([
        ('dl-PRSResourceID', _DLPRSResourceID_Item_dl_PRSResourceID),
        ('iE-Extensions', _DLPRSResourceID_Item_iE_Extensions),
        ])
    DLPRSResourceID_Item._ext = []
    
    #-----< DLPRSResource-Item-ExtIEs >-----#
    DLPRSResource_Item_ExtIEs = CLASS(name='DLPRSResource-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    DLPRSResource_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TRPType >-----#
    TRPType = ENUM(name='TRPType', mode=MODE_TYPE)
    TRPType._cont = ASN1Dict([('prsOnlyTP', 0), ('srsOnlyRP', 1), ('tp', 2), ('rp', 3), ('trp', 4)])
    TRPType._ext = []
    
    #-----< TypeOfError >-----#
    TypeOfError = ENUM(name='TypeOfError', mode=MODE_TYPE)
    TypeOfError._cont = ASN1Dict([('not-understood', 0), ('missing', 1)])
    TypeOfError._ext = []
    
    #-----< UARFCN >-----#
    UARFCN = INT(name='UARFCN', mode=MODE_TYPE)
    UARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=[], er=[])
    
    #-----< UE-Measurement-ID >-----#
    UE_Measurement_ID = INT(name='UE-Measurement-ID', mode=MODE_TYPE)
    UE_Measurement_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=[], er=[ASN1RangeInt(lb=16, ub=256)])
    
    #-----< UEReportingInformation >-----#
    UEReportingInformation = SEQ(name='UEReportingInformation', mode=MODE_TYPE)
    _UEReportingInformation_reportingAmount = ENUM(name='reportingAmount', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UEReportingInformation_reportingAmount._cont = ASN1Dict([('ma0', 0), ('ma1', 1), ('ma2', 2), ('ma4', 3), ('ma8', 4), ('ma16', 5), ('ma32', 6), ('ma64', 7)])
    _UEReportingInformation_reportingAmount._ext = None
    _UEReportingInformation_reportingInterval = ENUM(name='reportingInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UEReportingInformation_reportingInterval._cont = ASN1Dict([('none', 0), ('one', 1), ('two', 2), ('four', 3), ('eight', 4), ('ten', 5), ('sixteen', 6), ('twenty', 7), ('thirty-two', 8), ('sixty-four', 9)])
    _UEReportingInformation_reportingInterval._ext = []
    _UEReportingInformation_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEReportingInformation_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___UEReportingInformation_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____UEReportingInformation_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____UEReportingInformation_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEReportingInformation_iE_extensions__item__id._const_tab = ____UEReportingInformation_iE_extensions__item__id_tab
    ___UEReportingInformation_iE_extensions__item__id._const_tab_at = None
    ___UEReportingInformation_iE_extensions__item__id._const_tab_id = 'id'
    ___UEReportingInformation_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____UEReportingInformation_iE_extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____UEReportingInformation_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEReportingInformation_iE_extensions__item__criticality._const_tab = ____UEReportingInformation_iE_extensions__item__criticality_tab
    ___UEReportingInformation_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UEReportingInformation_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___UEReportingInformation_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____UEReportingInformation_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____UEReportingInformation_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEReportingInformation_iE_extensions__item__extensionValue._const_tab = ____UEReportingInformation_iE_extensions__item__extensionValue_tab
    ___UEReportingInformation_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UEReportingInformation_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __UEReportingInformation_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___UEReportingInformation_iE_extensions__item__id),
        ('criticality', ___UEReportingInformation_iE_extensions__item__criticality),
        ('extensionValue', ___UEReportingInformation_iE_extensions__item__extensionValue),
        ])
    __UEReportingInformation_iE_extensions__item_._ext = None
    _UEReportingInformation_iE_extensions._cont = __UEReportingInformation_iE_extensions__item_
    _UEReportingInformation_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEReportingInformation._cont = ASN1Dict([
        ('reportingAmount', _UEReportingInformation_reportingAmount),
        ('reportingInterval', _UEReportingInformation_reportingInterval),
        ('iE-extensions', _UEReportingInformation_iE_extensions),
        ])
    UEReportingInformation._ext = []
    
    #-----< UEReportingInformation-ExtIEs >-----#
    UEReportingInformation_ExtIEs = CLASS(name='UEReportingInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    UEReportingInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-TEG-ReportingPeriodicity >-----#
    UE_TEG_ReportingPeriodicity = ENUM(name='UE-TEG-ReportingPeriodicity', mode=MODE_TYPE)
    UE_TEG_ReportingPeriodicity._cont = ASN1Dict([('ms160', 0), ('ms320', 1), ('ms1280', 2), ('ms2560', 3), ('ms61440', 4), ('ms81920', 5), ('ms368640', 6), ('ms737280', 7)])
    UE_TEG_ReportingPeriodicity._ext = []
    
    #-----< UETxTEGAssociationList >-----#
    UETxTEGAssociationList = SEQ_OF(name='UETxTEGAssociationList', mode=MODE_TYPE)
    _UETxTEGAssociationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UETxTEGAssociationItem')))
    UETxTEGAssociationList._cont = _UETxTEGAssociationList__item_
    UETxTEGAssociationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< UETxTEGAssociationItem >-----#
    UETxTEGAssociationItem = SEQ(name='UETxTEGAssociationItem', mode=MODE_TYPE)
    _UETxTEGAssociationItem_uE_Tx_TEG_ID = INT(name='uE-Tx-TEG-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UETxTEGAssociationItem_uE_Tx_TEG_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _UETxTEGAssociationItem_posSRSResourceID_List = SEQ_OF(name='posSRSResourceID-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'PosSRSResourceID-List')))
    _UETxTEGAssociationItem_timeStamp = SEQ(name='timeStamp', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'TimeStamp')))
    _UETxTEGAssociationItem_carrierFreq = SEQ(name='carrierFreq', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'CarrierFreq')), opt=True)
    _UETxTEGAssociationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UETxTEGAssociationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___UETxTEGAssociationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____UETxTEGAssociationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____UETxTEGAssociationItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TimingErrorMargin')))
    ____UETxTEGAssociationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 104), ('criticality', 'ignore'), ('Extension', _____UETxTEGAssociationItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UETxTEGAssociationItem_iE_Extensions__item__id._const_tab = ____UETxTEGAssociationItem_iE_Extensions__item__id_tab
    ___UETxTEGAssociationItem_iE_Extensions__item__id._const_tab_at = None
    ___UETxTEGAssociationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UETxTEGAssociationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ___UETxTEGAssociationItem_iE_Extensions__item__criticality._const_tab = ____UETxTEGAssociationItem_iE_Extensions__item__id_tab
    ___UETxTEGAssociationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UETxTEGAssociationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UETxTEGAssociationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ___UETxTEGAssociationItem_iE_Extensions__item__extensionValue._const_tab = ____UETxTEGAssociationItem_iE_Extensions__item__id_tab
    ___UETxTEGAssociationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UETxTEGAssociationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UETxTEGAssociationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UETxTEGAssociationItem_iE_Extensions__item__id),
        ('criticality', ___UETxTEGAssociationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UETxTEGAssociationItem_iE_Extensions__item__extensionValue),
        ])
    __UETxTEGAssociationItem_iE_Extensions__item_._ext = None
    _UETxTEGAssociationItem_iE_Extensions._cont = __UETxTEGAssociationItem_iE_Extensions__item_
    _UETxTEGAssociationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UETxTEGAssociationItem._cont = ASN1Dict([
        ('uE-Tx-TEG-ID', _UETxTEGAssociationItem_uE_Tx_TEG_ID),
        ('posSRSResourceID-List', _UETxTEGAssociationItem_posSRSResourceID_List),
        ('timeStamp', _UETxTEGAssociationItem_timeStamp),
        ('carrierFreq', _UETxTEGAssociationItem_carrierFreq),
        ('iE-Extensions', _UETxTEGAssociationItem_iE_Extensions),
        ])
    UETxTEGAssociationItem._ext = []
    
    #-----< UETxTEGAssociationItem-ExtIEs >-----#
    UETxTEGAssociationItem_ExtIEs = CLASS(name='UETxTEGAssociationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _UETxTEGAssociationItem_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TimingErrorMargin')))
    UETxTEGAssociationItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 104), ('criticality', 'ignore'), ('Extension', _UETxTEGAssociationItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SRSResourceID-Item >-----#
    SRSResourceID_Item = SEQ(name='SRSResourceID-Item', mode=MODE_TYPE)
    _SRSResourceID_Item_sRSResourceID = INT(name='sRSResourceID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSResourceID')))
    _SRSResourceID_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRSResourceID_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SRSResourceID_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____SRSResourceID_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSResourceID_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceID_Item_iE_Extensions__item__id._const_tab = ____SRSResourceID_Item_iE_Extensions__item__id_tab
    ___SRSResourceID_Item_iE_Extensions__item__id._const_tab_at = None
    ___SRSResourceID_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRSResourceID_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____SRSResourceID_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSResourceID_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceID_Item_iE_Extensions__item__criticality._const_tab = ____SRSResourceID_Item_iE_Extensions__item__criticality_tab
    ___SRSResourceID_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRSResourceID_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRSResourceID_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____SRSResourceID_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____SRSResourceID_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRSResourceID_Item_iE_Extensions__item__extensionValue._const_tab = ____SRSResourceID_Item_iE_Extensions__item__extensionValue_tab
    ___SRSResourceID_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRSResourceID_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRSResourceID_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRSResourceID_Item_iE_Extensions__item__id),
        ('criticality', ___SRSResourceID_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___SRSResourceID_Item_iE_Extensions__item__extensionValue),
        ])
    __SRSResourceID_Item_iE_Extensions__item_._ext = None
    _SRSResourceID_Item_iE_Extensions._cont = __SRSResourceID_Item_iE_Extensions__item_
    _SRSResourceID_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRSResourceID_Item._cont = ASN1Dict([
        ('sRSResourceID', _SRSResourceID_Item_sRSResourceID),
        ('iE-Extensions', _SRSResourceID_Item_iE_Extensions),
        ])
    SRSResourceID_Item._ext = []
    
    #-----< SRSResourceID-Item-ExtIEs >-----#
    SRSResourceID_Item_ExtIEs = CLASS(name='SRSResourceID-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    SRSResourceID_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-TEG-Info-Request >-----#
    UE_TEG_Info_Request = ENUM(name='UE-TEG-Info-Request', mode=MODE_TYPE)
    UE_TEG_Info_Request._cont = ASN1Dict([('onDemand', 0), ('periodic', 1), ('stop', 2)])
    UE_TEG_Info_Request._ext = []
    
    #-----< UTRA-EcN0 >-----#
    UTRA_EcN0 = INT(name='UTRA-EcN0', mode=MODE_TYPE)
    UTRA_EcN0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=49)], ev=[], er=[])
    
    #-----< UTRA-RSCP >-----#
    UTRA_RSCP = INT(name='UTRA-RSCP', mode=MODE_TYPE)
    UTRA_RSCP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-5, ub=91)], ev=[], er=[])
    
    #-----< UL-AoA >-----#
    UL_AoA = SEQ(name='UL-AoA', mode=MODE_TYPE)
    _UL_AoA_azimuthAoA = INT(name='azimuthAoA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UL_AoA_azimuthAoA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599)], ev=None, er=[])
    _UL_AoA_zenithAoA = INT(name='zenithAoA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UL_AoA_zenithAoA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1799)], ev=None, er=[])
    _UL_AoA_lCS_to_GCS_Translation = SEQ(name='lCS-to-GCS-Translation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'LCS-to-GCS-Translation')), opt=True)
    _UL_AoA_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_AoA_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___UL_AoA_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____UL_AoA_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____UL_AoA_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_AoA_iE_extensions__item__id._const_tab = ____UL_AoA_iE_extensions__item__id_tab
    ___UL_AoA_iE_extensions__item__id._const_tab_at = None
    ___UL_AoA_iE_extensions__item__id._const_tab_id = 'id'
    ___UL_AoA_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_AoA_iE_extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____UL_AoA_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_AoA_iE_extensions__item__criticality._const_tab = ____UL_AoA_iE_extensions__item__criticality_tab
    ___UL_AoA_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_AoA_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_AoA_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_AoA_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____UL_AoA_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_AoA_iE_extensions__item__extensionValue._const_tab = ____UL_AoA_iE_extensions__item__extensionValue_tab
    ___UL_AoA_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_AoA_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_AoA_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___UL_AoA_iE_extensions__item__id),
        ('criticality', ___UL_AoA_iE_extensions__item__criticality),
        ('extensionValue', ___UL_AoA_iE_extensions__item__extensionValue),
        ])
    __UL_AoA_iE_extensions__item_._ext = None
    _UL_AoA_iE_extensions._cont = __UL_AoA_iE_extensions__item_
    _UL_AoA_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_AoA._cont = ASN1Dict([
        ('azimuthAoA', _UL_AoA_azimuthAoA),
        ('zenithAoA', _UL_AoA_zenithAoA),
        ('lCS-to-GCS-Translation', _UL_AoA_lCS_to_GCS_Translation),
        ('iE-extensions', _UL_AoA_iE_extensions),
        ])
    UL_AoA._ext = []
    
    #-----< UL-AoA-ExtIEs >-----#
    UL_AoA_ExtIEs = CLASS(name='UL-AoA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    UL_AoA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-RTOAMeasurement >-----#
    UL_RTOAMeasurement = SEQ(name='UL-RTOAMeasurement', mode=MODE_TYPE)
    _UL_RTOAMeasurement_uLRTOAmeas = CHOICE(name='uLRTOAmeas', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'ULRTOAMeas')))
    _UL_RTOAMeasurement_additionalPathList = SEQ_OF(name='additionalPathList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'AdditionalPathList')), opt=True)
    _UL_RTOAMeasurement_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_RTOAMeasurement_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___UL_RTOAMeasurement_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____UL_RTOAMeasurement_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____UL_RTOAMeasurement_iE_extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ExtendedAdditionalPathList')))
    _____UL_RTOAMeasurement_iE_extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-Rx-TEGInformation')))
    ____UL_RTOAMeasurement_iE_extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 77), ('criticality', 'ignore'), ('Extension', _____UL_RTOAMeasurement_iE_extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Extension', _____UL_RTOAMeasurement_iE_extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UL_RTOAMeasurement_iE_extensions__item__id._const_tab = ____UL_RTOAMeasurement_iE_extensions__item__id_tab
    ___UL_RTOAMeasurement_iE_extensions__item__id._const_tab_at = None
    ___UL_RTOAMeasurement_iE_extensions__item__id._const_tab_id = 'id'
    ___UL_RTOAMeasurement_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ___UL_RTOAMeasurement_iE_extensions__item__criticality._const_tab = ____UL_RTOAMeasurement_iE_extensions__item__id_tab
    ___UL_RTOAMeasurement_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_RTOAMeasurement_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_RTOAMeasurement_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ___UL_RTOAMeasurement_iE_extensions__item__extensionValue._const_tab = ____UL_RTOAMeasurement_iE_extensions__item__id_tab
    ___UL_RTOAMeasurement_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_RTOAMeasurement_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_RTOAMeasurement_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___UL_RTOAMeasurement_iE_extensions__item__id),
        ('criticality', ___UL_RTOAMeasurement_iE_extensions__item__criticality),
        ('extensionValue', ___UL_RTOAMeasurement_iE_extensions__item__extensionValue),
        ])
    __UL_RTOAMeasurement_iE_extensions__item_._ext = None
    _UL_RTOAMeasurement_iE_extensions._cont = __UL_RTOAMeasurement_iE_extensions__item_
    _UL_RTOAMeasurement_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_RTOAMeasurement._cont = ASN1Dict([
        ('uLRTOAmeas', _UL_RTOAMeasurement_uLRTOAmeas),
        ('additionalPathList', _UL_RTOAMeasurement_additionalPathList),
        ('iE-extensions', _UL_RTOAMeasurement_iE_extensions),
        ])
    UL_RTOAMeasurement._ext = []
    
    #-----< UL-RTOAMeasurement-ExtIEs >-----#
    UL_RTOAMeasurement_ExtIEs = CLASS(name='UL-RTOAMeasurement-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _UL_RTOAMeasurement_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ExtendedAdditionalPathList')))
    _UL_RTOAMeasurement_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-Rx-TEGInformation')))
    UL_RTOAMeasurement_ExtIEs._val = ASN1Set(rv=[dict([('id', 77), ('criticality', 'ignore'), ('Extension', _UL_RTOAMeasurement_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Extension', _UL_RTOAMeasurement_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ULRTOAMeas >-----#
    ULRTOAMeas = CHOICE(name='ULRTOAMeas', mode=MODE_TYPE)
    _ULRTOAMeas_k0 = INT(name='k0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ULRTOAMeas_k0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1970049)], ev=None, er=[])
    _ULRTOAMeas_k1 = INT(name='k1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ULRTOAMeas_k1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=985025)], ev=None, er=[])
    _ULRTOAMeas_k2 = INT(name='k2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ULRTOAMeas_k2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=492513)], ev=None, er=[])
    _ULRTOAMeas_k3 = INT(name='k3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ULRTOAMeas_k3._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=246257)], ev=None, er=[])
    _ULRTOAMeas_k4 = INT(name='k4', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ULRTOAMeas_k4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=123129)], ev=None, er=[])
    _ULRTOAMeas_k5 = INT(name='k5', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ULRTOAMeas_k5._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=61565)], ev=None, er=[])
    _ULRTOAMeas_choice_extension = SEQ(name='choice-extension', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __ULRTOAMeas_choice_extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___ULRTOAMeas_choice_extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ULRTOAMeas_choice_extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ULRTOAMeas_choice_extension_id._const_tab = ___ULRTOAMeas_choice_extension_id_tab
    __ULRTOAMeas_choice_extension_id._const_tab_at = None
    __ULRTOAMeas_choice_extension_id._const_tab_id = 'id'
    __ULRTOAMeas_choice_extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___ULRTOAMeas_choice_extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ULRTOAMeas_choice_extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ULRTOAMeas_choice_extension_criticality._const_tab = ___ULRTOAMeas_choice_extension_criticality_tab
    __ULRTOAMeas_choice_extension_criticality._const_tab_at = ('..', 'id')
    __ULRTOAMeas_choice_extension_criticality._const_tab_id = 'criticality'
    __ULRTOAMeas_choice_extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___ULRTOAMeas_choice_extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___ULRTOAMeas_choice_extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ULRTOAMeas_choice_extension_value._const_tab = ___ULRTOAMeas_choice_extension_value_tab
    __ULRTOAMeas_choice_extension_value._const_tab_at = ('..', 'id')
    __ULRTOAMeas_choice_extension_value._const_tab_id = 'Value'
    _ULRTOAMeas_choice_extension._cont = ASN1Dict([
        ('id', __ULRTOAMeas_choice_extension_id),
        ('criticality', __ULRTOAMeas_choice_extension_criticality),
        ('value', __ULRTOAMeas_choice_extension_value),
        ])
    _ULRTOAMeas_choice_extension._ext = None
    ULRTOAMeas._cont = ASN1Dict([
        ('k0', _ULRTOAMeas_k0),
        ('k1', _ULRTOAMeas_k1),
        ('k2', _ULRTOAMeas_k2),
        ('k3', _ULRTOAMeas_k3),
        ('k4', _ULRTOAMeas_k4),
        ('k5', _ULRTOAMeas_k5),
        ('choice-extension', _ULRTOAMeas_choice_extension),
        ])
    ULRTOAMeas._ext = None
    
    #-----< ULRTOAMeas-ExtIEs >-----#
    ULRTOAMeas_ExtIEs = CLASS(name='ULRTOAMeas-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ULRTOAMeas_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-SRS-RSRP >-----#
    UL_SRS_RSRP = INT(name='UL-SRS-RSRP', mode=MODE_TYPE)
    UL_SRS_RSRP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=126)], ev=None, er=[])
    
    #-----< UL-SRS-RSRPP >-----#
    UL_SRS_RSRPP = SEQ(name='UL-SRS-RSRPP', mode=MODE_TYPE)
    _UL_SRS_RSRPP_firstPathRSRPP = INT(name='firstPathRSRPP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UL_SRS_RSRPP_firstPathRSRPP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=126)], ev=None, er=[])
    _UL_SRS_RSRPP_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_SRS_RSRPP_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___UL_SRS_RSRPP_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____UL_SRS_RSRPP_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____UL_SRS_RSRPP_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_SRS_RSRPP_iE_extensions__item__id._const_tab = ____UL_SRS_RSRPP_iE_extensions__item__id_tab
    ___UL_SRS_RSRPP_iE_extensions__item__id._const_tab_at = None
    ___UL_SRS_RSRPP_iE_extensions__item__id._const_tab_id = 'id'
    ___UL_SRS_RSRPP_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_SRS_RSRPP_iE_extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____UL_SRS_RSRPP_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_SRS_RSRPP_iE_extensions__item__criticality._const_tab = ____UL_SRS_RSRPP_iE_extensions__item__criticality_tab
    ___UL_SRS_RSRPP_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_SRS_RSRPP_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_SRS_RSRPP_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_SRS_RSRPP_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____UL_SRS_RSRPP_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_SRS_RSRPP_iE_extensions__item__extensionValue._const_tab = ____UL_SRS_RSRPP_iE_extensions__item__extensionValue_tab
    ___UL_SRS_RSRPP_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_SRS_RSRPP_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_SRS_RSRPP_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___UL_SRS_RSRPP_iE_extensions__item__id),
        ('criticality', ___UL_SRS_RSRPP_iE_extensions__item__criticality),
        ('extensionValue', ___UL_SRS_RSRPP_iE_extensions__item__extensionValue),
        ])
    __UL_SRS_RSRPP_iE_extensions__item_._ext = None
    _UL_SRS_RSRPP_iE_extensions._cont = __UL_SRS_RSRPP_iE_extensions__item_
    _UL_SRS_RSRPP_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_SRS_RSRPP._cont = ASN1Dict([
        ('firstPathRSRPP', _UL_SRS_RSRPP_firstPathRSRPP),
        ('iE-extensions', _UL_SRS_RSRPP_iE_extensions),
        ])
    UL_SRS_RSRPP._ext = []
    
    #-----< UL-SRS-RSRPP-ExtIEs >-----#
    UL_SRS_RSRPP_ExtIEs = CLASS(name='UL-SRS-RSRPP-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    UL_SRS_RSRPP_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UplinkChannelBW-PerSCS-List >-----#
    UplinkChannelBW_PerSCS_List = SEQ_OF(name='UplinkChannelBW-PerSCS-List', mode=MODE_TYPE)
    _UplinkChannelBW_PerSCS_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SCS-SpecificCarrier')))
    UplinkChannelBW_PerSCS_List._cont = _UplinkChannelBW_PerSCS_List__item_
    UplinkChannelBW_PerSCS_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< Uncertainty-range-AoA >-----#
    Uncertainty_range_AoA = INT(name='Uncertainty-range-AoA', mode=MODE_TYPE)
    Uncertainty_range_AoA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599)], ev=None, er=[])
    
    #-----< Uncertainty-range-ZoA >-----#
    Uncertainty_range_ZoA = INT(name='Uncertainty-range-ZoA', mode=MODE_TYPE)
    Uncertainty_range_ZoA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1799)], ev=None, er=[])
    
    #-----< ValueRSRP-EUTRA >-----#
    ValueRSRP_EUTRA = INT(name='ValueRSRP-EUTRA', mode=MODE_TYPE)
    ValueRSRP_EUTRA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=97)], ev=[], er=[])
    
    #-----< ValueRSRQ-EUTRA >-----#
    ValueRSRQ_EUTRA = INT(name='ValueRSRQ-EUTRA', mode=MODE_TYPE)
    ValueRSRQ_EUTRA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=34)], ev=[], er=[])
    
    #-----< ValueRSRP-NR >-----#
    ValueRSRP_NR = INT(name='ValueRSRP-NR', mode=MODE_TYPE)
    ValueRSRP_NR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< ValueRSRQ-NR >-----#
    ValueRSRQ_NR = INT(name='ValueRSRQ-NR', mode=MODE_TYPE)
    ValueRSRQ_NR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< WLANMeasurementQuantities >-----#
    WLANMeasurementQuantities = SEQ_OF(name='WLANMeasurementQuantities', mode=MODE_TYPE)
    _WLANMeasurementQuantities__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __WLANMeasurementQuantities__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___WLANMeasurementQuantities__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ____WLANMeasurementQuantities__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'WLANMeasurementQuantities-Item')))
    ___WLANMeasurementQuantities__item__id_tab._val = ASN1Set(rv=[dict([('id', 20), ('criticality', 'reject'), ('Value', ____WLANMeasurementQuantities__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __WLANMeasurementQuantities__item__id._const_tab = ___WLANMeasurementQuantities__item__id_tab
    __WLANMeasurementQuantities__item__id._const_tab_at = None
    __WLANMeasurementQuantities__item__id._const_tab_id = 'id'
    __WLANMeasurementQuantities__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    __WLANMeasurementQuantities__item__criticality._const_tab = ___WLANMeasurementQuantities__item__id_tab
    __WLANMeasurementQuantities__item__criticality._const_tab_at = ('..', 'id')
    __WLANMeasurementQuantities__item__criticality._const_tab_id = 'criticality'
    __WLANMeasurementQuantities__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    __WLANMeasurementQuantities__item__value._const_tab = ___WLANMeasurementQuantities__item__id_tab
    __WLANMeasurementQuantities__item__value._const_tab_at = ('..', 'id')
    __WLANMeasurementQuantities__item__value._const_tab_id = 'Value'
    _WLANMeasurementQuantities__item_._cont = ASN1Dict([
        ('id', __WLANMeasurementQuantities__item__id),
        ('criticality', __WLANMeasurementQuantities__item__criticality),
        ('value', __WLANMeasurementQuantities__item__value),
        ])
    _WLANMeasurementQuantities__item_._ext = None
    WLANMeasurementQuantities._cont = _WLANMeasurementQuantities__item_
    WLANMeasurementQuantities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=64)], ev=None, er=[])
    
    #-----< WLANMeasurementQuantities-ItemIEs >-----#
    WLANMeasurementQuantities_ItemIEs = CLASS(name='WLANMeasurementQuantities-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _WLANMeasurementQuantities_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'WLANMeasurementQuantities-Item')))
    WLANMeasurementQuantities_ItemIEs._val = ASN1Set(rv=[dict([('id', 20), ('criticality', 'reject'), ('Value', _WLANMeasurementQuantities_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< WLANMeasurementQuantities-Item >-----#
    WLANMeasurementQuantities_Item = SEQ(name='WLANMeasurementQuantities-Item', mode=MODE_TYPE)
    _WLANMeasurementQuantities_Item_wLANMeasurementQuantitiesValue = ENUM(name='wLANMeasurementQuantitiesValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'WLANMeasurementQuantitiesValue')))
    _WLANMeasurementQuantities_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __WLANMeasurementQuantities_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___WLANMeasurementQuantities_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____WLANMeasurementQuantities_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____WLANMeasurementQuantities_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementQuantities_Item_iE_Extensions__item__id._const_tab = ____WLANMeasurementQuantities_Item_iE_Extensions__item__id_tab
    ___WLANMeasurementQuantities_Item_iE_Extensions__item__id._const_tab_at = None
    ___WLANMeasurementQuantities_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___WLANMeasurementQuantities_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____WLANMeasurementQuantities_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____WLANMeasurementQuantities_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab = ____WLANMeasurementQuantities_Item_iE_Extensions__item__criticality_tab
    ___WLANMeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___WLANMeasurementQuantities_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___WLANMeasurementQuantities_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____WLANMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____WLANMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab = ____WLANMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab
    ___WLANMeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___WLANMeasurementQuantities_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __WLANMeasurementQuantities_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___WLANMeasurementQuantities_Item_iE_Extensions__item__id),
        ('criticality', ___WLANMeasurementQuantities_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___WLANMeasurementQuantities_Item_iE_Extensions__item__extensionValue),
        ])
    __WLANMeasurementQuantities_Item_iE_Extensions__item_._ext = None
    _WLANMeasurementQuantities_Item_iE_Extensions._cont = __WLANMeasurementQuantities_Item_iE_Extensions__item_
    _WLANMeasurementQuantities_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    WLANMeasurementQuantities_Item._cont = ASN1Dict([
        ('wLANMeasurementQuantitiesValue', _WLANMeasurementQuantities_Item_wLANMeasurementQuantitiesValue),
        ('iE-Extensions', _WLANMeasurementQuantities_Item_iE_Extensions),
        ])
    WLANMeasurementQuantities_Item._ext = []
    
    #-----< WLANMeasurementQuantitiesValue-ExtIEs >-----#
    WLANMeasurementQuantitiesValue_ExtIEs = CLASS(name='WLANMeasurementQuantitiesValue-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    WLANMeasurementQuantitiesValue_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WLANMeasurementQuantitiesValue >-----#
    WLANMeasurementQuantitiesValue = ENUM(name='WLANMeasurementQuantitiesValue', mode=MODE_TYPE)
    WLANMeasurementQuantitiesValue._cont = ASN1Dict([('wlan', 0)])
    WLANMeasurementQuantitiesValue._ext = []
    
    #-----< WLANMeasurementResult >-----#
    WLANMeasurementResult = SEQ_OF(name='WLANMeasurementResult', mode=MODE_TYPE)
    _WLANMeasurementResult__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'WLANMeasurementResult-Item')))
    WLANMeasurementResult._cont = _WLANMeasurementResult__item_
    WLANMeasurementResult._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< WLANMeasurementResult-Item >-----#
    WLANMeasurementResult_Item = SEQ(name='WLANMeasurementResult-Item', mode=MODE_TYPE)
    _WLANMeasurementResult_Item_wLAN_RSSI = INT(name='wLAN-RSSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'WLAN-RSSI')))
    _WLANMeasurementResult_Item_sSID = OCT_STR(name='sSID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SSID')), opt=True)
    _WLANMeasurementResult_Item_bSSID = OCT_STR(name='bSSID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'BSSID')), opt=True)
    _WLANMeasurementResult_Item_hESSID = OCT_STR(name='hESSID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'HESSID')), opt=True)
    _WLANMeasurementResult_Item_operatingClass = INT(name='operatingClass', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'WLANOperatingClass')), opt=True)
    _WLANMeasurementResult_Item_countryCode = ENUM(name='countryCode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'WLANCountryCode')), opt=True)
    _WLANMeasurementResult_Item_wLANChannelList = SEQ_OF(name='wLANChannelList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'WLANChannelList')), opt=True)
    _WLANMeasurementResult_Item_wLANBand = ENUM(name='wLANBand', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'WLANBand')), opt=True)
    _WLANMeasurementResult_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __WLANMeasurementResult_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___WLANMeasurementResult_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____WLANMeasurementResult_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____WLANMeasurementResult_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementResult_Item_iE_Extensions__item__id._const_tab = ____WLANMeasurementResult_Item_iE_Extensions__item__id_tab
    ___WLANMeasurementResult_Item_iE_Extensions__item__id._const_tab_at = None
    ___WLANMeasurementResult_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___WLANMeasurementResult_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____WLANMeasurementResult_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____WLANMeasurementResult_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementResult_Item_iE_Extensions__item__criticality._const_tab = ____WLANMeasurementResult_Item_iE_Extensions__item__criticality_tab
    ___WLANMeasurementResult_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___WLANMeasurementResult_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___WLANMeasurementResult_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____WLANMeasurementResult_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____WLANMeasurementResult_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementResult_Item_iE_Extensions__item__extensionValue._const_tab = ____WLANMeasurementResult_Item_iE_Extensions__item__extensionValue_tab
    ___WLANMeasurementResult_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___WLANMeasurementResult_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __WLANMeasurementResult_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___WLANMeasurementResult_Item_iE_Extensions__item__id),
        ('criticality', ___WLANMeasurementResult_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___WLANMeasurementResult_Item_iE_Extensions__item__extensionValue),
        ])
    __WLANMeasurementResult_Item_iE_Extensions__item_._ext = None
    _WLANMeasurementResult_Item_iE_Extensions._cont = __WLANMeasurementResult_Item_iE_Extensions__item_
    _WLANMeasurementResult_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    WLANMeasurementResult_Item._cont = ASN1Dict([
        ('wLAN-RSSI', _WLANMeasurementResult_Item_wLAN_RSSI),
        ('sSID', _WLANMeasurementResult_Item_sSID),
        ('bSSID', _WLANMeasurementResult_Item_bSSID),
        ('hESSID', _WLANMeasurementResult_Item_hESSID),
        ('operatingClass', _WLANMeasurementResult_Item_operatingClass),
        ('countryCode', _WLANMeasurementResult_Item_countryCode),
        ('wLANChannelList', _WLANMeasurementResult_Item_wLANChannelList),
        ('wLANBand', _WLANMeasurementResult_Item_wLANBand),
        ('iE-Extensions', _WLANMeasurementResult_Item_iE_Extensions),
        ])
    WLANMeasurementResult_Item._ext = []
    
    #-----< WLANMeasurementResult-Item-ExtIEs >-----#
    WLANMeasurementResult_Item_ExtIEs = CLASS(name='WLANMeasurementResult-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    WLANMeasurementResult_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WLAN-RSSI >-----#
    WLAN_RSSI = INT(name='WLAN-RSSI', mode=MODE_TYPE)
    WLAN_RSSI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=141)], ev=[], er=[])
    
    #-----< WLANBand >-----#
    WLANBand = ENUM(name='WLANBand', mode=MODE_TYPE)
    WLANBand._cont = ASN1Dict([('band2dot4', 0), ('band5', 1)])
    WLANBand._ext = []
    
    #-----< WLANChannelList >-----#
    WLANChannelList = SEQ_OF(name='WLANChannelList', mode=MODE_TYPE)
    _WLANChannelList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'WLANChannel')))
    WLANChannelList._cont = _WLANChannelList__item_
    WLANChannelList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< WLANChannel >-----#
    WLANChannel = INT(name='WLANChannel', mode=MODE_TYPE)
    WLANChannel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< WLANCountryCode >-----#
    WLANCountryCode = ENUM(name='WLANCountryCode', mode=MODE_TYPE)
    WLANCountryCode._cont = ASN1Dict([('unitedStates', 0), ('europe', 1), ('japan', 2), ('global', 3)])
    WLANCountryCode._ext = []
    
    #-----< WLANOperatingClass >-----#
    WLANOperatingClass = INT(name='WLANOperatingClass', mode=MODE_TYPE)
    WLANOperatingClass._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ZoA >-----#
    ZoA = SEQ(name='ZoA', mode=MODE_TYPE)
    _ZoA_zenithAoA = INT(name='zenithAoA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ZoA_zenithAoA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1799)], ev=None, er=[])
    _ZoA_lCS_to_GCS_Translation = SEQ(name='lCS-to-GCS-Translation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'LCS-to-GCS-Translation')), opt=True)
    _ZoA_iE_extensions = SEQ_OF(name='iE-extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ZoA_iE_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___ZoA_iE_extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____ZoA_iE_extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ZoA_iE_extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ZoA_iE_extensions__item__id._const_tab = ____ZoA_iE_extensions__item__id_tab
    ___ZoA_iE_extensions__item__id._const_tab_at = None
    ___ZoA_iE_extensions__item__id._const_tab_id = 'id'
    ___ZoA_iE_extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____ZoA_iE_extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ZoA_iE_extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ZoA_iE_extensions__item__criticality._const_tab = ____ZoA_iE_extensions__item__criticality_tab
    ___ZoA_iE_extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ZoA_iE_extensions__item__criticality._const_tab_id = 'criticality'
    ___ZoA_iE_extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____ZoA_iE_extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____ZoA_iE_extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ZoA_iE_extensions__item__extensionValue._const_tab = ____ZoA_iE_extensions__item__extensionValue_tab
    ___ZoA_iE_extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ZoA_iE_extensions__item__extensionValue._const_tab_id = 'Extension'
    __ZoA_iE_extensions__item_._cont = ASN1Dict([
        ('id', ___ZoA_iE_extensions__item__id),
        ('criticality', ___ZoA_iE_extensions__item__criticality),
        ('extensionValue', ___ZoA_iE_extensions__item__extensionValue),
        ])
    __ZoA_iE_extensions__item_._ext = None
    _ZoA_iE_extensions._cont = __ZoA_iE_extensions__item_
    _ZoA_iE_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ZoA._cont = ASN1Dict([
        ('zenithAoA', _ZoA_zenithAoA),
        ('lCS-to-GCS-Translation', _ZoA_lCS_to_GCS_Translation),
        ('iE-extensions', _ZoA_iE_extensions),
        ])
    ZoA._ext = []
    
    #-----< ZoA-ExtIEs >-----#
    ZoA_ExtIEs = CLASS(name='ZoA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ZoA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    _all_ = [
        _AbortTransmission_deactivateSRSResourceSetID,
        _AbortTransmission_releaseALL,
        ___AbortTransmission_choice_extension_id_tab,
        __AbortTransmission_choice_extension_id,
        ___AbortTransmission_choice_extension_criticality_tab,
        __AbortTransmission_choice_extension_criticality,
        ___AbortTransmission_choice_extension_value_tab,
        __AbortTransmission_choice_extension_value,
        _AbortTransmission_choice_extension,
        AbortTransmission,
        AbortTransmission_ExtIEs,
        _ActiveULBWP_locationAndBandwidth,
        _ActiveULBWP_subcarrierSpacing,
        _ActiveULBWP_cyclicPrefix,
        _ActiveULBWP_txDirectCurrentLocation,
        _ActiveULBWP_shift7dot5kHz,
        _ActiveULBWP_sRSConfig,
        ____ActiveULBWP_iE_Extensions__item__id_tab,
        ___ActiveULBWP_iE_Extensions__item__id,
        ____ActiveULBWP_iE_Extensions__item__criticality_tab,
        ___ActiveULBWP_iE_Extensions__item__criticality,
        ____ActiveULBWP_iE_Extensions__item__extensionValue_tab,
        ___ActiveULBWP_iE_Extensions__item__extensionValue,
        __ActiveULBWP_iE_Extensions__item_,
        _ActiveULBWP_iE_Extensions,
        ActiveULBWP,
        ActiveULBWP_ExtIEs,
        _AdditionalPathList__item_,
        AdditionalPathList,
        _AdditionalPathListItem_relativeTimeOfPath,
        _AdditionalPathListItem_pathQuality,
        ____AdditionalPathListItem_iE_Extensions__item__id_tab,
        _____AdditionalPathListItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____AdditionalPathListItem_iE_Extensions__item__id_tab_val_Extension_1,
        ___AdditionalPathListItem_iE_Extensions__item__id,
        ___AdditionalPathListItem_iE_Extensions__item__criticality,
        ___AdditionalPathListItem_iE_Extensions__item__extensionValue,
        __AdditionalPathListItem_iE_Extensions__item_,
        _AdditionalPathListItem_iE_Extensions,
        AdditionalPathListItem,
        AdditionalPathListItem_ExtIEs,
        _AdditionalPathListItem_ExtIEs_val_Extension_0,
        _AdditionalPathListItem_ExtIEs_val_Extension_1,
        _ExtendedAdditionalPathList__item_,
        ExtendedAdditionalPathList,
        _ExtendedAdditionalPathList_Item_relativeTimeOfPath,
        _ExtendedAdditionalPathList_Item_pathQuality,
        _ExtendedAdditionalPathList_Item_multipleULAoA,
        _ExtendedAdditionalPathList_Item_pathPower,
        ____ExtendedAdditionalPathList_Item_iE_Extensions__item__id_tab,
        ___ExtendedAdditionalPathList_Item_iE_Extensions__item__id,
        ____ExtendedAdditionalPathList_Item_iE_Extensions__item__criticality_tab,
        ___ExtendedAdditionalPathList_Item_iE_Extensions__item__criticality,
        ____ExtendedAdditionalPathList_Item_iE_Extensions__item__extensionValue_tab,
        ___ExtendedAdditionalPathList_Item_iE_Extensions__item__extensionValue,
        __ExtendedAdditionalPathList_Item_iE_Extensions__item_,
        _ExtendedAdditionalPathList_Item_iE_Extensions,
        ExtendedAdditionalPathList_Item,
        ExtendedAdditionalPathList_Item_ExtIEs,
        _AoA_AssistanceInfo_angleMeasurement,
        _AoA_AssistanceInfo_lCS_to_GCS_Translation,
        ____AoA_AssistanceInfo_iE_Extensions__item__id_tab,
        ___AoA_AssistanceInfo_iE_Extensions__item__id,
        ____AoA_AssistanceInfo_iE_Extensions__item__criticality_tab,
        ___AoA_AssistanceInfo_iE_Extensions__item__criticality,
        ____AoA_AssistanceInfo_iE_Extensions__item__extensionValue_tab,
        ___AoA_AssistanceInfo_iE_Extensions__item__extensionValue,
        __AoA_AssistanceInfo_iE_Extensions__item_,
        _AoA_AssistanceInfo_iE_Extensions,
        AoA_AssistanceInfo,
        AoA_AssistanceInfo_ExtIEs,
        _AperiodicSRSResourceTriggerList__item_,
        AperiodicSRSResourceTriggerList,
        AperiodicSRSResourceTrigger,
        _AngleMeasurementType_expected_ULAoA,
        _AngleMeasurementType_expected_ZoA,
        ___AngleMeasurementType_choice_extension_id_tab,
        __AngleMeasurementType_choice_extension_id,
        ___AngleMeasurementType_choice_extension_criticality_tab,
        __AngleMeasurementType_choice_extension_criticality,
        ___AngleMeasurementType_choice_extension_value_tab,
        __AngleMeasurementType_choice_extension_value,
        _AngleMeasurementType_choice_extension,
        AngleMeasurementType,
        AngleMeasurementType_ExtIEs,
        _Expected_UL_AoA_expected_Azimuth_AoA,
        _Expected_UL_AoA_expected_Zenith_AoA,
        ____Expected_UL_AoA_iE_extensions__item__id_tab,
        ___Expected_UL_AoA_iE_extensions__item__id,
        ____Expected_UL_AoA_iE_extensions__item__criticality_tab,
        ___Expected_UL_AoA_iE_extensions__item__criticality,
        ____Expected_UL_AoA_iE_extensions__item__extensionValue_tab,
        ___Expected_UL_AoA_iE_extensions__item__extensionValue,
        __Expected_UL_AoA_iE_extensions__item_,
        _Expected_UL_AoA_iE_extensions,
        Expected_UL_AoA,
        Expected_UL_AoA_ExtIEs,
        _Expected_ZoA_only_expected_ZoA_only,
        ____Expected_ZoA_only_iE_extensions__item__id_tab,
        ___Expected_ZoA_only_iE_extensions__item__id,
        ____Expected_ZoA_only_iE_extensions__item__criticality_tab,
        ___Expected_ZoA_only_iE_extensions__item__criticality,
        ____Expected_ZoA_only_iE_extensions__item__extensionValue_tab,
        ___Expected_ZoA_only_iE_extensions__item__extensionValue,
        __Expected_ZoA_only_iE_extensions__item_,
        _Expected_ZoA_only_iE_extensions,
        Expected_ZoA_only,
        Expected_ZoA_only_ExtIEs,
        _Expected_Azimuth_AoA_expected_Azimuth_AoA_value,
        _Expected_Azimuth_AoA_expected_Azimuth_AoA_uncertainty,
        ____Expected_Azimuth_AoA_iE_extensions__item__id_tab,
        ___Expected_Azimuth_AoA_iE_extensions__item__id,
        ____Expected_Azimuth_AoA_iE_extensions__item__criticality_tab,
        ___Expected_Azimuth_AoA_iE_extensions__item__criticality,
        ____Expected_Azimuth_AoA_iE_extensions__item__extensionValue_tab,
        ___Expected_Azimuth_AoA_iE_extensions__item__extensionValue,
        __Expected_Azimuth_AoA_iE_extensions__item_,
        _Expected_Azimuth_AoA_iE_extensions,
        Expected_Azimuth_AoA,
        Expected_Azimuth_AoA_ExtIEs,
        _Expected_Zenith_AoA_expected_Zenith_AoA_value,
        _Expected_Zenith_AoA_expected_Zenith_AoA_uncertainty,
        ____Expected_Zenith_AoA_iE_extensions__item__id_tab,
        ___Expected_Zenith_AoA_iE_extensions__item__id,
        ____Expected_Zenith_AoA_iE_extensions__item__criticality_tab,
        ___Expected_Zenith_AoA_iE_extensions__item__criticality,
        ____Expected_Zenith_AoA_iE_extensions__item__extensionValue_tab,
        ___Expected_Zenith_AoA_iE_extensions__item__extensionValue,
        __Expected_Zenith_AoA_iE_extensions__item_,
        _Expected_Zenith_AoA_iE_extensions,
        Expected_Zenith_AoA,
        Expected_Zenith_AoA_ExtIEs,
        ARP_ID,
        _ARPLocationInformation__item_,
        ARPLocationInformation,
        _ARPLocationInformation_Item_aRP_ID,
        _ARPLocationInformation_Item_aRPLocationType,
        ____ARPLocationInformation_Item_iE_Extensions__item__id_tab,
        ___ARPLocationInformation_Item_iE_Extensions__item__id,
        ____ARPLocationInformation_Item_iE_Extensions__item__criticality_tab,
        ___ARPLocationInformation_Item_iE_Extensions__item__criticality,
        ____ARPLocationInformation_Item_iE_Extensions__item__extensionValue_tab,
        ___ARPLocationInformation_Item_iE_Extensions__item__extensionValue,
        __ARPLocationInformation_Item_iE_Extensions__item_,
        _ARPLocationInformation_Item_iE_Extensions,
        ARPLocationInformation_Item,
        ARPLocationInformation_ExtIEs,
        _ARPLocationType_aRPPositionRelativeGeodetic,
        _ARPLocationType_aRPPositionRelativeCartesian,
        ___ARPLocationType_choice_extension_id_tab,
        __ARPLocationType_choice_extension_id,
        ___ARPLocationType_choice_extension_criticality_tab,
        __ARPLocationType_choice_extension_criticality,
        ___ARPLocationType_choice_extension_value_tab,
        __ARPLocationType_choice_extension_value,
        _ARPLocationType_choice_extension,
        ARPLocationType,
        ARPLocationType_ExtIEs,
        _Assistance_Information_systemInformation,
        ____Assistance_Information_iE_Extensions__item__id_tab,
        ___Assistance_Information_iE_Extensions__item__id,
        ____Assistance_Information_iE_Extensions__item__criticality_tab,
        ___Assistance_Information_iE_Extensions__item__criticality,
        ____Assistance_Information_iE_Extensions__item__extensionValue_tab,
        ___Assistance_Information_iE_Extensions__item__extensionValue,
        __Assistance_Information_iE_Extensions__item_,
        _Assistance_Information_iE_Extensions,
        Assistance_Information,
        Assistance_Information_ExtIEs,
        __AssistanceInformationFailureList__item__posSIB_Type,
        __AssistanceInformationFailureList__item__outcome,
        _____AssistanceInformationFailureList__item__iE_Extensions__item__id_tab,
        ____AssistanceInformationFailureList__item__iE_Extensions__item__id,
        _____AssistanceInformationFailureList__item__iE_Extensions__item__criticality_tab,
        ____AssistanceInformationFailureList__item__iE_Extensions__item__criticality,
        _____AssistanceInformationFailureList__item__iE_Extensions__item__extensionValue_tab,
        ____AssistanceInformationFailureList__item__iE_Extensions__item__extensionValue,
        ___AssistanceInformationFailureList__item__iE_Extensions__item_,
        __AssistanceInformationFailureList__item__iE_Extensions,
        _AssistanceInformationFailureList__item_,
        AssistanceInformationFailureList,
        AssistanceInformationFailureList_ExtIEs,
        _AssistanceInformationMetaData_encrypted,
        _AssistanceInformationMetaData_gNSSID,
        _AssistanceInformationMetaData_sBASID,
        ____AssistanceInformationMetaData_iE_Extensions__item__id_tab,
        ___AssistanceInformationMetaData_iE_Extensions__item__id,
        ____AssistanceInformationMetaData_iE_Extensions__item__criticality_tab,
        ___AssistanceInformationMetaData_iE_Extensions__item__criticality,
        ____AssistanceInformationMetaData_iE_Extensions__item__extensionValue_tab,
        ___AssistanceInformationMetaData_iE_Extensions__item__extensionValue,
        __AssistanceInformationMetaData_iE_Extensions__item_,
        _AssistanceInformationMetaData_iE_Extensions,
        AssistanceInformationMetaData,
        AssistanceInformationMetaData_ExtIEs,
        _BandwidthSRS_fR1,
        _BandwidthSRS_fR2,
        ___BandwidthSRS_choice_extension_id_tab,
        __BandwidthSRS_choice_extension_id,
        ___BandwidthSRS_choice_extension_criticality_tab,
        __BandwidthSRS_choice_extension_criticality,
        ___BandwidthSRS_choice_extension_value_tab,
        __BandwidthSRS_choice_extension_value,
        _BandwidthSRS_choice_extension,
        BandwidthSRS,
        BandwidthSRS_ExtIEs,
        BCCH,
        Broadcast,
        BroadcastPeriodicity,
        _PositioningBroadcastCells__item_,
        PositioningBroadcastCells,
        BSSID,
        _CarrierFreq_pointA,
        _CarrierFreq_offsetToCarrier,
        ____CarrierFreq_iE_Extensions__item__id_tab,
        ___CarrierFreq_iE_Extensions__item__id,
        ____CarrierFreq_iE_Extensions__item__criticality_tab,
        ___CarrierFreq_iE_Extensions__item__criticality,
        ____CarrierFreq_iE_Extensions__item__extensionValue_tab,
        ___CarrierFreq_iE_Extensions__item__extensionValue,
        __CarrierFreq_iE_Extensions__item_,
        _CarrierFreq_iE_Extensions,
        CarrierFreq,
        CarrierFreq_ExtIEs,
        _Cause_radioNetwork,
        _Cause_protocol,
        _Cause_misc,
        ___Cause_choice_Extension_id_tab,
        __Cause_choice_Extension_id,
        ___Cause_choice_Extension_criticality_tab,
        __Cause_choice_Extension_criticality,
        ___Cause_choice_Extension_value_tab,
        __Cause_choice_Extension_value,
        _Cause_choice_Extension,
        Cause,
        Cause_ExtensionIE,
        CauseMisc,
        CauseProtocol,
        CauseRadioNetwork,
        Cell_Portion_ID,
        _CGI_EUTRA_pLMN_Identity,
        _CGI_EUTRA_eUTRAcellIdentifier,
        ____CGI_EUTRA_iE_Extensions__item__id_tab,
        ___CGI_EUTRA_iE_Extensions__item__id,
        ____CGI_EUTRA_iE_Extensions__item__criticality_tab,
        ___CGI_EUTRA_iE_Extensions__item__criticality,
        ____CGI_EUTRA_iE_Extensions__item__extensionValue_tab,
        ___CGI_EUTRA_iE_Extensions__item__extensionValue,
        __CGI_EUTRA_iE_Extensions__item_,
        _CGI_EUTRA_iE_Extensions,
        CGI_EUTRA,
        CGI_EUTRA_ExtIEs,
        _CGI_NR_pLMN_Identity,
        _CGI_NR_nRcellIdentifier,
        ____CGI_NR_iE_Extensions__item__id_tab,
        ___CGI_NR_iE_Extensions__item__id,
        ____CGI_NR_iE_Extensions__item__criticality_tab,
        ___CGI_NR_iE_Extensions__item__criticality,
        ____CGI_NR_iE_Extensions__item__extensionValue_tab,
        ___CGI_NR_iE_Extensions__item__extensionValue,
        __CGI_NR_iE_Extensions__item_,
        _CGI_NR_iE_Extensions,
        CGI_NR,
        CGI_NR_ExtIEs,
        CPLength_EUTRA,
        _CriticalityDiagnostics_procedureCode,
        _CriticalityDiagnostics_triggeringMessage,
        _CriticalityDiagnostics_procedureCriticality,
        _CriticalityDiagnostics_nrppatransactionID,
        _CriticalityDiagnostics_iEsCriticalityDiagnostics,
        ____CriticalityDiagnostics_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__id,
        ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_iE_Extensions__item_,
        _CriticalityDiagnostics_iE_Extensions,
        CriticalityDiagnostics,
        CriticalityDiagnostics_ExtIEs,
        __CriticalityDiagnostics_IE_List__item__iECriticality,
        __CriticalityDiagnostics_IE_List__item__iE_ID,
        __CriticalityDiagnostics_IE_List__item__typeOfError,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue,
        ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_,
        __CriticalityDiagnostics_IE_List__item__iE_Extensions,
        _CriticalityDiagnostics_IE_List__item_,
        CriticalityDiagnostics_IE_List,
        CriticalityDiagnostics_IE_List_ExtIEs,
        DL_Bandwidth_EUTRA,
        _DL_PRS_prsid,
        _DL_PRS_dl_PRSResourceSetID,
        _DL_PRS_dl_PRSResourceID,
        ____DL_PRS_iE_Extensions__item__id_tab,
        ___DL_PRS_iE_Extensions__item__id,
        ____DL_PRS_iE_Extensions__item__criticality_tab,
        ___DL_PRS_iE_Extensions__item__criticality,
        ____DL_PRS_iE_Extensions__item__extensionValue_tab,
        ___DL_PRS_iE_Extensions__item__extensionValue,
        __DL_PRS_iE_Extensions__item_,
        _DL_PRS_iE_Extensions,
        DL_PRS,
        DL_PRS_ExtIEs,
        _DL_PRSMutingPattern_two,
        _DL_PRSMutingPattern_four,
        _DL_PRSMutingPattern_six,
        _DL_PRSMutingPattern_eight,
        _DL_PRSMutingPattern_sixteen,
        _DL_PRSMutingPattern_thirty_two,
        ___DL_PRSMutingPattern_choice_extension_id_tab,
        __DL_PRSMutingPattern_choice_extension_id,
        ___DL_PRSMutingPattern_choice_extension_criticality_tab,
        __DL_PRSMutingPattern_choice_extension_criticality,
        ___DL_PRSMutingPattern_choice_extension_value_tab,
        __DL_PRSMutingPattern_choice_extension_value,
        _DL_PRSMutingPattern_choice_extension,
        DL_PRSMutingPattern,
        DL_PRSMutingPattern_ExtIEs,
        __DLPRSResourceCoordinates_listofDL_PRSResourceSetARP__item_,
        _DLPRSResourceCoordinates_listofDL_PRSResourceSetARP,
        ____DLPRSResourceCoordinates_iE_Extensions__item__id_tab,
        ___DLPRSResourceCoordinates_iE_Extensions__item__id,
        ____DLPRSResourceCoordinates_iE_Extensions__item__criticality_tab,
        ___DLPRSResourceCoordinates_iE_Extensions__item__criticality,
        ____DLPRSResourceCoordinates_iE_Extensions__item__extensionValue_tab,
        ___DLPRSResourceCoordinates_iE_Extensions__item__extensionValue,
        __DLPRSResourceCoordinates_iE_Extensions__item_,
        _DLPRSResourceCoordinates_iE_Extensions,
        DLPRSResourceCoordinates,
        DLPRSResourceCoordinates_ExtIEs,
        _DLPRSResourceSetARP_dl_PRSResourceSetID,
        _DLPRSResourceSetARP_dL_PRSResourceSetARPLocation,
        __DLPRSResourceSetARP_listofDL_PRSResourceARP__item_,
        _DLPRSResourceSetARP_listofDL_PRSResourceARP,
        ____DLPRSResourceSetARP_iE_Extensions__item__id_tab,
        ___DLPRSResourceSetARP_iE_Extensions__item__id,
        ____DLPRSResourceSetARP_iE_Extensions__item__criticality_tab,
        ___DLPRSResourceSetARP_iE_Extensions__item__criticality,
        ____DLPRSResourceSetARP_iE_Extensions__item__extensionValue_tab,
        ___DLPRSResourceSetARP_iE_Extensions__item__extensionValue,
        __DLPRSResourceSetARP_iE_Extensions__item_,
        _DLPRSResourceSetARP_iE_Extensions,
        DLPRSResourceSetARP,
        DLPRSResourceSetARP_ExtIEs,
        _DL_PRSResourceSetARPLocation_relativeGeodeticLocation,
        _DL_PRSResourceSetARPLocation_relativeCartesianLocation,
        ___DL_PRSResourceSetARPLocation_choice_Extension_id_tab,
        __DL_PRSResourceSetARPLocation_choice_Extension_id,
        ___DL_PRSResourceSetARPLocation_choice_Extension_criticality_tab,
        __DL_PRSResourceSetARPLocation_choice_Extension_criticality,
        ___DL_PRSResourceSetARPLocation_choice_Extension_value_tab,
        __DL_PRSResourceSetARPLocation_choice_Extension_value,
        _DL_PRSResourceSetARPLocation_choice_Extension,
        DL_PRSResourceSetARPLocation,
        DL_PRSResourceSetARPLocation_ExtIEs,
        _DLPRSResourceARP_dl_PRSResourceID,
        _DLPRSResourceARP_dL_PRSResourceARPLocation,
        ____DLPRSResourceARP_iE_Extensions__item__id_tab,
        ___DLPRSResourceARP_iE_Extensions__item__id,
        ____DLPRSResourceARP_iE_Extensions__item__criticality_tab,
        ___DLPRSResourceARP_iE_Extensions__item__criticality,
        ____DLPRSResourceARP_iE_Extensions__item__extensionValue_tab,
        ___DLPRSResourceARP_iE_Extensions__item__extensionValue,
        __DLPRSResourceARP_iE_Extensions__item_,
        _DLPRSResourceARP_iE_Extensions,
        DLPRSResourceARP,
        DLPRSResourceARP_ExtIEs,
        _DL_PRSResourceARPLocation_relativeGeodeticLocation,
        _DL_PRSResourceARPLocation_relativeCartesianLocation,
        ___DL_PRSResourceARPLocation_choice_Extension_id_tab,
        __DL_PRSResourceARPLocation_choice_Extension_id,
        ___DL_PRSResourceARPLocation_choice_Extension_criticality_tab,
        __DL_PRSResourceARPLocation_choice_Extension_criticality,
        ___DL_PRSResourceARPLocation_choice_Extension_value_tab,
        __DL_PRSResourceARPLocation_choice_Extension_value,
        _DL_PRSResourceARPLocation_choice_Extension,
        DL_PRSResourceARPLocation,
        DL_PRSResourceARPLocation_ExtIEs,
        _E_CID_MeasurementResult_servingCell_ID,
        _E_CID_MeasurementResult_servingCellTAC,
        _E_CID_MeasurementResult_nG_RANAccessPointPosition,
        _E_CID_MeasurementResult_measuredResults,
        ____E_CID_MeasurementResult_iE_Extensions__item__id_tab,
        _____E_CID_MeasurementResult_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_CID_MeasurementResult_iE_Extensions__item__id,
        ___E_CID_MeasurementResult_iE_Extensions__item__criticality,
        ___E_CID_MeasurementResult_iE_Extensions__item__extensionValue,
        __E_CID_MeasurementResult_iE_Extensions__item_,
        _E_CID_MeasurementResult_iE_Extensions,
        E_CID_MeasurementResult,
        E_CID_MeasurementResult_ExtIEs,
        _E_CID_MeasurementResult_ExtIEs_val_Extension_0,
        EUTRACellIdentifier,
        EARFCN,
        Expected_Value_AoA,
        Expected_Value_ZoA,
        _GeographicalCoordinates_tRPPositionDefinitionType,
        _GeographicalCoordinates_dLPRSResourceCoordinates,
        ____GeographicalCoordinates_iE_Extensions__item__id_tab,
        _____GeographicalCoordinates_iE_Extensions__item__id_tab_val_Extension_0,
        ___GeographicalCoordinates_iE_Extensions__item__id,
        ___GeographicalCoordinates_iE_Extensions__item__criticality,
        ___GeographicalCoordinates_iE_Extensions__item__extensionValue,
        __GeographicalCoordinates_iE_Extensions__item_,
        _GeographicalCoordinates_iE_Extensions,
        GeographicalCoordinates,
        GeographicalCoordinates_ExtIEs,
        _GeographicalCoordinates_ExtIEs_val_Extension_0,
        _GNB_RxTxTimeDiff_rxTxTimeDiff,
        _GNB_RxTxTimeDiff_additionalPathList,
        ____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab,
        _____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab_val_Extension_0,
        _____GNB_RxTxTimeDiff_iE_Extensions__item__id_tab_val_Extension_1,
        ___GNB_RxTxTimeDiff_iE_Extensions__item__id,
        ___GNB_RxTxTimeDiff_iE_Extensions__item__criticality,
        ___GNB_RxTxTimeDiff_iE_Extensions__item__extensionValue,
        __GNB_RxTxTimeDiff_iE_Extensions__item_,
        _GNB_RxTxTimeDiff_iE_Extensions,
        GNB_RxTxTimeDiff,
        GNB_RxTxTimeDiff_ExtIEs,
        _GNB_RxTxTimeDiff_ExtIEs_val_Extension_0,
        _GNB_RxTxTimeDiff_ExtIEs_val_Extension_1,
        _GNBRxTxTimeDiffMeas_k0,
        _GNBRxTxTimeDiffMeas_k1,
        _GNBRxTxTimeDiffMeas_k2,
        _GNBRxTxTimeDiffMeas_k3,
        _GNBRxTxTimeDiffMeas_k4,
        _GNBRxTxTimeDiffMeas_k5,
        ___GNBRxTxTimeDiffMeas_choice_extension_id_tab,
        __GNBRxTxTimeDiffMeas_choice_extension_id,
        ___GNBRxTxTimeDiffMeas_choice_extension_criticality_tab,
        __GNBRxTxTimeDiffMeas_choice_extension_criticality,
        ___GNBRxTxTimeDiffMeas_choice_extension_value_tab,
        __GNBRxTxTimeDiffMeas_choice_extension_value,
        _GNBRxTxTimeDiffMeas_choice_extension,
        GNBRxTxTimeDiffMeas,
        GNBRxTxTimeDiffMeas_ExtIEs,
        HESSID,
        _LCS_to_GCS_Translation_alpha,
        _LCS_to_GCS_Translation_beta,
        _LCS_to_GCS_Translation_gamma,
        ____LCS_to_GCS_Translation_iE_Extensions__item__id_tab,
        ___LCS_to_GCS_Translation_iE_Extensions__item__id,
        ____LCS_to_GCS_Translation_iE_Extensions__item__criticality_tab,
        ___LCS_to_GCS_Translation_iE_Extensions__item__criticality,
        ____LCS_to_GCS_Translation_iE_Extensions__item__extensionValue_tab,
        ___LCS_to_GCS_Translation_iE_Extensions__item__extensionValue,
        __LCS_to_GCS_Translation_iE_Extensions__item_,
        _LCS_to_GCS_Translation_iE_Extensions,
        LCS_to_GCS_Translation,
        LCS_to_GCS_Translation_ExtIEs,
        _LCS_to_GCS_TranslationItem_alpha,
        _LCS_to_GCS_TranslationItem_alphaFine,
        _LCS_to_GCS_TranslationItem_beta,
        _LCS_to_GCS_TranslationItem_betaFine,
        _LCS_to_GCS_TranslationItem_gamma,
        _LCS_to_GCS_TranslationItem_gammaFine,
        ____LCS_to_GCS_TranslationItem_iE_Extensions__item__id_tab,
        ___LCS_to_GCS_TranslationItem_iE_Extensions__item__id,
        ____LCS_to_GCS_TranslationItem_iE_Extensions__item__criticality_tab,
        ___LCS_to_GCS_TranslationItem_iE_Extensions__item__criticality,
        ____LCS_to_GCS_TranslationItem_iE_Extensions__item__extensionValue_tab,
        ___LCS_to_GCS_TranslationItem_iE_Extensions__item__extensionValue,
        __LCS_to_GCS_TranslationItem_iE_Extensions__item_,
        _LCS_to_GCS_TranslationItem_iE_Extensions,
        LCS_to_GCS_TranslationItem,
        LCS_to_GCS_TranslationItem_ExtIEs,
        _LocationUncertainty_horizontalUncertainty,
        _LocationUncertainty_horizontalConfidence,
        _LocationUncertainty_verticalUncertainty,
        _LocationUncertainty_verticalConfidence,
        ____LocationUncertainty_iE_Extensions__item__id_tab,
        ___LocationUncertainty_iE_Extensions__item__id,
        ____LocationUncertainty_iE_Extensions__item__criticality_tab,
        ___LocationUncertainty_iE_Extensions__item__criticality,
        ____LocationUncertainty_iE_Extensions__item__extensionValue_tab,
        ___LocationUncertainty_iE_Extensions__item__extensionValue,
        __LocationUncertainty_iE_Extensions__item_,
        _LocationUncertainty_iE_Extensions,
        LocationUncertainty,
        LocationUncertainty_ExtIEs,
        LoS_NLoSIndicatorHard,
        LoS_NLoSIndicatorSoft,
        _LoS_NLoSInformation_loS_NLoSIndicatorSoft,
        _LoS_NLoSInformation_loS_NLoSIndicatorHard,
        ___LoS_NLoSInformation_choice_Extension_id_tab,
        __LoS_NLoSInformation_choice_Extension_id,
        ___LoS_NLoSInformation_choice_Extension_criticality_tab,
        __LoS_NLoSInformation_choice_Extension_criticality,
        ___LoS_NLoSInformation_choice_Extension_value_tab,
        __LoS_NLoSInformation_choice_Extension_value,
        _LoS_NLoSInformation_choice_Extension,
        LoS_NLoSInformation,
        LoS_NLoSInformation_ExtIEs,
        Measurement_ID,
        MeasurementAmount,
        MeasurementBeamInfoRequest,
        _MeasurementBeamInfo_pRS_Resource_ID,
        _MeasurementBeamInfo_pRS_Resource_Set_ID,
        _MeasurementBeamInfo_sSB_Index,
        ____MeasurementBeamInfo_iE_Extensions__item__id_tab,
        ___MeasurementBeamInfo_iE_Extensions__item__id,
        ____MeasurementBeamInfo_iE_Extensions__item__criticality_tab,
        ___MeasurementBeamInfo_iE_Extensions__item__criticality,
        ____MeasurementBeamInfo_iE_Extensions__item__extensionValue_tab,
        ___MeasurementBeamInfo_iE_Extensions__item__extensionValue,
        __MeasurementBeamInfo_iE_Extensions__item_,
        _MeasurementBeamInfo_iE_Extensions,
        MeasurementBeamInfo,
        MeasurementBeamInfo_ExtIEs,
        MeasurementPeriodicity,
        MeasurementPeriodicityExtended,
        MeasurementPeriodicityNR_AoA,
        ___MeasurementQuantities__item__id_tab,
        ____MeasurementQuantities__item__id_tab_val_Value_0,
        __MeasurementQuantities__item__id,
        __MeasurementQuantities__item__criticality,
        __MeasurementQuantities__item__value,
        _MeasurementQuantities__item_,
        MeasurementQuantities,
        MeasurementQuantities_ItemIEs,
        _MeasurementQuantities_ItemIEs_val_Value_0,
        _MeasurementQuantities_Item_measurementQuantitiesValue,
        ____MeasurementQuantities_Item_iE_Extensions__item__id_tab,
        ___MeasurementQuantities_Item_iE_Extensions__item__id,
        ____MeasurementQuantities_Item_iE_Extensions__item__criticality_tab,
        ___MeasurementQuantities_Item_iE_Extensions__item__criticality,
        ____MeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab,
        ___MeasurementQuantities_Item_iE_Extensions__item__extensionValue,
        __MeasurementQuantities_Item_iE_Extensions__item_,
        _MeasurementQuantities_Item_iE_Extensions,
        MeasurementQuantities_Item,
        MeasurementQuantitiesValue_ExtIEs,
        MeasurementQuantitiesValue,
        MeasurementTimeOccasion,
        MeasurementCharacteristicsRequestIndicator,
        _MeasuredResults__item_,
        MeasuredResults,
        _MeasuredResultsValue_valueAngleOfArrival_EUTRA,
        _MeasuredResultsValue_valueTimingAdvanceType1_EUTRA,
        _MeasuredResultsValue_valueTimingAdvanceType2_EUTRA,
        _MeasuredResultsValue_resultRSRP_EUTRA,
        _MeasuredResultsValue_resultRSRQ_EUTRA,
        ___MeasuredResultsValue_choice_Extension_id_tab,
        ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_0,
        ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_1,
        ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_2,
        ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_3,
        ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_4,
        ____MeasuredResultsValue_choice_Extension_id_tab_val_Value_5,
        __MeasuredResultsValue_choice_Extension_id,
        __MeasuredResultsValue_choice_Extension_criticality,
        __MeasuredResultsValue_choice_Extension_value,
        _MeasuredResultsValue_choice_Extension,
        MeasuredResultsValue,
        MeasuredResultsValue_ExtensionIE,
        _MeasuredResultsValue_ExtensionIE_val_Value_0,
        _MeasuredResultsValue_ExtensionIE_val_Value_1,
        _MeasuredResultsValue_ExtensionIE_val_Value_2,
        _MeasuredResultsValue_ExtensionIE_val_Value_3,
        _MeasuredResultsValue_ExtensionIE_val_Value_4,
        _MeasuredResultsValue_ExtensionIE_val_Value_5,
        _MultipleULAoA_multipleULAoA,
        ____MultipleULAoA_iE_Extensions__item__id_tab,
        ___MultipleULAoA_iE_Extensions__item__id,
        ____MultipleULAoA_iE_Extensions__item__criticality_tab,
        ___MultipleULAoA_iE_Extensions__item__criticality,
        ____MultipleULAoA_iE_Extensions__item__extensionValue_tab,
        ___MultipleULAoA_iE_Extensions__item__extensionValue,
        __MultipleULAoA_iE_Extensions__item_,
        _MultipleULAoA_iE_Extensions,
        MultipleULAoA,
        MultipleULAoA_ExtIEs,
        _MultipleULAoA_List__item_,
        MultipleULAoA_List,
        _MultipleULAoA_Item_uL_AoA,
        _MultipleULAoA_Item_ul_ZoA,
        ___MultipleULAoA_Item_choice_extension_id_tab,
        __MultipleULAoA_Item_choice_extension_id,
        ___MultipleULAoA_Item_choice_extension_criticality_tab,
        __MultipleULAoA_Item_choice_extension_criticality,
        ___MultipleULAoA_Item_choice_extension_value_tab,
        __MultipleULAoA_Item_choice_extension_value,
        _MultipleULAoA_Item_choice_extension,
        MultipleULAoA_Item,
        MultipleULAoA_Item_ExtIEs,
        NarrowBandIndex,
        _NG_RANAccessPointPosition_latitudeSign,
        _NG_RANAccessPointPosition_latitude,
        _NG_RANAccessPointPosition_longitude,
        _NG_RANAccessPointPosition_directionOfAltitude,
        _NG_RANAccessPointPosition_altitude,
        _NG_RANAccessPointPosition_uncertaintySemi_major,
        _NG_RANAccessPointPosition_uncertaintySemi_minor,
        _NG_RANAccessPointPosition_orientationOfMajorAxis,
        _NG_RANAccessPointPosition_uncertaintyAltitude,
        _NG_RANAccessPointPosition_confidence,
        ____NG_RANAccessPointPosition_iE_Extensions__item__id_tab,
        ___NG_RANAccessPointPosition_iE_Extensions__item__id,
        ____NG_RANAccessPointPosition_iE_Extensions__item__criticality_tab,
        ___NG_RANAccessPointPosition_iE_Extensions__item__criticality,
        ____NG_RANAccessPointPosition_iE_Extensions__item__extensionValue_tab,
        ___NG_RANAccessPointPosition_iE_Extensions__item__extensionValue,
        __NG_RANAccessPointPosition_iE_Extensions__item_,
        _NG_RANAccessPointPosition_iE_Extensions,
        NG_RANAccessPointPosition,
        NG_RANAccessPointPosition_ExtIEs,
        _NGRANHighAccuracyAccessPointPosition_latitude,
        _NGRANHighAccuracyAccessPointPosition_longitude,
        _NGRANHighAccuracyAccessPointPosition_altitude,
        _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_major,
        _NGRANHighAccuracyAccessPointPosition_uncertaintySemi_minor,
        _NGRANHighAccuracyAccessPointPosition_orientationOfMajorAxis,
        _NGRANHighAccuracyAccessPointPosition_horizontalConfidence,
        _NGRANHighAccuracyAccessPointPosition_uncertaintyAltitude,
        _NGRANHighAccuracyAccessPointPosition_verticalConfidence,
        ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id_tab,
        ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__id,
        ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality_tab,
        ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__criticality,
        ____NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue_tab,
        ___NGRANHighAccuracyAccessPointPosition_iE_Extensions__item__extensionValue,
        __NGRANHighAccuracyAccessPointPosition_iE_Extensions__item_,
        _NGRANHighAccuracyAccessPointPosition_iE_Extensions,
        NGRANHighAccuracyAccessPointPosition,
        NGRANHighAccuracyAccessPointPosition_ExtIEs,
        _NG_RAN_CGI_pLMN_Identity,
        _NG_RAN_CGI_nG_RANcell,
        ____NG_RAN_CGI_iE_Extensions__item__id_tab,
        ___NG_RAN_CGI_iE_Extensions__item__id,
        ____NG_RAN_CGI_iE_Extensions__item__criticality_tab,
        ___NG_RAN_CGI_iE_Extensions__item__criticality,
        ____NG_RAN_CGI_iE_Extensions__item__extensionValue_tab,
        ___NG_RAN_CGI_iE_Extensions__item__extensionValue,
        __NG_RAN_CGI_iE_Extensions__item_,
        _NG_RAN_CGI_iE_Extensions,
        NG_RAN_CGI,
        NG_RAN_CGI_ExtIEs,
        _NG_RANCell_eUTRA_CellID,
        _NG_RANCell_nR_CellID,
        ___NG_RANCell_choice_Extension_id_tab,
        __NG_RANCell_choice_Extension_id,
        ___NG_RANCell_choice_Extension_criticality_tab,
        __NG_RANCell_choice_Extension_criticality,
        ___NG_RANCell_choice_Extension_value_tab,
        __NG_RANCell_choice_Extension_value,
        _NG_RANCell_choice_Extension,
        NG_RANCell,
        NG_RANCell_ExtensionIE,
        NR_ARFCN,
        NRCellIdentifier,
        NR_PCI,
        __NR_PRS_Beam_Information_nR_PRS_Beam_InformationList__item_,
        _NR_PRS_Beam_Information_nR_PRS_Beam_InformationList,
        __NR_PRS_Beam_Information_lCS_to_GCS_TranslationList__item_,
        _NR_PRS_Beam_Information_lCS_to_GCS_TranslationList,
        ____NR_PRS_Beam_Information_iE_Extensions__item__id_tab,
        ___NR_PRS_Beam_Information_iE_Extensions__item__id,
        ____NR_PRS_Beam_Information_iE_Extensions__item__criticality_tab,
        ___NR_PRS_Beam_Information_iE_Extensions__item__criticality,
        ____NR_PRS_Beam_Information_iE_Extensions__item__extensionValue_tab,
        ___NR_PRS_Beam_Information_iE_Extensions__item__extensionValue,
        __NR_PRS_Beam_Information_iE_Extensions__item_,
        _NR_PRS_Beam_Information_iE_Extensions,
        NR_PRS_Beam_Information,
        NR_PRS_Beam_Information_IEs,
        _NR_PRS_Beam_InformationItem_pRSresourceSetID,
        __NR_PRS_Beam_InformationItem_pRSAngle__item_,
        _NR_PRS_Beam_InformationItem_pRSAngle,
        ____NR_PRS_Beam_InformationItem_iE_Extensions__item__id_tab,
        ___NR_PRS_Beam_InformationItem_iE_Extensions__item__id,
        ____NR_PRS_Beam_InformationItem_iE_Extensions__item__criticality_tab,
        ___NR_PRS_Beam_InformationItem_iE_Extensions__item__criticality,
        ____NR_PRS_Beam_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___NR_PRS_Beam_InformationItem_iE_Extensions__item__extensionValue,
        __NR_PRS_Beam_InformationItem_iE_Extensions__item_,
        _NR_PRS_Beam_InformationItem_iE_Extensions,
        NR_PRS_Beam_InformationItem,
        NR_PRS_Beam_InformationItem_ExtIEs,
        NR_TADV,
        NumberOfAntennaPorts_EUTRA,
        NumberOfDlFrames_EUTRA,
        NumberOfDlFrames_Extended_EUTRA,
        NumberOfFrequencyHoppingBands,
        NumberOfTRPRxTEG,
        NumberOfTRPRxTxTEG,
        NZP_CSI_RS_ResourceID,
        _OnDemandPRS_Info_onDemandPRSRequestAllowed,
        _OnDemandPRS_Info_allowedResourceSetPeriodicityValues,
        _OnDemandPRS_Info_allowedPRSBandwidthValues,
        _OnDemandPRS_Info_allowedResourceRepetitionFactorValues,
        _OnDemandPRS_Info_allowedResourceNumberOfSymbolsValues,
        _OnDemandPRS_Info_allowedCombSizeValues,
        ____OnDemandPRS_Info_iE_Extensions__item__id_tab,
        ___OnDemandPRS_Info_iE_Extensions__item__id,
        ____OnDemandPRS_Info_iE_Extensions__item__criticality_tab,
        ___OnDemandPRS_Info_iE_Extensions__item__criticality,
        ____OnDemandPRS_Info_iE_Extensions__item__extensionValue_tab,
        ___OnDemandPRS_Info_iE_Extensions__item__extensionValue,
        __OnDemandPRS_Info_iE_Extensions__item_,
        _OnDemandPRS_Info_iE_Extensions,
        OnDemandPRS_Info,
        OnDemandPRS_Info_ExtIEs,
        __OTDOACells__item__oTDOACellInfo,
        _____OTDOACells__item__iE_Extensions__item__id_tab,
        ____OTDOACells__item__iE_Extensions__item__id,
        _____OTDOACells__item__iE_Extensions__item__criticality_tab,
        ____OTDOACells__item__iE_Extensions__item__criticality,
        _____OTDOACells__item__iE_Extensions__item__extensionValue_tab,
        ____OTDOACells__item__iE_Extensions__item__extensionValue,
        ___OTDOACells__item__iE_Extensions__item_,
        __OTDOACells__item__iE_Extensions,
        _OTDOACells__item_,
        OTDOACells,
        OTDOACells_ExtIEs,
        _OTDOACell_Information__item_,
        OTDOACell_Information,
        _OTDOACell_Information_Item_pCI_EUTRA,
        _OTDOACell_Information_Item_cGI_EUTRA,
        _OTDOACell_Information_Item_tAC,
        _OTDOACell_Information_Item_eARFCN,
        _OTDOACell_Information_Item_pRS_Bandwidth_EUTRA,
        _OTDOACell_Information_Item_pRS_ConfigurationIndex_EUTRA,
        _OTDOACell_Information_Item_cPLength_EUTRA,
        _OTDOACell_Information_Item_numberOfDlFrames_EUTRA,
        _OTDOACell_Information_Item_numberOfAntennaPorts_EUTRA,
        _OTDOACell_Information_Item_sFNInitialisationTime_EUTRA,
        _OTDOACell_Information_Item_nG_RANAccessPointPosition,
        _OTDOACell_Information_Item_pRSMutingConfiguration_EUTRA,
        _OTDOACell_Information_Item_prsid_EUTRA,
        _OTDOACell_Information_Item_tpid_EUTRA,
        _OTDOACell_Information_Item_tpType_EUTRA,
        _OTDOACell_Information_Item_numberOfDlFrames_Extended_EUTRA,
        _OTDOACell_Information_Item_crsCPlength_EUTRA,
        _OTDOACell_Information_Item_dL_Bandwidth_EUTRA,
        _OTDOACell_Information_Item_pRSOccasionGroup_EUTRA,
        _OTDOACell_Information_Item_pRSFrequencyHoppingConfiguration_EUTRA,
        ___OTDOACell_Information_Item_choice_Extension_id_tab,
        ____OTDOACell_Information_Item_choice_Extension_id_tab_val_Value_0,
        ____OTDOACell_Information_Item_choice_Extension_id_tab_val_Value_1,
        ____OTDOACell_Information_Item_choice_Extension_id_tab_val_Value_2,
        __OTDOACell_Information_Item_choice_Extension_id,
        __OTDOACell_Information_Item_choice_Extension_criticality,
        __OTDOACell_Information_Item_choice_Extension_value,
        _OTDOACell_Information_Item_choice_Extension,
        OTDOACell_Information_Item,
        OTDOACell_Information_Item_ExtensionIE,
        _OTDOACell_Information_Item_ExtensionIE_val_Value_0,
        _OTDOACell_Information_Item_ExtensionIE_val_Value_1,
        _OTDOACell_Information_Item_ExtensionIE_val_Value_2,
        OTDOA_Information_Item,
        ___OtherRATMeasurementQuantities__item__id_tab,
        ____OtherRATMeasurementQuantities__item__id_tab_val_Value_0,
        __OtherRATMeasurementQuantities__item__id,
        __OtherRATMeasurementQuantities__item__criticality,
        __OtherRATMeasurementQuantities__item__value,
        _OtherRATMeasurementQuantities__item_,
        OtherRATMeasurementQuantities,
        OtherRATMeasurementQuantities_ItemIEs,
        _OtherRATMeasurementQuantities_ItemIEs_val_Value_0,
        _OtherRATMeasurementQuantities_Item_otherRATMeasurementQuantitiesValue,
        ____OtherRATMeasurementQuantities_Item_iE_Extensions__item__id_tab,
        ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__id,
        ____OtherRATMeasurementQuantities_Item_iE_Extensions__item__criticality_tab,
        ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__criticality,
        ____OtherRATMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab,
        ___OtherRATMeasurementQuantities_Item_iE_Extensions__item__extensionValue,
        __OtherRATMeasurementQuantities_Item_iE_Extensions__item_,
        _OtherRATMeasurementQuantities_Item_iE_Extensions,
        OtherRATMeasurementQuantities_Item,
        OtherRATMeasurementQuantitiesValue_ExtIEs,
        OtherRATMeasurementQuantitiesValue,
        _OtherRATMeasurementResult__item_,
        OtherRATMeasurementResult,
        _OtherRATMeasuredResultsValue_resultGERAN,
        _OtherRATMeasuredResultsValue_resultUTRAN,
        ___OtherRATMeasuredResultsValue_choice_Extension_id_tab,
        ____OtherRATMeasuredResultsValue_choice_Extension_id_tab_val_Value_0,
        ____OtherRATMeasuredResultsValue_choice_Extension_id_tab_val_Value_1,
        __OtherRATMeasuredResultsValue_choice_Extension_id,
        __OtherRATMeasuredResultsValue_choice_Extension_criticality,
        __OtherRATMeasuredResultsValue_choice_Extension_value,
        _OtherRATMeasuredResultsValue_choice_Extension,
        OtherRATMeasuredResultsValue,
        OtherRATMeasuredResultsValue_ExtensionIE,
        _OtherRATMeasuredResultsValue_ExtensionIE_val_Value_0,
        _OtherRATMeasuredResultsValue_ExtensionIE_val_Value_1,
        Outcome,
        _PathlossReferenceInformation_pathlossReferenceSignal,
        ____PathlossReferenceInformation_iE_Extensions__item__id_tab,
        ___PathlossReferenceInformation_iE_Extensions__item__id,
        ____PathlossReferenceInformation_iE_Extensions__item__criticality_tab,
        ___PathlossReferenceInformation_iE_Extensions__item__criticality,
        ____PathlossReferenceInformation_iE_Extensions__item__extensionValue_tab,
        ___PathlossReferenceInformation_iE_Extensions__item__extensionValue,
        __PathlossReferenceInformation_iE_Extensions__item_,
        _PathlossReferenceInformation_iE_Extensions,
        PathlossReferenceInformation,
        PathlossReferenceInformation_ExtIEs,
        _PathlossReferenceSignal_sSB_Reference,
        _PathlossReferenceSignal_dL_PRS_Reference,
        ___PathlossReferenceSignal_choice_Extension_id_tab,
        __PathlossReferenceSignal_choice_Extension_id,
        ___PathlossReferenceSignal_choice_Extension_criticality_tab,
        __PathlossReferenceSignal_choice_Extension_criticality,
        ___PathlossReferenceSignal_choice_Extension_value_tab,
        __PathlossReferenceSignal_choice_Extension_value,
        _PathlossReferenceSignal_choice_Extension,
        PathlossReferenceSignal,
        PathlossReferenceSignal_ExtensionIE,
        PCI_EUTRA,
        PhysCellIDGERAN,
        PhysCellIDUTRA_FDD,
        PhysCellIDUTRA_TDD,
        PLMN_Identity,
        _PeriodicityList__item_,
        PeriodicityList,
        PeriodicityItem,
        __PosSIBs__item__posSIB_Type,
        __PosSIBs__item__posSIB_Segments,
        __PosSIBs__item__assistanceInformationMetaData,
        __PosSIBs__item__broadcastPriority,
        _____PosSIBs__item__iE_Extensions__item__id_tab,
        ____PosSIBs__item__iE_Extensions__item__id,
        _____PosSIBs__item__iE_Extensions__item__criticality_tab,
        ____PosSIBs__item__iE_Extensions__item__criticality,
        _____PosSIBs__item__iE_Extensions__item__extensionValue_tab,
        ____PosSIBs__item__iE_Extensions__item__extensionValue,
        ___PosSIBs__item__iE_Extensions__item_,
        __PosSIBs__item__iE_Extensions,
        _PosSIBs__item_,
        PosSIBs,
        PosSIBs_ExtIEs,
        __PosSIB_Segments__item__assistanceDataSIBelement,
        _____PosSIB_Segments__item__iE_Extensions__item__id_tab,
        ____PosSIB_Segments__item__iE_Extensions__item__id,
        _____PosSIB_Segments__item__iE_Extensions__item__criticality_tab,
        ____PosSIB_Segments__item__iE_Extensions__item__criticality,
        _____PosSIB_Segments__item__iE_Extensions__item__extensionValue_tab,
        ____PosSIB_Segments__item__iE_Extensions__item__extensionValue,
        ___PosSIB_Segments__item__iE_Extensions__item_,
        __PosSIB_Segments__item__iE_Extensions,
        _PosSIB_Segments__item_,
        PosSIB_Segments,
        PosSIB_Segments_ExtIEs,
        PosSIB_Type,
        _PosSRSResource_List__item_,
        PosSRSResource_List,
        _PosSRSResource_Item_srs_PosResourceId,
        _PosSRSResource_Item_transmissionCombPos,
        _PosSRSResource_Item_startPosition,
        _PosSRSResource_Item_nrofSymbols,
        _PosSRSResource_Item_freqDomainShift,
        _PosSRSResource_Item_c_SRS,
        _PosSRSResource_Item_groupOrSequenceHopping,
        _PosSRSResource_Item_resourceTypePos,
        _PosSRSResource_Item_sequenceId,
        _PosSRSResource_Item_spatialRelationPos,
        ____PosSRSResource_Item_iE_Extensions__item__id_tab,
        ___PosSRSResource_Item_iE_Extensions__item__id,
        ____PosSRSResource_Item_iE_Extensions__item__criticality_tab,
        ___PosSRSResource_Item_iE_Extensions__item__criticality,
        ____PosSRSResource_Item_iE_Extensions__item__extensionValue_tab,
        ___PosSRSResource_Item_iE_Extensions__item__extensionValue,
        __PosSRSResource_Item_iE_Extensions__item_,
        _PosSRSResource_Item_iE_Extensions,
        PosSRSResource_Item,
        PosSRSResource_Item_ExtIEs,
        _PosSRSResourceID_List__item_,
        PosSRSResourceID_List,
        _PosSRSResourceSet_List__item_,
        PosSRSResourceSet_List,
        _PosSRSResourceIDPerSet_List__item_,
        PosSRSResourceIDPerSet_List,
        _PosSRSResourceSet_Item_possrsResourceSetID,
        _PosSRSResourceSet_Item_possRSResourceIDPerSet_List,
        _PosSRSResourceSet_Item_posresourceSetType,
        ____PosSRSResourceSet_Item_iE_Extensions__item__id_tab,
        ___PosSRSResourceSet_Item_iE_Extensions__item__id,
        ____PosSRSResourceSet_Item_iE_Extensions__item__criticality_tab,
        ___PosSRSResourceSet_Item_iE_Extensions__item__criticality,
        ____PosSRSResourceSet_Item_iE_Extensions__item__extensionValue_tab,
        ___PosSRSResourceSet_Item_iE_Extensions__item__extensionValue,
        __PosSRSResourceSet_Item_iE_Extensions__item_,
        _PosSRSResourceSet_Item_iE_Extensions,
        PosSRSResourceSet_Item,
        PosSRSResourceSet_Item_ExtIEs,
        _PosResourceSetType_periodic,
        _PosResourceSetType_semi_persistent,
        _PosResourceSetType_aperiodic,
        ___PosResourceSetType_choice_extension_id_tab,
        __PosResourceSetType_choice_extension_id,
        ___PosResourceSetType_choice_extension_criticality_tab,
        __PosResourceSetType_choice_extension_criticality,
        ___PosResourceSetType_choice_extension_value_tab,
        __PosResourceSetType_choice_extension_value,
        _PosResourceSetType_choice_extension,
        PosResourceSetType,
        PosResourceSetType_ExtIEs,
        _PosResourceSetTypePeriodic_posperiodicSet,
        ____PosResourceSetTypePeriodic_iE_Extensions__item__id_tab,
        ___PosResourceSetTypePeriodic_iE_Extensions__item__id,
        ____PosResourceSetTypePeriodic_iE_Extensions__item__criticality_tab,
        ___PosResourceSetTypePeriodic_iE_Extensions__item__criticality,
        ____PosResourceSetTypePeriodic_iE_Extensions__item__extensionValue_tab,
        ___PosResourceSetTypePeriodic_iE_Extensions__item__extensionValue,
        __PosResourceSetTypePeriodic_iE_Extensions__item_,
        _PosResourceSetTypePeriodic_iE_Extensions,
        PosResourceSetTypePeriodic,
        PosResourceSetTypePeriodic_ExtIEs,
        _PosResourceSetTypeSemi_persistent_possemi_persistentSet,
        ____PosResourceSetTypeSemi_persistent_iE_Extensions__item__id_tab,
        ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__id,
        ____PosResourceSetTypeSemi_persistent_iE_Extensions__item__criticality_tab,
        ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__criticality,
        ____PosResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue_tab,
        ___PosResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue,
        __PosResourceSetTypeSemi_persistent_iE_Extensions__item_,
        _PosResourceSetTypeSemi_persistent_iE_Extensions,
        PosResourceSetTypeSemi_persistent,
        PosResourceSetTypeSemi_persistent_ExtIEs,
        _PosResourceSetTypeAperiodic_sRSResourceTrigger,
        ____PosResourceSetTypeAperiodic_iE_Extensions__item__id_tab,
        ___PosResourceSetTypeAperiodic_iE_Extensions__item__id,
        ____PosResourceSetTypeAperiodic_iE_Extensions__item__criticality_tab,
        ___PosResourceSetTypeAperiodic_iE_Extensions__item__criticality,
        ____PosResourceSetTypeAperiodic_iE_Extensions__item__extensionValue_tab,
        ___PosResourceSetTypeAperiodic_iE_Extensions__item__extensionValue,
        __PosResourceSetTypeAperiodic_iE_Extensions__item_,
        _PosResourceSetTypeAperiodic_iE_Extensions,
        PosResourceSetTypeAperiodic,
        PosResourceSetTypeAperiodic_ExtIEs,
        PreconfigurationResult,
        PRS_Bandwidth_EUTRA,
        _PRSAngleItem_nRPRSAzimuth,
        _PRSAngleItem_nRPRSAzimuthFine,
        _PRSAngleItem_nRPRSElevation,
        _PRSAngleItem_nRPRSElevationFine,
        ____PRSAngleItem_iE_Extensions__item__id_tab,
        _____PRSAngleItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___PRSAngleItem_iE_Extensions__item__id,
        ___PRSAngleItem_iE_Extensions__item__criticality,
        ___PRSAngleItem_iE_Extensions__item__extensionValue,
        __PRSAngleItem_iE_Extensions__item_,
        _PRSAngleItem_iE_Extensions,
        PRSAngleItem,
        PRSAngleItem_ExtIEs,
        _PRSAngleItem_ExtIEs_val_Extension_0,
        _PRSInformationPos_pRS_IDPos,
        _PRSInformationPos_pRS_Resource_Set_IDPos,
        _PRSInformationPos_pRS_Resource_IDPos,
        ____PRSInformationPos_iE_Extensions__item__id_tab,
        ___PRSInformationPos_iE_Extensions__item__id,
        ____PRSInformationPos_iE_Extensions__item__criticality_tab,
        ___PRSInformationPos_iE_Extensions__item__criticality,
        ____PRSInformationPos_iE_Extensions__item__extensionValue_tab,
        ___PRSInformationPos_iE_Extensions__item__extensionValue,
        __PRSInformationPos_iE_Extensions__item_,
        _PRSInformationPos_iE_Extensions,
        PRSInformationPos,
        PRSInformationPos_ExtIEs,
        PRSConfigRequestType,
        _PRSConfiguration_pRSResourceSet_List,
        ____PRSConfiguration_iE_Extensions__item__id_tab,
        ___PRSConfiguration_iE_Extensions__item__id,
        ____PRSConfiguration_iE_Extensions__item__criticality_tab,
        ___PRSConfiguration_iE_Extensions__item__criticality,
        ____PRSConfiguration_iE_Extensions__item__extensionValue_tab,
        ___PRSConfiguration_iE_Extensions__item__extensionValue,
        __PRSConfiguration_iE_Extensions__item_,
        _PRSConfiguration_iE_Extensions,
        PRSConfiguration,
        PRSConfiguration_ExtIEs,
        PRS_ConfigurationIndex_EUTRA,
        PRS_ID_EUTRA,
        _PRSMutingConfiguration_EUTRA_two,
        _PRSMutingConfiguration_EUTRA_four,
        _PRSMutingConfiguration_EUTRA_eight,
        _PRSMutingConfiguration_EUTRA_sixteen,
        _PRSMutingConfiguration_EUTRA_thirty_two,
        _PRSMutingConfiguration_EUTRA_sixty_four,
        _PRSMutingConfiguration_EUTRA_one_hundred_and_twenty_eight,
        _PRSMutingConfiguration_EUTRA_two_hundred_and_fifty_six,
        _PRSMutingConfiguration_EUTRA_five_hundred_and_twelve,
        _PRSMutingConfiguration_EUTRA_one_thousand_and_twenty_four,
        ___PRSMutingConfiguration_EUTRA_choice_Extension_id_tab,
        __PRSMutingConfiguration_EUTRA_choice_Extension_id,
        ___PRSMutingConfiguration_EUTRA_choice_Extension_criticality_tab,
        __PRSMutingConfiguration_EUTRA_choice_Extension_criticality,
        ___PRSMutingConfiguration_EUTRA_choice_Extension_value_tab,
        __PRSMutingConfiguration_EUTRA_choice_Extension_value,
        _PRSMutingConfiguration_EUTRA_choice_Extension,
        PRSMutingConfiguration_EUTRA,
        PRSMutingConfiguration_EUTRA_ExtensionIE,
        PRSOccasionGroup_EUTRA,
        _PRSFrequencyHoppingConfiguration_EUTRA_noOfFreqHoppingBands,
        __PRSFrequencyHoppingConfiguration_EUTRA_bandPositions__item_,
        _PRSFrequencyHoppingConfiguration_EUTRA_bandPositions,
        ____PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__id_tab,
        ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__id,
        ____PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__criticality_tab,
        ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__criticality,
        ____PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__extensionValue_tab,
        ___PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item__extensionValue,
        __PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions__item_,
        _PRSFrequencyHoppingConfiguration_EUTRA_iE_Extensions,
        PRSFrequencyHoppingConfiguration_EUTRA,
        PRSFrequencyHoppingConfiguration_EUTRA_Item_IEs,
        _PRS_Measurements_Info_List__item_,
        PRS_Measurements_Info_List,
        _PRS_Measurements_Info_List_Item_pointA,
        _PRS_Measurements_Info_List_Item_measPRSPeriodicity,
        _PRS_Measurements_Info_List_Item_measPRSOffset,
        _PRS_Measurements_Info_List_Item_measurementPRSLength,
        ____PRS_Measurements_Info_List_Item_iE_Extensions__item__id_tab,
        ___PRS_Measurements_Info_List_Item_iE_Extensions__item__id,
        ____PRS_Measurements_Info_List_Item_iE_Extensions__item__criticality_tab,
        ___PRS_Measurements_Info_List_Item_iE_Extensions__item__criticality,
        ____PRS_Measurements_Info_List_Item_iE_Extensions__item__extensionValue_tab,
        ___PRS_Measurements_Info_List_Item_iE_Extensions__item__extensionValue,
        __PRS_Measurements_Info_List_Item_iE_Extensions__item_,
        _PRS_Measurements_Info_List_Item_iE_Extensions,
        PRS_Measurements_Info_List_Item,
        PRS_Measurements_Info_List_Item_ExtIEs,
        _PRSMuting_pRSMutingOption1,
        _PRSMuting_pRSMutingOption2,
        ____PRSMuting_iE_Extensions__item__id_tab,
        ___PRSMuting_iE_Extensions__item__id,
        ____PRSMuting_iE_Extensions__item__criticality_tab,
        ___PRSMuting_iE_Extensions__item__criticality,
        ____PRSMuting_iE_Extensions__item__extensionValue_tab,
        ___PRSMuting_iE_Extensions__item__extensionValue,
        __PRSMuting_iE_Extensions__item_,
        _PRSMuting_iE_Extensions,
        PRSMuting,
        PRSMuting_ExtIEs,
        _PRSMutingOption1_mutingPattern,
        _PRSMutingOption1_mutingBitRepetitionFactor,
        ____PRSMutingOption1_iE_Extensions__item__id_tab,
        ___PRSMutingOption1_iE_Extensions__item__id,
        ____PRSMutingOption1_iE_Extensions__item__criticality_tab,
        ___PRSMutingOption1_iE_Extensions__item__criticality,
        ____PRSMutingOption1_iE_Extensions__item__extensionValue_tab,
        ___PRSMutingOption1_iE_Extensions__item__extensionValue,
        __PRSMutingOption1_iE_Extensions__item_,
        _PRSMutingOption1_iE_Extensions,
        PRSMutingOption1,
        PRSMutingOption1_ExtIEs,
        _PRSMutingOption2_mutingPattern,
        ____PRSMutingOption2_iE_Extensions__item__id_tab,
        ___PRSMutingOption2_iE_Extensions__item__id,
        ____PRSMutingOption2_iE_Extensions__item__criticality_tab,
        ___PRSMutingOption2_iE_Extensions__item__criticality,
        ____PRSMutingOption2_iE_Extensions__item__extensionValue_tab,
        ___PRSMutingOption2_iE_Extensions__item__extensionValue,
        __PRSMutingOption2_iE_Extensions__item_,
        _PRSMutingOption2_iE_Extensions,
        PRSMutingOption2,
        PRSMutingOption2_ExtIEs,
        _PRSResource_List__item_,
        PRSResource_List,
        _PRSResource_Item_pRSResourceID,
        _PRSResource_Item_sequenceID,
        _PRSResource_Item_rEOffset,
        _PRSResource_Item_resourceSlotOffset,
        _PRSResource_Item_resourceSymbolOffset,
        _PRSResource_Item_qCLInfo,
        ____PRSResource_Item_iE_Extensions__item__id_tab,
        ___PRSResource_Item_iE_Extensions__item__id,
        ____PRSResource_Item_iE_Extensions__item__criticality_tab,
        ___PRSResource_Item_iE_Extensions__item__criticality,
        ____PRSResource_Item_iE_Extensions__item__extensionValue_tab,
        ___PRSResource_Item_iE_Extensions__item__extensionValue,
        __PRSResource_Item_iE_Extensions__item_,
        _PRSResource_Item_iE_Extensions,
        PRSResource_Item,
        PRSResource_Item_ExtIEs,
        _PRSResource_QCLInfo_qCLSourceSSB,
        _PRSResource_QCLInfo_qCLSourcePRS,
        ___PRSResource_QCLInfo_choice_Extension_id_tab,
        __PRSResource_QCLInfo_choice_Extension_id,
        ___PRSResource_QCLInfo_choice_Extension_criticality_tab,
        __PRSResource_QCLInfo_choice_Extension_criticality,
        ___PRSResource_QCLInfo_choice_Extension_value_tab,
        __PRSResource_QCLInfo_choice_Extension_value,
        _PRSResource_QCLInfo_choice_Extension,
        PRSResource_QCLInfo,
        PRSResource_QCLInfo_ExtIEs,
        _PRSResource_QCLSourceSSB_pCI_NR,
        _PRSResource_QCLSourceSSB_sSB_Index,
        ____PRSResource_QCLSourceSSB_iE_Extensions__item__id_tab,
        ___PRSResource_QCLSourceSSB_iE_Extensions__item__id,
        ____PRSResource_QCLSourceSSB_iE_Extensions__item__criticality_tab,
        ___PRSResource_QCLSourceSSB_iE_Extensions__item__criticality,
        ____PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue_tab,
        ___PRSResource_QCLSourceSSB_iE_Extensions__item__extensionValue,
        __PRSResource_QCLSourceSSB_iE_Extensions__item_,
        _PRSResource_QCLSourceSSB_iE_Extensions,
        PRSResource_QCLSourceSSB,
        PRSResource_QCLSourceSSB_ExtIEs,
        _PRSResource_QCLSourcePRS_qCLSourcePRSResourceSetID,
        _PRSResource_QCLSourcePRS_qCLSourcePRSResourceID,
        ____PRSResource_QCLSourcePRS_iE_Extensions__item__id_tab,
        ___PRSResource_QCLSourcePRS_iE_Extensions__item__id,
        ____PRSResource_QCLSourcePRS_iE_Extensions__item__criticality_tab,
        ___PRSResource_QCLSourcePRS_iE_Extensions__item__criticality,
        ____PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue_tab,
        ___PRSResource_QCLSourcePRS_iE_Extensions__item__extensionValue,
        __PRSResource_QCLSourcePRS_iE_Extensions__item_,
        _PRSResource_QCLSourcePRS_iE_Extensions,
        PRSResource_QCLSourcePRS,
        PRSResource_QCLSourcePRS_ExtIEs,
        _PRSResourceSet_List__item_,
        PRSResourceSet_List,
        _PRSResourceSet_Item_pRSResourceSetID,
        _PRSResourceSet_Item_subcarrierSpacing,
        _PRSResourceSet_Item_pRSbandwidth,
        _PRSResourceSet_Item_startPRB,
        _PRSResourceSet_Item_pointA,
        _PRSResourceSet_Item_combSize,
        _PRSResourceSet_Item_cPType,
        _PRSResourceSet_Item_resourceSetPeriodicity,
        _PRSResourceSet_Item_resourceSetSlotOffset,
        _PRSResourceSet_Item_resourceRepetitionFactor,
        _PRSResourceSet_Item_resourceTimeGap,
        _PRSResourceSet_Item_resourceNumberofSymbols,
        _PRSResourceSet_Item_pRSMuting,
        _PRSResourceSet_Item_pRSResourceTransmitPower,
        _PRSResourceSet_Item_pRSResource_List,
        ____PRSResourceSet_Item_iE_Extensions__item__id_tab,
        ___PRSResourceSet_Item_iE_Extensions__item__id,
        ____PRSResourceSet_Item_iE_Extensions__item__criticality_tab,
        ___PRSResourceSet_Item_iE_Extensions__item__criticality,
        ____PRSResourceSet_Item_iE_Extensions__item__extensionValue_tab,
        ___PRSResourceSet_Item_iE_Extensions__item__extensionValue,
        __PRSResourceSet_Item_iE_Extensions__item_,
        _PRSResourceSet_Item_iE_Extensions,
        PRSResourceSet_Item,
        PRSResourceSet_Item_ExtIEs,
        PRS_Resource_ID,
        PRS_Resource_Set_ID,
        PRS_ID,
        _PRSTransmissionOffIndication_pRSTransmissionOffPerTRP,
        _PRSTransmissionOffIndication_pRSTransmissionOffPerResourceSet,
        _PRSTransmissionOffIndication_pRSTransmissionOffPerResource,
        ___PRSTransmissionOffIndication_choice_Extension_id_tab,
        __PRSTransmissionOffIndication_choice_Extension_id,
        ___PRSTransmissionOffIndication_choice_Extension_criticality_tab,
        __PRSTransmissionOffIndication_choice_Extension_criticality,
        ___PRSTransmissionOffIndication_choice_Extension_value_tab,
        __PRSTransmissionOffIndication_choice_Extension_value,
        _PRSTransmissionOffIndication_choice_Extension,
        PRSTransmissionOffIndication,
        PRSTransmissionOffIndication_ExtIEs,
        _PRSTransmissionOffPerResource__item_,
        PRSTransmissionOffPerResource,
        _PRSTransmissionOffPerResource_Item_pRSResourceSetID,
        __PRSTransmissionOffPerResource_Item_pRSTransmissionOffIndicationPerResourceList__item_,
        _PRSTransmissionOffPerResource_Item_pRSTransmissionOffIndicationPerResourceList,
        ____PRSTransmissionOffPerResource_Item_iE_Extensions__item__id_tab,
        ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__id,
        ____PRSTransmissionOffPerResource_Item_iE_Extensions__item__criticality_tab,
        ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__criticality,
        ____PRSTransmissionOffPerResource_Item_iE_Extensions__item__extensionValue_tab,
        ___PRSTransmissionOffPerResource_Item_iE_Extensions__item__extensionValue,
        __PRSTransmissionOffPerResource_Item_iE_Extensions__item_,
        _PRSTransmissionOffPerResource_Item_iE_Extensions,
        PRSTransmissionOffPerResource_Item,
        PRSTransmissionOffPerResource_Item_ExtIEs,
        _PRSTransmissionOffIndicationPerResource_Item_pRSResourceID,
        ____PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__id_tab,
        ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__id,
        ____PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__criticality_tab,
        ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__criticality,
        ____PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__extensionValue_tab,
        ___PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item__extensionValue,
        __PRSTransmissionOffIndicationPerResource_Item_iE_Extensions__item_,
        _PRSTransmissionOffIndicationPerResource_Item_iE_Extensions,
        PRSTransmissionOffIndicationPerResource_Item,
        PRSTransmissionOffIndicationPerResource_Item_ExtIEs,
        _PRSTransmissionOffInformation_pRSTransmissionOffIndication,
        ____PRSTransmissionOffInformation_iE_Extensions__item__id_tab,
        ___PRSTransmissionOffInformation_iE_Extensions__item__id,
        ____PRSTransmissionOffInformation_iE_Extensions__item__criticality_tab,
        ___PRSTransmissionOffInformation_iE_Extensions__item__criticality,
        ____PRSTransmissionOffInformation_iE_Extensions__item__extensionValue_tab,
        ___PRSTransmissionOffInformation_iE_Extensions__item__extensionValue,
        __PRSTransmissionOffInformation_iE_Extensions__item_,
        _PRSTransmissionOffInformation_iE_Extensions,
        PRSTransmissionOffInformation,
        PRSTransmissionOffInformation_ExtIEs,
        _PRSTransmissionOffPerResourceSet__item_,
        PRSTransmissionOffPerResourceSet,
        _PRSTransmissionOffPerResourceSet_Item_pRSResourceSetID,
        ____PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__id_tab,
        ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__id,
        ____PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__criticality_tab,
        ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__criticality,
        ____PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__extensionValue_tab,
        ___PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item__extensionValue,
        __PRSTransmissionOffPerResourceSet_Item_iE_Extensions__item_,
        _PRSTransmissionOffPerResourceSet_Item_iE_Extensions,
        PRSTransmissionOffPerResourceSet_Item,
        PRSTransmissionOffPerResourceSet_Item_ExtIEs,
        _PRSTRPList__item_,
        PRSTRPList,
        _PRSTRPItem_tRP_ID,
        _PRSTRPItem_requestedDLPRSTransmissionCharacteristics,
        _PRSTRPItem_pRSTransmissionOffInformation,
        ____PRSTRPItem_iE_Extensions__item__id_tab,
        ___PRSTRPItem_iE_Extensions__item__id,
        ____PRSTRPItem_iE_Extensions__item__criticality_tab,
        ___PRSTRPItem_iE_Extensions__item__criticality,
        ____PRSTRPItem_iE_Extensions__item__extensionValue_tab,
        ___PRSTRPItem_iE_Extensions__item__extensionValue,
        __PRSTRPItem_iE_Extensions__item_,
        _PRSTRPItem_iE_Extensions,
        PRSTRPItem,
        PRSTRPItem_ExtIEs,
        _PRSTransmissionTRPList__item_,
        PRSTransmissionTRPList,
        _PRSTransmissionTRPItem_tRP_ID,
        _PRSTransmissionTRPItem_pRSConfiguration,
        ____PRSTransmissionTRPItem_iE_Extensions__item__id_tab,
        ___PRSTransmissionTRPItem_iE_Extensions__item__id,
        ____PRSTransmissionTRPItem_iE_Extensions__item__criticality_tab,
        ___PRSTransmissionTRPItem_iE_Extensions__item__criticality,
        ____PRSTransmissionTRPItem_iE_Extensions__item__extensionValue_tab,
        ___PRSTransmissionTRPItem_iE_Extensions__item__extensionValue,
        __PRSTransmissionTRPItem_iE_Extensions__item_,
        _PRSTransmissionTRPItem_iE_Extensions,
        PRSTransmissionTRPItem,
        PRSTransmissionTRPItem_ExtIEs,
        _ReferenceSignal_nZP_CSI_RS,
        _ReferenceSignal_sSB,
        _ReferenceSignal_sRS,
        _ReferenceSignal_positioningSRS,
        _ReferenceSignal_dL_PRS,
        ___ReferenceSignal_choice_Extension_id_tab,
        __ReferenceSignal_choice_Extension_id,
        ___ReferenceSignal_choice_Extension_criticality_tab,
        __ReferenceSignal_choice_Extension_criticality,
        ___ReferenceSignal_choice_Extension_value_tab,
        __ReferenceSignal_choice_Extension_value,
        _ReferenceSignal_choice_Extension,
        ReferenceSignal,
        ReferenceSignal_ExtensionIE,
        _ReferencePoint_relativeCoordinateID,
        _ReferencePoint_referencePointCoordinate,
        _ReferencePoint_referencePointCoordinateHA,
        ___ReferencePoint_choice_Extension_id_tab,
        __ReferencePoint_choice_Extension_id,
        ___ReferencePoint_choice_Extension_criticality_tab,
        __ReferencePoint_choice_Extension_criticality,
        ___ReferencePoint_choice_Extension_value_tab,
        __ReferencePoint_choice_Extension_value,
        _ReferencePoint_choice_Extension,
        ReferencePoint,
        ReferencePoint_ExtIEs,
        CoordinateID,
        _RelativeGeodeticLocation_milli_Arc_SecondUnits,
        _RelativeGeodeticLocation_heightUnits,
        _RelativeGeodeticLocation_deltaLatitude,
        _RelativeGeodeticLocation_deltaLongitude,
        _RelativeGeodeticLocation_deltaHeight,
        _RelativeGeodeticLocation_locationUncertainty,
        ____RelativeGeodeticLocation_iE_extensions__item__id_tab,
        ___RelativeGeodeticLocation_iE_extensions__item__id,
        ____RelativeGeodeticLocation_iE_extensions__item__criticality_tab,
        ___RelativeGeodeticLocation_iE_extensions__item__criticality,
        ____RelativeGeodeticLocation_iE_extensions__item__extensionValue_tab,
        ___RelativeGeodeticLocation_iE_extensions__item__extensionValue,
        __RelativeGeodeticLocation_iE_extensions__item_,
        _RelativeGeodeticLocation_iE_extensions,
        RelativeGeodeticLocation,
        RelativeGeodeticLocation_ExtIEs,
        _RelativeCartesianLocation_xYZunit,
        _RelativeCartesianLocation_xvalue,
        _RelativeCartesianLocation_yvalue,
        _RelativeCartesianLocation_zvalue,
        _RelativeCartesianLocation_locationUncertainty,
        ____RelativeCartesianLocation_iE_Extensions__item__id_tab,
        ___RelativeCartesianLocation_iE_Extensions__item__id,
        ____RelativeCartesianLocation_iE_Extensions__item__criticality_tab,
        ___RelativeCartesianLocation_iE_Extensions__item__criticality,
        ____RelativeCartesianLocation_iE_Extensions__item__extensionValue_tab,
        ___RelativeCartesianLocation_iE_Extensions__item__extensionValue,
        __RelativeCartesianLocation_iE_Extensions__item_,
        _RelativeCartesianLocation_iE_Extensions,
        RelativeCartesianLocation,
        RelativeCartesianLocation_ExtIEs,
        _RelativePathDelay_k0,
        _RelativePathDelay_k1,
        _RelativePathDelay_k2,
        _RelativePathDelay_k3,
        _RelativePathDelay_k4,
        _RelativePathDelay_k5,
        ___RelativePathDelay_choice_Extension_id_tab,
        __RelativePathDelay_choice_Extension_id,
        ___RelativePathDelay_choice_Extension_criticality_tab,
        __RelativePathDelay_choice_Extension_criticality,
        ___RelativePathDelay_choice_Extension_value_tab,
        __RelativePathDelay_choice_Extension_value,
        _RelativePathDelay_choice_Extension,
        RelativePathDelay,
        RelativePathDelay_ExtIEs,
        ReportCharacteristics,
        _RequestedDLPRSTransmissionCharacteristics_requestedDLPRSResourceSet_List,
        _RequestedDLPRSTransmissionCharacteristics_numberofFrequencyLayers,
        _RequestedDLPRSTransmissionCharacteristics_startTimeAndDuration,
        ____RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__id_tab,
        ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__id,
        ____RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__criticality_tab,
        ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__criticality,
        ____RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__extensionValue_tab,
        ___RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item__extensionValue,
        __RequestedDLPRSTransmissionCharacteristics_iE_Extensions__item_,
        _RequestedDLPRSTransmissionCharacteristics_iE_Extensions,
        RequestedDLPRSTransmissionCharacteristics,
        RequestedDLPRSTransmissionCharacteristics_ExtIEs,
        _RequestedDLPRSResourceSet_List__item_,
        RequestedDLPRSResourceSet_List,
        _RequestedDLPRSResourceSet_Item_pRSbandwidth,
        _RequestedDLPRSResourceSet_Item_combSize,
        _RequestedDLPRSResourceSet_Item_resourceSetPeriodicity,
        _RequestedDLPRSResourceSet_Item_resourceRepetitionFactor,
        _RequestedDLPRSResourceSet_Item_resourceNumberofSymbols,
        _RequestedDLPRSResourceSet_Item_requestedDLPRSResource_List,
        _RequestedDLPRSResourceSet_Item_resourceSetStartTimeAndDuration,
        ____RequestedDLPRSResourceSet_Item_iE_Extensions__item__id_tab,
        ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__id,
        ____RequestedDLPRSResourceSet_Item_iE_Extensions__item__criticality_tab,
        ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__criticality,
        ____RequestedDLPRSResourceSet_Item_iE_Extensions__item__extensionValue_tab,
        ___RequestedDLPRSResourceSet_Item_iE_Extensions__item__extensionValue,
        __RequestedDLPRSResourceSet_Item_iE_Extensions__item_,
        _RequestedDLPRSResourceSet_Item_iE_Extensions,
        RequestedDLPRSResourceSet_Item,
        RequestedDLPRSResourceSet_Item_ExtIEs,
        _RequestedDLPRSResource_List__item_,
        RequestedDLPRSResource_List,
        _RequestedDLPRSResource_Item_qCLInfo,
        ____RequestedDLPRSResource_Item_iE_Extensions__item__id_tab,
        ___RequestedDLPRSResource_Item_iE_Extensions__item__id,
        ____RequestedDLPRSResource_Item_iE_Extensions__item__criticality_tab,
        ___RequestedDLPRSResource_Item_iE_Extensions__item__criticality,
        ____RequestedDLPRSResource_Item_iE_Extensions__item__extensionValue_tab,
        ___RequestedDLPRSResource_Item_iE_Extensions__item__extensionValue,
        __RequestedDLPRSResource_Item_iE_Extensions__item_,
        _RequestedDLPRSResource_Item_iE_Extensions,
        RequestedDLPRSResource_Item,
        RequestedDLPRSResource_Item_ExtIEs,
        _RequestedSRSTransmissionCharacteristics_numberOfTransmissions,
        _RequestedSRSTransmissionCharacteristics_resourceType,
        _RequestedSRSTransmissionCharacteristics_bandwidth,
        __RequestedSRSTransmissionCharacteristics_listOfSRSResourceSet__item_,
        _RequestedSRSTransmissionCharacteristics_listOfSRSResourceSet,
        _RequestedSRSTransmissionCharacteristics_sSBInformation,
        ____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab,
        _____RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id_tab_val_Extension_0,
        ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__id,
        ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__criticality,
        ___RequestedSRSTransmissionCharacteristics_iE_Extensions__item__extensionValue,
        __RequestedSRSTransmissionCharacteristics_iE_Extensions__item_,
        _RequestedSRSTransmissionCharacteristics_iE_Extensions,
        RequestedSRSTransmissionCharacteristics,
        RequestedSRSTransmissionCharacteristics_ExtIEs,
        _RequestedSRSTransmissionCharacteristics_ExtIEs_val_Extension_0,
        _SRSResourceSet_Item_numberOfSRSResourcePerSet,
        _SRSResourceSet_Item_periodicityList,
        _SRSResourceSet_Item_spatialRelationInformation,
        _SRSResourceSet_Item_pathlossReferenceInformation,
        ____SRSResourceSet_Item_iE_Extensions__item__id_tab,
        _____SRSResourceSet_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___SRSResourceSet_Item_iE_Extensions__item__id,
        ___SRSResourceSet_Item_iE_Extensions__item__criticality,
        ___SRSResourceSet_Item_iE_Extensions__item__extensionValue,
        __SRSResourceSet_Item_iE_Extensions__item_,
        _SRSResourceSet_Item_iE_Extensions,
        SRSResourceSet_Item,
        SRSResourceSet_Item_ExtIEs,
        _SRSResourceSet_Item_ExtIEs_val_Extension_0,
        RequestType,
        _ResourceSetType_periodic,
        _ResourceSetType_semi_persistent,
        _ResourceSetType_aperiodic,
        ___ResourceSetType_choice_extension_id_tab,
        __ResourceSetType_choice_extension_id,
        ___ResourceSetType_choice_extension_criticality_tab,
        __ResourceSetType_choice_extension_criticality,
        ___ResourceSetType_choice_extension_value_tab,
        __ResourceSetType_choice_extension_value,
        _ResourceSetType_choice_extension,
        ResourceSetType,
        ResourceSetType_ExtIEs,
        _ResourceSetTypePeriodic_periodicSet,
        ____ResourceSetTypePeriodic_iE_Extensions__item__id_tab,
        ___ResourceSetTypePeriodic_iE_Extensions__item__id,
        ____ResourceSetTypePeriodic_iE_Extensions__item__criticality_tab,
        ___ResourceSetTypePeriodic_iE_Extensions__item__criticality,
        ____ResourceSetTypePeriodic_iE_Extensions__item__extensionValue_tab,
        ___ResourceSetTypePeriodic_iE_Extensions__item__extensionValue,
        __ResourceSetTypePeriodic_iE_Extensions__item_,
        _ResourceSetTypePeriodic_iE_Extensions,
        ResourceSetTypePeriodic,
        ResourceSetTypePeriodic_ExtIEs,
        _ResourceSetTypeSemi_persistent_semi_persistentSet,
        ____ResourceSetTypeSemi_persistent_iE_Extensions__item__id_tab,
        ___ResourceSetTypeSemi_persistent_iE_Extensions__item__id,
        ____ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality_tab,
        ___ResourceSetTypeSemi_persistent_iE_Extensions__item__criticality,
        ____ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue_tab,
        ___ResourceSetTypeSemi_persistent_iE_Extensions__item__extensionValue,
        __ResourceSetTypeSemi_persistent_iE_Extensions__item_,
        _ResourceSetTypeSemi_persistent_iE_Extensions,
        ResourceSetTypeSemi_persistent,
        ResourceSetTypeSemi_persistent_ExtIEs,
        _ResourceSetTypeAperiodic_sRSResourceTrigger,
        _ResourceSetTypeAperiodic_slotoffset,
        ____ResourceSetTypeAperiodic_iE_Extensions__item__id_tab,
        ___ResourceSetTypeAperiodic_iE_Extensions__item__id,
        ____ResourceSetTypeAperiodic_iE_Extensions__item__criticality_tab,
        ___ResourceSetTypeAperiodic_iE_Extensions__item__criticality,
        ____ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue_tab,
        ___ResourceSetTypeAperiodic_iE_Extensions__item__extensionValue,
        __ResourceSetTypeAperiodic_iE_Extensions__item_,
        _ResourceSetTypeAperiodic_iE_Extensions,
        ResourceSetTypeAperiodic,
        ResourceSetTypeAperiodic_ExtIEs,
        _ResourceType_periodic,
        _ResourceType_semi_persistent,
        _ResourceType_aperiodic,
        ___ResourceType_choice_extension_id_tab,
        __ResourceType_choice_extension_id,
        ___ResourceType_choice_extension_criticality_tab,
        __ResourceType_choice_extension_criticality,
        ___ResourceType_choice_extension_value_tab,
        __ResourceType_choice_extension_value,
        _ResourceType_choice_extension,
        ResourceType,
        ResourceType_ExtIEs,
        _ResourceTypePeriodic_periodicity,
        _ResourceTypePeriodic_offset,
        ____ResourceTypePeriodic_iE_Extensions__item__id_tab,
        ___ResourceTypePeriodic_iE_Extensions__item__id,
        ____ResourceTypePeriodic_iE_Extensions__item__criticality_tab,
        ___ResourceTypePeriodic_iE_Extensions__item__criticality,
        ____ResourceTypePeriodic_iE_Extensions__item__extensionValue_tab,
        ___ResourceTypePeriodic_iE_Extensions__item__extensionValue,
        __ResourceTypePeriodic_iE_Extensions__item_,
        _ResourceTypePeriodic_iE_Extensions,
        ResourceTypePeriodic,
        ResourceTypePeriodic_ExtIEs,
        _ResourceTypeSemi_persistent_periodicity,
        _ResourceTypeSemi_persistent_offset,
        ____ResourceTypeSemi_persistent_iE_Extensions__item__id_tab,
        ___ResourceTypeSemi_persistent_iE_Extensions__item__id,
        ____ResourceTypeSemi_persistent_iE_Extensions__item__criticality_tab,
        ___ResourceTypeSemi_persistent_iE_Extensions__item__criticality,
        ____ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue_tab,
        ___ResourceTypeSemi_persistent_iE_Extensions__item__extensionValue,
        __ResourceTypeSemi_persistent_iE_Extensions__item_,
        _ResourceTypeSemi_persistent_iE_Extensions,
        ResourceTypeSemi_persistent,
        ResourceTypeSemi_persistent_ExtIEs,
        _ResourceTypeAperiodic_aperiodicResourceType,
        ____ResourceTypeAperiodic_iE_Extensions__item__id_tab,
        ___ResourceTypeAperiodic_iE_Extensions__item__id,
        ____ResourceTypeAperiodic_iE_Extensions__item__criticality_tab,
        ___ResourceTypeAperiodic_iE_Extensions__item__criticality,
        ____ResourceTypeAperiodic_iE_Extensions__item__extensionValue_tab,
        ___ResourceTypeAperiodic_iE_Extensions__item__extensionValue,
        __ResourceTypeAperiodic_iE_Extensions__item_,
        _ResourceTypeAperiodic_iE_Extensions,
        ResourceTypeAperiodic,
        ResourceTypeAperiodic_ExtIEs,
        _ResourceTypePos_periodic,
        _ResourceTypePos_semi_persistent,
        _ResourceTypePos_aperiodic,
        ___ResourceTypePos_choice_extension_id_tab,
        __ResourceTypePos_choice_extension_id,
        ___ResourceTypePos_choice_extension_criticality_tab,
        __ResourceTypePos_choice_extension_criticality,
        ___ResourceTypePos_choice_extension_value_tab,
        __ResourceTypePos_choice_extension_value,
        _ResourceTypePos_choice_extension,
        ResourceTypePos,
        ResourceTypePos_ExtIEs,
        _ResourceTypePeriodicPos_periodicity,
        _ResourceTypePeriodicPos_offset,
        ____ResourceTypePeriodicPos_iE_Extensions__item__id_tab,
        ___ResourceTypePeriodicPos_iE_Extensions__item__id,
        ____ResourceTypePeriodicPos_iE_Extensions__item__criticality_tab,
        ___ResourceTypePeriodicPos_iE_Extensions__item__criticality,
        ____ResourceTypePeriodicPos_iE_Extensions__item__extensionValue_tab,
        ___ResourceTypePeriodicPos_iE_Extensions__item__extensionValue,
        __ResourceTypePeriodicPos_iE_Extensions__item_,
        _ResourceTypePeriodicPos_iE_Extensions,
        ResourceTypePeriodicPos,
        ResourceTypePeriodicPos_ExtIEs,
        _ResourceTypeSemi_persistentPos_periodicity,
        _ResourceTypeSemi_persistentPos_offset,
        ____ResourceTypeSemi_persistentPos_iE_Extensions__item__id_tab,
        ___ResourceTypeSemi_persistentPos_iE_Extensions__item__id,
        ____ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality_tab,
        ___ResourceTypeSemi_persistentPos_iE_Extensions__item__criticality,
        ____ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue_tab,
        ___ResourceTypeSemi_persistentPos_iE_Extensions__item__extensionValue,
        __ResourceTypeSemi_persistentPos_iE_Extensions__item_,
        _ResourceTypeSemi_persistentPos_iE_Extensions,
        ResourceTypeSemi_persistentPos,
        ResourceTypeSemi_persistentPos_ExtIEs,
        _ResourceTypeAperiodicPos_slotOffset,
        ____ResourceTypeAperiodicPos_iE_Extensions__item__id_tab,
        ___ResourceTypeAperiodicPos_iE_Extensions__item__id,
        ____ResourceTypeAperiodicPos_iE_Extensions__item__criticality_tab,
        ___ResourceTypeAperiodicPos_iE_Extensions__item__criticality,
        ____ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue_tab,
        ___ResourceTypeAperiodicPos_iE_Extensions__item__extensionValue,
        __ResourceTypeAperiodicPos_iE_Extensions__item_,
        _ResourceTypeAperiodicPos_iE_Extensions,
        ResourceTypeAperiodicPos,
        ResourceTypeAperiodicPos_ExtIEs,
        _ResponseTime_time,
        _ResponseTime_timeUnit,
        ____ResponseTime_iE_Extensions__item__id_tab,
        ___ResponseTime_iE_Extensions__item__id,
        ____ResponseTime_iE_Extensions__item__criticality_tab,
        ___ResponseTime_iE_Extensions__item__criticality,
        ____ResponseTime_iE_Extensions__item__extensionValue_tab,
        ___ResponseTime_iE_Extensions__item__extensionValue,
        __ResponseTime_iE_Extensions__item_,
        _ResponseTime_iE_Extensions,
        ResponseTime,
        ResponseTime_ExtIEs,
        _ResultCSI_RSRP__item_,
        ResultCSI_RSRP,
        _ResultCSI_RSRP_Item_nR_PCI,
        _ResultCSI_RSRP_Item_nR_ARFCN,
        _ResultCSI_RSRP_Item_cGI_NR,
        _ResultCSI_RSRP_Item_valueCSI_RSRP_Cell,
        _ResultCSI_RSRP_Item_cSI_RSRP_PerCSI_RS,
        ____ResultCSI_RSRP_Item_iE_Extensions__item__id_tab,
        ___ResultCSI_RSRP_Item_iE_Extensions__item__id,
        ____ResultCSI_RSRP_Item_iE_Extensions__item__criticality_tab,
        ___ResultCSI_RSRP_Item_iE_Extensions__item__criticality,
        ____ResultCSI_RSRP_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultCSI_RSRP_Item_iE_Extensions__item__extensionValue,
        __ResultCSI_RSRP_Item_iE_Extensions__item_,
        _ResultCSI_RSRP_Item_iE_Extensions,
        ResultCSI_RSRP_Item,
        ResultCSI_RSRP_Item_ExtIEs,
        _ResultCSI_RSRP_PerCSI_RS__item_,
        ResultCSI_RSRP_PerCSI_RS,
        _ResultCSI_RSRP_PerCSI_RS_Item_cSI_RS_Index,
        _ResultCSI_RSRP_PerCSI_RS_Item_valueCSI_RSRP,
        ____ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__id_tab,
        ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__id,
        ____ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__criticality_tab,
        ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__criticality,
        ____ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item__extensionValue,
        __ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions__item_,
        _ResultCSI_RSRP_PerCSI_RS_Item_iE_Extensions,
        ResultCSI_RSRP_PerCSI_RS_Item,
        ResultCSI_RSRP_PerCSI_RS_Item_ExtIEs,
        _ResultCSI_RSRQ__item_,
        ResultCSI_RSRQ,
        _ResultCSI_RSRQ_Item_nR_PCI,
        _ResultCSI_RSRQ_Item_nR_ARFCN,
        _ResultCSI_RSRQ_Item_cGI_NR,
        _ResultCSI_RSRQ_Item_valueCSI_RSRQ_Cell,
        _ResultCSI_RSRQ_Item_cSI_RSRQ_PerCSI_RS,
        ____ResultCSI_RSRQ_Item_iE_Extensions__item__id_tab,
        ___ResultCSI_RSRQ_Item_iE_Extensions__item__id,
        ____ResultCSI_RSRQ_Item_iE_Extensions__item__criticality_tab,
        ___ResultCSI_RSRQ_Item_iE_Extensions__item__criticality,
        ____ResultCSI_RSRQ_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultCSI_RSRQ_Item_iE_Extensions__item__extensionValue,
        __ResultCSI_RSRQ_Item_iE_Extensions__item_,
        _ResultCSI_RSRQ_Item_iE_Extensions,
        ResultCSI_RSRQ_Item,
        ResultCSI_RSRQ_Item_ExtIEs,
        _ResultCSI_RSRQ_PerCSI_RS__item_,
        ResultCSI_RSRQ_PerCSI_RS,
        _ResultCSI_RSRQ_PerCSI_RS_Item_cSI_RS_Index,
        _ResultCSI_RSRQ_PerCSI_RS_Item_valueCSI_RSRQ,
        ____ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__id_tab,
        ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__id,
        ____ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__criticality_tab,
        ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__criticality,
        ____ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item__extensionValue,
        __ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions__item_,
        _ResultCSI_RSRQ_PerCSI_RS_Item_iE_Extensions,
        ResultCSI_RSRQ_PerCSI_RS_Item,
        ResultCSI_RSRQ_PerCSI_RS_Item_ExtIEs,
        _ResultEUTRA__item_,
        ResultEUTRA,
        _ResultEUTRA_Item_pCI_EUTRA,
        _ResultEUTRA_Item_eARFCN,
        _ResultEUTRA_Item_valueRSRP_EUTRA,
        _ResultEUTRA_Item_valueRSRQ_EUTRA,
        _ResultEUTRA_Item_cGI_EUTRA,
        ____ResultEUTRA_Item_iE_Extensions__item__id_tab,
        ___ResultEUTRA_Item_iE_Extensions__item__id,
        ____ResultEUTRA_Item_iE_Extensions__item__criticality_tab,
        ___ResultEUTRA_Item_iE_Extensions__item__criticality,
        ____ResultEUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultEUTRA_Item_iE_Extensions__item__extensionValue,
        __ResultEUTRA_Item_iE_Extensions__item_,
        _ResultEUTRA_Item_iE_Extensions,
        ResultEUTRA_Item,
        ResultEUTRA_Item_ExtIEs,
        _ResultRSRP_EUTRA__item_,
        ResultRSRP_EUTRA,
        _ResultRSRP_EUTRA_Item_pCI_EUTRA,
        _ResultRSRP_EUTRA_Item_eARFCN,
        _ResultRSRP_EUTRA_Item_cGI_EUTRA,
        _ResultRSRP_EUTRA_Item_valueRSRP_EUTRA,
        ____ResultRSRP_EUTRA_Item_iE_Extensions__item__id_tab,
        ___ResultRSRP_EUTRA_Item_iE_Extensions__item__id,
        ____ResultRSRP_EUTRA_Item_iE_Extensions__item__criticality_tab,
        ___ResultRSRP_EUTRA_Item_iE_Extensions__item__criticality,
        ____ResultRSRP_EUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultRSRP_EUTRA_Item_iE_Extensions__item__extensionValue,
        __ResultRSRP_EUTRA_Item_iE_Extensions__item_,
        _ResultRSRP_EUTRA_Item_iE_Extensions,
        ResultRSRP_EUTRA_Item,
        ResultRSRP_EUTRA_Item_ExtIEs,
        _ResultRSRQ_EUTRA__item_,
        ResultRSRQ_EUTRA,
        _ResultRSRQ_EUTRA_Item_pCI_EUTRA,
        _ResultRSRQ_EUTRA_Item_eARFCN,
        _ResultRSRQ_EUTRA_Item_cGI_UTRA,
        _ResultRSRQ_EUTRA_Item_valueRSRQ_EUTRA,
        ____ResultRSRQ_EUTRA_Item_iE_Extensions__item__id_tab,
        ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__id,
        ____ResultRSRQ_EUTRA_Item_iE_Extensions__item__criticality_tab,
        ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__criticality,
        ____ResultRSRQ_EUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultRSRQ_EUTRA_Item_iE_Extensions__item__extensionValue,
        __ResultRSRQ_EUTRA_Item_iE_Extensions__item_,
        _ResultRSRQ_EUTRA_Item_iE_Extensions,
        ResultRSRQ_EUTRA_Item,
        ResultRSRQ_EUTRA_Item_ExtIEs,
        _ResultSS_RSRP__item_,
        ResultSS_RSRP,
        _ResultSS_RSRP_Item_nR_PCI,
        _ResultSS_RSRP_Item_nR_ARFCN,
        _ResultSS_RSRP_Item_cGI_NR,
        _ResultSS_RSRP_Item_valueSS_RSRP_Cell,
        _ResultSS_RSRP_Item_sS_RSRP_PerSSB,
        ____ResultSS_RSRP_Item_iE_Extensions__item__id_tab,
        ___ResultSS_RSRP_Item_iE_Extensions__item__id,
        ____ResultSS_RSRP_Item_iE_Extensions__item__criticality_tab,
        ___ResultSS_RSRP_Item_iE_Extensions__item__criticality,
        ____ResultSS_RSRP_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultSS_RSRP_Item_iE_Extensions__item__extensionValue,
        __ResultSS_RSRP_Item_iE_Extensions__item_,
        _ResultSS_RSRP_Item_iE_Extensions,
        ResultSS_RSRP_Item,
        ResultSS_RSRP_Item_ExtIEs,
        _ResultSS_RSRP_PerSSB__item_,
        ResultSS_RSRP_PerSSB,
        _ResultSS_RSRP_PerSSB_Item_sSB_Index,
        _ResultSS_RSRP_PerSSB_Item_valueSS_RSRP,
        ____ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__id_tab,
        ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__id,
        ____ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__criticality_tab,
        ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__criticality,
        ____ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultSS_RSRP_PerSSB_Item_iE_Extensions__item__extensionValue,
        __ResultSS_RSRP_PerSSB_Item_iE_Extensions__item_,
        _ResultSS_RSRP_PerSSB_Item_iE_Extensions,
        ResultSS_RSRP_PerSSB_Item,
        ResultSS_RSRP_PerSSB_Item_ExtIEs,
        _ResultSS_RSRQ__item_,
        ResultSS_RSRQ,
        _ResultSS_RSRQ_Item_nR_PCI,
        _ResultSS_RSRQ_Item_nR_ARFCN,
        _ResultSS_RSRQ_Item_cGI_NR,
        _ResultSS_RSRQ_Item_valueSS_RSRQ_Cell,
        _ResultSS_RSRQ_Item_sS_RSRQ_PerSSB,
        ____ResultSS_RSRQ_Item_iE_Extensions__item__id_tab,
        ___ResultSS_RSRQ_Item_iE_Extensions__item__id,
        ____ResultSS_RSRQ_Item_iE_Extensions__item__criticality_tab,
        ___ResultSS_RSRQ_Item_iE_Extensions__item__criticality,
        ____ResultSS_RSRQ_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultSS_RSRQ_Item_iE_Extensions__item__extensionValue,
        __ResultSS_RSRQ_Item_iE_Extensions__item_,
        _ResultSS_RSRQ_Item_iE_Extensions,
        ResultSS_RSRQ_Item,
        ResultSS_RSRQ_Item_ExtIEs,
        _ResultSS_RSRQ_PerSSB__item_,
        ResultSS_RSRQ_PerSSB,
        _ResultSS_RSRQ_PerSSB_Item_sSB_Index,
        _ResultSS_RSRQ_PerSSB_Item_valueSS_RSRQ,
        ____ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__id_tab,
        ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__id,
        ____ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__criticality_tab,
        ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__criticality,
        ____ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item__extensionValue,
        __ResultSS_RSRQ_PerSSB_Item_iE_Extensions__item_,
        _ResultSS_RSRQ_PerSSB_Item_iE_Extensions,
        ResultSS_RSRQ_PerSSB_Item,
        ResultSS_RSRQ_PerSSB_Item_ExtIEs,
        _ResultGERAN__item_,
        ResultGERAN,
        _ResultGERAN_Item_bCCH,
        _ResultGERAN_Item_physCellIDGERAN,
        _ResultGERAN_Item_rSSI,
        ____ResultGERAN_Item_iE_Extensions__item__id_tab,
        ___ResultGERAN_Item_iE_Extensions__item__id,
        ____ResultGERAN_Item_iE_Extensions__item__criticality_tab,
        ___ResultGERAN_Item_iE_Extensions__item__criticality,
        ____ResultGERAN_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultGERAN_Item_iE_Extensions__item__extensionValue,
        __ResultGERAN_Item_iE_Extensions__item_,
        _ResultGERAN_Item_iE_Extensions,
        ResultGERAN_Item,
        ResultGERAN_Item_ExtIEs,
        _ResultNR__item_,
        ResultNR,
        _ResultNR_Item_nR_PCI,
        _ResultNR_Item_nR_ARFCN,
        _ResultNR_Item_valueSS_RSRP_Cell,
        _ResultNR_Item_valueSS_RSRQ_Cell,
        _ResultNR_Item_sS_RSRP_PerSSB,
        _ResultNR_Item_sS_RSRQ_PerSSB,
        _ResultNR_Item_cGI_NR,
        ____ResultNR_Item_iE_Extensions__item__id_tab,
        ___ResultNR_Item_iE_Extensions__item__id,
        ____ResultNR_Item_iE_Extensions__item__criticality_tab,
        ___ResultNR_Item_iE_Extensions__item__criticality,
        ____ResultNR_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultNR_Item_iE_Extensions__item__extensionValue,
        __ResultNR_Item_iE_Extensions__item_,
        _ResultNR_Item_iE_Extensions,
        ResultNR_Item,
        ResultNR_Item_ExtIEs,
        _ResultUTRAN__item_,
        ResultUTRAN,
        _ResultUTRAN_Item_uARFCN,
        __ResultUTRAN_Item_physCellIDUTRAN_physCellIDUTRA_FDD,
        __ResultUTRAN_Item_physCellIDUTRAN_physCellIDUTRA_TDD,
        _ResultUTRAN_Item_physCellIDUTRAN,
        _ResultUTRAN_Item_uTRA_RSCP,
        _ResultUTRAN_Item_uTRA_EcN0,
        ____ResultUTRAN_Item_iE_Extensions__item__id_tab,
        ___ResultUTRAN_Item_iE_Extensions__item__id,
        ____ResultUTRAN_Item_iE_Extensions__item__criticality_tab,
        ___ResultUTRAN_Item_iE_Extensions__item__criticality,
        ____ResultUTRAN_Item_iE_Extensions__item__extensionValue_tab,
        ___ResultUTRAN_Item_iE_Extensions__item__extensionValue,
        __ResultUTRAN_Item_iE_Extensions__item_,
        _ResultUTRAN_Item_iE_Extensions,
        ResultUTRAN_Item,
        ResultUTRAN_Item_ExtIEs,
        RSSI,
        RxTxTimingErrorMargin,
        _SCS_SpecificCarrier_offsetToCarrier,
        _SCS_SpecificCarrier_subcarrierSpacing,
        _SCS_SpecificCarrier_carrierBandwidth,
        ____SCS_SpecificCarrier_iE_Extensions__item__id_tab,
        ___SCS_SpecificCarrier_iE_Extensions__item__id,
        ____SCS_SpecificCarrier_iE_Extensions__item__criticality_tab,
        ___SCS_SpecificCarrier_iE_Extensions__item__criticality,
        ____SCS_SpecificCarrier_iE_Extensions__item__extensionValue_tab,
        ___SCS_SpecificCarrier_iE_Extensions__item__extensionValue,
        __SCS_SpecificCarrier_iE_Extensions__item_,
        _SCS_SpecificCarrier_iE_Extensions,
        SCS_SpecificCarrier,
        SCS_SpecificCarrier_ExtIEs,
        _Search_window_information_expectedPropagationDelay,
        _Search_window_information_delayUncertainty,
        ____Search_window_information_iE_Extensions__item__id_tab,
        ___Search_window_information_iE_Extensions__item__id,
        ____Search_window_information_iE_Extensions__item__criticality_tab,
        ___Search_window_information_iE_Extensions__item__criticality,
        ____Search_window_information_iE_Extensions__item__extensionValue_tab,
        ___Search_window_information_iE_Extensions__item__extensionValue,
        __Search_window_information_iE_Extensions__item_,
        _Search_window_information_iE_Extensions,
        Search_window_information,
        Search_window_information_ExtIEs,
        RelativeTime1900,
        SFNInitialisationTime_EUTRA,
        SlotNumber,
        _SpatialDirectionInformation_nR_PRS_Beam_Information,
        ____SpatialDirectionInformation_iE_Extensions__item__id_tab,
        ___SpatialDirectionInformation_iE_Extensions__item__id,
        ____SpatialDirectionInformation_iE_Extensions__item__criticality_tab,
        ___SpatialDirectionInformation_iE_Extensions__item__criticality,
        ____SpatialDirectionInformation_iE_Extensions__item__extensionValue_tab,
        ___SpatialDirectionInformation_iE_Extensions__item__extensionValue,
        __SpatialDirectionInformation_iE_Extensions__item_,
        _SpatialDirectionInformation_iE_Extensions,
        SpatialDirectionInformation,
        SpatialDirectionInformation_ExtIEs,
        _SpatialRelationInfo_spatialRelationforResourceID,
        ____SpatialRelationInfo_iE_Extensions__item__id_tab,
        ___SpatialRelationInfo_iE_Extensions__item__id,
        ____SpatialRelationInfo_iE_Extensions__item__criticality_tab,
        ___SpatialRelationInfo_iE_Extensions__item__criticality,
        ____SpatialRelationInfo_iE_Extensions__item__extensionValue_tab,
        ___SpatialRelationInfo_iE_Extensions__item__extensionValue,
        __SpatialRelationInfo_iE_Extensions__item_,
        _SpatialRelationInfo_iE_Extensions,
        SpatialRelationInfo,
        SpatialRelationInfo_ExtIEs,
        _SpatialRelationforResourceID__item_,
        SpatialRelationforResourceID,
        _SpatialRelationforResourceIDItem_referenceSignal,
        ____SpatialRelationforResourceIDItem_iE_Extensions__item__id_tab,
        ___SpatialRelationforResourceIDItem_iE_Extensions__item__id,
        ____SpatialRelationforResourceIDItem_iE_Extensions__item__criticality_tab,
        ___SpatialRelationforResourceIDItem_iE_Extensions__item__criticality,
        ____SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue_tab,
        ___SpatialRelationforResourceIDItem_iE_Extensions__item__extensionValue,
        __SpatialRelationforResourceIDItem_iE_Extensions__item_,
        _SpatialRelationforResourceIDItem_iE_Extensions,
        SpatialRelationforResourceIDItem,
        SpatialRelationforResourceIDItem_ExtIEs,
        _SpatialRelationPerSRSResource_spatialRelationPerSRSResource_List,
        ____SpatialRelationPerSRSResource_iE_Extensions__item__id_tab,
        ___SpatialRelationPerSRSResource_iE_Extensions__item__id,
        ____SpatialRelationPerSRSResource_iE_Extensions__item__criticality_tab,
        ___SpatialRelationPerSRSResource_iE_Extensions__item__criticality,
        ____SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue_tab,
        ___SpatialRelationPerSRSResource_iE_Extensions__item__extensionValue,
        __SpatialRelationPerSRSResource_iE_Extensions__item_,
        _SpatialRelationPerSRSResource_iE_Extensions,
        SpatialRelationPerSRSResource,
        SpatialRelationPerSRSResource_ExtIEs,
        _SpatialRelationPerSRSResource_List__item_,
        SpatialRelationPerSRSResource_List,
        _SpatialRelationPerSRSResourceItem_referenceSignal,
        ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__id_tab,
        ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__id,
        ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality_tab,
        ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__criticality,
        ____SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue_tab,
        ___SpatialRelationPerSRSResourceItem_iE_Extensions__item__extensionValue,
        __SpatialRelationPerSRSResourceItem_iE_Extensions__item_,
        _SpatialRelationPerSRSResourceItem_iE_Extensions,
        SpatialRelationPerSRSResourceItem,
        SpatialRelationPerSRSResourceItem_ExtIEs,
        _SpatialRelationPos_sSBPos,
        _SpatialRelationPos_pRSInformationPos,
        ___SpatialRelationPos_choice_extension_id_tab,
        __SpatialRelationPos_choice_extension_id,
        ___SpatialRelationPos_choice_extension_criticality_tab,
        __SpatialRelationPos_choice_extension_criticality,
        ___SpatialRelationPos_choice_extension_value_tab,
        __SpatialRelationPos_choice_extension_value,
        _SpatialRelationPos_choice_extension,
        SpatialRelationPos,
        SpatialInformationPos_ExtIEs,
        _SRSConfig_sRSResource_List,
        _SRSConfig_posSRSResource_List,
        _SRSConfig_sRSResourceSet_List,
        _SRSConfig_posSRSResourceSet_List,
        ____SRSConfig_iE_Extensions__item__id_tab,
        ___SRSConfig_iE_Extensions__item__id,
        ____SRSConfig_iE_Extensions__item__criticality_tab,
        ___SRSConfig_iE_Extensions__item__criticality,
        ____SRSConfig_iE_Extensions__item__extensionValue_tab,
        ___SRSConfig_iE_Extensions__item__extensionValue,
        __SRSConfig_iE_Extensions__item_,
        _SRSConfig_iE_Extensions,
        SRSConfig,
        SRSConfig_ExtIEs,
        _SRSCarrier_List__item_,
        SRSCarrier_List,
        _SRSCarrier_List_Item_pointA,
        _SRSCarrier_List_Item_uplinkChannelBW_PerSCS_List,
        _SRSCarrier_List_Item_activeULBWP,
        _SRSCarrier_List_Item_pCI_NR,
        ____SRSCarrier_List_Item_iE_Extensions__item__id_tab,
        ___SRSCarrier_List_Item_iE_Extensions__item__id,
        ____SRSCarrier_List_Item_iE_Extensions__item__criticality_tab,
        ___SRSCarrier_List_Item_iE_Extensions__item__criticality,
        ____SRSCarrier_List_Item_iE_Extensions__item__extensionValue_tab,
        ___SRSCarrier_List_Item_iE_Extensions__item__extensionValue,
        __SRSCarrier_List_Item_iE_Extensions__item_,
        _SRSCarrier_List_Item_iE_Extensions,
        SRSCarrier_List_Item,
        SRSCarrier_List_Item_ExtIEs,
        _SRSConfiguration_sRSCarrier_List,
        ____SRSConfiguration_iE_Extensions__item__id_tab,
        ___SRSConfiguration_iE_Extensions__item__id,
        ____SRSConfiguration_iE_Extensions__item__criticality_tab,
        ___SRSConfiguration_iE_Extensions__item__criticality,
        ____SRSConfiguration_iE_Extensions__item__extensionValue_tab,
        ___SRSConfiguration_iE_Extensions__item__extensionValue,
        __SRSConfiguration_iE_Extensions__item_,
        _SRSConfiguration_iE_Extensions,
        SRSConfiguration,
        SRSConfiguration_ExtIEs,
        SrsFrequency,
        SRSPortIndex,
        SRSPosResourceID,
        _SRSResource_sRSResourceID,
        _SRSResource_nrofSRS_Ports,
        _SRSResource_transmissionComb,
        _SRSResource_startPosition,
        _SRSResource_nrofSymbols,
        _SRSResource_repetitionFactor,
        _SRSResource_freqDomainPosition,
        _SRSResource_freqDomainShift,
        _SRSResource_c_SRS,
        _SRSResource_b_SRS,
        _SRSResource_b_hop,
        _SRSResource_groupOrSequenceHopping,
        _SRSResource_resourceType,
        _SRSResource_sequenceId,
        ____SRSResource_iE_Extensions__item__id_tab,
        ___SRSResource_iE_Extensions__item__id,
        ____SRSResource_iE_Extensions__item__criticality_tab,
        ___SRSResource_iE_Extensions__item__criticality,
        ____SRSResource_iE_Extensions__item__extensionValue_tab,
        ___SRSResource_iE_Extensions__item__extensionValue,
        __SRSResource_iE_Extensions__item_,
        _SRSResource_iE_Extensions,
        SRSResource,
        SRSResource_ExtIEs,
        SRSResourceID,
        _SRSResource_List__item_,
        SRSResource_List,
        _SRSResourceSet_List__item_,
        SRSResourceSet_List,
        _SRSResourceID_List__item_,
        SRSResourceID_List,
        _SRSResourceSet_sRSResourceSetID,
        _SRSResourceSet_sRSResourceID_List,
        _SRSResourceSet_resourceSetType,
        ____SRSResourceSet_iE_Extensions__item__id_tab,
        ___SRSResourceSet_iE_Extensions__item__id,
        ____SRSResourceSet_iE_Extensions__item__criticality_tab,
        ___SRSResourceSet_iE_Extensions__item__criticality,
        ____SRSResourceSet_iE_Extensions__item__extensionValue_tab,
        ___SRSResourceSet_iE_Extensions__item__extensionValue,
        __SRSResourceSet_iE_Extensions__item_,
        _SRSResourceSet_iE_Extensions,
        SRSResourceSet,
        SRSResourceSet_ExtIEs,
        SRSResourceSetID,
        _SRSResourceTrigger_aperiodicSRSResourceTriggerList,
        ____SRSResourceTrigger_iE_Extensions__item__id_tab,
        ___SRSResourceTrigger_iE_Extensions__item__id,
        ____SRSResourceTrigger_iE_Extensions__item__criticality_tab,
        ___SRSResourceTrigger_iE_Extensions__item__criticality,
        ____SRSResourceTrigger_iE_Extensions__item__extensionValue_tab,
        ___SRSResourceTrigger_iE_Extensions__item__extensionValue,
        __SRSResourceTrigger_iE_Extensions__item_,
        _SRSResourceTrigger_iE_Extensions,
        SRSResourceTrigger,
        SRSResourceTrigger_ExtIEs,
        _SRSResourcetype_sRSResourceTypeChoice,
        ____SRSResourcetype_iE_Extensions__item__id_tab,
        _____SRSResourcetype_iE_Extensions__item__id_tab_val_Extension_0,
        ___SRSResourcetype_iE_Extensions__item__id,
        ___SRSResourcetype_iE_Extensions__item__criticality,
        ___SRSResourcetype_iE_Extensions__item__extensionValue,
        __SRSResourcetype_iE_Extensions__item_,
        _SRSResourcetype_iE_Extensions,
        SRSResourcetype,
        SRSResourcetype_ExtIEs,
        _SRSResourcetype_ExtIEs_val_Extension_0,
        _SRSResourceTypeChoice_sRSResourceInfo,
        _SRSResourceTypeChoice_posSRSResourceInfo,
        SRSResourceTypeChoice,
        _SRSInfo_sRSResource,
        SRSInfo,
        SRSTransmissionStatus,
        _PosSRSInfo_posSRSResourceID,
        PosSRSInfo,
        __SSBInfo_listOfSSBInfo__item_,
        _SSBInfo_listOfSSBInfo,
        ____SSBInfo_iE_Extensions__item__id_tab,
        ___SSBInfo_iE_Extensions__item__id,
        ____SSBInfo_iE_Extensions__item__criticality_tab,
        ___SSBInfo_iE_Extensions__item__criticality,
        ____SSBInfo_iE_Extensions__item__extensionValue_tab,
        ___SSBInfo_iE_Extensions__item__extensionValue,
        __SSBInfo_iE_Extensions__item_,
        _SSBInfo_iE_Extensions,
        SSBInfo,
        SSBInfo_ExtIEs,
        _SSBInfoItem_sSB_Configuration,
        _SSBInfoItem_pCI_NR,
        ____SSBInfoItem_iE_Extensions__item__id_tab,
        ___SSBInfoItem_iE_Extensions__item__id,
        ____SSBInfoItem_iE_Extensions__item__criticality_tab,
        ___SSBInfoItem_iE_Extensions__item__criticality,
        ____SSBInfoItem_iE_Extensions__item__extensionValue_tab,
        ___SSBInfoItem_iE_Extensions__item__extensionValue,
        __SSBInfoItem_iE_Extensions__item_,
        _SSBInfoItem_iE_Extensions,
        SSBInfoItem,
        SSBInfoItem_ExtIEs,
        _SSB_pCI_NR,
        _SSB_ssb_index,
        ____SSB_iE_Extensions__item__id_tab,
        ___SSB_iE_Extensions__item__id,
        ____SSB_iE_Extensions__item__criticality_tab,
        ___SSB_iE_Extensions__item__criticality,
        ____SSB_iE_Extensions__item__extensionValue_tab,
        ___SSB_iE_Extensions__item__extensionValue,
        __SSB_iE_Extensions__item_,
        _SSB_iE_Extensions,
        SSB,
        SSB_ExtIEs,
        _SSBBurstPosition_shortBitmap,
        _SSBBurstPosition_mediumBitmap,
        _SSBBurstPosition_longBitmap,
        ___SSBBurstPosition_choice_extension_id_tab,
        __SSBBurstPosition_choice_extension_id,
        ___SSBBurstPosition_choice_extension_criticality_tab,
        __SSBBurstPosition_choice_extension_criticality,
        ___SSBBurstPosition_choice_extension_value_tab,
        __SSBBurstPosition_choice_extension_value,
        _SSBBurstPosition_choice_extension,
        SSBBurstPosition,
        SSBBurstPosition_ExtIEs,
        SSB_Index,
        SSID,
        _StartTimeAndDuration_startTime,
        _StartTimeAndDuration_duration,
        ____StartTimeAndDuration_iE_Extensions__item__id_tab,
        ___StartTimeAndDuration_iE_Extensions__item__id,
        ____StartTimeAndDuration_iE_Extensions__item__criticality_tab,
        ___StartTimeAndDuration_iE_Extensions__item__criticality,
        ____StartTimeAndDuration_iE_Extensions__item__extensionValue_tab,
        ___StartTimeAndDuration_iE_Extensions__item__extensionValue,
        __StartTimeAndDuration_iE_Extensions__item_,
        _StartTimeAndDuration_iE_Extensions,
        StartTimeAndDuration,
        StartTimeAndDuration_ExtIEs,
        SystemFrameNumber,
        __SystemInformation__item__broadcastPeriodicity,
        __SystemInformation__item__posSIBs,
        _____SystemInformation__item__iE_Extensions__item__id_tab,
        ____SystemInformation__item__iE_Extensions__item__id,
        _____SystemInformation__item__iE_Extensions__item__criticality_tab,
        ____SystemInformation__item__iE_Extensions__item__criticality,
        _____SystemInformation__item__iE_Extensions__item__extensionValue_tab,
        ____SystemInformation__item__iE_Extensions__item__extensionValue,
        ___SystemInformation__item__iE_Extensions__item_,
        __SystemInformation__item__iE_Extensions,
        _SystemInformation__item_,
        SystemInformation,
        SystemInformation_ExtIEs,
        TAC,
        _TDD_Config_EUTRA_Item_subframeAssignment,
        ____TDD_Config_EUTRA_Item_iE_Extensions__item__id_tab,
        ___TDD_Config_EUTRA_Item_iE_Extensions__item__id,
        ____TDD_Config_EUTRA_Item_iE_Extensions__item__criticality_tab,
        ___TDD_Config_EUTRA_Item_iE_Extensions__item__criticality,
        ____TDD_Config_EUTRA_Item_iE_Extensions__item__extensionValue_tab,
        ___TDD_Config_EUTRA_Item_iE_Extensions__item__extensionValue,
        __TDD_Config_EUTRA_Item_iE_Extensions__item_,
        _TDD_Config_EUTRA_Item_iE_Extensions,
        TDD_Config_EUTRA_Item,
        TDD_Config_EUTRA_Item_Item_ExtIEs,
        _TRPTEGInformation_rxTx_TEG,
        _TRPTEGInformation_rx_TEG,
        ___TRPTEGInformation_choice_extension_id_tab,
        __TRPTEGInformation_choice_extension_id,
        ___TRPTEGInformation_choice_extension_criticality_tab,
        __TRPTEGInformation_choice_extension_criticality,
        ___TRPTEGInformation_choice_extension_value_tab,
        __TRPTEGInformation_choice_extension_value,
        _TRPTEGInformation_choice_extension,
        TRPTEGInformation,
        TRPTEGInformation_ExtIEs,
        _RxTxTEG_tRP_RxTx_TEGInformation,
        _RxTxTEG_tRP_Tx_TEGInformation,
        ____RxTxTEG_iE_extensions__item__id_tab,
        ___RxTxTEG_iE_extensions__item__id,
        ____RxTxTEG_iE_extensions__item__criticality_tab,
        ___RxTxTEG_iE_extensions__item__criticality,
        ____RxTxTEG_iE_extensions__item__extensionValue_tab,
        ___RxTxTEG_iE_extensions__item__extensionValue,
        __RxTxTEG_iE_extensions__item_,
        _RxTxTEG_iE_extensions,
        RxTxTEG,
        RxTxTEG_ExtIEs,
        _RxTEG_tRP_Rx_TEGInformation,
        _RxTEG_tRP_Tx_TEGInformation,
        ____RxTEG_iE_extensions__item__id_tab,
        ___RxTEG_iE_extensions__item__id,
        ____RxTEG_iE_extensions__item__criticality_tab,
        ___RxTEG_iE_extensions__item__criticality,
        ____RxTEG_iE_extensions__item__extensionValue_tab,
        ___RxTEG_iE_extensions__item__extensionValue,
        __RxTEG_iE_extensions__item_,
        _RxTEG_iE_extensions,
        RxTEG,
        RxTEG_ExtIEs,
        TimingErrorMargin,
        _TF_Configuration_sSB_frequency,
        _TF_Configuration_sSB_subcarrier_spacing,
        _TF_Configuration_sSB_Transmit_power,
        _TF_Configuration_sSB_periodicity,
        _TF_Configuration_sSB_half_frame_offset,
        _TF_Configuration_sSB_SFN_offset,
        _TF_Configuration_sSB_BurstPosition,
        _TF_Configuration_sFN_initialisation_time,
        ____TF_Configuration_iE_Extensions__item__id_tab,
        ___TF_Configuration_iE_Extensions__item__id,
        ____TF_Configuration_iE_Extensions__item__criticality_tab,
        ___TF_Configuration_iE_Extensions__item__criticality,
        ____TF_Configuration_iE_Extensions__item__extensionValue_tab,
        ___TF_Configuration_iE_Extensions__item__extensionValue,
        __TF_Configuration_iE_Extensions__item_,
        _TF_Configuration_iE_Extensions,
        TF_Configuration,
        TF_Configuration_ExtIEs,
        _TimeStamp_systemFrameNumber,
        _TimeStamp_slotIndex,
        _TimeStamp_measurementTime,
        ____TimeStamp_iE_Extension__item__id_tab,
        ___TimeStamp_iE_Extension__item__id,
        ____TimeStamp_iE_Extension__item__criticality_tab,
        ___TimeStamp_iE_Extension__item__criticality,
        ____TimeStamp_iE_Extension__item__extensionValue_tab,
        ___TimeStamp_iE_Extension__item__extensionValue,
        __TimeStamp_iE_Extension__item_,
        _TimeStamp_iE_Extension,
        TimeStamp,
        TimeStamp_ExtIEs,
        _TimeStampSlotIndex_sCS_15,
        _TimeStampSlotIndex_sCS_30,
        _TimeStampSlotIndex_sCS_60,
        _TimeStampSlotIndex_sCS_120,
        ___TimeStampSlotIndex_choice_extension_id_tab,
        __TimeStampSlotIndex_choice_extension_id,
        ___TimeStampSlotIndex_choice_extension_criticality_tab,
        __TimeStampSlotIndex_choice_extension_criticality,
        ___TimeStampSlotIndex_choice_extension_value_tab,
        __TimeStampSlotIndex_choice_extension_value,
        _TimeStampSlotIndex_choice_extension,
        TimeStampSlotIndex,
        TimeStampSlotIndex_ExtIEs,
        TP_ID_EUTRA,
        TP_Type_EUTRA,
        __TransmissionComb_n2_combOffset_n2,
        __TransmissionComb_n2_cyclicShift_n2,
        _TransmissionComb_n2,
        __TransmissionComb_n4_combOffset_n4,
        __TransmissionComb_n4_cyclicShift_n4,
        _TransmissionComb_n4,
        ___TransmissionComb_choice_extension_id_tab,
        __TransmissionComb_choice_extension_id,
        ___TransmissionComb_choice_extension_criticality_tab,
        __TransmissionComb_choice_extension_criticality,
        ___TransmissionComb_choice_extension_value_tab,
        __TransmissionComb_choice_extension_value,
        _TransmissionComb_choice_extension,
        TransmissionComb,
        TransmissionComb_ExtIEs,
        __TransmissionCombPos_n2_combOffset_n2,
        __TransmissionCombPos_n2_cyclicShift_n2,
        _TransmissionCombPos_n2,
        __TransmissionCombPos_n4_combOffset_n4,
        __TransmissionCombPos_n4_cyclicShift_n4,
        _TransmissionCombPos_n4,
        __TransmissionCombPos_n8_combOffset_n8,
        __TransmissionCombPos_n8_cyclicShift_n8,
        _TransmissionCombPos_n8,
        ___TransmissionCombPos_choice_extension_id_tab,
        __TransmissionCombPos_choice_extension_id,
        ___TransmissionCombPos_choice_extension_criticality_tab,
        __TransmissionCombPos_choice_extension_criticality,
        ___TransmissionCombPos_choice_extension_value_tab,
        __TransmissionCombPos_choice_extension_value,
        _TransmissionCombPos_choice_extension,
        TransmissionCombPos,
        TransmissionCombPos_ExtIEs,
        _TRPBeamAntennaInformation_choice_TRP_Beam_Antenna_Info_Item,
        ____TRPBeamAntennaInformation_iE_Extensions__item__id_tab,
        ___TRPBeamAntennaInformation_iE_Extensions__item__id,
        ____TRPBeamAntennaInformation_iE_Extensions__item__criticality_tab,
        ___TRPBeamAntennaInformation_iE_Extensions__item__criticality,
        ____TRPBeamAntennaInformation_iE_Extensions__item__extensionValue_tab,
        ___TRPBeamAntennaInformation_iE_Extensions__item__extensionValue,
        __TRPBeamAntennaInformation_iE_Extensions__item_,
        _TRPBeamAntennaInformation_iE_Extensions,
        TRPBeamAntennaInformation,
        TRPBeamAntennaInformation_ExtIEs,
        _Choice_TRP_Beam_Antenna_Info_Item_reference,
        _Choice_TRP_Beam_Antenna_Info_Item_explicit,
        _Choice_TRP_Beam_Antenna_Info_Item_noChange,
        ___Choice_TRP_Beam_Antenna_Info_Item_choice_extension_id_tab,
        __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_id,
        ___Choice_TRP_Beam_Antenna_Info_Item_choice_extension_criticality_tab,
        __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_criticality,
        ___Choice_TRP_Beam_Antenna_Info_Item_choice_extension_value_tab,
        __Choice_TRP_Beam_Antenna_Info_Item_choice_extension_value,
        _Choice_TRP_Beam_Antenna_Info_Item_choice_extension,
        Choice_TRP_Beam_Antenna_Info_Item,
        Choice_TRP_Beam_Info_Item_ExtIEs,
        _TRP_BeamAntennaExplicitInformation_trp_BeamAntennaAngles,
        _TRP_BeamAntennaExplicitInformation_lcs_to_gcs_translation,
        ____TRP_BeamAntennaExplicitInformation_iE_Extensions__item__id_tab,
        ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__id,
        ____TRP_BeamAntennaExplicitInformation_iE_Extensions__item__criticality_tab,
        ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__criticality,
        ____TRP_BeamAntennaExplicitInformation_iE_Extensions__item__extensionValue_tab,
        ___TRP_BeamAntennaExplicitInformation_iE_Extensions__item__extensionValue,
        __TRP_BeamAntennaExplicitInformation_iE_Extensions__item_,
        _TRP_BeamAntennaExplicitInformation_iE_Extensions,
        TRP_BeamAntennaExplicitInformation,
        TRP_BeamAntennaExplicitInformation_ExtIEs,
        _TRP_BeamAntennaAngles__item_,
        TRP_BeamAntennaAngles,
        _TRP_BeamAntennaAnglesList_Item_trp_azimuth_angle,
        _TRP_BeamAntennaAnglesList_Item_trp_azimuth_angle_fine,
        __TRP_BeamAntennaAnglesList_Item_trp_elevation_angle_list__item_,
        _TRP_BeamAntennaAnglesList_Item_trp_elevation_angle_list,
        ____TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__id_tab,
        ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__id,
        ____TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__criticality_tab,
        ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__criticality,
        ____TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__extensionValue_tab,
        ___TRP_BeamAntennaAnglesList_Item_iE_Extensions__item__extensionValue,
        __TRP_BeamAntennaAnglesList_Item_iE_Extensions__item_,
        _TRP_BeamAntennaAnglesList_Item_iE_Extensions,
        TRP_BeamAntennaAnglesList_Item,
        TRP_BeamAntennaAnglesList_Item_ExtIEs,
        _TRP_ElevationAngleList_Item_trp_elevation_angle,
        _TRP_ElevationAngleList_Item_trp_elevation_angle_fine,
        __TRP_ElevationAngleList_Item_trp_beam_power_list__item_,
        _TRP_ElevationAngleList_Item_trp_beam_power_list,
        ____TRP_ElevationAngleList_Item_iE_Extensions__item__id_tab,
        ___TRP_ElevationAngleList_Item_iE_Extensions__item__id,
        ____TRP_ElevationAngleList_Item_iE_Extensions__item__criticality_tab,
        ___TRP_ElevationAngleList_Item_iE_Extensions__item__criticality,
        ____TRP_ElevationAngleList_Item_iE_Extensions__item__extensionValue_tab,
        ___TRP_ElevationAngleList_Item_iE_Extensions__item__extensionValue,
        __TRP_ElevationAngleList_Item_iE_Extensions__item_,
        _TRP_ElevationAngleList_Item_iE_Extensions,
        TRP_ElevationAngleList_Item,
        TRP_ElevationAngleList_Item_ExtIEs,
        _TRP_Beam_Power_Item_pRSResourceSetID,
        _TRP_Beam_Power_Item_pRSResourceID,
        _TRP_Beam_Power_Item_relativePower,
        _TRP_Beam_Power_Item_relativePowerFine,
        ____TRP_Beam_Power_Item_iE_Extensions__item__id_tab,
        ___TRP_Beam_Power_Item_iE_Extensions__item__id,
        ____TRP_Beam_Power_Item_iE_Extensions__item__criticality_tab,
        ___TRP_Beam_Power_Item_iE_Extensions__item__criticality,
        ____TRP_Beam_Power_Item_iE_Extensions__item__extensionValue_tab,
        ___TRP_Beam_Power_Item_iE_Extensions__item__extensionValue,
        __TRP_Beam_Power_Item_iE_Extensions__item_,
        _TRP_Beam_Power_Item_iE_Extensions,
        TRP_Beam_Power_Item,
        TRP_Beam_Power_Item_ExtIEs,
        _TRPMeasurementQuantities__item_,
        TRPMeasurementQuantities,
        _TRPMeasurementQuantitiesList_Item_tRPMeasurementQuantities_Item,
        _TRPMeasurementQuantitiesList_Item_timingReportingGranularityFactor,
        ____TRPMeasurementQuantitiesList_Item_iE_Extensions__item__id_tab,
        ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__id,
        ____TRPMeasurementQuantitiesList_Item_iE_Extensions__item__criticality_tab,
        ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__criticality,
        ____TRPMeasurementQuantitiesList_Item_iE_Extensions__item__extensionValue_tab,
        ___TRPMeasurementQuantitiesList_Item_iE_Extensions__item__extensionValue,
        __TRPMeasurementQuantitiesList_Item_iE_Extensions__item_,
        _TRPMeasurementQuantitiesList_Item_iE_Extensions,
        TRPMeasurementQuantitiesList_Item,
        TRPMeasurementQuantitiesList_Item_ExtIEs,
        TRPMeasurementQuantities_Item,
        _TrpMeasurementResult__item_,
        TrpMeasurementResult,
        _TrpMeasurementResultItem_measuredResultsValue,
        _TrpMeasurementResultItem_timeStamp,
        _TrpMeasurementResultItem_measurementQuality,
        _TrpMeasurementResultItem_measurementBeamInfo,
        ____TrpMeasurementResultItem_iE_Extensions__item__id_tab,
        _____TrpMeasurementResultItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____TrpMeasurementResultItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____TrpMeasurementResultItem_iE_Extensions__item__id_tab_val_Extension_2,
        ___TrpMeasurementResultItem_iE_Extensions__item__id,
        ___TrpMeasurementResultItem_iE_Extensions__item__criticality,
        ___TrpMeasurementResultItem_iE_Extensions__item__extensionValue,
        __TrpMeasurementResultItem_iE_Extensions__item_,
        _TrpMeasurementResultItem_iE_Extensions,
        TrpMeasurementResultItem,
        TrpMeasurementResultItem_ExtIEs,
        _TrpMeasurementResultItem_ExtIEs_val_Extension_0,
        _TrpMeasurementResultItem_ExtIEs_val_Extension_1,
        _TrpMeasurementResultItem_ExtIEs_val_Extension_2,
        _TrpMeasuredResultsValue_uL_AngleOfArrival,
        _TrpMeasuredResultsValue_uL_SRS_RSRP,
        _TrpMeasuredResultsValue_uL_RTOA,
        _TrpMeasuredResultsValue_gNB_RxTxTimeDiff,
        ___TrpMeasuredResultsValue_choice_extension_id_tab,
        ____TrpMeasuredResultsValue_choice_extension_id_tab_val_Value_0,
        ____TrpMeasuredResultsValue_choice_extension_id_tab_val_Value_1,
        ____TrpMeasuredResultsValue_choice_extension_id_tab_val_Value_2,
        __TrpMeasuredResultsValue_choice_extension_id,
        __TrpMeasuredResultsValue_choice_extension_criticality,
        __TrpMeasuredResultsValue_choice_extension_value,
        _TrpMeasuredResultsValue_choice_extension,
        TrpMeasuredResultsValue,
        TrpMeasuredResultsValue_ExtIEs,
        _TrpMeasuredResultsValue_ExtIEs_val_Value_0,
        _TrpMeasuredResultsValue_ExtIEs_val_Value_1,
        _TrpMeasuredResultsValue_ExtIEs_val_Value_2,
        _TrpMeasurementQuality_timingMeasQuality,
        _TrpMeasurementQuality_angleMeasQuality,
        ___TrpMeasurementQuality_choice_Extension_id_tab,
        __TrpMeasurementQuality_choice_Extension_id,
        ___TrpMeasurementQuality_choice_Extension_criticality_tab,
        __TrpMeasurementQuality_choice_Extension_criticality,
        ___TrpMeasurementQuality_choice_Extension_value_tab,
        __TrpMeasurementQuality_choice_Extension_value,
        _TrpMeasurementQuality_choice_Extension,
        TrpMeasurementQuality,
        TrpMeasurementQuality_ExtIEs,
        _TrpMeasurementTimingQuality_measurementQuality,
        _TrpMeasurementTimingQuality_resolution,
        ____TrpMeasurementTimingQuality_iE_extensions__item__id_tab,
        ___TrpMeasurementTimingQuality_iE_extensions__item__id,
        ____TrpMeasurementTimingQuality_iE_extensions__item__criticality_tab,
        ___TrpMeasurementTimingQuality_iE_extensions__item__criticality,
        ____TrpMeasurementTimingQuality_iE_extensions__item__extensionValue_tab,
        ___TrpMeasurementTimingQuality_iE_extensions__item__extensionValue,
        __TrpMeasurementTimingQuality_iE_extensions__item_,
        _TrpMeasurementTimingQuality_iE_extensions,
        TrpMeasurementTimingQuality,
        TrpMeasurementTimingQuality_ExtIEs,
        _TrpMeasurementAngleQuality_azimuthQuality,
        _TrpMeasurementAngleQuality_zenithQuality,
        _TrpMeasurementAngleQuality_resolution,
        ____TrpMeasurementAngleQuality_iE_extensions__item__id_tab,
        ___TrpMeasurementAngleQuality_iE_extensions__item__id,
        ____TrpMeasurementAngleQuality_iE_extensions__item__criticality_tab,
        ___TrpMeasurementAngleQuality_iE_extensions__item__criticality,
        ____TrpMeasurementAngleQuality_iE_extensions__item__extensionValue_tab,
        ___TrpMeasurementAngleQuality_iE_extensions__item__extensionValue,
        __TrpMeasurementAngleQuality_iE_extensions__item_,
        _TrpMeasurementAngleQuality_iE_extensions,
        TrpMeasurementAngleQuality,
        TrpMeasurementAngleQuality_ExtIEs,
        _TRP_MeasurementRequestList__item_,
        TRP_MeasurementRequestList,
        _TRP_MeasurementRequestItem_tRP_ID,
        _TRP_MeasurementRequestItem_search_window_information,
        ____TRP_MeasurementRequestItem_iE_extensions__item__id_tab,
        _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_0,
        _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_1,
        _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_2,
        _____TRP_MeasurementRequestItem_iE_extensions__item__id_tab_val_Extension_3,
        ___TRP_MeasurementRequestItem_iE_extensions__item__id,
        ___TRP_MeasurementRequestItem_iE_extensions__item__criticality,
        ___TRP_MeasurementRequestItem_iE_extensions__item__extensionValue,
        __TRP_MeasurementRequestItem_iE_extensions__item_,
        _TRP_MeasurementRequestItem_iE_extensions,
        TRP_MeasurementRequestItem,
        TRP_MeasurementRequestItem_ExtIEs,
        _TRP_MeasurementRequestItem_ExtIEs_val_Extension_0,
        _TRP_MeasurementRequestItem_ExtIEs_val_Extension_1,
        _TRP_MeasurementRequestItem_ExtIEs_val_Extension_2,
        _TRP_MeasurementRequestItem_ExtIEs_val_Extension_3,
        _TRP_MeasurementResponseList__item_,
        TRP_MeasurementResponseList,
        _TRP_MeasurementResponseItem_tRP_ID,
        _TRP_MeasurementResponseItem_measurementResult,
        ____TRP_MeasurementResponseItem_iE_extensions__item__id_tab,
        _____TRP_MeasurementResponseItem_iE_extensions__item__id_tab_val_Extension_0,
        ___TRP_MeasurementResponseItem_iE_extensions__item__id,
        ___TRP_MeasurementResponseItem_iE_extensions__item__criticality,
        ___TRP_MeasurementResponseItem_iE_extensions__item__extensionValue,
        __TRP_MeasurementResponseItem_iE_extensions__item_,
        _TRP_MeasurementResponseItem_iE_extensions,
        TRP_MeasurementResponseItem,
        TRP_MeasurementResponseItem_ExtIEs,
        _TRP_MeasurementResponseItem_ExtIEs_val_Extension_0,
        _TRP_MeasurementUpdateList__item_,
        TRP_MeasurementUpdateList,
        _TRP_MeasurementUpdateItem_tRP_ID,
        _TRP_MeasurementUpdateItem_aoA_window_information,
        ____TRP_MeasurementUpdateItem_iE_extensions__item__id_tab,
        _____TRP_MeasurementUpdateItem_iE_extensions__item__id_tab_val_Extension_0,
        _____TRP_MeasurementUpdateItem_iE_extensions__item__id_tab_val_Extension_1,
        ___TRP_MeasurementUpdateItem_iE_extensions__item__id,
        ___TRP_MeasurementUpdateItem_iE_extensions__item__criticality,
        ___TRP_MeasurementUpdateItem_iE_extensions__item__extensionValue,
        __TRP_MeasurementUpdateItem_iE_extensions__item_,
        _TRP_MeasurementUpdateItem_iE_extensions,
        TRP_MeasurementUpdateItem,
        TRP_MeasurementUpdateItem_ExtIEs,
        _TRP_MeasurementUpdateItem_ExtIEs_val_Extension_0,
        _TRP_MeasurementUpdateItem_ExtIEs_val_Extension_1,
        __TRPInformationListTRPResp__item__tRPInformation,
        _____TRPInformationListTRPResp__item__iE_Extensions__item__id_tab,
        ____TRPInformationListTRPResp__item__iE_Extensions__item__id,
        _____TRPInformationListTRPResp__item__iE_Extensions__item__criticality_tab,
        ____TRPInformationListTRPResp__item__iE_Extensions__item__criticality,
        _____TRPInformationListTRPResp__item__iE_Extensions__item__extensionValue_tab,
        ____TRPInformationListTRPResp__item__iE_Extensions__item__extensionValue,
        ___TRPInformationListTRPResp__item__iE_Extensions__item_,
        __TRPInformationListTRPResp__item__iE_Extensions,
        _TRPInformationListTRPResp__item_,
        TRPInformationListTRPResp,
        TRPInformationTRPResp_ExtIEs,
        _TRPInformation_tRP_ID,
        _TRPInformation_tRPInformationTypeResponseList,
        ____TRPInformation_iE_Extensions__item__id_tab,
        ___TRPInformation_iE_Extensions__item__id,
        ____TRPInformation_iE_Extensions__item__criticality_tab,
        ___TRPInformation_iE_Extensions__item__criticality,
        ____TRPInformation_iE_Extensions__item__extensionValue_tab,
        ___TRPInformation_iE_Extensions__item__extensionValue,
        __TRPInformation_iE_Extensions__item_,
        _TRPInformation_iE_Extensions,
        TRPInformation,
        TRPInformation_ExtIEs,
        _TRPInformationTypeResponseList__item_,
        TRPInformationTypeResponseList,
        _TRPInformationTypeResponseItem_pCI_NR,
        _TRPInformationTypeResponseItem_cGI_NR,
        _TRPInformationTypeResponseItem_aRFCN,
        _TRPInformationTypeResponseItem_pRSConfiguration,
        _TRPInformationTypeResponseItem_sSBinformation,
        _TRPInformationTypeResponseItem_sFNInitialisationTime,
        _TRPInformationTypeResponseItem_spatialDirectionInformation,
        _TRPInformationTypeResponseItem_geographicalCoordinates,
        ___TRPInformationTypeResponseItem_choice_extension_id_tab,
        ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_0,
        ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_1,
        ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_2,
        ____TRPInformationTypeResponseItem_choice_extension_id_tab_val_Value_3,
        __TRPInformationTypeResponseItem_choice_extension_id,
        __TRPInformationTypeResponseItem_choice_extension_criticality,
        __TRPInformationTypeResponseItem_choice_extension_value,
        _TRPInformationTypeResponseItem_choice_extension,
        TRPInformationTypeResponseItem,
        TRPInformationTypeResponseItem_ExtIEs,
        _TRPInformationTypeResponseItem_ExtIEs_val_Value_0,
        _TRPInformationTypeResponseItem_ExtIEs_val_Value_1,
        _TRPInformationTypeResponseItem_ExtIEs_val_Value_2,
        _TRPInformationTypeResponseItem_ExtIEs_val_Value_3,
        ___TRPInformationTypeListTRPReq__item__id_tab,
        ____TRPInformationTypeListTRPReq__item__id_tab_val_Value_0,
        __TRPInformationTypeListTRPReq__item__id,
        __TRPInformationTypeListTRPReq__item__criticality,
        __TRPInformationTypeListTRPReq__item__value,
        _TRPInformationTypeListTRPReq__item_,
        TRPInformationTypeListTRPReq,
        TRPInformationTypeItemTRPReq,
        _TRPInformationTypeItemTRPReq_val_Value_0,
        TRPInformationTypeItem,
        _TRPList__item_,
        TRPList,
        _TRPItem_tRP_ID,
        ____TRPItem_iE_Extensions__item__id_tab,
        ___TRPItem_iE_Extensions__item__id,
        ____TRPItem_iE_Extensions__item__criticality_tab,
        ___TRPItem_iE_Extensions__item__criticality,
        ____TRPItem_iE_Extensions__item__extensionValue_tab,
        ___TRPItem_iE_Extensions__item__extensionValue,
        __TRPItem_iE_Extensions__item_,
        _TRPItem_iE_Extensions,
        TRPItem,
        TRPItem_ExtIEs,
        TRP_ID,
        _TRPPositionDefinitionType_direct,
        _TRPPositionDefinitionType_referenced,
        ___TRPPositionDefinitionType_choice_extension_id_tab,
        __TRPPositionDefinitionType_choice_extension_id,
        ___TRPPositionDefinitionType_choice_extension_criticality_tab,
        __TRPPositionDefinitionType_choice_extension_criticality,
        ___TRPPositionDefinitionType_choice_extension_value_tab,
        __TRPPositionDefinitionType_choice_extension_value,
        _TRPPositionDefinitionType_choice_extension,
        TRPPositionDefinitionType,
        TRPPositionDefinitionType_ExtIEs,
        _TRPPositionDirect_accuracy,
        ____TRPPositionDirect_iE_extensions__item__id_tab,
        ___TRPPositionDirect_iE_extensions__item__id,
        ____TRPPositionDirect_iE_extensions__item__criticality_tab,
        ___TRPPositionDirect_iE_extensions__item__criticality,
        ____TRPPositionDirect_iE_extensions__item__extensionValue_tab,
        ___TRPPositionDirect_iE_extensions__item__extensionValue,
        __TRPPositionDirect_iE_extensions__item_,
        _TRPPositionDirect_iE_extensions,
        TRPPositionDirect,
        TRPPositionDirect_ExtIEs,
        _TRPPositionDirectAccuracy_tRPPosition,
        _TRPPositionDirectAccuracy_tRPHAposition,
        ___TRPPositionDirectAccuracy_choice_extension_id_tab,
        __TRPPositionDirectAccuracy_choice_extension_id,
        ___TRPPositionDirectAccuracy_choice_extension_criticality_tab,
        __TRPPositionDirectAccuracy_choice_extension_criticality,
        ___TRPPositionDirectAccuracy_choice_extension_value_tab,
        __TRPPositionDirectAccuracy_choice_extension_value,
        _TRPPositionDirectAccuracy_choice_extension,
        TRPPositionDirectAccuracy,
        TRPPositionDirectAccuracy_ExtIEs,
        _TRPPositionReferenced_referencePoint,
        _TRPPositionReferenced_referencePointType,
        ____TRPPositionReferenced_iE_extensions__item__id_tab,
        ___TRPPositionReferenced_iE_extensions__item__id,
        ____TRPPositionReferenced_iE_extensions__item__criticality_tab,
        ___TRPPositionReferenced_iE_extensions__item__criticality,
        ____TRPPositionReferenced_iE_extensions__item__extensionValue_tab,
        ___TRPPositionReferenced_iE_extensions__item__extensionValue,
        __TRPPositionReferenced_iE_extensions__item_,
        _TRPPositionReferenced_iE_extensions,
        TRPPositionReferenced,
        TRPPositionReferenced_ExtIEs,
        _TRP_PRS_Information_List__item_,
        TRP_PRS_Information_List,
        _TRP_PRS_Information_List_Item_tRP_ID,
        _TRP_PRS_Information_List_Item_nR_PCI,
        _TRP_PRS_Information_List_Item_cGI_NR,
        _TRP_PRS_Information_List_Item_pRSConfiguration,
        ____TRP_PRS_Information_List_Item_iE_Extensions__item__id_tab,
        ___TRP_PRS_Information_List_Item_iE_Extensions__item__id,
        ____TRP_PRS_Information_List_Item_iE_Extensions__item__criticality_tab,
        ___TRP_PRS_Information_List_Item_iE_Extensions__item__criticality,
        ____TRP_PRS_Information_List_Item_iE_Extensions__item__extensionValue_tab,
        ___TRP_PRS_Information_List_Item_iE_Extensions__item__extensionValue,
        __TRP_PRS_Information_List_Item_iE_Extensions__item_,
        _TRP_PRS_Information_List_Item_iE_Extensions,
        TRP_PRS_Information_List_Item,
        TRP_PRS_Information_List_Item_ExtIEs,
        _TRPReferencePointType_tRPPositionRelativeGeodetic,
        _TRPReferencePointType_tRPPositionRelativeCartesian,
        ___TRPReferencePointType_choice_extension_id_tab,
        __TRPReferencePointType_choice_extension_id,
        ___TRPReferencePointType_choice_extension_criticality_tab,
        __TRPReferencePointType_choice_extension_criticality,
        ___TRPReferencePointType_choice_extension_value_tab,
        __TRPReferencePointType_choice_extension_value,
        _TRPReferencePointType_choice_extension,
        TRPReferencePointType,
        TRPReferencePointType_ExtIEs,
        _TRP_Rx_TEGInformation_tRP_Rx_TEGID,
        _TRP_Rx_TEGInformation_tRP_Rx_TimingErrorMargin,
        ____TRP_Rx_TEGInformation_iE_Extensions__item__id_tab,
        ___TRP_Rx_TEGInformation_iE_Extensions__item__id,
        ____TRP_Rx_TEGInformation_iE_Extensions__item__criticality_tab,
        ___TRP_Rx_TEGInformation_iE_Extensions__item__criticality,
        ____TRP_Rx_TEGInformation_iE_Extensions__item__extensionValue_tab,
        ___TRP_Rx_TEGInformation_iE_Extensions__item__extensionValue,
        __TRP_Rx_TEGInformation_iE_Extensions__item_,
        _TRP_Rx_TEGInformation_iE_Extensions,
        TRP_Rx_TEGInformation,
        TRP_Rx_TEGInformation_ExtIEs,
        _TRP_RxTx_TEGInformation_tRP_RxTx_TEGID,
        _TRP_RxTx_TEGInformation_tRP_RxTx_TimingErrorMargin,
        ____TRP_RxTx_TEGInformation_iE_Extensions__item__id_tab,
        ___TRP_RxTx_TEGInformation_iE_Extensions__item__id,
        ____TRP_RxTx_TEGInformation_iE_Extensions__item__criticality_tab,
        ___TRP_RxTx_TEGInformation_iE_Extensions__item__criticality,
        ____TRP_RxTx_TEGInformation_iE_Extensions__item__extensionValue_tab,
        ___TRP_RxTx_TEGInformation_iE_Extensions__item__extensionValue,
        __TRP_RxTx_TEGInformation_iE_Extensions__item_,
        _TRP_RxTx_TEGInformation_iE_Extensions,
        TRP_RxTx_TEGInformation,
        TRP_RxTx_TEGInformation_ExtIEs,
        _TRP_Tx_TEGInformation_tRP_Tx_TEGID,
        _TRP_Tx_TEGInformation_tRP_Tx_TimingErrorMargin,
        ____TRP_Tx_TEGInformation_iE_Extensions__item__id_tab,
        ___TRP_Tx_TEGInformation_iE_Extensions__item__id,
        ____TRP_Tx_TEGInformation_iE_Extensions__item__criticality_tab,
        ___TRP_Tx_TEGInformation_iE_Extensions__item__criticality,
        ____TRP_Tx_TEGInformation_iE_Extensions__item__extensionValue_tab,
        ___TRP_Tx_TEGInformation_iE_Extensions__item__extensionValue,
        __TRP_Tx_TEGInformation_iE_Extensions__item_,
        _TRP_Tx_TEGInformation_iE_Extensions,
        TRP_Tx_TEGInformation,
        TRP_Tx_TEGInformation_ExtIEs,
        _TRPTxTEGAssociation__item_,
        TRPTxTEGAssociation,
        _TRPTEGItem_tRP_Tx_TEGInformation,
        _TRPTEGItem_dl_PRSResourceSetID,
        __TRPTEGItem_dl_PRSResourceID_List__item_,
        _TRPTEGItem_dl_PRSResourceID_List,
        ____TRPTEGItem_iE_Extensions__item__id_tab,
        ___TRPTEGItem_iE_Extensions__item__id,
        ____TRPTEGItem_iE_Extensions__item__criticality_tab,
        ___TRPTEGItem_iE_Extensions__item__criticality,
        ____TRPTEGItem_iE_Extensions__item__extensionValue_tab,
        ___TRPTEGItem_iE_Extensions__item__extensionValue,
        __TRPTEGItem_iE_Extensions__item_,
        _TRPTEGItem_iE_Extensions,
        TRPTEGItem,
        TRPTEGItem_ExtIEs,
        _DLPRSResourceID_Item_dl_PRSResourceID,
        ____DLPRSResourceID_Item_iE_Extensions__item__id_tab,
        ___DLPRSResourceID_Item_iE_Extensions__item__id,
        ____DLPRSResourceID_Item_iE_Extensions__item__criticality_tab,
        ___DLPRSResourceID_Item_iE_Extensions__item__criticality,
        ____DLPRSResourceID_Item_iE_Extensions__item__extensionValue_tab,
        ___DLPRSResourceID_Item_iE_Extensions__item__extensionValue,
        __DLPRSResourceID_Item_iE_Extensions__item_,
        _DLPRSResourceID_Item_iE_Extensions,
        DLPRSResourceID_Item,
        DLPRSResource_Item_ExtIEs,
        TRPType,
        TypeOfError,
        UARFCN,
        UE_Measurement_ID,
        _UEReportingInformation_reportingAmount,
        _UEReportingInformation_reportingInterval,
        ____UEReportingInformation_iE_extensions__item__id_tab,
        ___UEReportingInformation_iE_extensions__item__id,
        ____UEReportingInformation_iE_extensions__item__criticality_tab,
        ___UEReportingInformation_iE_extensions__item__criticality,
        ____UEReportingInformation_iE_extensions__item__extensionValue_tab,
        ___UEReportingInformation_iE_extensions__item__extensionValue,
        __UEReportingInformation_iE_extensions__item_,
        _UEReportingInformation_iE_extensions,
        UEReportingInformation,
        UEReportingInformation_ExtIEs,
        UE_TEG_ReportingPeriodicity,
        _UETxTEGAssociationList__item_,
        UETxTEGAssociationList,
        _UETxTEGAssociationItem_uE_Tx_TEG_ID,
        _UETxTEGAssociationItem_posSRSResourceID_List,
        _UETxTEGAssociationItem_timeStamp,
        _UETxTEGAssociationItem_carrierFreq,
        ____UETxTEGAssociationItem_iE_Extensions__item__id_tab,
        _____UETxTEGAssociationItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___UETxTEGAssociationItem_iE_Extensions__item__id,
        ___UETxTEGAssociationItem_iE_Extensions__item__criticality,
        ___UETxTEGAssociationItem_iE_Extensions__item__extensionValue,
        __UETxTEGAssociationItem_iE_Extensions__item_,
        _UETxTEGAssociationItem_iE_Extensions,
        UETxTEGAssociationItem,
        UETxTEGAssociationItem_ExtIEs,
        _UETxTEGAssociationItem_ExtIEs_val_Extension_0,
        _SRSResourceID_Item_sRSResourceID,
        ____SRSResourceID_Item_iE_Extensions__item__id_tab,
        ___SRSResourceID_Item_iE_Extensions__item__id,
        ____SRSResourceID_Item_iE_Extensions__item__criticality_tab,
        ___SRSResourceID_Item_iE_Extensions__item__criticality,
        ____SRSResourceID_Item_iE_Extensions__item__extensionValue_tab,
        ___SRSResourceID_Item_iE_Extensions__item__extensionValue,
        __SRSResourceID_Item_iE_Extensions__item_,
        _SRSResourceID_Item_iE_Extensions,
        SRSResourceID_Item,
        SRSResourceID_Item_ExtIEs,
        UE_TEG_Info_Request,
        UTRA_EcN0,
        UTRA_RSCP,
        _UL_AoA_azimuthAoA,
        _UL_AoA_zenithAoA,
        _UL_AoA_lCS_to_GCS_Translation,
        ____UL_AoA_iE_extensions__item__id_tab,
        ___UL_AoA_iE_extensions__item__id,
        ____UL_AoA_iE_extensions__item__criticality_tab,
        ___UL_AoA_iE_extensions__item__criticality,
        ____UL_AoA_iE_extensions__item__extensionValue_tab,
        ___UL_AoA_iE_extensions__item__extensionValue,
        __UL_AoA_iE_extensions__item_,
        _UL_AoA_iE_extensions,
        UL_AoA,
        UL_AoA_ExtIEs,
        _UL_RTOAMeasurement_uLRTOAmeas,
        _UL_RTOAMeasurement_additionalPathList,
        ____UL_RTOAMeasurement_iE_extensions__item__id_tab,
        _____UL_RTOAMeasurement_iE_extensions__item__id_tab_val_Extension_0,
        _____UL_RTOAMeasurement_iE_extensions__item__id_tab_val_Extension_1,
        ___UL_RTOAMeasurement_iE_extensions__item__id,
        ___UL_RTOAMeasurement_iE_extensions__item__criticality,
        ___UL_RTOAMeasurement_iE_extensions__item__extensionValue,
        __UL_RTOAMeasurement_iE_extensions__item_,
        _UL_RTOAMeasurement_iE_extensions,
        UL_RTOAMeasurement,
        UL_RTOAMeasurement_ExtIEs,
        _UL_RTOAMeasurement_ExtIEs_val_Extension_0,
        _UL_RTOAMeasurement_ExtIEs_val_Extension_1,
        _ULRTOAMeas_k0,
        _ULRTOAMeas_k1,
        _ULRTOAMeas_k2,
        _ULRTOAMeas_k3,
        _ULRTOAMeas_k4,
        _ULRTOAMeas_k5,
        ___ULRTOAMeas_choice_extension_id_tab,
        __ULRTOAMeas_choice_extension_id,
        ___ULRTOAMeas_choice_extension_criticality_tab,
        __ULRTOAMeas_choice_extension_criticality,
        ___ULRTOAMeas_choice_extension_value_tab,
        __ULRTOAMeas_choice_extension_value,
        _ULRTOAMeas_choice_extension,
        ULRTOAMeas,
        ULRTOAMeas_ExtIEs,
        UL_SRS_RSRP,
        _UL_SRS_RSRPP_firstPathRSRPP,
        ____UL_SRS_RSRPP_iE_extensions__item__id_tab,
        ___UL_SRS_RSRPP_iE_extensions__item__id,
        ____UL_SRS_RSRPP_iE_extensions__item__criticality_tab,
        ___UL_SRS_RSRPP_iE_extensions__item__criticality,
        ____UL_SRS_RSRPP_iE_extensions__item__extensionValue_tab,
        ___UL_SRS_RSRPP_iE_extensions__item__extensionValue,
        __UL_SRS_RSRPP_iE_extensions__item_,
        _UL_SRS_RSRPP_iE_extensions,
        UL_SRS_RSRPP,
        UL_SRS_RSRPP_ExtIEs,
        _UplinkChannelBW_PerSCS_List__item_,
        UplinkChannelBW_PerSCS_List,
        Uncertainty_range_AoA,
        Uncertainty_range_ZoA,
        ValueRSRP_EUTRA,
        ValueRSRQ_EUTRA,
        ValueRSRP_NR,
        ValueRSRQ_NR,
        ___WLANMeasurementQuantities__item__id_tab,
        ____WLANMeasurementQuantities__item__id_tab_val_Value_0,
        __WLANMeasurementQuantities__item__id,
        __WLANMeasurementQuantities__item__criticality,
        __WLANMeasurementQuantities__item__value,
        _WLANMeasurementQuantities__item_,
        WLANMeasurementQuantities,
        WLANMeasurementQuantities_ItemIEs,
        _WLANMeasurementQuantities_ItemIEs_val_Value_0,
        _WLANMeasurementQuantities_Item_wLANMeasurementQuantitiesValue,
        ____WLANMeasurementQuantities_Item_iE_Extensions__item__id_tab,
        ___WLANMeasurementQuantities_Item_iE_Extensions__item__id,
        ____WLANMeasurementQuantities_Item_iE_Extensions__item__criticality_tab,
        ___WLANMeasurementQuantities_Item_iE_Extensions__item__criticality,
        ____WLANMeasurementQuantities_Item_iE_Extensions__item__extensionValue_tab,
        ___WLANMeasurementQuantities_Item_iE_Extensions__item__extensionValue,
        __WLANMeasurementQuantities_Item_iE_Extensions__item_,
        _WLANMeasurementQuantities_Item_iE_Extensions,
        WLANMeasurementQuantities_Item,
        WLANMeasurementQuantitiesValue_ExtIEs,
        WLANMeasurementQuantitiesValue,
        _WLANMeasurementResult__item_,
        WLANMeasurementResult,
        _WLANMeasurementResult_Item_wLAN_RSSI,
        _WLANMeasurementResult_Item_sSID,
        _WLANMeasurementResult_Item_bSSID,
        _WLANMeasurementResult_Item_hESSID,
        _WLANMeasurementResult_Item_operatingClass,
        _WLANMeasurementResult_Item_countryCode,
        _WLANMeasurementResult_Item_wLANChannelList,
        _WLANMeasurementResult_Item_wLANBand,
        ____WLANMeasurementResult_Item_iE_Extensions__item__id_tab,
        ___WLANMeasurementResult_Item_iE_Extensions__item__id,
        ____WLANMeasurementResult_Item_iE_Extensions__item__criticality_tab,
        ___WLANMeasurementResult_Item_iE_Extensions__item__criticality,
        ____WLANMeasurementResult_Item_iE_Extensions__item__extensionValue_tab,
        ___WLANMeasurementResult_Item_iE_Extensions__item__extensionValue,
        __WLANMeasurementResult_Item_iE_Extensions__item_,
        _WLANMeasurementResult_Item_iE_Extensions,
        WLANMeasurementResult_Item,
        WLANMeasurementResult_Item_ExtIEs,
        WLAN_RSSI,
        WLANBand,
        _WLANChannelList__item_,
        WLANChannelList,
        WLANChannel,
        WLANCountryCode,
        WLANOperatingClass,
        _ZoA_zenithAoA,
        _ZoA_lCS_to_GCS_Translation,
        ____ZoA_iE_extensions__item__id_tab,
        ___ZoA_iE_extensions__item__id,
        ____ZoA_iE_extensions__item__criticality_tab,
        ___ZoA_iE_extensions__item__criticality,
        ____ZoA_iE_extensions__item__extensionValue_tab,
        ___ZoA_iE_extensions__item__extensionValue,
        __ZoA_iE_extensions__item_,
        _ZoA_iE_extensions,
        ZoA,
        ZoA_ExtIEs,
    ]

class NRPPA_PDU_Contents:

    _name_  = 'NRPPA-PDU-Contents'
    _oid_   = [0, 4, 0, 0, 22, 3, 4, 1, 1]
    
    _obj_ = [
        'E-CIDMeasurementInitiationRequest',
        'E-CIDMeasurementInitiationRequest-IEs',
        'E-CIDMeasurementInitiationResponse',
        'E-CIDMeasurementInitiationResponse-IEs',
        'E-CIDMeasurementInitiationFailure',
        'E-CIDMeasurementInitiationFailure-IEs',
        'E-CIDMeasurementFailureIndication',
        'E-CIDMeasurementFailureIndication-IEs',
        'E-CIDMeasurementReport',
        'E-CIDMeasurementReport-IEs',
        'E-CIDMeasurementTerminationCommand',
        'E-CIDMeasurementTerminationCommand-IEs',
        'OTDOAInformationRequest',
        'OTDOAInformationRequest-IEs',
        'OTDOA-Information-Type',
        'OTDOA-Information-Type-ItemIEs',
        'OTDOA-Information-Type-Item',
        'OTDOA-Information-Type-ItemExtIEs',
        'OTDOAInformationResponse',
        'OTDOAInformationResponse-IEs',
        'OTDOAInformationFailure',
        'OTDOAInformationFailure-IEs',
        'AssistanceInformationControl',
        'AssistanceInformationControl-IEs',
        'AssistanceInformationFeedback',
        'AssistanceInformationFeedback-IEs',
        'ErrorIndication',
        'ErrorIndication-IEs',
        'PrivateMessage',
        'PrivateMessage-IEs',
        'PositioningInformationRequest',
        'PositioningInformationRequest-IEs',
        'PositioningInformationResponse',
        'PositioningInformationResponse-IEs',
        'PositioningInformationFailure',
        'PositioningInformationFailure-IEs',
        'PositioningInformationUpdate',
        'PositioningInformationUpdate-IEs',
        'MeasurementRequest',
        'MeasurementRequest-IEs',
        'MeasurementResponse',
        'MeasurementResponse-IEs',
        'MeasurementFailure',
        'MeasurementFailure-IEs',
        'MeasurementReport',
        'MeasurementReport-IEs',
        'MeasurementUpdate',
        'MeasurementUpdate-IEs',
        'MeasurementAbort',
        'MeasurementAbort-IEs',
        'MeasurementFailureIndication',
        'MeasurementFailureIndication-IEs',
        'TRPInformationRequest',
        'TRPInformationRequest-IEs',
        'TRPInformationResponse',
        'TRPInformationResponse-IEs',
        'TRPInformationFailure',
        'TRPInformationFailure-IEs',
        'PositioningActivationRequest',
        'PositioningActivationRequestIEs',
        'SRSType',
        'SRSType-ExtIEs',
        'SemipersistentSRS',
        'SemipersistentSRS-ExtIEs',
        'AperiodicSRS',
        'AperiodicSRS-ExtIEs',
        'PositioningActivationResponse',
        'PositioningActivationResponseIEs',
        'PositioningActivationFailure',
        'PositioningActivationFailureIEs',
        'PositioningDeactivation',
        'PositioningDeactivationIEs',
        'PRSConfigurationRequest',
        'PRSConfigurationRequest-IEs',
        'PRSConfigurationResponse',
        'PRSConfigurationResponse-IEs',
        'PRSConfigurationFailure',
        'PRSConfigurationFailure-IEs',
        'MeasurementPreconfigurationRequired',
        'MeasurementPreconfigurationRequired-IEs',
        'MeasurementPreconfigurationConfirm',
        'MeasurementPreconfigurationConfirm-IEs',
        'MeasurementPreconfigurationRefuse',
        'MeasurementPreconfigurationRefuse-IEs',
        'MeasurementActivation',
        'MeasurementActivation-IEs',
        ]
    _type_ = [
        'E-CIDMeasurementInitiationRequest',
        'E-CIDMeasurementInitiationResponse',
        'E-CIDMeasurementInitiationFailure',
        'E-CIDMeasurementFailureIndication',
        'E-CIDMeasurementReport',
        'E-CIDMeasurementTerminationCommand',
        'OTDOAInformationRequest',
        'OTDOA-Information-Type',
        'OTDOA-Information-Type-Item',
        'OTDOAInformationResponse',
        'OTDOAInformationFailure',
        'AssistanceInformationControl',
        'AssistanceInformationFeedback',
        'ErrorIndication',
        'PrivateMessage',
        'PositioningInformationRequest',
        'PositioningInformationResponse',
        'PositioningInformationFailure',
        'PositioningInformationUpdate',
        'MeasurementRequest',
        'MeasurementResponse',
        'MeasurementFailure',
        'MeasurementReport',
        'MeasurementUpdate',
        'MeasurementAbort',
        'MeasurementFailureIndication',
        'TRPInformationRequest',
        'TRPInformationResponse',
        'TRPInformationFailure',
        'PositioningActivationRequest',
        'SRSType',
        'SemipersistentSRS',
        'AperiodicSRS',
        'PositioningActivationResponse',
        'PositioningActivationFailure',
        'PositioningDeactivation',
        'PRSConfigurationRequest',
        'PRSConfigurationResponse',
        'PRSConfigurationFailure',
        'MeasurementPreconfigurationRequired',
        'MeasurementPreconfigurationConfirm',
        'MeasurementPreconfigurationRefuse',
        'MeasurementActivation',
        ]
    _set_ = [
        'E-CIDMeasurementInitiationRequest-IEs',
        'E-CIDMeasurementInitiationResponse-IEs',
        'E-CIDMeasurementInitiationFailure-IEs',
        'E-CIDMeasurementFailureIndication-IEs',
        'E-CIDMeasurementReport-IEs',
        'E-CIDMeasurementTerminationCommand-IEs',
        'OTDOAInformationRequest-IEs',
        'OTDOA-Information-Type-ItemIEs',
        'OTDOA-Information-Type-ItemExtIEs',
        'OTDOAInformationResponse-IEs',
        'OTDOAInformationFailure-IEs',
        'AssistanceInformationControl-IEs',
        'AssistanceInformationFeedback-IEs',
        'ErrorIndication-IEs',
        'PrivateMessage-IEs',
        'PositioningInformationRequest-IEs',
        'PositioningInformationResponse-IEs',
        'PositioningInformationFailure-IEs',
        'PositioningInformationUpdate-IEs',
        'MeasurementRequest-IEs',
        'MeasurementResponse-IEs',
        'MeasurementFailure-IEs',
        'MeasurementReport-IEs',
        'MeasurementUpdate-IEs',
        'MeasurementAbort-IEs',
        'MeasurementFailureIndication-IEs',
        'TRPInformationRequest-IEs',
        'TRPInformationResponse-IEs',
        'TRPInformationFailure-IEs',
        'PositioningActivationRequestIEs',
        'SRSType-ExtIEs',
        'SemipersistentSRS-ExtIEs',
        'AperiodicSRS-ExtIEs',
        'PositioningActivationResponseIEs',
        'PositioningActivationFailureIEs',
        'PositioningDeactivationIEs',
        'PRSConfigurationRequest-IEs',
        'PRSConfigurationResponse-IEs',
        'PRSConfigurationFailure-IEs',
        'MeasurementPreconfigurationRequired-IEs',
        'MeasurementPreconfigurationConfirm-IEs',
        'MeasurementPreconfigurationRefuse-IEs',
        'MeasurementActivation-IEs',
        ]
    _val_ = [
        ]
    _class_ = [
        'E-CIDMeasurementInitiationRequest-IEs',
        'E-CIDMeasurementInitiationResponse-IEs',
        'E-CIDMeasurementInitiationFailure-IEs',
        'E-CIDMeasurementFailureIndication-IEs',
        'E-CIDMeasurementReport-IEs',
        'E-CIDMeasurementTerminationCommand-IEs',
        'OTDOAInformationRequest-IEs',
        'OTDOA-Information-Type-ItemIEs',
        'OTDOA-Information-Type-ItemExtIEs',
        'OTDOAInformationResponse-IEs',
        'OTDOAInformationFailure-IEs',
        'AssistanceInformationControl-IEs',
        'AssistanceInformationFeedback-IEs',
        'ErrorIndication-IEs',
        'PrivateMessage-IEs',
        'PositioningInformationRequest-IEs',
        'PositioningInformationResponse-IEs',
        'PositioningInformationFailure-IEs',
        'PositioningInformationUpdate-IEs',
        'MeasurementRequest-IEs',
        'MeasurementResponse-IEs',
        'MeasurementFailure-IEs',
        'MeasurementReport-IEs',
        'MeasurementUpdate-IEs',
        'MeasurementAbort-IEs',
        'MeasurementFailureIndication-IEs',
        'TRPInformationRequest-IEs',
        'TRPInformationResponse-IEs',
        'TRPInformationFailure-IEs',
        'PositioningActivationRequestIEs',
        'SRSType-ExtIEs',
        'SemipersistentSRS-ExtIEs',
        'AperiodicSRS-ExtIEs',
        'PositioningActivationResponseIEs',
        'PositioningActivationFailureIEs',
        'PositioningDeactivationIEs',
        'PRSConfigurationRequest-IEs',
        'PRSConfigurationResponse-IEs',
        'PRSConfigurationFailure-IEs',
        'MeasurementPreconfigurationRequired-IEs',
        'MeasurementPreconfigurationConfirm-IEs',
        'MeasurementPreconfigurationRefuse-IEs',
        'MeasurementActivation-IEs',
        ]
    _param_ = [
        ]
    
    #-----< E-CIDMeasurementInitiationRequest >-----#
    E_CIDMeasurementInitiationRequest = SEQ(name='E-CIDMeasurementInitiationRequest', mode=MODE_TYPE)
    _E_CIDMeasurementInitiationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __E_CIDMeasurementInitiationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ReportCharacteristics')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementPeriodicity')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementQuantities')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'OtherRATMeasurementQuantities')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'WLANMeasurementQuantities')))
    _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementPeriodicityNR-AoA')))
    ____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'conditional')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 105), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'conditional')])], rr=[], ev=None, er=[])
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__id._const_tab = ____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__id._const_tab_at = None
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab = ____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__value._const_tab = ____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E_CIDMeasurementInitiationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __E_CIDMeasurementInitiationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E_CIDMeasurementInitiationRequest_protocolIEs__item__id),
        ('criticality', ___E_CIDMeasurementInitiationRequest_protocolIEs__item__criticality),
        ('value', ___E_CIDMeasurementInitiationRequest_protocolIEs__item__value),
        ])
    __E_CIDMeasurementInitiationRequest_protocolIEs__item_._ext = None
    _E_CIDMeasurementInitiationRequest_protocolIEs._cont = __E_CIDMeasurementInitiationRequest_protocolIEs__item_
    _E_CIDMeasurementInitiationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_CIDMeasurementInitiationRequest._cont = ASN1Dict([
        ('protocolIEs', _E_CIDMeasurementInitiationRequest_protocolIEs),
        ])
    E_CIDMeasurementInitiationRequest._ext = []
    
    #-----< E-CIDMeasurementInitiationRequest-IEs >-----#
    E_CIDMeasurementInitiationRequest_IEs = CLASS(name='E-CIDMeasurementInitiationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ReportCharacteristics')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementPeriodicity')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementQuantities')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'OtherRATMeasurementQuantities')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'WLANMeasurementQuantities')))
    _E_CIDMeasurementInitiationRequest_IEs_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementPeriodicityNR-AoA')))
    E_CIDMeasurementInitiationRequest_IEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'reject'), ('Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_2), ('presence', 'conditional')]), dict([('id', 5), ('criticality', 'reject'), ('Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 105), ('criticality', 'reject'), ('Value', _E_CIDMeasurementInitiationRequest_IEs_val_Value_6), ('presence', 'conditional')])], rr=[], ev=[], er=[])
    
    #-----< E-CIDMeasurementInitiationResponse >-----#
    E_CIDMeasurementInitiationResponse = SEQ(name='E-CIDMeasurementInitiationResponse', mode=MODE_TYPE)
    _E_CIDMeasurementInitiationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __E_CIDMeasurementInitiationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'E-CID-MeasurementResult')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cell-Portion-ID')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'OtherRATMeasurementResult')))
    _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'WLANMeasurementResult')))
    ____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 14), ('criticality', 'ignore'), ('Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 21), ('criticality', 'ignore'), ('Value', _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__id._const_tab = ____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__id._const_tab_at = None
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab = ____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__value._const_tab = ____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E_CIDMeasurementInitiationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __E_CIDMeasurementInitiationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E_CIDMeasurementInitiationResponse_protocolIEs__item__id),
        ('criticality', ___E_CIDMeasurementInitiationResponse_protocolIEs__item__criticality),
        ('value', ___E_CIDMeasurementInitiationResponse_protocolIEs__item__value),
        ])
    __E_CIDMeasurementInitiationResponse_protocolIEs__item_._ext = None
    _E_CIDMeasurementInitiationResponse_protocolIEs._cont = __E_CIDMeasurementInitiationResponse_protocolIEs__item_
    _E_CIDMeasurementInitiationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_CIDMeasurementInitiationResponse._cont = ASN1Dict([
        ('protocolIEs', _E_CIDMeasurementInitiationResponse_protocolIEs),
        ])
    E_CIDMeasurementInitiationResponse._ext = []
    
    #-----< E-CIDMeasurementInitiationResponse-IEs >-----#
    E_CIDMeasurementInitiationResponse_IEs = CLASS(name='E-CIDMeasurementInitiationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'E-CID-MeasurementResult')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cell-Portion-ID')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'OtherRATMeasurementResult')))
    _E_CIDMeasurementInitiationResponse_IEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'WLANMeasurementResult')))
    E_CIDMeasurementInitiationResponse_IEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 14), ('criticality', 'ignore'), ('Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 21), ('criticality', 'ignore'), ('Value', _E_CIDMeasurementInitiationResponse_IEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-CIDMeasurementInitiationFailure >-----#
    E_CIDMeasurementInitiationFailure = SEQ(name='E-CIDMeasurementInitiationFailure', mode=MODE_TYPE)
    _E_CIDMeasurementInitiationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __E_CIDMeasurementInitiationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__id._const_tab = ____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__id._const_tab_at = None
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab = ____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__value._const_tab = ____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E_CIDMeasurementInitiationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __E_CIDMeasurementInitiationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E_CIDMeasurementInitiationFailure_protocolIEs__item__id),
        ('criticality', ___E_CIDMeasurementInitiationFailure_protocolIEs__item__criticality),
        ('value', ___E_CIDMeasurementInitiationFailure_protocolIEs__item__value),
        ])
    __E_CIDMeasurementInitiationFailure_protocolIEs__item_._ext = None
    _E_CIDMeasurementInitiationFailure_protocolIEs._cont = __E_CIDMeasurementInitiationFailure_protocolIEs__item_
    _E_CIDMeasurementInitiationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_CIDMeasurementInitiationFailure._cont = ASN1Dict([
        ('protocolIEs', _E_CIDMeasurementInitiationFailure_protocolIEs),
        ])
    E_CIDMeasurementInitiationFailure._ext = []
    
    #-----< E-CIDMeasurementInitiationFailure-IEs >-----#
    E_CIDMeasurementInitiationFailure_IEs = CLASS(name='E-CIDMeasurementInitiationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _E_CIDMeasurementInitiationFailure_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _E_CIDMeasurementInitiationFailure_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _E_CIDMeasurementInitiationFailure_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    E_CIDMeasurementInitiationFailure_IEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _E_CIDMeasurementInitiationFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _E_CIDMeasurementInitiationFailure_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _E_CIDMeasurementInitiationFailure_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-CIDMeasurementFailureIndication >-----#
    E_CIDMeasurementFailureIndication = SEQ(name='E-CIDMeasurementFailureIndication', mode=MODE_TYPE)
    _E_CIDMeasurementFailureIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __E_CIDMeasurementFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    ____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__id._const_tab = ____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__criticality._const_tab = ____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__value._const_tab = ____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E_CIDMeasurementFailureIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __E_CIDMeasurementFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E_CIDMeasurementFailureIndication_protocolIEs__item__id),
        ('criticality', ___E_CIDMeasurementFailureIndication_protocolIEs__item__criticality),
        ('value', ___E_CIDMeasurementFailureIndication_protocolIEs__item__value),
        ])
    __E_CIDMeasurementFailureIndication_protocolIEs__item_._ext = None
    _E_CIDMeasurementFailureIndication_protocolIEs._cont = __E_CIDMeasurementFailureIndication_protocolIEs__item_
    _E_CIDMeasurementFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_CIDMeasurementFailureIndication._cont = ASN1Dict([
        ('protocolIEs', _E_CIDMeasurementFailureIndication_protocolIEs),
        ])
    E_CIDMeasurementFailureIndication._ext = []
    
    #-----< E-CIDMeasurementFailureIndication-IEs >-----#
    E_CIDMeasurementFailureIndication_IEs = CLASS(name='E-CIDMeasurementFailureIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _E_CIDMeasurementFailureIndication_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _E_CIDMeasurementFailureIndication_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _E_CIDMeasurementFailureIndication_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    E_CIDMeasurementFailureIndication_IEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _E_CIDMeasurementFailureIndication_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _E_CIDMeasurementFailureIndication_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _E_CIDMeasurementFailureIndication_IEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-CIDMeasurementReport >-----#
    E_CIDMeasurementReport = SEQ(name='E-CIDMeasurementReport', mode=MODE_TYPE)
    _E_CIDMeasurementReport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __E_CIDMeasurementReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___E_CIDMeasurementReport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____E_CIDMeasurementReport_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'E-CID-MeasurementResult')))
    _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cell-Portion-ID')))
    ____E_CIDMeasurementReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 14), ('criticality', 'ignore'), ('Value', _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___E_CIDMeasurementReport_protocolIEs__item__id._const_tab = ____E_CIDMeasurementReport_protocolIEs__item__id_tab
    ___E_CIDMeasurementReport_protocolIEs__item__id._const_tab_at = None
    ___E_CIDMeasurementReport_protocolIEs__item__id._const_tab_id = 'id'
    ___E_CIDMeasurementReport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___E_CIDMeasurementReport_protocolIEs__item__criticality._const_tab = ____E_CIDMeasurementReport_protocolIEs__item__id_tab
    ___E_CIDMeasurementReport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E_CIDMeasurementReport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E_CIDMeasurementReport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___E_CIDMeasurementReport_protocolIEs__item__value._const_tab = ____E_CIDMeasurementReport_protocolIEs__item__id_tab
    ___E_CIDMeasurementReport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E_CIDMeasurementReport_protocolIEs__item__value._const_tab_id = 'Value'
    __E_CIDMeasurementReport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E_CIDMeasurementReport_protocolIEs__item__id),
        ('criticality', ___E_CIDMeasurementReport_protocolIEs__item__criticality),
        ('value', ___E_CIDMeasurementReport_protocolIEs__item__value),
        ])
    __E_CIDMeasurementReport_protocolIEs__item_._ext = None
    _E_CIDMeasurementReport_protocolIEs._cont = __E_CIDMeasurementReport_protocolIEs__item_
    _E_CIDMeasurementReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_CIDMeasurementReport._cont = ASN1Dict([
        ('protocolIEs', _E_CIDMeasurementReport_protocolIEs),
        ])
    E_CIDMeasurementReport._ext = []
    
    #-----< E-CIDMeasurementReport-IEs >-----#
    E_CIDMeasurementReport_IEs = CLASS(name='E-CIDMeasurementReport-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _E_CIDMeasurementReport_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _E_CIDMeasurementReport_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _E_CIDMeasurementReport_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'E-CID-MeasurementResult')))
    _E_CIDMeasurementReport_IEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cell-Portion-ID')))
    E_CIDMeasurementReport_IEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _E_CIDMeasurementReport_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _E_CIDMeasurementReport_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _E_CIDMeasurementReport_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 14), ('criticality', 'ignore'), ('Value', _E_CIDMeasurementReport_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-CIDMeasurementTerminationCommand >-----#
    E_CIDMeasurementTerminationCommand = SEQ(name='E-CIDMeasurementTerminationCommand', mode=MODE_TYPE)
    _E_CIDMeasurementTerminationCommand_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __E_CIDMeasurementTerminationCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    ____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__id._const_tab = ____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__id._const_tab_at = None
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__id._const_tab_id = 'id'
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__criticality._const_tab = ____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__value._const_tab = ____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___E_CIDMeasurementTerminationCommand_protocolIEs__item__value._const_tab_id = 'Value'
    __E_CIDMeasurementTerminationCommand_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___E_CIDMeasurementTerminationCommand_protocolIEs__item__id),
        ('criticality', ___E_CIDMeasurementTerminationCommand_protocolIEs__item__criticality),
        ('value', ___E_CIDMeasurementTerminationCommand_protocolIEs__item__value),
        ])
    __E_CIDMeasurementTerminationCommand_protocolIEs__item_._ext = None
    _E_CIDMeasurementTerminationCommand_protocolIEs._cont = __E_CIDMeasurementTerminationCommand_protocolIEs__item_
    _E_CIDMeasurementTerminationCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_CIDMeasurementTerminationCommand._cont = ASN1Dict([
        ('protocolIEs', _E_CIDMeasurementTerminationCommand_protocolIEs),
        ])
    E_CIDMeasurementTerminationCommand._ext = []
    
    #-----< E-CIDMeasurementTerminationCommand-IEs >-----#
    E_CIDMeasurementTerminationCommand_IEs = CLASS(name='E-CIDMeasurementTerminationCommand-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _E_CIDMeasurementTerminationCommand_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    _E_CIDMeasurementTerminationCommand_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-Measurement-ID')))
    E_CIDMeasurementTerminationCommand_IEs._val = ASN1Set(rv=[dict([('id', 2), ('criticality', 'reject'), ('Value', _E_CIDMeasurementTerminationCommand_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _E_CIDMeasurementTerminationCommand_IEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< OTDOAInformationRequest >-----#
    OTDOAInformationRequest = SEQ(name='OTDOAInformationRequest', mode=MODE_TYPE)
    _OTDOAInformationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __OTDOAInformationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___OTDOAInformationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____OTDOAInformationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____OTDOAInformationRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOA-Information-Type')))
    ____OTDOAInformationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 9), ('criticality', 'reject'), ('Value', _____OTDOAInformationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___OTDOAInformationRequest_protocolIEs__item__id._const_tab = ____OTDOAInformationRequest_protocolIEs__item__id_tab
    ___OTDOAInformationRequest_protocolIEs__item__id._const_tab_at = None
    ___OTDOAInformationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___OTDOAInformationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___OTDOAInformationRequest_protocolIEs__item__criticality._const_tab = ____OTDOAInformationRequest_protocolIEs__item__id_tab
    ___OTDOAInformationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___OTDOAInformationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___OTDOAInformationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___OTDOAInformationRequest_protocolIEs__item__value._const_tab = ____OTDOAInformationRequest_protocolIEs__item__id_tab
    ___OTDOAInformationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___OTDOAInformationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __OTDOAInformationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___OTDOAInformationRequest_protocolIEs__item__id),
        ('criticality', ___OTDOAInformationRequest_protocolIEs__item__criticality),
        ('value', ___OTDOAInformationRequest_protocolIEs__item__value),
        ])
    __OTDOAInformationRequest_protocolIEs__item_._ext = None
    _OTDOAInformationRequest_protocolIEs._cont = __OTDOAInformationRequest_protocolIEs__item_
    _OTDOAInformationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    OTDOAInformationRequest._cont = ASN1Dict([
        ('protocolIEs', _OTDOAInformationRequest_protocolIEs),
        ])
    OTDOAInformationRequest._ext = []
    
    #-----< OTDOAInformationRequest-IEs >-----#
    OTDOAInformationRequest_IEs = CLASS(name='OTDOAInformationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _OTDOAInformationRequest_IEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOA-Information-Type')))
    OTDOAInformationRequest_IEs._val = ASN1Set(rv=[dict([('id', 9), ('criticality', 'reject'), ('Value', _OTDOAInformationRequest_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< OTDOA-Information-Type >-----#
    OTDOA_Information_Type = SEQ_OF(name='OTDOA-Information-Type', mode=MODE_TYPE)
    _OTDOA_Information_Type__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __OTDOA_Information_Type__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___OTDOA_Information_Type__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ____OTDOA_Information_Type__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOA-Information-Type-Item')))
    ___OTDOA_Information_Type__item__id_tab._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', ____OTDOA_Information_Type__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    __OTDOA_Information_Type__item__id._const_tab = ___OTDOA_Information_Type__item__id_tab
    __OTDOA_Information_Type__item__id._const_tab_at = None
    __OTDOA_Information_Type__item__id._const_tab_id = 'id'
    __OTDOA_Information_Type__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    __OTDOA_Information_Type__item__criticality._const_tab = ___OTDOA_Information_Type__item__id_tab
    __OTDOA_Information_Type__item__criticality._const_tab_at = ('..', 'id')
    __OTDOA_Information_Type__item__criticality._const_tab_id = 'criticality'
    __OTDOA_Information_Type__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    __OTDOA_Information_Type__item__value._const_tab = ___OTDOA_Information_Type__item__id_tab
    __OTDOA_Information_Type__item__value._const_tab_at = ('..', 'id')
    __OTDOA_Information_Type__item__value._const_tab_id = 'Value'
    _OTDOA_Information_Type__item_._cont = ASN1Dict([
        ('id', __OTDOA_Information_Type__item__id),
        ('criticality', __OTDOA_Information_Type__item__criticality),
        ('value', __OTDOA_Information_Type__item__value),
        ])
    _OTDOA_Information_Type__item_._ext = None
    OTDOA_Information_Type._cont = _OTDOA_Information_Type__item_
    OTDOA_Information_Type._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    
    #-----< OTDOA-Information-Type-ItemIEs >-----#
    OTDOA_Information_Type_ItemIEs = CLASS(name='OTDOA-Information-Type-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _OTDOA_Information_Type_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOA-Information-Type-Item')))
    OTDOA_Information_Type_ItemIEs._val = ASN1Set(rv=[dict([('id', 10), ('criticality', 'reject'), ('Value', _OTDOA_Information_Type_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< OTDOA-Information-Type-Item >-----#
    OTDOA_Information_Type_Item = SEQ(name='OTDOA-Information-Type-Item', mode=MODE_TYPE)
    _OTDOA_Information_Type_Item_oTDOA_Information_Item = ENUM(name='oTDOA-Information-Item', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'OTDOA-Information-Item')))
    _OTDOA_Information_Type_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __OTDOA_Information_Type_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___OTDOA_Information_Type_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____OTDOA_Information_Type_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____OTDOA_Information_Type_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OTDOA_Information_Type_Item_iE_Extensions__item__id._const_tab = ____OTDOA_Information_Type_Item_iE_Extensions__item__id_tab
    ___OTDOA_Information_Type_Item_iE_Extensions__item__id._const_tab_at = None
    ___OTDOA_Information_Type_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___OTDOA_Information_Type_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____OTDOA_Information_Type_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____OTDOA_Information_Type_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OTDOA_Information_Type_Item_iE_Extensions__item__criticality._const_tab = ____OTDOA_Information_Type_Item_iE_Extensions__item__criticality_tab
    ___OTDOA_Information_Type_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___OTDOA_Information_Type_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___OTDOA_Information_Type_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____OTDOA_Information_Type_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____OTDOA_Information_Type_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OTDOA_Information_Type_Item_iE_Extensions__item__extensionValue._const_tab = ____OTDOA_Information_Type_Item_iE_Extensions__item__extensionValue_tab
    ___OTDOA_Information_Type_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___OTDOA_Information_Type_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __OTDOA_Information_Type_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___OTDOA_Information_Type_Item_iE_Extensions__item__id),
        ('criticality', ___OTDOA_Information_Type_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___OTDOA_Information_Type_Item_iE_Extensions__item__extensionValue),
        ])
    __OTDOA_Information_Type_Item_iE_Extensions__item_._ext = None
    _OTDOA_Information_Type_Item_iE_Extensions._cont = __OTDOA_Information_Type_Item_iE_Extensions__item_
    _OTDOA_Information_Type_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    OTDOA_Information_Type_Item._cont = ASN1Dict([
        ('oTDOA-Information-Item', _OTDOA_Information_Type_Item_oTDOA_Information_Item),
        ('iE-Extensions', _OTDOA_Information_Type_Item_iE_Extensions),
        ])
    OTDOA_Information_Type_Item._ext = []
    
    #-----< OTDOA-Information-Type-ItemExtIEs >-----#
    OTDOA_Information_Type_ItemExtIEs = CLASS(name='OTDOA-Information-Type-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    OTDOA_Information_Type_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< OTDOAInformationResponse >-----#
    OTDOAInformationResponse = SEQ(name='OTDOAInformationResponse', mode=MODE_TYPE)
    _OTDOAInformationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __OTDOAInformationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___OTDOAInformationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____OTDOAInformationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____OTDOAInformationResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'OTDOACells')))
    _____OTDOAInformationResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____OTDOAInformationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 8), ('criticality', 'ignore'), ('Value', _____OTDOAInformationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____OTDOAInformationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___OTDOAInformationResponse_protocolIEs__item__id._const_tab = ____OTDOAInformationResponse_protocolIEs__item__id_tab
    ___OTDOAInformationResponse_protocolIEs__item__id._const_tab_at = None
    ___OTDOAInformationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___OTDOAInformationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___OTDOAInformationResponse_protocolIEs__item__criticality._const_tab = ____OTDOAInformationResponse_protocolIEs__item__id_tab
    ___OTDOAInformationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___OTDOAInformationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___OTDOAInformationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___OTDOAInformationResponse_protocolIEs__item__value._const_tab = ____OTDOAInformationResponse_protocolIEs__item__id_tab
    ___OTDOAInformationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___OTDOAInformationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __OTDOAInformationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___OTDOAInformationResponse_protocolIEs__item__id),
        ('criticality', ___OTDOAInformationResponse_protocolIEs__item__criticality),
        ('value', ___OTDOAInformationResponse_protocolIEs__item__value),
        ])
    __OTDOAInformationResponse_protocolIEs__item_._ext = None
    _OTDOAInformationResponse_protocolIEs._cont = __OTDOAInformationResponse_protocolIEs__item_
    _OTDOAInformationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    OTDOAInformationResponse._cont = ASN1Dict([
        ('protocolIEs', _OTDOAInformationResponse_protocolIEs),
        ])
    OTDOAInformationResponse._ext = []
    
    #-----< OTDOAInformationResponse-IEs >-----#
    OTDOAInformationResponse_IEs = CLASS(name='OTDOAInformationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _OTDOAInformationResponse_IEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'OTDOACells')))
    _OTDOAInformationResponse_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    OTDOAInformationResponse_IEs._val = ASN1Set(rv=[dict([('id', 8), ('criticality', 'ignore'), ('Value', _OTDOAInformationResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _OTDOAInformationResponse_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< OTDOAInformationFailure >-----#
    OTDOAInformationFailure = SEQ(name='OTDOAInformationFailure', mode=MODE_TYPE)
    _OTDOAInformationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __OTDOAInformationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___OTDOAInformationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____OTDOAInformationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____OTDOAInformationFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _____OTDOAInformationFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____OTDOAInformationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____OTDOAInformationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____OTDOAInformationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___OTDOAInformationFailure_protocolIEs__item__id._const_tab = ____OTDOAInformationFailure_protocolIEs__item__id_tab
    ___OTDOAInformationFailure_protocolIEs__item__id._const_tab_at = None
    ___OTDOAInformationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___OTDOAInformationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___OTDOAInformationFailure_protocolIEs__item__criticality._const_tab = ____OTDOAInformationFailure_protocolIEs__item__id_tab
    ___OTDOAInformationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___OTDOAInformationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___OTDOAInformationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___OTDOAInformationFailure_protocolIEs__item__value._const_tab = ____OTDOAInformationFailure_protocolIEs__item__id_tab
    ___OTDOAInformationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___OTDOAInformationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __OTDOAInformationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___OTDOAInformationFailure_protocolIEs__item__id),
        ('criticality', ___OTDOAInformationFailure_protocolIEs__item__criticality),
        ('value', ___OTDOAInformationFailure_protocolIEs__item__value),
        ])
    __OTDOAInformationFailure_protocolIEs__item_._ext = None
    _OTDOAInformationFailure_protocolIEs._cont = __OTDOAInformationFailure_protocolIEs__item_
    _OTDOAInformationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    OTDOAInformationFailure._cont = ASN1Dict([
        ('protocolIEs', _OTDOAInformationFailure_protocolIEs),
        ])
    OTDOAInformationFailure._ext = []
    
    #-----< OTDOAInformationFailure-IEs >-----#
    OTDOAInformationFailure_IEs = CLASS(name='OTDOAInformationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _OTDOAInformationFailure_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _OTDOAInformationFailure_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    OTDOAInformationFailure_IEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _OTDOAInformationFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _OTDOAInformationFailure_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< AssistanceInformationControl >-----#
    AssistanceInformationControl = SEQ(name='AssistanceInformationControl', mode=MODE_TYPE)
    _AssistanceInformationControl_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __AssistanceInformationControl_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___AssistanceInformationControl_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____AssistanceInformationControl_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____AssistanceInformationControl_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Assistance-Information')))
    _____AssistanceInformationControl_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Broadcast')))
    _____AssistanceInformationControl_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PositioningBroadcastCells')))
    ____AssistanceInformationControl_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 23), ('criticality', 'reject'), ('Value', _____AssistanceInformationControl_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 24), ('criticality', 'reject'), ('Value', _____AssistanceInformationControl_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 38), ('criticality', 'reject'), ('Value', _____AssistanceInformationControl_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___AssistanceInformationControl_protocolIEs__item__id._const_tab = ____AssistanceInformationControl_protocolIEs__item__id_tab
    ___AssistanceInformationControl_protocolIEs__item__id._const_tab_at = None
    ___AssistanceInformationControl_protocolIEs__item__id._const_tab_id = 'id'
    ___AssistanceInformationControl_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___AssistanceInformationControl_protocolIEs__item__criticality._const_tab = ____AssistanceInformationControl_protocolIEs__item__id_tab
    ___AssistanceInformationControl_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___AssistanceInformationControl_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___AssistanceInformationControl_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___AssistanceInformationControl_protocolIEs__item__value._const_tab = ____AssistanceInformationControl_protocolIEs__item__id_tab
    ___AssistanceInformationControl_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___AssistanceInformationControl_protocolIEs__item__value._const_tab_id = 'Value'
    __AssistanceInformationControl_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___AssistanceInformationControl_protocolIEs__item__id),
        ('criticality', ___AssistanceInformationControl_protocolIEs__item__criticality),
        ('value', ___AssistanceInformationControl_protocolIEs__item__value),
        ])
    __AssistanceInformationControl_protocolIEs__item_._ext = None
    _AssistanceInformationControl_protocolIEs._cont = __AssistanceInformationControl_protocolIEs__item_
    _AssistanceInformationControl_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    AssistanceInformationControl._cont = ASN1Dict([
        ('protocolIEs', _AssistanceInformationControl_protocolIEs),
        ])
    AssistanceInformationControl._ext = []
    
    #-----< AssistanceInformationControl-IEs >-----#
    AssistanceInformationControl_IEs = CLASS(name='AssistanceInformationControl-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _AssistanceInformationControl_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Assistance-Information')))
    _AssistanceInformationControl_IEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Broadcast')))
    _AssistanceInformationControl_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PositioningBroadcastCells')))
    AssistanceInformationControl_IEs._val = ASN1Set(rv=[dict([('id', 23), ('criticality', 'reject'), ('Value', _AssistanceInformationControl_IEs_val_Value_0), ('presence', 'optional')]), dict([('id', 24), ('criticality', 'reject'), ('Value', _AssistanceInformationControl_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 38), ('criticality', 'reject'), ('Value', _AssistanceInformationControl_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< AssistanceInformationFeedback >-----#
    AssistanceInformationFeedback = SEQ(name='AssistanceInformationFeedback', mode=MODE_TYPE)
    _AssistanceInformationFeedback_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __AssistanceInformationFeedback_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___AssistanceInformationFeedback_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____AssistanceInformationFeedback_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____AssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'AssistanceInformationFailureList')))
    _____AssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PositioningBroadcastCells')))
    _____AssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____AssistanceInformationFeedback_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _____AssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 38), ('criticality', 'reject'), ('Value', _____AssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____AssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___AssistanceInformationFeedback_protocolIEs__item__id._const_tab = ____AssistanceInformationFeedback_protocolIEs__item__id_tab
    ___AssistanceInformationFeedback_protocolIEs__item__id._const_tab_at = None
    ___AssistanceInformationFeedback_protocolIEs__item__id._const_tab_id = 'id'
    ___AssistanceInformationFeedback_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___AssistanceInformationFeedback_protocolIEs__item__criticality._const_tab = ____AssistanceInformationFeedback_protocolIEs__item__id_tab
    ___AssistanceInformationFeedback_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___AssistanceInformationFeedback_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___AssistanceInformationFeedback_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___AssistanceInformationFeedback_protocolIEs__item__value._const_tab = ____AssistanceInformationFeedback_protocolIEs__item__id_tab
    ___AssistanceInformationFeedback_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___AssistanceInformationFeedback_protocolIEs__item__value._const_tab_id = 'Value'
    __AssistanceInformationFeedback_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___AssistanceInformationFeedback_protocolIEs__item__id),
        ('criticality', ___AssistanceInformationFeedback_protocolIEs__item__criticality),
        ('value', ___AssistanceInformationFeedback_protocolIEs__item__value),
        ])
    __AssistanceInformationFeedback_protocolIEs__item_._ext = None
    _AssistanceInformationFeedback_protocolIEs._cont = __AssistanceInformationFeedback_protocolIEs__item_
    _AssistanceInformationFeedback_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    AssistanceInformationFeedback._cont = ASN1Dict([
        ('protocolIEs', _AssistanceInformationFeedback_protocolIEs),
        ])
    AssistanceInformationFeedback._ext = []
    
    #-----< AssistanceInformationFeedback-IEs >-----#
    AssistanceInformationFeedback_IEs = CLASS(name='AssistanceInformationFeedback-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _AssistanceInformationFeedback_IEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'AssistanceInformationFailureList')))
    _AssistanceInformationFeedback_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PositioningBroadcastCells')))
    _AssistanceInformationFeedback_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    AssistanceInformationFeedback_IEs._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'reject'), ('Value', _AssistanceInformationFeedback_IEs_val_Value_0), ('presence', 'optional')]), dict([('id', 38), ('criticality', 'reject'), ('Value', _AssistanceInformationFeedback_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _AssistanceInformationFeedback_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ErrorIndication >-----#
    ErrorIndication = SEQ(name='ErrorIndication', mode=MODE_TYPE)
    _ErrorIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __ErrorIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___ErrorIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____ErrorIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____ErrorIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolIEs__item__id._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__id._const_tab_at = None
    ___ErrorIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___ErrorIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___ErrorIndication_protocolIEs__item__criticality._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ErrorIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___ErrorIndication_protocolIEs__item__value._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __ErrorIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ErrorIndication_protocolIEs__item__id),
        ('criticality', ___ErrorIndication_protocolIEs__item__criticality),
        ('value', ___ErrorIndication_protocolIEs__item__value),
        ])
    __ErrorIndication_protocolIEs__item_._ext = None
    _ErrorIndication_protocolIEs._cont = __ErrorIndication_protocolIEs__item_
    _ErrorIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ErrorIndication._cont = ASN1Dict([
        ('protocolIEs', _ErrorIndication_protocolIEs),
        ])
    ErrorIndication._ext = []
    
    #-----< ErrorIndication-IEs >-----#
    ErrorIndication_IEs = CLASS(name='ErrorIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _ErrorIndication_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _ErrorIndication_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ErrorIndication_IEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _ErrorIndication_IEs_val_Value_0), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _ErrorIndication_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PrivateMessage >-----#
    PrivateMessage = SEQ(name='PrivateMessage', mode=MODE_TYPE)
    _PrivateMessage_privateIEs = SEQ_OF(name='privateIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'PrivateIE-Container')))
    __PrivateMessage_privateIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'PrivateIE-Field')))
    ___PrivateMessage_privateIEs__item__id = CHOICE(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PRIVATE-IES'), ['id']))
    ____PrivateMessage_privateIEs__item__id_tab = CLASS(name='_tab_NRPPA-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__id._const_tab = ____PrivateMessage_privateIEs__item__id_tab
    ___PrivateMessage_privateIEs__item__id._const_tab_at = None
    ___PrivateMessage_privateIEs__item__id._const_tab_id = 'id'
    ___PrivateMessage_privateIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PRIVATE-IES'), ['criticality']))
    ____PrivateMessage_privateIEs__item__criticality_tab = CLASS(name='_tab_NRPPA-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__criticality._const_tab = ____PrivateMessage_privateIEs__item__criticality_tab
    ___PrivateMessage_privateIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PrivateMessage_privateIEs__item__criticality._const_tab_id = 'criticality'
    ___PrivateMessage_privateIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PRIVATE-IES'), ['Value']))
    ____PrivateMessage_privateIEs__item__value_tab = CLASS(name='_tab_NRPPA-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__value._const_tab = ____PrivateMessage_privateIEs__item__value_tab
    ___PrivateMessage_privateIEs__item__value._const_tab_at = ('..', 'id')
    ___PrivateMessage_privateIEs__item__value._const_tab_id = 'Value'
    __PrivateMessage_privateIEs__item_._cont = ASN1Dict([
        ('id', ___PrivateMessage_privateIEs__item__id),
        ('criticality', ___PrivateMessage_privateIEs__item__criticality),
        ('value', ___PrivateMessage_privateIEs__item__value),
        ])
    __PrivateMessage_privateIEs__item_._ext = None
    _PrivateMessage_privateIEs._cont = __PrivateMessage_privateIEs__item_
    _PrivateMessage_privateIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrivateMessage._cont = ASN1Dict([
        ('privateIEs', _PrivateMessage_privateIEs),
        ])
    PrivateMessage._ext = []
    
    #-----< PrivateMessage-IEs >-----#
    PrivateMessage_IEs = CLASS(name='PrivateMessage-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PRIVATE-IES')))
    PrivateMessage_IEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PositioningInformationRequest >-----#
    PositioningInformationRequest = SEQ(name='PositioningInformationRequest', mode=MODE_TYPE)
    _PositioningInformationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __PositioningInformationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___PositioningInformationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____PositioningInformationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'RequestedSRSTransmissionCharacteristics')))
    _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UEReportingInformation')))
    _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-TEG-Info-Request')))
    _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-TEG-ReportingPeriodicity')))
    ____PositioningInformationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 12), ('criticality', 'ignore'), ('Value', _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 73), ('criticality', 'ignore'), ('Value', _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 90), ('criticality', 'ignore'), ('Value', _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 99), ('criticality', 'reject'), ('Value', _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'conditional')])], rr=[], ev=None, er=[])
    ___PositioningInformationRequest_protocolIEs__item__id._const_tab = ____PositioningInformationRequest_protocolIEs__item__id_tab
    ___PositioningInformationRequest_protocolIEs__item__id._const_tab_at = None
    ___PositioningInformationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___PositioningInformationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___PositioningInformationRequest_protocolIEs__item__criticality._const_tab = ____PositioningInformationRequest_protocolIEs__item__id_tab
    ___PositioningInformationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositioningInformationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositioningInformationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___PositioningInformationRequest_protocolIEs__item__value._const_tab = ____PositioningInformationRequest_protocolIEs__item__id_tab
    ___PositioningInformationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositioningInformationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __PositioningInformationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositioningInformationRequest_protocolIEs__item__id),
        ('criticality', ___PositioningInformationRequest_protocolIEs__item__criticality),
        ('value', ___PositioningInformationRequest_protocolIEs__item__value),
        ])
    __PositioningInformationRequest_protocolIEs__item_._ext = None
    _PositioningInformationRequest_protocolIEs._cont = __PositioningInformationRequest_protocolIEs__item_
    _PositioningInformationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningInformationRequest._cont = ASN1Dict([
        ('protocolIEs', _PositioningInformationRequest_protocolIEs),
        ])
    PositioningInformationRequest._ext = []
    
    #-----< PositioningInformationRequest-IEs >-----#
    PositioningInformationRequest_IEs = CLASS(name='PositioningInformationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _PositioningInformationRequest_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'RequestedSRSTransmissionCharacteristics')))
    _PositioningInformationRequest_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UEReportingInformation')))
    _PositioningInformationRequest_IEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-TEG-Info-Request')))
    _PositioningInformationRequest_IEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UE-TEG-ReportingPeriodicity')))
    PositioningInformationRequest_IEs._val = ASN1Set(rv=[dict([('id', 12), ('criticality', 'ignore'), ('Value', _PositioningInformationRequest_IEs_val_Value_0), ('presence', 'optional')]), dict([('id', 73), ('criticality', 'ignore'), ('Value', _PositioningInformationRequest_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 90), ('criticality', 'ignore'), ('Value', _PositioningInformationRequest_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 99), ('criticality', 'reject'), ('Value', _PositioningInformationRequest_IEs_val_Value_3), ('presence', 'conditional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningInformationResponse >-----#
    PositioningInformationResponse = SEQ(name='PositioningInformationResponse', mode=MODE_TYPE)
    _PositioningInformationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __PositioningInformationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___PositioningInformationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____PositioningInformationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSConfiguration')))
    _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'RelativeTime1900')))
    _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UETxTEGAssociationList')))
    ____PositioningInformationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 26), ('criticality', 'ignore'), ('Value', _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 54), ('criticality', 'ignore'), ('Value', _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 81), ('criticality', 'ignore'), ('Value', _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositioningInformationResponse_protocolIEs__item__id._const_tab = ____PositioningInformationResponse_protocolIEs__item__id_tab
    ___PositioningInformationResponse_protocolIEs__item__id._const_tab_at = None
    ___PositioningInformationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___PositioningInformationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___PositioningInformationResponse_protocolIEs__item__criticality._const_tab = ____PositioningInformationResponse_protocolIEs__item__id_tab
    ___PositioningInformationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositioningInformationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositioningInformationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___PositioningInformationResponse_protocolIEs__item__value._const_tab = ____PositioningInformationResponse_protocolIEs__item__id_tab
    ___PositioningInformationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositioningInformationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __PositioningInformationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositioningInformationResponse_protocolIEs__item__id),
        ('criticality', ___PositioningInformationResponse_protocolIEs__item__criticality),
        ('value', ___PositioningInformationResponse_protocolIEs__item__value),
        ])
    __PositioningInformationResponse_protocolIEs__item_._ext = None
    _PositioningInformationResponse_protocolIEs._cont = __PositioningInformationResponse_protocolIEs__item_
    _PositioningInformationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningInformationResponse._cont = ASN1Dict([
        ('protocolIEs', _PositioningInformationResponse_protocolIEs),
        ])
    PositioningInformationResponse._ext = []
    
    #-----< PositioningInformationResponse-IEs >-----#
    PositioningInformationResponse_IEs = CLASS(name='PositioningInformationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _PositioningInformationResponse_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSConfiguration')))
    _PositioningInformationResponse_IEs_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'RelativeTime1900')))
    _PositioningInformationResponse_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    _PositioningInformationResponse_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UETxTEGAssociationList')))
    PositioningInformationResponse_IEs._val = ASN1Set(rv=[dict([('id', 26), ('criticality', 'ignore'), ('Value', _PositioningInformationResponse_IEs_val_Value_0), ('presence', 'optional')]), dict([('id', 54), ('criticality', 'ignore'), ('Value', _PositioningInformationResponse_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _PositioningInformationResponse_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 81), ('criticality', 'ignore'), ('Value', _PositioningInformationResponse_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningInformationFailure >-----#
    PositioningInformationFailure = SEQ(name='PositioningInformationFailure', mode=MODE_TYPE)
    _PositioningInformationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __PositioningInformationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___PositioningInformationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____PositioningInformationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____PositioningInformationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositioningInformationFailure_protocolIEs__item__id._const_tab = ____PositioningInformationFailure_protocolIEs__item__id_tab
    ___PositioningInformationFailure_protocolIEs__item__id._const_tab_at = None
    ___PositioningInformationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___PositioningInformationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___PositioningInformationFailure_protocolIEs__item__criticality._const_tab = ____PositioningInformationFailure_protocolIEs__item__id_tab
    ___PositioningInformationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositioningInformationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositioningInformationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___PositioningInformationFailure_protocolIEs__item__value._const_tab = ____PositioningInformationFailure_protocolIEs__item__id_tab
    ___PositioningInformationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositioningInformationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __PositioningInformationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositioningInformationFailure_protocolIEs__item__id),
        ('criticality', ___PositioningInformationFailure_protocolIEs__item__criticality),
        ('value', ___PositioningInformationFailure_protocolIEs__item__value),
        ])
    __PositioningInformationFailure_protocolIEs__item_._ext = None
    _PositioningInformationFailure_protocolIEs._cont = __PositioningInformationFailure_protocolIEs__item_
    _PositioningInformationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningInformationFailure._cont = ASN1Dict([
        ('protocolIEs', _PositioningInformationFailure_protocolIEs),
        ])
    PositioningInformationFailure._ext = []
    
    #-----< PositioningInformationFailure-IEs >-----#
    PositioningInformationFailure_IEs = CLASS(name='PositioningInformationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _PositioningInformationFailure_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _PositioningInformationFailure_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    PositioningInformationFailure_IEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _PositioningInformationFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _PositioningInformationFailure_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningInformationUpdate >-----#
    PositioningInformationUpdate = SEQ(name='PositioningInformationUpdate', mode=MODE_TYPE)
    _PositioningInformationUpdate_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __PositioningInformationUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___PositioningInformationUpdate_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____PositioningInformationUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSConfiguration')))
    _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'RelativeTime1900')))
    _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UETxTEGAssociationList')))
    _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSTransmissionStatus')))
    ____PositioningInformationUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 26), ('criticality', 'ignore'), ('Value', _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 54), ('criticality', 'ignore'), ('Value', _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 81), ('criticality', 'ignore'), ('Value', _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 106), ('criticality', 'ignore'), ('Value', _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositioningInformationUpdate_protocolIEs__item__id._const_tab = ____PositioningInformationUpdate_protocolIEs__item__id_tab
    ___PositioningInformationUpdate_protocolIEs__item__id._const_tab_at = None
    ___PositioningInformationUpdate_protocolIEs__item__id._const_tab_id = 'id'
    ___PositioningInformationUpdate_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___PositioningInformationUpdate_protocolIEs__item__criticality._const_tab = ____PositioningInformationUpdate_protocolIEs__item__id_tab
    ___PositioningInformationUpdate_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositioningInformationUpdate_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositioningInformationUpdate_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___PositioningInformationUpdate_protocolIEs__item__value._const_tab = ____PositioningInformationUpdate_protocolIEs__item__id_tab
    ___PositioningInformationUpdate_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositioningInformationUpdate_protocolIEs__item__value._const_tab_id = 'Value'
    __PositioningInformationUpdate_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositioningInformationUpdate_protocolIEs__item__id),
        ('criticality', ___PositioningInformationUpdate_protocolIEs__item__criticality),
        ('value', ___PositioningInformationUpdate_protocolIEs__item__value),
        ])
    __PositioningInformationUpdate_protocolIEs__item_._ext = None
    _PositioningInformationUpdate_protocolIEs._cont = __PositioningInformationUpdate_protocolIEs__item_
    _PositioningInformationUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningInformationUpdate._cont = ASN1Dict([
        ('protocolIEs', _PositioningInformationUpdate_protocolIEs),
        ])
    PositioningInformationUpdate._ext = []
    
    #-----< PositioningInformationUpdate-IEs >-----#
    PositioningInformationUpdate_IEs = CLASS(name='PositioningInformationUpdate-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _PositioningInformationUpdate_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSConfiguration')))
    _PositioningInformationUpdate_IEs_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'RelativeTime1900')))
    _PositioningInformationUpdate_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'UETxTEGAssociationList')))
    _PositioningInformationUpdate_IEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSTransmissionStatus')))
    PositioningInformationUpdate_IEs._val = ASN1Set(rv=[dict([('id', 26), ('criticality', 'ignore'), ('Value', _PositioningInformationUpdate_IEs_val_Value_0), ('presence', 'optional')]), dict([('id', 54), ('criticality', 'ignore'), ('Value', _PositioningInformationUpdate_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 81), ('criticality', 'ignore'), ('Value', _PositioningInformationUpdate_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 106), ('criticality', 'ignore'), ('Value', _PositioningInformationUpdate_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MeasurementRequest >-----#
    MeasurementRequest = SEQ(name='MeasurementRequest', mode=MODE_TYPE)
    _MeasurementRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __MeasurementRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___MeasurementRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____MeasurementRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-MeasurementRequestList')))
    _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ReportCharacteristics')))
    _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementPeriodicity')))
    _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPMeasurementQuantities')))
    _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_5 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'RelativeTime1900')))
    _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSConfiguration')))
    _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementBeamInfoRequest')))
    _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SystemFrameNumber')))
    _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SlotNumber')))
    _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementPeriodicityExtended')))
    _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResponseTime')))
    _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_12 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementCharacteristicsRequestIndicator')))
    _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementTimeOccasion')))
    _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_14 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementAmount')))
    ____MeasurementRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'reject'), ('Value', _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'reject'), ('Value', _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'conditional')]), dict([('id', 52), ('criticality', 'reject'), ('Value', _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 54), ('criticality', 'ignore'), ('Value', _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 26), ('criticality', 'ignore'), ('Value', _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 31), ('criticality', 'ignore'), ('Value', _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 49), ('criticality', 'ignore'), ('Value', _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 50), ('criticality', 'ignore'), ('Value', _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 64), ('criticality', 'reject'), ('Value', _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_10), ('presence', 'conditional')]), dict([('id', 72), ('criticality', 'ignore'), ('Value', _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 92), ('criticality', 'ignore'), ('Value', _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_12), ('presence', 'optional')]), dict([('id', 91), ('criticality', 'ignore'), ('Value', _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_13), ('presence', 'optional')]), dict([('id', 95), ('criticality', 'ignore'), ('Value', _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_14), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MeasurementRequest_protocolIEs__item__id._const_tab = ____MeasurementRequest_protocolIEs__item__id_tab
    ___MeasurementRequest_protocolIEs__item__id._const_tab_at = None
    ___MeasurementRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___MeasurementRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___MeasurementRequest_protocolIEs__item__criticality._const_tab = ____MeasurementRequest_protocolIEs__item__id_tab
    ___MeasurementRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MeasurementRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MeasurementRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___MeasurementRequest_protocolIEs__item__value._const_tab = ____MeasurementRequest_protocolIEs__item__id_tab
    ___MeasurementRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MeasurementRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __MeasurementRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MeasurementRequest_protocolIEs__item__id),
        ('criticality', ___MeasurementRequest_protocolIEs__item__criticality),
        ('value', ___MeasurementRequest_protocolIEs__item__value),
        ])
    __MeasurementRequest_protocolIEs__item_._ext = None
    _MeasurementRequest_protocolIEs._cont = __MeasurementRequest_protocolIEs__item_
    _MeasurementRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MeasurementRequest._cont = ASN1Dict([
        ('protocolIEs', _MeasurementRequest_protocolIEs),
        ])
    MeasurementRequest._ext = []
    
    #-----< MeasurementRequest-IEs >-----#
    MeasurementRequest_IEs = CLASS(name='MeasurementRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _MeasurementRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _MeasurementRequest_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-MeasurementRequestList')))
    _MeasurementRequest_IEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ReportCharacteristics')))
    _MeasurementRequest_IEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementPeriodicity')))
    _MeasurementRequest_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPMeasurementQuantities')))
    _MeasurementRequest_IEs_val_Value_5 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'RelativeTime1900')))
    _MeasurementRequest_IEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSConfiguration')))
    _MeasurementRequest_IEs_val_Value_7 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementBeamInfoRequest')))
    _MeasurementRequest_IEs_val_Value_8 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SystemFrameNumber')))
    _MeasurementRequest_IEs_val_Value_9 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SlotNumber')))
    _MeasurementRequest_IEs_val_Value_10 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementPeriodicityExtended')))
    _MeasurementRequest_IEs_val_Value_11 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'ResponseTime')))
    _MeasurementRequest_IEs_val_Value_12 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementCharacteristicsRequestIndicator')))
    _MeasurementRequest_IEs_val_Value_13 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementTimeOccasion')))
    _MeasurementRequest_IEs_val_Value_14 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementAmount')))
    MeasurementRequest_IEs._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'reject'), ('Value', _MeasurementRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 41), ('criticality', 'reject'), ('Value', _MeasurementRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _MeasurementRequest_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'reject'), ('Value', _MeasurementRequest_IEs_val_Value_3), ('presence', 'conditional')]), dict([('id', 52), ('criticality', 'reject'), ('Value', _MeasurementRequest_IEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 54), ('criticality', 'ignore'), ('Value', _MeasurementRequest_IEs_val_Value_5), ('presence', 'optional')]), dict([('id', 26), ('criticality', 'ignore'), ('Value', _MeasurementRequest_IEs_val_Value_6), ('presence', 'optional')]), dict([('id', 31), ('criticality', 'ignore'), ('Value', _MeasurementRequest_IEs_val_Value_7), ('presence', 'optional')]), dict([('id', 49), ('criticality', 'ignore'), ('Value', _MeasurementRequest_IEs_val_Value_8), ('presence', 'optional')]), dict([('id', 50), ('criticality', 'ignore'), ('Value', _MeasurementRequest_IEs_val_Value_9), ('presence', 'optional')]), dict([('id', 64), ('criticality', 'reject'), ('Value', _MeasurementRequest_IEs_val_Value_10), ('presence', 'conditional')]), dict([('id', 72), ('criticality', 'ignore'), ('Value', _MeasurementRequest_IEs_val_Value_11), ('presence', 'optional')]), dict([('id', 92), ('criticality', 'ignore'), ('Value', _MeasurementRequest_IEs_val_Value_12), ('presence', 'optional')]), dict([('id', 91), ('criticality', 'ignore'), ('Value', _MeasurementRequest_IEs_val_Value_13), ('presence', 'optional')]), dict([('id', 95), ('criticality', 'ignore'), ('Value', _MeasurementRequest_IEs_val_Value_14), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MeasurementResponse >-----#
    MeasurementResponse = SEQ(name='MeasurementResponse', mode=MODE_TYPE)
    _MeasurementResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __MeasurementResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___MeasurementResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____MeasurementResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____MeasurementResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _____MeasurementResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _____MeasurementResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-MeasurementResponseList')))
    _____MeasurementResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____MeasurementResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'reject'), ('Value', _____MeasurementResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _____MeasurementResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 42), ('criticality', 'reject'), ('Value', _____MeasurementResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____MeasurementResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MeasurementResponse_protocolIEs__item__id._const_tab = ____MeasurementResponse_protocolIEs__item__id_tab
    ___MeasurementResponse_protocolIEs__item__id._const_tab_at = None
    ___MeasurementResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___MeasurementResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___MeasurementResponse_protocolIEs__item__criticality._const_tab = ____MeasurementResponse_protocolIEs__item__id_tab
    ___MeasurementResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MeasurementResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MeasurementResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___MeasurementResponse_protocolIEs__item__value._const_tab = ____MeasurementResponse_protocolIEs__item__id_tab
    ___MeasurementResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MeasurementResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __MeasurementResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MeasurementResponse_protocolIEs__item__id),
        ('criticality', ___MeasurementResponse_protocolIEs__item__criticality),
        ('value', ___MeasurementResponse_protocolIEs__item__value),
        ])
    __MeasurementResponse_protocolIEs__item_._ext = None
    _MeasurementResponse_protocolIEs._cont = __MeasurementResponse_protocolIEs__item_
    _MeasurementResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MeasurementResponse._cont = ASN1Dict([
        ('protocolIEs', _MeasurementResponse_protocolIEs),
        ])
    MeasurementResponse._ext = []
    
    #-----< MeasurementResponse-IEs >-----#
    MeasurementResponse_IEs = CLASS(name='MeasurementResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _MeasurementResponse_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _MeasurementResponse_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _MeasurementResponse_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-MeasurementResponseList')))
    _MeasurementResponse_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    MeasurementResponse_IEs._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'reject'), ('Value', _MeasurementResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _MeasurementResponse_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 42), ('criticality', 'reject'), ('Value', _MeasurementResponse_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _MeasurementResponse_IEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MeasurementFailure >-----#
    MeasurementFailure = SEQ(name='MeasurementFailure', mode=MODE_TYPE)
    _MeasurementFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __MeasurementFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___MeasurementFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____MeasurementFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____MeasurementFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _____MeasurementFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _____MeasurementFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____MeasurementFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'reject'), ('Value', _____MeasurementFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____MeasurementFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____MeasurementFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MeasurementFailure_protocolIEs__item__id._const_tab = ____MeasurementFailure_protocolIEs__item__id_tab
    ___MeasurementFailure_protocolIEs__item__id._const_tab_at = None
    ___MeasurementFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___MeasurementFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___MeasurementFailure_protocolIEs__item__criticality._const_tab = ____MeasurementFailure_protocolIEs__item__id_tab
    ___MeasurementFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MeasurementFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MeasurementFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___MeasurementFailure_protocolIEs__item__value._const_tab = ____MeasurementFailure_protocolIEs__item__id_tab
    ___MeasurementFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MeasurementFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __MeasurementFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MeasurementFailure_protocolIEs__item__id),
        ('criticality', ___MeasurementFailure_protocolIEs__item__criticality),
        ('value', ___MeasurementFailure_protocolIEs__item__value),
        ])
    __MeasurementFailure_protocolIEs__item_._ext = None
    _MeasurementFailure_protocolIEs._cont = __MeasurementFailure_protocolIEs__item_
    _MeasurementFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MeasurementFailure._cont = ASN1Dict([
        ('protocolIEs', _MeasurementFailure_protocolIEs),
        ])
    MeasurementFailure._ext = []
    
    #-----< MeasurementFailure-IEs >-----#
    MeasurementFailure_IEs = CLASS(name='MeasurementFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _MeasurementFailure_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _MeasurementFailure_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _MeasurementFailure_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    MeasurementFailure_IEs._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'reject'), ('Value', _MeasurementFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _MeasurementFailure_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _MeasurementFailure_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MeasurementReport >-----#
    MeasurementReport = SEQ(name='MeasurementReport', mode=MODE_TYPE)
    _MeasurementReport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __MeasurementReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___MeasurementReport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____MeasurementReport_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____MeasurementReport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _____MeasurementReport_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _____MeasurementReport_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-MeasurementResponseList')))
    ____MeasurementReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'reject'), ('Value', _____MeasurementReport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _____MeasurementReport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 43), ('criticality', 'reject'), ('Value', _____MeasurementReport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MeasurementReport_protocolIEs__item__id._const_tab = ____MeasurementReport_protocolIEs__item__id_tab
    ___MeasurementReport_protocolIEs__item__id._const_tab_at = None
    ___MeasurementReport_protocolIEs__item__id._const_tab_id = 'id'
    ___MeasurementReport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___MeasurementReport_protocolIEs__item__criticality._const_tab = ____MeasurementReport_protocolIEs__item__id_tab
    ___MeasurementReport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MeasurementReport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MeasurementReport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___MeasurementReport_protocolIEs__item__value._const_tab = ____MeasurementReport_protocolIEs__item__id_tab
    ___MeasurementReport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MeasurementReport_protocolIEs__item__value._const_tab_id = 'Value'
    __MeasurementReport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MeasurementReport_protocolIEs__item__id),
        ('criticality', ___MeasurementReport_protocolIEs__item__criticality),
        ('value', ___MeasurementReport_protocolIEs__item__value),
        ])
    __MeasurementReport_protocolIEs__item_._ext = None
    _MeasurementReport_protocolIEs._cont = __MeasurementReport_protocolIEs__item_
    _MeasurementReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MeasurementReport._cont = ASN1Dict([
        ('protocolIEs', _MeasurementReport_protocolIEs),
        ])
    MeasurementReport._ext = []
    
    #-----< MeasurementReport-IEs >-----#
    MeasurementReport_IEs = CLASS(name='MeasurementReport-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _MeasurementReport_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _MeasurementReport_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _MeasurementReport_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-MeasurementResponseList')))
    MeasurementReport_IEs._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'reject'), ('Value', _MeasurementReport_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _MeasurementReport_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 43), ('criticality', 'reject'), ('Value', _MeasurementReport_IEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MeasurementUpdate >-----#
    MeasurementUpdate = SEQ(name='MeasurementUpdate', mode=MODE_TYPE)
    _MeasurementUpdate_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __MeasurementUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___MeasurementUpdate_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____MeasurementUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSConfiguration')))
    _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-MeasurementUpdateList')))
    _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_4 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementCharacteristicsRequestIndicator')))
    _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementTimeOccasion')))
    ____MeasurementUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'reject'), ('Value', _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 26), ('criticality', 'ignore'), ('Value', _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 70), ('criticality', 'reject'), ('Value', _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 92), ('criticality', 'ignore'), ('Value', _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 91), ('criticality', 'ignore'), ('Value', _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MeasurementUpdate_protocolIEs__item__id._const_tab = ____MeasurementUpdate_protocolIEs__item__id_tab
    ___MeasurementUpdate_protocolIEs__item__id._const_tab_at = None
    ___MeasurementUpdate_protocolIEs__item__id._const_tab_id = 'id'
    ___MeasurementUpdate_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___MeasurementUpdate_protocolIEs__item__criticality._const_tab = ____MeasurementUpdate_protocolIEs__item__id_tab
    ___MeasurementUpdate_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MeasurementUpdate_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MeasurementUpdate_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___MeasurementUpdate_protocolIEs__item__value._const_tab = ____MeasurementUpdate_protocolIEs__item__id_tab
    ___MeasurementUpdate_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MeasurementUpdate_protocolIEs__item__value._const_tab_id = 'Value'
    __MeasurementUpdate_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MeasurementUpdate_protocolIEs__item__id),
        ('criticality', ___MeasurementUpdate_protocolIEs__item__criticality),
        ('value', ___MeasurementUpdate_protocolIEs__item__value),
        ])
    __MeasurementUpdate_protocolIEs__item_._ext = None
    _MeasurementUpdate_protocolIEs._cont = __MeasurementUpdate_protocolIEs__item_
    _MeasurementUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MeasurementUpdate._cont = ASN1Dict([
        ('protocolIEs', _MeasurementUpdate_protocolIEs),
        ])
    MeasurementUpdate._ext = []
    
    #-----< MeasurementUpdate-IEs >-----#
    MeasurementUpdate_IEs = CLASS(name='MeasurementUpdate-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _MeasurementUpdate_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _MeasurementUpdate_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _MeasurementUpdate_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SRSConfiguration')))
    _MeasurementUpdate_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-MeasurementUpdateList')))
    _MeasurementUpdate_IEs_val_Value_4 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementCharacteristicsRequestIndicator')))
    _MeasurementUpdate_IEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'MeasurementTimeOccasion')))
    MeasurementUpdate_IEs._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'reject'), ('Value', _MeasurementUpdate_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _MeasurementUpdate_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 26), ('criticality', 'ignore'), ('Value', _MeasurementUpdate_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 70), ('criticality', 'reject'), ('Value', _MeasurementUpdate_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 92), ('criticality', 'ignore'), ('Value', _MeasurementUpdate_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 91), ('criticality', 'ignore'), ('Value', _MeasurementUpdate_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MeasurementAbort >-----#
    MeasurementAbort = SEQ(name='MeasurementAbort', mode=MODE_TYPE)
    _MeasurementAbort_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __MeasurementAbort_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___MeasurementAbort_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____MeasurementAbort_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____MeasurementAbort_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _____MeasurementAbort_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    ____MeasurementAbort_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'reject'), ('Value', _____MeasurementAbort_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _____MeasurementAbort_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MeasurementAbort_protocolIEs__item__id._const_tab = ____MeasurementAbort_protocolIEs__item__id_tab
    ___MeasurementAbort_protocolIEs__item__id._const_tab_at = None
    ___MeasurementAbort_protocolIEs__item__id._const_tab_id = 'id'
    ___MeasurementAbort_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___MeasurementAbort_protocolIEs__item__criticality._const_tab = ____MeasurementAbort_protocolIEs__item__id_tab
    ___MeasurementAbort_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MeasurementAbort_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MeasurementAbort_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___MeasurementAbort_protocolIEs__item__value._const_tab = ____MeasurementAbort_protocolIEs__item__id_tab
    ___MeasurementAbort_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MeasurementAbort_protocolIEs__item__value._const_tab_id = 'Value'
    __MeasurementAbort_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MeasurementAbort_protocolIEs__item__id),
        ('criticality', ___MeasurementAbort_protocolIEs__item__criticality),
        ('value', ___MeasurementAbort_protocolIEs__item__value),
        ])
    __MeasurementAbort_protocolIEs__item_._ext = None
    _MeasurementAbort_protocolIEs._cont = __MeasurementAbort_protocolIEs__item_
    _MeasurementAbort_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MeasurementAbort._cont = ASN1Dict([
        ('protocolIEs', _MeasurementAbort_protocolIEs),
        ])
    MeasurementAbort._ext = []
    
    #-----< MeasurementAbort-IEs >-----#
    MeasurementAbort_IEs = CLASS(name='MeasurementAbort-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _MeasurementAbort_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _MeasurementAbort_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    MeasurementAbort_IEs._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'reject'), ('Value', _MeasurementAbort_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _MeasurementAbort_IEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MeasurementFailureIndication >-----#
    MeasurementFailureIndication = SEQ(name='MeasurementFailureIndication', mode=MODE_TYPE)
    _MeasurementFailureIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __MeasurementFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___MeasurementFailureIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____MeasurementFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____MeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _____MeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _____MeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    ____MeasurementFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'reject'), ('Value', _____MeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _____MeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _____MeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MeasurementFailureIndication_protocolIEs__item__id._const_tab = ____MeasurementFailureIndication_protocolIEs__item__id_tab
    ___MeasurementFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___MeasurementFailureIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___MeasurementFailureIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___MeasurementFailureIndication_protocolIEs__item__criticality._const_tab = ____MeasurementFailureIndication_protocolIEs__item__id_tab
    ___MeasurementFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MeasurementFailureIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MeasurementFailureIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___MeasurementFailureIndication_protocolIEs__item__value._const_tab = ____MeasurementFailureIndication_protocolIEs__item__id_tab
    ___MeasurementFailureIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MeasurementFailureIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __MeasurementFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MeasurementFailureIndication_protocolIEs__item__id),
        ('criticality', ___MeasurementFailureIndication_protocolIEs__item__criticality),
        ('value', ___MeasurementFailureIndication_protocolIEs__item__value),
        ])
    __MeasurementFailureIndication_protocolIEs__item_._ext = None
    _MeasurementFailureIndication_protocolIEs._cont = __MeasurementFailureIndication_protocolIEs__item_
    _MeasurementFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MeasurementFailureIndication._cont = ASN1Dict([
        ('protocolIEs', _MeasurementFailureIndication_protocolIEs),
        ])
    MeasurementFailureIndication._ext = []
    
    #-----< MeasurementFailureIndication-IEs >-----#
    MeasurementFailureIndication_IEs = CLASS(name='MeasurementFailureIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _MeasurementFailureIndication_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _MeasurementFailureIndication_IEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Measurement-ID')))
    _MeasurementFailureIndication_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    MeasurementFailureIndication_IEs._val = ASN1Set(rv=[dict([('id', 39), ('criticality', 'reject'), ('Value', _MeasurementFailureIndication_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 40), ('criticality', 'reject'), ('Value', _MeasurementFailureIndication_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 0), ('criticality', 'ignore'), ('Value', _MeasurementFailureIndication_IEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TRPInformationRequest >-----#
    TRPInformationRequest = SEQ(name='TRPInformationRequest', mode=MODE_TYPE)
    _TRPInformationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __TRPInformationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___TRPInformationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____TRPInformationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPList')))
    _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPInformationTypeListTRPReq')))
    ____TRPInformationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 47), ('criticality', 'ignore'), ('Value', _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 29), ('criticality', 'reject'), ('Value', _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___TRPInformationRequest_protocolIEs__item__id._const_tab = ____TRPInformationRequest_protocolIEs__item__id_tab
    ___TRPInformationRequest_protocolIEs__item__id._const_tab_at = None
    ___TRPInformationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___TRPInformationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___TRPInformationRequest_protocolIEs__item__criticality._const_tab = ____TRPInformationRequest_protocolIEs__item__id_tab
    ___TRPInformationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___TRPInformationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___TRPInformationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___TRPInformationRequest_protocolIEs__item__value._const_tab = ____TRPInformationRequest_protocolIEs__item__id_tab
    ___TRPInformationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___TRPInformationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __TRPInformationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___TRPInformationRequest_protocolIEs__item__id),
        ('criticality', ___TRPInformationRequest_protocolIEs__item__criticality),
        ('value', ___TRPInformationRequest_protocolIEs__item__value),
        ])
    __TRPInformationRequest_protocolIEs__item_._ext = None
    _TRPInformationRequest_protocolIEs._cont = __TRPInformationRequest_protocolIEs__item_
    _TRPInformationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    TRPInformationRequest._cont = ASN1Dict([
        ('protocolIEs', _TRPInformationRequest_protocolIEs),
        ])
    TRPInformationRequest._ext = []
    
    #-----< TRPInformationRequest-IEs >-----#
    TRPInformationRequest_IEs = CLASS(name='TRPInformationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _TRPInformationRequest_IEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPList')))
    _TRPInformationRequest_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPInformationTypeListTRPReq')))
    TRPInformationRequest_IEs._val = ASN1Set(rv=[dict([('id', 47), ('criticality', 'ignore'), ('Value', _TRPInformationRequest_IEs_val_Value_0), ('presence', 'optional')]), dict([('id', 29), ('criticality', 'reject'), ('Value', _TRPInformationRequest_IEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TRPInformationResponse >-----#
    TRPInformationResponse = SEQ(name='TRPInformationResponse', mode=MODE_TYPE)
    _TRPInformationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __TRPInformationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___TRPInformationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____TRPInformationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPInformationListTRPResp')))
    _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____TRPInformationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 30), ('criticality', 'ignore'), ('Value', _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TRPInformationResponse_protocolIEs__item__id._const_tab = ____TRPInformationResponse_protocolIEs__item__id_tab
    ___TRPInformationResponse_protocolIEs__item__id._const_tab_at = None
    ___TRPInformationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___TRPInformationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___TRPInformationResponse_protocolIEs__item__criticality._const_tab = ____TRPInformationResponse_protocolIEs__item__id_tab
    ___TRPInformationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___TRPInformationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___TRPInformationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___TRPInformationResponse_protocolIEs__item__value._const_tab = ____TRPInformationResponse_protocolIEs__item__id_tab
    ___TRPInformationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___TRPInformationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __TRPInformationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___TRPInformationResponse_protocolIEs__item__id),
        ('criticality', ___TRPInformationResponse_protocolIEs__item__criticality),
        ('value', ___TRPInformationResponse_protocolIEs__item__value),
        ])
    __TRPInformationResponse_protocolIEs__item_._ext = None
    _TRPInformationResponse_protocolIEs._cont = __TRPInformationResponse_protocolIEs__item_
    _TRPInformationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    TRPInformationResponse._cont = ASN1Dict([
        ('protocolIEs', _TRPInformationResponse_protocolIEs),
        ])
    TRPInformationResponse._ext = []
    
    #-----< TRPInformationResponse-IEs >-----#
    TRPInformationResponse_IEs = CLASS(name='TRPInformationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _TRPInformationResponse_IEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRPInformationListTRPResp')))
    _TRPInformationResponse_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    TRPInformationResponse_IEs._val = ASN1Set(rv=[dict([('id', 30), ('criticality', 'ignore'), ('Value', _TRPInformationResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _TRPInformationResponse_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TRPInformationFailure >-----#
    TRPInformationFailure = SEQ(name='TRPInformationFailure', mode=MODE_TYPE)
    _TRPInformationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __TRPInformationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___TRPInformationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____TRPInformationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____TRPInformationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TRPInformationFailure_protocolIEs__item__id._const_tab = ____TRPInformationFailure_protocolIEs__item__id_tab
    ___TRPInformationFailure_protocolIEs__item__id._const_tab_at = None
    ___TRPInformationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___TRPInformationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___TRPInformationFailure_protocolIEs__item__criticality._const_tab = ____TRPInformationFailure_protocolIEs__item__id_tab
    ___TRPInformationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___TRPInformationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___TRPInformationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___TRPInformationFailure_protocolIEs__item__value._const_tab = ____TRPInformationFailure_protocolIEs__item__id_tab
    ___TRPInformationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___TRPInformationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __TRPInformationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___TRPInformationFailure_protocolIEs__item__id),
        ('criticality', ___TRPInformationFailure_protocolIEs__item__criticality),
        ('value', ___TRPInformationFailure_protocolIEs__item__value),
        ])
    __TRPInformationFailure_protocolIEs__item_._ext = None
    _TRPInformationFailure_protocolIEs._cont = __TRPInformationFailure_protocolIEs__item_
    _TRPInformationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    TRPInformationFailure._cont = ASN1Dict([
        ('protocolIEs', _TRPInformationFailure_protocolIEs),
        ])
    TRPInformationFailure._ext = []
    
    #-----< TRPInformationFailure-IEs >-----#
    TRPInformationFailure_IEs = CLASS(name='TRPInformationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _TRPInformationFailure_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _TRPInformationFailure_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    TRPInformationFailure_IEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _TRPInformationFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _TRPInformationFailure_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningActivationRequest >-----#
    PositioningActivationRequest = SEQ(name='PositioningActivationRequest', mode=MODE_TYPE)
    _PositioningActivationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __PositioningActivationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___PositioningActivationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____PositioningActivationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'SRSType')))
    _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'RelativeTime1900')))
    ____PositioningActivationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'reject'), ('Value', _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositioningActivationRequest_protocolIEs__item__id._const_tab = ____PositioningActivationRequest_protocolIEs__item__id_tab
    ___PositioningActivationRequest_protocolIEs__item__id._const_tab_at = None
    ___PositioningActivationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___PositioningActivationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___PositioningActivationRequest_protocolIEs__item__criticality._const_tab = ____PositioningActivationRequest_protocolIEs__item__id_tab
    ___PositioningActivationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositioningActivationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositioningActivationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___PositioningActivationRequest_protocolIEs__item__value._const_tab = ____PositioningActivationRequest_protocolIEs__item__id_tab
    ___PositioningActivationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositioningActivationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __PositioningActivationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositioningActivationRequest_protocolIEs__item__id),
        ('criticality', ___PositioningActivationRequest_protocolIEs__item__criticality),
        ('value', ___PositioningActivationRequest_protocolIEs__item__value),
        ])
    __PositioningActivationRequest_protocolIEs__item_._ext = None
    _PositioningActivationRequest_protocolIEs._cont = __PositioningActivationRequest_protocolIEs__item_
    _PositioningActivationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningActivationRequest._cont = ASN1Dict([
        ('protocolIEs', _PositioningActivationRequest_protocolIEs),
        ])
    PositioningActivationRequest._ext = []
    
    #-----< PositioningActivationRequestIEs >-----#
    PositioningActivationRequestIEs = CLASS(name='PositioningActivationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _PositioningActivationRequestIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'SRSType')))
    _PositioningActivationRequestIEs_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'RelativeTime1900')))
    PositioningActivationRequestIEs._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'reject'), ('Value', _PositioningActivationRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 45), ('criticality', 'ignore'), ('Value', _PositioningActivationRequestIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SRSType >-----#
    SRSType = CHOICE(name='SRSType', mode=MODE_TYPE)
    _SRSType_semipersistentSRS = SEQ(name='semipersistentSRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-PDU-Contents', 'SemipersistentSRS')))
    _SRSType_aperiodicSRS = SEQ(name='aperiodicSRS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-PDU-Contents', 'AperiodicSRS')))
    _SRSType_choice_Extension = SEQ(name='choice-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Single-Container')))
    __SRSType_choice_Extension_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ___SRSType_choice_Extension_id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___SRSType_choice_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SRSType_choice_Extension_id._const_tab = ___SRSType_choice_Extension_id_tab
    __SRSType_choice_Extension_id._const_tab_at = None
    __SRSType_choice_Extension_id._const_tab_id = 'id'
    __SRSType_choice_Extension_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___SRSType_choice_Extension_criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___SRSType_choice_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SRSType_choice_Extension_criticality._const_tab = ___SRSType_choice_Extension_criticality_tab
    __SRSType_choice_Extension_criticality._const_tab_at = ('..', 'id')
    __SRSType_choice_Extension_criticality._const_tab_id = 'criticality'
    __SRSType_choice_Extension_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___SRSType_choice_Extension_value_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    ___SRSType_choice_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SRSType_choice_Extension_value._const_tab = ___SRSType_choice_Extension_value_tab
    __SRSType_choice_Extension_value._const_tab_at = ('..', 'id')
    __SRSType_choice_Extension_value._const_tab_id = 'Value'
    _SRSType_choice_Extension._cont = ASN1Dict([
        ('id', __SRSType_choice_Extension_id),
        ('criticality', __SRSType_choice_Extension_criticality),
        ('value', __SRSType_choice_Extension_value),
        ])
    _SRSType_choice_Extension._ext = None
    SRSType._cont = ASN1Dict([
        ('semipersistentSRS', _SRSType_semipersistentSRS),
        ('aperiodicSRS', _SRSType_aperiodicSRS),
        ('choice-Extension', _SRSType_choice_Extension),
        ])
    SRSType._ext = None
    
    #-----< SRSType-ExtIEs >-----#
    SRSType_ExtIEs = CLASS(name='SRSType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    SRSType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SemipersistentSRS >-----#
    SemipersistentSRS = SEQ(name='SemipersistentSRS', mode=MODE_TYPE)
    _SemipersistentSRS_sRSResourceSetID = INT(name='sRSResourceSetID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSResourceSetID')))
    _SemipersistentSRS_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SemipersistentSRS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___SemipersistentSRS_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____SemipersistentSRS_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _____SemipersistentSRS_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SpatialRelationInfo')))
    _____SemipersistentSRS_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SpatialRelationPerSRSResource')))
    ____SemipersistentSRS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 48), ('criticality', 'ignore'), ('Extension', _____SemipersistentSRS_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 63), ('criticality', 'ignore'), ('Extension', _____SemipersistentSRS_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SemipersistentSRS_iE_Extensions__item__id._const_tab = ____SemipersistentSRS_iE_Extensions__item__id_tab
    ___SemipersistentSRS_iE_Extensions__item__id._const_tab_at = None
    ___SemipersistentSRS_iE_Extensions__item__id._const_tab_id = 'id'
    ___SemipersistentSRS_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ___SemipersistentSRS_iE_Extensions__item__criticality._const_tab = ____SemipersistentSRS_iE_Extensions__item__id_tab
    ___SemipersistentSRS_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SemipersistentSRS_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SemipersistentSRS_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ___SemipersistentSRS_iE_Extensions__item__extensionValue._const_tab = ____SemipersistentSRS_iE_Extensions__item__id_tab
    ___SemipersistentSRS_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SemipersistentSRS_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SemipersistentSRS_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SemipersistentSRS_iE_Extensions__item__id),
        ('criticality', ___SemipersistentSRS_iE_Extensions__item__criticality),
        ('extensionValue', ___SemipersistentSRS_iE_Extensions__item__extensionValue),
        ])
    __SemipersistentSRS_iE_Extensions__item_._ext = None
    _SemipersistentSRS_iE_Extensions._cont = __SemipersistentSRS_iE_Extensions__item_
    _SemipersistentSRS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SemipersistentSRS._cont = ASN1Dict([
        ('sRSResourceSetID', _SemipersistentSRS_sRSResourceSetID),
        ('iE-Extensions', _SemipersistentSRS_iE_Extensions),
        ])
    SemipersistentSRS._ext = []
    
    #-----< SemipersistentSRS-ExtIEs >-----#
    SemipersistentSRS_ExtIEs = CLASS(name='SemipersistentSRS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    _SemipersistentSRS_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SpatialRelationInfo')))
    _SemipersistentSRS_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SpatialRelationPerSRSResource')))
    SemipersistentSRS_ExtIEs._val = ASN1Set(rv=[dict([('id', 48), ('criticality', 'ignore'), ('Extension', _SemipersistentSRS_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 63), ('criticality', 'ignore'), ('Extension', _SemipersistentSRS_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< AperiodicSRS >-----#
    AperiodicSRS = SEQ(name='AperiodicSRS', mode=MODE_TYPE)
    _AperiodicSRS_aperiodic = ENUM(name='aperiodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AperiodicSRS_aperiodic._cont = ASN1Dict([('true', 0)])
    _AperiodicSRS_aperiodic._ext = []
    _AperiodicSRS_sRSResourceTrigger = SEQ(name='sRSResourceTrigger', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-IEs', 'SRSResourceTrigger')), opt=True)
    _AperiodicSRS_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AperiodicSRS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolExtensionField')))
    ___AperiodicSRS_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['id']))
    ____AperiodicSRS_iE_Extensions__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____AperiodicSRS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AperiodicSRS_iE_Extensions__item__id._const_tab = ____AperiodicSRS_iE_Extensions__item__id_tab
    ___AperiodicSRS_iE_Extensions__item__id._const_tab_at = None
    ___AperiodicSRS_iE_Extensions__item__id._const_tab_id = 'id'
    ___AperiodicSRS_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['criticality']))
    ____AperiodicSRS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____AperiodicSRS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AperiodicSRS_iE_Extensions__item__criticality._const_tab = ____AperiodicSRS_iE_Extensions__item__criticality_tab
    ___AperiodicSRS_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AperiodicSRS_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AperiodicSRS_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION'), ['Extension']))
    ____AperiodicSRS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_NRPPA-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    ____AperiodicSRS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AperiodicSRS_iE_Extensions__item__extensionValue._const_tab = ____AperiodicSRS_iE_Extensions__item__extensionValue_tab
    ___AperiodicSRS_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AperiodicSRS_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AperiodicSRS_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AperiodicSRS_iE_Extensions__item__id),
        ('criticality', ___AperiodicSRS_iE_Extensions__item__criticality),
        ('extensionValue', ___AperiodicSRS_iE_Extensions__item__extensionValue),
        ])
    __AperiodicSRS_iE_Extensions__item_._ext = None
    _AperiodicSRS_iE_Extensions._cont = __AperiodicSRS_iE_Extensions__item_
    _AperiodicSRS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AperiodicSRS._cont = ASN1Dict([
        ('aperiodic', _AperiodicSRS_aperiodic),
        ('sRSResourceTrigger', _AperiodicSRS_sRSResourceTrigger),
        ('iE-Extensions', _AperiodicSRS_iE_Extensions),
        ])
    AperiodicSRS._ext = []
    
    #-----< AperiodicSRS-ExtIEs >-----#
    AperiodicSRS_ExtIEs = CLASS(name='AperiodicSRS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-EXTENSION')))
    AperiodicSRS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PositioningActivationResponse >-----#
    PositioningActivationResponse = SEQ(name='PositioningActivationResponse', mode=MODE_TYPE)
    _PositioningActivationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __PositioningActivationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___PositioningActivationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____PositioningActivationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SystemFrameNumber')))
    _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SlotNumber')))
    ____PositioningActivationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'ignore'), ('Value', _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 49), ('criticality', 'ignore'), ('Value', _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 50), ('criticality', 'ignore'), ('Value', _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositioningActivationResponse_protocolIEs__item__id._const_tab = ____PositioningActivationResponse_protocolIEs__item__id_tab
    ___PositioningActivationResponse_protocolIEs__item__id._const_tab_at = None
    ___PositioningActivationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___PositioningActivationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___PositioningActivationResponse_protocolIEs__item__criticality._const_tab = ____PositioningActivationResponse_protocolIEs__item__id_tab
    ___PositioningActivationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositioningActivationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositioningActivationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___PositioningActivationResponse_protocolIEs__item__value._const_tab = ____PositioningActivationResponse_protocolIEs__item__id_tab
    ___PositioningActivationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositioningActivationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __PositioningActivationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositioningActivationResponse_protocolIEs__item__id),
        ('criticality', ___PositioningActivationResponse_protocolIEs__item__criticality),
        ('value', ___PositioningActivationResponse_protocolIEs__item__value),
        ])
    __PositioningActivationResponse_protocolIEs__item_._ext = None
    _PositioningActivationResponse_protocolIEs._cont = __PositioningActivationResponse_protocolIEs__item_
    _PositioningActivationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningActivationResponse._cont = ASN1Dict([
        ('protocolIEs', _PositioningActivationResponse_protocolIEs),
        ])
    PositioningActivationResponse._ext = []
    
    #-----< PositioningActivationResponseIEs >-----#
    PositioningActivationResponseIEs = CLASS(name='PositioningActivationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _PositioningActivationResponseIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    _PositioningActivationResponseIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SystemFrameNumber')))
    _PositioningActivationResponseIEs_val_Value_2 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'SlotNumber')))
    PositioningActivationResponseIEs._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'ignore'), ('Value', _PositioningActivationResponseIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 49), ('criticality', 'ignore'), ('Value', _PositioningActivationResponseIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 50), ('criticality', 'ignore'), ('Value', _PositioningActivationResponseIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningActivationFailure >-----#
    PositioningActivationFailure = SEQ(name='PositioningActivationFailure', mode=MODE_TYPE)
    _PositioningActivationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __PositioningActivationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___PositioningActivationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____PositioningActivationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____PositioningActivationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositioningActivationFailure_protocolIEs__item__id._const_tab = ____PositioningActivationFailure_protocolIEs__item__id_tab
    ___PositioningActivationFailure_protocolIEs__item__id._const_tab_at = None
    ___PositioningActivationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___PositioningActivationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___PositioningActivationFailure_protocolIEs__item__criticality._const_tab = ____PositioningActivationFailure_protocolIEs__item__id_tab
    ___PositioningActivationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositioningActivationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositioningActivationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___PositioningActivationFailure_protocolIEs__item__value._const_tab = ____PositioningActivationFailure_protocolIEs__item__id_tab
    ___PositioningActivationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositioningActivationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __PositioningActivationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositioningActivationFailure_protocolIEs__item__id),
        ('criticality', ___PositioningActivationFailure_protocolIEs__item__criticality),
        ('value', ___PositioningActivationFailure_protocolIEs__item__value),
        ])
    __PositioningActivationFailure_protocolIEs__item_._ext = None
    _PositioningActivationFailure_protocolIEs._cont = __PositioningActivationFailure_protocolIEs__item_
    _PositioningActivationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningActivationFailure._cont = ASN1Dict([
        ('protocolIEs', _PositioningActivationFailure_protocolIEs),
        ])
    PositioningActivationFailure._ext = []
    
    #-----< PositioningActivationFailureIEs >-----#
    PositioningActivationFailureIEs = CLASS(name='PositioningActivationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _PositioningActivationFailureIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _PositioningActivationFailureIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    PositioningActivationFailureIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _PositioningActivationFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _PositioningActivationFailureIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositioningDeactivation >-----#
    PositioningDeactivation = SEQ(name='PositioningDeactivation', mode=MODE_TYPE)
    _PositioningDeactivation_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __PositioningDeactivation_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___PositioningDeactivation_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____PositioningDeactivation_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____PositioningDeactivation_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'AbortTransmission')))
    ____PositioningDeactivation_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 53), ('criticality', 'ignore'), ('Value', _____PositioningDeactivation_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___PositioningDeactivation_protocolIEs__item__id._const_tab = ____PositioningDeactivation_protocolIEs__item__id_tab
    ___PositioningDeactivation_protocolIEs__item__id._const_tab_at = None
    ___PositioningDeactivation_protocolIEs__item__id._const_tab_id = 'id'
    ___PositioningDeactivation_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___PositioningDeactivation_protocolIEs__item__criticality._const_tab = ____PositioningDeactivation_protocolIEs__item__id_tab
    ___PositioningDeactivation_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositioningDeactivation_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositioningDeactivation_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___PositioningDeactivation_protocolIEs__item__value._const_tab = ____PositioningDeactivation_protocolIEs__item__id_tab
    ___PositioningDeactivation_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositioningDeactivation_protocolIEs__item__value._const_tab_id = 'Value'
    __PositioningDeactivation_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositioningDeactivation_protocolIEs__item__id),
        ('criticality', ___PositioningDeactivation_protocolIEs__item__criticality),
        ('value', ___PositioningDeactivation_protocolIEs__item__value),
        ])
    __PositioningDeactivation_protocolIEs__item_._ext = None
    _PositioningDeactivation_protocolIEs._cont = __PositioningDeactivation_protocolIEs__item_
    _PositioningDeactivation_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PositioningDeactivation._cont = ASN1Dict([
        ('protocolIEs', _PositioningDeactivation_protocolIEs),
        ])
    PositioningDeactivation._ext = []
    
    #-----< PositioningDeactivationIEs >-----#
    PositioningDeactivationIEs = CLASS(name='PositioningDeactivationIEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _PositioningDeactivationIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'AbortTransmission')))
    PositioningDeactivationIEs._val = ASN1Set(rv=[dict([('id', 53), ('criticality', 'ignore'), ('Value', _PositioningDeactivationIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PRSConfigurationRequest >-----#
    PRSConfigurationRequest = SEQ(name='PRSConfigurationRequest', mode=MODE_TYPE)
    _PRSConfigurationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __PRSConfigurationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___PRSConfigurationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____PRSConfigurationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____PRSConfigurationRequest_protocolIEs__item__id_tab_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PRSConfigRequestType')))
    _____PRSConfigurationRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PRSTRPList')))
    ____PRSConfigurationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 89), ('criticality', 'reject'), ('Value', _____PRSConfigurationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 66), ('criticality', 'ignore'), ('Value', _____PRSConfigurationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___PRSConfigurationRequest_protocolIEs__item__id._const_tab = ____PRSConfigurationRequest_protocolIEs__item__id_tab
    ___PRSConfigurationRequest_protocolIEs__item__id._const_tab_at = None
    ___PRSConfigurationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___PRSConfigurationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___PRSConfigurationRequest_protocolIEs__item__criticality._const_tab = ____PRSConfigurationRequest_protocolIEs__item__id_tab
    ___PRSConfigurationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PRSConfigurationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PRSConfigurationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___PRSConfigurationRequest_protocolIEs__item__value._const_tab = ____PRSConfigurationRequest_protocolIEs__item__id_tab
    ___PRSConfigurationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PRSConfigurationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __PRSConfigurationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PRSConfigurationRequest_protocolIEs__item__id),
        ('criticality', ___PRSConfigurationRequest_protocolIEs__item__criticality),
        ('value', ___PRSConfigurationRequest_protocolIEs__item__value),
        ])
    __PRSConfigurationRequest_protocolIEs__item_._ext = None
    _PRSConfigurationRequest_protocolIEs._cont = __PRSConfigurationRequest_protocolIEs__item_
    _PRSConfigurationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PRSConfigurationRequest._cont = ASN1Dict([
        ('protocolIEs', _PRSConfigurationRequest_protocolIEs),
        ])
    PRSConfigurationRequest._ext = []
    
    #-----< PRSConfigurationRequest-IEs >-----#
    PRSConfigurationRequest_IEs = CLASS(name='PRSConfigurationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _PRSConfigurationRequest_IEs_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PRSConfigRequestType')))
    _PRSConfigurationRequest_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PRSTRPList')))
    PRSConfigurationRequest_IEs._val = ASN1Set(rv=[dict([('id', 89), ('criticality', 'reject'), ('Value', _PRSConfigurationRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 66), ('criticality', 'ignore'), ('Value', _PRSConfigurationRequest_IEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PRSConfigurationResponse >-----#
    PRSConfigurationResponse = SEQ(name='PRSConfigurationResponse', mode=MODE_TYPE)
    _PRSConfigurationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __PRSConfigurationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___PRSConfigurationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____PRSConfigurationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____PRSConfigurationResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PRSTransmissionTRPList')))
    _____PRSConfigurationResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____PRSConfigurationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 67), ('criticality', 'ignore'), ('Value', _____PRSConfigurationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____PRSConfigurationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PRSConfigurationResponse_protocolIEs__item__id._const_tab = ____PRSConfigurationResponse_protocolIEs__item__id_tab
    ___PRSConfigurationResponse_protocolIEs__item__id._const_tab_at = None
    ___PRSConfigurationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___PRSConfigurationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___PRSConfigurationResponse_protocolIEs__item__criticality._const_tab = ____PRSConfigurationResponse_protocolIEs__item__id_tab
    ___PRSConfigurationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PRSConfigurationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PRSConfigurationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___PRSConfigurationResponse_protocolIEs__item__value._const_tab = ____PRSConfigurationResponse_protocolIEs__item__id_tab
    ___PRSConfigurationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PRSConfigurationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __PRSConfigurationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PRSConfigurationResponse_protocolIEs__item__id),
        ('criticality', ___PRSConfigurationResponse_protocolIEs__item__criticality),
        ('value', ___PRSConfigurationResponse_protocolIEs__item__value),
        ])
    __PRSConfigurationResponse_protocolIEs__item_._ext = None
    _PRSConfigurationResponse_protocolIEs._cont = __PRSConfigurationResponse_protocolIEs__item_
    _PRSConfigurationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PRSConfigurationResponse._cont = ASN1Dict([
        ('protocolIEs', _PRSConfigurationResponse_protocolIEs),
        ])
    PRSConfigurationResponse._ext = []
    
    #-----< PRSConfigurationResponse-IEs >-----#
    PRSConfigurationResponse_IEs = CLASS(name='PRSConfigurationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _PRSConfigurationResponse_IEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PRSTransmissionTRPList')))
    _PRSConfigurationResponse_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    PRSConfigurationResponse_IEs._val = ASN1Set(rv=[dict([('id', 67), ('criticality', 'ignore'), ('Value', _PRSConfigurationResponse_IEs_val_Value_0), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _PRSConfigurationResponse_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PRSConfigurationFailure >-----#
    PRSConfigurationFailure = SEQ(name='PRSConfigurationFailure', mode=MODE_TYPE)
    _PRSConfigurationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __PRSConfigurationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___PRSConfigurationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____PRSConfigurationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____PRSConfigurationFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _____PRSConfigurationFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____PRSConfigurationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____PRSConfigurationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____PRSConfigurationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PRSConfigurationFailure_protocolIEs__item__id._const_tab = ____PRSConfigurationFailure_protocolIEs__item__id_tab
    ___PRSConfigurationFailure_protocolIEs__item__id._const_tab_at = None
    ___PRSConfigurationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___PRSConfigurationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___PRSConfigurationFailure_protocolIEs__item__criticality._const_tab = ____PRSConfigurationFailure_protocolIEs__item__id_tab
    ___PRSConfigurationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PRSConfigurationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PRSConfigurationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___PRSConfigurationFailure_protocolIEs__item__value._const_tab = ____PRSConfigurationFailure_protocolIEs__item__id_tab
    ___PRSConfigurationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PRSConfigurationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __PRSConfigurationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PRSConfigurationFailure_protocolIEs__item__id),
        ('criticality', ___PRSConfigurationFailure_protocolIEs__item__criticality),
        ('value', ___PRSConfigurationFailure_protocolIEs__item__value),
        ])
    __PRSConfigurationFailure_protocolIEs__item_._ext = None
    _PRSConfigurationFailure_protocolIEs._cont = __PRSConfigurationFailure_protocolIEs__item_
    _PRSConfigurationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PRSConfigurationFailure._cont = ASN1Dict([
        ('protocolIEs', _PRSConfigurationFailure_protocolIEs),
        ])
    PRSConfigurationFailure._ext = []
    
    #-----< PRSConfigurationFailure-IEs >-----#
    PRSConfigurationFailure_IEs = CLASS(name='PRSConfigurationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _PRSConfigurationFailure_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _PRSConfigurationFailure_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    PRSConfigurationFailure_IEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _PRSConfigurationFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _PRSConfigurationFailure_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MeasurementPreconfigurationRequired >-----#
    MeasurementPreconfigurationRequired = SEQ(name='MeasurementPreconfigurationRequired', mode=MODE_TYPE)
    _MeasurementPreconfigurationRequired_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __MeasurementPreconfigurationRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___MeasurementPreconfigurationRequired_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____MeasurementPreconfigurationRequired_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____MeasurementPreconfigurationRequired_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-PRS-Information-List')))
    ____MeasurementPreconfigurationRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 87), ('criticality', 'ignore'), ('Value', _____MeasurementPreconfigurationRequired_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MeasurementPreconfigurationRequired_protocolIEs__item__id._const_tab = ____MeasurementPreconfigurationRequired_protocolIEs__item__id_tab
    ___MeasurementPreconfigurationRequired_protocolIEs__item__id._const_tab_at = None
    ___MeasurementPreconfigurationRequired_protocolIEs__item__id._const_tab_id = 'id'
    ___MeasurementPreconfigurationRequired_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___MeasurementPreconfigurationRequired_protocolIEs__item__criticality._const_tab = ____MeasurementPreconfigurationRequired_protocolIEs__item__id_tab
    ___MeasurementPreconfigurationRequired_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MeasurementPreconfigurationRequired_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MeasurementPreconfigurationRequired_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___MeasurementPreconfigurationRequired_protocolIEs__item__value._const_tab = ____MeasurementPreconfigurationRequired_protocolIEs__item__id_tab
    ___MeasurementPreconfigurationRequired_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MeasurementPreconfigurationRequired_protocolIEs__item__value._const_tab_id = 'Value'
    __MeasurementPreconfigurationRequired_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MeasurementPreconfigurationRequired_protocolIEs__item__id),
        ('criticality', ___MeasurementPreconfigurationRequired_protocolIEs__item__criticality),
        ('value', ___MeasurementPreconfigurationRequired_protocolIEs__item__value),
        ])
    __MeasurementPreconfigurationRequired_protocolIEs__item_._ext = None
    _MeasurementPreconfigurationRequired_protocolIEs._cont = __MeasurementPreconfigurationRequired_protocolIEs__item_
    _MeasurementPreconfigurationRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MeasurementPreconfigurationRequired._cont = ASN1Dict([
        ('protocolIEs', _MeasurementPreconfigurationRequired_protocolIEs),
        ])
    MeasurementPreconfigurationRequired._ext = []
    
    #-----< MeasurementPreconfigurationRequired-IEs >-----#
    MeasurementPreconfigurationRequired_IEs = CLASS(name='MeasurementPreconfigurationRequired-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _MeasurementPreconfigurationRequired_IEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'TRP-PRS-Information-List')))
    MeasurementPreconfigurationRequired_IEs._val = ASN1Set(rv=[dict([('id', 87), ('criticality', 'ignore'), ('Value', _MeasurementPreconfigurationRequired_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MeasurementPreconfigurationConfirm >-----#
    MeasurementPreconfigurationConfirm = SEQ(name='MeasurementPreconfigurationConfirm', mode=MODE_TYPE)
    _MeasurementPreconfigurationConfirm_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __MeasurementPreconfigurationConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___MeasurementPreconfigurationConfirm_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PreconfigurationResult')))
    _____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 97), ('criticality', 'ignore'), ('Value', _____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MeasurementPreconfigurationConfirm_protocolIEs__item__id._const_tab = ____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab
    ___MeasurementPreconfigurationConfirm_protocolIEs__item__id._const_tab_at = None
    ___MeasurementPreconfigurationConfirm_protocolIEs__item__id._const_tab_id = 'id'
    ___MeasurementPreconfigurationConfirm_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___MeasurementPreconfigurationConfirm_protocolIEs__item__criticality._const_tab = ____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab
    ___MeasurementPreconfigurationConfirm_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MeasurementPreconfigurationConfirm_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MeasurementPreconfigurationConfirm_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___MeasurementPreconfigurationConfirm_protocolIEs__item__value._const_tab = ____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab
    ___MeasurementPreconfigurationConfirm_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MeasurementPreconfigurationConfirm_protocolIEs__item__value._const_tab_id = 'Value'
    __MeasurementPreconfigurationConfirm_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MeasurementPreconfigurationConfirm_protocolIEs__item__id),
        ('criticality', ___MeasurementPreconfigurationConfirm_protocolIEs__item__criticality),
        ('value', ___MeasurementPreconfigurationConfirm_protocolIEs__item__value),
        ])
    __MeasurementPreconfigurationConfirm_protocolIEs__item_._ext = None
    _MeasurementPreconfigurationConfirm_protocolIEs._cont = __MeasurementPreconfigurationConfirm_protocolIEs__item_
    _MeasurementPreconfigurationConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MeasurementPreconfigurationConfirm._cont = ASN1Dict([
        ('protocolIEs', _MeasurementPreconfigurationConfirm_protocolIEs),
        ])
    MeasurementPreconfigurationConfirm._ext = []
    
    #-----< MeasurementPreconfigurationConfirm-IEs >-----#
    MeasurementPreconfigurationConfirm_IEs = CLASS(name='MeasurementPreconfigurationConfirm-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _MeasurementPreconfigurationConfirm_IEs_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PreconfigurationResult')))
    _MeasurementPreconfigurationConfirm_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    MeasurementPreconfigurationConfirm_IEs._val = ASN1Set(rv=[dict([('id', 97), ('criticality', 'ignore'), ('Value', _MeasurementPreconfigurationConfirm_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _MeasurementPreconfigurationConfirm_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MeasurementPreconfigurationRefuse >-----#
    MeasurementPreconfigurationRefuse = SEQ(name='MeasurementPreconfigurationRefuse', mode=MODE_TYPE)
    _MeasurementPreconfigurationRefuse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __MeasurementPreconfigurationRefuse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___MeasurementPreconfigurationRefuse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    ____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MeasurementPreconfigurationRefuse_protocolIEs__item__id._const_tab = ____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab
    ___MeasurementPreconfigurationRefuse_protocolIEs__item__id._const_tab_at = None
    ___MeasurementPreconfigurationRefuse_protocolIEs__item__id._const_tab_id = 'id'
    ___MeasurementPreconfigurationRefuse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___MeasurementPreconfigurationRefuse_protocolIEs__item__criticality._const_tab = ____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab
    ___MeasurementPreconfigurationRefuse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MeasurementPreconfigurationRefuse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MeasurementPreconfigurationRefuse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___MeasurementPreconfigurationRefuse_protocolIEs__item__value._const_tab = ____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab
    ___MeasurementPreconfigurationRefuse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MeasurementPreconfigurationRefuse_protocolIEs__item__value._const_tab_id = 'Value'
    __MeasurementPreconfigurationRefuse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MeasurementPreconfigurationRefuse_protocolIEs__item__id),
        ('criticality', ___MeasurementPreconfigurationRefuse_protocolIEs__item__criticality),
        ('value', ___MeasurementPreconfigurationRefuse_protocolIEs__item__value),
        ])
    __MeasurementPreconfigurationRefuse_protocolIEs__item_._ext = None
    _MeasurementPreconfigurationRefuse_protocolIEs._cont = __MeasurementPreconfigurationRefuse_protocolIEs__item_
    _MeasurementPreconfigurationRefuse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MeasurementPreconfigurationRefuse._cont = ASN1Dict([
        ('protocolIEs', _MeasurementPreconfigurationRefuse_protocolIEs),
        ])
    MeasurementPreconfigurationRefuse._ext = []
    
    #-----< MeasurementPreconfigurationRefuse-IEs >-----#
    MeasurementPreconfigurationRefuse_IEs = CLASS(name='MeasurementPreconfigurationRefuse-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _MeasurementPreconfigurationRefuse_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'Cause')))
    _MeasurementPreconfigurationRefuse_IEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'CriticalityDiagnostics')))
    MeasurementPreconfigurationRefuse_IEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _MeasurementPreconfigurationRefuse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _MeasurementPreconfigurationRefuse_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MeasurementActivation >-----#
    MeasurementActivation = SEQ(name='MeasurementActivation', mode=MODE_TYPE)
    _MeasurementActivation_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Container')))
    __MeasurementActivation_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-Containers', 'ProtocolIE-Field')))
    ___MeasurementActivation_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['id']))
    ____MeasurementActivation_protocolIEs__item__id_tab = CLASS(name='_tab_NRPPA-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _____MeasurementActivation_protocolIEs__item__id_tab_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'RequestType')))
    _____MeasurementActivation_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Measurements-Info-List')))
    ____MeasurementActivation_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 98), ('criticality', 'reject'), ('Value', _____MeasurementActivation_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 88), ('criticality', 'ignore'), ('Value', _____MeasurementActivation_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MeasurementActivation_protocolIEs__item__id._const_tab = ____MeasurementActivation_protocolIEs__item__id_tab
    ___MeasurementActivation_protocolIEs__item__id._const_tab_at = None
    ___MeasurementActivation_protocolIEs__item__id._const_tab_id = 'id'
    ___MeasurementActivation_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['criticality']))
    ___MeasurementActivation_protocolIEs__item__criticality._const_tab = ____MeasurementActivation_protocolIEs__item__id_tab
    ___MeasurementActivation_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MeasurementActivation_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MeasurementActivation_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES'), ['Value']))
    ___MeasurementActivation_protocolIEs__item__value._const_tab = ____MeasurementActivation_protocolIEs__item__id_tab
    ___MeasurementActivation_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MeasurementActivation_protocolIEs__item__value._const_tab_id = 'Value'
    __MeasurementActivation_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MeasurementActivation_protocolIEs__item__id),
        ('criticality', ___MeasurementActivation_protocolIEs__item__criticality),
        ('value', ___MeasurementActivation_protocolIEs__item__value),
        ])
    __MeasurementActivation_protocolIEs__item_._ext = None
    _MeasurementActivation_protocolIEs._cont = __MeasurementActivation_protocolIEs__item_
    _MeasurementActivation_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MeasurementActivation._cont = ASN1Dict([
        ('protocolIEs', _MeasurementActivation_protocolIEs),
        ])
    MeasurementActivation._ext = []
    
    #-----< MeasurementActivation-IEs >-----#
    MeasurementActivation_IEs = CLASS(name='MeasurementActivation-IEs', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-Containers', 'NRPPA-PROTOCOL-IES')))
    _MeasurementActivation_IEs_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'RequestType')))
    _MeasurementActivation_IEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-IEs', 'PRS-Measurements-Info-List')))
    MeasurementActivation_IEs._val = ASN1Set(rv=[dict([('id', 98), ('criticality', 'reject'), ('Value', _MeasurementActivation_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 88), ('criticality', 'ignore'), ('Value', _MeasurementActivation_IEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    _all_ = [
        ____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5,
        _____E_CIDMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_6,
        ___E_CIDMeasurementInitiationRequest_protocolIEs__item__id,
        ___E_CIDMeasurementInitiationRequest_protocolIEs__item__criticality,
        ___E_CIDMeasurementInitiationRequest_protocolIEs__item__value,
        __E_CIDMeasurementInitiationRequest_protocolIEs__item_,
        _E_CIDMeasurementInitiationRequest_protocolIEs,
        E_CIDMeasurementInitiationRequest,
        E_CIDMeasurementInitiationRequest_IEs,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_0,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_1,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_2,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_3,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_4,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_5,
        _E_CIDMeasurementInitiationRequest_IEs_val_Value_6,
        ____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_4,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_5,
        _____E_CIDMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_6,
        ___E_CIDMeasurementInitiationResponse_protocolIEs__item__id,
        ___E_CIDMeasurementInitiationResponse_protocolIEs__item__criticality,
        ___E_CIDMeasurementInitiationResponse_protocolIEs__item__value,
        __E_CIDMeasurementInitiationResponse_protocolIEs__item_,
        _E_CIDMeasurementInitiationResponse_protocolIEs,
        E_CIDMeasurementInitiationResponse,
        E_CIDMeasurementInitiationResponse_IEs,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_0,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_1,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_2,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_3,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_4,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_5,
        _E_CIDMeasurementInitiationResponse_IEs_val_Value_6,
        ____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab,
        _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____E_CIDMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2,
        ___E_CIDMeasurementInitiationFailure_protocolIEs__item__id,
        ___E_CIDMeasurementInitiationFailure_protocolIEs__item__criticality,
        ___E_CIDMeasurementInitiationFailure_protocolIEs__item__value,
        __E_CIDMeasurementInitiationFailure_protocolIEs__item_,
        _E_CIDMeasurementInitiationFailure_protocolIEs,
        E_CIDMeasurementInitiationFailure,
        E_CIDMeasurementInitiationFailure_IEs,
        _E_CIDMeasurementInitiationFailure_IEs_val_Value_0,
        _E_CIDMeasurementInitiationFailure_IEs_val_Value_1,
        _E_CIDMeasurementInitiationFailure_IEs_val_Value_2,
        ____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab,
        _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        _____E_CIDMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2,
        ___E_CIDMeasurementFailureIndication_protocolIEs__item__id,
        ___E_CIDMeasurementFailureIndication_protocolIEs__item__criticality,
        ___E_CIDMeasurementFailureIndication_protocolIEs__item__value,
        __E_CIDMeasurementFailureIndication_protocolIEs__item_,
        _E_CIDMeasurementFailureIndication_protocolIEs,
        E_CIDMeasurementFailureIndication,
        E_CIDMeasurementFailureIndication_IEs,
        _E_CIDMeasurementFailureIndication_IEs_val_Value_0,
        _E_CIDMeasurementFailureIndication_IEs_val_Value_1,
        _E_CIDMeasurementFailureIndication_IEs_val_Value_2,
        ____E_CIDMeasurementReport_protocolIEs__item__id_tab,
        _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_0,
        _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_1,
        _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_2,
        _____E_CIDMeasurementReport_protocolIEs__item__id_tab_val_Value_3,
        ___E_CIDMeasurementReport_protocolIEs__item__id,
        ___E_CIDMeasurementReport_protocolIEs__item__criticality,
        ___E_CIDMeasurementReport_protocolIEs__item__value,
        __E_CIDMeasurementReport_protocolIEs__item_,
        _E_CIDMeasurementReport_protocolIEs,
        E_CIDMeasurementReport,
        E_CIDMeasurementReport_IEs,
        _E_CIDMeasurementReport_IEs_val_Value_0,
        _E_CIDMeasurementReport_IEs_val_Value_1,
        _E_CIDMeasurementReport_IEs_val_Value_2,
        _E_CIDMeasurementReport_IEs_val_Value_3,
        ____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab,
        _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_0,
        _____E_CIDMeasurementTerminationCommand_protocolIEs__item__id_tab_val_Value_1,
        ___E_CIDMeasurementTerminationCommand_protocolIEs__item__id,
        ___E_CIDMeasurementTerminationCommand_protocolIEs__item__criticality,
        ___E_CIDMeasurementTerminationCommand_protocolIEs__item__value,
        __E_CIDMeasurementTerminationCommand_protocolIEs__item_,
        _E_CIDMeasurementTerminationCommand_protocolIEs,
        E_CIDMeasurementTerminationCommand,
        E_CIDMeasurementTerminationCommand_IEs,
        _E_CIDMeasurementTerminationCommand_IEs_val_Value_0,
        _E_CIDMeasurementTerminationCommand_IEs_val_Value_1,
        ____OTDOAInformationRequest_protocolIEs__item__id_tab,
        _____OTDOAInformationRequest_protocolIEs__item__id_tab_val_Value_0,
        ___OTDOAInformationRequest_protocolIEs__item__id,
        ___OTDOAInformationRequest_protocolIEs__item__criticality,
        ___OTDOAInformationRequest_protocolIEs__item__value,
        __OTDOAInformationRequest_protocolIEs__item_,
        _OTDOAInformationRequest_protocolIEs,
        OTDOAInformationRequest,
        OTDOAInformationRequest_IEs,
        _OTDOAInformationRequest_IEs_val_Value_0,
        ___OTDOA_Information_Type__item__id_tab,
        ____OTDOA_Information_Type__item__id_tab_val_Value_0,
        __OTDOA_Information_Type__item__id,
        __OTDOA_Information_Type__item__criticality,
        __OTDOA_Information_Type__item__value,
        _OTDOA_Information_Type__item_,
        OTDOA_Information_Type,
        OTDOA_Information_Type_ItemIEs,
        _OTDOA_Information_Type_ItemIEs_val_Value_0,
        _OTDOA_Information_Type_Item_oTDOA_Information_Item,
        ____OTDOA_Information_Type_Item_iE_Extensions__item__id_tab,
        ___OTDOA_Information_Type_Item_iE_Extensions__item__id,
        ____OTDOA_Information_Type_Item_iE_Extensions__item__criticality_tab,
        ___OTDOA_Information_Type_Item_iE_Extensions__item__criticality,
        ____OTDOA_Information_Type_Item_iE_Extensions__item__extensionValue_tab,
        ___OTDOA_Information_Type_Item_iE_Extensions__item__extensionValue,
        __OTDOA_Information_Type_Item_iE_Extensions__item_,
        _OTDOA_Information_Type_Item_iE_Extensions,
        OTDOA_Information_Type_Item,
        OTDOA_Information_Type_ItemExtIEs,
        ____OTDOAInformationResponse_protocolIEs__item__id_tab,
        _____OTDOAInformationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____OTDOAInformationResponse_protocolIEs__item__id_tab_val_Value_1,
        ___OTDOAInformationResponse_protocolIEs__item__id,
        ___OTDOAInformationResponse_protocolIEs__item__criticality,
        ___OTDOAInformationResponse_protocolIEs__item__value,
        __OTDOAInformationResponse_protocolIEs__item_,
        _OTDOAInformationResponse_protocolIEs,
        OTDOAInformationResponse,
        OTDOAInformationResponse_IEs,
        _OTDOAInformationResponse_IEs_val_Value_0,
        _OTDOAInformationResponse_IEs_val_Value_1,
        ____OTDOAInformationFailure_protocolIEs__item__id_tab,
        _____OTDOAInformationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____OTDOAInformationFailure_protocolIEs__item__id_tab_val_Value_1,
        ___OTDOAInformationFailure_protocolIEs__item__id,
        ___OTDOAInformationFailure_protocolIEs__item__criticality,
        ___OTDOAInformationFailure_protocolIEs__item__value,
        __OTDOAInformationFailure_protocolIEs__item_,
        _OTDOAInformationFailure_protocolIEs,
        OTDOAInformationFailure,
        OTDOAInformationFailure_IEs,
        _OTDOAInformationFailure_IEs_val_Value_0,
        _OTDOAInformationFailure_IEs_val_Value_1,
        ____AssistanceInformationControl_protocolIEs__item__id_tab,
        _____AssistanceInformationControl_protocolIEs__item__id_tab_val_Value_0,
        _____AssistanceInformationControl_protocolIEs__item__id_tab_val_Value_1,
        _____AssistanceInformationControl_protocolIEs__item__id_tab_val_Value_2,
        ___AssistanceInformationControl_protocolIEs__item__id,
        ___AssistanceInformationControl_protocolIEs__item__criticality,
        ___AssistanceInformationControl_protocolIEs__item__value,
        __AssistanceInformationControl_protocolIEs__item_,
        _AssistanceInformationControl_protocolIEs,
        AssistanceInformationControl,
        AssistanceInformationControl_IEs,
        _AssistanceInformationControl_IEs_val_Value_0,
        _AssistanceInformationControl_IEs_val_Value_1,
        _AssistanceInformationControl_IEs_val_Value_2,
        ____AssistanceInformationFeedback_protocolIEs__item__id_tab,
        _____AssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_0,
        _____AssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_1,
        _____AssistanceInformationFeedback_protocolIEs__item__id_tab_val_Value_2,
        ___AssistanceInformationFeedback_protocolIEs__item__id,
        ___AssistanceInformationFeedback_protocolIEs__item__criticality,
        ___AssistanceInformationFeedback_protocolIEs__item__value,
        __AssistanceInformationFeedback_protocolIEs__item_,
        _AssistanceInformationFeedback_protocolIEs,
        AssistanceInformationFeedback,
        AssistanceInformationFeedback_IEs,
        _AssistanceInformationFeedback_IEs_val_Value_0,
        _AssistanceInformationFeedback_IEs_val_Value_1,
        _AssistanceInformationFeedback_IEs_val_Value_2,
        ____ErrorIndication_protocolIEs__item__id_tab,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1,
        ___ErrorIndication_protocolIEs__item__id,
        ___ErrorIndication_protocolIEs__item__criticality,
        ___ErrorIndication_protocolIEs__item__value,
        __ErrorIndication_protocolIEs__item_,
        _ErrorIndication_protocolIEs,
        ErrorIndication,
        ErrorIndication_IEs,
        _ErrorIndication_IEs_val_Value_0,
        _ErrorIndication_IEs_val_Value_1,
        ____PrivateMessage_privateIEs__item__id_tab,
        ___PrivateMessage_privateIEs__item__id,
        ____PrivateMessage_privateIEs__item__criticality_tab,
        ___PrivateMessage_privateIEs__item__criticality,
        ____PrivateMessage_privateIEs__item__value_tab,
        ___PrivateMessage_privateIEs__item__value,
        __PrivateMessage_privateIEs__item_,
        _PrivateMessage_privateIEs,
        PrivateMessage,
        PrivateMessage_IEs,
        ____PositioningInformationRequest_protocolIEs__item__id_tab,
        _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningInformationRequest_protocolIEs__item__id_tab_val_Value_3,
        ___PositioningInformationRequest_protocolIEs__item__id,
        ___PositioningInformationRequest_protocolIEs__item__criticality,
        ___PositioningInformationRequest_protocolIEs__item__value,
        __PositioningInformationRequest_protocolIEs__item_,
        _PositioningInformationRequest_protocolIEs,
        PositioningInformationRequest,
        PositioningInformationRequest_IEs,
        _PositioningInformationRequest_IEs_val_Value_0,
        _PositioningInformationRequest_IEs_val_Value_1,
        _PositioningInformationRequest_IEs_val_Value_2,
        _PositioningInformationRequest_IEs_val_Value_3,
        ____PositioningInformationResponse_protocolIEs__item__id_tab,
        _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningInformationResponse_protocolIEs__item__id_tab_val_Value_3,
        ___PositioningInformationResponse_protocolIEs__item__id,
        ___PositioningInformationResponse_protocolIEs__item__criticality,
        ___PositioningInformationResponse_protocolIEs__item__value,
        __PositioningInformationResponse_protocolIEs__item_,
        _PositioningInformationResponse_protocolIEs,
        PositioningInformationResponse,
        PositioningInformationResponse_IEs,
        _PositioningInformationResponse_IEs_val_Value_0,
        _PositioningInformationResponse_IEs_val_Value_1,
        _PositioningInformationResponse_IEs_val_Value_2,
        _PositioningInformationResponse_IEs_val_Value_3,
        ____PositioningInformationFailure_protocolIEs__item__id_tab,
        _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningInformationFailure_protocolIEs__item__id_tab_val_Value_1,
        ___PositioningInformationFailure_protocolIEs__item__id,
        ___PositioningInformationFailure_protocolIEs__item__criticality,
        ___PositioningInformationFailure_protocolIEs__item__value,
        __PositioningInformationFailure_protocolIEs__item_,
        _PositioningInformationFailure_protocolIEs,
        PositioningInformationFailure,
        PositioningInformationFailure_IEs,
        _PositioningInformationFailure_IEs_val_Value_0,
        _PositioningInformationFailure_IEs_val_Value_1,
        ____PositioningInformationUpdate_protocolIEs__item__id_tab,
        _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____PositioningInformationUpdate_protocolIEs__item__id_tab_val_Value_3,
        ___PositioningInformationUpdate_protocolIEs__item__id,
        ___PositioningInformationUpdate_protocolIEs__item__criticality,
        ___PositioningInformationUpdate_protocolIEs__item__value,
        __PositioningInformationUpdate_protocolIEs__item_,
        _PositioningInformationUpdate_protocolIEs,
        PositioningInformationUpdate,
        PositioningInformationUpdate_IEs,
        _PositioningInformationUpdate_IEs_val_Value_0,
        _PositioningInformationUpdate_IEs_val_Value_1,
        _PositioningInformationUpdate_IEs_val_Value_2,
        _PositioningInformationUpdate_IEs_val_Value_3,
        ____MeasurementRequest_protocolIEs__item__id_tab,
        _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_0,
        _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_1,
        _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_2,
        _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_3,
        _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_4,
        _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_5,
        _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_6,
        _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_7,
        _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_8,
        _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_9,
        _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_10,
        _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_11,
        _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_12,
        _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_13,
        _____MeasurementRequest_protocolIEs__item__id_tab_val_Value_14,
        ___MeasurementRequest_protocolIEs__item__id,
        ___MeasurementRequest_protocolIEs__item__criticality,
        ___MeasurementRequest_protocolIEs__item__value,
        __MeasurementRequest_protocolIEs__item_,
        _MeasurementRequest_protocolIEs,
        MeasurementRequest,
        MeasurementRequest_IEs,
        _MeasurementRequest_IEs_val_Value_0,
        _MeasurementRequest_IEs_val_Value_1,
        _MeasurementRequest_IEs_val_Value_2,
        _MeasurementRequest_IEs_val_Value_3,
        _MeasurementRequest_IEs_val_Value_4,
        _MeasurementRequest_IEs_val_Value_5,
        _MeasurementRequest_IEs_val_Value_6,
        _MeasurementRequest_IEs_val_Value_7,
        _MeasurementRequest_IEs_val_Value_8,
        _MeasurementRequest_IEs_val_Value_9,
        _MeasurementRequest_IEs_val_Value_10,
        _MeasurementRequest_IEs_val_Value_11,
        _MeasurementRequest_IEs_val_Value_12,
        _MeasurementRequest_IEs_val_Value_13,
        _MeasurementRequest_IEs_val_Value_14,
        ____MeasurementResponse_protocolIEs__item__id_tab,
        _____MeasurementResponse_protocolIEs__item__id_tab_val_Value_0,
        _____MeasurementResponse_protocolIEs__item__id_tab_val_Value_1,
        _____MeasurementResponse_protocolIEs__item__id_tab_val_Value_2,
        _____MeasurementResponse_protocolIEs__item__id_tab_val_Value_3,
        ___MeasurementResponse_protocolIEs__item__id,
        ___MeasurementResponse_protocolIEs__item__criticality,
        ___MeasurementResponse_protocolIEs__item__value,
        __MeasurementResponse_protocolIEs__item_,
        _MeasurementResponse_protocolIEs,
        MeasurementResponse,
        MeasurementResponse_IEs,
        _MeasurementResponse_IEs_val_Value_0,
        _MeasurementResponse_IEs_val_Value_1,
        _MeasurementResponse_IEs_val_Value_2,
        _MeasurementResponse_IEs_val_Value_3,
        ____MeasurementFailure_protocolIEs__item__id_tab,
        _____MeasurementFailure_protocolIEs__item__id_tab_val_Value_0,
        _____MeasurementFailure_protocolIEs__item__id_tab_val_Value_1,
        _____MeasurementFailure_protocolIEs__item__id_tab_val_Value_2,
        ___MeasurementFailure_protocolIEs__item__id,
        ___MeasurementFailure_protocolIEs__item__criticality,
        ___MeasurementFailure_protocolIEs__item__value,
        __MeasurementFailure_protocolIEs__item_,
        _MeasurementFailure_protocolIEs,
        MeasurementFailure,
        MeasurementFailure_IEs,
        _MeasurementFailure_IEs_val_Value_0,
        _MeasurementFailure_IEs_val_Value_1,
        _MeasurementFailure_IEs_val_Value_2,
        ____MeasurementReport_protocolIEs__item__id_tab,
        _____MeasurementReport_protocolIEs__item__id_tab_val_Value_0,
        _____MeasurementReport_protocolIEs__item__id_tab_val_Value_1,
        _____MeasurementReport_protocolIEs__item__id_tab_val_Value_2,
        ___MeasurementReport_protocolIEs__item__id,
        ___MeasurementReport_protocolIEs__item__criticality,
        ___MeasurementReport_protocolIEs__item__value,
        __MeasurementReport_protocolIEs__item_,
        _MeasurementReport_protocolIEs,
        MeasurementReport,
        MeasurementReport_IEs,
        _MeasurementReport_IEs_val_Value_0,
        _MeasurementReport_IEs_val_Value_1,
        _MeasurementReport_IEs_val_Value_2,
        ____MeasurementUpdate_protocolIEs__item__id_tab,
        _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_3,
        _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_4,
        _____MeasurementUpdate_protocolIEs__item__id_tab_val_Value_5,
        ___MeasurementUpdate_protocolIEs__item__id,
        ___MeasurementUpdate_protocolIEs__item__criticality,
        ___MeasurementUpdate_protocolIEs__item__value,
        __MeasurementUpdate_protocolIEs__item_,
        _MeasurementUpdate_protocolIEs,
        MeasurementUpdate,
        MeasurementUpdate_IEs,
        _MeasurementUpdate_IEs_val_Value_0,
        _MeasurementUpdate_IEs_val_Value_1,
        _MeasurementUpdate_IEs_val_Value_2,
        _MeasurementUpdate_IEs_val_Value_3,
        _MeasurementUpdate_IEs_val_Value_4,
        _MeasurementUpdate_IEs_val_Value_5,
        ____MeasurementAbort_protocolIEs__item__id_tab,
        _____MeasurementAbort_protocolIEs__item__id_tab_val_Value_0,
        _____MeasurementAbort_protocolIEs__item__id_tab_val_Value_1,
        ___MeasurementAbort_protocolIEs__item__id,
        ___MeasurementAbort_protocolIEs__item__criticality,
        ___MeasurementAbort_protocolIEs__item__value,
        __MeasurementAbort_protocolIEs__item_,
        _MeasurementAbort_protocolIEs,
        MeasurementAbort,
        MeasurementAbort_IEs,
        _MeasurementAbort_IEs_val_Value_0,
        _MeasurementAbort_IEs_val_Value_1,
        ____MeasurementFailureIndication_protocolIEs__item__id_tab,
        _____MeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____MeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        _____MeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_2,
        ___MeasurementFailureIndication_protocolIEs__item__id,
        ___MeasurementFailureIndication_protocolIEs__item__criticality,
        ___MeasurementFailureIndication_protocolIEs__item__value,
        __MeasurementFailureIndication_protocolIEs__item_,
        _MeasurementFailureIndication_protocolIEs,
        MeasurementFailureIndication,
        MeasurementFailureIndication_IEs,
        _MeasurementFailureIndication_IEs_val_Value_0,
        _MeasurementFailureIndication_IEs_val_Value_1,
        _MeasurementFailureIndication_IEs_val_Value_2,
        ____TRPInformationRequest_protocolIEs__item__id_tab,
        _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____TRPInformationRequest_protocolIEs__item__id_tab_val_Value_1,
        ___TRPInformationRequest_protocolIEs__item__id,
        ___TRPInformationRequest_protocolIEs__item__criticality,
        ___TRPInformationRequest_protocolIEs__item__value,
        __TRPInformationRequest_protocolIEs__item_,
        _TRPInformationRequest_protocolIEs,
        TRPInformationRequest,
        TRPInformationRequest_IEs,
        _TRPInformationRequest_IEs_val_Value_0,
        _TRPInformationRequest_IEs_val_Value_1,
        ____TRPInformationResponse_protocolIEs__item__id_tab,
        _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____TRPInformationResponse_protocolIEs__item__id_tab_val_Value_1,
        ___TRPInformationResponse_protocolIEs__item__id,
        ___TRPInformationResponse_protocolIEs__item__criticality,
        ___TRPInformationResponse_protocolIEs__item__value,
        __TRPInformationResponse_protocolIEs__item_,
        _TRPInformationResponse_protocolIEs,
        TRPInformationResponse,
        TRPInformationResponse_IEs,
        _TRPInformationResponse_IEs_val_Value_0,
        _TRPInformationResponse_IEs_val_Value_1,
        ____TRPInformationFailure_protocolIEs__item__id_tab,
        _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____TRPInformationFailure_protocolIEs__item__id_tab_val_Value_1,
        ___TRPInformationFailure_protocolIEs__item__id,
        ___TRPInformationFailure_protocolIEs__item__criticality,
        ___TRPInformationFailure_protocolIEs__item__value,
        __TRPInformationFailure_protocolIEs__item_,
        _TRPInformationFailure_protocolIEs,
        TRPInformationFailure,
        TRPInformationFailure_IEs,
        _TRPInformationFailure_IEs_val_Value_0,
        _TRPInformationFailure_IEs_val_Value_1,
        ____PositioningActivationRequest_protocolIEs__item__id_tab,
        _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningActivationRequest_protocolIEs__item__id_tab_val_Value_1,
        ___PositioningActivationRequest_protocolIEs__item__id,
        ___PositioningActivationRequest_protocolIEs__item__criticality,
        ___PositioningActivationRequest_protocolIEs__item__value,
        __PositioningActivationRequest_protocolIEs__item_,
        _PositioningActivationRequest_protocolIEs,
        PositioningActivationRequest,
        PositioningActivationRequestIEs,
        _PositioningActivationRequestIEs_val_Value_0,
        _PositioningActivationRequestIEs_val_Value_1,
        _SRSType_semipersistentSRS,
        _SRSType_aperiodicSRS,
        ___SRSType_choice_Extension_id_tab,
        __SRSType_choice_Extension_id,
        ___SRSType_choice_Extension_criticality_tab,
        __SRSType_choice_Extension_criticality,
        ___SRSType_choice_Extension_value_tab,
        __SRSType_choice_Extension_value,
        _SRSType_choice_Extension,
        SRSType,
        SRSType_ExtIEs,
        _SemipersistentSRS_sRSResourceSetID,
        ____SemipersistentSRS_iE_Extensions__item__id_tab,
        _____SemipersistentSRS_iE_Extensions__item__id_tab_val_Extension_0,
        _____SemipersistentSRS_iE_Extensions__item__id_tab_val_Extension_1,
        ___SemipersistentSRS_iE_Extensions__item__id,
        ___SemipersistentSRS_iE_Extensions__item__criticality,
        ___SemipersistentSRS_iE_Extensions__item__extensionValue,
        __SemipersistentSRS_iE_Extensions__item_,
        _SemipersistentSRS_iE_Extensions,
        SemipersistentSRS,
        SemipersistentSRS_ExtIEs,
        _SemipersistentSRS_ExtIEs_val_Extension_0,
        _SemipersistentSRS_ExtIEs_val_Extension_1,
        _AperiodicSRS_aperiodic,
        _AperiodicSRS_sRSResourceTrigger,
        ____AperiodicSRS_iE_Extensions__item__id_tab,
        ___AperiodicSRS_iE_Extensions__item__id,
        ____AperiodicSRS_iE_Extensions__item__criticality_tab,
        ___AperiodicSRS_iE_Extensions__item__criticality,
        ____AperiodicSRS_iE_Extensions__item__extensionValue_tab,
        ___AperiodicSRS_iE_Extensions__item__extensionValue,
        __AperiodicSRS_iE_Extensions__item_,
        _AperiodicSRS_iE_Extensions,
        AperiodicSRS,
        AperiodicSRS_ExtIEs,
        ____PositioningActivationResponse_protocolIEs__item__id_tab,
        _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____PositioningActivationResponse_protocolIEs__item__id_tab_val_Value_2,
        ___PositioningActivationResponse_protocolIEs__item__id,
        ___PositioningActivationResponse_protocolIEs__item__criticality,
        ___PositioningActivationResponse_protocolIEs__item__value,
        __PositioningActivationResponse_protocolIEs__item_,
        _PositioningActivationResponse_protocolIEs,
        PositioningActivationResponse,
        PositioningActivationResponseIEs,
        _PositioningActivationResponseIEs_val_Value_0,
        _PositioningActivationResponseIEs_val_Value_1,
        _PositioningActivationResponseIEs_val_Value_2,
        ____PositioningActivationFailure_protocolIEs__item__id_tab,
        _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____PositioningActivationFailure_protocolIEs__item__id_tab_val_Value_1,
        ___PositioningActivationFailure_protocolIEs__item__id,
        ___PositioningActivationFailure_protocolIEs__item__criticality,
        ___PositioningActivationFailure_protocolIEs__item__value,
        __PositioningActivationFailure_protocolIEs__item_,
        _PositioningActivationFailure_protocolIEs,
        PositioningActivationFailure,
        PositioningActivationFailureIEs,
        _PositioningActivationFailureIEs_val_Value_0,
        _PositioningActivationFailureIEs_val_Value_1,
        ____PositioningDeactivation_protocolIEs__item__id_tab,
        _____PositioningDeactivation_protocolIEs__item__id_tab_val_Value_0,
        ___PositioningDeactivation_protocolIEs__item__id,
        ___PositioningDeactivation_protocolIEs__item__criticality,
        ___PositioningDeactivation_protocolIEs__item__value,
        __PositioningDeactivation_protocolIEs__item_,
        _PositioningDeactivation_protocolIEs,
        PositioningDeactivation,
        PositioningDeactivationIEs,
        _PositioningDeactivationIEs_val_Value_0,
        ____PRSConfigurationRequest_protocolIEs__item__id_tab,
        _____PRSConfigurationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PRSConfigurationRequest_protocolIEs__item__id_tab_val_Value_1,
        ___PRSConfigurationRequest_protocolIEs__item__id,
        ___PRSConfigurationRequest_protocolIEs__item__criticality,
        ___PRSConfigurationRequest_protocolIEs__item__value,
        __PRSConfigurationRequest_protocolIEs__item_,
        _PRSConfigurationRequest_protocolIEs,
        PRSConfigurationRequest,
        PRSConfigurationRequest_IEs,
        _PRSConfigurationRequest_IEs_val_Value_0,
        _PRSConfigurationRequest_IEs_val_Value_1,
        ____PRSConfigurationResponse_protocolIEs__item__id_tab,
        _____PRSConfigurationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____PRSConfigurationResponse_protocolIEs__item__id_tab_val_Value_1,
        ___PRSConfigurationResponse_protocolIEs__item__id,
        ___PRSConfigurationResponse_protocolIEs__item__criticality,
        ___PRSConfigurationResponse_protocolIEs__item__value,
        __PRSConfigurationResponse_protocolIEs__item_,
        _PRSConfigurationResponse_protocolIEs,
        PRSConfigurationResponse,
        PRSConfigurationResponse_IEs,
        _PRSConfigurationResponse_IEs_val_Value_0,
        _PRSConfigurationResponse_IEs_val_Value_1,
        ____PRSConfigurationFailure_protocolIEs__item__id_tab,
        _____PRSConfigurationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____PRSConfigurationFailure_protocolIEs__item__id_tab_val_Value_1,
        ___PRSConfigurationFailure_protocolIEs__item__id,
        ___PRSConfigurationFailure_protocolIEs__item__criticality,
        ___PRSConfigurationFailure_protocolIEs__item__value,
        __PRSConfigurationFailure_protocolIEs__item_,
        _PRSConfigurationFailure_protocolIEs,
        PRSConfigurationFailure,
        PRSConfigurationFailure_IEs,
        _PRSConfigurationFailure_IEs_val_Value_0,
        _PRSConfigurationFailure_IEs_val_Value_1,
        ____MeasurementPreconfigurationRequired_protocolIEs__item__id_tab,
        _____MeasurementPreconfigurationRequired_protocolIEs__item__id_tab_val_Value_0,
        ___MeasurementPreconfigurationRequired_protocolIEs__item__id,
        ___MeasurementPreconfigurationRequired_protocolIEs__item__criticality,
        ___MeasurementPreconfigurationRequired_protocolIEs__item__value,
        __MeasurementPreconfigurationRequired_protocolIEs__item_,
        _MeasurementPreconfigurationRequired_protocolIEs,
        MeasurementPreconfigurationRequired,
        MeasurementPreconfigurationRequired_IEs,
        _MeasurementPreconfigurationRequired_IEs_val_Value_0,
        ____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab,
        _____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab_val_Value_0,
        _____MeasurementPreconfigurationConfirm_protocolIEs__item__id_tab_val_Value_1,
        ___MeasurementPreconfigurationConfirm_protocolIEs__item__id,
        ___MeasurementPreconfigurationConfirm_protocolIEs__item__criticality,
        ___MeasurementPreconfigurationConfirm_protocolIEs__item__value,
        __MeasurementPreconfigurationConfirm_protocolIEs__item_,
        _MeasurementPreconfigurationConfirm_protocolIEs,
        MeasurementPreconfigurationConfirm,
        MeasurementPreconfigurationConfirm_IEs,
        _MeasurementPreconfigurationConfirm_IEs_val_Value_0,
        _MeasurementPreconfigurationConfirm_IEs_val_Value_1,
        ____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab,
        _____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab_val_Value_0,
        _____MeasurementPreconfigurationRefuse_protocolIEs__item__id_tab_val_Value_1,
        ___MeasurementPreconfigurationRefuse_protocolIEs__item__id,
        ___MeasurementPreconfigurationRefuse_protocolIEs__item__criticality,
        ___MeasurementPreconfigurationRefuse_protocolIEs__item__value,
        __MeasurementPreconfigurationRefuse_protocolIEs__item_,
        _MeasurementPreconfigurationRefuse_protocolIEs,
        MeasurementPreconfigurationRefuse,
        MeasurementPreconfigurationRefuse_IEs,
        _MeasurementPreconfigurationRefuse_IEs_val_Value_0,
        _MeasurementPreconfigurationRefuse_IEs_val_Value_1,
        ____MeasurementActivation_protocolIEs__item__id_tab,
        _____MeasurementActivation_protocolIEs__item__id_tab_val_Value_0,
        _____MeasurementActivation_protocolIEs__item__id_tab_val_Value_1,
        ___MeasurementActivation_protocolIEs__item__id,
        ___MeasurementActivation_protocolIEs__item__criticality,
        ___MeasurementActivation_protocolIEs__item__value,
        __MeasurementActivation_protocolIEs__item_,
        _MeasurementActivation_protocolIEs,
        MeasurementActivation,
        MeasurementActivation_IEs,
        _MeasurementActivation_IEs_val_Value_0,
        _MeasurementActivation_IEs_val_Value_1,
    ]

class NRPPA_PDU_Descriptions:

    _name_  = 'NRPPA-PDU-Descriptions'
    _oid_   = [0, 4, 0, 0, 22, 3, 4, 1, 0]
    
    _obj_ = [
        'NRPPA-ELEMENTARY-PROCEDURE',
        'NRPPA-PDU',
        'InitiatingMessage',
        'SuccessfulOutcome',
        'UnsuccessfulOutcome',
        'NRPPA-ELEMENTARY-PROCEDURES',
        'NRPPA-ELEMENTARY-PROCEDURES-CLASS-1',
        'NRPPA-ELEMENTARY-PROCEDURES-CLASS-2',
        'e-CIDMeasurementInitiation',
        'e-CIDMeasurementFailureIndication',
        'e-CIDMeasurementReport',
        'e-CIDMeasurementTermination',
        'oTDOAInformationExchange',
        'assistanceInformationControl',
        'assistanceInformationFeedback',
        'errorIndication',
        'privateMessage',
        'positioningInformationExchange',
        'positioningInformationUpdate',
        'measurement',
        'measurementReport',
        'measurementUpdate',
        'measurementAbort',
        'measurementFailureIndication',
        'tRPInformationExchange',
        'positioningActivation',
        'positioningDeactivation',
        'pRSConfigurationExchange',
        'measurementPreconfiguration',
        'measurementActivation',
        ]
    _type_ = [
        'NRPPA-ELEMENTARY-PROCEDURE',
        'NRPPA-PDU',
        'InitiatingMessage',
        'SuccessfulOutcome',
        'UnsuccessfulOutcome',
        ]
    _set_ = [
        'NRPPA-ELEMENTARY-PROCEDURES',
        'NRPPA-ELEMENTARY-PROCEDURES-CLASS-1',
        'NRPPA-ELEMENTARY-PROCEDURES-CLASS-2',
        ]
    _val_ = [
        'e-CIDMeasurementInitiation',
        'e-CIDMeasurementFailureIndication',
        'e-CIDMeasurementReport',
        'e-CIDMeasurementTermination',
        'oTDOAInformationExchange',
        'assistanceInformationControl',
        'assistanceInformationFeedback',
        'errorIndication',
        'privateMessage',
        'positioningInformationExchange',
        'positioningInformationUpdate',
        'measurement',
        'measurementReport',
        'measurementUpdate',
        'measurementAbort',
        'measurementFailureIndication',
        'tRPInformationExchange',
        'positioningActivation',
        'positioningDeactivation',
        'pRSConfigurationExchange',
        'measurementPreconfiguration',
        'measurementActivation',
        ]
    _class_ = [
        'NRPPA-ELEMENTARY-PROCEDURE',
        'NRPPA-ELEMENTARY-PROCEDURES',
        'NRPPA-ELEMENTARY-PROCEDURES-CLASS-1',
        'NRPPA-ELEMENTARY-PROCEDURES-CLASS-2',
        'e-CIDMeasurementInitiation',
        'e-CIDMeasurementFailureIndication',
        'e-CIDMeasurementReport',
        'e-CIDMeasurementTermination',
        'oTDOAInformationExchange',
        'assistanceInformationControl',
        'assistanceInformationFeedback',
        'errorIndication',
        'privateMessage',
        'positioningInformationExchange',
        'positioningInformationUpdate',
        'measurement',
        'measurementReport',
        'measurementUpdate',
        'measurementAbort',
        'measurementFailureIndication',
        'tRPInformationExchange',
        'positioningActivation',
        'positioningDeactivation',
        'pRSConfigurationExchange',
        'measurementPreconfiguration',
        'measurementActivation',
        ]
    _param_ = [
        ]
    
    #-----< NRPPA-ELEMENTARY-PROCEDURE >-----#
    NRPPA_ELEMENTARY_PROCEDURE = CLASS(name='NRPPA-ELEMENTARY-PROCEDURE', mode=MODE_TYPE)
    _NRPPA_ELEMENTARY_PROCEDURE_InitiatingMessage = OPEN(name='InitiatingMessage', mode=MODE_TYPE)
    _NRPPA_ELEMENTARY_PROCEDURE_SuccessfulOutcome = OPEN(name='SuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _NRPPA_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome = OPEN(name='UnsuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _NRPPA_ELEMENTARY_PROCEDURE_procedureCode = INT(name='procedureCode', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'ProcedureCode')), uniq=True)
    _NRPPA_ELEMENTARY_PROCEDURE_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'Criticality')), default='ignore')
    NRPPA_ELEMENTARY_PROCEDURE._cont = ASN1Dict([
        ('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURE_InitiatingMessage),
        ('SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURE_SuccessfulOutcome),
        ('UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome),
        ('procedureCode', _NRPPA_ELEMENTARY_PROCEDURE_procedureCode),
        ('criticality', _NRPPA_ELEMENTARY_PROCEDURE_criticality),
        ])
    
    #-----< NRPPA-PDU >-----#
    NRPPA_PDU = CHOICE(name='NRPPA-PDU', mode=MODE_TYPE)
    _NRPPA_PDU_initiatingMessage = SEQ(name='initiatingMessage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'InitiatingMessage')))
    _NRPPA_PDU_successfulOutcome = SEQ(name='successfulOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'SuccessfulOutcome')))
    _NRPPA_PDU_unsuccessfulOutcome = SEQ(name='unsuccessfulOutcome', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'UnsuccessfulOutcome')))
    NRPPA_PDU._cont = ASN1Dict([
        ('initiatingMessage', _NRPPA_PDU_initiatingMessage),
        ('successfulOutcome', _NRPPA_PDU_successfulOutcome),
        ('unsuccessfulOutcome', _NRPPA_PDU_unsuccessfulOutcome),
        ])
    NRPPA_PDU._ext = []
    
    #-----< InitiatingMessage >-----#
    InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE)
    _InitiatingMessage_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __InitiatingMessage_procedureCode_tab = CLASS(name='_tab_NRPPA-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PRSConfigurationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PRSConfigurationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PRSConfigurationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementPreconfigurationRequired')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementPreconfigurationConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementPreconfigurationRefuse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementFailureIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementTerminationCommand')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'ErrorIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PrivateMessage')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'AssistanceInformationControl')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'AssistanceInformationFeedback')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementAbort')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementFailureIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningDeactivation')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementActivation')))
    __InitiatingMessage_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0), ('procedureCode', 2), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3), ('procedureCode', 11), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4), ('procedureCode', 16), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_5), ('procedureCode', 17), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6), ('procedureCode', 19), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7), ('procedureCode', 20), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10), ('procedureCode', 5), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11), ('procedureCode', 0), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12), ('procedureCode', 1), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14), ('procedureCode', 8), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15), ('procedureCode', 10), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18), ('procedureCode', 14), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21), ('procedureCode', 21), ('criticality', 'ignore')])], rr=[], ev=None, er=[])
    _InitiatingMessage_procedureCode._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_procedureCode._const_tab_at = None
    _InitiatingMessage_procedureCode._const_tab_id = 'procedureCode'
    _InitiatingMessage_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE'), ['criticality']))
    _InitiatingMessage_criticality._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_criticality._const_tab_at = ('..', 'procedureCode')
    _InitiatingMessage_criticality._const_tab_id = 'criticality'
    _InitiatingMessage_nrppatransactionID = INT(name='nrppatransactionID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'NRPPATransactionID')))
    _InitiatingMessage_value = OPEN(name='value', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE'), ['InitiatingMessage']))
    _InitiatingMessage_value._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_value._const_tab_at = ('..', 'procedureCode')
    _InitiatingMessage_value._const_tab_id = 'InitiatingMessage'
    InitiatingMessage._cont = ASN1Dict([
        ('procedureCode', _InitiatingMessage_procedureCode),
        ('criticality', _InitiatingMessage_criticality),
        ('nrppatransactionID', _InitiatingMessage_nrppatransactionID),
        ('value', _InitiatingMessage_value),
        ])
    InitiatingMessage._ext = None
    
    #-----< SuccessfulOutcome >-----#
    SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE)
    _SuccessfulOutcome_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __SuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_NRPPA-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PRSConfigurationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PRSConfigurationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PRSConfigurationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementPreconfigurationRequired')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementPreconfigurationConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementPreconfigurationRefuse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementFailureIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementTerminationCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'ErrorIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PrivateMessage')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'AssistanceInformationControl')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'AssistanceInformationFeedback')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementAbort')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementFailureIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningDeactivation')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementActivation')))
    __SuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0), ('procedureCode', 2), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3), ('procedureCode', 11), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4), ('procedureCode', 16), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5), ('procedureCode', 17), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6), ('procedureCode', 19), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7), ('procedureCode', 20), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), ('procedureCode', 5), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), ('procedureCode', 0), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), ('procedureCode', 1), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), ('procedureCode', 8), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), ('procedureCode', 10), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18), ('procedureCode', 14), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21), ('procedureCode', 21), ('criticality', 'ignore')])], rr=[], ev=None, er=[])
    _SuccessfulOutcome_procedureCode._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_procedureCode._const_tab_at = None
    _SuccessfulOutcome_procedureCode._const_tab_id = 'procedureCode'
    _SuccessfulOutcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE'), ['criticality']))
    _SuccessfulOutcome_criticality._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_criticality._const_tab_at = ('..', 'procedureCode')
    _SuccessfulOutcome_criticality._const_tab_id = 'criticality'
    _SuccessfulOutcome_nrppatransactionID = INT(name='nrppatransactionID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'NRPPATransactionID')))
    _SuccessfulOutcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE'), ['SuccessfulOutcome']))
    _SuccessfulOutcome_value._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_value._const_tab_at = ('..', 'procedureCode')
    _SuccessfulOutcome_value._const_tab_id = 'SuccessfulOutcome'
    SuccessfulOutcome._cont = ASN1Dict([
        ('procedureCode', _SuccessfulOutcome_procedureCode),
        ('criticality', _SuccessfulOutcome_criticality),
        ('nrppatransactionID', _SuccessfulOutcome_nrppatransactionID),
        ('value', _SuccessfulOutcome_value),
        ])
    SuccessfulOutcome._ext = None
    
    #-----< UnsuccessfulOutcome >-----#
    UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE)
    _UnsuccessfulOutcome_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __UnsuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_NRPPA-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PRSConfigurationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PRSConfigurationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PRSConfigurationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementPreconfigurationRequired')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementPreconfigurationConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementPreconfigurationRefuse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementFailureIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementTerminationCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'ErrorIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PrivateMessage')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'AssistanceInformationControl')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'AssistanceInformationFeedback')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementAbort')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementFailureIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningDeactivation')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementActivation')))
    __UnsuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0), ('procedureCode', 2), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3), ('procedureCode', 11), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4), ('procedureCode', 16), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5), ('procedureCode', 17), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6), ('procedureCode', 19), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7), ('procedureCode', 20), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), ('procedureCode', 5), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), ('procedureCode', 0), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), ('procedureCode', 1), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), ('procedureCode', 8), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), ('procedureCode', 10), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18), ('procedureCode', 14), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21), ('procedureCode', 21), ('criticality', 'ignore')])], rr=[], ev=None, er=[])
    _UnsuccessfulOutcome_procedureCode._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_procedureCode._const_tab_at = None
    _UnsuccessfulOutcome_procedureCode._const_tab_id = 'procedureCode'
    _UnsuccessfulOutcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE'), ['criticality']))
    _UnsuccessfulOutcome_criticality._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_criticality._const_tab_at = ('..', 'procedureCode')
    _UnsuccessfulOutcome_criticality._const_tab_id = 'criticality'
    _UnsuccessfulOutcome_nrppatransactionID = INT(name='nrppatransactionID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('NRPPA-CommonDataTypes', 'NRPPATransactionID')))
    _UnsuccessfulOutcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE'), ['UnsuccessfulOutcome']))
    _UnsuccessfulOutcome_value._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_value._const_tab_at = ('..', 'procedureCode')
    _UnsuccessfulOutcome_value._const_tab_id = 'UnsuccessfulOutcome'
    UnsuccessfulOutcome._cont = ASN1Dict([
        ('procedureCode', _UnsuccessfulOutcome_procedureCode),
        ('criticality', _UnsuccessfulOutcome_criticality),
        ('nrppatransactionID', _UnsuccessfulOutcome_nrppatransactionID),
        ('value', _UnsuccessfulOutcome_value),
        ])
    UnsuccessfulOutcome._ext = None
    
    #-----< NRPPA-ELEMENTARY-PROCEDURES >-----#
    NRPPA_ELEMENTARY_PROCEDURES = CLASS(name='NRPPA-ELEMENTARY-PROCEDURES', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationRequest')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationResponse')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationFailure')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationRequest')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationResponse')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationFailure')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationRequest')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationResponse')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationFailure')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementRequest')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementResponse')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementFailure')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationRequest')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationResponse')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationFailure')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationRequest')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationResponse')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationFailure')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PRSConfigurationRequest')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PRSConfigurationResponse')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PRSConfigurationFailure')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementPreconfigurationRequired')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementPreconfigurationConfirm')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementPreconfigurationRefuse')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementFailureIndication')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementReport')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementTerminationCommand')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'ErrorIndication')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PrivateMessage')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'AssistanceInformationControl')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'AssistanceInformationFeedback')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationUpdate')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementReport')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementUpdate')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementAbort')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementFailureIndication')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningDeactivation')))
    _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementActivation')))
    NRPPA_ELEMENTARY_PROCEDURES._val = ASN1Set(rv=[dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0), ('SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0), ('procedureCode', 2), ('criticality', 'reject')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1), ('SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2), ('SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3), ('SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3), ('procedureCode', 11), ('criticality', 'reject')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4), ('SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4), ('procedureCode', 16), ('criticality', 'reject')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5), ('SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5), ('procedureCode', 17), ('criticality', 'reject')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6), ('SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6), ('procedureCode', 19), ('criticality', 'reject')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7), ('SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7), ('procedureCode', 20), ('criticality', 'reject')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10), ('procedureCode', 5), ('criticality', 'reject')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11), ('procedureCode', 0), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12), ('procedureCode', 1), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14), ('procedureCode', 8), ('criticality', 'reject')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15), ('procedureCode', 10), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18), ('procedureCode', 14), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21), ('procedureCode', 21), ('criticality', 'ignore')])], rr=[], ev=[], er=[])
    
    #-----< NRPPA-ELEMENTARY-PROCEDURES-CLASS-1 >-----#
    NRPPA_ELEMENTARY_PROCEDURES_CLASS_1 = CLASS(name='NRPPA-ELEMENTARY-PROCEDURES-CLASS-1', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationRequest')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationResponse')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationFailure')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationRequest')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationResponse')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationFailure')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationRequest')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationResponse')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationFailure')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementRequest')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementResponse')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementFailure')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationRequest')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationResponse')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationFailure')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationRequest')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationResponse')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationFailure')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PRSConfigurationRequest')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PRSConfigurationResponse')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PRSConfigurationFailure')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementPreconfigurationRequired')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementPreconfigurationConfirm')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementPreconfigurationRefuse')))
    NRPPA_ELEMENTARY_PROCEDURES_CLASS_1._val = ASN1Set(rv=[dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0), ('SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0), ('procedureCode', 2), ('criticality', 'reject')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1), ('SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2), ('SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3), ('SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3), ('procedureCode', 11), ('criticality', 'reject')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4), ('SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4), ('UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4), ('procedureCode', 16), ('criticality', 'reject')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5), ('SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5), ('procedureCode', 17), ('criticality', 'reject')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6), ('SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6), ('UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6), ('procedureCode', 19), ('criticality', 'reject')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7), ('SuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7), ('procedureCode', 20), ('criticality', 'reject')])], rr=[], ev=[], er=[])
    
    #-----< NRPPA-ELEMENTARY-PROCEDURES-CLASS-2 >-----#
    NRPPA_ELEMENTARY_PROCEDURES_CLASS_2 = CLASS(name='NRPPA-ELEMENTARY-PROCEDURES-CLASS-2', mode=MODE_SET, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementFailureIndication')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementReport')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementTerminationCommand')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'ErrorIndication')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PrivateMessage')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'AssistanceInformationControl')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'AssistanceInformationFeedback')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationUpdate')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementReport')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementUpdate')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementAbort')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementFailureIndication')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningDeactivation')))
    _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementActivation')))
    NRPPA_ELEMENTARY_PROCEDURES_CLASS_2._val = ASN1Set(rv=[dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2), ('procedureCode', 5), ('criticality', 'reject')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3), ('procedureCode', 0), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4), ('procedureCode', 1), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6), ('procedureCode', 8), ('criticality', 'reject')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7), ('procedureCode', 10), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10), ('procedureCode', 14), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13), ('procedureCode', 21), ('criticality', 'ignore')])], rr=[], ev=[], er=[])
    
    #-----< e-CIDMeasurementInitiation >-----#
    e_CIDMeasurementInitiation = CLASS(name='e-CIDMeasurementInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _e_CIDMeasurementInitiation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationRequest')))
    _e_CIDMeasurementInitiation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationResponse')))
    _e_CIDMeasurementInitiation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementInitiationFailure')))
    e_CIDMeasurementInitiation._val = dict([('InitiatingMessage', _e_CIDMeasurementInitiation_val_InitiatingMessage), ('SuccessfulOutcome', _e_CIDMeasurementInitiation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _e_CIDMeasurementInitiation_val_UnsuccessfulOutcome), ('procedureCode', 2), ('criticality', 'reject')])
    
    #-----< e-CIDMeasurementFailureIndication >-----#
    e_CIDMeasurementFailureIndication = CLASS(name='e-CIDMeasurementFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _e_CIDMeasurementFailureIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementFailureIndication')))
    e_CIDMeasurementFailureIndication._val = dict([('InitiatingMessage', _e_CIDMeasurementFailureIndication_val_InitiatingMessage), ('procedureCode', 3), ('criticality', 'ignore')])
    
    #-----< e-CIDMeasurementReport >-----#
    e_CIDMeasurementReport = CLASS(name='e-CIDMeasurementReport', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _e_CIDMeasurementReport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementReport')))
    e_CIDMeasurementReport._val = dict([('InitiatingMessage', _e_CIDMeasurementReport_val_InitiatingMessage), ('procedureCode', 4), ('criticality', 'ignore')])
    
    #-----< e-CIDMeasurementTermination >-----#
    e_CIDMeasurementTermination = CLASS(name='e-CIDMeasurementTermination', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _e_CIDMeasurementTermination_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'E-CIDMeasurementTerminationCommand')))
    e_CIDMeasurementTermination._val = dict([('InitiatingMessage', _e_CIDMeasurementTermination_val_InitiatingMessage), ('procedureCode', 5), ('criticality', 'reject')])
    
    #-----< oTDOAInformationExchange >-----#
    oTDOAInformationExchange = CLASS(name='oTDOAInformationExchange', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _oTDOAInformationExchange_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationRequest')))
    _oTDOAInformationExchange_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationResponse')))
    _oTDOAInformationExchange_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'OTDOAInformationFailure')))
    oTDOAInformationExchange._val = dict([('InitiatingMessage', _oTDOAInformationExchange_val_InitiatingMessage), ('SuccessfulOutcome', _oTDOAInformationExchange_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _oTDOAInformationExchange_val_UnsuccessfulOutcome), ('procedureCode', 6), ('criticality', 'reject')])
    
    #-----< assistanceInformationControl >-----#
    assistanceInformationControl = CLASS(name='assistanceInformationControl', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _assistanceInformationControl_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'AssistanceInformationControl')))
    assistanceInformationControl._val = dict([('InitiatingMessage', _assistanceInformationControl_val_InitiatingMessage), ('procedureCode', 7), ('criticality', 'reject')])
    
    #-----< assistanceInformationFeedback >-----#
    assistanceInformationFeedback = CLASS(name='assistanceInformationFeedback', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _assistanceInformationFeedback_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'AssistanceInformationFeedback')))
    assistanceInformationFeedback._val = dict([('InitiatingMessage', _assistanceInformationFeedback_val_InitiatingMessage), ('procedureCode', 8), ('criticality', 'reject')])
    
    #-----< errorIndication >-----#
    errorIndication = CLASS(name='errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _errorIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'ErrorIndication')))
    errorIndication._val = dict([('InitiatingMessage', _errorIndication_val_InitiatingMessage), ('procedureCode', 0), ('criticality', 'ignore')])
    
    #-----< privateMessage >-----#
    privateMessage = CLASS(name='privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _privateMessage_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PrivateMessage')))
    privateMessage._val = dict([('InitiatingMessage', _privateMessage_val_InitiatingMessage), ('procedureCode', 1), ('criticality', 'ignore')])
    
    #-----< positioningInformationExchange >-----#
    positioningInformationExchange = CLASS(name='positioningInformationExchange', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _positioningInformationExchange_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationRequest')))
    _positioningInformationExchange_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationResponse')))
    _positioningInformationExchange_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationFailure')))
    positioningInformationExchange._val = dict([('InitiatingMessage', _positioningInformationExchange_val_InitiatingMessage), ('SuccessfulOutcome', _positioningInformationExchange_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _positioningInformationExchange_val_UnsuccessfulOutcome), ('procedureCode', 9), ('criticality', 'reject')])
    
    #-----< positioningInformationUpdate >-----#
    positioningInformationUpdate = CLASS(name='positioningInformationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _positioningInformationUpdate_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningInformationUpdate')))
    positioningInformationUpdate._val = dict([('InitiatingMessage', _positioningInformationUpdate_val_InitiatingMessage), ('procedureCode', 10), ('criticality', 'ignore')])
    
    #-----< measurement >-----#
    measurement = CLASS(name='measurement', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _measurement_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementRequest')))
    _measurement_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementResponse')))
    _measurement_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementFailure')))
    measurement._val = dict([('InitiatingMessage', _measurement_val_InitiatingMessage), ('SuccessfulOutcome', _measurement_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _measurement_val_UnsuccessfulOutcome), ('procedureCode', 11), ('criticality', 'reject')])
    
    #-----< measurementReport >-----#
    measurementReport = CLASS(name='measurementReport', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _measurementReport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementReport')))
    measurementReport._val = dict([('InitiatingMessage', _measurementReport_val_InitiatingMessage), ('procedureCode', 12), ('criticality', 'ignore')])
    
    #-----< measurementUpdate >-----#
    measurementUpdate = CLASS(name='measurementUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _measurementUpdate_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementUpdate')))
    measurementUpdate._val = dict([('InitiatingMessage', _measurementUpdate_val_InitiatingMessage), ('procedureCode', 13), ('criticality', 'ignore')])
    
    #-----< measurementAbort >-----#
    measurementAbort = CLASS(name='measurementAbort', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _measurementAbort_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementAbort')))
    measurementAbort._val = dict([('InitiatingMessage', _measurementAbort_val_InitiatingMessage), ('procedureCode', 14), ('criticality', 'ignore')])
    
    #-----< measurementFailureIndication >-----#
    measurementFailureIndication = CLASS(name='measurementFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _measurementFailureIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementFailureIndication')))
    measurementFailureIndication._val = dict([('InitiatingMessage', _measurementFailureIndication_val_InitiatingMessage), ('procedureCode', 15), ('criticality', 'ignore')])
    
    #-----< tRPInformationExchange >-----#
    tRPInformationExchange = CLASS(name='tRPInformationExchange', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _tRPInformationExchange_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationRequest')))
    _tRPInformationExchange_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationResponse')))
    _tRPInformationExchange_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'TRPInformationFailure')))
    tRPInformationExchange._val = dict([('InitiatingMessage', _tRPInformationExchange_val_InitiatingMessage), ('SuccessfulOutcome', _tRPInformationExchange_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _tRPInformationExchange_val_UnsuccessfulOutcome), ('procedureCode', 16), ('criticality', 'reject')])
    
    #-----< positioningActivation >-----#
    positioningActivation = CLASS(name='positioningActivation', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _positioningActivation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationRequest')))
    _positioningActivation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationResponse')))
    _positioningActivation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningActivationFailure')))
    positioningActivation._val = dict([('InitiatingMessage', _positioningActivation_val_InitiatingMessage), ('SuccessfulOutcome', _positioningActivation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _positioningActivation_val_UnsuccessfulOutcome), ('procedureCode', 17), ('criticality', 'reject')])
    
    #-----< positioningDeactivation >-----#
    positioningDeactivation = CLASS(name='positioningDeactivation', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _positioningDeactivation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PositioningDeactivation')))
    positioningDeactivation._val = dict([('InitiatingMessage', _positioningDeactivation_val_InitiatingMessage), ('procedureCode', 18), ('criticality', 'ignore')])
    
    #-----< pRSConfigurationExchange >-----#
    pRSConfigurationExchange = CLASS(name='pRSConfigurationExchange', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _pRSConfigurationExchange_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PRSConfigurationRequest')))
    _pRSConfigurationExchange_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PRSConfigurationResponse')))
    _pRSConfigurationExchange_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'PRSConfigurationFailure')))
    pRSConfigurationExchange._val = dict([('InitiatingMessage', _pRSConfigurationExchange_val_InitiatingMessage), ('SuccessfulOutcome', _pRSConfigurationExchange_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _pRSConfigurationExchange_val_UnsuccessfulOutcome), ('procedureCode', 19), ('criticality', 'reject')])
    
    #-----< measurementPreconfiguration >-----#
    measurementPreconfiguration = CLASS(name='measurementPreconfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _measurementPreconfiguration_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementPreconfigurationRequired')))
    _measurementPreconfiguration_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementPreconfigurationConfirm')))
    _measurementPreconfiguration_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementPreconfigurationRefuse')))
    measurementPreconfiguration._val = dict([('InitiatingMessage', _measurementPreconfiguration_val_InitiatingMessage), ('SuccessfulOutcome', _measurementPreconfiguration_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _measurementPreconfiguration_val_UnsuccessfulOutcome), ('procedureCode', 20), ('criticality', 'reject')])
    
    #-----< measurementActivation >-----#
    measurementActivation = CLASS(name='measurementActivation', mode=MODE_VALUE, typeref=ASN1RefType(('NRPPA-PDU-Descriptions', 'NRPPA-ELEMENTARY-PROCEDURE')))
    _measurementActivation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('NRPPA-PDU-Contents', 'MeasurementActivation')))
    measurementActivation._val = dict([('InitiatingMessage', _measurementActivation_val_InitiatingMessage), ('procedureCode', 21), ('criticality', 'ignore')])
    
    _all_ = [
        _NRPPA_ELEMENTARY_PROCEDURE_InitiatingMessage,
        _NRPPA_ELEMENTARY_PROCEDURE_SuccessfulOutcome,
        _NRPPA_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome,
        _NRPPA_ELEMENTARY_PROCEDURE_procedureCode,
        _NRPPA_ELEMENTARY_PROCEDURE_criticality,
        NRPPA_ELEMENTARY_PROCEDURE,
        _NRPPA_PDU_initiatingMessage,
        _NRPPA_PDU_successfulOutcome,
        _NRPPA_PDU_unsuccessfulOutcome,
        NRPPA_PDU,
        __InitiatingMessage_procedureCode_tab,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_5,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21,
        _InitiatingMessage_procedureCode,
        _InitiatingMessage_criticality,
        _InitiatingMessage_nrppatransactionID,
        _InitiatingMessage_value,
        InitiatingMessage,
        __SuccessfulOutcome_procedureCode_tab,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21,
        _SuccessfulOutcome_procedureCode,
        _SuccessfulOutcome_criticality,
        _SuccessfulOutcome_nrppatransactionID,
        _SuccessfulOutcome_value,
        SuccessfulOutcome,
        __UnsuccessfulOutcome_procedureCode_tab,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21,
        _UnsuccessfulOutcome_procedureCode,
        _UnsuccessfulOutcome_criticality,
        _UnsuccessfulOutcome_nrppatransactionID,
        _UnsuccessfulOutcome_value,
        UnsuccessfulOutcome,
        NRPPA_ELEMENTARY_PROCEDURES,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0,
        _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0,
        _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1,
        _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1,
        _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2,
        _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2,
        _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3,
        _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3,
        _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4,
        _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4,
        _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5,
        _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5,
        _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6,
        _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6,
        _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7,
        _NRPPA_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7,
        _NRPPA_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20,
        _NRPPA_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21,
        NRPPA_ELEMENTARY_PROCEDURES_CLASS_1,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7,
        NRPPA_ELEMENTARY_PROCEDURES_CLASS_2,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12,
        _NRPPA_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13,
        e_CIDMeasurementInitiation,
        _e_CIDMeasurementInitiation_val_InitiatingMessage,
        _e_CIDMeasurementInitiation_val_SuccessfulOutcome,
        _e_CIDMeasurementInitiation_val_UnsuccessfulOutcome,
        e_CIDMeasurementFailureIndication,
        _e_CIDMeasurementFailureIndication_val_InitiatingMessage,
        e_CIDMeasurementReport,
        _e_CIDMeasurementReport_val_InitiatingMessage,
        e_CIDMeasurementTermination,
        _e_CIDMeasurementTermination_val_InitiatingMessage,
        oTDOAInformationExchange,
        _oTDOAInformationExchange_val_InitiatingMessage,
        _oTDOAInformationExchange_val_SuccessfulOutcome,
        _oTDOAInformationExchange_val_UnsuccessfulOutcome,
        assistanceInformationControl,
        _assistanceInformationControl_val_InitiatingMessage,
        assistanceInformationFeedback,
        _assistanceInformationFeedback_val_InitiatingMessage,
        errorIndication,
        _errorIndication_val_InitiatingMessage,
        privateMessage,
        _privateMessage_val_InitiatingMessage,
        positioningInformationExchange,
        _positioningInformationExchange_val_InitiatingMessage,
        _positioningInformationExchange_val_SuccessfulOutcome,
        _positioningInformationExchange_val_UnsuccessfulOutcome,
        positioningInformationUpdate,
        _positioningInformationUpdate_val_InitiatingMessage,
        measurement,
        _measurement_val_InitiatingMessage,
        _measurement_val_SuccessfulOutcome,
        _measurement_val_UnsuccessfulOutcome,
        measurementReport,
        _measurementReport_val_InitiatingMessage,
        measurementUpdate,
        _measurementUpdate_val_InitiatingMessage,
        measurementAbort,
        _measurementAbort_val_InitiatingMessage,
        measurementFailureIndication,
        _measurementFailureIndication_val_InitiatingMessage,
        tRPInformationExchange,
        _tRPInformationExchange_val_InitiatingMessage,
        _tRPInformationExchange_val_SuccessfulOutcome,
        _tRPInformationExchange_val_UnsuccessfulOutcome,
        positioningActivation,
        _positioningActivation_val_InitiatingMessage,
        _positioningActivation_val_SuccessfulOutcome,
        _positioningActivation_val_UnsuccessfulOutcome,
        positioningDeactivation,
        _positioningDeactivation_val_InitiatingMessage,
        pRSConfigurationExchange,
        _pRSConfigurationExchange_val_InitiatingMessage,
        _pRSConfigurationExchange_val_SuccessfulOutcome,
        _pRSConfigurationExchange_val_UnsuccessfulOutcome,
        measurementPreconfiguration,
        _measurementPreconfiguration_val_InitiatingMessage,
        _measurementPreconfiguration_val_SuccessfulOutcome,
        _measurementPreconfiguration_val_UnsuccessfulOutcome,
        measurementActivation,
        _measurementActivation_val_InitiatingMessage,
    ]

init_modules(NRPPA_CommonDataTypes, NRPPA_Constants, NRPPA_Containers, NRPPA_IEs, NRPPA_PDU_Contents, NRPPA_PDU_Descriptions)
