# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class RANAP_CommonDataTypes:

    _name_  = u'RANAP-CommonDataTypes'
    _oid_   = [0, 4, 0, 0, 20, 3, 0, 1, 3]
    
    _obj_ = [
        u'Criticality',
        u'Presence',
        u'PrivateIE-ID',
        u'ProcedureCode',
        u'ProtocolExtensionID',
        u'ProtocolIE-ID',
        u'TriggeringMessage',
        ]
    _type_ = [
        u'Criticality',
        u'Presence',
        u'PrivateIE-ID',
        u'ProcedureCode',
        u'ProtocolExtensionID',
        u'ProtocolIE-ID',
        u'TriggeringMessage',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< Criticality >-----#
    Criticality = ENUM(name=u'Criticality', mode=MODE_TYPE)
    Criticality._cont = ASN1Dict([(u'reject', 0), (u'ignore', 1), (u'notify', 2)])
    Criticality._ext = None
    
    #-----< Presence >-----#
    Presence = ENUM(name=u'Presence', mode=MODE_TYPE)
    Presence._cont = ASN1Dict([(u'optional', 0), (u'conditional', 1), (u'mandatory', 2)])
    Presence._ext = None
    
    #-----< PrivateIE-ID >-----#
    PrivateIE_ID = CHOICE(name=u'PrivateIE-ID', mode=MODE_TYPE)
    _PrivateIE_ID_local = INT(name=u'local', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrivateIE_ID_local._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PrivateIE_ID_global_ = OID(name=u'global', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    PrivateIE_ID._cont = ASN1Dict([
        (u'local', _PrivateIE_ID_local),
        (u'global', _PrivateIE_ID_global_),
        ])
    PrivateIE_ID._ext = None
    
    #-----< ProcedureCode >-----#
    ProcedureCode = INT(name=u'ProcedureCode', mode=MODE_TYPE)
    ProcedureCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ProtocolExtensionID >-----#
    ProtocolExtensionID = INT(name=u'ProtocolExtensionID', mode=MODE_TYPE)
    ProtocolExtensionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< ProtocolIE-ID >-----#
    ProtocolIE_ID = INT(name=u'ProtocolIE-ID', mode=MODE_TYPE)
    ProtocolIE_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TriggeringMessage >-----#
    TriggeringMessage = ENUM(name=u'TriggeringMessage', mode=MODE_TYPE)
    TriggeringMessage._cont = ASN1Dict([(u'initiating-message', 0), (u'successful-outcome', 1), (u'unsuccessfull-outcome', 2), (u'outcome', 3)])
    TriggeringMessage._ext = None
    
    _all_ = [
        Criticality,
        Presence,
        _PrivateIE_ID_local,
        _PrivateIE_ID_global_,
        PrivateIE_ID,
        ProcedureCode,
        ProtocolExtensionID,
        ProtocolIE_ID,
        TriggeringMessage,
    ]

class RANAP_Constants:

    _name_  = u'RANAP-Constants'
    _oid_   = [0, 4, 0, 0, 20, 3, 0, 1, 4]
    
    _obj_ = [
        u'id-RAB-Assignment',
        u'id-Iu-Release',
        u'id-RelocationPreparation',
        u'id-RelocationResourceAllocation',
        u'id-RelocationCancel',
        u'id-SRNS-ContextTransfer',
        u'id-SecurityModeControl',
        u'id-DataVolumeReport',
        u'id-Reset',
        u'id-RAB-ReleaseRequest',
        u'id-Iu-ReleaseRequest',
        u'id-RelocationDetect',
        u'id-RelocationComplete',
        u'id-Paging',
        u'id-CommonID',
        u'id-CN-InvokeTrace',
        u'id-LocationReportingControl',
        u'id-LocationReport',
        u'id-InitialUE-Message',
        u'id-DirectTransfer',
        u'id-OverloadControl',
        u'id-ErrorIndication',
        u'id-SRNS-DataForward',
        u'id-ForwardSRNS-Context',
        u'id-privateMessage',
        u'id-CN-DeactivateTrace',
        u'id-ResetResource',
        u'id-RANAP-Relocation',
        u'id-RAB-ModifyRequest',
        u'id-LocationRelatedData',
        u'id-InformationTransfer',
        u'id-UESpecificInformation',
        u'id-UplinkInformationExchange',
        u'id-DirectInformationTransfer',
        u'id-MBMSSessionStart',
        u'id-MBMSSessionUpdate',
        u'id-MBMSSessionStop',
        u'id-MBMSUELinking',
        u'id-MBMSRegistration',
        u'id-MBMSCNDe-Registration-Procedure',
        u'id-MBMSRABEstablishmentIndication',
        u'id-MBMSRABRelease',
        u'id-enhancedRelocationComplete',
        u'id-enhancedRelocationCompleteConfirm',
        u'id-RANAPenhancedRelocation',
        u'id-SRVCCPreparation',
        u'id-UeRadioCapabilityMatch',
        u'id-UeRegistrationQuery',
        u'id-RerouteNASRequest',
        u'maxPrivateIEs',
        u'maxProtocolExtensions',
        u'maxProtocolIEs',
        u'maxNrOfDTs',
        u'maxNrOfErrors',
        u'maxNrOfIuSigConIds',
        u'maxNrOfPDPDirections',
        u'maxNrOfPoints',
        u'maxNrOfRABs',
        u'maxNrOfSeparateTrafficDirections',
        u'maxNrOfSRBs',
        u'maxNrOfVol',
        u'maxNrOfLevels',
        u'maxNrOfAltValues',
        u'maxNrOfPLMNsSN',
        u'maxNrOfLAs',
        u'maxNrOfSNAs',
        u'maxNrOfUEsToBeTraced',
        u'maxNrOfInterfaces',
        u'maxRAB-Subflows',
        u'maxRAB-SubflowCombination',
        u'maxSet',
        u'maxNrOfHSDSCHMACdFlows-1',
        u'maxnoofMulticastServicesPerUE',
        u'maxnoofMulticastServicesPerRNC',
        u'maxMBMSSA',
        u'maxMBMSRA',
        u'maxNrOfEDCHMACdFlows-1',
        u'maxGANSSSet',
        u'maxNrOfCSGs',
        u'maxNrOfEUTRAFreqs',
        u'maxNrOfCellIds',
        u'maxNrOfRAIs',
        u'maxNrOfLAIs',
        u'maxSizeOfIMSInfo',
        u'maxnoofMDTPLMNs',
        u'maxAddPosSet',
        u'maxnoofPLMNs',
        u'id-AreaIdentity',
        u'id-CN-DomainIndicator',
        u'id-Cause',
        u'id-ChosenEncryptionAlgorithm',
        u'id-ChosenIntegrityProtectionAlgorithm',
        u'id-ClassmarkInformation2',
        u'id-ClassmarkInformation3',
        u'id-CriticalityDiagnostics',
        u'id-DL-GTP-PDU-SequenceNumber',
        u'id-EncryptionInformation',
        u'id-IntegrityProtectionInformation',
        u'id-IuTransportAssociation',
        u'id-L3-Information',
        u'id-LAI',
        u'id-NAS-PDU',
        u'id-NonSearchingIndication',
        u'id-NumberOfSteps',
        u'id-OMC-ID',
        u'id-OldBSS-ToNewBSS-Information',
        u'id-PagingAreaID',
        u'id-PagingCause',
        u'id-PermanentNAS-UE-ID',
        u'id-RAB-ContextItem',
        u'id-RAB-ContextList',
        u'id-RAB-DataForwardingItem',
        u'id-RAB-DataForwardingItem-SRNS-CtxReq',
        u'id-RAB-DataForwardingList',
        u'id-RAB-DataForwardingList-SRNS-CtxReq',
        u'id-RAB-DataVolumeReportItem',
        u'id-RAB-DataVolumeReportList',
        u'id-RAB-DataVolumeReportRequestItem',
        u'id-RAB-DataVolumeReportRequestList',
        u'id-RAB-FailedItem',
        u'id-RAB-FailedList',
        u'id-RAB-ID',
        u'id-RAB-QueuedItem',
        u'id-RAB-QueuedList',
        u'id-RAB-ReleaseFailedList',
        u'id-RAB-ReleaseItem',
        u'id-RAB-ReleaseList',
        u'id-RAB-ReleasedItem',
        u'id-RAB-ReleasedList',
        u'id-RAB-ReleasedList-IuRelComp',
        u'id-RAB-RelocationReleaseItem',
        u'id-RAB-RelocationReleaseList',
        u'id-RAB-SetupItem-RelocReq',
        u'id-RAB-SetupItem-RelocReqAck',
        u'id-RAB-SetupList-RelocReq',
        u'id-RAB-SetupList-RelocReqAck',
        u'id-RAB-SetupOrModifiedItem',
        u'id-RAB-SetupOrModifiedList',
        u'id-RAB-SetupOrModifyItem',
        u'id-RAB-SetupOrModifyList',
        u'id-RAC',
        u'id-RelocationType',
        u'id-RequestType',
        u'id-SAI',
        u'id-SAPI',
        u'id-SourceID',
        u'id-Source-ToTarget-TransparentContainer',
        u'id-TargetID',
        u'id-Target-ToSource-TransparentContainer',
        u'id-TemporaryUE-ID',
        u'id-TraceReference',
        u'id-TraceType',
        u'id-TransportLayerAddress',
        u'id-TriggerID',
        u'id-UE-ID',
        u'id-UL-GTP-PDU-SequenceNumber',
        u'id-RAB-FailedtoReportItem',
        u'id-RAB-FailedtoReportList',
        u'id-KeyStatus',
        u'id-DRX-CycleLengthCoefficient',
        u'id-IuSigConIdList',
        u'id-IuSigConIdItem',
        u'id-IuSigConId',
        u'id-DirectTransferInformationItem-RANAP-RelocInf',
        u'id-DirectTransferInformationList-RANAP-RelocInf',
        u'id-RAB-ContextItem-RANAP-RelocInf',
        u'id-RAB-ContextList-RANAP-RelocInf',
        u'id-RAB-ContextFailedtoTransferItem',
        u'id-RAB-ContextFailedtoTransferList',
        u'id-GlobalRNC-ID',
        u'id-RAB-ReleasedItem-IuRelComp',
        u'id-MessageStructure',
        u'id-Alt-RAB-Parameters',
        u'id-Ass-RAB-Parameters',
        u'id-RAB-ModifyList',
        u'id-RAB-ModifyItem',
        u'id-TypeOfError',
        u'id-BroadcastAssistanceDataDecipheringKeys',
        u'id-LocationRelatedDataRequestType',
        u'id-GlobalCN-ID',
        u'id-LastKnownServiceArea',
        u'id-SRB-TrCH-Mapping',
        u'id-InterSystemInformation-TransparentContainer',
        u'id-NewBSS-To-OldBSS-Information',
        u'id-SourceRNC-PDCP-context-info',
        u'id-InformationTransferID',
        u'id-SNA-Access-Information',
        u'id-ProvidedData',
        u'id-GERAN-BSC-Container',
        u'id-GERAN-Classmark',
        u'id-GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item',
        u'id-GERAN-Iumode-RAB-FailedList-RABAssgntResponse',
        u'id-VerticalAccuracyCode',
        u'id-ResponseTime',
        u'id-PositioningPriority',
        u'id-ClientType',
        u'id-LocationRelatedDataRequestTypeSpecificToGERANIuMode',
        u'id-SignallingIndication',
        u'id-hS-DSCH-MAC-d-Flow-ID',
        u'id-UESBI-Iu',
        u'id-PositionData',
        u'id-PositionDataSpecificToGERANIuMode',
        u'id-CellLoadInformationGroup',
        u'id-AccuracyFulfilmentIndicator',
        u'id-InformationTransferType',
        u'id-TraceRecordingSessionInformation',
        u'id-TracePropagationParameters',
        u'id-InterSystemInformationTransferType',
        u'id-SelectedPLMN-ID',
        u'id-RedirectionCompleted',
        u'id-RedirectionIndication',
        u'id-NAS-SequenceNumber',
        u'id-RejectCauseValue',
        u'id-APN',
        u'id-CNMBMSLinkingInformation',
        u'id-DeltaRAListofIdleModeUEs',
        u'id-FrequenceLayerConvergenceFlag',
        u'id-InformationExchangeID',
        u'id-InformationExchangeType',
        u'id-InformationRequested',
        u'id-InformationRequestType',
        u'id-IPMulticastAddress',
        u'id-JoinedMBMSBearerServicesList',
        u'id-LeftMBMSBearerServicesList',
        u'id-MBMSBearerServiceType',
        u'id-MBMSCNDe-Registration',
        u'id-MBMSServiceArea',
        u'id-MBMSSessionDuration',
        u'id-MBMSSessionIdentity',
        u'id-PDP-TypeInformation',
        u'id-RAB-Parameters',
        u'id-RAListofIdleModeUEs',
        u'id-MBMSRegistrationRequestType',
        u'id-SessionUpdateID',
        u'id-TMGI',
        u'id-TransportLayerInformation',
        u'id-UnsuccessfulLinkingList',
        u'id-MBMSLinkingInformation',
        u'id-MBMSSessionRepetitionNumber',
        u'id-AlternativeRABConfiguration',
        u'id-AlternativeRABConfigurationRequest',
        u'id-E-DCH-MAC-d-Flow-ID',
        u'id-SourceBSS-ToTargetBSS-TransparentContainer',
        u'id-TargetBSS-ToSourceBSS-TransparentContainer',
        u'id-TimeToMBMSDataTransfer',
        u'id-IncludeVelocity',
        u'id-VelocityEstimate',
        u'id-RedirectAttemptFlag',
        u'id-RAT-Type',
        u'id-PeriodicLocationInfo',
        u'id-MBMSCountingInformation',
        u'id-170-not-to-be-used-for-IE-ids',
        u'id-ExtendedRNC-ID',
        u'id-Alt-RAB-Parameter-ExtendedGuaranteedBitrateInf',
        u'id-Alt-RAB-Parameter-ExtendedMaxBitrateInf',
        u'id-Ass-RAB-Parameter-ExtendedGuaranteedBitrateList',
        u'id-Ass-RAB-Parameter-ExtendedMaxBitrateList',
        u'id-RAB-Parameter-ExtendedGuaranteedBitrateList',
        u'id-RAB-Parameter-ExtendedMaxBitrateList',
        u'id-Requested-RAB-Parameter-ExtendedMaxBitrateList',
        u'id-Requested-RAB-Parameter-ExtendedGuaranteedBitrateList',
        u'id-LAofIdleModeUEs',
        u'id-newLAListofIdleModeUEs',
        u'id-LAListwithNoIdleModeUEsAnyMore',
        u'id-183-not-to-be-used-for-IE-ids',
        u'id-GANSS-PositioningDataSet',
        u'id-RequestedGANSSAssistanceData',
        u'id-BroadcastGANSSAssistanceDataDecipheringKeys',
        u'id-d-RNTI-for-NoIuCSUP',
        u'id-RAB-SetupList-EnhancedRelocCompleteReq',
        u'id-RAB-SetupItem-EnhancedRelocCompleteReq',
        u'id-RAB-SetupList-EnhancedRelocCompleteRes',
        u'id-RAB-SetupItem-EnhancedRelocCompleteRes',
        u'id-RAB-SetupList-EnhRelocInfoReq',
        u'id-RAB-SetupItem-EnhRelocInfoReq',
        u'id-RAB-SetupList-EnhRelocInfoRes',
        u'id-RAB-SetupItem-EnhRelocInfoRes',
        u'id-OldIuSigConId',
        u'id-RAB-FailedList-EnhRelocInfoRes',
        u'id-RAB-FailedItem-EnhRelocInfoRes',
        u'id-Global-ENB-ID',
        u'id-UE-History-Information',
        u'id-MBMSSynchronisationInformation',
        u'id-SubscriberProfileIDforRFP',
        u'id-CSG-Id',
        u'id-OldIuSigConIdCS',
        u'id-OldIuSigConIdPS',
        u'id-GlobalCN-IDCS',
        u'id-GlobalCN-IDPS',
        u'id-SourceExtendedRNC-ID',
        u'id-RAB-ToBeReleasedItem-EnhancedRelocCompleteRes',
        u'id-RAB-ToBeReleasedList-EnhancedRelocCompleteRes',
        u'id-SourceRNC-ID',
        u'id-Relocation-TargetRNC-ID',
        u'id-Relocation-TargetExtendedRNC-ID',
        u'id-Alt-RAB-Parameter-SupportedGuaranteedBitrateInf',
        u'id-Alt-RAB-Parameter-SupportedMaxBitrateInf',
        u'id-Ass-RAB-Parameter-SupportedGuaranteedBitrateList',
        u'id-Ass-RAB-Parameter-SupportedMaxBitrateList',
        u'id-RAB-Parameter-SupportedGuaranteedBitrateList',
        u'id-RAB-Parameter-SupportedMaxBitrateList',
        u'id-Requested-RAB-Parameter-SupportedMaxBitrateList',
        u'id-Requested-RAB-Parameter-SupportedGuaranteedBitrateList',
        u'id-Relocation-SourceRNC-ID',
        u'id-Relocation-SourceExtendedRNC-ID',
        u'id-EncryptionKey',
        u'id-IntegrityProtectionKey',
        u'id-SRVCC-HO-Indication',
        u'id-SRVCC-Information',
        u'id-SRVCC-Operation-Possible',
        u'id-CSG-Id-List',
        u'id-PSRABtobeReplaced',
        u'id-E-UTRAN-Service-Handover',
        u'id-UE-AggregateMaximumBitRate',
        u'id-CSG-Membership-Status',
        u'id-Cell-Access-Mode',
        u'id-IP-Source-Address',
        u'id-CSFB-Information',
        u'id-PDP-TypeInformation-extension',
        u'id-MSISDN',
        u'id-Offload-RAB-Parameters',
        u'id-LGW-TransportLayerAddress',
        u'id-Correlation-ID',
        u'id-IRAT-Measurement-Configuration',
        u'id-MDT-Configuration',
        u'id-Priority-Class-Indicator',
        u'id-RNSAPRelocationParameters',
        u'id-RABParametersList',
        u'id-Management-Based-MDT-Allowed',
        u'id-HigherBitratesThan16MbpsFlag',
        u'id-Trace-Collection-Entity-IP-Addess',
        u'id-End-Of-CSFB',
        u'id-Time-UE-StayedInCell-EnhancedGranularity',
        u'id-Out-Of-UTRAN',
        u'id-TraceRecordingSessionReference',
        u'id-IMSI',
        u'id-HO-Cause',
        u'id-VoiceSupportMatchIndicator',
        u'id-RSRVCC-HO-Indication',
        u'id-RSRVCC-Information',
        u'id-AnchorPLMN-ID',
        u'id-Tunnel-Information-for-BBF',
        u'id-Management-Based-MDT-PLMN-List',
        u'id-SignallingBasedMDTPLMNList',
        u'id-M4Report',
        u'id-M5Report',
        u'id-M6Report',
        u'id-M7Report',
        u'id-TimingDifferenceULDL',
        u'id-Serving-Cell-Identifier',
        u'id-EARFCN-Extended',
        u'id-RSRVCC-Operation-Possible',
        u'id-SIPTO-LGW-TransportLayerAddress',
        u'id-SIPTO-Correlation-ID',
        u'id-LHN-ID',
        u'id-Session-Re-establishment-Indicator',
        u'id-LastE-UTRANPLMNIdentity',
        u'id-RSRQ-Type',
        u'id-RSRQ-Extension',
        u'id-Additional-CSPS-coordination-information',
        u'id-UERegistrationQueryResult',
        u'id-IuSigConIdRangeEnd',
        u'id-BarometricPressure',
        u'id-Additional-PositioningDataSet',
        u'id-CivicAddress',
        u'id-SGSN-Group-Identity',
        u'id-P-TMSI',
        u'id-RANAP-Message',
        u'id-PowerSavingIndicator',
        u'id-UE-Usage-Type',
        u'id-DCN-ID',
        u'id-UE-Application-Layer-Measurement-Configuration',
        u'id-UE-Application-Layer-Measurement-Configuration-For-Relocation',
        u'id-UE-Application-Layer-Measurement-Capability',
        u'id-UeApplicationLayerMeasurementSupportIndication',
        u'id-SRVCCSource',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        u'id-RAB-Assignment',
        u'id-Iu-Release',
        u'id-RelocationPreparation',
        u'id-RelocationResourceAllocation',
        u'id-RelocationCancel',
        u'id-SRNS-ContextTransfer',
        u'id-SecurityModeControl',
        u'id-DataVolumeReport',
        u'id-Reset',
        u'id-RAB-ReleaseRequest',
        u'id-Iu-ReleaseRequest',
        u'id-RelocationDetect',
        u'id-RelocationComplete',
        u'id-Paging',
        u'id-CommonID',
        u'id-CN-InvokeTrace',
        u'id-LocationReportingControl',
        u'id-LocationReport',
        u'id-InitialUE-Message',
        u'id-DirectTransfer',
        u'id-OverloadControl',
        u'id-ErrorIndication',
        u'id-SRNS-DataForward',
        u'id-ForwardSRNS-Context',
        u'id-privateMessage',
        u'id-CN-DeactivateTrace',
        u'id-ResetResource',
        u'id-RANAP-Relocation',
        u'id-RAB-ModifyRequest',
        u'id-LocationRelatedData',
        u'id-InformationTransfer',
        u'id-UESpecificInformation',
        u'id-UplinkInformationExchange',
        u'id-DirectInformationTransfer',
        u'id-MBMSSessionStart',
        u'id-MBMSSessionUpdate',
        u'id-MBMSSessionStop',
        u'id-MBMSUELinking',
        u'id-MBMSRegistration',
        u'id-MBMSCNDe-Registration-Procedure',
        u'id-MBMSRABEstablishmentIndication',
        u'id-MBMSRABRelease',
        u'id-enhancedRelocationComplete',
        u'id-enhancedRelocationCompleteConfirm',
        u'id-RANAPenhancedRelocation',
        u'id-SRVCCPreparation',
        u'id-UeRadioCapabilityMatch',
        u'id-UeRegistrationQuery',
        u'id-RerouteNASRequest',
        u'maxPrivateIEs',
        u'maxProtocolExtensions',
        u'maxProtocolIEs',
        u'maxNrOfDTs',
        u'maxNrOfErrors',
        u'maxNrOfIuSigConIds',
        u'maxNrOfPDPDirections',
        u'maxNrOfPoints',
        u'maxNrOfRABs',
        u'maxNrOfSeparateTrafficDirections',
        u'maxNrOfSRBs',
        u'maxNrOfVol',
        u'maxNrOfLevels',
        u'maxNrOfAltValues',
        u'maxNrOfPLMNsSN',
        u'maxNrOfLAs',
        u'maxNrOfSNAs',
        u'maxNrOfUEsToBeTraced',
        u'maxNrOfInterfaces',
        u'maxRAB-Subflows',
        u'maxRAB-SubflowCombination',
        u'maxSet',
        u'maxNrOfHSDSCHMACdFlows-1',
        u'maxnoofMulticastServicesPerUE',
        u'maxnoofMulticastServicesPerRNC',
        u'maxMBMSSA',
        u'maxMBMSRA',
        u'maxNrOfEDCHMACdFlows-1',
        u'maxGANSSSet',
        u'maxNrOfCSGs',
        u'maxNrOfEUTRAFreqs',
        u'maxNrOfCellIds',
        u'maxNrOfRAIs',
        u'maxNrOfLAIs',
        u'maxSizeOfIMSInfo',
        u'maxnoofMDTPLMNs',
        u'maxAddPosSet',
        u'maxnoofPLMNs',
        u'id-AreaIdentity',
        u'id-CN-DomainIndicator',
        u'id-Cause',
        u'id-ChosenEncryptionAlgorithm',
        u'id-ChosenIntegrityProtectionAlgorithm',
        u'id-ClassmarkInformation2',
        u'id-ClassmarkInformation3',
        u'id-CriticalityDiagnostics',
        u'id-DL-GTP-PDU-SequenceNumber',
        u'id-EncryptionInformation',
        u'id-IntegrityProtectionInformation',
        u'id-IuTransportAssociation',
        u'id-L3-Information',
        u'id-LAI',
        u'id-NAS-PDU',
        u'id-NonSearchingIndication',
        u'id-NumberOfSteps',
        u'id-OMC-ID',
        u'id-OldBSS-ToNewBSS-Information',
        u'id-PagingAreaID',
        u'id-PagingCause',
        u'id-PermanentNAS-UE-ID',
        u'id-RAB-ContextItem',
        u'id-RAB-ContextList',
        u'id-RAB-DataForwardingItem',
        u'id-RAB-DataForwardingItem-SRNS-CtxReq',
        u'id-RAB-DataForwardingList',
        u'id-RAB-DataForwardingList-SRNS-CtxReq',
        u'id-RAB-DataVolumeReportItem',
        u'id-RAB-DataVolumeReportList',
        u'id-RAB-DataVolumeReportRequestItem',
        u'id-RAB-DataVolumeReportRequestList',
        u'id-RAB-FailedItem',
        u'id-RAB-FailedList',
        u'id-RAB-ID',
        u'id-RAB-QueuedItem',
        u'id-RAB-QueuedList',
        u'id-RAB-ReleaseFailedList',
        u'id-RAB-ReleaseItem',
        u'id-RAB-ReleaseList',
        u'id-RAB-ReleasedItem',
        u'id-RAB-ReleasedList',
        u'id-RAB-ReleasedList-IuRelComp',
        u'id-RAB-RelocationReleaseItem',
        u'id-RAB-RelocationReleaseList',
        u'id-RAB-SetupItem-RelocReq',
        u'id-RAB-SetupItem-RelocReqAck',
        u'id-RAB-SetupList-RelocReq',
        u'id-RAB-SetupList-RelocReqAck',
        u'id-RAB-SetupOrModifiedItem',
        u'id-RAB-SetupOrModifiedList',
        u'id-RAB-SetupOrModifyItem',
        u'id-RAB-SetupOrModifyList',
        u'id-RAC',
        u'id-RelocationType',
        u'id-RequestType',
        u'id-SAI',
        u'id-SAPI',
        u'id-SourceID',
        u'id-Source-ToTarget-TransparentContainer',
        u'id-TargetID',
        u'id-Target-ToSource-TransparentContainer',
        u'id-TemporaryUE-ID',
        u'id-TraceReference',
        u'id-TraceType',
        u'id-TransportLayerAddress',
        u'id-TriggerID',
        u'id-UE-ID',
        u'id-UL-GTP-PDU-SequenceNumber',
        u'id-RAB-FailedtoReportItem',
        u'id-RAB-FailedtoReportList',
        u'id-KeyStatus',
        u'id-DRX-CycleLengthCoefficient',
        u'id-IuSigConIdList',
        u'id-IuSigConIdItem',
        u'id-IuSigConId',
        u'id-DirectTransferInformationItem-RANAP-RelocInf',
        u'id-DirectTransferInformationList-RANAP-RelocInf',
        u'id-RAB-ContextItem-RANAP-RelocInf',
        u'id-RAB-ContextList-RANAP-RelocInf',
        u'id-RAB-ContextFailedtoTransferItem',
        u'id-RAB-ContextFailedtoTransferList',
        u'id-GlobalRNC-ID',
        u'id-RAB-ReleasedItem-IuRelComp',
        u'id-MessageStructure',
        u'id-Alt-RAB-Parameters',
        u'id-Ass-RAB-Parameters',
        u'id-RAB-ModifyList',
        u'id-RAB-ModifyItem',
        u'id-TypeOfError',
        u'id-BroadcastAssistanceDataDecipheringKeys',
        u'id-LocationRelatedDataRequestType',
        u'id-GlobalCN-ID',
        u'id-LastKnownServiceArea',
        u'id-SRB-TrCH-Mapping',
        u'id-InterSystemInformation-TransparentContainer',
        u'id-NewBSS-To-OldBSS-Information',
        u'id-SourceRNC-PDCP-context-info',
        u'id-InformationTransferID',
        u'id-SNA-Access-Information',
        u'id-ProvidedData',
        u'id-GERAN-BSC-Container',
        u'id-GERAN-Classmark',
        u'id-GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item',
        u'id-GERAN-Iumode-RAB-FailedList-RABAssgntResponse',
        u'id-VerticalAccuracyCode',
        u'id-ResponseTime',
        u'id-PositioningPriority',
        u'id-ClientType',
        u'id-LocationRelatedDataRequestTypeSpecificToGERANIuMode',
        u'id-SignallingIndication',
        u'id-hS-DSCH-MAC-d-Flow-ID',
        u'id-UESBI-Iu',
        u'id-PositionData',
        u'id-PositionDataSpecificToGERANIuMode',
        u'id-CellLoadInformationGroup',
        u'id-AccuracyFulfilmentIndicator',
        u'id-InformationTransferType',
        u'id-TraceRecordingSessionInformation',
        u'id-TracePropagationParameters',
        u'id-InterSystemInformationTransferType',
        u'id-SelectedPLMN-ID',
        u'id-RedirectionCompleted',
        u'id-RedirectionIndication',
        u'id-NAS-SequenceNumber',
        u'id-RejectCauseValue',
        u'id-APN',
        u'id-CNMBMSLinkingInformation',
        u'id-DeltaRAListofIdleModeUEs',
        u'id-FrequenceLayerConvergenceFlag',
        u'id-InformationExchangeID',
        u'id-InformationExchangeType',
        u'id-InformationRequested',
        u'id-InformationRequestType',
        u'id-IPMulticastAddress',
        u'id-JoinedMBMSBearerServicesList',
        u'id-LeftMBMSBearerServicesList',
        u'id-MBMSBearerServiceType',
        u'id-MBMSCNDe-Registration',
        u'id-MBMSServiceArea',
        u'id-MBMSSessionDuration',
        u'id-MBMSSessionIdentity',
        u'id-PDP-TypeInformation',
        u'id-RAB-Parameters',
        u'id-RAListofIdleModeUEs',
        u'id-MBMSRegistrationRequestType',
        u'id-SessionUpdateID',
        u'id-TMGI',
        u'id-TransportLayerInformation',
        u'id-UnsuccessfulLinkingList',
        u'id-MBMSLinkingInformation',
        u'id-MBMSSessionRepetitionNumber',
        u'id-AlternativeRABConfiguration',
        u'id-AlternativeRABConfigurationRequest',
        u'id-E-DCH-MAC-d-Flow-ID',
        u'id-SourceBSS-ToTargetBSS-TransparentContainer',
        u'id-TargetBSS-ToSourceBSS-TransparentContainer',
        u'id-TimeToMBMSDataTransfer',
        u'id-IncludeVelocity',
        u'id-VelocityEstimate',
        u'id-RedirectAttemptFlag',
        u'id-RAT-Type',
        u'id-PeriodicLocationInfo',
        u'id-MBMSCountingInformation',
        u'id-170-not-to-be-used-for-IE-ids',
        u'id-ExtendedRNC-ID',
        u'id-Alt-RAB-Parameter-ExtendedGuaranteedBitrateInf',
        u'id-Alt-RAB-Parameter-ExtendedMaxBitrateInf',
        u'id-Ass-RAB-Parameter-ExtendedGuaranteedBitrateList',
        u'id-Ass-RAB-Parameter-ExtendedMaxBitrateList',
        u'id-RAB-Parameter-ExtendedGuaranteedBitrateList',
        u'id-RAB-Parameter-ExtendedMaxBitrateList',
        u'id-Requested-RAB-Parameter-ExtendedMaxBitrateList',
        u'id-Requested-RAB-Parameter-ExtendedGuaranteedBitrateList',
        u'id-LAofIdleModeUEs',
        u'id-newLAListofIdleModeUEs',
        u'id-LAListwithNoIdleModeUEsAnyMore',
        u'id-183-not-to-be-used-for-IE-ids',
        u'id-GANSS-PositioningDataSet',
        u'id-RequestedGANSSAssistanceData',
        u'id-BroadcastGANSSAssistanceDataDecipheringKeys',
        u'id-d-RNTI-for-NoIuCSUP',
        u'id-RAB-SetupList-EnhancedRelocCompleteReq',
        u'id-RAB-SetupItem-EnhancedRelocCompleteReq',
        u'id-RAB-SetupList-EnhancedRelocCompleteRes',
        u'id-RAB-SetupItem-EnhancedRelocCompleteRes',
        u'id-RAB-SetupList-EnhRelocInfoReq',
        u'id-RAB-SetupItem-EnhRelocInfoReq',
        u'id-RAB-SetupList-EnhRelocInfoRes',
        u'id-RAB-SetupItem-EnhRelocInfoRes',
        u'id-OldIuSigConId',
        u'id-RAB-FailedList-EnhRelocInfoRes',
        u'id-RAB-FailedItem-EnhRelocInfoRes',
        u'id-Global-ENB-ID',
        u'id-UE-History-Information',
        u'id-MBMSSynchronisationInformation',
        u'id-SubscriberProfileIDforRFP',
        u'id-CSG-Id',
        u'id-OldIuSigConIdCS',
        u'id-OldIuSigConIdPS',
        u'id-GlobalCN-IDCS',
        u'id-GlobalCN-IDPS',
        u'id-SourceExtendedRNC-ID',
        u'id-RAB-ToBeReleasedItem-EnhancedRelocCompleteRes',
        u'id-RAB-ToBeReleasedList-EnhancedRelocCompleteRes',
        u'id-SourceRNC-ID',
        u'id-Relocation-TargetRNC-ID',
        u'id-Relocation-TargetExtendedRNC-ID',
        u'id-Alt-RAB-Parameter-SupportedGuaranteedBitrateInf',
        u'id-Alt-RAB-Parameter-SupportedMaxBitrateInf',
        u'id-Ass-RAB-Parameter-SupportedGuaranteedBitrateList',
        u'id-Ass-RAB-Parameter-SupportedMaxBitrateList',
        u'id-RAB-Parameter-SupportedGuaranteedBitrateList',
        u'id-RAB-Parameter-SupportedMaxBitrateList',
        u'id-Requested-RAB-Parameter-SupportedMaxBitrateList',
        u'id-Requested-RAB-Parameter-SupportedGuaranteedBitrateList',
        u'id-Relocation-SourceRNC-ID',
        u'id-Relocation-SourceExtendedRNC-ID',
        u'id-EncryptionKey',
        u'id-IntegrityProtectionKey',
        u'id-SRVCC-HO-Indication',
        u'id-SRVCC-Information',
        u'id-SRVCC-Operation-Possible',
        u'id-CSG-Id-List',
        u'id-PSRABtobeReplaced',
        u'id-E-UTRAN-Service-Handover',
        u'id-UE-AggregateMaximumBitRate',
        u'id-CSG-Membership-Status',
        u'id-Cell-Access-Mode',
        u'id-IP-Source-Address',
        u'id-CSFB-Information',
        u'id-PDP-TypeInformation-extension',
        u'id-MSISDN',
        u'id-Offload-RAB-Parameters',
        u'id-LGW-TransportLayerAddress',
        u'id-Correlation-ID',
        u'id-IRAT-Measurement-Configuration',
        u'id-MDT-Configuration',
        u'id-Priority-Class-Indicator',
        u'id-RNSAPRelocationParameters',
        u'id-RABParametersList',
        u'id-Management-Based-MDT-Allowed',
        u'id-HigherBitratesThan16MbpsFlag',
        u'id-Trace-Collection-Entity-IP-Addess',
        u'id-End-Of-CSFB',
        u'id-Time-UE-StayedInCell-EnhancedGranularity',
        u'id-Out-Of-UTRAN',
        u'id-TraceRecordingSessionReference',
        u'id-IMSI',
        u'id-HO-Cause',
        u'id-VoiceSupportMatchIndicator',
        u'id-RSRVCC-HO-Indication',
        u'id-RSRVCC-Information',
        u'id-AnchorPLMN-ID',
        u'id-Tunnel-Information-for-BBF',
        u'id-Management-Based-MDT-PLMN-List',
        u'id-SignallingBasedMDTPLMNList',
        u'id-M4Report',
        u'id-M5Report',
        u'id-M6Report',
        u'id-M7Report',
        u'id-TimingDifferenceULDL',
        u'id-Serving-Cell-Identifier',
        u'id-EARFCN-Extended',
        u'id-RSRVCC-Operation-Possible',
        u'id-SIPTO-LGW-TransportLayerAddress',
        u'id-SIPTO-Correlation-ID',
        u'id-LHN-ID',
        u'id-Session-Re-establishment-Indicator',
        u'id-LastE-UTRANPLMNIdentity',
        u'id-RSRQ-Type',
        u'id-RSRQ-Extension',
        u'id-Additional-CSPS-coordination-information',
        u'id-UERegistrationQueryResult',
        u'id-IuSigConIdRangeEnd',
        u'id-BarometricPressure',
        u'id-Additional-PositioningDataSet',
        u'id-CivicAddress',
        u'id-SGSN-Group-Identity',
        u'id-P-TMSI',
        u'id-RANAP-Message',
        u'id-PowerSavingIndicator',
        u'id-UE-Usage-Type',
        u'id-DCN-ID',
        u'id-UE-Application-Layer-Measurement-Configuration',
        u'id-UE-Application-Layer-Measurement-Configuration-For-Relocation',
        u'id-UE-Application-Layer-Measurement-Capability',
        u'id-UeApplicationLayerMeasurementSupportIndication',
        u'id-SRVCCSource',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< id-RAB-Assignment >-----#
    id_RAB_Assignment = INT(name=u'id-RAB-Assignment', mode=MODE_VALUE)
    id_RAB_Assignment._val = 0
    
    #-----< id-Iu-Release >-----#
    id_Iu_Release = INT(name=u'id-Iu-Release', mode=MODE_VALUE)
    id_Iu_Release._val = 1
    
    #-----< id-RelocationPreparation >-----#
    id_RelocationPreparation = INT(name=u'id-RelocationPreparation', mode=MODE_VALUE)
    id_RelocationPreparation._val = 2
    
    #-----< id-RelocationResourceAllocation >-----#
    id_RelocationResourceAllocation = INT(name=u'id-RelocationResourceAllocation', mode=MODE_VALUE)
    id_RelocationResourceAllocation._val = 3
    
    #-----< id-RelocationCancel >-----#
    id_RelocationCancel = INT(name=u'id-RelocationCancel', mode=MODE_VALUE)
    id_RelocationCancel._val = 4
    
    #-----< id-SRNS-ContextTransfer >-----#
    id_SRNS_ContextTransfer = INT(name=u'id-SRNS-ContextTransfer', mode=MODE_VALUE)
    id_SRNS_ContextTransfer._val = 5
    
    #-----< id-SecurityModeControl >-----#
    id_SecurityModeControl = INT(name=u'id-SecurityModeControl', mode=MODE_VALUE)
    id_SecurityModeControl._val = 6
    
    #-----< id-DataVolumeReport >-----#
    id_DataVolumeReport = INT(name=u'id-DataVolumeReport', mode=MODE_VALUE)
    id_DataVolumeReport._val = 7
    
    #-----< id-Reset >-----#
    id_Reset = INT(name=u'id-Reset', mode=MODE_VALUE)
    id_Reset._val = 9
    
    #-----< id-RAB-ReleaseRequest >-----#
    id_RAB_ReleaseRequest = INT(name=u'id-RAB-ReleaseRequest', mode=MODE_VALUE)
    id_RAB_ReleaseRequest._val = 10
    
    #-----< id-Iu-ReleaseRequest >-----#
    id_Iu_ReleaseRequest = INT(name=u'id-Iu-ReleaseRequest', mode=MODE_VALUE)
    id_Iu_ReleaseRequest._val = 11
    
    #-----< id-RelocationDetect >-----#
    id_RelocationDetect = INT(name=u'id-RelocationDetect', mode=MODE_VALUE)
    id_RelocationDetect._val = 12
    
    #-----< id-RelocationComplete >-----#
    id_RelocationComplete = INT(name=u'id-RelocationComplete', mode=MODE_VALUE)
    id_RelocationComplete._val = 13
    
    #-----< id-Paging >-----#
    id_Paging = INT(name=u'id-Paging', mode=MODE_VALUE)
    id_Paging._val = 14
    
    #-----< id-CommonID >-----#
    id_CommonID = INT(name=u'id-CommonID', mode=MODE_VALUE)
    id_CommonID._val = 15
    
    #-----< id-CN-InvokeTrace >-----#
    id_CN_InvokeTrace = INT(name=u'id-CN-InvokeTrace', mode=MODE_VALUE)
    id_CN_InvokeTrace._val = 16
    
    #-----< id-LocationReportingControl >-----#
    id_LocationReportingControl = INT(name=u'id-LocationReportingControl', mode=MODE_VALUE)
    id_LocationReportingControl._val = 17
    
    #-----< id-LocationReport >-----#
    id_LocationReport = INT(name=u'id-LocationReport', mode=MODE_VALUE)
    id_LocationReport._val = 18
    
    #-----< id-InitialUE-Message >-----#
    id_InitialUE_Message = INT(name=u'id-InitialUE-Message', mode=MODE_VALUE)
    id_InitialUE_Message._val = 19
    
    #-----< id-DirectTransfer >-----#
    id_DirectTransfer = INT(name=u'id-DirectTransfer', mode=MODE_VALUE)
    id_DirectTransfer._val = 20
    
    #-----< id-OverloadControl >-----#
    id_OverloadControl = INT(name=u'id-OverloadControl', mode=MODE_VALUE)
    id_OverloadControl._val = 21
    
    #-----< id-ErrorIndication >-----#
    id_ErrorIndication = INT(name=u'id-ErrorIndication', mode=MODE_VALUE)
    id_ErrorIndication._val = 22
    
    #-----< id-SRNS-DataForward >-----#
    id_SRNS_DataForward = INT(name=u'id-SRNS-DataForward', mode=MODE_VALUE)
    id_SRNS_DataForward._val = 23
    
    #-----< id-ForwardSRNS-Context >-----#
    id_ForwardSRNS_Context = INT(name=u'id-ForwardSRNS-Context', mode=MODE_VALUE)
    id_ForwardSRNS_Context._val = 24
    
    #-----< id-privateMessage >-----#
    id_privateMessage = INT(name=u'id-privateMessage', mode=MODE_VALUE)
    id_privateMessage._val = 25
    
    #-----< id-CN-DeactivateTrace >-----#
    id_CN_DeactivateTrace = INT(name=u'id-CN-DeactivateTrace', mode=MODE_VALUE)
    id_CN_DeactivateTrace._val = 26
    
    #-----< id-ResetResource >-----#
    id_ResetResource = INT(name=u'id-ResetResource', mode=MODE_VALUE)
    id_ResetResource._val = 27
    
    #-----< id-RANAP-Relocation >-----#
    id_RANAP_Relocation = INT(name=u'id-RANAP-Relocation', mode=MODE_VALUE)
    id_RANAP_Relocation._val = 28
    
    #-----< id-RAB-ModifyRequest >-----#
    id_RAB_ModifyRequest = INT(name=u'id-RAB-ModifyRequest', mode=MODE_VALUE)
    id_RAB_ModifyRequest._val = 29
    
    #-----< id-LocationRelatedData >-----#
    id_LocationRelatedData = INT(name=u'id-LocationRelatedData', mode=MODE_VALUE)
    id_LocationRelatedData._val = 30
    
    #-----< id-InformationTransfer >-----#
    id_InformationTransfer = INT(name=u'id-InformationTransfer', mode=MODE_VALUE)
    id_InformationTransfer._val = 31
    
    #-----< id-UESpecificInformation >-----#
    id_UESpecificInformation = INT(name=u'id-UESpecificInformation', mode=MODE_VALUE)
    id_UESpecificInformation._val = 32
    
    #-----< id-UplinkInformationExchange >-----#
    id_UplinkInformationExchange = INT(name=u'id-UplinkInformationExchange', mode=MODE_VALUE)
    id_UplinkInformationExchange._val = 33
    
    #-----< id-DirectInformationTransfer >-----#
    id_DirectInformationTransfer = INT(name=u'id-DirectInformationTransfer', mode=MODE_VALUE)
    id_DirectInformationTransfer._val = 34
    
    #-----< id-MBMSSessionStart >-----#
    id_MBMSSessionStart = INT(name=u'id-MBMSSessionStart', mode=MODE_VALUE)
    id_MBMSSessionStart._val = 35
    
    #-----< id-MBMSSessionUpdate >-----#
    id_MBMSSessionUpdate = INT(name=u'id-MBMSSessionUpdate', mode=MODE_VALUE)
    id_MBMSSessionUpdate._val = 36
    
    #-----< id-MBMSSessionStop >-----#
    id_MBMSSessionStop = INT(name=u'id-MBMSSessionStop', mode=MODE_VALUE)
    id_MBMSSessionStop._val = 37
    
    #-----< id-MBMSUELinking >-----#
    id_MBMSUELinking = INT(name=u'id-MBMSUELinking', mode=MODE_VALUE)
    id_MBMSUELinking._val = 38
    
    #-----< id-MBMSRegistration >-----#
    id_MBMSRegistration = INT(name=u'id-MBMSRegistration', mode=MODE_VALUE)
    id_MBMSRegistration._val = 39
    
    #-----< id-MBMSCNDe-Registration-Procedure >-----#
    id_MBMSCNDe_Registration_Procedure = INT(name=u'id-MBMSCNDe-Registration-Procedure', mode=MODE_VALUE)
    id_MBMSCNDe_Registration_Procedure._val = 40
    
    #-----< id-MBMSRABEstablishmentIndication >-----#
    id_MBMSRABEstablishmentIndication = INT(name=u'id-MBMSRABEstablishmentIndication', mode=MODE_VALUE)
    id_MBMSRABEstablishmentIndication._val = 41
    
    #-----< id-MBMSRABRelease >-----#
    id_MBMSRABRelease = INT(name=u'id-MBMSRABRelease', mode=MODE_VALUE)
    id_MBMSRABRelease._val = 42
    
    #-----< id-enhancedRelocationComplete >-----#
    id_enhancedRelocationComplete = INT(name=u'id-enhancedRelocationComplete', mode=MODE_VALUE)
    id_enhancedRelocationComplete._val = 43
    
    #-----< id-enhancedRelocationCompleteConfirm >-----#
    id_enhancedRelocationCompleteConfirm = INT(name=u'id-enhancedRelocationCompleteConfirm', mode=MODE_VALUE)
    id_enhancedRelocationCompleteConfirm._val = 44
    
    #-----< id-RANAPenhancedRelocation >-----#
    id_RANAPenhancedRelocation = INT(name=u'id-RANAPenhancedRelocation', mode=MODE_VALUE)
    id_RANAPenhancedRelocation._val = 45
    
    #-----< id-SRVCCPreparation >-----#
    id_SRVCCPreparation = INT(name=u'id-SRVCCPreparation', mode=MODE_VALUE)
    id_SRVCCPreparation._val = 46
    
    #-----< id-UeRadioCapabilityMatch >-----#
    id_UeRadioCapabilityMatch = INT(name=u'id-UeRadioCapabilityMatch', mode=MODE_VALUE)
    id_UeRadioCapabilityMatch._val = 47
    
    #-----< id-UeRegistrationQuery >-----#
    id_UeRegistrationQuery = INT(name=u'id-UeRegistrationQuery', mode=MODE_VALUE)
    id_UeRegistrationQuery._val = 48
    
    #-----< id-RerouteNASRequest >-----#
    id_RerouteNASRequest = INT(name=u'id-RerouteNASRequest', mode=MODE_VALUE)
    id_RerouteNASRequest._val = 49
    
    #-----< maxPrivateIEs >-----#
    maxPrivateIEs = INT(name=u'maxPrivateIEs', mode=MODE_VALUE)
    maxPrivateIEs._val = 65535
    
    #-----< maxProtocolExtensions >-----#
    maxProtocolExtensions = INT(name=u'maxProtocolExtensions', mode=MODE_VALUE)
    maxProtocolExtensions._val = 65535
    
    #-----< maxProtocolIEs >-----#
    maxProtocolIEs = INT(name=u'maxProtocolIEs', mode=MODE_VALUE)
    maxProtocolIEs._val = 65535
    
    #-----< maxNrOfDTs >-----#
    maxNrOfDTs = INT(name=u'maxNrOfDTs', mode=MODE_VALUE)
    maxNrOfDTs._val = 15
    
    #-----< maxNrOfErrors >-----#
    maxNrOfErrors = INT(name=u'maxNrOfErrors', mode=MODE_VALUE)
    maxNrOfErrors._val = 256
    
    #-----< maxNrOfIuSigConIds >-----#
    maxNrOfIuSigConIds = INT(name=u'maxNrOfIuSigConIds', mode=MODE_VALUE)
    maxNrOfIuSigConIds._val = 250
    
    #-----< maxNrOfPDPDirections >-----#
    maxNrOfPDPDirections = INT(name=u'maxNrOfPDPDirections', mode=MODE_VALUE)
    maxNrOfPDPDirections._val = 2
    
    #-----< maxNrOfPoints >-----#
    maxNrOfPoints = INT(name=u'maxNrOfPoints', mode=MODE_VALUE)
    maxNrOfPoints._val = 15
    
    #-----< maxNrOfRABs >-----#
    maxNrOfRABs = INT(name=u'maxNrOfRABs', mode=MODE_VALUE)
    maxNrOfRABs._val = 256
    
    #-----< maxNrOfSeparateTrafficDirections >-----#
    maxNrOfSeparateTrafficDirections = INT(name=u'maxNrOfSeparateTrafficDirections', mode=MODE_VALUE)
    maxNrOfSeparateTrafficDirections._val = 2
    
    #-----< maxNrOfSRBs >-----#
    maxNrOfSRBs = INT(name=u'maxNrOfSRBs', mode=MODE_VALUE)
    maxNrOfSRBs._val = 8
    
    #-----< maxNrOfVol >-----#
    maxNrOfVol = INT(name=u'maxNrOfVol', mode=MODE_VALUE)
    maxNrOfVol._val = 2
    
    #-----< maxNrOfLevels >-----#
    maxNrOfLevels = INT(name=u'maxNrOfLevels', mode=MODE_VALUE)
    maxNrOfLevels._val = 256
    
    #-----< maxNrOfAltValues >-----#
    maxNrOfAltValues = INT(name=u'maxNrOfAltValues', mode=MODE_VALUE)
    maxNrOfAltValues._val = 16
    
    #-----< maxNrOfPLMNsSN >-----#
    maxNrOfPLMNsSN = INT(name=u'maxNrOfPLMNsSN', mode=MODE_VALUE)
    maxNrOfPLMNsSN._val = 32
    
    #-----< maxNrOfLAs >-----#
    maxNrOfLAs = INT(name=u'maxNrOfLAs', mode=MODE_VALUE)
    maxNrOfLAs._val = 65536
    
    #-----< maxNrOfSNAs >-----#
    maxNrOfSNAs = INT(name=u'maxNrOfSNAs', mode=MODE_VALUE)
    maxNrOfSNAs._val = 65536
    
    #-----< maxNrOfUEsToBeTraced >-----#
    maxNrOfUEsToBeTraced = INT(name=u'maxNrOfUEsToBeTraced', mode=MODE_VALUE)
    maxNrOfUEsToBeTraced._val = 64
    
    #-----< maxNrOfInterfaces >-----#
    maxNrOfInterfaces = INT(name=u'maxNrOfInterfaces', mode=MODE_VALUE)
    maxNrOfInterfaces._val = 16
    
    #-----< maxRAB-Subflows >-----#
    maxRAB_Subflows = INT(name=u'maxRAB-Subflows', mode=MODE_VALUE)
    maxRAB_Subflows._val = 7
    
    #-----< maxRAB-SubflowCombination >-----#
    maxRAB_SubflowCombination = INT(name=u'maxRAB-SubflowCombination', mode=MODE_VALUE)
    maxRAB_SubflowCombination._val = 64
    
    #-----< maxSet >-----#
    maxSet = INT(name=u'maxSet', mode=MODE_VALUE)
    maxSet._val = 9
    
    #-----< maxNrOfHSDSCHMACdFlows-1 >-----#
    maxNrOfHSDSCHMACdFlows_1 = INT(name=u'maxNrOfHSDSCHMACdFlows-1', mode=MODE_VALUE)
    maxNrOfHSDSCHMACdFlows_1._val = 7
    
    #-----< maxnoofMulticastServicesPerUE >-----#
    maxnoofMulticastServicesPerUE = INT(name=u'maxnoofMulticastServicesPerUE', mode=MODE_VALUE)
    maxnoofMulticastServicesPerUE._val = 128
    
    #-----< maxnoofMulticastServicesPerRNC >-----#
    maxnoofMulticastServicesPerRNC = INT(name=u'maxnoofMulticastServicesPerRNC', mode=MODE_VALUE)
    maxnoofMulticastServicesPerRNC._val = 512
    
    #-----< maxMBMSSA >-----#
    maxMBMSSA = INT(name=u'maxMBMSSA', mode=MODE_VALUE)
    maxMBMSSA._val = 256
    
    #-----< maxMBMSRA >-----#
    maxMBMSRA = INT(name=u'maxMBMSRA', mode=MODE_VALUE)
    maxMBMSRA._val = 65536
    
    #-----< maxNrOfEDCHMACdFlows-1 >-----#
    maxNrOfEDCHMACdFlows_1 = INT(name=u'maxNrOfEDCHMACdFlows-1', mode=MODE_VALUE)
    maxNrOfEDCHMACdFlows_1._val = 7
    
    #-----< maxGANSSSet >-----#
    maxGANSSSet = INT(name=u'maxGANSSSet', mode=MODE_VALUE)
    maxGANSSSet._val = 9
    
    #-----< maxNrOfCSGs >-----#
    maxNrOfCSGs = INT(name=u'maxNrOfCSGs', mode=MODE_VALUE)
    maxNrOfCSGs._val = 256
    
    #-----< maxNrOfEUTRAFreqs >-----#
    maxNrOfEUTRAFreqs = INT(name=u'maxNrOfEUTRAFreqs', mode=MODE_VALUE)
    maxNrOfEUTRAFreqs._val = 8
    
    #-----< maxNrOfCellIds >-----#
    maxNrOfCellIds = INT(name=u'maxNrOfCellIds', mode=MODE_VALUE)
    maxNrOfCellIds._val = 32
    
    #-----< maxNrOfRAIs >-----#
    maxNrOfRAIs = INT(name=u'maxNrOfRAIs', mode=MODE_VALUE)
    maxNrOfRAIs._val = 8
    
    #-----< maxNrOfLAIs >-----#
    maxNrOfLAIs = INT(name=u'maxNrOfLAIs', mode=MODE_VALUE)
    maxNrOfLAIs._val = 8
    
    #-----< maxSizeOfIMSInfo >-----#
    maxSizeOfIMSInfo = INT(name=u'maxSizeOfIMSInfo', mode=MODE_VALUE)
    maxSizeOfIMSInfo._val = 32
    
    #-----< maxnoofMDTPLMNs >-----#
    maxnoofMDTPLMNs = INT(name=u'maxnoofMDTPLMNs', mode=MODE_VALUE)
    maxnoofMDTPLMNs._val = 16
    
    #-----< maxAddPosSet >-----#
    maxAddPosSet = INT(name=u'maxAddPosSet', mode=MODE_VALUE)
    maxAddPosSet._val = 8
    
    #-----< maxnoofPLMNs >-----#
    maxnoofPLMNs = INT(name=u'maxnoofPLMNs', mode=MODE_VALUE)
    maxnoofPLMNs._val = 16
    
    #-----< id-AreaIdentity >-----#
    id_AreaIdentity = INT(name=u'id-AreaIdentity', mode=MODE_VALUE)
    id_AreaIdentity._val = 0
    
    #-----< id-CN-DomainIndicator >-----#
    id_CN_DomainIndicator = INT(name=u'id-CN-DomainIndicator', mode=MODE_VALUE)
    id_CN_DomainIndicator._val = 3
    
    #-----< id-Cause >-----#
    id_Cause = INT(name=u'id-Cause', mode=MODE_VALUE)
    id_Cause._val = 4
    
    #-----< id-ChosenEncryptionAlgorithm >-----#
    id_ChosenEncryptionAlgorithm = INT(name=u'id-ChosenEncryptionAlgorithm', mode=MODE_VALUE)
    id_ChosenEncryptionAlgorithm._val = 5
    
    #-----< id-ChosenIntegrityProtectionAlgorithm >-----#
    id_ChosenIntegrityProtectionAlgorithm = INT(name=u'id-ChosenIntegrityProtectionAlgorithm', mode=MODE_VALUE)
    id_ChosenIntegrityProtectionAlgorithm._val = 6
    
    #-----< id-ClassmarkInformation2 >-----#
    id_ClassmarkInformation2 = INT(name=u'id-ClassmarkInformation2', mode=MODE_VALUE)
    id_ClassmarkInformation2._val = 7
    
    #-----< id-ClassmarkInformation3 >-----#
    id_ClassmarkInformation3 = INT(name=u'id-ClassmarkInformation3', mode=MODE_VALUE)
    id_ClassmarkInformation3._val = 8
    
    #-----< id-CriticalityDiagnostics >-----#
    id_CriticalityDiagnostics = INT(name=u'id-CriticalityDiagnostics', mode=MODE_VALUE)
    id_CriticalityDiagnostics._val = 9
    
    #-----< id-DL-GTP-PDU-SequenceNumber >-----#
    id_DL_GTP_PDU_SequenceNumber = INT(name=u'id-DL-GTP-PDU-SequenceNumber', mode=MODE_VALUE)
    id_DL_GTP_PDU_SequenceNumber._val = 10
    
    #-----< id-EncryptionInformation >-----#
    id_EncryptionInformation = INT(name=u'id-EncryptionInformation', mode=MODE_VALUE)
    id_EncryptionInformation._val = 11
    
    #-----< id-IntegrityProtectionInformation >-----#
    id_IntegrityProtectionInformation = INT(name=u'id-IntegrityProtectionInformation', mode=MODE_VALUE)
    id_IntegrityProtectionInformation._val = 12
    
    #-----< id-IuTransportAssociation >-----#
    id_IuTransportAssociation = INT(name=u'id-IuTransportAssociation', mode=MODE_VALUE)
    id_IuTransportAssociation._val = 13
    
    #-----< id-L3-Information >-----#
    id_L3_Information = INT(name=u'id-L3-Information', mode=MODE_VALUE)
    id_L3_Information._val = 14
    
    #-----< id-LAI >-----#
    id_LAI = INT(name=u'id-LAI', mode=MODE_VALUE)
    id_LAI._val = 15
    
    #-----< id-NAS-PDU >-----#
    id_NAS_PDU = INT(name=u'id-NAS-PDU', mode=MODE_VALUE)
    id_NAS_PDU._val = 16
    
    #-----< id-NonSearchingIndication >-----#
    id_NonSearchingIndication = INT(name=u'id-NonSearchingIndication', mode=MODE_VALUE)
    id_NonSearchingIndication._val = 17
    
    #-----< id-NumberOfSteps >-----#
    id_NumberOfSteps = INT(name=u'id-NumberOfSteps', mode=MODE_VALUE)
    id_NumberOfSteps._val = 18
    
    #-----< id-OMC-ID >-----#
    id_OMC_ID = INT(name=u'id-OMC-ID', mode=MODE_VALUE)
    id_OMC_ID._val = 19
    
    #-----< id-OldBSS-ToNewBSS-Information >-----#
    id_OldBSS_ToNewBSS_Information = INT(name=u'id-OldBSS-ToNewBSS-Information', mode=MODE_VALUE)
    id_OldBSS_ToNewBSS_Information._val = 20
    
    #-----< id-PagingAreaID >-----#
    id_PagingAreaID = INT(name=u'id-PagingAreaID', mode=MODE_VALUE)
    id_PagingAreaID._val = 21
    
    #-----< id-PagingCause >-----#
    id_PagingCause = INT(name=u'id-PagingCause', mode=MODE_VALUE)
    id_PagingCause._val = 22
    
    #-----< id-PermanentNAS-UE-ID >-----#
    id_PermanentNAS_UE_ID = INT(name=u'id-PermanentNAS-UE-ID', mode=MODE_VALUE)
    id_PermanentNAS_UE_ID._val = 23
    
    #-----< id-RAB-ContextItem >-----#
    id_RAB_ContextItem = INT(name=u'id-RAB-ContextItem', mode=MODE_VALUE)
    id_RAB_ContextItem._val = 24
    
    #-----< id-RAB-ContextList >-----#
    id_RAB_ContextList = INT(name=u'id-RAB-ContextList', mode=MODE_VALUE)
    id_RAB_ContextList._val = 25
    
    #-----< id-RAB-DataForwardingItem >-----#
    id_RAB_DataForwardingItem = INT(name=u'id-RAB-DataForwardingItem', mode=MODE_VALUE)
    id_RAB_DataForwardingItem._val = 26
    
    #-----< id-RAB-DataForwardingItem-SRNS-CtxReq >-----#
    id_RAB_DataForwardingItem_SRNS_CtxReq = INT(name=u'id-RAB-DataForwardingItem-SRNS-CtxReq', mode=MODE_VALUE)
    id_RAB_DataForwardingItem_SRNS_CtxReq._val = 27
    
    #-----< id-RAB-DataForwardingList >-----#
    id_RAB_DataForwardingList = INT(name=u'id-RAB-DataForwardingList', mode=MODE_VALUE)
    id_RAB_DataForwardingList._val = 28
    
    #-----< id-RAB-DataForwardingList-SRNS-CtxReq >-----#
    id_RAB_DataForwardingList_SRNS_CtxReq = INT(name=u'id-RAB-DataForwardingList-SRNS-CtxReq', mode=MODE_VALUE)
    id_RAB_DataForwardingList_SRNS_CtxReq._val = 29
    
    #-----< id-RAB-DataVolumeReportItem >-----#
    id_RAB_DataVolumeReportItem = INT(name=u'id-RAB-DataVolumeReportItem', mode=MODE_VALUE)
    id_RAB_DataVolumeReportItem._val = 30
    
    #-----< id-RAB-DataVolumeReportList >-----#
    id_RAB_DataVolumeReportList = INT(name=u'id-RAB-DataVolumeReportList', mode=MODE_VALUE)
    id_RAB_DataVolumeReportList._val = 31
    
    #-----< id-RAB-DataVolumeReportRequestItem >-----#
    id_RAB_DataVolumeReportRequestItem = INT(name=u'id-RAB-DataVolumeReportRequestItem', mode=MODE_VALUE)
    id_RAB_DataVolumeReportRequestItem._val = 32
    
    #-----< id-RAB-DataVolumeReportRequestList >-----#
    id_RAB_DataVolumeReportRequestList = INT(name=u'id-RAB-DataVolumeReportRequestList', mode=MODE_VALUE)
    id_RAB_DataVolumeReportRequestList._val = 33
    
    #-----< id-RAB-FailedItem >-----#
    id_RAB_FailedItem = INT(name=u'id-RAB-FailedItem', mode=MODE_VALUE)
    id_RAB_FailedItem._val = 34
    
    #-----< id-RAB-FailedList >-----#
    id_RAB_FailedList = INT(name=u'id-RAB-FailedList', mode=MODE_VALUE)
    id_RAB_FailedList._val = 35
    
    #-----< id-RAB-ID >-----#
    id_RAB_ID = INT(name=u'id-RAB-ID', mode=MODE_VALUE)
    id_RAB_ID._val = 36
    
    #-----< id-RAB-QueuedItem >-----#
    id_RAB_QueuedItem = INT(name=u'id-RAB-QueuedItem', mode=MODE_VALUE)
    id_RAB_QueuedItem._val = 37
    
    #-----< id-RAB-QueuedList >-----#
    id_RAB_QueuedList = INT(name=u'id-RAB-QueuedList', mode=MODE_VALUE)
    id_RAB_QueuedList._val = 38
    
    #-----< id-RAB-ReleaseFailedList >-----#
    id_RAB_ReleaseFailedList = INT(name=u'id-RAB-ReleaseFailedList', mode=MODE_VALUE)
    id_RAB_ReleaseFailedList._val = 39
    
    #-----< id-RAB-ReleaseItem >-----#
    id_RAB_ReleaseItem = INT(name=u'id-RAB-ReleaseItem', mode=MODE_VALUE)
    id_RAB_ReleaseItem._val = 40
    
    #-----< id-RAB-ReleaseList >-----#
    id_RAB_ReleaseList = INT(name=u'id-RAB-ReleaseList', mode=MODE_VALUE)
    id_RAB_ReleaseList._val = 41
    
    #-----< id-RAB-ReleasedItem >-----#
    id_RAB_ReleasedItem = INT(name=u'id-RAB-ReleasedItem', mode=MODE_VALUE)
    id_RAB_ReleasedItem._val = 42
    
    #-----< id-RAB-ReleasedList >-----#
    id_RAB_ReleasedList = INT(name=u'id-RAB-ReleasedList', mode=MODE_VALUE)
    id_RAB_ReleasedList._val = 43
    
    #-----< id-RAB-ReleasedList-IuRelComp >-----#
    id_RAB_ReleasedList_IuRelComp = INT(name=u'id-RAB-ReleasedList-IuRelComp', mode=MODE_VALUE)
    id_RAB_ReleasedList_IuRelComp._val = 44
    
    #-----< id-RAB-RelocationReleaseItem >-----#
    id_RAB_RelocationReleaseItem = INT(name=u'id-RAB-RelocationReleaseItem', mode=MODE_VALUE)
    id_RAB_RelocationReleaseItem._val = 45
    
    #-----< id-RAB-RelocationReleaseList >-----#
    id_RAB_RelocationReleaseList = INT(name=u'id-RAB-RelocationReleaseList', mode=MODE_VALUE)
    id_RAB_RelocationReleaseList._val = 46
    
    #-----< id-RAB-SetupItem-RelocReq >-----#
    id_RAB_SetupItem_RelocReq = INT(name=u'id-RAB-SetupItem-RelocReq', mode=MODE_VALUE)
    id_RAB_SetupItem_RelocReq._val = 47
    
    #-----< id-RAB-SetupItem-RelocReqAck >-----#
    id_RAB_SetupItem_RelocReqAck = INT(name=u'id-RAB-SetupItem-RelocReqAck', mode=MODE_VALUE)
    id_RAB_SetupItem_RelocReqAck._val = 48
    
    #-----< id-RAB-SetupList-RelocReq >-----#
    id_RAB_SetupList_RelocReq = INT(name=u'id-RAB-SetupList-RelocReq', mode=MODE_VALUE)
    id_RAB_SetupList_RelocReq._val = 49
    
    #-----< id-RAB-SetupList-RelocReqAck >-----#
    id_RAB_SetupList_RelocReqAck = INT(name=u'id-RAB-SetupList-RelocReqAck', mode=MODE_VALUE)
    id_RAB_SetupList_RelocReqAck._val = 50
    
    #-----< id-RAB-SetupOrModifiedItem >-----#
    id_RAB_SetupOrModifiedItem = INT(name=u'id-RAB-SetupOrModifiedItem', mode=MODE_VALUE)
    id_RAB_SetupOrModifiedItem._val = 51
    
    #-----< id-RAB-SetupOrModifiedList >-----#
    id_RAB_SetupOrModifiedList = INT(name=u'id-RAB-SetupOrModifiedList', mode=MODE_VALUE)
    id_RAB_SetupOrModifiedList._val = 52
    
    #-----< id-RAB-SetupOrModifyItem >-----#
    id_RAB_SetupOrModifyItem = INT(name=u'id-RAB-SetupOrModifyItem', mode=MODE_VALUE)
    id_RAB_SetupOrModifyItem._val = 53
    
    #-----< id-RAB-SetupOrModifyList >-----#
    id_RAB_SetupOrModifyList = INT(name=u'id-RAB-SetupOrModifyList', mode=MODE_VALUE)
    id_RAB_SetupOrModifyList._val = 54
    
    #-----< id-RAC >-----#
    id_RAC = INT(name=u'id-RAC', mode=MODE_VALUE)
    id_RAC._val = 55
    
    #-----< id-RelocationType >-----#
    id_RelocationType = INT(name=u'id-RelocationType', mode=MODE_VALUE)
    id_RelocationType._val = 56
    
    #-----< id-RequestType >-----#
    id_RequestType = INT(name=u'id-RequestType', mode=MODE_VALUE)
    id_RequestType._val = 57
    
    #-----< id-SAI >-----#
    id_SAI = INT(name=u'id-SAI', mode=MODE_VALUE)
    id_SAI._val = 58
    
    #-----< id-SAPI >-----#
    id_SAPI = INT(name=u'id-SAPI', mode=MODE_VALUE)
    id_SAPI._val = 59
    
    #-----< id-SourceID >-----#
    id_SourceID = INT(name=u'id-SourceID', mode=MODE_VALUE)
    id_SourceID._val = 60
    
    #-----< id-Source-ToTarget-TransparentContainer >-----#
    id_Source_ToTarget_TransparentContainer = INT(name=u'id-Source-ToTarget-TransparentContainer', mode=MODE_VALUE)
    id_Source_ToTarget_TransparentContainer._val = 61
    
    #-----< id-TargetID >-----#
    id_TargetID = INT(name=u'id-TargetID', mode=MODE_VALUE)
    id_TargetID._val = 62
    
    #-----< id-Target-ToSource-TransparentContainer >-----#
    id_Target_ToSource_TransparentContainer = INT(name=u'id-Target-ToSource-TransparentContainer', mode=MODE_VALUE)
    id_Target_ToSource_TransparentContainer._val = 63
    
    #-----< id-TemporaryUE-ID >-----#
    id_TemporaryUE_ID = INT(name=u'id-TemporaryUE-ID', mode=MODE_VALUE)
    id_TemporaryUE_ID._val = 64
    
    #-----< id-TraceReference >-----#
    id_TraceReference = INT(name=u'id-TraceReference', mode=MODE_VALUE)
    id_TraceReference._val = 65
    
    #-----< id-TraceType >-----#
    id_TraceType = INT(name=u'id-TraceType', mode=MODE_VALUE)
    id_TraceType._val = 66
    
    #-----< id-TransportLayerAddress >-----#
    id_TransportLayerAddress = INT(name=u'id-TransportLayerAddress', mode=MODE_VALUE)
    id_TransportLayerAddress._val = 67
    
    #-----< id-TriggerID >-----#
    id_TriggerID = INT(name=u'id-TriggerID', mode=MODE_VALUE)
    id_TriggerID._val = 68
    
    #-----< id-UE-ID >-----#
    id_UE_ID = INT(name=u'id-UE-ID', mode=MODE_VALUE)
    id_UE_ID._val = 69
    
    #-----< id-UL-GTP-PDU-SequenceNumber >-----#
    id_UL_GTP_PDU_SequenceNumber = INT(name=u'id-UL-GTP-PDU-SequenceNumber', mode=MODE_VALUE)
    id_UL_GTP_PDU_SequenceNumber._val = 70
    
    #-----< id-RAB-FailedtoReportItem >-----#
    id_RAB_FailedtoReportItem = INT(name=u'id-RAB-FailedtoReportItem', mode=MODE_VALUE)
    id_RAB_FailedtoReportItem._val = 71
    
    #-----< id-RAB-FailedtoReportList >-----#
    id_RAB_FailedtoReportList = INT(name=u'id-RAB-FailedtoReportList', mode=MODE_VALUE)
    id_RAB_FailedtoReportList._val = 72
    
    #-----< id-KeyStatus >-----#
    id_KeyStatus = INT(name=u'id-KeyStatus', mode=MODE_VALUE)
    id_KeyStatus._val = 75
    
    #-----< id-DRX-CycleLengthCoefficient >-----#
    id_DRX_CycleLengthCoefficient = INT(name=u'id-DRX-CycleLengthCoefficient', mode=MODE_VALUE)
    id_DRX_CycleLengthCoefficient._val = 76
    
    #-----< id-IuSigConIdList >-----#
    id_IuSigConIdList = INT(name=u'id-IuSigConIdList', mode=MODE_VALUE)
    id_IuSigConIdList._val = 77
    
    #-----< id-IuSigConIdItem >-----#
    id_IuSigConIdItem = INT(name=u'id-IuSigConIdItem', mode=MODE_VALUE)
    id_IuSigConIdItem._val = 78
    
    #-----< id-IuSigConId >-----#
    id_IuSigConId = INT(name=u'id-IuSigConId', mode=MODE_VALUE)
    id_IuSigConId._val = 79
    
    #-----< id-DirectTransferInformationItem-RANAP-RelocInf >-----#
    id_DirectTransferInformationItem_RANAP_RelocInf = INT(name=u'id-DirectTransferInformationItem-RANAP-RelocInf', mode=MODE_VALUE)
    id_DirectTransferInformationItem_RANAP_RelocInf._val = 80
    
    #-----< id-DirectTransferInformationList-RANAP-RelocInf >-----#
    id_DirectTransferInformationList_RANAP_RelocInf = INT(name=u'id-DirectTransferInformationList-RANAP-RelocInf', mode=MODE_VALUE)
    id_DirectTransferInformationList_RANAP_RelocInf._val = 81
    
    #-----< id-RAB-ContextItem-RANAP-RelocInf >-----#
    id_RAB_ContextItem_RANAP_RelocInf = INT(name=u'id-RAB-ContextItem-RANAP-RelocInf', mode=MODE_VALUE)
    id_RAB_ContextItem_RANAP_RelocInf._val = 82
    
    #-----< id-RAB-ContextList-RANAP-RelocInf >-----#
    id_RAB_ContextList_RANAP_RelocInf = INT(name=u'id-RAB-ContextList-RANAP-RelocInf', mode=MODE_VALUE)
    id_RAB_ContextList_RANAP_RelocInf._val = 83
    
    #-----< id-RAB-ContextFailedtoTransferItem >-----#
    id_RAB_ContextFailedtoTransferItem = INT(name=u'id-RAB-ContextFailedtoTransferItem', mode=MODE_VALUE)
    id_RAB_ContextFailedtoTransferItem._val = 84
    
    #-----< id-RAB-ContextFailedtoTransferList >-----#
    id_RAB_ContextFailedtoTransferList = INT(name=u'id-RAB-ContextFailedtoTransferList', mode=MODE_VALUE)
    id_RAB_ContextFailedtoTransferList._val = 85
    
    #-----< id-GlobalRNC-ID >-----#
    id_GlobalRNC_ID = INT(name=u'id-GlobalRNC-ID', mode=MODE_VALUE)
    id_GlobalRNC_ID._val = 86
    
    #-----< id-RAB-ReleasedItem-IuRelComp >-----#
    id_RAB_ReleasedItem_IuRelComp = INT(name=u'id-RAB-ReleasedItem-IuRelComp', mode=MODE_VALUE)
    id_RAB_ReleasedItem_IuRelComp._val = 87
    
    #-----< id-MessageStructure >-----#
    id_MessageStructure = INT(name=u'id-MessageStructure', mode=MODE_VALUE)
    id_MessageStructure._val = 88
    
    #-----< id-Alt-RAB-Parameters >-----#
    id_Alt_RAB_Parameters = INT(name=u'id-Alt-RAB-Parameters', mode=MODE_VALUE)
    id_Alt_RAB_Parameters._val = 89
    
    #-----< id-Ass-RAB-Parameters >-----#
    id_Ass_RAB_Parameters = INT(name=u'id-Ass-RAB-Parameters', mode=MODE_VALUE)
    id_Ass_RAB_Parameters._val = 90
    
    #-----< id-RAB-ModifyList >-----#
    id_RAB_ModifyList = INT(name=u'id-RAB-ModifyList', mode=MODE_VALUE)
    id_RAB_ModifyList._val = 91
    
    #-----< id-RAB-ModifyItem >-----#
    id_RAB_ModifyItem = INT(name=u'id-RAB-ModifyItem', mode=MODE_VALUE)
    id_RAB_ModifyItem._val = 92
    
    #-----< id-TypeOfError >-----#
    id_TypeOfError = INT(name=u'id-TypeOfError', mode=MODE_VALUE)
    id_TypeOfError._val = 93
    
    #-----< id-BroadcastAssistanceDataDecipheringKeys >-----#
    id_BroadcastAssistanceDataDecipheringKeys = INT(name=u'id-BroadcastAssistanceDataDecipheringKeys', mode=MODE_VALUE)
    id_BroadcastAssistanceDataDecipheringKeys._val = 94
    
    #-----< id-LocationRelatedDataRequestType >-----#
    id_LocationRelatedDataRequestType = INT(name=u'id-LocationRelatedDataRequestType', mode=MODE_VALUE)
    id_LocationRelatedDataRequestType._val = 95
    
    #-----< id-GlobalCN-ID >-----#
    id_GlobalCN_ID = INT(name=u'id-GlobalCN-ID', mode=MODE_VALUE)
    id_GlobalCN_ID._val = 96
    
    #-----< id-LastKnownServiceArea >-----#
    id_LastKnownServiceArea = INT(name=u'id-LastKnownServiceArea', mode=MODE_VALUE)
    id_LastKnownServiceArea._val = 97
    
    #-----< id-SRB-TrCH-Mapping >-----#
    id_SRB_TrCH_Mapping = INT(name=u'id-SRB-TrCH-Mapping', mode=MODE_VALUE)
    id_SRB_TrCH_Mapping._val = 98
    
    #-----< id-InterSystemInformation-TransparentContainer >-----#
    id_InterSystemInformation_TransparentContainer = INT(name=u'id-InterSystemInformation-TransparentContainer', mode=MODE_VALUE)
    id_InterSystemInformation_TransparentContainer._val = 99
    
    #-----< id-NewBSS-To-OldBSS-Information >-----#
    id_NewBSS_To_OldBSS_Information = INT(name=u'id-NewBSS-To-OldBSS-Information', mode=MODE_VALUE)
    id_NewBSS_To_OldBSS_Information._val = 100
    
    #-----< id-SourceRNC-PDCP-context-info >-----#
    id_SourceRNC_PDCP_context_info = INT(name=u'id-SourceRNC-PDCP-context-info', mode=MODE_VALUE)
    id_SourceRNC_PDCP_context_info._val = 103
    
    #-----< id-InformationTransferID >-----#
    id_InformationTransferID = INT(name=u'id-InformationTransferID', mode=MODE_VALUE)
    id_InformationTransferID._val = 104
    
    #-----< id-SNA-Access-Information >-----#
    id_SNA_Access_Information = INT(name=u'id-SNA-Access-Information', mode=MODE_VALUE)
    id_SNA_Access_Information._val = 105
    
    #-----< id-ProvidedData >-----#
    id_ProvidedData = INT(name=u'id-ProvidedData', mode=MODE_VALUE)
    id_ProvidedData._val = 106
    
    #-----< id-GERAN-BSC-Container >-----#
    id_GERAN_BSC_Container = INT(name=u'id-GERAN-BSC-Container', mode=MODE_VALUE)
    id_GERAN_BSC_Container._val = 107
    
    #-----< id-GERAN-Classmark >-----#
    id_GERAN_Classmark = INT(name=u'id-GERAN-Classmark', mode=MODE_VALUE)
    id_GERAN_Classmark._val = 108
    
    #-----< id-GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item >-----#
    id_GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item = INT(name=u'id-GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item', mode=MODE_VALUE)
    id_GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item._val = 109
    
    #-----< id-GERAN-Iumode-RAB-FailedList-RABAssgntResponse >-----#
    id_GERAN_Iumode_RAB_FailedList_RABAssgntResponse = INT(name=u'id-GERAN-Iumode-RAB-FailedList-RABAssgntResponse', mode=MODE_VALUE)
    id_GERAN_Iumode_RAB_FailedList_RABAssgntResponse._val = 110
    
    #-----< id-VerticalAccuracyCode >-----#
    id_VerticalAccuracyCode = INT(name=u'id-VerticalAccuracyCode', mode=MODE_VALUE)
    id_VerticalAccuracyCode._val = 111
    
    #-----< id-ResponseTime >-----#
    id_ResponseTime = INT(name=u'id-ResponseTime', mode=MODE_VALUE)
    id_ResponseTime._val = 112
    
    #-----< id-PositioningPriority >-----#
    id_PositioningPriority = INT(name=u'id-PositioningPriority', mode=MODE_VALUE)
    id_PositioningPriority._val = 113
    
    #-----< id-ClientType >-----#
    id_ClientType = INT(name=u'id-ClientType', mode=MODE_VALUE)
    id_ClientType._val = 114
    
    #-----< id-LocationRelatedDataRequestTypeSpecificToGERANIuMode >-----#
    id_LocationRelatedDataRequestTypeSpecificToGERANIuMode = INT(name=u'id-LocationRelatedDataRequestTypeSpecificToGERANIuMode', mode=MODE_VALUE)
    id_LocationRelatedDataRequestTypeSpecificToGERANIuMode._val = 115
    
    #-----< id-SignallingIndication >-----#
    id_SignallingIndication = INT(name=u'id-SignallingIndication', mode=MODE_VALUE)
    id_SignallingIndication._val = 116
    
    #-----< id-hS-DSCH-MAC-d-Flow-ID >-----#
    id_hS_DSCH_MAC_d_Flow_ID = INT(name=u'id-hS-DSCH-MAC-d-Flow-ID', mode=MODE_VALUE)
    id_hS_DSCH_MAC_d_Flow_ID._val = 117
    
    #-----< id-UESBI-Iu >-----#
    id_UESBI_Iu = INT(name=u'id-UESBI-Iu', mode=MODE_VALUE)
    id_UESBI_Iu._val = 118
    
    #-----< id-PositionData >-----#
    id_PositionData = INT(name=u'id-PositionData', mode=MODE_VALUE)
    id_PositionData._val = 119
    
    #-----< id-PositionDataSpecificToGERANIuMode >-----#
    id_PositionDataSpecificToGERANIuMode = INT(name=u'id-PositionDataSpecificToGERANIuMode', mode=MODE_VALUE)
    id_PositionDataSpecificToGERANIuMode._val = 120
    
    #-----< id-CellLoadInformationGroup >-----#
    id_CellLoadInformationGroup = INT(name=u'id-CellLoadInformationGroup', mode=MODE_VALUE)
    id_CellLoadInformationGroup._val = 121
    
    #-----< id-AccuracyFulfilmentIndicator >-----#
    id_AccuracyFulfilmentIndicator = INT(name=u'id-AccuracyFulfilmentIndicator', mode=MODE_VALUE)
    id_AccuracyFulfilmentIndicator._val = 122
    
    #-----< id-InformationTransferType >-----#
    id_InformationTransferType = INT(name=u'id-InformationTransferType', mode=MODE_VALUE)
    id_InformationTransferType._val = 123
    
    #-----< id-TraceRecordingSessionInformation >-----#
    id_TraceRecordingSessionInformation = INT(name=u'id-TraceRecordingSessionInformation', mode=MODE_VALUE)
    id_TraceRecordingSessionInformation._val = 124
    
    #-----< id-TracePropagationParameters >-----#
    id_TracePropagationParameters = INT(name=u'id-TracePropagationParameters', mode=MODE_VALUE)
    id_TracePropagationParameters._val = 125
    
    #-----< id-InterSystemInformationTransferType >-----#
    id_InterSystemInformationTransferType = INT(name=u'id-InterSystemInformationTransferType', mode=MODE_VALUE)
    id_InterSystemInformationTransferType._val = 126
    
    #-----< id-SelectedPLMN-ID >-----#
    id_SelectedPLMN_ID = INT(name=u'id-SelectedPLMN-ID', mode=MODE_VALUE)
    id_SelectedPLMN_ID._val = 127
    
    #-----< id-RedirectionCompleted >-----#
    id_RedirectionCompleted = INT(name=u'id-RedirectionCompleted', mode=MODE_VALUE)
    id_RedirectionCompleted._val = 128
    
    #-----< id-RedirectionIndication >-----#
    id_RedirectionIndication = INT(name=u'id-RedirectionIndication', mode=MODE_VALUE)
    id_RedirectionIndication._val = 129
    
    #-----< id-NAS-SequenceNumber >-----#
    id_NAS_SequenceNumber = INT(name=u'id-NAS-SequenceNumber', mode=MODE_VALUE)
    id_NAS_SequenceNumber._val = 130
    
    #-----< id-RejectCauseValue >-----#
    id_RejectCauseValue = INT(name=u'id-RejectCauseValue', mode=MODE_VALUE)
    id_RejectCauseValue._val = 131
    
    #-----< id-APN >-----#
    id_APN = INT(name=u'id-APN', mode=MODE_VALUE)
    id_APN._val = 132
    
    #-----< id-CNMBMSLinkingInformation >-----#
    id_CNMBMSLinkingInformation = INT(name=u'id-CNMBMSLinkingInformation', mode=MODE_VALUE)
    id_CNMBMSLinkingInformation._val = 133
    
    #-----< id-DeltaRAListofIdleModeUEs >-----#
    id_DeltaRAListofIdleModeUEs = INT(name=u'id-DeltaRAListofIdleModeUEs', mode=MODE_VALUE)
    id_DeltaRAListofIdleModeUEs._val = 134
    
    #-----< id-FrequenceLayerConvergenceFlag >-----#
    id_FrequenceLayerConvergenceFlag = INT(name=u'id-FrequenceLayerConvergenceFlag', mode=MODE_VALUE)
    id_FrequenceLayerConvergenceFlag._val = 135
    
    #-----< id-InformationExchangeID >-----#
    id_InformationExchangeID = INT(name=u'id-InformationExchangeID', mode=MODE_VALUE)
    id_InformationExchangeID._val = 136
    
    #-----< id-InformationExchangeType >-----#
    id_InformationExchangeType = INT(name=u'id-InformationExchangeType', mode=MODE_VALUE)
    id_InformationExchangeType._val = 137
    
    #-----< id-InformationRequested >-----#
    id_InformationRequested = INT(name=u'id-InformationRequested', mode=MODE_VALUE)
    id_InformationRequested._val = 138
    
    #-----< id-InformationRequestType >-----#
    id_InformationRequestType = INT(name=u'id-InformationRequestType', mode=MODE_VALUE)
    id_InformationRequestType._val = 139
    
    #-----< id-IPMulticastAddress >-----#
    id_IPMulticastAddress = INT(name=u'id-IPMulticastAddress', mode=MODE_VALUE)
    id_IPMulticastAddress._val = 140
    
    #-----< id-JoinedMBMSBearerServicesList >-----#
    id_JoinedMBMSBearerServicesList = INT(name=u'id-JoinedMBMSBearerServicesList', mode=MODE_VALUE)
    id_JoinedMBMSBearerServicesList._val = 141
    
    #-----< id-LeftMBMSBearerServicesList >-----#
    id_LeftMBMSBearerServicesList = INT(name=u'id-LeftMBMSBearerServicesList', mode=MODE_VALUE)
    id_LeftMBMSBearerServicesList._val = 142
    
    #-----< id-MBMSBearerServiceType >-----#
    id_MBMSBearerServiceType = INT(name=u'id-MBMSBearerServiceType', mode=MODE_VALUE)
    id_MBMSBearerServiceType._val = 143
    
    #-----< id-MBMSCNDe-Registration >-----#
    id_MBMSCNDe_Registration = INT(name=u'id-MBMSCNDe-Registration', mode=MODE_VALUE)
    id_MBMSCNDe_Registration._val = 144
    
    #-----< id-MBMSServiceArea >-----#
    id_MBMSServiceArea = INT(name=u'id-MBMSServiceArea', mode=MODE_VALUE)
    id_MBMSServiceArea._val = 145
    
    #-----< id-MBMSSessionDuration >-----#
    id_MBMSSessionDuration = INT(name=u'id-MBMSSessionDuration', mode=MODE_VALUE)
    id_MBMSSessionDuration._val = 146
    
    #-----< id-MBMSSessionIdentity >-----#
    id_MBMSSessionIdentity = INT(name=u'id-MBMSSessionIdentity', mode=MODE_VALUE)
    id_MBMSSessionIdentity._val = 147
    
    #-----< id-PDP-TypeInformation >-----#
    id_PDP_TypeInformation = INT(name=u'id-PDP-TypeInformation', mode=MODE_VALUE)
    id_PDP_TypeInformation._val = 148
    
    #-----< id-RAB-Parameters >-----#
    id_RAB_Parameters = INT(name=u'id-RAB-Parameters', mode=MODE_VALUE)
    id_RAB_Parameters._val = 149
    
    #-----< id-RAListofIdleModeUEs >-----#
    id_RAListofIdleModeUEs = INT(name=u'id-RAListofIdleModeUEs', mode=MODE_VALUE)
    id_RAListofIdleModeUEs._val = 150
    
    #-----< id-MBMSRegistrationRequestType >-----#
    id_MBMSRegistrationRequestType = INT(name=u'id-MBMSRegistrationRequestType', mode=MODE_VALUE)
    id_MBMSRegistrationRequestType._val = 151
    
    #-----< id-SessionUpdateID >-----#
    id_SessionUpdateID = INT(name=u'id-SessionUpdateID', mode=MODE_VALUE)
    id_SessionUpdateID._val = 152
    
    #-----< id-TMGI >-----#
    id_TMGI = INT(name=u'id-TMGI', mode=MODE_VALUE)
    id_TMGI._val = 153
    
    #-----< id-TransportLayerInformation >-----#
    id_TransportLayerInformation = INT(name=u'id-TransportLayerInformation', mode=MODE_VALUE)
    id_TransportLayerInformation._val = 154
    
    #-----< id-UnsuccessfulLinkingList >-----#
    id_UnsuccessfulLinkingList = INT(name=u'id-UnsuccessfulLinkingList', mode=MODE_VALUE)
    id_UnsuccessfulLinkingList._val = 155
    
    #-----< id-MBMSLinkingInformation >-----#
    id_MBMSLinkingInformation = INT(name=u'id-MBMSLinkingInformation', mode=MODE_VALUE)
    id_MBMSLinkingInformation._val = 156
    
    #-----< id-MBMSSessionRepetitionNumber >-----#
    id_MBMSSessionRepetitionNumber = INT(name=u'id-MBMSSessionRepetitionNumber', mode=MODE_VALUE)
    id_MBMSSessionRepetitionNumber._val = 157
    
    #-----< id-AlternativeRABConfiguration >-----#
    id_AlternativeRABConfiguration = INT(name=u'id-AlternativeRABConfiguration', mode=MODE_VALUE)
    id_AlternativeRABConfiguration._val = 158
    
    #-----< id-AlternativeRABConfigurationRequest >-----#
    id_AlternativeRABConfigurationRequest = INT(name=u'id-AlternativeRABConfigurationRequest', mode=MODE_VALUE)
    id_AlternativeRABConfigurationRequest._val = 159
    
    #-----< id-E-DCH-MAC-d-Flow-ID >-----#
    id_E_DCH_MAC_d_Flow_ID = INT(name=u'id-E-DCH-MAC-d-Flow-ID', mode=MODE_VALUE)
    id_E_DCH_MAC_d_Flow_ID._val = 160
    
    #-----< id-SourceBSS-ToTargetBSS-TransparentContainer >-----#
    id_SourceBSS_ToTargetBSS_TransparentContainer = INT(name=u'id-SourceBSS-ToTargetBSS-TransparentContainer', mode=MODE_VALUE)
    id_SourceBSS_ToTargetBSS_TransparentContainer._val = 161
    
    #-----< id-TargetBSS-ToSourceBSS-TransparentContainer >-----#
    id_TargetBSS_ToSourceBSS_TransparentContainer = INT(name=u'id-TargetBSS-ToSourceBSS-TransparentContainer', mode=MODE_VALUE)
    id_TargetBSS_ToSourceBSS_TransparentContainer._val = 162
    
    #-----< id-TimeToMBMSDataTransfer >-----#
    id_TimeToMBMSDataTransfer = INT(name=u'id-TimeToMBMSDataTransfer', mode=MODE_VALUE)
    id_TimeToMBMSDataTransfer._val = 163
    
    #-----< id-IncludeVelocity >-----#
    id_IncludeVelocity = INT(name=u'id-IncludeVelocity', mode=MODE_VALUE)
    id_IncludeVelocity._val = 164
    
    #-----< id-VelocityEstimate >-----#
    id_VelocityEstimate = INT(name=u'id-VelocityEstimate', mode=MODE_VALUE)
    id_VelocityEstimate._val = 165
    
    #-----< id-RedirectAttemptFlag >-----#
    id_RedirectAttemptFlag = INT(name=u'id-RedirectAttemptFlag', mode=MODE_VALUE)
    id_RedirectAttemptFlag._val = 166
    
    #-----< id-RAT-Type >-----#
    id_RAT_Type = INT(name=u'id-RAT-Type', mode=MODE_VALUE)
    id_RAT_Type._val = 167
    
    #-----< id-PeriodicLocationInfo >-----#
    id_PeriodicLocationInfo = INT(name=u'id-PeriodicLocationInfo', mode=MODE_VALUE)
    id_PeriodicLocationInfo._val = 168
    
    #-----< id-MBMSCountingInformation >-----#
    id_MBMSCountingInformation = INT(name=u'id-MBMSCountingInformation', mode=MODE_VALUE)
    id_MBMSCountingInformation._val = 169
    
    #-----< id-170-not-to-be-used-for-IE-ids >-----#
    id_170_not_to_be_used_for_IE_ids = INT(name=u'id-170-not-to-be-used-for-IE-ids', mode=MODE_VALUE)
    id_170_not_to_be_used_for_IE_ids._val = 170
    
    #-----< id-ExtendedRNC-ID >-----#
    id_ExtendedRNC_ID = INT(name=u'id-ExtendedRNC-ID', mode=MODE_VALUE)
    id_ExtendedRNC_ID._val = 171
    
    #-----< id-Alt-RAB-Parameter-ExtendedGuaranteedBitrateInf >-----#
    id_Alt_RAB_Parameter_ExtendedGuaranteedBitrateInf = INT(name=u'id-Alt-RAB-Parameter-ExtendedGuaranteedBitrateInf', mode=MODE_VALUE)
    id_Alt_RAB_Parameter_ExtendedGuaranteedBitrateInf._val = 172
    
    #-----< id-Alt-RAB-Parameter-ExtendedMaxBitrateInf >-----#
    id_Alt_RAB_Parameter_ExtendedMaxBitrateInf = INT(name=u'id-Alt-RAB-Parameter-ExtendedMaxBitrateInf', mode=MODE_VALUE)
    id_Alt_RAB_Parameter_ExtendedMaxBitrateInf._val = 173
    
    #-----< id-Ass-RAB-Parameter-ExtendedGuaranteedBitrateList >-----#
    id_Ass_RAB_Parameter_ExtendedGuaranteedBitrateList = INT(name=u'id-Ass-RAB-Parameter-ExtendedGuaranteedBitrateList', mode=MODE_VALUE)
    id_Ass_RAB_Parameter_ExtendedGuaranteedBitrateList._val = 174
    
    #-----< id-Ass-RAB-Parameter-ExtendedMaxBitrateList >-----#
    id_Ass_RAB_Parameter_ExtendedMaxBitrateList = INT(name=u'id-Ass-RAB-Parameter-ExtendedMaxBitrateList', mode=MODE_VALUE)
    id_Ass_RAB_Parameter_ExtendedMaxBitrateList._val = 175
    
    #-----< id-RAB-Parameter-ExtendedGuaranteedBitrateList >-----#
    id_RAB_Parameter_ExtendedGuaranteedBitrateList = INT(name=u'id-RAB-Parameter-ExtendedGuaranteedBitrateList', mode=MODE_VALUE)
    id_RAB_Parameter_ExtendedGuaranteedBitrateList._val = 176
    
    #-----< id-RAB-Parameter-ExtendedMaxBitrateList >-----#
    id_RAB_Parameter_ExtendedMaxBitrateList = INT(name=u'id-RAB-Parameter-ExtendedMaxBitrateList', mode=MODE_VALUE)
    id_RAB_Parameter_ExtendedMaxBitrateList._val = 177
    
    #-----< id-Requested-RAB-Parameter-ExtendedMaxBitrateList >-----#
    id_Requested_RAB_Parameter_ExtendedMaxBitrateList = INT(name=u'id-Requested-RAB-Parameter-ExtendedMaxBitrateList', mode=MODE_VALUE)
    id_Requested_RAB_Parameter_ExtendedMaxBitrateList._val = 178
    
    #-----< id-Requested-RAB-Parameter-ExtendedGuaranteedBitrateList >-----#
    id_Requested_RAB_Parameter_ExtendedGuaranteedBitrateList = INT(name=u'id-Requested-RAB-Parameter-ExtendedGuaranteedBitrateList', mode=MODE_VALUE)
    id_Requested_RAB_Parameter_ExtendedGuaranteedBitrateList._val = 179
    
    #-----< id-LAofIdleModeUEs >-----#
    id_LAofIdleModeUEs = INT(name=u'id-LAofIdleModeUEs', mode=MODE_VALUE)
    id_LAofIdleModeUEs._val = 180
    
    #-----< id-newLAListofIdleModeUEs >-----#
    id_newLAListofIdleModeUEs = INT(name=u'id-newLAListofIdleModeUEs', mode=MODE_VALUE)
    id_newLAListofIdleModeUEs._val = 181
    
    #-----< id-LAListwithNoIdleModeUEsAnyMore >-----#
    id_LAListwithNoIdleModeUEsAnyMore = INT(name=u'id-LAListwithNoIdleModeUEsAnyMore', mode=MODE_VALUE)
    id_LAListwithNoIdleModeUEsAnyMore._val = 182
    
    #-----< id-183-not-to-be-used-for-IE-ids >-----#
    id_183_not_to_be_used_for_IE_ids = INT(name=u'id-183-not-to-be-used-for-IE-ids', mode=MODE_VALUE)
    id_183_not_to_be_used_for_IE_ids._val = 183
    
    #-----< id-GANSS-PositioningDataSet >-----#
    id_GANSS_PositioningDataSet = INT(name=u'id-GANSS-PositioningDataSet', mode=MODE_VALUE)
    id_GANSS_PositioningDataSet._val = 184
    
    #-----< id-RequestedGANSSAssistanceData >-----#
    id_RequestedGANSSAssistanceData = INT(name=u'id-RequestedGANSSAssistanceData', mode=MODE_VALUE)
    id_RequestedGANSSAssistanceData._val = 185
    
    #-----< id-BroadcastGANSSAssistanceDataDecipheringKeys >-----#
    id_BroadcastGANSSAssistanceDataDecipheringKeys = INT(name=u'id-BroadcastGANSSAssistanceDataDecipheringKeys', mode=MODE_VALUE)
    id_BroadcastGANSSAssistanceDataDecipheringKeys._val = 186
    
    #-----< id-d-RNTI-for-NoIuCSUP >-----#
    id_d_RNTI_for_NoIuCSUP = INT(name=u'id-d-RNTI-for-NoIuCSUP', mode=MODE_VALUE)
    id_d_RNTI_for_NoIuCSUP._val = 187
    
    #-----< id-RAB-SetupList-EnhancedRelocCompleteReq >-----#
    id_RAB_SetupList_EnhancedRelocCompleteReq = INT(name=u'id-RAB-SetupList-EnhancedRelocCompleteReq', mode=MODE_VALUE)
    id_RAB_SetupList_EnhancedRelocCompleteReq._val = 188
    
    #-----< id-RAB-SetupItem-EnhancedRelocCompleteReq >-----#
    id_RAB_SetupItem_EnhancedRelocCompleteReq = INT(name=u'id-RAB-SetupItem-EnhancedRelocCompleteReq', mode=MODE_VALUE)
    id_RAB_SetupItem_EnhancedRelocCompleteReq._val = 189
    
    #-----< id-RAB-SetupList-EnhancedRelocCompleteRes >-----#
    id_RAB_SetupList_EnhancedRelocCompleteRes = INT(name=u'id-RAB-SetupList-EnhancedRelocCompleteRes', mode=MODE_VALUE)
    id_RAB_SetupList_EnhancedRelocCompleteRes._val = 190
    
    #-----< id-RAB-SetupItem-EnhancedRelocCompleteRes >-----#
    id_RAB_SetupItem_EnhancedRelocCompleteRes = INT(name=u'id-RAB-SetupItem-EnhancedRelocCompleteRes', mode=MODE_VALUE)
    id_RAB_SetupItem_EnhancedRelocCompleteRes._val = 191
    
    #-----< id-RAB-SetupList-EnhRelocInfoReq >-----#
    id_RAB_SetupList_EnhRelocInfoReq = INT(name=u'id-RAB-SetupList-EnhRelocInfoReq', mode=MODE_VALUE)
    id_RAB_SetupList_EnhRelocInfoReq._val = 192
    
    #-----< id-RAB-SetupItem-EnhRelocInfoReq >-----#
    id_RAB_SetupItem_EnhRelocInfoReq = INT(name=u'id-RAB-SetupItem-EnhRelocInfoReq', mode=MODE_VALUE)
    id_RAB_SetupItem_EnhRelocInfoReq._val = 193
    
    #-----< id-RAB-SetupList-EnhRelocInfoRes >-----#
    id_RAB_SetupList_EnhRelocInfoRes = INT(name=u'id-RAB-SetupList-EnhRelocInfoRes', mode=MODE_VALUE)
    id_RAB_SetupList_EnhRelocInfoRes._val = 194
    
    #-----< id-RAB-SetupItem-EnhRelocInfoRes >-----#
    id_RAB_SetupItem_EnhRelocInfoRes = INT(name=u'id-RAB-SetupItem-EnhRelocInfoRes', mode=MODE_VALUE)
    id_RAB_SetupItem_EnhRelocInfoRes._val = 195
    
    #-----< id-OldIuSigConId >-----#
    id_OldIuSigConId = INT(name=u'id-OldIuSigConId', mode=MODE_VALUE)
    id_OldIuSigConId._val = 196
    
    #-----< id-RAB-FailedList-EnhRelocInfoRes >-----#
    id_RAB_FailedList_EnhRelocInfoRes = INT(name=u'id-RAB-FailedList-EnhRelocInfoRes', mode=MODE_VALUE)
    id_RAB_FailedList_EnhRelocInfoRes._val = 197
    
    #-----< id-RAB-FailedItem-EnhRelocInfoRes >-----#
    id_RAB_FailedItem_EnhRelocInfoRes = INT(name=u'id-RAB-FailedItem-EnhRelocInfoRes', mode=MODE_VALUE)
    id_RAB_FailedItem_EnhRelocInfoRes._val = 198
    
    #-----< id-Global-ENB-ID >-----#
    id_Global_ENB_ID = INT(name=u'id-Global-ENB-ID', mode=MODE_VALUE)
    id_Global_ENB_ID._val = 199
    
    #-----< id-UE-History-Information >-----#
    id_UE_History_Information = INT(name=u'id-UE-History-Information', mode=MODE_VALUE)
    id_UE_History_Information._val = 200
    
    #-----< id-MBMSSynchronisationInformation >-----#
    id_MBMSSynchronisationInformation = INT(name=u'id-MBMSSynchronisationInformation', mode=MODE_VALUE)
    id_MBMSSynchronisationInformation._val = 201
    
    #-----< id-SubscriberProfileIDforRFP >-----#
    id_SubscriberProfileIDforRFP = INT(name=u'id-SubscriberProfileIDforRFP', mode=MODE_VALUE)
    id_SubscriberProfileIDforRFP._val = 202
    
    #-----< id-CSG-Id >-----#
    id_CSG_Id = INT(name=u'id-CSG-Id', mode=MODE_VALUE)
    id_CSG_Id._val = 203
    
    #-----< id-OldIuSigConIdCS >-----#
    id_OldIuSigConIdCS = INT(name=u'id-OldIuSigConIdCS', mode=MODE_VALUE)
    id_OldIuSigConIdCS._val = 204
    
    #-----< id-OldIuSigConIdPS >-----#
    id_OldIuSigConIdPS = INT(name=u'id-OldIuSigConIdPS', mode=MODE_VALUE)
    id_OldIuSigConIdPS._val = 205
    
    #-----< id-GlobalCN-IDCS >-----#
    id_GlobalCN_IDCS = INT(name=u'id-GlobalCN-IDCS', mode=MODE_VALUE)
    id_GlobalCN_IDCS._val = 206
    
    #-----< id-GlobalCN-IDPS >-----#
    id_GlobalCN_IDPS = INT(name=u'id-GlobalCN-IDPS', mode=MODE_VALUE)
    id_GlobalCN_IDPS._val = 207
    
    #-----< id-SourceExtendedRNC-ID >-----#
    id_SourceExtendedRNC_ID = INT(name=u'id-SourceExtendedRNC-ID', mode=MODE_VALUE)
    id_SourceExtendedRNC_ID._val = 208
    
    #-----< id-RAB-ToBeReleasedItem-EnhancedRelocCompleteRes >-----#
    id_RAB_ToBeReleasedItem_EnhancedRelocCompleteRes = INT(name=u'id-RAB-ToBeReleasedItem-EnhancedRelocCompleteRes', mode=MODE_VALUE)
    id_RAB_ToBeReleasedItem_EnhancedRelocCompleteRes._val = 209
    
    #-----< id-RAB-ToBeReleasedList-EnhancedRelocCompleteRes >-----#
    id_RAB_ToBeReleasedList_EnhancedRelocCompleteRes = INT(name=u'id-RAB-ToBeReleasedList-EnhancedRelocCompleteRes', mode=MODE_VALUE)
    id_RAB_ToBeReleasedList_EnhancedRelocCompleteRes._val = 210
    
    #-----< id-SourceRNC-ID >-----#
    id_SourceRNC_ID = INT(name=u'id-SourceRNC-ID', mode=MODE_VALUE)
    id_SourceRNC_ID._val = 211
    
    #-----< id-Relocation-TargetRNC-ID >-----#
    id_Relocation_TargetRNC_ID = INT(name=u'id-Relocation-TargetRNC-ID', mode=MODE_VALUE)
    id_Relocation_TargetRNC_ID._val = 212
    
    #-----< id-Relocation-TargetExtendedRNC-ID >-----#
    id_Relocation_TargetExtendedRNC_ID = INT(name=u'id-Relocation-TargetExtendedRNC-ID', mode=MODE_VALUE)
    id_Relocation_TargetExtendedRNC_ID._val = 213
    
    #-----< id-Alt-RAB-Parameter-SupportedGuaranteedBitrateInf >-----#
    id_Alt_RAB_Parameter_SupportedGuaranteedBitrateInf = INT(name=u'id-Alt-RAB-Parameter-SupportedGuaranteedBitrateInf', mode=MODE_VALUE)
    id_Alt_RAB_Parameter_SupportedGuaranteedBitrateInf._val = 214
    
    #-----< id-Alt-RAB-Parameter-SupportedMaxBitrateInf >-----#
    id_Alt_RAB_Parameter_SupportedMaxBitrateInf = INT(name=u'id-Alt-RAB-Parameter-SupportedMaxBitrateInf', mode=MODE_VALUE)
    id_Alt_RAB_Parameter_SupportedMaxBitrateInf._val = 215
    
    #-----< id-Ass-RAB-Parameter-SupportedGuaranteedBitrateList >-----#
    id_Ass_RAB_Parameter_SupportedGuaranteedBitrateList = INT(name=u'id-Ass-RAB-Parameter-SupportedGuaranteedBitrateList', mode=MODE_VALUE)
    id_Ass_RAB_Parameter_SupportedGuaranteedBitrateList._val = 216
    
    #-----< id-Ass-RAB-Parameter-SupportedMaxBitrateList >-----#
    id_Ass_RAB_Parameter_SupportedMaxBitrateList = INT(name=u'id-Ass-RAB-Parameter-SupportedMaxBitrateList', mode=MODE_VALUE)
    id_Ass_RAB_Parameter_SupportedMaxBitrateList._val = 217
    
    #-----< id-RAB-Parameter-SupportedGuaranteedBitrateList >-----#
    id_RAB_Parameter_SupportedGuaranteedBitrateList = INT(name=u'id-RAB-Parameter-SupportedGuaranteedBitrateList', mode=MODE_VALUE)
    id_RAB_Parameter_SupportedGuaranteedBitrateList._val = 218
    
    #-----< id-RAB-Parameter-SupportedMaxBitrateList >-----#
    id_RAB_Parameter_SupportedMaxBitrateList = INT(name=u'id-RAB-Parameter-SupportedMaxBitrateList', mode=MODE_VALUE)
    id_RAB_Parameter_SupportedMaxBitrateList._val = 219
    
    #-----< id-Requested-RAB-Parameter-SupportedMaxBitrateList >-----#
    id_Requested_RAB_Parameter_SupportedMaxBitrateList = INT(name=u'id-Requested-RAB-Parameter-SupportedMaxBitrateList', mode=MODE_VALUE)
    id_Requested_RAB_Parameter_SupportedMaxBitrateList._val = 220
    
    #-----< id-Requested-RAB-Parameter-SupportedGuaranteedBitrateList >-----#
    id_Requested_RAB_Parameter_SupportedGuaranteedBitrateList = INT(name=u'id-Requested-RAB-Parameter-SupportedGuaranteedBitrateList', mode=MODE_VALUE)
    id_Requested_RAB_Parameter_SupportedGuaranteedBitrateList._val = 221
    
    #-----< id-Relocation-SourceRNC-ID >-----#
    id_Relocation_SourceRNC_ID = INT(name=u'id-Relocation-SourceRNC-ID', mode=MODE_VALUE)
    id_Relocation_SourceRNC_ID._val = 222
    
    #-----< id-Relocation-SourceExtendedRNC-ID >-----#
    id_Relocation_SourceExtendedRNC_ID = INT(name=u'id-Relocation-SourceExtendedRNC-ID', mode=MODE_VALUE)
    id_Relocation_SourceExtendedRNC_ID._val = 223
    
    #-----< id-EncryptionKey >-----#
    id_EncryptionKey = INT(name=u'id-EncryptionKey', mode=MODE_VALUE)
    id_EncryptionKey._val = 224
    
    #-----< id-IntegrityProtectionKey >-----#
    id_IntegrityProtectionKey = INT(name=u'id-IntegrityProtectionKey', mode=MODE_VALUE)
    id_IntegrityProtectionKey._val = 225
    
    #-----< id-SRVCC-HO-Indication >-----#
    id_SRVCC_HO_Indication = INT(name=u'id-SRVCC-HO-Indication', mode=MODE_VALUE)
    id_SRVCC_HO_Indication._val = 226
    
    #-----< id-SRVCC-Information >-----#
    id_SRVCC_Information = INT(name=u'id-SRVCC-Information', mode=MODE_VALUE)
    id_SRVCC_Information._val = 227
    
    #-----< id-SRVCC-Operation-Possible >-----#
    id_SRVCC_Operation_Possible = INT(name=u'id-SRVCC-Operation-Possible', mode=MODE_VALUE)
    id_SRVCC_Operation_Possible._val = 228
    
    #-----< id-CSG-Id-List >-----#
    id_CSG_Id_List = INT(name=u'id-CSG-Id-List', mode=MODE_VALUE)
    id_CSG_Id_List._val = 229
    
    #-----< id-PSRABtobeReplaced >-----#
    id_PSRABtobeReplaced = INT(name=u'id-PSRABtobeReplaced', mode=MODE_VALUE)
    id_PSRABtobeReplaced._val = 230
    
    #-----< id-E-UTRAN-Service-Handover >-----#
    id_E_UTRAN_Service_Handover = INT(name=u'id-E-UTRAN-Service-Handover', mode=MODE_VALUE)
    id_E_UTRAN_Service_Handover._val = 231
    
    #-----< id-UE-AggregateMaximumBitRate >-----#
    id_UE_AggregateMaximumBitRate = INT(name=u'id-UE-AggregateMaximumBitRate', mode=MODE_VALUE)
    id_UE_AggregateMaximumBitRate._val = 233
    
    #-----< id-CSG-Membership-Status >-----#
    id_CSG_Membership_Status = INT(name=u'id-CSG-Membership-Status', mode=MODE_VALUE)
    id_CSG_Membership_Status._val = 234
    
    #-----< id-Cell-Access-Mode >-----#
    id_Cell_Access_Mode = INT(name=u'id-Cell-Access-Mode', mode=MODE_VALUE)
    id_Cell_Access_Mode._val = 235
    
    #-----< id-IP-Source-Address >-----#
    id_IP_Source_Address = INT(name=u'id-IP-Source-Address', mode=MODE_VALUE)
    id_IP_Source_Address._val = 236
    
    #-----< id-CSFB-Information >-----#
    id_CSFB_Information = INT(name=u'id-CSFB-Information', mode=MODE_VALUE)
    id_CSFB_Information._val = 237
    
    #-----< id-PDP-TypeInformation-extension >-----#
    id_PDP_TypeInformation_extension = INT(name=u'id-PDP-TypeInformation-extension', mode=MODE_VALUE)
    id_PDP_TypeInformation_extension._val = 238
    
    #-----< id-MSISDN >-----#
    id_MSISDN = INT(name=u'id-MSISDN', mode=MODE_VALUE)
    id_MSISDN._val = 239
    
    #-----< id-Offload-RAB-Parameters >-----#
    id_Offload_RAB_Parameters = INT(name=u'id-Offload-RAB-Parameters', mode=MODE_VALUE)
    id_Offload_RAB_Parameters._val = 240
    
    #-----< id-LGW-TransportLayerAddress >-----#
    id_LGW_TransportLayerAddress = INT(name=u'id-LGW-TransportLayerAddress', mode=MODE_VALUE)
    id_LGW_TransportLayerAddress._val = 241
    
    #-----< id-Correlation-ID >-----#
    id_Correlation_ID = INT(name=u'id-Correlation-ID', mode=MODE_VALUE)
    id_Correlation_ID._val = 242
    
    #-----< id-IRAT-Measurement-Configuration >-----#
    id_IRAT_Measurement_Configuration = INT(name=u'id-IRAT-Measurement-Configuration', mode=MODE_VALUE)
    id_IRAT_Measurement_Configuration._val = 243
    
    #-----< id-MDT-Configuration >-----#
    id_MDT_Configuration = INT(name=u'id-MDT-Configuration', mode=MODE_VALUE)
    id_MDT_Configuration._val = 244
    
    #-----< id-Priority-Class-Indicator >-----#
    id_Priority_Class_Indicator = INT(name=u'id-Priority-Class-Indicator', mode=MODE_VALUE)
    id_Priority_Class_Indicator._val = 245
    
    #-----< id-RNSAPRelocationParameters >-----#
    id_RNSAPRelocationParameters = INT(name=u'id-RNSAPRelocationParameters', mode=MODE_VALUE)
    id_RNSAPRelocationParameters._val = 247
    
    #-----< id-RABParametersList >-----#
    id_RABParametersList = INT(name=u'id-RABParametersList', mode=MODE_VALUE)
    id_RABParametersList._val = 248
    
    #-----< id-Management-Based-MDT-Allowed >-----#
    id_Management_Based_MDT_Allowed = INT(name=u'id-Management-Based-MDT-Allowed', mode=MODE_VALUE)
    id_Management_Based_MDT_Allowed._val = 249
    
    #-----< id-HigherBitratesThan16MbpsFlag >-----#
    id_HigherBitratesThan16MbpsFlag = INT(name=u'id-HigherBitratesThan16MbpsFlag', mode=MODE_VALUE)
    id_HigherBitratesThan16MbpsFlag._val = 250
    
    #-----< id-Trace-Collection-Entity-IP-Addess >-----#
    id_Trace_Collection_Entity_IP_Addess = INT(name=u'id-Trace-Collection-Entity-IP-Addess', mode=MODE_VALUE)
    id_Trace_Collection_Entity_IP_Addess._val = 251
    
    #-----< id-End-Of-CSFB >-----#
    id_End_Of_CSFB = INT(name=u'id-End-Of-CSFB', mode=MODE_VALUE)
    id_End_Of_CSFB._val = 252
    
    #-----< id-Time-UE-StayedInCell-EnhancedGranularity >-----#
    id_Time_UE_StayedInCell_EnhancedGranularity = INT(name=u'id-Time-UE-StayedInCell-EnhancedGranularity', mode=MODE_VALUE)
    id_Time_UE_StayedInCell_EnhancedGranularity._val = 253
    
    #-----< id-Out-Of-UTRAN >-----#
    id_Out_Of_UTRAN = INT(name=u'id-Out-Of-UTRAN', mode=MODE_VALUE)
    id_Out_Of_UTRAN._val = 254
    
    #-----< id-TraceRecordingSessionReference >-----#
    id_TraceRecordingSessionReference = INT(name=u'id-TraceRecordingSessionReference', mode=MODE_VALUE)
    id_TraceRecordingSessionReference._val = 255
    
    #-----< id-IMSI >-----#
    id_IMSI = INT(name=u'id-IMSI', mode=MODE_VALUE)
    id_IMSI._val = 256
    
    #-----< id-HO-Cause >-----#
    id_HO_Cause = INT(name=u'id-HO-Cause', mode=MODE_VALUE)
    id_HO_Cause._val = 257
    
    #-----< id-VoiceSupportMatchIndicator >-----#
    id_VoiceSupportMatchIndicator = INT(name=u'id-VoiceSupportMatchIndicator', mode=MODE_VALUE)
    id_VoiceSupportMatchIndicator._val = 258
    
    #-----< id-RSRVCC-HO-Indication >-----#
    id_RSRVCC_HO_Indication = INT(name=u'id-RSRVCC-HO-Indication', mode=MODE_VALUE)
    id_RSRVCC_HO_Indication._val = 259
    
    #-----< id-RSRVCC-Information >-----#
    id_RSRVCC_Information = INT(name=u'id-RSRVCC-Information', mode=MODE_VALUE)
    id_RSRVCC_Information._val = 260
    
    #-----< id-AnchorPLMN-ID >-----#
    id_AnchorPLMN_ID = INT(name=u'id-AnchorPLMN-ID', mode=MODE_VALUE)
    id_AnchorPLMN_ID._val = 261
    
    #-----< id-Tunnel-Information-for-BBF >-----#
    id_Tunnel_Information_for_BBF = INT(name=u'id-Tunnel-Information-for-BBF', mode=MODE_VALUE)
    id_Tunnel_Information_for_BBF._val = 262
    
    #-----< id-Management-Based-MDT-PLMN-List >-----#
    id_Management_Based_MDT_PLMN_List = INT(name=u'id-Management-Based-MDT-PLMN-List', mode=MODE_VALUE)
    id_Management_Based_MDT_PLMN_List._val = 263
    
    #-----< id-SignallingBasedMDTPLMNList >-----#
    id_SignallingBasedMDTPLMNList = INT(name=u'id-SignallingBasedMDTPLMNList', mode=MODE_VALUE)
    id_SignallingBasedMDTPLMNList._val = 264
    
    #-----< id-M4Report >-----#
    id_M4Report = INT(name=u'id-M4Report', mode=MODE_VALUE)
    id_M4Report._val = 265
    
    #-----< id-M5Report >-----#
    id_M5Report = INT(name=u'id-M5Report', mode=MODE_VALUE)
    id_M5Report._val = 266
    
    #-----< id-M6Report >-----#
    id_M6Report = INT(name=u'id-M6Report', mode=MODE_VALUE)
    id_M6Report._val = 267
    
    #-----< id-M7Report >-----#
    id_M7Report = INT(name=u'id-M7Report', mode=MODE_VALUE)
    id_M7Report._val = 268
    
    #-----< id-TimingDifferenceULDL >-----#
    id_TimingDifferenceULDL = INT(name=u'id-TimingDifferenceULDL', mode=MODE_VALUE)
    id_TimingDifferenceULDL._val = 269
    
    #-----< id-Serving-Cell-Identifier >-----#
    id_Serving_Cell_Identifier = INT(name=u'id-Serving-Cell-Identifier', mode=MODE_VALUE)
    id_Serving_Cell_Identifier._val = 270
    
    #-----< id-EARFCN-Extended >-----#
    id_EARFCN_Extended = INT(name=u'id-EARFCN-Extended', mode=MODE_VALUE)
    id_EARFCN_Extended._val = 271
    
    #-----< id-RSRVCC-Operation-Possible >-----#
    id_RSRVCC_Operation_Possible = INT(name=u'id-RSRVCC-Operation-Possible', mode=MODE_VALUE)
    id_RSRVCC_Operation_Possible._val = 272
    
    #-----< id-SIPTO-LGW-TransportLayerAddress >-----#
    id_SIPTO_LGW_TransportLayerAddress = INT(name=u'id-SIPTO-LGW-TransportLayerAddress', mode=MODE_VALUE)
    id_SIPTO_LGW_TransportLayerAddress._val = 273
    
    #-----< id-SIPTO-Correlation-ID >-----#
    id_SIPTO_Correlation_ID = INT(name=u'id-SIPTO-Correlation-ID', mode=MODE_VALUE)
    id_SIPTO_Correlation_ID._val = 274
    
    #-----< id-LHN-ID >-----#
    id_LHN_ID = INT(name=u'id-LHN-ID', mode=MODE_VALUE)
    id_LHN_ID._val = 275
    
    #-----< id-Session-Re-establishment-Indicator >-----#
    id_Session_Re_establishment_Indicator = INT(name=u'id-Session-Re-establishment-Indicator', mode=MODE_VALUE)
    id_Session_Re_establishment_Indicator._val = 276
    
    #-----< id-LastE-UTRANPLMNIdentity >-----#
    id_LastE_UTRANPLMNIdentity = INT(name=u'id-LastE-UTRANPLMNIdentity', mode=MODE_VALUE)
    id_LastE_UTRANPLMNIdentity._val = 277
    
    #-----< id-RSRQ-Type >-----#
    id_RSRQ_Type = INT(name=u'id-RSRQ-Type', mode=MODE_VALUE)
    id_RSRQ_Type._val = 278
    
    #-----< id-RSRQ-Extension >-----#
    id_RSRQ_Extension = INT(name=u'id-RSRQ-Extension', mode=MODE_VALUE)
    id_RSRQ_Extension._val = 279
    
    #-----< id-Additional-CSPS-coordination-information >-----#
    id_Additional_CSPS_coordination_information = INT(name=u'id-Additional-CSPS-coordination-information', mode=MODE_VALUE)
    id_Additional_CSPS_coordination_information._val = 280
    
    #-----< id-UERegistrationQueryResult >-----#
    id_UERegistrationQueryResult = INT(name=u'id-UERegistrationQueryResult', mode=MODE_VALUE)
    id_UERegistrationQueryResult._val = 281
    
    #-----< id-IuSigConIdRangeEnd >-----#
    id_IuSigConIdRangeEnd = INT(name=u'id-IuSigConIdRangeEnd', mode=MODE_VALUE)
    id_IuSigConIdRangeEnd._val = 282
    
    #-----< id-BarometricPressure >-----#
    id_BarometricPressure = INT(name=u'id-BarometricPressure', mode=MODE_VALUE)
    id_BarometricPressure._val = 283
    
    #-----< id-Additional-PositioningDataSet >-----#
    id_Additional_PositioningDataSet = INT(name=u'id-Additional-PositioningDataSet', mode=MODE_VALUE)
    id_Additional_PositioningDataSet._val = 284
    
    #-----< id-CivicAddress >-----#
    id_CivicAddress = INT(name=u'id-CivicAddress', mode=MODE_VALUE)
    id_CivicAddress._val = 285
    
    #-----< id-SGSN-Group-Identity >-----#
    id_SGSN_Group_Identity = INT(name=u'id-SGSN-Group-Identity', mode=MODE_VALUE)
    id_SGSN_Group_Identity._val = 286
    
    #-----< id-P-TMSI >-----#
    id_P_TMSI = INT(name=u'id-P-TMSI', mode=MODE_VALUE)
    id_P_TMSI._val = 287
    
    #-----< id-RANAP-Message >-----#
    id_RANAP_Message = INT(name=u'id-RANAP-Message', mode=MODE_VALUE)
    id_RANAP_Message._val = 288
    
    #-----< id-PowerSavingIndicator >-----#
    id_PowerSavingIndicator = INT(name=u'id-PowerSavingIndicator', mode=MODE_VALUE)
    id_PowerSavingIndicator._val = 289
    
    #-----< id-UE-Usage-Type >-----#
    id_UE_Usage_Type = INT(name=u'id-UE-Usage-Type', mode=MODE_VALUE)
    id_UE_Usage_Type._val = 290
    
    #-----< id-DCN-ID >-----#
    id_DCN_ID = INT(name=u'id-DCN-ID', mode=MODE_VALUE)
    id_DCN_ID._val = 291
    
    #-----< id-UE-Application-Layer-Measurement-Configuration >-----#
    id_UE_Application_Layer_Measurement_Configuration = INT(name=u'id-UE-Application-Layer-Measurement-Configuration', mode=MODE_VALUE)
    id_UE_Application_Layer_Measurement_Configuration._val = 292
    
    #-----< id-UE-Application-Layer-Measurement-Configuration-For-Relocation >-----#
    id_UE_Application_Layer_Measurement_Configuration_For_Relocation = INT(name=u'id-UE-Application-Layer-Measurement-Configuration-For-Relocation', mode=MODE_VALUE)
    id_UE_Application_Layer_Measurement_Configuration_For_Relocation._val = 293
    
    #-----< id-UE-Application-Layer-Measurement-Capability >-----#
    id_UE_Application_Layer_Measurement_Capability = INT(name=u'id-UE-Application-Layer-Measurement-Capability', mode=MODE_VALUE)
    id_UE_Application_Layer_Measurement_Capability._val = 294
    
    #-----< id-UeApplicationLayerMeasurementSupportIndication >-----#
    id_UeApplicationLayerMeasurementSupportIndication = INT(name=u'id-UeApplicationLayerMeasurementSupportIndication', mode=MODE_VALUE)
    id_UeApplicationLayerMeasurementSupportIndication._val = 295
    
    #-----< id-SRVCCSource >-----#
    id_SRVCCSource = INT(name=u'id-SRVCCSource', mode=MODE_VALUE)
    id_SRVCCSource._val = 296
    
    _all_ = [
        id_RAB_Assignment,
        id_Iu_Release,
        id_RelocationPreparation,
        id_RelocationResourceAllocation,
        id_RelocationCancel,
        id_SRNS_ContextTransfer,
        id_SecurityModeControl,
        id_DataVolumeReport,
        id_Reset,
        id_RAB_ReleaseRequest,
        id_Iu_ReleaseRequest,
        id_RelocationDetect,
        id_RelocationComplete,
        id_Paging,
        id_CommonID,
        id_CN_InvokeTrace,
        id_LocationReportingControl,
        id_LocationReport,
        id_InitialUE_Message,
        id_DirectTransfer,
        id_OverloadControl,
        id_ErrorIndication,
        id_SRNS_DataForward,
        id_ForwardSRNS_Context,
        id_privateMessage,
        id_CN_DeactivateTrace,
        id_ResetResource,
        id_RANAP_Relocation,
        id_RAB_ModifyRequest,
        id_LocationRelatedData,
        id_InformationTransfer,
        id_UESpecificInformation,
        id_UplinkInformationExchange,
        id_DirectInformationTransfer,
        id_MBMSSessionStart,
        id_MBMSSessionUpdate,
        id_MBMSSessionStop,
        id_MBMSUELinking,
        id_MBMSRegistration,
        id_MBMSCNDe_Registration_Procedure,
        id_MBMSRABEstablishmentIndication,
        id_MBMSRABRelease,
        id_enhancedRelocationComplete,
        id_enhancedRelocationCompleteConfirm,
        id_RANAPenhancedRelocation,
        id_SRVCCPreparation,
        id_UeRadioCapabilityMatch,
        id_UeRegistrationQuery,
        id_RerouteNASRequest,
        maxPrivateIEs,
        maxProtocolExtensions,
        maxProtocolIEs,
        maxNrOfDTs,
        maxNrOfErrors,
        maxNrOfIuSigConIds,
        maxNrOfPDPDirections,
        maxNrOfPoints,
        maxNrOfRABs,
        maxNrOfSeparateTrafficDirections,
        maxNrOfSRBs,
        maxNrOfVol,
        maxNrOfLevels,
        maxNrOfAltValues,
        maxNrOfPLMNsSN,
        maxNrOfLAs,
        maxNrOfSNAs,
        maxNrOfUEsToBeTraced,
        maxNrOfInterfaces,
        maxRAB_Subflows,
        maxRAB_SubflowCombination,
        maxSet,
        maxNrOfHSDSCHMACdFlows_1,
        maxnoofMulticastServicesPerUE,
        maxnoofMulticastServicesPerRNC,
        maxMBMSSA,
        maxMBMSRA,
        maxNrOfEDCHMACdFlows_1,
        maxGANSSSet,
        maxNrOfCSGs,
        maxNrOfEUTRAFreqs,
        maxNrOfCellIds,
        maxNrOfRAIs,
        maxNrOfLAIs,
        maxSizeOfIMSInfo,
        maxnoofMDTPLMNs,
        maxAddPosSet,
        maxnoofPLMNs,
        id_AreaIdentity,
        id_CN_DomainIndicator,
        id_Cause,
        id_ChosenEncryptionAlgorithm,
        id_ChosenIntegrityProtectionAlgorithm,
        id_ClassmarkInformation2,
        id_ClassmarkInformation3,
        id_CriticalityDiagnostics,
        id_DL_GTP_PDU_SequenceNumber,
        id_EncryptionInformation,
        id_IntegrityProtectionInformation,
        id_IuTransportAssociation,
        id_L3_Information,
        id_LAI,
        id_NAS_PDU,
        id_NonSearchingIndication,
        id_NumberOfSteps,
        id_OMC_ID,
        id_OldBSS_ToNewBSS_Information,
        id_PagingAreaID,
        id_PagingCause,
        id_PermanentNAS_UE_ID,
        id_RAB_ContextItem,
        id_RAB_ContextList,
        id_RAB_DataForwardingItem,
        id_RAB_DataForwardingItem_SRNS_CtxReq,
        id_RAB_DataForwardingList,
        id_RAB_DataForwardingList_SRNS_CtxReq,
        id_RAB_DataVolumeReportItem,
        id_RAB_DataVolumeReportList,
        id_RAB_DataVolumeReportRequestItem,
        id_RAB_DataVolumeReportRequestList,
        id_RAB_FailedItem,
        id_RAB_FailedList,
        id_RAB_ID,
        id_RAB_QueuedItem,
        id_RAB_QueuedList,
        id_RAB_ReleaseFailedList,
        id_RAB_ReleaseItem,
        id_RAB_ReleaseList,
        id_RAB_ReleasedItem,
        id_RAB_ReleasedList,
        id_RAB_ReleasedList_IuRelComp,
        id_RAB_RelocationReleaseItem,
        id_RAB_RelocationReleaseList,
        id_RAB_SetupItem_RelocReq,
        id_RAB_SetupItem_RelocReqAck,
        id_RAB_SetupList_RelocReq,
        id_RAB_SetupList_RelocReqAck,
        id_RAB_SetupOrModifiedItem,
        id_RAB_SetupOrModifiedList,
        id_RAB_SetupOrModifyItem,
        id_RAB_SetupOrModifyList,
        id_RAC,
        id_RelocationType,
        id_RequestType,
        id_SAI,
        id_SAPI,
        id_SourceID,
        id_Source_ToTarget_TransparentContainer,
        id_TargetID,
        id_Target_ToSource_TransparentContainer,
        id_TemporaryUE_ID,
        id_TraceReference,
        id_TraceType,
        id_TransportLayerAddress,
        id_TriggerID,
        id_UE_ID,
        id_UL_GTP_PDU_SequenceNumber,
        id_RAB_FailedtoReportItem,
        id_RAB_FailedtoReportList,
        id_KeyStatus,
        id_DRX_CycleLengthCoefficient,
        id_IuSigConIdList,
        id_IuSigConIdItem,
        id_IuSigConId,
        id_DirectTransferInformationItem_RANAP_RelocInf,
        id_DirectTransferInformationList_RANAP_RelocInf,
        id_RAB_ContextItem_RANAP_RelocInf,
        id_RAB_ContextList_RANAP_RelocInf,
        id_RAB_ContextFailedtoTransferItem,
        id_RAB_ContextFailedtoTransferList,
        id_GlobalRNC_ID,
        id_RAB_ReleasedItem_IuRelComp,
        id_MessageStructure,
        id_Alt_RAB_Parameters,
        id_Ass_RAB_Parameters,
        id_RAB_ModifyList,
        id_RAB_ModifyItem,
        id_TypeOfError,
        id_BroadcastAssistanceDataDecipheringKeys,
        id_LocationRelatedDataRequestType,
        id_GlobalCN_ID,
        id_LastKnownServiceArea,
        id_SRB_TrCH_Mapping,
        id_InterSystemInformation_TransparentContainer,
        id_NewBSS_To_OldBSS_Information,
        id_SourceRNC_PDCP_context_info,
        id_InformationTransferID,
        id_SNA_Access_Information,
        id_ProvidedData,
        id_GERAN_BSC_Container,
        id_GERAN_Classmark,
        id_GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item,
        id_GERAN_Iumode_RAB_FailedList_RABAssgntResponse,
        id_VerticalAccuracyCode,
        id_ResponseTime,
        id_PositioningPriority,
        id_ClientType,
        id_LocationRelatedDataRequestTypeSpecificToGERANIuMode,
        id_SignallingIndication,
        id_hS_DSCH_MAC_d_Flow_ID,
        id_UESBI_Iu,
        id_PositionData,
        id_PositionDataSpecificToGERANIuMode,
        id_CellLoadInformationGroup,
        id_AccuracyFulfilmentIndicator,
        id_InformationTransferType,
        id_TraceRecordingSessionInformation,
        id_TracePropagationParameters,
        id_InterSystemInformationTransferType,
        id_SelectedPLMN_ID,
        id_RedirectionCompleted,
        id_RedirectionIndication,
        id_NAS_SequenceNumber,
        id_RejectCauseValue,
        id_APN,
        id_CNMBMSLinkingInformation,
        id_DeltaRAListofIdleModeUEs,
        id_FrequenceLayerConvergenceFlag,
        id_InformationExchangeID,
        id_InformationExchangeType,
        id_InformationRequested,
        id_InformationRequestType,
        id_IPMulticastAddress,
        id_JoinedMBMSBearerServicesList,
        id_LeftMBMSBearerServicesList,
        id_MBMSBearerServiceType,
        id_MBMSCNDe_Registration,
        id_MBMSServiceArea,
        id_MBMSSessionDuration,
        id_MBMSSessionIdentity,
        id_PDP_TypeInformation,
        id_RAB_Parameters,
        id_RAListofIdleModeUEs,
        id_MBMSRegistrationRequestType,
        id_SessionUpdateID,
        id_TMGI,
        id_TransportLayerInformation,
        id_UnsuccessfulLinkingList,
        id_MBMSLinkingInformation,
        id_MBMSSessionRepetitionNumber,
        id_AlternativeRABConfiguration,
        id_AlternativeRABConfigurationRequest,
        id_E_DCH_MAC_d_Flow_ID,
        id_SourceBSS_ToTargetBSS_TransparentContainer,
        id_TargetBSS_ToSourceBSS_TransparentContainer,
        id_TimeToMBMSDataTransfer,
        id_IncludeVelocity,
        id_VelocityEstimate,
        id_RedirectAttemptFlag,
        id_RAT_Type,
        id_PeriodicLocationInfo,
        id_MBMSCountingInformation,
        id_170_not_to_be_used_for_IE_ids,
        id_ExtendedRNC_ID,
        id_Alt_RAB_Parameter_ExtendedGuaranteedBitrateInf,
        id_Alt_RAB_Parameter_ExtendedMaxBitrateInf,
        id_Ass_RAB_Parameter_ExtendedGuaranteedBitrateList,
        id_Ass_RAB_Parameter_ExtendedMaxBitrateList,
        id_RAB_Parameter_ExtendedGuaranteedBitrateList,
        id_RAB_Parameter_ExtendedMaxBitrateList,
        id_Requested_RAB_Parameter_ExtendedMaxBitrateList,
        id_Requested_RAB_Parameter_ExtendedGuaranteedBitrateList,
        id_LAofIdleModeUEs,
        id_newLAListofIdleModeUEs,
        id_LAListwithNoIdleModeUEsAnyMore,
        id_183_not_to_be_used_for_IE_ids,
        id_GANSS_PositioningDataSet,
        id_RequestedGANSSAssistanceData,
        id_BroadcastGANSSAssistanceDataDecipheringKeys,
        id_d_RNTI_for_NoIuCSUP,
        id_RAB_SetupList_EnhancedRelocCompleteReq,
        id_RAB_SetupItem_EnhancedRelocCompleteReq,
        id_RAB_SetupList_EnhancedRelocCompleteRes,
        id_RAB_SetupItem_EnhancedRelocCompleteRes,
        id_RAB_SetupList_EnhRelocInfoReq,
        id_RAB_SetupItem_EnhRelocInfoReq,
        id_RAB_SetupList_EnhRelocInfoRes,
        id_RAB_SetupItem_EnhRelocInfoRes,
        id_OldIuSigConId,
        id_RAB_FailedList_EnhRelocInfoRes,
        id_RAB_FailedItem_EnhRelocInfoRes,
        id_Global_ENB_ID,
        id_UE_History_Information,
        id_MBMSSynchronisationInformation,
        id_SubscriberProfileIDforRFP,
        id_CSG_Id,
        id_OldIuSigConIdCS,
        id_OldIuSigConIdPS,
        id_GlobalCN_IDCS,
        id_GlobalCN_IDPS,
        id_SourceExtendedRNC_ID,
        id_RAB_ToBeReleasedItem_EnhancedRelocCompleteRes,
        id_RAB_ToBeReleasedList_EnhancedRelocCompleteRes,
        id_SourceRNC_ID,
        id_Relocation_TargetRNC_ID,
        id_Relocation_TargetExtendedRNC_ID,
        id_Alt_RAB_Parameter_SupportedGuaranteedBitrateInf,
        id_Alt_RAB_Parameter_SupportedMaxBitrateInf,
        id_Ass_RAB_Parameter_SupportedGuaranteedBitrateList,
        id_Ass_RAB_Parameter_SupportedMaxBitrateList,
        id_RAB_Parameter_SupportedGuaranteedBitrateList,
        id_RAB_Parameter_SupportedMaxBitrateList,
        id_Requested_RAB_Parameter_SupportedMaxBitrateList,
        id_Requested_RAB_Parameter_SupportedGuaranteedBitrateList,
        id_Relocation_SourceRNC_ID,
        id_Relocation_SourceExtendedRNC_ID,
        id_EncryptionKey,
        id_IntegrityProtectionKey,
        id_SRVCC_HO_Indication,
        id_SRVCC_Information,
        id_SRVCC_Operation_Possible,
        id_CSG_Id_List,
        id_PSRABtobeReplaced,
        id_E_UTRAN_Service_Handover,
        id_UE_AggregateMaximumBitRate,
        id_CSG_Membership_Status,
        id_Cell_Access_Mode,
        id_IP_Source_Address,
        id_CSFB_Information,
        id_PDP_TypeInformation_extension,
        id_MSISDN,
        id_Offload_RAB_Parameters,
        id_LGW_TransportLayerAddress,
        id_Correlation_ID,
        id_IRAT_Measurement_Configuration,
        id_MDT_Configuration,
        id_Priority_Class_Indicator,
        id_RNSAPRelocationParameters,
        id_RABParametersList,
        id_Management_Based_MDT_Allowed,
        id_HigherBitratesThan16MbpsFlag,
        id_Trace_Collection_Entity_IP_Addess,
        id_End_Of_CSFB,
        id_Time_UE_StayedInCell_EnhancedGranularity,
        id_Out_Of_UTRAN,
        id_TraceRecordingSessionReference,
        id_IMSI,
        id_HO_Cause,
        id_VoiceSupportMatchIndicator,
        id_RSRVCC_HO_Indication,
        id_RSRVCC_Information,
        id_AnchorPLMN_ID,
        id_Tunnel_Information_for_BBF,
        id_Management_Based_MDT_PLMN_List,
        id_SignallingBasedMDTPLMNList,
        id_M4Report,
        id_M5Report,
        id_M6Report,
        id_M7Report,
        id_TimingDifferenceULDL,
        id_Serving_Cell_Identifier,
        id_EARFCN_Extended,
        id_RSRVCC_Operation_Possible,
        id_SIPTO_LGW_TransportLayerAddress,
        id_SIPTO_Correlation_ID,
        id_LHN_ID,
        id_Session_Re_establishment_Indicator,
        id_LastE_UTRANPLMNIdentity,
        id_RSRQ_Type,
        id_RSRQ_Extension,
        id_Additional_CSPS_coordination_information,
        id_UERegistrationQueryResult,
        id_IuSigConIdRangeEnd,
        id_BarometricPressure,
        id_Additional_PositioningDataSet,
        id_CivicAddress,
        id_SGSN_Group_Identity,
        id_P_TMSI,
        id_RANAP_Message,
        id_PowerSavingIndicator,
        id_UE_Usage_Type,
        id_DCN_ID,
        id_UE_Application_Layer_Measurement_Configuration,
        id_UE_Application_Layer_Measurement_Configuration_For_Relocation,
        id_UE_Application_Layer_Measurement_Capability,
        id_UeApplicationLayerMeasurementSupportIndication,
        id_SRVCCSource,
    ]

class RANAP_Containers:

    _name_  = u'RANAP-Containers'
    _oid_   = [0, 4, 0, 0, 20, 3, 0, 1, 5]
    
    _obj_ = [
        u'RANAP-PROTOCOL-IES',
        u'RANAP-PROTOCOL-IES-PAIR',
        u'RANAP-PROTOCOL-EXTENSION',
        u'RANAP-PRIVATE-IES',
        u'ProtocolIE-Container',
        u'ProtocolIE-Field',
        u'ProtocolIE-ContainerPair',
        u'ProtocolIE-FieldPair',
        u'ProtocolIE-ContainerList',
        u'ProtocolIE-ContainerPairList',
        u'ProtocolExtensionContainer',
        u'ProtocolExtensionField',
        u'PrivateIE-Container',
        u'PrivateIE-Field',
        ]
    _type_ = [
        u'RANAP-PROTOCOL-IES',
        u'RANAP-PROTOCOL-IES-PAIR',
        u'RANAP-PROTOCOL-EXTENSION',
        u'RANAP-PRIVATE-IES',
        u'ProtocolIE-Container',
        u'ProtocolIE-Field',
        u'ProtocolIE-ContainerPair',
        u'ProtocolIE-FieldPair',
        u'ProtocolIE-ContainerList',
        u'ProtocolIE-ContainerPairList',
        u'ProtocolExtensionContainer',
        u'ProtocolExtensionField',
        u'PrivateIE-Container',
        u'PrivateIE-Field',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        u'RANAP-PROTOCOL-IES',
        u'RANAP-PROTOCOL-IES-PAIR',
        u'RANAP-PROTOCOL-EXTENSION',
        u'RANAP-PRIVATE-IES',
        ]
    _param_ = [
        u'ProtocolIE-Container',
        u'ProtocolIE-Field',
        u'ProtocolIE-ContainerPair',
        u'ProtocolIE-FieldPair',
        u'ProtocolIE-ContainerList',
        u'ProtocolIE-ContainerPairList',
        u'ProtocolExtensionContainer',
        u'ProtocolExtensionField',
        u'PrivateIE-Container',
        u'PrivateIE-Field',
        ]
    
    #-----< RANAP-PROTOCOL-IES >-----#
    RANAP_PROTOCOL_IES = CLASS(name=u'RANAP-PROTOCOL-IES', mode=MODE_TYPE)
    _RANAP_PROTOCOL_IES_id = INT(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _RANAP_PROTOCOL_IES_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'Criticality')))
    _RANAP_PROTOCOL_IES_Value = OPEN(name=u'Value', mode=MODE_TYPE)
    _RANAP_PROTOCOL_IES_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'Presence')))
    RANAP_PROTOCOL_IES._cont = ASN1Dict([
        (u'id', _RANAP_PROTOCOL_IES_id),
        (u'criticality', _RANAP_PROTOCOL_IES_criticality),
        (u'Value', _RANAP_PROTOCOL_IES_Value),
        (u'presence', _RANAP_PROTOCOL_IES_presence),
        ])
    
    #-----< RANAP-PROTOCOL-IES-PAIR >-----#
    RANAP_PROTOCOL_IES_PAIR = CLASS(name=u'RANAP-PROTOCOL-IES-PAIR', mode=MODE_TYPE)
    _RANAP_PROTOCOL_IES_PAIR_id = INT(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _RANAP_PROTOCOL_IES_PAIR_firstCriticality = ENUM(name=u'firstCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'Criticality')))
    _RANAP_PROTOCOL_IES_PAIR_FirstValue = OPEN(name=u'FirstValue', mode=MODE_TYPE)
    _RANAP_PROTOCOL_IES_PAIR_secondCriticality = ENUM(name=u'secondCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'Criticality')))
    _RANAP_PROTOCOL_IES_PAIR_SecondValue = OPEN(name=u'SecondValue', mode=MODE_TYPE)
    _RANAP_PROTOCOL_IES_PAIR_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'Presence')))
    RANAP_PROTOCOL_IES_PAIR._cont = ASN1Dict([
        (u'id', _RANAP_PROTOCOL_IES_PAIR_id),
        (u'firstCriticality', _RANAP_PROTOCOL_IES_PAIR_firstCriticality),
        (u'FirstValue', _RANAP_PROTOCOL_IES_PAIR_FirstValue),
        (u'secondCriticality', _RANAP_PROTOCOL_IES_PAIR_secondCriticality),
        (u'SecondValue', _RANAP_PROTOCOL_IES_PAIR_SecondValue),
        (u'presence', _RANAP_PROTOCOL_IES_PAIR_presence),
        ])
    
    #-----< RANAP-PROTOCOL-EXTENSION >-----#
    RANAP_PROTOCOL_EXTENSION = CLASS(name=u'RANAP-PROTOCOL-EXTENSION', mode=MODE_TYPE)
    _RANAP_PROTOCOL_EXTENSION_id = INT(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'ProtocolExtensionID')), uniq=True)
    _RANAP_PROTOCOL_EXTENSION_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'Criticality')))
    _RANAP_PROTOCOL_EXTENSION_Extension = OPEN(name=u'Extension', mode=MODE_TYPE)
    _RANAP_PROTOCOL_EXTENSION_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'Presence')))
    RANAP_PROTOCOL_EXTENSION._cont = ASN1Dict([
        (u'id', _RANAP_PROTOCOL_EXTENSION_id),
        (u'criticality', _RANAP_PROTOCOL_EXTENSION_criticality),
        (u'Extension', _RANAP_PROTOCOL_EXTENSION_Extension),
        (u'presence', _RANAP_PROTOCOL_EXTENSION_presence),
        ])
    
    #-----< RANAP-PRIVATE-IES >-----#
    RANAP_PRIVATE_IES = CLASS(name=u'RANAP-PRIVATE-IES', mode=MODE_TYPE)
    _RANAP_PRIVATE_IES_id = CHOICE(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'PrivateIE-ID')))
    _RANAP_PRIVATE_IES_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'Criticality')))
    _RANAP_PRIVATE_IES_Value = OPEN(name=u'Value', mode=MODE_TYPE)
    _RANAP_PRIVATE_IES_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'Presence')))
    RANAP_PRIVATE_IES._cont = ASN1Dict([
        (u'id', _RANAP_PRIVATE_IES_id),
        (u'criticality', _RANAP_PRIVATE_IES_criticality),
        (u'Value', _RANAP_PRIVATE_IES_Value),
        (u'presence', _RANAP_PRIVATE_IES_presence),
        ])
    
    #-----< ProtocolIE-Container >-----#
    ProtocolIE_Container = SEQ_OF(name=u'ProtocolIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-Field >-----#
    ProtocolIE_Field = SEQ(name=u'ProtocolIE-Field', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerPair >-----#
    ProtocolIE_ContainerPair = SEQ_OF(name=u'ProtocolIE-ContainerPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-FieldPair >-----#
    ProtocolIE_FieldPair = SEQ(name=u'ProtocolIE-FieldPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerList >-----#
    ProtocolIE_ContainerList = SEQ_OF(name=u'ProtocolIE-ContainerList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerPairList >-----#
    ProtocolIE_ContainerPairList = SEQ_OF(name=u'ProtocolIE-ContainerPairList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionContainer >-----#
    ProtocolExtensionContainer = SEQ_OF(name=u'ProtocolExtensionContainer', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionField >-----#
    ProtocolExtensionField = SEQ(name=u'ProtocolExtensionField', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Container >-----#
    PrivateIE_Container = SEQ_OF(name=u'PrivateIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Field >-----#
    PrivateIE_Field = SEQ(name=u'PrivateIE-Field', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _RANAP_PROTOCOL_IES_id,
        _RANAP_PROTOCOL_IES_criticality,
        _RANAP_PROTOCOL_IES_Value,
        _RANAP_PROTOCOL_IES_presence,
        RANAP_PROTOCOL_IES,
        _RANAP_PROTOCOL_IES_PAIR_id,
        _RANAP_PROTOCOL_IES_PAIR_firstCriticality,
        _RANAP_PROTOCOL_IES_PAIR_FirstValue,
        _RANAP_PROTOCOL_IES_PAIR_secondCriticality,
        _RANAP_PROTOCOL_IES_PAIR_SecondValue,
        _RANAP_PROTOCOL_IES_PAIR_presence,
        RANAP_PROTOCOL_IES_PAIR,
        _RANAP_PROTOCOL_EXTENSION_id,
        _RANAP_PROTOCOL_EXTENSION_criticality,
        _RANAP_PROTOCOL_EXTENSION_Extension,
        _RANAP_PROTOCOL_EXTENSION_presence,
        RANAP_PROTOCOL_EXTENSION,
        _RANAP_PRIVATE_IES_id,
        _RANAP_PRIVATE_IES_criticality,
        _RANAP_PRIVATE_IES_Value,
        _RANAP_PRIVATE_IES_presence,
        RANAP_PRIVATE_IES,
    ]

class RANAP_IEs:

    _name_  = u'RANAP-IEs'
    _oid_   = [0, 4, 0, 0, 20, 3, 0, 1, 2]
    
    _obj_ = [
        u'AccuracyFulfilmentIndicator',
        u'Additional-CSPS-coordination-information',
        u'Additional-CSPS-coordination-information-ExtIEs',
        u'Additional-PositioningDataSet',
        u'Additional-PositioningMethodAndUsage',
        u'AllocationOrRetentionPriority',
        u'AllocationOrRetentionPriority-ExtIEs',
        u'Alt-RAB-Parameters',
        u'Alt-RAB-Parameters-ExtIEs',
        u'Alt-RAB-Parameter-ExtendedGuaranteedBitrateInf',
        u'Alt-RAB-Parameter-ExtendedGuaranteedBitrates',
        u'Alt-RAB-Parameter-ExtendedGuaranteedBitrateList',
        u'Alt-RAB-Parameter-GuaranteedBitrateInf',
        u'Alt-RAB-Parameter-GuaranteedBitrateType',
        u'Alt-RAB-Parameter-GuaranteedBitrates',
        u'Alt-RAB-Parameter-GuaranteedBitrateList',
        u'Alt-RAB-Parameter-SupportedGuaranteedBitrateInf',
        u'Alt-RAB-Parameter-SupportedGuaranteedBitrateInf-ExtIEs',
        u'Alt-RAB-Parameter-SupportedGuaranteedBitrates',
        u'Alt-RAB-Parameter-ExtendedMaxBitrateInf',
        u'Alt-RAB-Parameter-ExtendedMaxBitrates',
        u'Alt-RAB-Parameter-ExtendedMaxBitrateList',
        u'Alt-RAB-Parameter-MaxBitrateInf',
        u'Alt-RAB-Parameter-MaxBitrateType',
        u'Alt-RAB-Parameter-MaxBitrates',
        u'Alt-RAB-Parameter-MaxBitrateList',
        u'Alt-RAB-Parameter-SupportedMaxBitrateInf',
        u'Alt-RAB-Parameter-SupportedMaxBitrateInf-ExtIEs',
        u'Alt-RAB-Parameter-SupportedMaxBitrates',
        u'AlternativeRABConfigurationRequest',
        u'UE-Application-Layer-Measurement-Configuration',
        u'UE-Application-Layer-Measurement-Configuration-For-Relocation',
        u'ServiceType',
        u'APN',
        u'AreaScopeForUEApplicationLayerMeasurementConfiguration',
        u'AreaIdentity',
        u'Ass-RAB-Parameters',
        u'Ass-RAB-Parameters-ExtIEs',
        u'Ass-RAB-Parameter-ExtendedGuaranteedBitrateList',
        u'Ass-RAB-Parameter-ExtendedMaxBitrateList',
        u'Ass-RAB-Parameter-GuaranteedBitrateList',
        u'Ass-RAB-Parameter-MaxBitrateList',
        u'AuthorisedPLMNs',
        u'AuthorisedPLMNs-ExtIEs',
        u'AuthorisedSNAs',
        u'BarometricPressure',
        u'BindingID',
        u'BroadcastAssistanceDataDecipheringKeys',
        u'Cause',
        u'CauseMisc',
        u'CauseNAS',
        u'CauseProtocol',
        u'CauseRadioNetwork',
        u'CauseRadioNetworkExtension',
        u'CauseNon-Standard',
        u'CauseTransmissionNetwork',
        u'Cell-Access-Mode',
        u'CellBased',
        u'CellBased-ExtIEs',
        u'CellIdList',
        u'Cell-Id',
        u'Cell-Capacity-Class-Value',
        u'CellLoadInformation',
        u'CellLoadInformation-ExtIEs',
        u'CellLoadInformationGroup',
        u'CellLoadInformationGroup-ExtIEs',
        u'CellType',
        u'CivicAddress',
        u'ClientType',
        u'CriticalityDiagnostics',
        u'CriticalityDiagnostics-ExtIEs',
        u'CriticalityDiagnostics-IE-List',
        u'CriticalityDiagnostics-IE-List-ExtIEs',
        u'MessageStructure',
        u'MessageStructure-ExtIEs',
        u'CGI',
        u'CGI-ExtIEs',
        u'ChosenEncryptionAlgorithm',
        u'ChosenIntegrityProtectionAlgorithm',
        u'CI',
        u'ClassmarkInformation2',
        u'ClassmarkInformation3',
        u'CN-DomainIndicator',
        u'CN-ID',
        u'Correlation-ID',
        u'CSFB-Information',
        u'CSG-Id',
        u'CSG-Id-List',
        u'CSG-Membership-Status',
        u'DataPDUType',
        u'DataVolumeReference',
        u'DataVolumeReportingIndication',
        u'DCH-ID',
        u'DCN-ID',
        u'DeliveryOfErroneousSDU',
        u'DeliveryOrder',
        u'DeltaRAListofIdleModeUEs',
        u'NewRAListofIdleModeUEs',
        u'RAListwithNoIdleModeUEsAnyMore',
        u'DeltaRAListofIdleModeUEs-ExtIEs',
        u'ForwardingIndication',
        u'DL-GTP-PDU-SequenceNumber',
        u'DL-N-PDU-SequenceNumber',
        u'D-RNTI',
        u'DRX-CycleLengthCoefficient',
        u'DSCH-ID',
        u'EARFCN-Extended',
        u'E-DCH-MAC-d-Flow-ID',
        u'ENB-ID',
        u'EncryptionAlgorithm',
        u'EncryptionInformation',
        u'EncryptionInformation-ExtIEs',
        u'EncryptionKey',
        u'End-Of-CSFB',
        u'EquipmentsToBeTraced',
        u'E-UTRAN-Service-Handover',
        u'Event',
        u'Event1F-Parameters',
        u'Event1I-Parameters',
        u'ExtendedGuaranteedBitrate',
        u'ExtendedMaxBitrate',
        u'ExtendedRNC-ID',
        u'FrameSequenceNumber',
        u'FrequenceLayerConvergenceFlag',
        u'GANSS-PositioningDataSet',
        u'GANSS-PositioningMethodAndUsage',
        u'GeographicalArea',
        u'GeographicalCoordinates',
        u'GeographicalCoordinates-ExtIEs',
        u'GA-AltitudeAndDirection',
        u'GA-EllipsoidArc',
        u'GA-EllipsoidArc-ExtIEs',
        u'GA-Point',
        u'GA-Point-ExtIEs',
        u'GA-PointWithAltitude',
        u'GA-PointWithAltitude-ExtIEs',
        u'GA-PointWithAltitudeAndUncertaintyEllipsoid',
        u'GA-PointWithAltitudeAndUncertaintyEllipsoid-ExtIEs',
        u'GA-PointWithUnCertainty',
        u'GA-PointWithUnCertainty-ExtIEs',
        u'GA-PointWithUnCertaintyEllipse',
        u'GA-PointWithUnCertaintyEllipse-ExtIEs',
        u'GA-Polygon',
        u'GA-Polygon-ExtIEs',
        u'GA-UncertaintyEllipse',
        u'GERAN-BSC-Container',
        u'GERAN-Cell-ID',
        u'GERAN-Cell-ID-ExtIEs',
        u'GERAN-Classmark',
        u'GlobalCN-ID',
        u'GlobalRNC-ID',
        u'GTP-TEI',
        u'GuaranteedBitrate',
        u'HigherBitratesThan16MbpsFlag',
        u'HS-DSCH-MAC-d-Flow-ID',
        u'IMEI',
        u'IMEIGroup',
        u'IMEIGroup-ExtIEs',
        u'IMEIList',
        u'IMEISV',
        u'IMEISVGroup',
        u'IMEISVGroup-ExtIEs',
        u'IMEISVList',
        u'ImmediateMDT',
        u'ImmediateMDT-ExtIEs',
        u'IMSI',
        u'IncludeVelocity',
        u'InformationExchangeID',
        u'InformationExchangeType',
        u'InformationRequested',
        u'InformationRequestType',
        u'InformationTransferID',
        u'InformationTransferType',
        u'IntegrityProtectionAlgorithm',
        u'IntegrityProtectionInformation',
        u'IntegrityProtectionInformation-ExtIEs',
        u'IntegrityProtectionKey',
        u'InterSystemInformationTransferType',
        u'InterSystemInformation-TransparentContainer',
        u'InterSystemInformation-TransparentContainer-ExtIEs',
        u'IPMulticastAddress',
        u'IuSignallingConnectionIdentifier',
        u'IuTransportAssociation',
        u'KeyStatus',
        u'LA-LIST',
        u'LA-LIST-ExtIEs',
        u'LAC',
        u'LAI',
        u'LAI-ExtIEs',
        u'LastKnownServiceArea',
        u'LastKnownServiceArea-ExtIEs',
        u'LastVisitedUTRANCell-Item',
        u'LastVisitedUTRANCell-Item-ExtIEs',
        u'LHN-ID',
        u'Links-to-log',
        u'ListOF-SNAs',
        u'ListOfInterfacesToTrace',
        u'InterfacesToTraceItem',
        u'InterfacesToTraceItem-ExtIEs',
        u'LoadValue',
        u'LocationRelatedDataRequestType',
        u'LocationRelatedDataRequestTypeSpecificToGERANIuMode',
        u'LocationReportingTransferInformation',
        u'LocationReportingTransferInformation-ExtIEs',
        u'ReportChangeOfSAI',
        u'PeriodicReportingIndicator',
        u'DirectReportingIndicator',
        u'L3-Information',
        u'M1Report',
        u'M2Report',
        u'M4Report',
        u'M4-Collection-Parameters',
        u'M4-Collection-Parameters-ExtIEs',
        u'M4-Period',
        u'M4-Threshold',
        u'M5Report',
        u'M5-Period',
        u'M6Report',
        u'M6Report-ExtIEs',
        u'M6-Period',
        u'M7Report',
        u'M7Report-ExtIEs',
        u'M7-Period',
        u'Management-Based-MDT-Allowed',
        u'MaxBitrate',
        u'MaxSDU-Size',
        u'MBMS-PTP-RAB-ID',
        u'MBMSBearerServiceType',
        u'MBMSCNDe-Registration',
        u'MBMSCountingInformation',
        u'MBMSHCIndicator',
        u'MBMSIPMulticastAddressandAPNRequest',
        u'MBMSLinkingInformation',
        u'MBMSRegistrationRequestType',
        u'MBMSServiceArea',
        u'MBMSSessionDuration',
        u'MBMSSessionIdentity',
        u'MBMSSessionRepetitionNumber',
        u'MDT-Activation',
        u'MDTAreaScope',
        u'MDT-Configuration',
        u'MDT-Configuration-ExtIEs',
        u'MDTMode',
        u'MDT-PLMN-List',
        u'MDT-Report-Parameters',
        u'MeasurementQuantity',
        u'MeasurementsToActivate',
        u'MSISDN',
        u'NAS-PDU',
        u'NAS-SequenceNumber',
        u'NAS-SynchronisationIndicator',
        u'NewBSS-To-OldBSS-Information',
        u'NonSearchingIndication',
        u'NRTLoadInformationValue',
        u'Null-NRI',
        u'NumberOfIuInstances',
        u'NumberOfSteps',
        u'Offload-RAB-Parameters',
        u'Offload-RAB-Parameters-ExtIEs',
        u'Offload-RAB-Parameters-APN',
        u'Offload-RAB-Parameters-ChargingCharacteristics',
        u'OldBSS-ToNewBSS-Information',
        u'OMC-ID',
        u'Out-Of-UTRAN',
        u'PagingAreaID',
        u'PagingCause',
        u'PDP-TypeInformation',
        u'PDP-Type',
        u'PDP-TypeInformation-extension',
        u'PDP-Type-extension',
        u'PDUType14FrameSequenceNumber',
        u'PeriodicLocationInfo',
        u'PeriodicLocationInfo-ExtIEs',
        u'PermanentNAS-UE-ID',
        u'PermittedEncryptionAlgorithms',
        u'PermittedIntegrityProtectionAlgorithms',
        u'LABased',
        u'LABased-ExtIEs',
        u'LAI-List',
        u'LoggedMDT',
        u'LoggedMDT-ExtIEs',
        u'LoggingInterval',
        u'LoggingDuration',
        u'PLMNBased',
        u'PLMNBased-ExtIEs',
        u'PLMNList',
        u'PLMNidentity',
        u'PLMNs-in-shared-network',
        u'PLMNs-in-shared-network-ExtIEs',
        u'Port-Number',
        u'PositioningDataDiscriminator',
        u'PositioningDataSet',
        u'PositioningMethodAndUsage',
        u'PositioningPriority',
        u'PositionData',
        u'PositionData-ExtIEs',
        u'PositionDataSpecificToGERANIuMode',
        u'Pre-emptionCapability',
        u'Pre-emptionVulnerability',
        u'PriorityLevel',
        u'Priority-Class-Indicator',
        u'ProvidedData',
        u'PowerSavingIndicator',
        u'P-TMSI',
        u'QueuingAllowed',
        u'RAB-AsymmetryIndicator',
        u'RABased',
        u'RABased-ExtIEs',
        u'RAI-List',
        u'RABDataVolumeReport',
        u'RABDataVolumeReport-ExtIEs',
        u'RAB-ID',
        u'RAB-Parameter-ExtendedGuaranteedBitrateList',
        u'RAB-Parameter-ExtendedMaxBitrateList',
        u'RAB-Parameter-GuaranteedBitrateList',
        u'RAB-Parameter-MaxBitrateList',
        u'RAB-Parameters',
        u'RAB-Parameters-ExtIEs',
        u'RABParametersList',
        u'RABParametersList-ExtIEs',
        u'RAB-SubflowCombinationBitRate',
        u'RAB-TrCH-Mapping',
        u'RAB-TrCH-MappingItem',
        u'RAB-TrCH-MappingItem-ExtIEs',
        u'RAC',
        u'RAI',
        u'RAI-ExtIEs',
        u'RAListofIdleModeUEs',
        u'NotEmptyRAListofIdleModeUEs',
        u'RAofIdleModeUEs',
        u'NotEmptyRAListofIdleModeUEs-ExtIEs',
        u'LAListofIdleModeUEs',
        u'RAT-Type',
        u'RateControlAllowed',
        u'RedirectAttemptFlag',
        u'RedirectionCompleted',
        u'RejectCauseValue',
        u'RelocationRequirement',
        u'RelocationType',
        u'RepetitionNumber0',
        u'RepetitionNumber1',
        u'ReportArea',
        u'ReportInterval',
        u'ReportAmount',
        u'RequestedGPSAssistanceData',
        u'RequestedGANSSAssistanceData',
        u'RequestedLocationRelatedDataType',
        u'RequestedMBMSIPMulticastAddressandAPNRequest',
        u'MBMSIPMulticastAddressandAPNlist',
        u'MBMSIPMulticastAddressandAPNlist-ExtIEs',
        u'RequestedMulticastServiceList',
        u'Requested-RAB-Parameter-Values',
        u'Requested-RAB-Parameter-Values-ExtIEs',
        u'Requested-RAB-Parameter-ExtendedMaxBitrateList',
        u'Requested-RAB-Parameter-ExtendedGuaranteedBitrateList',
        u'Requested-RAB-Parameter-MaxBitrateList',
        u'Requested-RAB-Parameter-GuaranteedBitrateList',
        u'RequestType',
        u'ResidualBitErrorRatio',
        u'ResidualBitErrorRatio-ExtIEs',
        u'ResponseTime',
        u'RIMInformation',
        u'RIM-Transfer',
        u'RIM-Transfer-ExtIEs',
        u'RIMRoutingAddress',
        u'RNC-ID',
        u'RNCTraceInformation',
        u'RNCTraceInformation-ExtIEs',
        u'RNSAPRelocationParameters',
        u'RNSAPRelocationParameters-ExtIEs',
        u'RRC-Container',
        u'RTLoadValue',
        u'RSRVCC-HO-Indication',
        u'RSRVCC-Information',
        u'RSRVCC-Information-ExtIEs',
        u'RSRVCC-Operation-Possible',
        u'SAC',
        u'SAI',
        u'SAI-ExtIEs',
        u'SAPI',
        u'SessionUpdateID',
        u'Shared-Network-Information',
        u'Session-Re-establishment-Indicator',
        u'Shared-Network-Information-ExtIEs',
        u'SignallingIndication',
        u'SDU-ErrorRatio',
        u'SDU-ErrorRatio-ExtIEs',
        u'SDU-FormatInformationParameters',
        u'SDU-FormatInformationParameters-ExtIEs',
        u'SDU-Parameters',
        u'SDU-Parameters-ExtIEs',
        u'SGSN-Group-Identity',
        u'SGSN-Group-ID',
        u'SNA-Access-Information',
        u'SNA-Access-Information-ExtIEs',
        u'SNAC',
        u'Service-Handover',
        u'Source-ToTarget-TransparentContainer',
        u'SourceeNodeB-ToTargeteNodeB-TransparentContainer',
        u'SourceCellID',
        u'SourceBSS-ToTargetBSS-TransparentContainer',
        u'SourceID',
        u'SourceRNC-ID',
        u'SourceRNC-ID-ExtIEs',
        u'SourceRNC-ToTargetRNC-TransparentContainer',
        u'SourceRNC-ToTargetRNC-TransparentContainer-ExtIEs',
        u'SRVCCSource',
        u'IRAT-Measurement-Configuration',
        u'IRAT-Measurement-Configuration-ExtIEs',
        u'IRATmeasurementParameters',
        u'IRATmeasurementParameters-ExtIEs',
        u'RSRQ-Type',
        u'RSRQ-Extension',
        u'EUTRANFrequencies',
        u'MeasBand',
        u'EUTRANFrequencies-ExtIEs',
        u'SubscriberProfileIDforRFP',
        u'SourceStatisticsDescriptor',
        u'SupportedRAB-ParameterBitrateList',
        u'SupportedBitrate',
        u'SourceUTRANCellID',
        u'SourceUTRANCellID-ExtIEs',
        u'SRB-ID',
        u'SRB-TrCH-Mapping',
        u'SRB-TrCH-MappingItem',
        u'SRB-TrCH-MappingItem-ExtIEs',
        u'SRVCC-HO-Indication',
        u'SRVCC-Information',
        u'SRVCC-Information-ExtIEs',
        u'SRVCC-Operation-Possible',
        u'SubflowSDU-Size',
        u'TAC',
        u'TAI',
        u'TAI-ExtIEs',
        u'Target-ToSource-TransparentContainer',
        u'TargeteNodeB-ToSourceeNodeB-TransparentContainer',
        u'TargetBSS-ToSourceBSS-TransparentContainer',
        u'TargetCellId',
        u'TargetID',
        u'TargetENB-ID',
        u'TargetENB-ID-ExtIEs',
        u'TargetRNC-ID',
        u'TargetRNC-ID-ExtIEs',
        u'TargetRNC-ToSourceRNC-TransparentContainer',
        u'TargetRNC-ToSourceRNC-TransparentContainer-ExtIEs',
        u'UeApplicationLayerMeasurementSupportIndication',
        u'TBCD-STRING',
        u'TemporaryUE-ID',
        u'Time-UE-StayedInCell',
        u'Time-UE-StayedInCell-EnhancedGranularity',
        u'TimeToMBMSDataTransfer',
        u'TimingDifferenceULDL',
        u'TMGI',
        u'TMGI-ExtIEs',
        u'TMSI',
        u'TraceDepth',
        u'TraceInformation',
        u'TraceInformation-ExtIEs',
        u'TracePropagationParameters',
        u'TracePropagationParameters-ExtIEs',
        u'TraceRecordingSessionInformation',
        u'TraceRecordingSessionInformation-ExtIEs',
        u'TraceRecordingSessionReference',
        u'TraceReference',
        u'TraceType',
        u'TrafficClass',
        u'TrafficHandlingPriority',
        u'TransferDelay',
        u'UnsuccessfullyTransmittedDataVolume',
        u'TransportLayerAddress',
        u'TrCH-ID',
        u'TrCH-ID-ExtIEs',
        u'TrCH-ID-List',
        u'TriggerID',
        u'TunnelInformation',
        u'Tunnel-Information-ExtIEs',
        u'TypeOfError',
        u'UE-AggregateMaximumBitRate',
        u'UE-AggregateMaximumBitRateDownlink',
        u'UE-AggregateMaximumBitRateUplink',
        u'UE-Application-Layer-Measurement-Capability',
        u'UE-History-Information',
        u'UE-ID',
        u'UE-IsNotServed',
        u'UE-IsNotServed-ExtIEs',
        u'UE-IsServed',
        u'UE-IsServed-ExtIEs',
        u'UE-Usage-Type',
        u'UERegistrationQueryResult',
        u'UESBI-Iu',
        u'UESBI-Iu-ExtIEs',
        u'UESBI-IuA',
        u'UESBI-IuB',
        u'UL-GTP-PDU-SequenceNumber',
        u'UL-N-PDU-SequenceNumber',
        u'UPInformation',
        u'UPInformation-ExtIEs',
        u'UPInitialisationFrame',
        u'UP-ModeVersions',
        u'USCH-ID',
        u'UserPlaneMode',
        u'UTRAN-CellID',
        u'UTRAN-CellID-ExtIEs',
        u'VelocityEstimate',
        u'HorizontalVelocity',
        u'HorizontalVelocity-ExtIEs',
        u'HorizontalWithVerticalVelocity',
        u'HorizontalWithVerticalVelocity-ExtIEs',
        u'HorizontalVelocityWithUncertainty',
        u'HorizontalVelocityWithUncertainty-ExtIEs',
        u'HorizontalWithVerticalVelocityAndUncertainty',
        u'HorizontalWithVerticalVelocityAndUncertainty-ExtIEs',
        u'HorizontalSpeedAndBearing',
        u'VerticalVelocity',
        u'VerticalSpeedDirection',
        u'VerticalAccuracyCode',
        u'VoiceSupportMatchIndicator',
        ]
    _type_ = [
        u'AccuracyFulfilmentIndicator',
        u'Additional-CSPS-coordination-information',
        u'Additional-PositioningDataSet',
        u'Additional-PositioningMethodAndUsage',
        u'AllocationOrRetentionPriority',
        u'Alt-RAB-Parameters',
        u'Alt-RAB-Parameter-ExtendedGuaranteedBitrateInf',
        u'Alt-RAB-Parameter-ExtendedGuaranteedBitrates',
        u'Alt-RAB-Parameter-ExtendedGuaranteedBitrateList',
        u'Alt-RAB-Parameter-GuaranteedBitrateInf',
        u'Alt-RAB-Parameter-GuaranteedBitrateType',
        u'Alt-RAB-Parameter-GuaranteedBitrates',
        u'Alt-RAB-Parameter-GuaranteedBitrateList',
        u'Alt-RAB-Parameter-SupportedGuaranteedBitrateInf',
        u'Alt-RAB-Parameter-SupportedGuaranteedBitrates',
        u'Alt-RAB-Parameter-ExtendedMaxBitrateInf',
        u'Alt-RAB-Parameter-ExtendedMaxBitrates',
        u'Alt-RAB-Parameter-ExtendedMaxBitrateList',
        u'Alt-RAB-Parameter-MaxBitrateInf',
        u'Alt-RAB-Parameter-MaxBitrateType',
        u'Alt-RAB-Parameter-MaxBitrates',
        u'Alt-RAB-Parameter-MaxBitrateList',
        u'Alt-RAB-Parameter-SupportedMaxBitrateInf',
        u'Alt-RAB-Parameter-SupportedMaxBitrates',
        u'AlternativeRABConfigurationRequest',
        u'UE-Application-Layer-Measurement-Configuration',
        u'UE-Application-Layer-Measurement-Configuration-For-Relocation',
        u'ServiceType',
        u'APN',
        u'AreaScopeForUEApplicationLayerMeasurementConfiguration',
        u'AreaIdentity',
        u'Ass-RAB-Parameters',
        u'Ass-RAB-Parameter-ExtendedGuaranteedBitrateList',
        u'Ass-RAB-Parameter-ExtendedMaxBitrateList',
        u'Ass-RAB-Parameter-GuaranteedBitrateList',
        u'Ass-RAB-Parameter-MaxBitrateList',
        u'AuthorisedPLMNs',
        u'AuthorisedSNAs',
        u'BarometricPressure',
        u'BindingID',
        u'BroadcastAssistanceDataDecipheringKeys',
        u'Cause',
        u'CauseMisc',
        u'CauseNAS',
        u'CauseProtocol',
        u'CauseRadioNetwork',
        u'CauseRadioNetworkExtension',
        u'CauseNon-Standard',
        u'CauseTransmissionNetwork',
        u'Cell-Access-Mode',
        u'CellBased',
        u'CellIdList',
        u'Cell-Id',
        u'Cell-Capacity-Class-Value',
        u'CellLoadInformation',
        u'CellLoadInformationGroup',
        u'CellType',
        u'CivicAddress',
        u'ClientType',
        u'CriticalityDiagnostics',
        u'CriticalityDiagnostics-IE-List',
        u'MessageStructure',
        u'CGI',
        u'ChosenEncryptionAlgorithm',
        u'ChosenIntegrityProtectionAlgorithm',
        u'CI',
        u'ClassmarkInformation2',
        u'ClassmarkInformation3',
        u'CN-DomainIndicator',
        u'CN-ID',
        u'Correlation-ID',
        u'CSFB-Information',
        u'CSG-Id',
        u'CSG-Id-List',
        u'CSG-Membership-Status',
        u'DataPDUType',
        u'DataVolumeReference',
        u'DataVolumeReportingIndication',
        u'DCH-ID',
        u'DCN-ID',
        u'DeliveryOfErroneousSDU',
        u'DeliveryOrder',
        u'DeltaRAListofIdleModeUEs',
        u'NewRAListofIdleModeUEs',
        u'RAListwithNoIdleModeUEsAnyMore',
        u'ForwardingIndication',
        u'DL-GTP-PDU-SequenceNumber',
        u'DL-N-PDU-SequenceNumber',
        u'D-RNTI',
        u'DRX-CycleLengthCoefficient',
        u'DSCH-ID',
        u'EARFCN-Extended',
        u'E-DCH-MAC-d-Flow-ID',
        u'ENB-ID',
        u'EncryptionAlgorithm',
        u'EncryptionInformation',
        u'EncryptionKey',
        u'End-Of-CSFB',
        u'EquipmentsToBeTraced',
        u'E-UTRAN-Service-Handover',
        u'Event',
        u'Event1F-Parameters',
        u'Event1I-Parameters',
        u'ExtendedGuaranteedBitrate',
        u'ExtendedMaxBitrate',
        u'ExtendedRNC-ID',
        u'FrameSequenceNumber',
        u'FrequenceLayerConvergenceFlag',
        u'GANSS-PositioningDataSet',
        u'GANSS-PositioningMethodAndUsage',
        u'GeographicalArea',
        u'GeographicalCoordinates',
        u'GA-AltitudeAndDirection',
        u'GA-EllipsoidArc',
        u'GA-Point',
        u'GA-PointWithAltitude',
        u'GA-PointWithAltitudeAndUncertaintyEllipsoid',
        u'GA-PointWithUnCertainty',
        u'GA-PointWithUnCertaintyEllipse',
        u'GA-Polygon',
        u'GA-UncertaintyEllipse',
        u'GERAN-BSC-Container',
        u'GERAN-Cell-ID',
        u'GERAN-Classmark',
        u'GlobalCN-ID',
        u'GlobalRNC-ID',
        u'GTP-TEI',
        u'GuaranteedBitrate',
        u'HigherBitratesThan16MbpsFlag',
        u'HS-DSCH-MAC-d-Flow-ID',
        u'IMEI',
        u'IMEIGroup',
        u'IMEIList',
        u'IMEISV',
        u'IMEISVGroup',
        u'IMEISVList',
        u'ImmediateMDT',
        u'IMSI',
        u'IncludeVelocity',
        u'InformationExchangeID',
        u'InformationExchangeType',
        u'InformationRequested',
        u'InformationRequestType',
        u'InformationTransferID',
        u'InformationTransferType',
        u'IntegrityProtectionAlgorithm',
        u'IntegrityProtectionInformation',
        u'IntegrityProtectionKey',
        u'InterSystemInformationTransferType',
        u'InterSystemInformation-TransparentContainer',
        u'IPMulticastAddress',
        u'IuSignallingConnectionIdentifier',
        u'IuTransportAssociation',
        u'KeyStatus',
        u'LA-LIST',
        u'LAC',
        u'LAI',
        u'LastKnownServiceArea',
        u'LastVisitedUTRANCell-Item',
        u'LHN-ID',
        u'Links-to-log',
        u'ListOF-SNAs',
        u'ListOfInterfacesToTrace',
        u'InterfacesToTraceItem',
        u'LoadValue',
        u'LocationRelatedDataRequestType',
        u'LocationRelatedDataRequestTypeSpecificToGERANIuMode',
        u'LocationReportingTransferInformation',
        u'ReportChangeOfSAI',
        u'PeriodicReportingIndicator',
        u'DirectReportingIndicator',
        u'L3-Information',
        u'M1Report',
        u'M2Report',
        u'M4Report',
        u'M4-Collection-Parameters',
        u'M4-Period',
        u'M4-Threshold',
        u'M5Report',
        u'M5-Period',
        u'M6Report',
        u'M6-Period',
        u'M7Report',
        u'M7-Period',
        u'Management-Based-MDT-Allowed',
        u'MaxBitrate',
        u'MaxSDU-Size',
        u'MBMS-PTP-RAB-ID',
        u'MBMSBearerServiceType',
        u'MBMSCNDe-Registration',
        u'MBMSCountingInformation',
        u'MBMSHCIndicator',
        u'MBMSIPMulticastAddressandAPNRequest',
        u'MBMSLinkingInformation',
        u'MBMSRegistrationRequestType',
        u'MBMSServiceArea',
        u'MBMSSessionDuration',
        u'MBMSSessionIdentity',
        u'MBMSSessionRepetitionNumber',
        u'MDT-Activation',
        u'MDTAreaScope',
        u'MDT-Configuration',
        u'MDTMode',
        u'MDT-PLMN-List',
        u'MDT-Report-Parameters',
        u'MeasurementQuantity',
        u'MeasurementsToActivate',
        u'MSISDN',
        u'NAS-PDU',
        u'NAS-SequenceNumber',
        u'NAS-SynchronisationIndicator',
        u'NewBSS-To-OldBSS-Information',
        u'NonSearchingIndication',
        u'NRTLoadInformationValue',
        u'Null-NRI',
        u'NumberOfIuInstances',
        u'NumberOfSteps',
        u'Offload-RAB-Parameters',
        u'Offload-RAB-Parameters-APN',
        u'Offload-RAB-Parameters-ChargingCharacteristics',
        u'OldBSS-ToNewBSS-Information',
        u'OMC-ID',
        u'Out-Of-UTRAN',
        u'PagingAreaID',
        u'PagingCause',
        u'PDP-TypeInformation',
        u'PDP-Type',
        u'PDP-TypeInformation-extension',
        u'PDP-Type-extension',
        u'PDUType14FrameSequenceNumber',
        u'PeriodicLocationInfo',
        u'PermanentNAS-UE-ID',
        u'PermittedEncryptionAlgorithms',
        u'PermittedIntegrityProtectionAlgorithms',
        u'LABased',
        u'LAI-List',
        u'LoggedMDT',
        u'LoggingInterval',
        u'LoggingDuration',
        u'PLMNBased',
        u'PLMNList',
        u'PLMNidentity',
        u'PLMNs-in-shared-network',
        u'Port-Number',
        u'PositioningDataDiscriminator',
        u'PositioningDataSet',
        u'PositioningMethodAndUsage',
        u'PositioningPriority',
        u'PositionData',
        u'PositionDataSpecificToGERANIuMode',
        u'Pre-emptionCapability',
        u'Pre-emptionVulnerability',
        u'PriorityLevel',
        u'Priority-Class-Indicator',
        u'ProvidedData',
        u'PowerSavingIndicator',
        u'P-TMSI',
        u'QueuingAllowed',
        u'RAB-AsymmetryIndicator',
        u'RABased',
        u'RAI-List',
        u'RABDataVolumeReport',
        u'RAB-ID',
        u'RAB-Parameter-ExtendedGuaranteedBitrateList',
        u'RAB-Parameter-ExtendedMaxBitrateList',
        u'RAB-Parameter-GuaranteedBitrateList',
        u'RAB-Parameter-MaxBitrateList',
        u'RAB-Parameters',
        u'RABParametersList',
        u'RAB-SubflowCombinationBitRate',
        u'RAB-TrCH-Mapping',
        u'RAB-TrCH-MappingItem',
        u'RAC',
        u'RAI',
        u'RAListofIdleModeUEs',
        u'NotEmptyRAListofIdleModeUEs',
        u'RAofIdleModeUEs',
        u'LAListofIdleModeUEs',
        u'RAT-Type',
        u'RateControlAllowed',
        u'RedirectAttemptFlag',
        u'RedirectionCompleted',
        u'RejectCauseValue',
        u'RelocationRequirement',
        u'RelocationType',
        u'RepetitionNumber0',
        u'RepetitionNumber1',
        u'ReportArea',
        u'ReportInterval',
        u'ReportAmount',
        u'RequestedGPSAssistanceData',
        u'RequestedGANSSAssistanceData',
        u'RequestedLocationRelatedDataType',
        u'RequestedMBMSIPMulticastAddressandAPNRequest',
        u'MBMSIPMulticastAddressandAPNlist',
        u'RequestedMulticastServiceList',
        u'Requested-RAB-Parameter-Values',
        u'Requested-RAB-Parameter-ExtendedMaxBitrateList',
        u'Requested-RAB-Parameter-ExtendedGuaranteedBitrateList',
        u'Requested-RAB-Parameter-MaxBitrateList',
        u'Requested-RAB-Parameter-GuaranteedBitrateList',
        u'RequestType',
        u'ResidualBitErrorRatio',
        u'ResponseTime',
        u'RIMInformation',
        u'RIM-Transfer',
        u'RIMRoutingAddress',
        u'RNC-ID',
        u'RNCTraceInformation',
        u'RNSAPRelocationParameters',
        u'RRC-Container',
        u'RTLoadValue',
        u'RSRVCC-HO-Indication',
        u'RSRVCC-Information',
        u'RSRVCC-Operation-Possible',
        u'SAC',
        u'SAI',
        u'SAPI',
        u'SessionUpdateID',
        u'Shared-Network-Information',
        u'Session-Re-establishment-Indicator',
        u'SignallingIndication',
        u'SDU-ErrorRatio',
        u'SDU-FormatInformationParameters',
        u'SDU-Parameters',
        u'SGSN-Group-Identity',
        u'SGSN-Group-ID',
        u'SNA-Access-Information',
        u'SNAC',
        u'Service-Handover',
        u'Source-ToTarget-TransparentContainer',
        u'SourceeNodeB-ToTargeteNodeB-TransparentContainer',
        u'SourceCellID',
        u'SourceBSS-ToTargetBSS-TransparentContainer',
        u'SourceID',
        u'SourceRNC-ID',
        u'SourceRNC-ToTargetRNC-TransparentContainer',
        u'SRVCCSource',
        u'IRAT-Measurement-Configuration',
        u'IRATmeasurementParameters',
        u'RSRQ-Type',
        u'RSRQ-Extension',
        u'EUTRANFrequencies',
        u'MeasBand',
        u'SubscriberProfileIDforRFP',
        u'SourceStatisticsDescriptor',
        u'SupportedRAB-ParameterBitrateList',
        u'SupportedBitrate',
        u'SourceUTRANCellID',
        u'SRB-ID',
        u'SRB-TrCH-Mapping',
        u'SRB-TrCH-MappingItem',
        u'SRVCC-HO-Indication',
        u'SRVCC-Information',
        u'SRVCC-Operation-Possible',
        u'SubflowSDU-Size',
        u'TAC',
        u'TAI',
        u'Target-ToSource-TransparentContainer',
        u'TargeteNodeB-ToSourceeNodeB-TransparentContainer',
        u'TargetBSS-ToSourceBSS-TransparentContainer',
        u'TargetCellId',
        u'TargetID',
        u'TargetENB-ID',
        u'TargetRNC-ID',
        u'TargetRNC-ToSourceRNC-TransparentContainer',
        u'UeApplicationLayerMeasurementSupportIndication',
        u'TBCD-STRING',
        u'TemporaryUE-ID',
        u'Time-UE-StayedInCell',
        u'Time-UE-StayedInCell-EnhancedGranularity',
        u'TimeToMBMSDataTransfer',
        u'TimingDifferenceULDL',
        u'TMGI',
        u'TMSI',
        u'TraceDepth',
        u'TraceInformation',
        u'TracePropagationParameters',
        u'TraceRecordingSessionInformation',
        u'TraceRecordingSessionReference',
        u'TraceReference',
        u'TraceType',
        u'TrafficClass',
        u'TrafficHandlingPriority',
        u'TransferDelay',
        u'UnsuccessfullyTransmittedDataVolume',
        u'TransportLayerAddress',
        u'TrCH-ID',
        u'TrCH-ID-List',
        u'TriggerID',
        u'TunnelInformation',
        u'TypeOfError',
        u'UE-AggregateMaximumBitRate',
        u'UE-AggregateMaximumBitRateDownlink',
        u'UE-AggregateMaximumBitRateUplink',
        u'UE-Application-Layer-Measurement-Capability',
        u'UE-History-Information',
        u'UE-ID',
        u'UE-IsNotServed',
        u'UE-IsServed',
        u'UE-Usage-Type',
        u'UERegistrationQueryResult',
        u'UESBI-Iu',
        u'UESBI-IuA',
        u'UESBI-IuB',
        u'UL-GTP-PDU-SequenceNumber',
        u'UL-N-PDU-SequenceNumber',
        u'UPInformation',
        u'UPInitialisationFrame',
        u'UP-ModeVersions',
        u'USCH-ID',
        u'UserPlaneMode',
        u'UTRAN-CellID',
        u'VelocityEstimate',
        u'HorizontalVelocity',
        u'HorizontalWithVerticalVelocity',
        u'HorizontalVelocityWithUncertainty',
        u'HorizontalWithVerticalVelocityAndUncertainty',
        u'HorizontalSpeedAndBearing',
        u'VerticalVelocity',
        u'VerticalSpeedDirection',
        u'VerticalAccuracyCode',
        u'VoiceSupportMatchIndicator',
        ]
    _set_ = [
        u'Additional-CSPS-coordination-information-ExtIEs',
        u'AllocationOrRetentionPriority-ExtIEs',
        u'Alt-RAB-Parameters-ExtIEs',
        u'Alt-RAB-Parameter-SupportedGuaranteedBitrateInf-ExtIEs',
        u'Alt-RAB-Parameter-SupportedMaxBitrateInf-ExtIEs',
        u'Ass-RAB-Parameters-ExtIEs',
        u'AuthorisedPLMNs-ExtIEs',
        u'CellBased-ExtIEs',
        u'CellLoadInformation-ExtIEs',
        u'CellLoadInformationGroup-ExtIEs',
        u'CriticalityDiagnostics-ExtIEs',
        u'CriticalityDiagnostics-IE-List-ExtIEs',
        u'MessageStructure-ExtIEs',
        u'CGI-ExtIEs',
        u'DeltaRAListofIdleModeUEs-ExtIEs',
        u'EncryptionInformation-ExtIEs',
        u'GeographicalCoordinates-ExtIEs',
        u'GA-EllipsoidArc-ExtIEs',
        u'GA-Point-ExtIEs',
        u'GA-PointWithAltitude-ExtIEs',
        u'GA-PointWithAltitudeAndUncertaintyEllipsoid-ExtIEs',
        u'GA-PointWithUnCertainty-ExtIEs',
        u'GA-PointWithUnCertaintyEllipse-ExtIEs',
        u'GA-Polygon-ExtIEs',
        u'GERAN-Cell-ID-ExtIEs',
        u'IMEIGroup-ExtIEs',
        u'IMEISVGroup-ExtIEs',
        u'ImmediateMDT-ExtIEs',
        u'IntegrityProtectionInformation-ExtIEs',
        u'InterSystemInformation-TransparentContainer-ExtIEs',
        u'LA-LIST-ExtIEs',
        u'LAI-ExtIEs',
        u'LastKnownServiceArea-ExtIEs',
        u'LastVisitedUTRANCell-Item-ExtIEs',
        u'InterfacesToTraceItem-ExtIEs',
        u'LocationReportingTransferInformation-ExtIEs',
        u'M4-Collection-Parameters-ExtIEs',
        u'M6Report-ExtIEs',
        u'M7Report-ExtIEs',
        u'MDT-Configuration-ExtIEs',
        u'Offload-RAB-Parameters-ExtIEs',
        u'PeriodicLocationInfo-ExtIEs',
        u'LABased-ExtIEs',
        u'LoggedMDT-ExtIEs',
        u'PLMNBased-ExtIEs',
        u'PLMNs-in-shared-network-ExtIEs',
        u'PositionData-ExtIEs',
        u'RABased-ExtIEs',
        u'RABDataVolumeReport-ExtIEs',
        u'RAB-Parameters-ExtIEs',
        u'RABParametersList-ExtIEs',
        u'RAB-TrCH-MappingItem-ExtIEs',
        u'RAI-ExtIEs',
        u'NotEmptyRAListofIdleModeUEs-ExtIEs',
        u'MBMSIPMulticastAddressandAPNlist-ExtIEs',
        u'Requested-RAB-Parameter-Values-ExtIEs',
        u'ResidualBitErrorRatio-ExtIEs',
        u'RIM-Transfer-ExtIEs',
        u'RNCTraceInformation-ExtIEs',
        u'RNSAPRelocationParameters-ExtIEs',
        u'RSRVCC-Information-ExtIEs',
        u'SAI-ExtIEs',
        u'Shared-Network-Information-ExtIEs',
        u'SDU-ErrorRatio-ExtIEs',
        u'SDU-FormatInformationParameters-ExtIEs',
        u'SDU-Parameters-ExtIEs',
        u'SNA-Access-Information-ExtIEs',
        u'SourceRNC-ID-ExtIEs',
        u'SourceRNC-ToTargetRNC-TransparentContainer-ExtIEs',
        u'IRAT-Measurement-Configuration-ExtIEs',
        u'IRATmeasurementParameters-ExtIEs',
        u'EUTRANFrequencies-ExtIEs',
        u'SourceUTRANCellID-ExtIEs',
        u'SRB-TrCH-MappingItem-ExtIEs',
        u'SRVCC-Information-ExtIEs',
        u'TAI-ExtIEs',
        u'TargetENB-ID-ExtIEs',
        u'TargetRNC-ID-ExtIEs',
        u'TargetRNC-ToSourceRNC-TransparentContainer-ExtIEs',
        u'TMGI-ExtIEs',
        u'TraceInformation-ExtIEs',
        u'TracePropagationParameters-ExtIEs',
        u'TraceRecordingSessionInformation-ExtIEs',
        u'TrCH-ID-ExtIEs',
        u'Tunnel-Information-ExtIEs',
        u'UE-IsNotServed-ExtIEs',
        u'UE-IsServed-ExtIEs',
        u'UESBI-Iu-ExtIEs',
        u'UPInformation-ExtIEs',
        u'UTRAN-CellID-ExtIEs',
        u'HorizontalVelocity-ExtIEs',
        u'HorizontalWithVerticalVelocity-ExtIEs',
        u'HorizontalVelocityWithUncertainty-ExtIEs',
        u'HorizontalWithVerticalVelocityAndUncertainty-ExtIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        u'Additional-CSPS-coordination-information-ExtIEs',
        u'AllocationOrRetentionPriority-ExtIEs',
        u'Alt-RAB-Parameters-ExtIEs',
        u'Alt-RAB-Parameter-SupportedGuaranteedBitrateInf-ExtIEs',
        u'Alt-RAB-Parameter-SupportedMaxBitrateInf-ExtIEs',
        u'Ass-RAB-Parameters-ExtIEs',
        u'AuthorisedPLMNs-ExtIEs',
        u'CellBased-ExtIEs',
        u'CellLoadInformation-ExtIEs',
        u'CellLoadInformationGroup-ExtIEs',
        u'CriticalityDiagnostics-ExtIEs',
        u'CriticalityDiagnostics-IE-List-ExtIEs',
        u'MessageStructure-ExtIEs',
        u'CGI-ExtIEs',
        u'DeltaRAListofIdleModeUEs-ExtIEs',
        u'EncryptionInformation-ExtIEs',
        u'GeographicalCoordinates-ExtIEs',
        u'GA-EllipsoidArc-ExtIEs',
        u'GA-Point-ExtIEs',
        u'GA-PointWithAltitude-ExtIEs',
        u'GA-PointWithAltitudeAndUncertaintyEllipsoid-ExtIEs',
        u'GA-PointWithUnCertainty-ExtIEs',
        u'GA-PointWithUnCertaintyEllipse-ExtIEs',
        u'GA-Polygon-ExtIEs',
        u'GERAN-Cell-ID-ExtIEs',
        u'IMEIGroup-ExtIEs',
        u'IMEISVGroup-ExtIEs',
        u'ImmediateMDT-ExtIEs',
        u'IntegrityProtectionInformation-ExtIEs',
        u'InterSystemInformation-TransparentContainer-ExtIEs',
        u'LA-LIST-ExtIEs',
        u'LAI-ExtIEs',
        u'LastKnownServiceArea-ExtIEs',
        u'LastVisitedUTRANCell-Item-ExtIEs',
        u'InterfacesToTraceItem-ExtIEs',
        u'LocationReportingTransferInformation-ExtIEs',
        u'M4-Collection-Parameters-ExtIEs',
        u'M6Report-ExtIEs',
        u'M7Report-ExtIEs',
        u'MDT-Configuration-ExtIEs',
        u'Offload-RAB-Parameters-ExtIEs',
        u'PeriodicLocationInfo-ExtIEs',
        u'LABased-ExtIEs',
        u'LoggedMDT-ExtIEs',
        u'PLMNBased-ExtIEs',
        u'PLMNs-in-shared-network-ExtIEs',
        u'PositionData-ExtIEs',
        u'RABased-ExtIEs',
        u'RABDataVolumeReport-ExtIEs',
        u'RAB-Parameters-ExtIEs',
        u'RABParametersList-ExtIEs',
        u'RAB-TrCH-MappingItem-ExtIEs',
        u'RAI-ExtIEs',
        u'NotEmptyRAListofIdleModeUEs-ExtIEs',
        u'MBMSIPMulticastAddressandAPNlist-ExtIEs',
        u'Requested-RAB-Parameter-Values-ExtIEs',
        u'ResidualBitErrorRatio-ExtIEs',
        u'RIM-Transfer-ExtIEs',
        u'RNCTraceInformation-ExtIEs',
        u'RNSAPRelocationParameters-ExtIEs',
        u'RSRVCC-Information-ExtIEs',
        u'SAI-ExtIEs',
        u'Shared-Network-Information-ExtIEs',
        u'SDU-ErrorRatio-ExtIEs',
        u'SDU-FormatInformationParameters-ExtIEs',
        u'SDU-Parameters-ExtIEs',
        u'SNA-Access-Information-ExtIEs',
        u'SourceRNC-ID-ExtIEs',
        u'SourceRNC-ToTargetRNC-TransparentContainer-ExtIEs',
        u'IRAT-Measurement-Configuration-ExtIEs',
        u'IRATmeasurementParameters-ExtIEs',
        u'EUTRANFrequencies-ExtIEs',
        u'SourceUTRANCellID-ExtIEs',
        u'SRB-TrCH-MappingItem-ExtIEs',
        u'SRVCC-Information-ExtIEs',
        u'TAI-ExtIEs',
        u'TargetENB-ID-ExtIEs',
        u'TargetRNC-ID-ExtIEs',
        u'TargetRNC-ToSourceRNC-TransparentContainer-ExtIEs',
        u'TMGI-ExtIEs',
        u'TraceInformation-ExtIEs',
        u'TracePropagationParameters-ExtIEs',
        u'TraceRecordingSessionInformation-ExtIEs',
        u'TrCH-ID-ExtIEs',
        u'Tunnel-Information-ExtIEs',
        u'UE-IsNotServed-ExtIEs',
        u'UE-IsServed-ExtIEs',
        u'UESBI-Iu-ExtIEs',
        u'UPInformation-ExtIEs',
        u'UTRAN-CellID-ExtIEs',
        u'HorizontalVelocity-ExtIEs',
        u'HorizontalWithVerticalVelocity-ExtIEs',
        u'HorizontalVelocityWithUncertainty-ExtIEs',
        u'HorizontalWithVerticalVelocityAndUncertainty-ExtIEs',
        ]
    _param_ = [
        ]
    
    #-----< AccuracyFulfilmentIndicator >-----#
    AccuracyFulfilmentIndicator = ENUM(name=u'AccuracyFulfilmentIndicator', mode=MODE_TYPE)
    AccuracyFulfilmentIndicator._cont = ASN1Dict([(u'requested-Accuracy-Fulfilled', 0), (u'requested-Accuracy-Not-Fulfilled', 1)])
    AccuracyFulfilmentIndicator._ext = []
    
    #-----< Additional-CSPS-coordination-information >-----#
    Additional_CSPS_coordination_information = SEQ(name=u'Additional-CSPS-coordination-information', mode=MODE_TYPE)
    _Additional_CSPS_coordination_information_old_LAI = SEQ(name=u'old-LAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LAI')), opt=True)
    _Additional_CSPS_coordination_information_old_RAC = OCT_STR(name=u'old-RAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAC')), opt=True)
    _Additional_CSPS_coordination_information_nRI = BIT_STR(name=u'nRI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Additional_CSPS_coordination_information_nRI._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _Additional_CSPS_coordination_information_uE_is_Attaching = NULL(name=u'uE-is-Attaching', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Additional_CSPS_coordination_information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_CSPS_coordination_information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Additional_CSPS_coordination_information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_CSPS_coordination_information_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Additional_CSPS_coordination_information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_CSPS_coordination_information_iE_Extensions__item__id._const_tab = ____Additional_CSPS_coordination_information_iE_Extensions__item__id_tab
    ___Additional_CSPS_coordination_information_iE_Extensions__item__id._const_tab_at = None
    ___Additional_CSPS_coordination_information_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_CSPS_coordination_information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_CSPS_coordination_information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Additional_CSPS_coordination_information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_CSPS_coordination_information_iE_Extensions__item__criticality._const_tab = ____Additional_CSPS_coordination_information_iE_Extensions__item__criticality_tab
    ___Additional_CSPS_coordination_information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_CSPS_coordination_information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_CSPS_coordination_information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_CSPS_coordination_information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Additional_CSPS_coordination_information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_CSPS_coordination_information_iE_Extensions__item__extensionValue._const_tab = ____Additional_CSPS_coordination_information_iE_Extensions__item__extensionValue_tab
    ___Additional_CSPS_coordination_information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_CSPS_coordination_information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_CSPS_coordination_information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_CSPS_coordination_information_iE_Extensions__item__id),
        (u'criticality', ___Additional_CSPS_coordination_information_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_CSPS_coordination_information_iE_Extensions__item__extensionValue),
        ])
    __Additional_CSPS_coordination_information_iE_Extensions__item_._ext = None
    _Additional_CSPS_coordination_information_iE_Extensions._cont = __Additional_CSPS_coordination_information_iE_Extensions__item_
    _Additional_CSPS_coordination_information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_CSPS_coordination_information._cont = ASN1Dict([
        (u'old-LAI', _Additional_CSPS_coordination_information_old_LAI),
        (u'old-RAC', _Additional_CSPS_coordination_information_old_RAC),
        (u'nRI', _Additional_CSPS_coordination_information_nRI),
        (u'uE-is-Attaching', _Additional_CSPS_coordination_information_uE_is_Attaching),
        (u'iE-Extensions', _Additional_CSPS_coordination_information_iE_Extensions),
        ])
    Additional_CSPS_coordination_information._ext = []
    
    #-----< Additional-CSPS-coordination-information-ExtIEs >-----#
    Additional_CSPS_coordination_information_ExtIEs = CLASS(name=u'Additional-CSPS-coordination-information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    Additional_CSPS_coordination_information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-PositioningDataSet >-----#
    Additional_PositioningDataSet = SEQ_OF(name=u'Additional-PositioningDataSet', mode=MODE_TYPE)
    _Additional_PositioningDataSet__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Additional-PositioningMethodAndUsage')))
    Additional_PositioningDataSet._cont = _Additional_PositioningDataSet__item_
    Additional_PositioningDataSet._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Additional-PositioningMethodAndUsage >-----#
    Additional_PositioningMethodAndUsage = OCT_STR(name=u'Additional-PositioningMethodAndUsage', mode=MODE_TYPE)
    Additional_PositioningMethodAndUsage._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< AllocationOrRetentionPriority >-----#
    AllocationOrRetentionPriority = SEQ(name=u'AllocationOrRetentionPriority', mode=MODE_TYPE)
    _AllocationOrRetentionPriority_priorityLevel = INT(name=u'priorityLevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PriorityLevel')))
    _AllocationOrRetentionPriority_pre_emptionCapability = ENUM(name=u'pre-emptionCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Pre-emptionCapability')))
    _AllocationOrRetentionPriority_pre_emptionVulnerability = ENUM(name=u'pre-emptionVulnerability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Pre-emptionVulnerability')))
    _AllocationOrRetentionPriority_queuingAllowed = ENUM(name=u'queuingAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'QueuingAllowed')))
    _AllocationOrRetentionPriority_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AllocationOrRetentionPriority_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___AllocationOrRetentionPriority_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____AllocationOrRetentionPriority_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____AllocationOrRetentionPriority_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationOrRetentionPriority_iE_Extensions__item__id._const_tab = ____AllocationOrRetentionPriority_iE_Extensions__item__id_tab
    ___AllocationOrRetentionPriority_iE_Extensions__item__id._const_tab_at = None
    ___AllocationOrRetentionPriority_iE_Extensions__item__id._const_tab_id = u'id'
    ___AllocationOrRetentionPriority_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AllocationOrRetentionPriority_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____AllocationOrRetentionPriority_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationOrRetentionPriority_iE_Extensions__item__criticality._const_tab = ____AllocationOrRetentionPriority_iE_Extensions__item__criticality_tab
    ___AllocationOrRetentionPriority_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AllocationOrRetentionPriority_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AllocationOrRetentionPriority_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AllocationOrRetentionPriority_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____AllocationOrRetentionPriority_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationOrRetentionPriority_iE_Extensions__item__extensionValue._const_tab = ____AllocationOrRetentionPriority_iE_Extensions__item__extensionValue_tab
    ___AllocationOrRetentionPriority_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AllocationOrRetentionPriority_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AllocationOrRetentionPriority_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AllocationOrRetentionPriority_iE_Extensions__item__id),
        (u'criticality', ___AllocationOrRetentionPriority_iE_Extensions__item__criticality),
        (u'extensionValue', ___AllocationOrRetentionPriority_iE_Extensions__item__extensionValue),
        ])
    __AllocationOrRetentionPriority_iE_Extensions__item_._ext = None
    _AllocationOrRetentionPriority_iE_Extensions._cont = __AllocationOrRetentionPriority_iE_Extensions__item_
    _AllocationOrRetentionPriority_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AllocationOrRetentionPriority._cont = ASN1Dict([
        (u'priorityLevel', _AllocationOrRetentionPriority_priorityLevel),
        (u'pre-emptionCapability', _AllocationOrRetentionPriority_pre_emptionCapability),
        (u'pre-emptionVulnerability', _AllocationOrRetentionPriority_pre_emptionVulnerability),
        (u'queuingAllowed', _AllocationOrRetentionPriority_queuingAllowed),
        (u'iE-Extensions', _AllocationOrRetentionPriority_iE_Extensions),
        ])
    AllocationOrRetentionPriority._ext = []
    
    #-----< AllocationOrRetentionPriority-ExtIEs >-----#
    AllocationOrRetentionPriority_ExtIEs = CLASS(name=u'AllocationOrRetentionPriority-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    AllocationOrRetentionPriority_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Alt-RAB-Parameters >-----#
    Alt_RAB_Parameters = SEQ(name=u'Alt-RAB-Parameters', mode=MODE_TYPE)
    _Alt_RAB_Parameters_altMaxBitrateInf = SEQ(name=u'altMaxBitrateInf', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-MaxBitrateInf')), opt=True)
    _Alt_RAB_Parameters_altGuaranteedBitRateInf = SEQ(name=u'altGuaranteedBitRateInf', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-GuaranteedBitrateInf')), opt=True)
    _Alt_RAB_Parameters_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Alt_RAB_Parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Alt_RAB_Parameters_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Alt_RAB_Parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameters')))
    _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-ExtendedGuaranteedBitrateInf')))
    _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-ExtendedMaxBitrateInf')))
    _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-SupportedMaxBitrateInf')))
    _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-SupportedGuaranteedBitrateInf')))
    ____Alt_RAB_Parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 158), (u'criticality', u'ignore'), (u'Extension', _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 172), (u'criticality', u'ignore'), (u'Extension', _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 173), (u'criticality', u'ignore'), (u'Extension', _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 215), (u'criticality', u'reject'), (u'Extension', _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 214), (u'criticality', u'reject'), (u'Extension', _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Alt_RAB_Parameters_iE_Extensions__item__id._const_tab = ____Alt_RAB_Parameters_iE_Extensions__item__id_tab
    ___Alt_RAB_Parameters_iE_Extensions__item__id._const_tab_at = None
    ___Alt_RAB_Parameters_iE_Extensions__item__id._const_tab_id = u'id'
    ___Alt_RAB_Parameters_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Alt_RAB_Parameters_iE_Extensions__item__criticality._const_tab = ____Alt_RAB_Parameters_iE_Extensions__item__id_tab
    ___Alt_RAB_Parameters_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Alt_RAB_Parameters_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Alt_RAB_Parameters_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Alt_RAB_Parameters_iE_Extensions__item__extensionValue._const_tab = ____Alt_RAB_Parameters_iE_Extensions__item__id_tab
    ___Alt_RAB_Parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Alt_RAB_Parameters_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Alt_RAB_Parameters_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Alt_RAB_Parameters_iE_Extensions__item__id),
        (u'criticality', ___Alt_RAB_Parameters_iE_Extensions__item__criticality),
        (u'extensionValue', ___Alt_RAB_Parameters_iE_Extensions__item__extensionValue),
        ])
    __Alt_RAB_Parameters_iE_Extensions__item_._ext = None
    _Alt_RAB_Parameters_iE_Extensions._cont = __Alt_RAB_Parameters_iE_Extensions__item_
    _Alt_RAB_Parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Alt_RAB_Parameters._cont = ASN1Dict([
        (u'altMaxBitrateInf', _Alt_RAB_Parameters_altMaxBitrateInf),
        (u'altGuaranteedBitRateInf', _Alt_RAB_Parameters_altGuaranteedBitRateInf),
        (u'iE-Extensions', _Alt_RAB_Parameters_iE_Extensions),
        ])
    Alt_RAB_Parameters._ext = []
    
    #-----< Alt-RAB-Parameters-ExtIEs >-----#
    Alt_RAB_Parameters_ExtIEs = CLASS(name=u'Alt-RAB-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _Alt_RAB_Parameters_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameters')))
    _Alt_RAB_Parameters_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-ExtendedGuaranteedBitrateInf')))
    _Alt_RAB_Parameters_ExtIEs_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-ExtendedMaxBitrateInf')))
    _Alt_RAB_Parameters_ExtIEs_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-SupportedMaxBitrateInf')))
    _Alt_RAB_Parameters_ExtIEs_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-SupportedGuaranteedBitrateInf')))
    Alt_RAB_Parameters_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 158), (u'criticality', u'ignore'), (u'Extension', _Alt_RAB_Parameters_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 172), (u'criticality', u'ignore'), (u'Extension', _Alt_RAB_Parameters_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 173), (u'criticality', u'ignore'), (u'Extension', _Alt_RAB_Parameters_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 215), (u'criticality', u'reject'), (u'Extension', _Alt_RAB_Parameters_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 214), (u'criticality', u'reject'), (u'Extension', _Alt_RAB_Parameters_ExtIEs_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Alt-RAB-Parameter-ExtendedGuaranteedBitrateInf >-----#
    Alt_RAB_Parameter_ExtendedGuaranteedBitrateInf = SEQ(name=u'Alt-RAB-Parameter-ExtendedGuaranteedBitrateInf', mode=MODE_TYPE)
    _Alt_RAB_Parameter_ExtendedGuaranteedBitrateInf_altExtendedGuaranteedBitrateType = ENUM(name=u'altExtendedGuaranteedBitrateType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-GuaranteedBitrateType')))
    _Alt_RAB_Parameter_ExtendedGuaranteedBitrateInf_altExtendedGuaranteedBitrates = SEQ_OF(name=u'altExtendedGuaranteedBitrates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-ExtendedGuaranteedBitrates')), opt=True)
    Alt_RAB_Parameter_ExtendedGuaranteedBitrateInf._cont = ASN1Dict([
        (u'altExtendedGuaranteedBitrateType', _Alt_RAB_Parameter_ExtendedGuaranteedBitrateInf_altExtendedGuaranteedBitrateType),
        (u'altExtendedGuaranteedBitrates', _Alt_RAB_Parameter_ExtendedGuaranteedBitrateInf_altExtendedGuaranteedBitrates),
        ])
    Alt_RAB_Parameter_ExtendedGuaranteedBitrateInf._ext = []
    
    #-----< Alt-RAB-Parameter-ExtendedGuaranteedBitrates >-----#
    Alt_RAB_Parameter_ExtendedGuaranteedBitrates = SEQ_OF(name=u'Alt-RAB-Parameter-ExtendedGuaranteedBitrates', mode=MODE_TYPE)
    _Alt_RAB_Parameter_ExtendedGuaranteedBitrates__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-ExtendedGuaranteedBitrateList')))
    Alt_RAB_Parameter_ExtendedGuaranteedBitrates._cont = _Alt_RAB_Parameter_ExtendedGuaranteedBitrates__item_
    Alt_RAB_Parameter_ExtendedGuaranteedBitrates._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Alt-RAB-Parameter-ExtendedGuaranteedBitrateList >-----#
    Alt_RAB_Parameter_ExtendedGuaranteedBitrateList = SEQ_OF(name=u'Alt-RAB-Parameter-ExtendedGuaranteedBitrateList', mode=MODE_TYPE)
    _Alt_RAB_Parameter_ExtendedGuaranteedBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedGuaranteedBitrate')))
    Alt_RAB_Parameter_ExtendedGuaranteedBitrateList._cont = _Alt_RAB_Parameter_ExtendedGuaranteedBitrateList__item_
    Alt_RAB_Parameter_ExtendedGuaranteedBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Alt-RAB-Parameter-GuaranteedBitrateInf >-----#
    Alt_RAB_Parameter_GuaranteedBitrateInf = SEQ(name=u'Alt-RAB-Parameter-GuaranteedBitrateInf', mode=MODE_TYPE)
    _Alt_RAB_Parameter_GuaranteedBitrateInf_altGuaranteedBitrateType = ENUM(name=u'altGuaranteedBitrateType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-GuaranteedBitrateType')))
    _Alt_RAB_Parameter_GuaranteedBitrateInf_altGuaranteedBitrates = SEQ_OF(name=u'altGuaranteedBitrates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-GuaranteedBitrates')), opt=True)
    Alt_RAB_Parameter_GuaranteedBitrateInf._cont = ASN1Dict([
        (u'altGuaranteedBitrateType', _Alt_RAB_Parameter_GuaranteedBitrateInf_altGuaranteedBitrateType),
        (u'altGuaranteedBitrates', _Alt_RAB_Parameter_GuaranteedBitrateInf_altGuaranteedBitrates),
        ])
    Alt_RAB_Parameter_GuaranteedBitrateInf._ext = []
    
    #-----< Alt-RAB-Parameter-GuaranteedBitrateType >-----#
    Alt_RAB_Parameter_GuaranteedBitrateType = ENUM(name=u'Alt-RAB-Parameter-GuaranteedBitrateType', mode=MODE_TYPE)
    Alt_RAB_Parameter_GuaranteedBitrateType._cont = ASN1Dict([(u'unspecified', 0), (u'value-range', 1), (u'discrete-values', 2)])
    Alt_RAB_Parameter_GuaranteedBitrateType._ext = []
    
    #-----< Alt-RAB-Parameter-GuaranteedBitrates >-----#
    Alt_RAB_Parameter_GuaranteedBitrates = SEQ_OF(name=u'Alt-RAB-Parameter-GuaranteedBitrates', mode=MODE_TYPE)
    _Alt_RAB_Parameter_GuaranteedBitrates__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-GuaranteedBitrateList')))
    Alt_RAB_Parameter_GuaranteedBitrates._cont = _Alt_RAB_Parameter_GuaranteedBitrates__item_
    Alt_RAB_Parameter_GuaranteedBitrates._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Alt-RAB-Parameter-GuaranteedBitrateList >-----#
    Alt_RAB_Parameter_GuaranteedBitrateList = SEQ_OF(name=u'Alt-RAB-Parameter-GuaranteedBitrateList', mode=MODE_TYPE)
    _Alt_RAB_Parameter_GuaranteedBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GuaranteedBitrate')))
    Alt_RAB_Parameter_GuaranteedBitrateList._cont = _Alt_RAB_Parameter_GuaranteedBitrateList__item_
    Alt_RAB_Parameter_GuaranteedBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Alt-RAB-Parameter-SupportedGuaranteedBitrateInf >-----#
    Alt_RAB_Parameter_SupportedGuaranteedBitrateInf = SEQ(name=u'Alt-RAB-Parameter-SupportedGuaranteedBitrateInf', mode=MODE_TYPE)
    _Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_altSupportedGuaranteedBitrateType = ENUM(name=u'altSupportedGuaranteedBitrateType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-GuaranteedBitrateType')))
    _Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_altSupportedGuaranteedBitrates = SEQ_OF(name=u'altSupportedGuaranteedBitrates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-SupportedGuaranteedBitrates')), opt=True)
    _Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__id._const_tab = ____Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__id_tab
    ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__id._const_tab_at = None
    ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__id._const_tab_id = u'id'
    ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__criticality._const_tab = ____Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__criticality_tab
    ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__extensionValue._const_tab = ____Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__extensionValue_tab
    ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__id),
        (u'criticality', ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__criticality),
        (u'extensionValue', ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__extensionValue),
        ])
    __Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item_._ext = None
    _Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions._cont = __Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item_
    _Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Alt_RAB_Parameter_SupportedGuaranteedBitrateInf._cont = ASN1Dict([
        (u'altSupportedGuaranteedBitrateType', _Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_altSupportedGuaranteedBitrateType),
        (u'altSupportedGuaranteedBitrates', _Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_altSupportedGuaranteedBitrates),
        (u'iE-Extensions', _Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions),
        ])
    Alt_RAB_Parameter_SupportedGuaranteedBitrateInf._ext = []
    
    #-----< Alt-RAB-Parameter-SupportedGuaranteedBitrateInf-ExtIEs >-----#
    Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_ExtIEs = CLASS(name=u'Alt-RAB-Parameter-SupportedGuaranteedBitrateInf-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Alt-RAB-Parameter-SupportedGuaranteedBitrates >-----#
    Alt_RAB_Parameter_SupportedGuaranteedBitrates = SEQ_OF(name=u'Alt-RAB-Parameter-SupportedGuaranteedBitrates', mode=MODE_TYPE)
    _Alt_RAB_Parameter_SupportedGuaranteedBitrates__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    Alt_RAB_Parameter_SupportedGuaranteedBitrates._cont = _Alt_RAB_Parameter_SupportedGuaranteedBitrates__item_
    Alt_RAB_Parameter_SupportedGuaranteedBitrates._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Alt-RAB-Parameter-ExtendedMaxBitrateInf >-----#
    Alt_RAB_Parameter_ExtendedMaxBitrateInf = SEQ(name=u'Alt-RAB-Parameter-ExtendedMaxBitrateInf', mode=MODE_TYPE)
    _Alt_RAB_Parameter_ExtendedMaxBitrateInf_altExtendedMaxBitrateType = ENUM(name=u'altExtendedMaxBitrateType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-MaxBitrateType')))
    _Alt_RAB_Parameter_ExtendedMaxBitrateInf_altExtendedMaxBitrates = SEQ_OF(name=u'altExtendedMaxBitrates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-ExtendedMaxBitrates')), opt=True)
    Alt_RAB_Parameter_ExtendedMaxBitrateInf._cont = ASN1Dict([
        (u'altExtendedMaxBitrateType', _Alt_RAB_Parameter_ExtendedMaxBitrateInf_altExtendedMaxBitrateType),
        (u'altExtendedMaxBitrates', _Alt_RAB_Parameter_ExtendedMaxBitrateInf_altExtendedMaxBitrates),
        ])
    Alt_RAB_Parameter_ExtendedMaxBitrateInf._ext = []
    
    #-----< Alt-RAB-Parameter-ExtendedMaxBitrates >-----#
    Alt_RAB_Parameter_ExtendedMaxBitrates = SEQ_OF(name=u'Alt-RAB-Parameter-ExtendedMaxBitrates', mode=MODE_TYPE)
    _Alt_RAB_Parameter_ExtendedMaxBitrates__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-ExtendedMaxBitrateList')))
    Alt_RAB_Parameter_ExtendedMaxBitrates._cont = _Alt_RAB_Parameter_ExtendedMaxBitrates__item_
    Alt_RAB_Parameter_ExtendedMaxBitrates._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Alt-RAB-Parameter-ExtendedMaxBitrateList >-----#
    Alt_RAB_Parameter_ExtendedMaxBitrateList = SEQ_OF(name=u'Alt-RAB-Parameter-ExtendedMaxBitrateList', mode=MODE_TYPE)
    _Alt_RAB_Parameter_ExtendedMaxBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedMaxBitrate')))
    Alt_RAB_Parameter_ExtendedMaxBitrateList._cont = _Alt_RAB_Parameter_ExtendedMaxBitrateList__item_
    Alt_RAB_Parameter_ExtendedMaxBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Alt-RAB-Parameter-MaxBitrateInf >-----#
    Alt_RAB_Parameter_MaxBitrateInf = SEQ(name=u'Alt-RAB-Parameter-MaxBitrateInf', mode=MODE_TYPE)
    _Alt_RAB_Parameter_MaxBitrateInf_altMaxBitrateType = ENUM(name=u'altMaxBitrateType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-MaxBitrateType')))
    _Alt_RAB_Parameter_MaxBitrateInf_altMaxBitrates = SEQ_OF(name=u'altMaxBitrates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-MaxBitrates')), opt=True)
    Alt_RAB_Parameter_MaxBitrateInf._cont = ASN1Dict([
        (u'altMaxBitrateType', _Alt_RAB_Parameter_MaxBitrateInf_altMaxBitrateType),
        (u'altMaxBitrates', _Alt_RAB_Parameter_MaxBitrateInf_altMaxBitrates),
        ])
    Alt_RAB_Parameter_MaxBitrateInf._ext = []
    
    #-----< Alt-RAB-Parameter-MaxBitrateType >-----#
    Alt_RAB_Parameter_MaxBitrateType = ENUM(name=u'Alt-RAB-Parameter-MaxBitrateType', mode=MODE_TYPE)
    Alt_RAB_Parameter_MaxBitrateType._cont = ASN1Dict([(u'unspecified', 0), (u'value-range', 1), (u'discrete-values', 2)])
    Alt_RAB_Parameter_MaxBitrateType._ext = []
    
    #-----< Alt-RAB-Parameter-MaxBitrates >-----#
    Alt_RAB_Parameter_MaxBitrates = SEQ_OF(name=u'Alt-RAB-Parameter-MaxBitrates', mode=MODE_TYPE)
    _Alt_RAB_Parameter_MaxBitrates__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-MaxBitrateList')))
    Alt_RAB_Parameter_MaxBitrates._cont = _Alt_RAB_Parameter_MaxBitrates__item_
    Alt_RAB_Parameter_MaxBitrates._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Alt-RAB-Parameter-MaxBitrateList >-----#
    Alt_RAB_Parameter_MaxBitrateList = SEQ_OF(name=u'Alt-RAB-Parameter-MaxBitrateList', mode=MODE_TYPE)
    _Alt_RAB_Parameter_MaxBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MaxBitrate')))
    Alt_RAB_Parameter_MaxBitrateList._cont = _Alt_RAB_Parameter_MaxBitrateList__item_
    Alt_RAB_Parameter_MaxBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Alt-RAB-Parameter-SupportedMaxBitrateInf >-----#
    Alt_RAB_Parameter_SupportedMaxBitrateInf = SEQ(name=u'Alt-RAB-Parameter-SupportedMaxBitrateInf', mode=MODE_TYPE)
    _Alt_RAB_Parameter_SupportedMaxBitrateInf_altSupportedMaxBitrateType = ENUM(name=u'altSupportedMaxBitrateType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-MaxBitrateType')))
    _Alt_RAB_Parameter_SupportedMaxBitrateInf_altSupportedMaxBitrates = SEQ_OF(name=u'altSupportedMaxBitrates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-SupportedMaxBitrates')), opt=True)
    _Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__id._const_tab = ____Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__id_tab
    ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__id._const_tab_at = None
    ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__id._const_tab_id = u'id'
    ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__criticality._const_tab = ____Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__criticality_tab
    ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__extensionValue._const_tab = ____Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__extensionValue_tab
    ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__id),
        (u'criticality', ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__criticality),
        (u'extensionValue', ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__extensionValue),
        ])
    __Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item_._ext = None
    _Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions._cont = __Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item_
    _Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Alt_RAB_Parameter_SupportedMaxBitrateInf._cont = ASN1Dict([
        (u'altSupportedMaxBitrateType', _Alt_RAB_Parameter_SupportedMaxBitrateInf_altSupportedMaxBitrateType),
        (u'altSupportedMaxBitrates', _Alt_RAB_Parameter_SupportedMaxBitrateInf_altSupportedMaxBitrates),
        (u'iE-Extensions', _Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions),
        ])
    Alt_RAB_Parameter_SupportedMaxBitrateInf._ext = []
    
    #-----< Alt-RAB-Parameter-SupportedMaxBitrateInf-ExtIEs >-----#
    Alt_RAB_Parameter_SupportedMaxBitrateInf_ExtIEs = CLASS(name=u'Alt-RAB-Parameter-SupportedMaxBitrateInf-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    Alt_RAB_Parameter_SupportedMaxBitrateInf_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Alt-RAB-Parameter-SupportedMaxBitrates >-----#
    Alt_RAB_Parameter_SupportedMaxBitrates = SEQ_OF(name=u'Alt-RAB-Parameter-SupportedMaxBitrates', mode=MODE_TYPE)
    _Alt_RAB_Parameter_SupportedMaxBitrates__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    Alt_RAB_Parameter_SupportedMaxBitrates._cont = _Alt_RAB_Parameter_SupportedMaxBitrates__item_
    Alt_RAB_Parameter_SupportedMaxBitrates._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< AlternativeRABConfigurationRequest >-----#
    AlternativeRABConfigurationRequest = ENUM(name=u'AlternativeRABConfigurationRequest', mode=MODE_TYPE)
    AlternativeRABConfigurationRequest._cont = ASN1Dict([(u'alternative-RAB-configuration-Requested', 0)])
    AlternativeRABConfigurationRequest._ext = []
    
    #-----< UE-Application-Layer-Measurement-Configuration >-----#
    UE_Application_Layer_Measurement_Configuration = SEQ(name=u'UE-Application-Layer-Measurement-Configuration', mode=MODE_TYPE)
    _UE_Application_Layer_Measurement_Configuration_applicationLayerContainerForMeasurementConfiguration = OCT_STR(name=u'applicationLayerContainerForMeasurementConfiguration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UE_Application_Layer_Measurement_Configuration_applicationLayerContainerForMeasurementConfiguration._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1000)], ev=None, er=[])
    _UE_Application_Layer_Measurement_Configuration_areaScopeForUEApplicationLayerMeasurementConfiguration = CHOICE(name=u'areaScopeForUEApplicationLayerMeasurementConfiguration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'AreaScopeForUEApplicationLayerMeasurementConfiguration')))
    _UE_Application_Layer_Measurement_Configuration_serviceType = ENUM(name=u'serviceType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ServiceType')))
    UE_Application_Layer_Measurement_Configuration._cont = ASN1Dict([
        (u'applicationLayerContainerForMeasurementConfiguration', _UE_Application_Layer_Measurement_Configuration_applicationLayerContainerForMeasurementConfiguration),
        (u'areaScopeForUEApplicationLayerMeasurementConfiguration', _UE_Application_Layer_Measurement_Configuration_areaScopeForUEApplicationLayerMeasurementConfiguration),
        (u'serviceType', _UE_Application_Layer_Measurement_Configuration_serviceType),
        ])
    UE_Application_Layer_Measurement_Configuration._ext = [u'serviceType']
    
    #-----< UE-Application-Layer-Measurement-Configuration-For-Relocation >-----#
    UE_Application_Layer_Measurement_Configuration_For_Relocation = SEQ(name=u'UE-Application-Layer-Measurement-Configuration-For-Relocation', mode=MODE_TYPE)
    _UE_Application_Layer_Measurement_Configuration_For_Relocation_areaScopeForUEApplicationLayerMeasurementConfiguration = CHOICE(name=u'areaScopeForUEApplicationLayerMeasurementConfiguration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'AreaScopeForUEApplicationLayerMeasurementConfiguration')))
    _UE_Application_Layer_Measurement_Configuration_For_Relocation_traceReference = OCT_STR(name=u'traceReference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TraceReference')))
    _UE_Application_Layer_Measurement_Configuration_For_Relocation_tracePropagationParameters = SEQ(name=u'tracePropagationParameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TracePropagationParameters')), opt=True)
    _UE_Application_Layer_Measurement_Configuration_For_Relocation_traceCollectionEntityIPAddress = BIT_STR(name=u'traceCollectionEntityIPAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')), opt=True)
    _UE_Application_Layer_Measurement_Configuration_For_Relocation_serviceType = ENUM(name=u'serviceType', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ServiceType')))
    UE_Application_Layer_Measurement_Configuration_For_Relocation._cont = ASN1Dict([
        (u'areaScopeForUEApplicationLayerMeasurementConfiguration', _UE_Application_Layer_Measurement_Configuration_For_Relocation_areaScopeForUEApplicationLayerMeasurementConfiguration),
        (u'traceReference', _UE_Application_Layer_Measurement_Configuration_For_Relocation_traceReference),
        (u'tracePropagationParameters', _UE_Application_Layer_Measurement_Configuration_For_Relocation_tracePropagationParameters),
        (u'traceCollectionEntityIPAddress', _UE_Application_Layer_Measurement_Configuration_For_Relocation_traceCollectionEntityIPAddress),
        (u'serviceType', _UE_Application_Layer_Measurement_Configuration_For_Relocation_serviceType),
        ])
    UE_Application_Layer_Measurement_Configuration_For_Relocation._ext = [u'serviceType']
    
    #-----< ServiceType >-----#
    ServiceType = ENUM(name=u'ServiceType', mode=MODE_TYPE)
    ServiceType._cont = ASN1Dict([(u'qMC-for-streaming-service', 0), (u'qMC-for-MSTI-service', 1)])
    ServiceType._ext = []
    
    #-----< APN >-----#
    APN = OCT_STR(name=u'APN', mode=MODE_TYPE)
    APN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    
    #-----< AreaScopeForUEApplicationLayerMeasurementConfiguration >-----#
    AreaScopeForUEApplicationLayerMeasurementConfiguration = CHOICE(name=u'AreaScopeForUEApplicationLayerMeasurementConfiguration', mode=MODE_TYPE)
    _AreaScopeForUEApplicationLayerMeasurementConfiguration_cellbased = SEQ(name=u'cellbased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CellBased')))
    _AreaScopeForUEApplicationLayerMeasurementConfiguration_labased = SEQ(name=u'labased', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LABased')))
    _AreaScopeForUEApplicationLayerMeasurementConfiguration_rabased = SEQ(name=u'rabased', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RABased')))
    _AreaScopeForUEApplicationLayerMeasurementConfiguration_plmn_area_based = SEQ(name=u'plmn-area-based', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNBased')))
    AreaScopeForUEApplicationLayerMeasurementConfiguration._cont = ASN1Dict([
        (u'cellbased', _AreaScopeForUEApplicationLayerMeasurementConfiguration_cellbased),
        (u'labased', _AreaScopeForUEApplicationLayerMeasurementConfiguration_labased),
        (u'rabased', _AreaScopeForUEApplicationLayerMeasurementConfiguration_rabased),
        (u'plmn-area-based', _AreaScopeForUEApplicationLayerMeasurementConfiguration_plmn_area_based),
        ])
    AreaScopeForUEApplicationLayerMeasurementConfiguration._ext = []
    
    #-----< AreaIdentity >-----#
    AreaIdentity = CHOICE(name=u'AreaIdentity', mode=MODE_TYPE)
    _AreaIdentity_sAI = SEQ(name=u'sAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SAI')))
    _AreaIdentity_geographicalArea = CHOICE(name=u'geographicalArea', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GeographicalArea')))
    AreaIdentity._cont = ASN1Dict([
        (u'sAI', _AreaIdentity_sAI),
        (u'geographicalArea', _AreaIdentity_geographicalArea),
        ])
    AreaIdentity._ext = []
    
    #-----< Ass-RAB-Parameters >-----#
    Ass_RAB_Parameters = SEQ(name=u'Ass-RAB-Parameters', mode=MODE_TYPE)
    _Ass_RAB_Parameters_assMaxBitrateInf = SEQ_OF(name=u'assMaxBitrateInf', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Ass-RAB-Parameter-MaxBitrateList')), opt=True)
    _Ass_RAB_Parameters_assGuaranteedBitRateInf = SEQ_OF(name=u'assGuaranteedBitRateInf', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Ass-RAB-Parameter-GuaranteedBitrateList')), opt=True)
    _Ass_RAB_Parameters_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Ass_RAB_Parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Ass_RAB_Parameters_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Ass_RAB_Parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____Ass_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Ass-RAB-Parameter-ExtendedGuaranteedBitrateList')))
    _____Ass_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Ass-RAB-Parameter-ExtendedMaxBitrateList')))
    _____Ass_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    _____Ass_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    ____Ass_RAB_Parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 174), (u'criticality', u'reject'), (u'Extension', _____Ass_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 175), (u'criticality', u'reject'), (u'Extension', _____Ass_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 217), (u'criticality', u'ignore'), (u'Extension', _____Ass_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 216), (u'criticality', u'ignore'), (u'Extension', _____Ass_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Ass_RAB_Parameters_iE_Extensions__item__id._const_tab = ____Ass_RAB_Parameters_iE_Extensions__item__id_tab
    ___Ass_RAB_Parameters_iE_Extensions__item__id._const_tab_at = None
    ___Ass_RAB_Parameters_iE_Extensions__item__id._const_tab_id = u'id'
    ___Ass_RAB_Parameters_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Ass_RAB_Parameters_iE_Extensions__item__criticality._const_tab = ____Ass_RAB_Parameters_iE_Extensions__item__id_tab
    ___Ass_RAB_Parameters_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Ass_RAB_Parameters_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Ass_RAB_Parameters_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Ass_RAB_Parameters_iE_Extensions__item__extensionValue._const_tab = ____Ass_RAB_Parameters_iE_Extensions__item__id_tab
    ___Ass_RAB_Parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Ass_RAB_Parameters_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Ass_RAB_Parameters_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Ass_RAB_Parameters_iE_Extensions__item__id),
        (u'criticality', ___Ass_RAB_Parameters_iE_Extensions__item__criticality),
        (u'extensionValue', ___Ass_RAB_Parameters_iE_Extensions__item__extensionValue),
        ])
    __Ass_RAB_Parameters_iE_Extensions__item_._ext = None
    _Ass_RAB_Parameters_iE_Extensions._cont = __Ass_RAB_Parameters_iE_Extensions__item_
    _Ass_RAB_Parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Ass_RAB_Parameters._cont = ASN1Dict([
        (u'assMaxBitrateInf', _Ass_RAB_Parameters_assMaxBitrateInf),
        (u'assGuaranteedBitRateInf', _Ass_RAB_Parameters_assGuaranteedBitRateInf),
        (u'iE-Extensions', _Ass_RAB_Parameters_iE_Extensions),
        ])
    Ass_RAB_Parameters._ext = []
    
    #-----< Ass-RAB-Parameters-ExtIEs >-----#
    Ass_RAB_Parameters_ExtIEs = CLASS(name=u'Ass-RAB-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _Ass_RAB_Parameters_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Ass-RAB-Parameter-ExtendedGuaranteedBitrateList')))
    _Ass_RAB_Parameters_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Ass-RAB-Parameter-ExtendedMaxBitrateList')))
    _Ass_RAB_Parameters_ExtIEs_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    _Ass_RAB_Parameters_ExtIEs_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    Ass_RAB_Parameters_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 174), (u'criticality', u'reject'), (u'Extension', _Ass_RAB_Parameters_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 175), (u'criticality', u'reject'), (u'Extension', _Ass_RAB_Parameters_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 217), (u'criticality', u'ignore'), (u'Extension', _Ass_RAB_Parameters_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 216), (u'criticality', u'ignore'), (u'Extension', _Ass_RAB_Parameters_ExtIEs_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Ass-RAB-Parameter-ExtendedGuaranteedBitrateList >-----#
    Ass_RAB_Parameter_ExtendedGuaranteedBitrateList = SEQ_OF(name=u'Ass-RAB-Parameter-ExtendedGuaranteedBitrateList', mode=MODE_TYPE)
    _Ass_RAB_Parameter_ExtendedGuaranteedBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedGuaranteedBitrate')))
    Ass_RAB_Parameter_ExtendedGuaranteedBitrateList._cont = _Ass_RAB_Parameter_ExtendedGuaranteedBitrateList__item_
    Ass_RAB_Parameter_ExtendedGuaranteedBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Ass-RAB-Parameter-ExtendedMaxBitrateList >-----#
    Ass_RAB_Parameter_ExtendedMaxBitrateList = SEQ_OF(name=u'Ass-RAB-Parameter-ExtendedMaxBitrateList', mode=MODE_TYPE)
    _Ass_RAB_Parameter_ExtendedMaxBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedMaxBitrate')))
    Ass_RAB_Parameter_ExtendedMaxBitrateList._cont = _Ass_RAB_Parameter_ExtendedMaxBitrateList__item_
    Ass_RAB_Parameter_ExtendedMaxBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Ass-RAB-Parameter-GuaranteedBitrateList >-----#
    Ass_RAB_Parameter_GuaranteedBitrateList = SEQ_OF(name=u'Ass-RAB-Parameter-GuaranteedBitrateList', mode=MODE_TYPE)
    _Ass_RAB_Parameter_GuaranteedBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GuaranteedBitrate')))
    Ass_RAB_Parameter_GuaranteedBitrateList._cont = _Ass_RAB_Parameter_GuaranteedBitrateList__item_
    Ass_RAB_Parameter_GuaranteedBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Ass-RAB-Parameter-MaxBitrateList >-----#
    Ass_RAB_Parameter_MaxBitrateList = SEQ_OF(name=u'Ass-RAB-Parameter-MaxBitrateList', mode=MODE_TYPE)
    _Ass_RAB_Parameter_MaxBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MaxBitrate')))
    Ass_RAB_Parameter_MaxBitrateList._cont = _Ass_RAB_Parameter_MaxBitrateList__item_
    Ass_RAB_Parameter_MaxBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< AuthorisedPLMNs >-----#
    AuthorisedPLMNs = SEQ_OF(name=u'AuthorisedPLMNs', mode=MODE_TYPE)
    _AuthorisedPLMNs__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __AuthorisedPLMNs__item__pLMNidentity = OCT_STR(name=u'pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    __AuthorisedPLMNs__item__authorisedSNAsList = SEQ_OF(name=u'authorisedSNAsList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'AuthorisedSNAs')), opt=True)
    __AuthorisedPLMNs__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___AuthorisedPLMNs__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____AuthorisedPLMNs__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    _____AuthorisedPLMNs__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____AuthorisedPLMNs__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AuthorisedPLMNs__item__iE_Extensions__item__id._const_tab = _____AuthorisedPLMNs__item__iE_Extensions__item__id_tab
    ____AuthorisedPLMNs__item__iE_Extensions__item__id._const_tab_at = None
    ____AuthorisedPLMNs__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____AuthorisedPLMNs__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____AuthorisedPLMNs__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____AuthorisedPLMNs__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AuthorisedPLMNs__item__iE_Extensions__item__criticality._const_tab = _____AuthorisedPLMNs__item__iE_Extensions__item__criticality_tab
    ____AuthorisedPLMNs__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____AuthorisedPLMNs__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____AuthorisedPLMNs__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____AuthorisedPLMNs__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____AuthorisedPLMNs__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AuthorisedPLMNs__item__iE_Extensions__item__extensionValue._const_tab = _____AuthorisedPLMNs__item__iE_Extensions__item__extensionValue_tab
    ____AuthorisedPLMNs__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____AuthorisedPLMNs__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___AuthorisedPLMNs__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____AuthorisedPLMNs__item__iE_Extensions__item__id),
        (u'criticality', ____AuthorisedPLMNs__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____AuthorisedPLMNs__item__iE_Extensions__item__extensionValue),
        ])
    ___AuthorisedPLMNs__item__iE_Extensions__item_._ext = None
    __AuthorisedPLMNs__item__iE_Extensions._cont = ___AuthorisedPLMNs__item__iE_Extensions__item_
    __AuthorisedPLMNs__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _AuthorisedPLMNs__item_._cont = ASN1Dict([
        (u'pLMNidentity', __AuthorisedPLMNs__item__pLMNidentity),
        (u'authorisedSNAsList', __AuthorisedPLMNs__item__authorisedSNAsList),
        (u'iE-Extensions', __AuthorisedPLMNs__item__iE_Extensions),
        ])
    _AuthorisedPLMNs__item_._ext = []
    AuthorisedPLMNs._cont = _AuthorisedPLMNs__item_
    AuthorisedPLMNs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< AuthorisedPLMNs-ExtIEs >-----#
    AuthorisedPLMNs_ExtIEs = CLASS(name=u'AuthorisedPLMNs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    AuthorisedPLMNs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AuthorisedSNAs >-----#
    AuthorisedSNAs = SEQ_OF(name=u'AuthorisedSNAs', mode=MODE_TYPE)
    _AuthorisedSNAs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SNAC')))
    AuthorisedSNAs._cont = _AuthorisedSNAs__item_
    AuthorisedSNAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< BarometricPressure >-----#
    BarometricPressure = INT(name=u'BarometricPressure', mode=MODE_TYPE)
    BarometricPressure._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=30000, ub=115000)], ev=None, er=[])
    
    #-----< BindingID >-----#
    BindingID = OCT_STR(name=u'BindingID', mode=MODE_TYPE)
    BindingID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< BroadcastAssistanceDataDecipheringKeys >-----#
    BroadcastAssistanceDataDecipheringKeys = SEQ(name=u'BroadcastAssistanceDataDecipheringKeys', mode=MODE_TYPE)
    _BroadcastAssistanceDataDecipheringKeys_cipheringKeyFlag = BIT_STR(name=u'cipheringKeyFlag', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BroadcastAssistanceDataDecipheringKeys_cipheringKeyFlag._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _BroadcastAssistanceDataDecipheringKeys_currentDecipheringKey = BIT_STR(name=u'currentDecipheringKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BroadcastAssistanceDataDecipheringKeys_currentDecipheringKey._const_sz = ASN1Set(rv=[56], rr=[], ev=None, er=[])
    _BroadcastAssistanceDataDecipheringKeys_nextDecipheringKey = BIT_STR(name=u'nextDecipheringKey', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BroadcastAssistanceDataDecipheringKeys_nextDecipheringKey._const_sz = ASN1Set(rv=[56], rr=[], ev=None, er=[])
    BroadcastAssistanceDataDecipheringKeys._cont = ASN1Dict([
        (u'cipheringKeyFlag', _BroadcastAssistanceDataDecipheringKeys_cipheringKeyFlag),
        (u'currentDecipheringKey', _BroadcastAssistanceDataDecipheringKeys_currentDecipheringKey),
        (u'nextDecipheringKey', _BroadcastAssistanceDataDecipheringKeys_nextDecipheringKey),
        ])
    BroadcastAssistanceDataDecipheringKeys._ext = []
    
    #-----< Cause >-----#
    Cause = CHOICE(name=u'Cause', mode=MODE_TYPE)
    _Cause_radioNetwork = INT(name=u'radioNetwork', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CauseRadioNetwork')))
    _Cause_transmissionNetwork = INT(name=u'transmissionNetwork', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CauseTransmissionNetwork')))
    _Cause_nAS = INT(name=u'nAS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CauseNAS')))
    _Cause_protocol = INT(name=u'protocol', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CauseProtocol')))
    _Cause_misc = INT(name=u'misc', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CauseMisc')))
    _Cause_non_Standard = INT(name=u'non-Standard', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CauseNon-Standard')))
    _Cause_radioNetworkExtension = INT(name=u'radioNetworkExtension', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CauseRadioNetworkExtension')))
    Cause._cont = ASN1Dict([
        (u'radioNetwork', _Cause_radioNetwork),
        (u'transmissionNetwork', _Cause_transmissionNetwork),
        (u'nAS', _Cause_nAS),
        (u'protocol', _Cause_protocol),
        (u'misc', _Cause_misc),
        (u'non-Standard', _Cause_non_Standard),
        (u'radioNetworkExtension', _Cause_radioNetworkExtension),
        ])
    Cause._ext = [u'radioNetworkExtension']
    
    #-----< CauseMisc >-----#
    CauseMisc = INT(name=u'CauseMisc', mode=MODE_TYPE)
    CauseMisc._cont = ASN1Dict([(u'om-intervention', 113), (u'no-resource-available', 114), (u'unspecified-failure', 115), (u'network-optimisation', 116)])
    CauseMisc._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=113, ub=128)], ev=None, er=[])
    
    #-----< CauseNAS >-----#
    CauseNAS = INT(name=u'CauseNAS', mode=MODE_TYPE)
    CauseNAS._cont = ASN1Dict([(u'user-restriction-start-indication', 81), (u'user-restriction-end-indication', 82), (u'normal-release', 83), (u'csg-subscription-expiry', 84)])
    CauseNAS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=81, ub=96)], ev=None, er=[])
    
    #-----< CauseProtocol >-----#
    CauseProtocol = INT(name=u'CauseProtocol', mode=MODE_TYPE)
    CauseProtocol._cont = ASN1Dict([(u'transfer-syntax-error', 97), (u'semantic-error', 98), (u'message-not-compatible-with-receiver-state', 99), (u'abstract-syntax-error-reject', 100), (u'abstract-syntax-error-ignore-and-notify', 101), (u'abstract-syntax-error-falsely-constructed-message', 102)])
    CauseProtocol._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=97, ub=112)], ev=None, er=[])
    
    #-----< CauseRadioNetwork >-----#
    CauseRadioNetwork = INT(name=u'CauseRadioNetwork', mode=MODE_TYPE)
    CauseRadioNetwork._cont = ASN1Dict([(u'rab-pre-empted', 1), (u'trelocoverall-expiry', 2), (u'trelocprep-expiry', 3), (u'treloccomplete-expiry', 4), (u'tqueing-expiry', 5), (u'relocation-triggered', 6), (u'trellocalloc-expiry', 7), (u'unable-to-establish-during-relocation', 8), (u'unknown-target-rnc', 9), (u'relocation-cancelled', 10), (u'successful-relocation', 11), (u'requested-ciphering-and-or-integrity-protection-algorithms-not-supported', 12), (u'conflict-with-already-existing-integrity-protection-and-or-ciphering-information', 13), (u'failure-in-the-radio-interface-procedure', 14), (u'release-due-to-utran-generated-reason', 15), (u'user-inactivity', 16), (u'time-critical-relocation', 17), (u'requested-traffic-class-not-available', 18), (u'invalid-rab-parameters-value', 19), (u'requested-maximum-bit-rate-not-available', 20), (u'requested-guaranteed-bit-rate-not-available', 21), (u'requested-transfer-delay-not-achievable', 22), (u'invalid-rab-parameters-combination', 23), (u'condition-violation-for-sdu-parameters', 24), (u'condition-violation-for-traffic-handling-priority', 25), (u'condition-violation-for-guaranteed-bit-rate', 26), (u'user-plane-versions-not-supported', 27), (u'iu-up-failure', 28), (u'relocation-failure-in-target-CN-RNC-or-target-system', 29), (u'invalid-RAB-ID', 30), (u'no-remaining-rab', 31), (u'interaction-with-other-procedure', 32), (u'requested-maximum-bit-rate-for-dl-not-available', 33), (u'requested-maximum-bit-rate-for-ul-not-available', 34), (u'requested-guaranteed-bit-rate-for-dl-not-available', 35), (u'requested-guaranteed-bit-rate-for-ul-not-available', 36), (u'repeated-integrity-checking-failure', 37), (u'requested-request-type-not-supported', 38), (u'request-superseded', 39), (u'release-due-to-UE-generated-signalling-connection-release', 40), (u'resource-optimisation-relocation', 41), (u'requested-information-not-available', 42), (u'relocation-desirable-for-radio-reasons', 43), (u'relocation-not-supported-in-target-RNC-or-target-system', 44), (u'directed-retry', 45), (u'radio-connection-with-UE-Lost', 46), (u'rNC-unable-to-establish-all-RFCs', 47), (u'deciphering-keys-not-available', 48), (u'dedicated-assistance-data-not-available', 49), (u'relocation-target-not-allowed', 50), (u'location-reporting-congestion', 51), (u'reduce-load-in-serving-cell', 52), (u'no-radio-resources-available-in-target-cell', 53), (u'gERAN-Iumode-failure', 54), (u'access-restricted-due-to-shared-networks', 55), (u'incoming-relocation-not-supported-due-to-PUESBINE-feature', 56), (u'traffic-load-in-the-target-cell-higher-than-in-the-source-cell', 57), (u'mBMS-no-multicast-service-for-this-UE', 58), (u'mBMS-unknown-UE-ID', 59), (u'successful-MBMS-session-start-no-data-bearer-necessary', 60), (u'mBMS-superseded-due-to-NNSF', 61), (u'mBMS-UE-linking-already-done', 62), (u'mBMS-UE-de-linking-failure-no-existing-UE-linking', 63), (u'tMGI-unknown', 64)])
    CauseRadioNetwork._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< CauseRadioNetworkExtension >-----#
    CauseRadioNetworkExtension = INT(name=u'CauseRadioNetworkExtension', mode=MODE_TYPE)
    CauseRadioNetworkExtension._cont = ASN1Dict([(u'iP-multicast-address-and-APN-not-valid', 257), (u'mBMS-de-registration-rejected-due-to-implicit-registration', 258), (u'mBMS-request-superseded', 259), (u'mBMS-de-registration-during-session-not-allowed', 260), (u'mBMS-no-data-bearer-necessary', 261), (u'periodicLocationInformationNotAvailable', 262), (u'gTP-Resources-Unavailable', 263), (u'tMGI-inUse-overlapping-MBMS-service-area', 264), (u'mBMS-no-cell-in-MBMS-service-area', 265), (u'no-Iu-CS-UP-relocation', 266), (u'successful-MBMS-Session-Start-IP-Multicast-Bearer-established', 267), (u'cS-fallback-triggered', 268), (u'invalid-CSG-Id', 269)])
    CauseRadioNetworkExtension._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=257, ub=512)], ev=None, er=[])
    
    #-----< CauseNon-Standard >-----#
    CauseNon_Standard = INT(name=u'CauseNon-Standard', mode=MODE_TYPE)
    CauseNon_Standard._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=129, ub=256)], ev=None, er=[])
    
    #-----< CauseTransmissionNetwork >-----#
    CauseTransmissionNetwork = INT(name=u'CauseTransmissionNetwork', mode=MODE_TYPE)
    CauseTransmissionNetwork._cont = ASN1Dict([(u'signalling-transport-resource-failure', 65), (u'iu-transport-connection-failed-to-establish', 66)])
    CauseTransmissionNetwork._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=65, ub=80)], ev=None, er=[])
    
    #-----< Cell-Access-Mode >-----#
    Cell_Access_Mode = ENUM(name=u'Cell-Access-Mode', mode=MODE_TYPE)
    Cell_Access_Mode._cont = ASN1Dict([(u'hybrid', 0)])
    Cell_Access_Mode._ext = []
    
    #-----< CellBased >-----#
    CellBased = SEQ(name=u'CellBased', mode=MODE_TYPE)
    _CellBased_cellIdList = SEQ_OF(name=u'cellIdList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CellIdList')))
    _CellBased_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellBased_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___CellBased_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CellBased_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CellBased_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBased_iE_Extensions__item__id._const_tab = ____CellBased_iE_Extensions__item__id_tab
    ___CellBased_iE_Extensions__item__id._const_tab_at = None
    ___CellBased_iE_Extensions__item__id._const_tab_id = u'id'
    ___CellBased_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CellBased_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CellBased_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBased_iE_Extensions__item__criticality._const_tab = ____CellBased_iE_Extensions__item__criticality_tab
    ___CellBased_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CellBased_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CellBased_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CellBased_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CellBased_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBased_iE_Extensions__item__extensionValue._const_tab = ____CellBased_iE_Extensions__item__extensionValue_tab
    ___CellBased_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CellBased_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CellBased_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CellBased_iE_Extensions__item__id),
        (u'criticality', ___CellBased_iE_Extensions__item__criticality),
        (u'extensionValue', ___CellBased_iE_Extensions__item__extensionValue),
        ])
    __CellBased_iE_Extensions__item_._ext = None
    _CellBased_iE_Extensions._cont = __CellBased_iE_Extensions__item_
    _CellBased_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellBased._cont = ASN1Dict([
        (u'cellIdList', _CellBased_cellIdList),
        (u'iE-Extensions', _CellBased_iE_Extensions),
        ])
    CellBased._ext = []
    
    #-----< CellBased-ExtIEs >-----#
    CellBased_ExtIEs = CLASS(name=u'CellBased-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    CellBased_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellIdList >-----#
    CellIdList = SEQ_OF(name=u'CellIdList', mode=MODE_TYPE)
    _CellIdList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cell-Id')))
    CellIdList._cont = _CellIdList__item_
    CellIdList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Cell-Id >-----#
    Cell_Id = INT(name=u'Cell-Id', mode=MODE_TYPE)
    Cell_Id._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=268435455)], ev=None, er=[])
    
    #-----< Cell-Capacity-Class-Value >-----#
    Cell_Capacity_Class_Value = INT(name=u'Cell-Capacity-Class-Value', mode=MODE_TYPE)
    Cell_Capacity_Class_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=[], er=[])
    
    #-----< CellLoadInformation >-----#
    CellLoadInformation = SEQ(name=u'CellLoadInformation', mode=MODE_TYPE)
    _CellLoadInformation_cell_Capacity_Class_Value = INT(name=u'cell-Capacity-Class-Value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Cell-Capacity-Class-Value')))
    _CellLoadInformation_loadValue = INT(name=u'loadValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LoadValue')))
    _CellLoadInformation_rTLoadValue = INT(name=u'rTLoadValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RTLoadValue')), opt=True)
    _CellLoadInformation_nRTLoadInformationValue = INT(name=u'nRTLoadInformationValue', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'NRTLoadInformationValue')), opt=True)
    _CellLoadInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellLoadInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___CellLoadInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CellLoadInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CellLoadInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellLoadInformation_iE_Extensions__item__id._const_tab = ____CellLoadInformation_iE_Extensions__item__id_tab
    ___CellLoadInformation_iE_Extensions__item__id._const_tab_at = None
    ___CellLoadInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___CellLoadInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CellLoadInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CellLoadInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellLoadInformation_iE_Extensions__item__criticality._const_tab = ____CellLoadInformation_iE_Extensions__item__criticality_tab
    ___CellLoadInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CellLoadInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CellLoadInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CellLoadInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CellLoadInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellLoadInformation_iE_Extensions__item__extensionValue._const_tab = ____CellLoadInformation_iE_Extensions__item__extensionValue_tab
    ___CellLoadInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CellLoadInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CellLoadInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CellLoadInformation_iE_Extensions__item__id),
        (u'criticality', ___CellLoadInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___CellLoadInformation_iE_Extensions__item__extensionValue),
        ])
    __CellLoadInformation_iE_Extensions__item_._ext = None
    _CellLoadInformation_iE_Extensions._cont = __CellLoadInformation_iE_Extensions__item_
    _CellLoadInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellLoadInformation._cont = ASN1Dict([
        (u'cell-Capacity-Class-Value', _CellLoadInformation_cell_Capacity_Class_Value),
        (u'loadValue', _CellLoadInformation_loadValue),
        (u'rTLoadValue', _CellLoadInformation_rTLoadValue),
        (u'nRTLoadInformationValue', _CellLoadInformation_nRTLoadInformationValue),
        (u'iE-Extensions', _CellLoadInformation_iE_Extensions),
        ])
    CellLoadInformation._ext = []
    
    #-----< CellLoadInformation-ExtIEs >-----#
    CellLoadInformation_ExtIEs = CLASS(name=u'CellLoadInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    CellLoadInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellLoadInformationGroup >-----#
    CellLoadInformationGroup = SEQ(name=u'CellLoadInformationGroup', mode=MODE_TYPE)
    _CellLoadInformationGroup_sourceCellID = CHOICE(name=u'sourceCellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SourceCellID')))
    _CellLoadInformationGroup_uplinkCellLoadInformation = SEQ(name=u'uplinkCellLoadInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CellLoadInformation')), opt=True)
    _CellLoadInformationGroup_downlinkCellLoadInformation = SEQ(name=u'downlinkCellLoadInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CellLoadInformation')), opt=True)
    _CellLoadInformationGroup_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellLoadInformationGroup_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___CellLoadInformationGroup_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CellLoadInformationGroup_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CellLoadInformationGroup_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellLoadInformationGroup_iE_Extensions__item__id._const_tab = ____CellLoadInformationGroup_iE_Extensions__item__id_tab
    ___CellLoadInformationGroup_iE_Extensions__item__id._const_tab_at = None
    ___CellLoadInformationGroup_iE_Extensions__item__id._const_tab_id = u'id'
    ___CellLoadInformationGroup_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CellLoadInformationGroup_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CellLoadInformationGroup_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellLoadInformationGroup_iE_Extensions__item__criticality._const_tab = ____CellLoadInformationGroup_iE_Extensions__item__criticality_tab
    ___CellLoadInformationGroup_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CellLoadInformationGroup_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CellLoadInformationGroup_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CellLoadInformationGroup_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CellLoadInformationGroup_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellLoadInformationGroup_iE_Extensions__item__extensionValue._const_tab = ____CellLoadInformationGroup_iE_Extensions__item__extensionValue_tab
    ___CellLoadInformationGroup_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CellLoadInformationGroup_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CellLoadInformationGroup_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CellLoadInformationGroup_iE_Extensions__item__id),
        (u'criticality', ___CellLoadInformationGroup_iE_Extensions__item__criticality),
        (u'extensionValue', ___CellLoadInformationGroup_iE_Extensions__item__extensionValue),
        ])
    __CellLoadInformationGroup_iE_Extensions__item_._ext = None
    _CellLoadInformationGroup_iE_Extensions._cont = __CellLoadInformationGroup_iE_Extensions__item_
    _CellLoadInformationGroup_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellLoadInformationGroup._cont = ASN1Dict([
        (u'sourceCellID', _CellLoadInformationGroup_sourceCellID),
        (u'uplinkCellLoadInformation', _CellLoadInformationGroup_uplinkCellLoadInformation),
        (u'downlinkCellLoadInformation', _CellLoadInformationGroup_downlinkCellLoadInformation),
        (u'iE-Extensions', _CellLoadInformationGroup_iE_Extensions),
        ])
    CellLoadInformationGroup._ext = []
    
    #-----< CellLoadInformationGroup-ExtIEs >-----#
    CellLoadInformationGroup_ExtIEs = CLASS(name=u'CellLoadInformationGroup-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    CellLoadInformationGroup_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellType >-----#
    CellType = ENUM(name=u'CellType', mode=MODE_TYPE)
    CellType._cont = ASN1Dict([(u'macro', 0), (u'micro', 1), (u'pico', 2), (u'femto', 3)])
    CellType._ext = []
    
    #-----< CivicAddress >-----#
    CivicAddress = OCT_STR(name=u'CivicAddress', mode=MODE_TYPE)
    
    #-----< ClientType >-----#
    ClientType = ENUM(name=u'ClientType', mode=MODE_TYPE)
    ClientType._cont = ASN1Dict([(u'emergency-Services', 0), (u'value-Added-Services', 1), (u'pLMN-Operator-Services', 2), (u'lawful-Intercept-Services', 3), (u'pLMN-Operator-Broadcast-Services', 4), (u'pLMN-Operator-O-et-M', 5), (u'pLMN-Operator-Anonymous-Statistics', 6), (u'pLMN-Operator-Target-MS-Service-Support', 7)])
    ClientType._ext = []
    
    #-----< CriticalityDiagnostics >-----#
    CriticalityDiagnostics = SEQ(name=u'CriticalityDiagnostics', mode=MODE_TYPE)
    _CriticalityDiagnostics_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-CommonDataTypes', 'ProcedureCode')), opt=True)
    _CriticalityDiagnostics_triggeringMessage = ENUM(name=u'triggeringMessage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-CommonDataTypes', 'TriggeringMessage')), opt=True)
    _CriticalityDiagnostics_procedureCriticality = ENUM(name=u'procedureCriticality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-CommonDataTypes', 'Criticality')), opt=True)
    _CriticalityDiagnostics_iEsCriticalityDiagnostics = SEQ_OF(name=u'iEsCriticalityDiagnostics', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics-IE-List')), opt=True)
    _CriticalityDiagnostics_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_id = u'id'
    ___CriticalityDiagnostics_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CriticalityDiagnostics_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CriticalityDiagnostics_iE_Extensions__item__id),
        (u'criticality', ___CriticalityDiagnostics_iE_Extensions__item__criticality),
        (u'extensionValue', ___CriticalityDiagnostics_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_iE_Extensions._cont = __CriticalityDiagnostics_iE_Extensions__item_
    _CriticalityDiagnostics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics._cont = ASN1Dict([
        (u'procedureCode', _CriticalityDiagnostics_procedureCode),
        (u'triggeringMessage', _CriticalityDiagnostics_triggeringMessage),
        (u'procedureCriticality', _CriticalityDiagnostics_procedureCriticality),
        (u'iEsCriticalityDiagnostics', _CriticalityDiagnostics_iEsCriticalityDiagnostics),
        (u'iE-Extensions', _CriticalityDiagnostics_iE_Extensions),
        ])
    CriticalityDiagnostics._ext = []
    
    #-----< CriticalityDiagnostics-ExtIEs >-----#
    CriticalityDiagnostics_ExtIEs = CLASS(name=u'CriticalityDiagnostics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CriticalityDiagnostics-IE-List >-----#
    CriticalityDiagnostics_IE_List = SEQ_OF(name=u'CriticalityDiagnostics-IE-List', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_List__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CriticalityDiagnostics_IE_List__item__iECriticality = ENUM(name=u'iECriticality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-CommonDataTypes', 'Criticality')))
    __CriticalityDiagnostics_IE_List__item__iE_ID = INT(name=u'iE-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-CommonDataTypes', 'ProtocolIE-ID')))
    __CriticalityDiagnostics_IE_List__item__repetitionNumber = INT(name=u'repetitionNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RepetitionNumber0')), opt=True)
    __CriticalityDiagnostics_IE_List__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ______CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MessageStructure')))
    ______CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TypeOfError')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 88), (u'criticality', u'ignore'), (u'Extension', ______CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 93), (u'criticality', u'ignore'), (u'Extension', ______CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab_at = None
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id),
        (u'criticality', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue),
        ])
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_._ext = None
    __CriticalityDiagnostics_IE_List__item__iE_Extensions._cont = ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_
    __CriticalityDiagnostics_IE_List__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _CriticalityDiagnostics_IE_List__item_._cont = ASN1Dict([
        (u'iECriticality', __CriticalityDiagnostics_IE_List__item__iECriticality),
        (u'iE-ID', __CriticalityDiagnostics_IE_List__item__iE_ID),
        (u'repetitionNumber', __CriticalityDiagnostics_IE_List__item__repetitionNumber),
        (u'iE-Extensions', __CriticalityDiagnostics_IE_List__item__iE_Extensions),
        ])
    _CriticalityDiagnostics_IE_List__item_._ext = []
    CriticalityDiagnostics_IE_List._cont = _CriticalityDiagnostics_IE_List__item_
    CriticalityDiagnostics_IE_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CriticalityDiagnostics-IE-List-ExtIEs >-----#
    CriticalityDiagnostics_IE_List_ExtIEs = CLASS(name=u'CriticalityDiagnostics-IE-List-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _CriticalityDiagnostics_IE_List_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MessageStructure')))
    _CriticalityDiagnostics_IE_List_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TypeOfError')))
    CriticalityDiagnostics_IE_List_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 88), (u'criticality', u'ignore'), (u'Extension', _CriticalityDiagnostics_IE_List_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 93), (u'criticality', u'ignore'), (u'Extension', _CriticalityDiagnostics_IE_List_ExtIEs_val_Extension_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MessageStructure >-----#
    MessageStructure = SEQ_OF(name=u'MessageStructure', mode=MODE_TYPE)
    _MessageStructure__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __MessageStructure__item__iE_ID = INT(name=u'iE-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-CommonDataTypes', 'ProtocolIE-ID')))
    __MessageStructure__item__repetitionNumber = INT(name=u'repetitionNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RepetitionNumber1')), opt=True)
    __MessageStructure__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___MessageStructure__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____MessageStructure__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    _____MessageStructure__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____MessageStructure__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____MessageStructure__item__iE_Extensions__item__id._const_tab = _____MessageStructure__item__iE_Extensions__item__id_tab
    ____MessageStructure__item__iE_Extensions__item__id._const_tab_at = None
    ____MessageStructure__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____MessageStructure__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____MessageStructure__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____MessageStructure__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____MessageStructure__item__iE_Extensions__item__criticality._const_tab = _____MessageStructure__item__iE_Extensions__item__criticality_tab
    ____MessageStructure__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____MessageStructure__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____MessageStructure__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____MessageStructure__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____MessageStructure__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____MessageStructure__item__iE_Extensions__item__extensionValue._const_tab = _____MessageStructure__item__iE_Extensions__item__extensionValue_tab
    ____MessageStructure__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____MessageStructure__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___MessageStructure__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____MessageStructure__item__iE_Extensions__item__id),
        (u'criticality', ____MessageStructure__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____MessageStructure__item__iE_Extensions__item__extensionValue),
        ])
    ___MessageStructure__item__iE_Extensions__item_._ext = None
    __MessageStructure__item__iE_Extensions._cont = ___MessageStructure__item__iE_Extensions__item_
    __MessageStructure__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _MessageStructure__item_._cont = ASN1Dict([
        (u'iE-ID', __MessageStructure__item__iE_ID),
        (u'repetitionNumber', __MessageStructure__item__repetitionNumber),
        (u'iE-Extensions', __MessageStructure__item__iE_Extensions),
        ])
    _MessageStructure__item_._ext = []
    MessageStructure._cont = _MessageStructure__item_
    MessageStructure._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< MessageStructure-ExtIEs >-----#
    MessageStructure_ExtIEs = CLASS(name=u'MessageStructure-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MessageStructure_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CGI >-----#
    CGI = SEQ(name=u'CGI', mode=MODE_TYPE)
    _CGI_pLMNidentity = OCT_STR(name=u'pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _CGI_lAC = OCT_STR(name=u'lAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LAC')))
    _CGI_cI = OCT_STR(name=u'cI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CI')))
    _CGI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___CGI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CGI_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____CGI_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAC')))
    ____CGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 55), (u'criticality', u'ignore'), (u'Extension', _____CGI_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CGI_iE_Extensions__item__id._const_tab = ____CGI_iE_Extensions__item__id_tab
    ___CGI_iE_Extensions__item__id._const_tab_at = None
    ___CGI_iE_Extensions__item__id._const_tab_id = u'id'
    ___CGI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CGI_iE_Extensions__item__criticality._const_tab = ____CGI_iE_Extensions__item__id_tab
    ___CGI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CGI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CGI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CGI_iE_Extensions__item__extensionValue._const_tab = ____CGI_iE_Extensions__item__id_tab
    ___CGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CGI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CGI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CGI_iE_Extensions__item__id),
        (u'criticality', ___CGI_iE_Extensions__item__criticality),
        (u'extensionValue', ___CGI_iE_Extensions__item__extensionValue),
        ])
    __CGI_iE_Extensions__item_._ext = None
    _CGI_iE_Extensions._cont = __CGI_iE_Extensions__item_
    _CGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CGI._cont = ASN1Dict([
        (u'pLMNidentity', _CGI_pLMNidentity),
        (u'lAC', _CGI_lAC),
        (u'cI', _CGI_cI),
        (u'iE-Extensions', _CGI_iE_Extensions),
        ])
    CGI._ext = None
    
    #-----< CGI-ExtIEs >-----#
    CGI_ExtIEs = CLASS(name=u'CGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _CGI_ExtIEs_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAC')))
    CGI_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 55), (u'criticality', u'ignore'), (u'Extension', _CGI_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ChosenEncryptionAlgorithm >-----#
    ChosenEncryptionAlgorithm = INT(name=u'ChosenEncryptionAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'EncryptionAlgorithm')))
    
    #-----< ChosenIntegrityProtectionAlgorithm >-----#
    ChosenIntegrityProtectionAlgorithm = INT(name=u'ChosenIntegrityProtectionAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IntegrityProtectionAlgorithm')))
    
    #-----< CI >-----#
    CI = OCT_STR(name=u'CI', mode=MODE_TYPE)
    CI._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< ClassmarkInformation2 >-----#
    ClassmarkInformation2 = OCT_STR(name=u'ClassmarkInformation2', mode=MODE_TYPE)
    
    #-----< ClassmarkInformation3 >-----#
    ClassmarkInformation3 = OCT_STR(name=u'ClassmarkInformation3', mode=MODE_TYPE)
    
    #-----< CN-DomainIndicator >-----#
    CN_DomainIndicator = ENUM(name=u'CN-DomainIndicator', mode=MODE_TYPE)
    CN_DomainIndicator._cont = ASN1Dict([(u'cs-domain', 0), (u'ps-domain', 1)])
    CN_DomainIndicator._ext = None
    
    #-----< CN-ID >-----#
    CN_ID = INT(name=u'CN-ID', mode=MODE_TYPE)
    CN_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< Correlation-ID >-----#
    Correlation_ID = OCT_STR(name=u'Correlation-ID', mode=MODE_TYPE)
    Correlation_ID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< CSFB-Information >-----#
    CSFB_Information = ENUM(name=u'CSFB-Information', mode=MODE_TYPE)
    CSFB_Information._cont = ASN1Dict([(u'csfb', 0), (u'csfb-high-priority', 1)])
    CSFB_Information._ext = []
    
    #-----< CSG-Id >-----#
    CSG_Id = BIT_STR(name=u'CSG-Id', mode=MODE_TYPE)
    CSG_Id._const_sz = ASN1Set(rv=[27], rr=[], ev=None, er=[])
    
    #-----< CSG-Id-List >-----#
    CSG_Id_List = SEQ_OF(name=u'CSG-Id-List', mode=MODE_TYPE)
    _CSG_Id_List__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id')))
    CSG_Id_List._cont = _CSG_Id_List__item_
    CSG_Id_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CSG-Membership-Status >-----#
    CSG_Membership_Status = ENUM(name=u'CSG-Membership-Status', mode=MODE_TYPE)
    CSG_Membership_Status._cont = ASN1Dict([(u'member', 0), (u'non-member', 1)])
    CSG_Membership_Status._ext = []
    
    #-----< DataPDUType >-----#
    DataPDUType = ENUM(name=u'DataPDUType', mode=MODE_TYPE)
    DataPDUType._cont = ASN1Dict([(u'pDUtype0', 0), (u'pDUtype1', 1)])
    DataPDUType._ext = []
    
    #-----< DataVolumeReference >-----#
    DataVolumeReference = INT(name=u'DataVolumeReference', mode=MODE_TYPE)
    DataVolumeReference._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< DataVolumeReportingIndication >-----#
    DataVolumeReportingIndication = ENUM(name=u'DataVolumeReportingIndication', mode=MODE_TYPE)
    DataVolumeReportingIndication._cont = ASN1Dict([(u'do-report', 0), (u'do-not-report', 1)])
    DataVolumeReportingIndication._ext = None
    
    #-----< DCH-ID >-----#
    DCH_ID = INT(name=u'DCH-ID', mode=MODE_TYPE)
    DCH_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< DCN-ID >-----#
    DCN_ID = INT(name=u'DCN-ID', mode=MODE_TYPE)
    DCN_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< DeliveryOfErroneousSDU >-----#
    DeliveryOfErroneousSDU = ENUM(name=u'DeliveryOfErroneousSDU', mode=MODE_TYPE)
    DeliveryOfErroneousSDU._cont = ASN1Dict([(u'yes', 0), (u'no', 1), (u'no-error-detection-consideration', 2)])
    DeliveryOfErroneousSDU._ext = None
    
    #-----< DeliveryOrder >-----#
    DeliveryOrder = ENUM(name=u'DeliveryOrder', mode=MODE_TYPE)
    DeliveryOrder._cont = ASN1Dict([(u'delivery-order-requested', 0), (u'delivery-order-not-requested', 1)])
    DeliveryOrder._ext = None
    
    #-----< DeltaRAListofIdleModeUEs >-----#
    DeltaRAListofIdleModeUEs = SEQ(name=u'DeltaRAListofIdleModeUEs', mode=MODE_TYPE)
    _DeltaRAListofIdleModeUEs_newRAListofIdleModeUEs = SEQ_OF(name=u'newRAListofIdleModeUEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'NewRAListofIdleModeUEs')), opt=True)
    _DeltaRAListofIdleModeUEs_rAListwithNoIdleModeUEsAnyMore = SEQ_OF(name=u'rAListwithNoIdleModeUEsAnyMore', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAListwithNoIdleModeUEsAnyMore')), opt=True)
    _DeltaRAListofIdleModeUEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DeltaRAListofIdleModeUEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___DeltaRAListofIdleModeUEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DeltaRAListofIdleModeUEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____DeltaRAListofIdleModeUEs_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LAListofIdleModeUEs')))
    _____DeltaRAListofIdleModeUEs_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LAListofIdleModeUEs')))
    ____DeltaRAListofIdleModeUEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 181), (u'criticality', u'reject'), (u'Extension', _____DeltaRAListofIdleModeUEs_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'conditional')]), dict([(u'id', 182), (u'criticality', u'reject'), (u'Extension', _____DeltaRAListofIdleModeUEs_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'conditional')])], rr=[], ev=None, er=[])
    ___DeltaRAListofIdleModeUEs_iE_Extensions__item__id._const_tab = ____DeltaRAListofIdleModeUEs_iE_Extensions__item__id_tab
    ___DeltaRAListofIdleModeUEs_iE_Extensions__item__id._const_tab_at = None
    ___DeltaRAListofIdleModeUEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___DeltaRAListofIdleModeUEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DeltaRAListofIdleModeUEs_iE_Extensions__item__criticality._const_tab = ____DeltaRAListofIdleModeUEs_iE_Extensions__item__id_tab
    ___DeltaRAListofIdleModeUEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DeltaRAListofIdleModeUEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DeltaRAListofIdleModeUEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DeltaRAListofIdleModeUEs_iE_Extensions__item__extensionValue._const_tab = ____DeltaRAListofIdleModeUEs_iE_Extensions__item__id_tab
    ___DeltaRAListofIdleModeUEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DeltaRAListofIdleModeUEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DeltaRAListofIdleModeUEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DeltaRAListofIdleModeUEs_iE_Extensions__item__id),
        (u'criticality', ___DeltaRAListofIdleModeUEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___DeltaRAListofIdleModeUEs_iE_Extensions__item__extensionValue),
        ])
    __DeltaRAListofIdleModeUEs_iE_Extensions__item_._ext = None
    _DeltaRAListofIdleModeUEs_iE_Extensions._cont = __DeltaRAListofIdleModeUEs_iE_Extensions__item_
    _DeltaRAListofIdleModeUEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DeltaRAListofIdleModeUEs._cont = ASN1Dict([
        (u'newRAListofIdleModeUEs', _DeltaRAListofIdleModeUEs_newRAListofIdleModeUEs),
        (u'rAListwithNoIdleModeUEsAnyMore', _DeltaRAListofIdleModeUEs_rAListwithNoIdleModeUEsAnyMore),
        (u'iE-Extensions', _DeltaRAListofIdleModeUEs_iE_Extensions),
        ])
    DeltaRAListofIdleModeUEs._ext = None
    
    #-----< NewRAListofIdleModeUEs >-----#
    NewRAListofIdleModeUEs = SEQ_OF(name=u'NewRAListofIdleModeUEs', mode=MODE_TYPE)
    _NewRAListofIdleModeUEs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAC')))
    NewRAListofIdleModeUEs._cont = _NewRAListofIdleModeUEs__item_
    NewRAListofIdleModeUEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< RAListwithNoIdleModeUEsAnyMore >-----#
    RAListwithNoIdleModeUEsAnyMore = SEQ_OF(name=u'RAListwithNoIdleModeUEsAnyMore', mode=MODE_TYPE)
    _RAListwithNoIdleModeUEsAnyMore__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAC')))
    RAListwithNoIdleModeUEsAnyMore._cont = _RAListwithNoIdleModeUEsAnyMore__item_
    RAListwithNoIdleModeUEsAnyMore._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< DeltaRAListofIdleModeUEs-ExtIEs >-----#
    DeltaRAListofIdleModeUEs_ExtIEs = CLASS(name=u'DeltaRAListofIdleModeUEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _DeltaRAListofIdleModeUEs_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LAListofIdleModeUEs')))
    _DeltaRAListofIdleModeUEs_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LAListofIdleModeUEs')))
    DeltaRAListofIdleModeUEs_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 181), (u'criticality', u'reject'), (u'Extension', _DeltaRAListofIdleModeUEs_ExtIEs_val_Extension_0), (u'presence', u'conditional')]), dict([(u'id', 182), (u'criticality', u'reject'), (u'Extension', _DeltaRAListofIdleModeUEs_ExtIEs_val_Extension_1), (u'presence', u'conditional')])], rr=[], ev=[], er=[])
    
    #-----< ForwardingIndication >-----#
    ForwardingIndication = ENUM(name=u'ForwardingIndication', mode=MODE_TYPE)
    ForwardingIndication._cont = ASN1Dict([(u'forwarding-admitted', 0)])
    ForwardingIndication._ext = []
    
    #-----< DL-GTP-PDU-SequenceNumber >-----#
    DL_GTP_PDU_SequenceNumber = INT(name=u'DL-GTP-PDU-SequenceNumber', mode=MODE_TYPE)
    DL_GTP_PDU_SequenceNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< DL-N-PDU-SequenceNumber >-----#
    DL_N_PDU_SequenceNumber = INT(name=u'DL-N-PDU-SequenceNumber', mode=MODE_TYPE)
    DL_N_PDU_SequenceNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< D-RNTI >-----#
    D_RNTI = INT(name=u'D-RNTI', mode=MODE_TYPE)
    D_RNTI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=None, er=[])
    
    #-----< DRX-CycleLengthCoefficient >-----#
    DRX_CycleLengthCoefficient = INT(name=u'DRX-CycleLengthCoefficient', mode=MODE_TYPE)
    DRX_CycleLengthCoefficient._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=9)], ev=None, er=[])
    
    #-----< DSCH-ID >-----#
    DSCH_ID = INT(name=u'DSCH-ID', mode=MODE_TYPE)
    DSCH_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< EARFCN-Extended >-----#
    EARFCN_Extended = INT(name=u'EARFCN-Extended', mode=MODE_TYPE)
    EARFCN_Extended._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=65536, ub=262143)], ev=[], er=[])
    
    #-----< E-DCH-MAC-d-Flow-ID >-----#
    E_DCH_MAC_d_Flow_ID = INT(name=u'E-DCH-MAC-d-Flow-ID', mode=MODE_TYPE)
    E_DCH_MAC_d_Flow_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< ENB-ID >-----#
    ENB_ID = CHOICE(name=u'ENB-ID', mode=MODE_TYPE)
    _ENB_ID_macroENB_ID = BIT_STR(name=u'macroENB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_macroENB_ID._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    _ENB_ID_homeENB_ID = BIT_STR(name=u'homeENB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_homeENB_ID._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    _ENB_ID_short_macroENB_ID = BIT_STR(name=u'short-macroENB-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_short_macroENB_ID._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _ENB_ID_long_macroENB_ID = BIT_STR(name=u'long-macroENB-ID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_long_macroENB_ID._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    ENB_ID._cont = ASN1Dict([
        (u'macroENB-ID', _ENB_ID_macroENB_ID),
        (u'homeENB-ID', _ENB_ID_homeENB_ID),
        (u'short-macroENB-ID', _ENB_ID_short_macroENB_ID),
        (u'long-macroENB-ID', _ENB_ID_long_macroENB_ID),
        ])
    ENB_ID._ext = [u'short-macroENB-ID', u'long-macroENB-ID']
    
    #-----< EncryptionAlgorithm >-----#
    EncryptionAlgorithm = INT(name=u'EncryptionAlgorithm', mode=MODE_TYPE)
    EncryptionAlgorithm._cont = ASN1Dict([(u'no-encryption', 0), (u'standard-UMTS-encryption-algorith-UEA1', 1), (u'standard-UMTS-encryption-algorithm-UEA2', 2)])
    EncryptionAlgorithm._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< EncryptionInformation >-----#
    EncryptionInformation = SEQ(name=u'EncryptionInformation', mode=MODE_TYPE)
    _EncryptionInformation_permittedAlgorithms = SEQ_OF(name=u'permittedAlgorithms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PermittedEncryptionAlgorithms')))
    _EncryptionInformation_key = BIT_STR(name=u'key', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'EncryptionKey')))
    _EncryptionInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EncryptionInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___EncryptionInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EncryptionInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____EncryptionInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EncryptionInformation_iE_Extensions__item__id._const_tab = ____EncryptionInformation_iE_Extensions__item__id_tab
    ___EncryptionInformation_iE_Extensions__item__id._const_tab_at = None
    ___EncryptionInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___EncryptionInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EncryptionInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____EncryptionInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EncryptionInformation_iE_Extensions__item__criticality._const_tab = ____EncryptionInformation_iE_Extensions__item__criticality_tab
    ___EncryptionInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EncryptionInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EncryptionInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EncryptionInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____EncryptionInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EncryptionInformation_iE_Extensions__item__extensionValue._const_tab = ____EncryptionInformation_iE_Extensions__item__extensionValue_tab
    ___EncryptionInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EncryptionInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EncryptionInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EncryptionInformation_iE_Extensions__item__id),
        (u'criticality', ___EncryptionInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___EncryptionInformation_iE_Extensions__item__extensionValue),
        ])
    __EncryptionInformation_iE_Extensions__item_._ext = None
    _EncryptionInformation_iE_Extensions._cont = __EncryptionInformation_iE_Extensions__item_
    _EncryptionInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EncryptionInformation._cont = ASN1Dict([
        (u'permittedAlgorithms', _EncryptionInformation_permittedAlgorithms),
        (u'key', _EncryptionInformation_key),
        (u'iE-Extensions', _EncryptionInformation_iE_Extensions),
        ])
    EncryptionInformation._ext = None
    
    #-----< EncryptionInformation-ExtIEs >-----#
    EncryptionInformation_ExtIEs = CLASS(name=u'EncryptionInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    EncryptionInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EncryptionKey >-----#
    EncryptionKey = BIT_STR(name=u'EncryptionKey', mode=MODE_TYPE)
    EncryptionKey._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    
    #-----< End-Of-CSFB >-----#
    End_Of_CSFB = ENUM(name=u'End-Of-CSFB', mode=MODE_TYPE)
    End_Of_CSFB._cont = ASN1Dict([(u'end-of-CSFB', 0)])
    End_Of_CSFB._ext = []
    
    #-----< EquipmentsToBeTraced >-----#
    EquipmentsToBeTraced = CHOICE(name=u'EquipmentsToBeTraced', mode=MODE_TYPE)
    _EquipmentsToBeTraced_iMEIlist = SEQ_OF(name=u'iMEIlist', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IMEIList')))
    _EquipmentsToBeTraced_iMEISVlist = SEQ_OF(name=u'iMEISVlist', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IMEISVList')))
    _EquipmentsToBeTraced_iMEIgroup = SEQ(name=u'iMEIgroup', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IMEIGroup')))
    _EquipmentsToBeTraced_iMEISVgroup = SEQ(name=u'iMEISVgroup', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IMEISVGroup')))
    EquipmentsToBeTraced._cont = ASN1Dict([
        (u'iMEIlist', _EquipmentsToBeTraced_iMEIlist),
        (u'iMEISVlist', _EquipmentsToBeTraced_iMEISVlist),
        (u'iMEIgroup', _EquipmentsToBeTraced_iMEIgroup),
        (u'iMEISVgroup', _EquipmentsToBeTraced_iMEISVgroup),
        ])
    EquipmentsToBeTraced._ext = []
    
    #-----< E-UTRAN-Service-Handover >-----#
    E_UTRAN_Service_Handover = ENUM(name=u'E-UTRAN-Service-Handover', mode=MODE_TYPE)
    E_UTRAN_Service_Handover._cont = ASN1Dict([(u'handover-to-E-UTRAN-shall-not-be-performed', 0)])
    E_UTRAN_Service_Handover._ext = []
    
    #-----< Event >-----#
    Event = ENUM(name=u'Event', mode=MODE_TYPE)
    Event._cont = ASN1Dict([(u'stop-change-of-service-area', 0), (u'direct', 1), (u'change-of-servicearea', 2), (u'stop-direct', 3), (u'periodic', 4), (u'stop-periodic', 5)])
    Event._ext = [u'stop-direct', u'periodic', u'stop-periodic']
    
    #-----< Event1F-Parameters >-----#
    Event1F_Parameters = SEQ(name=u'Event1F-Parameters', mode=MODE_TYPE)
    _Event1F_Parameters_measurementQuantity = ENUM(name=u'measurementQuantity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'MeasurementQuantity')))
    _Event1F_Parameters_threshold = INT(name=u'threshold', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Event1F_Parameters_threshold._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-120, ub=165)], ev=None, er=[])
    Event1F_Parameters._cont = ASN1Dict([
        (u'measurementQuantity', _Event1F_Parameters_measurementQuantity),
        (u'threshold', _Event1F_Parameters_threshold),
        ])
    Event1F_Parameters._ext = []
    
    #-----< Event1I-Parameters >-----#
    Event1I_Parameters = SEQ(name=u'Event1I-Parameters', mode=MODE_TYPE)
    _Event1I_Parameters_threshold = INT(name=u'threshold', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Event1I_Parameters_threshold._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-120, ub=-25)], ev=None, er=[])
    Event1I_Parameters._cont = ASN1Dict([
        (u'threshold', _Event1I_Parameters_threshold),
        ])
    Event1I_Parameters._ext = []
    
    #-----< ExtendedGuaranteedBitrate >-----#
    ExtendedGuaranteedBitrate = INT(name=u'ExtendedGuaranteedBitrate', mode=MODE_TYPE)
    ExtendedGuaranteedBitrate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=16000001, ub=256000000)], ev=None, er=[])
    
    #-----< ExtendedMaxBitrate >-----#
    ExtendedMaxBitrate = INT(name=u'ExtendedMaxBitrate', mode=MODE_TYPE)
    ExtendedMaxBitrate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=16000001, ub=256000000)], ev=None, er=[])
    
    #-----< ExtendedRNC-ID >-----#
    ExtendedRNC_ID = INT(name=u'ExtendedRNC-ID', mode=MODE_TYPE)
    ExtendedRNC_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4096, ub=65535)], ev=None, er=[])
    
    #-----< FrameSequenceNumber >-----#
    FrameSequenceNumber = INT(name=u'FrameSequenceNumber', mode=MODE_TYPE)
    FrameSequenceNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< FrequenceLayerConvergenceFlag >-----#
    FrequenceLayerConvergenceFlag = ENUM(name=u'FrequenceLayerConvergenceFlag', mode=MODE_TYPE)
    FrequenceLayerConvergenceFlag._cont = ASN1Dict([(u'no-FLC-flag', 0)])
    FrequenceLayerConvergenceFlag._ext = []
    
    #-----< GANSS-PositioningDataSet >-----#
    GANSS_PositioningDataSet = SEQ_OF(name=u'GANSS-PositioningDataSet', mode=MODE_TYPE)
    _GANSS_PositioningDataSet__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GANSS-PositioningMethodAndUsage')))
    GANSS_PositioningDataSet._cont = _GANSS_PositioningDataSet__item_
    GANSS_PositioningDataSet._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< GANSS-PositioningMethodAndUsage >-----#
    GANSS_PositioningMethodAndUsage = OCT_STR(name=u'GANSS-PositioningMethodAndUsage', mode=MODE_TYPE)
    GANSS_PositioningMethodAndUsage._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< GeographicalArea >-----#
    GeographicalArea = CHOICE(name=u'GeographicalArea', mode=MODE_TYPE)
    _GeographicalArea_point = SEQ(name=u'point', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GA-Point')))
    _GeographicalArea_pointWithUnCertainty = SEQ(name=u'pointWithUnCertainty', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GA-PointWithUnCertainty')))
    _GeographicalArea_polygon = SEQ_OF(name=u'polygon', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GA-Polygon')))
    _GeographicalArea_pointWithUncertaintyEllipse = SEQ(name=u'pointWithUncertaintyEllipse', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GA-PointWithUnCertaintyEllipse')))
    _GeographicalArea_pointWithAltitude = SEQ(name=u'pointWithAltitude', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GA-PointWithAltitude')))
    _GeographicalArea_pointWithAltitudeAndUncertaintyEllipsoid = SEQ(name=u'pointWithAltitudeAndUncertaintyEllipsoid', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GA-PointWithAltitudeAndUncertaintyEllipsoid')))
    _GeographicalArea_ellipsoidArc = SEQ(name=u'ellipsoidArc', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GA-EllipsoidArc')))
    GeographicalArea._cont = ASN1Dict([
        (u'point', _GeographicalArea_point),
        (u'pointWithUnCertainty', _GeographicalArea_pointWithUnCertainty),
        (u'polygon', _GeographicalArea_polygon),
        (u'pointWithUncertaintyEllipse', _GeographicalArea_pointWithUncertaintyEllipse),
        (u'pointWithAltitude', _GeographicalArea_pointWithAltitude),
        (u'pointWithAltitudeAndUncertaintyEllipsoid', _GeographicalArea_pointWithAltitudeAndUncertaintyEllipsoid),
        (u'ellipsoidArc', _GeographicalArea_ellipsoidArc),
        ])
    GeographicalArea._ext = [u'pointWithUncertaintyEllipse', u'pointWithAltitude', u'pointWithAltitudeAndUncertaintyEllipsoid', u'ellipsoidArc']
    
    #-----< GeographicalCoordinates >-----#
    GeographicalCoordinates = SEQ(name=u'GeographicalCoordinates', mode=MODE_TYPE)
    _GeographicalCoordinates_latitudeSign = ENUM(name=u'latitudeSign', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeographicalCoordinates_latitudeSign._cont = ASN1Dict([(u'north', 0), (u'south', 1)])
    _GeographicalCoordinates_latitudeSign._ext = None
    _GeographicalCoordinates_latitude = INT(name=u'latitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeographicalCoordinates_latitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8388607)], ev=None, er=[])
    _GeographicalCoordinates_longitude = INT(name=u'longitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeographicalCoordinates_longitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _GeographicalCoordinates_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GeographicalCoordinates_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___GeographicalCoordinates_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GeographicalCoordinates_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GeographicalCoordinates_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeographicalCoordinates_iE_Extensions__item__id._const_tab = ____GeographicalCoordinates_iE_Extensions__item__id_tab
    ___GeographicalCoordinates_iE_Extensions__item__id._const_tab_at = None
    ___GeographicalCoordinates_iE_Extensions__item__id._const_tab_id = u'id'
    ___GeographicalCoordinates_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GeographicalCoordinates_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GeographicalCoordinates_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeographicalCoordinates_iE_Extensions__item__criticality._const_tab = ____GeographicalCoordinates_iE_Extensions__item__criticality_tab
    ___GeographicalCoordinates_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GeographicalCoordinates_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GeographicalCoordinates_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GeographicalCoordinates_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue._const_tab = ____GeographicalCoordinates_iE_Extensions__item__extensionValue_tab
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GeographicalCoordinates_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GeographicalCoordinates_iE_Extensions__item__id),
        (u'criticality', ___GeographicalCoordinates_iE_Extensions__item__criticality),
        (u'extensionValue', ___GeographicalCoordinates_iE_Extensions__item__extensionValue),
        ])
    __GeographicalCoordinates_iE_Extensions__item_._ext = None
    _GeographicalCoordinates_iE_Extensions._cont = __GeographicalCoordinates_iE_Extensions__item_
    _GeographicalCoordinates_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GeographicalCoordinates._cont = ASN1Dict([
        (u'latitudeSign', _GeographicalCoordinates_latitudeSign),
        (u'latitude', _GeographicalCoordinates_latitude),
        (u'longitude', _GeographicalCoordinates_longitude),
        (u'iE-Extensions', _GeographicalCoordinates_iE_Extensions),
        ])
    GeographicalCoordinates._ext = []
    
    #-----< GeographicalCoordinates-ExtIEs >-----#
    GeographicalCoordinates_ExtIEs = CLASS(name=u'GeographicalCoordinates-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    GeographicalCoordinates_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-AltitudeAndDirection >-----#
    GA_AltitudeAndDirection = SEQ(name=u'GA-AltitudeAndDirection', mode=MODE_TYPE)
    _GA_AltitudeAndDirection_directionOfAltitude = ENUM(name=u'directionOfAltitude', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_AltitudeAndDirection_directionOfAltitude._cont = ASN1Dict([(u'height', 0), (u'depth', 1)])
    _GA_AltitudeAndDirection_directionOfAltitude._ext = None
    _GA_AltitudeAndDirection_altitude = INT(name=u'altitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_AltitudeAndDirection_altitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    GA_AltitudeAndDirection._cont = ASN1Dict([
        (u'directionOfAltitude', _GA_AltitudeAndDirection_directionOfAltitude),
        (u'altitude', _GA_AltitudeAndDirection_altitude),
        ])
    GA_AltitudeAndDirection._ext = []
    
    #-----< GA-EllipsoidArc >-----#
    GA_EllipsoidArc = SEQ(name=u'GA-EllipsoidArc', mode=MODE_TYPE)
    _GA_EllipsoidArc_geographicalCoordinates = SEQ(name=u'geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GeographicalCoordinates')))
    _GA_EllipsoidArc_innerRadius = INT(name=u'innerRadius', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_EllipsoidArc_innerRadius._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _GA_EllipsoidArc_uncertaintyRadius = INT(name=u'uncertaintyRadius', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_EllipsoidArc_uncertaintyRadius._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_EllipsoidArc_offsetAngle = INT(name=u'offsetAngle', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_EllipsoidArc_offsetAngle._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    _GA_EllipsoidArc_includedAngle = INT(name=u'includedAngle', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_EllipsoidArc_includedAngle._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    _GA_EllipsoidArc_confidence = INT(name=u'confidence', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_EllipsoidArc_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_EllipsoidArc_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GA_EllipsoidArc_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___GA_EllipsoidArc_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GA_EllipsoidArc_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_EllipsoidArc_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_EllipsoidArc_iE_Extensions__item__id._const_tab = ____GA_EllipsoidArc_iE_Extensions__item__id_tab
    ___GA_EllipsoidArc_iE_Extensions__item__id._const_tab_at = None
    ___GA_EllipsoidArc_iE_Extensions__item__id._const_tab_id = u'id'
    ___GA_EllipsoidArc_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GA_EllipsoidArc_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_EllipsoidArc_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_EllipsoidArc_iE_Extensions__item__criticality._const_tab = ____GA_EllipsoidArc_iE_Extensions__item__criticality_tab
    ___GA_EllipsoidArc_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GA_EllipsoidArc_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GA_EllipsoidArc_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GA_EllipsoidArc_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_EllipsoidArc_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_EllipsoidArc_iE_Extensions__item__extensionValue._const_tab = ____GA_EllipsoidArc_iE_Extensions__item__extensionValue_tab
    ___GA_EllipsoidArc_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GA_EllipsoidArc_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GA_EllipsoidArc_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GA_EllipsoidArc_iE_Extensions__item__id),
        (u'criticality', ___GA_EllipsoidArc_iE_Extensions__item__criticality),
        (u'extensionValue', ___GA_EllipsoidArc_iE_Extensions__item__extensionValue),
        ])
    __GA_EllipsoidArc_iE_Extensions__item_._ext = None
    _GA_EllipsoidArc_iE_Extensions._cont = __GA_EllipsoidArc_iE_Extensions__item_
    _GA_EllipsoidArc_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GA_EllipsoidArc._cont = ASN1Dict([
        (u'geographicalCoordinates', _GA_EllipsoidArc_geographicalCoordinates),
        (u'innerRadius', _GA_EllipsoidArc_innerRadius),
        (u'uncertaintyRadius', _GA_EllipsoidArc_uncertaintyRadius),
        (u'offsetAngle', _GA_EllipsoidArc_offsetAngle),
        (u'includedAngle', _GA_EllipsoidArc_includedAngle),
        (u'confidence', _GA_EllipsoidArc_confidence),
        (u'iE-Extensions', _GA_EllipsoidArc_iE_Extensions),
        ])
    GA_EllipsoidArc._ext = []
    
    #-----< GA-EllipsoidArc-ExtIEs >-----#
    GA_EllipsoidArc_ExtIEs = CLASS(name=u'GA-EllipsoidArc-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    GA_EllipsoidArc_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-Point >-----#
    GA_Point = SEQ(name=u'GA-Point', mode=MODE_TYPE)
    _GA_Point_geographicalCoordinates = SEQ(name=u'geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GeographicalCoordinates')))
    _GA_Point_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GA_Point_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___GA_Point_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GA_Point_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_Point_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_Point_iE_Extensions__item__id._const_tab = ____GA_Point_iE_Extensions__item__id_tab
    ___GA_Point_iE_Extensions__item__id._const_tab_at = None
    ___GA_Point_iE_Extensions__item__id._const_tab_id = u'id'
    ___GA_Point_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GA_Point_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_Point_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_Point_iE_Extensions__item__criticality._const_tab = ____GA_Point_iE_Extensions__item__criticality_tab
    ___GA_Point_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GA_Point_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GA_Point_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GA_Point_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_Point_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_Point_iE_Extensions__item__extensionValue._const_tab = ____GA_Point_iE_Extensions__item__extensionValue_tab
    ___GA_Point_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GA_Point_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GA_Point_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GA_Point_iE_Extensions__item__id),
        (u'criticality', ___GA_Point_iE_Extensions__item__criticality),
        (u'extensionValue', ___GA_Point_iE_Extensions__item__extensionValue),
        ])
    __GA_Point_iE_Extensions__item_._ext = None
    _GA_Point_iE_Extensions._cont = __GA_Point_iE_Extensions__item_
    _GA_Point_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GA_Point._cont = ASN1Dict([
        (u'geographicalCoordinates', _GA_Point_geographicalCoordinates),
        (u'iE-Extensions', _GA_Point_iE_Extensions),
        ])
    GA_Point._ext = []
    
    #-----< GA-Point-ExtIEs >-----#
    GA_Point_ExtIEs = CLASS(name=u'GA-Point-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    GA_Point_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-PointWithAltitude >-----#
    GA_PointWithAltitude = SEQ(name=u'GA-PointWithAltitude', mode=MODE_TYPE)
    _GA_PointWithAltitude_geographicalCoordinates = SEQ(name=u'geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GeographicalCoordinates')))
    _GA_PointWithAltitude_altitudeAndDirection = SEQ(name=u'altitudeAndDirection', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GA-AltitudeAndDirection')))
    _GA_PointWithAltitude_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GA_PointWithAltitude_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___GA_PointWithAltitude_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GA_PointWithAltitude_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithAltitude_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithAltitude_iE_Extensions__item__id._const_tab = ____GA_PointWithAltitude_iE_Extensions__item__id_tab
    ___GA_PointWithAltitude_iE_Extensions__item__id._const_tab_at = None
    ___GA_PointWithAltitude_iE_Extensions__item__id._const_tab_id = u'id'
    ___GA_PointWithAltitude_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GA_PointWithAltitude_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithAltitude_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithAltitude_iE_Extensions__item__criticality._const_tab = ____GA_PointWithAltitude_iE_Extensions__item__criticality_tab
    ___GA_PointWithAltitude_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GA_PointWithAltitude_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GA_PointWithAltitude_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GA_PointWithAltitude_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithAltitude_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithAltitude_iE_Extensions__item__extensionValue._const_tab = ____GA_PointWithAltitude_iE_Extensions__item__extensionValue_tab
    ___GA_PointWithAltitude_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GA_PointWithAltitude_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GA_PointWithAltitude_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GA_PointWithAltitude_iE_Extensions__item__id),
        (u'criticality', ___GA_PointWithAltitude_iE_Extensions__item__criticality),
        (u'extensionValue', ___GA_PointWithAltitude_iE_Extensions__item__extensionValue),
        ])
    __GA_PointWithAltitude_iE_Extensions__item_._ext = None
    _GA_PointWithAltitude_iE_Extensions._cont = __GA_PointWithAltitude_iE_Extensions__item_
    _GA_PointWithAltitude_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GA_PointWithAltitude._cont = ASN1Dict([
        (u'geographicalCoordinates', _GA_PointWithAltitude_geographicalCoordinates),
        (u'altitudeAndDirection', _GA_PointWithAltitude_altitudeAndDirection),
        (u'iE-Extensions', _GA_PointWithAltitude_iE_Extensions),
        ])
    GA_PointWithAltitude._ext = []
    
    #-----< GA-PointWithAltitude-ExtIEs >-----#
    GA_PointWithAltitude_ExtIEs = CLASS(name=u'GA-PointWithAltitude-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    GA_PointWithAltitude_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-PointWithAltitudeAndUncertaintyEllipsoid >-----#
    GA_PointWithAltitudeAndUncertaintyEllipsoid = SEQ(name=u'GA-PointWithAltitudeAndUncertaintyEllipsoid', mode=MODE_TYPE)
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_geographicalCoordinates = SEQ(name=u'geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GeographicalCoordinates')))
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_altitudeAndDirection = SEQ(name=u'altitudeAndDirection', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GA-AltitudeAndDirection')))
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyEllipse = SEQ(name=u'uncertaintyEllipse', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GA-UncertaintyEllipse')))
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyAltitude = INT(name=u'uncertaintyAltitude', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyAltitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_confidence = INT(name=u'confidence', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id._const_tab = ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id_tab
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id._const_tab_at = None
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id._const_tab_id = u'id'
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality._const_tab = ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality_tab
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue._const_tab = ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue_tab
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id),
        (u'criticality', ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality),
        (u'extensionValue', ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue),
        ])
    __GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item_._ext = None
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions._cont = __GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item_
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GA_PointWithAltitudeAndUncertaintyEllipsoid._cont = ASN1Dict([
        (u'geographicalCoordinates', _GA_PointWithAltitudeAndUncertaintyEllipsoid_geographicalCoordinates),
        (u'altitudeAndDirection', _GA_PointWithAltitudeAndUncertaintyEllipsoid_altitudeAndDirection),
        (u'uncertaintyEllipse', _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyEllipse),
        (u'uncertaintyAltitude', _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyAltitude),
        (u'confidence', _GA_PointWithAltitudeAndUncertaintyEllipsoid_confidence),
        (u'iE-Extensions', _GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions),
        ])
    GA_PointWithAltitudeAndUncertaintyEllipsoid._ext = []
    
    #-----< GA-PointWithAltitudeAndUncertaintyEllipsoid-ExtIEs >-----#
    GA_PointWithAltitudeAndUncertaintyEllipsoid_ExtIEs = CLASS(name=u'GA-PointWithAltitudeAndUncertaintyEllipsoid-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    GA_PointWithAltitudeAndUncertaintyEllipsoid_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-PointWithUnCertainty >-----#
    GA_PointWithUnCertainty = SEQ(name=u'GA-PointWithUnCertainty', mode=MODE_TYPE)
    _GA_PointWithUnCertainty_geographicalCoordinates = SEQ(name=u'geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GeographicalCoordinates')))
    _GA_PointWithUnCertainty_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GA_PointWithUnCertainty_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___GA_PointWithUnCertainty_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GA_PointWithUnCertainty_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithUnCertainty_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithUnCertainty_iE_Extensions__item__id._const_tab = ____GA_PointWithUnCertainty_iE_Extensions__item__id_tab
    ___GA_PointWithUnCertainty_iE_Extensions__item__id._const_tab_at = None
    ___GA_PointWithUnCertainty_iE_Extensions__item__id._const_tab_id = u'id'
    ___GA_PointWithUnCertainty_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GA_PointWithUnCertainty_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithUnCertainty_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithUnCertainty_iE_Extensions__item__criticality._const_tab = ____GA_PointWithUnCertainty_iE_Extensions__item__criticality_tab
    ___GA_PointWithUnCertainty_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GA_PointWithUnCertainty_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GA_PointWithUnCertainty_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GA_PointWithUnCertainty_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithUnCertainty_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithUnCertainty_iE_Extensions__item__extensionValue._const_tab = ____GA_PointWithUnCertainty_iE_Extensions__item__extensionValue_tab
    ___GA_PointWithUnCertainty_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GA_PointWithUnCertainty_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GA_PointWithUnCertainty_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GA_PointWithUnCertainty_iE_Extensions__item__id),
        (u'criticality', ___GA_PointWithUnCertainty_iE_Extensions__item__criticality),
        (u'extensionValue', ___GA_PointWithUnCertainty_iE_Extensions__item__extensionValue),
        ])
    __GA_PointWithUnCertainty_iE_Extensions__item_._ext = None
    _GA_PointWithUnCertainty_iE_Extensions._cont = __GA_PointWithUnCertainty_iE_Extensions__item_
    _GA_PointWithUnCertainty_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _GA_PointWithUnCertainty_uncertaintyCode = INT(name=u'uncertaintyCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_PointWithUnCertainty_uncertaintyCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    GA_PointWithUnCertainty._cont = ASN1Dict([
        (u'geographicalCoordinates', _GA_PointWithUnCertainty_geographicalCoordinates),
        (u'iE-Extensions', _GA_PointWithUnCertainty_iE_Extensions),
        (u'uncertaintyCode', _GA_PointWithUnCertainty_uncertaintyCode),
        ])
    GA_PointWithUnCertainty._ext = None
    
    #-----< GA-PointWithUnCertainty-ExtIEs >-----#
    GA_PointWithUnCertainty_ExtIEs = CLASS(name=u'GA-PointWithUnCertainty-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    GA_PointWithUnCertainty_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-PointWithUnCertaintyEllipse >-----#
    GA_PointWithUnCertaintyEllipse = SEQ(name=u'GA-PointWithUnCertaintyEllipse', mode=MODE_TYPE)
    _GA_PointWithUnCertaintyEllipse_geographicalCoordinates = SEQ(name=u'geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GeographicalCoordinates')))
    _GA_PointWithUnCertaintyEllipse_uncertaintyEllipse = SEQ(name=u'uncertaintyEllipse', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GA-UncertaintyEllipse')))
    _GA_PointWithUnCertaintyEllipse_confidence = INT(name=u'confidence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_PointWithUnCertaintyEllipse_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_PointWithUnCertaintyEllipse_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GA_PointWithUnCertaintyEllipse_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id._const_tab = ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id_tab
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id._const_tab_at = None
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id._const_tab_id = u'id'
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality._const_tab = ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality_tab
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue._const_tab = ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue_tab
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GA_PointWithUnCertaintyEllipse_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id),
        (u'criticality', ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality),
        (u'extensionValue', ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue),
        ])
    __GA_PointWithUnCertaintyEllipse_iE_Extensions__item_._ext = None
    _GA_PointWithUnCertaintyEllipse_iE_Extensions._cont = __GA_PointWithUnCertaintyEllipse_iE_Extensions__item_
    _GA_PointWithUnCertaintyEllipse_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GA_PointWithUnCertaintyEllipse._cont = ASN1Dict([
        (u'geographicalCoordinates', _GA_PointWithUnCertaintyEllipse_geographicalCoordinates),
        (u'uncertaintyEllipse', _GA_PointWithUnCertaintyEllipse_uncertaintyEllipse),
        (u'confidence', _GA_PointWithUnCertaintyEllipse_confidence),
        (u'iE-Extensions', _GA_PointWithUnCertaintyEllipse_iE_Extensions),
        ])
    GA_PointWithUnCertaintyEllipse._ext = []
    
    #-----< GA-PointWithUnCertaintyEllipse-ExtIEs >-----#
    GA_PointWithUnCertaintyEllipse_ExtIEs = CLASS(name=u'GA-PointWithUnCertaintyEllipse-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    GA_PointWithUnCertaintyEllipse_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-Polygon >-----#
    GA_Polygon = SEQ_OF(name=u'GA-Polygon', mode=MODE_TYPE)
    _GA_Polygon__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GA_Polygon__item__geographicalCoordinates = SEQ(name=u'geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GeographicalCoordinates')))
    __GA_Polygon__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___GA_Polygon__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____GA_Polygon__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    _____GA_Polygon__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____GA_Polygon__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GA_Polygon__item__iE_Extensions__item__id._const_tab = _____GA_Polygon__item__iE_Extensions__item__id_tab
    ____GA_Polygon__item__iE_Extensions__item__id._const_tab_at = None
    ____GA_Polygon__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____GA_Polygon__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____GA_Polygon__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____GA_Polygon__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GA_Polygon__item__iE_Extensions__item__criticality._const_tab = _____GA_Polygon__item__iE_Extensions__item__criticality_tab
    ____GA_Polygon__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____GA_Polygon__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____GA_Polygon__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____GA_Polygon__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____GA_Polygon__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GA_Polygon__item__iE_Extensions__item__extensionValue._const_tab = _____GA_Polygon__item__iE_Extensions__item__extensionValue_tab
    ____GA_Polygon__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____GA_Polygon__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___GA_Polygon__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____GA_Polygon__item__iE_Extensions__item__id),
        (u'criticality', ____GA_Polygon__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____GA_Polygon__item__iE_Extensions__item__extensionValue),
        ])
    ___GA_Polygon__item__iE_Extensions__item_._ext = None
    __GA_Polygon__item__iE_Extensions._cont = ___GA_Polygon__item__iE_Extensions__item_
    __GA_Polygon__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _GA_Polygon__item_._cont = ASN1Dict([
        (u'geographicalCoordinates', __GA_Polygon__item__geographicalCoordinates),
        (u'iE-Extensions', __GA_Polygon__item__iE_Extensions),
        ])
    _GA_Polygon__item_._ext = []
    GA_Polygon._cont = _GA_Polygon__item_
    GA_Polygon._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< GA-Polygon-ExtIEs >-----#
    GA_Polygon_ExtIEs = CLASS(name=u'GA-Polygon-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    GA_Polygon_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-UncertaintyEllipse >-----#
    GA_UncertaintyEllipse = SEQ(name=u'GA-UncertaintyEllipse', mode=MODE_TYPE)
    _GA_UncertaintyEllipse_uncertaintySemi_major = INT(name=u'uncertaintySemi-major', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_UncertaintyEllipse_uncertaintySemi_major._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_UncertaintyEllipse_uncertaintySemi_minor = INT(name=u'uncertaintySemi-minor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_UncertaintyEllipse_uncertaintySemi_minor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_UncertaintyEllipse_orientationOfMajorAxis = INT(name=u'orientationOfMajorAxis', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_UncertaintyEllipse_orientationOfMajorAxis._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    GA_UncertaintyEllipse._cont = ASN1Dict([
        (u'uncertaintySemi-major', _GA_UncertaintyEllipse_uncertaintySemi_major),
        (u'uncertaintySemi-minor', _GA_UncertaintyEllipse_uncertaintySemi_minor),
        (u'orientationOfMajorAxis', _GA_UncertaintyEllipse_orientationOfMajorAxis),
        ])
    GA_UncertaintyEllipse._ext = []
    
    #-----< GERAN-BSC-Container >-----#
    GERAN_BSC_Container = OCT_STR(name=u'GERAN-BSC-Container', mode=MODE_TYPE)
    
    #-----< GERAN-Cell-ID >-----#
    GERAN_Cell_ID = SEQ(name=u'GERAN-Cell-ID', mode=MODE_TYPE)
    _GERAN_Cell_ID_lAI = SEQ(name=u'lAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LAI')))
    _GERAN_Cell_ID_rAC = OCT_STR(name=u'rAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAC')))
    _GERAN_Cell_ID_cI = OCT_STR(name=u'cI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CI')))
    _GERAN_Cell_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GERAN_Cell_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___GERAN_Cell_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GERAN_Cell_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GERAN_Cell_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GERAN_Cell_ID_iE_Extensions__item__id._const_tab = ____GERAN_Cell_ID_iE_Extensions__item__id_tab
    ___GERAN_Cell_ID_iE_Extensions__item__id._const_tab_at = None
    ___GERAN_Cell_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___GERAN_Cell_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GERAN_Cell_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GERAN_Cell_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GERAN_Cell_ID_iE_Extensions__item__criticality._const_tab = ____GERAN_Cell_ID_iE_Extensions__item__criticality_tab
    ___GERAN_Cell_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GERAN_Cell_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GERAN_Cell_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GERAN_Cell_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GERAN_Cell_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GERAN_Cell_ID_iE_Extensions__item__extensionValue._const_tab = ____GERAN_Cell_ID_iE_Extensions__item__extensionValue_tab
    ___GERAN_Cell_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GERAN_Cell_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GERAN_Cell_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GERAN_Cell_ID_iE_Extensions__item__id),
        (u'criticality', ___GERAN_Cell_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___GERAN_Cell_ID_iE_Extensions__item__extensionValue),
        ])
    __GERAN_Cell_ID_iE_Extensions__item_._ext = None
    _GERAN_Cell_ID_iE_Extensions._cont = __GERAN_Cell_ID_iE_Extensions__item_
    _GERAN_Cell_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GERAN_Cell_ID._cont = ASN1Dict([
        (u'lAI', _GERAN_Cell_ID_lAI),
        (u'rAC', _GERAN_Cell_ID_rAC),
        (u'cI', _GERAN_Cell_ID_cI),
        (u'iE-Extensions', _GERAN_Cell_ID_iE_Extensions),
        ])
    GERAN_Cell_ID._ext = None
    
    #-----< GERAN-Cell-ID-ExtIEs >-----#
    GERAN_Cell_ID_ExtIEs = CLASS(name=u'GERAN-Cell-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    GERAN_Cell_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GERAN-Classmark >-----#
    GERAN_Classmark = OCT_STR(name=u'GERAN-Classmark', mode=MODE_TYPE)
    
    #-----< GlobalCN-ID >-----#
    GlobalCN_ID = SEQ(name=u'GlobalCN-ID', mode=MODE_TYPE)
    _GlobalCN_ID_pLMNidentity = OCT_STR(name=u'pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _GlobalCN_ID_cN_ID = INT(name=u'cN-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CN-ID')))
    GlobalCN_ID._cont = ASN1Dict([
        (u'pLMNidentity', _GlobalCN_ID_pLMNidentity),
        (u'cN-ID', _GlobalCN_ID_cN_ID),
        ])
    GlobalCN_ID._ext = None
    
    #-----< GlobalRNC-ID >-----#
    GlobalRNC_ID = SEQ(name=u'GlobalRNC-ID', mode=MODE_TYPE)
    _GlobalRNC_ID_pLMNidentity = OCT_STR(name=u'pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _GlobalRNC_ID_rNC_ID = INT(name=u'rNC-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RNC-ID')))
    GlobalRNC_ID._cont = ASN1Dict([
        (u'pLMNidentity', _GlobalRNC_ID_pLMNidentity),
        (u'rNC-ID', _GlobalRNC_ID_rNC_ID),
        ])
    GlobalRNC_ID._ext = None
    
    #-----< GTP-TEI >-----#
    GTP_TEI = OCT_STR(name=u'GTP-TEI', mode=MODE_TYPE)
    GTP_TEI._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< GuaranteedBitrate >-----#
    GuaranteedBitrate = INT(name=u'GuaranteedBitrate', mode=MODE_TYPE)
    GuaranteedBitrate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16000000)], ev=None, er=[])
    
    #-----< HigherBitratesThan16MbpsFlag >-----#
    HigherBitratesThan16MbpsFlag = ENUM(name=u'HigherBitratesThan16MbpsFlag', mode=MODE_TYPE)
    HigherBitratesThan16MbpsFlag._cont = ASN1Dict([(u'allowed', 0), (u'not-allowed', 1)])
    HigherBitratesThan16MbpsFlag._ext = []
    
    #-----< HS-DSCH-MAC-d-Flow-ID >-----#
    HS_DSCH_MAC_d_Flow_ID = INT(name=u'HS-DSCH-MAC-d-Flow-ID', mode=MODE_TYPE)
    HS_DSCH_MAC_d_Flow_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< IMEI >-----#
    IMEI = OCT_STR(name=u'IMEI', mode=MODE_TYPE)
    IMEI._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< IMEIGroup >-----#
    IMEIGroup = SEQ(name=u'IMEIGroup', mode=MODE_TYPE)
    _IMEIGroup_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IMEI')))
    _IMEIGroup_iMEIMask = BIT_STR(name=u'iMEIMask', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IMEIGroup_iMEIMask._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    _IMEIGroup_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IMEIGroup_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___IMEIGroup_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____IMEIGroup_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____IMEIGroup_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IMEIGroup_iE_Extensions__item__id._const_tab = ____IMEIGroup_iE_Extensions__item__id_tab
    ___IMEIGroup_iE_Extensions__item__id._const_tab_at = None
    ___IMEIGroup_iE_Extensions__item__id._const_tab_id = u'id'
    ___IMEIGroup_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IMEIGroup_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____IMEIGroup_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IMEIGroup_iE_Extensions__item__criticality._const_tab = ____IMEIGroup_iE_Extensions__item__criticality_tab
    ___IMEIGroup_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IMEIGroup_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IMEIGroup_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IMEIGroup_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____IMEIGroup_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IMEIGroup_iE_Extensions__item__extensionValue._const_tab = ____IMEIGroup_iE_Extensions__item__extensionValue_tab
    ___IMEIGroup_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IMEIGroup_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IMEIGroup_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IMEIGroup_iE_Extensions__item__id),
        (u'criticality', ___IMEIGroup_iE_Extensions__item__criticality),
        (u'extensionValue', ___IMEIGroup_iE_Extensions__item__extensionValue),
        ])
    __IMEIGroup_iE_Extensions__item_._ext = None
    _IMEIGroup_iE_Extensions._cont = __IMEIGroup_iE_Extensions__item_
    _IMEIGroup_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IMEIGroup._cont = ASN1Dict([
        (u'iMEI', _IMEIGroup_iMEI),
        (u'iMEIMask', _IMEIGroup_iMEIMask),
        (u'iE-Extensions', _IMEIGroup_iE_Extensions),
        ])
    IMEIGroup._ext = None
    
    #-----< IMEIGroup-ExtIEs >-----#
    IMEIGroup_ExtIEs = CLASS(name=u'IMEIGroup-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    IMEIGroup_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IMEIList >-----#
    IMEIList = SEQ_OF(name=u'IMEIList', mode=MODE_TYPE)
    _IMEIList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IMEI')))
    IMEIList._cont = _IMEIList__item_
    IMEIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< IMEISV >-----#
    IMEISV = OCT_STR(name=u'IMEISV', mode=MODE_TYPE)
    IMEISV._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< IMEISVGroup >-----#
    IMEISVGroup = SEQ(name=u'IMEISVGroup', mode=MODE_TYPE)
    _IMEISVGroup_iMEISV = OCT_STR(name=u'iMEISV', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IMEISV')))
    _IMEISVGroup_iMEISVMask = BIT_STR(name=u'iMEISVMask', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IMEISVGroup_iMEISVMask._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    _IMEISVGroup_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IMEISVGroup_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___IMEISVGroup_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____IMEISVGroup_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____IMEISVGroup_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IMEISVGroup_iE_Extensions__item__id._const_tab = ____IMEISVGroup_iE_Extensions__item__id_tab
    ___IMEISVGroup_iE_Extensions__item__id._const_tab_at = None
    ___IMEISVGroup_iE_Extensions__item__id._const_tab_id = u'id'
    ___IMEISVGroup_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IMEISVGroup_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____IMEISVGroup_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IMEISVGroup_iE_Extensions__item__criticality._const_tab = ____IMEISVGroup_iE_Extensions__item__criticality_tab
    ___IMEISVGroup_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IMEISVGroup_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IMEISVGroup_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IMEISVGroup_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____IMEISVGroup_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IMEISVGroup_iE_Extensions__item__extensionValue._const_tab = ____IMEISVGroup_iE_Extensions__item__extensionValue_tab
    ___IMEISVGroup_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IMEISVGroup_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IMEISVGroup_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IMEISVGroup_iE_Extensions__item__id),
        (u'criticality', ___IMEISVGroup_iE_Extensions__item__criticality),
        (u'extensionValue', ___IMEISVGroup_iE_Extensions__item__extensionValue),
        ])
    __IMEISVGroup_iE_Extensions__item_._ext = None
    _IMEISVGroup_iE_Extensions._cont = __IMEISVGroup_iE_Extensions__item_
    _IMEISVGroup_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IMEISVGroup._cont = ASN1Dict([
        (u'iMEISV', _IMEISVGroup_iMEISV),
        (u'iMEISVMask', _IMEISVGroup_iMEISVMask),
        (u'iE-Extensions', _IMEISVGroup_iE_Extensions),
        ])
    IMEISVGroup._ext = None
    
    #-----< IMEISVGroup-ExtIEs >-----#
    IMEISVGroup_ExtIEs = CLASS(name=u'IMEISVGroup-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    IMEISVGroup_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IMEISVList >-----#
    IMEISVList = SEQ_OF(name=u'IMEISVList', mode=MODE_TYPE)
    _IMEISVList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IMEISV')))
    IMEISVList._cont = _IMEISVList__item_
    IMEISVList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< ImmediateMDT >-----#
    ImmediateMDT = SEQ(name=u'ImmediateMDT', mode=MODE_TYPE)
    _ImmediateMDT_measurementsToActivate = BIT_STR(name=u'measurementsToActivate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'MeasurementsToActivate')))
    _ImmediateMDT_m1report = CHOICE(name=u'm1report', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'M1Report')), opt=True)
    _ImmediateMDT_m2report = CHOICE(name=u'm2report', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'M2Report')), opt=True)
    _ImmediateMDT_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ImmediateMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___ImmediateMDT_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ImmediateMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'M4Report')))
    _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'M5Report')))
    _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'M6Report')))
    _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'M7Report')))
    ____ImmediateMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 265), (u'criticality', u'ignore'), (u'Extension', _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 266), (u'criticality', u'ignore'), (u'Extension', _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 267), (u'criticality', u'ignore'), (u'Extension', _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 268), (u'criticality', u'ignore'), (u'Extension', _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ImmediateMDT_iE_Extensions__item__id._const_tab = ____ImmediateMDT_iE_Extensions__item__id_tab
    ___ImmediateMDT_iE_Extensions__item__id._const_tab_at = None
    ___ImmediateMDT_iE_Extensions__item__id._const_tab_id = u'id'
    ___ImmediateMDT_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ImmediateMDT_iE_Extensions__item__criticality._const_tab = ____ImmediateMDT_iE_Extensions__item__id_tab
    ___ImmediateMDT_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ImmediateMDT_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ImmediateMDT_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ImmediateMDT_iE_Extensions__item__extensionValue._const_tab = ____ImmediateMDT_iE_Extensions__item__id_tab
    ___ImmediateMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ImmediateMDT_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ImmediateMDT_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ImmediateMDT_iE_Extensions__item__id),
        (u'criticality', ___ImmediateMDT_iE_Extensions__item__criticality),
        (u'extensionValue', ___ImmediateMDT_iE_Extensions__item__extensionValue),
        ])
    __ImmediateMDT_iE_Extensions__item_._ext = None
    _ImmediateMDT_iE_Extensions._cont = __ImmediateMDT_iE_Extensions__item_
    _ImmediateMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ImmediateMDT._cont = ASN1Dict([
        (u'measurementsToActivate', _ImmediateMDT_measurementsToActivate),
        (u'm1report', _ImmediateMDT_m1report),
        (u'm2report', _ImmediateMDT_m2report),
        (u'iE-Extensions', _ImmediateMDT_iE_Extensions),
        ])
    ImmediateMDT._ext = [u'iE-Extensions']
    
    #-----< ImmediateMDT-ExtIEs >-----#
    ImmediateMDT_ExtIEs = CLASS(name=u'ImmediateMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _ImmediateMDT_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'M4Report')))
    _ImmediateMDT_ExtIEs_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'M5Report')))
    _ImmediateMDT_ExtIEs_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'M6Report')))
    _ImmediateMDT_ExtIEs_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'M7Report')))
    ImmediateMDT_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 265), (u'criticality', u'ignore'), (u'Extension', _ImmediateMDT_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 266), (u'criticality', u'ignore'), (u'Extension', _ImmediateMDT_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 267), (u'criticality', u'ignore'), (u'Extension', _ImmediateMDT_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 268), (u'criticality', u'ignore'), (u'Extension', _ImmediateMDT_ExtIEs_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< IMSI >-----#
    IMSI = OCT_STR(name=u'IMSI', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TBCD-STRING')))
    IMSI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< IncludeVelocity >-----#
    IncludeVelocity = ENUM(name=u'IncludeVelocity', mode=MODE_TYPE)
    IncludeVelocity._cont = ASN1Dict([(u'requested', 0)])
    IncludeVelocity._ext = None
    
    #-----< InformationExchangeID >-----#
    InformationExchangeID = INT(name=u'InformationExchangeID', mode=MODE_TYPE)
    InformationExchangeID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=None, er=[])
    
    #-----< InformationExchangeType >-----#
    InformationExchangeType = ENUM(name=u'InformationExchangeType', mode=MODE_TYPE)
    InformationExchangeType._cont = ASN1Dict([(u'transfer', 0), (u'request', 1)])
    InformationExchangeType._ext = []
    
    #-----< InformationRequested >-----#
    InformationRequested = CHOICE(name=u'InformationRequested', mode=MODE_TYPE)
    _InformationRequested_requestedMBMSIPMulticastAddressandAPNRequest = SEQ_OF(name=u'requestedMBMSIPMulticastAddressandAPNRequest', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RequestedMBMSIPMulticastAddressandAPNRequest')))
    _InformationRequested_requestedMulticastServiceList = SEQ_OF(name=u'requestedMulticastServiceList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RequestedMulticastServiceList')))
    InformationRequested._cont = ASN1Dict([
        (u'requestedMBMSIPMulticastAddressandAPNRequest', _InformationRequested_requestedMBMSIPMulticastAddressandAPNRequest),
        (u'requestedMulticastServiceList', _InformationRequested_requestedMulticastServiceList),
        ])
    InformationRequested._ext = []
    
    #-----< InformationRequestType >-----#
    InformationRequestType = CHOICE(name=u'InformationRequestType', mode=MODE_TYPE)
    _InformationRequestType_mBMSIPMulticastAddressandAPNRequest = SEQ_OF(name=u'mBMSIPMulticastAddressandAPNRequest', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'MBMSIPMulticastAddressandAPNRequest')))
    _InformationRequestType_permanentNAS_UE_ID = CHOICE(name=u'permanentNAS-UE-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    InformationRequestType._cont = ASN1Dict([
        (u'mBMSIPMulticastAddressandAPNRequest', _InformationRequestType_mBMSIPMulticastAddressandAPNRequest),
        (u'permanentNAS-UE-ID', _InformationRequestType_permanentNAS_UE_ID),
        ])
    InformationRequestType._ext = []
    
    #-----< InformationTransferID >-----#
    InformationTransferID = INT(name=u'InformationTransferID', mode=MODE_TYPE)
    InformationTransferID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=None, er=[])
    
    #-----< InformationTransferType >-----#
    InformationTransferType = CHOICE(name=u'InformationTransferType', mode=MODE_TYPE)
    _InformationTransferType_rNCTraceInformation = SEQ(name=u'rNCTraceInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RNCTraceInformation')))
    InformationTransferType._cont = ASN1Dict([
        (u'rNCTraceInformation', _InformationTransferType_rNCTraceInformation),
        ])
    InformationTransferType._ext = []
    
    #-----< IntegrityProtectionAlgorithm >-----#
    IntegrityProtectionAlgorithm = INT(name=u'IntegrityProtectionAlgorithm', mode=MODE_TYPE)
    IntegrityProtectionAlgorithm._cont = ASN1Dict([(u'standard-UMTS-integrity-algorithm-UIA1', 0), (u'standard-UMTS-integrity-algorithm-UIA2', 1), (u'no-value', 15)])
    IntegrityProtectionAlgorithm._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< IntegrityProtectionInformation >-----#
    IntegrityProtectionInformation = SEQ(name=u'IntegrityProtectionInformation', mode=MODE_TYPE)
    _IntegrityProtectionInformation_permittedAlgorithms = SEQ_OF(name=u'permittedAlgorithms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PermittedIntegrityProtectionAlgorithms')))
    _IntegrityProtectionInformation_key = BIT_STR(name=u'key', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IntegrityProtectionKey')))
    _IntegrityProtectionInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IntegrityProtectionInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___IntegrityProtectionInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____IntegrityProtectionInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____IntegrityProtectionInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntegrityProtectionInformation_iE_Extensions__item__id._const_tab = ____IntegrityProtectionInformation_iE_Extensions__item__id_tab
    ___IntegrityProtectionInformation_iE_Extensions__item__id._const_tab_at = None
    ___IntegrityProtectionInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___IntegrityProtectionInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IntegrityProtectionInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____IntegrityProtectionInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntegrityProtectionInformation_iE_Extensions__item__criticality._const_tab = ____IntegrityProtectionInformation_iE_Extensions__item__criticality_tab
    ___IntegrityProtectionInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IntegrityProtectionInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IntegrityProtectionInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IntegrityProtectionInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____IntegrityProtectionInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntegrityProtectionInformation_iE_Extensions__item__extensionValue._const_tab = ____IntegrityProtectionInformation_iE_Extensions__item__extensionValue_tab
    ___IntegrityProtectionInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IntegrityProtectionInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IntegrityProtectionInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IntegrityProtectionInformation_iE_Extensions__item__id),
        (u'criticality', ___IntegrityProtectionInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___IntegrityProtectionInformation_iE_Extensions__item__extensionValue),
        ])
    __IntegrityProtectionInformation_iE_Extensions__item_._ext = None
    _IntegrityProtectionInformation_iE_Extensions._cont = __IntegrityProtectionInformation_iE_Extensions__item_
    _IntegrityProtectionInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IntegrityProtectionInformation._cont = ASN1Dict([
        (u'permittedAlgorithms', _IntegrityProtectionInformation_permittedAlgorithms),
        (u'key', _IntegrityProtectionInformation_key),
        (u'iE-Extensions', _IntegrityProtectionInformation_iE_Extensions),
        ])
    IntegrityProtectionInformation._ext = None
    
    #-----< IntegrityProtectionInformation-ExtIEs >-----#
    IntegrityProtectionInformation_ExtIEs = CLASS(name=u'IntegrityProtectionInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    IntegrityProtectionInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntegrityProtectionKey >-----#
    IntegrityProtectionKey = BIT_STR(name=u'IntegrityProtectionKey', mode=MODE_TYPE)
    IntegrityProtectionKey._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    
    #-----< InterSystemInformationTransferType >-----#
    InterSystemInformationTransferType = CHOICE(name=u'InterSystemInformationTransferType', mode=MODE_TYPE)
    _InterSystemInformationTransferType_rIM_Transfer = SEQ(name=u'rIM-Transfer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RIM-Transfer')))
    InterSystemInformationTransferType._cont = ASN1Dict([
        (u'rIM-Transfer', _InterSystemInformationTransferType_rIM_Transfer),
        ])
    InterSystemInformationTransferType._ext = []
    
    #-----< InterSystemInformation-TransparentContainer >-----#
    InterSystemInformation_TransparentContainer = SEQ(name=u'InterSystemInformation-TransparentContainer', mode=MODE_TYPE)
    _InterSystemInformation_TransparentContainer_downlinkCellLoadInformation = SEQ(name=u'downlinkCellLoadInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CellLoadInformation')), opt=True)
    _InterSystemInformation_TransparentContainer_uplinkCellLoadInformation = SEQ(name=u'uplinkCellLoadInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CellLoadInformation')), opt=True)
    _InterSystemInformation_TransparentContainer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InterSystemInformation_TransparentContainer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___InterSystemInformation_TransparentContainer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____InterSystemInformation_TransparentContainer_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____InterSystemInformation_TransparentContainer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemInformation_TransparentContainer_iE_Extensions__item__id._const_tab = ____InterSystemInformation_TransparentContainer_iE_Extensions__item__id_tab
    ___InterSystemInformation_TransparentContainer_iE_Extensions__item__id._const_tab_at = None
    ___InterSystemInformation_TransparentContainer_iE_Extensions__item__id._const_tab_id = u'id'
    ___InterSystemInformation_TransparentContainer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____InterSystemInformation_TransparentContainer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____InterSystemInformation_TransparentContainer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemInformation_TransparentContainer_iE_Extensions__item__criticality._const_tab = ____InterSystemInformation_TransparentContainer_iE_Extensions__item__criticality_tab
    ___InterSystemInformation_TransparentContainer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___InterSystemInformation_TransparentContainer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___InterSystemInformation_TransparentContainer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____InterSystemInformation_TransparentContainer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____InterSystemInformation_TransparentContainer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemInformation_TransparentContainer_iE_Extensions__item__extensionValue._const_tab = ____InterSystemInformation_TransparentContainer_iE_Extensions__item__extensionValue_tab
    ___InterSystemInformation_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___InterSystemInformation_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __InterSystemInformation_TransparentContainer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___InterSystemInformation_TransparentContainer_iE_Extensions__item__id),
        (u'criticality', ___InterSystemInformation_TransparentContainer_iE_Extensions__item__criticality),
        (u'extensionValue', ___InterSystemInformation_TransparentContainer_iE_Extensions__item__extensionValue),
        ])
    __InterSystemInformation_TransparentContainer_iE_Extensions__item_._ext = None
    _InterSystemInformation_TransparentContainer_iE_Extensions._cont = __InterSystemInformation_TransparentContainer_iE_Extensions__item_
    _InterSystemInformation_TransparentContainer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InterSystemInformation_TransparentContainer._cont = ASN1Dict([
        (u'downlinkCellLoadInformation', _InterSystemInformation_TransparentContainer_downlinkCellLoadInformation),
        (u'uplinkCellLoadInformation', _InterSystemInformation_TransparentContainer_uplinkCellLoadInformation),
        (u'iE-Extensions', _InterSystemInformation_TransparentContainer_iE_Extensions),
        ])
    InterSystemInformation_TransparentContainer._ext = []
    
    #-----< InterSystemInformation-TransparentContainer-ExtIEs >-----#
    InterSystemInformation_TransparentContainer_ExtIEs = CLASS(name=u'InterSystemInformation-TransparentContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    InterSystemInformation_TransparentContainer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IPMulticastAddress >-----#
    IPMulticastAddress = OCT_STR(name=u'IPMulticastAddress', mode=MODE_TYPE)
    IPMulticastAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=16)], ev=None, er=[])
    
    #-----< IuSignallingConnectionIdentifier >-----#
    IuSignallingConnectionIdentifier = BIT_STR(name=u'IuSignallingConnectionIdentifier', mode=MODE_TYPE)
    IuSignallingConnectionIdentifier._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    
    #-----< IuTransportAssociation >-----#
    IuTransportAssociation = CHOICE(name=u'IuTransportAssociation', mode=MODE_TYPE)
    _IuTransportAssociation_gTP_TEI = OCT_STR(name=u'gTP-TEI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GTP-TEI')))
    _IuTransportAssociation_bindingID = OCT_STR(name=u'bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'BindingID')))
    IuTransportAssociation._cont = ASN1Dict([
        (u'gTP-TEI', _IuTransportAssociation_gTP_TEI),
        (u'bindingID', _IuTransportAssociation_bindingID),
        ])
    IuTransportAssociation._ext = []
    
    #-----< KeyStatus >-----#
    KeyStatus = ENUM(name=u'KeyStatus', mode=MODE_TYPE)
    KeyStatus._cont = ASN1Dict([(u'old', 0), (u'new', 1)])
    KeyStatus._ext = []
    
    #-----< LA-LIST >-----#
    LA_LIST = SEQ_OF(name=u'LA-LIST', mode=MODE_TYPE)
    _LA_LIST__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __LA_LIST__item__lAC = OCT_STR(name=u'lAC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LAC')))
    __LA_LIST__item__listOF_SNAs = SEQ_OF(name=u'listOF-SNAs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ListOF-SNAs')))
    __LA_LIST__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___LA_LIST__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____LA_LIST__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    _____LA_LIST__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____LA_LIST__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____LA_LIST__item__iE_Extensions__item__id._const_tab = _____LA_LIST__item__iE_Extensions__item__id_tab
    ____LA_LIST__item__iE_Extensions__item__id._const_tab_at = None
    ____LA_LIST__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____LA_LIST__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____LA_LIST__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____LA_LIST__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____LA_LIST__item__iE_Extensions__item__criticality._const_tab = _____LA_LIST__item__iE_Extensions__item__criticality_tab
    ____LA_LIST__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____LA_LIST__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____LA_LIST__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____LA_LIST__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____LA_LIST__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____LA_LIST__item__iE_Extensions__item__extensionValue._const_tab = _____LA_LIST__item__iE_Extensions__item__extensionValue_tab
    ____LA_LIST__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____LA_LIST__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___LA_LIST__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____LA_LIST__item__iE_Extensions__item__id),
        (u'criticality', ____LA_LIST__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____LA_LIST__item__iE_Extensions__item__extensionValue),
        ])
    ___LA_LIST__item__iE_Extensions__item_._ext = None
    __LA_LIST__item__iE_Extensions._cont = ___LA_LIST__item__iE_Extensions__item_
    __LA_LIST__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _LA_LIST__item_._cont = ASN1Dict([
        (u'lAC', __LA_LIST__item__lAC),
        (u'listOF-SNAs', __LA_LIST__item__listOF_SNAs),
        (u'iE-Extensions', __LA_LIST__item__iE_Extensions),
        ])
    _LA_LIST__item_._ext = []
    LA_LIST._cont = _LA_LIST__item_
    LA_LIST._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< LA-LIST-ExtIEs >-----#
    LA_LIST_ExtIEs = CLASS(name=u'LA-LIST-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    LA_LIST_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LAC >-----#
    LAC = OCT_STR(name=u'LAC', mode=MODE_TYPE)
    LAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< LAI >-----#
    LAI = SEQ(name=u'LAI', mode=MODE_TYPE)
    _LAI_pLMNidentity = OCT_STR(name=u'pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _LAI_lAC = OCT_STR(name=u'lAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LAC')))
    _LAI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___LAI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____LAI_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LAI_iE_Extensions__item__id._const_tab = ____LAI_iE_Extensions__item__id_tab
    ___LAI_iE_Extensions__item__id._const_tab_at = None
    ___LAI_iE_Extensions__item__id._const_tab_id = u'id'
    ___LAI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____LAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LAI_iE_Extensions__item__criticality._const_tab = ____LAI_iE_Extensions__item__criticality_tab
    ___LAI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LAI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LAI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____LAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LAI_iE_Extensions__item__extensionValue._const_tab = ____LAI_iE_Extensions__item__extensionValue_tab
    ___LAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LAI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LAI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LAI_iE_Extensions__item__id),
        (u'criticality', ___LAI_iE_Extensions__item__criticality),
        (u'extensionValue', ___LAI_iE_Extensions__item__extensionValue),
        ])
    __LAI_iE_Extensions__item_._ext = None
    _LAI_iE_Extensions._cont = __LAI_iE_Extensions__item_
    _LAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LAI._cont = ASN1Dict([
        (u'pLMNidentity', _LAI_pLMNidentity),
        (u'lAC', _LAI_lAC),
        (u'iE-Extensions', _LAI_iE_Extensions),
        ])
    LAI._ext = None
    
    #-----< LAI-ExtIEs >-----#
    LAI_ExtIEs = CLASS(name=u'LAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    LAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LastKnownServiceArea >-----#
    LastKnownServiceArea = SEQ(name=u'LastKnownServiceArea', mode=MODE_TYPE)
    _LastKnownServiceArea_sAI = SEQ(name=u'sAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SAI')))
    _LastKnownServiceArea_ageOfSAI = INT(name=u'ageOfSAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LastKnownServiceArea_ageOfSAI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _LastKnownServiceArea_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LastKnownServiceArea_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___LastKnownServiceArea_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____LastKnownServiceArea_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LastKnownServiceArea_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LastKnownServiceArea_iE_Extensions__item__id._const_tab = ____LastKnownServiceArea_iE_Extensions__item__id_tab
    ___LastKnownServiceArea_iE_Extensions__item__id._const_tab_at = None
    ___LastKnownServiceArea_iE_Extensions__item__id._const_tab_id = u'id'
    ___LastKnownServiceArea_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____LastKnownServiceArea_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LastKnownServiceArea_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LastKnownServiceArea_iE_Extensions__item__criticality._const_tab = ____LastKnownServiceArea_iE_Extensions__item__criticality_tab
    ___LastKnownServiceArea_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LastKnownServiceArea_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LastKnownServiceArea_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____LastKnownServiceArea_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LastKnownServiceArea_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LastKnownServiceArea_iE_Extensions__item__extensionValue._const_tab = ____LastKnownServiceArea_iE_Extensions__item__extensionValue_tab
    ___LastKnownServiceArea_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LastKnownServiceArea_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LastKnownServiceArea_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LastKnownServiceArea_iE_Extensions__item__id),
        (u'criticality', ___LastKnownServiceArea_iE_Extensions__item__criticality),
        (u'extensionValue', ___LastKnownServiceArea_iE_Extensions__item__extensionValue),
        ])
    __LastKnownServiceArea_iE_Extensions__item_._ext = None
    _LastKnownServiceArea_iE_Extensions._cont = __LastKnownServiceArea_iE_Extensions__item_
    _LastKnownServiceArea_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LastKnownServiceArea._cont = ASN1Dict([
        (u'sAI', _LastKnownServiceArea_sAI),
        (u'ageOfSAI', _LastKnownServiceArea_ageOfSAI),
        (u'iE-Extensions', _LastKnownServiceArea_iE_Extensions),
        ])
    LastKnownServiceArea._ext = []
    
    #-----< LastKnownServiceArea-ExtIEs >-----#
    LastKnownServiceArea_ExtIEs = CLASS(name=u'LastKnownServiceArea-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    LastKnownServiceArea_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LastVisitedUTRANCell-Item >-----#
    LastVisitedUTRANCell_Item = SEQ(name=u'LastVisitedUTRANCell-Item', mode=MODE_TYPE)
    _LastVisitedUTRANCell_Item_uTRAN_CellID = SEQ(name=u'uTRAN-CellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UTRAN-CellID')))
    _LastVisitedUTRANCell_Item_cellType = ENUM(name=u'cellType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CellType')))
    _LastVisitedUTRANCell_Item_time_UE_StayedInCell = INT(name=u'time-UE-StayedInCell', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Time-UE-StayedInCell')))
    _LastVisitedUTRANCell_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LastVisitedUTRANCell_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___LastVisitedUTRANCell_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____LastVisitedUTRANCell_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____LastVisitedUTRANCell_Item_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Time-UE-StayedInCell-EnhancedGranularity')))
    _____LastVisitedUTRANCell_Item_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    ____LastVisitedUTRANCell_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 253), (u'criticality', u'ignore'), (u'Extension', _____LastVisitedUTRANCell_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 257), (u'criticality', u'ignore'), (u'Extension', _____LastVisitedUTRANCell_Item_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___LastVisitedUTRANCell_Item_iE_Extensions__item__id._const_tab = ____LastVisitedUTRANCell_Item_iE_Extensions__item__id_tab
    ___LastVisitedUTRANCell_Item_iE_Extensions__item__id._const_tab_at = None
    ___LastVisitedUTRANCell_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___LastVisitedUTRANCell_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___LastVisitedUTRANCell_Item_iE_Extensions__item__criticality._const_tab = ____LastVisitedUTRANCell_Item_iE_Extensions__item__id_tab
    ___LastVisitedUTRANCell_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LastVisitedUTRANCell_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LastVisitedUTRANCell_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___LastVisitedUTRANCell_Item_iE_Extensions__item__extensionValue._const_tab = ____LastVisitedUTRANCell_Item_iE_Extensions__item__id_tab
    ___LastVisitedUTRANCell_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LastVisitedUTRANCell_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LastVisitedUTRANCell_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LastVisitedUTRANCell_Item_iE_Extensions__item__id),
        (u'criticality', ___LastVisitedUTRANCell_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___LastVisitedUTRANCell_Item_iE_Extensions__item__extensionValue),
        ])
    __LastVisitedUTRANCell_Item_iE_Extensions__item_._ext = None
    _LastVisitedUTRANCell_Item_iE_Extensions._cont = __LastVisitedUTRANCell_Item_iE_Extensions__item_
    _LastVisitedUTRANCell_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LastVisitedUTRANCell_Item._cont = ASN1Dict([
        (u'uTRAN-CellID', _LastVisitedUTRANCell_Item_uTRAN_CellID),
        (u'cellType', _LastVisitedUTRANCell_Item_cellType),
        (u'time-UE-StayedInCell', _LastVisitedUTRANCell_Item_time_UE_StayedInCell),
        (u'iE-Extensions', _LastVisitedUTRANCell_Item_iE_Extensions),
        ])
    LastVisitedUTRANCell_Item._ext = []
    
    #-----< LastVisitedUTRANCell-Item-ExtIEs >-----#
    LastVisitedUTRANCell_Item_ExtIEs = CLASS(name=u'LastVisitedUTRANCell-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _LastVisitedUTRANCell_Item_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Time-UE-StayedInCell-EnhancedGranularity')))
    _LastVisitedUTRANCell_Item_ExtIEs_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    LastVisitedUTRANCell_Item_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 253), (u'criticality', u'ignore'), (u'Extension', _LastVisitedUTRANCell_Item_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 257), (u'criticality', u'ignore'), (u'Extension', _LastVisitedUTRANCell_Item_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< LHN-ID >-----#
    LHN_ID = OCT_STR(name=u'LHN-ID', mode=MODE_TYPE)
    LHN_ID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=32, ub=256)], ev=None, er=[])
    
    #-----< Links-to-log >-----#
    Links_to_log = ENUM(name=u'Links-to-log', mode=MODE_TYPE)
    Links_to_log._cont = ASN1Dict([(u'uplink', 0), (u'downlink', 1), (u'both-uplink-and-downlink', 2)])
    Links_to_log._ext = []
    
    #-----< ListOF-SNAs >-----#
    ListOF_SNAs = SEQ_OF(name=u'ListOF-SNAs', mode=MODE_TYPE)
    _ListOF_SNAs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SNAC')))
    ListOF_SNAs._cont = _ListOF_SNAs__item_
    ListOF_SNAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< ListOfInterfacesToTrace >-----#
    ListOfInterfacesToTrace = SEQ_OF(name=u'ListOfInterfacesToTrace', mode=MODE_TYPE)
    _ListOfInterfacesToTrace__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InterfacesToTraceItem')))
    ListOfInterfacesToTrace._cont = _ListOfInterfacesToTrace__item_
    ListOfInterfacesToTrace._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< InterfacesToTraceItem >-----#
    InterfacesToTraceItem = SEQ(name=u'InterfacesToTraceItem', mode=MODE_TYPE)
    _InterfacesToTraceItem_interface = ENUM(name=u'interface', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _InterfacesToTraceItem_interface._cont = ASN1Dict([(u'iu-cs', 0), (u'iu-ps', 1), (u'iur', 2), (u'iub', 3), (u'uu', 4)])
    _InterfacesToTraceItem_interface._ext = []
    _InterfacesToTraceItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InterfacesToTraceItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___InterfacesToTraceItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____InterfacesToTraceItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____InterfacesToTraceItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterfacesToTraceItem_iE_Extensions__item__id._const_tab = ____InterfacesToTraceItem_iE_Extensions__item__id_tab
    ___InterfacesToTraceItem_iE_Extensions__item__id._const_tab_at = None
    ___InterfacesToTraceItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___InterfacesToTraceItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____InterfacesToTraceItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____InterfacesToTraceItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterfacesToTraceItem_iE_Extensions__item__criticality._const_tab = ____InterfacesToTraceItem_iE_Extensions__item__criticality_tab
    ___InterfacesToTraceItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___InterfacesToTraceItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___InterfacesToTraceItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____InterfacesToTraceItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____InterfacesToTraceItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterfacesToTraceItem_iE_Extensions__item__extensionValue._const_tab = ____InterfacesToTraceItem_iE_Extensions__item__extensionValue_tab
    ___InterfacesToTraceItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___InterfacesToTraceItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __InterfacesToTraceItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___InterfacesToTraceItem_iE_Extensions__item__id),
        (u'criticality', ___InterfacesToTraceItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___InterfacesToTraceItem_iE_Extensions__item__extensionValue),
        ])
    __InterfacesToTraceItem_iE_Extensions__item_._ext = None
    _InterfacesToTraceItem_iE_Extensions._cont = __InterfacesToTraceItem_iE_Extensions__item_
    _InterfacesToTraceItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InterfacesToTraceItem._cont = ASN1Dict([
        (u'interface', _InterfacesToTraceItem_interface),
        (u'iE-Extensions', _InterfacesToTraceItem_iE_Extensions),
        ])
    InterfacesToTraceItem._ext = []
    
    #-----< InterfacesToTraceItem-ExtIEs >-----#
    InterfacesToTraceItem_ExtIEs = CLASS(name=u'InterfacesToTraceItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    InterfacesToTraceItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LoadValue >-----#
    LoadValue = INT(name=u'LoadValue', mode=MODE_TYPE)
    LoadValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< LocationRelatedDataRequestType >-----#
    LocationRelatedDataRequestType = SEQ(name=u'LocationRelatedDataRequestType', mode=MODE_TYPE)
    _LocationRelatedDataRequestType_requestedLocationRelatedDataType = ENUM(name=u'requestedLocationRelatedDataType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RequestedLocationRelatedDataType')))
    _LocationRelatedDataRequestType_requestedGPSAssistanceData = OCT_STR(name=u'requestedGPSAssistanceData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RequestedGPSAssistanceData')), opt=True)
    LocationRelatedDataRequestType._cont = ASN1Dict([
        (u'requestedLocationRelatedDataType', _LocationRelatedDataRequestType_requestedLocationRelatedDataType),
        (u'requestedGPSAssistanceData', _LocationRelatedDataRequestType_requestedGPSAssistanceData),
        ])
    LocationRelatedDataRequestType._ext = []
    
    #-----< LocationRelatedDataRequestTypeSpecificToGERANIuMode >-----#
    LocationRelatedDataRequestTypeSpecificToGERANIuMode = ENUM(name=u'LocationRelatedDataRequestTypeSpecificToGERANIuMode', mode=MODE_TYPE)
    LocationRelatedDataRequestTypeSpecificToGERANIuMode._cont = ASN1Dict([(u'decipheringKeysEOTD', 0), (u'dedicatedMobileAssistedEOTDAssistanceData', 1), (u'dedicatedMobileBasedEOTDAssistanceData', 2)])
    LocationRelatedDataRequestTypeSpecificToGERANIuMode._ext = []
    
    #-----< LocationReportingTransferInformation >-----#
    LocationReportingTransferInformation = SEQ(name=u'LocationReportingTransferInformation', mode=MODE_TYPE)
    _LocationReportingTransferInformation_reportChangeOfSAI = ENUM(name=u'reportChangeOfSAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ReportChangeOfSAI')), opt=True)
    _LocationReportingTransferInformation_periodicReportingIndicator = ENUM(name=u'periodicReportingIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PeriodicReportingIndicator')), opt=True)
    _LocationReportingTransferInformation_directReportingIndicator = ENUM(name=u'directReportingIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DirectReportingIndicator')), opt=True)
    _LocationReportingTransferInformation_verticalAccuracyCode = INT(name=u'verticalAccuracyCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'VerticalAccuracyCode')), opt=True)
    _LocationReportingTransferInformation_positioningPriorityChangeSAI = ENUM(name=u'positioningPriorityChangeSAI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PositioningPriority')), opt=True)
    _LocationReportingTransferInformation_positioningPriorityDirect = ENUM(name=u'positioningPriorityDirect', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PositioningPriority')), opt=True)
    _LocationReportingTransferInformation_clientTypePeriodic = ENUM(name=u'clientTypePeriodic', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ClientType')), opt=True)
    _LocationReportingTransferInformation_clientTypeDirect = ENUM(name=u'clientTypeDirect', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ClientType')), opt=True)
    _LocationReportingTransferInformation_responseTime = ENUM(name=u'responseTime', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ResponseTime')), opt=True)
    _LocationReportingTransferInformation_includeVelocity = ENUM(name=u'includeVelocity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IncludeVelocity')), opt=True)
    _LocationReportingTransferInformation_periodicLocationInfo = SEQ(name=u'periodicLocationInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PeriodicLocationInfo')), opt=True)
    _LocationReportingTransferInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LocationReportingTransferInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___LocationReportingTransferInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____LocationReportingTransferInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LocationReportingTransferInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationReportingTransferInformation_iE_Extensions__item__id._const_tab = ____LocationReportingTransferInformation_iE_Extensions__item__id_tab
    ___LocationReportingTransferInformation_iE_Extensions__item__id._const_tab_at = None
    ___LocationReportingTransferInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___LocationReportingTransferInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____LocationReportingTransferInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LocationReportingTransferInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationReportingTransferInformation_iE_Extensions__item__criticality._const_tab = ____LocationReportingTransferInformation_iE_Extensions__item__criticality_tab
    ___LocationReportingTransferInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LocationReportingTransferInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LocationReportingTransferInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____LocationReportingTransferInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LocationReportingTransferInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationReportingTransferInformation_iE_Extensions__item__extensionValue._const_tab = ____LocationReportingTransferInformation_iE_Extensions__item__extensionValue_tab
    ___LocationReportingTransferInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LocationReportingTransferInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LocationReportingTransferInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LocationReportingTransferInformation_iE_Extensions__item__id),
        (u'criticality', ___LocationReportingTransferInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___LocationReportingTransferInformation_iE_Extensions__item__extensionValue),
        ])
    __LocationReportingTransferInformation_iE_Extensions__item_._ext = None
    _LocationReportingTransferInformation_iE_Extensions._cont = __LocationReportingTransferInformation_iE_Extensions__item_
    _LocationReportingTransferInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LocationReportingTransferInformation._cont = ASN1Dict([
        (u'reportChangeOfSAI', _LocationReportingTransferInformation_reportChangeOfSAI),
        (u'periodicReportingIndicator', _LocationReportingTransferInformation_periodicReportingIndicator),
        (u'directReportingIndicator', _LocationReportingTransferInformation_directReportingIndicator),
        (u'verticalAccuracyCode', _LocationReportingTransferInformation_verticalAccuracyCode),
        (u'positioningPriorityChangeSAI', _LocationReportingTransferInformation_positioningPriorityChangeSAI),
        (u'positioningPriorityDirect', _LocationReportingTransferInformation_positioningPriorityDirect),
        (u'clientTypePeriodic', _LocationReportingTransferInformation_clientTypePeriodic),
        (u'clientTypeDirect', _LocationReportingTransferInformation_clientTypeDirect),
        (u'responseTime', _LocationReportingTransferInformation_responseTime),
        (u'includeVelocity', _LocationReportingTransferInformation_includeVelocity),
        (u'periodicLocationInfo', _LocationReportingTransferInformation_periodicLocationInfo),
        (u'iE-Extensions', _LocationReportingTransferInformation_iE_Extensions),
        ])
    LocationReportingTransferInformation._ext = []
    
    #-----< LocationReportingTransferInformation-ExtIEs >-----#
    LocationReportingTransferInformation_ExtIEs = CLASS(name=u'LocationReportingTransferInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    LocationReportingTransferInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ReportChangeOfSAI >-----#
    ReportChangeOfSAI = ENUM(name=u'ReportChangeOfSAI', mode=MODE_TYPE)
    ReportChangeOfSAI._cont = ASN1Dict([(u'requested', 0)])
    ReportChangeOfSAI._ext = []
    
    #-----< PeriodicReportingIndicator >-----#
    PeriodicReportingIndicator = ENUM(name=u'PeriodicReportingIndicator', mode=MODE_TYPE)
    PeriodicReportingIndicator._cont = ASN1Dict([(u'periodicSAI', 0), (u'periodicGeo', 1)])
    PeriodicReportingIndicator._ext = []
    
    #-----< DirectReportingIndicator >-----#
    DirectReportingIndicator = ENUM(name=u'DirectReportingIndicator', mode=MODE_TYPE)
    DirectReportingIndicator._cont = ASN1Dict([(u'directSAI', 0), (u'directGeo', 1)])
    DirectReportingIndicator._ext = []
    
    #-----< L3-Information >-----#
    L3_Information = OCT_STR(name=u'L3-Information', mode=MODE_TYPE)
    
    #-----< M1Report >-----#
    M1Report = CHOICE(name=u'M1Report', mode=MODE_TYPE)
    _M1Report_periodic = SEQ(name=u'periodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'MDT-Report-Parameters')))
    _M1Report_event1F = SEQ(name=u'event1F', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Event1F-Parameters')))
    M1Report._cont = ASN1Dict([
        (u'periodic', _M1Report_periodic),
        (u'event1F', _M1Report_event1F),
        ])
    M1Report._ext = []
    
    #-----< M2Report >-----#
    M2Report = CHOICE(name=u'M2Report', mode=MODE_TYPE)
    _M2Report_periodic = SEQ(name=u'periodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'MDT-Report-Parameters')))
    _M2Report_event1I = SEQ(name=u'event1I', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Event1I-Parameters')))
    M2Report._cont = ASN1Dict([
        (u'periodic', _M2Report_periodic),
        (u'event1I', _M2Report_event1I),
        ])
    M2Report._ext = []
    
    #-----< M4Report >-----#
    M4Report = CHOICE(name=u'M4Report', mode=MODE_TYPE)
    _M4Report_all = NULL(name=u'all', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _M4Report_m4_collection_parameters = SEQ(name=u'm4-collection-parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'M4-Collection-Parameters')))
    M4Report._cont = ASN1Dict([
        (u'all', _M4Report_all),
        (u'm4-collection-parameters', _M4Report_m4_collection_parameters),
        ])
    M4Report._ext = []
    
    #-----< M4-Collection-Parameters >-----#
    M4_Collection_Parameters = SEQ(name=u'M4-Collection-Parameters', mode=MODE_TYPE)
    _M4_Collection_Parameters_m4_period = ENUM(name=u'm4-period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'M4-Period')))
    _M4_Collection_Parameters_m4_threshold = INT(name=u'm4-threshold', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'M4-Threshold')), opt=True)
    _M4_Collection_Parameters_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M4_Collection_Parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___M4_Collection_Parameters_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____M4_Collection_Parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____M4_Collection_Parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M4_Collection_Parameters_iE_Extensions__item__id._const_tab = ____M4_Collection_Parameters_iE_Extensions__item__id_tab
    ___M4_Collection_Parameters_iE_Extensions__item__id._const_tab_at = None
    ___M4_Collection_Parameters_iE_Extensions__item__id._const_tab_id = u'id'
    ___M4_Collection_Parameters_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____M4_Collection_Parameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____M4_Collection_Parameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M4_Collection_Parameters_iE_Extensions__item__criticality._const_tab = ____M4_Collection_Parameters_iE_Extensions__item__criticality_tab
    ___M4_Collection_Parameters_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M4_Collection_Parameters_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M4_Collection_Parameters_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____M4_Collection_Parameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____M4_Collection_Parameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M4_Collection_Parameters_iE_Extensions__item__extensionValue._const_tab = ____M4_Collection_Parameters_iE_Extensions__item__extensionValue_tab
    ___M4_Collection_Parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M4_Collection_Parameters_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M4_Collection_Parameters_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M4_Collection_Parameters_iE_Extensions__item__id),
        (u'criticality', ___M4_Collection_Parameters_iE_Extensions__item__criticality),
        (u'extensionValue', ___M4_Collection_Parameters_iE_Extensions__item__extensionValue),
        ])
    __M4_Collection_Parameters_iE_Extensions__item_._ext = None
    _M4_Collection_Parameters_iE_Extensions._cont = __M4_Collection_Parameters_iE_Extensions__item_
    _M4_Collection_Parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M4_Collection_Parameters._cont = ASN1Dict([
        (u'm4-period', _M4_Collection_Parameters_m4_period),
        (u'm4-threshold', _M4_Collection_Parameters_m4_threshold),
        (u'iE-Extensions', _M4_Collection_Parameters_iE_Extensions),
        ])
    M4_Collection_Parameters._ext = []
    
    #-----< M4-Collection-Parameters-ExtIEs >-----#
    M4_Collection_Parameters_ExtIEs = CLASS(name=u'M4-Collection-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    M4_Collection_Parameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M4-Period >-----#
    M4_Period = ENUM(name=u'M4-Period', mode=MODE_TYPE)
    M4_Period._cont = ASN1Dict([(u'ms100', 0), (u'ms250', 1), (u'ms500', 2), (u'ms1000', 3), (u'ms2000', 4), (u'ms3000', 5), (u'ms4000', 6), (u'ms6000', 7)])
    M4_Period._ext = []
    
    #-----< M4-Threshold >-----#
    M4_Threshold = INT(name=u'M4-Threshold', mode=MODE_TYPE)
    M4_Threshold._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    
    #-----< M5Report >-----#
    M5Report = CHOICE(name=u'M5Report', mode=MODE_TYPE)
    _M5Report_when_available = NULL(name=u'when-available', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _M5Report_m5_period = ENUM(name=u'm5-period', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'M5-Period')))
    M5Report._cont = ASN1Dict([
        (u'when-available', _M5Report_when_available),
        (u'm5-period', _M5Report_m5_period),
        ])
    M5Report._ext = []
    
    #-----< M5-Period >-----#
    M5_Period = ENUM(name=u'M5-Period', mode=MODE_TYPE)
    M5_Period._cont = ASN1Dict([(u'ms100', 0), (u'ms250', 1), (u'ms500', 2), (u'ms1000', 3), (u'ms2000', 4), (u'ms3000', 5), (u'ms4000', 6), (u'ms6000', 7)])
    M5_Period._ext = []
    
    #-----< M6Report >-----#
    M6Report = SEQ(name=u'M6Report', mode=MODE_TYPE)
    _M6Report_m6_period = ENUM(name=u'm6-period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'M6-Period')))
    _M6Report_m6_links_to_log = ENUM(name=u'm6-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Links-to-log')))
    _M6Report_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M6Report_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___M6Report_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____M6Report_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____M6Report_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M6Report_iE_Extensions__item__id._const_tab = ____M6Report_iE_Extensions__item__id_tab
    ___M6Report_iE_Extensions__item__id._const_tab_at = None
    ___M6Report_iE_Extensions__item__id._const_tab_id = u'id'
    ___M6Report_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____M6Report_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____M6Report_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M6Report_iE_Extensions__item__criticality._const_tab = ____M6Report_iE_Extensions__item__criticality_tab
    ___M6Report_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M6Report_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M6Report_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____M6Report_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____M6Report_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M6Report_iE_Extensions__item__extensionValue._const_tab = ____M6Report_iE_Extensions__item__extensionValue_tab
    ___M6Report_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M6Report_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M6Report_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M6Report_iE_Extensions__item__id),
        (u'criticality', ___M6Report_iE_Extensions__item__criticality),
        (u'extensionValue', ___M6Report_iE_Extensions__item__extensionValue),
        ])
    __M6Report_iE_Extensions__item_._ext = None
    _M6Report_iE_Extensions._cont = __M6Report_iE_Extensions__item_
    _M6Report_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M6Report._cont = ASN1Dict([
        (u'm6-period', _M6Report_m6_period),
        (u'm6-links-to-log', _M6Report_m6_links_to_log),
        (u'iE-Extensions', _M6Report_iE_Extensions),
        ])
    M6Report._ext = []
    
    #-----< M6Report-ExtIEs >-----#
    M6Report_ExtIEs = CLASS(name=u'M6Report-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    M6Report_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M6-Period >-----#
    M6_Period = ENUM(name=u'M6-Period', mode=MODE_TYPE)
    M6_Period._cont = ASN1Dict([(u'ms1000', 0), (u'ms2000', 1), (u'ms3000', 2), (u'ms4000', 3), (u'ms6000', 4), (u'ms8000', 5), (u'ms12000', 6), (u'ms16000', 7), (u'ms20000', 8), (u'ms24000', 9), (u'ms28000', 10), (u'ms32000', 11), (u'ms64000', 12)])
    M6_Period._ext = []
    
    #-----< M7Report >-----#
    M7Report = SEQ(name=u'M7Report', mode=MODE_TYPE)
    _M7Report_m7_period = ENUM(name=u'm7-period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'M7-Period')))
    _M7Report_m7_links_to_log = ENUM(name=u'm7-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Links-to-log')))
    _M7Report_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M7Report_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___M7Report_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____M7Report_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____M7Report_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M7Report_iE_Extensions__item__id._const_tab = ____M7Report_iE_Extensions__item__id_tab
    ___M7Report_iE_Extensions__item__id._const_tab_at = None
    ___M7Report_iE_Extensions__item__id._const_tab_id = u'id'
    ___M7Report_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____M7Report_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____M7Report_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M7Report_iE_Extensions__item__criticality._const_tab = ____M7Report_iE_Extensions__item__criticality_tab
    ___M7Report_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M7Report_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M7Report_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____M7Report_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____M7Report_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M7Report_iE_Extensions__item__extensionValue._const_tab = ____M7Report_iE_Extensions__item__extensionValue_tab
    ___M7Report_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M7Report_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M7Report_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M7Report_iE_Extensions__item__id),
        (u'criticality', ___M7Report_iE_Extensions__item__criticality),
        (u'extensionValue', ___M7Report_iE_Extensions__item__extensionValue),
        ])
    __M7Report_iE_Extensions__item_._ext = None
    _M7Report_iE_Extensions._cont = __M7Report_iE_Extensions__item_
    _M7Report_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M7Report._cont = ASN1Dict([
        (u'm7-period', _M7Report_m7_period),
        (u'm7-links-to-log', _M7Report_m7_links_to_log),
        (u'iE-Extensions', _M7Report_iE_Extensions),
        ])
    M7Report._ext = []
    
    #-----< M7Report-ExtIEs >-----#
    M7Report_ExtIEs = CLASS(name=u'M7Report-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    M7Report_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M7-Period >-----#
    M7_Period = ENUM(name=u'M7-Period', mode=MODE_TYPE)
    M7_Period._cont = ASN1Dict([(u'ms1000', 0), (u'ms2000', 1), (u'ms3000', 2), (u'ms4000', 3), (u'ms6000', 4), (u'ms8000', 5), (u'ms12000', 6), (u'ms16000', 7), (u'ms20000', 8), (u'ms24000', 9), (u'ms28000', 10), (u'ms32000', 11), (u'ms64000', 12)])
    M7_Period._ext = []
    
    #-----< Management-Based-MDT-Allowed >-----#
    Management_Based_MDT_Allowed = ENUM(name=u'Management-Based-MDT-Allowed', mode=MODE_TYPE)
    Management_Based_MDT_Allowed._cont = ASN1Dict([(u'allowed', 0)])
    Management_Based_MDT_Allowed._ext = []
    
    #-----< MaxBitrate >-----#
    MaxBitrate = INT(name=u'MaxBitrate', mode=MODE_TYPE)
    MaxBitrate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16000000)], ev=None, er=[])
    
    #-----< MaxSDU-Size >-----#
    MaxSDU_Size = INT(name=u'MaxSDU-Size', mode=MODE_TYPE)
    MaxSDU_Size._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32768)], ev=None, er=[])
    
    #-----< MBMS-PTP-RAB-ID >-----#
    MBMS_PTP_RAB_ID = BIT_STR(name=u'MBMS-PTP-RAB-ID', mode=MODE_TYPE)
    MBMS_PTP_RAB_ID._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< MBMSBearerServiceType >-----#
    MBMSBearerServiceType = ENUM(name=u'MBMSBearerServiceType', mode=MODE_TYPE)
    MBMSBearerServiceType._cont = ASN1Dict([(u'multicast', 0), (u'broadcast', 1)])
    MBMSBearerServiceType._ext = []
    
    #-----< MBMSCNDe-Registration >-----#
    MBMSCNDe_Registration = ENUM(name=u'MBMSCNDe-Registration', mode=MODE_TYPE)
    MBMSCNDe_Registration._cont = ASN1Dict([(u'normalsessionstop', 0), (u'deregister', 1)])
    MBMSCNDe_Registration._ext = []
    
    #-----< MBMSCountingInformation >-----#
    MBMSCountingInformation = ENUM(name=u'MBMSCountingInformation', mode=MODE_TYPE)
    MBMSCountingInformation._cont = ASN1Dict([(u'counting', 0), (u'notcounting', 1)])
    MBMSCountingInformation._ext = []
    
    #-----< MBMSHCIndicator >-----#
    MBMSHCIndicator = ENUM(name=u'MBMSHCIndicator', mode=MODE_TYPE)
    MBMSHCIndicator._cont = ASN1Dict([(u'uncompressed-header', 0), (u'compressed-header', 1)])
    MBMSHCIndicator._ext = []
    
    #-----< MBMSIPMulticastAddressandAPNRequest >-----#
    MBMSIPMulticastAddressandAPNRequest = SEQ_OF(name=u'MBMSIPMulticastAddressandAPNRequest', mode=MODE_TYPE)
    _MBMSIPMulticastAddressandAPNRequest__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    MBMSIPMulticastAddressandAPNRequest._cont = _MBMSIPMulticastAddressandAPNRequest__item_
    MBMSIPMulticastAddressandAPNRequest._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< MBMSLinkingInformation >-----#
    MBMSLinkingInformation = ENUM(name=u'MBMSLinkingInformation', mode=MODE_TYPE)
    MBMSLinkingInformation._cont = ASN1Dict([(u'uE-has-joined-multicast-services', 0)])
    MBMSLinkingInformation._ext = []
    
    #-----< MBMSRegistrationRequestType >-----#
    MBMSRegistrationRequestType = ENUM(name=u'MBMSRegistrationRequestType', mode=MODE_TYPE)
    MBMSRegistrationRequestType._cont = ASN1Dict([(u'register', 0), (u'deregister', 1)])
    MBMSRegistrationRequestType._ext = []
    
    #-----< MBMSServiceArea >-----#
    MBMSServiceArea = OCT_STR(name=u'MBMSServiceArea', mode=MODE_TYPE)
    
    #-----< MBMSSessionDuration >-----#
    MBMSSessionDuration = OCT_STR(name=u'MBMSSessionDuration', mode=MODE_TYPE)
    MBMSSessionDuration._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< MBMSSessionIdentity >-----#
    MBMSSessionIdentity = OCT_STR(name=u'MBMSSessionIdentity', mode=MODE_TYPE)
    MBMSSessionIdentity._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< MBMSSessionRepetitionNumber >-----#
    MBMSSessionRepetitionNumber = OCT_STR(name=u'MBMSSessionRepetitionNumber', mode=MODE_TYPE)
    MBMSSessionRepetitionNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< MDT-Activation >-----#
    MDT_Activation = ENUM(name=u'MDT-Activation', mode=MODE_TYPE)
    MDT_Activation._cont = ASN1Dict([(u'immediateMDTonly', 0), (u'loggedMDTonly', 1), (u'immediateMDTandTrace', 2)])
    MDT_Activation._ext = []
    
    #-----< MDTAreaScope >-----#
    MDTAreaScope = CHOICE(name=u'MDTAreaScope', mode=MODE_TYPE)
    _MDTAreaScope_cellbased = SEQ(name=u'cellbased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CellBased')))
    _MDTAreaScope_labased = SEQ(name=u'labased', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LABased')))
    _MDTAreaScope_rabased = SEQ(name=u'rabased', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RABased')))
    _MDTAreaScope_plmn_area_based = NULL(name=u'plmn-area-based', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    MDTAreaScope._cont = ASN1Dict([
        (u'cellbased', _MDTAreaScope_cellbased),
        (u'labased', _MDTAreaScope_labased),
        (u'rabased', _MDTAreaScope_rabased),
        (u'plmn-area-based', _MDTAreaScope_plmn_area_based),
        ])
    MDTAreaScope._ext = []
    
    #-----< MDT-Configuration >-----#
    MDT_Configuration = SEQ(name=u'MDT-Configuration', mode=MODE_TYPE)
    _MDT_Configuration_mdtActivation = ENUM(name=u'mdtActivation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'MDT-Activation')))
    _MDT_Configuration_mdtAreaScope = CHOICE(name=u'mdtAreaScope', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'MDTAreaScope')))
    _MDT_Configuration_mdtMode = CHOICE(name=u'mdtMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'MDTMode')))
    _MDT_Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MDT_Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MDT_Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MDT_Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MDT-PLMN-List')))
    ____MDT_Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 264), (u'criticality', u'ignore'), (u'Extension', _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MDT_Configuration_iE_Extensions__item__id._const_tab = ____MDT_Configuration_iE_Extensions__item__id_tab
    ___MDT_Configuration_iE_Extensions__item__id._const_tab_at = None
    ___MDT_Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___MDT_Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab = ____MDT_Configuration_iE_Extensions__item__id_tab
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MDT_Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab = ____MDT_Configuration_iE_Extensions__item__id_tab
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MDT_Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MDT_Configuration_iE_Extensions__item__id),
        (u'criticality', ___MDT_Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___MDT_Configuration_iE_Extensions__item__extensionValue),
        ])
    __MDT_Configuration_iE_Extensions__item_._ext = None
    _MDT_Configuration_iE_Extensions._cont = __MDT_Configuration_iE_Extensions__item_
    _MDT_Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MDT_Configuration._cont = ASN1Dict([
        (u'mdtActivation', _MDT_Configuration_mdtActivation),
        (u'mdtAreaScope', _MDT_Configuration_mdtAreaScope),
        (u'mdtMode', _MDT_Configuration_mdtMode),
        (u'iE-Extensions', _MDT_Configuration_iE_Extensions),
        ])
    MDT_Configuration._ext = []
    
    #-----< MDT-Configuration-ExtIEs >-----#
    MDT_Configuration_ExtIEs = CLASS(name=u'MDT-Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _MDT_Configuration_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MDT-PLMN-List')))
    MDT_Configuration_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 264), (u'criticality', u'ignore'), (u'Extension', _MDT_Configuration_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MDTMode >-----#
    MDTMode = CHOICE(name=u'MDTMode', mode=MODE_TYPE)
    _MDTMode_immediateMDT = SEQ(name=u'immediateMDT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ImmediateMDT')))
    _MDTMode_loggedMDT = SEQ(name=u'loggedMDT', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LoggedMDT')))
    MDTMode._cont = ASN1Dict([
        (u'immediateMDT', _MDTMode_immediateMDT),
        (u'loggedMDT', _MDTMode_loggedMDT),
        ])
    MDTMode._ext = []
    
    #-----< MDT-PLMN-List >-----#
    MDT_PLMN_List = SEQ_OF(name=u'MDT-PLMN-List', mode=MODE_TYPE)
    _MDT_PLMN_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    MDT_PLMN_List._cont = _MDT_PLMN_List__item_
    MDT_PLMN_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< MDT-Report-Parameters >-----#
    MDT_Report_Parameters = SEQ(name=u'MDT-Report-Parameters', mode=MODE_TYPE)
    _MDT_Report_Parameters_reportInterval = ENUM(name=u'reportInterval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ReportInterval')))
    _MDT_Report_Parameters_reportAmount = ENUM(name=u'reportAmount', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ReportAmount')))
    MDT_Report_Parameters._cont = ASN1Dict([
        (u'reportInterval', _MDT_Report_Parameters_reportInterval),
        (u'reportAmount', _MDT_Report_Parameters_reportAmount),
        ])
    MDT_Report_Parameters._ext = []
    
    #-----< MeasurementQuantity >-----#
    MeasurementQuantity = ENUM(name=u'MeasurementQuantity', mode=MODE_TYPE)
    MeasurementQuantity._cont = ASN1Dict([(u'cpichEcNo', 0), (u'cpichRSCP', 1), (u'pathloss', 2)])
    MeasurementQuantity._ext = []
    
    #-----< MeasurementsToActivate >-----#
    MeasurementsToActivate = BIT_STR(name=u'MeasurementsToActivate', mode=MODE_TYPE)
    MeasurementsToActivate._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< MSISDN >-----#
    MSISDN = OCT_STR(name=u'MSISDN', mode=MODE_TYPE)
    MSISDN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< NAS-PDU >-----#
    NAS_PDU = OCT_STR(name=u'NAS-PDU', mode=MODE_TYPE)
    
    #-----< NAS-SequenceNumber >-----#
    NAS_SequenceNumber = BIT_STR(name=u'NAS-SequenceNumber', mode=MODE_TYPE)
    NAS_SequenceNumber._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< NAS-SynchronisationIndicator >-----#
    NAS_SynchronisationIndicator = BIT_STR(name=u'NAS-SynchronisationIndicator', mode=MODE_TYPE)
    NAS_SynchronisationIndicator._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< NewBSS-To-OldBSS-Information >-----#
    NewBSS_To_OldBSS_Information = OCT_STR(name=u'NewBSS-To-OldBSS-Information', mode=MODE_TYPE)
    
    #-----< NonSearchingIndication >-----#
    NonSearchingIndication = ENUM(name=u'NonSearchingIndication', mode=MODE_TYPE)
    NonSearchingIndication._cont = ASN1Dict([(u'non-searching', 0), (u'searching', 1)])
    NonSearchingIndication._ext = None
    
    #-----< NRTLoadInformationValue >-----#
    NRTLoadInformationValue = INT(name=u'NRTLoadInformationValue', mode=MODE_TYPE)
    NRTLoadInformationValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    
    #-----< Null-NRI >-----#
    Null_NRI = BIT_STR(name=u'Null-NRI', mode=MODE_TYPE)
    Null_NRI._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    
    #-----< NumberOfIuInstances >-----#
    NumberOfIuInstances = INT(name=u'NumberOfIuInstances', mode=MODE_TYPE)
    NumberOfIuInstances._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< NumberOfSteps >-----#
    NumberOfSteps = INT(name=u'NumberOfSteps', mode=MODE_TYPE)
    NumberOfSteps._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Offload-RAB-Parameters >-----#
    Offload_RAB_Parameters = SEQ(name=u'Offload-RAB-Parameters', mode=MODE_TYPE)
    _Offload_RAB_Parameters_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Offload-RAB-Parameters-APN')))
    _Offload_RAB_Parameters_chargingCharacteristics = OCT_STR(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Offload-RAB-Parameters-ChargingCharacteristics')))
    _Offload_RAB_Parameters_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Offload_RAB_Parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Offload_RAB_Parameters_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Offload_RAB_Parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Offload_RAB_Parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Offload_RAB_Parameters_iE_Extensions__item__id._const_tab = ____Offload_RAB_Parameters_iE_Extensions__item__id_tab
    ___Offload_RAB_Parameters_iE_Extensions__item__id._const_tab_at = None
    ___Offload_RAB_Parameters_iE_Extensions__item__id._const_tab_id = u'id'
    ___Offload_RAB_Parameters_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Offload_RAB_Parameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Offload_RAB_Parameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Offload_RAB_Parameters_iE_Extensions__item__criticality._const_tab = ____Offload_RAB_Parameters_iE_Extensions__item__criticality_tab
    ___Offload_RAB_Parameters_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Offload_RAB_Parameters_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Offload_RAB_Parameters_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Offload_RAB_Parameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Offload_RAB_Parameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Offload_RAB_Parameters_iE_Extensions__item__extensionValue._const_tab = ____Offload_RAB_Parameters_iE_Extensions__item__extensionValue_tab
    ___Offload_RAB_Parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Offload_RAB_Parameters_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Offload_RAB_Parameters_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Offload_RAB_Parameters_iE_Extensions__item__id),
        (u'criticality', ___Offload_RAB_Parameters_iE_Extensions__item__criticality),
        (u'extensionValue', ___Offload_RAB_Parameters_iE_Extensions__item__extensionValue),
        ])
    __Offload_RAB_Parameters_iE_Extensions__item_._ext = None
    _Offload_RAB_Parameters_iE_Extensions._cont = __Offload_RAB_Parameters_iE_Extensions__item_
    _Offload_RAB_Parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Offload_RAB_Parameters._cont = ASN1Dict([
        (u'accessPointName', _Offload_RAB_Parameters_accessPointName),
        (u'chargingCharacteristics', _Offload_RAB_Parameters_chargingCharacteristics),
        (u'iE-Extensions', _Offload_RAB_Parameters_iE_Extensions),
        ])
    Offload_RAB_Parameters._ext = []
    
    #-----< Offload-RAB-Parameters-ExtIEs >-----#
    Offload_RAB_Parameters_ExtIEs = CLASS(name=u'Offload-RAB-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    Offload_RAB_Parameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Offload-RAB-Parameters-APN >-----#
    Offload_RAB_Parameters_APN = OCT_STR(name=u'Offload-RAB-Parameters-APN', mode=MODE_TYPE)
    Offload_RAB_Parameters_APN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    
    #-----< Offload-RAB-Parameters-ChargingCharacteristics >-----#
    Offload_RAB_Parameters_ChargingCharacteristics = OCT_STR(name=u'Offload-RAB-Parameters-ChargingCharacteristics', mode=MODE_TYPE)
    Offload_RAB_Parameters_ChargingCharacteristics._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< OldBSS-ToNewBSS-Information >-----#
    OldBSS_ToNewBSS_Information = OCT_STR(name=u'OldBSS-ToNewBSS-Information', mode=MODE_TYPE)
    
    #-----< OMC-ID >-----#
    OMC_ID = OCT_STR(name=u'OMC-ID', mode=MODE_TYPE)
    OMC_ID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=22)], ev=None, er=[])
    
    #-----< Out-Of-UTRAN >-----#
    Out_Of_UTRAN = ENUM(name=u'Out-Of-UTRAN', mode=MODE_TYPE)
    Out_Of_UTRAN._cont = ASN1Dict([(u'cell-reselection-to-EUTRAN', 0)])
    Out_Of_UTRAN._ext = []
    
    #-----< PagingAreaID >-----#
    PagingAreaID = CHOICE(name=u'PagingAreaID', mode=MODE_TYPE)
    _PagingAreaID_lAI = SEQ(name=u'lAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LAI')))
    _PagingAreaID_rAI = SEQ(name=u'rAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAI')))
    PagingAreaID._cont = ASN1Dict([
        (u'lAI', _PagingAreaID_lAI),
        (u'rAI', _PagingAreaID_rAI),
        ])
    PagingAreaID._ext = []
    
    #-----< PagingCause >-----#
    PagingCause = ENUM(name=u'PagingCause', mode=MODE_TYPE)
    PagingCause._cont = ASN1Dict([(u'terminating-conversational-call', 0), (u'terminating-streaming-call', 1), (u'terminating-interactive-call', 2), (u'terminating-background-call', 3), (u'terminating-low-priority-signalling', 4), (u'terminating-high-priority-signalling', 5)])
    PagingCause._ext = [u'terminating-high-priority-signalling']
    
    #-----< PDP-TypeInformation >-----#
    PDP_TypeInformation = SEQ_OF(name=u'PDP-TypeInformation', mode=MODE_TYPE)
    _PDP_TypeInformation__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PDP-Type')))
    PDP_TypeInformation._cont = _PDP_TypeInformation__item_
    PDP_TypeInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< PDP-Type >-----#
    PDP_Type = ENUM(name=u'PDP-Type', mode=MODE_TYPE)
    PDP_Type._cont = ASN1Dict([(u'empty', 0), (u'ppp', 1), (u'osp-ihoss', 2), (u'ipv4', 3), (u'ipv6', 4)])
    PDP_Type._ext = []
    
    #-----< PDP-TypeInformation-extension >-----#
    PDP_TypeInformation_extension = SEQ_OF(name=u'PDP-TypeInformation-extension', mode=MODE_TYPE)
    _PDP_TypeInformation_extension__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PDP-Type-extension')))
    PDP_TypeInformation_extension._cont = _PDP_TypeInformation_extension__item_
    PDP_TypeInformation_extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< PDP-Type-extension >-----#
    PDP_Type_extension = ENUM(name=u'PDP-Type-extension', mode=MODE_TYPE)
    PDP_Type_extension._cont = ASN1Dict([(u'ipv4-and-ipv6', 0)])
    PDP_Type_extension._ext = []
    
    #-----< PDUType14FrameSequenceNumber >-----#
    PDUType14FrameSequenceNumber = INT(name=u'PDUType14FrameSequenceNumber', mode=MODE_TYPE)
    PDUType14FrameSequenceNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    
    #-----< PeriodicLocationInfo >-----#
    PeriodicLocationInfo = SEQ(name=u'PeriodicLocationInfo', mode=MODE_TYPE)
    _PeriodicLocationInfo_reportingAmount = INT(name=u'reportingAmount', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PeriodicLocationInfo_reportingAmount._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8639999)], ev=[], er=[])
    _PeriodicLocationInfo_reportingInterval = INT(name=u'reportingInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PeriodicLocationInfo_reportingInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8639999)], ev=[], er=[])
    _PeriodicLocationInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PeriodicLocationInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___PeriodicLocationInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PeriodicLocationInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____PeriodicLocationInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PeriodicLocationInfo_iE_Extensions__item__id._const_tab = ____PeriodicLocationInfo_iE_Extensions__item__id_tab
    ___PeriodicLocationInfo_iE_Extensions__item__id._const_tab_at = None
    ___PeriodicLocationInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___PeriodicLocationInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PeriodicLocationInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____PeriodicLocationInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PeriodicLocationInfo_iE_Extensions__item__criticality._const_tab = ____PeriodicLocationInfo_iE_Extensions__item__criticality_tab
    ___PeriodicLocationInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PeriodicLocationInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PeriodicLocationInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PeriodicLocationInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____PeriodicLocationInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PeriodicLocationInfo_iE_Extensions__item__extensionValue._const_tab = ____PeriodicLocationInfo_iE_Extensions__item__extensionValue_tab
    ___PeriodicLocationInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PeriodicLocationInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PeriodicLocationInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PeriodicLocationInfo_iE_Extensions__item__id),
        (u'criticality', ___PeriodicLocationInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___PeriodicLocationInfo_iE_Extensions__item__extensionValue),
        ])
    __PeriodicLocationInfo_iE_Extensions__item_._ext = None
    _PeriodicLocationInfo_iE_Extensions._cont = __PeriodicLocationInfo_iE_Extensions__item_
    _PeriodicLocationInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PeriodicLocationInfo._cont = ASN1Dict([
        (u'reportingAmount', _PeriodicLocationInfo_reportingAmount),
        (u'reportingInterval', _PeriodicLocationInfo_reportingInterval),
        (u'iE-Extensions', _PeriodicLocationInfo_iE_Extensions),
        ])
    PeriodicLocationInfo._ext = []
    
    #-----< PeriodicLocationInfo-ExtIEs >-----#
    PeriodicLocationInfo_ExtIEs = CLASS(name=u'PeriodicLocationInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    PeriodicLocationInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PermanentNAS-UE-ID >-----#
    PermanentNAS_UE_ID = CHOICE(name=u'PermanentNAS-UE-ID', mode=MODE_TYPE)
    _PermanentNAS_UE_ID_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IMSI')))
    PermanentNAS_UE_ID._cont = ASN1Dict([
        (u'iMSI', _PermanentNAS_UE_ID_iMSI),
        ])
    PermanentNAS_UE_ID._ext = []
    
    #-----< PermittedEncryptionAlgorithms >-----#
    PermittedEncryptionAlgorithms = SEQ_OF(name=u'PermittedEncryptionAlgorithms', mode=MODE_TYPE)
    _PermittedEncryptionAlgorithms__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'EncryptionAlgorithm')))
    PermittedEncryptionAlgorithms._cont = _PermittedEncryptionAlgorithms__item_
    PermittedEncryptionAlgorithms._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PermittedIntegrityProtectionAlgorithms >-----#
    PermittedIntegrityProtectionAlgorithms = SEQ_OF(name=u'PermittedIntegrityProtectionAlgorithms', mode=MODE_TYPE)
    _PermittedIntegrityProtectionAlgorithms__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IntegrityProtectionAlgorithm')))
    PermittedIntegrityProtectionAlgorithms._cont = _PermittedIntegrityProtectionAlgorithms__item_
    PermittedIntegrityProtectionAlgorithms._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< LABased >-----#
    LABased = SEQ(name=u'LABased', mode=MODE_TYPE)
    _LABased_laiList = SEQ_OF(name=u'laiList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LAI-List')))
    _LABased_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LABased_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___LABased_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____LABased_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LABased_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LABased_iE_Extensions__item__id._const_tab = ____LABased_iE_Extensions__item__id_tab
    ___LABased_iE_Extensions__item__id._const_tab_at = None
    ___LABased_iE_Extensions__item__id._const_tab_id = u'id'
    ___LABased_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____LABased_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LABased_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LABased_iE_Extensions__item__criticality._const_tab = ____LABased_iE_Extensions__item__criticality_tab
    ___LABased_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LABased_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LABased_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____LABased_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LABased_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LABased_iE_Extensions__item__extensionValue._const_tab = ____LABased_iE_Extensions__item__extensionValue_tab
    ___LABased_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LABased_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LABased_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LABased_iE_Extensions__item__id),
        (u'criticality', ___LABased_iE_Extensions__item__criticality),
        (u'extensionValue', ___LABased_iE_Extensions__item__extensionValue),
        ])
    __LABased_iE_Extensions__item_._ext = None
    _LABased_iE_Extensions._cont = __LABased_iE_Extensions__item_
    _LABased_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LABased._cont = ASN1Dict([
        (u'laiList', _LABased_laiList),
        (u'iE-Extensions', _LABased_iE_Extensions),
        ])
    LABased._ext = []
    
    #-----< LABased-ExtIEs >-----#
    LABased_ExtIEs = CLASS(name=u'LABased-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    LABased_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LAI-List >-----#
    LAI_List = SEQ_OF(name=u'LAI-List', mode=MODE_TYPE)
    _LAI_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LAI')))
    LAI_List._cont = _LAI_List__item_
    LAI_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< LoggedMDT >-----#
    LoggedMDT = SEQ(name=u'LoggedMDT', mode=MODE_TYPE)
    _LoggedMDT_loggingInterval = ENUM(name=u'loggingInterval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LoggingInterval')))
    _LoggedMDT_loggingDuration = ENUM(name=u'loggingDuration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LoggingDuration')))
    _LoggedMDT_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LoggedMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___LoggedMDT_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____LoggedMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LoggedMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LoggedMDT_iE_Extensions__item__id._const_tab = ____LoggedMDT_iE_Extensions__item__id_tab
    ___LoggedMDT_iE_Extensions__item__id._const_tab_at = None
    ___LoggedMDT_iE_Extensions__item__id._const_tab_id = u'id'
    ___LoggedMDT_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____LoggedMDT_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LoggedMDT_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LoggedMDT_iE_Extensions__item__criticality._const_tab = ____LoggedMDT_iE_Extensions__item__criticality_tab
    ___LoggedMDT_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LoggedMDT_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LoggedMDT_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____LoggedMDT_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LoggedMDT_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LoggedMDT_iE_Extensions__item__extensionValue._const_tab = ____LoggedMDT_iE_Extensions__item__extensionValue_tab
    ___LoggedMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LoggedMDT_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LoggedMDT_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LoggedMDT_iE_Extensions__item__id),
        (u'criticality', ___LoggedMDT_iE_Extensions__item__criticality),
        (u'extensionValue', ___LoggedMDT_iE_Extensions__item__extensionValue),
        ])
    __LoggedMDT_iE_Extensions__item_._ext = None
    _LoggedMDT_iE_Extensions._cont = __LoggedMDT_iE_Extensions__item_
    _LoggedMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LoggedMDT._cont = ASN1Dict([
        (u'loggingInterval', _LoggedMDT_loggingInterval),
        (u'loggingDuration', _LoggedMDT_loggingDuration),
        (u'iE-Extensions', _LoggedMDT_iE_Extensions),
        ])
    LoggedMDT._ext = []
    
    #-----< LoggedMDT-ExtIEs >-----#
    LoggedMDT_ExtIEs = CLASS(name=u'LoggedMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    LoggedMDT_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LoggingInterval >-----#
    LoggingInterval = ENUM(name=u'LoggingInterval', mode=MODE_TYPE)
    LoggingInterval._cont = ASN1Dict([(u's1d28', 0), (u's2d56', 1), (u's5d12', 2), (u's10d24', 3), (u's20d48', 4), (u's30d72', 5), (u's40d96', 6), (u's61d44', 7)])
    LoggingInterval._ext = []
    
    #-----< LoggingDuration >-----#
    LoggingDuration = ENUM(name=u'LoggingDuration', mode=MODE_TYPE)
    LoggingDuration._cont = ASN1Dict([(u'min10', 0), (u'min20', 1), (u'min40', 2), (u'min60', 3), (u'min90', 4), (u'min120', 5)])
    LoggingDuration._ext = []
    
    #-----< PLMNBased >-----#
    PLMNBased = SEQ(name=u'PLMNBased', mode=MODE_TYPE)
    _PLMNBased_plmnList = SEQ_OF(name=u'plmnList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNList')))
    _PLMNBased_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PLMNBased_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___PLMNBased_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PLMNBased_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____PLMNBased_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLMNBased_iE_Extensions__item__id._const_tab = ____PLMNBased_iE_Extensions__item__id_tab
    ___PLMNBased_iE_Extensions__item__id._const_tab_at = None
    ___PLMNBased_iE_Extensions__item__id._const_tab_id = u'id'
    ___PLMNBased_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PLMNBased_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____PLMNBased_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLMNBased_iE_Extensions__item__criticality._const_tab = ____PLMNBased_iE_Extensions__item__criticality_tab
    ___PLMNBased_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PLMNBased_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PLMNBased_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PLMNBased_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____PLMNBased_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLMNBased_iE_Extensions__item__extensionValue._const_tab = ____PLMNBased_iE_Extensions__item__extensionValue_tab
    ___PLMNBased_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PLMNBased_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PLMNBased_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PLMNBased_iE_Extensions__item__id),
        (u'criticality', ___PLMNBased_iE_Extensions__item__criticality),
        (u'extensionValue', ___PLMNBased_iE_Extensions__item__extensionValue),
        ])
    __PLMNBased_iE_Extensions__item_._ext = None
    _PLMNBased_iE_Extensions._cont = __PLMNBased_iE_Extensions__item_
    _PLMNBased_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PLMNBased._cont = ASN1Dict([
        (u'plmnList', _PLMNBased_plmnList),
        (u'iE-Extensions', _PLMNBased_iE_Extensions),
        ])
    PLMNBased._ext = []
    
    #-----< PLMNBased-ExtIEs >-----#
    PLMNBased_ExtIEs = CLASS(name=u'PLMNBased-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    PLMNBased_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PLMNList >-----#
    PLMNList = SEQ_OF(name=u'PLMNList', mode=MODE_TYPE)
    _PLMNList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    PLMNList._cont = _PLMNList__item_
    PLMNList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PLMNidentity >-----#
    PLMNidentity = OCT_STR(name=u'PLMNidentity', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TBCD-STRING')))
    PLMNidentity._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< PLMNs-in-shared-network >-----#
    PLMNs_in_shared_network = SEQ_OF(name=u'PLMNs-in-shared-network', mode=MODE_TYPE)
    _PLMNs_in_shared_network__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __PLMNs_in_shared_network__item__pLMNidentity = OCT_STR(name=u'pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    __PLMNs_in_shared_network__item__lA_LIST = SEQ_OF(name=u'lA-LIST', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LA-LIST')))
    __PLMNs_in_shared_network__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___PLMNs_in_shared_network__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____PLMNs_in_shared_network__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    _____PLMNs_in_shared_network__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____PLMNs_in_shared_network__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____PLMNs_in_shared_network__item__iE_Extensions__item__id._const_tab = _____PLMNs_in_shared_network__item__iE_Extensions__item__id_tab
    ____PLMNs_in_shared_network__item__iE_Extensions__item__id._const_tab_at = None
    ____PLMNs_in_shared_network__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____PLMNs_in_shared_network__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____PLMNs_in_shared_network__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____PLMNs_in_shared_network__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____PLMNs_in_shared_network__item__iE_Extensions__item__criticality._const_tab = _____PLMNs_in_shared_network__item__iE_Extensions__item__criticality_tab
    ____PLMNs_in_shared_network__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____PLMNs_in_shared_network__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____PLMNs_in_shared_network__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____PLMNs_in_shared_network__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____PLMNs_in_shared_network__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____PLMNs_in_shared_network__item__iE_Extensions__item__extensionValue._const_tab = _____PLMNs_in_shared_network__item__iE_Extensions__item__extensionValue_tab
    ____PLMNs_in_shared_network__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____PLMNs_in_shared_network__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___PLMNs_in_shared_network__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____PLMNs_in_shared_network__item__iE_Extensions__item__id),
        (u'criticality', ____PLMNs_in_shared_network__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____PLMNs_in_shared_network__item__iE_Extensions__item__extensionValue),
        ])
    ___PLMNs_in_shared_network__item__iE_Extensions__item_._ext = None
    __PLMNs_in_shared_network__item__iE_Extensions._cont = ___PLMNs_in_shared_network__item__iE_Extensions__item_
    __PLMNs_in_shared_network__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _PLMNs_in_shared_network__item_._cont = ASN1Dict([
        (u'pLMNidentity', __PLMNs_in_shared_network__item__pLMNidentity),
        (u'lA-LIST', __PLMNs_in_shared_network__item__lA_LIST),
        (u'iE-Extensions', __PLMNs_in_shared_network__item__iE_Extensions),
        ])
    _PLMNs_in_shared_network__item_._ext = []
    PLMNs_in_shared_network._cont = _PLMNs_in_shared_network__item_
    PLMNs_in_shared_network._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< PLMNs-in-shared-network-ExtIEs >-----#
    PLMNs_in_shared_network_ExtIEs = CLASS(name=u'PLMNs-in-shared-network-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    PLMNs_in_shared_network_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Port-Number >-----#
    Port_Number = OCT_STR(name=u'Port-Number', mode=MODE_TYPE)
    Port_Number._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< PositioningDataDiscriminator >-----#
    PositioningDataDiscriminator = BIT_STR(name=u'PositioningDataDiscriminator', mode=MODE_TYPE)
    PositioningDataDiscriminator._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< PositioningDataSet >-----#
    PositioningDataSet = SEQ_OF(name=u'PositioningDataSet', mode=MODE_TYPE)
    _PositioningDataSet__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PositioningMethodAndUsage')))
    PositioningDataSet._cont = _PositioningDataSet__item_
    PositioningDataSet._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< PositioningMethodAndUsage >-----#
    PositioningMethodAndUsage = OCT_STR(name=u'PositioningMethodAndUsage', mode=MODE_TYPE)
    PositioningMethodAndUsage._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< PositioningPriority >-----#
    PositioningPriority = ENUM(name=u'PositioningPriority', mode=MODE_TYPE)
    PositioningPriority._cont = ASN1Dict([(u'high-Priority', 0), (u'normal-Priority', 1)])
    PositioningPriority._ext = []
    
    #-----< PositionData >-----#
    PositionData = SEQ(name=u'PositionData', mode=MODE_TYPE)
    _PositionData_positioningDataDiscriminator = BIT_STR(name=u'positioningDataDiscriminator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PositioningDataDiscriminator')))
    _PositionData_positioningDataSet = SEQ_OF(name=u'positioningDataSet', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PositioningDataSet')), opt=True)
    _PositionData_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PositionData_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___PositionData_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PositionData_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____PositionData_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GANSS-PositioningDataSet')))
    _____PositionData_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Additional-PositioningDataSet')))
    ____PositionData_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 184), (u'criticality', u'ignore'), (u'Extension', _____PositionData_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 284), (u'criticality', u'ignore'), (u'Extension', _____PositionData_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PositionData_iE_Extensions__item__id._const_tab = ____PositionData_iE_Extensions__item__id_tab
    ___PositionData_iE_Extensions__item__id._const_tab_at = None
    ___PositionData_iE_Extensions__item__id._const_tab_id = u'id'
    ___PositionData_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___PositionData_iE_Extensions__item__criticality._const_tab = ____PositionData_iE_Extensions__item__id_tab
    ___PositionData_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PositionData_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PositionData_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___PositionData_iE_Extensions__item__extensionValue._const_tab = ____PositionData_iE_Extensions__item__id_tab
    ___PositionData_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PositionData_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PositionData_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PositionData_iE_Extensions__item__id),
        (u'criticality', ___PositionData_iE_Extensions__item__criticality),
        (u'extensionValue', ___PositionData_iE_Extensions__item__extensionValue),
        ])
    __PositionData_iE_Extensions__item_._ext = None
    _PositionData_iE_Extensions._cont = __PositionData_iE_Extensions__item_
    _PositionData_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PositionData._cont = ASN1Dict([
        (u'positioningDataDiscriminator', _PositionData_positioningDataDiscriminator),
        (u'positioningDataSet', _PositionData_positioningDataSet),
        (u'iE-Extensions', _PositionData_iE_Extensions),
        ])
    PositionData._ext = []
    
    #-----< PositionData-ExtIEs >-----#
    PositionData_ExtIEs = CLASS(name=u'PositionData-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _PositionData_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GANSS-PositioningDataSet')))
    _PositionData_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Additional-PositioningDataSet')))
    PositionData_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 184), (u'criticality', u'ignore'), (u'Extension', _PositionData_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 284), (u'criticality', u'ignore'), (u'Extension', _PositionData_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositionDataSpecificToGERANIuMode >-----#
    PositionDataSpecificToGERANIuMode = OCT_STR(name=u'PositionDataSpecificToGERANIuMode', mode=MODE_TYPE)
    
    #-----< Pre-emptionCapability >-----#
    Pre_emptionCapability = ENUM(name=u'Pre-emptionCapability', mode=MODE_TYPE)
    Pre_emptionCapability._cont = ASN1Dict([(u'shall-not-trigger-pre-emption', 0), (u'may-trigger-pre-emption', 1)])
    Pre_emptionCapability._ext = None
    
    #-----< Pre-emptionVulnerability >-----#
    Pre_emptionVulnerability = ENUM(name=u'Pre-emptionVulnerability', mode=MODE_TYPE)
    Pre_emptionVulnerability._cont = ASN1Dict([(u'not-pre-emptable', 0), (u'pre-emptable', 1)])
    Pre_emptionVulnerability._ext = None
    
    #-----< PriorityLevel >-----#
    PriorityLevel = INT(name=u'PriorityLevel', mode=MODE_TYPE)
    PriorityLevel._cont = ASN1Dict([(u'spare', 0), (u'highest', 1), (u'lowest', 14), (u'no-priority', 15)])
    PriorityLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< Priority-Class-Indicator >-----#
    Priority_Class_Indicator = BIT_STR(name=u'Priority-Class-Indicator', mode=MODE_TYPE)
    Priority_Class_Indicator._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< ProvidedData >-----#
    ProvidedData = CHOICE(name=u'ProvidedData', mode=MODE_TYPE)
    _ProvidedData_shared_network_information = SEQ(name=u'shared-network-information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Shared-Network-Information')))
    ProvidedData._cont = ASN1Dict([
        (u'shared-network-information', _ProvidedData_shared_network_information),
        ])
    ProvidedData._ext = []
    
    #-----< PowerSavingIndicator >-----#
    PowerSavingIndicator = ENUM(name=u'PowerSavingIndicator', mode=MODE_TYPE)
    PowerSavingIndicator._cont = ASN1Dict([(u'psmConfigured', 0), (u'eDRXConfigured', 1)])
    PowerSavingIndicator._ext = []
    
    #-----< P-TMSI >-----#
    P_TMSI = OCT_STR(name=u'P-TMSI', mode=MODE_TYPE)
    P_TMSI._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< QueuingAllowed >-----#
    QueuingAllowed = ENUM(name=u'QueuingAllowed', mode=MODE_TYPE)
    QueuingAllowed._cont = ASN1Dict([(u'queueing-not-allowed', 0), (u'queueing-allowed', 1)])
    QueuingAllowed._ext = None
    
    #-----< RAB-AsymmetryIndicator >-----#
    RAB_AsymmetryIndicator = ENUM(name=u'RAB-AsymmetryIndicator', mode=MODE_TYPE)
    RAB_AsymmetryIndicator._cont = ASN1Dict([(u'symmetric-bidirectional', 0), (u'asymmetric-unidirectional-downlink', 1), (u'asymmetric-unidirectional-uplink', 2), (u'asymmetric-bidirectional', 3)])
    RAB_AsymmetryIndicator._ext = []
    
    #-----< RABased >-----#
    RABased = SEQ(name=u'RABased', mode=MODE_TYPE)
    _RABased_raiList = SEQ_OF(name=u'raiList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAI-List')))
    _RABased_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RABased_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RABased_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RABased_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RABased_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RABased_iE_Extensions__item__id._const_tab = ____RABased_iE_Extensions__item__id_tab
    ___RABased_iE_Extensions__item__id._const_tab_at = None
    ___RABased_iE_Extensions__item__id._const_tab_id = u'id'
    ___RABased_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RABased_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RABased_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RABased_iE_Extensions__item__criticality._const_tab = ____RABased_iE_Extensions__item__criticality_tab
    ___RABased_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RABased_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RABased_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RABased_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RABased_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RABased_iE_Extensions__item__extensionValue._const_tab = ____RABased_iE_Extensions__item__extensionValue_tab
    ___RABased_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RABased_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RABased_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RABased_iE_Extensions__item__id),
        (u'criticality', ___RABased_iE_Extensions__item__criticality),
        (u'extensionValue', ___RABased_iE_Extensions__item__extensionValue),
        ])
    __RABased_iE_Extensions__item_._ext = None
    _RABased_iE_Extensions._cont = __RABased_iE_Extensions__item_
    _RABased_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RABased._cont = ASN1Dict([
        (u'raiList', _RABased_raiList),
        (u'iE-Extensions', _RABased_iE_Extensions),
        ])
    RABased._ext = []
    
    #-----< RABased-ExtIEs >-----#
    RABased_ExtIEs = CLASS(name=u'RABased-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RABased_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAI-List >-----#
    RAI_List = SEQ_OF(name=u'RAI-List', mode=MODE_TYPE)
    _RAI_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAI')))
    RAI_List._cont = _RAI_List__item_
    RAI_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< RABDataVolumeReport >-----#
    RABDataVolumeReport = SEQ_OF(name=u'RABDataVolumeReport', mode=MODE_TYPE)
    _RABDataVolumeReport__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __RABDataVolumeReport__item__dl_UnsuccessfullyTransmittedDataVolume = INT(name=u'dl-UnsuccessfullyTransmittedDataVolume', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UnsuccessfullyTransmittedDataVolume')))
    __RABDataVolumeReport__item__dataVolumeReference = INT(name=u'dataVolumeReference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DataVolumeReference')), opt=True)
    __RABDataVolumeReport__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___RABDataVolumeReport__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____RABDataVolumeReport__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    _____RABDataVolumeReport__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RABDataVolumeReport__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RABDataVolumeReport__item__iE_Extensions__item__id._const_tab = _____RABDataVolumeReport__item__iE_Extensions__item__id_tab
    ____RABDataVolumeReport__item__iE_Extensions__item__id._const_tab_at = None
    ____RABDataVolumeReport__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____RABDataVolumeReport__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____RABDataVolumeReport__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RABDataVolumeReport__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RABDataVolumeReport__item__iE_Extensions__item__criticality._const_tab = _____RABDataVolumeReport__item__iE_Extensions__item__criticality_tab
    ____RABDataVolumeReport__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____RABDataVolumeReport__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____RABDataVolumeReport__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____RABDataVolumeReport__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RABDataVolumeReport__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RABDataVolumeReport__item__iE_Extensions__item__extensionValue._const_tab = _____RABDataVolumeReport__item__iE_Extensions__item__extensionValue_tab
    ____RABDataVolumeReport__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____RABDataVolumeReport__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___RABDataVolumeReport__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____RABDataVolumeReport__item__iE_Extensions__item__id),
        (u'criticality', ____RABDataVolumeReport__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____RABDataVolumeReport__item__iE_Extensions__item__extensionValue),
        ])
    ___RABDataVolumeReport__item__iE_Extensions__item_._ext = None
    __RABDataVolumeReport__item__iE_Extensions._cont = ___RABDataVolumeReport__item__iE_Extensions__item_
    __RABDataVolumeReport__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _RABDataVolumeReport__item_._cont = ASN1Dict([
        (u'dl-UnsuccessfullyTransmittedDataVolume', __RABDataVolumeReport__item__dl_UnsuccessfullyTransmittedDataVolume),
        (u'dataVolumeReference', __RABDataVolumeReport__item__dataVolumeReference),
        (u'iE-Extensions', __RABDataVolumeReport__item__iE_Extensions),
        ])
    _RABDataVolumeReport__item_._ext = []
    RABDataVolumeReport._cont = _RABDataVolumeReport__item_
    RABDataVolumeReport._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< RABDataVolumeReport-ExtIEs >-----#
    RABDataVolumeReport_ExtIEs = CLASS(name=u'RABDataVolumeReport-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RABDataVolumeReport_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-ID >-----#
    RAB_ID = BIT_STR(name=u'RAB-ID', mode=MODE_TYPE)
    RAB_ID._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< RAB-Parameter-ExtendedGuaranteedBitrateList >-----#
    RAB_Parameter_ExtendedGuaranteedBitrateList = SEQ_OF(name=u'RAB-Parameter-ExtendedGuaranteedBitrateList', mode=MODE_TYPE)
    _RAB_Parameter_ExtendedGuaranteedBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedGuaranteedBitrate')))
    RAB_Parameter_ExtendedGuaranteedBitrateList._cont = _RAB_Parameter_ExtendedGuaranteedBitrateList__item_
    RAB_Parameter_ExtendedGuaranteedBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< RAB-Parameter-ExtendedMaxBitrateList >-----#
    RAB_Parameter_ExtendedMaxBitrateList = SEQ_OF(name=u'RAB-Parameter-ExtendedMaxBitrateList', mode=MODE_TYPE)
    _RAB_Parameter_ExtendedMaxBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedMaxBitrate')))
    RAB_Parameter_ExtendedMaxBitrateList._cont = _RAB_Parameter_ExtendedMaxBitrateList__item_
    RAB_Parameter_ExtendedMaxBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< RAB-Parameter-GuaranteedBitrateList >-----#
    RAB_Parameter_GuaranteedBitrateList = SEQ_OF(name=u'RAB-Parameter-GuaranteedBitrateList', mode=MODE_TYPE)
    _RAB_Parameter_GuaranteedBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GuaranteedBitrate')))
    RAB_Parameter_GuaranteedBitrateList._cont = _RAB_Parameter_GuaranteedBitrateList__item_
    RAB_Parameter_GuaranteedBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< RAB-Parameter-MaxBitrateList >-----#
    RAB_Parameter_MaxBitrateList = SEQ_OF(name=u'RAB-Parameter-MaxBitrateList', mode=MODE_TYPE)
    _RAB_Parameter_MaxBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MaxBitrate')))
    RAB_Parameter_MaxBitrateList._cont = _RAB_Parameter_MaxBitrateList__item_
    RAB_Parameter_MaxBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< RAB-Parameters >-----#
    RAB_Parameters = SEQ(name=u'RAB-Parameters', mode=MODE_TYPE)
    _RAB_Parameters_trafficClass = ENUM(name=u'trafficClass', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TrafficClass')))
    _RAB_Parameters_rAB_AsymmetryIndicator = ENUM(name=u'rAB-AsymmetryIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-AsymmetryIndicator')))
    _RAB_Parameters_maxBitrate = SEQ_OF(name=u'maxBitrate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameter-MaxBitrateList')))
    _RAB_Parameters_guaranteedBitRate = SEQ_OF(name=u'guaranteedBitRate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameter-GuaranteedBitrateList')), opt=True)
    _RAB_Parameters_deliveryOrder = ENUM(name=u'deliveryOrder', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DeliveryOrder')))
    _RAB_Parameters_maxSDU_Size = INT(name=u'maxSDU-Size', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'MaxSDU-Size')))
    _RAB_Parameters_sDU_Parameters = SEQ_OF(name=u'sDU-Parameters', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SDU-Parameters')))
    _RAB_Parameters_transferDelay = INT(name=u'transferDelay', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TransferDelay')), opt=True)
    _RAB_Parameters_trafficHandlingPriority = INT(name=u'trafficHandlingPriority', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TrafficHandlingPriority')), opt=True)
    _RAB_Parameters_allocationOrRetentionPriority = SEQ(name=u'allocationOrRetentionPriority', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'AllocationOrRetentionPriority')), opt=True)
    _RAB_Parameters_sourceStatisticsDescriptor = ENUM(name=u'sourceStatisticsDescriptor', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SourceStatisticsDescriptor')), opt=True)
    _RAB_Parameters_relocationRequirement = ENUM(name=u'relocationRequirement', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RelocationRequirement')), opt=True)
    _RAB_Parameters_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_Parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_Parameters_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_Parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SignallingIndication')))
    _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameter-ExtendedGuaranteedBitrateList')))
    _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameter-ExtendedMaxBitrateList')))
    _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    ____RAB_Parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 116), (u'criticality', u'ignore'), (u'Extension', _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 176), (u'criticality', u'reject'), (u'Extension', _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 177), (u'criticality', u'reject'), (u'Extension', _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 219), (u'criticality', u'reject'), (u'Extension', _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 218), (u'criticality', u'reject'), (u'Extension', _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RAB_Parameters_iE_Extensions__item__id._const_tab = ____RAB_Parameters_iE_Extensions__item__id_tab
    ___RAB_Parameters_iE_Extensions__item__id._const_tab_at = None
    ___RAB_Parameters_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAB_Parameters_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RAB_Parameters_iE_Extensions__item__criticality._const_tab = ____RAB_Parameters_iE_Extensions__item__id_tab
    ___RAB_Parameters_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_Parameters_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_Parameters_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RAB_Parameters_iE_Extensions__item__extensionValue._const_tab = ____RAB_Parameters_iE_Extensions__item__id_tab
    ___RAB_Parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_Parameters_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_Parameters_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_Parameters_iE_Extensions__item__id),
        (u'criticality', ___RAB_Parameters_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAB_Parameters_iE_Extensions__item__extensionValue),
        ])
    __RAB_Parameters_iE_Extensions__item_._ext = None
    _RAB_Parameters_iE_Extensions._cont = __RAB_Parameters_iE_Extensions__item_
    _RAB_Parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_Parameters._cont = ASN1Dict([
        (u'trafficClass', _RAB_Parameters_trafficClass),
        (u'rAB-AsymmetryIndicator', _RAB_Parameters_rAB_AsymmetryIndicator),
        (u'maxBitrate', _RAB_Parameters_maxBitrate),
        (u'guaranteedBitRate', _RAB_Parameters_guaranteedBitRate),
        (u'deliveryOrder', _RAB_Parameters_deliveryOrder),
        (u'maxSDU-Size', _RAB_Parameters_maxSDU_Size),
        (u'sDU-Parameters', _RAB_Parameters_sDU_Parameters),
        (u'transferDelay', _RAB_Parameters_transferDelay),
        (u'trafficHandlingPriority', _RAB_Parameters_trafficHandlingPriority),
        (u'allocationOrRetentionPriority', _RAB_Parameters_allocationOrRetentionPriority),
        (u'sourceStatisticsDescriptor', _RAB_Parameters_sourceStatisticsDescriptor),
        (u'relocationRequirement', _RAB_Parameters_relocationRequirement),
        (u'iE-Extensions', _RAB_Parameters_iE_Extensions),
        ])
    RAB_Parameters._ext = []
    
    #-----< RAB-Parameters-ExtIEs >-----#
    RAB_Parameters_ExtIEs = CLASS(name=u'RAB-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RAB_Parameters_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SignallingIndication')))
    _RAB_Parameters_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameter-ExtendedGuaranteedBitrateList')))
    _RAB_Parameters_ExtIEs_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameter-ExtendedMaxBitrateList')))
    _RAB_Parameters_ExtIEs_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    _RAB_Parameters_ExtIEs_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    RAB_Parameters_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 116), (u'criticality', u'ignore'), (u'Extension', _RAB_Parameters_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 176), (u'criticality', u'reject'), (u'Extension', _RAB_Parameters_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 177), (u'criticality', u'reject'), (u'Extension', _RAB_Parameters_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 219), (u'criticality', u'reject'), (u'Extension', _RAB_Parameters_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 218), (u'criticality', u'reject'), (u'Extension', _RAB_Parameters_ExtIEs_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RABParametersList >-----#
    RABParametersList = SEQ_OF(name=u'RABParametersList', mode=MODE_TYPE)
    _RABParametersList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __RABParametersList__item__rab_Id = BIT_STR(name=u'rab-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    __RABParametersList__item__cn_domain = ENUM(name=u'cn-domain', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    __RABParametersList__item__rabDataVolumeReport = SEQ_OF(name=u'rabDataVolumeReport', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RABDataVolumeReport')), opt=True)
    __RABParametersList__item__upInformation = SEQ(name=u'upInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UPInformation')), opt=True)
    __RABParametersList__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___RABParametersList__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____RABParametersList__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    _____RABParametersList__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RABParametersList__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RABParametersList__item__iE_Extensions__item__id._const_tab = _____RABParametersList__item__iE_Extensions__item__id_tab
    ____RABParametersList__item__iE_Extensions__item__id._const_tab_at = None
    ____RABParametersList__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____RABParametersList__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____RABParametersList__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RABParametersList__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RABParametersList__item__iE_Extensions__item__criticality._const_tab = _____RABParametersList__item__iE_Extensions__item__criticality_tab
    ____RABParametersList__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____RABParametersList__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____RABParametersList__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____RABParametersList__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RABParametersList__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RABParametersList__item__iE_Extensions__item__extensionValue._const_tab = _____RABParametersList__item__iE_Extensions__item__extensionValue_tab
    ____RABParametersList__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____RABParametersList__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___RABParametersList__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____RABParametersList__item__iE_Extensions__item__id),
        (u'criticality', ____RABParametersList__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____RABParametersList__item__iE_Extensions__item__extensionValue),
        ])
    ___RABParametersList__item__iE_Extensions__item_._ext = None
    __RABParametersList__item__iE_Extensions._cont = ___RABParametersList__item__iE_Extensions__item_
    __RABParametersList__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _RABParametersList__item_._cont = ASN1Dict([
        (u'rab-Id', __RABParametersList__item__rab_Id),
        (u'cn-domain', __RABParametersList__item__cn_domain),
        (u'rabDataVolumeReport', __RABParametersList__item__rabDataVolumeReport),
        (u'upInformation', __RABParametersList__item__upInformation),
        (u'iE-Extensions', __RABParametersList__item__iE_Extensions),
        ])
    _RABParametersList__item_._ext = []
    RABParametersList._cont = _RABParametersList__item_
    RABParametersList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RABParametersList-ExtIEs >-----#
    RABParametersList_ExtIEs = CLASS(name=u'RABParametersList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RABParametersList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-SubflowCombinationBitRate >-----#
    RAB_SubflowCombinationBitRate = INT(name=u'RAB-SubflowCombinationBitRate', mode=MODE_TYPE)
    RAB_SubflowCombinationBitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16000000)], ev=None, er=[])
    
    #-----< RAB-TrCH-Mapping >-----#
    RAB_TrCH_Mapping = SEQ_OF(name=u'RAB-TrCH-Mapping', mode=MODE_TYPE)
    _RAB_TrCH_Mapping__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAB-TrCH-MappingItem')))
    RAB_TrCH_Mapping._cont = _RAB_TrCH_Mapping__item_
    RAB_TrCH_Mapping._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-TrCH-MappingItem >-----#
    RAB_TrCH_MappingItem = SEQ(name=u'RAB-TrCH-MappingItem', mode=MODE_TYPE)
    _RAB_TrCH_MappingItem_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_TrCH_MappingItem_trCH_ID_List = SEQ_OF(name=u'trCH-ID-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TrCH-ID-List')))
    _RAB_TrCH_MappingItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_TrCH_MappingItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_TrCH_MappingItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_TrCH_MappingItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RAB_TrCH_MappingItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    ____RAB_TrCH_MappingItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Extension', _____RAB_TrCH_MappingItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RAB_TrCH_MappingItem_iE_Extensions__item__id._const_tab = ____RAB_TrCH_MappingItem_iE_Extensions__item__id_tab
    ___RAB_TrCH_MappingItem_iE_Extensions__item__id._const_tab_at = None
    ___RAB_TrCH_MappingItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAB_TrCH_MappingItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RAB_TrCH_MappingItem_iE_Extensions__item__criticality._const_tab = ____RAB_TrCH_MappingItem_iE_Extensions__item__id_tab
    ___RAB_TrCH_MappingItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_TrCH_MappingItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_TrCH_MappingItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RAB_TrCH_MappingItem_iE_Extensions__item__extensionValue._const_tab = ____RAB_TrCH_MappingItem_iE_Extensions__item__id_tab
    ___RAB_TrCH_MappingItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_TrCH_MappingItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_TrCH_MappingItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_TrCH_MappingItem_iE_Extensions__item__id),
        (u'criticality', ___RAB_TrCH_MappingItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAB_TrCH_MappingItem_iE_Extensions__item__extensionValue),
        ])
    __RAB_TrCH_MappingItem_iE_Extensions__item_._ext = None
    _RAB_TrCH_MappingItem_iE_Extensions._cont = __RAB_TrCH_MappingItem_iE_Extensions__item_
    _RAB_TrCH_MappingItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_TrCH_MappingItem._cont = ASN1Dict([
        (u'rAB-ID', _RAB_TrCH_MappingItem_rAB_ID),
        (u'trCH-ID-List', _RAB_TrCH_MappingItem_trCH_ID_List),
        (u'iE-Extensions', _RAB_TrCH_MappingItem_iE_Extensions),
        ])
    RAB_TrCH_MappingItem._ext = []
    
    #-----< RAB-TrCH-MappingItem-ExtIEs >-----#
    RAB_TrCH_MappingItem_ExtIEs = CLASS(name=u'RAB-TrCH-MappingItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RAB_TrCH_MappingItem_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    RAB_TrCH_MappingItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Extension', _RAB_TrCH_MappingItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAC >-----#
    RAC = OCT_STR(name=u'RAC', mode=MODE_TYPE)
    RAC._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< RAI >-----#
    RAI = SEQ(name=u'RAI', mode=MODE_TYPE)
    _RAI_lAI = SEQ(name=u'lAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LAI')))
    _RAI_rAC = OCT_STR(name=u'rAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAC')))
    _RAI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAI_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAI_iE_Extensions__item__id._const_tab = ____RAI_iE_Extensions__item__id_tab
    ___RAI_iE_Extensions__item__id._const_tab_at = None
    ___RAI_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAI_iE_Extensions__item__criticality._const_tab = ____RAI_iE_Extensions__item__criticality_tab
    ___RAI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAI_iE_Extensions__item__extensionValue._const_tab = ____RAI_iE_Extensions__item__extensionValue_tab
    ___RAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAI_iE_Extensions__item__id),
        (u'criticality', ___RAI_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAI_iE_Extensions__item__extensionValue),
        ])
    __RAI_iE_Extensions__item_._ext = None
    _RAI_iE_Extensions._cont = __RAI_iE_Extensions__item_
    _RAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAI._cont = ASN1Dict([
        (u'lAI', _RAI_lAI),
        (u'rAC', _RAI_rAC),
        (u'iE-Extensions', _RAI_iE_Extensions),
        ])
    RAI._ext = []
    
    #-----< RAI-ExtIEs >-----#
    RAI_ExtIEs = CLASS(name=u'RAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAListofIdleModeUEs >-----#
    RAListofIdleModeUEs = CHOICE(name=u'RAListofIdleModeUEs', mode=MODE_TYPE)
    _RAListofIdleModeUEs_notEmptyRAListofIdleModeUEs = SEQ(name=u'notEmptyRAListofIdleModeUEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'NotEmptyRAListofIdleModeUEs')))
    _RAListofIdleModeUEs_emptyFullRAListofIdleModeUEs = ENUM(name=u'emptyFullRAListofIdleModeUEs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RAListofIdleModeUEs_emptyFullRAListofIdleModeUEs._cont = ASN1Dict([(u'emptylist', 0), (u'fulllist', 1)])
    _RAListofIdleModeUEs_emptyFullRAListofIdleModeUEs._ext = []
    RAListofIdleModeUEs._cont = ASN1Dict([
        (u'notEmptyRAListofIdleModeUEs', _RAListofIdleModeUEs_notEmptyRAListofIdleModeUEs),
        (u'emptyFullRAListofIdleModeUEs', _RAListofIdleModeUEs_emptyFullRAListofIdleModeUEs),
        ])
    RAListofIdleModeUEs._ext = []
    
    #-----< NotEmptyRAListofIdleModeUEs >-----#
    NotEmptyRAListofIdleModeUEs = SEQ(name=u'NotEmptyRAListofIdleModeUEs', mode=MODE_TYPE)
    _NotEmptyRAListofIdleModeUEs_rAofIdleModeUEs = SEQ_OF(name=u'rAofIdleModeUEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAofIdleModeUEs')))
    _NotEmptyRAListofIdleModeUEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NotEmptyRAListofIdleModeUEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LAListofIdleModeUEs')))
    ____NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 180), (u'criticality', u'reject'), (u'Extension', _____NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'conditional')])], rr=[], ev=None, er=[])
    ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id._const_tab = ____NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id_tab
    ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id._const_tab_at = None
    ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__criticality._const_tab = ____NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id_tab
    ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__extensionValue._const_tab = ____NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id_tab
    ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NotEmptyRAListofIdleModeUEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id),
        (u'criticality', ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__extensionValue),
        ])
    __NotEmptyRAListofIdleModeUEs_iE_Extensions__item_._ext = None
    _NotEmptyRAListofIdleModeUEs_iE_Extensions._cont = __NotEmptyRAListofIdleModeUEs_iE_Extensions__item_
    _NotEmptyRAListofIdleModeUEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NotEmptyRAListofIdleModeUEs._cont = ASN1Dict([
        (u'rAofIdleModeUEs', _NotEmptyRAListofIdleModeUEs_rAofIdleModeUEs),
        (u'iE-Extensions', _NotEmptyRAListofIdleModeUEs_iE_Extensions),
        ])
    NotEmptyRAListofIdleModeUEs._ext = None
    
    #-----< RAofIdleModeUEs >-----#
    RAofIdleModeUEs = SEQ_OF(name=u'RAofIdleModeUEs', mode=MODE_TYPE)
    _RAofIdleModeUEs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAC')))
    RAofIdleModeUEs._cont = _RAofIdleModeUEs__item_
    RAofIdleModeUEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< NotEmptyRAListofIdleModeUEs-ExtIEs >-----#
    NotEmptyRAListofIdleModeUEs_ExtIEs = CLASS(name=u'NotEmptyRAListofIdleModeUEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _NotEmptyRAListofIdleModeUEs_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LAListofIdleModeUEs')))
    NotEmptyRAListofIdleModeUEs_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 180), (u'criticality', u'reject'), (u'Extension', _NotEmptyRAListofIdleModeUEs_ExtIEs_val_Extension_0), (u'presence', u'conditional')])], rr=[], ev=[], er=[])
    
    #-----< LAListofIdleModeUEs >-----#
    LAListofIdleModeUEs = SEQ_OF(name=u'LAListofIdleModeUEs', mode=MODE_TYPE)
    _LAListofIdleModeUEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LAI')))
    LAListofIdleModeUEs._cont = _LAListofIdleModeUEs__item_
    LAListofIdleModeUEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< RAT-Type >-----#
    RAT_Type = ENUM(name=u'RAT-Type', mode=MODE_TYPE)
    RAT_Type._cont = ASN1Dict([(u'utran', 0), (u'geran', 1)])
    RAT_Type._ext = []
    
    #-----< RateControlAllowed >-----#
    RateControlAllowed = ENUM(name=u'RateControlAllowed', mode=MODE_TYPE)
    RateControlAllowed._cont = ASN1Dict([(u'not-allowed', 0), (u'allowed', 1)])
    RateControlAllowed._ext = None
    
    #-----< RedirectAttemptFlag >-----#
    RedirectAttemptFlag = NULL(name=u'RedirectAttemptFlag', mode=MODE_TYPE)
    
    #-----< RedirectionCompleted >-----#
    RedirectionCompleted = ENUM(name=u'RedirectionCompleted', mode=MODE_TYPE)
    RedirectionCompleted._cont = ASN1Dict([(u'redirection-completed', 0)])
    RedirectionCompleted._ext = []
    
    #-----< RejectCauseValue >-----#
    RejectCauseValue = ENUM(name=u'RejectCauseValue', mode=MODE_TYPE)
    RejectCauseValue._cont = ASN1Dict([(u'pLMN-Not-Allowed', 0), (u'location-Area-Not-Allowed', 1), (u'roaming-Not-Allowed-In-This-Location-Area', 2), (u'no-Suitable-Cell-In-Location-Area', 3), (u'gPRS-Services-Not-Allowed-In-This-PLMN', 4), (u'cS-PS-coordination-required', 5), (u'network-failure', 6), (u'not-authorized-for-this-CSG', 7)])
    RejectCauseValue._ext = [u'network-failure', u'not-authorized-for-this-CSG']
    
    #-----< RelocationRequirement >-----#
    RelocationRequirement = ENUM(name=u'RelocationRequirement', mode=MODE_TYPE)
    RelocationRequirement._cont = ASN1Dict([(u'lossless', 0), (u'none', 1), (u'realtime', 2)])
    RelocationRequirement._ext = [u'realtime']
    
    #-----< RelocationType >-----#
    RelocationType = ENUM(name=u'RelocationType', mode=MODE_TYPE)
    RelocationType._cont = ASN1Dict([(u'ue-not-involved', 0), (u'ue-involved', 1)])
    RelocationType._ext = []
    
    #-----< RepetitionNumber0 >-----#
    RepetitionNumber0 = INT(name=u'RepetitionNumber0', mode=MODE_TYPE)
    RepetitionNumber0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< RepetitionNumber1 >-----#
    RepetitionNumber1 = INT(name=u'RepetitionNumber1', mode=MODE_TYPE)
    RepetitionNumber1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ReportArea >-----#
    ReportArea = ENUM(name=u'ReportArea', mode=MODE_TYPE)
    ReportArea._cont = ASN1Dict([(u'service-area', 0), (u'geographical-area', 1)])
    ReportArea._ext = []
    
    #-----< ReportInterval >-----#
    ReportInterval = ENUM(name=u'ReportInterval', mode=MODE_TYPE)
    ReportInterval._cont = ASN1Dict([(u'ms250', 0), (u'ms500', 1), (u'ms1000', 2), (u'ms2000', 3), (u'ms3000', 4), (u'ms4000', 5), (u'ms6000', 6), (u'ms12000', 7), (u'ms16000', 8), (u'ms20000', 9), (u'ms24000', 10), (u'ms32000', 11), (u'ms64000', 12), (u'ms8000', 13), (u'ms28000', 14)])
    ReportInterval._ext = [u'ms8000', u'ms28000']
    
    #-----< ReportAmount >-----#
    ReportAmount = ENUM(name=u'ReportAmount', mode=MODE_TYPE)
    ReportAmount._cont = ASN1Dict([(u'n1', 0), (u'n2', 1), (u'n4', 2), (u'n8', 3), (u'n16', 4), (u'n32', 5), (u'n64', 6), (u'infinity', 7)])
    ReportAmount._ext = []
    
    #-----< RequestedGPSAssistanceData >-----#
    RequestedGPSAssistanceData = OCT_STR(name=u'RequestedGPSAssistanceData', mode=MODE_TYPE)
    RequestedGPSAssistanceData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=38)], ev=None, er=[])
    
    #-----< RequestedGANSSAssistanceData >-----#
    RequestedGANSSAssistanceData = OCT_STR(name=u'RequestedGANSSAssistanceData', mode=MODE_TYPE)
    RequestedGANSSAssistanceData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=201)], ev=None, er=[])
    
    #-----< RequestedLocationRelatedDataType >-----#
    RequestedLocationRelatedDataType = ENUM(name=u'RequestedLocationRelatedDataType', mode=MODE_TYPE)
    RequestedLocationRelatedDataType._cont = ASN1Dict([(u'decipheringKeysUEBasedOTDOA', 0), (u'decipheringKeysAssistedGPS', 1), (u'dedicatedAssistanceDataUEBasedOTDOA', 2), (u'dedicatedAssistanceDataAssistedGPS', 3), (u'decipheringKeysAssistedGANSS', 4), (u'dedicatedAssistanceDataAssistedGANSS', 5), (u'decipheringKeysAssistedGPSandGANSS', 6), (u'dedicatedAssistanceDataAssistedGPSandGANSS', 7)])
    RequestedLocationRelatedDataType._ext = [u'decipheringKeysAssistedGANSS', u'dedicatedAssistanceDataAssistedGANSS', u'decipheringKeysAssistedGPSandGANSS', u'dedicatedAssistanceDataAssistedGPSandGANSS']
    
    #-----< RequestedMBMSIPMulticastAddressandAPNRequest >-----#
    RequestedMBMSIPMulticastAddressandAPNRequest = SEQ_OF(name=u'RequestedMBMSIPMulticastAddressandAPNRequest', mode=MODE_TYPE)
    _RequestedMBMSIPMulticastAddressandAPNRequest__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSIPMulticastAddressandAPNlist')))
    RequestedMBMSIPMulticastAddressandAPNRequest._cont = _RequestedMBMSIPMulticastAddressandAPNRequest__item_
    RequestedMBMSIPMulticastAddressandAPNRequest._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< MBMSIPMulticastAddressandAPNlist >-----#
    MBMSIPMulticastAddressandAPNlist = SEQ(name=u'MBMSIPMulticastAddressandAPNlist', mode=MODE_TYPE)
    _MBMSIPMulticastAddressandAPNlist_tMGI = SEQ(name=u'tMGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    _MBMSIPMulticastAddressandAPNlist_iPMulticastAddress = OCT_STR(name=u'iPMulticastAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IPMulticastAddress')))
    _MBMSIPMulticastAddressandAPNlist_aPN = OCT_STR(name=u'aPN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'APN')))
    _MBMSIPMulticastAddressandAPNlist_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSIPMulticastAddressandAPNlist_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__id._const_tab = ____MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__id_tab
    ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__id._const_tab_at = None
    ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__id._const_tab_id = u'id'
    ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__criticality._const_tab = ____MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__criticality_tab
    ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__extensionValue._const_tab = ____MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__extensionValue_tab
    ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMSIPMulticastAddressandAPNlist_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__id),
        (u'criticality', ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__criticality),
        (u'extensionValue', ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__extensionValue),
        ])
    __MBMSIPMulticastAddressandAPNlist_iE_Extensions__item_._ext = None
    _MBMSIPMulticastAddressandAPNlist_iE_Extensions._cont = __MBMSIPMulticastAddressandAPNlist_iE_Extensions__item_
    _MBMSIPMulticastAddressandAPNlist_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSIPMulticastAddressandAPNlist._cont = ASN1Dict([
        (u'tMGI', _MBMSIPMulticastAddressandAPNlist_tMGI),
        (u'iPMulticastAddress', _MBMSIPMulticastAddressandAPNlist_iPMulticastAddress),
        (u'aPN', _MBMSIPMulticastAddressandAPNlist_aPN),
        (u'iE-Extensions', _MBMSIPMulticastAddressandAPNlist_iE_Extensions),
        ])
    MBMSIPMulticastAddressandAPNlist._ext = []
    
    #-----< MBMSIPMulticastAddressandAPNlist-ExtIEs >-----#
    MBMSIPMulticastAddressandAPNlist_ExtIEs = CLASS(name=u'MBMSIPMulticastAddressandAPNlist-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSIPMulticastAddressandAPNlist_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RequestedMulticastServiceList >-----#
    RequestedMulticastServiceList = SEQ_OF(name=u'RequestedMulticastServiceList', mode=MODE_TYPE)
    _RequestedMulticastServiceList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    RequestedMulticastServiceList._cont = _RequestedMulticastServiceList__item_
    RequestedMulticastServiceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< Requested-RAB-Parameter-Values >-----#
    Requested_RAB_Parameter_Values = SEQ(name=u'Requested-RAB-Parameter-Values', mode=MODE_TYPE)
    _Requested_RAB_Parameter_Values_requestedMaxBitrates = SEQ_OF(name=u'requestedMaxBitrates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Requested-RAB-Parameter-MaxBitrateList')), opt=True)
    _Requested_RAB_Parameter_Values_requestedGuaranteedBitrates = SEQ_OF(name=u'requestedGuaranteedBitrates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Requested-RAB-Parameter-GuaranteedBitrateList')), opt=True)
    _Requested_RAB_Parameter_Values_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Requested_RAB_Parameter_Values_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Requested_RAB_Parameter_Values_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'AlternativeRABConfigurationRequest')))
    _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Requested-RAB-Parameter-ExtendedMaxBitrateList')))
    _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Requested-RAB-Parameter-ExtendedGuaranteedBitrateList')))
    _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    ____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 159), (u'criticality', u'ignore'), (u'Extension', _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 178), (u'criticality', u'reject'), (u'Extension', _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 179), (u'criticality', u'reject'), (u'Extension', _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 220), (u'criticality', u'reject'), (u'Extension', _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 221), (u'criticality', u'reject'), (u'Extension', _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Requested_RAB_Parameter_Values_iE_Extensions__item__id._const_tab = ____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab
    ___Requested_RAB_Parameter_Values_iE_Extensions__item__id._const_tab_at = None
    ___Requested_RAB_Parameter_Values_iE_Extensions__item__id._const_tab_id = u'id'
    ___Requested_RAB_Parameter_Values_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Requested_RAB_Parameter_Values_iE_Extensions__item__criticality._const_tab = ____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab
    ___Requested_RAB_Parameter_Values_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Requested_RAB_Parameter_Values_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Requested_RAB_Parameter_Values_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Requested_RAB_Parameter_Values_iE_Extensions__item__extensionValue._const_tab = ____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab
    ___Requested_RAB_Parameter_Values_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Requested_RAB_Parameter_Values_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Requested_RAB_Parameter_Values_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Requested_RAB_Parameter_Values_iE_Extensions__item__id),
        (u'criticality', ___Requested_RAB_Parameter_Values_iE_Extensions__item__criticality),
        (u'extensionValue', ___Requested_RAB_Parameter_Values_iE_Extensions__item__extensionValue),
        ])
    __Requested_RAB_Parameter_Values_iE_Extensions__item_._ext = None
    _Requested_RAB_Parameter_Values_iE_Extensions._cont = __Requested_RAB_Parameter_Values_iE_Extensions__item_
    _Requested_RAB_Parameter_Values_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Requested_RAB_Parameter_Values._cont = ASN1Dict([
        (u'requestedMaxBitrates', _Requested_RAB_Parameter_Values_requestedMaxBitrates),
        (u'requestedGuaranteedBitrates', _Requested_RAB_Parameter_Values_requestedGuaranteedBitrates),
        (u'iE-Extensions', _Requested_RAB_Parameter_Values_iE_Extensions),
        ])
    Requested_RAB_Parameter_Values._ext = []
    
    #-----< Requested-RAB-Parameter-Values-ExtIEs >-----#
    Requested_RAB_Parameter_Values_ExtIEs = CLASS(name=u'Requested-RAB-Parameter-Values-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'AlternativeRABConfigurationRequest')))
    _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Requested-RAB-Parameter-ExtendedMaxBitrateList')))
    _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Requested-RAB-Parameter-ExtendedGuaranteedBitrateList')))
    _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    Requested_RAB_Parameter_Values_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 159), (u'criticality', u'ignore'), (u'Extension', _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 178), (u'criticality', u'reject'), (u'Extension', _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 179), (u'criticality', u'reject'), (u'Extension', _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 220), (u'criticality', u'reject'), (u'Extension', _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 221), (u'criticality', u'reject'), (u'Extension', _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Requested-RAB-Parameter-ExtendedMaxBitrateList >-----#
    Requested_RAB_Parameter_ExtendedMaxBitrateList = SEQ_OF(name=u'Requested-RAB-Parameter-ExtendedMaxBitrateList', mode=MODE_TYPE)
    _Requested_RAB_Parameter_ExtendedMaxBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedMaxBitrate')))
    Requested_RAB_Parameter_ExtendedMaxBitrateList._cont = _Requested_RAB_Parameter_ExtendedMaxBitrateList__item_
    Requested_RAB_Parameter_ExtendedMaxBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Requested-RAB-Parameter-ExtendedGuaranteedBitrateList >-----#
    Requested_RAB_Parameter_ExtendedGuaranteedBitrateList = SEQ_OF(name=u'Requested-RAB-Parameter-ExtendedGuaranteedBitrateList', mode=MODE_TYPE)
    _Requested_RAB_Parameter_ExtendedGuaranteedBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedGuaranteedBitrate')))
    Requested_RAB_Parameter_ExtendedGuaranteedBitrateList._cont = _Requested_RAB_Parameter_ExtendedGuaranteedBitrateList__item_
    Requested_RAB_Parameter_ExtendedGuaranteedBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Requested-RAB-Parameter-MaxBitrateList >-----#
    Requested_RAB_Parameter_MaxBitrateList = SEQ_OF(name=u'Requested-RAB-Parameter-MaxBitrateList', mode=MODE_TYPE)
    _Requested_RAB_Parameter_MaxBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MaxBitrate')))
    Requested_RAB_Parameter_MaxBitrateList._cont = _Requested_RAB_Parameter_MaxBitrateList__item_
    Requested_RAB_Parameter_MaxBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Requested-RAB-Parameter-GuaranteedBitrateList >-----#
    Requested_RAB_Parameter_GuaranteedBitrateList = SEQ_OF(name=u'Requested-RAB-Parameter-GuaranteedBitrateList', mode=MODE_TYPE)
    _Requested_RAB_Parameter_GuaranteedBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GuaranteedBitrate')))
    Requested_RAB_Parameter_GuaranteedBitrateList._cont = _Requested_RAB_Parameter_GuaranteedBitrateList__item_
    Requested_RAB_Parameter_GuaranteedBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< RequestType >-----#
    RequestType = SEQ(name=u'RequestType', mode=MODE_TYPE)
    _RequestType_event = ENUM(name=u'event', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Event')))
    _RequestType_reportArea = ENUM(name=u'reportArea', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ReportArea')))
    _RequestType_accuracyCode = INT(name=u'accuracyCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestType_accuracyCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    RequestType._cont = ASN1Dict([
        (u'event', _RequestType_event),
        (u'reportArea', _RequestType_reportArea),
        (u'accuracyCode', _RequestType_accuracyCode),
        ])
    RequestType._ext = []
    
    #-----< ResidualBitErrorRatio >-----#
    ResidualBitErrorRatio = SEQ(name=u'ResidualBitErrorRatio', mode=MODE_TYPE)
    _ResidualBitErrorRatio_mantissa = INT(name=u'mantissa', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResidualBitErrorRatio_mantissa._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    _ResidualBitErrorRatio_exponent = INT(name=u'exponent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResidualBitErrorRatio_exponent._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _ResidualBitErrorRatio_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResidualBitErrorRatio_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___ResidualBitErrorRatio_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ResidualBitErrorRatio_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____ResidualBitErrorRatio_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResidualBitErrorRatio_iE_Extensions__item__id._const_tab = ____ResidualBitErrorRatio_iE_Extensions__item__id_tab
    ___ResidualBitErrorRatio_iE_Extensions__item__id._const_tab_at = None
    ___ResidualBitErrorRatio_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResidualBitErrorRatio_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ResidualBitErrorRatio_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____ResidualBitErrorRatio_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResidualBitErrorRatio_iE_Extensions__item__criticality._const_tab = ____ResidualBitErrorRatio_iE_Extensions__item__criticality_tab
    ___ResidualBitErrorRatio_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResidualBitErrorRatio_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResidualBitErrorRatio_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ResidualBitErrorRatio_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____ResidualBitErrorRatio_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResidualBitErrorRatio_iE_Extensions__item__extensionValue._const_tab = ____ResidualBitErrorRatio_iE_Extensions__item__extensionValue_tab
    ___ResidualBitErrorRatio_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResidualBitErrorRatio_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResidualBitErrorRatio_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResidualBitErrorRatio_iE_Extensions__item__id),
        (u'criticality', ___ResidualBitErrorRatio_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResidualBitErrorRatio_iE_Extensions__item__extensionValue),
        ])
    __ResidualBitErrorRatio_iE_Extensions__item_._ext = None
    _ResidualBitErrorRatio_iE_Extensions._cont = __ResidualBitErrorRatio_iE_Extensions__item_
    _ResidualBitErrorRatio_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResidualBitErrorRatio._cont = ASN1Dict([
        (u'mantissa', _ResidualBitErrorRatio_mantissa),
        (u'exponent', _ResidualBitErrorRatio_exponent),
        (u'iE-Extensions', _ResidualBitErrorRatio_iE_Extensions),
        ])
    ResidualBitErrorRatio._ext = None
    
    #-----< ResidualBitErrorRatio-ExtIEs >-----#
    ResidualBitErrorRatio_ExtIEs = CLASS(name=u'ResidualBitErrorRatio-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ResidualBitErrorRatio_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResponseTime >-----#
    ResponseTime = ENUM(name=u'ResponseTime', mode=MODE_TYPE)
    ResponseTime._cont = ASN1Dict([(u'lowdelay', 0), (u'delaytolerant', 1)])
    ResponseTime._ext = []
    
    #-----< RIMInformation >-----#
    RIMInformation = OCT_STR(name=u'RIMInformation', mode=MODE_TYPE)
    
    #-----< RIM-Transfer >-----#
    RIM_Transfer = SEQ(name=u'RIM-Transfer', mode=MODE_TYPE)
    _RIM_Transfer_rIMInformation = OCT_STR(name=u'rIMInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RIMInformation')))
    _RIM_Transfer_rIMRoutingAddress = CHOICE(name=u'rIMRoutingAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RIMRoutingAddress')), opt=True)
    _RIM_Transfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RIM_Transfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RIM_Transfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RIM_Transfer_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RIM_Transfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RIM_Transfer_iE_Extensions__item__id._const_tab = ____RIM_Transfer_iE_Extensions__item__id_tab
    ___RIM_Transfer_iE_Extensions__item__id._const_tab_at = None
    ___RIM_Transfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___RIM_Transfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RIM_Transfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RIM_Transfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RIM_Transfer_iE_Extensions__item__criticality._const_tab = ____RIM_Transfer_iE_Extensions__item__criticality_tab
    ___RIM_Transfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RIM_Transfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RIM_Transfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RIM_Transfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RIM_Transfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RIM_Transfer_iE_Extensions__item__extensionValue._const_tab = ____RIM_Transfer_iE_Extensions__item__extensionValue_tab
    ___RIM_Transfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RIM_Transfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RIM_Transfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RIM_Transfer_iE_Extensions__item__id),
        (u'criticality', ___RIM_Transfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___RIM_Transfer_iE_Extensions__item__extensionValue),
        ])
    __RIM_Transfer_iE_Extensions__item_._ext = None
    _RIM_Transfer_iE_Extensions._cont = __RIM_Transfer_iE_Extensions__item_
    _RIM_Transfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RIM_Transfer._cont = ASN1Dict([
        (u'rIMInformation', _RIM_Transfer_rIMInformation),
        (u'rIMRoutingAddress', _RIM_Transfer_rIMRoutingAddress),
        (u'iE-Extensions', _RIM_Transfer_iE_Extensions),
        ])
    RIM_Transfer._ext = None
    
    #-----< RIM-Transfer-ExtIEs >-----#
    RIM_Transfer_ExtIEs = CLASS(name=u'RIM-Transfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RIM_Transfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RIMRoutingAddress >-----#
    RIMRoutingAddress = CHOICE(name=u'RIMRoutingAddress', mode=MODE_TYPE)
    _RIMRoutingAddress_targetRNC_ID = SEQ(name=u'targetRNC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TargetRNC-ID')))
    _RIMRoutingAddress_gERAN_Cell_ID = SEQ(name=u'gERAN-Cell-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GERAN-Cell-ID')))
    _RIMRoutingAddress_targeteNB_ID = SEQ(name=u'targeteNB-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TargetENB-ID')))
    RIMRoutingAddress._cont = ASN1Dict([
        (u'targetRNC-ID', _RIMRoutingAddress_targetRNC_ID),
        (u'gERAN-Cell-ID', _RIMRoutingAddress_gERAN_Cell_ID),
        (u'targeteNB-ID', _RIMRoutingAddress_targeteNB_ID),
        ])
    RIMRoutingAddress._ext = [u'targeteNB-ID']
    
    #-----< RNC-ID >-----#
    RNC_ID = INT(name=u'RNC-ID', mode=MODE_TYPE)
    RNC_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< RNCTraceInformation >-----#
    RNCTraceInformation = SEQ(name=u'RNCTraceInformation', mode=MODE_TYPE)
    _RNCTraceInformation_traceReference = OCT_STR(name=u'traceReference', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TraceReference')))
    _RNCTraceInformation_traceActivationIndicator = ENUM(name=u'traceActivationIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RNCTraceInformation_traceActivationIndicator._cont = ASN1Dict([(u'activated', 0), (u'deactivated', 1)])
    _RNCTraceInformation_traceActivationIndicator._ext = None
    _RNCTraceInformation_equipmentsToBeTraced = CHOICE(name=u'equipmentsToBeTraced', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'EquipmentsToBeTraced')), opt=True)
    _RNCTraceInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RNCTraceInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RNCTraceInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RNCTraceInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RNCTraceInformation_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TraceRecordingSessionReference')))
    _____RNCTraceInformation_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IMSI')))
    _____RNCTraceInformation_iE_Extensions__item__id_tab_val_Extension_2 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _____RNCTraceInformation_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UTRAN-CellID')))
    ____RNCTraceInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 255), (u'criticality', u'ignore'), (u'Extension', _____RNCTraceInformation_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 256), (u'criticality', u'ignore'), (u'Extension', _____RNCTraceInformation_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 251), (u'criticality', u'ignore'), (u'Extension', _____RNCTraceInformation_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 270), (u'criticality', u'ignore'), (u'Extension', _____RNCTraceInformation_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RNCTraceInformation_iE_Extensions__item__id._const_tab = ____RNCTraceInformation_iE_Extensions__item__id_tab
    ___RNCTraceInformation_iE_Extensions__item__id._const_tab_at = None
    ___RNCTraceInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___RNCTraceInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RNCTraceInformation_iE_Extensions__item__criticality._const_tab = ____RNCTraceInformation_iE_Extensions__item__id_tab
    ___RNCTraceInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RNCTraceInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RNCTraceInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RNCTraceInformation_iE_Extensions__item__extensionValue._const_tab = ____RNCTraceInformation_iE_Extensions__item__id_tab
    ___RNCTraceInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RNCTraceInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RNCTraceInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RNCTraceInformation_iE_Extensions__item__id),
        (u'criticality', ___RNCTraceInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___RNCTraceInformation_iE_Extensions__item__extensionValue),
        ])
    __RNCTraceInformation_iE_Extensions__item_._ext = None
    _RNCTraceInformation_iE_Extensions._cont = __RNCTraceInformation_iE_Extensions__item_
    _RNCTraceInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RNCTraceInformation._cont = ASN1Dict([
        (u'traceReference', _RNCTraceInformation_traceReference),
        (u'traceActivationIndicator', _RNCTraceInformation_traceActivationIndicator),
        (u'equipmentsToBeTraced', _RNCTraceInformation_equipmentsToBeTraced),
        (u'iE-Extensions', _RNCTraceInformation_iE_Extensions),
        ])
    RNCTraceInformation._ext = None
    
    #-----< RNCTraceInformation-ExtIEs >-----#
    RNCTraceInformation_ExtIEs = CLASS(name=u'RNCTraceInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RNCTraceInformation_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TraceRecordingSessionReference')))
    _RNCTraceInformation_ExtIEs_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IMSI')))
    _RNCTraceInformation_ExtIEs_val_Extension_2 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _RNCTraceInformation_ExtIEs_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UTRAN-CellID')))
    RNCTraceInformation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 255), (u'criticality', u'ignore'), (u'Extension', _RNCTraceInformation_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 256), (u'criticality', u'ignore'), (u'Extension', _RNCTraceInformation_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 251), (u'criticality', u'ignore'), (u'Extension', _RNCTraceInformation_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 270), (u'criticality', u'ignore'), (u'Extension', _RNCTraceInformation_ExtIEs_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RNSAPRelocationParameters >-----#
    RNSAPRelocationParameters = SEQ(name=u'RNSAPRelocationParameters', mode=MODE_TYPE)
    _RNSAPRelocationParameters_rabParmetersList = SEQ_OF(name=u'rabParmetersList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RABParametersList')), opt=True)
    _RNSAPRelocationParameters_locationReporting = SEQ(name=u'locationReporting', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LocationReportingTransferInformation')), opt=True)
    _RNSAPRelocationParameters_traceInformation = SEQ(name=u'traceInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TraceInformation')), opt=True)
    _RNSAPRelocationParameters_sourceSAI = SEQ(name=u'sourceSAI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SAI')), opt=True)
    _RNSAPRelocationParameters_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RNSAPRelocationParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RNSAPRelocationParameters_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RNSAPRelocationParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RNSAPRelocationParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RNSAPRelocationParameters_iE_Extensions__item__id._const_tab = ____RNSAPRelocationParameters_iE_Extensions__item__id_tab
    ___RNSAPRelocationParameters_iE_Extensions__item__id._const_tab_at = None
    ___RNSAPRelocationParameters_iE_Extensions__item__id._const_tab_id = u'id'
    ___RNSAPRelocationParameters_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RNSAPRelocationParameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RNSAPRelocationParameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RNSAPRelocationParameters_iE_Extensions__item__criticality._const_tab = ____RNSAPRelocationParameters_iE_Extensions__item__criticality_tab
    ___RNSAPRelocationParameters_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RNSAPRelocationParameters_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RNSAPRelocationParameters_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RNSAPRelocationParameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RNSAPRelocationParameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RNSAPRelocationParameters_iE_Extensions__item__extensionValue._const_tab = ____RNSAPRelocationParameters_iE_Extensions__item__extensionValue_tab
    ___RNSAPRelocationParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RNSAPRelocationParameters_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RNSAPRelocationParameters_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RNSAPRelocationParameters_iE_Extensions__item__id),
        (u'criticality', ___RNSAPRelocationParameters_iE_Extensions__item__criticality),
        (u'extensionValue', ___RNSAPRelocationParameters_iE_Extensions__item__extensionValue),
        ])
    __RNSAPRelocationParameters_iE_Extensions__item_._ext = None
    _RNSAPRelocationParameters_iE_Extensions._cont = __RNSAPRelocationParameters_iE_Extensions__item_
    _RNSAPRelocationParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RNSAPRelocationParameters._cont = ASN1Dict([
        (u'rabParmetersList', _RNSAPRelocationParameters_rabParmetersList),
        (u'locationReporting', _RNSAPRelocationParameters_locationReporting),
        (u'traceInformation', _RNSAPRelocationParameters_traceInformation),
        (u'sourceSAI', _RNSAPRelocationParameters_sourceSAI),
        (u'iE-Extensions', _RNSAPRelocationParameters_iE_Extensions),
        ])
    RNSAPRelocationParameters._ext = []
    
    #-----< RNSAPRelocationParameters-ExtIEs >-----#
    RNSAPRelocationParameters_ExtIEs = CLASS(name=u'RNSAPRelocationParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RNSAPRelocationParameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RRC-Container >-----#
    RRC_Container = OCT_STR(name=u'RRC-Container', mode=MODE_TYPE)
    
    #-----< RTLoadValue >-----#
    RTLoadValue = INT(name=u'RTLoadValue', mode=MODE_TYPE)
    RTLoadValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< RSRVCC-HO-Indication >-----#
    RSRVCC_HO_Indication = ENUM(name=u'RSRVCC-HO-Indication', mode=MODE_TYPE)
    RSRVCC_HO_Indication._cont = ASN1Dict([(u'ps-only', 0)])
    RSRVCC_HO_Indication._ext = []
    
    #-----< RSRVCC-Information >-----#
    RSRVCC_Information = SEQ(name=u'RSRVCC-Information', mode=MODE_TYPE)
    _RSRVCC_Information_nonce = BIT_STR(name=u'nonce', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RSRVCC_Information_nonce._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    _RSRVCC_Information_iMSInformation = OCT_STR(name=u'iMSInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RSRVCC_Information_iMSInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _RSRVCC_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RSRVCC_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RSRVCC_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RSRVCC_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RSRVCC_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RSRVCC_Information_iE_Extensions__item__id._const_tab = ____RSRVCC_Information_iE_Extensions__item__id_tab
    ___RSRVCC_Information_iE_Extensions__item__id._const_tab_at = None
    ___RSRVCC_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___RSRVCC_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RSRVCC_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RSRVCC_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RSRVCC_Information_iE_Extensions__item__criticality._const_tab = ____RSRVCC_Information_iE_Extensions__item__criticality_tab
    ___RSRVCC_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RSRVCC_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RSRVCC_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RSRVCC_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RSRVCC_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RSRVCC_Information_iE_Extensions__item__extensionValue._const_tab = ____RSRVCC_Information_iE_Extensions__item__extensionValue_tab
    ___RSRVCC_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RSRVCC_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RSRVCC_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RSRVCC_Information_iE_Extensions__item__id),
        (u'criticality', ___RSRVCC_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___RSRVCC_Information_iE_Extensions__item__extensionValue),
        ])
    __RSRVCC_Information_iE_Extensions__item_._ext = None
    _RSRVCC_Information_iE_Extensions._cont = __RSRVCC_Information_iE_Extensions__item_
    _RSRVCC_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RSRVCC_Information._cont = ASN1Dict([
        (u'nonce', _RSRVCC_Information_nonce),
        (u'iMSInformation', _RSRVCC_Information_iMSInformation),
        (u'iE-Extensions', _RSRVCC_Information_iE_Extensions),
        ])
    RSRVCC_Information._ext = []
    
    #-----< RSRVCC-Information-ExtIEs >-----#
    RSRVCC_Information_ExtIEs = CLASS(name=u'RSRVCC-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RSRVCC_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RSRVCC-Operation-Possible >-----#
    RSRVCC_Operation_Possible = ENUM(name=u'RSRVCC-Operation-Possible', mode=MODE_TYPE)
    RSRVCC_Operation_Possible._cont = ASN1Dict([(u'rsrvcc-possible', 0)])
    RSRVCC_Operation_Possible._ext = []
    
    #-----< SAC >-----#
    SAC = OCT_STR(name=u'SAC', mode=MODE_TYPE)
    SAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< SAI >-----#
    SAI = SEQ(name=u'SAI', mode=MODE_TYPE)
    _SAI_pLMNidentity = OCT_STR(name=u'pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _SAI_lAC = OCT_STR(name=u'lAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LAC')))
    _SAI_sAC = OCT_STR(name=u'sAC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SAC')))
    _SAI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SAI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SAI_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SAI_iE_Extensions__item__id._const_tab = ____SAI_iE_Extensions__item__id_tab
    ___SAI_iE_Extensions__item__id._const_tab_at = None
    ___SAI_iE_Extensions__item__id._const_tab_id = u'id'
    ___SAI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SAI_iE_Extensions__item__criticality._const_tab = ____SAI_iE_Extensions__item__criticality_tab
    ___SAI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SAI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SAI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SAI_iE_Extensions__item__extensionValue._const_tab = ____SAI_iE_Extensions__item__extensionValue_tab
    ___SAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SAI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SAI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SAI_iE_Extensions__item__id),
        (u'criticality', ___SAI_iE_Extensions__item__criticality),
        (u'extensionValue', ___SAI_iE_Extensions__item__extensionValue),
        ])
    __SAI_iE_Extensions__item_._ext = None
    _SAI_iE_Extensions._cont = __SAI_iE_Extensions__item_
    _SAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SAI._cont = ASN1Dict([
        (u'pLMNidentity', _SAI_pLMNidentity),
        (u'lAC', _SAI_lAC),
        (u'sAC', _SAI_sAC),
        (u'iE-Extensions', _SAI_iE_Extensions),
        ])
    SAI._ext = None
    
    #-----< SAI-ExtIEs >-----#
    SAI_ExtIEs = CLASS(name=u'SAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SAPI >-----#
    SAPI = ENUM(name=u'SAPI', mode=MODE_TYPE)
    SAPI._cont = ASN1Dict([(u'sapi-0', 0), (u'sapi-3', 1)])
    SAPI._ext = []
    
    #-----< SessionUpdateID >-----#
    SessionUpdateID = INT(name=u'SessionUpdateID', mode=MODE_TYPE)
    SessionUpdateID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=None, er=[])
    
    #-----< Shared-Network-Information >-----#
    Shared_Network_Information = SEQ(name=u'Shared-Network-Information', mode=MODE_TYPE)
    _Shared_Network_Information_pLMNs_in_shared_network = SEQ_OF(name=u'pLMNs-in-shared-network', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNs-in-shared-network')))
    _Shared_Network_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Shared_Network_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Shared_Network_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Shared_Network_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Shared_Network_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Shared_Network_Information_iE_Extensions__item__id._const_tab = ____Shared_Network_Information_iE_Extensions__item__id_tab
    ___Shared_Network_Information_iE_Extensions__item__id._const_tab_at = None
    ___Shared_Network_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___Shared_Network_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Shared_Network_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Shared_Network_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Shared_Network_Information_iE_Extensions__item__criticality._const_tab = ____Shared_Network_Information_iE_Extensions__item__criticality_tab
    ___Shared_Network_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Shared_Network_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Shared_Network_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Shared_Network_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Shared_Network_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Shared_Network_Information_iE_Extensions__item__extensionValue._const_tab = ____Shared_Network_Information_iE_Extensions__item__extensionValue_tab
    ___Shared_Network_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Shared_Network_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Shared_Network_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Shared_Network_Information_iE_Extensions__item__id),
        (u'criticality', ___Shared_Network_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___Shared_Network_Information_iE_Extensions__item__extensionValue),
        ])
    __Shared_Network_Information_iE_Extensions__item_._ext = None
    _Shared_Network_Information_iE_Extensions._cont = __Shared_Network_Information_iE_Extensions__item_
    _Shared_Network_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Shared_Network_Information._cont = ASN1Dict([
        (u'pLMNs-in-shared-network', _Shared_Network_Information_pLMNs_in_shared_network),
        (u'iE-Extensions', _Shared_Network_Information_iE_Extensions),
        ])
    Shared_Network_Information._ext = []
    
    #-----< Session-Re-establishment-Indicator >-----#
    Session_Re_establishment_Indicator = ENUM(name=u'Session-Re-establishment-Indicator', mode=MODE_TYPE)
    Session_Re_establishment_Indicator._cont = ASN1Dict([(u'true', 0)])
    Session_Re_establishment_Indicator._ext = []
    
    #-----< Shared-Network-Information-ExtIEs >-----#
    Shared_Network_Information_ExtIEs = CLASS(name=u'Shared-Network-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    Shared_Network_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SignallingIndication >-----#
    SignallingIndication = ENUM(name=u'SignallingIndication', mode=MODE_TYPE)
    SignallingIndication._cont = ASN1Dict([(u'signalling', 0)])
    SignallingIndication._ext = []
    
    #-----< SDU-ErrorRatio >-----#
    SDU_ErrorRatio = SEQ(name=u'SDU-ErrorRatio', mode=MODE_TYPE)
    _SDU_ErrorRatio_mantissa = INT(name=u'mantissa', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SDU_ErrorRatio_mantissa._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    _SDU_ErrorRatio_exponent = INT(name=u'exponent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SDU_ErrorRatio_exponent._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    _SDU_ErrorRatio_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SDU_ErrorRatio_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SDU_ErrorRatio_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SDU_ErrorRatio_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SDU_ErrorRatio_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SDU_ErrorRatio_iE_Extensions__item__id._const_tab = ____SDU_ErrorRatio_iE_Extensions__item__id_tab
    ___SDU_ErrorRatio_iE_Extensions__item__id._const_tab_at = None
    ___SDU_ErrorRatio_iE_Extensions__item__id._const_tab_id = u'id'
    ___SDU_ErrorRatio_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SDU_ErrorRatio_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SDU_ErrorRatio_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SDU_ErrorRatio_iE_Extensions__item__criticality._const_tab = ____SDU_ErrorRatio_iE_Extensions__item__criticality_tab
    ___SDU_ErrorRatio_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SDU_ErrorRatio_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SDU_ErrorRatio_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SDU_ErrorRatio_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SDU_ErrorRatio_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SDU_ErrorRatio_iE_Extensions__item__extensionValue._const_tab = ____SDU_ErrorRatio_iE_Extensions__item__extensionValue_tab
    ___SDU_ErrorRatio_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SDU_ErrorRatio_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SDU_ErrorRatio_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SDU_ErrorRatio_iE_Extensions__item__id),
        (u'criticality', ___SDU_ErrorRatio_iE_Extensions__item__criticality),
        (u'extensionValue', ___SDU_ErrorRatio_iE_Extensions__item__extensionValue),
        ])
    __SDU_ErrorRatio_iE_Extensions__item_._ext = None
    _SDU_ErrorRatio_iE_Extensions._cont = __SDU_ErrorRatio_iE_Extensions__item_
    _SDU_ErrorRatio_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SDU_ErrorRatio._cont = ASN1Dict([
        (u'mantissa', _SDU_ErrorRatio_mantissa),
        (u'exponent', _SDU_ErrorRatio_exponent),
        (u'iE-Extensions', _SDU_ErrorRatio_iE_Extensions),
        ])
    SDU_ErrorRatio._ext = None
    
    #-----< SDU-ErrorRatio-ExtIEs >-----#
    SDU_ErrorRatio_ExtIEs = CLASS(name=u'SDU-ErrorRatio-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SDU_ErrorRatio_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SDU-FormatInformationParameters >-----#
    SDU_FormatInformationParameters = SEQ_OF(name=u'SDU-FormatInformationParameters', mode=MODE_TYPE)
    _SDU_FormatInformationParameters__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __SDU_FormatInformationParameters__item__subflowSDU_Size = INT(name=u'subflowSDU-Size', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SubflowSDU-Size')), opt=True)
    __SDU_FormatInformationParameters__item__rAB_SubflowCombinationBitRate = INT(name=u'rAB-SubflowCombinationBitRate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-SubflowCombinationBitRate')), opt=True)
    __SDU_FormatInformationParameters__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___SDU_FormatInformationParameters__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____SDU_FormatInformationParameters__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    _____SDU_FormatInformationParameters__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____SDU_FormatInformationParameters__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____SDU_FormatInformationParameters__item__iE_Extensions__item__id._const_tab = _____SDU_FormatInformationParameters__item__iE_Extensions__item__id_tab
    ____SDU_FormatInformationParameters__item__iE_Extensions__item__id._const_tab_at = None
    ____SDU_FormatInformationParameters__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____SDU_FormatInformationParameters__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____SDU_FormatInformationParameters__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____SDU_FormatInformationParameters__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____SDU_FormatInformationParameters__item__iE_Extensions__item__criticality._const_tab = _____SDU_FormatInformationParameters__item__iE_Extensions__item__criticality_tab
    ____SDU_FormatInformationParameters__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____SDU_FormatInformationParameters__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____SDU_FormatInformationParameters__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____SDU_FormatInformationParameters__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____SDU_FormatInformationParameters__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____SDU_FormatInformationParameters__item__iE_Extensions__item__extensionValue._const_tab = _____SDU_FormatInformationParameters__item__iE_Extensions__item__extensionValue_tab
    ____SDU_FormatInformationParameters__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____SDU_FormatInformationParameters__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___SDU_FormatInformationParameters__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____SDU_FormatInformationParameters__item__iE_Extensions__item__id),
        (u'criticality', ____SDU_FormatInformationParameters__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____SDU_FormatInformationParameters__item__iE_Extensions__item__extensionValue),
        ])
    ___SDU_FormatInformationParameters__item__iE_Extensions__item_._ext = None
    __SDU_FormatInformationParameters__item__iE_Extensions._cont = ___SDU_FormatInformationParameters__item__iE_Extensions__item_
    __SDU_FormatInformationParameters__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _SDU_FormatInformationParameters__item_._cont = ASN1Dict([
        (u'subflowSDU-Size', __SDU_FormatInformationParameters__item__subflowSDU_Size),
        (u'rAB-SubflowCombinationBitRate', __SDU_FormatInformationParameters__item__rAB_SubflowCombinationBitRate),
        (u'iE-Extensions', __SDU_FormatInformationParameters__item__iE_Extensions),
        ])
    _SDU_FormatInformationParameters__item_._ext = []
    SDU_FormatInformationParameters._cont = _SDU_FormatInformationParameters__item_
    SDU_FormatInformationParameters._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SDU-FormatInformationParameters-ExtIEs >-----#
    SDU_FormatInformationParameters_ExtIEs = CLASS(name=u'SDU-FormatInformationParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SDU_FormatInformationParameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SDU-Parameters >-----#
    SDU_Parameters = SEQ_OF(name=u'SDU-Parameters', mode=MODE_TYPE)
    _SDU_Parameters__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __SDU_Parameters__item__sDU_ErrorRatio = SEQ(name=u'sDU-ErrorRatio', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SDU-ErrorRatio')), opt=True)
    __SDU_Parameters__item__residualBitErrorRatio = SEQ(name=u'residualBitErrorRatio', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ResidualBitErrorRatio')))
    __SDU_Parameters__item__deliveryOfErroneousSDU = ENUM(name=u'deliveryOfErroneousSDU', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DeliveryOfErroneousSDU')))
    __SDU_Parameters__item__sDU_FormatInformationParameters = SEQ_OF(name=u'sDU-FormatInformationParameters', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SDU-FormatInformationParameters')), opt=True)
    __SDU_Parameters__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___SDU_Parameters__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____SDU_Parameters__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    _____SDU_Parameters__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____SDU_Parameters__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____SDU_Parameters__item__iE_Extensions__item__id._const_tab = _____SDU_Parameters__item__iE_Extensions__item__id_tab
    ____SDU_Parameters__item__iE_Extensions__item__id._const_tab_at = None
    ____SDU_Parameters__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____SDU_Parameters__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____SDU_Parameters__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____SDU_Parameters__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____SDU_Parameters__item__iE_Extensions__item__criticality._const_tab = _____SDU_Parameters__item__iE_Extensions__item__criticality_tab
    ____SDU_Parameters__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____SDU_Parameters__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____SDU_Parameters__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____SDU_Parameters__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____SDU_Parameters__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____SDU_Parameters__item__iE_Extensions__item__extensionValue._const_tab = _____SDU_Parameters__item__iE_Extensions__item__extensionValue_tab
    ____SDU_Parameters__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____SDU_Parameters__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___SDU_Parameters__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____SDU_Parameters__item__iE_Extensions__item__id),
        (u'criticality', ____SDU_Parameters__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____SDU_Parameters__item__iE_Extensions__item__extensionValue),
        ])
    ___SDU_Parameters__item__iE_Extensions__item_._ext = None
    __SDU_Parameters__item__iE_Extensions._cont = ___SDU_Parameters__item__iE_Extensions__item_
    __SDU_Parameters__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _SDU_Parameters__item_._cont = ASN1Dict([
        (u'sDU-ErrorRatio', __SDU_Parameters__item__sDU_ErrorRatio),
        (u'residualBitErrorRatio', __SDU_Parameters__item__residualBitErrorRatio),
        (u'deliveryOfErroneousSDU', __SDU_Parameters__item__deliveryOfErroneousSDU),
        (u'sDU-FormatInformationParameters', __SDU_Parameters__item__sDU_FormatInformationParameters),
        (u'iE-Extensions', __SDU_Parameters__item__iE_Extensions),
        ])
    _SDU_Parameters__item_._ext = []
    SDU_Parameters._cont = _SDU_Parameters__item_
    SDU_Parameters._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< SDU-Parameters-ExtIEs >-----#
    SDU_Parameters_ExtIEs = CLASS(name=u'SDU-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SDU_Parameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SGSN-Group-Identity >-----#
    SGSN_Group_Identity = CHOICE(name=u'SGSN-Group-Identity', mode=MODE_TYPE)
    _SGSN_Group_Identity_null_NRI = BIT_STR(name=u'null-NRI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Null-NRI')))
    _SGSN_Group_Identity_sGSN_Group_ID = OCT_STR(name=u'sGSN-Group-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SGSN-Group-ID')))
    SGSN_Group_Identity._cont = ASN1Dict([
        (u'null-NRI', _SGSN_Group_Identity_null_NRI),
        (u'sGSN-Group-ID', _SGSN_Group_Identity_sGSN_Group_ID),
        ])
    SGSN_Group_Identity._ext = None
    
    #-----< SGSN-Group-ID >-----#
    SGSN_Group_ID = OCT_STR(name=u'SGSN-Group-ID', mode=MODE_TYPE)
    SGSN_Group_ID._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< SNA-Access-Information >-----#
    SNA_Access_Information = SEQ(name=u'SNA-Access-Information', mode=MODE_TYPE)
    _SNA_Access_Information_authorisedPLMNs = SEQ_OF(name=u'authorisedPLMNs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'AuthorisedPLMNs')))
    _SNA_Access_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SNA_Access_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SNA_Access_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SNA_Access_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SNA_Access_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNA_Access_Information_iE_Extensions__item__id._const_tab = ____SNA_Access_Information_iE_Extensions__item__id_tab
    ___SNA_Access_Information_iE_Extensions__item__id._const_tab_at = None
    ___SNA_Access_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___SNA_Access_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SNA_Access_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SNA_Access_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNA_Access_Information_iE_Extensions__item__criticality._const_tab = ____SNA_Access_Information_iE_Extensions__item__criticality_tab
    ___SNA_Access_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SNA_Access_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SNA_Access_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SNA_Access_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SNA_Access_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNA_Access_Information_iE_Extensions__item__extensionValue._const_tab = ____SNA_Access_Information_iE_Extensions__item__extensionValue_tab
    ___SNA_Access_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SNA_Access_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SNA_Access_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SNA_Access_Information_iE_Extensions__item__id),
        (u'criticality', ___SNA_Access_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___SNA_Access_Information_iE_Extensions__item__extensionValue),
        ])
    __SNA_Access_Information_iE_Extensions__item_._ext = None
    _SNA_Access_Information_iE_Extensions._cont = __SNA_Access_Information_iE_Extensions__item_
    _SNA_Access_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SNA_Access_Information._cont = ASN1Dict([
        (u'authorisedPLMNs', _SNA_Access_Information_authorisedPLMNs),
        (u'iE-Extensions', _SNA_Access_Information_iE_Extensions),
        ])
    SNA_Access_Information._ext = []
    
    #-----< SNA-Access-Information-ExtIEs >-----#
    SNA_Access_Information_ExtIEs = CLASS(name=u'SNA-Access-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SNA_Access_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SNAC >-----#
    SNAC = INT(name=u'SNAC', mode=MODE_TYPE)
    SNAC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< Service-Handover >-----#
    Service_Handover = ENUM(name=u'Service-Handover', mode=MODE_TYPE)
    Service_Handover._cont = ASN1Dict([(u'handover-to-GSM-should-be-performed', 0), (u'handover-to-GSM-should-not-be-performed', 1), (u'handover-to-GSM-shall-not-be-performed', 2)])
    Service_Handover._ext = []
    
    #-----< Source-ToTarget-TransparentContainer >-----#
    Source_ToTarget_TransparentContainer = OCT_STR(name=u'Source-ToTarget-TransparentContainer', mode=MODE_TYPE)
    
    #-----< SourceeNodeB-ToTargeteNodeB-TransparentContainer >-----#
    SourceeNodeB_ToTargeteNodeB_TransparentContainer = OCT_STR(name=u'SourceeNodeB-ToTargeteNodeB-TransparentContainer', mode=MODE_TYPE)
    
    #-----< SourceCellID >-----#
    SourceCellID = CHOICE(name=u'SourceCellID', mode=MODE_TYPE)
    _SourceCellID_sourceUTRANCellID = SEQ(name=u'sourceUTRANCellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SourceUTRANCellID')))
    _SourceCellID_sourceGERANCellID = SEQ(name=u'sourceGERANCellID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CGI')))
    SourceCellID._cont = ASN1Dict([
        (u'sourceUTRANCellID', _SourceCellID_sourceUTRANCellID),
        (u'sourceGERANCellID', _SourceCellID_sourceGERANCellID),
        ])
    SourceCellID._ext = []
    
    #-----< SourceBSS-ToTargetBSS-TransparentContainer >-----#
    SourceBSS_ToTargetBSS_TransparentContainer = OCT_STR(name=u'SourceBSS-ToTargetBSS-TransparentContainer', mode=MODE_TYPE)
    
    #-----< SourceID >-----#
    SourceID = CHOICE(name=u'SourceID', mode=MODE_TYPE)
    _SourceID_sourceRNC_ID = SEQ(name=u'sourceRNC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SourceRNC-ID')))
    _SourceID_sAI = SEQ(name=u'sAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SAI')))
    SourceID._cont = ASN1Dict([
        (u'sourceRNC-ID', _SourceID_sourceRNC_ID),
        (u'sAI', _SourceID_sAI),
        ])
    SourceID._ext = []
    
    #-----< SourceRNC-ID >-----#
    SourceRNC_ID = SEQ(name=u'SourceRNC-ID', mode=MODE_TYPE)
    _SourceRNC_ID_pLMNidentity = OCT_STR(name=u'pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _SourceRNC_ID_rNC_ID = INT(name=u'rNC-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RNC-ID')))
    _SourceRNC_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SourceRNC_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SourceRNC_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SourceRNC_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____SourceRNC_ID_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ____SourceRNC_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _____SourceRNC_ID_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SourceRNC_ID_iE_Extensions__item__id._const_tab = ____SourceRNC_ID_iE_Extensions__item__id_tab
    ___SourceRNC_ID_iE_Extensions__item__id._const_tab_at = None
    ___SourceRNC_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___SourceRNC_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SourceRNC_ID_iE_Extensions__item__criticality._const_tab = ____SourceRNC_ID_iE_Extensions__item__id_tab
    ___SourceRNC_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SourceRNC_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SourceRNC_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SourceRNC_ID_iE_Extensions__item__extensionValue._const_tab = ____SourceRNC_ID_iE_Extensions__item__id_tab
    ___SourceRNC_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SourceRNC_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SourceRNC_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SourceRNC_ID_iE_Extensions__item__id),
        (u'criticality', ___SourceRNC_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___SourceRNC_ID_iE_Extensions__item__extensionValue),
        ])
    __SourceRNC_ID_iE_Extensions__item_._ext = None
    _SourceRNC_ID_iE_Extensions._cont = __SourceRNC_ID_iE_Extensions__item_
    _SourceRNC_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SourceRNC_ID._cont = ASN1Dict([
        (u'pLMNidentity', _SourceRNC_ID_pLMNidentity),
        (u'rNC-ID', _SourceRNC_ID_rNC_ID),
        (u'iE-Extensions', _SourceRNC_ID_iE_Extensions),
        ])
    SourceRNC_ID._ext = None
    
    #-----< SourceRNC-ID-ExtIEs >-----#
    SourceRNC_ID_ExtIEs = CLASS(name=u'SourceRNC-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _SourceRNC_ID_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    SourceRNC_ID_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _SourceRNC_ID_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SourceRNC-ToTargetRNC-TransparentContainer >-----#
    SourceRNC_ToTargetRNC_TransparentContainer = SEQ(name=u'SourceRNC-ToTargetRNC-TransparentContainer', mode=MODE_TYPE)
    _SourceRNC_ToTargetRNC_TransparentContainer_rRC_Container = OCT_STR(name=u'rRC-Container', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RRC-Container')))
    _SourceRNC_ToTargetRNC_TransparentContainer_numberOfIuInstances = INT(name=u'numberOfIuInstances', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'NumberOfIuInstances')))
    _SourceRNC_ToTargetRNC_TransparentContainer_relocationType = ENUM(name=u'relocationType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RelocationType')))
    _SourceRNC_ToTargetRNC_TransparentContainer_chosenIntegrityProtectionAlgorithm = INT(name=u'chosenIntegrityProtectionAlgorithm', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ChosenIntegrityProtectionAlgorithm')), opt=True)
    _SourceRNC_ToTargetRNC_TransparentContainer_integrityProtectionKey = BIT_STR(name=u'integrityProtectionKey', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IntegrityProtectionKey')), opt=True)
    _SourceRNC_ToTargetRNC_TransparentContainer_chosenEncryptionAlgorithForSignalling = INT(name=u'chosenEncryptionAlgorithForSignalling', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ChosenEncryptionAlgorithm')), opt=True)
    _SourceRNC_ToTargetRNC_TransparentContainer_cipheringKey = BIT_STR(name=u'cipheringKey', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'EncryptionKey')), opt=True)
    _SourceRNC_ToTargetRNC_TransparentContainer_chosenEncryptionAlgorithForCS = INT(name=u'chosenEncryptionAlgorithForCS', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ChosenEncryptionAlgorithm')), opt=True)
    _SourceRNC_ToTargetRNC_TransparentContainer_chosenEncryptionAlgorithForPS = INT(name=u'chosenEncryptionAlgorithForPS', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ChosenEncryptionAlgorithm')), opt=True)
    _SourceRNC_ToTargetRNC_TransparentContainer_d_RNTI = INT(name=u'd-RNTI', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'D-RNTI')), opt=True)
    _SourceRNC_ToTargetRNC_TransparentContainer_targetCellId = INT(name=u'targetCellId', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TargetCellId')), opt=True)
    _SourceRNC_ToTargetRNC_TransparentContainer_rAB_TrCH_Mapping = SEQ_OF(name=u'rAB-TrCH-Mapping', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-TrCH-Mapping')), opt=True)
    _SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRB-TrCH-Mapping')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CellLoadInformationGroup')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TraceRecordingSessionInformation')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSLinkingInformation')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'D-RNTI')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_5 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-History-Information')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_6 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SubscriberProfileIDforRFP')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRVCC-Information')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_8 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_9 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSFB-Information')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IRAT-Measurement-Configuration')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_11 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Management-Based-MDT-Allowed')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_12 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MDT-PLMN-List')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_13 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_14 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRVCCSource')))
    ____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 98), (u'criticality', u'reject'), (u'Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 124), (u'criticality', u'ignore'), (u'Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 156), (u'criticality', u'ignore'), (u'Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 187), (u'criticality', u'reject'), (u'Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 200), (u'criticality', u'ignore'), (u'Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 202), (u'criticality', u'ignore'), (u'Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 227), (u'criticality', u'reject'), (u'Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 230), (u'criticality', u'reject'), (u'Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 237), (u'criticality', u'ignore'), (u'Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 243), (u'criticality', u'ignore'), (u'Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 249), (u'criticality', u'ignore'), (u'Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 263), (u'criticality', u'ignore'), (u'Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 277), (u'criticality', u'ignore'), (u'Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 296), (u'criticality', u'ignore'), (u'Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_14), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id._const_tab = ____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab
    ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id._const_tab_at = None
    ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id._const_tab_id = u'id'
    ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__criticality._const_tab = ____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab
    ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__extensionValue._const_tab = ____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab
    ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id),
        (u'criticality', ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__criticality),
        (u'extensionValue', ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__extensionValue),
        ])
    __SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item_._ext = None
    _SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions._cont = __SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item_
    _SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SourceRNC_ToTargetRNC_TransparentContainer._cont = ASN1Dict([
        (u'rRC-Container', _SourceRNC_ToTargetRNC_TransparentContainer_rRC_Container),
        (u'numberOfIuInstances', _SourceRNC_ToTargetRNC_TransparentContainer_numberOfIuInstances),
        (u'relocationType', _SourceRNC_ToTargetRNC_TransparentContainer_relocationType),
        (u'chosenIntegrityProtectionAlgorithm', _SourceRNC_ToTargetRNC_TransparentContainer_chosenIntegrityProtectionAlgorithm),
        (u'integrityProtectionKey', _SourceRNC_ToTargetRNC_TransparentContainer_integrityProtectionKey),
        (u'chosenEncryptionAlgorithForSignalling', _SourceRNC_ToTargetRNC_TransparentContainer_chosenEncryptionAlgorithForSignalling),
        (u'cipheringKey', _SourceRNC_ToTargetRNC_TransparentContainer_cipheringKey),
        (u'chosenEncryptionAlgorithForCS', _SourceRNC_ToTargetRNC_TransparentContainer_chosenEncryptionAlgorithForCS),
        (u'chosenEncryptionAlgorithForPS', _SourceRNC_ToTargetRNC_TransparentContainer_chosenEncryptionAlgorithForPS),
        (u'd-RNTI', _SourceRNC_ToTargetRNC_TransparentContainer_d_RNTI),
        (u'targetCellId', _SourceRNC_ToTargetRNC_TransparentContainer_targetCellId),
        (u'rAB-TrCH-Mapping', _SourceRNC_ToTargetRNC_TransparentContainer_rAB_TrCH_Mapping),
        (u'iE-Extensions', _SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions),
        ])
    SourceRNC_ToTargetRNC_TransparentContainer._ext = []
    
    #-----< SourceRNC-ToTargetRNC-TransparentContainer-ExtIEs >-----#
    SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs = CLASS(name=u'SourceRNC-ToTargetRNC-TransparentContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRB-TrCH-Mapping')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CellLoadInformationGroup')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TraceRecordingSessionInformation')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSLinkingInformation')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'D-RNTI')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_5 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-History-Information')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_6 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SubscriberProfileIDforRFP')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRVCC-Information')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_8 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_9 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSFB-Information')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IRAT-Measurement-Configuration')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_11 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Management-Based-MDT-Allowed')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_12 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MDT-PLMN-List')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_13 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_14 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRVCCSource')))
    SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 98), (u'criticality', u'reject'), (u'Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 121), (u'criticality', u'ignore'), (u'Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 124), (u'criticality', u'ignore'), (u'Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 156), (u'criticality', u'ignore'), (u'Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 187), (u'criticality', u'reject'), (u'Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 200), (u'criticality', u'ignore'), (u'Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 202), (u'criticality', u'ignore'), (u'Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 227), (u'criticality', u'reject'), (u'Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 230), (u'criticality', u'reject'), (u'Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 237), (u'criticality', u'ignore'), (u'Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 243), (u'criticality', u'ignore'), (u'Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 249), (u'criticality', u'ignore'), (u'Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 263), (u'criticality', u'ignore'), (u'Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 277), (u'criticality', u'ignore'), (u'Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 296), (u'criticality', u'ignore'), (u'Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_14), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SRVCCSource >-----#
    SRVCCSource = ENUM(name=u'SRVCCSource', mode=MODE_TYPE)
    SRVCCSource._cont = ASN1Dict([(u'v5G', 0)])
    SRVCCSource._ext = []
    
    #-----< IRAT-Measurement-Configuration >-----#
    IRAT_Measurement_Configuration = SEQ(name=u'IRAT-Measurement-Configuration', mode=MODE_TYPE)
    _IRAT_Measurement_Configuration_rSRP = INT(name=u'rSRP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRAT_Measurement_Configuration_rSRP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=97)], ev=None, er=[])
    _IRAT_Measurement_Configuration_rSRQ = INT(name=u'rSRQ', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRAT_Measurement_Configuration_rSRQ._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=34)], ev=None, er=[])
    _IRAT_Measurement_Configuration_iRATmeasurementParameters = SEQ(name=u'iRATmeasurementParameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IRATmeasurementParameters')))
    _IRAT_Measurement_Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IRAT_Measurement_Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___IRAT_Measurement_Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____IRAT_Measurement_Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____IRAT_Measurement_Configuration_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RSRQ-Type')))
    _____IRAT_Measurement_Configuration_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RSRQ-Extension')))
    ____IRAT_Measurement_Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 278), (u'criticality', u'ignore'), (u'Extension', _____IRAT_Measurement_Configuration_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 279), (u'criticality', u'ignore'), (u'Extension', _____IRAT_Measurement_Configuration_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___IRAT_Measurement_Configuration_iE_Extensions__item__id._const_tab = ____IRAT_Measurement_Configuration_iE_Extensions__item__id_tab
    ___IRAT_Measurement_Configuration_iE_Extensions__item__id._const_tab_at = None
    ___IRAT_Measurement_Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___IRAT_Measurement_Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___IRAT_Measurement_Configuration_iE_Extensions__item__criticality._const_tab = ____IRAT_Measurement_Configuration_iE_Extensions__item__id_tab
    ___IRAT_Measurement_Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IRAT_Measurement_Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IRAT_Measurement_Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___IRAT_Measurement_Configuration_iE_Extensions__item__extensionValue._const_tab = ____IRAT_Measurement_Configuration_iE_Extensions__item__id_tab
    ___IRAT_Measurement_Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IRAT_Measurement_Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IRAT_Measurement_Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IRAT_Measurement_Configuration_iE_Extensions__item__id),
        (u'criticality', ___IRAT_Measurement_Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___IRAT_Measurement_Configuration_iE_Extensions__item__extensionValue),
        ])
    __IRAT_Measurement_Configuration_iE_Extensions__item_._ext = None
    _IRAT_Measurement_Configuration_iE_Extensions._cont = __IRAT_Measurement_Configuration_iE_Extensions__item_
    _IRAT_Measurement_Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IRAT_Measurement_Configuration._cont = ASN1Dict([
        (u'rSRP', _IRAT_Measurement_Configuration_rSRP),
        (u'rSRQ', _IRAT_Measurement_Configuration_rSRQ),
        (u'iRATmeasurementParameters', _IRAT_Measurement_Configuration_iRATmeasurementParameters),
        (u'iE-Extensions', _IRAT_Measurement_Configuration_iE_Extensions),
        ])
    IRAT_Measurement_Configuration._ext = None
    
    #-----< IRAT-Measurement-Configuration-ExtIEs >-----#
    IRAT_Measurement_Configuration_ExtIEs = CLASS(name=u'IRAT-Measurement-Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _IRAT_Measurement_Configuration_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RSRQ-Type')))
    _IRAT_Measurement_Configuration_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RSRQ-Extension')))
    IRAT_Measurement_Configuration_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 278), (u'criticality', u'ignore'), (u'Extension', _IRAT_Measurement_Configuration_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 279), (u'criticality', u'ignore'), (u'Extension', _IRAT_Measurement_Configuration_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< IRATmeasurementParameters >-----#
    IRATmeasurementParameters = SEQ(name=u'IRATmeasurementParameters', mode=MODE_TYPE)
    _IRATmeasurementParameters_measurementDuration = INT(name=u'measurementDuration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IRATmeasurementParameters_measurementDuration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _IRATmeasurementParameters_eUTRANFrequencies = SEQ_OF(name=u'eUTRANFrequencies', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'EUTRANFrequencies')), opt=True)
    _IRATmeasurementParameters_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IRATmeasurementParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___IRATmeasurementParameters_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____IRATmeasurementParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____IRATmeasurementParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IRATmeasurementParameters_iE_Extensions__item__id._const_tab = ____IRATmeasurementParameters_iE_Extensions__item__id_tab
    ___IRATmeasurementParameters_iE_Extensions__item__id._const_tab_at = None
    ___IRATmeasurementParameters_iE_Extensions__item__id._const_tab_id = u'id'
    ___IRATmeasurementParameters_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IRATmeasurementParameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____IRATmeasurementParameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IRATmeasurementParameters_iE_Extensions__item__criticality._const_tab = ____IRATmeasurementParameters_iE_Extensions__item__criticality_tab
    ___IRATmeasurementParameters_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IRATmeasurementParameters_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IRATmeasurementParameters_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IRATmeasurementParameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____IRATmeasurementParameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IRATmeasurementParameters_iE_Extensions__item__extensionValue._const_tab = ____IRATmeasurementParameters_iE_Extensions__item__extensionValue_tab
    ___IRATmeasurementParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IRATmeasurementParameters_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IRATmeasurementParameters_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IRATmeasurementParameters_iE_Extensions__item__id),
        (u'criticality', ___IRATmeasurementParameters_iE_Extensions__item__criticality),
        (u'extensionValue', ___IRATmeasurementParameters_iE_Extensions__item__extensionValue),
        ])
    __IRATmeasurementParameters_iE_Extensions__item_._ext = None
    _IRATmeasurementParameters_iE_Extensions._cont = __IRATmeasurementParameters_iE_Extensions__item_
    _IRATmeasurementParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IRATmeasurementParameters._cont = ASN1Dict([
        (u'measurementDuration', _IRATmeasurementParameters_measurementDuration),
        (u'eUTRANFrequencies', _IRATmeasurementParameters_eUTRANFrequencies),
        (u'iE-Extensions', _IRATmeasurementParameters_iE_Extensions),
        ])
    IRATmeasurementParameters._ext = None
    
    #-----< IRATmeasurementParameters-ExtIEs >-----#
    IRATmeasurementParameters_ExtIEs = CLASS(name=u'IRATmeasurementParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    IRATmeasurementParameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RSRQ-Type >-----#
    RSRQ_Type = SEQ(name=u'RSRQ-Type', mode=MODE_TYPE)
    _RSRQ_Type_allSymbols = BOOL(name=u'allSymbols', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RSRQ_Type_wideBand = BOOL(name=u'wideBand', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    RSRQ_Type._cont = ASN1Dict([
        (u'allSymbols', _RSRQ_Type_allSymbols),
        (u'wideBand', _RSRQ_Type_wideBand),
        ])
    RSRQ_Type._ext = None
    
    #-----< RSRQ-Extension >-----#
    RSRQ_Extension = INT(name=u'RSRQ-Extension', mode=MODE_TYPE)
    RSRQ_Extension._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-30, ub=46)], ev=[], er=[])
    
    #-----< EUTRANFrequencies >-----#
    EUTRANFrequencies = SEQ_OF(name=u'EUTRANFrequencies', mode=MODE_TYPE)
    _EUTRANFrequencies__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __EUTRANFrequencies__item__earfcn = INT(name=u'earfcn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __EUTRANFrequencies__item__earfcn._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    __EUTRANFrequencies__item__measBand = ENUM(name=u'measBand', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'MeasBand')), opt=True)
    __EUTRANFrequencies__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___EUTRANFrequencies__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____EUTRANFrequencies__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    _____EUTRANFrequencies__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ______EUTRANFrequencies__item__iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'EARFCN-Extended')))
    _____EUTRANFrequencies__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 271), (u'criticality', u'reject'), (u'Extension', ______EUTRANFrequencies__item__iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ____EUTRANFrequencies__item__iE_Extensions__item__id._const_tab = _____EUTRANFrequencies__item__iE_Extensions__item__id_tab
    ____EUTRANFrequencies__item__iE_Extensions__item__id._const_tab_at = None
    ____EUTRANFrequencies__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____EUTRANFrequencies__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EUTRANFrequencies__item__iE_Extensions__item__criticality._const_tab = _____EUTRANFrequencies__item__iE_Extensions__item__id_tab
    ____EUTRANFrequencies__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____EUTRANFrequencies__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____EUTRANFrequencies__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EUTRANFrequencies__item__iE_Extensions__item__extensionValue._const_tab = _____EUTRANFrequencies__item__iE_Extensions__item__id_tab
    ____EUTRANFrequencies__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____EUTRANFrequencies__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___EUTRANFrequencies__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____EUTRANFrequencies__item__iE_Extensions__item__id),
        (u'criticality', ____EUTRANFrequencies__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____EUTRANFrequencies__item__iE_Extensions__item__extensionValue),
        ])
    ___EUTRANFrequencies__item__iE_Extensions__item_._ext = None
    __EUTRANFrequencies__item__iE_Extensions._cont = ___EUTRANFrequencies__item__iE_Extensions__item_
    __EUTRANFrequencies__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _EUTRANFrequencies__item_._cont = ASN1Dict([
        (u'earfcn', __EUTRANFrequencies__item__earfcn),
        (u'measBand', __EUTRANFrequencies__item__measBand),
        (u'iE-Extensions', __EUTRANFrequencies__item__iE_Extensions),
        ])
    _EUTRANFrequencies__item_._ext = None
    EUTRANFrequencies._cont = _EUTRANFrequencies__item_
    EUTRANFrequencies._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MeasBand >-----#
    MeasBand = ENUM(name=u'MeasBand', mode=MODE_TYPE)
    MeasBand._cont = ASN1Dict([(u'v6', 0), (u'v15', 1), (u'v25', 2), (u'v50', 3), (u'v75', 4), (u'v100', 5)])
    MeasBand._ext = None
    
    #-----< EUTRANFrequencies-ExtIEs >-----#
    EUTRANFrequencies_ExtIEs = CLASS(name=u'EUTRANFrequencies-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _EUTRANFrequencies_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'EARFCN-Extended')))
    EUTRANFrequencies_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 271), (u'criticality', u'reject'), (u'Extension', _EUTRANFrequencies_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SubscriberProfileIDforRFP >-----#
    SubscriberProfileIDforRFP = INT(name=u'SubscriberProfileIDforRFP', mode=MODE_TYPE)
    SubscriberProfileIDforRFP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< SourceStatisticsDescriptor >-----#
    SourceStatisticsDescriptor = ENUM(name=u'SourceStatisticsDescriptor', mode=MODE_TYPE)
    SourceStatisticsDescriptor._cont = ASN1Dict([(u'speech', 0), (u'unknown', 1)])
    SourceStatisticsDescriptor._ext = []
    
    #-----< SupportedRAB-ParameterBitrateList >-----#
    SupportedRAB_ParameterBitrateList = SEQ_OF(name=u'SupportedRAB-ParameterBitrateList', mode=MODE_TYPE)
    _SupportedRAB_ParameterBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedBitrate')))
    SupportedRAB_ParameterBitrateList._cont = _SupportedRAB_ParameterBitrateList__item_
    SupportedRAB_ParameterBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< SupportedBitrate >-----#
    SupportedBitrate = INT(name=u'SupportedBitrate', mode=MODE_TYPE)
    SupportedBitrate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1000000000)], ev=[], er=[])
    
    #-----< SourceUTRANCellID >-----#
    SourceUTRANCellID = SEQ(name=u'SourceUTRANCellID', mode=MODE_TYPE)
    _SourceUTRANCellID_pLMNidentity = OCT_STR(name=u'pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _SourceUTRANCellID_uTRANcellID = INT(name=u'uTRANcellID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TargetCellId')))
    _SourceUTRANCellID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SourceUTRANCellID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SourceUTRANCellID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SourceUTRANCellID_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SourceUTRANCellID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceUTRANCellID_iE_Extensions__item__id._const_tab = ____SourceUTRANCellID_iE_Extensions__item__id_tab
    ___SourceUTRANCellID_iE_Extensions__item__id._const_tab_at = None
    ___SourceUTRANCellID_iE_Extensions__item__id._const_tab_id = u'id'
    ___SourceUTRANCellID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SourceUTRANCellID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SourceUTRANCellID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceUTRANCellID_iE_Extensions__item__criticality._const_tab = ____SourceUTRANCellID_iE_Extensions__item__criticality_tab
    ___SourceUTRANCellID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SourceUTRANCellID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SourceUTRANCellID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SourceUTRANCellID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SourceUTRANCellID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceUTRANCellID_iE_Extensions__item__extensionValue._const_tab = ____SourceUTRANCellID_iE_Extensions__item__extensionValue_tab
    ___SourceUTRANCellID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SourceUTRANCellID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SourceUTRANCellID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SourceUTRANCellID_iE_Extensions__item__id),
        (u'criticality', ___SourceUTRANCellID_iE_Extensions__item__criticality),
        (u'extensionValue', ___SourceUTRANCellID_iE_Extensions__item__extensionValue),
        ])
    __SourceUTRANCellID_iE_Extensions__item_._ext = None
    _SourceUTRANCellID_iE_Extensions._cont = __SourceUTRANCellID_iE_Extensions__item_
    _SourceUTRANCellID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SourceUTRANCellID._cont = ASN1Dict([
        (u'pLMNidentity', _SourceUTRANCellID_pLMNidentity),
        (u'uTRANcellID', _SourceUTRANCellID_uTRANcellID),
        (u'iE-Extensions', _SourceUTRANCellID_iE_Extensions),
        ])
    SourceUTRANCellID._ext = None
    
    #-----< SourceUTRANCellID-ExtIEs >-----#
    SourceUTRANCellID_ExtIEs = CLASS(name=u'SourceUTRANCellID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SourceUTRANCellID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRB-ID >-----#
    SRB_ID = INT(name=u'SRB-ID', mode=MODE_TYPE)
    SRB_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SRB-TrCH-Mapping >-----#
    SRB_TrCH_Mapping = SEQ_OF(name=u'SRB-TrCH-Mapping', mode=MODE_TYPE)
    _SRB_TrCH_Mapping__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRB-TrCH-MappingItem')))
    SRB_TrCH_Mapping._cont = _SRB_TrCH_Mapping__item_
    SRB_TrCH_Mapping._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< SRB-TrCH-MappingItem >-----#
    SRB_TrCH_MappingItem = SEQ(name=u'SRB-TrCH-MappingItem', mode=MODE_TYPE)
    _SRB_TrCH_MappingItem_sRB_ID = INT(name=u'sRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SRB-ID')))
    _SRB_TrCH_MappingItem_trCH_ID = SEQ(name=u'trCH-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TrCH-ID')))
    _SRB_TrCH_MappingItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRB_TrCH_MappingItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SRB_TrCH_MappingItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SRB_TrCH_MappingItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRB_TrCH_MappingItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRB_TrCH_MappingItem_iE_Extensions__item__id._const_tab = ____SRB_TrCH_MappingItem_iE_Extensions__item__id_tab
    ___SRB_TrCH_MappingItem_iE_Extensions__item__id._const_tab_at = None
    ___SRB_TrCH_MappingItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___SRB_TrCH_MappingItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SRB_TrCH_MappingItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRB_TrCH_MappingItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRB_TrCH_MappingItem_iE_Extensions__item__criticality._const_tab = ____SRB_TrCH_MappingItem_iE_Extensions__item__criticality_tab
    ___SRB_TrCH_MappingItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRB_TrCH_MappingItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SRB_TrCH_MappingItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SRB_TrCH_MappingItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRB_TrCH_MappingItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRB_TrCH_MappingItem_iE_Extensions__item__extensionValue._const_tab = ____SRB_TrCH_MappingItem_iE_Extensions__item__extensionValue_tab
    ___SRB_TrCH_MappingItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRB_TrCH_MappingItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SRB_TrCH_MappingItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SRB_TrCH_MappingItem_iE_Extensions__item__id),
        (u'criticality', ___SRB_TrCH_MappingItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___SRB_TrCH_MappingItem_iE_Extensions__item__extensionValue),
        ])
    __SRB_TrCH_MappingItem_iE_Extensions__item_._ext = None
    _SRB_TrCH_MappingItem_iE_Extensions._cont = __SRB_TrCH_MappingItem_iE_Extensions__item_
    _SRB_TrCH_MappingItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRB_TrCH_MappingItem._cont = ASN1Dict([
        (u'sRB-ID', _SRB_TrCH_MappingItem_sRB_ID),
        (u'trCH-ID', _SRB_TrCH_MappingItem_trCH_ID),
        (u'iE-Extensions', _SRB_TrCH_MappingItem_iE_Extensions),
        ])
    SRB_TrCH_MappingItem._ext = []
    
    #-----< SRB-TrCH-MappingItem-ExtIEs >-----#
    SRB_TrCH_MappingItem_ExtIEs = CLASS(name=u'SRB-TrCH-MappingItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SRB_TrCH_MappingItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRVCC-HO-Indication >-----#
    SRVCC_HO_Indication = ENUM(name=u'SRVCC-HO-Indication', mode=MODE_TYPE)
    SRVCC_HO_Indication._cont = ASN1Dict([(u'ps-and-cs', 0), (u'cs-only', 1)])
    SRVCC_HO_Indication._ext = []
    
    #-----< SRVCC-Information >-----#
    SRVCC_Information = SEQ(name=u'SRVCC-Information', mode=MODE_TYPE)
    _SRVCC_Information_nonce = BIT_STR(name=u'nonce', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRVCC_Information_nonce._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    _SRVCC_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRVCC_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SRVCC_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SRVCC_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRVCC_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRVCC_Information_iE_Extensions__item__id._const_tab = ____SRVCC_Information_iE_Extensions__item__id_tab
    ___SRVCC_Information_iE_Extensions__item__id._const_tab_at = None
    ___SRVCC_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___SRVCC_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SRVCC_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRVCC_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRVCC_Information_iE_Extensions__item__criticality._const_tab = ____SRVCC_Information_iE_Extensions__item__criticality_tab
    ___SRVCC_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRVCC_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SRVCC_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SRVCC_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRVCC_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRVCC_Information_iE_Extensions__item__extensionValue._const_tab = ____SRVCC_Information_iE_Extensions__item__extensionValue_tab
    ___SRVCC_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRVCC_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SRVCC_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SRVCC_Information_iE_Extensions__item__id),
        (u'criticality', ___SRVCC_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___SRVCC_Information_iE_Extensions__item__extensionValue),
        ])
    __SRVCC_Information_iE_Extensions__item_._ext = None
    _SRVCC_Information_iE_Extensions._cont = __SRVCC_Information_iE_Extensions__item_
    _SRVCC_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRVCC_Information._cont = ASN1Dict([
        (u'nonce', _SRVCC_Information_nonce),
        (u'iE-Extensions', _SRVCC_Information_iE_Extensions),
        ])
    SRVCC_Information._ext = []
    
    #-----< SRVCC-Information-ExtIEs >-----#
    SRVCC_Information_ExtIEs = CLASS(name=u'SRVCC-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SRVCC_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRVCC-Operation-Possible >-----#
    SRVCC_Operation_Possible = ENUM(name=u'SRVCC-Operation-Possible', mode=MODE_TYPE)
    SRVCC_Operation_Possible._cont = ASN1Dict([(u'srvcc-possible', 0)])
    SRVCC_Operation_Possible._ext = []
    
    #-----< SubflowSDU-Size >-----#
    SubflowSDU_Size = INT(name=u'SubflowSDU-Size', mode=MODE_TYPE)
    SubflowSDU_Size._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< TAC >-----#
    TAC = OCT_STR(name=u'TAC', mode=MODE_TYPE)
    TAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< TAI >-----#
    TAI = SEQ(name=u'TAI', mode=MODE_TYPE)
    _TAI_pLMNidentity = OCT_STR(name=u'pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _TAI_tAC = OCT_STR(name=u'tAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TAC')))
    _TAI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___TAI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TAI_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_iE_Extensions__item__id._const_tab = ____TAI_iE_Extensions__item__id_tab
    ___TAI_iE_Extensions__item__id._const_tab_at = None
    ___TAI_iE_Extensions__item__id._const_tab_id = u'id'
    ___TAI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_iE_Extensions__item__criticality._const_tab = ____TAI_iE_Extensions__item__criticality_tab
    ___TAI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TAI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TAI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_iE_Extensions__item__extensionValue._const_tab = ____TAI_iE_Extensions__item__extensionValue_tab
    ___TAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TAI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TAI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TAI_iE_Extensions__item__id),
        (u'criticality', ___TAI_iE_Extensions__item__criticality),
        (u'extensionValue', ___TAI_iE_Extensions__item__extensionValue),
        ])
    __TAI_iE_Extensions__item_._ext = None
    _TAI_iE_Extensions._cont = __TAI_iE_Extensions__item_
    _TAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAI._cont = ASN1Dict([
        (u'pLMNidentity', _TAI_pLMNidentity),
        (u'tAC', _TAI_tAC),
        (u'iE-Extensions', _TAI_iE_Extensions),
        ])
    TAI._ext = None
    
    #-----< TAI-ExtIEs >-----#
    TAI_ExtIEs = CLASS(name=u'TAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    TAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Target-ToSource-TransparentContainer >-----#
    Target_ToSource_TransparentContainer = OCT_STR(name=u'Target-ToSource-TransparentContainer', mode=MODE_TYPE)
    
    #-----< TargeteNodeB-ToSourceeNodeB-TransparentContainer >-----#
    TargeteNodeB_ToSourceeNodeB_TransparentContainer = OCT_STR(name=u'TargeteNodeB-ToSourceeNodeB-TransparentContainer', mode=MODE_TYPE)
    
    #-----< TargetBSS-ToSourceBSS-TransparentContainer >-----#
    TargetBSS_ToSourceBSS_TransparentContainer = OCT_STR(name=u'TargetBSS-ToSourceBSS-TransparentContainer', mode=MODE_TYPE)
    
    #-----< TargetCellId >-----#
    TargetCellId = INT(name=u'TargetCellId', mode=MODE_TYPE)
    TargetCellId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=268435455)], ev=None, er=[])
    
    #-----< TargetID >-----#
    TargetID = CHOICE(name=u'TargetID', mode=MODE_TYPE)
    _TargetID_targetRNC_ID = SEQ(name=u'targetRNC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TargetRNC-ID')))
    _TargetID_cGI = SEQ(name=u'cGI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CGI')))
    _TargetID_targeteNB_ID = SEQ(name=u'targeteNB-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TargetENB-ID')))
    TargetID._cont = ASN1Dict([
        (u'targetRNC-ID', _TargetID_targetRNC_ID),
        (u'cGI', _TargetID_cGI),
        (u'targeteNB-ID', _TargetID_targeteNB_ID),
        ])
    TargetID._ext = [u'targeteNB-ID']
    
    #-----< TargetENB-ID >-----#
    TargetENB_ID = SEQ(name=u'TargetENB-ID', mode=MODE_TYPE)
    _TargetENB_ID_pLMNidentity = OCT_STR(name=u'pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _TargetENB_ID_eNB_ID = CHOICE(name=u'eNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ENB-ID')))
    _TargetENB_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargetENB_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___TargetENB_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TargetENB_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TargetENB_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetENB_ID_iE_Extensions__item__id._const_tab = ____TargetENB_ID_iE_Extensions__item__id_tab
    ___TargetENB_ID_iE_Extensions__item__id._const_tab_at = None
    ___TargetENB_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___TargetENB_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TargetENB_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TargetENB_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetENB_ID_iE_Extensions__item__criticality._const_tab = ____TargetENB_ID_iE_Extensions__item__criticality_tab
    ___TargetENB_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TargetENB_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TargetENB_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TargetENB_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TargetENB_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetENB_ID_iE_Extensions__item__extensionValue._const_tab = ____TargetENB_ID_iE_Extensions__item__extensionValue_tab
    ___TargetENB_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TargetENB_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TargetENB_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TargetENB_ID_iE_Extensions__item__id),
        (u'criticality', ___TargetENB_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___TargetENB_ID_iE_Extensions__item__extensionValue),
        ])
    __TargetENB_ID_iE_Extensions__item_._ext = None
    _TargetENB_ID_iE_Extensions._cont = __TargetENB_ID_iE_Extensions__item_
    _TargetENB_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _TargetENB_ID_selectedTAI = SEQ(name=u'selectedTAI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TAI')))
    TargetENB_ID._cont = ASN1Dict([
        (u'pLMNidentity', _TargetENB_ID_pLMNidentity),
        (u'eNB-ID', _TargetENB_ID_eNB_ID),
        (u'iE-Extensions', _TargetENB_ID_iE_Extensions),
        (u'selectedTAI', _TargetENB_ID_selectedTAI),
        ])
    TargetENB_ID._ext = []
    
    #-----< TargetENB-ID-ExtIEs >-----#
    TargetENB_ID_ExtIEs = CLASS(name=u'TargetENB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    TargetENB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TargetRNC-ID >-----#
    TargetRNC_ID = SEQ(name=u'TargetRNC-ID', mode=MODE_TYPE)
    _TargetRNC_ID_lAI = SEQ(name=u'lAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LAI')))
    _TargetRNC_ID_rAC = OCT_STR(name=u'rAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAC')), opt=True)
    _TargetRNC_ID_rNC_ID = INT(name=u'rNC-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RNC-ID')))
    _TargetRNC_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargetRNC_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___TargetRNC_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TargetRNC_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____TargetRNC_ID_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ____TargetRNC_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _____TargetRNC_ID_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___TargetRNC_ID_iE_Extensions__item__id._const_tab = ____TargetRNC_ID_iE_Extensions__item__id_tab
    ___TargetRNC_ID_iE_Extensions__item__id._const_tab_at = None
    ___TargetRNC_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___TargetRNC_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___TargetRNC_ID_iE_Extensions__item__criticality._const_tab = ____TargetRNC_ID_iE_Extensions__item__id_tab
    ___TargetRNC_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TargetRNC_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TargetRNC_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___TargetRNC_ID_iE_Extensions__item__extensionValue._const_tab = ____TargetRNC_ID_iE_Extensions__item__id_tab
    ___TargetRNC_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TargetRNC_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TargetRNC_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TargetRNC_ID_iE_Extensions__item__id),
        (u'criticality', ___TargetRNC_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___TargetRNC_ID_iE_Extensions__item__extensionValue),
        ])
    __TargetRNC_ID_iE_Extensions__item_._ext = None
    _TargetRNC_ID_iE_Extensions._cont = __TargetRNC_ID_iE_Extensions__item_
    _TargetRNC_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargetRNC_ID._cont = ASN1Dict([
        (u'lAI', _TargetRNC_ID_lAI),
        (u'rAC', _TargetRNC_ID_rAC),
        (u'rNC-ID', _TargetRNC_ID_rNC_ID),
        (u'iE-Extensions', _TargetRNC_ID_iE_Extensions),
        ])
    TargetRNC_ID._ext = None
    
    #-----< TargetRNC-ID-ExtIEs >-----#
    TargetRNC_ID_ExtIEs = CLASS(name=u'TargetRNC-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _TargetRNC_ID_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    TargetRNC_ID_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _TargetRNC_ID_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< TargetRNC-ToSourceRNC-TransparentContainer >-----#
    TargetRNC_ToSourceRNC_TransparentContainer = SEQ(name=u'TargetRNC-ToSourceRNC-TransparentContainer', mode=MODE_TYPE)
    _TargetRNC_ToSourceRNC_TransparentContainer_rRC_Container = OCT_STR(name=u'rRC-Container', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RRC-Container')))
    _TargetRNC_ToSourceRNC_TransparentContainer_d_RNTI = INT(name=u'd-RNTI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'D-RNTI')), opt=True)
    _TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UeApplicationLayerMeasurementSupportIndication')))
    ____TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 295), (u'criticality', u'ignore'), (u'Extension', _____TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id._const_tab = ____TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id_tab
    ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id._const_tab_at = None
    ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id._const_tab_id = u'id'
    ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__criticality._const_tab = ____TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id_tab
    ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__extensionValue._const_tab = ____TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id_tab
    ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id),
        (u'criticality', ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__criticality),
        (u'extensionValue', ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__extensionValue),
        ])
    __TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item_._ext = None
    _TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions._cont = __TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item_
    _TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargetRNC_ToSourceRNC_TransparentContainer._cont = ASN1Dict([
        (u'rRC-Container', _TargetRNC_ToSourceRNC_TransparentContainer_rRC_Container),
        (u'd-RNTI', _TargetRNC_ToSourceRNC_TransparentContainer_d_RNTI),
        (u'iE-Extensions', _TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions),
        ])
    TargetRNC_ToSourceRNC_TransparentContainer._ext = []
    
    #-----< TargetRNC-ToSourceRNC-TransparentContainer-ExtIEs >-----#
    TargetRNC_ToSourceRNC_TransparentContainer_ExtIEs = CLASS(name=u'TargetRNC-ToSourceRNC-TransparentContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _TargetRNC_ToSourceRNC_TransparentContainer_ExtIEs_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UeApplicationLayerMeasurementSupportIndication')))
    TargetRNC_ToSourceRNC_TransparentContainer_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 295), (u'criticality', u'ignore'), (u'Extension', _TargetRNC_ToSourceRNC_TransparentContainer_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UeApplicationLayerMeasurementSupportIndication >-----#
    UeApplicationLayerMeasurementSupportIndication = BIT_STR(name=u'UeApplicationLayerMeasurementSupportIndication', mode=MODE_TYPE)
    UeApplicationLayerMeasurementSupportIndication._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< TBCD-STRING >-----#
    TBCD_STRING = OCT_STR(name=u'TBCD-STRING', mode=MODE_TYPE)
    
    #-----< TemporaryUE-ID >-----#
    TemporaryUE_ID = CHOICE(name=u'TemporaryUE-ID', mode=MODE_TYPE)
    _TemporaryUE_ID_tMSI = OCT_STR(name=u'tMSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TMSI')))
    _TemporaryUE_ID_p_TMSI = OCT_STR(name=u'p-TMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'P-TMSI')))
    TemporaryUE_ID._cont = ASN1Dict([
        (u'tMSI', _TemporaryUE_ID_tMSI),
        (u'p-TMSI', _TemporaryUE_ID_p_TMSI),
        ])
    TemporaryUE_ID._ext = []
    
    #-----< Time-UE-StayedInCell >-----#
    Time_UE_StayedInCell = INT(name=u'Time-UE-StayedInCell', mode=MODE_TYPE)
    Time_UE_StayedInCell._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< Time-UE-StayedInCell-EnhancedGranularity >-----#
    Time_UE_StayedInCell_EnhancedGranularity = INT(name=u'Time-UE-StayedInCell-EnhancedGranularity', mode=MODE_TYPE)
    Time_UE_StayedInCell_EnhancedGranularity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=40950)], ev=None, er=[])
    
    #-----< TimeToMBMSDataTransfer >-----#
    TimeToMBMSDataTransfer = OCT_STR(name=u'TimeToMBMSDataTransfer', mode=MODE_TYPE)
    TimeToMBMSDataTransfer._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< TimingDifferenceULDL >-----#
    TimingDifferenceULDL = OCT_STR(name=u'TimingDifferenceULDL', mode=MODE_TYPE)
    TimingDifferenceULDL._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< TMGI >-----#
    TMGI = SEQ(name=u'TMGI', mode=MODE_TYPE)
    _TMGI_pLMNidentity = OCT_STR(name=u'pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _TMGI_serviceID = OCT_STR(name=u'serviceID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TMGI_serviceID._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _TMGI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TMGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___TMGI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TMGI_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TMGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TMGI_iE_Extensions__item__id._const_tab = ____TMGI_iE_Extensions__item__id_tab
    ___TMGI_iE_Extensions__item__id._const_tab_at = None
    ___TMGI_iE_Extensions__item__id._const_tab_id = u'id'
    ___TMGI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TMGI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TMGI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TMGI_iE_Extensions__item__criticality._const_tab = ____TMGI_iE_Extensions__item__criticality_tab
    ___TMGI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TMGI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TMGI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TMGI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TMGI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TMGI_iE_Extensions__item__extensionValue._const_tab = ____TMGI_iE_Extensions__item__extensionValue_tab
    ___TMGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TMGI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TMGI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TMGI_iE_Extensions__item__id),
        (u'criticality', ___TMGI_iE_Extensions__item__criticality),
        (u'extensionValue', ___TMGI_iE_Extensions__item__extensionValue),
        ])
    __TMGI_iE_Extensions__item_._ext = None
    _TMGI_iE_Extensions._cont = __TMGI_iE_Extensions__item_
    _TMGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TMGI._cont = ASN1Dict([
        (u'pLMNidentity', _TMGI_pLMNidentity),
        (u'serviceID', _TMGI_serviceID),
        (u'iE-Extensions', _TMGI_iE_Extensions),
        ])
    TMGI._ext = None
    
    #-----< TMGI-ExtIEs >-----#
    TMGI_ExtIEs = CLASS(name=u'TMGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    TMGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TMSI >-----#
    TMSI = OCT_STR(name=u'TMSI', mode=MODE_TYPE)
    TMSI._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< TraceDepth >-----#
    TraceDepth = ENUM(name=u'TraceDepth', mode=MODE_TYPE)
    TraceDepth._cont = ASN1Dict([(u'minimum', 0), (u'medium', 1), (u'maximum', 2)])
    TraceDepth._ext = []
    
    #-----< TraceInformation >-----#
    TraceInformation = SEQ(name=u'TraceInformation', mode=MODE_TYPE)
    _TraceInformation_traceReference = OCT_STR(name=u'traceReference', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TraceReference')))
    _TraceInformation_ue_identity = CHOICE(name=u'ue-identity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UE-ID')))
    _TraceInformation_tracePropagationParameters = SEQ(name=u'tracePropagationParameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TracePropagationParameters')), opt=True)
    _TraceInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TraceInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___TraceInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TraceInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TraceInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TraceInformation_iE_Extensions__item__id._const_tab = ____TraceInformation_iE_Extensions__item__id_tab
    ___TraceInformation_iE_Extensions__item__id._const_tab_at = None
    ___TraceInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___TraceInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TraceInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TraceInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TraceInformation_iE_Extensions__item__criticality._const_tab = ____TraceInformation_iE_Extensions__item__criticality_tab
    ___TraceInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TraceInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TraceInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TraceInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TraceInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TraceInformation_iE_Extensions__item__extensionValue._const_tab = ____TraceInformation_iE_Extensions__item__extensionValue_tab
    ___TraceInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TraceInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TraceInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TraceInformation_iE_Extensions__item__id),
        (u'criticality', ___TraceInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___TraceInformation_iE_Extensions__item__extensionValue),
        ])
    __TraceInformation_iE_Extensions__item_._ext = None
    _TraceInformation_iE_Extensions._cont = __TraceInformation_iE_Extensions__item_
    _TraceInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TraceInformation._cont = ASN1Dict([
        (u'traceReference', _TraceInformation_traceReference),
        (u'ue-identity', _TraceInformation_ue_identity),
        (u'tracePropagationParameters', _TraceInformation_tracePropagationParameters),
        (u'iE-Extensions', _TraceInformation_iE_Extensions),
        ])
    TraceInformation._ext = []
    
    #-----< TraceInformation-ExtIEs >-----#
    TraceInformation_ExtIEs = CLASS(name=u'TraceInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    TraceInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TracePropagationParameters >-----#
    TracePropagationParameters = SEQ(name=u'TracePropagationParameters', mode=MODE_TYPE)
    _TracePropagationParameters_traceRecordingSessionReference = INT(name=u'traceRecordingSessionReference', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TraceRecordingSessionReference')))
    _TracePropagationParameters_traceDepth = ENUM(name=u'traceDepth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TraceDepth')))
    _TracePropagationParameters_listOfInterfacesToTrace = SEQ_OF(name=u'listOfInterfacesToTrace', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ListOfInterfacesToTrace')), opt=True)
    _TracePropagationParameters_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TracePropagationParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___TracePropagationParameters_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TracePropagationParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TracePropagationParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TracePropagationParameters_iE_Extensions__item__id._const_tab = ____TracePropagationParameters_iE_Extensions__item__id_tab
    ___TracePropagationParameters_iE_Extensions__item__id._const_tab_at = None
    ___TracePropagationParameters_iE_Extensions__item__id._const_tab_id = u'id'
    ___TracePropagationParameters_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TracePropagationParameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TracePropagationParameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TracePropagationParameters_iE_Extensions__item__criticality._const_tab = ____TracePropagationParameters_iE_Extensions__item__criticality_tab
    ___TracePropagationParameters_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TracePropagationParameters_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TracePropagationParameters_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TracePropagationParameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TracePropagationParameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TracePropagationParameters_iE_Extensions__item__extensionValue._const_tab = ____TracePropagationParameters_iE_Extensions__item__extensionValue_tab
    ___TracePropagationParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TracePropagationParameters_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TracePropagationParameters_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TracePropagationParameters_iE_Extensions__item__id),
        (u'criticality', ___TracePropagationParameters_iE_Extensions__item__criticality),
        (u'extensionValue', ___TracePropagationParameters_iE_Extensions__item__extensionValue),
        ])
    __TracePropagationParameters_iE_Extensions__item_._ext = None
    _TracePropagationParameters_iE_Extensions._cont = __TracePropagationParameters_iE_Extensions__item_
    _TracePropagationParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TracePropagationParameters._cont = ASN1Dict([
        (u'traceRecordingSessionReference', _TracePropagationParameters_traceRecordingSessionReference),
        (u'traceDepth', _TracePropagationParameters_traceDepth),
        (u'listOfInterfacesToTrace', _TracePropagationParameters_listOfInterfacesToTrace),
        (u'iE-Extensions', _TracePropagationParameters_iE_Extensions),
        ])
    TracePropagationParameters._ext = []
    
    #-----< TracePropagationParameters-ExtIEs >-----#
    TracePropagationParameters_ExtIEs = CLASS(name=u'TracePropagationParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    TracePropagationParameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TraceRecordingSessionInformation >-----#
    TraceRecordingSessionInformation = SEQ(name=u'TraceRecordingSessionInformation', mode=MODE_TYPE)
    _TraceRecordingSessionInformation_traceReference = OCT_STR(name=u'traceReference', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TraceReference')))
    _TraceRecordingSessionInformation_traceRecordingSessionReference = INT(name=u'traceRecordingSessionReference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TraceRecordingSessionReference')))
    _TraceRecordingSessionInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TraceRecordingSessionInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___TraceRecordingSessionInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TraceRecordingSessionInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TraceRecordingSessionInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TraceRecordingSessionInformation_iE_Extensions__item__id._const_tab = ____TraceRecordingSessionInformation_iE_Extensions__item__id_tab
    ___TraceRecordingSessionInformation_iE_Extensions__item__id._const_tab_at = None
    ___TraceRecordingSessionInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___TraceRecordingSessionInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TraceRecordingSessionInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TraceRecordingSessionInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TraceRecordingSessionInformation_iE_Extensions__item__criticality._const_tab = ____TraceRecordingSessionInformation_iE_Extensions__item__criticality_tab
    ___TraceRecordingSessionInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TraceRecordingSessionInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TraceRecordingSessionInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TraceRecordingSessionInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TraceRecordingSessionInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TraceRecordingSessionInformation_iE_Extensions__item__extensionValue._const_tab = ____TraceRecordingSessionInformation_iE_Extensions__item__extensionValue_tab
    ___TraceRecordingSessionInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TraceRecordingSessionInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TraceRecordingSessionInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TraceRecordingSessionInformation_iE_Extensions__item__id),
        (u'criticality', ___TraceRecordingSessionInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___TraceRecordingSessionInformation_iE_Extensions__item__extensionValue),
        ])
    __TraceRecordingSessionInformation_iE_Extensions__item_._ext = None
    _TraceRecordingSessionInformation_iE_Extensions._cont = __TraceRecordingSessionInformation_iE_Extensions__item_
    _TraceRecordingSessionInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TraceRecordingSessionInformation._cont = ASN1Dict([
        (u'traceReference', _TraceRecordingSessionInformation_traceReference),
        (u'traceRecordingSessionReference', _TraceRecordingSessionInformation_traceRecordingSessionReference),
        (u'iE-Extensions', _TraceRecordingSessionInformation_iE_Extensions),
        ])
    TraceRecordingSessionInformation._ext = []
    
    #-----< TraceRecordingSessionInformation-ExtIEs >-----#
    TraceRecordingSessionInformation_ExtIEs = CLASS(name=u'TraceRecordingSessionInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    TraceRecordingSessionInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TraceRecordingSessionReference >-----#
    TraceRecordingSessionReference = INT(name=u'TraceRecordingSessionReference', mode=MODE_TYPE)
    TraceRecordingSessionReference._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TraceReference >-----#
    TraceReference = OCT_STR(name=u'TraceReference', mode=MODE_TYPE)
    TraceReference._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=3)], ev=None, er=[])
    
    #-----< TraceType >-----#
    TraceType = OCT_STR(name=u'TraceType', mode=MODE_TYPE)
    TraceType._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< TrafficClass >-----#
    TrafficClass = ENUM(name=u'TrafficClass', mode=MODE_TYPE)
    TrafficClass._cont = ASN1Dict([(u'conversational', 0), (u'streaming', 1), (u'interactive', 2), (u'background', 3)])
    TrafficClass._ext = []
    
    #-----< TrafficHandlingPriority >-----#
    TrafficHandlingPriority = INT(name=u'TrafficHandlingPriority', mode=MODE_TYPE)
    TrafficHandlingPriority._cont = ASN1Dict([(u'spare', 0), (u'highest', 1), (u'lowest', 14), (u'no-priority-used', 15)])
    TrafficHandlingPriority._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< TransferDelay >-----#
    TransferDelay = INT(name=u'TransferDelay', mode=MODE_TYPE)
    TransferDelay._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< UnsuccessfullyTransmittedDataVolume >-----#
    UnsuccessfullyTransmittedDataVolume = INT(name=u'UnsuccessfullyTransmittedDataVolume', mode=MODE_TYPE)
    UnsuccessfullyTransmittedDataVolume._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< TransportLayerAddress >-----#
    TransportLayerAddress = BIT_STR(name=u'TransportLayerAddress', mode=MODE_TYPE)
    TransportLayerAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=[], er=[])
    
    #-----< TrCH-ID >-----#
    TrCH_ID = SEQ(name=u'TrCH-ID', mode=MODE_TYPE)
    _TrCH_ID_dCH_ID = INT(name=u'dCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DCH-ID')), opt=True)
    _TrCH_ID_dSCH_ID = INT(name=u'dSCH-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DSCH-ID')), opt=True)
    _TrCH_ID_uSCH_ID = INT(name=u'uSCH-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'USCH-ID')), opt=True)
    _TrCH_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TrCH_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___TrCH_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TrCH_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____TrCH_ID_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'HS-DSCH-MAC-d-Flow-ID')))
    _____TrCH_ID_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'E-DCH-MAC-d-Flow-ID')))
    ____TrCH_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 117), (u'criticality', u'ignore'), (u'Extension', _____TrCH_ID_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 160), (u'criticality', u'ignore'), (u'Extension', _____TrCH_ID_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___TrCH_ID_iE_Extensions__item__id._const_tab = ____TrCH_ID_iE_Extensions__item__id_tab
    ___TrCH_ID_iE_Extensions__item__id._const_tab_at = None
    ___TrCH_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___TrCH_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___TrCH_ID_iE_Extensions__item__criticality._const_tab = ____TrCH_ID_iE_Extensions__item__id_tab
    ___TrCH_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TrCH_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TrCH_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___TrCH_ID_iE_Extensions__item__extensionValue._const_tab = ____TrCH_ID_iE_Extensions__item__id_tab
    ___TrCH_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TrCH_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TrCH_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TrCH_ID_iE_Extensions__item__id),
        (u'criticality', ___TrCH_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___TrCH_ID_iE_Extensions__item__extensionValue),
        ])
    __TrCH_ID_iE_Extensions__item_._ext = None
    _TrCH_ID_iE_Extensions._cont = __TrCH_ID_iE_Extensions__item_
    _TrCH_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TrCH_ID._cont = ASN1Dict([
        (u'dCH-ID', _TrCH_ID_dCH_ID),
        (u'dSCH-ID', _TrCH_ID_dSCH_ID),
        (u'uSCH-ID', _TrCH_ID_uSCH_ID),
        (u'iE-Extensions', _TrCH_ID_iE_Extensions),
        ])
    TrCH_ID._ext = []
    
    #-----< TrCH-ID-ExtIEs >-----#
    TrCH_ID_ExtIEs = CLASS(name=u'TrCH-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _TrCH_ID_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'HS-DSCH-MAC-d-Flow-ID')))
    _TrCH_ID_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'E-DCH-MAC-d-Flow-ID')))
    TrCH_ID_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 117), (u'criticality', u'ignore'), (u'Extension', _TrCH_ID_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 160), (u'criticality', u'ignore'), (u'Extension', _TrCH_ID_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< TrCH-ID-List >-----#
    TrCH_ID_List = SEQ_OF(name=u'TrCH-ID-List', mode=MODE_TYPE)
    _TrCH_ID_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TrCH-ID')))
    TrCH_ID_List._cont = _TrCH_ID_List__item_
    TrCH_ID_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< TriggerID >-----#
    TriggerID = OCT_STR(name=u'TriggerID', mode=MODE_TYPE)
    TriggerID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=22)], ev=None, er=[])
    
    #-----< TunnelInformation >-----#
    TunnelInformation = SEQ(name=u'TunnelInformation', mode=MODE_TYPE)
    _TunnelInformation_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _TunnelInformation_uDP_Port_Number = OCT_STR(name=u'uDP-Port-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Port-Number')), opt=True)
    _TunnelInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TunnelInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___TunnelInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TunnelInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TunnelInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TunnelInformation_iE_Extensions__item__id._const_tab = ____TunnelInformation_iE_Extensions__item__id_tab
    ___TunnelInformation_iE_Extensions__item__id._const_tab_at = None
    ___TunnelInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___TunnelInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TunnelInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TunnelInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TunnelInformation_iE_Extensions__item__criticality._const_tab = ____TunnelInformation_iE_Extensions__item__criticality_tab
    ___TunnelInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TunnelInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TunnelInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TunnelInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TunnelInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TunnelInformation_iE_Extensions__item__extensionValue._const_tab = ____TunnelInformation_iE_Extensions__item__extensionValue_tab
    ___TunnelInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TunnelInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TunnelInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TunnelInformation_iE_Extensions__item__id),
        (u'criticality', ___TunnelInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___TunnelInformation_iE_Extensions__item__extensionValue),
        ])
    __TunnelInformation_iE_Extensions__item_._ext = None
    _TunnelInformation_iE_Extensions._cont = __TunnelInformation_iE_Extensions__item_
    _TunnelInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TunnelInformation._cont = ASN1Dict([
        (u'transportLayerAddress', _TunnelInformation_transportLayerAddress),
        (u'uDP-Port-Number', _TunnelInformation_uDP_Port_Number),
        (u'iE-Extensions', _TunnelInformation_iE_Extensions),
        ])
    TunnelInformation._ext = []
    
    #-----< Tunnel-Information-ExtIEs >-----#
    Tunnel_Information_ExtIEs = CLASS(name=u'Tunnel-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    Tunnel_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TypeOfError >-----#
    TypeOfError = ENUM(name=u'TypeOfError', mode=MODE_TYPE)
    TypeOfError._cont = ASN1Dict([(u'not-understood', 0), (u'missing', 1)])
    TypeOfError._ext = []
    
    #-----< UE-AggregateMaximumBitRate >-----#
    UE_AggregateMaximumBitRate = SEQ(name=u'UE-AggregateMaximumBitRate', mode=MODE_TYPE)
    _UE_AggregateMaximumBitRate_uE_AggregateMaximumBitRateDownlink = INT(name=u'uE-AggregateMaximumBitRateDownlink', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UE-AggregateMaximumBitRateDownlink')), opt=True)
    _UE_AggregateMaximumBitRate_uE_AggregateMaximumBitRateUplink = INT(name=u'uE-AggregateMaximumBitRateUplink', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UE-AggregateMaximumBitRateUplink')), opt=True)
    UE_AggregateMaximumBitRate._cont = ASN1Dict([
        (u'uE-AggregateMaximumBitRateDownlink', _UE_AggregateMaximumBitRate_uE_AggregateMaximumBitRateDownlink),
        (u'uE-AggregateMaximumBitRateUplink', _UE_AggregateMaximumBitRate_uE_AggregateMaximumBitRateUplink),
        ])
    UE_AggregateMaximumBitRate._ext = []
    
    #-----< UE-AggregateMaximumBitRateDownlink >-----#
    UE_AggregateMaximumBitRateDownlink = INT(name=u'UE-AggregateMaximumBitRateDownlink', mode=MODE_TYPE)
    UE_AggregateMaximumBitRateDownlink._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1000000000)], ev=None, er=[])
    
    #-----< UE-AggregateMaximumBitRateUplink >-----#
    UE_AggregateMaximumBitRateUplink = INT(name=u'UE-AggregateMaximumBitRateUplink', mode=MODE_TYPE)
    UE_AggregateMaximumBitRateUplink._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1000000000)], ev=None, er=[])
    
    #-----< UE-Application-Layer-Measurement-Capability >-----#
    UE_Application_Layer_Measurement_Capability = BIT_STR(name=u'UE-Application-Layer-Measurement-Capability', mode=MODE_TYPE)
    UE_Application_Layer_Measurement_Capability._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< UE-History-Information >-----#
    UE_History_Information = OCT_STR(name=u'UE-History-Information', mode=MODE_TYPE)
    
    #-----< UE-ID >-----#
    UE_ID = CHOICE(name=u'UE-ID', mode=MODE_TYPE)
    _UE_ID_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IMSI')))
    _UE_ID_imei = OCT_STR(name=u'imei', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IMEI')))
    _UE_ID_imeisv = OCT_STR(name=u'imeisv', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IMEISV')))
    UE_ID._cont = ASN1Dict([
        (u'imsi', _UE_ID_imsi),
        (u'imei', _UE_ID_imei),
        (u'imeisv', _UE_ID_imeisv),
        ])
    UE_ID._ext = [u'imeisv']
    
    #-----< UE-IsNotServed >-----#
    UE_IsNotServed = SEQ(name=u'UE-IsNotServed', mode=MODE_TYPE)
    _UE_IsNotServed_permanentNAS_UE_ID = CHOICE(name=u'permanentNAS-UE-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    _UE_IsNotServed_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_IsNotServed_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UE_IsNotServed_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UE_IsNotServed_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UE_IsNotServed_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_IsNotServed_iE_Extensions__item__id._const_tab = ____UE_IsNotServed_iE_Extensions__item__id_tab
    ___UE_IsNotServed_iE_Extensions__item__id._const_tab_at = None
    ___UE_IsNotServed_iE_Extensions__item__id._const_tab_id = u'id'
    ___UE_IsNotServed_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UE_IsNotServed_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UE_IsNotServed_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_IsNotServed_iE_Extensions__item__criticality._const_tab = ____UE_IsNotServed_iE_Extensions__item__criticality_tab
    ___UE_IsNotServed_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UE_IsNotServed_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UE_IsNotServed_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UE_IsNotServed_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UE_IsNotServed_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_IsNotServed_iE_Extensions__item__extensionValue._const_tab = ____UE_IsNotServed_iE_Extensions__item__extensionValue_tab
    ___UE_IsNotServed_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UE_IsNotServed_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UE_IsNotServed_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UE_IsNotServed_iE_Extensions__item__id),
        (u'criticality', ___UE_IsNotServed_iE_Extensions__item__criticality),
        (u'extensionValue', ___UE_IsNotServed_iE_Extensions__item__extensionValue),
        ])
    __UE_IsNotServed_iE_Extensions__item_._ext = None
    _UE_IsNotServed_iE_Extensions._cont = __UE_IsNotServed_iE_Extensions__item_
    _UE_IsNotServed_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_IsNotServed._cont = ASN1Dict([
        (u'permanentNAS-UE-ID', _UE_IsNotServed_permanentNAS_UE_ID),
        (u'iE-Extensions', _UE_IsNotServed_iE_Extensions),
        ])
    UE_IsNotServed._ext = []
    
    #-----< UE-IsNotServed-ExtIEs >-----#
    UE_IsNotServed_ExtIEs = CLASS(name=u'UE-IsNotServed-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    UE_IsNotServed_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-IsServed >-----#
    UE_IsServed = SEQ(name=u'UE-IsServed', mode=MODE_TYPE)
    _UE_IsServed_permanentNAS_UE_ID = CHOICE(name=u'permanentNAS-UE-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    _UE_IsServed_pLMNidentity = OCT_STR(name=u'pLMNidentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _UE_IsServed_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_IsServed_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UE_IsServed_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UE_IsServed_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UE_IsServed_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_IsServed_iE_Extensions__item__id._const_tab = ____UE_IsServed_iE_Extensions__item__id_tab
    ___UE_IsServed_iE_Extensions__item__id._const_tab_at = None
    ___UE_IsServed_iE_Extensions__item__id._const_tab_id = u'id'
    ___UE_IsServed_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UE_IsServed_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UE_IsServed_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_IsServed_iE_Extensions__item__criticality._const_tab = ____UE_IsServed_iE_Extensions__item__criticality_tab
    ___UE_IsServed_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UE_IsServed_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UE_IsServed_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UE_IsServed_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UE_IsServed_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_IsServed_iE_Extensions__item__extensionValue._const_tab = ____UE_IsServed_iE_Extensions__item__extensionValue_tab
    ___UE_IsServed_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UE_IsServed_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UE_IsServed_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UE_IsServed_iE_Extensions__item__id),
        (u'criticality', ___UE_IsServed_iE_Extensions__item__criticality),
        (u'extensionValue', ___UE_IsServed_iE_Extensions__item__extensionValue),
        ])
    __UE_IsServed_iE_Extensions__item_._ext = None
    _UE_IsServed_iE_Extensions._cont = __UE_IsServed_iE_Extensions__item_
    _UE_IsServed_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_IsServed._cont = ASN1Dict([
        (u'permanentNAS-UE-ID', _UE_IsServed_permanentNAS_UE_ID),
        (u'pLMNidentity', _UE_IsServed_pLMNidentity),
        (u'iE-Extensions', _UE_IsServed_iE_Extensions),
        ])
    UE_IsServed._ext = []
    
    #-----< UE-IsServed-ExtIEs >-----#
    UE_IsServed_ExtIEs = CLASS(name=u'UE-IsServed-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    UE_IsServed_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-Usage-Type >-----#
    UE_Usage_Type = INT(name=u'UE-Usage-Type', mode=MODE_TYPE)
    UE_Usage_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< UERegistrationQueryResult >-----#
    UERegistrationQueryResult = CHOICE(name=u'UERegistrationQueryResult', mode=MODE_TYPE)
    _UERegistrationQueryResult_uE_IsServed = SEQ(name=u'uE-IsServed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UE-IsServed')))
    _UERegistrationQueryResult_uE_IsNotServed = SEQ(name=u'uE-IsNotServed', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UE-IsNotServed')))
    UERegistrationQueryResult._cont = ASN1Dict([
        (u'uE-IsServed', _UERegistrationQueryResult_uE_IsServed),
        (u'uE-IsNotServed', _UERegistrationQueryResult_uE_IsNotServed),
        ])
    UERegistrationQueryResult._ext = None
    
    #-----< UESBI-Iu >-----#
    UESBI_Iu = SEQ(name=u'UESBI-Iu', mode=MODE_TYPE)
    _UESBI_Iu_uESBI_IuA = BIT_STR(name=u'uESBI-IuA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UESBI-IuA')), opt=True)
    _UESBI_Iu_uESBI_IuB = BIT_STR(name=u'uESBI-IuB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UESBI-IuB')), opt=True)
    _UESBI_Iu_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UESBI_Iu_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UESBI_Iu_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UESBI_Iu_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UESBI_Iu_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESBI_Iu_iE_Extensions__item__id._const_tab = ____UESBI_Iu_iE_Extensions__item__id_tab
    ___UESBI_Iu_iE_Extensions__item__id._const_tab_at = None
    ___UESBI_Iu_iE_Extensions__item__id._const_tab_id = u'id'
    ___UESBI_Iu_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UESBI_Iu_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UESBI_Iu_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESBI_Iu_iE_Extensions__item__criticality._const_tab = ____UESBI_Iu_iE_Extensions__item__criticality_tab
    ___UESBI_Iu_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UESBI_Iu_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UESBI_Iu_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UESBI_Iu_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UESBI_Iu_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESBI_Iu_iE_Extensions__item__extensionValue._const_tab = ____UESBI_Iu_iE_Extensions__item__extensionValue_tab
    ___UESBI_Iu_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UESBI_Iu_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UESBI_Iu_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UESBI_Iu_iE_Extensions__item__id),
        (u'criticality', ___UESBI_Iu_iE_Extensions__item__criticality),
        (u'extensionValue', ___UESBI_Iu_iE_Extensions__item__extensionValue),
        ])
    __UESBI_Iu_iE_Extensions__item_._ext = None
    _UESBI_Iu_iE_Extensions._cont = __UESBI_Iu_iE_Extensions__item_
    _UESBI_Iu_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UESBI_Iu._cont = ASN1Dict([
        (u'uESBI-IuA', _UESBI_Iu_uESBI_IuA),
        (u'uESBI-IuB', _UESBI_Iu_uESBI_IuB),
        (u'iE-Extensions', _UESBI_Iu_iE_Extensions),
        ])
    UESBI_Iu._ext = []
    
    #-----< UESBI-Iu-ExtIEs >-----#
    UESBI_Iu_ExtIEs = CLASS(name=u'UESBI-Iu-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    UESBI_Iu_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UESBI-IuA >-----#
    UESBI_IuA = BIT_STR(name=u'UESBI-IuA', mode=MODE_TYPE)
    UESBI_IuA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< UESBI-IuB >-----#
    UESBI_IuB = BIT_STR(name=u'UESBI-IuB', mode=MODE_TYPE)
    UESBI_IuB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< UL-GTP-PDU-SequenceNumber >-----#
    UL_GTP_PDU_SequenceNumber = INT(name=u'UL-GTP-PDU-SequenceNumber', mode=MODE_TYPE)
    UL_GTP_PDU_SequenceNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< UL-N-PDU-SequenceNumber >-----#
    UL_N_PDU_SequenceNumber = INT(name=u'UL-N-PDU-SequenceNumber', mode=MODE_TYPE)
    UL_N_PDU_SequenceNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< UPInformation >-----#
    UPInformation = SEQ(name=u'UPInformation', mode=MODE_TYPE)
    _UPInformation_frameSeqNoUL = INT(name=u'frameSeqNoUL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'FrameSequenceNumber')))
    _UPInformation_frameSeqNoDL = INT(name=u'frameSeqNoDL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'FrameSequenceNumber')))
    _UPInformation_pdu14FrameSeqNoUL = INT(name=u'pdu14FrameSeqNoUL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PDUType14FrameSequenceNumber')))
    _UPInformation_pdu14FrameSeqNoDL = INT(name=u'pdu14FrameSeqNoDL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PDUType14FrameSequenceNumber')))
    _UPInformation_dataPDUType = ENUM(name=u'dataPDUType', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DataPDUType')))
    _UPInformation_upinitialisationFrame = OCT_STR(name=u'upinitialisationFrame', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UPInitialisationFrame')))
    _UPInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UPInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UPInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UPInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____UPInformation_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TimingDifferenceULDL')))
    ____UPInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 269), (u'criticality', u'ignore'), (u'Extension', _____UPInformation_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UPInformation_iE_Extensions__item__id._const_tab = ____UPInformation_iE_Extensions__item__id_tab
    ___UPInformation_iE_Extensions__item__id._const_tab_at = None
    ___UPInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___UPInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UPInformation_iE_Extensions__item__criticality._const_tab = ____UPInformation_iE_Extensions__item__id_tab
    ___UPInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UPInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UPInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UPInformation_iE_Extensions__item__extensionValue._const_tab = ____UPInformation_iE_Extensions__item__id_tab
    ___UPInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UPInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UPInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UPInformation_iE_Extensions__item__id),
        (u'criticality', ___UPInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___UPInformation_iE_Extensions__item__extensionValue),
        ])
    __UPInformation_iE_Extensions__item_._ext = None
    _UPInformation_iE_Extensions._cont = __UPInformation_iE_Extensions__item_
    _UPInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UPInformation._cont = ASN1Dict([
        (u'frameSeqNoUL', _UPInformation_frameSeqNoUL),
        (u'frameSeqNoDL', _UPInformation_frameSeqNoDL),
        (u'pdu14FrameSeqNoUL', _UPInformation_pdu14FrameSeqNoUL),
        (u'pdu14FrameSeqNoDL', _UPInformation_pdu14FrameSeqNoDL),
        (u'dataPDUType', _UPInformation_dataPDUType),
        (u'upinitialisationFrame', _UPInformation_upinitialisationFrame),
        (u'iE-Extensions', _UPInformation_iE_Extensions),
        ])
    UPInformation._ext = []
    
    #-----< UPInformation-ExtIEs >-----#
    UPInformation_ExtIEs = CLASS(name=u'UPInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _UPInformation_ExtIEs_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TimingDifferenceULDL')))
    UPInformation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 269), (u'criticality', u'ignore'), (u'Extension', _UPInformation_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UPInitialisationFrame >-----#
    UPInitialisationFrame = OCT_STR(name=u'UPInitialisationFrame', mode=MODE_TYPE)
    
    #-----< UP-ModeVersions >-----#
    UP_ModeVersions = BIT_STR(name=u'UP-ModeVersions', mode=MODE_TYPE)
    UP_ModeVersions._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< USCH-ID >-----#
    USCH_ID = INT(name=u'USCH-ID', mode=MODE_TYPE)
    USCH_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< UserPlaneMode >-----#
    UserPlaneMode = ENUM(name=u'UserPlaneMode', mode=MODE_TYPE)
    UserPlaneMode._cont = ASN1Dict([(u'transparent-mode', 0), (u'support-mode-for-predefined-SDU-sizes', 1)])
    UserPlaneMode._ext = []
    
    #-----< UTRAN-CellID >-----#
    UTRAN_CellID = SEQ(name=u'UTRAN-CellID', mode=MODE_TYPE)
    _UTRAN_CellID_pLMNidentity = OCT_STR(name=u'pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _UTRAN_CellID_cellID = INT(name=u'cellID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TargetCellId')))
    _UTRAN_CellID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UTRAN_CellID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UTRAN_CellID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UTRAN_CellID_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UTRAN_CellID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRAN_CellID_iE_Extensions__item__id._const_tab = ____UTRAN_CellID_iE_Extensions__item__id_tab
    ___UTRAN_CellID_iE_Extensions__item__id._const_tab_at = None
    ___UTRAN_CellID_iE_Extensions__item__id._const_tab_id = u'id'
    ___UTRAN_CellID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UTRAN_CellID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UTRAN_CellID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRAN_CellID_iE_Extensions__item__criticality._const_tab = ____UTRAN_CellID_iE_Extensions__item__criticality_tab
    ___UTRAN_CellID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UTRAN_CellID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UTRAN_CellID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UTRAN_CellID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UTRAN_CellID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRAN_CellID_iE_Extensions__item__extensionValue._const_tab = ____UTRAN_CellID_iE_Extensions__item__extensionValue_tab
    ___UTRAN_CellID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UTRAN_CellID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UTRAN_CellID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UTRAN_CellID_iE_Extensions__item__id),
        (u'criticality', ___UTRAN_CellID_iE_Extensions__item__criticality),
        (u'extensionValue', ___UTRAN_CellID_iE_Extensions__item__extensionValue),
        ])
    __UTRAN_CellID_iE_Extensions__item_._ext = None
    _UTRAN_CellID_iE_Extensions._cont = __UTRAN_CellID_iE_Extensions__item_
    _UTRAN_CellID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UTRAN_CellID._cont = ASN1Dict([
        (u'pLMNidentity', _UTRAN_CellID_pLMNidentity),
        (u'cellID', _UTRAN_CellID_cellID),
        (u'iE-Extensions', _UTRAN_CellID_iE_Extensions),
        ])
    UTRAN_CellID._ext = None
    
    #-----< UTRAN-CellID-ExtIEs >-----#
    UTRAN_CellID_ExtIEs = CLASS(name=u'UTRAN-CellID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    UTRAN_CellID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< VelocityEstimate >-----#
    VelocityEstimate = CHOICE(name=u'VelocityEstimate', mode=MODE_TYPE)
    _VelocityEstimate_horizontalVelocity = SEQ(name=u'horizontalVelocity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'HorizontalVelocity')))
    _VelocityEstimate_horizontalWithVerticalVelocity = SEQ(name=u'horizontalWithVerticalVelocity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'HorizontalWithVerticalVelocity')))
    _VelocityEstimate_horizontalVelocityWithUncertainty = SEQ(name=u'horizontalVelocityWithUncertainty', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'HorizontalVelocityWithUncertainty')))
    _VelocityEstimate_horizontalWithVeritcalVelocityAndUncertainty = SEQ(name=u'horizontalWithVeritcalVelocityAndUncertainty', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'HorizontalWithVerticalVelocityAndUncertainty')))
    VelocityEstimate._cont = ASN1Dict([
        (u'horizontalVelocity', _VelocityEstimate_horizontalVelocity),
        (u'horizontalWithVerticalVelocity', _VelocityEstimate_horizontalWithVerticalVelocity),
        (u'horizontalVelocityWithUncertainty', _VelocityEstimate_horizontalVelocityWithUncertainty),
        (u'horizontalWithVeritcalVelocityAndUncertainty', _VelocityEstimate_horizontalWithVeritcalVelocityAndUncertainty),
        ])
    VelocityEstimate._ext = []
    
    #-----< HorizontalVelocity >-----#
    HorizontalVelocity = SEQ(name=u'HorizontalVelocity', mode=MODE_TYPE)
    _HorizontalVelocity_horizontalSpeedAndBearing = SEQ(name=u'horizontalSpeedAndBearing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'HorizontalSpeedAndBearing')))
    _HorizontalVelocity_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HorizontalVelocity_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___HorizontalVelocity_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HorizontalVelocity_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____HorizontalVelocity_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalVelocity_iE_Extensions__item__id._const_tab = ____HorizontalVelocity_iE_Extensions__item__id_tab
    ___HorizontalVelocity_iE_Extensions__item__id._const_tab_at = None
    ___HorizontalVelocity_iE_Extensions__item__id._const_tab_id = u'id'
    ___HorizontalVelocity_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HorizontalVelocity_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____HorizontalVelocity_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalVelocity_iE_Extensions__item__criticality._const_tab = ____HorizontalVelocity_iE_Extensions__item__criticality_tab
    ___HorizontalVelocity_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HorizontalVelocity_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HorizontalVelocity_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HorizontalVelocity_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____HorizontalVelocity_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalVelocity_iE_Extensions__item__extensionValue._const_tab = ____HorizontalVelocity_iE_Extensions__item__extensionValue_tab
    ___HorizontalVelocity_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HorizontalVelocity_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HorizontalVelocity_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HorizontalVelocity_iE_Extensions__item__id),
        (u'criticality', ___HorizontalVelocity_iE_Extensions__item__criticality),
        (u'extensionValue', ___HorizontalVelocity_iE_Extensions__item__extensionValue),
        ])
    __HorizontalVelocity_iE_Extensions__item_._ext = None
    _HorizontalVelocity_iE_Extensions._cont = __HorizontalVelocity_iE_Extensions__item_
    _HorizontalVelocity_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HorizontalVelocity._cont = ASN1Dict([
        (u'horizontalSpeedAndBearing', _HorizontalVelocity_horizontalSpeedAndBearing),
        (u'iE-Extensions', _HorizontalVelocity_iE_Extensions),
        ])
    HorizontalVelocity._ext = []
    
    #-----< HorizontalVelocity-ExtIEs >-----#
    HorizontalVelocity_ExtIEs = CLASS(name=u'HorizontalVelocity-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    HorizontalVelocity_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HorizontalWithVerticalVelocity >-----#
    HorizontalWithVerticalVelocity = SEQ(name=u'HorizontalWithVerticalVelocity', mode=MODE_TYPE)
    _HorizontalWithVerticalVelocity_horizontalSpeedAndBearing = SEQ(name=u'horizontalSpeedAndBearing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'HorizontalSpeedAndBearing')))
    _HorizontalWithVerticalVelocity_veritcalVelocity = SEQ(name=u'veritcalVelocity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'VerticalVelocity')))
    _HorizontalWithVerticalVelocity_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HorizontalWithVerticalVelocity_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HorizontalWithVerticalVelocity_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____HorizontalWithVerticalVelocity_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__id._const_tab = ____HorizontalWithVerticalVelocity_iE_Extensions__item__id_tab
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__id._const_tab_at = None
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__id._const_tab_id = u'id'
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HorizontalWithVerticalVelocity_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____HorizontalWithVerticalVelocity_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__criticality._const_tab = ____HorizontalWithVerticalVelocity_iE_Extensions__item__criticality_tab
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue._const_tab = ____HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue_tab
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HorizontalWithVerticalVelocity_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HorizontalWithVerticalVelocity_iE_Extensions__item__id),
        (u'criticality', ___HorizontalWithVerticalVelocity_iE_Extensions__item__criticality),
        (u'extensionValue', ___HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue),
        ])
    __HorizontalWithVerticalVelocity_iE_Extensions__item_._ext = None
    _HorizontalWithVerticalVelocity_iE_Extensions._cont = __HorizontalWithVerticalVelocity_iE_Extensions__item_
    _HorizontalWithVerticalVelocity_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HorizontalWithVerticalVelocity._cont = ASN1Dict([
        (u'horizontalSpeedAndBearing', _HorizontalWithVerticalVelocity_horizontalSpeedAndBearing),
        (u'veritcalVelocity', _HorizontalWithVerticalVelocity_veritcalVelocity),
        (u'iE-Extensions', _HorizontalWithVerticalVelocity_iE_Extensions),
        ])
    HorizontalWithVerticalVelocity._ext = []
    
    #-----< HorizontalWithVerticalVelocity-ExtIEs >-----#
    HorizontalWithVerticalVelocity_ExtIEs = CLASS(name=u'HorizontalWithVerticalVelocity-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    HorizontalWithVerticalVelocity_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HorizontalVelocityWithUncertainty >-----#
    HorizontalVelocityWithUncertainty = SEQ(name=u'HorizontalVelocityWithUncertainty', mode=MODE_TYPE)
    _HorizontalVelocityWithUncertainty_horizontalSpeedAndBearing = SEQ(name=u'horizontalSpeedAndBearing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'HorizontalSpeedAndBearing')))
    _HorizontalVelocityWithUncertainty_uncertaintySpeed = INT(name=u'uncertaintySpeed', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalVelocityWithUncertainty_uncertaintySpeed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _HorizontalVelocityWithUncertainty_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HorizontalVelocityWithUncertainty_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HorizontalVelocityWithUncertainty_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____HorizontalVelocityWithUncertainty_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__id._const_tab = ____HorizontalVelocityWithUncertainty_iE_Extensions__item__id_tab
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__id._const_tab_at = None
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__id._const_tab_id = u'id'
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality._const_tab = ____HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality_tab
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue._const_tab = ____HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue_tab
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HorizontalVelocityWithUncertainty_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HorizontalVelocityWithUncertainty_iE_Extensions__item__id),
        (u'criticality', ___HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality),
        (u'extensionValue', ___HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue),
        ])
    __HorizontalVelocityWithUncertainty_iE_Extensions__item_._ext = None
    _HorizontalVelocityWithUncertainty_iE_Extensions._cont = __HorizontalVelocityWithUncertainty_iE_Extensions__item_
    _HorizontalVelocityWithUncertainty_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HorizontalVelocityWithUncertainty._cont = ASN1Dict([
        (u'horizontalSpeedAndBearing', _HorizontalVelocityWithUncertainty_horizontalSpeedAndBearing),
        (u'uncertaintySpeed', _HorizontalVelocityWithUncertainty_uncertaintySpeed),
        (u'iE-Extensions', _HorizontalVelocityWithUncertainty_iE_Extensions),
        ])
    HorizontalVelocityWithUncertainty._ext = []
    
    #-----< HorizontalVelocityWithUncertainty-ExtIEs >-----#
    HorizontalVelocityWithUncertainty_ExtIEs = CLASS(name=u'HorizontalVelocityWithUncertainty-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    HorizontalVelocityWithUncertainty_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HorizontalWithVerticalVelocityAndUncertainty >-----#
    HorizontalWithVerticalVelocityAndUncertainty = SEQ(name=u'HorizontalWithVerticalVelocityAndUncertainty', mode=MODE_TYPE)
    _HorizontalWithVerticalVelocityAndUncertainty_horizontalSpeedAndBearing = SEQ(name=u'horizontalSpeedAndBearing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'HorizontalSpeedAndBearing')))
    _HorizontalWithVerticalVelocityAndUncertainty_veritcalVelocity = SEQ(name=u'veritcalVelocity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'VerticalVelocity')))
    _HorizontalWithVerticalVelocityAndUncertainty_horizontalUncertaintySpeed = INT(name=u'horizontalUncertaintySpeed', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalWithVerticalVelocityAndUncertainty_horizontalUncertaintySpeed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _HorizontalWithVerticalVelocityAndUncertainty_verticalUncertaintySpeed = INT(name=u'verticalUncertaintySpeed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalWithVerticalVelocityAndUncertainty_verticalUncertaintySpeed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id._const_tab = ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id_tab
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id._const_tab_at = None
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id._const_tab_id = u'id'
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality._const_tab = ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality_tab
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue._const_tab = ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue_tab
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id),
        (u'criticality', ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality),
        (u'extensionValue', ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue),
        ])
    __HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item_._ext = None
    _HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions._cont = __HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item_
    _HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HorizontalWithVerticalVelocityAndUncertainty._cont = ASN1Dict([
        (u'horizontalSpeedAndBearing', _HorizontalWithVerticalVelocityAndUncertainty_horizontalSpeedAndBearing),
        (u'veritcalVelocity', _HorizontalWithVerticalVelocityAndUncertainty_veritcalVelocity),
        (u'horizontalUncertaintySpeed', _HorizontalWithVerticalVelocityAndUncertainty_horizontalUncertaintySpeed),
        (u'verticalUncertaintySpeed', _HorizontalWithVerticalVelocityAndUncertainty_verticalUncertaintySpeed),
        (u'iE-Extensions', _HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions),
        ])
    HorizontalWithVerticalVelocityAndUncertainty._ext = []
    
    #-----< HorizontalWithVerticalVelocityAndUncertainty-ExtIEs >-----#
    HorizontalWithVerticalVelocityAndUncertainty_ExtIEs = CLASS(name=u'HorizontalWithVerticalVelocityAndUncertainty-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    HorizontalWithVerticalVelocityAndUncertainty_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HorizontalSpeedAndBearing >-----#
    HorizontalSpeedAndBearing = SEQ(name=u'HorizontalSpeedAndBearing', mode=MODE_TYPE)
    _HorizontalSpeedAndBearing_bearing = INT(name=u'bearing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalSpeedAndBearing_bearing._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _HorizontalSpeedAndBearing_horizontalSpeed = INT(name=u'horizontalSpeed', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalSpeedAndBearing_horizontalSpeed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2047)], ev=None, er=[])
    HorizontalSpeedAndBearing._cont = ASN1Dict([
        (u'bearing', _HorizontalSpeedAndBearing_bearing),
        (u'horizontalSpeed', _HorizontalSpeedAndBearing_horizontalSpeed),
        ])
    HorizontalSpeedAndBearing._ext = None
    
    #-----< VerticalVelocity >-----#
    VerticalVelocity = SEQ(name=u'VerticalVelocity', mode=MODE_TYPE)
    _VerticalVelocity_veritcalSpeed = INT(name=u'veritcalSpeed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _VerticalVelocity_veritcalSpeed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _VerticalVelocity_veritcalSpeedDirection = ENUM(name=u'veritcalSpeedDirection', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'VerticalSpeedDirection')))
    VerticalVelocity._cont = ASN1Dict([
        (u'veritcalSpeed', _VerticalVelocity_veritcalSpeed),
        (u'veritcalSpeedDirection', _VerticalVelocity_veritcalSpeedDirection),
        ])
    VerticalVelocity._ext = None
    
    #-----< VerticalSpeedDirection >-----#
    VerticalSpeedDirection = ENUM(name=u'VerticalSpeedDirection', mode=MODE_TYPE)
    VerticalSpeedDirection._cont = ASN1Dict([(u'upward', 0), (u'downward', 1)])
    VerticalSpeedDirection._ext = None
    
    #-----< VerticalAccuracyCode >-----#
    VerticalAccuracyCode = INT(name=u'VerticalAccuracyCode', mode=MODE_TYPE)
    VerticalAccuracyCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< VoiceSupportMatchIndicator >-----#
    VoiceSupportMatchIndicator = ENUM(name=u'VoiceSupportMatchIndicator', mode=MODE_TYPE)
    VoiceSupportMatchIndicator._cont = ASN1Dict([(u'supported', 0), (u'not-supported', 1)])
    VoiceSupportMatchIndicator._ext = []
    
    _all_ = [
        AccuracyFulfilmentIndicator,
        _Additional_CSPS_coordination_information_old_LAI,
        _Additional_CSPS_coordination_information_old_RAC,
        _Additional_CSPS_coordination_information_nRI,
        _Additional_CSPS_coordination_information_uE_is_Attaching,
        ____Additional_CSPS_coordination_information_iE_Extensions__item__id_tab,
        ___Additional_CSPS_coordination_information_iE_Extensions__item__id,
        ____Additional_CSPS_coordination_information_iE_Extensions__item__criticality_tab,
        ___Additional_CSPS_coordination_information_iE_Extensions__item__criticality,
        ____Additional_CSPS_coordination_information_iE_Extensions__item__extensionValue_tab,
        ___Additional_CSPS_coordination_information_iE_Extensions__item__extensionValue,
        __Additional_CSPS_coordination_information_iE_Extensions__item_,
        _Additional_CSPS_coordination_information_iE_Extensions,
        Additional_CSPS_coordination_information,
        Additional_CSPS_coordination_information_ExtIEs,
        _Additional_PositioningDataSet__item_,
        Additional_PositioningDataSet,
        Additional_PositioningMethodAndUsage,
        _AllocationOrRetentionPriority_priorityLevel,
        _AllocationOrRetentionPriority_pre_emptionCapability,
        _AllocationOrRetentionPriority_pre_emptionVulnerability,
        _AllocationOrRetentionPriority_queuingAllowed,
        ____AllocationOrRetentionPriority_iE_Extensions__item__id_tab,
        ___AllocationOrRetentionPriority_iE_Extensions__item__id,
        ____AllocationOrRetentionPriority_iE_Extensions__item__criticality_tab,
        ___AllocationOrRetentionPriority_iE_Extensions__item__criticality,
        ____AllocationOrRetentionPriority_iE_Extensions__item__extensionValue_tab,
        ___AllocationOrRetentionPriority_iE_Extensions__item__extensionValue,
        __AllocationOrRetentionPriority_iE_Extensions__item_,
        _AllocationOrRetentionPriority_iE_Extensions,
        AllocationOrRetentionPriority,
        AllocationOrRetentionPriority_ExtIEs,
        _Alt_RAB_Parameters_altMaxBitrateInf,
        _Alt_RAB_Parameters_altGuaranteedBitRateInf,
        ____Alt_RAB_Parameters_iE_Extensions__item__id_tab,
        _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_0,
        _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_1,
        _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_2,
        _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_3,
        _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_4,
        ___Alt_RAB_Parameters_iE_Extensions__item__id,
        ___Alt_RAB_Parameters_iE_Extensions__item__criticality,
        ___Alt_RAB_Parameters_iE_Extensions__item__extensionValue,
        __Alt_RAB_Parameters_iE_Extensions__item_,
        _Alt_RAB_Parameters_iE_Extensions,
        Alt_RAB_Parameters,
        Alt_RAB_Parameters_ExtIEs,
        _Alt_RAB_Parameters_ExtIEs_val_Extension_0,
        _Alt_RAB_Parameters_ExtIEs_val_Extension_1,
        _Alt_RAB_Parameters_ExtIEs_val_Extension_2,
        _Alt_RAB_Parameters_ExtIEs_val_Extension_3,
        _Alt_RAB_Parameters_ExtIEs_val_Extension_4,
        _Alt_RAB_Parameter_ExtendedGuaranteedBitrateInf_altExtendedGuaranteedBitrateType,
        _Alt_RAB_Parameter_ExtendedGuaranteedBitrateInf_altExtendedGuaranteedBitrates,
        Alt_RAB_Parameter_ExtendedGuaranteedBitrateInf,
        _Alt_RAB_Parameter_ExtendedGuaranteedBitrates__item_,
        Alt_RAB_Parameter_ExtendedGuaranteedBitrates,
        _Alt_RAB_Parameter_ExtendedGuaranteedBitrateList__item_,
        Alt_RAB_Parameter_ExtendedGuaranteedBitrateList,
        _Alt_RAB_Parameter_GuaranteedBitrateInf_altGuaranteedBitrateType,
        _Alt_RAB_Parameter_GuaranteedBitrateInf_altGuaranteedBitrates,
        Alt_RAB_Parameter_GuaranteedBitrateInf,
        Alt_RAB_Parameter_GuaranteedBitrateType,
        _Alt_RAB_Parameter_GuaranteedBitrates__item_,
        Alt_RAB_Parameter_GuaranteedBitrates,
        _Alt_RAB_Parameter_GuaranteedBitrateList__item_,
        Alt_RAB_Parameter_GuaranteedBitrateList,
        _Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_altSupportedGuaranteedBitrateType,
        _Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_altSupportedGuaranteedBitrates,
        ____Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__id_tab,
        ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__id,
        ____Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__criticality_tab,
        ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__criticality,
        ____Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__extensionValue_tab,
        ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__extensionValue,
        __Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item_,
        _Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions,
        Alt_RAB_Parameter_SupportedGuaranteedBitrateInf,
        Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_ExtIEs,
        _Alt_RAB_Parameter_SupportedGuaranteedBitrates__item_,
        Alt_RAB_Parameter_SupportedGuaranteedBitrates,
        _Alt_RAB_Parameter_ExtendedMaxBitrateInf_altExtendedMaxBitrateType,
        _Alt_RAB_Parameter_ExtendedMaxBitrateInf_altExtendedMaxBitrates,
        Alt_RAB_Parameter_ExtendedMaxBitrateInf,
        _Alt_RAB_Parameter_ExtendedMaxBitrates__item_,
        Alt_RAB_Parameter_ExtendedMaxBitrates,
        _Alt_RAB_Parameter_ExtendedMaxBitrateList__item_,
        Alt_RAB_Parameter_ExtendedMaxBitrateList,
        _Alt_RAB_Parameter_MaxBitrateInf_altMaxBitrateType,
        _Alt_RAB_Parameter_MaxBitrateInf_altMaxBitrates,
        Alt_RAB_Parameter_MaxBitrateInf,
        Alt_RAB_Parameter_MaxBitrateType,
        _Alt_RAB_Parameter_MaxBitrates__item_,
        Alt_RAB_Parameter_MaxBitrates,
        _Alt_RAB_Parameter_MaxBitrateList__item_,
        Alt_RAB_Parameter_MaxBitrateList,
        _Alt_RAB_Parameter_SupportedMaxBitrateInf_altSupportedMaxBitrateType,
        _Alt_RAB_Parameter_SupportedMaxBitrateInf_altSupportedMaxBitrates,
        ____Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__id_tab,
        ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__id,
        ____Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__criticality_tab,
        ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__criticality,
        ____Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__extensionValue_tab,
        ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__extensionValue,
        __Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item_,
        _Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions,
        Alt_RAB_Parameter_SupportedMaxBitrateInf,
        Alt_RAB_Parameter_SupportedMaxBitrateInf_ExtIEs,
        _Alt_RAB_Parameter_SupportedMaxBitrates__item_,
        Alt_RAB_Parameter_SupportedMaxBitrates,
        AlternativeRABConfigurationRequest,
        _UE_Application_Layer_Measurement_Configuration_applicationLayerContainerForMeasurementConfiguration,
        _UE_Application_Layer_Measurement_Configuration_areaScopeForUEApplicationLayerMeasurementConfiguration,
        _UE_Application_Layer_Measurement_Configuration_serviceType,
        UE_Application_Layer_Measurement_Configuration,
        _UE_Application_Layer_Measurement_Configuration_For_Relocation_areaScopeForUEApplicationLayerMeasurementConfiguration,
        _UE_Application_Layer_Measurement_Configuration_For_Relocation_traceReference,
        _UE_Application_Layer_Measurement_Configuration_For_Relocation_tracePropagationParameters,
        _UE_Application_Layer_Measurement_Configuration_For_Relocation_traceCollectionEntityIPAddress,
        _UE_Application_Layer_Measurement_Configuration_For_Relocation_serviceType,
        UE_Application_Layer_Measurement_Configuration_For_Relocation,
        ServiceType,
        APN,
        _AreaScopeForUEApplicationLayerMeasurementConfiguration_cellbased,
        _AreaScopeForUEApplicationLayerMeasurementConfiguration_labased,
        _AreaScopeForUEApplicationLayerMeasurementConfiguration_rabased,
        _AreaScopeForUEApplicationLayerMeasurementConfiguration_plmn_area_based,
        AreaScopeForUEApplicationLayerMeasurementConfiguration,
        _AreaIdentity_sAI,
        _AreaIdentity_geographicalArea,
        AreaIdentity,
        _Ass_RAB_Parameters_assMaxBitrateInf,
        _Ass_RAB_Parameters_assGuaranteedBitRateInf,
        ____Ass_RAB_Parameters_iE_Extensions__item__id_tab,
        _____Ass_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_0,
        _____Ass_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_1,
        _____Ass_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_2,
        _____Ass_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_3,
        ___Ass_RAB_Parameters_iE_Extensions__item__id,
        ___Ass_RAB_Parameters_iE_Extensions__item__criticality,
        ___Ass_RAB_Parameters_iE_Extensions__item__extensionValue,
        __Ass_RAB_Parameters_iE_Extensions__item_,
        _Ass_RAB_Parameters_iE_Extensions,
        Ass_RAB_Parameters,
        Ass_RAB_Parameters_ExtIEs,
        _Ass_RAB_Parameters_ExtIEs_val_Extension_0,
        _Ass_RAB_Parameters_ExtIEs_val_Extension_1,
        _Ass_RAB_Parameters_ExtIEs_val_Extension_2,
        _Ass_RAB_Parameters_ExtIEs_val_Extension_3,
        _Ass_RAB_Parameter_ExtendedGuaranteedBitrateList__item_,
        Ass_RAB_Parameter_ExtendedGuaranteedBitrateList,
        _Ass_RAB_Parameter_ExtendedMaxBitrateList__item_,
        Ass_RAB_Parameter_ExtendedMaxBitrateList,
        _Ass_RAB_Parameter_GuaranteedBitrateList__item_,
        Ass_RAB_Parameter_GuaranteedBitrateList,
        _Ass_RAB_Parameter_MaxBitrateList__item_,
        Ass_RAB_Parameter_MaxBitrateList,
        __AuthorisedPLMNs__item__pLMNidentity,
        __AuthorisedPLMNs__item__authorisedSNAsList,
        _____AuthorisedPLMNs__item__iE_Extensions__item__id_tab,
        ____AuthorisedPLMNs__item__iE_Extensions__item__id,
        _____AuthorisedPLMNs__item__iE_Extensions__item__criticality_tab,
        ____AuthorisedPLMNs__item__iE_Extensions__item__criticality,
        _____AuthorisedPLMNs__item__iE_Extensions__item__extensionValue_tab,
        ____AuthorisedPLMNs__item__iE_Extensions__item__extensionValue,
        ___AuthorisedPLMNs__item__iE_Extensions__item_,
        __AuthorisedPLMNs__item__iE_Extensions,
        _AuthorisedPLMNs__item_,
        AuthorisedPLMNs,
        AuthorisedPLMNs_ExtIEs,
        _AuthorisedSNAs__item_,
        AuthorisedSNAs,
        BarometricPressure,
        BindingID,
        _BroadcastAssistanceDataDecipheringKeys_cipheringKeyFlag,
        _BroadcastAssistanceDataDecipheringKeys_currentDecipheringKey,
        _BroadcastAssistanceDataDecipheringKeys_nextDecipheringKey,
        BroadcastAssistanceDataDecipheringKeys,
        _Cause_radioNetwork,
        _Cause_transmissionNetwork,
        _Cause_nAS,
        _Cause_protocol,
        _Cause_misc,
        _Cause_non_Standard,
        _Cause_radioNetworkExtension,
        Cause,
        CauseMisc,
        CauseNAS,
        CauseProtocol,
        CauseRadioNetwork,
        CauseRadioNetworkExtension,
        CauseNon_Standard,
        CauseTransmissionNetwork,
        Cell_Access_Mode,
        _CellBased_cellIdList,
        ____CellBased_iE_Extensions__item__id_tab,
        ___CellBased_iE_Extensions__item__id,
        ____CellBased_iE_Extensions__item__criticality_tab,
        ___CellBased_iE_Extensions__item__criticality,
        ____CellBased_iE_Extensions__item__extensionValue_tab,
        ___CellBased_iE_Extensions__item__extensionValue,
        __CellBased_iE_Extensions__item_,
        _CellBased_iE_Extensions,
        CellBased,
        CellBased_ExtIEs,
        _CellIdList__item_,
        CellIdList,
        Cell_Id,
        Cell_Capacity_Class_Value,
        _CellLoadInformation_cell_Capacity_Class_Value,
        _CellLoadInformation_loadValue,
        _CellLoadInformation_rTLoadValue,
        _CellLoadInformation_nRTLoadInformationValue,
        ____CellLoadInformation_iE_Extensions__item__id_tab,
        ___CellLoadInformation_iE_Extensions__item__id,
        ____CellLoadInformation_iE_Extensions__item__criticality_tab,
        ___CellLoadInformation_iE_Extensions__item__criticality,
        ____CellLoadInformation_iE_Extensions__item__extensionValue_tab,
        ___CellLoadInformation_iE_Extensions__item__extensionValue,
        __CellLoadInformation_iE_Extensions__item_,
        _CellLoadInformation_iE_Extensions,
        CellLoadInformation,
        CellLoadInformation_ExtIEs,
        _CellLoadInformationGroup_sourceCellID,
        _CellLoadInformationGroup_uplinkCellLoadInformation,
        _CellLoadInformationGroup_downlinkCellLoadInformation,
        ____CellLoadInformationGroup_iE_Extensions__item__id_tab,
        ___CellLoadInformationGroup_iE_Extensions__item__id,
        ____CellLoadInformationGroup_iE_Extensions__item__criticality_tab,
        ___CellLoadInformationGroup_iE_Extensions__item__criticality,
        ____CellLoadInformationGroup_iE_Extensions__item__extensionValue_tab,
        ___CellLoadInformationGroup_iE_Extensions__item__extensionValue,
        __CellLoadInformationGroup_iE_Extensions__item_,
        _CellLoadInformationGroup_iE_Extensions,
        CellLoadInformationGroup,
        CellLoadInformationGroup_ExtIEs,
        CellType,
        CivicAddress,
        ClientType,
        _CriticalityDiagnostics_procedureCode,
        _CriticalityDiagnostics_triggeringMessage,
        _CriticalityDiagnostics_procedureCriticality,
        _CriticalityDiagnostics_iEsCriticalityDiagnostics,
        ____CriticalityDiagnostics_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__id,
        ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_iE_Extensions__item_,
        _CriticalityDiagnostics_iE_Extensions,
        CriticalityDiagnostics,
        CriticalityDiagnostics_ExtIEs,
        __CriticalityDiagnostics_IE_List__item__iECriticality,
        __CriticalityDiagnostics_IE_List__item__iE_ID,
        __CriticalityDiagnostics_IE_List__item__repetitionNumber,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab,
        ______CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab_val_Extension_0,
        ______CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab_val_Extension_1,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue,
        ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_,
        __CriticalityDiagnostics_IE_List__item__iE_Extensions,
        _CriticalityDiagnostics_IE_List__item_,
        CriticalityDiagnostics_IE_List,
        CriticalityDiagnostics_IE_List_ExtIEs,
        _CriticalityDiagnostics_IE_List_ExtIEs_val_Extension_0,
        _CriticalityDiagnostics_IE_List_ExtIEs_val_Extension_1,
        __MessageStructure__item__iE_ID,
        __MessageStructure__item__repetitionNumber,
        _____MessageStructure__item__iE_Extensions__item__id_tab,
        ____MessageStructure__item__iE_Extensions__item__id,
        _____MessageStructure__item__iE_Extensions__item__criticality_tab,
        ____MessageStructure__item__iE_Extensions__item__criticality,
        _____MessageStructure__item__iE_Extensions__item__extensionValue_tab,
        ____MessageStructure__item__iE_Extensions__item__extensionValue,
        ___MessageStructure__item__iE_Extensions__item_,
        __MessageStructure__item__iE_Extensions,
        _MessageStructure__item_,
        MessageStructure,
        MessageStructure_ExtIEs,
        _CGI_pLMNidentity,
        _CGI_lAC,
        _CGI_cI,
        ____CGI_iE_Extensions__item__id_tab,
        _____CGI_iE_Extensions__item__id_tab_val_Extension_0,
        ___CGI_iE_Extensions__item__id,
        ___CGI_iE_Extensions__item__criticality,
        ___CGI_iE_Extensions__item__extensionValue,
        __CGI_iE_Extensions__item_,
        _CGI_iE_Extensions,
        CGI,
        CGI_ExtIEs,
        _CGI_ExtIEs_val_Extension_0,
        ChosenEncryptionAlgorithm,
        ChosenIntegrityProtectionAlgorithm,
        CI,
        ClassmarkInformation2,
        ClassmarkInformation3,
        CN_DomainIndicator,
        CN_ID,
        Correlation_ID,
        CSFB_Information,
        CSG_Id,
        _CSG_Id_List__item_,
        CSG_Id_List,
        CSG_Membership_Status,
        DataPDUType,
        DataVolumeReference,
        DataVolumeReportingIndication,
        DCH_ID,
        DCN_ID,
        DeliveryOfErroneousSDU,
        DeliveryOrder,
        _DeltaRAListofIdleModeUEs_newRAListofIdleModeUEs,
        _DeltaRAListofIdleModeUEs_rAListwithNoIdleModeUEsAnyMore,
        ____DeltaRAListofIdleModeUEs_iE_Extensions__item__id_tab,
        _____DeltaRAListofIdleModeUEs_iE_Extensions__item__id_tab_val_Extension_0,
        _____DeltaRAListofIdleModeUEs_iE_Extensions__item__id_tab_val_Extension_1,
        ___DeltaRAListofIdleModeUEs_iE_Extensions__item__id,
        ___DeltaRAListofIdleModeUEs_iE_Extensions__item__criticality,
        ___DeltaRAListofIdleModeUEs_iE_Extensions__item__extensionValue,
        __DeltaRAListofIdleModeUEs_iE_Extensions__item_,
        _DeltaRAListofIdleModeUEs_iE_Extensions,
        DeltaRAListofIdleModeUEs,
        _NewRAListofIdleModeUEs__item_,
        NewRAListofIdleModeUEs,
        _RAListwithNoIdleModeUEsAnyMore__item_,
        RAListwithNoIdleModeUEsAnyMore,
        DeltaRAListofIdleModeUEs_ExtIEs,
        _DeltaRAListofIdleModeUEs_ExtIEs_val_Extension_0,
        _DeltaRAListofIdleModeUEs_ExtIEs_val_Extension_1,
        ForwardingIndication,
        DL_GTP_PDU_SequenceNumber,
        DL_N_PDU_SequenceNumber,
        D_RNTI,
        DRX_CycleLengthCoefficient,
        DSCH_ID,
        EARFCN_Extended,
        E_DCH_MAC_d_Flow_ID,
        _ENB_ID_macroENB_ID,
        _ENB_ID_homeENB_ID,
        _ENB_ID_short_macroENB_ID,
        _ENB_ID_long_macroENB_ID,
        ENB_ID,
        EncryptionAlgorithm,
        _EncryptionInformation_permittedAlgorithms,
        _EncryptionInformation_key,
        ____EncryptionInformation_iE_Extensions__item__id_tab,
        ___EncryptionInformation_iE_Extensions__item__id,
        ____EncryptionInformation_iE_Extensions__item__criticality_tab,
        ___EncryptionInformation_iE_Extensions__item__criticality,
        ____EncryptionInformation_iE_Extensions__item__extensionValue_tab,
        ___EncryptionInformation_iE_Extensions__item__extensionValue,
        __EncryptionInformation_iE_Extensions__item_,
        _EncryptionInformation_iE_Extensions,
        EncryptionInformation,
        EncryptionInformation_ExtIEs,
        EncryptionKey,
        End_Of_CSFB,
        _EquipmentsToBeTraced_iMEIlist,
        _EquipmentsToBeTraced_iMEISVlist,
        _EquipmentsToBeTraced_iMEIgroup,
        _EquipmentsToBeTraced_iMEISVgroup,
        EquipmentsToBeTraced,
        E_UTRAN_Service_Handover,
        Event,
        _Event1F_Parameters_measurementQuantity,
        _Event1F_Parameters_threshold,
        Event1F_Parameters,
        _Event1I_Parameters_threshold,
        Event1I_Parameters,
        ExtendedGuaranteedBitrate,
        ExtendedMaxBitrate,
        ExtendedRNC_ID,
        FrameSequenceNumber,
        FrequenceLayerConvergenceFlag,
        _GANSS_PositioningDataSet__item_,
        GANSS_PositioningDataSet,
        GANSS_PositioningMethodAndUsage,
        _GeographicalArea_point,
        _GeographicalArea_pointWithUnCertainty,
        _GeographicalArea_polygon,
        _GeographicalArea_pointWithUncertaintyEllipse,
        _GeographicalArea_pointWithAltitude,
        _GeographicalArea_pointWithAltitudeAndUncertaintyEllipsoid,
        _GeographicalArea_ellipsoidArc,
        GeographicalArea,
        _GeographicalCoordinates_latitudeSign,
        _GeographicalCoordinates_latitude,
        _GeographicalCoordinates_longitude,
        ____GeographicalCoordinates_iE_Extensions__item__id_tab,
        ___GeographicalCoordinates_iE_Extensions__item__id,
        ____GeographicalCoordinates_iE_Extensions__item__criticality_tab,
        ___GeographicalCoordinates_iE_Extensions__item__criticality,
        ____GeographicalCoordinates_iE_Extensions__item__extensionValue_tab,
        ___GeographicalCoordinates_iE_Extensions__item__extensionValue,
        __GeographicalCoordinates_iE_Extensions__item_,
        _GeographicalCoordinates_iE_Extensions,
        GeographicalCoordinates,
        GeographicalCoordinates_ExtIEs,
        _GA_AltitudeAndDirection_directionOfAltitude,
        _GA_AltitudeAndDirection_altitude,
        GA_AltitudeAndDirection,
        _GA_EllipsoidArc_geographicalCoordinates,
        _GA_EllipsoidArc_innerRadius,
        _GA_EllipsoidArc_uncertaintyRadius,
        _GA_EllipsoidArc_offsetAngle,
        _GA_EllipsoidArc_includedAngle,
        _GA_EllipsoidArc_confidence,
        ____GA_EllipsoidArc_iE_Extensions__item__id_tab,
        ___GA_EllipsoidArc_iE_Extensions__item__id,
        ____GA_EllipsoidArc_iE_Extensions__item__criticality_tab,
        ___GA_EllipsoidArc_iE_Extensions__item__criticality,
        ____GA_EllipsoidArc_iE_Extensions__item__extensionValue_tab,
        ___GA_EllipsoidArc_iE_Extensions__item__extensionValue,
        __GA_EllipsoidArc_iE_Extensions__item_,
        _GA_EllipsoidArc_iE_Extensions,
        GA_EllipsoidArc,
        GA_EllipsoidArc_ExtIEs,
        _GA_Point_geographicalCoordinates,
        ____GA_Point_iE_Extensions__item__id_tab,
        ___GA_Point_iE_Extensions__item__id,
        ____GA_Point_iE_Extensions__item__criticality_tab,
        ___GA_Point_iE_Extensions__item__criticality,
        ____GA_Point_iE_Extensions__item__extensionValue_tab,
        ___GA_Point_iE_Extensions__item__extensionValue,
        __GA_Point_iE_Extensions__item_,
        _GA_Point_iE_Extensions,
        GA_Point,
        GA_Point_ExtIEs,
        _GA_PointWithAltitude_geographicalCoordinates,
        _GA_PointWithAltitude_altitudeAndDirection,
        ____GA_PointWithAltitude_iE_Extensions__item__id_tab,
        ___GA_PointWithAltitude_iE_Extensions__item__id,
        ____GA_PointWithAltitude_iE_Extensions__item__criticality_tab,
        ___GA_PointWithAltitude_iE_Extensions__item__criticality,
        ____GA_PointWithAltitude_iE_Extensions__item__extensionValue_tab,
        ___GA_PointWithAltitude_iE_Extensions__item__extensionValue,
        __GA_PointWithAltitude_iE_Extensions__item_,
        _GA_PointWithAltitude_iE_Extensions,
        GA_PointWithAltitude,
        GA_PointWithAltitude_ExtIEs,
        _GA_PointWithAltitudeAndUncertaintyEllipsoid_geographicalCoordinates,
        _GA_PointWithAltitudeAndUncertaintyEllipsoid_altitudeAndDirection,
        _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyEllipse,
        _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyAltitude,
        _GA_PointWithAltitudeAndUncertaintyEllipsoid_confidence,
        ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id_tab,
        ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id,
        ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality_tab,
        ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality,
        ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue_tab,
        ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue,
        __GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item_,
        _GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions,
        GA_PointWithAltitudeAndUncertaintyEllipsoid,
        GA_PointWithAltitudeAndUncertaintyEllipsoid_ExtIEs,
        _GA_PointWithUnCertainty_geographicalCoordinates,
        ____GA_PointWithUnCertainty_iE_Extensions__item__id_tab,
        ___GA_PointWithUnCertainty_iE_Extensions__item__id,
        ____GA_PointWithUnCertainty_iE_Extensions__item__criticality_tab,
        ___GA_PointWithUnCertainty_iE_Extensions__item__criticality,
        ____GA_PointWithUnCertainty_iE_Extensions__item__extensionValue_tab,
        ___GA_PointWithUnCertainty_iE_Extensions__item__extensionValue,
        __GA_PointWithUnCertainty_iE_Extensions__item_,
        _GA_PointWithUnCertainty_iE_Extensions,
        _GA_PointWithUnCertainty_uncertaintyCode,
        GA_PointWithUnCertainty,
        GA_PointWithUnCertainty_ExtIEs,
        _GA_PointWithUnCertaintyEllipse_geographicalCoordinates,
        _GA_PointWithUnCertaintyEllipse_uncertaintyEllipse,
        _GA_PointWithUnCertaintyEllipse_confidence,
        ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id_tab,
        ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id,
        ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality_tab,
        ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality,
        ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue_tab,
        ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue,
        __GA_PointWithUnCertaintyEllipse_iE_Extensions__item_,
        _GA_PointWithUnCertaintyEllipse_iE_Extensions,
        GA_PointWithUnCertaintyEllipse,
        GA_PointWithUnCertaintyEllipse_ExtIEs,
        __GA_Polygon__item__geographicalCoordinates,
        _____GA_Polygon__item__iE_Extensions__item__id_tab,
        ____GA_Polygon__item__iE_Extensions__item__id,
        _____GA_Polygon__item__iE_Extensions__item__criticality_tab,
        ____GA_Polygon__item__iE_Extensions__item__criticality,
        _____GA_Polygon__item__iE_Extensions__item__extensionValue_tab,
        ____GA_Polygon__item__iE_Extensions__item__extensionValue,
        ___GA_Polygon__item__iE_Extensions__item_,
        __GA_Polygon__item__iE_Extensions,
        _GA_Polygon__item_,
        GA_Polygon,
        GA_Polygon_ExtIEs,
        _GA_UncertaintyEllipse_uncertaintySemi_major,
        _GA_UncertaintyEllipse_uncertaintySemi_minor,
        _GA_UncertaintyEllipse_orientationOfMajorAxis,
        GA_UncertaintyEllipse,
        GERAN_BSC_Container,
        _GERAN_Cell_ID_lAI,
        _GERAN_Cell_ID_rAC,
        _GERAN_Cell_ID_cI,
        ____GERAN_Cell_ID_iE_Extensions__item__id_tab,
        ___GERAN_Cell_ID_iE_Extensions__item__id,
        ____GERAN_Cell_ID_iE_Extensions__item__criticality_tab,
        ___GERAN_Cell_ID_iE_Extensions__item__criticality,
        ____GERAN_Cell_ID_iE_Extensions__item__extensionValue_tab,
        ___GERAN_Cell_ID_iE_Extensions__item__extensionValue,
        __GERAN_Cell_ID_iE_Extensions__item_,
        _GERAN_Cell_ID_iE_Extensions,
        GERAN_Cell_ID,
        GERAN_Cell_ID_ExtIEs,
        GERAN_Classmark,
        _GlobalCN_ID_pLMNidentity,
        _GlobalCN_ID_cN_ID,
        GlobalCN_ID,
        _GlobalRNC_ID_pLMNidentity,
        _GlobalRNC_ID_rNC_ID,
        GlobalRNC_ID,
        GTP_TEI,
        GuaranteedBitrate,
        HigherBitratesThan16MbpsFlag,
        HS_DSCH_MAC_d_Flow_ID,
        IMEI,
        _IMEIGroup_iMEI,
        _IMEIGroup_iMEIMask,
        ____IMEIGroup_iE_Extensions__item__id_tab,
        ___IMEIGroup_iE_Extensions__item__id,
        ____IMEIGroup_iE_Extensions__item__criticality_tab,
        ___IMEIGroup_iE_Extensions__item__criticality,
        ____IMEIGroup_iE_Extensions__item__extensionValue_tab,
        ___IMEIGroup_iE_Extensions__item__extensionValue,
        __IMEIGroup_iE_Extensions__item_,
        _IMEIGroup_iE_Extensions,
        IMEIGroup,
        IMEIGroup_ExtIEs,
        _IMEIList__item_,
        IMEIList,
        IMEISV,
        _IMEISVGroup_iMEISV,
        _IMEISVGroup_iMEISVMask,
        ____IMEISVGroup_iE_Extensions__item__id_tab,
        ___IMEISVGroup_iE_Extensions__item__id,
        ____IMEISVGroup_iE_Extensions__item__criticality_tab,
        ___IMEISVGroup_iE_Extensions__item__criticality,
        ____IMEISVGroup_iE_Extensions__item__extensionValue_tab,
        ___IMEISVGroup_iE_Extensions__item__extensionValue,
        __IMEISVGroup_iE_Extensions__item_,
        _IMEISVGroup_iE_Extensions,
        IMEISVGroup,
        IMEISVGroup_ExtIEs,
        _IMEISVList__item_,
        IMEISVList,
        _ImmediateMDT_measurementsToActivate,
        _ImmediateMDT_m1report,
        _ImmediateMDT_m2report,
        ____ImmediateMDT_iE_Extensions__item__id_tab,
        _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_0,
        _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_1,
        _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_2,
        _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_3,
        ___ImmediateMDT_iE_Extensions__item__id,
        ___ImmediateMDT_iE_Extensions__item__criticality,
        ___ImmediateMDT_iE_Extensions__item__extensionValue,
        __ImmediateMDT_iE_Extensions__item_,
        _ImmediateMDT_iE_Extensions,
        ImmediateMDT,
        ImmediateMDT_ExtIEs,
        _ImmediateMDT_ExtIEs_val_Extension_0,
        _ImmediateMDT_ExtIEs_val_Extension_1,
        _ImmediateMDT_ExtIEs_val_Extension_2,
        _ImmediateMDT_ExtIEs_val_Extension_3,
        IMSI,
        IncludeVelocity,
        InformationExchangeID,
        InformationExchangeType,
        _InformationRequested_requestedMBMSIPMulticastAddressandAPNRequest,
        _InformationRequested_requestedMulticastServiceList,
        InformationRequested,
        _InformationRequestType_mBMSIPMulticastAddressandAPNRequest,
        _InformationRequestType_permanentNAS_UE_ID,
        InformationRequestType,
        InformationTransferID,
        _InformationTransferType_rNCTraceInformation,
        InformationTransferType,
        IntegrityProtectionAlgorithm,
        _IntegrityProtectionInformation_permittedAlgorithms,
        _IntegrityProtectionInformation_key,
        ____IntegrityProtectionInformation_iE_Extensions__item__id_tab,
        ___IntegrityProtectionInformation_iE_Extensions__item__id,
        ____IntegrityProtectionInformation_iE_Extensions__item__criticality_tab,
        ___IntegrityProtectionInformation_iE_Extensions__item__criticality,
        ____IntegrityProtectionInformation_iE_Extensions__item__extensionValue_tab,
        ___IntegrityProtectionInformation_iE_Extensions__item__extensionValue,
        __IntegrityProtectionInformation_iE_Extensions__item_,
        _IntegrityProtectionInformation_iE_Extensions,
        IntegrityProtectionInformation,
        IntegrityProtectionInformation_ExtIEs,
        IntegrityProtectionKey,
        _InterSystemInformationTransferType_rIM_Transfer,
        InterSystemInformationTransferType,
        _InterSystemInformation_TransparentContainer_downlinkCellLoadInformation,
        _InterSystemInformation_TransparentContainer_uplinkCellLoadInformation,
        ____InterSystemInformation_TransparentContainer_iE_Extensions__item__id_tab,
        ___InterSystemInformation_TransparentContainer_iE_Extensions__item__id,
        ____InterSystemInformation_TransparentContainer_iE_Extensions__item__criticality_tab,
        ___InterSystemInformation_TransparentContainer_iE_Extensions__item__criticality,
        ____InterSystemInformation_TransparentContainer_iE_Extensions__item__extensionValue_tab,
        ___InterSystemInformation_TransparentContainer_iE_Extensions__item__extensionValue,
        __InterSystemInformation_TransparentContainer_iE_Extensions__item_,
        _InterSystemInformation_TransparentContainer_iE_Extensions,
        InterSystemInformation_TransparentContainer,
        InterSystemInformation_TransparentContainer_ExtIEs,
        IPMulticastAddress,
        IuSignallingConnectionIdentifier,
        _IuTransportAssociation_gTP_TEI,
        _IuTransportAssociation_bindingID,
        IuTransportAssociation,
        KeyStatus,
        __LA_LIST__item__lAC,
        __LA_LIST__item__listOF_SNAs,
        _____LA_LIST__item__iE_Extensions__item__id_tab,
        ____LA_LIST__item__iE_Extensions__item__id,
        _____LA_LIST__item__iE_Extensions__item__criticality_tab,
        ____LA_LIST__item__iE_Extensions__item__criticality,
        _____LA_LIST__item__iE_Extensions__item__extensionValue_tab,
        ____LA_LIST__item__iE_Extensions__item__extensionValue,
        ___LA_LIST__item__iE_Extensions__item_,
        __LA_LIST__item__iE_Extensions,
        _LA_LIST__item_,
        LA_LIST,
        LA_LIST_ExtIEs,
        LAC,
        _LAI_pLMNidentity,
        _LAI_lAC,
        ____LAI_iE_Extensions__item__id_tab,
        ___LAI_iE_Extensions__item__id,
        ____LAI_iE_Extensions__item__criticality_tab,
        ___LAI_iE_Extensions__item__criticality,
        ____LAI_iE_Extensions__item__extensionValue_tab,
        ___LAI_iE_Extensions__item__extensionValue,
        __LAI_iE_Extensions__item_,
        _LAI_iE_Extensions,
        LAI,
        LAI_ExtIEs,
        _LastKnownServiceArea_sAI,
        _LastKnownServiceArea_ageOfSAI,
        ____LastKnownServiceArea_iE_Extensions__item__id_tab,
        ___LastKnownServiceArea_iE_Extensions__item__id,
        ____LastKnownServiceArea_iE_Extensions__item__criticality_tab,
        ___LastKnownServiceArea_iE_Extensions__item__criticality,
        ____LastKnownServiceArea_iE_Extensions__item__extensionValue_tab,
        ___LastKnownServiceArea_iE_Extensions__item__extensionValue,
        __LastKnownServiceArea_iE_Extensions__item_,
        _LastKnownServiceArea_iE_Extensions,
        LastKnownServiceArea,
        LastKnownServiceArea_ExtIEs,
        _LastVisitedUTRANCell_Item_uTRAN_CellID,
        _LastVisitedUTRANCell_Item_cellType,
        _LastVisitedUTRANCell_Item_time_UE_StayedInCell,
        ____LastVisitedUTRANCell_Item_iE_Extensions__item__id_tab,
        _____LastVisitedUTRANCell_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____LastVisitedUTRANCell_Item_iE_Extensions__item__id_tab_val_Extension_1,
        ___LastVisitedUTRANCell_Item_iE_Extensions__item__id,
        ___LastVisitedUTRANCell_Item_iE_Extensions__item__criticality,
        ___LastVisitedUTRANCell_Item_iE_Extensions__item__extensionValue,
        __LastVisitedUTRANCell_Item_iE_Extensions__item_,
        _LastVisitedUTRANCell_Item_iE_Extensions,
        LastVisitedUTRANCell_Item,
        LastVisitedUTRANCell_Item_ExtIEs,
        _LastVisitedUTRANCell_Item_ExtIEs_val_Extension_0,
        _LastVisitedUTRANCell_Item_ExtIEs_val_Extension_1,
        LHN_ID,
        Links_to_log,
        _ListOF_SNAs__item_,
        ListOF_SNAs,
        _ListOfInterfacesToTrace__item_,
        ListOfInterfacesToTrace,
        _InterfacesToTraceItem_interface,
        ____InterfacesToTraceItem_iE_Extensions__item__id_tab,
        ___InterfacesToTraceItem_iE_Extensions__item__id,
        ____InterfacesToTraceItem_iE_Extensions__item__criticality_tab,
        ___InterfacesToTraceItem_iE_Extensions__item__criticality,
        ____InterfacesToTraceItem_iE_Extensions__item__extensionValue_tab,
        ___InterfacesToTraceItem_iE_Extensions__item__extensionValue,
        __InterfacesToTraceItem_iE_Extensions__item_,
        _InterfacesToTraceItem_iE_Extensions,
        InterfacesToTraceItem,
        InterfacesToTraceItem_ExtIEs,
        LoadValue,
        _LocationRelatedDataRequestType_requestedLocationRelatedDataType,
        _LocationRelatedDataRequestType_requestedGPSAssistanceData,
        LocationRelatedDataRequestType,
        LocationRelatedDataRequestTypeSpecificToGERANIuMode,
        _LocationReportingTransferInformation_reportChangeOfSAI,
        _LocationReportingTransferInformation_periodicReportingIndicator,
        _LocationReportingTransferInformation_directReportingIndicator,
        _LocationReportingTransferInformation_verticalAccuracyCode,
        _LocationReportingTransferInformation_positioningPriorityChangeSAI,
        _LocationReportingTransferInformation_positioningPriorityDirect,
        _LocationReportingTransferInformation_clientTypePeriodic,
        _LocationReportingTransferInformation_clientTypeDirect,
        _LocationReportingTransferInformation_responseTime,
        _LocationReportingTransferInformation_includeVelocity,
        _LocationReportingTransferInformation_periodicLocationInfo,
        ____LocationReportingTransferInformation_iE_Extensions__item__id_tab,
        ___LocationReportingTransferInformation_iE_Extensions__item__id,
        ____LocationReportingTransferInformation_iE_Extensions__item__criticality_tab,
        ___LocationReportingTransferInformation_iE_Extensions__item__criticality,
        ____LocationReportingTransferInformation_iE_Extensions__item__extensionValue_tab,
        ___LocationReportingTransferInformation_iE_Extensions__item__extensionValue,
        __LocationReportingTransferInformation_iE_Extensions__item_,
        _LocationReportingTransferInformation_iE_Extensions,
        LocationReportingTransferInformation,
        LocationReportingTransferInformation_ExtIEs,
        ReportChangeOfSAI,
        PeriodicReportingIndicator,
        DirectReportingIndicator,
        L3_Information,
        _M1Report_periodic,
        _M1Report_event1F,
        M1Report,
        _M2Report_periodic,
        _M2Report_event1I,
        M2Report,
        _M4Report_all,
        _M4Report_m4_collection_parameters,
        M4Report,
        _M4_Collection_Parameters_m4_period,
        _M4_Collection_Parameters_m4_threshold,
        ____M4_Collection_Parameters_iE_Extensions__item__id_tab,
        ___M4_Collection_Parameters_iE_Extensions__item__id,
        ____M4_Collection_Parameters_iE_Extensions__item__criticality_tab,
        ___M4_Collection_Parameters_iE_Extensions__item__criticality,
        ____M4_Collection_Parameters_iE_Extensions__item__extensionValue_tab,
        ___M4_Collection_Parameters_iE_Extensions__item__extensionValue,
        __M4_Collection_Parameters_iE_Extensions__item_,
        _M4_Collection_Parameters_iE_Extensions,
        M4_Collection_Parameters,
        M4_Collection_Parameters_ExtIEs,
        M4_Period,
        M4_Threshold,
        _M5Report_when_available,
        _M5Report_m5_period,
        M5Report,
        M5_Period,
        _M6Report_m6_period,
        _M6Report_m6_links_to_log,
        ____M6Report_iE_Extensions__item__id_tab,
        ___M6Report_iE_Extensions__item__id,
        ____M6Report_iE_Extensions__item__criticality_tab,
        ___M6Report_iE_Extensions__item__criticality,
        ____M6Report_iE_Extensions__item__extensionValue_tab,
        ___M6Report_iE_Extensions__item__extensionValue,
        __M6Report_iE_Extensions__item_,
        _M6Report_iE_Extensions,
        M6Report,
        M6Report_ExtIEs,
        M6_Period,
        _M7Report_m7_period,
        _M7Report_m7_links_to_log,
        ____M7Report_iE_Extensions__item__id_tab,
        ___M7Report_iE_Extensions__item__id,
        ____M7Report_iE_Extensions__item__criticality_tab,
        ___M7Report_iE_Extensions__item__criticality,
        ____M7Report_iE_Extensions__item__extensionValue_tab,
        ___M7Report_iE_Extensions__item__extensionValue,
        __M7Report_iE_Extensions__item_,
        _M7Report_iE_Extensions,
        M7Report,
        M7Report_ExtIEs,
        M7_Period,
        Management_Based_MDT_Allowed,
        MaxBitrate,
        MaxSDU_Size,
        MBMS_PTP_RAB_ID,
        MBMSBearerServiceType,
        MBMSCNDe_Registration,
        MBMSCountingInformation,
        MBMSHCIndicator,
        _MBMSIPMulticastAddressandAPNRequest__item_,
        MBMSIPMulticastAddressandAPNRequest,
        MBMSLinkingInformation,
        MBMSRegistrationRequestType,
        MBMSServiceArea,
        MBMSSessionDuration,
        MBMSSessionIdentity,
        MBMSSessionRepetitionNumber,
        MDT_Activation,
        _MDTAreaScope_cellbased,
        _MDTAreaScope_labased,
        _MDTAreaScope_rabased,
        _MDTAreaScope_plmn_area_based,
        MDTAreaScope,
        _MDT_Configuration_mdtActivation,
        _MDT_Configuration_mdtAreaScope,
        _MDT_Configuration_mdtMode,
        ____MDT_Configuration_iE_Extensions__item__id_tab,
        _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_0,
        ___MDT_Configuration_iE_Extensions__item__id,
        ___MDT_Configuration_iE_Extensions__item__criticality,
        ___MDT_Configuration_iE_Extensions__item__extensionValue,
        __MDT_Configuration_iE_Extensions__item_,
        _MDT_Configuration_iE_Extensions,
        MDT_Configuration,
        MDT_Configuration_ExtIEs,
        _MDT_Configuration_ExtIEs_val_Extension_0,
        _MDTMode_immediateMDT,
        _MDTMode_loggedMDT,
        MDTMode,
        _MDT_PLMN_List__item_,
        MDT_PLMN_List,
        _MDT_Report_Parameters_reportInterval,
        _MDT_Report_Parameters_reportAmount,
        MDT_Report_Parameters,
        MeasurementQuantity,
        MeasurementsToActivate,
        MSISDN,
        NAS_PDU,
        NAS_SequenceNumber,
        NAS_SynchronisationIndicator,
        NewBSS_To_OldBSS_Information,
        NonSearchingIndication,
        NRTLoadInformationValue,
        Null_NRI,
        NumberOfIuInstances,
        NumberOfSteps,
        _Offload_RAB_Parameters_accessPointName,
        _Offload_RAB_Parameters_chargingCharacteristics,
        ____Offload_RAB_Parameters_iE_Extensions__item__id_tab,
        ___Offload_RAB_Parameters_iE_Extensions__item__id,
        ____Offload_RAB_Parameters_iE_Extensions__item__criticality_tab,
        ___Offload_RAB_Parameters_iE_Extensions__item__criticality,
        ____Offload_RAB_Parameters_iE_Extensions__item__extensionValue_tab,
        ___Offload_RAB_Parameters_iE_Extensions__item__extensionValue,
        __Offload_RAB_Parameters_iE_Extensions__item_,
        _Offload_RAB_Parameters_iE_Extensions,
        Offload_RAB_Parameters,
        Offload_RAB_Parameters_ExtIEs,
        Offload_RAB_Parameters_APN,
        Offload_RAB_Parameters_ChargingCharacteristics,
        OldBSS_ToNewBSS_Information,
        OMC_ID,
        Out_Of_UTRAN,
        _PagingAreaID_lAI,
        _PagingAreaID_rAI,
        PagingAreaID,
        PagingCause,
        _PDP_TypeInformation__item_,
        PDP_TypeInformation,
        PDP_Type,
        _PDP_TypeInformation_extension__item_,
        PDP_TypeInformation_extension,
        PDP_Type_extension,
        PDUType14FrameSequenceNumber,
        _PeriodicLocationInfo_reportingAmount,
        _PeriodicLocationInfo_reportingInterval,
        ____PeriodicLocationInfo_iE_Extensions__item__id_tab,
        ___PeriodicLocationInfo_iE_Extensions__item__id,
        ____PeriodicLocationInfo_iE_Extensions__item__criticality_tab,
        ___PeriodicLocationInfo_iE_Extensions__item__criticality,
        ____PeriodicLocationInfo_iE_Extensions__item__extensionValue_tab,
        ___PeriodicLocationInfo_iE_Extensions__item__extensionValue,
        __PeriodicLocationInfo_iE_Extensions__item_,
        _PeriodicLocationInfo_iE_Extensions,
        PeriodicLocationInfo,
        PeriodicLocationInfo_ExtIEs,
        _PermanentNAS_UE_ID_iMSI,
        PermanentNAS_UE_ID,
        _PermittedEncryptionAlgorithms__item_,
        PermittedEncryptionAlgorithms,
        _PermittedIntegrityProtectionAlgorithms__item_,
        PermittedIntegrityProtectionAlgorithms,
        _LABased_laiList,
        ____LABased_iE_Extensions__item__id_tab,
        ___LABased_iE_Extensions__item__id,
        ____LABased_iE_Extensions__item__criticality_tab,
        ___LABased_iE_Extensions__item__criticality,
        ____LABased_iE_Extensions__item__extensionValue_tab,
        ___LABased_iE_Extensions__item__extensionValue,
        __LABased_iE_Extensions__item_,
        _LABased_iE_Extensions,
        LABased,
        LABased_ExtIEs,
        _LAI_List__item_,
        LAI_List,
        _LoggedMDT_loggingInterval,
        _LoggedMDT_loggingDuration,
        ____LoggedMDT_iE_Extensions__item__id_tab,
        ___LoggedMDT_iE_Extensions__item__id,
        ____LoggedMDT_iE_Extensions__item__criticality_tab,
        ___LoggedMDT_iE_Extensions__item__criticality,
        ____LoggedMDT_iE_Extensions__item__extensionValue_tab,
        ___LoggedMDT_iE_Extensions__item__extensionValue,
        __LoggedMDT_iE_Extensions__item_,
        _LoggedMDT_iE_Extensions,
        LoggedMDT,
        LoggedMDT_ExtIEs,
        LoggingInterval,
        LoggingDuration,
        _PLMNBased_plmnList,
        ____PLMNBased_iE_Extensions__item__id_tab,
        ___PLMNBased_iE_Extensions__item__id,
        ____PLMNBased_iE_Extensions__item__criticality_tab,
        ___PLMNBased_iE_Extensions__item__criticality,
        ____PLMNBased_iE_Extensions__item__extensionValue_tab,
        ___PLMNBased_iE_Extensions__item__extensionValue,
        __PLMNBased_iE_Extensions__item_,
        _PLMNBased_iE_Extensions,
        PLMNBased,
        PLMNBased_ExtIEs,
        _PLMNList__item_,
        PLMNList,
        PLMNidentity,
        __PLMNs_in_shared_network__item__pLMNidentity,
        __PLMNs_in_shared_network__item__lA_LIST,
        _____PLMNs_in_shared_network__item__iE_Extensions__item__id_tab,
        ____PLMNs_in_shared_network__item__iE_Extensions__item__id,
        _____PLMNs_in_shared_network__item__iE_Extensions__item__criticality_tab,
        ____PLMNs_in_shared_network__item__iE_Extensions__item__criticality,
        _____PLMNs_in_shared_network__item__iE_Extensions__item__extensionValue_tab,
        ____PLMNs_in_shared_network__item__iE_Extensions__item__extensionValue,
        ___PLMNs_in_shared_network__item__iE_Extensions__item_,
        __PLMNs_in_shared_network__item__iE_Extensions,
        _PLMNs_in_shared_network__item_,
        PLMNs_in_shared_network,
        PLMNs_in_shared_network_ExtIEs,
        Port_Number,
        PositioningDataDiscriminator,
        _PositioningDataSet__item_,
        PositioningDataSet,
        PositioningMethodAndUsage,
        PositioningPriority,
        _PositionData_positioningDataDiscriminator,
        _PositionData_positioningDataSet,
        ____PositionData_iE_Extensions__item__id_tab,
        _____PositionData_iE_Extensions__item__id_tab_val_Extension_0,
        _____PositionData_iE_Extensions__item__id_tab_val_Extension_1,
        ___PositionData_iE_Extensions__item__id,
        ___PositionData_iE_Extensions__item__criticality,
        ___PositionData_iE_Extensions__item__extensionValue,
        __PositionData_iE_Extensions__item_,
        _PositionData_iE_Extensions,
        PositionData,
        PositionData_ExtIEs,
        _PositionData_ExtIEs_val_Extension_0,
        _PositionData_ExtIEs_val_Extension_1,
        PositionDataSpecificToGERANIuMode,
        Pre_emptionCapability,
        Pre_emptionVulnerability,
        PriorityLevel,
        Priority_Class_Indicator,
        _ProvidedData_shared_network_information,
        ProvidedData,
        PowerSavingIndicator,
        P_TMSI,
        QueuingAllowed,
        RAB_AsymmetryIndicator,
        _RABased_raiList,
        ____RABased_iE_Extensions__item__id_tab,
        ___RABased_iE_Extensions__item__id,
        ____RABased_iE_Extensions__item__criticality_tab,
        ___RABased_iE_Extensions__item__criticality,
        ____RABased_iE_Extensions__item__extensionValue_tab,
        ___RABased_iE_Extensions__item__extensionValue,
        __RABased_iE_Extensions__item_,
        _RABased_iE_Extensions,
        RABased,
        RABased_ExtIEs,
        _RAI_List__item_,
        RAI_List,
        __RABDataVolumeReport__item__dl_UnsuccessfullyTransmittedDataVolume,
        __RABDataVolumeReport__item__dataVolumeReference,
        _____RABDataVolumeReport__item__iE_Extensions__item__id_tab,
        ____RABDataVolumeReport__item__iE_Extensions__item__id,
        _____RABDataVolumeReport__item__iE_Extensions__item__criticality_tab,
        ____RABDataVolumeReport__item__iE_Extensions__item__criticality,
        _____RABDataVolumeReport__item__iE_Extensions__item__extensionValue_tab,
        ____RABDataVolumeReport__item__iE_Extensions__item__extensionValue,
        ___RABDataVolumeReport__item__iE_Extensions__item_,
        __RABDataVolumeReport__item__iE_Extensions,
        _RABDataVolumeReport__item_,
        RABDataVolumeReport,
        RABDataVolumeReport_ExtIEs,
        RAB_ID,
        _RAB_Parameter_ExtendedGuaranteedBitrateList__item_,
        RAB_Parameter_ExtendedGuaranteedBitrateList,
        _RAB_Parameter_ExtendedMaxBitrateList__item_,
        RAB_Parameter_ExtendedMaxBitrateList,
        _RAB_Parameter_GuaranteedBitrateList__item_,
        RAB_Parameter_GuaranteedBitrateList,
        _RAB_Parameter_MaxBitrateList__item_,
        RAB_Parameter_MaxBitrateList,
        _RAB_Parameters_trafficClass,
        _RAB_Parameters_rAB_AsymmetryIndicator,
        _RAB_Parameters_maxBitrate,
        _RAB_Parameters_guaranteedBitRate,
        _RAB_Parameters_deliveryOrder,
        _RAB_Parameters_maxSDU_Size,
        _RAB_Parameters_sDU_Parameters,
        _RAB_Parameters_transferDelay,
        _RAB_Parameters_trafficHandlingPriority,
        _RAB_Parameters_allocationOrRetentionPriority,
        _RAB_Parameters_sourceStatisticsDescriptor,
        _RAB_Parameters_relocationRequirement,
        ____RAB_Parameters_iE_Extensions__item__id_tab,
        _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_0,
        _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_1,
        _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_2,
        _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_3,
        _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_4,
        ___RAB_Parameters_iE_Extensions__item__id,
        ___RAB_Parameters_iE_Extensions__item__criticality,
        ___RAB_Parameters_iE_Extensions__item__extensionValue,
        __RAB_Parameters_iE_Extensions__item_,
        _RAB_Parameters_iE_Extensions,
        RAB_Parameters,
        RAB_Parameters_ExtIEs,
        _RAB_Parameters_ExtIEs_val_Extension_0,
        _RAB_Parameters_ExtIEs_val_Extension_1,
        _RAB_Parameters_ExtIEs_val_Extension_2,
        _RAB_Parameters_ExtIEs_val_Extension_3,
        _RAB_Parameters_ExtIEs_val_Extension_4,
        __RABParametersList__item__rab_Id,
        __RABParametersList__item__cn_domain,
        __RABParametersList__item__rabDataVolumeReport,
        __RABParametersList__item__upInformation,
        _____RABParametersList__item__iE_Extensions__item__id_tab,
        ____RABParametersList__item__iE_Extensions__item__id,
        _____RABParametersList__item__iE_Extensions__item__criticality_tab,
        ____RABParametersList__item__iE_Extensions__item__criticality,
        _____RABParametersList__item__iE_Extensions__item__extensionValue_tab,
        ____RABParametersList__item__iE_Extensions__item__extensionValue,
        ___RABParametersList__item__iE_Extensions__item_,
        __RABParametersList__item__iE_Extensions,
        _RABParametersList__item_,
        RABParametersList,
        RABParametersList_ExtIEs,
        RAB_SubflowCombinationBitRate,
        _RAB_TrCH_Mapping__item_,
        RAB_TrCH_Mapping,
        _RAB_TrCH_MappingItem_rAB_ID,
        _RAB_TrCH_MappingItem_trCH_ID_List,
        ____RAB_TrCH_MappingItem_iE_Extensions__item__id_tab,
        _____RAB_TrCH_MappingItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___RAB_TrCH_MappingItem_iE_Extensions__item__id,
        ___RAB_TrCH_MappingItem_iE_Extensions__item__criticality,
        ___RAB_TrCH_MappingItem_iE_Extensions__item__extensionValue,
        __RAB_TrCH_MappingItem_iE_Extensions__item_,
        _RAB_TrCH_MappingItem_iE_Extensions,
        RAB_TrCH_MappingItem,
        RAB_TrCH_MappingItem_ExtIEs,
        _RAB_TrCH_MappingItem_ExtIEs_val_Extension_0,
        RAC,
        _RAI_lAI,
        _RAI_rAC,
        ____RAI_iE_Extensions__item__id_tab,
        ___RAI_iE_Extensions__item__id,
        ____RAI_iE_Extensions__item__criticality_tab,
        ___RAI_iE_Extensions__item__criticality,
        ____RAI_iE_Extensions__item__extensionValue_tab,
        ___RAI_iE_Extensions__item__extensionValue,
        __RAI_iE_Extensions__item_,
        _RAI_iE_Extensions,
        RAI,
        RAI_ExtIEs,
        _RAListofIdleModeUEs_notEmptyRAListofIdleModeUEs,
        _RAListofIdleModeUEs_emptyFullRAListofIdleModeUEs,
        RAListofIdleModeUEs,
        _NotEmptyRAListofIdleModeUEs_rAofIdleModeUEs,
        ____NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id_tab,
        _____NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id_tab_val_Extension_0,
        ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id,
        ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__criticality,
        ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__extensionValue,
        __NotEmptyRAListofIdleModeUEs_iE_Extensions__item_,
        _NotEmptyRAListofIdleModeUEs_iE_Extensions,
        NotEmptyRAListofIdleModeUEs,
        _RAofIdleModeUEs__item_,
        RAofIdleModeUEs,
        NotEmptyRAListofIdleModeUEs_ExtIEs,
        _NotEmptyRAListofIdleModeUEs_ExtIEs_val_Extension_0,
        _LAListofIdleModeUEs__item_,
        LAListofIdleModeUEs,
        RAT_Type,
        RateControlAllowed,
        RedirectAttemptFlag,
        RedirectionCompleted,
        RejectCauseValue,
        RelocationRequirement,
        RelocationType,
        RepetitionNumber0,
        RepetitionNumber1,
        ReportArea,
        ReportInterval,
        ReportAmount,
        RequestedGPSAssistanceData,
        RequestedGANSSAssistanceData,
        RequestedLocationRelatedDataType,
        _RequestedMBMSIPMulticastAddressandAPNRequest__item_,
        RequestedMBMSIPMulticastAddressandAPNRequest,
        _MBMSIPMulticastAddressandAPNlist_tMGI,
        _MBMSIPMulticastAddressandAPNlist_iPMulticastAddress,
        _MBMSIPMulticastAddressandAPNlist_aPN,
        ____MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__id_tab,
        ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__id,
        ____MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__criticality_tab,
        ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__criticality,
        ____MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__extensionValue_tab,
        ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__extensionValue,
        __MBMSIPMulticastAddressandAPNlist_iE_Extensions__item_,
        _MBMSIPMulticastAddressandAPNlist_iE_Extensions,
        MBMSIPMulticastAddressandAPNlist,
        MBMSIPMulticastAddressandAPNlist_ExtIEs,
        _RequestedMulticastServiceList__item_,
        RequestedMulticastServiceList,
        _Requested_RAB_Parameter_Values_requestedMaxBitrates,
        _Requested_RAB_Parameter_Values_requestedGuaranteedBitrates,
        ____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab,
        _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_0,
        _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_1,
        _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_2,
        _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_3,
        _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_4,
        ___Requested_RAB_Parameter_Values_iE_Extensions__item__id,
        ___Requested_RAB_Parameter_Values_iE_Extensions__item__criticality,
        ___Requested_RAB_Parameter_Values_iE_Extensions__item__extensionValue,
        __Requested_RAB_Parameter_Values_iE_Extensions__item_,
        _Requested_RAB_Parameter_Values_iE_Extensions,
        Requested_RAB_Parameter_Values,
        Requested_RAB_Parameter_Values_ExtIEs,
        _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_0,
        _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_1,
        _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_2,
        _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_3,
        _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_4,
        _Requested_RAB_Parameter_ExtendedMaxBitrateList__item_,
        Requested_RAB_Parameter_ExtendedMaxBitrateList,
        _Requested_RAB_Parameter_ExtendedGuaranteedBitrateList__item_,
        Requested_RAB_Parameter_ExtendedGuaranteedBitrateList,
        _Requested_RAB_Parameter_MaxBitrateList__item_,
        Requested_RAB_Parameter_MaxBitrateList,
        _Requested_RAB_Parameter_GuaranteedBitrateList__item_,
        Requested_RAB_Parameter_GuaranteedBitrateList,
        _RequestType_event,
        _RequestType_reportArea,
        _RequestType_accuracyCode,
        RequestType,
        _ResidualBitErrorRatio_mantissa,
        _ResidualBitErrorRatio_exponent,
        ____ResidualBitErrorRatio_iE_Extensions__item__id_tab,
        ___ResidualBitErrorRatio_iE_Extensions__item__id,
        ____ResidualBitErrorRatio_iE_Extensions__item__criticality_tab,
        ___ResidualBitErrorRatio_iE_Extensions__item__criticality,
        ____ResidualBitErrorRatio_iE_Extensions__item__extensionValue_tab,
        ___ResidualBitErrorRatio_iE_Extensions__item__extensionValue,
        __ResidualBitErrorRatio_iE_Extensions__item_,
        _ResidualBitErrorRatio_iE_Extensions,
        ResidualBitErrorRatio,
        ResidualBitErrorRatio_ExtIEs,
        ResponseTime,
        RIMInformation,
        _RIM_Transfer_rIMInformation,
        _RIM_Transfer_rIMRoutingAddress,
        ____RIM_Transfer_iE_Extensions__item__id_tab,
        ___RIM_Transfer_iE_Extensions__item__id,
        ____RIM_Transfer_iE_Extensions__item__criticality_tab,
        ___RIM_Transfer_iE_Extensions__item__criticality,
        ____RIM_Transfer_iE_Extensions__item__extensionValue_tab,
        ___RIM_Transfer_iE_Extensions__item__extensionValue,
        __RIM_Transfer_iE_Extensions__item_,
        _RIM_Transfer_iE_Extensions,
        RIM_Transfer,
        RIM_Transfer_ExtIEs,
        _RIMRoutingAddress_targetRNC_ID,
        _RIMRoutingAddress_gERAN_Cell_ID,
        _RIMRoutingAddress_targeteNB_ID,
        RIMRoutingAddress,
        RNC_ID,
        _RNCTraceInformation_traceReference,
        _RNCTraceInformation_traceActivationIndicator,
        _RNCTraceInformation_equipmentsToBeTraced,
        ____RNCTraceInformation_iE_Extensions__item__id_tab,
        _____RNCTraceInformation_iE_Extensions__item__id_tab_val_Extension_0,
        _____RNCTraceInformation_iE_Extensions__item__id_tab_val_Extension_1,
        _____RNCTraceInformation_iE_Extensions__item__id_tab_val_Extension_2,
        _____RNCTraceInformation_iE_Extensions__item__id_tab_val_Extension_3,
        ___RNCTraceInformation_iE_Extensions__item__id,
        ___RNCTraceInformation_iE_Extensions__item__criticality,
        ___RNCTraceInformation_iE_Extensions__item__extensionValue,
        __RNCTraceInformation_iE_Extensions__item_,
        _RNCTraceInformation_iE_Extensions,
        RNCTraceInformation,
        RNCTraceInformation_ExtIEs,
        _RNCTraceInformation_ExtIEs_val_Extension_0,
        _RNCTraceInformation_ExtIEs_val_Extension_1,
        _RNCTraceInformation_ExtIEs_val_Extension_2,
        _RNCTraceInformation_ExtIEs_val_Extension_3,
        _RNSAPRelocationParameters_rabParmetersList,
        _RNSAPRelocationParameters_locationReporting,
        _RNSAPRelocationParameters_traceInformation,
        _RNSAPRelocationParameters_sourceSAI,
        ____RNSAPRelocationParameters_iE_Extensions__item__id_tab,
        ___RNSAPRelocationParameters_iE_Extensions__item__id,
        ____RNSAPRelocationParameters_iE_Extensions__item__criticality_tab,
        ___RNSAPRelocationParameters_iE_Extensions__item__criticality,
        ____RNSAPRelocationParameters_iE_Extensions__item__extensionValue_tab,
        ___RNSAPRelocationParameters_iE_Extensions__item__extensionValue,
        __RNSAPRelocationParameters_iE_Extensions__item_,
        _RNSAPRelocationParameters_iE_Extensions,
        RNSAPRelocationParameters,
        RNSAPRelocationParameters_ExtIEs,
        RRC_Container,
        RTLoadValue,
        RSRVCC_HO_Indication,
        _RSRVCC_Information_nonce,
        _RSRVCC_Information_iMSInformation,
        ____RSRVCC_Information_iE_Extensions__item__id_tab,
        ___RSRVCC_Information_iE_Extensions__item__id,
        ____RSRVCC_Information_iE_Extensions__item__criticality_tab,
        ___RSRVCC_Information_iE_Extensions__item__criticality,
        ____RSRVCC_Information_iE_Extensions__item__extensionValue_tab,
        ___RSRVCC_Information_iE_Extensions__item__extensionValue,
        __RSRVCC_Information_iE_Extensions__item_,
        _RSRVCC_Information_iE_Extensions,
        RSRVCC_Information,
        RSRVCC_Information_ExtIEs,
        RSRVCC_Operation_Possible,
        SAC,
        _SAI_pLMNidentity,
        _SAI_lAC,
        _SAI_sAC,
        ____SAI_iE_Extensions__item__id_tab,
        ___SAI_iE_Extensions__item__id,
        ____SAI_iE_Extensions__item__criticality_tab,
        ___SAI_iE_Extensions__item__criticality,
        ____SAI_iE_Extensions__item__extensionValue_tab,
        ___SAI_iE_Extensions__item__extensionValue,
        __SAI_iE_Extensions__item_,
        _SAI_iE_Extensions,
        SAI,
        SAI_ExtIEs,
        SAPI,
        SessionUpdateID,
        _Shared_Network_Information_pLMNs_in_shared_network,
        ____Shared_Network_Information_iE_Extensions__item__id_tab,
        ___Shared_Network_Information_iE_Extensions__item__id,
        ____Shared_Network_Information_iE_Extensions__item__criticality_tab,
        ___Shared_Network_Information_iE_Extensions__item__criticality,
        ____Shared_Network_Information_iE_Extensions__item__extensionValue_tab,
        ___Shared_Network_Information_iE_Extensions__item__extensionValue,
        __Shared_Network_Information_iE_Extensions__item_,
        _Shared_Network_Information_iE_Extensions,
        Shared_Network_Information,
        Session_Re_establishment_Indicator,
        Shared_Network_Information_ExtIEs,
        SignallingIndication,
        _SDU_ErrorRatio_mantissa,
        _SDU_ErrorRatio_exponent,
        ____SDU_ErrorRatio_iE_Extensions__item__id_tab,
        ___SDU_ErrorRatio_iE_Extensions__item__id,
        ____SDU_ErrorRatio_iE_Extensions__item__criticality_tab,
        ___SDU_ErrorRatio_iE_Extensions__item__criticality,
        ____SDU_ErrorRatio_iE_Extensions__item__extensionValue_tab,
        ___SDU_ErrorRatio_iE_Extensions__item__extensionValue,
        __SDU_ErrorRatio_iE_Extensions__item_,
        _SDU_ErrorRatio_iE_Extensions,
        SDU_ErrorRatio,
        SDU_ErrorRatio_ExtIEs,
        __SDU_FormatInformationParameters__item__subflowSDU_Size,
        __SDU_FormatInformationParameters__item__rAB_SubflowCombinationBitRate,
        _____SDU_FormatInformationParameters__item__iE_Extensions__item__id_tab,
        ____SDU_FormatInformationParameters__item__iE_Extensions__item__id,
        _____SDU_FormatInformationParameters__item__iE_Extensions__item__criticality_tab,
        ____SDU_FormatInformationParameters__item__iE_Extensions__item__criticality,
        _____SDU_FormatInformationParameters__item__iE_Extensions__item__extensionValue_tab,
        ____SDU_FormatInformationParameters__item__iE_Extensions__item__extensionValue,
        ___SDU_FormatInformationParameters__item__iE_Extensions__item_,
        __SDU_FormatInformationParameters__item__iE_Extensions,
        _SDU_FormatInformationParameters__item_,
        SDU_FormatInformationParameters,
        SDU_FormatInformationParameters_ExtIEs,
        __SDU_Parameters__item__sDU_ErrorRatio,
        __SDU_Parameters__item__residualBitErrorRatio,
        __SDU_Parameters__item__deliveryOfErroneousSDU,
        __SDU_Parameters__item__sDU_FormatInformationParameters,
        _____SDU_Parameters__item__iE_Extensions__item__id_tab,
        ____SDU_Parameters__item__iE_Extensions__item__id,
        _____SDU_Parameters__item__iE_Extensions__item__criticality_tab,
        ____SDU_Parameters__item__iE_Extensions__item__criticality,
        _____SDU_Parameters__item__iE_Extensions__item__extensionValue_tab,
        ____SDU_Parameters__item__iE_Extensions__item__extensionValue,
        ___SDU_Parameters__item__iE_Extensions__item_,
        __SDU_Parameters__item__iE_Extensions,
        _SDU_Parameters__item_,
        SDU_Parameters,
        SDU_Parameters_ExtIEs,
        _SGSN_Group_Identity_null_NRI,
        _SGSN_Group_Identity_sGSN_Group_ID,
        SGSN_Group_Identity,
        SGSN_Group_ID,
        _SNA_Access_Information_authorisedPLMNs,
        ____SNA_Access_Information_iE_Extensions__item__id_tab,
        ___SNA_Access_Information_iE_Extensions__item__id,
        ____SNA_Access_Information_iE_Extensions__item__criticality_tab,
        ___SNA_Access_Information_iE_Extensions__item__criticality,
        ____SNA_Access_Information_iE_Extensions__item__extensionValue_tab,
        ___SNA_Access_Information_iE_Extensions__item__extensionValue,
        __SNA_Access_Information_iE_Extensions__item_,
        _SNA_Access_Information_iE_Extensions,
        SNA_Access_Information,
        SNA_Access_Information_ExtIEs,
        SNAC,
        Service_Handover,
        Source_ToTarget_TransparentContainer,
        SourceeNodeB_ToTargeteNodeB_TransparentContainer,
        _SourceCellID_sourceUTRANCellID,
        _SourceCellID_sourceGERANCellID,
        SourceCellID,
        SourceBSS_ToTargetBSS_TransparentContainer,
        _SourceID_sourceRNC_ID,
        _SourceID_sAI,
        SourceID,
        _SourceRNC_ID_pLMNidentity,
        _SourceRNC_ID_rNC_ID,
        ____SourceRNC_ID_iE_Extensions__item__id_tab,
        _____SourceRNC_ID_iE_Extensions__item__id_tab_val_Extension_0,
        ___SourceRNC_ID_iE_Extensions__item__id,
        ___SourceRNC_ID_iE_Extensions__item__criticality,
        ___SourceRNC_ID_iE_Extensions__item__extensionValue,
        __SourceRNC_ID_iE_Extensions__item_,
        _SourceRNC_ID_iE_Extensions,
        SourceRNC_ID,
        SourceRNC_ID_ExtIEs,
        _SourceRNC_ID_ExtIEs_val_Extension_0,
        _SourceRNC_ToTargetRNC_TransparentContainer_rRC_Container,
        _SourceRNC_ToTargetRNC_TransparentContainer_numberOfIuInstances,
        _SourceRNC_ToTargetRNC_TransparentContainer_relocationType,
        _SourceRNC_ToTargetRNC_TransparentContainer_chosenIntegrityProtectionAlgorithm,
        _SourceRNC_ToTargetRNC_TransparentContainer_integrityProtectionKey,
        _SourceRNC_ToTargetRNC_TransparentContainer_chosenEncryptionAlgorithForSignalling,
        _SourceRNC_ToTargetRNC_TransparentContainer_cipheringKey,
        _SourceRNC_ToTargetRNC_TransparentContainer_chosenEncryptionAlgorithForCS,
        _SourceRNC_ToTargetRNC_TransparentContainer_chosenEncryptionAlgorithForPS,
        _SourceRNC_ToTargetRNC_TransparentContainer_d_RNTI,
        _SourceRNC_ToTargetRNC_TransparentContainer_targetCellId,
        _SourceRNC_ToTargetRNC_TransparentContainer_rAB_TrCH_Mapping,
        ____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_2,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_3,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_4,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_5,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_6,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_7,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_8,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_9,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_10,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_11,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_12,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_13,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_14,
        ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id,
        ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__criticality,
        ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__extensionValue,
        __SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item_,
        _SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions,
        SourceRNC_ToTargetRNC_TransparentContainer,
        SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_0,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_1,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_2,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_3,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_4,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_5,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_6,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_7,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_8,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_9,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_10,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_11,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_12,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_13,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_14,
        SRVCCSource,
        _IRAT_Measurement_Configuration_rSRP,
        _IRAT_Measurement_Configuration_rSRQ,
        _IRAT_Measurement_Configuration_iRATmeasurementParameters,
        ____IRAT_Measurement_Configuration_iE_Extensions__item__id_tab,
        _____IRAT_Measurement_Configuration_iE_Extensions__item__id_tab_val_Extension_0,
        _____IRAT_Measurement_Configuration_iE_Extensions__item__id_tab_val_Extension_1,
        ___IRAT_Measurement_Configuration_iE_Extensions__item__id,
        ___IRAT_Measurement_Configuration_iE_Extensions__item__criticality,
        ___IRAT_Measurement_Configuration_iE_Extensions__item__extensionValue,
        __IRAT_Measurement_Configuration_iE_Extensions__item_,
        _IRAT_Measurement_Configuration_iE_Extensions,
        IRAT_Measurement_Configuration,
        IRAT_Measurement_Configuration_ExtIEs,
        _IRAT_Measurement_Configuration_ExtIEs_val_Extension_0,
        _IRAT_Measurement_Configuration_ExtIEs_val_Extension_1,
        _IRATmeasurementParameters_measurementDuration,
        _IRATmeasurementParameters_eUTRANFrequencies,
        ____IRATmeasurementParameters_iE_Extensions__item__id_tab,
        ___IRATmeasurementParameters_iE_Extensions__item__id,
        ____IRATmeasurementParameters_iE_Extensions__item__criticality_tab,
        ___IRATmeasurementParameters_iE_Extensions__item__criticality,
        ____IRATmeasurementParameters_iE_Extensions__item__extensionValue_tab,
        ___IRATmeasurementParameters_iE_Extensions__item__extensionValue,
        __IRATmeasurementParameters_iE_Extensions__item_,
        _IRATmeasurementParameters_iE_Extensions,
        IRATmeasurementParameters,
        IRATmeasurementParameters_ExtIEs,
        _RSRQ_Type_allSymbols,
        _RSRQ_Type_wideBand,
        RSRQ_Type,
        RSRQ_Extension,
        __EUTRANFrequencies__item__earfcn,
        __EUTRANFrequencies__item__measBand,
        _____EUTRANFrequencies__item__iE_Extensions__item__id_tab,
        ______EUTRANFrequencies__item__iE_Extensions__item__id_tab_val_Extension_0,
        ____EUTRANFrequencies__item__iE_Extensions__item__id,
        ____EUTRANFrequencies__item__iE_Extensions__item__criticality,
        ____EUTRANFrequencies__item__iE_Extensions__item__extensionValue,
        ___EUTRANFrequencies__item__iE_Extensions__item_,
        __EUTRANFrequencies__item__iE_Extensions,
        _EUTRANFrequencies__item_,
        EUTRANFrequencies,
        MeasBand,
        EUTRANFrequencies_ExtIEs,
        _EUTRANFrequencies_ExtIEs_val_Extension_0,
        SubscriberProfileIDforRFP,
        SourceStatisticsDescriptor,
        _SupportedRAB_ParameterBitrateList__item_,
        SupportedRAB_ParameterBitrateList,
        SupportedBitrate,
        _SourceUTRANCellID_pLMNidentity,
        _SourceUTRANCellID_uTRANcellID,
        ____SourceUTRANCellID_iE_Extensions__item__id_tab,
        ___SourceUTRANCellID_iE_Extensions__item__id,
        ____SourceUTRANCellID_iE_Extensions__item__criticality_tab,
        ___SourceUTRANCellID_iE_Extensions__item__criticality,
        ____SourceUTRANCellID_iE_Extensions__item__extensionValue_tab,
        ___SourceUTRANCellID_iE_Extensions__item__extensionValue,
        __SourceUTRANCellID_iE_Extensions__item_,
        _SourceUTRANCellID_iE_Extensions,
        SourceUTRANCellID,
        SourceUTRANCellID_ExtIEs,
        SRB_ID,
        _SRB_TrCH_Mapping__item_,
        SRB_TrCH_Mapping,
        _SRB_TrCH_MappingItem_sRB_ID,
        _SRB_TrCH_MappingItem_trCH_ID,
        ____SRB_TrCH_MappingItem_iE_Extensions__item__id_tab,
        ___SRB_TrCH_MappingItem_iE_Extensions__item__id,
        ____SRB_TrCH_MappingItem_iE_Extensions__item__criticality_tab,
        ___SRB_TrCH_MappingItem_iE_Extensions__item__criticality,
        ____SRB_TrCH_MappingItem_iE_Extensions__item__extensionValue_tab,
        ___SRB_TrCH_MappingItem_iE_Extensions__item__extensionValue,
        __SRB_TrCH_MappingItem_iE_Extensions__item_,
        _SRB_TrCH_MappingItem_iE_Extensions,
        SRB_TrCH_MappingItem,
        SRB_TrCH_MappingItem_ExtIEs,
        SRVCC_HO_Indication,
        _SRVCC_Information_nonce,
        ____SRVCC_Information_iE_Extensions__item__id_tab,
        ___SRVCC_Information_iE_Extensions__item__id,
        ____SRVCC_Information_iE_Extensions__item__criticality_tab,
        ___SRVCC_Information_iE_Extensions__item__criticality,
        ____SRVCC_Information_iE_Extensions__item__extensionValue_tab,
        ___SRVCC_Information_iE_Extensions__item__extensionValue,
        __SRVCC_Information_iE_Extensions__item_,
        _SRVCC_Information_iE_Extensions,
        SRVCC_Information,
        SRVCC_Information_ExtIEs,
        SRVCC_Operation_Possible,
        SubflowSDU_Size,
        TAC,
        _TAI_pLMNidentity,
        _TAI_tAC,
        ____TAI_iE_Extensions__item__id_tab,
        ___TAI_iE_Extensions__item__id,
        ____TAI_iE_Extensions__item__criticality_tab,
        ___TAI_iE_Extensions__item__criticality,
        ____TAI_iE_Extensions__item__extensionValue_tab,
        ___TAI_iE_Extensions__item__extensionValue,
        __TAI_iE_Extensions__item_,
        _TAI_iE_Extensions,
        TAI,
        TAI_ExtIEs,
        Target_ToSource_TransparentContainer,
        TargeteNodeB_ToSourceeNodeB_TransparentContainer,
        TargetBSS_ToSourceBSS_TransparentContainer,
        TargetCellId,
        _TargetID_targetRNC_ID,
        _TargetID_cGI,
        _TargetID_targeteNB_ID,
        TargetID,
        _TargetENB_ID_pLMNidentity,
        _TargetENB_ID_eNB_ID,
        ____TargetENB_ID_iE_Extensions__item__id_tab,
        ___TargetENB_ID_iE_Extensions__item__id,
        ____TargetENB_ID_iE_Extensions__item__criticality_tab,
        ___TargetENB_ID_iE_Extensions__item__criticality,
        ____TargetENB_ID_iE_Extensions__item__extensionValue_tab,
        ___TargetENB_ID_iE_Extensions__item__extensionValue,
        __TargetENB_ID_iE_Extensions__item_,
        _TargetENB_ID_iE_Extensions,
        _TargetENB_ID_selectedTAI,
        TargetENB_ID,
        TargetENB_ID_ExtIEs,
        _TargetRNC_ID_lAI,
        _TargetRNC_ID_rAC,
        _TargetRNC_ID_rNC_ID,
        ____TargetRNC_ID_iE_Extensions__item__id_tab,
        _____TargetRNC_ID_iE_Extensions__item__id_tab_val_Extension_0,
        ___TargetRNC_ID_iE_Extensions__item__id,
        ___TargetRNC_ID_iE_Extensions__item__criticality,
        ___TargetRNC_ID_iE_Extensions__item__extensionValue,
        __TargetRNC_ID_iE_Extensions__item_,
        _TargetRNC_ID_iE_Extensions,
        TargetRNC_ID,
        TargetRNC_ID_ExtIEs,
        _TargetRNC_ID_ExtIEs_val_Extension_0,
        _TargetRNC_ToSourceRNC_TransparentContainer_rRC_Container,
        _TargetRNC_ToSourceRNC_TransparentContainer_d_RNTI,
        ____TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id_tab,
        _____TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0,
        ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id,
        ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__criticality,
        ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__extensionValue,
        __TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item_,
        _TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions,
        TargetRNC_ToSourceRNC_TransparentContainer,
        TargetRNC_ToSourceRNC_TransparentContainer_ExtIEs,
        _TargetRNC_ToSourceRNC_TransparentContainer_ExtIEs_val_Extension_0,
        UeApplicationLayerMeasurementSupportIndication,
        TBCD_STRING,
        _TemporaryUE_ID_tMSI,
        _TemporaryUE_ID_p_TMSI,
        TemporaryUE_ID,
        Time_UE_StayedInCell,
        Time_UE_StayedInCell_EnhancedGranularity,
        TimeToMBMSDataTransfer,
        TimingDifferenceULDL,
        _TMGI_pLMNidentity,
        _TMGI_serviceID,
        ____TMGI_iE_Extensions__item__id_tab,
        ___TMGI_iE_Extensions__item__id,
        ____TMGI_iE_Extensions__item__criticality_tab,
        ___TMGI_iE_Extensions__item__criticality,
        ____TMGI_iE_Extensions__item__extensionValue_tab,
        ___TMGI_iE_Extensions__item__extensionValue,
        __TMGI_iE_Extensions__item_,
        _TMGI_iE_Extensions,
        TMGI,
        TMGI_ExtIEs,
        TMSI,
        TraceDepth,
        _TraceInformation_traceReference,
        _TraceInformation_ue_identity,
        _TraceInformation_tracePropagationParameters,
        ____TraceInformation_iE_Extensions__item__id_tab,
        ___TraceInformation_iE_Extensions__item__id,
        ____TraceInformation_iE_Extensions__item__criticality_tab,
        ___TraceInformation_iE_Extensions__item__criticality,
        ____TraceInformation_iE_Extensions__item__extensionValue_tab,
        ___TraceInformation_iE_Extensions__item__extensionValue,
        __TraceInformation_iE_Extensions__item_,
        _TraceInformation_iE_Extensions,
        TraceInformation,
        TraceInformation_ExtIEs,
        _TracePropagationParameters_traceRecordingSessionReference,
        _TracePropagationParameters_traceDepth,
        _TracePropagationParameters_listOfInterfacesToTrace,
        ____TracePropagationParameters_iE_Extensions__item__id_tab,
        ___TracePropagationParameters_iE_Extensions__item__id,
        ____TracePropagationParameters_iE_Extensions__item__criticality_tab,
        ___TracePropagationParameters_iE_Extensions__item__criticality,
        ____TracePropagationParameters_iE_Extensions__item__extensionValue_tab,
        ___TracePropagationParameters_iE_Extensions__item__extensionValue,
        __TracePropagationParameters_iE_Extensions__item_,
        _TracePropagationParameters_iE_Extensions,
        TracePropagationParameters,
        TracePropagationParameters_ExtIEs,
        _TraceRecordingSessionInformation_traceReference,
        _TraceRecordingSessionInformation_traceRecordingSessionReference,
        ____TraceRecordingSessionInformation_iE_Extensions__item__id_tab,
        ___TraceRecordingSessionInformation_iE_Extensions__item__id,
        ____TraceRecordingSessionInformation_iE_Extensions__item__criticality_tab,
        ___TraceRecordingSessionInformation_iE_Extensions__item__criticality,
        ____TraceRecordingSessionInformation_iE_Extensions__item__extensionValue_tab,
        ___TraceRecordingSessionInformation_iE_Extensions__item__extensionValue,
        __TraceRecordingSessionInformation_iE_Extensions__item_,
        _TraceRecordingSessionInformation_iE_Extensions,
        TraceRecordingSessionInformation,
        TraceRecordingSessionInformation_ExtIEs,
        TraceRecordingSessionReference,
        TraceReference,
        TraceType,
        TrafficClass,
        TrafficHandlingPriority,
        TransferDelay,
        UnsuccessfullyTransmittedDataVolume,
        TransportLayerAddress,
        _TrCH_ID_dCH_ID,
        _TrCH_ID_dSCH_ID,
        _TrCH_ID_uSCH_ID,
        ____TrCH_ID_iE_Extensions__item__id_tab,
        _____TrCH_ID_iE_Extensions__item__id_tab_val_Extension_0,
        _____TrCH_ID_iE_Extensions__item__id_tab_val_Extension_1,
        ___TrCH_ID_iE_Extensions__item__id,
        ___TrCH_ID_iE_Extensions__item__criticality,
        ___TrCH_ID_iE_Extensions__item__extensionValue,
        __TrCH_ID_iE_Extensions__item_,
        _TrCH_ID_iE_Extensions,
        TrCH_ID,
        TrCH_ID_ExtIEs,
        _TrCH_ID_ExtIEs_val_Extension_0,
        _TrCH_ID_ExtIEs_val_Extension_1,
        _TrCH_ID_List__item_,
        TrCH_ID_List,
        TriggerID,
        _TunnelInformation_transportLayerAddress,
        _TunnelInformation_uDP_Port_Number,
        ____TunnelInformation_iE_Extensions__item__id_tab,
        ___TunnelInformation_iE_Extensions__item__id,
        ____TunnelInformation_iE_Extensions__item__criticality_tab,
        ___TunnelInformation_iE_Extensions__item__criticality,
        ____TunnelInformation_iE_Extensions__item__extensionValue_tab,
        ___TunnelInformation_iE_Extensions__item__extensionValue,
        __TunnelInformation_iE_Extensions__item_,
        _TunnelInformation_iE_Extensions,
        TunnelInformation,
        Tunnel_Information_ExtIEs,
        TypeOfError,
        _UE_AggregateMaximumBitRate_uE_AggregateMaximumBitRateDownlink,
        _UE_AggregateMaximumBitRate_uE_AggregateMaximumBitRateUplink,
        UE_AggregateMaximumBitRate,
        UE_AggregateMaximumBitRateDownlink,
        UE_AggregateMaximumBitRateUplink,
        UE_Application_Layer_Measurement_Capability,
        UE_History_Information,
        _UE_ID_imsi,
        _UE_ID_imei,
        _UE_ID_imeisv,
        UE_ID,
        _UE_IsNotServed_permanentNAS_UE_ID,
        ____UE_IsNotServed_iE_Extensions__item__id_tab,
        ___UE_IsNotServed_iE_Extensions__item__id,
        ____UE_IsNotServed_iE_Extensions__item__criticality_tab,
        ___UE_IsNotServed_iE_Extensions__item__criticality,
        ____UE_IsNotServed_iE_Extensions__item__extensionValue_tab,
        ___UE_IsNotServed_iE_Extensions__item__extensionValue,
        __UE_IsNotServed_iE_Extensions__item_,
        _UE_IsNotServed_iE_Extensions,
        UE_IsNotServed,
        UE_IsNotServed_ExtIEs,
        _UE_IsServed_permanentNAS_UE_ID,
        _UE_IsServed_pLMNidentity,
        ____UE_IsServed_iE_Extensions__item__id_tab,
        ___UE_IsServed_iE_Extensions__item__id,
        ____UE_IsServed_iE_Extensions__item__criticality_tab,
        ___UE_IsServed_iE_Extensions__item__criticality,
        ____UE_IsServed_iE_Extensions__item__extensionValue_tab,
        ___UE_IsServed_iE_Extensions__item__extensionValue,
        __UE_IsServed_iE_Extensions__item_,
        _UE_IsServed_iE_Extensions,
        UE_IsServed,
        UE_IsServed_ExtIEs,
        UE_Usage_Type,
        _UERegistrationQueryResult_uE_IsServed,
        _UERegistrationQueryResult_uE_IsNotServed,
        UERegistrationQueryResult,
        _UESBI_Iu_uESBI_IuA,
        _UESBI_Iu_uESBI_IuB,
        ____UESBI_Iu_iE_Extensions__item__id_tab,
        ___UESBI_Iu_iE_Extensions__item__id,
        ____UESBI_Iu_iE_Extensions__item__criticality_tab,
        ___UESBI_Iu_iE_Extensions__item__criticality,
        ____UESBI_Iu_iE_Extensions__item__extensionValue_tab,
        ___UESBI_Iu_iE_Extensions__item__extensionValue,
        __UESBI_Iu_iE_Extensions__item_,
        _UESBI_Iu_iE_Extensions,
        UESBI_Iu,
        UESBI_Iu_ExtIEs,
        UESBI_IuA,
        UESBI_IuB,
        UL_GTP_PDU_SequenceNumber,
        UL_N_PDU_SequenceNumber,
        _UPInformation_frameSeqNoUL,
        _UPInformation_frameSeqNoDL,
        _UPInformation_pdu14FrameSeqNoUL,
        _UPInformation_pdu14FrameSeqNoDL,
        _UPInformation_dataPDUType,
        _UPInformation_upinitialisationFrame,
        ____UPInformation_iE_Extensions__item__id_tab,
        _____UPInformation_iE_Extensions__item__id_tab_val_Extension_0,
        ___UPInformation_iE_Extensions__item__id,
        ___UPInformation_iE_Extensions__item__criticality,
        ___UPInformation_iE_Extensions__item__extensionValue,
        __UPInformation_iE_Extensions__item_,
        _UPInformation_iE_Extensions,
        UPInformation,
        UPInformation_ExtIEs,
        _UPInformation_ExtIEs_val_Extension_0,
        UPInitialisationFrame,
        UP_ModeVersions,
        USCH_ID,
        UserPlaneMode,
        _UTRAN_CellID_pLMNidentity,
        _UTRAN_CellID_cellID,
        ____UTRAN_CellID_iE_Extensions__item__id_tab,
        ___UTRAN_CellID_iE_Extensions__item__id,
        ____UTRAN_CellID_iE_Extensions__item__criticality_tab,
        ___UTRAN_CellID_iE_Extensions__item__criticality,
        ____UTRAN_CellID_iE_Extensions__item__extensionValue_tab,
        ___UTRAN_CellID_iE_Extensions__item__extensionValue,
        __UTRAN_CellID_iE_Extensions__item_,
        _UTRAN_CellID_iE_Extensions,
        UTRAN_CellID,
        UTRAN_CellID_ExtIEs,
        _VelocityEstimate_horizontalVelocity,
        _VelocityEstimate_horizontalWithVerticalVelocity,
        _VelocityEstimate_horizontalVelocityWithUncertainty,
        _VelocityEstimate_horizontalWithVeritcalVelocityAndUncertainty,
        VelocityEstimate,
        _HorizontalVelocity_horizontalSpeedAndBearing,
        ____HorizontalVelocity_iE_Extensions__item__id_tab,
        ___HorizontalVelocity_iE_Extensions__item__id,
        ____HorizontalVelocity_iE_Extensions__item__criticality_tab,
        ___HorizontalVelocity_iE_Extensions__item__criticality,
        ____HorizontalVelocity_iE_Extensions__item__extensionValue_tab,
        ___HorizontalVelocity_iE_Extensions__item__extensionValue,
        __HorizontalVelocity_iE_Extensions__item_,
        _HorizontalVelocity_iE_Extensions,
        HorizontalVelocity,
        HorizontalVelocity_ExtIEs,
        _HorizontalWithVerticalVelocity_horizontalSpeedAndBearing,
        _HorizontalWithVerticalVelocity_veritcalVelocity,
        ____HorizontalWithVerticalVelocity_iE_Extensions__item__id_tab,
        ___HorizontalWithVerticalVelocity_iE_Extensions__item__id,
        ____HorizontalWithVerticalVelocity_iE_Extensions__item__criticality_tab,
        ___HorizontalWithVerticalVelocity_iE_Extensions__item__criticality,
        ____HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue_tab,
        ___HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue,
        __HorizontalWithVerticalVelocity_iE_Extensions__item_,
        _HorizontalWithVerticalVelocity_iE_Extensions,
        HorizontalWithVerticalVelocity,
        HorizontalWithVerticalVelocity_ExtIEs,
        _HorizontalVelocityWithUncertainty_horizontalSpeedAndBearing,
        _HorizontalVelocityWithUncertainty_uncertaintySpeed,
        ____HorizontalVelocityWithUncertainty_iE_Extensions__item__id_tab,
        ___HorizontalVelocityWithUncertainty_iE_Extensions__item__id,
        ____HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality_tab,
        ___HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality,
        ____HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue_tab,
        ___HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue,
        __HorizontalVelocityWithUncertainty_iE_Extensions__item_,
        _HorizontalVelocityWithUncertainty_iE_Extensions,
        HorizontalVelocityWithUncertainty,
        HorizontalVelocityWithUncertainty_ExtIEs,
        _HorizontalWithVerticalVelocityAndUncertainty_horizontalSpeedAndBearing,
        _HorizontalWithVerticalVelocityAndUncertainty_veritcalVelocity,
        _HorizontalWithVerticalVelocityAndUncertainty_horizontalUncertaintySpeed,
        _HorizontalWithVerticalVelocityAndUncertainty_verticalUncertaintySpeed,
        ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id_tab,
        ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id,
        ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality_tab,
        ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality,
        ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue_tab,
        ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue,
        __HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item_,
        _HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions,
        HorizontalWithVerticalVelocityAndUncertainty,
        HorizontalWithVerticalVelocityAndUncertainty_ExtIEs,
        _HorizontalSpeedAndBearing_bearing,
        _HorizontalSpeedAndBearing_horizontalSpeed,
        HorizontalSpeedAndBearing,
        _VerticalVelocity_veritcalSpeed,
        _VerticalVelocity_veritcalSpeedDirection,
        VerticalVelocity,
        VerticalSpeedDirection,
        VerticalAccuracyCode,
        VoiceSupportMatchIndicator,
    ]

class RANAP_PDU_Contents:

    _name_  = u'RANAP-PDU-Contents'
    _oid_   = [0, 4, 0, 0, 20, 3, 0, 1, 1]
    
    _obj_ = [
        u'RAB-IE-ContainerList',
        u'RAB-IE-ContainerPairList',
        u'ProtocolError-IE-ContainerList',
        u'IuSigConId-IE-ContainerList',
        u'DirectTransfer-IE-ContainerList',
        u'Iu-ReleaseCommand',
        u'Iu-ReleaseCommandIEs',
        u'Iu-ReleaseCommandExtensions',
        u'Iu-ReleaseComplete',
        u'Iu-ReleaseCompleteIEs',
        u'RAB-DataVolumeReportList',
        u'RAB-DataVolumeReportItemIEs',
        u'RAB-DataVolumeReportItem',
        u'RAB-DataVolumeReportItem-ExtIEs',
        u'RAB-ReleasedList-IuRelComp',
        u'RAB-ReleasedItem-IuRelComp-IEs',
        u'RAB-ReleasedItem-IuRelComp',
        u'RAB-ReleasedItem-IuRelComp-ExtIEs',
        u'Iu-ReleaseCompleteExtensions',
        u'RelocationRequired',
        u'RelocationRequiredIEs',
        u'RelocationRequiredExtensions',
        u'RelocationCommand',
        u'RelocationCommandIEs',
        u'RAB-RelocationReleaseList',
        u'RAB-RelocationReleaseItemIEs',
        u'RAB-RelocationReleaseItem',
        u'RAB-RelocationReleaseItem-ExtIEs',
        u'RAB-DataForwardingList',
        u'RAB-DataForwardingItemIEs',
        u'RAB-DataForwardingItem',
        u'RAB-DataForwardingItem-ExtIEs',
        u'RelocationCommandExtensions',
        u'RelocationPreparationFailure',
        u'RelocationPreparationFailureIEs',
        u'RelocationPreparationFailureExtensions',
        u'RelocationRequest',
        u'RelocationRequestIEs',
        u'RAB-SetupList-RelocReq',
        u'RAB-SetupItem-RelocReq-IEs',
        u'RAB-SetupItem-RelocReq',
        u'RAB-SetupItem-RelocReq-ExtIEs',
        u'UserPlaneInformation',
        u'UserPlaneInformation-ExtIEs',
        u'RelocationRequestExtensions',
        u'CNMBMSLinkingInformation',
        u'CNMBMSLinkingInformation-ExtIEs',
        u'JoinedMBMSBearerService-IEs',
        u'JoinedMBMSBearerService-ExtIEs',
        u'RelocationRequestAcknowledge',
        u'RelocationRequestAcknowledgeIEs',
        u'RAB-SetupList-RelocReqAck',
        u'RAB-SetupItem-RelocReqAck-IEs',
        u'RAB-SetupItem-RelocReqAck',
        u'RAB-SetupItem-RelocReqAck-ExtIEs',
        u'RAB-FailedList',
        u'RAB-FailedItemIEs',
        u'RAB-FailedItem',
        u'RAB-FailedItem-ExtIEs',
        u'RelocationRequestAcknowledgeExtensions',
        u'RelocationFailure',
        u'RelocationFailureIEs',
        u'RelocationFailureExtensions',
        u'RelocationCancel',
        u'RelocationCancelIEs',
        u'RelocationCancelExtensions',
        u'RelocationCancelAcknowledge',
        u'RelocationCancelAcknowledgeIEs',
        u'RelocationCancelAcknowledgeExtensions',
        u'SRNS-ContextRequest',
        u'SRNS-ContextRequestIEs',
        u'RAB-DataForwardingList-SRNS-CtxReq',
        u'RAB-DataForwardingItem-SRNS-CtxReq-IEs',
        u'RAB-DataForwardingItem-SRNS-CtxReq',
        u'RAB-DataForwardingItem-SRNS-CtxReq-ExtIEs',
        u'SRNS-ContextRequestExtensions',
        u'SRNS-ContextResponse',
        u'SRNS-ContextResponseIEs',
        u'RAB-ContextList',
        u'RAB-ContextItemIEs',
        u'RAB-ContextItem',
        u'RAB-ContextItem-ExtIEs',
        u'RAB-ContextFailedtoTransferList',
        u'RABs-ContextFailedtoTransferItemIEs',
        u'RABs-ContextFailedtoTransferItem',
        u'RABs-ContextFailedtoTransferItem-ExtIEs',
        u'SRNS-ContextResponseExtensions',
        u'SecurityModeCommand',
        u'SecurityModeCommandIEs',
        u'SecurityModeCommandExtensions',
        u'SecurityModeComplete',
        u'SecurityModeCompleteIEs',
        u'SecurityModeCompleteExtensions',
        u'SecurityModeReject',
        u'SecurityModeRejectIEs',
        u'SecurityModeRejectExtensions',
        u'DataVolumeReportRequest',
        u'DataVolumeReportRequestIEs',
        u'RAB-DataVolumeReportRequestList',
        u'RAB-DataVolumeReportRequestItemIEs',
        u'RAB-DataVolumeReportRequestItem',
        u'RAB-DataVolumeReportRequestItem-ExtIEs',
        u'DataVolumeReportRequestExtensions',
        u'DataVolumeReport',
        u'DataVolumeReportIEs',
        u'DataVolumeReportExtensions',
        u'RAB-FailedtoReportList',
        u'RABs-failed-to-reportItemIEs',
        u'RABs-failed-to-reportItem',
        u'RABs-failed-to-reportItem-ExtIEs',
        u'Reset',
        u'ResetIEs',
        u'ResetExtensions',
        u'ResetAcknowledge',
        u'ResetAcknowledgeIEs',
        u'ResetAcknowledgeExtensions',
        u'ResetResource',
        u'ResetResourceIEs',
        u'ResetResourceList',
        u'ResetResourceItemIEs',
        u'ResetResourceItem',
        u'ResetResourceItem-ExtIEs',
        u'ResetResourceExtensions',
        u'ResetResourceAcknowledge',
        u'ResetResourceAcknowledgeIEs',
        u'ResetResourceAckList',
        u'ResetResourceAckItemIEs',
        u'ResetResourceAckItem',
        u'ResetResourceAckItem-ExtIEs',
        u'ResetResourceAcknowledgeExtensions',
        u'RAB-ReleaseRequest',
        u'RAB-ReleaseRequestIEs',
        u'RAB-ReleaseList',
        u'RAB-ReleaseItemIEs',
        u'RAB-ReleaseItem',
        u'RAB-ReleaseItem-ExtIEs',
        u'RAB-ReleaseRequestExtensions',
        u'Iu-ReleaseRequest',
        u'Iu-ReleaseRequestIEs',
        u'Iu-ReleaseRequestExtensions',
        u'RelocationDetect',
        u'RelocationDetectIEs',
        u'RelocationDetectExtensions',
        u'RelocationComplete',
        u'RelocationCompleteIEs',
        u'RelocationCompleteExtensions',
        u'EnhancedRelocationCompleteRequest',
        u'EnhancedRelocationCompleteRequestIEs',
        u'RAB-SetupList-EnhancedRelocCompleteReq',
        u'RAB-SetupItem-EnhancedRelocCompleteReq-IEs',
        u'RAB-SetupItem-EnhancedRelocCompleteReq',
        u'RAB-SetupItem-EnhancedRelocCompleteReq-ExtIEs',
        u'EnhancedRelocationCompleteRequestExtensions',
        u'EnhancedRelocationCompleteResponse',
        u'EnhancedRelocationCompleteResponseIEs',
        u'RAB-SetupList-EnhancedRelocCompleteRes',
        u'RAB-SetupItem-EnhancedRelocCompleteRes-IEs',
        u'RAB-SetupItem-EnhancedRelocCompleteRes',
        u'RAB-SetupItem-EnhancedRelocCompleteRes-ExtIEs',
        u'RAB-ToBeReleasedList-EnhancedRelocCompleteRes',
        u'RAB-ToBeReleasedItem-EnhancedRelocCompleteRes-IEs',
        u'RAB-ToBeReleasedItem-EnhancedRelocCompleteRes',
        u'RAB-ToBeReleasedItem-EnhancedRelocCompleteRes-ExtIEs',
        u'EnhancedRelocationCompleteResponseExtensions',
        u'EnhancedRelocationCompleteFailure',
        u'EnhancedRelocationCompleteFailureIEs',
        u'EnhancedRelocationCompleteFailureExtensions',
        u'EnhancedRelocationCompleteConfirm',
        u'EnhancedRelocationCompleteConfirmIEs',
        u'EnhancedRelocationCompleteConfirmExtensions',
        u'Paging',
        u'PagingIEs',
        u'PagingExtensions',
        u'CommonID',
        u'CommonID-IEs',
        u'CommonIDExtensions',
        u'CN-InvokeTrace',
        u'CN-InvokeTraceIEs',
        u'CN-InvokeTraceExtensions',
        u'CN-DeactivateTrace',
        u'CN-DeactivateTraceIEs',
        u'CN-DeactivateTraceExtensions',
        u'LocationReportingControl',
        u'LocationReportingControlIEs',
        u'LocationReportingControlExtensions',
        u'LocationReport',
        u'LocationReportIEs',
        u'LocationReportExtensions',
        u'InitialUE-Message',
        u'InitialUE-MessageIEs',
        u'InitialUE-MessageExtensions',
        u'DirectTransfer',
        u'DirectTransferIEs',
        u'DirectTransferExtensions',
        u'RedirectionIndication',
        u'RedirectionIndication-IEs',
        u'Overload',
        u'OverloadIEs',
        u'OverloadExtensions',
        u'ErrorIndication',
        u'ErrorIndicationIEs',
        u'ErrorIndicationExtensions',
        u'SRNS-DataForwardCommand',
        u'SRNS-DataForwardCommandIEs',
        u'SRNS-DataForwardCommandExtensions',
        u'ForwardSRNS-Context',
        u'ForwardSRNS-ContextIEs',
        u'ForwardSRNS-ContextExtensions',
        u'RAB-AssignmentRequest',
        u'RAB-AssignmentRequestIEs',
        u'RAB-SetupOrModifyList',
        u'RAB-SetupOrModifyItem-IEs',
        u'RAB-SetupOrModifyItemFirst',
        u'TransportLayerInformation',
        u'TransportLayerInformation-ExtIEs',
        u'RAB-SetupOrModifyItemFirst-ExtIEs',
        u'RAB-SetupOrModifyItemSecond',
        u'RAB-SetupOrModifyItemSecond-ExtIEs',
        u'RAB-AssignmentRequestExtensions',
        u'RAB-AssignmentResponse',
        u'RAB-AssignmentResponseIEs',
        u'RAB-SetupOrModifiedList',
        u'RAB-SetupOrModifiedItemIEs',
        u'RAB-SetupOrModifiedItem',
        u'RAB-SetupOrModifiedItem-ExtIEs',
        u'RAB-ReleasedList',
        u'RAB-ReleasedItemIEs',
        u'RAB-ReleasedItem',
        u'RAB-ReleasedItem-ExtIEs',
        u'DataVolumeList',
        u'DataVolumeList-ExtIEs',
        u'RAB-QueuedList',
        u'RAB-QueuedItemIEs',
        u'RAB-QueuedItem',
        u'RAB-QueuedItem-ExtIEs',
        u'RAB-ReleaseFailedList',
        u'RAB-AssignmentResponseExtensions',
        u'GERAN-Iumode-RAB-FailedList-RABAssgntResponse',
        u'GERAN-Iumode-RAB-Failed-RABAssgntResponse-ItemIEs',
        u'GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item',
        u'GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item-ExtIEs',
        u'PrivateMessage',
        u'PrivateMessage-IEs',
        u'RANAP-RelocationInformation',
        u'RANAP-RelocationInformationIEs',
        u'DirectTransferInformationList-RANAP-RelocInf',
        u'DirectTransferInformationItemIEs-RANAP-RelocInf',
        u'DirectTransferInformationItem-RANAP-RelocInf',
        u'RANAP-DirectTransferInformationItem-ExtIEs-RANAP-RelocInf',
        u'RAB-ContextList-RANAP-RelocInf',
        u'RAB-ContextItemIEs-RANAP-RelocInf',
        u'RAB-ContextItem-RANAP-RelocInf',
        u'RAB-ContextItem-ExtIEs-RANAP-RelocInf',
        u'RANAP-RelocationInformationExtensions',
        u'RANAP-EnhancedRelocationInformationRequest',
        u'RANAP-EnhancedRelocationInformationRequestIEs',
        u'RAB-SetupList-EnhRelocInfoReq',
        u'RAB-SetupItem-EnhRelocInfoReq-IEs',
        u'RAB-SetupItem-EnhRelocInfoReq',
        u'RAB-SetupItem-EnhRelocInfoReq-ExtIEs',
        u'TNLInformationEnhRelInfoReq',
        u'TNLInformationEnhRelInfoReq-ExtIEs',
        u'RANAP-EnhancedRelocationInformationRequestExtensions',
        u'RANAP-EnhancedRelocationInformationResponse',
        u'RANAP-EnhancedRelocationInformationResponseIEs',
        u'RAB-SetupList-EnhRelocInfoRes',
        u'RAB-SetupItem-EnhRelocInfoRes-IEs',
        u'RAB-SetupItem-EnhRelocInfoRes',
        u'RAB-SetupItem-EnhRelocInfoRes-ExtIEs',
        u'RAB-FailedList-EnhRelocInfoRes',
        u'RAB-FailedItem-EnhRelocInfoRes-IEs',
        u'RAB-FailedItem-EnhRelocInfoRes',
        u'RAB-FailedItem-EnhRelocInfoRes-ExtIEs',
        u'TNLInformationEnhRelInfoRes',
        u'TNLInformationEnhRelInfoRes-ExtIEs',
        u'RANAP-EnhancedRelocationInformationResponseExtensions',
        u'RAB-ModifyRequest',
        u'RAB-ModifyRequestIEs',
        u'RAB-ModifyList',
        u'RAB-ModifyItemIEs',
        u'RAB-ModifyItem',
        u'RAB-ModifyItem-ExtIEs',
        u'RAB-ModifyRequestExtensions',
        u'LocationRelatedDataRequest',
        u'LocationRelatedDataRequestIEs',
        u'LocationRelatedDataRequestExtensions',
        u'LocationRelatedDataResponse',
        u'LocationRelatedDataResponseIEs',
        u'LocationRelatedDataResponseExtensions',
        u'LocationRelatedDataFailure',
        u'LocationRelatedDataFailureIEs',
        u'LocationRelatedDataFailureExtensions',
        u'InformationTransferIndication',
        u'InformationTransferIndicationIEs',
        u'InformationTransferIndicationExtensions',
        u'InformationTransferConfirmation',
        u'InformationTransferConfirmationIEs',
        u'InformationTransferConfirmationExtensions',
        u'InformationTransferFailure',
        u'InformationTransferFailureIEs',
        u'InformationTransferFailureExtensions',
        u'UESpecificInformationIndication',
        u'UESpecificInformationIndicationIEs',
        u'UESpecificInformationIndicationExtensions',
        u'DirectInformationTransfer',
        u'DirectInformationTransferIEs',
        u'DirectInformationTransferExtensions',
        u'UplinkInformationExchangeRequest',
        u'UplinkInformationExchangeRequestIEs',
        u'UplinkInformationExchangeRequestExtensions',
        u'UplinkInformationExchangeResponse',
        u'UplinkInformationExchangeResponseIEs',
        u'UplinkInformationExchangeResponseExtensions',
        u'UplinkInformationExchangeFailure',
        u'UplinkInformationExchangeFailureIEs',
        u'UplinkInformationExchangeFailureExtensions',
        u'MBMSSessionStart',
        u'MBMSSessionStartIEs',
        u'MBMSSessionStartExtensions',
        u'MBMSSynchronisationInformation',
        u'MBMSSynchronisationInformation-ExtIEs',
        u'MBMSSessionStartResponse',
        u'MBMSSessionStartResponseIEs',
        u'MBMSSessionStartResponseExtensions',
        u'MBMSSessionStartFailure',
        u'MBMSSessionStartFailureIEs',
        u'MBMSSessionStartFailureExtensions',
        u'MBMSSessionUpdate',
        u'MBMSSessionUpdateIEs',
        u'MBMSSessionUpdateExtensions',
        u'MBMSSessionUpdateResponse',
        u'MBMSSessionUpdateResponseIEs',
        u'MBMSSessionUpdateResponseExtensions',
        u'MBMSSessionUpdateFailure',
        u'MBMSSessionUpdateFailureIEs',
        u'MBMSSessionUpdateFailureExtensions',
        u'MBMSSessionStop',
        u'MBMSSessionStopIEs',
        u'MBMSSessionStopExtensions',
        u'MBMSSessionStopResponse',
        u'MBMSSessionStopResponseIEs',
        u'MBMSSessionStopResponseExtensions',
        u'MBMSUELinkingRequest',
        u'MBMSUELinkingRequestIEs',
        u'LeftMBMSBearerService-IEs',
        u'LeftMBMSBearerService-ExtIEs',
        u'MBMSUELinkingRequestExtensions',
        u'MBMSUELinkingResponse',
        u'MBMSUELinkingResponseIEs',
        u'UnsuccessfulLinking-IEs',
        u'UnsuccessfulLinking-ExtIEs',
        u'MBMSUELinkingResponseExtensions',
        u'MBMSRegistrationRequest',
        u'MBMSRegistrationRequestIEs',
        u'MBMSRegistrationRequestExtensions',
        u'MBMSRegistrationResponse',
        u'MBMSRegistrationResponseIEs',
        u'MBMSRegistrationResponseExtensions',
        u'MBMSRegistrationFailure',
        u'MBMSRegistrationFailureIEs',
        u'MBMSRegistrationFailureExtensions',
        u'MBMSCNDe-RegistrationRequest',
        u'MBMSCNDe-RegistrationRequestIEs',
        u'MBMSCNDe-RegistrationRequestExtensions',
        u'MBMSCNDe-RegistrationResponse',
        u'MBMSCNDe-RegistrationResponseIEs',
        u'MBMSCNDe-RegistrationResponseExtensions',
        u'MBMSRABEstablishmentIndication',
        u'MBMSRABEstablishmentIndicationIEs',
        u'MBMSRABEstablishmentIndicationExtensions',
        u'MBMSRABReleaseRequest',
        u'MBMSRABReleaseRequestIEs',
        u'MBMSRABReleaseRequestExtensions',
        u'MBMSRABRelease',
        u'MBMSRABReleaseIEs',
        u'MBMSRABReleaseExtensions',
        u'MBMSRABReleaseFailure',
        u'MBMSRABReleaseFailureIEs',
        u'MBMSRABReleaseFailureExtensions',
        u'SRVCC-CSKeysRequest',
        u'SRVCC-CSKeysRequestIEs',
        u'SRVCC-CSKeysRequestExtensions',
        u'SRVCC-CSKeysResponse',
        u'SRVCC-CSKeysResponseIEs',
        u'SRVCC-CSKeysResponseExtensions',
        u'UeRadioCapabilityMatchRequest',
        u'UeRadioCapabilityMatchRequestIEs',
        u'UeRadioCapabilityMatchRequestExtensions',
        u'UeRadioCapabilityMatchResponse',
        u'UeRadioCapabilityMatchResponseIEs',
        u'UeRadioCapabilityMatchResponseExtensions',
        u'UeRegistrationQueryRequest',
        u'UeRegistrationQueryRequestIEs',
        u'UeRegistrationQueryRequestExtensions',
        u'UeRegistrationQueryResponse',
        u'UeRegistrationQueryResponseIEs',
        u'UeRegistrationQueryResponseExtensions',
        u'RerouteNASRequest',
        u'RerouteNASRequestIEs',
        u'RerouteNASRequestExtensions',
        ]
    _type_ = [
        u'RAB-IE-ContainerList',
        u'RAB-IE-ContainerPairList',
        u'ProtocolError-IE-ContainerList',
        u'IuSigConId-IE-ContainerList',
        u'DirectTransfer-IE-ContainerList',
        u'Iu-ReleaseCommand',
        u'Iu-ReleaseComplete',
        u'RAB-DataVolumeReportList',
        u'RAB-DataVolumeReportItem',
        u'RAB-ReleasedList-IuRelComp',
        u'RAB-ReleasedItem-IuRelComp',
        u'RelocationRequired',
        u'RelocationCommand',
        u'RAB-RelocationReleaseList',
        u'RAB-RelocationReleaseItem',
        u'RAB-DataForwardingList',
        u'RAB-DataForwardingItem',
        u'RelocationPreparationFailure',
        u'RelocationRequest',
        u'RAB-SetupList-RelocReq',
        u'RAB-SetupItem-RelocReq',
        u'UserPlaneInformation',
        u'CNMBMSLinkingInformation',
        u'JoinedMBMSBearerService-IEs',
        u'RelocationRequestAcknowledge',
        u'RAB-SetupList-RelocReqAck',
        u'RAB-SetupItem-RelocReqAck',
        u'RAB-FailedList',
        u'RAB-FailedItem',
        u'RelocationFailure',
        u'RelocationCancel',
        u'RelocationCancelAcknowledge',
        u'SRNS-ContextRequest',
        u'RAB-DataForwardingList-SRNS-CtxReq',
        u'RAB-DataForwardingItem-SRNS-CtxReq',
        u'SRNS-ContextResponse',
        u'RAB-ContextList',
        u'RAB-ContextItem',
        u'RAB-ContextFailedtoTransferList',
        u'RABs-ContextFailedtoTransferItem',
        u'SecurityModeCommand',
        u'SecurityModeComplete',
        u'SecurityModeReject',
        u'DataVolumeReportRequest',
        u'RAB-DataVolumeReportRequestList',
        u'RAB-DataVolumeReportRequestItem',
        u'DataVolumeReport',
        u'RAB-FailedtoReportList',
        u'RABs-failed-to-reportItem',
        u'Reset',
        u'ResetAcknowledge',
        u'ResetResource',
        u'ResetResourceList',
        u'ResetResourceItem',
        u'ResetResourceAcknowledge',
        u'ResetResourceAckList',
        u'ResetResourceAckItem',
        u'RAB-ReleaseRequest',
        u'RAB-ReleaseList',
        u'RAB-ReleaseItem',
        u'Iu-ReleaseRequest',
        u'RelocationDetect',
        u'RelocationComplete',
        u'EnhancedRelocationCompleteRequest',
        u'RAB-SetupList-EnhancedRelocCompleteReq',
        u'RAB-SetupItem-EnhancedRelocCompleteReq',
        u'EnhancedRelocationCompleteResponse',
        u'RAB-SetupList-EnhancedRelocCompleteRes',
        u'RAB-SetupItem-EnhancedRelocCompleteRes',
        u'RAB-ToBeReleasedList-EnhancedRelocCompleteRes',
        u'RAB-ToBeReleasedItem-EnhancedRelocCompleteRes',
        u'EnhancedRelocationCompleteFailure',
        u'EnhancedRelocationCompleteConfirm',
        u'Paging',
        u'CommonID',
        u'CN-InvokeTrace',
        u'CN-DeactivateTrace',
        u'LocationReportingControl',
        u'LocationReport',
        u'InitialUE-Message',
        u'DirectTransfer',
        u'RedirectionIndication',
        u'Overload',
        u'ErrorIndication',
        u'SRNS-DataForwardCommand',
        u'ForwardSRNS-Context',
        u'RAB-AssignmentRequest',
        u'RAB-SetupOrModifyList',
        u'RAB-SetupOrModifyItemFirst',
        u'TransportLayerInformation',
        u'RAB-SetupOrModifyItemSecond',
        u'RAB-AssignmentResponse',
        u'RAB-SetupOrModifiedList',
        u'RAB-SetupOrModifiedItem',
        u'RAB-ReleasedList',
        u'RAB-ReleasedItem',
        u'DataVolumeList',
        u'RAB-QueuedList',
        u'RAB-QueuedItem',
        u'RAB-ReleaseFailedList',
        u'GERAN-Iumode-RAB-FailedList-RABAssgntResponse',
        u'GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item',
        u'PrivateMessage',
        u'RANAP-RelocationInformation',
        u'DirectTransferInformationList-RANAP-RelocInf',
        u'DirectTransferInformationItem-RANAP-RelocInf',
        u'RAB-ContextList-RANAP-RelocInf',
        u'RAB-ContextItem-RANAP-RelocInf',
        u'RANAP-EnhancedRelocationInformationRequest',
        u'RAB-SetupList-EnhRelocInfoReq',
        u'RAB-SetupItem-EnhRelocInfoReq',
        u'TNLInformationEnhRelInfoReq',
        u'RANAP-EnhancedRelocationInformationResponse',
        u'RAB-SetupList-EnhRelocInfoRes',
        u'RAB-SetupItem-EnhRelocInfoRes',
        u'RAB-FailedList-EnhRelocInfoRes',
        u'RAB-FailedItem-EnhRelocInfoRes',
        u'TNLInformationEnhRelInfoRes',
        u'RAB-ModifyRequest',
        u'RAB-ModifyList',
        u'RAB-ModifyItem',
        u'LocationRelatedDataRequest',
        u'LocationRelatedDataResponse',
        u'LocationRelatedDataFailure',
        u'InformationTransferIndication',
        u'InformationTransferConfirmation',
        u'InformationTransferFailure',
        u'UESpecificInformationIndication',
        u'DirectInformationTransfer',
        u'UplinkInformationExchangeRequest',
        u'UplinkInformationExchangeResponse',
        u'UplinkInformationExchangeFailure',
        u'MBMSSessionStart',
        u'MBMSSynchronisationInformation',
        u'MBMSSessionStartResponse',
        u'MBMSSessionStartFailure',
        u'MBMSSessionUpdate',
        u'MBMSSessionUpdateResponse',
        u'MBMSSessionUpdateFailure',
        u'MBMSSessionStop',
        u'MBMSSessionStopResponse',
        u'MBMSUELinkingRequest',
        u'LeftMBMSBearerService-IEs',
        u'MBMSUELinkingResponse',
        u'UnsuccessfulLinking-IEs',
        u'MBMSRegistrationRequest',
        u'MBMSRegistrationResponse',
        u'MBMSRegistrationFailure',
        u'MBMSCNDe-RegistrationRequest',
        u'MBMSCNDe-RegistrationResponse',
        u'MBMSRABEstablishmentIndication',
        u'MBMSRABReleaseRequest',
        u'MBMSRABRelease',
        u'MBMSRABReleaseFailure',
        u'SRVCC-CSKeysRequest',
        u'SRVCC-CSKeysResponse',
        u'UeRadioCapabilityMatchRequest',
        u'UeRadioCapabilityMatchResponse',
        u'UeRegistrationQueryRequest',
        u'UeRegistrationQueryResponse',
        u'RerouteNASRequest',
        ]
    _set_ = [
        u'Iu-ReleaseCommandIEs',
        u'Iu-ReleaseCommandExtensions',
        u'Iu-ReleaseCompleteIEs',
        u'RAB-DataVolumeReportItemIEs',
        u'RAB-DataVolumeReportItem-ExtIEs',
        u'RAB-ReleasedItem-IuRelComp-IEs',
        u'RAB-ReleasedItem-IuRelComp-ExtIEs',
        u'Iu-ReleaseCompleteExtensions',
        u'RelocationRequiredIEs',
        u'RelocationRequiredExtensions',
        u'RelocationCommandIEs',
        u'RAB-RelocationReleaseItemIEs',
        u'RAB-RelocationReleaseItem-ExtIEs',
        u'RAB-DataForwardingItemIEs',
        u'RAB-DataForwardingItem-ExtIEs',
        u'RelocationCommandExtensions',
        u'RelocationPreparationFailureIEs',
        u'RelocationPreparationFailureExtensions',
        u'RelocationRequestIEs',
        u'RAB-SetupItem-RelocReq-IEs',
        u'RAB-SetupItem-RelocReq-ExtIEs',
        u'UserPlaneInformation-ExtIEs',
        u'RelocationRequestExtensions',
        u'CNMBMSLinkingInformation-ExtIEs',
        u'JoinedMBMSBearerService-ExtIEs',
        u'RelocationRequestAcknowledgeIEs',
        u'RAB-SetupItem-RelocReqAck-IEs',
        u'RAB-SetupItem-RelocReqAck-ExtIEs',
        u'RAB-FailedItemIEs',
        u'RAB-FailedItem-ExtIEs',
        u'RelocationRequestAcknowledgeExtensions',
        u'RelocationFailureIEs',
        u'RelocationFailureExtensions',
        u'RelocationCancelIEs',
        u'RelocationCancelExtensions',
        u'RelocationCancelAcknowledgeIEs',
        u'RelocationCancelAcknowledgeExtensions',
        u'SRNS-ContextRequestIEs',
        u'RAB-DataForwardingItem-SRNS-CtxReq-IEs',
        u'RAB-DataForwardingItem-SRNS-CtxReq-ExtIEs',
        u'SRNS-ContextRequestExtensions',
        u'SRNS-ContextResponseIEs',
        u'RAB-ContextItemIEs',
        u'RAB-ContextItem-ExtIEs',
        u'RABs-ContextFailedtoTransferItemIEs',
        u'RABs-ContextFailedtoTransferItem-ExtIEs',
        u'SRNS-ContextResponseExtensions',
        u'SecurityModeCommandIEs',
        u'SecurityModeCommandExtensions',
        u'SecurityModeCompleteIEs',
        u'SecurityModeCompleteExtensions',
        u'SecurityModeRejectIEs',
        u'SecurityModeRejectExtensions',
        u'DataVolumeReportRequestIEs',
        u'RAB-DataVolumeReportRequestItemIEs',
        u'RAB-DataVolumeReportRequestItem-ExtIEs',
        u'DataVolumeReportRequestExtensions',
        u'DataVolumeReportIEs',
        u'DataVolumeReportExtensions',
        u'RABs-failed-to-reportItemIEs',
        u'RABs-failed-to-reportItem-ExtIEs',
        u'ResetIEs',
        u'ResetExtensions',
        u'ResetAcknowledgeIEs',
        u'ResetAcknowledgeExtensions',
        u'ResetResourceIEs',
        u'ResetResourceItemIEs',
        u'ResetResourceItem-ExtIEs',
        u'ResetResourceExtensions',
        u'ResetResourceAcknowledgeIEs',
        u'ResetResourceAckItemIEs',
        u'ResetResourceAckItem-ExtIEs',
        u'ResetResourceAcknowledgeExtensions',
        u'RAB-ReleaseRequestIEs',
        u'RAB-ReleaseItemIEs',
        u'RAB-ReleaseItem-ExtIEs',
        u'RAB-ReleaseRequestExtensions',
        u'Iu-ReleaseRequestIEs',
        u'Iu-ReleaseRequestExtensions',
        u'RelocationDetectIEs',
        u'RelocationDetectExtensions',
        u'RelocationCompleteIEs',
        u'RelocationCompleteExtensions',
        u'EnhancedRelocationCompleteRequestIEs',
        u'RAB-SetupItem-EnhancedRelocCompleteReq-IEs',
        u'RAB-SetupItem-EnhancedRelocCompleteReq-ExtIEs',
        u'EnhancedRelocationCompleteRequestExtensions',
        u'EnhancedRelocationCompleteResponseIEs',
        u'RAB-SetupItem-EnhancedRelocCompleteRes-IEs',
        u'RAB-SetupItem-EnhancedRelocCompleteRes-ExtIEs',
        u'RAB-ToBeReleasedItem-EnhancedRelocCompleteRes-IEs',
        u'RAB-ToBeReleasedItem-EnhancedRelocCompleteRes-ExtIEs',
        u'EnhancedRelocationCompleteResponseExtensions',
        u'EnhancedRelocationCompleteFailureIEs',
        u'EnhancedRelocationCompleteFailureExtensions',
        u'EnhancedRelocationCompleteConfirmIEs',
        u'EnhancedRelocationCompleteConfirmExtensions',
        u'PagingIEs',
        u'PagingExtensions',
        u'CommonID-IEs',
        u'CommonIDExtensions',
        u'CN-InvokeTraceIEs',
        u'CN-InvokeTraceExtensions',
        u'CN-DeactivateTraceIEs',
        u'CN-DeactivateTraceExtensions',
        u'LocationReportingControlIEs',
        u'LocationReportingControlExtensions',
        u'LocationReportIEs',
        u'LocationReportExtensions',
        u'InitialUE-MessageIEs',
        u'InitialUE-MessageExtensions',
        u'DirectTransferIEs',
        u'DirectTransferExtensions',
        u'RedirectionIndication-IEs',
        u'OverloadIEs',
        u'OverloadExtensions',
        u'ErrorIndicationIEs',
        u'ErrorIndicationExtensions',
        u'SRNS-DataForwardCommandIEs',
        u'SRNS-DataForwardCommandExtensions',
        u'ForwardSRNS-ContextIEs',
        u'ForwardSRNS-ContextExtensions',
        u'RAB-AssignmentRequestIEs',
        u'RAB-SetupOrModifyItem-IEs',
        u'TransportLayerInformation-ExtIEs',
        u'RAB-SetupOrModifyItemFirst-ExtIEs',
        u'RAB-SetupOrModifyItemSecond-ExtIEs',
        u'RAB-AssignmentRequestExtensions',
        u'RAB-AssignmentResponseIEs',
        u'RAB-SetupOrModifiedItemIEs',
        u'RAB-SetupOrModifiedItem-ExtIEs',
        u'RAB-ReleasedItemIEs',
        u'RAB-ReleasedItem-ExtIEs',
        u'DataVolumeList-ExtIEs',
        u'RAB-QueuedItemIEs',
        u'RAB-QueuedItem-ExtIEs',
        u'RAB-AssignmentResponseExtensions',
        u'GERAN-Iumode-RAB-Failed-RABAssgntResponse-ItemIEs',
        u'GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item-ExtIEs',
        u'PrivateMessage-IEs',
        u'RANAP-RelocationInformationIEs',
        u'DirectTransferInformationItemIEs-RANAP-RelocInf',
        u'RANAP-DirectTransferInformationItem-ExtIEs-RANAP-RelocInf',
        u'RAB-ContextItemIEs-RANAP-RelocInf',
        u'RAB-ContextItem-ExtIEs-RANAP-RelocInf',
        u'RANAP-RelocationInformationExtensions',
        u'RANAP-EnhancedRelocationInformationRequestIEs',
        u'RAB-SetupItem-EnhRelocInfoReq-IEs',
        u'RAB-SetupItem-EnhRelocInfoReq-ExtIEs',
        u'TNLInformationEnhRelInfoReq-ExtIEs',
        u'RANAP-EnhancedRelocationInformationRequestExtensions',
        u'RANAP-EnhancedRelocationInformationResponseIEs',
        u'RAB-SetupItem-EnhRelocInfoRes-IEs',
        u'RAB-SetupItem-EnhRelocInfoRes-ExtIEs',
        u'RAB-FailedItem-EnhRelocInfoRes-IEs',
        u'RAB-FailedItem-EnhRelocInfoRes-ExtIEs',
        u'TNLInformationEnhRelInfoRes-ExtIEs',
        u'RANAP-EnhancedRelocationInformationResponseExtensions',
        u'RAB-ModifyRequestIEs',
        u'RAB-ModifyItemIEs',
        u'RAB-ModifyItem-ExtIEs',
        u'RAB-ModifyRequestExtensions',
        u'LocationRelatedDataRequestIEs',
        u'LocationRelatedDataRequestExtensions',
        u'LocationRelatedDataResponseIEs',
        u'LocationRelatedDataResponseExtensions',
        u'LocationRelatedDataFailureIEs',
        u'LocationRelatedDataFailureExtensions',
        u'InformationTransferIndicationIEs',
        u'InformationTransferIndicationExtensions',
        u'InformationTransferConfirmationIEs',
        u'InformationTransferConfirmationExtensions',
        u'InformationTransferFailureIEs',
        u'InformationTransferFailureExtensions',
        u'UESpecificInformationIndicationIEs',
        u'UESpecificInformationIndicationExtensions',
        u'DirectInformationTransferIEs',
        u'DirectInformationTransferExtensions',
        u'UplinkInformationExchangeRequestIEs',
        u'UplinkInformationExchangeRequestExtensions',
        u'UplinkInformationExchangeResponseIEs',
        u'UplinkInformationExchangeResponseExtensions',
        u'UplinkInformationExchangeFailureIEs',
        u'UplinkInformationExchangeFailureExtensions',
        u'MBMSSessionStartIEs',
        u'MBMSSessionStartExtensions',
        u'MBMSSynchronisationInformation-ExtIEs',
        u'MBMSSessionStartResponseIEs',
        u'MBMSSessionStartResponseExtensions',
        u'MBMSSessionStartFailureIEs',
        u'MBMSSessionStartFailureExtensions',
        u'MBMSSessionUpdateIEs',
        u'MBMSSessionUpdateExtensions',
        u'MBMSSessionUpdateResponseIEs',
        u'MBMSSessionUpdateResponseExtensions',
        u'MBMSSessionUpdateFailureIEs',
        u'MBMSSessionUpdateFailureExtensions',
        u'MBMSSessionStopIEs',
        u'MBMSSessionStopExtensions',
        u'MBMSSessionStopResponseIEs',
        u'MBMSSessionStopResponseExtensions',
        u'MBMSUELinkingRequestIEs',
        u'LeftMBMSBearerService-ExtIEs',
        u'MBMSUELinkingRequestExtensions',
        u'MBMSUELinkingResponseIEs',
        u'UnsuccessfulLinking-ExtIEs',
        u'MBMSUELinkingResponseExtensions',
        u'MBMSRegistrationRequestIEs',
        u'MBMSRegistrationRequestExtensions',
        u'MBMSRegistrationResponseIEs',
        u'MBMSRegistrationResponseExtensions',
        u'MBMSRegistrationFailureIEs',
        u'MBMSRegistrationFailureExtensions',
        u'MBMSCNDe-RegistrationRequestIEs',
        u'MBMSCNDe-RegistrationRequestExtensions',
        u'MBMSCNDe-RegistrationResponseIEs',
        u'MBMSCNDe-RegistrationResponseExtensions',
        u'MBMSRABEstablishmentIndicationIEs',
        u'MBMSRABEstablishmentIndicationExtensions',
        u'MBMSRABReleaseRequestIEs',
        u'MBMSRABReleaseRequestExtensions',
        u'MBMSRABReleaseIEs',
        u'MBMSRABReleaseExtensions',
        u'MBMSRABReleaseFailureIEs',
        u'MBMSRABReleaseFailureExtensions',
        u'SRVCC-CSKeysRequestIEs',
        u'SRVCC-CSKeysRequestExtensions',
        u'SRVCC-CSKeysResponseIEs',
        u'SRVCC-CSKeysResponseExtensions',
        u'UeRadioCapabilityMatchRequestIEs',
        u'UeRadioCapabilityMatchRequestExtensions',
        u'UeRadioCapabilityMatchResponseIEs',
        u'UeRadioCapabilityMatchResponseExtensions',
        u'UeRegistrationQueryRequestIEs',
        u'UeRegistrationQueryRequestExtensions',
        u'UeRegistrationQueryResponseIEs',
        u'UeRegistrationQueryResponseExtensions',
        u'RerouteNASRequestIEs',
        u'RerouteNASRequestExtensions',
        ]
    _val_ = [
        ]
    _class_ = [
        u'Iu-ReleaseCommandIEs',
        u'Iu-ReleaseCommandExtensions',
        u'Iu-ReleaseCompleteIEs',
        u'RAB-DataVolumeReportItemIEs',
        u'RAB-DataVolumeReportItem-ExtIEs',
        u'RAB-ReleasedItem-IuRelComp-IEs',
        u'RAB-ReleasedItem-IuRelComp-ExtIEs',
        u'Iu-ReleaseCompleteExtensions',
        u'RelocationRequiredIEs',
        u'RelocationRequiredExtensions',
        u'RelocationCommandIEs',
        u'RAB-RelocationReleaseItemIEs',
        u'RAB-RelocationReleaseItem-ExtIEs',
        u'RAB-DataForwardingItemIEs',
        u'RAB-DataForwardingItem-ExtIEs',
        u'RelocationCommandExtensions',
        u'RelocationPreparationFailureIEs',
        u'RelocationPreparationFailureExtensions',
        u'RelocationRequestIEs',
        u'RAB-SetupItem-RelocReq-IEs',
        u'RAB-SetupItem-RelocReq-ExtIEs',
        u'UserPlaneInformation-ExtIEs',
        u'RelocationRequestExtensions',
        u'CNMBMSLinkingInformation-ExtIEs',
        u'JoinedMBMSBearerService-ExtIEs',
        u'RelocationRequestAcknowledgeIEs',
        u'RAB-SetupItem-RelocReqAck-IEs',
        u'RAB-SetupItem-RelocReqAck-ExtIEs',
        u'RAB-FailedItemIEs',
        u'RAB-FailedItem-ExtIEs',
        u'RelocationRequestAcknowledgeExtensions',
        u'RelocationFailureIEs',
        u'RelocationFailureExtensions',
        u'RelocationCancelIEs',
        u'RelocationCancelExtensions',
        u'RelocationCancelAcknowledgeIEs',
        u'RelocationCancelAcknowledgeExtensions',
        u'SRNS-ContextRequestIEs',
        u'RAB-DataForwardingItem-SRNS-CtxReq-IEs',
        u'RAB-DataForwardingItem-SRNS-CtxReq-ExtIEs',
        u'SRNS-ContextRequestExtensions',
        u'SRNS-ContextResponseIEs',
        u'RAB-ContextItemIEs',
        u'RAB-ContextItem-ExtIEs',
        u'RABs-ContextFailedtoTransferItemIEs',
        u'RABs-ContextFailedtoTransferItem-ExtIEs',
        u'SRNS-ContextResponseExtensions',
        u'SecurityModeCommandIEs',
        u'SecurityModeCommandExtensions',
        u'SecurityModeCompleteIEs',
        u'SecurityModeCompleteExtensions',
        u'SecurityModeRejectIEs',
        u'SecurityModeRejectExtensions',
        u'DataVolumeReportRequestIEs',
        u'RAB-DataVolumeReportRequestItemIEs',
        u'RAB-DataVolumeReportRequestItem-ExtIEs',
        u'DataVolumeReportRequestExtensions',
        u'DataVolumeReportIEs',
        u'DataVolumeReportExtensions',
        u'RABs-failed-to-reportItemIEs',
        u'RABs-failed-to-reportItem-ExtIEs',
        u'ResetIEs',
        u'ResetExtensions',
        u'ResetAcknowledgeIEs',
        u'ResetAcknowledgeExtensions',
        u'ResetResourceIEs',
        u'ResetResourceItemIEs',
        u'ResetResourceItem-ExtIEs',
        u'ResetResourceExtensions',
        u'ResetResourceAcknowledgeIEs',
        u'ResetResourceAckItemIEs',
        u'ResetResourceAckItem-ExtIEs',
        u'ResetResourceAcknowledgeExtensions',
        u'RAB-ReleaseRequestIEs',
        u'RAB-ReleaseItemIEs',
        u'RAB-ReleaseItem-ExtIEs',
        u'RAB-ReleaseRequestExtensions',
        u'Iu-ReleaseRequestIEs',
        u'Iu-ReleaseRequestExtensions',
        u'RelocationDetectIEs',
        u'RelocationDetectExtensions',
        u'RelocationCompleteIEs',
        u'RelocationCompleteExtensions',
        u'EnhancedRelocationCompleteRequestIEs',
        u'RAB-SetupItem-EnhancedRelocCompleteReq-IEs',
        u'RAB-SetupItem-EnhancedRelocCompleteReq-ExtIEs',
        u'EnhancedRelocationCompleteRequestExtensions',
        u'EnhancedRelocationCompleteResponseIEs',
        u'RAB-SetupItem-EnhancedRelocCompleteRes-IEs',
        u'RAB-SetupItem-EnhancedRelocCompleteRes-ExtIEs',
        u'RAB-ToBeReleasedItem-EnhancedRelocCompleteRes-IEs',
        u'RAB-ToBeReleasedItem-EnhancedRelocCompleteRes-ExtIEs',
        u'EnhancedRelocationCompleteResponseExtensions',
        u'EnhancedRelocationCompleteFailureIEs',
        u'EnhancedRelocationCompleteFailureExtensions',
        u'EnhancedRelocationCompleteConfirmIEs',
        u'EnhancedRelocationCompleteConfirmExtensions',
        u'PagingIEs',
        u'PagingExtensions',
        u'CommonID-IEs',
        u'CommonIDExtensions',
        u'CN-InvokeTraceIEs',
        u'CN-InvokeTraceExtensions',
        u'CN-DeactivateTraceIEs',
        u'CN-DeactivateTraceExtensions',
        u'LocationReportingControlIEs',
        u'LocationReportingControlExtensions',
        u'LocationReportIEs',
        u'LocationReportExtensions',
        u'InitialUE-MessageIEs',
        u'InitialUE-MessageExtensions',
        u'DirectTransferIEs',
        u'DirectTransferExtensions',
        u'RedirectionIndication-IEs',
        u'OverloadIEs',
        u'OverloadExtensions',
        u'ErrorIndicationIEs',
        u'ErrorIndicationExtensions',
        u'SRNS-DataForwardCommandIEs',
        u'SRNS-DataForwardCommandExtensions',
        u'ForwardSRNS-ContextIEs',
        u'ForwardSRNS-ContextExtensions',
        u'RAB-AssignmentRequestIEs',
        u'RAB-SetupOrModifyItem-IEs',
        u'TransportLayerInformation-ExtIEs',
        u'RAB-SetupOrModifyItemFirst-ExtIEs',
        u'RAB-SetupOrModifyItemSecond-ExtIEs',
        u'RAB-AssignmentRequestExtensions',
        u'RAB-AssignmentResponseIEs',
        u'RAB-SetupOrModifiedItemIEs',
        u'RAB-SetupOrModifiedItem-ExtIEs',
        u'RAB-ReleasedItemIEs',
        u'RAB-ReleasedItem-ExtIEs',
        u'DataVolumeList-ExtIEs',
        u'RAB-QueuedItemIEs',
        u'RAB-QueuedItem-ExtIEs',
        u'RAB-AssignmentResponseExtensions',
        u'GERAN-Iumode-RAB-Failed-RABAssgntResponse-ItemIEs',
        u'GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item-ExtIEs',
        u'PrivateMessage-IEs',
        u'RANAP-RelocationInformationIEs',
        u'DirectTransferInformationItemIEs-RANAP-RelocInf',
        u'RANAP-DirectTransferInformationItem-ExtIEs-RANAP-RelocInf',
        u'RAB-ContextItemIEs-RANAP-RelocInf',
        u'RAB-ContextItem-ExtIEs-RANAP-RelocInf',
        u'RANAP-RelocationInformationExtensions',
        u'RANAP-EnhancedRelocationInformationRequestIEs',
        u'RAB-SetupItem-EnhRelocInfoReq-IEs',
        u'RAB-SetupItem-EnhRelocInfoReq-ExtIEs',
        u'TNLInformationEnhRelInfoReq-ExtIEs',
        u'RANAP-EnhancedRelocationInformationRequestExtensions',
        u'RANAP-EnhancedRelocationInformationResponseIEs',
        u'RAB-SetupItem-EnhRelocInfoRes-IEs',
        u'RAB-SetupItem-EnhRelocInfoRes-ExtIEs',
        u'RAB-FailedItem-EnhRelocInfoRes-IEs',
        u'RAB-FailedItem-EnhRelocInfoRes-ExtIEs',
        u'TNLInformationEnhRelInfoRes-ExtIEs',
        u'RANAP-EnhancedRelocationInformationResponseExtensions',
        u'RAB-ModifyRequestIEs',
        u'RAB-ModifyItemIEs',
        u'RAB-ModifyItem-ExtIEs',
        u'RAB-ModifyRequestExtensions',
        u'LocationRelatedDataRequestIEs',
        u'LocationRelatedDataRequestExtensions',
        u'LocationRelatedDataResponseIEs',
        u'LocationRelatedDataResponseExtensions',
        u'LocationRelatedDataFailureIEs',
        u'LocationRelatedDataFailureExtensions',
        u'InformationTransferIndicationIEs',
        u'InformationTransferIndicationExtensions',
        u'InformationTransferConfirmationIEs',
        u'InformationTransferConfirmationExtensions',
        u'InformationTransferFailureIEs',
        u'InformationTransferFailureExtensions',
        u'UESpecificInformationIndicationIEs',
        u'UESpecificInformationIndicationExtensions',
        u'DirectInformationTransferIEs',
        u'DirectInformationTransferExtensions',
        u'UplinkInformationExchangeRequestIEs',
        u'UplinkInformationExchangeRequestExtensions',
        u'UplinkInformationExchangeResponseIEs',
        u'UplinkInformationExchangeResponseExtensions',
        u'UplinkInformationExchangeFailureIEs',
        u'UplinkInformationExchangeFailureExtensions',
        u'MBMSSessionStartIEs',
        u'MBMSSessionStartExtensions',
        u'MBMSSynchronisationInformation-ExtIEs',
        u'MBMSSessionStartResponseIEs',
        u'MBMSSessionStartResponseExtensions',
        u'MBMSSessionStartFailureIEs',
        u'MBMSSessionStartFailureExtensions',
        u'MBMSSessionUpdateIEs',
        u'MBMSSessionUpdateExtensions',
        u'MBMSSessionUpdateResponseIEs',
        u'MBMSSessionUpdateResponseExtensions',
        u'MBMSSessionUpdateFailureIEs',
        u'MBMSSessionUpdateFailureExtensions',
        u'MBMSSessionStopIEs',
        u'MBMSSessionStopExtensions',
        u'MBMSSessionStopResponseIEs',
        u'MBMSSessionStopResponseExtensions',
        u'MBMSUELinkingRequestIEs',
        u'LeftMBMSBearerService-ExtIEs',
        u'MBMSUELinkingRequestExtensions',
        u'MBMSUELinkingResponseIEs',
        u'UnsuccessfulLinking-ExtIEs',
        u'MBMSUELinkingResponseExtensions',
        u'MBMSRegistrationRequestIEs',
        u'MBMSRegistrationRequestExtensions',
        u'MBMSRegistrationResponseIEs',
        u'MBMSRegistrationResponseExtensions',
        u'MBMSRegistrationFailureIEs',
        u'MBMSRegistrationFailureExtensions',
        u'MBMSCNDe-RegistrationRequestIEs',
        u'MBMSCNDe-RegistrationRequestExtensions',
        u'MBMSCNDe-RegistrationResponseIEs',
        u'MBMSCNDe-RegistrationResponseExtensions',
        u'MBMSRABEstablishmentIndicationIEs',
        u'MBMSRABEstablishmentIndicationExtensions',
        u'MBMSRABReleaseRequestIEs',
        u'MBMSRABReleaseRequestExtensions',
        u'MBMSRABReleaseIEs',
        u'MBMSRABReleaseExtensions',
        u'MBMSRABReleaseFailureIEs',
        u'MBMSRABReleaseFailureExtensions',
        u'SRVCC-CSKeysRequestIEs',
        u'SRVCC-CSKeysRequestExtensions',
        u'SRVCC-CSKeysResponseIEs',
        u'SRVCC-CSKeysResponseExtensions',
        u'UeRadioCapabilityMatchRequestIEs',
        u'UeRadioCapabilityMatchRequestExtensions',
        u'UeRadioCapabilityMatchResponseIEs',
        u'UeRadioCapabilityMatchResponseExtensions',
        u'UeRegistrationQueryRequestIEs',
        u'UeRegistrationQueryRequestExtensions',
        u'UeRegistrationQueryResponseIEs',
        u'UeRegistrationQueryResponseExtensions',
        u'RerouteNASRequestIEs',
        u'RerouteNASRequestExtensions',
        ]
    _param_ = [
        u'RAB-IE-ContainerList',
        u'RAB-IE-ContainerPairList',
        u'ProtocolError-IE-ContainerList',
        u'IuSigConId-IE-ContainerList',
        u'DirectTransfer-IE-ContainerList',
        ]
    
    #-----< RAB-IE-ContainerList >-----#
    RAB_IE_ContainerList = SEQ_OF(name=u'RAB-IE-ContainerList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-ContainerList')), param=True)
    
    #-----< RAB-IE-ContainerPairList >-----#
    RAB_IE_ContainerPairList = SEQ_OF(name=u'RAB-IE-ContainerPairList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-ContainerPairList')), param=True)
    
    #-----< ProtocolError-IE-ContainerList >-----#
    ProtocolError_IE_ContainerList = SEQ_OF(name=u'ProtocolError-IE-ContainerList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-ContainerList')), param=True)
    
    #-----< IuSigConId-IE-ContainerList >-----#
    IuSigConId_IE_ContainerList = SEQ_OF(name=u'IuSigConId-IE-ContainerList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-ContainerList')), param=True)
    
    #-----< DirectTransfer-IE-ContainerList >-----#
    DirectTransfer_IE_ContainerList = SEQ_OF(name=u'DirectTransfer-IE-ContainerList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-ContainerList')), param=True)
    
    #-----< Iu-ReleaseCommand >-----#
    Iu_ReleaseCommand = SEQ(name=u'Iu-ReleaseCommand', mode=MODE_TYPE)
    _Iu_ReleaseCommand_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __Iu_ReleaseCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___Iu_ReleaseCommand_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____Iu_ReleaseCommand_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____Iu_ReleaseCommand_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    ____Iu_ReleaseCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____Iu_ReleaseCommand_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___Iu_ReleaseCommand_protocolIEs__item__id._const_tab = ____Iu_ReleaseCommand_protocolIEs__item__id_tab
    ___Iu_ReleaseCommand_protocolIEs__item__id._const_tab_at = None
    ___Iu_ReleaseCommand_protocolIEs__item__id._const_tab_id = u'id'
    ___Iu_ReleaseCommand_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___Iu_ReleaseCommand_protocolIEs__item__criticality._const_tab = ____Iu_ReleaseCommand_protocolIEs__item__id_tab
    ___Iu_ReleaseCommand_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___Iu_ReleaseCommand_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___Iu_ReleaseCommand_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___Iu_ReleaseCommand_protocolIEs__item__value._const_tab = ____Iu_ReleaseCommand_protocolIEs__item__id_tab
    ___Iu_ReleaseCommand_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___Iu_ReleaseCommand_protocolIEs__item__value._const_tab_id = u'Value'
    __Iu_ReleaseCommand_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___Iu_ReleaseCommand_protocolIEs__item__id),
        (u'criticality', ___Iu_ReleaseCommand_protocolIEs__item__criticality),
        (u'value', ___Iu_ReleaseCommand_protocolIEs__item__value),
        ])
    __Iu_ReleaseCommand_protocolIEs__item_._ext = None
    _Iu_ReleaseCommand_protocolIEs._cont = __Iu_ReleaseCommand_protocolIEs__item_
    _Iu_ReleaseCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _Iu_ReleaseCommand_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Iu_ReleaseCommand_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Iu_ReleaseCommand_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Iu_ReleaseCommand_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____Iu_ReleaseCommand_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'End-Of-CSFB')))
    _____Iu_ReleaseCommand_protocolExtensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Out-Of-UTRAN')))
    _____Iu_ReleaseCommand_protocolExtensions__item__id_tab_val_Extension_2 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    ____Iu_ReleaseCommand_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 252), (u'criticality', u'ignore'), (u'Extension', _____Iu_ReleaseCommand_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 254), (u'criticality', u'ignore'), (u'Extension', _____Iu_ReleaseCommand_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 277), (u'criticality', u'ignore'), (u'Extension', _____Iu_ReleaseCommand_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Iu_ReleaseCommand_protocolExtensions__item__id._const_tab = ____Iu_ReleaseCommand_protocolExtensions__item__id_tab
    ___Iu_ReleaseCommand_protocolExtensions__item__id._const_tab_at = None
    ___Iu_ReleaseCommand_protocolExtensions__item__id._const_tab_id = u'id'
    ___Iu_ReleaseCommand_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Iu_ReleaseCommand_protocolExtensions__item__criticality._const_tab = ____Iu_ReleaseCommand_protocolExtensions__item__id_tab
    ___Iu_ReleaseCommand_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___Iu_ReleaseCommand_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___Iu_ReleaseCommand_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Iu_ReleaseCommand_protocolExtensions__item__extensionValue._const_tab = ____Iu_ReleaseCommand_protocolExtensions__item__id_tab
    ___Iu_ReleaseCommand_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Iu_ReleaseCommand_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __Iu_ReleaseCommand_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___Iu_ReleaseCommand_protocolExtensions__item__id),
        (u'criticality', ___Iu_ReleaseCommand_protocolExtensions__item__criticality),
        (u'extensionValue', ___Iu_ReleaseCommand_protocolExtensions__item__extensionValue),
        ])
    __Iu_ReleaseCommand_protocolExtensions__item_._ext = None
    _Iu_ReleaseCommand_protocolExtensions._cont = __Iu_ReleaseCommand_protocolExtensions__item_
    _Iu_ReleaseCommand_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Iu_ReleaseCommand._cont = ASN1Dict([
        (u'protocolIEs', _Iu_ReleaseCommand_protocolIEs),
        (u'protocolExtensions', _Iu_ReleaseCommand_protocolExtensions),
        ])
    Iu_ReleaseCommand._ext = []
    
    #-----< Iu-ReleaseCommandIEs >-----#
    Iu_ReleaseCommandIEs = CLASS(name=u'Iu-ReleaseCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _Iu_ReleaseCommandIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    Iu_ReleaseCommandIEs._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _Iu_ReleaseCommandIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Iu-ReleaseCommandExtensions >-----#
    Iu_ReleaseCommandExtensions = CLASS(name=u'Iu-ReleaseCommandExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _Iu_ReleaseCommandExtensions_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'End-Of-CSFB')))
    _Iu_ReleaseCommandExtensions_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Out-Of-UTRAN')))
    _Iu_ReleaseCommandExtensions_val_Extension_2 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    Iu_ReleaseCommandExtensions._val = ASN1Set(rv=[dict([(u'id', 252), (u'criticality', u'ignore'), (u'Extension', _Iu_ReleaseCommandExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 254), (u'criticality', u'ignore'), (u'Extension', _Iu_ReleaseCommandExtensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 277), (u'criticality', u'ignore'), (u'Extension', _Iu_ReleaseCommandExtensions_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Iu-ReleaseComplete >-----#
    Iu_ReleaseComplete = SEQ(name=u'Iu-ReleaseComplete', mode=MODE_TYPE)
    _Iu_ReleaseComplete_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __Iu_ReleaseComplete_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___Iu_ReleaseComplete_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____Iu_ReleaseComplete_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____Iu_ReleaseComplete_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataVolumeReportList')))
    _____Iu_ReleaseComplete_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleasedList-IuRelComp')))
    _____Iu_ReleaseComplete_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____Iu_ReleaseComplete_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 31), (u'criticality', u'ignore'), (u'Value', _____Iu_ReleaseComplete_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 44), (u'criticality', u'ignore'), (u'Value', _____Iu_ReleaseComplete_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____Iu_ReleaseComplete_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Iu_ReleaseComplete_protocolIEs__item__id._const_tab = ____Iu_ReleaseComplete_protocolIEs__item__id_tab
    ___Iu_ReleaseComplete_protocolIEs__item__id._const_tab_at = None
    ___Iu_ReleaseComplete_protocolIEs__item__id._const_tab_id = u'id'
    ___Iu_ReleaseComplete_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___Iu_ReleaseComplete_protocolIEs__item__criticality._const_tab = ____Iu_ReleaseComplete_protocolIEs__item__id_tab
    ___Iu_ReleaseComplete_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___Iu_ReleaseComplete_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___Iu_ReleaseComplete_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___Iu_ReleaseComplete_protocolIEs__item__value._const_tab = ____Iu_ReleaseComplete_protocolIEs__item__id_tab
    ___Iu_ReleaseComplete_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___Iu_ReleaseComplete_protocolIEs__item__value._const_tab_id = u'Value'
    __Iu_ReleaseComplete_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___Iu_ReleaseComplete_protocolIEs__item__id),
        (u'criticality', ___Iu_ReleaseComplete_protocolIEs__item__criticality),
        (u'value', ___Iu_ReleaseComplete_protocolIEs__item__value),
        ])
    __Iu_ReleaseComplete_protocolIEs__item_._ext = None
    _Iu_ReleaseComplete_protocolIEs._cont = __Iu_ReleaseComplete_protocolIEs__item_
    _Iu_ReleaseComplete_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _Iu_ReleaseComplete_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Iu_ReleaseComplete_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Iu_ReleaseComplete_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Iu_ReleaseComplete_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Iu_ReleaseComplete_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Iu_ReleaseComplete_protocolExtensions__item__id._const_tab = ____Iu_ReleaseComplete_protocolExtensions__item__id_tab
    ___Iu_ReleaseComplete_protocolExtensions__item__id._const_tab_at = None
    ___Iu_ReleaseComplete_protocolExtensions__item__id._const_tab_id = u'id'
    ___Iu_ReleaseComplete_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Iu_ReleaseComplete_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Iu_ReleaseComplete_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Iu_ReleaseComplete_protocolExtensions__item__criticality._const_tab = ____Iu_ReleaseComplete_protocolExtensions__item__criticality_tab
    ___Iu_ReleaseComplete_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___Iu_ReleaseComplete_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___Iu_ReleaseComplete_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Iu_ReleaseComplete_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Iu_ReleaseComplete_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Iu_ReleaseComplete_protocolExtensions__item__extensionValue._const_tab = ____Iu_ReleaseComplete_protocolExtensions__item__extensionValue_tab
    ___Iu_ReleaseComplete_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Iu_ReleaseComplete_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __Iu_ReleaseComplete_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___Iu_ReleaseComplete_protocolExtensions__item__id),
        (u'criticality', ___Iu_ReleaseComplete_protocolExtensions__item__criticality),
        (u'extensionValue', ___Iu_ReleaseComplete_protocolExtensions__item__extensionValue),
        ])
    __Iu_ReleaseComplete_protocolExtensions__item_._ext = None
    _Iu_ReleaseComplete_protocolExtensions._cont = __Iu_ReleaseComplete_protocolExtensions__item_
    _Iu_ReleaseComplete_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Iu_ReleaseComplete._cont = ASN1Dict([
        (u'protocolIEs', _Iu_ReleaseComplete_protocolIEs),
        (u'protocolExtensions', _Iu_ReleaseComplete_protocolExtensions),
        ])
    Iu_ReleaseComplete._ext = []
    
    #-----< Iu-ReleaseCompleteIEs >-----#
    Iu_ReleaseCompleteIEs = CLASS(name=u'Iu-ReleaseCompleteIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _Iu_ReleaseCompleteIEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataVolumeReportList')))
    _Iu_ReleaseCompleteIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleasedList-IuRelComp')))
    _Iu_ReleaseCompleteIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    Iu_ReleaseCompleteIEs._val = ASN1Set(rv=[dict([(u'id', 31), (u'criticality', u'ignore'), (u'Value', _Iu_ReleaseCompleteIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 44), (u'criticality', u'ignore'), (u'Value', _Iu_ReleaseCompleteIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _Iu_ReleaseCompleteIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-DataVolumeReportList >-----#
    RAB_DataVolumeReportList = SEQ_OF(name=u'RAB-DataVolumeReportList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_DataVolumeReportList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_DataVolumeReportList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_DataVolumeReportList__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_DataVolumeReportList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_DataVolumeReportList__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataVolumeReportItem')))
    ____RAB_DataVolumeReportList__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 30), (u'criticality', u'ignore'), (u'Value', _____RAB_DataVolumeReportList__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_DataVolumeReportList__item___item__id._const_tab = ____RAB_DataVolumeReportList__item___item__id_tab
    ___RAB_DataVolumeReportList__item___item__id._const_tab_at = None
    ___RAB_DataVolumeReportList__item___item__id._const_tab_id = u'id'
    ___RAB_DataVolumeReportList__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_DataVolumeReportList__item___item__criticality._const_tab = ____RAB_DataVolumeReportList__item___item__id_tab
    ___RAB_DataVolumeReportList__item___item__criticality._const_tab_at = ('..', u'id')
    ___RAB_DataVolumeReportList__item___item__criticality._const_tab_id = u'criticality'
    ___RAB_DataVolumeReportList__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_DataVolumeReportList__item___item__value._const_tab = ____RAB_DataVolumeReportList__item___item__id_tab
    ___RAB_DataVolumeReportList__item___item__value._const_tab_at = ('..', u'id')
    ___RAB_DataVolumeReportList__item___item__value._const_tab_id = u'Value'
    __RAB_DataVolumeReportList__item___item_._cont = ASN1Dict([
        (u'id', ___RAB_DataVolumeReportList__item___item__id),
        (u'criticality', ___RAB_DataVolumeReportList__item___item__criticality),
        (u'value', ___RAB_DataVolumeReportList__item___item__value),
        ])
    __RAB_DataVolumeReportList__item___item_._ext = None
    _RAB_DataVolumeReportList__item_._cont = __RAB_DataVolumeReportList__item___item_
    _RAB_DataVolumeReportList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_DataVolumeReportList._cont = _RAB_DataVolumeReportList__item_
    RAB_DataVolumeReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-DataVolumeReportItemIEs >-----#
    RAB_DataVolumeReportItemIEs = CLASS(name=u'RAB-DataVolumeReportItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_DataVolumeReportItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataVolumeReportItem')))
    RAB_DataVolumeReportItemIEs._val = ASN1Set(rv=[dict([(u'id', 30), (u'criticality', u'ignore'), (u'Value', _RAB_DataVolumeReportItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-DataVolumeReportItem >-----#
    RAB_DataVolumeReportItem = SEQ(name=u'RAB-DataVolumeReportItem', mode=MODE_TYPE)
    _RAB_DataVolumeReportItem_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_DataVolumeReportItem_dl_UnsuccessfullyTransmittedDataVolume = SEQ_OF(name=u'dl-UnsuccessfullyTransmittedDataVolume', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeList')), opt=True)
    _RAB_DataVolumeReportItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_DataVolumeReportItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_DataVolumeReportItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_DataVolumeReportItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_DataVolumeReportItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_DataVolumeReportItem_iE_Extensions__item__id._const_tab = ____RAB_DataVolumeReportItem_iE_Extensions__item__id_tab
    ___RAB_DataVolumeReportItem_iE_Extensions__item__id._const_tab_at = None
    ___RAB_DataVolumeReportItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAB_DataVolumeReportItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RAB_DataVolumeReportItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_DataVolumeReportItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_DataVolumeReportItem_iE_Extensions__item__criticality._const_tab = ____RAB_DataVolumeReportItem_iE_Extensions__item__criticality_tab
    ___RAB_DataVolumeReportItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_DataVolumeReportItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_DataVolumeReportItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RAB_DataVolumeReportItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_DataVolumeReportItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_DataVolumeReportItem_iE_Extensions__item__extensionValue._const_tab = ____RAB_DataVolumeReportItem_iE_Extensions__item__extensionValue_tab
    ___RAB_DataVolumeReportItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_DataVolumeReportItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_DataVolumeReportItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_DataVolumeReportItem_iE_Extensions__item__id),
        (u'criticality', ___RAB_DataVolumeReportItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAB_DataVolumeReportItem_iE_Extensions__item__extensionValue),
        ])
    __RAB_DataVolumeReportItem_iE_Extensions__item_._ext = None
    _RAB_DataVolumeReportItem_iE_Extensions._cont = __RAB_DataVolumeReportItem_iE_Extensions__item_
    _RAB_DataVolumeReportItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_DataVolumeReportItem._cont = ASN1Dict([
        (u'rAB-ID', _RAB_DataVolumeReportItem_rAB_ID),
        (u'dl-UnsuccessfullyTransmittedDataVolume', _RAB_DataVolumeReportItem_dl_UnsuccessfullyTransmittedDataVolume),
        (u'iE-Extensions', _RAB_DataVolumeReportItem_iE_Extensions),
        ])
    RAB_DataVolumeReportItem._ext = []
    
    #-----< RAB-DataVolumeReportItem-ExtIEs >-----#
    RAB_DataVolumeReportItem_ExtIEs = CLASS(name=u'RAB-DataVolumeReportItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_DataVolumeReportItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-ReleasedList-IuRelComp >-----#
    RAB_ReleasedList_IuRelComp = SEQ_OF(name=u'RAB-ReleasedList-IuRelComp', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_ReleasedList_IuRelComp__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_ReleasedList_IuRelComp__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_ReleasedList_IuRelComp__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_ReleasedList_IuRelComp__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_ReleasedList_IuRelComp__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleasedItem-IuRelComp')))
    ____RAB_ReleasedList_IuRelComp__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 87), (u'criticality', u'ignore'), (u'Value', _____RAB_ReleasedList_IuRelComp__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_ReleasedList_IuRelComp__item___item__id._const_tab = ____RAB_ReleasedList_IuRelComp__item___item__id_tab
    ___RAB_ReleasedList_IuRelComp__item___item__id._const_tab_at = None
    ___RAB_ReleasedList_IuRelComp__item___item__id._const_tab_id = u'id'
    ___RAB_ReleasedList_IuRelComp__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_ReleasedList_IuRelComp__item___item__criticality._const_tab = ____RAB_ReleasedList_IuRelComp__item___item__id_tab
    ___RAB_ReleasedList_IuRelComp__item___item__criticality._const_tab_at = ('..', u'id')
    ___RAB_ReleasedList_IuRelComp__item___item__criticality._const_tab_id = u'criticality'
    ___RAB_ReleasedList_IuRelComp__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_ReleasedList_IuRelComp__item___item__value._const_tab = ____RAB_ReleasedList_IuRelComp__item___item__id_tab
    ___RAB_ReleasedList_IuRelComp__item___item__value._const_tab_at = ('..', u'id')
    ___RAB_ReleasedList_IuRelComp__item___item__value._const_tab_id = u'Value'
    __RAB_ReleasedList_IuRelComp__item___item_._cont = ASN1Dict([
        (u'id', ___RAB_ReleasedList_IuRelComp__item___item__id),
        (u'criticality', ___RAB_ReleasedList_IuRelComp__item___item__criticality),
        (u'value', ___RAB_ReleasedList_IuRelComp__item___item__value),
        ])
    __RAB_ReleasedList_IuRelComp__item___item_._ext = None
    _RAB_ReleasedList_IuRelComp__item_._cont = __RAB_ReleasedList_IuRelComp__item___item_
    _RAB_ReleasedList_IuRelComp__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_ReleasedList_IuRelComp._cont = _RAB_ReleasedList_IuRelComp__item_
    RAB_ReleasedList_IuRelComp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-ReleasedItem-IuRelComp-IEs >-----#
    RAB_ReleasedItem_IuRelComp_IEs = CLASS(name=u'RAB-ReleasedItem-IuRelComp-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_ReleasedItem_IuRelComp_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleasedItem-IuRelComp')))
    RAB_ReleasedItem_IuRelComp_IEs._val = ASN1Set(rv=[dict([(u'id', 87), (u'criticality', u'ignore'), (u'Value', _RAB_ReleasedItem_IuRelComp_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-ReleasedItem-IuRelComp >-----#
    RAB_ReleasedItem_IuRelComp = SEQ(name=u'RAB-ReleasedItem-IuRelComp', mode=MODE_TYPE)
    _RAB_ReleasedItem_IuRelComp_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_ReleasedItem_IuRelComp_dL_GTP_PDU_SequenceNumber = INT(name=u'dL-GTP-PDU-SequenceNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DL-GTP-PDU-SequenceNumber')), opt=True)
    _RAB_ReleasedItem_IuRelComp_uL_GTP_PDU_SequenceNumber = INT(name=u'uL-GTP-PDU-SequenceNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UL-GTP-PDU-SequenceNumber')), opt=True)
    _RAB_ReleasedItem_IuRelComp_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_ReleasedItem_IuRelComp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_ReleasedItem_IuRelComp_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ReleasedItem_IuRelComp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__id._const_tab = ____RAB_ReleasedItem_IuRelComp_iE_Extensions__item__id_tab
    ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__id._const_tab_at = None
    ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RAB_ReleasedItem_IuRelComp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ReleasedItem_IuRelComp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__criticality._const_tab = ____RAB_ReleasedItem_IuRelComp_iE_Extensions__item__criticality_tab
    ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RAB_ReleasedItem_IuRelComp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ReleasedItem_IuRelComp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__extensionValue._const_tab = ____RAB_ReleasedItem_IuRelComp_iE_Extensions__item__extensionValue_tab
    ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_ReleasedItem_IuRelComp_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__id),
        (u'criticality', ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__extensionValue),
        ])
    __RAB_ReleasedItem_IuRelComp_iE_Extensions__item_._ext = None
    _RAB_ReleasedItem_IuRelComp_iE_Extensions._cont = __RAB_ReleasedItem_IuRelComp_iE_Extensions__item_
    _RAB_ReleasedItem_IuRelComp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_ReleasedItem_IuRelComp._cont = ASN1Dict([
        (u'rAB-ID', _RAB_ReleasedItem_IuRelComp_rAB_ID),
        (u'dL-GTP-PDU-SequenceNumber', _RAB_ReleasedItem_IuRelComp_dL_GTP_PDU_SequenceNumber),
        (u'uL-GTP-PDU-SequenceNumber', _RAB_ReleasedItem_IuRelComp_uL_GTP_PDU_SequenceNumber),
        (u'iE-Extensions', _RAB_ReleasedItem_IuRelComp_iE_Extensions),
        ])
    RAB_ReleasedItem_IuRelComp._ext = []
    
    #-----< RAB-ReleasedItem-IuRelComp-ExtIEs >-----#
    RAB_ReleasedItem_IuRelComp_ExtIEs = CLASS(name=u'RAB-ReleasedItem-IuRelComp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_ReleasedItem_IuRelComp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Iu-ReleaseCompleteExtensions >-----#
    Iu_ReleaseCompleteExtensions = CLASS(name=u'Iu-ReleaseCompleteExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    Iu_ReleaseCompleteExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelocationRequired >-----#
    RelocationRequired = SEQ(name=u'RelocationRequired', mode=MODE_TYPE)
    _RelocationRequired_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RelocationRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RelocationRequired_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RelocationRequired_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RelocationRequired_protocolIEs__item__id_tab_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RelocationType')))
    _____RelocationRequired_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____RelocationRequired_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SourceID')))
    _____RelocationRequired_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TargetID')))
    _____RelocationRequired_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ClassmarkInformation2')))
    _____RelocationRequired_protocolIEs__item__id_tab_val_Value_5 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ClassmarkInformation3')))
    _____RelocationRequired_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Source-ToTarget-TransparentContainer')))
    _____RelocationRequired_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'OldBSS-ToNewBSS-Information')))
    ____RelocationRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 56), (u'criticality', u'reject'), (u'Value', _____RelocationRequired_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____RelocationRequired_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 60), (u'criticality', u'ignore'), (u'Value', _____RelocationRequired_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 62), (u'criticality', u'reject'), (u'Value', _____RelocationRequired_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'reject'), (u'Value', _____RelocationRequired_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'conditional')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____RelocationRequired_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'conditional')]), dict([(u'id', 61), (u'criticality', u'reject'), (u'Value', _____RelocationRequired_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'conditional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____RelocationRequired_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RelocationRequired_protocolIEs__item__id._const_tab = ____RelocationRequired_protocolIEs__item__id_tab
    ___RelocationRequired_protocolIEs__item__id._const_tab_at = None
    ___RelocationRequired_protocolIEs__item__id._const_tab_id = u'id'
    ___RelocationRequired_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RelocationRequired_protocolIEs__item__criticality._const_tab = ____RelocationRequired_protocolIEs__item__id_tab
    ___RelocationRequired_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RelocationRequired_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RelocationRequired_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RelocationRequired_protocolIEs__item__value._const_tab = ____RelocationRequired_protocolIEs__item__id_tab
    ___RelocationRequired_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RelocationRequired_protocolIEs__item__value._const_tab_id = u'Value'
    __RelocationRequired_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RelocationRequired_protocolIEs__item__id),
        (u'criticality', ___RelocationRequired_protocolIEs__item__criticality),
        (u'value', ___RelocationRequired_protocolIEs__item__value),
        ])
    __RelocationRequired_protocolIEs__item_._ext = None
    _RelocationRequired_protocolIEs._cont = __RelocationRequired_protocolIEs__item_
    _RelocationRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RelocationRequired_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelocationRequired_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RelocationRequired_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RelocationRequired_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GERAN-Classmark')))
    _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SourceBSS-ToTargetBSS-TransparentContainer')))
    _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRVCC-HO-Indication')))
    _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id')))
    _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cell-Access-Mode')))
    _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RSRVCC-HO-Indication')))
    _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-Application-Layer-Measurement-Configuration-For-Relocation')))
    ____RelocationRequired_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 108), (u'criticality', u'ignore'), (u'Extension', _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 161), (u'criticality', u'ignore'), (u'Extension', _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 226), (u'criticality', u'reject'), (u'Extension', _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 203), (u'criticality', u'reject'), (u'Extension', _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 235), (u'criticality', u'reject'), (u'Extension', _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 259), (u'criticality', u'reject'), (u'Extension', _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 293), (u'criticality', u'ignore'), (u'Extension', _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RelocationRequired_protocolExtensions__item__id._const_tab = ____RelocationRequired_protocolExtensions__item__id_tab
    ___RelocationRequired_protocolExtensions__item__id._const_tab_at = None
    ___RelocationRequired_protocolExtensions__item__id._const_tab_id = u'id'
    ___RelocationRequired_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RelocationRequired_protocolExtensions__item__criticality._const_tab = ____RelocationRequired_protocolExtensions__item__id_tab
    ___RelocationRequired_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RelocationRequired_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RelocationRequired_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RelocationRequired_protocolExtensions__item__extensionValue._const_tab = ____RelocationRequired_protocolExtensions__item__id_tab
    ___RelocationRequired_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RelocationRequired_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RelocationRequired_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RelocationRequired_protocolExtensions__item__id),
        (u'criticality', ___RelocationRequired_protocolExtensions__item__criticality),
        (u'extensionValue', ___RelocationRequired_protocolExtensions__item__extensionValue),
        ])
    __RelocationRequired_protocolExtensions__item_._ext = None
    _RelocationRequired_protocolExtensions._cont = __RelocationRequired_protocolExtensions__item_
    _RelocationRequired_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelocationRequired._cont = ASN1Dict([
        (u'protocolIEs', _RelocationRequired_protocolIEs),
        (u'protocolExtensions', _RelocationRequired_protocolExtensions),
        ])
    RelocationRequired._ext = []
    
    #-----< RelocationRequiredIEs >-----#
    RelocationRequiredIEs = CLASS(name=u'RelocationRequiredIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RelocationRequiredIEs_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RelocationType')))
    _RelocationRequiredIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _RelocationRequiredIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SourceID')))
    _RelocationRequiredIEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TargetID')))
    _RelocationRequiredIEs_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ClassmarkInformation2')))
    _RelocationRequiredIEs_val_Value_5 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ClassmarkInformation3')))
    _RelocationRequiredIEs_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Source-ToTarget-TransparentContainer')))
    _RelocationRequiredIEs_val_Value_7 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'OldBSS-ToNewBSS-Information')))
    RelocationRequiredIEs._val = ASN1Set(rv=[dict([(u'id', 56), (u'criticality', u'reject'), (u'Value', _RelocationRequiredIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _RelocationRequiredIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 60), (u'criticality', u'ignore'), (u'Value', _RelocationRequiredIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 62), (u'criticality', u'reject'), (u'Value', _RelocationRequiredIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'reject'), (u'Value', _RelocationRequiredIEs_val_Value_4), (u'presence', u'conditional')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _RelocationRequiredIEs_val_Value_5), (u'presence', u'conditional')]), dict([(u'id', 61), (u'criticality', u'reject'), (u'Value', _RelocationRequiredIEs_val_Value_6), (u'presence', u'conditional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _RelocationRequiredIEs_val_Value_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RelocationRequiredExtensions >-----#
    RelocationRequiredExtensions = CLASS(name=u'RelocationRequiredExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RelocationRequiredExtensions_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GERAN-Classmark')))
    _RelocationRequiredExtensions_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SourceBSS-ToTargetBSS-TransparentContainer')))
    _RelocationRequiredExtensions_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRVCC-HO-Indication')))
    _RelocationRequiredExtensions_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id')))
    _RelocationRequiredExtensions_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cell-Access-Mode')))
    _RelocationRequiredExtensions_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RSRVCC-HO-Indication')))
    _RelocationRequiredExtensions_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-Application-Layer-Measurement-Configuration-For-Relocation')))
    RelocationRequiredExtensions._val = ASN1Set(rv=[dict([(u'id', 108), (u'criticality', u'ignore'), (u'Extension', _RelocationRequiredExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 161), (u'criticality', u'ignore'), (u'Extension', _RelocationRequiredExtensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 226), (u'criticality', u'reject'), (u'Extension', _RelocationRequiredExtensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 203), (u'criticality', u'reject'), (u'Extension', _RelocationRequiredExtensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 235), (u'criticality', u'reject'), (u'Extension', _RelocationRequiredExtensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 259), (u'criticality', u'reject'), (u'Extension', _RelocationRequiredExtensions_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 293), (u'criticality', u'ignore'), (u'Extension', _RelocationRequiredExtensions_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RelocationCommand >-----#
    RelocationCommand = SEQ(name=u'RelocationCommand', mode=MODE_TYPE)
    _RelocationCommand_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RelocationCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RelocationCommand_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RelocationCommand_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RelocationCommand_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Target-ToSource-TransparentContainer')))
    _____RelocationCommand_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'L3-Information')))
    _____RelocationCommand_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-RelocationReleaseList')))
    _____RelocationCommand_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataForwardingList')))
    _____RelocationCommand_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____RelocationCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 63), (u'criticality', u'reject'), (u'Value', _____RelocationCommand_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 14), (u'criticality', u'ignore'), (u'Value', _____RelocationCommand_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 46), (u'criticality', u'ignore'), (u'Value', _____RelocationCommand_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 28), (u'criticality', u'ignore'), (u'Value', _____RelocationCommand_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____RelocationCommand_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RelocationCommand_protocolIEs__item__id._const_tab = ____RelocationCommand_protocolIEs__item__id_tab
    ___RelocationCommand_protocolIEs__item__id._const_tab_at = None
    ___RelocationCommand_protocolIEs__item__id._const_tab_id = u'id'
    ___RelocationCommand_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RelocationCommand_protocolIEs__item__criticality._const_tab = ____RelocationCommand_protocolIEs__item__id_tab
    ___RelocationCommand_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RelocationCommand_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RelocationCommand_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RelocationCommand_protocolIEs__item__value._const_tab = ____RelocationCommand_protocolIEs__item__id_tab
    ___RelocationCommand_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RelocationCommand_protocolIEs__item__value._const_tab_id = u'Value'
    __RelocationCommand_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RelocationCommand_protocolIEs__item__id),
        (u'criticality', ___RelocationCommand_protocolIEs__item__criticality),
        (u'value', ___RelocationCommand_protocolIEs__item__value),
        ])
    __RelocationCommand_protocolIEs__item_._ext = None
    _RelocationCommand_protocolIEs._cont = __RelocationCommand_protocolIEs__item_
    _RelocationCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RelocationCommand_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelocationCommand_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RelocationCommand_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RelocationCommand_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RelocationCommand_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InterSystemInformation-TransparentContainer')))
    _____RelocationCommand_protocolExtensions__item__id_tab_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TargetBSS-ToSourceBSS-TransparentContainer')))
    _____RelocationCommand_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRVCC-Information')))
    _____RelocationCommand_protocolExtensions__item__id_tab_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RSRVCC-Information')))
    ____RelocationCommand_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 99), (u'criticality', u'ignore'), (u'Extension', _____RelocationCommand_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 162), (u'criticality', u'ignore'), (u'Extension', _____RelocationCommand_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 227), (u'criticality', u'reject'), (u'Extension', _____RelocationCommand_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 260), (u'criticality', u'reject'), (u'Extension', _____RelocationCommand_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RelocationCommand_protocolExtensions__item__id._const_tab = ____RelocationCommand_protocolExtensions__item__id_tab
    ___RelocationCommand_protocolExtensions__item__id._const_tab_at = None
    ___RelocationCommand_protocolExtensions__item__id._const_tab_id = u'id'
    ___RelocationCommand_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RelocationCommand_protocolExtensions__item__criticality._const_tab = ____RelocationCommand_protocolExtensions__item__id_tab
    ___RelocationCommand_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RelocationCommand_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RelocationCommand_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RelocationCommand_protocolExtensions__item__extensionValue._const_tab = ____RelocationCommand_protocolExtensions__item__id_tab
    ___RelocationCommand_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RelocationCommand_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RelocationCommand_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RelocationCommand_protocolExtensions__item__id),
        (u'criticality', ___RelocationCommand_protocolExtensions__item__criticality),
        (u'extensionValue', ___RelocationCommand_protocolExtensions__item__extensionValue),
        ])
    __RelocationCommand_protocolExtensions__item_._ext = None
    _RelocationCommand_protocolExtensions._cont = __RelocationCommand_protocolExtensions__item_
    _RelocationCommand_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelocationCommand._cont = ASN1Dict([
        (u'protocolIEs', _RelocationCommand_protocolIEs),
        (u'protocolExtensions', _RelocationCommand_protocolExtensions),
        ])
    RelocationCommand._ext = []
    
    #-----< RelocationCommandIEs >-----#
    RelocationCommandIEs = CLASS(name=u'RelocationCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RelocationCommandIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Target-ToSource-TransparentContainer')))
    _RelocationCommandIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'L3-Information')))
    _RelocationCommandIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-RelocationReleaseList')))
    _RelocationCommandIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataForwardingList')))
    _RelocationCommandIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    RelocationCommandIEs._val = ASN1Set(rv=[dict([(u'id', 63), (u'criticality', u'reject'), (u'Value', _RelocationCommandIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 14), (u'criticality', u'ignore'), (u'Value', _RelocationCommandIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 46), (u'criticality', u'ignore'), (u'Value', _RelocationCommandIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 28), (u'criticality', u'ignore'), (u'Value', _RelocationCommandIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _RelocationCommandIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-RelocationReleaseList >-----#
    RAB_RelocationReleaseList = SEQ_OF(name=u'RAB-RelocationReleaseList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_RelocationReleaseList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_RelocationReleaseList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_RelocationReleaseList__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_RelocationReleaseList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_RelocationReleaseList__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-RelocationReleaseItem')))
    ____RAB_RelocationReleaseList__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 45), (u'criticality', u'ignore'), (u'Value', _____RAB_RelocationReleaseList__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_RelocationReleaseList__item___item__id._const_tab = ____RAB_RelocationReleaseList__item___item__id_tab
    ___RAB_RelocationReleaseList__item___item__id._const_tab_at = None
    ___RAB_RelocationReleaseList__item___item__id._const_tab_id = u'id'
    ___RAB_RelocationReleaseList__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_RelocationReleaseList__item___item__criticality._const_tab = ____RAB_RelocationReleaseList__item___item__id_tab
    ___RAB_RelocationReleaseList__item___item__criticality._const_tab_at = ('..', u'id')
    ___RAB_RelocationReleaseList__item___item__criticality._const_tab_id = u'criticality'
    ___RAB_RelocationReleaseList__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_RelocationReleaseList__item___item__value._const_tab = ____RAB_RelocationReleaseList__item___item__id_tab
    ___RAB_RelocationReleaseList__item___item__value._const_tab_at = ('..', u'id')
    ___RAB_RelocationReleaseList__item___item__value._const_tab_id = u'Value'
    __RAB_RelocationReleaseList__item___item_._cont = ASN1Dict([
        (u'id', ___RAB_RelocationReleaseList__item___item__id),
        (u'criticality', ___RAB_RelocationReleaseList__item___item__criticality),
        (u'value', ___RAB_RelocationReleaseList__item___item__value),
        ])
    __RAB_RelocationReleaseList__item___item_._ext = None
    _RAB_RelocationReleaseList__item_._cont = __RAB_RelocationReleaseList__item___item_
    _RAB_RelocationReleaseList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_RelocationReleaseList._cont = _RAB_RelocationReleaseList__item_
    RAB_RelocationReleaseList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-RelocationReleaseItemIEs >-----#
    RAB_RelocationReleaseItemIEs = CLASS(name=u'RAB-RelocationReleaseItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_RelocationReleaseItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-RelocationReleaseItem')))
    RAB_RelocationReleaseItemIEs._val = ASN1Set(rv=[dict([(u'id', 45), (u'criticality', u'ignore'), (u'Value', _RAB_RelocationReleaseItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-RelocationReleaseItem >-----#
    RAB_RelocationReleaseItem = SEQ(name=u'RAB-RelocationReleaseItem', mode=MODE_TYPE)
    _RAB_RelocationReleaseItem_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_RelocationReleaseItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_RelocationReleaseItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_RelocationReleaseItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_RelocationReleaseItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_RelocationReleaseItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_RelocationReleaseItem_iE_Extensions__item__id._const_tab = ____RAB_RelocationReleaseItem_iE_Extensions__item__id_tab
    ___RAB_RelocationReleaseItem_iE_Extensions__item__id._const_tab_at = None
    ___RAB_RelocationReleaseItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAB_RelocationReleaseItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RAB_RelocationReleaseItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_RelocationReleaseItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_RelocationReleaseItem_iE_Extensions__item__criticality._const_tab = ____RAB_RelocationReleaseItem_iE_Extensions__item__criticality_tab
    ___RAB_RelocationReleaseItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_RelocationReleaseItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_RelocationReleaseItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RAB_RelocationReleaseItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_RelocationReleaseItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_RelocationReleaseItem_iE_Extensions__item__extensionValue._const_tab = ____RAB_RelocationReleaseItem_iE_Extensions__item__extensionValue_tab
    ___RAB_RelocationReleaseItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_RelocationReleaseItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_RelocationReleaseItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_RelocationReleaseItem_iE_Extensions__item__id),
        (u'criticality', ___RAB_RelocationReleaseItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAB_RelocationReleaseItem_iE_Extensions__item__extensionValue),
        ])
    __RAB_RelocationReleaseItem_iE_Extensions__item_._ext = None
    _RAB_RelocationReleaseItem_iE_Extensions._cont = __RAB_RelocationReleaseItem_iE_Extensions__item_
    _RAB_RelocationReleaseItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_RelocationReleaseItem._cont = ASN1Dict([
        (u'rAB-ID', _RAB_RelocationReleaseItem_rAB_ID),
        (u'iE-Extensions', _RAB_RelocationReleaseItem_iE_Extensions),
        ])
    RAB_RelocationReleaseItem._ext = []
    
    #-----< RAB-RelocationReleaseItem-ExtIEs >-----#
    RAB_RelocationReleaseItem_ExtIEs = CLASS(name=u'RAB-RelocationReleaseItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_RelocationReleaseItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-DataForwardingList >-----#
    RAB_DataForwardingList = SEQ_OF(name=u'RAB-DataForwardingList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_DataForwardingList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_DataForwardingList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_DataForwardingList__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_DataForwardingList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_DataForwardingList__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataForwardingItem')))
    ____RAB_DataForwardingList__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _____RAB_DataForwardingList__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_DataForwardingList__item___item__id._const_tab = ____RAB_DataForwardingList__item___item__id_tab
    ___RAB_DataForwardingList__item___item__id._const_tab_at = None
    ___RAB_DataForwardingList__item___item__id._const_tab_id = u'id'
    ___RAB_DataForwardingList__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_DataForwardingList__item___item__criticality._const_tab = ____RAB_DataForwardingList__item___item__id_tab
    ___RAB_DataForwardingList__item___item__criticality._const_tab_at = ('..', u'id')
    ___RAB_DataForwardingList__item___item__criticality._const_tab_id = u'criticality'
    ___RAB_DataForwardingList__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_DataForwardingList__item___item__value._const_tab = ____RAB_DataForwardingList__item___item__id_tab
    ___RAB_DataForwardingList__item___item__value._const_tab_at = ('..', u'id')
    ___RAB_DataForwardingList__item___item__value._const_tab_id = u'Value'
    __RAB_DataForwardingList__item___item_._cont = ASN1Dict([
        (u'id', ___RAB_DataForwardingList__item___item__id),
        (u'criticality', ___RAB_DataForwardingList__item___item__criticality),
        (u'value', ___RAB_DataForwardingList__item___item__value),
        ])
    __RAB_DataForwardingList__item___item_._ext = None
    _RAB_DataForwardingList__item_._cont = __RAB_DataForwardingList__item___item_
    _RAB_DataForwardingList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_DataForwardingList._cont = _RAB_DataForwardingList__item_
    RAB_DataForwardingList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-DataForwardingItemIEs >-----#
    RAB_DataForwardingItemIEs = CLASS(name=u'RAB-DataForwardingItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_DataForwardingItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataForwardingItem')))
    RAB_DataForwardingItemIEs._val = ASN1Set(rv=[dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _RAB_DataForwardingItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-DataForwardingItem >-----#
    RAB_DataForwardingItem = SEQ(name=u'RAB-DataForwardingItem', mode=MODE_TYPE)
    _RAB_DataForwardingItem_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_DataForwardingItem_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _RAB_DataForwardingItem_iuTransportAssociation = CHOICE(name=u'iuTransportAssociation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IuTransportAssociation')))
    _RAB_DataForwardingItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_DataForwardingItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_DataForwardingItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_DataForwardingItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RAB_DataForwardingItem_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _____RAB_DataForwardingItem_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuTransportAssociation')))
    ____RAB_DataForwardingItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 67), (u'criticality', u'ignore'), (u'Extension', _____RAB_DataForwardingItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 13), (u'criticality', u'ignore'), (u'Extension', _____RAB_DataForwardingItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RAB_DataForwardingItem_iE_Extensions__item__id._const_tab = ____RAB_DataForwardingItem_iE_Extensions__item__id_tab
    ___RAB_DataForwardingItem_iE_Extensions__item__id._const_tab_at = None
    ___RAB_DataForwardingItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAB_DataForwardingItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RAB_DataForwardingItem_iE_Extensions__item__criticality._const_tab = ____RAB_DataForwardingItem_iE_Extensions__item__id_tab
    ___RAB_DataForwardingItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_DataForwardingItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_DataForwardingItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RAB_DataForwardingItem_iE_Extensions__item__extensionValue._const_tab = ____RAB_DataForwardingItem_iE_Extensions__item__id_tab
    ___RAB_DataForwardingItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_DataForwardingItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_DataForwardingItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_DataForwardingItem_iE_Extensions__item__id),
        (u'criticality', ___RAB_DataForwardingItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAB_DataForwardingItem_iE_Extensions__item__extensionValue),
        ])
    __RAB_DataForwardingItem_iE_Extensions__item_._ext = None
    _RAB_DataForwardingItem_iE_Extensions._cont = __RAB_DataForwardingItem_iE_Extensions__item_
    _RAB_DataForwardingItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_DataForwardingItem._cont = ASN1Dict([
        (u'rAB-ID', _RAB_DataForwardingItem_rAB_ID),
        (u'transportLayerAddress', _RAB_DataForwardingItem_transportLayerAddress),
        (u'iuTransportAssociation', _RAB_DataForwardingItem_iuTransportAssociation),
        (u'iE-Extensions', _RAB_DataForwardingItem_iE_Extensions),
        ])
    RAB_DataForwardingItem._ext = []
    
    #-----< RAB-DataForwardingItem-ExtIEs >-----#
    RAB_DataForwardingItem_ExtIEs = CLASS(name=u'RAB-DataForwardingItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RAB_DataForwardingItem_ExtIEs_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _RAB_DataForwardingItem_ExtIEs_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuTransportAssociation')))
    RAB_DataForwardingItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 67), (u'criticality', u'ignore'), (u'Extension', _RAB_DataForwardingItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 13), (u'criticality', u'ignore'), (u'Extension', _RAB_DataForwardingItem_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RelocationCommandExtensions >-----#
    RelocationCommandExtensions = CLASS(name=u'RelocationCommandExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RelocationCommandExtensions_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InterSystemInformation-TransparentContainer')))
    _RelocationCommandExtensions_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TargetBSS-ToSourceBSS-TransparentContainer')))
    _RelocationCommandExtensions_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRVCC-Information')))
    _RelocationCommandExtensions_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RSRVCC-Information')))
    RelocationCommandExtensions._val = ASN1Set(rv=[dict([(u'id', 99), (u'criticality', u'ignore'), (u'Extension', _RelocationCommandExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 162), (u'criticality', u'ignore'), (u'Extension', _RelocationCommandExtensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 227), (u'criticality', u'reject'), (u'Extension', _RelocationCommandExtensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 260), (u'criticality', u'reject'), (u'Extension', _RelocationCommandExtensions_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RelocationPreparationFailure >-----#
    RelocationPreparationFailure = SEQ(name=u'RelocationPreparationFailure', mode=MODE_TYPE)
    _RelocationPreparationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RelocationPreparationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RelocationPreparationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RelocationPreparationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RelocationPreparationFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____RelocationPreparationFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____RelocationPreparationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____RelocationPreparationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____RelocationPreparationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RelocationPreparationFailure_protocolIEs__item__id._const_tab = ____RelocationPreparationFailure_protocolIEs__item__id_tab
    ___RelocationPreparationFailure_protocolIEs__item__id._const_tab_at = None
    ___RelocationPreparationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___RelocationPreparationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RelocationPreparationFailure_protocolIEs__item__criticality._const_tab = ____RelocationPreparationFailure_protocolIEs__item__id_tab
    ___RelocationPreparationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RelocationPreparationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RelocationPreparationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RelocationPreparationFailure_protocolIEs__item__value._const_tab = ____RelocationPreparationFailure_protocolIEs__item__id_tab
    ___RelocationPreparationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RelocationPreparationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __RelocationPreparationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RelocationPreparationFailure_protocolIEs__item__id),
        (u'criticality', ___RelocationPreparationFailure_protocolIEs__item__criticality),
        (u'value', ___RelocationPreparationFailure_protocolIEs__item__value),
        ])
    __RelocationPreparationFailure_protocolIEs__item_._ext = None
    _RelocationPreparationFailure_protocolIEs._cont = __RelocationPreparationFailure_protocolIEs__item_
    _RelocationPreparationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RelocationPreparationFailure_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelocationPreparationFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RelocationPreparationFailure_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RelocationPreparationFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RelocationPreparationFailure_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InterSystemInformation-TransparentContainer')))
    ____RelocationPreparationFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 99), (u'criticality', u'ignore'), (u'Extension', _____RelocationPreparationFailure_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RelocationPreparationFailure_protocolExtensions__item__id._const_tab = ____RelocationPreparationFailure_protocolExtensions__item__id_tab
    ___RelocationPreparationFailure_protocolExtensions__item__id._const_tab_at = None
    ___RelocationPreparationFailure_protocolExtensions__item__id._const_tab_id = u'id'
    ___RelocationPreparationFailure_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RelocationPreparationFailure_protocolExtensions__item__criticality._const_tab = ____RelocationPreparationFailure_protocolExtensions__item__id_tab
    ___RelocationPreparationFailure_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RelocationPreparationFailure_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RelocationPreparationFailure_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RelocationPreparationFailure_protocolExtensions__item__extensionValue._const_tab = ____RelocationPreparationFailure_protocolExtensions__item__id_tab
    ___RelocationPreparationFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RelocationPreparationFailure_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RelocationPreparationFailure_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RelocationPreparationFailure_protocolExtensions__item__id),
        (u'criticality', ___RelocationPreparationFailure_protocolExtensions__item__criticality),
        (u'extensionValue', ___RelocationPreparationFailure_protocolExtensions__item__extensionValue),
        ])
    __RelocationPreparationFailure_protocolExtensions__item_._ext = None
    _RelocationPreparationFailure_protocolExtensions._cont = __RelocationPreparationFailure_protocolExtensions__item_
    _RelocationPreparationFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelocationPreparationFailure._cont = ASN1Dict([
        (u'protocolIEs', _RelocationPreparationFailure_protocolIEs),
        (u'protocolExtensions', _RelocationPreparationFailure_protocolExtensions),
        ])
    RelocationPreparationFailure._ext = []
    
    #-----< RelocationPreparationFailureIEs >-----#
    RelocationPreparationFailureIEs = CLASS(name=u'RelocationPreparationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RelocationPreparationFailureIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _RelocationPreparationFailureIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    RelocationPreparationFailureIEs._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _RelocationPreparationFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _RelocationPreparationFailureIEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RelocationPreparationFailureExtensions >-----#
    RelocationPreparationFailureExtensions = CLASS(name=u'RelocationPreparationFailureExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RelocationPreparationFailureExtensions_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InterSystemInformation-TransparentContainer')))
    RelocationPreparationFailureExtensions._val = ASN1Set(rv=[dict([(u'id', 99), (u'criticality', u'ignore'), (u'Extension', _RelocationPreparationFailureExtensions_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RelocationRequest >-----#
    RelocationRequest = SEQ(name=u'RelocationRequest', mode=MODE_TYPE)
    _RelocationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RelocationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RelocationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RelocationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RelocationRequest_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    _____RelocationRequest_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____RelocationRequest_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____RelocationRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SourceRNC-ToTargetRNC-TransparentContainer')))
    _____RelocationRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupList-RelocReq')))
    _____RelocationRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IntegrityProtectionInformation')))
    _____RelocationRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'EncryptionInformation')))
    _____RelocationRequest_protocolIEs__item__id_tab_val_Value_7 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    ____RelocationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 23), (u'criticality', u'ignore'), (u'Value', _____RelocationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____RelocationRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 3), (u'criticality', u'reject'), (u'Value', _____RelocationRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 61), (u'criticality', u'reject'), (u'Value', _____RelocationRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 49), (u'criticality', u'reject'), (u'Value', _____RelocationRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 12), (u'criticality', u'ignore'), (u'Value', _____RelocationRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _____RelocationRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 79), (u'criticality', u'ignore'), (u'Value', _____RelocationRequest_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RelocationRequest_protocolIEs__item__id._const_tab = ____RelocationRequest_protocolIEs__item__id_tab
    ___RelocationRequest_protocolIEs__item__id._const_tab_at = None
    ___RelocationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___RelocationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RelocationRequest_protocolIEs__item__criticality._const_tab = ____RelocationRequest_protocolIEs__item__id_tab
    ___RelocationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RelocationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RelocationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RelocationRequest_protocolIEs__item__value._const_tab = ____RelocationRequest_protocolIEs__item__id_tab
    ___RelocationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RelocationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __RelocationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RelocationRequest_protocolIEs__item__id),
        (u'criticality', ___RelocationRequest_protocolIEs__item__criticality),
        (u'value', ___RelocationRequest_protocolIEs__item__value),
        ])
    __RelocationRequest_protocolIEs__item_._ext = None
    _RelocationRequest_protocolIEs._cont = __RelocationRequest_protocolIEs__item_
    _RelocationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RelocationRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelocationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RelocationRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RelocationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SNA-Access-Information')))
    _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UESBI-Iu')))
    _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_3 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CNMBMSLinkingInformation')))
    _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-AggregateMaximumBitRate')))
    _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_6 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id')))
    _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_7 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Membership-Status')))
    _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_8 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MSISDN')))
    _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_9 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_10 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PowerSavingIndicator')))
    _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_11 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-Application-Layer-Measurement-Configuration-For-Relocation')))
    ____RelocationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 96), (u'criticality', u'reject'), (u'Extension', _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 105), (u'criticality', u'ignore'), (u'Extension', _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 118), (u'criticality', u'ignore'), (u'Extension', _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 127), (u'criticality', u'ignore'), (u'Extension', _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 133), (u'criticality', u'ignore'), (u'Extension', _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 233), (u'criticality', u'ignore'), (u'Extension', _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 203), (u'criticality', u'reject'), (u'Extension', _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 234), (u'criticality', u'ignore'), (u'Extension', _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 239), (u'criticality', u'ignore'), (u'Extension', _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 261), (u'criticality', u'ignore'), (u'Extension', _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 289), (u'criticality', u'ignore'), (u'Extension', _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 293), (u'criticality', u'ignore'), (u'Extension', _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_11), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RelocationRequest_protocolExtensions__item__id._const_tab = ____RelocationRequest_protocolExtensions__item__id_tab
    ___RelocationRequest_protocolExtensions__item__id._const_tab_at = None
    ___RelocationRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___RelocationRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RelocationRequest_protocolExtensions__item__criticality._const_tab = ____RelocationRequest_protocolExtensions__item__id_tab
    ___RelocationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RelocationRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RelocationRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RelocationRequest_protocolExtensions__item__extensionValue._const_tab = ____RelocationRequest_protocolExtensions__item__id_tab
    ___RelocationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RelocationRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RelocationRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RelocationRequest_protocolExtensions__item__id),
        (u'criticality', ___RelocationRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___RelocationRequest_protocolExtensions__item__extensionValue),
        ])
    __RelocationRequest_protocolExtensions__item_._ext = None
    _RelocationRequest_protocolExtensions._cont = __RelocationRequest_protocolExtensions__item_
    _RelocationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelocationRequest._cont = ASN1Dict([
        (u'protocolIEs', _RelocationRequest_protocolIEs),
        (u'protocolExtensions', _RelocationRequest_protocolExtensions),
        ])
    RelocationRequest._ext = []
    
    #-----< RelocationRequestIEs >-----#
    RelocationRequestIEs = CLASS(name=u'RelocationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RelocationRequestIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    _RelocationRequestIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _RelocationRequestIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _RelocationRequestIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SourceRNC-ToTargetRNC-TransparentContainer')))
    _RelocationRequestIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupList-RelocReq')))
    _RelocationRequestIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IntegrityProtectionInformation')))
    _RelocationRequestIEs_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'EncryptionInformation')))
    _RelocationRequestIEs_val_Value_7 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    RelocationRequestIEs._val = ASN1Set(rv=[dict([(u'id', 23), (u'criticality', u'ignore'), (u'Value', _RelocationRequestIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _RelocationRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 3), (u'criticality', u'reject'), (u'Value', _RelocationRequestIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 61), (u'criticality', u'reject'), (u'Value', _RelocationRequestIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 49), (u'criticality', u'reject'), (u'Value', _RelocationRequestIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 12), (u'criticality', u'ignore'), (u'Value', _RelocationRequestIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _RelocationRequestIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 79), (u'criticality', u'ignore'), (u'Value', _RelocationRequestIEs_val_Value_7), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupList-RelocReq >-----#
    RAB_SetupList_RelocReq = SEQ_OF(name=u'RAB-SetupList-RelocReq', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_SetupList_RelocReq__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_SetupList_RelocReq__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_SetupList_RelocReq__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_SetupList_RelocReq__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_SetupList_RelocReq__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupItem-RelocReq')))
    ____RAB_SetupList_RelocReq__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 47), (u'criticality', u'reject'), (u'Value', _____RAB_SetupList_RelocReq__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_SetupList_RelocReq__item___item__id._const_tab = ____RAB_SetupList_RelocReq__item___item__id_tab
    ___RAB_SetupList_RelocReq__item___item__id._const_tab_at = None
    ___RAB_SetupList_RelocReq__item___item__id._const_tab_id = u'id'
    ___RAB_SetupList_RelocReq__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_SetupList_RelocReq__item___item__criticality._const_tab = ____RAB_SetupList_RelocReq__item___item__id_tab
    ___RAB_SetupList_RelocReq__item___item__criticality._const_tab_at = ('..', u'id')
    ___RAB_SetupList_RelocReq__item___item__criticality._const_tab_id = u'criticality'
    ___RAB_SetupList_RelocReq__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_SetupList_RelocReq__item___item__value._const_tab = ____RAB_SetupList_RelocReq__item___item__id_tab
    ___RAB_SetupList_RelocReq__item___item__value._const_tab_at = ('..', u'id')
    ___RAB_SetupList_RelocReq__item___item__value._const_tab_id = u'Value'
    __RAB_SetupList_RelocReq__item___item_._cont = ASN1Dict([
        (u'id', ___RAB_SetupList_RelocReq__item___item__id),
        (u'criticality', ___RAB_SetupList_RelocReq__item___item__criticality),
        (u'value', ___RAB_SetupList_RelocReq__item___item__value),
        ])
    __RAB_SetupList_RelocReq__item___item_._ext = None
    _RAB_SetupList_RelocReq__item_._cont = __RAB_SetupList_RelocReq__item___item_
    _RAB_SetupList_RelocReq__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_SetupList_RelocReq._cont = _RAB_SetupList_RelocReq__item_
    RAB_SetupList_RelocReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-SetupItem-RelocReq-IEs >-----#
    RAB_SetupItem_RelocReq_IEs = CLASS(name=u'RAB-SetupItem-RelocReq-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_SetupItem_RelocReq_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupItem-RelocReq')))
    RAB_SetupItem_RelocReq_IEs._val = ASN1Set(rv=[dict([(u'id', 47), (u'criticality', u'reject'), (u'Value', _RAB_SetupItem_RelocReq_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupItem-RelocReq >-----#
    RAB_SetupItem_RelocReq = SEQ(name=u'RAB-SetupItem-RelocReq', mode=MODE_TYPE)
    _RAB_SetupItem_RelocReq_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_SetupItem_RelocReq_nAS_SynchronisationIndicator = BIT_STR(name=u'nAS-SynchronisationIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'NAS-SynchronisationIndicator')), opt=True)
    _RAB_SetupItem_RelocReq_rAB_Parameters = SEQ(name=u'rAB-Parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameters')))
    _RAB_SetupItem_RelocReq_dataVolumeReportingIndication = ENUM(name=u'dataVolumeReportingIndication', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DataVolumeReportingIndication')), opt=True)
    _RAB_SetupItem_RelocReq_pDP_TypeInformation = SEQ_OF(name=u'pDP-TypeInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PDP-TypeInformation')), opt=True)
    _RAB_SetupItem_RelocReq_userPlaneInformation = SEQ(name=u'userPlaneInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Contents', 'UserPlaneInformation')))
    _RAB_SetupItem_RelocReq_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _RAB_SetupItem_RelocReq_iuTransportAssociation = CHOICE(name=u'iuTransportAssociation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IuTransportAssociation')))
    _RAB_SetupItem_RelocReq_service_Handover = ENUM(name=u'service-Handover', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Service-Handover')), opt=True)
    _RAB_SetupItem_RelocReq_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_SetupItem_RelocReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_SetupItem_RelocReq_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameters')))
    _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GERAN-BSC-Container')))
    _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'E-UTRAN-Service-Handover')))
    _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PDP-TypeInformation-extension')))
    _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Offload-RAB-Parameters')))
    ____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 89), (u'criticality', u'ignore'), (u'Extension', _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 107), (u'criticality', u'ignore'), (u'Extension', _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 231), (u'criticality', u'ignore'), (u'Extension', _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 238), (u'criticality', u'ignore'), (u'Extension', _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 240), (u'criticality', u'ignore'), (u'Extension', _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RAB_SetupItem_RelocReq_iE_Extensions__item__id._const_tab = ____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab
    ___RAB_SetupItem_RelocReq_iE_Extensions__item__id._const_tab_at = None
    ___RAB_SetupItem_RelocReq_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAB_SetupItem_RelocReq_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RAB_SetupItem_RelocReq_iE_Extensions__item__criticality._const_tab = ____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab
    ___RAB_SetupItem_RelocReq_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_SetupItem_RelocReq_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_SetupItem_RelocReq_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RAB_SetupItem_RelocReq_iE_Extensions__item__extensionValue._const_tab = ____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab
    ___RAB_SetupItem_RelocReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_SetupItem_RelocReq_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_SetupItem_RelocReq_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_SetupItem_RelocReq_iE_Extensions__item__id),
        (u'criticality', ___RAB_SetupItem_RelocReq_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAB_SetupItem_RelocReq_iE_Extensions__item__extensionValue),
        ])
    __RAB_SetupItem_RelocReq_iE_Extensions__item_._ext = None
    _RAB_SetupItem_RelocReq_iE_Extensions._cont = __RAB_SetupItem_RelocReq_iE_Extensions__item_
    _RAB_SetupItem_RelocReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_SetupItem_RelocReq._cont = ASN1Dict([
        (u'rAB-ID', _RAB_SetupItem_RelocReq_rAB_ID),
        (u'nAS-SynchronisationIndicator', _RAB_SetupItem_RelocReq_nAS_SynchronisationIndicator),
        (u'rAB-Parameters', _RAB_SetupItem_RelocReq_rAB_Parameters),
        (u'dataVolumeReportingIndication', _RAB_SetupItem_RelocReq_dataVolumeReportingIndication),
        (u'pDP-TypeInformation', _RAB_SetupItem_RelocReq_pDP_TypeInformation),
        (u'userPlaneInformation', _RAB_SetupItem_RelocReq_userPlaneInformation),
        (u'transportLayerAddress', _RAB_SetupItem_RelocReq_transportLayerAddress),
        (u'iuTransportAssociation', _RAB_SetupItem_RelocReq_iuTransportAssociation),
        (u'service-Handover', _RAB_SetupItem_RelocReq_service_Handover),
        (u'iE-Extensions', _RAB_SetupItem_RelocReq_iE_Extensions),
        ])
    RAB_SetupItem_RelocReq._ext = []
    
    #-----< RAB-SetupItem-RelocReq-ExtIEs >-----#
    RAB_SetupItem_RelocReq_ExtIEs = CLASS(name=u'RAB-SetupItem-RelocReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameters')))
    _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GERAN-BSC-Container')))
    _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'E-UTRAN-Service-Handover')))
    _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PDP-TypeInformation-extension')))
    _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Offload-RAB-Parameters')))
    RAB_SetupItem_RelocReq_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 89), (u'criticality', u'ignore'), (u'Extension', _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 107), (u'criticality', u'ignore'), (u'Extension', _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 231), (u'criticality', u'ignore'), (u'Extension', _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 238), (u'criticality', u'ignore'), (u'Extension', _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 240), (u'criticality', u'ignore'), (u'Extension', _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UserPlaneInformation >-----#
    UserPlaneInformation = SEQ(name=u'UserPlaneInformation', mode=MODE_TYPE)
    _UserPlaneInformation_userPlaneMode = ENUM(name=u'userPlaneMode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UserPlaneMode')))
    _UserPlaneInformation_uP_ModeVersions = BIT_STR(name=u'uP-ModeVersions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UP-ModeVersions')))
    _UserPlaneInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UserPlaneInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UserPlaneInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UserPlaneInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UserPlaneInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserPlaneInformation_iE_Extensions__item__id._const_tab = ____UserPlaneInformation_iE_Extensions__item__id_tab
    ___UserPlaneInformation_iE_Extensions__item__id._const_tab_at = None
    ___UserPlaneInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___UserPlaneInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UserPlaneInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UserPlaneInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserPlaneInformation_iE_Extensions__item__criticality._const_tab = ____UserPlaneInformation_iE_Extensions__item__criticality_tab
    ___UserPlaneInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UserPlaneInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UserPlaneInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UserPlaneInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UserPlaneInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserPlaneInformation_iE_Extensions__item__extensionValue._const_tab = ____UserPlaneInformation_iE_Extensions__item__extensionValue_tab
    ___UserPlaneInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UserPlaneInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UserPlaneInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UserPlaneInformation_iE_Extensions__item__id),
        (u'criticality', ___UserPlaneInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___UserPlaneInformation_iE_Extensions__item__extensionValue),
        ])
    __UserPlaneInformation_iE_Extensions__item_._ext = None
    _UserPlaneInformation_iE_Extensions._cont = __UserPlaneInformation_iE_Extensions__item_
    _UserPlaneInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UserPlaneInformation._cont = ASN1Dict([
        (u'userPlaneMode', _UserPlaneInformation_userPlaneMode),
        (u'uP-ModeVersions', _UserPlaneInformation_uP_ModeVersions),
        (u'iE-Extensions', _UserPlaneInformation_iE_Extensions),
        ])
    UserPlaneInformation._ext = []
    
    #-----< UserPlaneInformation-ExtIEs >-----#
    UserPlaneInformation_ExtIEs = CLASS(name=u'UserPlaneInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    UserPlaneInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelocationRequestExtensions >-----#
    RelocationRequestExtensions = CLASS(name=u'RelocationRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RelocationRequestExtensions_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _RelocationRequestExtensions_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SNA-Access-Information')))
    _RelocationRequestExtensions_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UESBI-Iu')))
    _RelocationRequestExtensions_val_Extension_3 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _RelocationRequestExtensions_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CNMBMSLinkingInformation')))
    _RelocationRequestExtensions_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-AggregateMaximumBitRate')))
    _RelocationRequestExtensions_val_Extension_6 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id')))
    _RelocationRequestExtensions_val_Extension_7 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Membership-Status')))
    _RelocationRequestExtensions_val_Extension_8 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MSISDN')))
    _RelocationRequestExtensions_val_Extension_9 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _RelocationRequestExtensions_val_Extension_10 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PowerSavingIndicator')))
    _RelocationRequestExtensions_val_Extension_11 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-Application-Layer-Measurement-Configuration-For-Relocation')))
    RelocationRequestExtensions._val = ASN1Set(rv=[dict([(u'id', 96), (u'criticality', u'reject'), (u'Extension', _RelocationRequestExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 105), (u'criticality', u'ignore'), (u'Extension', _RelocationRequestExtensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 118), (u'criticality', u'ignore'), (u'Extension', _RelocationRequestExtensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 127), (u'criticality', u'ignore'), (u'Extension', _RelocationRequestExtensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 133), (u'criticality', u'ignore'), (u'Extension', _RelocationRequestExtensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 233), (u'criticality', u'ignore'), (u'Extension', _RelocationRequestExtensions_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 203), (u'criticality', u'reject'), (u'Extension', _RelocationRequestExtensions_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 234), (u'criticality', u'ignore'), (u'Extension', _RelocationRequestExtensions_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 239), (u'criticality', u'ignore'), (u'Extension', _RelocationRequestExtensions_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 261), (u'criticality', u'ignore'), (u'Extension', _RelocationRequestExtensions_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 289), (u'criticality', u'ignore'), (u'Extension', _RelocationRequestExtensions_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 293), (u'criticality', u'ignore'), (u'Extension', _RelocationRequestExtensions_val_Extension_11), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CNMBMSLinkingInformation >-----#
    CNMBMSLinkingInformation = SEQ(name=u'CNMBMSLinkingInformation', mode=MODE_TYPE)
    _CNMBMSLinkingInformation_joinedMBMSBearerService_IEs = SEQ_OF(name=u'joinedMBMSBearerService-IEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Contents', 'JoinedMBMSBearerService-IEs')))
    _CNMBMSLinkingInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CNMBMSLinkingInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___CNMBMSLinkingInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CNMBMSLinkingInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CNMBMSLinkingInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNMBMSLinkingInformation_iE_Extensions__item__id._const_tab = ____CNMBMSLinkingInformation_iE_Extensions__item__id_tab
    ___CNMBMSLinkingInformation_iE_Extensions__item__id._const_tab_at = None
    ___CNMBMSLinkingInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___CNMBMSLinkingInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CNMBMSLinkingInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CNMBMSLinkingInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNMBMSLinkingInformation_iE_Extensions__item__criticality._const_tab = ____CNMBMSLinkingInformation_iE_Extensions__item__criticality_tab
    ___CNMBMSLinkingInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CNMBMSLinkingInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CNMBMSLinkingInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CNMBMSLinkingInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CNMBMSLinkingInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNMBMSLinkingInformation_iE_Extensions__item__extensionValue._const_tab = ____CNMBMSLinkingInformation_iE_Extensions__item__extensionValue_tab
    ___CNMBMSLinkingInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CNMBMSLinkingInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CNMBMSLinkingInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CNMBMSLinkingInformation_iE_Extensions__item__id),
        (u'criticality', ___CNMBMSLinkingInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___CNMBMSLinkingInformation_iE_Extensions__item__extensionValue),
        ])
    __CNMBMSLinkingInformation_iE_Extensions__item_._ext = None
    _CNMBMSLinkingInformation_iE_Extensions._cont = __CNMBMSLinkingInformation_iE_Extensions__item_
    _CNMBMSLinkingInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CNMBMSLinkingInformation._cont = ASN1Dict([
        (u'joinedMBMSBearerService-IEs', _CNMBMSLinkingInformation_joinedMBMSBearerService_IEs),
        (u'iE-Extensions', _CNMBMSLinkingInformation_iE_Extensions),
        ])
    CNMBMSLinkingInformation._ext = []
    
    #-----< CNMBMSLinkingInformation-ExtIEs >-----#
    CNMBMSLinkingInformation_ExtIEs = CLASS(name=u'CNMBMSLinkingInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    CNMBMSLinkingInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< JoinedMBMSBearerService-IEs >-----#
    JoinedMBMSBearerService_IEs = SEQ_OF(name=u'JoinedMBMSBearerService-IEs', mode=MODE_TYPE)
    _JoinedMBMSBearerService_IEs__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __JoinedMBMSBearerService_IEs__item__tMGI = SEQ(name=u'tMGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    __JoinedMBMSBearerService_IEs__item__mBMS_PTP_RAB_ID = BIT_STR(name=u'mBMS-PTP-RAB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'MBMS-PTP-RAB-ID')))
    __JoinedMBMSBearerService_IEs__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___JoinedMBMSBearerService_IEs__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    _____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__id._const_tab = _____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__id_tab
    ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__id._const_tab_at = None
    ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__criticality._const_tab = _____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__criticality_tab
    ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue._const_tab = _____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue_tab
    ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___JoinedMBMSBearerService_IEs__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__id),
        (u'criticality', ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue),
        ])
    ___JoinedMBMSBearerService_IEs__item__iE_Extensions__item_._ext = None
    __JoinedMBMSBearerService_IEs__item__iE_Extensions._cont = ___JoinedMBMSBearerService_IEs__item__iE_Extensions__item_
    __JoinedMBMSBearerService_IEs__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _JoinedMBMSBearerService_IEs__item_._cont = ASN1Dict([
        (u'tMGI', __JoinedMBMSBearerService_IEs__item__tMGI),
        (u'mBMS-PTP-RAB-ID', __JoinedMBMSBearerService_IEs__item__mBMS_PTP_RAB_ID),
        (u'iE-Extensions', __JoinedMBMSBearerService_IEs__item__iE_Extensions),
        ])
    _JoinedMBMSBearerService_IEs__item_._ext = []
    JoinedMBMSBearerService_IEs._cont = _JoinedMBMSBearerService_IEs__item_
    JoinedMBMSBearerService_IEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< JoinedMBMSBearerService-ExtIEs >-----#
    JoinedMBMSBearerService_ExtIEs = CLASS(name=u'JoinedMBMSBearerService-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    JoinedMBMSBearerService_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelocationRequestAcknowledge >-----#
    RelocationRequestAcknowledge = SEQ(name=u'RelocationRequestAcknowledge', mode=MODE_TYPE)
    _RelocationRequestAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RelocationRequestAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RelocationRequestAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RelocationRequestAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TargetRNC-ToSourceRNC-TransparentContainer')))
    _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupList-RelocReqAck')))
    _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedList')))
    _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ChosenIntegrityProtectionAlgorithm')))
    _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ChosenEncryptionAlgorithm')))
    _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____RelocationRequestAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 63), (u'criticality', u'ignore'), (u'Value', _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 50), (u'criticality', u'ignore'), (u'Value', _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 35), (u'criticality', u'ignore'), (u'Value', _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 6), (u'criticality', u'ignore'), (u'Value', _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RelocationRequestAcknowledge_protocolIEs__item__id._const_tab = ____RelocationRequestAcknowledge_protocolIEs__item__id_tab
    ___RelocationRequestAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___RelocationRequestAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___RelocationRequestAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RelocationRequestAcknowledge_protocolIEs__item__criticality._const_tab = ____RelocationRequestAcknowledge_protocolIEs__item__id_tab
    ___RelocationRequestAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RelocationRequestAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RelocationRequestAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RelocationRequestAcknowledge_protocolIEs__item__value._const_tab = ____RelocationRequestAcknowledge_protocolIEs__item__id_tab
    ___RelocationRequestAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RelocationRequestAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __RelocationRequestAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RelocationRequestAcknowledge_protocolIEs__item__id),
        (u'criticality', ___RelocationRequestAcknowledge_protocolIEs__item__criticality),
        (u'value', ___RelocationRequestAcknowledge_protocolIEs__item__value),
        ])
    __RelocationRequestAcknowledge_protocolIEs__item_._ext = None
    _RelocationRequestAcknowledge_protocolIEs._cont = __RelocationRequestAcknowledge_protocolIEs__item_
    _RelocationRequestAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RelocationRequestAcknowledge_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelocationRequestAcknowledge_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RelocationRequestAcknowledge_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RelocationRequestAcknowledge_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RelocationRequestAcknowledge_protocolExtensions__item__id_tab_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NewBSS-To-OldBSS-Information')))
    _____RelocationRequestAcknowledge_protocolExtensions__item__id_tab_val_Extension_1 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id')))
    ____RelocationRequestAcknowledge_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 100), (u'criticality', u'ignore'), (u'Extension', _____RelocationRequestAcknowledge_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 203), (u'criticality', u'ignore'), (u'Extension', _____RelocationRequestAcknowledge_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RelocationRequestAcknowledge_protocolExtensions__item__id._const_tab = ____RelocationRequestAcknowledge_protocolExtensions__item__id_tab
    ___RelocationRequestAcknowledge_protocolExtensions__item__id._const_tab_at = None
    ___RelocationRequestAcknowledge_protocolExtensions__item__id._const_tab_id = u'id'
    ___RelocationRequestAcknowledge_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RelocationRequestAcknowledge_protocolExtensions__item__criticality._const_tab = ____RelocationRequestAcknowledge_protocolExtensions__item__id_tab
    ___RelocationRequestAcknowledge_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RelocationRequestAcknowledge_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RelocationRequestAcknowledge_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RelocationRequestAcknowledge_protocolExtensions__item__extensionValue._const_tab = ____RelocationRequestAcknowledge_protocolExtensions__item__id_tab
    ___RelocationRequestAcknowledge_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RelocationRequestAcknowledge_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RelocationRequestAcknowledge_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RelocationRequestAcknowledge_protocolExtensions__item__id),
        (u'criticality', ___RelocationRequestAcknowledge_protocolExtensions__item__criticality),
        (u'extensionValue', ___RelocationRequestAcknowledge_protocolExtensions__item__extensionValue),
        ])
    __RelocationRequestAcknowledge_protocolExtensions__item_._ext = None
    _RelocationRequestAcknowledge_protocolExtensions._cont = __RelocationRequestAcknowledge_protocolExtensions__item_
    _RelocationRequestAcknowledge_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelocationRequestAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _RelocationRequestAcknowledge_protocolIEs),
        (u'protocolExtensions', _RelocationRequestAcknowledge_protocolExtensions),
        ])
    RelocationRequestAcknowledge._ext = []
    
    #-----< RelocationRequestAcknowledgeIEs >-----#
    RelocationRequestAcknowledgeIEs = CLASS(name=u'RelocationRequestAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RelocationRequestAcknowledgeIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TargetRNC-ToSourceRNC-TransparentContainer')))
    _RelocationRequestAcknowledgeIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupList-RelocReqAck')))
    _RelocationRequestAcknowledgeIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedList')))
    _RelocationRequestAcknowledgeIEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ChosenIntegrityProtectionAlgorithm')))
    _RelocationRequestAcknowledgeIEs_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ChosenEncryptionAlgorithm')))
    _RelocationRequestAcknowledgeIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    RelocationRequestAcknowledgeIEs._val = ASN1Set(rv=[dict([(u'id', 63), (u'criticality', u'ignore'), (u'Value', _RelocationRequestAcknowledgeIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 50), (u'criticality', u'ignore'), (u'Value', _RelocationRequestAcknowledgeIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 35), (u'criticality', u'ignore'), (u'Value', _RelocationRequestAcknowledgeIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 6), (u'criticality', u'ignore'), (u'Value', _RelocationRequestAcknowledgeIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _RelocationRequestAcknowledgeIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _RelocationRequestAcknowledgeIEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupList-RelocReqAck >-----#
    RAB_SetupList_RelocReqAck = SEQ_OF(name=u'RAB-SetupList-RelocReqAck', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_SetupList_RelocReqAck__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_SetupList_RelocReqAck__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_SetupList_RelocReqAck__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_SetupList_RelocReqAck__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_SetupList_RelocReqAck__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupItem-RelocReqAck')))
    ____RAB_SetupList_RelocReqAck__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 48), (u'criticality', u'reject'), (u'Value', _____RAB_SetupList_RelocReqAck__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_SetupList_RelocReqAck__item___item__id._const_tab = ____RAB_SetupList_RelocReqAck__item___item__id_tab
    ___RAB_SetupList_RelocReqAck__item___item__id._const_tab_at = None
    ___RAB_SetupList_RelocReqAck__item___item__id._const_tab_id = u'id'
    ___RAB_SetupList_RelocReqAck__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_SetupList_RelocReqAck__item___item__criticality._const_tab = ____RAB_SetupList_RelocReqAck__item___item__id_tab
    ___RAB_SetupList_RelocReqAck__item___item__criticality._const_tab_at = ('..', u'id')
    ___RAB_SetupList_RelocReqAck__item___item__criticality._const_tab_id = u'criticality'
    ___RAB_SetupList_RelocReqAck__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_SetupList_RelocReqAck__item___item__value._const_tab = ____RAB_SetupList_RelocReqAck__item___item__id_tab
    ___RAB_SetupList_RelocReqAck__item___item__value._const_tab_at = ('..', u'id')
    ___RAB_SetupList_RelocReqAck__item___item__value._const_tab_id = u'Value'
    __RAB_SetupList_RelocReqAck__item___item_._cont = ASN1Dict([
        (u'id', ___RAB_SetupList_RelocReqAck__item___item__id),
        (u'criticality', ___RAB_SetupList_RelocReqAck__item___item__criticality),
        (u'value', ___RAB_SetupList_RelocReqAck__item___item__value),
        ])
    __RAB_SetupList_RelocReqAck__item___item_._ext = None
    _RAB_SetupList_RelocReqAck__item_._cont = __RAB_SetupList_RelocReqAck__item___item_
    _RAB_SetupList_RelocReqAck__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_SetupList_RelocReqAck._cont = _RAB_SetupList_RelocReqAck__item_
    RAB_SetupList_RelocReqAck._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-SetupItem-RelocReqAck-IEs >-----#
    RAB_SetupItem_RelocReqAck_IEs = CLASS(name=u'RAB-SetupItem-RelocReqAck-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_SetupItem_RelocReqAck_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupItem-RelocReqAck')))
    RAB_SetupItem_RelocReqAck_IEs._val = ASN1Set(rv=[dict([(u'id', 48), (u'criticality', u'reject'), (u'Value', _RAB_SetupItem_RelocReqAck_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupItem-RelocReqAck >-----#
    RAB_SetupItem_RelocReqAck = SEQ(name=u'RAB-SetupItem-RelocReqAck', mode=MODE_TYPE)
    _RAB_SetupItem_RelocReqAck_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_SetupItem_RelocReqAck_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')), opt=True)
    _RAB_SetupItem_RelocReqAck_iuTransportAssociation = CHOICE(name=u'iuTransportAssociation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IuTransportAssociation')), opt=True)
    _RAB_SetupItem_RelocReqAck_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_SetupItem_RelocReqAck_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Ass-RAB-Parameters')))
    _____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuTransportAssociation')))
    ____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 90), (u'criticality', u'ignore'), (u'Extension', _____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 67), (u'criticality', u'ignore'), (u'Extension', _____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 13), (u'criticality', u'ignore'), (u'Extension', _____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__id._const_tab = ____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab
    ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__id._const_tab_at = None
    ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__criticality._const_tab = ____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab
    ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__extensionValue._const_tab = ____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab
    ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_SetupItem_RelocReqAck_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__id),
        (u'criticality', ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__extensionValue),
        ])
    __RAB_SetupItem_RelocReqAck_iE_Extensions__item_._ext = None
    _RAB_SetupItem_RelocReqAck_iE_Extensions._cont = __RAB_SetupItem_RelocReqAck_iE_Extensions__item_
    _RAB_SetupItem_RelocReqAck_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_SetupItem_RelocReqAck._cont = ASN1Dict([
        (u'rAB-ID', _RAB_SetupItem_RelocReqAck_rAB_ID),
        (u'transportLayerAddress', _RAB_SetupItem_RelocReqAck_transportLayerAddress),
        (u'iuTransportAssociation', _RAB_SetupItem_RelocReqAck_iuTransportAssociation),
        (u'iE-Extensions', _RAB_SetupItem_RelocReqAck_iE_Extensions),
        ])
    RAB_SetupItem_RelocReqAck._ext = []
    
    #-----< RAB-SetupItem-RelocReqAck-ExtIEs >-----#
    RAB_SetupItem_RelocReqAck_ExtIEs = CLASS(name=u'RAB-SetupItem-RelocReqAck-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RAB_SetupItem_RelocReqAck_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Ass-RAB-Parameters')))
    _RAB_SetupItem_RelocReqAck_ExtIEs_val_Extension_1 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _RAB_SetupItem_RelocReqAck_ExtIEs_val_Extension_2 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuTransportAssociation')))
    RAB_SetupItem_RelocReqAck_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 90), (u'criticality', u'ignore'), (u'Extension', _RAB_SetupItem_RelocReqAck_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 67), (u'criticality', u'ignore'), (u'Extension', _RAB_SetupItem_RelocReqAck_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 13), (u'criticality', u'ignore'), (u'Extension', _RAB_SetupItem_RelocReqAck_ExtIEs_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-FailedList >-----#
    RAB_FailedList = SEQ_OF(name=u'RAB-FailedList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_FailedList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_FailedList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_FailedList__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_FailedList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_FailedList__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedItem')))
    ____RAB_FailedList__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 34), (u'criticality', u'ignore'), (u'Value', _____RAB_FailedList__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_FailedList__item___item__id._const_tab = ____RAB_FailedList__item___item__id_tab
    ___RAB_FailedList__item___item__id._const_tab_at = None
    ___RAB_FailedList__item___item__id._const_tab_id = u'id'
    ___RAB_FailedList__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_FailedList__item___item__criticality._const_tab = ____RAB_FailedList__item___item__id_tab
    ___RAB_FailedList__item___item__criticality._const_tab_at = ('..', u'id')
    ___RAB_FailedList__item___item__criticality._const_tab_id = u'criticality'
    ___RAB_FailedList__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_FailedList__item___item__value._const_tab = ____RAB_FailedList__item___item__id_tab
    ___RAB_FailedList__item___item__value._const_tab_at = ('..', u'id')
    ___RAB_FailedList__item___item__value._const_tab_id = u'Value'
    __RAB_FailedList__item___item_._cont = ASN1Dict([
        (u'id', ___RAB_FailedList__item___item__id),
        (u'criticality', ___RAB_FailedList__item___item__criticality),
        (u'value', ___RAB_FailedList__item___item__value),
        ])
    __RAB_FailedList__item___item_._ext = None
    _RAB_FailedList__item_._cont = __RAB_FailedList__item___item_
    _RAB_FailedList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_FailedList._cont = _RAB_FailedList__item_
    RAB_FailedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-FailedItemIEs >-----#
    RAB_FailedItemIEs = CLASS(name=u'RAB-FailedItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_FailedItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedItem')))
    RAB_FailedItemIEs._val = ASN1Set(rv=[dict([(u'id', 34), (u'criticality', u'ignore'), (u'Value', _RAB_FailedItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-FailedItem >-----#
    RAB_FailedItem = SEQ(name=u'RAB-FailedItem', mode=MODE_TYPE)
    _RAB_FailedItem_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_FailedItem_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _RAB_FailedItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_FailedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_FailedItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_FailedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_FailedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_FailedItem_iE_Extensions__item__id._const_tab = ____RAB_FailedItem_iE_Extensions__item__id_tab
    ___RAB_FailedItem_iE_Extensions__item__id._const_tab_at = None
    ___RAB_FailedItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAB_FailedItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RAB_FailedItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_FailedItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_FailedItem_iE_Extensions__item__criticality._const_tab = ____RAB_FailedItem_iE_Extensions__item__criticality_tab
    ___RAB_FailedItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_FailedItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_FailedItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RAB_FailedItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_FailedItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_FailedItem_iE_Extensions__item__extensionValue._const_tab = ____RAB_FailedItem_iE_Extensions__item__extensionValue_tab
    ___RAB_FailedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_FailedItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_FailedItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_FailedItem_iE_Extensions__item__id),
        (u'criticality', ___RAB_FailedItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAB_FailedItem_iE_Extensions__item__extensionValue),
        ])
    __RAB_FailedItem_iE_Extensions__item_._ext = None
    _RAB_FailedItem_iE_Extensions._cont = __RAB_FailedItem_iE_Extensions__item_
    _RAB_FailedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_FailedItem._cont = ASN1Dict([
        (u'rAB-ID', _RAB_FailedItem_rAB_ID),
        (u'cause', _RAB_FailedItem_cause),
        (u'iE-Extensions', _RAB_FailedItem_iE_Extensions),
        ])
    RAB_FailedItem._ext = []
    
    #-----< RAB-FailedItem-ExtIEs >-----#
    RAB_FailedItem_ExtIEs = CLASS(name=u'RAB-FailedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_FailedItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelocationRequestAcknowledgeExtensions >-----#
    RelocationRequestAcknowledgeExtensions = CLASS(name=u'RelocationRequestAcknowledgeExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RelocationRequestAcknowledgeExtensions_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NewBSS-To-OldBSS-Information')))
    _RelocationRequestAcknowledgeExtensions_val_Extension_1 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id')))
    RelocationRequestAcknowledgeExtensions._val = ASN1Set(rv=[dict([(u'id', 100), (u'criticality', u'ignore'), (u'Extension', _RelocationRequestAcknowledgeExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 203), (u'criticality', u'ignore'), (u'Extension', _RelocationRequestAcknowledgeExtensions_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RelocationFailure >-----#
    RelocationFailure = SEQ(name=u'RelocationFailure', mode=MODE_TYPE)
    _RelocationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RelocationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RelocationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RelocationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RelocationFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____RelocationFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____RelocationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____RelocationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____RelocationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RelocationFailure_protocolIEs__item__id._const_tab = ____RelocationFailure_protocolIEs__item__id_tab
    ___RelocationFailure_protocolIEs__item__id._const_tab_at = None
    ___RelocationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___RelocationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RelocationFailure_protocolIEs__item__criticality._const_tab = ____RelocationFailure_protocolIEs__item__id_tab
    ___RelocationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RelocationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RelocationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RelocationFailure_protocolIEs__item__value._const_tab = ____RelocationFailure_protocolIEs__item__id_tab
    ___RelocationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RelocationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __RelocationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RelocationFailure_protocolIEs__item__id),
        (u'criticality', ___RelocationFailure_protocolIEs__item__criticality),
        (u'value', ___RelocationFailure_protocolIEs__item__value),
        ])
    __RelocationFailure_protocolIEs__item_._ext = None
    _RelocationFailure_protocolIEs._cont = __RelocationFailure_protocolIEs__item_
    _RelocationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RelocationFailure_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelocationFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RelocationFailure_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RelocationFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RelocationFailure_protocolExtensions__item__id_tab_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NewBSS-To-OldBSS-Information')))
    _____RelocationFailure_protocolExtensions__item__id_tab_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GERAN-Classmark')))
    ____RelocationFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 100), (u'criticality', u'ignore'), (u'Extension', _____RelocationFailure_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 108), (u'criticality', u'ignore'), (u'Extension', _____RelocationFailure_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RelocationFailure_protocolExtensions__item__id._const_tab = ____RelocationFailure_protocolExtensions__item__id_tab
    ___RelocationFailure_protocolExtensions__item__id._const_tab_at = None
    ___RelocationFailure_protocolExtensions__item__id._const_tab_id = u'id'
    ___RelocationFailure_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RelocationFailure_protocolExtensions__item__criticality._const_tab = ____RelocationFailure_protocolExtensions__item__id_tab
    ___RelocationFailure_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RelocationFailure_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RelocationFailure_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RelocationFailure_protocolExtensions__item__extensionValue._const_tab = ____RelocationFailure_protocolExtensions__item__id_tab
    ___RelocationFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RelocationFailure_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RelocationFailure_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RelocationFailure_protocolExtensions__item__id),
        (u'criticality', ___RelocationFailure_protocolExtensions__item__criticality),
        (u'extensionValue', ___RelocationFailure_protocolExtensions__item__extensionValue),
        ])
    __RelocationFailure_protocolExtensions__item_._ext = None
    _RelocationFailure_protocolExtensions._cont = __RelocationFailure_protocolExtensions__item_
    _RelocationFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelocationFailure._cont = ASN1Dict([
        (u'protocolIEs', _RelocationFailure_protocolIEs),
        (u'protocolExtensions', _RelocationFailure_protocolExtensions),
        ])
    RelocationFailure._ext = []
    
    #-----< RelocationFailureIEs >-----#
    RelocationFailureIEs = CLASS(name=u'RelocationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RelocationFailureIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _RelocationFailureIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    RelocationFailureIEs._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _RelocationFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _RelocationFailureIEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RelocationFailureExtensions >-----#
    RelocationFailureExtensions = CLASS(name=u'RelocationFailureExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RelocationFailureExtensions_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NewBSS-To-OldBSS-Information')))
    _RelocationFailureExtensions_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GERAN-Classmark')))
    RelocationFailureExtensions._val = ASN1Set(rv=[dict([(u'id', 100), (u'criticality', u'ignore'), (u'Extension', _RelocationFailureExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 108), (u'criticality', u'ignore'), (u'Extension', _RelocationFailureExtensions_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RelocationCancel >-----#
    RelocationCancel = SEQ(name=u'RelocationCancel', mode=MODE_TYPE)
    _RelocationCancel_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RelocationCancel_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RelocationCancel_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RelocationCancel_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RelocationCancel_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    ____RelocationCancel_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____RelocationCancel_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RelocationCancel_protocolIEs__item__id._const_tab = ____RelocationCancel_protocolIEs__item__id_tab
    ___RelocationCancel_protocolIEs__item__id._const_tab_at = None
    ___RelocationCancel_protocolIEs__item__id._const_tab_id = u'id'
    ___RelocationCancel_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RelocationCancel_protocolIEs__item__criticality._const_tab = ____RelocationCancel_protocolIEs__item__id_tab
    ___RelocationCancel_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RelocationCancel_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RelocationCancel_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RelocationCancel_protocolIEs__item__value._const_tab = ____RelocationCancel_protocolIEs__item__id_tab
    ___RelocationCancel_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RelocationCancel_protocolIEs__item__value._const_tab_id = u'Value'
    __RelocationCancel_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RelocationCancel_protocolIEs__item__id),
        (u'criticality', ___RelocationCancel_protocolIEs__item__criticality),
        (u'value', ___RelocationCancel_protocolIEs__item__value),
        ])
    __RelocationCancel_protocolIEs__item_._ext = None
    _RelocationCancel_protocolIEs._cont = __RelocationCancel_protocolIEs__item_
    _RelocationCancel_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RelocationCancel_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelocationCancel_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RelocationCancel_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RelocationCancel_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RelocationCancel_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationCancel_protocolExtensions__item__id._const_tab = ____RelocationCancel_protocolExtensions__item__id_tab
    ___RelocationCancel_protocolExtensions__item__id._const_tab_at = None
    ___RelocationCancel_protocolExtensions__item__id._const_tab_id = u'id'
    ___RelocationCancel_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RelocationCancel_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RelocationCancel_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationCancel_protocolExtensions__item__criticality._const_tab = ____RelocationCancel_protocolExtensions__item__criticality_tab
    ___RelocationCancel_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RelocationCancel_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RelocationCancel_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RelocationCancel_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RelocationCancel_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationCancel_protocolExtensions__item__extensionValue._const_tab = ____RelocationCancel_protocolExtensions__item__extensionValue_tab
    ___RelocationCancel_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RelocationCancel_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RelocationCancel_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RelocationCancel_protocolExtensions__item__id),
        (u'criticality', ___RelocationCancel_protocolExtensions__item__criticality),
        (u'extensionValue', ___RelocationCancel_protocolExtensions__item__extensionValue),
        ])
    __RelocationCancel_protocolExtensions__item_._ext = None
    _RelocationCancel_protocolExtensions._cont = __RelocationCancel_protocolExtensions__item_
    _RelocationCancel_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelocationCancel._cont = ASN1Dict([
        (u'protocolIEs', _RelocationCancel_protocolIEs),
        (u'protocolExtensions', _RelocationCancel_protocolExtensions),
        ])
    RelocationCancel._ext = []
    
    #-----< RelocationCancelIEs >-----#
    RelocationCancelIEs = CLASS(name=u'RelocationCancelIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RelocationCancelIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    RelocationCancelIEs._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _RelocationCancelIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RelocationCancelExtensions >-----#
    RelocationCancelExtensions = CLASS(name=u'RelocationCancelExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RelocationCancelExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelocationCancelAcknowledge >-----#
    RelocationCancelAcknowledge = SEQ(name=u'RelocationCancelAcknowledge', mode=MODE_TYPE)
    _RelocationCancelAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RelocationCancelAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RelocationCancelAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RelocationCancelAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RelocationCancelAcknowledge_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____RelocationCancelAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____RelocationCancelAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RelocationCancelAcknowledge_protocolIEs__item__id._const_tab = ____RelocationCancelAcknowledge_protocolIEs__item__id_tab
    ___RelocationCancelAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___RelocationCancelAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___RelocationCancelAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RelocationCancelAcknowledge_protocolIEs__item__criticality._const_tab = ____RelocationCancelAcknowledge_protocolIEs__item__id_tab
    ___RelocationCancelAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RelocationCancelAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RelocationCancelAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RelocationCancelAcknowledge_protocolIEs__item__value._const_tab = ____RelocationCancelAcknowledge_protocolIEs__item__id_tab
    ___RelocationCancelAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RelocationCancelAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __RelocationCancelAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RelocationCancelAcknowledge_protocolIEs__item__id),
        (u'criticality', ___RelocationCancelAcknowledge_protocolIEs__item__criticality),
        (u'value', ___RelocationCancelAcknowledge_protocolIEs__item__value),
        ])
    __RelocationCancelAcknowledge_protocolIEs__item_._ext = None
    _RelocationCancelAcknowledge_protocolIEs._cont = __RelocationCancelAcknowledge_protocolIEs__item_
    _RelocationCancelAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RelocationCancelAcknowledge_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelocationCancelAcknowledge_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RelocationCancelAcknowledge_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RelocationCancelAcknowledge_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RelocationCancelAcknowledge_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationCancelAcknowledge_protocolExtensions__item__id._const_tab = ____RelocationCancelAcknowledge_protocolExtensions__item__id_tab
    ___RelocationCancelAcknowledge_protocolExtensions__item__id._const_tab_at = None
    ___RelocationCancelAcknowledge_protocolExtensions__item__id._const_tab_id = u'id'
    ___RelocationCancelAcknowledge_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RelocationCancelAcknowledge_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RelocationCancelAcknowledge_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationCancelAcknowledge_protocolExtensions__item__criticality._const_tab = ____RelocationCancelAcknowledge_protocolExtensions__item__criticality_tab
    ___RelocationCancelAcknowledge_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RelocationCancelAcknowledge_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RelocationCancelAcknowledge_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RelocationCancelAcknowledge_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RelocationCancelAcknowledge_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationCancelAcknowledge_protocolExtensions__item__extensionValue._const_tab = ____RelocationCancelAcknowledge_protocolExtensions__item__extensionValue_tab
    ___RelocationCancelAcknowledge_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RelocationCancelAcknowledge_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RelocationCancelAcknowledge_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RelocationCancelAcknowledge_protocolExtensions__item__id),
        (u'criticality', ___RelocationCancelAcknowledge_protocolExtensions__item__criticality),
        (u'extensionValue', ___RelocationCancelAcknowledge_protocolExtensions__item__extensionValue),
        ])
    __RelocationCancelAcknowledge_protocolExtensions__item_._ext = None
    _RelocationCancelAcknowledge_protocolExtensions._cont = __RelocationCancelAcknowledge_protocolExtensions__item_
    _RelocationCancelAcknowledge_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelocationCancelAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _RelocationCancelAcknowledge_protocolIEs),
        (u'protocolExtensions', _RelocationCancelAcknowledge_protocolExtensions),
        ])
    RelocationCancelAcknowledge._ext = []
    
    #-----< RelocationCancelAcknowledgeIEs >-----#
    RelocationCancelAcknowledgeIEs = CLASS(name=u'RelocationCancelAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RelocationCancelAcknowledgeIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    RelocationCancelAcknowledgeIEs._val = ASN1Set(rv=[dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _RelocationCancelAcknowledgeIEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RelocationCancelAcknowledgeExtensions >-----#
    RelocationCancelAcknowledgeExtensions = CLASS(name=u'RelocationCancelAcknowledgeExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RelocationCancelAcknowledgeExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRNS-ContextRequest >-----#
    SRNS_ContextRequest = SEQ(name=u'SRNS-ContextRequest', mode=MODE_TYPE)
    _SRNS_ContextRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __SRNS_ContextRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___SRNS_ContextRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____SRNS_ContextRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____SRNS_ContextRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataForwardingList-SRNS-CtxReq')))
    ____SRNS_ContextRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 29), (u'criticality', u'ignore'), (u'Value', _____SRNS_ContextRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___SRNS_ContextRequest_protocolIEs__item__id._const_tab = ____SRNS_ContextRequest_protocolIEs__item__id_tab
    ___SRNS_ContextRequest_protocolIEs__item__id._const_tab_at = None
    ___SRNS_ContextRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___SRNS_ContextRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___SRNS_ContextRequest_protocolIEs__item__criticality._const_tab = ____SRNS_ContextRequest_protocolIEs__item__id_tab
    ___SRNS_ContextRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SRNS_ContextRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SRNS_ContextRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___SRNS_ContextRequest_protocolIEs__item__value._const_tab = ____SRNS_ContextRequest_protocolIEs__item__id_tab
    ___SRNS_ContextRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SRNS_ContextRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __SRNS_ContextRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SRNS_ContextRequest_protocolIEs__item__id),
        (u'criticality', ___SRNS_ContextRequest_protocolIEs__item__criticality),
        (u'value', ___SRNS_ContextRequest_protocolIEs__item__value),
        ])
    __SRNS_ContextRequest_protocolIEs__item_._ext = None
    _SRNS_ContextRequest_protocolIEs._cont = __SRNS_ContextRequest_protocolIEs__item_
    _SRNS_ContextRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _SRNS_ContextRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRNS_ContextRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SRNS_ContextRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SRNS_ContextRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____SRNS_ContextRequest_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAT-Type')))
    ____SRNS_ContextRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 167), (u'criticality', u'ignore'), (u'Extension', _____SRNS_ContextRequest_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SRNS_ContextRequest_protocolExtensions__item__id._const_tab = ____SRNS_ContextRequest_protocolExtensions__item__id_tab
    ___SRNS_ContextRequest_protocolExtensions__item__id._const_tab_at = None
    ___SRNS_ContextRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___SRNS_ContextRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SRNS_ContextRequest_protocolExtensions__item__criticality._const_tab = ____SRNS_ContextRequest_protocolExtensions__item__id_tab
    ___SRNS_ContextRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRNS_ContextRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___SRNS_ContextRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SRNS_ContextRequest_protocolExtensions__item__extensionValue._const_tab = ____SRNS_ContextRequest_protocolExtensions__item__id_tab
    ___SRNS_ContextRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRNS_ContextRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __SRNS_ContextRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___SRNS_ContextRequest_protocolExtensions__item__id),
        (u'criticality', ___SRNS_ContextRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___SRNS_ContextRequest_protocolExtensions__item__extensionValue),
        ])
    __SRNS_ContextRequest_protocolExtensions__item_._ext = None
    _SRNS_ContextRequest_protocolExtensions._cont = __SRNS_ContextRequest_protocolExtensions__item_
    _SRNS_ContextRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRNS_ContextRequest._cont = ASN1Dict([
        (u'protocolIEs', _SRNS_ContextRequest_protocolIEs),
        (u'protocolExtensions', _SRNS_ContextRequest_protocolExtensions),
        ])
    SRNS_ContextRequest._ext = []
    
    #-----< SRNS-ContextRequestIEs >-----#
    SRNS_ContextRequestIEs = CLASS(name=u'SRNS-ContextRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _SRNS_ContextRequestIEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataForwardingList-SRNS-CtxReq')))
    SRNS_ContextRequestIEs._val = ASN1Set(rv=[dict([(u'id', 29), (u'criticality', u'ignore'), (u'Value', _SRNS_ContextRequestIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-DataForwardingList-SRNS-CtxReq >-----#
    RAB_DataForwardingList_SRNS_CtxReq = SEQ_OF(name=u'RAB-DataForwardingList-SRNS-CtxReq', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_DataForwardingList_SRNS_CtxReq__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_DataForwardingList_SRNS_CtxReq__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_DataForwardingList_SRNS_CtxReq__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_DataForwardingList_SRNS_CtxReq__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_DataForwardingList_SRNS_CtxReq__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataForwardingItem-SRNS-CtxReq')))
    ____RAB_DataForwardingList_SRNS_CtxReq__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 27), (u'criticality', u'reject'), (u'Value', _____RAB_DataForwardingList_SRNS_CtxReq__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_DataForwardingList_SRNS_CtxReq__item___item__id._const_tab = ____RAB_DataForwardingList_SRNS_CtxReq__item___item__id_tab
    ___RAB_DataForwardingList_SRNS_CtxReq__item___item__id._const_tab_at = None
    ___RAB_DataForwardingList_SRNS_CtxReq__item___item__id._const_tab_id = u'id'
    ___RAB_DataForwardingList_SRNS_CtxReq__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_DataForwardingList_SRNS_CtxReq__item___item__criticality._const_tab = ____RAB_DataForwardingList_SRNS_CtxReq__item___item__id_tab
    ___RAB_DataForwardingList_SRNS_CtxReq__item___item__criticality._const_tab_at = ('..', u'id')
    ___RAB_DataForwardingList_SRNS_CtxReq__item___item__criticality._const_tab_id = u'criticality'
    ___RAB_DataForwardingList_SRNS_CtxReq__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_DataForwardingList_SRNS_CtxReq__item___item__value._const_tab = ____RAB_DataForwardingList_SRNS_CtxReq__item___item__id_tab
    ___RAB_DataForwardingList_SRNS_CtxReq__item___item__value._const_tab_at = ('..', u'id')
    ___RAB_DataForwardingList_SRNS_CtxReq__item___item__value._const_tab_id = u'Value'
    __RAB_DataForwardingList_SRNS_CtxReq__item___item_._cont = ASN1Dict([
        (u'id', ___RAB_DataForwardingList_SRNS_CtxReq__item___item__id),
        (u'criticality', ___RAB_DataForwardingList_SRNS_CtxReq__item___item__criticality),
        (u'value', ___RAB_DataForwardingList_SRNS_CtxReq__item___item__value),
        ])
    __RAB_DataForwardingList_SRNS_CtxReq__item___item_._ext = None
    _RAB_DataForwardingList_SRNS_CtxReq__item_._cont = __RAB_DataForwardingList_SRNS_CtxReq__item___item_
    _RAB_DataForwardingList_SRNS_CtxReq__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_DataForwardingList_SRNS_CtxReq._cont = _RAB_DataForwardingList_SRNS_CtxReq__item_
    RAB_DataForwardingList_SRNS_CtxReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-DataForwardingItem-SRNS-CtxReq-IEs >-----#
    RAB_DataForwardingItem_SRNS_CtxReq_IEs = CLASS(name=u'RAB-DataForwardingItem-SRNS-CtxReq-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_DataForwardingItem_SRNS_CtxReq_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataForwardingItem-SRNS-CtxReq')))
    RAB_DataForwardingItem_SRNS_CtxReq_IEs._val = ASN1Set(rv=[dict([(u'id', 27), (u'criticality', u'reject'), (u'Value', _RAB_DataForwardingItem_SRNS_CtxReq_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-DataForwardingItem-SRNS-CtxReq >-----#
    RAB_DataForwardingItem_SRNS_CtxReq = SEQ(name=u'RAB-DataForwardingItem-SRNS-CtxReq', mode=MODE_TYPE)
    _RAB_DataForwardingItem_SRNS_CtxReq_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__id._const_tab = ____RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__id_tab
    ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__id._const_tab_at = None
    ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__criticality._const_tab = ____RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__criticality_tab
    ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__extensionValue._const_tab = ____RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__extensionValue_tab
    ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__id),
        (u'criticality', ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__extensionValue),
        ])
    __RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item_._ext = None
    _RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions._cont = __RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item_
    _RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_DataForwardingItem_SRNS_CtxReq._cont = ASN1Dict([
        (u'rAB-ID', _RAB_DataForwardingItem_SRNS_CtxReq_rAB_ID),
        (u'iE-Extensions', _RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions),
        ])
    RAB_DataForwardingItem_SRNS_CtxReq._ext = []
    
    #-----< RAB-DataForwardingItem-SRNS-CtxReq-ExtIEs >-----#
    RAB_DataForwardingItem_SRNS_CtxReq_ExtIEs = CLASS(name=u'RAB-DataForwardingItem-SRNS-CtxReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_DataForwardingItem_SRNS_CtxReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRNS-ContextRequestExtensions >-----#
    SRNS_ContextRequestExtensions = CLASS(name=u'SRNS-ContextRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _SRNS_ContextRequestExtensions_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAT-Type')))
    SRNS_ContextRequestExtensions._val = ASN1Set(rv=[dict([(u'id', 167), (u'criticality', u'ignore'), (u'Extension', _SRNS_ContextRequestExtensions_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SRNS-ContextResponse >-----#
    SRNS_ContextResponse = SEQ(name=u'SRNS-ContextResponse', mode=MODE_TYPE)
    _SRNS_ContextResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __SRNS_ContextResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___SRNS_ContextResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____SRNS_ContextResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____SRNS_ContextResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ContextList')))
    _____SRNS_ContextResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ContextFailedtoTransferList')))
    _____SRNS_ContextResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____SRNS_ContextResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _____SRNS_ContextResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____SRNS_ContextResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____SRNS_ContextResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SRNS_ContextResponse_protocolIEs__item__id._const_tab = ____SRNS_ContextResponse_protocolIEs__item__id_tab
    ___SRNS_ContextResponse_protocolIEs__item__id._const_tab_at = None
    ___SRNS_ContextResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___SRNS_ContextResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___SRNS_ContextResponse_protocolIEs__item__criticality._const_tab = ____SRNS_ContextResponse_protocolIEs__item__id_tab
    ___SRNS_ContextResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SRNS_ContextResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SRNS_ContextResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___SRNS_ContextResponse_protocolIEs__item__value._const_tab = ____SRNS_ContextResponse_protocolIEs__item__id_tab
    ___SRNS_ContextResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SRNS_ContextResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __SRNS_ContextResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SRNS_ContextResponse_protocolIEs__item__id),
        (u'criticality', ___SRNS_ContextResponse_protocolIEs__item__criticality),
        (u'value', ___SRNS_ContextResponse_protocolIEs__item__value),
        ])
    __SRNS_ContextResponse_protocolIEs__item_._ext = None
    _SRNS_ContextResponse_protocolIEs._cont = __SRNS_ContextResponse_protocolIEs__item_
    _SRNS_ContextResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _SRNS_ContextResponse_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRNS_ContextResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SRNS_ContextResponse_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SRNS_ContextResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRNS_ContextResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRNS_ContextResponse_protocolExtensions__item__id._const_tab = ____SRNS_ContextResponse_protocolExtensions__item__id_tab
    ___SRNS_ContextResponse_protocolExtensions__item__id._const_tab_at = None
    ___SRNS_ContextResponse_protocolExtensions__item__id._const_tab_id = u'id'
    ___SRNS_ContextResponse_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SRNS_ContextResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRNS_ContextResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRNS_ContextResponse_protocolExtensions__item__criticality._const_tab = ____SRNS_ContextResponse_protocolExtensions__item__criticality_tab
    ___SRNS_ContextResponse_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRNS_ContextResponse_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___SRNS_ContextResponse_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SRNS_ContextResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRNS_ContextResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRNS_ContextResponse_protocolExtensions__item__extensionValue._const_tab = ____SRNS_ContextResponse_protocolExtensions__item__extensionValue_tab
    ___SRNS_ContextResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRNS_ContextResponse_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __SRNS_ContextResponse_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___SRNS_ContextResponse_protocolExtensions__item__id),
        (u'criticality', ___SRNS_ContextResponse_protocolExtensions__item__criticality),
        (u'extensionValue', ___SRNS_ContextResponse_protocolExtensions__item__extensionValue),
        ])
    __SRNS_ContextResponse_protocolExtensions__item_._ext = None
    _SRNS_ContextResponse_protocolExtensions._cont = __SRNS_ContextResponse_protocolExtensions__item_
    _SRNS_ContextResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRNS_ContextResponse._cont = ASN1Dict([
        (u'protocolIEs', _SRNS_ContextResponse_protocolIEs),
        (u'protocolExtensions', _SRNS_ContextResponse_protocolExtensions),
        ])
    SRNS_ContextResponse._ext = []
    
    #-----< SRNS-ContextResponseIEs >-----#
    SRNS_ContextResponseIEs = CLASS(name=u'SRNS-ContextResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _SRNS_ContextResponseIEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ContextList')))
    _SRNS_ContextResponseIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ContextFailedtoTransferList')))
    _SRNS_ContextResponseIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    SRNS_ContextResponseIEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _SRNS_ContextResponseIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _SRNS_ContextResponseIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _SRNS_ContextResponseIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-ContextList >-----#
    RAB_ContextList = SEQ_OF(name=u'RAB-ContextList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_ContextList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_ContextList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_ContextList__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_ContextList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_ContextList__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ContextItem')))
    ____RAB_ContextList__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 24), (u'criticality', u'ignore'), (u'Value', _____RAB_ContextList__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_ContextList__item___item__id._const_tab = ____RAB_ContextList__item___item__id_tab
    ___RAB_ContextList__item___item__id._const_tab_at = None
    ___RAB_ContextList__item___item__id._const_tab_id = u'id'
    ___RAB_ContextList__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_ContextList__item___item__criticality._const_tab = ____RAB_ContextList__item___item__id_tab
    ___RAB_ContextList__item___item__criticality._const_tab_at = ('..', u'id')
    ___RAB_ContextList__item___item__criticality._const_tab_id = u'criticality'
    ___RAB_ContextList__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_ContextList__item___item__value._const_tab = ____RAB_ContextList__item___item__id_tab
    ___RAB_ContextList__item___item__value._const_tab_at = ('..', u'id')
    ___RAB_ContextList__item___item__value._const_tab_id = u'Value'
    __RAB_ContextList__item___item_._cont = ASN1Dict([
        (u'id', ___RAB_ContextList__item___item__id),
        (u'criticality', ___RAB_ContextList__item___item__criticality),
        (u'value', ___RAB_ContextList__item___item__value),
        ])
    __RAB_ContextList__item___item_._ext = None
    _RAB_ContextList__item_._cont = __RAB_ContextList__item___item_
    _RAB_ContextList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_ContextList._cont = _RAB_ContextList__item_
    RAB_ContextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-ContextItemIEs >-----#
    RAB_ContextItemIEs = CLASS(name=u'RAB-ContextItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_ContextItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ContextItem')))
    RAB_ContextItemIEs._val = ASN1Set(rv=[dict([(u'id', 24), (u'criticality', u'ignore'), (u'Value', _RAB_ContextItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-ContextItem >-----#
    RAB_ContextItem = SEQ(name=u'RAB-ContextItem', mode=MODE_TYPE)
    _RAB_ContextItem_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_ContextItem_dl_GTP_PDU_SequenceNumber = INT(name=u'dl-GTP-PDU-SequenceNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DL-GTP-PDU-SequenceNumber')), opt=True)
    _RAB_ContextItem_ul_GTP_PDU_SequenceNumber = INT(name=u'ul-GTP-PDU-SequenceNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UL-GTP-PDU-SequenceNumber')), opt=True)
    _RAB_ContextItem_dl_N_PDU_SequenceNumber = INT(name=u'dl-N-PDU-SequenceNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DL-N-PDU-SequenceNumber')), opt=True)
    _RAB_ContextItem_ul_N_PDU_SequenceNumber = INT(name=u'ul-N-PDU-SequenceNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UL-N-PDU-SequenceNumber')), opt=True)
    _RAB_ContextItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_ContextItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_ContextItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_ContextItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ContextItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ContextItem_iE_Extensions__item__id._const_tab = ____RAB_ContextItem_iE_Extensions__item__id_tab
    ___RAB_ContextItem_iE_Extensions__item__id._const_tab_at = None
    ___RAB_ContextItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAB_ContextItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RAB_ContextItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ContextItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ContextItem_iE_Extensions__item__criticality._const_tab = ____RAB_ContextItem_iE_Extensions__item__criticality_tab
    ___RAB_ContextItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_ContextItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_ContextItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RAB_ContextItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ContextItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ContextItem_iE_Extensions__item__extensionValue._const_tab = ____RAB_ContextItem_iE_Extensions__item__extensionValue_tab
    ___RAB_ContextItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_ContextItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_ContextItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_ContextItem_iE_Extensions__item__id),
        (u'criticality', ___RAB_ContextItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAB_ContextItem_iE_Extensions__item__extensionValue),
        ])
    __RAB_ContextItem_iE_Extensions__item_._ext = None
    _RAB_ContextItem_iE_Extensions._cont = __RAB_ContextItem_iE_Extensions__item_
    _RAB_ContextItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_ContextItem._cont = ASN1Dict([
        (u'rAB-ID', _RAB_ContextItem_rAB_ID),
        (u'dl-GTP-PDU-SequenceNumber', _RAB_ContextItem_dl_GTP_PDU_SequenceNumber),
        (u'ul-GTP-PDU-SequenceNumber', _RAB_ContextItem_ul_GTP_PDU_SequenceNumber),
        (u'dl-N-PDU-SequenceNumber', _RAB_ContextItem_dl_N_PDU_SequenceNumber),
        (u'ul-N-PDU-SequenceNumber', _RAB_ContextItem_ul_N_PDU_SequenceNumber),
        (u'iE-Extensions', _RAB_ContextItem_iE_Extensions),
        ])
    RAB_ContextItem._ext = []
    
    #-----< RAB-ContextItem-ExtIEs >-----#
    RAB_ContextItem_ExtIEs = CLASS(name=u'RAB-ContextItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_ContextItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-ContextFailedtoTransferList >-----#
    RAB_ContextFailedtoTransferList = SEQ_OF(name=u'RAB-ContextFailedtoTransferList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_ContextFailedtoTransferList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_ContextFailedtoTransferList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_ContextFailedtoTransferList__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_ContextFailedtoTransferList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_ContextFailedtoTransferList__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RABs-ContextFailedtoTransferItem')))
    ____RAB_ContextFailedtoTransferList__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 84), (u'criticality', u'ignore'), (u'Value', _____RAB_ContextFailedtoTransferList__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_ContextFailedtoTransferList__item___item__id._const_tab = ____RAB_ContextFailedtoTransferList__item___item__id_tab
    ___RAB_ContextFailedtoTransferList__item___item__id._const_tab_at = None
    ___RAB_ContextFailedtoTransferList__item___item__id._const_tab_id = u'id'
    ___RAB_ContextFailedtoTransferList__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_ContextFailedtoTransferList__item___item__criticality._const_tab = ____RAB_ContextFailedtoTransferList__item___item__id_tab
    ___RAB_ContextFailedtoTransferList__item___item__criticality._const_tab_at = ('..', u'id')
    ___RAB_ContextFailedtoTransferList__item___item__criticality._const_tab_id = u'criticality'
    ___RAB_ContextFailedtoTransferList__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_ContextFailedtoTransferList__item___item__value._const_tab = ____RAB_ContextFailedtoTransferList__item___item__id_tab
    ___RAB_ContextFailedtoTransferList__item___item__value._const_tab_at = ('..', u'id')
    ___RAB_ContextFailedtoTransferList__item___item__value._const_tab_id = u'Value'
    __RAB_ContextFailedtoTransferList__item___item_._cont = ASN1Dict([
        (u'id', ___RAB_ContextFailedtoTransferList__item___item__id),
        (u'criticality', ___RAB_ContextFailedtoTransferList__item___item__criticality),
        (u'value', ___RAB_ContextFailedtoTransferList__item___item__value),
        ])
    __RAB_ContextFailedtoTransferList__item___item_._ext = None
    _RAB_ContextFailedtoTransferList__item_._cont = __RAB_ContextFailedtoTransferList__item___item_
    _RAB_ContextFailedtoTransferList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_ContextFailedtoTransferList._cont = _RAB_ContextFailedtoTransferList__item_
    RAB_ContextFailedtoTransferList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RABs-ContextFailedtoTransferItemIEs >-----#
    RABs_ContextFailedtoTransferItemIEs = CLASS(name=u'RABs-ContextFailedtoTransferItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RABs_ContextFailedtoTransferItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RABs-ContextFailedtoTransferItem')))
    RABs_ContextFailedtoTransferItemIEs._val = ASN1Set(rv=[dict([(u'id', 84), (u'criticality', u'ignore'), (u'Value', _RABs_ContextFailedtoTransferItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RABs-ContextFailedtoTransferItem >-----#
    RABs_ContextFailedtoTransferItem = SEQ(name=u'RABs-ContextFailedtoTransferItem', mode=MODE_TYPE)
    _RABs_ContextFailedtoTransferItem_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RABs_ContextFailedtoTransferItem_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _RABs_ContextFailedtoTransferItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RABs_ContextFailedtoTransferItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RABs_ContextFailedtoTransferItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RABs_ContextFailedtoTransferItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__id._const_tab = ____RABs_ContextFailedtoTransferItem_iE_Extensions__item__id_tab
    ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__id._const_tab_at = None
    ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RABs_ContextFailedtoTransferItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RABs_ContextFailedtoTransferItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__criticality._const_tab = ____RABs_ContextFailedtoTransferItem_iE_Extensions__item__criticality_tab
    ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RABs_ContextFailedtoTransferItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RABs_ContextFailedtoTransferItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__extensionValue._const_tab = ____RABs_ContextFailedtoTransferItem_iE_Extensions__item__extensionValue_tab
    ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RABs_ContextFailedtoTransferItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__id),
        (u'criticality', ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__extensionValue),
        ])
    __RABs_ContextFailedtoTransferItem_iE_Extensions__item_._ext = None
    _RABs_ContextFailedtoTransferItem_iE_Extensions._cont = __RABs_ContextFailedtoTransferItem_iE_Extensions__item_
    _RABs_ContextFailedtoTransferItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RABs_ContextFailedtoTransferItem._cont = ASN1Dict([
        (u'rAB-ID', _RABs_ContextFailedtoTransferItem_rAB_ID),
        (u'cause', _RABs_ContextFailedtoTransferItem_cause),
        (u'iE-Extensions', _RABs_ContextFailedtoTransferItem_iE_Extensions),
        ])
    RABs_ContextFailedtoTransferItem._ext = []
    
    #-----< RABs-ContextFailedtoTransferItem-ExtIEs >-----#
    RABs_ContextFailedtoTransferItem_ExtIEs = CLASS(name=u'RABs-ContextFailedtoTransferItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RABs_ContextFailedtoTransferItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRNS-ContextResponseExtensions >-----#
    SRNS_ContextResponseExtensions = CLASS(name=u'SRNS-ContextResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SRNS_ContextResponseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecurityModeCommand >-----#
    SecurityModeCommand = SEQ(name=u'SecurityModeCommand', mode=MODE_TYPE)
    _SecurityModeCommand_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __SecurityModeCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___SecurityModeCommand_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____SecurityModeCommand_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____SecurityModeCommand_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IntegrityProtectionInformation')))
    _____SecurityModeCommand_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'EncryptionInformation')))
    _____SecurityModeCommand_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'KeyStatus')))
    ____SecurityModeCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 12), (u'criticality', u'reject'), (u'Value', _____SecurityModeCommand_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _____SecurityModeCommand_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 75), (u'criticality', u'reject'), (u'Value', _____SecurityModeCommand_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___SecurityModeCommand_protocolIEs__item__id._const_tab = ____SecurityModeCommand_protocolIEs__item__id_tab
    ___SecurityModeCommand_protocolIEs__item__id._const_tab_at = None
    ___SecurityModeCommand_protocolIEs__item__id._const_tab_id = u'id'
    ___SecurityModeCommand_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___SecurityModeCommand_protocolIEs__item__criticality._const_tab = ____SecurityModeCommand_protocolIEs__item__id_tab
    ___SecurityModeCommand_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SecurityModeCommand_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SecurityModeCommand_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___SecurityModeCommand_protocolIEs__item__value._const_tab = ____SecurityModeCommand_protocolIEs__item__id_tab
    ___SecurityModeCommand_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SecurityModeCommand_protocolIEs__item__value._const_tab_id = u'Value'
    __SecurityModeCommand_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SecurityModeCommand_protocolIEs__item__id),
        (u'criticality', ___SecurityModeCommand_protocolIEs__item__criticality),
        (u'value', ___SecurityModeCommand_protocolIEs__item__value),
        ])
    __SecurityModeCommand_protocolIEs__item_._ext = None
    _SecurityModeCommand_protocolIEs._cont = __SecurityModeCommand_protocolIEs__item_
    _SecurityModeCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _SecurityModeCommand_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecurityModeCommand_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SecurityModeCommand_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SecurityModeCommand_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SecurityModeCommand_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityModeCommand_protocolExtensions__item__id._const_tab = ____SecurityModeCommand_protocolExtensions__item__id_tab
    ___SecurityModeCommand_protocolExtensions__item__id._const_tab_at = None
    ___SecurityModeCommand_protocolExtensions__item__id._const_tab_id = u'id'
    ___SecurityModeCommand_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SecurityModeCommand_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SecurityModeCommand_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityModeCommand_protocolExtensions__item__criticality._const_tab = ____SecurityModeCommand_protocolExtensions__item__criticality_tab
    ___SecurityModeCommand_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___SecurityModeCommand_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___SecurityModeCommand_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SecurityModeCommand_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SecurityModeCommand_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityModeCommand_protocolExtensions__item__extensionValue._const_tab = ____SecurityModeCommand_protocolExtensions__item__extensionValue_tab
    ___SecurityModeCommand_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SecurityModeCommand_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __SecurityModeCommand_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___SecurityModeCommand_protocolExtensions__item__id),
        (u'criticality', ___SecurityModeCommand_protocolExtensions__item__criticality),
        (u'extensionValue', ___SecurityModeCommand_protocolExtensions__item__extensionValue),
        ])
    __SecurityModeCommand_protocolExtensions__item_._ext = None
    _SecurityModeCommand_protocolExtensions._cont = __SecurityModeCommand_protocolExtensions__item_
    _SecurityModeCommand_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecurityModeCommand._cont = ASN1Dict([
        (u'protocolIEs', _SecurityModeCommand_protocolIEs),
        (u'protocolExtensions', _SecurityModeCommand_protocolExtensions),
        ])
    SecurityModeCommand._ext = []
    
    #-----< SecurityModeCommandIEs >-----#
    SecurityModeCommandIEs = CLASS(name=u'SecurityModeCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _SecurityModeCommandIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IntegrityProtectionInformation')))
    _SecurityModeCommandIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'EncryptionInformation')))
    _SecurityModeCommandIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'KeyStatus')))
    SecurityModeCommandIEs._val = ASN1Set(rv=[dict([(u'id', 12), (u'criticality', u'reject'), (u'Value', _SecurityModeCommandIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _SecurityModeCommandIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 75), (u'criticality', u'reject'), (u'Value', _SecurityModeCommandIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SecurityModeCommandExtensions >-----#
    SecurityModeCommandExtensions = CLASS(name=u'SecurityModeCommandExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SecurityModeCommandExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecurityModeComplete >-----#
    SecurityModeComplete = SEQ(name=u'SecurityModeComplete', mode=MODE_TYPE)
    _SecurityModeComplete_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __SecurityModeComplete_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___SecurityModeComplete_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____SecurityModeComplete_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____SecurityModeComplete_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ChosenIntegrityProtectionAlgorithm')))
    _____SecurityModeComplete_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ChosenEncryptionAlgorithm')))
    _____SecurityModeComplete_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____SecurityModeComplete_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 6), (u'criticality', u'reject'), (u'Value', _____SecurityModeComplete_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _____SecurityModeComplete_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____SecurityModeComplete_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SecurityModeComplete_protocolIEs__item__id._const_tab = ____SecurityModeComplete_protocolIEs__item__id_tab
    ___SecurityModeComplete_protocolIEs__item__id._const_tab_at = None
    ___SecurityModeComplete_protocolIEs__item__id._const_tab_id = u'id'
    ___SecurityModeComplete_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___SecurityModeComplete_protocolIEs__item__criticality._const_tab = ____SecurityModeComplete_protocolIEs__item__id_tab
    ___SecurityModeComplete_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SecurityModeComplete_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SecurityModeComplete_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___SecurityModeComplete_protocolIEs__item__value._const_tab = ____SecurityModeComplete_protocolIEs__item__id_tab
    ___SecurityModeComplete_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SecurityModeComplete_protocolIEs__item__value._const_tab_id = u'Value'
    __SecurityModeComplete_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SecurityModeComplete_protocolIEs__item__id),
        (u'criticality', ___SecurityModeComplete_protocolIEs__item__criticality),
        (u'value', ___SecurityModeComplete_protocolIEs__item__value),
        ])
    __SecurityModeComplete_protocolIEs__item_._ext = None
    _SecurityModeComplete_protocolIEs._cont = __SecurityModeComplete_protocolIEs__item_
    _SecurityModeComplete_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _SecurityModeComplete_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecurityModeComplete_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SecurityModeComplete_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SecurityModeComplete_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SecurityModeComplete_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityModeComplete_protocolExtensions__item__id._const_tab = ____SecurityModeComplete_protocolExtensions__item__id_tab
    ___SecurityModeComplete_protocolExtensions__item__id._const_tab_at = None
    ___SecurityModeComplete_protocolExtensions__item__id._const_tab_id = u'id'
    ___SecurityModeComplete_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SecurityModeComplete_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SecurityModeComplete_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityModeComplete_protocolExtensions__item__criticality._const_tab = ____SecurityModeComplete_protocolExtensions__item__criticality_tab
    ___SecurityModeComplete_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___SecurityModeComplete_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___SecurityModeComplete_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SecurityModeComplete_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SecurityModeComplete_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityModeComplete_protocolExtensions__item__extensionValue._const_tab = ____SecurityModeComplete_protocolExtensions__item__extensionValue_tab
    ___SecurityModeComplete_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SecurityModeComplete_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __SecurityModeComplete_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___SecurityModeComplete_protocolExtensions__item__id),
        (u'criticality', ___SecurityModeComplete_protocolExtensions__item__criticality),
        (u'extensionValue', ___SecurityModeComplete_protocolExtensions__item__extensionValue),
        ])
    __SecurityModeComplete_protocolExtensions__item_._ext = None
    _SecurityModeComplete_protocolExtensions._cont = __SecurityModeComplete_protocolExtensions__item_
    _SecurityModeComplete_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecurityModeComplete._cont = ASN1Dict([
        (u'protocolIEs', _SecurityModeComplete_protocolIEs),
        (u'protocolExtensions', _SecurityModeComplete_protocolExtensions),
        ])
    SecurityModeComplete._ext = []
    
    #-----< SecurityModeCompleteIEs >-----#
    SecurityModeCompleteIEs = CLASS(name=u'SecurityModeCompleteIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _SecurityModeCompleteIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ChosenIntegrityProtectionAlgorithm')))
    _SecurityModeCompleteIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ChosenEncryptionAlgorithm')))
    _SecurityModeCompleteIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    SecurityModeCompleteIEs._val = ASN1Set(rv=[dict([(u'id', 6), (u'criticality', u'reject'), (u'Value', _SecurityModeCompleteIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _SecurityModeCompleteIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _SecurityModeCompleteIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SecurityModeCompleteExtensions >-----#
    SecurityModeCompleteExtensions = CLASS(name=u'SecurityModeCompleteExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SecurityModeCompleteExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecurityModeReject >-----#
    SecurityModeReject = SEQ(name=u'SecurityModeReject', mode=MODE_TYPE)
    _SecurityModeReject_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __SecurityModeReject_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___SecurityModeReject_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____SecurityModeReject_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____SecurityModeReject_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____SecurityModeReject_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____SecurityModeReject_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____SecurityModeReject_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____SecurityModeReject_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SecurityModeReject_protocolIEs__item__id._const_tab = ____SecurityModeReject_protocolIEs__item__id_tab
    ___SecurityModeReject_protocolIEs__item__id._const_tab_at = None
    ___SecurityModeReject_protocolIEs__item__id._const_tab_id = u'id'
    ___SecurityModeReject_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___SecurityModeReject_protocolIEs__item__criticality._const_tab = ____SecurityModeReject_protocolIEs__item__id_tab
    ___SecurityModeReject_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SecurityModeReject_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SecurityModeReject_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___SecurityModeReject_protocolIEs__item__value._const_tab = ____SecurityModeReject_protocolIEs__item__id_tab
    ___SecurityModeReject_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SecurityModeReject_protocolIEs__item__value._const_tab_id = u'Value'
    __SecurityModeReject_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SecurityModeReject_protocolIEs__item__id),
        (u'criticality', ___SecurityModeReject_protocolIEs__item__criticality),
        (u'value', ___SecurityModeReject_protocolIEs__item__value),
        ])
    __SecurityModeReject_protocolIEs__item_._ext = None
    _SecurityModeReject_protocolIEs._cont = __SecurityModeReject_protocolIEs__item_
    _SecurityModeReject_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _SecurityModeReject_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecurityModeReject_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SecurityModeReject_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SecurityModeReject_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SecurityModeReject_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityModeReject_protocolExtensions__item__id._const_tab = ____SecurityModeReject_protocolExtensions__item__id_tab
    ___SecurityModeReject_protocolExtensions__item__id._const_tab_at = None
    ___SecurityModeReject_protocolExtensions__item__id._const_tab_id = u'id'
    ___SecurityModeReject_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SecurityModeReject_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SecurityModeReject_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityModeReject_protocolExtensions__item__criticality._const_tab = ____SecurityModeReject_protocolExtensions__item__criticality_tab
    ___SecurityModeReject_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___SecurityModeReject_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___SecurityModeReject_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SecurityModeReject_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SecurityModeReject_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityModeReject_protocolExtensions__item__extensionValue._const_tab = ____SecurityModeReject_protocolExtensions__item__extensionValue_tab
    ___SecurityModeReject_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SecurityModeReject_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __SecurityModeReject_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___SecurityModeReject_protocolExtensions__item__id),
        (u'criticality', ___SecurityModeReject_protocolExtensions__item__criticality),
        (u'extensionValue', ___SecurityModeReject_protocolExtensions__item__extensionValue),
        ])
    __SecurityModeReject_protocolExtensions__item_._ext = None
    _SecurityModeReject_protocolExtensions._cont = __SecurityModeReject_protocolExtensions__item_
    _SecurityModeReject_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecurityModeReject._cont = ASN1Dict([
        (u'protocolIEs', _SecurityModeReject_protocolIEs),
        (u'protocolExtensions', _SecurityModeReject_protocolExtensions),
        ])
    SecurityModeReject._ext = []
    
    #-----< SecurityModeRejectIEs >-----#
    SecurityModeRejectIEs = CLASS(name=u'SecurityModeRejectIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _SecurityModeRejectIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _SecurityModeRejectIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    SecurityModeRejectIEs._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _SecurityModeRejectIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _SecurityModeRejectIEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SecurityModeRejectExtensions >-----#
    SecurityModeRejectExtensions = CLASS(name=u'SecurityModeRejectExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SecurityModeRejectExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DataVolumeReportRequest >-----#
    DataVolumeReportRequest = SEQ(name=u'DataVolumeReportRequest', mode=MODE_TYPE)
    _DataVolumeReportRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __DataVolumeReportRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___DataVolumeReportRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____DataVolumeReportRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____DataVolumeReportRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataVolumeReportRequestList')))
    ____DataVolumeReportRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 33), (u'criticality', u'ignore'), (u'Value', _____DataVolumeReportRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___DataVolumeReportRequest_protocolIEs__item__id._const_tab = ____DataVolumeReportRequest_protocolIEs__item__id_tab
    ___DataVolumeReportRequest_protocolIEs__item__id._const_tab_at = None
    ___DataVolumeReportRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___DataVolumeReportRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___DataVolumeReportRequest_protocolIEs__item__criticality._const_tab = ____DataVolumeReportRequest_protocolIEs__item__id_tab
    ___DataVolumeReportRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DataVolumeReportRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DataVolumeReportRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___DataVolumeReportRequest_protocolIEs__item__value._const_tab = ____DataVolumeReportRequest_protocolIEs__item__id_tab
    ___DataVolumeReportRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DataVolumeReportRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __DataVolumeReportRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DataVolumeReportRequest_protocolIEs__item__id),
        (u'criticality', ___DataVolumeReportRequest_protocolIEs__item__criticality),
        (u'value', ___DataVolumeReportRequest_protocolIEs__item__value),
        ])
    __DataVolumeReportRequest_protocolIEs__item_._ext = None
    _DataVolumeReportRequest_protocolIEs._cont = __DataVolumeReportRequest_protocolIEs__item_
    _DataVolumeReportRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DataVolumeReportRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DataVolumeReportRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___DataVolumeReportRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DataVolumeReportRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____DataVolumeReportRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataVolumeReportRequest_protocolExtensions__item__id._const_tab = ____DataVolumeReportRequest_protocolExtensions__item__id_tab
    ___DataVolumeReportRequest_protocolExtensions__item__id._const_tab_at = None
    ___DataVolumeReportRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___DataVolumeReportRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DataVolumeReportRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____DataVolumeReportRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataVolumeReportRequest_protocolExtensions__item__criticality._const_tab = ____DataVolumeReportRequest_protocolExtensions__item__criticality_tab
    ___DataVolumeReportRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___DataVolumeReportRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___DataVolumeReportRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DataVolumeReportRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____DataVolumeReportRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataVolumeReportRequest_protocolExtensions__item__extensionValue._const_tab = ____DataVolumeReportRequest_protocolExtensions__item__extensionValue_tab
    ___DataVolumeReportRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DataVolumeReportRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __DataVolumeReportRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___DataVolumeReportRequest_protocolExtensions__item__id),
        (u'criticality', ___DataVolumeReportRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___DataVolumeReportRequest_protocolExtensions__item__extensionValue),
        ])
    __DataVolumeReportRequest_protocolExtensions__item_._ext = None
    _DataVolumeReportRequest_protocolExtensions._cont = __DataVolumeReportRequest_protocolExtensions__item_
    _DataVolumeReportRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DataVolumeReportRequest._cont = ASN1Dict([
        (u'protocolIEs', _DataVolumeReportRequest_protocolIEs),
        (u'protocolExtensions', _DataVolumeReportRequest_protocolExtensions),
        ])
    DataVolumeReportRequest._ext = []
    
    #-----< DataVolumeReportRequestIEs >-----#
    DataVolumeReportRequestIEs = CLASS(name=u'DataVolumeReportRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _DataVolumeReportRequestIEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataVolumeReportRequestList')))
    DataVolumeReportRequestIEs._val = ASN1Set(rv=[dict([(u'id', 33), (u'criticality', u'ignore'), (u'Value', _DataVolumeReportRequestIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-DataVolumeReportRequestList >-----#
    RAB_DataVolumeReportRequestList = SEQ_OF(name=u'RAB-DataVolumeReportRequestList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_DataVolumeReportRequestList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_DataVolumeReportRequestList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_DataVolumeReportRequestList__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_DataVolumeReportRequestList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_DataVolumeReportRequestList__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataVolumeReportRequestItem')))
    ____RAB_DataVolumeReportRequestList__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 32), (u'criticality', u'reject'), (u'Value', _____RAB_DataVolumeReportRequestList__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_DataVolumeReportRequestList__item___item__id._const_tab = ____RAB_DataVolumeReportRequestList__item___item__id_tab
    ___RAB_DataVolumeReportRequestList__item___item__id._const_tab_at = None
    ___RAB_DataVolumeReportRequestList__item___item__id._const_tab_id = u'id'
    ___RAB_DataVolumeReportRequestList__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_DataVolumeReportRequestList__item___item__criticality._const_tab = ____RAB_DataVolumeReportRequestList__item___item__id_tab
    ___RAB_DataVolumeReportRequestList__item___item__criticality._const_tab_at = ('..', u'id')
    ___RAB_DataVolumeReportRequestList__item___item__criticality._const_tab_id = u'criticality'
    ___RAB_DataVolumeReportRequestList__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_DataVolumeReportRequestList__item___item__value._const_tab = ____RAB_DataVolumeReportRequestList__item___item__id_tab
    ___RAB_DataVolumeReportRequestList__item___item__value._const_tab_at = ('..', u'id')
    ___RAB_DataVolumeReportRequestList__item___item__value._const_tab_id = u'Value'
    __RAB_DataVolumeReportRequestList__item___item_._cont = ASN1Dict([
        (u'id', ___RAB_DataVolumeReportRequestList__item___item__id),
        (u'criticality', ___RAB_DataVolumeReportRequestList__item___item__criticality),
        (u'value', ___RAB_DataVolumeReportRequestList__item___item__value),
        ])
    __RAB_DataVolumeReportRequestList__item___item_._ext = None
    _RAB_DataVolumeReportRequestList__item_._cont = __RAB_DataVolumeReportRequestList__item___item_
    _RAB_DataVolumeReportRequestList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_DataVolumeReportRequestList._cont = _RAB_DataVolumeReportRequestList__item_
    RAB_DataVolumeReportRequestList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-DataVolumeReportRequestItemIEs >-----#
    RAB_DataVolumeReportRequestItemIEs = CLASS(name=u'RAB-DataVolumeReportRequestItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_DataVolumeReportRequestItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataVolumeReportRequestItem')))
    RAB_DataVolumeReportRequestItemIEs._val = ASN1Set(rv=[dict([(u'id', 32), (u'criticality', u'reject'), (u'Value', _RAB_DataVolumeReportRequestItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-DataVolumeReportRequestItem >-----#
    RAB_DataVolumeReportRequestItem = SEQ(name=u'RAB-DataVolumeReportRequestItem', mode=MODE_TYPE)
    _RAB_DataVolumeReportRequestItem_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_DataVolumeReportRequestItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_DataVolumeReportRequestItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_DataVolumeReportRequestItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_DataVolumeReportRequestItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__id._const_tab = ____RAB_DataVolumeReportRequestItem_iE_Extensions__item__id_tab
    ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__id._const_tab_at = None
    ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RAB_DataVolumeReportRequestItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_DataVolumeReportRequestItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__criticality._const_tab = ____RAB_DataVolumeReportRequestItem_iE_Extensions__item__criticality_tab
    ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RAB_DataVolumeReportRequestItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_DataVolumeReportRequestItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__extensionValue._const_tab = ____RAB_DataVolumeReportRequestItem_iE_Extensions__item__extensionValue_tab
    ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_DataVolumeReportRequestItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__id),
        (u'criticality', ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__extensionValue),
        ])
    __RAB_DataVolumeReportRequestItem_iE_Extensions__item_._ext = None
    _RAB_DataVolumeReportRequestItem_iE_Extensions._cont = __RAB_DataVolumeReportRequestItem_iE_Extensions__item_
    _RAB_DataVolumeReportRequestItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_DataVolumeReportRequestItem._cont = ASN1Dict([
        (u'rAB-ID', _RAB_DataVolumeReportRequestItem_rAB_ID),
        (u'iE-Extensions', _RAB_DataVolumeReportRequestItem_iE_Extensions),
        ])
    RAB_DataVolumeReportRequestItem._ext = []
    
    #-----< RAB-DataVolumeReportRequestItem-ExtIEs >-----#
    RAB_DataVolumeReportRequestItem_ExtIEs = CLASS(name=u'RAB-DataVolumeReportRequestItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_DataVolumeReportRequestItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DataVolumeReportRequestExtensions >-----#
    DataVolumeReportRequestExtensions = CLASS(name=u'DataVolumeReportRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    DataVolumeReportRequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DataVolumeReport >-----#
    DataVolumeReport = SEQ(name=u'DataVolumeReport', mode=MODE_TYPE)
    _DataVolumeReport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __DataVolumeReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___DataVolumeReport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____DataVolumeReport_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____DataVolumeReport_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataVolumeReportList')))
    _____DataVolumeReport_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedtoReportList')))
    _____DataVolumeReport_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____DataVolumeReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 31), (u'criticality', u'ignore'), (u'Value', _____DataVolumeReport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 72), (u'criticality', u'ignore'), (u'Value', _____DataVolumeReport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____DataVolumeReport_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DataVolumeReport_protocolIEs__item__id._const_tab = ____DataVolumeReport_protocolIEs__item__id_tab
    ___DataVolumeReport_protocolIEs__item__id._const_tab_at = None
    ___DataVolumeReport_protocolIEs__item__id._const_tab_id = u'id'
    ___DataVolumeReport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___DataVolumeReport_protocolIEs__item__criticality._const_tab = ____DataVolumeReport_protocolIEs__item__id_tab
    ___DataVolumeReport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DataVolumeReport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DataVolumeReport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___DataVolumeReport_protocolIEs__item__value._const_tab = ____DataVolumeReport_protocolIEs__item__id_tab
    ___DataVolumeReport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DataVolumeReport_protocolIEs__item__value._const_tab_id = u'Value'
    __DataVolumeReport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DataVolumeReport_protocolIEs__item__id),
        (u'criticality', ___DataVolumeReport_protocolIEs__item__criticality),
        (u'value', ___DataVolumeReport_protocolIEs__item__value),
        ])
    __DataVolumeReport_protocolIEs__item_._ext = None
    _DataVolumeReport_protocolIEs._cont = __DataVolumeReport_protocolIEs__item_
    _DataVolumeReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DataVolumeReport_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DataVolumeReport_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___DataVolumeReport_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DataVolumeReport_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____DataVolumeReport_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataVolumeReport_protocolExtensions__item__id._const_tab = ____DataVolumeReport_protocolExtensions__item__id_tab
    ___DataVolumeReport_protocolExtensions__item__id._const_tab_at = None
    ___DataVolumeReport_protocolExtensions__item__id._const_tab_id = u'id'
    ___DataVolumeReport_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DataVolumeReport_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____DataVolumeReport_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataVolumeReport_protocolExtensions__item__criticality._const_tab = ____DataVolumeReport_protocolExtensions__item__criticality_tab
    ___DataVolumeReport_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___DataVolumeReport_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___DataVolumeReport_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DataVolumeReport_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____DataVolumeReport_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataVolumeReport_protocolExtensions__item__extensionValue._const_tab = ____DataVolumeReport_protocolExtensions__item__extensionValue_tab
    ___DataVolumeReport_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DataVolumeReport_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __DataVolumeReport_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___DataVolumeReport_protocolExtensions__item__id),
        (u'criticality', ___DataVolumeReport_protocolExtensions__item__criticality),
        (u'extensionValue', ___DataVolumeReport_protocolExtensions__item__extensionValue),
        ])
    __DataVolumeReport_protocolExtensions__item_._ext = None
    _DataVolumeReport_protocolExtensions._cont = __DataVolumeReport_protocolExtensions__item_
    _DataVolumeReport_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DataVolumeReport._cont = ASN1Dict([
        (u'protocolIEs', _DataVolumeReport_protocolIEs),
        (u'protocolExtensions', _DataVolumeReport_protocolExtensions),
        ])
    DataVolumeReport._ext = []
    
    #-----< DataVolumeReportIEs >-----#
    DataVolumeReportIEs = CLASS(name=u'DataVolumeReportIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _DataVolumeReportIEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataVolumeReportList')))
    _DataVolumeReportIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedtoReportList')))
    _DataVolumeReportIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    DataVolumeReportIEs._val = ASN1Set(rv=[dict([(u'id', 31), (u'criticality', u'ignore'), (u'Value', _DataVolumeReportIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 72), (u'criticality', u'ignore'), (u'Value', _DataVolumeReportIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _DataVolumeReportIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DataVolumeReportExtensions >-----#
    DataVolumeReportExtensions = CLASS(name=u'DataVolumeReportExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    DataVolumeReportExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-FailedtoReportList >-----#
    RAB_FailedtoReportList = SEQ_OF(name=u'RAB-FailedtoReportList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_FailedtoReportList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_FailedtoReportList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_FailedtoReportList__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_FailedtoReportList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_FailedtoReportList__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RABs-failed-to-reportItem')))
    ____RAB_FailedtoReportList__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 71), (u'criticality', u'ignore'), (u'Value', _____RAB_FailedtoReportList__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_FailedtoReportList__item___item__id._const_tab = ____RAB_FailedtoReportList__item___item__id_tab
    ___RAB_FailedtoReportList__item___item__id._const_tab_at = None
    ___RAB_FailedtoReportList__item___item__id._const_tab_id = u'id'
    ___RAB_FailedtoReportList__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_FailedtoReportList__item___item__criticality._const_tab = ____RAB_FailedtoReportList__item___item__id_tab
    ___RAB_FailedtoReportList__item___item__criticality._const_tab_at = ('..', u'id')
    ___RAB_FailedtoReportList__item___item__criticality._const_tab_id = u'criticality'
    ___RAB_FailedtoReportList__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_FailedtoReportList__item___item__value._const_tab = ____RAB_FailedtoReportList__item___item__id_tab
    ___RAB_FailedtoReportList__item___item__value._const_tab_at = ('..', u'id')
    ___RAB_FailedtoReportList__item___item__value._const_tab_id = u'Value'
    __RAB_FailedtoReportList__item___item_._cont = ASN1Dict([
        (u'id', ___RAB_FailedtoReportList__item___item__id),
        (u'criticality', ___RAB_FailedtoReportList__item___item__criticality),
        (u'value', ___RAB_FailedtoReportList__item___item__value),
        ])
    __RAB_FailedtoReportList__item___item_._ext = None
    _RAB_FailedtoReportList__item_._cont = __RAB_FailedtoReportList__item___item_
    _RAB_FailedtoReportList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_FailedtoReportList._cont = _RAB_FailedtoReportList__item_
    RAB_FailedtoReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RABs-failed-to-reportItemIEs >-----#
    RABs_failed_to_reportItemIEs = CLASS(name=u'RABs-failed-to-reportItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RABs_failed_to_reportItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RABs-failed-to-reportItem')))
    RABs_failed_to_reportItemIEs._val = ASN1Set(rv=[dict([(u'id', 71), (u'criticality', u'ignore'), (u'Value', _RABs_failed_to_reportItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RABs-failed-to-reportItem >-----#
    RABs_failed_to_reportItem = SEQ(name=u'RABs-failed-to-reportItem', mode=MODE_TYPE)
    _RABs_failed_to_reportItem_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RABs_failed_to_reportItem_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _RABs_failed_to_reportItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RABs_failed_to_reportItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RABs_failed_to_reportItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RABs_failed_to_reportItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RABs_failed_to_reportItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RABs_failed_to_reportItem_iE_Extensions__item__id._const_tab = ____RABs_failed_to_reportItem_iE_Extensions__item__id_tab
    ___RABs_failed_to_reportItem_iE_Extensions__item__id._const_tab_at = None
    ___RABs_failed_to_reportItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___RABs_failed_to_reportItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RABs_failed_to_reportItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RABs_failed_to_reportItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RABs_failed_to_reportItem_iE_Extensions__item__criticality._const_tab = ____RABs_failed_to_reportItem_iE_Extensions__item__criticality_tab
    ___RABs_failed_to_reportItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RABs_failed_to_reportItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RABs_failed_to_reportItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RABs_failed_to_reportItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RABs_failed_to_reportItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RABs_failed_to_reportItem_iE_Extensions__item__extensionValue._const_tab = ____RABs_failed_to_reportItem_iE_Extensions__item__extensionValue_tab
    ___RABs_failed_to_reportItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RABs_failed_to_reportItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RABs_failed_to_reportItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RABs_failed_to_reportItem_iE_Extensions__item__id),
        (u'criticality', ___RABs_failed_to_reportItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___RABs_failed_to_reportItem_iE_Extensions__item__extensionValue),
        ])
    __RABs_failed_to_reportItem_iE_Extensions__item_._ext = None
    _RABs_failed_to_reportItem_iE_Extensions._cont = __RABs_failed_to_reportItem_iE_Extensions__item_
    _RABs_failed_to_reportItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RABs_failed_to_reportItem._cont = ASN1Dict([
        (u'rAB-ID', _RABs_failed_to_reportItem_rAB_ID),
        (u'cause', _RABs_failed_to_reportItem_cause),
        (u'iE-Extensions', _RABs_failed_to_reportItem_iE_Extensions),
        ])
    RABs_failed_to_reportItem._ext = []
    
    #-----< RABs-failed-to-reportItem-ExtIEs >-----#
    RABs_failed_to_reportItem_ExtIEs = CLASS(name=u'RABs-failed-to-reportItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RABs_failed_to_reportItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Reset >-----#
    Reset = SEQ(name=u'Reset', mode=MODE_TYPE)
    _Reset_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __Reset_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___Reset_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____Reset_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____Reset_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____Reset_protocolIEs__item__id_tab_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____Reset_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ____Reset_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____Reset_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 3), (u'criticality', u'reject'), (u'Value', _____Reset_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _____Reset_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Reset_protocolIEs__item__id._const_tab = ____Reset_protocolIEs__item__id_tab
    ___Reset_protocolIEs__item__id._const_tab_at = None
    ___Reset_protocolIEs__item__id._const_tab_id = u'id'
    ___Reset_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___Reset_protocolIEs__item__criticality._const_tab = ____Reset_protocolIEs__item__id_tab
    ___Reset_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___Reset_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___Reset_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___Reset_protocolIEs__item__value._const_tab = ____Reset_protocolIEs__item__id_tab
    ___Reset_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___Reset_protocolIEs__item__value._const_tab_id = u'Value'
    __Reset_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___Reset_protocolIEs__item__id),
        (u'criticality', ___Reset_protocolIEs__item__criticality),
        (u'value', ___Reset_protocolIEs__item__value),
        ])
    __Reset_protocolIEs__item_._ext = None
    _Reset_protocolIEs._cont = __Reset_protocolIEs__item_
    _Reset_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _Reset_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Reset_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Reset_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Reset_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____Reset_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____Reset_protocolExtensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ____Reset_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 96), (u'criticality', u'ignore'), (u'Extension', _____Reset_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _____Reset_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Reset_protocolExtensions__item__id._const_tab = ____Reset_protocolExtensions__item__id_tab
    ___Reset_protocolExtensions__item__id._const_tab_at = None
    ___Reset_protocolExtensions__item__id._const_tab_id = u'id'
    ___Reset_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Reset_protocolExtensions__item__criticality._const_tab = ____Reset_protocolExtensions__item__id_tab
    ___Reset_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___Reset_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___Reset_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Reset_protocolExtensions__item__extensionValue._const_tab = ____Reset_protocolExtensions__item__id_tab
    ___Reset_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Reset_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __Reset_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___Reset_protocolExtensions__item__id),
        (u'criticality', ___Reset_protocolExtensions__item__criticality),
        (u'extensionValue', ___Reset_protocolExtensions__item__extensionValue),
        ])
    __Reset_protocolExtensions__item_._ext = None
    _Reset_protocolExtensions._cont = __Reset_protocolExtensions__item_
    _Reset_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Reset._cont = ASN1Dict([
        (u'protocolIEs', _Reset_protocolIEs),
        (u'protocolExtensions', _Reset_protocolExtensions),
        ])
    Reset._ext = []
    
    #-----< ResetIEs >-----#
    ResetIEs = CLASS(name=u'ResetIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _ResetIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _ResetIEs_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _ResetIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ResetIEs._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _ResetIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 3), (u'criticality', u'reject'), (u'Value', _ResetIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _ResetIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResetExtensions >-----#
    ResetExtensions = CLASS(name=u'ResetExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _ResetExtensions_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _ResetExtensions_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ResetExtensions._val = ASN1Set(rv=[dict([(u'id', 96), (u'criticality', u'ignore'), (u'Extension', _ResetExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _ResetExtensions_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResetAcknowledge >-----#
    ResetAcknowledge = SEQ(name=u'ResetAcknowledge', mode=MODE_TYPE)
    _ResetAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __ResetAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___ResetAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____ResetAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ____ResetAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'reject'), (u'Value', _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ResetAcknowledge_protocolIEs__item__id._const_tab = ____ResetAcknowledge_protocolIEs__item__id_tab
    ___ResetAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___ResetAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___ResetAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___ResetAcknowledge_protocolIEs__item__criticality._const_tab = ____ResetAcknowledge_protocolIEs__item__id_tab
    ___ResetAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ResetAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ResetAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___ResetAcknowledge_protocolIEs__item__value._const_tab = ____ResetAcknowledge_protocolIEs__item__id_tab
    ___ResetAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ResetAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __ResetAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ResetAcknowledge_protocolIEs__item__id),
        (u'criticality', ___ResetAcknowledge_protocolIEs__item__criticality),
        (u'value', ___ResetAcknowledge_protocolIEs__item__value),
        ])
    __ResetAcknowledge_protocolIEs__item_._ext = None
    _ResetAcknowledge_protocolIEs._cont = __ResetAcknowledge_protocolIEs__item_
    _ResetAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ResetAcknowledge_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResetAcknowledge_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___ResetAcknowledge_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ResetAcknowledge_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____ResetAcknowledge_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____ResetAcknowledge_protocolExtensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ____ResetAcknowledge_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 96), (u'criticality', u'ignore'), (u'Extension', _____ResetAcknowledge_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _____ResetAcknowledge_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ResetAcknowledge_protocolExtensions__item__id._const_tab = ____ResetAcknowledge_protocolExtensions__item__id_tab
    ___ResetAcknowledge_protocolExtensions__item__id._const_tab_at = None
    ___ResetAcknowledge_protocolExtensions__item__id._const_tab_id = u'id'
    ___ResetAcknowledge_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ResetAcknowledge_protocolExtensions__item__criticality._const_tab = ____ResetAcknowledge_protocolExtensions__item__id_tab
    ___ResetAcknowledge_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResetAcknowledge_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___ResetAcknowledge_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ResetAcknowledge_protocolExtensions__item__extensionValue._const_tab = ____ResetAcknowledge_protocolExtensions__item__id_tab
    ___ResetAcknowledge_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResetAcknowledge_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __ResetAcknowledge_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___ResetAcknowledge_protocolExtensions__item__id),
        (u'criticality', ___ResetAcknowledge_protocolExtensions__item__criticality),
        (u'extensionValue', ___ResetAcknowledge_protocolExtensions__item__extensionValue),
        ])
    __ResetAcknowledge_protocolExtensions__item_._ext = None
    _ResetAcknowledge_protocolExtensions._cont = __ResetAcknowledge_protocolExtensions__item_
    _ResetAcknowledge_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResetAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _ResetAcknowledge_protocolIEs),
        (u'protocolExtensions', _ResetAcknowledge_protocolExtensions),
        ])
    ResetAcknowledge._ext = []
    
    #-----< ResetAcknowledgeIEs >-----#
    ResetAcknowledgeIEs = CLASS(name=u'ResetAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _ResetAcknowledgeIEs_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _ResetAcknowledgeIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    _ResetAcknowledgeIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ResetAcknowledgeIEs._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'reject'), (u'Value', _ResetAcknowledgeIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _ResetAcknowledgeIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _ResetAcknowledgeIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResetAcknowledgeExtensions >-----#
    ResetAcknowledgeExtensions = CLASS(name=u'ResetAcknowledgeExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _ResetAcknowledgeExtensions_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _ResetAcknowledgeExtensions_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ResetAcknowledgeExtensions._val = ASN1Set(rv=[dict([(u'id', 96), (u'criticality', u'ignore'), (u'Extension', _ResetAcknowledgeExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _ResetAcknowledgeExtensions_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResetResource >-----#
    ResetResource = SEQ(name=u'ResetResource', mode=MODE_TYPE)
    _ResetResource_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __ResetResource_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___ResetResource_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____ResetResource_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____ResetResource_protocolIEs__item__id_tab_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____ResetResource_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____ResetResource_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceList')))
    _____ResetResource_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ____ResetResource_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'reject'), (u'Value', _____ResetResource_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____ResetResource_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 77), (u'criticality', u'ignore'), (u'Value', _____ResetResource_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _____ResetResource_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ResetResource_protocolIEs__item__id._const_tab = ____ResetResource_protocolIEs__item__id_tab
    ___ResetResource_protocolIEs__item__id._const_tab_at = None
    ___ResetResource_protocolIEs__item__id._const_tab_id = u'id'
    ___ResetResource_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___ResetResource_protocolIEs__item__criticality._const_tab = ____ResetResource_protocolIEs__item__id_tab
    ___ResetResource_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ResetResource_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ResetResource_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___ResetResource_protocolIEs__item__value._const_tab = ____ResetResource_protocolIEs__item__id_tab
    ___ResetResource_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ResetResource_protocolIEs__item__value._const_tab_id = u'Value'
    __ResetResource_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ResetResource_protocolIEs__item__id),
        (u'criticality', ___ResetResource_protocolIEs__item__criticality),
        (u'value', ___ResetResource_protocolIEs__item__value),
        ])
    __ResetResource_protocolIEs__item_._ext = None
    _ResetResource_protocolIEs._cont = __ResetResource_protocolIEs__item_
    _ResetResource_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ResetResource_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResetResource_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___ResetResource_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ResetResource_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____ResetResource_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____ResetResource_protocolExtensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ____ResetResource_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 96), (u'criticality', u'ignore'), (u'Extension', _____ResetResource_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _____ResetResource_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ResetResource_protocolExtensions__item__id._const_tab = ____ResetResource_protocolExtensions__item__id_tab
    ___ResetResource_protocolExtensions__item__id._const_tab_at = None
    ___ResetResource_protocolExtensions__item__id._const_tab_id = u'id'
    ___ResetResource_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ResetResource_protocolExtensions__item__criticality._const_tab = ____ResetResource_protocolExtensions__item__id_tab
    ___ResetResource_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResetResource_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___ResetResource_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ResetResource_protocolExtensions__item__extensionValue._const_tab = ____ResetResource_protocolExtensions__item__id_tab
    ___ResetResource_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResetResource_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __ResetResource_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___ResetResource_protocolExtensions__item__id),
        (u'criticality', ___ResetResource_protocolExtensions__item__criticality),
        (u'extensionValue', ___ResetResource_protocolExtensions__item__extensionValue),
        ])
    __ResetResource_protocolExtensions__item_._ext = None
    _ResetResource_protocolExtensions._cont = __ResetResource_protocolExtensions__item_
    _ResetResource_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResetResource._cont = ASN1Dict([
        (u'protocolIEs', _ResetResource_protocolIEs),
        (u'protocolExtensions', _ResetResource_protocolExtensions),
        ])
    ResetResource._ext = []
    
    #-----< ResetResourceIEs >-----#
    ResetResourceIEs = CLASS(name=u'ResetResourceIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _ResetResourceIEs_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _ResetResourceIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _ResetResourceIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceList')))
    _ResetResourceIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ResetResourceIEs._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'reject'), (u'Value', _ResetResourceIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _ResetResourceIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 77), (u'criticality', u'ignore'), (u'Value', _ResetResourceIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _ResetResourceIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResetResourceList >-----#
    ResetResourceList = SEQ_OF(name=u'ResetResourceList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'IuSigConId-IE-ContainerList')))
    _ResetResourceList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __ResetResourceList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___ResetResourceList__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____ResetResourceList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____ResetResourceList__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceItem')))
    ____ResetResourceList__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____ResetResourceList__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___ResetResourceList__item___item__id._const_tab = ____ResetResourceList__item___item__id_tab
    ___ResetResourceList__item___item__id._const_tab_at = None
    ___ResetResourceList__item___item__id._const_tab_id = u'id'
    ___ResetResourceList__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___ResetResourceList__item___item__criticality._const_tab = ____ResetResourceList__item___item__id_tab
    ___ResetResourceList__item___item__criticality._const_tab_at = ('..', u'id')
    ___ResetResourceList__item___item__criticality._const_tab_id = u'criticality'
    ___ResetResourceList__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___ResetResourceList__item___item__value._const_tab = ____ResetResourceList__item___item__id_tab
    ___ResetResourceList__item___item__value._const_tab_at = ('..', u'id')
    ___ResetResourceList__item___item__value._const_tab_id = u'Value'
    __ResetResourceList__item___item_._cont = ASN1Dict([
        (u'id', ___ResetResourceList__item___item__id),
        (u'criticality', ___ResetResourceList__item___item__criticality),
        (u'value', ___ResetResourceList__item___item__value),
        ])
    __ResetResourceList__item___item_._ext = None
    _ResetResourceList__item_._cont = __ResetResourceList__item___item_
    _ResetResourceList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResetResourceList._cont = _ResetResourceList__item_
    ResetResourceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=250)], ev=None, er=[])
    
    #-----< ResetResourceItemIEs >-----#
    ResetResourceItemIEs = CLASS(name=u'ResetResourceItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _ResetResourceItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceItem')))
    ResetResourceItemIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _ResetResourceItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ResetResourceItem >-----#
    ResetResourceItem = SEQ(name=u'ResetResourceItem', mode=MODE_TYPE)
    _ResetResourceItem_iuSigConId = BIT_STR(name=u'iuSigConId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _ResetResourceItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResetResourceItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___ResetResourceItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ResetResourceItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____ResetResourceItem_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    ____ResetResourceItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 282), (u'criticality', u'reject'), (u'Extension', _____ResetResourceItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ResetResourceItem_iE_Extensions__item__id._const_tab = ____ResetResourceItem_iE_Extensions__item__id_tab
    ___ResetResourceItem_iE_Extensions__item__id._const_tab_at = None
    ___ResetResourceItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResetResourceItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ResetResourceItem_iE_Extensions__item__criticality._const_tab = ____ResetResourceItem_iE_Extensions__item__id_tab
    ___ResetResourceItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResetResourceItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResetResourceItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ResetResourceItem_iE_Extensions__item__extensionValue._const_tab = ____ResetResourceItem_iE_Extensions__item__id_tab
    ___ResetResourceItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResetResourceItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResetResourceItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResetResourceItem_iE_Extensions__item__id),
        (u'criticality', ___ResetResourceItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResetResourceItem_iE_Extensions__item__extensionValue),
        ])
    __ResetResourceItem_iE_Extensions__item_._ext = None
    _ResetResourceItem_iE_Extensions._cont = __ResetResourceItem_iE_Extensions__item_
    _ResetResourceItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResetResourceItem._cont = ASN1Dict([
        (u'iuSigConId', _ResetResourceItem_iuSigConId),
        (u'iE-Extensions', _ResetResourceItem_iE_Extensions),
        ])
    ResetResourceItem._ext = []
    
    #-----< ResetResourceItem-ExtIEs >-----#
    ResetResourceItem_ExtIEs = CLASS(name=u'ResetResourceItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _ResetResourceItem_ExtIEs_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    ResetResourceItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 282), (u'criticality', u'reject'), (u'Extension', _ResetResourceItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResetResourceExtensions >-----#
    ResetResourceExtensions = CLASS(name=u'ResetResourceExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _ResetResourceExtensions_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _ResetResourceExtensions_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ResetResourceExtensions._val = ASN1Set(rv=[dict([(u'id', 96), (u'criticality', u'ignore'), (u'Extension', _ResetResourceExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _ResetResourceExtensions_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResetResourceAcknowledge >-----#
    ResetResourceAcknowledge = SEQ(name=u'ResetResourceAcknowledge', mode=MODE_TYPE)
    _ResetResourceAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __ResetResourceAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___ResetResourceAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____ResetResourceAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____ResetResourceAcknowledge_protocolIEs__item__id_tab_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____ResetResourceAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceAckList')))
    _____ResetResourceAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    _____ResetResourceAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____ResetResourceAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'reject'), (u'Value', _____ResetResourceAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 77), (u'criticality', u'ignore'), (u'Value', _____ResetResourceAcknowledge_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _____ResetResourceAcknowledge_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____ResetResourceAcknowledge_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ResetResourceAcknowledge_protocolIEs__item__id._const_tab = ____ResetResourceAcknowledge_protocolIEs__item__id_tab
    ___ResetResourceAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___ResetResourceAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___ResetResourceAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___ResetResourceAcknowledge_protocolIEs__item__criticality._const_tab = ____ResetResourceAcknowledge_protocolIEs__item__id_tab
    ___ResetResourceAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ResetResourceAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ResetResourceAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___ResetResourceAcknowledge_protocolIEs__item__value._const_tab = ____ResetResourceAcknowledge_protocolIEs__item__id_tab
    ___ResetResourceAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ResetResourceAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __ResetResourceAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ResetResourceAcknowledge_protocolIEs__item__id),
        (u'criticality', ___ResetResourceAcknowledge_protocolIEs__item__criticality),
        (u'value', ___ResetResourceAcknowledge_protocolIEs__item__value),
        ])
    __ResetResourceAcknowledge_protocolIEs__item_._ext = None
    _ResetResourceAcknowledge_protocolIEs._cont = __ResetResourceAcknowledge_protocolIEs__item_
    _ResetResourceAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ResetResourceAcknowledge_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResetResourceAcknowledge_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___ResetResourceAcknowledge_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ResetResourceAcknowledge_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____ResetResourceAcknowledge_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____ResetResourceAcknowledge_protocolExtensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ____ResetResourceAcknowledge_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 96), (u'criticality', u'ignore'), (u'Extension', _____ResetResourceAcknowledge_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _____ResetResourceAcknowledge_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ResetResourceAcknowledge_protocolExtensions__item__id._const_tab = ____ResetResourceAcknowledge_protocolExtensions__item__id_tab
    ___ResetResourceAcknowledge_protocolExtensions__item__id._const_tab_at = None
    ___ResetResourceAcknowledge_protocolExtensions__item__id._const_tab_id = u'id'
    ___ResetResourceAcknowledge_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ResetResourceAcknowledge_protocolExtensions__item__criticality._const_tab = ____ResetResourceAcknowledge_protocolExtensions__item__id_tab
    ___ResetResourceAcknowledge_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResetResourceAcknowledge_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___ResetResourceAcknowledge_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ResetResourceAcknowledge_protocolExtensions__item__extensionValue._const_tab = ____ResetResourceAcknowledge_protocolExtensions__item__id_tab
    ___ResetResourceAcknowledge_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResetResourceAcknowledge_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __ResetResourceAcknowledge_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___ResetResourceAcknowledge_protocolExtensions__item__id),
        (u'criticality', ___ResetResourceAcknowledge_protocolExtensions__item__criticality),
        (u'extensionValue', ___ResetResourceAcknowledge_protocolExtensions__item__extensionValue),
        ])
    __ResetResourceAcknowledge_protocolExtensions__item_._ext = None
    _ResetResourceAcknowledge_protocolExtensions._cont = __ResetResourceAcknowledge_protocolExtensions__item_
    _ResetResourceAcknowledge_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResetResourceAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _ResetResourceAcknowledge_protocolIEs),
        (u'protocolExtensions', _ResetResourceAcknowledge_protocolExtensions),
        ])
    ResetResourceAcknowledge._ext = []
    
    #-----< ResetResourceAcknowledgeIEs >-----#
    ResetResourceAcknowledgeIEs = CLASS(name=u'ResetResourceAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _ResetResourceAcknowledgeIEs_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _ResetResourceAcknowledgeIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceAckList')))
    _ResetResourceAcknowledgeIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    _ResetResourceAcknowledgeIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ResetResourceAcknowledgeIEs._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'reject'), (u'Value', _ResetResourceAcknowledgeIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 77), (u'criticality', u'ignore'), (u'Value', _ResetResourceAcknowledgeIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _ResetResourceAcknowledgeIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _ResetResourceAcknowledgeIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResetResourceAckList >-----#
    ResetResourceAckList = SEQ_OF(name=u'ResetResourceAckList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'IuSigConId-IE-ContainerList')))
    _ResetResourceAckList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __ResetResourceAckList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___ResetResourceAckList__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____ResetResourceAckList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____ResetResourceAckList__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceAckItem')))
    ____ResetResourceAckList__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _____ResetResourceAckList__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___ResetResourceAckList__item___item__id._const_tab = ____ResetResourceAckList__item___item__id_tab
    ___ResetResourceAckList__item___item__id._const_tab_at = None
    ___ResetResourceAckList__item___item__id._const_tab_id = u'id'
    ___ResetResourceAckList__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___ResetResourceAckList__item___item__criticality._const_tab = ____ResetResourceAckList__item___item__id_tab
    ___ResetResourceAckList__item___item__criticality._const_tab_at = ('..', u'id')
    ___ResetResourceAckList__item___item__criticality._const_tab_id = u'criticality'
    ___ResetResourceAckList__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___ResetResourceAckList__item___item__value._const_tab = ____ResetResourceAckList__item___item__id_tab
    ___ResetResourceAckList__item___item__value._const_tab_at = ('..', u'id')
    ___ResetResourceAckList__item___item__value._const_tab_id = u'Value'
    __ResetResourceAckList__item___item_._cont = ASN1Dict([
        (u'id', ___ResetResourceAckList__item___item__id),
        (u'criticality', ___ResetResourceAckList__item___item__criticality),
        (u'value', ___ResetResourceAckList__item___item__value),
        ])
    __ResetResourceAckList__item___item_._ext = None
    _ResetResourceAckList__item_._cont = __ResetResourceAckList__item___item_
    _ResetResourceAckList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResetResourceAckList._cont = _ResetResourceAckList__item_
    ResetResourceAckList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=250)], ev=None, er=[])
    
    #-----< ResetResourceAckItemIEs >-----#
    ResetResourceAckItemIEs = CLASS(name=u'ResetResourceAckItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _ResetResourceAckItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceAckItem')))
    ResetResourceAckItemIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'reject'), (u'Value', _ResetResourceAckItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ResetResourceAckItem >-----#
    ResetResourceAckItem = SEQ(name=u'ResetResourceAckItem', mode=MODE_TYPE)
    _ResetResourceAckItem_iuSigConId = BIT_STR(name=u'iuSigConId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _ResetResourceAckItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResetResourceAckItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___ResetResourceAckItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ResetResourceAckItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____ResetResourceAckItem_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    ____ResetResourceAckItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 282), (u'criticality', u'ignore'), (u'Extension', _____ResetResourceAckItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ResetResourceAckItem_iE_Extensions__item__id._const_tab = ____ResetResourceAckItem_iE_Extensions__item__id_tab
    ___ResetResourceAckItem_iE_Extensions__item__id._const_tab_at = None
    ___ResetResourceAckItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___ResetResourceAckItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ResetResourceAckItem_iE_Extensions__item__criticality._const_tab = ____ResetResourceAckItem_iE_Extensions__item__id_tab
    ___ResetResourceAckItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResetResourceAckItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ResetResourceAckItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ResetResourceAckItem_iE_Extensions__item__extensionValue._const_tab = ____ResetResourceAckItem_iE_Extensions__item__id_tab
    ___ResetResourceAckItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResetResourceAckItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ResetResourceAckItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ResetResourceAckItem_iE_Extensions__item__id),
        (u'criticality', ___ResetResourceAckItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___ResetResourceAckItem_iE_Extensions__item__extensionValue),
        ])
    __ResetResourceAckItem_iE_Extensions__item_._ext = None
    _ResetResourceAckItem_iE_Extensions._cont = __ResetResourceAckItem_iE_Extensions__item_
    _ResetResourceAckItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResetResourceAckItem._cont = ASN1Dict([
        (u'iuSigConId', _ResetResourceAckItem_iuSigConId),
        (u'iE-Extensions', _ResetResourceAckItem_iE_Extensions),
        ])
    ResetResourceAckItem._ext = []
    
    #-----< ResetResourceAckItem-ExtIEs >-----#
    ResetResourceAckItem_ExtIEs = CLASS(name=u'ResetResourceAckItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _ResetResourceAckItem_ExtIEs_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    ResetResourceAckItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 282), (u'criticality', u'ignore'), (u'Extension', _ResetResourceAckItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResetResourceAcknowledgeExtensions >-----#
    ResetResourceAcknowledgeExtensions = CLASS(name=u'ResetResourceAcknowledgeExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _ResetResourceAcknowledgeExtensions_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _ResetResourceAcknowledgeExtensions_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ResetResourceAcknowledgeExtensions._val = ASN1Set(rv=[dict([(u'id', 96), (u'criticality', u'ignore'), (u'Extension', _ResetResourceAcknowledgeExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _ResetResourceAcknowledgeExtensions_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-ReleaseRequest >-----#
    RAB_ReleaseRequest = SEQ(name=u'RAB-ReleaseRequest', mode=MODE_TYPE)
    _RAB_ReleaseRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_ReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_ReleaseRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_ReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_ReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseList')))
    ____RAB_ReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 41), (u'criticality', u'ignore'), (u'Value', _____RAB_ReleaseRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_ReleaseRequest_protocolIEs__item__id._const_tab = ____RAB_ReleaseRequest_protocolIEs__item__id_tab
    ___RAB_ReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___RAB_ReleaseRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___RAB_ReleaseRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_ReleaseRequest_protocolIEs__item__criticality._const_tab = ____RAB_ReleaseRequest_protocolIEs__item__id_tab
    ___RAB_ReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_ReleaseRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RAB_ReleaseRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_ReleaseRequest_protocolIEs__item__value._const_tab = ____RAB_ReleaseRequest_protocolIEs__item__id_tab
    ___RAB_ReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RAB_ReleaseRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __RAB_ReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RAB_ReleaseRequest_protocolIEs__item__id),
        (u'criticality', ___RAB_ReleaseRequest_protocolIEs__item__criticality),
        (u'value', ___RAB_ReleaseRequest_protocolIEs__item__value),
        ])
    __RAB_ReleaseRequest_protocolIEs__item_._ext = None
    _RAB_ReleaseRequest_protocolIEs._cont = __RAB_ReleaseRequest_protocolIEs__item_
    _RAB_ReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RAB_ReleaseRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_ReleaseRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_ReleaseRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_ReleaseRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ReleaseRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ReleaseRequest_protocolExtensions__item__id._const_tab = ____RAB_ReleaseRequest_protocolExtensions__item__id_tab
    ___RAB_ReleaseRequest_protocolExtensions__item__id._const_tab_at = None
    ___RAB_ReleaseRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___RAB_ReleaseRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RAB_ReleaseRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ReleaseRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ReleaseRequest_protocolExtensions__item__criticality._const_tab = ____RAB_ReleaseRequest_protocolExtensions__item__criticality_tab
    ___RAB_ReleaseRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_ReleaseRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_ReleaseRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RAB_ReleaseRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ReleaseRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ReleaseRequest_protocolExtensions__item__extensionValue._const_tab = ____RAB_ReleaseRequest_protocolExtensions__item__extensionValue_tab
    ___RAB_ReleaseRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_ReleaseRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_ReleaseRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_ReleaseRequest_protocolExtensions__item__id),
        (u'criticality', ___RAB_ReleaseRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___RAB_ReleaseRequest_protocolExtensions__item__extensionValue),
        ])
    __RAB_ReleaseRequest_protocolExtensions__item_._ext = None
    _RAB_ReleaseRequest_protocolExtensions._cont = __RAB_ReleaseRequest_protocolExtensions__item_
    _RAB_ReleaseRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_ReleaseRequest._cont = ASN1Dict([
        (u'protocolIEs', _RAB_ReleaseRequest_protocolIEs),
        (u'protocolExtensions', _RAB_ReleaseRequest_protocolExtensions),
        ])
    RAB_ReleaseRequest._ext = []
    
    #-----< RAB-ReleaseRequestIEs >-----#
    RAB_ReleaseRequestIEs = CLASS(name=u'RAB-ReleaseRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_ReleaseRequestIEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseList')))
    RAB_ReleaseRequestIEs._val = ASN1Set(rv=[dict([(u'id', 41), (u'criticality', u'ignore'), (u'Value', _RAB_ReleaseRequestIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-ReleaseList >-----#
    RAB_ReleaseList = SEQ_OF(name=u'RAB-ReleaseList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_ReleaseList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_ReleaseList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_ReleaseList__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_ReleaseList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_ReleaseList__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseItem')))
    ____RAB_ReleaseList__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'ignore'), (u'Value', _____RAB_ReleaseList__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_ReleaseList__item___item__id._const_tab = ____RAB_ReleaseList__item___item__id_tab
    ___RAB_ReleaseList__item___item__id._const_tab_at = None
    ___RAB_ReleaseList__item___item__id._const_tab_id = u'id'
    ___RAB_ReleaseList__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_ReleaseList__item___item__criticality._const_tab = ____RAB_ReleaseList__item___item__id_tab
    ___RAB_ReleaseList__item___item__criticality._const_tab_at = ('..', u'id')
    ___RAB_ReleaseList__item___item__criticality._const_tab_id = u'criticality'
    ___RAB_ReleaseList__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_ReleaseList__item___item__value._const_tab = ____RAB_ReleaseList__item___item__id_tab
    ___RAB_ReleaseList__item___item__value._const_tab_at = ('..', u'id')
    ___RAB_ReleaseList__item___item__value._const_tab_id = u'Value'
    __RAB_ReleaseList__item___item_._cont = ASN1Dict([
        (u'id', ___RAB_ReleaseList__item___item__id),
        (u'criticality', ___RAB_ReleaseList__item___item__criticality),
        (u'value', ___RAB_ReleaseList__item___item__value),
        ])
    __RAB_ReleaseList__item___item_._ext = None
    _RAB_ReleaseList__item_._cont = __RAB_ReleaseList__item___item_
    _RAB_ReleaseList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_ReleaseList._cont = _RAB_ReleaseList__item_
    RAB_ReleaseList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-ReleaseItemIEs >-----#
    RAB_ReleaseItemIEs = CLASS(name=u'RAB-ReleaseItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_ReleaseItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseItem')))
    RAB_ReleaseItemIEs._val = ASN1Set(rv=[dict([(u'id', 40), (u'criticality', u'ignore'), (u'Value', _RAB_ReleaseItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-ReleaseItem >-----#
    RAB_ReleaseItem = SEQ(name=u'RAB-ReleaseItem', mode=MODE_TYPE)
    _RAB_ReleaseItem_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_ReleaseItem_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _RAB_ReleaseItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_ReleaseItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_ReleaseItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_ReleaseItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ReleaseItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ReleaseItem_iE_Extensions__item__id._const_tab = ____RAB_ReleaseItem_iE_Extensions__item__id_tab
    ___RAB_ReleaseItem_iE_Extensions__item__id._const_tab_at = None
    ___RAB_ReleaseItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAB_ReleaseItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RAB_ReleaseItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ReleaseItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ReleaseItem_iE_Extensions__item__criticality._const_tab = ____RAB_ReleaseItem_iE_Extensions__item__criticality_tab
    ___RAB_ReleaseItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_ReleaseItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_ReleaseItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RAB_ReleaseItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ReleaseItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ReleaseItem_iE_Extensions__item__extensionValue._const_tab = ____RAB_ReleaseItem_iE_Extensions__item__extensionValue_tab
    ___RAB_ReleaseItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_ReleaseItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_ReleaseItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_ReleaseItem_iE_Extensions__item__id),
        (u'criticality', ___RAB_ReleaseItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAB_ReleaseItem_iE_Extensions__item__extensionValue),
        ])
    __RAB_ReleaseItem_iE_Extensions__item_._ext = None
    _RAB_ReleaseItem_iE_Extensions._cont = __RAB_ReleaseItem_iE_Extensions__item_
    _RAB_ReleaseItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_ReleaseItem._cont = ASN1Dict([
        (u'rAB-ID', _RAB_ReleaseItem_rAB_ID),
        (u'cause', _RAB_ReleaseItem_cause),
        (u'iE-Extensions', _RAB_ReleaseItem_iE_Extensions),
        ])
    RAB_ReleaseItem._ext = []
    
    #-----< RAB-ReleaseItem-ExtIEs >-----#
    RAB_ReleaseItem_ExtIEs = CLASS(name=u'RAB-ReleaseItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_ReleaseItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-ReleaseRequestExtensions >-----#
    RAB_ReleaseRequestExtensions = CLASS(name=u'RAB-ReleaseRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_ReleaseRequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Iu-ReleaseRequest >-----#
    Iu_ReleaseRequest = SEQ(name=u'Iu-ReleaseRequest', mode=MODE_TYPE)
    _Iu_ReleaseRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __Iu_ReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___Iu_ReleaseRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____Iu_ReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____Iu_ReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    ____Iu_ReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____Iu_ReleaseRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___Iu_ReleaseRequest_protocolIEs__item__id._const_tab = ____Iu_ReleaseRequest_protocolIEs__item__id_tab
    ___Iu_ReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___Iu_ReleaseRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___Iu_ReleaseRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___Iu_ReleaseRequest_protocolIEs__item__criticality._const_tab = ____Iu_ReleaseRequest_protocolIEs__item__id_tab
    ___Iu_ReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___Iu_ReleaseRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___Iu_ReleaseRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___Iu_ReleaseRequest_protocolIEs__item__value._const_tab = ____Iu_ReleaseRequest_protocolIEs__item__id_tab
    ___Iu_ReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___Iu_ReleaseRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __Iu_ReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___Iu_ReleaseRequest_protocolIEs__item__id),
        (u'criticality', ___Iu_ReleaseRequest_protocolIEs__item__criticality),
        (u'value', ___Iu_ReleaseRequest_protocolIEs__item__value),
        ])
    __Iu_ReleaseRequest_protocolIEs__item_._ext = None
    _Iu_ReleaseRequest_protocolIEs._cont = __Iu_ReleaseRequest_protocolIEs__item_
    _Iu_ReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _Iu_ReleaseRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Iu_ReleaseRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Iu_ReleaseRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Iu_ReleaseRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Iu_ReleaseRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Iu_ReleaseRequest_protocolExtensions__item__id._const_tab = ____Iu_ReleaseRequest_protocolExtensions__item__id_tab
    ___Iu_ReleaseRequest_protocolExtensions__item__id._const_tab_at = None
    ___Iu_ReleaseRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___Iu_ReleaseRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Iu_ReleaseRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Iu_ReleaseRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Iu_ReleaseRequest_protocolExtensions__item__criticality._const_tab = ____Iu_ReleaseRequest_protocolExtensions__item__criticality_tab
    ___Iu_ReleaseRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___Iu_ReleaseRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___Iu_ReleaseRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Iu_ReleaseRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Iu_ReleaseRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Iu_ReleaseRequest_protocolExtensions__item__extensionValue._const_tab = ____Iu_ReleaseRequest_protocolExtensions__item__extensionValue_tab
    ___Iu_ReleaseRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Iu_ReleaseRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __Iu_ReleaseRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___Iu_ReleaseRequest_protocolExtensions__item__id),
        (u'criticality', ___Iu_ReleaseRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___Iu_ReleaseRequest_protocolExtensions__item__extensionValue),
        ])
    __Iu_ReleaseRequest_protocolExtensions__item_._ext = None
    _Iu_ReleaseRequest_protocolExtensions._cont = __Iu_ReleaseRequest_protocolExtensions__item_
    _Iu_ReleaseRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Iu_ReleaseRequest._cont = ASN1Dict([
        (u'protocolIEs', _Iu_ReleaseRequest_protocolIEs),
        (u'protocolExtensions', _Iu_ReleaseRequest_protocolExtensions),
        ])
    Iu_ReleaseRequest._ext = []
    
    #-----< Iu-ReleaseRequestIEs >-----#
    Iu_ReleaseRequestIEs = CLASS(name=u'Iu-ReleaseRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _Iu_ReleaseRequestIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    Iu_ReleaseRequestIEs._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _Iu_ReleaseRequestIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Iu-ReleaseRequestExtensions >-----#
    Iu_ReleaseRequestExtensions = CLASS(name=u'Iu-ReleaseRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    Iu_ReleaseRequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelocationDetect >-----#
    RelocationDetect = SEQ(name=u'RelocationDetect', mode=MODE_TYPE)
    _RelocationDetect_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RelocationDetect_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RelocationDetect_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RelocationDetect_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    ____RelocationDetect_protocolIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationDetect_protocolIEs__item__id._const_tab = ____RelocationDetect_protocolIEs__item__id_tab
    ___RelocationDetect_protocolIEs__item__id._const_tab_at = None
    ___RelocationDetect_protocolIEs__item__id._const_tab_id = u'id'
    ___RelocationDetect_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ____RelocationDetect_protocolIEs__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    ____RelocationDetect_protocolIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationDetect_protocolIEs__item__criticality._const_tab = ____RelocationDetect_protocolIEs__item__criticality_tab
    ___RelocationDetect_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RelocationDetect_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RelocationDetect_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ____RelocationDetect_protocolIEs__item__value_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    ____RelocationDetect_protocolIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationDetect_protocolIEs__item__value._const_tab = ____RelocationDetect_protocolIEs__item__value_tab
    ___RelocationDetect_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RelocationDetect_protocolIEs__item__value._const_tab_id = u'Value'
    __RelocationDetect_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RelocationDetect_protocolIEs__item__id),
        (u'criticality', ___RelocationDetect_protocolIEs__item__criticality),
        (u'value', ___RelocationDetect_protocolIEs__item__value),
        ])
    __RelocationDetect_protocolIEs__item_._ext = None
    _RelocationDetect_protocolIEs._cont = __RelocationDetect_protocolIEs__item_
    _RelocationDetect_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RelocationDetect_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelocationDetect_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RelocationDetect_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RelocationDetect_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RelocationDetect_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationDetect_protocolExtensions__item__id._const_tab = ____RelocationDetect_protocolExtensions__item__id_tab
    ___RelocationDetect_protocolExtensions__item__id._const_tab_at = None
    ___RelocationDetect_protocolExtensions__item__id._const_tab_id = u'id'
    ___RelocationDetect_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RelocationDetect_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RelocationDetect_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationDetect_protocolExtensions__item__criticality._const_tab = ____RelocationDetect_protocolExtensions__item__criticality_tab
    ___RelocationDetect_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RelocationDetect_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RelocationDetect_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RelocationDetect_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RelocationDetect_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationDetect_protocolExtensions__item__extensionValue._const_tab = ____RelocationDetect_protocolExtensions__item__extensionValue_tab
    ___RelocationDetect_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RelocationDetect_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RelocationDetect_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RelocationDetect_protocolExtensions__item__id),
        (u'criticality', ___RelocationDetect_protocolExtensions__item__criticality),
        (u'extensionValue', ___RelocationDetect_protocolExtensions__item__extensionValue),
        ])
    __RelocationDetect_protocolExtensions__item_._ext = None
    _RelocationDetect_protocolExtensions._cont = __RelocationDetect_protocolExtensions__item_
    _RelocationDetect_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelocationDetect._cont = ASN1Dict([
        (u'protocolIEs', _RelocationDetect_protocolIEs),
        (u'protocolExtensions', _RelocationDetect_protocolExtensions),
        ])
    RelocationDetect._ext = []
    
    #-----< RelocationDetectIEs >-----#
    RelocationDetectIEs = CLASS(name=u'RelocationDetectIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    RelocationDetectIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelocationDetectExtensions >-----#
    RelocationDetectExtensions = CLASS(name=u'RelocationDetectExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RelocationDetectExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelocationComplete >-----#
    RelocationComplete = SEQ(name=u'RelocationComplete', mode=MODE_TYPE)
    _RelocationComplete_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RelocationComplete_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RelocationComplete_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RelocationComplete_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    ____RelocationComplete_protocolIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationComplete_protocolIEs__item__id._const_tab = ____RelocationComplete_protocolIEs__item__id_tab
    ___RelocationComplete_protocolIEs__item__id._const_tab_at = None
    ___RelocationComplete_protocolIEs__item__id._const_tab_id = u'id'
    ___RelocationComplete_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ____RelocationComplete_protocolIEs__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    ____RelocationComplete_protocolIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationComplete_protocolIEs__item__criticality._const_tab = ____RelocationComplete_protocolIEs__item__criticality_tab
    ___RelocationComplete_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RelocationComplete_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RelocationComplete_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ____RelocationComplete_protocolIEs__item__value_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    ____RelocationComplete_protocolIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationComplete_protocolIEs__item__value._const_tab = ____RelocationComplete_protocolIEs__item__value_tab
    ___RelocationComplete_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RelocationComplete_protocolIEs__item__value._const_tab_id = u'Value'
    __RelocationComplete_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RelocationComplete_protocolIEs__item__id),
        (u'criticality', ___RelocationComplete_protocolIEs__item__criticality),
        (u'value', ___RelocationComplete_protocolIEs__item__value),
        ])
    __RelocationComplete_protocolIEs__item_._ext = None
    _RelocationComplete_protocolIEs._cont = __RelocationComplete_protocolIEs__item_
    _RelocationComplete_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RelocationComplete_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelocationComplete_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RelocationComplete_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RelocationComplete_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RelocationComplete_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'HigherBitratesThan16MbpsFlag')))
    _____RelocationComplete_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TunnelInformation')))
    _____RelocationComplete_protocolExtensions__item__id_tab_val_Extension_2 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LHN-ID')))
    ____RelocationComplete_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 250), (u'criticality', u'ignore'), (u'Extension', _____RelocationComplete_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 262), (u'criticality', u'ignore'), (u'Extension', _____RelocationComplete_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 275), (u'criticality', u'ignore'), (u'Extension', _____RelocationComplete_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RelocationComplete_protocolExtensions__item__id._const_tab = ____RelocationComplete_protocolExtensions__item__id_tab
    ___RelocationComplete_protocolExtensions__item__id._const_tab_at = None
    ___RelocationComplete_protocolExtensions__item__id._const_tab_id = u'id'
    ___RelocationComplete_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RelocationComplete_protocolExtensions__item__criticality._const_tab = ____RelocationComplete_protocolExtensions__item__id_tab
    ___RelocationComplete_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RelocationComplete_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RelocationComplete_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RelocationComplete_protocolExtensions__item__extensionValue._const_tab = ____RelocationComplete_protocolExtensions__item__id_tab
    ___RelocationComplete_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RelocationComplete_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RelocationComplete_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RelocationComplete_protocolExtensions__item__id),
        (u'criticality', ___RelocationComplete_protocolExtensions__item__criticality),
        (u'extensionValue', ___RelocationComplete_protocolExtensions__item__extensionValue),
        ])
    __RelocationComplete_protocolExtensions__item_._ext = None
    _RelocationComplete_protocolExtensions._cont = __RelocationComplete_protocolExtensions__item_
    _RelocationComplete_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelocationComplete._cont = ASN1Dict([
        (u'protocolIEs', _RelocationComplete_protocolIEs),
        (u'protocolExtensions', _RelocationComplete_protocolExtensions),
        ])
    RelocationComplete._ext = []
    
    #-----< RelocationCompleteIEs >-----#
    RelocationCompleteIEs = CLASS(name=u'RelocationCompleteIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    RelocationCompleteIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelocationCompleteExtensions >-----#
    RelocationCompleteExtensions = CLASS(name=u'RelocationCompleteExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RelocationCompleteExtensions_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'HigherBitratesThan16MbpsFlag')))
    _RelocationCompleteExtensions_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TunnelInformation')))
    _RelocationCompleteExtensions_val_Extension_2 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LHN-ID')))
    RelocationCompleteExtensions._val = ASN1Set(rv=[dict([(u'id', 250), (u'criticality', u'ignore'), (u'Extension', _RelocationCompleteExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 262), (u'criticality', u'ignore'), (u'Extension', _RelocationCompleteExtensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 275), (u'criticality', u'ignore'), (u'Extension', _RelocationCompleteExtensions_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationCompleteRequest >-----#
    EnhancedRelocationCompleteRequest = SEQ(name=u'EnhancedRelocationCompleteRequest', mode=MODE_TYPE)
    _EnhancedRelocationCompleteRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __EnhancedRelocationCompleteRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___EnhancedRelocationCompleteRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupList-EnhancedRelocCompleteReq')))
    ____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 196), (u'criticality', u'reject'), (u'Value', _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 79), (u'criticality', u'reject'), (u'Value', _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 222), (u'criticality', u'ignore'), (u'Value', _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 223), (u'criticality', u'ignore'), (u'Value', _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 212), (u'criticality', u'reject'), (u'Value', _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 213), (u'criticality', u'reject'), (u'Value', _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 188), (u'criticality', u'reject'), (u'Value', _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___EnhancedRelocationCompleteRequest_protocolIEs__item__id._const_tab = ____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab
    ___EnhancedRelocationCompleteRequest_protocolIEs__item__id._const_tab_at = None
    ___EnhancedRelocationCompleteRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___EnhancedRelocationCompleteRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___EnhancedRelocationCompleteRequest_protocolIEs__item__criticality._const_tab = ____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab
    ___EnhancedRelocationCompleteRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationCompleteRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationCompleteRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___EnhancedRelocationCompleteRequest_protocolIEs__item__value._const_tab = ____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab
    ___EnhancedRelocationCompleteRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___EnhancedRelocationCompleteRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __EnhancedRelocationCompleteRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationCompleteRequest_protocolIEs__item__id),
        (u'criticality', ___EnhancedRelocationCompleteRequest_protocolIEs__item__criticality),
        (u'value', ___EnhancedRelocationCompleteRequest_protocolIEs__item__value),
        ])
    __EnhancedRelocationCompleteRequest_protocolIEs__item_._ext = None
    _EnhancedRelocationCompleteRequest_protocolIEs._cont = __EnhancedRelocationCompleteRequest_protocolIEs__item_
    _EnhancedRelocationCompleteRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _EnhancedRelocationCompleteRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EnhancedRelocationCompleteRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___EnhancedRelocationCompleteRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ChosenIntegrityProtectionAlgorithm')))
    _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ChosenEncryptionAlgorithm')))
    _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'HigherBitratesThan16MbpsFlag')))
    _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id')))
    _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cell-Access-Mode')))
    _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TunnelInformation')))
    _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_6 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LHN-ID')))
    ____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 6), (u'criticality', u'ignore'), (u'Extension', _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Extension', _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 250), (u'criticality', u'ignore'), (u'Extension', _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 203), (u'criticality', u'reject'), (u'Extension', _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 235), (u'criticality', u'reject'), (u'Extension', _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 262), (u'criticality', u'ignore'), (u'Extension', _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 275), (u'criticality', u'ignore'), (u'Extension', _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___EnhancedRelocationCompleteRequest_protocolExtensions__item__id._const_tab = ____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab
    ___EnhancedRelocationCompleteRequest_protocolExtensions__item__id._const_tab_at = None
    ___EnhancedRelocationCompleteRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___EnhancedRelocationCompleteRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___EnhancedRelocationCompleteRequest_protocolExtensions__item__criticality._const_tab = ____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab
    ___EnhancedRelocationCompleteRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationCompleteRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationCompleteRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___EnhancedRelocationCompleteRequest_protocolExtensions__item__extensionValue._const_tab = ____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab
    ___EnhancedRelocationCompleteRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EnhancedRelocationCompleteRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __EnhancedRelocationCompleteRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationCompleteRequest_protocolExtensions__item__id),
        (u'criticality', ___EnhancedRelocationCompleteRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___EnhancedRelocationCompleteRequest_protocolExtensions__item__extensionValue),
        ])
    __EnhancedRelocationCompleteRequest_protocolExtensions__item_._ext = None
    _EnhancedRelocationCompleteRequest_protocolExtensions._cont = __EnhancedRelocationCompleteRequest_protocolExtensions__item_
    _EnhancedRelocationCompleteRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EnhancedRelocationCompleteRequest._cont = ASN1Dict([
        (u'protocolIEs', _EnhancedRelocationCompleteRequest_protocolIEs),
        (u'protocolExtensions', _EnhancedRelocationCompleteRequest_protocolExtensions),
        ])
    EnhancedRelocationCompleteRequest._ext = []
    
    #-----< EnhancedRelocationCompleteRequestIEs >-----#
    EnhancedRelocationCompleteRequestIEs = CLASS(name=u'EnhancedRelocationCompleteRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _EnhancedRelocationCompleteRequestIEs_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _EnhancedRelocationCompleteRequestIEs_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _EnhancedRelocationCompleteRequestIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    _EnhancedRelocationCompleteRequestIEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    _EnhancedRelocationCompleteRequestIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    _EnhancedRelocationCompleteRequestIEs_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    _EnhancedRelocationCompleteRequestIEs_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupList-EnhancedRelocCompleteReq')))
    EnhancedRelocationCompleteRequestIEs._val = ASN1Set(rv=[dict([(u'id', 196), (u'criticality', u'reject'), (u'Value', _EnhancedRelocationCompleteRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 79), (u'criticality', u'reject'), (u'Value', _EnhancedRelocationCompleteRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 222), (u'criticality', u'ignore'), (u'Value', _EnhancedRelocationCompleteRequestIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 223), (u'criticality', u'ignore'), (u'Value', _EnhancedRelocationCompleteRequestIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 212), (u'criticality', u'reject'), (u'Value', _EnhancedRelocationCompleteRequestIEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 213), (u'criticality', u'reject'), (u'Value', _EnhancedRelocationCompleteRequestIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 188), (u'criticality', u'reject'), (u'Value', _EnhancedRelocationCompleteRequestIEs_val_Value_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupList-EnhancedRelocCompleteReq >-----#
    RAB_SetupList_EnhancedRelocCompleteReq = SEQ_OF(name=u'RAB-SetupList-EnhancedRelocCompleteReq', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_SetupList_EnhancedRelocCompleteReq__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_SetupList_EnhancedRelocCompleteReq__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_SetupList_EnhancedRelocCompleteReq__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_SetupList_EnhancedRelocCompleteReq__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupItem-EnhancedRelocCompleteReq')))
    ____RAB_SetupList_EnhancedRelocCompleteReq__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 189), (u'criticality', u'reject'), (u'Value', _____RAB_SetupList_EnhancedRelocCompleteReq__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__id._const_tab = ____RAB_SetupList_EnhancedRelocCompleteReq__item___item__id_tab
    ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__id._const_tab_at = None
    ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__id._const_tab_id = u'id'
    ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__criticality._const_tab = ____RAB_SetupList_EnhancedRelocCompleteReq__item___item__id_tab
    ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__criticality._const_tab_at = ('..', u'id')
    ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__criticality._const_tab_id = u'criticality'
    ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__value._const_tab = ____RAB_SetupList_EnhancedRelocCompleteReq__item___item__id_tab
    ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__value._const_tab_at = ('..', u'id')
    ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__value._const_tab_id = u'Value'
    __RAB_SetupList_EnhancedRelocCompleteReq__item___item_._cont = ASN1Dict([
        (u'id', ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__id),
        (u'criticality', ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__criticality),
        (u'value', ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__value),
        ])
    __RAB_SetupList_EnhancedRelocCompleteReq__item___item_._ext = None
    _RAB_SetupList_EnhancedRelocCompleteReq__item_._cont = __RAB_SetupList_EnhancedRelocCompleteReq__item___item_
    _RAB_SetupList_EnhancedRelocCompleteReq__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_SetupList_EnhancedRelocCompleteReq._cont = _RAB_SetupList_EnhancedRelocCompleteReq__item_
    RAB_SetupList_EnhancedRelocCompleteReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-SetupItem-EnhancedRelocCompleteReq-IEs >-----#
    RAB_SetupItem_EnhancedRelocCompleteReq_IEs = CLASS(name=u'RAB-SetupItem-EnhancedRelocCompleteReq-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_SetupItem_EnhancedRelocCompleteReq_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupItem-EnhancedRelocCompleteReq')))
    RAB_SetupItem_EnhancedRelocCompleteReq_IEs._val = ASN1Set(rv=[dict([(u'id', 189), (u'criticality', u'reject'), (u'Value', _RAB_SetupItem_EnhancedRelocCompleteReq_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupItem-EnhancedRelocCompleteReq >-----#
    RAB_SetupItem_EnhancedRelocCompleteReq = SEQ(name=u'RAB-SetupItem-EnhancedRelocCompleteReq', mode=MODE_TYPE)
    _RAB_SetupItem_EnhancedRelocCompleteReq_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_SetupItem_EnhancedRelocCompleteReq_transportLayerAddressReq1 = BIT_STR(name=u'transportLayerAddressReq1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')), opt=True)
    _RAB_SetupItem_EnhancedRelocCompleteReq_iuTransportAssociationReq1 = CHOICE(name=u'iuTransportAssociationReq1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IuTransportAssociation')), opt=True)
    _RAB_SetupItem_EnhancedRelocCompleteReq_ass_RAB_Parameters = SEQ(name=u'ass-RAB-Parameters', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Ass-RAB-Parameters')), opt=True)
    _RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__id._const_tab = ____RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__id_tab
    ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__id._const_tab_at = None
    ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__criticality._const_tab = ____RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__criticality_tab
    ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__extensionValue._const_tab = ____RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__extensionValue_tab
    ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__id),
        (u'criticality', ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__extensionValue),
        ])
    __RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item_._ext = None
    _RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions._cont = __RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item_
    _RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_SetupItem_EnhancedRelocCompleteReq._cont = ASN1Dict([
        (u'rAB-ID', _RAB_SetupItem_EnhancedRelocCompleteReq_rAB_ID),
        (u'transportLayerAddressReq1', _RAB_SetupItem_EnhancedRelocCompleteReq_transportLayerAddressReq1),
        (u'iuTransportAssociationReq1', _RAB_SetupItem_EnhancedRelocCompleteReq_iuTransportAssociationReq1),
        (u'ass-RAB-Parameters', _RAB_SetupItem_EnhancedRelocCompleteReq_ass_RAB_Parameters),
        (u'iE-Extensions', _RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions),
        ])
    RAB_SetupItem_EnhancedRelocCompleteReq._ext = []
    
    #-----< RAB-SetupItem-EnhancedRelocCompleteReq-ExtIEs >-----#
    RAB_SetupItem_EnhancedRelocCompleteReq_ExtIEs = CLASS(name=u'RAB-SetupItem-EnhancedRelocCompleteReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_SetupItem_EnhancedRelocCompleteReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationCompleteRequestExtensions >-----#
    EnhancedRelocationCompleteRequestExtensions = CLASS(name=u'EnhancedRelocationCompleteRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _EnhancedRelocationCompleteRequestExtensions_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ChosenIntegrityProtectionAlgorithm')))
    _EnhancedRelocationCompleteRequestExtensions_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ChosenEncryptionAlgorithm')))
    _EnhancedRelocationCompleteRequestExtensions_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'HigherBitratesThan16MbpsFlag')))
    _EnhancedRelocationCompleteRequestExtensions_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id')))
    _EnhancedRelocationCompleteRequestExtensions_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cell-Access-Mode')))
    _EnhancedRelocationCompleteRequestExtensions_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TunnelInformation')))
    _EnhancedRelocationCompleteRequestExtensions_val_Extension_6 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LHN-ID')))
    EnhancedRelocationCompleteRequestExtensions._val = ASN1Set(rv=[dict([(u'id', 6), (u'criticality', u'ignore'), (u'Extension', _EnhancedRelocationCompleteRequestExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Extension', _EnhancedRelocationCompleteRequestExtensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 250), (u'criticality', u'ignore'), (u'Extension', _EnhancedRelocationCompleteRequestExtensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 203), (u'criticality', u'reject'), (u'Extension', _EnhancedRelocationCompleteRequestExtensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 235), (u'criticality', u'reject'), (u'Extension', _EnhancedRelocationCompleteRequestExtensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 262), (u'criticality', u'ignore'), (u'Extension', _EnhancedRelocationCompleteRequestExtensions_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 275), (u'criticality', u'ignore'), (u'Extension', _EnhancedRelocationCompleteRequestExtensions_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationCompleteResponse >-----#
    EnhancedRelocationCompleteResponse = SEQ(name=u'EnhancedRelocationCompleteResponse', mode=MODE_TYPE)
    _EnhancedRelocationCompleteResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __EnhancedRelocationCompleteResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___EnhancedRelocationCompleteResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupList-EnhancedRelocCompleteRes')))
    _____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ToBeReleasedList-EnhancedRelocCompleteRes')))
    _____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 190), (u'criticality', u'ignore'), (u'Value', _____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 210), (u'criticality', u'ignore'), (u'Value', _____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___EnhancedRelocationCompleteResponse_protocolIEs__item__id._const_tab = ____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab
    ___EnhancedRelocationCompleteResponse_protocolIEs__item__id._const_tab_at = None
    ___EnhancedRelocationCompleteResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___EnhancedRelocationCompleteResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___EnhancedRelocationCompleteResponse_protocolIEs__item__criticality._const_tab = ____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab
    ___EnhancedRelocationCompleteResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationCompleteResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationCompleteResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___EnhancedRelocationCompleteResponse_protocolIEs__item__value._const_tab = ____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab
    ___EnhancedRelocationCompleteResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___EnhancedRelocationCompleteResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __EnhancedRelocationCompleteResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationCompleteResponse_protocolIEs__item__id),
        (u'criticality', ___EnhancedRelocationCompleteResponse_protocolIEs__item__criticality),
        (u'value', ___EnhancedRelocationCompleteResponse_protocolIEs__item__value),
        ])
    __EnhancedRelocationCompleteResponse_protocolIEs__item_._ext = None
    _EnhancedRelocationCompleteResponse_protocolIEs._cont = __EnhancedRelocationCompleteResponse_protocolIEs__item_
    _EnhancedRelocationCompleteResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _EnhancedRelocationCompleteResponse_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EnhancedRelocationCompleteResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___EnhancedRelocationCompleteResponse_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-AggregateMaximumBitRate')))
    _____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MSISDN')))
    _____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Membership-Status')))
    ____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 233), (u'criticality', u'ignore'), (u'Extension', _____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 239), (u'criticality', u'ignore'), (u'Extension', _____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 234), (u'criticality', u'ignore'), (u'Extension', _____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___EnhancedRelocationCompleteResponse_protocolExtensions__item__id._const_tab = ____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab
    ___EnhancedRelocationCompleteResponse_protocolExtensions__item__id._const_tab_at = None
    ___EnhancedRelocationCompleteResponse_protocolExtensions__item__id._const_tab_id = u'id'
    ___EnhancedRelocationCompleteResponse_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___EnhancedRelocationCompleteResponse_protocolExtensions__item__criticality._const_tab = ____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab
    ___EnhancedRelocationCompleteResponse_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationCompleteResponse_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationCompleteResponse_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___EnhancedRelocationCompleteResponse_protocolExtensions__item__extensionValue._const_tab = ____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab
    ___EnhancedRelocationCompleteResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EnhancedRelocationCompleteResponse_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __EnhancedRelocationCompleteResponse_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationCompleteResponse_protocolExtensions__item__id),
        (u'criticality', ___EnhancedRelocationCompleteResponse_protocolExtensions__item__criticality),
        (u'extensionValue', ___EnhancedRelocationCompleteResponse_protocolExtensions__item__extensionValue),
        ])
    __EnhancedRelocationCompleteResponse_protocolExtensions__item_._ext = None
    _EnhancedRelocationCompleteResponse_protocolExtensions._cont = __EnhancedRelocationCompleteResponse_protocolExtensions__item_
    _EnhancedRelocationCompleteResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EnhancedRelocationCompleteResponse._cont = ASN1Dict([
        (u'protocolIEs', _EnhancedRelocationCompleteResponse_protocolIEs),
        (u'protocolExtensions', _EnhancedRelocationCompleteResponse_protocolExtensions),
        ])
    EnhancedRelocationCompleteResponse._ext = []
    
    #-----< EnhancedRelocationCompleteResponseIEs >-----#
    EnhancedRelocationCompleteResponseIEs = CLASS(name=u'EnhancedRelocationCompleteResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _EnhancedRelocationCompleteResponseIEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupList-EnhancedRelocCompleteRes')))
    _EnhancedRelocationCompleteResponseIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ToBeReleasedList-EnhancedRelocCompleteRes')))
    _EnhancedRelocationCompleteResponseIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    EnhancedRelocationCompleteResponseIEs._val = ASN1Set(rv=[dict([(u'id', 190), (u'criticality', u'ignore'), (u'Value', _EnhancedRelocationCompleteResponseIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 210), (u'criticality', u'ignore'), (u'Value', _EnhancedRelocationCompleteResponseIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _EnhancedRelocationCompleteResponseIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupList-EnhancedRelocCompleteRes >-----#
    RAB_SetupList_EnhancedRelocCompleteRes = SEQ_OF(name=u'RAB-SetupList-EnhancedRelocCompleteRes', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_SetupList_EnhancedRelocCompleteRes__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_SetupList_EnhancedRelocCompleteRes__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_SetupList_EnhancedRelocCompleteRes__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_SetupList_EnhancedRelocCompleteRes__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupItem-EnhancedRelocCompleteRes')))
    ____RAB_SetupList_EnhancedRelocCompleteRes__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 191), (u'criticality', u'reject'), (u'Value', _____RAB_SetupList_EnhancedRelocCompleteRes__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__id._const_tab = ____RAB_SetupList_EnhancedRelocCompleteRes__item___item__id_tab
    ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__id._const_tab_at = None
    ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__id._const_tab_id = u'id'
    ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__criticality._const_tab = ____RAB_SetupList_EnhancedRelocCompleteRes__item___item__id_tab
    ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__criticality._const_tab_at = ('..', u'id')
    ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__criticality._const_tab_id = u'criticality'
    ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__value._const_tab = ____RAB_SetupList_EnhancedRelocCompleteRes__item___item__id_tab
    ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__value._const_tab_at = ('..', u'id')
    ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__value._const_tab_id = u'Value'
    __RAB_SetupList_EnhancedRelocCompleteRes__item___item_._cont = ASN1Dict([
        (u'id', ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__id),
        (u'criticality', ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__criticality),
        (u'value', ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__value),
        ])
    __RAB_SetupList_EnhancedRelocCompleteRes__item___item_._ext = None
    _RAB_SetupList_EnhancedRelocCompleteRes__item_._cont = __RAB_SetupList_EnhancedRelocCompleteRes__item___item_
    _RAB_SetupList_EnhancedRelocCompleteRes__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_SetupList_EnhancedRelocCompleteRes._cont = _RAB_SetupList_EnhancedRelocCompleteRes__item_
    RAB_SetupList_EnhancedRelocCompleteRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-SetupItem-EnhancedRelocCompleteRes-IEs >-----#
    RAB_SetupItem_EnhancedRelocCompleteRes_IEs = CLASS(name=u'RAB-SetupItem-EnhancedRelocCompleteRes-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_SetupItem_EnhancedRelocCompleteRes_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupItem-EnhancedRelocCompleteRes')))
    RAB_SetupItem_EnhancedRelocCompleteRes_IEs._val = ASN1Set(rv=[dict([(u'id', 191), (u'criticality', u'reject'), (u'Value', _RAB_SetupItem_EnhancedRelocCompleteRes_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupItem-EnhancedRelocCompleteRes >-----#
    RAB_SetupItem_EnhancedRelocCompleteRes = SEQ(name=u'RAB-SetupItem-EnhancedRelocCompleteRes', mode=MODE_TYPE)
    _RAB_SetupItem_EnhancedRelocCompleteRes_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_SetupItem_EnhancedRelocCompleteRes_rAB_Parameters = SEQ(name=u'rAB-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameters')), opt=True)
    _RAB_SetupItem_EnhancedRelocCompleteRes_userPlaneInformation = SEQ(name=u'userPlaneInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Contents', 'UserPlaneInformation')))
    _RAB_SetupItem_EnhancedRelocCompleteRes_transportLayerAddressRes1 = BIT_STR(name=u'transportLayerAddressRes1', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')), opt=True)
    _RAB_SetupItem_EnhancedRelocCompleteRes_iuTransportAssociationRes1 = CHOICE(name=u'iuTransportAssociationRes1', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IuTransportAssociation')), opt=True)
    _RAB_SetupItem_EnhancedRelocCompleteRes_rab2beReleasedList = SEQ_OF(name=u'rab2beReleasedList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ToBeReleasedList-EnhancedRelocCompleteRes')), opt=True)
    _RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Offload-RAB-Parameters')))
    ____RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 240), (u'criticality', u'ignore'), (u'Extension', _____RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id._const_tab = ____RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id_tab
    ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id._const_tab_at = None
    ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality._const_tab = ____RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id_tab
    ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue._const_tab = ____RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id_tab
    ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id),
        (u'criticality', ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue),
        ])
    __RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item_._ext = None
    _RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions._cont = __RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item_
    _RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_SetupItem_EnhancedRelocCompleteRes._cont = ASN1Dict([
        (u'rAB-ID', _RAB_SetupItem_EnhancedRelocCompleteRes_rAB_ID),
        (u'rAB-Parameters', _RAB_SetupItem_EnhancedRelocCompleteRes_rAB_Parameters),
        (u'userPlaneInformation', _RAB_SetupItem_EnhancedRelocCompleteRes_userPlaneInformation),
        (u'transportLayerAddressRes1', _RAB_SetupItem_EnhancedRelocCompleteRes_transportLayerAddressRes1),
        (u'iuTransportAssociationRes1', _RAB_SetupItem_EnhancedRelocCompleteRes_iuTransportAssociationRes1),
        (u'rab2beReleasedList', _RAB_SetupItem_EnhancedRelocCompleteRes_rab2beReleasedList),
        (u'iE-Extensions', _RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions),
        ])
    RAB_SetupItem_EnhancedRelocCompleteRes._ext = []
    
    #-----< RAB-SetupItem-EnhancedRelocCompleteRes-ExtIEs >-----#
    RAB_SetupItem_EnhancedRelocCompleteRes_ExtIEs = CLASS(name=u'RAB-SetupItem-EnhancedRelocCompleteRes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RAB_SetupItem_EnhancedRelocCompleteRes_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Offload-RAB-Parameters')))
    RAB_SetupItem_EnhancedRelocCompleteRes_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 240), (u'criticality', u'ignore'), (u'Extension', _RAB_SetupItem_EnhancedRelocCompleteRes_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-ToBeReleasedList-EnhancedRelocCompleteRes >-----#
    RAB_ToBeReleasedList_EnhancedRelocCompleteRes = SEQ_OF(name=u'RAB-ToBeReleasedList-EnhancedRelocCompleteRes', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ToBeReleasedItem-EnhancedRelocCompleteRes')))
    ____RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 209), (u'criticality', u'ignore'), (u'Value', _____RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id._const_tab = ____RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id_tab
    ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id._const_tab_at = None
    ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id._const_tab_id = u'id'
    ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__criticality._const_tab = ____RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id_tab
    ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__criticality._const_tab_at = ('..', u'id')
    ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__criticality._const_tab_id = u'criticality'
    ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__value._const_tab = ____RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id_tab
    ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__value._const_tab_at = ('..', u'id')
    ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__value._const_tab_id = u'Value'
    __RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item_._cont = ASN1Dict([
        (u'id', ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id),
        (u'criticality', ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__criticality),
        (u'value', ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__value),
        ])
    __RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item_._ext = None
    _RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item_._cont = __RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item_
    _RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_ToBeReleasedList_EnhancedRelocCompleteRes._cont = _RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item_
    RAB_ToBeReleasedList_EnhancedRelocCompleteRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-ToBeReleasedItem-EnhancedRelocCompleteRes-IEs >-----#
    RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_IEs = CLASS(name=u'RAB-ToBeReleasedItem-EnhancedRelocCompleteRes-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ToBeReleasedItem-EnhancedRelocCompleteRes')))
    RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_IEs._val = ASN1Set(rv=[dict([(u'id', 209), (u'criticality', u'ignore'), (u'Value', _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-ToBeReleasedItem-EnhancedRelocCompleteRes >-----#
    RAB_ToBeReleasedItem_EnhancedRelocCompleteRes = SEQ(name=u'RAB-ToBeReleasedItem-EnhancedRelocCompleteRes', mode=MODE_TYPE)
    _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__id._const_tab = ____RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__id_tab
    ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__id._const_tab_at = None
    ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality._const_tab = ____RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality_tab
    ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue._const_tab = ____RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue_tab
    ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__id),
        (u'criticality', ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue),
        ])
    __RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item_._ext = None
    _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions._cont = __RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item_
    _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_ToBeReleasedItem_EnhancedRelocCompleteRes._cont = ASN1Dict([
        (u'rAB-ID', _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_rAB_ID),
        (u'cause', _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_cause),
        (u'iE-Extensions', _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions),
        ])
    RAB_ToBeReleasedItem_EnhancedRelocCompleteRes._ext = []
    
    #-----< RAB-ToBeReleasedItem-EnhancedRelocCompleteRes-ExtIEs >-----#
    RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_ExtIEs = CLASS(name=u'RAB-ToBeReleasedItem-EnhancedRelocCompleteRes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationCompleteResponseExtensions >-----#
    EnhancedRelocationCompleteResponseExtensions = CLASS(name=u'EnhancedRelocationCompleteResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _EnhancedRelocationCompleteResponseExtensions_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-AggregateMaximumBitRate')))
    _EnhancedRelocationCompleteResponseExtensions_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MSISDN')))
    _EnhancedRelocationCompleteResponseExtensions_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Membership-Status')))
    EnhancedRelocationCompleteResponseExtensions._val = ASN1Set(rv=[dict([(u'id', 233), (u'criticality', u'ignore'), (u'Extension', _EnhancedRelocationCompleteResponseExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 239), (u'criticality', u'ignore'), (u'Extension', _EnhancedRelocationCompleteResponseExtensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 234), (u'criticality', u'ignore'), (u'Extension', _EnhancedRelocationCompleteResponseExtensions_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationCompleteFailure >-----#
    EnhancedRelocationCompleteFailure = SEQ(name=u'EnhancedRelocationCompleteFailure', mode=MODE_TYPE)
    _EnhancedRelocationCompleteFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __EnhancedRelocationCompleteFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___EnhancedRelocationCompleteFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____EnhancedRelocationCompleteFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____EnhancedRelocationCompleteFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____EnhancedRelocationCompleteFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____EnhancedRelocationCompleteFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____EnhancedRelocationCompleteFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____EnhancedRelocationCompleteFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___EnhancedRelocationCompleteFailure_protocolIEs__item__id._const_tab = ____EnhancedRelocationCompleteFailure_protocolIEs__item__id_tab
    ___EnhancedRelocationCompleteFailure_protocolIEs__item__id._const_tab_at = None
    ___EnhancedRelocationCompleteFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___EnhancedRelocationCompleteFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___EnhancedRelocationCompleteFailure_protocolIEs__item__criticality._const_tab = ____EnhancedRelocationCompleteFailure_protocolIEs__item__id_tab
    ___EnhancedRelocationCompleteFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationCompleteFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationCompleteFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___EnhancedRelocationCompleteFailure_protocolIEs__item__value._const_tab = ____EnhancedRelocationCompleteFailure_protocolIEs__item__id_tab
    ___EnhancedRelocationCompleteFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___EnhancedRelocationCompleteFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __EnhancedRelocationCompleteFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationCompleteFailure_protocolIEs__item__id),
        (u'criticality', ___EnhancedRelocationCompleteFailure_protocolIEs__item__criticality),
        (u'value', ___EnhancedRelocationCompleteFailure_protocolIEs__item__value),
        ])
    __EnhancedRelocationCompleteFailure_protocolIEs__item_._ext = None
    _EnhancedRelocationCompleteFailure_protocolIEs._cont = __EnhancedRelocationCompleteFailure_protocolIEs__item_
    _EnhancedRelocationCompleteFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _EnhancedRelocationCompleteFailure_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EnhancedRelocationCompleteFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___EnhancedRelocationCompleteFailure_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EnhancedRelocationCompleteFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationCompleteFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationCompleteFailure_protocolExtensions__item__id._const_tab = ____EnhancedRelocationCompleteFailure_protocolExtensions__item__id_tab
    ___EnhancedRelocationCompleteFailure_protocolExtensions__item__id._const_tab_at = None
    ___EnhancedRelocationCompleteFailure_protocolExtensions__item__id._const_tab_id = u'id'
    ___EnhancedRelocationCompleteFailure_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EnhancedRelocationCompleteFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationCompleteFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationCompleteFailure_protocolExtensions__item__criticality._const_tab = ____EnhancedRelocationCompleteFailure_protocolExtensions__item__criticality_tab
    ___EnhancedRelocationCompleteFailure_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationCompleteFailure_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationCompleteFailure_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EnhancedRelocationCompleteFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationCompleteFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationCompleteFailure_protocolExtensions__item__extensionValue._const_tab = ____EnhancedRelocationCompleteFailure_protocolExtensions__item__extensionValue_tab
    ___EnhancedRelocationCompleteFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EnhancedRelocationCompleteFailure_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __EnhancedRelocationCompleteFailure_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationCompleteFailure_protocolExtensions__item__id),
        (u'criticality', ___EnhancedRelocationCompleteFailure_protocolExtensions__item__criticality),
        (u'extensionValue', ___EnhancedRelocationCompleteFailure_protocolExtensions__item__extensionValue),
        ])
    __EnhancedRelocationCompleteFailure_protocolExtensions__item_._ext = None
    _EnhancedRelocationCompleteFailure_protocolExtensions._cont = __EnhancedRelocationCompleteFailure_protocolExtensions__item_
    _EnhancedRelocationCompleteFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EnhancedRelocationCompleteFailure._cont = ASN1Dict([
        (u'protocolIEs', _EnhancedRelocationCompleteFailure_protocolIEs),
        (u'protocolExtensions', _EnhancedRelocationCompleteFailure_protocolExtensions),
        ])
    EnhancedRelocationCompleteFailure._ext = []
    
    #-----< EnhancedRelocationCompleteFailureIEs >-----#
    EnhancedRelocationCompleteFailureIEs = CLASS(name=u'EnhancedRelocationCompleteFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _EnhancedRelocationCompleteFailureIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _EnhancedRelocationCompleteFailureIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    EnhancedRelocationCompleteFailureIEs._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _EnhancedRelocationCompleteFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _EnhancedRelocationCompleteFailureIEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationCompleteFailureExtensions >-----#
    EnhancedRelocationCompleteFailureExtensions = CLASS(name=u'EnhancedRelocationCompleteFailureExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    EnhancedRelocationCompleteFailureExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationCompleteConfirm >-----#
    EnhancedRelocationCompleteConfirm = SEQ(name=u'EnhancedRelocationCompleteConfirm', mode=MODE_TYPE)
    _EnhancedRelocationCompleteConfirm_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __EnhancedRelocationCompleteConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___EnhancedRelocationCompleteConfirm_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____EnhancedRelocationCompleteConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____EnhancedRelocationCompleteConfirm_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedList')))
    ____EnhancedRelocationCompleteConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 35), (u'criticality', u'ignore'), (u'Value', _____EnhancedRelocationCompleteConfirm_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___EnhancedRelocationCompleteConfirm_protocolIEs__item__id._const_tab = ____EnhancedRelocationCompleteConfirm_protocolIEs__item__id_tab
    ___EnhancedRelocationCompleteConfirm_protocolIEs__item__id._const_tab_at = None
    ___EnhancedRelocationCompleteConfirm_protocolIEs__item__id._const_tab_id = u'id'
    ___EnhancedRelocationCompleteConfirm_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___EnhancedRelocationCompleteConfirm_protocolIEs__item__criticality._const_tab = ____EnhancedRelocationCompleteConfirm_protocolIEs__item__id_tab
    ___EnhancedRelocationCompleteConfirm_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationCompleteConfirm_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationCompleteConfirm_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___EnhancedRelocationCompleteConfirm_protocolIEs__item__value._const_tab = ____EnhancedRelocationCompleteConfirm_protocolIEs__item__id_tab
    ___EnhancedRelocationCompleteConfirm_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___EnhancedRelocationCompleteConfirm_protocolIEs__item__value._const_tab_id = u'Value'
    __EnhancedRelocationCompleteConfirm_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationCompleteConfirm_protocolIEs__item__id),
        (u'criticality', ___EnhancedRelocationCompleteConfirm_protocolIEs__item__criticality),
        (u'value', ___EnhancedRelocationCompleteConfirm_protocolIEs__item__value),
        ])
    __EnhancedRelocationCompleteConfirm_protocolIEs__item_._ext = None
    _EnhancedRelocationCompleteConfirm_protocolIEs._cont = __EnhancedRelocationCompleteConfirm_protocolIEs__item_
    _EnhancedRelocationCompleteConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _EnhancedRelocationCompleteConfirm_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EnhancedRelocationCompleteConfirm_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EnhancedRelocationCompleteConfirm_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationCompleteConfirm_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__id._const_tab = ____EnhancedRelocationCompleteConfirm_protocolExtensions__item__id_tab
    ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__id._const_tab_at = None
    ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__id._const_tab_id = u'id'
    ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EnhancedRelocationCompleteConfirm_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationCompleteConfirm_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__criticality._const_tab = ____EnhancedRelocationCompleteConfirm_protocolExtensions__item__criticality_tab
    ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EnhancedRelocationCompleteConfirm_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationCompleteConfirm_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__extensionValue._const_tab = ____EnhancedRelocationCompleteConfirm_protocolExtensions__item__extensionValue_tab
    ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __EnhancedRelocationCompleteConfirm_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__id),
        (u'criticality', ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__criticality),
        (u'extensionValue', ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__extensionValue),
        ])
    __EnhancedRelocationCompleteConfirm_protocolExtensions__item_._ext = None
    _EnhancedRelocationCompleteConfirm_protocolExtensions._cont = __EnhancedRelocationCompleteConfirm_protocolExtensions__item_
    _EnhancedRelocationCompleteConfirm_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EnhancedRelocationCompleteConfirm._cont = ASN1Dict([
        (u'protocolIEs', _EnhancedRelocationCompleteConfirm_protocolIEs),
        (u'protocolExtensions', _EnhancedRelocationCompleteConfirm_protocolExtensions),
        ])
    EnhancedRelocationCompleteConfirm._ext = []
    
    #-----< EnhancedRelocationCompleteConfirmIEs >-----#
    EnhancedRelocationCompleteConfirmIEs = CLASS(name=u'EnhancedRelocationCompleteConfirmIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _EnhancedRelocationCompleteConfirmIEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedList')))
    EnhancedRelocationCompleteConfirmIEs._val = ASN1Set(rv=[dict([(u'id', 35), (u'criticality', u'ignore'), (u'Value', _EnhancedRelocationCompleteConfirmIEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationCompleteConfirmExtensions >-----#
    EnhancedRelocationCompleteConfirmExtensions = CLASS(name=u'EnhancedRelocationCompleteConfirmExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    EnhancedRelocationCompleteConfirmExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Paging >-----#
    Paging = SEQ(name=u'Paging', mode=MODE_TYPE)
    _Paging_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __Paging_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___Paging_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____Paging_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____Paging_protocolIEs__item__id_tab_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____Paging_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    _____Paging_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TemporaryUE-ID')))
    _____Paging_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PagingAreaID')))
    _____Paging_protocolIEs__item__id_tab_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PagingCause')))
    _____Paging_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NonSearchingIndication')))
    _____Paging_protocolIEs__item__id_tab_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'DRX-CycleLengthCoefficient')))
    ____Paging_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 23), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 64), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 22), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 76), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Paging_protocolIEs__item__id._const_tab = ____Paging_protocolIEs__item__id_tab
    ___Paging_protocolIEs__item__id._const_tab_at = None
    ___Paging_protocolIEs__item__id._const_tab_id = u'id'
    ___Paging_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___Paging_protocolIEs__item__criticality._const_tab = ____Paging_protocolIEs__item__id_tab
    ___Paging_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___Paging_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___Paging_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___Paging_protocolIEs__item__value._const_tab = ____Paging_protocolIEs__item__id_tab
    ___Paging_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___Paging_protocolIEs__item__value._const_tab_id = u'Value'
    __Paging_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___Paging_protocolIEs__item__id),
        (u'criticality', ___Paging_protocolIEs__item__criticality),
        (u'value', ___Paging_protocolIEs__item__value),
        ])
    __Paging_protocolIEs__item_._ext = None
    _Paging_protocolIEs._cont = __Paging_protocolIEs__item_
    _Paging_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _Paging_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Paging_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Paging_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Paging_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____Paging_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____Paging_protocolExtensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id-List')))
    ____Paging_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 96), (u'criticality', u'ignore'), (u'Extension', _____Paging_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 229), (u'criticality', u'ignore'), (u'Extension', _____Paging_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Paging_protocolExtensions__item__id._const_tab = ____Paging_protocolExtensions__item__id_tab
    ___Paging_protocolExtensions__item__id._const_tab_at = None
    ___Paging_protocolExtensions__item__id._const_tab_id = u'id'
    ___Paging_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Paging_protocolExtensions__item__criticality._const_tab = ____Paging_protocolExtensions__item__id_tab
    ___Paging_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___Paging_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___Paging_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Paging_protocolExtensions__item__extensionValue._const_tab = ____Paging_protocolExtensions__item__id_tab
    ___Paging_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Paging_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __Paging_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___Paging_protocolExtensions__item__id),
        (u'criticality', ___Paging_protocolExtensions__item__criticality),
        (u'extensionValue', ___Paging_protocolExtensions__item__extensionValue),
        ])
    __Paging_protocolExtensions__item_._ext = None
    _Paging_protocolExtensions._cont = __Paging_protocolExtensions__item_
    _Paging_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Paging._cont = ASN1Dict([
        (u'protocolIEs', _Paging_protocolIEs),
        (u'protocolExtensions', _Paging_protocolExtensions),
        ])
    Paging._ext = []
    
    #-----< PagingIEs >-----#
    PagingIEs = CLASS(name=u'PagingIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _PagingIEs_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _PagingIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    _PagingIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TemporaryUE-ID')))
    _PagingIEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PagingAreaID')))
    _PagingIEs_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PagingCause')))
    _PagingIEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NonSearchingIndication')))
    _PagingIEs_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'DRX-CycleLengthCoefficient')))
    PagingIEs._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 23), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 64), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 22), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 76), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PagingExtensions >-----#
    PagingExtensions = CLASS(name=u'PagingExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _PagingExtensions_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _PagingExtensions_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id-List')))
    PagingExtensions._val = ASN1Set(rv=[dict([(u'id', 96), (u'criticality', u'ignore'), (u'Extension', _PagingExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 229), (u'criticality', u'ignore'), (u'Extension', _PagingExtensions_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonID >-----#
    CommonID = SEQ(name=u'CommonID', mode=MODE_TYPE)
    _CommonID_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __CommonID_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___CommonID_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____CommonID_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____CommonID_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    ____CommonID_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 23), (u'criticality', u'ignore'), (u'Value', _____CommonID_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___CommonID_protocolIEs__item__id._const_tab = ____CommonID_protocolIEs__item__id_tab
    ___CommonID_protocolIEs__item__id._const_tab_at = None
    ___CommonID_protocolIEs__item__id._const_tab_id = u'id'
    ___CommonID_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___CommonID_protocolIEs__item__criticality._const_tab = ____CommonID_protocolIEs__item__id_tab
    ___CommonID_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___CommonID_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___CommonID_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___CommonID_protocolIEs__item__value._const_tab = ____CommonID_protocolIEs__item__id_tab
    ___CommonID_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___CommonID_protocolIEs__item__value._const_tab_id = u'Value'
    __CommonID_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___CommonID_protocolIEs__item__id),
        (u'criticality', ___CommonID_protocolIEs__item__criticality),
        (u'value', ___CommonID_protocolIEs__item__value),
        ])
    __CommonID_protocolIEs__item_._ext = None
    _CommonID_protocolIEs._cont = __CommonID_protocolIEs__item_
    _CommonID_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonID_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonID_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___CommonID_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CommonID_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____CommonID_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SNA-Access-Information')))
    _____CommonID_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UESBI-Iu')))
    _____CommonID_protocolExtensions__item__id_tab_val_Extension_2 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _____CommonID_protocolExtensions__item__id_tab_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SubscriberProfileIDforRFP')))
    _____CommonID_protocolExtensions__item__id_tab_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRVCC-Operation-Possible')))
    _____CommonID_protocolExtensions__item__id_tab_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Membership-Status')))
    _____CommonID_protocolExtensions__item__id_tab_val_Extension_6 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Management-Based-MDT-Allowed')))
    _____CommonID_protocolExtensions__item__id_tab_val_Extension_7 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MDT-PLMN-List')))
    _____CommonID_protocolExtensions__item__id_tab_val_Extension_8 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RSRVCC-Operation-Possible')))
    _____CommonID_protocolExtensions__item__id_tab_val_Extension_9 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _____CommonID_protocolExtensions__item__id_tab_val_Extension_10 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PowerSavingIndicator')))
    ____CommonID_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 105), (u'criticality', u'ignore'), (u'Extension', _____CommonID_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 118), (u'criticality', u'ignore'), (u'Extension', _____CommonID_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 127), (u'criticality', u'ignore'), (u'Extension', _____CommonID_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 202), (u'criticality', u'ignore'), (u'Extension', _____CommonID_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 228), (u'criticality', u'ignore'), (u'Extension', _____CommonID_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 234), (u'criticality', u'ignore'), (u'Extension', _____CommonID_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 249), (u'criticality', u'ignore'), (u'Extension', _____CommonID_protocolExtensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 263), (u'criticality', u'ignore'), (u'Extension', _____CommonID_protocolExtensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 272), (u'criticality', u'ignore'), (u'Extension', _____CommonID_protocolExtensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 277), (u'criticality', u'ignore'), (u'Extension', _____CommonID_protocolExtensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 289), (u'criticality', u'ignore'), (u'Extension', _____CommonID_protocolExtensions__item__id_tab_val_Extension_10), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CommonID_protocolExtensions__item__id._const_tab = ____CommonID_protocolExtensions__item__id_tab
    ___CommonID_protocolExtensions__item__id._const_tab_at = None
    ___CommonID_protocolExtensions__item__id._const_tab_id = u'id'
    ___CommonID_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CommonID_protocolExtensions__item__criticality._const_tab = ____CommonID_protocolExtensions__item__id_tab
    ___CommonID_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___CommonID_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___CommonID_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CommonID_protocolExtensions__item__extensionValue._const_tab = ____CommonID_protocolExtensions__item__id_tab
    ___CommonID_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CommonID_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __CommonID_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___CommonID_protocolExtensions__item__id),
        (u'criticality', ___CommonID_protocolExtensions__item__criticality),
        (u'extensionValue', ___CommonID_protocolExtensions__item__extensionValue),
        ])
    __CommonID_protocolExtensions__item_._ext = None
    _CommonID_protocolExtensions._cont = __CommonID_protocolExtensions__item_
    _CommonID_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonID._cont = ASN1Dict([
        (u'protocolIEs', _CommonID_protocolIEs),
        (u'protocolExtensions', _CommonID_protocolExtensions),
        ])
    CommonID._ext = []
    
    #-----< CommonID-IEs >-----#
    CommonID_IEs = CLASS(name=u'CommonID-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _CommonID_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    CommonID_IEs._val = ASN1Set(rv=[dict([(u'id', 23), (u'criticality', u'ignore'), (u'Value', _CommonID_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CommonIDExtensions >-----#
    CommonIDExtensions = CLASS(name=u'CommonIDExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _CommonIDExtensions_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SNA-Access-Information')))
    _CommonIDExtensions_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UESBI-Iu')))
    _CommonIDExtensions_val_Extension_2 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _CommonIDExtensions_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SubscriberProfileIDforRFP')))
    _CommonIDExtensions_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRVCC-Operation-Possible')))
    _CommonIDExtensions_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Membership-Status')))
    _CommonIDExtensions_val_Extension_6 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Management-Based-MDT-Allowed')))
    _CommonIDExtensions_val_Extension_7 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MDT-PLMN-List')))
    _CommonIDExtensions_val_Extension_8 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RSRVCC-Operation-Possible')))
    _CommonIDExtensions_val_Extension_9 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _CommonIDExtensions_val_Extension_10 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PowerSavingIndicator')))
    CommonIDExtensions._val = ASN1Set(rv=[dict([(u'id', 105), (u'criticality', u'ignore'), (u'Extension', _CommonIDExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 118), (u'criticality', u'ignore'), (u'Extension', _CommonIDExtensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 127), (u'criticality', u'ignore'), (u'Extension', _CommonIDExtensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 202), (u'criticality', u'ignore'), (u'Extension', _CommonIDExtensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 228), (u'criticality', u'ignore'), (u'Extension', _CommonIDExtensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 234), (u'criticality', u'ignore'), (u'Extension', _CommonIDExtensions_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 249), (u'criticality', u'ignore'), (u'Extension', _CommonIDExtensions_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 263), (u'criticality', u'ignore'), (u'Extension', _CommonIDExtensions_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 272), (u'criticality', u'ignore'), (u'Extension', _CommonIDExtensions_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 277), (u'criticality', u'ignore'), (u'Extension', _CommonIDExtensions_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 289), (u'criticality', u'ignore'), (u'Extension', _CommonIDExtensions_val_Extension_10), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CN-InvokeTrace >-----#
    CN_InvokeTrace = SEQ(name=u'CN-InvokeTrace', mode=MODE_TYPE)
    _CN_InvokeTrace_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __CN_InvokeTrace_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___CN_InvokeTrace_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____CN_InvokeTrace_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TraceType')))
    _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TraceReference')))
    _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TriggerID')))
    _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-ID')))
    _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'OMC-ID')))
    ____CN_InvokeTrace_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 66), (u'criticality', u'ignore'), (u'Value', _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 65), (u'criticality', u'ignore'), (u'Value', _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 68), (u'criticality', u'ignore'), (u'Value', _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 69), (u'criticality', u'ignore'), (u'Value', _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CN_InvokeTrace_protocolIEs__item__id._const_tab = ____CN_InvokeTrace_protocolIEs__item__id_tab
    ___CN_InvokeTrace_protocolIEs__item__id._const_tab_at = None
    ___CN_InvokeTrace_protocolIEs__item__id._const_tab_id = u'id'
    ___CN_InvokeTrace_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___CN_InvokeTrace_protocolIEs__item__criticality._const_tab = ____CN_InvokeTrace_protocolIEs__item__id_tab
    ___CN_InvokeTrace_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___CN_InvokeTrace_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___CN_InvokeTrace_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___CN_InvokeTrace_protocolIEs__item__value._const_tab = ____CN_InvokeTrace_protocolIEs__item__id_tab
    ___CN_InvokeTrace_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___CN_InvokeTrace_protocolIEs__item__value._const_tab_id = u'Value'
    __CN_InvokeTrace_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___CN_InvokeTrace_protocolIEs__item__id),
        (u'criticality', ___CN_InvokeTrace_protocolIEs__item__criticality),
        (u'value', ___CN_InvokeTrace_protocolIEs__item__value),
        ])
    __CN_InvokeTrace_protocolIEs__item_._ext = None
    _CN_InvokeTrace_protocolIEs._cont = __CN_InvokeTrace_protocolIEs__item_
    _CN_InvokeTrace_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CN_InvokeTrace_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CN_InvokeTrace_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___CN_InvokeTrace_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CN_InvokeTrace_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____CN_InvokeTrace_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TracePropagationParameters')))
    _____CN_InvokeTrace_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MDT-Configuration')))
    _____CN_InvokeTrace_protocolExtensions__item__id_tab_val_Extension_2 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _____CN_InvokeTrace_protocolExtensions__item__id_tab_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-Application-Layer-Measurement-Configuration')))
    ____CN_InvokeTrace_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 125), (u'criticality', u'ignore'), (u'Extension', _____CN_InvokeTrace_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 244), (u'criticality', u'ignore'), (u'Extension', _____CN_InvokeTrace_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 251), (u'criticality', u'ignore'), (u'Extension', _____CN_InvokeTrace_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 292), (u'criticality', u'ignore'), (u'Extension', _____CN_InvokeTrace_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CN_InvokeTrace_protocolExtensions__item__id._const_tab = ____CN_InvokeTrace_protocolExtensions__item__id_tab
    ___CN_InvokeTrace_protocolExtensions__item__id._const_tab_at = None
    ___CN_InvokeTrace_protocolExtensions__item__id._const_tab_id = u'id'
    ___CN_InvokeTrace_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CN_InvokeTrace_protocolExtensions__item__criticality._const_tab = ____CN_InvokeTrace_protocolExtensions__item__id_tab
    ___CN_InvokeTrace_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___CN_InvokeTrace_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___CN_InvokeTrace_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CN_InvokeTrace_protocolExtensions__item__extensionValue._const_tab = ____CN_InvokeTrace_protocolExtensions__item__id_tab
    ___CN_InvokeTrace_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CN_InvokeTrace_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __CN_InvokeTrace_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___CN_InvokeTrace_protocolExtensions__item__id),
        (u'criticality', ___CN_InvokeTrace_protocolExtensions__item__criticality),
        (u'extensionValue', ___CN_InvokeTrace_protocolExtensions__item__extensionValue),
        ])
    __CN_InvokeTrace_protocolExtensions__item_._ext = None
    _CN_InvokeTrace_protocolExtensions._cont = __CN_InvokeTrace_protocolExtensions__item_
    _CN_InvokeTrace_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CN_InvokeTrace._cont = ASN1Dict([
        (u'protocolIEs', _CN_InvokeTrace_protocolIEs),
        (u'protocolExtensions', _CN_InvokeTrace_protocolExtensions),
        ])
    CN_InvokeTrace._ext = []
    
    #-----< CN-InvokeTraceIEs >-----#
    CN_InvokeTraceIEs = CLASS(name=u'CN-InvokeTraceIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _CN_InvokeTraceIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TraceType')))
    _CN_InvokeTraceIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TraceReference')))
    _CN_InvokeTraceIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TriggerID')))
    _CN_InvokeTraceIEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-ID')))
    _CN_InvokeTraceIEs_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'OMC-ID')))
    CN_InvokeTraceIEs._val = ASN1Set(rv=[dict([(u'id', 66), (u'criticality', u'ignore'), (u'Value', _CN_InvokeTraceIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 65), (u'criticality', u'ignore'), (u'Value', _CN_InvokeTraceIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 68), (u'criticality', u'ignore'), (u'Value', _CN_InvokeTraceIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 69), (u'criticality', u'ignore'), (u'Value', _CN_InvokeTraceIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _CN_InvokeTraceIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CN-InvokeTraceExtensions >-----#
    CN_InvokeTraceExtensions = CLASS(name=u'CN-InvokeTraceExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _CN_InvokeTraceExtensions_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TracePropagationParameters')))
    _CN_InvokeTraceExtensions_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MDT-Configuration')))
    _CN_InvokeTraceExtensions_val_Extension_2 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _CN_InvokeTraceExtensions_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-Application-Layer-Measurement-Configuration')))
    CN_InvokeTraceExtensions._val = ASN1Set(rv=[dict([(u'id', 125), (u'criticality', u'ignore'), (u'Extension', _CN_InvokeTraceExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 244), (u'criticality', u'ignore'), (u'Extension', _CN_InvokeTraceExtensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 251), (u'criticality', u'ignore'), (u'Extension', _CN_InvokeTraceExtensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 292), (u'criticality', u'ignore'), (u'Extension', _CN_InvokeTraceExtensions_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CN-DeactivateTrace >-----#
    CN_DeactivateTrace = SEQ(name=u'CN-DeactivateTrace', mode=MODE_TYPE)
    _CN_DeactivateTrace_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __CN_DeactivateTrace_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___CN_DeactivateTrace_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____CN_DeactivateTrace_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____CN_DeactivateTrace_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TraceReference')))
    _____CN_DeactivateTrace_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TriggerID')))
    ____CN_DeactivateTrace_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 65), (u'criticality', u'ignore'), (u'Value', _____CN_DeactivateTrace_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 68), (u'criticality', u'ignore'), (u'Value', _____CN_DeactivateTrace_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CN_DeactivateTrace_protocolIEs__item__id._const_tab = ____CN_DeactivateTrace_protocolIEs__item__id_tab
    ___CN_DeactivateTrace_protocolIEs__item__id._const_tab_at = None
    ___CN_DeactivateTrace_protocolIEs__item__id._const_tab_id = u'id'
    ___CN_DeactivateTrace_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___CN_DeactivateTrace_protocolIEs__item__criticality._const_tab = ____CN_DeactivateTrace_protocolIEs__item__id_tab
    ___CN_DeactivateTrace_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___CN_DeactivateTrace_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___CN_DeactivateTrace_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___CN_DeactivateTrace_protocolIEs__item__value._const_tab = ____CN_DeactivateTrace_protocolIEs__item__id_tab
    ___CN_DeactivateTrace_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___CN_DeactivateTrace_protocolIEs__item__value._const_tab_id = u'Value'
    __CN_DeactivateTrace_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___CN_DeactivateTrace_protocolIEs__item__id),
        (u'criticality', ___CN_DeactivateTrace_protocolIEs__item__criticality),
        (u'value', ___CN_DeactivateTrace_protocolIEs__item__value),
        ])
    __CN_DeactivateTrace_protocolIEs__item_._ext = None
    _CN_DeactivateTrace_protocolIEs._cont = __CN_DeactivateTrace_protocolIEs__item_
    _CN_DeactivateTrace_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CN_DeactivateTrace_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CN_DeactivateTrace_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___CN_DeactivateTrace_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CN_DeactivateTrace_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CN_DeactivateTrace_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CN_DeactivateTrace_protocolExtensions__item__id._const_tab = ____CN_DeactivateTrace_protocolExtensions__item__id_tab
    ___CN_DeactivateTrace_protocolExtensions__item__id._const_tab_at = None
    ___CN_DeactivateTrace_protocolExtensions__item__id._const_tab_id = u'id'
    ___CN_DeactivateTrace_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CN_DeactivateTrace_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CN_DeactivateTrace_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CN_DeactivateTrace_protocolExtensions__item__criticality._const_tab = ____CN_DeactivateTrace_protocolExtensions__item__criticality_tab
    ___CN_DeactivateTrace_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___CN_DeactivateTrace_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___CN_DeactivateTrace_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CN_DeactivateTrace_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CN_DeactivateTrace_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CN_DeactivateTrace_protocolExtensions__item__extensionValue._const_tab = ____CN_DeactivateTrace_protocolExtensions__item__extensionValue_tab
    ___CN_DeactivateTrace_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CN_DeactivateTrace_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __CN_DeactivateTrace_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___CN_DeactivateTrace_protocolExtensions__item__id),
        (u'criticality', ___CN_DeactivateTrace_protocolExtensions__item__criticality),
        (u'extensionValue', ___CN_DeactivateTrace_protocolExtensions__item__extensionValue),
        ])
    __CN_DeactivateTrace_protocolExtensions__item_._ext = None
    _CN_DeactivateTrace_protocolExtensions._cont = __CN_DeactivateTrace_protocolExtensions__item_
    _CN_DeactivateTrace_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CN_DeactivateTrace._cont = ASN1Dict([
        (u'protocolIEs', _CN_DeactivateTrace_protocolIEs),
        (u'protocolExtensions', _CN_DeactivateTrace_protocolExtensions),
        ])
    CN_DeactivateTrace._ext = []
    
    #-----< CN-DeactivateTraceIEs >-----#
    CN_DeactivateTraceIEs = CLASS(name=u'CN-DeactivateTraceIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _CN_DeactivateTraceIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TraceReference')))
    _CN_DeactivateTraceIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TriggerID')))
    CN_DeactivateTraceIEs._val = ASN1Set(rv=[dict([(u'id', 65), (u'criticality', u'ignore'), (u'Value', _CN_DeactivateTraceIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 68), (u'criticality', u'ignore'), (u'Value', _CN_DeactivateTraceIEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CN-DeactivateTraceExtensions >-----#
    CN_DeactivateTraceExtensions = CLASS(name=u'CN-DeactivateTraceExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    CN_DeactivateTraceExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LocationReportingControl >-----#
    LocationReportingControl = SEQ(name=u'LocationReportingControl', mode=MODE_TYPE)
    _LocationReportingControl_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __LocationReportingControl_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___LocationReportingControl_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____LocationReportingControl_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RequestType')))
    ____LocationReportingControl_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 57), (u'criticality', u'ignore'), (u'Value', _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___LocationReportingControl_protocolIEs__item__id._const_tab = ____LocationReportingControl_protocolIEs__item__id_tab
    ___LocationReportingControl_protocolIEs__item__id._const_tab_at = None
    ___LocationReportingControl_protocolIEs__item__id._const_tab_id = u'id'
    ___LocationReportingControl_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___LocationReportingControl_protocolIEs__item__criticality._const_tab = ____LocationReportingControl_protocolIEs__item__id_tab
    ___LocationReportingControl_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___LocationReportingControl_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___LocationReportingControl_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___LocationReportingControl_protocolIEs__item__value._const_tab = ____LocationReportingControl_protocolIEs__item__id_tab
    ___LocationReportingControl_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___LocationReportingControl_protocolIEs__item__value._const_tab_id = u'Value'
    __LocationReportingControl_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___LocationReportingControl_protocolIEs__item__id),
        (u'criticality', ___LocationReportingControl_protocolIEs__item__criticality),
        (u'value', ___LocationReportingControl_protocolIEs__item__value),
        ])
    __LocationReportingControl_protocolIEs__item_._ext = None
    _LocationReportingControl_protocolIEs._cont = __LocationReportingControl_protocolIEs__item_
    _LocationReportingControl_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _LocationReportingControl_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LocationReportingControl_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___LocationReportingControl_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____LocationReportingControl_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'VerticalAccuracyCode')))
    _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ResponseTime')))
    _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PositioningPriority')))
    _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ClientType')))
    _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IncludeVelocity')))
    _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PeriodicLocationInfo')))
    ____LocationReportingControl_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'ignore'), (u'Extension', _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 112), (u'criticality', u'ignore'), (u'Extension', _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 113), (u'criticality', u'ignore'), (u'Extension', _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 114), (u'criticality', u'ignore'), (u'Extension', _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 164), (u'criticality', u'ignore'), (u'Extension', _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 168), (u'criticality', u'ignore'), (u'Extension', _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___LocationReportingControl_protocolExtensions__item__id._const_tab = ____LocationReportingControl_protocolExtensions__item__id_tab
    ___LocationReportingControl_protocolExtensions__item__id._const_tab_at = None
    ___LocationReportingControl_protocolExtensions__item__id._const_tab_id = u'id'
    ___LocationReportingControl_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___LocationReportingControl_protocolExtensions__item__criticality._const_tab = ____LocationReportingControl_protocolExtensions__item__id_tab
    ___LocationReportingControl_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___LocationReportingControl_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___LocationReportingControl_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___LocationReportingControl_protocolExtensions__item__extensionValue._const_tab = ____LocationReportingControl_protocolExtensions__item__id_tab
    ___LocationReportingControl_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LocationReportingControl_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __LocationReportingControl_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___LocationReportingControl_protocolExtensions__item__id),
        (u'criticality', ___LocationReportingControl_protocolExtensions__item__criticality),
        (u'extensionValue', ___LocationReportingControl_protocolExtensions__item__extensionValue),
        ])
    __LocationReportingControl_protocolExtensions__item_._ext = None
    _LocationReportingControl_protocolExtensions._cont = __LocationReportingControl_protocolExtensions__item_
    _LocationReportingControl_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LocationReportingControl._cont = ASN1Dict([
        (u'protocolIEs', _LocationReportingControl_protocolIEs),
        (u'protocolExtensions', _LocationReportingControl_protocolExtensions),
        ])
    LocationReportingControl._ext = []
    
    #-----< LocationReportingControlIEs >-----#
    LocationReportingControlIEs = CLASS(name=u'LocationReportingControlIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _LocationReportingControlIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RequestType')))
    LocationReportingControlIEs._val = ASN1Set(rv=[dict([(u'id', 57), (u'criticality', u'ignore'), (u'Value', _LocationReportingControlIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< LocationReportingControlExtensions >-----#
    LocationReportingControlExtensions = CLASS(name=u'LocationReportingControlExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _LocationReportingControlExtensions_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'VerticalAccuracyCode')))
    _LocationReportingControlExtensions_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ResponseTime')))
    _LocationReportingControlExtensions_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PositioningPriority')))
    _LocationReportingControlExtensions_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ClientType')))
    _LocationReportingControlExtensions_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IncludeVelocity')))
    _LocationReportingControlExtensions_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PeriodicLocationInfo')))
    LocationReportingControlExtensions._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'ignore'), (u'Extension', _LocationReportingControlExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 112), (u'criticality', u'ignore'), (u'Extension', _LocationReportingControlExtensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 113), (u'criticality', u'ignore'), (u'Extension', _LocationReportingControlExtensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 114), (u'criticality', u'ignore'), (u'Extension', _LocationReportingControlExtensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 164), (u'criticality', u'ignore'), (u'Extension', _LocationReportingControlExtensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 168), (u'criticality', u'ignore'), (u'Extension', _LocationReportingControlExtensions_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< LocationReport >-----#
    LocationReport = SEQ(name=u'LocationReport', mode=MODE_TYPE)
    _LocationReport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __LocationReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___LocationReport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____LocationReport_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'AreaIdentity')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RequestType')))
    ____LocationReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 57), (u'criticality', u'ignore'), (u'Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___LocationReport_protocolIEs__item__id._const_tab = ____LocationReport_protocolIEs__item__id_tab
    ___LocationReport_protocolIEs__item__id._const_tab_at = None
    ___LocationReport_protocolIEs__item__id._const_tab_id = u'id'
    ___LocationReport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___LocationReport_protocolIEs__item__criticality._const_tab = ____LocationReport_protocolIEs__item__id_tab
    ___LocationReport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___LocationReport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___LocationReport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___LocationReport_protocolIEs__item__value._const_tab = ____LocationReport_protocolIEs__item__id_tab
    ___LocationReport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___LocationReport_protocolIEs__item__value._const_tab_id = u'Value'
    __LocationReport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___LocationReport_protocolIEs__item__id),
        (u'criticality', ___LocationReport_protocolIEs__item__criticality),
        (u'value', ___LocationReport_protocolIEs__item__value),
        ])
    __LocationReport_protocolIEs__item_._ext = None
    _LocationReport_protocolIEs._cont = __LocationReport_protocolIEs__item_
    _LocationReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _LocationReport_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LocationReport_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___LocationReport_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____LocationReport_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____LocationReport_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LastKnownServiceArea')))
    _____LocationReport_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PositionData')))
    _____LocationReport_protocolExtensions__item__id_tab_val_Extension_2 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PositionDataSpecificToGERANIuMode')))
    _____LocationReport_protocolExtensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'AccuracyFulfilmentIndicator')))
    _____LocationReport_protocolExtensions__item__id_tab_val_Extension_4 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'VelocityEstimate')))
    _____LocationReport_protocolExtensions__item__id_tab_val_Extension_5 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'BarometricPressure')))
    _____LocationReport_protocolExtensions__item__id_tab_val_Extension_6 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CivicAddress')))
    ____LocationReport_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 97), (u'criticality', u'ignore'), (u'Extension', _____LocationReport_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 119), (u'criticality', u'ignore'), (u'Extension', _____LocationReport_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 120), (u'criticality', u'ignore'), (u'Extension', _____LocationReport_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 122), (u'criticality', u'ignore'), (u'Extension', _____LocationReport_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Extension', _____LocationReport_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 283), (u'criticality', u'ignore'), (u'Extension', _____LocationReport_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 285), (u'criticality', u'ignore'), (u'Extension', _____LocationReport_protocolExtensions__item__id_tab_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___LocationReport_protocolExtensions__item__id._const_tab = ____LocationReport_protocolExtensions__item__id_tab
    ___LocationReport_protocolExtensions__item__id._const_tab_at = None
    ___LocationReport_protocolExtensions__item__id._const_tab_id = u'id'
    ___LocationReport_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___LocationReport_protocolExtensions__item__criticality._const_tab = ____LocationReport_protocolExtensions__item__id_tab
    ___LocationReport_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___LocationReport_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___LocationReport_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___LocationReport_protocolExtensions__item__extensionValue._const_tab = ____LocationReport_protocolExtensions__item__id_tab
    ___LocationReport_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LocationReport_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __LocationReport_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___LocationReport_protocolExtensions__item__id),
        (u'criticality', ___LocationReport_protocolExtensions__item__criticality),
        (u'extensionValue', ___LocationReport_protocolExtensions__item__extensionValue),
        ])
    __LocationReport_protocolExtensions__item_._ext = None
    _LocationReport_protocolExtensions._cont = __LocationReport_protocolExtensions__item_
    _LocationReport_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LocationReport._cont = ASN1Dict([
        (u'protocolIEs', _LocationReport_protocolIEs),
        (u'protocolExtensions', _LocationReport_protocolExtensions),
        ])
    LocationReport._ext = []
    
    #-----< LocationReportIEs >-----#
    LocationReportIEs = CLASS(name=u'LocationReportIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _LocationReportIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'AreaIdentity')))
    _LocationReportIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _LocationReportIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RequestType')))
    LocationReportIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _LocationReportIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _LocationReportIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 57), (u'criticality', u'ignore'), (u'Value', _LocationReportIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< LocationReportExtensions >-----#
    LocationReportExtensions = CLASS(name=u'LocationReportExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _LocationReportExtensions_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LastKnownServiceArea')))
    _LocationReportExtensions_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PositionData')))
    _LocationReportExtensions_val_Extension_2 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PositionDataSpecificToGERANIuMode')))
    _LocationReportExtensions_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'AccuracyFulfilmentIndicator')))
    _LocationReportExtensions_val_Extension_4 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'VelocityEstimate')))
    _LocationReportExtensions_val_Extension_5 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'BarometricPressure')))
    _LocationReportExtensions_val_Extension_6 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CivicAddress')))
    LocationReportExtensions._val = ASN1Set(rv=[dict([(u'id', 97), (u'criticality', u'ignore'), (u'Extension', _LocationReportExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 119), (u'criticality', u'ignore'), (u'Extension', _LocationReportExtensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 120), (u'criticality', u'ignore'), (u'Extension', _LocationReportExtensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 122), (u'criticality', u'ignore'), (u'Extension', _LocationReportExtensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Extension', _LocationReportExtensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 283), (u'criticality', u'ignore'), (u'Extension', _LocationReportExtensions_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 285), (u'criticality', u'ignore'), (u'Extension', _LocationReportExtensions_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< InitialUE-Message >-----#
    InitialUE_Message = SEQ(name=u'InitialUE-Message', mode=MODE_TYPE)
    _InitialUE_Message_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __InitialUE_Message_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___InitialUE_Message_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____InitialUE_Message_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LAI')))
    _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAC')))
    _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SAI')))
    _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NAS-PDU')))
    _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_5 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ____InitialUE_Message_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Value', _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 55), (u'criticality', u'ignore'), (u'Value', _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'conditional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 16), (u'criticality', u'ignore'), (u'Value', _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 79), (u'criticality', u'ignore'), (u'Value', _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___InitialUE_Message_protocolIEs__item__id._const_tab = ____InitialUE_Message_protocolIEs__item__id_tab
    ___InitialUE_Message_protocolIEs__item__id._const_tab_at = None
    ___InitialUE_Message_protocolIEs__item__id._const_tab_id = u'id'
    ___InitialUE_Message_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___InitialUE_Message_protocolIEs__item__criticality._const_tab = ____InitialUE_Message_protocolIEs__item__id_tab
    ___InitialUE_Message_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___InitialUE_Message_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___InitialUE_Message_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___InitialUE_Message_protocolIEs__item__value._const_tab = ____InitialUE_Message_protocolIEs__item__id_tab
    ___InitialUE_Message_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___InitialUE_Message_protocolIEs__item__value._const_tab_id = u'Value'
    __InitialUE_Message_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___InitialUE_Message_protocolIEs__item__id),
        (u'criticality', ___InitialUE_Message_protocolIEs__item__criticality),
        (u'value', ___InitialUE_Message_protocolIEs__item__value),
        ])
    __InitialUE_Message_protocolIEs__item_._ext = None
    _InitialUE_Message_protocolIEs._cont = __InitialUE_Message_protocolIEs__item_
    _InitialUE_Message_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InitialUE_Message_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InitialUE_Message_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___InitialUE_Message_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____InitialUE_Message_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GERAN-Classmark')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_2 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NAS-SequenceNumber')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_4 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RedirectAttemptFlag')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_5 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_6 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_7 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cell-Access-Mode')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_8 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_9 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'HigherBitratesThan16MbpsFlag')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TunnelInformation')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_11 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_12 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LHN-ID')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_13 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SGSN-Group-Identity')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_14 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-Usage-Type')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_15 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'DCN-ID')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_16 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-Application-Layer-Measurement-Capability')))
    ____InitialUE_Message_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 108), (u'criticality', u'ignore'), (u'Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 127), (u'criticality', u'ignore'), (u'Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 23), (u'criticality', u'ignore'), (u'Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 130), (u'criticality', u'ignore'), (u'Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 166), (u'criticality', u'ignore'), (u'Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 203), (u'criticality', u'reject'), (u'Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 235), (u'criticality', u'reject'), (u'Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 241), (u'criticality', u'ignore'), (u'Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 250), (u'criticality', u'ignore'), (u'Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 262), (u'criticality', u'ignore'), (u'Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 273), (u'criticality', u'ignore'), (u'Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 275), (u'criticality', u'ignore'), (u'Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 286), (u'criticality', u'ignore'), (u'Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 290), (u'criticality', u'ignore'), (u'Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 291), (u'criticality', u'ignore'), (u'Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_15), (u'presence', u'optional')]), dict([(u'id', 294), (u'criticality', u'ignore'), (u'Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_16), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___InitialUE_Message_protocolExtensions__item__id._const_tab = ____InitialUE_Message_protocolExtensions__item__id_tab
    ___InitialUE_Message_protocolExtensions__item__id._const_tab_at = None
    ___InitialUE_Message_protocolExtensions__item__id._const_tab_id = u'id'
    ___InitialUE_Message_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___InitialUE_Message_protocolExtensions__item__criticality._const_tab = ____InitialUE_Message_protocolExtensions__item__id_tab
    ___InitialUE_Message_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___InitialUE_Message_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___InitialUE_Message_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___InitialUE_Message_protocolExtensions__item__extensionValue._const_tab = ____InitialUE_Message_protocolExtensions__item__id_tab
    ___InitialUE_Message_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___InitialUE_Message_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __InitialUE_Message_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___InitialUE_Message_protocolExtensions__item__id),
        (u'criticality', ___InitialUE_Message_protocolExtensions__item__criticality),
        (u'extensionValue', ___InitialUE_Message_protocolExtensions__item__extensionValue),
        ])
    __InitialUE_Message_protocolExtensions__item_._ext = None
    _InitialUE_Message_protocolExtensions._cont = __InitialUE_Message_protocolExtensions__item_
    _InitialUE_Message_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InitialUE_Message._cont = ASN1Dict([
        (u'protocolIEs', _InitialUE_Message_protocolIEs),
        (u'protocolExtensions', _InitialUE_Message_protocolExtensions),
        ])
    InitialUE_Message._ext = []
    
    #-----< InitialUE-MessageIEs >-----#
    InitialUE_MessageIEs = CLASS(name=u'InitialUE-MessageIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _InitialUE_MessageIEs_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _InitialUE_MessageIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LAI')))
    _InitialUE_MessageIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAC')))
    _InitialUE_MessageIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SAI')))
    _InitialUE_MessageIEs_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NAS-PDU')))
    _InitialUE_MessageIEs_val_Value_5 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _InitialUE_MessageIEs_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    InitialUE_MessageIEs._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Value', _InitialUE_MessageIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _InitialUE_MessageIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 55), (u'criticality', u'ignore'), (u'Value', _InitialUE_MessageIEs_val_Value_2), (u'presence', u'conditional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _InitialUE_MessageIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 16), (u'criticality', u'ignore'), (u'Value', _InitialUE_MessageIEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 79), (u'criticality', u'ignore'), (u'Value', _InitialUE_MessageIEs_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _InitialUE_MessageIEs_val_Value_6), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< InitialUE-MessageExtensions >-----#
    InitialUE_MessageExtensions = CLASS(name=u'InitialUE-MessageExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _InitialUE_MessageExtensions_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GERAN-Classmark')))
    _InitialUE_MessageExtensions_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _InitialUE_MessageExtensions_val_Extension_2 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    _InitialUE_MessageExtensions_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NAS-SequenceNumber')))
    _InitialUE_MessageExtensions_val_Extension_4 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RedirectAttemptFlag')))
    _InitialUE_MessageExtensions_val_Extension_5 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    _InitialUE_MessageExtensions_val_Extension_6 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id')))
    _InitialUE_MessageExtensions_val_Extension_7 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cell-Access-Mode')))
    _InitialUE_MessageExtensions_val_Extension_8 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _InitialUE_MessageExtensions_val_Extension_9 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'HigherBitratesThan16MbpsFlag')))
    _InitialUE_MessageExtensions_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TunnelInformation')))
    _InitialUE_MessageExtensions_val_Extension_11 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _InitialUE_MessageExtensions_val_Extension_12 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LHN-ID')))
    _InitialUE_MessageExtensions_val_Extension_13 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SGSN-Group-Identity')))
    _InitialUE_MessageExtensions_val_Extension_14 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-Usage-Type')))
    _InitialUE_MessageExtensions_val_Extension_15 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'DCN-ID')))
    _InitialUE_MessageExtensions_val_Extension_16 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-Application-Layer-Measurement-Capability')))
    InitialUE_MessageExtensions._val = ASN1Set(rv=[dict([(u'id', 108), (u'criticality', u'ignore'), (u'Extension', _InitialUE_MessageExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 127), (u'criticality', u'ignore'), (u'Extension', _InitialUE_MessageExtensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 23), (u'criticality', u'ignore'), (u'Extension', _InitialUE_MessageExtensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 130), (u'criticality', u'ignore'), (u'Extension', _InitialUE_MessageExtensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 166), (u'criticality', u'ignore'), (u'Extension', _InitialUE_MessageExtensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _InitialUE_MessageExtensions_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 203), (u'criticality', u'reject'), (u'Extension', _InitialUE_MessageExtensions_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 235), (u'criticality', u'reject'), (u'Extension', _InitialUE_MessageExtensions_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 241), (u'criticality', u'ignore'), (u'Extension', _InitialUE_MessageExtensions_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 250), (u'criticality', u'ignore'), (u'Extension', _InitialUE_MessageExtensions_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 262), (u'criticality', u'ignore'), (u'Extension', _InitialUE_MessageExtensions_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 273), (u'criticality', u'ignore'), (u'Extension', _InitialUE_MessageExtensions_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 275), (u'criticality', u'ignore'), (u'Extension', _InitialUE_MessageExtensions_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 286), (u'criticality', u'ignore'), (u'Extension', _InitialUE_MessageExtensions_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 290), (u'criticality', u'ignore'), (u'Extension', _InitialUE_MessageExtensions_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 291), (u'criticality', u'ignore'), (u'Extension', _InitialUE_MessageExtensions_val_Extension_15), (u'presence', u'optional')]), dict([(u'id', 294), (u'criticality', u'ignore'), (u'Extension', _InitialUE_MessageExtensions_val_Extension_16), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DirectTransfer >-----#
    DirectTransfer = SEQ(name=u'DirectTransfer', mode=MODE_TYPE)
    _DirectTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __DirectTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___DirectTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____DirectTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____DirectTransfer_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NAS-PDU')))
    _____DirectTransfer_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LAI')))
    _____DirectTransfer_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAC')))
    _____DirectTransfer_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SAI')))
    _____DirectTransfer_protocolIEs__item__id_tab_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SAPI')))
    ____DirectTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 16), (u'criticality', u'ignore'), (u'Value', _____DirectTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _____DirectTransfer_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 55), (u'criticality', u'ignore'), (u'Value', _____DirectTransfer_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____DirectTransfer_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 59), (u'criticality', u'ignore'), (u'Value', _____DirectTransfer_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DirectTransfer_protocolIEs__item__id._const_tab = ____DirectTransfer_protocolIEs__item__id_tab
    ___DirectTransfer_protocolIEs__item__id._const_tab_at = None
    ___DirectTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___DirectTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___DirectTransfer_protocolIEs__item__criticality._const_tab = ____DirectTransfer_protocolIEs__item__id_tab
    ___DirectTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DirectTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DirectTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___DirectTransfer_protocolIEs__item__value._const_tab = ____DirectTransfer_protocolIEs__item__id_tab
    ___DirectTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DirectTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __DirectTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DirectTransfer_protocolIEs__item__id),
        (u'criticality', ___DirectTransfer_protocolIEs__item__criticality),
        (u'value', ___DirectTransfer_protocolIEs__item__value),
        ])
    __DirectTransfer_protocolIEs__item_._ext = None
    _DirectTransfer_protocolIEs._cont = __DirectTransfer_protocolIEs__item_
    _DirectTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DirectTransfer_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DirectTransfer_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___DirectTransfer_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DirectTransfer_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RedirectionIndication')))
    _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RedirectionCompleted')))
    _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SubscriberProfileIDforRFP')))
    _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_4 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_5 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LHN-ID')))
    ____DirectTransfer_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 129), (u'criticality', u'ignore'), (u'Extension', _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 128), (u'criticality', u'ignore'), (u'Extension', _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 202), (u'criticality', u'ignore'), (u'Extension', _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 241), (u'criticality', u'ignore'), (u'Extension', _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 273), (u'criticality', u'ignore'), (u'Extension', _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 275), (u'criticality', u'ignore'), (u'Extension', _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DirectTransfer_protocolExtensions__item__id._const_tab = ____DirectTransfer_protocolExtensions__item__id_tab
    ___DirectTransfer_protocolExtensions__item__id._const_tab_at = None
    ___DirectTransfer_protocolExtensions__item__id._const_tab_id = u'id'
    ___DirectTransfer_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DirectTransfer_protocolExtensions__item__criticality._const_tab = ____DirectTransfer_protocolExtensions__item__id_tab
    ___DirectTransfer_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___DirectTransfer_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___DirectTransfer_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DirectTransfer_protocolExtensions__item__extensionValue._const_tab = ____DirectTransfer_protocolExtensions__item__id_tab
    ___DirectTransfer_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DirectTransfer_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __DirectTransfer_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___DirectTransfer_protocolExtensions__item__id),
        (u'criticality', ___DirectTransfer_protocolExtensions__item__criticality),
        (u'extensionValue', ___DirectTransfer_protocolExtensions__item__extensionValue),
        ])
    __DirectTransfer_protocolExtensions__item_._ext = None
    _DirectTransfer_protocolExtensions._cont = __DirectTransfer_protocolExtensions__item_
    _DirectTransfer_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DirectTransfer._cont = ASN1Dict([
        (u'protocolIEs', _DirectTransfer_protocolIEs),
        (u'protocolExtensions', _DirectTransfer_protocolExtensions),
        ])
    DirectTransfer._ext = []
    
    #-----< DirectTransferIEs >-----#
    DirectTransferIEs = CLASS(name=u'DirectTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _DirectTransferIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NAS-PDU')))
    _DirectTransferIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LAI')))
    _DirectTransferIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAC')))
    _DirectTransferIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SAI')))
    _DirectTransferIEs_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SAPI')))
    DirectTransferIEs._val = ASN1Set(rv=[dict([(u'id', 16), (u'criticality', u'ignore'), (u'Value', _DirectTransferIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _DirectTransferIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 55), (u'criticality', u'ignore'), (u'Value', _DirectTransferIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _DirectTransferIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 59), (u'criticality', u'ignore'), (u'Value', _DirectTransferIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DirectTransferExtensions >-----#
    DirectTransferExtensions = CLASS(name=u'DirectTransferExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _DirectTransferExtensions_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RedirectionIndication')))
    _DirectTransferExtensions_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RedirectionCompleted')))
    _DirectTransferExtensions_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SubscriberProfileIDforRFP')))
    _DirectTransferExtensions_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _DirectTransferExtensions_val_Extension_4 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _DirectTransferExtensions_val_Extension_5 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LHN-ID')))
    DirectTransferExtensions._val = ASN1Set(rv=[dict([(u'id', 129), (u'criticality', u'ignore'), (u'Extension', _DirectTransferExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 128), (u'criticality', u'ignore'), (u'Extension', _DirectTransferExtensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 202), (u'criticality', u'ignore'), (u'Extension', _DirectTransferExtensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 241), (u'criticality', u'ignore'), (u'Extension', _DirectTransferExtensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 273), (u'criticality', u'ignore'), (u'Extension', _DirectTransferExtensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 275), (u'criticality', u'ignore'), (u'Extension', _DirectTransferExtensions_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RedirectionIndication >-----#
    RedirectionIndication = SEQ_OF(name=u'RedirectionIndication', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    _RedirectionIndication__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    __RedirectionIndication__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ___RedirectionIndication__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    ____RedirectionIndication__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NAS-PDU')))
    ____RedirectionIndication__item__id_tab_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RejectCauseValue')))
    ____RedirectionIndication__item__id_tab_val_Value_2 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NAS-SequenceNumber')))
    ____RedirectionIndication__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    ____RedirectionIndication__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Additional-CSPS-coordination-information')))
    ___RedirectionIndication__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 16), (u'criticality', u'ignore'), (u'Value', ____RedirectionIndication__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 131), (u'criticality', u'ignore'), (u'Value', ____RedirectionIndication__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 130), (u'criticality', u'ignore'), (u'Value', ____RedirectionIndication__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 23), (u'criticality', u'ignore'), (u'Value', ____RedirectionIndication__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 280), (u'criticality', u'reject'), (u'Value', ____RedirectionIndication__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    __RedirectionIndication__item__id._const_tab = ___RedirectionIndication__item__id_tab
    __RedirectionIndication__item__id._const_tab_at = None
    __RedirectionIndication__item__id._const_tab_id = u'id'
    __RedirectionIndication__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    __RedirectionIndication__item__criticality._const_tab = ___RedirectionIndication__item__id_tab
    __RedirectionIndication__item__criticality._const_tab_at = ('..', u'id')
    __RedirectionIndication__item__criticality._const_tab_id = u'criticality'
    __RedirectionIndication__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    __RedirectionIndication__item__value._const_tab = ___RedirectionIndication__item__id_tab
    __RedirectionIndication__item__value._const_tab_at = ('..', u'id')
    __RedirectionIndication__item__value._const_tab_id = u'Value'
    _RedirectionIndication__item_._cont = ASN1Dict([
        (u'id', __RedirectionIndication__item__id),
        (u'criticality', __RedirectionIndication__item__criticality),
        (u'value', __RedirectionIndication__item__value),
        ])
    _RedirectionIndication__item_._ext = None
    RedirectionIndication._cont = _RedirectionIndication__item_
    RedirectionIndication._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< RedirectionIndication-IEs >-----#
    RedirectionIndication_IEs = CLASS(name=u'RedirectionIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RedirectionIndication_IEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NAS-PDU')))
    _RedirectionIndication_IEs_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RejectCauseValue')))
    _RedirectionIndication_IEs_val_Value_2 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NAS-SequenceNumber')))
    _RedirectionIndication_IEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    _RedirectionIndication_IEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Additional-CSPS-coordination-information')))
    RedirectionIndication_IEs._val = ASN1Set(rv=[dict([(u'id', 16), (u'criticality', u'ignore'), (u'Value', _RedirectionIndication_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 131), (u'criticality', u'ignore'), (u'Value', _RedirectionIndication_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 130), (u'criticality', u'ignore'), (u'Value', _RedirectionIndication_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 23), (u'criticality', u'ignore'), (u'Value', _RedirectionIndication_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 280), (u'criticality', u'reject'), (u'Value', _RedirectionIndication_IEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Overload >-----#
    Overload = SEQ(name=u'Overload', mode=MODE_TYPE)
    _Overload_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __Overload_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___Overload_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____Overload_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____Overload_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NumberOfSteps')))
    _____Overload_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ____Overload_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 18), (u'criticality', u'ignore'), (u'Value', _____Overload_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _____Overload_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Overload_protocolIEs__item__id._const_tab = ____Overload_protocolIEs__item__id_tab
    ___Overload_protocolIEs__item__id._const_tab_at = None
    ___Overload_protocolIEs__item__id._const_tab_id = u'id'
    ___Overload_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___Overload_protocolIEs__item__criticality._const_tab = ____Overload_protocolIEs__item__id_tab
    ___Overload_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___Overload_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___Overload_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___Overload_protocolIEs__item__value._const_tab = ____Overload_protocolIEs__item__id_tab
    ___Overload_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___Overload_protocolIEs__item__value._const_tab_id = u'Value'
    __Overload_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___Overload_protocolIEs__item__id),
        (u'criticality', ___Overload_protocolIEs__item__criticality),
        (u'value', ___Overload_protocolIEs__item__value),
        ])
    __Overload_protocolIEs__item_._ext = None
    _Overload_protocolIEs._cont = __Overload_protocolIEs__item_
    _Overload_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _Overload_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Overload_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Overload_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Overload_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____Overload_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____Overload_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____Overload_protocolExtensions__item__id_tab_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    _____Overload_protocolExtensions__item__id_tab_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Priority-Class-Indicator')))
    ____Overload_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Extension', _____Overload_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 96), (u'criticality', u'ignore'), (u'Extension', _____Overload_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _____Overload_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 245), (u'criticality', u'ignore'), (u'Extension', _____Overload_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Overload_protocolExtensions__item__id._const_tab = ____Overload_protocolExtensions__item__id_tab
    ___Overload_protocolExtensions__item__id._const_tab_at = None
    ___Overload_protocolExtensions__item__id._const_tab_id = u'id'
    ___Overload_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Overload_protocolExtensions__item__criticality._const_tab = ____Overload_protocolExtensions__item__id_tab
    ___Overload_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___Overload_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___Overload_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Overload_protocolExtensions__item__extensionValue._const_tab = ____Overload_protocolExtensions__item__id_tab
    ___Overload_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Overload_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __Overload_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___Overload_protocolExtensions__item__id),
        (u'criticality', ___Overload_protocolExtensions__item__criticality),
        (u'extensionValue', ___Overload_protocolExtensions__item__extensionValue),
        ])
    __Overload_protocolExtensions__item_._ext = None
    _Overload_protocolExtensions._cont = __Overload_protocolExtensions__item_
    _Overload_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Overload._cont = ASN1Dict([
        (u'protocolIEs', _Overload_protocolIEs),
        (u'protocolExtensions', _Overload_protocolExtensions),
        ])
    Overload._ext = []
    
    #-----< OverloadIEs >-----#
    OverloadIEs = CLASS(name=u'OverloadIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _OverloadIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NumberOfSteps')))
    _OverloadIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    OverloadIEs._val = ASN1Set(rv=[dict([(u'id', 18), (u'criticality', u'ignore'), (u'Value', _OverloadIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _OverloadIEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< OverloadExtensions >-----#
    OverloadExtensions = CLASS(name=u'OverloadExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _OverloadExtensions_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _OverloadExtensions_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _OverloadExtensions_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    _OverloadExtensions_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Priority-Class-Indicator')))
    OverloadExtensions._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Extension', _OverloadExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 96), (u'criticality', u'ignore'), (u'Extension', _OverloadExtensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _OverloadExtensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 245), (u'criticality', u'ignore'), (u'Extension', _OverloadExtensions_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ErrorIndication >-----#
    ErrorIndication = SEQ(name=u'ErrorIndication', mode=MODE_TYPE)
    _ErrorIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __ErrorIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___ErrorIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____ErrorIndication_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ____ErrorIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 3), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolIEs__item__id._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__id._const_tab_at = None
    ___ErrorIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___ErrorIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___ErrorIndication_protocolIEs__item__criticality._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ErrorIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___ErrorIndication_protocolIEs__item__value._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ErrorIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __ErrorIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ErrorIndication_protocolIEs__item__id),
        (u'criticality', ___ErrorIndication_protocolIEs__item__criticality),
        (u'value', ___ErrorIndication_protocolIEs__item__value),
        ])
    __ErrorIndication_protocolIEs__item_._ext = None
    _ErrorIndication_protocolIEs._cont = __ErrorIndication_protocolIEs__item_
    _ErrorIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ErrorIndication_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ErrorIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___ErrorIndication_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ErrorIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____ErrorIndication_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____ErrorIndication_protocolExtensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ____ErrorIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 96), (u'criticality', u'ignore'), (u'Extension', _____ErrorIndication_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _____ErrorIndication_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolExtensions__item__id._const_tab = ____ErrorIndication_protocolExtensions__item__id_tab
    ___ErrorIndication_protocolExtensions__item__id._const_tab_at = None
    ___ErrorIndication_protocolExtensions__item__id._const_tab_id = u'id'
    ___ErrorIndication_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ErrorIndication_protocolExtensions__item__criticality._const_tab = ____ErrorIndication_protocolExtensions__item__id_tab
    ___ErrorIndication_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___ErrorIndication_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___ErrorIndication_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ErrorIndication_protocolExtensions__item__extensionValue._const_tab = ____ErrorIndication_protocolExtensions__item__id_tab
    ___ErrorIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ErrorIndication_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __ErrorIndication_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___ErrorIndication_protocolExtensions__item__id),
        (u'criticality', ___ErrorIndication_protocolExtensions__item__criticality),
        (u'extensionValue', ___ErrorIndication_protocolExtensions__item__extensionValue),
        ])
    __ErrorIndication_protocolExtensions__item_._ext = None
    _ErrorIndication_protocolExtensions._cont = __ErrorIndication_protocolExtensions__item_
    _ErrorIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ErrorIndication._cont = ASN1Dict([
        (u'protocolIEs', _ErrorIndication_protocolIEs),
        (u'protocolExtensions', _ErrorIndication_protocolExtensions),
        ])
    ErrorIndication._ext = []
    
    #-----< ErrorIndicationIEs >-----#
    ErrorIndicationIEs = CLASS(name=u'ErrorIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _ErrorIndicationIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _ErrorIndicationIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    _ErrorIndicationIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _ErrorIndicationIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ErrorIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _ErrorIndicationIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _ErrorIndicationIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 3), (u'criticality', u'ignore'), (u'Value', _ErrorIndicationIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _ErrorIndicationIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ErrorIndicationExtensions >-----#
    ErrorIndicationExtensions = CLASS(name=u'ErrorIndicationExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _ErrorIndicationExtensions_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _ErrorIndicationExtensions_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ErrorIndicationExtensions._val = ASN1Set(rv=[dict([(u'id', 96), (u'criticality', u'ignore'), (u'Extension', _ErrorIndicationExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _ErrorIndicationExtensions_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SRNS-DataForwardCommand >-----#
    SRNS_DataForwardCommand = SEQ(name=u'SRNS-DataForwardCommand', mode=MODE_TYPE)
    _SRNS_DataForwardCommand_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __SRNS_DataForwardCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___SRNS_DataForwardCommand_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____SRNS_DataForwardCommand_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____SRNS_DataForwardCommand_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataForwardingList')))
    ____SRNS_DataForwardCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 28), (u'criticality', u'ignore'), (u'Value', _____SRNS_DataForwardCommand_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SRNS_DataForwardCommand_protocolIEs__item__id._const_tab = ____SRNS_DataForwardCommand_protocolIEs__item__id_tab
    ___SRNS_DataForwardCommand_protocolIEs__item__id._const_tab_at = None
    ___SRNS_DataForwardCommand_protocolIEs__item__id._const_tab_id = u'id'
    ___SRNS_DataForwardCommand_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___SRNS_DataForwardCommand_protocolIEs__item__criticality._const_tab = ____SRNS_DataForwardCommand_protocolIEs__item__id_tab
    ___SRNS_DataForwardCommand_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SRNS_DataForwardCommand_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SRNS_DataForwardCommand_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___SRNS_DataForwardCommand_protocolIEs__item__value._const_tab = ____SRNS_DataForwardCommand_protocolIEs__item__id_tab
    ___SRNS_DataForwardCommand_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SRNS_DataForwardCommand_protocolIEs__item__value._const_tab_id = u'Value'
    __SRNS_DataForwardCommand_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SRNS_DataForwardCommand_protocolIEs__item__id),
        (u'criticality', ___SRNS_DataForwardCommand_protocolIEs__item__criticality),
        (u'value', ___SRNS_DataForwardCommand_protocolIEs__item__value),
        ])
    __SRNS_DataForwardCommand_protocolIEs__item_._ext = None
    _SRNS_DataForwardCommand_protocolIEs._cont = __SRNS_DataForwardCommand_protocolIEs__item_
    _SRNS_DataForwardCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _SRNS_DataForwardCommand_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRNS_DataForwardCommand_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SRNS_DataForwardCommand_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SRNS_DataForwardCommand_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRNS_DataForwardCommand_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRNS_DataForwardCommand_protocolExtensions__item__id._const_tab = ____SRNS_DataForwardCommand_protocolExtensions__item__id_tab
    ___SRNS_DataForwardCommand_protocolExtensions__item__id._const_tab_at = None
    ___SRNS_DataForwardCommand_protocolExtensions__item__id._const_tab_id = u'id'
    ___SRNS_DataForwardCommand_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SRNS_DataForwardCommand_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRNS_DataForwardCommand_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRNS_DataForwardCommand_protocolExtensions__item__criticality._const_tab = ____SRNS_DataForwardCommand_protocolExtensions__item__criticality_tab
    ___SRNS_DataForwardCommand_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRNS_DataForwardCommand_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___SRNS_DataForwardCommand_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SRNS_DataForwardCommand_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRNS_DataForwardCommand_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRNS_DataForwardCommand_protocolExtensions__item__extensionValue._const_tab = ____SRNS_DataForwardCommand_protocolExtensions__item__extensionValue_tab
    ___SRNS_DataForwardCommand_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRNS_DataForwardCommand_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __SRNS_DataForwardCommand_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___SRNS_DataForwardCommand_protocolExtensions__item__id),
        (u'criticality', ___SRNS_DataForwardCommand_protocolExtensions__item__criticality),
        (u'extensionValue', ___SRNS_DataForwardCommand_protocolExtensions__item__extensionValue),
        ])
    __SRNS_DataForwardCommand_protocolExtensions__item_._ext = None
    _SRNS_DataForwardCommand_protocolExtensions._cont = __SRNS_DataForwardCommand_protocolExtensions__item_
    _SRNS_DataForwardCommand_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRNS_DataForwardCommand._cont = ASN1Dict([
        (u'protocolIEs', _SRNS_DataForwardCommand_protocolIEs),
        (u'protocolExtensions', _SRNS_DataForwardCommand_protocolExtensions),
        ])
    SRNS_DataForwardCommand._ext = []
    
    #-----< SRNS-DataForwardCommandIEs >-----#
    SRNS_DataForwardCommandIEs = CLASS(name=u'SRNS-DataForwardCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _SRNS_DataForwardCommandIEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataForwardingList')))
    SRNS_DataForwardCommandIEs._val = ASN1Set(rv=[dict([(u'id', 28), (u'criticality', u'ignore'), (u'Value', _SRNS_DataForwardCommandIEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SRNS-DataForwardCommandExtensions >-----#
    SRNS_DataForwardCommandExtensions = CLASS(name=u'SRNS-DataForwardCommandExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SRNS_DataForwardCommandExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ForwardSRNS-Context >-----#
    ForwardSRNS_Context = SEQ(name=u'ForwardSRNS-Context', mode=MODE_TYPE)
    _ForwardSRNS_Context_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __ForwardSRNS_Context_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___ForwardSRNS_Context_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____ForwardSRNS_Context_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____ForwardSRNS_Context_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ContextList')))
    ____ForwardSRNS_Context_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _____ForwardSRNS_Context_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___ForwardSRNS_Context_protocolIEs__item__id._const_tab = ____ForwardSRNS_Context_protocolIEs__item__id_tab
    ___ForwardSRNS_Context_protocolIEs__item__id._const_tab_at = None
    ___ForwardSRNS_Context_protocolIEs__item__id._const_tab_id = u'id'
    ___ForwardSRNS_Context_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___ForwardSRNS_Context_protocolIEs__item__criticality._const_tab = ____ForwardSRNS_Context_protocolIEs__item__id_tab
    ___ForwardSRNS_Context_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ForwardSRNS_Context_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ForwardSRNS_Context_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___ForwardSRNS_Context_protocolIEs__item__value._const_tab = ____ForwardSRNS_Context_protocolIEs__item__id_tab
    ___ForwardSRNS_Context_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ForwardSRNS_Context_protocolIEs__item__value._const_tab_id = u'Value'
    __ForwardSRNS_Context_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ForwardSRNS_Context_protocolIEs__item__id),
        (u'criticality', ___ForwardSRNS_Context_protocolIEs__item__criticality),
        (u'value', ___ForwardSRNS_Context_protocolIEs__item__value),
        ])
    __ForwardSRNS_Context_protocolIEs__item_._ext = None
    _ForwardSRNS_Context_protocolIEs._cont = __ForwardSRNS_Context_protocolIEs__item_
    _ForwardSRNS_Context_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ForwardSRNS_Context_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ForwardSRNS_Context_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___ForwardSRNS_Context_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ForwardSRNS_Context_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____ForwardSRNS_Context_protocolExtensions__item__id_tab_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RRC-Container')))
    ____ForwardSRNS_Context_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 103), (u'criticality', u'ignore'), (u'Extension', _____ForwardSRNS_Context_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ForwardSRNS_Context_protocolExtensions__item__id._const_tab = ____ForwardSRNS_Context_protocolExtensions__item__id_tab
    ___ForwardSRNS_Context_protocolExtensions__item__id._const_tab_at = None
    ___ForwardSRNS_Context_protocolExtensions__item__id._const_tab_id = u'id'
    ___ForwardSRNS_Context_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ForwardSRNS_Context_protocolExtensions__item__criticality._const_tab = ____ForwardSRNS_Context_protocolExtensions__item__id_tab
    ___ForwardSRNS_Context_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___ForwardSRNS_Context_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___ForwardSRNS_Context_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ForwardSRNS_Context_protocolExtensions__item__extensionValue._const_tab = ____ForwardSRNS_Context_protocolExtensions__item__id_tab
    ___ForwardSRNS_Context_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ForwardSRNS_Context_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __ForwardSRNS_Context_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___ForwardSRNS_Context_protocolExtensions__item__id),
        (u'criticality', ___ForwardSRNS_Context_protocolExtensions__item__criticality),
        (u'extensionValue', ___ForwardSRNS_Context_protocolExtensions__item__extensionValue),
        ])
    __ForwardSRNS_Context_protocolExtensions__item_._ext = None
    _ForwardSRNS_Context_protocolExtensions._cont = __ForwardSRNS_Context_protocolExtensions__item_
    _ForwardSRNS_Context_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ForwardSRNS_Context._cont = ASN1Dict([
        (u'protocolIEs', _ForwardSRNS_Context_protocolIEs),
        (u'protocolExtensions', _ForwardSRNS_Context_protocolExtensions),
        ])
    ForwardSRNS_Context._ext = []
    
    #-----< ForwardSRNS-ContextIEs >-----#
    ForwardSRNS_ContextIEs = CLASS(name=u'ForwardSRNS-ContextIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _ForwardSRNS_ContextIEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ContextList')))
    ForwardSRNS_ContextIEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _ForwardSRNS_ContextIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ForwardSRNS-ContextExtensions >-----#
    ForwardSRNS_ContextExtensions = CLASS(name=u'ForwardSRNS-ContextExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _ForwardSRNS_ContextExtensions_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RRC-Container')))
    ForwardSRNS_ContextExtensions._val = ASN1Set(rv=[dict([(u'id', 103), (u'criticality', u'ignore'), (u'Extension', _ForwardSRNS_ContextExtensions_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-AssignmentRequest >-----#
    RAB_AssignmentRequest = SEQ(name=u'RAB-AssignmentRequest', mode=MODE_TYPE)
    _RAB_AssignmentRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_AssignmentRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_AssignmentRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_AssignmentRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_AssignmentRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupOrModifyList')))
    _____RAB_AssignmentRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseList')))
    ____RAB_AssignmentRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 54), (u'criticality', u'ignore'), (u'Value', _____RAB_AssignmentRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 41), (u'criticality', u'ignore'), (u'Value', _____RAB_AssignmentRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RAB_AssignmentRequest_protocolIEs__item__id._const_tab = ____RAB_AssignmentRequest_protocolIEs__item__id_tab
    ___RAB_AssignmentRequest_protocolIEs__item__id._const_tab_at = None
    ___RAB_AssignmentRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___RAB_AssignmentRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_AssignmentRequest_protocolIEs__item__criticality._const_tab = ____RAB_AssignmentRequest_protocolIEs__item__id_tab
    ___RAB_AssignmentRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_AssignmentRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RAB_AssignmentRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_AssignmentRequest_protocolIEs__item__value._const_tab = ____RAB_AssignmentRequest_protocolIEs__item__id_tab
    ___RAB_AssignmentRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RAB_AssignmentRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __RAB_AssignmentRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RAB_AssignmentRequest_protocolIEs__item__id),
        (u'criticality', ___RAB_AssignmentRequest_protocolIEs__item__criticality),
        (u'value', ___RAB_AssignmentRequest_protocolIEs__item__value),
        ])
    __RAB_AssignmentRequest_protocolIEs__item_._ext = None
    _RAB_AssignmentRequest_protocolIEs._cont = __RAB_AssignmentRequest_protocolIEs__item_
    _RAB_AssignmentRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RAB_AssignmentRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_AssignmentRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_AssignmentRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_AssignmentRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RAB_AssignmentRequest_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-AggregateMaximumBitRate')))
    _____RAB_AssignmentRequest_protocolExtensions__item__id_tab_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MSISDN')))
    ____RAB_AssignmentRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 233), (u'criticality', u'ignore'), (u'Extension', _____RAB_AssignmentRequest_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 239), (u'criticality', u'ignore'), (u'Extension', _____RAB_AssignmentRequest_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RAB_AssignmentRequest_protocolExtensions__item__id._const_tab = ____RAB_AssignmentRequest_protocolExtensions__item__id_tab
    ___RAB_AssignmentRequest_protocolExtensions__item__id._const_tab_at = None
    ___RAB_AssignmentRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___RAB_AssignmentRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RAB_AssignmentRequest_protocolExtensions__item__criticality._const_tab = ____RAB_AssignmentRequest_protocolExtensions__item__id_tab
    ___RAB_AssignmentRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_AssignmentRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_AssignmentRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RAB_AssignmentRequest_protocolExtensions__item__extensionValue._const_tab = ____RAB_AssignmentRequest_protocolExtensions__item__id_tab
    ___RAB_AssignmentRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_AssignmentRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_AssignmentRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_AssignmentRequest_protocolExtensions__item__id),
        (u'criticality', ___RAB_AssignmentRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___RAB_AssignmentRequest_protocolExtensions__item__extensionValue),
        ])
    __RAB_AssignmentRequest_protocolExtensions__item_._ext = None
    _RAB_AssignmentRequest_protocolExtensions._cont = __RAB_AssignmentRequest_protocolExtensions__item_
    _RAB_AssignmentRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_AssignmentRequest._cont = ASN1Dict([
        (u'protocolIEs', _RAB_AssignmentRequest_protocolIEs),
        (u'protocolExtensions', _RAB_AssignmentRequest_protocolExtensions),
        ])
    RAB_AssignmentRequest._ext = []
    
    #-----< RAB-AssignmentRequestIEs >-----#
    RAB_AssignmentRequestIEs = CLASS(name=u'RAB-AssignmentRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_AssignmentRequestIEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupOrModifyList')))
    _RAB_AssignmentRequestIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseList')))
    RAB_AssignmentRequestIEs._val = ASN1Set(rv=[dict([(u'id', 54), (u'criticality', u'ignore'), (u'Value', _RAB_AssignmentRequestIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 41), (u'criticality', u'ignore'), (u'Value', _RAB_AssignmentRequestIEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupOrModifyList >-----#
    RAB_SetupOrModifyList = SEQ_OF(name=u'RAB-SetupOrModifyList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerPairList')))
    _RAB_SetupOrModifyList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-ContainerPair')))
    __RAB_SetupOrModifyList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-FieldPair')))
    ___RAB_SetupOrModifyList__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES-PAIR'), [u'id']))
    ____RAB_SetupOrModifyList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES-PAIR', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES-PAIR')))
    _____RAB_SetupOrModifyList__item___item__id_tab_val_FirstValue_0 = SEQ(name=u'FirstValue', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupOrModifyItemFirst')))
    _____RAB_SetupOrModifyList__item___item__id_tab_val_SecondValue_0 = SEQ(name=u'SecondValue', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupOrModifyItemSecond')))
    ____RAB_SetupOrModifyList__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 53), (u'firstCriticality', u'reject'), (u'FirstValue', _____RAB_SetupOrModifyList__item___item__id_tab_val_FirstValue_0), (u'secondCriticality', u'ignore'), (u'SecondValue', _____RAB_SetupOrModifyList__item___item__id_tab_val_SecondValue_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_SetupOrModifyList__item___item__id._const_tab = ____RAB_SetupOrModifyList__item___item__id_tab
    ___RAB_SetupOrModifyList__item___item__id._const_tab_at = None
    ___RAB_SetupOrModifyList__item___item__id._const_tab_id = u'id'
    ___RAB_SetupOrModifyList__item___item__firstCriticality = ENUM(name=u'firstCriticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES-PAIR'), [u'firstCriticality']))
    ___RAB_SetupOrModifyList__item___item__firstCriticality._const_tab = ____RAB_SetupOrModifyList__item___item__id_tab
    ___RAB_SetupOrModifyList__item___item__firstCriticality._const_tab_at = ('..', u'id')
    ___RAB_SetupOrModifyList__item___item__firstCriticality._const_tab_id = u'firstCriticality'
    ___RAB_SetupOrModifyList__item___item__firstValue = OPEN(name=u'firstValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES-PAIR'), [u'FirstValue']))
    ___RAB_SetupOrModifyList__item___item__firstValue._const_tab = ____RAB_SetupOrModifyList__item___item__id_tab
    ___RAB_SetupOrModifyList__item___item__firstValue._const_tab_at = ('..', u'id')
    ___RAB_SetupOrModifyList__item___item__firstValue._const_tab_id = u'FirstValue'
    ___RAB_SetupOrModifyList__item___item__secondCriticality = ENUM(name=u'secondCriticality', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES-PAIR'), [u'secondCriticality']))
    ___RAB_SetupOrModifyList__item___item__secondCriticality._const_tab = ____RAB_SetupOrModifyList__item___item__id_tab
    ___RAB_SetupOrModifyList__item___item__secondCriticality._const_tab_at = ('..', u'id')
    ___RAB_SetupOrModifyList__item___item__secondCriticality._const_tab_id = u'secondCriticality'
    ___RAB_SetupOrModifyList__item___item__secondValue = OPEN(name=u'secondValue', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES-PAIR'), [u'SecondValue']))
    ___RAB_SetupOrModifyList__item___item__secondValue._const_tab = ____RAB_SetupOrModifyList__item___item__id_tab
    ___RAB_SetupOrModifyList__item___item__secondValue._const_tab_at = ('..', u'id')
    ___RAB_SetupOrModifyList__item___item__secondValue._const_tab_id = u'SecondValue'
    __RAB_SetupOrModifyList__item___item_._cont = ASN1Dict([
        (u'id', ___RAB_SetupOrModifyList__item___item__id),
        (u'firstCriticality', ___RAB_SetupOrModifyList__item___item__firstCriticality),
        (u'firstValue', ___RAB_SetupOrModifyList__item___item__firstValue),
        (u'secondCriticality', ___RAB_SetupOrModifyList__item___item__secondCriticality),
        (u'secondValue', ___RAB_SetupOrModifyList__item___item__secondValue),
        ])
    __RAB_SetupOrModifyList__item___item_._ext = None
    _RAB_SetupOrModifyList__item_._cont = __RAB_SetupOrModifyList__item___item_
    _RAB_SetupOrModifyList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_SetupOrModifyList._cont = _RAB_SetupOrModifyList__item_
    RAB_SetupOrModifyList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-SetupOrModifyItem-IEs >-----#
    RAB_SetupOrModifyItem_IEs = CLASS(name=u'RAB-SetupOrModifyItem-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES-PAIR')))
    _RAB_SetupOrModifyItem_IEs_val_FirstValue_0 = SEQ(name=u'FirstValue', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupOrModifyItemFirst')))
    _RAB_SetupOrModifyItem_IEs_val_SecondValue_0 = SEQ(name=u'SecondValue', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupOrModifyItemSecond')))
    RAB_SetupOrModifyItem_IEs._val = ASN1Set(rv=[dict([(u'id', 53), (u'firstCriticality', u'reject'), (u'FirstValue', _RAB_SetupOrModifyItem_IEs_val_FirstValue_0), (u'secondCriticality', u'ignore'), (u'SecondValue', _RAB_SetupOrModifyItem_IEs_val_SecondValue_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupOrModifyItemFirst >-----#
    RAB_SetupOrModifyItemFirst = SEQ(name=u'RAB-SetupOrModifyItemFirst', mode=MODE_TYPE)
    _RAB_SetupOrModifyItemFirst_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_SetupOrModifyItemFirst_nAS_SynchronisationIndicator = BIT_STR(name=u'nAS-SynchronisationIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'NAS-SynchronisationIndicator')), opt=True)
    _RAB_SetupOrModifyItemFirst_rAB_Parameters = SEQ(name=u'rAB-Parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameters')), opt=True)
    _RAB_SetupOrModifyItemFirst_userPlaneInformation = SEQ(name=u'userPlaneInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Contents', 'UserPlaneInformation')), opt=True)
    _RAB_SetupOrModifyItemFirst_transportLayerInformation = SEQ(name=u'transportLayerInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Contents', 'TransportLayerInformation')), opt=True)
    _RAB_SetupOrModifyItemFirst_service_Handover = ENUM(name=u'service-Handover', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Service-Handover')), opt=True)
    _RAB_SetupOrModifyItemFirst_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_SetupOrModifyItemFirst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'E-UTRAN-Service-Handover')))
    _____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Correlation-ID')))
    _____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab_val_Extension_2 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Correlation-ID')))
    ____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 231), (u'criticality', u'ignore'), (u'Extension', _____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 242), (u'criticality', u'ignore'), (u'Extension', _____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 274), (u'criticality', u'ignore'), (u'Extension', _____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__id._const_tab = ____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab
    ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__id._const_tab_at = None
    ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__criticality._const_tab = ____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab
    ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__extensionValue._const_tab = ____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab
    ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_SetupOrModifyItemFirst_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__id),
        (u'criticality', ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__extensionValue),
        ])
    __RAB_SetupOrModifyItemFirst_iE_Extensions__item_._ext = None
    _RAB_SetupOrModifyItemFirst_iE_Extensions._cont = __RAB_SetupOrModifyItemFirst_iE_Extensions__item_
    _RAB_SetupOrModifyItemFirst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_SetupOrModifyItemFirst._cont = ASN1Dict([
        (u'rAB-ID', _RAB_SetupOrModifyItemFirst_rAB_ID),
        (u'nAS-SynchronisationIndicator', _RAB_SetupOrModifyItemFirst_nAS_SynchronisationIndicator),
        (u'rAB-Parameters', _RAB_SetupOrModifyItemFirst_rAB_Parameters),
        (u'userPlaneInformation', _RAB_SetupOrModifyItemFirst_userPlaneInformation),
        (u'transportLayerInformation', _RAB_SetupOrModifyItemFirst_transportLayerInformation),
        (u'service-Handover', _RAB_SetupOrModifyItemFirst_service_Handover),
        (u'iE-Extensions', _RAB_SetupOrModifyItemFirst_iE_Extensions),
        ])
    RAB_SetupOrModifyItemFirst._ext = []
    
    #-----< TransportLayerInformation >-----#
    TransportLayerInformation = SEQ(name=u'TransportLayerInformation', mode=MODE_TYPE)
    _TransportLayerInformation_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _TransportLayerInformation_iuTransportAssociation = CHOICE(name=u'iuTransportAssociation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IuTransportAssociation')))
    _TransportLayerInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TransportLayerInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___TransportLayerInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TransportLayerInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TransportLayerInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportLayerInformation_iE_Extensions__item__id._const_tab = ____TransportLayerInformation_iE_Extensions__item__id_tab
    ___TransportLayerInformation_iE_Extensions__item__id._const_tab_at = None
    ___TransportLayerInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___TransportLayerInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TransportLayerInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TransportLayerInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportLayerInformation_iE_Extensions__item__criticality._const_tab = ____TransportLayerInformation_iE_Extensions__item__criticality_tab
    ___TransportLayerInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TransportLayerInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TransportLayerInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TransportLayerInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TransportLayerInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportLayerInformation_iE_Extensions__item__extensionValue._const_tab = ____TransportLayerInformation_iE_Extensions__item__extensionValue_tab
    ___TransportLayerInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TransportLayerInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TransportLayerInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TransportLayerInformation_iE_Extensions__item__id),
        (u'criticality', ___TransportLayerInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___TransportLayerInformation_iE_Extensions__item__extensionValue),
        ])
    __TransportLayerInformation_iE_Extensions__item_._ext = None
    _TransportLayerInformation_iE_Extensions._cont = __TransportLayerInformation_iE_Extensions__item_
    _TransportLayerInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TransportLayerInformation._cont = ASN1Dict([
        (u'transportLayerAddress', _TransportLayerInformation_transportLayerAddress),
        (u'iuTransportAssociation', _TransportLayerInformation_iuTransportAssociation),
        (u'iE-Extensions', _TransportLayerInformation_iE_Extensions),
        ])
    TransportLayerInformation._ext = []
    
    #-----< TransportLayerInformation-ExtIEs >-----#
    TransportLayerInformation_ExtIEs = CLASS(name=u'TransportLayerInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    TransportLayerInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupOrModifyItemFirst-ExtIEs >-----#
    RAB_SetupOrModifyItemFirst_ExtIEs = CLASS(name=u'RAB-SetupOrModifyItemFirst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RAB_SetupOrModifyItemFirst_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'E-UTRAN-Service-Handover')))
    _RAB_SetupOrModifyItemFirst_ExtIEs_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Correlation-ID')))
    _RAB_SetupOrModifyItemFirst_ExtIEs_val_Extension_2 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Correlation-ID')))
    RAB_SetupOrModifyItemFirst_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 231), (u'criticality', u'ignore'), (u'Extension', _RAB_SetupOrModifyItemFirst_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 242), (u'criticality', u'ignore'), (u'Extension', _RAB_SetupOrModifyItemFirst_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 274), (u'criticality', u'ignore'), (u'Extension', _RAB_SetupOrModifyItemFirst_ExtIEs_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupOrModifyItemSecond >-----#
    RAB_SetupOrModifyItemSecond = SEQ(name=u'RAB-SetupOrModifyItemSecond', mode=MODE_TYPE)
    _RAB_SetupOrModifyItemSecond_pDP_TypeInformation = SEQ_OF(name=u'pDP-TypeInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PDP-TypeInformation')), opt=True)
    _RAB_SetupOrModifyItemSecond_dataVolumeReportingIndication = ENUM(name=u'dataVolumeReportingIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DataVolumeReportingIndication')), opt=True)
    _RAB_SetupOrModifyItemSecond_dl_GTP_PDU_SequenceNumber = INT(name=u'dl-GTP-PDU-SequenceNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DL-GTP-PDU-SequenceNumber')), opt=True)
    _RAB_SetupOrModifyItemSecond_ul_GTP_PDU_SequenceNumber = INT(name=u'ul-GTP-PDU-SequenceNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UL-GTP-PDU-SequenceNumber')), opt=True)
    _RAB_SetupOrModifyItemSecond_dl_N_PDU_SequenceNumber = INT(name=u'dl-N-PDU-SequenceNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DL-N-PDU-SequenceNumber')), opt=True)
    _RAB_SetupOrModifyItemSecond_ul_N_PDU_SequenceNumber = INT(name=u'ul-N-PDU-SequenceNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UL-N-PDU-SequenceNumber')), opt=True)
    _RAB_SetupOrModifyItemSecond_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_SetupOrModifyItemSecond_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameters')))
    _____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GERAN-BSC-Container')))
    _____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PDP-TypeInformation-extension')))
    _____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Offload-RAB-Parameters')))
    ____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 89), (u'criticality', u'ignore'), (u'Extension', _____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 107), (u'criticality', u'ignore'), (u'Extension', _____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 238), (u'criticality', u'ignore'), (u'Extension', _____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 240), (u'criticality', u'ignore'), (u'Extension', _____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__id._const_tab = ____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab
    ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__id._const_tab_at = None
    ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__criticality._const_tab = ____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab
    ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__extensionValue._const_tab = ____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab
    ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_SetupOrModifyItemSecond_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__id),
        (u'criticality', ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__extensionValue),
        ])
    __RAB_SetupOrModifyItemSecond_iE_Extensions__item_._ext = None
    _RAB_SetupOrModifyItemSecond_iE_Extensions._cont = __RAB_SetupOrModifyItemSecond_iE_Extensions__item_
    _RAB_SetupOrModifyItemSecond_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_SetupOrModifyItemSecond._cont = ASN1Dict([
        (u'pDP-TypeInformation', _RAB_SetupOrModifyItemSecond_pDP_TypeInformation),
        (u'dataVolumeReportingIndication', _RAB_SetupOrModifyItemSecond_dataVolumeReportingIndication),
        (u'dl-GTP-PDU-SequenceNumber', _RAB_SetupOrModifyItemSecond_dl_GTP_PDU_SequenceNumber),
        (u'ul-GTP-PDU-SequenceNumber', _RAB_SetupOrModifyItemSecond_ul_GTP_PDU_SequenceNumber),
        (u'dl-N-PDU-SequenceNumber', _RAB_SetupOrModifyItemSecond_dl_N_PDU_SequenceNumber),
        (u'ul-N-PDU-SequenceNumber', _RAB_SetupOrModifyItemSecond_ul_N_PDU_SequenceNumber),
        (u'iE-Extensions', _RAB_SetupOrModifyItemSecond_iE_Extensions),
        ])
    RAB_SetupOrModifyItemSecond._ext = []
    
    #-----< RAB-SetupOrModifyItemSecond-ExtIEs >-----#
    RAB_SetupOrModifyItemSecond_ExtIEs = CLASS(name=u'RAB-SetupOrModifyItemSecond-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RAB_SetupOrModifyItemSecond_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameters')))
    _RAB_SetupOrModifyItemSecond_ExtIEs_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GERAN-BSC-Container')))
    _RAB_SetupOrModifyItemSecond_ExtIEs_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PDP-TypeInformation-extension')))
    _RAB_SetupOrModifyItemSecond_ExtIEs_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Offload-RAB-Parameters')))
    RAB_SetupOrModifyItemSecond_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 89), (u'criticality', u'ignore'), (u'Extension', _RAB_SetupOrModifyItemSecond_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 107), (u'criticality', u'ignore'), (u'Extension', _RAB_SetupOrModifyItemSecond_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 238), (u'criticality', u'ignore'), (u'Extension', _RAB_SetupOrModifyItemSecond_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 240), (u'criticality', u'ignore'), (u'Extension', _RAB_SetupOrModifyItemSecond_ExtIEs_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-AssignmentRequestExtensions >-----#
    RAB_AssignmentRequestExtensions = CLASS(name=u'RAB-AssignmentRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RAB_AssignmentRequestExtensions_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-AggregateMaximumBitRate')))
    _RAB_AssignmentRequestExtensions_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MSISDN')))
    RAB_AssignmentRequestExtensions._val = ASN1Set(rv=[dict([(u'id', 233), (u'criticality', u'ignore'), (u'Extension', _RAB_AssignmentRequestExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 239), (u'criticality', u'ignore'), (u'Extension', _RAB_AssignmentRequestExtensions_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-AssignmentResponse >-----#
    RAB_AssignmentResponse = SEQ(name=u'RAB-AssignmentResponse', mode=MODE_TYPE)
    _RAB_AssignmentResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_AssignmentResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_AssignmentResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_AssignmentResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupOrModifiedList')))
    _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleasedList')))
    _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-QueuedList')))
    _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedList')))
    _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseFailedList')))
    _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____RAB_AssignmentResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 52), (u'criticality', u'ignore'), (u'Value', _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 43), (u'criticality', u'ignore'), (u'Value', _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 38), (u'criticality', u'ignore'), (u'Value', _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 35), (u'criticality', u'ignore'), (u'Value', _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 39), (u'criticality', u'ignore'), (u'Value', _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RAB_AssignmentResponse_protocolIEs__item__id._const_tab = ____RAB_AssignmentResponse_protocolIEs__item__id_tab
    ___RAB_AssignmentResponse_protocolIEs__item__id._const_tab_at = None
    ___RAB_AssignmentResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___RAB_AssignmentResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_AssignmentResponse_protocolIEs__item__criticality._const_tab = ____RAB_AssignmentResponse_protocolIEs__item__id_tab
    ___RAB_AssignmentResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_AssignmentResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RAB_AssignmentResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_AssignmentResponse_protocolIEs__item__value._const_tab = ____RAB_AssignmentResponse_protocolIEs__item__id_tab
    ___RAB_AssignmentResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RAB_AssignmentResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __RAB_AssignmentResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RAB_AssignmentResponse_protocolIEs__item__id),
        (u'criticality', ___RAB_AssignmentResponse_protocolIEs__item__criticality),
        (u'value', ___RAB_AssignmentResponse_protocolIEs__item__value),
        ])
    __RAB_AssignmentResponse_protocolIEs__item_._ext = None
    _RAB_AssignmentResponse_protocolIEs._cont = __RAB_AssignmentResponse_protocolIEs__item_
    _RAB_AssignmentResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RAB_AssignmentResponse_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_AssignmentResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_AssignmentResponse_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_AssignmentResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RAB_AssignmentResponse_protocolExtensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'GERAN-Iumode-RAB-FailedList-RABAssgntResponse')))
    ____RAB_AssignmentResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 110), (u'criticality', u'ignore'), (u'Extension', _____RAB_AssignmentResponse_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RAB_AssignmentResponse_protocolExtensions__item__id._const_tab = ____RAB_AssignmentResponse_protocolExtensions__item__id_tab
    ___RAB_AssignmentResponse_protocolExtensions__item__id._const_tab_at = None
    ___RAB_AssignmentResponse_protocolExtensions__item__id._const_tab_id = u'id'
    ___RAB_AssignmentResponse_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RAB_AssignmentResponse_protocolExtensions__item__criticality._const_tab = ____RAB_AssignmentResponse_protocolExtensions__item__id_tab
    ___RAB_AssignmentResponse_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_AssignmentResponse_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_AssignmentResponse_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RAB_AssignmentResponse_protocolExtensions__item__extensionValue._const_tab = ____RAB_AssignmentResponse_protocolExtensions__item__id_tab
    ___RAB_AssignmentResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_AssignmentResponse_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_AssignmentResponse_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_AssignmentResponse_protocolExtensions__item__id),
        (u'criticality', ___RAB_AssignmentResponse_protocolExtensions__item__criticality),
        (u'extensionValue', ___RAB_AssignmentResponse_protocolExtensions__item__extensionValue),
        ])
    __RAB_AssignmentResponse_protocolExtensions__item_._ext = None
    _RAB_AssignmentResponse_protocolExtensions._cont = __RAB_AssignmentResponse_protocolExtensions__item_
    _RAB_AssignmentResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_AssignmentResponse._cont = ASN1Dict([
        (u'protocolIEs', _RAB_AssignmentResponse_protocolIEs),
        (u'protocolExtensions', _RAB_AssignmentResponse_protocolExtensions),
        ])
    RAB_AssignmentResponse._ext = []
    
    #-----< RAB-AssignmentResponseIEs >-----#
    RAB_AssignmentResponseIEs = CLASS(name=u'RAB-AssignmentResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_AssignmentResponseIEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupOrModifiedList')))
    _RAB_AssignmentResponseIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleasedList')))
    _RAB_AssignmentResponseIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-QueuedList')))
    _RAB_AssignmentResponseIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedList')))
    _RAB_AssignmentResponseIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseFailedList')))
    _RAB_AssignmentResponseIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    RAB_AssignmentResponseIEs._val = ASN1Set(rv=[dict([(u'id', 52), (u'criticality', u'ignore'), (u'Value', _RAB_AssignmentResponseIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 43), (u'criticality', u'ignore'), (u'Value', _RAB_AssignmentResponseIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 38), (u'criticality', u'ignore'), (u'Value', _RAB_AssignmentResponseIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 35), (u'criticality', u'ignore'), (u'Value', _RAB_AssignmentResponseIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 39), (u'criticality', u'ignore'), (u'Value', _RAB_AssignmentResponseIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _RAB_AssignmentResponseIEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupOrModifiedList >-----#
    RAB_SetupOrModifiedList = SEQ_OF(name=u'RAB-SetupOrModifiedList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_SetupOrModifiedList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_SetupOrModifiedList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_SetupOrModifiedList__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_SetupOrModifiedList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_SetupOrModifiedList__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupOrModifiedItem')))
    ____RAB_SetupOrModifiedList__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 51), (u'criticality', u'ignore'), (u'Value', _____RAB_SetupOrModifiedList__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_SetupOrModifiedList__item___item__id._const_tab = ____RAB_SetupOrModifiedList__item___item__id_tab
    ___RAB_SetupOrModifiedList__item___item__id._const_tab_at = None
    ___RAB_SetupOrModifiedList__item___item__id._const_tab_id = u'id'
    ___RAB_SetupOrModifiedList__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_SetupOrModifiedList__item___item__criticality._const_tab = ____RAB_SetupOrModifiedList__item___item__id_tab
    ___RAB_SetupOrModifiedList__item___item__criticality._const_tab_at = ('..', u'id')
    ___RAB_SetupOrModifiedList__item___item__criticality._const_tab_id = u'criticality'
    ___RAB_SetupOrModifiedList__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_SetupOrModifiedList__item___item__value._const_tab = ____RAB_SetupOrModifiedList__item___item__id_tab
    ___RAB_SetupOrModifiedList__item___item__value._const_tab_at = ('..', u'id')
    ___RAB_SetupOrModifiedList__item___item__value._const_tab_id = u'Value'
    __RAB_SetupOrModifiedList__item___item_._cont = ASN1Dict([
        (u'id', ___RAB_SetupOrModifiedList__item___item__id),
        (u'criticality', ___RAB_SetupOrModifiedList__item___item__criticality),
        (u'value', ___RAB_SetupOrModifiedList__item___item__value),
        ])
    __RAB_SetupOrModifiedList__item___item_._ext = None
    _RAB_SetupOrModifiedList__item_._cont = __RAB_SetupOrModifiedList__item___item_
    _RAB_SetupOrModifiedList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_SetupOrModifiedList._cont = _RAB_SetupOrModifiedList__item_
    RAB_SetupOrModifiedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-SetupOrModifiedItemIEs >-----#
    RAB_SetupOrModifiedItemIEs = CLASS(name=u'RAB-SetupOrModifiedItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_SetupOrModifiedItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupOrModifiedItem')))
    RAB_SetupOrModifiedItemIEs._val = ASN1Set(rv=[dict([(u'id', 51), (u'criticality', u'ignore'), (u'Value', _RAB_SetupOrModifiedItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupOrModifiedItem >-----#
    RAB_SetupOrModifiedItem = SEQ(name=u'RAB-SetupOrModifiedItem', mode=MODE_TYPE)
    _RAB_SetupOrModifiedItem_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_SetupOrModifiedItem_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')), opt=True)
    _RAB_SetupOrModifiedItem_iuTransportAssociation = CHOICE(name=u'iuTransportAssociation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IuTransportAssociation')), opt=True)
    _RAB_SetupOrModifiedItem_dl_dataVolumes = SEQ_OF(name=u'dl-dataVolumes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeList')), opt=True)
    _RAB_SetupOrModifiedItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_SetupOrModifiedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_SetupOrModifiedItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_SetupOrModifiedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RAB_SetupOrModifiedItem_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Ass-RAB-Parameters')))
    ____RAB_SetupOrModifiedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 90), (u'criticality', u'ignore'), (u'Extension', _____RAB_SetupOrModifiedItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RAB_SetupOrModifiedItem_iE_Extensions__item__id._const_tab = ____RAB_SetupOrModifiedItem_iE_Extensions__item__id_tab
    ___RAB_SetupOrModifiedItem_iE_Extensions__item__id._const_tab_at = None
    ___RAB_SetupOrModifiedItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAB_SetupOrModifiedItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RAB_SetupOrModifiedItem_iE_Extensions__item__criticality._const_tab = ____RAB_SetupOrModifiedItem_iE_Extensions__item__id_tab
    ___RAB_SetupOrModifiedItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_SetupOrModifiedItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_SetupOrModifiedItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RAB_SetupOrModifiedItem_iE_Extensions__item__extensionValue._const_tab = ____RAB_SetupOrModifiedItem_iE_Extensions__item__id_tab
    ___RAB_SetupOrModifiedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_SetupOrModifiedItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_SetupOrModifiedItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_SetupOrModifiedItem_iE_Extensions__item__id),
        (u'criticality', ___RAB_SetupOrModifiedItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAB_SetupOrModifiedItem_iE_Extensions__item__extensionValue),
        ])
    __RAB_SetupOrModifiedItem_iE_Extensions__item_._ext = None
    _RAB_SetupOrModifiedItem_iE_Extensions._cont = __RAB_SetupOrModifiedItem_iE_Extensions__item_
    _RAB_SetupOrModifiedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_SetupOrModifiedItem._cont = ASN1Dict([
        (u'rAB-ID', _RAB_SetupOrModifiedItem_rAB_ID),
        (u'transportLayerAddress', _RAB_SetupOrModifiedItem_transportLayerAddress),
        (u'iuTransportAssociation', _RAB_SetupOrModifiedItem_iuTransportAssociation),
        (u'dl-dataVolumes', _RAB_SetupOrModifiedItem_dl_dataVolumes),
        (u'iE-Extensions', _RAB_SetupOrModifiedItem_iE_Extensions),
        ])
    RAB_SetupOrModifiedItem._ext = []
    
    #-----< RAB-SetupOrModifiedItem-ExtIEs >-----#
    RAB_SetupOrModifiedItem_ExtIEs = CLASS(name=u'RAB-SetupOrModifiedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RAB_SetupOrModifiedItem_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Ass-RAB-Parameters')))
    RAB_SetupOrModifiedItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 90), (u'criticality', u'ignore'), (u'Extension', _RAB_SetupOrModifiedItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-ReleasedList >-----#
    RAB_ReleasedList = SEQ_OF(name=u'RAB-ReleasedList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_ReleasedList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_ReleasedList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_ReleasedList__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_ReleasedList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_ReleasedList__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleasedItem')))
    ____RAB_ReleasedList__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 42), (u'criticality', u'ignore'), (u'Value', _____RAB_ReleasedList__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_ReleasedList__item___item__id._const_tab = ____RAB_ReleasedList__item___item__id_tab
    ___RAB_ReleasedList__item___item__id._const_tab_at = None
    ___RAB_ReleasedList__item___item__id._const_tab_id = u'id'
    ___RAB_ReleasedList__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_ReleasedList__item___item__criticality._const_tab = ____RAB_ReleasedList__item___item__id_tab
    ___RAB_ReleasedList__item___item__criticality._const_tab_at = ('..', u'id')
    ___RAB_ReleasedList__item___item__criticality._const_tab_id = u'criticality'
    ___RAB_ReleasedList__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_ReleasedList__item___item__value._const_tab = ____RAB_ReleasedList__item___item__id_tab
    ___RAB_ReleasedList__item___item__value._const_tab_at = ('..', u'id')
    ___RAB_ReleasedList__item___item__value._const_tab_id = u'Value'
    __RAB_ReleasedList__item___item_._cont = ASN1Dict([
        (u'id', ___RAB_ReleasedList__item___item__id),
        (u'criticality', ___RAB_ReleasedList__item___item__criticality),
        (u'value', ___RAB_ReleasedList__item___item__value),
        ])
    __RAB_ReleasedList__item___item_._ext = None
    _RAB_ReleasedList__item_._cont = __RAB_ReleasedList__item___item_
    _RAB_ReleasedList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_ReleasedList._cont = _RAB_ReleasedList__item_
    RAB_ReleasedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-ReleasedItemIEs >-----#
    RAB_ReleasedItemIEs = CLASS(name=u'RAB-ReleasedItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_ReleasedItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleasedItem')))
    RAB_ReleasedItemIEs._val = ASN1Set(rv=[dict([(u'id', 42), (u'criticality', u'ignore'), (u'Value', _RAB_ReleasedItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-ReleasedItem >-----#
    RAB_ReleasedItem = SEQ(name=u'RAB-ReleasedItem', mode=MODE_TYPE)
    _RAB_ReleasedItem_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_ReleasedItem_dl_dataVolumes = SEQ_OF(name=u'dl-dataVolumes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeList')), opt=True)
    _RAB_ReleasedItem_dL_GTP_PDU_SequenceNumber = INT(name=u'dL-GTP-PDU-SequenceNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DL-GTP-PDU-SequenceNumber')), opt=True)
    _RAB_ReleasedItem_uL_GTP_PDU_SequenceNumber = INT(name=u'uL-GTP-PDU-SequenceNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UL-GTP-PDU-SequenceNumber')), opt=True)
    _RAB_ReleasedItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_ReleasedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_ReleasedItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_ReleasedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ReleasedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ReleasedItem_iE_Extensions__item__id._const_tab = ____RAB_ReleasedItem_iE_Extensions__item__id_tab
    ___RAB_ReleasedItem_iE_Extensions__item__id._const_tab_at = None
    ___RAB_ReleasedItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAB_ReleasedItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RAB_ReleasedItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ReleasedItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ReleasedItem_iE_Extensions__item__criticality._const_tab = ____RAB_ReleasedItem_iE_Extensions__item__criticality_tab
    ___RAB_ReleasedItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_ReleasedItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_ReleasedItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RAB_ReleasedItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ReleasedItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ReleasedItem_iE_Extensions__item__extensionValue._const_tab = ____RAB_ReleasedItem_iE_Extensions__item__extensionValue_tab
    ___RAB_ReleasedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_ReleasedItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_ReleasedItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_ReleasedItem_iE_Extensions__item__id),
        (u'criticality', ___RAB_ReleasedItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAB_ReleasedItem_iE_Extensions__item__extensionValue),
        ])
    __RAB_ReleasedItem_iE_Extensions__item_._ext = None
    _RAB_ReleasedItem_iE_Extensions._cont = __RAB_ReleasedItem_iE_Extensions__item_
    _RAB_ReleasedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_ReleasedItem._cont = ASN1Dict([
        (u'rAB-ID', _RAB_ReleasedItem_rAB_ID),
        (u'dl-dataVolumes', _RAB_ReleasedItem_dl_dataVolumes),
        (u'dL-GTP-PDU-SequenceNumber', _RAB_ReleasedItem_dL_GTP_PDU_SequenceNumber),
        (u'uL-GTP-PDU-SequenceNumber', _RAB_ReleasedItem_uL_GTP_PDU_SequenceNumber),
        (u'iE-Extensions', _RAB_ReleasedItem_iE_Extensions),
        ])
    RAB_ReleasedItem._ext = []
    
    #-----< RAB-ReleasedItem-ExtIEs >-----#
    RAB_ReleasedItem_ExtIEs = CLASS(name=u'RAB-ReleasedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_ReleasedItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DataVolumeList >-----#
    DataVolumeList = SEQ_OF(name=u'DataVolumeList', mode=MODE_TYPE)
    _DataVolumeList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __DataVolumeList__item__dl_UnsuccessfullyTransmittedDataVolume = INT(name=u'dl-UnsuccessfullyTransmittedDataVolume', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UnsuccessfullyTransmittedDataVolume')))
    __DataVolumeList__item__dataVolumeReference = INT(name=u'dataVolumeReference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DataVolumeReference')), opt=True)
    __DataVolumeList__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___DataVolumeList__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____DataVolumeList__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    _____DataVolumeList__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____DataVolumeList__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____DataVolumeList__item__iE_Extensions__item__id._const_tab = _____DataVolumeList__item__iE_Extensions__item__id_tab
    ____DataVolumeList__item__iE_Extensions__item__id._const_tab_at = None
    ____DataVolumeList__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____DataVolumeList__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____DataVolumeList__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____DataVolumeList__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____DataVolumeList__item__iE_Extensions__item__criticality._const_tab = _____DataVolumeList__item__iE_Extensions__item__criticality_tab
    ____DataVolumeList__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____DataVolumeList__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____DataVolumeList__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____DataVolumeList__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____DataVolumeList__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____DataVolumeList__item__iE_Extensions__item__extensionValue._const_tab = _____DataVolumeList__item__iE_Extensions__item__extensionValue_tab
    ____DataVolumeList__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____DataVolumeList__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___DataVolumeList__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____DataVolumeList__item__iE_Extensions__item__id),
        (u'criticality', ____DataVolumeList__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____DataVolumeList__item__iE_Extensions__item__extensionValue),
        ])
    ___DataVolumeList__item__iE_Extensions__item_._ext = None
    __DataVolumeList__item__iE_Extensions._cont = ___DataVolumeList__item__iE_Extensions__item_
    __DataVolumeList__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _DataVolumeList__item_._cont = ASN1Dict([
        (u'dl-UnsuccessfullyTransmittedDataVolume', __DataVolumeList__item__dl_UnsuccessfullyTransmittedDataVolume),
        (u'dataVolumeReference', __DataVolumeList__item__dataVolumeReference),
        (u'iE-Extensions', __DataVolumeList__item__iE_Extensions),
        ])
    _DataVolumeList__item_._ext = []
    DataVolumeList._cont = _DataVolumeList__item_
    DataVolumeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< DataVolumeList-ExtIEs >-----#
    DataVolumeList_ExtIEs = CLASS(name=u'DataVolumeList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    DataVolumeList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-QueuedList >-----#
    RAB_QueuedList = SEQ_OF(name=u'RAB-QueuedList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_QueuedList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_QueuedList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_QueuedList__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_QueuedList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_QueuedList__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-QueuedItem')))
    ____RAB_QueuedList__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 37), (u'criticality', u'ignore'), (u'Value', _____RAB_QueuedList__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_QueuedList__item___item__id._const_tab = ____RAB_QueuedList__item___item__id_tab
    ___RAB_QueuedList__item___item__id._const_tab_at = None
    ___RAB_QueuedList__item___item__id._const_tab_id = u'id'
    ___RAB_QueuedList__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_QueuedList__item___item__criticality._const_tab = ____RAB_QueuedList__item___item__id_tab
    ___RAB_QueuedList__item___item__criticality._const_tab_at = ('..', u'id')
    ___RAB_QueuedList__item___item__criticality._const_tab_id = u'criticality'
    ___RAB_QueuedList__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_QueuedList__item___item__value._const_tab = ____RAB_QueuedList__item___item__id_tab
    ___RAB_QueuedList__item___item__value._const_tab_at = ('..', u'id')
    ___RAB_QueuedList__item___item__value._const_tab_id = u'Value'
    __RAB_QueuedList__item___item_._cont = ASN1Dict([
        (u'id', ___RAB_QueuedList__item___item__id),
        (u'criticality', ___RAB_QueuedList__item___item__criticality),
        (u'value', ___RAB_QueuedList__item___item__value),
        ])
    __RAB_QueuedList__item___item_._ext = None
    _RAB_QueuedList__item_._cont = __RAB_QueuedList__item___item_
    _RAB_QueuedList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_QueuedList._cont = _RAB_QueuedList__item_
    RAB_QueuedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-QueuedItemIEs >-----#
    RAB_QueuedItemIEs = CLASS(name=u'RAB-QueuedItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_QueuedItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-QueuedItem')))
    RAB_QueuedItemIEs._val = ASN1Set(rv=[dict([(u'id', 37), (u'criticality', u'ignore'), (u'Value', _RAB_QueuedItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-QueuedItem >-----#
    RAB_QueuedItem = SEQ(name=u'RAB-QueuedItem', mode=MODE_TYPE)
    _RAB_QueuedItem_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_QueuedItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_QueuedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_QueuedItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_QueuedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_QueuedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_QueuedItem_iE_Extensions__item__id._const_tab = ____RAB_QueuedItem_iE_Extensions__item__id_tab
    ___RAB_QueuedItem_iE_Extensions__item__id._const_tab_at = None
    ___RAB_QueuedItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAB_QueuedItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RAB_QueuedItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_QueuedItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_QueuedItem_iE_Extensions__item__criticality._const_tab = ____RAB_QueuedItem_iE_Extensions__item__criticality_tab
    ___RAB_QueuedItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_QueuedItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_QueuedItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RAB_QueuedItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_QueuedItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_QueuedItem_iE_Extensions__item__extensionValue._const_tab = ____RAB_QueuedItem_iE_Extensions__item__extensionValue_tab
    ___RAB_QueuedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_QueuedItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_QueuedItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_QueuedItem_iE_Extensions__item__id),
        (u'criticality', ___RAB_QueuedItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAB_QueuedItem_iE_Extensions__item__extensionValue),
        ])
    __RAB_QueuedItem_iE_Extensions__item_._ext = None
    _RAB_QueuedItem_iE_Extensions._cont = __RAB_QueuedItem_iE_Extensions__item_
    _RAB_QueuedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_QueuedItem._cont = ASN1Dict([
        (u'rAB-ID', _RAB_QueuedItem_rAB_ID),
        (u'iE-Extensions', _RAB_QueuedItem_iE_Extensions),
        ])
    RAB_QueuedItem._ext = []
    
    #-----< RAB-QueuedItem-ExtIEs >-----#
    RAB_QueuedItem_ExtIEs = CLASS(name=u'RAB-QueuedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_QueuedItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-ReleaseFailedList >-----#
    RAB_ReleaseFailedList = SEQ_OF(name=u'RAB-ReleaseFailedList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedList')))
    
    #-----< RAB-AssignmentResponseExtensions >-----#
    RAB_AssignmentResponseExtensions = CLASS(name=u'RAB-AssignmentResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RAB_AssignmentResponseExtensions_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'GERAN-Iumode-RAB-FailedList-RABAssgntResponse')))
    RAB_AssignmentResponseExtensions._val = ASN1Set(rv=[dict([(u'id', 110), (u'criticality', u'ignore'), (u'Extension', _RAB_AssignmentResponseExtensions_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< GERAN-Iumode-RAB-FailedList-RABAssgntResponse >-----#
    GERAN_Iumode_RAB_FailedList_RABAssgntResponse = SEQ_OF(name=u'GERAN-Iumode-RAB-FailedList-RABAssgntResponse', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item')))
    ____GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 109), (u'criticality', u'ignore'), (u'Value', _____GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id._const_tab = ____GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id_tab
    ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id._const_tab_at = None
    ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id._const_tab_id = u'id'
    ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__criticality._const_tab = ____GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id_tab
    ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__criticality._const_tab_at = ('..', u'id')
    ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__criticality._const_tab_id = u'criticality'
    ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__value._const_tab = ____GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id_tab
    ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__value._const_tab_at = ('..', u'id')
    ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__value._const_tab_id = u'Value'
    __GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item_._cont = ASN1Dict([
        (u'id', ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id),
        (u'criticality', ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__criticality),
        (u'value', ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__value),
        ])
    __GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item_._ext = None
    _GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item_._cont = __GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item_
    _GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GERAN_Iumode_RAB_FailedList_RABAssgntResponse._cont = _GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item_
    GERAN_Iumode_RAB_FailedList_RABAssgntResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< GERAN-Iumode-RAB-Failed-RABAssgntResponse-ItemIEs >-----#
    GERAN_Iumode_RAB_Failed_RABAssgntResponse_ItemIEs = CLASS(name=u'GERAN-Iumode-RAB-Failed-RABAssgntResponse-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _GERAN_Iumode_RAB_Failed_RABAssgntResponse_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item')))
    GERAN_Iumode_RAB_Failed_RABAssgntResponse_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 109), (u'criticality', u'ignore'), (u'Value', _GERAN_Iumode_RAB_Failed_RABAssgntResponse_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item >-----#
    GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item = SEQ(name=u'GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item', mode=MODE_TYPE)
    _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_gERAN_Classmark = OCT_STR(name=u'gERAN-Classmark', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GERAN-Classmark')), opt=True)
    _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__id._const_tab = ____GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__id_tab
    ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__id._const_tab_at = None
    ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__criticality._const_tab = ____GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__criticality_tab
    ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__extensionValue._const_tab = ____GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__extensionValue_tab
    ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__id),
        (u'criticality', ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__extensionValue),
        ])
    __GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item_._ext = None
    _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions._cont = __GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item_
    _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item._cont = ASN1Dict([
        (u'rAB-ID', _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_rAB_ID),
        (u'cause', _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_cause),
        (u'gERAN-Classmark', _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_gERAN_Classmark),
        (u'iE-Extensions', _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions),
        ])
    GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item._ext = []
    
    #-----< GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item-ExtIEs >-----#
    GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_ExtIEs = CLASS(name=u'GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PrivateMessage >-----#
    PrivateMessage = SEQ(name=u'PrivateMessage', mode=MODE_TYPE)
    _PrivateMessage_privateIEs = SEQ_OF(name=u'privateIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'PrivateIE-Container')))
    __PrivateMessage_privateIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'PrivateIE-Field')))
    ___PrivateMessage_privateIEs__item__id = CHOICE(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PRIVATE-IES'), [u'id']))
    ____PrivateMessage_privateIEs__item__id_tab = CLASS(name='_tab_RANAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__id._const_tab = ____PrivateMessage_privateIEs__item__id_tab
    ___PrivateMessage_privateIEs__item__id._const_tab_at = None
    ___PrivateMessage_privateIEs__item__id._const_tab_id = u'id'
    ___PrivateMessage_privateIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PRIVATE-IES'), [u'criticality']))
    ____PrivateMessage_privateIEs__item__criticality_tab = CLASS(name='_tab_RANAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__criticality._const_tab = ____PrivateMessage_privateIEs__item__criticality_tab
    ___PrivateMessage_privateIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PrivateMessage_privateIEs__item__criticality._const_tab_id = u'criticality'
    ___PrivateMessage_privateIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PRIVATE-IES'), [u'Value']))
    ____PrivateMessage_privateIEs__item__value_tab = CLASS(name='_tab_RANAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__value._const_tab = ____PrivateMessage_privateIEs__item__value_tab
    ___PrivateMessage_privateIEs__item__value._const_tab_at = ('..', u'id')
    ___PrivateMessage_privateIEs__item__value._const_tab_id = u'Value'
    __PrivateMessage_privateIEs__item_._cont = ASN1Dict([
        (u'id', ___PrivateMessage_privateIEs__item__id),
        (u'criticality', ___PrivateMessage_privateIEs__item__criticality),
        (u'value', ___PrivateMessage_privateIEs__item__value),
        ])
    __PrivateMessage_privateIEs__item_._ext = None
    _PrivateMessage_privateIEs._cont = __PrivateMessage_privateIEs__item_
    _PrivateMessage_privateIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrivateMessage._cont = ASN1Dict([
        (u'privateIEs', _PrivateMessage_privateIEs),
        ])
    PrivateMessage._ext = []
    
    #-----< PrivateMessage-IEs >-----#
    PrivateMessage_IEs = CLASS(name=u'PrivateMessage-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PRIVATE-IES')))
    PrivateMessage_IEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RANAP-RelocationInformation >-----#
    RANAP_RelocationInformation = SEQ(name=u'RANAP-RelocationInformation', mode=MODE_TYPE)
    _RANAP_RelocationInformation_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RANAP_RelocationInformation_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RANAP_RelocationInformation_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RANAP_RelocationInformation_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RANAP_RelocationInformation_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectTransferInformationList-RANAP-RelocInf')))
    _____RANAP_RelocationInformation_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ContextList-RANAP-RelocInf')))
    ____RANAP_RelocationInformation_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 81), (u'criticality', u'ignore'), (u'Value', _____RANAP_RelocationInformation_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 83), (u'criticality', u'ignore'), (u'Value', _____RANAP_RelocationInformation_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RANAP_RelocationInformation_protocolIEs__item__id._const_tab = ____RANAP_RelocationInformation_protocolIEs__item__id_tab
    ___RANAP_RelocationInformation_protocolIEs__item__id._const_tab_at = None
    ___RANAP_RelocationInformation_protocolIEs__item__id._const_tab_id = u'id'
    ___RANAP_RelocationInformation_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RANAP_RelocationInformation_protocolIEs__item__criticality._const_tab = ____RANAP_RelocationInformation_protocolIEs__item__id_tab
    ___RANAP_RelocationInformation_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RANAP_RelocationInformation_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RANAP_RelocationInformation_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RANAP_RelocationInformation_protocolIEs__item__value._const_tab = ____RANAP_RelocationInformation_protocolIEs__item__id_tab
    ___RANAP_RelocationInformation_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RANAP_RelocationInformation_protocolIEs__item__value._const_tab_id = u'Value'
    __RANAP_RelocationInformation_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RANAP_RelocationInformation_protocolIEs__item__id),
        (u'criticality', ___RANAP_RelocationInformation_protocolIEs__item__criticality),
        (u'value', ___RANAP_RelocationInformation_protocolIEs__item__value),
        ])
    __RANAP_RelocationInformation_protocolIEs__item_._ext = None
    _RANAP_RelocationInformation_protocolIEs._cont = __RANAP_RelocationInformation_protocolIEs__item_
    _RANAP_RelocationInformation_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RANAP_RelocationInformation_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RANAP_RelocationInformation_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RANAP_RelocationInformation_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RANAP_RelocationInformation_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RANAP_RelocationInformation_protocolExtensions__item__id_tab_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RRC-Container')))
    _____RANAP_RelocationInformation_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RNSAPRelocationParameters')))
    ____RANAP_RelocationInformation_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 103), (u'criticality', u'ignore'), (u'Extension', _____RANAP_RelocationInformation_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 247), (u'criticality', u'reject'), (u'Extension', _____RANAP_RelocationInformation_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RANAP_RelocationInformation_protocolExtensions__item__id._const_tab = ____RANAP_RelocationInformation_protocolExtensions__item__id_tab
    ___RANAP_RelocationInformation_protocolExtensions__item__id._const_tab_at = None
    ___RANAP_RelocationInformation_protocolExtensions__item__id._const_tab_id = u'id'
    ___RANAP_RelocationInformation_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RANAP_RelocationInformation_protocolExtensions__item__criticality._const_tab = ____RANAP_RelocationInformation_protocolExtensions__item__id_tab
    ___RANAP_RelocationInformation_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RANAP_RelocationInformation_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RANAP_RelocationInformation_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RANAP_RelocationInformation_protocolExtensions__item__extensionValue._const_tab = ____RANAP_RelocationInformation_protocolExtensions__item__id_tab
    ___RANAP_RelocationInformation_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RANAP_RelocationInformation_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RANAP_RelocationInformation_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RANAP_RelocationInformation_protocolExtensions__item__id),
        (u'criticality', ___RANAP_RelocationInformation_protocolExtensions__item__criticality),
        (u'extensionValue', ___RANAP_RelocationInformation_protocolExtensions__item__extensionValue),
        ])
    __RANAP_RelocationInformation_protocolExtensions__item_._ext = None
    _RANAP_RelocationInformation_protocolExtensions._cont = __RANAP_RelocationInformation_protocolExtensions__item_
    _RANAP_RelocationInformation_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RANAP_RelocationInformation._cont = ASN1Dict([
        (u'protocolIEs', _RANAP_RelocationInformation_protocolIEs),
        (u'protocolExtensions', _RANAP_RelocationInformation_protocolExtensions),
        ])
    RANAP_RelocationInformation._ext = []
    
    #-----< RANAP-RelocationInformationIEs >-----#
    RANAP_RelocationInformationIEs = CLASS(name=u'RANAP-RelocationInformationIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RANAP_RelocationInformationIEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectTransferInformationList-RANAP-RelocInf')))
    _RANAP_RelocationInformationIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ContextList-RANAP-RelocInf')))
    RANAP_RelocationInformationIEs._val = ASN1Set(rv=[dict([(u'id', 81), (u'criticality', u'ignore'), (u'Value', _RANAP_RelocationInformationIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 83), (u'criticality', u'ignore'), (u'Value', _RANAP_RelocationInformationIEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DirectTransferInformationList-RANAP-RelocInf >-----#
    DirectTransferInformationList_RANAP_RelocInf = SEQ_OF(name=u'DirectTransferInformationList-RANAP-RelocInf', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectTransfer-IE-ContainerList')))
    _DirectTransferInformationList_RANAP_RelocInf__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __DirectTransferInformationList_RANAP_RelocInf__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___DirectTransferInformationList_RANAP_RelocInf__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____DirectTransferInformationList_RANAP_RelocInf__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____DirectTransferInformationList_RANAP_RelocInf__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectTransferInformationItem-RANAP-RelocInf')))
    ____DirectTransferInformationList_RANAP_RelocInf__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 80), (u'criticality', u'ignore'), (u'Value', _____DirectTransferInformationList_RANAP_RelocInf__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___DirectTransferInformationList_RANAP_RelocInf__item___item__id._const_tab = ____DirectTransferInformationList_RANAP_RelocInf__item___item__id_tab
    ___DirectTransferInformationList_RANAP_RelocInf__item___item__id._const_tab_at = None
    ___DirectTransferInformationList_RANAP_RelocInf__item___item__id._const_tab_id = u'id'
    ___DirectTransferInformationList_RANAP_RelocInf__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___DirectTransferInformationList_RANAP_RelocInf__item___item__criticality._const_tab = ____DirectTransferInformationList_RANAP_RelocInf__item___item__id_tab
    ___DirectTransferInformationList_RANAP_RelocInf__item___item__criticality._const_tab_at = ('..', u'id')
    ___DirectTransferInformationList_RANAP_RelocInf__item___item__criticality._const_tab_id = u'criticality'
    ___DirectTransferInformationList_RANAP_RelocInf__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___DirectTransferInformationList_RANAP_RelocInf__item___item__value._const_tab = ____DirectTransferInformationList_RANAP_RelocInf__item___item__id_tab
    ___DirectTransferInformationList_RANAP_RelocInf__item___item__value._const_tab_at = ('..', u'id')
    ___DirectTransferInformationList_RANAP_RelocInf__item___item__value._const_tab_id = u'Value'
    __DirectTransferInformationList_RANAP_RelocInf__item___item_._cont = ASN1Dict([
        (u'id', ___DirectTransferInformationList_RANAP_RelocInf__item___item__id),
        (u'criticality', ___DirectTransferInformationList_RANAP_RelocInf__item___item__criticality),
        (u'value', ___DirectTransferInformationList_RANAP_RelocInf__item___item__value),
        ])
    __DirectTransferInformationList_RANAP_RelocInf__item___item_._ext = None
    _DirectTransferInformationList_RANAP_RelocInf__item_._cont = __DirectTransferInformationList_RANAP_RelocInf__item___item_
    _DirectTransferInformationList_RANAP_RelocInf__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DirectTransferInformationList_RANAP_RelocInf._cont = _DirectTransferInformationList_RANAP_RelocInf__item_
    DirectTransferInformationList_RANAP_RelocInf._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< DirectTransferInformationItemIEs-RANAP-RelocInf >-----#
    DirectTransferInformationItemIEs_RANAP_RelocInf = CLASS(name=u'DirectTransferInformationItemIEs-RANAP-RelocInf', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _DirectTransferInformationItemIEs_RANAP_RelocInf_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectTransferInformationItem-RANAP-RelocInf')))
    DirectTransferInformationItemIEs_RANAP_RelocInf._val = ASN1Set(rv=[dict([(u'id', 80), (u'criticality', u'ignore'), (u'Value', _DirectTransferInformationItemIEs_RANAP_RelocInf_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DirectTransferInformationItem-RANAP-RelocInf >-----#
    DirectTransferInformationItem_RANAP_RelocInf = SEQ(name=u'DirectTransferInformationItem-RANAP-RelocInf', mode=MODE_TYPE)
    _DirectTransferInformationItem_RANAP_RelocInf_nAS_PDU = OCT_STR(name=u'nAS-PDU', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'NAS-PDU')))
    _DirectTransferInformationItem_RANAP_RelocInf_sAPI = ENUM(name=u'sAPI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SAPI')))
    _DirectTransferInformationItem_RANAP_RelocInf_cN_DomainIndicator = ENUM(name=u'cN-DomainIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__id._const_tab = ____DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__id_tab
    ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__id._const_tab_at = None
    ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__id._const_tab_id = u'id'
    ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__criticality._const_tab = ____DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__criticality_tab
    ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__extensionValue._const_tab = ____DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__extensionValue_tab
    ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__id),
        (u'criticality', ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__criticality),
        (u'extensionValue', ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__extensionValue),
        ])
    __DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item_._ext = None
    _DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions._cont = __DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item_
    _DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DirectTransferInformationItem_RANAP_RelocInf._cont = ASN1Dict([
        (u'nAS-PDU', _DirectTransferInformationItem_RANAP_RelocInf_nAS_PDU),
        (u'sAPI', _DirectTransferInformationItem_RANAP_RelocInf_sAPI),
        (u'cN-DomainIndicator', _DirectTransferInformationItem_RANAP_RelocInf_cN_DomainIndicator),
        (u'iE-Extensions', _DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions),
        ])
    DirectTransferInformationItem_RANAP_RelocInf._ext = []
    
    #-----< RANAP-DirectTransferInformationItem-ExtIEs-RANAP-RelocInf >-----#
    RANAP_DirectTransferInformationItem_ExtIEs_RANAP_RelocInf = CLASS(name=u'RANAP-DirectTransferInformationItem-ExtIEs-RANAP-RelocInf', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RANAP_DirectTransferInformationItem_ExtIEs_RANAP_RelocInf._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-ContextList-RANAP-RelocInf >-----#
    RAB_ContextList_RANAP_RelocInf = SEQ_OF(name=u'RAB-ContextList-RANAP-RelocInf', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_ContextList_RANAP_RelocInf__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_ContextList_RANAP_RelocInf__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_ContextList_RANAP_RelocInf__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_ContextList_RANAP_RelocInf__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_ContextList_RANAP_RelocInf__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ContextItem-RANAP-RelocInf')))
    ____RAB_ContextList_RANAP_RelocInf__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 82), (u'criticality', u'ignore'), (u'Value', _____RAB_ContextList_RANAP_RelocInf__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_ContextList_RANAP_RelocInf__item___item__id._const_tab = ____RAB_ContextList_RANAP_RelocInf__item___item__id_tab
    ___RAB_ContextList_RANAP_RelocInf__item___item__id._const_tab_at = None
    ___RAB_ContextList_RANAP_RelocInf__item___item__id._const_tab_id = u'id'
    ___RAB_ContextList_RANAP_RelocInf__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_ContextList_RANAP_RelocInf__item___item__criticality._const_tab = ____RAB_ContextList_RANAP_RelocInf__item___item__id_tab
    ___RAB_ContextList_RANAP_RelocInf__item___item__criticality._const_tab_at = ('..', u'id')
    ___RAB_ContextList_RANAP_RelocInf__item___item__criticality._const_tab_id = u'criticality'
    ___RAB_ContextList_RANAP_RelocInf__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_ContextList_RANAP_RelocInf__item___item__value._const_tab = ____RAB_ContextList_RANAP_RelocInf__item___item__id_tab
    ___RAB_ContextList_RANAP_RelocInf__item___item__value._const_tab_at = ('..', u'id')
    ___RAB_ContextList_RANAP_RelocInf__item___item__value._const_tab_id = u'Value'
    __RAB_ContextList_RANAP_RelocInf__item___item_._cont = ASN1Dict([
        (u'id', ___RAB_ContextList_RANAP_RelocInf__item___item__id),
        (u'criticality', ___RAB_ContextList_RANAP_RelocInf__item___item__criticality),
        (u'value', ___RAB_ContextList_RANAP_RelocInf__item___item__value),
        ])
    __RAB_ContextList_RANAP_RelocInf__item___item_._ext = None
    _RAB_ContextList_RANAP_RelocInf__item_._cont = __RAB_ContextList_RANAP_RelocInf__item___item_
    _RAB_ContextList_RANAP_RelocInf__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_ContextList_RANAP_RelocInf._cont = _RAB_ContextList_RANAP_RelocInf__item_
    RAB_ContextList_RANAP_RelocInf._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-ContextItemIEs-RANAP-RelocInf >-----#
    RAB_ContextItemIEs_RANAP_RelocInf = CLASS(name=u'RAB-ContextItemIEs-RANAP-RelocInf', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_ContextItemIEs_RANAP_RelocInf_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ContextItem-RANAP-RelocInf')))
    RAB_ContextItemIEs_RANAP_RelocInf._val = ASN1Set(rv=[dict([(u'id', 82), (u'criticality', u'ignore'), (u'Value', _RAB_ContextItemIEs_RANAP_RelocInf_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-ContextItem-RANAP-RelocInf >-----#
    RAB_ContextItem_RANAP_RelocInf = SEQ(name=u'RAB-ContextItem-RANAP-RelocInf', mode=MODE_TYPE)
    _RAB_ContextItem_RANAP_RelocInf_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_ContextItem_RANAP_RelocInf_dl_GTP_PDU_SequenceNumber = INT(name=u'dl-GTP-PDU-SequenceNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DL-GTP-PDU-SequenceNumber')), opt=True)
    _RAB_ContextItem_RANAP_RelocInf_ul_GTP_PDU_SequenceNumber = INT(name=u'ul-GTP-PDU-SequenceNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UL-GTP-PDU-SequenceNumber')), opt=True)
    _RAB_ContextItem_RANAP_RelocInf_dl_N_PDU_SequenceNumber = INT(name=u'dl-N-PDU-SequenceNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DL-N-PDU-SequenceNumber')), opt=True)
    _RAB_ContextItem_RANAP_RelocInf_ul_N_PDU_SequenceNumber = INT(name=u'ul-N-PDU-SequenceNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UL-N-PDU-SequenceNumber')), opt=True)
    _RAB_ContextItem_RANAP_RelocInf_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__id._const_tab = ____RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__id_tab
    ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__id._const_tab_at = None
    ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__criticality._const_tab = ____RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__criticality_tab
    ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__extensionValue._const_tab = ____RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__extensionValue_tab
    ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__id),
        (u'criticality', ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__extensionValue),
        ])
    __RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item_._ext = None
    _RAB_ContextItem_RANAP_RelocInf_iE_Extensions._cont = __RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item_
    _RAB_ContextItem_RANAP_RelocInf_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_ContextItem_RANAP_RelocInf._cont = ASN1Dict([
        (u'rAB-ID', _RAB_ContextItem_RANAP_RelocInf_rAB_ID),
        (u'dl-GTP-PDU-SequenceNumber', _RAB_ContextItem_RANAP_RelocInf_dl_GTP_PDU_SequenceNumber),
        (u'ul-GTP-PDU-SequenceNumber', _RAB_ContextItem_RANAP_RelocInf_ul_GTP_PDU_SequenceNumber),
        (u'dl-N-PDU-SequenceNumber', _RAB_ContextItem_RANAP_RelocInf_dl_N_PDU_SequenceNumber),
        (u'ul-N-PDU-SequenceNumber', _RAB_ContextItem_RANAP_RelocInf_ul_N_PDU_SequenceNumber),
        (u'iE-Extensions', _RAB_ContextItem_RANAP_RelocInf_iE_Extensions),
        ])
    RAB_ContextItem_RANAP_RelocInf._ext = []
    
    #-----< RAB-ContextItem-ExtIEs-RANAP-RelocInf >-----#
    RAB_ContextItem_ExtIEs_RANAP_RelocInf = CLASS(name=u'RAB-ContextItem-ExtIEs-RANAP-RelocInf', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_ContextItem_ExtIEs_RANAP_RelocInf._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RANAP-RelocationInformationExtensions >-----#
    RANAP_RelocationInformationExtensions = CLASS(name=u'RANAP-RelocationInformationExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RANAP_RelocationInformationExtensions_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RRC-Container')))
    _RANAP_RelocationInformationExtensions_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RNSAPRelocationParameters')))
    RANAP_RelocationInformationExtensions._val = ASN1Set(rv=[dict([(u'id', 103), (u'criticality', u'ignore'), (u'Extension', _RANAP_RelocationInformationExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 247), (u'criticality', u'reject'), (u'Extension', _RANAP_RelocationInformationExtensions_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RANAP-EnhancedRelocationInformationRequest >-----#
    RANAP_EnhancedRelocationInformationRequest = SEQ(name=u'RANAP-EnhancedRelocationInformationRequest', mode=MODE_TYPE)
    _RANAP_EnhancedRelocationInformationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RANAP_EnhancedRelocationInformationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SourceRNC-ToTargetRNC-TransparentContainer')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupList-EnhRelocInfoReq')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SNA-Access-Information')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UESBI-Iu')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_8 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_9 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CNMBMSLinkingInformation')))
    ____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 61), (u'criticality', u'reject'), (u'Value', _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 204), (u'criticality', u'ignore'), (u'Value', _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 206), (u'criticality', u'reject'), (u'Value', _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 205), (u'criticality', u'ignore'), (u'Value', _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 207), (u'criticality', u'reject'), (u'Value', _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 192), (u'criticality', u'reject'), (u'Value', _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 105), (u'criticality', u'ignore'), (u'Value', _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 118), (u'criticality', u'ignore'), (u'Value', _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 127), (u'criticality', u'ignore'), (u'Value', _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 133), (u'criticality', u'ignore'), (u'Value', _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id._const_tab = ____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab
    ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id._const_tab_at = None
    ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__criticality._const_tab = ____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab
    ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__value._const_tab = ____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab
    ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __RANAP_EnhancedRelocationInformationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id),
        (u'criticality', ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__criticality),
        (u'value', ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__value),
        ])
    __RANAP_EnhancedRelocationInformationRequest_protocolIEs__item_._ext = None
    _RANAP_EnhancedRelocationInformationRequest_protocolIEs._cont = __RANAP_EnhancedRelocationInformationRequest_protocolIEs__item_
    _RANAP_EnhancedRelocationInformationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RANAP_EnhancedRelocationInformationRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IntegrityProtectionInformation')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'EncryptionInformation')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-AggregateMaximumBitRate')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RABParametersList')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_4 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Membership-Status')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_6 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    ____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 12), (u'criticality', u'ignore'), (u'Extension', _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 11), (u'criticality', u'ignore'), (u'Extension', _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 233), (u'criticality', u'ignore'), (u'Extension', _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 248), (u'criticality', u'reject'), (u'Extension', _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 203), (u'criticality', u'reject'), (u'Extension', _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 234), (u'criticality', u'reject'), (u'Extension', _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 261), (u'criticality', u'ignore'), (u'Extension', _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id._const_tab = ____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab
    ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id._const_tab_at = None
    ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__criticality._const_tab = ____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab
    ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__extensionValue._const_tab = ____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab
    ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id),
        (u'criticality', ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__extensionValue),
        ])
    __RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item_._ext = None
    _RANAP_EnhancedRelocationInformationRequest_protocolExtensions._cont = __RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item_
    _RANAP_EnhancedRelocationInformationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RANAP_EnhancedRelocationInformationRequest._cont = ASN1Dict([
        (u'protocolIEs', _RANAP_EnhancedRelocationInformationRequest_protocolIEs),
        (u'protocolExtensions', _RANAP_EnhancedRelocationInformationRequest_protocolExtensions),
        ])
    RANAP_EnhancedRelocationInformationRequest._ext = []
    
    #-----< RANAP-EnhancedRelocationInformationRequestIEs >-----#
    RANAP_EnhancedRelocationInformationRequestIEs = CLASS(name=u'RANAP-EnhancedRelocationInformationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SourceRNC-ToTargetRNC-TransparentContainer')))
    _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupList-EnhRelocInfoReq')))
    _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SNA-Access-Information')))
    _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UESBI-Iu')))
    _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_8 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_9 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CNMBMSLinkingInformation')))
    RANAP_EnhancedRelocationInformationRequestIEs._val = ASN1Set(rv=[dict([(u'id', 61), (u'criticality', u'reject'), (u'Value', _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 204), (u'criticality', u'ignore'), (u'Value', _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 206), (u'criticality', u'reject'), (u'Value', _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 205), (u'criticality', u'ignore'), (u'Value', _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 207), (u'criticality', u'reject'), (u'Value', _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 192), (u'criticality', u'reject'), (u'Value', _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 105), (u'criticality', u'ignore'), (u'Value', _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 118), (u'criticality', u'ignore'), (u'Value', _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 127), (u'criticality', u'ignore'), (u'Value', _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 133), (u'criticality', u'ignore'), (u'Value', _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_9), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupList-EnhRelocInfoReq >-----#
    RAB_SetupList_EnhRelocInfoReq = SEQ_OF(name=u'RAB-SetupList-EnhRelocInfoReq', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_SetupList_EnhRelocInfoReq__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_SetupList_EnhRelocInfoReq__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_SetupList_EnhRelocInfoReq__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_SetupList_EnhRelocInfoReq__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_SetupList_EnhRelocInfoReq__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupItem-EnhRelocInfoReq')))
    ____RAB_SetupList_EnhRelocInfoReq__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 193), (u'criticality', u'reject'), (u'Value', _____RAB_SetupList_EnhRelocInfoReq__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_SetupList_EnhRelocInfoReq__item___item__id._const_tab = ____RAB_SetupList_EnhRelocInfoReq__item___item__id_tab
    ___RAB_SetupList_EnhRelocInfoReq__item___item__id._const_tab_at = None
    ___RAB_SetupList_EnhRelocInfoReq__item___item__id._const_tab_id = u'id'
    ___RAB_SetupList_EnhRelocInfoReq__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_SetupList_EnhRelocInfoReq__item___item__criticality._const_tab = ____RAB_SetupList_EnhRelocInfoReq__item___item__id_tab
    ___RAB_SetupList_EnhRelocInfoReq__item___item__criticality._const_tab_at = ('..', u'id')
    ___RAB_SetupList_EnhRelocInfoReq__item___item__criticality._const_tab_id = u'criticality'
    ___RAB_SetupList_EnhRelocInfoReq__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_SetupList_EnhRelocInfoReq__item___item__value._const_tab = ____RAB_SetupList_EnhRelocInfoReq__item___item__id_tab
    ___RAB_SetupList_EnhRelocInfoReq__item___item__value._const_tab_at = ('..', u'id')
    ___RAB_SetupList_EnhRelocInfoReq__item___item__value._const_tab_id = u'Value'
    __RAB_SetupList_EnhRelocInfoReq__item___item_._cont = ASN1Dict([
        (u'id', ___RAB_SetupList_EnhRelocInfoReq__item___item__id),
        (u'criticality', ___RAB_SetupList_EnhRelocInfoReq__item___item__criticality),
        (u'value', ___RAB_SetupList_EnhRelocInfoReq__item___item__value),
        ])
    __RAB_SetupList_EnhRelocInfoReq__item___item_._ext = None
    _RAB_SetupList_EnhRelocInfoReq__item_._cont = __RAB_SetupList_EnhRelocInfoReq__item___item_
    _RAB_SetupList_EnhRelocInfoReq__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_SetupList_EnhRelocInfoReq._cont = _RAB_SetupList_EnhRelocInfoReq__item_
    RAB_SetupList_EnhRelocInfoReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-SetupItem-EnhRelocInfoReq-IEs >-----#
    RAB_SetupItem_EnhRelocInfoReq_IEs = CLASS(name=u'RAB-SetupItem-EnhRelocInfoReq-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_SetupItem_EnhRelocInfoReq_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupItem-EnhRelocInfoReq')))
    RAB_SetupItem_EnhRelocInfoReq_IEs._val = ASN1Set(rv=[dict([(u'id', 193), (u'criticality', u'reject'), (u'Value', _RAB_SetupItem_EnhRelocInfoReq_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupItem-EnhRelocInfoReq >-----#
    RAB_SetupItem_EnhRelocInfoReq = SEQ(name=u'RAB-SetupItem-EnhRelocInfoReq', mode=MODE_TYPE)
    _RAB_SetupItem_EnhRelocInfoReq_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_SetupItem_EnhRelocInfoReq_cN_DomainIndicator = ENUM(name=u'cN-DomainIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _RAB_SetupItem_EnhRelocInfoReq_rAB_Parameters = SEQ(name=u'rAB-Parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameters')))
    _RAB_SetupItem_EnhRelocInfoReq_dataVolumeReportingIndication = ENUM(name=u'dataVolumeReportingIndication', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DataVolumeReportingIndication')), opt=True)
    _RAB_SetupItem_EnhRelocInfoReq_pDP_TypeInformation = SEQ_OF(name=u'pDP-TypeInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PDP-TypeInformation')), opt=True)
    _RAB_SetupItem_EnhRelocInfoReq_userPlaneInformation = SEQ(name=u'userPlaneInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Contents', 'UserPlaneInformation')))
    _RAB_SetupItem_EnhRelocInfoReq_dataForwardingInformation = SEQ(name=u'dataForwardingInformation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Contents', 'TNLInformationEnhRelInfoReq')), opt=True)
    _RAB_SetupItem_EnhRelocInfoReq_sourceSideIuULTNLInfo = SEQ(name=u'sourceSideIuULTNLInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Contents', 'TNLInformationEnhRelInfoReq')), opt=True)
    _RAB_SetupItem_EnhRelocInfoReq_service_Handover = ENUM(name=u'service-Handover', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Service-Handover')), opt=True)
    _RAB_SetupItem_EnhRelocInfoReq_alt_RAB_Parameters = SEQ(name=u'alt-RAB-Parameters', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameters')), opt=True)
    _RAB_SetupItem_EnhRelocInfoReq_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'E-UTRAN-Service-Handover')))
    _____RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PDP-TypeInformation-extension')))
    ____RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 231), (u'criticality', u'ignore'), (u'Extension', _____RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 238), (u'criticality', u'ignore'), (u'Extension', _____RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id._const_tab = ____RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id_tab
    ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id._const_tab_at = None
    ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__criticality._const_tab = ____RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id_tab
    ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__extensionValue._const_tab = ____RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id_tab
    ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id),
        (u'criticality', ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__extensionValue),
        ])
    __RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item_._ext = None
    _RAB_SetupItem_EnhRelocInfoReq_iE_Extensions._cont = __RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item_
    _RAB_SetupItem_EnhRelocInfoReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_SetupItem_EnhRelocInfoReq._cont = ASN1Dict([
        (u'rAB-ID', _RAB_SetupItem_EnhRelocInfoReq_rAB_ID),
        (u'cN-DomainIndicator', _RAB_SetupItem_EnhRelocInfoReq_cN_DomainIndicator),
        (u'rAB-Parameters', _RAB_SetupItem_EnhRelocInfoReq_rAB_Parameters),
        (u'dataVolumeReportingIndication', _RAB_SetupItem_EnhRelocInfoReq_dataVolumeReportingIndication),
        (u'pDP-TypeInformation', _RAB_SetupItem_EnhRelocInfoReq_pDP_TypeInformation),
        (u'userPlaneInformation', _RAB_SetupItem_EnhRelocInfoReq_userPlaneInformation),
        (u'dataForwardingInformation', _RAB_SetupItem_EnhRelocInfoReq_dataForwardingInformation),
        (u'sourceSideIuULTNLInfo', _RAB_SetupItem_EnhRelocInfoReq_sourceSideIuULTNLInfo),
        (u'service-Handover', _RAB_SetupItem_EnhRelocInfoReq_service_Handover),
        (u'alt-RAB-Parameters', _RAB_SetupItem_EnhRelocInfoReq_alt_RAB_Parameters),
        (u'iE-Extensions', _RAB_SetupItem_EnhRelocInfoReq_iE_Extensions),
        ])
    RAB_SetupItem_EnhRelocInfoReq._ext = []
    
    #-----< RAB-SetupItem-EnhRelocInfoReq-ExtIEs >-----#
    RAB_SetupItem_EnhRelocInfoReq_ExtIEs = CLASS(name=u'RAB-SetupItem-EnhRelocInfoReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RAB_SetupItem_EnhRelocInfoReq_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'E-UTRAN-Service-Handover')))
    _RAB_SetupItem_EnhRelocInfoReq_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PDP-TypeInformation-extension')))
    RAB_SetupItem_EnhRelocInfoReq_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 231), (u'criticality', u'ignore'), (u'Extension', _RAB_SetupItem_EnhRelocInfoReq_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 238), (u'criticality', u'ignore'), (u'Extension', _RAB_SetupItem_EnhRelocInfoReq_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< TNLInformationEnhRelInfoReq >-----#
    TNLInformationEnhRelInfoReq = SEQ(name=u'TNLInformationEnhRelInfoReq', mode=MODE_TYPE)
    _TNLInformationEnhRelInfoReq_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _TNLInformationEnhRelInfoReq_iuTransportAssociation = CHOICE(name=u'iuTransportAssociation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IuTransportAssociation')))
    _TNLInformationEnhRelInfoReq_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TNLInformationEnhRelInfoReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___TNLInformationEnhRelInfoReq_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TNLInformationEnhRelInfoReq_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TNLInformationEnhRelInfoReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLInformationEnhRelInfoReq_iE_Extensions__item__id._const_tab = ____TNLInformationEnhRelInfoReq_iE_Extensions__item__id_tab
    ___TNLInformationEnhRelInfoReq_iE_Extensions__item__id._const_tab_at = None
    ___TNLInformationEnhRelInfoReq_iE_Extensions__item__id._const_tab_id = u'id'
    ___TNLInformationEnhRelInfoReq_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TNLInformationEnhRelInfoReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TNLInformationEnhRelInfoReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLInformationEnhRelInfoReq_iE_Extensions__item__criticality._const_tab = ____TNLInformationEnhRelInfoReq_iE_Extensions__item__criticality_tab
    ___TNLInformationEnhRelInfoReq_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TNLInformationEnhRelInfoReq_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TNLInformationEnhRelInfoReq_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TNLInformationEnhRelInfoReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TNLInformationEnhRelInfoReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLInformationEnhRelInfoReq_iE_Extensions__item__extensionValue._const_tab = ____TNLInformationEnhRelInfoReq_iE_Extensions__item__extensionValue_tab
    ___TNLInformationEnhRelInfoReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TNLInformationEnhRelInfoReq_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TNLInformationEnhRelInfoReq_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TNLInformationEnhRelInfoReq_iE_Extensions__item__id),
        (u'criticality', ___TNLInformationEnhRelInfoReq_iE_Extensions__item__criticality),
        (u'extensionValue', ___TNLInformationEnhRelInfoReq_iE_Extensions__item__extensionValue),
        ])
    __TNLInformationEnhRelInfoReq_iE_Extensions__item_._ext = None
    _TNLInformationEnhRelInfoReq_iE_Extensions._cont = __TNLInformationEnhRelInfoReq_iE_Extensions__item_
    _TNLInformationEnhRelInfoReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TNLInformationEnhRelInfoReq._cont = ASN1Dict([
        (u'transportLayerAddress', _TNLInformationEnhRelInfoReq_transportLayerAddress),
        (u'iuTransportAssociation', _TNLInformationEnhRelInfoReq_iuTransportAssociation),
        (u'iE-Extensions', _TNLInformationEnhRelInfoReq_iE_Extensions),
        ])
    TNLInformationEnhRelInfoReq._ext = []
    
    #-----< TNLInformationEnhRelInfoReq-ExtIEs >-----#
    TNLInformationEnhRelInfoReq_ExtIEs = CLASS(name=u'TNLInformationEnhRelInfoReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    TNLInformationEnhRelInfoReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RANAP-EnhancedRelocationInformationRequestExtensions >-----#
    RANAP_EnhancedRelocationInformationRequestExtensions = CLASS(name=u'RANAP-EnhancedRelocationInformationRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IntegrityProtectionInformation')))
    _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'EncryptionInformation')))
    _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-AggregateMaximumBitRate')))
    _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RABParametersList')))
    _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_4 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id')))
    _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Membership-Status')))
    _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_6 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    RANAP_EnhancedRelocationInformationRequestExtensions._val = ASN1Set(rv=[dict([(u'id', 12), (u'criticality', u'ignore'), (u'Extension', _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 11), (u'criticality', u'ignore'), (u'Extension', _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 233), (u'criticality', u'ignore'), (u'Extension', _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 248), (u'criticality', u'reject'), (u'Extension', _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 203), (u'criticality', u'reject'), (u'Extension', _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 234), (u'criticality', u'reject'), (u'Extension', _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 261), (u'criticality', u'ignore'), (u'Extension', _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RANAP-EnhancedRelocationInformationResponse >-----#
    RANAP_EnhancedRelocationInformationResponse = SEQ(name=u'RANAP-EnhancedRelocationInformationResponse', mode=MODE_TYPE)
    _RANAP_EnhancedRelocationInformationResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RANAP_EnhancedRelocationInformationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TargetRNC-ToSourceRNC-TransparentContainer')))
    _____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupList-EnhRelocInfoRes')))
    _____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedList-EnhRelocInfoRes')))
    _____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 63), (u'criticality', u'ignore'), (u'Value', _____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 194), (u'criticality', u'ignore'), (u'Value', _____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 197), (u'criticality', u'ignore'), (u'Value', _____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id._const_tab = ____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab
    ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id._const_tab_at = None
    ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__criticality._const_tab = ____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab
    ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__value._const_tab = ____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab
    ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __RANAP_EnhancedRelocationInformationResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id),
        (u'criticality', ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__criticality),
        (u'value', ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__value),
        ])
    __RANAP_EnhancedRelocationInformationResponse_protocolIEs__item_._ext = None
    _RANAP_EnhancedRelocationInformationResponse_protocolIEs._cont = __RANAP_EnhancedRelocationInformationResponse_protocolIEs__item_
    _RANAP_EnhancedRelocationInformationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RANAP_EnhancedRelocationInformationResponse_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__id._const_tab = ____RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__id_tab
    ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__id._const_tab_at = None
    ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__id._const_tab_id = u'id'
    ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__criticality._const_tab = ____RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__criticality_tab
    ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__extensionValue._const_tab = ____RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__extensionValue_tab
    ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__id),
        (u'criticality', ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__criticality),
        (u'extensionValue', ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__extensionValue),
        ])
    __RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item_._ext = None
    _RANAP_EnhancedRelocationInformationResponse_protocolExtensions._cont = __RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item_
    _RANAP_EnhancedRelocationInformationResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RANAP_EnhancedRelocationInformationResponse._cont = ASN1Dict([
        (u'protocolIEs', _RANAP_EnhancedRelocationInformationResponse_protocolIEs),
        (u'protocolExtensions', _RANAP_EnhancedRelocationInformationResponse_protocolExtensions),
        ])
    RANAP_EnhancedRelocationInformationResponse._ext = []
    
    #-----< RANAP-EnhancedRelocationInformationResponseIEs >-----#
    RANAP_EnhancedRelocationInformationResponseIEs = CLASS(name=u'RANAP-EnhancedRelocationInformationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RANAP_EnhancedRelocationInformationResponseIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TargetRNC-ToSourceRNC-TransparentContainer')))
    _RANAP_EnhancedRelocationInformationResponseIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupList-EnhRelocInfoRes')))
    _RANAP_EnhancedRelocationInformationResponseIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedList-EnhRelocInfoRes')))
    _RANAP_EnhancedRelocationInformationResponseIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    RANAP_EnhancedRelocationInformationResponseIEs._val = ASN1Set(rv=[dict([(u'id', 63), (u'criticality', u'ignore'), (u'Value', _RANAP_EnhancedRelocationInformationResponseIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 194), (u'criticality', u'ignore'), (u'Value', _RANAP_EnhancedRelocationInformationResponseIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 197), (u'criticality', u'ignore'), (u'Value', _RANAP_EnhancedRelocationInformationResponseIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _RANAP_EnhancedRelocationInformationResponseIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupList-EnhRelocInfoRes >-----#
    RAB_SetupList_EnhRelocInfoRes = SEQ_OF(name=u'RAB-SetupList-EnhRelocInfoRes', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_SetupList_EnhRelocInfoRes__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_SetupList_EnhRelocInfoRes__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_SetupList_EnhRelocInfoRes__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_SetupList_EnhRelocInfoRes__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_SetupList_EnhRelocInfoRes__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupItem-EnhRelocInfoRes')))
    ____RAB_SetupList_EnhRelocInfoRes__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 195), (u'criticality', u'reject'), (u'Value', _____RAB_SetupList_EnhRelocInfoRes__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_SetupList_EnhRelocInfoRes__item___item__id._const_tab = ____RAB_SetupList_EnhRelocInfoRes__item___item__id_tab
    ___RAB_SetupList_EnhRelocInfoRes__item___item__id._const_tab_at = None
    ___RAB_SetupList_EnhRelocInfoRes__item___item__id._const_tab_id = u'id'
    ___RAB_SetupList_EnhRelocInfoRes__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_SetupList_EnhRelocInfoRes__item___item__criticality._const_tab = ____RAB_SetupList_EnhRelocInfoRes__item___item__id_tab
    ___RAB_SetupList_EnhRelocInfoRes__item___item__criticality._const_tab_at = ('..', u'id')
    ___RAB_SetupList_EnhRelocInfoRes__item___item__criticality._const_tab_id = u'criticality'
    ___RAB_SetupList_EnhRelocInfoRes__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_SetupList_EnhRelocInfoRes__item___item__value._const_tab = ____RAB_SetupList_EnhRelocInfoRes__item___item__id_tab
    ___RAB_SetupList_EnhRelocInfoRes__item___item__value._const_tab_at = ('..', u'id')
    ___RAB_SetupList_EnhRelocInfoRes__item___item__value._const_tab_id = u'Value'
    __RAB_SetupList_EnhRelocInfoRes__item___item_._cont = ASN1Dict([
        (u'id', ___RAB_SetupList_EnhRelocInfoRes__item___item__id),
        (u'criticality', ___RAB_SetupList_EnhRelocInfoRes__item___item__criticality),
        (u'value', ___RAB_SetupList_EnhRelocInfoRes__item___item__value),
        ])
    __RAB_SetupList_EnhRelocInfoRes__item___item_._ext = None
    _RAB_SetupList_EnhRelocInfoRes__item_._cont = __RAB_SetupList_EnhRelocInfoRes__item___item_
    _RAB_SetupList_EnhRelocInfoRes__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_SetupList_EnhRelocInfoRes._cont = _RAB_SetupList_EnhRelocInfoRes__item_
    RAB_SetupList_EnhRelocInfoRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-SetupItem-EnhRelocInfoRes-IEs >-----#
    RAB_SetupItem_EnhRelocInfoRes_IEs = CLASS(name=u'RAB-SetupItem-EnhRelocInfoRes-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_SetupItem_EnhRelocInfoRes_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupItem-EnhRelocInfoRes')))
    RAB_SetupItem_EnhRelocInfoRes_IEs._val = ASN1Set(rv=[dict([(u'id', 195), (u'criticality', u'reject'), (u'Value', _RAB_SetupItem_EnhRelocInfoRes_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupItem-EnhRelocInfoRes >-----#
    RAB_SetupItem_EnhRelocInfoRes = SEQ(name=u'RAB-SetupItem-EnhRelocInfoRes', mode=MODE_TYPE)
    _RAB_SetupItem_EnhRelocInfoRes_cN_DomainIndicator = ENUM(name=u'cN-DomainIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _RAB_SetupItem_EnhRelocInfoRes_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_SetupItem_EnhRelocInfoRes_dataForwardingInformation = SEQ(name=u'dataForwardingInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Contents', 'TNLInformationEnhRelInfoRes')), opt=True)
    _RAB_SetupItem_EnhRelocInfoRes_ass_RAB_Parameters = SEQ(name=u'ass-RAB-Parameters', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Ass-RAB-Parameters')), opt=True)
    _RAB_SetupItem_EnhRelocInfoRes_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__id._const_tab = ____RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__id_tab
    ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__id._const_tab_at = None
    ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__criticality._const_tab = ____RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__criticality_tab
    ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue._const_tab = ____RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue_tab
    ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__id),
        (u'criticality', ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue),
        ])
    __RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item_._ext = None
    _RAB_SetupItem_EnhRelocInfoRes_iE_Extensions._cont = __RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item_
    _RAB_SetupItem_EnhRelocInfoRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_SetupItem_EnhRelocInfoRes._cont = ASN1Dict([
        (u'cN-DomainIndicator', _RAB_SetupItem_EnhRelocInfoRes_cN_DomainIndicator),
        (u'rAB-ID', _RAB_SetupItem_EnhRelocInfoRes_rAB_ID),
        (u'dataForwardingInformation', _RAB_SetupItem_EnhRelocInfoRes_dataForwardingInformation),
        (u'ass-RAB-Parameters', _RAB_SetupItem_EnhRelocInfoRes_ass_RAB_Parameters),
        (u'iE-Extensions', _RAB_SetupItem_EnhRelocInfoRes_iE_Extensions),
        ])
    RAB_SetupItem_EnhRelocInfoRes._ext = []
    
    #-----< RAB-SetupItem-EnhRelocInfoRes-ExtIEs >-----#
    RAB_SetupItem_EnhRelocInfoRes_ExtIEs = CLASS(name=u'RAB-SetupItem-EnhRelocInfoRes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_SetupItem_EnhRelocInfoRes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-FailedList-EnhRelocInfoRes >-----#
    RAB_FailedList_EnhRelocInfoRes = SEQ_OF(name=u'RAB-FailedList-EnhRelocInfoRes', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_FailedList_EnhRelocInfoRes__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_FailedList_EnhRelocInfoRes__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_FailedList_EnhRelocInfoRes__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_FailedList_EnhRelocInfoRes__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_FailedList_EnhRelocInfoRes__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedItem-EnhRelocInfoRes')))
    ____RAB_FailedList_EnhRelocInfoRes__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 198), (u'criticality', u'reject'), (u'Value', _____RAB_FailedList_EnhRelocInfoRes__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_FailedList_EnhRelocInfoRes__item___item__id._const_tab = ____RAB_FailedList_EnhRelocInfoRes__item___item__id_tab
    ___RAB_FailedList_EnhRelocInfoRes__item___item__id._const_tab_at = None
    ___RAB_FailedList_EnhRelocInfoRes__item___item__id._const_tab_id = u'id'
    ___RAB_FailedList_EnhRelocInfoRes__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_FailedList_EnhRelocInfoRes__item___item__criticality._const_tab = ____RAB_FailedList_EnhRelocInfoRes__item___item__id_tab
    ___RAB_FailedList_EnhRelocInfoRes__item___item__criticality._const_tab_at = ('..', u'id')
    ___RAB_FailedList_EnhRelocInfoRes__item___item__criticality._const_tab_id = u'criticality'
    ___RAB_FailedList_EnhRelocInfoRes__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_FailedList_EnhRelocInfoRes__item___item__value._const_tab = ____RAB_FailedList_EnhRelocInfoRes__item___item__id_tab
    ___RAB_FailedList_EnhRelocInfoRes__item___item__value._const_tab_at = ('..', u'id')
    ___RAB_FailedList_EnhRelocInfoRes__item___item__value._const_tab_id = u'Value'
    __RAB_FailedList_EnhRelocInfoRes__item___item_._cont = ASN1Dict([
        (u'id', ___RAB_FailedList_EnhRelocInfoRes__item___item__id),
        (u'criticality', ___RAB_FailedList_EnhRelocInfoRes__item___item__criticality),
        (u'value', ___RAB_FailedList_EnhRelocInfoRes__item___item__value),
        ])
    __RAB_FailedList_EnhRelocInfoRes__item___item_._ext = None
    _RAB_FailedList_EnhRelocInfoRes__item_._cont = __RAB_FailedList_EnhRelocInfoRes__item___item_
    _RAB_FailedList_EnhRelocInfoRes__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_FailedList_EnhRelocInfoRes._cont = _RAB_FailedList_EnhRelocInfoRes__item_
    RAB_FailedList_EnhRelocInfoRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-FailedItem-EnhRelocInfoRes-IEs >-----#
    RAB_FailedItem_EnhRelocInfoRes_IEs = CLASS(name=u'RAB-FailedItem-EnhRelocInfoRes-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_FailedItem_EnhRelocInfoRes_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedItem-EnhRelocInfoRes')))
    RAB_FailedItem_EnhRelocInfoRes_IEs._val = ASN1Set(rv=[dict([(u'id', 198), (u'criticality', u'reject'), (u'Value', _RAB_FailedItem_EnhRelocInfoRes_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-FailedItem-EnhRelocInfoRes >-----#
    RAB_FailedItem_EnhRelocInfoRes = SEQ(name=u'RAB-FailedItem-EnhRelocInfoRes', mode=MODE_TYPE)
    _RAB_FailedItem_EnhRelocInfoRes_cN_DomainIndicator = ENUM(name=u'cN-DomainIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _RAB_FailedItem_EnhRelocInfoRes_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_FailedItem_EnhRelocInfoRes_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _RAB_FailedItem_EnhRelocInfoRes_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__id._const_tab = ____RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__id_tab
    ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__id._const_tab_at = None
    ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__criticality._const_tab = ____RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__criticality_tab
    ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue._const_tab = ____RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue_tab
    ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__id),
        (u'criticality', ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue),
        ])
    __RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item_._ext = None
    _RAB_FailedItem_EnhRelocInfoRes_iE_Extensions._cont = __RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item_
    _RAB_FailedItem_EnhRelocInfoRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_FailedItem_EnhRelocInfoRes._cont = ASN1Dict([
        (u'cN-DomainIndicator', _RAB_FailedItem_EnhRelocInfoRes_cN_DomainIndicator),
        (u'rAB-ID', _RAB_FailedItem_EnhRelocInfoRes_rAB_ID),
        (u'cause', _RAB_FailedItem_EnhRelocInfoRes_cause),
        (u'iE-Extensions', _RAB_FailedItem_EnhRelocInfoRes_iE_Extensions),
        ])
    RAB_FailedItem_EnhRelocInfoRes._ext = []
    
    #-----< RAB-FailedItem-EnhRelocInfoRes-ExtIEs >-----#
    RAB_FailedItem_EnhRelocInfoRes_ExtIEs = CLASS(name=u'RAB-FailedItem-EnhRelocInfoRes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_FailedItem_EnhRelocInfoRes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TNLInformationEnhRelInfoRes >-----#
    TNLInformationEnhRelInfoRes = SEQ(name=u'TNLInformationEnhRelInfoRes', mode=MODE_TYPE)
    _TNLInformationEnhRelInfoRes_dl_forwardingTransportLayerAddress = BIT_STR(name=u'dl-forwardingTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _TNLInformationEnhRelInfoRes_dl_forwardingTransportAssociation = CHOICE(name=u'dl-forwardingTransportAssociation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IuTransportAssociation')))
    _TNLInformationEnhRelInfoRes_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TNLInformationEnhRelInfoRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___TNLInformationEnhRelInfoRes_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TNLInformationEnhRelInfoRes_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TNLInformationEnhRelInfoRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLInformationEnhRelInfoRes_iE_Extensions__item__id._const_tab = ____TNLInformationEnhRelInfoRes_iE_Extensions__item__id_tab
    ___TNLInformationEnhRelInfoRes_iE_Extensions__item__id._const_tab_at = None
    ___TNLInformationEnhRelInfoRes_iE_Extensions__item__id._const_tab_id = u'id'
    ___TNLInformationEnhRelInfoRes_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TNLInformationEnhRelInfoRes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TNLInformationEnhRelInfoRes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLInformationEnhRelInfoRes_iE_Extensions__item__criticality._const_tab = ____TNLInformationEnhRelInfoRes_iE_Extensions__item__criticality_tab
    ___TNLInformationEnhRelInfoRes_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TNLInformationEnhRelInfoRes_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TNLInformationEnhRelInfoRes_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TNLInformationEnhRelInfoRes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TNLInformationEnhRelInfoRes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLInformationEnhRelInfoRes_iE_Extensions__item__extensionValue._const_tab = ____TNLInformationEnhRelInfoRes_iE_Extensions__item__extensionValue_tab
    ___TNLInformationEnhRelInfoRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TNLInformationEnhRelInfoRes_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TNLInformationEnhRelInfoRes_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TNLInformationEnhRelInfoRes_iE_Extensions__item__id),
        (u'criticality', ___TNLInformationEnhRelInfoRes_iE_Extensions__item__criticality),
        (u'extensionValue', ___TNLInformationEnhRelInfoRes_iE_Extensions__item__extensionValue),
        ])
    __TNLInformationEnhRelInfoRes_iE_Extensions__item_._ext = None
    _TNLInformationEnhRelInfoRes_iE_Extensions._cont = __TNLInformationEnhRelInfoRes_iE_Extensions__item_
    _TNLInformationEnhRelInfoRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TNLInformationEnhRelInfoRes._cont = ASN1Dict([
        (u'dl-forwardingTransportLayerAddress', _TNLInformationEnhRelInfoRes_dl_forwardingTransportLayerAddress),
        (u'dl-forwardingTransportAssociation', _TNLInformationEnhRelInfoRes_dl_forwardingTransportAssociation),
        (u'iE-Extensions', _TNLInformationEnhRelInfoRes_iE_Extensions),
        ])
    TNLInformationEnhRelInfoRes._ext = []
    
    #-----< TNLInformationEnhRelInfoRes-ExtIEs >-----#
    TNLInformationEnhRelInfoRes_ExtIEs = CLASS(name=u'TNLInformationEnhRelInfoRes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    TNLInformationEnhRelInfoRes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RANAP-EnhancedRelocationInformationResponseExtensions >-----#
    RANAP_EnhancedRelocationInformationResponseExtensions = CLASS(name=u'RANAP-EnhancedRelocationInformationResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RANAP_EnhancedRelocationInformationResponseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-ModifyRequest >-----#
    RAB_ModifyRequest = SEQ(name=u'RAB-ModifyRequest', mode=MODE_TYPE)
    _RAB_ModifyRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_ModifyRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_ModifyRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_ModifyRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_ModifyRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ModifyList')))
    ____RAB_ModifyRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 91), (u'criticality', u'ignore'), (u'Value', _____RAB_ModifyRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_ModifyRequest_protocolIEs__item__id._const_tab = ____RAB_ModifyRequest_protocolIEs__item__id_tab
    ___RAB_ModifyRequest_protocolIEs__item__id._const_tab_at = None
    ___RAB_ModifyRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___RAB_ModifyRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_ModifyRequest_protocolIEs__item__criticality._const_tab = ____RAB_ModifyRequest_protocolIEs__item__id_tab
    ___RAB_ModifyRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_ModifyRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RAB_ModifyRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_ModifyRequest_protocolIEs__item__value._const_tab = ____RAB_ModifyRequest_protocolIEs__item__id_tab
    ___RAB_ModifyRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RAB_ModifyRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __RAB_ModifyRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RAB_ModifyRequest_protocolIEs__item__id),
        (u'criticality', ___RAB_ModifyRequest_protocolIEs__item__criticality),
        (u'value', ___RAB_ModifyRequest_protocolIEs__item__value),
        ])
    __RAB_ModifyRequest_protocolIEs__item_._ext = None
    _RAB_ModifyRequest_protocolIEs._cont = __RAB_ModifyRequest_protocolIEs__item_
    _RAB_ModifyRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RAB_ModifyRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_ModifyRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_ModifyRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_ModifyRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ModifyRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ModifyRequest_protocolExtensions__item__id._const_tab = ____RAB_ModifyRequest_protocolExtensions__item__id_tab
    ___RAB_ModifyRequest_protocolExtensions__item__id._const_tab_at = None
    ___RAB_ModifyRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___RAB_ModifyRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RAB_ModifyRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ModifyRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ModifyRequest_protocolExtensions__item__criticality._const_tab = ____RAB_ModifyRequest_protocolExtensions__item__criticality_tab
    ___RAB_ModifyRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_ModifyRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_ModifyRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RAB_ModifyRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ModifyRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ModifyRequest_protocolExtensions__item__extensionValue._const_tab = ____RAB_ModifyRequest_protocolExtensions__item__extensionValue_tab
    ___RAB_ModifyRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_ModifyRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_ModifyRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_ModifyRequest_protocolExtensions__item__id),
        (u'criticality', ___RAB_ModifyRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___RAB_ModifyRequest_protocolExtensions__item__extensionValue),
        ])
    __RAB_ModifyRequest_protocolExtensions__item_._ext = None
    _RAB_ModifyRequest_protocolExtensions._cont = __RAB_ModifyRequest_protocolExtensions__item_
    _RAB_ModifyRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_ModifyRequest._cont = ASN1Dict([
        (u'protocolIEs', _RAB_ModifyRequest_protocolIEs),
        (u'protocolExtensions', _RAB_ModifyRequest_protocolExtensions),
        ])
    RAB_ModifyRequest._ext = []
    
    #-----< RAB-ModifyRequestIEs >-----#
    RAB_ModifyRequestIEs = CLASS(name=u'RAB-ModifyRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_ModifyRequestIEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ModifyList')))
    RAB_ModifyRequestIEs._val = ASN1Set(rv=[dict([(u'id', 91), (u'criticality', u'ignore'), (u'Value', _RAB_ModifyRequestIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-ModifyList >-----#
    RAB_ModifyList = SEQ_OF(name=u'RAB-ModifyList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_ModifyList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_ModifyList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_ModifyList__item___item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RAB_ModifyList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_ModifyList__item___item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ModifyItem')))
    ____RAB_ModifyList__item___item__id_tab._val = ASN1Set(rv=[dict([(u'id', 92), (u'criticality', u'ignore'), (u'Value', _____RAB_ModifyList__item___item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_ModifyList__item___item__id._const_tab = ____RAB_ModifyList__item___item__id_tab
    ___RAB_ModifyList__item___item__id._const_tab_at = None
    ___RAB_ModifyList__item___item__id._const_tab_id = u'id'
    ___RAB_ModifyList__item___item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RAB_ModifyList__item___item__criticality._const_tab = ____RAB_ModifyList__item___item__id_tab
    ___RAB_ModifyList__item___item__criticality._const_tab_at = ('..', u'id')
    ___RAB_ModifyList__item___item__criticality._const_tab_id = u'criticality'
    ___RAB_ModifyList__item___item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RAB_ModifyList__item___item__value._const_tab = ____RAB_ModifyList__item___item__id_tab
    ___RAB_ModifyList__item___item__value._const_tab_at = ('..', u'id')
    ___RAB_ModifyList__item___item__value._const_tab_id = u'Value'
    __RAB_ModifyList__item___item_._cont = ASN1Dict([
        (u'id', ___RAB_ModifyList__item___item__id),
        (u'criticality', ___RAB_ModifyList__item___item__criticality),
        (u'value', ___RAB_ModifyList__item___item__value),
        ])
    __RAB_ModifyList__item___item_._ext = None
    _RAB_ModifyList__item_._cont = __RAB_ModifyList__item___item_
    _RAB_ModifyList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_ModifyList._cont = _RAB_ModifyList__item_
    RAB_ModifyList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-ModifyItemIEs >-----#
    RAB_ModifyItemIEs = CLASS(name=u'RAB-ModifyItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_ModifyItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ModifyItem')))
    RAB_ModifyItemIEs._val = ASN1Set(rv=[dict([(u'id', 92), (u'criticality', u'ignore'), (u'Value', _RAB_ModifyItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-ModifyItem >-----#
    RAB_ModifyItem = SEQ(name=u'RAB-ModifyItem', mode=MODE_TYPE)
    _RAB_ModifyItem_rAB_ID = BIT_STR(name=u'rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_ModifyItem_requested_RAB_Parameter_Values = SEQ(name=u'requested-RAB-Parameter-Values', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Requested-RAB-Parameter-Values')))
    _RAB_ModifyItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_ModifyItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_ModifyItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RAB_ModifyItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ModifyItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ModifyItem_iE_Extensions__item__id._const_tab = ____RAB_ModifyItem_iE_Extensions__item__id_tab
    ___RAB_ModifyItem_iE_Extensions__item__id._const_tab_at = None
    ___RAB_ModifyItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___RAB_ModifyItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RAB_ModifyItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ModifyItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ModifyItem_iE_Extensions__item__criticality._const_tab = ____RAB_ModifyItem_iE_Extensions__item__criticality_tab
    ___RAB_ModifyItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RAB_ModifyItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RAB_ModifyItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RAB_ModifyItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ModifyItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ModifyItem_iE_Extensions__item__extensionValue._const_tab = ____RAB_ModifyItem_iE_Extensions__item__extensionValue_tab
    ___RAB_ModifyItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RAB_ModifyItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RAB_ModifyItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RAB_ModifyItem_iE_Extensions__item__id),
        (u'criticality', ___RAB_ModifyItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___RAB_ModifyItem_iE_Extensions__item__extensionValue),
        ])
    __RAB_ModifyItem_iE_Extensions__item_._ext = None
    _RAB_ModifyItem_iE_Extensions._cont = __RAB_ModifyItem_iE_Extensions__item_
    _RAB_ModifyItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_ModifyItem._cont = ASN1Dict([
        (u'rAB-ID', _RAB_ModifyItem_rAB_ID),
        (u'requested-RAB-Parameter-Values', _RAB_ModifyItem_requested_RAB_Parameter_Values),
        (u'iE-Extensions', _RAB_ModifyItem_iE_Extensions),
        ])
    RAB_ModifyItem._ext = []
    
    #-----< RAB-ModifyItem-ExtIEs >-----#
    RAB_ModifyItem_ExtIEs = CLASS(name=u'RAB-ModifyItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_ModifyItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-ModifyRequestExtensions >-----#
    RAB_ModifyRequestExtensions = CLASS(name=u'RAB-ModifyRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_ModifyRequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LocationRelatedDataRequest >-----#
    LocationRelatedDataRequest = SEQ(name=u'LocationRelatedDataRequest', mode=MODE_TYPE)
    _LocationRelatedDataRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __LocationRelatedDataRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___LocationRelatedDataRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____LocationRelatedDataRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____LocationRelatedDataRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LocationRelatedDataRequestType')))
    ____LocationRelatedDataRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 95), (u'criticality', u'reject'), (u'Value', _____LocationRelatedDataRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___LocationRelatedDataRequest_protocolIEs__item__id._const_tab = ____LocationRelatedDataRequest_protocolIEs__item__id_tab
    ___LocationRelatedDataRequest_protocolIEs__item__id._const_tab_at = None
    ___LocationRelatedDataRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___LocationRelatedDataRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___LocationRelatedDataRequest_protocolIEs__item__criticality._const_tab = ____LocationRelatedDataRequest_protocolIEs__item__id_tab
    ___LocationRelatedDataRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___LocationRelatedDataRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___LocationRelatedDataRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___LocationRelatedDataRequest_protocolIEs__item__value._const_tab = ____LocationRelatedDataRequest_protocolIEs__item__id_tab
    ___LocationRelatedDataRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___LocationRelatedDataRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __LocationRelatedDataRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___LocationRelatedDataRequest_protocolIEs__item__id),
        (u'criticality', ___LocationRelatedDataRequest_protocolIEs__item__criticality),
        (u'value', ___LocationRelatedDataRequest_protocolIEs__item__value),
        ])
    __LocationRelatedDataRequest_protocolIEs__item_._ext = None
    _LocationRelatedDataRequest_protocolIEs._cont = __LocationRelatedDataRequest_protocolIEs__item_
    _LocationRelatedDataRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _LocationRelatedDataRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LocationRelatedDataRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___LocationRelatedDataRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____LocationRelatedDataRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____LocationRelatedDataRequest_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LocationRelatedDataRequestTypeSpecificToGERANIuMode')))
    _____LocationRelatedDataRequest_protocolExtensions__item__id_tab_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RequestedGANSSAssistanceData')))
    ____LocationRelatedDataRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 115), (u'criticality', u'reject'), (u'Extension', _____LocationRelatedDataRequest_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 185), (u'criticality', u'reject'), (u'Extension', _____LocationRelatedDataRequest_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'conditional')])], rr=[], ev=None, er=[])
    ___LocationRelatedDataRequest_protocolExtensions__item__id._const_tab = ____LocationRelatedDataRequest_protocolExtensions__item__id_tab
    ___LocationRelatedDataRequest_protocolExtensions__item__id._const_tab_at = None
    ___LocationRelatedDataRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___LocationRelatedDataRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___LocationRelatedDataRequest_protocolExtensions__item__criticality._const_tab = ____LocationRelatedDataRequest_protocolExtensions__item__id_tab
    ___LocationRelatedDataRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___LocationRelatedDataRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___LocationRelatedDataRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___LocationRelatedDataRequest_protocolExtensions__item__extensionValue._const_tab = ____LocationRelatedDataRequest_protocolExtensions__item__id_tab
    ___LocationRelatedDataRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LocationRelatedDataRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __LocationRelatedDataRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___LocationRelatedDataRequest_protocolExtensions__item__id),
        (u'criticality', ___LocationRelatedDataRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___LocationRelatedDataRequest_protocolExtensions__item__extensionValue),
        ])
    __LocationRelatedDataRequest_protocolExtensions__item_._ext = None
    _LocationRelatedDataRequest_protocolExtensions._cont = __LocationRelatedDataRequest_protocolExtensions__item_
    _LocationRelatedDataRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LocationRelatedDataRequest._cont = ASN1Dict([
        (u'protocolIEs', _LocationRelatedDataRequest_protocolIEs),
        (u'protocolExtensions', _LocationRelatedDataRequest_protocolExtensions),
        ])
    LocationRelatedDataRequest._ext = []
    
    #-----< LocationRelatedDataRequestIEs >-----#
    LocationRelatedDataRequestIEs = CLASS(name=u'LocationRelatedDataRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _LocationRelatedDataRequestIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LocationRelatedDataRequestType')))
    LocationRelatedDataRequestIEs._val = ASN1Set(rv=[dict([(u'id', 95), (u'criticality', u'reject'), (u'Value', _LocationRelatedDataRequestIEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< LocationRelatedDataRequestExtensions >-----#
    LocationRelatedDataRequestExtensions = CLASS(name=u'LocationRelatedDataRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _LocationRelatedDataRequestExtensions_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LocationRelatedDataRequestTypeSpecificToGERANIuMode')))
    _LocationRelatedDataRequestExtensions_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RequestedGANSSAssistanceData')))
    LocationRelatedDataRequestExtensions._val = ASN1Set(rv=[dict([(u'id', 115), (u'criticality', u'reject'), (u'Extension', _LocationRelatedDataRequestExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 185), (u'criticality', u'reject'), (u'Extension', _LocationRelatedDataRequestExtensions_val_Extension_1), (u'presence', u'conditional')])], rr=[], ev=[], er=[])
    
    #-----< LocationRelatedDataResponse >-----#
    LocationRelatedDataResponse = SEQ(name=u'LocationRelatedDataResponse', mode=MODE_TYPE)
    _LocationRelatedDataResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __LocationRelatedDataResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___LocationRelatedDataResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____LocationRelatedDataResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____LocationRelatedDataResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'BroadcastAssistanceDataDecipheringKeys')))
    ____LocationRelatedDataResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 94), (u'criticality', u'ignore'), (u'Value', _____LocationRelatedDataResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___LocationRelatedDataResponse_protocolIEs__item__id._const_tab = ____LocationRelatedDataResponse_protocolIEs__item__id_tab
    ___LocationRelatedDataResponse_protocolIEs__item__id._const_tab_at = None
    ___LocationRelatedDataResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___LocationRelatedDataResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___LocationRelatedDataResponse_protocolIEs__item__criticality._const_tab = ____LocationRelatedDataResponse_protocolIEs__item__id_tab
    ___LocationRelatedDataResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___LocationRelatedDataResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___LocationRelatedDataResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___LocationRelatedDataResponse_protocolIEs__item__value._const_tab = ____LocationRelatedDataResponse_protocolIEs__item__id_tab
    ___LocationRelatedDataResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___LocationRelatedDataResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __LocationRelatedDataResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___LocationRelatedDataResponse_protocolIEs__item__id),
        (u'criticality', ___LocationRelatedDataResponse_protocolIEs__item__criticality),
        (u'value', ___LocationRelatedDataResponse_protocolIEs__item__value),
        ])
    __LocationRelatedDataResponse_protocolIEs__item_._ext = None
    _LocationRelatedDataResponse_protocolIEs._cont = __LocationRelatedDataResponse_protocolIEs__item_
    _LocationRelatedDataResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _LocationRelatedDataResponse_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LocationRelatedDataResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___LocationRelatedDataResponse_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____LocationRelatedDataResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____LocationRelatedDataResponse_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    _____LocationRelatedDataResponse_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'BroadcastAssistanceDataDecipheringKeys')))
    ____LocationRelatedDataResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 9), (u'criticality', u'ignore'), (u'Extension', _____LocationRelatedDataResponse_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 186), (u'criticality', u'ignore'), (u'Extension', _____LocationRelatedDataResponse_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___LocationRelatedDataResponse_protocolExtensions__item__id._const_tab = ____LocationRelatedDataResponse_protocolExtensions__item__id_tab
    ___LocationRelatedDataResponse_protocolExtensions__item__id._const_tab_at = None
    ___LocationRelatedDataResponse_protocolExtensions__item__id._const_tab_id = u'id'
    ___LocationRelatedDataResponse_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___LocationRelatedDataResponse_protocolExtensions__item__criticality._const_tab = ____LocationRelatedDataResponse_protocolExtensions__item__id_tab
    ___LocationRelatedDataResponse_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___LocationRelatedDataResponse_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___LocationRelatedDataResponse_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___LocationRelatedDataResponse_protocolExtensions__item__extensionValue._const_tab = ____LocationRelatedDataResponse_protocolExtensions__item__id_tab
    ___LocationRelatedDataResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LocationRelatedDataResponse_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __LocationRelatedDataResponse_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___LocationRelatedDataResponse_protocolExtensions__item__id),
        (u'criticality', ___LocationRelatedDataResponse_protocolExtensions__item__criticality),
        (u'extensionValue', ___LocationRelatedDataResponse_protocolExtensions__item__extensionValue),
        ])
    __LocationRelatedDataResponse_protocolExtensions__item_._ext = None
    _LocationRelatedDataResponse_protocolExtensions._cont = __LocationRelatedDataResponse_protocolExtensions__item_
    _LocationRelatedDataResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LocationRelatedDataResponse._cont = ASN1Dict([
        (u'protocolIEs', _LocationRelatedDataResponse_protocolIEs),
        (u'protocolExtensions', _LocationRelatedDataResponse_protocolExtensions),
        ])
    LocationRelatedDataResponse._ext = []
    
    #-----< LocationRelatedDataResponseIEs >-----#
    LocationRelatedDataResponseIEs = CLASS(name=u'LocationRelatedDataResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _LocationRelatedDataResponseIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'BroadcastAssistanceDataDecipheringKeys')))
    LocationRelatedDataResponseIEs._val = ASN1Set(rv=[dict([(u'id', 94), (u'criticality', u'ignore'), (u'Value', _LocationRelatedDataResponseIEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< LocationRelatedDataResponseExtensions >-----#
    LocationRelatedDataResponseExtensions = CLASS(name=u'LocationRelatedDataResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _LocationRelatedDataResponseExtensions_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    _LocationRelatedDataResponseExtensions_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'BroadcastAssistanceDataDecipheringKeys')))
    LocationRelatedDataResponseExtensions._val = ASN1Set(rv=[dict([(u'id', 9), (u'criticality', u'ignore'), (u'Extension', _LocationRelatedDataResponseExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 186), (u'criticality', u'ignore'), (u'Extension', _LocationRelatedDataResponseExtensions_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< LocationRelatedDataFailure >-----#
    LocationRelatedDataFailure = SEQ(name=u'LocationRelatedDataFailure', mode=MODE_TYPE)
    _LocationRelatedDataFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __LocationRelatedDataFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___LocationRelatedDataFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____LocationRelatedDataFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____LocationRelatedDataFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    ____LocationRelatedDataFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____LocationRelatedDataFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___LocationRelatedDataFailure_protocolIEs__item__id._const_tab = ____LocationRelatedDataFailure_protocolIEs__item__id_tab
    ___LocationRelatedDataFailure_protocolIEs__item__id._const_tab_at = None
    ___LocationRelatedDataFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___LocationRelatedDataFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___LocationRelatedDataFailure_protocolIEs__item__criticality._const_tab = ____LocationRelatedDataFailure_protocolIEs__item__id_tab
    ___LocationRelatedDataFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___LocationRelatedDataFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___LocationRelatedDataFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___LocationRelatedDataFailure_protocolIEs__item__value._const_tab = ____LocationRelatedDataFailure_protocolIEs__item__id_tab
    ___LocationRelatedDataFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___LocationRelatedDataFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __LocationRelatedDataFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___LocationRelatedDataFailure_protocolIEs__item__id),
        (u'criticality', ___LocationRelatedDataFailure_protocolIEs__item__criticality),
        (u'value', ___LocationRelatedDataFailure_protocolIEs__item__value),
        ])
    __LocationRelatedDataFailure_protocolIEs__item_._ext = None
    _LocationRelatedDataFailure_protocolIEs._cont = __LocationRelatedDataFailure_protocolIEs__item_
    _LocationRelatedDataFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _LocationRelatedDataFailure_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LocationRelatedDataFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___LocationRelatedDataFailure_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____LocationRelatedDataFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____LocationRelatedDataFailure_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____LocationRelatedDataFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 9), (u'criticality', u'ignore'), (u'Extension', _____LocationRelatedDataFailure_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___LocationRelatedDataFailure_protocolExtensions__item__id._const_tab = ____LocationRelatedDataFailure_protocolExtensions__item__id_tab
    ___LocationRelatedDataFailure_protocolExtensions__item__id._const_tab_at = None
    ___LocationRelatedDataFailure_protocolExtensions__item__id._const_tab_id = u'id'
    ___LocationRelatedDataFailure_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___LocationRelatedDataFailure_protocolExtensions__item__criticality._const_tab = ____LocationRelatedDataFailure_protocolExtensions__item__id_tab
    ___LocationRelatedDataFailure_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___LocationRelatedDataFailure_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___LocationRelatedDataFailure_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___LocationRelatedDataFailure_protocolExtensions__item__extensionValue._const_tab = ____LocationRelatedDataFailure_protocolExtensions__item__id_tab
    ___LocationRelatedDataFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LocationRelatedDataFailure_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __LocationRelatedDataFailure_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___LocationRelatedDataFailure_protocolExtensions__item__id),
        (u'criticality', ___LocationRelatedDataFailure_protocolExtensions__item__criticality),
        (u'extensionValue', ___LocationRelatedDataFailure_protocolExtensions__item__extensionValue),
        ])
    __LocationRelatedDataFailure_protocolExtensions__item_._ext = None
    _LocationRelatedDataFailure_protocolExtensions._cont = __LocationRelatedDataFailure_protocolExtensions__item_
    _LocationRelatedDataFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LocationRelatedDataFailure._cont = ASN1Dict([
        (u'protocolIEs', _LocationRelatedDataFailure_protocolIEs),
        (u'protocolExtensions', _LocationRelatedDataFailure_protocolExtensions),
        ])
    LocationRelatedDataFailure._ext = []
    
    #-----< LocationRelatedDataFailureIEs >-----#
    LocationRelatedDataFailureIEs = CLASS(name=u'LocationRelatedDataFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _LocationRelatedDataFailureIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    LocationRelatedDataFailureIEs._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _LocationRelatedDataFailureIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< LocationRelatedDataFailureExtensions >-----#
    LocationRelatedDataFailureExtensions = CLASS(name=u'LocationRelatedDataFailureExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _LocationRelatedDataFailureExtensions_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    LocationRelatedDataFailureExtensions._val = ASN1Set(rv=[dict([(u'id', 9), (u'criticality', u'ignore'), (u'Extension', _LocationRelatedDataFailureExtensions_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< InformationTransferIndication >-----#
    InformationTransferIndication = SEQ(name=u'InformationTransferIndication', mode=MODE_TYPE)
    _InformationTransferIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __InformationTransferIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___InformationTransferIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____InformationTransferIndication_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____InformationTransferIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationTransferID')))
    _____InformationTransferIndication_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ProvidedData')))
    _____InformationTransferIndication_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____InformationTransferIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    ____InformationTransferIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 104), (u'criticality', u'reject'), (u'Value', _____InformationTransferIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 106), (u'criticality', u'reject'), (u'Value', _____InformationTransferIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 3), (u'criticality', u'reject'), (u'Value', _____InformationTransferIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 96), (u'criticality', u'ignore'), (u'Value', _____InformationTransferIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___InformationTransferIndication_protocolIEs__item__id._const_tab = ____InformationTransferIndication_protocolIEs__item__id_tab
    ___InformationTransferIndication_protocolIEs__item__id._const_tab_at = None
    ___InformationTransferIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___InformationTransferIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___InformationTransferIndication_protocolIEs__item__criticality._const_tab = ____InformationTransferIndication_protocolIEs__item__id_tab
    ___InformationTransferIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___InformationTransferIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___InformationTransferIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___InformationTransferIndication_protocolIEs__item__value._const_tab = ____InformationTransferIndication_protocolIEs__item__id_tab
    ___InformationTransferIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___InformationTransferIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __InformationTransferIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___InformationTransferIndication_protocolIEs__item__id),
        (u'criticality', ___InformationTransferIndication_protocolIEs__item__criticality),
        (u'value', ___InformationTransferIndication_protocolIEs__item__value),
        ])
    __InformationTransferIndication_protocolIEs__item_._ext = None
    _InformationTransferIndication_protocolIEs._cont = __InformationTransferIndication_protocolIEs__item_
    _InformationTransferIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InformationTransferIndication_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationTransferIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___InformationTransferIndication_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____InformationTransferIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____InformationTransferIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationTransferIndication_protocolExtensions__item__id._const_tab = ____InformationTransferIndication_protocolExtensions__item__id_tab
    ___InformationTransferIndication_protocolExtensions__item__id._const_tab_at = None
    ___InformationTransferIndication_protocolExtensions__item__id._const_tab_id = u'id'
    ___InformationTransferIndication_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____InformationTransferIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____InformationTransferIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationTransferIndication_protocolExtensions__item__criticality._const_tab = ____InformationTransferIndication_protocolExtensions__item__criticality_tab
    ___InformationTransferIndication_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___InformationTransferIndication_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___InformationTransferIndication_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____InformationTransferIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____InformationTransferIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationTransferIndication_protocolExtensions__item__extensionValue._const_tab = ____InformationTransferIndication_protocolExtensions__item__extensionValue_tab
    ___InformationTransferIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___InformationTransferIndication_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __InformationTransferIndication_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___InformationTransferIndication_protocolExtensions__item__id),
        (u'criticality', ___InformationTransferIndication_protocolExtensions__item__criticality),
        (u'extensionValue', ___InformationTransferIndication_protocolExtensions__item__extensionValue),
        ])
    __InformationTransferIndication_protocolExtensions__item_._ext = None
    _InformationTransferIndication_protocolExtensions._cont = __InformationTransferIndication_protocolExtensions__item_
    _InformationTransferIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationTransferIndication._cont = ASN1Dict([
        (u'protocolIEs', _InformationTransferIndication_protocolIEs),
        (u'protocolExtensions', _InformationTransferIndication_protocolExtensions),
        ])
    InformationTransferIndication._ext = []
    
    #-----< InformationTransferIndicationIEs >-----#
    InformationTransferIndicationIEs = CLASS(name=u'InformationTransferIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _InformationTransferIndicationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationTransferID')))
    _InformationTransferIndicationIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ProvidedData')))
    _InformationTransferIndicationIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _InformationTransferIndicationIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    InformationTransferIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 104), (u'criticality', u'reject'), (u'Value', _InformationTransferIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 106), (u'criticality', u'reject'), (u'Value', _InformationTransferIndicationIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 3), (u'criticality', u'reject'), (u'Value', _InformationTransferIndicationIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 96), (u'criticality', u'ignore'), (u'Value', _InformationTransferIndicationIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< InformationTransferIndicationExtensions >-----#
    InformationTransferIndicationExtensions = CLASS(name=u'InformationTransferIndicationExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    InformationTransferIndicationExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationTransferConfirmation >-----#
    InformationTransferConfirmation = SEQ(name=u'InformationTransferConfirmation', mode=MODE_TYPE)
    _InformationTransferConfirmation_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __InformationTransferConfirmation_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___InformationTransferConfirmation_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____InformationTransferConfirmation_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____InformationTransferConfirmation_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationTransferID')))
    _____InformationTransferConfirmation_protocolIEs__item__id_tab_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____InformationTransferConfirmation_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    _____InformationTransferConfirmation_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ____InformationTransferConfirmation_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 104), (u'criticality', u'ignore'), (u'Value', _____InformationTransferConfirmation_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 3), (u'criticality', u'ignore'), (u'Value', _____InformationTransferConfirmation_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____InformationTransferConfirmation_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _____InformationTransferConfirmation_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___InformationTransferConfirmation_protocolIEs__item__id._const_tab = ____InformationTransferConfirmation_protocolIEs__item__id_tab
    ___InformationTransferConfirmation_protocolIEs__item__id._const_tab_at = None
    ___InformationTransferConfirmation_protocolIEs__item__id._const_tab_id = u'id'
    ___InformationTransferConfirmation_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___InformationTransferConfirmation_protocolIEs__item__criticality._const_tab = ____InformationTransferConfirmation_protocolIEs__item__id_tab
    ___InformationTransferConfirmation_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___InformationTransferConfirmation_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___InformationTransferConfirmation_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___InformationTransferConfirmation_protocolIEs__item__value._const_tab = ____InformationTransferConfirmation_protocolIEs__item__id_tab
    ___InformationTransferConfirmation_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___InformationTransferConfirmation_protocolIEs__item__value._const_tab_id = u'Value'
    __InformationTransferConfirmation_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___InformationTransferConfirmation_protocolIEs__item__id),
        (u'criticality', ___InformationTransferConfirmation_protocolIEs__item__criticality),
        (u'value', ___InformationTransferConfirmation_protocolIEs__item__value),
        ])
    __InformationTransferConfirmation_protocolIEs__item_._ext = None
    _InformationTransferConfirmation_protocolIEs._cont = __InformationTransferConfirmation_protocolIEs__item_
    _InformationTransferConfirmation_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InformationTransferConfirmation_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationTransferConfirmation_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___InformationTransferConfirmation_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____InformationTransferConfirmation_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____InformationTransferConfirmation_protocolExtensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ____InformationTransferConfirmation_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _____InformationTransferConfirmation_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___InformationTransferConfirmation_protocolExtensions__item__id._const_tab = ____InformationTransferConfirmation_protocolExtensions__item__id_tab
    ___InformationTransferConfirmation_protocolExtensions__item__id._const_tab_at = None
    ___InformationTransferConfirmation_protocolExtensions__item__id._const_tab_id = u'id'
    ___InformationTransferConfirmation_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___InformationTransferConfirmation_protocolExtensions__item__criticality._const_tab = ____InformationTransferConfirmation_protocolExtensions__item__id_tab
    ___InformationTransferConfirmation_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___InformationTransferConfirmation_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___InformationTransferConfirmation_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___InformationTransferConfirmation_protocolExtensions__item__extensionValue._const_tab = ____InformationTransferConfirmation_protocolExtensions__item__id_tab
    ___InformationTransferConfirmation_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___InformationTransferConfirmation_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __InformationTransferConfirmation_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___InformationTransferConfirmation_protocolExtensions__item__id),
        (u'criticality', ___InformationTransferConfirmation_protocolExtensions__item__criticality),
        (u'extensionValue', ___InformationTransferConfirmation_protocolExtensions__item__extensionValue),
        ])
    __InformationTransferConfirmation_protocolExtensions__item_._ext = None
    _InformationTransferConfirmation_protocolExtensions._cont = __InformationTransferConfirmation_protocolExtensions__item_
    _InformationTransferConfirmation_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationTransferConfirmation._cont = ASN1Dict([
        (u'protocolIEs', _InformationTransferConfirmation_protocolIEs),
        (u'protocolExtensions', _InformationTransferConfirmation_protocolExtensions),
        ])
    InformationTransferConfirmation._ext = []
    
    #-----< InformationTransferConfirmationIEs >-----#
    InformationTransferConfirmationIEs = CLASS(name=u'InformationTransferConfirmationIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _InformationTransferConfirmationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationTransferID')))
    _InformationTransferConfirmationIEs_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _InformationTransferConfirmationIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    _InformationTransferConfirmationIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    InformationTransferConfirmationIEs._val = ASN1Set(rv=[dict([(u'id', 104), (u'criticality', u'ignore'), (u'Value', _InformationTransferConfirmationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 3), (u'criticality', u'ignore'), (u'Value', _InformationTransferConfirmationIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _InformationTransferConfirmationIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _InformationTransferConfirmationIEs_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< InformationTransferConfirmationExtensions >-----#
    InformationTransferConfirmationExtensions = CLASS(name=u'InformationTransferConfirmationExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _InformationTransferConfirmationExtensions_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    InformationTransferConfirmationExtensions._val = ASN1Set(rv=[dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _InformationTransferConfirmationExtensions_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< InformationTransferFailure >-----#
    InformationTransferFailure = SEQ(name=u'InformationTransferFailure', mode=MODE_TYPE)
    _InformationTransferFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __InformationTransferFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___InformationTransferFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____InformationTransferFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationTransferID')))
    _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ____InformationTransferFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 104), (u'criticality', u'ignore'), (u'Value', _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 3), (u'criticality', u'ignore'), (u'Value', _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___InformationTransferFailure_protocolIEs__item__id._const_tab = ____InformationTransferFailure_protocolIEs__item__id_tab
    ___InformationTransferFailure_protocolIEs__item__id._const_tab_at = None
    ___InformationTransferFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___InformationTransferFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___InformationTransferFailure_protocolIEs__item__criticality._const_tab = ____InformationTransferFailure_protocolIEs__item__id_tab
    ___InformationTransferFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___InformationTransferFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___InformationTransferFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___InformationTransferFailure_protocolIEs__item__value._const_tab = ____InformationTransferFailure_protocolIEs__item__id_tab
    ___InformationTransferFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___InformationTransferFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __InformationTransferFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___InformationTransferFailure_protocolIEs__item__id),
        (u'criticality', ___InformationTransferFailure_protocolIEs__item__criticality),
        (u'value', ___InformationTransferFailure_protocolIEs__item__value),
        ])
    __InformationTransferFailure_protocolIEs__item_._ext = None
    _InformationTransferFailure_protocolIEs._cont = __InformationTransferFailure_protocolIEs__item_
    _InformationTransferFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InformationTransferFailure_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationTransferFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___InformationTransferFailure_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____InformationTransferFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____InformationTransferFailure_protocolExtensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ____InformationTransferFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _____InformationTransferFailure_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___InformationTransferFailure_protocolExtensions__item__id._const_tab = ____InformationTransferFailure_protocolExtensions__item__id_tab
    ___InformationTransferFailure_protocolExtensions__item__id._const_tab_at = None
    ___InformationTransferFailure_protocolExtensions__item__id._const_tab_id = u'id'
    ___InformationTransferFailure_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___InformationTransferFailure_protocolExtensions__item__criticality._const_tab = ____InformationTransferFailure_protocolExtensions__item__id_tab
    ___InformationTransferFailure_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___InformationTransferFailure_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___InformationTransferFailure_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___InformationTransferFailure_protocolExtensions__item__extensionValue._const_tab = ____InformationTransferFailure_protocolExtensions__item__id_tab
    ___InformationTransferFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___InformationTransferFailure_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __InformationTransferFailure_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___InformationTransferFailure_protocolExtensions__item__id),
        (u'criticality', ___InformationTransferFailure_protocolExtensions__item__criticality),
        (u'extensionValue', ___InformationTransferFailure_protocolExtensions__item__extensionValue),
        ])
    __InformationTransferFailure_protocolExtensions__item_._ext = None
    _InformationTransferFailure_protocolExtensions._cont = __InformationTransferFailure_protocolExtensions__item_
    _InformationTransferFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationTransferFailure._cont = ASN1Dict([
        (u'protocolIEs', _InformationTransferFailure_protocolIEs),
        (u'protocolExtensions', _InformationTransferFailure_protocolExtensions),
        ])
    InformationTransferFailure._ext = []
    
    #-----< InformationTransferFailureIEs >-----#
    InformationTransferFailureIEs = CLASS(name=u'InformationTransferFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _InformationTransferFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationTransferID')))
    _InformationTransferFailureIEs_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _InformationTransferFailureIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _InformationTransferFailureIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    _InformationTransferFailureIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    InformationTransferFailureIEs._val = ASN1Set(rv=[dict([(u'id', 104), (u'criticality', u'ignore'), (u'Value', _InformationTransferFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 3), (u'criticality', u'ignore'), (u'Value', _InformationTransferFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _InformationTransferFailureIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _InformationTransferFailureIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _InformationTransferFailureIEs_val_Value_4), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< InformationTransferFailureExtensions >-----#
    InformationTransferFailureExtensions = CLASS(name=u'InformationTransferFailureExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _InformationTransferFailureExtensions_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    InformationTransferFailureExtensions._val = ASN1Set(rv=[dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _InformationTransferFailureExtensions_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UESpecificInformationIndication >-----#
    UESpecificInformationIndication = SEQ(name=u'UESpecificInformationIndication', mode=MODE_TYPE)
    _UESpecificInformationIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __UESpecificInformationIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___UESpecificInformationIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____UESpecificInformationIndication_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____UESpecificInformationIndication_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UESBI-Iu')))
    ____UESpecificInformationIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 118), (u'criticality', u'ignore'), (u'Value', _____UESpecificInformationIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UESpecificInformationIndication_protocolIEs__item__id._const_tab = ____UESpecificInformationIndication_protocolIEs__item__id_tab
    ___UESpecificInformationIndication_protocolIEs__item__id._const_tab_at = None
    ___UESpecificInformationIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___UESpecificInformationIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___UESpecificInformationIndication_protocolIEs__item__criticality._const_tab = ____UESpecificInformationIndication_protocolIEs__item__id_tab
    ___UESpecificInformationIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UESpecificInformationIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UESpecificInformationIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___UESpecificInformationIndication_protocolIEs__item__value._const_tab = ____UESpecificInformationIndication_protocolIEs__item__id_tab
    ___UESpecificInformationIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UESpecificInformationIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __UESpecificInformationIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UESpecificInformationIndication_protocolIEs__item__id),
        (u'criticality', ___UESpecificInformationIndication_protocolIEs__item__criticality),
        (u'value', ___UESpecificInformationIndication_protocolIEs__item__value),
        ])
    __UESpecificInformationIndication_protocolIEs__item_._ext = None
    _UESpecificInformationIndication_protocolIEs._cont = __UESpecificInformationIndication_protocolIEs__item_
    _UESpecificInformationIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UESpecificInformationIndication_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UESpecificInformationIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UESpecificInformationIndication_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UESpecificInformationIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UESpecificInformationIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESpecificInformationIndication_protocolExtensions__item__id._const_tab = ____UESpecificInformationIndication_protocolExtensions__item__id_tab
    ___UESpecificInformationIndication_protocolExtensions__item__id._const_tab_at = None
    ___UESpecificInformationIndication_protocolExtensions__item__id._const_tab_id = u'id'
    ___UESpecificInformationIndication_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UESpecificInformationIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UESpecificInformationIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESpecificInformationIndication_protocolExtensions__item__criticality._const_tab = ____UESpecificInformationIndication_protocolExtensions__item__criticality_tab
    ___UESpecificInformationIndication_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___UESpecificInformationIndication_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___UESpecificInformationIndication_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UESpecificInformationIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UESpecificInformationIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESpecificInformationIndication_protocolExtensions__item__extensionValue._const_tab = ____UESpecificInformationIndication_protocolExtensions__item__extensionValue_tab
    ___UESpecificInformationIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UESpecificInformationIndication_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __UESpecificInformationIndication_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___UESpecificInformationIndication_protocolExtensions__item__id),
        (u'criticality', ___UESpecificInformationIndication_protocolExtensions__item__criticality),
        (u'extensionValue', ___UESpecificInformationIndication_protocolExtensions__item__extensionValue),
        ])
    __UESpecificInformationIndication_protocolExtensions__item_._ext = None
    _UESpecificInformationIndication_protocolExtensions._cont = __UESpecificInformationIndication_protocolExtensions__item_
    _UESpecificInformationIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UESpecificInformationIndication._cont = ASN1Dict([
        (u'protocolIEs', _UESpecificInformationIndication_protocolIEs),
        (u'protocolExtensions', _UESpecificInformationIndication_protocolExtensions),
        ])
    UESpecificInformationIndication._ext = []
    
    #-----< UESpecificInformationIndicationIEs >-----#
    UESpecificInformationIndicationIEs = CLASS(name=u'UESpecificInformationIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _UESpecificInformationIndicationIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UESBI-Iu')))
    UESpecificInformationIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 118), (u'criticality', u'ignore'), (u'Value', _UESpecificInformationIndicationIEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UESpecificInformationIndicationExtensions >-----#
    UESpecificInformationIndicationExtensions = CLASS(name=u'UESpecificInformationIndicationExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    UESpecificInformationIndicationExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DirectInformationTransfer >-----#
    DirectInformationTransfer = SEQ(name=u'DirectInformationTransfer', mode=MODE_TYPE)
    _DirectInformationTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __DirectInformationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___DirectInformationTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____DirectInformationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InterSystemInformationTransferType')))
    _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    ____DirectInformationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 126), (u'criticality', u'ignore'), (u'Value', _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 3), (u'criticality', u'ignore'), (u'Value', _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 96), (u'criticality', u'ignore'), (u'Value', _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DirectInformationTransfer_protocolIEs__item__id._const_tab = ____DirectInformationTransfer_protocolIEs__item__id_tab
    ___DirectInformationTransfer_protocolIEs__item__id._const_tab_at = None
    ___DirectInformationTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___DirectInformationTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___DirectInformationTransfer_protocolIEs__item__criticality._const_tab = ____DirectInformationTransfer_protocolIEs__item__id_tab
    ___DirectInformationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DirectInformationTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DirectInformationTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___DirectInformationTransfer_protocolIEs__item__value._const_tab = ____DirectInformationTransfer_protocolIEs__item__id_tab
    ___DirectInformationTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DirectInformationTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __DirectInformationTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DirectInformationTransfer_protocolIEs__item__id),
        (u'criticality', ___DirectInformationTransfer_protocolIEs__item__criticality),
        (u'value', ___DirectInformationTransfer_protocolIEs__item__value),
        ])
    __DirectInformationTransfer_protocolIEs__item_._ext = None
    _DirectInformationTransfer_protocolIEs._cont = __DirectInformationTransfer_protocolIEs__item_
    _DirectInformationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DirectInformationTransfer_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DirectInformationTransfer_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___DirectInformationTransfer_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DirectInformationTransfer_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____DirectInformationTransfer_protocolExtensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ____DirectInformationTransfer_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _____DirectInformationTransfer_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DirectInformationTransfer_protocolExtensions__item__id._const_tab = ____DirectInformationTransfer_protocolExtensions__item__id_tab
    ___DirectInformationTransfer_protocolExtensions__item__id._const_tab_at = None
    ___DirectInformationTransfer_protocolExtensions__item__id._const_tab_id = u'id'
    ___DirectInformationTransfer_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DirectInformationTransfer_protocolExtensions__item__criticality._const_tab = ____DirectInformationTransfer_protocolExtensions__item__id_tab
    ___DirectInformationTransfer_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___DirectInformationTransfer_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___DirectInformationTransfer_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DirectInformationTransfer_protocolExtensions__item__extensionValue._const_tab = ____DirectInformationTransfer_protocolExtensions__item__id_tab
    ___DirectInformationTransfer_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DirectInformationTransfer_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __DirectInformationTransfer_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___DirectInformationTransfer_protocolExtensions__item__id),
        (u'criticality', ___DirectInformationTransfer_protocolExtensions__item__criticality),
        (u'extensionValue', ___DirectInformationTransfer_protocolExtensions__item__extensionValue),
        ])
    __DirectInformationTransfer_protocolExtensions__item_._ext = None
    _DirectInformationTransfer_protocolExtensions._cont = __DirectInformationTransfer_protocolExtensions__item_
    _DirectInformationTransfer_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DirectInformationTransfer._cont = ASN1Dict([
        (u'protocolIEs', _DirectInformationTransfer_protocolIEs),
        (u'protocolExtensions', _DirectInformationTransfer_protocolExtensions),
        ])
    DirectInformationTransfer._ext = []
    
    #-----< DirectInformationTransferIEs >-----#
    DirectInformationTransferIEs = CLASS(name=u'DirectInformationTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _DirectInformationTransferIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InterSystemInformationTransferType')))
    _DirectInformationTransferIEs_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _DirectInformationTransferIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    _DirectInformationTransferIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    DirectInformationTransferIEs._val = ASN1Set(rv=[dict([(u'id', 126), (u'criticality', u'ignore'), (u'Value', _DirectInformationTransferIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 3), (u'criticality', u'ignore'), (u'Value', _DirectInformationTransferIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _DirectInformationTransferIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 96), (u'criticality', u'ignore'), (u'Value', _DirectInformationTransferIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DirectInformationTransferExtensions >-----#
    DirectInformationTransferExtensions = CLASS(name=u'DirectInformationTransferExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _DirectInformationTransferExtensions_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    DirectInformationTransferExtensions._val = ASN1Set(rv=[dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _DirectInformationTransferExtensions_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UplinkInformationExchangeRequest >-----#
    UplinkInformationExchangeRequest = SEQ(name=u'UplinkInformationExchangeRequest', mode=MODE_TYPE)
    _UplinkInformationExchangeRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __UplinkInformationExchangeRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___UplinkInformationExchangeRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____UplinkInformationExchangeRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationExchangeID')))
    _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationExchangeType')))
    _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationTransferType')))
    _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationRequestType')))
    _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ____UplinkInformationExchangeRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 136), (u'criticality', u'reject'), (u'Value', _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 137), (u'criticality', u'reject'), (u'Value', _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 123), (u'criticality', u'reject'), (u'Value', _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'conditional')]), dict([(u'id', 139), (u'criticality', u'reject'), (u'Value', _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'conditional')]), dict([(u'id', 3), (u'criticality', u'reject'), (u'Value', _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 86), (u'criticality', u'reject'), (u'Value', _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___UplinkInformationExchangeRequest_protocolIEs__item__id._const_tab = ____UplinkInformationExchangeRequest_protocolIEs__item__id_tab
    ___UplinkInformationExchangeRequest_protocolIEs__item__id._const_tab_at = None
    ___UplinkInformationExchangeRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___UplinkInformationExchangeRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___UplinkInformationExchangeRequest_protocolIEs__item__criticality._const_tab = ____UplinkInformationExchangeRequest_protocolIEs__item__id_tab
    ___UplinkInformationExchangeRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UplinkInformationExchangeRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UplinkInformationExchangeRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___UplinkInformationExchangeRequest_protocolIEs__item__value._const_tab = ____UplinkInformationExchangeRequest_protocolIEs__item__id_tab
    ___UplinkInformationExchangeRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UplinkInformationExchangeRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __UplinkInformationExchangeRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UplinkInformationExchangeRequest_protocolIEs__item__id),
        (u'criticality', ___UplinkInformationExchangeRequest_protocolIEs__item__criticality),
        (u'value', ___UplinkInformationExchangeRequest_protocolIEs__item__value),
        ])
    __UplinkInformationExchangeRequest_protocolIEs__item_._ext = None
    _UplinkInformationExchangeRequest_protocolIEs._cont = __UplinkInformationExchangeRequest_protocolIEs__item_
    _UplinkInformationExchangeRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UplinkInformationExchangeRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UplinkInformationExchangeRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UplinkInformationExchangeRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UplinkInformationExchangeRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____UplinkInformationExchangeRequest_protocolExtensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ____UplinkInformationExchangeRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _____UplinkInformationExchangeRequest_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UplinkInformationExchangeRequest_protocolExtensions__item__id._const_tab = ____UplinkInformationExchangeRequest_protocolExtensions__item__id_tab
    ___UplinkInformationExchangeRequest_protocolExtensions__item__id._const_tab_at = None
    ___UplinkInformationExchangeRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___UplinkInformationExchangeRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UplinkInformationExchangeRequest_protocolExtensions__item__criticality._const_tab = ____UplinkInformationExchangeRequest_protocolExtensions__item__id_tab
    ___UplinkInformationExchangeRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___UplinkInformationExchangeRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___UplinkInformationExchangeRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UplinkInformationExchangeRequest_protocolExtensions__item__extensionValue._const_tab = ____UplinkInformationExchangeRequest_protocolExtensions__item__id_tab
    ___UplinkInformationExchangeRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UplinkInformationExchangeRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __UplinkInformationExchangeRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___UplinkInformationExchangeRequest_protocolExtensions__item__id),
        (u'criticality', ___UplinkInformationExchangeRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___UplinkInformationExchangeRequest_protocolExtensions__item__extensionValue),
        ])
    __UplinkInformationExchangeRequest_protocolExtensions__item_._ext = None
    _UplinkInformationExchangeRequest_protocolExtensions._cont = __UplinkInformationExchangeRequest_protocolExtensions__item_
    _UplinkInformationExchangeRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UplinkInformationExchangeRequest._cont = ASN1Dict([
        (u'protocolIEs', _UplinkInformationExchangeRequest_protocolIEs),
        (u'protocolExtensions', _UplinkInformationExchangeRequest_protocolExtensions),
        ])
    UplinkInformationExchangeRequest._ext = []
    
    #-----< UplinkInformationExchangeRequestIEs >-----#
    UplinkInformationExchangeRequestIEs = CLASS(name=u'UplinkInformationExchangeRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _UplinkInformationExchangeRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationExchangeID')))
    _UplinkInformationExchangeRequestIEs_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationExchangeType')))
    _UplinkInformationExchangeRequestIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationTransferType')))
    _UplinkInformationExchangeRequestIEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationRequestType')))
    _UplinkInformationExchangeRequestIEs_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _UplinkInformationExchangeRequestIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    UplinkInformationExchangeRequestIEs._val = ASN1Set(rv=[dict([(u'id', 136), (u'criticality', u'reject'), (u'Value', _UplinkInformationExchangeRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 137), (u'criticality', u'reject'), (u'Value', _UplinkInformationExchangeRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 123), (u'criticality', u'reject'), (u'Value', _UplinkInformationExchangeRequestIEs_val_Value_2), (u'presence', u'conditional')]), dict([(u'id', 139), (u'criticality', u'reject'), (u'Value', _UplinkInformationExchangeRequestIEs_val_Value_3), (u'presence', u'conditional')]), dict([(u'id', 3), (u'criticality', u'reject'), (u'Value', _UplinkInformationExchangeRequestIEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 86), (u'criticality', u'reject'), (u'Value', _UplinkInformationExchangeRequestIEs_val_Value_5), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UplinkInformationExchangeRequestExtensions >-----#
    UplinkInformationExchangeRequestExtensions = CLASS(name=u'UplinkInformationExchangeRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _UplinkInformationExchangeRequestExtensions_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    UplinkInformationExchangeRequestExtensions._val = ASN1Set(rv=[dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _UplinkInformationExchangeRequestExtensions_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UplinkInformationExchangeResponse >-----#
    UplinkInformationExchangeResponse = SEQ(name=u'UplinkInformationExchangeResponse', mode=MODE_TYPE)
    _UplinkInformationExchangeResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __UplinkInformationExchangeResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___UplinkInformationExchangeResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____UplinkInformationExchangeResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationExchangeID')))
    _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationRequested')))
    _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____UplinkInformationExchangeResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 136), (u'criticality', u'ignore'), (u'Value', _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 138), (u'criticality', u'ignore'), (u'Value', _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 3), (u'criticality', u'ignore'), (u'Value', _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 96), (u'criticality', u'ignore'), (u'Value', _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UplinkInformationExchangeResponse_protocolIEs__item__id._const_tab = ____UplinkInformationExchangeResponse_protocolIEs__item__id_tab
    ___UplinkInformationExchangeResponse_protocolIEs__item__id._const_tab_at = None
    ___UplinkInformationExchangeResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___UplinkInformationExchangeResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___UplinkInformationExchangeResponse_protocolIEs__item__criticality._const_tab = ____UplinkInformationExchangeResponse_protocolIEs__item__id_tab
    ___UplinkInformationExchangeResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UplinkInformationExchangeResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UplinkInformationExchangeResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___UplinkInformationExchangeResponse_protocolIEs__item__value._const_tab = ____UplinkInformationExchangeResponse_protocolIEs__item__id_tab
    ___UplinkInformationExchangeResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UplinkInformationExchangeResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __UplinkInformationExchangeResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UplinkInformationExchangeResponse_protocolIEs__item__id),
        (u'criticality', ___UplinkInformationExchangeResponse_protocolIEs__item__criticality),
        (u'value', ___UplinkInformationExchangeResponse_protocolIEs__item__value),
        ])
    __UplinkInformationExchangeResponse_protocolIEs__item_._ext = None
    _UplinkInformationExchangeResponse_protocolIEs._cont = __UplinkInformationExchangeResponse_protocolIEs__item_
    _UplinkInformationExchangeResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UplinkInformationExchangeResponse_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UplinkInformationExchangeResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UplinkInformationExchangeResponse_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UplinkInformationExchangeResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UplinkInformationExchangeResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UplinkInformationExchangeResponse_protocolExtensions__item__id._const_tab = ____UplinkInformationExchangeResponse_protocolExtensions__item__id_tab
    ___UplinkInformationExchangeResponse_protocolExtensions__item__id._const_tab_at = None
    ___UplinkInformationExchangeResponse_protocolExtensions__item__id._const_tab_id = u'id'
    ___UplinkInformationExchangeResponse_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UplinkInformationExchangeResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UplinkInformationExchangeResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UplinkInformationExchangeResponse_protocolExtensions__item__criticality._const_tab = ____UplinkInformationExchangeResponse_protocolExtensions__item__criticality_tab
    ___UplinkInformationExchangeResponse_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___UplinkInformationExchangeResponse_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___UplinkInformationExchangeResponse_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UplinkInformationExchangeResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UplinkInformationExchangeResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UplinkInformationExchangeResponse_protocolExtensions__item__extensionValue._const_tab = ____UplinkInformationExchangeResponse_protocolExtensions__item__extensionValue_tab
    ___UplinkInformationExchangeResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UplinkInformationExchangeResponse_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __UplinkInformationExchangeResponse_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___UplinkInformationExchangeResponse_protocolExtensions__item__id),
        (u'criticality', ___UplinkInformationExchangeResponse_protocolExtensions__item__criticality),
        (u'extensionValue', ___UplinkInformationExchangeResponse_protocolExtensions__item__extensionValue),
        ])
    __UplinkInformationExchangeResponse_protocolExtensions__item_._ext = None
    _UplinkInformationExchangeResponse_protocolExtensions._cont = __UplinkInformationExchangeResponse_protocolExtensions__item_
    _UplinkInformationExchangeResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UplinkInformationExchangeResponse._cont = ASN1Dict([
        (u'protocolIEs', _UplinkInformationExchangeResponse_protocolIEs),
        (u'protocolExtensions', _UplinkInformationExchangeResponse_protocolExtensions),
        ])
    UplinkInformationExchangeResponse._ext = []
    
    #-----< UplinkInformationExchangeResponseIEs >-----#
    UplinkInformationExchangeResponseIEs = CLASS(name=u'UplinkInformationExchangeResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _UplinkInformationExchangeResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationExchangeID')))
    _UplinkInformationExchangeResponseIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationRequested')))
    _UplinkInformationExchangeResponseIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _UplinkInformationExchangeResponseIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _UplinkInformationExchangeResponseIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    UplinkInformationExchangeResponseIEs._val = ASN1Set(rv=[dict([(u'id', 136), (u'criticality', u'ignore'), (u'Value', _UplinkInformationExchangeResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 138), (u'criticality', u'ignore'), (u'Value', _UplinkInformationExchangeResponseIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 3), (u'criticality', u'ignore'), (u'Value', _UplinkInformationExchangeResponseIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 96), (u'criticality', u'ignore'), (u'Value', _UplinkInformationExchangeResponseIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _UplinkInformationExchangeResponseIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UplinkInformationExchangeResponseExtensions >-----#
    UplinkInformationExchangeResponseExtensions = CLASS(name=u'UplinkInformationExchangeResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    UplinkInformationExchangeResponseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UplinkInformationExchangeFailure >-----#
    UplinkInformationExchangeFailure = SEQ(name=u'UplinkInformationExchangeFailure', mode=MODE_TYPE)
    _UplinkInformationExchangeFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __UplinkInformationExchangeFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___UplinkInformationExchangeFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____UplinkInformationExchangeFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationExchangeID')))
    _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____UplinkInformationExchangeFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 136), (u'criticality', u'ignore'), (u'Value', _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 3), (u'criticality', u'ignore'), (u'Value', _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 96), (u'criticality', u'ignore'), (u'Value', _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UplinkInformationExchangeFailure_protocolIEs__item__id._const_tab = ____UplinkInformationExchangeFailure_protocolIEs__item__id_tab
    ___UplinkInformationExchangeFailure_protocolIEs__item__id._const_tab_at = None
    ___UplinkInformationExchangeFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___UplinkInformationExchangeFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___UplinkInformationExchangeFailure_protocolIEs__item__criticality._const_tab = ____UplinkInformationExchangeFailure_protocolIEs__item__id_tab
    ___UplinkInformationExchangeFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UplinkInformationExchangeFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UplinkInformationExchangeFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___UplinkInformationExchangeFailure_protocolIEs__item__value._const_tab = ____UplinkInformationExchangeFailure_protocolIEs__item__id_tab
    ___UplinkInformationExchangeFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UplinkInformationExchangeFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __UplinkInformationExchangeFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UplinkInformationExchangeFailure_protocolIEs__item__id),
        (u'criticality', ___UplinkInformationExchangeFailure_protocolIEs__item__criticality),
        (u'value', ___UplinkInformationExchangeFailure_protocolIEs__item__value),
        ])
    __UplinkInformationExchangeFailure_protocolIEs__item_._ext = None
    _UplinkInformationExchangeFailure_protocolIEs._cont = __UplinkInformationExchangeFailure_protocolIEs__item_
    _UplinkInformationExchangeFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UplinkInformationExchangeFailure_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UplinkInformationExchangeFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UplinkInformationExchangeFailure_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UplinkInformationExchangeFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UplinkInformationExchangeFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UplinkInformationExchangeFailure_protocolExtensions__item__id._const_tab = ____UplinkInformationExchangeFailure_protocolExtensions__item__id_tab
    ___UplinkInformationExchangeFailure_protocolExtensions__item__id._const_tab_at = None
    ___UplinkInformationExchangeFailure_protocolExtensions__item__id._const_tab_id = u'id'
    ___UplinkInformationExchangeFailure_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UplinkInformationExchangeFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UplinkInformationExchangeFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UplinkInformationExchangeFailure_protocolExtensions__item__criticality._const_tab = ____UplinkInformationExchangeFailure_protocolExtensions__item__criticality_tab
    ___UplinkInformationExchangeFailure_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___UplinkInformationExchangeFailure_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___UplinkInformationExchangeFailure_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UplinkInformationExchangeFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UplinkInformationExchangeFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UplinkInformationExchangeFailure_protocolExtensions__item__extensionValue._const_tab = ____UplinkInformationExchangeFailure_protocolExtensions__item__extensionValue_tab
    ___UplinkInformationExchangeFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UplinkInformationExchangeFailure_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __UplinkInformationExchangeFailure_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___UplinkInformationExchangeFailure_protocolExtensions__item__id),
        (u'criticality', ___UplinkInformationExchangeFailure_protocolExtensions__item__criticality),
        (u'extensionValue', ___UplinkInformationExchangeFailure_protocolExtensions__item__extensionValue),
        ])
    __UplinkInformationExchangeFailure_protocolExtensions__item_._ext = None
    _UplinkInformationExchangeFailure_protocolExtensions._cont = __UplinkInformationExchangeFailure_protocolExtensions__item_
    _UplinkInformationExchangeFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UplinkInformationExchangeFailure._cont = ASN1Dict([
        (u'protocolIEs', _UplinkInformationExchangeFailure_protocolIEs),
        (u'protocolExtensions', _UplinkInformationExchangeFailure_protocolExtensions),
        ])
    UplinkInformationExchangeFailure._ext = []
    
    #-----< UplinkInformationExchangeFailureIEs >-----#
    UplinkInformationExchangeFailureIEs = CLASS(name=u'UplinkInformationExchangeFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _UplinkInformationExchangeFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationExchangeID')))
    _UplinkInformationExchangeFailureIEs_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _UplinkInformationExchangeFailureIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _UplinkInformationExchangeFailureIEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _UplinkInformationExchangeFailureIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    UplinkInformationExchangeFailureIEs._val = ASN1Set(rv=[dict([(u'id', 136), (u'criticality', u'ignore'), (u'Value', _UplinkInformationExchangeFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 3), (u'criticality', u'ignore'), (u'Value', _UplinkInformationExchangeFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 96), (u'criticality', u'ignore'), (u'Value', _UplinkInformationExchangeFailureIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _UplinkInformationExchangeFailureIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _UplinkInformationExchangeFailureIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UplinkInformationExchangeFailureExtensions >-----#
    UplinkInformationExchangeFailureExtensions = CLASS(name=u'UplinkInformationExchangeFailureExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    UplinkInformationExchangeFailureExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionStart >-----#
    MBMSSessionStart = SEQ(name=u'MBMSSessionStart', mode=MODE_TYPE)
    _MBMSSessionStart_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSSessionStart_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSSessionStart_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____MBMSSessionStart_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSSessionIdentity')))
    _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSBearerServiceType')))
    _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameters')))
    _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PDP-TypeInformation')))
    _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSSessionDuration')))
    _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSServiceArea')))
    _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_8 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'FrequenceLayerConvergenceFlag')))
    _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_9 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAListofIdleModeUEs')))
    _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_11 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSSessionRepetitionNumber')))
    _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_12 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TimeToMBMSDataTransfer')))
    ____MBMSSessionStart_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 153), (u'criticality', u'reject'), (u'Value', _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 147), (u'criticality', u'ignore'), (u'Value', _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 143), (u'criticality', u'reject'), (u'Value', _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 79), (u'criticality', u'reject'), (u'Value', _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 149), (u'criticality', u'reject'), (u'Value', _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 148), (u'criticality', u'ignore'), (u'Value', _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 146), (u'criticality', u'reject'), (u'Value', _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 145), (u'criticality', u'reject'), (u'Value', _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'mandatory')]), dict([(u'id', 135), (u'criticality', u'ignore'), (u'Value', _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 150), (u'criticality', u'ignore'), (u'Value', _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 96), (u'criticality', u'reject'), (u'Value', _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'ignore'), (u'Value', _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 163), (u'criticality', u'reject'), (u'Value', _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___MBMSSessionStart_protocolIEs__item__id._const_tab = ____MBMSSessionStart_protocolIEs__item__id_tab
    ___MBMSSessionStart_protocolIEs__item__id._const_tab_at = None
    ___MBMSSessionStart_protocolIEs__item__id._const_tab_id = u'id'
    ___MBMSSessionStart_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___MBMSSessionStart_protocolIEs__item__criticality._const_tab = ____MBMSSessionStart_protocolIEs__item__id_tab
    ___MBMSSessionStart_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSSessionStart_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MBMSSessionStart_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___MBMSSessionStart_protocolIEs__item__value._const_tab = ____MBMSSessionStart_protocolIEs__item__id_tab
    ___MBMSSessionStart_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MBMSSessionStart_protocolIEs__item__value._const_tab_id = u'Value'
    __MBMSSessionStart_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MBMSSessionStart_protocolIEs__item__id),
        (u'criticality', ___MBMSSessionStart_protocolIEs__item__criticality),
        (u'value', ___MBMSSessionStart_protocolIEs__item__value),
        ])
    __MBMSSessionStart_protocolIEs__item_._ext = None
    _MBMSSessionStart_protocolIEs._cont = __MBMSSessionStart_protocolIEs__item_
    _MBMSSessionStart_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSSessionStart_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSSessionStart_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSSessionStart_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMSSessionStart_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____MBMSSessionStart_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSCountingInformation')))
    _____MBMSSessionStart_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSynchronisationInformation')))
    _____MBMSSessionStart_protocolExtensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PDP-TypeInformation-extension')))
    _____MBMSSessionStart_protocolExtensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Session-Re-establishment-Indicator')))
    ____MBMSSessionStart_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 169), (u'criticality', u'ignore'), (u'Extension', _____MBMSSessionStart_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 201), (u'criticality', u'ignore'), (u'Extension', _____MBMSSessionStart_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 238), (u'criticality', u'ignore'), (u'Extension', _____MBMSSessionStart_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 276), (u'criticality', u'ignore'), (u'Extension', _____MBMSSessionStart_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MBMSSessionStart_protocolExtensions__item__id._const_tab = ____MBMSSessionStart_protocolExtensions__item__id_tab
    ___MBMSSessionStart_protocolExtensions__item__id._const_tab_at = None
    ___MBMSSessionStart_protocolExtensions__item__id._const_tab_id = u'id'
    ___MBMSSessionStart_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___MBMSSessionStart_protocolExtensions__item__criticality._const_tab = ____MBMSSessionStart_protocolExtensions__item__id_tab
    ___MBMSSessionStart_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSSessionStart_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___MBMSSessionStart_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___MBMSSessionStart_protocolExtensions__item__extensionValue._const_tab = ____MBMSSessionStart_protocolExtensions__item__id_tab
    ___MBMSSessionStart_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMSSessionStart_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMSSessionStart_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___MBMSSessionStart_protocolExtensions__item__id),
        (u'criticality', ___MBMSSessionStart_protocolExtensions__item__criticality),
        (u'extensionValue', ___MBMSSessionStart_protocolExtensions__item__extensionValue),
        ])
    __MBMSSessionStart_protocolExtensions__item_._ext = None
    _MBMSSessionStart_protocolExtensions._cont = __MBMSSessionStart_protocolExtensions__item_
    _MBMSSessionStart_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSSessionStart._cont = ASN1Dict([
        (u'protocolIEs', _MBMSSessionStart_protocolIEs),
        (u'protocolExtensions', _MBMSSessionStart_protocolExtensions),
        ])
    MBMSSessionStart._ext = []
    
    #-----< MBMSSessionStartIEs >-----#
    MBMSSessionStartIEs = CLASS(name=u'MBMSSessionStartIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSSessionStartIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    _MBMSSessionStartIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSSessionIdentity')))
    _MBMSSessionStartIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSBearerServiceType')))
    _MBMSSessionStartIEs_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _MBMSSessionStartIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameters')))
    _MBMSSessionStartIEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PDP-TypeInformation')))
    _MBMSSessionStartIEs_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSSessionDuration')))
    _MBMSSessionStartIEs_val_Value_7 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSServiceArea')))
    _MBMSSessionStartIEs_val_Value_8 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'FrequenceLayerConvergenceFlag')))
    _MBMSSessionStartIEs_val_Value_9 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAListofIdleModeUEs')))
    _MBMSSessionStartIEs_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _MBMSSessionStartIEs_val_Value_11 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSSessionRepetitionNumber')))
    _MBMSSessionStartIEs_val_Value_12 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TimeToMBMSDataTransfer')))
    MBMSSessionStartIEs._val = ASN1Set(rv=[dict([(u'id', 153), (u'criticality', u'reject'), (u'Value', _MBMSSessionStartIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 147), (u'criticality', u'ignore'), (u'Value', _MBMSSessionStartIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 143), (u'criticality', u'reject'), (u'Value', _MBMSSessionStartIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 79), (u'criticality', u'reject'), (u'Value', _MBMSSessionStartIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 149), (u'criticality', u'reject'), (u'Value', _MBMSSessionStartIEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 148), (u'criticality', u'ignore'), (u'Value', _MBMSSessionStartIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 146), (u'criticality', u'reject'), (u'Value', _MBMSSessionStartIEs_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 145), (u'criticality', u'reject'), (u'Value', _MBMSSessionStartIEs_val_Value_7), (u'presence', u'mandatory')]), dict([(u'id', 135), (u'criticality', u'ignore'), (u'Value', _MBMSSessionStartIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 150), (u'criticality', u'ignore'), (u'Value', _MBMSSessionStartIEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 96), (u'criticality', u'reject'), (u'Value', _MBMSSessionStartIEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'ignore'), (u'Value', _MBMSSessionStartIEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 163), (u'criticality', u'reject'), (u'Value', _MBMSSessionStartIEs_val_Value_12), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionStartExtensions >-----#
    MBMSSessionStartExtensions = CLASS(name=u'MBMSSessionStartExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _MBMSSessionStartExtensions_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSCountingInformation')))
    _MBMSSessionStartExtensions_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSynchronisationInformation')))
    _MBMSSessionStartExtensions_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PDP-TypeInformation-extension')))
    _MBMSSessionStartExtensions_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Session-Re-establishment-Indicator')))
    MBMSSessionStartExtensions._val = ASN1Set(rv=[dict([(u'id', 169), (u'criticality', u'ignore'), (u'Extension', _MBMSSessionStartExtensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 201), (u'criticality', u'ignore'), (u'Extension', _MBMSSessionStartExtensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 238), (u'criticality', u'ignore'), (u'Extension', _MBMSSessionStartExtensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 276), (u'criticality', u'ignore'), (u'Extension', _MBMSSessionStartExtensions_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSSynchronisationInformation >-----#
    MBMSSynchronisationInformation = SEQ(name=u'MBMSSynchronisationInformation', mode=MODE_TYPE)
    _MBMSSynchronisationInformation_mBMSHCIndicator = ENUM(name=u'mBMSHCIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'MBMSHCIndicator')))
    _MBMSSynchronisationInformation_iPMulticastAddress = OCT_STR(name=u'iPMulticastAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IPMulticastAddress')))
    _MBMSSynchronisationInformation_gTPDLTEID = OCT_STR(name=u'gTPDLTEID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GTP-TEI')))
    _MBMSSynchronisationInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSSynchronisationInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSSynchronisationInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMSSynchronisationInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____MBMSSynchronisationInformation_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IPMulticastAddress')))
    ____MBMSSynchronisationInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 236), (u'criticality', u'reject'), (u'Extension', _____MBMSSynchronisationInformation_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MBMSSynchronisationInformation_iE_Extensions__item__id._const_tab = ____MBMSSynchronisationInformation_iE_Extensions__item__id_tab
    ___MBMSSynchronisationInformation_iE_Extensions__item__id._const_tab_at = None
    ___MBMSSynchronisationInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___MBMSSynchronisationInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___MBMSSynchronisationInformation_iE_Extensions__item__criticality._const_tab = ____MBMSSynchronisationInformation_iE_Extensions__item__id_tab
    ___MBMSSynchronisationInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSSynchronisationInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MBMSSynchronisationInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___MBMSSynchronisationInformation_iE_Extensions__item__extensionValue._const_tab = ____MBMSSynchronisationInformation_iE_Extensions__item__id_tab
    ___MBMSSynchronisationInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMSSynchronisationInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMSSynchronisationInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MBMSSynchronisationInformation_iE_Extensions__item__id),
        (u'criticality', ___MBMSSynchronisationInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___MBMSSynchronisationInformation_iE_Extensions__item__extensionValue),
        ])
    __MBMSSynchronisationInformation_iE_Extensions__item_._ext = None
    _MBMSSynchronisationInformation_iE_Extensions._cont = __MBMSSynchronisationInformation_iE_Extensions__item_
    _MBMSSynchronisationInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSSynchronisationInformation._cont = ASN1Dict([
        (u'mBMSHCIndicator', _MBMSSynchronisationInformation_mBMSHCIndicator),
        (u'iPMulticastAddress', _MBMSSynchronisationInformation_iPMulticastAddress),
        (u'gTPDLTEID', _MBMSSynchronisationInformation_gTPDLTEID),
        (u'iE-Extensions', _MBMSSynchronisationInformation_iE_Extensions),
        ])
    MBMSSynchronisationInformation._ext = []
    
    #-----< MBMSSynchronisationInformation-ExtIEs >-----#
    MBMSSynchronisationInformation_ExtIEs = CLASS(name=u'MBMSSynchronisationInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _MBMSSynchronisationInformation_ExtIEs_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IPMulticastAddress')))
    MBMSSynchronisationInformation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 236), (u'criticality', u'reject'), (u'Extension', _MBMSSynchronisationInformation_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionStartResponse >-----#
    MBMSSessionStartResponse = SEQ(name=u'MBMSSessionStartResponse', mode=MODE_TYPE)
    _MBMSSessionStartResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSSessionStartResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSSessionStartResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____MBMSSessionStartResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSSessionStartResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'TransportLayerInformation')))
    _____MBMSSessionStartResponse_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____MBMSSessionStartResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____MBMSSessionStartResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 154), (u'criticality', u'ignore'), (u'Value', _____MBMSSessionStartResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____MBMSSessionStartResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____MBMSSessionStartResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MBMSSessionStartResponse_protocolIEs__item__id._const_tab = ____MBMSSessionStartResponse_protocolIEs__item__id_tab
    ___MBMSSessionStartResponse_protocolIEs__item__id._const_tab_at = None
    ___MBMSSessionStartResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___MBMSSessionStartResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___MBMSSessionStartResponse_protocolIEs__item__criticality._const_tab = ____MBMSSessionStartResponse_protocolIEs__item__id_tab
    ___MBMSSessionStartResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSSessionStartResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MBMSSessionStartResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___MBMSSessionStartResponse_protocolIEs__item__value._const_tab = ____MBMSSessionStartResponse_protocolIEs__item__id_tab
    ___MBMSSessionStartResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MBMSSessionStartResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __MBMSSessionStartResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MBMSSessionStartResponse_protocolIEs__item__id),
        (u'criticality', ___MBMSSessionStartResponse_protocolIEs__item__criticality),
        (u'value', ___MBMSSessionStartResponse_protocolIEs__item__value),
        ])
    __MBMSSessionStartResponse_protocolIEs__item_._ext = None
    _MBMSSessionStartResponse_protocolIEs._cont = __MBMSSessionStartResponse_protocolIEs__item_
    _MBMSSessionStartResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSSessionStartResponse_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSSessionStartResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSSessionStartResponse_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMSSessionStartResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionStartResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionStartResponse_protocolExtensions__item__id._const_tab = ____MBMSSessionStartResponse_protocolExtensions__item__id_tab
    ___MBMSSessionStartResponse_protocolExtensions__item__id._const_tab_at = None
    ___MBMSSessionStartResponse_protocolExtensions__item__id._const_tab_id = u'id'
    ___MBMSSessionStartResponse_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMSSessionStartResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionStartResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionStartResponse_protocolExtensions__item__criticality._const_tab = ____MBMSSessionStartResponse_protocolExtensions__item__criticality_tab
    ___MBMSSessionStartResponse_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSSessionStartResponse_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___MBMSSessionStartResponse_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMSSessionStartResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionStartResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionStartResponse_protocolExtensions__item__extensionValue._const_tab = ____MBMSSessionStartResponse_protocolExtensions__item__extensionValue_tab
    ___MBMSSessionStartResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMSSessionStartResponse_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMSSessionStartResponse_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___MBMSSessionStartResponse_protocolExtensions__item__id),
        (u'criticality', ___MBMSSessionStartResponse_protocolExtensions__item__criticality),
        (u'extensionValue', ___MBMSSessionStartResponse_protocolExtensions__item__extensionValue),
        ])
    __MBMSSessionStartResponse_protocolExtensions__item_._ext = None
    _MBMSSessionStartResponse_protocolExtensions._cont = __MBMSSessionStartResponse_protocolExtensions__item_
    _MBMSSessionStartResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSSessionStartResponse._cont = ASN1Dict([
        (u'protocolIEs', _MBMSSessionStartResponse_protocolIEs),
        (u'protocolExtensions', _MBMSSessionStartResponse_protocolExtensions),
        ])
    MBMSSessionStartResponse._ext = []
    
    #-----< MBMSSessionStartResponseIEs >-----#
    MBMSSessionStartResponseIEs = CLASS(name=u'MBMSSessionStartResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSSessionStartResponseIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'TransportLayerInformation')))
    _MBMSSessionStartResponseIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _MBMSSessionStartResponseIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    MBMSSessionStartResponseIEs._val = ASN1Set(rv=[dict([(u'id', 154), (u'criticality', u'ignore'), (u'Value', _MBMSSessionStartResponseIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _MBMSSessionStartResponseIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _MBMSSessionStartResponseIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionStartResponseExtensions >-----#
    MBMSSessionStartResponseExtensions = CLASS(name=u'MBMSSessionStartResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSSessionStartResponseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionStartFailure >-----#
    MBMSSessionStartFailure = SEQ(name=u'MBMSSessionStartFailure', mode=MODE_TYPE)
    _MBMSSessionStartFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSSessionStartFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSSessionStartFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____MBMSSessionStartFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSSessionStartFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____MBMSSessionStartFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____MBMSSessionStartFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____MBMSSessionStartFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____MBMSSessionStartFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MBMSSessionStartFailure_protocolIEs__item__id._const_tab = ____MBMSSessionStartFailure_protocolIEs__item__id_tab
    ___MBMSSessionStartFailure_protocolIEs__item__id._const_tab_at = None
    ___MBMSSessionStartFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___MBMSSessionStartFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___MBMSSessionStartFailure_protocolIEs__item__criticality._const_tab = ____MBMSSessionStartFailure_protocolIEs__item__id_tab
    ___MBMSSessionStartFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSSessionStartFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MBMSSessionStartFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___MBMSSessionStartFailure_protocolIEs__item__value._const_tab = ____MBMSSessionStartFailure_protocolIEs__item__id_tab
    ___MBMSSessionStartFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MBMSSessionStartFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __MBMSSessionStartFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MBMSSessionStartFailure_protocolIEs__item__id),
        (u'criticality', ___MBMSSessionStartFailure_protocolIEs__item__criticality),
        (u'value', ___MBMSSessionStartFailure_protocolIEs__item__value),
        ])
    __MBMSSessionStartFailure_protocolIEs__item_._ext = None
    _MBMSSessionStartFailure_protocolIEs._cont = __MBMSSessionStartFailure_protocolIEs__item_
    _MBMSSessionStartFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSSessionStartFailure_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSSessionStartFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSSessionStartFailure_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMSSessionStartFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionStartFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionStartFailure_protocolExtensions__item__id._const_tab = ____MBMSSessionStartFailure_protocolExtensions__item__id_tab
    ___MBMSSessionStartFailure_protocolExtensions__item__id._const_tab_at = None
    ___MBMSSessionStartFailure_protocolExtensions__item__id._const_tab_id = u'id'
    ___MBMSSessionStartFailure_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMSSessionStartFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionStartFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionStartFailure_protocolExtensions__item__criticality._const_tab = ____MBMSSessionStartFailure_protocolExtensions__item__criticality_tab
    ___MBMSSessionStartFailure_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSSessionStartFailure_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___MBMSSessionStartFailure_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMSSessionStartFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionStartFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionStartFailure_protocolExtensions__item__extensionValue._const_tab = ____MBMSSessionStartFailure_protocolExtensions__item__extensionValue_tab
    ___MBMSSessionStartFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMSSessionStartFailure_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMSSessionStartFailure_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___MBMSSessionStartFailure_protocolExtensions__item__id),
        (u'criticality', ___MBMSSessionStartFailure_protocolExtensions__item__criticality),
        (u'extensionValue', ___MBMSSessionStartFailure_protocolExtensions__item__extensionValue),
        ])
    __MBMSSessionStartFailure_protocolExtensions__item_._ext = None
    _MBMSSessionStartFailure_protocolExtensions._cont = __MBMSSessionStartFailure_protocolExtensions__item_
    _MBMSSessionStartFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSSessionStartFailure._cont = ASN1Dict([
        (u'protocolIEs', _MBMSSessionStartFailure_protocolIEs),
        (u'protocolExtensions', _MBMSSessionStartFailure_protocolExtensions),
        ])
    MBMSSessionStartFailure._ext = []
    
    #-----< MBMSSessionStartFailureIEs >-----#
    MBMSSessionStartFailureIEs = CLASS(name=u'MBMSSessionStartFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSSessionStartFailureIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _MBMSSessionStartFailureIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    MBMSSessionStartFailureIEs._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _MBMSSessionStartFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _MBMSSessionStartFailureIEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionStartFailureExtensions >-----#
    MBMSSessionStartFailureExtensions = CLASS(name=u'MBMSSessionStartFailureExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSSessionStartFailureExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionUpdate >-----#
    MBMSSessionUpdate = SEQ(name=u'MBMSSessionUpdate', mode=MODE_TYPE)
    _MBMSSessionUpdate_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSSessionUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSSessionUpdate_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____MBMSSessionUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSSessionUpdate_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SessionUpdateID')))
    _____MBMSSessionUpdate_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'DeltaRAListofIdleModeUEs')))
    ____MBMSSessionUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 152), (u'criticality', u'reject'), (u'Value', _____MBMSSessionUpdate_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 134), (u'criticality', u'reject'), (u'Value', _____MBMSSessionUpdate_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___MBMSSessionUpdate_protocolIEs__item__id._const_tab = ____MBMSSessionUpdate_protocolIEs__item__id_tab
    ___MBMSSessionUpdate_protocolIEs__item__id._const_tab_at = None
    ___MBMSSessionUpdate_protocolIEs__item__id._const_tab_id = u'id'
    ___MBMSSessionUpdate_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___MBMSSessionUpdate_protocolIEs__item__criticality._const_tab = ____MBMSSessionUpdate_protocolIEs__item__id_tab
    ___MBMSSessionUpdate_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSSessionUpdate_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MBMSSessionUpdate_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___MBMSSessionUpdate_protocolIEs__item__value._const_tab = ____MBMSSessionUpdate_protocolIEs__item__id_tab
    ___MBMSSessionUpdate_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MBMSSessionUpdate_protocolIEs__item__value._const_tab_id = u'Value'
    __MBMSSessionUpdate_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MBMSSessionUpdate_protocolIEs__item__id),
        (u'criticality', ___MBMSSessionUpdate_protocolIEs__item__criticality),
        (u'value', ___MBMSSessionUpdate_protocolIEs__item__value),
        ])
    __MBMSSessionUpdate_protocolIEs__item_._ext = None
    _MBMSSessionUpdate_protocolIEs._cont = __MBMSSessionUpdate_protocolIEs__item_
    _MBMSSessionUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSSessionUpdate_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSSessionUpdate_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSSessionUpdate_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMSSessionUpdate_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionUpdate_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionUpdate_protocolExtensions__item__id._const_tab = ____MBMSSessionUpdate_protocolExtensions__item__id_tab
    ___MBMSSessionUpdate_protocolExtensions__item__id._const_tab_at = None
    ___MBMSSessionUpdate_protocolExtensions__item__id._const_tab_id = u'id'
    ___MBMSSessionUpdate_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMSSessionUpdate_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionUpdate_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionUpdate_protocolExtensions__item__criticality._const_tab = ____MBMSSessionUpdate_protocolExtensions__item__criticality_tab
    ___MBMSSessionUpdate_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSSessionUpdate_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___MBMSSessionUpdate_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMSSessionUpdate_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionUpdate_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionUpdate_protocolExtensions__item__extensionValue._const_tab = ____MBMSSessionUpdate_protocolExtensions__item__extensionValue_tab
    ___MBMSSessionUpdate_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMSSessionUpdate_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMSSessionUpdate_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___MBMSSessionUpdate_protocolExtensions__item__id),
        (u'criticality', ___MBMSSessionUpdate_protocolExtensions__item__criticality),
        (u'extensionValue', ___MBMSSessionUpdate_protocolExtensions__item__extensionValue),
        ])
    __MBMSSessionUpdate_protocolExtensions__item_._ext = None
    _MBMSSessionUpdate_protocolExtensions._cont = __MBMSSessionUpdate_protocolExtensions__item_
    _MBMSSessionUpdate_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSSessionUpdate._cont = ASN1Dict([
        (u'protocolIEs', _MBMSSessionUpdate_protocolIEs),
        (u'protocolExtensions', _MBMSSessionUpdate_protocolExtensions),
        ])
    MBMSSessionUpdate._ext = []
    
    #-----< MBMSSessionUpdateIEs >-----#
    MBMSSessionUpdateIEs = CLASS(name=u'MBMSSessionUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSSessionUpdateIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SessionUpdateID')))
    _MBMSSessionUpdateIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'DeltaRAListofIdleModeUEs')))
    MBMSSessionUpdateIEs._val = ASN1Set(rv=[dict([(u'id', 152), (u'criticality', u'reject'), (u'Value', _MBMSSessionUpdateIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 134), (u'criticality', u'reject'), (u'Value', _MBMSSessionUpdateIEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionUpdateExtensions >-----#
    MBMSSessionUpdateExtensions = CLASS(name=u'MBMSSessionUpdateExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSSessionUpdateExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionUpdateResponse >-----#
    MBMSSessionUpdateResponse = SEQ(name=u'MBMSSessionUpdateResponse', mode=MODE_TYPE)
    _MBMSSessionUpdateResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSSessionUpdateResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSSessionUpdateResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____MBMSSessionUpdateResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SessionUpdateID')))
    _____MBMSSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'TransportLayerInformation')))
    _____MBMSSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____MBMSSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____MBMSSessionUpdateResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 152), (u'criticality', u'ignore'), (u'Value', _____MBMSSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 154), (u'criticality', u'ignore'), (u'Value', _____MBMSSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____MBMSSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____MBMSSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MBMSSessionUpdateResponse_protocolIEs__item__id._const_tab = ____MBMSSessionUpdateResponse_protocolIEs__item__id_tab
    ___MBMSSessionUpdateResponse_protocolIEs__item__id._const_tab_at = None
    ___MBMSSessionUpdateResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___MBMSSessionUpdateResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___MBMSSessionUpdateResponse_protocolIEs__item__criticality._const_tab = ____MBMSSessionUpdateResponse_protocolIEs__item__id_tab
    ___MBMSSessionUpdateResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSSessionUpdateResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MBMSSessionUpdateResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___MBMSSessionUpdateResponse_protocolIEs__item__value._const_tab = ____MBMSSessionUpdateResponse_protocolIEs__item__id_tab
    ___MBMSSessionUpdateResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MBMSSessionUpdateResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __MBMSSessionUpdateResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MBMSSessionUpdateResponse_protocolIEs__item__id),
        (u'criticality', ___MBMSSessionUpdateResponse_protocolIEs__item__criticality),
        (u'value', ___MBMSSessionUpdateResponse_protocolIEs__item__value),
        ])
    __MBMSSessionUpdateResponse_protocolIEs__item_._ext = None
    _MBMSSessionUpdateResponse_protocolIEs._cont = __MBMSSessionUpdateResponse_protocolIEs__item_
    _MBMSSessionUpdateResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSSessionUpdateResponse_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSSessionUpdateResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSSessionUpdateResponse_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMSSessionUpdateResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionUpdateResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionUpdateResponse_protocolExtensions__item__id._const_tab = ____MBMSSessionUpdateResponse_protocolExtensions__item__id_tab
    ___MBMSSessionUpdateResponse_protocolExtensions__item__id._const_tab_at = None
    ___MBMSSessionUpdateResponse_protocolExtensions__item__id._const_tab_id = u'id'
    ___MBMSSessionUpdateResponse_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMSSessionUpdateResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionUpdateResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionUpdateResponse_protocolExtensions__item__criticality._const_tab = ____MBMSSessionUpdateResponse_protocolExtensions__item__criticality_tab
    ___MBMSSessionUpdateResponse_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSSessionUpdateResponse_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___MBMSSessionUpdateResponse_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMSSessionUpdateResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionUpdateResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionUpdateResponse_protocolExtensions__item__extensionValue._const_tab = ____MBMSSessionUpdateResponse_protocolExtensions__item__extensionValue_tab
    ___MBMSSessionUpdateResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMSSessionUpdateResponse_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMSSessionUpdateResponse_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___MBMSSessionUpdateResponse_protocolExtensions__item__id),
        (u'criticality', ___MBMSSessionUpdateResponse_protocolExtensions__item__criticality),
        (u'extensionValue', ___MBMSSessionUpdateResponse_protocolExtensions__item__extensionValue),
        ])
    __MBMSSessionUpdateResponse_protocolExtensions__item_._ext = None
    _MBMSSessionUpdateResponse_protocolExtensions._cont = __MBMSSessionUpdateResponse_protocolExtensions__item_
    _MBMSSessionUpdateResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSSessionUpdateResponse._cont = ASN1Dict([
        (u'protocolIEs', _MBMSSessionUpdateResponse_protocolIEs),
        (u'protocolExtensions', _MBMSSessionUpdateResponse_protocolExtensions),
        ])
    MBMSSessionUpdateResponse._ext = []
    
    #-----< MBMSSessionUpdateResponseIEs >-----#
    MBMSSessionUpdateResponseIEs = CLASS(name=u'MBMSSessionUpdateResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSSessionUpdateResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SessionUpdateID')))
    _MBMSSessionUpdateResponseIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'TransportLayerInformation')))
    _MBMSSessionUpdateResponseIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _MBMSSessionUpdateResponseIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    MBMSSessionUpdateResponseIEs._val = ASN1Set(rv=[dict([(u'id', 152), (u'criticality', u'ignore'), (u'Value', _MBMSSessionUpdateResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 154), (u'criticality', u'ignore'), (u'Value', _MBMSSessionUpdateResponseIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _MBMSSessionUpdateResponseIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _MBMSSessionUpdateResponseIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionUpdateResponseExtensions >-----#
    MBMSSessionUpdateResponseExtensions = CLASS(name=u'MBMSSessionUpdateResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSSessionUpdateResponseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionUpdateFailure >-----#
    MBMSSessionUpdateFailure = SEQ(name=u'MBMSSessionUpdateFailure', mode=MODE_TYPE)
    _MBMSSessionUpdateFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSSessionUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSSessionUpdateFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____MBMSSessionUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SessionUpdateID')))
    _____MBMSSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____MBMSSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____MBMSSessionUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 152), (u'criticality', u'ignore'), (u'Value', _____MBMSSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____MBMSSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____MBMSSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MBMSSessionUpdateFailure_protocolIEs__item__id._const_tab = ____MBMSSessionUpdateFailure_protocolIEs__item__id_tab
    ___MBMSSessionUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___MBMSSessionUpdateFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___MBMSSessionUpdateFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___MBMSSessionUpdateFailure_protocolIEs__item__criticality._const_tab = ____MBMSSessionUpdateFailure_protocolIEs__item__id_tab
    ___MBMSSessionUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSSessionUpdateFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MBMSSessionUpdateFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___MBMSSessionUpdateFailure_protocolIEs__item__value._const_tab = ____MBMSSessionUpdateFailure_protocolIEs__item__id_tab
    ___MBMSSessionUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MBMSSessionUpdateFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __MBMSSessionUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MBMSSessionUpdateFailure_protocolIEs__item__id),
        (u'criticality', ___MBMSSessionUpdateFailure_protocolIEs__item__criticality),
        (u'value', ___MBMSSessionUpdateFailure_protocolIEs__item__value),
        ])
    __MBMSSessionUpdateFailure_protocolIEs__item_._ext = None
    _MBMSSessionUpdateFailure_protocolIEs._cont = __MBMSSessionUpdateFailure_protocolIEs__item_
    _MBMSSessionUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSSessionUpdateFailure_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSSessionUpdateFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSSessionUpdateFailure_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMSSessionUpdateFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionUpdateFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionUpdateFailure_protocolExtensions__item__id._const_tab = ____MBMSSessionUpdateFailure_protocolExtensions__item__id_tab
    ___MBMSSessionUpdateFailure_protocolExtensions__item__id._const_tab_at = None
    ___MBMSSessionUpdateFailure_protocolExtensions__item__id._const_tab_id = u'id'
    ___MBMSSessionUpdateFailure_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMSSessionUpdateFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionUpdateFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionUpdateFailure_protocolExtensions__item__criticality._const_tab = ____MBMSSessionUpdateFailure_protocolExtensions__item__criticality_tab
    ___MBMSSessionUpdateFailure_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSSessionUpdateFailure_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___MBMSSessionUpdateFailure_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMSSessionUpdateFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionUpdateFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionUpdateFailure_protocolExtensions__item__extensionValue._const_tab = ____MBMSSessionUpdateFailure_protocolExtensions__item__extensionValue_tab
    ___MBMSSessionUpdateFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMSSessionUpdateFailure_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMSSessionUpdateFailure_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___MBMSSessionUpdateFailure_protocolExtensions__item__id),
        (u'criticality', ___MBMSSessionUpdateFailure_protocolExtensions__item__criticality),
        (u'extensionValue', ___MBMSSessionUpdateFailure_protocolExtensions__item__extensionValue),
        ])
    __MBMSSessionUpdateFailure_protocolExtensions__item_._ext = None
    _MBMSSessionUpdateFailure_protocolExtensions._cont = __MBMSSessionUpdateFailure_protocolExtensions__item_
    _MBMSSessionUpdateFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSSessionUpdateFailure._cont = ASN1Dict([
        (u'protocolIEs', _MBMSSessionUpdateFailure_protocolIEs),
        (u'protocolExtensions', _MBMSSessionUpdateFailure_protocolExtensions),
        ])
    MBMSSessionUpdateFailure._ext = []
    
    #-----< MBMSSessionUpdateFailureIEs >-----#
    MBMSSessionUpdateFailureIEs = CLASS(name=u'MBMSSessionUpdateFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSSessionUpdateFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SessionUpdateID')))
    _MBMSSessionUpdateFailureIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _MBMSSessionUpdateFailureIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    MBMSSessionUpdateFailureIEs._val = ASN1Set(rv=[dict([(u'id', 152), (u'criticality', u'ignore'), (u'Value', _MBMSSessionUpdateFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _MBMSSessionUpdateFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _MBMSSessionUpdateFailureIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionUpdateFailureExtensions >-----#
    MBMSSessionUpdateFailureExtensions = CLASS(name=u'MBMSSessionUpdateFailureExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSSessionUpdateFailureExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionStop >-----#
    MBMSSessionStop = SEQ(name=u'MBMSSessionStop', mode=MODE_TYPE)
    _MBMSSessionStop_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSSessionStop_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSSessionStop_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____MBMSSessionStop_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSSessionStop_protocolIEs__item__id_tab_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSCNDe-Registration')))
    ____MBMSSessionStop_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 144), (u'criticality', u'reject'), (u'Value', _____MBMSSessionStop_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___MBMSSessionStop_protocolIEs__item__id._const_tab = ____MBMSSessionStop_protocolIEs__item__id_tab
    ___MBMSSessionStop_protocolIEs__item__id._const_tab_at = None
    ___MBMSSessionStop_protocolIEs__item__id._const_tab_id = u'id'
    ___MBMSSessionStop_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___MBMSSessionStop_protocolIEs__item__criticality._const_tab = ____MBMSSessionStop_protocolIEs__item__id_tab
    ___MBMSSessionStop_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSSessionStop_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MBMSSessionStop_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___MBMSSessionStop_protocolIEs__item__value._const_tab = ____MBMSSessionStop_protocolIEs__item__id_tab
    ___MBMSSessionStop_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MBMSSessionStop_protocolIEs__item__value._const_tab_id = u'Value'
    __MBMSSessionStop_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MBMSSessionStop_protocolIEs__item__id),
        (u'criticality', ___MBMSSessionStop_protocolIEs__item__criticality),
        (u'value', ___MBMSSessionStop_protocolIEs__item__value),
        ])
    __MBMSSessionStop_protocolIEs__item_._ext = None
    _MBMSSessionStop_protocolIEs._cont = __MBMSSessionStop_protocolIEs__item_
    _MBMSSessionStop_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSSessionStop_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSSessionStop_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSSessionStop_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMSSessionStop_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionStop_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionStop_protocolExtensions__item__id._const_tab = ____MBMSSessionStop_protocolExtensions__item__id_tab
    ___MBMSSessionStop_protocolExtensions__item__id._const_tab_at = None
    ___MBMSSessionStop_protocolExtensions__item__id._const_tab_id = u'id'
    ___MBMSSessionStop_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMSSessionStop_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionStop_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionStop_protocolExtensions__item__criticality._const_tab = ____MBMSSessionStop_protocolExtensions__item__criticality_tab
    ___MBMSSessionStop_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSSessionStop_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___MBMSSessionStop_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMSSessionStop_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionStop_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionStop_protocolExtensions__item__extensionValue._const_tab = ____MBMSSessionStop_protocolExtensions__item__extensionValue_tab
    ___MBMSSessionStop_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMSSessionStop_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMSSessionStop_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___MBMSSessionStop_protocolExtensions__item__id),
        (u'criticality', ___MBMSSessionStop_protocolExtensions__item__criticality),
        (u'extensionValue', ___MBMSSessionStop_protocolExtensions__item__extensionValue),
        ])
    __MBMSSessionStop_protocolExtensions__item_._ext = None
    _MBMSSessionStop_protocolExtensions._cont = __MBMSSessionStop_protocolExtensions__item_
    _MBMSSessionStop_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSSessionStop._cont = ASN1Dict([
        (u'protocolIEs', _MBMSSessionStop_protocolIEs),
        (u'protocolExtensions', _MBMSSessionStop_protocolExtensions),
        ])
    MBMSSessionStop._ext = []
    
    #-----< MBMSSessionStopIEs >-----#
    MBMSSessionStopIEs = CLASS(name=u'MBMSSessionStopIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSSessionStopIEs_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSCNDe-Registration')))
    MBMSSessionStopIEs._val = ASN1Set(rv=[dict([(u'id', 144), (u'criticality', u'reject'), (u'Value', _MBMSSessionStopIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionStopExtensions >-----#
    MBMSSessionStopExtensions = CLASS(name=u'MBMSSessionStopExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSSessionStopExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionStopResponse >-----#
    MBMSSessionStopResponse = SEQ(name=u'MBMSSessionStopResponse', mode=MODE_TYPE)
    _MBMSSessionStopResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSSessionStopResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSSessionStopResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____MBMSSessionStopResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSSessionStopResponse_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____MBMSSessionStopResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____MBMSSessionStopResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____MBMSSessionStopResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____MBMSSessionStopResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MBMSSessionStopResponse_protocolIEs__item__id._const_tab = ____MBMSSessionStopResponse_protocolIEs__item__id_tab
    ___MBMSSessionStopResponse_protocolIEs__item__id._const_tab_at = None
    ___MBMSSessionStopResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___MBMSSessionStopResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___MBMSSessionStopResponse_protocolIEs__item__criticality._const_tab = ____MBMSSessionStopResponse_protocolIEs__item__id_tab
    ___MBMSSessionStopResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSSessionStopResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MBMSSessionStopResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___MBMSSessionStopResponse_protocolIEs__item__value._const_tab = ____MBMSSessionStopResponse_protocolIEs__item__id_tab
    ___MBMSSessionStopResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MBMSSessionStopResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __MBMSSessionStopResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MBMSSessionStopResponse_protocolIEs__item__id),
        (u'criticality', ___MBMSSessionStopResponse_protocolIEs__item__criticality),
        (u'value', ___MBMSSessionStopResponse_protocolIEs__item__value),
        ])
    __MBMSSessionStopResponse_protocolIEs__item_._ext = None
    _MBMSSessionStopResponse_protocolIEs._cont = __MBMSSessionStopResponse_protocolIEs__item_
    _MBMSSessionStopResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSSessionStopResponse_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSSessionStopResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSSessionStopResponse_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMSSessionStopResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionStopResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionStopResponse_protocolExtensions__item__id._const_tab = ____MBMSSessionStopResponse_protocolExtensions__item__id_tab
    ___MBMSSessionStopResponse_protocolExtensions__item__id._const_tab_at = None
    ___MBMSSessionStopResponse_protocolExtensions__item__id._const_tab_id = u'id'
    ___MBMSSessionStopResponse_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMSSessionStopResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionStopResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionStopResponse_protocolExtensions__item__criticality._const_tab = ____MBMSSessionStopResponse_protocolExtensions__item__criticality_tab
    ___MBMSSessionStopResponse_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSSessionStopResponse_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___MBMSSessionStopResponse_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMSSessionStopResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionStopResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionStopResponse_protocolExtensions__item__extensionValue._const_tab = ____MBMSSessionStopResponse_protocolExtensions__item__extensionValue_tab
    ___MBMSSessionStopResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMSSessionStopResponse_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMSSessionStopResponse_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___MBMSSessionStopResponse_protocolExtensions__item__id),
        (u'criticality', ___MBMSSessionStopResponse_protocolExtensions__item__criticality),
        (u'extensionValue', ___MBMSSessionStopResponse_protocolExtensions__item__extensionValue),
        ])
    __MBMSSessionStopResponse_protocolExtensions__item_._ext = None
    _MBMSSessionStopResponse_protocolExtensions._cont = __MBMSSessionStopResponse_protocolExtensions__item_
    _MBMSSessionStopResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSSessionStopResponse._cont = ASN1Dict([
        (u'protocolIEs', _MBMSSessionStopResponse_protocolIEs),
        (u'protocolExtensions', _MBMSSessionStopResponse_protocolExtensions),
        ])
    MBMSSessionStopResponse._ext = []
    
    #-----< MBMSSessionStopResponseIEs >-----#
    MBMSSessionStopResponseIEs = CLASS(name=u'MBMSSessionStopResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSSessionStopResponseIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _MBMSSessionStopResponseIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    MBMSSessionStopResponseIEs._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _MBMSSessionStopResponseIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _MBMSSessionStopResponseIEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionStopResponseExtensions >-----#
    MBMSSessionStopResponseExtensions = CLASS(name=u'MBMSSessionStopResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSSessionStopResponseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSUELinkingRequest >-----#
    MBMSUELinkingRequest = SEQ(name=u'MBMSUELinkingRequest', mode=MODE_TYPE)
    _MBMSUELinkingRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSUELinkingRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSUELinkingRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____MBMSUELinkingRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSUELinkingRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'JoinedMBMSBearerService-IEs')))
    _____MBMSUELinkingRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LeftMBMSBearerService-IEs')))
    ____MBMSUELinkingRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 141), (u'criticality', u'reject'), (u'Value', _____MBMSUELinkingRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 142), (u'criticality', u'reject'), (u'Value', _____MBMSUELinkingRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MBMSUELinkingRequest_protocolIEs__item__id._const_tab = ____MBMSUELinkingRequest_protocolIEs__item__id_tab
    ___MBMSUELinkingRequest_protocolIEs__item__id._const_tab_at = None
    ___MBMSUELinkingRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___MBMSUELinkingRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___MBMSUELinkingRequest_protocolIEs__item__criticality._const_tab = ____MBMSUELinkingRequest_protocolIEs__item__id_tab
    ___MBMSUELinkingRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSUELinkingRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MBMSUELinkingRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___MBMSUELinkingRequest_protocolIEs__item__value._const_tab = ____MBMSUELinkingRequest_protocolIEs__item__id_tab
    ___MBMSUELinkingRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MBMSUELinkingRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __MBMSUELinkingRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MBMSUELinkingRequest_protocolIEs__item__id),
        (u'criticality', ___MBMSUELinkingRequest_protocolIEs__item__criticality),
        (u'value', ___MBMSUELinkingRequest_protocolIEs__item__value),
        ])
    __MBMSUELinkingRequest_protocolIEs__item_._ext = None
    _MBMSUELinkingRequest_protocolIEs._cont = __MBMSUELinkingRequest_protocolIEs__item_
    _MBMSUELinkingRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSUELinkingRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSUELinkingRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSUELinkingRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMSUELinkingRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSUELinkingRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSUELinkingRequest_protocolExtensions__item__id._const_tab = ____MBMSUELinkingRequest_protocolExtensions__item__id_tab
    ___MBMSUELinkingRequest_protocolExtensions__item__id._const_tab_at = None
    ___MBMSUELinkingRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___MBMSUELinkingRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMSUELinkingRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSUELinkingRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSUELinkingRequest_protocolExtensions__item__criticality._const_tab = ____MBMSUELinkingRequest_protocolExtensions__item__criticality_tab
    ___MBMSUELinkingRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSUELinkingRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___MBMSUELinkingRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMSUELinkingRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSUELinkingRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSUELinkingRequest_protocolExtensions__item__extensionValue._const_tab = ____MBMSUELinkingRequest_protocolExtensions__item__extensionValue_tab
    ___MBMSUELinkingRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMSUELinkingRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMSUELinkingRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___MBMSUELinkingRequest_protocolExtensions__item__id),
        (u'criticality', ___MBMSUELinkingRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___MBMSUELinkingRequest_protocolExtensions__item__extensionValue),
        ])
    __MBMSUELinkingRequest_protocolExtensions__item_._ext = None
    _MBMSUELinkingRequest_protocolExtensions._cont = __MBMSUELinkingRequest_protocolExtensions__item_
    _MBMSUELinkingRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSUELinkingRequest._cont = ASN1Dict([
        (u'protocolIEs', _MBMSUELinkingRequest_protocolIEs),
        (u'protocolExtensions', _MBMSUELinkingRequest_protocolExtensions),
        ])
    MBMSUELinkingRequest._ext = []
    
    #-----< MBMSUELinkingRequestIEs >-----#
    MBMSUELinkingRequestIEs = CLASS(name=u'MBMSUELinkingRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSUELinkingRequestIEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'JoinedMBMSBearerService-IEs')))
    _MBMSUELinkingRequestIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LeftMBMSBearerService-IEs')))
    MBMSUELinkingRequestIEs._val = ASN1Set(rv=[dict([(u'id', 141), (u'criticality', u'reject'), (u'Value', _MBMSUELinkingRequestIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 142), (u'criticality', u'reject'), (u'Value', _MBMSUELinkingRequestIEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< LeftMBMSBearerService-IEs >-----#
    LeftMBMSBearerService_IEs = SEQ_OF(name=u'LeftMBMSBearerService-IEs', mode=MODE_TYPE)
    _LeftMBMSBearerService_IEs__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __LeftMBMSBearerService_IEs__item__tMGI = SEQ(name=u'tMGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    __LeftMBMSBearerService_IEs__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___LeftMBMSBearerService_IEs__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    _____LeftMBMSBearerService_IEs__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____LeftMBMSBearerService_IEs__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__id._const_tab = _____LeftMBMSBearerService_IEs__item__iE_Extensions__item__id_tab
    ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__id._const_tab_at = None
    ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____LeftMBMSBearerService_IEs__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____LeftMBMSBearerService_IEs__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__criticality._const_tab = _____LeftMBMSBearerService_IEs__item__iE_Extensions__item__criticality_tab
    ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____LeftMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____LeftMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue._const_tab = _____LeftMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue_tab
    ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___LeftMBMSBearerService_IEs__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__id),
        (u'criticality', ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue),
        ])
    ___LeftMBMSBearerService_IEs__item__iE_Extensions__item_._ext = None
    __LeftMBMSBearerService_IEs__item__iE_Extensions._cont = ___LeftMBMSBearerService_IEs__item__iE_Extensions__item_
    __LeftMBMSBearerService_IEs__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _LeftMBMSBearerService_IEs__item_._cont = ASN1Dict([
        (u'tMGI', __LeftMBMSBearerService_IEs__item__tMGI),
        (u'iE-Extensions', __LeftMBMSBearerService_IEs__item__iE_Extensions),
        ])
    _LeftMBMSBearerService_IEs__item_._ext = []
    LeftMBMSBearerService_IEs._cont = _LeftMBMSBearerService_IEs__item_
    LeftMBMSBearerService_IEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< LeftMBMSBearerService-ExtIEs >-----#
    LeftMBMSBearerService_ExtIEs = CLASS(name=u'LeftMBMSBearerService-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    LeftMBMSBearerService_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSUELinkingRequestExtensions >-----#
    MBMSUELinkingRequestExtensions = CLASS(name=u'MBMSUELinkingRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSUELinkingRequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSUELinkingResponse >-----#
    MBMSUELinkingResponse = SEQ(name=u'MBMSUELinkingResponse', mode=MODE_TYPE)
    _MBMSUELinkingResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSUELinkingResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSUELinkingResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____MBMSUELinkingResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSUELinkingResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UnsuccessfulLinking-IEs')))
    _____MBMSUELinkingResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____MBMSUELinkingResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _____MBMSUELinkingResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____MBMSUELinkingResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MBMSUELinkingResponse_protocolIEs__item__id._const_tab = ____MBMSUELinkingResponse_protocolIEs__item__id_tab
    ___MBMSUELinkingResponse_protocolIEs__item__id._const_tab_at = None
    ___MBMSUELinkingResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___MBMSUELinkingResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___MBMSUELinkingResponse_protocolIEs__item__criticality._const_tab = ____MBMSUELinkingResponse_protocolIEs__item__id_tab
    ___MBMSUELinkingResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSUELinkingResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MBMSUELinkingResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___MBMSUELinkingResponse_protocolIEs__item__value._const_tab = ____MBMSUELinkingResponse_protocolIEs__item__id_tab
    ___MBMSUELinkingResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MBMSUELinkingResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __MBMSUELinkingResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MBMSUELinkingResponse_protocolIEs__item__id),
        (u'criticality', ___MBMSUELinkingResponse_protocolIEs__item__criticality),
        (u'value', ___MBMSUELinkingResponse_protocolIEs__item__value),
        ])
    __MBMSUELinkingResponse_protocolIEs__item_._ext = None
    _MBMSUELinkingResponse_protocolIEs._cont = __MBMSUELinkingResponse_protocolIEs__item_
    _MBMSUELinkingResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSUELinkingResponse_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSUELinkingResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSUELinkingResponse_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMSUELinkingResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSUELinkingResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSUELinkingResponse_protocolExtensions__item__id._const_tab = ____MBMSUELinkingResponse_protocolExtensions__item__id_tab
    ___MBMSUELinkingResponse_protocolExtensions__item__id._const_tab_at = None
    ___MBMSUELinkingResponse_protocolExtensions__item__id._const_tab_id = u'id'
    ___MBMSUELinkingResponse_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMSUELinkingResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSUELinkingResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSUELinkingResponse_protocolExtensions__item__criticality._const_tab = ____MBMSUELinkingResponse_protocolExtensions__item__criticality_tab
    ___MBMSUELinkingResponse_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSUELinkingResponse_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___MBMSUELinkingResponse_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMSUELinkingResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSUELinkingResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSUELinkingResponse_protocolExtensions__item__extensionValue._const_tab = ____MBMSUELinkingResponse_protocolExtensions__item__extensionValue_tab
    ___MBMSUELinkingResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMSUELinkingResponse_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMSUELinkingResponse_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___MBMSUELinkingResponse_protocolExtensions__item__id),
        (u'criticality', ___MBMSUELinkingResponse_protocolExtensions__item__criticality),
        (u'extensionValue', ___MBMSUELinkingResponse_protocolExtensions__item__extensionValue),
        ])
    __MBMSUELinkingResponse_protocolExtensions__item_._ext = None
    _MBMSUELinkingResponse_protocolExtensions._cont = __MBMSUELinkingResponse_protocolExtensions__item_
    _MBMSUELinkingResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSUELinkingResponse._cont = ASN1Dict([
        (u'protocolIEs', _MBMSUELinkingResponse_protocolIEs),
        (u'protocolExtensions', _MBMSUELinkingResponse_protocolExtensions),
        ])
    MBMSUELinkingResponse._ext = []
    
    #-----< MBMSUELinkingResponseIEs >-----#
    MBMSUELinkingResponseIEs = CLASS(name=u'MBMSUELinkingResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSUELinkingResponseIEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UnsuccessfulLinking-IEs')))
    _MBMSUELinkingResponseIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    MBMSUELinkingResponseIEs._val = ASN1Set(rv=[dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _MBMSUELinkingResponseIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _MBMSUELinkingResponseIEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UnsuccessfulLinking-IEs >-----#
    UnsuccessfulLinking_IEs = SEQ_OF(name=u'UnsuccessfulLinking-IEs', mode=MODE_TYPE)
    _UnsuccessfulLinking_IEs__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __UnsuccessfulLinking_IEs__item__tMGI = SEQ(name=u'tMGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    __UnsuccessfulLinking_IEs__item__cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    __UnsuccessfulLinking_IEs__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___UnsuccessfulLinking_IEs__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    _____UnsuccessfulLinking_IEs__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____UnsuccessfulLinking_IEs__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__id._const_tab = _____UnsuccessfulLinking_IEs__item__iE_Extensions__item__id_tab
    ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__id._const_tab_at = None
    ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____UnsuccessfulLinking_IEs__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____UnsuccessfulLinking_IEs__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__criticality._const_tab = _____UnsuccessfulLinking_IEs__item__iE_Extensions__item__criticality_tab
    ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____UnsuccessfulLinking_IEs__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____UnsuccessfulLinking_IEs__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__extensionValue._const_tab = _____UnsuccessfulLinking_IEs__item__iE_Extensions__item__extensionValue_tab
    ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___UnsuccessfulLinking_IEs__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__id),
        (u'criticality', ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__extensionValue),
        ])
    ___UnsuccessfulLinking_IEs__item__iE_Extensions__item_._ext = None
    __UnsuccessfulLinking_IEs__item__iE_Extensions._cont = ___UnsuccessfulLinking_IEs__item__iE_Extensions__item_
    __UnsuccessfulLinking_IEs__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _UnsuccessfulLinking_IEs__item_._cont = ASN1Dict([
        (u'tMGI', __UnsuccessfulLinking_IEs__item__tMGI),
        (u'cause', __UnsuccessfulLinking_IEs__item__cause),
        (u'iE-Extensions', __UnsuccessfulLinking_IEs__item__iE_Extensions),
        ])
    _UnsuccessfulLinking_IEs__item_._ext = []
    UnsuccessfulLinking_IEs._cont = _UnsuccessfulLinking_IEs__item_
    UnsuccessfulLinking_IEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< UnsuccessfulLinking-ExtIEs >-----#
    UnsuccessfulLinking_ExtIEs = CLASS(name=u'UnsuccessfulLinking-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    UnsuccessfulLinking_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSUELinkingResponseExtensions >-----#
    MBMSUELinkingResponseExtensions = CLASS(name=u'MBMSUELinkingResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSUELinkingResponseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSRegistrationRequest >-----#
    MBMSRegistrationRequest = SEQ(name=u'MBMSRegistrationRequest', mode=MODE_TYPE)
    _MBMSRegistrationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSRegistrationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSRegistrationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____MBMSRegistrationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSRegistrationRequestType')))
    _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IPMulticastAddress')))
    _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'APN')))
    _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ____MBMSRegistrationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 151), (u'criticality', u'reject'), (u'Value', _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 153), (u'criticality', u'reject'), (u'Value', _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 140), (u'criticality', u'reject'), (u'Value', _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'conditional')]), dict([(u'id', 132), (u'criticality', u'reject'), (u'Value', _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'conditional')]), dict([(u'id', 86), (u'criticality', u'reject'), (u'Value', _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MBMSRegistrationRequest_protocolIEs__item__id._const_tab = ____MBMSRegistrationRequest_protocolIEs__item__id_tab
    ___MBMSRegistrationRequest_protocolIEs__item__id._const_tab_at = None
    ___MBMSRegistrationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___MBMSRegistrationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___MBMSRegistrationRequest_protocolIEs__item__criticality._const_tab = ____MBMSRegistrationRequest_protocolIEs__item__id_tab
    ___MBMSRegistrationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSRegistrationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MBMSRegistrationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___MBMSRegistrationRequest_protocolIEs__item__value._const_tab = ____MBMSRegistrationRequest_protocolIEs__item__id_tab
    ___MBMSRegistrationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MBMSRegistrationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __MBMSRegistrationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MBMSRegistrationRequest_protocolIEs__item__id),
        (u'criticality', ___MBMSRegistrationRequest_protocolIEs__item__criticality),
        (u'value', ___MBMSRegistrationRequest_protocolIEs__item__value),
        ])
    __MBMSRegistrationRequest_protocolIEs__item_._ext = None
    _MBMSRegistrationRequest_protocolIEs._cont = __MBMSRegistrationRequest_protocolIEs__item_
    _MBMSRegistrationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSRegistrationRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSRegistrationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSRegistrationRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMSRegistrationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____MBMSRegistrationRequest_protocolExtensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ____MBMSRegistrationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _____MBMSRegistrationRequest_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MBMSRegistrationRequest_protocolExtensions__item__id._const_tab = ____MBMSRegistrationRequest_protocolExtensions__item__id_tab
    ___MBMSRegistrationRequest_protocolExtensions__item__id._const_tab_at = None
    ___MBMSRegistrationRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___MBMSRegistrationRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___MBMSRegistrationRequest_protocolExtensions__item__criticality._const_tab = ____MBMSRegistrationRequest_protocolExtensions__item__id_tab
    ___MBMSRegistrationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSRegistrationRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___MBMSRegistrationRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___MBMSRegistrationRequest_protocolExtensions__item__extensionValue._const_tab = ____MBMSRegistrationRequest_protocolExtensions__item__id_tab
    ___MBMSRegistrationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMSRegistrationRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMSRegistrationRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___MBMSRegistrationRequest_protocolExtensions__item__id),
        (u'criticality', ___MBMSRegistrationRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___MBMSRegistrationRequest_protocolExtensions__item__extensionValue),
        ])
    __MBMSRegistrationRequest_protocolExtensions__item_._ext = None
    _MBMSRegistrationRequest_protocolExtensions._cont = __MBMSRegistrationRequest_protocolExtensions__item_
    _MBMSRegistrationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSRegistrationRequest._cont = ASN1Dict([
        (u'protocolIEs', _MBMSRegistrationRequest_protocolIEs),
        (u'protocolExtensions', _MBMSRegistrationRequest_protocolExtensions),
        ])
    MBMSRegistrationRequest._ext = []
    
    #-----< MBMSRegistrationRequestIEs >-----#
    MBMSRegistrationRequestIEs = CLASS(name=u'MBMSRegistrationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSRegistrationRequestIEs_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSRegistrationRequestType')))
    _MBMSRegistrationRequestIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    _MBMSRegistrationRequestIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IPMulticastAddress')))
    _MBMSRegistrationRequestIEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'APN')))
    _MBMSRegistrationRequestIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    MBMSRegistrationRequestIEs._val = ASN1Set(rv=[dict([(u'id', 151), (u'criticality', u'reject'), (u'Value', _MBMSRegistrationRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 153), (u'criticality', u'reject'), (u'Value', _MBMSRegistrationRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 140), (u'criticality', u'reject'), (u'Value', _MBMSRegistrationRequestIEs_val_Value_2), (u'presence', u'conditional')]), dict([(u'id', 132), (u'criticality', u'reject'), (u'Value', _MBMSRegistrationRequestIEs_val_Value_3), (u'presence', u'conditional')]), dict([(u'id', 86), (u'criticality', u'reject'), (u'Value', _MBMSRegistrationRequestIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSRegistrationRequestExtensions >-----#
    MBMSRegistrationRequestExtensions = CLASS(name=u'MBMSRegistrationRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _MBMSRegistrationRequestExtensions_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    MBMSRegistrationRequestExtensions._val = ASN1Set(rv=[dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _MBMSRegistrationRequestExtensions_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSRegistrationResponse >-----#
    MBMSRegistrationResponse = SEQ(name=u'MBMSRegistrationResponse', mode=MODE_TYPE)
    _MBMSRegistrationResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSRegistrationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSRegistrationResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____MBMSRegistrationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSRegistrationResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    _____MBMSRegistrationResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____MBMSRegistrationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____MBMSRegistrationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 153), (u'criticality', u'ignore'), (u'Value', _____MBMSRegistrationResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 96), (u'criticality', u'ignore'), (u'Value', _____MBMSRegistrationResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____MBMSRegistrationResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MBMSRegistrationResponse_protocolIEs__item__id._const_tab = ____MBMSRegistrationResponse_protocolIEs__item__id_tab
    ___MBMSRegistrationResponse_protocolIEs__item__id._const_tab_at = None
    ___MBMSRegistrationResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___MBMSRegistrationResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___MBMSRegistrationResponse_protocolIEs__item__criticality._const_tab = ____MBMSRegistrationResponse_protocolIEs__item__id_tab
    ___MBMSRegistrationResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSRegistrationResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MBMSRegistrationResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___MBMSRegistrationResponse_protocolIEs__item__value._const_tab = ____MBMSRegistrationResponse_protocolIEs__item__id_tab
    ___MBMSRegistrationResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MBMSRegistrationResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __MBMSRegistrationResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MBMSRegistrationResponse_protocolIEs__item__id),
        (u'criticality', ___MBMSRegistrationResponse_protocolIEs__item__criticality),
        (u'value', ___MBMSRegistrationResponse_protocolIEs__item__value),
        ])
    __MBMSRegistrationResponse_protocolIEs__item_._ext = None
    _MBMSRegistrationResponse_protocolIEs._cont = __MBMSRegistrationResponse_protocolIEs__item_
    _MBMSRegistrationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSRegistrationResponse_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSRegistrationResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSRegistrationResponse_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMSRegistrationResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRegistrationResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRegistrationResponse_protocolExtensions__item__id._const_tab = ____MBMSRegistrationResponse_protocolExtensions__item__id_tab
    ___MBMSRegistrationResponse_protocolExtensions__item__id._const_tab_at = None
    ___MBMSRegistrationResponse_protocolExtensions__item__id._const_tab_id = u'id'
    ___MBMSRegistrationResponse_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMSRegistrationResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRegistrationResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRegistrationResponse_protocolExtensions__item__criticality._const_tab = ____MBMSRegistrationResponse_protocolExtensions__item__criticality_tab
    ___MBMSRegistrationResponse_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSRegistrationResponse_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___MBMSRegistrationResponse_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMSRegistrationResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRegistrationResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRegistrationResponse_protocolExtensions__item__extensionValue._const_tab = ____MBMSRegistrationResponse_protocolExtensions__item__extensionValue_tab
    ___MBMSRegistrationResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMSRegistrationResponse_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMSRegistrationResponse_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___MBMSRegistrationResponse_protocolExtensions__item__id),
        (u'criticality', ___MBMSRegistrationResponse_protocolExtensions__item__criticality),
        (u'extensionValue', ___MBMSRegistrationResponse_protocolExtensions__item__extensionValue),
        ])
    __MBMSRegistrationResponse_protocolExtensions__item_._ext = None
    _MBMSRegistrationResponse_protocolExtensions._cont = __MBMSRegistrationResponse_protocolExtensions__item_
    _MBMSRegistrationResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSRegistrationResponse._cont = ASN1Dict([
        (u'protocolIEs', _MBMSRegistrationResponse_protocolIEs),
        (u'protocolExtensions', _MBMSRegistrationResponse_protocolExtensions),
        ])
    MBMSRegistrationResponse._ext = []
    
    #-----< MBMSRegistrationResponseIEs >-----#
    MBMSRegistrationResponseIEs = CLASS(name=u'MBMSRegistrationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSRegistrationResponseIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    _MBMSRegistrationResponseIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _MBMSRegistrationResponseIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    MBMSRegistrationResponseIEs._val = ASN1Set(rv=[dict([(u'id', 153), (u'criticality', u'ignore'), (u'Value', _MBMSRegistrationResponseIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 96), (u'criticality', u'ignore'), (u'Value', _MBMSRegistrationResponseIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _MBMSRegistrationResponseIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSRegistrationResponseExtensions >-----#
    MBMSRegistrationResponseExtensions = CLASS(name=u'MBMSRegistrationResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSRegistrationResponseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSRegistrationFailure >-----#
    MBMSRegistrationFailure = SEQ(name=u'MBMSRegistrationFailure', mode=MODE_TYPE)
    _MBMSRegistrationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSRegistrationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSRegistrationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____MBMSRegistrationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSRegistrationFailure_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    _____MBMSRegistrationFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____MBMSRegistrationFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____MBMSRegistrationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____MBMSRegistrationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 153), (u'criticality', u'ignore'), (u'Value', _____MBMSRegistrationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 96), (u'criticality', u'ignore'), (u'Value', _____MBMSRegistrationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____MBMSRegistrationFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____MBMSRegistrationFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MBMSRegistrationFailure_protocolIEs__item__id._const_tab = ____MBMSRegistrationFailure_protocolIEs__item__id_tab
    ___MBMSRegistrationFailure_protocolIEs__item__id._const_tab_at = None
    ___MBMSRegistrationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___MBMSRegistrationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___MBMSRegistrationFailure_protocolIEs__item__criticality._const_tab = ____MBMSRegistrationFailure_protocolIEs__item__id_tab
    ___MBMSRegistrationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSRegistrationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MBMSRegistrationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___MBMSRegistrationFailure_protocolIEs__item__value._const_tab = ____MBMSRegistrationFailure_protocolIEs__item__id_tab
    ___MBMSRegistrationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MBMSRegistrationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __MBMSRegistrationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MBMSRegistrationFailure_protocolIEs__item__id),
        (u'criticality', ___MBMSRegistrationFailure_protocolIEs__item__criticality),
        (u'value', ___MBMSRegistrationFailure_protocolIEs__item__value),
        ])
    __MBMSRegistrationFailure_protocolIEs__item_._ext = None
    _MBMSRegistrationFailure_protocolIEs._cont = __MBMSRegistrationFailure_protocolIEs__item_
    _MBMSRegistrationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSRegistrationFailure_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSRegistrationFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSRegistrationFailure_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMSRegistrationFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRegistrationFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRegistrationFailure_protocolExtensions__item__id._const_tab = ____MBMSRegistrationFailure_protocolExtensions__item__id_tab
    ___MBMSRegistrationFailure_protocolExtensions__item__id._const_tab_at = None
    ___MBMSRegistrationFailure_protocolExtensions__item__id._const_tab_id = u'id'
    ___MBMSRegistrationFailure_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMSRegistrationFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRegistrationFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRegistrationFailure_protocolExtensions__item__criticality._const_tab = ____MBMSRegistrationFailure_protocolExtensions__item__criticality_tab
    ___MBMSRegistrationFailure_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSRegistrationFailure_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___MBMSRegistrationFailure_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMSRegistrationFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRegistrationFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRegistrationFailure_protocolExtensions__item__extensionValue._const_tab = ____MBMSRegistrationFailure_protocolExtensions__item__extensionValue_tab
    ___MBMSRegistrationFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMSRegistrationFailure_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMSRegistrationFailure_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___MBMSRegistrationFailure_protocolExtensions__item__id),
        (u'criticality', ___MBMSRegistrationFailure_protocolExtensions__item__criticality),
        (u'extensionValue', ___MBMSRegistrationFailure_protocolExtensions__item__extensionValue),
        ])
    __MBMSRegistrationFailure_protocolExtensions__item_._ext = None
    _MBMSRegistrationFailure_protocolExtensions._cont = __MBMSRegistrationFailure_protocolExtensions__item_
    _MBMSRegistrationFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSRegistrationFailure._cont = ASN1Dict([
        (u'protocolIEs', _MBMSRegistrationFailure_protocolIEs),
        (u'protocolExtensions', _MBMSRegistrationFailure_protocolExtensions),
        ])
    MBMSRegistrationFailure._ext = []
    
    #-----< MBMSRegistrationFailureIEs >-----#
    MBMSRegistrationFailureIEs = CLASS(name=u'MBMSRegistrationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSRegistrationFailureIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    _MBMSRegistrationFailureIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _MBMSRegistrationFailureIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _MBMSRegistrationFailureIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    MBMSRegistrationFailureIEs._val = ASN1Set(rv=[dict([(u'id', 153), (u'criticality', u'ignore'), (u'Value', _MBMSRegistrationFailureIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 96), (u'criticality', u'ignore'), (u'Value', _MBMSRegistrationFailureIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _MBMSRegistrationFailureIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _MBMSRegistrationFailureIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSRegistrationFailureExtensions >-----#
    MBMSRegistrationFailureExtensions = CLASS(name=u'MBMSRegistrationFailureExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSRegistrationFailureExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSCNDe-RegistrationRequest >-----#
    MBMSCNDe_RegistrationRequest = SEQ(name=u'MBMSCNDe-RegistrationRequest', mode=MODE_TYPE)
    _MBMSCNDe_RegistrationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSCNDe_RegistrationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSCNDe_RegistrationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____MBMSCNDe_RegistrationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSCNDe_RegistrationRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    _____MBMSCNDe_RegistrationRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    ____MBMSCNDe_RegistrationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 153), (u'criticality', u'reject'), (u'Value', _____MBMSCNDe_RegistrationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 96), (u'criticality', u'reject'), (u'Value', _____MBMSCNDe_RegistrationRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MBMSCNDe_RegistrationRequest_protocolIEs__item__id._const_tab = ____MBMSCNDe_RegistrationRequest_protocolIEs__item__id_tab
    ___MBMSCNDe_RegistrationRequest_protocolIEs__item__id._const_tab_at = None
    ___MBMSCNDe_RegistrationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___MBMSCNDe_RegistrationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___MBMSCNDe_RegistrationRequest_protocolIEs__item__criticality._const_tab = ____MBMSCNDe_RegistrationRequest_protocolIEs__item__id_tab
    ___MBMSCNDe_RegistrationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSCNDe_RegistrationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MBMSCNDe_RegistrationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___MBMSCNDe_RegistrationRequest_protocolIEs__item__value._const_tab = ____MBMSCNDe_RegistrationRequest_protocolIEs__item__id_tab
    ___MBMSCNDe_RegistrationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MBMSCNDe_RegistrationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __MBMSCNDe_RegistrationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MBMSCNDe_RegistrationRequest_protocolIEs__item__id),
        (u'criticality', ___MBMSCNDe_RegistrationRequest_protocolIEs__item__criticality),
        (u'value', ___MBMSCNDe_RegistrationRequest_protocolIEs__item__value),
        ])
    __MBMSCNDe_RegistrationRequest_protocolIEs__item_._ext = None
    _MBMSCNDe_RegistrationRequest_protocolIEs._cont = __MBMSCNDe_RegistrationRequest_protocolIEs__item_
    _MBMSCNDe_RegistrationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSCNDe_RegistrationRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSCNDe_RegistrationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMSCNDe_RegistrationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSCNDe_RegistrationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__id._const_tab = ____MBMSCNDe_RegistrationRequest_protocolExtensions__item__id_tab
    ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__id._const_tab_at = None
    ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMSCNDe_RegistrationRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSCNDe_RegistrationRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__criticality._const_tab = ____MBMSCNDe_RegistrationRequest_protocolExtensions__item__criticality_tab
    ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMSCNDe_RegistrationRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSCNDe_RegistrationRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__extensionValue._const_tab = ____MBMSCNDe_RegistrationRequest_protocolExtensions__item__extensionValue_tab
    ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMSCNDe_RegistrationRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__id),
        (u'criticality', ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__extensionValue),
        ])
    __MBMSCNDe_RegistrationRequest_protocolExtensions__item_._ext = None
    _MBMSCNDe_RegistrationRequest_protocolExtensions._cont = __MBMSCNDe_RegistrationRequest_protocolExtensions__item_
    _MBMSCNDe_RegistrationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSCNDe_RegistrationRequest._cont = ASN1Dict([
        (u'protocolIEs', _MBMSCNDe_RegistrationRequest_protocolIEs),
        (u'protocolExtensions', _MBMSCNDe_RegistrationRequest_protocolExtensions),
        ])
    MBMSCNDe_RegistrationRequest._ext = []
    
    #-----< MBMSCNDe-RegistrationRequestIEs >-----#
    MBMSCNDe_RegistrationRequestIEs = CLASS(name=u'MBMSCNDe-RegistrationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSCNDe_RegistrationRequestIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    _MBMSCNDe_RegistrationRequestIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    MBMSCNDe_RegistrationRequestIEs._val = ASN1Set(rv=[dict([(u'id', 153), (u'criticality', u'reject'), (u'Value', _MBMSCNDe_RegistrationRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 96), (u'criticality', u'reject'), (u'Value', _MBMSCNDe_RegistrationRequestIEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSCNDe-RegistrationRequestExtensions >-----#
    MBMSCNDe_RegistrationRequestExtensions = CLASS(name=u'MBMSCNDe-RegistrationRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSCNDe_RegistrationRequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSCNDe-RegistrationResponse >-----#
    MBMSCNDe_RegistrationResponse = SEQ(name=u'MBMSCNDe-RegistrationResponse', mode=MODE_TYPE)
    _MBMSCNDe_RegistrationResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSCNDe_RegistrationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSCNDe_RegistrationResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    _____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    _____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 153), (u'criticality', u'ignore'), (u'Value', _____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MBMSCNDe_RegistrationResponse_protocolIEs__item__id._const_tab = ____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab
    ___MBMSCNDe_RegistrationResponse_protocolIEs__item__id._const_tab_at = None
    ___MBMSCNDe_RegistrationResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___MBMSCNDe_RegistrationResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___MBMSCNDe_RegistrationResponse_protocolIEs__item__criticality._const_tab = ____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab
    ___MBMSCNDe_RegistrationResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSCNDe_RegistrationResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MBMSCNDe_RegistrationResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___MBMSCNDe_RegistrationResponse_protocolIEs__item__value._const_tab = ____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab
    ___MBMSCNDe_RegistrationResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MBMSCNDe_RegistrationResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __MBMSCNDe_RegistrationResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MBMSCNDe_RegistrationResponse_protocolIEs__item__id),
        (u'criticality', ___MBMSCNDe_RegistrationResponse_protocolIEs__item__criticality),
        (u'value', ___MBMSCNDe_RegistrationResponse_protocolIEs__item__value),
        ])
    __MBMSCNDe_RegistrationResponse_protocolIEs__item_._ext = None
    _MBMSCNDe_RegistrationResponse_protocolIEs._cont = __MBMSCNDe_RegistrationResponse_protocolIEs__item_
    _MBMSCNDe_RegistrationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSCNDe_RegistrationResponse_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSCNDe_RegistrationResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMSCNDe_RegistrationResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____MBMSCNDe_RegistrationResponse_protocolExtensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ____MBMSCNDe_RegistrationResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _____MBMSCNDe_RegistrationResponse_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__id._const_tab = ____MBMSCNDe_RegistrationResponse_protocolExtensions__item__id_tab
    ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__id._const_tab_at = None
    ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__id._const_tab_id = u'id'
    ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__criticality._const_tab = ____MBMSCNDe_RegistrationResponse_protocolExtensions__item__id_tab
    ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__extensionValue._const_tab = ____MBMSCNDe_RegistrationResponse_protocolExtensions__item__id_tab
    ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMSCNDe_RegistrationResponse_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__id),
        (u'criticality', ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__criticality),
        (u'extensionValue', ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__extensionValue),
        ])
    __MBMSCNDe_RegistrationResponse_protocolExtensions__item_._ext = None
    _MBMSCNDe_RegistrationResponse_protocolExtensions._cont = __MBMSCNDe_RegistrationResponse_protocolExtensions__item_
    _MBMSCNDe_RegistrationResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSCNDe_RegistrationResponse._cont = ASN1Dict([
        (u'protocolIEs', _MBMSCNDe_RegistrationResponse_protocolIEs),
        (u'protocolExtensions', _MBMSCNDe_RegistrationResponse_protocolExtensions),
        ])
    MBMSCNDe_RegistrationResponse._ext = []
    
    #-----< MBMSCNDe-RegistrationResponseIEs >-----#
    MBMSCNDe_RegistrationResponseIEs = CLASS(name=u'MBMSCNDe-RegistrationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSCNDe_RegistrationResponseIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    _MBMSCNDe_RegistrationResponseIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    _MBMSCNDe_RegistrationResponseIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _MBMSCNDe_RegistrationResponseIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    MBMSCNDe_RegistrationResponseIEs._val = ASN1Set(rv=[dict([(u'id', 153), (u'criticality', u'ignore'), (u'Value', _MBMSCNDe_RegistrationResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _MBMSCNDe_RegistrationResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _MBMSCNDe_RegistrationResponseIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _MBMSCNDe_RegistrationResponseIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSCNDe-RegistrationResponseExtensions >-----#
    MBMSCNDe_RegistrationResponseExtensions = CLASS(name=u'MBMSCNDe-RegistrationResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _MBMSCNDe_RegistrationResponseExtensions_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    MBMSCNDe_RegistrationResponseExtensions._val = ASN1Set(rv=[dict([(u'id', 171), (u'criticality', u'reject'), (u'Extension', _MBMSCNDe_RegistrationResponseExtensions_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSRABEstablishmentIndication >-----#
    MBMSRABEstablishmentIndication = SEQ(name=u'MBMSRABEstablishmentIndication', mode=MODE_TYPE)
    _MBMSRABEstablishmentIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSRABEstablishmentIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSRABEstablishmentIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____MBMSRABEstablishmentIndication_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSRABEstablishmentIndication_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'TransportLayerInformation')))
    ____MBMSRABEstablishmentIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 154), (u'criticality', u'ignore'), (u'Value', _____MBMSRABEstablishmentIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___MBMSRABEstablishmentIndication_protocolIEs__item__id._const_tab = ____MBMSRABEstablishmentIndication_protocolIEs__item__id_tab
    ___MBMSRABEstablishmentIndication_protocolIEs__item__id._const_tab_at = None
    ___MBMSRABEstablishmentIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___MBMSRABEstablishmentIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___MBMSRABEstablishmentIndication_protocolIEs__item__criticality._const_tab = ____MBMSRABEstablishmentIndication_protocolIEs__item__id_tab
    ___MBMSRABEstablishmentIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSRABEstablishmentIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MBMSRABEstablishmentIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___MBMSRABEstablishmentIndication_protocolIEs__item__value._const_tab = ____MBMSRABEstablishmentIndication_protocolIEs__item__id_tab
    ___MBMSRABEstablishmentIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MBMSRABEstablishmentIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __MBMSRABEstablishmentIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MBMSRABEstablishmentIndication_protocolIEs__item__id),
        (u'criticality', ___MBMSRABEstablishmentIndication_protocolIEs__item__criticality),
        (u'value', ___MBMSRABEstablishmentIndication_protocolIEs__item__value),
        ])
    __MBMSRABEstablishmentIndication_protocolIEs__item_._ext = None
    _MBMSRABEstablishmentIndication_protocolIEs._cont = __MBMSRABEstablishmentIndication_protocolIEs__item_
    _MBMSRABEstablishmentIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSRABEstablishmentIndication_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSRABEstablishmentIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSRABEstablishmentIndication_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMSRABEstablishmentIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRABEstablishmentIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRABEstablishmentIndication_protocolExtensions__item__id._const_tab = ____MBMSRABEstablishmentIndication_protocolExtensions__item__id_tab
    ___MBMSRABEstablishmentIndication_protocolExtensions__item__id._const_tab_at = None
    ___MBMSRABEstablishmentIndication_protocolExtensions__item__id._const_tab_id = u'id'
    ___MBMSRABEstablishmentIndication_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMSRABEstablishmentIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRABEstablishmentIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRABEstablishmentIndication_protocolExtensions__item__criticality._const_tab = ____MBMSRABEstablishmentIndication_protocolExtensions__item__criticality_tab
    ___MBMSRABEstablishmentIndication_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSRABEstablishmentIndication_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___MBMSRABEstablishmentIndication_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMSRABEstablishmentIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRABEstablishmentIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRABEstablishmentIndication_protocolExtensions__item__extensionValue._const_tab = ____MBMSRABEstablishmentIndication_protocolExtensions__item__extensionValue_tab
    ___MBMSRABEstablishmentIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMSRABEstablishmentIndication_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMSRABEstablishmentIndication_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___MBMSRABEstablishmentIndication_protocolExtensions__item__id),
        (u'criticality', ___MBMSRABEstablishmentIndication_protocolExtensions__item__criticality),
        (u'extensionValue', ___MBMSRABEstablishmentIndication_protocolExtensions__item__extensionValue),
        ])
    __MBMSRABEstablishmentIndication_protocolExtensions__item_._ext = None
    _MBMSRABEstablishmentIndication_protocolExtensions._cont = __MBMSRABEstablishmentIndication_protocolExtensions__item_
    _MBMSRABEstablishmentIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSRABEstablishmentIndication._cont = ASN1Dict([
        (u'protocolIEs', _MBMSRABEstablishmentIndication_protocolIEs),
        (u'protocolExtensions', _MBMSRABEstablishmentIndication_protocolExtensions),
        ])
    MBMSRABEstablishmentIndication._ext = []
    
    #-----< MBMSRABEstablishmentIndicationIEs >-----#
    MBMSRABEstablishmentIndicationIEs = CLASS(name=u'MBMSRABEstablishmentIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSRABEstablishmentIndicationIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'TransportLayerInformation')))
    MBMSRABEstablishmentIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 154), (u'criticality', u'ignore'), (u'Value', _MBMSRABEstablishmentIndicationIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MBMSRABEstablishmentIndicationExtensions >-----#
    MBMSRABEstablishmentIndicationExtensions = CLASS(name=u'MBMSRABEstablishmentIndicationExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSRABEstablishmentIndicationExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSRABReleaseRequest >-----#
    MBMSRABReleaseRequest = SEQ(name=u'MBMSRABReleaseRequest', mode=MODE_TYPE)
    _MBMSRABReleaseRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSRABReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSRABReleaseRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____MBMSRABReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSRABReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    ____MBMSRABReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____MBMSRABReleaseRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___MBMSRABReleaseRequest_protocolIEs__item__id._const_tab = ____MBMSRABReleaseRequest_protocolIEs__item__id_tab
    ___MBMSRABReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___MBMSRABReleaseRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___MBMSRABReleaseRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___MBMSRABReleaseRequest_protocolIEs__item__criticality._const_tab = ____MBMSRABReleaseRequest_protocolIEs__item__id_tab
    ___MBMSRABReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSRABReleaseRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MBMSRABReleaseRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___MBMSRABReleaseRequest_protocolIEs__item__value._const_tab = ____MBMSRABReleaseRequest_protocolIEs__item__id_tab
    ___MBMSRABReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MBMSRABReleaseRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __MBMSRABReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MBMSRABReleaseRequest_protocolIEs__item__id),
        (u'criticality', ___MBMSRABReleaseRequest_protocolIEs__item__criticality),
        (u'value', ___MBMSRABReleaseRequest_protocolIEs__item__value),
        ])
    __MBMSRABReleaseRequest_protocolIEs__item_._ext = None
    _MBMSRABReleaseRequest_protocolIEs._cont = __MBMSRABReleaseRequest_protocolIEs__item_
    _MBMSRABReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSRABReleaseRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSRABReleaseRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSRABReleaseRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMSRABReleaseRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRABReleaseRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRABReleaseRequest_protocolExtensions__item__id._const_tab = ____MBMSRABReleaseRequest_protocolExtensions__item__id_tab
    ___MBMSRABReleaseRequest_protocolExtensions__item__id._const_tab_at = None
    ___MBMSRABReleaseRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___MBMSRABReleaseRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMSRABReleaseRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRABReleaseRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRABReleaseRequest_protocolExtensions__item__criticality._const_tab = ____MBMSRABReleaseRequest_protocolExtensions__item__criticality_tab
    ___MBMSRABReleaseRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSRABReleaseRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___MBMSRABReleaseRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMSRABReleaseRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRABReleaseRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRABReleaseRequest_protocolExtensions__item__extensionValue._const_tab = ____MBMSRABReleaseRequest_protocolExtensions__item__extensionValue_tab
    ___MBMSRABReleaseRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMSRABReleaseRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMSRABReleaseRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___MBMSRABReleaseRequest_protocolExtensions__item__id),
        (u'criticality', ___MBMSRABReleaseRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___MBMSRABReleaseRequest_protocolExtensions__item__extensionValue),
        ])
    __MBMSRABReleaseRequest_protocolExtensions__item_._ext = None
    _MBMSRABReleaseRequest_protocolExtensions._cont = __MBMSRABReleaseRequest_protocolExtensions__item_
    _MBMSRABReleaseRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSRABReleaseRequest._cont = ASN1Dict([
        (u'protocolIEs', _MBMSRABReleaseRequest_protocolIEs),
        (u'protocolExtensions', _MBMSRABReleaseRequest_protocolExtensions),
        ])
    MBMSRABReleaseRequest._ext = []
    
    #-----< MBMSRABReleaseRequestIEs >-----#
    MBMSRABReleaseRequestIEs = CLASS(name=u'MBMSRABReleaseRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSRABReleaseRequestIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    MBMSRABReleaseRequestIEs._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _MBMSRABReleaseRequestIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MBMSRABReleaseRequestExtensions >-----#
    MBMSRABReleaseRequestExtensions = CLASS(name=u'MBMSRABReleaseRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSRABReleaseRequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSRABRelease >-----#
    MBMSRABRelease = SEQ(name=u'MBMSRABRelease', mode=MODE_TYPE)
    _MBMSRABRelease_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSRABRelease_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSRABRelease_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____MBMSRABRelease_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSRABRelease_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____MBMSRABRelease_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____MBMSRABRelease_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____MBMSRABRelease_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____MBMSRABRelease_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MBMSRABRelease_protocolIEs__item__id._const_tab = ____MBMSRABRelease_protocolIEs__item__id_tab
    ___MBMSRABRelease_protocolIEs__item__id._const_tab_at = None
    ___MBMSRABRelease_protocolIEs__item__id._const_tab_id = u'id'
    ___MBMSRABRelease_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___MBMSRABRelease_protocolIEs__item__criticality._const_tab = ____MBMSRABRelease_protocolIEs__item__id_tab
    ___MBMSRABRelease_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSRABRelease_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MBMSRABRelease_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___MBMSRABRelease_protocolIEs__item__value._const_tab = ____MBMSRABRelease_protocolIEs__item__id_tab
    ___MBMSRABRelease_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MBMSRABRelease_protocolIEs__item__value._const_tab_id = u'Value'
    __MBMSRABRelease_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MBMSRABRelease_protocolIEs__item__id),
        (u'criticality', ___MBMSRABRelease_protocolIEs__item__criticality),
        (u'value', ___MBMSRABRelease_protocolIEs__item__value),
        ])
    __MBMSRABRelease_protocolIEs__item_._ext = None
    _MBMSRABRelease_protocolIEs._cont = __MBMSRABRelease_protocolIEs__item_
    _MBMSRABRelease_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSRABRelease_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSRABRelease_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSRABRelease_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMSRABRelease_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRABRelease_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRABRelease_protocolExtensions__item__id._const_tab = ____MBMSRABRelease_protocolExtensions__item__id_tab
    ___MBMSRABRelease_protocolExtensions__item__id._const_tab_at = None
    ___MBMSRABRelease_protocolExtensions__item__id._const_tab_id = u'id'
    ___MBMSRABRelease_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMSRABRelease_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRABRelease_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRABRelease_protocolExtensions__item__criticality._const_tab = ____MBMSRABRelease_protocolExtensions__item__criticality_tab
    ___MBMSRABRelease_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSRABRelease_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___MBMSRABRelease_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMSRABRelease_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRABRelease_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRABRelease_protocolExtensions__item__extensionValue._const_tab = ____MBMSRABRelease_protocolExtensions__item__extensionValue_tab
    ___MBMSRABRelease_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMSRABRelease_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMSRABRelease_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___MBMSRABRelease_protocolExtensions__item__id),
        (u'criticality', ___MBMSRABRelease_protocolExtensions__item__criticality),
        (u'extensionValue', ___MBMSRABRelease_protocolExtensions__item__extensionValue),
        ])
    __MBMSRABRelease_protocolExtensions__item_._ext = None
    _MBMSRABRelease_protocolExtensions._cont = __MBMSRABRelease_protocolExtensions__item_
    _MBMSRABRelease_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSRABRelease._cont = ASN1Dict([
        (u'protocolIEs', _MBMSRABRelease_protocolIEs),
        (u'protocolExtensions', _MBMSRABRelease_protocolExtensions),
        ])
    MBMSRABRelease._ext = []
    
    #-----< MBMSRABReleaseIEs >-----#
    MBMSRABReleaseIEs = CLASS(name=u'MBMSRABReleaseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSRABReleaseIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _MBMSRABReleaseIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    MBMSRABReleaseIEs._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _MBMSRABReleaseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _MBMSRABReleaseIEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSRABReleaseExtensions >-----#
    MBMSRABReleaseExtensions = CLASS(name=u'MBMSRABReleaseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSRABReleaseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSRABReleaseFailure >-----#
    MBMSRABReleaseFailure = SEQ(name=u'MBMSRABReleaseFailure', mode=MODE_TYPE)
    _MBMSRABReleaseFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSRABReleaseFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSRABReleaseFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____MBMSRABReleaseFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSRABReleaseFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____MBMSRABReleaseFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____MBMSRABReleaseFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____MBMSRABReleaseFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____MBMSRABReleaseFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MBMSRABReleaseFailure_protocolIEs__item__id._const_tab = ____MBMSRABReleaseFailure_protocolIEs__item__id_tab
    ___MBMSRABReleaseFailure_protocolIEs__item__id._const_tab_at = None
    ___MBMSRABReleaseFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___MBMSRABReleaseFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___MBMSRABReleaseFailure_protocolIEs__item__criticality._const_tab = ____MBMSRABReleaseFailure_protocolIEs__item__id_tab
    ___MBMSRABReleaseFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSRABReleaseFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MBMSRABReleaseFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___MBMSRABReleaseFailure_protocolIEs__item__value._const_tab = ____MBMSRABReleaseFailure_protocolIEs__item__id_tab
    ___MBMSRABReleaseFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MBMSRABReleaseFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __MBMSRABReleaseFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MBMSRABReleaseFailure_protocolIEs__item__id),
        (u'criticality', ___MBMSRABReleaseFailure_protocolIEs__item__criticality),
        (u'value', ___MBMSRABReleaseFailure_protocolIEs__item__value),
        ])
    __MBMSRABReleaseFailure_protocolIEs__item_._ext = None
    _MBMSRABReleaseFailure_protocolIEs._cont = __MBMSRABReleaseFailure_protocolIEs__item_
    _MBMSRABReleaseFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSRABReleaseFailure_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSRABReleaseFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSRABReleaseFailure_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMSRABReleaseFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRABReleaseFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRABReleaseFailure_protocolExtensions__item__id._const_tab = ____MBMSRABReleaseFailure_protocolExtensions__item__id_tab
    ___MBMSRABReleaseFailure_protocolExtensions__item__id._const_tab_at = None
    ___MBMSRABReleaseFailure_protocolExtensions__item__id._const_tab_id = u'id'
    ___MBMSRABReleaseFailure_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMSRABReleaseFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRABReleaseFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRABReleaseFailure_protocolExtensions__item__criticality._const_tab = ____MBMSRABReleaseFailure_protocolExtensions__item__criticality_tab
    ___MBMSRABReleaseFailure_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSRABReleaseFailure_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___MBMSRABReleaseFailure_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMSRABReleaseFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRABReleaseFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRABReleaseFailure_protocolExtensions__item__extensionValue._const_tab = ____MBMSRABReleaseFailure_protocolExtensions__item__extensionValue_tab
    ___MBMSRABReleaseFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMSRABReleaseFailure_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMSRABReleaseFailure_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___MBMSRABReleaseFailure_protocolExtensions__item__id),
        (u'criticality', ___MBMSRABReleaseFailure_protocolExtensions__item__criticality),
        (u'extensionValue', ___MBMSRABReleaseFailure_protocolExtensions__item__extensionValue),
        ])
    __MBMSRABReleaseFailure_protocolExtensions__item_._ext = None
    _MBMSRABReleaseFailure_protocolExtensions._cont = __MBMSRABReleaseFailure_protocolExtensions__item_
    _MBMSRABReleaseFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSRABReleaseFailure._cont = ASN1Dict([
        (u'protocolIEs', _MBMSRABReleaseFailure_protocolIEs),
        (u'protocolExtensions', _MBMSRABReleaseFailure_protocolExtensions),
        ])
    MBMSRABReleaseFailure._ext = []
    
    #-----< MBMSRABReleaseFailureIEs >-----#
    MBMSRABReleaseFailureIEs = CLASS(name=u'MBMSRABReleaseFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSRABReleaseFailureIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _MBMSRABReleaseFailureIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    MBMSRABReleaseFailureIEs._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _MBMSRABReleaseFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _MBMSRABReleaseFailureIEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSRABReleaseFailureExtensions >-----#
    MBMSRABReleaseFailureExtensions = CLASS(name=u'MBMSRABReleaseFailureExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSRABReleaseFailureExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRVCC-CSKeysRequest >-----#
    SRVCC_CSKeysRequest = SEQ(name=u'SRVCC-CSKeysRequest', mode=MODE_TYPE)
    _SRVCC_CSKeysRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __SRVCC_CSKeysRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___SRVCC_CSKeysRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____SRVCC_CSKeysRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    ____SRVCC_CSKeysRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRVCC_CSKeysRequest_protocolIEs__item__id._const_tab = ____SRVCC_CSKeysRequest_protocolIEs__item__id_tab
    ___SRVCC_CSKeysRequest_protocolIEs__item__id._const_tab_at = None
    ___SRVCC_CSKeysRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___SRVCC_CSKeysRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ____SRVCC_CSKeysRequest_protocolIEs__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    ____SRVCC_CSKeysRequest_protocolIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRVCC_CSKeysRequest_protocolIEs__item__criticality._const_tab = ____SRVCC_CSKeysRequest_protocolIEs__item__criticality_tab
    ___SRVCC_CSKeysRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SRVCC_CSKeysRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SRVCC_CSKeysRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ____SRVCC_CSKeysRequest_protocolIEs__item__value_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    ____SRVCC_CSKeysRequest_protocolIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRVCC_CSKeysRequest_protocolIEs__item__value._const_tab = ____SRVCC_CSKeysRequest_protocolIEs__item__value_tab
    ___SRVCC_CSKeysRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SRVCC_CSKeysRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __SRVCC_CSKeysRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SRVCC_CSKeysRequest_protocolIEs__item__id),
        (u'criticality', ___SRVCC_CSKeysRequest_protocolIEs__item__criticality),
        (u'value', ___SRVCC_CSKeysRequest_protocolIEs__item__value),
        ])
    __SRVCC_CSKeysRequest_protocolIEs__item_._ext = None
    _SRVCC_CSKeysRequest_protocolIEs._cont = __SRVCC_CSKeysRequest_protocolIEs__item_
    _SRVCC_CSKeysRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _SRVCC_CSKeysRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRVCC_CSKeysRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SRVCC_CSKeysRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SRVCC_CSKeysRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRVCC_CSKeysRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRVCC_CSKeysRequest_protocolExtensions__item__id._const_tab = ____SRVCC_CSKeysRequest_protocolExtensions__item__id_tab
    ___SRVCC_CSKeysRequest_protocolExtensions__item__id._const_tab_at = None
    ___SRVCC_CSKeysRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___SRVCC_CSKeysRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SRVCC_CSKeysRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRVCC_CSKeysRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRVCC_CSKeysRequest_protocolExtensions__item__criticality._const_tab = ____SRVCC_CSKeysRequest_protocolExtensions__item__criticality_tab
    ___SRVCC_CSKeysRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRVCC_CSKeysRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___SRVCC_CSKeysRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SRVCC_CSKeysRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRVCC_CSKeysRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRVCC_CSKeysRequest_protocolExtensions__item__extensionValue._const_tab = ____SRVCC_CSKeysRequest_protocolExtensions__item__extensionValue_tab
    ___SRVCC_CSKeysRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRVCC_CSKeysRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __SRVCC_CSKeysRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___SRVCC_CSKeysRequest_protocolExtensions__item__id),
        (u'criticality', ___SRVCC_CSKeysRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___SRVCC_CSKeysRequest_protocolExtensions__item__extensionValue),
        ])
    __SRVCC_CSKeysRequest_protocolExtensions__item_._ext = None
    _SRVCC_CSKeysRequest_protocolExtensions._cont = __SRVCC_CSKeysRequest_protocolExtensions__item_
    _SRVCC_CSKeysRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRVCC_CSKeysRequest._cont = ASN1Dict([
        (u'protocolIEs', _SRVCC_CSKeysRequest_protocolIEs),
        (u'protocolExtensions', _SRVCC_CSKeysRequest_protocolExtensions),
        ])
    SRVCC_CSKeysRequest._ext = []
    
    #-----< SRVCC-CSKeysRequestIEs >-----#
    SRVCC_CSKeysRequestIEs = CLASS(name=u'SRVCC-CSKeysRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    SRVCC_CSKeysRequestIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRVCC-CSKeysRequestExtensions >-----#
    SRVCC_CSKeysRequestExtensions = CLASS(name=u'SRVCC-CSKeysRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SRVCC_CSKeysRequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRVCC-CSKeysResponse >-----#
    SRVCC_CSKeysResponse = SEQ(name=u'SRVCC-CSKeysResponse', mode=MODE_TYPE)
    _SRVCC_CSKeysResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __SRVCC_CSKeysResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___SRVCC_CSKeysResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____SRVCC_CSKeysResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____SRVCC_CSKeysResponse_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IntegrityProtectionKey')))
    _____SRVCC_CSKeysResponse_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'EncryptionKey')))
    _____SRVCC_CSKeysResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRVCC-Information')))
    _____SRVCC_CSKeysResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____SRVCC_CSKeysResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 225), (u'criticality', u'reject'), (u'Value', _____SRVCC_CSKeysResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 224), (u'criticality', u'reject'), (u'Value', _____SRVCC_CSKeysResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 227), (u'criticality', u'reject'), (u'Value', _____SRVCC_CSKeysResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____SRVCC_CSKeysResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SRVCC_CSKeysResponse_protocolIEs__item__id._const_tab = ____SRVCC_CSKeysResponse_protocolIEs__item__id_tab
    ___SRVCC_CSKeysResponse_protocolIEs__item__id._const_tab_at = None
    ___SRVCC_CSKeysResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___SRVCC_CSKeysResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___SRVCC_CSKeysResponse_protocolIEs__item__criticality._const_tab = ____SRVCC_CSKeysResponse_protocolIEs__item__id_tab
    ___SRVCC_CSKeysResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SRVCC_CSKeysResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SRVCC_CSKeysResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___SRVCC_CSKeysResponse_protocolIEs__item__value._const_tab = ____SRVCC_CSKeysResponse_protocolIEs__item__id_tab
    ___SRVCC_CSKeysResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SRVCC_CSKeysResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __SRVCC_CSKeysResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SRVCC_CSKeysResponse_protocolIEs__item__id),
        (u'criticality', ___SRVCC_CSKeysResponse_protocolIEs__item__criticality),
        (u'value', ___SRVCC_CSKeysResponse_protocolIEs__item__value),
        ])
    __SRVCC_CSKeysResponse_protocolIEs__item_._ext = None
    _SRVCC_CSKeysResponse_protocolIEs._cont = __SRVCC_CSKeysResponse_protocolIEs__item_
    _SRVCC_CSKeysResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _SRVCC_CSKeysResponse_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRVCC_CSKeysResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SRVCC_CSKeysResponse_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SRVCC_CSKeysResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRVCC_CSKeysResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRVCC_CSKeysResponse_protocolExtensions__item__id._const_tab = ____SRVCC_CSKeysResponse_protocolExtensions__item__id_tab
    ___SRVCC_CSKeysResponse_protocolExtensions__item__id._const_tab_at = None
    ___SRVCC_CSKeysResponse_protocolExtensions__item__id._const_tab_id = u'id'
    ___SRVCC_CSKeysResponse_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SRVCC_CSKeysResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRVCC_CSKeysResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRVCC_CSKeysResponse_protocolExtensions__item__criticality._const_tab = ____SRVCC_CSKeysResponse_protocolExtensions__item__criticality_tab
    ___SRVCC_CSKeysResponse_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___SRVCC_CSKeysResponse_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___SRVCC_CSKeysResponse_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SRVCC_CSKeysResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRVCC_CSKeysResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRVCC_CSKeysResponse_protocolExtensions__item__extensionValue._const_tab = ____SRVCC_CSKeysResponse_protocolExtensions__item__extensionValue_tab
    ___SRVCC_CSKeysResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SRVCC_CSKeysResponse_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __SRVCC_CSKeysResponse_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___SRVCC_CSKeysResponse_protocolExtensions__item__id),
        (u'criticality', ___SRVCC_CSKeysResponse_protocolExtensions__item__criticality),
        (u'extensionValue', ___SRVCC_CSKeysResponse_protocolExtensions__item__extensionValue),
        ])
    __SRVCC_CSKeysResponse_protocolExtensions__item_._ext = None
    _SRVCC_CSKeysResponse_protocolExtensions._cont = __SRVCC_CSKeysResponse_protocolExtensions__item_
    _SRVCC_CSKeysResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRVCC_CSKeysResponse._cont = ASN1Dict([
        (u'protocolIEs', _SRVCC_CSKeysResponse_protocolIEs),
        (u'protocolExtensions', _SRVCC_CSKeysResponse_protocolExtensions),
        ])
    SRVCC_CSKeysResponse._ext = []
    
    #-----< SRVCC-CSKeysResponseIEs >-----#
    SRVCC_CSKeysResponseIEs = CLASS(name=u'SRVCC-CSKeysResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _SRVCC_CSKeysResponseIEs_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IntegrityProtectionKey')))
    _SRVCC_CSKeysResponseIEs_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'EncryptionKey')))
    _SRVCC_CSKeysResponseIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRVCC-Information')))
    _SRVCC_CSKeysResponseIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    SRVCC_CSKeysResponseIEs._val = ASN1Set(rv=[dict([(u'id', 225), (u'criticality', u'reject'), (u'Value', _SRVCC_CSKeysResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 224), (u'criticality', u'reject'), (u'Value', _SRVCC_CSKeysResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 227), (u'criticality', u'reject'), (u'Value', _SRVCC_CSKeysResponseIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _SRVCC_CSKeysResponseIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SRVCC-CSKeysResponseExtensions >-----#
    SRVCC_CSKeysResponseExtensions = CLASS(name=u'SRVCC-CSKeysResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SRVCC_CSKeysResponseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UeRadioCapabilityMatchRequest >-----#
    UeRadioCapabilityMatchRequest = SEQ(name=u'UeRadioCapabilityMatchRequest', mode=MODE_TYPE)
    _UeRadioCapabilityMatchRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __UeRadioCapabilityMatchRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___UeRadioCapabilityMatchRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____UeRadioCapabilityMatchRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    ____UeRadioCapabilityMatchRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRadioCapabilityMatchRequest_protocolIEs__item__id._const_tab = ____UeRadioCapabilityMatchRequest_protocolIEs__item__id_tab
    ___UeRadioCapabilityMatchRequest_protocolIEs__item__id._const_tab_at = None
    ___UeRadioCapabilityMatchRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___UeRadioCapabilityMatchRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ____UeRadioCapabilityMatchRequest_protocolIEs__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    ____UeRadioCapabilityMatchRequest_protocolIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRadioCapabilityMatchRequest_protocolIEs__item__criticality._const_tab = ____UeRadioCapabilityMatchRequest_protocolIEs__item__criticality_tab
    ___UeRadioCapabilityMatchRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UeRadioCapabilityMatchRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UeRadioCapabilityMatchRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ____UeRadioCapabilityMatchRequest_protocolIEs__item__value_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    ____UeRadioCapabilityMatchRequest_protocolIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRadioCapabilityMatchRequest_protocolIEs__item__value._const_tab = ____UeRadioCapabilityMatchRequest_protocolIEs__item__value_tab
    ___UeRadioCapabilityMatchRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UeRadioCapabilityMatchRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __UeRadioCapabilityMatchRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UeRadioCapabilityMatchRequest_protocolIEs__item__id),
        (u'criticality', ___UeRadioCapabilityMatchRequest_protocolIEs__item__criticality),
        (u'value', ___UeRadioCapabilityMatchRequest_protocolIEs__item__value),
        ])
    __UeRadioCapabilityMatchRequest_protocolIEs__item_._ext = None
    _UeRadioCapabilityMatchRequest_protocolIEs._cont = __UeRadioCapabilityMatchRequest_protocolIEs__item_
    _UeRadioCapabilityMatchRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UeRadioCapabilityMatchRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UeRadioCapabilityMatchRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UeRadioCapabilityMatchRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UeRadioCapabilityMatchRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UeRadioCapabilityMatchRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRadioCapabilityMatchRequest_protocolExtensions__item__id._const_tab = ____UeRadioCapabilityMatchRequest_protocolExtensions__item__id_tab
    ___UeRadioCapabilityMatchRequest_protocolExtensions__item__id._const_tab_at = None
    ___UeRadioCapabilityMatchRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___UeRadioCapabilityMatchRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UeRadioCapabilityMatchRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UeRadioCapabilityMatchRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRadioCapabilityMatchRequest_protocolExtensions__item__criticality._const_tab = ____UeRadioCapabilityMatchRequest_protocolExtensions__item__criticality_tab
    ___UeRadioCapabilityMatchRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___UeRadioCapabilityMatchRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___UeRadioCapabilityMatchRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UeRadioCapabilityMatchRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UeRadioCapabilityMatchRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRadioCapabilityMatchRequest_protocolExtensions__item__extensionValue._const_tab = ____UeRadioCapabilityMatchRequest_protocolExtensions__item__extensionValue_tab
    ___UeRadioCapabilityMatchRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UeRadioCapabilityMatchRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __UeRadioCapabilityMatchRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___UeRadioCapabilityMatchRequest_protocolExtensions__item__id),
        (u'criticality', ___UeRadioCapabilityMatchRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___UeRadioCapabilityMatchRequest_protocolExtensions__item__extensionValue),
        ])
    __UeRadioCapabilityMatchRequest_protocolExtensions__item_._ext = None
    _UeRadioCapabilityMatchRequest_protocolExtensions._cont = __UeRadioCapabilityMatchRequest_protocolExtensions__item_
    _UeRadioCapabilityMatchRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UeRadioCapabilityMatchRequest._cont = ASN1Dict([
        (u'protocolIEs', _UeRadioCapabilityMatchRequest_protocolIEs),
        (u'protocolExtensions', _UeRadioCapabilityMatchRequest_protocolExtensions),
        ])
    UeRadioCapabilityMatchRequest._ext = []
    
    #-----< UeRadioCapabilityMatchRequestIEs >-----#
    UeRadioCapabilityMatchRequestIEs = CLASS(name=u'UeRadioCapabilityMatchRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    UeRadioCapabilityMatchRequestIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UeRadioCapabilityMatchRequestExtensions >-----#
    UeRadioCapabilityMatchRequestExtensions = CLASS(name=u'UeRadioCapabilityMatchRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    UeRadioCapabilityMatchRequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UeRadioCapabilityMatchResponse >-----#
    UeRadioCapabilityMatchResponse = SEQ(name=u'UeRadioCapabilityMatchResponse', mode=MODE_TYPE)
    _UeRadioCapabilityMatchResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __UeRadioCapabilityMatchResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___UeRadioCapabilityMatchResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____UeRadioCapabilityMatchResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____UeRadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'VoiceSupportMatchIndicator')))
    ____UeRadioCapabilityMatchResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 258), (u'criticality', u'reject'), (u'Value', _____UeRadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___UeRadioCapabilityMatchResponse_protocolIEs__item__id._const_tab = ____UeRadioCapabilityMatchResponse_protocolIEs__item__id_tab
    ___UeRadioCapabilityMatchResponse_protocolIEs__item__id._const_tab_at = None
    ___UeRadioCapabilityMatchResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___UeRadioCapabilityMatchResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___UeRadioCapabilityMatchResponse_protocolIEs__item__criticality._const_tab = ____UeRadioCapabilityMatchResponse_protocolIEs__item__id_tab
    ___UeRadioCapabilityMatchResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UeRadioCapabilityMatchResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UeRadioCapabilityMatchResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___UeRadioCapabilityMatchResponse_protocolIEs__item__value._const_tab = ____UeRadioCapabilityMatchResponse_protocolIEs__item__id_tab
    ___UeRadioCapabilityMatchResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UeRadioCapabilityMatchResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __UeRadioCapabilityMatchResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UeRadioCapabilityMatchResponse_protocolIEs__item__id),
        (u'criticality', ___UeRadioCapabilityMatchResponse_protocolIEs__item__criticality),
        (u'value', ___UeRadioCapabilityMatchResponse_protocolIEs__item__value),
        ])
    __UeRadioCapabilityMatchResponse_protocolIEs__item_._ext = None
    _UeRadioCapabilityMatchResponse_protocolIEs._cont = __UeRadioCapabilityMatchResponse_protocolIEs__item_
    _UeRadioCapabilityMatchResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UeRadioCapabilityMatchResponse_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UeRadioCapabilityMatchResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UeRadioCapabilityMatchResponse_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UeRadioCapabilityMatchResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UeRadioCapabilityMatchResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRadioCapabilityMatchResponse_protocolExtensions__item__id._const_tab = ____UeRadioCapabilityMatchResponse_protocolExtensions__item__id_tab
    ___UeRadioCapabilityMatchResponse_protocolExtensions__item__id._const_tab_at = None
    ___UeRadioCapabilityMatchResponse_protocolExtensions__item__id._const_tab_id = u'id'
    ___UeRadioCapabilityMatchResponse_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UeRadioCapabilityMatchResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UeRadioCapabilityMatchResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRadioCapabilityMatchResponse_protocolExtensions__item__criticality._const_tab = ____UeRadioCapabilityMatchResponse_protocolExtensions__item__criticality_tab
    ___UeRadioCapabilityMatchResponse_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___UeRadioCapabilityMatchResponse_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___UeRadioCapabilityMatchResponse_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UeRadioCapabilityMatchResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UeRadioCapabilityMatchResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRadioCapabilityMatchResponse_protocolExtensions__item__extensionValue._const_tab = ____UeRadioCapabilityMatchResponse_protocolExtensions__item__extensionValue_tab
    ___UeRadioCapabilityMatchResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UeRadioCapabilityMatchResponse_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __UeRadioCapabilityMatchResponse_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___UeRadioCapabilityMatchResponse_protocolExtensions__item__id),
        (u'criticality', ___UeRadioCapabilityMatchResponse_protocolExtensions__item__criticality),
        (u'extensionValue', ___UeRadioCapabilityMatchResponse_protocolExtensions__item__extensionValue),
        ])
    __UeRadioCapabilityMatchResponse_protocolExtensions__item_._ext = None
    _UeRadioCapabilityMatchResponse_protocolExtensions._cont = __UeRadioCapabilityMatchResponse_protocolExtensions__item_
    _UeRadioCapabilityMatchResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UeRadioCapabilityMatchResponse._cont = ASN1Dict([
        (u'protocolIEs', _UeRadioCapabilityMatchResponse_protocolIEs),
        (u'protocolExtensions', _UeRadioCapabilityMatchResponse_protocolExtensions),
        ])
    UeRadioCapabilityMatchResponse._ext = []
    
    #-----< UeRadioCapabilityMatchResponseIEs >-----#
    UeRadioCapabilityMatchResponseIEs = CLASS(name=u'UeRadioCapabilityMatchResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _UeRadioCapabilityMatchResponseIEs_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'VoiceSupportMatchIndicator')))
    UeRadioCapabilityMatchResponseIEs._val = ASN1Set(rv=[dict([(u'id', 258), (u'criticality', u'reject'), (u'Value', _UeRadioCapabilityMatchResponseIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UeRadioCapabilityMatchResponseExtensions >-----#
    UeRadioCapabilityMatchResponseExtensions = CLASS(name=u'UeRadioCapabilityMatchResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    UeRadioCapabilityMatchResponseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UeRegistrationQueryRequest >-----#
    UeRegistrationQueryRequest = SEQ(name=u'UeRegistrationQueryRequest', mode=MODE_TYPE)
    _UeRegistrationQueryRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __UeRegistrationQueryRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___UeRegistrationQueryRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____UeRegistrationQueryRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____UeRegistrationQueryRequest_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _____UeRegistrationQueryRequest_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    ____UeRegistrationQueryRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 79), (u'criticality', u'ignore'), (u'Value', _____UeRegistrationQueryRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 23), (u'criticality', u'ignore'), (u'Value', _____UeRegistrationQueryRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___UeRegistrationQueryRequest_protocolIEs__item__id._const_tab = ____UeRegistrationQueryRequest_protocolIEs__item__id_tab
    ___UeRegistrationQueryRequest_protocolIEs__item__id._const_tab_at = None
    ___UeRegistrationQueryRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___UeRegistrationQueryRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___UeRegistrationQueryRequest_protocolIEs__item__criticality._const_tab = ____UeRegistrationQueryRequest_protocolIEs__item__id_tab
    ___UeRegistrationQueryRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UeRegistrationQueryRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UeRegistrationQueryRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___UeRegistrationQueryRequest_protocolIEs__item__value._const_tab = ____UeRegistrationQueryRequest_protocolIEs__item__id_tab
    ___UeRegistrationQueryRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UeRegistrationQueryRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __UeRegistrationQueryRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UeRegistrationQueryRequest_protocolIEs__item__id),
        (u'criticality', ___UeRegistrationQueryRequest_protocolIEs__item__criticality),
        (u'value', ___UeRegistrationQueryRequest_protocolIEs__item__value),
        ])
    __UeRegistrationQueryRequest_protocolIEs__item_._ext = None
    _UeRegistrationQueryRequest_protocolIEs._cont = __UeRegistrationQueryRequest_protocolIEs__item_
    _UeRegistrationQueryRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UeRegistrationQueryRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UeRegistrationQueryRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UeRegistrationQueryRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UeRegistrationQueryRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UeRegistrationQueryRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRegistrationQueryRequest_protocolExtensions__item__id._const_tab = ____UeRegistrationQueryRequest_protocolExtensions__item__id_tab
    ___UeRegistrationQueryRequest_protocolExtensions__item__id._const_tab_at = None
    ___UeRegistrationQueryRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___UeRegistrationQueryRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UeRegistrationQueryRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UeRegistrationQueryRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRegistrationQueryRequest_protocolExtensions__item__criticality._const_tab = ____UeRegistrationQueryRequest_protocolExtensions__item__criticality_tab
    ___UeRegistrationQueryRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___UeRegistrationQueryRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___UeRegistrationQueryRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UeRegistrationQueryRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UeRegistrationQueryRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRegistrationQueryRequest_protocolExtensions__item__extensionValue._const_tab = ____UeRegistrationQueryRequest_protocolExtensions__item__extensionValue_tab
    ___UeRegistrationQueryRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UeRegistrationQueryRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __UeRegistrationQueryRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___UeRegistrationQueryRequest_protocolExtensions__item__id),
        (u'criticality', ___UeRegistrationQueryRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___UeRegistrationQueryRequest_protocolExtensions__item__extensionValue),
        ])
    __UeRegistrationQueryRequest_protocolExtensions__item_._ext = None
    _UeRegistrationQueryRequest_protocolExtensions._cont = __UeRegistrationQueryRequest_protocolExtensions__item_
    _UeRegistrationQueryRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UeRegistrationQueryRequest._cont = ASN1Dict([
        (u'protocolIEs', _UeRegistrationQueryRequest_protocolIEs),
        (u'protocolExtensions', _UeRegistrationQueryRequest_protocolExtensions),
        ])
    UeRegistrationQueryRequest._ext = []
    
    #-----< UeRegistrationQueryRequestIEs >-----#
    UeRegistrationQueryRequestIEs = CLASS(name=u'UeRegistrationQueryRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _UeRegistrationQueryRequestIEs_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _UeRegistrationQueryRequestIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    UeRegistrationQueryRequestIEs._val = ASN1Set(rv=[dict([(u'id', 79), (u'criticality', u'ignore'), (u'Value', _UeRegistrationQueryRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 23), (u'criticality', u'ignore'), (u'Value', _UeRegistrationQueryRequestIEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UeRegistrationQueryRequestExtensions >-----#
    UeRegistrationQueryRequestExtensions = CLASS(name=u'UeRegistrationQueryRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    UeRegistrationQueryRequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UeRegistrationQueryResponse >-----#
    UeRegistrationQueryResponse = SEQ(name=u'UeRegistrationQueryResponse', mode=MODE_TYPE)
    _UeRegistrationQueryResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __UeRegistrationQueryResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___UeRegistrationQueryResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____UeRegistrationQueryResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____UeRegistrationQueryResponse_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UERegistrationQueryResult')))
    ____UeRegistrationQueryResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 281), (u'criticality', u'ignore'), (u'Value', _____UeRegistrationQueryResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___UeRegistrationQueryResponse_protocolIEs__item__id._const_tab = ____UeRegistrationQueryResponse_protocolIEs__item__id_tab
    ___UeRegistrationQueryResponse_protocolIEs__item__id._const_tab_at = None
    ___UeRegistrationQueryResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___UeRegistrationQueryResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___UeRegistrationQueryResponse_protocolIEs__item__criticality._const_tab = ____UeRegistrationQueryResponse_protocolIEs__item__id_tab
    ___UeRegistrationQueryResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UeRegistrationQueryResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UeRegistrationQueryResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___UeRegistrationQueryResponse_protocolIEs__item__value._const_tab = ____UeRegistrationQueryResponse_protocolIEs__item__id_tab
    ___UeRegistrationQueryResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UeRegistrationQueryResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __UeRegistrationQueryResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UeRegistrationQueryResponse_protocolIEs__item__id),
        (u'criticality', ___UeRegistrationQueryResponse_protocolIEs__item__criticality),
        (u'value', ___UeRegistrationQueryResponse_protocolIEs__item__value),
        ])
    __UeRegistrationQueryResponse_protocolIEs__item_._ext = None
    _UeRegistrationQueryResponse_protocolIEs._cont = __UeRegistrationQueryResponse_protocolIEs__item_
    _UeRegistrationQueryResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UeRegistrationQueryResponse_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UeRegistrationQueryResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UeRegistrationQueryResponse_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UeRegistrationQueryResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UeRegistrationQueryResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRegistrationQueryResponse_protocolExtensions__item__id._const_tab = ____UeRegistrationQueryResponse_protocolExtensions__item__id_tab
    ___UeRegistrationQueryResponse_protocolExtensions__item__id._const_tab_at = None
    ___UeRegistrationQueryResponse_protocolExtensions__item__id._const_tab_id = u'id'
    ___UeRegistrationQueryResponse_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UeRegistrationQueryResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UeRegistrationQueryResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRegistrationQueryResponse_protocolExtensions__item__criticality._const_tab = ____UeRegistrationQueryResponse_protocolExtensions__item__criticality_tab
    ___UeRegistrationQueryResponse_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___UeRegistrationQueryResponse_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___UeRegistrationQueryResponse_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UeRegistrationQueryResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UeRegistrationQueryResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRegistrationQueryResponse_protocolExtensions__item__extensionValue._const_tab = ____UeRegistrationQueryResponse_protocolExtensions__item__extensionValue_tab
    ___UeRegistrationQueryResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UeRegistrationQueryResponse_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __UeRegistrationQueryResponse_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___UeRegistrationQueryResponse_protocolExtensions__item__id),
        (u'criticality', ___UeRegistrationQueryResponse_protocolExtensions__item__criticality),
        (u'extensionValue', ___UeRegistrationQueryResponse_protocolExtensions__item__extensionValue),
        ])
    __UeRegistrationQueryResponse_protocolExtensions__item_._ext = None
    _UeRegistrationQueryResponse_protocolExtensions._cont = __UeRegistrationQueryResponse_protocolExtensions__item_
    _UeRegistrationQueryResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UeRegistrationQueryResponse._cont = ASN1Dict([
        (u'protocolIEs', _UeRegistrationQueryResponse_protocolIEs),
        (u'protocolExtensions', _UeRegistrationQueryResponse_protocolExtensions),
        ])
    UeRegistrationQueryResponse._ext = []
    
    #-----< UeRegistrationQueryResponseIEs >-----#
    UeRegistrationQueryResponseIEs = CLASS(name=u'UeRegistrationQueryResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _UeRegistrationQueryResponseIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UERegistrationQueryResult')))
    UeRegistrationQueryResponseIEs._val = ASN1Set(rv=[dict([(u'id', 281), (u'criticality', u'ignore'), (u'Value', _UeRegistrationQueryResponseIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UeRegistrationQueryResponseExtensions >-----#
    UeRegistrationQueryResponseExtensions = CLASS(name=u'UeRegistrationQueryResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    UeRegistrationQueryResponseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RerouteNASRequest >-----#
    RerouteNASRequest = SEQ(name=u'RerouteNASRequest', mode=MODE_TYPE)
    _RerouteNASRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RerouteNASRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RerouteNASRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'id']))
    ____RerouteNASRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE)
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SGSN-Group-Identity')))
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'P-TMSI')))
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-Usage-Type')))
    ____RerouteNASRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 288), (u'criticality', u'ignore'), (u'Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 286), (u'criticality', u'ignore'), (u'Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 287), (u'criticality', u'ignore'), (u'Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 290), (u'criticality', u'ignore'), (u'Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RerouteNASRequest_protocolIEs__item__id._const_tab = ____RerouteNASRequest_protocolIEs__item__id_tab
    ___RerouteNASRequest_protocolIEs__item__id._const_tab_at = None
    ___RerouteNASRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___RerouteNASRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'criticality']))
    ___RerouteNASRequest_protocolIEs__item__criticality._const_tab = ____RerouteNASRequest_protocolIEs__item__id_tab
    ___RerouteNASRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RerouteNASRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RerouteNASRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), [u'Value']))
    ___RerouteNASRequest_protocolIEs__item__value._const_tab = ____RerouteNASRequest_protocolIEs__item__id_tab
    ___RerouteNASRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RerouteNASRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __RerouteNASRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RerouteNASRequest_protocolIEs__item__id),
        (u'criticality', ___RerouteNASRequest_protocolIEs__item__criticality),
        (u'value', ___RerouteNASRequest_protocolIEs__item__value),
        ])
    __RerouteNASRequest_protocolIEs__item_._ext = None
    _RerouteNASRequest_protocolIEs._cont = __RerouteNASRequest_protocolIEs__item_
    _RerouteNASRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RerouteNASRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RerouteNASRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RerouteNASRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RerouteNASRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RerouteNASRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RerouteNASRequest_protocolExtensions__item__id._const_tab = ____RerouteNASRequest_protocolExtensions__item__id_tab
    ___RerouteNASRequest_protocolExtensions__item__id._const_tab_at = None
    ___RerouteNASRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___RerouteNASRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RerouteNASRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RerouteNASRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RerouteNASRequest_protocolExtensions__item__criticality._const_tab = ____RerouteNASRequest_protocolExtensions__item__criticality_tab
    ___RerouteNASRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RerouteNASRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RerouteNASRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RerouteNASRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RerouteNASRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RerouteNASRequest_protocolExtensions__item__extensionValue._const_tab = ____RerouteNASRequest_protocolExtensions__item__extensionValue_tab
    ___RerouteNASRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RerouteNASRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RerouteNASRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RerouteNASRequest_protocolExtensions__item__id),
        (u'criticality', ___RerouteNASRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___RerouteNASRequest_protocolExtensions__item__extensionValue),
        ])
    __RerouteNASRequest_protocolExtensions__item_._ext = None
    _RerouteNASRequest_protocolExtensions._cont = __RerouteNASRequest_protocolExtensions__item_
    _RerouteNASRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RerouteNASRequest._cont = ASN1Dict([
        (u'protocolIEs', _RerouteNASRequest_protocolIEs),
        (u'protocolExtensions', _RerouteNASRequest_protocolExtensions),
        ])
    RerouteNASRequest._ext = []
    
    #-----< RerouteNASRequestIEs >-----#
    RerouteNASRequestIEs = CLASS(name=u'RerouteNASRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RerouteNASRequestIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE)
    _RerouteNASRequestIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SGSN-Group-Identity')))
    _RerouteNASRequestIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'P-TMSI')))
    _RerouteNASRequestIEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-Usage-Type')))
    RerouteNASRequestIEs._val = ASN1Set(rv=[dict([(u'id', 288), (u'criticality', u'ignore'), (u'Value', _RerouteNASRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 286), (u'criticality', u'ignore'), (u'Value', _RerouteNASRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 287), (u'criticality', u'ignore'), (u'Value', _RerouteNASRequestIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 290), (u'criticality', u'ignore'), (u'Value', _RerouteNASRequestIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RerouteNASRequestExtensions >-----#
    RerouteNASRequestExtensions = CLASS(name=u'RerouteNASRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RerouteNASRequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    _all_ = [
        ____Iu_ReleaseCommand_protocolIEs__item__id_tab,
        _____Iu_ReleaseCommand_protocolIEs__item__id_tab_val_Value_0,
        ___Iu_ReleaseCommand_protocolIEs__item__id,
        ___Iu_ReleaseCommand_protocolIEs__item__criticality,
        ___Iu_ReleaseCommand_protocolIEs__item__value,
        __Iu_ReleaseCommand_protocolIEs__item_,
        _Iu_ReleaseCommand_protocolIEs,
        ____Iu_ReleaseCommand_protocolExtensions__item__id_tab,
        _____Iu_ReleaseCommand_protocolExtensions__item__id_tab_val_Extension_0,
        _____Iu_ReleaseCommand_protocolExtensions__item__id_tab_val_Extension_1,
        _____Iu_ReleaseCommand_protocolExtensions__item__id_tab_val_Extension_2,
        ___Iu_ReleaseCommand_protocolExtensions__item__id,
        ___Iu_ReleaseCommand_protocolExtensions__item__criticality,
        ___Iu_ReleaseCommand_protocolExtensions__item__extensionValue,
        __Iu_ReleaseCommand_protocolExtensions__item_,
        _Iu_ReleaseCommand_protocolExtensions,
        Iu_ReleaseCommand,
        Iu_ReleaseCommandIEs,
        _Iu_ReleaseCommandIEs_val_Value_0,
        Iu_ReleaseCommandExtensions,
        _Iu_ReleaseCommandExtensions_val_Extension_0,
        _Iu_ReleaseCommandExtensions_val_Extension_1,
        _Iu_ReleaseCommandExtensions_val_Extension_2,
        ____Iu_ReleaseComplete_protocolIEs__item__id_tab,
        _____Iu_ReleaseComplete_protocolIEs__item__id_tab_val_Value_0,
        _____Iu_ReleaseComplete_protocolIEs__item__id_tab_val_Value_1,
        _____Iu_ReleaseComplete_protocolIEs__item__id_tab_val_Value_2,
        ___Iu_ReleaseComplete_protocolIEs__item__id,
        ___Iu_ReleaseComplete_protocolIEs__item__criticality,
        ___Iu_ReleaseComplete_protocolIEs__item__value,
        __Iu_ReleaseComplete_protocolIEs__item_,
        _Iu_ReleaseComplete_protocolIEs,
        ____Iu_ReleaseComplete_protocolExtensions__item__id_tab,
        ___Iu_ReleaseComplete_protocolExtensions__item__id,
        ____Iu_ReleaseComplete_protocolExtensions__item__criticality_tab,
        ___Iu_ReleaseComplete_protocolExtensions__item__criticality,
        ____Iu_ReleaseComplete_protocolExtensions__item__extensionValue_tab,
        ___Iu_ReleaseComplete_protocolExtensions__item__extensionValue,
        __Iu_ReleaseComplete_protocolExtensions__item_,
        _Iu_ReleaseComplete_protocolExtensions,
        Iu_ReleaseComplete,
        Iu_ReleaseCompleteIEs,
        _Iu_ReleaseCompleteIEs_val_Value_0,
        _Iu_ReleaseCompleteIEs_val_Value_1,
        _Iu_ReleaseCompleteIEs_val_Value_2,
        ____RAB_DataVolumeReportList__item___item__id_tab,
        _____RAB_DataVolumeReportList__item___item__id_tab_val_Value_0,
        ___RAB_DataVolumeReportList__item___item__id,
        ___RAB_DataVolumeReportList__item___item__criticality,
        ___RAB_DataVolumeReportList__item___item__value,
        __RAB_DataVolumeReportList__item___item_,
        _RAB_DataVolumeReportList__item_,
        RAB_DataVolumeReportList,
        RAB_DataVolumeReportItemIEs,
        _RAB_DataVolumeReportItemIEs_val_Value_0,
        _RAB_DataVolumeReportItem_rAB_ID,
        _RAB_DataVolumeReportItem_dl_UnsuccessfullyTransmittedDataVolume,
        ____RAB_DataVolumeReportItem_iE_Extensions__item__id_tab,
        ___RAB_DataVolumeReportItem_iE_Extensions__item__id,
        ____RAB_DataVolumeReportItem_iE_Extensions__item__criticality_tab,
        ___RAB_DataVolumeReportItem_iE_Extensions__item__criticality,
        ____RAB_DataVolumeReportItem_iE_Extensions__item__extensionValue_tab,
        ___RAB_DataVolumeReportItem_iE_Extensions__item__extensionValue,
        __RAB_DataVolumeReportItem_iE_Extensions__item_,
        _RAB_DataVolumeReportItem_iE_Extensions,
        RAB_DataVolumeReportItem,
        RAB_DataVolumeReportItem_ExtIEs,
        ____RAB_ReleasedList_IuRelComp__item___item__id_tab,
        _____RAB_ReleasedList_IuRelComp__item___item__id_tab_val_Value_0,
        ___RAB_ReleasedList_IuRelComp__item___item__id,
        ___RAB_ReleasedList_IuRelComp__item___item__criticality,
        ___RAB_ReleasedList_IuRelComp__item___item__value,
        __RAB_ReleasedList_IuRelComp__item___item_,
        _RAB_ReleasedList_IuRelComp__item_,
        RAB_ReleasedList_IuRelComp,
        RAB_ReleasedItem_IuRelComp_IEs,
        _RAB_ReleasedItem_IuRelComp_IEs_val_Value_0,
        _RAB_ReleasedItem_IuRelComp_rAB_ID,
        _RAB_ReleasedItem_IuRelComp_dL_GTP_PDU_SequenceNumber,
        _RAB_ReleasedItem_IuRelComp_uL_GTP_PDU_SequenceNumber,
        ____RAB_ReleasedItem_IuRelComp_iE_Extensions__item__id_tab,
        ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__id,
        ____RAB_ReleasedItem_IuRelComp_iE_Extensions__item__criticality_tab,
        ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__criticality,
        ____RAB_ReleasedItem_IuRelComp_iE_Extensions__item__extensionValue_tab,
        ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__extensionValue,
        __RAB_ReleasedItem_IuRelComp_iE_Extensions__item_,
        _RAB_ReleasedItem_IuRelComp_iE_Extensions,
        RAB_ReleasedItem_IuRelComp,
        RAB_ReleasedItem_IuRelComp_ExtIEs,
        Iu_ReleaseCompleteExtensions,
        ____RelocationRequired_protocolIEs__item__id_tab,
        _____RelocationRequired_protocolIEs__item__id_tab_val_Value_0,
        _____RelocationRequired_protocolIEs__item__id_tab_val_Value_1,
        _____RelocationRequired_protocolIEs__item__id_tab_val_Value_2,
        _____RelocationRequired_protocolIEs__item__id_tab_val_Value_3,
        _____RelocationRequired_protocolIEs__item__id_tab_val_Value_4,
        _____RelocationRequired_protocolIEs__item__id_tab_val_Value_5,
        _____RelocationRequired_protocolIEs__item__id_tab_val_Value_6,
        _____RelocationRequired_protocolIEs__item__id_tab_val_Value_7,
        ___RelocationRequired_protocolIEs__item__id,
        ___RelocationRequired_protocolIEs__item__criticality,
        ___RelocationRequired_protocolIEs__item__value,
        __RelocationRequired_protocolIEs__item_,
        _RelocationRequired_protocolIEs,
        ____RelocationRequired_protocolExtensions__item__id_tab,
        _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_0,
        _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_1,
        _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_2,
        _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_3,
        _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_4,
        _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_5,
        _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_6,
        ___RelocationRequired_protocolExtensions__item__id,
        ___RelocationRequired_protocolExtensions__item__criticality,
        ___RelocationRequired_protocolExtensions__item__extensionValue,
        __RelocationRequired_protocolExtensions__item_,
        _RelocationRequired_protocolExtensions,
        RelocationRequired,
        RelocationRequiredIEs,
        _RelocationRequiredIEs_val_Value_0,
        _RelocationRequiredIEs_val_Value_1,
        _RelocationRequiredIEs_val_Value_2,
        _RelocationRequiredIEs_val_Value_3,
        _RelocationRequiredIEs_val_Value_4,
        _RelocationRequiredIEs_val_Value_5,
        _RelocationRequiredIEs_val_Value_6,
        _RelocationRequiredIEs_val_Value_7,
        RelocationRequiredExtensions,
        _RelocationRequiredExtensions_val_Extension_0,
        _RelocationRequiredExtensions_val_Extension_1,
        _RelocationRequiredExtensions_val_Extension_2,
        _RelocationRequiredExtensions_val_Extension_3,
        _RelocationRequiredExtensions_val_Extension_4,
        _RelocationRequiredExtensions_val_Extension_5,
        _RelocationRequiredExtensions_val_Extension_6,
        ____RelocationCommand_protocolIEs__item__id_tab,
        _____RelocationCommand_protocolIEs__item__id_tab_val_Value_0,
        _____RelocationCommand_protocolIEs__item__id_tab_val_Value_1,
        _____RelocationCommand_protocolIEs__item__id_tab_val_Value_2,
        _____RelocationCommand_protocolIEs__item__id_tab_val_Value_3,
        _____RelocationCommand_protocolIEs__item__id_tab_val_Value_4,
        ___RelocationCommand_protocolIEs__item__id,
        ___RelocationCommand_protocolIEs__item__criticality,
        ___RelocationCommand_protocolIEs__item__value,
        __RelocationCommand_protocolIEs__item_,
        _RelocationCommand_protocolIEs,
        ____RelocationCommand_protocolExtensions__item__id_tab,
        _____RelocationCommand_protocolExtensions__item__id_tab_val_Extension_0,
        _____RelocationCommand_protocolExtensions__item__id_tab_val_Extension_1,
        _____RelocationCommand_protocolExtensions__item__id_tab_val_Extension_2,
        _____RelocationCommand_protocolExtensions__item__id_tab_val_Extension_3,
        ___RelocationCommand_protocolExtensions__item__id,
        ___RelocationCommand_protocolExtensions__item__criticality,
        ___RelocationCommand_protocolExtensions__item__extensionValue,
        __RelocationCommand_protocolExtensions__item_,
        _RelocationCommand_protocolExtensions,
        RelocationCommand,
        RelocationCommandIEs,
        _RelocationCommandIEs_val_Value_0,
        _RelocationCommandIEs_val_Value_1,
        _RelocationCommandIEs_val_Value_2,
        _RelocationCommandIEs_val_Value_3,
        _RelocationCommandIEs_val_Value_4,
        ____RAB_RelocationReleaseList__item___item__id_tab,
        _____RAB_RelocationReleaseList__item___item__id_tab_val_Value_0,
        ___RAB_RelocationReleaseList__item___item__id,
        ___RAB_RelocationReleaseList__item___item__criticality,
        ___RAB_RelocationReleaseList__item___item__value,
        __RAB_RelocationReleaseList__item___item_,
        _RAB_RelocationReleaseList__item_,
        RAB_RelocationReleaseList,
        RAB_RelocationReleaseItemIEs,
        _RAB_RelocationReleaseItemIEs_val_Value_0,
        _RAB_RelocationReleaseItem_rAB_ID,
        ____RAB_RelocationReleaseItem_iE_Extensions__item__id_tab,
        ___RAB_RelocationReleaseItem_iE_Extensions__item__id,
        ____RAB_RelocationReleaseItem_iE_Extensions__item__criticality_tab,
        ___RAB_RelocationReleaseItem_iE_Extensions__item__criticality,
        ____RAB_RelocationReleaseItem_iE_Extensions__item__extensionValue_tab,
        ___RAB_RelocationReleaseItem_iE_Extensions__item__extensionValue,
        __RAB_RelocationReleaseItem_iE_Extensions__item_,
        _RAB_RelocationReleaseItem_iE_Extensions,
        RAB_RelocationReleaseItem,
        RAB_RelocationReleaseItem_ExtIEs,
        ____RAB_DataForwardingList__item___item__id_tab,
        _____RAB_DataForwardingList__item___item__id_tab_val_Value_0,
        ___RAB_DataForwardingList__item___item__id,
        ___RAB_DataForwardingList__item___item__criticality,
        ___RAB_DataForwardingList__item___item__value,
        __RAB_DataForwardingList__item___item_,
        _RAB_DataForwardingList__item_,
        RAB_DataForwardingList,
        RAB_DataForwardingItemIEs,
        _RAB_DataForwardingItemIEs_val_Value_0,
        _RAB_DataForwardingItem_rAB_ID,
        _RAB_DataForwardingItem_transportLayerAddress,
        _RAB_DataForwardingItem_iuTransportAssociation,
        ____RAB_DataForwardingItem_iE_Extensions__item__id_tab,
        _____RAB_DataForwardingItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____RAB_DataForwardingItem_iE_Extensions__item__id_tab_val_Extension_1,
        ___RAB_DataForwardingItem_iE_Extensions__item__id,
        ___RAB_DataForwardingItem_iE_Extensions__item__criticality,
        ___RAB_DataForwardingItem_iE_Extensions__item__extensionValue,
        __RAB_DataForwardingItem_iE_Extensions__item_,
        _RAB_DataForwardingItem_iE_Extensions,
        RAB_DataForwardingItem,
        RAB_DataForwardingItem_ExtIEs,
        _RAB_DataForwardingItem_ExtIEs_val_Extension_0,
        _RAB_DataForwardingItem_ExtIEs_val_Extension_1,
        RelocationCommandExtensions,
        _RelocationCommandExtensions_val_Extension_0,
        _RelocationCommandExtensions_val_Extension_1,
        _RelocationCommandExtensions_val_Extension_2,
        _RelocationCommandExtensions_val_Extension_3,
        ____RelocationPreparationFailure_protocolIEs__item__id_tab,
        _____RelocationPreparationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____RelocationPreparationFailure_protocolIEs__item__id_tab_val_Value_1,
        ___RelocationPreparationFailure_protocolIEs__item__id,
        ___RelocationPreparationFailure_protocolIEs__item__criticality,
        ___RelocationPreparationFailure_protocolIEs__item__value,
        __RelocationPreparationFailure_protocolIEs__item_,
        _RelocationPreparationFailure_protocolIEs,
        ____RelocationPreparationFailure_protocolExtensions__item__id_tab,
        _____RelocationPreparationFailure_protocolExtensions__item__id_tab_val_Extension_0,
        ___RelocationPreparationFailure_protocolExtensions__item__id,
        ___RelocationPreparationFailure_protocolExtensions__item__criticality,
        ___RelocationPreparationFailure_protocolExtensions__item__extensionValue,
        __RelocationPreparationFailure_protocolExtensions__item_,
        _RelocationPreparationFailure_protocolExtensions,
        RelocationPreparationFailure,
        RelocationPreparationFailureIEs,
        _RelocationPreparationFailureIEs_val_Value_0,
        _RelocationPreparationFailureIEs_val_Value_1,
        RelocationPreparationFailureExtensions,
        _RelocationPreparationFailureExtensions_val_Extension_0,
        ____RelocationRequest_protocolIEs__item__id_tab,
        _____RelocationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____RelocationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____RelocationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____RelocationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____RelocationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____RelocationRequest_protocolIEs__item__id_tab_val_Value_5,
        _____RelocationRequest_protocolIEs__item__id_tab_val_Value_6,
        _____RelocationRequest_protocolIEs__item__id_tab_val_Value_7,
        ___RelocationRequest_protocolIEs__item__id,
        ___RelocationRequest_protocolIEs__item__criticality,
        ___RelocationRequest_protocolIEs__item__value,
        __RelocationRequest_protocolIEs__item_,
        _RelocationRequest_protocolIEs,
        ____RelocationRequest_protocolExtensions__item__id_tab,
        _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_0,
        _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_1,
        _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_2,
        _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_3,
        _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_4,
        _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_5,
        _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_6,
        _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_7,
        _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_8,
        _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_9,
        _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_10,
        _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_11,
        ___RelocationRequest_protocolExtensions__item__id,
        ___RelocationRequest_protocolExtensions__item__criticality,
        ___RelocationRequest_protocolExtensions__item__extensionValue,
        __RelocationRequest_protocolExtensions__item_,
        _RelocationRequest_protocolExtensions,
        RelocationRequest,
        RelocationRequestIEs,
        _RelocationRequestIEs_val_Value_0,
        _RelocationRequestIEs_val_Value_1,
        _RelocationRequestIEs_val_Value_2,
        _RelocationRequestIEs_val_Value_3,
        _RelocationRequestIEs_val_Value_4,
        _RelocationRequestIEs_val_Value_5,
        _RelocationRequestIEs_val_Value_6,
        _RelocationRequestIEs_val_Value_7,
        ____RAB_SetupList_RelocReq__item___item__id_tab,
        _____RAB_SetupList_RelocReq__item___item__id_tab_val_Value_0,
        ___RAB_SetupList_RelocReq__item___item__id,
        ___RAB_SetupList_RelocReq__item___item__criticality,
        ___RAB_SetupList_RelocReq__item___item__value,
        __RAB_SetupList_RelocReq__item___item_,
        _RAB_SetupList_RelocReq__item_,
        RAB_SetupList_RelocReq,
        RAB_SetupItem_RelocReq_IEs,
        _RAB_SetupItem_RelocReq_IEs_val_Value_0,
        _RAB_SetupItem_RelocReq_rAB_ID,
        _RAB_SetupItem_RelocReq_nAS_SynchronisationIndicator,
        _RAB_SetupItem_RelocReq_rAB_Parameters,
        _RAB_SetupItem_RelocReq_dataVolumeReportingIndication,
        _RAB_SetupItem_RelocReq_pDP_TypeInformation,
        _RAB_SetupItem_RelocReq_userPlaneInformation,
        _RAB_SetupItem_RelocReq_transportLayerAddress,
        _RAB_SetupItem_RelocReq_iuTransportAssociation,
        _RAB_SetupItem_RelocReq_service_Handover,
        ____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab,
        _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_0,
        _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_1,
        _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_2,
        _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_3,
        _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_4,
        ___RAB_SetupItem_RelocReq_iE_Extensions__item__id,
        ___RAB_SetupItem_RelocReq_iE_Extensions__item__criticality,
        ___RAB_SetupItem_RelocReq_iE_Extensions__item__extensionValue,
        __RAB_SetupItem_RelocReq_iE_Extensions__item_,
        _RAB_SetupItem_RelocReq_iE_Extensions,
        RAB_SetupItem_RelocReq,
        RAB_SetupItem_RelocReq_ExtIEs,
        _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_0,
        _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_1,
        _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_2,
        _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_3,
        _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_4,
        _UserPlaneInformation_userPlaneMode,
        _UserPlaneInformation_uP_ModeVersions,
        ____UserPlaneInformation_iE_Extensions__item__id_tab,
        ___UserPlaneInformation_iE_Extensions__item__id,
        ____UserPlaneInformation_iE_Extensions__item__criticality_tab,
        ___UserPlaneInformation_iE_Extensions__item__criticality,
        ____UserPlaneInformation_iE_Extensions__item__extensionValue_tab,
        ___UserPlaneInformation_iE_Extensions__item__extensionValue,
        __UserPlaneInformation_iE_Extensions__item_,
        _UserPlaneInformation_iE_Extensions,
        UserPlaneInformation,
        UserPlaneInformation_ExtIEs,
        RelocationRequestExtensions,
        _RelocationRequestExtensions_val_Extension_0,
        _RelocationRequestExtensions_val_Extension_1,
        _RelocationRequestExtensions_val_Extension_2,
        _RelocationRequestExtensions_val_Extension_3,
        _RelocationRequestExtensions_val_Extension_4,
        _RelocationRequestExtensions_val_Extension_5,
        _RelocationRequestExtensions_val_Extension_6,
        _RelocationRequestExtensions_val_Extension_7,
        _RelocationRequestExtensions_val_Extension_8,
        _RelocationRequestExtensions_val_Extension_9,
        _RelocationRequestExtensions_val_Extension_10,
        _RelocationRequestExtensions_val_Extension_11,
        _CNMBMSLinkingInformation_joinedMBMSBearerService_IEs,
        ____CNMBMSLinkingInformation_iE_Extensions__item__id_tab,
        ___CNMBMSLinkingInformation_iE_Extensions__item__id,
        ____CNMBMSLinkingInformation_iE_Extensions__item__criticality_tab,
        ___CNMBMSLinkingInformation_iE_Extensions__item__criticality,
        ____CNMBMSLinkingInformation_iE_Extensions__item__extensionValue_tab,
        ___CNMBMSLinkingInformation_iE_Extensions__item__extensionValue,
        __CNMBMSLinkingInformation_iE_Extensions__item_,
        _CNMBMSLinkingInformation_iE_Extensions,
        CNMBMSLinkingInformation,
        CNMBMSLinkingInformation_ExtIEs,
        __JoinedMBMSBearerService_IEs__item__tMGI,
        __JoinedMBMSBearerService_IEs__item__mBMS_PTP_RAB_ID,
        _____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__id_tab,
        ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__id,
        _____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__criticality_tab,
        ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__criticality,
        _____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue_tab,
        ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue,
        ___JoinedMBMSBearerService_IEs__item__iE_Extensions__item_,
        __JoinedMBMSBearerService_IEs__item__iE_Extensions,
        _JoinedMBMSBearerService_IEs__item_,
        JoinedMBMSBearerService_IEs,
        JoinedMBMSBearerService_ExtIEs,
        ____RelocationRequestAcknowledge_protocolIEs__item__id_tab,
        _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        ___RelocationRequestAcknowledge_protocolIEs__item__id,
        ___RelocationRequestAcknowledge_protocolIEs__item__criticality,
        ___RelocationRequestAcknowledge_protocolIEs__item__value,
        __RelocationRequestAcknowledge_protocolIEs__item_,
        _RelocationRequestAcknowledge_protocolIEs,
        ____RelocationRequestAcknowledge_protocolExtensions__item__id_tab,
        _____RelocationRequestAcknowledge_protocolExtensions__item__id_tab_val_Extension_0,
        _____RelocationRequestAcknowledge_protocolExtensions__item__id_tab_val_Extension_1,
        ___RelocationRequestAcknowledge_protocolExtensions__item__id,
        ___RelocationRequestAcknowledge_protocolExtensions__item__criticality,
        ___RelocationRequestAcknowledge_protocolExtensions__item__extensionValue,
        __RelocationRequestAcknowledge_protocolExtensions__item_,
        _RelocationRequestAcknowledge_protocolExtensions,
        RelocationRequestAcknowledge,
        RelocationRequestAcknowledgeIEs,
        _RelocationRequestAcknowledgeIEs_val_Value_0,
        _RelocationRequestAcknowledgeIEs_val_Value_1,
        _RelocationRequestAcknowledgeIEs_val_Value_2,
        _RelocationRequestAcknowledgeIEs_val_Value_3,
        _RelocationRequestAcknowledgeIEs_val_Value_4,
        _RelocationRequestAcknowledgeIEs_val_Value_5,
        ____RAB_SetupList_RelocReqAck__item___item__id_tab,
        _____RAB_SetupList_RelocReqAck__item___item__id_tab_val_Value_0,
        ___RAB_SetupList_RelocReqAck__item___item__id,
        ___RAB_SetupList_RelocReqAck__item___item__criticality,
        ___RAB_SetupList_RelocReqAck__item___item__value,
        __RAB_SetupList_RelocReqAck__item___item_,
        _RAB_SetupList_RelocReqAck__item_,
        RAB_SetupList_RelocReqAck,
        RAB_SetupItem_RelocReqAck_IEs,
        _RAB_SetupItem_RelocReqAck_IEs_val_Value_0,
        _RAB_SetupItem_RelocReqAck_rAB_ID,
        _RAB_SetupItem_RelocReqAck_transportLayerAddress,
        _RAB_SetupItem_RelocReqAck_iuTransportAssociation,
        ____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab,
        _____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab_val_Extension_0,
        _____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab_val_Extension_1,
        _____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab_val_Extension_2,
        ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__id,
        ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__criticality,
        ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__extensionValue,
        __RAB_SetupItem_RelocReqAck_iE_Extensions__item_,
        _RAB_SetupItem_RelocReqAck_iE_Extensions,
        RAB_SetupItem_RelocReqAck,
        RAB_SetupItem_RelocReqAck_ExtIEs,
        _RAB_SetupItem_RelocReqAck_ExtIEs_val_Extension_0,
        _RAB_SetupItem_RelocReqAck_ExtIEs_val_Extension_1,
        _RAB_SetupItem_RelocReqAck_ExtIEs_val_Extension_2,
        ____RAB_FailedList__item___item__id_tab,
        _____RAB_FailedList__item___item__id_tab_val_Value_0,
        ___RAB_FailedList__item___item__id,
        ___RAB_FailedList__item___item__criticality,
        ___RAB_FailedList__item___item__value,
        __RAB_FailedList__item___item_,
        _RAB_FailedList__item_,
        RAB_FailedList,
        RAB_FailedItemIEs,
        _RAB_FailedItemIEs_val_Value_0,
        _RAB_FailedItem_rAB_ID,
        _RAB_FailedItem_cause,
        ____RAB_FailedItem_iE_Extensions__item__id_tab,
        ___RAB_FailedItem_iE_Extensions__item__id,
        ____RAB_FailedItem_iE_Extensions__item__criticality_tab,
        ___RAB_FailedItem_iE_Extensions__item__criticality,
        ____RAB_FailedItem_iE_Extensions__item__extensionValue_tab,
        ___RAB_FailedItem_iE_Extensions__item__extensionValue,
        __RAB_FailedItem_iE_Extensions__item_,
        _RAB_FailedItem_iE_Extensions,
        RAB_FailedItem,
        RAB_FailedItem_ExtIEs,
        RelocationRequestAcknowledgeExtensions,
        _RelocationRequestAcknowledgeExtensions_val_Extension_0,
        _RelocationRequestAcknowledgeExtensions_val_Extension_1,
        ____RelocationFailure_protocolIEs__item__id_tab,
        _____RelocationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____RelocationFailure_protocolIEs__item__id_tab_val_Value_1,
        ___RelocationFailure_protocolIEs__item__id,
        ___RelocationFailure_protocolIEs__item__criticality,
        ___RelocationFailure_protocolIEs__item__value,
        __RelocationFailure_protocolIEs__item_,
        _RelocationFailure_protocolIEs,
        ____RelocationFailure_protocolExtensions__item__id_tab,
        _____RelocationFailure_protocolExtensions__item__id_tab_val_Extension_0,
        _____RelocationFailure_protocolExtensions__item__id_tab_val_Extension_1,
        ___RelocationFailure_protocolExtensions__item__id,
        ___RelocationFailure_protocolExtensions__item__criticality,
        ___RelocationFailure_protocolExtensions__item__extensionValue,
        __RelocationFailure_protocolExtensions__item_,
        _RelocationFailure_protocolExtensions,
        RelocationFailure,
        RelocationFailureIEs,
        _RelocationFailureIEs_val_Value_0,
        _RelocationFailureIEs_val_Value_1,
        RelocationFailureExtensions,
        _RelocationFailureExtensions_val_Extension_0,
        _RelocationFailureExtensions_val_Extension_1,
        ____RelocationCancel_protocolIEs__item__id_tab,
        _____RelocationCancel_protocolIEs__item__id_tab_val_Value_0,
        ___RelocationCancel_protocolIEs__item__id,
        ___RelocationCancel_protocolIEs__item__criticality,
        ___RelocationCancel_protocolIEs__item__value,
        __RelocationCancel_protocolIEs__item_,
        _RelocationCancel_protocolIEs,
        ____RelocationCancel_protocolExtensions__item__id_tab,
        ___RelocationCancel_protocolExtensions__item__id,
        ____RelocationCancel_protocolExtensions__item__criticality_tab,
        ___RelocationCancel_protocolExtensions__item__criticality,
        ____RelocationCancel_protocolExtensions__item__extensionValue_tab,
        ___RelocationCancel_protocolExtensions__item__extensionValue,
        __RelocationCancel_protocolExtensions__item_,
        _RelocationCancel_protocolExtensions,
        RelocationCancel,
        RelocationCancelIEs,
        _RelocationCancelIEs_val_Value_0,
        RelocationCancelExtensions,
        ____RelocationCancelAcknowledge_protocolIEs__item__id_tab,
        _____RelocationCancelAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        ___RelocationCancelAcknowledge_protocolIEs__item__id,
        ___RelocationCancelAcknowledge_protocolIEs__item__criticality,
        ___RelocationCancelAcknowledge_protocolIEs__item__value,
        __RelocationCancelAcknowledge_protocolIEs__item_,
        _RelocationCancelAcknowledge_protocolIEs,
        ____RelocationCancelAcknowledge_protocolExtensions__item__id_tab,
        ___RelocationCancelAcknowledge_protocolExtensions__item__id,
        ____RelocationCancelAcknowledge_protocolExtensions__item__criticality_tab,
        ___RelocationCancelAcknowledge_protocolExtensions__item__criticality,
        ____RelocationCancelAcknowledge_protocolExtensions__item__extensionValue_tab,
        ___RelocationCancelAcknowledge_protocolExtensions__item__extensionValue,
        __RelocationCancelAcknowledge_protocolExtensions__item_,
        _RelocationCancelAcknowledge_protocolExtensions,
        RelocationCancelAcknowledge,
        RelocationCancelAcknowledgeIEs,
        _RelocationCancelAcknowledgeIEs_val_Value_0,
        RelocationCancelAcknowledgeExtensions,
        ____SRNS_ContextRequest_protocolIEs__item__id_tab,
        _____SRNS_ContextRequest_protocolIEs__item__id_tab_val_Value_0,
        ___SRNS_ContextRequest_protocolIEs__item__id,
        ___SRNS_ContextRequest_protocolIEs__item__criticality,
        ___SRNS_ContextRequest_protocolIEs__item__value,
        __SRNS_ContextRequest_protocolIEs__item_,
        _SRNS_ContextRequest_protocolIEs,
        ____SRNS_ContextRequest_protocolExtensions__item__id_tab,
        _____SRNS_ContextRequest_protocolExtensions__item__id_tab_val_Extension_0,
        ___SRNS_ContextRequest_protocolExtensions__item__id,
        ___SRNS_ContextRequest_protocolExtensions__item__criticality,
        ___SRNS_ContextRequest_protocolExtensions__item__extensionValue,
        __SRNS_ContextRequest_protocolExtensions__item_,
        _SRNS_ContextRequest_protocolExtensions,
        SRNS_ContextRequest,
        SRNS_ContextRequestIEs,
        _SRNS_ContextRequestIEs_val_Value_0,
        ____RAB_DataForwardingList_SRNS_CtxReq__item___item__id_tab,
        _____RAB_DataForwardingList_SRNS_CtxReq__item___item__id_tab_val_Value_0,
        ___RAB_DataForwardingList_SRNS_CtxReq__item___item__id,
        ___RAB_DataForwardingList_SRNS_CtxReq__item___item__criticality,
        ___RAB_DataForwardingList_SRNS_CtxReq__item___item__value,
        __RAB_DataForwardingList_SRNS_CtxReq__item___item_,
        _RAB_DataForwardingList_SRNS_CtxReq__item_,
        RAB_DataForwardingList_SRNS_CtxReq,
        RAB_DataForwardingItem_SRNS_CtxReq_IEs,
        _RAB_DataForwardingItem_SRNS_CtxReq_IEs_val_Value_0,
        _RAB_DataForwardingItem_SRNS_CtxReq_rAB_ID,
        ____RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__id_tab,
        ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__id,
        ____RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__criticality_tab,
        ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__criticality,
        ____RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__extensionValue_tab,
        ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__extensionValue,
        __RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item_,
        _RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions,
        RAB_DataForwardingItem_SRNS_CtxReq,
        RAB_DataForwardingItem_SRNS_CtxReq_ExtIEs,
        SRNS_ContextRequestExtensions,
        _SRNS_ContextRequestExtensions_val_Extension_0,
        ____SRNS_ContextResponse_protocolIEs__item__id_tab,
        _____SRNS_ContextResponse_protocolIEs__item__id_tab_val_Value_0,
        _____SRNS_ContextResponse_protocolIEs__item__id_tab_val_Value_1,
        _____SRNS_ContextResponse_protocolIEs__item__id_tab_val_Value_2,
        ___SRNS_ContextResponse_protocolIEs__item__id,
        ___SRNS_ContextResponse_protocolIEs__item__criticality,
        ___SRNS_ContextResponse_protocolIEs__item__value,
        __SRNS_ContextResponse_protocolIEs__item_,
        _SRNS_ContextResponse_protocolIEs,
        ____SRNS_ContextResponse_protocolExtensions__item__id_tab,
        ___SRNS_ContextResponse_protocolExtensions__item__id,
        ____SRNS_ContextResponse_protocolExtensions__item__criticality_tab,
        ___SRNS_ContextResponse_protocolExtensions__item__criticality,
        ____SRNS_ContextResponse_protocolExtensions__item__extensionValue_tab,
        ___SRNS_ContextResponse_protocolExtensions__item__extensionValue,
        __SRNS_ContextResponse_protocolExtensions__item_,
        _SRNS_ContextResponse_protocolExtensions,
        SRNS_ContextResponse,
        SRNS_ContextResponseIEs,
        _SRNS_ContextResponseIEs_val_Value_0,
        _SRNS_ContextResponseIEs_val_Value_1,
        _SRNS_ContextResponseIEs_val_Value_2,
        ____RAB_ContextList__item___item__id_tab,
        _____RAB_ContextList__item___item__id_tab_val_Value_0,
        ___RAB_ContextList__item___item__id,
        ___RAB_ContextList__item___item__criticality,
        ___RAB_ContextList__item___item__value,
        __RAB_ContextList__item___item_,
        _RAB_ContextList__item_,
        RAB_ContextList,
        RAB_ContextItemIEs,
        _RAB_ContextItemIEs_val_Value_0,
        _RAB_ContextItem_rAB_ID,
        _RAB_ContextItem_dl_GTP_PDU_SequenceNumber,
        _RAB_ContextItem_ul_GTP_PDU_SequenceNumber,
        _RAB_ContextItem_dl_N_PDU_SequenceNumber,
        _RAB_ContextItem_ul_N_PDU_SequenceNumber,
        ____RAB_ContextItem_iE_Extensions__item__id_tab,
        ___RAB_ContextItem_iE_Extensions__item__id,
        ____RAB_ContextItem_iE_Extensions__item__criticality_tab,
        ___RAB_ContextItem_iE_Extensions__item__criticality,
        ____RAB_ContextItem_iE_Extensions__item__extensionValue_tab,
        ___RAB_ContextItem_iE_Extensions__item__extensionValue,
        __RAB_ContextItem_iE_Extensions__item_,
        _RAB_ContextItem_iE_Extensions,
        RAB_ContextItem,
        RAB_ContextItem_ExtIEs,
        ____RAB_ContextFailedtoTransferList__item___item__id_tab,
        _____RAB_ContextFailedtoTransferList__item___item__id_tab_val_Value_0,
        ___RAB_ContextFailedtoTransferList__item___item__id,
        ___RAB_ContextFailedtoTransferList__item___item__criticality,
        ___RAB_ContextFailedtoTransferList__item___item__value,
        __RAB_ContextFailedtoTransferList__item___item_,
        _RAB_ContextFailedtoTransferList__item_,
        RAB_ContextFailedtoTransferList,
        RABs_ContextFailedtoTransferItemIEs,
        _RABs_ContextFailedtoTransferItemIEs_val_Value_0,
        _RABs_ContextFailedtoTransferItem_rAB_ID,
        _RABs_ContextFailedtoTransferItem_cause,
        ____RABs_ContextFailedtoTransferItem_iE_Extensions__item__id_tab,
        ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__id,
        ____RABs_ContextFailedtoTransferItem_iE_Extensions__item__criticality_tab,
        ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__criticality,
        ____RABs_ContextFailedtoTransferItem_iE_Extensions__item__extensionValue_tab,
        ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__extensionValue,
        __RABs_ContextFailedtoTransferItem_iE_Extensions__item_,
        _RABs_ContextFailedtoTransferItem_iE_Extensions,
        RABs_ContextFailedtoTransferItem,
        RABs_ContextFailedtoTransferItem_ExtIEs,
        SRNS_ContextResponseExtensions,
        ____SecurityModeCommand_protocolIEs__item__id_tab,
        _____SecurityModeCommand_protocolIEs__item__id_tab_val_Value_0,
        _____SecurityModeCommand_protocolIEs__item__id_tab_val_Value_1,
        _____SecurityModeCommand_protocolIEs__item__id_tab_val_Value_2,
        ___SecurityModeCommand_protocolIEs__item__id,
        ___SecurityModeCommand_protocolIEs__item__criticality,
        ___SecurityModeCommand_protocolIEs__item__value,
        __SecurityModeCommand_protocolIEs__item_,
        _SecurityModeCommand_protocolIEs,
        ____SecurityModeCommand_protocolExtensions__item__id_tab,
        ___SecurityModeCommand_protocolExtensions__item__id,
        ____SecurityModeCommand_protocolExtensions__item__criticality_tab,
        ___SecurityModeCommand_protocolExtensions__item__criticality,
        ____SecurityModeCommand_protocolExtensions__item__extensionValue_tab,
        ___SecurityModeCommand_protocolExtensions__item__extensionValue,
        __SecurityModeCommand_protocolExtensions__item_,
        _SecurityModeCommand_protocolExtensions,
        SecurityModeCommand,
        SecurityModeCommandIEs,
        _SecurityModeCommandIEs_val_Value_0,
        _SecurityModeCommandIEs_val_Value_1,
        _SecurityModeCommandIEs_val_Value_2,
        SecurityModeCommandExtensions,
        ____SecurityModeComplete_protocolIEs__item__id_tab,
        _____SecurityModeComplete_protocolIEs__item__id_tab_val_Value_0,
        _____SecurityModeComplete_protocolIEs__item__id_tab_val_Value_1,
        _____SecurityModeComplete_protocolIEs__item__id_tab_val_Value_2,
        ___SecurityModeComplete_protocolIEs__item__id,
        ___SecurityModeComplete_protocolIEs__item__criticality,
        ___SecurityModeComplete_protocolIEs__item__value,
        __SecurityModeComplete_protocolIEs__item_,
        _SecurityModeComplete_protocolIEs,
        ____SecurityModeComplete_protocolExtensions__item__id_tab,
        ___SecurityModeComplete_protocolExtensions__item__id,
        ____SecurityModeComplete_protocolExtensions__item__criticality_tab,
        ___SecurityModeComplete_protocolExtensions__item__criticality,
        ____SecurityModeComplete_protocolExtensions__item__extensionValue_tab,
        ___SecurityModeComplete_protocolExtensions__item__extensionValue,
        __SecurityModeComplete_protocolExtensions__item_,
        _SecurityModeComplete_protocolExtensions,
        SecurityModeComplete,
        SecurityModeCompleteIEs,
        _SecurityModeCompleteIEs_val_Value_0,
        _SecurityModeCompleteIEs_val_Value_1,
        _SecurityModeCompleteIEs_val_Value_2,
        SecurityModeCompleteExtensions,
        ____SecurityModeReject_protocolIEs__item__id_tab,
        _____SecurityModeReject_protocolIEs__item__id_tab_val_Value_0,
        _____SecurityModeReject_protocolIEs__item__id_tab_val_Value_1,
        ___SecurityModeReject_protocolIEs__item__id,
        ___SecurityModeReject_protocolIEs__item__criticality,
        ___SecurityModeReject_protocolIEs__item__value,
        __SecurityModeReject_protocolIEs__item_,
        _SecurityModeReject_protocolIEs,
        ____SecurityModeReject_protocolExtensions__item__id_tab,
        ___SecurityModeReject_protocolExtensions__item__id,
        ____SecurityModeReject_protocolExtensions__item__criticality_tab,
        ___SecurityModeReject_protocolExtensions__item__criticality,
        ____SecurityModeReject_protocolExtensions__item__extensionValue_tab,
        ___SecurityModeReject_protocolExtensions__item__extensionValue,
        __SecurityModeReject_protocolExtensions__item_,
        _SecurityModeReject_protocolExtensions,
        SecurityModeReject,
        SecurityModeRejectIEs,
        _SecurityModeRejectIEs_val_Value_0,
        _SecurityModeRejectIEs_val_Value_1,
        SecurityModeRejectExtensions,
        ____DataVolumeReportRequest_protocolIEs__item__id_tab,
        _____DataVolumeReportRequest_protocolIEs__item__id_tab_val_Value_0,
        ___DataVolumeReportRequest_protocolIEs__item__id,
        ___DataVolumeReportRequest_protocolIEs__item__criticality,
        ___DataVolumeReportRequest_protocolIEs__item__value,
        __DataVolumeReportRequest_protocolIEs__item_,
        _DataVolumeReportRequest_protocolIEs,
        ____DataVolumeReportRequest_protocolExtensions__item__id_tab,
        ___DataVolumeReportRequest_protocolExtensions__item__id,
        ____DataVolumeReportRequest_protocolExtensions__item__criticality_tab,
        ___DataVolumeReportRequest_protocolExtensions__item__criticality,
        ____DataVolumeReportRequest_protocolExtensions__item__extensionValue_tab,
        ___DataVolumeReportRequest_protocolExtensions__item__extensionValue,
        __DataVolumeReportRequest_protocolExtensions__item_,
        _DataVolumeReportRequest_protocolExtensions,
        DataVolumeReportRequest,
        DataVolumeReportRequestIEs,
        _DataVolumeReportRequestIEs_val_Value_0,
        ____RAB_DataVolumeReportRequestList__item___item__id_tab,
        _____RAB_DataVolumeReportRequestList__item___item__id_tab_val_Value_0,
        ___RAB_DataVolumeReportRequestList__item___item__id,
        ___RAB_DataVolumeReportRequestList__item___item__criticality,
        ___RAB_DataVolumeReportRequestList__item___item__value,
        __RAB_DataVolumeReportRequestList__item___item_,
        _RAB_DataVolumeReportRequestList__item_,
        RAB_DataVolumeReportRequestList,
        RAB_DataVolumeReportRequestItemIEs,
        _RAB_DataVolumeReportRequestItemIEs_val_Value_0,
        _RAB_DataVolumeReportRequestItem_rAB_ID,
        ____RAB_DataVolumeReportRequestItem_iE_Extensions__item__id_tab,
        ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__id,
        ____RAB_DataVolumeReportRequestItem_iE_Extensions__item__criticality_tab,
        ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__criticality,
        ____RAB_DataVolumeReportRequestItem_iE_Extensions__item__extensionValue_tab,
        ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__extensionValue,
        __RAB_DataVolumeReportRequestItem_iE_Extensions__item_,
        _RAB_DataVolumeReportRequestItem_iE_Extensions,
        RAB_DataVolumeReportRequestItem,
        RAB_DataVolumeReportRequestItem_ExtIEs,
        DataVolumeReportRequestExtensions,
        ____DataVolumeReport_protocolIEs__item__id_tab,
        _____DataVolumeReport_protocolIEs__item__id_tab_val_Value_0,
        _____DataVolumeReport_protocolIEs__item__id_tab_val_Value_1,
        _____DataVolumeReport_protocolIEs__item__id_tab_val_Value_2,
        ___DataVolumeReport_protocolIEs__item__id,
        ___DataVolumeReport_protocolIEs__item__criticality,
        ___DataVolumeReport_protocolIEs__item__value,
        __DataVolumeReport_protocolIEs__item_,
        _DataVolumeReport_protocolIEs,
        ____DataVolumeReport_protocolExtensions__item__id_tab,
        ___DataVolumeReport_protocolExtensions__item__id,
        ____DataVolumeReport_protocolExtensions__item__criticality_tab,
        ___DataVolumeReport_protocolExtensions__item__criticality,
        ____DataVolumeReport_protocolExtensions__item__extensionValue_tab,
        ___DataVolumeReport_protocolExtensions__item__extensionValue,
        __DataVolumeReport_protocolExtensions__item_,
        _DataVolumeReport_protocolExtensions,
        DataVolumeReport,
        DataVolumeReportIEs,
        _DataVolumeReportIEs_val_Value_0,
        _DataVolumeReportIEs_val_Value_1,
        _DataVolumeReportIEs_val_Value_2,
        DataVolumeReportExtensions,
        ____RAB_FailedtoReportList__item___item__id_tab,
        _____RAB_FailedtoReportList__item___item__id_tab_val_Value_0,
        ___RAB_FailedtoReportList__item___item__id,
        ___RAB_FailedtoReportList__item___item__criticality,
        ___RAB_FailedtoReportList__item___item__value,
        __RAB_FailedtoReportList__item___item_,
        _RAB_FailedtoReportList__item_,
        RAB_FailedtoReportList,
        RABs_failed_to_reportItemIEs,
        _RABs_failed_to_reportItemIEs_val_Value_0,
        _RABs_failed_to_reportItem_rAB_ID,
        _RABs_failed_to_reportItem_cause,
        ____RABs_failed_to_reportItem_iE_Extensions__item__id_tab,
        ___RABs_failed_to_reportItem_iE_Extensions__item__id,
        ____RABs_failed_to_reportItem_iE_Extensions__item__criticality_tab,
        ___RABs_failed_to_reportItem_iE_Extensions__item__criticality,
        ____RABs_failed_to_reportItem_iE_Extensions__item__extensionValue_tab,
        ___RABs_failed_to_reportItem_iE_Extensions__item__extensionValue,
        __RABs_failed_to_reportItem_iE_Extensions__item_,
        _RABs_failed_to_reportItem_iE_Extensions,
        RABs_failed_to_reportItem,
        RABs_failed_to_reportItem_ExtIEs,
        ____Reset_protocolIEs__item__id_tab,
        _____Reset_protocolIEs__item__id_tab_val_Value_0,
        _____Reset_protocolIEs__item__id_tab_val_Value_1,
        _____Reset_protocolIEs__item__id_tab_val_Value_2,
        ___Reset_protocolIEs__item__id,
        ___Reset_protocolIEs__item__criticality,
        ___Reset_protocolIEs__item__value,
        __Reset_protocolIEs__item_,
        _Reset_protocolIEs,
        ____Reset_protocolExtensions__item__id_tab,
        _____Reset_protocolExtensions__item__id_tab_val_Extension_0,
        _____Reset_protocolExtensions__item__id_tab_val_Extension_1,
        ___Reset_protocolExtensions__item__id,
        ___Reset_protocolExtensions__item__criticality,
        ___Reset_protocolExtensions__item__extensionValue,
        __Reset_protocolExtensions__item_,
        _Reset_protocolExtensions,
        Reset,
        ResetIEs,
        _ResetIEs_val_Value_0,
        _ResetIEs_val_Value_1,
        _ResetIEs_val_Value_2,
        ResetExtensions,
        _ResetExtensions_val_Extension_0,
        _ResetExtensions_val_Extension_1,
        ____ResetAcknowledge_protocolIEs__item__id_tab,
        _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        ___ResetAcknowledge_protocolIEs__item__id,
        ___ResetAcknowledge_protocolIEs__item__criticality,
        ___ResetAcknowledge_protocolIEs__item__value,
        __ResetAcknowledge_protocolIEs__item_,
        _ResetAcknowledge_protocolIEs,
        ____ResetAcknowledge_protocolExtensions__item__id_tab,
        _____ResetAcknowledge_protocolExtensions__item__id_tab_val_Extension_0,
        _____ResetAcknowledge_protocolExtensions__item__id_tab_val_Extension_1,
        ___ResetAcknowledge_protocolExtensions__item__id,
        ___ResetAcknowledge_protocolExtensions__item__criticality,
        ___ResetAcknowledge_protocolExtensions__item__extensionValue,
        __ResetAcknowledge_protocolExtensions__item_,
        _ResetAcknowledge_protocolExtensions,
        ResetAcknowledge,
        ResetAcknowledgeIEs,
        _ResetAcknowledgeIEs_val_Value_0,
        _ResetAcknowledgeIEs_val_Value_1,
        _ResetAcknowledgeIEs_val_Value_2,
        ResetAcknowledgeExtensions,
        _ResetAcknowledgeExtensions_val_Extension_0,
        _ResetAcknowledgeExtensions_val_Extension_1,
        ____ResetResource_protocolIEs__item__id_tab,
        _____ResetResource_protocolIEs__item__id_tab_val_Value_0,
        _____ResetResource_protocolIEs__item__id_tab_val_Value_1,
        _____ResetResource_protocolIEs__item__id_tab_val_Value_2,
        _____ResetResource_protocolIEs__item__id_tab_val_Value_3,
        ___ResetResource_protocolIEs__item__id,
        ___ResetResource_protocolIEs__item__criticality,
        ___ResetResource_protocolIEs__item__value,
        __ResetResource_protocolIEs__item_,
        _ResetResource_protocolIEs,
        ____ResetResource_protocolExtensions__item__id_tab,
        _____ResetResource_protocolExtensions__item__id_tab_val_Extension_0,
        _____ResetResource_protocolExtensions__item__id_tab_val_Extension_1,
        ___ResetResource_protocolExtensions__item__id,
        ___ResetResource_protocolExtensions__item__criticality,
        ___ResetResource_protocolExtensions__item__extensionValue,
        __ResetResource_protocolExtensions__item_,
        _ResetResource_protocolExtensions,
        ResetResource,
        ResetResourceIEs,
        _ResetResourceIEs_val_Value_0,
        _ResetResourceIEs_val_Value_1,
        _ResetResourceIEs_val_Value_2,
        _ResetResourceIEs_val_Value_3,
        ____ResetResourceList__item___item__id_tab,
        _____ResetResourceList__item___item__id_tab_val_Value_0,
        ___ResetResourceList__item___item__id,
        ___ResetResourceList__item___item__criticality,
        ___ResetResourceList__item___item__value,
        __ResetResourceList__item___item_,
        _ResetResourceList__item_,
        ResetResourceList,
        ResetResourceItemIEs,
        _ResetResourceItemIEs_val_Value_0,
        _ResetResourceItem_iuSigConId,
        ____ResetResourceItem_iE_Extensions__item__id_tab,
        _____ResetResourceItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___ResetResourceItem_iE_Extensions__item__id,
        ___ResetResourceItem_iE_Extensions__item__criticality,
        ___ResetResourceItem_iE_Extensions__item__extensionValue,
        __ResetResourceItem_iE_Extensions__item_,
        _ResetResourceItem_iE_Extensions,
        ResetResourceItem,
        ResetResourceItem_ExtIEs,
        _ResetResourceItem_ExtIEs_val_Extension_0,
        ResetResourceExtensions,
        _ResetResourceExtensions_val_Extension_0,
        _ResetResourceExtensions_val_Extension_1,
        ____ResetResourceAcknowledge_protocolIEs__item__id_tab,
        _____ResetResourceAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____ResetResourceAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____ResetResourceAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____ResetResourceAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        ___ResetResourceAcknowledge_protocolIEs__item__id,
        ___ResetResourceAcknowledge_protocolIEs__item__criticality,
        ___ResetResourceAcknowledge_protocolIEs__item__value,
        __ResetResourceAcknowledge_protocolIEs__item_,
        _ResetResourceAcknowledge_protocolIEs,
        ____ResetResourceAcknowledge_protocolExtensions__item__id_tab,
        _____ResetResourceAcknowledge_protocolExtensions__item__id_tab_val_Extension_0,
        _____ResetResourceAcknowledge_protocolExtensions__item__id_tab_val_Extension_1,
        ___ResetResourceAcknowledge_protocolExtensions__item__id,
        ___ResetResourceAcknowledge_protocolExtensions__item__criticality,
        ___ResetResourceAcknowledge_protocolExtensions__item__extensionValue,
        __ResetResourceAcknowledge_protocolExtensions__item_,
        _ResetResourceAcknowledge_protocolExtensions,
        ResetResourceAcknowledge,
        ResetResourceAcknowledgeIEs,
        _ResetResourceAcknowledgeIEs_val_Value_0,
        _ResetResourceAcknowledgeIEs_val_Value_1,
        _ResetResourceAcknowledgeIEs_val_Value_2,
        _ResetResourceAcknowledgeIEs_val_Value_3,
        ____ResetResourceAckList__item___item__id_tab,
        _____ResetResourceAckList__item___item__id_tab_val_Value_0,
        ___ResetResourceAckList__item___item__id,
        ___ResetResourceAckList__item___item__criticality,
        ___ResetResourceAckList__item___item__value,
        __ResetResourceAckList__item___item_,
        _ResetResourceAckList__item_,
        ResetResourceAckList,
        ResetResourceAckItemIEs,
        _ResetResourceAckItemIEs_val_Value_0,
        _ResetResourceAckItem_iuSigConId,
        ____ResetResourceAckItem_iE_Extensions__item__id_tab,
        _____ResetResourceAckItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___ResetResourceAckItem_iE_Extensions__item__id,
        ___ResetResourceAckItem_iE_Extensions__item__criticality,
        ___ResetResourceAckItem_iE_Extensions__item__extensionValue,
        __ResetResourceAckItem_iE_Extensions__item_,
        _ResetResourceAckItem_iE_Extensions,
        ResetResourceAckItem,
        ResetResourceAckItem_ExtIEs,
        _ResetResourceAckItem_ExtIEs_val_Extension_0,
        ResetResourceAcknowledgeExtensions,
        _ResetResourceAcknowledgeExtensions_val_Extension_0,
        _ResetResourceAcknowledgeExtensions_val_Extension_1,
        ____RAB_ReleaseRequest_protocolIEs__item__id_tab,
        _____RAB_ReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        ___RAB_ReleaseRequest_protocolIEs__item__id,
        ___RAB_ReleaseRequest_protocolIEs__item__criticality,
        ___RAB_ReleaseRequest_protocolIEs__item__value,
        __RAB_ReleaseRequest_protocolIEs__item_,
        _RAB_ReleaseRequest_protocolIEs,
        ____RAB_ReleaseRequest_protocolExtensions__item__id_tab,
        ___RAB_ReleaseRequest_protocolExtensions__item__id,
        ____RAB_ReleaseRequest_protocolExtensions__item__criticality_tab,
        ___RAB_ReleaseRequest_protocolExtensions__item__criticality,
        ____RAB_ReleaseRequest_protocolExtensions__item__extensionValue_tab,
        ___RAB_ReleaseRequest_protocolExtensions__item__extensionValue,
        __RAB_ReleaseRequest_protocolExtensions__item_,
        _RAB_ReleaseRequest_protocolExtensions,
        RAB_ReleaseRequest,
        RAB_ReleaseRequestIEs,
        _RAB_ReleaseRequestIEs_val_Value_0,
        ____RAB_ReleaseList__item___item__id_tab,
        _____RAB_ReleaseList__item___item__id_tab_val_Value_0,
        ___RAB_ReleaseList__item___item__id,
        ___RAB_ReleaseList__item___item__criticality,
        ___RAB_ReleaseList__item___item__value,
        __RAB_ReleaseList__item___item_,
        _RAB_ReleaseList__item_,
        RAB_ReleaseList,
        RAB_ReleaseItemIEs,
        _RAB_ReleaseItemIEs_val_Value_0,
        _RAB_ReleaseItem_rAB_ID,
        _RAB_ReleaseItem_cause,
        ____RAB_ReleaseItem_iE_Extensions__item__id_tab,
        ___RAB_ReleaseItem_iE_Extensions__item__id,
        ____RAB_ReleaseItem_iE_Extensions__item__criticality_tab,
        ___RAB_ReleaseItem_iE_Extensions__item__criticality,
        ____RAB_ReleaseItem_iE_Extensions__item__extensionValue_tab,
        ___RAB_ReleaseItem_iE_Extensions__item__extensionValue,
        __RAB_ReleaseItem_iE_Extensions__item_,
        _RAB_ReleaseItem_iE_Extensions,
        RAB_ReleaseItem,
        RAB_ReleaseItem_ExtIEs,
        RAB_ReleaseRequestExtensions,
        ____Iu_ReleaseRequest_protocolIEs__item__id_tab,
        _____Iu_ReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        ___Iu_ReleaseRequest_protocolIEs__item__id,
        ___Iu_ReleaseRequest_protocolIEs__item__criticality,
        ___Iu_ReleaseRequest_protocolIEs__item__value,
        __Iu_ReleaseRequest_protocolIEs__item_,
        _Iu_ReleaseRequest_protocolIEs,
        ____Iu_ReleaseRequest_protocolExtensions__item__id_tab,
        ___Iu_ReleaseRequest_protocolExtensions__item__id,
        ____Iu_ReleaseRequest_protocolExtensions__item__criticality_tab,
        ___Iu_ReleaseRequest_protocolExtensions__item__criticality,
        ____Iu_ReleaseRequest_protocolExtensions__item__extensionValue_tab,
        ___Iu_ReleaseRequest_protocolExtensions__item__extensionValue,
        __Iu_ReleaseRequest_protocolExtensions__item_,
        _Iu_ReleaseRequest_protocolExtensions,
        Iu_ReleaseRequest,
        Iu_ReleaseRequestIEs,
        _Iu_ReleaseRequestIEs_val_Value_0,
        Iu_ReleaseRequestExtensions,
        ____RelocationDetect_protocolIEs__item__id_tab,
        ___RelocationDetect_protocolIEs__item__id,
        ____RelocationDetect_protocolIEs__item__criticality_tab,
        ___RelocationDetect_protocolIEs__item__criticality,
        ____RelocationDetect_protocolIEs__item__value_tab,
        ___RelocationDetect_protocolIEs__item__value,
        __RelocationDetect_protocolIEs__item_,
        _RelocationDetect_protocolIEs,
        ____RelocationDetect_protocolExtensions__item__id_tab,
        ___RelocationDetect_protocolExtensions__item__id,
        ____RelocationDetect_protocolExtensions__item__criticality_tab,
        ___RelocationDetect_protocolExtensions__item__criticality,
        ____RelocationDetect_protocolExtensions__item__extensionValue_tab,
        ___RelocationDetect_protocolExtensions__item__extensionValue,
        __RelocationDetect_protocolExtensions__item_,
        _RelocationDetect_protocolExtensions,
        RelocationDetect,
        RelocationDetectIEs,
        RelocationDetectExtensions,
        ____RelocationComplete_protocolIEs__item__id_tab,
        ___RelocationComplete_protocolIEs__item__id,
        ____RelocationComplete_protocolIEs__item__criticality_tab,
        ___RelocationComplete_protocolIEs__item__criticality,
        ____RelocationComplete_protocolIEs__item__value_tab,
        ___RelocationComplete_protocolIEs__item__value,
        __RelocationComplete_protocolIEs__item_,
        _RelocationComplete_protocolIEs,
        ____RelocationComplete_protocolExtensions__item__id_tab,
        _____RelocationComplete_protocolExtensions__item__id_tab_val_Extension_0,
        _____RelocationComplete_protocolExtensions__item__id_tab_val_Extension_1,
        _____RelocationComplete_protocolExtensions__item__id_tab_val_Extension_2,
        ___RelocationComplete_protocolExtensions__item__id,
        ___RelocationComplete_protocolExtensions__item__criticality,
        ___RelocationComplete_protocolExtensions__item__extensionValue,
        __RelocationComplete_protocolExtensions__item_,
        _RelocationComplete_protocolExtensions,
        RelocationComplete,
        RelocationCompleteIEs,
        RelocationCompleteExtensions,
        _RelocationCompleteExtensions_val_Extension_0,
        _RelocationCompleteExtensions_val_Extension_1,
        _RelocationCompleteExtensions_val_Extension_2,
        ____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab,
        _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_0,
        _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_1,
        _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_2,
        _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_3,
        _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_4,
        _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_5,
        _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_6,
        ___EnhancedRelocationCompleteRequest_protocolIEs__item__id,
        ___EnhancedRelocationCompleteRequest_protocolIEs__item__criticality,
        ___EnhancedRelocationCompleteRequest_protocolIEs__item__value,
        __EnhancedRelocationCompleteRequest_protocolIEs__item_,
        _EnhancedRelocationCompleteRequest_protocolIEs,
        ____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab,
        _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_0,
        _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_1,
        _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_2,
        _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_3,
        _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_4,
        _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_5,
        _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_6,
        ___EnhancedRelocationCompleteRequest_protocolExtensions__item__id,
        ___EnhancedRelocationCompleteRequest_protocolExtensions__item__criticality,
        ___EnhancedRelocationCompleteRequest_protocolExtensions__item__extensionValue,
        __EnhancedRelocationCompleteRequest_protocolExtensions__item_,
        _EnhancedRelocationCompleteRequest_protocolExtensions,
        EnhancedRelocationCompleteRequest,
        EnhancedRelocationCompleteRequestIEs,
        _EnhancedRelocationCompleteRequestIEs_val_Value_0,
        _EnhancedRelocationCompleteRequestIEs_val_Value_1,
        _EnhancedRelocationCompleteRequestIEs_val_Value_2,
        _EnhancedRelocationCompleteRequestIEs_val_Value_3,
        _EnhancedRelocationCompleteRequestIEs_val_Value_4,
        _EnhancedRelocationCompleteRequestIEs_val_Value_5,
        _EnhancedRelocationCompleteRequestIEs_val_Value_6,
        ____RAB_SetupList_EnhancedRelocCompleteReq__item___item__id_tab,
        _____RAB_SetupList_EnhancedRelocCompleteReq__item___item__id_tab_val_Value_0,
        ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__id,
        ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__criticality,
        ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__value,
        __RAB_SetupList_EnhancedRelocCompleteReq__item___item_,
        _RAB_SetupList_EnhancedRelocCompleteReq__item_,
        RAB_SetupList_EnhancedRelocCompleteReq,
        RAB_SetupItem_EnhancedRelocCompleteReq_IEs,
        _RAB_SetupItem_EnhancedRelocCompleteReq_IEs_val_Value_0,
        _RAB_SetupItem_EnhancedRelocCompleteReq_rAB_ID,
        _RAB_SetupItem_EnhancedRelocCompleteReq_transportLayerAddressReq1,
        _RAB_SetupItem_EnhancedRelocCompleteReq_iuTransportAssociationReq1,
        _RAB_SetupItem_EnhancedRelocCompleteReq_ass_RAB_Parameters,
        ____RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__id_tab,
        ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__id,
        ____RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__criticality_tab,
        ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__criticality,
        ____RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__extensionValue_tab,
        ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__extensionValue,
        __RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item_,
        _RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions,
        RAB_SetupItem_EnhancedRelocCompleteReq,
        RAB_SetupItem_EnhancedRelocCompleteReq_ExtIEs,
        EnhancedRelocationCompleteRequestExtensions,
        _EnhancedRelocationCompleteRequestExtensions_val_Extension_0,
        _EnhancedRelocationCompleteRequestExtensions_val_Extension_1,
        _EnhancedRelocationCompleteRequestExtensions_val_Extension_2,
        _EnhancedRelocationCompleteRequestExtensions_val_Extension_3,
        _EnhancedRelocationCompleteRequestExtensions_val_Extension_4,
        _EnhancedRelocationCompleteRequestExtensions_val_Extension_5,
        _EnhancedRelocationCompleteRequestExtensions_val_Extension_6,
        ____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab,
        _____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab_val_Value_0,
        _____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab_val_Value_1,
        _____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab_val_Value_2,
        ___EnhancedRelocationCompleteResponse_protocolIEs__item__id,
        ___EnhancedRelocationCompleteResponse_protocolIEs__item__criticality,
        ___EnhancedRelocationCompleteResponse_protocolIEs__item__value,
        __EnhancedRelocationCompleteResponse_protocolIEs__item_,
        _EnhancedRelocationCompleteResponse_protocolIEs,
        ____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab,
        _____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab_val_Extension_0,
        _____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab_val_Extension_1,
        _____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab_val_Extension_2,
        ___EnhancedRelocationCompleteResponse_protocolExtensions__item__id,
        ___EnhancedRelocationCompleteResponse_protocolExtensions__item__criticality,
        ___EnhancedRelocationCompleteResponse_protocolExtensions__item__extensionValue,
        __EnhancedRelocationCompleteResponse_protocolExtensions__item_,
        _EnhancedRelocationCompleteResponse_protocolExtensions,
        EnhancedRelocationCompleteResponse,
        EnhancedRelocationCompleteResponseIEs,
        _EnhancedRelocationCompleteResponseIEs_val_Value_0,
        _EnhancedRelocationCompleteResponseIEs_val_Value_1,
        _EnhancedRelocationCompleteResponseIEs_val_Value_2,
        ____RAB_SetupList_EnhancedRelocCompleteRes__item___item__id_tab,
        _____RAB_SetupList_EnhancedRelocCompleteRes__item___item__id_tab_val_Value_0,
        ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__id,
        ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__criticality,
        ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__value,
        __RAB_SetupList_EnhancedRelocCompleteRes__item___item_,
        _RAB_SetupList_EnhancedRelocCompleteRes__item_,
        RAB_SetupList_EnhancedRelocCompleteRes,
        RAB_SetupItem_EnhancedRelocCompleteRes_IEs,
        _RAB_SetupItem_EnhancedRelocCompleteRes_IEs_val_Value_0,
        _RAB_SetupItem_EnhancedRelocCompleteRes_rAB_ID,
        _RAB_SetupItem_EnhancedRelocCompleteRes_rAB_Parameters,
        _RAB_SetupItem_EnhancedRelocCompleteRes_userPlaneInformation,
        _RAB_SetupItem_EnhancedRelocCompleteRes_transportLayerAddressRes1,
        _RAB_SetupItem_EnhancedRelocCompleteRes_iuTransportAssociationRes1,
        _RAB_SetupItem_EnhancedRelocCompleteRes_rab2beReleasedList,
        ____RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id_tab,
        _____RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id_tab_val_Extension_0,
        ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id,
        ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality,
        ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue,
        __RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item_,
        _RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions,
        RAB_SetupItem_EnhancedRelocCompleteRes,
        RAB_SetupItem_EnhancedRelocCompleteRes_ExtIEs,
        _RAB_SetupItem_EnhancedRelocCompleteRes_ExtIEs_val_Extension_0,
        ____RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id_tab,
        _____RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id_tab_val_Value_0,
        ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id,
        ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__criticality,
        ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__value,
        __RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item_,
        _RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item_,
        RAB_ToBeReleasedList_EnhancedRelocCompleteRes,
        RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_IEs,
        _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_IEs_val_Value_0,
        _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_rAB_ID,
        _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_cause,
        ____RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__id_tab,
        ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__id,
        ____RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality_tab,
        ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality,
        ____RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue_tab,
        ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue,
        __RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item_,
        _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions,
        RAB_ToBeReleasedItem_EnhancedRelocCompleteRes,
        RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_ExtIEs,
        EnhancedRelocationCompleteResponseExtensions,
        _EnhancedRelocationCompleteResponseExtensions_val_Extension_0,
        _EnhancedRelocationCompleteResponseExtensions_val_Extension_1,
        _EnhancedRelocationCompleteResponseExtensions_val_Extension_2,
        ____EnhancedRelocationCompleteFailure_protocolIEs__item__id_tab,
        _____EnhancedRelocationCompleteFailure_protocolIEs__item__id_tab_val_Value_0,
        _____EnhancedRelocationCompleteFailure_protocolIEs__item__id_tab_val_Value_1,
        ___EnhancedRelocationCompleteFailure_protocolIEs__item__id,
        ___EnhancedRelocationCompleteFailure_protocolIEs__item__criticality,
        ___EnhancedRelocationCompleteFailure_protocolIEs__item__value,
        __EnhancedRelocationCompleteFailure_protocolIEs__item_,
        _EnhancedRelocationCompleteFailure_protocolIEs,
        ____EnhancedRelocationCompleteFailure_protocolExtensions__item__id_tab,
        ___EnhancedRelocationCompleteFailure_protocolExtensions__item__id,
        ____EnhancedRelocationCompleteFailure_protocolExtensions__item__criticality_tab,
        ___EnhancedRelocationCompleteFailure_protocolExtensions__item__criticality,
        ____EnhancedRelocationCompleteFailure_protocolExtensions__item__extensionValue_tab,
        ___EnhancedRelocationCompleteFailure_protocolExtensions__item__extensionValue,
        __EnhancedRelocationCompleteFailure_protocolExtensions__item_,
        _EnhancedRelocationCompleteFailure_protocolExtensions,
        EnhancedRelocationCompleteFailure,
        EnhancedRelocationCompleteFailureIEs,
        _EnhancedRelocationCompleteFailureIEs_val_Value_0,
        _EnhancedRelocationCompleteFailureIEs_val_Value_1,
        EnhancedRelocationCompleteFailureExtensions,
        ____EnhancedRelocationCompleteConfirm_protocolIEs__item__id_tab,
        _____EnhancedRelocationCompleteConfirm_protocolIEs__item__id_tab_val_Value_0,
        ___EnhancedRelocationCompleteConfirm_protocolIEs__item__id,
        ___EnhancedRelocationCompleteConfirm_protocolIEs__item__criticality,
        ___EnhancedRelocationCompleteConfirm_protocolIEs__item__value,
        __EnhancedRelocationCompleteConfirm_protocolIEs__item_,
        _EnhancedRelocationCompleteConfirm_protocolIEs,
        ____EnhancedRelocationCompleteConfirm_protocolExtensions__item__id_tab,
        ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__id,
        ____EnhancedRelocationCompleteConfirm_protocolExtensions__item__criticality_tab,
        ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__criticality,
        ____EnhancedRelocationCompleteConfirm_protocolExtensions__item__extensionValue_tab,
        ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__extensionValue,
        __EnhancedRelocationCompleteConfirm_protocolExtensions__item_,
        _EnhancedRelocationCompleteConfirm_protocolExtensions,
        EnhancedRelocationCompleteConfirm,
        EnhancedRelocationCompleteConfirmIEs,
        _EnhancedRelocationCompleteConfirmIEs_val_Value_0,
        EnhancedRelocationCompleteConfirmExtensions,
        ____Paging_protocolIEs__item__id_tab,
        _____Paging_protocolIEs__item__id_tab_val_Value_0,
        _____Paging_protocolIEs__item__id_tab_val_Value_1,
        _____Paging_protocolIEs__item__id_tab_val_Value_2,
        _____Paging_protocolIEs__item__id_tab_val_Value_3,
        _____Paging_protocolIEs__item__id_tab_val_Value_4,
        _____Paging_protocolIEs__item__id_tab_val_Value_5,
        _____Paging_protocolIEs__item__id_tab_val_Value_6,
        ___Paging_protocolIEs__item__id,
        ___Paging_protocolIEs__item__criticality,
        ___Paging_protocolIEs__item__value,
        __Paging_protocolIEs__item_,
        _Paging_protocolIEs,
        ____Paging_protocolExtensions__item__id_tab,
        _____Paging_protocolExtensions__item__id_tab_val_Extension_0,
        _____Paging_protocolExtensions__item__id_tab_val_Extension_1,
        ___Paging_protocolExtensions__item__id,
        ___Paging_protocolExtensions__item__criticality,
        ___Paging_protocolExtensions__item__extensionValue,
        __Paging_protocolExtensions__item_,
        _Paging_protocolExtensions,
        Paging,
        PagingIEs,
        _PagingIEs_val_Value_0,
        _PagingIEs_val_Value_1,
        _PagingIEs_val_Value_2,
        _PagingIEs_val_Value_3,
        _PagingIEs_val_Value_4,
        _PagingIEs_val_Value_5,
        _PagingIEs_val_Value_6,
        PagingExtensions,
        _PagingExtensions_val_Extension_0,
        _PagingExtensions_val_Extension_1,
        ____CommonID_protocolIEs__item__id_tab,
        _____CommonID_protocolIEs__item__id_tab_val_Value_0,
        ___CommonID_protocolIEs__item__id,
        ___CommonID_protocolIEs__item__criticality,
        ___CommonID_protocolIEs__item__value,
        __CommonID_protocolIEs__item_,
        _CommonID_protocolIEs,
        ____CommonID_protocolExtensions__item__id_tab,
        _____CommonID_protocolExtensions__item__id_tab_val_Extension_0,
        _____CommonID_protocolExtensions__item__id_tab_val_Extension_1,
        _____CommonID_protocolExtensions__item__id_tab_val_Extension_2,
        _____CommonID_protocolExtensions__item__id_tab_val_Extension_3,
        _____CommonID_protocolExtensions__item__id_tab_val_Extension_4,
        _____CommonID_protocolExtensions__item__id_tab_val_Extension_5,
        _____CommonID_protocolExtensions__item__id_tab_val_Extension_6,
        _____CommonID_protocolExtensions__item__id_tab_val_Extension_7,
        _____CommonID_protocolExtensions__item__id_tab_val_Extension_8,
        _____CommonID_protocolExtensions__item__id_tab_val_Extension_9,
        _____CommonID_protocolExtensions__item__id_tab_val_Extension_10,
        ___CommonID_protocolExtensions__item__id,
        ___CommonID_protocolExtensions__item__criticality,
        ___CommonID_protocolExtensions__item__extensionValue,
        __CommonID_protocolExtensions__item_,
        _CommonID_protocolExtensions,
        CommonID,
        CommonID_IEs,
        _CommonID_IEs_val_Value_0,
        CommonIDExtensions,
        _CommonIDExtensions_val_Extension_0,
        _CommonIDExtensions_val_Extension_1,
        _CommonIDExtensions_val_Extension_2,
        _CommonIDExtensions_val_Extension_3,
        _CommonIDExtensions_val_Extension_4,
        _CommonIDExtensions_val_Extension_5,
        _CommonIDExtensions_val_Extension_6,
        _CommonIDExtensions_val_Extension_7,
        _CommonIDExtensions_val_Extension_8,
        _CommonIDExtensions_val_Extension_9,
        _CommonIDExtensions_val_Extension_10,
        ____CN_InvokeTrace_protocolIEs__item__id_tab,
        _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_0,
        _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_1,
        _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_2,
        _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_3,
        _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_4,
        ___CN_InvokeTrace_protocolIEs__item__id,
        ___CN_InvokeTrace_protocolIEs__item__criticality,
        ___CN_InvokeTrace_protocolIEs__item__value,
        __CN_InvokeTrace_protocolIEs__item_,
        _CN_InvokeTrace_protocolIEs,
        ____CN_InvokeTrace_protocolExtensions__item__id_tab,
        _____CN_InvokeTrace_protocolExtensions__item__id_tab_val_Extension_0,
        _____CN_InvokeTrace_protocolExtensions__item__id_tab_val_Extension_1,
        _____CN_InvokeTrace_protocolExtensions__item__id_tab_val_Extension_2,
        _____CN_InvokeTrace_protocolExtensions__item__id_tab_val_Extension_3,
        ___CN_InvokeTrace_protocolExtensions__item__id,
        ___CN_InvokeTrace_protocolExtensions__item__criticality,
        ___CN_InvokeTrace_protocolExtensions__item__extensionValue,
        __CN_InvokeTrace_protocolExtensions__item_,
        _CN_InvokeTrace_protocolExtensions,
        CN_InvokeTrace,
        CN_InvokeTraceIEs,
        _CN_InvokeTraceIEs_val_Value_0,
        _CN_InvokeTraceIEs_val_Value_1,
        _CN_InvokeTraceIEs_val_Value_2,
        _CN_InvokeTraceIEs_val_Value_3,
        _CN_InvokeTraceIEs_val_Value_4,
        CN_InvokeTraceExtensions,
        _CN_InvokeTraceExtensions_val_Extension_0,
        _CN_InvokeTraceExtensions_val_Extension_1,
        _CN_InvokeTraceExtensions_val_Extension_2,
        _CN_InvokeTraceExtensions_val_Extension_3,
        ____CN_DeactivateTrace_protocolIEs__item__id_tab,
        _____CN_DeactivateTrace_protocolIEs__item__id_tab_val_Value_0,
        _____CN_DeactivateTrace_protocolIEs__item__id_tab_val_Value_1,
        ___CN_DeactivateTrace_protocolIEs__item__id,
        ___CN_DeactivateTrace_protocolIEs__item__criticality,
        ___CN_DeactivateTrace_protocolIEs__item__value,
        __CN_DeactivateTrace_protocolIEs__item_,
        _CN_DeactivateTrace_protocolIEs,
        ____CN_DeactivateTrace_protocolExtensions__item__id_tab,
        ___CN_DeactivateTrace_protocolExtensions__item__id,
        ____CN_DeactivateTrace_protocolExtensions__item__criticality_tab,
        ___CN_DeactivateTrace_protocolExtensions__item__criticality,
        ____CN_DeactivateTrace_protocolExtensions__item__extensionValue_tab,
        ___CN_DeactivateTrace_protocolExtensions__item__extensionValue,
        __CN_DeactivateTrace_protocolExtensions__item_,
        _CN_DeactivateTrace_protocolExtensions,
        CN_DeactivateTrace,
        CN_DeactivateTraceIEs,
        _CN_DeactivateTraceIEs_val_Value_0,
        _CN_DeactivateTraceIEs_val_Value_1,
        CN_DeactivateTraceExtensions,
        ____LocationReportingControl_protocolIEs__item__id_tab,
        _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_0,
        ___LocationReportingControl_protocolIEs__item__id,
        ___LocationReportingControl_protocolIEs__item__criticality,
        ___LocationReportingControl_protocolIEs__item__value,
        __LocationReportingControl_protocolIEs__item_,
        _LocationReportingControl_protocolIEs,
        ____LocationReportingControl_protocolExtensions__item__id_tab,
        _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_0,
        _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_1,
        _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_2,
        _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_3,
        _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_4,
        _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_5,
        ___LocationReportingControl_protocolExtensions__item__id,
        ___LocationReportingControl_protocolExtensions__item__criticality,
        ___LocationReportingControl_protocolExtensions__item__extensionValue,
        __LocationReportingControl_protocolExtensions__item_,
        _LocationReportingControl_protocolExtensions,
        LocationReportingControl,
        LocationReportingControlIEs,
        _LocationReportingControlIEs_val_Value_0,
        LocationReportingControlExtensions,
        _LocationReportingControlExtensions_val_Extension_0,
        _LocationReportingControlExtensions_val_Extension_1,
        _LocationReportingControlExtensions_val_Extension_2,
        _LocationReportingControlExtensions_val_Extension_3,
        _LocationReportingControlExtensions_val_Extension_4,
        _LocationReportingControlExtensions_val_Extension_5,
        ____LocationReport_protocolIEs__item__id_tab,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_0,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_1,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_2,
        ___LocationReport_protocolIEs__item__id,
        ___LocationReport_protocolIEs__item__criticality,
        ___LocationReport_protocolIEs__item__value,
        __LocationReport_protocolIEs__item_,
        _LocationReport_protocolIEs,
        ____LocationReport_protocolExtensions__item__id_tab,
        _____LocationReport_protocolExtensions__item__id_tab_val_Extension_0,
        _____LocationReport_protocolExtensions__item__id_tab_val_Extension_1,
        _____LocationReport_protocolExtensions__item__id_tab_val_Extension_2,
        _____LocationReport_protocolExtensions__item__id_tab_val_Extension_3,
        _____LocationReport_protocolExtensions__item__id_tab_val_Extension_4,
        _____LocationReport_protocolExtensions__item__id_tab_val_Extension_5,
        _____LocationReport_protocolExtensions__item__id_tab_val_Extension_6,
        ___LocationReport_protocolExtensions__item__id,
        ___LocationReport_protocolExtensions__item__criticality,
        ___LocationReport_protocolExtensions__item__extensionValue,
        __LocationReport_protocolExtensions__item_,
        _LocationReport_protocolExtensions,
        LocationReport,
        LocationReportIEs,
        _LocationReportIEs_val_Value_0,
        _LocationReportIEs_val_Value_1,
        _LocationReportIEs_val_Value_2,
        LocationReportExtensions,
        _LocationReportExtensions_val_Extension_0,
        _LocationReportExtensions_val_Extension_1,
        _LocationReportExtensions_val_Extension_2,
        _LocationReportExtensions_val_Extension_3,
        _LocationReportExtensions_val_Extension_4,
        _LocationReportExtensions_val_Extension_5,
        _LocationReportExtensions_val_Extension_6,
        ____InitialUE_Message_protocolIEs__item__id_tab,
        _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_0,
        _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_1,
        _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_2,
        _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_3,
        _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_4,
        _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_5,
        _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_6,
        ___InitialUE_Message_protocolIEs__item__id,
        ___InitialUE_Message_protocolIEs__item__criticality,
        ___InitialUE_Message_protocolIEs__item__value,
        __InitialUE_Message_protocolIEs__item_,
        _InitialUE_Message_protocolIEs,
        ____InitialUE_Message_protocolExtensions__item__id_tab,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_0,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_1,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_2,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_3,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_4,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_5,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_6,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_7,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_8,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_9,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_10,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_11,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_12,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_13,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_14,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_15,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_16,
        ___InitialUE_Message_protocolExtensions__item__id,
        ___InitialUE_Message_protocolExtensions__item__criticality,
        ___InitialUE_Message_protocolExtensions__item__extensionValue,
        __InitialUE_Message_protocolExtensions__item_,
        _InitialUE_Message_protocolExtensions,
        InitialUE_Message,
        InitialUE_MessageIEs,
        _InitialUE_MessageIEs_val_Value_0,
        _InitialUE_MessageIEs_val_Value_1,
        _InitialUE_MessageIEs_val_Value_2,
        _InitialUE_MessageIEs_val_Value_3,
        _InitialUE_MessageIEs_val_Value_4,
        _InitialUE_MessageIEs_val_Value_5,
        _InitialUE_MessageIEs_val_Value_6,
        InitialUE_MessageExtensions,
        _InitialUE_MessageExtensions_val_Extension_0,
        _InitialUE_MessageExtensions_val_Extension_1,
        _InitialUE_MessageExtensions_val_Extension_2,
        _InitialUE_MessageExtensions_val_Extension_3,
        _InitialUE_MessageExtensions_val_Extension_4,
        _InitialUE_MessageExtensions_val_Extension_5,
        _InitialUE_MessageExtensions_val_Extension_6,
        _InitialUE_MessageExtensions_val_Extension_7,
        _InitialUE_MessageExtensions_val_Extension_8,
        _InitialUE_MessageExtensions_val_Extension_9,
        _InitialUE_MessageExtensions_val_Extension_10,
        _InitialUE_MessageExtensions_val_Extension_11,
        _InitialUE_MessageExtensions_val_Extension_12,
        _InitialUE_MessageExtensions_val_Extension_13,
        _InitialUE_MessageExtensions_val_Extension_14,
        _InitialUE_MessageExtensions_val_Extension_15,
        _InitialUE_MessageExtensions_val_Extension_16,
        ____DirectTransfer_protocolIEs__item__id_tab,
        _____DirectTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____DirectTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____DirectTransfer_protocolIEs__item__id_tab_val_Value_2,
        _____DirectTransfer_protocolIEs__item__id_tab_val_Value_3,
        _____DirectTransfer_protocolIEs__item__id_tab_val_Value_4,
        ___DirectTransfer_protocolIEs__item__id,
        ___DirectTransfer_protocolIEs__item__criticality,
        ___DirectTransfer_protocolIEs__item__value,
        __DirectTransfer_protocolIEs__item_,
        _DirectTransfer_protocolIEs,
        ____DirectTransfer_protocolExtensions__item__id_tab,
        _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_0,
        _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_1,
        _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_2,
        _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_3,
        _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_4,
        _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_5,
        ___DirectTransfer_protocolExtensions__item__id,
        ___DirectTransfer_protocolExtensions__item__criticality,
        ___DirectTransfer_protocolExtensions__item__extensionValue,
        __DirectTransfer_protocolExtensions__item_,
        _DirectTransfer_protocolExtensions,
        DirectTransfer,
        DirectTransferIEs,
        _DirectTransferIEs_val_Value_0,
        _DirectTransferIEs_val_Value_1,
        _DirectTransferIEs_val_Value_2,
        _DirectTransferIEs_val_Value_3,
        _DirectTransferIEs_val_Value_4,
        DirectTransferExtensions,
        _DirectTransferExtensions_val_Extension_0,
        _DirectTransferExtensions_val_Extension_1,
        _DirectTransferExtensions_val_Extension_2,
        _DirectTransferExtensions_val_Extension_3,
        _DirectTransferExtensions_val_Extension_4,
        _DirectTransferExtensions_val_Extension_5,
        ___RedirectionIndication__item__id_tab,
        ____RedirectionIndication__item__id_tab_val_Value_0,
        ____RedirectionIndication__item__id_tab_val_Value_1,
        ____RedirectionIndication__item__id_tab_val_Value_2,
        ____RedirectionIndication__item__id_tab_val_Value_3,
        ____RedirectionIndication__item__id_tab_val_Value_4,
        __RedirectionIndication__item__id,
        __RedirectionIndication__item__criticality,
        __RedirectionIndication__item__value,
        _RedirectionIndication__item_,
        RedirectionIndication,
        RedirectionIndication_IEs,
        _RedirectionIndication_IEs_val_Value_0,
        _RedirectionIndication_IEs_val_Value_1,
        _RedirectionIndication_IEs_val_Value_2,
        _RedirectionIndication_IEs_val_Value_3,
        _RedirectionIndication_IEs_val_Value_4,
        ____Overload_protocolIEs__item__id_tab,
        _____Overload_protocolIEs__item__id_tab_val_Value_0,
        _____Overload_protocolIEs__item__id_tab_val_Value_1,
        ___Overload_protocolIEs__item__id,
        ___Overload_protocolIEs__item__criticality,
        ___Overload_protocolIEs__item__value,
        __Overload_protocolIEs__item_,
        _Overload_protocolIEs,
        ____Overload_protocolExtensions__item__id_tab,
        _____Overload_protocolExtensions__item__id_tab_val_Extension_0,
        _____Overload_protocolExtensions__item__id_tab_val_Extension_1,
        _____Overload_protocolExtensions__item__id_tab_val_Extension_2,
        _____Overload_protocolExtensions__item__id_tab_val_Extension_3,
        ___Overload_protocolExtensions__item__id,
        ___Overload_protocolExtensions__item__criticality,
        ___Overload_protocolExtensions__item__extensionValue,
        __Overload_protocolExtensions__item_,
        _Overload_protocolExtensions,
        Overload,
        OverloadIEs,
        _OverloadIEs_val_Value_0,
        _OverloadIEs_val_Value_1,
        OverloadExtensions,
        _OverloadExtensions_val_Extension_0,
        _OverloadExtensions_val_Extension_1,
        _OverloadExtensions_val_Extension_2,
        _OverloadExtensions_val_Extension_3,
        ____ErrorIndication_protocolIEs__item__id_tab,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3,
        ___ErrorIndication_protocolIEs__item__id,
        ___ErrorIndication_protocolIEs__item__criticality,
        ___ErrorIndication_protocolIEs__item__value,
        __ErrorIndication_protocolIEs__item_,
        _ErrorIndication_protocolIEs,
        ____ErrorIndication_protocolExtensions__item__id_tab,
        _____ErrorIndication_protocolExtensions__item__id_tab_val_Extension_0,
        _____ErrorIndication_protocolExtensions__item__id_tab_val_Extension_1,
        ___ErrorIndication_protocolExtensions__item__id,
        ___ErrorIndication_protocolExtensions__item__criticality,
        ___ErrorIndication_protocolExtensions__item__extensionValue,
        __ErrorIndication_protocolExtensions__item_,
        _ErrorIndication_protocolExtensions,
        ErrorIndication,
        ErrorIndicationIEs,
        _ErrorIndicationIEs_val_Value_0,
        _ErrorIndicationIEs_val_Value_1,
        _ErrorIndicationIEs_val_Value_2,
        _ErrorIndicationIEs_val_Value_3,
        ErrorIndicationExtensions,
        _ErrorIndicationExtensions_val_Extension_0,
        _ErrorIndicationExtensions_val_Extension_1,
        ____SRNS_DataForwardCommand_protocolIEs__item__id_tab,
        _____SRNS_DataForwardCommand_protocolIEs__item__id_tab_val_Value_0,
        ___SRNS_DataForwardCommand_protocolIEs__item__id,
        ___SRNS_DataForwardCommand_protocolIEs__item__criticality,
        ___SRNS_DataForwardCommand_protocolIEs__item__value,
        __SRNS_DataForwardCommand_protocolIEs__item_,
        _SRNS_DataForwardCommand_protocolIEs,
        ____SRNS_DataForwardCommand_protocolExtensions__item__id_tab,
        ___SRNS_DataForwardCommand_protocolExtensions__item__id,
        ____SRNS_DataForwardCommand_protocolExtensions__item__criticality_tab,
        ___SRNS_DataForwardCommand_protocolExtensions__item__criticality,
        ____SRNS_DataForwardCommand_protocolExtensions__item__extensionValue_tab,
        ___SRNS_DataForwardCommand_protocolExtensions__item__extensionValue,
        __SRNS_DataForwardCommand_protocolExtensions__item_,
        _SRNS_DataForwardCommand_protocolExtensions,
        SRNS_DataForwardCommand,
        SRNS_DataForwardCommandIEs,
        _SRNS_DataForwardCommandIEs_val_Value_0,
        SRNS_DataForwardCommandExtensions,
        ____ForwardSRNS_Context_protocolIEs__item__id_tab,
        _____ForwardSRNS_Context_protocolIEs__item__id_tab_val_Value_0,
        ___ForwardSRNS_Context_protocolIEs__item__id,
        ___ForwardSRNS_Context_protocolIEs__item__criticality,
        ___ForwardSRNS_Context_protocolIEs__item__value,
        __ForwardSRNS_Context_protocolIEs__item_,
        _ForwardSRNS_Context_protocolIEs,
        ____ForwardSRNS_Context_protocolExtensions__item__id_tab,
        _____ForwardSRNS_Context_protocolExtensions__item__id_tab_val_Extension_0,
        ___ForwardSRNS_Context_protocolExtensions__item__id,
        ___ForwardSRNS_Context_protocolExtensions__item__criticality,
        ___ForwardSRNS_Context_protocolExtensions__item__extensionValue,
        __ForwardSRNS_Context_protocolExtensions__item_,
        _ForwardSRNS_Context_protocolExtensions,
        ForwardSRNS_Context,
        ForwardSRNS_ContextIEs,
        _ForwardSRNS_ContextIEs_val_Value_0,
        ForwardSRNS_ContextExtensions,
        _ForwardSRNS_ContextExtensions_val_Extension_0,
        ____RAB_AssignmentRequest_protocolIEs__item__id_tab,
        _____RAB_AssignmentRequest_protocolIEs__item__id_tab_val_Value_0,
        _____RAB_AssignmentRequest_protocolIEs__item__id_tab_val_Value_1,
        ___RAB_AssignmentRequest_protocolIEs__item__id,
        ___RAB_AssignmentRequest_protocolIEs__item__criticality,
        ___RAB_AssignmentRequest_protocolIEs__item__value,
        __RAB_AssignmentRequest_protocolIEs__item_,
        _RAB_AssignmentRequest_protocolIEs,
        ____RAB_AssignmentRequest_protocolExtensions__item__id_tab,
        _____RAB_AssignmentRequest_protocolExtensions__item__id_tab_val_Extension_0,
        _____RAB_AssignmentRequest_protocolExtensions__item__id_tab_val_Extension_1,
        ___RAB_AssignmentRequest_protocolExtensions__item__id,
        ___RAB_AssignmentRequest_protocolExtensions__item__criticality,
        ___RAB_AssignmentRequest_protocolExtensions__item__extensionValue,
        __RAB_AssignmentRequest_protocolExtensions__item_,
        _RAB_AssignmentRequest_protocolExtensions,
        RAB_AssignmentRequest,
        RAB_AssignmentRequestIEs,
        _RAB_AssignmentRequestIEs_val_Value_0,
        _RAB_AssignmentRequestIEs_val_Value_1,
        ____RAB_SetupOrModifyList__item___item__id_tab,
        _____RAB_SetupOrModifyList__item___item__id_tab_val_FirstValue_0,
        _____RAB_SetupOrModifyList__item___item__id_tab_val_SecondValue_0,
        ___RAB_SetupOrModifyList__item___item__id,
        ___RAB_SetupOrModifyList__item___item__firstCriticality,
        ___RAB_SetupOrModifyList__item___item__firstValue,
        ___RAB_SetupOrModifyList__item___item__secondCriticality,
        ___RAB_SetupOrModifyList__item___item__secondValue,
        __RAB_SetupOrModifyList__item___item_,
        _RAB_SetupOrModifyList__item_,
        RAB_SetupOrModifyList,
        RAB_SetupOrModifyItem_IEs,
        _RAB_SetupOrModifyItem_IEs_val_FirstValue_0,
        _RAB_SetupOrModifyItem_IEs_val_SecondValue_0,
        _RAB_SetupOrModifyItemFirst_rAB_ID,
        _RAB_SetupOrModifyItemFirst_nAS_SynchronisationIndicator,
        _RAB_SetupOrModifyItemFirst_rAB_Parameters,
        _RAB_SetupOrModifyItemFirst_userPlaneInformation,
        _RAB_SetupOrModifyItemFirst_transportLayerInformation,
        _RAB_SetupOrModifyItemFirst_service_Handover,
        ____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab,
        _____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab_val_Extension_0,
        _____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab_val_Extension_1,
        _____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab_val_Extension_2,
        ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__id,
        ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__criticality,
        ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__extensionValue,
        __RAB_SetupOrModifyItemFirst_iE_Extensions__item_,
        _RAB_SetupOrModifyItemFirst_iE_Extensions,
        RAB_SetupOrModifyItemFirst,
        _TransportLayerInformation_transportLayerAddress,
        _TransportLayerInformation_iuTransportAssociation,
        ____TransportLayerInformation_iE_Extensions__item__id_tab,
        ___TransportLayerInformation_iE_Extensions__item__id,
        ____TransportLayerInformation_iE_Extensions__item__criticality_tab,
        ___TransportLayerInformation_iE_Extensions__item__criticality,
        ____TransportLayerInformation_iE_Extensions__item__extensionValue_tab,
        ___TransportLayerInformation_iE_Extensions__item__extensionValue,
        __TransportLayerInformation_iE_Extensions__item_,
        _TransportLayerInformation_iE_Extensions,
        TransportLayerInformation,
        TransportLayerInformation_ExtIEs,
        RAB_SetupOrModifyItemFirst_ExtIEs,
        _RAB_SetupOrModifyItemFirst_ExtIEs_val_Extension_0,
        _RAB_SetupOrModifyItemFirst_ExtIEs_val_Extension_1,
        _RAB_SetupOrModifyItemFirst_ExtIEs_val_Extension_2,
        _RAB_SetupOrModifyItemSecond_pDP_TypeInformation,
        _RAB_SetupOrModifyItemSecond_dataVolumeReportingIndication,
        _RAB_SetupOrModifyItemSecond_dl_GTP_PDU_SequenceNumber,
        _RAB_SetupOrModifyItemSecond_ul_GTP_PDU_SequenceNumber,
        _RAB_SetupOrModifyItemSecond_dl_N_PDU_SequenceNumber,
        _RAB_SetupOrModifyItemSecond_ul_N_PDU_SequenceNumber,
        ____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab,
        _____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab_val_Extension_0,
        _____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab_val_Extension_1,
        _____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab_val_Extension_2,
        _____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab_val_Extension_3,
        ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__id,
        ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__criticality,
        ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__extensionValue,
        __RAB_SetupOrModifyItemSecond_iE_Extensions__item_,
        _RAB_SetupOrModifyItemSecond_iE_Extensions,
        RAB_SetupOrModifyItemSecond,
        RAB_SetupOrModifyItemSecond_ExtIEs,
        _RAB_SetupOrModifyItemSecond_ExtIEs_val_Extension_0,
        _RAB_SetupOrModifyItemSecond_ExtIEs_val_Extension_1,
        _RAB_SetupOrModifyItemSecond_ExtIEs_val_Extension_2,
        _RAB_SetupOrModifyItemSecond_ExtIEs_val_Extension_3,
        RAB_AssignmentRequestExtensions,
        _RAB_AssignmentRequestExtensions_val_Extension_0,
        _RAB_AssignmentRequestExtensions_val_Extension_1,
        ____RAB_AssignmentResponse_protocolIEs__item__id_tab,
        _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_0,
        _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_1,
        _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_2,
        _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_3,
        _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_4,
        _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_5,
        ___RAB_AssignmentResponse_protocolIEs__item__id,
        ___RAB_AssignmentResponse_protocolIEs__item__criticality,
        ___RAB_AssignmentResponse_protocolIEs__item__value,
        __RAB_AssignmentResponse_protocolIEs__item_,
        _RAB_AssignmentResponse_protocolIEs,
        ____RAB_AssignmentResponse_protocolExtensions__item__id_tab,
        _____RAB_AssignmentResponse_protocolExtensions__item__id_tab_val_Extension_0,
        ___RAB_AssignmentResponse_protocolExtensions__item__id,
        ___RAB_AssignmentResponse_protocolExtensions__item__criticality,
        ___RAB_AssignmentResponse_protocolExtensions__item__extensionValue,
        __RAB_AssignmentResponse_protocolExtensions__item_,
        _RAB_AssignmentResponse_protocolExtensions,
        RAB_AssignmentResponse,
        RAB_AssignmentResponseIEs,
        _RAB_AssignmentResponseIEs_val_Value_0,
        _RAB_AssignmentResponseIEs_val_Value_1,
        _RAB_AssignmentResponseIEs_val_Value_2,
        _RAB_AssignmentResponseIEs_val_Value_3,
        _RAB_AssignmentResponseIEs_val_Value_4,
        _RAB_AssignmentResponseIEs_val_Value_5,
        ____RAB_SetupOrModifiedList__item___item__id_tab,
        _____RAB_SetupOrModifiedList__item___item__id_tab_val_Value_0,
        ___RAB_SetupOrModifiedList__item___item__id,
        ___RAB_SetupOrModifiedList__item___item__criticality,
        ___RAB_SetupOrModifiedList__item___item__value,
        __RAB_SetupOrModifiedList__item___item_,
        _RAB_SetupOrModifiedList__item_,
        RAB_SetupOrModifiedList,
        RAB_SetupOrModifiedItemIEs,
        _RAB_SetupOrModifiedItemIEs_val_Value_0,
        _RAB_SetupOrModifiedItem_rAB_ID,
        _RAB_SetupOrModifiedItem_transportLayerAddress,
        _RAB_SetupOrModifiedItem_iuTransportAssociation,
        _RAB_SetupOrModifiedItem_dl_dataVolumes,
        ____RAB_SetupOrModifiedItem_iE_Extensions__item__id_tab,
        _____RAB_SetupOrModifiedItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___RAB_SetupOrModifiedItem_iE_Extensions__item__id,
        ___RAB_SetupOrModifiedItem_iE_Extensions__item__criticality,
        ___RAB_SetupOrModifiedItem_iE_Extensions__item__extensionValue,
        __RAB_SetupOrModifiedItem_iE_Extensions__item_,
        _RAB_SetupOrModifiedItem_iE_Extensions,
        RAB_SetupOrModifiedItem,
        RAB_SetupOrModifiedItem_ExtIEs,
        _RAB_SetupOrModifiedItem_ExtIEs_val_Extension_0,
        ____RAB_ReleasedList__item___item__id_tab,
        _____RAB_ReleasedList__item___item__id_tab_val_Value_0,
        ___RAB_ReleasedList__item___item__id,
        ___RAB_ReleasedList__item___item__criticality,
        ___RAB_ReleasedList__item___item__value,
        __RAB_ReleasedList__item___item_,
        _RAB_ReleasedList__item_,
        RAB_ReleasedList,
        RAB_ReleasedItemIEs,
        _RAB_ReleasedItemIEs_val_Value_0,
        _RAB_ReleasedItem_rAB_ID,
        _RAB_ReleasedItem_dl_dataVolumes,
        _RAB_ReleasedItem_dL_GTP_PDU_SequenceNumber,
        _RAB_ReleasedItem_uL_GTP_PDU_SequenceNumber,
        ____RAB_ReleasedItem_iE_Extensions__item__id_tab,
        ___RAB_ReleasedItem_iE_Extensions__item__id,
        ____RAB_ReleasedItem_iE_Extensions__item__criticality_tab,
        ___RAB_ReleasedItem_iE_Extensions__item__criticality,
        ____RAB_ReleasedItem_iE_Extensions__item__extensionValue_tab,
        ___RAB_ReleasedItem_iE_Extensions__item__extensionValue,
        __RAB_ReleasedItem_iE_Extensions__item_,
        _RAB_ReleasedItem_iE_Extensions,
        RAB_ReleasedItem,
        RAB_ReleasedItem_ExtIEs,
        __DataVolumeList__item__dl_UnsuccessfullyTransmittedDataVolume,
        __DataVolumeList__item__dataVolumeReference,
        _____DataVolumeList__item__iE_Extensions__item__id_tab,
        ____DataVolumeList__item__iE_Extensions__item__id,
        _____DataVolumeList__item__iE_Extensions__item__criticality_tab,
        ____DataVolumeList__item__iE_Extensions__item__criticality,
        _____DataVolumeList__item__iE_Extensions__item__extensionValue_tab,
        ____DataVolumeList__item__iE_Extensions__item__extensionValue,
        ___DataVolumeList__item__iE_Extensions__item_,
        __DataVolumeList__item__iE_Extensions,
        _DataVolumeList__item_,
        DataVolumeList,
        DataVolumeList_ExtIEs,
        ____RAB_QueuedList__item___item__id_tab,
        _____RAB_QueuedList__item___item__id_tab_val_Value_0,
        ___RAB_QueuedList__item___item__id,
        ___RAB_QueuedList__item___item__criticality,
        ___RAB_QueuedList__item___item__value,
        __RAB_QueuedList__item___item_,
        _RAB_QueuedList__item_,
        RAB_QueuedList,
        RAB_QueuedItemIEs,
        _RAB_QueuedItemIEs_val_Value_0,
        _RAB_QueuedItem_rAB_ID,
        ____RAB_QueuedItem_iE_Extensions__item__id_tab,
        ___RAB_QueuedItem_iE_Extensions__item__id,
        ____RAB_QueuedItem_iE_Extensions__item__criticality_tab,
        ___RAB_QueuedItem_iE_Extensions__item__criticality,
        ____RAB_QueuedItem_iE_Extensions__item__extensionValue_tab,
        ___RAB_QueuedItem_iE_Extensions__item__extensionValue,
        __RAB_QueuedItem_iE_Extensions__item_,
        _RAB_QueuedItem_iE_Extensions,
        RAB_QueuedItem,
        RAB_QueuedItem_ExtIEs,
        RAB_ReleaseFailedList,
        RAB_AssignmentResponseExtensions,
        _RAB_AssignmentResponseExtensions_val_Extension_0,
        ____GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id_tab,
        _____GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id_tab_val_Value_0,
        ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id,
        ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__criticality,
        ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__value,
        __GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item_,
        _GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item_,
        GERAN_Iumode_RAB_FailedList_RABAssgntResponse,
        GERAN_Iumode_RAB_Failed_RABAssgntResponse_ItemIEs,
        _GERAN_Iumode_RAB_Failed_RABAssgntResponse_ItemIEs_val_Value_0,
        _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_rAB_ID,
        _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_cause,
        _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_gERAN_Classmark,
        ____GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__id_tab,
        ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__id,
        ____GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__criticality_tab,
        ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__criticality,
        ____GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__extensionValue_tab,
        ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__extensionValue,
        __GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item_,
        _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions,
        GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item,
        GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_ExtIEs,
        ____PrivateMessage_privateIEs__item__id_tab,
        ___PrivateMessage_privateIEs__item__id,
        ____PrivateMessage_privateIEs__item__criticality_tab,
        ___PrivateMessage_privateIEs__item__criticality,
        ____PrivateMessage_privateIEs__item__value_tab,
        ___PrivateMessage_privateIEs__item__value,
        __PrivateMessage_privateIEs__item_,
        _PrivateMessage_privateIEs,
        PrivateMessage,
        PrivateMessage_IEs,
        ____RANAP_RelocationInformation_protocolIEs__item__id_tab,
        _____RANAP_RelocationInformation_protocolIEs__item__id_tab_val_Value_0,
        _____RANAP_RelocationInformation_protocolIEs__item__id_tab_val_Value_1,
        ___RANAP_RelocationInformation_protocolIEs__item__id,
        ___RANAP_RelocationInformation_protocolIEs__item__criticality,
        ___RANAP_RelocationInformation_protocolIEs__item__value,
        __RANAP_RelocationInformation_protocolIEs__item_,
        _RANAP_RelocationInformation_protocolIEs,
        ____RANAP_RelocationInformation_protocolExtensions__item__id_tab,
        _____RANAP_RelocationInformation_protocolExtensions__item__id_tab_val_Extension_0,
        _____RANAP_RelocationInformation_protocolExtensions__item__id_tab_val_Extension_1,
        ___RANAP_RelocationInformation_protocolExtensions__item__id,
        ___RANAP_RelocationInformation_protocolExtensions__item__criticality,
        ___RANAP_RelocationInformation_protocolExtensions__item__extensionValue,
        __RANAP_RelocationInformation_protocolExtensions__item_,
        _RANAP_RelocationInformation_protocolExtensions,
        RANAP_RelocationInformation,
        RANAP_RelocationInformationIEs,
        _RANAP_RelocationInformationIEs_val_Value_0,
        _RANAP_RelocationInformationIEs_val_Value_1,
        ____DirectTransferInformationList_RANAP_RelocInf__item___item__id_tab,
        _____DirectTransferInformationList_RANAP_RelocInf__item___item__id_tab_val_Value_0,
        ___DirectTransferInformationList_RANAP_RelocInf__item___item__id,
        ___DirectTransferInformationList_RANAP_RelocInf__item___item__criticality,
        ___DirectTransferInformationList_RANAP_RelocInf__item___item__value,
        __DirectTransferInformationList_RANAP_RelocInf__item___item_,
        _DirectTransferInformationList_RANAP_RelocInf__item_,
        DirectTransferInformationList_RANAP_RelocInf,
        DirectTransferInformationItemIEs_RANAP_RelocInf,
        _DirectTransferInformationItemIEs_RANAP_RelocInf_val_Value_0,
        _DirectTransferInformationItem_RANAP_RelocInf_nAS_PDU,
        _DirectTransferInformationItem_RANAP_RelocInf_sAPI,
        _DirectTransferInformationItem_RANAP_RelocInf_cN_DomainIndicator,
        ____DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__id_tab,
        ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__id,
        ____DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__criticality_tab,
        ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__criticality,
        ____DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__extensionValue_tab,
        ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__extensionValue,
        __DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item_,
        _DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions,
        DirectTransferInformationItem_RANAP_RelocInf,
        RANAP_DirectTransferInformationItem_ExtIEs_RANAP_RelocInf,
        ____RAB_ContextList_RANAP_RelocInf__item___item__id_tab,
        _____RAB_ContextList_RANAP_RelocInf__item___item__id_tab_val_Value_0,
        ___RAB_ContextList_RANAP_RelocInf__item___item__id,
        ___RAB_ContextList_RANAP_RelocInf__item___item__criticality,
        ___RAB_ContextList_RANAP_RelocInf__item___item__value,
        __RAB_ContextList_RANAP_RelocInf__item___item_,
        _RAB_ContextList_RANAP_RelocInf__item_,
        RAB_ContextList_RANAP_RelocInf,
        RAB_ContextItemIEs_RANAP_RelocInf,
        _RAB_ContextItemIEs_RANAP_RelocInf_val_Value_0,
        _RAB_ContextItem_RANAP_RelocInf_rAB_ID,
        _RAB_ContextItem_RANAP_RelocInf_dl_GTP_PDU_SequenceNumber,
        _RAB_ContextItem_RANAP_RelocInf_ul_GTP_PDU_SequenceNumber,
        _RAB_ContextItem_RANAP_RelocInf_dl_N_PDU_SequenceNumber,
        _RAB_ContextItem_RANAP_RelocInf_ul_N_PDU_SequenceNumber,
        ____RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__id_tab,
        ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__id,
        ____RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__criticality_tab,
        ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__criticality,
        ____RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__extensionValue_tab,
        ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__extensionValue,
        __RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item_,
        _RAB_ContextItem_RANAP_RelocInf_iE_Extensions,
        RAB_ContextItem_RANAP_RelocInf,
        RAB_ContextItem_ExtIEs_RANAP_RelocInf,
        RANAP_RelocationInformationExtensions,
        _RANAP_RelocationInformationExtensions_val_Extension_0,
        _RANAP_RelocationInformationExtensions_val_Extension_1,
        ____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab,
        _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_5,
        _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_6,
        _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_7,
        _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_8,
        _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_9,
        ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id,
        ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__criticality,
        ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__value,
        __RANAP_EnhancedRelocationInformationRequest_protocolIEs__item_,
        _RANAP_EnhancedRelocationInformationRequest_protocolIEs,
        ____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab,
        _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_0,
        _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_1,
        _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_2,
        _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_3,
        _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_4,
        _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_5,
        _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_6,
        ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id,
        ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__criticality,
        ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__extensionValue,
        __RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item_,
        _RANAP_EnhancedRelocationInformationRequest_protocolExtensions,
        RANAP_EnhancedRelocationInformationRequest,
        RANAP_EnhancedRelocationInformationRequestIEs,
        _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_0,
        _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_1,
        _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_2,
        _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_3,
        _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_4,
        _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_5,
        _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_6,
        _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_7,
        _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_8,
        _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_9,
        ____RAB_SetupList_EnhRelocInfoReq__item___item__id_tab,
        _____RAB_SetupList_EnhRelocInfoReq__item___item__id_tab_val_Value_0,
        ___RAB_SetupList_EnhRelocInfoReq__item___item__id,
        ___RAB_SetupList_EnhRelocInfoReq__item___item__criticality,
        ___RAB_SetupList_EnhRelocInfoReq__item___item__value,
        __RAB_SetupList_EnhRelocInfoReq__item___item_,
        _RAB_SetupList_EnhRelocInfoReq__item_,
        RAB_SetupList_EnhRelocInfoReq,
        RAB_SetupItem_EnhRelocInfoReq_IEs,
        _RAB_SetupItem_EnhRelocInfoReq_IEs_val_Value_0,
        _RAB_SetupItem_EnhRelocInfoReq_rAB_ID,
        _RAB_SetupItem_EnhRelocInfoReq_cN_DomainIndicator,
        _RAB_SetupItem_EnhRelocInfoReq_rAB_Parameters,
        _RAB_SetupItem_EnhRelocInfoReq_dataVolumeReportingIndication,
        _RAB_SetupItem_EnhRelocInfoReq_pDP_TypeInformation,
        _RAB_SetupItem_EnhRelocInfoReq_userPlaneInformation,
        _RAB_SetupItem_EnhRelocInfoReq_dataForwardingInformation,
        _RAB_SetupItem_EnhRelocInfoReq_sourceSideIuULTNLInfo,
        _RAB_SetupItem_EnhRelocInfoReq_service_Handover,
        _RAB_SetupItem_EnhRelocInfoReq_alt_RAB_Parameters,
        ____RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id_tab,
        _____RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id_tab_val_Extension_0,
        _____RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id_tab_val_Extension_1,
        ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id,
        ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__criticality,
        ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__extensionValue,
        __RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item_,
        _RAB_SetupItem_EnhRelocInfoReq_iE_Extensions,
        RAB_SetupItem_EnhRelocInfoReq,
        RAB_SetupItem_EnhRelocInfoReq_ExtIEs,
        _RAB_SetupItem_EnhRelocInfoReq_ExtIEs_val_Extension_0,
        _RAB_SetupItem_EnhRelocInfoReq_ExtIEs_val_Extension_1,
        _TNLInformationEnhRelInfoReq_transportLayerAddress,
        _TNLInformationEnhRelInfoReq_iuTransportAssociation,
        ____TNLInformationEnhRelInfoReq_iE_Extensions__item__id_tab,
        ___TNLInformationEnhRelInfoReq_iE_Extensions__item__id,
        ____TNLInformationEnhRelInfoReq_iE_Extensions__item__criticality_tab,
        ___TNLInformationEnhRelInfoReq_iE_Extensions__item__criticality,
        ____TNLInformationEnhRelInfoReq_iE_Extensions__item__extensionValue_tab,
        ___TNLInformationEnhRelInfoReq_iE_Extensions__item__extensionValue,
        __TNLInformationEnhRelInfoReq_iE_Extensions__item_,
        _TNLInformationEnhRelInfoReq_iE_Extensions,
        TNLInformationEnhRelInfoReq,
        TNLInformationEnhRelInfoReq_ExtIEs,
        RANAP_EnhancedRelocationInformationRequestExtensions,
        _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_0,
        _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_1,
        _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_2,
        _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_3,
        _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_4,
        _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_5,
        _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_6,
        ____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab,
        _____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab_val_Value_3,
        ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id,
        ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__criticality,
        ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__value,
        __RANAP_EnhancedRelocationInformationResponse_protocolIEs__item_,
        _RANAP_EnhancedRelocationInformationResponse_protocolIEs,
        ____RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__id_tab,
        ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__id,
        ____RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__criticality_tab,
        ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__criticality,
        ____RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__extensionValue_tab,
        ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__extensionValue,
        __RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item_,
        _RANAP_EnhancedRelocationInformationResponse_protocolExtensions,
        RANAP_EnhancedRelocationInformationResponse,
        RANAP_EnhancedRelocationInformationResponseIEs,
        _RANAP_EnhancedRelocationInformationResponseIEs_val_Value_0,
        _RANAP_EnhancedRelocationInformationResponseIEs_val_Value_1,
        _RANAP_EnhancedRelocationInformationResponseIEs_val_Value_2,
        _RANAP_EnhancedRelocationInformationResponseIEs_val_Value_3,
        ____RAB_SetupList_EnhRelocInfoRes__item___item__id_tab,
        _____RAB_SetupList_EnhRelocInfoRes__item___item__id_tab_val_Value_0,
        ___RAB_SetupList_EnhRelocInfoRes__item___item__id,
        ___RAB_SetupList_EnhRelocInfoRes__item___item__criticality,
        ___RAB_SetupList_EnhRelocInfoRes__item___item__value,
        __RAB_SetupList_EnhRelocInfoRes__item___item_,
        _RAB_SetupList_EnhRelocInfoRes__item_,
        RAB_SetupList_EnhRelocInfoRes,
        RAB_SetupItem_EnhRelocInfoRes_IEs,
        _RAB_SetupItem_EnhRelocInfoRes_IEs_val_Value_0,
        _RAB_SetupItem_EnhRelocInfoRes_cN_DomainIndicator,
        _RAB_SetupItem_EnhRelocInfoRes_rAB_ID,
        _RAB_SetupItem_EnhRelocInfoRes_dataForwardingInformation,
        _RAB_SetupItem_EnhRelocInfoRes_ass_RAB_Parameters,
        ____RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__id_tab,
        ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__id,
        ____RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__criticality_tab,
        ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__criticality,
        ____RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue_tab,
        ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue,
        __RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item_,
        _RAB_SetupItem_EnhRelocInfoRes_iE_Extensions,
        RAB_SetupItem_EnhRelocInfoRes,
        RAB_SetupItem_EnhRelocInfoRes_ExtIEs,
        ____RAB_FailedList_EnhRelocInfoRes__item___item__id_tab,
        _____RAB_FailedList_EnhRelocInfoRes__item___item__id_tab_val_Value_0,
        ___RAB_FailedList_EnhRelocInfoRes__item___item__id,
        ___RAB_FailedList_EnhRelocInfoRes__item___item__criticality,
        ___RAB_FailedList_EnhRelocInfoRes__item___item__value,
        __RAB_FailedList_EnhRelocInfoRes__item___item_,
        _RAB_FailedList_EnhRelocInfoRes__item_,
        RAB_FailedList_EnhRelocInfoRes,
        RAB_FailedItem_EnhRelocInfoRes_IEs,
        _RAB_FailedItem_EnhRelocInfoRes_IEs_val_Value_0,
        _RAB_FailedItem_EnhRelocInfoRes_cN_DomainIndicator,
        _RAB_FailedItem_EnhRelocInfoRes_rAB_ID,
        _RAB_FailedItem_EnhRelocInfoRes_cause,
        ____RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__id_tab,
        ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__id,
        ____RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__criticality_tab,
        ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__criticality,
        ____RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue_tab,
        ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue,
        __RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item_,
        _RAB_FailedItem_EnhRelocInfoRes_iE_Extensions,
        RAB_FailedItem_EnhRelocInfoRes,
        RAB_FailedItem_EnhRelocInfoRes_ExtIEs,
        _TNLInformationEnhRelInfoRes_dl_forwardingTransportLayerAddress,
        _TNLInformationEnhRelInfoRes_dl_forwardingTransportAssociation,
        ____TNLInformationEnhRelInfoRes_iE_Extensions__item__id_tab,
        ___TNLInformationEnhRelInfoRes_iE_Extensions__item__id,
        ____TNLInformationEnhRelInfoRes_iE_Extensions__item__criticality_tab,
        ___TNLInformationEnhRelInfoRes_iE_Extensions__item__criticality,
        ____TNLInformationEnhRelInfoRes_iE_Extensions__item__extensionValue_tab,
        ___TNLInformationEnhRelInfoRes_iE_Extensions__item__extensionValue,
        __TNLInformationEnhRelInfoRes_iE_Extensions__item_,
        _TNLInformationEnhRelInfoRes_iE_Extensions,
        TNLInformationEnhRelInfoRes,
        TNLInformationEnhRelInfoRes_ExtIEs,
        RANAP_EnhancedRelocationInformationResponseExtensions,
        ____RAB_ModifyRequest_protocolIEs__item__id_tab,
        _____RAB_ModifyRequest_protocolIEs__item__id_tab_val_Value_0,
        ___RAB_ModifyRequest_protocolIEs__item__id,
        ___RAB_ModifyRequest_protocolIEs__item__criticality,
        ___RAB_ModifyRequest_protocolIEs__item__value,
        __RAB_ModifyRequest_protocolIEs__item_,
        _RAB_ModifyRequest_protocolIEs,
        ____RAB_ModifyRequest_protocolExtensions__item__id_tab,
        ___RAB_ModifyRequest_protocolExtensions__item__id,
        ____RAB_ModifyRequest_protocolExtensions__item__criticality_tab,
        ___RAB_ModifyRequest_protocolExtensions__item__criticality,
        ____RAB_ModifyRequest_protocolExtensions__item__extensionValue_tab,
        ___RAB_ModifyRequest_protocolExtensions__item__extensionValue,
        __RAB_ModifyRequest_protocolExtensions__item_,
        _RAB_ModifyRequest_protocolExtensions,
        RAB_ModifyRequest,
        RAB_ModifyRequestIEs,
        _RAB_ModifyRequestIEs_val_Value_0,
        ____RAB_ModifyList__item___item__id_tab,
        _____RAB_ModifyList__item___item__id_tab_val_Value_0,
        ___RAB_ModifyList__item___item__id,
        ___RAB_ModifyList__item___item__criticality,
        ___RAB_ModifyList__item___item__value,
        __RAB_ModifyList__item___item_,
        _RAB_ModifyList__item_,
        RAB_ModifyList,
        RAB_ModifyItemIEs,
        _RAB_ModifyItemIEs_val_Value_0,
        _RAB_ModifyItem_rAB_ID,
        _RAB_ModifyItem_requested_RAB_Parameter_Values,
        ____RAB_ModifyItem_iE_Extensions__item__id_tab,
        ___RAB_ModifyItem_iE_Extensions__item__id,
        ____RAB_ModifyItem_iE_Extensions__item__criticality_tab,
        ___RAB_ModifyItem_iE_Extensions__item__criticality,
        ____RAB_ModifyItem_iE_Extensions__item__extensionValue_tab,
        ___RAB_ModifyItem_iE_Extensions__item__extensionValue,
        __RAB_ModifyItem_iE_Extensions__item_,
        _RAB_ModifyItem_iE_Extensions,
        RAB_ModifyItem,
        RAB_ModifyItem_ExtIEs,
        RAB_ModifyRequestExtensions,
        ____LocationRelatedDataRequest_protocolIEs__item__id_tab,
        _____LocationRelatedDataRequest_protocolIEs__item__id_tab_val_Value_0,
        ___LocationRelatedDataRequest_protocolIEs__item__id,
        ___LocationRelatedDataRequest_protocolIEs__item__criticality,
        ___LocationRelatedDataRequest_protocolIEs__item__value,
        __LocationRelatedDataRequest_protocolIEs__item_,
        _LocationRelatedDataRequest_protocolIEs,
        ____LocationRelatedDataRequest_protocolExtensions__item__id_tab,
        _____LocationRelatedDataRequest_protocolExtensions__item__id_tab_val_Extension_0,
        _____LocationRelatedDataRequest_protocolExtensions__item__id_tab_val_Extension_1,
        ___LocationRelatedDataRequest_protocolExtensions__item__id,
        ___LocationRelatedDataRequest_protocolExtensions__item__criticality,
        ___LocationRelatedDataRequest_protocolExtensions__item__extensionValue,
        __LocationRelatedDataRequest_protocolExtensions__item_,
        _LocationRelatedDataRequest_protocolExtensions,
        LocationRelatedDataRequest,
        LocationRelatedDataRequestIEs,
        _LocationRelatedDataRequestIEs_val_Value_0,
        LocationRelatedDataRequestExtensions,
        _LocationRelatedDataRequestExtensions_val_Extension_0,
        _LocationRelatedDataRequestExtensions_val_Extension_1,
        ____LocationRelatedDataResponse_protocolIEs__item__id_tab,
        _____LocationRelatedDataResponse_protocolIEs__item__id_tab_val_Value_0,
        ___LocationRelatedDataResponse_protocolIEs__item__id,
        ___LocationRelatedDataResponse_protocolIEs__item__criticality,
        ___LocationRelatedDataResponse_protocolIEs__item__value,
        __LocationRelatedDataResponse_protocolIEs__item_,
        _LocationRelatedDataResponse_protocolIEs,
        ____LocationRelatedDataResponse_protocolExtensions__item__id_tab,
        _____LocationRelatedDataResponse_protocolExtensions__item__id_tab_val_Extension_0,
        _____LocationRelatedDataResponse_protocolExtensions__item__id_tab_val_Extension_1,
        ___LocationRelatedDataResponse_protocolExtensions__item__id,
        ___LocationRelatedDataResponse_protocolExtensions__item__criticality,
        ___LocationRelatedDataResponse_protocolExtensions__item__extensionValue,
        __LocationRelatedDataResponse_protocolExtensions__item_,
        _LocationRelatedDataResponse_protocolExtensions,
        LocationRelatedDataResponse,
        LocationRelatedDataResponseIEs,
        _LocationRelatedDataResponseIEs_val_Value_0,
        LocationRelatedDataResponseExtensions,
        _LocationRelatedDataResponseExtensions_val_Extension_0,
        _LocationRelatedDataResponseExtensions_val_Extension_1,
        ____LocationRelatedDataFailure_protocolIEs__item__id_tab,
        _____LocationRelatedDataFailure_protocolIEs__item__id_tab_val_Value_0,
        ___LocationRelatedDataFailure_protocolIEs__item__id,
        ___LocationRelatedDataFailure_protocolIEs__item__criticality,
        ___LocationRelatedDataFailure_protocolIEs__item__value,
        __LocationRelatedDataFailure_protocolIEs__item_,
        _LocationRelatedDataFailure_protocolIEs,
        ____LocationRelatedDataFailure_protocolExtensions__item__id_tab,
        _____LocationRelatedDataFailure_protocolExtensions__item__id_tab_val_Extension_0,
        ___LocationRelatedDataFailure_protocolExtensions__item__id,
        ___LocationRelatedDataFailure_protocolExtensions__item__criticality,
        ___LocationRelatedDataFailure_protocolExtensions__item__extensionValue,
        __LocationRelatedDataFailure_protocolExtensions__item_,
        _LocationRelatedDataFailure_protocolExtensions,
        LocationRelatedDataFailure,
        LocationRelatedDataFailureIEs,
        _LocationRelatedDataFailureIEs_val_Value_0,
        LocationRelatedDataFailureExtensions,
        _LocationRelatedDataFailureExtensions_val_Extension_0,
        ____InformationTransferIndication_protocolIEs__item__id_tab,
        _____InformationTransferIndication_protocolIEs__item__id_tab_val_Value_0,
        _____InformationTransferIndication_protocolIEs__item__id_tab_val_Value_1,
        _____InformationTransferIndication_protocolIEs__item__id_tab_val_Value_2,
        _____InformationTransferIndication_protocolIEs__item__id_tab_val_Value_3,
        ___InformationTransferIndication_protocolIEs__item__id,
        ___InformationTransferIndication_protocolIEs__item__criticality,
        ___InformationTransferIndication_protocolIEs__item__value,
        __InformationTransferIndication_protocolIEs__item_,
        _InformationTransferIndication_protocolIEs,
        ____InformationTransferIndication_protocolExtensions__item__id_tab,
        ___InformationTransferIndication_protocolExtensions__item__id,
        ____InformationTransferIndication_protocolExtensions__item__criticality_tab,
        ___InformationTransferIndication_protocolExtensions__item__criticality,
        ____InformationTransferIndication_protocolExtensions__item__extensionValue_tab,
        ___InformationTransferIndication_protocolExtensions__item__extensionValue,
        __InformationTransferIndication_protocolExtensions__item_,
        _InformationTransferIndication_protocolExtensions,
        InformationTransferIndication,
        InformationTransferIndicationIEs,
        _InformationTransferIndicationIEs_val_Value_0,
        _InformationTransferIndicationIEs_val_Value_1,
        _InformationTransferIndicationIEs_val_Value_2,
        _InformationTransferIndicationIEs_val_Value_3,
        InformationTransferIndicationExtensions,
        ____InformationTransferConfirmation_protocolIEs__item__id_tab,
        _____InformationTransferConfirmation_protocolIEs__item__id_tab_val_Value_0,
        _____InformationTransferConfirmation_protocolIEs__item__id_tab_val_Value_1,
        _____InformationTransferConfirmation_protocolIEs__item__id_tab_val_Value_2,
        _____InformationTransferConfirmation_protocolIEs__item__id_tab_val_Value_3,
        ___InformationTransferConfirmation_protocolIEs__item__id,
        ___InformationTransferConfirmation_protocolIEs__item__criticality,
        ___InformationTransferConfirmation_protocolIEs__item__value,
        __InformationTransferConfirmation_protocolIEs__item_,
        _InformationTransferConfirmation_protocolIEs,
        ____InformationTransferConfirmation_protocolExtensions__item__id_tab,
        _____InformationTransferConfirmation_protocolExtensions__item__id_tab_val_Extension_0,
        ___InformationTransferConfirmation_protocolExtensions__item__id,
        ___InformationTransferConfirmation_protocolExtensions__item__criticality,
        ___InformationTransferConfirmation_protocolExtensions__item__extensionValue,
        __InformationTransferConfirmation_protocolExtensions__item_,
        _InformationTransferConfirmation_protocolExtensions,
        InformationTransferConfirmation,
        InformationTransferConfirmationIEs,
        _InformationTransferConfirmationIEs_val_Value_0,
        _InformationTransferConfirmationIEs_val_Value_1,
        _InformationTransferConfirmationIEs_val_Value_2,
        _InformationTransferConfirmationIEs_val_Value_3,
        InformationTransferConfirmationExtensions,
        _InformationTransferConfirmationExtensions_val_Extension_0,
        ____InformationTransferFailure_protocolIEs__item__id_tab,
        _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_0,
        _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_1,
        _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_2,
        _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_3,
        _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_4,
        ___InformationTransferFailure_protocolIEs__item__id,
        ___InformationTransferFailure_protocolIEs__item__criticality,
        ___InformationTransferFailure_protocolIEs__item__value,
        __InformationTransferFailure_protocolIEs__item_,
        _InformationTransferFailure_protocolIEs,
        ____InformationTransferFailure_protocolExtensions__item__id_tab,
        _____InformationTransferFailure_protocolExtensions__item__id_tab_val_Extension_0,
        ___InformationTransferFailure_protocolExtensions__item__id,
        ___InformationTransferFailure_protocolExtensions__item__criticality,
        ___InformationTransferFailure_protocolExtensions__item__extensionValue,
        __InformationTransferFailure_protocolExtensions__item_,
        _InformationTransferFailure_protocolExtensions,
        InformationTransferFailure,
        InformationTransferFailureIEs,
        _InformationTransferFailureIEs_val_Value_0,
        _InformationTransferFailureIEs_val_Value_1,
        _InformationTransferFailureIEs_val_Value_2,
        _InformationTransferFailureIEs_val_Value_3,
        _InformationTransferFailureIEs_val_Value_4,
        InformationTransferFailureExtensions,
        _InformationTransferFailureExtensions_val_Extension_0,
        ____UESpecificInformationIndication_protocolIEs__item__id_tab,
        _____UESpecificInformationIndication_protocolIEs__item__id_tab_val_Value_0,
        ___UESpecificInformationIndication_protocolIEs__item__id,
        ___UESpecificInformationIndication_protocolIEs__item__criticality,
        ___UESpecificInformationIndication_protocolIEs__item__value,
        __UESpecificInformationIndication_protocolIEs__item_,
        _UESpecificInformationIndication_protocolIEs,
        ____UESpecificInformationIndication_protocolExtensions__item__id_tab,
        ___UESpecificInformationIndication_protocolExtensions__item__id,
        ____UESpecificInformationIndication_protocolExtensions__item__criticality_tab,
        ___UESpecificInformationIndication_protocolExtensions__item__criticality,
        ____UESpecificInformationIndication_protocolExtensions__item__extensionValue_tab,
        ___UESpecificInformationIndication_protocolExtensions__item__extensionValue,
        __UESpecificInformationIndication_protocolExtensions__item_,
        _UESpecificInformationIndication_protocolExtensions,
        UESpecificInformationIndication,
        UESpecificInformationIndicationIEs,
        _UESpecificInformationIndicationIEs_val_Value_0,
        UESpecificInformationIndicationExtensions,
        ____DirectInformationTransfer_protocolIEs__item__id_tab,
        _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_2,
        _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_3,
        ___DirectInformationTransfer_protocolIEs__item__id,
        ___DirectInformationTransfer_protocolIEs__item__criticality,
        ___DirectInformationTransfer_protocolIEs__item__value,
        __DirectInformationTransfer_protocolIEs__item_,
        _DirectInformationTransfer_protocolIEs,
        ____DirectInformationTransfer_protocolExtensions__item__id_tab,
        _____DirectInformationTransfer_protocolExtensions__item__id_tab_val_Extension_0,
        ___DirectInformationTransfer_protocolExtensions__item__id,
        ___DirectInformationTransfer_protocolExtensions__item__criticality,
        ___DirectInformationTransfer_protocolExtensions__item__extensionValue,
        __DirectInformationTransfer_protocolExtensions__item_,
        _DirectInformationTransfer_protocolExtensions,
        DirectInformationTransfer,
        DirectInformationTransferIEs,
        _DirectInformationTransferIEs_val_Value_0,
        _DirectInformationTransferIEs_val_Value_1,
        _DirectInformationTransferIEs_val_Value_2,
        _DirectInformationTransferIEs_val_Value_3,
        DirectInformationTransferExtensions,
        _DirectInformationTransferExtensions_val_Extension_0,
        ____UplinkInformationExchangeRequest_protocolIEs__item__id_tab,
        _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_3,
        _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_4,
        _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_5,
        ___UplinkInformationExchangeRequest_protocolIEs__item__id,
        ___UplinkInformationExchangeRequest_protocolIEs__item__criticality,
        ___UplinkInformationExchangeRequest_protocolIEs__item__value,
        __UplinkInformationExchangeRequest_protocolIEs__item_,
        _UplinkInformationExchangeRequest_protocolIEs,
        ____UplinkInformationExchangeRequest_protocolExtensions__item__id_tab,
        _____UplinkInformationExchangeRequest_protocolExtensions__item__id_tab_val_Extension_0,
        ___UplinkInformationExchangeRequest_protocolExtensions__item__id,
        ___UplinkInformationExchangeRequest_protocolExtensions__item__criticality,
        ___UplinkInformationExchangeRequest_protocolExtensions__item__extensionValue,
        __UplinkInformationExchangeRequest_protocolExtensions__item_,
        _UplinkInformationExchangeRequest_protocolExtensions,
        UplinkInformationExchangeRequest,
        UplinkInformationExchangeRequestIEs,
        _UplinkInformationExchangeRequestIEs_val_Value_0,
        _UplinkInformationExchangeRequestIEs_val_Value_1,
        _UplinkInformationExchangeRequestIEs_val_Value_2,
        _UplinkInformationExchangeRequestIEs_val_Value_3,
        _UplinkInformationExchangeRequestIEs_val_Value_4,
        _UplinkInformationExchangeRequestIEs_val_Value_5,
        UplinkInformationExchangeRequestExtensions,
        _UplinkInformationExchangeRequestExtensions_val_Extension_0,
        ____UplinkInformationExchangeResponse_protocolIEs__item__id_tab,
        _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_2,
        _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_3,
        _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_4,
        ___UplinkInformationExchangeResponse_protocolIEs__item__id,
        ___UplinkInformationExchangeResponse_protocolIEs__item__criticality,
        ___UplinkInformationExchangeResponse_protocolIEs__item__value,
        __UplinkInformationExchangeResponse_protocolIEs__item_,
        _UplinkInformationExchangeResponse_protocolIEs,
        ____UplinkInformationExchangeResponse_protocolExtensions__item__id_tab,
        ___UplinkInformationExchangeResponse_protocolExtensions__item__id,
        ____UplinkInformationExchangeResponse_protocolExtensions__item__criticality_tab,
        ___UplinkInformationExchangeResponse_protocolExtensions__item__criticality,
        ____UplinkInformationExchangeResponse_protocolExtensions__item__extensionValue_tab,
        ___UplinkInformationExchangeResponse_protocolExtensions__item__extensionValue,
        __UplinkInformationExchangeResponse_protocolExtensions__item_,
        _UplinkInformationExchangeResponse_protocolExtensions,
        UplinkInformationExchangeResponse,
        UplinkInformationExchangeResponseIEs,
        _UplinkInformationExchangeResponseIEs_val_Value_0,
        _UplinkInformationExchangeResponseIEs_val_Value_1,
        _UplinkInformationExchangeResponseIEs_val_Value_2,
        _UplinkInformationExchangeResponseIEs_val_Value_3,
        _UplinkInformationExchangeResponseIEs_val_Value_4,
        UplinkInformationExchangeResponseExtensions,
        ____UplinkInformationExchangeFailure_protocolIEs__item__id_tab,
        _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_1,
        _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_2,
        _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_3,
        _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_4,
        ___UplinkInformationExchangeFailure_protocolIEs__item__id,
        ___UplinkInformationExchangeFailure_protocolIEs__item__criticality,
        ___UplinkInformationExchangeFailure_protocolIEs__item__value,
        __UplinkInformationExchangeFailure_protocolIEs__item_,
        _UplinkInformationExchangeFailure_protocolIEs,
        ____UplinkInformationExchangeFailure_protocolExtensions__item__id_tab,
        ___UplinkInformationExchangeFailure_protocolExtensions__item__id,
        ____UplinkInformationExchangeFailure_protocolExtensions__item__criticality_tab,
        ___UplinkInformationExchangeFailure_protocolExtensions__item__criticality,
        ____UplinkInformationExchangeFailure_protocolExtensions__item__extensionValue_tab,
        ___UplinkInformationExchangeFailure_protocolExtensions__item__extensionValue,
        __UplinkInformationExchangeFailure_protocolExtensions__item_,
        _UplinkInformationExchangeFailure_protocolExtensions,
        UplinkInformationExchangeFailure,
        UplinkInformationExchangeFailureIEs,
        _UplinkInformationExchangeFailureIEs_val_Value_0,
        _UplinkInformationExchangeFailureIEs_val_Value_1,
        _UplinkInformationExchangeFailureIEs_val_Value_2,
        _UplinkInformationExchangeFailureIEs_val_Value_3,
        _UplinkInformationExchangeFailureIEs_val_Value_4,
        UplinkInformationExchangeFailureExtensions,
        ____MBMSSessionStart_protocolIEs__item__id_tab,
        _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_1,
        _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_2,
        _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_3,
        _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_4,
        _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_5,
        _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_6,
        _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_7,
        _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_8,
        _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_9,
        _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_10,
        _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_11,
        _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_12,
        ___MBMSSessionStart_protocolIEs__item__id,
        ___MBMSSessionStart_protocolIEs__item__criticality,
        ___MBMSSessionStart_protocolIEs__item__value,
        __MBMSSessionStart_protocolIEs__item_,
        _MBMSSessionStart_protocolIEs,
        ____MBMSSessionStart_protocolExtensions__item__id_tab,
        _____MBMSSessionStart_protocolExtensions__item__id_tab_val_Extension_0,
        _____MBMSSessionStart_protocolExtensions__item__id_tab_val_Extension_1,
        _____MBMSSessionStart_protocolExtensions__item__id_tab_val_Extension_2,
        _____MBMSSessionStart_protocolExtensions__item__id_tab_val_Extension_3,
        ___MBMSSessionStart_protocolExtensions__item__id,
        ___MBMSSessionStart_protocolExtensions__item__criticality,
        ___MBMSSessionStart_protocolExtensions__item__extensionValue,
        __MBMSSessionStart_protocolExtensions__item_,
        _MBMSSessionStart_protocolExtensions,
        MBMSSessionStart,
        MBMSSessionStartIEs,
        _MBMSSessionStartIEs_val_Value_0,
        _MBMSSessionStartIEs_val_Value_1,
        _MBMSSessionStartIEs_val_Value_2,
        _MBMSSessionStartIEs_val_Value_3,
        _MBMSSessionStartIEs_val_Value_4,
        _MBMSSessionStartIEs_val_Value_5,
        _MBMSSessionStartIEs_val_Value_6,
        _MBMSSessionStartIEs_val_Value_7,
        _MBMSSessionStartIEs_val_Value_8,
        _MBMSSessionStartIEs_val_Value_9,
        _MBMSSessionStartIEs_val_Value_10,
        _MBMSSessionStartIEs_val_Value_11,
        _MBMSSessionStartIEs_val_Value_12,
        MBMSSessionStartExtensions,
        _MBMSSessionStartExtensions_val_Extension_0,
        _MBMSSessionStartExtensions_val_Extension_1,
        _MBMSSessionStartExtensions_val_Extension_2,
        _MBMSSessionStartExtensions_val_Extension_3,
        _MBMSSynchronisationInformation_mBMSHCIndicator,
        _MBMSSynchronisationInformation_iPMulticastAddress,
        _MBMSSynchronisationInformation_gTPDLTEID,
        ____MBMSSynchronisationInformation_iE_Extensions__item__id_tab,
        _____MBMSSynchronisationInformation_iE_Extensions__item__id_tab_val_Extension_0,
        ___MBMSSynchronisationInformation_iE_Extensions__item__id,
        ___MBMSSynchronisationInformation_iE_Extensions__item__criticality,
        ___MBMSSynchronisationInformation_iE_Extensions__item__extensionValue,
        __MBMSSynchronisationInformation_iE_Extensions__item_,
        _MBMSSynchronisationInformation_iE_Extensions,
        MBMSSynchronisationInformation,
        MBMSSynchronisationInformation_ExtIEs,
        _MBMSSynchronisationInformation_ExtIEs_val_Extension_0,
        ____MBMSSessionStartResponse_protocolIEs__item__id_tab,
        _____MBMSSessionStartResponse_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSSessionStartResponse_protocolIEs__item__id_tab_val_Value_1,
        _____MBMSSessionStartResponse_protocolIEs__item__id_tab_val_Value_2,
        ___MBMSSessionStartResponse_protocolIEs__item__id,
        ___MBMSSessionStartResponse_protocolIEs__item__criticality,
        ___MBMSSessionStartResponse_protocolIEs__item__value,
        __MBMSSessionStartResponse_protocolIEs__item_,
        _MBMSSessionStartResponse_protocolIEs,
        ____MBMSSessionStartResponse_protocolExtensions__item__id_tab,
        ___MBMSSessionStartResponse_protocolExtensions__item__id,
        ____MBMSSessionStartResponse_protocolExtensions__item__criticality_tab,
        ___MBMSSessionStartResponse_protocolExtensions__item__criticality,
        ____MBMSSessionStartResponse_protocolExtensions__item__extensionValue_tab,
        ___MBMSSessionStartResponse_protocolExtensions__item__extensionValue,
        __MBMSSessionStartResponse_protocolExtensions__item_,
        _MBMSSessionStartResponse_protocolExtensions,
        MBMSSessionStartResponse,
        MBMSSessionStartResponseIEs,
        _MBMSSessionStartResponseIEs_val_Value_0,
        _MBMSSessionStartResponseIEs_val_Value_1,
        _MBMSSessionStartResponseIEs_val_Value_2,
        MBMSSessionStartResponseExtensions,
        ____MBMSSessionStartFailure_protocolIEs__item__id_tab,
        _____MBMSSessionStartFailure_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSSessionStartFailure_protocolIEs__item__id_tab_val_Value_1,
        ___MBMSSessionStartFailure_protocolIEs__item__id,
        ___MBMSSessionStartFailure_protocolIEs__item__criticality,
        ___MBMSSessionStartFailure_protocolIEs__item__value,
        __MBMSSessionStartFailure_protocolIEs__item_,
        _MBMSSessionStartFailure_protocolIEs,
        ____MBMSSessionStartFailure_protocolExtensions__item__id_tab,
        ___MBMSSessionStartFailure_protocolExtensions__item__id,
        ____MBMSSessionStartFailure_protocolExtensions__item__criticality_tab,
        ___MBMSSessionStartFailure_protocolExtensions__item__criticality,
        ____MBMSSessionStartFailure_protocolExtensions__item__extensionValue_tab,
        ___MBMSSessionStartFailure_protocolExtensions__item__extensionValue,
        __MBMSSessionStartFailure_protocolExtensions__item_,
        _MBMSSessionStartFailure_protocolExtensions,
        MBMSSessionStartFailure,
        MBMSSessionStartFailureIEs,
        _MBMSSessionStartFailureIEs_val_Value_0,
        _MBMSSessionStartFailureIEs_val_Value_1,
        MBMSSessionStartFailureExtensions,
        ____MBMSSessionUpdate_protocolIEs__item__id_tab,
        _____MBMSSessionUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSSessionUpdate_protocolIEs__item__id_tab_val_Value_1,
        ___MBMSSessionUpdate_protocolIEs__item__id,
        ___MBMSSessionUpdate_protocolIEs__item__criticality,
        ___MBMSSessionUpdate_protocolIEs__item__value,
        __MBMSSessionUpdate_protocolIEs__item_,
        _MBMSSessionUpdate_protocolIEs,
        ____MBMSSessionUpdate_protocolExtensions__item__id_tab,
        ___MBMSSessionUpdate_protocolExtensions__item__id,
        ____MBMSSessionUpdate_protocolExtensions__item__criticality_tab,
        ___MBMSSessionUpdate_protocolExtensions__item__criticality,
        ____MBMSSessionUpdate_protocolExtensions__item__extensionValue_tab,
        ___MBMSSessionUpdate_protocolExtensions__item__extensionValue,
        __MBMSSessionUpdate_protocolExtensions__item_,
        _MBMSSessionUpdate_protocolExtensions,
        MBMSSessionUpdate,
        MBMSSessionUpdateIEs,
        _MBMSSessionUpdateIEs_val_Value_0,
        _MBMSSessionUpdateIEs_val_Value_1,
        MBMSSessionUpdateExtensions,
        ____MBMSSessionUpdateResponse_protocolIEs__item__id_tab,
        _____MBMSSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_1,
        _____MBMSSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_2,
        _____MBMSSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_3,
        ___MBMSSessionUpdateResponse_protocolIEs__item__id,
        ___MBMSSessionUpdateResponse_protocolIEs__item__criticality,
        ___MBMSSessionUpdateResponse_protocolIEs__item__value,
        __MBMSSessionUpdateResponse_protocolIEs__item_,
        _MBMSSessionUpdateResponse_protocolIEs,
        ____MBMSSessionUpdateResponse_protocolExtensions__item__id_tab,
        ___MBMSSessionUpdateResponse_protocolExtensions__item__id,
        ____MBMSSessionUpdateResponse_protocolExtensions__item__criticality_tab,
        ___MBMSSessionUpdateResponse_protocolExtensions__item__criticality,
        ____MBMSSessionUpdateResponse_protocolExtensions__item__extensionValue_tab,
        ___MBMSSessionUpdateResponse_protocolExtensions__item__extensionValue,
        __MBMSSessionUpdateResponse_protocolExtensions__item_,
        _MBMSSessionUpdateResponse_protocolExtensions,
        MBMSSessionUpdateResponse,
        MBMSSessionUpdateResponseIEs,
        _MBMSSessionUpdateResponseIEs_val_Value_0,
        _MBMSSessionUpdateResponseIEs_val_Value_1,
        _MBMSSessionUpdateResponseIEs_val_Value_2,
        _MBMSSessionUpdateResponseIEs_val_Value_3,
        MBMSSessionUpdateResponseExtensions,
        ____MBMSSessionUpdateFailure_protocolIEs__item__id_tab,
        _____MBMSSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____MBMSSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        ___MBMSSessionUpdateFailure_protocolIEs__item__id,
        ___MBMSSessionUpdateFailure_protocolIEs__item__criticality,
        ___MBMSSessionUpdateFailure_protocolIEs__item__value,
        __MBMSSessionUpdateFailure_protocolIEs__item_,
        _MBMSSessionUpdateFailure_protocolIEs,
        ____MBMSSessionUpdateFailure_protocolExtensions__item__id_tab,
        ___MBMSSessionUpdateFailure_protocolExtensions__item__id,
        ____MBMSSessionUpdateFailure_protocolExtensions__item__criticality_tab,
        ___MBMSSessionUpdateFailure_protocolExtensions__item__criticality,
        ____MBMSSessionUpdateFailure_protocolExtensions__item__extensionValue_tab,
        ___MBMSSessionUpdateFailure_protocolExtensions__item__extensionValue,
        __MBMSSessionUpdateFailure_protocolExtensions__item_,
        _MBMSSessionUpdateFailure_protocolExtensions,
        MBMSSessionUpdateFailure,
        MBMSSessionUpdateFailureIEs,
        _MBMSSessionUpdateFailureIEs_val_Value_0,
        _MBMSSessionUpdateFailureIEs_val_Value_1,
        _MBMSSessionUpdateFailureIEs_val_Value_2,
        MBMSSessionUpdateFailureExtensions,
        ____MBMSSessionStop_protocolIEs__item__id_tab,
        _____MBMSSessionStop_protocolIEs__item__id_tab_val_Value_0,
        ___MBMSSessionStop_protocolIEs__item__id,
        ___MBMSSessionStop_protocolIEs__item__criticality,
        ___MBMSSessionStop_protocolIEs__item__value,
        __MBMSSessionStop_protocolIEs__item_,
        _MBMSSessionStop_protocolIEs,
        ____MBMSSessionStop_protocolExtensions__item__id_tab,
        ___MBMSSessionStop_protocolExtensions__item__id,
        ____MBMSSessionStop_protocolExtensions__item__criticality_tab,
        ___MBMSSessionStop_protocolExtensions__item__criticality,
        ____MBMSSessionStop_protocolExtensions__item__extensionValue_tab,
        ___MBMSSessionStop_protocolExtensions__item__extensionValue,
        __MBMSSessionStop_protocolExtensions__item_,
        _MBMSSessionStop_protocolExtensions,
        MBMSSessionStop,
        MBMSSessionStopIEs,
        _MBMSSessionStopIEs_val_Value_0,
        MBMSSessionStopExtensions,
        ____MBMSSessionStopResponse_protocolIEs__item__id_tab,
        _____MBMSSessionStopResponse_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSSessionStopResponse_protocolIEs__item__id_tab_val_Value_1,
        ___MBMSSessionStopResponse_protocolIEs__item__id,
        ___MBMSSessionStopResponse_protocolIEs__item__criticality,
        ___MBMSSessionStopResponse_protocolIEs__item__value,
        __MBMSSessionStopResponse_protocolIEs__item_,
        _MBMSSessionStopResponse_protocolIEs,
        ____MBMSSessionStopResponse_protocolExtensions__item__id_tab,
        ___MBMSSessionStopResponse_protocolExtensions__item__id,
        ____MBMSSessionStopResponse_protocolExtensions__item__criticality_tab,
        ___MBMSSessionStopResponse_protocolExtensions__item__criticality,
        ____MBMSSessionStopResponse_protocolExtensions__item__extensionValue_tab,
        ___MBMSSessionStopResponse_protocolExtensions__item__extensionValue,
        __MBMSSessionStopResponse_protocolExtensions__item_,
        _MBMSSessionStopResponse_protocolExtensions,
        MBMSSessionStopResponse,
        MBMSSessionStopResponseIEs,
        _MBMSSessionStopResponseIEs_val_Value_0,
        _MBMSSessionStopResponseIEs_val_Value_1,
        MBMSSessionStopResponseExtensions,
        ____MBMSUELinkingRequest_protocolIEs__item__id_tab,
        _____MBMSUELinkingRequest_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSUELinkingRequest_protocolIEs__item__id_tab_val_Value_1,
        ___MBMSUELinkingRequest_protocolIEs__item__id,
        ___MBMSUELinkingRequest_protocolIEs__item__criticality,
        ___MBMSUELinkingRequest_protocolIEs__item__value,
        __MBMSUELinkingRequest_protocolIEs__item_,
        _MBMSUELinkingRequest_protocolIEs,
        ____MBMSUELinkingRequest_protocolExtensions__item__id_tab,
        ___MBMSUELinkingRequest_protocolExtensions__item__id,
        ____MBMSUELinkingRequest_protocolExtensions__item__criticality_tab,
        ___MBMSUELinkingRequest_protocolExtensions__item__criticality,
        ____MBMSUELinkingRequest_protocolExtensions__item__extensionValue_tab,
        ___MBMSUELinkingRequest_protocolExtensions__item__extensionValue,
        __MBMSUELinkingRequest_protocolExtensions__item_,
        _MBMSUELinkingRequest_protocolExtensions,
        MBMSUELinkingRequest,
        MBMSUELinkingRequestIEs,
        _MBMSUELinkingRequestIEs_val_Value_0,
        _MBMSUELinkingRequestIEs_val_Value_1,
        __LeftMBMSBearerService_IEs__item__tMGI,
        _____LeftMBMSBearerService_IEs__item__iE_Extensions__item__id_tab,
        ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__id,
        _____LeftMBMSBearerService_IEs__item__iE_Extensions__item__criticality_tab,
        ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__criticality,
        _____LeftMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue_tab,
        ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue,
        ___LeftMBMSBearerService_IEs__item__iE_Extensions__item_,
        __LeftMBMSBearerService_IEs__item__iE_Extensions,
        _LeftMBMSBearerService_IEs__item_,
        LeftMBMSBearerService_IEs,
        LeftMBMSBearerService_ExtIEs,
        MBMSUELinkingRequestExtensions,
        ____MBMSUELinkingResponse_protocolIEs__item__id_tab,
        _____MBMSUELinkingResponse_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSUELinkingResponse_protocolIEs__item__id_tab_val_Value_1,
        ___MBMSUELinkingResponse_protocolIEs__item__id,
        ___MBMSUELinkingResponse_protocolIEs__item__criticality,
        ___MBMSUELinkingResponse_protocolIEs__item__value,
        __MBMSUELinkingResponse_protocolIEs__item_,
        _MBMSUELinkingResponse_protocolIEs,
        ____MBMSUELinkingResponse_protocolExtensions__item__id_tab,
        ___MBMSUELinkingResponse_protocolExtensions__item__id,
        ____MBMSUELinkingResponse_protocolExtensions__item__criticality_tab,
        ___MBMSUELinkingResponse_protocolExtensions__item__criticality,
        ____MBMSUELinkingResponse_protocolExtensions__item__extensionValue_tab,
        ___MBMSUELinkingResponse_protocolExtensions__item__extensionValue,
        __MBMSUELinkingResponse_protocolExtensions__item_,
        _MBMSUELinkingResponse_protocolExtensions,
        MBMSUELinkingResponse,
        MBMSUELinkingResponseIEs,
        _MBMSUELinkingResponseIEs_val_Value_0,
        _MBMSUELinkingResponseIEs_val_Value_1,
        __UnsuccessfulLinking_IEs__item__tMGI,
        __UnsuccessfulLinking_IEs__item__cause,
        _____UnsuccessfulLinking_IEs__item__iE_Extensions__item__id_tab,
        ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__id,
        _____UnsuccessfulLinking_IEs__item__iE_Extensions__item__criticality_tab,
        ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__criticality,
        _____UnsuccessfulLinking_IEs__item__iE_Extensions__item__extensionValue_tab,
        ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__extensionValue,
        ___UnsuccessfulLinking_IEs__item__iE_Extensions__item_,
        __UnsuccessfulLinking_IEs__item__iE_Extensions,
        _UnsuccessfulLinking_IEs__item_,
        UnsuccessfulLinking_IEs,
        UnsuccessfulLinking_ExtIEs,
        MBMSUELinkingResponseExtensions,
        ____MBMSRegistrationRequest_protocolIEs__item__id_tab,
        _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_4,
        ___MBMSRegistrationRequest_protocolIEs__item__id,
        ___MBMSRegistrationRequest_protocolIEs__item__criticality,
        ___MBMSRegistrationRequest_protocolIEs__item__value,
        __MBMSRegistrationRequest_protocolIEs__item_,
        _MBMSRegistrationRequest_protocolIEs,
        ____MBMSRegistrationRequest_protocolExtensions__item__id_tab,
        _____MBMSRegistrationRequest_protocolExtensions__item__id_tab_val_Extension_0,
        ___MBMSRegistrationRequest_protocolExtensions__item__id,
        ___MBMSRegistrationRequest_protocolExtensions__item__criticality,
        ___MBMSRegistrationRequest_protocolExtensions__item__extensionValue,
        __MBMSRegistrationRequest_protocolExtensions__item_,
        _MBMSRegistrationRequest_protocolExtensions,
        MBMSRegistrationRequest,
        MBMSRegistrationRequestIEs,
        _MBMSRegistrationRequestIEs_val_Value_0,
        _MBMSRegistrationRequestIEs_val_Value_1,
        _MBMSRegistrationRequestIEs_val_Value_2,
        _MBMSRegistrationRequestIEs_val_Value_3,
        _MBMSRegistrationRequestIEs_val_Value_4,
        MBMSRegistrationRequestExtensions,
        _MBMSRegistrationRequestExtensions_val_Extension_0,
        ____MBMSRegistrationResponse_protocolIEs__item__id_tab,
        _____MBMSRegistrationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSRegistrationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____MBMSRegistrationResponse_protocolIEs__item__id_tab_val_Value_2,
        ___MBMSRegistrationResponse_protocolIEs__item__id,
        ___MBMSRegistrationResponse_protocolIEs__item__criticality,
        ___MBMSRegistrationResponse_protocolIEs__item__value,
        __MBMSRegistrationResponse_protocolIEs__item_,
        _MBMSRegistrationResponse_protocolIEs,
        ____MBMSRegistrationResponse_protocolExtensions__item__id_tab,
        ___MBMSRegistrationResponse_protocolExtensions__item__id,
        ____MBMSRegistrationResponse_protocolExtensions__item__criticality_tab,
        ___MBMSRegistrationResponse_protocolExtensions__item__criticality,
        ____MBMSRegistrationResponse_protocolExtensions__item__extensionValue_tab,
        ___MBMSRegistrationResponse_protocolExtensions__item__extensionValue,
        __MBMSRegistrationResponse_protocolExtensions__item_,
        _MBMSRegistrationResponse_protocolExtensions,
        MBMSRegistrationResponse,
        MBMSRegistrationResponseIEs,
        _MBMSRegistrationResponseIEs_val_Value_0,
        _MBMSRegistrationResponseIEs_val_Value_1,
        _MBMSRegistrationResponseIEs_val_Value_2,
        MBMSRegistrationResponseExtensions,
        ____MBMSRegistrationFailure_protocolIEs__item__id_tab,
        _____MBMSRegistrationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSRegistrationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____MBMSRegistrationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____MBMSRegistrationFailure_protocolIEs__item__id_tab_val_Value_3,
        ___MBMSRegistrationFailure_protocolIEs__item__id,
        ___MBMSRegistrationFailure_protocolIEs__item__criticality,
        ___MBMSRegistrationFailure_protocolIEs__item__value,
        __MBMSRegistrationFailure_protocolIEs__item_,
        _MBMSRegistrationFailure_protocolIEs,
        ____MBMSRegistrationFailure_protocolExtensions__item__id_tab,
        ___MBMSRegistrationFailure_protocolExtensions__item__id,
        ____MBMSRegistrationFailure_protocolExtensions__item__criticality_tab,
        ___MBMSRegistrationFailure_protocolExtensions__item__criticality,
        ____MBMSRegistrationFailure_protocolExtensions__item__extensionValue_tab,
        ___MBMSRegistrationFailure_protocolExtensions__item__extensionValue,
        __MBMSRegistrationFailure_protocolExtensions__item_,
        _MBMSRegistrationFailure_protocolExtensions,
        MBMSRegistrationFailure,
        MBMSRegistrationFailureIEs,
        _MBMSRegistrationFailureIEs_val_Value_0,
        _MBMSRegistrationFailureIEs_val_Value_1,
        _MBMSRegistrationFailureIEs_val_Value_2,
        _MBMSRegistrationFailureIEs_val_Value_3,
        MBMSRegistrationFailureExtensions,
        ____MBMSCNDe_RegistrationRequest_protocolIEs__item__id_tab,
        _____MBMSCNDe_RegistrationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSCNDe_RegistrationRequest_protocolIEs__item__id_tab_val_Value_1,
        ___MBMSCNDe_RegistrationRequest_protocolIEs__item__id,
        ___MBMSCNDe_RegistrationRequest_protocolIEs__item__criticality,
        ___MBMSCNDe_RegistrationRequest_protocolIEs__item__value,
        __MBMSCNDe_RegistrationRequest_protocolIEs__item_,
        _MBMSCNDe_RegistrationRequest_protocolIEs,
        ____MBMSCNDe_RegistrationRequest_protocolExtensions__item__id_tab,
        ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__id,
        ____MBMSCNDe_RegistrationRequest_protocolExtensions__item__criticality_tab,
        ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__criticality,
        ____MBMSCNDe_RegistrationRequest_protocolExtensions__item__extensionValue_tab,
        ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__extensionValue,
        __MBMSCNDe_RegistrationRequest_protocolExtensions__item_,
        _MBMSCNDe_RegistrationRequest_protocolExtensions,
        MBMSCNDe_RegistrationRequest,
        MBMSCNDe_RegistrationRequestIEs,
        _MBMSCNDe_RegistrationRequestIEs_val_Value_0,
        _MBMSCNDe_RegistrationRequestIEs_val_Value_1,
        MBMSCNDe_RegistrationRequestExtensions,
        ____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab,
        _____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab_val_Value_3,
        ___MBMSCNDe_RegistrationResponse_protocolIEs__item__id,
        ___MBMSCNDe_RegistrationResponse_protocolIEs__item__criticality,
        ___MBMSCNDe_RegistrationResponse_protocolIEs__item__value,
        __MBMSCNDe_RegistrationResponse_protocolIEs__item_,
        _MBMSCNDe_RegistrationResponse_protocolIEs,
        ____MBMSCNDe_RegistrationResponse_protocolExtensions__item__id_tab,
        _____MBMSCNDe_RegistrationResponse_protocolExtensions__item__id_tab_val_Extension_0,
        ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__id,
        ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__criticality,
        ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__extensionValue,
        __MBMSCNDe_RegistrationResponse_protocolExtensions__item_,
        _MBMSCNDe_RegistrationResponse_protocolExtensions,
        MBMSCNDe_RegistrationResponse,
        MBMSCNDe_RegistrationResponseIEs,
        _MBMSCNDe_RegistrationResponseIEs_val_Value_0,
        _MBMSCNDe_RegistrationResponseIEs_val_Value_1,
        _MBMSCNDe_RegistrationResponseIEs_val_Value_2,
        _MBMSCNDe_RegistrationResponseIEs_val_Value_3,
        MBMSCNDe_RegistrationResponseExtensions,
        _MBMSCNDe_RegistrationResponseExtensions_val_Extension_0,
        ____MBMSRABEstablishmentIndication_protocolIEs__item__id_tab,
        _____MBMSRABEstablishmentIndication_protocolIEs__item__id_tab_val_Value_0,
        ___MBMSRABEstablishmentIndication_protocolIEs__item__id,
        ___MBMSRABEstablishmentIndication_protocolIEs__item__criticality,
        ___MBMSRABEstablishmentIndication_protocolIEs__item__value,
        __MBMSRABEstablishmentIndication_protocolIEs__item_,
        _MBMSRABEstablishmentIndication_protocolIEs,
        ____MBMSRABEstablishmentIndication_protocolExtensions__item__id_tab,
        ___MBMSRABEstablishmentIndication_protocolExtensions__item__id,
        ____MBMSRABEstablishmentIndication_protocolExtensions__item__criticality_tab,
        ___MBMSRABEstablishmentIndication_protocolExtensions__item__criticality,
        ____MBMSRABEstablishmentIndication_protocolExtensions__item__extensionValue_tab,
        ___MBMSRABEstablishmentIndication_protocolExtensions__item__extensionValue,
        __MBMSRABEstablishmentIndication_protocolExtensions__item_,
        _MBMSRABEstablishmentIndication_protocolExtensions,
        MBMSRABEstablishmentIndication,
        MBMSRABEstablishmentIndicationIEs,
        _MBMSRABEstablishmentIndicationIEs_val_Value_0,
        MBMSRABEstablishmentIndicationExtensions,
        ____MBMSRABReleaseRequest_protocolIEs__item__id_tab,
        _____MBMSRABReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        ___MBMSRABReleaseRequest_protocolIEs__item__id,
        ___MBMSRABReleaseRequest_protocolIEs__item__criticality,
        ___MBMSRABReleaseRequest_protocolIEs__item__value,
        __MBMSRABReleaseRequest_protocolIEs__item_,
        _MBMSRABReleaseRequest_protocolIEs,
        ____MBMSRABReleaseRequest_protocolExtensions__item__id_tab,
        ___MBMSRABReleaseRequest_protocolExtensions__item__id,
        ____MBMSRABReleaseRequest_protocolExtensions__item__criticality_tab,
        ___MBMSRABReleaseRequest_protocolExtensions__item__criticality,
        ____MBMSRABReleaseRequest_protocolExtensions__item__extensionValue_tab,
        ___MBMSRABReleaseRequest_protocolExtensions__item__extensionValue,
        __MBMSRABReleaseRequest_protocolExtensions__item_,
        _MBMSRABReleaseRequest_protocolExtensions,
        MBMSRABReleaseRequest,
        MBMSRABReleaseRequestIEs,
        _MBMSRABReleaseRequestIEs_val_Value_0,
        MBMSRABReleaseRequestExtensions,
        ____MBMSRABRelease_protocolIEs__item__id_tab,
        _____MBMSRABRelease_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSRABRelease_protocolIEs__item__id_tab_val_Value_1,
        ___MBMSRABRelease_protocolIEs__item__id,
        ___MBMSRABRelease_protocolIEs__item__criticality,
        ___MBMSRABRelease_protocolIEs__item__value,
        __MBMSRABRelease_protocolIEs__item_,
        _MBMSRABRelease_protocolIEs,
        ____MBMSRABRelease_protocolExtensions__item__id_tab,
        ___MBMSRABRelease_protocolExtensions__item__id,
        ____MBMSRABRelease_protocolExtensions__item__criticality_tab,
        ___MBMSRABRelease_protocolExtensions__item__criticality,
        ____MBMSRABRelease_protocolExtensions__item__extensionValue_tab,
        ___MBMSRABRelease_protocolExtensions__item__extensionValue,
        __MBMSRABRelease_protocolExtensions__item_,
        _MBMSRABRelease_protocolExtensions,
        MBMSRABRelease,
        MBMSRABReleaseIEs,
        _MBMSRABReleaseIEs_val_Value_0,
        _MBMSRABReleaseIEs_val_Value_1,
        MBMSRABReleaseExtensions,
        ____MBMSRABReleaseFailure_protocolIEs__item__id_tab,
        _____MBMSRABReleaseFailure_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSRABReleaseFailure_protocolIEs__item__id_tab_val_Value_1,
        ___MBMSRABReleaseFailure_protocolIEs__item__id,
        ___MBMSRABReleaseFailure_protocolIEs__item__criticality,
        ___MBMSRABReleaseFailure_protocolIEs__item__value,
        __MBMSRABReleaseFailure_protocolIEs__item_,
        _MBMSRABReleaseFailure_protocolIEs,
        ____MBMSRABReleaseFailure_protocolExtensions__item__id_tab,
        ___MBMSRABReleaseFailure_protocolExtensions__item__id,
        ____MBMSRABReleaseFailure_protocolExtensions__item__criticality_tab,
        ___MBMSRABReleaseFailure_protocolExtensions__item__criticality,
        ____MBMSRABReleaseFailure_protocolExtensions__item__extensionValue_tab,
        ___MBMSRABReleaseFailure_protocolExtensions__item__extensionValue,
        __MBMSRABReleaseFailure_protocolExtensions__item_,
        _MBMSRABReleaseFailure_protocolExtensions,
        MBMSRABReleaseFailure,
        MBMSRABReleaseFailureIEs,
        _MBMSRABReleaseFailureIEs_val_Value_0,
        _MBMSRABReleaseFailureIEs_val_Value_1,
        MBMSRABReleaseFailureExtensions,
        ____SRVCC_CSKeysRequest_protocolIEs__item__id_tab,
        ___SRVCC_CSKeysRequest_protocolIEs__item__id,
        ____SRVCC_CSKeysRequest_protocolIEs__item__criticality_tab,
        ___SRVCC_CSKeysRequest_protocolIEs__item__criticality,
        ____SRVCC_CSKeysRequest_protocolIEs__item__value_tab,
        ___SRVCC_CSKeysRequest_protocolIEs__item__value,
        __SRVCC_CSKeysRequest_protocolIEs__item_,
        _SRVCC_CSKeysRequest_protocolIEs,
        ____SRVCC_CSKeysRequest_protocolExtensions__item__id_tab,
        ___SRVCC_CSKeysRequest_protocolExtensions__item__id,
        ____SRVCC_CSKeysRequest_protocolExtensions__item__criticality_tab,
        ___SRVCC_CSKeysRequest_protocolExtensions__item__criticality,
        ____SRVCC_CSKeysRequest_protocolExtensions__item__extensionValue_tab,
        ___SRVCC_CSKeysRequest_protocolExtensions__item__extensionValue,
        __SRVCC_CSKeysRequest_protocolExtensions__item_,
        _SRVCC_CSKeysRequest_protocolExtensions,
        SRVCC_CSKeysRequest,
        SRVCC_CSKeysRequestIEs,
        SRVCC_CSKeysRequestExtensions,
        ____SRVCC_CSKeysResponse_protocolIEs__item__id_tab,
        _____SRVCC_CSKeysResponse_protocolIEs__item__id_tab_val_Value_0,
        _____SRVCC_CSKeysResponse_protocolIEs__item__id_tab_val_Value_1,
        _____SRVCC_CSKeysResponse_protocolIEs__item__id_tab_val_Value_2,
        _____SRVCC_CSKeysResponse_protocolIEs__item__id_tab_val_Value_3,
        ___SRVCC_CSKeysResponse_protocolIEs__item__id,
        ___SRVCC_CSKeysResponse_protocolIEs__item__criticality,
        ___SRVCC_CSKeysResponse_protocolIEs__item__value,
        __SRVCC_CSKeysResponse_protocolIEs__item_,
        _SRVCC_CSKeysResponse_protocolIEs,
        ____SRVCC_CSKeysResponse_protocolExtensions__item__id_tab,
        ___SRVCC_CSKeysResponse_protocolExtensions__item__id,
        ____SRVCC_CSKeysResponse_protocolExtensions__item__criticality_tab,
        ___SRVCC_CSKeysResponse_protocolExtensions__item__criticality,
        ____SRVCC_CSKeysResponse_protocolExtensions__item__extensionValue_tab,
        ___SRVCC_CSKeysResponse_protocolExtensions__item__extensionValue,
        __SRVCC_CSKeysResponse_protocolExtensions__item_,
        _SRVCC_CSKeysResponse_protocolExtensions,
        SRVCC_CSKeysResponse,
        SRVCC_CSKeysResponseIEs,
        _SRVCC_CSKeysResponseIEs_val_Value_0,
        _SRVCC_CSKeysResponseIEs_val_Value_1,
        _SRVCC_CSKeysResponseIEs_val_Value_2,
        _SRVCC_CSKeysResponseIEs_val_Value_3,
        SRVCC_CSKeysResponseExtensions,
        ____UeRadioCapabilityMatchRequest_protocolIEs__item__id_tab,
        ___UeRadioCapabilityMatchRequest_protocolIEs__item__id,
        ____UeRadioCapabilityMatchRequest_protocolIEs__item__criticality_tab,
        ___UeRadioCapabilityMatchRequest_protocolIEs__item__criticality,
        ____UeRadioCapabilityMatchRequest_protocolIEs__item__value_tab,
        ___UeRadioCapabilityMatchRequest_protocolIEs__item__value,
        __UeRadioCapabilityMatchRequest_protocolIEs__item_,
        _UeRadioCapabilityMatchRequest_protocolIEs,
        ____UeRadioCapabilityMatchRequest_protocolExtensions__item__id_tab,
        ___UeRadioCapabilityMatchRequest_protocolExtensions__item__id,
        ____UeRadioCapabilityMatchRequest_protocolExtensions__item__criticality_tab,
        ___UeRadioCapabilityMatchRequest_protocolExtensions__item__criticality,
        ____UeRadioCapabilityMatchRequest_protocolExtensions__item__extensionValue_tab,
        ___UeRadioCapabilityMatchRequest_protocolExtensions__item__extensionValue,
        __UeRadioCapabilityMatchRequest_protocolExtensions__item_,
        _UeRadioCapabilityMatchRequest_protocolExtensions,
        UeRadioCapabilityMatchRequest,
        UeRadioCapabilityMatchRequestIEs,
        UeRadioCapabilityMatchRequestExtensions,
        ____UeRadioCapabilityMatchResponse_protocolIEs__item__id_tab,
        _____UeRadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_0,
        ___UeRadioCapabilityMatchResponse_protocolIEs__item__id,
        ___UeRadioCapabilityMatchResponse_protocolIEs__item__criticality,
        ___UeRadioCapabilityMatchResponse_protocolIEs__item__value,
        __UeRadioCapabilityMatchResponse_protocolIEs__item_,
        _UeRadioCapabilityMatchResponse_protocolIEs,
        ____UeRadioCapabilityMatchResponse_protocolExtensions__item__id_tab,
        ___UeRadioCapabilityMatchResponse_protocolExtensions__item__id,
        ____UeRadioCapabilityMatchResponse_protocolExtensions__item__criticality_tab,
        ___UeRadioCapabilityMatchResponse_protocolExtensions__item__criticality,
        ____UeRadioCapabilityMatchResponse_protocolExtensions__item__extensionValue_tab,
        ___UeRadioCapabilityMatchResponse_protocolExtensions__item__extensionValue,
        __UeRadioCapabilityMatchResponse_protocolExtensions__item_,
        _UeRadioCapabilityMatchResponse_protocolExtensions,
        UeRadioCapabilityMatchResponse,
        UeRadioCapabilityMatchResponseIEs,
        _UeRadioCapabilityMatchResponseIEs_val_Value_0,
        UeRadioCapabilityMatchResponseExtensions,
        ____UeRegistrationQueryRequest_protocolIEs__item__id_tab,
        _____UeRegistrationQueryRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UeRegistrationQueryRequest_protocolIEs__item__id_tab_val_Value_1,
        ___UeRegistrationQueryRequest_protocolIEs__item__id,
        ___UeRegistrationQueryRequest_protocolIEs__item__criticality,
        ___UeRegistrationQueryRequest_protocolIEs__item__value,
        __UeRegistrationQueryRequest_protocolIEs__item_,
        _UeRegistrationQueryRequest_protocolIEs,
        ____UeRegistrationQueryRequest_protocolExtensions__item__id_tab,
        ___UeRegistrationQueryRequest_protocolExtensions__item__id,
        ____UeRegistrationQueryRequest_protocolExtensions__item__criticality_tab,
        ___UeRegistrationQueryRequest_protocolExtensions__item__criticality,
        ____UeRegistrationQueryRequest_protocolExtensions__item__extensionValue_tab,
        ___UeRegistrationQueryRequest_protocolExtensions__item__extensionValue,
        __UeRegistrationQueryRequest_protocolExtensions__item_,
        _UeRegistrationQueryRequest_protocolExtensions,
        UeRegistrationQueryRequest,
        UeRegistrationQueryRequestIEs,
        _UeRegistrationQueryRequestIEs_val_Value_0,
        _UeRegistrationQueryRequestIEs_val_Value_1,
        UeRegistrationQueryRequestExtensions,
        ____UeRegistrationQueryResponse_protocolIEs__item__id_tab,
        _____UeRegistrationQueryResponse_protocolIEs__item__id_tab_val_Value_0,
        ___UeRegistrationQueryResponse_protocolIEs__item__id,
        ___UeRegistrationQueryResponse_protocolIEs__item__criticality,
        ___UeRegistrationQueryResponse_protocolIEs__item__value,
        __UeRegistrationQueryResponse_protocolIEs__item_,
        _UeRegistrationQueryResponse_protocolIEs,
        ____UeRegistrationQueryResponse_protocolExtensions__item__id_tab,
        ___UeRegistrationQueryResponse_protocolExtensions__item__id,
        ____UeRegistrationQueryResponse_protocolExtensions__item__criticality_tab,
        ___UeRegistrationQueryResponse_protocolExtensions__item__criticality,
        ____UeRegistrationQueryResponse_protocolExtensions__item__extensionValue_tab,
        ___UeRegistrationQueryResponse_protocolExtensions__item__extensionValue,
        __UeRegistrationQueryResponse_protocolExtensions__item_,
        _UeRegistrationQueryResponse_protocolExtensions,
        UeRegistrationQueryResponse,
        UeRegistrationQueryResponseIEs,
        _UeRegistrationQueryResponseIEs_val_Value_0,
        UeRegistrationQueryResponseExtensions,
        ____RerouteNASRequest_protocolIEs__item__id_tab,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_0,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_1,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_2,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_3,
        ___RerouteNASRequest_protocolIEs__item__id,
        ___RerouteNASRequest_protocolIEs__item__criticality,
        ___RerouteNASRequest_protocolIEs__item__value,
        __RerouteNASRequest_protocolIEs__item_,
        _RerouteNASRequest_protocolIEs,
        ____RerouteNASRequest_protocolExtensions__item__id_tab,
        ___RerouteNASRequest_protocolExtensions__item__id,
        ____RerouteNASRequest_protocolExtensions__item__criticality_tab,
        ___RerouteNASRequest_protocolExtensions__item__criticality,
        ____RerouteNASRequest_protocolExtensions__item__extensionValue_tab,
        ___RerouteNASRequest_protocolExtensions__item__extensionValue,
        __RerouteNASRequest_protocolExtensions__item_,
        _RerouteNASRequest_protocolExtensions,
        RerouteNASRequest,
        RerouteNASRequestIEs,
        _RerouteNASRequestIEs_val_Value_0,
        _RerouteNASRequestIEs_val_Value_1,
        _RerouteNASRequestIEs_val_Value_2,
        _RerouteNASRequestIEs_val_Value_3,
        RerouteNASRequestExtensions,
    ]

class RANAP_PDU_Descriptions:

    _name_  = u'RANAP-PDU-Descriptions'
    _oid_   = [0, 4, 0, 0, 20, 3, 0, 1, 0]
    
    _obj_ = [
        u'RANAP-ELEMENTARY-PROCEDURE',
        u'RANAP-PDU',
        u'InitiatingMessage',
        u'SuccessfulOutcome',
        u'UnsuccessfulOutcome',
        u'Outcome',
        u'RANAP-ELEMENTARY-PROCEDURES',
        u'RANAP-ELEMENTARY-PROCEDURES-CLASS-1',
        u'RANAP-ELEMENTARY-PROCEDURES-CLASS-2',
        u'RANAP-ELEMENTARY-PROCEDURES-CLASS-3',
        u'iu-Release',
        u'relocationPreparation',
        u'relocationResourceAllocation',
        u'relocationCancel',
        u'sRNS-ContextTransfer',
        u'securityModeControl',
        u'dataVolumeReport',
        u'reset',
        u'rAB-ReleaseRequest',
        u'iu-ReleaseRequest',
        u'relocationDetect',
        u'relocationComplete',
        u'paging',
        u'commonID',
        u'cN-InvokeTrace',
        u'cN-DeactivateTrace',
        u'locationReportingControl',
        u'locationReport',
        u'initialUE-Message',
        u'directTransfer',
        u'overloadControl',
        u'errorIndication',
        u'sRNS-DataForward',
        u'forwardSRNS-Context',
        u'rAB-Assignment',
        u'privateMessage',
        u'resetResource',
        u'rANAP-Relocation',
        u'rAB-ModifyRequest',
        u'locationRelatedData',
        u'informationTransfer',
        u'uESpecificInformation',
        u'directInformationTransfer',
        u'uplinkInformationExchange',
        u'mBMSSessionStart',
        u'mBMSSessionUpdate',
        u'mBMSSessionStop',
        u'mBMSUELinking',
        u'mBMSRegistration',
        u'mBMSCNDe-Registration',
        u'mBMSRABEstablishmentIndication',
        u'mBMSRABRelease',
        u'enhancedRelocationComplete',
        u'enhancedRelocationCompleteConfirm',
        u'rANAP-enhancedRelocation',
        u'sRVCCPreparation',
        u'ueRadioCapabilityMatch',
        u'ueRegistrationQuery',
        u'rerouteNASRequest',
        ]
    _type_ = [
        u'RANAP-ELEMENTARY-PROCEDURE',
        u'RANAP-PDU',
        u'InitiatingMessage',
        u'SuccessfulOutcome',
        u'UnsuccessfulOutcome',
        u'Outcome',
        ]
    _set_ = [
        u'RANAP-ELEMENTARY-PROCEDURES',
        u'RANAP-ELEMENTARY-PROCEDURES-CLASS-1',
        u'RANAP-ELEMENTARY-PROCEDURES-CLASS-2',
        u'RANAP-ELEMENTARY-PROCEDURES-CLASS-3',
        ]
    _val_ = [
        u'iu-Release',
        u'relocationPreparation',
        u'relocationResourceAllocation',
        u'relocationCancel',
        u'sRNS-ContextTransfer',
        u'securityModeControl',
        u'dataVolumeReport',
        u'reset',
        u'rAB-ReleaseRequest',
        u'iu-ReleaseRequest',
        u'relocationDetect',
        u'relocationComplete',
        u'paging',
        u'commonID',
        u'cN-InvokeTrace',
        u'cN-DeactivateTrace',
        u'locationReportingControl',
        u'locationReport',
        u'initialUE-Message',
        u'directTransfer',
        u'overloadControl',
        u'errorIndication',
        u'sRNS-DataForward',
        u'forwardSRNS-Context',
        u'rAB-Assignment',
        u'privateMessage',
        u'resetResource',
        u'rANAP-Relocation',
        u'rAB-ModifyRequest',
        u'locationRelatedData',
        u'informationTransfer',
        u'uESpecificInformation',
        u'directInformationTransfer',
        u'uplinkInformationExchange',
        u'mBMSSessionStart',
        u'mBMSSessionUpdate',
        u'mBMSSessionStop',
        u'mBMSUELinking',
        u'mBMSRegistration',
        u'mBMSCNDe-Registration',
        u'mBMSRABEstablishmentIndication',
        u'mBMSRABRelease',
        u'enhancedRelocationComplete',
        u'enhancedRelocationCompleteConfirm',
        u'rANAP-enhancedRelocation',
        u'sRVCCPreparation',
        u'ueRadioCapabilityMatch',
        u'ueRegistrationQuery',
        u'rerouteNASRequest',
        ]
    _class_ = [
        u'RANAP-ELEMENTARY-PROCEDURE',
        u'RANAP-ELEMENTARY-PROCEDURES',
        u'RANAP-ELEMENTARY-PROCEDURES-CLASS-1',
        u'RANAP-ELEMENTARY-PROCEDURES-CLASS-2',
        u'RANAP-ELEMENTARY-PROCEDURES-CLASS-3',
        u'iu-Release',
        u'relocationPreparation',
        u'relocationResourceAllocation',
        u'relocationCancel',
        u'sRNS-ContextTransfer',
        u'securityModeControl',
        u'dataVolumeReport',
        u'reset',
        u'rAB-ReleaseRequest',
        u'iu-ReleaseRequest',
        u'relocationDetect',
        u'relocationComplete',
        u'paging',
        u'commonID',
        u'cN-InvokeTrace',
        u'cN-DeactivateTrace',
        u'locationReportingControl',
        u'locationReport',
        u'initialUE-Message',
        u'directTransfer',
        u'overloadControl',
        u'errorIndication',
        u'sRNS-DataForward',
        u'forwardSRNS-Context',
        u'rAB-Assignment',
        u'privateMessage',
        u'resetResource',
        u'rANAP-Relocation',
        u'rAB-ModifyRequest',
        u'locationRelatedData',
        u'informationTransfer',
        u'uESpecificInformation',
        u'directInformationTransfer',
        u'uplinkInformationExchange',
        u'mBMSSessionStart',
        u'mBMSSessionUpdate',
        u'mBMSSessionStop',
        u'mBMSUELinking',
        u'mBMSRegistration',
        u'mBMSCNDe-Registration',
        u'mBMSRABEstablishmentIndication',
        u'mBMSRABRelease',
        u'enhancedRelocationComplete',
        u'enhancedRelocationCompleteConfirm',
        u'rANAP-enhancedRelocation',
        u'sRVCCPreparation',
        u'ueRadioCapabilityMatch',
        u'ueRegistrationQuery',
        u'rerouteNASRequest',
        ]
    _param_ = [
        ]
    
    #-----< RANAP-ELEMENTARY-PROCEDURE >-----#
    RANAP_ELEMENTARY_PROCEDURE = CLASS(name=u'RANAP-ELEMENTARY-PROCEDURE', mode=MODE_TYPE)
    _RANAP_ELEMENTARY_PROCEDURE_InitiatingMessage = OPEN(name=u'InitiatingMessage', mode=MODE_TYPE)
    _RANAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome = OPEN(name=u'SuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _RANAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome = OPEN(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _RANAP_ELEMENTARY_PROCEDURE_Outcome = OPEN(name=u'Outcome', mode=MODE_TYPE, opt=True)
    _RANAP_ELEMENTARY_PROCEDURE_procedureCode = INT(name=u'procedureCode', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'ProcedureCode')), uniq=True)
    _RANAP_ELEMENTARY_PROCEDURE_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'Criticality')), default=u'ignore')
    RANAP_ELEMENTARY_PROCEDURE._cont = ASN1Dict([
        (u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURE_InitiatingMessage),
        (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome),
        (u'UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome),
        (u'Outcome', _RANAP_ELEMENTARY_PROCEDURE_Outcome),
        (u'procedureCode', _RANAP_ELEMENTARY_PROCEDURE_procedureCode),
        (u'criticality', _RANAP_ELEMENTARY_PROCEDURE_criticality),
        ])
    
    #-----< RANAP-PDU >-----#
    RANAP_PDU = CHOICE(name=u'RANAP-PDU', mode=MODE_TYPE)
    _RANAP_PDU_initiatingMessage = SEQ(name=u'initiatingMessage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'InitiatingMessage')))
    _RANAP_PDU_successfulOutcome = SEQ(name=u'successfulOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'SuccessfulOutcome')))
    _RANAP_PDU_unsuccessfulOutcome = SEQ(name=u'unsuccessfulOutcome', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'UnsuccessfulOutcome')))
    _RANAP_PDU_outcome = SEQ(name=u'outcome', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'Outcome')))
    RANAP_PDU._cont = ASN1Dict([
        (u'initiatingMessage', _RANAP_PDU_initiatingMessage),
        (u'successfulOutcome', _RANAP_PDU_successfulOutcome),
        (u'unsuccessfulOutcome', _RANAP_PDU_unsuccessfulOutcome),
        (u'outcome', _RANAP_PDU_outcome),
        ])
    RANAP_PDU._ext = []
    
    #-----< InitiatingMessage >-----#
    InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE)
    _InitiatingMessage_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE'), [u'procedureCode']))
    __InitiatingMessage_procedureCode_tab = CLASS(name='_tab_RANAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseCommand')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseComplete')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequired')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCommand')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationPreparationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequestAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancel')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancelAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeCommand')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeComplete')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeReject')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReportRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Reset')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResource')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationDetect')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationComplete')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Paging')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CommonID')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-InvokeTrace')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-DeactivateTrace')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReportingControl')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InitialUE-Message')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Overload')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ErrorIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-DataForwardCommand')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ForwardSRNS-Context')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'PrivateMessage')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-RelocationInformation')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentRequest')))
    ___InitiatingMessage_procedureCode_tab_val_Outcome_27 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_28 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_28 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferIndication')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_29 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferConfirmation')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_29 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_30 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_30 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStart')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_31 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_31 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_32 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_32 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStop')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_33 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStopResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingRequest')))
    ___InitiatingMessage_procedureCode_tab_val_Outcome_34 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_35 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_35 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_36 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_37 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABRelease')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_37 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_38 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_38 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_39 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysRequest')))
    ___InitiatingMessage_procedureCode_tab_val_Outcome_40 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchRequest')))
    ___InitiatingMessage_procedureCode_tab_val_Outcome_41 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryRequest')))
    ___InitiatingMessage_procedureCode_tab_val_Outcome_42 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ModifyRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UESpecificInformationIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectInformationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABEstablishmentIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RerouteNASRequest')))
    __InitiatingMessage_procedureCode_tab._val = ASN1Set(rv=[dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0), (u'procedureCode', 1), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1), (u'procedureCode', 2), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2), (u'procedureCode', 3), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3), (u'procedureCode', 4), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4), (u'procedureCode', 5), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_5), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7), (u'procedureCode', 9), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8), (u'procedureCode', 27), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9), (u'procedureCode', 10), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11), (u'procedureCode', 12), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12), (u'procedureCode', 13), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13), (u'procedureCode', 14), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14), (u'procedureCode', 15), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15), (u'procedureCode', 16), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16), (u'procedureCode', 26), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17), (u'procedureCode', 17), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18), (u'procedureCode', 18), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19), (u'procedureCode', 19), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20), (u'procedureCode', 20), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21), (u'procedureCode', 21), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22), (u'procedureCode', 22), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23), (u'procedureCode', 23), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24), (u'procedureCode', 24), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25), (u'procedureCode', 25), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26), (u'procedureCode', 28), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27), (u'Outcome', ___InitiatingMessage_procedureCode_tab_val_Outcome_27), (u'procedureCode', 0), (u'criticality', u'reject')])], rr=[], ev=[dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_28), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_28), (u'procedureCode', 30), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_29), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_29), (u'procedureCode', 31), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_30), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_30), (u'procedureCode', 33), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_31), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_31), (u'procedureCode', 35), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_32), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_32), (u'procedureCode', 36), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_33), (u'procedureCode', 37), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34), (u'Outcome', ___InitiatingMessage_procedureCode_tab_val_Outcome_34), (u'procedureCode', 38), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_35), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_35), (u'procedureCode', 39), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_36), (u'procedureCode', 40), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_37), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_37), (u'procedureCode', 42), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_38), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_38), (u'procedureCode', 43), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_39), (u'procedureCode', 45), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40), (u'Outcome', ___InitiatingMessage_procedureCode_tab_val_Outcome_40), (u'procedureCode', 46), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41), (u'Outcome', ___InitiatingMessage_procedureCode_tab_val_Outcome_41), (u'procedureCode', 47), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42), (u'Outcome', ___InitiatingMessage_procedureCode_tab_val_Outcome_42), (u'procedureCode', 48), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43), (u'procedureCode', 29), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44), (u'procedureCode', 32), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45), (u'procedureCode', 34), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46), (u'procedureCode', 41), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47), (u'procedureCode', 44), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48), (u'procedureCode', 49), (u'criticality', u'reject')])], er=[])
    _InitiatingMessage_procedureCode._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_procedureCode._const_tab_at = None
    _InitiatingMessage_procedureCode._const_tab_id = u'procedureCode'
    _InitiatingMessage_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE'), [u'criticality']))
    _InitiatingMessage_criticality._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_criticality._const_tab_at = ('..', u'procedureCode')
    _InitiatingMessage_criticality._const_tab_id = u'criticality'
    _InitiatingMessage_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE'), [u'InitiatingMessage']))
    _InitiatingMessage_value._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_value._const_tab_at = ('..', u'procedureCode')
    _InitiatingMessage_value._const_tab_id = u'InitiatingMessage'
    InitiatingMessage._cont = ASN1Dict([
        (u'procedureCode', _InitiatingMessage_procedureCode),
        (u'criticality', _InitiatingMessage_criticality),
        (u'value', _InitiatingMessage_value),
        ])
    InitiatingMessage._ext = None
    
    #-----< SuccessfulOutcome >-----#
    SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE)
    _SuccessfulOutcome_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE'), [u'procedureCode']))
    __SuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_RANAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseComplete')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequired')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationPreparationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequestAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancel')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancelAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeComplete')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeReject')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReportRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Reset')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResource')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationDetect')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationComplete')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Paging')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CommonID')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-InvokeTrace')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-DeactivateTrace')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReportingControl')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InitialUE-Message')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Overload')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ErrorIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-DataForwardCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ForwardSRNS-Context')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'PrivateMessage')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-RelocationInformation')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_Outcome_27 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_28 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_28 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_29 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferConfirmation')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_29 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_30 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_30 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStart')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_31 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_31 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_32 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_32 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStop')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_33 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStopResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_Outcome_34 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_35 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_35 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_36 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_37 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABRelease')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_37 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_38 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_38 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_39 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_Outcome_40 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_Outcome_41 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_Outcome_42 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ModifyRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UESpecificInformationIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectInformationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABEstablishmentIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RerouteNASRequest')))
    __SuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), (u'procedureCode', 1), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), (u'procedureCode', 2), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), (u'procedureCode', 3), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), (u'procedureCode', 4), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), (u'procedureCode', 5), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), (u'procedureCode', 9), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), (u'procedureCode', 27), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), (u'procedureCode', 10), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), (u'procedureCode', 12), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), (u'procedureCode', 13), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), (u'procedureCode', 14), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), (u'procedureCode', 15), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), (u'procedureCode', 16), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), (u'procedureCode', 26), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17), (u'procedureCode', 17), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18), (u'procedureCode', 18), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19), (u'procedureCode', 19), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20), (u'procedureCode', 20), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21), (u'procedureCode', 21), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22), (u'procedureCode', 22), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23), (u'procedureCode', 23), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24), (u'procedureCode', 24), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25), (u'procedureCode', 25), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26), (u'procedureCode', 28), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27), (u'Outcome', ___SuccessfulOutcome_procedureCode_tab_val_Outcome_27), (u'procedureCode', 0), (u'criticality', u'reject')])], rr=[], ev=[dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_28), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_28), (u'procedureCode', 30), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_29), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_29), (u'procedureCode', 31), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_30), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_30), (u'procedureCode', 33), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_31), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_31), (u'procedureCode', 35), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_32), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_32), (u'procedureCode', 36), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_33), (u'procedureCode', 37), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34), (u'Outcome', ___SuccessfulOutcome_procedureCode_tab_val_Outcome_34), (u'procedureCode', 38), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_35), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_35), (u'procedureCode', 39), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_36), (u'procedureCode', 40), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_37), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_37), (u'procedureCode', 42), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_38), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_38), (u'procedureCode', 43), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_39), (u'procedureCode', 45), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40), (u'Outcome', ___SuccessfulOutcome_procedureCode_tab_val_Outcome_40), (u'procedureCode', 46), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41), (u'Outcome', ___SuccessfulOutcome_procedureCode_tab_val_Outcome_41), (u'procedureCode', 47), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42), (u'Outcome', ___SuccessfulOutcome_procedureCode_tab_val_Outcome_42), (u'procedureCode', 48), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43), (u'procedureCode', 29), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44), (u'procedureCode', 32), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45), (u'procedureCode', 34), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46), (u'procedureCode', 41), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47), (u'procedureCode', 44), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48), (u'procedureCode', 49), (u'criticality', u'reject')])], er=[])
    _SuccessfulOutcome_procedureCode._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_procedureCode._const_tab_at = None
    _SuccessfulOutcome_procedureCode._const_tab_id = u'procedureCode'
    _SuccessfulOutcome_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE'), [u'criticality']))
    _SuccessfulOutcome_criticality._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_criticality._const_tab_at = ('..', u'procedureCode')
    _SuccessfulOutcome_criticality._const_tab_id = u'criticality'
    _SuccessfulOutcome_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE'), [u'SuccessfulOutcome']))
    _SuccessfulOutcome_value._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_value._const_tab_at = ('..', u'procedureCode')
    _SuccessfulOutcome_value._const_tab_id = u'SuccessfulOutcome'
    SuccessfulOutcome._cont = ASN1Dict([
        (u'procedureCode', _SuccessfulOutcome_procedureCode),
        (u'criticality', _SuccessfulOutcome_criticality),
        (u'value', _SuccessfulOutcome_value),
        ])
    SuccessfulOutcome._ext = None
    
    #-----< UnsuccessfulOutcome >-----#
    UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE)
    _UnsuccessfulOutcome_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE'), [u'procedureCode']))
    __UnsuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_RANAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseComplete')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequired')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationPreparationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequestAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancel')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancelAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeComplete')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeReject')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReportRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Reset')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResource')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationDetect')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationComplete')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Paging')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CommonID')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-InvokeTrace')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-DeactivateTrace')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReportingControl')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InitialUE-Message')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Overload')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ErrorIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-DataForwardCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ForwardSRNS-Context')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'PrivateMessage')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-RelocationInformation')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_27 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_28 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_28 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_29 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferConfirmation')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_29 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_30 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_30 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStart')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_31 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_31 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_32 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_32 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStop')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_33 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStopResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_34 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_35 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_35 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_36 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_37 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABRelease')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_37 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_38 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_38 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_39 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_40 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_41 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_42 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ModifyRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UESpecificInformationIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectInformationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABEstablishmentIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RerouteNASRequest')))
    __UnsuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), (u'procedureCode', 1), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), (u'procedureCode', 2), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), (u'procedureCode', 3), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), (u'procedureCode', 4), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), (u'procedureCode', 5), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), (u'procedureCode', 9), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), (u'procedureCode', 27), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), (u'procedureCode', 10), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), (u'procedureCode', 12), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), (u'procedureCode', 13), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), (u'procedureCode', 14), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), (u'procedureCode', 15), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), (u'procedureCode', 16), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), (u'procedureCode', 26), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17), (u'procedureCode', 17), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18), (u'procedureCode', 18), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19), (u'procedureCode', 19), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20), (u'procedureCode', 20), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21), (u'procedureCode', 21), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22), (u'procedureCode', 22), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23), (u'procedureCode', 23), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24), (u'procedureCode', 24), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25), (u'procedureCode', 25), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26), (u'procedureCode', 28), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27), (u'Outcome', ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_27), (u'procedureCode', 0), (u'criticality', u'reject')])], rr=[], ev=[dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_28), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_28), (u'procedureCode', 30), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_29), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_29), (u'procedureCode', 31), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_30), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_30), (u'procedureCode', 33), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_31), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_31), (u'procedureCode', 35), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_32), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_32), (u'procedureCode', 36), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_33), (u'procedureCode', 37), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34), (u'Outcome', ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_34), (u'procedureCode', 38), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_35), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_35), (u'procedureCode', 39), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_36), (u'procedureCode', 40), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_37), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_37), (u'procedureCode', 42), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_38), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_38), (u'procedureCode', 43), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_39), (u'procedureCode', 45), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40), (u'Outcome', ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_40), (u'procedureCode', 46), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41), (u'Outcome', ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_41), (u'procedureCode', 47), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42), (u'Outcome', ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_42), (u'procedureCode', 48), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43), (u'procedureCode', 29), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44), (u'procedureCode', 32), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45), (u'procedureCode', 34), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46), (u'procedureCode', 41), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47), (u'procedureCode', 44), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48), (u'procedureCode', 49), (u'criticality', u'reject')])], er=[])
    _UnsuccessfulOutcome_procedureCode._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_procedureCode._const_tab_at = None
    _UnsuccessfulOutcome_procedureCode._const_tab_id = u'procedureCode'
    _UnsuccessfulOutcome_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE'), [u'criticality']))
    _UnsuccessfulOutcome_criticality._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_criticality._const_tab_at = ('..', u'procedureCode')
    _UnsuccessfulOutcome_criticality._const_tab_id = u'criticality'
    _UnsuccessfulOutcome_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE'), [u'UnsuccessfulOutcome']))
    _UnsuccessfulOutcome_value._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_value._const_tab_at = ('..', u'procedureCode')
    _UnsuccessfulOutcome_value._const_tab_id = u'UnsuccessfulOutcome'
    UnsuccessfulOutcome._cont = ASN1Dict([
        (u'procedureCode', _UnsuccessfulOutcome_procedureCode),
        (u'criticality', _UnsuccessfulOutcome_criticality),
        (u'value', _UnsuccessfulOutcome_value),
        ])
    UnsuccessfulOutcome._ext = None
    
    #-----< Outcome >-----#
    Outcome = SEQ(name=u'Outcome', mode=MODE_TYPE)
    _Outcome_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE'), [u'procedureCode']))
    __Outcome_procedureCode_tab = CLASS(name='_tab_RANAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseCommand')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseComplete')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequired')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCommand')))
    ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationPreparationFailure')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequest')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequestAcknowledge')))
    ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationFailure')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancel')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancelAcknowledge')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextRequest')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextResponse')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeCommand')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeComplete')))
    ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeReject')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReportRequest')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReport')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Reset')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetAcknowledge')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResource')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceAcknowledge')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseRequest')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseRequest')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationDetect')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationComplete')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Paging')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CommonID')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-InvokeTrace')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-DeactivateTrace')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReportingControl')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReport')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InitialUE-Message')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectTransfer')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Overload')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ErrorIndication')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-DataForwardCommand')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ForwardSRNS-Context')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'PrivateMessage')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-RelocationInformation')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentRequest')))
    ___Outcome_procedureCode_tab_val_Outcome_27 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentResponse')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataRequest')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_28 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataResponse')))
    ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_28 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataFailure')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferIndication')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_29 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferConfirmation')))
    ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_29 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferFailure')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeRequest')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_30 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeResponse')))
    ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_30 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeFailure')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStart')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_31 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartResponse')))
    ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_31 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartFailure')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdate')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_32 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateResponse')))
    ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_32 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateFailure')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStop')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_33 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStopResponse')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingRequest')))
    ___Outcome_procedureCode_tab_val_Outcome_34 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingResponse')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationRequest')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_35 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationResponse')))
    ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_35 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationFailure')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationRequest')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_36 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationResponse')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseRequest')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_37 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABRelease')))
    ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_37 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseFailure')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteRequest')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_38 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteResponse')))
    ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_38 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteFailure')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationRequest')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_39 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationResponse')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysRequest')))
    ___Outcome_procedureCode_tab_val_Outcome_40 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysResponse')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchRequest')))
    ___Outcome_procedureCode_tab_val_Outcome_41 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchResponse')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryRequest')))
    ___Outcome_procedureCode_tab_val_Outcome_42 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryResponse')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ModifyRequest')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UESpecificInformationIndication')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectInformationTransfer')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABEstablishmentIndication')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteConfirm')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RerouteNASRequest')))
    __Outcome_procedureCode_tab._val = ASN1Set(rv=[dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_0), (u'SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_0), (u'procedureCode', 1), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_1), (u'SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_1), (u'procedureCode', 2), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_2), (u'SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_2), (u'procedureCode', 3), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_3), (u'SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_3), (u'procedureCode', 4), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_4), (u'SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_4), (u'procedureCode', 5), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_5), (u'SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_5), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_6), (u'SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_6), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_7), (u'SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_7), (u'procedureCode', 9), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_8), (u'SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_8), (u'procedureCode', 27), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_9), (u'procedureCode', 10), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_10), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_11), (u'procedureCode', 12), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_12), (u'procedureCode', 13), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_13), (u'procedureCode', 14), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_14), (u'procedureCode', 15), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_15), (u'procedureCode', 16), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_16), (u'procedureCode', 26), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_17), (u'procedureCode', 17), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_18), (u'procedureCode', 18), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_19), (u'procedureCode', 19), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_20), (u'procedureCode', 20), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_21), (u'procedureCode', 21), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_22), (u'procedureCode', 22), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_23), (u'procedureCode', 23), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_24), (u'procedureCode', 24), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_25), (u'procedureCode', 25), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_26), (u'procedureCode', 28), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_27), (u'Outcome', ___Outcome_procedureCode_tab_val_Outcome_27), (u'procedureCode', 0), (u'criticality', u'reject')])], rr=[], ev=[dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_28), (u'SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_28), (u'UnsuccessfulOutcome', ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_28), (u'procedureCode', 30), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_29), (u'SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_29), (u'UnsuccessfulOutcome', ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_29), (u'procedureCode', 31), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_30), (u'SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_30), (u'UnsuccessfulOutcome', ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_30), (u'procedureCode', 33), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_31), (u'SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_31), (u'UnsuccessfulOutcome', ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_31), (u'procedureCode', 35), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_32), (u'SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_32), (u'UnsuccessfulOutcome', ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_32), (u'procedureCode', 36), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_33), (u'SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_33), (u'procedureCode', 37), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_34), (u'Outcome', ___Outcome_procedureCode_tab_val_Outcome_34), (u'procedureCode', 38), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_35), (u'SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_35), (u'UnsuccessfulOutcome', ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_35), (u'procedureCode', 39), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_36), (u'SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_36), (u'procedureCode', 40), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_37), (u'SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_37), (u'UnsuccessfulOutcome', ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_37), (u'procedureCode', 42), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_38), (u'SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_38), (u'UnsuccessfulOutcome', ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_38), (u'procedureCode', 43), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_39), (u'SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_39), (u'procedureCode', 45), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_40), (u'Outcome', ___Outcome_procedureCode_tab_val_Outcome_40), (u'procedureCode', 46), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_41), (u'Outcome', ___Outcome_procedureCode_tab_val_Outcome_41), (u'procedureCode', 47), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_42), (u'Outcome', ___Outcome_procedureCode_tab_val_Outcome_42), (u'procedureCode', 48), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_43), (u'procedureCode', 29), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_44), (u'procedureCode', 32), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_45), (u'procedureCode', 34), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_46), (u'procedureCode', 41), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_47), (u'procedureCode', 44), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_48), (u'procedureCode', 49), (u'criticality', u'reject')])], er=[])
    _Outcome_procedureCode._const_tab = __Outcome_procedureCode_tab
    _Outcome_procedureCode._const_tab_at = None
    _Outcome_procedureCode._const_tab_id = u'procedureCode'
    _Outcome_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE'), [u'criticality']))
    _Outcome_criticality._const_tab = __Outcome_procedureCode_tab
    _Outcome_criticality._const_tab_at = ('..', u'procedureCode')
    _Outcome_criticality._const_tab_id = u'criticality'
    _Outcome_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE'), [u'Outcome']))
    _Outcome_value._const_tab = __Outcome_procedureCode_tab
    _Outcome_value._const_tab_at = ('..', u'procedureCode')
    _Outcome_value._const_tab_id = u'Outcome'
    Outcome._cont = ASN1Dict([
        (u'procedureCode', _Outcome_procedureCode),
        (u'criticality', _Outcome_criticality),
        (u'value', _Outcome_value),
        ])
    Outcome._ext = None
    
    #-----< RANAP-ELEMENTARY-PROCEDURES >-----#
    RANAP_ELEMENTARY_PROCEDURES = CLASS(name=u'RANAP-ELEMENTARY-PROCEDURES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseCommand')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseComplete')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequired')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCommand')))
    _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationPreparationFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequestAcknowledge')))
    _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancel')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancelAcknowledge')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeCommand')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeComplete')))
    _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeReject')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReportRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReport')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Reset')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetAcknowledge')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResource')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceAcknowledge')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationDetect')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationComplete')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Paging')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CommonID')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-InvokeTrace')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-DeactivateTrace')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReportingControl')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReport')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InitialUE-Message')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectTransfer')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Overload')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ErrorIndication')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-DataForwardCommand')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ForwardSRNS-Context')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'PrivateMessage')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-RelocationInformation')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_27 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_28 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_28 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferIndication')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_29 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferConfirmation')))
    _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_29 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_30 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_30 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStart')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_31 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_31 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdate')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_32 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_32 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStop')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_33 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStopResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_34 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_35 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_35 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_36 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_37 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABRelease')))
    _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_37 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_38 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_38 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_39 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_40 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_41 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_42 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ModifyRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UESpecificInformationIndication')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectInformationTransfer')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABEstablishmentIndication')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteConfirm')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RerouteNASRequest')))
    RANAP_ELEMENTARY_PROCEDURES._val = ASN1Set(rv=[dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0), (u'procedureCode', 1), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1), (u'procedureCode', 2), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2), (u'procedureCode', 3), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3), (u'procedureCode', 4), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4), (u'procedureCode', 5), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7), (u'procedureCode', 9), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8), (u'procedureCode', 27), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9), (u'procedureCode', 10), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11), (u'procedureCode', 12), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12), (u'procedureCode', 13), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13), (u'procedureCode', 14), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14), (u'procedureCode', 15), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15), (u'procedureCode', 16), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16), (u'procedureCode', 26), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17), (u'procedureCode', 17), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18), (u'procedureCode', 18), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19), (u'procedureCode', 19), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20), (u'procedureCode', 20), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21), (u'procedureCode', 21), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22), (u'procedureCode', 22), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23), (u'procedureCode', 23), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24), (u'procedureCode', 24), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25), (u'procedureCode', 25), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26), (u'procedureCode', 28), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27), (u'Outcome', _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_27), (u'procedureCode', 0), (u'criticality', u'reject')])], rr=[], ev=[dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_28), (u'UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_28), (u'procedureCode', 30), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_29), (u'UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_29), (u'procedureCode', 31), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_30), (u'UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_30), (u'procedureCode', 33), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_31), (u'UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_31), (u'procedureCode', 35), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_32), (u'UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_32), (u'procedureCode', 36), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_33), (u'procedureCode', 37), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34), (u'Outcome', _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_34), (u'procedureCode', 38), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_35), (u'UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_35), (u'procedureCode', 39), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_36), (u'procedureCode', 40), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_37), (u'UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_37), (u'procedureCode', 42), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_38), (u'UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_38), (u'procedureCode', 43), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_39), (u'procedureCode', 45), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40), (u'Outcome', _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_40), (u'procedureCode', 46), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41), (u'Outcome', _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_41), (u'procedureCode', 47), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42), (u'Outcome', _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_42), (u'procedureCode', 48), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43), (u'procedureCode', 29), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44), (u'procedureCode', 32), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45), (u'procedureCode', 34), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46), (u'procedureCode', 41), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47), (u'procedureCode', 44), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48), (u'procedureCode', 49), (u'criticality', u'reject')])], er=[])
    
    #-----< RANAP-ELEMENTARY-PROCEDURES-CLASS-1 >-----#
    RANAP_ELEMENTARY_PROCEDURES_CLASS_1 = CLASS(name=u'RANAP-ELEMENTARY-PROCEDURES-CLASS-1', mode=MODE_SET, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseCommand')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseComplete')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequired')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCommand')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationPreparationFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequestAcknowledge')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancel')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancelAcknowledge')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeCommand')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeComplete')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeReject')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReportRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReport')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Reset')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetAcknowledge')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResource')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceAcknowledge')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_9 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferIndication')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferConfirmation')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStart')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdate')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStop')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStopResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_Outcome_15 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_16 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABRelease')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_18 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_19 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_Outcome_21 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_Outcome_22 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_Outcome_23 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryResponse')))
    RANAP_ELEMENTARY_PROCEDURES_CLASS_1._val = ASN1Set(rv=[dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0), (u'procedureCode', 1), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1), (u'procedureCode', 2), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2), (u'procedureCode', 3), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3), (u'procedureCode', 4), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4), (u'procedureCode', 5), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7), (u'procedureCode', 9), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8), (u'procedureCode', 27), (u'criticality', u'reject')])], rr=[], ev=[dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9), (u'UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_9), (u'procedureCode', 30), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10), (u'UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10), (u'procedureCode', 31), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11), (u'UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11), (u'procedureCode', 33), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12), (u'UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12), (u'procedureCode', 35), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13), (u'UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13), (u'procedureCode', 36), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14), (u'procedureCode', 37), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15), (u'Outcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_Outcome_15), (u'procedureCode', 38), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16), (u'UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_16), (u'procedureCode', 39), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17), (u'procedureCode', 40), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18), (u'UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_18), (u'procedureCode', 42), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19), (u'UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_19), (u'procedureCode', 43), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20), (u'SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20), (u'procedureCode', 45), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21), (u'Outcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_Outcome_21), (u'procedureCode', 46), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_22), (u'Outcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_Outcome_22), (u'procedureCode', 47), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_23), (u'Outcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_Outcome_23), (u'procedureCode', 48), (u'criticality', u'ignore')])], er=[])
    
    #-----< RANAP-ELEMENTARY-PROCEDURES-CLASS-2 >-----#
    RANAP_ELEMENTARY_PROCEDURES_CLASS_2 = CLASS(name=u'RANAP-ELEMENTARY-PROCEDURES-CLASS-2', mode=MODE_SET, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationDetect')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationComplete')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Paging')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CommonID')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-InvokeTrace')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-DeactivateTrace')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReportingControl')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReport')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InitialUE-Message')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectTransfer')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Overload')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ErrorIndication')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-DataForwardCommand')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ForwardSRNS-Context')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'PrivateMessage')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-RelocationInformation')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ModifyRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UESpecificInformationIndication')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectInformationTransfer')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABEstablishmentIndication')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteConfirm')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RerouteNASRequest')))
    RANAP_ELEMENTARY_PROCEDURES_CLASS_2._val = ASN1Set(rv=[dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0), (u'procedureCode', 10), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2), (u'procedureCode', 12), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3), (u'procedureCode', 13), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4), (u'procedureCode', 14), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5), (u'procedureCode', 15), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6), (u'procedureCode', 16), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7), (u'procedureCode', 26), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8), (u'procedureCode', 17), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9), (u'procedureCode', 18), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10), (u'procedureCode', 19), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11), (u'procedureCode', 20), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12), (u'procedureCode', 21), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13), (u'procedureCode', 22), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14), (u'procedureCode', 23), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15), (u'procedureCode', 24), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16), (u'procedureCode', 25), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17), (u'procedureCode', 28), (u'criticality', u'ignore')])], rr=[], ev=[dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18), (u'procedureCode', 29), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19), (u'procedureCode', 32), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20), (u'procedureCode', 34), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21), (u'procedureCode', 41), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22), (u'procedureCode', 44), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23), (u'procedureCode', 49), (u'criticality', u'reject')])], er=[])
    
    #-----< RANAP-ELEMENTARY-PROCEDURES-CLASS-3 >-----#
    RANAP_ELEMENTARY_PROCEDURES_CLASS_3 = CLASS(name=u'RANAP-ELEMENTARY-PROCEDURES-CLASS-3', mode=MODE_SET, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_3_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_3_val_Outcome_0 = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentResponse')))
    RANAP_ELEMENTARY_PROCEDURES_CLASS_3._val = ASN1Set(rv=[dict([(u'InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_3_val_InitiatingMessage_0), (u'Outcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_3_val_Outcome_0), (u'procedureCode', 0), (u'criticality', u'reject')])], rr=[], ev=[], er=[])
    
    #-----< iu-Release >-----#
    iu_Release = CLASS(name=u'iu-Release', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _iu_Release_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseCommand')))
    _iu_Release_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseComplete')))
    iu_Release._val = dict([(u'InitiatingMessage', _iu_Release_val_InitiatingMessage), (u'SuccessfulOutcome', _iu_Release_val_SuccessfulOutcome), (u'procedureCode', 1), (u'criticality', u'reject')])
    
    #-----< relocationPreparation >-----#
    relocationPreparation = CLASS(name=u'relocationPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _relocationPreparation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequired')))
    _relocationPreparation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCommand')))
    _relocationPreparation_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationPreparationFailure')))
    relocationPreparation._val = dict([(u'InitiatingMessage', _relocationPreparation_val_InitiatingMessage), (u'SuccessfulOutcome', _relocationPreparation_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _relocationPreparation_val_UnsuccessfulOutcome), (u'procedureCode', 2), (u'criticality', u'reject')])
    
    #-----< relocationResourceAllocation >-----#
    relocationResourceAllocation = CLASS(name=u'relocationResourceAllocation', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _relocationResourceAllocation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequest')))
    _relocationResourceAllocation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequestAcknowledge')))
    _relocationResourceAllocation_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationFailure')))
    relocationResourceAllocation._val = dict([(u'InitiatingMessage', _relocationResourceAllocation_val_InitiatingMessage), (u'SuccessfulOutcome', _relocationResourceAllocation_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _relocationResourceAllocation_val_UnsuccessfulOutcome), (u'procedureCode', 3), (u'criticality', u'reject')])
    
    #-----< relocationCancel >-----#
    relocationCancel = CLASS(name=u'relocationCancel', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _relocationCancel_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancel')))
    _relocationCancel_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancelAcknowledge')))
    relocationCancel._val = dict([(u'InitiatingMessage', _relocationCancel_val_InitiatingMessage), (u'SuccessfulOutcome', _relocationCancel_val_SuccessfulOutcome), (u'procedureCode', 4), (u'criticality', u'reject')])
    
    #-----< sRNS-ContextTransfer >-----#
    sRNS_ContextTransfer = CLASS(name=u'sRNS-ContextTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _sRNS_ContextTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextRequest')))
    _sRNS_ContextTransfer_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextResponse')))
    sRNS_ContextTransfer._val = dict([(u'InitiatingMessage', _sRNS_ContextTransfer_val_InitiatingMessage), (u'SuccessfulOutcome', _sRNS_ContextTransfer_val_SuccessfulOutcome), (u'procedureCode', 5), (u'criticality', u'reject')])
    
    #-----< securityModeControl >-----#
    securityModeControl = CLASS(name=u'securityModeControl', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _securityModeControl_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeCommand')))
    _securityModeControl_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeComplete')))
    _securityModeControl_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeReject')))
    securityModeControl._val = dict([(u'InitiatingMessage', _securityModeControl_val_InitiatingMessage), (u'SuccessfulOutcome', _securityModeControl_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _securityModeControl_val_UnsuccessfulOutcome), (u'procedureCode', 6), (u'criticality', u'reject')])
    
    #-----< dataVolumeReport >-----#
    dataVolumeReport = CLASS(name=u'dataVolumeReport', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _dataVolumeReport_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReportRequest')))
    _dataVolumeReport_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReport')))
    dataVolumeReport._val = dict([(u'InitiatingMessage', _dataVolumeReport_val_InitiatingMessage), (u'SuccessfulOutcome', _dataVolumeReport_val_SuccessfulOutcome), (u'procedureCode', 7), (u'criticality', u'reject')])
    
    #-----< reset >-----#
    reset = CLASS(name=u'reset', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _reset_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Reset')))
    _reset_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetAcknowledge')))
    reset._val = dict([(u'InitiatingMessage', _reset_val_InitiatingMessage), (u'SuccessfulOutcome', _reset_val_SuccessfulOutcome), (u'procedureCode', 9), (u'criticality', u'reject')])
    
    #-----< rAB-ReleaseRequest >-----#
    rAB_ReleaseRequest = CLASS(name=u'rAB-ReleaseRequest', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _rAB_ReleaseRequest_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseRequest')))
    rAB_ReleaseRequest._val = dict([(u'InitiatingMessage', _rAB_ReleaseRequest_val_InitiatingMessage), (u'procedureCode', 10), (u'criticality', u'ignore')])
    
    #-----< iu-ReleaseRequest >-----#
    iu_ReleaseRequest = CLASS(name=u'iu-ReleaseRequest', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _iu_ReleaseRequest_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseRequest')))
    iu_ReleaseRequest._val = dict([(u'InitiatingMessage', _iu_ReleaseRequest_val_InitiatingMessage), (u'procedureCode', 11), (u'criticality', u'ignore')])
    
    #-----< relocationDetect >-----#
    relocationDetect = CLASS(name=u'relocationDetect', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _relocationDetect_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationDetect')))
    relocationDetect._val = dict([(u'InitiatingMessage', _relocationDetect_val_InitiatingMessage), (u'procedureCode', 12), (u'criticality', u'ignore')])
    
    #-----< relocationComplete >-----#
    relocationComplete = CLASS(name=u'relocationComplete', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _relocationComplete_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationComplete')))
    relocationComplete._val = dict([(u'InitiatingMessage', _relocationComplete_val_InitiatingMessage), (u'procedureCode', 13), (u'criticality', u'ignore')])
    
    #-----< paging >-----#
    paging = CLASS(name=u'paging', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _paging_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Paging')))
    paging._val = dict([(u'InitiatingMessage', _paging_val_InitiatingMessage), (u'procedureCode', 14), (u'criticality', u'ignore')])
    
    #-----< commonID >-----#
    commonID = CLASS(name=u'commonID', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _commonID_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CommonID')))
    commonID._val = dict([(u'InitiatingMessage', _commonID_val_InitiatingMessage), (u'procedureCode', 15), (u'criticality', u'ignore')])
    
    #-----< cN-InvokeTrace >-----#
    cN_InvokeTrace = CLASS(name=u'cN-InvokeTrace', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _cN_InvokeTrace_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-InvokeTrace')))
    cN_InvokeTrace._val = dict([(u'InitiatingMessage', _cN_InvokeTrace_val_InitiatingMessage), (u'procedureCode', 16), (u'criticality', u'ignore')])
    
    #-----< cN-DeactivateTrace >-----#
    cN_DeactivateTrace = CLASS(name=u'cN-DeactivateTrace', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _cN_DeactivateTrace_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-DeactivateTrace')))
    cN_DeactivateTrace._val = dict([(u'InitiatingMessage', _cN_DeactivateTrace_val_InitiatingMessage), (u'procedureCode', 26), (u'criticality', u'ignore')])
    
    #-----< locationReportingControl >-----#
    locationReportingControl = CLASS(name=u'locationReportingControl', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _locationReportingControl_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReportingControl')))
    locationReportingControl._val = dict([(u'InitiatingMessage', _locationReportingControl_val_InitiatingMessage), (u'procedureCode', 17), (u'criticality', u'ignore')])
    
    #-----< locationReport >-----#
    locationReport = CLASS(name=u'locationReport', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _locationReport_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReport')))
    locationReport._val = dict([(u'InitiatingMessage', _locationReport_val_InitiatingMessage), (u'procedureCode', 18), (u'criticality', u'ignore')])
    
    #-----< initialUE-Message >-----#
    initialUE_Message = CLASS(name=u'initialUE-Message', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _initialUE_Message_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InitialUE-Message')))
    initialUE_Message._val = dict([(u'InitiatingMessage', _initialUE_Message_val_InitiatingMessage), (u'procedureCode', 19), (u'criticality', u'ignore')])
    
    #-----< directTransfer >-----#
    directTransfer = CLASS(name=u'directTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _directTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectTransfer')))
    directTransfer._val = dict([(u'InitiatingMessage', _directTransfer_val_InitiatingMessage), (u'procedureCode', 20), (u'criticality', u'ignore')])
    
    #-----< overloadControl >-----#
    overloadControl = CLASS(name=u'overloadControl', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _overloadControl_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Overload')))
    overloadControl._val = dict([(u'InitiatingMessage', _overloadControl_val_InitiatingMessage), (u'procedureCode', 21), (u'criticality', u'ignore')])
    
    #-----< errorIndication >-----#
    errorIndication = CLASS(name=u'errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _errorIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ErrorIndication')))
    errorIndication._val = dict([(u'InitiatingMessage', _errorIndication_val_InitiatingMessage), (u'procedureCode', 22), (u'criticality', u'ignore')])
    
    #-----< sRNS-DataForward >-----#
    sRNS_DataForward = CLASS(name=u'sRNS-DataForward', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _sRNS_DataForward_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-DataForwardCommand')))
    sRNS_DataForward._val = dict([(u'InitiatingMessage', _sRNS_DataForward_val_InitiatingMessage), (u'procedureCode', 23), (u'criticality', u'ignore')])
    
    #-----< forwardSRNS-Context >-----#
    forwardSRNS_Context = CLASS(name=u'forwardSRNS-Context', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _forwardSRNS_Context_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ForwardSRNS-Context')))
    forwardSRNS_Context._val = dict([(u'InitiatingMessage', _forwardSRNS_Context_val_InitiatingMessage), (u'procedureCode', 24), (u'criticality', u'ignore')])
    
    #-----< rAB-Assignment >-----#
    rAB_Assignment = CLASS(name=u'rAB-Assignment', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _rAB_Assignment_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentRequest')))
    _rAB_Assignment_val_Outcome = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentResponse')))
    rAB_Assignment._val = dict([(u'InitiatingMessage', _rAB_Assignment_val_InitiatingMessage), (u'Outcome', _rAB_Assignment_val_Outcome), (u'procedureCode', 0), (u'criticality', u'reject')])
    
    #-----< privateMessage >-----#
    privateMessage = CLASS(name=u'privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _privateMessage_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'PrivateMessage')))
    privateMessage._val = dict([(u'InitiatingMessage', _privateMessage_val_InitiatingMessage), (u'procedureCode', 25), (u'criticality', u'ignore')])
    
    #-----< resetResource >-----#
    resetResource = CLASS(name=u'resetResource', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _resetResource_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResource')))
    _resetResource_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceAcknowledge')))
    resetResource._val = dict([(u'InitiatingMessage', _resetResource_val_InitiatingMessage), (u'SuccessfulOutcome', _resetResource_val_SuccessfulOutcome), (u'procedureCode', 27), (u'criticality', u'reject')])
    
    #-----< rANAP-Relocation >-----#
    rANAP_Relocation = CLASS(name=u'rANAP-Relocation', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _rANAP_Relocation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-RelocationInformation')))
    rANAP_Relocation._val = dict([(u'InitiatingMessage', _rANAP_Relocation_val_InitiatingMessage), (u'procedureCode', 28), (u'criticality', u'ignore')])
    
    #-----< rAB-ModifyRequest >-----#
    rAB_ModifyRequest = CLASS(name=u'rAB-ModifyRequest', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _rAB_ModifyRequest_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ModifyRequest')))
    rAB_ModifyRequest._val = dict([(u'InitiatingMessage', _rAB_ModifyRequest_val_InitiatingMessage), (u'procedureCode', 29), (u'criticality', u'ignore')])
    
    #-----< locationRelatedData >-----#
    locationRelatedData = CLASS(name=u'locationRelatedData', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _locationRelatedData_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataRequest')))
    _locationRelatedData_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataResponse')))
    _locationRelatedData_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataFailure')))
    locationRelatedData._val = dict([(u'InitiatingMessage', _locationRelatedData_val_InitiatingMessage), (u'SuccessfulOutcome', _locationRelatedData_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _locationRelatedData_val_UnsuccessfulOutcome), (u'procedureCode', 30), (u'criticality', u'reject')])
    
    #-----< informationTransfer >-----#
    informationTransfer = CLASS(name=u'informationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _informationTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferIndication')))
    _informationTransfer_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferConfirmation')))
    _informationTransfer_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferFailure')))
    informationTransfer._val = dict([(u'InitiatingMessage', _informationTransfer_val_InitiatingMessage), (u'SuccessfulOutcome', _informationTransfer_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _informationTransfer_val_UnsuccessfulOutcome), (u'procedureCode', 31), (u'criticality', u'reject')])
    
    #-----< uESpecificInformation >-----#
    uESpecificInformation = CLASS(name=u'uESpecificInformation', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _uESpecificInformation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UESpecificInformationIndication')))
    uESpecificInformation._val = dict([(u'InitiatingMessage', _uESpecificInformation_val_InitiatingMessage), (u'procedureCode', 32), (u'criticality', u'ignore')])
    
    #-----< directInformationTransfer >-----#
    directInformationTransfer = CLASS(name=u'directInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _directInformationTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectInformationTransfer')))
    directInformationTransfer._val = dict([(u'InitiatingMessage', _directInformationTransfer_val_InitiatingMessage), (u'procedureCode', 34), (u'criticality', u'ignore')])
    
    #-----< uplinkInformationExchange >-----#
    uplinkInformationExchange = CLASS(name=u'uplinkInformationExchange', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _uplinkInformationExchange_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeRequest')))
    _uplinkInformationExchange_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeResponse')))
    _uplinkInformationExchange_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeFailure')))
    uplinkInformationExchange._val = dict([(u'InitiatingMessage', _uplinkInformationExchange_val_InitiatingMessage), (u'SuccessfulOutcome', _uplinkInformationExchange_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _uplinkInformationExchange_val_UnsuccessfulOutcome), (u'procedureCode', 33), (u'criticality', u'reject')])
    
    #-----< mBMSSessionStart >-----#
    mBMSSessionStart = CLASS(name=u'mBMSSessionStart', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _mBMSSessionStart_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStart')))
    _mBMSSessionStart_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartResponse')))
    _mBMSSessionStart_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartFailure')))
    mBMSSessionStart._val = dict([(u'InitiatingMessage', _mBMSSessionStart_val_InitiatingMessage), (u'SuccessfulOutcome', _mBMSSessionStart_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _mBMSSessionStart_val_UnsuccessfulOutcome), (u'procedureCode', 35), (u'criticality', u'reject')])
    
    #-----< mBMSSessionUpdate >-----#
    mBMSSessionUpdate = CLASS(name=u'mBMSSessionUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _mBMSSessionUpdate_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdate')))
    _mBMSSessionUpdate_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateResponse')))
    _mBMSSessionUpdate_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateFailure')))
    mBMSSessionUpdate._val = dict([(u'InitiatingMessage', _mBMSSessionUpdate_val_InitiatingMessage), (u'SuccessfulOutcome', _mBMSSessionUpdate_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _mBMSSessionUpdate_val_UnsuccessfulOutcome), (u'procedureCode', 36), (u'criticality', u'reject')])
    
    #-----< mBMSSessionStop >-----#
    mBMSSessionStop = CLASS(name=u'mBMSSessionStop', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _mBMSSessionStop_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStop')))
    _mBMSSessionStop_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStopResponse')))
    mBMSSessionStop._val = dict([(u'InitiatingMessage', _mBMSSessionStop_val_InitiatingMessage), (u'SuccessfulOutcome', _mBMSSessionStop_val_SuccessfulOutcome), (u'procedureCode', 37), (u'criticality', u'reject')])
    
    #-----< mBMSUELinking >-----#
    mBMSUELinking = CLASS(name=u'mBMSUELinking', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _mBMSUELinking_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingRequest')))
    _mBMSUELinking_val_Outcome = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingResponse')))
    mBMSUELinking._val = dict([(u'InitiatingMessage', _mBMSUELinking_val_InitiatingMessage), (u'Outcome', _mBMSUELinking_val_Outcome), (u'procedureCode', 38), (u'criticality', u'reject')])
    
    #-----< mBMSRegistration >-----#
    mBMSRegistration = CLASS(name=u'mBMSRegistration', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _mBMSRegistration_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationRequest')))
    _mBMSRegistration_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationResponse')))
    _mBMSRegistration_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationFailure')))
    mBMSRegistration._val = dict([(u'InitiatingMessage', _mBMSRegistration_val_InitiatingMessage), (u'SuccessfulOutcome', _mBMSRegistration_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _mBMSRegistration_val_UnsuccessfulOutcome), (u'procedureCode', 39), (u'criticality', u'reject')])
    
    #-----< mBMSCNDe-Registration >-----#
    mBMSCNDe_Registration = CLASS(name=u'mBMSCNDe-Registration', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _mBMSCNDe_Registration_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationRequest')))
    _mBMSCNDe_Registration_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationResponse')))
    mBMSCNDe_Registration._val = dict([(u'InitiatingMessage', _mBMSCNDe_Registration_val_InitiatingMessage), (u'SuccessfulOutcome', _mBMSCNDe_Registration_val_SuccessfulOutcome), (u'procedureCode', 40), (u'criticality', u'reject')])
    
    #-----< mBMSRABEstablishmentIndication >-----#
    mBMSRABEstablishmentIndication = CLASS(name=u'mBMSRABEstablishmentIndication', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _mBMSRABEstablishmentIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABEstablishmentIndication')))
    mBMSRABEstablishmentIndication._val = dict([(u'InitiatingMessage', _mBMSRABEstablishmentIndication_val_InitiatingMessage), (u'procedureCode', 41), (u'criticality', u'ignore')])
    
    #-----< mBMSRABRelease >-----#
    mBMSRABRelease = CLASS(name=u'mBMSRABRelease', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _mBMSRABRelease_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseRequest')))
    _mBMSRABRelease_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABRelease')))
    _mBMSRABRelease_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseFailure')))
    mBMSRABRelease._val = dict([(u'InitiatingMessage', _mBMSRABRelease_val_InitiatingMessage), (u'SuccessfulOutcome', _mBMSRABRelease_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _mBMSRABRelease_val_UnsuccessfulOutcome), (u'procedureCode', 42), (u'criticality', u'reject')])
    
    #-----< enhancedRelocationComplete >-----#
    enhancedRelocationComplete = CLASS(name=u'enhancedRelocationComplete', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _enhancedRelocationComplete_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteRequest')))
    _enhancedRelocationComplete_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteResponse')))
    _enhancedRelocationComplete_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteFailure')))
    enhancedRelocationComplete._val = dict([(u'InitiatingMessage', _enhancedRelocationComplete_val_InitiatingMessage), (u'SuccessfulOutcome', _enhancedRelocationComplete_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _enhancedRelocationComplete_val_UnsuccessfulOutcome), (u'procedureCode', 43), (u'criticality', u'reject')])
    
    #-----< enhancedRelocationCompleteConfirm >-----#
    enhancedRelocationCompleteConfirm = CLASS(name=u'enhancedRelocationCompleteConfirm', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _enhancedRelocationCompleteConfirm_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteConfirm')))
    enhancedRelocationCompleteConfirm._val = dict([(u'InitiatingMessage', _enhancedRelocationCompleteConfirm_val_InitiatingMessage), (u'procedureCode', 44), (u'criticality', u'ignore')])
    
    #-----< rANAP-enhancedRelocation >-----#
    rANAP_enhancedRelocation = CLASS(name=u'rANAP-enhancedRelocation', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _rANAP_enhancedRelocation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationRequest')))
    _rANAP_enhancedRelocation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationResponse')))
    rANAP_enhancedRelocation._val = dict([(u'InitiatingMessage', _rANAP_enhancedRelocation_val_InitiatingMessage), (u'SuccessfulOutcome', _rANAP_enhancedRelocation_val_SuccessfulOutcome), (u'procedureCode', 45), (u'criticality', u'reject')])
    
    #-----< sRVCCPreparation >-----#
    sRVCCPreparation = CLASS(name=u'sRVCCPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _sRVCCPreparation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysRequest')))
    _sRVCCPreparation_val_Outcome = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysResponse')))
    sRVCCPreparation._val = dict([(u'InitiatingMessage', _sRVCCPreparation_val_InitiatingMessage), (u'Outcome', _sRVCCPreparation_val_Outcome), (u'procedureCode', 46), (u'criticality', u'reject')])
    
    #-----< ueRadioCapabilityMatch >-----#
    ueRadioCapabilityMatch = CLASS(name=u'ueRadioCapabilityMatch', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _ueRadioCapabilityMatch_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchRequest')))
    _ueRadioCapabilityMatch_val_Outcome = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchResponse')))
    ueRadioCapabilityMatch._val = dict([(u'InitiatingMessage', _ueRadioCapabilityMatch_val_InitiatingMessage), (u'Outcome', _ueRadioCapabilityMatch_val_Outcome), (u'procedureCode', 47), (u'criticality', u'ignore')])
    
    #-----< ueRegistrationQuery >-----#
    ueRegistrationQuery = CLASS(name=u'ueRegistrationQuery', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _ueRegistrationQuery_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryRequest')))
    _ueRegistrationQuery_val_Outcome = SEQ(name=u'Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryResponse')))
    ueRegistrationQuery._val = dict([(u'InitiatingMessage', _ueRegistrationQuery_val_InitiatingMessage), (u'Outcome', _ueRegistrationQuery_val_Outcome), (u'procedureCode', 48), (u'criticality', u'ignore')])
    
    #-----< rerouteNASRequest >-----#
    rerouteNASRequest = CLASS(name=u'rerouteNASRequest', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _rerouteNASRequest_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RerouteNASRequest')))
    rerouteNASRequest._val = dict([(u'InitiatingMessage', _rerouteNASRequest_val_InitiatingMessage), (u'procedureCode', 49), (u'criticality', u'reject')])
    
    _all_ = [
        _RANAP_ELEMENTARY_PROCEDURE_InitiatingMessage,
        _RANAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome,
        _RANAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome,
        _RANAP_ELEMENTARY_PROCEDURE_Outcome,
        _RANAP_ELEMENTARY_PROCEDURE_procedureCode,
        _RANAP_ELEMENTARY_PROCEDURE_criticality,
        RANAP_ELEMENTARY_PROCEDURE,
        _RANAP_PDU_initiatingMessage,
        _RANAP_PDU_successfulOutcome,
        _RANAP_PDU_unsuccessfulOutcome,
        _RANAP_PDU_outcome,
        RANAP_PDU,
        __InitiatingMessage_procedureCode_tab,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_5,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27,
        ___InitiatingMessage_procedureCode_tab_val_Outcome_27,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_28,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_28,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_29,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_29,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_30,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_30,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_31,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_31,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_32,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_32,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_33,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34,
        ___InitiatingMessage_procedureCode_tab_val_Outcome_34,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_35,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_35,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_36,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_37,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_37,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_38,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_38,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_39,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40,
        ___InitiatingMessage_procedureCode_tab_val_Outcome_40,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41,
        ___InitiatingMessage_procedureCode_tab_val_Outcome_41,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42,
        ___InitiatingMessage_procedureCode_tab_val_Outcome_42,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48,
        _InitiatingMessage_procedureCode,
        _InitiatingMessage_criticality,
        _InitiatingMessage_value,
        InitiatingMessage,
        __SuccessfulOutcome_procedureCode_tab,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27,
        ___SuccessfulOutcome_procedureCode_tab_val_Outcome_27,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_28,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_28,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_29,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_29,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_30,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_30,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_31,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_31,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_32,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_32,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_33,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34,
        ___SuccessfulOutcome_procedureCode_tab_val_Outcome_34,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_35,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_35,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_36,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_37,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_37,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_38,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_38,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_39,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40,
        ___SuccessfulOutcome_procedureCode_tab_val_Outcome_40,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41,
        ___SuccessfulOutcome_procedureCode_tab_val_Outcome_41,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42,
        ___SuccessfulOutcome_procedureCode_tab_val_Outcome_42,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48,
        _SuccessfulOutcome_procedureCode,
        _SuccessfulOutcome_criticality,
        _SuccessfulOutcome_value,
        SuccessfulOutcome,
        __UnsuccessfulOutcome_procedureCode_tab,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27,
        ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_27,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_28,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_28,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_29,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_29,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_30,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_30,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_31,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_31,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_32,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_32,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_33,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34,
        ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_34,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_35,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_35,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_36,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_37,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_37,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_38,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_38,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_39,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40,
        ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_40,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41,
        ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_41,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42,
        ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_42,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48,
        _UnsuccessfulOutcome_procedureCode,
        _UnsuccessfulOutcome_criticality,
        _UnsuccessfulOutcome_value,
        UnsuccessfulOutcome,
        __Outcome_procedureCode_tab,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_0,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_1,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_2,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_3,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_4,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_5,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_5,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_6,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_7,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_8,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_9,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_10,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_11,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_12,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_13,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_14,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_15,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_16,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_17,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_18,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_19,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_20,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_21,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_22,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_23,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_24,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_25,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_26,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_27,
        ___Outcome_procedureCode_tab_val_Outcome_27,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_28,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_28,
        ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_28,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_29,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_29,
        ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_29,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_30,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_30,
        ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_30,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_31,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_31,
        ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_31,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_32,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_32,
        ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_32,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_33,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_33,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_34,
        ___Outcome_procedureCode_tab_val_Outcome_34,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_35,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_35,
        ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_35,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_36,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_36,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_37,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_37,
        ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_37,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_38,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_38,
        ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_38,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_39,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_39,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_40,
        ___Outcome_procedureCode_tab_val_Outcome_40,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_41,
        ___Outcome_procedureCode_tab_val_Outcome_41,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_42,
        ___Outcome_procedureCode_tab_val_Outcome_42,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_43,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_44,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_45,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_46,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_47,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_48,
        _Outcome_procedureCode,
        _Outcome_criticality,
        _Outcome_value,
        Outcome,
        RANAP_ELEMENTARY_PROCEDURES,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1,
        _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2,
        _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5,
        _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27,
        _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_27,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_28,
        _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_28,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_29,
        _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_29,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_30,
        _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_30,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_31,
        _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_31,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_32,
        _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_32,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_33,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34,
        _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_34,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_35,
        _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_35,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_36,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_37,
        _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_37,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_38,
        _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_38,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_39,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40,
        _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_40,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41,
        _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_41,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42,
        _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_42,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48,
        RANAP_ELEMENTARY_PROCEDURES_CLASS_1,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_9,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_Outcome_15,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_16,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_18,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_19,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_Outcome_21,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_22,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_Outcome_22,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_23,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_Outcome_23,
        RANAP_ELEMENTARY_PROCEDURES_CLASS_2,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23,
        RANAP_ELEMENTARY_PROCEDURES_CLASS_3,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_3_val_InitiatingMessage_0,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_3_val_Outcome_0,
        iu_Release,
        _iu_Release_val_InitiatingMessage,
        _iu_Release_val_SuccessfulOutcome,
        relocationPreparation,
        _relocationPreparation_val_InitiatingMessage,
        _relocationPreparation_val_SuccessfulOutcome,
        _relocationPreparation_val_UnsuccessfulOutcome,
        relocationResourceAllocation,
        _relocationResourceAllocation_val_InitiatingMessage,
        _relocationResourceAllocation_val_SuccessfulOutcome,
        _relocationResourceAllocation_val_UnsuccessfulOutcome,
        relocationCancel,
        _relocationCancel_val_InitiatingMessage,
        _relocationCancel_val_SuccessfulOutcome,
        sRNS_ContextTransfer,
        _sRNS_ContextTransfer_val_InitiatingMessage,
        _sRNS_ContextTransfer_val_SuccessfulOutcome,
        securityModeControl,
        _securityModeControl_val_InitiatingMessage,
        _securityModeControl_val_SuccessfulOutcome,
        _securityModeControl_val_UnsuccessfulOutcome,
        dataVolumeReport,
        _dataVolumeReport_val_InitiatingMessage,
        _dataVolumeReport_val_SuccessfulOutcome,
        reset,
        _reset_val_InitiatingMessage,
        _reset_val_SuccessfulOutcome,
        rAB_ReleaseRequest,
        _rAB_ReleaseRequest_val_InitiatingMessage,
        iu_ReleaseRequest,
        _iu_ReleaseRequest_val_InitiatingMessage,
        relocationDetect,
        _relocationDetect_val_InitiatingMessage,
        relocationComplete,
        _relocationComplete_val_InitiatingMessage,
        paging,
        _paging_val_InitiatingMessage,
        commonID,
        _commonID_val_InitiatingMessage,
        cN_InvokeTrace,
        _cN_InvokeTrace_val_InitiatingMessage,
        cN_DeactivateTrace,
        _cN_DeactivateTrace_val_InitiatingMessage,
        locationReportingControl,
        _locationReportingControl_val_InitiatingMessage,
        locationReport,
        _locationReport_val_InitiatingMessage,
        initialUE_Message,
        _initialUE_Message_val_InitiatingMessage,
        directTransfer,
        _directTransfer_val_InitiatingMessage,
        overloadControl,
        _overloadControl_val_InitiatingMessage,
        errorIndication,
        _errorIndication_val_InitiatingMessage,
        sRNS_DataForward,
        _sRNS_DataForward_val_InitiatingMessage,
        forwardSRNS_Context,
        _forwardSRNS_Context_val_InitiatingMessage,
        rAB_Assignment,
        _rAB_Assignment_val_InitiatingMessage,
        _rAB_Assignment_val_Outcome,
        privateMessage,
        _privateMessage_val_InitiatingMessage,
        resetResource,
        _resetResource_val_InitiatingMessage,
        _resetResource_val_SuccessfulOutcome,
        rANAP_Relocation,
        _rANAP_Relocation_val_InitiatingMessage,
        rAB_ModifyRequest,
        _rAB_ModifyRequest_val_InitiatingMessage,
        locationRelatedData,
        _locationRelatedData_val_InitiatingMessage,
        _locationRelatedData_val_SuccessfulOutcome,
        _locationRelatedData_val_UnsuccessfulOutcome,
        informationTransfer,
        _informationTransfer_val_InitiatingMessage,
        _informationTransfer_val_SuccessfulOutcome,
        _informationTransfer_val_UnsuccessfulOutcome,
        uESpecificInformation,
        _uESpecificInformation_val_InitiatingMessage,
        directInformationTransfer,
        _directInformationTransfer_val_InitiatingMessage,
        uplinkInformationExchange,
        _uplinkInformationExchange_val_InitiatingMessage,
        _uplinkInformationExchange_val_SuccessfulOutcome,
        _uplinkInformationExchange_val_UnsuccessfulOutcome,
        mBMSSessionStart,
        _mBMSSessionStart_val_InitiatingMessage,
        _mBMSSessionStart_val_SuccessfulOutcome,
        _mBMSSessionStart_val_UnsuccessfulOutcome,
        mBMSSessionUpdate,
        _mBMSSessionUpdate_val_InitiatingMessage,
        _mBMSSessionUpdate_val_SuccessfulOutcome,
        _mBMSSessionUpdate_val_UnsuccessfulOutcome,
        mBMSSessionStop,
        _mBMSSessionStop_val_InitiatingMessage,
        _mBMSSessionStop_val_SuccessfulOutcome,
        mBMSUELinking,
        _mBMSUELinking_val_InitiatingMessage,
        _mBMSUELinking_val_Outcome,
        mBMSRegistration,
        _mBMSRegistration_val_InitiatingMessage,
        _mBMSRegistration_val_SuccessfulOutcome,
        _mBMSRegistration_val_UnsuccessfulOutcome,
        mBMSCNDe_Registration,
        _mBMSCNDe_Registration_val_InitiatingMessage,
        _mBMSCNDe_Registration_val_SuccessfulOutcome,
        mBMSRABEstablishmentIndication,
        _mBMSRABEstablishmentIndication_val_InitiatingMessage,
        mBMSRABRelease,
        _mBMSRABRelease_val_InitiatingMessage,
        _mBMSRABRelease_val_SuccessfulOutcome,
        _mBMSRABRelease_val_UnsuccessfulOutcome,
        enhancedRelocationComplete,
        _enhancedRelocationComplete_val_InitiatingMessage,
        _enhancedRelocationComplete_val_SuccessfulOutcome,
        _enhancedRelocationComplete_val_UnsuccessfulOutcome,
        enhancedRelocationCompleteConfirm,
        _enhancedRelocationCompleteConfirm_val_InitiatingMessage,
        rANAP_enhancedRelocation,
        _rANAP_enhancedRelocation_val_InitiatingMessage,
        _rANAP_enhancedRelocation_val_SuccessfulOutcome,
        sRVCCPreparation,
        _sRVCCPreparation_val_InitiatingMessage,
        _sRVCCPreparation_val_Outcome,
        ueRadioCapabilityMatch,
        _ueRadioCapabilityMatch_val_InitiatingMessage,
        _ueRadioCapabilityMatch_val_Outcome,
        ueRegistrationQuery,
        _ueRegistrationQuery_val_InitiatingMessage,
        _ueRegistrationQuery_val_Outcome,
        rerouteNASRequest,
        _rerouteNASRequest_val_InitiatingMessage,
    ]

init_modules(RANAP_CommonDataTypes, RANAP_Constants, RANAP_Containers, RANAP_IEs, RANAP_PDU_Contents, RANAP_PDU_Descriptions)
